"use strict";/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ee=["exports","require","vs/base/common/lifecycle","vs/base/common/uri","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/path","vs/nls","vs/nls!vs/server/node/server.main","vs/base/common/errors","vs/base/common/types","vs/base/common/network","vs/platform/log/common/log","vs/base/common/buffer","vs/base/common/async","vs/platform/files/common/files","vs/base/common/strings","vs/base/common/arrays","vs/base/common/resources","vs/base/common/cancellation","vs/base/common/objects","vs/base/common/uuid","vs/base/node/pfs","vs/base/common/map","vs/platform/configuration/common/configuration","vs/platform/environment/common/environment","fs","os","vs/platform/telemetry/common/telemetry","vs/base/common/process","vs/platform/extensionManagement/common/extensionManagement","vs/platform/product/common/productService","vs/platform/userDataProfile/common/userDataProfile","vs/platform/uriIdentity/common/uriIdentity","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/extpath","vs/platform/registry/common/platform","vs/platform/telemetry/common/telemetryUtils","vs/base/common/errorMessage","vs/base/common/iterator","vs/base/common/json","vs/base/common/performance","vs/base/parts/ipc/common/ipc","vs/editor/common/core/range","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/server/node/serverEnvironmentService","vs/base/common/stream","vs/base/common/codicons","vs/base/common/marshalling","vs/base/common/uriIpc","child_process","vs/base/common/semver/semver","vs/platform/contextkey/common/contextkey","vs/platform/product/common/product","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/lazy","vs/base/common/mime","vs/base/common/processes","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/severity","vs/base/common/ternarySearchTree","vs/platform/environment/node/argv","vs/platform/instantiation/common/descriptors","vs/platform/files/node/diskFileSystemProvider","vs/platform/policy/common/policy","vs/workbench/api/node/uriTransformer","vs/workbench/contrib/testing/common/testId","vs/base/parts/ipc/node/ipc.net","vs/base/common/decorators","vs/base/common/functional","vs/base/common/glob","path","net","vs/editor/common/core/position","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/download/common/download","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/remote/common/remoteHosts","url","vs/platform/shell/node/shellEnv","vs/platform/extensionManagement/node/extensionSignatureVerificationService","crypto","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminal","vs/platform/workspace/common/workspace","vs/server/node/remoteLanguagePacks","vs/workbench/common/editor","vs/workbench/contrib/testing/common/testTypes","vs/base/common/amd","vs/base/common/assert","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/codiconsUtil","vs/base/common/themables","vs/base/common/htmlContent","vs/base/node/id","vs/base/node/powershell","vs/base/node/processes","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.cp","vs/platform/environment/node/environmentService","vs/platform/instantiation/common/extensions","vs/platform/files/common/io","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/fileService","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/node/loggerService","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/languagePacks/node/languagePacks","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/terminalEnvironment","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/server/node/extensionHostStatusService","vs/server/node/extensionsScannerService","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/platform/request/node/requestService","vs/server/node/extensionHostConnection","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/prefixTree","vs/base/common/skipList","vs/base/common/cache","vs/base/common/filters","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/iconLabels","vs/base/common/console","vs/amdX","vs/base/common/labels","vs/base/common/dataTransfer","vs/base/node/languagePacks","vs/base/node/macAddress","vs/base/node/osReleaseInfo","vs/base/node/extpath","vs/base/node/ports","vs/base/parts/storage/common/storage","vs/editor/common/core/editOperation","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/node/zip","vs/nls!vs/editor/common/languages","vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/server/node/remoteExtensionHostAgentCli","vs/nls!vs/server/node/serverEnvironmentService","vs/nls!vs/server/node/serverServices","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsUtil","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/download/common/downloadIpc","vs/platform/environment/common/environmentService","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/graph","vs/platform/diagnostics/common/diagnostics","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/label/common/label","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/remote/common/remoteExtensionsScanner","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/telemetry/common/errorTelemetry","vs/platform/telemetry/common/remoteTelemetryChannel","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/common/serverTelemetryService","vs/platform/telemetry/node/1dsAppender","https","vs/platform/telemetry/node/errorTelemetry","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/nodePtyHostStarter","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/storage/common/storage","vs/platform/userDataProfile/common/userDataProfileIpc","vs/server/node/remoteExtensionManagement","vs/server/node/serverConnectionToken","cookie","vs/server/node/telemetryClient","http","vs/server/node/webClientServer","vs/workbench/api/common/extHostInitDataService","vs/workbench/api/common/extHostRpcService","vs/server/node/remoteAgentEnvironmentImpl","vs/server/node/remoteFileSystemProviderServer","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/terminal/common/environmentVariable","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/services/configuration/common/configuration","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/contrib/terminal/common/remote/remoteTerminalChannel","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/workbench/services/extensions/common/extensions","vs/workbench/services/extensions/common/extensionsUtil","vs/server/node/remoteExtensionsScanner","vs/workbench/api/common/extHost.protocol","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostCommands","vs/workbench/services/remote/common/remoteFileSystemProviderClient","zlib","vs/server/node/remoteExtensionHostAgentCli","vs/base/node/unc","vs/workbench/api/node/extHostCLIServer","vs/server/node/remoteTerminalChannel","vs/server/node/serverServices","vs/server/node/remoteExtensionHostAgentServer","perf_hooks","fs/promises","readline","util","minimist","assert","graceful-fs","@microsoft/1ds-core-js","vs/server/node/server.main"],ke=function(ce){for(var e=[],n=0,A=ce.length;n<A;n++)e[n]=Ee[ce[n]];return e};define(Ee[96],ke([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class n{static get(){const P=new Map,D=new Map,C=new Map,k=new Map;function b(g,d){g.has(d.detail)||g.set(d.detail,-d.timestamp)}function $(g,d){const c=g.get(d.detail);c&&(c>=0||g.set(d.detail,c+d.timestamp))}let E=[];typeof ce=="function"&&typeof ce.getStats=="function"&&(E=ce.getStats().slice(0).sort((g,d)=>g.timestamp-d.timestamp));for(const g of E)switch(g.type){case 10:b(P,g);break;case 11:case 12:$(P,g);break;case 21:b(D,g);break;case 22:$(D,g);break;case 33:b(C,g);break;case 34:$(C,g);break;case 31:b(k,g);break;case 32:$(k,g);break}let y=0;C.forEach(g=>y+=g);function w(g){const d=[];return g.forEach((c,m)=>d.push([m,c])),d}return{amdLoad:w(P),amdInvoke:w(D),nodeRequire:w(C),nodeEval:w(k),nodeRequireTotal:y}}static toMarkdownTable(P,D){let C="";const k=[];return P.forEach((b,$)=>{k[$]=b.length}),D.forEach(b=>{b.forEach(($,E)=>{typeof $>"u"&&($=b[E]="-");const y=$.toString().length;k[E]=Math.max(y,k[E])})}),P.forEach((b,$)=>{C+=`| ${b+" ".repeat(k[$]-b.toString().length)} `}),C+=`|
`,P.forEach((b,$)=>{C+=`| ${"-".repeat(k[$])} `}),C+=`|
`,D.forEach(b=>{b.forEach(($,E)=>{typeof $<"u"&&(C+=`| ${$+" ".repeat(k[E]-$.toString().length)} `)}),C+=`|
`}),C}}e.$U=n}),define(Ee[144],ke([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mb=void 0,e.$fb=n,e.$gb=A,e.$hb=P,e.$ib=D,e.$jb=C,e.$kb=k,e.$lb=b,e.$nb=E,e.$ob=y,e.$pb=w,e.$qb=g,e.$rb=d;function n(c,m,u){const p=A(c,m);if(p!==-1)return c[p]}function A(c,m,u=c.length-1){for(let p=u;p>=0;p--){const h=c[p];if(m(h))return p}return-1}function P(c,m){const u=D(c,m);return u===-1?void 0:c[u]}function D(c,m,u=0,p=c.length){let h=u,f=p;for(;h<f;){const l=Math.floor((h+f)/2);m(c[l])?h=l+1:f=l}return h-1}function C(c,m){const u=k(c,m);return u===c.length?void 0:c[u]}function k(c,m,u=0,p=c.length){let h=u,f=p;for(;h<f;){const l=Math.floor((h+f)/2);m(c[l])?f=l:h=l+1}return h}function b(c,m,u=0,p=c.length){const h=k(c,m,u,p);return h===c.length?-1:h}class ${constructor(m){this.e=m,this.c=0}findLastMonotonous(m){if($.assertInvariants){if(this.d){for(const p of this.e)if(this.d(p)&&!m(p))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=m}const u=D(this.e,m,this.c);return this.c=u+1,u===-1?void 0:this.e[u]}}e.$mb=$,$.assertInvariants=!1;function E(c,m){if(c.length===0)return;let u=c[0];for(let p=1;p<c.length;p++){const h=c[p];m(h,u)>0&&(u=h)}return u}function y(c,m){if(c.length===0)return;let u=c[0];for(let p=1;p<c.length;p++){const h=c[p];m(h,u)>=0&&(u=h)}return u}function w(c,m){return E(c,(u,p)=>-m(u,p))}function g(c,m){if(c.length===0)return-1;let u=0;for(let p=1;p<c.length;p++){const h=c[p];m(h,c[u])>0&&(u=p)}return u}function d(c,m){for(const u of c){const p=m(u);if(p!==void 0)return p}}}),define(Ee[145],ke([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E=n,e.$F=A,e.$G=P,e.$H=D;function n(C,k){const b=Object.create(null);for(const $ of C){const E=k($);let y=b[E];y||(y=b[E]=[]),y.push($)}return b}function A(C,k){const b=[],$=[];for(const E of C)k.has(E)||b.push(E);for(const E of k)C.has(E)||$.push(E);return{removed:b,added:$}}function P(C,k){const b=[],$=[];for(const[E,y]of C)k.has(E)||b.push(y);for(const[E,y]of k)C.has(E)||$.push(y);return{removed:b,added:$}}function D(C,k){const b=new Set;for(const $ of k)C.has($)&&b.add($);return b}}),define(Ee[74],ke([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mh=A,e.$Nh=P,e.$Oh=D;function n(C){return(k,b,$)=>{let E=null,y=null;if(typeof $.value=="function"?(E="value",y=$.value):typeof $.get=="function"&&(E="get",y=$.get),!y)throw new Error("not supported");$[E]=C(y,b)}}function A(C,k,b){let $=null,E=null;if(typeof b.value=="function"?($="value",E=b.value,E.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof b.get=="function"&&($="get",E=b.get),!E)throw new Error("not supported");const y=`$memoize$${k}`;b[$]=function(...w){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:E.apply(this,w)}),this[y]}}function P(C,k,b){return n(($,E)=>{const y=`$debounce$${E}`,w=`$debounce$result$${E}`;return function(...g){this[w]||(this[w]=b?b():void 0),clearTimeout(this[y]),k&&(this[w]=k(this[w],...g),g=[this[w]]),this[y]=setTimeout(()=>{$.apply(this,g),this[w]=b?b():void 0},C)}})}function D(C,k,b){return n(($,E)=>{const y=`$throttle$timer$${E}`,w=`$throttle$result$${E}`,g=`$throttle$lastRun$${E}`,d=`$throttle$pending$${E}`;return function(...c){if(this[w]||(this[w]=b?b():void 0),(this[g]===null||this[g]===void 0)&&(this[g]=-Number.MAX_VALUE),k&&(this[w]=k(this[w],...c)),this[d])return;const m=this[g]+C;m<=Date.now()?(this[g]=Date.now(),$.apply(this,[this[w]]),this[w]=b?b():void 0):(this[d]=!0,this[y]=setTimeout(()=>{this[d]=!1,this[g]=Date.now(),$.apply(this,[this[w]]),this[w]=b?b():void 0},m-Date.now()))}})}}),define(Ee[10],ke([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$9=e.$5=e.$X=e.$W=void 0,e.setUnexpectedErrorHandler=A,e.$Z=P,e.$1=D,e.$2=C,e.$3=k,e.$4=$,e.$6=y,e.$7=w,e.$8=g,e.$0=c;class n{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?h.isErrorNoTelemetry(t)?new h(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(a=>{a(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=n,e.$X=new n;function A(l){e.$X.setUnexpectedErrorHandler(l)}function P(l){if(!l||typeof l!="object")return!1;const t=l;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function D(l){$(l)||e.$X.onUnexpectedError(l)}function C(l){$(l)||e.$X.onUnexpectedExternalError(l)}function k(l){if(l instanceof Error){const{name:t,message:a}=l,o=l.stacktrace||l.stack;return{$isError:!0,name:t,message:a,stack:o,noTelemetry:h.isErrorNoTelemetry(l)}}return l}const b="Canceled";function $(l){return l instanceof E?!0:l instanceof Error&&l.name===b&&l.message===b}class E extends Error{constructor(){super(b),this.name=this.message}}e.$5=E;function y(){const l=new Error(b);return l.name=l.message,l}function w(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}function g(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}class d extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=d;function c(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}class m extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=m;class u extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=u;class p extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=p;class h extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof h)return t;const a=new h;return a.message=t.message,a.stack=t.stack,a}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=h;class f extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,f.prototype)}}e.$cb=f}),define(Ee[18],ke([1,0,10,144]),function(ce,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bc=e.$ac=e.$_b=e.$0b=e.$9b=e.CompareResult=void 0,e.$sb=P,e.$tb=D,e.$ub=C,e.$vb=k,e.$wb=b,e.$xb=$,e.$yb=E,e.$zb=y,e.$Ab=w,e.$Bb=g,e.$Cb=d,e.$Db=c,e.$Eb=m,e.top=u,e.$Gb=p,e.$Hb=f,e.$Ib=l,e.$Jb=t,e.$Kb=a,e.$Lb=o,e.$Mb=r,e.$Nb=s,e.$Ob=i,e.$Pb=v,e.$Qb=S,e.$Rb=O,e.$Sb=N,e.$Tb=j,e.$Ub=I,e.$Vb=B,e.$Wb=Z,e.$Xb=he,e.$Yb=ae,e.$Zb=ee,e.$1b=_,e.$2b=z,e.$3b=T,e.$4b=J,e.$5b=Y,e.$6b=W,e.$7b=ie,e.$8b=$e,e.$$b=R;function P(Q,x=0){return Q[Q.length-(1+x)]}function D(Q){if(Q.length===0)throw new Error("Invalid tail call");return[Q.slice(0,Q.length-1),Q[Q.length-1]]}function C(Q,x,V=(L,H)=>L===H){if(Q===x)return!0;if(!Q||!x||Q.length!==x.length)return!1;for(let L=0,H=Q.length;L<H;L++)if(!V(Q[L],x[L]))return!1;return!0}function k(Q,x){const V=Q.length-1;x<V&&(Q[x]=Q[V]),Q.pop()}function b(Q,x,V){return $(Q.length,L=>V(Q[L],x))}function $(Q,x){let V=0,L=Q-1;for(;V<=L;){const H=(V+L)/2|0,K=x(H);if(K<0)V=H+1;else if(K>0)L=H-1;else return H}return-(V+1)}function E(Q,x,V){if(Q=Q|0,Q>=x.length)throw new TypeError("invalid index");const L=x[Math.floor(x.length*Math.random())],H=[],K=[],te=[];for(const de of x){const se=V(de,L);se<0?H.push(de):se>0?K.push(de):te.push(de)}return Q<H.length?E(Q,H,V):Q<H.length+te.length?te[0]:E(Q-(H.length+te.length),K,V)}function y(Q,x){const V=[];let L;for(const H of Q.slice(0).sort(x))!L||x(L[0],H)!==0?(L=[H],V.push(L)):L.push(H);return V}function*w(Q,x){let V,L;for(const H of Q)L!==void 0&&x(L,H)?V.push(H):(V&&(yield V),V=[H]),L=H;V&&(yield V)}function g(Q,x){for(let V=0;V<=Q.length;V++)x(V===0?void 0:Q[V-1],V===Q.length?void 0:Q[V])}function d(Q,x){for(let V=0;V<Q.length;V++)x(V===0?void 0:Q[V-1],Q[V],V+1===Q.length?void 0:Q[V+1])}function c(Q,x,V){const L=[];function H(de,se,ge){if(se===0&&ge.length===0)return;const we=L[L.length-1];we&&we.start+we.deleteCount===de?(we.deleteCount+=se,we.toInsert.push(...ge)):L.push({start:de,deleteCount:se,toInsert:ge})}let K=0,te=0;for(;;){if(K===Q.length){H(K,0,x.slice(te));break}if(te===x.length){H(K,Q.length-K,[]);break}const de=Q[K],se=x[te],ge=V(de,se);ge===0?(K+=1,te+=1):ge<0?(H(K,1,[]),K+=1):ge>0&&(H(K,0,[se]),te+=1)}return L}function m(Q,x,V){const L=c(Q,x,V),H=[],K=[];for(const te of L)H.push(...Q.slice(te.start,te.start+te.deleteCount)),K.push(...te.toInsert);return{removed:H,added:K}}function u(Q,x,V){if(V===0)return[];const L=Q.slice(0,V).sort(x);return h(Q,x,L,V,Q.length),L}function p(Q,x,V,L,H){return V===0?Promise.resolve([]):new Promise((K,te)=>{(async()=>{const de=Q.length,se=Q.slice(0,V).sort(x);for(let ge=V,we=Math.min(V+L,de);ge<de;ge=we,we=Math.min(we+L,de)){if(ge>V&&await new Promise(Ie=>setTimeout(Ie)),H&&H.isCancellationRequested)throw new n.$5;h(Q,x,se,ge,we)}return se})().then(K,te)})}function h(Q,x,V,L,H){for(const K=V.length;L<H;L++){const te=Q[L];if(x(te,V[K-1])<0){V.pop();const de=(0,A.$kb)(V,se=>x(te,se)<0);V.splice(de,0,te)}}}function f(Q){return Q.filter(x=>!!x)}function l(Q){let x=0;for(let V=0;V<Q.length;V++)Q[V]&&(Q[x]=Q[V],x+=1);Q.length=x}function t(Q,x,V){Q.splice(V,0,Q.splice(x,1)[0])}function a(Q){return!Array.isArray(Q)||Q.length===0}function o(Q){return Array.isArray(Q)&&Q.length>0}function r(Q,x=V=>V){const V=new Set;return Q.filter(L=>{const H=x(L);return V.has(H)?!1:(V.add(H),!0)})}function s(Q){const x=new Set;return V=>{const L=Q(V);return x.has(L)?!1:(x.add(L),!0)}}function i(Q,x){return Q.length>0?Q[0]:x}function v(Q,x){return Q.length>0?Q[Q.length-1]:x}function S(Q,x,V=(L,H)=>L===H){let L=0;for(let H=0,K=Math.min(Q.length,x.length);H<K&&V(Q[H],x[H]);H++)L++;return L}function O(Q){return[].concat(...Q)}function N(Q,x){let V=typeof x=="number"?Q:0;typeof x=="number"?V=Q:(V=0,x=Q);const L=[];if(V<=x)for(let H=V;H<x;H++)L.push(H);else for(let H=V;H>x;H--)L.push(H);return L}function j(Q,x,V){return Q.reduce((L,H)=>(L[x(H)]=V?V(H):H,L),Object.create(null))}function I(Q,x){return Q.push(x),()=>B(Q,x)}function B(Q,x){const V=Q.indexOf(x);if(V>-1)return Q.splice(V,1),x}function Z(Q,x,V){const L=Q.slice(0,x),H=Q.slice(x);return L.concat(V,H)}function he(Q,x){let V;if(typeof x=="number"){let L=x;V=()=>{const H=Math.sin(L++)*179426549;return H-Math.floor(H)}}else V=Math.random;for(let L=Q.length-1;L>0;L-=1){const H=Math.floor(V()*(L+1)),K=Q[L];Q[L]=Q[H],Q[H]=K}}function ae(Q,x){const V=Q.indexOf(x);V>-1&&(Q.splice(V,1),Q.unshift(x))}function ee(Q,x){const V=Q.indexOf(x);V>-1&&(Q.splice(V,1),Q.push(x))}function _(Q,x){for(const V of x)Q.push(V)}function z(Q,x){return Array.isArray(Q)?Q.map(x):x(Q)}function T(Q){return Array.isArray(Q)?Q:[Q]}function J(Q){return Q[Math.floor(Math.random()*Q.length)]}function Y(Q,x,V){const L=re(Q,x),H=Q.length,K=V.length;Q.length=H+K;for(let te=H-1;te>=L;te--)Q[te+K]=Q[te];for(let te=0;te<K;te++)Q[te+L]=V[te]}function W(Q,x,V,L){const H=re(Q,x);let K=Q.splice(H,V);return K===void 0&&(K=[]),Y(Q,H,L),K}function re(Q,x){return x<0?Math.max(x+Q.length,0):Math.min(x,Q.length)}var ue;(function(Q){function x(K){return K<0}Q.isLessThan=x;function V(K){return K<=0}Q.isLessThanOrEqual=V;function L(K){return K>0}Q.isGreaterThan=L;function H(K){return K===0}Q.isNeitherLessOrGreaterThan=H,Q.greaterThan=1,Q.lessThan=-1,Q.neitherLessOrGreaterThan=0})(ue||(e.CompareResult=ue={}));function ie(Q,x){return(V,L)=>x(Q(V),Q(L))}function $e(...Q){return(x,V)=>{for(const L of Q){const H=L(x,V);if(!ue.isNeitherLessOrGreaterThan(H))return H}return ue.neitherLessOrGreaterThan}}const ne=(Q,x)=>Q-x;e.$9b=ne;const U=(Q,x)=>(0,e.$9b)(Q?1:0,x?1:0);e.$0b=U;function R(Q){return(x,V)=>-Q(x,V)}class q{constructor(x){this.g=x,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(x){let V=this.c;for(;V<this.g.length&&x(this.g[V]);)V++;const L=V===this.c?null:this.g.slice(this.c,V);return this.c=V,L}takeFromEndWhile(x){let V=this.d;for(;V>=0&&x(this.g[V]);)V--;const L=V===this.d?null:this.g.slice(V+1,this.d+1);return this.d=V,L}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const x=this.g[this.c];return this.c++,x}removeLast(){const x=this.g[this.d];return this.d--,x}takeCount(x){const V=this.g.slice(this.c,this.c+x);return this.c+=x,V}}e.$_b=q;class X{constructor(x){this.iterate=x}forEach(x){this.iterate(V=>(x(V),!0))}toArray(){const x=[];return this.iterate(V=>(x.push(V),!0)),x}filter(x){return new X(V=>this.iterate(L=>x(L)?V(L):!0))}map(x){return new X(V=>this.iterate(L=>V(x(L))))}some(x){let V=!1;return this.iterate(L=>(V=x(L),!V)),V}findFirst(x){let V;return this.iterate(L=>x(L)?(V=L,!1):!0),V}findLast(x){let V;return this.iterate(L=>(x(L)&&(V=L),!0)),V}findLastMaxBy(x){let V,L=!0;return this.iterate(H=>((L||ue.isGreaterThan(x(H,V)))&&(L=!1,V=H),!0)),V}}e.$ac=X,X.empty=new X(Q=>{});class le{constructor(x){this.c=x}static createSortPermutation(x,V){const L=Array.from(x.keys()).sort((H,K)=>V(x[H],x[K]));return new le(L)}apply(x){return x.map((V,L)=>x[this.c[L]])}inverse(){const x=this.c.slice();for(let V=0;V<this.c.length;V++)x[this.c[V]]=V;return new le(x)}}e.$bc=le}),define(Ee[97],ke([1,0,10]),function(ce,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=A,e.$0c=P,e.$$c=D,e.$_c=C,e.$ad=k,e.$bd=b;function A($,E){if(!$)throw new Error(E?`Assertion failed (${E})`:"Assertion Failed")}function P($,E="Unreachable"){throw new Error(E)}function D($){if(!$)throw new n.$cb("Assertion Failed")}function C($){$||(0,n.$1)(new n.$cb("Soft Assertion Failed"))}function k($){if(!$()){debugger;$(),(0,n.$1)(new n.$cb("Assertion Failed"))}}function b($,E){let y=0;for(;y<$.length-1;){const w=$[y],g=$[y+1];if(!E(w,g))return!1;y++}return!0}}),define(Ee[75],ke([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=n;function n(A,P){const D=this;let C=!1,k;return function(){if(C)return k;if(C=!0,P)try{k=A.apply(D,arguments)}finally{P()}else k=A.apply(D,arguments);return k}}}),define(Ee[41],ke([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var n;(function(A){function P(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}A.is=P;const D=Object.freeze([]);function C(){return D}A.empty=C;function*k(t){yield t}A.single=k;function b(t){return P(t)?t:k(t)}A.wrap=b;function $(t){return t||D}A.from=$;function*E(t){for(let a=t.length-1;a>=0;a--)yield t[a]}A.reverse=E;function y(t){return!t||t[Symbol.iterator]().next().done===!0}A.isEmpty=y;function w(t){return t[Symbol.iterator]().next().value}A.first=w;function g(t,a){for(const o of t)if(a(o))return!0;return!1}A.some=g;function d(t,a){for(const o of t)if(a(o))return o}A.find=d;function*c(t,a){for(const o of t)a(o)&&(yield o)}A.filter=c;function*m(t,a){let o=0;for(const r of t)yield a(r,o++)}A.map=m;function*u(...t){for(const a of t)yield*a}A.concat=u;function p(t,a,o){let r=o;for(const s of t)r=a(r,s);return r}A.reduce=p;function*h(t,a,o=t.length){for(a<0&&(a+=t.length),o<0?o+=t.length:o>t.length&&(o=t.length);a<o;a++)yield t[a]}A.slice=h;function f(t,a=Number.POSITIVE_INFINITY){const o=[];if(a===0)return[o,t];const r=t[Symbol.iterator]();for(let s=0;s<a;s++){const i=r.next();if(i.done)return[o,A.empty()];o.push(i.value)}return[o,{[Symbol.iterator](){return r}}]}A.consume=f;async function l(t){const a=[];for await(const o of t)a.push(o);return Promise.resolve(a)}A.asyncToArray=l})(n||(e.Iterable=n={}))}),define(Ee[42],ke([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$un=C,e.$vn=y,e.$wn=w,e.$xn=g,e.$yn=d,e.$zn=c,e.$An=m,e.$Bn=u,e.$Cn=p,e.$Dn=h,e.$En=f,e.$Fn=l;var n;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(n||(e.ScanError=n={}));var A;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(A||(e.SyntaxKind=A={}));var P;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(P||(e.ParseErrorCode=P={}));var D;(function(t){t.DEFAULT={allowTrailingComma:!0}})(D||(e.ParseOptions=D={}));function C(t,a=!1){let o=0;const r=t.length;let s="",i=0,v=16,S=0;function O(ae){let ee=0,_=0;for(;ee<ae;){const z=t.charCodeAt(o);if(z>=48&&z<=57)_=_*16+z-48;else if(z>=65&&z<=70)_=_*16+z-65+10;else if(z>=97&&z<=102)_=_*16+z-97+10;else break;o++,ee++}return ee<ae&&(_=-1),_}function N(ae){o=ae,s="",i=0,v=16,S=0}function j(){const ae=o;if(t.charCodeAt(o)===48)o++;else for(o++;o<t.length&&$(t.charCodeAt(o));)o++;if(o<t.length&&t.charCodeAt(o)===46)if(o++,o<t.length&&$(t.charCodeAt(o)))for(o++;o<t.length&&$(t.charCodeAt(o));)o++;else return S=3,t.substring(ae,o);let ee=o;if(o<t.length&&(t.charCodeAt(o)===69||t.charCodeAt(o)===101))if(o++,(o<t.length&&t.charCodeAt(o)===43||t.charCodeAt(o)===45)&&o++,o<t.length&&$(t.charCodeAt(o))){for(o++;o<t.length&&$(t.charCodeAt(o));)o++;ee=o}else S=3;return t.substring(ae,ee)}function I(){let ae="",ee=o;for(;;){if(o>=r){ae+=t.substring(ee,o),S=2;break}const _=t.charCodeAt(o);if(_===34){ae+=t.substring(ee,o),o++;break}if(_===92){if(ae+=t.substring(ee,o),o++,o>=r){S=2;break}switch(t.charCodeAt(o++)){case 34:ae+='"';break;case 92:ae+="\\";break;case 47:ae+="/";break;case 98:ae+="\b";break;case 102:ae+="\f";break;case 110:ae+=`
`;break;case 114:ae+="\r";break;case 116:ae+="	";break;case 117:{const T=O(4);T>=0?ae+=String.fromCharCode(T):S=4;break}default:S=5}ee=o;continue}if(_>=0&&_<=31)if(b(_)){ae+=t.substring(ee,o),S=2;break}else S=6;o++}return ae}function B(){if(s="",S=0,i=o,o>=r)return i=r,v=17;let ae=t.charCodeAt(o);if(k(ae)){do o++,s+=String.fromCharCode(ae),ae=t.charCodeAt(o);while(k(ae));return v=15}if(b(ae))return o++,s+=String.fromCharCode(ae),ae===13&&t.charCodeAt(o)===10&&(o++,s+=`
`),v=14;switch(ae){case 123:return o++,v=1;case 125:return o++,v=2;case 91:return o++,v=3;case 93:return o++,v=4;case 58:return o++,v=6;case 44:return o++,v=5;case 34:return o++,s=I(),v=10;case 47:{const ee=o-1;if(t.charCodeAt(o+1)===47){for(o+=2;o<r&&!b(t.charCodeAt(o));)o++;return s=t.substring(ee,o),v=12}if(t.charCodeAt(o+1)===42){o+=2;const _=r-1;let z=!1;for(;o<_;){if(t.charCodeAt(o)===42&&t.charCodeAt(o+1)===47){o+=2,z=!0;break}o++}return z||(o++,S=1),s=t.substring(ee,o),v=13}return s+=String.fromCharCode(ae),o++,v=16}case 45:if(s+=String.fromCharCode(ae),o++,o===r||!$(t.charCodeAt(o)))return v=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=j(),v=11;default:for(;o<r&&Z(ae);)o++,ae=t.charCodeAt(o);if(i!==o){switch(s=t.substring(i,o),s){case"true":return v=8;case"false":return v=9;case"null":return v=7}return v=16}return s+=String.fromCharCode(ae),o++,v=16}}function Z(ae){if(k(ae)||b(ae))return!1;switch(ae){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function he(){let ae;do ae=B();while(ae>=12&&ae<=15);return ae}return{setPosition:N,getPosition:()=>o,scan:a?he:B,getToken:()=>v,getTokenValue:()=>s,getTokenOffset:()=>i,getTokenLength:()=>o-i,getTokenError:()=>S}}function k(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function b(t){return t===10||t===13||t===8232||t===8233}function $(t){return t>=48&&t<=57}var E;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(E||(E={}));function y(t,a){const o=[],r=new Object;let s;const i={value:{},offset:0,length:0,type:"object",parent:void 0};let v=!1;function S(O,N,j,I){i.value=O,i.offset=N,i.length=j,i.type=I,i.colonOffset=void 0,s=i}try{h(t,{onObjectBegin:(O,N)=>{if(a<=O)throw r;s=void 0,v=a>O,o.push("")},onObjectProperty:(O,N,j)=>{if(a<N||(S(O,N,j,"property"),o[o.length-1]=O,a<=N+j))throw r},onObjectEnd:(O,N)=>{if(a<=O)throw r;s=void 0,o.pop()},onArrayBegin:(O,N)=>{if(a<=O)throw r;s=void 0,o.push(0)},onArrayEnd:(O,N)=>{if(a<=O)throw r;s=void 0,o.pop()},onLiteralValue:(O,N,j)=>{if(a<N||(S(O,N,j,l(O)),a<=N+j))throw r},onSeparator:(O,N,j)=>{if(a<=N)throw r;if(O===":"&&s&&s.type==="property")s.colonOffset=N,v=!1,s=void 0;else if(O===","){const I=o[o.length-1];typeof I=="number"?o[o.length-1]=I+1:(v=!0,o[o.length-1]=""),s=void 0}}})}catch(O){if(O!==r)throw O}return{path:o,previousNode:s,isAtPropertyKey:v,matches:O=>{let N=0;for(let j=0;N<O.length&&j<o.length;j++)if(O[N]===o[j]||O[N]==="*")N++;else if(O[N]!=="**")return!1;return N===O.length}}}function w(t,a=[],o=D.DEFAULT){let r=null,s=[];const i=[];function v(O){Array.isArray(s)?s.push(O):r!==null&&(s[r]=O)}return h(t,{onObjectBegin:()=>{const O={};v(O),i.push(s),s=O,r=null},onObjectProperty:O=>{r=O},onObjectEnd:()=>{s=i.pop()},onArrayBegin:()=>{const O=[];v(O),i.push(s),s=O,r=null},onArrayEnd:()=>{s=i.pop()},onLiteralValue:v,onError:(O,N,j)=>{a.push({error:O,offset:N,length:j})}},o),s[0]}function g(t,a=[],o=D.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(O){r.type==="property"&&(r.length=O-r.offset,r=r.parent)}function i(O){return r.children.push(O),O}h(t,{onObjectBegin:O=>{r=i({type:"object",offset:O,length:-1,parent:r,children:[]})},onObjectProperty:(O,N,j)=>{r=i({type:"property",offset:N,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:O,offset:N,length:j,parent:r})},onObjectEnd:(O,N)=>{r.length=O+N-r.offset,r=r.parent,s(O+N)},onArrayBegin:(O,N)=>{r=i({type:"array",offset:O,length:-1,parent:r,children:[]})},onArrayEnd:(O,N)=>{r.length=O+N-r.offset,r=r.parent,s(O+N)},onLiteralValue:(O,N,j)=>{i({type:l(O),offset:N,length:j,parent:r,value:O}),s(N+j)},onSeparator:(O,N,j)=>{r.type==="property"&&(O===":"?r.colonOffset=N:O===","&&s(N))},onError:(O,N,j)=>{a.push({error:O,offset:N,length:j})}},o);const S=r.children[0];return S&&delete S.parent,S}function d(t,a){if(!t)return;let o=t;for(const r of a)if(typeof r=="string"){if(o.type!=="object"||!Array.isArray(o.children))return;let s=!1;for(const i of o.children)if(Array.isArray(i.children)&&i.children[0].value===r){o=i.children[1],s=!0;break}if(!s)return}else{const s=r;if(o.type!=="array"||s<0||!Array.isArray(o.children)||s>=o.children.length)return;o=o.children[s]}return o}function c(t){if(!t.parent||!t.parent.children)return[];const a=c(t.parent);if(t.parent.type==="property"){const o=t.parent.children[0].value;a.push(o)}else if(t.parent.type==="array"){const o=t.parent.children.indexOf(t);o!==-1&&a.push(o)}return a}function m(t){switch(t.type){case"array":return t.children.map(m);case"object":{const a=Object.create(null);for(const o of t.children){const r=o.children[1];r&&(a[o.children[0].value]=m(r))}return a}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function u(t,a,o=!1){return a>=t.offset&&a<t.offset+t.length||o&&a===t.offset+t.length}function p(t,a,o=!1){if(u(t,a,o)){const r=t.children;if(Array.isArray(r))for(let s=0;s<r.length&&r[s].offset<=a;s++){const i=p(r[s],a,o);if(i)return i}return t}}function h(t,a,o=D.DEFAULT){const r=C(t,!1);function s(ie){return ie?()=>ie(r.getTokenOffset(),r.getTokenLength()):()=>!0}function i(ie){return ie?$e=>ie($e,r.getTokenOffset(),r.getTokenLength()):()=>!0}const v=s(a.onObjectBegin),S=i(a.onObjectProperty),O=s(a.onObjectEnd),N=s(a.onArrayBegin),j=s(a.onArrayEnd),I=i(a.onLiteralValue),B=i(a.onSeparator),Z=s(a.onComment),he=i(a.onError),ae=o&&o.disallowComments,ee=o&&o.allowTrailingComma;function _(){for(;;){const ie=r.scan();switch(r.getTokenError()){case 4:z(14);break;case 5:z(15);break;case 3:z(13);break;case 1:ae||z(11);break;case 2:z(12);break;case 6:z(16);break}switch(ie){case 12:case 13:ae?z(10):Z();break;case 16:z(1);break;case 15:case 14:break;default:return ie}}}function z(ie,$e=[],ne=[]){if(he(ie),$e.length+ne.length>0){let U=r.getToken();for(;U!==17;){if($e.indexOf(U)!==-1){_();break}else if(ne.indexOf(U)!==-1)break;U=_()}}}function T(ie){const $e=r.getTokenValue();return ie?I($e):S($e),_(),!0}function J(){switch(r.getToken()){case 11:{let ie=0;try{ie=JSON.parse(r.getTokenValue()),typeof ie!="number"&&(z(2),ie=0)}catch{z(2)}I(ie);break}case 7:I(null);break;case 8:I(!0);break;case 9:I(!1);break;default:return!1}return _(),!0}function Y(){return r.getToken()!==10?(z(3,[],[2,5]),!1):(T(!1),r.getToken()===6?(B(":"),_(),ue()||z(4,[],[2,5])):z(5,[],[2,5]),!0)}function W(){v(),_();let ie=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(ie||z(4,[],[]),B(","),_(),r.getToken()===2&&ee)break}else ie&&z(6,[],[]);Y()||z(4,[],[2,5]),ie=!0}return O(),r.getToken()!==2?z(7,[2],[]):_(),!0}function re(){N(),_();let ie=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(ie||z(4,[],[]),B(","),_(),r.getToken()===4&&ee)break}else ie&&z(6,[],[]);ue()||z(4,[],[4,5]),ie=!0}return j(),r.getToken()!==4?z(8,[4],[]):_(),!0}function ue(){switch(r.getToken()){case 3:return re();case 1:return W();case 10:return T(!0);default:return J()}}return _(),r.getToken()===17?o.allowEmptyContent?!0:(z(4,[],[]),!1):ue()?(r.getToken()!==17&&z(9,[],[]),!0):(z(4,[],[]),!1)}function f(t,a){const o=C(t),r=[];let s,i=0,v;do switch(v=o.getPosition(),s=o.scan(),s){case 12:case 13:case 17:i!==v&&r.push(t.substring(i,v)),a!==void 0&&r.push(o.getTokenValue().replace(/[^\r\n]/g,a)),i=o.getPosition();break}while(s!==17);return r.join("")}function l(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(Ee[146],ke([1,0,42]),function(ce,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gn=A,e.$Hn=P,e.$In=k,e.$Jn=b;function A($,E,y){let w,g,d,c,m;if(E){for(c=E.offset,m=c+E.length,d=c;d>0&&!b($,d-1);)d--;let v=m;for(;v<$.length&&!b($,v);)v++;g=$.substring(d,v),w=C(g,y)}else g=$,w=0,d=0,c=0,m=$.length;const u=k(y,$);let p=!1,h=0,f;y.insertSpaces?f=D(" ",y.tabSize||4):f="	";const l=(0,n.$un)(g,!1);let t=!1;function a(){return u+D(f,w+h)}function o(){let v=l.scan();for(p=!1;v===15||v===14;)p=p||v===14,v=l.scan();return t=v===16||l.getTokenError()!==0,v}const r=[];function s(v,S,O){!t&&S<m&&O>c&&$.substring(S,O)!==v&&r.push({offset:S,length:O-S,content:v})}let i=o();if(i!==17){const v=l.getTokenOffset()+d,S=D(f,w);s(S,d,v)}for(;i!==17;){let v=l.getTokenOffset()+l.getTokenLength()+d,S=o(),O="";for(;!p&&(S===12||S===13);){const j=l.getTokenOffset()+d;s(" ",v,j),v=l.getTokenOffset()+l.getTokenLength()+d,O=S===12?a():"",S=o()}if(S===2)i!==1&&(h--,O=a());else if(S===4)i!==3&&(h--,O=a());else{switch(i){case 3:case 1:h++,O=a();break;case 5:case 12:O=a();break;case 13:p?O=a():O=" ";break;case 6:O=" ";break;case 10:if(S===6){O="";break}case 7:case 8:case 9:case 11:case 2:case 4:S===12||S===13?O=" ":S!==5&&S!==17&&(t=!0);break;case 16:t=!0;break}p&&(S===12||S===13)&&(O=a())}const N=l.getTokenOffset()+d;s(O,v,N),i=S}return r}function P($,E){const y=JSON.stringify($,void 0,E.insertSpaces?E.tabSize||4:"	");return E.eol!==void 0?y.replace(/\r\n|\r|\n/g,E.eol):y}function D($,E){let y="";for(let w=0;w<E;w++)y+=$;return y}function C($,E){let y=0,w=0;const g=E.tabSize||4;for(;y<$.length;){const d=$.charAt(y);if(d===" ")w++;else if(d==="	")w+=g;else break;y++}return Math.floor(w/g)}function k($,E){for(let y=0;y<E.length;y++){const w=E.charAt(y);if(w==="\r")return y+1<E.length&&E.charAt(y+1)===`
`?`\r
`:"\r";if(w===`
`)return`
`}return $&&$.eol||`
`}function b($,E){return`\r
`.indexOf($.charAt(E))!==-1}}),define(Ee[147],ke([1,0,42,146]),function(ce,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kn=P,e.$Ln=D,e.$Mn=C,e.$Nn=k,e.$On=b;function P($,E,y){return D($,E,void 0,y)}function D($,E,y,w,g){const d=E.slice(),c=[],m=(0,n.$xn)($,c);let u,p;for(;d.length>0&&(p=d.pop(),u=(0,n.$yn)(m,d),u===void 0&&y!==void 0);)typeof p=="string"?y={[p]:y}:y=[y];if(u)if(u.type==="object"&&typeof p=="string"&&Array.isArray(u.children)){const h=(0,n.$yn)(u,[p]);if(h!==void 0)if(y===void 0){if(!h.parent)throw new Error("Malformed AST");const f=u.children.indexOf(h.parent);let l,t=h.parent.offset+h.parent.length;if(f>0){const a=u.children[f-1];l=a.offset+a.length}else l=u.offset+1,u.children.length>1&&(t=u.children[1].offset);return C($,{offset:l,length:t-l,content:""},w)}else return C($,{offset:h.offset,length:h.length,content:JSON.stringify(y)},w);else{if(y===void 0)return[];const f=`${JSON.stringify(p)}: ${JSON.stringify(y)}`,l=g?g(u.children.map(a=>a.children[0].value)):u.children.length;let t;if(l>0){const a=u.children[l-1];t={offset:a.offset+a.length,length:0,content:","+f}}else u.children.length===0?t={offset:u.offset+1,length:0,content:f}:t={offset:u.offset+1,length:0,content:f+","};return C($,t,w)}}else if(u.type==="array"&&typeof p=="number"&&Array.isArray(u.children))if(y!==void 0){const h=`${JSON.stringify(y)}`;let f;if(u.children.length===0||p===0)f={offset:u.offset+1,length:0,content:u.children.length===0?h:h+","};else{const l=p===-1||p>u.children.length?u.children.length:p,t=u.children[l-1];f={offset:t.offset+t.length,length:0,content:","+h}}return C($,f,w)}else{const h=p,f=u.children[h];let l;if(u.children.length===1)l={offset:u.offset+1,length:u.length-2,content:""};else if(u.children.length-1===h){const t=u.children[h-1],a=t.offset+t.length,o=u.offset+u.length;l={offset:a,length:o-2-a,content:""}}else l={offset:f.offset,length:u.children[h+1].offset-f.offset,content:""};return C($,l,w)}else throw new Error(`Can not add ${typeof p!="number"?"index":"property"} to parent of type ${u.type}`);else{if(y===void 0)throw new Error("Can not delete in empty document");return C($,{offset:m?m.offset:0,length:m?m.length:0,content:JSON.stringify(y)},w)}}function C($,E,y){let w=k($,E),g=E.offset,d=E.offset+E.content.length;if(E.length===0||E.content.length===0){for(;g>0&&!(0,A.$Jn)(w,g-1);)g--;for(;d<w.length&&!(0,A.$Jn)(w,d);)d++}const c=(0,A.$Gn)(w,{offset:g,length:d-g},y);for(let u=c.length-1;u>=0;u--){const p=c[u];w=k(w,p),g=Math.min(g,p.offset),d=Math.max(d,p.offset+p.length),d+=p.content.length-p.length}const m=$.length-(w.length-d)-g;return[{offset:g,length:m,content:w.substring(g,d)}]}function k($,E){return $.substring(0,E.offset)+E.content+$.substring(E.offset+E.length)}function b($,E){const y=E.slice(0).sort((g,d)=>{const c=g.offset-d.offset;return c===0?g.length-d.length:c});let w=$.length;for(let g=y.length-1;g>=0;g--){const d=y[g];if(d.offset+d.length<=w)$=k($,d);else throw new Error("Overlapping edit");w=d.offset}return $}}),define(Ee[60],ke([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class n{constructor(P){this.d=P,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(P){this.c=P}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=n}),define(Ee[98],ke([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=void 0;class n{constructor(D){this.element=D,this.next=n.Undefined,this.prev=n.Undefined}}n.Undefined=new n(void 0);class A{constructor(){this.a=n.Undefined,this.b=n.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===n.Undefined}clear(){let D=this.a;for(;D!==n.Undefined;){const C=D.next;D.prev=n.Undefined,D.next=n.Undefined,D=C}this.a=n.Undefined,this.b=n.Undefined,this.c=0}unshift(D){return this.d(D,!1)}push(D){return this.d(D,!0)}d(D,C){const k=new n(D);if(this.a===n.Undefined)this.a=k,this.b=k;else if(C){const $=this.b;this.b=k,k.prev=$,$.next=k}else{const $=this.a;this.a=k,k.next=$,$.prev=k}this.c+=1;let b=!1;return()=>{b||(b=!0,this.e(k))}}shift(){if(this.a!==n.Undefined){const D=this.a.element;return this.e(this.a),D}}pop(){if(this.b!==n.Undefined){const D=this.b.element;return this.e(this.b),D}}e(D){if(D.prev!==n.Undefined&&D.next!==n.Undefined){const C=D.prev;C.next=D.next,D.next.prev=C}else D.prev===n.Undefined&&D.next===n.Undefined?(this.a=n.Undefined,this.b=n.Undefined):D.next===n.Undefined?(this.b=this.b.prev,this.b.next=n.Undefined):D.prev===n.Undefined&&(this.a=this.a.next,this.a.prev=n.Undefined);this.c-=1}*[Symbol.iterator](){let D=this.a;for(;D!==n.Undefined;)yield D.element,D=D.next}}e.$5c=A}),define(Ee[24],ke([1,0]),function(ce,e){"use strict";var n,A,P;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.Touch=e.$Cc=e.$Bc=void 0,e.$yc=D,e.$zc=C,e.$Ac=k,e.$Ic=p;function D(h,f,l){let t=h.get(f);return t===void 0&&(t=l,h.set(f,t)),t}function C(h){const f=[];return h.forEach((l,t)=>{f.push(`${t} => ${l}`)}),`Map(${h.size}) {${f.join(", ")}}`}function k(h){const f=[];return h.forEach(l=>{f.push(l)}),`Set(${h.size}) {${f.join(", ")}}`}class b{constructor(f,l){this.uri=f,this.value=l}}function $(h){return Array.isArray(h)}class E{constructor(f,l){if(this[n]="ResourceMap",f instanceof E)this.d=new Map(f.d),this.e=l??E.c;else if($(f)){this.d=new Map,this.e=l??E.c;for(const[t,a]of f)this.set(t,a)}else this.d=new Map,this.e=f??E.c}set(f,l){return this.d.set(this.e(f),new b(f,l)),this}get(f){return this.d.get(this.e(f))?.value}has(f){return this.d.has(this.e(f))}get size(){return this.d.size}clear(){this.d.clear()}delete(f){return this.d.delete(this.e(f))}forEach(f,l){typeof l<"u"&&(f=f.bind(l));for(const[t,a]of this.d)f(a.value,a.uri,this)}*values(){for(const f of this.d.values())yield f.value}*keys(){for(const f of this.d.values())yield f.uri}*entries(){for(const f of this.d.values())yield[f.uri,f.value]}*[(n=Symbol.toStringTag,Symbol.iterator)](){for(const[,f]of this.d)yield[f.uri,f.value]}}e.$Bc=E,E.c=h=>h.toString();class y{constructor(f,l){this[A]="ResourceSet",!f||typeof f=="function"?this.c=new E(f):(this.c=new E(l),f.forEach(this.add,this))}get size(){return this.c.size}add(f){return this.c.set(f,f),this}clear(){this.c.clear()}delete(f){return this.c.delete(f)}forEach(f,l){this.c.forEach((t,a)=>f.call(l,a,a,this))}has(f){return this.c.has(f)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Cc=y;var w;(function(h){h[h.None=0]="None",h[h.AsOld=1]="AsOld",h[h.AsNew=2]="AsNew"})(w||(e.Touch=w={}));class g{constructor(){this[P]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(f){return this.c.has(f)}get(f,l=0){const t=this.c.get(f);if(t)return l!==0&&this.l(t,l),t.value}set(f,l,t=0){let a=this.c.get(f);if(a)a.value=l,t!==0&&this.l(a,t);else{switch(a={key:f,value:l,next:void 0,previous:void 0},t){case 0:this.j(a);break;case 1:this.i(a);break;case 2:this.j(a);break;default:this.j(a);break}this.c.set(f,a),this.f++}return this}delete(f){return!!this.remove(f)}remove(f){const l=this.c.get(f);if(l)return this.c.delete(f),this.k(l),this.f--,l.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const f=this.d;return this.c.delete(f.key),this.k(f),this.f--,f.value}forEach(f,l){const t=this.g;let a=this.d;for(;a;){if(l?f.bind(l)(a.value,a.key,this):f(a.value,a.key,this),this.g!==t)throw new Error("LinkedMap got modified during iteration.");a=a.next}}keys(){const f=this,l=this.g;let t=this.d;const a={[Symbol.iterator](){return a},next(){if(f.g!==l)throw new Error("LinkedMap got modified during iteration.");if(t){const o={value:t.key,done:!1};return t=t.next,o}else return{value:void 0,done:!0}}};return a}values(){const f=this,l=this.g;let t=this.d;const a={[Symbol.iterator](){return a},next(){if(f.g!==l)throw new Error("LinkedMap got modified during iteration.");if(t){const o={value:t.value,done:!1};return t=t.next,o}else return{value:void 0,done:!0}}};return a}entries(){const f=this,l=this.g;let t=this.d;const a={[Symbol.iterator](){return a},next(){if(f.g!==l)throw new Error("LinkedMap got modified during iteration.");if(t){const o={value:[t.key,t.value],done:!1};return t=t.next,o}else return{value:void 0,done:!0}}};return a}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(f){if(f>=this.size)return;if(f===0){this.clear();return}let l=this.d,t=this.size;for(;l&&t>f;)this.c.delete(l.key),l=l.next,t--;this.d=l,this.f=t,l&&(l.previous=void 0),this.g++}i(f){if(!this.d&&!this.e)this.e=f;else if(this.d)f.next=this.d,this.d.previous=f;else throw new Error("Invalid list");this.d=f,this.g++}j(f){if(!this.d&&!this.e)this.d=f;else if(this.e)f.previous=this.e,this.e.next=f;else throw new Error("Invalid list");this.e=f,this.g++}k(f){if(f===this.d&&f===this.e)this.d=void 0,this.e=void 0;else if(f===this.d){if(!f.next)throw new Error("Invalid list");f.next.previous=void 0,this.d=f.next}else if(f===this.e){if(!f.previous)throw new Error("Invalid list");f.previous.next=void 0,this.e=f.previous}else{const l=f.next,t=f.previous;if(!l||!t)throw new Error("Invalid list");l.previous=t,t.next=l}f.next=void 0,f.previous=void 0,this.g++}l(f,l){if(!this.d||!this.e)throw new Error("Invalid list");if(!(l!==1&&l!==2)){if(l===1){if(f===this.d)return;const t=f.next,a=f.previous;f===this.e?(a.next=void 0,this.e=a):(t.previous=a,a.next=t),f.previous=void 0,f.next=this.d,this.d.previous=f,this.d=f,this.g++}else if(l===2){if(f===this.e)return;const t=f.next,a=f.previous;f===this.d?(t.previous=void 0,this.d=t):(t.previous=a,a.next=t),f.next=void 0,f.previous=this.e,this.e.next=f,this.e=f,this.g++}}}toJSON(){const f=[];return this.forEach((l,t)=>{f.push([t,l])}),f}fromJSON(f){this.clear();for(const[l,t]of f)this.set(l,t)}}e.$Dc=g;class d extends g{constructor(f,l=1){super(),this.m=f,this.n=Math.min(Math.max(0,l),1)}get limit(){return this.m}set limit(f){this.m=f,this.o()}get ratio(){return this.n}set ratio(f){this.n=Math.min(Math.max(0,f),1),this.o()}get(f,l=2){return super.get(f,l)}peek(f){return super.get(f,0)}set(f,l){return super.set(f,l,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}e.$Ec=d;class c{constructor(){this.c=new Map}add(f){return this.c.set(f,(this.c.get(f)||0)+1),this}delete(f){let l=this.c.get(f)||0;return l===0?!1:(l--,l===0?this.c.delete(f):this.c.set(f,l),!0)}has(f){return this.c.has(f)}}e.$Fc=c;class m{constructor(f){if(this.c=new Map,this.d=new Map,f)for(const[l,t]of f)this.set(l,t)}clear(){this.c.clear(),this.d.clear()}set(f,l){this.c.set(f,l),this.d.set(l,f)}get(f){return this.c.get(f)}getKey(f){return this.d.get(f)}delete(f){const l=this.c.get(f);return l===void 0?!1:(this.c.delete(f),this.d.delete(l),!0)}forEach(f,l){this.c.forEach((t,a)=>{f.call(l,t,a,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Gc=m;class u{constructor(){this.c=new Map}add(f,l){let t=this.c.get(f);t||(t=new Set,this.c.set(f,t)),t.add(l)}delete(f,l){const t=this.c.get(f);t&&(t.delete(l),t.size===0&&this.c.delete(f))}forEach(f,l){const t=this.c.get(f);t&&t.forEach(l)}get(f){const l=this.c.get(f);return l||new Set}}e.$Hc=u;function p(h,f){if(h===f)return!0;if(h.size!==f.size)return!1;for(const[l,t]of h)if(!f.has(l)||f.get(l)!==t)return!1;for(const[l]of f)if(!h.has(l))return!1;return!0}}),define(Ee[2],ke([1,0,18,145,24,75,41]),function(ce,e,n,A,P,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Jc=void 0,e.$Kc=E,e.$Lc=y,e.$Mc=w,e.$Nc=c,e.$Oc=m,e.$Pc=u,e.$Qc=p,e.$Rc=h,e.$Sc=f,e.$3c=O;const k=!1;let b=null;class ${constructor(){this.b=new Map}c(I){let B=this.b.get(I);return B||(B={parent:null,source:null,isSingleton:!1,value:I,idx:$.a++},this.b.set(I,B)),B}trackDisposable(I){const B=this.c(I);B.source||(B.source=new Error().stack)}setParent(I,B){const Z=this.c(I);Z.parent=B}markAsDisposed(I){this.b.delete(I)}markAsSingleton(I){this.c(I).isSingleton=!0}f(I,B){const Z=B.get(I);if(Z)return Z;const he=I.parent?this.f(this.c(I.parent),B):I;return B.set(I,he),he}getTrackedDisposables(){const I=new Map;return[...this.b.entries()].filter(([,Z])=>Z.source!==null&&!this.f(Z,I).isSingleton).flatMap(([Z])=>Z)}computeLeakingDisposables(I=10,B){let Z;if(B)Z=B;else{const z=new Map,T=[...this.b.values()].filter(Y=>Y.source!==null&&!this.f(Y,z).isSingleton);if(T.length===0)return;const J=new Set(T.map(Y=>Y.value));if(Z=T.filter(Y=>!(Y.parent&&J.has(Y.parent))),Z.length===0)throw new Error("There are cyclic diposable chains!")}if(!Z)return;function he(z){function T(Y,W){for(;Y.length>0&&W.some(re=>typeof re=="string"?re===Y[0]:Y[0].match(re));)Y.shift()}const J=z.source.split(`
`).map(Y=>Y.trim().replace("at ","")).filter(Y=>Y!=="");return T(J,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),J.reverse()}const ae=new P.$Hc;for(const z of Z){const T=he(z);for(let J=0;J<=T.length;J++)ae.add(T.slice(0,J).join(`
`),z)}Z.sort((0,n.$7b)(z=>z.idx,n.$9b));let ee="",_=0;for(const z of Z.slice(0,I)){_++;const T=he(z),J=[];for(let Y=0;Y<T.length;Y++){let W=T[Y];W=`(shared with ${ae.get(T.slice(0,Y+1).join(`
`)).size}/${Z.length} leaks) at ${W}`;const ue=ae.get(T.slice(0,Y).join(`
`)),ie=(0,A.$E)([...ue].map($e=>he($e)[Y]),$e=>$e);delete ie[T[Y]];for(const[$e,ne]of Object.entries(ie))J.unshift(`    - stacktraces of ${ne.length} other leaks continue with ${$e}`);J.unshift(W)}ee+=`


==================== Leaking disposable ${_}/${Z.length}: ${z.value.constructor.name} ====================
${J.join(`
`)}
============================================================

`}return Z.length>I&&(ee+=`


... and ${Z.length-I} more leaking disposables

`),{leaks:Z,details:ee}}}e.$Jc=$,$.a=0;function E(j){b=j}if(k){const j="__is_disposable_tracked__";E(new class{trackDisposable(I){const B=new Error("Potentially leaked disposable").stack;setTimeout(()=>{I[j]||console.log(B)},3e3)}setParent(I,B){if(I&&I!==t.None)try{I[j]=!0}catch{}}markAsDisposed(I){if(I&&I!==t.None)try{I[j]=!0}catch{}}markAsSingleton(I){}})}function y(j){return b?.trackDisposable(j),j}function w(j){b?.markAsDisposed(j)}function g(j,I){b?.setParent(j,I)}function d(j,I){if(b)for(const B of j)b.setParent(B,I)}function c(j){return b?.markAsSingleton(j),j}function m(j){return typeof j.dispose=="function"&&j.dispose.length===0}function u(j){if(C.Iterable.is(j)){const I=[];for(const B of j)if(B)try{B.dispose()}catch(Z){I.push(Z)}if(I.length===1)throw I[0];if(I.length>1)throw new AggregateError(I,"Encountered errors while disposing of store");return Array.isArray(j)?[]:j}else if(j)return j.dispose(),j}function p(j){for(const I of j)m(I)&&I.dispose();return[]}function h(...j){const I=f(()=>u(j));return d(j,I),I}function f(j){const I=y({dispose:(0,D.$db)(()=>{w(I),j()})});return I}class l{constructor(){this.f=new Set,this.g=!1,y(this)}dispose(){this.g||(w(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{u(this.f)}finally{this.f.clear()}}add(I){if(!I)return I;if(I===this)throw new Error("Cannot register a disposable on itself!");return g(I,this),this.g?l.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(I),I}delete(I){if(I){if(I===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(I),I.dispose()}}deleteAndLeak(I){I&&this.f.has(I)&&(this.f.delete(I),g(I,null))}}e.$Tc=l,l.DISABLE_DISPOSED_WARNING=!1;class t{constructor(){this.q=new l,y(this),g(this.q,this)}dispose(){w(this),this.q.dispose()}B(I){if(I===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(I)}}e.$Uc=t,t.None=Object.freeze({dispose(){}});class a{constructor(){this.b=!1,y(this)}get value(){return this.b?void 0:this.a}set value(I){this.b||I===this.a||(this.a?.dispose(),I&&g(I,this),this.a=I)}clear(){this.value=void 0}dispose(){this.b=!0,w(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const I=this.a;return this.a=void 0,I&&g(I,null),I}}e.$Vc=a;class o{constructor(I){this.a=new a,this.b=!1,this.a.value=I}get value(){return this.a.value}set value(I){this.b||I===this.a.value||(this.a.value=I)}dispose(){this.b=!0,this.a.dispose()}}e.$Wc=o;class r{constructor(I){this.b=I,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Xc=r;class s{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,y(this)}set(I){let B=I;return this.unset=()=>B=void 0,this.isset=()=>B!==void 0,this.dispose=()=>{B&&(B(),B=void 0,w(this))},this}}e.$Yc=s;class i{constructor(){this.a=new Map}acquire(I,...B){let Z=this.a.get(I);Z||(Z={counter:0,object:this.b(I,...B)},this.a.set(I,Z));const{object:he}=Z,ae=(0,D.$db)(()=>{--Z.counter===0&&(this.c(I,Z.object),this.a.delete(I))});return Z.counter++,{object:he,dispose:ae}}}e.$Zc=i;class v{constructor(I){this.a=I}async acquire(I,...B){const Z=this.a.acquire(I,...B);try{return{object:await Z.object,dispose:()=>Z.dispose()}}catch(he){throw Z.dispose(),he}}}e.$1c=v;class S{constructor(I){this.object=I}dispose(){}}e.$2c=S;function O(j){const I=new l;try{j(I)}finally{I.dispose()}}class N{constructor(){this.a=new Map,this.b=!1,y(this)}dispose(){w(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{u(this.a.values())}finally{this.a.clear()}}has(I){return this.a.has(I)}get size(){return this.a.size}get(I){return this.a.get(I)}set(I,B,Z=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),Z||this.a.get(I)?.dispose(),this.a.set(I,B)}deleteAndDispose(I){this.a.get(I)?.dispose(),this.a.delete(I)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$4c=N}),function(ce,e){typeof define=="function"&&define.amd?define(Ee[148],ke([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(ce=typeof globalThis<"u"?globalThis:ce||self,e(ce.marked={}))}(this,function(ce){"use strict";function e(Q,x){for(var V=0;V<x.length;V++){var L=x[V];L.enumerable=L.enumerable||!1,L.configurable=!0,"value"in L&&(L.writable=!0),Object.defineProperty(Q,L.key,L)}}function n(Q,x,V){return x&&e(Q.prototype,x),V&&e(Q,V),Object.defineProperty(Q,"prototype",{writable:!1}),Q}function A(Q,x){if(Q){if(typeof Q=="string")return P(Q,x);var V=Object.prototype.toString.call(Q).slice(8,-1);if(V==="Object"&&Q.constructor&&(V=Q.constructor.name),V==="Map"||V==="Set")return Array.from(Q);if(V==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(V))return P(Q,x)}}function P(Q,x){(x==null||x>Q.length)&&(x=Q.length);for(var V=0,L=new Array(x);V<x;V++)L[V]=Q[V];return L}function D(Q,x){var V=typeof Symbol<"u"&&Q[Symbol.iterator]||Q["@@iterator"];if(V)return(V=V.call(Q)).next.bind(V);if(Array.isArray(Q)||(V=A(Q))||x&&Q&&typeof Q.length=="number"){V&&(Q=V);var L=0;return function(){return L>=Q.length?{done:!0}:{done:!1,value:Q[L++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function C(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ce.defaults=C();function k(Q){ce.defaults=Q}var b=/[&<>"']/,$=/[&<>"']/g,E=/[<>"']|&(?!#?\w+;)/,y=/[<>"']|&(?!#?\w+;)/g,w={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},g=function(x){return w[x]};function d(Q,x){if(x){if(b.test(Q))return Q.replace($,g)}else if(E.test(Q))return Q.replace(y,g);return Q}var c=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function m(Q){return Q.replace(c,function(x,V){return V=V.toLowerCase(),V==="colon"?":":V.charAt(0)==="#"?V.charAt(1)==="x"?String.fromCharCode(parseInt(V.substring(2),16)):String.fromCharCode(+V.substring(1)):""})}var u=/(^|[^\[])\^/g;function p(Q,x){Q=typeof Q=="string"?Q:Q.source,x=x||"";var V={replace:function(H,K){return K=K.source||K,K=K.replace(u,"$1"),Q=Q.replace(H,K),V},getRegex:function(){return new RegExp(Q,x)}};return V}var h=/[^\w:]/g,f=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function l(Q,x,V){if(Q){var L;try{L=decodeURIComponent(m(V)).replace(h,"").toLowerCase()}catch{return null}if(L.indexOf("javascript:")===0||L.indexOf("vbscript:")===0||L.indexOf("data:")===0)return null}x&&!f.test(V)&&(V=s(x,V));try{V=encodeURI(V).replace(/%25/g,"%")}catch{return null}return V}var t={},a=/^[^:]+:\/*[^/]*$/,o=/^([^:]+:)[\s\S]*$/,r=/^([^:]+:\/*[^/]*)[\s\S]*$/;function s(Q,x){t[" "+Q]||(a.test(Q)?t[" "+Q]=Q+"/":t[" "+Q]=O(Q,"/",!0)),Q=t[" "+Q];var V=Q.indexOf(":")===-1;return x.substring(0,2)==="//"?V?x:Q.replace(o,"$1")+x:x.charAt(0)==="/"?V?x:Q.replace(r,"$1")+x:Q+x}var i={exec:function(){}};function v(Q){for(var x=1,V,L;x<arguments.length;x++){V=arguments[x];for(L in V)Object.prototype.hasOwnProperty.call(V,L)&&(Q[L]=V[L])}return Q}function S(Q,x){var V=Q.replace(/\|/g,function(K,te,de){for(var se=!1,ge=te;--ge>=0&&de[ge]==="\\";)se=!se;return se?"|":" |"}),L=V.split(/ \|/),H=0;if(L[0].trim()||L.shift(),L.length>0&&!L[L.length-1].trim()&&L.pop(),L.length>x)L.splice(x);else for(;L.length<x;)L.push("");for(;H<L.length;H++)L[H]=L[H].trim().replace(/\\\|/g,"|");return L}function O(Q,x,V){var L=Q.length;if(L===0)return"";for(var H=0;H<L;){var K=Q.charAt(L-H-1);if(K===x&&!V)H++;else if(K!==x&&V)H++;else break}return Q.slice(0,L-H)}function N(Q,x){if(Q.indexOf(x[1])===-1)return-1;for(var V=Q.length,L=0,H=0;H<V;H++)if(Q[H]==="\\")H++;else if(Q[H]===x[0])L++;else if(Q[H]===x[1]&&(L--,L<0))return H;return-1}function j(Q){Q&&Q.sanitize&&!Q.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function I(Q,x){if(x<1)return"";for(var V="";x>1;)x&1&&(V+=Q),x>>=1,Q+=Q;return V+Q}function B(Q,x,V,L){var H=x.href,K=x.title?d(x.title):null,te=Q[1].replace(/\\([\[\]])/g,"$1");if(Q[0].charAt(0)!=="!"){L.state.inLink=!0;var de={type:"link",raw:V,href:H,title:K,text:te,tokens:L.inlineTokens(te)};return L.state.inLink=!1,de}return{type:"image",raw:V,href:H,title:K,text:d(te)}}function Z(Q,x){var V=Q.match(/^(\s+)(?:```)/);if(V===null)return x;var L=V[1];return x.split(`
`).map(function(H){var K=H.match(/^\s+/);if(K===null)return H;var te=K[0];return te.length>=L.length?H.slice(L.length):H}).join(`
`)}var he=function(){function Q(V){this.options=V||ce.defaults}var x=Q.prototype;return x.space=function(L){var H=this.rules.block.newline.exec(L);if(H&&H[0].length>0)return{type:"space",raw:H[0]}},x.code=function(L){var H=this.rules.block.code.exec(L);if(H){var K=H[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:H[0],codeBlockStyle:"indented",text:this.options.pedantic?K:O(K,`
`)}}},x.fences=function(L){var H=this.rules.block.fences.exec(L);if(H){var K=H[0],te=Z(K,H[3]||"");return{type:"code",raw:K,lang:H[2]?H[2].trim():H[2],text:te}}},x.heading=function(L){var H=this.rules.block.heading.exec(L);if(H){var K=H[2].trim();if(/#$/.test(K)){var te=O(K,"#");(this.options.pedantic||!te||/ $/.test(te))&&(K=te.trim())}return{type:"heading",raw:H[0],depth:H[1].length,text:K,tokens:this.lexer.inline(K)}}},x.hr=function(L){var H=this.rules.block.hr.exec(L);if(H)return{type:"hr",raw:H[0]}},x.blockquote=function(L){var H=this.rules.block.blockquote.exec(L);if(H){var K=H[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:H[0],tokens:this.lexer.blockTokens(K,[]),text:K}}},x.list=function(L){var H=this.rules.block.list.exec(L);if(H){var K,te,de,se,ge,we,Ie,je,pe,Pe,Ce,Le,Me=H[1].trim(),Ve=Me.length>1,qe={type:"list",raw:"",ordered:Ve,start:Ve?+Me.slice(0,-1):"",loose:!1,items:[]};Me=Ve?"\\d{1,9}\\"+Me.slice(-1):"\\"+Me,this.options.pedantic&&(Me=Ve?Me:"[*+-]");for(var xe=new RegExp("^( {0,3}"+Me+")((?:[	 ][^\\n]*)?(?:\\n|$))");L&&(Le=!1,!(!(H=xe.exec(L))||this.rules.block.hr.test(L)));){if(K=H[0],L=L.substring(K.length),je=H[2].split(`
`,1)[0],pe=L.split(`
`,1)[0],this.options.pedantic?(se=2,Ce=je.trimLeft()):(se=H[2].search(/[^ ]/),se=se>4?1:se,Ce=je.slice(se),se+=H[1].length),we=!1,!je&&/^ *$/.test(pe)&&(K+=pe+`
`,L=L.substring(pe.length+1),Le=!0),!Le)for(var _e=new RegExp("^ {0,"+Math.min(3,se-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Ke=new RegExp("^ {0,"+Math.min(3,se-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),nt=new RegExp("^ {0,"+Math.min(3,se-1)+"}(?:```|~~~)"),Ye=new RegExp("^ {0,"+Math.min(3,se-1)+"}#");L&&(Pe=L.split(`
`,1)[0],je=Pe,this.options.pedantic&&(je=je.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(nt.test(je)||Ye.test(je)||_e.test(je)||Ke.test(L)));){if(je.search(/[^ ]/)>=se||!je.trim())Ce+=`
`+je.slice(se);else if(!we)Ce+=`
`+je;else break;!we&&!je.trim()&&(we=!0),K+=Pe+`
`,L=L.substring(Pe.length+1)}qe.loose||(Ie?qe.loose=!0:/\n *\n *$/.test(K)&&(Ie=!0)),this.options.gfm&&(te=/^\[[ xX]\] /.exec(Ce),te&&(de=te[0]!=="[ ] ",Ce=Ce.replace(/^\[[ xX]\] +/,""))),qe.items.push({type:"list_item",raw:K,task:!!te,checked:de,loose:!1,text:Ce}),qe.raw+=K}qe.items[qe.items.length-1].raw=K.trimRight(),qe.items[qe.items.length-1].text=Ce.trimRight(),qe.raw=qe.raw.trimRight();var Qe=qe.items.length;for(ge=0;ge<Qe;ge++){this.lexer.state.top=!1,qe.items[ge].tokens=this.lexer.blockTokens(qe.items[ge].text,[]);var me=qe.items[ge].tokens.filter(function(Ae){return Ae.type==="space"}),Se=me.every(function(Ae){for(var Re=Ae.raw.split(""),Te=0,He=D(Re),We;!(We=He()).done;){var rt=We.value;if(rt===`
`&&(Te+=1),Te>1)return!0}return!1});!qe.loose&&me.length&&Se&&(qe.loose=!0,qe.items[ge].loose=!0)}return qe}},x.html=function(L){var H=this.rules.block.html.exec(L);if(H){var K={type:"html",raw:H[0],pre:!this.options.sanitizer&&(H[1]==="pre"||H[1]==="script"||H[1]==="style"),text:H[0]};if(this.options.sanitize){var te=this.options.sanitizer?this.options.sanitizer(H[0]):d(H[0]);K.type="paragraph",K.text=te,K.tokens=this.lexer.inline(te)}return K}},x.def=function(L){var H=this.rules.block.def.exec(L);if(H){H[3]&&(H[3]=H[3].substring(1,H[3].length-1));var K=H[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:K,raw:H[0],href:H[2],title:H[3]}}},x.table=function(L){var H=this.rules.block.table.exec(L);if(H){var K={type:"table",header:S(H[1]).map(function(Ie){return{text:Ie}}),align:H[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:H[3]&&H[3].trim()?H[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(K.header.length===K.align.length){K.raw=H[0];var te=K.align.length,de,se,ge,we;for(de=0;de<te;de++)/^ *-+: *$/.test(K.align[de])?K.align[de]="right":/^ *:-+: *$/.test(K.align[de])?K.align[de]="center":/^ *:-+ *$/.test(K.align[de])?K.align[de]="left":K.align[de]=null;for(te=K.rows.length,de=0;de<te;de++)K.rows[de]=S(K.rows[de],K.header.length).map(function(Ie){return{text:Ie}});for(te=K.header.length,se=0;se<te;se++)K.header[se].tokens=this.lexer.inline(K.header[se].text);for(te=K.rows.length,se=0;se<te;se++)for(we=K.rows[se],ge=0;ge<we.length;ge++)we[ge].tokens=this.lexer.inline(we[ge].text);return K}}},x.lheading=function(L){var H=this.rules.block.lheading.exec(L);if(H)return{type:"heading",raw:H[0],depth:H[2].charAt(0)==="="?1:2,text:H[1],tokens:this.lexer.inline(H[1])}},x.paragraph=function(L){var H=this.rules.block.paragraph.exec(L);if(H){var K=H[1].charAt(H[1].length-1)===`
`?H[1].slice(0,-1):H[1];return{type:"paragraph",raw:H[0],text:K,tokens:this.lexer.inline(K)}}},x.text=function(L){var H=this.rules.block.text.exec(L);if(H)return{type:"text",raw:H[0],text:H[0],tokens:this.lexer.inline(H[0])}},x.escape=function(L){var H=this.rules.inline.escape.exec(L);if(H)return{type:"escape",raw:H[0],text:d(H[1])}},x.tag=function(L){var H=this.rules.inline.tag.exec(L);if(H)return!this.lexer.state.inLink&&/^<a /i.test(H[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(H[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(H[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(H[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:H[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(H[0]):d(H[0]):H[0]}},x.link=function(L){var H=this.rules.inline.link.exec(L);if(H){var K=H[2].trim();if(!this.options.pedantic&&/^</.test(K)){if(!/>$/.test(K))return;var te=O(K.slice(0,-1),"\\");if((K.length-te.length)%2===0)return}else{var de=N(H[2],"()");if(de>-1){var se=H[0].indexOf("!")===0?5:4,ge=se+H[1].length+de;H[2]=H[2].substring(0,de),H[0]=H[0].substring(0,ge).trim(),H[3]=""}}var we=H[2],Ie="";if(this.options.pedantic){var je=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(we);je&&(we=je[1],Ie=je[3])}else Ie=H[3]?H[3].slice(1,-1):"";return we=we.trim(),/^</.test(we)&&(this.options.pedantic&&!/>$/.test(K)?we=we.slice(1):we=we.slice(1,-1)),B(H,{href:we&&we.replace(this.rules.inline._escapes,"$1"),title:Ie&&Ie.replace(this.rules.inline._escapes,"$1")},H[0],this.lexer)}},x.reflink=function(L,H){var K;if((K=this.rules.inline.reflink.exec(L))||(K=this.rules.inline.nolink.exec(L))){var te=(K[2]||K[1]).replace(/\s+/g," ");if(te=H[te.toLowerCase()],!te||!te.href){var de=K[0].charAt(0);return{type:"text",raw:de,text:de}}return B(K,te,K[0],this.lexer)}},x.emStrong=function(L,H,K){K===void 0&&(K="");var te=this.rules.inline.emStrong.lDelim.exec(L);if(te&&!(te[3]&&K.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var de=te[1]||te[2]||"";if(!de||de&&(K===""||this.rules.inline.punctuation.exec(K))){var se=te[0].length-1,ge,we,Ie=se,je=0,pe=te[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(pe.lastIndex=0,H=H.slice(-1*L.length+se);(te=pe.exec(H))!=null;)if(ge=te[1]||te[2]||te[3]||te[4]||te[5]||te[6],!!ge){if(we=ge.length,te[3]||te[4]){Ie+=we;continue}else if((te[5]||te[6])&&se%3&&!((se+we)%3)){je+=we;continue}if(Ie-=we,!(Ie>0)){if(we=Math.min(we,we+Ie+je),Math.min(se,we)%2){var Pe=L.slice(1,se+te.index+we);return{type:"em",raw:L.slice(0,se+te.index+we+1),text:Pe,tokens:this.lexer.inlineTokens(Pe)}}var Ce=L.slice(2,se+te.index+we-1);return{type:"strong",raw:L.slice(0,se+te.index+we+1),text:Ce,tokens:this.lexer.inlineTokens(Ce)}}}}}},x.codespan=function(L){var H=this.rules.inline.code.exec(L);if(H){var K=H[2].replace(/\n/g," "),te=/[^ ]/.test(K),de=/^ /.test(K)&&/ $/.test(K);return te&&de&&(K=K.substring(1,K.length-1)),K=d(K,!0),{type:"codespan",raw:H[0],text:K}}},x.br=function(L){var H=this.rules.inline.br.exec(L);if(H)return{type:"br",raw:H[0]}},x.del=function(L){var H=this.rules.inline.del.exec(L);if(H)return{type:"del",raw:H[0],text:H[2],tokens:this.lexer.inlineTokens(H[2])}},x.autolink=function(L,H){var K=this.rules.inline.autolink.exec(L);if(K){var te,de;return K[2]==="@"?(te=d(this.options.mangle?H(K[1]):K[1]),de="mailto:"+te):(te=d(K[1]),de=te),{type:"link",raw:K[0],text:te,href:de,tokens:[{type:"text",raw:te,text:te}]}}},x.url=function(L,H){var K;if(K=this.rules.inline.url.exec(L)){var te,de;if(K[2]==="@")te=d(this.options.mangle?H(K[0]):K[0]),de="mailto:"+te;else{var se;do se=K[0],K[0]=this.rules.inline._backpedal.exec(K[0])[0];while(se!==K[0]);te=d(K[0]),K[1]==="www."?de="http://"+te:de=te}return{type:"link",raw:K[0],text:te,href:de,tokens:[{type:"text",raw:te,text:te}]}}},x.inlineText=function(L,H){var K=this.rules.inline.text.exec(L);if(K){var te;return this.lexer.state.inRawBlock?te=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(K[0]):d(K[0]):K[0]:te=d(this.options.smartypants?H(K[0]):K[0]),{type:"text",raw:K[0],text:te}}},Q}(),ae={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:i,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};ae._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,ae._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,ae.def=p(ae.def).replace("label",ae._label).replace("title",ae._title).getRegex(),ae.bullet=/(?:[*+-]|\d{1,9}[.)])/,ae.listItemStart=p(/^( *)(bull) */).replace("bull",ae.bullet).getRegex(),ae.list=p(ae.list).replace(/bull/g,ae.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+ae.def.source+")").getRegex(),ae._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",ae._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,ae.html=p(ae.html,"i").replace("comment",ae._comment).replace("tag",ae._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),ae.paragraph=p(ae._paragraph).replace("hr",ae.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ae._tag).getRegex(),ae.blockquote=p(ae.blockquote).replace("paragraph",ae.paragraph).getRegex(),ae.normal=v({},ae),ae.gfm=v({},ae.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),ae.gfm.table=p(ae.gfm.table).replace("hr",ae.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ae._tag).getRegex(),ae.gfm.paragraph=p(ae._paragraph).replace("hr",ae.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",ae.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ae._tag).getRegex(),ae.pedantic=v({},ae.normal,{html:p(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",ae._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:i,paragraph:p(ae.normal._paragraph).replace("hr",ae.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",ae.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ee={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:i,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:i,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};ee._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ee.punctuation=p(ee.punctuation).replace(/punctuation/g,ee._punctuation).getRegex(),ee.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,ee.escapedEmSt=/\\\*|\\_/g,ee._comment=p(ae._comment).replace("(?:-->|$)","-->").getRegex(),ee.emStrong.lDelim=p(ee.emStrong.lDelim).replace(/punct/g,ee._punctuation).getRegex(),ee.emStrong.rDelimAst=p(ee.emStrong.rDelimAst,"g").replace(/punct/g,ee._punctuation).getRegex(),ee.emStrong.rDelimUnd=p(ee.emStrong.rDelimUnd,"g").replace(/punct/g,ee._punctuation).getRegex(),ee._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ee._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ee._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ee.autolink=p(ee.autolink).replace("scheme",ee._scheme).replace("email",ee._email).getRegex(),ee._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ee.tag=p(ee.tag).replace("comment",ee._comment).replace("attribute",ee._attribute).getRegex(),ee._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ee._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,ee._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ee.link=p(ee.link).replace("label",ee._label).replace("href",ee._href).replace("title",ee._title).getRegex(),ee.reflink=p(ee.reflink).replace("label",ee._label).replace("ref",ae._label).getRegex(),ee.nolink=p(ee.nolink).replace("ref",ae._label).getRegex(),ee.reflinkSearch=p(ee.reflinkSearch,"g").replace("reflink",ee.reflink).replace("nolink",ee.nolink).getRegex(),ee.normal=v({},ee),ee.pedantic=v({},ee.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:p(/^!?\[(label)\]\((.*?)\)/).replace("label",ee._label).getRegex(),reflink:p(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ee._label).getRegex()}),ee.gfm=v({},ee.normal,{escape:p(ee.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),ee.gfm.url=p(ee.gfm.url,"i").replace("email",ee.gfm._extended_email).getRegex(),ee.breaks=v({},ee.gfm,{br:p(ee.br).replace("{2,}","*").getRegex(),text:p(ee.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function _(Q){return Q.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function z(Q){var x="",V,L,H=Q.length;for(V=0;V<H;V++)L=Q.charCodeAt(V),Math.random()>.5&&(L="x"+L.toString(16)),x+="&#"+L+";";return x}var T=function(){function Q(V){this.tokens=[],this.tokens.links=Object.create(null),this.options=V||ce.defaults,this.options.tokenizer=this.options.tokenizer||new he,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var L={block:ae.normal,inline:ee.normal};this.options.pedantic?(L.block=ae.pedantic,L.inline=ee.pedantic):this.options.gfm&&(L.block=ae.gfm,this.options.breaks?L.inline=ee.breaks:L.inline=ee.gfm),this.tokenizer.rules=L}Q.lex=function(L,H){var K=new Q(H);return K.lex(L)},Q.lexInline=function(L,H){var K=new Q(H);return K.inlineTokens(L)};var x=Q.prototype;return x.lex=function(L){L=L.replace(/\r\n|\r/g,`
`),this.blockTokens(L,this.tokens);for(var H;H=this.inlineQueue.shift();)this.inlineTokens(H.src,H.tokens);return this.tokens},x.blockTokens=function(L,H){var K=this;H===void 0&&(H=[]),this.options.pedantic?L=L.replace(/\t/g,"    ").replace(/^ +$/gm,""):L=L.replace(/^( *)(\t+)/gm,function(Ie,je,pe){return je+"    ".repeat(pe.length)});for(var te,de,se,ge;L;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Ie){return(te=Ie.call({lexer:K},L,H))?(L=L.substring(te.raw.length),H.push(te),!0):!1}))){if(te=this.tokenizer.space(L)){L=L.substring(te.raw.length),te.raw.length===1&&H.length>0?H[H.length-1].raw+=`
`:H.push(te);continue}if(te=this.tokenizer.code(L)){L=L.substring(te.raw.length),de=H[H.length-1],de&&(de.type==="paragraph"||de.type==="text")?(de.raw+=`
`+te.raw,de.text+=`
`+te.text,this.inlineQueue[this.inlineQueue.length-1].src=de.text):H.push(te);continue}if(te=this.tokenizer.fences(L)){L=L.substring(te.raw.length),H.push(te);continue}if(te=this.tokenizer.heading(L)){L=L.substring(te.raw.length),H.push(te);continue}if(te=this.tokenizer.hr(L)){L=L.substring(te.raw.length),H.push(te);continue}if(te=this.tokenizer.blockquote(L)){L=L.substring(te.raw.length),H.push(te);continue}if(te=this.tokenizer.list(L)){L=L.substring(te.raw.length),H.push(te);continue}if(te=this.tokenizer.html(L)){L=L.substring(te.raw.length),H.push(te);continue}if(te=this.tokenizer.def(L)){L=L.substring(te.raw.length),de=H[H.length-1],de&&(de.type==="paragraph"||de.type==="text")?(de.raw+=`
`+te.raw,de.text+=`
`+te.raw,this.inlineQueue[this.inlineQueue.length-1].src=de.text):this.tokens.links[te.tag]||(this.tokens.links[te.tag]={href:te.href,title:te.title});continue}if(te=this.tokenizer.table(L)){L=L.substring(te.raw.length),H.push(te);continue}if(te=this.tokenizer.lheading(L)){L=L.substring(te.raw.length),H.push(te);continue}if(se=L,this.options.extensions&&this.options.extensions.startBlock&&function(){var Ie=1/0,je=L.slice(1),pe=void 0;K.options.extensions.startBlock.forEach(function(Pe){pe=Pe.call({lexer:this},je),typeof pe=="number"&&pe>=0&&(Ie=Math.min(Ie,pe))}),Ie<1/0&&Ie>=0&&(se=L.substring(0,Ie+1))}(),this.state.top&&(te=this.tokenizer.paragraph(se))){de=H[H.length-1],ge&&de.type==="paragraph"?(de.raw+=`
`+te.raw,de.text+=`
`+te.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=de.text):H.push(te),ge=se.length!==L.length,L=L.substring(te.raw.length);continue}if(te=this.tokenizer.text(L)){L=L.substring(te.raw.length),de=H[H.length-1],de&&de.type==="text"?(de.raw+=`
`+te.raw,de.text+=`
`+te.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=de.text):H.push(te);continue}if(L){var we="Infinite loop on byte: "+L.charCodeAt(0);if(this.options.silent){console.error(we);break}else throw new Error(we)}}return this.state.top=!0,H},x.inline=function(L,H){return H===void 0&&(H=[]),this.inlineQueue.push({src:L,tokens:H}),H},x.inlineTokens=function(L,H){var K=this;H===void 0&&(H=[]);var te,de,se,ge=L,we,Ie,je;if(this.tokens.links){var pe=Object.keys(this.tokens.links);if(pe.length>0)for(;(we=this.tokenizer.rules.inline.reflinkSearch.exec(ge))!=null;)pe.includes(we[0].slice(we[0].lastIndexOf("[")+1,-1))&&(ge=ge.slice(0,we.index)+"["+I("a",we[0].length-2)+"]"+ge.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(we=this.tokenizer.rules.inline.blockSkip.exec(ge))!=null;)ge=ge.slice(0,we.index)+"["+I("a",we[0].length-2)+"]"+ge.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(we=this.tokenizer.rules.inline.escapedEmSt.exec(ge))!=null;)ge=ge.slice(0,we.index)+"++"+ge.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;L;)if(Ie||(je=""),Ie=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Ce){return(te=Ce.call({lexer:K},L,H))?(L=L.substring(te.raw.length),H.push(te),!0):!1}))){if(te=this.tokenizer.escape(L)){L=L.substring(te.raw.length),H.push(te);continue}if(te=this.tokenizer.tag(L)){L=L.substring(te.raw.length),de=H[H.length-1],de&&te.type==="text"&&de.type==="text"?(de.raw+=te.raw,de.text+=te.text):H.push(te);continue}if(te=this.tokenizer.link(L)){L=L.substring(te.raw.length),H.push(te);continue}if(te=this.tokenizer.reflink(L,this.tokens.links)){L=L.substring(te.raw.length),de=H[H.length-1],de&&te.type==="text"&&de.type==="text"?(de.raw+=te.raw,de.text+=te.text):H.push(te);continue}if(te=this.tokenizer.emStrong(L,ge,je)){L=L.substring(te.raw.length),H.push(te);continue}if(te=this.tokenizer.codespan(L)){L=L.substring(te.raw.length),H.push(te);continue}if(te=this.tokenizer.br(L)){L=L.substring(te.raw.length),H.push(te);continue}if(te=this.tokenizer.del(L)){L=L.substring(te.raw.length),H.push(te);continue}if(te=this.tokenizer.autolink(L,z)){L=L.substring(te.raw.length),H.push(te);continue}if(!this.state.inLink&&(te=this.tokenizer.url(L,z))){L=L.substring(te.raw.length),H.push(te);continue}if(se=L,this.options.extensions&&this.options.extensions.startInline&&function(){var Ce=1/0,Le=L.slice(1),Me=void 0;K.options.extensions.startInline.forEach(function(Ve){Me=Ve.call({lexer:this},Le),typeof Me=="number"&&Me>=0&&(Ce=Math.min(Ce,Me))}),Ce<1/0&&Ce>=0&&(se=L.substring(0,Ce+1))}(),te=this.tokenizer.inlineText(se,_)){L=L.substring(te.raw.length),te.raw.slice(-1)!=="_"&&(je=te.raw.slice(-1)),Ie=!0,de=H[H.length-1],de&&de.type==="text"?(de.raw+=te.raw,de.text+=te.text):H.push(te);continue}if(L){var Pe="Infinite loop on byte: "+L.charCodeAt(0);if(this.options.silent){console.error(Pe);break}else throw new Error(Pe)}}return H},n(Q,null,[{key:"rules",get:function(){return{block:ae,inline:ee}}}]),Q}(),J=function(){function Q(V){this.options=V||ce.defaults}var x=Q.prototype;return x.code=function(L,H,K){var te=(H||"").match(/\S*/)[0];if(this.options.highlight){var de=this.options.highlight(L,te);de!=null&&de!==L&&(K=!0,L=de)}return L=L.replace(/\n$/,"")+`
`,te?'<pre><code class="'+this.options.langPrefix+d(te,!0)+'">'+(K?L:d(L,!0))+`</code></pre>
`:"<pre><code>"+(K?L:d(L,!0))+`</code></pre>
`},x.blockquote=function(L){return`<blockquote>
`+L+`</blockquote>
`},x.html=function(L){return L},x.heading=function(L,H,K,te){if(this.options.headerIds){var de=this.options.headerPrefix+te.slug(K);return"<h"+H+' id="'+de+'">'+L+"</h"+H+`>
`}return"<h"+H+">"+L+"</h"+H+`>
`},x.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},x.list=function(L,H,K){var te=H?"ol":"ul",de=H&&K!==1?' start="'+K+'"':"";return"<"+te+de+`>
`+L+"</"+te+`>
`},x.listitem=function(L){return"<li>"+L+`</li>
`},x.checkbox=function(L){return"<input "+(L?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},x.paragraph=function(L){return"<p>"+L+`</p>
`},x.table=function(L,H){return H&&(H="<tbody>"+H+"</tbody>"),`<table>
<thead>
`+L+`</thead>
`+H+`</table>
`},x.tablerow=function(L){return`<tr>
`+L+`</tr>
`},x.tablecell=function(L,H){var K=H.header?"th":"td",te=H.align?"<"+K+' align="'+H.align+'">':"<"+K+">";return te+L+("</"+K+`>
`)},x.strong=function(L){return"<strong>"+L+"</strong>"},x.em=function(L){return"<em>"+L+"</em>"},x.codespan=function(L){return"<code>"+L+"</code>"},x.br=function(){return this.options.xhtml?"<br/>":"<br>"},x.del=function(L){return"<del>"+L+"</del>"},x.link=function(L,H,K){if(L=l(this.options.sanitize,this.options.baseUrl,L),L===null)return K;var te='<a href="'+d(L)+'"';return H&&(te+=' title="'+H+'"'),te+=">"+K+"</a>",te},x.image=function(L,H,K){if(L=l(this.options.sanitize,this.options.baseUrl,L),L===null)return K;var te='<img src="'+L+'" alt="'+K+'"';return H&&(te+=' title="'+H+'"'),te+=this.options.xhtml?"/>":">",te},x.text=function(L){return L},Q}(),Y=function(){function Q(){}var x=Q.prototype;return x.strong=function(L){return L},x.em=function(L){return L},x.codespan=function(L){return L},x.del=function(L){return L},x.html=function(L){return L},x.text=function(L){return L},x.link=function(L,H,K){return""+K},x.image=function(L,H,K){return""+K},x.br=function(){return""},Q}(),W=function(){function Q(){this.seen={}}var x=Q.prototype;return x.serialize=function(L){return L.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},x.getNextSafeSlug=function(L,H){var K=L,te=0;if(this.seen.hasOwnProperty(K)){te=this.seen[L];do te++,K=L+"-"+te;while(this.seen.hasOwnProperty(K))}return H||(this.seen[L]=te,this.seen[K]=0),K},x.slug=function(L,H){H===void 0&&(H={});var K=this.serialize(L);return this.getNextSafeSlug(K,H.dryrun)},Q}(),re=function(){function Q(V){this.options=V||ce.defaults,this.options.renderer=this.options.renderer||new J,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Y,this.slugger=new W}Q.parse=function(L,H){var K=new Q(H);return K.parse(L)},Q.parseInline=function(L,H){var K=new Q(H);return K.parseInline(L)};var x=Q.prototype;return x.parse=function(L,H){H===void 0&&(H=!0);var K="",te,de,se,ge,we,Ie,je,pe,Pe,Ce,Le,Me,Ve,qe,xe,_e,Ke,nt,Ye,Qe=L.length;for(te=0;te<Qe;te++){if(Ce=L[te],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ce.type]&&(Ye=this.options.extensions.renderers[Ce.type].call({parser:this},Ce),Ye!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Ce.type))){K+=Ye||"";continue}switch(Ce.type){case"space":continue;case"hr":{K+=this.renderer.hr();continue}case"heading":{K+=this.renderer.heading(this.parseInline(Ce.tokens),Ce.depth,m(this.parseInline(Ce.tokens,this.textRenderer)),this.slugger);continue}case"code":{K+=this.renderer.code(Ce.text,Ce.lang,Ce.escaped);continue}case"table":{for(pe="",je="",ge=Ce.header.length,de=0;de<ge;de++)je+=this.renderer.tablecell(this.parseInline(Ce.header[de].tokens),{header:!0,align:Ce.align[de]});for(pe+=this.renderer.tablerow(je),Pe="",ge=Ce.rows.length,de=0;de<ge;de++){for(Ie=Ce.rows[de],je="",we=Ie.length,se=0;se<we;se++)je+=this.renderer.tablecell(this.parseInline(Ie[se].tokens),{header:!1,align:Ce.align[se]});Pe+=this.renderer.tablerow(je)}K+=this.renderer.table(pe,Pe);continue}case"blockquote":{Pe=this.parse(Ce.tokens),K+=this.renderer.blockquote(Pe);continue}case"list":{for(Le=Ce.ordered,Me=Ce.start,Ve=Ce.loose,ge=Ce.items.length,Pe="",de=0;de<ge;de++)xe=Ce.items[de],_e=xe.checked,Ke=xe.task,qe="",xe.task&&(nt=this.renderer.checkbox(_e),Ve?xe.tokens.length>0&&xe.tokens[0].type==="paragraph"?(xe.tokens[0].text=nt+" "+xe.tokens[0].text,xe.tokens[0].tokens&&xe.tokens[0].tokens.length>0&&xe.tokens[0].tokens[0].type==="text"&&(xe.tokens[0].tokens[0].text=nt+" "+xe.tokens[0].tokens[0].text)):xe.tokens.unshift({type:"text",text:nt}):qe+=nt),qe+=this.parse(xe.tokens,Ve),Pe+=this.renderer.listitem(qe,Ke,_e);K+=this.renderer.list(Pe,Le,Me);continue}case"html":{K+=this.renderer.html(Ce.text);continue}case"paragraph":{K+=this.renderer.paragraph(this.parseInline(Ce.tokens));continue}case"text":{for(Pe=Ce.tokens?this.parseInline(Ce.tokens):Ce.text;te+1<Qe&&L[te+1].type==="text";)Ce=L[++te],Pe+=`
`+(Ce.tokens?this.parseInline(Ce.tokens):Ce.text);K+=H?this.renderer.paragraph(Pe):Pe;continue}default:{var me='Token with "'+Ce.type+'" type was not found.';if(this.options.silent){console.error(me);return}else throw new Error(me)}}}return K},x.parseInline=function(L,H){H=H||this.renderer;var K="",te,de,se,ge=L.length;for(te=0;te<ge;te++){if(de=L[te],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[de.type]&&(se=this.options.extensions.renderers[de.type].call({parser:this},de),se!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(de.type))){K+=se||"";continue}switch(de.type){case"escape":{K+=H.text(de.text);break}case"html":{K+=H.html(de.text);break}case"link":{K+=H.link(de.href,de.title,this.parseInline(de.tokens,H));break}case"image":{K+=H.image(de.href,de.title,de.text);break}case"strong":{K+=H.strong(this.parseInline(de.tokens,H));break}case"em":{K+=H.em(this.parseInline(de.tokens,H));break}case"codespan":{K+=H.codespan(de.text);break}case"br":{K+=H.br();break}case"del":{K+=H.del(this.parseInline(de.tokens,H));break}case"text":{K+=H.text(de.text);break}default:{var we='Token with "'+de.type+'" type was not found.';if(this.options.silent){console.error(we);return}else throw new Error(we)}}}return K},Q}();function ue(Q,x,V){if(typeof Q>"u"||Q===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Q!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Q)+", string expected");if(typeof x=="function"&&(V=x,x=null),x=v({},ue.defaults,x||{}),j(x),V){var L=x.highlight,H;try{H=T.lex(Q,x)}catch(ge){return V(ge)}var K=function(we){var Ie;if(!we)try{x.walkTokens&&ue.walkTokens(H,x.walkTokens),Ie=re.parse(H,x)}catch(je){we=je}return x.highlight=L,we?V(we):V(null,Ie)};if(!L||L.length<3||(delete x.highlight,!H.length))return K();var te=0;ue.walkTokens(H,function(ge){ge.type==="code"&&(te++,setTimeout(function(){L(ge.text,ge.lang,function(we,Ie){if(we)return K(we);Ie!=null&&Ie!==ge.text&&(ge.text=Ie,ge.escaped=!0),te--,te===0&&K()})},0))}),te===0&&K();return}function de(ge){if(ge.message+=`
Please report this to https://github.com/markedjs/marked.`,x.silent)return"<p>An error occurred:</p><pre>"+d(ge.message+"",!0)+"</pre>";throw ge}try{var se=T.lex(Q,x);if(x.walkTokens){if(x.async)return Promise.all(ue.walkTokens(se,x.walkTokens)).then(function(){return re.parse(se,x)}).catch(de);ue.walkTokens(se,x.walkTokens)}return re.parse(se,x)}catch(ge){de(ge)}}ue.options=ue.setOptions=function(Q){return v(ue.defaults,Q),k(ue.defaults),ue},ue.getDefaults=C,ue.defaults=ce.defaults,ue.use=function(){for(var Q=arguments.length,x=new Array(Q),V=0;V<Q;V++)x[V]=arguments[V];var L=v.apply(void 0,[{}].concat(x)),H=ue.defaults.extensions||{renderers:{},childTokens:{}},K;x.forEach(function(te){if(te.extensions&&(K=!0,te.extensions.forEach(function(se){if(!se.name)throw new Error("extension name required");if(se.renderer){var ge=H.renderers?H.renderers[se.name]:null;ge?H.renderers[se.name]=function(){for(var we=arguments.length,Ie=new Array(we),je=0;je<we;je++)Ie[je]=arguments[je];var pe=se.renderer.apply(this,Ie);return pe===!1&&(pe=ge.apply(this,Ie)),pe}:H.renderers[se.name]=se.renderer}if(se.tokenizer){if(!se.level||se.level!=="block"&&se.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");H[se.level]?H[se.level].unshift(se.tokenizer):H[se.level]=[se.tokenizer],se.start&&(se.level==="block"?H.startBlock?H.startBlock.push(se.start):H.startBlock=[se.start]:se.level==="inline"&&(H.startInline?H.startInline.push(se.start):H.startInline=[se.start]))}se.childTokens&&(H.childTokens[se.name]=se.childTokens)})),te.renderer&&function(){var se=ue.defaults.renderer||new J,ge=function(je){var pe=se[je];se[je]=function(){for(var Pe=arguments.length,Ce=new Array(Pe),Le=0;Le<Pe;Le++)Ce[Le]=arguments[Le];var Me=te.renderer[je].apply(se,Ce);return Me===!1&&(Me=pe.apply(se,Ce)),Me}};for(var we in te.renderer)ge(we);L.renderer=se}(),te.tokenizer&&function(){var se=ue.defaults.tokenizer||new he,ge=function(je){var pe=se[je];se[je]=function(){for(var Pe=arguments.length,Ce=new Array(Pe),Le=0;Le<Pe;Le++)Ce[Le]=arguments[Le];var Me=te.tokenizer[je].apply(se,Ce);return Me===!1&&(Me=pe.apply(se,Ce)),Me}};for(var we in te.tokenizer)ge(we);L.tokenizer=se}(),te.walkTokens){var de=ue.defaults.walkTokens;L.walkTokens=function(se){var ge=[];return ge.push(te.walkTokens.call(this,se)),de&&(ge=ge.concat(de.call(this,se))),ge}}K&&(L.extensions=H),ue.setOptions(L)})},ue.walkTokens=function(Q,x){for(var V=[],L=function(){var de=K.value;switch(V=V.concat(x.call(ue,de)),de.type){case"table":{for(var se=D(de.header),ge;!(ge=se()).done;){var we=ge.value;V=V.concat(ue.walkTokens(we.tokens,x))}for(var Ie=D(de.rows),je;!(je=Ie()).done;)for(var pe=je.value,Pe=D(pe),Ce;!(Ce=Pe()).done;){var Le=Ce.value;V=V.concat(ue.walkTokens(Le.tokens,x))}break}case"list":{V=V.concat(ue.walkTokens(de.items,x));break}default:ue.defaults.extensions&&ue.defaults.extensions.childTokens&&ue.defaults.extensions.childTokens[de.type]?ue.defaults.extensions.childTokens[de.type].forEach(function(Me){V=V.concat(ue.walkTokens(de[Me],x))}):de.tokens&&(V=V.concat(ue.walkTokens(de.tokens,x)))}},H=D(Q),K;!(K=H()).done;)L();return V},ue.parseInline=function(Q,x){if(typeof Q>"u"||Q===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Q!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Q)+", string expected");x=v({},ue.defaults,x||{}),j(x);try{var V=T.lexInline(Q,x);return x.walkTokens&&ue.walkTokens(V,x.walkTokens),re.parseInline(V,x)}catch(L){if(L.message+=`
Please report this to https://github.com/markedjs/marked.`,x.silent)return"<p>An error occurred:</p><pre>"+d(L.message+"",!0)+"</pre>";throw L}},ue.Parser=re,ue.parser=re.parse,ue.Renderer=J,ue.TextRenderer=Y,ue.Lexer=T,ue.lexer=T.lex,ue.Tokenizer=he,ue.Slugger=W,ue.parse=ue;var ie=ue.options,$e=ue.setOptions,ne=ue.use,U=ue.walkTokens,R=ue.parseInline,q=ue,X=re.parse,le=T.lex;ce.Lexer=T,ce.Parser=re,ce.Renderer=J,ce.Slugger=W,ce.TextRenderer=Y,ce.Tokenizer=he,ce.getDefaults=C,ce.lexer=le,ce.marked=ue,ce.options=ie,ce.parse=q,ce.parseInline=R,ce.parser=X,ce.setOptions=$e,ce.use=ne,ce.walkTokens=U,Object.defineProperty(ce,"__esModule",{value:!0})}),define(Ee[149],ke([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hk=n;function n(c){const m=D(c);if(m&&m.length>0)return new Uint32Array(m)}let A=0;const P=new Uint32Array(10);function D(c){if(A=0,C(c,y,4352),A>0||(C(c,w,4449),A>0)||(C(c,g,4520),A>0)||(C(c,d,12593),A))return P.subarray(0,A);if(c>=44032&&c<=55203){const m=c-44032,u=m%588,p=Math.floor(m/588),h=Math.floor(u/28),f=u%28-1;if(p<y.length?C(p,y,0):4352+p-12593<d.length&&C(4352+p,d,12593),h<w.length?C(h,w,0):4449+h-12593<d.length&&C(4449+h-12593,d,12593),f>=0&&(f<g.length?C(f,g,0):4520+f-12593<d.length&&C(4520+f-12593,d,12593)),A>0)return P.subarray(0,A)}}function C(c,m,u){c>=u&&c<u+m.length&&k(m[c-u])}function k(c){c!==0&&(P[A++]=c&255,c>>8&&(P[A++]=c>>8&255),c>>16&&(P[A++]=c>>16&255))}var b;(function(c){c[c.InitialConsonant=4352]="InitialConsonant",c[c.Vowel=4449]="Vowel",c[c.FinalConsonant=4520]="FinalConsonant",c[c.CompatibilityJamo=12593]="CompatibilityJamo"})(b||(b={}));var $;(function(c){c[c.NUL=0]="NUL",c[c.A=65]="A",c[c.B=66]="B",c[c.C=67]="C",c[c.D=68]="D",c[c.E=69]="E",c[c.F=70]="F",c[c.G=71]="G",c[c.H=72]="H",c[c.I=73]="I",c[c.J=74]="J",c[c.K=75]="K",c[c.L=76]="L",c[c.M=77]="M",c[c.N=78]="N",c[c.O=79]="O",c[c.P=80]="P",c[c.Q=81]="Q",c[c.R=82]="R",c[c.S=83]="S",c[c.T=84]="T",c[c.U=85]="U",c[c.V=86]="V",c[c.W=87]="W",c[c.X=88]="X",c[c.Y=89]="Y",c[c.Z=90]="Z",c[c.a=97]="a",c[c.b=98]="b",c[c.c=99]="c",c[c.d=100]="d",c[c.e=101]="e",c[c.f=102]="f",c[c.g=103]="g",c[c.h=104]="h",c[c.i=105]="i",c[c.j=106]="j",c[c.k=107]="k",c[c.l=108]="l",c[c.m=109]="m",c[c.n=110]="n",c[c.o=111]="o",c[c.p=112]="p",c[c.q=113]="q",c[c.r=114]="r",c[c.s=115]="s",c[c.t=116]="t",c[c.u=117]="u",c[c.v=118]="v",c[c.w=119]="w",c[c.x=120]="x",c[c.y=121]="y",c[c.z=122]="z"})($||($={}));var E;(function(c){c[c.fa=24934]="fa",c[c.fg=26470]="fg",c[c.fq=29030]="fq",c[c.fr=29286]="fr",c[c.ft=29798]="ft",c[c.fv=30310]="fv",c[c.fx=30822]="fx",c[c.hk=27496]="hk",c[c.hl=27752]="hl",c[c.ho=28520]="ho",c[c.ml=27757]="ml",c[c.nj=27246]="nj",c[c.nl=27758]="nl",c[c.np=28782]="np",c[c.qt=29809]="qt",c[c.rt=29810]="rt",c[c.sg=26483]="sg",c[c.sw=30579]="sw"})(E||(E={}));const y=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),w=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),g=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),d=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(Ee[99],ke([1,0,24]),function(ce,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3l=void 0,e.$1l=P,e.$2l=C;const A=new n.$Ec(1e4);function P($){return b($,"NFC",A)}const D=new n.$Ec(1e4);function C($){return b($,"NFD",D)}const k=/[^\u0000-\u0080]/;function b($,E,y){if(!$)return $;const w=y.get($);if(w)return w;let g;return k.test($)?g=$.normalize(E):g=$,y.set($,g),g}e.$3l=function(){const $=/[\u0300-\u036f]/g;return function(E){return C(E).replace($,"")}}()}),define(Ee[150],ke([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=e.$rm=e.$qm=void 0,e.$om=n,e.rot=A;function n(k,b,$){return Math.min(Math.max(k,b),$)}function A(k,b){return(b+k%b)%b}class P{constructor(){this.a=0}getNext(){return this.a++}}e.$qm=P;class D{constructor(){this.a=1,this.b=0}update(b){return this.b=this.b+(b-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$rm=D;class C{constructor(b){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(b),this.c.fill(0,0,b)}update(b){const $=this.c[this.d];return this.c[this.d]=b,this.d=(this.d+1)%this.c.length,this.e-=$,this.e+=b,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$sm=C}),function(){function ce(P){const D=[];typeof P=="number"&&D.push("code/timeOrigin",P);function C(b){D.push(b,Date.now())}function k(){const b=[];for(let $=0;$<D.length;$+=2)b.push({name:D[$],startTime:D[$+1]});return b}return{mark:C,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ce():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const D=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const C of performance.getEntriesByType("mark"))D.push({name:C.name,startTime:Math.round(P+C.startTime)});return D}};if(typeof process=="object"){const P=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ce(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),ce()}function n(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=e()),P.MonacoPerformanceMarks}var A;typeof global=="object"?A=global:typeof self=="object"?A=self:A={},typeof define=="function"?define("vs/base/common/performance",[],function(){return n(A)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=n(A):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),A.perf=n(A))}(),define(Ee[4],ke([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C=e.$B=e.$A=e.$z=e.$y=e.OS=e.OperatingSystem=e.$v=e.$u=e.$t=e.$s=e.$r=e.Language=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.$g=e.$f=e.$e=e.$d=e.$c=e.Platform=e.$a=void 0,e.$b=t,e.$x=v,e.$D=S,e.$a="en";let n=!1,A=!1,P=!1,D=!1,C=!1,k=!1,b=!1,$=!1,E=!1,y=!1,w,g=e.$a,d=e.$a,c,m;const u=globalThis;let p;typeof u.vscode<"u"&&typeof u.vscode.process<"u"?p=u.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(p=process);const h=typeof p?.versions?.electron=="string",f=h&&p?.type==="renderer";if(typeof p=="object"){n=p.platform==="win32",A=p.platform==="darwin",P=p.platform==="linux",D=P&&!!p.env.SNAP&&!!p.env.SNAP_REVISION,b=h,E=!!p.env.CI||!!p.env.BUILD_ARTIFACTSTAGINGDIRECTORY,w=e.$a,g=e.$a;const O=p.env.VSCODE_NLS_CONFIG;if(O)try{const N=JSON.parse(O),j=N.availableLanguages["*"];w=N.locale,d=N.osLocale,g=j||e.$a,c=N._translationsConfigFile}catch{}C=!0}else if(typeof navigator=="object"&&!f){m=navigator.userAgent,n=m.indexOf("Windows")>=0,A=m.indexOf("Macintosh")>=0,$=(m.indexOf("Macintosh")>=0||m.indexOf("iPad")>=0||m.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,P=m.indexOf("Linux")>=0,y=m?.indexOf("Mobi")>=0,k=!0,w=e.$a,g=w,d=navigator.language;const O=typeof document<"u"&&document.getElementById("vscode-remote-nls-configuration"),N=O&&O.getAttribute("data-settings");if(N)try{const j=JSON.parse(N),I=j.availableLanguages["*"];w=j.locale,d=j.osLocale,g=I||e.$a,c=j._translationsConfigFile}catch{}}else console.error("Unable to resolve platform.");var l;(function(O){O[O.Web=0]="Web",O[O.Mac=1]="Mac",O[O.Linux=2]="Linux",O[O.Windows=3]="Windows"})(l||(e.Platform=l={}));function t(O){switch(O){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let a=0;A?a=1:n?a=3:P&&(a=2),e.$c=n,e.$d=A,e.$e=P,e.$f=D,e.$g=C,e.$h=b,e.$i=k,e.$j=k&&typeof u.importScripts=="function",e.$k=e.$j?u.origin:void 0,e.$l=$,e.$m=y,e.$n=E,e.$o=a,e.$p=m,e.$q=g;var o;(function(O){function N(){return e.$q}O.value=N;function j(){return e.$q.length===2?e.$q==="en":e.$q.length>=3?e.$q[0]==="e"&&e.$q[1]==="n"&&e.$q[2]==="-":!1}O.isDefaultVariant=j;function I(){return e.$q==="en"}O.isDefault=I})(o||(e.Language=o={})),e.$r=w,e.$s=d,e.$t=c,e.$u=typeof u.postMessage=="function"&&!u.importScripts,e.$v=(()=>{if(e.$u){const O=[];u.addEventListener("message",j=>{if(j.data&&j.data.vscodeScheduleAsyncWork)for(let I=0,B=O.length;I<B;I++){const Z=O[I];if(Z.id===j.data.vscodeScheduleAsyncWork){O.splice(I,1),Z.callback();return}}});let N=0;return j=>{const I=++N;O.push({id:I,callback:j}),u.postMessage({vscodeScheduleAsyncWork:I},"*")}}return O=>setTimeout(O)})();var r;(function(O){O[O.Windows=1]="Windows",O[O.Macintosh=2]="Macintosh",O[O.Linux=3]="Linux"})(r||(e.OperatingSystem=r={})),e.OS=A||$?2:n?1:3;let s=!0,i=!1;function v(){if(!i){i=!0;const O=new Uint8Array(2);O[0]=1,O[1]=2,s=new Uint16Array(O.buffer)[0]===513}return s}e.$y=!!(e.$p&&e.$p.indexOf("Chrome")>=0),e.$z=!!(e.$p&&e.$p.indexOf("Firefox")>=0),e.$A=!!(!e.$y&&e.$p&&e.$p.indexOf("Safari")>=0),e.$B=!!(e.$p&&e.$p.indexOf("Edg/")>=0),e.$C=!!(e.$p&&e.$p.indexOf("Android")>=0);function S(O){return parseFloat(O)>=20}}),define(Ee[151],ke([1,0,41]),function(ce,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DO=void 0;const A=Symbol("unset");class P{constructor(){this.a=new C,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||n.Iterable.empty()}insert(b,$,E){this.d(b,y=>y._value=$,E)}mutate(b,$){this.d(b,E=>E._value=$(E._value===A?void 0:E._value))}delete(b){const $=this.c(b);if(!$)return;let E=$.length-1;const y=$[E].node._value;if(y!==A){for(this.b--,$[E].node._value=A;E>0;E--){const{node:w,part:g}=$[E];if(w.children?.size||w._value!==A)break;$[E-1].node.children.delete(g)}return y}}*deleteRecursive(b){const $=this.c(b);if(!$)return;const E=$[$.length-1].node;for(let y=$.length-1;y>0;y--){const w=$[y-1];if(w.node.children.delete($[y].part),w.node.children.size>0||w.node._value!==A)break}for(const y of D(E))y._value!==A&&(this.b--,yield y._value)}find(b){let $=this.a;for(const E of b){const y=$.children?.get(E);if(!y)return;$=y}return $._value===A?void 0:$._value}hasKeyOrParent(b){let $=this.a;for(const E of b){const y=$.children?.get(E);if(!y)return!1;if(y._value!==A)return!0;$=y}return!1}hasKeyOrChildren(b){let $=this.a;for(const E of b){const y=$.children?.get(E);if(!y)return!1;$=y}return!0}hasKey(b){let $=this.a;for(const E of b){const y=$.children?.get(E);if(!y)return!1;$=y}return $._value!==A}c(b){const $=[{part:"",node:this.a}];let E=0;for(const y of b){const w=$[E].node.children?.get(y);if(!w)return;$.push({part:y,node:w}),E++}return $}d(b,$,E){let y=this.a;for(const d of b){if(y.children)if(y.children.has(d))y=y.children.get(d);else{const c=new C;y.children.set(d,c),y=c}else{const c=new C;y.children=new Map([[d,c]]),y=c}E?.(y)}const w=y._value===A?0:1;$(y);const g=y._value===A?0:1;this.b+=g-w}*values(){for(const{_value:b}of D(this.a))b!==A&&(yield b)}}e.$DO=P;function*D(k){const b=[k];for(;b.length>0;){const $=b.pop();if(yield $,$.children)for(const E of $.children.values())b.push(E)}}class C{constructor(){this._value=A}get value(){return this._value===A?void 0:this._value}set value(b){this._value=b===void 0?A:b}}}),define(Ee[30],ke([1,0,4]),function(ce,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fc=e.$ec=e.env=e.cwd=void 0;let A;const P=globalThis.vscode;if(typeof P<"u"&&typeof P.process<"u"){const D=P.process;A={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()}}}else typeof process<"u"?A={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:A={get platform(){return n.$c?"win32":n.$d?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=A.cwd,e.env=A.env,e.$ec=A.platform,e.$fc=A.arch}),define(Ee[7],ke([1,0,30]),function(ce,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uc=e.sep=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=void 0;const A=65,P=97,D=90,C=122,k=46,b=47,$=92,E=58,y=63;class w extends Error{constructor(a,o,r){let s;typeof o=="string"&&o.indexOf("not ")===0?(s="must not be",o=o.replace(/^not /,"")):s="must be";const i=a.indexOf(".")!==-1?"property":"argument";let v=`The "${a}" ${i} ${s} of type ${o}`;v+=`. Received type ${typeof r}`,super(v),this.code="ERR_INVALID_ARG_TYPE"}}function g(t,a){if(t===null||typeof t!="object")throw new w(a,"Object",t)}function d(t,a){if(typeof t!="string")throw new w(a,"string",t)}const c=n.$ec==="win32";function m(t){return t===b||t===$}function u(t){return t===b}function p(t){return t>=A&&t<=D||t>=P&&t<=C}function h(t,a,o,r){let s="",i=0,v=-1,S=0,O=0;for(let N=0;N<=t.length;++N){if(N<t.length)O=t.charCodeAt(N);else{if(r(O))break;O=b}if(r(O)){if(!(v===N-1||S===1))if(S===2){if(s.length<2||i!==2||s.charCodeAt(s.length-1)!==k||s.charCodeAt(s.length-2)!==k){if(s.length>2){const j=s.lastIndexOf(o);j===-1?(s="",i=0):(s=s.slice(0,j),i=s.length-1-s.lastIndexOf(o)),v=N,S=0;continue}else if(s.length!==0){s="",i=0,v=N,S=0;continue}}a&&(s+=s.length>0?`${o}..`:"..",i=2)}else s.length>0?s+=`${o}${t.slice(v+1,N)}`:s=t.slice(v+1,N),i=N-v-1;v=N,S=0}else O===k&&S!==-1?++S:S=-1}return s}function f(t,a){g(a,"pathObject");const o=a.dir||a.root,r=a.base||`${a.name||""}${a.ext||""}`;return o?o===a.root?`${o}${r}`:`${o}${t}${r}`:r}e.$gc={resolve(...t){let a="",o="",r=!1;for(let s=t.length-1;s>=-1;s--){let i;if(s>=0){if(i=t[s],d(i,"path"),i.length===0)continue}else a.length===0?i=n.cwd():(i=n.env[`=${a}`]||n.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==a.toLowerCase()&&i.charCodeAt(2)===$)&&(i=`${a}\\`));const v=i.length;let S=0,O="",N=!1;const j=i.charCodeAt(0);if(v===1)m(j)&&(S=1,N=!0);else if(m(j))if(N=!0,m(i.charCodeAt(1))){let I=2,B=I;for(;I<v&&!m(i.charCodeAt(I));)I++;if(I<v&&I!==B){const Z=i.slice(B,I);for(B=I;I<v&&m(i.charCodeAt(I));)I++;if(I<v&&I!==B){for(B=I;I<v&&!m(i.charCodeAt(I));)I++;(I===v||I!==B)&&(O=`\\\\${Z}\\${i.slice(B,I)}`,S=I)}}}else S=1;else p(j)&&i.charCodeAt(1)===E&&(O=i.slice(0,2),S=2,v>2&&m(i.charCodeAt(2))&&(N=!0,S=3));if(O.length>0)if(a.length>0){if(O.toLowerCase()!==a.toLowerCase())continue}else a=O;if(r){if(a.length>0)break}else if(o=`${i.slice(S)}\\${o}`,r=N,N&&a.length>0)break}return o=h(o,!r,"\\",m),r?`${a}\\${o}`:`${a}${o}`||"."},normalize(t){d(t,"path");const a=t.length;if(a===0)return".";let o=0,r,s=!1;const i=t.charCodeAt(0);if(a===1)return u(i)?"\\":t;if(m(i))if(s=!0,m(t.charCodeAt(1))){let S=2,O=S;for(;S<a&&!m(t.charCodeAt(S));)S++;if(S<a&&S!==O){const N=t.slice(O,S);for(O=S;S<a&&m(t.charCodeAt(S));)S++;if(S<a&&S!==O){for(O=S;S<a&&!m(t.charCodeAt(S));)S++;if(S===a)return`\\\\${N}\\${t.slice(O)}\\`;S!==O&&(r=`\\\\${N}\\${t.slice(O,S)}`,o=S)}}}else o=1;else p(i)&&t.charCodeAt(1)===E&&(r=t.slice(0,2),o=2,a>2&&m(t.charCodeAt(2))&&(s=!0,o=3));let v=o<a?h(t.slice(o),!s,"\\",m):"";return v.length===0&&!s&&(v="."),v.length>0&&m(t.charCodeAt(a-1))&&(v+="\\"),r===void 0?s?`\\${v}`:v:s?`${r}\\${v}`:`${r}${v}`},isAbsolute(t){d(t,"path");const a=t.length;if(a===0)return!1;const o=t.charCodeAt(0);return m(o)||a>2&&p(o)&&t.charCodeAt(1)===E&&m(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let a,o;for(let i=0;i<t.length;++i){const v=t[i];d(v,"path"),v.length>0&&(a===void 0?a=o=v:a+=`\\${v}`)}if(a===void 0)return".";let r=!0,s=0;if(typeof o=="string"&&m(o.charCodeAt(0))){++s;const i=o.length;i>1&&m(o.charCodeAt(1))&&(++s,i>2&&(m(o.charCodeAt(2))?++s:r=!1))}if(r){for(;s<a.length&&m(a.charCodeAt(s));)s++;s>=2&&(a=`\\${a.slice(s)}`)}return e.$gc.normalize(a)},relative(t,a){if(d(t,"from"),d(a,"to"),t===a)return"";const o=e.$gc.resolve(t),r=e.$gc.resolve(a);if(o===r||(t=o.toLowerCase(),a=r.toLowerCase(),t===a))return"";let s=0;for(;s<t.length&&t.charCodeAt(s)===$;)s++;let i=t.length;for(;i-1>s&&t.charCodeAt(i-1)===$;)i--;const v=i-s;let S=0;for(;S<a.length&&a.charCodeAt(S)===$;)S++;let O=a.length;for(;O-1>S&&a.charCodeAt(O-1)===$;)O--;const N=O-S,j=v<N?v:N;let I=-1,B=0;for(;B<j;B++){const he=t.charCodeAt(s+B);if(he!==a.charCodeAt(S+B))break;he===$&&(I=B)}if(B!==j){if(I===-1)return r}else{if(N>j){if(a.charCodeAt(S+B)===$)return r.slice(S+B+1);if(B===2)return r.slice(S+B)}v>j&&(t.charCodeAt(s+B)===$?I=B:B===2&&(I=3)),I===-1&&(I=0)}let Z="";for(B=s+I+1;B<=i;++B)(B===i||t.charCodeAt(B)===$)&&(Z+=Z.length===0?"..":"\\..");return S+=I,Z.length>0?`${Z}${r.slice(S,O)}`:(r.charCodeAt(S)===$&&++S,r.slice(S,O))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const a=e.$gc.resolve(t);if(a.length<=2)return t;if(a.charCodeAt(0)===$){if(a.charCodeAt(1)===$){const o=a.charCodeAt(2);if(o!==y&&o!==k)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(p(a.charCodeAt(0))&&a.charCodeAt(1)===E&&a.charCodeAt(2)===$)return`\\\\?\\${a}`;return t},dirname(t){d(t,"path");const a=t.length;if(a===0)return".";let o=-1,r=0;const s=t.charCodeAt(0);if(a===1)return m(s)?t:".";if(m(s)){if(o=r=1,m(t.charCodeAt(1))){let S=2,O=S;for(;S<a&&!m(t.charCodeAt(S));)S++;if(S<a&&S!==O){for(O=S;S<a&&m(t.charCodeAt(S));)S++;if(S<a&&S!==O){for(O=S;S<a&&!m(t.charCodeAt(S));)S++;if(S===a)return t;S!==O&&(o=r=S+1)}}}}else p(s)&&t.charCodeAt(1)===E&&(o=a>2&&m(t.charCodeAt(2))?3:2,r=o);let i=-1,v=!0;for(let S=a-1;S>=r;--S)if(m(t.charCodeAt(S))){if(!v){i=S;break}}else v=!1;if(i===-1){if(o===-1)return".";i=o}return t.slice(0,i)},basename(t,a){a!==void 0&&d(a,"ext"),d(t,"path");let o=0,r=-1,s=!0,i;if(t.length>=2&&p(t.charCodeAt(0))&&t.charCodeAt(1)===E&&(o=2),a!==void 0&&a.length>0&&a.length<=t.length){if(a===t)return"";let v=a.length-1,S=-1;for(i=t.length-1;i>=o;--i){const O=t.charCodeAt(i);if(m(O)){if(!s){o=i+1;break}}else S===-1&&(s=!1,S=i+1),v>=0&&(O===a.charCodeAt(v)?--v===-1&&(r=i):(v=-1,r=S))}return o===r?r=S:r===-1&&(r=t.length),t.slice(o,r)}for(i=t.length-1;i>=o;--i)if(m(t.charCodeAt(i))){if(!s){o=i+1;break}}else r===-1&&(s=!1,r=i+1);return r===-1?"":t.slice(o,r)},extname(t){d(t,"path");let a=0,o=-1,r=0,s=-1,i=!0,v=0;t.length>=2&&t.charCodeAt(1)===E&&p(t.charCodeAt(0))&&(a=r=2);for(let S=t.length-1;S>=a;--S){const O=t.charCodeAt(S);if(m(O)){if(!i){r=S+1;break}continue}s===-1&&(i=!1,s=S+1),O===k?o===-1?o=S:v!==1&&(v=1):o!==-1&&(v=-1)}return o===-1||s===-1||v===0||v===1&&o===s-1&&o===r+1?"":t.slice(o,s)},format:f.bind(null,"\\"),parse(t){d(t,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return a;const o=t.length;let r=0,s=t.charCodeAt(0);if(o===1)return m(s)?(a.root=a.dir=t,a):(a.base=a.name=t,a);if(m(s)){if(r=1,m(t.charCodeAt(1))){let I=2,B=I;for(;I<o&&!m(t.charCodeAt(I));)I++;if(I<o&&I!==B){for(B=I;I<o&&m(t.charCodeAt(I));)I++;if(I<o&&I!==B){for(B=I;I<o&&!m(t.charCodeAt(I));)I++;I===o?r=I:I!==B&&(r=I+1)}}}}else if(p(s)&&t.charCodeAt(1)===E){if(o<=2)return a.root=a.dir=t,a;if(r=2,m(t.charCodeAt(2))){if(o===3)return a.root=a.dir=t,a;r=3}}r>0&&(a.root=t.slice(0,r));let i=-1,v=r,S=-1,O=!0,N=t.length-1,j=0;for(;N>=r;--N){if(s=t.charCodeAt(N),m(s)){if(!O){v=N+1;break}continue}S===-1&&(O=!1,S=N+1),s===k?i===-1?i=N:j!==1&&(j=1):i!==-1&&(j=-1)}return S!==-1&&(i===-1||j===0||j===1&&i===S-1&&i===v+1?a.base=a.name=t.slice(v,S):(a.name=t.slice(v,i),a.base=t.slice(v,S),a.ext=t.slice(i,S))),v>0&&v!==r?a.dir=t.slice(0,v-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null};const l=(()=>{if(c){const t=/\\/g;return()=>{const a=n.cwd().replace(t,"/");return a.slice(a.indexOf("/"))}}return()=>n.cwd()})();e.$hc={resolve(...t){let a="",o=!1;for(let r=t.length-1;r>=-1&&!o;r--){const s=r>=0?t[r]:l();d(s,"path"),s.length!==0&&(a=`${s}/${a}`,o=s.charCodeAt(0)===b)}return a=h(a,!o,"/",u),o?`/${a}`:a.length>0?a:"."},normalize(t){if(d(t,"path"),t.length===0)return".";const a=t.charCodeAt(0)===b,o=t.charCodeAt(t.length-1)===b;return t=h(t,!a,"/",u),t.length===0?a?"/":o?"./":".":(o&&(t+="/"),a?`/${t}`:t)},isAbsolute(t){return d(t,"path"),t.length>0&&t.charCodeAt(0)===b},join(...t){if(t.length===0)return".";let a;for(let o=0;o<t.length;++o){const r=t[o];d(r,"path"),r.length>0&&(a===void 0?a=r:a+=`/${r}`)}return a===void 0?".":e.$hc.normalize(a)},relative(t,a){if(d(t,"from"),d(a,"to"),t===a||(t=e.$hc.resolve(t),a=e.$hc.resolve(a),t===a))return"";const o=1,r=t.length,s=r-o,i=1,v=a.length-i,S=s<v?s:v;let O=-1,N=0;for(;N<S;N++){const I=t.charCodeAt(o+N);if(I!==a.charCodeAt(i+N))break;I===b&&(O=N)}if(N===S)if(v>S){if(a.charCodeAt(i+N)===b)return a.slice(i+N+1);if(N===0)return a.slice(i+N)}else s>S&&(t.charCodeAt(o+N)===b?O=N:N===0&&(O=0));let j="";for(N=o+O+1;N<=r;++N)(N===r||t.charCodeAt(N)===b)&&(j+=j.length===0?"..":"/..");return`${j}${a.slice(i+O)}`},toNamespacedPath(t){return t},dirname(t){if(d(t,"path"),t.length===0)return".";const a=t.charCodeAt(0)===b;let o=-1,r=!0;for(let s=t.length-1;s>=1;--s)if(t.charCodeAt(s)===b){if(!r){o=s;break}}else r=!1;return o===-1?a?"/":".":a&&o===1?"//":t.slice(0,o)},basename(t,a){a!==void 0&&d(a,"ext"),d(t,"path");let o=0,r=-1,s=!0,i;if(a!==void 0&&a.length>0&&a.length<=t.length){if(a===t)return"";let v=a.length-1,S=-1;for(i=t.length-1;i>=0;--i){const O=t.charCodeAt(i);if(O===b){if(!s){o=i+1;break}}else S===-1&&(s=!1,S=i+1),v>=0&&(O===a.charCodeAt(v)?--v===-1&&(r=i):(v=-1,r=S))}return o===r?r=S:r===-1&&(r=t.length),t.slice(o,r)}for(i=t.length-1;i>=0;--i)if(t.charCodeAt(i)===b){if(!s){o=i+1;break}}else r===-1&&(s=!1,r=i+1);return r===-1?"":t.slice(o,r)},extname(t){d(t,"path");let a=-1,o=0,r=-1,s=!0,i=0;for(let v=t.length-1;v>=0;--v){const S=t.charCodeAt(v);if(S===b){if(!s){o=v+1;break}continue}r===-1&&(s=!1,r=v+1),S===k?a===-1?a=v:i!==1&&(i=1):a!==-1&&(i=-1)}return a===-1||r===-1||i===0||i===1&&a===r-1&&a===o+1?"":t.slice(a,r)},format:f.bind(null,"/"),parse(t){d(t,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return a;const o=t.charCodeAt(0)===b;let r;o?(a.root="/",r=1):r=0;let s=-1,i=0,v=-1,S=!0,O=t.length-1,N=0;for(;O>=r;--O){const j=t.charCodeAt(O);if(j===b){if(!S){i=O+1;break}continue}v===-1&&(S=!1,v=O+1),j===k?s===-1?s=O:N!==1&&(N=1):s!==-1&&(N=-1)}if(v!==-1){const j=i===0&&o?1:i;s===-1||N===0||N===1&&s===v-1&&s===i+1?a.base=a.name=t.slice(j,v):(a.name=t.slice(j,s),a.base=t.slice(j,v),a.ext=t.slice(s,v))}return i>0?a.dir=t.slice(0,i-1):o&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},e.$hc.win32=e.$gc.win32=e.$gc,e.$hc.posix=e.$gc.posix=e.$hc,e.$ic=c?e.$gc.normalize:e.$hc.normalize,e.$jc=c?e.$gc.isAbsolute:e.$hc.isAbsolute,e.$kc=c?e.$gc.join:e.$hc.join,e.$lc=c?e.$gc.resolve:e.$hc.resolve,e.$mc=c?e.$gc.relative:e.$hc.relative,e.$nc=c?e.$gc.dirname:e.$hc.dirname,e.$oc=c?e.$gc.basename:e.$hc.basename,e.$pc=c?e.$gc.extname:e.$hc.extname,e.$qc=c?e.$gc.format:e.$hc.format,e.$rc=c?e.$gc.parse:e.$hc.parse,e.$sc=c?e.$gc.toNamespacedPath:e.$hc.toNamespacedPath,e.sep=c?e.$gc.sep:e.$hc.sep,e.$uc=c?e.$gc.delimiter:e.$hc.delimiter}),define(Ee[61],ke([1,0,7]),function(ce,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$As=void 0,e.$Bs=D,e.$Cs=C,e.$Ds=k,e.$Es=$,e.$As=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const A={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},P={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function D(E){const y=(0,n.$pc)(E),w=A[y.toLowerCase()];return w!==void 0?w:C(E)}function C(E){const y=(0,n.$pc)(E);return P[y.toLowerCase()]}function k(E){for(const y in P)if(P[y]===E)return y}const b=/^(.+)\/(.+?)(;.+)?$/;function $(E,y){const w=b.exec(E);return w?`${w[1].toLowerCase()}/${w[2].toLowerCase()}${w[3]??""}`:y?void 0:E}}),define(Ee[62],ke([1,0,4]),function(ce,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$_l=D,e.$am=C;var A;(function(k){k[k.stdout=0]="stdout",k[k.stderr=1]="stderr"})(A||(e.Source=A={}));var P;(function(k){k[k.Success=0]="Success",k[k.Unknown=1]="Unknown",k[k.AccessDenied=2]="AccessDenied",k[k.ProcessNotFound=3]="ProcessNotFound"})(P||(e.TerminateResponseCode=P={}));function D(k,...b){const $=b.reduce((w,g)=>(w[g]=!0,w),{}),E=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/,/^CODE_SERVER_.+$/,/^CS_.+$/];Object.keys(k).filter(w=>!$[w]).forEach(w=>{for(let g=0;g<E.length;g++)if(w.search(E[g])!==-1){delete k[w];break}})}function C(k){k&&(delete k.DEBUG,n.$d&&delete k.DYLD_LIBRARY_PATH,n.$e&&delete k.LD_PRELOAD)}}),function(ce,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var n=e();for(var A in n)(typeof exports=="object"?exports:ce)[A]=n[A]}}(typeof self<"u"?self:this,function(){return function(ce){var e={};function n(A){if(e[A])return e[A].exports;var P=e[A]={i:A,l:!1,exports:{}};return ce[A].call(P.exports,P,P.exports,n),P.l=!0,P.exports}return n.m=ce,n.c=e,n.d=function(A,P,D){n.o(A,P)||Object.defineProperty(A,P,{enumerable:!0,get:D})},n.r=function(A){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(A,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(A,"__esModule",{value:!0})},n.t=function(A,P){if(1&P&&(A=n(A)),8&P||4&P&&typeof A=="object"&&A&&A.__esModule)return A;var D=Object.create(null);if(n.r(D),Object.defineProperty(D,"default",{enumerable:!0,value:A}),2&P&&typeof A!="string")for(var C in A)n.d(D,C,function(k){return A[k]}.bind(null,C));return D},n.n=function(A){var P=A&&A.__esModule?function(){return A.default}:function(){return A};return n.d(P,"a",P),P},n.o=function(A,P){return Object.prototype.hasOwnProperty.call(A,P)},n.p="",n(n.s=0)}([function(ce,e,n){(function(A){var P;e=ce.exports=ne,P=typeof A=="object"&&A.env&&A.env.NODE_DEBUG&&/\bsemver\b/i.test(A.env.NODE_DEBUG)?function(){var pe=Array.prototype.slice.call(arguments,0);pe.unshift("SEMVER"),console.log.apply(console,pe)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var D=256,C=Number.MAX_SAFE_INTEGER||9007199254740991,k=e.re=[],b=e.src=[],$=0,E=$++;b[E]="0|[1-9]\\d*";var y=$++;b[y]="[0-9]+";var w=$++;b[w]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var g=$++;b[g]="("+b[E]+")\\.("+b[E]+")\\.("+b[E]+")";var d=$++;b[d]="("+b[y]+")\\.("+b[y]+")\\.("+b[y]+")";var c=$++;b[c]="(?:"+b[E]+"|"+b[w]+")";var m=$++;b[m]="(?:"+b[y]+"|"+b[w]+")";var u=$++;b[u]="(?:-("+b[c]+"(?:\\."+b[c]+")*))";var p=$++;b[p]="(?:-?("+b[m]+"(?:\\."+b[m]+")*))";var h=$++;b[h]="[0-9A-Za-z-]+";var f=$++;b[f]="(?:\\+("+b[h]+"(?:\\."+b[h]+")*))";var l=$++,t="v?"+b[g]+b[u]+"?"+b[f]+"?";b[l]="^"+t+"$";var a="[v=\\s]*"+b[d]+b[p]+"?"+b[f]+"?",o=$++;b[o]="^"+a+"$";var r=$++;b[r]="((?:<|>)?=?)";var s=$++;b[s]=b[y]+"|x|X|\\*";var i=$++;b[i]=b[E]+"|x|X|\\*";var v=$++;b[v]="[v=\\s]*("+b[i]+")(?:\\.("+b[i]+")(?:\\.("+b[i]+")(?:"+b[u]+")?"+b[f]+"?)?)?";var S=$++;b[S]="[v=\\s]*("+b[s]+")(?:\\.("+b[s]+")(?:\\.("+b[s]+")(?:"+b[p]+")?"+b[f]+"?)?)?";var O=$++;b[O]="^"+b[r]+"\\s*"+b[v]+"$";var N=$++;b[N]="^"+b[r]+"\\s*"+b[S]+"$";var j=$++;b[j]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var I=$++;b[I]="(?:~>?)";var B=$++;b[B]="(\\s*)"+b[I]+"\\s+",k[B]=new RegExp(b[B],"g");var Z=$++;b[Z]="^"+b[I]+b[v]+"$";var he=$++;b[he]="^"+b[I]+b[S]+"$";var ae=$++;b[ae]="(?:\\^)";var ee=$++;b[ee]="(\\s*)"+b[ae]+"\\s+",k[ee]=new RegExp(b[ee],"g");var _=$++;b[_]="^"+b[ae]+b[v]+"$";var z=$++;b[z]="^"+b[ae]+b[S]+"$";var T=$++;b[T]="^"+b[r]+"\\s*("+a+")$|^$";var J=$++;b[J]="^"+b[r]+"\\s*("+t+")$|^$";var Y=$++;b[Y]="(\\s*)"+b[r]+"\\s*("+a+"|"+b[v]+")",k[Y]=new RegExp(b[Y],"g");var W=$++;b[W]="^\\s*("+b[v]+")\\s+-\\s+("+b[v]+")\\s*$";var re=$++;b[re]="^\\s*("+b[S]+")\\s+-\\s+("+b[S]+")\\s*$";var ue=$++;b[ue]="(<|>)?=?\\s*\\*";for(var ie=0;ie<35;ie++)P(ie,b[ie]),k[ie]||(k[ie]=new RegExp(b[ie]));function $e(pe,Pe){if(pe instanceof ne)return pe;if(typeof pe!="string"||pe.length>D||!(Pe?k[o]:k[l]).test(pe))return null;try{return new ne(pe,Pe)}catch{return null}}function ne(pe,Pe){if(pe instanceof ne){if(pe.loose===Pe)return pe;pe=pe.version}else if(typeof pe!="string")throw new TypeError("Invalid Version: "+pe);if(pe.length>D)throw new TypeError("version is longer than "+D+" characters");if(!(this instanceof ne))return new ne(pe,Pe);P("SemVer",pe,Pe),this.loose=Pe;var Ce=pe.trim().match(Pe?k[o]:k[l]);if(!Ce)throw new TypeError("Invalid Version: "+pe);if(this.raw=pe,this.major=+Ce[1],this.minor=+Ce[2],this.patch=+Ce[3],this.major>C||this.major<0)throw new TypeError("Invalid major version");if(this.minor>C||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>C||this.patch<0)throw new TypeError("Invalid patch version");Ce[4]?this.prerelease=Ce[4].split(".").map(function(Le){if(/^[0-9]+$/.test(Le)){var Me=+Le;if(Me>=0&&Me<C)return Me}return Le}):this.prerelease=[],this.build=Ce[5]?Ce[5].split("."):[],this.format()}e.parse=$e,e.valid=function(pe,Pe){var Ce=$e(pe,Pe);return Ce?Ce.version:null},e.clean=function(pe,Pe){var Ce=$e(pe.trim().replace(/^[=v]+/,""),Pe);return Ce?Ce.version:null},e.SemVer=ne,ne.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ne.prototype.toString=function(){return this.version},ne.prototype.compare=function(pe){return P("SemVer.compare",this.version,this.loose,pe),pe instanceof ne||(pe=new ne(pe,this.loose)),this.compareMain(pe)||this.comparePre(pe)},ne.prototype.compareMain=function(pe){return pe instanceof ne||(pe=new ne(pe,this.loose)),R(this.major,pe.major)||R(this.minor,pe.minor)||R(this.patch,pe.patch)},ne.prototype.comparePre=function(pe){if(pe instanceof ne||(pe=new ne(pe,this.loose)),this.prerelease.length&&!pe.prerelease.length)return-1;if(!this.prerelease.length&&pe.prerelease.length)return 1;if(!this.prerelease.length&&!pe.prerelease.length)return 0;var Pe=0;do{var Ce=this.prerelease[Pe],Le=pe.prerelease[Pe];if(P("prerelease compare",Pe,Ce,Le),Ce===void 0&&Le===void 0)return 0;if(Le===void 0)return 1;if(Ce===void 0)return-1;if(Ce!==Le)return R(Ce,Le)}while(++Pe)},ne.prototype.inc=function(pe,Pe){switch(pe){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Pe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Pe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Pe),this.inc("pre",Pe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Pe),this.inc("pre",Pe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Ce=this.prerelease.length;--Ce>=0;)typeof this.prerelease[Ce]=="number"&&(this.prerelease[Ce]++,Ce=-2);Ce===-1&&this.prerelease.push(0)}Pe&&(this.prerelease[0]===Pe?isNaN(this.prerelease[1])&&(this.prerelease=[Pe,0]):this.prerelease=[Pe,0]);break;default:throw new Error("invalid increment argument: "+pe)}return this.format(),this.raw=this.version,this},e.inc=function(pe,Pe,Ce,Le){typeof Ce=="string"&&(Le=Ce,Ce=void 0);try{return new ne(pe,Ce).inc(Pe,Le).version}catch{return null}},e.diff=function(pe,Pe){if(Q(pe,Pe))return null;var Ce=$e(pe),Le=$e(Pe);if(Ce.prerelease.length||Le.prerelease.length){for(var Me in Ce)if((Me==="major"||Me==="minor"||Me==="patch")&&Ce[Me]!==Le[Me])return"pre"+Me;return"prerelease"}for(var Me in Ce)if((Me==="major"||Me==="minor"||Me==="patch")&&Ce[Me]!==Le[Me])return Me},e.compareIdentifiers=R;var U=/^[0-9]+$/;function R(pe,Pe){var Ce=U.test(pe),Le=U.test(Pe);return Ce&&Le&&(pe=+pe,Pe=+Pe),Ce&&!Le?-1:Le&&!Ce?1:pe<Pe?-1:pe>Pe?1:0}function q(pe,Pe,Ce){return new ne(pe,Ce).compare(new ne(Pe,Ce))}function X(pe,Pe,Ce){return q(pe,Pe,Ce)>0}function le(pe,Pe,Ce){return q(pe,Pe,Ce)<0}function Q(pe,Pe,Ce){return q(pe,Pe,Ce)===0}function x(pe,Pe,Ce){return q(pe,Pe,Ce)!==0}function V(pe,Pe,Ce){return q(pe,Pe,Ce)>=0}function L(pe,Pe,Ce){return q(pe,Pe,Ce)<=0}function H(pe,Pe,Ce,Le){var Me;switch(Pe){case"===":typeof pe=="object"&&(pe=pe.version),typeof Ce=="object"&&(Ce=Ce.version),Me=pe===Ce;break;case"!==":typeof pe=="object"&&(pe=pe.version),typeof Ce=="object"&&(Ce=Ce.version),Me=pe!==Ce;break;case"":case"=":case"==":Me=Q(pe,Ce,Le);break;case"!=":Me=x(pe,Ce,Le);break;case">":Me=X(pe,Ce,Le);break;case">=":Me=V(pe,Ce,Le);break;case"<":Me=le(pe,Ce,Le);break;case"<=":Me=L(pe,Ce,Le);break;default:throw new TypeError("Invalid operator: "+Pe)}return Me}function K(pe,Pe){if(pe instanceof K){if(pe.loose===Pe)return pe;pe=pe.value}if(!(this instanceof K))return new K(pe,Pe);P("comparator",pe,Pe),this.loose=Pe,this.parse(pe),this.semver===te?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}e.rcompareIdentifiers=function(pe,Pe){return R(Pe,pe)},e.major=function(pe,Pe){return new ne(pe,Pe).major},e.minor=function(pe,Pe){return new ne(pe,Pe).minor},e.patch=function(pe,Pe){return new ne(pe,Pe).patch},e.compare=q,e.compareLoose=function(pe,Pe){return q(pe,Pe,!0)},e.rcompare=function(pe,Pe,Ce){return q(Pe,pe,Ce)},e.sort=function(pe,Pe){return pe.sort(function(Ce,Le){return e.compare(Ce,Le,Pe)})},e.rsort=function(pe,Pe){return pe.sort(function(Ce,Le){return e.rcompare(Ce,Le,Pe)})},e.gt=X,e.lt=le,e.eq=Q,e.neq=x,e.gte=V,e.lte=L,e.cmp=H,e.Comparator=K;var te={};function de(pe,Pe){if(pe instanceof de)return pe.loose===Pe?pe:new de(pe.raw,Pe);if(pe instanceof K)return new de(pe.value,Pe);if(!(this instanceof de))return new de(pe,Pe);if(this.loose=Pe,this.raw=pe,this.set=pe.split(/\s*\|\|\s*/).map(function(Ce){return this.parseRange(Ce.trim())},this).filter(function(Ce){return Ce.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+pe);this.format()}function se(pe){return!pe||pe.toLowerCase()==="x"||pe==="*"}function ge(pe,Pe,Ce,Le,Me,Ve,qe,xe,_e,Ke,nt,Ye,Qe){return((Pe=se(Ce)?"":se(Le)?">="+Ce+".0.0":se(Me)?">="+Ce+"."+Le+".0":">="+Pe)+" "+(xe=se(_e)?"":se(Ke)?"<"+(+_e+1)+".0.0":se(nt)?"<"+_e+"."+(+Ke+1)+".0":Ye?"<="+_e+"."+Ke+"."+nt+"-"+Ye:"<="+xe)).trim()}function we(pe,Pe){for(var Ce=0;Ce<pe.length;Ce++)if(!pe[Ce].test(Pe))return!1;if(Pe.prerelease.length){for(Ce=0;Ce<pe.length;Ce++)if(P(pe[Ce].semver),pe[Ce].semver!==te&&pe[Ce].semver.prerelease.length>0){var Le=pe[Ce].semver;if(Le.major===Pe.major&&Le.minor===Pe.minor&&Le.patch===Pe.patch)return!0}return!1}return!0}function Ie(pe,Pe,Ce){try{Pe=new de(Pe,Ce)}catch{return!1}return Pe.test(pe)}function je(pe,Pe,Ce,Le){var Me,Ve,qe,xe,_e;switch(pe=new ne(pe,Le),Pe=new de(Pe,Le),Ce){case">":Me=X,Ve=L,qe=le,xe=">",_e=">=";break;case"<":Me=le,Ve=V,qe=X,xe="<",_e="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ie(pe,Pe,Le))return!1;for(var Ke=0;Ke<Pe.set.length;++Ke){var nt=Pe.set[Ke],Ye=null,Qe=null;if(nt.forEach(function(me){me.semver===te&&(me=new K(">=0.0.0")),Ye=Ye||me,Qe=Qe||me,Me(me.semver,Ye.semver,Le)?Ye=me:qe(me.semver,Qe.semver,Le)&&(Qe=me)}),Ye.operator===xe||Ye.operator===_e||(!Qe.operator||Qe.operator===xe)&&Ve(pe,Qe.semver)||Qe.operator===_e&&qe(pe,Qe.semver))return!1}return!0}K.prototype.parse=function(pe){var Pe=this.loose?k[T]:k[J],Ce=pe.match(Pe);if(!Ce)throw new TypeError("Invalid comparator: "+pe);this.operator=Ce[1],this.operator==="="&&(this.operator=""),Ce[2]?this.semver=new ne(Ce[2],this.loose):this.semver=te},K.prototype.toString=function(){return this.value},K.prototype.test=function(pe){return P("Comparator.test",pe,this.loose),this.semver===te||(typeof pe=="string"&&(pe=new ne(pe,this.loose)),H(pe,this.operator,this.semver,this.loose))},K.prototype.intersects=function(pe,Pe){if(!(pe instanceof K))throw new TypeError("a Comparator is required");var Ce;if(this.operator==="")return Ce=new de(pe.value,Pe),Ie(this.value,Ce,Pe);if(pe.operator==="")return Ce=new de(this.value,Pe),Ie(pe.semver,Ce,Pe);var Le=!(this.operator!==">="&&this.operator!==">"||pe.operator!==">="&&pe.operator!==">"),Me=!(this.operator!=="<="&&this.operator!=="<"||pe.operator!=="<="&&pe.operator!=="<"),Ve=this.semver.version===pe.semver.version,qe=!(this.operator!==">="&&this.operator!=="<="||pe.operator!==">="&&pe.operator!=="<="),xe=H(this.semver,"<",pe.semver,Pe)&&(this.operator===">="||this.operator===">")&&(pe.operator==="<="||pe.operator==="<"),_e=H(this.semver,">",pe.semver,Pe)&&(this.operator==="<="||this.operator==="<")&&(pe.operator===">="||pe.operator===">");return Le||Me||Ve&&qe||xe||_e},e.Range=de,de.prototype.format=function(){return this.range=this.set.map(function(pe){return pe.join(" ").trim()}).join("||").trim(),this.range},de.prototype.toString=function(){return this.range},de.prototype.parseRange=function(pe){var Pe=this.loose;pe=pe.trim(),P("range",pe,Pe);var Ce=Pe?k[re]:k[W];pe=pe.replace(Ce,ge),P("hyphen replace",pe),pe=pe.replace(k[Y],"$1$2$3"),P("comparator trim",pe,k[Y]),pe=(pe=(pe=pe.replace(k[B],"$1~")).replace(k[ee],"$1^")).split(/\s+/).join(" ");var Le=Pe?k[T]:k[J],Me=pe.split(" ").map(function(Ve){return function(qe,xe){return P("comp",qe),qe=function(_e,Ke){return _e.trim().split(/\s+/).map(function(nt){return function(Ye,Qe){P("caret",Ye,Qe);var me=Qe?k[z]:k[_];return Ye.replace(me,function(Se,Ae,Re,Te,He){var We;return P("caret",Ye,Se,Ae,Re,Te,He),se(Ae)?We="":se(Re)?We=">="+Ae+".0.0 <"+(+Ae+1)+".0.0":se(Te)?We=Ae==="0"?">="+Ae+"."+Re+".0 <"+Ae+"."+(+Re+1)+".0":">="+Ae+"."+Re+".0 <"+(+Ae+1)+".0.0":He?(P("replaceCaret pr",He),He.charAt(0)!=="-"&&(He="-"+He),We=Ae==="0"?Re==="0"?">="+Ae+"."+Re+"."+Te+He+" <"+Ae+"."+Re+"."+(+Te+1):">="+Ae+"."+Re+"."+Te+He+" <"+Ae+"."+(+Re+1)+".0":">="+Ae+"."+Re+"."+Te+He+" <"+(+Ae+1)+".0.0"):(P("no pr"),We=Ae==="0"?Re==="0"?">="+Ae+"."+Re+"."+Te+" <"+Ae+"."+Re+"."+(+Te+1):">="+Ae+"."+Re+"."+Te+" <"+Ae+"."+(+Re+1)+".0":">="+Ae+"."+Re+"."+Te+" <"+(+Ae+1)+".0.0"),P("caret return",We),We})}(nt,Ke)}).join(" ")}(qe,xe),P("caret",qe),qe=function(_e,Ke){return _e.trim().split(/\s+/).map(function(nt){return function(Ye,Qe){var me=Qe?k[he]:k[Z];return Ye.replace(me,function(Se,Ae,Re,Te,He){var We;return P("tilde",Ye,Se,Ae,Re,Te,He),se(Ae)?We="":se(Re)?We=">="+Ae+".0.0 <"+(+Ae+1)+".0.0":se(Te)?We=">="+Ae+"."+Re+".0 <"+Ae+"."+(+Re+1)+".0":He?(P("replaceTilde pr",He),He.charAt(0)!=="-"&&(He="-"+He),We=">="+Ae+"."+Re+"."+Te+He+" <"+Ae+"."+(+Re+1)+".0"):We=">="+Ae+"."+Re+"."+Te+" <"+Ae+"."+(+Re+1)+".0",P("tilde return",We),We})}(nt,Ke)}).join(" ")}(qe,xe),P("tildes",qe),qe=function(_e,Ke){return P("replaceXRanges",_e,Ke),_e.split(/\s+/).map(function(nt){return function(Ye,Qe){Ye=Ye.trim();var me=Qe?k[N]:k[O];return Ye.replace(me,function(Se,Ae,Re,Te,He,We){P("xRange",Ye,Se,Ae,Re,Te,He,We);var rt=se(Re),st=rt||se(Te),Je=st||se(He);return Ae==="="&&Je&&(Ae=""),rt?Se=Ae===">"||Ae==="<"?"<0.0.0":"*":Ae&&Je?(st&&(Te=0),Je&&(He=0),Ae===">"?(Ae=">=",st?(Re=+Re+1,Te=0,He=0):Je&&(Te=+Te+1,He=0)):Ae==="<="&&(Ae="<",st?Re=+Re+1:Te=+Te+1),Se=Ae+Re+"."+Te+"."+He):st?Se=">="+Re+".0.0 <"+(+Re+1)+".0.0":Je&&(Se=">="+Re+"."+Te+".0 <"+Re+"."+(+Te+1)+".0"),P("xRange return",Se),Se})}(nt,Ke)}).join(" ")}(qe,xe),P("xrange",qe),qe=function(_e,Ke){return P("replaceStars",_e,Ke),_e.trim().replace(k[ue],"")}(qe,xe),P("stars",qe),qe}(Ve,Pe)}).join(" ").split(/\s+/);return this.loose&&(Me=Me.filter(function(Ve){return!!Ve.match(Le)})),Me=Me.map(function(Ve){return new K(Ve,Pe)})},de.prototype.intersects=function(pe,Pe){if(!(pe instanceof de))throw new TypeError("a Range is required");return this.set.some(function(Ce){return Ce.every(function(Le){return pe.set.some(function(Me){return Me.every(function(Ve){return Le.intersects(Ve,Pe)})})})})},e.toComparators=function(pe,Pe){return new de(pe,Pe).set.map(function(Ce){return Ce.map(function(Le){return Le.value}).join(" ").trim().split(" ")})},de.prototype.test=function(pe){if(!pe)return!1;typeof pe=="string"&&(pe=new ne(pe,this.loose));for(var Pe=0;Pe<this.set.length;Pe++)if(we(this.set[Pe],pe))return!0;return!1},e.satisfies=Ie,e.maxSatisfying=function(pe,Pe,Ce){var Le=null,Me=null;try{var Ve=new de(Pe,Ce)}catch{return null}return pe.forEach(function(qe){Ve.test(qe)&&(Le&&Me.compare(qe)!==-1||(Me=new ne(Le=qe,Ce)))}),Le},e.minSatisfying=function(pe,Pe,Ce){var Le=null,Me=null;try{var Ve=new de(Pe,Ce)}catch{return null}return pe.forEach(function(qe){Ve.test(qe)&&(Le&&Me.compare(qe)!==1||(Me=new ne(Le=qe,Ce)))}),Le},e.validRange=function(pe,Pe){try{return new de(pe,Pe).range||"*"}catch{return null}},e.ltr=function(pe,Pe,Ce){return je(pe,Pe,"<",Ce)},e.gtr=function(pe,Pe,Ce){return je(pe,Pe,">",Ce)},e.outside=je,e.prerelease=function(pe,Pe){var Ce=$e(pe,Pe);return Ce&&Ce.prerelease.length?Ce.prerelease:null},e.intersects=function(pe,Pe,Ce){return pe=new de(pe,Ce),Pe=new de(Pe,Ce),pe.intersects(Pe)},e.coerce=function(pe){if(pe instanceof ne)return pe;if(typeof pe!="string")return null;var Pe=pe.match(k[j]);return Pe==null?null:$e((Pe[1]||"0")+"."+(Pe[2]||"0")+"."+(Pe[3]||"0"))}}).call(this,n(1))},function(ce,e){var n,A,P=ce.exports={};function D(){throw new Error("setTimeout has not been defined")}function C(){throw new Error("clearTimeout has not been defined")}function k(m){if(n===setTimeout)return setTimeout(m,0);if((n===D||!n)&&setTimeout)return n=setTimeout,setTimeout(m,0);try{return n(m,0)}catch{try{return n.call(null,m,0)}catch{return n.call(this,m,0)}}}(function(){try{n=typeof setTimeout=="function"?setTimeout:D}catch{n=D}try{A=typeof clearTimeout=="function"?clearTimeout:C}catch{A=C}})();var b,$=[],E=!1,y=-1;function w(){E&&b&&(E=!1,b.length?$=b.concat($):y=-1,$.length&&g())}function g(){if(!E){var m=k(w);E=!0;for(var u=$.length;u;){for(b=$,$=[];++y<u;)b&&b[y].run();y=-1,u=$.length}b=null,E=!1,function(p){if(A===clearTimeout)return clearTimeout(p);if((A===C||!A)&&clearTimeout)return A=clearTimeout,clearTimeout(p);try{A(p)}catch{try{return A.call(null,p)}catch{return A.call(this,p)}}}(m)}}function d(m,u){this.fun=m,this.array=u}function c(){}P.nextTick=function(m){var u=new Array(arguments.length-1);if(arguments.length>1)for(var p=1;p<arguments.length;p++)u[p-1]=arguments[p];$.push(new d(m,u)),$.length!==1||E||k(g)},d.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=c,P.addListener=c,P.once=c,P.off=c,P.removeListener=c,P.removeAllListeners=c,P.emit=c,P.prependListener=c,P.prependOnceListener=c,P.listeners=function(m){return[]},P.binding=function(m){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(m){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(Ee[152],ke([1,0]),function(ce,e){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.$js=void 0;class A{constructor(k,b,$){this.level=k,this.key=b,this.value=$,this.forward=[]}}const P=void 0;class D{constructor(k,b=2**16){this.comparator=k,this[n]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(b)|0),this.e=new A(this.c,P,P)}get size(){return this.f}clear(){this.e=new A(this.c,P,P),this.f=0}has(k){return!!D.g(this,k,this.comparator)}get(k){return D.g(this,k,this.comparator)?.value}set(k,b){return D.h(this,k,b,this.comparator)&&(this.f+=1),this}delete(k){const b=D.k(this,k,this.comparator);return b&&(this.f-=1),b}forEach(k,b){let $=this.e.forward[0];for(;$;)k.call(b,$.value,$.key,this),$=$.forward[0]}[(n=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let k=this.e.forward[0];for(;k;)yield[k.key,k.value],k=k.forward[0]}*keys(){let k=this.e.forward[0];for(;k;)yield k.key,k=k.forward[0]}*values(){let k=this.e.forward[0];for(;k;)yield k.value,k=k.forward[0]}toString(){let k="[SkipList]:",b=this.e.forward[0];for(;b;)k+=`node(${b.key}, ${b.value}, lvl:${b.level})`,b=b.forward[0];return k}static g(k,b,$){let E=k.e;for(let y=k.d-1;y>=0;y--)for(;E.forward[y]&&$(E.forward[y].key,b)<0;)E=E.forward[y];if(E=E.forward[0],E&&$(E.key,b)===0)return E}static h(k,b,$,E){const y=[];let w=k.e;for(let g=k.d-1;g>=0;g--){for(;w.forward[g]&&E(w.forward[g].key,b)<0;)w=w.forward[g];y[g]=w}if(w=w.forward[0],w&&E(w.key,b)===0)return w.value=$,!1;{const g=D.j(k);if(g>k.d){for(let d=k.d;d<g;d++)y[d]=k.e;k.d=g}w=new A(g,b,$);for(let d=0;d<g;d++)w.forward[d]=y[d].forward[d],y[d].forward[d]=w;return!0}}static j(k,b=.5){let $=1;for(;Math.random()<b&&$<k.c;)$+=1;return $}static k(k,b,$){const E=[];let y=k.e;for(let w=k.d-1;w>=0;w--){for(;y.forward[w]&&$(y.forward[w].key,b)<0;)y=y.forward[w];E[w]=y}if(y=y.forward[0],!y||$(y.key,b)!==0)return!1;for(let w=0;w<k.d&&E[w].forward[w]===y;w++)E[w].forward[w]=y.forward[w];for(;k.d>0&&k.e.forward[k.d-1]===P;)k.d-=1;return!0}}e.$js=D}),define(Ee[63],ke([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3d=void 0;const n=globalThis.performance&&typeof globalThis.performance.now=="function";class A{static create(D){return new A(D)}constructor(D){this.c=n&&D===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$3d=A}),define(Ee[6],ke([1,0,10,75,2,98,63]),function(ce,e,n,A,P,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$5d=e.Event=void 0,e.$6d=g;const k=!1,b=!1,$=!1;var E;(function(j){j.None=()=>P.$Uc.None;function I(K){if($){const{onDidAddListener:te}=K,de=c.create();let se=0;K.onDidAddListener=()=>{++se===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),de.print()),te?.()}}}function B(K,te){return W(K,()=>{},0,void 0,!0,void 0,te)}j.defer=B;function Z(K){return(te,de=null,se)=>{let ge=!1,we;return we=K(Ie=>{if(!ge)return we?we.dispose():ge=!0,te.call(de,Ie)},null,se),ge&&we.dispose(),we}}j.once=Z;function he(K,te,de){return J((se,ge=null,we)=>K(Ie=>se.call(ge,te(Ie)),null,we),de)}j.map=he;function ae(K,te,de){return J((se,ge=null,we)=>K(Ie=>{te(Ie),se.call(ge,Ie)},null,we),de)}j.forEach=ae;function ee(K,te,de){return J((se,ge=null,we)=>K(Ie=>te(Ie)&&se.call(ge,Ie),null,we),de)}j.filter=ee;function _(K){return K}j.signal=_;function z(...K){return(te,de=null,se)=>{const ge=(0,P.$Rc)(...K.map(we=>we(Ie=>te.call(de,Ie))));return Y(ge,se)}}j.any=z;function T(K,te,de,se){let ge=de;return he(K,we=>(ge=te(ge,we),ge),se)}j.reduce=T;function J(K,te){let de;const se={onWillAddFirstListener(){de=K(ge.fire,ge)},onDidRemoveLastListener(){de?.dispose()}};te||I(se);const ge=new l(se);return te?.add(ge),ge.event}function Y(K,te){return te instanceof Array?te.push(K):te&&te.add(K),K}function W(K,te,de=100,se=!1,ge=!1,we,Ie){let je,pe,Pe,Ce=0,Le;const Me={leakWarningThreshold:we,onWillAddFirstListener(){je=K(qe=>{Ce++,pe=te(pe,qe),se&&!Pe&&(Ve.fire(pe),pe=void 0),Le=()=>{const xe=pe;pe=void 0,Pe=void 0,(!se||Ce>1)&&Ve.fire(xe),Ce=0},typeof de=="number"?(clearTimeout(Pe),Pe=setTimeout(Le,de)):Pe===void 0&&(Pe=0,queueMicrotask(Le))})},onWillRemoveListener(){ge&&Ce>0&&Le?.()},onDidRemoveLastListener(){Le=void 0,je.dispose()}};Ie||I(Me);const Ve=new l(Me);return Ie?.add(Ve),Ve.event}j.debounce=W;function re(K,te=0,de){return j.debounce(K,(se,ge)=>se?(se.push(ge),se):[ge],te,void 0,!0,void 0,de)}j.accumulate=re;function ue(K,te=(se,ge)=>se===ge,de){let se=!0,ge;return ee(K,we=>{const Ie=se||!te(we,ge);return se=!1,ge=we,Ie},de)}j.latch=ue;function ie(K,te,de){return[j.filter(K,te,de),j.filter(K,se=>!te(se),de)]}j.split=ie;function $e(K,te=!1,de=[],se){let ge=de.slice(),we=K(pe=>{ge?ge.push(pe):je.fire(pe)});se&&se.add(we);const Ie=()=>{ge?.forEach(pe=>je.fire(pe)),ge=null},je=new l({onWillAddFirstListener(){we||(we=K(pe=>je.fire(pe)),se&&se.add(we))},onDidAddFirstListener(){ge&&(te?setTimeout(Ie):Ie())},onDidRemoveLastListener(){we&&we.dispose(),we=null}});return se&&se.add(je),je.event}j.buffer=$e;function ne(K,te){return(se,ge,we)=>{const Ie=te(new R);return K(function(je){const pe=Ie.evaluate(je);pe!==U&&se.call(ge,pe)},void 0,we)}}j.chain=ne;const U=Symbol("HaltChainable");class R{constructor(){this.f=[]}map(te){return this.f.push(te),this}forEach(te){return this.f.push(de=>(te(de),de)),this}filter(te){return this.f.push(de=>te(de)?de:U),this}reduce(te,de){let se=de;return this.f.push(ge=>(se=te(se,ge),se)),this}latch(te=(de,se)=>de===se){let de=!0,se;return this.f.push(ge=>{const we=de||!te(ge,se);return de=!1,se=ge,we?ge:U}),this}evaluate(te){for(const de of this.f)if(te=de(te),te===U)break;return te}}function q(K,te,de=se=>se){const se=(...je)=>Ie.fire(de(...je)),ge=()=>K.on(te,se),we=()=>K.removeListener(te,se),Ie=new l({onWillAddFirstListener:ge,onDidRemoveLastListener:we});return Ie.event}j.fromNodeEventEmitter=q;function X(K,te,de=se=>se){const se=(...je)=>Ie.fire(de(...je)),ge=()=>K.addEventListener(te,se),we=()=>K.removeEventListener(te,se),Ie=new l({onWillAddFirstListener:ge,onDidRemoveLastListener:we});return Ie.event}j.fromDOMEventEmitter=X;function le(K){return new Promise(te=>Z(K)(te))}j.toPromise=le;function Q(K){const te=new l;return K.then(de=>{te.fire(de)},()=>{te.fire(void 0)}).finally(()=>{te.dispose()}),te.event}j.fromPromise=Q;function x(K,te,de){return te(de),K(se=>te(se))}j.runAndSubscribe=x;class V{constructor(te,de){this._observable=te,this.f=0,this.g=!1;const se={onWillAddFirstListener:()=>{te.addObserver(this)},onDidRemoveLastListener:()=>{te.removeObserver(this)}};de||I(se),this.emitter=new l(se),de&&de.add(this.emitter)}beginUpdate(te){this.f++}handlePossibleChange(te){}handleChange(te,de){this.g=!0}endUpdate(te){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function L(K,te){return new V(K,te).emitter.event}j.fromObservable=L;function H(K){return(te,de,se)=>{let ge=0,we=!1;const Ie={beginUpdate(){ge++},endUpdate(){ge--,ge===0&&(K.reportChanges(),we&&(we=!1,te.call(de)))},handlePossibleChange(){},handleChange(){we=!0}};K.addObserver(Ie),K.reportChanges();const je={dispose(){K.removeObserver(Ie)}};return se instanceof P.$Tc?se.add(je):Array.isArray(se)&&se.push(je),je}}j.fromObservableLight=H})(E||(e.Event=E={}));class y{constructor(I){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${I}_${y.f++}`,y.all.add(this)}start(I){this.g=new C.$3d,this.listenerCount=I}stop(){if(this.g){const I=this.g.elapsed();this.durations.push(I),this.elapsedOverall+=I,this.invocationCount+=1,this.g=void 0}}}e.$5d=y,y.all=new Set,y.f=0;let w=-1;function g(j){const I=w;return w=j,{dispose(){w=I}}}class d{constructor(I,B=Math.random().toString(18).slice(2,5)){this.threshold=I,this.name=B,this.g=0}dispose(){this.f?.clear()}check(I,B){const Z=this.threshold;if(Z<=0||B<Z)return;this.f||(this.f=new Map);const he=this.f.get(I.value)||0;if(this.f.set(I.value,he+1),this.g-=1,this.g<=0){this.g=Z*.5;let ae,ee=0;for(const[_,z]of this.f)(!ae||ee<z)&&(ae=_,ee=z);console.warn(`[${this.name}] potential listener LEAK detected, having ${B} listeners already. MOST frequent listener (${ee}):`),console.warn(ae)}return()=>{const ae=this.f.get(I.value)||0;this.f.set(I.value,ae-1)}}}class c{static create(){return new c(new Error().stack??"")}constructor(I){this.value=I}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let m=0;class u{constructor(I){this.value=I,this.id=m++}}const p=2,h=(j,I)=>{if(j instanceof u)I(j);else for(let B=0;B<j.length;B++){const Z=j[B];Z&&I(Z)}},f=k?new FinalizationRegistry(j=>{typeof j=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(j))}):void 0;class l{constructor(I){this.w=0,this.f=I,this.g=w>0||this.f?.leakWarningThreshold?new d(this.f?.leakWarningThreshold??w):void 0,this.j=this.f?._profName?new y(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(b){const I=this.t;queueMicrotask(()=>{h(I,B=>B.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??(this.q=(I,B,Z)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),P.$Uc.None;if(this.m)return P.$Uc.None;B&&(I=I.bind(B));const he=new u(I);let ae,ee;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(he.stack=c.create(),ae=this.g.check(he.stack,this.w+1)),b&&(he.stack=ee??c.create()),this.t?this.t instanceof u?(this.u??(this.u=new a),this.t=[this.t,he]):this.t.push(he):(this.f?.onWillAddFirstListener?.(this),this.t=he,this.f?.onDidAddFirstListener?.(this)),this.w++;const _=(0,P.$Sc)(()=>{f?.unregister(_),ae?.(),this.x(he)});if(Z instanceof P.$Tc?Z.add(_):Array.isArray(Z)&&Z.push(_),f){const z=new Error().stack.split(`
`).slice(2).join(`
`).trim();f.register(_,z,_)}return _}),this.q}x(I){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const B=this.t,Z=B.indexOf(I);if(Z===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,B[Z]=void 0;const he=this.u.current===this;if(this.w*p<=B.length){let ae=0;for(let ee=0;ee<B.length;ee++)B[ee]?B[ae++]=B[ee]:he&&(this.u.end--,ae<this.u.i&&this.u.i--);B.length=ae}}y(I,B){if(!I)return;const Z=this.f?.onListenerError||n.$1;if(!Z){I.value(B);return}try{I.value(B)}catch(he){Z(he)}}z(I){const B=I.current.t;for(;I.i<I.end;)this.y(B[I.i++],I.value);I.reset()}fire(I){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof u)this.y(this.t,I);else{const B=this.u;B.enqueue(this,I,this.t.length),this.z(B)}this.j?.stop()}hasListeners(){return this.w>0}}e.$7d=l;const t=()=>new a;e.$8d=t;class a{constructor(){this.i=-1,this.end=0}enqueue(I,B,Z){this.i=0,this.end=Z,this.current=I,this.value=B}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class o extends l{async fireAsync(I,B,Z){if(this.t)for(this.h||(this.h=new D.$5c),h(this.t,he=>this.h.push([he.value,I]));this.h.size>0&&!B.isCancellationRequested;){const[he,ae]=this.h.shift(),ee=[],_={...ae,token:B,waitUntil:z=>{if(Object.isFrozen(ee))throw new Error("waitUntil can NOT be called asynchronous");Z&&(z=Z(z,he)),ee.push(z)}};try{he(_)}catch(z){(0,n.$1)(z);continue}Object.freeze(ee),await Promise.allSettled(ee).then(z=>{for(const T of z)T.status==="rejected"&&(0,n.$1)(T.reason)})}}}e.$9d=o;class r extends l{get isPaused(){return this.h!==0}constructor(I){super(I),this.h=0,this.s=new D.$5c,this.A=I?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const I=Array.from(this.s);this.s.clear(),super.fire(this.A(I))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(I){this.w&&(this.h!==0?this.s.push(I):super.fire(I))}}e.$0d=r;class s extends r{constructor(I){super(I),this.k=I.delay??100}fire(I){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(I)}}e.$$d=s;class i extends l{constructor(I){super(I),this.h=[],this.k=I?.merge}fire(I){this.hasListeners()&&(this.h.push(I),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(B=>super.fire(B)),this.h=[]}))}}e.$_d=i;class v{constructor(){this.g=!1,this.h=[],this.f=new l({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(I){const B={event:I,listener:null};this.h.push(B),this.g&&this.m(B);const Z=()=>{this.g&&this.o(B);const he=this.h.indexOf(B);this.h.splice(he,1)};return(0,P.$Sc)((0,A.$db)(Z))}j(){this.g=!0,this.h.forEach(I=>this.m(I))}k(){this.g=!1,this.h.forEach(I=>this.o(I))}m(I){I.listener=I.event(B=>this.f.fire(B))}o(I){I.listener?.dispose(),I.listener=null}dispose(){this.f.dispose();for(const I of this.h)I.listener?.dispose();this.h=[]}}e.$ae=v;class S{constructor(I,B,Z,he){this.f=new P.$Tc;const ae=this.f.add(new v),ee=this.f.add(new P.$4c);function _(z){ee.set(z,ae.add(he(z)))}for(const z of I)_(z);this.f.add(B(z=>{_(z)})),this.f.add(Z(z=>{ee.deleteAndDispose(z)})),this.event=ae.event}dispose(){this.f.dispose()}}e.$be=S;class O{constructor(){this.f=[]}wrapEvent(I){return(B,Z,he)=>I(ae=>{const ee=this.f[this.f.length-1];ee?ee.push(()=>B.call(Z,ae)):B.call(Z,ae)},void 0,he)}bufferEvents(I){const B=[];this.f.push(B);const Z=I();return this.f.pop(),B.forEach(he=>he()),Z}}e.$ce=O;class N{constructor(){this.f=!1,this.g=E.None,this.h=P.$Uc.None,this.j=new l({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(I){this.g=I,this.f&&(this.h.dispose(),this.h=I(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$de=N}),define(Ee[20],ke([1,0,6]),function(ce,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ee=e.CancellationToken=void 0;const A=Object.freeze(function(k,b){const $=setTimeout(k.bind(b),0);return{dispose(){clearTimeout($)}}});var P;(function(k){function b($){return $===k.None||$===k.Cancelled||$ instanceof D?!0:!$||typeof $!="object"?!1:typeof $.isCancellationRequested=="boolean"&&typeof $.onCancellationRequested=="function"}k.isCancellationToken=b,k.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:n.Event.None}),k.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:A})})(P||(e.CancellationToken=P={}));class D{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?A:(this.b||(this.b=new n.$7d),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class C{constructor(b){this.f=void 0,this.g=void 0,this.g=b&&b.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new D),this.f}cancel(){this.f?this.f instanceof D&&this.f.cancel():this.f=P.Cancelled}dispose(b=!1){b&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof D&&this.f.dispose():this.f=P.None}}e.$ee=C}),define(Ee[153],ke([1,0,20]),function(ce,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Re=e.$Qe=e.$Pe=void 0;class A{constructor(k){this.b=k,this.a=null}get(){if(this.a)return this.a;const k=new n.$ee,b=this.b(k.token);return this.a={promise:b,dispose:()=>{this.a=null,k.cancel(),k.dispose()}},this.a}}e.$Pe=A;class P{constructor(k,b=JSON.stringify){this.c=k,this.d=b,this.a=void 0,this.b=void 0}get(k){const b=this.d(k);return this.b!==b&&(this.b=b,this.a=this.c(k)),this.a}}e.$Qe=P;class D{get cachedValues(){return this.a}constructor(k){this.b=k,this.a=new Map}get(k){if(this.a.has(k))return this.a.get(k);const b=this.b(k);return this.a.set(k,b),b}}e.$Re=D}),define(Ee[51],ke([1,0,10,2]),function(ce,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fe=P,e.$ge=D,e.$he=C,e.$ie=k,e.$je=$,e.$ke=E,e.$le=y,e.$me=w,e.$ne=g,e.$oe=d,e.$pe=c,e.$qe=m,e.$re=u,e.$se=p,e.$te=h;function P(f){const l=f;return l?typeof l.read=="function":!1}function D(f){const l=f;return l?[l.on,l.pause,l.resume,l.destroy].every(t=>typeof t=="function"):!1}function C(f){const l=f;return l?D(l.stream)&&Array.isArray(l.buffer)&&typeof l.ended=="boolean":!1}function k(f,l){return new b(f,l)}class b{constructor(l,t){this.e=l,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(l){if(!this.a.destroyed){if(this.a.flowing)this.g(l);else if(this.b.data.push(l),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(l){this.a.destroyed||(this.a.flowing?this.h(l):this.b.error.push(l))}end(l){this.a.destroyed||(typeof l<"u"&&this.write(l),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(l){this.c.data.slice(0).forEach(t=>t(l))}h(l){this.c.error.length===0?(0,n.$1)(l):this.c.error.slice(0).forEach(t=>t(l))}i(){this.c.end.slice(0).forEach(l=>l())}on(l,t){if(!this.a.destroyed)switch(l){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(l,t){if(this.a.destroyed)return;let a;switch(l){case"data":a=this.c.data;break;case"end":a=this.c.end;break;case"error":a=this.c.error;break}if(a){const o=a.indexOf(t);o>=0&&a.splice(o,1)}}j(){if(this.b.data.length>0){const l=this.e(this.b.data);this.g(l),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(a=>a())}}k(){if(this.c.error.length>0){for(const l of this.b.error)this.h(l);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function $(f,l){const t=[];let a;for(;(a=f.read())!==null;)t.push(a);return l(t)}function E(f,l,t){const a=[];let o;for(;(o=f.read())!==null&&a.length<t;)a.push(o);return o===null&&a.length>0?l(a):{read:()=>{if(a.length>0)return a.shift();if(typeof o<"u"){const r=o;return o=void 0,r}return f.read()}}}function y(f,l){return new Promise((t,a)=>{const o=[];w(f,{onData:r=>{l&&o.push(r)},onError:r=>{l?a(r):t(void 0)},onEnd:()=>{t(l?l(o):void 0)}})})}function w(f,l,t){f.on("error",a=>{t?.isCancellationRequested||l.onError(a)}),f.on("end",()=>{t?.isCancellationRequested||l.onEnd()}),f.on("data",a=>{t?.isCancellationRequested||l.onData(a)})}function g(f,l){return new Promise((t,a)=>{const o=new A.$Tc,r=[],s=S=>{if(r.push(S),r.length>l)return o.dispose(),f.pause(),t({stream:f,buffer:r,ended:!1})},i=S=>(o.dispose(),a(S)),v=()=>(o.dispose(),t({stream:f,buffer:r,ended:!0}));o.add((0,A.$Sc)(()=>f.removeListener("error",i))),f.on("error",i),o.add((0,A.$Sc)(()=>f.removeListener("end",v))),f.on("end",v),o.add((0,A.$Sc)(()=>f.removeListener("data",s))),f.on("data",s)})}function d(f,l){const t=k(l);return t.end(f),t}function c(){const f=k(()=>{throw new Error("not supported")});return f.end(),f}function m(f){let l=!1;return{read:()=>l?null:(l=!0,f)}}function u(f,l,t){const a=k(t);return w(f,{onData:o=>a.write(l.data(o)),onError:o=>a.error(l.error?l.error(o):o),onEnd:()=>a.end()}),a}function p(f,l,t){let a=!1;return{read:()=>{const o=l.read();return a?o:(a=!0,o!==null?t([f,o]):f)}}}function h(f,l,t){let a=!1;const o=k(t);return w(l,{onData:r=>a?o.write(r):(a=!0,o.write(t([f,r]))),onError:r=>o.error(r),onEnd:()=>{a||(a=!0,o.write(f)),o.end()}}),o}}),define(Ee[14],ke([1,0,60,51]),function(ce,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ue=void 0,e.$ve=$,e.$we=E,e.$xe=y,e.$ye=w,e.$ze=g,e.$Ae=d,e.$Be=c,e.$Ce=m,e.$De=u,e.$Ee=p,e.$Fe=h,e.$Ge=f,e.$He=l,e.$Ie=t,e.$Je=a,e.$Ke=o,e.$Le=r,e.$Me=s,e.$Ne=i,e.$Oe=O;const P=typeof Buffer<"u",D=new n.$V(()=>new Uint8Array(256));let C,k;class b{static alloc(j){return P?new b(Buffer.allocUnsafe(j)):new b(new Uint8Array(j))}static wrap(j){return P&&!Buffer.isBuffer(j)&&(j=Buffer.from(j.buffer,j.byteOffset,j.byteLength)),new b(j)}static fromString(j,I){return!(I?.dontUseNodeBuffer||!1)&&P?new b(Buffer.from(j)):(C||(C=new TextEncoder),new b(C.encode(j)))}static fromByteArray(j){const I=b.alloc(j.length);for(let B=0,Z=j.length;B<Z;B++)I.buffer[B]=j[B];return I}static concat(j,I){if(typeof I>"u"){I=0;for(let he=0,ae=j.length;he<ae;he++)I+=j[he].byteLength}const B=b.alloc(I);let Z=0;for(let he=0,ae=j.length;he<ae;he++){const ee=j[he];B.set(ee,Z),Z+=ee.byteLength}return B}constructor(j){this.buffer=j,this.byteLength=this.buffer.byteLength}clone(){const j=b.alloc(this.byteLength);return j.set(this),j}toString(){return P?this.buffer.toString():(k||(k=new TextDecoder),k.decode(this.buffer))}slice(j,I){return new b(this.buffer.subarray(j,I))}set(j,I){if(j instanceof b)this.buffer.set(j.buffer,I);else if(j instanceof Uint8Array)this.buffer.set(j,I);else if(j instanceof ArrayBuffer)this.buffer.set(new Uint8Array(j),I);else if(ArrayBuffer.isView(j))this.buffer.set(new Uint8Array(j.buffer,j.byteOffset,j.byteLength),I);else throw new Error("Unknown argument 'array'")}readUInt32BE(j){return w(this.buffer,j)}writeUInt32BE(j,I){g(this.buffer,j,I)}readUInt32LE(j){return d(this.buffer,j)}writeUInt32LE(j,I){c(this.buffer,j,I)}readUInt8(j){return m(this.buffer,j)}writeUInt8(j,I){u(this.buffer,j,I)}indexOf(j,I=0){return $(this.buffer,j instanceof b?j.buffer:j,I)}}e.$ue=b;function $(N,j,I=0){const B=j.byteLength,Z=N.byteLength;if(B===0)return 0;if(B===1)return N.indexOf(j[0]);if(B>Z-I)return-1;const he=D.value;he.fill(j.length);for(let z=0;z<j.length;z++)he[j[z]]=j.length-z-1;let ae=I+j.length-1,ee=ae,_=-1;for(;ae<Z;)if(N[ae]===j[ee]){if(ee===0){_=ae;break}ae--,ee--}else ae+=Math.max(j.length-ee,he[N[ae]]),ee=j.length-1;return _}function E(N,j){return N[j+0]<<0>>>0|N[j+1]<<8>>>0}function y(N,j,I){N[I+0]=j&255,j=j>>>8,N[I+1]=j&255}function w(N,j){return N[j]*2**24+N[j+1]*2**16+N[j+2]*2**8+N[j+3]}function g(N,j,I){N[I+3]=j,j=j>>>8,N[I+2]=j,j=j>>>8,N[I+1]=j,j=j>>>8,N[I]=j}function d(N,j){return N[j+0]<<0>>>0|N[j+1]<<8>>>0|N[j+2]<<16>>>0|N[j+3]<<24>>>0}function c(N,j,I){N[I+0]=j&255,j=j>>>8,N[I+1]=j&255,j=j>>>8,N[I+2]=j&255,j=j>>>8,N[I+3]=j&255}function m(N,j){return N[j]}function u(N,j,I){N[I]=j}function p(N){return A.$je(N,j=>b.concat(j))}function h(N){return A.$qe(N)}function f(N){return A.$le(N,j=>b.concat(j))}async function l(N){return N.ended?b.concat(N.buffer):b.concat([...N.buffer,await f(N.stream)])}function t(N){return A.$oe(N,j=>b.concat(j))}function a(N){return A.$re(N,{data:j=>typeof j=="string"?b.fromString(j):b.wrap(j)},j=>b.concat(j))}function o(N){return A.$ie(j=>b.concat(j),N)}function r(N,j){return A.$se(N,j,I=>b.concat(I))}function s(N,j){return A.$te(N,j,I=>b.concat(I))}function i(N){let j=0,I=0,B=0;const Z=new Uint8Array(Math.floor(N.length/4*3)),he=ee=>{switch(I){case 3:Z[B++]=j|ee,I=0;break;case 2:Z[B++]=j|ee>>>2,j=ee<<6,I=3;break;case 1:Z[B++]=j|ee>>>4,j=ee<<4,I=2;break;default:j=ee<<2,I=1}};for(let ee=0;ee<N.length;ee++){const _=N.charCodeAt(ee);if(_>=65&&_<=90)he(_-65);else if(_>=97&&_<=122)he(_-97+26);else if(_>=48&&_<=57)he(_-48+52);else if(_===43||_===45)he(62);else if(_===47||_===95)he(63);else{if(_===61)break;throw new SyntaxError(`Unexpected base64 character ${N[ee]}`)}}const ae=B;for(;I>0;)he(0);return b.wrap(Z).slice(0,ae)}const v="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function O({buffer:N},j=!0,I=!1){const B=I?S:v;let Z="";const he=N.byteLength%3;let ae=0;for(;ae<N.byteLength-he;ae+=3){const ee=N[ae+0],_=N[ae+1],z=N[ae+2];Z+=B[ee>>>2],Z+=B[(ee<<4|_>>>4)&63],Z+=B[(_<<2|z>>>6)&63],Z+=B[z&63]}if(he===1){const ee=N[ae+0];Z+=B[ee>>>2],Z+=B[ee<<4&63],j&&(Z+="==")}else if(he===2){const ee=N[ae+0],_=N[ae+1];Z+=B[ee>>>2],Z+=B[(ee<<4|_>>>4)&63],Z+=B[_<<2&63],j&&(Z+="=")}return Z}}),define(Ee[17],ke([1,0,153,60]),function(ce,e,n,A){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$Uf=e.$Tf=e.$Sf=e.GraphemeBreakType=e.$If=e.$Bf=e.$uf=e.$tf=void 0,e.$Ue=D,e.$Ve=k,e.$We=$,e.$Xe=E,e.$Ye=y,e.$Ze=w,e.$1e=g,e.$2e=d,e.$3e=c,e.$4e=m,e.$5e=u,e.$6e=p,e.$7e=h,e.$8e=f,e.$9e=l,e.$0e=t,e.$$e=a,e.$_e=o,e.$af=r,e.$bf=s,e.$cf=i,e.$df=v,e.$ef=S,e.$ff=O,e.$gf=N,e.$hf=j,e.$if=I,e.$jf=B,e.$kf=Z,e.$lf=he,e.$mf=ae,e.$nf=ee,e.$of=_,e.$pf=z,e.$qf=T,e.$rf=J,e.$sf=Y,e.$vf=ie,e.$wf=$e,e.$xf=ne,e.$yf=U,e.$zf=X,e.$Af=Q,e.$Cf=x,e.$Df=V,e.$Ef=L,e.$Ff=H,e.$Gf=te,e.$Hf=de,e.$Jf=se,e.$Kf=ge,e.$Lf=we,e.$Mf=Ie,e.$Nf=je,e.$Of=pe,e.$Pf=Pe,e.$Qf=Ce,e.$Rf=xe;function D(me){return!me||typeof me!="string"?!0:me.trim().length===0}const C=/{(\d+)}/g;function k(me,...Se){return Se.length===0?me:me.replace(C,function(Ae,Re){const Te=parseInt(Re,10);return isNaN(Te)||Te<0||Te>=Se.length?Ae:Se[Te]})}const b=/{([^}]+)}/g;function $(me,Se){return Object.keys(Se).length===0?me:me.replace(b,(Ae,Re)=>Se[Re]??Ae)}function E(me){return me.replace(/[<>"'&]/g,Se=>{switch(Se){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return Se})}function y(me){return me.replace(/[<>&]/g,function(Se){switch(Se){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Se}})}function w(me){return me.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function g(me,Se){let Ae=0;const Re=Se.charCodeAt(0);for(let Te=me.length-1;Te>=0;Te--)me.charCodeAt(Te)===Re&&Ae++;return Ae}function d(me,Se,Ae="\u2026"){return me.length<=Se?me:`${me.substr(0,Se)}${Ae}`}function c(me,Se,Ae="\u2026"){if(me.length<=Se)return me;const Re=Math.ceil(Se/2)-Ae.length/2,Te=Math.floor(Se/2)-Ae.length/2;return`${me.substr(0,Re)}${Ae}${me.substr(me.length-Te)}`}function m(me,Se=" "){const Ae=u(me,Se);return p(Ae,Se)}function u(me,Se){if(!me||!Se)return me;const Ae=Se.length;if(Ae===0||me.length===0)return me;let Re=0;for(;me.indexOf(Se,Re)===Re;)Re=Re+Ae;return me.substring(Re)}function p(me,Se){if(!me||!Se)return me;const Ae=Se.length,Re=me.length;if(Ae===0||Re===0)return me;let Te=Re,He=-1;for(;He=me.lastIndexOf(Se,Te-1),!(He===-1||He+Ae!==Te);){if(He===0)return"";Te=He}return me.substring(0,Te)}function h(me){return me.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function f(me){return me.replace(/\*/g,"")}function l(me,Se,Ae={}){if(!me)throw new Error("Cannot create regex from empty string");Se||(me=w(me)),Ae.wholeWord&&(/\B/.test(me.charAt(0))||(me="\\b"+me),/\B/.test(me.charAt(me.length-1))||(me=me+"\\b"));let Re="";return Ae.global&&(Re+="g"),Ae.matchCase||(Re+="i"),Ae.multiline&&(Re+="m"),Ae.unicode&&(Re+="u"),new RegExp(me,Re)}function t(me){return me.source==="^"||me.source==="^$"||me.source==="$"||me.source==="^\\s*$"?!1:!!(me.exec("")&&me.lastIndex===0)}function a(me){return me.split(/\r\n|\r|\n/)}function o(me){const Se=[],Ae=me.split(/(\r\n|\r|\n)/);for(let Re=0;Re<Math.ceil(Ae.length/2);Re++)Se.push(Ae[2*Re]+(Ae[2*Re+1]??""));return Se}function r(me){for(let Se=0,Ae=me.length;Se<Ae;Se++){const Re=me.charCodeAt(Se);if(Re!==32&&Re!==9)return Se}return-1}function s(me,Se=0,Ae=me.length){for(let Re=Se;Re<Ae;Re++){const Te=me.charCodeAt(Re);if(Te!==32&&Te!==9)return me.substring(Se,Re)}return me.substring(Se,Ae)}function i(me,Se=me.length-1){for(let Ae=Se;Ae>=0;Ae--){const Re=me.charCodeAt(Ae);if(Re!==32&&Re!==9)return Ae}return-1}function v(me,Se,Ae){const Re=[];let Te=0;for(const He of me.matchAll(Se)){if(Re.push(me.slice(Te,He.index)),He.index===void 0)throw new Error("match.index should be defined");Te=He.index+He[0].length,Re.push(Ae(He[0],...He.slice(1),He.index,me,He.groups))}return Re.push(me.slice(Te)),Promise.all(Re).then(He=>He.join(""))}function S(me,Se){return me<Se?-1:me>Se?1:0}function O(me,Se,Ae=0,Re=me.length,Te=0,He=Se.length){for(;Ae<Re&&Te<He;Ae++,Te++){const st=me.charCodeAt(Ae),Je=Se.charCodeAt(Te);if(st<Je)return-1;if(st>Je)return 1}const We=Re-Ae,rt=He-Te;return We<rt?-1:We>rt?1:0}function N(me,Se){return j(me,Se,0,me.length,0,Se.length)}function j(me,Se,Ae=0,Re=me.length,Te=0,He=Se.length){for(;Ae<Re&&Te<He;Ae++,Te++){let st=me.charCodeAt(Ae),Je=Se.charCodeAt(Te);if(st===Je)continue;if(st>=128||Je>=128)return O(me.toLowerCase(),Se.toLowerCase(),Ae,Re,Te,He);B(st)&&(st-=32),B(Je)&&(Je-=32);const ct=st-Je;if(ct!==0)return ct}const We=Re-Ae,rt=He-Te;return We<rt?-1:We>rt?1:0}function I(me){return me>=48&&me<=57}function B(me){return me>=97&&me<=122}function Z(me){return me>=65&&me<=90}function he(me,Se){return me.length===Se.length&&j(me,Se)===0}function ae(me,Se){const Ae=Se.length;return Se.length>me.length?!1:j(me,Se,0,Ae)===0}function ee(me,Se){const Ae=Math.min(me.length,Se.length);let Re;for(Re=0;Re<Ae;Re++)if(me.charCodeAt(Re)!==Se.charCodeAt(Re))return Re;return Ae}function _(me,Se){const Ae=Math.min(me.length,Se.length);let Re;const Te=me.length-1,He=Se.length-1;for(Re=0;Re<Ae;Re++)if(me.charCodeAt(Te-Re)!==Se.charCodeAt(He-Re))return Re;return Ae}function z(me){return 55296<=me&&me<=56319}function T(me){return 56320<=me&&me<=57343}function J(me,Se){return(me-55296<<10)+(Se-56320)+65536}function Y(me,Se,Ae){const Re=me.charCodeAt(Ae);if(z(Re)&&Ae+1<Se){const Te=me.charCodeAt(Ae+1);if(T(Te))return J(Re,Te)}return Re}function W(me,Se){const Ae=me.charCodeAt(Se-1);if(T(Ae)&&Se>1){const Re=me.charCodeAt(Se-2);if(z(Re))return J(Re,Ae)}return Ae}class re{get offset(){return this.e}constructor(Se,Ae=0){this.c=Se,this.d=Se.length,this.e=Ae}setOffset(Se){this.e=Se}prevCodePoint(){const Se=W(this.c,this.e);return this.e-=Se>=65536?2:1,Se}nextCodePoint(){const Se=Y(this.c,this.d,this.e);return this.e+=Se>=65536?2:1,Se}eol(){return this.e>=this.d}}e.$tf=re;class ue{get offset(){return this.c.offset}constructor(Se,Ae=0){this.c=new re(Se,Ae)}nextGraphemeLength(){const Se=Ve.getInstance(),Ae=this.c,Re=Ae.offset;let Te=Se.getGraphemeBreakType(Ae.nextCodePoint());for(;!Ae.eol();){const He=Ae.offset,We=Se.getGraphemeBreakType(Ae.nextCodePoint());if(Le(Te,We)){Ae.setOffset(He);break}Te=We}return Ae.offset-Re}prevGraphemeLength(){const Se=Ve.getInstance(),Ae=this.c,Re=Ae.offset;let Te=Se.getGraphemeBreakType(Ae.prevCodePoint());for(;Ae.offset>0;){const He=Ae.offset,We=Se.getGraphemeBreakType(Ae.prevCodePoint());if(Le(We,Te)){Ae.setOffset(He);break}Te=We}return Re-Ae.offset}eol(){return this.c.eol()}}e.$uf=ue;function ie(me,Se){return new ue(me,Se).nextGraphemeLength()}function $e(me,Se){return new ue(me,Se).prevGraphemeLength()}function ne(me,Se){Se>0&&T(me.charCodeAt(Se))&&Se--;const Ae=Se+ie(me,Se);return[Ae-$e(me,Ae),Ae]}function U(me){const Se=new ue(me);let Ae=0;for(;!Se.eol();)Ae++,Se.nextGraphemeLength();return Ae}let R;function q(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function X(me){return R||(R=q()),R.test(me)}const le=/^[\t\n\r\x20-\x7E]*$/;function Q(me){return le.test(me)}e.$Bf=/[\u2028\u2029]/;function x(me){return e.$Bf.test(me)}function V(me){return me>=11904&&me<=55215||me>=63744&&me<=64255||me>=65281&&me<=65374}function L(me){return me>=127462&&me<=127487||me===8986||me===8987||me===9200||me===9203||me>=9728&&me<=10175||me===11088||me===11093||me>=127744&&me<=128591||me>=128640&&me<=128764||me>=128992&&me<=129008||me>=129280&&me<=129535||me>=129648&&me<=129782}function H(me,Se,Ae=""){const Re=me.trimStart();if(Re.length<Se)return Re;const Te=/\b/g;let He=0;for(;Te.test(Re)&&!(Re.length-Te.lastIndex<Se);)He=Te.lastIndex,Te.lastIndex+=1;return He===0?Re:Ae+Re.substring(He).trimStart()}const K=/(:?(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*te(me){let Se=0;for(const Ae of me.matchAll(K))Se!==Ae.index&&(yield{isCode:!1,str:me.substring(Se,Ae.index)}),yield{isCode:!0,str:Ae[0]},Se=Ae.index+Ae[0].length;Se!==me.length&&(yield{isCode:!1,str:me.substring(Se)})}function de(me){return me&&(me=me.replace(K,"")),me}e.$If="\uFEFF";function se(me){return!!(me&&me.length>0&&me.charCodeAt(0)===65279)}function ge(me){return se(me)?me.substr(1):me}function we(me,Se){if(!me||!Se||me.length<Se.length)return!1;const Ae=Se.length,Re=me.toLowerCase();let Te=0,He=-1;for(;Te<Ae;){const We=Re.indexOf(Se[Te],He+1);if(We<0)return!1;He=We,Te++}return!0}function Ie(me,Se=!1){return me?(Se&&(me=me.replace(/\\./g,"")),me.toLowerCase()!==me):!1}function je(me){return me.charAt(0).toUpperCase()+me.slice(1)}function pe(me,Se=1){if(Se===0)return"";let Ae=-1;do Ae=me.indexOf(`
`,Ae+1),Se--;while(Se>0&&Ae>=0);return Ae===-1?me:(me[Ae-1]==="\r"&&Ae--,me.substr(0,Ae))}function Pe(me){return me=me%(2*26),me<26?String.fromCharCode(97+me):String.fromCharCode(65+me-26)}function Ce(me){return Ve.getInstance().getGraphemeBreakType(me)}function Le(me,Se){return me===0?Se!==5&&Se!==7:me===2&&Se===3?!1:me===4||me===2||me===3||Se===4||Se===2||Se===3?!0:!(me===8&&(Se===8||Se===9||Se===11||Se===12)||(me===11||me===9)&&(Se===9||Se===10)||(me===12||me===10)&&Se===10||Se===5||Se===13||Se===7||me===1||me===13&&Se===14||me===6&&Se===6)}var Me;(function(me){me[me.Other=0]="Other",me[me.Prepend=1]="Prepend",me[me.CR=2]="CR",me[me.LF=3]="LF",me[me.Control=4]="Control",me[me.Extend=5]="Extend",me[me.Regional_Indicator=6]="Regional_Indicator",me[me.SpacingMark=7]="SpacingMark",me[me.L=8]="L",me[me.V=9]="V",me[me.T=10]="T",me[me.LV=11]="LV",me[me.LVT=12]="LVT",me[me.ZWJ=13]="ZWJ",me[me.Extended_Pictographic=14]="Extended_Pictographic"})(Me||(e.GraphemeBreakType=Me={}));class Ve{static getInstance(){return Ve.c||(Ve.c=new Ve),Ve.c}constructor(){this.d=qe()}getGraphemeBreakType(Se){if(Se<32)return Se===10?3:Se===13?2:4;if(Se<127)return 0;const Ae=this.d,Re=Ae.length/3;let Te=1;for(;Te<=Re;)if(Se<Ae[3*Te])Te=2*Te;else if(Se>Ae[3*Te+1])Te=2*Te+1;else return Ae[3*Te+2];return 0}}Ve.c=null;function qe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function xe(me,Se){if(me===0)return 0;const Ae=_e(me,Se);if(Ae!==void 0)return Ae;const Re=new re(Se,me);return Re.prevCodePoint(),Re.offset}function _e(me,Se){const Ae=new re(Se,me);let Re=Ae.prevCodePoint();for(;Ke(Re)||Re===65039||Re===8419;){if(Ae.offset===0)return;Re=Ae.prevCodePoint()}if(!L(Re))return;let Te=Ae.offset;return Te>0&&Ae.prevCodePoint()===8205&&(Te=Ae.offset),Te}function Ke(me){return 127995<=me&&me<=127999}var nt;(function(me){me[me.zwj=8205]="zwj",me[me.emojiVariantSelector=65039]="emojiVariantSelector",me[me.enclosingKeyCap=8419]="enclosingKeyCap"})(nt||(nt={})),e.$Sf="\xA0";class Ye{static getInstance(Se){return P.d.get(Array.from(Se))}static getLocales(){return P.e.value}constructor(Se){this.f=Se}isAmbiguous(Se){return this.f.has(Se)}getPrimaryConfusable(Se){return this.f.get(Se)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Tf=Ye,P=Ye,Ye.c=new A.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Ye.d=new n.$Qe(me=>{function Se(Je){const ct=new Map;for(let at=0;at<Je.length;at+=2)ct.set(Je[at],Je[at+1]);return ct}function Ae(Je,ct){const at=new Map(Je);for(const[ft,ut]of ct)at.set(ft,ut);return at}function Re(Je,ct){if(!Je)return ct;const at=new Map;for(const[ft,ut]of Je)ct.has(ft)&&at.set(ft,ut);return at}const Te=P.c.value;let He=me.filter(Je=>!Je.startsWith("_")&&Je in Te);He.length===0&&(He=["_default"]);let We;for(const Je of He){const ct=Se(Te[Je]);We=Re(We,ct)}const rt=Se(Te._common),st=Ae(rt,We);return new P(st)}),Ye.e=new A.$V(()=>Object.keys(P.c.value).filter(me=>!me.startsWith("_")));class Qe{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(Qe.c())),this.d}static isInvisibleCharacter(Se){return Qe.e().has(Se)}static get codePoints(){return Qe.e()}}e.$Uf=Qe,Qe.d=void 0}),define(Ee[154],ke([1,0,24,149,17]),function(ce,e,n,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vk=e.FuzzyScore=e.$kk=e.$jk=void 0,e.or=D,e.$lk=k,e.$mk=b,e.$nk=y,e.$ok=i,e.$pk=v,e.$qk=B,e.$rk=Z,e.$sk=he,e.$tk=ae,e.$uk=q,e.$wk=x,e.$xk=H,e.$yk=K;function D(...se){return function(ge,we){for(let Ie=0,je=se.length;Ie<je;Ie++){const pe=se[Ie](ge,we);if(pe)return pe}return null}}e.$jk=C.bind(void 0,!1),e.$kk=C.bind(void 0,!0);function C(se,ge,we){if(!we||we.length<ge.length)return null;let Ie;return se?Ie=P.$mf(we,ge):Ie=we.indexOf(ge)===0,Ie?ge.length>0?[{start:0,end:ge.length}]:[]:null}function k(se,ge){const we=ge.toLowerCase().indexOf(se.toLowerCase());return we===-1?null:[{start:we,end:we+se.length}]}function b(se,ge){return $(se.toLowerCase(),ge.toLowerCase(),0,0)}function $(se,ge,we,Ie){if(we===se.length)return[];if(Ie===ge.length)return null;if(se[we]===ge[Ie]){let je=null;return(je=$(se,ge,we+1,Ie+1))?f({start:Ie,end:Ie+1},je):null}return $(se,ge,we,Ie+1)}function E(se){return 97<=se&&se<=122}function y(se){return 65<=se&&se<=90}function w(se){return 48<=se&&se<=57}function g(se){return se===32||se===9||se===10||se===13}const d=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(se=>d.add(se.charCodeAt(0)));function c(se){return g(se)||d.has(se)}function m(se,ge){return se===ge||c(se)&&c(ge)}const u=new Map;function p(se){if(u.has(se))return u.get(se);let ge;const we=(0,A.$hk)(se);return we&&(ge=we),u.set(se,ge),ge}function h(se){return E(se)||y(se)||w(se)}function f(se,ge){return ge.length===0?ge=[se]:se.end===ge[0].start?ge[0].start=se.start:ge.unshift(se),ge}function l(se,ge){for(let we=ge;we<se.length;we++){const Ie=se.charCodeAt(we);if(y(Ie)||w(Ie)||we>0&&!h(se.charCodeAt(we-1)))return we}return se.length}function t(se,ge,we,Ie){if(we===se.length)return[];if(Ie===ge.length)return null;if(se[we]!==ge[Ie].toLowerCase())return null;{let je=null,pe=Ie+1;for(je=t(se,ge,we+1,Ie+1);!je&&(pe=l(ge,pe))<ge.length;)je=t(se,ge,we+1,pe),pe++;return je===null?null:f({start:Ie,end:Ie+1},je)}}function a(se){let ge=0,we=0,Ie=0,je=0,pe=0;for(let Ve=0;Ve<se.length;Ve++)pe=se.charCodeAt(Ve),y(pe)&&ge++,E(pe)&&we++,h(pe)&&Ie++,w(pe)&&je++;const Pe=ge/se.length,Ce=we/se.length,Le=Ie/se.length,Me=je/se.length;return{upperPercent:Pe,lowerPercent:Ce,alphaPercent:Le,numericPercent:Me}}function o(se){const{upperPercent:ge,lowerPercent:we}=se;return we===0&&ge>.6}function r(se){const{upperPercent:ge,lowerPercent:we,alphaPercent:Ie,numericPercent:je}=se;return we>.2&&ge<.8&&Ie>.6&&je<.2}function s(se){let ge=0,we=0,Ie=0,je=0;for(let pe=0;pe<se.length;pe++)Ie=se.charCodeAt(pe),y(Ie)&&ge++,E(Ie)&&we++,g(Ie)&&je++;return(ge===0||we===0)&&je===0?se.length<=30:ge<=5}function i(se,ge){if(!ge||(ge=ge.trim(),ge.length===0)||!s(se))return null;ge.length>60&&(ge=ge.substring(0,60));const we=a(ge);if(!r(we)){if(!o(we))return null;ge=ge.toLowerCase()}let Ie=null,je=0;for(se=se.toLowerCase();je<ge.length&&(Ie=t(se,ge,0,je))===null;)je=l(ge,je+1);return Ie}function v(se,ge,we=!1){if(!ge||ge.length===0)return null;let Ie=null,je=0;for(se=se.toLowerCase(),ge=ge.toLowerCase();je<ge.length&&(Ie=S(se,ge,0,je,we),Ie===null);)je=O(ge,je+1);return Ie}function S(se,ge,we,Ie,je){let pe=0;if(we===se.length)return[];if(Ie===ge.length)return null;if(!m(se.charCodeAt(we),ge.charCodeAt(Ie))){const Le=p(se.charCodeAt(we));if(!Le)return null;for(let Me=0;Me<Le.length;Me++)if(!m(Le[Me],ge.charCodeAt(Ie+Me)))return null;pe+=Le.length-1}let Pe=null,Ce=Ie+pe+1;if(Pe=S(se,ge,we+1,Ce,je),!je)for(;!Pe&&(Ce=O(ge,Ce))<ge.length;)Pe=S(se,ge,we+1,Ce,je),Ce++;if(!Pe)return null;if(se.charCodeAt(we)!==ge.charCodeAt(Ie)){const Le=p(se.charCodeAt(we));if(!Le)return Pe;for(let Me=0;Me<Le.length;Me++)if(Le[Me]!==ge.charCodeAt(Ie+Me))return Pe}return f({start:Ie,end:Ie+pe+1},Pe)}function O(se,ge){for(let we=ge;we<se.length;we++)if(c(se.charCodeAt(we))||we>0&&c(se.charCodeAt(we-1)))return we;return se.length}const N=D(e.$kk,i,k),j=D(e.$kk,i,b),I=new n.$Ec(1e4);function B(se,ge,we=!1){if(typeof se!="string"||typeof ge!="string")return null;let Ie=I.get(se);Ie||(Ie=new RegExp(P.$7e(se),"i"),I.set(se,Ie));const je=Ie.exec(ge);return je?[{start:je.index,end:je.index+je[0].length}]:we?j(se,ge):N(se,ge)}function Z(se,ge){const we=x(se,se.toLowerCase(),0,ge,ge.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return we?ae(we):null}function he(se,ge,we,Ie,je,pe){const Pe=Math.min(13,se.length);for(;we<Pe;we++){const Ce=x(se,ge,we,Ie,je,pe,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Ce)return Ce}return[0,pe]}function ae(se){if(typeof se>"u")return[];const ge=[],we=se[1];for(let Ie=se.length-1;Ie>1;Ie--){const je=se[Ie]+we,pe=ge[ge.length-1];pe&&pe.end===je?pe.end=je+1:ge.push({start:je,end:je+1})}return ge}const ee=128;function _(){const se=[],ge=[];for(let we=0;we<=ee;we++)ge[we]=0;for(let we=0;we<=ee;we++)se.push(ge.slice(0));return se}function z(se){const ge=[];for(let we=0;we<=se;we++)ge[we]=0;return ge}const T=z(2*ee),J=z(2*ee),Y=_(),W=_(),re=_(),ue=!1;function ie(se,ge,we,Ie,je){function pe(Ce,Le,Me=" "){for(;Ce.length<Le;)Ce=Me+Ce;return Ce}let Pe=` |   |${Ie.split("").map(Ce=>pe(Ce,3)).join("|")}
`;for(let Ce=0;Ce<=we;Ce++)Ce===0?Pe+=" |":Pe+=`${ge[Ce-1]}|`,Pe+=se[Ce].slice(0,je+1).map(Le=>pe(Le.toString(),3)).join("|")+`
`;return Pe}function $e(se,ge,we,Ie){se=se.substr(ge),we=we.substr(Ie),console.log(ie(W,se,se.length,we,we.length)),console.log(ie(re,se,se.length,we,we.length)),console.log(ie(Y,se,se.length,we,we.length))}function ne(se,ge){if(ge<0||ge>=se.length)return!1;const we=se.codePointAt(ge);switch(we){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!P.$Ef(we)}}function U(se,ge){if(ge<0||ge>=se.length)return!1;switch(se.charCodeAt(ge)){case 32:case 9:return!0;default:return!1}}function R(se,ge,we){return ge[se]!==we[se]}function q(se,ge,we,Ie,je,pe,Pe=!1){for(;ge<we&&je<pe;)se[ge]===Ie[je]&&(Pe&&(T[ge]=je),ge+=1),je+=1;return ge===we}var X;(function(se){se[se.Diag=1]="Diag",se[se.Left=2]="Left",se[se.LeftLeft=3]="LeftLeft"})(X||(X={}));var le;(function(se){se.Default=[-100,0];function ge(we){return!we||we.length===2&&we[0]===-100&&we[1]===0}se.isDefault=ge})(le||(e.FuzzyScore=le={}));class Q{constructor(ge,we){this.firstMatchCanBeWeak=ge,this.boostFullMatch=we}}e.$vk=Q,Q.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function x(se,ge,we,Ie,je,pe,Pe=Q.default){const Ce=se.length>ee?ee:se.length,Le=Ie.length>ee?ee:Ie.length;if(we>=Ce||pe>=Le||Ce-we>Le-pe||!q(ge,we,Ce,je,pe,Le,!0))return;V(Ce,Le,we,pe,ge,je);let Me=1,Ve=1,qe=we,xe=pe;const _e=[!1];for(Me=1,qe=we;qe<Ce;Me++,qe++){const me=T[qe],Se=J[qe],Ae=qe+1<Ce?J[qe+1]:Le;for(Ve=me-pe+1,xe=me;xe<Ae;Ve++,xe++){let Re=Number.MIN_SAFE_INTEGER,Te=!1;xe<=Se&&(Re=L(se,ge,qe,we,Ie,je,xe,Le,pe,Y[Me-1][Ve-1]===0,_e));let He=0;Re!==Number.MAX_SAFE_INTEGER&&(Te=!0,He=Re+W[Me-1][Ve-1]);const We=xe>me,rt=We?W[Me][Ve-1]+(Y[Me][Ve-1]>0?-5:0):0,st=xe>me+1&&Y[Me][Ve-1]>0,Je=st?W[Me][Ve-2]+(Y[Me][Ve-2]>0?-5:0):0;if(st&&(!We||Je>=rt)&&(!Te||Je>=He))W[Me][Ve]=Je,re[Me][Ve]=3,Y[Me][Ve]=0;else if(We&&(!Te||rt>=He))W[Me][Ve]=rt,re[Me][Ve]=2,Y[Me][Ve]=0;else if(Te)W[Me][Ve]=He,re[Me][Ve]=1,Y[Me][Ve]=Y[Me-1][Ve-1]+1;else throw new Error("not possible")}}if(ue&&$e(se,we,Ie,pe),!_e[0]&&!Pe.firstMatchCanBeWeak)return;Me--,Ve--;const Ke=[W[Me][Ve],pe];let nt=0,Ye=0;for(;Me>=1;){let me=Ve;do{const Se=re[Me][me];if(Se===3)me=me-2;else if(Se===2)me=me-1;else break}while(me>=1);nt>1&&ge[we+Me-1]===je[pe+Ve-1]&&!R(me+pe-1,Ie,je)&&nt+1>Y[Me][me]&&(me=Ve),me===Ve?nt++:nt=1,Ye||(Ye=me),Me--,Ve=me-1,Ke.push(Ve)}Le===Ce&&Pe.boostFullMatch&&(Ke[0]+=2);const Qe=Ye-Ce;return Ke[0]-=Qe,Ke}function V(se,ge,we,Ie,je,pe){let Pe=se-1,Ce=ge-1;for(;Pe>=we&&Ce>=Ie;)je[Pe]===pe[Ce]&&(J[Pe]=Ce,Pe--),Ce--}function L(se,ge,we,Ie,je,pe,Pe,Ce,Le,Me,Ve){if(ge[we]!==pe[Pe])return Number.MIN_SAFE_INTEGER;let qe=1,xe=!1;return Pe===we-Ie?qe=se[we]===je[Pe]?7:5:R(Pe,je,pe)&&(Pe===0||!R(Pe-1,je,pe))?(qe=se[we]===je[Pe]?7:5,xe=!0):ne(pe,Pe)&&(Pe===0||!ne(pe,Pe-1))?qe=5:(ne(pe,Pe-1)||U(pe,Pe-1))&&(qe=5,xe=!0),qe>1&&we===Ie&&(Ve[0]=!0),xe||(xe=R(Pe,je,pe)||ne(pe,Pe-1)||U(pe,Pe-1)),we===Ie?Pe>Le&&(qe-=xe?3:5):Me?qe+=xe?2:0:qe+=xe?0:1,Pe+1===Ce&&(qe-=xe?3:5),qe}function H(se,ge,we,Ie,je,pe,Pe){return te(se,ge,we,Ie,je,pe,!0,Pe)}function K(se,ge,we,Ie,je,pe,Pe){return te(se,ge,we,Ie,je,pe,!1,Pe)}function te(se,ge,we,Ie,je,pe,Pe,Ce){let Le=x(se,ge,we,Ie,je,pe,Ce);if(Le&&!Pe)return Le;if(se.length>=3){const Me=Math.min(7,se.length-1);for(let Ve=we+1;Ve<Me;Ve++){const qe=de(se,Ve);if(qe){const xe=x(qe,qe.toLowerCase(),we,Ie,je,pe,Ce);xe&&(xe[0]-=3,(!Le||xe[0]>Le[0])&&(Le=xe))}}}return Le}function de(se,ge){if(ge+1>=se.length)return;const we=se[ge],Ie=se[ge+1];if(we!==Ie)return se.slice(0,ge)+Ie+we+se.slice(ge+2)}}),define(Ee[64],ke([1,0,17]),function(ce,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cj=e.$aj=void 0,e.$9i=A,e.$0i=P,e.$$i=D,e.$_i=k,e.$bj=c;function A(u){return P(u,0)}function P(u,p){switch(typeof u){case"object":return u===null?D(349,p):Array.isArray(u)?b(u,p):$(u,p);case"string":return k(u,p);case"boolean":return C(u,p);case"number":return D(u,p);case"undefined":return D(937,p);default:return D(617,p)}}function D(u,p){return(p<<5)-p+u|0}function C(u,p){return D(u?433:863,p)}function k(u,p){p=D(149417,p);for(let h=0,f=u.length;h<f;h++)p=D(u.charCodeAt(h),p);return p}function b(u,p){return p=D(104579,p),u.reduce((h,f)=>P(f,h),p)}function $(u,p){return p=D(181387,p),Object.keys(u).sort().reduce((h,f)=>(h=k(f,h),P(u[f],h)),p)}class E{constructor(){this.g=0}get value(){return this.g}hash(p){return this.g=P(p,this.g),this.g}}e.$aj=E;var y;(function(u){u[u.BLOCK_SIZE=64]="BLOCK_SIZE",u[u.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(y||(y={}));function w(u,p,h=32){const f=h-p,l=~((1<<f)-1);return(u<<p|(l&u)>>>f)>>>0}function g(u,p=0,h=u.byteLength,f=0){for(let l=0;l<h;l++)u[p+l]=f}function d(u,p,h="0"){for(;u.length<p;)u=h+u;return u}function c(u,p=32){return u instanceof ArrayBuffer?Array.from(new Uint8Array(u)).map(h=>h.toString(16).padStart(2,"0")).join(""):d((u>>>0).toString(16),p/4)}class m{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(p){const h=p.length;if(h===0)return;const f=this.p;let l=this.r,t=this.u,a,o;for(t!==0?(a=t,o=-1,t=0):(a=p.charCodeAt(0),o=0);;){let r=a;if(n.$pf(a))if(o+1<h){const s=p.charCodeAt(o+1);n.$qf(s)?(o++,r=n.$rf(a,s)):r=65533}else{t=a;break}else n.$qf(a)&&(r=65533);if(l=this.w(f,l,r),o++,o<h)a=p.charCodeAt(o);else break}this.r=l,this.u=t}w(p,h,f){return f<128?p[h++]=f:f<2048?(p[h++]=192|(f&1984)>>>6,p[h++]=128|(f&63)>>>0):f<65536?(p[h++]=224|(f&61440)>>>12,p[h++]=128|(f&4032)>>>6,p[h++]=128|(f&63)>>>0):(p[h++]=240|(f&1835008)>>>18,p[h++]=128|(f&258048)>>>12,p[h++]=128|(f&4032)>>>6,p[h++]=128|(f&63)>>>0),h>=64&&(this.y(),h-=64,this.t+=64,p[0]=p[64],p[1]=p[65],p[2]=p[66]),h}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),c(this.h)+c(this.l)+c(this.m)+c(this.n)+c(this.o)}x(){this.p[this.r++]=128,g(this.p,this.r),this.r>56&&(this.y(),g(this.p));const p=8*this.t;this.q.setUint32(56,Math.floor(p/4294967296),!1),this.q.setUint32(60,p%4294967296,!1),this.y()}y(){const p=m.g,h=this.q;for(let v=0;v<64;v+=4)p.setUint32(v,h.getUint32(v,!1),!1);for(let v=64;v<320;v+=4)p.setUint32(v,w(p.getUint32(v-12,!1)^p.getUint32(v-32,!1)^p.getUint32(v-56,!1)^p.getUint32(v-64,!1),1),!1);let f=this.h,l=this.l,t=this.m,a=this.n,o=this.o,r,s,i;for(let v=0;v<80;v++)v<20?(r=l&t|~l&a,s=1518500249):v<40?(r=l^t^a,s=1859775393):v<60?(r=l&t|l&a|t&a,s=2400959708):(r=l^t^a,s=3395469782),i=w(f,5)+r+o+s+p.getUint32(v*4,!1)&4294967295,o=a,a=t,t=w(l,30),l=f,f=i;this.h=this.h+f&4294967295,this.l=this.l+l&4294967295,this.m=this.m+t&4294967295,this.n=this.n+a&4294967295,this.o=this.o+o&4294967295}}e.$cj=m,m.g=new DataView(new ArrayBuffer(320))}),define(Ee[65],ke([1,0,17]),function(ce,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var A;(function(P){P[P.Ignore=0]="Ignore",P[P.Info=1]="Info",P[P.Warning=2]="Warning",P[P.Error=3]="Error"})(A||(A={})),function(P){const D="error",C="warning",k="warn",b="info",$="ignore";function E(w){return w?n.$lf(D,w)?P.Error:n.$lf(C,w)||n.$lf(k,w)?P.Warning:n.$lf(b,w)?P.Info:P.Ignore:P.Ignore}P.fromValue=E;function y(w){switch(w){case P.Error:return D;case P.Warning:return C;case P.Info:return b;default:return $}}P.toString=y}(A||(A={})),e.default=A}),define(Ee[155],ke([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4d=void 0,e.$4d=Symbol("MicrotaskDelay")}),define(Ee[66],ke([1,0,18,17]),function(ce,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=e.$ni=e.$mi=e.$li=e.$ki=void 0;class P{constructor(){this.b="",this.c=0}reset(g){return this.b=g,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(g){const d=g.charCodeAt(0),c=this.b.charCodeAt(this.c);return d-c}value(){return this.b[this.c]}}e.$ki=P;class D{constructor(g=!0){this.e=g}reset(g){return this.b=g,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let g=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(g)this.c++;else break;else g=!1;return this}cmp(g){return this.e?(0,A.$ff)(g,this.b,0,g.length,this.c,this.d):(0,A.$hf)(g,this.b,0,g.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$li=D;class C{constructor(g=!0,d=!0){this.f=g,this.g=d}reset(g){this.d=0,this.e=0,this.b=g,this.c=g.length;for(let d=g.length-1;d>=0;d--,this.c--){const c=this.b.charCodeAt(d);if(!(c===47||this.f&&c===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let g=!0;for(;this.e<this.c;this.e++){const d=this.b.charCodeAt(this.e);if(d===47||this.f&&d===92)if(g)this.d++;else break;else g=!1}return this}cmp(g){return this.g?(0,A.$ff)(g,this.b,0,g.length,this.d,this.e):(0,A.$hf)(g,this.b,0,g.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$mi=C;var k;(function(w){w[w.Scheme=1]="Scheme",w[w.Authority=2]="Authority",w[w.Path=3]="Path",w[w.Query=4]="Query",w[w.Fragment=5]="Fragment"})(k||(k={}));class b{constructor(g,d){this.f=g,this.g=d,this.d=[],this.e=0}reset(g){return this.c=g,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new C(!1,!this.f(g)),this.b.reset(g.path),this.b.value()&&this.d.push(3)),this.g(g)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(g){if(this.d[this.e]===1)return(0,A.$gf)(g,this.c.scheme);if(this.d[this.e]===2)return(0,A.$gf)(g,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(g);if(this.d[this.e]===4)return(0,A.$ef)(g,this.c.query);if(this.d[this.e]===5)return(0,A.$ef)(g,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$ni=b;class ${constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const g=this.right;return this.right=g.left,g.left=this,this.updateHeight(),g.updateHeight(),g}rotateRight(){const g=this.left;return this.left=g.right,g.right=this,this.updateHeight(),g.updateHeight(),g}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var E;(function(w){w[w.Left=-1]="Left",w[w.Mid=0]="Mid",w[w.Right=1]="Right"})(E||(E={}));class y{static forUris(g=()=>!1,d=()=>!1){return new y(new b(g,d))}static forPaths(g=!1){return new y(new C(void 0,!g))}static forStrings(){return new y(new P)}static forConfigKeys(){return new y(new D)}constructor(g){this.b=g}clear(){this.c=void 0}fill(g,d){if(d){const c=d.slice(0);(0,n.$Xb)(c);for(const m of c)this.set(m,g)}else{const c=g.slice(0);(0,n.$Xb)(c);for(const m of c)this.set(m[0],m[1])}}set(g,d){const c=this.b.reset(g);let m;this.c||(this.c=new $,this.c.segment=c.value());const u=[];for(m=this.c;;){const h=c.cmp(m.segment);if(h>0)m.left||(m.left=new $,m.left.segment=c.value()),u.push([-1,m]),m=m.left;else if(h<0)m.right||(m.right=new $,m.right.segment=c.value()),u.push([1,m]),m=m.right;else if(c.hasNext())c.next(),m.mid||(m.mid=new $,m.mid.segment=c.value()),u.push([0,m]),m=m.mid;else break}const p=m.value;m.value=d,m.key=g;for(let h=u.length-1;h>=0;h--){const f=u[h][1];f.updateHeight();const l=f.balanceFactor();if(l<-1||l>1){const t=u[h][0],a=u[h+1][0];if(t===1&&a===1)u[h][1]=f.rotateLeft();else if(t===-1&&a===-1)u[h][1]=f.rotateRight();else if(t===1&&a===-1)f.right=u[h+1][1]=u[h+1][1].rotateRight(),u[h][1]=f.rotateLeft();else if(t===-1&&a===1)f.left=u[h+1][1]=u[h+1][1].rotateLeft(),u[h][1]=f.rotateRight();else throw new Error;if(h>0)switch(u[h-1][0]){case-1:u[h-1][1].left=u[h][1];break;case 1:u[h-1][1].right=u[h][1];break;case 0:u[h-1][1].mid=u[h][1];break}else this.c=u[0][1]}}return p}get(g){return this.d(g)?.value}d(g){const d=this.b.reset(g);let c=this.c;for(;c;){const m=d.cmp(c.segment);if(m>0)c=c.left;else if(m<0)c=c.right;else if(d.hasNext())d.next(),c=c.mid;else break}return c}has(g){const d=this.d(g);return!(d?.value===void 0&&d?.mid===void 0)}delete(g){return this.e(g,!1)}deleteSuperstr(g){return this.e(g,!0)}e(g,d){const c=this.b.reset(g),m=[];let u=this.c;for(;u;){const p=c.cmp(u.segment);if(p>0)m.push([-1,u]),u=u.left;else if(p<0)m.push([1,u]),u=u.right;else if(c.hasNext())c.next(),m.push([0,u]),u=u.mid;else break}if(u){if(d?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const p=this.f(u.right);if(p.key){const{key:h,value:f,segment:l}=p;this.e(p.key,!1),u.key=h,u.value=f,u.segment=l}}else{const p=u.left??u.right;if(m.length>0){const[h,f]=m[m.length-1];switch(h){case-1:f.left=p;break;case 0:f.mid=p;break;case 1:f.right=p;break}}else this.c=p}for(let p=m.length-1;p>=0;p--){const h=m[p][1];h.updateHeight();const f=h.balanceFactor();if(f>1?(h.right.balanceFactor()>=0||(h.right=h.right.rotateRight()),m[p][1]=h.rotateLeft()):f<-1&&(h.left.balanceFactor()<=0||(h.left=h.left.rotateLeft()),m[p][1]=h.rotateRight()),p>0)switch(m[p-1][0]){case-1:m[p-1][1].left=m[p][1];break;case 1:m[p-1][1].right=m[p][1];break;case 0:m[p-1][1].mid=m[p][1];break}else this.c=m[0][1]}}}f(g){for(;g.left;)g=g.left;return g}findSubstr(g){const d=this.b.reset(g);let c=this.c,m;for(;c;){const u=d.cmp(c.segment);if(u>0)c=c.left;else if(u<0)c=c.right;else if(d.hasNext())d.next(),m=c.value||m,c=c.mid;else break}return c&&c.value||m}findSuperstr(g){return this.g(g,!1)}g(g,d){const c=this.b.reset(g);let m=this.c;for(;m;){const u=c.cmp(m.segment);if(u>0)m=m.left;else if(u<0)m=m.right;else if(c.hasNext())c.next(),m=m.mid;else return m.mid?this.h(m.mid):d?m.value:void 0}}hasElementOrSubtree(g){return this.g(g,!0)!==void 0}forEach(g){for(const[d,c]of this)g(c,d)}*[Symbol.iterator](){yield*this.h(this.c)}h(g){const d=[];return this.j(g,d),d[Symbol.iterator]()}j(g,d){g&&(g.left&&this.j(g.left,d),g.value&&d.push([g.key,g.value]),g.mid&&this.j(g.mid,d),g.right&&this.j(g.right,d))}_isBalanced(){const g=d=>{if(!d)return!0;const c=d.balanceFactor();return c<-1||c>1?!1:g(d.left)&&g(d.right)};return g(this.c)}}e.$oi=y}),define(Ee[11],ke([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vf=n,e.$Wf=A,e.$Xf=P,e.$Yf=D,e.$Zf=C,e.$1f=k,e.$2f=b,e.$3f=$,e.$4f=E,e.$5f=y,e.$6f=w,e.$7f=g,e.$8f=d,e.$9f=m,e.$0f=u,e.$$f=p,e.$_f=h,e.$ag=f;function n(l){return typeof l=="string"}function A(l){return Array.isArray(l)&&l.every(t=>n(t))}function P(l){return typeof l=="object"&&l!==null&&!Array.isArray(l)&&!(l instanceof RegExp)&&!(l instanceof Date)}function D(l){const t=Object.getPrototypeOf(Uint8Array);return typeof l=="object"&&l instanceof t}function C(l){return typeof l=="number"&&!isNaN(l)}function k(l){return!!l&&typeof l[Symbol.iterator]=="function"}function b(l){return l===!0||l===!1}function $(l){return typeof l>"u"}function E(l){return!y(l)}function y(l){return $(l)||l===null}function w(l,t){if(!l)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function g(l){if(y(l))throw new Error("Assertion Failed: argument is undefined or null");return l}function d(...l){const t=[];for(let a=0;a<l.length;a++){const o=l[a];if(y(o))throw new Error(`Assertion Failed: argument at index ${a} is undefined or null`);t.push(o)}return t}const c=Object.prototype.hasOwnProperty;function m(l){if(!P(l))return!1;for(const t in l)if(c.call(l,t))return!1;return!0}function u(l){return typeof l=="function"}function p(...l){return l.length>0&&l.every(u)}function h(l,t){const a=Math.min(l.length,t.length);for(let o=0;o<a;o++)f(l[o],t[o])}function f(l,t){if(n(t)){if(typeof l!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(u(t)){try{if(l instanceof t)return}catch{}if(!y(l)&&l.constructor===t||t.length===1&&t.call(void 0,l)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(Ee[100],ke([1,0,11]),function(ce,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cj=P,e.$Dj=D;const A=Object.create(null);function P(C,k){if((0,n.$Vf)(k)){const b=A[k];if(b===void 0)throw new Error(`${C} references an unknown codicon: ${k}`);k=b}return A[C]=k,{id:C}}function D(){return A}}),define(Ee[156],ke([1,0,100]),function(ce,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ej=void 0,e.$Ej={add:(0,n.$Cj)("add",6e4),plus:(0,n.$Cj)("plus",6e4),gistNew:(0,n.$Cj)("gist-new",6e4),repoCreate:(0,n.$Cj)("repo-create",6e4),lightbulb:(0,n.$Cj)("lightbulb",60001),lightBulb:(0,n.$Cj)("light-bulb",60001),repo:(0,n.$Cj)("repo",60002),repoDelete:(0,n.$Cj)("repo-delete",60002),gistFork:(0,n.$Cj)("gist-fork",60003),repoForked:(0,n.$Cj)("repo-forked",60003),gitPullRequest:(0,n.$Cj)("git-pull-request",60004),gitPullRequestAbandoned:(0,n.$Cj)("git-pull-request-abandoned",60004),recordKeys:(0,n.$Cj)("record-keys",60005),keyboard:(0,n.$Cj)("keyboard",60005),tag:(0,n.$Cj)("tag",60006),gitPullRequestLabel:(0,n.$Cj)("git-pull-request-label",60006),tagAdd:(0,n.$Cj)("tag-add",60006),tagRemove:(0,n.$Cj)("tag-remove",60006),person:(0,n.$Cj)("person",60007),personFollow:(0,n.$Cj)("person-follow",60007),personOutline:(0,n.$Cj)("person-outline",60007),personFilled:(0,n.$Cj)("person-filled",60007),gitBranch:(0,n.$Cj)("git-branch",60008),gitBranchCreate:(0,n.$Cj)("git-branch-create",60008),gitBranchDelete:(0,n.$Cj)("git-branch-delete",60008),sourceControl:(0,n.$Cj)("source-control",60008),mirror:(0,n.$Cj)("mirror",60009),mirrorPublic:(0,n.$Cj)("mirror-public",60009),star:(0,n.$Cj)("star",60010),starAdd:(0,n.$Cj)("star-add",60010),starDelete:(0,n.$Cj)("star-delete",60010),starEmpty:(0,n.$Cj)("star-empty",60010),comment:(0,n.$Cj)("comment",60011),commentAdd:(0,n.$Cj)("comment-add",60011),alert:(0,n.$Cj)("alert",60012),warning:(0,n.$Cj)("warning",60012),search:(0,n.$Cj)("search",60013),searchSave:(0,n.$Cj)("search-save",60013),logOut:(0,n.$Cj)("log-out",60014),signOut:(0,n.$Cj)("sign-out",60014),logIn:(0,n.$Cj)("log-in",60015),signIn:(0,n.$Cj)("sign-in",60015),eye:(0,n.$Cj)("eye",60016),eyeUnwatch:(0,n.$Cj)("eye-unwatch",60016),eyeWatch:(0,n.$Cj)("eye-watch",60016),circleFilled:(0,n.$Cj)("circle-filled",60017),primitiveDot:(0,n.$Cj)("primitive-dot",60017),closeDirty:(0,n.$Cj)("close-dirty",60017),debugBreakpoint:(0,n.$Cj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,n.$Cj)("debug-breakpoint-disabled",60017),debugHint:(0,n.$Cj)("debug-hint",60017),terminalDecorationSuccess:(0,n.$Cj)("terminal-decoration-success",60017),primitiveSquare:(0,n.$Cj)("primitive-square",60018),edit:(0,n.$Cj)("edit",60019),pencil:(0,n.$Cj)("pencil",60019),info:(0,n.$Cj)("info",60020),issueOpened:(0,n.$Cj)("issue-opened",60020),gistPrivate:(0,n.$Cj)("gist-private",60021),gitForkPrivate:(0,n.$Cj)("git-fork-private",60021),lock:(0,n.$Cj)("lock",60021),mirrorPrivate:(0,n.$Cj)("mirror-private",60021),close:(0,n.$Cj)("close",60022),removeClose:(0,n.$Cj)("remove-close",60022),x:(0,n.$Cj)("x",60022),repoSync:(0,n.$Cj)("repo-sync",60023),sync:(0,n.$Cj)("sync",60023),clone:(0,n.$Cj)("clone",60024),desktopDownload:(0,n.$Cj)("desktop-download",60024),beaker:(0,n.$Cj)("beaker",60025),microscope:(0,n.$Cj)("microscope",60025),vm:(0,n.$Cj)("vm",60026),deviceDesktop:(0,n.$Cj)("device-desktop",60026),file:(0,n.$Cj)("file",60027),fileText:(0,n.$Cj)("file-text",60027),more:(0,n.$Cj)("more",60028),ellipsis:(0,n.$Cj)("ellipsis",60028),kebabHorizontal:(0,n.$Cj)("kebab-horizontal",60028),mailReply:(0,n.$Cj)("mail-reply",60029),reply:(0,n.$Cj)("reply",60029),organization:(0,n.$Cj)("organization",60030),organizationFilled:(0,n.$Cj)("organization-filled",60030),organizationOutline:(0,n.$Cj)("organization-outline",60030),newFile:(0,n.$Cj)("new-file",60031),fileAdd:(0,n.$Cj)("file-add",60031),newFolder:(0,n.$Cj)("new-folder",60032),fileDirectoryCreate:(0,n.$Cj)("file-directory-create",60032),trash:(0,n.$Cj)("trash",60033),trashcan:(0,n.$Cj)("trashcan",60033),history:(0,n.$Cj)("history",60034),clock:(0,n.$Cj)("clock",60034),folder:(0,n.$Cj)("folder",60035),fileDirectory:(0,n.$Cj)("file-directory",60035),symbolFolder:(0,n.$Cj)("symbol-folder",60035),logoGithub:(0,n.$Cj)("logo-github",60036),markGithub:(0,n.$Cj)("mark-github",60036),github:(0,n.$Cj)("github",60036),terminal:(0,n.$Cj)("terminal",60037),console:(0,n.$Cj)("console",60037),repl:(0,n.$Cj)("repl",60037),zap:(0,n.$Cj)("zap",60038),symbolEvent:(0,n.$Cj)("symbol-event",60038),error:(0,n.$Cj)("error",60039),stop:(0,n.$Cj)("stop",60039),variable:(0,n.$Cj)("variable",60040),symbolVariable:(0,n.$Cj)("symbol-variable",60040),array:(0,n.$Cj)("array",60042),symbolArray:(0,n.$Cj)("symbol-array",60042),symbolModule:(0,n.$Cj)("symbol-module",60043),symbolPackage:(0,n.$Cj)("symbol-package",60043),symbolNamespace:(0,n.$Cj)("symbol-namespace",60043),symbolObject:(0,n.$Cj)("symbol-object",60043),symbolMethod:(0,n.$Cj)("symbol-method",60044),symbolFunction:(0,n.$Cj)("symbol-function",60044),symbolConstructor:(0,n.$Cj)("symbol-constructor",60044),symbolBoolean:(0,n.$Cj)("symbol-boolean",60047),symbolNull:(0,n.$Cj)("symbol-null",60047),symbolNumeric:(0,n.$Cj)("symbol-numeric",60048),symbolNumber:(0,n.$Cj)("symbol-number",60048),symbolStructure:(0,n.$Cj)("symbol-structure",60049),symbolStruct:(0,n.$Cj)("symbol-struct",60049),symbolParameter:(0,n.$Cj)("symbol-parameter",60050),symbolTypeParameter:(0,n.$Cj)("symbol-type-parameter",60050),symbolKey:(0,n.$Cj)("symbol-key",60051),symbolText:(0,n.$Cj)("symbol-text",60051),symbolReference:(0,n.$Cj)("symbol-reference",60052),goToFile:(0,n.$Cj)("go-to-file",60052),symbolEnum:(0,n.$Cj)("symbol-enum",60053),symbolValue:(0,n.$Cj)("symbol-value",60053),symbolRuler:(0,n.$Cj)("symbol-ruler",60054),symbolUnit:(0,n.$Cj)("symbol-unit",60054),activateBreakpoints:(0,n.$Cj)("activate-breakpoints",60055),archive:(0,n.$Cj)("archive",60056),arrowBoth:(0,n.$Cj)("arrow-both",60057),arrowDown:(0,n.$Cj)("arrow-down",60058),arrowLeft:(0,n.$Cj)("arrow-left",60059),arrowRight:(0,n.$Cj)("arrow-right",60060),arrowSmallDown:(0,n.$Cj)("arrow-small-down",60061),arrowSmallLeft:(0,n.$Cj)("arrow-small-left",60062),arrowSmallRight:(0,n.$Cj)("arrow-small-right",60063),arrowSmallUp:(0,n.$Cj)("arrow-small-up",60064),arrowUp:(0,n.$Cj)("arrow-up",60065),bell:(0,n.$Cj)("bell",60066),bold:(0,n.$Cj)("bold",60067),book:(0,n.$Cj)("book",60068),bookmark:(0,n.$Cj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,n.$Cj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,n.$Cj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,n.$Cj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,n.$Cj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,n.$Cj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,n.$Cj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,n.$Cj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,n.$Cj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,n.$Cj)("debug-breakpoint-log-disabled",60075),briefcase:(0,n.$Cj)("briefcase",60076),broadcast:(0,n.$Cj)("broadcast",60077),browser:(0,n.$Cj)("browser",60078),bug:(0,n.$Cj)("bug",60079),calendar:(0,n.$Cj)("calendar",60080),caseSensitive:(0,n.$Cj)("case-sensitive",60081),check:(0,n.$Cj)("check",60082),checklist:(0,n.$Cj)("checklist",60083),chevronDown:(0,n.$Cj)("chevron-down",60084),chevronLeft:(0,n.$Cj)("chevron-left",60085),chevronRight:(0,n.$Cj)("chevron-right",60086),chevronUp:(0,n.$Cj)("chevron-up",60087),chromeClose:(0,n.$Cj)("chrome-close",60088),chromeMaximize:(0,n.$Cj)("chrome-maximize",60089),chromeMinimize:(0,n.$Cj)("chrome-minimize",60090),chromeRestore:(0,n.$Cj)("chrome-restore",60091),circleOutline:(0,n.$Cj)("circle-outline",60092),circle:(0,n.$Cj)("circle",60092),debugBreakpointUnverified:(0,n.$Cj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,n.$Cj)("terminal-decoration-incomplete",60092),circleSlash:(0,n.$Cj)("circle-slash",60093),circuitBoard:(0,n.$Cj)("circuit-board",60094),clearAll:(0,n.$Cj)("clear-all",60095),clippy:(0,n.$Cj)("clippy",60096),closeAll:(0,n.$Cj)("close-all",60097),cloudDownload:(0,n.$Cj)("cloud-download",60098),cloudUpload:(0,n.$Cj)("cloud-upload",60099),code:(0,n.$Cj)("code",60100),collapseAll:(0,n.$Cj)("collapse-all",60101),colorMode:(0,n.$Cj)("color-mode",60102),commentDiscussion:(0,n.$Cj)("comment-discussion",60103),creditCard:(0,n.$Cj)("credit-card",60105),dash:(0,n.$Cj)("dash",60108),dashboard:(0,n.$Cj)("dashboard",60109),database:(0,n.$Cj)("database",60110),debugContinue:(0,n.$Cj)("debug-continue",60111),debugDisconnect:(0,n.$Cj)("debug-disconnect",60112),debugPause:(0,n.$Cj)("debug-pause",60113),debugRestart:(0,n.$Cj)("debug-restart",60114),debugStart:(0,n.$Cj)("debug-start",60115),debugStepInto:(0,n.$Cj)("debug-step-into",60116),debugStepOut:(0,n.$Cj)("debug-step-out",60117),debugStepOver:(0,n.$Cj)("debug-step-over",60118),debugStop:(0,n.$Cj)("debug-stop",60119),debug:(0,n.$Cj)("debug",60120),deviceCameraVideo:(0,n.$Cj)("device-camera-video",60121),deviceCamera:(0,n.$Cj)("device-camera",60122),deviceMobile:(0,n.$Cj)("device-mobile",60123),diffAdded:(0,n.$Cj)("diff-added",60124),diffIgnored:(0,n.$Cj)("diff-ignored",60125),diffModified:(0,n.$Cj)("diff-modified",60126),diffRemoved:(0,n.$Cj)("diff-removed",60127),diffRenamed:(0,n.$Cj)("diff-renamed",60128),diff:(0,n.$Cj)("diff",60129),diffSidebyside:(0,n.$Cj)("diff-sidebyside",60129),discard:(0,n.$Cj)("discard",60130),editorLayout:(0,n.$Cj)("editor-layout",60131),emptyWindow:(0,n.$Cj)("empty-window",60132),exclude:(0,n.$Cj)("exclude",60133),extensions:(0,n.$Cj)("extensions",60134),eyeClosed:(0,n.$Cj)("eye-closed",60135),fileBinary:(0,n.$Cj)("file-binary",60136),fileCode:(0,n.$Cj)("file-code",60137),fileMedia:(0,n.$Cj)("file-media",60138),filePdf:(0,n.$Cj)("file-pdf",60139),fileSubmodule:(0,n.$Cj)("file-submodule",60140),fileSymlinkDirectory:(0,n.$Cj)("file-symlink-directory",60141),fileSymlinkFile:(0,n.$Cj)("file-symlink-file",60142),fileZip:(0,n.$Cj)("file-zip",60143),files:(0,n.$Cj)("files",60144),filter:(0,n.$Cj)("filter",60145),flame:(0,n.$Cj)("flame",60146),foldDown:(0,n.$Cj)("fold-down",60147),foldUp:(0,n.$Cj)("fold-up",60148),fold:(0,n.$Cj)("fold",60149),folderActive:(0,n.$Cj)("folder-active",60150),folderOpened:(0,n.$Cj)("folder-opened",60151),gear:(0,n.$Cj)("gear",60152),gift:(0,n.$Cj)("gift",60153),gistSecret:(0,n.$Cj)("gist-secret",60154),gist:(0,n.$Cj)("gist",60155),gitCommit:(0,n.$Cj)("git-commit",60156),gitCompare:(0,n.$Cj)("git-compare",60157),compareChanges:(0,n.$Cj)("compare-changes",60157),gitMerge:(0,n.$Cj)("git-merge",60158),githubAction:(0,n.$Cj)("github-action",60159),githubAlt:(0,n.$Cj)("github-alt",60160),globe:(0,n.$Cj)("globe",60161),grabber:(0,n.$Cj)("grabber",60162),graph:(0,n.$Cj)("graph",60163),gripper:(0,n.$Cj)("gripper",60164),heart:(0,n.$Cj)("heart",60165),home:(0,n.$Cj)("home",60166),horizontalRule:(0,n.$Cj)("horizontal-rule",60167),hubot:(0,n.$Cj)("hubot",60168),inbox:(0,n.$Cj)("inbox",60169),issueReopened:(0,n.$Cj)("issue-reopened",60171),issues:(0,n.$Cj)("issues",60172),italic:(0,n.$Cj)("italic",60173),jersey:(0,n.$Cj)("jersey",60174),json:(0,n.$Cj)("json",60175),kebabVertical:(0,n.$Cj)("kebab-vertical",60176),key:(0,n.$Cj)("key",60177),law:(0,n.$Cj)("law",60178),lightbulbAutofix:(0,n.$Cj)("lightbulb-autofix",60179),linkExternal:(0,n.$Cj)("link-external",60180),link:(0,n.$Cj)("link",60181),listOrdered:(0,n.$Cj)("list-ordered",60182),listUnordered:(0,n.$Cj)("list-unordered",60183),liveShare:(0,n.$Cj)("live-share",60184),loading:(0,n.$Cj)("loading",60185),location:(0,n.$Cj)("location",60186),mailRead:(0,n.$Cj)("mail-read",60187),mail:(0,n.$Cj)("mail",60188),markdown:(0,n.$Cj)("markdown",60189),megaphone:(0,n.$Cj)("megaphone",60190),mention:(0,n.$Cj)("mention",60191),milestone:(0,n.$Cj)("milestone",60192),gitPullRequestMilestone:(0,n.$Cj)("git-pull-request-milestone",60192),mortarBoard:(0,n.$Cj)("mortar-board",60193),move:(0,n.$Cj)("move",60194),multipleWindows:(0,n.$Cj)("multiple-windows",60195),mute:(0,n.$Cj)("mute",60196),noNewline:(0,n.$Cj)("no-newline",60197),note:(0,n.$Cj)("note",60198),octoface:(0,n.$Cj)("octoface",60199),openPreview:(0,n.$Cj)("open-preview",60200),package:(0,n.$Cj)("package",60201),paintcan:(0,n.$Cj)("paintcan",60202),pin:(0,n.$Cj)("pin",60203),play:(0,n.$Cj)("play",60204),run:(0,n.$Cj)("run",60204),plug:(0,n.$Cj)("plug",60205),preserveCase:(0,n.$Cj)("preserve-case",60206),preview:(0,n.$Cj)("preview",60207),project:(0,n.$Cj)("project",60208),pulse:(0,n.$Cj)("pulse",60209),question:(0,n.$Cj)("question",60210),quote:(0,n.$Cj)("quote",60211),radioTower:(0,n.$Cj)("radio-tower",60212),reactions:(0,n.$Cj)("reactions",60213),references:(0,n.$Cj)("references",60214),refresh:(0,n.$Cj)("refresh",60215),regex:(0,n.$Cj)("regex",60216),remoteExplorer:(0,n.$Cj)("remote-explorer",60217),remote:(0,n.$Cj)("remote",60218),remove:(0,n.$Cj)("remove",60219),replaceAll:(0,n.$Cj)("replace-all",60220),replace:(0,n.$Cj)("replace",60221),repoClone:(0,n.$Cj)("repo-clone",60222),repoForcePush:(0,n.$Cj)("repo-force-push",60223),repoPull:(0,n.$Cj)("repo-pull",60224),repoPush:(0,n.$Cj)("repo-push",60225),report:(0,n.$Cj)("report",60226),requestChanges:(0,n.$Cj)("request-changes",60227),rocket:(0,n.$Cj)("rocket",60228),rootFolderOpened:(0,n.$Cj)("root-folder-opened",60229),rootFolder:(0,n.$Cj)("root-folder",60230),rss:(0,n.$Cj)("rss",60231),ruby:(0,n.$Cj)("ruby",60232),saveAll:(0,n.$Cj)("save-all",60233),saveAs:(0,n.$Cj)("save-as",60234),save:(0,n.$Cj)("save",60235),screenFull:(0,n.$Cj)("screen-full",60236),screenNormal:(0,n.$Cj)("screen-normal",60237),searchStop:(0,n.$Cj)("search-stop",60238),server:(0,n.$Cj)("server",60240),settingsGear:(0,n.$Cj)("settings-gear",60241),settings:(0,n.$Cj)("settings",60242),shield:(0,n.$Cj)("shield",60243),smiley:(0,n.$Cj)("smiley",60244),sortPrecedence:(0,n.$Cj)("sort-precedence",60245),splitHorizontal:(0,n.$Cj)("split-horizontal",60246),splitVertical:(0,n.$Cj)("split-vertical",60247),squirrel:(0,n.$Cj)("squirrel",60248),starFull:(0,n.$Cj)("star-full",60249),starHalf:(0,n.$Cj)("star-half",60250),symbolClass:(0,n.$Cj)("symbol-class",60251),symbolColor:(0,n.$Cj)("symbol-color",60252),symbolConstant:(0,n.$Cj)("symbol-constant",60253),symbolEnumMember:(0,n.$Cj)("symbol-enum-member",60254),symbolField:(0,n.$Cj)("symbol-field",60255),symbolFile:(0,n.$Cj)("symbol-file",60256),symbolInterface:(0,n.$Cj)("symbol-interface",60257),symbolKeyword:(0,n.$Cj)("symbol-keyword",60258),symbolMisc:(0,n.$Cj)("symbol-misc",60259),symbolOperator:(0,n.$Cj)("symbol-operator",60260),symbolProperty:(0,n.$Cj)("symbol-property",60261),wrench:(0,n.$Cj)("wrench",60261),wrenchSubaction:(0,n.$Cj)("wrench-subaction",60261),symbolSnippet:(0,n.$Cj)("symbol-snippet",60262),tasklist:(0,n.$Cj)("tasklist",60263),telescope:(0,n.$Cj)("telescope",60264),textSize:(0,n.$Cj)("text-size",60265),threeBars:(0,n.$Cj)("three-bars",60266),thumbsdown:(0,n.$Cj)("thumbsdown",60267),thumbsup:(0,n.$Cj)("thumbsup",60268),tools:(0,n.$Cj)("tools",60269),triangleDown:(0,n.$Cj)("triangle-down",60270),triangleLeft:(0,n.$Cj)("triangle-left",60271),triangleRight:(0,n.$Cj)("triangle-right",60272),triangleUp:(0,n.$Cj)("triangle-up",60273),twitter:(0,n.$Cj)("twitter",60274),unfold:(0,n.$Cj)("unfold",60275),unlock:(0,n.$Cj)("unlock",60276),unmute:(0,n.$Cj)("unmute",60277),unverified:(0,n.$Cj)("unverified",60278),verified:(0,n.$Cj)("verified",60279),versions:(0,n.$Cj)("versions",60280),vmActive:(0,n.$Cj)("vm-active",60281),vmOutline:(0,n.$Cj)("vm-outline",60282),vmRunning:(0,n.$Cj)("vm-running",60283),watch:(0,n.$Cj)("watch",60284),whitespace:(0,n.$Cj)("whitespace",60285),wholeWord:(0,n.$Cj)("whole-word",60286),window:(0,n.$Cj)("window",60287),wordWrap:(0,n.$Cj)("word-wrap",60288),zoomIn:(0,n.$Cj)("zoom-in",60289),zoomOut:(0,n.$Cj)("zoom-out",60290),listFilter:(0,n.$Cj)("list-filter",60291),listFlat:(0,n.$Cj)("list-flat",60292),listSelection:(0,n.$Cj)("list-selection",60293),selection:(0,n.$Cj)("selection",60293),listTree:(0,n.$Cj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,n.$Cj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,n.$Cj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,n.$Cj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,n.$Cj)("debug-stackframe-active",60297),circleSmallFilled:(0,n.$Cj)("circle-small-filled",60298),debugStackframeDot:(0,n.$Cj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,n.$Cj)("terminal-decoration-mark",60298),debugStackframe:(0,n.$Cj)("debug-stackframe",60299),debugStackframeFocused:(0,n.$Cj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,n.$Cj)("debug-breakpoint-unsupported",60300),symbolString:(0,n.$Cj)("symbol-string",60301),debugReverseContinue:(0,n.$Cj)("debug-reverse-continue",60302),debugStepBack:(0,n.$Cj)("debug-step-back",60303),debugRestartFrame:(0,n.$Cj)("debug-restart-frame",60304),debugAlt:(0,n.$Cj)("debug-alt",60305),callIncoming:(0,n.$Cj)("call-incoming",60306),callOutgoing:(0,n.$Cj)("call-outgoing",60307),menu:(0,n.$Cj)("menu",60308),expandAll:(0,n.$Cj)("expand-all",60309),feedback:(0,n.$Cj)("feedback",60310),gitPullRequestReviewer:(0,n.$Cj)("git-pull-request-reviewer",60310),groupByRefType:(0,n.$Cj)("group-by-ref-type",60311),ungroupByRefType:(0,n.$Cj)("ungroup-by-ref-type",60312),account:(0,n.$Cj)("account",60313),gitPullRequestAssignee:(0,n.$Cj)("git-pull-request-assignee",60313),bellDot:(0,n.$Cj)("bell-dot",60314),debugConsole:(0,n.$Cj)("debug-console",60315),library:(0,n.$Cj)("library",60316),output:(0,n.$Cj)("output",60317),runAll:(0,n.$Cj)("run-all",60318),syncIgnored:(0,n.$Cj)("sync-ignored",60319),pinned:(0,n.$Cj)("pinned",60320),githubInverted:(0,n.$Cj)("github-inverted",60321),serverProcess:(0,n.$Cj)("server-process",60322),serverEnvironment:(0,n.$Cj)("server-environment",60323),pass:(0,n.$Cj)("pass",60324),issueClosed:(0,n.$Cj)("issue-closed",60324),stopCircle:(0,n.$Cj)("stop-circle",60325),playCircle:(0,n.$Cj)("play-circle",60326),record:(0,n.$Cj)("record",60327),debugAltSmall:(0,n.$Cj)("debug-alt-small",60328),vmConnect:(0,n.$Cj)("vm-connect",60329),cloud:(0,n.$Cj)("cloud",60330),merge:(0,n.$Cj)("merge",60331),export:(0,n.$Cj)("export",60332),graphLeft:(0,n.$Cj)("graph-left",60333),magnet:(0,n.$Cj)("magnet",60334),notebook:(0,n.$Cj)("notebook",60335),redo:(0,n.$Cj)("redo",60336),checkAll:(0,n.$Cj)("check-all",60337),pinnedDirty:(0,n.$Cj)("pinned-dirty",60338),passFilled:(0,n.$Cj)("pass-filled",60339),circleLargeFilled:(0,n.$Cj)("circle-large-filled",60340),circleLarge:(0,n.$Cj)("circle-large",60341),circleLargeOutline:(0,n.$Cj)("circle-large-outline",60341),combine:(0,n.$Cj)("combine",60342),gather:(0,n.$Cj)("gather",60342),table:(0,n.$Cj)("table",60343),variableGroup:(0,n.$Cj)("variable-group",60344),typeHierarchy:(0,n.$Cj)("type-hierarchy",60345),typeHierarchySub:(0,n.$Cj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,n.$Cj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,n.$Cj)("git-pull-request-create",60348),runAbove:(0,n.$Cj)("run-above",60349),runBelow:(0,n.$Cj)("run-below",60350),notebookTemplate:(0,n.$Cj)("notebook-template",60351),debugRerun:(0,n.$Cj)("debug-rerun",60352),workspaceTrusted:(0,n.$Cj)("workspace-trusted",60353),workspaceUntrusted:(0,n.$Cj)("workspace-untrusted",60354),workspaceUnknown:(0,n.$Cj)("workspace-unknown",60355),terminalCmd:(0,n.$Cj)("terminal-cmd",60356),terminalDebian:(0,n.$Cj)("terminal-debian",60357),terminalLinux:(0,n.$Cj)("terminal-linux",60358),terminalPowershell:(0,n.$Cj)("terminal-powershell",60359),terminalTmux:(0,n.$Cj)("terminal-tmux",60360),terminalUbuntu:(0,n.$Cj)("terminal-ubuntu",60361),terminalBash:(0,n.$Cj)("terminal-bash",60362),arrowSwap:(0,n.$Cj)("arrow-swap",60363),copy:(0,n.$Cj)("copy",60364),personAdd:(0,n.$Cj)("person-add",60365),filterFilled:(0,n.$Cj)("filter-filled",60366),wand:(0,n.$Cj)("wand",60367),debugLineByLine:(0,n.$Cj)("debug-line-by-line",60368),inspect:(0,n.$Cj)("inspect",60369),layers:(0,n.$Cj)("layers",60370),layersDot:(0,n.$Cj)("layers-dot",60371),layersActive:(0,n.$Cj)("layers-active",60372),compass:(0,n.$Cj)("compass",60373),compassDot:(0,n.$Cj)("compass-dot",60374),compassActive:(0,n.$Cj)("compass-active",60375),azure:(0,n.$Cj)("azure",60376),issueDraft:(0,n.$Cj)("issue-draft",60377),gitPullRequestClosed:(0,n.$Cj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,n.$Cj)("git-pull-request-draft",60379),debugAll:(0,n.$Cj)("debug-all",60380),debugCoverage:(0,n.$Cj)("debug-coverage",60381),runErrors:(0,n.$Cj)("run-errors",60382),folderLibrary:(0,n.$Cj)("folder-library",60383),debugContinueSmall:(0,n.$Cj)("debug-continue-small",60384),beakerStop:(0,n.$Cj)("beaker-stop",60385),graphLine:(0,n.$Cj)("graph-line",60386),graphScatter:(0,n.$Cj)("graph-scatter",60387),pieChart:(0,n.$Cj)("pie-chart",60388),bracket:(0,n.$Cj)("bracket",60175),bracketDot:(0,n.$Cj)("bracket-dot",60389),bracketError:(0,n.$Cj)("bracket-error",60390),lockSmall:(0,n.$Cj)("lock-small",60391),azureDevops:(0,n.$Cj)("azure-devops",60392),verifiedFilled:(0,n.$Cj)("verified-filled",60393),newline:(0,n.$Cj)("newline",60394),layout:(0,n.$Cj)("layout",60395),layoutActivitybarLeft:(0,n.$Cj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,n.$Cj)("layout-activitybar-right",60397),layoutPanelLeft:(0,n.$Cj)("layout-panel-left",60398),layoutPanelCenter:(0,n.$Cj)("layout-panel-center",60399),layoutPanelJustify:(0,n.$Cj)("layout-panel-justify",60400),layoutPanelRight:(0,n.$Cj)("layout-panel-right",60401),layoutPanel:(0,n.$Cj)("layout-panel",60402),layoutSidebarLeft:(0,n.$Cj)("layout-sidebar-left",60403),layoutSidebarRight:(0,n.$Cj)("layout-sidebar-right",60404),layoutStatusbar:(0,n.$Cj)("layout-statusbar",60405),layoutMenubar:(0,n.$Cj)("layout-menubar",60406),layoutCentered:(0,n.$Cj)("layout-centered",60407),target:(0,n.$Cj)("target",60408),indent:(0,n.$Cj)("indent",60409),recordSmall:(0,n.$Cj)("record-small",60410),errorSmall:(0,n.$Cj)("error-small",60411),terminalDecorationError:(0,n.$Cj)("terminal-decoration-error",60411),arrowCircleDown:(0,n.$Cj)("arrow-circle-down",60412),arrowCircleLeft:(0,n.$Cj)("arrow-circle-left",60413),arrowCircleRight:(0,n.$Cj)("arrow-circle-right",60414),arrowCircleUp:(0,n.$Cj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,n.$Cj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,n.$Cj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,n.$Cj)("layout-sidebar-left-off",60418),blank:(0,n.$Cj)("blank",60419),heartFilled:(0,n.$Cj)("heart-filled",60420),map:(0,n.$Cj)("map",60421),mapHorizontal:(0,n.$Cj)("map-horizontal",60421),foldHorizontal:(0,n.$Cj)("fold-horizontal",60421),mapFilled:(0,n.$Cj)("map-filled",60422),mapHorizontalFilled:(0,n.$Cj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,n.$Cj)("fold-horizontal-filled",60422),circleSmall:(0,n.$Cj)("circle-small",60423),bellSlash:(0,n.$Cj)("bell-slash",60424),bellSlashDot:(0,n.$Cj)("bell-slash-dot",60425),commentUnresolved:(0,n.$Cj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,n.$Cj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,n.$Cj)("git-pull-request-new-changes",60428),searchFuzzy:(0,n.$Cj)("search-fuzzy",60429),commentDraft:(0,n.$Cj)("comment-draft",60430),send:(0,n.$Cj)("send",60431),sparkle:(0,n.$Cj)("sparkle",60432),insert:(0,n.$Cj)("insert",60433),mic:(0,n.$Cj)("mic",60434),thumbsdownFilled:(0,n.$Cj)("thumbsdown-filled",60435),thumbsupFilled:(0,n.$Cj)("thumbsup-filled",60436),coffee:(0,n.$Cj)("coffee",60437),snake:(0,n.$Cj)("snake",60438),game:(0,n.$Cj)("game",60439),vr:(0,n.$Cj)("vr",60440),chip:(0,n.$Cj)("chip",60441),piano:(0,n.$Cj)("piano",60442),music:(0,n.$Cj)("music",60443),micFilled:(0,n.$Cj)("mic-filled",60444),repoFetch:(0,n.$Cj)("repo-fetch",60445),copilot:(0,n.$Cj)("copilot",60446),lightbulbSparkle:(0,n.$Cj)("lightbulb-sparkle",60447),robot:(0,n.$Cj)("robot",60448),sparkleFilled:(0,n.$Cj)("sparkle-filled",60449),diffSingle:(0,n.$Cj)("diff-single",60450),diffMultiple:(0,n.$Cj)("diff-multiple",60451),surroundWith:(0,n.$Cj)("surround-with",60452),share:(0,n.$Cj)("share",60453),gitStash:(0,n.$Cj)("git-stash",60454),gitStashApply:(0,n.$Cj)("git-stash-apply",60455),gitStashPop:(0,n.$Cj)("git-stash-pop",60456),vscode:(0,n.$Cj)("vscode",60457),vscodeInsiders:(0,n.$Cj)("vscode-insiders",60458),codeOss:(0,n.$Cj)("code-oss",60459),runCoverage:(0,n.$Cj)("run-coverage",60460),runAllCoverage:(0,n.$Cj)("run-all-coverage",60461),coverage:(0,n.$Cj)("coverage",60462),githubProject:(0,n.$Cj)("github-project",60463),mapVertical:(0,n.$Cj)("map-vertical",60464),foldVertical:(0,n.$Cj)("fold-vertical",60464),mapVerticalFilled:(0,n.$Cj)("map-vertical-filled",60465),foldVerticalFilled:(0,n.$Cj)("fold-vertical-filled",60465)}}),define(Ee[52],ke([1,0,100,156]),function(ce,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hj=e.$Gj=void 0,e.$Fj=P;function P(){return Object.values(e.$Hj)}e.$Gj={dialogError:(0,n.$Cj)("dialog-error","error"),dialogWarning:(0,n.$Cj)("dialog-warning","warning"),dialogInfo:(0,n.$Cj)("dialog-info","info"),dialogClose:(0,n.$Cj)("dialog-close","close"),treeItemExpanded:(0,n.$Cj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,n.$Cj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,n.$Cj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,n.$Cj)("tree-filter-clear","close"),treeItemLoading:(0,n.$Cj)("tree-item-loading","loading"),menuSelection:(0,n.$Cj)("menu-selection","check"),menuSubmenu:(0,n.$Cj)("menu-submenu","chevron-right"),menuBarMore:(0,n.$Cj)("menubar-more","more"),scrollbarButtonLeft:(0,n.$Cj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,n.$Cj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,n.$Cj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,n.$Cj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,n.$Cj)("toolbar-more","more"),quickInputBack:(0,n.$Cj)("quick-input-back","arrow-left"),dropDownButton:(0,n.$Cj)("drop-down-button",60084),symbolCustomColor:(0,n.$Cj)("symbol-customcolor",60252),exportIcon:(0,n.$Cj)("export",60332),workspaceUnspecified:(0,n.$Cj)("workspace-unspecified",60355),newLine:(0,n.$Cj)("newline",60394),thumbsDownFilled:(0,n.$Cj)("thumbsdown-filled",60435),thumbsUpFilled:(0,n.$Cj)("thumbsup-filled",60436),gitFetch:(0,n.$Cj)("git-fetch",60445),lightbulbSparkleAutofix:(0,n.$Cj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,n.$Cj)("debug-breakpoint-pending",60377)},e.$Hj={...A.$Ej,...e.$Gj}}),define(Ee[37],ke([1,0,7,4,17,11]),function(ce,e,n,A,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bg=C,e.$cg=k,e.$dg=b,e.$eg=$,e.$fg=E,e.$gg=d,e.$hg=c,e.$ig=m,e.$jg=u,e.$kg=p,e.$lg=h,e.$mg=f,e.$ng=l,e.$og=t,e.$pg=a,e.$qg=s;function C(i){return i===47||i===92}function k(i){return i.replace(/[\\/]/g,n.$hc.sep)}function b(i){return i.indexOf("/")===-1&&(i=k(i)),/^[a-zA-Z]:(\/|$)/.test(i)&&(i="/"+i),i}function $(i,v=n.$hc.sep){if(!i)return"";const S=i.length,O=i.charCodeAt(0);if(C(O)){if(C(i.charCodeAt(1))&&!C(i.charCodeAt(2))){let j=3;const I=j;for(;j<S&&!C(i.charCodeAt(j));j++);if(I!==j&&!C(i.charCodeAt(j+1))){for(j+=1;j<S;j++)if(C(i.charCodeAt(j)))return i.slice(0,j+1).replace(/[\\/]/g,v)}}return v}else if(u(O)&&i.charCodeAt(1)===58)return C(i.charCodeAt(2))?i.slice(0,2)+v:i.slice(0,2);let N=i.indexOf("://");if(N!==-1){for(N+=3;N<S;N++)if(C(i.charCodeAt(N)))return i.slice(0,N+1)}return""}function E(i){if(!A.$c||!i||i.length<5)return!1;let v=i.charCodeAt(0);if(v!==92||(v=i.charCodeAt(1),v!==92))return!1;let S=2;const O=S;for(;S<i.length&&(v=i.charCodeAt(S),v!==92);S++);return!(O===S||(v=i.charCodeAt(S+1),isNaN(v)||v===92))}const y=/[\\/:\*\?"<>\|]/g,w=/[\\/]/g,g=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(i,v=A.$c){const S=v?y:w;return!(!i||i.length===0||/^\s+$/.test(i)||(S.lastIndex=0,S.test(i))||v&&g.test(i)||i==="."||i===".."||v&&i[i.length-1]==="."||v&&i.length!==i.trim().length||i.length>255)}function c(i,v,S){const O=i===v;return!S||O?O:!i||!v?!1:(0,P.$lf)(i,v)}function m(i,v,S,O=n.sep){if(i===v)return!0;if(!i||!v||v.length>i.length)return!1;if(S){if(!(0,P.$mf)(i,v))return!1;if(v.length===i.length)return!0;let j=v.length;return v.charAt(v.length-1)===O&&j--,i.charAt(j)===O}return v.charAt(v.length-1)!==O&&(v+=O),i.indexOf(v)===0}function u(i){return i>=65&&i<=90||i>=97&&i<=122}function p(i,v){return A.$c&&i.endsWith(":")&&(i+=n.sep),(0,n.$jc)(i)||(i=(0,n.$kc)(v,i)),i=(0,n.$ic)(i),A.$c?(i=(0,P.$6e)(i,n.sep),i.endsWith(":")&&(i+=n.sep)):(i=(0,P.$6e)(i,n.sep),i||(i=n.sep)),i}function h(i){const v=(0,n.$ic)(i);return A.$c?i.length>3?!1:f(v)&&(i.length===2||v.charCodeAt(2)===92):v===n.$hc.sep}function f(i,v=A.$c){return v?u(i.charCodeAt(0))&&i.charCodeAt(1)===58:!1}function l(i,v=A.$c){return f(i,v)?i[0]:void 0}function t(i,v,S){return v.length>i.length?-1:i===v?0:(S&&(i=i.toLowerCase(),v=v.toLowerCase()),i.indexOf(v))}function a(i){const v=i.split(":");let S,O,N;for(const j of v){const I=Number(j);(0,D.$Zf)(I)?O===void 0?O=I:N===void 0&&(N=I):S=S?[S,j].join(":"):j}if(!S)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:S,line:O!==void 0?O:void 0,column:N!==void 0?N:O!==void 0?1:void 0}}const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",r="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function s(i,v,S=8){let O="";for(let j=0;j<S;j++){let I;j===0&&A.$c&&!v&&(S===3||S===4)?I=r:I=o,O+=I.charAt(Math.floor(Math.random()*I.length))}let N;return v?N=`${v}-${O}`:N=O,i?(0,n.$kc)(i,N):N}}),define(Ee[21],ke([1,0,11]),function(ce,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pn=A,e.$Qn=P,e.$Rn=C,e.$Sn=b,e.$Tn=$,e.$Un=E,e.$Vn=y,e.$Wn=w,e.$Xn=g,e.$Yn=d,e.$Zn=c,e.$1n=m;function A(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const p=Array.isArray(u)?[]:{};return Object.entries(u).forEach(([h,f])=>{p[h]=f&&typeof f=="object"?A(f):f}),p}function P(u){if(!u||typeof u!="object")return u;const p=[u];for(;p.length>0;){const h=p.shift();Object.freeze(h);for(const f in h)if(D.call(h,f)){const l=h[f];typeof l=="object"&&!Object.isFrozen(l)&&!(0,n.$Yf)(l)&&p.push(l)}}return u}const D=Object.prototype.hasOwnProperty;function C(u,p){return k(u,p,new Set)}function k(u,p,h){if((0,n.$5f)(u))return u;const f=p(u);if(typeof f<"u")return f;if(Array.isArray(u)){const l=[];for(const t of u)l.push(k(t,p,h));return l}if((0,n.$Xf)(u)){if(h.has(u))throw new Error("Cannot clone recursive data-structure");h.add(u);const l={};for(const t in u)D.call(u,t)&&(l[t]=k(u[t],p,h));return h.delete(u),l}return u}function b(u,p,h=!0){return(0,n.$Xf)(u)?((0,n.$Xf)(p)&&Object.keys(p).forEach(f=>{f in u?h&&((0,n.$Xf)(u[f])&&(0,n.$Xf)(p[f])?b(u[f],p[f],h):u[f]=p[f]):u[f]=p[f]}),u):p}function $(u,p){if(u===p)return!0;if(u==null||p===null||p===void 0||typeof u!=typeof p||typeof u!="object"||Array.isArray(u)!==Array.isArray(p))return!1;let h,f;if(Array.isArray(u)){if(u.length!==p.length)return!1;for(h=0;h<u.length;h++)if(!$(u[h],p[h]))return!1}else{const l=[];for(f in u)l.push(f);l.sort();const t=[];for(f in p)t.push(f);if(t.sort(),!$(l,t))return!1;for(h=0;h<l.length;h++)if(!$(u[l[h]],p[l[h]]))return!1}return!0}function E(u){const p=new Set;return JSON.stringify(u,(h,f)=>{if((0,n.$Xf)(f)||Array.isArray(f)){if(p.has(f))return"[Circular]";p.add(f)}return f})}function y(u,p){const h=Object.create(null);return!u||!p||Object.keys(p).forEach(l=>{const t=u[l],a=p[l];$(t,a)||(h[l]=a)}),h}function w(u,p){const h=p.toLowerCase(),f=Object.keys(u).find(l=>l.toLowerCase()===h);return f?u[f]:u[p]}function g(u,p){const h=Object.create(null);for(const[f,l]of Object.entries(u))p(f,l)&&(h[f]=l);return h}function d(u){let p=[];for(;Object.prototype!==u;)p=p.concat(Object.getOwnPropertyNames(u)),u=Object.getPrototypeOf(u);return p}function c(u){const p=[];for(const h of d(u))typeof u[h]=="function"&&p.push(h);return p}function m(u,p){const h=l=>function(){const t=Array.prototype.slice.call(arguments,0);return p(l,t)},f={};for(const l of u)f[l]=h(l);return f}}),define(Ee[101],ke([1,0,52]),function(ce,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$Ij=P;var A;(function(C){function k(b){return b&&typeof b=="object"&&typeof b.id=="string"}C.isThemeColor=k})(A||(e.ThemeColor=A={}));function P(C){return{id:C}}var D;(function(C){C.iconNameSegment="[A-Za-z0-9]+",C.iconNameExpression="[A-Za-z0-9-]+",C.iconModifierExpression="~[A-Za-z]+",C.iconNameCharacter="[A-Za-z0-9~-]";const k=new RegExp(`^(${C.iconNameExpression})(${C.iconModifierExpression})?$`);function b(p){const h=k.exec(p.id);if(!h)return b(n.$Hj.error);const[,f,l]=h,t=["codicon","codicon-"+f];return l&&t.push("codicon-modifier-"+l.substring(1)),t}C.asClassNameArray=b;function $(p){return b(p).join(" ")}C.asClassName=$;function E(p){return"."+b(p).join(".")}C.asCSSSelector=E;function y(p){return p&&typeof p=="object"&&typeof p.id=="string"&&(typeof p.color>"u"||A.isThemeColor(p.color))}C.isThemeIcon=y;const w=new RegExp(`^\\$\\((${C.iconNameExpression}(?:${C.iconModifierExpression})?)\\)$`);function g(p){const h=w.exec(p);if(!h)return;const[,f]=h;return{id:f}}C.fromString=g;function d(p){return{id:p}}C.fromId=d;function c(p,h){let f=p.id;const l=f.lastIndexOf("~");return l!==-1&&(f=f.substring(0,l)),h&&(f=`${f}~${h}`),{id:f}}C.modify=c;function m(p){const h=p.id.lastIndexOf("~");if(h!==-1)return p.id.substring(h+1)}C.getModifier=m;function u(p,h){return p.id===h.id&&p.color?.id===h.color?.id}C.isEqual=u})(D||(e.ThemeIcon=D={}))}),define(Ee[157],ke([1,0,154,17,101]),function(ce,e,n,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zk=b,e.$Ak=E,e.$Bk=w,e.$Ck=g,e.$Dk=c,e.$Ek=m;const D="$(",C=new RegExp(`\\$\\(${P.ThemeIcon.iconNameExpression}(?:${P.ThemeIcon.iconModifierExpression})?\\)`,"g"),k=new RegExp(`(\\\\)?${C.source}`,"g");function b(u){return u.replace(k,(p,h)=>h?p:`\\${p}`)}const $=new RegExp(`\\\\${C.source}`,"g");function E(u){return u.replace($,p=>`\\${p}`)}const y=new RegExp(`(\\s)?(\\\\)?${C.source}(\\s)?`,"g");function w(u){return u.indexOf(D)===-1?u:u.replace(y,(p,h,f,l)=>f?p:h||l||"")}function g(u){return u?u.replace(/\$\((.*?)\)/g,(p,h)=>` ${h} `).trim():""}const d=new RegExp(`\\$\\(${P.ThemeIcon.iconNameCharacter}+\\)`,"g");function c(u){d.lastIndex=0;let p="";const h=[];let f=0;for(;;){const l=d.lastIndex,t=d.exec(u),a=u.substring(l,t?.index);if(a.length>0){p+=a;for(let o=0;o<a.length;o++)h.push(f)}if(!t)break;f+=t[0].length}return{text:p,iconOffsets:h}}function m(u,p,h=!1){const{text:f,iconOffsets:l}=p;if(!l||l.length===0)return(0,n.$qk)(u,f,h);const t=(0,A.$5e)(f," "),a=f.length-t.length,o=(0,n.$qk)(u,t,h);if(o)for(const r of o){const s=l[r.start+a]+a;r.start+=s,r.end+=s}return o}}),define(Ee[3],ke([1,0,7,4]),function(ce,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$wc=d,e.$xc=f;const P=/^\w[\w\d+.-]*$/,D=/^\//,C=/^\/\//;function k(r,s){if(!r.scheme&&s)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!P.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!D.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(C.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function b(r,s){return!r&&!s?"file":r}function $(r,s){switch(r){case"https":case"http":case"file":s?s[0]!==y&&(s=y+s):s=y;break}return s}const E="",y="/",w=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class g{static isUri(s){return s instanceof g?!0:s?typeof s.authority=="string"&&typeof s.fragment=="string"&&typeof s.path=="string"&&typeof s.query=="string"&&typeof s.scheme=="string"&&typeof s.fsPath=="string"&&typeof s.with=="function"&&typeof s.toString=="function":!1}constructor(s,i,v,S,O,N=!1){typeof s=="object"?(this.scheme=s.scheme||E,this.authority=s.authority||E,this.path=s.path||E,this.query=s.query||E,this.fragment=s.fragment||E):(this.scheme=b(s,N),this.authority=i||E,this.path=$(this.scheme,v||E),this.query=S||E,this.fragment=O||E,k(this,N))}get fsPath(){return f(this,!1)}with(s){if(!s)return this;let{scheme:i,authority:v,path:S,query:O,fragment:N}=s;return i===void 0?i=this.scheme:i===null&&(i=E),v===void 0?v=this.authority:v===null&&(v=E),S===void 0?S=this.path:S===null&&(S=E),O===void 0?O=this.query:O===null&&(O=E),N===void 0?N=this.fragment:N===null&&(N=E),i===this.scheme&&v===this.authority&&S===this.path&&O===this.query&&N===this.fragment?this:new m(i,v,S,O,N)}static parse(s,i=!1){const v=w.exec(s);return v?new m(v[2]||E,o(v[4]||E),o(v[5]||E),o(v[7]||E),o(v[9]||E),i):new m(E,E,E,E,E)}static file(s){let i=E;if(A.$c&&(s=s.replace(/\\/g,y)),s[0]===y&&s[1]===y){const v=s.indexOf(y,2);v===-1?(i=s.substring(2),s=y):(i=s.substring(2,v),s=s.substring(v)||y)}return new m("file",i,s,E,E)}static from(s,i){return new m(s.scheme,s.authority,s.path,s.query,s.fragment,i)}static joinPath(s,...i){if(!s.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let v;return A.$c&&s.scheme==="file"?v=g.file(n.$gc.join(f(s,!0),...i)).path:v=n.$hc.join(s.path,...i),s.with({path:v})}toString(s=!1){return l(this,s)}toJSON(){return this}static revive(s){if(s){if(s instanceof g)return s;{const i=new m(s);return i._formatted=s.external??null,i._fsPath=s._sep===c?s.fsPath??null:null,i}}else return s}}e.URI=g;function d(r){return!r||typeof r!="object"?!1:typeof r.scheme=="string"&&(typeof r.authority=="string"||typeof r.authority>"u")&&(typeof r.path=="string"||typeof r.path>"u")&&(typeof r.query=="string"||typeof r.query>"u")&&(typeof r.fragment=="string"||typeof r.fragment>"u")}const c=A.$c?1:void 0;class m extends g{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=f(this,!1)),this._fsPath}toString(s=!1){return s?l(this,!0):(this._formatted||(this._formatted=l(this,!1)),this._formatted)}toJSON(){const s={$mid:1};return this._fsPath&&(s.fsPath=this._fsPath,s._sep=c),this._formatted&&(s.external=this._formatted),this.path&&(s.path=this.path),this.scheme&&(s.scheme=this.scheme),this.authority&&(s.authority=this.authority),this.query&&(s.query=this.query),this.fragment&&(s.fragment=this.fragment),s}}const u={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function p(r,s,i){let v,S=-1;for(let O=0;O<r.length;O++){const N=r.charCodeAt(O);if(N>=97&&N<=122||N>=65&&N<=90||N>=48&&N<=57||N===45||N===46||N===95||N===126||s&&N===47||i&&N===91||i&&N===93||i&&N===58)S!==-1&&(v+=encodeURIComponent(r.substring(S,O)),S=-1),v!==void 0&&(v+=r.charAt(O));else{v===void 0&&(v=r.substr(0,O));const j=u[N];j!==void 0?(S!==-1&&(v+=encodeURIComponent(r.substring(S,O)),S=-1),v+=j):S===-1&&(S=O)}}return S!==-1&&(v+=encodeURIComponent(r.substring(S))),v!==void 0?v:r}function h(r){let s;for(let i=0;i<r.length;i++){const v=r.charCodeAt(i);v===35||v===63?(s===void 0&&(s=r.substr(0,i)),s+=u[v]):s!==void 0&&(s+=r[i])}return s!==void 0?s:r}function f(r,s){let i;return r.authority&&r.path.length>1&&r.scheme==="file"?i=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?s?i=r.path.substr(1):i=r.path[1].toLowerCase()+r.path.substr(2):i=r.path,A.$c&&(i=i.replace(/\//g,"\\")),i}function l(r,s){const i=s?h:p;let v="",{scheme:S,authority:O,path:N,query:j,fragment:I}=r;if(S&&(v+=S,v+=":"),(O||S==="file")&&(v+=y,v+=y),O){let B=O.indexOf("@");if(B!==-1){const Z=O.substr(0,B);O=O.substr(B+1),B=Z.lastIndexOf(":"),B===-1?v+=i(Z,!1,!1):(v+=i(Z.substr(0,B),!1,!1),v+=":",v+=i(Z.substr(B+1),!1,!0)),v+="@"}O=O.toLowerCase(),B=O.lastIndexOf(":"),B===-1?v+=i(O,!1,!0):(v+=i(O.substr(0,B),!1,!0),v+=O.substr(B))}if(N){if(N.length>=3&&N.charCodeAt(0)===47&&N.charCodeAt(2)===58){const B=N.charCodeAt(1);B>=65&&B<=90&&(N=`/${String.fromCharCode(B+32)}:${N.substr(3)}`)}else if(N.length>=2&&N.charCodeAt(1)===58){const B=N.charCodeAt(0);B>=65&&B<=90&&(N=`${String.fromCharCode(B+32)}:${N.substr(2)}`)}v+=i(N,!0,!1)}return j&&(v+="?",v+=i(j,!1,!1)),I&&(v+="#",v+=s?I:p(I,!1,!1)),v}function t(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+t(r.substr(3)):r}}const a=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function o(r){return r.match(a)?r.replace(a,s=>t(s)):r}}),define(Ee[158],ke([1,0,3]),function(ce,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gq=A,e.$Hq=P,e.$Iq=D,e.log=k;function A($){const E=$;return E&&typeof E.type=="string"&&typeof E.severity=="string"}function P($){const E=[];let y;try{const w=JSON.parse($.arguments),g=w[w.length-1];g&&g.__$stack&&(w.pop(),y=g.__$stack),E.push(...w)}catch{E.push("Unable to log remote console arguments",$.arguments)}return{args:E,stack:y}}function D($){if(typeof $!="string")return D(P($).stack);const E=$;if(E){const y=C(E),w=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(y||"");if(w&&w.length===4)return{uri:n.URI.file(w[1]),line:Number(w[2]),column:Number(w[3])}}}function C($){if(!$)return $;const E=$.indexOf(`
`);return E===-1?$:$.substring(0,E)}function k($,E){const{args:y,stack:w}=P($),g=typeof y[0]=="string"&&y.length===1;let d=C(w);d&&(d=`(${d.trim()})`);let c=[];if(typeof y[0]=="string"?d&&g?c=[`%c[${E}] %c${y[0]} %c${d}`,b("blue"),b(""),b("grey")]:c=[`%c[${E}] %c${y[0]}`,b("blue"),b(""),...y.slice(1)]:c=[`%c[${E}]%`,b("blue"),...y],d&&!g&&c.push(d),typeof console[$.severity]!="function")throw new Error("Unknown console method");console[$.severity].apply(console,c)}function b($){return`color: ${$}`}}),define(Ee[53],ke([1,0,14,3]),function(ce,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ph=P,e.$Qh=D,e.$Rh=k;function P(b){return JSON.stringify(b,C)}function D(b){let $=JSON.parse(b);return $=k($),$}function C(b,$){return $ instanceof RegExp?{$mid:2,source:$.source,flags:$.flags}:$}function k(b,$=0){if(!b||$>200)return b;if(typeof b=="object"){switch(b.$mid){case 1:return A.URI.revive(b);case 2:return new RegExp(b.source,b.flags);case 17:return new Date(b.source)}if(b instanceof n.$ue||b instanceof Uint8Array)return b;if(Array.isArray(b))for(let E=0;E<b.length;++E)b[E]=k(b[E],$+1);else for(const E in b)Object.hasOwnProperty.call(b,E)&&(b[E]=k(b[E],$+1))}return b}}),define(Ee[12],ke([1,0,10,4,17,3,7]),function(ce,e,n,A,P,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$vg=e.$ug=e.$tg=e.Schemas=void 0,e.$rg=b,e.$sg=$,e.$wg=y;var k;(function(d){d.inMemory="inmemory",d.vscode="vscode",d.internal="private",d.walkThrough="walkThrough",d.walkThroughSnippet="walkThroughSnippet",d.http="http",d.https="https",d.file="file",d.mailto="mailto",d.untitled="untitled",d.data="data",d.command="command",d.vscodeRemote="vscode-remote",d.vscodeRemoteResource="vscode-remote-resource",d.vscodeManagedRemoteResource="vscode-managed-remote-resource",d.vscodeUserData="vscode-userdata",d.vscodeCustomEditor="vscode-custom-editor",d.vscodeNotebookCell="vscode-notebook-cell",d.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",d.vscodeNotebookCellOutput="vscode-notebook-cell-output",d.vscodeInteractiveInput="vscode-interactive-input",d.vscodeSettings="vscode-settings",d.vscodeWorkspaceTrust="vscode-workspace-trust",d.vscodeTerminal="vscode-terminal",d.vscodeChatCodeBlock="vscode-chat-code-block",d.vscodeChatSesssion="vscode-chat-editor",d.webviewPanel="webview-panel",d.vscodeWebview="vscode-webview",d.extension="extension",d.vscodeFileResource="vscode-file",d.tmp="tmp",d.vsls="vsls",d.vscodeSourceControl="vscode-scm",d.codeSetting="code-setting"})(k||(e.Schemas=k={}));function b(d,c){return D.URI.isUri(d)?(0,P.$lf)(d.scheme,c):(0,P.$mf)(d,c+":")}function $(d,...c){return c.some(m=>b(d,m))}e.$tg="vscode-tkn",e.$ug="tkn";class E{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(c){this.d=c}setDelegate(c){this.e=c}setServerRootPath(c,m){this.f=y(c,m)}getServerRootPath(){return this.f}get g(){return C.$hc.join(this.f,k.vscodeRemoteResource)}set(c,m,u){this.a[c]=m,this.b[c]=u}setConnectionToken(c,m){this.c[c]=m}getPreferredWebSchema(){return this.d}rewrite(c){if(this.e)try{return this.e(c)}catch(l){return n.$1(l),c}const m=c.authority;let u=this.a[m];u&&u.indexOf(":")!==-1&&u.indexOf("[")===-1&&(u=`[${u}]`);const p=this.b[m],h=this.c[m];let f=`path=${encodeURIComponent(c.path)}`;return typeof h=="string"&&(f+=`&${e.$ug}=${encodeURIComponent(h)}`),D.URI.from({scheme:A.$i?this.d:k.vscodeRemoteResource,authority:`${u}:${p}`,path:A.$i?(window.location.pathname+"/"+this.g).replace(/\/\/+/g,"/"):this.g,query:f})}}e.$vg=new E;function y(d,c){return C.$hc.join(c??"/",`${d.quality??"oss"}-${d.commit??"dev"}`)}e.$xg="vs/../../extensions",e.$yg="vs/../../node_modules",e.$zg="vs/../../node_modules.asar",e.$Ag="vs/../../node_modules.asar.unpacked",e.$Bg="vscode-app";class w{asBrowserUri(c){const m=this.b(c,ce);return this.uriToBrowserUri(m)}uriToBrowserUri(c){return c.scheme===k.vscodeRemote?e.$vg.rewrite(c):c.scheme===k.file&&(A.$g||A.$k===`${k.vscodeFileResource}://${w.a}`)?c.with({scheme:k.vscodeFileResource,authority:c.authority||w.a,query:null,fragment:null}):c}asFileUri(c){const m=this.b(c,ce);return this.uriToFileUri(m)}uriToFileUri(c){return c.scheme===k.vscodeFileResource?c.with({scheme:k.file,authority:c.authority!==w.a?c.authority:null,query:null,fragment:null}):c}b(c,m){return D.URI.isUri(c)?c:D.URI.parse(m.toUrl(c))}}w.a=e.$Bg,e.$Cg=new w;var g;(function(d){const c=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);d.CoopAndCoep=Object.freeze(c.get("3"));const m="vscode-coi";function u(h){let f;typeof h=="string"?f=new URL(h).searchParams:h instanceof URL?f=h.searchParams:D.URI.isUri(h)&&(f=new URL(h.toString(!0)).searchParams);const l=f?.get(m);if(l)return c.get(l)}d.getHeadersFromQuery=u;function p(h,f,l){if(!globalThis.crossOriginIsolated)return;const t=f&&l?"3":l?"2":"1";h instanceof URLSearchParams?h.set(m,t):h[m]=t}d.addSearchParam=p})(g||(e.COI=g={}))}),define(Ee[159],ke([1,0,96,12,4,3]),function(ce,e,n,A,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KD=E;class C{constructor(w,g,d){this.id=w,this.dependencies=g,this.callback=d}}class k{constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(w,g,d)=>{typeof w!="string"&&(d=g,g=w,w=null),(typeof g!="object"||!Array.isArray(g))&&(d=g,g=null),this.c.push(new C(w,g,d))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(w){if(w.startsWith(window.location.origin)||w.startsWith("vscode-file://vscode-app"))return w;throw new Error(`[trusted_script_src] Invalid script url: ${w}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(w){return w}})))}async load(w){this.g();const g=await(this.a?this.i(w):this.b?this.h(w):this.j(w));if(!g)throw new Error(`Did not receive a define call from script ${w}`);if(Array.isArray(g.dependencies)&&g.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${w}. The dependencies are: ${g.dependencies.join(", ")}`);return typeof g.callback=="function"?g.callback([]):g.callback}h(w){return new Promise((g,d)=>{const c=document.createElement("script");c.setAttribute("async","async"),c.setAttribute("type","text/javascript");const m=()=>{c.removeEventListener("load",u),c.removeEventListener("error",p)},u=h=>{m(),g(this.c.pop())},p=h=>{m(),d(h)};c.addEventListener("load",u),c.addEventListener("error",p),this.f&&(w=this.f.createScriptURL(w)),c.setAttribute("src",w),window.document.getElementsByTagName("head")[0].appendChild(c)})}i(w){return new Promise((g,d)=>{try{this.f&&(w=this.f.createScriptURL(w)),importScripts(w),g(this.c.pop())}catch(c){d(c)}})}async j(w){try{const g=globalThis._VSCODE_NODE_MODULES.fs,d=globalThis._VSCODE_NODE_MODULES.vm,c=globalThis._VSCODE_NODE_MODULES.module,m=D.URI.parse(w).fsPath,u=g.readFileSync(m).toString(),p=c.wrap(u.replace(/^#!.*/,""));return new d.Script(p).runInThisContext().apply(),this.c.pop()}catch(g){throw g}}}k.INSTANCE=new k;const b=new Map;let $={};typeof globalThis.require=="object"&&($=globalThis.require.paths??{});async function E(y,w,g){if(n.$T){g===void 0&&(g=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),$[y]&&(y=$[y]);const d=`${y}/${w}`;if(b.has(d))return b.get(d);let c;if(/^\w[\w\d+.-]*:\/\//.test(d))c=d;else{const h=`${g&&!P.$i?A.$zg:A.$yg}/${d}`;c=A.$Cg.asBrowserUri(h).toString(!0)}const m=k.INSTANCE.load(c);return b.set(d,m),m}else return await new Promise((d,c)=>{ce([y],d,c)})}}),define(Ee[19],ke([1,0,37,12,7,4,17,3]),function(ce,e,n,A,P,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=void 0,e.$Jg=b,e.$5g=E,e.$6g=w;function b(g){return(0,k.$xc)(g,!0)}class ${constructor(d){this.a=d}compare(d,c,m=!1){return d===c?0:(0,C.$ef)(this.getComparisonKey(d,m),this.getComparisonKey(c,m))}isEqual(d,c,m=!1){return d===c?!0:!d||!c?!1:this.getComparisonKey(d,m)===this.getComparisonKey(c,m)}getComparisonKey(d,c=!1){return d.with({path:this.a(d)?d.path.toLowerCase():void 0,fragment:c?null:void 0}).toString()}ignorePathCasing(d){return this.a(d)}isEqualOrParent(d,c,m=!1){if(d.scheme===c.scheme){if(d.scheme===A.Schemas.file)return n.$ig(b(d),b(c),this.a(d))&&d.query===c.query&&(m||d.fragment===c.fragment);if((0,e.$1g)(d.authority,c.authority))return n.$ig(d.path,c.path,this.a(d),"/")&&d.query===c.query&&(m||d.fragment===c.fragment)}return!1}joinPath(d,...c){return k.URI.joinPath(d,...c)}basenameOrAuthority(d){return(0,e.$Sg)(d)||d.authority}basename(d){return P.$hc.basename(d.path)}extname(d){return P.$hc.extname(d.path)}dirname(d){if(d.path.length===0)return d;let c;return d.scheme===A.Schemas.file?c=k.URI.file(P.$nc(b(d))).path:(c=P.$hc.dirname(d.path),d.authority&&c.length&&c.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),c="/")),d.with({path:c})}normalizePath(d){if(!d.path.length)return d;let c;return d.scheme===A.Schemas.file?c=k.URI.file(P.$ic(b(d))).path:c=P.$hc.normalize(d.path),d.with({path:c})}relativePath(d,c){if(d.scheme!==c.scheme||!(0,e.$1g)(d.authority,c.authority))return;if(d.scheme===A.Schemas.file){const p=P.$mc(b(d),b(c));return D.$c?n.$cg(p):p}let m=d.path||"/";const u=c.path||"/";if(this.a(d)){let p=0;for(const h=Math.min(m.length,u.length);p<h&&!(m.charCodeAt(p)!==u.charCodeAt(p)&&m.charAt(p).toLowerCase()!==u.charAt(p).toLowerCase());p++);m=u.substr(0,p)+m.substr(p)}return P.$hc.relative(m,u)}resolvePath(d,c){if(d.scheme===A.Schemas.file){const m=k.URI.file(P.$lc(b(d),c));return d.with({authority:m.authority,path:m.path})}return c=n.$dg(c),d.with({path:P.$hc.resolve(d.path,c)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,c){return d===c||d!==void 0&&c!==void 0&&(0,C.$lf)(d,c)}hasTrailingPathSeparator(d,c=P.sep){if(d.scheme===A.Schemas.file){const m=b(d);return m.length>n.$eg(m).length&&m[m.length-1]===c}else{const m=d.path;return m.length>1&&m.charCodeAt(m.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,c=P.sep){return(0,e.$2g)(d,c)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,c=P.sep){let m=!1;if(d.scheme===A.Schemas.file){const u=b(d);m=u!==void 0&&u.length===n.$eg(u).length&&u[u.length-1]===c}else{c="/";const u=d.path;m=u.length===1&&u.charCodeAt(u.length-1)===47}return!m&&!(0,e.$2g)(d,c)?d.with({path:d.path+"/"}):d}}e.$Kg=$,e.$Lg=new $(()=>!1),e.$Mg=new $(g=>g.scheme===A.Schemas.file?!D.$e:!0),e.$Ng=new $(g=>!0),e.$Og=e.$Lg.isEqual.bind(e.$Lg),e.$Pg=e.$Lg.isEqualOrParent.bind(e.$Lg),e.$Qg=e.$Lg.getComparisonKey.bind(e.$Lg),e.$Rg=e.$Lg.basenameOrAuthority.bind(e.$Lg),e.$Sg=e.$Lg.basename.bind(e.$Lg),e.$Tg=e.$Lg.extname.bind(e.$Lg),e.$Ug=e.$Lg.dirname.bind(e.$Lg),e.$Vg=e.$Lg.joinPath.bind(e.$Lg),e.$Wg=e.$Lg.normalizePath.bind(e.$Lg),e.$Xg=e.$Lg.relativePath.bind(e.$Lg),e.$Yg=e.$Lg.resolvePath.bind(e.$Lg),e.$Zg=e.$Lg.isAbsolutePath.bind(e.$Lg),e.$1g=e.$Lg.isEqualAuthority.bind(e.$Lg),e.$2g=e.$Lg.hasTrailingPathSeparator.bind(e.$Lg),e.$3g=e.$Lg.removeTrailingPathSeparator.bind(e.$Lg),e.$4g=e.$Lg.addTrailingPathSeparator.bind(e.$Lg);function E(g,d){const c=[];for(let m=0;m<g.length;m++){const u=d(g[m]);g.some((p,h)=>h===m?!1:(0,e.$Pg)(u,d(p)))||c.push(g[m])}return c}var y;(function(g){g.META_DATA_LABEL="label",g.META_DATA_DESCRIPTION="description",g.META_DATA_SIZE="size",g.META_DATA_MIME="mime";function d(c){const m=new Map;c.path.substring(c.path.indexOf(";")+1,c.path.lastIndexOf(";")).split(";").forEach(h=>{const[f,l]=h.split(":");f&&l&&m.set(f,l)});const p=c.path.substring(0,c.path.indexOf(";"));return p&&m.set(g.META_DATA_MIME,p),m}g.parseMetaData=d})(y||(e.DataUri=y={}));function w(g,d,c){if(d){let m=g.path;return m&&m[0]!==P.$hc.sep&&(m=P.$hc.sep+m),g.with({scheme:c,authority:d,path:m})}return g.with({scheme:c})}}),define(Ee[15],ke([1,0,20,10,6,2,19,4,155,60]),function(ce,e,n,A,P,D,C,k,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.Promises=e.$Fh=e.$Eh=e.$Dh=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=void 0,e.$7g=E,e.$8g=y,e.$9g=w,e.$0g=g,e.$$g=d,e.$_g=c,e.$ah=m,e.$bh=u,e.$jh=i,e.$kh=v,e.$lh=S,e.$mh=O,e.$nh=N,e.$Ch=W,e.$Kh=Q;function E(V){return!!V&&typeof V.then=="function"}function y(V){const L=new n.$ee,H=V(L.token),K=new Promise((te,de)=>{const se=L.token.onCancellationRequested(()=>{se.dispose(),de(new A.$5)});Promise.resolve(H).then(ge=>{se.dispose(),L.dispose(),te(ge)},ge=>{se.dispose(),L.dispose(),de(ge)})});return new class{cancel(){L.cancel(),L.dispose()}then(te,de){return K.then(te,de)}catch(te){return this.then(void 0,te)}finally(te){return K.finally(te)}}}function w(V,L,H){return new Promise((K,te)=>{const de=L.onCancellationRequested(()=>{de.dispose(),K(H)});V.then(K,te).finally(()=>de.dispose())})}function g(V,L){return new Promise((H,K)=>{const te=L.onCancellationRequested(()=>{te.dispose(),K(new A.$5)});V.then(H,K).finally(()=>te.dispose())})}async function d(V){let L=-1;const H=V.map((K,te)=>K.then(de=>(L=te,de)));try{return await Promise.race(H)}finally{V.forEach((K,te)=>{te!==L&&K.cancel()})}}function c(V,L,H){let K;const te=setTimeout(()=>{K?.(void 0),H?.()},L);return Promise.race([V.finally(()=>clearTimeout(te)),new Promise(de=>K=de)])}function m(V){return new Promise((L,H)=>{const K=V();E(K)?K.then(L,H):L(K)})}function u(){let V,L;return{promise:new Promise((K,te)=>{V=K,L=te}),resolve:V,reject:L}}class p{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(L){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=L,!this.b){const H=()=>{if(this.b=null,this.f)return;const K=this.queue(this.d);return this.d=null,K};this.b=new Promise(K=>{this.a.then(H,H).then(K)})}return new Promise((H,K)=>{this.b.then(H,K)})}return this.a=L(),new Promise((H,K)=>{this.a.then(te=>{this.a=null,H(te)},te=>{this.a=null,K(te)})})}dispose(){this.f=!0}}e.$ch=p;class h{constructor(){this.a=Promise.resolve(null)}queue(L){return this.a=this.a.then(()=>L(),()=>L())}}e.$dh=h;class f{constructor(){this.a=new Map}queue(L,H){const te=(this.a.get(L)??Promise.resolve()).catch(()=>{}).then(H).finally(()=>{this.a.get(L)===te&&this.a.delete(L)});return this.a.set(L,te),te}}e.$eh=f;const l=(V,L)=>{let H=!0;const K=setTimeout(()=>{H=!1,L()},V);return{isTriggered:()=>H,dispose:()=>{clearTimeout(K),H=!1}}},t=V=>{let L=!0;return queueMicrotask(()=>{L&&(L=!1,V())}),{isTriggered:()=>L,dispose:()=>{L=!1}}};class a{constructor(L){this.defaultDelay=L,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(L,H=this.defaultDelay){this.g=L,this.h(),this.b||(this.b=new Promise((te,de)=>{this.d=te,this.f=de}).then(()=>{if(this.b=null,this.d=null,this.g){const te=this.g;return this.g=null,te()}}));const K=()=>{this.a=null,this.d?.(null)};return this.a=H===b.$4d?t(K):l(H,K),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new A.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$fh=a;class o{constructor(L){this.a=new a(L),this.b=new p}trigger(L,H){return this.a.trigger(()=>this.b.queue(L),H)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$gh=o;class r{constructor(){this.a=!1,this.b=new Promise((L,H)=>{this.d=L})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$hh=r;class s extends r{constructor(L){super(),this.f=setTimeout(()=>this.open(),L)}open(){clearTimeout(this.f),super.open()}}e.$ih=s;function i(V,L){return L?new Promise((H,K)=>{const te=setTimeout(()=>{de.dispose(),H()},V),de=L.onCancellationRequested(()=>{clearTimeout(te),de.dispose(),K(new A.$5)})}):y(H=>i(V,H))}function v(V,L=0,H){const K=setTimeout(()=>{V(),H&&te.dispose()},L),te=(0,D.$Sc)(()=>{clearTimeout(K),H?.deleteAndLeak(te)});return H?.add(te),te}function S(V){const L=[];let H=0;const K=V.length;function te(){return H<K?V[H++]():null}function de(se){se!=null&&L.push(se);const ge=te();return ge?ge.then(de):Promise.resolve(L)}return Promise.resolve(null).then(de)}function O(V,L=K=>!!K,H=null){let K=0;const te=V.length,de=()=>{if(K>=te)return Promise.resolve(H);const se=V[K++];return Promise.resolve(se()).then(we=>L(we)?Promise.resolve(we):de())};return de()}function N(V,L=K=>!!K,H=null){if(V.length===0)return Promise.resolve(H);let K=V.length;const te=()=>{K=-1;for(const de of V)de.cancel?.()};return new Promise((de,se)=>{for(const ge of V)ge.then(we=>{--K>=0&&L(we)?(te(),de(we)):K===0&&de(H)}).catch(we=>{--K>=0&&(te(),se(we))})})}class j{constructor(L){this.a=0,this.b=!1,this.f=L,this.g=[],this.d=0,this.h=new P.$7d}whenIdle(){return this.size>0?P.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(L){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((H,K)=>{this.g.push({factory:L,c:H,e:K}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const L=this.g.shift();this.d++;const H=L.factory();H.then(L.c,L.e),H.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$oh=j;class I extends j{constructor(){super(1)}}e.$ph=I;class B{constructor(){this.a=new re,this.b=0}queue(L){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,L())):this.a.run(this.b++,L())}}e.$qh=B;class Z{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const L=new $e;return this.b.add(L),L.p}g(){for(const[,L]of this.a)if(L.size>0)return!1;return!0}queueSize(L,H=C.$Lg){const K=H.getComparisonKey(L);return this.a.get(K)?.size??0}queueFor(L,H,K=C.$Lg){const te=K.getComparisonKey(L);let de=this.a.get(te);if(!de){de=new I;const se=this.f++,ge=P.Event.once(de.onDrained)(()=>{de?.dispose(),this.a.delete(te),this.h(),this.d?.deleteAndDispose(se),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new D.$4c),this.d.set(se,ge),this.a.set(te,de)}return de.queue(H)}h(){this.g()&&this.j()}j(){for(const L of this.b)L.complete();this.b.clear()}dispose(){for(const[,L]of this.a)L.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$rh=Z;class he{constructor(L,H){this.a=-1,typeof L=="function"&&typeof H=="number"&&this.setIfNotSet(L,H)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(L,H){this.cancel(),this.a=setTimeout(()=>{this.a=-1,L()},H)}setIfNotSet(L,H){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,L()},H))}}e.$sh=he;class ae{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(L,H,K=globalThis){this.cancel();const te=K.setInterval(()=>{L()},H);this.d=(0,D.$Sc)(()=>{K.clearInterval(te),this.d=void 0})}dispose(){this.cancel()}}e.$th=ae;class ee{constructor(L,H){this.b=-1,this.a=L,this.d=H,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(L=this.d){this.cancel(),this.b=setTimeout(this.f,L)}get delay(){return this.d}set delay(L){this.d=L}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$uh=ee;class _{constructor(L,H){H%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${H}ms is not a multiple of 1000ms.`),this.a=L,this.b=H,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(L=this.b){L%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${L}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(L/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$vh=_;class z extends ee{constructor(L,H){super(L,H),this.j=[]}work(L){this.j.push(L),this.isScheduled()||this.schedule()}h(){const L=this.j;this.j=[],this.a?.(L)}dispose(){this.j=[],super.dispose()}}e.$wh=z;class T extends D.$Uc{constructor(L,H){super(),this.g=L,this.h=H,this.a=[],this.b=this.B(new D.$Vc),this.f=!1}get pending(){return this.a.length}work(L){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+L.length>this.g.maxBufferedWork)return!1}else if(this.pending+L.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const H of L)this.a.push(H);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new ee(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$xh=T,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$zh=(V,L)=>{(0,k.$v)(()=>{if(H)return;const K=Date.now()+15;L(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,K-Date.now())}}))});let H=!1;return{dispose(){H||(H=!0)}}}:e.$zh=(V,L,H)=>{const K=V.requestIdleCallback(L,typeof H=="number"?{timeout:H}:void 0);let te=!1;return{dispose(){te||(te=!0,V.cancelIdleCallback(K))}}},e.$yh=V=>(0,e.$zh)(globalThis,V)}();class J{constructor(L,H){this.g=!1,this.d=()=>{try{this.j=H()}catch(K){this.l=K}finally{this.g=!0}},this.f=(0,e.$zh)(L,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Ah=J;class Y extends J{constructor(L){super(globalThis,L)}}e.$Bh=Y;async function W(V,L,H){let K;for(let te=0;te<H;te++)try{return await V()}catch(de){K=de,await i(L)}throw K}class re{isRunning(L){return typeof L=="number"?this.a?.taskId===L:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(L,H,K){return this.a={taskId:L,cancel:()=>K?.(),promise:H},H.then(()=>this.d(L),()=>this.d(L)),H}d(L){this.a&&L===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const L=this.b;this.b=void 0,L.run().then(L.promiseResolve,L.promiseReject)}}queue(L){if(this.b)this.b.run=L;else{const{promise:H,resolve:K,reject:te}=u();this.b={run:L,promise:H,promiseResolve:K,promiseReject:te}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Dh=re;class ue{constructor(L,H=()=>Date.now()){this.d=L,this.f=H,this.a=0,this.b=0}increment(){const L=this.f();return L-this.a>this.d&&(this.a=L,this.b=0),this.b++,this.b}}e.$Eh=ue;var ie;(function(V){V[V.Resolved=0]="Resolved",V[V.Rejected=1]="Rejected"})(ie||(ie={}));class $e{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((L,H)=>{this.a=L,this.b=H})}complete(L){return new Promise(H=>{this.a(L),this.d={outcome:0,value:L},H()})}error(L){return new Promise(H=>{this.b(L),this.d={outcome:1,value:L},H()})}cancel(){return this.error(new A.$5)}}e.$Fh=$e;var ne;(function(V){async function L(K){let te;const de=await Promise.all(K.map(se=>se.then(ge=>ge,ge=>{te||(te=ge)})));if(typeof te<"u")throw te;return de}V.settled=L;function H(K){return new Promise(async(te,de)=>{try{await K(te,de)}catch(se){de(se)}})}V.withAsyncBody=H})(ne||(e.Promises=ne={}));class U{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(L){this.a=void 0,this.b=void 0,this.d=!1,this.promise=L.then(H=>(this.a=H,this.d=!0,H),H=>{throw this.b=H,this.d=!0,H})}requireValue(){if(!this.d)throw new A.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Gh=U;class R{constructor(L){this.b=L,this.a=new $.$V(()=>new U(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Hh=R;var q;(function(V){V[V.Initial=0]="Initial",V[V.DoneOK=1]="DoneOK",V[V.DoneError=2]="DoneError"})(q||(q={}));class X{static fromArray(L){return new X(H=>{H.emitMany(L)})}static fromPromise(L){return new X(async H=>{H.emitMany(await L)})}static fromPromises(L){return new X(async H=>{await Promise.all(L.map(async K=>H.emitOne(await K)))})}static merge(L){return new X(async H=>{await Promise.all(L.map(async K=>{for await(const te of K)H.emitOne(te)}))})}constructor(L){this.a=0,this.b=[],this.d=null,this.f=new P.$7d,queueMicrotask(async()=>{const H={emitOne:K=>this.g(K),emitMany:K=>this.h(K),reject:K=>this.k(K)};try{await Promise.resolve(L(H)),this.j()}catch(K){this.k(K)}finally{H.emitOne=void 0,H.emitMany=void 0,H.reject=void 0}})}[Symbol.asyncIterator](){let L=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(L<this.b.length)return{done:!1,value:this.b[L++]};if(this.a===1)return{done:!0,value:void 0};await P.Event.toPromise(this.f.event)}while(!0)}}}static map(L,H){return new X(async K=>{for await(const te of L)K.emitOne(H(te))})}map(L){return X.map(this,L)}static filter(L,H){return new X(async K=>{for await(const te of L)H(te)&&K.emitOne(te)})}filter(L){return X.filter(this,L)}static coalesce(L){return X.filter(L,H=>!!H)}coalesce(){return X.coalesce(this)}static async toPromise(L){const H=[];for await(const K of L)H.push(K);return H}toPromise(){return X.toPromise(this)}g(L){this.a===0&&(this.b.push(L),this.f.fire())}h(L){this.a===0&&(this.b=this.b.concat(L),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(L){this.a===0&&(this.a=2,this.d=L,this.f.fire())}}e.$Ih=X,X.EMPTY=X.fromArray([]);class le extends X{constructor(L,H){super(H),this.l=L}cancel(){this.l.cancel()}}e.$Jh=le;function Q(V){const L=new n.$ee,H=V(L.token);return new le(L,async K=>{const te=L.token.onCancellationRequested(()=>{te.dispose(),L.dispose(),K.reject(new A.$5)});try{for await(const de of H){if(L.token.isCancellationRequested)return;K.emitOne(de)}te.dispose(),L.dispose()}catch(de){te.dispose(),L.dispose(),K.reject(de)}})}class x{constructor(){this.a=new $e,this.b=new X(K=>{if(L){K.reject(L);return}return H&&K.emitMany(H),this.d=te=>K.reject(te),this.f=te=>K.emitOne(te),this.a.p});let L,H;this.f=K=>{H||(H=[]),H.push(K)},this.d=K=>{L||(L=K)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(L){this.d(L),this.a.complete()}emitOne(L){this.f(L)}}e.$Lh=x}),define(Ee[76],ke([1,0,18,15,37,24,7,4,17]),function(ce,e,n,A,P,D,C,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_j=e.$$j=void 0,e.$0j=$,e.$ak=d,e.$bk=I,e.$ck=B,e.$dk=Z,e.$ek=he,e.$fk=ae,e.$gk=T;function $(){return Object.create(null)}e.$$j="**",e.$_j="/";const E="[/\\\\]",y="[^/\\\\]",w=/\//g;function g(J,Y){switch(J){case 0:return"";case 1:return`${y}*?`;default:return`(?:${E}|${y}+${E}${Y?`|${E}${y}+`:""})*?`}}function d(J,Y){if(!J)return[];const W=[];let re=!1,ue=!1,ie="";for(const $e of J){switch($e){case Y:if(!re&&!ue){W.push(ie),ie="";continue}break;case"{":re=!0;break;case"}":re=!1;break;case"[":ue=!0;break;case"]":ue=!1;break}ie+=$e}return ie&&W.push(ie),W}function c(J){if(!J)return"";let Y="";const W=d(J,e.$_j);if(W.every(re=>re===e.$$j))Y=".*";else{let re=!1;W.forEach((ue,ie)=>{if(ue===e.$$j){if(re)return;Y+=g(2,ie===W.length-1)}else{let $e=!1,ne="",U=!1,R="";for(const q of ue){if(q!=="}"&&$e){ne+=q;continue}if(U&&(q!=="]"||!R)){let X;q==="-"?X=q:(q==="^"||q==="!")&&!R?X="^":q===e.$_j?X="":X=(0,b.$Ze)(q),R+=X;continue}switch(q){case"{":$e=!0;continue;case"[":U=!0;continue;case"}":{const le=`(?:${d(ne,",").map(Q=>c(Q)).join("|")})`;Y+=le,$e=!1,ne="";break}case"]":{Y+="["+R+"]",U=!1,R="";break}case"?":Y+=y;continue;case"*":Y+=g(1);continue;default:Y+=(0,b.$Ze)(q)}}ie<W.length-1&&(W[ie+1]!==e.$$j||ie+2<W.length)&&(Y+=E)}re=ue===e.$$j})}return Y}const m=/^\*\*\/\*\.[\w\.-]+$/,u=/^\*\*\/([\w\.-]+)\/?$/,p=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,h=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,f=/^\*\*((\/[\w\.-]+)+)\/?$/,l=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new D.$Ec(1e4),a=function(){return!1},o=function(){return null};function r(J,Y){if(!J)return o;let W;typeof J!="string"?W=J.pattern:W=J,W=W.trim();const re=`${W}_${!!Y.trimForExclusions}`;let ue=t.get(re);if(ue)return s(ue,J);let ie;return m.test(W)?ue=v(W.substr(4),W):(ie=u.exec(i(W,Y)))?ue=S(ie[1],W):(Y.trimForExclusions?h:p).test(W)?ue=O(W,Y):(ie=f.exec(i(W,Y)))?ue=N(ie[1].substr(1),W,!0):(ie=l.exec(i(W,Y)))?ue=N(ie[1],W,!1):ue=j(W),t.set(re,ue),s(ue,J)}function s(J,Y){if(typeof Y=="string")return J;const W=function(re,ue){return(0,P.$ig)(re,Y.base,!k.$e)?J((0,b.$5e)(re.substr(Y.base.length),C.sep),ue):null};return W.allBasenames=J.allBasenames,W.allPaths=J.allPaths,W.basenames=J.basenames,W.patterns=J.patterns,W}function i(J,Y){return Y.trimForExclusions&&J.endsWith("/**")?J.substr(0,J.length-2):J}function v(J,Y){return function(W,re){return typeof W=="string"&&W.endsWith(J)?Y:null}}function S(J,Y){const W=`/${J}`,re=`\\${J}`,ue=function($e,ne){return typeof $e!="string"?null:ne?ne===J?Y:null:$e===J||$e.endsWith(W)||$e.endsWith(re)?Y:null},ie=[J];return ue.basenames=ie,ue.patterns=[Y],ue.allBasenames=ie,ue}function O(J,Y){const W=z(J.slice(1,-1).split(",").map(ne=>r(ne,Y)).filter(ne=>ne!==o),J),re=W.length;if(!re)return o;if(re===1)return W[0];const ue=function(ne,U){for(let R=0,q=W.length;R<q;R++)if(W[R](ne,U))return J;return null},ie=W.find(ne=>!!ne.allBasenames);ie&&(ue.allBasenames=ie.allBasenames);const $e=W.reduce((ne,U)=>U.allPaths?ne.concat(U.allPaths):ne,[]);return $e.length&&(ue.allPaths=$e),ue}function N(J,Y,W){const re=C.sep===C.$hc.sep,ue=re?J:J.replace(w,C.sep),ie=C.sep+ue,$e=C.$hc.sep+J;let ne;return W?ne=function(U,R){return typeof U=="string"&&(U===ue||U.endsWith(ie)||!re&&(U===J||U.endsWith($e)))?Y:null}:ne=function(U,R){return typeof U=="string"&&(U===ue||!re&&U===J)?Y:null},ne.allPaths=[(W?"*/":"./")+J],ne}function j(J){try{const Y=new RegExp(`^${c(J)}$`);return function(W){return Y.lastIndex=0,typeof W=="string"&&Y.test(W)?J:null}}catch{return o}}function I(J,Y,W){return!J||typeof Y!="string"?!1:B(J)(Y,void 0,W)}function B(J,Y={}){if(!J)return a;if(typeof J=="string"||Z(J)){const W=r(J,Y);if(W===o)return a;const re=function(ue,ie){return!!W(ue,ie)};return W.allBasenames&&(re.allBasenames=W.allBasenames),W.allPaths&&(re.allPaths=W.allPaths),re}return ee(J,Y)}function Z(J){const Y=J;return Y?typeof Y.base=="string"&&typeof Y.pattern=="string":!1}function he(J){return J.allBasenames||[]}function ae(J){return J.allPaths||[]}function ee(J,Y){const W=z(Object.getOwnPropertyNames(J).map(ne=>_(ne,J[ne],Y)).filter(ne=>ne!==o)),re=W.length;if(!re)return o;if(!W.some(ne=>!!ne.requiresSiblings)){if(re===1)return W[0];const ne=function(q,X){let le;for(let Q=0,x=W.length;Q<x;Q++){const V=W[Q](q,X);if(typeof V=="string")return V;(0,A.$7g)(V)&&(le||(le=[]),le.push(V))}return le?(async()=>{for(const Q of le){const x=await Q;if(typeof x=="string")return x}return null})():null},U=W.find(q=>!!q.allBasenames);U&&(ne.allBasenames=U.allBasenames);const R=W.reduce((q,X)=>X.allPaths?q.concat(X.allPaths):q,[]);return R.length&&(ne.allPaths=R),ne}const ue=function(ne,U,R){let q,X;for(let le=0,Q=W.length;le<Q;le++){const x=W[le];x.requiresSiblings&&R&&(U||(U=(0,C.$oc)(ne)),q||(q=U.substr(0,U.length-(0,C.$pc)(ne).length)));const V=x(ne,U,q,R);if(typeof V=="string")return V;(0,A.$7g)(V)&&(X||(X=[]),X.push(V))}return X?(async()=>{for(const le of X){const Q=await le;if(typeof Q=="string")return Q}return null})():null},ie=W.find(ne=>!!ne.allBasenames);ie&&(ue.allBasenames=ie.allBasenames);const $e=W.reduce((ne,U)=>U.allPaths?ne.concat(U.allPaths):ne,[]);return $e.length&&(ue.allPaths=$e),ue}function _(J,Y,W){if(Y===!1)return o;const re=r(J,W);if(re===o)return o;if(typeof Y=="boolean")return re;if(Y){const ue=Y.when;if(typeof ue=="string"){const ie=($e,ne,U,R)=>{if(!R||!re($e,ne))return null;const q=ue.replace("$(basename)",()=>U),X=R(q);return(0,A.$7g)(X)?X.then(le=>le?J:null):X?J:null};return ie.requiresSiblings=!0,ie}}return re}function z(J,Y){const W=J.filter(ne=>!!ne.basenames);if(W.length<2)return J;const re=W.reduce((ne,U)=>{const R=U.basenames;return R?ne.concat(R):ne},[]);let ue;if(Y){ue=[];for(let ne=0,U=re.length;ne<U;ne++)ue.push(Y)}else ue=W.reduce((ne,U)=>{const R=U.patterns;return R?ne.concat(R):ne},[]);const ie=function(ne,U){if(typeof ne!="string")return null;if(!U){let q;for(q=ne.length;q>0;q--){const X=ne.charCodeAt(q-1);if(X===47||X===92)break}U=ne.substr(q)}const R=re.indexOf(U);return R!==-1?ue[R]:null};ie.basenames=re,ie.patterns=ue,ie.allBasenames=re;const $e=J.filter(ne=>!ne.basenames);return $e.push(ie),$e}function T(J,Y){return(0,n.$ub)(J,Y,(W,re)=>typeof W=="string"&&typeof re=="string"?W===re:typeof W!="string"&&typeof re!="string"?W.base===re.base&&W.pattern===re.pattern:!1)}}),define(Ee[102],ke([1,0,10,157,19,17,3]),function(ce,e,n,A,P,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fk=e.MarkdownStringTextNewlineStyle=void 0,e.$Gk=$,e.$Hk=E,e.$Ik=y,e.$Jk=w,e.$Kk=g,e.$Lk=d,e.$Mk=c,e.$Nk=m;var k;(function(u){u[u.Paragraph=0]="Paragraph",u[u.Break=1]="Break"})(k||(e.MarkdownStringTextNewlineStyle=k={}));class b{constructor(p="",h=!1){if(this.value=p,typeof this.value!="string")throw(0,n.$7)("value");typeof h=="boolean"?(this.isTrusted=h,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=h.isTrusted??void 0,this.supportThemeIcons=h.supportThemeIcons??!1,this.supportHtml=h.supportHtml??!1)}appendText(p,h=0){return this.value+=w(this.supportThemeIcons?(0,A.$zk)(p):p).replace(/([ \t]+)/g,(f,l)=>"&nbsp;".repeat(l.length)).replace(/\>/gm,"\\>").replace(/\n/g,h===1?`\\
`:`

`),this}appendMarkdown(p){return this.value+=p,this}appendCodeblock(p,h){return this.value+=`
${g(h,p)}
`,this}appendLink(p,h,f){return this.value+="[",this.value+=this.c(h,"]"),this.value+="](",this.value+=this.c(String(p),")"),f&&(this.value+=` "${this.c(this.c(f,'"'),")")}"`),this.value+=")",this}c(p,h){const f=new RegExp((0,D.$Ze)(h),"g");return p.replace(f,(l,t)=>p.charAt(t-1)!=="\\"?`\\${l}`:l)}}e.$Fk=b;function $(u){return E(u)?!u.value:Array.isArray(u)?u.every($):!0}function E(u){return u instanceof b?!0:u&&typeof u=="object"?typeof u.value=="string"&&(typeof u.isTrusted=="boolean"||typeof u.isTrusted=="object"||u.isTrusted===void 0)&&(typeof u.supportThemeIcons=="boolean"||u.supportThemeIcons===void 0):!1}function y(u,p){return u===p?!0:!u||!p?!1:u.value===p.value&&u.isTrusted===p.isTrusted&&u.supportThemeIcons===p.supportThemeIcons&&u.supportHtml===p.supportHtml&&(u.baseUri===p.baseUri||!!u.baseUri&&!!p.baseUri&&(0,P.$Og)(C.URI.from(u.baseUri),C.URI.from(p.baseUri)))}function w(u){return u.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function g(u,p){const h=u.match(/^`+/gm)?.reduce((l,t)=>l.length>t.length?l:t).length??0,f=h>=3?h+1:3;return[`${"`".repeat(f)}${p}`,u,`${"`".repeat(f)}`].join(`
`)}function d(u){return u.replace(/"/g,"&quot;")}function c(u){return u&&u.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function m(u){const p=[],h=u.split("|").map(l=>l.trim());u=h[0];const f=h[1];if(f){const l=/height=(\d+)/.exec(f),t=/width=(\d+)/.exec(f),a=l?l[1]:"",o=t?t[1]:"",r=isFinite(parseInt(o)),s=isFinite(parseInt(a));r&&p.push(`width="${o}"`),s&&p.push(`height="${a}"`)}return{href:u,dimensions:p}}}),define(Ee[160],ke([1,0,18,37,7,4,19,17]),function(ce,e,n,A,P,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hw=b,e.$iw=E,e.$jw=w,e.$kw=g,e.$lw=u,e.$mw=h,e.$nw=f,e.$ow=l,e.$pw=t,e.$qw=a;function b(r,s){const{os:i,tildify:v,relative:S}=s;if(S){const j=$(r,S,i);if(typeof j=="string")return j}let O=r.fsPath;if(i===1&&!D.$c?O=O.replace(/\//g,"\\"):i!==1&&D.$c&&(O=O.replace(/\\/g,"/")),i!==1&&v?.userHome){const j=v.userHome.fsPath;let I;r.scheme!==v.userHome.scheme&&r.path[0]===P.$hc.sep&&r.path[1]!==P.$hc.sep?I=v.userHome.with({path:r.path}).fsPath:I=O,O=w(I,j,i)}return(i===1?P.$gc:P.$hc).normalize(E(O,i===1))}function $(r,s,i){const v=i===1?P.$gc:P.$hc,S=i===3?C.$Lg:C.$Ng,O=s.getWorkspace(),N=(0,n.$Ob)(O.folders);if(!N)return;r.scheme!==N.uri.scheme&&r.path[0]===P.$hc.sep&&r.path[1]!==P.$hc.sep&&(r=N.uri.with({path:r.path}));const j=s.getWorkspaceFolder(r);if(!j)return;let I;if(S.isEqual(j.uri,r)?I="":I=S.relativePath(j.uri,r)??"",I&&(I=v.normalize(I)),O.folders.length>1&&!s.noPrefix){const B=j.name?j.name:S.basenameOrAuthority(j.uri);I=I?`${B} \u2022 ${I}`:B}return I}function E(r,s=D.$c){return(0,A.$mg)(r,s)?r.charAt(0).toUpperCase()+r.slice(1):r}let y=Object.create(null);function w(r,s,i=D.OS){if(i===1||!r||!s)return r;let v=y.original===s?y.normalized:void 0;v||(v=s,D.$c&&(v=(0,A.$cg)(v)),v=`${(0,k.$6e)(v,P.$hc.sep)}${P.$hc.sep}`,y={original:s,normalized:v});let S=r;return D.$c&&(S=(0,A.$cg)(S)),(i===3?S.startsWith(v):(0,k.$mf)(S,v))?`~/${S.substr(v.length)}`:r}function g(r,s){return r.replace(/^~($|\/|\\)/,`${s}$1`)}const d="\u2026",c="\\\\",m="~";function u(r,s=P.sep){const i=new Array(r.length);let v=!1;for(let S=0;S<r.length;S++){const O=r[S];if(O===""){i[S]=`.${s}`;continue}if(!O){i[S]=O;continue}v=!0;let N="",j=O;j.indexOf(c)===0?(N=j.substr(0,j.indexOf(c)+c.length),j=j.substr(j.indexOf(c)+c.length)):j.indexOf(s)===0?(N=j.substr(0,j.indexOf(s)+s.length),j=j.substr(j.indexOf(s)+s.length)):j.indexOf(m)===0&&(N=j.substr(0,j.indexOf(m)+m.length),j=j.substr(j.indexOf(m)+m.length));const I=j.split(s);for(let B=1;v&&B<=I.length;B++)for(let Z=I.length-B;v&&Z>=0;Z--){v=!1;let he=I.slice(Z,Z+B).join(s);for(let ae=0;!v&&ae<r.length;ae++)if(ae!==S&&r[ae]&&r[ae].indexOf(he)>-1){const ee=Z+B===I.length,_=Z>0&&r[ae].indexOf(s)>-1?s+he:he,z=r[ae].endsWith(_);v=!ee||z}if(!v){let ae="";(I[0].endsWith(":")||N!=="")&&(Z===1&&(Z=0,B++,he=I[0]+s+he),Z>0&&(ae=I[0]+s),ae=N+ae),Z>0&&(ae=ae+d+s),ae=ae+he,Z+B<I.length&&(ae=ae+s+d),i[S]=ae}}v&&(i[S]=O)}return i}var p;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(p||(p={}));function h(r,s=Object.create(null)){const i=[];let v=!1,S="";for(const O of r)if(O==="$"||v&&O==="{")S&&i.push({value:S,type:p.TEXT}),S="",v=!0;else if(O==="}"&&v){const N=s[S];if(typeof N=="string")N.length&&i.push({value:N,type:p.VARIABLE});else if(N){const j=i[i.length-1];(!j||j.type!==p.SEPARATOR)&&i.push({value:N.label,type:p.SEPARATOR})}S="",v=!1}else S+=O;return S&&!v&&i.push({value:S,type:p.TEXT}),i.filter((O,N)=>{if(O.type===p.SEPARATOR){const j=i[N-1],I=i[N+1];return[j,I].every(B=>B&&(B.type===p.VARIABLE||B.type===p.TEXT)&&B.value.length>0)}return!0}).map(O=>O.value).join("")}function f(r,s){return D.$d||s?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,D.$d?"&":"&&"):r.replace(/&&|&/g,i=>i==="&"?"&&":"&")}function l(r,s){return D.$d||s?r.replace(/\(&&\w\)|&&/g,""):D.$c?r.replace(/&&|&/g,i=>i==="&"?"&&":"&"):r.replace(/&&/g,"_")}function t(r){return r.replace(/&/g,"&&")}function a(r){if(r.endsWith("]")){const s=r.lastIndexOf(" [",r.length-2);if(s!==-1){const i=o(r.substring(0,s)),v=r.substring(s);return{name:i.name+v,parentPath:i.parentPath}}}return o(r)}function o(r){const s=r.indexOf("/")!==-1?P.$hc:P.$gc,i=s.basename(r),v=s.dirname(r);return i.length?{name:i,parentPath:v}:{name:v,parentPath:""}}}),define(Ee[54],ke([1,0,14,3]),function(ce,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mn=e.$ln=void 0,e.$nn=k,e.$on=$,e.$pn=E;function P(y){return y.toJSON()}class D{constructor(w){this.a=w}transformIncoming(w){const g=this.a.transformIncoming(w);return g===w?w:P(A.URI.from(g))}transformOutgoing(w){const g=this.a.transformOutgoing(w);return g===w?w:P(A.URI.from(g))}transformOutgoingURI(w){const g=this.a.transformOutgoing(w);return g===w?w:A.URI.from(g)}transformOutgoingScheme(w){return this.a.transformOutgoingScheme(w)}}e.$ln=D,e.$mn=new class{transformIncoming(y){return y}transformOutgoing(y){return y}transformOutgoingURI(y){return y}transformOutgoingScheme(y){return y}};function C(y,w,g){if(!y||g>200)return null;if(typeof y=="object"){if(y instanceof A.URI)return w.transformOutgoing(y);for(const d in y)if(Object.hasOwnProperty.call(y,d)){const c=C(y[d],w,g+1);c!==null&&(y[d]=c)}}return null}function k(y,w){const g=C(y,w,0);return g===null?y:g}function b(y,w,g,d){if(!y||d>200)return null;if(typeof y=="object"){if(y.$mid===1)return g?A.URI.revive(w.transformIncoming(y)):w.transformIncoming(y);if(y instanceof n.$ue)return null;for(const c in y)if(Object.hasOwnProperty.call(y,c)){const m=b(y[c],w,g,d+1);m!==null&&(y[c]=m)}}return null}function $(y,w){const g=b(y,w,!1,0);return g===null?y:g}function E(y,w){const g=b(y,w,!0,0);return g===null?y:g}}),define(Ee[22],ke([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eg=void 0,e.$Dg=A;const n=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function A(P){return n.test(P)}e.$Eg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(k){for(let b=0;b<k.length;b++)k[b]=Math.floor(Math.random()*256);return k};const D=new Uint8Array(16),C=[];for(let k=0;k<256;k++)C.push(k.toString(16).padStart(2,"0"));return function(){P(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let b=0,$="";return $+=C[D[b++]],$+=C[D[b++]],$+=C[D[b++]],$+=C[D[b++]],$+="-",$+=C[D[b++]],$+=C[D[b++]],$+="-",$+=C[D[b++]],$+=C[D[b++]],$+="-",$+=C[D[b++]],$+=C[D[b++]],$+="-",$+=C[D[b++]],$+=C[D[b++]],$+=C[D[b++]],$+=C[D[b++]],$+=C[D[b++]],$+=C[D[b++]],$}}()}),define(Ee[161],ke([1,0,18,41,22]),function(ce,e,n,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mt=e.$Kt=void 0,e.$It=D,e.$Jt=C,e.$Lt=$;function D(y){return{asString:async()=>y,asFile:()=>{},value:typeof y=="string"?y:void 0}}function C(y,w,g){const d={id:(0,P.$Eg)(),name:y,uri:w,data:g};return{asString:async()=>"",asFile:()=>d,value:void 0}}class k{constructor(){this.a=new Map}get size(){let w=0;for(const g of this.a)w++;return w}has(w){return this.a.has(this.b(w))}matches(w){const g=[...this.a.keys()];return A.Iterable.some(this,([d,c])=>c.asFile())&&g.push("files"),E(b(w),g)}get(w){return this.a.get(this.b(w))?.[0]}append(w,g){const d=this.a.get(w);d?d.push(g):this.a.set(this.b(w),[g])}replace(w,g){this.a.set(this.b(w),[g])}delete(w){this.a.delete(this.b(w))}*[Symbol.iterator](){for(const[w,g]of this.a)for(const d of g)yield[w,d]}b(w){return b(w)}}e.$Kt=k;function b(y){return y.toLowerCase()}function $(y,w){return E(b(y),w.map(b))}function E(y,w){if(y==="*/*")return w.length>0;if(w.includes(y))return!0;const g=y.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!g)return!1;const[d,c,m]=g;return m==="*"?w.some(u=>u.startsWith(c+"/")):!1}e.$Mt=Object.freeze({create:y=>(0,n.$Mb)(y.map(w=>w.toString())).join(`\r
`),split:y=>y.split(`\r
`),parse:y=>e.$Mt.split(y).filter(w=>!w.startsWith("#"))})}),function(){"use strict";function ce(e,n,A){function P(g){return new Promise(d=>n.exists(g,d))}function D(g){return new Promise((d,c)=>{const m=new Date;n.utimes(g,m,m,u=>u?c(u):d())})}function C(g){return new Promise((d,c)=>n.mkdir(g,{recursive:!0},m=>m&&m.code!=="EEXIST"?c(m):d(g)))}function k(g){return new Promise((d,c)=>n.rm(g,{recursive:!0,force:!0,maxRetries:3},m=>m?c(m):d()))}function b(g){return new Promise((d,c)=>n.readFile(g,"utf8",(m,u)=>m?c(m):d(u)))}function $(g,d){return new Promise((c,m)=>n.writeFile(g,d,"utf8",u=>u?m(u):c()))}async function E(g){const d=e.join(g,"languagepacks.json");try{return JSON.parse(await b(d))}catch{}}function y(g,d){try{for(;d;){if(g[d])return d;{const c=d.lastIndexOf("-");if(c>0)d=d.substring(0,c);else return}}}catch(c){console.error("Resolving language pack configuration failed.",c)}}function w(g,d,c,m,u){const p=function(f){return A.mark("code/didGenerateNls"),Promise.resolve({locale:f,osLocale:u,availableLanguages:{}})};if(A.mark("code/willGenerateNls"),m==="pseudo")return Promise.resolve({locale:m,osLocale:u,availableLanguages:{},pseudo:!0});if(process.env.VSCODE_DEV)return Promise.resolve({locale:m,osLocale:u,availableLanguages:{}});if(m&&(m==="en"||m==="en-us"))return Promise.resolve({locale:m,osLocale:u,availableLanguages:{}});const h=m;try{return g?E(d).then(f=>{if(!f)return p(h);const l=y(f,m);if(!l)return p(h);m=l;const t=f[m];let a;return!t||typeof t.hash!="string"||!t.translations||typeof(a=t.translations.vscode)!="string"?p(h):P(a).then(o=>{if(!o)return p(h);const r=t.hash+"."+m,s=e.join(d,"clp",r),i=e.join(s,g),v=e.join(s,"tcf.json"),S=e.join(s,"corrupted.info"),O={locale:h,osLocale:u,availableLanguages:{"*":m},_languagePackId:r,_translationsConfigFile:v,_cacheRoot:s,_resolvedLanguagePackCoreLocation:i,_corruptedFile:S};return P(S).then(N=>{let j;return N?j=k(s):j=Promise.resolve(void 0),j.then(()=>P(i).then(I=>I?(D(i).catch(()=>{}),A.mark("code/didGenerateNls"),O):C(i).then(()=>Promise.all([b(c),b(a)])).then(B=>{const Z=JSON.parse(B[0]),he=JSON.parse(B[1]).contents,ae=Object.keys(Z.bundles),ee=[];for(const _ of ae){const z=Z.bundles[_],T=Object.create(null);for(const J of z){const Y=Z.keys[J],W=Z.messages[J],re=he[J];let ue;if(re){ue=[];for(let ie=0;ie<Y.length;ie++){const $e=Y[ie],ne=typeof $e=="string"?$e:$e.key;let U=re[ne];U===void 0&&(U=W[ie]),ue.push(U)}}else ue=W;T[J]=ue}ee.push($(e.join(i,_.replace(/\//g,"!")+".nls.json"),JSON.stringify(T)))}return ee.push($(v,JSON.stringify(t.translations))),Promise.all(ee)}).then(()=>(A.mark("code/didGenerateNls"),O)).catch(B=>(console.error("Generating translation files failed.",B),p(m)))))})})}):p(h)}catch(f){return console.error("Generating translation files failed.",f),p(m)}}return{getNLSConfiguration:w}}if(typeof define=="function")define(Ee[162],ke([77,27,43]),function(e,n,A){return ce(e,n,A)});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),n=require("fs"),A=require("../common/performance");module.exports=ce(e,n,A)}else throw new Error("Unknown context")}(),define(Ee[163],ke([1,0,28]),function(ce,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qn=D;const A=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function P(C){const k=C.replace(/\-/g,":").toLowerCase();return!A.has(k)}function D(){const C=(0,n.networkInterfaces)();for(const k in C){const b=C[k];if(b){for(const{mac:$}of b)if(P($))return $}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(Ee[103],ke([1,0,28,66,22,163,4]),function(ce,e,n,A,P,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rn=void 0,e.$sn=b,e.$tn=y,e.$rn=new class{c(w){return this.a||(this.a=A.$oi.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(w)}value(){if(this.b===void 0){let w=0,g=0;const d=(0,n.networkInterfaces)();for(const c in d){const m=d[c];if(m)for(const{mac:u,internal:p}of m)p||(g+=1,this.c(u.toUpperCase())&&(w+=1))}this.b=g>0?w/g:0}return this.b}};let k;async function b(w){return k||(k=(async()=>await $(w)||P.$Eg())()),k}async function $(w){try{const g=await new Promise((c,m)=>{ce(["crypto"],c,m)}),d=(0,D.$qn)();return g.createHash("sha256").update(d,"utf8").digest("hex")}catch(g){w(g);return}}const E="Software\\Microsoft\\SQMClient";async function y(w){if(C.$c){const g=await new Promise((d,c)=>{ce(["@vscode/windows-registry"],d,c)});try{return g.GetStringRegKey("HKEY_LOCAL_MACHINE",E,"MachineId")||""}catch(d){return w(d),""}}return""}}),define(Ee[164],ke([1,0,27,306,307,4]),function(ce,e,n,A,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fg=C;async function C(k){if(D.$d||D.$c)return;let b;for(const $ of["/etc/os-release","/usr/lib/os-release","/etc/lsb-release"])try{b=await(0,A.open)($,n.constants.R_OK);break}catch{}if(!b){k("Unable to retrieve release information from known identifier paths.");return}try{const $=new Set(["ID","DISTRIB_ID","ID_LIKE","VERSION_ID","DISTRIB_RELEASE"]),E={id:"unknown"};for await(const y of(0,P.createInterface)({input:b.createReadStream(),crlfDelay:1/0})){if(!y.includes("="))continue;const w=y.split("=")[0].toUpperCase().trim();if($.has(w)){const g=y.split("=")[1].replace(/"/g,"").toLowerCase().trim();w==="ID"||w==="DISTRIB_ID"?E.id=g:w==="ID_LIKE"?E.id_like=g:(w==="VERSION_ID"||w==="DISTRIB_RELEASE")&&(E.version_id=g)}}return E}catch($){k($)}}}),define(Ee[23],ke([1,0,27,28,308,15,37,99,7,4,19,3]),function(ce,e,n,A,P,D,C,k,b,$,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=m,e.readdirSync=h,e.whenDeleted=t,e.configureFlushOnWrite=i,e.writeFileSync=S;var w;(function(_){_[_.UNLINK=0]="UNLINK",_[_.MOVE=1]="MOVE"})(w||(e.RimRafMode=w={}));async function g(_,z=w.UNLINK,T){if((0,C.$lg)(_))throw new Error("rimraf - will refuse to recursively delete root");return z===w.UNLINK?c(_):d(_,T)}async function d(_,z=(0,C.$qg)((0,A.tmpdir)())){try{try{await n.promises.rename(_,z)}catch(T){return T.code==="ENOENT"?void 0:c(_)}c(z).catch(T=>{})}catch(T){if(T.code!=="ENOENT")throw T}}async function c(_){return(0,P.promisify)(n.rm)(_,{recursive:!0,force:!0,maxRetries:3})}function m(_){if((0,C.$lg)(_))throw new Error("rimraf - will refuse to recursively delete root");n.rmSync(_,{recursive:!0,force:!0,maxRetries:3})}async function u(_,z){return f(await(z?p(_):(0,P.promisify)(n.readdir)(_)))}async function p(_){try{return await(0,P.promisify)(n.readdir)(_,{withFileTypes:!0})}catch(J){console.warn("[node.js fs] readdir with filetypes failed with error: ",J)}const z=[],T=await u(_);for(const J of T){let Y=!1,W=!1,re=!1;try{const ue=await e.Promises.lstat((0,b.$kc)(_,J));Y=ue.isFile(),W=ue.isDirectory(),re=ue.isSymbolicLink()}catch(ue){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ue)}z.push({name:J,isFile:()=>Y,isDirectory:()=>W,isSymbolicLink:()=>re})}return z}function h(_){return f(n.readdirSync(_))}function f(_){return _.map(z=>typeof z=="string"?$.$d?(0,k.$1l)(z):z:(z.name=$.$d?(0,k.$1l)(z.name):z.name,z))}async function l(_){const z=await u(_),T=[];for(const J of z)await a.existsDirectory((0,b.$kc)(_,J))&&T.push(J);return T}function t(_,z=1e3){return new Promise(T=>{let J=!1;const Y=setInterval(()=>{J||(J=!0,n.access(_,W=>{J=!1,W&&(clearInterval(Y),T(void 0))}))},z)})}var a;(function(_){async function z(Y){let W;try{if(W=await e.Promises.lstat(Y),!W.isSymbolicLink())return{stat:W}}catch{}try{return{stat:await e.Promises.stat(Y),symbolicLink:W?.isSymbolicLink()?{dangling:!1}:void 0}}catch(re){if(re.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};if($.$c&&re.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(Y)),symbolicLink:{dangling:!1}}}catch(ue){if(ue.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};throw ue}throw re}}_.stat=z;async function T(Y){try{const{stat:W,symbolicLink:re}=await _.stat(Y);return W.isFile()&&re?.dangling!==!0}catch{}return!1}_.existsFile=T;async function J(Y){try{const{stat:W,symbolicLink:re}=await _.stat(Y);return W.isDirectory()&&re?.dangling!==!0}catch{}return!1}_.existsDirectory=J})(a||(e.SymlinkSupport=a={}));const o=new D.$rh;function r(_,z,T){return o.queueFor(y.URI.file(_),()=>{const J=O(T);return new Promise((Y,W)=>v(_,z,J,re=>re?W(re):Y()))},E.$Mg)}let s=!0;function i(_){s=_}function v(_,z,T,J){if(!s)return n.writeFile(_,z,{mode:T.mode,flag:T.flag},J);n.open(_,T.flag,T.mode,(Y,W)=>{if(Y)return J(Y);n.writeFile(W,z,re=>{if(re)return n.close(W,()=>J(re));n.fdatasync(W,ue=>(ue&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ue),i(!1)),n.close(W,ie=>J(ie))))})})}function S(_,z,T){const J=O(T);if(!s)return n.writeFileSync(_,z,{mode:J.mode,flag:J.flag});const Y=n.openSync(_,J.flag,J.mode);try{n.writeFileSync(Y,z);try{n.fdatasyncSync(Y)}catch(W){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",W),i(!1)}}finally{n.closeSync(Y)}}function O(_){return _?{mode:typeof _.mode=="number"?_.mode:438,flag:typeof _.flag=="string"?_.flag:"w"}:{mode:438,flag:"w"}}async function N(_,z,T=6e4){if(_!==z)try{$.$c&&typeof T=="number"?await j(_,z,Date.now(),T):await(0,P.promisify)(n.rename)(_,z)}catch(J){if(_.toLowerCase()!==z.toLowerCase()&&J.code==="EXDEV"||_.endsWith("."))await I(_,z,{preserveSymlinks:!1}),await g(_,w.MOVE);else throw J}}async function j(_,z,T,J,Y=0){try{return await(0,P.promisify)(n.rename)(_,z)}catch(W){if(W.code!=="EACCES"&&W.code!=="EPERM"&&W.code!=="EBUSY")throw W;if(Date.now()-T>=J)throw console.error(`[node.js fs] rename failed after ${Y} retries with error: ${W}`),W;if(Y===0){let re=!1;try{const{stat:ue}=await a.stat(z);ue.isFile()||(re=!0)}catch{}if(re)throw W}return await(0,D.$jh)(Math.min(100,Y*10)),j(_,z,T,J,Y+1)}}async function I(_,z,T){return Z(_,z,{root:{source:_,target:z},options:T,handledSourcePaths:new Set})}const B=511;async function Z(_,z,T){if(T.handledSourcePaths.has(_))return;T.handledSourcePaths.add(_);const{stat:J,symbolicLink:Y}=await a.stat(_);if(Y){if(T.options.preserveSymlinks)try{return await ee(_,z,T)}catch{}if(Y.dangling)return}return J.isDirectory()?he(_,z,J.mode&B,T):ae(_,z,J.mode&B)}async function he(_,z,T,J){await e.Promises.mkdir(z,{recursive:!0,mode:T});const Y=await u(_);for(const W of Y)await Z((0,b.$kc)(_,W),(0,b.$kc)(z,W),J)}async function ae(_,z,T){await e.Promises.copyFile(_,z),await e.Promises.chmod(z,T)}async function ee(_,z,T){let J=await e.Promises.readlink(_);(0,C.$ig)(J,T.root.source,!$.$e)&&(J=(0,b.$kc)(T.root.target,J.substr(T.root.source.length+1))),await e.Promises.symlink(J,z)}e.Promises=new class{get access(){return(0,P.promisify)(n.access)}get stat(){return(0,P.promisify)(n.stat)}get lstat(){return(0,P.promisify)(n.lstat)}get utimes(){return(0,P.promisify)(n.utimes)}get read(){return(_,z,T,J,Y)=>new Promise((W,re)=>{n.read(_,z,T,J,Y,(ue,ie,$e)=>ue?re(ue):W({bytesRead:ie,buffer:$e}))})}get readFile(){return(0,P.promisify)(n.readFile)}get write(){return(_,z,T,J,Y)=>new Promise((W,re)=>{n.write(_,z,T,J,Y,(ue,ie,$e)=>ue?re(ue):W({bytesWritten:ie,buffer:$e}))})}get appendFile(){return(0,P.promisify)(n.appendFile)}get fdatasync(){return(0,P.promisify)(n.fdatasync)}get truncate(){return(0,P.promisify)(n.truncate)}get copyFile(){return(0,P.promisify)(n.copyFile)}get open(){return(0,P.promisify)(n.open)}get close(){return(0,P.promisify)(n.close)}get symlink(){return(0,P.promisify)(n.symlink)}get readlink(){return(0,P.promisify)(n.readlink)}get chmod(){return(0,P.promisify)(n.chmod)}get mkdir(){return(0,P.promisify)(n.mkdir)}get unlink(){return(0,P.promisify)(n.unlink)}get rmdir(){return(0,P.promisify)(n.rmdir)}get realpath(){return(0,P.promisify)(n.realpath)}async exists(_){try{return await e.Promises.access(_),!0}catch{return!1}}get readdir(){return u}get readDirsInDir(){return l}get writeFile(){return r}get rm(){return g}get rename(){return N}get copy(){return I}}}),define(Ee[165],ke([1,0,27,7,4,17,23]),function(ce,e,n,A,P,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oq=k,e.$Pq=b,e.$Qq=$,e.$Rq=E;function k(w){if(P.$e)return w;const g=(0,A.$nc)(w);if(w===g)return w;const d=((0,A.$oc)(w)||w).toLowerCase();try{const m=(0,C.readdirSync)(g).filter(u=>u.toLowerCase()===d);if(m.length===1){const u=k(g);if(u)return(0,A.$kc)(u,m[0])}else if(m.length>1){const u=m.indexOf(d);if(u>=0){const p=k(g);if(p)return(0,A.$kc)(p,m[u])}}}catch{}return null}async function b(w,g){if(P.$e)return w;const d=(0,A.$nc)(w);if(w===d)return w;const c=((0,A.$oc)(w)||w).toLowerCase();try{if(g?.isCancellationRequested)return null;const u=(await C.Promises.readdir(d)).filter(p=>p.toLowerCase()===c);if(u.length===1){const p=await b(d,g);if(p)return(0,A.$kc)(p,u[0])}else if(u.length>1){const p=u.indexOf(c);if(p>=0){const h=await b(d,g);if(h)return(0,A.$kc)(h,u[p])}}}catch{}return null}async function $(w){try{return await C.Promises.realpath(w)}catch{const d=y(w);return await C.Promises.access(d,n.constants.R_OK),d}}function E(w){try{return n.realpathSync(w)}catch{const d=y(w);return n.accessSync(d,n.constants.R_OK),d}}function y(w){return(0,D.$6e)((0,A.$ic)(w),A.sep)}}),define(Ee[166],ke([1,0,78]),function(ce,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hg=void 0,e.$Gg=A,e.$Ig=D;function A(k,b,$,E=1){let y=!1;return new Promise(w=>{const g=setTimeout(()=>{if(!y)return y=!0,w(0)},$);P(k,b,E,d=>{if(!y)return y=!0,clearTimeout(g),w(d)})})}function P(k,b,$,E){if(b===0)return E(0);const y=new n.Socket;y.once("connect",()=>(C(y),P(k+$,b-1,$,E))),y.once("data",()=>{}),y.once("error",w=>(C(y),w.code!=="ECONNREFUSED"?P(k+$,b-1,$,E):E(k))),y.connect(k,"127.0.0.1")}e.$Hg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function D(k,b,$,E="127.0.0.1"){let y=!1,w,g=1;const d=n.createServer({pauseOnConnect:!0});function c(m,u){y||(y=!0,d.removeAllListeners(),d.close(),w&&clearTimeout(w),u(m))}return new Promise(m=>{w=setTimeout(()=>{c(0,m)},$),d.on("listening",()=>{c(k,m)}),d.on("error",u=>{u&&(u.code==="EADDRINUSE"||u.code==="EACCES")&&g<b?(k++,g++,d.listen(k,E)):c(0,m)}),d.on("close",()=>{c(0,m)}),d.listen(k,E)})}function C(k){try{k.removeAllListeners("connect"),k.removeAllListeners("error"),k.end(),k.destroy(),k.unref()}catch(b){console.error(b)}}}),define(Ee[104],ke([1,0,28,7,23]),function(ce,e,n,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0l=p,e.$$l=h;const D=/^\d+$/,C=/^Microsoft.PowerShell_.*/,k=/^Microsoft.PowerShellPreview_.*/;var b;(function(f){f[f.x64=0]="x64",f[f.x86=1]="x86",f[f.ARM=2]="ARM"})(b||(b={}));let $;switch(process.arch){case"ia32":$=1;break;case"arm":case"arm64":$=2;break;default:$=0;break}let E;process.env.PROCESSOR_ARCHITEW6432?E=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?E=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?E=1:E=0;class y{constructor(l,t,a){this.exePath=l,this.displayName=t,this.a=a}async exists(){return this.a===void 0&&(this.a=await P.SymlinkSupport.existsFile(this.exePath)),this.a}}function w({useAlternateBitness:f=!1}={}){return f?$===0?process.env["ProgramFiles(x86)"]||null:E===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function g({useAlternateBitness:f=!1,findPreview:l=!1}={}){const t=w({useAlternateBitness:f});if(!t)return null;const a=A.$kc(t,"PowerShell");if(!await P.SymlinkSupport.existsDirectory(a))return null;let o=-1,r=null;for(const v of await P.Promises.readdir(a)){let S=-1;if(l){const N=v.indexOf("-");if(N<0)continue;const j=v.substring(0,N);if(!D.test(j)||v.substring(N+1)!=="preview")continue;S=parseInt(j,10)}else{if(!D.test(v))continue;S=parseInt(v,10)}if(S<=o)continue;const O=A.$kc(a,v,"pwsh.exe");await P.SymlinkSupport.existsFile(O)&&(r=O,o=S)}if(!r)return null;const s=t.includes("x86")?" (x86)":"",i=l?" Preview":"";return new y(r,`PowerShell${i}${s}`,!0)}async function d({findPreview:f}={}){if(!process.env.LOCALAPPDATA)return null;const l=A.$kc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await P.SymlinkSupport.existsDirectory(l))return null;const{pwshMsixDirRegex:t,pwshMsixName:a}=f?{pwshMsixDirRegex:k,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:C,pwshMsixName:"PowerShell (Store)"};for(const o of await P.Promises.readdir(l))if(t.test(o)){const r=A.$kc(l,o,"pwsh.exe");return new y(r,a)}return null}function c(){const f=A.$kc(n.homedir(),".dotnet","tools","pwsh.exe");return new y(f,".NET Core PowerShell Global Tool")}function m(){const f=A.$kc(process.env.windir,$===1&&E!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new y(f,"Windows PowerShell",!0)}async function*u(){let f=await g();f&&(yield f),f=await g({useAlternateBitness:!0}),f&&(yield f),f=await d(),f&&(yield f),f=c(),f&&(yield f),f=await g({findPreview:!0}),f&&(yield f),f=await d({findPreview:!0}),f&&(yield f),f=await g({useAlternateBitness:!0,findPreview:!0}),f&&(yield f),f=m(),f&&(yield f)}async function*p(){for await(const f of u())await f.exists()&&(yield f)}async function h(){for await(const f of p())return f;return null}}),define(Ee[105],ke([1,0,7,4,30,62,11,23]),function(ce,e,n,A,P,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$bm=b,e.$cm=$,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return D.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return D.TerminateResponseCode}});function b(y=P.env){return y.comspec||"cmd.exe"}function $(y){let w=[],g=!1;const d=function(c){if(g){w.push(c);return}(!y.send(c,u=>{if(u&&console.error(u),g=!1,w.length>0){const p=w.slice(0);w=[],p.forEach(h=>d(h))}})||A.$c)&&(g=!0)};return{send:d}}var E;(function(y){async function w(g,d,c){if(n.$jc(g))return g;if(d===void 0&&(d=P.cwd()),n.$nc(g)!=="."||(c===void 0&&C.$Vf(P.env.PATH)&&(c=P.env.PATH.split(n.$uc)),c===void 0||c.length===0))return n.$kc(d,g);async function u(p){if(await k.Promises.exists(p)){let h;try{h=await k.Promises.stat(p)}catch(f){f.message.startsWith("EACCES")&&(h=await k.Promises.lstat(p))}return h?!h.isDirectory():!1}return!1}for(const p of c){let h;if(n.$jc(p)?h=n.$kc(p,g):h=n.$kc(d,p,g),await u(h))return h;let f=h+".com";if(await u(f)||(f=h+".exe",await u(f)))return f}return n.$kc(d,g)}y.findExecutable=w})(E||(e.win32=E={}))}),define(Ee[106],ke([1,0,55,12]),function(ce,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ns=P;function P(C){return new Promise((k,b)=>{let $;const E=new Map;function y(g,d,c,m,u){const p=E.get(d);if(g===C||p){const h={name:w(c),cmd:c,pid:g,ppid:d,load:m,mem:u};E.set(g,h),g===C&&($=h),p&&(p.children||(p.children=[]),p.children.push(h),p.children.length>1&&(p.children=p.children.sort((f,l)=>f.pid-l.pid)))}}function w(g){const d=/--utility-sub-type=network/i,c=/--crashes-directory/i,m=/\\pipe\\winpty-control/i,u=/conhost\.exe.+--headless/i,p=/--type=([a-zA-Z-]+)/;if(c.exec(g))return"electron-crash-reporter";if(m.exec(g))return"winpty-agent";if(u.exec(g))return"conpty-agent";let h=p.exec(g);if(h&&h.length===2)return h[1]==="renderer"?"window":h[1]==="utility"?d.exec(g)?"utility-network-service":"utility-process":h[1]==="extensionHost"?"extension-host":h[1];const f=/[a-zA-Z-]+\.js/g;let l="";do h=f.exec(g),h&&(l+=h+" ");while(h);return l&&g.indexOf("node ")<0&&g.indexOf("node.exe")<0?`electron-nodejs (${l})`:g}if(process.platform==="win32"){const g=d=>d.indexOf("\\\\?\\")===0||d.indexOf("\\??\\")===0?d.substring(4):d.indexOf('"\\\\?\\')===0||d.indexOf('"\\??\\')===0?'"'+d.substring(5):d;new Promise((d,c)=>{ce(["@vscode/windows-process-tree"],d,c)}).then(d=>{d.getProcessList(C,c=>{if(!c){b(new Error(`Root process ${C} not found`));return}d.getProcessCpuUsage(c,m=>{const u=new Map;m.forEach(p=>{const h=g(p.commandLine||"");u.set(p.pid,{name:w(h),cmd:h,pid:p.pid,ppid:p.ppid,load:p.cpu||0,mem:p.memory||0})}),$=u.get(C),$?(u.forEach(p=>{const h=u.get(p.ppid);h&&(h.children||(h.children=[]),h.children.push(p))}),u.forEach(p=>{p.children&&(p.children=p.children.sort((h,f)=>h.pid-f.pid))}),k($)):b(new Error(`Root process ${C} not found`))})},d.ProcessDataFlag.CommandLine|d.ProcessDataFlag.Memory)})}else{let g=function(){let d=[$];const c=[];for(;d.length;){const u=d.shift();u&&(c.push(u.pid),u.children&&(d=d.concat(u.children)))}let m=JSON.stringify(A.$Cg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);m+=" "+c.join(" "),(0,n.exec)(m,{},(u,p,h)=>{if(u||h)b(u||new Error(h.toString()));else{const f=p.toString().split(`
`);for(let l=0;l<c.length;l++){const t=E.get(c[l]);t.load=parseFloat(f[l])}if(!$){b(new Error(`Root process ${C} not found`));return}k($)}})};(0,n.exec)("which ps",{},(d,c,m)=>{if(d||m)if(process.platform!=="linux")b(d||new Error(m.toString()));else{const u=JSON.stringify(A.$Cg.asFileUri("vs/base/node/ps.sh").fsPath);(0,n.exec)(u,{},(p,h,f)=>{p||f?b(p||new Error(f.toString())):(D(h,y),g())})}else{const u=c.toString().trim();(0,n.exec)(`${u} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(h,f,l)=>{h||l&&!l.includes("screen size is bogus")?b(h||new Error(l.toString())):(D(f,y),process.platform==="linux"?g():$?k($):b(new Error(`Root process ${C} not found`)))})}})}})}function D(C,k){const b=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,$=C.toString().split(`
`);for(const E of $){const y=b.exec(E.trim());y&&y.length===6&&k(parseInt(y[1]),parseInt(y[2]),y[5],parseFloat(y[3]),parseFloat(y[4]))}}}),define(Ee[107],ke([1,0,28,4,104,105]),function(ce,e,n,A,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dm=C;async function C(y,w){return y===1?A.$c?E():D.$bm(w):b(y,w)}let k=null;function b(y,w){if(A.$e&&y===2||A.$d&&y===3)return"/bin/bash";if(!k){let g;if(A.$c)g="/bin/bash";else{if(g=w.SHELL,!g)try{g=(0,n.userInfo)().shell}catch{}g||(g="sh"),g==="/bin/false"&&(g="/bin/bash")}k=g}return k}let $=null;async function E(){return $||($=(await(0,P.$$l)()).exePath),$}}),function(){function ce(){function e(){return process.uncHostAllowlist}function n(b){const $=new Set;if(Array.isArray(b))for(const E of b)typeof E=="string"&&$.add(E);return Array.from($)}function A(){const b=e();return b?Array.from(b):[]}function P(b){if(process.platform!=="win32")return;const $=e();if($)if(typeof b=="string")$.add(b.toLowerCase());else for(const E of n(b))P(E)}function D(b){if(typeof b!="string")return;const $=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let E;for(const y of $){if(b.indexOf(y)!==0)continue;const g=b.indexOf("\\",y.length);if(g===-1)continue;const d=b.substring(y.length,g);if(d){E=d;break}}return E}function C(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function k(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:A,addUNCHostToAllowlist:P,getUNCHost:D,disableUNCAccessRestrictions:C,isUNCAccessRestrictionsDisabled:k}}typeof define=="function"?define("vs/base/node/unc",[],function(){return ce()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=ce():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}();var Fe=this&&this.__decorate||function(ce,e,n,A){var P=arguments.length,D=P<3?e:A===null?A=Object.getOwnPropertyDescriptor(e,n):A,C;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")D=Reflect.decorate(ce,e,n,A);else for(var k=ce.length-1;k>=0;k--)(C=ce[k])&&(D=(P<3?C(D):P>3?C(e,n,D):C(e,n))||D);return P>3&&D&&Object.defineProperty(e,n,D),D};define(Ee[44],ke([1,0,18,15,14,20,74,10,6,2,53,17,11]),function(ce,e,n,A,P,D,C,k,b,$,E,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=e.ProxyChannel=e.$3h=e.$Zh=e.$Yh=e.$Xh=e.RequestInitiator=e.$Wh=e.$Th=e.$Sh=void 0,e.$Uh=i,e.$Vh=v,e.$1h=B,e.$2h=Z;var g;(function(Y){Y[Y.Promise=100]="Promise",Y[Y.PromiseCancel=101]="PromiseCancel",Y[Y.EventListen=102]="EventListen",Y[Y.EventDispose=103]="EventDispose"})(g||(g={}));function d(Y){switch(Y){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var c;(function(Y){Y[Y.Initialize=200]="Initialize",Y[Y.PromiseSuccess=201]="PromiseSuccess",Y[Y.PromiseError=202]="PromiseError",Y[Y.PromiseErrorObj=203]="PromiseErrorObj",Y[Y.EventFire=204]="EventFire"})(c||(c={}));function m(Y){switch(Y){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var u;(function(Y){Y[Y.Uninitialized=0]="Uninitialized",Y[Y.Idle=1]="Idle"})(u||(u={}));function p(Y){let W=0;for(let re=0;;re+=7){const ue=Y.read(1);if(W|=(ue.buffer[0]&127)<<re,!(ue.buffer[0]&128))return W}}const h=o(0);function f(Y,W){if(W===0){Y.write(h);return}let re=0;for(let ie=W;ie!==0;ie=ie>>>7)re++;const ue=P.$ue.alloc(re);for(let ie=0;W!==0;ie++)ue.buffer[ie]=W&127,W=W>>>7,W>0&&(ue.buffer[ie]|=128);Y.write(ue)}class l{constructor(W){this.b=W,this.a=0}read(W){const re=this.b.slice(this.a,this.a+W);return this.a+=re.byteLength,re}}e.$Sh=l;class t{constructor(){this.a=[]}get buffer(){return P.$ue.concat(this.a)}write(W){this.a.push(W)}}e.$Th=t;var a;(function(Y){Y[Y.Undefined=0]="Undefined",Y[Y.String=1]="String",Y[Y.Buffer=2]="Buffer",Y[Y.VSBuffer=3]="VSBuffer",Y[Y.Array=4]="Array",Y[Y.Object=5]="Object",Y[Y.Int=6]="Int"})(a||(a={}));function o(Y){const W=P.$ue.alloc(1);return W.writeUInt8(Y,0),W}const r={Undefined:o(a.Undefined),String:o(a.String),Buffer:o(a.Buffer),VSBuffer:o(a.VSBuffer),Array:o(a.Array),Object:o(a.Object),Uint:o(a.Int)},s=typeof Buffer<"u";function i(Y,W){if(typeof W>"u")Y.write(r.Undefined);else if(typeof W=="string"){const re=P.$ue.fromString(W);Y.write(r.String),f(Y,re.byteLength),Y.write(re)}else if(s&&Buffer.isBuffer(W)){const re=P.$ue.wrap(W);Y.write(r.Buffer),f(Y,re.byteLength),Y.write(re)}else if(W instanceof P.$ue)Y.write(r.VSBuffer),f(Y,W.byteLength),Y.write(W);else if(Array.isArray(W)){Y.write(r.Array),f(Y,W.length);for(const re of W)i(Y,re)}else if(typeof W=="number"&&(W|0)===W)Y.write(r.Uint),f(Y,W);else{const re=P.$ue.fromString(JSON.stringify(W));Y.write(r.Object),f(Y,re.byteLength),Y.write(re)}}function v(Y){switch(Y.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return Y.read(p(Y)).toString();case a.Buffer:return Y.read(p(Y)).buffer;case a.VSBuffer:return Y.read(p(Y));case a.Array:{const re=p(Y),ue=[];for(let ie=0;ie<re;ie++)ue.push(v(Y));return ue}case a.Object:return JSON.parse(Y.read(p(Y)).toString());case a.Int:return p(Y)}}class S{constructor(W,re,ue=null,ie=1e3){this.h=W,this.j=re,this.k=ue,this.l=ie,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage($e=>this.q($e)),this.m({type:200})}registerChannel(W,re){this.b.set(W,re),setTimeout(()=>this.w(W),0)}m(W){switch(W.type){case 200:{const re=this.o([W.type]);this.k?.logOutgoing(re,0,1,m(W.type));return}case 201:case 202:case 204:case 203:{const re=this.o([W.type,W.id],W.data);this.k?.logOutgoing(re,W.id,1,m(W.type),W.data);return}}}o(W,re=void 0){const ue=new t;return i(ue,W),i(ue,re),this.p(ue.buffer)}p(W){try{return this.h.send(W),W.byteLength}catch{return 0}}q(W){const re=new l(W),ue=v(re),ie=v(re),$e=ue[0];switch($e){case 100:return this.k?.logIncoming(W.byteLength,ue[1],1,`${d($e)}: ${ue[2]}.${ue[3]}`,ie),this.s({type:$e,id:ue[1],channelName:ue[2],name:ue[3],arg:ie});case 102:return this.k?.logIncoming(W.byteLength,ue[1],1,`${d($e)}: ${ue[2]}.${ue[3]}`,ie),this.t({type:$e,id:ue[1],channelName:ue[2],name:ue[3],arg:ie});case 101:return this.k?.logIncoming(W.byteLength,ue[1],1,`${d($e)}`),this.u({type:$e,id:ue[1]});case 103:return this.k?.logIncoming(W.byteLength,ue[1],1,`${d($e)}`),this.u({type:$e,id:ue[1]})}}s(W){const re=this.b.get(W.channelName);if(!re){this.v(W);return}const ue=new D.$ee;let ie;try{ie=re.call(this.j,W.name,W.arg,ue.token)}catch(U){ie=Promise.reject(U)}const $e=W.id;ie.then(U=>{this.m({id:$e,data:U,type:201})},U=>{U instanceof Error?this.m({id:$e,data:{message:U.message,name:U.name,stack:U.stack?U.stack.split?U.stack.split(`
`):U.stack:void 0},type:202}):this.m({id:$e,data:U,type:203})}).finally(()=>{ne.dispose(),this.d.delete(W.id)});const ne=(0,$.$Sc)(()=>ue.cancel());this.d.set(W.id,ne)}t(W){const re=this.b.get(W.channelName);if(!re){this.v(W);return}const ue=W.id,$e=re.listen(this.j,W.name,W.arg)(ne=>this.m({id:ue,data:ne,type:204}));this.d.set(W.id,$e)}u(W){const re=this.d.get(W.id);re&&(re.dispose(),this.d.delete(W.id))}v(W){let re=this.g.get(W.channelName);re||(re=[],this.g.set(W.channelName,re));const ue=setTimeout(()=>{console.error(`Unknown channel: ${W.channelName}`),W.type===100&&this.m({id:W.id,data:{name:"Unknown channel",message:`Channel name '${W.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);re.push({request:W,timeoutTimer:ue})}w(W){const re=this.g.get(W);if(re){for(const ue of re)switch(clearTimeout(ue.timeoutTimer),ue.request.type){case 100:this.s(ue.request);break;case 102:this.t(ue.request);break}this.g.delete(W)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,$.$Pc)(this.d.values()),this.d.clear()}}e.$Wh=S;var O;(function(Y){Y[Y.LocalSide=0]="LocalSide",Y[Y.OtherSide=1]="OtherSide"})(O||(e.RequestInitiator=O={}));class N{constructor(W,re=null){this.l=W,this.a=!1,this.b=u.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new b.$7d,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ue=>this.s(ue)),this.j=re}getChannel(W){const re=this;return{call(ue,ie,$e){return re.a?Promise.reject(new k.$5):re.m(W,ue,ie,$e)},listen(ue,ie){return re.a?b.Event.None:re.o(W,ue,ie)}}}m(W,re,ue,ie=D.CancellationToken.None){const $e=this.g++,U={id:$e,type:100,channelName:W,name:re,arg:ue};if(ie.isCancellationRequested)return Promise.reject(new k.$5);let R;return new Promise((X,le)=>{if(ie.isCancellationRequested)return le(new k.$5);const Q=()=>{const H=K=>{switch(K.type){case 201:this.f.delete($e),X(K.data);break;case 202:{this.f.delete($e);const te=new Error(K.data.message);te.stack=Array.isArray(K.data.stack)?K.data.stack.join(`
`):K.data.stack,te.name=K.data.name,le(te);break}case 203:this.f.delete($e),le(K.data);break}};this.f.set($e,H),this.p(U)};let x=null;this.b===u.Idle?Q():(x=(0,A.$8g)(H=>this.u()),x.then(()=>{x=null,Q()}));const V=()=>{x?(x.cancel(),x=null):this.p({id:$e,type:101}),le(new k.$5)},L=ie.onCancellationRequested(V);R=(0,$.$Rc)((0,$.$Sc)(V),L),this.d.add(R)}).finally(()=>{R.dispose(),this.d.delete(R)})}o(W,re,ue){const ie=this.g++,ne={id:ie,type:102,channelName:W,name:re,arg:ue};let U=null;const R=new b.$7d({onWillAddFirstListener:()=>{U=(0,A.$8g)(X=>this.u()),U.then(()=>{U=null,this.d.add(R),this.p(ne)})},onDidRemoveLastListener:()=>{U?(U.cancel(),U=null):(this.d.delete(R),this.p({id:ie,type:103}))}}),q=X=>R.fire(X.data);return this.f.set(ie,q),R.event}p(W){switch(W.type){case 100:case 102:{const re=this.q([W.type,W.id,W.channelName,W.name],W.arg);this.j?.logOutgoing(re,W.id,0,`${d(W.type)}: ${W.channelName}.${W.name}`,W.arg);return}case 101:case 103:{const re=this.q([W.type,W.id]);this.j?.logOutgoing(re,W.id,0,d(W.type));return}}}q(W,re=void 0){const ue=new t;return i(ue,W),i(ue,re),this.r(ue.buffer)}r(W){try{return this.l.send(W),W.byteLength}catch{return 0}}s(W){const re=new l(W),ue=v(re),ie=v(re),$e=ue[0];switch($e){case 200:return this.j?.logIncoming(W.byteLength,0,0,m($e)),this.t({type:ue[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(W.byteLength,ue[1],0,m($e),ie),this.t({type:ue[0],id:ue[1],data:ie})}}t(W){if(W.type===200){this.b=u.Idle,this.k.fire();return}this.f.get(W.id)?.(W)}get onDidInitializePromise(){return b.Event.toPromise(this.onDidInitialize)}u(){return this.b===u.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,$.$Pc)(this.d.values()),this.d.clear()}}e.$Xh=N,Fe([C.$Mh],N.prototype,"onDidInitializePromise",null);class j{get connections(){const W=[];return this.f.forEach(re=>W.push(re)),W}constructor(W,re,ue){this.a=new Map,this.f=new Set,this.g=new b.$7d,this.onDidAddConnection=this.g.event,this.h=new b.$7d,this.onDidRemoveConnection=this.h.event,this.j=new $.$Tc,this.j.add(W(({protocol:ie,onDidClientDisconnect:$e})=>{const ne=b.Event.once(ie.onMessage);this.j.add(ne(U=>{const R=new l(U),q=v(R),X=new S(ie,q,re,ue),le=new N(ie,re);this.a.forEach((x,V)=>X.registerChannel(V,x));const Q={channelServer:X,channelClient:le,ctx:q};this.f.add(Q),this.g.fire(Q),this.j.add($e(()=>{X.dispose(),le.dispose(),this.f.delete(Q),this.h.fire(Q)}))}))}))}getChannel(W,re){const ue=this;return{call(ie,$e,ne){let U;if((0,w.$0f)(re)){const q=(0,n.$4b)(ue.connections.filter(re));U=q?Promise.resolve(q):b.Event.toPromise(b.Event.filter(ue.onDidAddConnection,re))}else U=re.routeCall(ue,ie,$e);const R=U.then(q=>q.channelClient.getChannel(W));return B(R).call(ie,$e,ne)},listen(ie,$e){if((0,w.$0f)(re))return ue.k(W,re,ie,$e);const ne=re.routeEvent(ue,ie,$e).then(U=>U.channelClient.getChannel(W));return B(ne).listen(ie,$e)}}}k(W,re,ue,ie){const $e=this;let ne;const U=new b.$7d({onWillAddFirstListener:()=>{ne=new $.$Tc;const R=new b.$ae,q=new Map,X=Q=>{const V=Q.channelClient.getChannel(W).listen(ue,ie),L=R.add(V);q.set(Q,L)},le=Q=>{const x=q.get(Q);x&&(x.dispose(),q.delete(Q))};$e.connections.filter(re).forEach(X),b.Event.filter($e.onDidAddConnection,re)(X,void 0,ne),$e.onDidRemoveConnection(le,void 0,ne),R.event(U.fire,U,ne),ne.add(R)},onDidRemoveLastListener:()=>{ne?.dispose(),ne=void 0}});return U.event}registerChannel(W,re){this.a.set(W,re);for(const ue of this.f)ue.channelServer.registerChannel(W,re)}dispose(){this.j.dispose();for(const W of this.f)W.channelClient.dispose(),W.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Yh=j;class I{constructor(W,re,ue=null){const ie=new t;i(ie,re),W.send(ie.buffer),this.a=new N(W,ue),this.d=new S(W,re,ue)}getChannel(W){return this.a.getChannel(W)}registerChannel(W,re){this.d.registerChannel(W,re)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Zh=I;function B(Y){return{call(W,re,ue){return Y.then(ie=>ie.call(W,re,ue))},listen(W,re){const ue=new b.$de;return Y.then(ie=>ue.input=ie.listen(W,re)),ue.event}}}function Z(Y){let W=!1;return{call(re,ue,ie){return W?Y.call(re,ue,ie):(0,A.$jh)(0).then(()=>W=!0).then(()=>Y.call(re,ue,ie))},listen(re,ue){if(W)return Y.listen(re,ue);const ie=new b.$de;return(0,A.$jh)(0).then(()=>W=!0).then(()=>ie.input=Y.listen(re,ue)),ie.event}}}class he{constructor(W){this.a=W}routeCall(W){return this.b(W)}routeEvent(W){return this.b(W)}async b(W){for(const re of W.connections)if(await Promise.resolve(this.a(re.ctx)))return Promise.resolve(re);return await b.Event.toPromise(W.onDidAddConnection),await this.b(W)}}e.$3h=he;var ae;(function(Y){function W($e,ne,U){const R=$e,q=U&&U.disableMarshalling,X=new Map;for(const le in R)ue(le)&&X.set(le,b.Event.buffer(R[le],!0,void 0,ne));return new class{listen(le,Q,x){const V=X.get(Q);if(V)return V;const L=R[Q];if(typeof L=="function"){if(ie(Q))return L.call(R,x);if(ue(Q))return X.set(Q,b.Event.buffer(R[Q],!0,void 0,ne)),X.get(Q)}throw new k.$bb(`Event not found: ${Q}`)}call(le,Q,x){const V=R[Q];if(typeof V=="function"){if(!q&&Array.isArray(x))for(let H=0;H<x.length;H++)x[H]=(0,E.$Rh)(x[H]);let L=V.apply(R,x);return L instanceof Promise||(L=Promise.resolve(L)),L}throw new k.$bb(`Method not found: ${Q}`)}}}Y.fromService=W;function re($e,ne){const U=ne&&ne.disableMarshalling;return new Proxy({},{get(R,q){if(typeof q=="string")return ne?.properties?.has(q)?ne.properties.get(q):ie(q)?function(X){return $e.listen(q,X)}:ue(q)?$e.listen(q):async function(...X){let le;ne&&!(0,w.$5f)(ne.context)?le=[ne.context,...X]:le=X;const Q=await $e.call(q,le);return U?Q:(0,E.$Rh)(Q)};throw new k.$bb(`Property not found: ${String(q)}`)}})}Y.toService=re;function ue($e){return $e[0]==="o"&&$e[1]==="n"&&y.$kf($e.charCodeAt(2))}function ie($e){return/^onDynamic/.test($e)&&y.$kf($e.charCodeAt(9))}})(ae||(e.ProxyChannel=ae={}));const ee=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function _(Y){if(Array.isArray(Y))return Y;if(Y&&typeof Y=="object"&&typeof Y.toString=="function"){const W=Y.toString();if(W!=="[object Object]")return W}return Y}function z(Y){return Array.isArray(Y)?Y.map(_):_(Y)}function T(Y,W,re,ue,ie,$e,ne){ne=z(ne);const U=ee[ie],R=U[ue%U.length];let q=[`%c[${Y}]%c[${String(W).padStart(7," ")}]%c[len: ${String(re).padStart(5," ")}]%c${String(ue).padStart(5," ")} - ${$e}`,"color: darkgreen","color: grey","color: grey",`color: ${R}`];/\($/.test($e)?(q=q.concat(ne),q.push(")")):q.push(ne),console.log.apply(console,q)}class J{constructor(W,re){this.d=W,this.f=re,this.a=0,this.b=0}logOutgoing(W,re,ue,ie,$e){this.b+=W,T(this.d,this.b,W,re,ue,ie,$e)}logIncoming(W,re,ue,ie,$e){this.a+=W,T(this.f,this.a,W,re,ue,ie,$e)}}e.$4h=J}),define(Ee[108],ke([1,0,14,6,2,44]),function(ce,e,n,A,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9h=e.$8h=e.$7h=e.$6h=e.ProtocolConstants=e.$5h=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var C;(function(r){r.Created="created",r.Read="read",r.Write="write",r.Open="open",r.Error="error",r.Close="close",r.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",r.NodeEndReceived="nodeEndReceived",r.NodeEndSent="nodeEndSent",r.NodeDrainBegin="nodeDrainBegin",r.NodeDrainEnd="nodeDrainEnd",r.zlibInflateError="zlibInflateError",r.zlibInflateData="zlibInflateData",r.zlibInflateInitialWrite="zlibInflateInitialWrite",r.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",r.zlibInflateWrite="zlibInflateWrite",r.zlibInflateFlushFired="zlibInflateFlushFired",r.zlibDeflateError="zlibDeflateError",r.zlibDeflateData="zlibDeflateData",r.zlibDeflateWrite="zlibDeflateWrite",r.zlibDeflateFlushFired="zlibDeflateFlushFired",r.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",r.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",r.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",r.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",r.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",r.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",r.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",r.ProtocolHeaderRead="protocolHeaderRead",r.ProtocolMessageRead="protocolMessageRead",r.ProtocolHeaderWrite="protocolHeaderWrite",r.ProtocolMessageWrite="protocolMessageWrite",r.ProtocolWrite="protocolWrite"})(C||(e.SocketDiagnosticsEventType=C={}));var k;(function(r){r.enableDiagnostics=!1,r.records=[];const s=new WeakMap;let i=0;function v(O,N){if(!s.has(O)){const j=String(++i);s.set(O,j)}return s.get(O)}function S(O,N,j,I){if(!r.enableDiagnostics)return;const B=v(O,N);if(I instanceof n.$ue||I instanceof Uint8Array||I instanceof ArrayBuffer||ArrayBuffer.isView(I)){const Z=n.$ue.alloc(I.byteLength);Z.set(I),r.records.push({timestamp:Date.now(),id:B,label:N,type:j,buff:Z})}else r.records.push({timestamp:Date.now(),id:B,label:N,type:j,data:I})}r.traceSocketEvent=S})(k||(e.SocketDiagnostics=k={}));var b;(function(r){r[r.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",r[r.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(b||(e.SocketCloseEventType=b={}));let $=null;function E(){return $||($=n.$ue.alloc(0)),$}class y{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(s){this.a.push(s),this.b+=s.byteLength}read(s){return this.c(s,!0)}peek(s){return this.c(s,!1)}c(s,i){if(s===0)return E();if(s>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===s){const N=this.a[0];return i&&(this.a.shift(),this.b-=s),N}if(this.a[0].byteLength>s){const N=this.a[0].slice(0,s);return i&&(this.a[0]=this.a[0].slice(s),this.b-=s),N}const v=n.$ue.alloc(s);let S=0,O=0;for(;s>0;){const N=this.a[O];if(N.byteLength>s){const j=N.slice(0,s);v.set(j,S),S+=s,i&&(this.a[O]=N.slice(s),this.b-=s),s-=s}else v.set(N,S),S+=N.byteLength,i?(this.a.shift(),this.b-=N.byteLength):O++,s-=N.byteLength}return v}}e.$5h=y;var w;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest",r[r.Pause=7]="Pause",r[r.Resume=8]="Resume",r[r.KeepAlive=9]="KeepAlive"})(w||(w={}));function g(r){switch(r){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var d;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.TimeoutTime=2e4]="TimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",r[r.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(d||(e.ProtocolConstants=d={}));class c{constructor(s,i,v,S){this.type=s,this.id=i,this.ack=v,this.data=S,this.writtenTime=0}get size(){return this.data.byteLength}}class m extends P.$Uc{constructor(s){super(),this.f=this.B(new A.$7d),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=s,this.b=!1,this.c=new y,this.B(this.a.onData(i=>this.acceptChunk(i))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(s);this.c.byteLength>=this.g.readLen;){const i=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=i.readUInt32BE(9),this.g.messageType=i.readUInt8(0),this.g.id=i.readUInt32BE(1),this.g.ack=i.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:g(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const v=this.g.messageType,S=this.g.id,O=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",i),this.f.fire(new c(v,S,O,i)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class u{constructor(s){this.k=null,this.a=!1,this.b=!1,this.c=s,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(s){if(this.a)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const i=n.$ue.alloc(13);i.writeUInt8(s.type,0),i.writeUInt32BE(s.id,1),i.writeUInt32BE(s.ack,5),i.writeUInt32BE(s.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:g(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",s.data),this.j(i,s.data)}g(s,i){const v=this.f===0;return this.d.push(s,i),this.f+=s.byteLength+i.byteLength,v}h(){const s=n.$ue.concat(this.d,this.f);return this.d.length=0,this.f=0,s}j(s,i){this.g(s,i)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const s=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:s.byteLength}),this.c.write(s)}}class p extends P.$Uc{constructor(s){super(),this.f=new A.$7d,this.onMessage=this.f.event,this.g=new A.$7d,this.onDidDispose=this.g.event,this.a=s,this.b=this.B(new u(this.a)),this.c=this.B(new m(this.a)),this.B(this.c.onMessage(i=>{i.type===1&&this.f.fire(i.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(s){this.b.write(new c(1,0,0,s))}}e.$6h=p;class h extends D.$Zh{static fromSocket(s,i){return new h(new p(s),i)}get onDidDispose(){return this.b.onDidDispose}constructor(s,i,v=null){super(s,i,v),this.b=s}dispose(){super.dispose();const s=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),s.end()}}e.$7h=h;class f{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new A.$7d({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(s){this.b?this.d.length>0?this.d.push(s):this.a.fire(s):this.d.push(s)}flushBuffer(){this.d=[]}}e.$8h=f;class l{constructor(s){this.data=s,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let s=0,i=this.a;for(;i;)i=i.next,s++;return s}peek(){return this.a?this.a.data:null}toArray(){const s=[];let i=0,v=this.a;for(;v;)s[i++]=v.data,v=v.next;return s}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(s){const i=new l(s);if(!this.a){this.a=i,this.b=i;return}this.b.next=i,this.b=i}}class a{static getInstance(){return a.b||(a.b=new a),a.b}constructor(){this.c=[];const s=Date.now();for(let i=0;i<a.a;i++)this.c[i]=s-1e3*i;setInterval(()=>{for(let i=a.a;i>=1;i--)this.c[i]=this.c[i-1];this.c[0]=Date.now()},1e3)}d(){const s=Date.now(),i=(1+a.a)*1e3;let v=0;for(let S=0;S<a.a;S++)s-this.c[S]<=i&&v++;return 1-v/a.a}hasHighLoad(){return this.d()>=.5}}a.a=10,a.b=null;class o{get unacknowledgedCount(){return this.c-this.d}constructor(s){this.u=new f,this.onControlMessage=this.u.event,this.v=new f,this.onMessage=this.v.event,this.w=new f,this.onDidDispose=this.w.event,this.x=new f,this.onSocketClose=this.x.event,this.y=new f,this.onSocketTimeout=this.y.event,this.s=s.loadEstimator??a.getInstance(),this.t=s.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new P.$Tc,this.o=s.socket,this.p=this.r.add(new u(this.o)),this.q=this.r.add(new m(this.o)),this.r.add(this.q.onMessage(i=>this.z(i))),this.r.add(this.o.onClose(i=>this.x.fire(i))),s.initialChunk&&this.q.acceptChunk(s.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const s=new c(5,0,0,E());this.p.write(s),this.p.flush()}sendPause(){const s=new c(7,0,0,E());this.p.write(s)}sendResume(){const s=new c(8,0,0,E());this.p.write(s)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(s,i){this.a=!0,this.r.dispose(),this.r=new P.$Tc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=s,this.p=this.r.add(new u(this.o)),this.q=this.r.add(new m(this.o)),this.r.add(this.q.onMessage(v=>this.z(v))),this.r.add(this.o.onClose(v=>this.x.fire(v))),this.q.acceptChunk(i)}endAcceptReconnection(){this.a=!1,this.h=this.g;const s=new c(3,0,this.h,E());this.p.write(s);const i=this.b.toArray();for(let v=0,S=i.length;v<S;v++)this.p.write(i[v]);this.B()}acceptDisconnect(){this.w.fire()}z(s){if(s.ack>this.d){this.d=s.ack;do{const i=this.b.peek();if(i&&i.id<=s.ack)this.b.pop();else break}while(!0)}switch(s.type){case 0:break;case 1:{if(s.id>this.g)if(s.id!==this.g+1){const i=Date.now();i-this.m>1e4&&(this.m=i,this.p.write(new c(6,0,0,E())))}else this.g=s.id,this.j=Date.now(),this.A(),this.v.fire(s.data);break}case 2:{this.u.fire(s.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const i=this.b.toArray();for(let v=0,S=i.length;v<S;v++)this.p.write(i[v]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(s){const i=++this.c;this.h=this.g;const v=new c(1,i,this.h,s);this.b.push(v),this.a||(this.p.write(v),this.B())}sendControl(s){const i=new c(2,0,0,s);this.p.write(i)}A(){if(this.g<=this.h||this.k)return;const s=Date.now()-this.j;if(s>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-s+5)}B(){if(this.c<=this.d||this.f||this.a)return;const s=this.b.peek(),i=Date.now()-s.writtenTime,v=Date.now()-this.q.lastReadTime,S=Date.now()-this.n;if(i>=2e4&&v>=2e4&&S>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:i,timeSinceLastReceivedSomeData:v});return}const O=Math.max(2e4-i,2e4-v,2e4-S,500);this.f=setTimeout(()=>{this.f=null,this.B()},O)}C(){if(this.g<=this.h)return;this.h=this.g;const s=new c(3,0,this.h,E());this.p.write(s)}D(){this.h=this.g;const s=new c(9,0,this.h,E());this.p.write(s)}}e.$9h=o}),define(Ee[109],ke([1,0,55,15,14,20,158,10,6,2,21,105,62,44]),function(ce,e,n,A,P,D,C,k,b,$,E,y,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lq=e.$Kq=void 0;class d extends g.$Wh{constructor(u){super({send:p=>{try{process.send?.(p.buffer.toString("base64"))}catch{}},onMessage:b.Event.fromNodeEventEmitter(process,"message",p=>P.$ue.wrap(Buffer.from(p,"base64")))},u),process.once("disconnect",()=>this.dispose())}}e.$Kq=d;class c{constructor(u,p){this.i=u,this.j=p,this.c=new Set,this.g=new Map,this.h=new b.$7d,this.onDidProcessExit=this.h.event;const h=p&&p.timeout?p.timeout:6e4;this.b=new A.$fh(h),this.d=null,this.f=null}getChannel(u){const p=this;return{call(h,f,l){return p.k(u,h,f,l)},listen(h,f){return p.l(u,h,f)}}}k(u,p,h,f=D.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(f.isCancellationRequested)return Promise.reject(k.$6());this.b.cancel();const l=this.n(u),t=(0,A.$8g)(r=>l.call(p,h,r)),a=f.onCancellationRequested(()=>t.cancel()),o=(0,$.$Sc)(()=>t.cancel());return this.c.add(o),t.finally(()=>{a.dispose(),this.c.delete(o),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(u,p,h){if(!this.b)return b.Event.None;this.b.cancel();let f;const l=new b.$7d({onWillAddFirstListener:()=>{f=this.n(u).listen(p,h)(l.fire,l),this.c.add(f)},onDidRemoveLastListener:()=>{this.c.delete(f),f.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return l.event}get m(){if(!this.f){const u=this.j&&this.j.args?this.j.args:[],p=Object.create(null);p.env={...(0,E.$Pn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(p.env={...p.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(p.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(p.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(p.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),p.execArgv===void 0&&(p.execArgv=process.execArgv.filter(i=>!/^--inspect(-brk)?=/.test(i)).filter(i=>!i.startsWith("--vscode-"))),(0,w.$am)(p.env),this.d=(0,n.fork)(this.i,u,p);const h=new b.$7d,l=b.Event.fromNodeEventEmitter(this.d,"message",i=>i)(i=>{if((0,C.$Gq)(i)){(0,C.log)(i,`IPC Library: ${this.j.serverName}`);return}h.fire(P.$ue.wrap(Buffer.from(i,"base64")))}),t=this.j.useQueue?(0,y.$cm)(this.d):this.d,a=i=>this.d&&this.d.connected&&t.send(i.buffer.toString("base64")),o=h.event,r={send:a,onMessage:o};this.f=new g.$Xh(r);const s=()=>this.o();process.once("exit",s),this.d.on("error",i=>console.warn('IPC "'+this.j.serverName+'" errored with '+i)),this.d.on("exit",(i,v)=>{process.removeListener("exit",s),l.dispose(),this.c.forEach(S=>(0,$.$Pc)(S)),this.c.clear(),i!==0&&v!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+i+" and signal "+v),this.b?.cancel(),this.o(),this.h.fire({code:i,signal:v})})}return this.f}n(u){let p=this.g.get(u);return p||(p=this.m.getChannel(u),this.g.set(u,p)),p}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Lq=c}),define(Ee[167],ke([1,0,15,6,2,53,11]),function(ce,e,n,A,P,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kp=e.$Jp=e.StorageState=e.StorageHint=void 0,e.$Ip=b;var k;(function(w){w[w.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",w[w.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(k||(e.StorageHint=k={}));function b(w){const g=w;return g?.changed instanceof Map||g?.deleted instanceof Set}var $;(function(w){w[w.None=0]="None",w[w.Initialized=1]="Initialized",w[w.Closed=2]="Closed"})($||(e.StorageState=$={}));class E extends P.$Uc{constructor(g,d=Object.create(null)){super(),this.r=g,this.s=d,this.b=this.B(new A.$0d),this.onDidChangeStorage=this.b.event,this.c=$.None,this.f=new Map,this.g=this.B(new n.$gh(E.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(g=>this.u(g)))}u(g){this.b.pause();try{g.changed?.forEach((d,c)=>this.w(c,d)),g.deleted?.forEach(d=>this.w(d,void 0))}finally{this.b.resume()}}w(g,d){if(this.c===$.Closed)return;let c=!1;(0,C.$5f)(d)?c=this.f.delete(g):this.f.get(g)!==d&&(this.f.set(g,d),c=!0),c&&this.b.fire({key:g,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===$.None&&(this.c=$.Initialized,this.s.hint!==k.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(g,d){const c=this.f.get(g);return(0,C.$5f)(c)?d:c}getBoolean(g,d){const c=this.get(g);return(0,C.$5f)(c)?d:c==="true"}getNumber(g,d){const c=this.get(g);return(0,C.$5f)(c)?d:parseInt(c,10)}getObject(g,d){const c=this.get(g);return(0,C.$5f)(c)?d:(0,D.$Qh)(c)}async set(g,d,c=!1){if(this.c===$.Closed)return;if((0,C.$5f)(d))return this.delete(g,c);const m=(0,C.$Xf)(d)||Array.isArray(d)?(0,D.$Ph)(d):String(d);if(this.f.get(g)!==m)return this.f.set(g,m),this.j.set(g,m),this.h.delete(g),this.b.fire({key:g,external:c}),this.D()}async delete(g,d=!1){if(!(this.c===$.Closed||!this.f.delete(g)))return this.h.has(g)||this.h.add(g),this.j.delete(g),this.b.fire({key:g,external:d}),this.D()}async optimize(){if(this.c!==$.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=$.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const g={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(g).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(g){if(this.z)return this.D(g)}async D(g){return this.s.hint===k.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),g)}async whenFlushed(){if(this.z)return new Promise(g=>this.n.push(g))}isInMemory(){return this.s.hint===k.STORAGE_IN_MEMORY}}e.$Jp=E,E.a=100;class y{constructor(){this.onDidChangeItemsExternal=A.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(g){g.insert?.forEach((d,c)=>this.a.set(c,d)),g.delete?.forEach(d=>this.a.delete(d))}async optimize(){}async close(){}}e.$Kp=y}),define(Ee[79],ke([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ct=void 0;class n{constructor(P,D){this.lineNumber=P,this.column=D}with(P=this.lineNumber,D=this.column){return P===this.lineNumber&&D===this.column?this:new n(P,D)}delta(P=0,D=0){return this.with(this.lineNumber+P,this.column+D)}equals(P){return n.equals(this,P)}static equals(P,D){return!P&&!D?!0:!!P&&!!D&&P.lineNumber===D.lineNumber&&P.column===D.column}isBefore(P){return n.isBefore(this,P)}static isBefore(P,D){return P.lineNumber<D.lineNumber?!0:D.lineNumber<P.lineNumber?!1:P.column<D.column}isBeforeOrEqual(P){return n.isBeforeOrEqual(this,P)}static isBeforeOrEqual(P,D){return P.lineNumber<D.lineNumber?!0:D.lineNumber<P.lineNumber?!1:P.column<=D.column}static compare(P,D){const C=P.lineNumber|0,k=D.lineNumber|0;if(C===k){const b=P.column|0,$=D.column|0;return b-$}return C-k}clone(){return new n(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(P){return new n(P.lineNumber,P.column)}static isIPosition(P){return P&&typeof P.lineNumber=="number"&&typeof P.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$ct=n}),define(Ee[45],ke([1,0,79]),function(ce,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dt=void 0;class A{constructor(D,C,k,b){D>k||D===k&&C>b?(this.startLineNumber=k,this.startColumn=b,this.endLineNumber=D,this.endColumn=C):(this.startLineNumber=D,this.startColumn=C,this.endLineNumber=k,this.endColumn=b)}isEmpty(){return A.isEmpty(this)}static isEmpty(D){return D.startLineNumber===D.endLineNumber&&D.startColumn===D.endColumn}containsPosition(D){return A.containsPosition(this,D)}static containsPosition(D,C){return!(C.lineNumber<D.startLineNumber||C.lineNumber>D.endLineNumber||C.lineNumber===D.startLineNumber&&C.column<D.startColumn||C.lineNumber===D.endLineNumber&&C.column>D.endColumn)}static strictContainsPosition(D,C){return!(C.lineNumber<D.startLineNumber||C.lineNumber>D.endLineNumber||C.lineNumber===D.startLineNumber&&C.column<=D.startColumn||C.lineNumber===D.endLineNumber&&C.column>=D.endColumn)}containsRange(D){return A.containsRange(this,D)}static containsRange(D,C){return!(C.startLineNumber<D.startLineNumber||C.endLineNumber<D.startLineNumber||C.startLineNumber>D.endLineNumber||C.endLineNumber>D.endLineNumber||C.startLineNumber===D.startLineNumber&&C.startColumn<D.startColumn||C.endLineNumber===D.endLineNumber&&C.endColumn>D.endColumn)}strictContainsRange(D){return A.strictContainsRange(this,D)}static strictContainsRange(D,C){return!(C.startLineNumber<D.startLineNumber||C.endLineNumber<D.startLineNumber||C.startLineNumber>D.endLineNumber||C.endLineNumber>D.endLineNumber||C.startLineNumber===D.startLineNumber&&C.startColumn<=D.startColumn||C.endLineNumber===D.endLineNumber&&C.endColumn>=D.endColumn)}plusRange(D){return A.plusRange(this,D)}static plusRange(D,C){let k,b,$,E;return C.startLineNumber<D.startLineNumber?(k=C.startLineNumber,b=C.startColumn):C.startLineNumber===D.startLineNumber?(k=C.startLineNumber,b=Math.min(C.startColumn,D.startColumn)):(k=D.startLineNumber,b=D.startColumn),C.endLineNumber>D.endLineNumber?($=C.endLineNumber,E=C.endColumn):C.endLineNumber===D.endLineNumber?($=C.endLineNumber,E=Math.max(C.endColumn,D.endColumn)):($=D.endLineNumber,E=D.endColumn),new A(k,b,$,E)}intersectRanges(D){return A.intersectRanges(this,D)}static intersectRanges(D,C){let k=D.startLineNumber,b=D.startColumn,$=D.endLineNumber,E=D.endColumn;const y=C.startLineNumber,w=C.startColumn,g=C.endLineNumber,d=C.endColumn;return k<y?(k=y,b=w):k===y&&(b=Math.max(b,w)),$>g?($=g,E=d):$===g&&(E=Math.min(E,d)),k>$||k===$&&b>E?null:new A(k,b,$,E)}equalsRange(D){return A.equalsRange(this,D)}static equalsRange(D,C){return!D&&!C?!0:!!D&&!!C&&D.startLineNumber===C.startLineNumber&&D.startColumn===C.startColumn&&D.endLineNumber===C.endLineNumber&&D.endColumn===C.endColumn}getEndPosition(){return A.getEndPosition(this)}static getEndPosition(D){return new n.$ct(D.endLineNumber,D.endColumn)}getStartPosition(){return A.getStartPosition(this)}static getStartPosition(D){return new n.$ct(D.startLineNumber,D.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(D,C){return new A(this.startLineNumber,this.startColumn,D,C)}setStartPosition(D,C){return new A(D,C,this.endLineNumber,this.endColumn)}collapseToStart(){return A.collapseToStart(this)}static collapseToStart(D){return new A(D.startLineNumber,D.startColumn,D.startLineNumber,D.startColumn)}collapseToEnd(){return A.collapseToEnd(this)}static collapseToEnd(D){return new A(D.endLineNumber,D.endColumn,D.endLineNumber,D.endColumn)}delta(D){return new A(this.startLineNumber+D,this.startColumn,this.endLineNumber+D,this.endColumn)}static fromPositions(D,C=D){return new A(D.lineNumber,D.column,C.lineNumber,C.column)}static lift(D){return D?new A(D.startLineNumber,D.startColumn,D.endLineNumber,D.endColumn):null}static isIRange(D){return D&&typeof D.startLineNumber=="number"&&typeof D.startColumn=="number"&&typeof D.endLineNumber=="number"&&typeof D.endColumn=="number"}static areIntersectingOrTouching(D,C){return!(D.endLineNumber<C.startLineNumber||D.endLineNumber===C.startLineNumber&&D.endColumn<C.startColumn||C.endLineNumber<D.startLineNumber||C.endLineNumber===D.startLineNumber&&C.endColumn<D.startColumn)}static areIntersecting(D,C){return!(D.endLineNumber<C.startLineNumber||D.endLineNumber===C.startLineNumber&&D.endColumn<=C.startColumn||C.endLineNumber<D.startLineNumber||C.endLineNumber===D.startLineNumber&&C.endColumn<=D.startColumn)}static compareRangesUsingStarts(D,C){if(D&&C){const $=D.startLineNumber|0,E=C.startLineNumber|0;if($===E){const y=D.startColumn|0,w=C.startColumn|0;if(y===w){const g=D.endLineNumber|0,d=C.endLineNumber|0;if(g===d){const c=D.endColumn|0,m=C.endColumn|0;return c-m}return g-d}return y-w}return $-E}return(D?1:0)-(C?1:0)}static compareRangesUsingEnds(D,C){return D.endLineNumber===C.endLineNumber?D.endColumn===C.endColumn?D.startLineNumber===C.startLineNumber?D.startColumn-C.startColumn:D.startLineNumber-C.startLineNumber:D.endColumn-C.endColumn:D.endLineNumber-C.endLineNumber}static spansMultipleLines(D){return D.endLineNumber>D.startLineNumber}toJSON(){return this}}e.$dt=A}),define(Ee[168],ke([1,0,45]),function(ce,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$et=void 0;class A{static insert(D,C){return{range:new n.$dt(D.lineNumber,D.column,D.lineNumber,D.column),text:C,forceMoveMarkers:!0}}static delete(D){return{range:D,text:null}}static replace(D,C){return{range:D,text:C}}static replaceMove(D,C){return{range:D,text:C,forceMoveMarkers:!0}}}e.$et=A}),define(Ee[169],ke([1,0,6,2]),function(ce,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ot=void 0;class P{constructor(){this.a=new Map,this.b=new Map,this.c=new n.$7d,this.onDidChange=this.c.event,this.d=null}handleChange(k){this.c.fire({changedLanguages:k,changedColorMap:!1})}register(k,b){return this.a.set(k,b),this.handleChange([k]),(0,A.$Sc)(()=>{this.a.get(k)===b&&(this.a.delete(k),this.handleChange([k]))})}get(k){return this.a.get(k)||null}registerFactory(k,b){this.b.get(k)?.dispose();const $=new D(this,k,b);return this.b.set(k,$),(0,A.$Sc)(()=>{const E=this.b.get(k);!E||E!==$||(this.b.delete(k),E.dispose())})}async getOrCreate(k){const b=this.get(k);if(b)return b;const $=this.b.get(k);return!$||$.isResolved?null:(await $.resolve(),this.get(k))}isResolved(k){if(this.get(k))return!0;const $=this.b.get(k);return!!(!$||$.isResolved)}setColorMap(k){this.d=k,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$Ot=P;class D extends A.$Uc{get isResolved(){return this.c}constructor(k,b,$){super(),this.f=k,this.g=b,this.h=$,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const k=await this.h.tokenizationSupport;this.c=!0,k&&!this.a&&this.B(this.f.register(this.g,k))}}}),define(Ee[170],ke([8,9]),function(ce,e){return ce.create("vs/base/common/actions",e)}),define(Ee[171],ke([1,0,6,2,170]),function(ce,e,n,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=void 0,e.$5i=E;class D extends A.$Uc{constructor(w,g="",d="",c=!0,m){super(),this.h=this.B(new n.$7d),this.onDidChange=this.h.event,this.w=!0,this.j=w,this.m=g,this.u=d,this.w=c,this.C=m}get id(){return this.j}get label(){return this.m}set label(w){this.D(w)}D(w){this.m!==w&&(this.m=w,this.h.fire({label:w}))}get tooltip(){return this.n||""}set tooltip(w){this.F(w)}F(w){this.n!==w&&(this.n=w,this.h.fire({tooltip:w}))}get class(){return this.u}set class(w){this.G(w)}G(w){this.u!==w&&(this.u=w,this.h.fire({class:w}))}get enabled(){return this.w}set enabled(w){this.H(w)}H(w){this.w!==w&&(this.w=w,this.h.fire({enabled:w}))}get checked(){return this.z}set checked(w){this.I(w)}I(w){this.z!==w&&(this.z=w,this.h.fire({checked:w}))}async run(w,g){this.C&&await this.C(w)}}e.$Zi=D;class C extends A.$Uc{constructor(){super(...arguments),this.f=this.B(new n.$7d),this.onWillRun=this.f.event,this.m=this.B(new n.$7d),this.onDidRun=this.m.event}async run(w,g){if(!w.enabled)return;this.f.fire({action:w});let d;try{await this.u(w,g)}catch(c){d=c}this.m.fire({action:w,error:d})}async u(w,g){await w.run(g)}}e.$1i=C;class k{constructor(){this.id=k.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...w){let g=[];for(const d of w)d.length&&(g.length?g=[...g,new k,...d]:g=d);return g}async run(){}}e.$2i=k,k.ID="vs.actions.separator";class b{get actions(){return this.a}constructor(w,g,d,c){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=w,this.label=g,this.class=c,this.a=d}async run(){}}e.$3i=b;class $ extends D{constructor(){super($.ID,P.localize(0,null),void 0,!1)}}e.$4i=$,$.ID="vs.actions.empty";function E(y){return{id:y.id,label:y.label,class:y.class,enabled:y.enabled??!0,checked:y.checked,run:async(...w)=>y.run(...w),tooltip:y.label}}}),define(Ee[172],ke([8,9]),function(ce,e){return ce.create("vs/base/common/date",e)}),define(Ee[173],ke([1,0,172]),function(ce,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Om=$,e.$Pm=E,e.$Qm=y;const A=60,P=A*60,D=P*24,C=D*7,k=D*30,b=D*365;function $(w,g,d,c){typeof w!="number"&&(w=w.getTime());const m=Math.round((new Date().getTime()-w)/1e3);if(m<-30)return(0,n.localize)(0,null,$(new Date().getTime()+m*1e3,!1));if(!c&&m<30)return(0,n.localize)(1,null);let u;return m<A?(u=m,g?u===1?d?(0,n.localize)(2,null,u):(0,n.localize)(3,null,u):d?(0,n.localize)(4,null,u):(0,n.localize)(5,null,u):u===1?d?(0,n.localize)(6,null,u):(0,n.localize)(7,null,u):d?(0,n.localize)(8,null,u):(0,n.localize)(9,null,u)):m<P?(u=Math.floor(m/A),g?u===1?d?(0,n.localize)(10,null,u):(0,n.localize)(11,null,u):d?(0,n.localize)(12,null,u):(0,n.localize)(13,null,u):u===1?d?(0,n.localize)(14,null,u):(0,n.localize)(15,null,u):d?(0,n.localize)(16,null,u):(0,n.localize)(17,null,u)):m<D?(u=Math.floor(m/P),g?u===1?d?(0,n.localize)(18,null,u):(0,n.localize)(19,null,u):d?(0,n.localize)(20,null,u):(0,n.localize)(21,null,u):u===1?d?(0,n.localize)(22,null,u):(0,n.localize)(23,null,u):d?(0,n.localize)(24,null,u):(0,n.localize)(25,null,u)):m<C?(u=Math.floor(m/D),g?u===1?(0,n.localize)(26,null,u):(0,n.localize)(27,null,u):u===1?(0,n.localize)(28,null,u):(0,n.localize)(29,null,u)):m<k?(u=Math.floor(m/C),g?u===1?d?(0,n.localize)(30,null,u):(0,n.localize)(31,null,u):d?(0,n.localize)(32,null,u):(0,n.localize)(33,null,u):u===1?d?(0,n.localize)(34,null,u):(0,n.localize)(35,null,u):d?(0,n.localize)(36,null,u):(0,n.localize)(37,null,u)):m<b?(u=Math.floor(m/k),g?u===1?d?(0,n.localize)(38,null,u):(0,n.localize)(39,null,u):d?(0,n.localize)(40,null,u):(0,n.localize)(41,null,u):u===1?d?(0,n.localize)(42,null,u):(0,n.localize)(43,null,u):d?(0,n.localize)(44,null,u):(0,n.localize)(45,null,u)):(u=Math.floor(m/b),g?u===1?d?(0,n.localize)(46,null,u):(0,n.localize)(47,null,u):d?(0,n.localize)(48,null,u):(0,n.localize)(49,null,u):u===1?d?(0,n.localize)(50,null,u):(0,n.localize)(51,null,u):d?(0,n.localize)(52,null,u):(0,n.localize)(53,null,u))}function E(w,g){const d=Math.abs(w/1e3);return d<1?g?(0,n.localize)(54,null,w):(0,n.localize)(55,null,w):d<A?g?(0,n.localize)(56,null,Math.round(w)/1e3):(0,n.localize)(57,null,Math.round(w)/1e3):d<P?g?(0,n.localize)(58,null,Math.round(w/(1e3*A))):(0,n.localize)(59,null,Math.round(w/(1e3*A))):d<D?g?(0,n.localize)(60,null,Math.round(w/(1e3*P))):(0,n.localize)(61,null,Math.round(w/(1e3*P))):(0,n.localize)(62,null,Math.round(w/(1e3*D)))}function y(w){return w.getFullYear()+"-"+String(w.getMonth()+1).padStart(2,"0")+"-"+String(w.getDate()).padStart(2,"0")+"T"+String(w.getHours()).padStart(2,"0")+":"+String(w.getMinutes()).padStart(2,"0")+":"+String(w.getSeconds()).padStart(2,"0")+"."+(w.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Ee[174],ke([8,9]),function(ce,e){return ce.create("vs/base/common/errorMessage",e)}),define(Ee[40],ke([1,0,18,11,174]),function(ce,e,n,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6i=b,e.$7i=$,e.$8i=E;function D(y,w){return w&&(y.stack||y.stacktrace)?P.localize(0,null,k(y),C(y.stack)||C(y.stacktrace)):k(y)}function C(y){return Array.isArray(y)?y.join(`
`):y}function k(y){return y.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${y.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?P.localize(1,null,y.message):y.message||P.localize(2,null)}function b(y=null,w=!1){if(!y)return P.localize(3,null);if(Array.isArray(y)){const g=n.$Hb(y),d=b(g[0],w);return g.length>1?P.localize(4,null,d,g.length):d}if(A.$Vf(y))return y;if(y.detail){const g=y.detail;if(g.error)return D(g.error,w);if(g.exception)return D(g.exception,w)}return y.stack?D(y,w):y.message?y.message:P.localize(5,null)}function $(y){const w=y;return w instanceof Error&&Array.isArray(w.actions)}function E(y,w){let g;return typeof y=="string"?g=new Error(y):g=y,g.actions=w,g}}),define(Ee[175],ke([8,9]),function(ce,e){return ce.create("vs/base/common/jsonErrorMessages",e)}),define(Ee[176],ke([1,0,175]),function(ce,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eq=A;function A(P){switch(P){case 1:return(0,n.localize)(0,null);case 2:return(0,n.localize)(1,null);case 3:return(0,n.localize)(2,null);case 4:return(0,n.localize)(3,null);case 5:return(0,n.localize)(4,null);case 6:return(0,n.localize)(5,null);case 7:return(0,n.localize)(6,null);case 8:return(0,n.localize)(7,null);case 9:return(0,n.localize)(8,null);default:return""}}}),define(Ee[177],ke([8,9]),function(ce,e){return ce.create("vs/base/node/zip",e)}),define(Ee[80],ke([1,0,27,15,7,11,23,177]),function(ce,e,n,A,P,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6p=e.$5p=void 0,e.zip=m,e.$8p=u,e.$9p=h,e.$5p="end of central directory record signature not found";const b=new RegExp(e.$5p);class $ extends Error{constructor(l,t){let a=t.message;switch(l){case"CorruptZip":a=`Corrupt ZIP: ${a}`;break}super(a),this.type=l,this.cause=t}}e.$6p=$;function E(f){const l=f.externalFileAttributes>>16||33188;return[448,56,7].map(t=>l&t).reduce((t,a)=>t+a,l&61440)}function y(f){if(f instanceof $)return f;let l;return b.test(f.message)&&(l="CorruptZip"),new $(l,f)}function w(f,l,t,a,o,r){const s=P.$nc(l),i=P.$kc(a,s);if(!i.startsWith(a))return Promise.reject(new Error(k.localize(0,null,l)));const v=P.$kc(a,l);let S;return r.onCancellationRequested(()=>{S?.destroy()}),Promise.resolve(C.Promises.mkdir(i,{recursive:!0})).then(()=>new Promise((O,N)=>{if(!r.isCancellationRequested)try{S=(0,n.createWriteStream)(v,{mode:t}),S.once("close",()=>O()),S.once("error",N),f.once("error",N),f.pipe(S)}catch(j){N(j)}}))}function g(f,l,t,a){let o=(0,A.$8g)(()=>Promise.resolve()),r=0;const s=a.onCancellationRequested(()=>{o.cancel(),f.close()});return new Promise((i,v)=>{const S=new A.$dh,O=N=>{N.isCancellationRequested||(r++,f.readEntry())};f.once("error",v),f.once("close",()=>o.then(()=>{a.isCancellationRequested||f.entryCount===r?i():v(new $("Incomplete",new Error(k.localize(1,null,r,f.entryCount))))},v)),f.readEntry(),f.on("entry",N=>{if(a.isCancellationRequested)return;if(!t.sourcePathRegex.test(N.fileName)){O(a);return}const j=N.fileName.replace(t.sourcePathRegex,"");if(/\/$/.test(j)){const Z=P.$kc(l,j);o=(0,A.$8g)(he=>C.Promises.mkdir(Z,{recursive:!0}).then(()=>O(he)).then(void 0,v));return}const I=c(f,N),B=E(N);o=(0,A.$8g)(Z=>S.queue(()=>I.then(he=>w(he,j,B,l,t,Z).then(()=>O(Z)))).then(null,v))})}).finally(()=>s.dispose())}async function d(f,l=!1){const{open:t}=await new Promise((a,o)=>{ce(["yauzl"],a,o)});return new Promise((a,o)=>{t(f,l?{lazyEntries:!0}:void 0,(r,s)=>{r?o(y(r)):a((0,D.$7f)(s))})})}function c(f,l){return new Promise((t,a)=>{f.openReadStream(l,(o,r)=>{o?a(y(o)):t((0,D.$7f)(r))})})}async function m(f,l){const{ZipFile:t}=await new Promise((a,o)=>{ce(["yazl"],a,o)});return new Promise((a,o)=>{const r=new t;l.forEach(i=>{i.contents?r.addBuffer(typeof i.contents=="string"?Buffer.from(i.contents,"utf8"):i.contents,i.path):i.localPath&&r.addFile(i.localPath,i.path)}),r.end();const s=(0,n.createWriteStream)(f);r.outputStream.pipe(s),r.outputStream.once("error",o),s.once("error",o),s.once("finish",()=>a(f))})}function u(f,l,t={},a){const o=new RegExp(t.sourcePath?`^${t.sourcePath}`:"");let r=d(f,!0);return t.overwrite&&(r=r.then(s=>C.Promises.rm(l).then(()=>s))),r.then(s=>g(s,l,{sourcePathRegex:o},a))}function p(f,l){return d(f).then(t=>new Promise((a,o)=>{t.on("entry",r=>{r.fileName===l&&c(t,r).then(s=>a(s),s=>o(s))}),t.once("close",()=>o(new Error(k.localize(2,null,l))))}))}function h(f,l){return p(f,l).then(t=>new Promise((a,o)=>{const r=[];t.once("error",o),t.on("data",s=>r.push(s)),t.on("end",()=>a(Buffer.concat(r)))}))}}),define(Ee[178],ke([8,9]),function(ce,e){return ce.create("vs/editor/common/languages",e)}),define(Ee[179],ke([1,0,52,3,168,45,169,178]),function(ce,e,n,A,P,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.ExternalUriOpenerPriority=e.$0t=e.$9t=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadApplicability=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.NewSymbolNameTag=e.$8t=e.$7t=e.SymbolKinds=e.SymbolTag=e.$5t=e.SymbolKind=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.DocumentPasteTriggerKind=e.CodeActionTriggerType=e.$3t=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.PartialAcceptTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.$2t=e.$1t=e.$Zt=void 0,e.$4t=a,e.$6t=r;class b{constructor(J,Y,W){this.offset=J,this.type=Y,this.language=W,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$Zt=b;class ${constructor(J,Y){this.tokens=J,this.endState=Y,this._tokenizationResultBrand=void 0}}e.$1t=$;class E{constructor(J,Y){this.tokens=J,this.endState=Y,this._encodedTokenizationResultBrand=void 0}}e.$2t=E;var y;(function(T){T[T.Method=0]="Method",T[T.Function=1]="Function",T[T.Constructor=2]="Constructor",T[T.Field=3]="Field",T[T.Variable=4]="Variable",T[T.Class=5]="Class",T[T.Struct=6]="Struct",T[T.Interface=7]="Interface",T[T.Module=8]="Module",T[T.Property=9]="Property",T[T.Event=10]="Event",T[T.Operator=11]="Operator",T[T.Unit=12]="Unit",T[T.Value=13]="Value",T[T.Constant=14]="Constant",T[T.Enum=15]="Enum",T[T.EnumMember=16]="EnumMember",T[T.Keyword=17]="Keyword",T[T.Text=18]="Text",T[T.Color=19]="Color",T[T.File=20]="File",T[T.Reference=21]="Reference",T[T.Customcolor=22]="Customcolor",T[T.Folder=23]="Folder",T[T.TypeParameter=24]="TypeParameter",T[T.User=25]="User",T[T.Issue=26]="Issue",T[T.Snippet=27]="Snippet"})(y||(e.CompletionItemKind=y={}));var w;(function(T){const J=new Map;J.set(0,n.$Hj.symbolMethod),J.set(1,n.$Hj.symbolFunction),J.set(2,n.$Hj.symbolConstructor),J.set(3,n.$Hj.symbolField),J.set(4,n.$Hj.symbolVariable),J.set(5,n.$Hj.symbolClass),J.set(6,n.$Hj.symbolStruct),J.set(7,n.$Hj.symbolInterface),J.set(8,n.$Hj.symbolModule),J.set(9,n.$Hj.symbolProperty),J.set(10,n.$Hj.symbolEvent),J.set(11,n.$Hj.symbolOperator),J.set(12,n.$Hj.symbolUnit),J.set(13,n.$Hj.symbolValue),J.set(15,n.$Hj.symbolEnum),J.set(14,n.$Hj.symbolConstant),J.set(15,n.$Hj.symbolEnum),J.set(16,n.$Hj.symbolEnumMember),J.set(17,n.$Hj.symbolKeyword),J.set(27,n.$Hj.symbolSnippet),J.set(18,n.$Hj.symbolText),J.set(19,n.$Hj.symbolColor),J.set(20,n.$Hj.symbolFile),J.set(21,n.$Hj.symbolReference),J.set(22,n.$Hj.symbolCustomColor),J.set(23,n.$Hj.symbolFolder),J.set(24,n.$Hj.symbolTypeParameter),J.set(25,n.$Hj.account),J.set(26,n.$Hj.issues);function Y(ue){let ie=J.get(ue);return ie||(console.info("No codicon found for CompletionItemKind "+ue),ie=n.$Hj.symbolProperty),ie}T.toIcon=Y;const W=new Map;W.set("method",0),W.set("function",1),W.set("constructor",2),W.set("field",3),W.set("variable",4),W.set("class",5),W.set("struct",6),W.set("interface",7),W.set("module",8),W.set("property",9),W.set("event",10),W.set("operator",11),W.set("unit",12),W.set("value",13),W.set("constant",14),W.set("enum",15),W.set("enum-member",16),W.set("enumMember",16),W.set("keyword",17),W.set("snippet",27),W.set("text",18),W.set("color",19),W.set("file",20),W.set("reference",21),W.set("customcolor",22),W.set("folder",23),W.set("type-parameter",24),W.set("typeParameter",24),W.set("account",25),W.set("issue",26);function re(ue,ie){let $e=W.get(ue);return typeof $e>"u"&&!ie&&($e=9),$e}T.fromString=re})(w||(e.CompletionItemKinds=w={}));var g;(function(T){T[T.Deprecated=1]="Deprecated"})(g||(e.CompletionItemTag=g={}));var d;(function(T){T[T.None=0]="None",T[T.KeepWhitespace=1]="KeepWhitespace",T[T.InsertAsSnippet=4]="InsertAsSnippet"})(d||(e.CompletionItemInsertTextRule=d={}));var c;(function(T){T[T.Word=0]="Word",T[T.Line=1]="Line",T[T.Suggest=2]="Suggest"})(c||(e.PartialAcceptTriggerKind=c={}));var m;(function(T){T[T.Invoke=0]="Invoke",T[T.TriggerCharacter=1]="TriggerCharacter",T[T.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(m||(e.CompletionTriggerKind=m={}));var u;(function(T){T[T.Automatic=0]="Automatic",T[T.Explicit=1]="Explicit"})(u||(e.InlineCompletionTriggerKind=u={}));class p{constructor(J,Y,W,re){this.range=J,this.text=Y,this.completionKind=W,this.isSnippetText=re}equals(J){return D.$dt.lift(this.range).equalsRange(J.range)&&this.text===J.text&&this.completionKind===J.completionKind&&this.isSnippetText===J.isSnippetText}}e.$3t=p;var h;(function(T){T[T.Invoke=1]="Invoke",T[T.Auto=2]="Auto"})(h||(e.CodeActionTriggerType=h={}));var f;(function(T){T[T.Automatic=0]="Automatic",T[T.PasteAs=1]="PasteAs"})(f||(e.DocumentPasteTriggerKind=f={}));var l;(function(T){T[T.Invoke=1]="Invoke",T[T.TriggerCharacter=2]="TriggerCharacter",T[T.ContentChange=3]="ContentChange"})(l||(e.SignatureHelpTriggerKind=l={}));var t;(function(T){T[T.Text=0]="Text",T[T.Read=1]="Read",T[T.Write=2]="Write"})(t||(e.DocumentHighlightKind=t={}));function a(T){return T&&A.URI.isUri(T.uri)&&D.$dt.isIRange(T.range)&&(D.$dt.isIRange(T.originSelectionRange)||D.$dt.isIRange(T.targetSelectionRange))}var o;(function(T){T[T.File=0]="File",T[T.Module=1]="Module",T[T.Namespace=2]="Namespace",T[T.Package=3]="Package",T[T.Class=4]="Class",T[T.Method=5]="Method",T[T.Property=6]="Property",T[T.Field=7]="Field",T[T.Constructor=8]="Constructor",T[T.Enum=9]="Enum",T[T.Interface=10]="Interface",T[T.Function=11]="Function",T[T.Variable=12]="Variable",T[T.Constant=13]="Constant",T[T.String=14]="String",T[T.Number=15]="Number",T[T.Boolean=16]="Boolean",T[T.Array=17]="Array",T[T.Object=18]="Object",T[T.Key=19]="Key",T[T.Null=20]="Null",T[T.EnumMember=21]="EnumMember",T[T.Struct=22]="Struct",T[T.Event=23]="Event",T[T.Operator=24]="Operator",T[T.TypeParameter=25]="TypeParameter"})(o||(e.SymbolKind=o={})),e.$5t={17:(0,k.localize)(0,null),16:(0,k.localize)(1,null),4:(0,k.localize)(2,null),13:(0,k.localize)(3,null),8:(0,k.localize)(4,null),9:(0,k.localize)(5,null),21:(0,k.localize)(6,null),23:(0,k.localize)(7,null),7:(0,k.localize)(8,null),0:(0,k.localize)(9,null),11:(0,k.localize)(10,null),10:(0,k.localize)(11,null),19:(0,k.localize)(12,null),5:(0,k.localize)(13,null),1:(0,k.localize)(14,null),2:(0,k.localize)(15,null),20:(0,k.localize)(16,null),15:(0,k.localize)(17,null),18:(0,k.localize)(18,null),24:(0,k.localize)(19,null),3:(0,k.localize)(20,null),6:(0,k.localize)(21,null),14:(0,k.localize)(22,null),22:(0,k.localize)(23,null),25:(0,k.localize)(24,null),12:(0,k.localize)(25,null)};function r(T,J){return(0,k.localize)(26,null,T,e.$5t[J])}var s;(function(T){T[T.Deprecated=1]="Deprecated"})(s||(e.SymbolTag=s={}));var i;(function(T){const J=new Map;J.set(0,n.$Hj.symbolFile),J.set(1,n.$Hj.symbolModule),J.set(2,n.$Hj.symbolNamespace),J.set(3,n.$Hj.symbolPackage),J.set(4,n.$Hj.symbolClass),J.set(5,n.$Hj.symbolMethod),J.set(6,n.$Hj.symbolProperty),J.set(7,n.$Hj.symbolField),J.set(8,n.$Hj.symbolConstructor),J.set(9,n.$Hj.symbolEnum),J.set(10,n.$Hj.symbolInterface),J.set(11,n.$Hj.symbolFunction),J.set(12,n.$Hj.symbolVariable),J.set(13,n.$Hj.symbolConstant),J.set(14,n.$Hj.symbolString),J.set(15,n.$Hj.symbolNumber),J.set(16,n.$Hj.symbolBoolean),J.set(17,n.$Hj.symbolArray),J.set(18,n.$Hj.symbolObject),J.set(19,n.$Hj.symbolKey),J.set(20,n.$Hj.symbolNull),J.set(21,n.$Hj.symbolEnumMember),J.set(22,n.$Hj.symbolStruct),J.set(23,n.$Hj.symbolEvent),J.set(24,n.$Hj.symbolOperator),J.set(25,n.$Hj.symbolTypeParameter);function Y(W){let re=J.get(W);return re||(console.info("No codicon found for SymbolKind "+W),re=n.$Hj.symbolProperty),re}T.toIcon=Y})(i||(e.SymbolKinds=i={}));class v{static asEditOperation(J){return P.$et.replace(D.$dt.lift(J.range),J.text)}}e.$7t=v;class S{static fromValue(J){switch(J){case"comment":return S.Comment;case"imports":return S.Imports;case"region":return S.Region}return new S(J)}constructor(J){this.value=J}}e.$8t=S,S.Comment=new S("comment"),S.Imports=new S("imports"),S.Region=new S("region");var O;(function(T){T[T.AIGenerated=1]="AIGenerated"})(O||(e.NewSymbolNameTag=O={}));var N;(function(T){function J(Y){return!Y||typeof Y!="object"?!1:typeof Y.id=="string"&&typeof Y.title=="string"}T.is=J})(N||(e.Command=N={}));var j;(function(T){T[T.Collapsed=0]="Collapsed",T[T.Expanded=1]="Expanded"})(j||(e.CommentThreadCollapsibleState=j={}));var I;(function(T){T[T.Unresolved=0]="Unresolved",T[T.Resolved=1]="Resolved"})(I||(e.CommentThreadState=I={}));var B;(function(T){T[T.Current=0]="Current",T[T.Outdated=1]="Outdated"})(B||(e.CommentThreadApplicability=B={}));var Z;(function(T){T[T.Editing=0]="Editing",T[T.Preview=1]="Preview"})(Z||(e.CommentMode=Z={}));var he;(function(T){T[T.Published=0]="Published",T[T.Draft=1]="Draft"})(he||(e.CommentState=he={}));var ae;(function(T){T[T.Type=1]="Type",T[T.Parameter=2]="Parameter"})(ae||(e.InlayHintKind=ae={}));class ee{constructor(J){this.b=J,this.a=null}dispose(){this.a&&this.a.then(J=>{J&&J.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$9t=ee,e.$0t=new C.$Ot;var _;(function(T){T[T.None=0]="None",T[T.Option=1]="Option",T[T.Default=2]="Default",T[T.Preferred=3]="Preferred"})(_||(e.ExternalUriOpenerPriority=_={}));var z;(function(T){T[T.Invoke=0]="Invoke",T[T.Automatic=1]="Automatic"})(z||(e.InlineEditTriggerKind=z={}))}),define(Ee[180],ke([8,9]),function(ce,e){return ce.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ee[181],ke([8,9]),function(ce,e){return ce.create("vs/platform/contextkey/common/contextkey",e)}),define(Ee[182],ke([8,9]),function(ce,e){return ce.create("vs/platform/contextkey/common/scanner",e)}),define(Ee[183],ke([8,9]),function(ce,e){return ce.create("vs/platform/environment/node/argv",e)}),define(Ee[184],ke([8,9]),function(ce,e){return ce.create("vs/platform/environment/node/argvHelper",e)}),define(Ee[185],ke([8,9]),function(ce,e){return ce.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(Ee[186],ke([8,9]),function(ce,e){return ce.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ee[187],ke([8,9]),function(ce,e){return ce.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(Ee[188],ke([8,9]),function(ce,e){return ce.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(Ee[189],ke([8,9]),function(ce,e){return ce.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(Ee[190],ke([8,9]),function(ce,e){return ce.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(Ee[191],ke([8,9]),function(ce,e){return ce.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(Ee[192],ke([8,9]),function(ce,e){return ce.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ee[193],ke([8,9]),function(ce,e){return ce.create("vs/platform/files/common/fileService",e)}),define(Ee[194],ke([8,9]),function(ce,e){return ce.create("vs/platform/files/common/files",e)}),define(Ee[195],ke([8,9]),function(ce,e){return ce.create("vs/platform/files/common/io",e)}),define(Ee[196],ke([8,9]),function(ce,e){return ce.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Ee[197],ke([8,9]),function(ce,e){return ce.create("vs/platform/languagePacks/common/languagePacks",e)}),define(Ee[198],ke([8,9]),function(ce,e){return ce.create("vs/platform/log/common/log",e)}),define(Ee[199],ke([8,9]),function(ce,e){return ce.create("vs/platform/markers/common/markers",e)}),define(Ee[200],ke([8,9]),function(ce,e){return ce.create("vs/platform/request/common/request",e)}),define(Ee[201],ke([8,9]),function(ce,e){return ce.create("vs/platform/shell/node/shellEnv",e)}),define(Ee[202],ke([8,9]),function(ce,e){return ce.create("vs/platform/telemetry/common/telemetryService",e)}),define(Ee[203],ke([8,9]),function(ce,e){return ce.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(Ee[204],ke([8,9]),function(ce,e){return ce.create("vs/platform/terminal/common/terminalProfiles",e)}),define(Ee[205],ke([8,9]),function(ce,e){return ce.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Ee[206],ke([8,9]),function(ce,e){return ce.create("vs/platform/workspace/common/workspace",e)}),define(Ee[207],ke([8,9]),function(ce,e){return ce.create("vs/server/node/remoteExtensionHostAgentCli",e)}),define(Ee[208],ke([8,9]),function(ce,e){return ce.create("vs/server/node/serverEnvironmentService",e)}),define(Ee[209],ke([8,9]),function(ce,e){return ce.create("vs/server/node/serverServices",e)}),define(Ee[210],ke([8,9]),function(ce,e){return ce.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ee[211],ke([8,9]),function(ce,e){return ce.create("vs/workbench/common/editor",e)}),define(Ee[212],ke([8,9]),function(ce,e){return ce.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ee[213],ke([8,9]),function(ce,e){return ce.create("vs/workbench/services/extensions/common/extensionsUtil",e)}),define(Ee[214],ke([1,0,10,182]),function(ce,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dj=e.TokenType=void 0;var P;(function($){$[$.LParen=0]="LParen",$[$.RParen=1]="RParen",$[$.Neg=2]="Neg",$[$.Eq=3]="Eq",$[$.NotEq=4]="NotEq",$[$.Lt=5]="Lt",$[$.LtEq=6]="LtEq",$[$.Gt=7]="Gt",$[$.GtEq=8]="GtEq",$[$.RegexOp=9]="RegexOp",$[$.RegexStr=10]="RegexStr",$[$.True=11]="True",$[$.False=12]="False",$[$.In=13]="In",$[$.Not=14]="Not",$[$.And=15]="And",$[$.Or=16]="Or",$[$.Str=17]="Str",$[$.QuotedStr=18]="QuotedStr",$[$.Error=19]="Error",$[$.EOF=20]="EOF"})(P||(e.TokenType=P={}));function D(...$){switch($.length){case 1:return(0,A.localize)(0,null,$[0]);case 2:return(0,A.localize)(1,null,$[0],$[1]);case 3:return(0,A.localize)(2,null,$[0],$[1],$[2]);default:return}}const C=(0,A.localize)(3,null),k=(0,A.localize)(4,null);class b{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(E){switch(E.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return E.isTripleEq?"===":"==";case 4:return E.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return E.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return E.lexeme;case 18:return E.lexeme;case 19:return E.lexeme;case 20:return"EOF";default:throw(0,n.$8)(`unhandled token type: ${JSON.stringify(E)}; have you forgotten to add a case?`)}}get errors(){return this.g}reset(E){return this.c=E,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const y=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:y})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const y=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:y})}else this.h(126)?this.k(9):this.l(D("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(D("&&"));break;case 124:this.h(124)?this.k(16):this.l(D("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(E){return this.r()||this.c.charCodeAt(this.e)!==E?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(E){this.f.push({type:E,offset:this.d})}l(E){const y=this.d,w=this.c.substring(this.d,this.e),g={type:19,offset:this.d,lexeme:w};this.g.push({offset:y,lexeme:w,additionalInfo:E}),this.f.push(g)}n(){this.m.lastIndex=this.d;const E=this.m.exec(this.c);if(E){this.e=this.d+E[0].length;const y=this.c.substring(this.d,this.e),w=b.b.get(y);w?this.k(w):this.f.push({type:17,lexeme:y,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(C);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let E=this.e,y=!1,w=!1;for(;;){if(E>=this.c.length){this.e=E,this.l(k);return}const d=this.c.charCodeAt(E);if(y)y=!1;else if(d===47&&!w){E++;break}else d===91?w=!0:d===92?y=!0:d===93&&(w=!1);E++}for(;E<this.c.length&&b.a.has(this.c.charCodeAt(E));)E++;this.e=E;const g=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:g,offset:this.d})}r(){return this.e>=this.c.length}}e.$dj=b,b.a=new Set(["i","g","s","m","y","u"].map($=>$.charCodeAt(0))),b.b=new Map([["not",14],["in",13],["false",12],["true",11]])}),define(Ee[215],ke([1,0,6,2]),function(ce,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wo=e.$vo=void 0;class P{constructor(){this.a=new n.$7d,this.b=new n.$7d,this.c=new n.$7d,this.d=new n.$7d}call(k,b,$){switch(b){case"close":return Promise.resolve(this.a.fire({sessionId:$[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:$[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:$[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:$[0],port:$[1],subId:$[2]}))}throw new Error("Method not implemented.")}listen(k,b,$){switch(b){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$vo=P,P.ChannelName="extensionhostdebugservice";class D extends A.$Uc{constructor(k){super(),this.b=k}reload(k){this.b.call("reload",[k])}get onReload(){return this.b.listen("reload")}close(k){this.b.call("close",[k])}get onClose(){return this.b.listen("close")}attachSession(k,b,$){this.b.call("attach",[k,b,$])}get onAttachSession(){return this.b.listen("attach")}terminateSession(k,b){this.b.call("terminate",[k,b])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(k,b){return this.b.call("openExtensionDevelopmentHostWindow",[k,b])}}e.$wo=D}),define(Ee[216],ke([1,0,3]),function(ce,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zo=e.$yo=void 0;class A{constructor(C){this.a=C}listen(C,k,b){throw new Error("Invalid listen")}call(C,k,b){switch(k){case"download":return this.a.download(n.URI.revive(b[0]),n.URI.revive(b[1]))}throw new Error("Invalid call")}}e.$yo=A;class P{constructor(C,k){this.a=C,this.b=k}async download(C,k){const b=this.b();b&&(C=b.transformOutgoingURI(C),k=b.transformOutgoingURI(k)),await this.a.call("download",[C,k])}}e.$zo=P}),define(Ee[217],ke([1,0,173,74,12,7,30,19,3]),function(ce,e,n,A,P,D,C,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sm=e.$Rm=void 0,e.$Tm=E,e.$Um=y,e.$Rm=/^([^.]+\..+)[:=](.+)$/;class ${get appRoot(){return(0,D.$nc)(P.$Cg.asFileUri("").fsPath)}get userHome(){return b.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return b.URI.file((0,D.$kc)(this.userDataPath,"User"))}get tmpDir(){return b.URI.file(this.b.tmpDir)}get cacheHome(){return b.URI.file(this.userDataPath)}get stateResource(){return(0,k.$Vg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:P.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,k.$Vg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const g=(0,n.$Qm)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,D.$kc)(this.userDataPath,"logs",g)}return b.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,k.$Vg)(b.URI.file((0,D.$kc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,k.$Vg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,k.$Vg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,k.$Vg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const g=C.env.VSCODE_PORTABLE;return g?b.URI.file((0,D.$kc)(g,"argv.json")):(0,k.$Vg)(this.appSettingsHome,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return b.URI.file((0,D.$kc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const g=this.args["builtin-extensions-dir"];return g?(0,D.$lc)(g):(0,D.$ic)((0,D.$kc)(P.$Cg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const g=this.args["extensions-download-dir"];return g?b.URI.file((0,D.$lc)(g)):b.URI.file((0,D.$kc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const g=this.args["extensions-dir"];if(g)return(0,D.$lc)(g);const d=C.env.VSCODE_EXTENSIONS;if(d)return d;const c=C.env.VSCODE_PORTABLE;return c?(0,D.$kc)(c,"extensions"):(0,k.$Vg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const g=this.args.extensionDevelopmentPath;if(Array.isArray(g))return g.map(d=>/^[^:/?#]+?:\/\//.test(d)?b.URI.parse(d):b.URI.file((0,D.$ic)(d)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(g=>g==="ui"||g==="workspace"||g==="web"?g:"workspace")}get extensionTestsLocationURI(){const g=this.args.extensionTestsPath;if(g)return/^[^:/?#]+?:\/\//.test(g)?b.URI.parse(g):b.URI.file((0,D.$ic)(g))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const g=this.args["disable-extension"];if(g){if(typeof g=="string")return[g];if(Array.isArray(g)&&g.length>0)return g}return!1}get debugExtensionHost(){return E(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!C.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(g=>!e.$Rm.test(g))}get extensionLogLevel(){const g=[];for(const d of this.args.log||[]){const c=e.$Rm.exec(d);c&&c[1]&&c[2]&&g.push([c[1],c[2]])}return g.length?g:void 0}get serviceMachineIdResource(){return(0,k.$Vg)(b.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const g=C.env.VSCODE_PORTABLE;return g?b.URI.file((0,D.$kc)(g,"policy.json")):(0,k.$Vg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(g){this.args.continueOn=g}get args(){return this.a}constructor(g,d,c){this.a=g,this.b=d,this.c=c,this.editSessionId=this.args.editSessionId}}e.$Sm=$,Fe([A.$Mh],$.prototype,"appRoot",null),Fe([A.$Mh],$.prototype,"userHome",null),Fe([A.$Mh],$.prototype,"userDataPath",null),Fe([A.$Mh],$.prototype,"appSettingsHome",null),Fe([A.$Mh],$.prototype,"tmpDir",null),Fe([A.$Mh],$.prototype,"cacheHome",null),Fe([A.$Mh],$.prototype,"stateResource",null),Fe([A.$Mh],$.prototype,"userRoamingDataHome",null),Fe([A.$Mh],$.prototype,"userDataSyncHome",null),Fe([A.$Mh],$.prototype,"sync",null),Fe([A.$Mh],$.prototype,"machineSettingsResource",null),Fe([A.$Mh],$.prototype,"workspaceStorageHome",null),Fe([A.$Mh],$.prototype,"localHistoryHome",null),Fe([A.$Mh],$.prototype,"keyboardLayoutResource",null),Fe([A.$Mh],$.prototype,"argvResource",null),Fe([A.$Mh],$.prototype,"isExtensionDevelopment",null),Fe([A.$Mh],$.prototype,"untitledWorkspacesHome",null),Fe([A.$Mh],$.prototype,"builtinExtensionsPath",null),Fe([A.$Mh],$.prototype,"extensionsPath",null),Fe([A.$Mh],$.prototype,"extensionDevelopmentLocationURI",null),Fe([A.$Mh],$.prototype,"extensionDevelopmentKind",null),Fe([A.$Mh],$.prototype,"extensionTestsLocationURI",null),Fe([A.$Mh],$.prototype,"debugExtensionHost",null),Fe([A.$Mh],$.prototype,"logLevel",null),Fe([A.$Mh],$.prototype,"extensionLogLevel",null),Fe([A.$Mh],$.prototype,"serviceMachineIdResource",null),Fe([A.$Mh],$.prototype,"disableTelemetry",null),Fe([A.$Mh],$.prototype,"disableWorkspaceTrust",null),Fe([A.$Mh],$.prototype,"useInMemorySecretStorage",null),Fe([A.$Mh],$.prototype,"policyFile",null);function E(w,g){return y(w["inspect-extensions"],w["inspect-brk-extensions"],5870,g,w.debugId,w.extensionEnvironment)}function y(w,g,d,c,m,u){const h=Number(g||w)||(c?null:d),f=h?!!g:!1;let l;if(u)try{l=JSON.parse(u)}catch{}return{port:h,break:f,debugId:m,env:l}}}),define(Ee[67],ke([1,0,309,4,183]),function(ce,e,n,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fm=e.$em=void 0,e.$gm=k,e.$hm=$,e.$im=g,e.$jm=d;const D={o:(0,P.localize)(0,null),e:(0,P.localize)(1,null),t:(0,P.localize)(2,null)};e.$em=["tunnel","serve-web"],e.$fm={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,P.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,P.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,P.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,P.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,P.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,P.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,P.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,P.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,P.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,P.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,P.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,P.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,P.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,P.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,P.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,P.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,P.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,P.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,P.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,P.localize)(22,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,P.localize)(23,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,P.localize)(24,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,P.localize)(25,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,P.localize)(26,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,P.localize)(27,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,P.localize)(28,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,P.localize)(29,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,P.localize)(30,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,P.localize)(31,null)},sync:{type:"string",cat:"t",description:(0,P.localize)(32,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,P.localize)(33,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,P.localize)(34,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,P.localize)(35,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,P.localize)(36,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,P.localize)(37,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},"ozone-platform":{type:"string"},_:{type:"string[]"}};const C={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function k(c,m,u=C){const p=c.find(i=>i.length>0&&i[0]!=="-"),h={},f=["_"],l=[],t={};let a;for(const i in m){const v=m[i];v.type==="subcommand"?i===p&&(a=v):(v.alias&&(h[i]=v.alias),v.type==="string"||v.type==="string[]"?(f.push(i),v.deprecates&&f.push(...v.deprecates)):v.type==="boolean"&&(l.push(i),v.deprecates&&l.push(...v.deprecates)),v.global&&(t[i]=v))}if(a&&p){const i=t;for(const N in a.options)i[N]=a.options[N];const v=c.filter(N=>N!==p),S=u.getSubcommandReporter?u.getSubcommandReporter(p):void 0,O=k(v,i,S);return{[p]:O,_:[]}}const o=n(c,{string:f,boolean:l,alias:h}),r={},s=o;r._=o._.map(i=>String(i)).filter(i=>i.length>0),delete s._;for(const i in m){const v=m[i];if(v.type==="subcommand")continue;v.alias&&delete s[v.alias];let S=s[i];if(v.deprecates)for(const O of v.deprecates)s.hasOwnProperty(O)&&(S||(S=s[O],S&&u.onDeprecatedOption(O,v.deprecationMessage||(0,P.localize)(38,null,i))),delete s[O]);if(typeof S<"u"){if(v.type==="string[]"){if(Array.isArray(S)||(S=[S]),!v.allowEmptyValue){const O=S.filter(N=>N.length>0);O.length!==S.length&&(u.onEmptyValue(i),S=O.length>0?O:void 0)}}else v.type==="string"&&(Array.isArray(S)?(S=S.pop(),u.onMultipleValues(i,S)):!S&&!v.allowEmptyValue&&(u.onEmptyValue(i),S=void 0));r[i]=S,v.deprecationMessage&&u.onDeprecatedOption(i,v.deprecationMessage)}delete s[i]}for(const i in s)u.onUnknownOption(i);return r}function b(c,m){let u="";return m.args&&(Array.isArray(m.args)?u=` <${m.args.join("> <")}>`:u=` <${m.args}>`),m.alias?`-${m.alias} --${c}${u}`:`--${c}${u}`}function $(c,m){const u=[];for(const p in c){const h=c[p],f=b(p,h);u.push([f,h.description])}return E(u,m)}function E(c,m){const p=c.reduce((l,t)=>Math.max(l,t[0].length),12)+2+1;if(m-p<25)return c.reduce((l,t)=>l.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const h=m-p-1,f=[];for(const l of c){const t=l[0],a=w(l[1],h),o=y(p-t.length-2);f.push("  "+t+o+a[0]);for(let r=1;r<a.length;r++)f.push(y(p)+a[r])}return f}function y(c){return" ".repeat(c)}function w(c,m){const u=[];for(;c.length;){const p=c.length<m?c.length:c.lastIndexOf(" ",m),h=c.slice(0,p).trim();c=c.slice(p),u.push(h)}return u}function g(c,m,u,p,h){const f=process.stdout.isTTY&&process.stdout.columns||80,l=h?.noInputFiles!==!0?`[${(0,P.localize)(39,null)}...]`:"",t=[`${c} ${u}`];t.push(""),t.push(`${(0,P.localize)(40,null)}: ${m} [${(0,P.localize)(41,null)}]${l}`),t.push(""),h?.noPipe!==!0&&(A.$c?t.push((0,P.localize)(42,null,m)):t.push((0,P.localize)(43,null,m)),t.push(""));const a={},o=[];for(const r in p){const s=p[r];if(s.type==="subcommand")s.description&&o.push({command:r,description:s.description});else if(s.description&&s.cat){let i=a[s.cat];i||(a[s.cat]=i={}),i[r]=s}}for(const r in a){const s=r,i=a[s];i&&(t.push(D[s]),t.push(...$(i,f)),t.push(""))}return o.length&&(t.push((0,P.localize)(44,null)),t.push(...E(o.map(r=>[r.command,r.description]),f)),t.push("")),t.join(`
`)}function d(c,m){return`${c||(0,P.localize)(45,null)}
${m||(0,P.localize)(46,null)}
${process.arch}`}}),define(Ee[218],ke([1,0,310,184,67]),function(ce,e,n,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$km=k,e.$lm=b,e.$mm=$,e.$nm=E;function D(y,w){const g=(h,f)=>{console.warn((0,A.localize)(0,null,h,f))},d=h=>{console.warn((0,A.localize)(1,null,h))},c=(h,f)=>{console.warn((0,A.localize)(2,null,h,f))},m=h=>({onUnknownOption:f=>{P.$em.includes(h)||console.warn((0,A.localize)(3,null,f,h))},onMultipleValues:g,onEmptyValue:d,onDeprecatedOption:c,getSubcommandReporter:P.$em.includes(h)?m:void 0}),u={onUnknownOption:h=>{console.warn((0,A.localize)(4,null,h))},onMultipleValues:g,onEmptyValue:d,onDeprecatedOption:c,getSubcommandReporter:m},p=(0,P.$gm)(y,P.$fm,w?u:void 0);return p.goto&&p._.forEach(h=>n(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(h),(0,A.localize)(5,null))),p}function C(y){const w=y.findIndex(g=>!/^-/.test(g));if(w>-1)return[...y.slice(0,w),...y.slice(w+1)]}function k(y){let[,...w]=y;process.env.VSCODE_DEV&&(w=C(w)||[]);const g=!E(process.env);return D(w,g)}function b(y){let[,,...w]=y;return process.env.VSCODE_DEV&&(w=C(w)||[]),D(w,!0)}function $(y,...w){const g=y.indexOf("--");return g===-1?y.push(...w):y.splice(g,0,...w),y}function E(y){return y.VSCODE_CLI==="1"}}),function(){"use strict";function ce(e,n,A){function P(C,k){const b=D(C,k),$=[b];return e.isAbsolute(b)||$.unshift(A),e.resolve(...$)}function D(C,k){process.env.VSCODE_DEV&&(k="code-oss-dev");const b=process.env.VSCODE_PORTABLE;if(b)return e.join(b,"user-data");let $=process.env.VSCODE_APPDATA;if($)return e.join($,k);const E=C["user-data-dir"];if(E)return E;switch(process.platform){case"win32":if($=process.env.APPDATA,!$){const y=process.env.USERPROFILE;if(typeof y!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");$=e.join(y,"AppData","Roaming")}break;case"darwin":$=e.join(n.homedir(),"Library","Application Support");break;case"linux":$=process.env.XDG_CONFIG_HOME||e.join(n.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join($,k)}return{getUserDataPath:P}}if(typeof define=="function")define(Ee[219],ke([77,28,30]),function(e,n,A){return ce(e,n,A.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),n=require("os");module.exports=ce(e,n,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Ee[110],ke([1,0,28,217,219]),function(ce,e,n,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vm=void 0,e.$Wm=C,e.$Xm=k;class D extends A.$Sm{constructor($,E){super($,{homeDir:(0,n.homedir)(),tmpDir:(0,n.tmpdir)(),userDataDir:(0,P.getUserDataPath)($,E.nameShort)},E)}}e.$Vm=D;function C(b,$){return(0,A.$Um)(b["inspect-ptyhost"],b["inspect-brk-ptyhost"],5877,$,b.extensionEnvironment)}function k(b,$){return(0,A.$Um)(b["inspect-sharedprocess"],b["inspect-brk-sharedprocess"],5879,$,b.extensionEnvironment)}}),define(Ee[220],ke([1,0,11,188]),function(ce,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fq=P;function P(C,k,b,$){try{D(C,k,b,$)}catch(E){C.error(E?.message??E)}return k}function D(C,k,b,$){const E=(y,w,g)=>{const d=y[w];if((0,n.$Vf)(d)){const c=d,m=c.length;if(m>1&&c[0]==="%"&&c[m-1]==="%"){const u=c.substr(1,m-2);let p=b[u];p===void 0&&$&&(p=$[u]);const h=typeof p=="string"?p:p?.message,f=$?.[u],l=typeof f=="string"?f:f?.message;if(!h){l||C.warn(`[${k.name}]: ${(0,A.localize)(0,null,u)}`);return}if(g&&(w==="title"||w==="category")&&l&&l!==h){const t={value:h,original:l};y[w]=t}else y[w]=h}}else if((0,n.$Xf)(d))for(const c in d)d.hasOwnProperty(c)&&(c==="commands"?E(d,c,!0):E(d,c,g));else if(Array.isArray(d))for(let c=0;c<d.length;c++)E(d,c,g)};for(const y in k)k.hasOwnProperty(y)&&E(k,y)}}),define(Ee[221],ke([1,0,80,191]),function(ce,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nq=P;function P(D){return(0,n.$9p)(D,"extension/package.json").then(C=>{try{return JSON.parse(C.toString("utf8"))}catch{throw new Error((0,A.localize)(0,null))}})}}),define(Ee[81],ke([1,0,19,65,192,56]),function(ce,e,n,A,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tp=b,e.$up=$,e.$vp=E,e.$wp=y,e.$xp=w,e.$yp=g,e.$zp=d;const C=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,k=/^-(\d{4})(\d{2})(\d{2})$/;function b(u){return u=u.trim(),u==="*"||C.test(u)}function $(u){if(!b(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const p=u.match(C);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}function E(u){if(!u)return null;const p=u.majorBase,h=u.majorMustEqual,f=u.minorBase;let l=u.minorMustEqual;const t=u.patchBase;let a=u.patchMustEqual;u.hasCaret&&(p===0||(l=!1),a=!1);let o=0;if(u.preRelease){const r=k.exec(u.preRelease);if(r){const[,s,i,v]=r;o=Date.UTC(Number(s),Number(i)-1,Number(v))}}return{majorBase:p,majorMustEqual:h,minorBase:f,minorMustEqual:l,patchBase:t,patchMustEqual:a,isMinimum:u.hasGreaterEquals,notBefore:o}}function y(u,p,h){let f;typeof u=="string"?f=E($(u)):f=u;let l;p instanceof Date?l=p.getTime():typeof p=="string"&&(l=new Date(p).getTime());let t;if(typeof h=="string"?t=E($(h)):t=h,!f||!t)return!1;const a=f.majorBase,o=f.minorBase,r=f.patchBase;let s=t.majorBase,i=t.minorBase,v=t.patchBase;const S=t.notBefore;let O=t.majorMustEqual,N=t.minorMustEqual,j=t.patchMustEqual;return t.isMinimum?a>s?!0:a<s?!1:o>i?!0:o<i||l&&l<S?!1:r>=v:(a===1&&s===0&&(!O||!N||!j)&&(s=1,i=0,v=0,O=!0,N=!1,j=!1),a<s?!1:a>s?!O:o<i?!1:o>i?!N:r<v?!1:r>v?!j:!(l&&l<S))}function w(u,p,h,f,l){const t=[];if(typeof f.publisher<"u"&&typeof f.publisher!="string")return t.push([A.default.Error,P.localize(0,null)]),t;if(typeof f.name!="string")return t.push([A.default.Error,P.localize(1,null,"name")]),t;if(typeof f.version!="string")return t.push([A.default.Error,P.localize(2,null,"version")]),t;if(!f.engines)return t.push([A.default.Error,P.localize(3,null,"engines")]),t;if(typeof f.engines.vscode!="string")return t.push([A.default.Error,P.localize(4,null,"engines.vscode")]),t;if(typeof f.extensionDependencies<"u"&&!m(f.extensionDependencies))return t.push([A.default.Error,P.localize(5,null,"extensionDependencies")]),t;if(typeof f.activationEvents<"u"){if(!m(f.activationEvents))return t.push([A.default.Error,P.localize(6,null,"activationEvents")]),t;if(typeof f.main>"u"&&typeof f.browser>"u")return t.push([A.default.Error,P.localize(7,null,"activationEvents","main","browser")]),t}if(typeof f.extensionKind<"u"&&typeof f.main>"u"&&t.push([A.default.Warning,P.localize(8,null,"extensionKind")]),typeof f.main<"u"){if(typeof f.main!="string")return t.push([A.default.Error,P.localize(9,null,"main")]),t;{const r=(0,n.$Vg)(h,f.main);(0,n.$Pg)(r,h)||t.push([A.default.Warning,P.localize(10,null,r.path,h.path)])}}if(typeof f.browser<"u"){if(typeof f.browser!="string")return t.push([A.default.Error,P.localize(11,null,"browser")]),t;{const r=(0,n.$Vg)(h,f.browser);(0,n.$Pg)(r,h)||t.push([A.default.Warning,P.localize(12,null,r.path,h.path)])}}if(!D.valid(f.version))return t.push([A.default.Error,P.localize(13,null)]),t;const a=[];if(!g(u,p,f,l,a))for(const r of a)t.push([A.default.Error,r]);return t}function g(u,p,h,f,l){return f||typeof h.main>"u"&&typeof h.browser>"u"?!0:c(u,p,h.engines.vscode,l)}function d(u,p,h){return u==="*"||c(p,h,u)}function c(u,p,h,f=[]){const l=E($(h));if(!l)return f.push(P.localize(14,null,h)),!1;if(l.majorBase===0){if(!l.majorMustEqual||!l.minorMustEqual)return f.push(P.localize(15,null,h)),!1}else if(!l.majorMustEqual)return f.push(P.localize(16,null,h)),!1;return y(u,p,l)?!0:(f.push(P.localize(17,null,u,h)),!1)}function m(u){if(!Array.isArray(u))return!1;for(let p=0,h=u.length;p<h;p++)if(typeof u[p]!="string")return!1;return!0}}),define(Ee[222],ke([1,0,14,22]),function(ce,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tp=P;async function P(D,C,k){let b=k&&k.get("storage.serviceMachineId",-1)||null;if(b)return b;try{const E=(await C.readFile(D.serviceMachineIdResource)).value.toString();b=(0,A.$Dg)(E)?E:null}catch{b=null}if(!b){b=(0,A.$Eg)();try{await C.writeFile(D.serviceMachineIdResource,n.$ue.fromString(b))}catch{}}return k?.store("storage.serviceMachineId",b,-1,1),b}}),define(Ee[68],ke([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=void 0;class n{constructor(P,D=[],C=!1){this.ctor=P,this.staticArguments=D,this.supportsDelayedInstantiation=C}}e.$fi=n}),define(Ee[111],ke([1,0,68]),function(ce,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$hs=D,e.$is=C;const A=[];var P;(function(k){k[k.Eager=0]="Eager",k[k.Delayed=1]="Delayed"})(P||(e.InstantiationType=P={}));function D(k,b,$){b instanceof n.$fi||(b=new n.$fi(b,[],!!$)),A.push([k,b])}function C(){return A}}),define(Ee[223],ke([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yq=e.$Xq=void 0;class n{constructor(D,C){this.key=D,this.data=C,this.incoming=new Map,this.outgoing=new Map}}e.$Xq=n;class A{constructor(D){this.b=D,this.a=new Map}roots(){const D=[];for(const C of this.a.values())C.outgoing.size===0&&D.push(C);return D}insertEdge(D,C){const k=this.lookupOrInsertNode(D),b=this.lookupOrInsertNode(C);k.outgoing.set(b.key,b),b.incoming.set(k.key,k)}removeNode(D){const C=this.b(D);this.a.delete(C);for(const k of this.a.values())k.outgoing.delete(C),k.incoming.delete(C)}lookupOrInsertNode(D){const C=this.b(D);let k=this.a.get(C);return k||(k=new n(C,D),this.a.set(C,k)),k}lookup(D){return this.a.get(this.b(D))}isEmpty(){return this.a.size===0}toString(){const D=[];for(const[C,k]of this.a)D.push(`${C}
	(-> incoming)[${[...k.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...k.outgoing.keys()].join(",")}]
`);return D.join(`
`)}findCycleSlow(){for(const[D,C]of this.a){const k=new Set([D]),b=this.c(C,k);if(b)return b}}c(D,C){for(const[k,b]of D.outgoing){if(C.has(k))return[...C,k].join(" -> ");C.add(k);const $=this.c(b,C);if($)return $;C.delete(k)}}}e.$Yq=A}),define(Ee[5],ke([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hi=e._util=void 0,e.$ii=P,e.$ji=D;var n;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function k(b){return b[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=k})(n||(e._util=n={})),e.$hi=P("instantiationService");function A(C,k,b){k[n.DI_TARGET]===k?k[n.DI_DEPENDENCIES].push({id:C,index:b}):(k[n.DI_DEPENDENCIES]=[{id:C,index:b}],k[n.DI_TARGET]=k)}function P(C){if(n.serviceIds.has(C))return n.serviceIds.get(C);const k=function(b,$,E){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");A(k,b,E)};return k.toString=()=>C,n.serviceIds.set(C,k),k}function D(C){return C}}),define(Ee[25],ke([1,0,11,3,5]),function(ce,e,n,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$Oi=void 0,e.$Pi=D,e.$Qi=C,e.$Ri=b,e.$Si=$,e.$Ti=E,e.$Ui=y,e.$Vi=w,e.$Wi=d,e.$Xi=c,e.$Yi=m,e.$Oi=(0,P.$ii)("configurationService");function D(u){return u&&typeof u=="object"&&(!u.overrideIdentifier||typeof u.overrideIdentifier=="string")&&(!u.resource||u.resource instanceof A.URI)}function C(u){return u&&typeof u=="object"&&(!u.overrideIdentifiers||Array.isArray(u.overrideIdentifiers))&&!u.overrideIdentifier&&(!u.resource||u.resource instanceof A.URI)}var k;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.USER=2]="USER",u[u.USER_LOCAL=3]="USER_LOCAL",u[u.USER_REMOTE=4]="USER_REMOTE",u[u.WORKSPACE=5]="WORKSPACE",u[u.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",u[u.DEFAULT=7]="DEFAULT",u[u.MEMORY=8]="MEMORY"})(k||(e.ConfigurationTarget=k={}));function b(u){switch(u){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function $(u){return u.applicationValue!==void 0||u.userValue!==void 0||u.userLocalValue!==void 0||u.userRemoteValue!==void 0||u.workspaceValue!==void 0||u.workspaceFolderValue!==void 0}function E(u,p){const h=Object.create(null);for(const f in u)y(h,f,u[f],p);return h}function y(u,p,h,f){const l=p.split("."),t=l.pop();let a=u;for(let o=0;o<l.length;o++){const r=l[o];let s=a[r];switch(typeof s){case"undefined":s=a[r]=Object.create(null);break;case"object":break;default:f(`Ignoring ${p} as ${l.slice(0,o+1).join(".")} is ${JSON.stringify(s)}`);return}a=s}if(typeof a=="object"&&a!==null)try{a[t]=h}catch{f(`Ignoring ${p} as ${l.join(".")} is ${JSON.stringify(a)}`)}else f(`Ignoring ${p} as ${l.join(".")} is ${JSON.stringify(a)}`)}function w(u,p){const h=p.split(".");g(u,h)}function g(u,p){const h=p.shift();if(p.length===0){delete u[h];return}if(Object.keys(u).indexOf(h)!==-1){const f=u[h];typeof f=="object"&&!Array.isArray(f)&&(g(f,p),Object.keys(f).length===0&&delete u[h])}}function d(u,p,h){function f(a,o){let r=a;for(const s of o){if(typeof r!="object"||r===null)return;r=r[s]}return r}const l=p.split("."),t=f(u,l);return typeof t>"u"?h:t}function c(u,p,h){Object.keys(p).forEach(f=>{f!=="__proto__"&&(f in u?n.$Xf(u[f])&&n.$Xf(p[f])?c(u[f],p[f],h):h&&(u[f]=p[f]):u[f]=p[f])})}function m(u){return u.replace(/[\[\]]/g,"")}}),define(Ee[57],ke([1,0,4,17,214,5,181,10]),function(ce,e,n,A,P,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$gj=e.$fj=e.ContextKeyExprType=void 0,e.$ej=$,e.$hj=a,e.$ij=o,e.$Bj=ie;const b=new Map;b.set("false",!1),b.set("true",!0),b.set("isMac",n.$d),b.set("isLinux",n.$e),b.set("isWindows",n.$c),b.set("isWeb",n.$i),b.set("isMacNative",n.$d&&!n.$i),b.set("isEdge",n.$B),b.set("isFirefox",n.$z),b.set("isChrome",n.$y),b.set("isSafari",n.$A);function $(U,R){if(b.get(U)!==void 0)throw(0,k.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");b.set(U,R)}const E=Object.prototype.hasOwnProperty;var y;(function(U){U[U.False=0]="False",U[U.True=1]="True",U[U.Defined=2]="Defined",U[U.Not=3]="Not",U[U.Equals=4]="Equals",U[U.NotEquals=5]="NotEquals",U[U.And=6]="And",U[U.Regex=7]="Regex",U[U.NotRegex=8]="NotRegex",U[U.Or=9]="Or",U[U.In=10]="In",U[U.NotIn=11]="NotIn",U[U.Greater=12]="Greater",U[U.GreaterEquals=13]="GreaterEquals",U[U.Smaller=14]="Smaller",U[U.SmallerEquals=15]="SmallerEquals"})(y||(e.ContextKeyExprType=y={}));const w={regexParsingWithErrorRecovery:!0},g=(0,C.localize)(0,null),d=(0,C.localize)(1,null),c=(0,C.localize)(2,null),m=(0,C.localize)(3,null),u=(0,C.localize)(4,null),p=(0,C.localize)(5,null),h=(0,C.localize)(6,null),f=(0,C.localize)(7,null);class l{get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(R=w){this.k=R,this.d=new P.$dj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(R){if(R===""){this.h.push({message:g,offset:0,lexeme:"",additionalInfo:d});return}this.f=this.d.reset(R).scan(),this.g=0,this.h=[];try{const q=this.l();if(!this.E()){const X=this.D(),le=X.type===17?p:void 0;throw this.h.push({message:u,offset:X.offset,lexeme:P.$dj.getLexeme(X),additionalInfo:le}),l.c}return q}catch(q){if(q!==l.c)throw q;return}}l(){return this.m()}m(){const R=[this.o()];for(;this.y(16);){const q=this.o();R.push(q)}return R.length===1?R[0]:t.or(...R)}o(){const R=[this.s()];for(;this.y(15);){const q=this.s();R.push(q)}return R.length===1?R[0]:t.and(...R)}s(){if(this.y(2)){const R=this.D();switch(R.type){case 11:return this.z(),s.INSTANCE;case 12:return this.z(),i.INSTANCE;case 0:{this.z();const q=this.l();return this.A(1,m),q?.negate()}case 17:return this.z(),I.create(R.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",R)}}return this.t()}t(){const R=this.D();switch(R.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const q=this.l();return this.A(1,m),q}case 17:{const q=R.lexeme;if(this.z(),this.y(9)){const le=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),le.type!==10)throw this.B("REGEX",le);const Q=le.lexeme,x=Q.lastIndexOf("/"),V=x===Q.length-1?void 0:this.w(Q.substring(x+1));let L;try{L=new RegExp(Q.substring(1,x),V)}catch{throw this.B("REGEX",le)}return _.create(q,L)}switch(le.type){case 10:case 19:{const Q=[le.lexeme];this.z();let x=this.D(),V=0;for(let de=0;de<le.lexeme.length;de++)le.lexeme.charCodeAt(de)===40?V++:le.lexeme.charCodeAt(de)===41&&V--;for(;!this.E()&&x.type!==15&&x.type!==16;){switch(x.type){case 0:V++;break;case 1:V--;break;case 10:case 18:for(let de=0;de<x.lexeme.length;de++)x.lexeme.charCodeAt(de)===40?V++:le.lexeme.charCodeAt(de)===41&&V--}if(V<0)break;Q.push(P.$dj.getLexeme(x)),this.z(),x=this.D()}const L=Q.join(""),H=L.lastIndexOf("/"),K=H===L.length-1?void 0:this.w(L.substring(H+1));let te;try{te=new RegExp(L.substring(1,H),K)}catch{throw this.B("REGEX",le)}return t.regex(q,te)}case 18:{const Q=le.lexeme;this.z();let x=null;if(!(0,A.$Ue)(Q)){const V=Q.indexOf("/"),L=Q.lastIndexOf("/");if(V!==L&&V>=0){const H=Q.slice(V+1,L),K=Q[L+1]==="i"?"i":"";try{x=new RegExp(H,K)}catch{throw this.B("REGEX",le)}}}if(x===null)throw this.B("REGEX",le);return _.create(q,x)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,c);const le=this.u();return t.notIn(q,le)}switch(this.D().type){case 3:{this.z();const le=this.u();if(this.x().type===18)return t.equals(q,le);switch(le){case"true":return t.has(q);case"false":return t.not(q);default:return t.equals(q,le)}}case 4:{this.z();const le=this.u();if(this.x().type===18)return t.notEquals(q,le);switch(le){case"true":return t.not(q);case"false":return t.has(q);default:return t.notEquals(q,le)}}case 5:return this.z(),ae.create(q,this.u());case 6:return this.z(),ee.create(q,this.u());case 7:return this.z(),Z.create(q,this.u());case 8:return this.z(),he.create(q,this.u());case 13:return this.z(),t.in(q,this.u());default:return t.has(q)}}case 20:throw this.h.push({message:h,offset:R.offset,lexeme:"",additionalInfo:f}),l.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const R=this.D();switch(R.type){case 17:case 18:return this.z(),R.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(R){return R.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(R){return this.C(R)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(R,q){if(this.C(R))return this.z();throw this.B(q,this.D())}B(R,q,X){const le=(0,C.localize)(8,null,R,P.$dj.getLexeme(q)),Q=q.offset,x=P.$dj.getLexeme(q);return this.h.push({message:le,offset:Q,lexeme:x,additionalInfo:X}),l.c}C(R){return this.D().type===R}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$fj=l,l.c=new Error;class t{static false(){return s.INSTANCE}static true(){return i.INSTANCE}static has(R){return v.create(R)}static equals(R,q){return S.create(R,q)}static notEquals(R,q){return j.create(R,q)}static regex(R,q){return _.create(R,q)}static in(R,q){return O.create(R,q)}static notIn(R,q){return N.create(R,q)}static not(R){return I.create(R)}static and(...R){return J.create(R,null,!0)}static or(...R){return Y.create(R,null,!0)}static greater(R,q){return Z.create(R,q)}static greaterEquals(R,q){return he.create(R,q)}static smaller(R,q){return ae.create(R,q)}static smallerEquals(R,q){return ee.create(R,q)}static deserialize(R){return R==null?void 0:this.c.parse(R)}}e.$gj=t,t.c=new l({regexParsingWithErrorRecovery:!1});function a(U){const R=new l({regexParsingWithErrorRecovery:!1});return U.map(q=>(R.parse(q),R.lexingErrors.length>0?R.lexingErrors.map(X=>({errorMessage:X.additionalInfo?(0,C.localize)(9,null,X.additionalInfo):(0,C.localize)(10,null),offset:X.offset,length:X.lexeme.length})):R.parsingErrors.length>0?R.parsingErrors.map(X=>({errorMessage:X.additionalInfo?`${X.message}. ${X.additionalInfo}`:X.message,offset:X.offset,length:X.lexeme.length})):[]))}function o(U,R){const q=U?U.substituteConstants():void 0,X=R?R.substituteConstants():void 0;return!q&&!X?!0:!q||!X?!1:q.equals(X)}function r(U,R){return U.cmp(R)}class s{constructor(){this.type=0}cmp(R){return this.type-R.type}equals(R){return R.type===this.type}substituteConstants(){return this}evaluate(R){return!1}serialize(){return"false"}keys(){return[]}map(R){return this}negate(){return i.INSTANCE}}e.$jj=s,s.INSTANCE=new s;class i{constructor(){this.type=1}cmp(R){return this.type-R.type}equals(R){return R.type===this.type}substituteConstants(){return this}evaluate(R){return!0}serialize(){return"true"}keys(){return[]}map(R){return this}negate(){return s.INSTANCE}}e.$kj=i,i.INSTANCE=new i;class v{static create(R,q=null){const X=b.get(R);return typeof X=="boolean"?X?i.INSTANCE:s.INSTANCE:new v(R,q)}constructor(R,q){this.key=R,this.c=q,this.type=2}cmp(R){return R.type!==this.type?this.type-R.type:re(this.key,R.key)}equals(R){return R.type===this.type?this.key===R.key:!1}substituteConstants(){const R=b.get(this.key);return typeof R=="boolean"?R?i.INSTANCE:s.INSTANCE:this}evaluate(R){return!!R.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(R){return R.mapDefined(this.key)}negate(){return this.c||(this.c=I.create(this.key,this)),this.c}}e.$lj=v;class S{static create(R,q,X=null){if(typeof q=="boolean")return q?v.create(R,X):I.create(R,X);const le=b.get(R);return typeof le=="boolean"?q===(le?"true":"false")?i.INSTANCE:s.INSTANCE:new S(R,q,X)}constructor(R,q,X){this.c=R,this.d=q,this.f=X,this.type=4}cmp(R){return R.type!==this.type?this.type-R.type:ue(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){const R=b.get(this.c);if(typeof R=="boolean"){const q=R?"true":"false";return this.d===q?i.INSTANCE:s.INSTANCE}return this}evaluate(R){return R.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(R){return R.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$mj=S;class O{static create(R,q){return new O(R,q)}constructor(R,q){this.d=R,this.f=q,this.type=10,this.c=null}cmp(R){return R.type!==this.type?this.type-R.type:ue(this.d,this.f,R.d,R.f)}equals(R){return R.type===this.type?this.d===R.d&&this.f===R.f:!1}substituteConstants(){return this}evaluate(R){const q=R.getValue(this.f),X=R.getValue(this.d);return Array.isArray(q)?q.includes(X):typeof X=="string"&&typeof q=="object"&&q!==null?E.call(q,X):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(R){return R.mapIn(this.d,this.f)}negate(){return this.c||(this.c=N.create(this.d,this.f)),this.c}}e.$nj=O;class N{static create(R,q){return new N(R,q)}constructor(R,q){this.d=R,this.f=q,this.type=11,this.c=O.create(R,q)}cmp(R){return R.type!==this.type?this.type-R.type:this.c.cmp(R.c)}equals(R){return R.type===this.type?this.c.equals(R.c):!1}substituteConstants(){return this}evaluate(R){return!this.c.evaluate(R)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(R){return R.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$oj=N;class j{static create(R,q,X=null){if(typeof q=="boolean")return q?I.create(R,X):v.create(R,X);const le=b.get(R);return typeof le=="boolean"?q===(le?"true":"false")?s.INSTANCE:i.INSTANCE:new j(R,q,X)}constructor(R,q,X){this.c=R,this.d=q,this.f=X,this.type=5}cmp(R){return R.type!==this.type?this.type-R.type:ue(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){const R=b.get(this.c);if(typeof R=="boolean"){const q=R?"true":"false";return this.d===q?s.INSTANCE:i.INSTANCE}return this}evaluate(R){return R.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(R){return R.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=S.create(this.c,this.d,this)),this.f}}e.$pj=j;class I{static create(R,q=null){const X=b.get(R);return typeof X=="boolean"?X?s.INSTANCE:i.INSTANCE:new I(R,q)}constructor(R,q){this.c=R,this.d=q,this.type=3}cmp(R){return R.type!==this.type?this.type-R.type:re(this.c,R.c)}equals(R){return R.type===this.type?this.c===R.c:!1}substituteConstants(){const R=b.get(this.c);return typeof R=="boolean"?R?s.INSTANCE:i.INSTANCE:this}evaluate(R){return!R.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(R){return R.mapNot(this.c)}negate(){return this.d||(this.d=v.create(this.c,this)),this.d}}e.$qj=I;function B(U,R){if(typeof U=="string"){const q=parseFloat(U);isNaN(q)||(U=q)}return typeof U=="string"||typeof U=="number"?R(U):s.INSTANCE}class Z{static create(R,q,X=null){return B(q,le=>new Z(R,le,X))}constructor(R,q,X){this.c=R,this.d=q,this.f=X,this.type=12}cmp(R){return R.type!==this.type?this.type-R.type:ue(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){return this}evaluate(R){return typeof this.d=="string"?!1:parseFloat(R.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(R){return R.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ee.create(this.c,this.d,this)),this.f}}e.$rj=Z;class he{static create(R,q,X=null){return B(q,le=>new he(R,le,X))}constructor(R,q,X){this.c=R,this.d=q,this.f=X,this.type=13}cmp(R){return R.type!==this.type?this.type-R.type:ue(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){return this}evaluate(R){return typeof this.d=="string"?!1:parseFloat(R.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(R){return R.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=ae.create(this.c,this.d,this)),this.f}}e.$sj=he;class ae{static create(R,q,X=null){return B(q,le=>new ae(R,le,X))}constructor(R,q,X){this.c=R,this.d=q,this.f=X,this.type=14}cmp(R){return R.type!==this.type?this.type-R.type:ue(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){return this}evaluate(R){return typeof this.d=="string"?!1:parseFloat(R.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(R){return R.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=he.create(this.c,this.d,this)),this.f}}e.$tj=ae;class ee{static create(R,q,X=null){return B(q,le=>new ee(R,le,X))}constructor(R,q,X){this.c=R,this.d=q,this.f=X,this.type=15}cmp(R){return R.type!==this.type?this.type-R.type:ue(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){return this}evaluate(R){return typeof this.d=="string"?!1:parseFloat(R.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(R){return R.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=Z.create(this.c,this.d,this)),this.f}}e.$uj=ee;class _{static create(R,q){return new _(R,q)}constructor(R,q){this.d=R,this.f=q,this.type=7,this.c=null}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.d<R.d)return-1;if(this.d>R.d)return 1;const q=this.f?this.f.source:"",X=R.f?R.f.source:"";return q<X?-1:q>X?1:0}equals(R){if(R.type===this.type){const q=this.f?this.f.source:"",X=R.f?R.f.source:"";return this.d===R.d&&q===X}return!1}substituteConstants(){return this}evaluate(R){const q=R.getValue(this.d);return this.f?this.f.test(q):!1}serialize(){const R=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${R}`}keys(){return[this.d]}map(R){return R.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=z.create(this)),this.c}}e.$vj=_;class z{static create(R){return new z(R)}constructor(R){this.c=R,this.type=8}cmp(R){return R.type!==this.type?this.type-R.type:this.c.cmp(R.c)}equals(R){return R.type===this.type?this.c.equals(R.c):!1}substituteConstants(){return this}evaluate(R){return!this.c.evaluate(R)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(R){return new z(this.c.map(R))}negate(){return this.c}}e.$wj=z;function T(U){let R=null;for(let q=0,X=U.length;q<X;q++){const le=U[q].substituteConstants();if(U[q]!==le&&R===null){R=[];for(let Q=0;Q<q;Q++)R[Q]=U[Q]}R!==null&&(R[q]=le)}return R===null?U:R}class J{static create(R,q,X){return J.d(R,q,X)}constructor(R,q){this.expr=R,this.c=q,this.type=6}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.expr.length<R.expr.length)return-1;if(this.expr.length>R.expr.length)return 1;for(let q=0,X=this.expr.length;q<X;q++){const le=r(this.expr[q],R.expr[q]);if(le!==0)return le}return 0}equals(R){if(R.type===this.type){if(this.expr.length!==R.expr.length)return!1;for(let q=0,X=this.expr.length;q<X;q++)if(!this.expr[q].equals(R.expr[q]))return!1;return!0}return!1}substituteConstants(){const R=T(this.expr);return R===this.expr?this:J.create(R,this.c,!1)}evaluate(R){for(let q=0,X=this.expr.length;q<X;q++)if(!this.expr[q].evaluate(R))return!1;return!0}static d(R,q,X){const le=[];let Q=!1;for(const x of R)if(x){if(x.type===1){Q=!0;continue}if(x.type===0)return s.INSTANCE;if(x.type===6){le.push(...x.expr);continue}le.push(x)}if(le.length===0&&Q)return i.INSTANCE;if(le.length!==0){if(le.length===1)return le[0];le.sort(r);for(let x=1;x<le.length;x++)le[x-1].equals(le[x])&&(le.splice(x,1),x--);if(le.length===1)return le[0];for(;le.length>1;){const x=le[le.length-1];if(x.type!==9)break;le.pop();const V=le.pop(),L=le.length===0,H=Y.create(x.expr.map(K=>J.create([K,V],null,X)),null,L);H&&(le.push(H),le.sort(r))}if(le.length===1)return le[0];if(X){for(let x=0;x<le.length;x++)for(let V=x+1;V<le.length;V++)if(le[x].negate().equals(le[V]))return s.INSTANCE;if(le.length===1)return le[0]}return new J(le,q)}}serialize(){return this.expr.map(R=>R.serialize()).join(" && ")}keys(){const R=[];for(const q of this.expr)R.push(...q.keys());return R}map(R){return new J(this.expr.map(q=>q.map(R)),null)}negate(){if(!this.c){const R=[];for(const q of this.expr)R.push(q.negate());this.c=Y.create(R,this,!0)}return this.c}}e.$xj=J;class Y{static create(R,q,X){return Y.d(R,q,X)}constructor(R,q){this.expr=R,this.c=q,this.type=9}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.expr.length<R.expr.length)return-1;if(this.expr.length>R.expr.length)return 1;for(let q=0,X=this.expr.length;q<X;q++){const le=r(this.expr[q],R.expr[q]);if(le!==0)return le}return 0}equals(R){if(R.type===this.type){if(this.expr.length!==R.expr.length)return!1;for(let q=0,X=this.expr.length;q<X;q++)if(!this.expr[q].equals(R.expr[q]))return!1;return!0}return!1}substituteConstants(){const R=T(this.expr);return R===this.expr?this:Y.create(R,this.c,!1)}evaluate(R){for(let q=0,X=this.expr.length;q<X;q++)if(this.expr[q].evaluate(R))return!0;return!1}static d(R,q,X){let le=[],Q=!1;if(R){for(let x=0,V=R.length;x<V;x++){const L=R[x];if(L){if(L.type===0){Q=!0;continue}if(L.type===1)return i.INSTANCE;if(L.type===9){le=le.concat(L.expr);continue}le.push(L)}}if(le.length===0&&Q)return s.INSTANCE;le.sort(r)}if(le.length!==0){if(le.length===1)return le[0];for(let x=1;x<le.length;x++)le[x-1].equals(le[x])&&(le.splice(x,1),x--);if(le.length===1)return le[0];if(X){for(let x=0;x<le.length;x++)for(let V=x+1;V<le.length;V++)if(le[x].negate().equals(le[V]))return i.INSTANCE;if(le.length===1)return le[0]}return new Y(le,q)}}serialize(){return this.expr.map(R=>R.serialize()).join(" || ")}keys(){const R=[];for(const q of this.expr)R.push(...q.keys());return R}map(R){return new Y(this.expr.map(q=>q.map(R)),null)}negate(){if(!this.c){const R=[];for(const q of this.expr)R.push(q.negate());for(;R.length>1;){const q=R.shift(),X=R.shift(),le=[];for(const Q of ne(q))for(const x of ne(X))le.push(J.create([Q,x],null,!1));R.unshift(Y.create(le,null,!1))}this.c=Y.create(R,this,!0)}return this.c}}e.$yj=Y;class W extends v{static all(){return W.d.values()}constructor(R,q,X){super(R,null),this.f=q,typeof X=="object"?W.d.push({...X,key:R}):X!==!0&&W.d.push({key:R,description:X,type:q!=null?typeof q:void 0})}bindTo(R){return R.createKey(this.key,this.f)}getValue(R){return R.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(R){return S.create(this.key,R)}notEqualsTo(R){return j.create(this.key,R)}}e.$zj=W,W.d=[],e.$Aj=(0,D.$ii)("contextKeyService");function re(U,R){return U<R?-1:U>R?1:0}function ue(U,R,q,X){return U<q?-1:U>q?1:R<X?-1:R>X?1:0}function ie(U,R){if(U.type===0||R.type===1)return!0;if(U.type===9)return R.type===9?$e(U.expr,R.expr):!1;if(R.type===9){for(const q of R.expr)if(ie(U,q))return!0;return!1}if(U.type===6){if(R.type===6)return $e(R.expr,U.expr);for(const q of U.expr)if(ie(q,R))return!0;return!1}return U.equals(R)}function $e(U,R){let q=0,X=0;for(;q<U.length&&X<R.length;){const le=U[q].cmp(R[X]);if(le<0)return!1;le===0&&q++,X++}return q===U.length}function ne(U){return U.type===9?U.expr:[U]}}),define(Ee[224],ke([1,0,5]),function(ce,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5m=e.$3m=e.ID=void 0,e.$4m=A,e.ID="diagnosticsService",e.$3m=(0,n.$ii)(e.ID);function A(D){return!!D.hostName&&!!D.errorMessage}class P{async getPerformanceInfo(C,k){return{}}async getSystemInfo(C,k){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(C,k){return""}async getWorkspaceFileExtensions(C){return{extensions:[]}}async reportWorkspaceStats(C){}}e.$5m=P}),define(Ee[82],ke([1,0,5]),function(ce,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xo=void 0,e.$xo=(0,n.$ii)("downloadService")}),define(Ee[26],ke([1,0,5]),function(ce,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qi=e.$pi=void 0,e.$pi=(0,n.$ii)("environmentService"),e.$qi=(0,n.$ji)(e.$pi)}),define(Ee[31],ke([1,0,186,5]),function(ce,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2o=e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.ExtensionGalleryErrorCode=e.$To=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$So=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=void 0,e.$Mo=P,e.$No=D,e.$Oo=C,e.$Po=k,e.$Qo=b,e.$Ro=$,e.$Go="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Ho=new RegExp(e.$Go),e.$Io="__web_extension",e.$Jo="skipWalkthrough",e.$Ko="extensionsSync",e.$Lo="dependecyOrPackExtensionInstall";function P(h){switch(h){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function D(h){switch(h){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function C(h,f){switch(h){case 3:return f==="x64"?"win32-x64":f==="arm64"?"win32-arm64":"unknown";case 2:return f==="x64"?"linux-x64":f==="arm64"?"linux-arm64":f==="arm"?"linux-armhf":"unknown";case"alpine":return f==="x64"?"alpine-x64":f==="arm64"?"alpine-arm64":"unknown";case 1:return f==="x64"?"darwin-x64":f==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function k(h,f){return f==="web"&&!h.includes("web")}function b(h,f,l){return k(f,l)?!1:h==="undefined"||h==="universal"?!0:h==="unknown"?!1:h===l}function $(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}var E;(function(h){h[h.NoneOrRelevance=0]="NoneOrRelevance",h[h.LastUpdatedDate=1]="LastUpdatedDate",h[h.Title=2]="Title",h[h.PublisherName=3]="PublisherName",h[h.InstallCount=4]="InstallCount",h[h.PublishedDate=10]="PublishedDate",h[h.AverageRating=6]="AverageRating",h[h.WeightedRating=12]="WeightedRating"})(E||(e.SortBy=E={}));var y;(function(h){h[h.Default=0]="Default",h[h.Ascending=1]="Ascending",h[h.Descending=2]="Descending"})(y||(e.SortOrder=y={}));var w;(function(h){h.Install="install",h.Uninstall="uninstall"})(w||(e.StatisticType=w={}));var g;(function(h){h[h.None=1]="None",h[h.Install=2]="Install",h[h.Update=3]="Update",h[h.Migrate=4]="Migrate"})(g||(e.InstallOperation=g={})),e.$So=(0,A.$ii)("extensionGalleryService");var d;(function(h){h.Unsupported="Unsupported",h.Deprecated="Deprecated",h.Malicious="Malicious",h.Incompatible="Incompatible",h.IncompatibleTargetPlatform="IncompatibleTargetPlatform",h.ReleaseVersionNotFound="ReleaseVersionNotFound",h.Invalid="Invalid",h.Download="Download",h.DownloadSignature="DownloadSignature",h.UpdateMetadata="UpdateMetadata",h.Extract="Extract",h.Scanning="Scanning",h.Delete="Delete",h.Rename="Rename",h.CorruptZip="CorruptZip",h.IncompleteZip="IncompleteZip",h.Signature="Signature",h.NotAllowed="NotAllowed",h.Gallery="Gallery",h.Unknown="Unknown",h.Internal="Internal"})(d||(e.ExtensionManagementErrorCode=d={}));var c;(function(h){h.UnknownError="UnknownError",h.PackageIsInvalidZip="PackageIsInvalidZip",h.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(c||(e.ExtensionSignaturetErrorCode=c={}));class m extends Error{constructor(f,l){super(f),this.code=l,this.name=l}}e.$To=m;var u;(function(h){h.Timeout="Timeout",h.Cancelled="Cancelled",h.Failed="Failed"})(u||(e.ExtensionGalleryErrorCode=u={}));class p extends Error{constructor(f,l){super(f),this.code=l,this.name=l}}e.$Uo=p,e.$Vo=(0,A.$ii)("extensionManagementService"),e.$Wo="extensionsIdentifiers/disabled",e.$Xo="extensionsIdentifiers/enabled",e.$Yo=(0,A.$ii)("IGlobalExtensionEnablementService"),e.$Zo=(0,A.$ii)("IExtensionTipsService"),e.$1o=(0,n.localize2)(0,"Extensions"),e.$2o=(0,n.localize2)(1,"Preferences")}),define(Ee[225],ke([1,0,6,2,21,3,54,31]),function(ce,e,n,A,P,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4p=e.$3p=e.$2p=void 0;function b(m,u){return m?D.URI.revive(u?u.transformIncoming(m):m):void 0}function $(m,u){return u?u.transformOutgoingURI(m):m}function E(m,u){u=u||C.$mn;const p=m.manifest;return{...(0,C.$pn)({...m,manifest:void 0},u),manifest:p}}function y(m,u){return m?.profileLocation?(0,C.$pn)(m,u??C.$mn):m}function w(m,u){return u?(0,P.$Rn)(m,p=>p instanceof D.URI?u.transformOutgoingURI(p):void 0):m}class g{constructor(u,p){this.a=u,this.b=p,this.onInstallExtension=n.Event.buffer(u.onInstallExtension,!0),this.onDidInstallExtensions=n.Event.buffer(u.onDidInstallExtensions,!0),this.onUninstallExtension=n.Event.buffer(u.onUninstallExtension,!0),this.onDidUninstallExtension=n.Event.buffer(u.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=n.Event.buffer(u.onDidUpdateExtensionMetadata,!0)}listen(u,p){const h=this.b(u);switch(p){case"onInstallExtension":return n.Event.map(this.onInstallExtension,f=>({...f,profileLocation:f.profileLocation?$(f.profileLocation,h):f.profileLocation}));case"onDidInstallExtensions":return n.Event.map(this.onDidInstallExtensions,f=>f.map(l=>({...l,local:l.local?w(l.local,h):l.local,profileLocation:l.profileLocation?$(l.profileLocation,h):l.profileLocation})));case"onUninstallExtension":return n.Event.map(this.onUninstallExtension,f=>({...f,profileLocation:f.profileLocation?$(f.profileLocation,h):f.profileLocation}));case"onDidUninstallExtension":return n.Event.map(this.onDidUninstallExtension,f=>({...f,profileLocation:f.profileLocation?$(f.profileLocation,h):f.profileLocation}));case"onDidUpdateExtensionMetadata":return n.Event.map(this.onDidUpdateExtensionMetadata,f=>w(f,h))}throw new Error("Invalid listen")}async call(u,p,h){const f=this.b(u);switch(p){case"zip":{const l=E(h[0],f),t=await this.a.zip(l);return $(t,f)}case"unzip":return this.a.unzip(b(h[0],f));case"install":return this.a.install(b(h[0],f),y(h[1],f));case"installFromLocation":return this.a.installFromLocation(b(h[0],f),b(h[1],f));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(h[0],b(h[1],f),b(h[2],f));case"getManifest":return this.a.getManifest(b(h[0],f));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(h[0]);case"installFromGallery":return this.a.installFromGallery(h[0],y(h[1],f));case"installGalleryExtensions":{const l=h[0];return this.a.installGalleryExtensions(l.map(({extension:t,options:a})=>({extension:t,options:y(a,f)??{}})))}case"uninstall":return this.a.uninstall(E(h[0],f),y(h[1],f));case"reinstallFromGallery":return this.a.reinstallFromGallery(E(h[0],f));case"getInstalled":return(await this.a.getInstalled(h[0],b(h[1],f),h[2])).map(t=>w(t,f));case"toggleAppliationScope":{const l=await this.a.toggleAppliationScope(E(h[0],f),b(h[1],f));return w(l,f)}case"copyExtensions":return this.a.copyExtensions(b(h[0],f),b(h[1],f));case"updateMetadata":{const l=await this.a.updateMetadata(E(h[0],f),h[1],b(h[2],f));return w(l,f)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(h[0],h[1],h[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$2p=g;class d extends A.$Uc{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(u){super(),this.m=u,this.c=this.B(new n.$7d),this.f=this.B(new n.$7d),this.g=this.B(new n.$7d),this.h=this.B(new n.$7d),this.j=this.B(new n.$7d),this.B(this.m.listen("onInstallExtension")(p=>this.n(this.c,{...p,source:this.r(p.source)?D.URI.revive(p.source):p.source,profileLocation:D.URI.revive(p.profileLocation)}))),this.B(this.m.listen("onDidInstallExtensions")(p=>this.n(this.f,p.map(h=>({...h,local:h.local?E(h.local,null):h.local,source:this.r(h.source)?D.URI.revive(h.source):h.source,profileLocation:D.URI.revive(h.profileLocation)}))))),this.B(this.m.listen("onUninstallExtension")(p=>this.n(this.g,{...p,profileLocation:D.URI.revive(p.profileLocation)}))),this.B(this.m.listen("onDidUninstallExtension")(p=>this.n(this.h,{...p,profileLocation:D.URI.revive(p.profileLocation)}))),this.B(this.m.listen("onDidUpdateExtensionMetadata")(p=>this.j.fire(E(p,null))))}n(u,p){u.fire(p)}r(u){return u?typeof u.path=="string"&&typeof u.scheme=="string":!1}getTargetPlatform(){return this.s||(this.s=this.m.call("getTargetPlatform")),this.s}async canInstall(u){const p=await this.getTargetPlatform();return u.allTargetPlatforms.some(h=>(0,k.$Qo)(h,u.allTargetPlatforms,p))}zip(u){return Promise.resolve(this.m.call("zip",[u]).then(p=>D.URI.revive(p)))}unzip(u){return Promise.resolve(this.m.call("unzip",[u]))}install(u,p){return Promise.resolve(this.m.call("install",[u,p])).then(h=>E(h,null))}installFromLocation(u,p){return Promise.resolve(this.m.call("installFromLocation",[u,p])).then(h=>E(h,null))}async installExtensionsFromProfile(u,p,h){return(await this.m.call("installExtensionsFromProfile",[u,p,h])).map(l=>E(l,null))}getManifest(u){return Promise.resolve(this.m.call("getManifest",[u]))}installFromGallery(u,p){return Promise.resolve(this.m.call("installFromGallery",[u,p])).then(h=>E(h,null))}async installGalleryExtensions(u){return(await this.m.call("installGalleryExtensions",[u])).map(h=>({...h,local:h.local?E(h.local,null):h.local,source:this.r(h.source)?D.URI.revive(h.source):h.source,profileLocation:D.URI.revive(h.profileLocation)}))}uninstall(u,p){if(u.isWorkspaceScoped)throw new Error("Cannot uninstall a workspace extension");return Promise.resolve(this.m.call("uninstall",[u,p]))}reinstallFromGallery(u){return Promise.resolve(this.m.call("reinstallFromGallery",[u])).then(p=>E(p,null))}getInstalled(u=null,p,h){return Promise.resolve(this.m.call("getInstalled",[u,p,h])).then(f=>f.map(l=>E(l,null)))}updateMetadata(u,p,h){return Promise.resolve(this.m.call("updateMetadata",[u,p,h])).then(f=>E(f,null))}toggleAppliationScope(u,p){return this.m.call("toggleAppliationScope",[u,p]).then(h=>E(h,null))}copyExtensions(u,p){return this.m.call("copyExtensions",[u,p])}getExtensionsControlManifest(){return Promise.resolve(this.m.call("getExtensionsControlManifest"))}async download(u,p,h){const f=await this.m.call("download",[u,p,h]);return D.URI.revive(f)}async cleanUp(){return this.m.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$3p=d;class c{constructor(u){this.a=u}listen(u,p){throw new Error("Invalid listen")}call(u,p,h){switch(p){case"getConfigBasedTips":return this.a.getConfigBasedTips(D.URI.revive(h[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$4p=c}),define(Ee[16],ke([1,0,66,7,17,11,3,194,5,4,12,60]),function(ce,e,n,A,P,D,C,k,b,$,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kl=e.$hl=e.FileKind=e.$gl=e.$fl=e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.FileOperationResult=e.$_k=e.$$k=e.$0k=e.$8k=e.FileChangeType=e.$7k=e.FileOperation=e.$1k=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$Ok=void 0,e.$Pk=w,e.$Qk=c,e.$Rk=u,e.$Sk=p,e.$Tk=h,e.$Uk=f,e.$Vk=l,e.$Wk=t,e.$Xk=a,e.$Yk=o,e.$Zk=r,e.$2k=v,e.$3k=S,e.$4k=O,e.$5k=N,e.$6k=j,e.$9k=ae,e.$il=Y,e.$jl=W,e.$ll=ue,e.$Ok=(0,b.$ii)("fileService");function w(ie){return ie.create===!0}var g;(function(ie){ie[ie.Unknown=0]="Unknown",ie[ie.File=1]="File",ie[ie.Directory=2]="Directory",ie[ie.SymbolicLink=64]="SymbolicLink"})(g||(e.FileType=g={}));var d;(function(ie){ie[ie.Readonly=1]="Readonly",ie[ie.Locked=2]="Locked"})(d||(e.FilePermission=d={}));function c(ie){const $e=ie;return!!$e&&typeof $e.onDidChange=="function"}var m;(function(ie){ie[ie.None=0]="None",ie[ie.FileReadWrite=2]="FileReadWrite",ie[ie.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ie[ie.FileReadStream=16]="FileReadStream",ie[ie.FileFolderCopy=8]="FileFolderCopy",ie[ie.PathCaseSensitive=1024]="PathCaseSensitive",ie[ie.Readonly=2048]="Readonly",ie[ie.Trash=4096]="Trash",ie[ie.FileWriteUnlock=8192]="FileWriteUnlock",ie[ie.FileAtomicRead=16384]="FileAtomicRead",ie[ie.FileAtomicWrite=32768]="FileAtomicWrite",ie[ie.FileAtomicDelete=65536]="FileAtomicDelete",ie[ie.FileClone=131072]="FileClone"})(m||(e.FileSystemProviderCapabilities=m={}));function u(ie){return!!(ie.capabilities&2)}function p(ie){return!!(ie.capabilities&8)}function h(ie){return!!(ie.capabilities&131072)}function f(ie){return!!(ie.capabilities&4)}function l(ie){return!!(ie.capabilities&16)}function t(ie){return u(ie)?!!(ie.capabilities&16384):!1}function a(ie){return u(ie)?!!(ie.capabilities&32768):!1}function o(ie){return!!(ie.capabilities&65536)}function r(ie){return!!(ie.capabilities&2048)}var s;(function(ie){ie.FileExists="EntryExists",ie.FileNotFound="EntryNotFound",ie.FileNotADirectory="EntryNotADirectory",ie.FileIsADirectory="EntryIsADirectory",ie.FileExceedsStorageQuota="EntryExceedsStorageQuota",ie.FileTooLarge="EntryTooLarge",ie.FileWriteLocked="EntryWriteLocked",ie.NoPermissions="NoPermissions",ie.Unavailable="Unavailable",ie.Unknown="Unknown"})(s||(e.FileSystemProviderErrorCode=s={}));class i extends Error{static create($e,ne){const U=new i($e.toString(),ne);return O(U,ne),U}constructor($e,ne){super($e),this.code=ne}}e.$1k=i;function v(ie,$e){return i.create(ie,$e)}function S(ie){return ie||v((0,k.localize)(0,null),s.Unknown)}function O(ie,$e){return ie.name=$e?`${$e} (FileSystemError)`:"FileSystemError",ie}function N(ie){if(!ie)return s.Unknown;if(ie instanceof i)return ie.code;const $e=/^(.+) \(FileSystemError\)$/.exec(ie.name);if(!$e)return s.Unknown;switch($e[1]){case s.FileExists:return s.FileExists;case s.FileIsADirectory:return s.FileIsADirectory;case s.FileNotADirectory:return s.FileNotADirectory;case s.FileNotFound:return s.FileNotFound;case s.FileTooLarge:return s.FileTooLarge;case s.FileWriteLocked:return s.FileWriteLocked;case s.NoPermissions:return s.NoPermissions;case s.Unavailable:return s.Unavailable}return s.Unknown}function j(ie){if(ie instanceof ee)return ie.fileOperationResult;switch(N(ie)){case s.FileNotFound:return 1;case s.FileIsADirectory:return 0;case s.FileNotADirectory:return 9;case s.FileWriteLocked:return 5;case s.NoPermissions:return 6;case s.FileExists:return 4;case s.FileTooLarge:return 7;default:return 10}}var I;(function(ie){ie[ie.CREATE=0]="CREATE",ie[ie.DELETE=1]="DELETE",ie[ie.MOVE=2]="MOVE",ie[ie.COPY=3]="COPY",ie[ie.WRITE=4]="WRITE"})(I||(e.FileOperation=I={}));class B{constructor($e,ne,U){this.resource=$e,this.operation=ne,this.target=U}isOperation($e){return this.operation===$e}}e.$7k=B;var Z;(function(ie){ie[ie.UPDATED=0]="UPDATED",ie[ie.ADDED=1]="ADDED",ie[ie.DELETED=2]="DELETED"})(Z||(e.FileChangeType=Z={}));class he{constructor($e,ne){this.c=ne,this.b=void 0,this.d=new y.$V(()=>{const U=n.$oi.forUris(()=>this.c);return U.fill(this.rawAdded.map(R=>[R,!0])),U}),this.f=new y.$V(()=>{const U=n.$oi.forUris(()=>this.c);return U.fill(this.rawUpdated.map(R=>[R,!0])),U}),this.g=new y.$V(()=>{const U=n.$oi.forUris(()=>this.c);return U.fill(this.rawDeleted.map(R=>[R,!0])),U}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const U of $e){switch(U.type){case 1:this.rawAdded.push(U.resource);break;case 0:this.rawUpdated.push(U.resource);break;case 2:this.rawDeleted.push(U.resource);break}this.b!==he.a&&(typeof U.cId=="number"?this.b===void 0?this.b=U.cId:this.b!==U.cId&&(this.b=he.a):this.b!==void 0&&(this.b=he.a))}}contains($e,...ne){return this.h($e,{includeChildren:!1},...ne)}affects($e,...ne){return this.h($e,{includeChildren:!0},...ne)}h($e,ne,...U){if(!$e)return!1;const R=U.length>0;return!!((!R||U.includes(1))&&(this.d.value.get($e)||ne.includeChildren&&this.d.value.findSuperstr($e))||(!R||U.includes(0))&&(this.f.value.get($e)||ne.includeChildren&&this.f.value.findSuperstr($e))||(!R||U.includes(2))&&(this.g.value.findSubstr($e)||ne.includeChildren&&this.g.value.findSuperstr($e)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates($e){return this.b===$e}hasCorrelation(){return typeof this.b=="number"}}e.$8k=he,he.a=null;function ae(ie,$e,ne){return!ie||!$e||ie===$e||$e.length>ie.length?!1:($e.charAt($e.length-1)!==A.sep&&($e+=A.sep),ne?(0,P.$mf)(ie,$e):ie.indexOf($e)===0)}class ee extends Error{constructor($e,ne,U){super($e),this.fileOperationResult=ne,this.options=U}}e.$0k=ee;class _ extends ee{constructor($e,ne,U,R){super($e,ne,R),this.fileOperationResult=ne,this.size=U}}e.$$k=_;class z extends ee{constructor($e,ne,U){super($e,2,U),this.stat=ne}}e.$_k=z;var T;(function(ie){ie[ie.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ie[ie.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ie[ie.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ie[ie.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ie[ie.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ie[ie.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ie[ie.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ie[ie.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ie[ie.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ie[ie.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ie[ie.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(T||(e.FileOperationResult=T={})),e.$al={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$bl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$cl="files.associations",e.$dl="files.exclude",e.$el="files.readonlyInclude",e.$fl="files.readonlyExclude",e.$gl="files.readonlyFromPermissions";var J;(function(ie){ie[ie.FILE=0]="FILE",ie[ie.FOLDER=1]="FOLDER",ie[ie.ROOT_FOLDER=2]="ROOT_FOLDER"})(J||(e.FileKind=J={})),e.$hl="";function Y(ie){if(!(typeof ie.size!="number"||typeof ie.mtime!="number"))return ie.mtime.toString(29)+ie.size.toString(31)}async function W(ie,$e){if(!$e.hasProvider(C.URI.from({scheme:ie.scheme})))return new Promise(ne=>{const U=$e.onDidChangeFileSystemProviderRegistrations(R=>{R.scheme===ie.scheme&&R.added&&(U.dispose(),ne())})})}class re{static formatSize($e){return(0,D.$Zf)($e)||($e=0),$e<re.KB?(0,k.localize)(1,null,$e.toFixed(0)):$e<re.MB?(0,k.localize)(2,null,($e/re.KB).toFixed(2)):$e<re.GB?(0,k.localize)(3,null,($e/re.MB).toFixed(2)):$e<re.TB?(0,k.localize)(4,null,($e/re.GB).toFixed(2)):(0,k.localize)(5,null,($e/re.TB).toFixed(2))}}e.$kl=re,re.KB=1024,re.MB=re.KB*re.KB,re.GB=re.MB*re.KB,re.TB=re.GB*re.KB;function ue(ie){const $e=typeof ie=="string"||ie?.scheme===E.Schemas.vscodeRemote;return typeof ie!="string"&&ie?.scheme===E.Schemas.file?1024*re.MB:$e?10*re.MB:$.$i?50*re.MB:1024*re.MB}}),define(Ee[112],ke([1,0,14,10,195,16]),function(ce,e,n,A,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uq=C;async function C(E,y,w,g,d,c){let m;try{await k(E,y,w,g,d,c)}catch(u){m=u}finally{m&&d.errorTransformer&&(m=d.errorTransformer(m)),typeof m<"u"&&w.error(m),w.end()}}async function k(E,y,w,g,d,c){b(c);const m=await E.open(y,{create:!1});try{b(c);let u=0,p=0,h=d&&typeof d.length=="number"?d.length:void 0,f=n.$ue.alloc(Math.min(d.bufferSize,typeof h=="number"?h:d.bufferSize)),l=d&&typeof d.position=="number"?d.position:0,t=0;do p=await E.read(m,l,f.buffer,t,f.byteLength-t),l+=p,t+=p,u+=p,typeof h=="number"&&(h-=p),t===f.byteLength&&(await w.write(g(f)),f=n.$ue.alloc(Math.min(d.bufferSize,typeof h=="number"?h:d.bufferSize)),t=0);while(p>0&&(typeof h!="number"||h>0)&&b(c)&&$(u,d));if(t>0){let a=t;typeof h=="number"&&(a=Math.min(t,h)),w.write(g(f.slice(0,a)))}}catch(u){throw(0,D.$3k)(u)}finally{await E.close(m)}}function b(E){if(E.isCancellationRequested)throw(0,A.$6)();return!0}function $(E,y){if(typeof y?.limits?.size=="number"&&E>y.limits.size)throw(0,D.$2k)((0,P.localize)(0,null),D.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(Ee[46],ke([1,0,76,2,7,4,3,16]),function(ce,e,n,A,P,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aq=e.$zq=e.$yq=void 0,e.$wq=b,e.$xq=$,e.$Bq=g,e.$Cq=d,e.$Dq=c,e.$Eq=m;function b(p){return typeof p.correlationId=="number"}function $(p){return p.recursive===!0}class E extends A.$Uc{constructor(h,f,l,t){super(),this.h=h,this.j=f,this.m=l,this.n=t,this.c=this.B(new A.$Vc),this.f=void 0,this.g=0}s(){const h=new A.$Tc;this.c.value=h,this.b=this.r(h),this.b.setVerboseLogging(this.m),h.add(this.b.onDidChangeFile(f=>this.h(f))),h.add(this.b.onDidLogMessage(f=>this.j(f))),h.add(this.b.onDidError(f=>this.t(f)))}t(h){this.n.restartOnError?this.g<E.a&&this.f?(this.w(`restarting watcher after error: ${h}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${h}`):this.w(h)}u(h){this.g++,this.s(),this.watch(h)}async watch(h){this.f=h,await this.b?.watch(h)}async setVerboseLogging(h){this.m=h,await this.b?.setVerboseLogging(h)}w(h){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${h}`})}y(h){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${h}`})}dispose(){return this.b=void 0,super.dispose()}}e.$yq=E,E.a=5;class y extends E{constructor(h,f,l){super(h,f,l,{type:"node.js",restartOnError:!1})}}e.$zq=y;class w extends E{constructor(h,f,l){super(h,f,l,{type:"universal",restartOnError:!0})}}e.$Aq=w;function g(p){return p.map(h=>({type:h.type,resource:C.URI.revive(h.resource),cId:h.cId}))}function d(p){const h=new u;for(const f of p)h.processEvent(f);return h.coalesce()}function c(p,h){return typeof h=="string"&&!h.startsWith(n.$$j)&&!(0,P.$jc)(h)?{base:p,pattern:h}:h}function m(p,h){const f=[];for(const l of h)f.push((0,n.$ck)(c(p,l)));return f}class u{constructor(){this.a=new Set,this.b=new Map}c(h){return D.$e?h.resource.fsPath:h.resource.fsPath.toLowerCase()}processEvent(h){const f=this.b.get(this.c(h));let l=!1;if(f){const t=f.type,a=h.type;f.resource.fsPath!==h.resource.fsPath&&(h.type===2||h.type===1)?l=!0:t===1&&a===2?(this.b.delete(this.c(h)),this.a.delete(f)):t===2&&a===1?f.type=0:t===1&&a===0||(f.type=a)}else l=!0;l&&(this.a.add(h),this.b.set(this.c(h),h))}coalesce(){const h=[],f=[];return Array.from(this.a).filter(l=>l.type!==2?(h.push(l),!1):!0).sort((l,t)=>l.resource.fsPath.length-t.resource.fsPath.length).filter(l=>f.some(t=>(0,k.$9k)(l.resource.fsPath,t,!D.$e))?!1:(f.push(l.resource.fsPath),!0)).concat(h)}}}),define(Ee[226],ke([1,0,14,40,10,6,2,51,22,16,46]),function(ce,e,n,A,P,D,C,k,b,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VP=e.$UP=void 0,e.$UP="localFilesystem";class y extends C.$Uc{constructor(g,d){super(),this.a=g,this.b=d,this.onDidChangeCapabilities=D.Event.None,this.f=this.B(new D.$7d),this.onDidChangeFile=this.f.event,this.g=this.B(new D.$7d),this.onDidWatchError=this.g.event,this.h=(0,b.$Eg)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(g){return this.a.call("stat",[g])}readdir(g){return this.a.call("readdir",[g])}async readFile(g,d){const{buffer:c}=await this.a.call("readFile",[g,d]);return c}readFileStream(g,d,c){const m=(0,k.$ie)(p=>n.$ue.concat(p.map(h=>n.$ue.wrap(h))).buffer),u=new C.$Tc;return u.add(this.a.listen("readFileStream",[g,d])(p=>{if(p instanceof n.$ue)m.write(p.buffer);else{if(p==="end")m.end();else{let h;if(p instanceof Error)h=p;else{const f=p;h=(0,$.$2k)(f.message??(0,A.$6i)(f),f.code??$.FileSystemProviderErrorCode.Unknown)}m.error(h),m.end()}u.dispose()}})),u.add(c.onCancellationRequested(()=>{m.error((0,P.$6)()),m.end(),u.dispose()})),m}writeFile(g,d,c){return this.a.call("writeFile",[g,n.$ue.wrap(d),c])}open(g,d){return this.a.call("open",[g,d])}close(g){return this.a.call("close",[g])}async read(g,d,c,m,u){const[p,h]=await this.a.call("read",[g,d,u]);return c.set(p.buffer.slice(0,h),m),h}write(g,d,c,m,u){return this.a.call("write",[g,d,n.$ue.wrap(c),m,u])}mkdir(g){return this.a.call("mkdir",[g])}delete(g,d){return this.a.call("delete",[g,d])}rename(g,d,c){return this.a.call("rename",[g,d,c])}copy(g,d,c){return this.a.call("copy",[g,d,c])}cloneFile(g,d){return this.a.call("cloneFile",[g,d])}j(){this.B(this.a.listen("fileChange",[this.h])(g=>{if(Array.isArray(g)){const d=g;this.f.fire((0,E.$Bq)(d))}else{const d=g;this.g.fire(d)}}))}watch(g,d){const c=(0,b.$Eg)();return this.a.call("watch",[this.h,c,g,d]),(0,C.$Sc)(()=>this.a.call("unwatch",[this.h,c]))}}e.$VP=y}),define(Ee[227],ke([1,0,27,2,46,6,3]),function(ce,e,n,A,P,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nq=void 0;class k extends A.$Uc{constructor(){super(),this.a=this.B(new D.$7d),this.onDidChangeFile=this.a.event,this.b=this.B(new D.$7d),this.onDidLogMessage=this.b.event,this.c=this.B(new D.$7d),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new A.$4c),this.m=5007,this.B(this.f($=>this.n($)))}n($){this.r($)&&this.t($)}r($){return(0,P.$wq)($)}async watch($){this.h.clear(),this.g.clear();for(const E of $)this.r(E)?this.h.set(E.correlationId,E):this.g.add(E);for(const[E]of this.j)this.h.has(E)||this.j.deleteAndDispose(E);return this.s()}s(){return this.D([...this.g,...Array.from(this.h.values()).filter($=>!this.j.has($.correlationId))])}t($){if(this.j.has($.correlationId))return;const E=new A.$Tc;this.j.set($.correlationId,E),this.w($,E),this.s()}u($){this.j.deleteAndDispose($.correlationId),this.s()}w($,E){const y=C.URI.file($.path),w=this;let g=!1;const d=(c,m)=>{if(E.isDisposed)return;const u=this.y(c),p=this.y(m),h=g;if(g=u,!u&&(p||h)){this.F(`fs.watchFile() detected ${$.path} exists again, resuming watcher (correlationId: ${$.correlationId})`);const f={resource:y,type:1,cId:$.correlationId};w.a.fire([f]),this.z(f,$),this.u($)}};this.F(`starting fs.watchFile() on ${$.path} (correlationId: ${$.correlationId})`);try{(0,n.watchFile)($.path,{persistent:!1,interval:this.m},d)}catch(c){this.G(`fs.watchFile() failed with error ${c} on path ${$.path} (correlationId: ${$.correlationId})`)}E.add((0,A.$Sc)(()=>{this.F(`stopping fs.watchFile() on ${$.path} (correlationId: ${$.correlationId})`);try{(0,n.unwatchFile)($.path,d)}catch(c){this.G(`fs.unwatchFile() failed with error ${c} on path ${$.path} (correlationId: ${$.correlationId})`)}}))}y($){return $.ctimeMs===0&&$.ino===0}async stop(){this.j.clearAndDisposeAll()}z($,E){const y=` >> normalized ${$.type===1?"[ADDED]":$.type===2?"[DELETED]":"[CHANGED]"} ${$.resource.fsPath}`;this.F(typeof E.correlationId=="number"?`${y} (correlationId: ${E.correlationId})`:y)}C($){return`${$.path} (excludes: ${$.excludes.length>0?$.excludes:"<none>"}, includes: ${$.includes&&$.includes.length>0?JSON.stringify($.includes):"<all>"}, correlationId: ${typeof $.correlationId=="number"?$.correlationId:"<none>"})`}}e.$Nq=k}),define(Ee[228],ke([1,0,27,15,20,37,2,99,7,4,19,3,165,23,46]),function(ce,e,n,A,P,D,C,k,b,$,E,y,w,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sq=void 0,e.$Tq=m;class c extends C.$Uc{constructor(p,h,f,l,t){super(),this.m=p,this.n=h,this.r=f,this.s=l,this.t=t,this.c=this.B(new A.$xh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},a=>this.n(a))),this.f=this.B(new A.$wh(a=>this.D(a),c.b)),this.g=(0,d.$Eq)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,d.$Eq)(this.m.path,this.m.includes):void 0,this.j=new P.$ee,this.ready=this.u()}async u(){try{const p=await this.w(this.m);if(this.j.token.isCancellationRequested)return;const h=await g.Promises.stat(p);if(this.j.token.isCancellationRequested)return;this.B(await this.y(p,h.isDirectory()))}catch(p){p.code!=="ENOENT"?this.G(p):this.I(`ignoring a path for watching who's stat info failed to resolve: ${this.m.path} (error: ${p})`),this.r?.()}}async w(p){let h=p.path;try{h=await g.Promises.realpath(p.path),p.path===h&&(h=await(0,w.$Pq)(p.path,this.j.token)??p.path),p.path!==h&&this.I(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${p.path}, real: ${h})`)}catch{}return h}async y(p,h){if($.$d&&(0,D.$ig)(p,"/Volumes/",!0))return this.G(`Refusing to watch ${p} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),C.$Uc.None;const f=new P.$ee(this.j.token),l=new C.$Tc;try{const t=y.URI.file(this.m.path),a=(0,b.$oc)(p),o=(0,n.watch)(p);l.add((0,C.$Sc)(()=>{o.removeAllListeners(),o.close()})),this.I(`Started watching: '${p}'`);const r=new Set;if(h)try{for(const i of await g.Promises.readdir(p))r.add(i)}catch(i){this.G(i)}const s=new Map;l.add((0,C.$Sc)(()=>{for(const[,i]of s)i.dispose();s.clear()})),o.on("error",(i,v)=>{this.G(`Failed to watch ${p} for changes using fs.watch() (${i}, ${v})`),this.r?.()}),o.on("change",(i,v)=>{if(f.token.isCancellationRequested)return;this.I(`[raw] ["${i}"] ${v}`);let S="";if(v&&(S=v.toString(),$.$d&&(S=(0,k.$1l)(S))),!(!S||i!=="change"&&i!=="rename"))if(h)if(i==="rename"){s.get(S)?.dispose();const O=setTimeout(async()=>{if(s.delete(S),S===a&&!await g.Promises.exists(p)){this.z(t);return}const N=await this.F((0,b.$kc)(p,S));if(f.token.isCancellationRequested)return;let j;N?r.has(S)?j=0:(j=1,r.add(S)):(r.delete(S),j=2),this.C({resource:(0,E.$Vg)(t,S),type:j,cId:this.m.correlationId})},c.a);s.set(S,(0,C.$Sc)(()=>clearTimeout(O)))}else{let O;r.has(S)?O=0:(O=1,r.add(S)),this.C({resource:(0,E.$Vg)(t,S),type:O,cId:this.m.correlationId})}else if(i==="rename"||S!==a){const O=setTimeout(async()=>{const N=await g.Promises.exists(p);f.token.isCancellationRequested||(N?(this.C({resource:t,type:0,cId:this.m.correlationId},!0),l.add(await this.y(p,!1))):this.z(t))},c.a);l.clear(),l.add((0,C.$Sc)(()=>clearTimeout(O)))}else this.C({resource:t,type:0,cId:this.m.correlationId},!0)})}catch(t){f.token.isCancellationRequested||this.G(`Failed to watch ${p} for changes using fs.watch() (${t.toString()})`),this.r?.()}return(0,C.$Sc)(()=>{f.dispose(!0),l.dispose()})}z(p){this.H("Watcher shutdown because watched path got deleted"),this.C({resource:p,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.r?.()}C(p,h=!1){this.j.token.isCancellationRequested||(this.t&&this.I(`${p.type===1?"[ADDED]":p.type===2?"[DELETED]":"[CHANGED]"} ${p.resource.fsPath}`),!h&&this.g.some(f=>f(p.resource.fsPath))?this.t&&this.I(` >> ignored (excluded) ${p.resource.fsPath}`):!h&&this.h&&this.h.length>0&&!this.h.some(f=>f(p.resource.fsPath))?this.t&&this.I(` >> ignored (not included) ${p.resource.fsPath}`):this.f.work(p))}D(p){const h=(0,d.$Cq)(p);if(h.length>0){if(this.t)for(const l of h)this.I(` >> normalized ${l.type===1?"[ADDED]":l.type===2?"[DELETED]":"[CHANGED]"} ${l.resource.fsPath}`);this.c.work(h)?this.c.pending>0&&this.I(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${h[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.H(`started ignoring events due to too many file change events at once (incoming: ${h.length}, most recent change: ${h[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async F(p){if($.$e)return g.Promises.exists(p);try{const h=(0,b.$oc)(p);return(await g.Promises.readdir((0,b.$nc)(p))).some(l=>l===h)}catch(h){return this.I(h),!1}}setVerboseLogging(p){this.t=p}G(p){this.j.token.isCancellationRequested||this.s?.({type:"error",message:`[File Watcher (node.js)] ${p}`})}H(p){this.j.token.isCancellationRequested||this.s?.({type:"warn",message:`[File Watcher (node.js)] ${p}`})}I(p){!this.j.token.isCancellationRequested&&this.t&&this.s?.({type:"trace",message:`[File Watcher (node.js)] ${p}`})}dispose(){this.j.dispose(!0),super.dispose()}}e.$Sq=c,c.a=100,c.b=75;async function m(u,p,h,f,l=512){const t=await g.Promises.open(u,"r"),a=Buffer.allocUnsafe(l),o=new P.$ee(f);let r,s=!1;const i={path:u,excludes:[],recursive:!1},v=new c(i,S=>{(async()=>{for(const{type:O}of S)if(O===0){if(s)return;s=!0;try{for(;!o.token.isCancellationRequested;){const{bytesRead:N}=await g.Promises.read(t,a,0,l,null);if(!N||o.token.isCancellationRequested)break;p(a.slice(0,N))}}catch(N){r=new Error(N),o.dispose(!0)}finally{s=!1}}})()});return await v.ready,h(),new Promise((S,O)=>{o.token.onCancellationRequested(async()=>{v.dispose();try{await g.Promises.close(t)}catch(N){r=new Error(N)}r?O(r):S()})})}}),define(Ee[229],ke([1,0,6,76,227,4,228,37]),function(ce,e,n,A,P,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=void 0;class b extends P.$Nq{constructor(){super(...arguments),this.onDidError=n.Event.None,this.H=new Set,this.I=!1}async D(E){E=this.O(E);const y=[],w=new Set(Array.from(this.H));for(const g of E){const d=this.L(g);d&&(0,A.$gk)(d.request.excludes,g.excludes)&&(0,A.$gk)(d.request.includes,g.includes)?w.delete(d):y.push(g)}y.length&&this.F(`Request to start watching: ${y.map(g=>this.C(g)).join(",")}`),w.size&&this.F(`Request to stop watching: ${Array.from(w).map(g=>this.C(g.request)).join(",")}`);for(const g of w)this.N(g);for(const g of y)this.M(g)}L(E){for(const y of this.H)if(typeof E.correlationId=="number"||typeof y.request.correlationId=="number"){if(y.request.correlationId===E.correlationId)return y}else if((0,k.$hg)(y.request.path,E.path,!D.$e))return y}M(E){const y=new C.$Sq(E,g=>this.a.fire(g),()=>this.c.fire(E),g=>this.b.fire(g),this.I),w={request:E,instance:y};this.H.add(w)}async stop(){await super.stop();for(const E of this.H)this.N(E)}N(E){this.F("stopping file watcher",E),this.H.delete(E),E.instance.dispose()}O(E){const y=new Map;for(const w of E){const g=D.$e?w.path:w.path.toLowerCase();let d=y.get(w.correlationId);d||(d=new Map,y.set(w.correlationId,d)),d.has(g)&&this.F(`ignoring a request for watching who's path is already watched: ${this.C(w)}`),d.set(g,w)}return Array.from(y.values()).map(w=>Array.from(w.values())).flat()}async setVerboseLogging(E){this.I=E;for(const y of this.H)y.instance.setVerboseLogging(E)}F(E,y){this.I&&this.b.fire({type:"trace",message:this.R(E,y)})}G(E){this.b.fire({type:"warn",message:this.R(E)})}R(E,y){return y?`[File Watcher (node.js)] ${E} (${this.C(y.request)})`:`[File Watcher (node.js)] ${E}`}}e.$Uq=b}),define(Ee[230],ke([1,0,46,229]),function(ce,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vq=void 0;class P extends n.$zq{constructor(C,k,b){super(C,k,b),this.s()}r(C){return C.add(new A.$Uq)}}e.$Vq=P}),define(Ee[231],ke([1,0,12,44,109,46]),function(ce,e,n,A,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mq=void 0;class C extends D.$Aq{constructor(b,$,E){super(b,$,E),this.s()}r(b){const $=b.add(new P.$Lq(n.$Cg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return b.add($.onDidProcessExit(({code:E,signal:y})=>this.t(`terminated by itself with code ${E}, signal: ${y}`))),A.ProxyChannel.toService((0,A.$2h)($.getChannel("watcher")))}}e.$Mq=C}),define(Ee[83],ke([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gi=void 0;class n{constructor(...P){this.a=new Map;for(const[D,C]of P)this.set(D,C)}set(P,D){const C=this.a.get(P);return this.a.set(P,D),C}has(P){return this.a.has(P)}get(P){return this.a.get(P)}}e.$gi=n}),define(Ee[113],ke([1,0,15,10,2,68,223,5,83,98]),function(ce,e,n,A,P,D,C,k,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=e.$Zq=void 0;const E=!1;class y extends Error{constructor(m){super("cyclic dependency between services"),this.message=m.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${m.toString()}`}}class w{constructor(m=new b.$gi,u=!1,p,h=E){this.f=m,this.g=u,this.h=p,this.i=h,this.o=new Set,this.f.set(k.$hi,this),this._globalGraph=h?p?._globalGraph??new C.$Yq(f=>f):void 0}createChild(m){return new w(m,this.g,this,this.i)}invokeFunction(m,...u){const p=d.traceInvocation(this.i,m);let h=!1;try{return m({get:l=>{if(h)throw(0,A.$8)("service accessor is only valid during the invocation of its target method");const t=this.m(l,p);if(!t)throw new Error(`[invokeFunction] unknown service '${l}'`);return t}},...u)}finally{h=!0,p.stop()}}createInstance(m,...u){let p,h;return m instanceof D.$fi?(p=d.traceCreation(this.i,m.ctor),h=this.j(m.ctor,m.staticArguments.concat(u),p)):(p=d.traceCreation(this.i,m),h=this.j(m,u,p)),p.stop(),h}j(m,u=[],p){const h=k._util.getServiceDependencies(m).sort((t,a)=>t.index-a.index),f=[];for(const t of h){const a=this.m(t.id,p);a||this.u(`[createInstance] ${m.name} depends on UNKNOWN service ${t.id}.`,!1),f.push(a)}const l=h.length>0?h[0].index:u.length;if(u.length!==l){console.trace(`[createInstance] First service dependency of ${m.name} at position ${l+1} conflicts with ${u.length} static arguments`);const t=l-u.length;t>0?u=u.concat(new Array(t)):u=u.slice(0,l)}return Reflect.construct(m,u.concat(f))}k(m,u){if(this.f.get(m)instanceof D.$fi)this.f.set(m,u);else if(this.h)this.h.k(m,u);else throw new Error("illegalState - setting UNKNOWN service instance")}l(m){const u=this.f.get(m);return!u&&this.h?this.h.l(m):u}m(m,u){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(m));const p=this.l(m);return p instanceof D.$fi?this.q(m,p,u.branch(m,!0)):(u.branch(m,!1),p)}q(m,u,p){if(this.o.has(m))throw new Error(`illegal state - RECURSIVELY instantiating service '${m}'`);this.o.add(m);try{return this.r(m,u,p)}finally{this.o.delete(m)}}r(m,u,p){const h=new C.$Yq(t=>t.id.toString());let f=0;const l=[{id:m,desc:u,_trace:p}];for(;l.length;){const t=l.pop();if(h.lookupOrInsertNode(t),f++>1e3)throw new y(h);for(const a of k._util.getServiceDependencies(t.desc.ctor)){const o=this.l(a.id);if(o||this.u(`[createInstance] ${m} depends on ${a.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(a.id)),o instanceof D.$fi){const r={id:a.id,desc:o,_trace:t._trace.branch(a.id,!0)};h.insertEdge(t,r),l.push(r)}}}for(;;){const t=h.roots();if(t.length===0){if(!h.isEmpty())throw new y(h);break}for(const{data:a}of t){if(this.l(a.id)instanceof D.$fi){const r=this.s(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this.k(a.id,r)}h.removeNode(a)}}return this.l(m)}s(m,u,p=[],h,f){if(this.f.get(m)instanceof D.$fi)return this.t(m,u,p,h,f);if(this.h)return this.h.s(m,u,p,h,f);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}t(m,u,p=[],h,f){if(h){const l=new w(void 0,this.g,this,this.i);l.c=String(m);const t=new Map,a=new n.$Bh(()=>{const o=l.j(u,p,f);for(const[r,s]of t){const i=o[r];if(typeof i=="function")for(const v of s)v.disposable=i.apply(o,v.listener)}return t.clear(),o});return new Proxy(Object.create(null),{get(o,r){if(!a.isInitialized&&typeof r=="string"&&(r.startsWith("onDid")||r.startsWith("onWill"))){let v=t.get(r);return v||(v=new $.$5c,t.set(r,v)),(O,N,j)=>{if(a.isInitialized)return a.value[r](O,N,j);{const I={listener:[O,N,j],disposable:void 0},B=v.push(I);return(0,P.$Sc)(()=>{B(),I.disposable?.dispose()})}}}if(r in o)return o[r];const s=a.value;let i=s[r];return typeof i!="function"||(i=i.bind(s),o[r]=i),i},set(o,r,s){return a.value[r]=s,!0},getPrototypeOf(o){return u.prototype}})}else return this.j(u,p,f)}u(m,u){if(u&&console.warn(m),this.g)throw new Error(m)}}e.$Zq=w;var g;(function(c){c[c.None=0]="None",c[c.Creation=1]="Creation",c[c.Invocation=2]="Invocation",c[c.Branch=3]="Branch"})(g||(g={}));class d{static traceInvocation(m,u){return m?new d(2,u.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):d.c}static traceCreation(m,u){return m?new d(1,u.name):d.c}constructor(m,u){this.type=m,this.name=u,this.g=Date.now(),this.h=[]}branch(m,u){const p=new d(3,m.toString());return this.h.push([m,u,p]),p}stop(){const m=Date.now()-this.g;d.f+=m;let u=!1;function p(f,l){const t=[],a=new Array(f+1).join("	");for(const[o,r,s]of l.h)if(r&&s){u=!0,t.push(`${a}CREATES -> ${o}`);const i=p(f+1,s);i&&t.push(i)}else t.push(`${a}uses -> ${o}`);return t.join(`
`)}const h=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${m.toFixed(2)}ms (grand total ${d.f.toFixed(2)}ms)`];(m>2||u)&&d.all.add(h.join(`
`))}}e.$1q=d,d.all=new Set,d.c=new class extends d{constructor(){super(0,null)}stop(){}branch(){return this}},d.f=0}),define(Ee[232],ke([1,0,5]),function(ce,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Verbosity=e.$Lv=void 0,e.$Lv=(0,n.$ii)("labelService");var A;(function(P){P[P.SHORT=0]="SHORT",P[P.MEDIUM=1]="MEDIUM",P[P.LONG=2]="LONG"})(A||(e.Verbosity=A={}))});var Ne=this&&this.__param||function(ce,e){return function(n,A){e(n,A,ce)}};define(Ee[84],ke([1,0,20,2,4,197,31,5]),function(ce,e,n,A,P,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dr=e.$Cr=void 0,e.$Br=b;function b(E){return E.tags.find(y=>y.startsWith("lp-"))?.split("lp-")[1]}e.$Cr=(0,k.$ii)("languagePackService");let $=class extends A.$Uc{constructor(y){super(),this.c=y}async getAvailableLanguages(){const y=new n.$ee;setTimeout(()=>y.cancel(),1e3);let w;try{w=await this.c.query({text:'category:"language packs"',pageSize:20},y.token)}catch{return[]}const d=w.firstPage.filter(c=>c.properties.localizedLanguages?.length&&c.tags.some(m=>m.startsWith("lp-"))).map(c=>{const m=c.properties.localizedLanguages?.[0],u=b(c);return{...this.f(u,m,c),extensionId:c.identifier.id,galleryExtension:c}});return d.push(this.f("en","English")),d}f(y,w,g){const d=w??y;let c;if(d!==y&&(c=`(${y})`),y.toLowerCase()===P.$q.toLowerCase()&&(c??(c=""),c+=(0,D.localize)(0,null)),g?.installCount){c??(c="");const m=g.installCount;let u;m>1e6?u=`${Math.floor(m/1e5)/10}M`:m>1e3?u=`${Math.floor(m/1e3)}K`:u=String(m),c+=` $(cloud-download) ${u}`}return{id:y,label:d,description:c}}};e.$Dr=$,e.$Dr=$=Fe([Ne(0,C.$So)],$)}),define(Ee[13],ke([1,0,198,40,6,64,2,24,4,19,11,3,57,5]),function(ce,e,n,A,P,D,C,k,b,$,E,y,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Rj=e.LogLevel=e.$Pj=e.$Oj=void 0,e.$Qj=c,e.log=u,e.$3j=v,e.$4j=S,e.$5j=O,e.$6j=N,e.$Oj=(0,g.$ii)("logService"),e.$Pj=(0,g.$ii)("loggerService");function d(){return new Date().toISOString()}function c(j){return(0,E.$Zf)(j)}var m;(function(j){j[j.Off=0]="Off",j[j.Trace=1]="Trace",j[j.Debug=2]="Debug",j[j.Info=3]="Info",j[j.Warning=4]="Warning",j[j.Error=5]="Error"})(m||(e.LogLevel=m={})),e.$Rj=m.Info;function u(j,I,B){switch(I){case m.Trace:j.trace(B);break;case m.Debug:j.debug(B);break;case m.Info:j.info(B);break;case m.Warning:j.warn(B);break;case m.Error:j.error(B);break;case m.Off:break;default:throw new Error(`Invalid log level ${I}`)}}function p(j,I=!1){let B="";for(let Z=0;Z<j.length;Z++){let he=j[Z];if(he instanceof Error&&(he=(0,A.$6i)(he,I)),typeof he=="object")try{he=JSON.stringify(he)}catch{}B+=(Z>0?" ":"")+he}return B}class h extends C.$Uc{constructor(){super(...arguments),this.b=e.$Rj,this.c=this.B(new P.$7d),this.onDidChangeLogLevel=this.c.event}setLevel(I){this.b!==I&&(this.b=I,this.c.fire(this.b))}getLevel(){return this.b}f(I){return this.b!==m.Off&&this.b<=I}}e.$Tj=h;class f extends h{constructor(I){super(),this.h=I}f(I){return this.h||super.f(I)}trace(I,...B){this.f(m.Trace)&&this.g(m.Trace,p([I,...B],!0))}debug(I,...B){this.f(m.Debug)&&this.g(m.Debug,p([I,...B]))}info(I,...B){this.f(m.Info)&&this.g(m.Info,p([I,...B]))}warn(I,...B){this.f(m.Warning)&&this.g(m.Warning,p([I,...B]))}error(I,...B){if(this.f(m.Error))if(I instanceof Error){const Z=Array.prototype.slice.call(arguments);Z[0]=I.stack,this.g(m.Error,p(Z))}else this.g(m.Error,p([I,...B]))}flush(){}}e.$Uj=f;class l extends h{constructor(I=e.$Rj){super(),this.setLevel(I),this.g=!b.$c}trace(I,...B){this.f(m.Trace)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,I,...B):console.log(`[main ${d()}]`,I,...B))}debug(I,...B){this.f(m.Debug)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,I,...B):console.log(`[main ${d()}]`,I,...B))}info(I,...B){this.f(m.Info)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,I,...B):console.log(`[main ${d()}]`,I,...B))}warn(I,...B){this.f(m.Warning)&&(this.g?console.warn(`\x1B[93m[main ${d()}]\x1B[0m`,I,...B):console.warn(`[main ${d()}]`,I,...B))}error(I,...B){this.f(m.Error)&&(this.g?console.error(`\x1B[91m[main ${d()}]\x1B[0m`,I,...B):console.error(`[main ${d()}]`,I,...B))}flush(){}}e.$Vj=l;class t extends h{constructor(I=e.$Rj,B=!0){super(),this.g=B,this.setLevel(I)}trace(I,...B){this.f(m.Trace)&&(this.g?console.log("%cTRACE","color: #888",I,...B):console.log(I,...B))}debug(I,...B){this.f(m.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",I,...B):console.log(I,...B))}info(I,...B){this.f(m.Info)&&(this.g?console.log("%c INFO","color: #33f",I,...B):console.log(I,...B))}warn(I,...B){this.f(m.Warning)&&(this.g?console.log("%c WARN","color: #993",I,...B):console.log(I,...B))}error(I,...B){this.f(m.Error)&&(this.g?console.log("%c  ERR","color: #f33",I,...B):console.error(I,...B))}flush(){}}e.$Wj=t;class a extends h{constructor(I,B=e.$Rj){super(),this.g=I,this.setLevel(B)}trace(I,...B){this.f(m.Trace)&&this.g.log(m.Trace,[this.h(I),...B])}debug(I,...B){this.f(m.Debug)&&this.g.log(m.Debug,[this.h(I),...B])}info(I,...B){this.f(m.Info)&&this.g.log(m.Info,[this.h(I),...B])}warn(I,...B){this.f(m.Warning)&&this.g.log(m.Warning,[this.h(I),...B])}error(I,...B){this.f(m.Error)&&this.g.log(m.Error,[this.h(I),...B])}h(I){return typeof I=="string"?I:(0,A.$6i)(I,this.f(m.Trace))}flush(){}}e.$Xj=a;class o extends h{constructor(I){super(),this.g=I,I.length&&this.setLevel(I[0].getLevel())}setLevel(I){for(const B of this.g)B.setLevel(I);super.setLevel(I)}trace(I,...B){for(const Z of this.g)Z.trace(I,...B)}debug(I,...B){for(const Z of this.g)Z.debug(I,...B)}info(I,...B){for(const Z of this.g)Z.info(I,...B)}warn(I,...B){for(const Z of this.g)Z.warn(I,...B)}error(I,...B){for(const Z of this.g)Z.error(I,...B)}flush(){for(const I of this.g)I.flush()}dispose(){for(const I of this.g)I.dispose();super.dispose()}}e.$Yj=o;class r extends C.$Uc{constructor(I,B,Z){if(super(),this.h=I,this.j=B,this.b=new k.$Bc,this.c=this.B(new P.$7d),this.onDidChangeLoggers=this.c.event,this.f=this.B(new P.$7d),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new P.$7d),this.onDidChangeVisibility=this.g.event,Z)for(const he of Z)this.b.set(he.resource,{logger:void 0,info:he})}m(I){return(0,E.$Vf)(I)?[...this.b.values()].find(B=>B.info.id===I):this.b.get(I)}getLogger(I){return this.m(I)?.logger}createLogger(I,B){const Z=this.n(I),he=(0,E.$Vf)(I)?I:B?.id??(0,D.$9i)(Z.toString()).toString(16);let ae=this.b.get(Z)?.logger;const ee=B?.logLevel==="always"?m.Trace:B?.logLevel;ae||(ae=this.s(Z,ee??this.getLogLevel(Z)??this.h,{...B,id:he}));const _={logger:ae,info:{resource:Z,id:he,logLevel:ee,name:B?.name,hidden:B?.hidden,extensionId:B?.extensionId,when:B?.when}};return this.registerLogger(_.info),this.b.set(Z,_),ae}n(I){return(0,E.$Vf)(I)?(0,$.$Vg)(this.j,`${I}.log`):I}setLogLevel(I,B){if(y.URI.isUri(I)){const Z=I,he=B,ae=this.b.get(Z);ae&&he!==ae.info.logLevel&&(ae.info.logLevel=he===this.h?void 0:he,ae.logger?.setLevel(he),this.b.set(ae.info.resource,ae),this.f.fire([Z,he]))}else{this.h=I;for(const[Z,he]of this.b.entries())this.b.get(Z)?.info.logLevel===void 0&&he.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(I,B){const Z=this.m(I);Z&&B!==!Z.info.hidden&&(Z.info.hidden=!B,this.b.set(Z.info.resource,Z),this.g.fire([Z.info.resource,B]))}getLogLevel(I){let B;return I&&(B=this.b.get(I)?.info.logLevel),B??this.h}registerLogger(I){const B=this.b.get(I.resource);B?B.info.hidden!==I.hidden&&this.setVisibility(I.resource,!I.hidden):(this.b.set(I.resource,{info:I,logger:void 0}),this.c.fire({added:[I],removed:[]}))}deregisterLogger(I){const B=this.b.get(I);B&&(B.logger&&B.logger.dispose(),this.b.delete(I),this.c.fire({added:[],removed:[B.info]}))}*getRegisteredLoggers(){for(const I of this.b.values())yield I.info}getRegisteredLogger(I){return this.b.get(I)?.info}dispose(){this.b.forEach(I=>I.logger?.dispose()),this.b.clear(),super.dispose()}}e.$Zj=r;class s{constructor(){this.onDidChangeLogLevel=new P.$7d().event}setLevel(I){}getLevel(){return m.Info}trace(I,...B){}debug(I,...B){}info(I,...B){}warn(I,...B){}error(I,...B){}critical(I,...B){}dispose(){}flush(){}}e.$1j=s;class i extends s{}e.$2j=i;function v(j){if(j.verbose)return m.Trace;if(typeof j.logLevel=="string"){const I=N(j.logLevel.toLowerCase());if(I!==void 0)return I}return e.$Rj}function S(j){switch(j){case m.Trace:return"trace";case m.Debug:return"debug";case m.Info:return"info";case m.Warning:return"warn";case m.Error:return"error";case m.Off:return"off"}}function O(j){switch(j){case m.Trace:return{original:"Trace",value:n.localize(0,null)};case m.Debug:return{original:"Debug",value:n.localize(1,null)};case m.Info:return{original:"Info",value:n.localize(2,null)};case m.Warning:return{original:"Warning",value:n.localize(3,null)};case m.Error:return{original:"Error",value:n.localize(4,null)};case m.Off:return{original:"Off",value:n.localize(5,null)}}}function N(j){switch(j){case"trace":return m.Trace;case"debug":return m.Debug;case"info":return m.Info;case"warn":return m.Warning;case"error":return m.Error;case"critical":return m.Error;case"off":return m.Off}}e.$7j=new w.$zj("logLevel",S(m.Info))}),define(Ee[233],ke([1,0,18,15,10,6,2,7,46,13]),function(ce,e,n,A,P,D,C,k,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fq=void 0;class E extends C.$Uc{constructor(w,g){super(),this.a=w,this.b=g,this.c=this.B(new D.$7d),this.onDidChangeFile=this.c.event,this.g=this.B(new D.$7d),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new A.$gh(0)),this.w=[],this.y=this.B(new A.$gh(0))}watch(w,g){return g.recursive||this.b?.watcher?.forceUniversal?this.n(w,g):this.z(w,g)}n(w,g){const d={path:this.H(w),excludes:g.excludes,includes:g.includes,recursive:g.recursive,correlationId:g.correlationId},c=(0,n.$Ub)(this.j,d);return this.r(),(0,C.$Sc)(()=>{c(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(w=>(0,P.$1)(w))}s(){this.h||(this.h=this.B(this.t(g=>this.c.fire((0,b.$Bq)(g)),g=>this.G(g),this.a.getLevel()===$.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===$.LogLevel.Trace)})));const w=this.b?.watcher?.recursive?.usePolling;if(w===!0)for(const g of this.j)(0,b.$xq)(g)&&(g.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(w))for(const g of this.j)(0,b.$xq)(g)&&w.includes(g.path)&&(g.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(w,g){const d={path:this.H(w),excludes:g.excludes,includes:g.includes,recursive:!1,correlationId:g.correlationId},c=(0,n.$Ub)(this.w,d);return this.C(),(0,C.$Sc)(()=>{c(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(w=>(0,P.$1)(w))}D(){return this.u||(this.u=this.B(this.F(w=>this.c.fire((0,b.$Bq)(w)),w=>this.G(w),this.a.getLevel()===$.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===$.LogLevel.Trace)}))),this.u.watch(this.w)}G(w){w.type==="error"&&this.g.fire(w.message),this.a[w.type](w.message)}H(w){return(0,k.$ic)(w.fsPath)}}e.$Fq=E}),define(Ee[114],ke([1,0,18,15,14,20,6,64,41,2,66,12,43,19,51,193,16,112,13,10]),function(ce,e,n,A,P,D,C,k,b,$,E,y,w,g,d,c,m,u,p,h){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.$vq=void 0;let l=f=class extends $.$Uc{constructor(a){super(),this.b=a,this.a=256*1024,this.c=this.B(new C.$7d),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new C.$7d),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new C.$7d),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new C.$7d),this.onDidRunOperation=this.r.event,this.X=this.B(new C.$7d),this.Y=this.B(new C.$7d),this.onDidFilesChange=this.Y.event,this.Z=this.B(new C.$7d),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new A.$rh)}registerProvider(a,o){if(this.h.has(a))throw new Error(`A filesystem provider for the scheme '${a}' is already registered.`);(0,w.mark)(`code/registerFilesystem/${a}`);const r=new $.$Tc;return this.h.set(a,o),this.c.fire({added:!0,scheme:a,provider:o}),r.add(o.onDidChangeFile(s=>{const i=new m.$8k(s,!this.S(o));this.X.fire(i),i.hasCorrelation()||this.Y.fire(i)})),typeof o.onDidWatchError=="function"&&r.add(o.onDidWatchError(s=>this.Z.fire(new Error(s)))),r.add(o.onDidChangeCapabilities(()=>this.g.fire({provider:o,scheme:a}))),(0,$.$Sc)(()=>{this.c.fire({added:!1,scheme:a,provider:o}),this.h.delete(a),(0,$.$Pc)(r)})}getProvider(a){return this.h.get(a)}async activateProvider(a){const o=[];this.f.fire({scheme:a,join(r){o.push(r)}}),!this.h.has(a)&&await A.Promises.settled(o)}async canHandleResource(a){return await this.activateProvider(a.scheme),this.hasProvider(a)}hasProvider(a){return this.h.has(a.scheme)}hasCapability(a,o){const r=this.h.get(a.scheme);return!!(r&&r.capabilities&o)}listCapabilities(){return b.Iterable.map(this.h,([a,o])=>({scheme:a,capabilities:o.capabilities}))}async j(a){if(!(0,g.$Zg)(a))throw new m.$0k((0,c.localize)(0,null,this.sb(a)),8);await this.activateProvider(a.scheme);const o=this.h.get(a.scheme);if(!o){const r=new h.$bb;throw r.message=(0,c.localize)(1,null,a.toString()),r}return o}async m(a){const o=await this.j(a);if((0,m.$Uk)(o)||(0,m.$Rk)(o)||(0,m.$Vk)(o))return o;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(a){const o=await this.j(a);if((0,m.$Uk)(o)||(0,m.$Rk)(o))return o;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(a,o){try{return await this.s(a,o)}catch(r){throw(0,m.$5k)(r)===m.FileSystemProviderErrorCode.FileNotFound?new m.$0k((0,c.localize)(2,null,this.sb(a)),1):(0,m.$3k)(r)}}async s(a,o){const r=await this.j(a),s=this.S(r),i=o?.resolveTo,v=o?.resolveSingleChildDescendants,S=o?.resolveMetadata,O=await r.stat(a);let N;return this.t(r,a,O,void 0,!!S,(j,I)=>(N||(N=E.$oi.forUris(()=>!s),N.set(a,!0),i&&N.fill(!0,i)),N.get(j.resource)||N.findSuperstr(j.resource.with({query:null,fragment:null}))?!0:j.isDirectory&&v?I===1:!1))}async t(a,o,r,s,i,v){const{providerExtUri:S}=this.R(a),O={resource:o,name:S.basename(o),isFile:(r.type&m.FileType.File)!==0,isDirectory:(r.type&m.FileType.Directory)!==0,isSymbolicLink:(r.type&m.FileType.SymbolicLink)!==0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:!!((r.permissions??0)&m.FilePermission.Readonly)||!!(a.capabilities&2048),locked:!!((r.permissions??0)&m.FilePermission.Locked),etag:(0,m.$il)({mtime:r.mtime,size:r.size}),children:void 0};if(O.isDirectory&&v(O,s)){try{const N=await a.readdir(o),j=await A.Promises.settled(N.map(async([I,B])=>{try{const Z=S.joinPath(o,I),he=i?await a.stat(Z):{type:B};return await this.t(a,Z,he,N.length,i,v)}catch(Z){return this.b.trace(Z),null}}));O.children=(0,n.$Hb)(j)}catch(N){this.b.trace(N),O.children=[]}return O}return O}async resolveAll(a){return A.Promises.settled(a.map(async o=>{try{return{stat:await this.s(o.resource,o.options),success:!0}}catch(r){return this.b.trace(r),{stat:void 0,success:!1}}}))}async stat(a){const o=await this.j(a),r=await o.stat(a);return this.t(o,a,r,void 0,!0,()=>!1)}async exists(a){const o=await this.j(a);try{return!!await o.stat(a)}catch{return!1}}async canCreateFile(a,o){try{await this.u(a,o)}catch(r){return r}return!0}async u(a,o){if(!o?.overwrite&&await this.exists(a))throw new m.$0k((0,c.localize)(3,null,this.sb(a)),3,o)}async createFile(a,o=P.$ue.fromString(""),r){await this.u(a,r);const s=await this.writeFile(a,o);return this.r.fire(new m.$7k(a,0,s)),s}async writeFile(a,o,r){const s=this.qb(await this.n(a),a),{providerExtUri:i}=this.R(s);let v=r;if((0,m.$Xk)(s)&&!v?.atomic){const S=s.enforceAtomicWriteFile?.(a);S&&(v={...r,atomic:S})}try{await this.w(s,a,v)||await this.U(s,i.dirname(a));let O;if((0,m.$Rk)(s)&&!(o instanceof P.$ue))if((0,d.$ge)(o)){const N=await(0,d.$ne)(o,3);N.ended?O=P.$ue.concat(N.buffer):O=N}else O=(0,d.$ke)(o,N=>P.$ue.concat(N),3);else O=o;!(0,m.$Uk)(s)||(0,m.$Rk)(s)&&O instanceof P.$ue||(0,m.$Rk)(s)&&(0,m.$Xk)(s)&&v?.atomic?await this.hb(s,a,v,O):await this.db(s,a,v,O instanceof P.$ue?(0,P.$Fe)(O):O),this.r.fire(new m.$7k(a,4))}catch(S){throw new m.$0k((0,c.localize)(4,null,this.sb(a),(0,m.$3k)(S).toString()),(0,m.$6k)(S),v)}return this.resolve(a,{resolveMetadata:!0})}async w(a,o,r){const s=!!r?.unlock;if(s&&!(a.capabilities&8192))throw new Error((0,c.localize)(5,null,this.sb(o)));if(!!r?.atomic){if(!(a.capabilities&32768))throw new Error((0,c.localize)(6,null,this.sb(o)));if(!(a.capabilities&2))throw new Error((0,c.localize)(7,null,this.sb(o)));if(s)throw new Error((0,c.localize)(8,null,this.sb(o)))}let v;try{v=await a.stat(o)}catch{return}if(v.type&m.FileType.Directory)throw new m.$0k((0,c.localize)(9,null,this.sb(o)),0,r);if(this.rb(o,v),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==m.$hl&&typeof v.mtime=="number"&&typeof v.size=="number"&&r.mtime<v.mtime&&r.etag!==(0,m.$il)({mtime:r.mtime,size:v.size}))throw new m.$0k((0,c.localize)(10,null),3,r);return v}async readFile(a,o,r){const s=await this.m(a);return o?.atomic?this.z(s,a,o,r):this.C(s,a,o,r)}async z(a,o,r,s){return new Promise((i,v)=>{this.cb.queueFor(o,async()=>{try{const S=await this.C(a,o,r,s);i(S)}catch(S){v(S)}},this.R(a).providerExtUri)})}async C(a,o,r,s){const i=await this.D(a,o,{...r,preferUnbuffered:!0},s);return{...i,value:await(0,P.$Ge)(i.value)}}async readFileStream(a,o,r){const s=await this.m(a);return this.D(s,a,o,r)}async D(a,o,r,s){const i=new D.$ee(s);let v=r;(0,m.$Wk)(a)&&a.enforceAtomicReadFile?.(o)&&(v={...r,atomic:!0});const S=this.J(o,v).then(N=>N,N=>{throw i.dispose(!0),N});let O;try{return typeof v?.etag=="string"&&v.etag!==m.$hl&&await S,v?.atomic&&(0,m.$Wk)(a)||!((0,m.$Uk)(a)||(0,m.$Vk)(a))||(0,m.$Rk)(a)&&v?.preferUnbuffered?O=this.I(a,o,v):(0,m.$Vk)(a)?O=this.G(a,o,i.token,v):O=this.H(a,o,i.token,v),O.on("end",()=>i.dispose()),O.on("error",()=>i.dispose()),{...await S,value:O}}catch(N){throw O&&await(0,d.$le)(O),this.F(N,o,v)}}F(a,o,r){const s=(0,c.localize)(11,null,this.sb(o),(0,m.$3k)(a).toString());return a instanceof m.$_k?new m.$_k(s,a.stat,r):a instanceof m.$$k?new m.$$k(s,a.fileOperationResult,a.size,a.options):new m.$0k(s,(0,m.$6k)(a),r)}G(a,o,r,s=Object.create(null)){const i=a.readFileStream(o,s,r);return(0,d.$re)(i,{data:v=>v instanceof P.$ue?v:P.$ue.wrap(v),error:v=>this.F(v,o,s)},v=>P.$ue.concat(v))}H(a,o,r,s=Object.create(null)){const i=(0,P.$Ke)();return(0,u.$uq)(a,o,i,v=>v,{...s,bufferSize:this.a,errorTransformer:v=>this.F(v,o,s)},r),i}I(a,o,r){const s=(0,d.$ie)(i=>P.$ue.concat(i));return(async()=>{try{let i;r?.atomic&&(0,m.$Wk)(a)?i=await a.readFile(o,{atomic:!0}):i=await a.readFile(o),typeof r?.position=="number"&&(i=i.slice(r.position)),typeof r?.length=="number"&&(i=i.slice(0,r.length)),this.L(o,i.byteLength,r),s.end(P.$ue.wrap(i))}catch(i){s.error(i),s.end()}})(),s}async J(a,o){const r=await this.resolve(a,{resolveMetadata:!0});if(r.isDirectory)throw new m.$0k((0,c.localize)(12,null,this.sb(a)),0,o);if(typeof o?.etag=="string"&&o.etag!==m.$hl&&o.etag===r.etag)throw new m.$_k((0,c.localize)(13,null),r,o);return this.L(a,r.size,o),r}L(a,o,r){if(typeof r?.limits?.size=="number"&&o>r.limits.size)throw new m.$$k((0,c.localize)(14,null,this.sb(a)),7,o,r)}async canMove(a,o,r){return this.M(a,o,"move",r)}async canCopy(a,o,r){return this.M(a,o,"copy",r)}async M(a,o,r,s){if(a.toString()!==o.toString())try{const i=r==="move"?this.qb(await this.n(a),a):await this.m(a),v=this.qb(await this.n(o),o);await this.Q(i,a,v,o,r,s)}catch(i){return i}return!0}async move(a,o,r){const s=this.qb(await this.n(a),a),i=this.qb(await this.n(o),o),v=await this.N(s,a,i,o,"move",!!r),S=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new m.$7k(a,v==="move"?2:3,S)),S}async copy(a,o,r){const s=await this.m(a),i=this.qb(await this.n(o),o),v=await this.N(s,a,i,o,"copy",!!r),S=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new m.$7k(a,v==="copy"?3:2,S)),S}async N(a,o,r,s,i,v){if(o.toString()===s.toString())return i;const{exists:S,isSameResourceWithDifferentPathCase:O}=await this.Q(a,o,r,s,i,v);if(S&&!O&&v&&await this.del(s,{recursive:!0}),await this.U(r,this.R(r).providerExtUri.dirname(s)),i==="copy"){if(a===r&&(0,m.$Sk)(a))await a.copy(o,s,{overwrite:v});else{const N=await this.resolve(o);N.isDirectory?await this.P(a,N,r,s):await this.O(a,o,r,s)}return i}else return a===r?(await a.rename(o,s,{overwrite:v}),i):(await this.N(a,o,r,s,"copy",v),await this.del(o,{recursive:!0}),"copy")}async O(a,o,r,s){if((0,m.$Uk)(a)&&(0,m.$Uk)(r))return this.jb(a,o,r,s);if((0,m.$Uk)(a)&&(0,m.$Rk)(r))return this.pb(a,o,r,s);if((0,m.$Rk)(a)&&(0,m.$Uk)(r))return this.nb(a,o,r,s);if((0,m.$Rk)(a)&&(0,m.$Rk)(r))return this.lb(a,o,r,s)}async P(a,o,r,s){await r.mkdir(s),Array.isArray(o.children)&&await A.Promises.settled(o.children.map(async i=>{const v=this.R(r).providerExtUri.joinPath(s,i.name);return i.isDirectory?this.P(a,await this.resolve(i.resource),r,v):this.O(a,i.resource,r,v)}))}async Q(a,o,r,s,i,v){let S=!1;if(a===r){const{providerExtUri:N,isPathCaseSensitive:j}=this.R(a);if(j||(S=N.isEqual(o,s)),S&&i==="copy")throw new Error((0,c.localize)(15,null,this.sb(o),this.sb(s)));if(!S&&N.isEqualOrParent(s,o))throw new Error((0,c.localize)(16,null,this.sb(o),this.sb(s)))}const O=await this.exists(s);if(O&&!S){if(!v)throw new m.$0k((0,c.localize)(17,null,this.sb(o),this.sb(s)),4);if(a===r){const{providerExtUri:N}=this.R(a);if(N.isEqualOrParent(o,s))throw new Error((0,c.localize)(18,null,this.sb(o),this.sb(s)))}}return{exists:O,isSameResourceWithDifferentPathCase:S}}R(a){const o=this.S(a);return{providerExtUri:o?g.$Lg:g.$Ng,isPathCaseSensitive:o}}S(a){return!!(a.capabilities&1024)}async createFolder(a){const o=this.qb(await this.j(a),a);await this.U(o,a);const r=await this.resolve(a,{resolveMetadata:!0});return this.r.fire(new m.$7k(a,0,r)),r}async U(a,o){const r=[],{providerExtUri:s}=this.R(a);for(;!s.isEqual(o,s.dirname(o));)try{if(!((await a.stat(o)).type&m.FileType.Directory))throw new Error((0,c.localize)(19,null,this.sb(o)));break}catch(i){if((0,m.$5k)(i)!==m.FileSystemProviderErrorCode.FileNotFound)throw i;r.push(s.basename(o)),o=s.dirname(o)}for(let i=r.length-1;i>=0;i--){o=s.joinPath(o,r[i]);try{await a.mkdir(o)}catch(v){if((0,m.$5k)(v)!==m.FileSystemProviderErrorCode.FileExists)throw v}}}async canDelete(a,o){try{await this.W(a,o)}catch(r){return r}return!0}async W(a,o){const r=this.qb(await this.j(a),a),s=!!o?.useTrash;if(s&&!(r.capabilities&4096))throw new Error((0,c.localize)(20,null,this.sb(a)));const i=o?.atomic;if(i&&!(r.capabilities&65536))throw new Error((0,c.localize)(21,null,this.sb(a)));if(s&&i)throw new Error((0,c.localize)(22,null,this.sb(a)));let v;try{v=await r.stat(a)}catch{}if(v)this.rb(a,v);else throw new m.$0k((0,c.localize)(23,null,this.sb(a)),1);if(!!!o?.recursive){const O=await this.resolve(a);if(O.isDirectory&&Array.isArray(O.children)&&O.children.length>0)throw new Error((0,c.localize)(24,null,this.sb(a)))}return r}async del(a,o){const r=await this.W(a,o);let s=o;if((0,m.$Yk)(r)&&!s?.atomic){const O=r.enforceAtomicDelete?.(a);O&&(s={...o,atomic:O})}const i=!!s?.useTrash,v=!!s?.recursive,S=s?.atomic??!1;await r.delete(a,{recursive:v,useTrash:i,atomic:S}),this.r.fire(new m.$7k(a,1))}async cloneFile(a,o){const r=await this.j(a),s=this.qb(await this.n(o),o);if(!(r===s&&this.R(r).providerExtUri.isEqual(a,o)))return r===s&&(0,m.$Tk)(r)?r.cloneFile(a,o):(await this.U(s,this.R(s).providerExtUri.dirname(o)),r===s&&(0,m.$Sk)(r)?this.cb.queueFor(a,()=>r.copy(a,o,{overwrite:!0}),this.R(r).providerExtUri):this.cb.queueFor(a,()=>this.O(r,a,s,o),this.R(r).providerExtUri))}createWatcher(a,o){return this.watch(a,{...o,correlationId:f.ab++})}watch(a,o={recursive:!1,excludes:[]}){const r=new $.$Tc;let s=!1,i=()=>{s=!0};r.add((0,$.$Sc)(()=>i())),(async()=>{try{const S=await this.bb(a,o);s?(0,$.$Pc)(S):i=()=>(0,$.$Pc)(S)}catch(S){this.b.error(S)}})();const v=o.correlationId;if(typeof v=="number"){const S=r.add(new C.$7d);return r.add(this.X.event(N=>{N.correlates(v)&&S.fire(N)})),{onDidChange:S.event,dispose:()=>r.dispose()}}return r}async bb(a,o){const r=await this.j(a),s=(0,k.$9i)([this.R(r).providerExtUri.getComparisonKey(a),o]);let i=this.$.get(s);return i||(i={count:0,disposable:r.watch(a,o)},this.$.set(s,i)),i.count+=1,(0,$.$Sc)(()=>{i&&(i.count--,i.count===0&&((0,$.$Pc)(i.disposable),this.$.delete(s)))})}dispose(){super.dispose();for(const[,a]of this.$)(0,$.$Pc)(a.disposable);this.$.clear()}async db(a,o,r,s){return this.cb.queueFor(o,async()=>{const i=await a.open(o,{create:!0,unlock:r?.unlock??!1});try{(0,d.$ge)(s)||(0,d.$he)(s)?await this.eb(a,i,s):await this.fb(a,i,s)}catch(v){throw(0,m.$3k)(v)}finally{await a.close(i)}},this.R(a).providerExtUri)}async eb(a,o,r){let s=0,i;if((0,d.$he)(r)){if(r.buffer.length>0){const v=P.$ue.concat(r.buffer);await this.gb(a,o,v,v.byteLength,s,0),s+=v.byteLength}if(r.ended)return;i=r.stream}else i=r;return new Promise((v,S)=>{(0,d.$me)(i,{onData:async O=>{i.pause();try{await this.gb(a,o,O,O.byteLength,s,0)}catch(N){return S(N)}s+=O.byteLength,setTimeout(()=>i.resume())},onError:O=>S(O),onEnd:()=>v()})})}async fb(a,o,r){let s=0,i;for(;(i=r.read())!==null;)await this.gb(a,o,i,i.byteLength,s,0),s+=i.byteLength}async gb(a,o,r,s,i,v){let S=0;for(;S<s;){const O=await a.write(o,i+S,r.buffer,v+S,s-S);S+=O}}async hb(a,o,r,s){return this.cb.queueFor(o,()=>this.ib(a,o,r,s),this.R(a).providerExtUri)}async ib(a,o,r,s){let i;s instanceof P.$ue?i=s:(0,d.$ge)(s)?i=await(0,P.$Ge)(s):(0,d.$he)(s)?i=await(0,P.$He)(s):i=(0,P.$Ee)(s),await a.writeFile(o,i.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1,atomic:r?.atomic??!1})}async jb(a,o,r,s){return this.cb.queueFor(s,()=>this.kb(a,o,r,s),this.R(r).providerExtUri)}async kb(a,o,r,s){let i,v;try{i=await a.open(o,{create:!1}),v=await r.open(s,{create:!0,unlock:!1});const S=P.$ue.alloc(this.a);let O=0,N=0,j=0;do j=await a.read(i,O,S.buffer,N,S.byteLength-N),await this.gb(r,v,S,j,O,N),O+=j,N+=j,N===S.byteLength&&(N=0);while(j>0)}catch(S){throw(0,m.$3k)(S)}finally{await A.Promises.settled([typeof i=="number"?a.close(i):Promise.resolve(),typeof v=="number"?r.close(v):Promise.resolve()])}}async lb(a,o,r,s){return this.cb.queueFor(s,()=>this.mb(a,o,r,s),this.R(r).providerExtUri)}async mb(a,o,r,s){return r.writeFile(s,await a.readFile(o),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(a,o,r,s){return this.cb.queueFor(s,()=>this.ob(a,o,r,s),this.R(r).providerExtUri)}async ob(a,o,r,s){const i=await r.open(s,{create:!0,unlock:!1});try{const v=await a.readFile(o);await this.gb(r,i,P.$ue.wrap(v),v.byteLength,0,0)}catch(v){throw(0,m.$3k)(v)}finally{await r.close(i)}}async pb(a,o,r,s){const i=await(0,P.$Ge)(this.H(a,o,D.CancellationToken.None));await this.hb(r,s,void 0,i)}qb(a,o){if(a.capabilities&2048)throw new m.$0k((0,c.localize)(25,null,this.sb(o)),6);return a}rb(a,o){if((o.permissions??0)&m.FilePermission.Readonly)throw new m.$0k((0,c.localize)(26,null,this.sb(a)),6)}sb(a){return a.scheme===y.Schemas.file?a.fsPath:a.toString(!0)}};e.$vq=l,l.ab=0,e.$vq=l=f=Fe([Ne(0,p.$Oj)],l)}),define(Ee[69],ke([1,0,27,311,15,24,14,6,37,2,7,4,19,51,23,196,16,112,233,40,231,230]),function(ce,e,n,A,P,D,C,k,b,$,E,y,w,g,d,c,m,u,p,h,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wq=void 0,(()=>{try{(0,A.gracefulify)(n)}catch(a){console.error(`Error enabling graceful-fs: ${(0,h.$6i)(a)}`)}})();class t extends p.$Fq{constructor(o,r){super(o,r),this.onDidChangeCapabilities=k.Event.None,this.N=new D.$Bc(s=>w.$Mg.getComparisonKey(s)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,y.$e&&(this.J|=1024)),this.J}async stat(o){try{const{stat:r,symbolicLink:s}=await d.SymlinkSupport.stat(this.H(o));return{type:this.M(r,s),ctime:r.birthtime.getTime(),mtime:r.mtime.getTime(),size:r.size,permissions:r.mode&128?void 0:m.FilePermission.Locked}}catch(r){throw this.fb(r)}}async L(o){try{return await this.stat(o)}catch{return}}async readdir(o){try{const r=await d.Promises.readdir(this.H(o),{withFileTypes:!0}),s=[];return await Promise.all(r.map(async i=>{try{let v;i.isSymbolicLink()?v=(await this.stat((0,w.$Vg)(o,i.name))).type:v=this.M(i),s.push([i.name,v])}catch(v){this.a.trace(v)}})),s}catch(r){throw this.fb(r)}}M(o,r){let s;return r?.dangling?s=m.FileType.Unknown:o.isFile()?s=m.FileType.File:o.isDirectory()?s=m.FileType.Directory:s=m.FileType.Unknown,r&&(s|=m.FileType.SymbolicLink),s}async O(o){const r=this.H(o);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${r})`);let s;for(;s=this.N.get(o);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${r})`),await s.wait();const i=new P.$hh;return this.N.set(o,i),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${r})`),(0,$.$Sc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${r})`),this.N.get(o)===i&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${r})`),this.N.delete(o)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${r})`),i.open()})}async readFile(o,r){let s;try{r?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(o)})`),s=await this.O(o));const i=this.H(o);return await d.Promises.readFile(i)}catch(i){throw this.fb(i)}finally{s?.dispose()}}P(o){t.I&&this.a.trace(o)}readFileStream(o,r,s){const i=(0,g.$ie)(v=>C.$ue.concat(v.map(S=>C.$ue.wrap(S))).buffer);return(0,u.$uq)(this,o,i,v=>v.buffer,{...r,bufferSize:256*1024},s),i}async writeFile(o,r,s){return s?.atomic!==!1&&s?.atomic?.postfix&&await this.Q(o)?this.R(o,(0,w.$Vg)((0,w.$Ug)(o),`${(0,w.$Sg)(o)}${s.atomic.postfix}`),r,s):this.S(o,r,s)}async Q(o){try{const r=this.H(o),{symbolicLink:s}=await d.SymlinkSupport.stat(r);if(s)return!1}catch{}return!0}async R(o,r,s,i){const v=new $.$Tc;try{v.add(await this.O(o)),v.add(await this.O(r)),await this.S(r,s,i,!0);try{await this.rename(r,o,{overwrite:!0})}catch(S){try{await this.delete(r,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw S}}finally{v.dispose()}}async S(o,r,s,i){let v;try{const S=this.H(o);if(!s.create||!s.overwrite){if(await d.Promises.exists(S)){if(!s.overwrite)throw(0,m.$2k)((0,c.localize)(0,null),m.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,m.$2k)((0,c.localize)(1,null),m.FileSystemProviderErrorCode.FileNotFound)}v=await this.open(o,{create:!0,unlock:s.unlock},i),await this.write(v,0,r,0,r.byteLength)}catch(S){throw await this.gb(o,S)}finally{typeof v=="number"&&await this.close(v)}}static configureFlushOnWrite(o){t.Y=o}async open(o,r,s){const i=this.H(o);let v;(0,m.$Pk)(r)&&!s&&(v=await this.O(o));let S;try{if((0,m.$Pk)(r)&&r.unlock)try{const{stat:N}=await d.SymlinkSupport.stat(i);N.mode&128||await d.Promises.chmod(i,N.mode|128)}catch(N){N.code!=="ENOENT"&&this.a.trace(N)}let O;if((0,m.$Pk)(r)){if(y.$c)try{await d.Promises.truncate(i,0),O="r+"}catch(N){N.code!=="ENOENT"&&this.a.trace(N)}O||(O="w")}else O="r";S=await d.Promises.open(i,O)}catch(O){throw v?.dispose(),(0,m.$Pk)(r)?await this.gb(o,O):this.fb(O)}if(this.U.set(S,0),(0,m.$Pk)(r)&&this.X.set(S,o),v){const O=this.W.get(S);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${S} (${i})`),this.W.set(S,v),O&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${S} (${i})`),O.dispose())}return S}async close(o){const r=this.W.get(o);try{if(this.U.delete(o),this.X.delete(o)&&t.Y)try{await d.Promises.fdatasync(o)}catch(s){t.configureFlushOnWrite(!1),this.a.error(s)}return await d.Promises.close(o)}catch(s){throw this.fb(s)}finally{r&&(this.W.get(o)===r&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${o}`),this.W.delete(o)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${o}`),r.dispose())}}async read(o,r,s,i,v){const S=this.Z(o,r);let O=null;try{O=(await d.Promises.read(o,s,i,v,S)).bytesRead}catch(N){throw this.fb(N)}finally{this.$(o,S,O)}return O}Z(o,r){return r===this.U.get(o)?null:r}$(o,r,s){const i=this.U.get(o);typeof i=="number"&&(typeof r=="number"||(typeof s=="number"?this.U.set(o,i+s):this.U.delete(o)))}async write(o,r,s,i,v){return(0,P.$Ch)(()=>this.ab(o,r,s,i,v),100,3)}async ab(o,r,s,i,v){const S=this.Z(o,r);let O=null;try{O=(await d.Promises.write(o,s,i,v,S)).bytesWritten}catch(N){throw await this.gb(this.X.get(o),N)}finally{this.$(o,S,O)}return O}async mkdir(o){try{await d.Promises.mkdir(this.H(o))}catch(r){throw this.fb(r)}}async delete(o,r){try{const s=this.H(o);if(r.recursive){let i;r?.atomic!==!1&&r.atomic.postfix&&(i=(0,E.$kc)((0,E.$nc)(s),`${(0,E.$oc)(s)}${r.atomic.postfix}`)),await d.Promises.rm(s,d.RimRafMode.MOVE,i)}else try{await d.Promises.unlink(s)}catch(i){if(i.code==="EPERM"||i.code==="EISDIR"){let v=!1;try{const{stat:S,symbolicLink:O}=await d.SymlinkSupport.stat(s);v=S.isDirectory()&&!O}catch{}if(v)await d.Promises.rmdir(s);else throw i}else throw i}}catch(s){throw this.fb(s)}}async rename(o,r,s){const i=this.H(o),v=this.H(r);if(i!==v)try{await this.bb(o,r,"move",s.overwrite),await d.Promises.rename(i,v)}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error((0,c.localize)(2,null,(0,E.$oc)(i),(0,E.$oc)((0,E.$nc)(v)),S.toString()))),this.fb(S)}}async copy(o,r,s){const i=this.H(o),v=this.H(r);if(i!==v)try{await this.bb(o,r,"copy",s.overwrite),await d.Promises.copy(i,v,{preserveSymlinks:!0})}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error((0,c.localize)(3,null,(0,E.$oc)(i),(0,E.$oc)((0,E.$nc)(v)),S.toString()))),this.fb(S)}}async bb(o,r,s,i){const v=this.H(o),S=this.H(r);let O=!1;if(!!(this.capabilities&1024)||(O=(0,b.$hg)(v,S,!0)),O){if(s==="copy")throw(0,m.$2k)((0,c.localize)(4,null),m.FileSystemProviderErrorCode.FileExists);if(s==="move")return}const j=await this.L(o);if(!j)throw(0,m.$2k)((0,c.localize)(5,null),m.FileSystemProviderErrorCode.FileNotFound);const I=await this.L(r);if(I){if(!i)throw(0,m.$2k)((0,c.localize)(6,null),m.FileSystemProviderErrorCode.FileExists);j.type&m.FileType.File&&I.type&m.FileType.File||await this.delete(r,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(o,r){return this.cb(o,r,!1)}async cb(o,r,s){const i=this.H(o),v=this.H(r),S=!!(this.capabilities&1024);if((0,b.$hg)(i,v,!S))return;const O=new $.$Tc;try{O.add(await this.O(o)),O.add(await this.O(r)),s&&await d.Promises.mkdir((0,E.$nc)(v),{recursive:!0}),await d.Promises.copyFile(i,v)}catch(N){if(N.code==="ENOENT"&&!s)return this.cb(o,r,!0);throw this.fb(N)}finally{O.dispose()}}t(o,r,s){return new f.$Mq(i=>o(i),i=>r(i),s)}F(o,r,s){return new l.$Vq(i=>o(i),i=>r(i),s)}fb(o){if(o instanceof m.$1k)return o;let r=o,s;switch(o.code){case"ENOENT":s=m.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=m.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=m.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=m.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=m.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":r=`${o.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,s=m.FileSystemProviderErrorCode.Unknown;break;default:s=m.FileSystemProviderErrorCode.Unknown}return(0,m.$2k)(r,s)}async gb(o,r){let s=this.fb(r);if(o&&s.code===m.FileSystemProviderErrorCode.NoPermissions)try{const{stat:i}=await d.SymlinkSupport.stat(this.H(o));i.mode&128||(s=(0,m.$2k)(r,m.FileSystemProviderErrorCode.FileWriteLocked))}catch(i){this.a.trace(i)}return s}}e.$Wq=t,t.I=!1,t.Y=!0}),define(Ee[234],ke([1,0,6,69,2,14,51,20]),function(ce,e,n,A,P,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$us=e.$ts=void 0;class b extends P.$Uc{constructor(y,w){super(),this.a=y,this.b=w,this.F=new Map,this.G=new Map}call(y,w,g){const d=this.c(y);switch(w){case"stat":return this.g(d,g[0]);case"readdir":return this.h(d,g[0]);case"open":return this.r(d,g[0],g[1]);case"close":return this.s(g[0]);case"read":return this.t(g[0],g[1],g[2]);case"readFile":return this.j(d,g[0],g[1]);case"write":return this.u(g[0],g[1],g[2],g[3],g[4]);case"writeFile":return this.n(d,g[0],g[1],g[2]);case"rename":return this.z(d,g[0],g[1],g[2]);case"copy":return this.C(d,g[0],g[1],g[2]);case"cloneFile":return this.D(d,g[0],g[1]);case"mkdir":return this.w(d,g[0]);case"delete":return this.y(d,g[0],g[1]);case"watch":return this.I(d,g[0],g[1],g[2],g[3]);case"unwatch":return this.J(g[0],g[1])}throw new Error(`IPC Command ${w} not found`)}listen(y,w,g){const d=this.c(y);switch(w){case"fileChange":return this.H(d,g[0]);case"readFileStream":return this.m(d,g[0],g[1])}throw new Error(`Unknown event ${w}`)}g(y,w){const g=this.f(y,w,!0);return this.a.stat(g)}h(y,w){const g=this.f(y,w);return this.a.readdir(g)}async j(y,w,g){const d=this.f(y,w,!0);this.b.trace(`File action: readFile ${d.path}`);const c=await this.a.readFile(d,g);return D.$ue.wrap(c)}m(y,w,g){const d=this.f(y,w,!0),c=new k.$ee,m=new n.$7d({onDidRemoveLastListener:()=>{c.cancel()}});this.b.trace(`File action: readFileStream ${d.path}`);const u=this.a.readFileStream(d,g,c.token);return(0,C.$me)(u,{onData:p=>m.fire(D.$ue.wrap(p)),onError:p=>m.fire(p),onEnd:()=>{m.fire("end"),m.dispose(),c.dispose()}}),m.event}n(y,w,g,d){const c=this.f(y,w);return this.b.trace(`File action: writeFile ${c.path}`),this.a.writeFile(c,g.buffer,d)}r(y,w,g){const d=this.f(y,w,!0);return this.a.open(d,g)}s(y){return this.a.close(y)}async t(y,w,g){const d=D.$ue.alloc(g),m=await this.a.read(y,w,d.buffer,0,g);return[d,m]}u(y,w,g,d,c){return this.a.write(y,w,g.buffer,d,c)}w(y,w){const g=this.f(y,w);return this.a.mkdir(g)}y(y,w,g){const d=this.f(y,w);return this.a.delete(d,g)}z(y,w,g,d){const c=this.f(y,w),m=this.f(y,g);return this.a.rename(c,m,d)}C(y,w,g,d){const c=this.f(y,w),m=this.f(y,g);return this.a.copy(c,m,d)}D(y,w,g){const d=this.f(y,w),c=this.f(y,g);return this.a.cloneFile(d,c)}H(y,w){const g=new n.$7d({onWillAddFirstListener:()=>{this.F.set(w,this.L(y,g))},onDidRemoveLastListener:()=>{(0,P.$Pc)(this.F.get(w)),this.F.delete(w)}});return g.event}async I(y,w,g,d,c){const m=this.F.get(w);if(m){const u=this.f(y,d),p=m.watch(g,u,c);this.G.set(w+g,p)}}async J(y,w){const g=y+w,d=this.G.get(g);d&&((0,P.$Pc)(d),this.G.delete(g))}dispose(){super.dispose();for(const[,y]of this.G)y.dispose();this.G.clear();for(const[,y]of this.F)y.dispose();this.F.clear()}}e.$ts=b;class $ extends P.$Uc{constructor(y,w,g,d){super(),this.c=y,this.f=g,this.g=d,this.a=new Map,this.b=this.B(new A.$Wq(this.f,{watcher:{recursive:this.j(this.g)}})),this.h(w)}h(y){const w=this.B(new n.$7d);this.B(w.event(g=>{y.fire(g.map(d=>({resource:this.c.transformOutgoingURI(d.resource),type:d.type,cId:d.cId})))})),this.B(this.b.onDidChangeFile(g=>w.fire(g))),this.B(this.b.onDidWatchError(g=>y.fire(g)))}j(y){}m(y){}watch(y,w,g){const d=this.m(this.g);return Array.isArray(d)&&(g.excludes=[...g.excludes,...d]),this.a.set(y,this.b.watch(w,g)),(0,P.$Sc)(()=>{(0,P.$Pc)(this.a.get(y)),this.a.delete(y)})}dispose(){for(const[,y]of this.a)y.dispose();this.a.clear(),super.dispose()}}e.$us=$}),define(Ee[115],ke([1,0,3,6,13,2]),function(ce,e,n,A,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xr=e.$Wr=e.$Vr=void 0;class C extends P.$Zj{constructor(y,w,g,d,c){super(w,g,d),this.r=y,this.t=c,this.B(c.listen("onDidChangeLogLevel",y)(m=>{(0,P.$Qj)(m)?super.setLogLevel(m):super.setLogLevel(n.URI.revive(m[0]),m[1])})),this.B(c.listen("onDidChangeVisibility",y)(([m,u])=>super.setVisibility(n.URI.revive(m),u))),this.B(c.listen("onDidChangeLoggers",y)(({added:m,removed:u})=>{for(const p of m)super.registerLogger({...p,resource:n.URI.revive(p.resource)});for(const p of u)super.deregisterLogger(p.resource)}))}createConsoleMainLogger(){return new P.$Xj({log:(y,w)=>{this.t.call("consoleLog",[y,w])}})}registerLogger(y){super.registerLogger(y),this.t.call("registerLogger",[y,this.r])}deregisterLogger(y){super.deregisterLogger(y),this.t.call("deregisterLogger",[y,this.r])}setLogLevel(y,w){super.setLogLevel(y,w),this.t.call("setLogLevel",[y,w])}setVisibility(y,w){super.setVisibility(y,w),this.t.call("setVisibility",[this.n(y),w])}s(y,w,g){return new k(this.t,y,w,g,this.r)}static setLogLevel(y,w,g){return y.call("setLogLevel",[w,g])}}e.$Vr=C;class k extends P.$Uj{constructor(y,w,g,d,c){super(d?.logLevel==="always"),this.r=y,this.s=w,this.m=!1,this.n=[],this.setLevel(g),this.r.call("createLogger",[w,d,c]).then(()=>{this.u(this.n),this.m=!0})}g(y,w){const g=[[y,w]];this.m?this.u(g):this.n.push(...g)}u(y){this.r.call("log",[this.s,y])}}class b{constructor(y,w){this.a=y,this.b=w}listen(y,w){const g=this.b(y);switch(w){case"onDidChangeLoggers":return A.Event.map(this.a.onDidChangeLoggers,d=>({added:[...d.added].map(c=>this.c(c,g)),removed:[...d.removed].map(c=>this.c(c,g))}));case"onDidChangeVisibility":return A.Event.map(this.a.onDidChangeVisibility,d=>[g.transformOutgoingURI(d[0]),d[1]]);case"onDidChangeLogLevel":return A.Event.map(this.a.onDidChangeLogLevel,d=>(0,P.$Qj)(d)?d:[g.transformOutgoingURI(d[0]),d[1]])}throw new Error(`Event not found: ${w}`)}async call(y,w,g){const d=this.b(y);switch(w){case"setLogLevel":return(0,P.$Qj)(g[0])?this.a.setLogLevel(g[0]):this.a.setLogLevel(n.URI.revive(d.transformIncoming(g[0][0])),g[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(c=>this.c(c,d)))}throw new Error(`Call not found: ${w}`)}c(y,w){return{...y,resource:w.transformOutgoingURI(y.resource)}}}e.$Wr=b;class $ extends D.$Uc{constructor(y,w){super(),w.call("setLogLevel",[y.getLogLevel()]),this.B(y.onDidChangeLogLevel(g=>w.call("setLogLevel",[g]))),w.call("getRegisteredLoggers").then(g=>{for(const d of g)y.registerLogger({...d,resource:n.URI.revive(d.resource)})}),this.B(w.listen("onDidChangeVisibility")(([g,d])=>y.setVisibility(n.URI.revive(g),d))),this.B(w.listen("onDidChangeLoggers")(({added:g,removed:d})=>{for(const c of g)y.registerLogger({...c,resource:n.URI.revive(c.resource)});for(const c of d)y.deregisterLogger(c.resource)}))}}e.$Xr=$}),define(Ee[116],ke([1,0,2,13]),function(ce,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bQ=void 0;class P extends n.$Uc{constructor(C,k=[]){super(),this.a=new A.$Yj([C,...k]),this.B(C.onDidChangeLogLevel(b=>this.setLevel(b)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(C){this.a.setLevel(C)}getLevel(){return this.a.getLevel()}trace(C,...k){this.a.trace(C,...k)}debug(C,...k){this.a.debug(C,...k)}info(C,...k){this.a.info(C,...k)}warn(C,...k){this.a.warn(C,...k)}error(C,...k){this.a.error(C,...k)}flush(){this.a.flush()}}e.$bQ=P}),define(Ee[235],ke([1,0,16,13]),function(ce,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3P=void 0;var P;(function($){$[$.Trace=0]="Trace",$[$.Debug=1]="Debug",$[$.Info=2]="Info",$[$.Warning=3]="Warning",$[$.Error=4]="Error",$[$.Critical=5]="Critical",$[$.Off=6]="Off"})(P||(P={}));async function D($,E,y,w,g){try{const d=await new Promise((m,u)=>{ce(["@vscode/spdlog"],m,u)});d.setFlushOn(P.Trace);const c=await d.createAsyncRotatingLogger($,E,y,w);return g?c.clearFormatters():c.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),c}catch(d){console.error(d)}return null}function C($,E,y){switch(E){case A.LogLevel.Trace:$.trace(y);break;case A.LogLevel.Debug:$.debug(y);break;case A.LogLevel.Info:$.info(y);break;case A.LogLevel.Warning:$.warn(y);break;case A.LogLevel.Error:$.error(y);break;case A.LogLevel.Off:break;default:throw new Error(`Invalid log level ${E}`)}}function k($,E){switch(E){case A.LogLevel.Trace:$.setLevel(P.Trace);break;case A.LogLevel.Debug:$.setLevel(P.Debug);break;case A.LogLevel.Info:$.setLevel(P.Info);break;case A.LogLevel.Warning:$.setLevel(P.Warning);break;case A.LogLevel.Error:$.setLevel(P.Error);break;case A.LogLevel.Off:$.setLevel(P.Off);break;default:throw new Error(`Invalid log level ${E}`)}}class b extends A.$Uj{constructor(E,y,w,g,d){super(),this.m=[],this.setLevel(d),this.n=this.s(E,y,w,g),this.B(this.onDidChangeLogLevel(c=>{this.r&&k(this.r,c)}))}async s(E,y,w,g){const d=w?6:1,c=30/d*n.$kl.MB,m=await D(E,y,c,d,g);if(m){this.r=m,k(this.r,this.getLevel());for(const{level:u,message:p}of this.m)C(this.r,u,p);this.m=[]}}g(E,y){this.r?C(this.r,E,y):this.getLevel()<=E&&this.m.push({level:E,message:y})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$3P=b}),define(Ee[117],ke([1,0,22,13,235]),function(ce,e,n,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4P=void 0;class D extends A.$Zj{s(k,b,$){return new P.$3P((0,n.$Eg)(),k.fsPath,!$?.donotRotate,!!$?.donotUseFormatters,b)}}e.$4P=D}),define(Ee[236],ke([1,0,65,199,5]),function(ce,e,n,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vt=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var D;(function(b){b[b.Unnecessary=1]="Unnecessary",b[b.Deprecated=2]="Deprecated"})(D||(e.MarkerTag=D={}));var C;(function(b){b[b.Hint=1]="Hint",b[b.Info=2]="Info",b[b.Warning=4]="Warning",b[b.Error=8]="Error"})(C||(e.MarkerSeverity=C={})),function(b){function $(d,c){return c-d}b.compare=$;const E=Object.create(null);E[b.Error]=(0,A.localize)(0,null),E[b.Warning]=(0,A.localize)(1,null),E[b.Info]=(0,A.localize)(2,null);function y(d){return E[d]||""}b.toString=y;function w(d){switch(d){case n.default.Error:return b.Error;case n.default.Warning:return b.Warning;case n.default.Info:return b.Info;case n.default.Ignore:return b.Hint}}b.fromSeverity=w;function g(d){switch(d){case b.Error:return n.default.Error;case b.Warning:return n.default.Warning;case b.Info:return n.default.Info;case b.Hint:return n.default.Ignore}}b.toSeverity=g}(C||(e.MarkerSeverity=C={}));var k;(function(b){const $="";function E(w){return y(w,!0)}b.makeKey=E;function y(w,g){const d=[$];return w.source?d.push(w.source.replace("\xA6","\\\xA6")):d.push($),w.code?typeof w.code=="string"?d.push(w.code.replace("\xA6","\\\xA6")):d.push(w.code.value.replace("\xA6","\\\xA6")):d.push($),w.severity!==void 0&&w.severity!==null?d.push(C.toString(w.severity)):d.push($),w.message&&g?d.push(w.message.replace("\xA6","\\\xA6")):d.push($),w.startLineNumber!==void 0&&w.startLineNumber!==null?d.push(w.startLineNumber.toString()):d.push($),w.startColumn!==void 0&&w.startColumn!==null?d.push(w.startColumn.toString()):d.push($),w.endLineNumber!==void 0&&w.endLineNumber!==null?d.push(w.endLineNumber.toString()):d.push($),w.endColumn!==void 0&&w.endColumn!==null?d.push(w.endColumn.toString()):d.push($),d.push($),d.join("\xA6")}b.makeKeyOptionalMessage=y})(k||(e.IMarkerData=k={})),e.$Vt=(0,P.$ii)("markerService")}),define(Ee[70],ke([1,0,6,41,2,5]),function(ce,e,n,A,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6n=e.$5n=e.$4n=void 0,e.$4n=(0,D.$ii)("policy");class C extends P.$Uc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new n.$7d),this.onDidChange=this.h.event}async updatePolicyDefinitions($){const E=Object.keys(this.f).length;return this.f={...$,...this.f},E!==Object.keys(this.f).length&&await this.j($),A.Iterable.reduce(this.g.entries(),(y,[w,g])=>({...y,[w]:g}),{})}getPolicyValue($){return this.g.get($)}serialize(){return A.Iterable.reduce(Object.entries(this.f),($,[E,y])=>({...$,[E]:{definition:y,value:this.g.get(E)}}),{})}}e.$5n=C;class k{constructor(){this.onDidChange=n.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$6n=k}),define(Ee[58],ke([1,0,30]),function(ce,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let A;const P=globalThis.vscode;if(typeof P<"u"&&typeof P.context<"u"){const D=P.context.configuration();if(D)A=D.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(A=globalThis._VSCODE_PRODUCT_JSON,n.env.VSCODE_DEV&&Object.assign(A,{nameShort:`${A.nameShort} Dev`,nameLong:`${A.nameLong} Dev`,dataFolderName:`${A.dataFolderName}-dev`,serverDataFolderName:A.serverDataFolderName?`${A.serverDataFolderName}-dev`:void 0}),!A.version){const D=globalThis._VSCODE_PACKAGE_JSON;Object.assign(A,{version:D.version})}Object.assign(A,{extensionsGallery:n.env.EXTENSIONS_GALLERY?JSON.parse(n.env.EXTENSIONS_GALLERY):A.extensionsGallery||{serviceUrl:"https://open-vsx.org/vscode/gallery",itemUrl:"https://open-vsx.org/vscode/item",resourceUrlTemplate:"https://open-vsx.org/vscode/asset/{publisher}/{name}/{version}/Microsoft.VisualStudio.Code.WebResources/{path}",controlUrl:"",recommendationsUrl:""}})}else A={nameShort:"code-server",nameLong:"code-server",applicationName:"code-server",dataFolderName:".code-server",win32MutexName:"codeserver",licenseName:"MIT",licenseUrl:"https://github.com/coder/code-server/blob/main/LICENSE",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverGreeting:[],serverLicense:[],serverLicensePrompt:"",serverApplicationName:"code-server-oss",serverDataFolderName:".vscode-server-oss",tunnelApplicationName:"code-tunnel-oss",win32DirName:"code-server",win32NameVersion:"code-server",win32RegValueName:"CodeOSS",win32x64AppId:"{{D77B7E06-80BA-4137-BCF4-654B95CCEBC5}",win32arm64AppId:"{{D1ACE434-89C5-48D1-88D3-E2991DF85475}",win32x64UserAppId:"{{CC6B787D-37A0-49E8-AE24-8559A032BE0C}",win32arm64UserAppId:"{{3AEBF0C8-F733-4AD4-BADE-FDB816D53D7B}",win32AppUserModelId:"coder.code-server",win32ShellNameShort:"c&ode-server",win32TunnelServiceMutex:"vscodeoss-tunnelservice",win32TunnelMutex:"vscodeoss-tunnel",darwinBundleIdentifier:"com.coder.code.server",linuxIconName:"com.coder.code.server",licenseFileName:"LICENSE.txt",reportIssueUrl:"https://github.com/coder/code-server/issues/new",nodejsRepository:"https://nodejs.org",urlProtocol:"code-oss",webviewContentExternalBaseUrlTemplate:"https://{{uuid}}.vscode-cdn.net/insider/ef65ac1ba57f57f2a3961bfe94aa20481caca4c6/out/vs/workbench/contrib/webview/browser/pre/",builtInExtensions:[{name:"ms-vscode.js-debug-companion",version:"1.1.2",sha256:"e034b8b41beb4e97e02c70f7175bd88abe66048374c2bd629f54bb33354bc2aa",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.88.0",sha256:"3a048d87c0fac116fce9190ff6042ec7691e66fc17211a058faf0db91bb6605e",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"1.0.8",sha256:"ca30069e21fbf576b49638ff8ff7c316b028c2faca924c23526737c65b8762bf",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}}],enableTelemetry:!0,quality:"stable",codeServerVersion:"0.0.0",documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",linkProtectionTrustedDomains:["https://open-vsx.org"],trustedExtensionAuthAccess:["vscode.git","vscode.github","github.vscode-pull-request-github","github.copilot","github.copilot-chat"],aiConfig:{ariaKey:"code-server"},version:"1.88.0",commit:"0cca7c67a4aba0e8ce199df0fdc59b64fc659fbc",date:"2024-04-05T22:24:44.781Z"},Object.keys(A).length===0&&Object.assign(A,{version:"1.87.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=A}),define(Ee[32],ke([1,0,5]),function(ce,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9j=e.$8j=void 0,e.$8j=(0,n.$ii)("productService"),e.$9j="vscode://schemas/vscode-product"}),define(Ee[38],ke([1,0,97,11]),function(ce,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2n=void 0;class P{constructor(){this.a=new Map}add(C,k){n.ok(A.$Vf(C)),n.ok(A.$Xf(k)),n.ok(!this.a.has(C),"There is already an extension with this id"),this.a.set(C,k)}knows(C){return this.a.has(C)}as(C){return this.a.get(C)||null}}e.$2n=new P}),define(Ee[237],ke([1,0,6,38]),function(ce,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3n=void 0,e.$3n={JSONContribution:"base.contributions.json"};function P(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class D{constructor(){this.b=new n.$7d,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(b,$){this.a[P(b)]=$,this.b.fire(b)}notifySchemaChanged(b){this.b.fire(b)}getSchemaContributions(){return{schemas:this.a}}}const C=new D;A.$2n.add(e.$3n.JSONContribution,C)}),define(Ee[47],ke([1,0,18,6,11,180,25,237,38]),function(ce,e,n,A,P,D,C,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.ConfigurationScope=e.$7n=e.EditPresentationTypes=void 0,e.$fo=c,e.$go=m,e.$ho=u,e.$io=h,e.$jo=f;var $;(function(l){l.Multiline="multilineText",l.Singleline="singlelineText"})($||(e.EditPresentationTypes=$={})),e.$7n={Configuration:"base.contributions.configuration"};var E;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.MACHINE=2]="MACHINE",l[l.WINDOW=3]="WINDOW",l[l.RESOURCE=4]="RESOURCE",l[l.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",l[l.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(E||(e.ConfigurationScope=E={})),e.$8n={properties:{},patternProperties:{}},e.$9n={properties:{},patternProperties:{}},e.$0n={properties:{},patternProperties:{}},e.$$n={properties:{},patternProperties:{}},e.$_n={properties:{},patternProperties:{}},e.$ao={properties:{},patternProperties:{}},e.$bo="vscode://schemas/settings/resourceLanguage",e.$co="vscode://schemas/settings/configurationDefaults";const y=b.$2n.as(k.$3n.JSONContribution);class w{constructor(){this.h=new Set,this.i=new A.$7d,this.onDidSchemaChange=this.i.event,this.j=new A.$7d,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:D.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},y.registerSchema(e.$bo,this.g),this.v()}registerConfiguration(t,a=!0){this.registerConfigurations([t],a)}registerConfigurations(t,a=!0){const o=new Set;this.n(t,a,o),y.registerSchema(e.$bo,this.g),this.i.fire(),this.j.fire({properties:o})}deregisterConfigurations(t){const a=new Set;this.o(t,a),y.registerSchema(e.$bo,this.g),this.i.fire(),this.j.fire({properties:a})}updateConfigurations({add:t,remove:a}){const o=new Set;this.o(a,o),this.n(t,!1,o),y.registerSchema(e.$bo,this.g),this.i.fire(),this.j.fire({properties:o})}registerDefaultConfigurations(t){const a=new Set;this.k(t,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}k(t,a){const o=[];for(const{overrides:r,source:s}of t)for(const i in r)if(a.add(i),e.$eo.test(i)){const v=this.a.get(i),S=v?.valuesSources??new Map;if(s)for(const I of Object.keys(r[i]))S.set(I,s);const O={...v?.value||{},...r[i]};this.a.set(i,{source:s,value:O,valuesSources:S});const N=(0,C.$Yi)(i),j={type:"object",default:O,description:D.localize(1,null,N),$ref:e.$bo,defaultDefaultValue:O,source:P.$Vf(s)?void 0:s,defaultValueSource:s};o.push(...c(i)),this.d[i]=j,this.b.properties[i]=j}else{this.a.set(i,{value:r[i],source:s});const v=this.d[i];v&&(this.w(i,v),this.r(i,v))}this.m(o)}deregisterDefaultConfigurations(t){const a=new Set;this.l(t,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}l(t,a){for(const{overrides:o,source:r}of t)for(const s in o){const i=this.a.get(s),v=P.$Vf(r)?r:r?.id,S=P.$Vf(i?.source)?i?.source:i?.source?.id;if(v===S)if(a.add(s),this.a.delete(s),e.$eo.test(s))delete this.d[s],delete this.b.properties[s];else{const O=this.d[s];O&&(this.w(s,O),this.r(s,O))}}this.u()}deltaConfiguration(t){let a=!1;const o=new Set;t.removedDefaults&&(this.l(t.removedDefaults,o),a=!0),t.addedDefaults&&(this.k(t.addedDefaults,o),a=!0),t.removedConfigurations&&this.o(t.removedConfigurations,o),t.addedConfigurations&&this.n(t.addedConfigurations,!1,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:a})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const a of t)this.h.add(a);this.u()}n(t,a,o){t.forEach(r=>{this.p(r,a,r.extensionInfo,r.restrictedProperties,void 0,o),this.c.push(r),this.q(r)})}o(t,a){const o=r=>{if(r.properties)for(const s in r.properties){a.add(s);const i=this.d[s];i?.policy?.name&&this.e.delete(i.policy.name),delete this.d[s],this.s(s,r.properties[s])}r.allOf?.forEach(s=>o(s))};for(const r of t){o(r);const s=this.c.indexOf(r);s!==-1&&this.c.splice(s,1)}}p(t,a=!0,o,r,s=3,i){s=P.$5f(t.scope)?s:t.scope;const v=t.properties;if(v)for(const O in v){const N=v[O];if(a&&h(O,N)){delete v[O];continue}if(N.source=o,N.defaultDefaultValue=v[O].default,this.w(O,N),e.$eo.test(O)?N.scope=void 0:(N.scope=P.$5f(N.scope)?s:N.scope,N.restricted=P.$5f(N.restricted)?!!r?.includes(O):N.restricted),v[O].hasOwnProperty("included")&&!v[O].included){this.f[O]=v[O],delete v[O];continue}else this.d[O]=v[O],v[O].policy?.name&&this.e.set(v[O].policy.name,O);!v[O].deprecationMessage&&v[O].markdownDeprecationMessage&&(v[O].deprecationMessage=v[O].markdownDeprecationMessage),i.add(O)}const S=t.allOf;if(S)for(const O of S)this.p(O,a,o,r,s,i)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const a=o=>{const r=o.properties;if(r)for(const i in r)this.r(i,r[i]);o.allOf?.forEach(a)};a(t)}r(t,a){switch(e.$8n.properties[t]=a,a.scope){case 1:e.$9n.properties[t]=a;break;case 2:e.$0n.properties[t]=a;break;case 6:e.$$n.properties[t]=a;break;case 3:e.$_n.properties[t]=a;break;case 4:e.$ao.properties[t]=a;break;case 5:e.$ao.properties[t]=a,this.g.properties[t]=a;break}}s(t,a){switch(delete e.$8n.properties[t],a.scope){case 1:delete e.$9n.properties[t];break;case 2:delete e.$0n.properties[t];break;case 6:delete e.$$n.properties[t];break;case 3:delete e.$_n.properties[t];break;case 4:case 5:delete e.$ao.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const a=`[${t}]`,o={type:"object",description:D.localize(2,null),errorMessage:D.localize(3,null),$ref:e.$bo};this.w(a,o),e.$8n.properties[a]=o,e.$9n.properties[a]=o,e.$0n.properties[a]=o,e.$$n.properties[a]=o,e.$_n.properties[a]=o,e.$ao.properties[a]=o}}v(){const t={type:"object",description:D.localize(4,null),errorMessage:D.localize(5,null),$ref:e.$bo};e.$8n.patternProperties[e.$do]=t,e.$9n.patternProperties[e.$do]=t,e.$0n.patternProperties[e.$do]=t,e.$$n.patternProperties[e.$do]=t,e.$_n.patternProperties[e.$do]=t,e.$ao.patternProperties[e.$do]=t,this.i.fire()}w(t,a){const o=this.a.get(t);let r=o?.value,s=o?.source;P.$3f(r)&&(r=a.defaultDefaultValue,s=void 0),P.$3f(r)&&(r=u(a.type)),a.default=r,a.defaultValueSource=s}}const g="\\[([^\\]]+)\\]",d=new RegExp(g,"g");e.$do=`^(${g})+$`,e.$eo=new RegExp(e.$do);function c(l){const t=[];if(e.$eo.test(l)){let a=d.exec(l);for(;a?.length;){const o=a[1].trim();o&&t.push(o),a=d.exec(l)}}return(0,n.$Mb)(t)}function m(l){return l.reduce((t,a)=>`${t}[${a}]`,"")}function u(l){switch(Array.isArray(l)?l[0]:l){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const p=new w;b.$2n.add(e.$7n.Configuration,p);function h(l,t){return l.trim()?e.$eo.test(l)?D.localize(7,null,l):p.getConfigurationProperties()[l]!==void 0?D.localize(8,null,l):t.policy?.name&&p.getPolicyConfigurations().get(t.policy?.name)!==void 0?D.localize(9,null,l,t.policy?.name,p.getPolicyConfigurations().get(t.policy?.name)):null:D.localize(6,null)}function f(){const l=[],t=p.getConfigurationProperties();for(const a of Object.keys(t))l.push([a,t[a].scope]);return l.push(["launch",4]),l.push(["task",4]),l}}),define(Ee[118],ke([1,0,18,6,42,2,24,21,11,3,25,47,38]),function(ce,e,n,A,P,D,C,k,b,$,E,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$po=e.$no=e.$mo=e.$lo=e.$ko=void 0,e.$oo=h;function g(a){return Object.isFrozen(a)?a:k.$Qn(a)}class d{constructor(o={},r=[],s=[],i){this.b=o,this.c=r,this.d=s,this.raw=i,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const o=this.raw.map(r=>{if(r instanceof d)return r;const s=new c("");return s.parseRaw(r),s.configurationModel});this.f=o.reduce((r,s)=>s===r?s:r.merge(s),o[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(o){return o?(0,E.$Wi)(this.contents,o):this.contents}inspect(o,r){const s=this;return{get value(){return g(s.rawConfiguration.getValue(o))},get override(){return r?g(s.rawConfiguration.getOverrideValue(o,r)):void 0},get merged(){return g(r?s.rawConfiguration.override(r).getValue(o):s.rawConfiguration.getValue(o))},get overrides(){const i=[];for(const{contents:v,identifiers:S,keys:O}of s.rawConfiguration.overrides){const N=new d(v,O).getValue(o);N!==void 0&&i.push({identifiers:S,value:N})}return i.length?g(i):void 0}}}getOverrideValue(o,r){const s=this.i(r);return s?o?(0,E.$Wi)(s,o):s:void 0}getKeysForOverrideIdentifier(o){const r=[];for(const s of this.overrides)s.identifiers.includes(o)&&r.push(...s.keys);return n.$Mb(r)}getAllOverrideIdentifiers(){const o=[];for(const r of this.overrides)o.push(...r.identifiers);return n.$Mb(o)}override(o){let r=this.a.get(o);return r||(r=this.g(o),this.a.set(o,r)),r}merge(...o){const r=k.$Pn(this.contents),s=k.$Pn(this.overrides),i=[...this.keys],v=this.raw?.length?[...this.raw]:[this];for(const S of o)if(v.push(...S.raw?.length?S.raw:[S]),!S.isEmpty()){this.h(r,S.contents);for(const O of S.overrides){const[N]=s.filter(j=>n.$ub(j.identifiers,O.identifiers));N?(this.h(N.contents,O.contents),N.keys.push(...O.keys),N.keys=n.$Mb(N.keys)):s.push(k.$Pn(O))}for(const O of S.keys)i.indexOf(O)===-1&&i.push(O)}return new d(r,i,s,v.every(S=>S instanceof d)?void 0:v)}g(o){const r=this.i(o);if(!r||typeof r!="object"||!Object.keys(r).length)return this;const s={};for(const i of n.$Mb([...Object.keys(this.contents),...Object.keys(r)])){let v=this.contents[i];const S=r[i];S&&(typeof v=="object"&&typeof S=="object"?(v=k.$Pn(v),this.h(v,S)):v=S),s[i]=v}return new d(s,this.keys,this.overrides)}h(o,r){for(const s of Object.keys(r)){if(s in o&&b.$Xf(o[s])&&b.$Xf(r[s])){this.h(o[s],r[s]);continue}o[s]=k.$Pn(r[s])}}i(o){let r=null,s=null;const i=v=>{v&&(s?this.h(s,v):s=k.$Pn(v))};for(const v of this.overrides)v.identifiers.length===1&&v.identifiers[0]===o?r=v.contents:v.identifiers.includes(o)&&i(v.contents);return i(r),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(o,r){this.j(o,r,!0)}setValue(o,r){this.j(o,r,!1)}removeValue(o){const r=this.keys.indexOf(o);r!==-1&&(this.keys.splice(r,1),(0,E.$Vi)(this.contents,o),y.$eo.test(o)&&this.overrides.splice(this.overrides.findIndex(s=>n.$ub(s.identifiers,(0,y.$fo)(o))),1))}j(o,r,s){(0,E.$Ui)(this.contents,o,r,i=>console.error(i)),s=s||this.keys.indexOf(o)===-1,s&&this.keys.push(o),y.$eo.test(o)&&this.overrides.push({identifiers:(0,y.$fo)(o),keys:Object.keys(this.contents[o]),contents:(0,E.$Ti)(this.contents[o],i=>console.error(i))})}}e.$ko=d;class c{constructor(o){this.f=o,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new d}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(o,r){if(!b.$5f(o)){const s=this.g(o);this.parseRaw(s,r)}}reparse(o){this.a&&this.parseRaw(this.a,o)}parseRaw(o,r){this.a=o;const{contents:s,keys:i,overrides:v,restricted:S,hasExcludedProperties:O}=this.h(o,r);this.b=new d(s,i,v,O?[o]:void 0),this.c=S||[]}g(o){let r={},s=null,i=[];const v=[],S=[];function O(j){Array.isArray(i)?i.push(j):s!==null&&(i[s]=j)}const N={onObjectBegin:()=>{const j={};O(j),v.push(i),i=j,s=null},onObjectProperty:j=>{s=j},onObjectEnd:()=>{i=v.pop()},onArrayBegin:()=>{const j=[];O(j),v.push(i),i=j,s=null},onArrayEnd:()=>{i=v.pop()},onLiteralValue:O,onError:(j,I,B)=>{S.push({error:j,offset:I,length:B})}};if(o)try{P.$Dn(o,N),r=i[0]||{}}catch(j){console.error(`Error while parsing settings file ${this.f}: ${j}`),this.d=[j]}return r}h(o,r){const s=w.$2n.as(y.$7n.Configuration).getConfigurationProperties(),i=this.i(o,s,!0,r);o=i.raw;const v=(0,E.$Ti)(o,N=>console.error(`Conflict in settings file ${this.f}: ${N}`)),S=Object.keys(o),O=this.j(o,N=>console.error(`Conflict in settings file ${this.f}: ${N}`));return{contents:v,keys:S,overrides:O,restricted:i.restricted,hasExcludedProperties:i.hasExcludedProperties}}i(o,r,s,i){let v=!1;if(!i?.scopes&&!i?.skipRestricted&&!i?.exclude?.length)return{raw:o,restricted:[],hasExcludedProperties:v};const S={},O=[];for(const N in o)if(y.$eo.test(N)&&s){const j=this.i(o[N],r,!1,i);S[N]=j.raw,v=v||j.hasExcludedProperties,O.push(...j.restricted)}else{const j=r[N],I=j?typeof j.scope<"u"?j.scope:3:void 0;j?.restricted&&O.push(N),!i.exclude?.includes(N)&&(i.include?.includes(N)||(I===void 0||i.scopes===void 0||i.scopes.includes(I))&&!(i.skipRestricted&&j?.restricted))?S[N]=o[N]:v=!0}return{raw:S,restricted:O,hasExcludedProperties:v}}j(o,r){const s=[];for(const i of Object.keys(o))if(y.$eo.test(i)){const v={};for(const S in o[i])v[S]=o[i][S];s.push({identifiers:(0,y.$fo)(i),keys:Object.keys(v),contents:(0,E.$Ti)(v,r)})}return s}}e.$lo=c;class m extends D.$Uc{constructor(o,r,s,i){super(),this.c=o,this.f=r,this.g=i,this.b=this.B(new A.$7d),this.onDidChange=this.b.event,this.a=new c(this.c.toString()),this.B(this.g.watch(s.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(A.Event.any(A.Event.filter(this.g.onDidFilesChange,v=>v.contains(this.c)),A.Event.filter(this.g.onDidRunOperation,v=>(v.isOperation(0)||v.isOperation(3)||v.isOperation(1)||v.isOperation(4))&&s.isEqual(v.resource,o)))(()=>this.b.fire()))}async loadConfiguration(){try{const o=await this.g.readFile(this.c);return this.a.parse(o.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new d}}reparse(o){return o&&(this.f=o),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$mo=m;class u{constructor(o,r,s,i,v,S,O,N,j,I,B,Z,he){this.a=o,this.b=r,this.c=s,this.overrideIdentifiers=i,this.d=v,this.f=S,this.g=O,this.h=N,this.i=j,this.j=I,this.k=B,this.l=Z,this.m=he}get value(){return g(this.c)}n(o){return o?.value!==void 0||o?.override!==void 0||o?.overrides!==void 0?o:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class p{constructor(o,r,s,i,v=new d,S=new d,O=new C.$Bc,N=new d,j=new C.$Bc){this.c=o,this.d=r,this.f=s,this.g=i,this.h=v,this.i=S,this.j=O,this.l=N,this.m=j,this.a=null,this.b=new C.$Bc,this.n=null}getValue(o,r,s){return this.p(o,r,s).getValue(o)}updateValue(o,r,s={}){let i;s.resource?(i=this.m.get(s.resource),i||(i=new d,this.m.set(s.resource,i))):i=this.l,r===void 0?i.removeValue(o):i.setValue(o,r),s.resource||(this.a=null)}inspect(o,r,s){const i=this.p(o,r,s),v=this.t(r.resource,s),S=r.resource?this.m.get(r.resource)||this.l:this.l,O=new Set;for(const N of i.overrides)for(const j of N.identifiers)i.getOverrideValue(o,j)!==void 0&&O.add(j);return new u(o,r,i.getValue(o),O.size?[...O]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,s?this.i:void 0,v||void 0,S)}keys(o){const r=this.t(void 0,o);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:r?r.keys.slice(0):[]}}updateDefaultConfiguration(o){this.c=o,this.a=null,this.b.clear()}updatePolicyConfiguration(o){this.d=o}updateApplicationConfiguration(o){this.f=o,this.a=null,this.b.clear()}updateLocalUserConfiguration(o){this.g=o,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(o){this.h=o,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(o){this.i=o,this.a=null,this.b.clear()}updateFolderConfiguration(o,r){this.j.set(o,r),this.b.delete(o)}deleteFolderConfiguration(o){this.folderConfigurations.delete(o),this.b.delete(o)}compareAndUpdateDefaultConfiguration(o,r){const s=[];if(!r){const{added:i,updated:v,removed:S}=l(this.c,o);r=[...i,...v,...S]}for(const i of r)for(const v of(0,y.$fo)(i)){const S=this.c.getKeysForOverrideIdentifier(v),O=o.getKeysForOverrideIdentifier(v),N=[...O.filter(j=>S.indexOf(j)===-1),...S.filter(j=>O.indexOf(j)===-1),...S.filter(j=>!k.$Tn(this.c.override(v).getValue(j),o.override(v).getValue(j)))];s.push([v,N])}return this.updateDefaultConfiguration(o),{keys:r,overrides:s}}compareAndUpdatePolicyConfiguration(o){const{added:r,updated:s,removed:i}=l(this.d,o),v=[...r,...s,...i];return v.length&&this.updatePolicyConfiguration(o),{keys:v,overrides:[]}}compareAndUpdateApplicationConfiguration(o){const{added:r,updated:s,removed:i,overrides:v}=l(this.applicationConfiguration,o),S=[...r,...s,...i];return S.length&&this.updateApplicationConfiguration(o),{keys:S,overrides:v}}compareAndUpdateLocalUserConfiguration(o){const{added:r,updated:s,removed:i,overrides:v}=l(this.localUserConfiguration,o),S=[...r,...s,...i];return S.length&&this.updateLocalUserConfiguration(o),{keys:S,overrides:v}}compareAndUpdateRemoteUserConfiguration(o){const{added:r,updated:s,removed:i,overrides:v}=l(this.remoteUserConfiguration,o),S=[...r,...s,...i];return S.length&&this.updateRemoteUserConfiguration(o),{keys:S,overrides:v}}compareAndUpdateWorkspaceConfiguration(o){const{added:r,updated:s,removed:i,overrides:v}=l(this.workspaceConfiguration,o),S=[...r,...s,...i];return S.length&&this.updateWorkspaceConfiguration(o),{keys:S,overrides:v}}compareAndUpdateFolderConfiguration(o,r){const s=this.folderConfigurations.get(o),{added:i,updated:v,removed:S,overrides:O}=l(s,r),N=[...i,...v,...S];return(N.length||!s)&&this.updateFolderConfiguration(o,r),{keys:N,overrides:O}}compareAndDeleteFolderConfiguration(o){const r=this.folderConfigurations.get(o);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(o);const{added:s,updated:i,removed:v,overrides:S}=l(r,void 0);return{keys:[...s,...i,...v],overrides:S}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(o,r,s){let i=this.q(r,s);return r.overrideIdentifier&&(i=i.override(r.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(o)!==void 0&&(i=i.merge(this.d)),i}q({resource:o},r){let s=this.r();if(r&&o){const i=r.getFolder(o);i&&(s=this.s(i.uri)||s);const v=this.m.get(o);v&&(s=s.merge(v))}return s}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(o){let r=this.b.get(o);if(!r){const s=this.r(),i=this.j.get(o);i?(r=s.merge(i),this.b.set(o,r)):r=s}return r}t(o,r){if(r&&o){const s=r.getFolder(o);if(s)return this.j.get(s.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((o,r)=>{const{contents:s,overrides:i,keys:v}=this.j.get(r);return o.push([r,{contents:s,overrides:i,keys:v}]),o},[])}}allKeys(){const o=new Set;return this.c.keys.forEach(r=>o.add(r)),this.userConfiguration.keys.forEach(r=>o.add(r)),this.i.keys.forEach(r=>o.add(r)),this.j.forEach(r=>r.keys.forEach(s=>o.add(s))),[...o.values()]}u(){const o=new Set;return this.c.getAllOverrideIdentifiers().forEach(r=>o.add(r)),this.userConfiguration.getAllOverrideIdentifiers().forEach(r=>o.add(r)),this.i.getAllOverrideIdentifiers().forEach(r=>o.add(r)),this.j.forEach(r=>r.getAllOverrideIdentifiers().forEach(s=>o.add(s))),[...o.values()]}v(o){const r=new Set;return this.c.getKeysForOverrideIdentifier(o).forEach(s=>r.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(o).forEach(s=>r.add(s)),this.i.getKeysForOverrideIdentifier(o).forEach(s=>r.add(s)),this.j.forEach(s=>s.getKeysForOverrideIdentifier(o).forEach(i=>r.add(i))),[...r.values()]}static parse(o){const r=this.w(o.defaults),s=this.w(o.policy),i=this.w(o.application),v=this.w(o.user),S=this.w(o.workspace),O=o.folders.reduce((N,j)=>(N.set($.URI.revive(j[0]),this.w(j[1])),N),new C.$Bc);return new p(r,s,i,v,new d,S,O,new d,new C.$Bc)}static w(o){return new d(o.contents,o.keys,o.overrides)}}e.$no=p;function h(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const o=new Set,r=new Map;for(const i of a)i.keys.forEach(v=>o.add(v)),i.overrides.forEach(([v,S])=>{const O=(0,C.$yc)(r,v,new Set);S.forEach(N=>O.add(N))});const s=[];return r.forEach((i,v)=>s.push([v,[...i.values()]])),{keys:[...o.values()],overrides:s}}class f{constructor(o,r,s,i){this.change=o,this.f=r,this.g=s,this.h=i,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.i=void 0;for(const v of o.keys)this.affectedKeys.add(v);for(const[,v]of o.overrides)for(const S of v)this.affectedKeys.add(S);this.d=this.a;for(const v of this.affectedKeys)this.d+=v+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=p.parse(this.f.data)),this.i}affectsConfiguration(o,r){const s=this.a+o,i=this.d.indexOf(s);if(i<0)return!1;const v=i+s.length;if(v>=this.d.length)return!1;const S=this.d.charCodeAt(v);if(S!==this.b&&S!==this.c)return!1;if(r){const O=this.previousConfiguration?this.previousConfiguration.getValue(o,r,this.f?.workspace):void 0,N=this.g.getValue(o,r,this.h);return!k.$Tn(O,N)}return!0}}e.$po=f;function l(a,o){const{added:r,removed:s,updated:i}=t(o?.rawConfiguration,a?.rawConfiguration),v=[],S=a?.getAllOverrideIdentifiers()||[],O=o?.getAllOverrideIdentifiers()||[];if(o){const N=O.filter(j=>!S.includes(j));for(const j of N)v.push([j,o.getKeysForOverrideIdentifier(j)])}if(a){const N=S.filter(j=>!O.includes(j));for(const j of N)v.push([j,a.getKeysForOverrideIdentifier(j)])}if(o&&a){for(const N of S)if(O.includes(N)){const j=t({contents:a.getOverrideValue(void 0,N)||{},keys:a.getKeysForOverrideIdentifier(N)},{contents:o.getOverrideValue(void 0,N)||{},keys:o.getKeysForOverrideIdentifier(N)});v.push([N,[...j.added,...j.removed,...j.updated]])}}return{added:r,removed:s,updated:i,overrides:v}}function t(a,o){const r=a?o?a.keys.filter(v=>o.keys.indexOf(v)===-1):[...a.keys]:[],s=o?a?o.keys.filter(v=>a.keys.indexOf(v)===-1):[...o.keys]:[],i=[];if(a&&o){for(const v of o.keys)if(a.keys.indexOf(v)!==-1){const S=(0,E.$Wi)(o.contents,v),O=(0,E.$Wi)(a.contents,v);k.$Tn(S,O)||i.push(v)}}return{added:r,removed:s,updated:i}}}),define(Ee[238],ke([1,0,18,6,2,21,11,118,47,13,70,38]),function(ce,e,n,A,P,D,C,k,b,$,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$so=e.$ro=e.$qo=void 0;class w extends P.$Uc{constructor(){super(...arguments),this.a=this.B(new A.$7d),this.onDidChangeConfiguration=this.a.event,this.b=new k.$ko}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(y.$2n.as(b.$7n.Configuration).onDidUpdateConfiguration(({properties:m,defaultsOverrides:u})=>this.c(Array.from(m),u))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(m,u){this.h(m,y.$2n.as(b.$7n.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:m})}f(){return{}}g(){this.b=new k.$ko;const m=y.$2n.as(b.$7n.Configuration).getConfigurationProperties();this.h(Object.keys(m),m)}h(m,u){const p=this.f();for(const h of m){const f=p[h],l=u[h];f!==void 0?this.b.addValue(h,f):l?this.b.addValue(h,l.default):this.b.removeValue(h)}}}e.$qo=w;class g{constructor(){this.onDidChangeConfiguration=A.Event.None,this.configurationModel=new k.$ko}async initialize(){return this.configurationModel}}e.$ro=g;let d=class extends P.$Uc{get configurationModel(){return this.b}constructor(m,u,p){super(),this.c=m,this.f=u,this.g=p,this.a=this.B(new A.$7d),this.onDidChangeConfiguration=this.a.event,this.b=new k.$ko}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(m=>this.j(m))),this.B(this.c.onDidChangeConfiguration(async({properties:m})=>this.m(await this.h(m),!0))),this.b}async h(m){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",m);const u={},p=[],h=y.$2n.as(b.$7n.Configuration).getConfigurationProperties();for(const f of m){const l=h[f];if(!l){p.push(f);continue}if(l.policy){if(l.type!=="string"&&l.type!=="number"){this.g.warn(`Policy ${l.policy.name} has unsupported type ${l.type}`);continue}p.push(f),u[l.policy.name]={type:l.type}}}return(0,C.$9f)(u)||await this.f.updatePolicyDefinitions(u),p}j(m){this.g.trace("PolicyConfiguration#onDidChangePolicies",m);const u=y.$2n.as(b.$7n.Configuration).getPolicyConfigurations(),p=(0,n.$Hb)(m.map(h=>u.get(h)));this.m(p,!0)}m(m,u){this.g.trace("PolicyConfiguration#update",m);const p=y.$2n.as(b.$7n.Configuration).getConfigurationProperties(),h=[],f=this.b.isEmpty();for(const l of m){const t=p[l]?.policy?.name;if(t){const a=this.f.getPolicyValue(t);(f?a!==void 0:!(0,D.$Tn)(this.b.getValue(l),a))&&h.push([l,a])}else this.b.getValue(l)!==void 0&&h.push([l,void 0])}if(h.length){this.g.trace("PolicyConfiguration#changed",h);const l=this.b;this.b=new k.$ko;for(const t of l.keys)this.b.setValue(t,l.getValue(t));for(const[t,a]of h)a===void 0?this.b.removeValue(t):this.b.setValue(t,a);u&&this.a.fire(this.b)}}};e.$so=d,e.$so=d=Fe([Ne(1,E.$4n),Ne(2,$.$Oj)],d)}),define(Ee[119],ke([1,0,18,15,14,6,42,147,2,21,4,19,25,118,47,238,70]),function(ce,e,n,A,P,D,C,k,b,$,E,y,w,g,d,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$to=void 0;class u extends b.$Uc{constructor(f,l,t,a){super(),this.m=f,this.h=this.B(new D.$7d),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new c.$qo),this.c=t instanceof m.$6n?new c.$ro:this.B(new c.$so(this.b,t,a)),this.f=this.B(new g.$mo(this.m,{},y.$Mg,l)),this.a=new g.$no(this.b.configurationModel,this.c.configurationModel,new g.$ko,new g.$ko),this.j=new p(f,l,this),this.g=this.B(new A.$uh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:o,properties:r})=>this.r(o,r))),this.B(this.c.onDidChangeConfiguration(o=>this.s(o))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[f,l,t]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new g.$no(f,l,new g.$ko,t)}getConfigurationData(){return this.a.toData()}getValue(f,l){const t=typeof f=="string"?f:void 0,a=(0,w.$Pi)(f)?f:(0,w.$Pi)(l)?l:{};return this.a.getValue(t,a,void 0)}async updateValue(f,l,t,a,o){const r=(0,w.$Qi)(t)?t:(0,w.$Pi)(t)?{resource:t.resource,overrideIdentifiers:t.overrideIdentifier?[t.overrideIdentifier]:void 0}:void 0,s=r?a:t;if(s!==void 0&&s!==3&&s!==2)throw new Error(`Unable to write ${f} to target ${s}.`);r?.overrideIdentifiers&&(r.overrideIdentifiers=(0,n.$Mb)(r.overrideIdentifiers),r.overrideIdentifiers=r.overrideIdentifiers.length?r.overrideIdentifiers:void 0);const i=this.inspect(f,{resource:r?.resource,overrideIdentifier:r?.overrideIdentifiers?r.overrideIdentifiers[0]:void 0});if(i.policyValue!==void 0)throw new Error(`Unable to write ${f} because it is configured in system policy.`);if((0,$.$Tn)(l,i.defaultValue)&&(l=void 0),r?.overrideIdentifiers?.length&&r.overrideIdentifiers.length>1){const S=r.overrideIdentifiers.sort(),O=this.a.localUserConfiguration.overrides.find(N=>(0,n.$ub)([...N.identifiers].sort(),S));O&&(r.overrideIdentifiers=O.identifiers)}const v=r?.overrideIdentifiers?.length?[(0,d.$go)(r.overrideIdentifiers),f]:[f];await this.j.write(v,l),await this.reloadConfiguration()}inspect(f,l={}){return this.a.inspect(f,l,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const f=await this.f.loadConfiguration();this.n(f)}n(f){const l=this.a.toData(),t=this.a.compareAndUpdateLocalUserConfiguration(f);this.t(t,l,2)}r(f,l){const t=this.a.toData(),a=this.a.compareAndUpdateDefaultConfiguration(f,l);this.t(a,t,7)}s(f){const l=this.a.toData(),t=this.a.compareAndUpdatePolicyConfiguration(f);this.t(t,l,7)}t(f,l,t){const a=new g.$po(f,{data:l},this.a);a.source=t,this.h.fire(a)}}e.$to=u;class p{constructor(f,l,t){this.b=f,this.c=l,this.d=t,this.a=new A.$ph}write(f,l){return this.a.queue(()=>this.e(f,l))}async e(f,l){let t;try{t=(await this.c.readFile(this.b)).value.toString()}catch(r){if(r.fileOperationResult===1)t="{}";else throw r}const a=[];if((0,C.$wn)(t,a,{allowTrailingComma:!0,allowEmptyContent:!0}),a.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const o=this.f(t,f,l);t=(0,k.$On)(t,o),await this.c.writeFile(this.b,P.$ue.fromString(t))}f(f,l,t){const{tabSize:a,insertSpaces:o,eol:r}=this.h;if(!l.length){const s=JSON.stringify(t,null,o?" ".repeat(a):"	");return[{content:s,length:s.length,offset:0}]}return(0,k.$Ln)(f,l,t,{tabSize:a,insertSpaces:o,eol:r})}get h(){if(!this.g){let f=E.OS===3||E.OS===2?`
`:`\r
`;const l=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});l&&typeof l=="string"&&l!=="auto"&&(f=l),this.g={eol:f,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(Ee[120],ke([1,0,10,5]),function(ce,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wl=e.RemoteAuthorityResolverErrorCode=e.$vl=e.$ul=e.RemoteConnectionType=e.$tl=void 0,e.$xl=$,e.$tl=(0,A.$ii)("remoteAuthorityResolverService");var P;(function(E){E[E.WebSocket=0]="WebSocket",E[E.Managed=1]="Managed"})(P||(e.RemoteConnectionType=P={}));class D{constructor(y){this.id=y,this.type=1}toString(){return`Managed(${this.id})`}}e.$ul=D;class C{constructor(y,w){this.host=y,this.port=w,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$vl=C;var k;(function(E){E.Unknown="Unknown",E.NotAvailable="NotAvailable",E.TemporarilyNotAvailable="TemporarilyNotAvailable",E.NoResolverFound="NoResolverFound",E.InvalidAuthority="InvalidAuthority"})(k||(e.RemoteAuthorityResolverErrorCode=k={}));class b extends n.$bb{static isNotAvailable(y){return y instanceof b&&y._code===k.NotAvailable}static isTemporarilyNotAvailable(y){return y instanceof b&&y._code===k.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof b&&y._code===k.NoResolverFound}static isInvalidAuthority(y){return y instanceof b&&y._code===k.InvalidAuthority}static isHandled(y){return y instanceof b&&y.isHandled}constructor(y,w=k.Unknown,g){super(y),this._message=y,this._code=w,this._detail=g,this.isHandled=w===k.NotAvailable&&g===!0,Object.setPrototypeOf(this,b.prototype)}}e.$wl=b;function $(E){const y=E.indexOf("+");return y===-1?E:E.substring(0,y)}}),define(Ee[239],ke([1,0,5]),function(ce,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eQ=e.$dQ=void 0,e.$dQ=(0,n.$ii)("IRemoteExtensionsScannerService"),e.$eQ="remoteExtensionsScanner"}),define(Ee[85],ke([1,0,12]),function(ce,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$um=A,e.$vm=P,e.$wm=D,e.$xm=C;function A(b){return b.scheme===n.Schemas.vscodeRemote?b.authority:void 0}function P(b){if(!b)return;const $=b.indexOf("+");return $<0?b:b.substr(0,$)}function D(b){const{host:$,port:E}=k(b);if(typeof E>"u")throw new Error(`Invalid remote authority: ${b}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:$,port:E}}function C(b,$){let{host:E,port:y}=k(b);return typeof y>"u"&&(y=$),{host:E,port:y}}function k(b){const $=b.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if($)return{host:$[1],port:parseInt($[2],10)};const E=b.match(/^(\[[0-9a-z:]+\])$/);if(E)return{host:E[1],port:void 0};const y=b.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:b,port:void 0}}}),define(Ee[35],ke([1,0,17,5,85]),function(ce,e,n,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lm=e.$Gm=e.$Fm=e.$Em=e.TargetPlatform=e.ExtensionType=e.$Dm=e.$Bm=e.$Am=e.$zm=e.$ym=void 0,e.$Cm=D,e.$Hm=y,e.$Im=w,e.$Jm=g,e.$Km=d,e.$ym="extensions.user.cache",e.$zm="extensions.builtin.cache",e.$Am="undefined_publisher",e.$Bm=["ui","workspace","web"];function D(c){if(typeof c=="object"&&c!==null&&c.supported!==!0)return c.description}e.$Dm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var C;(function(c){c[c.System=0]="System",c[c.User=1]="User"})(C||(e.ExtensionType=C={}));var k;(function(c){c.WIN32_X64="win32-x64",c.WIN32_ARM64="win32-arm64",c.LINUX_X64="linux-x64",c.LINUX_ARM64="linux-arm64",c.LINUX_ARMHF="linux-armhf",c.ALPINE_X64="alpine-x64",c.ALPINE_ARM64="alpine-arm64",c.DARWIN_X64="darwin-x64",c.DARWIN_ARM64="darwin-arm64",c.WEB="web",c.UNIVERSAL="universal",c.UNKNOWN="unknown",c.UNDEFINED="undefined"})(k||(e.TargetPlatform=k={}));class b{constructor(m){this.value=m,this._lower=m.toLowerCase()}static equals(m,u){if(typeof m>"u"||m===null)return typeof u>"u"||u===null;if(typeof u>"u"||u===null)return!1;if(typeof m=="string"||typeof u=="string"){const p=typeof m=="string"?m:m.value,h=typeof u=="string"?u:u.value;return n.$lf(p,h)}return m._lower===u._lower}static toKey(m){return typeof m=="string"?m.toLowerCase():m._lower}}e.$Em=b;class ${get size(){return this.c.size}constructor(m){if(this.c=new Set,m)for(const u of m)this.add(u)}add(m){this.c.add(b.toKey(m))}delete(m){return this.c.delete(b.toKey(m))}has(m){return this.c.has(b.toKey(m))}}e.$Fm=$;class E{constructor(){this.c=new Map}clear(){this.c.clear()}delete(m){this.c.delete(b.toKey(m))}get(m){return this.c.get(b.toKey(m))}has(m){return this.c.has(b.toKey(m))}set(m,u){this.c.set(b.toKey(m),u)}values(){return this.c.values()}forEach(m){this.c.forEach(m)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Gm=E;function y(c){return w(c)}function w(c){return c.contributes&&c.contributes.localizations?c.contributes.localizations.length>0:!1}function g(c){return c.contributes&&c.contributes.authentication?c.contributes.authentication.length>0:!1}function d(c,m){if(m){const u=`onResolveRemoteAuthority:${(0,P.$vm)(m)}`;return!!c.activationEvents?.includes(u)}return!1}e.$Lm=(0,A.$ii)("IBuiltinExtensionsScannerService")}),define(Ee[240],ke([1,0,10,35]),function(ce,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UF=e.$TF=void 0;class P{constructor(){this.a=new Map,this.b=new WeakMap}register(C,k){this.a.set(C,k)}readActivationEvents(C){return this.b.has(C)||this.b.set(C,this.c(C)),this.b.get(C)}createActivationEventsMap(C){const k=Object.create(null);for(const b of C){const $=this.readActivationEvents(b);$.length>0&&(k[A.$Em.toKey(b.identifier)]=$)}return k}c(C){if(typeof C.main>"u"&&typeof C.browser>"u")return[];const k=Array.isArray(C.activationEvents)?C.activationEvents.slice(0):[];for(let b=0;b<k.length;b++)k[b]==="onUri"&&(k[b]=`onUri:${A.$Em.toKey(C.identifier)}`);if(!C.contributes)return k;for(const b in C.contributes){const $=this.a.get(b);if(!$)continue;const E=C.contributes[b],y=Array.isArray(E)?E:[E];try{$(y,k)}catch(w){(0,n.$1)(w)}}return k}}e.$TF=P,e.$UF=new P}),define(Ee[241],ke([1,0,2,35,16]),function(ce,e,n,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oq=void 0;class D extends n.$Uc{constructor(k,b,$,E,y){super(),this.a=k,this.b=b,this.c=$,this.f=y,this.B(E.onDidInstallExtensions(w=>this.g(w))),this.B(E.onDidUninstallExtension(w=>this.h(w)))}g(k){for(const b of k)b.local&&this.invalidate(b.profileLocation)}h(k){k.error||this.invalidate(k.profileLocation)}async invalidate(k){if(k)for(const b of this.a.profiles)this.c.extUri.isEqual(b.extensionsResource,k)&&await this.j(b);else await this.j(this.a.defaultProfile)}async j(k){try{await this.b.del(this.c.extUri.joinPath(k.cacheHome,A.$ym))}catch(b){(0,P.$6k)(b)!==1&&this.f.error(b)}}}e.$oq=D}),define(Ee[48],ke([1,0,14,10,2,200,47,5,13,38]),function(ce,e,n,A,P,D,C,k,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bp=e.$Ap=void 0,e.$Cp=w,e.$Dp=g,e.$Ep=d,e.$Fp=c,e.$Gp=m,e.$Hp=u,e.$Ap=(0,k.$ii)("requestService");class E{constructor(l){this.b=l}toJSON(){if(!this.a){const l=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?l[t]="*****":l[t]=this.b[t];this.a=l}return this.a}}class y extends P.$Uc{constructor(l){super(),this.b=0,this.a=l.createLogger("network",{name:(0,D.localize)(0,null),when:b.$7j.isEqualTo((0,b.$4j)(b.LogLevel.Trace)).serialize()})}async c(l,t,a){const o=`${l} #${++this.b}: ${t.url}`;this.a.trace(`${o} - begin`,t.type,new E(t.headers??{}));try{const r=await a();return this.a.trace(`${o} - end`,t.type,r.res.statusCode,r.res.headers),r}catch(r){throw this.a.error(`${o} - error`,t.type,(0,A.$0)(r)),r}}}e.$Bp=y;function w(f){return f.res.statusCode&&f.res.statusCode>=200&&f.res.statusCode<300||f.res.statusCode===1223}function g(f){return f.res.statusCode===204}async function d(f){return g(f)?null:(await(0,n.$Ge)(f.stream)).toString()}async function c(f){if(!w(f))throw new Error("Server returned "+f.res.statusCode);return d(f)}async function m(f){if(!w(f))throw new Error("Server returned "+f.res.statusCode);if(g(f))return null;const t=(await(0,n.$Ge)(f.stream)).toString();try{return JSON.parse(t)}catch(a){throw a.message+=`:
`+t,a}}function u(f){h(f)}let p;function h(f){const l=$.$2n.as(C.$7n.Configuration),t=p;p={id:"http",order:15,title:(0,D.localize)(1,null),type:"object",scope:f,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,D.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,D.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,D.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,D.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,D.localize)(6,null),(0,D.localize)(7,null),(0,D.localize)(8,null),(0,D.localize)(9,null)],default:"override",description:(0,D.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,D.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,D.localize)(12,null),restricted:!0}}},l.updateConfigurations({add:[p],remove:t?[t]:[]})}h(1)}),define(Ee[242],ke([1,0,20,12,16,48]),function(ce,e,n,A,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uQ=void 0;let C=class{constructor(b,$){this.a=b,this.b=$}async download(b,$,E=n.CancellationToken.None){if(b.scheme===A.Schemas.file||b.scheme===A.Schemas.vscodeRemote){await this.b.copy(b,$);return}const y={type:"GET",url:b.toString(!0)},w=await this.a.request(y,E);if(w.res.statusCode===200)await this.b.writeFile($,w.stream);else{const g=await(0,D.$Fp)(w);throw new Error(`Expected 200, got back ${w.res.statusCode} instead.

${g}`)}}};e.$uQ=C,e.$uQ=C=Fe([Ne(0,D.$Ap),Ne(1,P.$Ok)],C)}),define(Ee[243],ke([1,0,14,20]),function(ce,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gr=e.$Fr=void 0;class P{constructor(k){this.a=k}listen(k,b){throw new Error("Invalid listen")}call(k,b,$,E=A.CancellationToken.None){switch(b){case"request":return this.a.request($[0],E).then(async({res:y,stream:w})=>{const g=await(0,n.$Ge)(w);return[{statusCode:y.statusCode,headers:y.headers},g]});case"resolveProxy":return this.a.resolveProxy($[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$Fr=P;class D{constructor(k){this.a=k}async request(k,b){const[$,E]=await this.a.call("request",[k],b);return{res:$,stream:(0,n.$Ie)(E)}}async resolveProxy(k){return this.a.call("resolveProxy",[k])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$Gr=D}),define(Ee[244],ke([1,0,86,11]),function(ce,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hr=D;function P(C,k){return C.protocol==="http:"?k.HTTP_PROXY||k.http_proxy||null:C.protocol==="https:"&&(k.HTTPS_PROXY||k.https_proxy||k.HTTP_PROXY||k.http_proxy)||null}async function D(C,k,b={}){const $=(0,n.parse)(C),E=b.proxyUrl||P($,k);if(!E)return null;const y=(0,n.parse)(E);if(!/^https?:$/.test(y.protocol||""))return null;const w={host:y.hostname||"",port:(y.port?+y.port:0)||(y.protocol==="https"?443:80),auth:y.auth,rejectUnauthorized:(0,A.$2f)(b.strictSSL)?b.strictSSL:!0,keepAlive:!0};return $.protocol==="http:"?new(await new Promise((g,d)=>{ce(["http-proxy-agent"],g,d)})).HttpProxyAgent(E,w):new(await new Promise((g,d)=>{ce(["https-proxy-agent"],g,d)})).HttpsProxyAgent(E,w)}}),define(Ee[87],ke([1,0,55,7,201,20,40,10,4,22,107,218,15,150]),function(ce,e,n,A,P,D,C,k,b,$,E,y,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tm=c;let d;async function c(u,p,h,f){return h["force-disable-user-env"]?(p.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):b.$c?(p.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,y.$nm)(f)&&!h["force-user-env"]?(p.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,y.$nm)(f)?p.trace("resolveShellEnv(): running (--force-user-env)"):p.trace("resolveShellEnv(): running (macOS/Linux)"),d||(d=w.Promises.withAsyncBody(async(l,t)=>{const a=new D.$ee;let o=1e4;const r=u.getValue("application.shellEnvironmentResolutionTimeout");typeof r=="number"&&(o=(0,g.$om)(r,1,120)*1e3);const s=setTimeout(()=>{a.dispose(!0),t(new Error((0,P.localize)(0,null)))},o);try{l(await m(p,a.token))}catch(i){!(0,k.$4)(i)&&!a.token.isCancellationRequested?t(new Error((0,P.localize)(1,null,(0,C.$6i)(i)))):l({})}finally{clearTimeout(s),a.dispose()}})),d)}async function m(u,p){const h=process.env.ELECTRON_RUN_AS_NODE;u.trace("getUnixShellEnvironment#runAsNode",h);const f=process.env.ELECTRON_NO_ATTACH_CONSOLE;u.trace("getUnixShellEnvironment#noAttach",f);const l=(0,$.$Eg)().replace(/-/g,"").substr(0,12),t=new RegExp(l+"({.*})"+l),a={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};u.trace("getUnixShellEnvironment#env",a);const o=await(0,E.$dm)(b.OS,a);return u.trace("getUnixShellEnvironment#shell",o),new Promise((r,s)=>{if(p.isCancellationRequested)return s(new k.$5);const i=(0,A.$oc)(o);let v,S;const O="";/^pwsh(-preview)?$/.test(i)?(v=`& '${process.execPath}' ${O} -p '''${l}'' + JSON.stringify(process.env) + ''${l}'''`,S=["-Login","-Command"]):i==="nu"?(v=`^'${process.execPath}' ${O} -p '"${l}" + JSON.stringify(process.env) + "${l}"'`,S=["-i","-l","-c"]):i==="xonsh"?(v=`import os, json; print("${l}", json.dumps(dict(os.environ)), "${l}")`,S=["-i","-l","-c"]):(v=`'${process.execPath}' ${O} -p '"${l}" + JSON.stringify(process.env) + "${l}"'`,i==="tcsh"||i==="csh"?S=["-ic"]:S=["-i","-l","-c"]),u.trace("getUnixShellEnvironment#spawn",JSON.stringify(S),v);const N=(0,n.spawn)(o,[...S,v],{detached:!0,stdio:["ignore","pipe","pipe"],env:a});p.onCancellationRequested(()=>(N.kill(),s(new k.$5))),N.on("error",B=>{u.error("getUnixShellEnvironment#errorChildProcess",(0,C.$6i)(B)),s(B)});const j=[];N.stdout.on("data",B=>j.push(B));const I=[];N.stderr.on("data",B=>I.push(B)),N.on("close",(B,Z)=>{const he=Buffer.concat(j).toString("utf8");u.trace("getUnixShellEnvironment#raw",he);const ae=Buffer.concat(I).toString("utf8");if(ae.trim()&&u.trace("getUnixShellEnvironment#stderr",ae),B||Z)return s(new Error((0,P.localize)(2,null,B,Z)));const ee=t.exec(he),_=ee?ee[1]:"{}";try{const z=JSON.parse(_);h?z.ELECTRON_RUN_AS_NODE=h:delete z.ELECTRON_RUN_AS_NODE,f?z.ELECTRON_NO_ATTACH_CONSOLE=f:delete z.ELECTRON_NO_ATTACH_CONSOLE,delete z.VSCODE_RESOLVING_ENVIRONMENT,delete z.XDG_RUNTIME_DIR,u.trace("getUnixShellEnvironment#result",z),r(z)}catch(z){u.error("getUnixShellEnvironment#errorCaught",(0,C.$6i)(z)),s(z)}})})}}),define(Ee[245],ke([1,0,5]),function(ce,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6P=e.$5P=void 0,e.$5P=(0,n.$ii)("stateReadService"),e.$6P=(0,n.$ii)("stateService")}),define(Ee[246],ke([1,0,15,14,2,11,26,16,13]),function(ce,e,n,A,P,D,C,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9P=e.$8P=e.$7P=e.SaveStrategy=void 0;var $;(function(g){g[g.IMMEDIATE=0]="IMMEDIATE",g[g.DELAYED=1]="DELAYED"})($||(e.SaveStrategy=$={}));class E extends P.$Uc{constructor(d,c,m,u){super(),this.h=d,this.j=c,this.m=m,this.n=u,this.a=Object.create(null),this.b="",this.c=this.B(new n.$gh(this.j===0?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(d){d.fileOperationResult!==1&&this.m.error(d)}}getItem(d,c){const m=this.a[d];return(0,D.$5f)(m)?c:m}setItem(d,c){this.setItems([{key:d,data:c}])}setItems(d){let c=!1;for(const{key:m,data:u}of d)this.a[m]!==u&&((0,D.$5f)(u)?(0,D.$3f)(this.a[m])||(this.a[m]=void 0,c=!0):(this.a[m]=u,c=!0));c&&this.s()}removeItem(d){(0,D.$3f)(this.a[d])||(this.a[d]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const d=JSON.stringify(this.a,null,4);if(d!==this.b)try{await this.n.writeFile(this.h,A.$ue.fromString(d),{atomic:{postfix:".vsctmp"}}),this.b=d}catch(c){this.m.error(c)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$7P=E;let y=class extends P.$Uc{constructor(d,c,m,u){super(),this.a=this.B(new E(c.stateResource,d,m,u))}async init(){await this.a.init()}getItem(d,c){return this.a.getItem(d,c)}};e.$8P=y,e.$8P=y=Fe([Ne(1,C.$pi),Ne(2,b.$Oj),Ne(3,k.$Ok)],y);class w extends y{setItem(d,c){this.a.setItem(d,c)}setItems(d){this.a.setItems(d)}removeItem(d){this.a.removeItem(d)}close(){return this.a.close()}}e.$9P=w}),define(Ee[121],ke([1,0,4,30,22]),function(ce,e,n,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3o=C,e.$4o=k;function D(b){if(n.$o===2&&/^penguin(\.|$)/i.test(b))return"chromebook"}function C(b,$,E,y,w,g,d,c,m){const u=Object.create(null);u["common.machineId"]=g,u["common.sqmId"]=d,u.sessionID=(0,P.$Eg)()+Date.now(),u.commitHash=y,u.version=w,u["common.platformVersion"]=(b||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),u["common.platform"]=(0,n.$b)(n.$o),u["common.nodePlatform"]=A.$ec,u["common.nodeArch"]=E,u["common.product"]=m||"desktop",c&&(u["common.msftInternal"]=c);let p=0;const h=Date.now();Object.defineProperties(u,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-h,enumerable:!0},"common.sequence":{get:()=>p++,enumerable:!0}}),n.$f&&(u["common.snap"]="true");const f=D($);return f&&(u["common.platformDetail"]=f),u}function k(b){const $=A.env.USERDNSDOMAIN;if(!$)return!1;const E=$.toLowerCase();return b.some(y=>E===y)}}),define(Ee[247],ke([1,0,18,10,2,21,16]),function(ce,e,n,A,P,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ErrorEvent=void 0;var k;(function($){function E(y,w){return y.callstack<w.callstack?-1:y.callstack>w.callstack?1:0}$.compare=E})(k||(e.ErrorEvent=k={}));class b{constructor(E,y=b.ERROR_FLUSH_TIMEOUT){this.f=-1,this.g=[],this.h=new P.$Tc,this.c=E,this.d=y;const w=A.$X.addListener(g=>this.j(g));this.h.add((0,P.$Sc)(w)),this.i()}dispose(){clearTimeout(this.f),this.l(),this.h.dispose()}i(){}j(E){if(!E||E.code||(E.detail&&E.detail.stack&&(E=E.detail),A.$bb.isErrorNoTelemetry(E)||E instanceof C.$0k||typeof E?.message=="string"&&E.message.includes("Unable to read file")))return;const y=Array.isArray(E.stack)?E.stack.join(`
`):E.stack,w=E.message?E.message:(0,D.$Un)(E);y&&this.k({msg:w,callstack:y})}k(E){const y=(0,n.$wb)(this.g,E,k.compare);y<0?(E.count=1,this.g.splice(~y,0,E)):(this.g[y].count||(this.g[y].count=0),this.g[y].count+=1),this.f===-1&&(this.f=setTimeout(()=>{this.l(),this.f=-1},this.d))}l(){for(const E of this.g)this.c.publicLogError2("UnhandledError",E);this.g.length=0}}b.ERROR_FLUSH_TIMEOUT=5*1e3,e.default=b}),define(Ee[248],ke([1,0,2]),function(ce,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zs=void 0;class A extends n.$Uc{constructor(D,C){super(),this.a=D,this.b=C}async call(D,C,k){switch(C){case"updateTelemetryLevel":{const{telemetryLevel:b}=k;return this.a.updateInjectedTelemetryLevel(b)}case"logTelemetry":{const{eventName:b,data:$}=k;return this.b?this.b.log(b,$):Promise.resolve()}case"flushTelemetry":return this.b?this.b.flush():Promise.resolve();case"ping":return}throw new Error(`IPC Command ${C} not found`)}listen(D,C,k){throw new Error("Not supported")}dispose(){this.a.updateInjectedTelemetryLevel(0),super.dispose()}}e.$zs=A}),define(Ee[29],ke([1,0,5]),function(ce,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Xl=e.$Wl=e.$Vl=e.$Ul=e.$Tl=e.$Sl=e.$Rl=e.$Ql=e.$Pl=e.$Ol=e.$Nl=void 0,e.$Nl=(0,n.$ii)("telemetryService"),e.$Ol=(0,n.$ii)("customEndpointTelemetryService"),e.$Pl="telemetry.currentSessionDate",e.$Ql="telemetry.firstSessionDate",e.$Rl="telemetry.lastSessionDate",e.$Sl="telemetry.machineId",e.$Tl="telemetry.sqmId",e.$Ul="telemetry",e.$Vl="telemetry.telemetryLevel",e.$Wl="telemetry.enableCrashReporter",e.$Xl="telemetry.enableTelemetry";var A;(function(D){D[D.NONE=0]="NONE",D[D.CRASH=1]="CRASH",D[D.ERROR=2]="ERROR",D[D.USAGE=3]="USAGE"})(A||(e.TelemetryLevel=A={}));var P;(function(D){D.OFF="off",D.CRASH="crash",D.ERROR="error",D.ON="all"})(P||(e.TelemetryConfiguration=P={}))}),define(Ee[249],ke([1,0,28,15,42,12,7,4,3,103,23,106,224,16,32,29]),function(ce,e,n,A,P,D,C,k,b,$,E,y,w,g,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rs=void 0,e.$os=u,e.$ps=h,e.$qs=f;const m=new Map;async function u(t,a){const o=`${t}::${a.join(":")}`,r=m.get(o);if(r)return r;const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],i=new Map,v=new Map,S=2e4;function O(j,I,B,Z){const he=I.substring(j.length+1);return A.Promises.withAsyncBody(async ae=>{let ee;try{ee=await E.Promises.readdir(I,{withFileTypes:!0})}catch{ae();return}if(Z.count>=S){Z.count+=ee.length,Z.maxReached=!0,ae();return}let _=ee.length;if(_===0){ae();return}let z=ee;Z.count+ee.length>S&&(Z.maxReached=!0,_=S-Z.count,z=ee.slice(0,_)),Z.count+=ee.length;for(const T of z)if(T.isDirectory()){if(B.includes(T.name)||await O(j,(0,C.$kc)(I,T.name),B,Z),--_===0){ae();return}}else{const J=T.name.lastIndexOf(".");if(J>=0){const Y=T.name.substring(J+1);Y&&i.set(Y,(i.get(Y)??0)+1)}for(const Y of s)Y.relativePathPattern?.test(he)!==!1&&Y.filePattern.test(T.name)&&v.set(Y.tag,(v.get(Y.tag)??0)+1);if(--_===0){ae();return}}})}const N=A.Promises.withAsyncBody(async j=>{const I={count:0,maxReached:!1};await O(t,t,a,I);const B=await f(t);j({configFiles:p(v),fileTypes:p(i),fileCount:I.count,maxFilesReached:I.maxReached,launchConfigFiles:B})});return m.set(o,N),N}function p(t){return Array.from(t.entries(),([a,o])=>({name:a,count:o})).sort((a,o)=>o.count-a.count)}function h(){const t={os:`${n.type()} ${n.arch()} ${n.release()}`,memory:`${(n.totalmem()/g.$kl.GB).toFixed(2)}GB (${(n.freemem()/g.$kl.GB).toFixed(2)}GB free)`,vmHint:`${Math.round($.$rn.value()*100)}%`},a=n.cpus();return a&&a.length>0&&(t.cpus=`${a[0].model} (${a.length} x ${a[0].speed})`),t}async function f(t){try{const a=new Map,o=(0,C.$kc)(t,".vscode","launch.json"),r=await E.Promises.readFile(o),s=[],i=(0,P.$wn)(r.toString(),s);if(s.length)return console.log(`Unable to parse ${o}`),[];if((0,P.$Fn)(i)==="object"&&i.configurations)for(const v of i.configurations){const S=v.type;S&&(a.has(S)?a.set(S,a.get(S)+1):a.set(S,1))}return p(a)}catch{return[]}}let l=class{constructor(a,o){this.c=a,this.d=o}f(a){const o=[];return o.push(`OS Version:       ${a.os}`),o.push(`CPUs:             ${a.cpus}`),o.push(`Memory (System):  ${a.memory}`),o.push(`VM:               ${a.vmHint}`),o.join(`
`)}g(a){const o=[];o.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),o.push(`OS Version:       ${n.type()} ${n.arch()} ${n.release()}`);const r=n.cpus();return r&&r.length>0&&o.push(`CPUs:             ${r[0].model} (${r.length} x ${r[0].speed})`),o.push(`Memory (System):  ${(n.totalmem()/g.$kl.GB).toFixed(2)}GB (${(n.freemem()/g.$kl.GB).toFixed(2)}GB free)`),k.$c||o.push(`Load (avg):       ${n.loadavg().map(s=>Math.round(s)).join(", ")}`),o.push(`VM:               ${Math.round($.$rn.value()*100)}%`),o.push(`Screen Reader:    ${a.screenReader?"yes":"no"}`),o.push(`Process Argv:     ${a.mainArguments.join(" ")}`),o.push(`GPU Status:       ${this.j(a.gpuFeatureStatus)}`),o.join(`
`)}async getPerformanceInfo(a,o){return Promise.all([(0,y.$ns)(a.mainPID),this.k(a)]).then(async r=>{let[s,i]=r,v=this.m(a,s);return o.forEach(S=>{if((0,w.$4m)(S))v+=`
${S.errorMessage}`,i+=`
${S.errorMessage}`;else if(v+=`

Remote: ${S.hostName}`,S.processes&&(v+=`
${this.m(a,S.processes)}`),S.workspaceMetadata){i+=`
|  Remote: ${S.hostName}`;for(const O of Object.keys(S.workspaceMetadata)){const N=S.workspaceMetadata[O];let j=`${N.fileCount} files`;N.maxFilesReached&&(j=`more than ${j}`),i+=`|    Folder (${O}): ${j}`,i+=this.h(N)}}}),{processInfo:v,workspaceInfo:i}})}async getSystemInfo(a,o){const{memory:r,vmHint:s,os:i,cpus:v}=h(),S={os:i,memory:r,cpus:v,vmHint:s,processArgs:`${a.mainArguments.join(" ")}`,gpuStatus:a.gpuFeatureStatus,screenReader:`${a.screenReader?"yes":"no"}`,remoteData:o};return k.$c||(S.load=`${n.loadavg().map(O=>Math.round(O)).join(", ")}`),k.$e&&(S.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(S)}async getDiagnostics(a,o){const r=[];return(0,y.$ns)(a.mainPID).then(async s=>(r.push(""),r.push(this.g(a)),r.push(""),r.push(this.m(a,s)),a.windows.some(i=>i.folderURIs&&i.folderURIs.length>0&&!i.remoteAuthority)&&(r.push(""),r.push("Workspace Stats: "),r.push(await this.k(a))),o.forEach(i=>{if((0,w.$4m)(i))r.push(`
${i.errorMessage}`);else if(r.push(`

`),r.push(`Remote:           ${i.hostName}`),r.push(this.f(i.machineInfo)),i.processes&&r.push(this.m(a,i.processes)),i.workspaceMetadata)for(const v of Object.keys(i.workspaceMetadata)){const S=i.workspaceMetadata[v];let O=`${S.fileCount} files`;S.maxFilesReached&&(O=`more than ${O}`),r.push(`Folder (${v}): ${O}`),r.push(this.h(S))}}),r.push(""),r.push(""),r.join(`
`)))}h(a){const o=[];let s=0;const i=(N,j)=>{const I=` ${N}(${j})`;s+I.length>60?(o.push(v),v="|                 ",s=v.length):s+=I.length,v+=I};let v="|      File types:";const S=10,O=a.fileTypes.length>S?S:a.fileTypes.length;for(let N=0;N<O;N++){const j=a.fileTypes[N];i(j.name,j.count)}if(o.push(v),a.configFiles.length>=0&&(v="|      Conf files:",s=0,a.configFiles.forEach(N=>{i(N.name,N.count)}),o.push(v)),a.launchConfigFiles.length>0){let N="|      Launch Configs:";a.launchConfigFiles.forEach(j=>{const I=j.count>1?` ${j.name}(${j.count})`:` ${j.name}`;N+=I}),o.push(N)}return o.join(`
`)}j(a){const o=Math.max(...Object.keys(a).map(r=>r.length));return Object.keys(a).map(r=>`${r}:  ${" ".repeat(o-r.length)}  ${a[r]}`).join(`
                  `)}k(a){const o=[],r=[];return a.windows.forEach(s=>{s.folderURIs.length===0||s.remoteAuthority||(o.push(`|  Window (${s.title})`),s.folderURIs.forEach(i=>{const v=b.URI.revive(i);if(v.scheme===D.Schemas.file){const S=v.fsPath;r.push(u(S,["node_modules",".git"]).then(O=>{let N=`${O.fileCount} files`;O.maxFilesReached&&(N=`more than ${N}`),o.push(`|    Folder (${(0,C.$oc)(S)}): ${N}`),o.push(this.h(O))}).catch(O=>{o.push(`|      Error: Unable to collect workspace stats for folder ${S} (${O.toString()})`)}))}else o.push(`|    Folder (${v.toString()}): Workspace stats not available.`)}))}),Promise.all(r).then(s=>o.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}m(a,o){const r=new Map;a.windows.forEach(i=>r.set(i.pid,`window [${i.id}] (${i.title})`)),a.pidToNames.forEach(({pid:i,name:v})=>r.set(i,v));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),o&&this.n(a.mainPID,r,s,o,0),s.join(`
`)}n(a,o,r,s,i){const v=i===0;let S;v?S=s.pid===a?`${this.d.applicationName} main`:"remote agent":o.has(s.pid)?S=o.get(s.pid):S=`${"  ".repeat(i)} ${s.name}`;const O=process.platform==="win32"?s.mem:n.totalmem()*(s.mem/100);r.push(`${s.load.toFixed(0).padStart(5," ")}	${(O/g.$kl.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${S}`),Array.isArray(s.children)&&s.children.forEach(N=>this.n(a,o,r,N,i+1))}async getWorkspaceFileExtensions(a){const o=new Set;for(const{uri:r}of a.folders){const s=b.URI.revive(r);if(s.scheme!==D.Schemas.file)continue;const i=s.fsPath;try{(await u(i,["node_modules",".git"])).fileTypes.forEach(S=>o.add(S.name))}catch{}}return{extensions:[...o]}}async reportWorkspaceStats(a){for(const{uri:o}of a.folders){const r=b.URI.revive(o);if(r.scheme!==D.Schemas.file)continue;const s=r.fsPath;try{const i=await u(s,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":a.telemetryId,rendererSessionId:a.rendererSessionId}),i.fileTypes.forEach(v=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:a.rendererSessionId,type:v.name,count:v.count})}),i.launchConfigFiles.forEach(v=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:a.rendererSessionId,type:v.name,count:v.count})}),i.configFiles.forEach(v=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:a.rendererSessionId,type:v.name,count:v.count})})}catch{}}}};e.$rs=l,e.$rs=l=Fe([Ne(0,c.$Nl),Ne(1,d.$8j)],l)}),define(Ee[88],ke([1,0,10,5,13,29]),function(ce,e,n,A,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zp=e.$Yp=void 0,e.$Yp=(0,A.$ii)("IExtensionSignatureVerificationService");let C=class{constructor(b,$){this.b=b,this.c=$}d(){return this.a||(this.a=new Promise((b,$)=>ce(["@vscode/vsce-sign"],async E=>b(E),$))),this.a}async verify(b,$,E){let y;try{y=await this.d()}catch(c){return this.b.error("Could not load vsce-sign module",(0,n.$0)(c)),!1}const w=new Date().getTime();let g,d;try{return g=await y.verify(b,$,E),g}catch(c){throw d=c,c}finally{const c=new Date().getTime()-w;this.c.publicLog2("extensionsignature:verification",{duration:c,verified:g,error:d?d.code??"unknown":void 0})}}};e.$Zp=C,e.$Zp=C=Fe([Ne(0,P.$Oj),Ne(1,D.$Nl)],C)}),define(Ee[39],ke([1,0,21,11,85,121,29]),function(ce,e,n,A,P,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=void 0,e.$_o=E,e.$ap=y,e.$bp=w,e.$cp=g,e.$dp=c,e.$ep=u,e.$fp=p,e.$gp=l;class k{constructor(a){this.value=a,this.isTrustedTelemetryValue=!0}}e.$5o=k;class b{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$6o=b,e.$7o=new b;class ${async publicLog(a,o,r){}async publicLogError(a,o,r){}}e.$8o=$,e.$9o="telemetry",e.$0o="extensionTelemetryLog",e.$$o={log:()=>null,flush:()=>Promise.resolve(null)};function E(t,a){return!a.isBuilt&&!a.disableTelemetry?!0:!(a.disableTelemetry||!t.enableTelemetry)}function y(t,a){return a.extensionTestsLocationURI?!0:!(a.isBuilt||a.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function w(t){const a=t.getValue(C.$Vl),o=t.getValue(C.$Wl);if(t.getValue(C.$Xl)===!1||o===!1)return 0;switch(a??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function g(t){const a={},o={},r={};m(t,r);for(let s in r){s=s.length>150?s.substr(s.length-149):s;const i=r[s];typeof i=="number"?o[s]=i:typeof i=="boolean"?o[s]=i?1:0:typeof i=="string"?(i.length>8192&&console.warn(`Telemetry property: ${s} has been trimmed to 8192, the original length is ${i.length}`),a[s]=i.substring(0,8191)):typeof i<"u"&&i!==null&&(a[s]=i)}return{properties:a,measurements:o}}const d=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function c(t){if(!t)return"none";const a=(0,P.$vm)(t);return d.has(a)?a:"other"}function m(t,a,o=0,r){if(t)for(const s of Object.getOwnPropertyNames(t)){const i=t[s],v=r?r+s:s;Array.isArray(i)?a[v]=(0,n.$Un)(i):i instanceof Date?a[v]=i.toISOString():(0,A.$Xf)(i)?o<2?m(i,a,o+1,v+"."):a[v]=(0,n.$Un)(i):a[v]=i}}function u(t,a){const o=t.msftInternalDomains||[],r=a.getValue("telemetry.internalTesting");return(0,D.$4o)(o)||r}function p(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function h(t,a){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let o=t;const r=[];for(const S of a)for(;;){const O=S.exec(t);if(!O)break;r.push([O.index,S.lastIndex])}const s=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,i=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let v=0;for(o="";;){const S=i.exec(t);if(!S)break;const O=r.some(([N,j])=>S.index<j&&N<i.lastIndex);!s.test(S[0])&&!O&&(o+=t.substring(v,S.index)+"<REDACTED: user-file-path>",v=i.lastIndex)}return v<t.length&&(o+=t.substr(v)),o}function f(t){if(!t)return t;const a=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const o of a)if(o.regex.test(t))return`<REDACTED: ${o.label}>`;return t}function l(t,a){return(0,n.$Rn)(t,o=>{if(o instanceof k||Object.hasOwnProperty.call(o,"isTrustedTelemetryValue"))return o.value;if(typeof o=="string"){let r=o.replaceAll("%20"," ");r=h(r,a);for(const s of a)r=r.replace(s,"");return r=f(r),r}})}}),define(Ee[36],ke([1,0,17,31,35,4,3,10,30,39]),function(ce,e,n,A,P,D,C,k,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qp=e.$ip=void 0,e.$hp=E,e.$jp=d,e.$kp=c,e.$lp=m,e.$mp=u,e.$np=p,e.$op=h,e.$pp=f,e.$rp=l,e.$sp=a;function E(o,r){return o.uuid&&r.uuid?o.uuid===r.uuid:o.id===r.id?!0:(0,n.$gf)(o.id,r.id)===0}const y=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class w{static create(r){const s=r.manifest?r.manifest.version:r.version,i=r.manifest?r.targetPlatform:r.properties.targetPlatform;return new w(r.identifier,s,i)}static parse(r){const s=y.exec(r);return s&&s[1]&&s[2]?new w({id:s[1]},s[2],s[4]||void 0):null}constructor(r,s,i="undefined"){this.version=s,this.targetPlatform=i,this.id=r.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(r){return r instanceof w?E(this,r)&&this.version===r.version&&this.targetPlatform===r.targetPlatform:!1}}e.$ip=w;const g=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function d(o){const r=g.exec(o);return r&&r[1]?[m(r[1]),r[2]]:[m(o),void 0]}function c(o,r){return`${o}.${r}`}function m(o){return o.toLowerCase()}function u(o,r){return m(c(o??P.$Am,r))}function p(o,r){const s=[],i=v=>{for(const S of s)if(S.some(O=>E(r(O),r(v))))return S;return null};for(const v of o){const S=i(v);S?S.push(v):s.push([v])}return s}function h(o){return{id:o.identifier.id,name:o.manifest.name,galleryId:null,publisherId:o.publisherId,publisherName:o.manifest.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:o.manifest.extensionDependencies&&o.manifest.extensionDependencies.length>0}}function f(o){return{id:new $.$5o(o.identifier.id),name:new $.$5o(o.name),galleryId:o.identifier.uuid,publisherId:o.publisherId,publisherName:o.publisher,publisherDisplayName:o.publisherDisplayName,isPreReleaseVersion:o.properties.isPreReleaseVersion,dependencies:!!(o.properties.dependencies&&o.properties.dependencies.length>0),isSigned:o.isSigned,...o.telemetryData}}e.$qp=new P.$Em("pprice.better-merge");function l(o,r){const s=[],i=r.manifest.extensionDependencies?.slice(0)??[];for(;i.length;){const v=i.shift();if(v&&s.every(S=>!E(S.identifier,{id:v}))){const S=o.filter(O=>E(O.identifier,{id:v}));S.length===1&&(s.push(S[0]),i.push(...S[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}async function t(o,r){if(!D.$e)return!1;let s;try{s=(await o.readFile(C.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await o.readFile(C.URI.file("/usr/lib/os-release"))).value.toString()}catch(v){r.debug("Error while getting the os-release file.",(0,k.$0)(v))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function a(o,r){const s=await t(o,r),i=(0,A.$Oo)(s?"alpine":D.$o,b.$fc);return r.debug("ComputeTargetPlatform:",i),i}}),define(Ee[122],ke([1,0,20,10,12,19,56,3,187,31,36,35]),function(ce,e,n,A,P,D,C,k,b,$,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1p=void 0;const w=c=>(0,b.localize)(0,null,c),g=(0,b.localize)(1,null,"ms-dotnettools.csharp");let d=class{constructor(m,u,p){this.a=m,this.b=u,this.d=p}get f(){}async listExtensions(m,u,p){let h=await this.b.getInstalled(1,p);const f=y.$Dm.map(t=>t.toLowerCase());if(u&&u!==""){if(f.indexOf(u.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}h=h.filter(t=>t.manifest.categories?t.manifest.categories.map(o=>o.toLowerCase()).indexOf(u.toLowerCase())>-1:!1)}else if(u===""){this.a.info("Possible Categories: "),f.forEach(t=>{this.a.info(t)});return}this.f&&this.a.info((0,b.localize)(2,null,this.f)),h=h.sort((t,a)=>t.identifier.id.localeCompare(a.identifier.id));let l;for(const t of h)l!==t.identifier.id&&(l=t.identifier.id,this.a.info(m?`${l}@${t.manifest.version}`:l))}async installExtensions(m,u,p,h){const f=[];try{m.length&&this.a.info(this.f?(0,b.localize)(3,null,this.f):(0,b.localize)(4,null));const l=[],t=[],a=(r,s,i)=>{t.push({id:r,version:s!=="prerelease"?s:void 0,installOptions:{...p,isBuiltin:i,installPreReleaseVersion:s==="prerelease"||p.installPreReleaseVersion}})};for(const r of m)if(r instanceof k.URI)l.push({vsix:r,installOptions:p});else{const[s,i]=(0,E.$jp)(r);a(s,i,!1)}for(const r of u)if(r instanceof k.URI)l.push({vsix:r,installOptions:{...p,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[s,i]=(0,E.$jp)(r);a(s,i,!0)}const o=await this.b.getInstalled(1,p.profileLocation);if(l.length&&await Promise.all(l.map(async({vsix:r,installOptions:s})=>{try{await this.h(r,s,h,o)}catch(i){this.a.error(i),f.push(r.toString())}})),t.length){const r=await this.g(t,o,h);f.push(...r)}}catch(l){throw this.a.error((0,b.localize)(5,null,(0,A.$0)(l))),l}if(f.length)throw new Error((0,b.localize)(6,null,f.join(", ")))}async updateExtensions(m){const u=await this.b.getInstalled(1,m),p=[];for(const t of u)t.identifier.uuid&&p.push({...t.identifier,preRelease:t.preRelease});this.a.trace((0,b.localize)(7,null,p.length));const h=await this.d.getExtensions(p,{compatible:!0},n.CancellationToken.None),f=[];for(const t of h)for(const a of u)(0,E.$hp)(a.identifier,t.identifier)&&(0,C.gt)(t.version,a.manifest.version)&&f.push({extension:t,options:{operation:3,installPreReleaseVersion:a.isPreReleaseVersion}});if(!f.length){this.a.info((0,b.localize)(8,null));return}this.a.info((0,b.localize)(9,null,f.map(t=>t.extension.identifier.id).join(", ")));const l=await this.b.installGalleryExtensions(f);for(const t of l)t.error?this.a.error((0,b.localize)(10,null,t.identifier.id,(0,A.$0)(t.error))):this.a.info((0,b.localize)(11,null,t.identifier.id,t.local?.manifest.version))}async g(m,u,p){if(m=m.filter(({id:t,version:a})=>{const o=u.find(r=>(0,E.$hp)(r.identifier,{id:t}));if(o){if(!p&&(!a||a==="prerelease"&&o.preRelease))return this.a.info((0,b.localize)(12,null,t,o.manifest.version,t)),!1;if(a&&o.manifest.version===a)return this.a.info((0,b.localize)(13,null,`${t}@${a}`)),!1}return!0}),!m.length)return[];const h=[],f=[],l=await this.j(m);if(await Promise.all(m.map(async({id:t,version:a,installOptions:o})=>{const r=l.get(t.toLowerCase());if(!r){this.a.error(`${w(a?`${t}@${a}`:t)}
${g}`),h.push(t);return}try{const i=await this.d.getManifest(r,n.CancellationToken.None);if(i&&!this.k(i))return}catch(i){this.a.error(i.message||i.stack||i),h.push(t);return}const s=u.find(i=>(0,E.$hp)(i.identifier,r.identifier));if(s){if(r.version===s.manifest.version){this.a.info((0,b.localize)(14,null,a?`${t}@${a}`:t));return}this.a.info((0,b.localize)(15,null,t,r.version))}o.isBuiltin?this.a.info(a?(0,b.localize)(16,null,t,a):(0,b.localize)(17,null,t)):this.a.info(a?(0,b.localize)(18,null,t,a):(0,b.localize)(19,null,t)),f.push({extension:r,options:{...o,installGivenVersion:!!a}})})),f.length){const t=await this.b.installGalleryExtensions(f);for(const a of t)a.error?(this.a.error((0,b.localize)(20,null,a.identifier.id,(0,A.$0)(a.error))),h.push(a.identifier.id)):this.a.info((0,b.localize)(21,null,a.identifier.id,a.local?.manifest.version))}return h}async h(m,u,p,h){const f=await this.b.getManifest(m);if(!f)throw new Error("Invalid vsix");if(await this.l(f,p,u.profileLocation,h))try{await this.b.install(m,u),this.a.info((0,b.localize)(22,null,(0,D.$Sg)(m)))}catch(t){if((0,A.$4)(t))this.a.info((0,b.localize)(23,null,(0,D.$Sg)(m)));else throw t}}async j(m){const u=new Map,p=m.some(l=>l.installOptions.installPreReleaseVersion),h=await this.b.getTargetPlatform(),f=[];for(const l of m)$.$Ho.test(l.id)&&f.push({...l,preRelease:p});if(f.length){const l=await this.d.getExtensions(f,{targetPlatform:h},n.CancellationToken.None);for(const t of l)u.set(t.identifier.id.toLowerCase(),t)}return u}k(m){return!0}async l(m,u,p,h){if(!u){const f={id:(0,E.$mp)(m.publisher,m.name)},l=h.find(t=>(0,E.$hp)(f,t.identifier)&&(0,C.gt)(t.manifest.version,m.version));if(l)return this.a.info((0,b.localize)(24,null,l.identifier.id,l.manifest.version,m.version)),!1}return this.k(m)}async uninstallExtensions(m,u,p){const h=async l=>{if(l instanceof k.URI){const t=await this.b.getManifest(l);return(0,E.$kp)(t.publisher,t.name)}return l},f=[];for(const l of m){const t=await h(l),o=(await this.b.getInstalled(void 0,p)).filter(r=>(0,E.$hp)(r.identifier,{id:t}));if(!o.length)throw new Error(`${this.m(t)}
${g}`);if(o.some(r=>r.type===0)){this.a.info((0,b.localize)(25,null,t));return}if(!u&&o.some(r=>r.isBuiltin)){this.a.info((0,b.localize)(26,null,t));return}this.a.info((0,b.localize)(27,null,t));for(const r of o)await this.b.uninstall(r,{profileLocation:p}),f.push(r);this.f?this.a.info((0,b.localize)(28,null,t,this.f)):this.a.info((0,b.localize)(29,null,t))}}async locateExtension(m){const u=await this.b.getInstalled();m.forEach(p=>{u.forEach(h=>{if(h.identifier.id===p&&h.location.scheme===P.Schemas.file){this.a.info(h.location.fsPath);return}})})}m(m){return this.f?(0,b.localize)(30,null,m,this.f):(0,b.localize)(31,null,m)}};e.$1p=d,e.$1p=d=Fe([Ne(1,$.$Vo),Ne(2,$.$So)],d)}),define(Ee[250],ke([1,0,15,10,2,12,19,56,11,22,23,80,25,26,31,36,88,16,13]),function(ce,e,n,A,P,D,C,k,b,$,E,y,w,g,d,c,m,u,p){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=void 0;let f=h=class extends P.$Uc{constructor(t,a,o,r,s,i){super(),this.h=a,this.j=o,this.m=r,this.n=s,this.r=i,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(t,a,o){await this.g;const r=(0,C.$Vg)(this.extensionsDownloadDir,this.z(t));try{await this.w(t,r,i=>this.j.download(t,i,a))}catch(i){throw new d.$To(i.message,d.ExtensionManagementErrorCode.Download)}let s=!1;if(o&&this.t(t)){const i=await this.u(t);try{s=await this.n.verify(r.fsPath,i.fsPath,this.r.getLevel()===p.LogLevel.Trace)}catch(v){const S=v;if(s=S.code,S.output&&this.r.trace(`Extension signature verification details for ${t.identifier.id} ${t.version}:
${S.output}`),s===d.ExtensionSignaturetErrorCode.PackageIsInvalidZip||s===d.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip){try{await this.delete(r)}catch(O){this.r.error(O)}throw new d.$To(y.$5p,d.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(i)}catch(v){this.r.error(v)}}}return s===!0?this.r.info(`Extension signature is verified: ${t.identifier.id}`):s===!1?this.r.info(`Extension signature verification is not done: ${t.identifier.id}`):this.r.warn(`Extension signature verification failed with error '${s}': ${t.identifier.id}`),{location:r,verificationStatus:s}}t(t){if(!t.isSigned)return this.r.info(`Extension is not signed: ${t.identifier.id}`),!1;const a=this.m.getValue("extensions.verifySignature");return(0,b.$2f)(a)?a:!0}async u(t){await this.g;const a=(0,C.$Vg)(this.extensionsDownloadDir,`${this.z(t)}${h.c}`);try{await this.w(t,a,o=>this.j.downloadSignatureArchive(t,o))}catch(o){throw new d.$To(o.message,d.ExtensionManagementErrorCode.DownloadSignature)}return a}async w(t,a,o){if(await this.h.exists(a))return;if(a.scheme!==D.Schemas.file){await o(a);return}const r=(0,C.$Vg)(this.extensionsDownloadDir,`.${(0,$.$Eg)()}`);await this.h.exists(r)||await o(r);try{await E.Promises.rename(r.fsPath,a.fsPath,2*60*1e3)}catch(s){try{await this.h.del(r)}catch{}if(s.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,a.path);else throw this.r.info(`Rename failed because of ${(0,A.$0)(s)}. Deleted the file from downloaded location`,r.path),s}}async delete(t){await this.g,await this.h.del(t)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const a=[],o=[],r=[];for(const v of t.children)if(v.name.endsWith(h.c))r.push(v.resource);else{const S=c.$ip.parse(v.name);S&&o.push([S,v])}const s=(0,c.$np)(o,([v])=>v),i=[];for(const v of s)v.sort((S,O)=>k.rcompare(S[0].version,O[0].version)),a.push(...v.slice(1).map(S=>S[1].resource)),i.push(v[0][1]);i.sort((v,S)=>v.mtime-S.mtime),a.push(...i.slice(0,Math.max(0,i.length-this.f)).map(v=>v.resource)),a.push(...r),await n.Promises.settled(a.map(v=>(this.r.trace("Deleting from cache",v.path),this.h.del(v))))}}catch(t){this.r.error(t)}}z(t){return this.f?c.$ip.create(t).toString().toLowerCase():(0,$.$Eg)()}};e.$lq=f,f.c=".sigzip",e.$lq=f=h=Fe([Ne(0,g.$qi),Ne(1,u.$Ok),Ne(2,d.$So),Ne(3,w.$Oi),Ne(4,m.$Yp),Ne(5,p.$Oj)],f)}),define(Ee[251],ke([1,0,6,2,24,36,35]),function(ce,e,n,A,P,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pq=void 0;class k extends A.$Uc{constructor($,E,y,w,g,d,c){super(),this.f=$,this.g=E,this.h=y,this.j=w,this.m=g,this.n=d,this.r=c,this.a=this.B(new n.$7d),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new A.$4c),this.s().then(null,m=>c.error(m))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles($=>this.u($.added))),this.B(this.j.onAddExtensions($=>this.w($))),this.B(this.j.onDidAddExtensions($=>this.y($))),this.B(this.j.onRemoveExtensions($=>this.z($))),this.B(this.j.onDidRemoveExtensions($=>this.C($))),this.B(this.n.onDidFilesChange($=>this.D($)))}async u($){try{$.length&&await Promise.all($.map(E=>(this.c.set(E.id,(0,A.$Rc)(this.n.watch(this.m.extUri.dirname(E.extensionsResource)),this.n.watch(E.extensionsResource))),this.G(E.extensionsResource))))}catch(E){throw this.r.error(E),E}}async w($){for(const E of $.extensions)this.I(this.L(E.identifier,E.version),$.profileLocation)}async y($){for(const E of $.extensions){const y=this.L(E.identifier,E.version);$.error?this.J(y,$.profileLocation):this.I(y,$.profileLocation)}}async z($){for(const E of $.extensions)this.J(this.L(E.identifier,E.version),$.profileLocation)}async C($){const E=[],y=[];for(const w of $.extensions){const g=this.L(w.identifier,w.version);$.error?this.I(g,$.profileLocation):(this.J(g,$.profileLocation),this.b.has(g)||(this.r.debug("Extension is removed from all profiles",w.identifier.id,w.version),y.push(this.f.scanInstalledExtensionAtLocation(w.location).then(d=>{d?E.push(d):this.r.info("Extension not found at the location",w.location.toString())},d=>this.r.error(d)))))}try{await Promise.all(y),E.length&&await this.H(E)}catch(w){this.r.error(w)}}D($){for(const E of this.h.profiles)$.contains(E.extensionsResource,0,1)&&this.F(E.extensionsResource)}async F($){const E=[],y=[],w=await this.j.scanProfileExtensions($),g=new Set,d=new Set;for(const[c,m]of this.b)m.has($)&&d.add(c);for(const c of w){const m=this.L(c.identifier,c.version);g.add(m),d.has(m)||(E.push(c.identifier),this.I(m,$))}for(const c of d)if(!g.has(c)){const m=this.M(c);m&&(y.push(m.identifier),this.J(c,$))}(E.length||y.length)&&this.a.fire({added:E.length?{extensions:E,profileLocation:$}:void 0,removed:y.length?{extensions:y,profileLocation:$}:void 0})}async G($){const E=await this.j.scanProfileExtensions($);for(const y of E)this.I(this.L(y.identifier,y.version),$)}async H($){$||($=(await this.f.scanAllUserInstalledExtensions()).filter(y=>!this.b.has(this.L(y.identifier,y.manifest.version)))),$.length&&await this.f.markAsUninstalled(...$)}I($,E){let y=this.b.get($);y||this.b.set($,y=new P.$Cc(w=>this.m.extUri.getComparisonKey(w))),y.add(E)}J($,E){const y=this.b.get($);y&&y.delete(E),y?.size||this.b.delete($)}L($,E){return`${C.$Em.toKey($.id)}@${E}`}M($){const[E,y]=(0,D.$jp)($);return y?{identifier:{id:E},version:y}:void 0}}e.$pq=k}),define(Ee[252],ke([1,0,222,39]),function(ce,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Up=P;async function P(D,C,k,b,$,E,y){const w={"X-Market-Client-Id":`VSCode ${D}`,"User-Agent":`VSCode ${D} (${C.nameShort})`};if((0,A.$_o)(C,k)&&(0,A.$bp)(b)===3){const g=await(0,n.$Tp)(k,$,E);w["X-Market-User-Id"]=g,w["VSCode-SessionId"]=y.machineId||g}return w}}),define(Ee[123],ke([1,0,89,18,15,2,12,7,23,26,31,36,13,84,3]),function(ce,e,n,A,P,D,C,k,b,$,E,y,w,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Er=void 0;let c=class extends g.$Dr{constructor(h,f,l,t){super(l),this.h=h,this.j=t,this.g=this.B(new m(f,t)),this.h.registerParticipant({postInstall:async a=>this.m(a),postUninstall:async a=>this.n(a)})}async getBuiltInExtensionTranslationsUri(h,f){const t=(await this.g.getLanguagePacks())[f];if(!t){this.j.warn(`No language pack found for ${f}`);return}const a=t.translations[h];return a?d.URI.file(a):void 0}async getInstalledLanguages(){const h=await this.g.getLanguagePacks(),f=Object.keys(h).map(l=>{const t=h[l];return{...this.f(l,t.label),extensionId:t.extensions[0].extensionIdentifier.id}});return f.push(this.f("en","English")),f.sort((l,t)=>l.label.localeCompare(t.label)),f}async m(h){h&&h.manifest&&h.manifest.contributes&&h.manifest.contributes.localizations&&h.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",h.identifier.id),await this.update())}async n(h){const f=await this.g.getLanguagePacks();Object.keys(f).some(l=>f[l]&&f[l].extensions.some(t=>(0,y.$hp)(t.extensionIdentifier,h.identifier)))&&(this.j.info("Removing language packs from the extension",h.identifier.id),await this.update())}async update(){const[h,f]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),l=await this.g.update(f);return!(0,A.$ub)(Object.keys(h),Object.keys(l))}};e.$Er=c,e.$Er=c=Fe([Ne(0,E.$Vo),Ne(1,$.$qi),Ne(2,E.$So),Ne(3,w.$Oj)],c);let m=class extends D.$Uc{constructor(h,f){super(),this.j=f,this.c={},this.f=(0,k.$kc)(h.userDataPath,"languagepacks.json"),this.g=new P.$ph}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(h){return this.s(f=>{Object.keys(f).forEach(l=>delete f[l]),this.m(f,...h)}).then(()=>this.c)}m(h,...f){for(const l of f)l&&l.manifest&&l.manifest.contributes&&l.manifest.contributes.localizations&&l.manifest.contributes.localizations.length&&this.n(h,l);Object.keys(h).forEach(l=>this.r(h[l]))}n(h,f){const l=f.identifier,t=f.manifest.contributes&&f.manifest.contributes.localizations?f.manifest.contributes.localizations:[];for(const a of t)if(f.location.scheme===C.Schemas.file&&u(a)){let o=h[a.languageId];o||(o={hash:"",extensions:[],translations:{},label:a.localizedLanguageName??a.languageName},h[a.languageId]=o);const r=o.extensions.filter(s=>(0,y.$hp)(s.extensionIdentifier,l))[0];r?r.version=f.manifest.version:o.extensions.push({extensionIdentifier:l,version:f.manifest.version});for(const s of a.translations)o.translations[s.id]=(0,k.$kc)(f.location.fsPath,s.path)}}r(h){if(h){const f=(0,n.createHash)("md5");for(const l of h.extensions)f.update(l.extensionIdentifier.uuid||l.extensionIdentifier.id).update(l.version);h.hash=f.digest("hex")}}s(h=()=>null){return this.g.queue(()=>{let f=null;return b.Promises.readFile(this.f,"utf8").then(void 0,l=>l.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(l)).then(l=>{try{return JSON.parse(l)}catch{return{}}}).then(l=>(f=h(l),l)).then(l=>{for(const a of Object.keys(l))l[a]||delete l[a];this.c=l,this.h=!0;const t=JSON.stringify(this.c);return this.j.debug("Writing language packs",t),b.Promises.writeFile(this.f,t)}).then(()=>f,l=>this.j.error(l))})}};m=Fe([Ne(0,$.$qi),Ne(1,w.$Oj)],m);function u(p){if(typeof p.languageId!="string"||!Array.isArray(p.translations)||p.translations.length===0)return!1;for(const h of p.translations)if(typeof h.id!="string"||typeof h.path!="string")return!1;return!(p.languageName&&typeof p.languageName!="string"||p.localizedLanguageName&&typeof p.localizedLanguageName!="string")}}),define(Ee[253],ke([1,0,159,10,21,39]),function(ce,e,n,A,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1P=void 0;const C="https://mobile.events.data.microsoft.com/OneCollector/1.0",k="https://mobile.events.data.microsoft.com/ping";async function b(E,y,w){const g=await(0,n.$KD)("@microsoft/1ds-core-js","dist/ms.core.js"),d=await(0,n.$KD)("@microsoft/1ds-post-js","dist/ms.post.js"),c=new g.AppInsightsCore,m=new d.PostChannel,u={instrumentationKey:E,endpointUrl:C,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[m]]};if(w){u.extensionConfig={};const p={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:w};u.extensionConfig[m.identifier]=p}return c.initialize(u,[]),c.addTelemetryInitializer(p=>{p.ext=p.ext??{},p.ext.web=p.ext.web??{},p.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',y&&(p.ext.utc=p.ext.utc??{},p.ext.utc.flags=8462029)}),c}class ${constructor(y,w,g,d,c){this.e=y,this.f=w,this.g=g,this.h=c,this.c=C,this.d=k,this.g||(this.g={}),typeof d=="function"?this.a=d():this.a=d,this.b=null}i(y){if(this.a){if(typeof this.a!="string"){y(this.a);return}this.b||(this.b=b(this.a,this.e,this.h)),this.b.then(w=>{y(w)},w=>{(0,A.$1)(w),console.error(w)})}}log(y,w){if(!this.a)return;w=(0,P.$Sn)(w,this.g),w=(0,D.$cp)(w);const g=this.f+"/"+y;try{this.i(d=>{d.pluginVersionString=w?.properties.version??"Unknown",d.track({name:g,baseData:{name:g,properties:w?.properties,measurements:w?.measurements}})})}catch{}}flush(){return this.a?new Promise(y=>{this.i(w=>{w.unload(!0,()=>{this.a=void 0,y(void 0)})})}):Promise.resolve(void 0)}}e.$1P=$}),define(Ee[254],ke([1,0,2,21,4,17,202,25,47,58,32,38,29,39]),function(ce,e,n,A,P,D,C,k,b,$,E,y,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kr=void 0;let d=class{constructor(u,p,h){this.k=p,this.l=h,this.d={},this.i=new n.$Tc,this.j=[],this.b=u.appenders,this.c=u.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=u.piiPaths||[],this.g=3,this.h=!!u.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const f of this.f)this.j.push(new RegExp((0,D.$Ze)(f),"gi")),f.indexOf("\\")>=0&&this.j.push(new RegExp((0,D.$Ze)(f.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(f=>{(f.affectsConfiguration(w.$Vl)||f.affectsConfiguration(w.$Xl)||f.affectsConfiguration(w.$Wl))&&this.m()}))}setExperimentProperty(u,p){this.d[u]=p}m(){let u=(0,g.$bp)(this.k);const p=this.l.enabledTelemetryLevels;if(p){this.h=this.sendErrorTelemetry?p.error:!1;const h=p.usage?3:p.error?2:0;u=Math.min(u,h)}this.g=u}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(u,p,h){this.g<p||(h=(0,A.$Sn)(h,this.d),h=(0,g.$gp)(h,this.j),h=(0,A.$Sn)(h,this.c),this.b.forEach(f=>f.log(u,h)))}publicLog(u,p){this.n(u,3,p)}publicLog2(u,p){this.publicLog(u,p)}publicLogError(u,p){this.h&&this.n(u,2,p)}publicLogError2(u,p){this.publicLogError(u,p)}};e.$Kr=d,d.IDLE_START_EVENT_NAME="UserIdleStart",d.IDLE_STOP_EVENT_NAME="UserIdleStop",e.$Kr=d=Fe([Ne(1,k.$Oi),Ne(2,E.$8j)],d);function c(){const m=(0,C.localize)(0,null,$.default.nameLong),u=$.default.privacyStatementUrl?(0,C.localize)(2,null,"https://aka.ms/vscode-telemetry",$.default.privacyStatementUrl):(0,C.localize)(1,null,"https://aka.ms/vscode-telemetry"),p=P.$i?"":(0,C.localize)(3,null),h=(0,C.localize)(4,null),f=(0,C.localize)(5,null),l=(0,C.localize)(6,null),t=(0,C.localize)(7,null),a=`
|       | ${h} | ${f} | ${l} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,o=(0,C.localize)(8,null);return`
${m} ${u} ${p}

&nbsp;

${t}
${a}

&nbsp;

${o}
`}y.$2n.as(b.$7n.Configuration).registerConfiguration({id:w.$Ul,order:1,type:"object",title:(0,C.localize)(9,null),properties:{[w.$Vl]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,C.localize)(10,null),(0,C.localize)(11,null),(0,C.localize)(12,null),(0,C.localize)(13,null)],markdownDescription:c(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),y.$2n.as(b.$7n.Configuration).registerConfiguration({id:w.$Ul,order:110,type:"object",title:(0,C.localize)(14,null),properties:{[w.$Xl]:{type:"boolean",markdownDescription:$.default.privacyStatementUrl?(0,C.localize)(16,null,$.default.nameLong,$.default.privacyStatementUrl):(0,C.localize)(15,null,$.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,C.localize)(17,null,`\`#${w.$Vl}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Ee[255],ke([1,0,25,5,32,29,254,39]),function(ce,e,n,A,P,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ys=e.$xs=e.$ws=void 0;let b=class extends C.$Kr{constructor(E,y,w,g){super(E,w,g),this.o=y}publicLog(E,y){if(!(this.o<3))return super.publicLog(E,y)}publicLog2(E,y){return this.publicLog(E,y)}publicLogError(E,y){return this.o<2?Promise.resolve(void 0):super.publicLogError(E,y)}publicLogError2(E,y){return this.publicLogError(E,y)}async updateInjectedTelemetryLevel(E){if(E===void 0)throw this.o=0,new Error("Telemetry level cannot be undefined. This will cause infinite looping!");this.o=this.o?Math.min(this.o,E):E,this.o===0&&this.dispose()}};e.$ws=b,e.$ws=b=Fe([Ne(2,n.$Oi),Ne(3,P.$8j)],b),e.$xs=new class extends k.$6o{async updateInjectedTelemetryLevel(){}},e.$ys=(0,A.$ji)(D.$Nl)}),define(Ee[256],ke([1,0,14,20,257,253]),function(ce,e,n,A,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2P=void 0;async function C(E,y){const w=await y.request(E,A.CancellationToken.None),g=(await(0,n.$Ge)(w.stream)).toString(),d=w.res.statusCode??200;return{headers:w.res.headers,statusCode:d,responseData:g}}async function k(E){const y={method:E.type,headers:E.headers};return new Promise((g,d)=>{const c=P.request(E.url??"",y,m=>{m.on("data",function(u){g({headers:m.headers,statusCode:m.statusCode??200,responseData:u.toString()})}),m.on("error",function(u){d(u)})});c.write(E.data,m=>{m&&d(m)}),c.end()})}async function b(E,y,w){const g=typeof y.data=="string"?y.data:new TextDecoder().decode(y.data),d={type:"POST",headers:{...y.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(y.data).toString()},url:y.urlString,data:g};try{const c=E?await C(d,E):await k(d);w(c.statusCode,c.headers,c.responseData)}catch{w(0,{})}}class $ extends D.$1P{constructor(y,w,g,d,c){const m={sendPOST:(u,p)=>{b(y,u,p)}};super(w,g,d,c,m)}}e.$2P=$}),define(Ee[258],ke([1,0,10,247]),function(ce,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class P extends A.default{i(){(0,n.setUnexpectedErrorHandler)(k=>console.error(k));const C=[];process.on("unhandledRejection",(k,b)=>{C.push(b),setTimeout(()=>{const $=C.indexOf(b);$>=0&&b.catch(E=>{C.splice($,1),(0,n.$4)(E)||(console.warn(`rejected promise not handled within 1 second: ${E}`),E.stack&&console.warn(`stack trace: ${E.stack}`),k&&(0,n.$1)(k))})},1e3)}),process.on("rejectionHandled",k=>{const b=C.indexOf(k);b>=0&&C.splice(b,1)}),process.on("uncaughtException",k=>{(0,n.$Z)(k)||(0,n.$1)(k)})}}e.default=P}),define(Ee[124],ke([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var n;(function(A){A[A.Replace=1]="Replace",A[A.Append=2]="Append",A[A.Prepend=3]="Prepend"})(n||(e.EnvironmentVariableMutatorType=n={}))}),define(Ee[125],ke([1,0,4,124]),function(ce,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bs=void 0;const P=new Map([[A.EnvironmentVariableMutatorType.Append,"APPEND"],[A.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[A.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class D{constructor(E){this.collections=E,this.a=new Map,this.b=new Map,E.forEach((y,w)=>{this.d(y,w);const g=y.map.entries();let d=g.next();for(;!d.done;){const c=d.value[1],m=d.value[0];let u=this.a.get(m);if(u||(u=[],this.a.set(m,u)),u.length>0&&u[0].type===A.EnvironmentVariableMutatorType.Replace){d=g.next();continue}const p={extensionIdentifier:w,value:c.value,type:c.type,scope:c.scope,variable:c.variable,options:c.options};p.scope||delete p.scope,u.unshift(p),d=g.next()}})}async applyToProcessEnvironment(E,y,w){let g;n.$c&&(g={},Object.keys(E).forEach(d=>g[d.toLowerCase()]=d));for(const[d,c]of this.getVariableMap(y)){const m=n.$c&&g[d.toLowerCase()]||d;for(const u of c){const p=w?await w(u.value):u.value;if(u.options?.applyAtProcessCreation??!0)switch(u.type){case A.EnvironmentVariableMutatorType.Append:E[m]=(E[m]||"")+p;break;case A.EnvironmentVariableMutatorType.Prepend:E[m]=p+(E[m]||"");break;case A.EnvironmentVariableMutatorType.Replace:E[m]=p;break}if(u.options?.applyAtShellIntegration??!1){const h=`VSCODE_ENV_${P.get(u.type)}`;E[h]=(E[h]?E[h]+":":"")+d+"="+this.c(p)}}}}c(E){return E.replaceAll(":","\\x3a")}diff(E,y){const w=new Map,g=new Map,d=new Map;if(E.getVariableMap(y).forEach((c,m)=>{const u=this.getVariableMap(y).get(m),p=k(c,u);p&&w.set(m,p)}),this.getVariableMap(y).forEach((c,m)=>{const u=E.getVariableMap(y).get(m),p=k(c,u);p&&d.set(m,p)}),this.getVariableMap(y).forEach((c,m)=>{const u=E.getVariableMap(y).get(m),p=b(c,u);p&&g.set(m,p)}),!(w.size===0&&g.size===0&&d.size===0))return{added:w,changed:g,removed:d}}getVariableMap(E){const y=new Map;for(const w of this.a.values()){const g=w.filter(d=>C(d,E));g.length>0&&y.set(g[0].variable,g)}return y}getDescriptionMap(E){const y=new Map;for(const w of this.b.values()){const g=w.filter(d=>C(d,E,!0));for(const d of g)y.set(d.extensionIdentifier,d.description)}return y}d(E,y){if(!E.descriptionMap)return;const w=E.descriptionMap.entries();let g=w.next();for(;!g.done;){const d=g.value[1],c=g.value[0];let m=this.b.get(c);m||(m=[],this.b.set(c,m));const u={extensionIdentifier:y,scope:d.scope,description:d.description};u.scope||delete u.scope,m.push(u),g=w.next()}}}e.$bs=D;function C($,E,y=!1){return $.scope?!!($.scope.workspaceFolder&&E?.workspaceFolder&&$.scope.workspaceFolder.index===E.workspaceFolder.index):y?E===$.scope:!0}function k($,E){if(!E)return $;const y=new Set;E.forEach(g=>y.add(g.extensionIdentifier));const w=[];return $.forEach(g=>{y.has(g.extensionIdentifier)||w.push(g)}),w.length===0?void 0:w}function b($,E){if(!E)return;const y=new Map;E.forEach(g=>y.set(g.extensionIdentifier,g));const w=[];return $.forEach(g=>{const d=y.get(g.extensionIdentifier);d&&(g.type!==d.type||g.value!==d.value||g.scope?.workspaceFolder?.index!==d.scope?.workspaceFolder?.index)&&w.push(d)}),w.length===0?void 0:w}}),define(Ee[90],ke([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8r=n,e.$9r=A,e.$0r=P,e.$$r=D,e.$_r=C,e.$as=k;function n(b){return[...b.entries()]}function A(b){return b?[...b.entries()]:[]}function P(b){return new Map(b)}function D(b){return new Map(b??[])}function C(b){return Array.from(b.entries()).map($=>[$[0],n($[1].map),A($[1].descriptionMap)])}function k(b){return new Map(b.map($=>[$[0],{map:P($[1]),descriptionMap:D($[2])}]))}}),define(Ee[259],ke([1,0,15,20,6,2,13]),function(ce,e,n,A,P,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yr=void 0;let k=class extends D.$Uc{constructor($,E){super(),this.h=E,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new P.$7d),this.onCreateRequest=this.g.event,this.b=$===void 0?15e3:$,this.B((0,D.$Sc)(()=>{for(const y of this.f.values())(0,D.$Pc)(y)}))}createRequest($){return new Promise((E,y)=>{const w=++this.a;this.c.set(w,E),this.g.fire({requestId:w,...$});const g=new A.$ee;(0,n.$jh)(this.b,g.token).then(()=>y(`Request ${w} timed out (${this.b}ms)`)),this.f.set(w,[(0,D.$Sc)(()=>g.cancel())])})}acceptReply($,E){const y=this.c.get($);y?(this.c.delete($),(0,D.$Pc)(this.f.get($)||[]),this.f.delete($),y(E)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${$}`)}};e.$Yr=k,e.$Yr=k=Fe([Ne(1,C.$Oj)],k)}),define(Ee[91],ke([1,0,5,57,38]),function(ce,e,n,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ur=e.$Tr=e.$Sr=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$Rr=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$Qr=void 0,e.$Qr=new A.$zj("terminalTabFocusMode",!1,!0);var D;(function(l){l.AutomationProfile="terminal.integrated.automationProfile.",l.DefaultProfile="terminal.integrated.defaultProfile.",l.Profiles="terminal.integrated.profiles."})(D||(e.TerminalSettingPrefix=D={}));var C;(function(l){l.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",l.AutomationProfileLinux="terminal.integrated.automationProfile.linux",l.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",l.AutomationProfileWindows="terminal.integrated.automationProfile.windows",l.ProfilesWindows="terminal.integrated.profiles.windows",l.ProfilesMacOs="terminal.integrated.profiles.osx",l.ProfilesLinux="terminal.integrated.profiles.linux",l.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",l.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",l.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",l.UseWslProfiles="terminal.integrated.useWslProfiles",l.TabsDefaultColor="terminal.integrated.tabs.defaultColor",l.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",l.TabsEnabled="terminal.integrated.tabs.enabled",l.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",l.TabsHideCondition="terminal.integrated.tabs.hideCondition",l.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",l.TabsShowActions="terminal.integrated.tabs.showActions",l.TabsLocation="terminal.integrated.tabs.location",l.TabsFocusMode="terminal.integrated.tabs.focusMode",l.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",l.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",l.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",l.CopyOnSelection="terminal.integrated.copyOnSelection",l.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",l.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",l.FontFamily="terminal.integrated.fontFamily",l.FontSize="terminal.integrated.fontSize",l.LetterSpacing="terminal.integrated.letterSpacing",l.LineHeight="terminal.integrated.lineHeight",l.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",l.TabStopWidth="terminal.integrated.tabStopWidth",l.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",l.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",l.BellDuration="terminal.integrated.bellDuration",l.FontWeight="terminal.integrated.fontWeight",l.FontWeightBold="terminal.integrated.fontWeightBold",l.CursorBlinking="terminal.integrated.cursorBlinking",l.CursorStyle="terminal.integrated.cursorStyle",l.CursorStyleInactive="terminal.integrated.cursorStyleInactive",l.CursorWidth="terminal.integrated.cursorWidth",l.Scrollback="terminal.integrated.scrollback",l.DetectLocale="terminal.integrated.detectLocale",l.DefaultLocation="terminal.integrated.defaultLocation",l.GpuAcceleration="terminal.integrated.gpuAcceleration",l.TerminalTitleSeparator="terminal.integrated.tabs.separator",l.TerminalTitle="terminal.integrated.tabs.title",l.TerminalDescription="terminal.integrated.tabs.description",l.RightClickBehavior="terminal.integrated.rightClickBehavior",l.Cwd="terminal.integrated.cwd",l.ConfirmOnExit="terminal.integrated.confirmOnExit",l.ConfirmOnKill="terminal.integrated.confirmOnKill",l.EnableBell="terminal.integrated.enableBell",l.EnableVisualBell="terminal.integrated.enableVisualBell",l.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",l.AllowChords="terminal.integrated.allowChords",l.AllowMnemonics="terminal.integrated.allowMnemonics",l.TabFocusMode="terminal.integrated.tabFocusMode",l.EnvMacOs="terminal.integrated.env.osx",l.EnvLinux="terminal.integrated.env.linux",l.EnvWindows="terminal.integrated.env.windows",l.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",l.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",l.ShowExitAlert="terminal.integrated.showExitAlert",l.SplitCwd="terminal.integrated.splitCwd",l.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",l.WordSeparators="terminal.integrated.wordSeparators",l.EnableFileLinks="terminal.integrated.enableFileLinks",l.UnicodeVersion="terminal.integrated.unicodeVersion",l.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",l.LocalEchoEnabled="terminal.integrated.localEchoEnabled",l.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",l.LocalEchoStyle="terminal.integrated.localEchoStyle",l.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",l.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",l.HideOnStartup="terminal.integrated.hideOnStartup",l.CustomGlyphs="terminal.integrated.customGlyphs",l.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",l.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",l.InheritEnv="terminal.integrated.inheritEnv",l.ShowLinkHover="terminal.integrated.showLinkHover",l.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",l.AutoReplies="terminal.integrated.autoReplies",l.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",l.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",l.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",l.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",l.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",l.EnableImages="terminal.integrated.enableImages",l.SmoothScrolling="terminal.integrated.smoothScrolling",l.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",l.FocusAfterRun="terminal.integrated.focusAfterRun",l.AccessibleViewPreserveCursorPosition="terminal.integrated.accessibleViewPreserveCursorPosition",l.AccessibleViewFocusOnCommandExecution="terminal.integrated.accessibleViewFocusOnCommandExecution",l.StickyScrollEnabled="terminal.integrated.stickyScroll.enabled",l.StickyScrollMaxLineCount="terminal.integrated.stickyScroll.maxLineCount",l.MouseWheelZoom="terminal.integrated.mouseWheelZoom",l.ExperimentalInlineChat="terminal.integrated.experimentalInlineChat",l.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",l.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",l.DevMode="terminal.integrated.developer.devMode"})(C||(e.TerminalSettingId=C={}));var k;(function(l){l.PowerShell="pwsh",l.Bash="bash",l.Fish="fish",l.Sh="sh",l.Csh="csh",l.Ksh="ksh",l.Zsh="zsh",l.Python="python"})(k||(e.PosixShellType=k={}));var b;(function(l){l.CommandPrompt="cmd",l.PowerShell="pwsh",l.Wsl="wsl",l.GitBash="gitbash",l.Python="python"})(b||(e.WindowsShellType=b={}));var $;(function(l){l[l.Api=0]="Api",l[l.Process=1]="Process",l[l.Sequence=2]="Sequence",l[l.Config=3]="Config"})($||(e.TitleEventSource=$={}));var E;(function(l){l.LocalPty="localPty",l.PtyHost="ptyHost",l.PtyHostWindow="ptyHostWindow",l.Logger="logger",l.Heartbeat="heartbeat"})(E||(e.TerminalIpcChannels=E={}));var y;(function(l){l.Cwd="cwd",l.InitialCwd="initialCwd",l.FixedDimensions="fixedDimensions",l.Title="title",l.ShellType="shellType",l.HasChildProcesses="hasChildProcesses",l.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",l.OverrideDimensions="overrideDimensions",l.FailedShellIntegrationActivation="failedShellIntegrationActivation",l.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(y||(e.ProcessPropertyType=y={})),e.$Rr=(0,n.$ii)("ptyService");var w;(function(l){l[l.BeatInterval=5e3]="BeatInterval",l[l.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",l[l.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",l[l.SecondWaitMultiplier=1]="SecondWaitMultiplier",l[l.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(w||(e.HeartbeatConstants=w={}));var g;(function(l){l[l.Panel=1]="Panel",l[l.Editor=2]="Editor"})(g||(e.TerminalLocation=g={}));var d;(function(l){l.TerminalView="view",l.Editor="editor"})(d||(e.TerminalLocationString=d={}));var c;(function(l){l[l.GraceTime=6e4]="GraceTime",l[l.ShortGraceTime=6e3]="ShortGraceTime"})(c||(e.LocalReconnectConstants=c={}));var m;(function(l){l[l.HighWatermarkChars=1e5]="HighWatermarkChars",l[l.LowWatermarkChars=5e3]="LowWatermarkChars",l[l.CharCountAckSize=5e3]="CharCountAckSize"})(m||(e.FlowControlConstants=m={}));var u;(function(l){l.GitBash="Git Bash",l.Pwsh="PowerShell"})(u||(e.ProfileSource=u={}));var p;(function(l){l[l.Off=0]="Off",l[l.FinalTerm=1]="FinalTerm",l[l.VSCode=2]="VSCode"})(p||(e.ShellIntegrationStatus=p={}));var h;(function(l){l[l.Unknown=0]="Unknown",l[l.Shutdown=1]="Shutdown",l[l.Process=2]="Process",l[l.User=3]="User",l[l.Extension=4]="Extension"})(h||(e.TerminalExitReason=h={})),e.$Sr={Backend:"workbench.contributions.terminal.processBackend"};class f{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(t){const a=this.b(t.remoteAuthority);if(this.a.has(a))throw new Error(`A terminal backend with remote authority '${a}' was already registered.`);this.a.set(a,t)}getTerminalBackend(t){return this.a.get(this.b(t))}b(t){return t?.toLowerCase()??""}}P.$2n.add(e.$Sr.Backend,new f),e.$Tr=(0,n.$ii)("localPtyService"),e.$Ur=(0,n.$ii)("terminalLogService")}),define(Ee[126],ke([1,0,4]),function(ce,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CP=A,e.$DP=P,e.$EP=D,e.$FP=C;function A(k){let b=k;b.includes("\\")&&(b=b.replace(/\\/g,"\\\\"));const $=/[\`\$\|\&\>\~\#\!\^\*\;\<\"\']/g;return b=b.replace($,""),`'${b}'`}function P(k,b,$){if(!k)return"";if(!b)return k;b.match(/[\/\\]$/)&&(b=b.slice(0,b.length-1));const E=k.replace(/\\/g,"/").toLowerCase(),y=b.replace(/\\/g,"/").toLowerCase();return E.includes(y)?`~${$}${k.slice(b.length+1)}`:k}function D(k){return k.match(/^['"].*['"]$/)&&(k=k.substring(1,k.length-1)),n.OS===1&&k&&k[1]===":"?k[0].toUpperCase()+k.substring(1):k}function C(k){return!k.strictEnv}}),define(Ee[260],ke([1,0,52,3,204,101]),function(ce,e,n,A,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zr=C,e.$1r=$,e.$2r=E,e.$3r=y;function C(w,g){const d=[{name:null,description:(0,P.localize)(0,null)}];return d.push(...w.map(c=>({name:c.profileName,description:k(c)}))),g&&d.push(...g.map(c=>({name:c.title,description:b(c)}))),{values:d.map(c=>c.name),markdownDescriptions:d.map(c=>c.description)}}function k(w){let g=`$(${D.ThemeIcon.isThemeIcon(w.icon)?w.icon.id:w.icon?w.icon:n.$Hj.terminal.id}) ${w.profileName}
- path: ${w.path}`;return w.args&&(typeof w.args=="string"?g+=`
- args: "${w.args}"`:g+=`
- args: [${w.args.length===0?"":`'${w.args.join("','")}'`}]`),w.overrideName!==void 0&&(g+=`
- overrideName: ${w.overrideName}`),w.color&&(g+=`
- color: ${w.color}`),w.env&&(g+=`
- env: ${JSON.stringify(w.env)}`),g}function b(w){return`$(${D.ThemeIcon.isThemeIcon(w.icon)?w.icon.id:w.icon?w.icon:n.$Hj.terminal.id}) ${w.title}
- extensionIdentifier: ${w.extensionIdentifier}`}function $(w,g){if(!w&&!g)return!0;if(typeof w=="string"&&typeof g=="string")return w===g;if(Array.isArray(w)&&Array.isArray(g)){if(w.length!==g.length)return!1;for(let d=0;d<w.length;d++)if(w[d]!==g[d])return!1;return!0}return!1}function E(w,g){if(!w&&!g)return!0;if(!w||!g)return!1;if(D.ThemeIcon.isThemeIcon(w)&&D.ThemeIcon.isThemeIcon(g))return w.id===g.id&&w.color===g.color;if(typeof w=="object"&&"light"in w&&"dark"in w&&typeof g=="object"&&"light"in g&&"dark"in g){const d=w,c=g;if((A.URI.isUri(d.light)||y(d.light))&&(A.URI.isUri(d.dark)||y(d.dark))&&(A.URI.isUri(c.light)||y(c.light))&&(A.URI.isUri(c.dark)||y(c.dark)))return d.light.path===c.light.path&&d.dark.path===c.dark.path}if(A.URI.isUri(w)&&A.URI.isUri(g)||y(w)||y(g)){const d=w,c=g;return d.path===c.path&&d.scheme===c.scheme}return!1}function y(w){return w?typeof w.path=="string"&&typeof w.scheme=="string":!1}}),define(Ee[261],ke([1,0,52,4,203,47,38,260]),function(ce,e,n,A,P,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5r=e.$4r=void 0,e.$6r=g,e.$7r=c,e.$4r={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$5r={type:"string",enum:Array.from((0,n.$Fj)(),m=>m.id),markdownEnumDescriptions:Array.from((0,n.$Fj)(),m=>`$(${m.id})`)};const b={args:{description:(0,P.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,P.localize)(1,null),type:"boolean"},icon:{description:(0,P.localize)(2,null),...e.$5r},color:{description:(0,P.localize)(3,null),...e.$4r},env:{markdownDescription:(0,P.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},$={type:"object",required:["path"],properties:{path:{description:(0,P.localize)(5,null),type:["string","array"],items:{type:"string"}},...b}},E={type:"object",required:["path"],properties:{path:{description:(0,P.localize)(6,null),type:["string"],items:{type:"string"}},...b}};function y(m){const u=m===2?"linux":m===1?"osx":"windows";return(0,P.localize)(7,null,(0,A.$b)(m),'```json\n"terminal.integrated.profile.'+u+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const w={id:"terminal",order:100,title:(0,P.localize)(8,null),type:"object",properties:{"terminal.integrated.automationProfile.linux":{restricted:!0,markdownDescription:(0,P.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},E],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},"terminal.integrated.automationProfile.osx":{restricted:!0,markdownDescription:(0,P.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},E],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},"terminal.integrated.automationProfile.windows":{restricted:!0,markdownDescription:(0,P.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},E],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},"terminal.integrated.profiles.windows":{restricted:!0,markdownDescription:y(3),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,P.localize)(12,null),enum:["PowerShell","Git Bash"]},...b}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,P.localize)(13,null),type:"string"},id:{description:(0,P.localize)(14,null),type:"string"},title:{description:(0,P.localize)(15,null),type:"string"},...b}},{type:"null"},$]}},"terminal.integrated.profiles.osx":{restricted:!0,markdownDescription:y(1),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,P.localize)(16,null),type:"string"},id:{description:(0,P.localize)(17,null),type:"string"},title:{description:(0,P.localize)(18,null),type:"string"},...b}},{type:"null"},$]}},"terminal.integrated.profiles.linux":{restricted:!0,markdownDescription:y(2),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,P.localize)(19,null),type:"string"},id:{description:(0,P.localize)(20,null),type:"string"},title:{description:(0,P.localize)(21,null),type:"string"},...b}},{type:"null"},$]}},"terminal.integrated.useWslProfiles":{description:(0,P.localize)(22,null),type:"boolean",default:!0},"terminal.integrated.inheritEnv":{scope:1,description:(0,P.localize)(23,null),type:"boolean",default:!0},"terminal.integrated.persistentSessionScrollback":{scope:1,markdownDescription:(0,P.localize)(24,null),type:"number",default:100},"terminal.integrated.showLinkHover":{scope:1,description:(0,P.localize)(25,null),type:"boolean",default:!0},"terminal.integrated.ignoreProcessNames":{markdownDescription:(0,P.localize)(26,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function g(){C.$2n.as(D.$7n.Configuration).registerConfiguration(w),c()}let d;function c(m,u){const p=C.$2n.as(D.$7n.Configuration);let h;m&&(h=(0,k.$Zr)(m?.profiles,u));const f=d;d={id:"terminal",order:100,title:(0,P.localize)(27,null),type:"object",properties:{"terminal.integrated.defaultProfile.linux":{restricted:!0,markdownDescription:(0,P.localize)(28,null),type:["string","null"],default:null,enum:m?.os===3?h?.values:void 0,markdownEnumDescriptions:m?.os===3?h?.markdownDescriptions:void 0},"terminal.integrated.defaultProfile.osx":{restricted:!0,markdownDescription:(0,P.localize)(29,null),type:["string","null"],default:null,enum:m?.os===2?h?.values:void 0,markdownEnumDescriptions:m?.os===2?h?.markdownDescriptions:void 0},"terminal.integrated.defaultProfile.windows":{restricted:!0,markdownDescription:(0,P.localize)(30,null),type:["string","null"],default:null,enum:m?.os===1?h?.values:void 0,markdownEnumDescriptions:m?.os===1?h?.markdownDescriptions:void 0}}},p.updateConfigurations({add:[d],remove:f?[f]:[]})}}),define(Ee[262],ke([1,0,2,12,109,26,110]),function(ce,e,n,A,P,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jQ=void 0;let k=class extends n.$Uc{constructor($,E){super(),this.a=$,this.b=E}start(){const $={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this.b.logsHome.with({scheme:A.Schemas.file}).fsPath],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this.a.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this.a.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this.a.scrollback}},E=(0,C.$Wm)(this.b.args,this.b.isBuilt);E&&(E.break&&E.port?$.debugBrk=E.port:!E.break&&E.port&&($.debug=E.port));const y=new P.$Lq(A.$Cg.asFileUri("bootstrap-fork").fsPath,$),w=new n.$Tc;return w.add(y),{client:y,store:w,onDidProcessExit:y.onDidProcessExit}}};e.$jQ=k,e.$jQ=k=Fe([Ne(1,D.$pi)],k)}),define(Ee[263],ke([1,0,28,12,21,7,4,30,17,11,23,124,90,125]),function(ce,e,n,A,P,D,C,k,b,$,E,y,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cs=d,e.$ds=c,e.$es=m;function d(){const r=/(\d+)\.(\d+)\.(\d+)/g.exec(n.release());let s=0;return r&&r.length===4&&(s=parseInt(r[3])),s}async function c(r,s,i,v=k.env,S=E.Promises.exists){if(D.$jc(r))return await S(r)?r:void 0;if(s===void 0&&(s=k.cwd()),D.$nc(r)!=="."){const I=D.$kc(s,r);return await S(I)?I:void 0}const N=(0,P.$Wn)(v,"PATH");if(i===void 0&&(0,$.$Vf)(N)&&(i=N.split(D.$uc)),i===void 0||i.length===0){const I=D.$kc(s,r);return await S(I)?I:void 0}for(const I of i){let B;if(D.$jc(I)?B=D.$kc(I,r):B=D.$kc(s,I,r),await S(B))return B;if(C.$c){let Z=B+".com";if(await S(Z)||(Z=B+".exe",await S(Z)))return Z}}const j=D.$kc(s,r);return await S(j)?j:void 0}function m(r,s,i,v,S){const O=C.$c&&(!s.windowsEnableConpty||d()<18309);if(!s.shellIntegration.enabled||!r.executable||r.isFeatureTerminal&&!r.forceShellIntegration||r.ignoreShellIntegration||O)return;const N=r.args,j=k.$ec==="win32"?D.$oc(r.executable).toLowerCase():D.$oc(r.executable),I=D.$nc(A.$Cg.asFileUri("").fsPath);let B;const Z={VSCODE_INJECTION:"1"};if(s.shellIntegration.nonce&&(Z.VSCODE_NONCE=s.shellIntegration.nonce),C.$c){if(j==="pwsh.exe"||j==="powershell.exe")return!N||a(N)?B=h.get(p.WindowsPwsh):t(N)&&(B=h.get(p.WindowsPwshLogin)),B?(B=[...B],B[B.length-1]=(0,b.$Ve)(B[B.length-1],I,""),s.shellIntegration.suggestEnabled&&(Z.VSCODE_SUGGEST="1"),{newArgs:B,envMixin:Z}):void 0;v.warn(`Shell integration cannot be enabled for executable "${r.executable}" and args`,r.args);return}switch(j){case"bash":return!N||N.length===0?B=h.get(p.Bash):o(N)&&(Z.VSCODE_SHELL_LOGIN="1",u(s,Z),B=h.get(p.Bash)),B?(B=[...B],B[B.length-1]=(0,b.$Ve)(B[B.length-1],I),{newArgs:B,envMixin:Z}):void 0;case"fish":{const he=i?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",ae=D.$kc(I,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return Z.XDG_DATA_DIRS=`${he}:${ae}`,u(s,Z),{newArgs:void 0,envMixin:Z}}case"pwsh":return!N||a(N)?B=h.get(p.Pwsh):t(N)&&(B=h.get(p.PwshLogin)),B?(s.shellIntegration.suggestEnabled&&(Z.VSCODE_SUGGEST="1"),B=[...B],B[B.length-1]=(0,b.$Ve)(B[B.length-1],I,""),{newArgs:B,envMixin:Z}):void 0;case"zsh":{if(!N||N.length===0?B=h.get(p.Zsh):o(N)?(B=h.get(p.ZshLogin),u(s,Z)):(N===h.get(p.Zsh)||N===h.get(p.ZshLogin))&&(B=N),!B)return;B=[...B],B[B.length-1]=(0,b.$Ve)(B[B.length-1],I);let he;try{he=n.userInfo().username}catch{he="unknown"}const ae=D.$kc(n.tmpdir(),`${he}-${S.applicationName}-zsh`);Z.ZDOTDIR=ae;const ee=i?.ZDOTDIR??n.homedir()??"~";Z.USER_ZDOTDIR=ee;const _=[];return _.push({source:D.$kc(I,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:D.$kc(ae,".zshrc")}),_.push({source:D.$kc(I,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:D.$kc(ae,".zprofile")}),_.push({source:D.$kc(I,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:D.$kc(ae,".zshenv")}),_.push({source:D.$kc(I,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:D.$kc(ae,".zlogin")}),{newArgs:B,envMixin:Z,filesToCopy:_}}}v.warn(`Shell integration cannot be enabled for executable "${r.executable}" and args`,r.args)}function u(r,s){if(C.$d&&r.environmentVariableCollections){const i=(0,w.$as)(r.environmentVariableCollections),S=new g.$bs(i).getVariableMap({workspaceFolder:r.workspaceFolder}).get("PATH"),O=[];if(S)for(const N of S)N.type===y.EnvironmentVariableMutatorType.Prepend&&O.push(N.value);O.length>0&&(s.VSCODE_PATH_PREFIX=O.join(""))}}var p;(function(r){r.WindowsPwsh="windows-pwsh",r.WindowsPwshLogin="windows-pwsh-login",r.Pwsh="pwsh",r.PwshLogin="pwsh-login",r.Zsh="zsh",r.ZshLogin="zsh-login",r.Bash="bash"})(p||(p={}));const h=new Map;h.set(p.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),h.set(p.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),h.set(p.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),h.set(p.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),h.set(p.Zsh,["-i"]),h.set(p.ZshLogin,["-il"]),h.set(p.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const f=["-login","-l"],l=["-nol","-nologo"];function t(r){return typeof r=="string"?f.includes(r.toLowerCase()):r.length===1&&f.includes(r[0].toLowerCase())||r.length===2&&(f.includes(r[0].toLowerCase())||f.includes(r[1].toLowerCase()))&&(l.includes(r[0].toLowerCase())||l.includes(r[1].toLowerCase()))}function a(r){return typeof r=="string"?l.includes(r.toLowerCase()):r.length===0||r?.length===1&&l.includes(r[0].toLowerCase())}function o(r){return r==="string"&&f.includes(r.toLowerCase())||typeof r!="string"&&r.length===1&&f.includes(r[0].toLowerCase())}}),define(Ee[264],ke([1,0,55,52,7,4,11,23,104,263,77]),function(ce,e,n,A,P,D,C,k,b,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fs=d;var y;(function(i){i.UnixShellsPath="/etc/shells"})(y||(y={}));let w,g=!0;function d(i,v,S,O,N=process.env,j,I,B,Z){return j=j||{existsFile:k.SymlinkSupport.existsFile,readFile:k.Promises.readFile},D.$c?c(S,j,N,I,O.getValue("terminal.integrated.useWslProfiles")!==!1,i&&typeof i=="object"?{...i}:O.getValue("terminal.integrated.profiles.windows"),typeof v=="string"?v:O.getValue("terminal.integrated.defaultProfile.windows"),Z,B):o(j,I,S,i&&typeof i=="object"?{...i}:O.getValue(D.$e?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof v=="string"?v:O.getValue(D.$e?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),Z,B,N)}async function c(i,v,S,O,N,j,I,B,Z){const he=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),ae=`${process.env.windir}\\${he?"Sysnative":"System32"}`;let ee=!1;(0,$.$cs)()>=16299&&(ee=!0),await h(B);const _=new Map;if(i){_.set("PowerShell",{source:"PowerShell",icon:A.$Hj.terminalPowershell,isAutoDetected:!0}),_.set("Windows PowerShell",{path:`${ae}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:A.$Hj.terminalPowershell,isAutoDetected:!0}),_.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),_.set("Command Prompt",{path:`${ae}\\cmd.exe`,icon:A.$Hj.terminalCmd,isAutoDetected:!0}),_.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),_.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],env:{CHERE_INVOKING:"1"},icon:A.$Hj.terminalBash,isAutoDetected:!0});const T=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;_.set("Cmder",{path:`${ae}\\cmd.exe`,args:["/K",T],requiresPath:process.env.CMDER_ROOT?T:{path:T,isUnsafe:!0},isAutoDetected:!0})}r(j,_);const z=await m(_.entries(),I,v,S,O,Z);if(i&&N)try{const T=await t(`${ae}\\${ee?"wsl":"bash"}.exe`,I);for(const J of T)(!j||!(J.profileName in j))&&z.push(J)}catch{g&&(O?.trace("WSL is not installed, so could not detect WSL profiles"),g=!1)}return z}async function m(i,v,S,O=process.env,N,j){const I=[];for(const[B,Z]of i)I.push(u(B,Z,v,S,O,N,j));return(await Promise.all(I)).filter(B=>!!B)}async function u(i,v,S,O,N=process.env,j,I){if(v===null)return;let B,Z,he;if("source"in v&&!("path"in v)){const z=w?.get(v.source);if(!z)return;B=z.paths,Z=v.args||z.args,v.icon?he=p(v.icon):z.icon&&(he=z.icon)}else B=Array.isArray(v.path)?v.path:[v.path],Z=D.$c||Array.isArray(v.args)?v.args:void 0,he=p(v.icon);let ae;if(I){const z=B.map(J=>typeof J=="string"?J:J.path),T=await I(z);ae=new Array(B.length);for(let J=0;J<B.length;J++)typeof B[J]=="string"?ae[J]=T[J]:ae[J]={path:T[J],isUnsafe:!0}}else ae=B.slice();let ee;if(v.requiresPath){let z;if((0,C.$Vf)(v.requiresPath)?z=v.requiresPath:(z=v.requiresPath.path,v.requiresPath.isUnsafe&&(ee=z)),!await O.existsFile(z))return}const _=await s(i,S,ae,O,N,Z,v.env,v.overrideName,v.isAutoDetected,ee);if(!_){j?.debug("Terminal profile not validated",i,B);return}return _.isAutoDetected=v.isAutoDetected,_.icon=he,_.color=v.color,_}function p(i){return typeof i=="string"?{id:i}:i}async function h(i){if(w&&!i)return;const[v,S]=await Promise.all([f(),i||l()]);w=new Map,w.set("Git Bash",{profileName:"Git Bash",paths:v,args:["--login","-i"]}),w.set("PowerShell",{profileName:"PowerShell",paths:S,icon:A.$Hj.terminalPowershell})}async function f(){const i=new Set,v=await(0,$.$ds)("git.exe");if(v){const N=(0,E.dirname)(v);i.add((0,E.resolve)(N,"../.."))}function S(N,j){j&&N.add(j)}S(i,process.env.ProgramW6432),S(i,process.env.ProgramFiles),S(i,process.env["ProgramFiles(X86)"]),S(i,`${process.env.LocalAppData}\\Program`);const O=[];for(const N of i)O.push(`${N}\\Git\\bin\\bash.exe`,`${N}\\Git\\usr\\bin\\bash.exe`,`${N}\\usr\\bin\\bash.exe`);return O.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),O.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),O}async function l(){const i=[];for await(const v of(0,b.$0l)())i.push(v.exePath);return i}async function t(i,v){const S=[],O=await new Promise((I,B)=>{n.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(Z,he)=>{if(Z)return B("Problem occurred when getting wsl distros");I(he)})});if(!O)return[];const N=new RegExp(/[\r?\n]/),j=O.split(N).filter(I=>I.trim().length>0&&I!=="");for(const I of j){if(I===""||I.startsWith("docker-desktop"))continue;const B=`${I} (WSL)`,Z={profileName:B,path:i,args:["-d",`${I}`],isDefault:B===v,icon:a(I),isAutoDetected:!1};S.push(Z)}return S}function a(i){return i.includes("Ubuntu")?A.$Hj.terminalUbuntu:i.includes("Debian")?A.$Hj.terminalDebian:A.$Hj.terminalLinux}async function o(i,v,S,O,N,j,I,B){const Z=new Map;if(S&&await i.existsFile("/etc/shells")){const he=(await i.readFile("/etc/shells")).toString(),ae=(j||he.split(`
`)).map(_=>{const z=_.indexOf("#");return z===-1?_:_.substring(0,z)}).filter(_=>_.trim().length>0),ee=new Map;for(const _ of ae){let z=(0,P.$oc)(_),T=ee.get(z)||0;T++,T>1&&(z=`${z} (${T})`),ee.set(z,T),Z.set(z,{path:_,isAutoDetected:!0})}}return r(O,Z),await m(Z.entries(),N,i,B,v,I)}function r(i,v){if(i)for(const[S,O]of Object.entries(i))O===null||typeof O!="object"||!("path"in O)&&!("source"in O)?v.delete(S):(O.icon=O.icon||v.get(S)?.icon,v.set(S,O))}async function s(i,v,S,O,N,j,I,B,Z,he){if(S.length===0)return Promise.resolve(void 0);const ae=S.shift();if(ae==="")return s(i,v,S,O,N,j,I,B,Z);const ee=typeof ae!="string"&&ae.isUnsafe,_=typeof ae=="string"?ae:ae.path,z={profileName:i,path:_,args:j,env:I,overrideName:B,isAutoDetected:Z,isDefault:i===v,isUnsafePath:ee,requiresUnsafePath:he};if((0,P.$oc)(_)===_){const J=N.PATH?N.PATH.split(P.$uc):void 0,Y=await(0,$.$ds)(_,void 0,J,void 0,O.existsFile);return Y?(z.path=Y,z.isFromPath=!0,z):s(i,v,S,O,N,j)}return await O.existsFile((0,P.$ic)(_))?z:s(i,v,S,O,N,j,I,B,Z)}}),define(Ee[265],ke([1,0,6,2,4,44,25,13,115,87,259,91,261,264,107,63]),function(ce,e,n,A,P,D,C,k,b,$,E,y,w,g,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gs=void 0;var m;(function(p){p[p.MaxRestarts=5]="MaxRestarts"})(m||(m={}));let u=class extends A.$Uc{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.U()}constructor(h,f,l,t){super(),this.M=h,this.N=f,this.O=l,this.P=t,this.m=!1,this.n=0,this.r=!0,this.u=this.B(new n.$7d),this.onPtyHostExit=this.u.event,this.w=this.B(new n.$7d),this.onPtyHostStart=this.w.event,this.y=this.B(new n.$7d),this.onPtyHostUnresponsive=this.y.event,this.z=this.B(new n.$7d),this.onPtyHostResponsive=this.z.event,this.C=this.B(new n.$7d),this.onPtyHostRequestResolveVariables=this.C.event,this.D=this.B(new n.$7d),this.onProcessData=this.D.event,this.F=this.B(new n.$7d),this.onProcessReady=this.F.event,this.G=this.B(new n.$7d),this.onProcessReplay=this.G.event,this.H=this.B(new n.$7d),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new n.$7d),this.onDidRequestDetach=this.I.event,this.J=this.B(new n.$7d),this.onDidChangeProperty=this.J.event,this.L=this.B(new n.$7d),this.onProcessExit=this.L.event,(0,w.$6r)(),this.B(this.M),this.B((0,A.$Sc)(()=>this.W())),this.j=this.B(new E.$Yr(void 0,this.O)),this.j.onCreateRequest(this.C.fire,this.C),this.M.onRequestConnection&&n.Event.once(this.M.onRequestConnection)(()=>this.h()),this.M.onWillShutdown?.(()=>this.m=!0)}get Q(){return this.N.getValue("terminal.integrated.ignoreProcessNames")}async R(){return this.g?.refreshIgnoreProcessNames?.(this.Q)}async S(){if(P.$c)return process.env;try{return await(0,$.$tm)(this.N,this.O,{_:[]},process.env)}catch(h){return this.O.error("ptyHost was unable to resolve shell environment",h),{}}}U(){const h=this.M.start(),f=h.client;this.O.getLevel()===k.LogLevel.Trace&&this.O.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),D.ProxyChannel.toService(f.getChannel(y.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.X()),this.X(!0),this.B(h.onDidProcessExit(a=>{this.u.fire(a.code),!this.m&&!this.q.isDisposed&&(this.n<=m.MaxRestarts?(this.O.error(`ptyHost terminated unexpectedly with code ${a.code}`),this.n++,this.restartPtyHost()):this.O.error(`ptyHost terminated unexpectedly with code ${a.code}, giving up`))}));const t=D.ProxyChannel.toService(f.getChannel(y.TerminalIpcChannels.PtyHost));return this.B(t.onProcessData(a=>this.D.fire(a))),this.B(t.onProcessReady(a=>this.F.fire(a))),this.B(t.onProcessExit(a=>this.L.fire(a))),this.B(t.onDidChangeProperty(a=>this.J.fire(a))),this.B(t.onProcessReplay(a=>this.G.fire(a))),this.B(t.onProcessOrphanQuestion(a=>this.H.fire(a))),this.B(t.onDidRequestDetach(a=>this.I.fire(a))),this.B(new b.$Xr(this.P,f.getChannel(y.TerminalIpcChannels.Logger))),this.a=h,this.b=t,this.w.fire(),this.B(this.N.onDidChangeConfiguration(async a=>{a.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.R()})),this.R(),[h,t]}async createProcess(h,f,l,t,a,o,r,s,i,v,S){const O=setTimeout(()=>this.$(),y.HeartbeatConstants.CreateProcessTimeout),N=await this.f.createProcess(h,f,l,t,a,o,r,s,i,v,S);return clearTimeout(O),N}updateTitle(h,f,l){return this.f.updateTitle(h,f,l)}updateIcon(h,f,l,t){return this.f.updateIcon(h,f,l,t)}attachToProcess(h){return this.f.attachToProcess(h)}detachFromProcess(h,f){return this.f.detachFromProcess(h,f)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start(h){return this.f.start(h)}shutdown(h,f){return this.f.shutdown(h,f)}input(h,f){return this.f.input(h,f)}processBinary(h,f){return this.f.processBinary(h,f)}resize(h,f,l){return this.f.resize(h,f,l)}clearBuffer(h){return this.f.clearBuffer(h)}acknowledgeDataEvent(h,f){return this.f.acknowledgeDataEvent(h,f)}setUnicodeVersion(h,f){return this.f.setUnicodeVersion(h,f)}getInitialCwd(h){return this.f.getInitialCwd(h)}getCwd(h){return this.f.getCwd(h)}async getLatency(){const h=new c.$3d,f=await this.f.getLatency();return h.stop(),[{label:"ptyhostservice<->ptyhost",latency:h.elapsed()},...f]}orphanQuestionReply(h){return this.f.orphanQuestionReply(h)}installAutoReply(h,f){return this.f.installAutoReply(h,f)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(h){return this.f.uninstallAutoReply(h)}getDefaultSystemShell(h){return this.g?.getDefaultSystemShell(h)??(0,d.$dm)(h??P.OS,process.env)}async getProfiles(h,f,l,t=!1){const a=await this.S();return(0,g.$fs)(f,l,t,this.N,a,void 0,this.O,this.bb.bind(this,h))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath(h,f){return this.f.getWslPath(h,f)}getRevivedPtyNewId(h,f){return this.f.getRevivedPtyNewId(h,f)}setTerminalLayoutInfo(h){return this.f.setTerminalLayoutInfo(h)}async getTerminalLayoutInfo(h){return this.g?.getTerminalLayoutInfo(h)}async requestDetachInstance(h,f){return this.f.requestDetachInstance(h,f)}async acceptDetachInstanceReply(h,f){return this.f.acceptDetachInstanceReply(h,f)}async freePortKillProcess(h){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(h)}async serializeTerminalState(h){return this.f.serializeTerminalState(h)}async reviveTerminalProcesses(h,f,l){return this.f.reviveTerminalProcesses(h,f,l)}async refreshProperty(h,f){return this.f.refreshProperty(h,f)}async updateProperty(h,f,l){return this.f.updateProperty(h,f,l)}async restartPtyHost(){this.W(),this.r=!0,this.U()}W(){this.f.shutdownAll(),this.c.store.dispose()}X(h){this.ab(),this.s=setTimeout(()=>this.Y(),h?y.HeartbeatConstants.ConnectingBeatInterval:y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier),this.r||(this.r=!0,this.z.fire())}Y(){this.O.warn(`No ptyHost heartbeat after ${y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.s=void 0,this.t=setTimeout(()=>this.Z(),y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.SecondWaitMultiplier)}Z(){this.O.error(`No ptyHost heartbeat after ${(y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier+y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.t=void 0,this.r&&(this.r=!1,this.y.fire())}$(){this.ab(),this.O.error(`No ptyHost response to createProcess after ${y.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.r&&(this.r=!1,this.y.fire())}ab(){this.s&&(clearTimeout(this.s),this.s=void 0),this.t&&(clearTimeout(this.t),this.t=void 0)}bb(h,f){return this.j.createRequest({workspaceId:h,originalText:f})}async acceptPtyHostResolvedVariables(h,f){this.j.acceptReply(h,f)}};e.$gs=u,e.$gs=u=Fe([Ne(1,C.$Oi),Ne(2,k.$Oj),Ne(3,k.$Pj)],u)}),define(Ee[34],ke([1,0,5]),function(ce,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ml=void 0,e.$ml=(0,n.$ii)("IUriIdentityService")}),define(Ee[127],ke([1,0,34,111,16,19,152,6,2]),function(ce,e,n,A,P,D,C,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ks=void 0;class ${constructor(w){this.uri=w,this.time=$._clock++}touch(){return this.time=$._clock++,this}}$._clock=0;let E=class{constructor(w){this.g=w,this.c=new b.$Tc,this.f=2**16;const g=new Map,d=c=>{let m=g.get(c.scheme);return m===void 0&&(m=w.hasProvider(c)&&!this.g.hasCapability(c,1024),g.set(c.scheme,m)),m};this.c.add(k.Event.any(w.onDidChangeFileSystemProviderRegistrations,w.onDidChangeFileSystemProviderCapabilities)(c=>{g.delete(c.scheme)})),this.extUri=new D.$Kg(d),this.d=new C.$js((c,m)=>this.extUri.compare(c,m,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(w){this.g.hasProvider(w)&&(w=(0,D.$Wg)(w));const g=this.d.get(w);return g?g.touch().uri.with({fragment:w.fragment}):(this.d.set(w,new $(w)),this.h(),w)}h(){if(this.d.size<this.f)return;const w=[...this.d.entries()].sort((d,c)=>d[1].time<c[1].time?1:d[1].time>c[1].time?-1:0);$._clock=0,this.d.clear();const g=this.f*.5;for(let d=0;d<g;d++)this.d.set(w[d][0],w[d][1].touch())}};e.$ks=E,e.$ks=E=Fe([Ne(0,P.$Ok)],E),(0,A.$hs)(n.$ml,E,1)}),define(Ee[92],ke([1,0,206,7,66,19,3,5,12]),function(ce,e,n,A,P,D,C,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Ci=e.$Bi=e.WorkbenchState=e.$vi=e.$ui=e.$ri=void 0,e.$si=$,e.$ti=E,e.$wi=y,e.$xi=w,e.$yi=g,e.$zi=c,e.$Ai=m,e.$Di=h,e.$Ii=f,e.$Ji=l,e.$Li=t,e.$Mi=a,e.$Ni=o,e.$ri=(0,k.$ii)("contextService");function $(r){const s=r;return typeof s?.id=="string"&&C.URI.isUri(s.uri)}function E(r){return typeof r?.id=="string"&&!$(r)&&!w(r)}e.$ui={id:"ext-dev"},e.$vi={id:"empty-window"};function y(r,s){if(typeof r=="string"||typeof r>"u")return typeof r=="string"?{id:(0,A.$oc)(r)}:s?e.$ui:e.$vi;const i=r;return i.configuration?{id:i.id,configPath:i.configuration}:i.folders.length===1?{id:i.id,uri:i.folders[0].uri}:{id:i.id}}function w(r){const s=r;return typeof s?.id=="string"&&C.URI.isUri(s.configPath)}function g(r){const s=r;if(s?.uri)return{id:s.id,uri:C.URI.revive(s.uri)};const i=r;if(i?.configPath)return{id:i.id,configPath:C.URI.revive(i.configPath)};if(r?.id)return{id:r.id}}var d;(function(r){r[r.EMPTY=1]="EMPTY",r[r.FOLDER=2]="FOLDER",r[r.WORKSPACE=3]="WORKSPACE"})(d||(e.WorkbenchState=d={}));function c(r){const s=r;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}function m(r){const s=r;return!!(s&&typeof s=="object"&&C.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}class u{constructor(s,i,v,S,O){this.h=s,this.j=v,this.k=S,this.l=O,this.c=P.$oi.forUris(this.l,()=>!0),this.folders=i}update(s){this.h=s.id,this.k=s.configuration,this.j=s.transient,this.l=s.l,this.folders=s.folders}get folders(){return this.g}set folders(s){this.g=s,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(s){this.k=s}getFolder(s){return s&&this.c.findSubstr(s)||null}n(){this.c=P.$oi.forUris(this.l,()=>!0);for(const s of this.folders)this.c.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Bi=u;class p{constructor(s,i){this.raw=i,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,D.$Vg)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Ci=p;function h(r){return new p({uri:r,index:0,name:(0,D.$Rg)(r)},{uri:r.toString()})}e.$Ei="code-workspace",e.$Fi=`.${e.$Ei}`,e.$Gi=[{name:(0,n.localize)(0,null),extensions:[e.$Ei]}],e.$Hi="workspace.json";function f(r,s){return D.$Mg.isEqualOrParent(r,s.untitledWorkspacesHome)}function l(r){let s;return C.URI.isUri(r)?s=r:s=r.configuration,s?.scheme===b.Schemas.tmp}e.$Ki="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(r){return r.id===e.$Ki}function a(r,s){return!f(r,s)&&!l(r)}function o(r){return(typeof r=="string"?(0,A.$pc)(r):(0,D.$Tg)(r))===e.$Fi}}),define(Ee[33],ke([1,0,64,6,2,19,3,205,26,16,5,13,92,24,34,15,22,17,11]),function(ce,e,n,A,P,D,C,k,b,$,E,y,w,g,d,c,m,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sl=e.$rl=e.$ol=e.ProfileResourceType=void 0,e.$nl=f,e.$pl=l,e.$ql=t;var h;(function(r){r.Settings="settings",r.Keybindings="keybindings",r.Snippets="snippets",r.Tasks="tasks",r.Extensions="extensions",r.GlobalState="globalState"})(h||(e.ProfileResourceType=h={}));function f(r){const s=r;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&typeof s.isDefault=="boolean"&&typeof s.name=="string"&&C.URI.isUri(s.location)&&C.URI.isUri(s.globalStorageHome)&&C.URI.isUri(s.settingsResource)&&C.URI.isUri(s.keybindingsResource)&&C.URI.isUri(s.tasksResource)&&C.URI.isUri(s.snippetsHome)&&C.URI.isUri(s.extensionsResource))}e.$ol=(0,E.$ii)("IUserDataProfilesService");function l(r,s){return{id:r.id,isDefault:r.isDefault,name:r.name,shortName:r.shortName,icon:r.icon,location:C.URI.revive(r.location).with({scheme:s}),globalStorageHome:C.URI.revive(r.globalStorageHome).with({scheme:s}),settingsResource:C.URI.revive(r.settingsResource).with({scheme:s}),keybindingsResource:C.URI.revive(r.keybindingsResource).with({scheme:s}),tasksResource:C.URI.revive(r.tasksResource).with({scheme:s}),snippetsHome:C.URI.revive(r.snippetsHome).with({scheme:s}),extensionsResource:C.URI.revive(r.extensionsResource).with({scheme:s}),cacheHome:C.URI.revive(r.cacheHome).with({scheme:s}),useDefaultFlags:r.useDefaultFlags,isTransient:r.isTransient}}function t(r,s,i,v,S,O){return{id:r,name:s,location:i,isDefault:!1,shortName:S?.shortName,icon:S?.icon,globalStorageHome:O&&S?.useDefaultFlags?.globalState?O.globalStorageHome:(0,D.$Vg)(i,"globalStorage"),settingsResource:O&&S?.useDefaultFlags?.settings?O.settingsResource:(0,D.$Vg)(i,"settings.json"),keybindingsResource:O&&S?.useDefaultFlags?.keybindings?O.keybindingsResource:(0,D.$Vg)(i,"keybindings.json"),tasksResource:O&&S?.useDefaultFlags?.tasks?O.tasksResource:(0,D.$Vg)(i,"tasks.json"),snippetsHome:O&&S?.useDefaultFlags?.snippets?O.snippetsHome:(0,D.$Vg)(i,"snippets"),extensionsResource:O&&S?.useDefaultFlags?.extensions?O.extensionsResource:(0,D.$Vg)(i,"extensions.json"),cacheHome:(0,D.$Vg)(v,r),useDefaultFlags:S?.useDefaultFlags,isTransient:S?.transient}}let a=class extends P.$Uc{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(s,i,v,S){super(),this.t=s,this.u=i,this.w=v,this.y=S,this.f=!0,this.h=this.B(new A.$7d),this.onDidChangeProfiles=this.h.event,this.j=this.B(new A.$7d),this.onWillCreateProfile=this.j.event,this.m=this.B(new A.$7d),this.onWillRemoveProfile=this.m.event,this.n=this.B(new A.$7d),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new g.$Bc,emptyWindows:new Map},this.profilesHome=(0,D.$Vg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,D.$Vg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(s){this.f!==s&&(this.z=void 0,this.f=s)}isEnabled(){return this.f}get C(){if(!this.z){const s=this.D(),i=[s];if(this.f)try{for(const O of this.O()){if(!O.name||!(0,p.$Vf)(O.name)||!O.location){this.y.warn("Skipping the invalid stored profile",O.location||O.name);continue}i.push(t((0,D.$Sg)(O.location),O.name,O.location,this.g,{shortName:O.shortName,icon:O.icon,useDefaultFlags:O.useDefaultFlags},s))}}catch(O){this.y.error(O)}const v=new g.$Bc,S=new Map;if(i.length)try{const O=this.Q();if(O.workspaces)for(const[N,j]of Object.entries(O.workspaces)){const I=C.URI.parse(N),B=i.find(Z=>Z.id===j);B&&v.set(I,B)}if(O.emptyWindows)for(const[N,j]of Object.entries(O.emptyWindows)){const I=i.find(B=>B.id===j);I&&S.set(N,I)}}catch(O){this.y.error(O)}this.z={profiles:i,workspaces:v,emptyWindows:S}}return this.z}D(){const s=t("__default__profile__",(0,k.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...s,extensionsResource:this.S()??s.extensionsResource,isDefault:!0}}async createTransientProfile(s){const i="Temp",v=new RegExp(`${(0,u.$Ze)(i)}\\s(\\d+)`);let S=0;for(const N of this.profiles){const j=v.exec(N.name),I=j?parseInt(j[1]):0;S=I>S?I:S}const O=`${i} ${S+1}`;return this.createProfile((0,n.$9i)((0,m.$Eg)()).toString(16),O,{transient:!0},s)}async createNamedProfile(s,i,v){return this.createProfile((0,n.$9i)((0,m.$Eg)()).toString(16),s,i,v)}async createProfile(s,i,v,S){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const O=await this.F(s,i,v);return S&&await this.setProfileForWorkspace(S,O),O}async F(s,i,v){if(!(0,p.$Vf)(i)||!i)throw new Error("Name of the profile is mandatory and must be of type `string`");let S=this.r.get(i);return S||(S=(async()=>{try{const O=this.profiles.find(I=>I.name===i||I.id===s);if(O)return O;const N=t(s,i,(0,D.$Vg)(this.profilesHome,s),this.g,v,this.defaultProfile);await this.u.createFolder(N.location);const j=[];return this.j.fire({profile:N,join(I){j.push(I)}}),await c.Promises.settled(j),this.I([N],[],[]),N}finally{this.r.delete(i)}})(),this.r.set(i,S)),S}async updateProfile(s,i){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let v=this.profiles.find(S=>S.id===s.id);if(!v)throw new Error(`Profile '${s.name}' does not exist`);return v=t(v.id,i.name??v.name,v.location,this.g,{shortName:i.shortName??v.shortName,icon:i.icon===null?void 0:i.icon??v.icon,transient:i.transient??v.isTransient,useDefaultFlags:i.useDefaultFlags??v.useDefaultFlags},this.defaultProfile),this.I([],[],[v]),v}async removeProfile(s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(s.isDefault)throw new Error("Cannot remove default profile");const i=this.profiles.find(S=>S.id===s.id);if(!i)throw new Error(`Profile '${s.name}' does not exist`);const v=[];this.m.fire({profile:i,join(S){v.push(S)}});try{await Promise.allSettled(v)}catch(S){this.y.error(S)}for(const S of[...this.C.emptyWindows.keys()])i.id===this.C.emptyWindows.get(S)?.id&&this.C.emptyWindows.delete(S);for(const S of[...this.C.workspaces.keys()])i.id===this.C.workspaces.get(S)?.id&&this.C.workspaces.delete(S);this.M(),this.I([],[i],[]);try{await this.u.del(i.cacheHome,{recursive:!0})}catch(S){(0,$.$6k)(S)!==1&&this.y.error(S)}}async setProfileForWorkspace(s,i){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const v=this.profiles.find(S=>S.id===i.id);if(!v)throw new Error(`Profile '${i.name}' does not exist`);this.L(s,v)}unsetWorkspace(s,i){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(s,void 0,i)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const s=await this.u.resolve(this.profilesHome);await Promise.all((s.children||[]).filter(i=>i.isDirectory&&this.profiles.every(v=>!this.w.extUri.isEqual(v.location,i.resource))).map(i=>this.u.del(i.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const s=this.s.profiles.filter(i=>!this.H(i));await Promise.allSettled(s.map(i=>this.removeProfile(i)))}getProfileForWorkspace(s){const i=this.G(s);return C.URI.isUri(i)?this.s.workspaces.get(i)??this.C.workspaces.get(i):this.s.emptyWindows.get(i)??this.C.emptyWindows.get(i)}G(s){return(0,w.$si)(s)?s.uri:(0,w.$xi)(s)?s.configPath:s.id}H(s){return!!([...this.s.emptyWindows.values()].some(i=>this.w.extUri.isEqual(i.location,s.location))||[...this.s.workspaces.values()].some(i=>this.w.extUri.isEqual(i.location,s.location))||[...this.C.emptyWindows.values()].some(i=>this.w.extUri.isEqual(i.location,s.location))||[...this.C.workspaces.values()].some(i=>this.w.extUri.isEqual(i.location,s.location)))}I(s,i,v){const S=[...this.profiles,...s],O=[];this.s.profiles=[];for(let N of S)N.isDefault||i.some(j=>N.id===j.id)||(N=v.find(j=>N.id===j.id)??N,N.isTransient?this.s.profiles.push(N):O.push({location:N.location,name:N.name,shortName:N.shortName,icon:N.icon,useDefaultFlags:N.useDefaultFlags}));this.P(O),this.z=void 0,this.J(s,i,v)}J(s,i,v){this.h.fire({added:s,removed:i,updated:v,all:this.profiles})}L(s,i,v){v=i?.isTransient?!0:v,v||this.L(s,void 0,!0);const S=this.G(s),O=v?this.s:this.C;C.URI.isUri(S)?(O.workspaces.delete(S),i&&O.workspaces.set(S,i)):(O.emptyWindows.delete(S),i&&O.emptyWindows.set(S,i)),v||this.M()}M(){const s={};for(const[v,S]of this.C.workspaces.entries())s[v.toString()]=S.id;const i={};for(const[v,S]of this.C.emptyWindows.entries())i[v.toString()]=S.id;this.R({workspaces:s,emptyWindows:i}),this.z=void 0}N(s){const i={},v=this.D();if(s.workspaces)for(const[O,N]of Object.entries(s.workspaces)){const j=C.URI.parse(N);i[O]=this.w.extUri.isEqual(j,v.location)?v.id:this.w.extUri.basename(j)}const S={};if(s.emptyWindows)for(const[O,N]of Object.entries(s.emptyWindows)){const j=C.URI.parse(N);S[O]=this.w.extUri.isEqual(j,v.location)?v.id:this.w.extUri.basename(j)}return{workspaces:i,emptyWindows:S}}O(){return[]}P(s){throw new Error("not implemented")}Q(){return{}}R(s){throw new Error("not implemented")}S(){}};e.$rl=a,a.b="userDataProfiles",a.c="profileAssociations",e.$rl=a=Fe([Ne(0,b.$pi),Ne(1,$.$Ok),Ne(2,d.$ml),Ne(3,y.$Oj)],a);class o extends a{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(s){this.a=s}Q(){return this.X}R(s){this.X=s}}e.$sl=o}),define(Ee[266],ke([1,0,18,15,20,10,6,2,4,11,3,185,31,36,35,13,32,29,34,33]),function(ce,e,n,A,P,D,C,k,b,$,E,y,w,g,d,c,m,u,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aq=e.$0p=void 0,e.$$p=l,e.$_p=t;let f=class extends k.$Uc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(s,i,v,S,O,N){super(),this.z=s,this.C=i,this.D=v,this.F=S,this.G=O,this.H=N,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new C.$7d),this.s=this.B(new C.$7d),this.t=this.B(new C.$7d),this.u=this.B(new C.$7d),this.w=this.B(new C.$7d),this.y=[],this.B((0,k.$Sc)(()=>{this.j.forEach(({task:j})=>j.cancel()),this.m.forEach(j=>j.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(s){const i=await this.getTargetPlatform();return s.allTargetPlatforms.some(v=>(0,w.$Qo)(v,s.allTargetPlatforms,i))}async installFromGallery(s,i={}){try{const S=(await this.installGalleryExtensions([{extension:s,options:i}])).find(({identifier:O})=>(0,g.$hp)(O,s.identifier));if(S?.local)return S?.local;throw S?.error?S.error:new w.$To(`Unknown error while installing extension ${s.identifier.id}`,w.ExtensionManagementErrorCode.Unknown)}catch(v){throw t(v)}}async installGalleryExtensions(s){if(!this.z.isEnabled())throw new w.$To(y.localize(0,null),w.ExtensionManagementErrorCode.NotAllowed);const i=[],v=[];await Promise.allSettled(s.map(async({extension:S,options:O})=>{try{const N=await this.N(S,!!O?.installGivenVersion,!!O?.installPreReleaseVersion,O.productVersion??{version:this.G.version,date:this.G.date});v.push({...N,options:O})}catch(N){i.push({identifier:S.identifier,operation:2,source:S,error:N})}})),v.length&&i.push(...await this.I(v));for(const S of i)S.error&&(this.F.error("Failed to install extension.",S.identifier.id),this.F.error(S.error),S.source&&!E.URI.isUri(S.source)&&a(this.C,"extensionGallery:install",{extensionData:(0,g.$pp)(S.source),error:S.error}));return i}async uninstall(s,i={}){return this.F.trace("ExtensionManagementService#uninstall",s.identifier.id),this.P(s,i)}async toggleAppliationScope(s,i){if((0,d.$Hm)(s.manifest)||s.isBuiltin)return s;if(s.isApplicationScoped){let v=await this.updateMetadata(s,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(i,this.H.defaultProfile.extensionsResource)||(v=await this.$(s,this.H.defaultProfile.extensionsResource,i));for(const S of this.H.profiles){const O=(await this.getInstalled(1,S.extensionsResource)).find(N=>(0,g.$hp)(N.identifier,s.identifier));O?this.w.fire(O):this.u.fire({identifier:s.identifier,profileLocation:S.extensionsResource})}return v}else{const v=this.D.extUri.isEqual(i,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(s,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.$(s,i,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:v.identifier,operation:2,local:v,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),v}}getExtensionsControlManifest(){const s=new Date().getTime();return(!this.g||s-this.h>1e3*60*5)&&(this.g=this.W(),this.h=s),this.g}registerParticipant(s){this.y.push(s)}async I(s){const i=[],v=new Map,S=[],O=[],N=(I,B)=>`${g.$ip.create(I).toString()}-${B.toString()}`,j=(I,B,Z)=>{const he=this.Y(I,B,Z),ae=E.URI.isUri(B)?B.path:`${B.identifier.id.toLowerCase()}-${Z.profileLocation.toString()}`;v.set(ae,{task:he,manifest:I}),this.n.fire({identifier:he.identifier,source:B,profileLocation:Z.profileLocation}),this.F.info("Installing extension:",he.identifier.id),E.URI.isUri(B)||this.j.set(N(B,Z.profileLocation),{task:he,waitingTasks:[]})};try{for(const{manifest:I,extension:B,options:Z}of s){const he=Z.isApplicationScoped||Z.isBuiltin||(0,d.$Hm)(I),ae={...Z,installOnlyNewlyAddedFromExtensionPack:Z.installOnlyNewlyAddedFromExtensionPack??!E.URI.isUri(B),isApplicationScoped:he,profileLocation:he?this.H.defaultProfile.extensionsResource:Z.profileLocation??this.X(),productVersion:Z.productVersion??{version:this.G.version,date:this.G.date}},ee=E.URI.isUri(B)?void 0:this.j.get(N(B,ae.profileLocation));ee?(this.F.info("Extension is already requested to install",ee.task.identifier.id),S.push(ee.task.waitUntilTaskIsFinished())):j(I,B,ae)}await Promise.all([...v.values()].map(async({task:I,manifest:B})=>{if(I.options.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",I.identifier.id);else try{const Z=await this.M(I.identifier,B,!!I.options.installOnlyNewlyAddedFromExtensionPack,!!I.options.installPreReleaseVersion,I.options.profileLocation,I.options.productVersion),he=await this.getInstalled(void 0,I.options.profileLocation,I.options.productVersion),ae={...I.options,donotIncludePackAndDependencies:!0,context:{...I.options.context,[w.$Lo]:!0}};for(const{gallery:ee,manifest:_}of(0,n.$Mb)(Z,({gallery:z})=>z.identifier.id)){if(v.has(`${ee.identifier.id.toLowerCase()}-${ae.profileLocation.toString()}`))continue;const z=this.j.get(N(ee,ae.profileLocation));if(z){if(this.J(I,z.task)){const T=z.task.identifier;this.F.info("Waiting for already requested installing extension",T.id,I.identifier.id),z.waitingTasks.push(I),S.push(C.Event.toPromise(C.Event.filter(this.onDidInstallExtensions,J=>J.some(Y=>(0,g.$hp)(Y.identifier,T)))).then(J=>{if(this.F.info("Finished waiting for already requested installing extension",T.id,I.identifier.id),!J.find(W=>(0,g.$hp)(W.identifier,T))?.local)throw new Error(`Extension ${T.id} is not installed`)}))}}else he.some(({identifier:T})=>(0,g.$hp)(T,ee.identifier))||j(_,ee,ae)}}catch(Z){if(E.URI.isUri(I.source))(0,n.$Lb)(B.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",I.identifier.id,Z.message),(0,n.$Lb)(B.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",I.identifier.id,Z.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",I.identifier.id),Z}})),await this.L([...v.values()].map(async({task:I})=>{const B=new Date().getTime();try{const Z=await I.run();if(await this.L(this.y.map(he=>he.postInstall(Z,I.source,I.options,P.CancellationToken.None))),!E.URI.isUri(I.source)){const he=I.operation===3,ae=he?void 0:(new Date().getTime()-I.source.lastUpdated)/1e3;if(a(this.C,he?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,g.$pp)(I.source),verificationStatus:I.verificationStatus,duration:new Date().getTime()-B,durationSinceUpdate:ae}),b.$i&&I.operation!==3)try{await this.z.reportStatistic(Z.manifest.publisher,Z.manifest.name,Z.manifest.version,"install")}catch{}}O.push({local:Z,identifier:I.identifier,operation:I.operation,source:I.source,context:I.options.context,profileLocation:I.profileLocation,applicationScoped:Z.isApplicationScoped})}catch(Z){throw this.F.error("Error while installing the extension",I.identifier.id,(0,D.$0)(Z)),Z}})),S.length&&await this.L(S);for(const I of O)this.F.info("Extension installed successfully:",I.identifier.id),i.push(I);return i}catch(I){O.length&&(this.F.info("Rollback: Uninstalling installed extensions",(0,D.$0)(I)),await Promise.allSettled(O.map(async({local:B,profileLocation:Z})=>{try{await this.Z(B,{versionOnly:!0,profileLocation:Z}).run(),this.F.info("Rollback: Uninstalled extension",B.identifier.id)}catch(he){this.F.warn("Rollback: Error while uninstalling extension",B.identifier.id,(0,D.$0)(he))}})));for(const{task:B}of v.values())B.cancel(),i.push({identifier:B.identifier,operation:2,source:B.source,context:B.options.context,profileLocation:B.profileLocation,error:I});throw I}finally{for(const{task:I}of v.values())I.source&&!E.URI.isUri(I.source)&&this.j.delete(N(I.source,I.profileLocation));i.length&&this.s.fire(i)}}J(s,i){for(const[,{task:v,waitingTasks:S}]of this.j.entries())if(v===s&&(S.includes(i)||S.some(O=>this.J(O,i)))||v===i&&S[0]&&!this.J(s,S[0]))return!1;return!0}async L(s){const i=[],v=[],S=await Promise.allSettled(s);for(const O of S)O.status==="fulfilled"?i.push(O.value):v.push(O.reason);if(v.length)throw l(v);return i}async M(s,i,v,S,O,N){if(!this.z.isEnabled())return[];const j=await this.getInstalled(void 0,O,N),I=[],B=[],Z=async(he,ae)=>{I.push(he);const ee=ae.extensionDependencies||[],_=[...ee];if(ae.extensionPack){const z=v?j.find(T=>(0,g.$hp)(T.identifier,he)):void 0;for(const T of ae.extensionPack)z&&z.manifest.extensionPack&&z.manifest.extensionPack.some(J=>(0,g.$hp)({id:J},{id:T}))||_.every(J=>!(0,g.$hp)({id:J},{id:T}))&&_.push(T)}if(_.length){const z=_.filter(T=>I.every(J=>!(0,g.$hp)(J,{id:T})));if(z.length){const T=await this.z.getExtensions(z.map(J=>({id:J,preRelease:S})),P.CancellationToken.None);for(const J of T){if(I.find(re=>(0,g.$hp)(re,J.identifier)))continue;const Y=ee.some(re=>(0,g.$hp)({id:re},J.identifier));let W;try{W=await this.N(J,!1,S,N)}catch(re){if(Y)throw re;this.F.info("Skipping the packed extension as it cannot be installed",J.identifier.id,(0,D.$0)(re));continue}B.push({gallery:W.extension,manifest:W.manifest}),await Z(W.extension.identifier,W.manifest)}}}};return await Z(s,i),B}async N(s,i,v,S){let O;const N=await this.getExtensionsControlManifest();if(N.malicious.some(B=>(0,g.$hp)(s.identifier,B)))throw new w.$To(y.localize(1,null,s.identifier.id),w.ExtensionManagementErrorCode.Malicious);const j=N.deprecated[s.identifier.id.toLowerCase()];if(j?.extension?.autoMigrate){if(this.F.info(`The '${s.identifier.id}' extension is deprecated, fetching the compatible '${j.extension.id}' extension instead.`),O=(await this.z.getExtensions([{id:j.extension.id,preRelease:j.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:S},P.CancellationToken.None))[0],!O)throw new w.$To(y.localize(2,null,s.identifier.id,j.extension.id),w.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(s)){const B=await this.getTargetPlatform();throw new w.$To(y.localize(3,null,s.identifier.id,this.G.nameLong,(0,w.$Mo)(B)),w.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(O=await this.O(s,i,v,S),!O)throw!v&&s.properties.isPreReleaseVersion&&(await this.z.getExtensions([s.identifier],P.CancellationToken.None))[0]?new w.$To(y.localize(4,null,s.displayName??s.identifier.id),w.ExtensionManagementErrorCode.ReleaseVersionNotFound):new w.$To(y.localize(5,null,s.identifier.id,this.G.nameLong,this.G.version),w.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",O.identifier.id);const I=await this.z.getManifest(O,P.CancellationToken.None);if(I===null)throw new w.$To(`Missing manifest for extension ${O.identifier.id}`,w.ExtensionManagementErrorCode.Invalid);if(I.version!==O.version)throw new w.$To(`Cannot install '${O.identifier.id}' extension because of version mismatch in Marketplace`,w.ExtensionManagementErrorCode.Invalid);return{extension:O,manifest:I}}async O(s,i,v,S){const O=await this.getTargetPlatform();let N=null;return!i&&s.hasPreReleaseVersion&&s.properties.isPreReleaseVersion!==v&&(N=(await this.z.getExtensions([{...s.identifier,preRelease:v}],{targetPlatform:O,compatible:!0,productVersion:S},P.CancellationToken.None))[0]||null),!N&&await this.z.isExtensionCompatible(s,v,O,S)&&(N=s),N||(i?N=(await this.z.getExtensions([{...s.identifier,version:s.version}],{targetPlatform:O,compatible:!0,productVersion:S},P.CancellationToken.None))[0]||null:N=await this.z.getCompatibleExtension(s,v,O,S)),N}async P(s,i){const v={...i,profileLocation:s.isApplicationScoped?this.H.defaultProfile.extensionsResource:i.profileLocation??this.X()},S=Z=>`${Z.id.toLowerCase()}${v.versionOnly?`-${s.manifest.version}`:""}${v.profileLocation?`@${v.profileLocation.toString()}`:""}`,O=this.m.get(S(s.identifier));if(O)return this.F.info("Extensions is already requested to uninstall",s.identifier.id),O.waitUntilTaskIsFinished();const N=Z=>{const he=this.Z(Z,v);return this.m.set(S(he.extension.identifier),he),v.profileLocation?this.F.info("Uninstalling extension from the profile:",`${Z.identifier.id}@${Z.manifest.version}`,v.profileLocation.toString()):this.F.info("Uninstalling extension:",`${Z.identifier.id}@${Z.manifest.version}`),this.t.fire({identifier:Z.identifier,profileLocation:v.profileLocation,applicationScoped:Z.isApplicationScoped}),he},j=(Z,he)=>{he?v.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${Z.identifier.id}@${Z.manifest.version}`,v.profileLocation.toString(),he.message):this.F.error("Failed to uninstall extension:",`${Z.identifier.id}@${Z.manifest.version}`,he.message):v.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${Z.identifier.id}@${Z.manifest.version}`,v.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${Z.identifier.id}@${Z.manifest.version}`),a(this.C,"extensionGallery:uninstall",{extensionData:(0,g.$op)(Z),error:he}),this.u.fire({identifier:Z.identifier,error:he?.code,profileLocation:v.profileLocation,applicationScoped:Z.isApplicationScoped})},I=[],B=[];try{I.push(N(s));const Z=await this.getInstalled(1,v.profileLocation);if(v.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${s.identifier.id}@${s.manifest.version}`);else{const he=this.S(s,Z);for(const ae of he)this.m.has(S(ae.identifier))?this.F.info("Extensions is already requested to uninstall",ae.identifier.id):I.push(N(ae))}v.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${s.identifier.id}@${s.manifest.version}`):this.Q(I.map(he=>he.extension),Z,s),await this.L(I.map(async he=>{try{if(await he.run(),await this.L(this.y.map(ae=>ae.postUninstall(he.extension,v,P.CancellationToken.None))),he.extension.identifier.uuid)try{await this.z.reportStatistic(he.extension.manifest.publisher,he.extension.manifest.name,he.extension.manifest.version,"uninstall")}catch{}j(he.extension)}catch(ae){const ee=ae instanceof w.$To?ae:new w.$To((0,D.$0)(ae),w.ExtensionManagementErrorCode.Internal);throw j(he.extension,ee),ee}finally{B.push(he)}}))}catch(Z){const he=Z instanceof w.$To?Z:new w.$To((0,D.$0)(Z),w.ExtensionManagementErrorCode.Internal);for(const ae of I){try{ae.cancel()}catch{}B.includes(ae)||j(ae.extension,he)}throw he}finally{for(const Z of I)this.m.delete(S(Z.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",Z.extension.identifier.id)}}Q(s,i,v){for(const S of s){const O=this.U(S,i);if(O.length){const N=O.filter(j=>!s.some(I=>(0,g.$hp)(I.identifier,j.identifier)));if(N.length)throw new Error(this.R(S,N,v))}}}R(s,i,v){return v===s?i.length===1?y.localize(6,null,v.manifest.displayName||v.manifest.name,i[0].manifest.displayName||i[0].manifest.name):i.length===2?y.localize(7,null,v.manifest.displayName||v.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):y.localize(8,null,v.manifest.displayName||v.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):i.length===1?y.localize(9,null,v.manifest.displayName||v.manifest.name,s.manifest.displayName||s.manifest.name,i[0].manifest.displayName||i[0].manifest.name):i.length===2?y.localize(10,null,v.manifest.displayName||v.manifest.name,s.manifest.displayName||s.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):y.localize(11,null,v.manifest.displayName||v.manifest.name,s.manifest.displayName||s.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name)}S(s,i,v=[]){if(v.indexOf(s)!==-1)return[];v.push(s);const S=s.manifest.extensionPack?s.manifest.extensionPack:[];if(S.length){const O=i.filter(j=>!j.isBuiltin&&S.some(I=>(0,g.$hp)({id:I},j.identifier))),N=[];for(const j of O)N.push(...this.S(j,i,v));return[...O,...N]}return[]}U(s,i){return i.filter(v=>v.manifest.extensionDependencies&&v.manifest.extensionDependencies.some(S=>(0,g.$hp)({id:S},s.identifier)))}async W(){try{return this.F.trace("ExtensionManagementService.updateControlCache"),await this.z.getExtensionsControlManifest()}catch(s){return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,D.$0)(s)),{malicious:[],deprecated:{},search:[]}}}};e.$0p=f,e.$0p=f=Fe([Ne(0,w.$So),Ne(1,u.$Nl),Ne(2,p.$ml),Ne(3,c.$Oj),Ne(4,m.$8j),Ne(5,h.$ol)],f);function l(r){const s=Array.isArray(r)?r:[r];return s.length===1?s[0]instanceof Error?s[0]:new Error(s[0]):s.reduce((i,v)=>new Error(`${i.message}${i.message?",":""}${v instanceof Error?v.message:v}`),new Error(""))}function t(r){if(r instanceof w.$To)return r;if(r instanceof w.$Uo){const i=new w.$To(r.message,w.ExtensionManagementErrorCode.Gallery);return i.stack=r.stack,i}const s=new w.$To(r.message,w.ExtensionManagementErrorCode.Internal);return s.stack=r.stack,s}function a(r,s,{extensionData:i,verificationStatus:v,duration:S,error:O,durationSinceUpdate:N}){let j,I;(0,$.$4f)(v)&&(v===!0?v="Verified":(v===!1||(j=w.ExtensionManagementErrorCode.Signature,I=v),v="Unverified")),O&&(O instanceof w.$To||O instanceof w.$Uo?(j=O.code,O.code===w.ExtensionManagementErrorCode.Signature&&(I=O.message)):j=w.ExtensionManagementErrorCode.Internal),r.publicLog(s,{...i,verificationStatus:v,success:!O,duration:S,errorcode:j,errorcodeDetail:I,durationSinceUpdate:N})}class o{constructor(){this.d=new A.$hh}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,A.$8g)(s=>this.h(s))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,A.$8g)(s=>new Promise((i,v)=>{const S=s.onCancellationRequested(()=>{S.dispose(),v(new D.$5)})})),this.d.open()),this.g.cancel()}}e.$aq=o}),define(Ee[49],ke([1,0,15,14,2,6,24,3,31,36,16,5,13,33,34,11,10,29]),function(ce,e,n,A,P,D,C,k,b,$,E,y,w,g,d,c,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=e.$cq=e.$bq=e.ExtensionsProfileScanningErrorCode=void 0;var p;(function(a){a.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",a.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(p||(e.ExtensionsProfileScanningErrorCode=p={}));class h extends Error{constructor(o,r){super(o),this.code=r}}e.$bq=h,e.$cq=(0,y.$ii)("IExtensionsProfileScannerService");let f=class extends P.$Uc{constructor(o,r,s,i,v,S){super(),this.j=o,this.m=r,this.n=s,this.r=i,this.s=v,this.t=S,this.b=this.B(new D.$7d),this.onAddExtensions=this.b.event,this.c=this.B(new D.$7d),this.onDidAddExtensions=this.c.event,this.f=this.B(new D.$7d),this.onRemoveExtensions=this.f.event,this.g=this.B(new D.$7d),this.onDidRemoveExtensions=this.g.event,this.h=new C.$Bc}scanProfileExtensions(o,r){return this.u(o,void 0,r)}async addExtensionsToProfile(o,r,s){const i=[],v=[];try{return await this.u(r,S=>{const O=[];if(s)O.push(...S);else for(const N of S)o.some(([j])=>(0,$.$hp)(j.identifier,N.identifier)&&j.manifest.version!==N.version)?i.push(N):O.push(N);for(const[N,j]of o){const I=O.findIndex(Z=>(0,$.$hp)(Z.identifier,N.identifier)&&Z.version===N.manifest.version),B={identifier:N.identifier,version:N.manifest.version,location:N.location,metadata:j};I===-1?(v.push(B),O.push(B)):O.splice(I,1,B)}return v.length&&this.b.fire({extensions:v,profileLocation:r}),i.length&&this.f.fire({extensions:i,profileLocation:r}),O}),v.length&&this.c.fire({extensions:v,profileLocation:r}),i.length&&this.g.fire({extensions:i,profileLocation:r}),v}catch(S){throw v.length&&this.c.fire({extensions:v,error:S,profileLocation:r}),i.length&&this.g.fire({extensions:i,error:S,profileLocation:r}),S}}async updateMetadata(o,r){const s=[];return await this.u(r,i=>{const v=[];for(const S of i){const O=o.find(([N])=>(0,$.$hp)(N.identifier,S.identifier)&&N.manifest.version===S.version);O&&(S.metadata={...S.metadata,...O[1]},s.push(S)),v.push(S)}return v}),s}async removeExtensionFromProfile(o,r){const s=[];try{await this.u(r,i=>{const v=[];for(const S of i)(0,$.$hp)(S.identifier,o.identifier)?s.push(S):v.push(S);return s.length&&this.f.fire({extensions:s,profileLocation:r}),v}),s.length&&this.g.fire({extensions:s,profileLocation:r})}catch(i){throw s.length&&this.g.fire({extensions:s,error:i,profileLocation:r}),i}}async u(o,r,s){return this.F(o).queue(async()=>{let i=[],v;try{const S=await this.m.readFile(o);v=JSON.parse(S.value.toString().trim()||"[]")}catch(S){if((0,E.$6k)(S)!==1)throw S;if(this.r.extUri.isEqual(o,this.n.defaultProfile.extensionsResource)&&(v=await this.D()),!v&&s?.bailOutWhenFileNotFound)throw new h((0,m.$0)(S),"ERROR_PROFILE_NOT_FOUND")}if(v){Array.isArray(v)||this.w(o);let S=!1;for(const O of v){l(O)||this.w(o);let N;if((0,c.$Vf)(O.relativeLocation)&&O.relativeLocation)N=this.z(O.relativeLocation);else if((0,c.$Vf)(O.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${O.location}`);continue}else{N=k.URI.revive(O.location);const j=this.y(N);j&&(S=!0,O.relativeLocation=j)}(0,c.$3f)(O.metadata?.hasPreReleaseVersion)&&O.metadata?.preRelease&&(S=!0,O.metadata.hasPreReleaseVersion=!0),i.push({identifier:O.identifier,location:N,version:O.version,metadata:O.metadata})}S&&await this.m.writeFile(o,A.$ue.fromString(JSON.stringify(v)))}if(r){i=r(i);const S=i.map(O=>({identifier:O.identifier,version:O.version,location:O.location.toJSON(),relativeLocation:this.y(O.location),metadata:O.metadata}));await this.m.writeFile(o,A.$ue.fromString(JSON.stringify(S)))}return i})}w(o){const r=new h(`Invalid extensions content in ${o.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:r.code}),r}y(o){return this.r.extUri.isEqual(this.r.extUri.dirname(o),this.j)?this.r.extUri.basename(o):void 0}z(o){return this.r.extUri.joinPath(this.j,o)}async D(){return this.C||(this.C=(async()=>{const o=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),r=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let s;try{s=(await this.m.readFile(o)).value.toString()}catch(v){if((0,E.$6k)(v)===1)return;throw v}this.t.info("Migrating extensions from old default profile location",o.toString());let i;try{const v=JSON.parse(s);Array.isArray(v)&&v.every(S=>l(S))?i=v:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",v)}catch(v){this.t.error(v)}if(i)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,A.$ue.fromString(JSON.stringify(i)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",o.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(v){if((0,E.$6k)(v)===3)this.t.info("Migration from old default profile location to new location is done by another window",o.toString(),this.n.defaultProfile.extensionsResource.toString());else throw v}try{await this.m.del(o)}catch(v){(0,E.$6k)(v)!==1&&this.t.error(v)}try{await this.m.del(r)}catch(v){(0,E.$6k)(v)!==1&&this.t.error(v)}return i})()),this.C}F(o){let r=this.h.get(o);return r||(r=new n.$ph,this.h.set(o,r)),r}};e.$dq=f,e.$dq=f=Fe([Ne(1,E.$Ok),Ne(2,g.$ol),Ne(3,d.$ml),Ne(4,u.$Nl),Ne(5,w.$Oj)],f);function l(a){return(0,c.$Xf)(a)&&(0,b.$Ro)(a.identifier)&&(t(a.location)||(0,c.$Vf)(a.location)&&a.location)&&((0,c.$3f)(a.relativeLocation)||(0,c.$Vf)(a.relativeLocation))&&a.version&&(0,c.$Vf)(a.version)}function t(a){return a?(0,c.$Vf)(a.path)&&(0,c.$Vf)(a.scheme):!1}}),define(Ee[59],ke([1,0,18,15,21,14,10,42,176,2,12,7,4,19,56,65,11,3,189,26,36,35,81,16,5,13,32,6,53,49,33,34,220]),function(ce,e,n,A,P,D,C,k,b,$,E,y,w,g,d,c,m,u,p,h,f,l,t,a,o,r,s,i,v,S,O,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kq=e.$iq=e.$hq=e.$gq=e.Translations=void 0,e.$jq=ee;var I;(function(z){function T(J,Y){if(J===Y)return!0;const W=Object.keys(J),re=new Set;for(const ue of Object.keys(Y))re.add(ue);if(W.length!==re.size)return!1;for(const ue of W){if(J[ue]!==Y[ue])return!1;re.delete(ue)}return re.size===0}z.equals=T})(I||(e.Translations=I={})),e.$gq=(0,o.$ii)("IExtensionsScannerService");let B=class extends $.$Uc{constructor(T,J,Y,W,re,ue,ie,$e,ne,U,R,q){super(),this.systemExtensionsLocation=T,this.userExtensionsLocation=J,this.r=Y,this.s=W,this.t=re,this.u=ue,this.w=ie,this.y=$e,this.z=ne,this.C=U,this.D=R,this.F=q,this.g=this.B(new i.$7d),this.onDidChangeCache=this.g.event,this.h=(0,g.$Vg)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(ae,this.s,this.h)),this.m=this.B(this.F.createInstance(ae,this.s,this.h)),this.n=this.B(this.F.createInstance(he,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,f.$sp)(this.w,this.y)),this.G}async scanAllExtensions(T,J,Y){const[W,re]=await Promise.all([this.scanSystemExtensions(T),this.scanUserExtensions(J)]),ue=Y?await this.scanExtensionsUnderDevelopment(T,[...W,...re]):[];return this.L(W,re,ue,await this.getTargetPlatform(),!0)}async scanSystemExtensions(T){const J=[];J.push(this.M(!!T.useCache,T.language)),J.push(this.N(T.language,!!T.checkControlFile));const[Y,W]=await Promise.all(J);return this.J([...Y,...W],0,T,!1)}async scanUserExtensions(T){const J=T.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",J);const Y=this.D.extUri.isEqual(T.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,W=await this.P(J,!!T.profileLocation,1,!T.includeUninstalled,T.language,!0,Y,T.productVersion??this.R()),re=T.useCache&&!W.devMode&&W.excludeObsolete?this.m:this.n;let ue;try{ue=await re.scanExtensions(W)}catch(ie){if(ie instanceof S.$bq&&ie.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),ue=await re.scanExtensions(W);else throw ie}return ue=await this.J(ue,1,T,!0),this.y.trace("Scanned user extensions:",ue.length),ue}async scanExtensionsUnderDevelopment(T,J){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const Y=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(W=>W.scheme===E.Schemas.file).map(async W=>{const re=await this.P(W,!1,1,!0,T.language,!1,void 0,T.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(re)).map(ie=>(ie.type=J.find($e=>(0,f.$hp)($e.identifier,ie.identifier))?.type??ie.type,this.n.validate(ie,re)))}))).flat();return this.J(Y,"development",T,!0)}return[]}async scanExistingExtension(T,J,Y){const W=await this.P(T,!1,J,!0,Y.language,!0,void 0,Y.productVersion??this.R()),re=await this.n.scanExtension(W);return!re||!Y.includeInvalid&&!re.isValid?null:re}async scanOneOrMultipleExtensions(T,J,Y){const W=await this.P(T,!1,J,!0,Y.language,!0,void 0,Y.productVersion??this.R()),re=await this.n.scanOneOrMultipleExtensions(W);return this.J(re,J,Y,!0)}async scanMultipleExtensions(T,J,Y){const W=[];return await Promise.all(T.map(async re=>{const ue=await this.scanOneOrMultipleExtensions(re,J,Y);W.push(...ue)})),this.J(W,J,Y,!0)}async scanMetadata(T){const J=(0,g.$Vg)(T,"package.json"),Y=(await this.w.readFile(J)).value.toString();return JSON.parse(Y).__metadata}async updateMetadata(T,J){const Y=(0,g.$Vg)(T,"package.json"),W=(await this.w.readFile(Y)).value.toString(),re=JSON.parse(W);J.isMachineScoped===!1&&delete J.isMachineScoped,J.isBuiltin===!1&&delete J.isBuiltin,re.__metadata={...re.__metadata,...J},await this.w.writeFile((0,g.$Vg)(T,"package.json"),D.$ue.fromString(JSON.stringify(re,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(T){if(T instanceof S.$bq&&T.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw T}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const T=await this.scanUserExtensions({includeInvalid:!0});if(T.length)await this.u.addExtensionsToProfile(T.map(J=>[J,J.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,D.$ue.fromString(JSON.stringify([])))}catch(J){(0,a.$6k)(J)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,C.$0)(J))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(T){this.y.error(T)}finally{this.H=void 0}})()),this.H}async J(T,J,Y,W){return Y.includeAllVersions||(T=this.L(J===0?T:void 0,J===1?T:void 0,J==="development"?T:void 0,await this.getTargetPlatform(),W)),Y.includeInvalid||(T=T.filter(re=>re.isValid)),T.sort((re,ue)=>{const ie=y.$oc(re.location.fsPath),$e=y.$oc(ue.location.fsPath);return ie<$e?-1:ie>$e?1:0})}L(T,J,Y,W,re){const ue=($e,ne,U)=>{if($e.isValid&&!ne.isValid)return!1;if($e.isValid===ne.isValid){if(re&&d.gt($e.manifest.version,ne.manifest.version))return this.y.debug(`Skipping extension ${ne.location.path} with lower version ${ne.manifest.version} in favour of ${$e.location.path} with version ${$e.manifest.version}`),!1;if(d.eq($e.manifest.version,ne.manifest.version)){if($e.type===0)return this.y.debug(`Skipping extension ${ne.location.path} in favour of system extension ${$e.location.path} with same version`),!1;if($e.targetPlatform===W)return this.y.debug(`Skipping extension ${ne.location.path} from different target platform ${ne.targetPlatform}`),!1}}return U?this.y.warn(`Overwriting user extension ${$e.location.path} with ${ne.location.path}.`):this.y.debug(`Overwriting user extension ${$e.location.path} with ${ne.location.path}.`),!0},ie=new l.$Gm;return T?.forEach($e=>{const ne=ie.get($e.identifier.id);(!ne||ue(ne,$e,!1))&&ie.set($e.identifier.id,$e)}),J?.forEach($e=>{const ne=ie.get($e.identifier.id);if(!ne&&T&&$e.type===0){this.y.debug(`Skipping obsolete system extension ${$e.location.path}.`);return}(!ne||ue(ne,$e,!1))&&ie.set($e.identifier.id,$e)}),Y?.forEach($e=>{const ne=ie.get($e.identifier.id);(!ne||ue(ne,$e,!0))&&ie.set($e.identifier.id,$e),ie.set($e.identifier.id,$e)}),[...ie.values()]}async M(T,J){this.y.trace("Started scanning system extensions");const Y=await this.P(this.systemExtensionsLocation,!1,0,!0,J,!0,void 0,this.R()),re=await(T&&!Y.devMode?this.j:this.n).scanExtensions(Y);return this.y.trace("Scanned system extensions:",re.length),re}async N(T,J){const Y=this.z.isBuilt?[]:this.C.builtInExtensions;if(!Y?.length)return[];this.y.trace("Started scanning dev system extensions");const W=J?await this.O():{},re=[],ue=u.URI.file(y.$ic(y.$kc(E.$Cg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const $e of Y){const ne=W[$e.name]||"marketplace";switch(ne){case"disabled":break;case"marketplace":re.push((0,g.$Vg)(ue,$e.name));break;default:re.push(u.URI.file(ne));break}}const ie=await Promise.all(re.map(async $e=>this.n.scanExtension(await this.P($e,!1,0,!0,T,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",ie.length),(0,n.$Hb)(ie)}async O(){try{const T=await this.w.readFile(this.r);return JSON.parse(T.value.toString())}catch{return{}}}async P(T,J,Y,W,re,ue,ie,$e){const ne=await this.f(re??w.$q),U=await this.Q(T),R=J&&!this.D.extUri.isEqual(T,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,q=R?await this.Q(R):void 0;return new Z(T,U,R,q,J,ie,Y,W,ue,$e.version,$e.date,this.C.commit,!this.z.isBuilt,re,ne)}async Q(T){try{const J=await this.w.stat(T);if(typeof J.mtime=="number")return J.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$hq=B,e.$hq=B=Fe([Ne(4,O.$ol),Ne(5,S.$cq),Ne(6,a.$Ok),Ne(7,r.$Oj),Ne(8,h.$pi),Ne(9,s.$8j),Ne(10,N.$ml),Ne(11,o.$hi)],B);class Z{constructor(T,J,Y,W,re,ue,ie,$e,ne,U,R,q,X,le,Q){this.location=T,this.mtime=J,this.applicationExtensionslocation=Y,this.applicationExtensionslocationMtime=W,this.profile=re,this.profileScanOptions=ue,this.type=ie,this.excludeObsolete=$e,this.validate=ne,this.productVersion=U,this.productDate=R,this.productCommit=q,this.devMode=X,this.language=le,this.translations=Q}static createNlsConfiguration(T){return{language:T.language,pseudo:T.language==="pseudo",devMode:T.devMode,translations:T.translations}}static equals(T,J){return(0,g.$Og)(T.location,J.location)&&T.mtime===J.mtime&&(0,g.$Og)(T.applicationExtensionslocation,J.applicationExtensionslocation)&&T.applicationExtensionslocationMtime===J.applicationExtensionslocationMtime&&T.profile===J.profile&&P.$Tn(T.profileScanOptions,J.profileScanOptions)&&T.type===J.type&&T.excludeObsolete===J.excludeObsolete&&T.validate===J.validate&&T.productVersion===J.productVersion&&T.productDate===J.productDate&&T.productCommit===J.productCommit&&T.devMode===J.devMode&&T.language===J.language&&I.equals(T.translations,J.translations)}}e.$iq=Z;let he=class extends $.$Uc{constructor(T,J,Y,W,re){super(),this.f=T,this.g=J,this.h=Y,this.j=W,this.m=re}async scanExtensions(T){const J=T.profile?await this.r(T):await this.n(T);let Y={};if(T.excludeObsolete&&T.type===1)try{const W=(await this.j.readFile(this.f)).value.toString();Y=JSON.parse(W)}catch{}return(0,m.$9f)(Y)?J:J.filter(W=>!Y[f.$ip.create(W).toString()])}async n(T){const J=await this.j.resolve(T.location);if(!J.children?.length)return[];const Y=await Promise.all(J.children.map(async W=>{if(!W.isDirectory||T.type===1&&(0,g.$Sg)(W.resource).indexOf(".")===0)return null;const re=new Z(W.resource,T.mtime,T.applicationExtensionslocation,T.applicationExtensionslocationMtime,T.profile,T.profileScanOptions,T.type,T.excludeObsolete,T.validate,T.productVersion,T.productDate,T.productCommit,T.devMode,T.language,T.translations);return this.scanExtension(re)}));return(0,n.$Hb)(Y).sort((W,re)=>W.location.path<re.location.path?-1:1)}async r(T){let J=await this.s(T.location,()=>!0,T);if(T.applicationExtensionslocation&&!this.h.extUri.isEqual(T.location,T.applicationExtensionslocation)){J=J.filter(W=>!W.metadata?.isApplicationScoped);const Y=await this.s(T.applicationExtensionslocation,W=>!!W.metadata?.isBuiltin||!!W.metadata?.isApplicationScoped,T);J.push(...Y)}return J}async s(T,J,Y){const W=await this.g.scanProfileExtensions(T,Y.profileScanOptions);if(!W.length)return[];const re=await Promise.all(W.map(async ue=>{if(J(ue)){const ie=new Z(ue.location,Y.mtime,Y.applicationExtensionslocation,Y.applicationExtensionslocationMtime,Y.profile,Y.profileScanOptions,Y.type,Y.excludeObsolete,Y.validate,Y.productVersion,Y.productDate,Y.productCommit,Y.devMode,Y.language,Y.translations);return this.scanExtension(ie,ue.metadata)}return null}));return(0,n.$Hb)(re)}async scanOneOrMultipleExtensions(T){try{if(await this.j.exists((0,g.$Vg)(T.location,"package.json"))){const J=await this.scanExtension(T);return J?[J]:[]}else return await this.scanExtensions(T)}catch(J){return this.m.error(`Error scanning extensions at ${T.location.path}:`,(0,C.$0)(J)),[]}}async scanExtension(T,J){try{let Y=await this.scanExtensionManifest(T.location);if(Y){Y.publisher||(Y.publisher=l.$Am),J=J??Y.__metadata,delete Y.__metadata;const W=(0,f.$mp)(Y.publisher,Y.name),re=J?.id?{id:W,uuid:J.id}:{id:W},ue=J?.isSystem?0:T.type,ie=ue===0||!!J?.isBuiltin;Y=await this.t(T.location,Y,Z.createNlsConfiguration(T));const $e={type:ue,identifier:re,manifest:Y,location:T.location,isBuiltin:ie,targetPlatform:J?.targetPlatform??"undefined",metadata:J,isValid:!0,validations:[]};return T.validate?this.validate($e,T):$e}}catch(Y){T.type!==0&&this.m.error(Y)}return null}validate(T,J){let Y=!0;const W=(0,t.$xp)(J.productVersion,J.productDate,J.location,T.manifest,T.isBuiltin);for(const[re,ue]of W)re===c.default.Error&&(Y=!1,this.m.error(this.z(J.location,ue)));return T.isValid=Y,T.validations=W,T}async scanExtensionManifest(T){const J=(0,g.$Vg)(T,"package.json");let Y;try{Y=(await this.j.readFile(J)).value.toString()}catch(re){return(0,a.$6k)(re)!==1&&this.m.error(this.z(T,(0,p.localize)(0,null,J.path,re.message))),null}let W;try{W=JSON.parse(Y)}catch{const ue=[];(0,k.$wn)(Y,ue);for(const ie of ue)this.m.error(this.z(T,(0,p.localize)(1,null,J.path,ie.offset,ie.length,(0,b.$eq)(ie.error))));return null}return(0,k.$Fn)(W)!=="object"?(this.m.error(this.z(T,(0,p.localize)(2,null,J.path))),null):W}async t(T,J,Y){const W=await this.u(T,J,Y);if(W)try{const re=[],ue=await this.w(W.default,re);if(re.length>0)return re.forEach($e=>{this.m.error(this.z(T,(0,p.localize)(3,null,W.default?.path,(0,b.$eq)($e.error))))}),J;if((0,k.$Fn)(W)!=="object")return this.m.error(this.z(T,(0,p.localize)(4,null,W.default?.path))),J;const ie=W.values||Object.create(null);return(0,j.$fq)(this.m,J,ie,ue)}catch{}return J}async u(T,J,Y){const W=(0,g.$Vg)(T,"package.nls.json"),re=(ne,U)=>{U.forEach(R=>{this.m.error(this.z(T,(0,p.localize)(5,null,ne?.path,(0,b.$eq)(R.error))))})},ue=ne=>{this.m.error(this.z(T,(0,p.localize)(6,null,ne?.path)))},ie=`${J.publisher}.${J.name}`,$e=Y.translations[ie];if($e)try{const ne=u.URI.file($e),U=(await this.j.readFile(ne)).value.toString(),R=[],q=(0,k.$wn)(U,R);return R.length>0?(re(ne,R),{values:void 0,default:W}):(0,k.$Fn)(q)!=="object"?(ue(ne),{values:void 0,default:W}):{values:q.contents?q.contents.package:void 0,default:W}}catch{return{values:void 0,default:W}}else{if(!await this.j.exists(W))return;let U;try{U=await this.y(T,Y)}catch{return}if(!U.localized)return{values:void 0,default:U.original};try{const R=(await this.j.readFile(U.localized)).value.toString(),q=[],X=(0,k.$wn)(R,q);return q.length>0?(re(U.localized,q),{values:void 0,default:U.original}):(0,k.$Fn)(X)!=="object"?(ue(U.localized),{values:void 0,default:U.original}):{values:X,default:U.original}}catch{return{values:void 0,default:U.original}}}}async w(T,J){if(T)try{const Y=(await this.j.readFile(T)).value.toString();return(0,k.$wn)(Y,J)}catch{}}y(T,J){return new Promise((Y,W)=>{const re=ue=>{const ie=(0,g.$Vg)(T,`package.nls.${ue}.json`);this.j.exists(ie).then($e=>{$e&&Y({localized:ie,original:(0,g.$Vg)(T,"package.nls.json")});const ne=ue.lastIndexOf("-");ne===-1?Y({localized:(0,g.$Vg)(T,"package.nls.json"),original:null}):(ue=ue.substring(0,ne),re(ue))})};if(J.devMode||J.pseudo||!J.language)return Y({localized:(0,g.$Vg)(T,"package.nls.json"),original:null});re(J.language)})}z(T,J){return`[${T.path}]: ${J}`}};he=Fe([Ne(1,S.$cq),Ne(2,N.$ml),Ne(3,a.$Ok),Ne(4,r.$Oj)],he);let ae=class extends he{constructor(T,J,Y,W,re,ue,ie){super(J,W,re,ue,ie),this.G=T,this.H=Y,this.D=this.B(new A.$gh(3e3)),this.F=this.B(new i.$7d),this.onDidChangeCache=this.F.event}async scanExtensions(T){const J=this.M(T),Y=await this.I(J);if(this.C=T,Y&&Y.input&&Z.equals(Y.input,this.C))return this.m.debug("Using cached extensions scan result",T.location.toString()),this.D.trigger(()=>this.L()),Y.result.map(re=>(re.location=u.URI.revive(re.location),re));const W=await super.scanExtensions(T);return await this.J(J,{input:T,result:W}),W}async I(T){try{const J=await this.j.readFile(T),Y=JSON.parse(J.value.toString());return{result:Y.result,input:(0,v.$Rh)(Y.input)}}catch(J){this.m.debug("Error while reading the extension cache file:",T.path,(0,C.$0)(J))}return null}async J(T,J){try{await this.j.writeFile(T,D.$ue.fromString(JSON.stringify(J)))}catch(Y){this.m.debug("Error while writing the extension cache file:",T.path,(0,C.$0)(Y))}}async L(){if(!this.C)return;const T=this.M(this.C),J=await this.I(T);if(!J)return;const Y=J.result,W=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!P.$Tn(W,Y))try{this.m.info("Invalidating Cache",Y,W),await this.j.del(T),this.F.fire()}catch(re){this.m.error(re)}}M(T){const J=this.N(T);return this.h.extUri.joinPath(J.cacheHome,T.type===0?l.$zm:l.$ym)}N(T){return T.type===0?this.H.defaultProfile:T.profile?this.h.extUri.isEqual(T.location,this.G.extensionsResource)?this.G:this.H.profiles.find(J=>this.h.extUri.isEqual(T.location,J.extensionsResource))??this.G:this.H.defaultProfile}};ae=Fe([Ne(2,O.$ol),Ne(3,S.$cq),Ne(4,N.$ml),Ne(5,a.$Ok),Ne(6,r.$Oj)],ae);function ee(z,T){const J=(0,f.$kp)(z.manifest.publisher,z.manifest.name);return{id:J,identifier:new l.$Em(J),isBuiltin:z.type===0,isUserBuiltin:z.type===1&&z.isBuiltin,isUnderDevelopment:T,extensionLocation:z.location,uuid:z.identifier.uuid,targetPlatform:z.targetPlatform,...z.manifest}}class _ extends B{constructor(T,J,Y,W,re,ue,ie,$e,ne,U,R,q){super(T,J,(0,g.$Vg)(Y,".vscode-oss-dev","extensions","control.json"),W,re,ue,ie,$e,ne,U,R,q),this.S=(async()=>{if(w.$t)try{const X=await this.w.readFile(u.URI.file(w.$t));return JSON.parse(X.value.toString())}catch{}return Object.create(null)})()}f(T){return this.S}}e.$kq=_}),define(Ee[267],ke([1,0,55,15,40,6,2,12,7,23,13,33]),function(ce,e,n,A,P,D,C,k,b,$,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mq=void 0;let w=class extends C.$Uc{constructor(d,c){super(),this.b=d,this.f=c,this.a=new A.$oh(5)}async postUninstall(d){const c=this.g(d,"uninstall");c&&(this.f.info(d.identifier.id,d.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(c.script,"uninstall",c.args,!0,d),this.f.info("Finished running post uninstall script",d.identifier.id,d.manifest.version)}catch(m){this.f.error("Failed to run post uninstall script",d.identifier.id,d.manifest.version),this.f.error(m)}}));try{await $.Promises.rm(this.m(d))}catch(m){this.f.error("Error while removing extension storage path",d.identifier.id),this.f.error(m)}}g(d,c){const m=`vscode:${c}`;if(d.location.scheme===k.Schemas.file&&d.manifest&&d.manifest.scripts&&typeof d.manifest.scripts[m]=="string"){const u=d.manifest.scripts[m].split(" ");return u.length<2||u[0]!=="node"||!u[1]?(this.f.warn(d.identifier.id,d.manifest.version,`${m} should be a node script`),null):{script:(0,b.$kc)(d.location.fsPath,u[1]),args:u.slice(2)||[]}}return null}h(d,c,m,u,p){return new Promise((h,f)=>{const l=this.j(d,c,m,p);let t;const a=o=>{t&&(clearTimeout(t),t=null),o?f(o):h(void 0)};l.on("error",o=>{a((0,P.$6i)(o)||"Unknown")}),l.on("exit",(o,r)=>{a(o?`post-${c} process exited with code ${o}`:void 0)}),u&&(t=setTimeout(()=>{t=null,l.kill(),f("timed out")},5e3))})}j(d,c,m,u){const p={silent:!0,execArgv:void 0},h=(0,n.fork)(d,[`--type=extension-post-${c}`,...m],p);h.stdout.setEncoding("utf8"),h.stderr.setEncoding("utf8");const f=D.Event.fromNodeEventEmitter(h.stdout,"data"),l=D.Event.fromNodeEventEmitter(h.stderr,"data");f(o=>this.f.info(u.identifier.id,u.manifest.version,`post-${c}`,o)),l(o=>this.f.error(u.identifier.id,u.manifest.version,`post-${c}`,o));const t=D.Event.any(D.Event.map(f,o=>({data:`%c${o}`,format:[""]})),D.Event.map(l,o=>({data:`%c${o}`,format:["color: red"]})));return D.Event.debounce(t,(o,r)=>o?{data:o.data+r.data,format:[...o.format,...r.format]}:{data:r.data,format:r.format},100)(o=>{console.group(u.identifier.id),console.log(o.data,...o.format),console.groupEnd()}),h}m(d){return(0,b.$kc)(this.b.defaultProfile.globalStorageHome.fsPath,d.identifier.id.toLowerCase())}};e.$mq=w,e.$mq=w=Fe([Ne(0,y.$ol),Ne(1,E.$Oj)],w)}),define(Ee[128],ke([1,0,15,14,20,40,10,6,64,2,24,12,7,19,56,11,3,22,23,80,190,82,26,266,31,36,49,59,250,267,221,241,251,81,16,5,13,32,29,34,33]),function(ce,e,n,A,P,D,C,k,b,$,E,y,w,g,d,c,m,u,p,h,f,l,t,a,o,r,s,i,v,S,O,N,j,I,B,Z,he,ae,ee,_,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tq=e.$sq=e.$rq=e.$qq=void 0,e.$qq=(0,Z.$ji)(o.$Vo);const T=".vsctmp";let J=class extends a.$0p{constructor(ne,U,R,q,X,le,Q,x,V,L,H,K){super(ne,U,H,R,L,K),this.eb=X,this.fb=le,this.gb=Q,this.hb=V,this.db=new Map,this.qb=new E.$Cc;const te=this.B(x.createInstance(S.$mq));this.ab=this.B(x.createInstance(Y,se=>te.postUninstall(se))),this.bb=this.B(new N.$oq(K,V,H,this,this.F)),this.cb=this.B(x.createInstance(v.$lq));const de=this.B(new j.$pq(this,this.eb,K,le,H,V,R));this.B(de.onDidChangeExtensionsByAnotherSource(se=>this.pb(se))),this.rb()}getTargetPlatform(){return this.ib||(this.ib=(0,r.$sp)(this.hb,this.F)),this.ib}async zip(ne){this.F.trace("ExtensionManagementService#zip",ne.identifier.id);const U=await this.ob(ne),R=await(0,h.zip)((0,g.$Vg)(this.cb.extensionsDownloadDir,(0,u.$Eg)()).fsPath,U);return m.URI.file(R)}async unzip(ne){return this.F.trace("ExtensionManagementService#unzip",ne.toString()),(await this.install(ne)).identifier}async getManifest(ne){const{location:U,cleanup:R}=await this.kb(ne),q=w.$lc(U.fsPath);try{return await(0,O.$nq)(q)}finally{await R()}}getInstalled(ne,U=this.H.defaultProfile.extensionsResource,R={version:this.G.version,date:this.G.date}){return this.ab.scanExtensions(ne??null,U,R)}scanAllUserInstalledExtensions(){return this.ab.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(ne){return this.ab.scanUserExtensionAtLocation(ne)}async install(ne,U={}){this.F.trace("ExtensionManagementService#install",ne.toString());const{location:R,cleanup:q}=await this.kb(ne);try{const X=await(0,O.$nq)(w.$lc(R.fsPath)),le=(0,r.$mp)(X.publisher,X.name);if(X.engines&&X.engines.vscode&&!(0,I.$zp)(X.engines.vscode,this.G.version,this.G.date))throw new Error(f.localize(0,null,le,this.G.version));const x=(await this.I([{manifest:X,extension:R,options:U}])).find(({identifier:V})=>(0,r.$hp)(V,{id:le}));if(x?.local)return x.local;throw x?.error?x.error:(0,a.$_p)(new Error(`Unknown error while installing extension ${le}`))}finally{await q()}}async installFromLocation(ne,U){this.F.trace("ExtensionManagementService#installFromLocation",ne.toString());const R=await this.ab.scanUserExtensionAtLocation(ne);if(!R||!R.manifest.name||!R.manifest.version)throw new Error(`Cannot find a valid extension from the location ${ne.toString()}`);return await this.tb([[R,{source:"resource"}]],U),this.F.info("Successfully installed extension",R.identifier.id,U.toString()),R}async installExtensionsFromProfile(ne,U,R){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",ne,U.toString(),R.toString());const q=(await this.getInstalled(1,U)).filter(X=>ne.some(le=>(0,r.$hp)(le,X.identifier)));if(q.length){const X=await Promise.all(q.map(le=>this.ab.scanMetadata(le,U)));await this.tb(q.map((le,Q)=>[le,X[Q]]),R),this.F.info("Successfully installed extensions",q.map(le=>le.identifier.id),R.toString())}return q}async updateMetadata(ne,U,R=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",ne.identifier.id),U.isPreReleaseVersion&&(U.preRelease=!0,U.hasPreReleaseVersion=!0),U.isMachineScoped===!1&&(U.isMachineScoped=void 0),U.isBuiltin===!1&&(U.isBuiltin=void 0),U.pinned===!1&&(U.pinned=void 0),ne=await this.ab.updateMetadata(ne,U,R),this.bb.invalidate(R),this.w.fire(ne),ne}async reinstallFromGallery(ne){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",ne.identifier.id),!this.z.isEnabled())throw new Error(f.localize(1,null));const U=await this.getTargetPlatform(),[R]=await this.z.getExtensions([{...ne.identifier,preRelease:ne.preRelease}],{targetPlatform:U,compatible:!0},P.CancellationToken.None);if(!R)throw new Error(f.localize(2,null));await this.ab.setUninstalled(ne);try{await this.ab.removeUninstalledExtension(ne)}catch(q){throw new Error(f.localize(3,null,(0,D.$6i)(q)))}return this.installFromGallery(R)}$(ne,U,R,q){return this.ab.copyExtension(ne,U,R,q)}copyExtensions(ne,U){return this.ab.copyExtensions(ne,U,{version:this.G.version,date:this.G.date})}markAsUninstalled(...ne){return this.ab.setUninstalled(...ne)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.ab.cleanUp()}catch(ne){this.F.error(ne)}}async download(ne,U,R){const{location:q}=await this.cb.download(ne,U,!R);return q}async kb(ne){if(ne.scheme===y.Schemas.file)return{location:ne,async cleanup(){}};this.F.trace("Downloading extension from",ne.toString());const U=(0,g.$Vg)(this.cb.extensionsDownloadDir,(0,u.$Eg)());return await this.gb.download(ne,U),this.F.info("Downloaded extension to",U.toString()),{location:U,cleanup:async()=>{try{await this.hb.del(U)}catch(q){this.F.error(q)}}}}X(){return this.H.defaultProfile.extensionsResource}Y(ne,U,R){if(m.URI.isUri(U))return new ue(ne,U,R,this.z,this.ab,this.D,this.H,this.eb,this.fb,this.F);const q=r.$ip.create(U).toString();let X=this.db.get(q);return X||(this.db.set(q,X=new re(ne,U,R,this.cb,this.ab,this.D,this.H,this.eb,this.fb,this.F,this.C)),X.waitUntilTaskIsFinished().finally(()=>this.db.delete(q))),X}Z(ne,U){return new ie(ne,U.profileLocation,this.fb)}async ob(ne){const U=async q=>{let X=await p.Promises.readdir(q);X=X.map(x=>w.$kc(q,x));const le=await Promise.all(X.map(x=>p.Promises.stat(x)));let Q=Promise.resolve([]);return le.forEach((x,V)=>{const L=X[V];x.isFile()&&(Q=Q.then(H=>[...H,L])),x.isDirectory()&&(Q=Q.then(H=>U(L).then(K=>[...H,...K])))}),Q};return(await U(ne.location.fsPath)).map(q=>({path:`extension/${w.$mc(ne.location.fsPath,q)}`,localPath:q}))}async pb({added:ne,removed:U}){if(U){const R=ne&&this.D.extUri.isEqual(U.profileLocation,ne.profileLocation)?U.extensions.filter(q=>ne.extensions.every(X=>!(0,r.$hp)(X,q))):U.extensions;for(const q of R)this.F.info("Extensions removed from another source",q.id,U.profileLocation.toString()),this.u.fire({identifier:q,profileLocation:U.profileLocation})}if(ne){const q=(await this.getInstalled(1,ne.profileLocation)).filter(X=>ne.extensions.some(le=>(0,r.$hp)(le,X.identifier)));this.s.fire(q.map(X=>(this.F.info("Extensions added from another source",X.identifier.id,ne.profileLocation.toString()),{identifier:X.identifier,local:X,profileLocation:ne.profileLocation,operation:1})))}}async rb(){this.B(this.ab.onExtract(U=>this.qb.add(U)));const ne=await this.hb.resolve(this.eb.userExtensionsLocation);for(const U of ne.children??[])U.isDirectory&&this.qb.add(U.resource);this.B(this.hb.watch(this.eb.userExtensionsLocation)),this.B(this.hb.onDidFilesChange(U=>this.sb(U)))}async sb(ne){if(!ne.affects(this.eb.userExtensionsLocation,1))return;const U=[];for(const R of ne.rawAdded){if(this.qb.has(R)||!this.D.extUri.isEqual(this.D.extUri.dirname(R),this.eb.userExtensionsLocation)||this.D.extUri.isEqual(R,this.D.extUri.joinPath(this.eb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(R).startsWith(".")||!(await this.hb.stat(R)).isDirectory)continue;const q=await this.ab.scanUserExtensionAtLocation(R);q&&q.installedTimestamp===void 0&&(this.qb.add(R),U.push(q))}U.length&&(await this.tb(U.map(R=>[R,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",U.map(R=>R.identifier.id)))}async tb(ne,U){const R=ne.map(q=>q[0]);await this.ub(R),await this.fb.addExtensionsToProfile(ne,U),this.s.fire(R.map(q=>({local:q,identifier:q.identifier,operation:1,profileLocation:U})))}async ub(ne){const U=await this.ab.getUninstalledExtensions();for(const R of ne){const q=r.$ip.create(R);U[q.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",q.id),await this.ab.setInstalled(q),this.F.info("Removed the extension from uninstalled list:",q.id))}}};e.$rq=J,e.$rq=J=Fe([Ne(0,o.$So),Ne(1,ee.$Nl),Ne(2,he.$Oj),Ne(3,t.$qi),Ne(4,i.$gq),Ne(5,s.$cq),Ne(6,l.$xo),Ne(7,Z.$hi),Ne(8,B.$Ok),Ne(9,ae.$8j),Ne(10,_.$ml),Ne(11,z.$ol)],J);let Y=class extends $.$Uc{constructor(ne,U,R,q,X,le){super(),this.j=ne,this.m=U,this.n=R,this.s=q,this.t=X,this.u=le,this.h=this.B(new k.$7d),this.onExtract=this.h.event,this.c=(0,g.$Vg)(this.n.userExtensionsLocation,".obsolete"),this.g=new n.$ph}async cleanUp(){await this.H(),await this.G()}async scanExtensions(ne,U,R){const q={includeInvalid:!0,profileLocation:U,productVersion:R};let X=[];return ne===null||ne===0?X.push(...await this.n.scanAllExtensions({includeInvalid:!0},q,!1)):ne===1&&X.push(...await this.n.scanUserExtensions(q)),X=ne!==null?X.filter(le=>le.type===ne):X,Promise.all(X.map(le=>this.F(le)))}async scanAllUserExtensions(ne){const U=await this.n.scanUserExtensions({includeAllVersions:!ne,includeInvalid:!0});return Promise.all(U.map(R=>this.F(R)))}async scanUserExtensionAtLocation(ne){try{const U=await this.n.scanExistingExtension(ne,1,{includeInvalid:!0});if(U)return await this.F(U)}catch(U){this.u.error(U)}return null}async extractUserExtension(ne,U,R,q,X){const le=ne.toString(),Q=m.URI.file(w.$kc(this.n.userExtensionsLocation.fsPath,`.${(0,u.$Eg)()}`)),x=m.URI.file(w.$kc(this.n.userExtensionsLocation.fsPath,le));let V=await this.m.exists(x);if(V&&q){try{await this.y(ne.id,x,"removeExisting")}catch{throw new o.$To(f.localize(4,null,x.fsPath,ne.id),o.ExtensionManagementErrorCode.Delete)}V=!1}if(V)await this.n.updateMetadata(x,R);else try{try{this.u.trace(`Started extracting the extension from ${U} to ${x.fsPath}`),await(0,h.$8p)(U,Q.fsPath,{sourcePath:"extension",overwrite:!0},X),this.u.info(`Extracted extension to ${x}:`,ne.id)}catch(L){let H=o.ExtensionManagementErrorCode.Extract;throw L instanceof h.$6p&&(L.type==="CorruptZip"?H=o.ExtensionManagementErrorCode.CorruptZip:L.type==="Incomplete"&&(H=o.ExtensionManagementErrorCode.IncompleteZip)),new o.$To(L.message,H)}await this.n.updateMetadata(Q,R);try{this.u.trace(`Started renaming the extension from ${Q.fsPath} to ${x.fsPath}`),await this.C(Q.fsPath,x.fsPath),this.u.info("Renamed to",x.fsPath)}catch(L){if(L.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",ne.id);else throw this.u.info(`Rename failed because of ${(0,C.$0)(L)}. Deleted from extracted location`,Q),L}this.h.fire(x)}catch(L){try{await this.m.del(Q,{recursive:!0})}catch{}throw L}return this.D(x,1)}async scanMetadata(ne,U){return U?(await this.w(ne,U))?.metadata:this.n.scanMetadata(ne.location)}async w(ne,U){return(await this.s.scanProfileExtensions(U)).find(q=>(0,r.$hp)(q.identifier,ne.identifier))}async updateMetadata(ne,U,R){return R?await this.s.updateMetadata([[ne,U]],R):await this.n.updateMetadata(ne.location,U),this.D(ne.location,ne.type,R)}getUninstalledExtensions(){return this.z()}async setUninstalled(...ne){const U=ne.map(R=>r.$ip.create(R));await this.z(R=>U.forEach(q=>{R[q.toString()]=!0,this.u.info("Marked extension as uninstalled",q.toString())}))}async setInstalled(ne){await this.z(U=>delete U[ne.toString()])}async removeExtension(ne,U){if(this.t.extUri.isEqualOrParent(ne.location,this.n.userExtensionsLocation))return this.y(ne.identifier.id,ne.location,U)}async removeUninstalledExtension(ne){await this.removeExtension(ne,"uninstalled"),await this.z(U=>delete U[r.$ip.create(ne).toString()])}async copyExtension(ne,U,R,q){const X=await this.w(ne,U),le=await this.w(ne,R);if(q={...X?.metadata,...q},le)if(this.t.extUri.isEqual(le.location,ne.location))await this.s.updateMetadata([[ne,{...le.metadata,...q}]],R);else{const Q=await this.D(le.location,ne.type,R);await this.s.removeExtensionFromProfile(Q,R),await this.s.addExtensionsToProfile([[ne,{...le.metadata,...q}]],R)}else await this.s.addExtensionsToProfile([[ne,q]],R);return this.D(ne.location,ne.type,R)}async copyExtensions(ne,U,R){const q=await this.scanExtensions(1,ne,R),X=await Promise.all(q.filter(le=>!le.isApplicationScoped).map(async le=>[le,await this.scanMetadata(le,ne)]));await this.s.addExtensionsToProfile(X,U)}async y(ne,U,R){this.u.trace(`Deleting ${R} extension from disk`,ne,U.fsPath);const q=this.t.extUri.joinPath(this.t.extUri.dirname(U),`${this.t.extUri.basename(U)}.${(0,b.$9i)((0,u.$Eg)()).toString(16)}${T}`);await this.C(U.fsPath,q.fsPath),await this.m.del(q,{recursive:!0}),this.u.info(`Deleted ${R} extension from disk`,ne,U.fsPath)}async z(ne){return this.g.queue(async()=>{let U;try{U=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(q){if((0,B.$6k)(q)!==1)throw q}let R={};if(U)try{R=JSON.parse(U)}catch{}return ne&&(ne(R),Object.keys(R).length?await this.m.writeFile(this.c,A.$ue.fromString(JSON.stringify(R))):await this.m.del(this.c)),R})}async C(ne,U){try{await p.Promises.rename(ne,U,2*60*1e3)}catch(R){throw new o.$To(R.message||f.localize(5,null,ne,U),R.code||o.ExtensionManagementErrorCode.Rename)}}async D(ne,U,R){if(R){const X=(await this.n.scanUserExtensions({profileLocation:R})).find(le=>this.t.extUri.isEqual(le.location,ne));if(X)return this.F(X)}else{const q=await this.n.scanExistingExtension(ne,U,{includeInvalid:!0});if(q)return this.F(q)}throw new Error(f.localize(6,null,ne.path))}async F(ne){const U=await this.m.resolve(ne.location);let R,q;return U.children&&(R=U.children.find(({name:X})=>/^readme(\.txt|\.md|)$/i.test(X))?.resource,q=U.children.find(({name:X})=>/^changelog(\.txt|\.md|)$/i.test(X))?.resource),{identifier:ne.identifier,type:ne.type,isBuiltin:ne.isBuiltin||!!ne.metadata?.isBuiltin,location:ne.location,manifest:ne.manifest,targetPlatform:ne.targetPlatform,validations:ne.validations,isValid:ne.isValid,readmeUrl:R,changelogUrl:q,publisherDisplayName:ne.metadata?.publisherDisplayName||null,publisherId:ne.metadata?.publisherId||null,isApplicationScoped:!!ne.metadata?.isApplicationScoped,isMachineScoped:!!ne.metadata?.isMachineScoped,isPreReleaseVersion:!!ne.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!ne.metadata?.hasPreReleaseVersion,preRelease:!!ne.metadata?.preRelease,installedTimestamp:ne.metadata?.installedTimestamp,updated:!!ne.metadata?.updated,pinned:!!ne.metadata?.pinned,isWorkspaceScoped:!1,source:ne.metadata?.source??(ne.identifier.uuid?"gallery":"vsix")}}async G(){const ne=await this.getUninstalledExtensions();if(Object.keys(ne).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(ne));const U=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),R=new Set;for(const X of U)ne[r.$ip.create(X).toString()]||R.add(X.identifier.id.toLowerCase());try{const X=(0,r.$np)(U,le=>le.identifier);await n.Promises.settled(X.map(async le=>{const Q=le.sort((x,V)=>d.rcompare(x.manifest.version,V.manifest.version))[0];R.has(Q.identifier.id.toLowerCase())||await this.j(await this.F(Q))}))}catch(X){this.u.error(X)}const q=U.filter(X=>X.metadata&&ne[r.$ip.create(X).toString()]);await Promise.allSettled(q.map(X=>this.removeUninstalledExtension(X)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let ne;try{ne=await this.m.resolve(this.n.userExtensionsLocation)}catch(U){(0,B.$6k)(U)!==1&&this.u.error(U);return}if(ne?.children)try{await Promise.allSettled(ne.children.map(async U=>{if(!(!U.isDirectory||!U.name.endsWith(T))){this.u.trace("Deleting the temporarily deleted folder",U.resource.toString());try{await this.m.del(U.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",U.resource.toString())}catch(R){(0,B.$6k)(R)!==1&&this.u.error(R)}}}))}catch{}}};e.$sq=Y,e.$sq=Y=Fe([Ne(1,B.$Ok),Ne(2,i.$gq),Ne(3,s.$cq),Ne(4,_.$ml),Ne(5,he.$Oj)],Y);class W extends a.$aq{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,c.$3f)(this.options.operation)?this.l:this.options.operation}constructor(ne,U,R,q,X,le,Q,x,V){super(),this.identifier=ne,this.source=U,this.options=R,this.m=q,this.n=X,this.o=le,this.p=Q,this.q=x,this.s=V,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(ne){const[U,R]=await this.x(ne);return this.j=U.isBuiltin||U.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[U,R]],this.j,!U.isValid),U}async u({zipPath:ne,key:U,metadata:R},q,X){let le=await this.v(U);return le?le=await this.m.updateMetadata(le,R):(this.s.trace("Extracting extension...",U.id),le=await this.m.extractUserExtension(U,ne,R,q,X),this.s.info("Extracting extension completed.",U.id)),le}async v(ne){return await this.w(ne)?(this.s.trace("Removing the extension from uninstalled list:",ne.id),await this.m.setInstalled(ne),this.s.info("Removed the extension from uninstalled list:",ne.id),(await this.m.scanAllUserExtensions(!0)).find(q=>r.$ip.create(q).equals(ne))):void 0}async w(ne){return!!(await this.m.getUninstalledExtensions())[ne.toString()]}}class re extends W{constructor(ne,U,R,q,X,le,Q,x,V,L,H){super(U.identifier,U,R,X,le,Q,x,V,L),this.y=U,this.z=q,this.A=H}async x(ne){let U;try{U=await this.m.scanExtensions(null,this.options.profileLocation,this.options.productVersion)}catch(X){throw new o.$To(X,o.ExtensionManagementErrorCode.Scanning)}const R=U.find(X=>(0,r.$hp)(X.identifier,this.y.identifier));R&&(this.l=3);const q={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||R?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||R?.isMachineScoped,isBuiltin:this.options.isBuiltin||R?.isBuiltin,isSystem:R?.type===0?!0:void 0,updated:!!R,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,hasPreReleaseVersion:R?.hasPreReleaseVersion||this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??R?.pinned,preRelease:(0,c.$2f)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.y.properties.isPreReleaseVersion||R?.preRelease,source:"gallery"};if(R?.manifest.version===this.y.version)try{return[await this.m.updateMetadata(R,q),q]}catch(X){throw new o.$To((0,C.$0)(X),o.ExtensionManagementErrorCode.UpdateMetadata)}try{return await this.C(q,ne)}catch(X){if(X instanceof o.$To&&(X.code===o.ExtensionManagementErrorCode.CorruptZip||X.code===o.ExtensionManagementErrorCode.IncompleteZip)){this.s.info("Downloaded VSIX is invalid. Trying to download and install again...",this.y.identifier.id);try{const le=await this.C(q,ne);return this.A.publicLog2("extensiongallery:install:retry",{extensionId:this.y.identifier.id,succeeded:!0}),le}catch(le){throw this.A.publicLog2("extensiongallery:install:retry",{extensionId:this.y.identifier.id,succeeded:!1}),le}}else throw X}}async C(ne,U){const{location:R,verificationStatus:q}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=q,this.D(R.fsPath),[await this.u({zipPath:R.fsPath,key:r.$ip.create(this.y),metadata:ne},!1,U),ne]}catch(X){try{await this.z.delete(R)}catch(le){this.s.warn("Error while deleting the downloaded file",R.toString(),(0,C.$0)(le))}throw X}}async D(ne){try{await(0,O.$nq)(ne)}catch(U){throw new o.$To((0,a.$$p)(U).message,o.ExtensionManagementErrorCode.Invalid)}}}e.$tq=re;class ue extends W{constructor(ne,U,R,q,X,le,Q,x,V,L){super({id:(0,r.$mp)(ne.publisher,ne.name)},U,R,X,le,Q,x,V,L),this.y=ne,this.z=U,this.A=q}async h(ne){const U=await super.h(ne);return this.D(U,ne),U}async x(ne){const U=new r.$ip(this.identifier,this.y.version),q=(await this.m.scanExtensions(1,this.options.profileLocation,this.options.productVersion)).find(Q=>(0,r.$hp)(this.identifier,Q.identifier)),X={isApplicationScoped:this.options.isApplicationScoped||q?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||q?.isMachineScoped,isBuiltin:this.options.isBuiltin||q?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??q?.pinned,source:"vsix"};if(q)if(this.l=3,U.equals(new r.$ip(q.identifier,q.manifest.version)))try{await this.m.removeExtension(q,"existing")}catch{throw new Error(f.localize(7,null,this.y.displayName||this.y.name))}else!this.options.profileLocation&&d.gt(q.manifest.version,this.y.version)&&await this.m.setUninstalled(q);else{const Q=await this.v(U);if(Q)try{await this.m.removeExtension(Q,"existing")}catch{throw new Error(f.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:w.$lc(this.z.fsPath),key:U,metadata:X},!0,ne),X]}async D(ne,U){try{let[R]=await this.A.getExtensions([{id:ne.identifier.id,version:ne.manifest.version}],U);if(R||([R]=await this.A.getExtensions([{id:ne.identifier.id}],U)),R){const q={id:R.identifier.uuid,publisherDisplayName:R.publisherDisplayName,publisherId:R.publisherId,isPreReleaseVersion:R.properties.isPreReleaseVersion,hasPreReleaseVersion:ne.hasPreReleaseVersion||R.properties.isPreReleaseVersion,preRelease:R.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(ne,q,this.options.profileLocation)}}catch{}}}class ie extends a.$aq{constructor(ne,U,R){super(),this.extension=ne,this.j=U,this.k=R}async h(ne){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(Ee[129],ke([1,0,13,33,34,29,49,16,26,3]),function(ce,e,n,A,P,D,C,k,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aQ=void 0;let E=class extends C.$dq{constructor(w,g,d,c,m,u){super($.URI.file(w.extensionsPath),g,d,c,m,u)}};e.$aQ=E,e.$aQ=E=Fe([Ne(0,b.$qi),Ne(1,k.$Ok),Ne(2,A.$ol),Ne(3,P.$ml),Ne(4,D.$Nl),Ne(5,n.$Oj)],E)}),define(Ee[268],ke([1,0,15,6,2,43,11,167,5,33]),function(ce,e,n,A,P,D,C,k,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=e.$Pp=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Np=e.$Mp=e.$Lp=void 0,e.$Op=g,e.$Qp=c,e.$Sp=u,e.$Lp="__$__isNewStorageMarker",e.$Mp="__$__targetStorageMarker",e.$Np=(0,b.$ii)("storageService");var E;(function(p){p[p.NONE=0]="NONE",p[p.SHUTDOWN=1]="SHUTDOWN"})(E||(e.WillSaveStateReason=E={}));var y;(function(p){p[p.APPLICATION=-1]="APPLICATION",p[p.PROFILE=0]="PROFILE",p[p.WORKSPACE=1]="WORKSPACE"})(y||(e.StorageScope=y={}));var w;(function(p){p[p.USER=0]="USER",p[p.MACHINE=1]="MACHINE"})(w||(e.StorageTarget=w={}));function g(p){const h=p.get(e.$Mp);if(h)try{return JSON.parse(h)}catch{}return Object.create(null)}class d extends P.$Uc{constructor(h={flushInterval:d.a}){super(),this.m=h,this.b=this.B(new A.$0d),this.c=this.B(new A.$0d),this.onDidChangeTarget=this.c.event,this.f=this.B(new A.$7d),this.onWillSaveState=this.f.event,this.h=this.B(new n.$uh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new P.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(h,f,l){return A.Event.filter(this.b.event,t=>t.scope===h&&(f===void 0||t.key===f),l)}n(){this.j.value=(0,n.$yh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,P.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,D.mark)("code/willInitStorage");try{await this.O()}finally{(0,D.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(h,f){const{key:l,external:t}=f;if(l===e.$Mp){switch(h){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:h})}else this.b.fire({scope:h,key:l,target:this.J(h)[l],external:t})}w(h){this.f.fire({reason:h})}get(h,f,l){return this.P(f)?.get(h,l)}getBoolean(h,f,l){return this.P(f)?.getBoolean(h,l)}getNumber(h,f,l){return this.P(f)?.getNumber(h,l)}getObject(h,f,l){return this.P(f)?.getObject(h,l)}storeAll(h,f){this.y(()=>{for(const l of h)this.store(l.key,l.value,l.scope,l.target,f)})}store(h,f,l,t,a=!1){if((0,C.$5f)(f)){this.remove(h,l,a);return}this.y(()=>{this.z(h,l,t),this.P(l)?.set(h,f,a)})}remove(h,f,l=!1){this.y(()=>{this.z(h,f,void 0),this.P(f)?.delete(h,l)})}y(h){this.b.pause(),this.c.pause();try{h()}finally{this.b.resume(),this.c.resume()}}keys(h,f){const l=[],t=this.J(h);for(const a of Object.keys(t))t[a]===f&&l.push(a);return l}z(h,f,l,t=!1){const a=this.J(f);typeof l=="number"?a[h]!==l&&(a[h]=l,this.P(f)?.set(e.$Mp,JSON.stringify(a),t)):typeof a[h]=="number"&&(delete a[h],this.P(f)?.set(e.$Mp,JSON.stringify(a),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(h){switch(h){case-1:return this.I;case 0:return this.G;default:return this.D}}L(h){const f=this.P(h);return f?g(f):Object.create(null)}isNew(h){return this.getBoolean(e.$Lp,h)===!0}async flush(h=E.NONE){this.f.fire({reason:h});const f=this.P(-1),l=this.P(0),t=this.P(1);switch(h){case E.NONE:await n.Promises.settled([f?.whenFlushed()??Promise.resolve(),l?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case E.SHUTDOWN:await n.Promises.settled([f?.flush(0)??Promise.resolve(),l?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const h=this.P(-1)?.items??new Map,f=this.P(0)?.items??new Map,l=this.P(1)?.items??new Map;return u(h,f,l,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(h){return await this.flush(),this.P(h)?.optimize()}async switch(h,f){return this.w(E.NONE),(0,$.$nl)(h)?this.R(h,f):this.S(h,f)}M(h,f){return!(h.id===f.id||c(f)&&c(h))}N(h,f,l){this.y(()=>{const t=new Set;for(const[a,o]of h)t.add(a),f.get(a)!==o&&this.u(l,{key:a,external:!0});for(const[a]of f.items)t.has(a)||this.u(l,{key:a,external:!0})})}}e.$Pp=d,d.a=60*1e3;function c(p){return p.isDefault||!!p.useDefaultFlags?.globalState}class m extends d{constructor(){super(),this.U=this.B(new k.$Jp(new k.$Kp,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new k.$Jp(new k.$Kp,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new k.$Jp(new k.$Kp,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(h=>this.u(1,h))),this.B(this.W.onDidChangeStorage(h=>this.u(0,h))),this.B(this.U.onDidChangeStorage(h=>this.u(-1,h)))}P(h){switch(h){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(h){switch(h){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(h){return!1}}e.$Rp=m;async function u(p,h,f,l,t,a){const o=I=>{try{return JSON.parse(I)}catch{return I}},r=new Map,s=new Map;p.forEach((I,B)=>{r.set(B,I),s.set(B,o(I))});const i=new Map,v=new Map;h.forEach((I,B)=>{i.set(B,I),v.set(B,o(I))});const S=new Map,O=new Map;f.forEach((I,B)=>{S.set(B,I),O.set(B,o(I))}),console.group(l!==t?`Storage: Application (path: ${l})`:`Storage: Application & Profile (path: ${l}, default profile)`);const N=[];if(r.forEach((I,B)=>{N.push({key:B,value:I})}),console.table(N),console.groupEnd(),console.log(s),l!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const I=[];i.forEach((B,Z)=>{I.push({key:Z,value:B})}),console.table(I),console.groupEnd(),console.log(v)}console.group(`Storage: Workspace (path: ${a})`);const j=[];S.forEach((I,B)=>{j.push({key:B,value:I})}),console.table(j),console.groupEnd(),console.log(O)}}),define(Ee[130],ke([1,0,18,20,10,4,30,11,3,25,26,31,36,81,16,13,32,48,252,268,29,63]),function(ce,e,n,A,P,D,C,k,b,$,E,y,w,g,d,c,m,u,p,h,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xp=e.$Wp=void 0,e.$Vp=ue;const t=D.$i?"web":(0,y.$Oo)(D.$o,C.$fc),a="X-Market-Search-Activity-Id";var o;(function(q){q[q.None=0]="None",q[q.IncludeVersions=1]="IncludeVersions",q[q.IncludeFiles=2]="IncludeFiles",q[q.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",q[q.IncludeSharedAccounts=8]="IncludeSharedAccounts",q[q.IncludeVersionProperties=16]="IncludeVersionProperties",q[q.ExcludeNonValidated=32]="ExcludeNonValidated",q[q.IncludeInstallationTargets=64]="IncludeInstallationTargets",q[q.IncludeAssetUri=128]="IncludeAssetUri",q[q.IncludeStatistics=256]="IncludeStatistics",q[q.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",q[q.Unpublished=4096]="Unpublished",q[q.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(o||(o={}));function r(...q){return String(q.reduce((X,le)=>X|le,0))}var s;(function(q){q[q.Tag=1]="Tag",q[q.ExtensionId=4]="ExtensionId",q[q.Category=5]="Category",q[q.ExtensionName=7]="ExtensionName",q[q.Target=8]="Target",q[q.Featured=9]="Featured",q[q.SearchText=10]="SearchText",q[q.ExcludeWithFlags=12]="ExcludeWithFlags"})(s||(s={}));const i={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},v={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},O={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:o.None,criteria:[],assetTypes:[]};class N{constructor(X=O){this.d=X}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(X,le=this.d.pageSize){return new N({...this.d,pageNumber:X,pageSize:le})}withFilter(X,...le){const Q=[...this.d.criteria,...le.length?le.map(x=>({filterType:X,value:x})):[{filterType:X}]];return new N({...this.d,criteria:Q})}withSortBy(X){return new N({...this.d,sortBy:X})}withSortOrder(X){return new N({...this.d,sortOrder:X})}withFlags(...X){return new N({...this.d,flags:X.reduce((le,Q)=>le|Q,0)})}withAssetTypes(...X){return new N({...this.d,assetTypes:X})}withSource(X){return new N({...this.d,source:X})}get raw(){const{criteria:X,pageNumber:le,pageSize:Q,sortBy:x,sortOrder:V,flags:L,assetTypes:H}=this.d;return{filters:[{criteria:X,pageNumber:le,pageSize:Q,sortBy:x,sortOrder:V}],assetTypes:H,flags:L}}get searchText(){const X=this.d.criteria.filter(le=>le.filterType===s.SearchText)[0];return X&&X.value?X.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(X=>String(X.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function j(q,X){const le=(q||[]).filter(Q=>Q.statisticName===X)[0];return le?le.value:0}function I(q){const X="Microsoft.VisualStudio.Code.Translation.";return q.files.filter(Q=>Q.assetType.indexOf(X)===0).reduce((Q,x)=>{const V=he(q,x.assetType);return V&&Q.push([x.assetType.substring(X.length),V]),Q},[])}function B(q){if(q.properties){const X=q.properties.filter(x=>x.key===i.Repository),le=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),Q=X.filter(x=>le.test(x.value))[0];return Q?{uri:Q.value,fallbackUri:Q.value}:null}return he(q,i.Repository)}function Z(q){return{uri:`${q.fallbackAssetUri}/${i.VSIX}?redirect=true${q.targetPlatform?`&targetPlatform=${q.targetPlatform}`:""}`,fallbackUri:`${q.fallbackAssetUri}/${i.VSIX}${q.targetPlatform?`?targetPlatform=${q.targetPlatform}`:""}`}}function he(q,X){return q.files.filter(Q=>Q.assetType===X)[0]?{uri:`${q.assetUri}/${X}${q.targetPlatform?`?targetPlatform=${q.targetPlatform}`:""}`,fallbackUri:`${q.fallbackAssetUri}/${X}${q.targetPlatform?`?targetPlatform=${q.targetPlatform}`:""}`}:null}function ae(q,X){const le=q.properties?q.properties.filter(x=>x.key===X):[],Q=le.length>0&&le[0].value;return Q?Q.split(",").map(x=>(0,w.$lp)(x)):[]}function ee(q){const X=q.properties?q.properties.filter(le=>le.key===v.Engine):[];return X.length>0&&X[0].value||""}function _(q){const X=q.properties?q.properties.filter(le=>le.key===v.PreRelease):[];return X.length>0&&X[0].value==="true"}function z(q){const X=q.properties?q.properties.filter(Q=>Q.key===v.LocalizedLanguages):[],le=X.length>0&&X[0].value||"";return le?le.split(","):[]}function T(q){return q.properties?.find(X=>X.key===v.SponsorLink)?.value}function J(q){return q.properties?.find(X=>X.key===v.SupportLink)?.value}function Y(q){return q.indexOf("preview")!==-1}function W(q){return q.targetPlatform?(0,y.$No)(q.targetPlatform):"undefined"}function re(q){const X=(0,n.$Mb)(q.versions.map(W)),le=!!q.tags?.includes(y.$Io),Q=X.indexOf("web");return le?Q===-1&&X.push("web"):Q!==-1&&X.splice(Q,1),X}function ue(q,X){for(let le=0;le<q.length;le++){const Q=q[le];if(Q.version===q[le-1]?.version){let x=le;if(W(Q)===X)for(;x>0&&q[x-1].version===Q.version;)x--;x!==le&&(q.splice(le,1),q.splice(x,0,Q))}}return q}function ie(q,X,le){q.telemetryData={index:X,querySource:le,queryActivityId:q.queryContext?.[a]}}function $e(q,X,le,Q){const x=q.versions[0],V={manifest:he(X,i.Manifest),readme:he(X,i.Details),changelog:he(X,i.Changelog),license:he(X,i.License),repository:B(X),download:Z(X),icon:he(X,i.Icon),signature:he(X,i.Signature),coreTranslations:I(X)};return{identifier:{id:(0,w.$mp)(q.publisher.publisherName,q.extensionName),uuid:q.extensionId},name:q.extensionName,version:X.version,displayName:q.displayName,publisherId:q.publisher.publisherId,publisher:q.publisher.publisherName,publisherDisplayName:q.publisher.displayName,publisherDomain:q.publisher.domain?{link:q.publisher.domain,verified:!!q.publisher.isDomainVerified}:void 0,publisherSponsorLink:T(x),description:q.shortDescription??"",installCount:j(q.statistics,"install"),rating:j(q.statistics,"averagerating"),ratingCount:j(q.statistics,"ratingcount"),categories:q.categories||[],tags:q.tags||[],releaseDate:Date.parse(q.releaseDate),lastUpdated:Date.parse(q.lastUpdated),allTargetPlatforms:le,assets:V,properties:{dependencies:ae(X,v.Dependency),extensionPack:ae(X,v.ExtensionPack),engine:ee(X),localizedLanguages:z(X),targetPlatform:W(X),isPreReleaseVersion:_(X)},hasPreReleaseVersion:_(x),hasReleaseVersion:!0,preview:Y(q.flags),isSigned:!!V.signature,queryContext:Q,supportLink:J(x)}}let ne=class{constructor(X,le,Q,x,V,L,H,K){this.k=le,this.l=Q,this.n=x,this.o=V,this.q=L,this.u=H,this.w=K;const te=H.extensionsGallery,de=te?.servicePPEUrl&&K.getValue("_extensionsGallery.enablePPE");this.d=de?te.servicePPEUrl:te?.serviceUrl,this.g=de?void 0:te?.searchUrl,this.h=te?.controlUrl,this.j=(0,p.$Up)(H.version,H,this.n,this.w,this.q,X,this.o)}x(X=""){return`${this.d}${X}`}isEnabled(){return!!this.d}async getExtensions(X,le,Q){const x=A.CancellationToken.isCancellationToken(le)?{}:le,V=A.CancellationToken.isCancellationToken(le)?le:Q,L=[],H=[],K=[],te=[];let de=!0;for(const we of X){we.uuid?H.push(we.uuid):L.push(we.id);const Ie=!!(we.version||we.preRelease);K.push({id:we.id,uuid:we.uuid,includePreRelease:Ie}),we.version&&te.push({id:we.id,uuid:we.uuid,version:we.version}),de=de&&!!we.hasPreRelease&&!Ie}if(!H.length&&!L.length)return[];let se=new N().withPage(1,X.length);H.length&&(se=se.withFilter(s.ExtensionId,...H)),L.length&&(se=se.withFilter(s.ExtensionName,...L)),(x.queryAllVersions||de)&&(se=se.withFlags(se.flags,o.IncludeVersions)),x.source&&(se=se.withSource(x.source));const{extensions:ge}=await this.z(se,{targetPlatform:x.targetPlatform??t,includePreRelease:K,versions:te,compatible:!!x.compatible,productVersion:x.productVersion??{version:this.u.version,date:this.u.date}},V);return x.source&&ge.forEach((we,Ie)=>ie(we,Ie,x.source)),ge}async getCompatibleExtension(X,le,Q,x={version:this.u.version,date:this.u.date}){if((0,y.$Po)(X.allTargetPlatforms,Q))return null;if(await this.isExtensionCompatible(X,le,Q))return X;const V=new N().withFlags(o.IncludeVersions).withPage(1,1).withFilter(s.ExtensionId,X.identifier.uuid),{extensions:L}=await this.z(V,{targetPlatform:Q,compatible:!0,includePreRelease:le,productVersion:x},A.CancellationToken.None);return L[0]||null}async isExtensionCompatible(X,le,Q,x={version:this.u.version,date:this.u.date}){if(!(0,y.$Qo)(X.properties.targetPlatform,X.allTargetPlatforms,Q)||!le&&X.properties.isPreReleaseVersion)return!1;let V=X.properties.engine;if(!V){const L=await this.getManifest(X,A.CancellationToken.None);if(!L)throw new Error("Manifest was not found");V=L.engines.vscode}return(0,g.$zp)(V,x.version,x.date)}async y(X,le,Q,x,V,L,H={version:this.u.version,date:this.u.date}){if(!(0,y.$Qo)(W(le),V,L)||Q!=="any"&&_(le)!==(Q==="prerelease"))return!1;if(x)try{const K=await this.E(X,le);if(!(0,g.$zp)(K,H.version,H.date))return!1}catch(K){return this.l.error(`Error while getting the engine for the version ${le.version}.`,(0,P.$0)(K)),!1}return!0}async query(X,le){let Q=X.text||"";const x=X.pageSize??50;let V=new N().withPage(1,x);Q?(Q=Q.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(de,se,ge)=>(V=V.withFilter(s.Category,ge||se),"")),Q=Q.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(de,se,ge)=>(V=V.withFilter(s.Tag,ge||se),"")),Q=Q.replace(/\bfeatured(\s+|\b|$)/g,()=>(V=V.withFilter(s.Featured),"")),Q=Q.trim(),Q&&(Q=Q.length<200?Q:Q.substring(0,200),V=V.withFilter(s.SearchText,Q)),V=V.withSortBy(0)):X.ids?V=V.withFilter(s.ExtensionId,...X.ids):X.names?V=V.withFilter(s.ExtensionName,...X.names):V=V.withSortBy(4),typeof X.sortBy=="number"&&(V=V.withSortBy(X.sortBy)),typeof X.sortOrder=="number"&&(V=V.withSortOrder(X.sortOrder)),X.source&&(V=V.withSource(X.source));const L=async(de,se)=>{const{extensions:ge,total:we}=await this.z(de,{targetPlatform:t,compatible:!1,includePreRelease:!!X.includePreRelease,productVersion:X.productVersion??{version:this.u.version,date:this.u.date}},se);return ge.forEach((Ie,je)=>ie(Ie,(de.pageNumber-1)*de.pageSize+je,X.source)),{extensions:ge,total:we}},{extensions:H,total:K}=await L(V,le),te=async(de,se)=>{if(se.isCancellationRequested)throw new P.$5;const{extensions:ge}=await L(V.withPage(de+1),se);return ge};return{firstPage:H,total:K,pageSize:V.pageSize,getPage:te}}async z(X,le,Q){const x=X.flags;X.flags&o.IncludeLatestVersionOnly&&X.flags&o.IncludeVersions&&(X=X.withFlags(X.flags&~o.IncludeVersions,o.IncludeLatestVersionOnly)),!(X.flags&o.IncludeLatestVersionOnly)&&!(X.flags&o.IncludeVersions)&&(X=X.withFlags(X.flags,o.IncludeLatestVersionOnly)),le.versions?.length&&(X=X.withFlags(X.flags&~o.IncludeLatestVersionOnly,o.IncludeVersions)),X=X.withFlags(X.flags,o.IncludeAssetUri,o.IncludeCategoryAndTags,o.IncludeFiles,o.IncludeStatistics,o.IncludeVersionProperties);const{galleryExtensions:V,total:L,context:H}=await this.B(X,Q);if(!(X.flags&o.IncludeLatestVersionOnly)){const se=[];for(const ge of V){const we=await this.A(ge,le,H);we&&se.push(we)}return{extensions:se,total:L}}const te=[],de=new Map;for(let se=0;se<V.length;se++){const ge=V[se],we={id:(0,w.$mp)(ge.publisher.publisherName,ge.extensionName),uuid:ge.extensionId},Ie=(0,k.$2f)(le.includePreRelease)?le.includePreRelease:!!le.includePreRelease.find(pe=>(0,w.$hp)(pe,we))?.includePreRelease;if(le.compatible&&(0,y.$Po)(re(ge),le.targetPlatform))continue;const je=await this.A(ge,le,H);!je||je.properties.isPreReleaseVersion&&(!Ie||!je.hasReleaseVersion)||!je.properties.isPreReleaseVersion&&je.properties.targetPlatform!==le.targetPlatform&&je.hasPreReleaseVersion?de.set(ge.extensionId,se):te.push([se,je])}if(de.size){const se=new l.$3d,ge=new N().withFlags(x&~o.IncludeLatestVersionOnly,o.IncludeVersions).withPage(1,de.size).withFilter(s.ExtensionId,...de.keys()),{extensions:we}=await this.z(ge,le,Q);this.o.publicLog2("galleryService:additionalQuery",{duration:se.elapsed(),count:de.size});for(const Ie of we){const je=de.get(Ie.identifier.uuid);te.push([je,Ie])}}return{extensions:te.sort((se,ge)=>se[0]-ge[0]).map(([,se])=>se),total:L}}async A(X,le,Q){const x={id:(0,w.$mp)(X.publisher.publisherName,X.extensionName),uuid:X.extensionId},V=le.versions?.find(te=>(0,w.$hp)(te,x))?.version,L=(0,k.$2f)(le.includePreRelease)?le.includePreRelease:!!le.includePreRelease.find(te=>(0,w.$hp)(te,x))?.includePreRelease,H=re(X),K=ue(X.versions,le.targetPlatform);if(le.compatible&&(0,y.$Po)(H,le.targetPlatform))return null;for(let te=0;te<K.length;te++){const de=K[te];if(!(V&&de.version!==V)){if(await this.y((0,w.$mp)(X.publisher.publisherName,X.extensionName),de,L?"any":"release",le.compatible,H,le.targetPlatform,le.productVersion))return $e(X,de,H,Q);if(V&&de.version===V)return null}}return V||le.compatible?null:$e(X,X.versions[0],H)}async B(X,le){if(!this.isEnabled())throw new Error("No extension gallery service configured.");X=X.withFlags(X.flags,o.ExcludeNonValidated).withFilter(s.Target,"Microsoft.VisualStudio.Code").withFilter(s.ExcludeWithFlags,r(o.Unpublished));const Q=await this.j,x=JSON.stringify(X.raw),V={...Q,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(x.length)},L=new l.$3d;let H,K,te=0;try{if(H=await this.k.request({type:"POST",url:this.g&&X.criteria.some(se=>se.filterType===s.SearchText)?this.g:this.x("/extensionquery"),data:x,headers:V},le),H.res.statusCode&&H.res.statusCode>=400&&H.res.statusCode<500)return{galleryExtensions:[],total:te};const de=await(0,u.$Gp)(H);if(de){const se=de.results[0],ge=se.extensions,we=se.resultMetadata&&se.resultMetadata.filter(Ie=>Ie.metadataType==="ResultCount")[0];return te=we&&we.metadataItems.filter(Ie=>Ie.name==="TotalCount")[0].count||0,{galleryExtensions:ge,total:te,context:{[a]:H.res.headers.activityid}}}return{galleryExtensions:[],total:te}}catch(de){const se=(0,P.$4)(de)?y.ExtensionGalleryErrorCode.Cancelled:(0,P.$0)(de).startsWith("XHR timeout")?y.ExtensionGalleryErrorCode.Timeout:y.ExtensionGalleryErrorCode.Failed;throw K=new y.$Uo((0,P.$0)(de),se),K}finally{this.o.publicLog2("galleryService:query",{...X.telemetryData,requestBodySize:String(x.length),duration:L.elapsed(),success:!!H&&(0,u.$Cp)(H),responseBodySize:H?.res.headers["Content-Length"],statusCode:H?String(H.res.statusCode):void 0,errorCode:K?.code,count:String(te)})}}async reportStatistic(X,le,Q,x){if(!this.isEnabled())return;const V=D.$i?this.x(`/itemName/${X}.${le}/version/${Q}/statType/${x==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${X}/extensions/${le}/${Q}/stats?statType=${x}`),L=D.$i?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",K={...await this.j,Accept:L};try{await this.k.request({type:"POST",url:V,headers:K},A.CancellationToken.None)}catch{}}async download(X,le,Q){this.l.trace("ExtensionGalleryService#download",X.identifier.id);const x=(0,w.$pp)(X),V=new Date().getTime(),L=se=>this.o.publicLog("galleryService:downloadVSIX",{...x,duration:se}),H=Q===2?"install":Q===3?"update":"",K=H?{uri:`${X.assets.download.uri}${b.URI.parse(X.assets.download.uri).query?"&":"?"}${H}=true`,fallbackUri:`${X.assets.download.fallbackUri}${b.URI.parse(X.assets.download.fallbackUri).query?"&":"?"}${H}=true`}:X.assets.download,te=X.queryContext?.[a]?{[a]:X.queryContext[a]}:void 0,de=await this.D(X.identifier.id,K,i.VSIX,te?{headers:te}:void 0);await this.q.writeFile(le,de.stream),L(new Date().getTime()-V)}async downloadSignatureArchive(X,le){if(!X.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",X.identifier.id);const Q=await this.D(X.identifier.id,X.assets.signature,i.Signature);await this.q.writeFile(le,Q.stream)}async getReadme(X,le){if(X.assets.readme){const Q=await this.D(X.identifier.id,X.assets.readme,i.Details,{},le);return await(0,u.$Fp)(Q)||""}return""}async getManifest(X,le){if(X.assets.manifest){const Q=await this.D(X.identifier.id,X.assets.manifest,i.Manifest,{},le),x=await(0,u.$Fp)(Q);return x?JSON.parse(x):null}return null}async C(X,le,Q){const x=he(le,i.Manifest);if(!x)throw new Error("Manifest was not found");const V={"Accept-Encoding":"gzip"},L=await this.D(X,x,i.Manifest,{headers:V});return await(0,u.$Gp)(L)}async getCoreTranslation(X,le){const Q=X.assets.coreTranslations.filter(x=>x[0]===le.toUpperCase())[0];if(Q){const x=await this.D(X.identifier.id,Q[1],Q[0]),V=await(0,u.$Fp)(x);return V?JSON.parse(V):null}return null}async getChangelog(X,le){if(X.assets.changelog){const Q=await this.D(X.identifier.id,X.assets.changelog,i.Changelog,{},le);return await(0,u.$Fp)(Q)||""}return""}async getAllCompatibleVersions(X,le,Q){let x=new N().withFlags(o.IncludeVersions,o.IncludeCategoryAndTags,o.IncludeFiles,o.IncludeVersionProperties).withPage(1,1);X.identifier.uuid?x=x.withFilter(s.ExtensionId,X.identifier.uuid):x=x.withFilter(s.ExtensionName,X.identifier.id);const{galleryExtensions:V}=await this.B(x,A.CancellationToken.None);if(!V.length)return[];const L=re(V[0]);if((0,y.$Po)(L,Q))return[];const H=[];await Promise.all(V[0].versions.map(async de=>{try{await this.y(X.identifier.id,de,le?"any":"release",!0,L,Q)&&H.push(de)}catch{}}));const K=[],te=new Set;for(const de of ue(H,Q))te.has(de.version)||(te.add(de.version),K.push({version:de.version,date:de.lastUpdated,isPreReleaseVersion:_(de)}));return K}async D(X,le,Q,x={},V=A.CancellationToken.None){const L=await this.j,H={type:"GET"},K={...L,...x.headers||{}};x={...x,...H,headers:K};const te=le.uri,de=le.fallbackUri,se={...x,url:te};try{const ge=await this.k.request(se,V);if(ge.res.statusCode===200)return ge;const we=await(0,u.$Fp)(ge);throw new Error(`Expected 200, got back ${ge.res.statusCode} instead.

${we}`)}catch(ge){if((0,P.$4)(ge))throw ge;const we=(0,P.$0)(ge);this.o.publicLog2("galleryService:cdnFallback",{extension:X,assetType:Q,message:we});const Ie={...x,url:de};return this.k.request(Ie,V)}}async E(X,le){let Q=ee(le);if(!Q){this.o.publicLog2("galleryService:engineFallback",{extension:X,version:le.version});const x=await this.C(X,le,A.CancellationToken.None);if(!x)throw new Error("Manifest was not found");Q=x.engines.vscode}return Q}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const X=await this.k.request({type:"GET",url:this.h},A.CancellationToken.None);if(X.res.statusCode!==200)throw new Error("Could not get extensions report.");const le=await(0,u.$Gp)(X),Q=[],x={},V=[];if(le){for(const L of le.malicious)Q.push({id:L});if(le.migrateToPreRelease)for(const[L,H]of Object.entries(le.migrateToPreRelease))(!H.engine||(0,g.$zp)(H.engine,this.u.version,this.u.date))&&(x[L.toLowerCase()]={disallowInstall:!0,extension:{id:H.id,displayName:H.displayName,autoMigrate:{storage:!!H.migrateStorage},preRelease:!0}});if(le.deprecated)for(const[L,H]of Object.entries(le.deprecated))H&&(x[L.toLowerCase()]=(0,k.$2f)(H)?{}:H);if(le.search)for(const L of le.search)V.push(L)}return{malicious:Q,deprecated:x,search:V}}};ne=Fe([Ne(1,u.$Ap),Ne(2,c.$Oj),Ne(3,E.$pi),Ne(4,f.$Nl),Ne(5,d.$Ok),Ne(6,m.$8j),Ne(7,$.$Oi)],ne);let U=class extends ne{constructor(X,le,Q,x,V,L,H,K){super(X,le,Q,x,V,L,H,K)}};e.$Wp=U,e.$Wp=U=Fe([Ne(0,h.$Np),Ne(1,u.$Ap),Ne(2,c.$Oj),Ne(3,E.$pi),Ne(4,f.$Nl),Ne(5,d.$Ok),Ne(6,m.$8j),Ne(7,$.$Oi)],U);let R=class extends ne{constructor(X,le,Q,x,V,L,H){super(void 0,X,le,Q,x,V,L,H)}};e.$Xp=R,e.$Xp=R=Fe([Ne(0,u.$Ap),Ne(1,c.$Oj),Ne(2,E.$pi),Ne(3,f.$Nl),Ne(4,d.$Ok),Ne(5,m.$8j),Ne(6,$.$Oi)],R)}),define(Ee[269],ke([1,0,6,2,33,54]),function(ce,e,n,A,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iQ=e.$hQ=void 0;class C{constructor($,E){this.a=$,this.b=E}listen($,E){const y=this.b($);switch(E){case"onDidChangeProfiles":return n.Event.map(this.a.onDidChangeProfiles,w=>({all:w.all.map(g=>(0,D.$nn)({...g},y)),added:w.added.map(g=>(0,D.$nn)({...g},y)),removed:w.removed.map(g=>(0,D.$nn)({...g},y)),updated:w.updated.map(g=>(0,D.$nn)({...g},y))}))}throw new Error(`Invalid listen ${E}`)}async call($,E,y){const w=this.b($);switch(E){case"createProfile":{const g=await this.a.createProfile(y[0],y[1],y[2]);return(0,D.$nn)({...g},w)}case"updateProfile":{let g=(0,P.$pl)((0,D.$on)(y[0],w),this.a.profilesHome.scheme);return g=await this.a.updateProfile(g,y[1]),(0,D.$nn)({...g},w)}case"removeProfile":{const g=(0,P.$pl)((0,D.$on)(y[0],w),this.a.profilesHome.scheme);return this.a.removeProfile(g)}}throw new Error(`Invalid call ${E}`)}}e.$hQ=C;class k extends A.$Uc{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor($,E,y){super(),this.profilesHome=E,this.f=y,this.a=[],this.b=this.B(new n.$7d),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=$.map(w=>(0,P.$pl)(w,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(w=>{const g=w.added.map(m=>(0,P.$pl)(m,this.profilesHome.scheme)),d=w.removed.map(m=>(0,P.$pl)(m,this.profilesHome.scheme)),c=w.updated.map(m=>(0,P.$pl)(m,this.profilesHome.scheme));this.a=w.all.map(m=>(0,P.$pl)(m,this.profilesHome.scheme)),this.b.fire({added:g,removed:d,updated:c,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement($){this.c=$}isEnabled(){return this.c}async createNamedProfile($,E,y){const w=await this.f.call("createNamedProfile",[$,E,y]);return(0,P.$pl)(w,this.profilesHome.scheme)}async createProfile($,E,y,w){const g=await this.f.call("createProfile",[$,E,y,w]);return(0,P.$pl)(g,this.profilesHome.scheme)}async createTransientProfile($){const E=await this.f.call("createTransientProfile",[$]);return(0,P.$pl)(E,this.profilesHome.scheme)}async setProfileForWorkspace($,E){await this.f.call("setProfileForWorkspace",[$,E])}removeProfile($){return this.f.call("removeProfile",[$])}async updateProfile($,E){const y=await this.f.call("updateProfile",[$,E]);return(0,P.$pl)(y,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$iQ=k}),define(Ee[131],ke([1,0,3,26,16,13,245,34,33,11,246]),function(ce,e,n,A,P,D,C,k,b,$,E){"use strict";var y,w;Object.defineProperty(e,"__esModule",{value:!0}),e.$_P=e.$$P=e.$0P=void 0;let g=y=class extends b.$rl{constructor(u,p,h,f,l){super(h,f,p,l),this.U=u,this.W=h}O(){return this.U.getItem(y.b,[]).map(p=>({...p,location:(0,$.$Vf)(p.location)?this.w.extUri.joinPath(this.profilesHome,p.location):n.URI.revive(p.location)}))}Q(){const u=this.U.getItem(y.c,{});return this.U.getItem(y.a,!1)?u:this.N(u)}S(){return this.w.extUri.joinPath(n.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$0P=g,g.a="profileAssociationsMigration",e.$0P=g=y=Fe([Ne(0,C.$5P),Ne(1,k.$ml),Ne(2,A.$qi),Ne(3,P.$Ok),Ne(4,D.$Oj)],g);let d=w=class extends g{constructor(u,p,h,f,l){super(u,p,h,f,l),this.$=u}P(u){u.length?this.$.setItem(w.b,u.map(p=>({...p,location:this.w.extUri.basename(p.location)}))):this.$.removeItem(w.b)}O(){const u=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(u),this.$.setItem("userDataProfilesMigration",!0)),u}R(u){u.emptyWindows||u.workspaces?this.$.setItem(w.c,u):this.$.removeItem(w.c)}Q(){const u="workspaceAndProfileInfo",p=this.$.getItem(u,void 0);if(p){this.$.removeItem(u);const f=p.reduce((l,{workspace:t,profile:a})=>(l[n.URI.revive(t).toString()]=n.URI.revive(a).toString(),l),{});this.$.setItem(w.c,{workspaces:f})}const h=super.Q();return this.$.getItem(w.a,!1)||(this.R(h),this.$.setItem(w.a,!0)),h}};e.$$P=d,e.$$P=d=w=Fe([Ne(0,C.$6P),Ne(1,k.$ml),Ne(2,A.$qi),Ne(3,P.$Ok),Ne(4,D.$Oj)],d);let c=class extends d{constructor(u,p,h,f){super(new E.$9P(0,p,f,h),u,p,h,f)}async init(){return await this.$.init(),super.init()}};e.$_P=c,e.$_P=c=Fe([Ne(0,k.$ml),Ne(1,A.$qi),Ne(2,P.$Ok),Ne(3,D.$Oj)],c)}),define(Ee[132],ke([1,0,5]),function(ce,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9m=e.$8m=void 0,e.$8m=(0,n.$ii)("extensionHostStatusService");class A{constructor(){this.a=new Map}setExitInfo(D,C){this.a.set(D,C)}getExitInfo(D){return this.a.get(D)||null}}e.$9m=A}),define(Ee[270],ke([1,0,6,15]),function(ce,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$en=void 0;function P(C){let k=0,b=0,$=0;C>=1e3&&($=Math.floor(C/1e3),C-=$*1e3),$>=60&&(b=Math.floor($/60),$-=b*60),b>=60&&(k=Math.floor(b/60),b-=k*60);const E=k?`${k}h`:"",y=b?`${b}m`:"",w=$?`${$}s`:"",g=C?`${C}ms`:"";return`${E}${y}${w}${g}`}class D{constructor(k,b,$,E){this.i=k,this.j=b,this.a=new n.$7d,this.onClose=this.a.event,this.b=108e5,this.c=3e5,this.d=$,this.protocol=E,this.e=!1,this.f=new A.$vh(()=>{this.k(`The reconnection grace time of ${P(this.b)} has expired, so the connection will be disposed.`),this.l()},this.b),this.g=new A.$vh(()=>{this.k(`The reconnection short grace time of ${P(this.c)} has expired, so the connection will be disposed.`),this.l()},this.c),this.protocol.onDidDispose(()=>{this.k("The client has disconnected gracefully, so the connection will be disposed."),this.l()}),this.protocol.onSocketClose(()=>{this.k(`The client has disconnected, will wait for reconnection ${P(this.b)} before disposing...`),this.f.schedule()}),this.k("New connection established.")}k(k){this.i.info(`[${this.d}][${this.j.substr(0,8)}][ManagementConnection] ${k}`)}shortenReconnectionGraceTimeIfNecessary(){this.g.isScheduled()||this.f.isScheduled()&&(this.k(`Another client has connected, will shorten the wait for reconnection ${P(this.c)} before disposing...`),this.g.schedule())}l(){if(this.e)return;this.e=!0,this.f.dispose(),this.g.dispose();const k=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),k.end(),this.a.fire(void 0)}acceptReconnection(k,b,$){this.d=k,this.k("The client has reconnected."),this.f.cancel(),this.g.cancel(),this.protocol.beginAcceptReconnection(b,$),this.protocol.endAcceptReconnection()}}e.$en=D}),define(Ee[93],ke([1,0,27,12,7,162,58]),function(ce,e,n,A,P,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zl=e.InternalNLSConfiguration=void 0,e.$Yl=E;const k=P.$kc(A.$Cg.asFileUri("").fsPath,"nls.metadata.json"),b=new Map;function $(d){return new Promise(c=>n.exists(d,c))}function E(d,c){return $(k).then(m=>{if(!m||!C.default.commit)return Promise.resolve({locale:"en",osLocale:"en",availableLanguages:{}});const u=`${d}||${c}`;let p=b.get(u);return p||(p=D.getNLSConfiguration(C.default.commit,c,k,d,d).then(h=>(y.is(h)&&(h._languagePackSupport=!0),h.locale!=="en"&&h.locale!=="en-us"&&Object.keys(h.availableLanguages).length===0&&b.delete(u),h)),b.set(u,p)),p})}var y;(function(d){function c(m){const u=m;return u&&typeof u._languagePackId=="string"}d.is=c})(y||(e.InternalNLSConfiguration=y={}));const w=async d=>{try{const c=g(await n.promises.readFile(d,"utf8"));return JSON.parse(c).locale}catch(c){return c.code!=="ENOENT"&&console.warn(c),"en"}};e.$Zl=w;const g=d=>{const c=/('(?:[^\\']*(?:\\.)?)*')|('(?:[^\\']*(?:\\.)?)*')|(\/\*(?:\r?\n|.)*?\*\/)|(\/{2,}.*?(?:(?:\r?\n)|$))/g;return d.replace(c,(m,u,p,h,f)=>{if(h)return"";if(f){const l=f.length;return l>2&&f[l-1]===`
`?f[l-2]==="\r"?`\r
`:`
`:""}else return m})}}),define(Ee[133],ke([1,0,19,3,26,49,59,16,5,13,32,34,33,93]),function(ce,e,n,A,P,D,C,k,b,$,E,y,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YP=void 0;let d=class extends C.$hq{constructor(m,u,p,h,f,l,t,a){super(A.URI.file(f.builtinExtensionsPath),A.URI.file(f.extensionsPath),(0,n.$Vg)(f.userHome,".vscode-oss-dev","extensions","control.json"),m.defaultProfile,m,u,p,h,f,l,t,a),this.S=f}async f(m){const u=await(0,g.$Yl)(m,this.S.userDataPath);if(g.InternalNLSConfiguration.is(u))try{const p=await this.w.readFile(A.URI.file(u._translationsConfigFile));return JSON.parse(p.value.toString())}catch{}return Object.create(null)}};e.$YP=d,e.$YP=d=Fe([Ne(0,w.$ol),Ne(1,D.$cq),Ne(2,k.$Ok),Ne(3,$.$Oj),Ne(4,P.$qi),Ne(5,E.$8j),Ne(6,y.$ml),Ne(7,b.$hi)],d)}),define(Ee[271],ke([1,0,272,27,7,22,12,23]),function(ce,e,n,A,P,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hn=e.$gn=e.$fn=e.ServerConnectionTokenType=void 0,e.$in=g,e.$jn=d,e.$kn=c;const b=/^[0-9A-Za-z_-]+$/;var $;(function(m){m[m.None=0]="None",m[m.Optional=1]="Optional",m[m.Mandatory=2]="Mandatory"})($||(e.ServerConnectionTokenType=$={}));class E{constructor(){this.type=0}validate(u){return!0}}e.$fn=E;class y{constructor(u){this.value=u,this.type=2}validate(u){return u===this.value}}e.$gn=y;class w{constructor(u){this.message=u}}e.$hn=w;async function g(m,u){const p=m["without-connection-token"],h=m["connection-token"],f=m["connection-token-file"];if(p)return typeof h<"u"||typeof f<"u"?new w("Please do not use the argument '--connection-token' or '--connection-token-file' at the same time as '--without-connection-token'."):new E;if(typeof f<"u"){if(typeof h<"u")return new w("Please do not use the argument '--connection-token' at the same time as '--connection-token-file'.");let l;try{l=A.readFileSync(f).toString().replace(/\r?\n$/,"")}catch{return new w(`Unable to read the connection token file at '${f}'.`)}return b.test(l)?new y(l):new w(`The connection token defined in '${f} does not adhere to the characters 0-9, a-z, A-Z, _, or -.`)}return typeof h<"u"?b.test(h)?new y(h):new w(`The connection token '${h} does not adhere to the characters 0-9, a-z, A-Z or -.`):new y(await u())}async function d(m){return g(m,async()=>{if(!m["user-data-dir"])return(0,D.$Eg)();const p=P.$kc(m["user-data-dir"],"token");try{const l=(await k.Promises.readFile(p)).toString().replace(/\r?\n$/,"");if(b.test(l))return l}catch{}const h=(0,D.$Eg)();try{await k.Promises.writeFile(p,h,{mode:384})}catch{}return h})}function c(m,u,p){if(m.validate(p.query[C.$ug]))return!0;const h=n.parse(u.headers.cookie||"");return m.validate(h[C.$tg])}}),define(Ee[50],ke([1,0,208,110,67,5,26,74]),function(ce,e,n,A,P,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1m=e.$Zm=e.$Ym=void 0,e.$Ym={"disable-update-check":{type:"boolean"},auth:{type:"string"},"disable-file-downloads":{type:"boolean"},"disable-file-uploads":{type:"boolean"},locale:{type:"string"},"disable-getting-started-override":{type:"boolean"},host:{type:"string",cat:"o",args:"ip-address",description:n.localize(0,null)},port:{type:"string",cat:"o",args:"port | port range",description:n.localize(1,null)},"socket-path":{type:"string",cat:"o",args:"path",description:n.localize(2,null)},"server-base-path":{type:"string",cat:"o",args:"path",description:n.localize(3,null)},"connection-token":{type:"string",cat:"o",args:"token",deprecates:["connectionToken"],description:n.localize(4,null)},"connection-token-file":{type:"string",cat:"o",args:"path",deprecates:["connection-secret","connectionTokenFile"],description:n.localize(5,null)},"without-connection-token":{type:"boolean",cat:"o",description:n.localize(6,null)},"disable-websocket-compression":{type:"boolean"},"print-startup-performance":{type:"boolean"},"print-ip-address":{type:"boolean"},"accept-server-license-terms":{type:"boolean",cat:"o",description:n.localize(7,null)},"server-data-dir":{type:"string",cat:"o",description:n.localize(8,null)},"telemetry-level":{type:"string",cat:"o",args:"level",description:n.localize(9,null)},"user-data-dir":P.$fm["user-data-dir"],"enable-smoke-test-driver":P.$fm["enable-smoke-test-driver"],"disable-telemetry":P.$fm["disable-telemetry"],"disable-workspace-trust":P.$fm["disable-workspace-trust"],"file-watcher-polling":{type:"string",deprecates:["fileWatcherPolling"]},log:P.$fm.log,logsPath:P.$fm.logsPath,"force-disable-user-env":P.$fm["force-disable-user-env"],folder:{type:"string",deprecationMessage:"No longer supported. Folder needs to be provided in the browser URL or with `default-folder`."},workspace:{type:"string",deprecationMessage:"No longer supported. Workspace needs to be provided in the browser URL or with `default-workspace`."},"default-folder":{type:"string",description:n.localize(10,null)},"default-workspace":{type:"string",description:n.localize(11,null)},"enable-sync":{type:"boolean"},"github-auth":{type:"string"},"use-test-resolver":{type:"boolean"},"extensions-dir":P.$fm["extensions-dir"],"extensions-download-dir":P.$fm["extensions-download-dir"],"builtin-extensions-dir":P.$fm["builtin-extensions-dir"],"install-extension":P.$fm["install-extension"],"install-builtin-extension":P.$fm["install-builtin-extension"],"update-extensions":P.$fm["update-extensions"],"uninstall-extension":P.$fm["uninstall-extension"],"list-extensions":P.$fm["list-extensions"],"locate-extension":P.$fm["locate-extension"],"show-versions":P.$fm["show-versions"],category:P.$fm.category,force:P.$fm.force,"do-not-sync":P.$fm["do-not-sync"],"pre-release":P.$fm["pre-release"],"start-server":{type:"boolean",cat:"e",description:n.localize(12,null)},"enable-remote-auto-shutdown":{type:"boolean"},"remote-auto-shutdown-without-delay":{type:"boolean"},"use-host-proxy":{type:"boolean"},"without-browser-env-var":{type:"boolean"},help:P.$fm.help,version:P.$fm.version,"locate-shell-integration-path":P.$fm["locate-shell-integration-path"],compatibility:{type:"string"},_:P.$fm._},e.$Zm=(0,D.$ji)(C.$pi);class b extends A.$Vm{get userRoamingDataHome(){return this.appSettingsHome}get args(){return super.args}}e.$1m=b,Fe([k.$Mh],b.prototype,"userRoamingDataHome",null)}),define(Ee[273],ke([1,0,312,257,274,28]),function(ce,e,n,A,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZP=void 0;class C extends n.AppInsightsCore{constructor(b){super(),this.a=b}track(b){const $=b.baseData||{};$.properties||($.properties={}),$.measurements||($.measurements={});try{const E=D.cpus();$.measurements.cores=E.length,$.properties["common.cpuModel"]=E[0].model}catch{}try{$.measurements.memoryFree=D.freemem(),$.measurements.memoryTotal=D.totalmem()}catch{}try{$.properties["common.shell"]=D.userInfo().shell,$.properties["common.release"]=D.release(),$.properties["common.arch"]=D.arch()}catch{}try{const E=(/^http:/.test(this.a)?P:A).request(this.a,{method:"POST",headers:{"Content-Type":"application/json"}});E.on("error",()=>{}),E.write(JSON.stringify($)),E.end()}catch{}}}e.$ZP=C}),define(Ee[275],ke([1,0,27,23,77,86,272,89,37,61,4,13,50,7,12,22,32,48,20,3,14,11,93]),function(ce,e,n,A,P,D,C,k,b,$,E,y,w,g,d,c,m,u,p,h,f,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sQ=e.$rQ=e.$qQ=e.$pQ=e.$oQ=e.CacheControl=void 0,e.$mQ=o,e.$nQ=s;const a={".html":"text/html",".js":"text/javascript",".json":"application/json",".css":"text/css",".svg":"image/svg+xml"};async function o(I,B,Z,he){B.writeHead(Z,{"Content-Type":"text/plain"}),B.end(he)}var r;(function(I){I[I.NO_CACHING=0]="NO_CACHING",I[I.ETAG=1]="ETAG",I[I.NO_EXPIRY=2]="NO_EXPIRY"})(r||(e.CacheControl=r={}));async function s(I,B,Z,he,ae,ee){try{const _=await A.Promises.stat(I);if(B===1){const z=`W/"${[_.ino,_.size,_.mtime.getTime()].join("-")}"`;if(he.headers["if-none-match"]===z)return ae.writeHead(304),void ae.end();ee.Etag=z}else B===2?ee["Cache-Control"]="public, max-age=31536000":B===0&&(ee["Cache-Control"]="no-store");ee["Content-Type"]=a[(0,g.$pc)(I)]||(0,$.$Cs)(I)||"text/plain",ae.writeHead(200,ee),(0,n.createReadStream)(I).pipe(ae)}catch(_){return _.code!=="ENOENT"?(Z.error(_),console.error(_.toString())):console.error(`File not found: ${I}`),ae.writeHead(404,{"Content-Type":"text/plain"}),void ae.end("Not found")}}const i=(0,g.$nc)(d.$Cg.asFileUri("").fsPath);let v=class{constructor(B,Z,he,ae,ee,_,z){this.f=B,this.g=Z,this.serverRootPath=he,this.h=ae,this.i=ee,this.j=_,this.k=z,this.a=this.k.extensionsGallery?.resourceUrlTemplate?h.URI.parse(this.k.extensionsGallery.resourceUrlTemplate):void 0,this.b=`${he}/static`,this.c=`${he}/callback`,this.d="/web-extension-resource"}async handle(B,Z,he){try{const ae=he.pathname;return ae.startsWith(this.b)&&ae.charCodeAt(this.b.length)===47?this.l(B,Z,he):ae===this.g?this.o(B,Z,he):ae===this.c?this.q(Z):ae.startsWith(this.d)&&ae.charCodeAt(this.d.length)===47?this.n(B,Z,he):o(B,Z,404,"Not found.")}catch(ae){return this.i.error(ae),console.error(ae.toString()),o(B,Z,500,"Internal Server Error.")}}async l(B,Z,he){const ae=Object.create(null),_=decodeURIComponent(he.pathname).substring(this.b.length+1),z=(0,g.$kc)(i,_);return(0,b.$ig)(z,i,!E.$e)?s(z,this.h.isBuilt?2:1,this.i,B,Z,ae):o(B,Z,400,"Bad request.")}m(B){const Z=B.authority.indexOf(".");return Z!==-1?B.authority.substring(Z+1):void 0}async n(B,Z,he){if(!this.a)return o(B,Z,500,"No extension gallery service configured.");const ae=decodeURIComponent(he.pathname),ee=(0,g.$ic)(ae.substring(this.d.length+1)),_=h.URI.parse(ee).with({scheme:this.a.scheme,authority:ee.substring(0,ee.indexOf("/")),path:ee.substring(ee.indexOf("/")+1)});if(this.m(this.a)!==this.m(_))return o(B,Z,403,"Request Forbidden");const z={},T=ie=>{const $e=B.headers[ie];$e&&((0,l.$Vf)($e)||$e[0])?z[ie]=(0,l.$Vf)($e)?$e:$e[0]:ie!==ie.toLowerCase()&&T(ie.toLowerCase())};T("X-Client-Name"),T("X-Client-Version"),T("X-Machine-Id"),T("X-Client-Commit");const J=await this.j.request({type:"GET",url:_.toString(!0),headers:z},p.CancellationToken.None),Y=J.res.statusCode||500;if(Y!==200){let ie=null;try{ie=await(0,u.$Fp)(J)}catch{}return o(B,Z,Y,ie||`Request failed with status ${Y}`)}const W=Object.create(null),re=ie=>{const $e=J.res.headers[ie];$e?W[ie]=$e:ie!==ie.toLowerCase()&&re(ie.toLowerCase())};re("Cache-Control"),re("Content-Type"),Z.writeHead(200,W);const ue=await(0,f.$Ge)(J.stream);return void Z.end(ue.buffer)}async o(B,Z,he){const ae=he.query[d.$ug];if(typeof ae=="string"){const V=Object.create(null);V["Set-Cookie"]=C.serialize(d.$tg,ae,{sameSite:"lax",maxAge:60*60*24*7});const L=Object.create(null);for(const K in he.query)K!==d.$ug&&(L[K]=he.query[K]);const H=D.format({pathname:he.pathname,query:L});return V.Location=H,Z.writeHead(302,V),void Z.end()}const ee=!this.h.isBuilt&&this.h.args["use-test-resolver"],_=ee?"test+test":"remote";if(!_)return o(B,Z,400,"Bad request.");function z(V){return JSON.stringify(V).replace(/"/g,"&quot;")}let T;this.h.args["enable-smoke-test-driver"]&&(T=!1);const J=V=>V&&h.URI.file(P.resolve(V)).with({scheme:d.Schemas.vscodeRemote,authority:_}),Y=d.$Cg.asFileUri(this.h.isBuilt?"vs/code/browser/workbench/workbench.html":"vs/code/browser/workbench/workbench-dev.html").fsPath,W=!this.h.isBuilt&&this.h.args["github-auth"]?{id:(0,c.$Eg)(),providerId:"github",accessToken:this.h.args["github-auth"],scopes:[["user:email"],["repo"]]}:void 0,re=(0,e.$qQ)((0,e.$sQ)(B)),ue=(0,e.$rQ)((0,e.$sQ)(B)),ie={codeServerVersion:this.k.codeServerVersion,rootEndpoint:re,updateEndpoint:this.h.args["disable-update-check"]?void 0:re+"/update/check",logoutEndpoint:this.h.args.auth&&this.h.args.auth!=="none"?re+"/logout":void 0,proxyEndpointTemplate:process.env.VSCODE_PROXY_URI??re+"/proxy/{{port}}/",serviceWorker:{scope:ue+"/",path:re+"/_static/out/browser/serviceWorker.js"},enableTelemetry:this.k.enableTelemetry,embedderIdentifier:"server-distro",extensionsGallery:this.k.extensionsGallery};if(!this.h.isBuilt)try{const V=JSON.parse((await A.Promises.readFile((0,g.$kc)(i,"product.overrides.json"))).toString());Object.assign(ie,V)}catch{}const $e={remoteAuthority:_,serverBasePath:this.g,webviewEndpoint:ue+this.b+"/out/vs/workbench/contrib/webview/browser/pre",userDataPath:this.h.userDataPath,isEnabledFileDownloads:!this.h.args["disable-file-downloads"],isEnabledFileUploads:!this.h.args["disable-file-uploads"],isEnabledCoderGettingStarted:!this.h.args["disable-getting-started-override"],_wrapWebWorkerExtHostInIframe:T,developmentOptions:{enableSmokeTestDriver:this.h.args["enable-smoke-test-driver"]?!0:void 0,logLevel:this.i.getLevel()},settingsSyncOptions:!this.h.isBuilt&&this.h.args["enable-sync"]?{enabled:!0}:void 0,enableWorkspaceTrust:!this.h.args["disable-workspace-trust"],folderUri:J(this.h.args["default-folder"]),workspaceUri:J(this.h.args["default-workspace"]),productConfiguration:ie,callbackRoute:this.c},ne=this.h.args.locale||await(0,t.$Zl)(this.h.argvResource.fsPath),U=await(0,t.$Yl)(ne,this.h.userDataPath),R=this.k.extensionsGallery?.nlsBaseUrl,q={WORKBENCH_WEB_CONFIGURATION:z($e),WORKBENCH_AUTH_SESSION:W?z(W):"",WORKBENCH_WEB_BASE_URL:ue+this.b,WORKBENCH_NLS_BASE_URL:ue+(R?`${R}${R.endsWith("/")?"":"/"}${this.k.commit}/${this.k.version}/`:""),BASE:re,VS_BASE:ue,NLS_CONFIGURATION:z(U)};if(ee){const V=[];for(const L of["vscode-test-resolver","github-authentication"]){const H=JSON.parse((await A.Promises.readFile(d.$Cg.asFileUri(`${d.$xg}/${L}/package.json`).fsPath)).toString());V.push({extensionPath:L,packageJSON:H})}q.WORKBENCH_BUILTIN_EXTENSIONS=z(V)}let X;try{X=(await A.Promises.readFile(Y)).toString().replace(/\{\{([^}]+)\}\}/g,(L,H)=>q[H]??"undefined")}catch{return Z.writeHead(404,{"Content-Type":"text/plain"}),void Z.end("Not found")}const x={"Content-Type":"text/html","Content-Security-Policy":["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'self';",`script-src 'self' 'unsafe-eval' ${this.p(X).join(" ")} 'sha256-75NYUUvf+5++1WbfCZOV3PSWxBhONpaxwx+mkOFRv/Y=' ;`,"child-src 'self';","frame-src 'self' https://*.vscode-cdn.net data:;","worker-src 'self' data: blob:;","style-src 'self' 'unsafe-inline';","connect-src 'self' ws: wss: https:;","font-src 'self' blob:;","manifest-src 'self';"].join(" ")};return this.f.type!==0&&(x["Set-Cookie"]=C.serialize(d.$tg,this.f.value,{sameSite:"lax",maxAge:60*60*24*7})),Z.writeHead(200,x),void Z.end(X)}p(B){const Z=/<script>([\s\S]+?)<\/script>/img,he=[];let ae;for(;ae=Z.exec(B);){const ee=k.createHash("sha256"),_=ae[1].replace(/\r\n/g,`
`),z=ee.update(Buffer.from(_)).digest().toString("base64");he.push(`'sha256-${z}'`)}return he}async q(B){const Z=d.$Cg.asFileUri("vs/code/browser/workbench/callback.html").fsPath,he=(await A.Promises.readFile(Z)).toString(),ae=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'none';",`script-src 'self' ${this.p(he).join(" ")};`,"style-src 'self' 'unsafe-inline';","font-src 'self' blob:;"].join(" ");return B.writeHead(200,{"Content-Type":"text/html","Content-Security-Policy":ae}),void B.end(he)}};e.$oQ=v,e.$oQ=v=Fe([Ne(3,w.$Zm),Ne(4,y.$Oj),Ne(5,u.$Ap),Ne(6,m.$8j)],v);const S=(I,B=!1)=>I.replace(/\/\/+/g,"/").replace(/\/+$/,B?"/":"");e.$pQ=S;const O=I=>{const B=(I.split("?",1)[0].match(/\//g)||[]).length;return(0,e.$pQ)("./"+(B>1?"../".repeat(B-1):""))};e.$qQ=O;const N=I=>{const B=I.split("?",1)[0].split("/");return(0,e.$pQ)("./"+B[B.length-1])};e.$rQ=N;const j=I=>I.originalUrl||I.url;e.$sQ=j}),define(Ee[276],ke([1,0,5]),function(ce,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5O=void 0,e.$5O=(0,n.$ii)("IExtHostInitDataService")}),define(Ee[277],ke([1,0,5]),function(ce,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PO=e.$OO=void 0,e.$OO=(0,n.$ii)("IExtHostRpcService");class A{constructor(D){this.getProxy=D.getProxy.bind(D),this.set=D.set.bind(D),this.dispose=D.dispose.bind(D),this.assertRegistered=D.assertRegistered.bind(D),this.drain=D.drain.bind(D)}}e.$PO=A}),define(Ee[71],ke([1,0,54]),function(ce,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ls=P;function A(D){return{transformIncoming:C=>C.scheme==="vscode-remote"?{scheme:"file",path:C.path,query:C.query,fragment:C.fragment}:C.scheme==="file"?{scheme:"vscode-local",path:C.path,query:C.query,fragment:C.fragment}:C,transformOutgoing:C=>C.scheme==="file"?{scheme:"vscode-remote",authority:D,path:C.path,query:C.query,fragment:C.fragment}:C.scheme==="vscode-local"?{scheme:"file",path:C.path,query:C.query,fragment:C.fragment}:C,transformOutgoingScheme:C=>C==="file"?"vscode-remote":C==="vscode-local"?"file":C}}function P(D){return new n.$ln(A(D))}}),define(Ee[278],ke([1,0,4,43,3,71,54,106,249,7,19]),function(ce,e,n,A,P,D,C,k,b,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ss=void 0;class y{constructor(g,d,c,m){this.b=g,this.c=d,this.d=c,this.e=m}async call(g,d,c){switch(d){case"getEnvironmentData":{const m=c,u=(0,D.$ls)(m.remoteAuthority);let p=await this.f(m.profile);return p=(0,C.$nn)(p,u),p}case"getExtensionHostExitInfo":{const m=c;return this.e.getExitInfo(m.reconnectionToken)}case"getDiagnosticInfo":{const m=c,u={machineInfo:(0,b.$ps)()},p=m.includeProcesses?(0,k.$ns)(process.pid):Promise.resolve();let h=[];const f={};if(m.folders){const l=(0,D.$ls)("");h=m.folders.map(a=>P.URI.revive(l.transformIncoming(a))).filter(a=>a.scheme==="file").map(a=>(0,b.$os)(a.fsPath,["node_modules",".git"]).then(o=>{f[(0,$.$oc)(a.fsPath)]=o}))}return Promise.all([p,...h]).then(([l,t])=>(u.processes=l||void 0,u.workspaceMetadata=m.folders?f:void 0,u))}}throw new Error(`IPC Command ${d} not found`)}listen(g,d,c){throw new Error("Not supported")}async f(g){g&&!this.d.profiles.some(c=>c.id===g)&&await this.d.createProfile(g,g);let d=!1;if(process.platform==="linux"){const c=process.glibcVersion;d=(c?parseInt(c.split(".")[1]):28)<=27}return{pid:process.pid,connectionToken:this.b.type!==0?this.b.value:"",appRoot:P.URI.file(this.c.appRoot),settingsPath:this.c.machineSettingsResource,logsPath:this.c.logsHome,extensionHostLogsPath:(0,E.$Vg)(this.c.logsHome,`exthost${y.a++}`),globalStorageHome:this.d.defaultProfile.globalStorageHome,workspaceStorageHome:this.c.workspaceStorageHome,localHistoryHome:this.c.localHistoryHome,userHome:this.c.userHome,os:n.OS,arch:process.arch,marks:A.getMarks(),useHostProxy:!!this.c.args["use-host-proxy"],profiles:{home:this.d.profilesHome,all:[...this.d.profiles].map(c=>({...c}))},isUnsupportedGlibc:d}}}e.$ss=y,y.a=1}),define(Ee[279],ke([1,0,3,71,69,7,234]),function(ce,e,n,A,P,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vs=void 0;class k extends C.$ts{constructor(E,y){super(new P.$Wq(E),E),this.N=y,this.M=new Map,this.B(this.a)}c(E){let y=this.M.get(E.remoteAuthority);return y||(y=(0,A.$ls)(E.remoteAuthority),this.M.set(E.remoteAuthority,y)),y}f(E,y,w=!1){if(w&&y.path==="/vscode-resource"&&y.query){const g=JSON.parse(y.query).requestResourcePath;return n.URI.from({scheme:"file",path:g})}return n.URI.revive(E.transformIncoming(y))}L(E,y){return new b(E,y,this.b,this.N)}}e.$vs=k;class b extends C.$us{constructor(E,y,w,g){super(E,y,w,g)}j(E){const y=E.args["file-watcher-polling"];if(y){const w=y.split(D.$uc),g=Number(w[0]);if(g>0)return{usePolling:w.length>1?w.slice(1):!0,pollingInterval:g}}}m(E){if(E.extensionsPath)return[D.$hc.join(E.extensionsPath,"**")]}}}),define(Ee[94],ke([1,0,211,11,3,2,5,38,16,12,40,171,65]),function(ce,e,n,A,P,D,C,k,b,$,E,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$uF=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$lF=e.EditorInputCapabilities=e.$kF=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$aF=e.$_E=e.$$E=e.$0E=e.$9E=void 0,e.$bF=c,e.$cF=m,e.$dF=u,e.$eF=p,e.$fF=h,e.$gF=f,e.$hF=l,e.$iF=t,e.$jF=a,e.$mF=S,e.$nF=N,e.$oF=j,e.$pF=I,e.$qF=B,e.$rF=Z,e.$sF=he,e.$tF=J,e.$vF=re,e.$wF=ie,e.$xF=$e,e.$yF=ne,e.$9E={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$0E={id:"default",displayName:(0,n.localize)(0,null),providerDisplayName:(0,n.localize)(1,null)},e.$$E="workbench.editor.sidebysideEditor",e.$_E="workbench.editors.textDiffEditor",e.$aF="workbench.editors.binaryResourceDiffEditor";var g;(function(U){U[U.PROGRAMMATIC=1]="PROGRAMMATIC",U[U.USER=2]="USER",U[U.EDIT=3]="EDIT",U[U.NAVIGATION=4]="NAVIGATION",U[U.JUMP=5]="JUMP"})(g||(e.EditorPaneSelectionChangeReason=g={}));var d;(function(U){U[U.IDENTICAL=1]="IDENTICAL",U[U.SIMILAR=2]="SIMILAR",U[U.DIFFERENT=3]="DIFFERENT"})(d||(e.EditorPaneSelectionCompareResult=d={}));function c(U){const R=U;return!!R&&typeof R.getSelection=="function"&&!!R.onDidChangeSelection}function m(U){const R=U;return!!R&&typeof R.getScrollPosition=="function"&&typeof R.setScrollPosition=="function"&&!!R.onDidChangeScroll}function u(U,R,q){for(const X of q.visibleEditorPanes)if(X.group.id===R&&U.matches(X.input))return X.getViewState()}function p(U){if(S(U))return!1;const R=U;return P.URI.isUri(R?.resource)}function h(U){if(S(U))return!1;const R=U;return R?.original!==void 0&&R.modified!==void 0}function f(U){if(S(U))return!1;const R=U;return!R||R.resources&&!Array.isArray(R.resources)?!1:!!R.resources||!!R.multiDiffSource}function l(U){if(S(U)||h(U))return!1;const R=U;return R?.primary!==void 0&&R.secondary!==void 0}function t(U){if(S(U))return!1;const R=U;return R?R.resource===void 0||R.resource.scheme===$.Schemas.untitled||R.forceUntitled===!0:!1}function a(U){if(S(U))return!1;const R=U;return P.URI.isUri(R?.base?.resource)&&P.URI.isUri(R?.input1?.resource)&&P.URI.isUri(R?.input2?.resource)&&P.URI.isUri(R?.result?.resource)}var o;(function(U){U[U.SHORT=0]="SHORT",U[U.MEDIUM=1]="MEDIUM",U[U.LONG=2]="LONG"})(o||(e.Verbosity=o={}));var r;(function(U){U[U.EXPLICIT=1]="EXPLICIT",U[U.AUTO=2]="AUTO",U[U.FOCUS_CHANGE=3]="FOCUS_CHANGE",U[U.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(r||(e.SaveReason=r={}));class s{constructor(){this.a=new Map}registerSource(R,q){let X=this.a.get(R);return X||(X={source:R,label:q},this.a.set(R,X)),X.source}getSourceLabel(R){return this.a.get(R)?.label??R}}e.$kF=new s;var i;(function(U){U[U.None=0]="None",U[U.Readonly=2]="Readonly",U[U.Untitled=4]="Untitled",U[U.Singleton=8]="Singleton",U[U.RequiresTrust=16]="RequiresTrust",U[U.CanSplitInGroup=32]="CanSplitInGroup",U[U.ForceDescription=64]="ForceDescription",U[U.CanDropIntoEditor=128]="CanDropIntoEditor",U[U.MultipleEditors=256]="MultipleEditors",U[U.Scratchpad=512]="Scratchpad"})(i||(e.EditorInputCapabilities=i={}));class v extends D.$Uc{}e.$lF=v;function S(U){return U instanceof v}function O(U){const R=U;return P.URI.isUri(R?.preferredResource)}function N(U){const R=U;return S(R?.primary)&&S(R?.secondary)}function j(U){const R=U;return S(R?.modified)&&S(R?.original)}function I(U,R,q,X,le){return ne(X,[(0,y.$5i)({id:"workbench.action.openLargeFile",label:(0,n.localize)(2,null),run:()=>{const Q={...q,limits:{size:Number.MAX_VALUE}};U.openEditor(R,Q)}}),(0,y.$5i)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,n.localize)(3,null),run:()=>le.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:w.default.Warning})}function B(U){return S(U?.editor)}function Z(U){const R=U;return B(U)&&R?.group!==void 0}function he(U){const R=U;return typeof R?.groupId=="number"&&S(R.editor)}var ae;(function(U){U[U.UNKNOWN=0]="UNKNOWN",U[U.REPLACE=1]="REPLACE",U[U.MOVE=2]="MOVE",U[U.UNPIN=3]="UNPIN"})(ae||(e.EditorCloseContext=ae={}));var ee;(function(U){U[U.GROUP_ACTIVE=0]="GROUP_ACTIVE",U[U.GROUP_INDEX=1]="GROUP_INDEX",U[U.GROUP_LABEL=2]="GROUP_LABEL",U[U.GROUP_LOCKED=3]="GROUP_LOCKED",U[U.EDITOR_OPEN=4]="EDITOR_OPEN",U[U.EDITOR_CLOSE=5]="EDITOR_CLOSE",U[U.EDITOR_MOVE=6]="EDITOR_MOVE",U[U.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",U[U.EDITOR_LABEL=8]="EDITOR_LABEL",U[U.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",U[U.EDITOR_PIN=10]="EDITOR_PIN",U[U.EDITOR_TRANSIENT=11]="EDITOR_TRANSIENT",U[U.EDITOR_STICKY=12]="EDITOR_STICKY",U[U.EDITOR_DIRTY=13]="EDITOR_DIRTY",U[U.EDITOR_WILL_DISPOSE=14]="EDITOR_WILL_DISPOSE"})(ee||(e.GroupModelChangeKind=ee={}));var _;(function(U){U[U.PRIMARY=1]="PRIMARY",U[U.SECONDARY=2]="SECONDARY",U[U.BOTH=3]="BOTH",U[U.ANY=4]="ANY"})(_||(e.SideBySideEditor=_={}));class z{getOriginalUri(R,q){if(!R)return;if(a(R))return e.$uF.getOriginalUri(R.result,q);if(q?.supportSideBySide){const{primary:le,secondary:Q}=this.a(R);if(le&&Q){if(q?.supportSideBySide===_.BOTH)return{primary:this.getOriginalUri(le,{filterByScheme:q.filterByScheme}),secondary:this.getOriginalUri(Q,{filterByScheme:q.filterByScheme})};if(q?.supportSideBySide===_.ANY)return this.getOriginalUri(le,{filterByScheme:q.filterByScheme})??this.getOriginalUri(Q,{filterByScheme:q.filterByScheme});R=q.supportSideBySide===_.PRIMARY?le:Q}}if(h(R)||f(R)||l(R)||a(R))return;const X=O(R)?R.preferredResource:R.resource;return!X||!q||!q.filterByScheme?X:this.b(X,q.filterByScheme)}a(R){return N(R)||l(R)?{primary:R.primary,secondary:R.secondary}:j(R)||h(R)?{primary:R.modified,secondary:R.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(R,q){if(!R)return;if(a(R))return e.$uF.getCanonicalUri(R.result,q);if(q?.supportSideBySide){const{primary:le,secondary:Q}=this.a(R);if(le&&Q){if(q?.supportSideBySide===_.BOTH)return{primary:this.getCanonicalUri(le,{filterByScheme:q.filterByScheme}),secondary:this.getCanonicalUri(Q,{filterByScheme:q.filterByScheme})};if(q?.supportSideBySide===_.ANY)return this.getCanonicalUri(le,{filterByScheme:q.filterByScheme})??this.getCanonicalUri(Q,{filterByScheme:q.filterByScheme});R=q.supportSideBySide===_.PRIMARY?le:Q}}if(h(R)||f(R)||l(R)||a(R))return;const X=R.resource;return!X||!q||!q.filterByScheme?X:this.b(X,q.filterByScheme)}b(R,q){if(Array.isArray(q)){if(q.some(X=>R.scheme===X))return R}else if(q===R.scheme)return R}}var T;(function(U){U[U.UNKNOWN=0]="UNKNOWN",U[U.KEYBOARD=1]="KEYBOARD",U[U.MOUSE=2]="MOUSE"})(T||(e.EditorCloseMethod=T={}));function J(U,R,q,X){if(!U.isSticky(R))return!1;switch(X.preventPinnedEditorClose){case"keyboardAndMouse":return q===T.MOUSE||q===T.KEYBOARD;case"mouse":return q===T.MOUSE;case"keyboard":return q===T.KEYBOARD}return!1}e.$uF=new z;var Y;(function(U){U[U.LEFT=0]="LEFT",U[U.RIGHT=1]="RIGHT"})(Y||(e.CloseDirection=Y={}));class W{constructor(){this.c=new Map,this.d=new Map}start(R){const q=this.a=R.get(C.$hi);for(const[X,le]of this.c)this.e(X,le,q);this.c.clear()}e(R,q,X){const le=X.createInstance(q);this.d.set(R,le)}registerFileEditorFactory(R){if(this.b)throw new Error("Can only register one file editor factory.");this.b=R}getFileEditorFactory(){return(0,A.$7f)(this.b)}registerEditorSerializer(R,q){if(this.c.has(R)||this.d.has(R))throw new Error(`A editor serializer with type ID '${R}' was already registered.`);return this.a?this.e(R,q,this.a):this.c.set(R,q),(0,D.$Sc)(()=>{this.c.delete(R),this.d.delete(R)})}getEditorSerializer(R){return this.d.get(typeof R=="string"?R:R.typeId)}}k.$2n.add(e.$9E.EditorFactory,new W);async function re(U,R,q){return!U||!U.length?[]:await Promise.all(U.map(async X=>{const le=P.URI.revive(X.fileUri);if(!le){q.info("Cannot resolve the path because it is not valid.",X);return}if(!await R.canHandleResource(le)){q.info("Cannot resolve the path because it cannot be handled",X);return}let x=X.exists,V=X.type;if(typeof x!="boolean"||typeof V!="number")try{V=(await R.stat(le)).isDirectory?b.FileType.Directory:b.FileType.Unknown,x=!0}catch(H){q.error(H),x=!1}if(!x&&X.openOnlyIfExists){q.info("Cannot resolve the path because it does not exist",X);return}if(V===b.FileType.Directory){q.info("Cannot resolve the path because it is a directory",X);return}const L={...X.options,pinned:!0};return x?{resource:le,options:L}:{resource:le,options:L,forceUntitled:!0}}))}var ue;(function(U){U[U.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",U[U.SEQUENTIAL=1]="SEQUENTIAL"})(ue||(e.EditorsOrder=ue={}));function ie(U){const R=U;if(!R)return!1;const q=R;if(q.modified)return ie(q.modified);const X=R;return!!(X.contributionsState&&X.viewState&&Array.isArray(X.cursorState))}function $e(U){return(0,E.$7i)(U)}function ne(U,R,q){const X=(0,E.$8i)(U,R);return X.forceMessage=q?.forceMessage,X.forceSeverity=q?.forceSeverity,X.allowDialog=q?.allowDialog,X}}),define(Ee[280],ke([1,0,6,41,2,57,5]),function(ce,e,n,A,P,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IG=e.$HG=e.$GG=e.ChatAgentLocation=void 0;var k;(function(E){E.Panel="panel",E.Terminal="terminal",E.Notebook="notebook",E.Editor="editor"})(k||(e.ChatAgentLocation=k={})),function(E){function y(w){switch(w){case"panel":return E.Panel;case"terminal":return E.Terminal;case"notebook":return E.Notebook}return E.Panel}E.fromRaw=y}(k||(e.ChatAgentLocation=k={})),e.$GG=(0,C.$ii)("chatAgentService");let b=class{constructor(y){this.e=y,this.b=[],this.d=new n.$7d,this.onDidChangeAgents=this.d.event}registerAgent(y,w){if(this.getAgent(y))throw new Error(`Agent already registered: ${JSON.stringify(y)}`);const d=this,c=w.slashCommands;w={...w,get slashCommands(){return c.filter(u=>!u.when||d.e.contextMatchesRules(D.$gj.deserialize(u.when)))}};const m={data:w};return this.b.push(m),(0,P.$Sc)(()=>{this.b=this.b.filter(u=>u!==m),this.d.fire(void 0)})}registerAgentImplementation(y,w){const g=this.f(y);if(!g)throw new Error(`Unknown agent: ${JSON.stringify(y)}`);if(g.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(y)}`);return g.impl=w,this.d.fire(new $(g.data,w)),(0,P.$Sc)(()=>{g.impl=void 0,this.d.fire(void 0)})}registerDynamicAgent(y,w){const g={data:y,impl:w};return this.b.push(g),this.d.fire(new $(y,w)),(0,P.$Sc)(()=>{this.b=this.b.filter(d=>d!==g),this.d.fire(void 0)})}updateAgent(y,w){const g=this.f(y);if(!g?.impl)throw new Error(`No activated agent with id ${JSON.stringify(y)} registered`);g.data.metadata={...g.data.metadata,...w},this.d.fire(new $(g.data,g.impl))}getDefaultAgent(y){return this.getActivatedAgents().find(w=>!!w.isDefault&&w.locations.includes(y))}getSecondaryAgent(){return A.Iterable.find(this.b.values(),y=>!!y.data.metadata.isSecondary)?.data}f(y){return this.b.find(w=>w.data.id===y)}getAgent(y){return this.f(y)?.data}getAgents(){return this.b.map(y=>y.data)}getActivatedAgents(){return Array.from(this.b.values()).filter(y=>!!y.impl).map(y=>new $(y.data,y.impl))}getAgentsByName(y){return this.getAgents().filter(w=>w.name===y)}async invokeAgent(y,w,g,d,c){const m=this.f(y);if(!m?.impl)throw new Error(`No activated agent with id ${y}`);return await m.impl.invoke(w,g,d,c)}async getFollowups(y,w,g,d,c){const m=this.f(y);if(!m?.impl)throw new Error(`No activated agent with id ${y}`);return m.impl?.provideFollowups?m.impl.provideFollowups(w,g,d,c):[]}};e.$HG=b,b.AGENT_LEADER="@",e.$HG=b=Fe([Ne(0,D.$Aj)],b);class ${constructor(y,w){this.b=y,this.d=w}get id(){return this.b.id}get name(){return this.b.name??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get defaultImplicitVariables(){return this.b.defaultImplicitVariables}get locations(){return this.b.locations}async invoke(y,w,g,d){return this.d.invoke(y,w,g,d)}async provideFollowups(y,w,g,d){return this.d.provideFollowups?this.d.provideFollowups(y,w,g,d):[]}provideWelcomeMessage(y){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(y)}provideSampleQuestions(y){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(y)}}e.$IG=$}),define(Ee[281],ke([1,0,5]),function(ce,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fP=void 0,e.$fP=(0,n.$ii)("environmentVariableService")}),define(Ee[282],ke([1,0,7,3,62,4,126,11]),function(ce,e,n,A,P,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HP=b,e.$IP=E,e.$JP=g,e.$KP=d,e.$LP=c,e.$MP=u,e.$NP=p,e.$OP=h,e.$PP=f;function b(l,t){if(t)if(D.$c)for(const a in t){let o=a;for(const s in l)if(a.toLowerCase()===s.toLowerCase()){o=s;break}const r=t[a];r!==void 0&&$(l,o,r)}else Object.keys(t).forEach(a=>{const o=t[a];o!==void 0&&$(l,a,o)})}function $(l,t,a){typeof a=="string"?l[t]=a:delete l[t]}function E(l,t,a,o){l.TERM_PROGRAM="vscode",t&&(l.TERM_PROGRAM_VERSION=t),g(l,o)&&(l.LANG=d(a)),l.COLORTERM="truecolor"}function y(l,t){if(t)for(const a of Object.keys(t)){const o=t[a];o!=null&&(l[a]=o)}}async function w(l,t){return await Promise.all(Object.entries(t).map(async([a,o])=>{if(typeof o=="string")try{t[a]=await l(o)}catch{t[a]=o}})),t}function g(l,t){if(t==="on")return!0;if(t==="auto"){const a=l.LANG;return!a||a.search(/\.UTF\-8$/)===-1&&a.search(/\.utf8$/)===-1&&a.search(/\.euc.+/)===-1}return!1}function d(l){const t=l?l.split("-"):[],a=t.length;if(a===0)return"en_US.UTF-8";if(a===1){const o={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};t[0]in o&&t.push(o[t[0]])}else t[1]=t[1].toUpperCase();return t.join("_")+".UTF-8"}async function c(l,t,a,o,r,s){if(l.cwd){const v=typeof l.cwd=="object"?l.cwd.fsPath:l.cwd,S=await m(v,a);return(0,C.$EP)(S||v)}let i;return!l.ignoreConfigurationCwd&&r&&(a&&(r=await m(r,a,s)),r&&(n.$jc(r)?i=r:o&&(i=n.$kc(o.fsPath,r)))),i||(i=o?o.fsPath:t||""),(0,C.$EP)(i)}async function m(l,t,a){if(t)try{return await t(l)}catch(o){a?.error("Could not resolve terminal cwd",o);return}return l}function u(l,t,a){if(a)return o=>a.resolveWithEnvironment(t,l,o)}async function p(l,t,a,o,r,s){const i={};if(l.strictEnv)y(i,l.env);else{y(i,s);const v={...t};a&&(v&&await w(a,v),l.env&&await w(a,l.env)),D.$d&&(i.VSCODE_NODE_OPTIONS&&(i.NODE_OPTIONS=i.VSCODE_NODE_OPTIONS,delete i.VSCODE_NODE_OPTIONS),i.VSCODE_NODE_REPL_EXTERNAL_MODULE&&(i.NODE_REPL_EXTERNAL_MODULE=i.VSCODE_NODE_REPL_EXTERNAL_MODULE,delete i.VSCODE_NODE_REPL_EXTERNAL_MODULE)),(0,P.$_l)(i,"VSCODE_IPC_HOOK_CLI","VSCODE_PROXY_URI"),b(i,v),b(i,l.env),E(i,o,D.$q,r)}return i}async function h(l,t,a,o,r,s,i=D.$c){let v;if((0,k.$Vf)(l)?v=l:(v=l.fsPath,i&&s!==1?v=v.replace(/\\/g,"/"):!i&&s===1&&(v=v.replace(/\//g,"\\"))),!t)return v;const S=v.includes(" "),O=v.includes("(")||v.includes(")"),N=n.$oc(t,".exe"),j=N==="pwsh"||a==="pwsh"||N==="powershell"||a==="powershell";if(j&&(S||v.includes("'")))return`& '${v.replace(/'/g,"''")}'`;if(O&&j)return`& '${v}'`;if(s===1){if(o!==void 0)return o==="gitbash"?(0,C.$CP)(v.replace(/\\/g,"/")):o==="wsl"?r?.getWslPath(v,"win-to-unix")||v:S?`"${v}"`:v;const I=t.toLowerCase();return I.includes("wsl")||I.includes("bash.exe")&&!I.toLowerCase().includes("git")?r?.getWslPath(v,"win-to-unix")||v:S?`"${v}"`:v}return(0,C.$CP)(v)}function f(l,t,a){const o=typeof l=="string"?A.URI.parse(l):l;let r=o?t.getWorkspaceFolder(o)??void 0:void 0;if(!r){const s=a.getLastActiveWorkspaceRoot();r=s?t.getWorkspaceFolder(s)??void 0:void 0}return r}}),define(Ee[72],ke([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eL=e.TestPosition=e.TestIdPathParts=void 0;var n;(function(D){D.Delimiter="\0"})(n||(e.TestIdPathParts=n={}));var A;(function(D){D[D.IsSame=0]="IsSame",D[D.Disconnected=1]="Disconnected",D[D.IsChild=2]="IsChild",D[D.IsParent=3]="IsParent"})(A||(e.TestPosition=A={}));class P{static fromExtHostTestItem(C,k,b=C.parent){if(C._isRoot)return new P([k]);const $=[C.id];for(let E=b;E&&E.id!==k;E=E.parent)$.push(E.id);return $.push(k),new P($.reverse())}static isRoot(C){return!C.includes("\0")}static root(C){const k=C.indexOf("\0");return k===-1?C:C.slice(0,k)}static fromString(C){return new P(C.split("\0"))}static join(C,k){return new P([...C.path,k])}static joinToString(C,k){return C.toString()+"\0"+k}static parentId(C){const k=C.lastIndexOf("\0");return k===-1?void 0:C.slice(0,k)}static localId(C){const k=C.lastIndexOf("\0");return k===-1?C:C.slice(k+1)}static isChild(C,k){return k.startsWith(C)&&k[C.length]==="\0"}static compare(C,k){return C===k?0:P.isChild(C,k)?2:P.isChild(k,C)?3:1}constructor(C,k=C.length){if(this.path=C,this.d=k,C.length===0||k<1)throw new Error("cannot create test with empty path")}get rootId(){return new P(this.path,1)}get parentId(){return this.d>1?new P(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let C=1;C<=this.d;C++)yield new P(this.path,C)}*idsToRoot(){for(let C=this.d;C>0;C--)yield new P(this.path,C)}compare(C){if(typeof C=="string")return P.compare(this.toString(),C);for(let k=0;k<C.d&&k<this.d;k++)if(C.path[k]!==this.path[k])return 1;return C.d>this.d?2:C.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let C=1;C<this.d;C++)this.c+="\0",this.c+=this.path[C]}return this.c}}e.$eL=P}),define(Ee[95],ke([1,0,3,79,45,72]),function(ce,e,n,A,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nL=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$mL=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$lL=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$kL=e.$jL=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$iL=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$hL=e.$gL=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$fL=e.TestResultState=void 0;var C;(function(ee){ee[ee.Unset=0]="Unset",ee[ee.Queued=1]="Queued",ee[ee.Running=2]="Running",ee[ee.Passed=3]="Passed",ee[ee.Failed=4]="Failed",ee[ee.Skipped=5]="Skipped",ee[ee.Errored=6]="Errored"})(C||(e.TestResultState=C={})),e.$fL={0:"unset",1:"queued",2:"running",3:"passed",4:"failed",5:"skipped",6:"errored"};var k;(function(ee){ee[ee.Run=1]="Run",ee[ee.Debug=2]="Debug",ee[ee.Coverage=3]="Coverage"})(k||(e.ExtTestRunProfileKind=k={}));var b;(function(ee){ee[ee.Run=2]="Run",ee[ee.Debug=4]="Debug",ee[ee.Coverage=8]="Coverage",ee[ee.HasNonDefaultProfile=16]="HasNonDefaultProfile",ee[ee.HasConfigurable=32]="HasConfigurable",ee[ee.SupportsContinuousRun=64]="SupportsContinuousRun"})(b||(e.TestRunProfileBitset=b={})),e.$gL=[2,4,8,16,32,64];const $=ee=>"runId"in ee;e.$hL=$;var E;(function(ee){ee.serialize=_=>({range:_.range.toJSON(),uri:_.uri.toJSON()}),ee.deserialize=(_,z)=>({range:P.$dt.lift(z.range),uri:_.asCanonicalUri(n.URI.revive(z.uri))})})(E||(e.IRichLocation=E={}));var y;(function(ee){ee[ee.Error=0]="Error",ee[ee.Output=1]="Output"})(y||(e.TestMessageType=y={}));var w;(function(ee){ee.serialize=_=>({message:_.message,type:0,expected:_.expected,actual:_.actual,contextValue:_.contextValue,location:_.location&&E.serialize(_.location)}),ee.deserialize=(_,z)=>({message:z.message,type:0,expected:z.expected,actual:z.actual,contextValue:z.contextValue,location:z.location&&E.deserialize(_,z.location)})})(w||(e.ITestErrorMessage=w={}));const g=(ee,_)=>`${_?"s":"e"}${ee}`;e.$iL=g;var d;(function(ee){ee.serialize=_=>({message:_.message,type:1,offset:_.offset,length:_.length,location:_.location&&E.serialize(_.location)}),ee.deserialize=(_,z)=>({message:z.message,type:1,offset:z.offset,length:z.length,location:z.location&&E.deserialize(_,z.location)})})(d||(e.ITestOutputMessage=d={}));var c;(function(ee){ee.serialize=_=>_.type===0?w.serialize(_):d.serialize(_),ee.deserialize=(_,z)=>z.type===0?w.deserialize(_,z):d.deserialize(_,z)})(c||(e.ITestMessage=c={}));var m;(function(ee){ee.serializeWithoutMessages=_=>({state:_.state,duration:_.duration,messages:[]}),ee.serialize=_=>({state:_.state,duration:_.duration,messages:_.messages.map(c.serialize)}),ee.deserialize=(_,z)=>({state:z.state,duration:z.duration,messages:z.messages.map(T=>c.deserialize(_,T))})})(m||(e.ITestTaskState=m={}));const u="\0",p=(ee,_)=>ee+u+_;e.$jL=p;const h=ee=>{const _=ee.indexOf(u);return{ctrlId:ee.slice(0,_),tagId:ee.slice(_+1)}};e.$kL=h;var f;(function(ee){ee.serialize=_=>({extId:_.extId,label:_.label,tags:_.tags,busy:_.busy,children:void 0,uri:_.uri?.toJSON(),range:_.range?.toJSON()||null,description:_.description,error:_.error,sortText:_.sortText}),ee.deserialize=(_,z)=>({extId:z.extId,label:z.label,tags:z.tags,busy:z.busy,children:void 0,uri:z.uri?_.asCanonicalUri(n.URI.revive(z.uri)):void 0,range:z.range?P.$dt.lift(z.range):null,description:z.description,error:z.error,sortText:z.sortText})})(f||(e.ITestItem=f={}));var l;(function(ee){ee[ee.NotExpandable=0]="NotExpandable",ee[ee.Expandable=1]="Expandable",ee[ee.BusyExpanding=2]="BusyExpanding",ee[ee.Expanded=3]="Expanded"})(l||(e.TestItemExpandState=l={}));var t;(function(ee){ee.serialize=_=>({expand:_.expand,item:f.serialize(_.item)}),ee.deserialize=(_,z)=>({controllerId:D.$eL.root(z.item.extId),expand:z.expand,item:f.deserialize(_,z.item)})})(t||(e.InternalTestItem=t={}));var a;(function(ee){ee.serialize=_=>{let z;return _.item&&(z={},_.item.label!==void 0&&(z.label=_.item.label),_.item.tags!==void 0&&(z.tags=_.item.tags),_.item.busy!==void 0&&(z.busy=_.item.busy),_.item.uri!==void 0&&(z.uri=_.item.uri?.toJSON()),_.item.range!==void 0&&(z.range=_.item.range?.toJSON()),_.item.description!==void 0&&(z.description=_.item.description),_.item.error!==void 0&&(z.error=_.item.error),_.item.sortText!==void 0&&(z.sortText=_.item.sortText)),{extId:_.extId,expand:_.expand,item:z}},ee.deserialize=_=>{let z;return _.item&&(z={},_.item.label!==void 0&&(z.label=_.item.label),_.item.tags!==void 0&&(z.tags=_.item.tags),_.item.busy!==void 0&&(z.busy=_.item.busy),_.item.range!==void 0&&(z.range=_.item.range?P.$dt.lift(_.item.range):null),_.item.description!==void 0&&(z.description=_.item.description),_.item.error!==void 0&&(z.error=_.item.error),_.item.sortText!==void 0&&(z.sortText=_.item.sortText)),{extId:_.extId,expand:_.expand,item:z}}})(a||(e.ITestItemUpdate=a={}));const o=(ee,_)=>{_.expand!==void 0&&(ee.expand=_.expand),_.item!==void 0&&(ee.item=ee.item?Object.assign(ee.item,_.item):_.item)};e.$lL=o;var r;(function(ee){ee.serializeWithoutMessages=_=>({...t.serialize(_),ownComputedState:_.ownComputedState,computedState:_.computedState,tasks:_.tasks.map(m.serializeWithoutMessages)}),ee.serialize=_=>({...t.serialize(_),ownComputedState:_.ownComputedState,computedState:_.computedState,tasks:_.tasks.map(m.serialize)}),ee.deserialize=(_,z)=>({...t.deserialize(_,z),ownComputedState:z.ownComputedState,computedState:z.computedState,tasks:z.tasks.map(T=>m.deserialize(_,T)),retired:!0})})(r||(e.TestResultItem=r={}));var s;(function(ee){ee.empty=()=>({covered:0,total:0}),ee.sum=(_,z)=>{_.covered+=z.covered,_.total+=z.total}})(s||(e.ICoverageCount=s={}));var i;(function(ee){ee.serialize=_=>({id:_.id,statement:_.statement,branch:_.branch,declaration:_.declaration,uri:_.uri.toJSON()}),ee.deserialize=(_,z)=>({id:z.id,statement:z.statement,branch:z.branch,declaration:z.declaration,uri:_.asCanonicalUri(n.URI.revive(z.uri))})})(i||(e.IFileCoverage=i={}));function v(ee){return{...ee,location:ee.location?.toJSON()}}function S(ee){return ee.location=ee.location?A.$ct.isIPosition(ee.location)?A.$ct.lift(ee.location):P.$dt.lift(ee.location):void 0,ee}e.$mL=3;var O;(function(ee){ee[ee.Declaration=0]="Declaration",ee[ee.Statement=1]="Statement",ee[ee.Branch=2]="Branch"})(O||(e.DetailType=O={}));var N;(function(ee){ee.serialize=_=>_.type===0?I.serialize(_):B.serialize(_),ee.deserialize=_=>_.type===0?I.deserialize(_):B.deserialize(_)})(N||(e.CoverageDetails=N={}));var j;(function(ee){ee.serialize=v,ee.deserialize=S})(j||(e.IBranchCoverage=j={}));var I;(function(ee){ee.serialize=v,ee.deserialize=S})(I||(e.IDeclarationCoverage=I={}));var B;(function(ee){ee.serialize=_=>({...v(_),branches:_.branches?.map(j.serialize)}),ee.deserialize=_=>({...S(_),branches:_.branches?.map(j.deserialize)})})(B||(e.IStatementCoverage=B={}));var Z;(function(ee){ee[ee.Add=0]="Add",ee[ee.Update=1]="Update",ee[ee.DocumentSynced=2]="DocumentSynced",ee[ee.Remove=3]="Remove",ee[ee.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",ee[ee.Retire=5]="Retire",ee[ee.AddTag=6]="AddTag",ee[ee.RemoveTag=7]="RemoveTag"})(Z||(e.TestDiffOpType=Z={}));var he;(function(ee){ee.deserialize=(_,z)=>z.op===0?{op:z.op,item:t.deserialize(_,z.item)}:z.op===1?{op:z.op,item:a.deserialize(z.item)}:z.op===2?{op:z.op,uri:_.asCanonicalUri(n.URI.revive(z.uri)),docv:z.docv}:z,ee.serialize=_=>_.op===0?{op:_.op,item:t.serialize(_.item)}:_.op===1?{op:_.op,item:a.serialize(_.item)}:_})(he||(e.TestsDiffOp=he={}));class ae{constructor(_){this.l=_,this.f=new Map,this.g=new Map,this.h=new Set,this.j=0,this.k=0,this.tags=this.f}apply(_){const z=this.w();for(const T of _)switch(T.op){case 0:this.o(t.deserialize(this.l,T.item),z);break;case 1:this.p(a.deserialize(T.item),z);break;case 3:this.q(T.itemId,z);break;case 5:this.v(T.itemId);break;case 4:this.updatePendingRoots(T.amount);break;case 6:this.f.set(T.tag.id,T.tag);break;case 7:this.f.delete(T.id);break}z.complete?.()}o(_,z){const T=D.$eL.parentId(_.item.extId)?.toString();let J;if(!T)J=this.x(_),this.h.add(J),this.g.set(_.item.extId,J);else if(this.g.has(T)){const Y=this.g.get(T);Y.children.add(_.item.extId),J=this.x(_,Y),this.g.set(_.item.extId,J)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(_)}`);return}return z.add?.(J),_.expand===2&&this.j++,J}p(_,z){const T=this.g.get(_.extId);if(T)return _.expand!==void 0&&(T.expand===2&&this.j--,_.expand===2&&this.j++),(0,e.$lL)(T,_),z.update?.(T),T}q(_,z){const T=this.g.get(_);if(!T)return;const J=D.$eL.parentId(T.item.extId)?.toString();J?this.g.get(J).children.delete(T.item.extId):this.h.delete(T);const Y=[[_]];for(;Y.length;)for(const W of Y.pop()){const re=this.g.get(W);re&&(Y.push(re.children),this.g.delete(W),z.remove?.(re,re!==T),re.expand===2&&this.j--)}}v(_){}updatePendingRoots(_){this.k+=_}w(){return{}}}e.$nL=ae}),define(Ee[134],ke([1,0,15,6,2,97,95,72]),function(ce,e,n,A,P,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IO=e.$HO=e.$GO=e.$FO=e.$EO=e.TestItemEventOp=void 0;var b;(function(p){p[p.Upsert=0]="Upsert",p[p.SetTags=1]="SetTags",p[p.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",p[p.RemoveChild=3]="RemoveChild",p[p.SetProp=4]="SetProp",p[p.Bulk=5]="Bulk",p[p.DocumentSynced=6]="DocumentSynced"})(b||(e.TestItemEventOp=b={}));const $=(p,h)=>p===h,y=Object.entries({range:(p,h)=>p===h?!0:!p||!h?!1:p.equalsRange(h),busy:$,label:$,description:$,error:$,sortText:$,tags:(p,h)=>!(p.length!==h.length||p.some(f=>!h.includes(f)))}),w=(p,h)=>{let f;for(const[l,t]of y)t(p[l],h[l])||(f?f[l]=h[l]:f={[l]:h[l]});return f};class g extends P.$Uc{get root(){return this.s.root}constructor(h){super(),this.s=h,this.f=this.B(new n.$uh(()=>this.flushDiff(),200)),this.g=this.B(new A.$7d),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(h){this.h=h;for(const f of this.tree.values())this.J(f)}get resolveHandler(){return this.h}collectDiff(){const h=this.m;return this.m=[],h}pushDiff(h){switch(h.op){case 2:{for(const f of this.m)if(f.op===2&&f.uri===h.uri){f.docv=h.docv;return}break}case 1:{const f=this.m[this.m.length-1];if(f){if(f.op===1&&f.item.extId===h.item.extId){(0,C.$lL)(f.item,h.item);return}if(f.op===0&&f.item.item.extId===h.item.extId){(0,C.$lL)(f.item,h.item);return}}break}}this.m.push(h),this.f.isScheduled()||this.f.schedule()}expand(h,f){const l=this.tree.get(h);if(l){if((l.expandLevels===void 0||f>l.expandLevels)&&(l.expandLevels=f),l.expand===1){const t=this.M(l);return t.isOpen()?this.L(l,f-1):t.wait().then(()=>this.L(l,f-1))}else if(l.expand===3)return l.resolveBarrier?.isOpen()===!1?l.resolveBarrier.wait().then(()=>this.L(l,f-1)):this.L(l,f-1)}}dispose(){for(const h of this.tree.values())this.s.getApiFor(h.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(h,f){switch(f.op){case 3:this.O(k.$eL.joinToString(h.fullId,f.id));break;case 0:this.z(f.item,h);break;case 5:for(const l of f.ops)this.w(h,l);break;case 1:this.C(f.new,f.old,h.fullId.toString());break;case 2:this.J(h);break;case 4:this.pushDiff({op:1,item:{extId:h.fullId.toString(),item:f.update}});break;case 6:this.y(h.actual.uri);break;default:(0,D.$0c)(f)}}y(h){h&&this.pushDiff({op:2,uri:h,docv:this.s.getDocumentVersion(h)})}z(h,f){const l=k.$eL.fromExtHostTestItem(h,this.root.id,f?.actual),t=this.s.getApiFor(h);t.parent&&t.parent!==f?.actual&&this.s.getChildren(t.parent).delete(h.id);let a=this.tree.get(l.toString());if(!a){a={fullId:l,actual:h,expandLevels:f?.expandLevels?f.expandLevels-1:void 0,expand:0},h.tags.forEach(this.D,this),this.tree.set(a.fullId.toString(),a),this.G(h,f),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:a.expand,item:this.s.toITestItem(h)}}),this.I(h,a,f);return}if(a.actual===h){this.H(h,a,f);return}if(a.actual.uri?.toString()!==h.uri?.toString())return this.O(l.toString()),this.z(h,f);const o=this.s.getChildren(a.actual),r=a.actual,s=w(this.s.toITestItem(r),this.s.toITestItem(h));this.s.getApiFor(r).listener=void 0,a.actual=h,a.expand=0,s&&(s.hasOwnProperty("tags")&&(this.C(h.tags,r.tags,l.toString()),delete s.tags),this.w(a,{op:4,update:s})),this.I(h,a,f);for(const[i,v]of o)this.s.getChildren(h).get(v.id)||this.O(k.$eL.joinToString(l,v.id));this.y(a.actual.uri)}C(h,f,l){const t=new Set(f.map(a=>a.id));for(const a of h)t.delete(a.id)||this.D(a);this.pushDiff({op:1,item:{extId:l,item:{tags:h.map(a=>(0,C.$jL)(this.s.controllerId,a.id))}}}),t.forEach(this.F,this)}D(h){const f=this.j.get(h.id);f?f.refCount++:(this.j.set(h.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,C.$jL)(this.s.controllerId,h.id)}}))}F(h){const f=this.j.get(h);f&&!--f.refCount&&(this.j.delete(h),this.pushDiff({op:7,id:(0,C.$jL)(this.s.controllerId,h)}))}G(h,f){this.s.getApiFor(h).parent=f&&f.actual!==this.root?f.actual:void 0}H(h,f,l){this.G(h,l);const t=this.s.getApiFor(h);t.parent=l?.actual,t.listener=a=>this.w(f,a),this.J(f)}I(h,f,l){this.H(h,f,l);for(const[t,a]of this.s.getChildren(h))this.z(a,f)}J(h){let f;this.h?h.resolveBarrier?f=h.resolveBarrier.isOpen()?3:2:f=h.actual.canResolveChildren?1:0:f=0,f!==h.expand&&(h.expand=f,this.pushDiff({op:1,item:{extId:h.fullId.toString(),expand:f}}),f===1&&h.expandLevels!==void 0&&this.M(h))}L(h,f){if(f<0)return;const l=[];for(const[t,a]of this.s.getChildren(h.actual)){const o=this.expand(k.$eL.joinToString(h.fullId,a.id),f);(0,n.$7g)(o)&&l.push(o)}if(l.length)return Promise.all(l).then(()=>{})}M(h){if(h.resolveBarrier)return h.resolveBarrier;if(!this.h){const a=new n.$hh;return a.open(),a}h.expand=2,this.N(h);const f=h.resolveBarrier=new n.$hh,l=a=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,a)};let t;try{t=this.h(h.actual===this.root?void 0:h.actual)}catch(a){l(a)}return(0,n.$7g)(t)?t.catch(l).then(()=>{f.open(),this.J(h)}):(f.open(),this.J(h)),h.resolveBarrier}N(h){this.pushDiff({op:1,item:{extId:h.fullId.toString(),expand:h.expand}})}O(h){const f=this.tree.get(h);if(!f)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:h});const l=[f];for(;l.length;){const t=l.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const a of t.actual.tags)this.F(a.id);this.tree.delete(t.fullId.toString());for(const[a,o]of this.s.getChildren(t.actual))l.push(this.tree.get(k.$eL.joinToString(t.fullId,o.id)))}}}flushDiff(){const h=this.collectDiff();h.length&&this.g.fire(h)}}e.$EO=g;class d extends Error{constructor(h){super(`Attempted to insert a duplicate test item ID ${h}`)}}e.$FO=d;class c extends Error{constructor(h){super(`TestItem with ID "${h}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$GO=c;class m extends Error{constructor(h,f,l){super(`TestItem with ID "${h}" is from controller "${f}" and cannot be added as a child of an item from controller "${l}".`)}}e.$HO=m;const u=(p,h,f)=>{let l=new Map;return{get size(){return l.size},forEach(t,a){for(const o of l.values())t.call(a,o,this)},[Symbol.iterator](){return l.entries()},replace(t){const a=new Map,o=new Set(l.keys()),r={op:5,ops:[]};for(const s of t){if(!(s instanceof f))throw new c(s.id);const i=h(s).controllerId;if(i!==p.controllerId)throw new m(s.id,i,p.controllerId);if(a.has(s.id))throw new d(s.id);a.set(s.id,s),o.delete(s.id),r.ops.push({op:0,item:s})}for(const s of o.keys())r.ops.push({op:3,id:s});p.listener?.(r),l=a},add(t){if(!(t instanceof f))throw new c(t.id);l.set(t.id,t),p.listener?.({op:0,item:t})},delete(t){l.delete(t)&&p.listener?.({op:3,id:t})},get(t){return l.get(t)},toJSON(){return Array.from(l.values())}}};e.$IO=u}),define(Ee[135],ke([1,0,134]),function(ce,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KO=e.$JO=void 0;const A=new WeakMap,P=(C,k)=>{const b={controllerId:k};return A.set(C,b),b};e.$JO=P;const D=C=>{const k=A.get(C);if(!k)throw new n.$GO(C?.id||"<unknown>");return k};e.$KO=D}),define(Ee[283],ke([1,0,25,5]),function(ce,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QE=e.$PE=e.$OE=e.$NE=e.$ME=e.$LE=e.$KE=e.$JE=e.$IE=e.$HE=e.$GE=e.$FE=e.$EE=e.$DE=e.$CE=e.$BE=e.$AE=e.$zE=e.$yE=e.$xE=e.$wE=e.$vE=e.$uE=e.$tE=e.$sE=void 0,e.$sE=".vscode",e.$tE="settings",e.$uE=`${e.$sE}/${e.$tE}.json`,e.$vE="vscode://schemas/settings/default",e.$wE="vscode://schemas/settings/user",e.$xE="vscode://schemas/settings/profile",e.$yE="vscode://schemas/settings/machine",e.$zE="vscode://schemas/settings/workspace",e.$AE="vscode://schemas/settings/folder",e.$BE="vscode://schemas/launch",e.$CE="vscode://schemas/tasks",e.$DE=[1],e.$EE=[2,3,4,5,6],e.$FE=[3,4,5],e.$GE=[1,...e.$FE],e.$HE=[2,3,4,5,6],e.$IE=[3,4,5,6],e.$JE=[4,5,6],e.$KE="tasks",e.$LE="launch",e.$ME=Object.create(null),e.$ME[e.$KE]=`${e.$sE}/${e.$KE}.json`,e.$ME[e.$LE]=`${e.$sE}/${e.$LE}.json`,e.$NE=Object.create(null),e.$NE[e.$KE]=`${e.$KE}.json`,e.$OE=(0,A.$ji)(n.$Oi),e.$PE=`{
	"version": "2.0.0",
	"tasks": []
}`,e.$QE="workbench.settings.applyToAllProfiles"}),define(Ee[136],ke([1,0,5]),function(ce,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BP=e.VariableKind=e.$AP=void 0,e.$AP=(0,n.$ii)("configurationResolverService");var A;(function(D){D.Unknown="unknown",D.Env="env",D.Config="config",D.Command="command",D.Input="input",D.ExtensionInstallFolder="extensionInstallFolder",D.WorkspaceFolder="workspaceFolder",D.Cwd="cwd",D.WorkspaceFolderBasename="workspaceFolderBasename",D.UserHome="userHome",D.LineNumber="lineNumber",D.SelectedText="selectedText",D.File="file",D.FileWorkspaceFolder="fileWorkspaceFolder",D.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",D.RelativeFile="relativeFile",D.RelativeFileDirname="relativeFileDirname",D.FileDirname="fileDirname",D.FileExtname="fileExtname",D.FileBasename="fileBasename",D.FileBasenameNoExtension="fileBasenameNoExtension",D.FileDirnameBasename="fileDirnameBasename",D.ExecPath="execPath",D.ExecInstallFolder="execInstallFolder",D.PathSeparator="pathSeparator",D.PathSeparatorAlias="/"})(A||(e.VariableKind=A={}));class P extends Error{constructor(C,k){super(k),this.variable=C}}e.$BP=P}),define(Ee[284],ke([1,0,7,30,11,21,4,160,212,136,17]),function(ce,e,n,A,P,D,C,k,b,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QP=void 0;class y{constructor(g,d,c,m){this.h=new Map,this.a=g,this.b=d,this.g=c,m&&(this.c=m.then(u=>this.i(u)))}i(g){if(C.$c){const d=Object.create(null);return Object.keys(g).forEach(c=>{d[c.toLowerCase()]=g[c]}),d}return g}resolveWithEnvironment(g,d,c){return this.l({env:this.i(g),userHome:void 0},d?d.uri:void 0,c)}async resolveAsync(g,d){const c={env:await this.c,userHome:await this.g};return this.l(c,g?g.uri:void 0,d)}async j(g,d,c,m){const u=D.$Pn(d);C.$c&&u.windows?Object.keys(u.windows).forEach(h=>u[h]=u.windows[h]):C.$d&&u.osx?Object.keys(u.osx).forEach(h=>u[h]=u.osx[h]):C.$e&&u.linux&&Object.keys(u.linux).forEach(h=>u[h]=u.linux[h]),delete u.windows,delete u.osx,delete u.linux;const p={env:await this.c,userHome:await this.g};return this.l(p,g?g.uri:void 0,u,c,m)}async resolveAnyAsync(g,d,c){return this.j(g,d,c)}async resolveAnyMap(g,d,c){const m=new Map;return{newConfig:await this.j(g,d,c,m),resolvedVariables:m}}resolveWithInteractionReplace(g,d,c,m){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(g,d,c,m){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(g,d){if(this.h.has(g))throw new Error("Variable "+g+" is contributed twice.");this.h.set(g,d)}async l(g,d,c,m,u){if(P.$Vf(c))return this.m(g,d,c,m,u);if(Array.isArray(c))return Promise.all(c.map(p=>this.l(g,d,p,m,u)));if(P.$Xf(c)){const p=Object.create(null),h=await Promise.all(Object.keys(c).map(async f=>[await this.m(g,d,f,m,u),await this.l(g,d,c[f],m,u)]));for(const[f,l]of h)p[f]=l;return p}return c}m(g,d,c,m,u){return(0,E.$df)(c,y.VARIABLE_REGEXP,async(p,h)=>{if(h.includes(y.VARIABLE_LHS))return p;let f=await this.o(g,p,h,d,m);return u?.set(h,f),f!==p&&P.$Vf(f)&&f.match(y.VARIABLE_REGEXP)&&(f=await this.m(g,d,f,m,u)),f})}n(g){return this.b?this.b.getUriLabel(g,{noPrefix:!0}):g.fsPath}async o(g,d,c,m,u){let p;const h=c.split(":");h.length>1&&(c=h[0],p=h[1]);const f=a=>{const o=this.a.getFilePath();if(o)return(0,k.$iw)(o);throw new $.$BP(a,(0,b.localize)(0,null,d))},l=a=>{const o=f(a);if(this.a.getWorkspaceFolderPathForFile){const r=this.a.getWorkspaceFolderPathForFile();if(r)return(0,k.$iw)(r)}throw new $.$BP(a,(0,b.localize)(1,null,d,n.$oc(o)))},t=a=>{if(p){const o=this.a.getFolderUri(p);if(o)return o;throw new $.$BP(a,(0,b.localize)(2,null,d,p))}if(m)return m;throw this.a.getWorkspaceFolderCount()>1?new $.$BP(a,(0,b.localize)(3,null,d)):new $.$BP(a,(0,b.localize)(4,null,d))};switch(c){case"env":if(p){if(g.env){const a=g.env[C.$c?p.toLowerCase():p];if(P.$Vf(a))return a}return""}throw new $.$BP($.VariableKind.Env,(0,b.localize)(5,null,d));case"config":if(p){const a=this.a.getConfigurationValue(m,p);if(P.$5f(a))throw new $.$BP($.VariableKind.Config,(0,b.localize)(6,null,d,p));if(P.$Xf(a))throw new $.$BP($.VariableKind.Config,(0,b.localize)(7,null,d,p));return a}throw new $.$BP($.VariableKind.Config,(0,b.localize)(8,null,d));case"command":return this.p($.VariableKind.Command,d,p,u,"command");case"input":return this.p($.VariableKind.Input,d,p,u,"input");case"extensionInstallFolder":if(p){const a=await this.a.getExtension(p);if(!a)throw new $.$BP($.VariableKind.ExtensionInstallFolder,(0,b.localize)(9,null,d,p));return this.n(a.extensionLocation)}throw new $.$BP($.VariableKind.ExtensionInstallFolder,(0,b.localize)(10,null,d));default:switch(c){case"workspaceRoot":case"workspaceFolder":return(0,k.$iw)(this.n(t($.VariableKind.WorkspaceFolder)));case"cwd":return m||p?(0,k.$iw)(this.n(t($.VariableKind.Cwd))):A.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,k.$iw)(n.$oc(this.n(t($.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(g.userHome)return g.userHome;throw new $.$BP($.VariableKind.UserHome,(0,b.localize)(11,null,d))}case"lineNumber":{const a=this.a.getLineNumber();if(a)return a;throw new $.$BP($.VariableKind.LineNumber,(0,b.localize)(12,null,d))}case"selectedText":{const a=this.a.getSelectedText();if(a)return a;throw new $.$BP($.VariableKind.SelectedText,(0,b.localize)(13,null,d))}case"file":return f($.VariableKind.File);case"fileWorkspaceFolder":return l($.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return n.$oc(l($.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return m||p?n.$mc(this.n(t($.VariableKind.RelativeFile)),f($.VariableKind.RelativeFile)):f($.VariableKind.RelativeFile);case"relativeFileDirname":{const a=n.$nc(f($.VariableKind.RelativeFileDirname));if(m||p){const o=n.$mc(this.n(t($.VariableKind.RelativeFileDirname)),a);return o.length===0?".":o}return a}case"fileDirname":return n.$nc(f($.VariableKind.FileDirname));case"fileExtname":return n.$pc(f($.VariableKind.FileExtname));case"fileBasename":return n.$oc(f($.VariableKind.FileBasename));case"fileBasenameNoExtension":{const a=n.$oc(f($.VariableKind.FileBasenameNoExtension));return a.slice(0,a.length-n.$pc(a).length)}case"fileDirnameBasename":return n.$oc(n.$nc(f($.VariableKind.FileDirnameBasename)));case"execPath":{const a=this.a.getExecPath();return a||d}case"execInstallFolder":{const a=this.a.getAppRoot();return a||d}case"pathSeparator":case"/":return n.sep;default:try{const a=p?`${c}:${p}`:c;return this.p($.VariableKind.Unknown,d,a,u,void 0)}catch{return d}}}}p(g,d,c,m,u){if(c&&m){const p=u===void 0?m[c]:m[u+":"+c];if(typeof p=="string")return p;throw new $.$BP(g,(0,b.localize)(14,null,d))}return d}}e.$QP=y,y.VARIABLE_LHS="${",y.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Ee[285],ke([1,0,5,94]),function(ce,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$BD=void 0,e.$CD=$,e.$DD=w,e.$ED=g,e.$BD=(0,n.$ii)("editorGroupsService");var P;(function(d){d[d.UP=0]="UP",d[d.DOWN=1]="DOWN",d[d.LEFT=2]="LEFT",d[d.RIGHT=3]="RIGHT"})(P||(e.GroupDirection=P={}));var D;(function(d){d[d.HORIZONTAL=0]="HORIZONTAL",d[d.VERTICAL=1]="VERTICAL"})(D||(e.GroupOrientation=D={}));var C;(function(d){d[d.FIRST=0]="FIRST",d[d.LAST=1]="LAST",d[d.NEXT=2]="NEXT",d[d.PREVIOUS=3]="PREVIOUS"})(C||(e.GroupLocation=C={}));var k;(function(d){d[d.MAXIMIZE=0]="MAXIMIZE",d[d.EXPAND=1]="EXPAND",d[d.EVEN=2]="EVEN"})(k||(e.GroupsArrangement=k={}));var b;(function(d){d[d.COPY_EDITORS=0]="COPY_EDITORS",d[d.MOVE_EDITORS=1]="MOVE_EDITORS"})(b||(e.MergeGroupMode=b={}));function $(d){const c=d;return(0,A.$mF)(c?.editor)&&(0,A.$mF)(c?.replacement)}var E;(function(d){d[d.CREATION_TIME=0]="CREATION_TIME",d[d.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",d[d.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(E||(e.GroupsOrder=E={}));var y;(function(d){d[d.NEW_EDITOR=1]="NEW_EDITOR",d[d.MOVE_EDITOR=2]="MOVE_EDITOR",d[d.COPY_EDITOR=3]="COPY_EDITOR"})(y||(e.OpenEditorContext=y={}));function w(d){const c=d;return!!c&&typeof c.id=="number"&&Array.isArray(c.editors)}function g(d){return d.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}}),define(Ee[137],ke([1,0,5,285]),function(ce,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ID=e.$HD=e.$GD=e.$FD=void 0,e.$JD=P,e.$FD=(0,n.$ii)("editorService"),e.$GD=-1,e.$HD=-2,e.$ID=-3;function P(D){const C=D;return typeof D=="number"||(0,A.$DD)(C)}}),define(Ee[286],ke([1,0,283,120,92,90,136,94,137,12,232,281,91]),function(ce,e,n,A,P,D,C,k,b,$,E,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TP=e.$SP=void 0,e.$SP="remoteterminal";let g=class{get onPtyHostExit(){return this.b.listen("$onPtyHostExitEvent")}get onPtyHostStart(){return this.b.listen("$onPtyHostStartEvent")}get onPtyHostUnresponsive(){return this.b.listen("$onPtyHostUnresponsiveEvent")}get onPtyHostResponsive(){return this.b.listen("$onPtyHostResponsiveEvent")}get onPtyHostRequestResolveVariables(){return this.b.listen("$onPtyHostRequestResolveVariablesEvent")}get onProcessData(){return this.b.listen("$onProcessDataEvent")}get onProcessExit(){return this.b.listen("$onProcessExitEvent")}get onProcessReady(){return this.b.listen("$onProcessReadyEvent")}get onProcessReplay(){return this.b.listen("$onProcessReplayEvent")}get onProcessOrphanQuestion(){return this.b.listen("$onProcessOrphanQuestion")}get onExecuteCommand(){return this.b.listen("$onExecuteCommand")}get onDidRequestDetach(){return this.b.listen("$onDidRequestDetach")}get onDidChangeProperty(){return this.b.listen("$onDidChangeProperty")}constructor(c,m,u,p,h,f,l,t,a,o){this.a=c,this.b=m,this.c=u,this.d=p,this.e=h,this.f=f,this.g=l,this.h=t,this.i=a,this.j=o}restartPtyHost(){return this.b.call("$restartPtyHost",[])}async createProcess(c,m,u,p,h,f,l,t){await this.c.whenRemoteConfigurationLoaded();const a=Object.create(null),o=u?this.d.getWorkspaceFolder(u)??void 0:void 0;let r;try{r=(await this.e.resolveAnyMap(o,{shellLaunchConfig:c,configuration:m})).resolvedVariables}catch(B){this.h.error(B)}if(r)for(const[B,Z]of r.entries())(/^config:/.test(B)||B==="selectedText"||B==="lineNumber")&&(a[B]=Z);const s=[];for(const[B,Z]of this.f.collections.entries())s.push([B,(0,D.$8r)(Z.map),(0,D.$9r)(Z.descriptionMap)]);const i=await this.g.resolveAuthority(this.a),v=i.options&&i.options.extensionHostEnv,S=this.d.getWorkspace(),O=S.folders,N=u?this.d.getWorkspaceFolder(u):null,j=k.$uF.getOriginalUri(this.i.activeEditor,{supportSideBySide:k.SideBySideEditor.PRIMARY,filterByScheme:[$.Schemas.file,$.Schemas.vscodeUserData,$.Schemas.vscodeRemote]}),I={configuration:m,resolvedVariables:a,envVariableCollections:s,shellLaunchConfig:c,workspaceId:S.id,workspaceName:this.j.getWorkspaceLabel(S),workspaceFolders:O,activeWorkspaceFolder:N,activeFileResource:j,shouldPersistTerminal:h,options:p,cols:f,rows:l,unicodeVersion:t,resolverEnv:v};return await this.b.call("$createProcess",I)}requestDetachInstance(c,m){return this.b.call("$requestDetachInstance",[c,m])}acceptDetachInstanceReply(c,m){return this.b.call("$acceptDetachInstanceReply",[c,m])}attachToProcess(c){return this.b.call("$attachToProcess",[c])}detachFromProcess(c,m){return this.b.call("$detachFromProcess",[c,m])}listProcesses(){return this.b.call("$listProcesses")}getLatency(){return this.b.call("$getLatency")}getPerformanceMarks(){return this.b.call("$getPerformanceMarks")}reduceConnectionGraceTime(){return this.b.call("$reduceConnectionGraceTime")}processBinary(c,m){return this.b.call("$processBinary",[c,m])}start(c){return this.b.call("$start",[c])}input(c,m){return this.b.call("$input",[c,m])}acknowledgeDataEvent(c,m){return this.b.call("$acknowledgeDataEvent",[c,m])}setUnicodeVersion(c,m){return this.b.call("$setUnicodeVersion",[c,m])}shutdown(c,m){return this.b.call("$shutdown",[c,m])}resize(c,m,u){return this.b.call("$resize",[c,m,u])}clearBuffer(c){return this.b.call("$clearBuffer",[c])}getInitialCwd(c){return this.b.call("$getInitialCwd",[c])}getCwd(c){return this.b.call("$getCwd",[c])}orphanQuestionReply(c){return this.b.call("$orphanQuestionReply",[c])}sendCommandResult(c,m,u){return this.b.call("$sendCommandResult",[c,m,u])}freePortKillProcess(c){return this.b.call("$freePortKillProcess",[c])}installAutoReply(c,m){return this.b.call("$installAutoReply",[c,m])}uninstallAllAutoReplies(){return this.b.call("$uninstallAllAutoReplies",[])}getDefaultSystemShell(c){return this.b.call("$getDefaultSystemShell",[c])}getProfiles(c,m,u){return this.b.call("$getProfiles",[this.d.getWorkspace().id,c,m,u])}acceptPtyHostResolvedVariables(c,m){return this.b.call("$acceptPtyHostResolvedVariables",[c,m])}getEnvironment(){return this.b.call("$getEnvironment")}getWslPath(c,m){return this.b.call("$getWslPath",[c,m])}setTerminalLayoutInfo(c){const u={workspaceId:this.d.getWorkspace().id,tabs:c?c.tabs:[]};return this.b.call("$setTerminalLayoutInfo",u)}updateTitle(c,m,u){return this.b.call("$updateTitle",[c,m,u])}updateIcon(c,m,u,p){return this.b.call("$updateIcon",[c,m,u,p])}refreshProperty(c,m){return this.b.call("$refreshProperty",[c,m])}updateProperty(c,m,u){return this.b.call("$updateProperty",[c,m,u])}getTerminalLayoutInfo(){const m={workspaceId:this.d.getWorkspace().id};return this.b.call("$getTerminalLayoutInfo",m)}reviveTerminalProcesses(c,m,u){return this.b.call("$reviveTerminalProcesses",[c,m,u])}getRevivedPtyNewId(c){return this.b.call("$getRevivedPtyNewId",[c])}serializeTerminalState(c){return this.b.call("$serializeTerminalState",[c])}};e.$TP=g,e.$TP=g=Fe([Ne(2,n.$OE),Ne(3,P.$ri),Ne(4,C.$AP),Ne(5,y.$fP),Ne(6,A.$tl),Ne(7,w.$Ur),Ne(8,b.$FD),Ne(9,E.$Lv)],g)}),define(Ee[287],ke([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_m=e.$$m=e.$0m=e.ExtHostConnectionType=void 0,e.$an=k,e.$bn=b;var n;(function(E){E[E.IPC=1]="IPC",E[E.Socket=2]="Socket",E[E.MessagePort=3]="MessagePort"})(n||(e.ExtHostConnectionType=n={}));class A{constructor(y){this.pipeName=y,this.type=1}serialize(y){y[A.ENV_KEY]=this.pipeName}}e.$0m=A,A.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK";class P{constructor(){this.type=2}serialize(y){y[P.ENV_KEY]="1"}}e.$$m=P,P.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET";class D{constructor(){this.type=3}serialize(y){y[D.ENV_KEY]="1"}}e.$_m=D,D.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT";function C(E){delete E[A.ENV_KEY],delete E[P.ENV_KEY],delete E[D.ENV_KEY]}function k(E,y){C(y),E.serialize(y)}function b(E){if(E[A.ENV_KEY])return $(E,new A(E[A.ENV_KEY]));if(E[P.ENV_KEY])return $(E,new P);if(E[D.ENV_KEY])return $(E,new D);throw new Error("No connection information defined in environment!")}function $(E,y){return C(E),y}}),define(Ee[288],ke([1,0,14]),function(ce,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$Mm=C,e.$Nm=k;var A;(function($){$[$.Desktop=1]="Desktop",$[$.Web=2]="Web"})(A||(e.UIKind=A={}));var P;(function($){$[$.VersionMismatch=55]="VersionMismatch",$[$.UnexpectedError=81]="UnexpectedError"})(P||(e.ExtensionHostExitCode=P={}));var D;(function($){$[$.Initialized=0]="Initialized",$[$.Ready=1]="Ready",$[$.Terminate=2]="Terminate"})(D||(e.MessageType=D={}));function C($){const E=n.$ue.alloc(1);switch($){case 0:E.writeUInt8(1,0);break;case 1:E.writeUInt8(2,0);break;case 2:E.writeUInt8(3,0);break}return E}function k($,E){if($.byteLength!==1)return!1;switch($.readUInt8(0)){case 1:return E===0;case 2:return E===1;case 3:return E===2;default:return!1}}var b;(function($){$.Start="START_NATIVE_LOG",$.End="END_NATIVE_LOG"})(b||(e.NativeLogMarkers=b={}))}),define(Ee[289],ke([1,0,5,6,13,276,288,85,39,21,3,2,210]),function(ce,e,n,A,P,D,C,k,b,$,E,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9O=e.$7O=e.$6O=void 0,e.$8O=c;let g=class extends y.$Uc{constructor(u,p){super(),this.s=u,this.t=p,this.a=this.B(new A.$7d),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new A.$7d),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=E.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=p.createLogger(this.m,{id:b.$0o,name:(0,w.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(p.onDidChangeLogLevel(h=>{(0,P.$Qj)(h)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===P.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(u,p,h){const f=this.getTelemetryDetails(),l=new d(p,h,u,this.n,this.j,this.getBuiltInCommonProperties(u),{isUsageEnabled:f.isUsageEnabled,isErrorsEnabled:f.isErrorsEnabled}),t=this.r.get(u.identifier.value)??[];return this.r.set(u.identifier.value,[...t,l]),l.apiTelemetryLogger}$initializeTelemetryLevel(u,p,h){this.f=u,this.g=p,this.c=h??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(u){const p=Object.create(null);switch(p["common.extname"]=`${u.publisher}.${u.name}`,p["common.extversion"]=u.version,p["common.vscodemachineid"]=this.s.telemetryInfo.machineId,p["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,p["common.sqmid"]=this.s.telemetryInfo.sqmId,p["common.vscodeversion"]=this.s.version,p["common.isnewappinstall"]=c(this.s.telemetryInfo.firstSessionDate),p["common.product"]=this.s.environment.appHost,this.s.uiKind){case C.UIKind.Web:p["common.uikind"]="web";break;case C.UIKind.Desktop:p["common.uikind"]="desktop";break;default:p["common.uikind"]="unknown"}return p["common.remotename"]=(0,k.$vm)((0,b.$dp)(this.s.remote.authority)),p}$onDidChangeTelemetryLevel(u){this.h=this.getTelemetryConfiguration(),this.f=u;const p=this.getTelemetryDetails();this.r.forEach((h,f)=>{const l=h.filter(t=>!t.isDisposed);l.length===0?this.r.delete(f):this.r.set(f,l)}),this.r.forEach(h=>{for(const f of h)f.updateTelemetryEnablements(p.isUsageEnabled,p.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(u,p){const f=this.r.get(u.value)?.filter(t=>!t.isDisposed);if(!f)return this.r.delete(u.value),!1;let l=!1;for(const t of f)t.ignoreUnhandledExtHostErrors||(t.logError(p),l=!0);return l}};e.$6O=g,e.$6O=g=Fe([Ne(0,D.$5O),Ne(1,P.$Pj)],g);class d{static validateSender(u){if(typeof u!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof u.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof u.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof u.flush<"u"&&typeof u.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(u,p,h,f,l,t,a){this.g=h,this.h=f,this.i=l,this.j=t,this.a=new A.$7d,this.ignoreUnhandledExtHostErrors=p?.ignoreUnhandledErrors??!1,this.b=p?.ignoreBuiltInCommonProperties??!1,this.c=p?.additionalCommonProperties,this.f=u,this.d={isUsageEnabled:a.isUsageEnabled,isErrorsEnabled:a.isErrorsEnabled}}updateTelemetryEnablements(u,p){this.e&&(this.d={isUsageEnabled:u,isErrorsEnabled:p},this.a.fire(this.e))}mixInCommonPropsAndCleanData(u){let p="properties"in u?u.properties??{}:u;return p=(0,b.$gp)(p,[]),this.c&&(p=(0,$.$Sn)(p,this.c)),this.b||(p=(0,$.$Sn)(p,this.j)),"properties"in u?u.properties=p:u=p,u}k(u,p){this.f&&(this.g.publisher==="vscode"?u=this.g.name+"/"+u:u=this.g.identifier.value+"/"+u,p=this.mixInCommonPropsAndCleanData(p||{}),this.i||this.f?.sendEventData(u,p),this.h.trace(u,p))}logUsage(u,p){this.d.isUsageEnabled&&this.k(u,p)}logError(u,p){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof u=="string")this.k(u,p);else{const h={name:u.name,message:u.message,stack:u.stack,cause:u.cause},f=(0,b.$gp)(h,[]),l=new Error(f.message,{cause:f.cause});l.stack=f.stack,l.name=f.name,p=this.mixInCommonPropsAndCleanData(p||{}),this.i||this.f.sendErrorData(l,p),this.h.trace("exception",p)}}get apiTelemetryLogger(){if(!this.e){const u=this,p={logUsage:u.logUsage.bind(u),get isUsageEnabled(){return u.d.isUsageEnabled},get isErrorsEnabled(){return u.d.isErrorsEnabled},logError:u.logError.bind(u),dispose:u.dispose.bind(u),onDidChangeEnableStates:u.a.event.bind(u)};this.e=Object.freeze(p)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let u=this.f;this.f=void 0,Promise.resolve(u.flush()).then(u=void 0),this.e=void 0}else this.f=void 0}}e.$7O=d;function c(m){const u=Date.now()-new Date(m).getTime();return isNaN(u)?!1:u<1e3*60*60*24}e.$9O=(0,n.$ii)("IExtHostTelemetry")}),define(Ee[290],ke([1,0,6,3,36,240,35,5]),function(ce,e,n,A,P,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iG=e.ActivationKind=e.$fG=e.$eG=e.$bG=e.ExtensionHostStartup=e.$aG=e.$_F=e.$$F=e.$0F=void 0,e.$cG=w,e.$dG=g,e.$gG=u,e.$hG=p,e.$0F=Object.freeze({identifier:new C.$Em("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:A.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$$F="extensions.webWorker",e.$_F=(0,k.$ii)("extensionService");class b{constructor(l){this.dependency=l}}e.$aG=b;var $;(function(f){f[f.EagerAutoStart=1]="EagerAutoStart",f[f.EagerManualStart=2]="EagerManualStart",f[f.Lazy=3]="Lazy"})($||(e.ExtensionHostStartup=$={}));class E{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(l,t,a){this.c=l,this.d=t.slice(0),this.e=a.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:D.$UF.createActivationEventsMap(this.d)}}set(l,t,a){if(this.c>l)throw new Error(`ExtensionHostExtensions: invalid versionId ${l} (current: ${this.c})`);const o=[],r=[],s=[],i=[],v=y(this.d),S=y(t),O=(Z,he)=>Z.extensionLocation.toString()===he.extensionLocation.toString()||Z.isBuiltin===he.isBuiltin||Z.isUserBuiltin===he.isUserBuiltin||Z.isUnderDevelopment===he.isUnderDevelopment;for(const Z of this.d){const he=S.get(Z.identifier);if(!he){o.push(Z.identifier),v.delete(Z.identifier);continue}if(!O(Z,he)){o.push(Z.identifier),v.delete(Z.identifier);continue}}for(const Z of t){const he=v.get(Z.identifier);if(!he){r.push(Z);continue}if(!O(he,Z)){o.push(he.identifier),v.delete(he.identifier);continue}}const N=new C.$Fm(this.e),j=new C.$Fm(a);for(const Z of this.e)j.has(Z)||s.push(Z);for(const Z of a)N.has(Z)||i.push(Z);const I=D.$UF.createActivationEventsMap(r),B={versionId:l,toRemove:o,toAdd:r,addActivationEvents:I,myToRemove:s,myToAdd:i};return this.delta(B),B}delta(l){if(this.c>=l.versionId)return null;const{toRemove:t,toAdd:a,myToRemove:o,myToAdd:r}=l,s=new C.$Fm(t),i=new C.$Fm(o);for(let v=0;v<this.d.length;v++)s.has(this.d[v].identifier)&&(this.d.splice(v,1),v--);for(let v=0;v<this.e.length;v++)i.has(this.e[v])&&(this.e.splice(v,1),v--);for(const v of a)this.d.push(v);for(const v of r)this.e.push(v);return this.f=null,l}containsExtension(l){for(const t of this.e)if(C.$Em.equals(t,l))return!0;return!1}containsActivationEvent(l){return this.f||(this.f=this.g()),this.f.has(l)}g(){const l=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const a=D.$UF.readActivationEvents(t);for(const o of a)l.add(o)}return l}}e.$bG=E;function y(f){const l=new C.$Gm;for(const t of f)l.set(t.identifier,t);return l}function w(f,l){return!0}function g(f,l){if(!w(f,l))throw new Error(`Extension '${f.identifier.value}' CANNOT use API proposal: ${l}.
Its package.json#enabledApiProposals-property declares: ${f.enabledApiProposals?.join(", ")??"[]"} but NOT ${l}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${f.identifier.value}`)}class d{constructor(l,t,a,o){this.codeLoadingTime=l,this.activateCallTime=t,this.activateResolvedTime=a,this.activationReason=o}}e.$eG=d;class c{constructor(l,t){this.description=l,this.value=t}}e.$fG=c;var m;(function(f){f[f.Normal=0]="Normal",f[f.Immediate=1]="Immediate"})(m||(e.ActivationKind=m={}));function u(f){return{type:f.isBuiltin?0:1,isBuiltin:f.isBuiltin||f.isUserBuiltin,identifier:{id:(0,P.$mp)(f.publisher,f.name),uuid:f.uuid},manifest:f,location:f.extensionLocation,targetPlatform:f.targetPlatform,validations:[],isValid:!0}}function p(f,l){return{identifier:new C.$Em((0,P.$kp)(f.manifest.publisher,f.manifest.name)),isBuiltin:f.type===0,isUserBuiltin:f.type===1&&f.isBuiltin,isUnderDevelopment:!!l,extensionLocation:f.location,...f.manifest,uuid:f.identifier.uuid,targetPlatform:f.targetPlatform}}class h{constructor(){this.onDidRegisterExtensions=n.Event.None,this.onDidChangeExtensionsStatus=n.Event.None,this.onDidChangeExtensions=n.Event.None,this.onWillActivateByEvent=n.Event.None,this.onDidChangeResponsiveChange=n.Event.None,this.onWillStop=n.Event.None,this.extensions=[]}activateByEvent(l){return Promise.resolve(void 0)}activateById(l,t){return Promise.resolve(void 0)}activationEventIsDone(l){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(l){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(l,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(l){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$iG=h}),define(Ee[291],ke([1,0,35,213,56]),function(ce,e,n,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cQ=D;function D(C,k,b,$){const E=new n.$Gm;return C.forEach(y=>{const w=E.get(y.identifier);w&&$.warn((0,A.localize)(0,null,w.extensionLocation.fsPath,y.extensionLocation.fsPath)),E.set(y.identifier,y)}),k.forEach(y=>{const w=E.get(y.identifier);if(w)if(w.isBuiltin){if(P.gte(w.version,y.version)){$.warn(`Skipping extension ${y.extensionLocation.path} in favour of the builtin extension ${w.extensionLocation.path}.`);return}y.isBuiltin=!0}else $.warn((0,A.localize)(1,null,w.extensionLocation.fsPath,y.extensionLocation.fsPath));else if(y.isBuiltin){$.warn(`Skipping obsolete builtin extension ${y.extensionLocation.path}`);return}E.set(y.identifier,y)}),b.forEach(y=>{$.info((0,A.localize)(2,null,y.extensionLocation.fsPath));const w=E.get(y.identifier);w&&w.isBuiltin&&(y.isBuiltin=!0),E.set(y.identifier,y)}),Array.from(E.values())}}),define(Ee[292],ke([1,0,7,4,30,3,43,54,57,59,291,12]),function(ce,e,n,A,P,D,C,k,b,$,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gQ=e.$fQ=void 0;class w{constructor(c,m,u,p,h,f,l){this.c=c,this.d=u,this.f=p,this.g=h,this.h=f,this.i=l,this.a=Promise.resolve(),this.b=Promise.resolve();const t=m.args["install-builtin-extension"];if(t){h.trace("Installing builtin extensions passed via args...");const o={isMachineScoped:!!m.args["do-not-sync"],installPreReleaseVersion:!!m.args["pre-release"]};C.mark("code/server/willInstallBuiltinExtensions"),this.b=this.a=c.installExtensions([],this.j(t),o,!!m.args.force).then(()=>{C.mark("code/server/didInstallBuiltinExtensions"),h.trace("Finished installing builtin extensions")},r=>{h.error(r)})}const a=m.args["install-extension"];a&&(h.trace("Installing extensions passed via args..."),this.b=this.a.then(()=>c.installExtensions(this.j(a),[],{isMachineScoped:!!m.args["do-not-sync"],installPreReleaseVersion:!!m.args["pre-release"],isApplicationScoped:!0},!!m.args.force)).then(()=>{h.trace("Finished installing extensions")},o=>{h.error(o)}))}j(c){return c.map(m=>/\.vsix$/i.test(m)?D.URI.file((0,n.$jc)(m)?m:(0,n.$kc)((0,P.cwd)(),m)):m)}whenExtensionsReady(){return this.b}async scanExtensions(c,m,u,p){C.mark("code/server/willScanExtensions"),this.g.trace(`Scanning extensions using UI language: ${c}`),await this.a;const h=u?u.filter(l=>l.scheme===y.Schemas.file).map(l=>l.fsPath):void 0;m=m??this.d.defaultProfile.extensionsResource;const f=await this.k(m,c??A.$q,h,p);return this.g.trace("Scanned Extensions",f),this.r(f),C.mark("code/server/didScanExtensions"),f}async scanSingleExtension(c,m,u){await this.a;const p=c.scheme===y.Schemas.file?c.fsPath:null;if(!p)return null;const h=await this.o(p,m,u??A.$q);return h?(this.r([h]),h):null}async k(c,m,u,p){await this.q(m,p);const[h,f,l]=await Promise.all([this.m(m),this.n(c,m),this.l(m,u)]);return(0,E.$cQ)(h,f,l,this.g)}async l(c,m){return m?(await Promise.all(m.map(u=>this.f.scanOneOrMultipleExtensions(D.URI.file((0,n.$lc)(u)),1,{language:c})))).flat().map(u=>(0,$.$jq)(u,!0)):[]}async m(c){return(await this.f.scanSystemExtensions({language:c,useCache:!0})).map(u=>(0,$.$jq)(u,!1))}async n(c,m){return(await this.f.scanUserExtensions({profileLocation:c,language:m,useCache:!0})).map(p=>(0,$.$jq)(p,!1))}async o(c,m,u){const p=D.URI.file((0,n.$lc)(c)),h=m?0:1,f=await this.f.scanExistingExtension(p,h,{language:u});return f?(0,$.$jq)(f,!1):null}async q(c,m){if(!(c===A.$a||!this.h.isEnabled())){try{if((await this.i.getInstalledLanguages()).find(p=>p.id===c)){this.g.trace(`Language Pack ${c} is already installed. Skipping language pack installation.`);return}}catch(u){this.g.error(u)}if(!m){this.g.trace(`No language pack id provided for language ${c}. Skipping language pack installation.`);return}this.g.trace(`Language Pack ${m} for language ${c} is not installed. It will be installed now.`);try{await this.c.installExtensions([m],[],{isMachineScoped:!0},!0)}catch(u){this.g.error(u)}}}r(c){const m=(t,a)=>t.replace(/file/g,"vscode-remote"),u=t=>{let a="";return a+=t.global?"g":"",a+=t.ignoreCase?"i":"",a+=t.multiline?"m":"",new RegExp(m(t.source,!0),a)},p=new class{mapDefined(t){return b.$lj.create(t)}mapNot(t){return b.$qj.create(t)}mapEquals(t,a){return t==="resourceScheme"&&typeof a=="string"?b.$mj.create(t,m(a,!1)):b.$mj.create(t,a)}mapNotEquals(t,a){return t==="resourceScheme"&&typeof a=="string"?b.$pj.create(t,m(a,!1)):b.$pj.create(t,a)}mapGreater(t,a){return b.$rj.create(t,a)}mapGreaterEquals(t,a){return b.$sj.create(t,a)}mapSmaller(t,a){return b.$tj.create(t,a)}mapSmallerEquals(t,a){return b.$uj.create(t,a)}mapRegex(t,a){return t==="resourceScheme"&&a?b.$vj.create(t,u(a)):b.$vj.create(t,a)}mapIn(t,a){return b.$nj.create(t,a)}mapNotIn(t,a){return b.$oj.create(t,a)}},h=t=>{if(!t||!t.when||!/resourceScheme/.test(t.when))return;const a=b.$gj.deserialize(t.when);if(!a)return;const o=a.map(p);t.when=o.serialize()},f=t=>{if(Array.isArray(t))for(const a of t)h(a);else h(t)},l=t=>{for(const a in t)f(t[a])};c.forEach(t=>{t.contributes&&(t.contributes.menus&&l(t.contributes.menus),t.contributes.keybindings&&f(t.contributes.keybindings),t.contributes.views&&l(t.contributes.views))})}}e.$fQ=w;class g{constructor(c,m){this.a=c,this.b=m}listen(c,m){throw new Error("Invalid listen")}async call(c,m,u){const p=this.b(c);switch(m){case"whenExtensionsReady":return this.a.whenExtensionsReady();case"scanExtensions":{const h=u[0],f=u[1]?D.URI.revive(p.transformIncoming(u[1])):void 0,l=Array.isArray(u[2])?u[2].map(o=>D.URI.revive(p.transformIncoming(o))):void 0,t=u[3];return(await this.a.scanExtensions(h,f,l,t)).map(o=>(0,k.$nn)(o,p))}case"scanSingleExtension":{const h=await this.a.scanSingleExtension(D.URI.revive(p.transformIncoming(u[0])),u[1],u[2]);return h?(0,k.$nn)(h,p):null}}throw new Error("Invalid call")}}e.$gQ=g}),define(Ee[138],ke([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fw=e.$cw=void 0,e.$dw=P,e.$ew=D;class n{constructor(b){this._proxyIdentifierBrand=void 0,this.sid=b,this.nid=++n.count}}e.$cw=n,n.count=0;const A=[];function P(k){const b=new n(k);return A[b.nid]=b,b}function D(k){return A[k].sid}class C{constructor(b){this.value=b}}e.$fw=C}),define(Ee[293],ke([1,0,138]),function(ce,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tM=e.$sM=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$rM=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var A;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(A||(e.TextEditorRevealType=A={}));var P;(function(c){c[c.UnknownInput=0]="UnknownInput",c[c.TextInput=1]="TextInput",c[c.TextDiffInput=2]="TextDiffInput",c[c.TextMergeInput=3]="TextMergeInput",c[c.NotebookInput=4]="NotebookInput",c[c.NotebookDiffInput=5]="NotebookDiffInput",c[c.CustomEditorInput=6]="CustomEditorInput",c[c.WebviewEditorInput=7]="WebviewEditorInput",c[c.TerminalEditorInput=8]="TerminalEditorInput",c[c.InteractiveEditorInput=9]="InteractiveEditorInput",c[c.ChatEditorInput=10]="ChatEditorInput",c[c.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(P||(e.TabInputKind=P={}));var D;(function(c){c[c.TAB_OPEN=0]="TAB_OPEN",c[c.TAB_CLOSE=1]="TAB_CLOSE",c[c.TAB_UPDATE=2]="TAB_UPDATE",c[c.TAB_MOVE=3]="TAB_MOVE"})(D||(e.TabModelOperationKind=D={}));var C;(function(c){c[c.Editable=0]="Editable",c[c.SupportsHotExit=1]="SupportsHotExit"})(C||(e.WebviewEditorCapabilities=C={}));var k;(function(c){c[c.Int8Array=1]="Int8Array",c[c.Uint8Array=2]="Uint8Array",c[c.Uint8ClampedArray=3]="Uint8ClampedArray",c[c.Int16Array=4]="Int16Array",c[c.Uint16Array=5]="Uint16Array",c[c.Int32Array=6]="Int32Array",c[c.Uint32Array=7]="Uint32Array",c[c.Float32Array=8]="Float32Array",c[c.Float64Array=9]="Float64Array",c[c.BigInt64Array=10]="BigInt64Array",c[c.BigUint64Array=11]="BigUint64Array"})(k||(e.WebviewMessageArrayBufferViewType=k={}));var b;(function(c){c[c.Text=1]="Text",c[c.Error=2]="Error",c[c.Rich=3]="Rich"})(b||(e.CellOutputKind=b={}));var $;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})($||(e.NotebookEditorRevealType=$={}));var E;(function(c){c[c.None=0]="None",c[c.Process=1]="Process",c[c.Output=2]="Output"})(E||(e.CandidatePortSource=E={}));class y{static mixin(m){return m._id=y.a++,m}}e.$rM=y,y.a=0;var w;(function(c){c.label="a",c.kind="b",c.detail="c",c.documentation="d",c.sortText="e",c.filterText="f",c.preselect="g",c.insertText="h",c.insertTextRules="i",c.range="j",c.commitCharacters="k",c.additionalTextEdits="l",c.kindModifier="m",c.commandIdent="n",c.commandId="o",c.commandArguments="p"})(w||(e.ISuggestDataDtoField=w={}));var g;(function(c){c.defaultRanges="a",c.completions="b",c.isIncomplete="c",c.duration="d"})(g||(e.ISuggestResultDtoField=g={}));var d;(function(c){c[c.Workspace=0]="Workspace",c[c.TextDocument=1]="TextDocument"})(d||(e.ExtHostTestingResource=d={})),e.$sM={MainThreadAuthentication:(0,n.$dw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,n.$dw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,n.$dw)("MainThreadLanguageModels"),MainThreadChatAgents2:(0,n.$dw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,n.$dw)("MainThreadChatVariables"),MainThreadClipboard:(0,n.$dw)("MainThreadClipboard"),MainThreadCommands:(0,n.$dw)("MainThreadCommands"),MainThreadComments:(0,n.$dw)("MainThreadComments"),MainThreadConfiguration:(0,n.$dw)("MainThreadConfiguration"),MainThreadConsole:(0,n.$dw)("MainThreadConsole"),MainThreadDebugService:(0,n.$dw)("MainThreadDebugService"),MainThreadDecorations:(0,n.$dw)("MainThreadDecorations"),MainThreadDiagnostics:(0,n.$dw)("MainThreadDiagnostics"),MainThreadDialogs:(0,n.$dw)("MainThreadDiaglogs"),MainThreadDocuments:(0,n.$dw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,n.$dw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,n.$dw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,n.$dw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,n.$dw)("MainThreadEditorTabs"),MainThreadErrors:(0,n.$dw)("MainThreadErrors"),MainThreadTreeViews:(0,n.$dw)("MainThreadTreeViews"),MainThreadDownloadService:(0,n.$dw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,n.$dw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,n.$dw)("MainThreadLanguages"),MainThreadLogger:(0,n.$dw)("MainThreadLogger"),MainThreadMessageService:(0,n.$dw)("MainThreadMessageService"),MainThreadOutputService:(0,n.$dw)("MainThreadOutputService"),MainThreadProgress:(0,n.$dw)("MainThreadProgress"),MainThreadQuickDiff:(0,n.$dw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,n.$dw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,n.$dw)("MainThreadStatusBar"),MainThreadSecretState:(0,n.$dw)("MainThreadSecretState"),MainThreadStorage:(0,n.$dw)("MainThreadStorage"),MainThreadSpeech:(0,n.$dw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,n.$dw)("MainThreadTelemetry"),MainThreadTerminalService:(0,n.$dw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,n.$dw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,n.$dw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,n.$dw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,n.$dw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,n.$dw)("MainThreadCustomEditors"),MainThreadUrls:(0,n.$dw)("MainThreadUrls"),MainThreadUriOpeners:(0,n.$dw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,n.$dw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,n.$dw)("MainThreadWorkspace"),MainThreadFileSystem:(0,n.$dw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,n.$dw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,n.$dw)("MainThreadExtensionService"),MainThreadSCM:(0,n.$dw)("MainThreadSCM"),MainThreadSearch:(0,n.$dw)("MainThreadSearch"),MainThreadShare:(0,n.$dw)("MainThreadShare"),MainThreadTask:(0,n.$dw)("MainThreadTask"),MainThreadWindow:(0,n.$dw)("MainThreadWindow"),MainThreadLabelService:(0,n.$dw)("MainThreadLabelService"),MainThreadNotebook:(0,n.$dw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,n.$dw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,n.$dw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,n.$dw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,n.$dw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,n.$dw)("MainThreadInteractive"),MainThreadChat:(0,n.$dw)("MainThreadChat"),MainThreadInlineChat:(0,n.$dw)("MainThreadInlineChatShape"),MainThreadTheming:(0,n.$dw)("MainThreadTheming"),MainThreadTunnelService:(0,n.$dw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,n.$dw)("MainThreadManagedSockets"),MainThreadTimeline:(0,n.$dw)("MainThreadTimeline"),MainThreadTesting:(0,n.$dw)("MainThreadTesting"),MainThreadLocalization:(0,n.$dw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,n.$dw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,n.$dw)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,n.$dw)("MainThreadIssueReporter")},e.$tM={ExtHostCommands:(0,n.$dw)("ExtHostCommands"),ExtHostConfiguration:(0,n.$dw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,n.$dw)("ExtHostDiagnostics"),ExtHostDebugService:(0,n.$dw)("ExtHostDebugService"),ExtHostDecorations:(0,n.$dw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,n.$dw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,n.$dw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,n.$dw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,n.$dw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,n.$dw)("ExtHostEditors"),ExtHostTreeViews:(0,n.$dw)("ExtHostTreeViews"),ExtHostFileSystem:(0,n.$dw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,n.$dw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,n.$dw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,n.$dw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,n.$dw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,n.$dw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,n.$dw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,n.$dw)("ExtHostStatusBar"),ExtHostShare:(0,n.$dw)("ExtHostShare"),ExtHostExtensionService:(0,n.$dw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,n.$dw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,n.$dw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,n.$dw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,n.$dw)("ExtHostSCM"),ExtHostSearch:(0,n.$dw)("ExtHostSearch"),ExtHostTask:(0,n.$dw)("ExtHostTask"),ExtHostWorkspace:(0,n.$dw)("ExtHostWorkspace"),ExtHostWindow:(0,n.$dw)("ExtHostWindow"),ExtHostWebviews:(0,n.$dw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,n.$dw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,n.$dw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,n.$dw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,n.$dw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,n.$dw)("ExtHostEditorTabs"),ExtHostProgress:(0,n.$dw)("ExtHostProgress"),ExtHostComments:(0,n.$dw)("ExtHostComments"),ExtHostSecretState:(0,n.$dw)("ExtHostSecretState"),ExtHostStorage:(0,n.$dw)("ExtHostStorage"),ExtHostUrls:(0,n.$dw)("ExtHostUrls"),ExtHostUriOpeners:(0,n.$dw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,n.$dw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,n.$dw)("ExtHostOutputService"),ExtHostLabelService:(0,n.$dw)("ExtHostLabelService"),ExtHostNotebook:(0,n.$dw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,n.$dw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,n.$dw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,n.$dw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,n.$dw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,n.$dw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,n.$dw)("ExtHostInteractive"),ExtHostInlineChat:(0,n.$dw)("ExtHostInlineChatShape"),ExtHostChat:(0,n.$dw)("ExtHostChat"),ExtHostChatAgents2:(0,n.$dw)("ExtHostChatAgents"),ExtHostChatVariables:(0,n.$dw)("ExtHostChatVariables"),ExtHostChatProvider:(0,n.$dw)("ExtHostChatProvider"),ExtHostSpeech:(0,n.$dw)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,n.$dw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,n.$dw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,n.$dw)("ExtHostTheming"),ExtHostTunnelService:(0,n.$dw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,n.$dw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,n.$dw)("ExtHostAuthentication"),ExtHostTimeline:(0,n.$dw)("ExtHostTimeline"),ExtHostTesting:(0,n.$dw)("ExtHostTesting"),ExtHostTelemetry:(0,n.$dw)("ExtHostTelemetry"),ExtHostLocalization:(0,n.$dw)("ExtHostLocalization"),ExtHostIssueReporter:(0,n.$dw)("ExtHostIssueReporter")}}),define(Ee[294],ke([1,0,14,24,12,111,5]),function(ce,e,n,A,P,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0J=e.$7J=void 0,e.$8J=E,e.$9J=y,e.$7J=(0,C.$ii)("notebookDocumentService");const k=["W","X","Y","Z","a","b","c","d","e","f"],b=new RegExp(`^[${k.join("")}]+`),$=7;function E(g){if(g.scheme!==P.Schemas.vscodeNotebookCell)return;const d=g.fragment.indexOf("s");if(d<0)return;const c=parseInt(g.fragment.substring(0,d).replace(b,""),$),m=(0,n.$Ne)(g.fragment.substring(d+1)).toString();if(!isNaN(c))return{handle:c,notebook:g.with({scheme:m,fragment:null})}}function y(g,d){const c=d.toString($),u=`${c.length<k.length?k[c.length-1]:"z"}${c}s${(0,n.$Oe)(n.$ue.fromString(g.scheme),!0,!0)}`;return g.with({scheme:P.Schemas.vscodeNotebookCell,fragment:u})}class w{constructor(){this.a=new A.$Bc}getNotebook(d){if(d.scheme===P.Schemas.vscodeNotebookCell){const c=E(d);if(c){const m=this.a.get(c.notebook);if(m)return m}}return this.a.get(d)}addNotebookDocument(d){this.a.set(d.uri,d)}removeNotebookDocument(d){this.a.delete(d.uri)}}e.$0J=w,(0,D.$hs)(e.$7J,w,1)}),define(Ee[139],ke([1,0,14,76,41,61,12,7,4,57,294]),function(ce,e,n,A,P,D,C,k,b,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rK=e.$oK=e.CellStatusbarAlignment=e.$nK=e.NotebookEditorPriority=e.$kK=e.$jK=e.$hK=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$gK=e.$fK=e.$eK=e.$dK=e.CellKind=e.$cK=e.$bK=e.$aK=void 0,e.$iK=a,e.$lK=r,e.$mK=s,e.$pK=S,e.$qK=N,e.$aK="workbench.editor.notebook",e.$bK="workbench.editor.notebookTextDiffEditor",e.$cK="workbench.editor.interactive";var y;(function(z){z[z.Markup=1]="Markup",z[z.Code=2]="Code"})(y||(e.CellKind=y={})),e.$dK=["application/json","application/javascript","text/html","image/svg+xml",D.$As.latex,D.$As.markdown,"image/png","image/jpeg",D.$As.text],e.$eK=[D.$As.latex,D.$As.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",D.$As.text],e.$fK=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$gK="_notAvailable";var w;(function(z){z[z.Running=1]="Running",z[z.Idle=2]="Idle"})(w||(e.NotebookRunState=w={}));var g;(function(z){z[z.Unconfirmed=1]="Unconfirmed",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(g||(e.NotebookCellExecutionState=g={}));var d;(function(z){z[z.Unconfirmed=1]="Unconfirmed",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(d||(e.NotebookExecutionState=d={}));var c;(function(z){z[z.WithHardKernelDependency=0]="WithHardKernelDependency",z[z.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",z[z.Pure=2]="Pure",z[z.Never=3]="Never"})(c||(e.NotebookRendererMatch=c={}));var m;(function(z){z.Always="always",z.Never="never",z.Optional="optional"})(m||(e.RendererMessagingSpec=m={}));var u;(function(z){z[z.ModelChange=1]="ModelChange",z[z.Move=2]="Move",z[z.ChangeCellLanguage=5]="ChangeCellLanguage",z[z.Initialize=6]="Initialize",z[z.ChangeCellMetadata=7]="ChangeCellMetadata",z[z.Output=8]="Output",z[z.OutputItem=9]="OutputItem",z[z.ChangeCellContent=10]="ChangeCellContent",z[z.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",z[z.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",z[z.ChangeCellMime=13]="ChangeCellMime",z[z.Unknown=100]="Unknown"})(u||(e.NotebookCellsChangeType=u={}));var p;(function(z){z[z.Handle=0]="Handle",z[z.Index=1]="Index"})(p||(e.SelectionStateType=p={}));var h;(function(z){z[z.Replace=1]="Replace",z[z.Output=2]="Output",z[z.Metadata=3]="Metadata",z[z.CellLanguage=4]="CellLanguage",z[z.DocumentMetadata=5]="DocumentMetadata",z[z.Move=6]="Move",z[z.OutputItems=7]="OutputItems",z[z.PartialMetadata=8]="PartialMetadata",z[z.PartialInternalMetadata=9]="PartialInternalMetadata"})(h||(e.CellEditType=h={}));var f;(function(z){z.scheme=C.Schemas.vscodeNotebookCell;function T(ie,$e){return(0,E.$9J)(ie,$e)}z.generate=T;function J(ie){return(0,E.$8J)(ie)}z.parse=J;function Y(ie,$e){return ie.with({scheme:C.Schemas.vscodeNotebookCellOutput,fragment:`op${$e??""},${ie.scheme!==C.Schemas.file?ie.scheme:""}`})}z.generateCellOutputUri=Y;function W(ie){if(ie.scheme!==C.Schemas.vscodeNotebookCellOutput)return;const $e=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ie.fragment);if(!$e)return;const ne=$e[1]&&$e[1]!==""?$e[1]:void 0,U=$e[2];return{outputId:ne,notebook:ie.with({scheme:U||C.Schemas.file,fragment:null})}}z.parseCellOutputUri=W;function re(ie,$e,ne){return z.generate(ie,$e).with({scheme:ne})}z.generateCellPropertyUri=re;function ue(ie,$e){if(ie.scheme===$e)return z.parse(ie.with({scheme:z.scheme}))}z.parseCellPropertyUri=ue})(f||(e.CellUri=f={}));const l=z=>b.$c?z.replace(/\//g,"\\"):z;class t{constructor(T=[],J=e.$dK){this.e=J,this.d=[...new Set(T)].map(Y=>({pattern:Y,matches:A.$ck(l(Y))}))}sort(T){const J=new Map(P.Iterable.map(T,W=>[W,l(W)]));let Y=[];for(const{matches:W}of this.d)for(const[re,ue]of J)if(W(ue)){Y.push(re),J.delete(re);break}return J.size&&(Y=Y.concat([...J.keys()].sort((W,re)=>this.e.indexOf(W)-this.e.indexOf(re)))),Y}prioritize(T,J){const Y=this.f(T);if(Y===-1){this.d.unshift({pattern:T,matches:A.$ck(l(T))});return}const W=new Set(J.map(ue=>this.f(ue,Y)));W.delete(-1);const re=Array.from(W).sort();this.d.splice(Y+1,0,...re.map(ue=>this.d[ue]));for(let ue=re.length-1;ue>=0;ue--)this.d.splice(re[ue],1)}toArray(){return this.d.map(T=>T.pattern)}f(T,J=this.d.length){const Y=l(T);for(let W=0;W<J;W++)if(this.d[W].matches(Y))return W;return-1}}e.$hK=t;function a(z,T,J,Y=(W,re)=>W===re){const W=[];function re($e,ne,U){if(ne===0&&U.length===0)return;const R=W[W.length-1];R&&R.start+R.deleteCount===$e?(R.deleteCount+=ne,R.toInsert.push(...U)):W.push({start:$e,deleteCount:ne,toInsert:U})}let ue=0,ie=0;for(;;){if(ue===z.length){re(ue,0,T.slice(ie));break}if(ie===T.length){re(ue,z.length-ue,[]);break}const $e=z[ue],ne=T[ie];if(Y($e,ne)){ue+=1,ie+=1;continue}J(ne)?(re(ue,1,[]),ue+=1):(re(ue,0,[ne]),ie+=1)}return W}e.$jK=new $.$zj("notebookEditorCursorAtBoundary","none"),e.$kK=new $.$zj("notebookEditorCursorAtLineBoundary","none");var o;(function(z){z.default="default",z.option="option"})(o||(e.NotebookEditorPriority=o={}));function r(z){const T=z;return!!((typeof T.include=="string"||A.$dk(T.include))&&(typeof T.exclude=="string"||A.$dk(T.exclude)))}function s(z,T,J){if(Array.isArray(z.viewType)&&z.viewType.indexOf(T)>=0||z.viewType===T)return!0;if(z.filenamePattern){const Y=r(z.filenamePattern)?z.filenamePattern.include:z.filenamePattern,W=r(z.filenamePattern)?z.filenamePattern.exclude:void 0;if(A.$bk(Y,(0,k.$oc)(J.fsPath).toLowerCase()))return!(W&&A.$bk(W,(0,k.$oc)(J.fsPath).toLowerCase()))}return!1}e.$nK={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics"};var i;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(i||(e.CellStatusbarAlignment=i={}));class v{static create(T){return`${v.d}${T}`}static parse(T){if(T.startsWith(v.d))return T.substring(v.d.length)}}e.$oK=v,v.d="notebook/";function S(z){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(z)}const O=new TextDecoder;function N(z){const T=[];let J=!1;for(const ue of z)(T.length===0||J)&&(T.push(ue),J=!0);let Y=B(T);const W=n.$ue.concat(T.map(ue=>n.$ue.wrap(ue))),re=_(W);return Y=Y||re.byteLength!==W.byteLength,{data:re,didCompression:Y}}e.$rK="\x1B[A";const j=e.$rK.split("").map(z=>z.charCodeAt(0)),I=10;function B(z){let T=!1;return z.forEach((J,Y)=>{if(Y===0||J.length<e.$rK.length)return;const W=z[Y-1],re=J.subarray(0,e.$rK.length);if(re[0]===j[0]&&re[1]===j[1]&&re[2]===j[2]){const ue=W.lastIndexOf(I);if(ue===-1)return;T=!0,z[Y-1]=W.subarray(0,ue),z[Y]=J.subarray(e.$rK.length)}}),T}function Z(z){let T=z;do z=T,T=z.replace(/[^\n]\x08/gm,"");while(T.length<z.length);return z}function he(z){for(z=z.replace(/\r+\n/gm,`
`);z.search(/\r[^$]/g)>-1;){const T=z.match(/^(.*)\r+/m)[1];let J=z.match(/\r+(.*)$/m)[1];J=J+T.slice(J.length,T.length),z=z.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,J)}return z}const ae=8,ee=13;function _(z){return!z.buffer.includes(ae)&&!z.buffer.includes(ee)?z:n.$ue.fromString(he(Z(O.decode(z.buffer))))}});var Tt=this&&this.__classPrivateFieldSet||function(ce,e,n,A,P){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ce!==e||!P:!e.has(ce))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?P.call(ce,n):P?P.value=n:e.set(ce,n),n},tt=this&&this.__classPrivateFieldGet||function(ce,e,n,A){if(n==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ce!==e||!A:!e.has(ce))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?A:n==="a"?A.call(ce):A?A.value:e.get(ce)};define(Ee[140],ke([1,0,18,10,102,24,61,17,11,3,22,35,16,120,139]),function(ce,e,n,A,P,D,C,k,b,$,E,y,w,g,d){"use strict";var c,m,u,p,h,f,l,t,a,o,r,s,i,v,S,O,N,j,I,B,Z,he,ae,ee,_;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$CO=e.KeywordRecognitionStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$BO=e.$AO=e.$zO=e.$yO=e.ChatLocation=e.$xO=e.$wO=e.$vO=e.$uO=e.$tO=e.$sO=e.$rO=e.$qO=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$pO=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$oO=e.$nO=e.$mO=e.$lO=e.$kO=e.$jO=e.$iO=e.$hO=e.$gO=e.$fO=e.$eO=e.$dO=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$cO=e.$bO=e.$aO=e.$_N=e.$0N=e.$9N=e.$8N=e.$7N=e.TestRunProfileKind=e.TestResultState=e.$6N=e.$5N=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$4N=e.NotebookVariablesRequestKind=e.$3N=e.$2N=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$1N=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$ZN=e.$YN=e.$XN=e.$WN=e.$VN=e.ColorThemeKind=e.$UN=e.$TN=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$SN=e.$RN=e.DebugConsoleMode=e.$QN=e.$PN=e.$ON=e.$NN=e.$MN=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$LN=e.$KN=e.FileChangeType=e.$JN=e.NewSymbolNameTag=e.$IN=e.$HN=e.$GN=e.$FN=e.InlineCompletionTriggerKind=e.$EN=e.$DN=e.$CN=e.$BN=e.$AN=e.$zN=e.$yN=e.$xN=e.$wN=e.$vN=e.$uN=e.$sN=e.ConfigurationTarget=e.$rN=e.$qN=e.$pN=e.$oN=e.DocumentPasteTriggerKind=e.$nN=e.$mN=e.$lN=e.$kN=e.$jN=e.$iN=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$hN=e.ViewBadge=e.ProgressLocation=e.$gN=e.$fN=e.TaskScope=e.ShellQuoting=e.$eN=e.$dN=e.$cN=e.TaskPanelKind=e.TaskRevealKind=e.$bN=e.TerminalLocation=e.$aN=e.$_M=e.$$M=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$0M=e.$9M=e.$8M=e.$7M=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$5M=e.$4M=e.$3M=e.$2M=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$1M=e.$ZM=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$YM=e.$XM=e.$WM=e.$VM=e.$UM=e.LanguageStatusSeverity=e.$TM=e.$SM=e.$RM=e.$QM=e.$PM=e.$OM=e.CodeActionTriggerKind=e.$NM=e.$MM=e.SymbolTag=e.SymbolKind=e.$LM=e.$KM=e.DocumentHighlightKind=e.$JM=e.$IM=e.$HM=e.$GM=e.DiagnosticSeverity=e.DiagnosticTag=e.$FM=e.$EM=e.FileEditType=e.$DM=e.$CM=e.$BM=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$AM=e.$zM=e.$yM=e.$xM=e.$wM=e.$vM=e.$uM=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$6M=zt,e.$tN=Pt,e.$$N=hi;function z(M){return Object.assign(M,{apply:function(...oe){if(oe.length===0)return Reflect.construct(M,[]);{const ye=oe.length===1?[]:oe[1];return Reflect.construct(M,ye,oe[0].constructor)}},call:function(...oe){if(oe.length===0)return Reflect.construct(M,[]);{const[ye,...Be]=oe;return Reflect.construct(M,Be,ye.constructor)}}})}var T;(function(M){M[M.Top=0]="Top",M[M.Bottom=1]="Bottom"})(T||(e.TerminalOutputAnchor=T={}));var J;(function(M){M[M.TerminalCommand=0]="TerminalCommand",M[M.Opener=1]="Opener",M[M.Command=3]="Command"})(J||(e.TerminalQuickFixType=J={}));let Y=a=class{static from(...F){let oe=F;return new a(function(){if(oe){for(const ye of oe)ye&&typeof ye.dispose=="function"&&ye.dispose();oe=void 0}})}constructor(F){c.set(this,void 0),Tt(this,c,F,"f")}dispose(){typeof tt(this,c,"f")=="function"&&(tt(this,c,"f").call(this),Tt(this,c,void 0,"f"))}};e.$uM=Y,c=new WeakMap,e.$uM=Y=a=Fe([z],Y);let W=o=class{static Min(...F){if(F.length===0)throw new TypeError;let oe=F[0];for(let ye=1;ye<F.length;ye++){const Be=F[ye];Be.isBefore(oe)&&(oe=Be)}return oe}static Max(...F){if(F.length===0)throw new TypeError;let oe=F[0];for(let ye=1;ye<F.length;ye++){const Be=F[ye];Be.isAfter(oe)&&(oe=Be)}return oe}static isPosition(F){if(!F)return!1;if(F instanceof o)return!0;const{line:oe,character:ye}=F;return typeof oe=="number"&&typeof ye=="number"}static of(F){if(F instanceof o)return F;if(this.isPosition(F))return new o(F.line,F.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(F,oe){if(F<0)throw(0,A.$7)("line must be non-negative");if(oe<0)throw(0,A.$7)("character must be non-negative");this.c=F,this.e=oe}isBefore(F){return this.c<F.c?!0:F.c<this.c?!1:this.e<F.e}isBeforeOrEqual(F){return this.c<F.c?!0:F.c<this.c?!1:this.e<=F.e}isAfter(F){return!this.isBeforeOrEqual(F)}isAfterOrEqual(F){return!this.isBefore(F)}isEqual(F){return this.c===F.c&&this.e===F.e}compareTo(F){return this.c<F.c?-1:this.c>F.line?1:this.e<F.e?-1:this.e>F.e?1:0}translate(F,oe=0){if(F===null||oe===null)throw(0,A.$7)();let ye;return typeof F>"u"?ye=0:typeof F=="number"?ye=F:(ye=typeof F.lineDelta=="number"?F.lineDelta:0,oe=typeof F.characterDelta=="number"?F.characterDelta:0),ye===0&&oe===0?this:new o(this.line+ye,this.character+oe)}with(F,oe=this.character){if(F===null||oe===null)throw(0,A.$7)();let ye;return typeof F>"u"?ye=this.line:typeof F=="number"?ye=F:(ye=typeof F.line=="number"?F.line:this.line,oe=typeof F.character=="number"?F.character:this.character),ye===this.line&&oe===this.character?this:new o(ye,oe)}toJSON(){return{line:this.line,character:this.character}}};e.$vM=W,e.$vM=W=o=Fe([z],W);let re=r=class{static isRange(F){return F instanceof r?!0:F?W.isPosition(F.start)&&W.isPosition(F.end):!1}static of(F){if(F instanceof r)return F;if(this.isRange(F))return new r(F.start,F.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(F,oe,ye,Be){let Ge,Ze;if(typeof F=="number"&&typeof oe=="number"&&typeof ye=="number"&&typeof Be=="number"?(Ge=new W(F,oe),Ze=new W(ye,Be)):W.isPosition(F)&&W.isPosition(oe)&&(Ge=W.of(F),Ze=W.of(oe)),!Ge||!Ze)throw new Error("Invalid arguments");Ge.isBefore(Ze)?(this.c=Ge,this.e=Ze):(this.c=Ze,this.e=Ge)}contains(F){return r.isRange(F)?this.contains(F.start)&&this.contains(F.end):W.isPosition(F)?!(W.of(F).isBefore(this.c)||this.e.isBefore(F)):!1}isEqual(F){return this.c.isEqual(F.c)&&this.e.isEqual(F.e)}intersection(F){const oe=W.Max(F.start,this.c),ye=W.Min(F.end,this.e);if(!oe.isAfter(ye))return new r(oe,ye)}union(F){if(this.contains(F))return this;if(F.contains(this))return F;const oe=W.Min(F.start,this.c),ye=W.Max(F.end,this.end);return new r(oe,ye)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(F,oe=this.end){if(F===null||oe===null)throw(0,A.$7)();let ye;return F?W.isPosition(F)?ye=F:(ye=F.start||this.start,oe=F.end||this.end):ye=this.start,ye.isEqual(this.c)&&oe.isEqual(this.end)?this:new r(ye,oe)}toJSON(){return[this.start,this.end]}};e.$wM=re,e.$wM=re=r=Fe([z],re);let ue=s=class extends re{static isSelection(F){return F instanceof s?!0:F?re.isRange(F)&&W.isPosition(F.anchor)&&W.isPosition(F.active)&&typeof F.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(F,oe,ye,Be){let Ge,Ze;if(typeof F=="number"&&typeof oe=="number"&&typeof ye=="number"&&typeof Be=="number"?(Ge=new W(F,oe),Ze=new W(ye,Be)):W.isPosition(F)&&W.isPosition(oe)&&(Ge=W.of(F),Ze=W.of(oe)),!Ge||!Ze)throw new Error("Invalid arguments");super(Ge,Ze),this.f=Ge,this.g=Ze}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$xM=ue,e.$xM=ue=s=Fe([z],ue);const ie=M=>{if(typeof M!="string"||M.length===0||!/^[0-9A-Za-z_\-]+$/.test(M))throw(0,A.$7)("connectionToken")};class $e{static isResolvedAuthority(F){return F&&typeof F=="object"&&typeof F.host=="string"&&typeof F.port=="number"&&(F.connectionToken===void 0||typeof F.connectionToken=="string")}constructor(F,oe,ye){if(typeof F!="string"||F.length===0)throw(0,A.$7)("host");if(typeof oe!="number"||oe===0||Math.round(oe)!==oe)throw(0,A.$7)("port");typeof ye<"u"&&ie(ye),this.host=F,this.port=Math.round(oe),this.connectionToken=ye}}e.$yM=$e;class ne{static isManagedResolvedAuthority(F){return F&&typeof F=="object"&&typeof F.makeConnection=="function"&&(F.connectionToken===void 0||typeof F.connectionToken=="string")}constructor(F,oe){this.makeConnection=F,this.connectionToken=oe,typeof oe<"u"&&ie(oe)}}e.$zM=ne;class U extends Error{static NotAvailable(F,oe){return new U(F,g.RemoteAuthorityResolverErrorCode.NotAvailable,oe)}static TemporarilyNotAvailable(F){return new U(F,g.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(F,oe=g.RemoteAuthorityResolverErrorCode.Unknown,ye){super(F),this._message=F,this._code=oe,this._detail=ye,Object.setPrototypeOf(this,U.prototype)}}e.$AM=U;var R;(function(M){M[M.LF=1]="LF",M[M.CRLF=2]="CRLF"})(R||(e.EndOfLine=R={}));var q;(function(M){M[M.Replace=1]="Replace",M[M.Append=2]="Append",M[M.Prepend=3]="Prepend"})(q||(e.EnvironmentVariableMutatorType=q={}));let X=i=class{static isTextEdit(F){return F instanceof i?!0:F?re.isRange(F)&&typeof F.newText=="string":!1}static replace(F,oe){return new i(F,oe)}static insert(F,oe){return i.replace(new re(F,F),oe)}static delete(F){return i.replace(F,"")}static setEndOfLine(F){const oe=new i(new re(new W(0,0),new W(0,0)),"");return oe.newEol=F,oe}get range(){return this.c}set range(F){if(F&&!re.isRange(F))throw(0,A.$7)("range");this.c=F}get newText(){return this.e||""}set newText(F){if(F&&typeof F!="string")throw(0,A.$7)("newText");this.e=F}get newEol(){return this.f}set newEol(F){if(F&&typeof F!="number")throw(0,A.$7)("newEol");this.f=F}constructor(F,oe){this.c=F,this.e=oe}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$BM=X,e.$BM=X=i=Fe([z],X);let le=v=class{static isNotebookCellEdit(F){return F instanceof v?!0:F?Gt.isNotebookRange(F)&&Array.isArray(F.newCells):!1}static replaceCells(F,oe){return new v(F,oe)}static insertCells(F,oe){return new v(new Gt(F,F),oe)}static deleteCells(F){return new v(F,[])}static updateCellMetadata(F,oe){const ye=new v(new Gt(F,F),[]);return ye.newCellMetadata=oe,ye}static updateNotebookMetadata(F){const oe=new v(new Gt(0,0),[]);return oe.newNotebookMetadata=F,oe}constructor(F,oe){this.range=F,this.newCells=oe}};e.$CM=le,e.$CM=le=v=Fe([z],le);class Q{static isSnippetTextEdit(F){return F instanceof Q?!0:F?re.isRange(F.range)&&L.isSnippetString(F.snippet):!1}static replace(F,oe){return new Q(F,oe)}static insert(F,oe){return Q.replace(new re(F,F),oe)}constructor(F,oe){this.range=F,this.snippet=oe}}e.$DM=Q;var x;(function(M){M[M.File=1]="File",M[M.Text=2]="Text",M[M.Cell=3]="Cell",M[M.CellReplace=5]="CellReplace",M[M.Snippet=6]="Snippet"})(x||(e.FileEditType=x={}));let V=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(F,oe,ye,Be){this.c.push({_type:1,from:F,to:oe,options:ye,metadata:Be})}createFile(F,oe,ye){this.c.push({_type:1,from:void 0,to:F,options:oe,metadata:ye})}deleteFile(F,oe,ye){this.c.push({_type:1,from:F,to:void 0,options:oe,metadata:ye})}e(F,oe,ye){this.c.push({_type:3,metadata:ye,uri:F,edit:{editType:5,metadata:oe},notebookMetadata:oe})}f(F,oe,ye,Be){const Ge=oe.start,Ze=oe.end;(Ge!==Ze||ye.length>0)&&this.c.push({_type:5,uri:F,index:Ge,count:Ze-Ge,cells:ye,metadata:Be})}g(F,oe,ye,Be){this.c.push({_type:3,metadata:Be,uri:F,edit:{editType:3,index:oe,metadata:ye}})}replace(F,oe,ye,Be){this.c.push({_type:2,uri:F,edit:new X(oe,ye),metadata:Be})}insert(F,oe,ye,Be){this.replace(F,new re(oe,oe),ye,Be)}delete(F,oe,ye){this.replace(F,oe,"",ye)}has(F){return this.c.some(oe=>oe._type===2&&oe.uri.toString()===F.toString())}set(F,oe){if(oe)for(const ye of oe){if(!ye)continue;let Be,Ge;Array.isArray(ye)?(Be=ye[0],Ge=ye[1]):Be=ye,le.isNotebookCellEdit(Be)?Be.newCellMetadata?this.g(F,Be.range.start,Be.newCellMetadata,Ge):Be.newNotebookMetadata?this.e(F,Be.newNotebookMetadata,Ge):this.f(F,Be.range,Be.newCells,Ge):Q.isSnippetTextEdit(Be)?this.c.push({_type:6,uri:F,range:Be.range,edit:Be.snippet,metadata:Ge}):this.c.push({_type:2,uri:F,edit:Be,metadata:Ge})}else{for(let ye=0;ye<this.c.length;ye++){const Be=this.c[ye];switch(Be._type){case 2:case 6:case 3:case 5:Be.uri.toString()===F.toString()&&(this.c[ye]=void 0);break}}(0,n.$Ib)(this.c)}}get(F){const oe=[];for(const ye of this.c)ye._type===2&&ye.uri.toString()===F.toString()&&oe.push(ye.edit);return oe}entries(){const F=new D.$Bc;for(const oe of this.c)if(oe._type===2){let ye=F.get(oe.uri);ye||(ye=[oe.uri,[]],F.set(oe.uri,ye)),ye[1].push(oe.edit)}return[...F.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$EM=V,e.$EM=V=Fe([z],V);let L=S=class{static isSnippetString(F){return F instanceof S?!0:F?typeof F.value=="string":!1}static c(F){return F.replace(/\$|}|\\/g,"\\$&")}constructor(F){this.e=1,this.value=F||""}appendText(F){return this.value+=S.c(F),this}appendTabstop(F=this.e++){return this.value+="$",this.value+=F,this}appendPlaceholder(F,oe=this.e++){if(typeof F=="function"){const ye=new S;ye.e=this.e,F(ye),this.e=ye.e,F=ye.value}else F=S.c(F);return this.value+="${",this.value+=oe,this.value+=":",this.value+=F,this.value+="}",this}appendChoice(F,oe=this.e++){const ye=F.map(Be=>Be.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=oe,this.value+="|",this.value+=ye,this.value+="|}",this}appendVariable(F,oe){if(typeof oe=="function"){const ye=new S;ye.e=this.e,oe(ye),this.e=ye.e,oe=ye.value}else typeof oe=="string"&&(oe=oe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=F,oe&&(this.value+=":",this.value+=oe),this.value+="}",this}};e.$FM=L,e.$FM=L=S=Fe([z],L);var H;(function(M){M[M.Unnecessary=1]="Unnecessary",M[M.Deprecated=2]="Deprecated"})(H||(e.DiagnosticTag=H={}));var K;(function(M){M[M.Hint=3]="Hint",M[M.Information=2]="Information",M[M.Warning=1]="Warning",M[M.Error=0]="Error"})(K||(e.DiagnosticSeverity=K={}));let te=O=class{static isLocation(F){return F instanceof O?!0:F?re.isRange(F.range)&&$.URI.isUri(F.uri):!1}constructor(F,oe){if(this.uri=F,oe)if(re.isRange(oe))this.range=re.of(oe);else if(W.isPosition(oe))this.range=new re(oe,oe);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$GM=te,e.$GM=te=O=Fe([z],te);let de=class{static is(F){return F?typeof F.message=="string"&&F.location&&re.isRange(F.location.range)&&$.URI.isUri(F.location.uri):!1}constructor(F,oe){this.location=F,this.message=oe}static isEqual(F,oe){return F===oe?!0:!F||!oe?!1:F.message===oe.message&&F.location.range.isEqual(oe.location.range)&&F.location.uri.toString()===oe.location.uri.toString()}};e.$HM=de,e.$HM=de=Fe([z],de);let se=class{constructor(F,oe,ye=K.Error){if(!re.isRange(F))throw new TypeError("range must be set");if(!oe)throw new TypeError("message must be set");this.range=F,this.message=oe,this.severity=ye}toJSON(){return{severity:K[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(F,oe){return F===oe?!0:!F||!oe?!1:F.message===oe.message&&F.severity===oe.severity&&F.code===oe.code&&F.severity===oe.severity&&F.source===oe.source&&F.range.isEqual(oe.range)&&(0,n.$ub)(F.tags,oe.tags)&&(0,n.$ub)(F.relatedInformation,oe.relatedInformation,de.isEqual)}};e.$IM=se,e.$IM=se=Fe([z],se);let ge=class{constructor(F,oe){if(!F)throw new Error("Illegal argument, contents must be defined");Array.isArray(F)?this.contents=F:this.contents=[F],this.range=oe}};e.$JM=ge,e.$JM=ge=Fe([z],ge);var we;(function(M){M[M.Text=0]="Text",M[M.Read=1]="Read",M[M.Write=2]="Write"})(we||(e.DocumentHighlightKind=we={}));let Ie=class{constructor(F,oe=we.Text){this.range=F,this.kind=oe}toJSON(){return{range:this.range,kind:we[this.kind]}}};e.$KM=Ie,e.$KM=Ie=Fe([z],Ie);let je=class{constructor(F,oe){this.uri=F,this.highlights=oe}toJSON(){return{uri:this.uri,highlights:this.highlights.map(F=>F.toJSON())}}};e.$LM=je,e.$LM=je=Fe([z],je);var pe;(function(M){M[M.File=0]="File",M[M.Module=1]="Module",M[M.Namespace=2]="Namespace",M[M.Package=3]="Package",M[M.Class=4]="Class",M[M.Method=5]="Method",M[M.Property=6]="Property",M[M.Field=7]="Field",M[M.Constructor=8]="Constructor",M[M.Enum=9]="Enum",M[M.Interface=10]="Interface",M[M.Function=11]="Function",M[M.Variable=12]="Variable",M[M.Constant=13]="Constant",M[M.String=14]="String",M[M.Number=15]="Number",M[M.Boolean=16]="Boolean",M[M.Array=17]="Array",M[M.Object=18]="Object",M[M.Key=19]="Key",M[M.Null=20]="Null",M[M.EnumMember=21]="EnumMember",M[M.Struct=22]="Struct",M[M.Event=23]="Event",M[M.Operator=24]="Operator",M[M.TypeParameter=25]="TypeParameter"})(pe||(e.SymbolKind=pe={}));var Pe;(function(M){M[M.Deprecated=1]="Deprecated"})(Pe||(e.SymbolTag=Pe={}));let Ce=N=class{static validate(F){if(!F.name)throw new Error("name must not be falsy")}constructor(F,oe,ye,Be,Ge){this.name=F,this.kind=oe,this.containerName=Ge,typeof ye=="string"&&(this.containerName=ye),Be instanceof te?this.location=Be:ye instanceof re&&(this.location=new te(Be,ye)),N.validate(this)}toJSON(){return{name:this.name,kind:pe[this.kind],location:this.location,containerName:this.containerName}}};e.$MM=Ce,e.$MM=Ce=N=Fe([z],Ce);let Le=j=class{static validate(F){if(!F.name)throw new Error("name must not be falsy");if(!F.range.contains(F.selectionRange))throw new Error("selectionRange must be contained in fullRange");F.children?.forEach(j.validate)}constructor(F,oe,ye,Be,Ge){this.name=F,this.detail=oe,this.kind=ye,this.range=Be,this.selectionRange=Ge,this.children=[],j.validate(this)}};e.$NM=Le,e.$NM=Le=j=Fe([z],Le);var Me;(function(M){M[M.Invoke=1]="Invoke",M[M.Automatic=2]="Automatic"})(Me||(e.CodeActionTriggerKind=Me={}));let Ve=class{constructor(F,oe){this.title=F,this.kind=oe}};e.$OM=Ve,e.$OM=Ve=Fe([z],Ve);let qe=I=class{constructor(F){this.value=F}append(F){return new I(this.value?this.value+I.c+F:F)}intersects(F){return this.contains(F)||F.contains(this)}contains(F){return this.value===F.value||F.value.startsWith(this.value+I.c)}};e.$PM=qe,qe.c=".",e.$PM=qe=I=Fe([z],qe),qe.Empty=new qe(""),qe.QuickFix=qe.Empty.append("quickfix"),qe.Refactor=qe.Empty.append("refactor"),qe.RefactorExtract=qe.Refactor.append("extract"),qe.RefactorInline=qe.Refactor.append("inline"),qe.RefactorMove=qe.Refactor.append("move"),qe.RefactorRewrite=qe.Refactor.append("rewrite"),qe.Source=qe.Empty.append("source"),qe.SourceOrganizeImports=qe.Source.append("organizeImports"),qe.SourceFixAll=qe.Source.append("fixAll"),qe.Notebook=qe.Empty.append("notebook");let xe=class{constructor(F,oe){if(this.range=F,this.parent=oe,oe&&!oe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$QM=xe,e.$QM=xe=Fe([z],xe);class _e{constructor(F,oe,ye,Be,Ge,Ze){this.kind=F,this.name=oe,this.detail=ye,this.uri=Be,this.range=Ge,this.selectionRange=Ze}}e.$RM=_e;class Ke{constructor(F,oe){this.fromRanges=oe,this.from=F}}e.$SM=Ke;class nt{constructor(F,oe){this.fromRanges=oe,this.to=F}}e.$TM=nt;var Ye;(function(M){M[M.Information=0]="Information",M[M.Warning=1]="Warning",M[M.Error=2]="Error"})(Ye||(e.LanguageStatusSeverity=Ye={}));let Qe=class{constructor(F,oe){this.range=F,this.command=oe}get isResolved(){return!!this.command}};e.$UM=Qe,e.$UM=Qe=Fe([z],Qe);let me=B=class{static isMarkdownString(F){return F instanceof B?!0:F&&F.appendCodeblock&&F.appendMarkdown&&F.appendText&&F.value!==void 0}constructor(F,oe=!1){m.set(this,void 0),Tt(this,m,new P.$Fk(F,{supportThemeIcons:oe}),"f")}get value(){return tt(this,m,"f").value}set value(F){tt(this,m,"f").value=F}get isTrusted(){return tt(this,m,"f").isTrusted}set isTrusted(F){tt(this,m,"f").isTrusted=F}get supportThemeIcons(){return tt(this,m,"f").supportThemeIcons}set supportThemeIcons(F){tt(this,m,"f").supportThemeIcons=F}get supportHtml(){return tt(this,m,"f").supportHtml}set supportHtml(F){tt(this,m,"f").supportHtml=F}get baseUri(){return tt(this,m,"f").baseUri}set baseUri(F){tt(this,m,"f").baseUri=F}appendText(F){return tt(this,m,"f").appendText(F),this}appendMarkdown(F){return tt(this,m,"f").appendMarkdown(F),this}appendCodeblock(F,oe){return tt(this,m,"f").appendCodeblock(oe??"",F),this}};e.$VM=me,m=new WeakMap,e.$VM=me=B=Fe([z],me);let Se=class{constructor(F,oe){this.label=F,this.documentation=oe}};e.$WM=Se,e.$WM=Se=Fe([z],Se);let Ae=class{constructor(F,oe){this.label=F,this.documentation=oe,this.parameters=[]}};e.$XM=Ae,e.$XM=Ae=Fe([z],Ae);let Re=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$YM=Re,e.$YM=Re=Fe([z],Re);var Te;(function(M){M[M.Invoke=1]="Invoke",M[M.TriggerCharacter=2]="TriggerCharacter",M[M.ContentChange=3]="ContentChange"})(Te||(e.SignatureHelpTriggerKind=Te={}));var He;(function(M){M[M.Type=1]="Type",M[M.Parameter=2]="Parameter"})(He||(e.InlayHintKind=He={}));let We=class{constructor(F){this.value=F}};e.$ZM=We,e.$ZM=We=Fe([z],We);let rt=class{constructor(F,oe,ye){this.position=F,this.label=oe,this.kind=ye}};e.$1M=rt,e.$1M=rt=Fe([z],rt);var st;(function(M){M[M.Invoke=0]="Invoke",M[M.TriggerCharacter=1]="TriggerCharacter",M[M.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(st||(e.CompletionTriggerKind=st={}));var Je;(function(M){M[M.Text=0]="Text",M[M.Method=1]="Method",M[M.Function=2]="Function",M[M.Constructor=3]="Constructor",M[M.Field=4]="Field",M[M.Variable=5]="Variable",M[M.Class=6]="Class",M[M.Interface=7]="Interface",M[M.Module=8]="Module",M[M.Property=9]="Property",M[M.Unit=10]="Unit",M[M.Value=11]="Value",M[M.Enum=12]="Enum",M[M.Keyword=13]="Keyword",M[M.Snippet=14]="Snippet",M[M.Color=15]="Color",M[M.File=16]="File",M[M.Reference=17]="Reference",M[M.Folder=18]="Folder",M[M.EnumMember=19]="EnumMember",M[M.Constant=20]="Constant",M[M.Struct=21]="Struct",M[M.Event=22]="Event",M[M.Operator=23]="Operator",M[M.TypeParameter=24]="TypeParameter",M[M.User=25]="User",M[M.Issue=26]="Issue"})(Je||(e.CompletionItemKind=Je={}));var ct;(function(M){M[M.Deprecated=1]="Deprecated"})(ct||(e.CompletionItemTag=ct={}));let at=class{constructor(F,oe){this.label=F,this.kind=oe}toJSON(){return{label:this.label,kind:this.kind&&Je[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$2M=at,e.$2M=at=Fe([z],at);let ft=class{constructor(F=[],oe=!1){this.items=F,this.isIncomplete=oe}};e.$3M=ft,e.$3M=ft=Fe([z],ft);let ut=class{constructor(F,oe,ye){this.insertText=F,this.range=oe,this.command=ye}};e.$4M=ut,e.$4M=ut=Fe([z],ut);let dt=class{constructor(F){this.commands=void 0,this.suppressSuggestions=void 0,this.items=F}};e.$5M=dt,e.$5M=dt=Fe([z],dt);var At;(function(M){M[M.Unknown=0]="Unknown",M[M.Word=1]="Word",M[M.Line=2]="Line",M[M.Suggest=3]="Suggest"})(At||(e.PartialAcceptTriggerKind=At={}));var Ot;(function(M){M[M.Active=-1]="Active",M[M.Beside=-2]="Beside",M[M.One=1]="One",M[M.Two=2]="Two",M[M.Three=3]="Three",M[M.Four=4]="Four",M[M.Five=5]="Five",M[M.Six=6]="Six",M[M.Seven=7]="Seven",M[M.Eight=8]="Eight",M[M.Nine=9]="Nine"})(Ot||(e.ViewColumn=Ot={}));var Bt;(function(M){M[M.Left=1]="Left",M[M.Right=2]="Right"})(Bt||(e.StatusBarAlignment=Bt={}));function zt(M,F){return`${y.$Em.toKey(M)}.${F}`}var Et;(function(M){M[M.Off=0]="Off",M[M.On=1]="On",M[M.Relative=2]="Relative",M[M.Interval=3]="Interval"})(Et||(e.TextEditorLineNumbersStyle=Et={}));var qt;(function(M){M[M.Manual=1]="Manual",M[M.AfterDelay=2]="AfterDelay",M[M.FocusOut=3]="FocusOut"})(qt||(e.TextDocumentSaveReason=qt={}));var xt;(function(M){M[M.Default=0]="Default",M[M.InCenter=1]="InCenter",M[M.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",M[M.AtTop=3]="AtTop"})(xt||(e.TextEditorRevealType=xt={}));var mt;(function(M){M[M.Keyboard=1]="Keyboard",M[M.Mouse=2]="Mouse",M[M.Command=3]="Command"})(mt||(e.TextEditorSelectionChangeKind=mt={}));var kt;(function(M){M[M.Undo=1]="Undo",M[M.Redo=2]="Redo"})(kt||(e.TextDocumentChangeReason=kt={}));var jt;(function(M){M[M.OpenOpen=0]="OpenOpen",M[M.ClosedClosed=1]="ClosedClosed",M[M.OpenClosed=2]="OpenClosed",M[M.ClosedOpen=3]="ClosedOpen"})(jt||(e.DecorationRangeBehavior=jt={})),function(M){function F(oe){switch(oe){case"keyboard":return M.Keyboard;case"mouse":return M.Mouse;case"api":return M.Command}}M.fromValue=F}(mt||(e.TextEditorSelectionChangeKind=mt={}));var it;(function(M){M[M.Other=0]="Other",M[M.Comment=1]="Comment",M[M.String=2]="String",M[M.RegEx=3]="RegEx"})(it||(e.SyntaxTokenType=it={})),function(M){function F(oe){switch(oe){case M.Other:return"other";case M.Comment:return"comment";case M.String:return"string";case M.RegEx:return"regex"}return"other"}M.toString=F}(it||(e.SyntaxTokenType=it={}));let bt=class{constructor(F,oe){if(oe&&!$.URI.isUri(oe))throw(0,A.$7)("target");if(!re.isRange(F)||F.isEmpty)throw(0,A.$7)("range");this.range=F,this.target=oe}};e.$7M=bt,e.$7M=bt=Fe([z],bt);let gt=class{constructor(F,oe,ye,Be){this.red=F,this.green=oe,this.blue=ye,this.alpha=Be}};e.$8M=gt,e.$8M=gt=Fe([z],gt);let $t=class{constructor(F,oe){if(oe&&!(oe instanceof gt))throw(0,A.$7)("color");if(!re.isRange(F)||F.isEmpty)throw(0,A.$7)("range");this.range=F,this.color=oe}};e.$9M=$t,e.$9M=$t=Fe([z],$t);let Ut=class{constructor(F){if(!F||typeof F!="string")throw(0,A.$7)("label");this.label=F}};e.$0M=Ut,e.$0M=Ut=Fe([z],Ut);var Rt;(function(M){M[M.RGB=0]="RGB",M[M.HEX=1]="HEX",M[M.HSL=2]="HSL"})(Rt||(e.ColorFormat=Rt={}));var Jt;(function(M){M[M.Error=0]="Error",M[M.Warning=1]="Warning",M[M.Information=2]="Information"})(Jt||(e.SourceControlInputBoxValidationType=Jt={}));var Nt;(function(M){M[M.Unknown=0]="Unknown",M[M.Shutdown=1]="Shutdown",M[M.Process=2]="Process",M[M.User=3]="User",M[M.Extension=4]="Extension"})(Nt||(e.TerminalExitReason=Nt={}));class _t{constructor(F,oe,ye){if(this.startIndex=F,this.length=oe,this.tooltip=ye,typeof F!="number"||F<0)throw(0,A.$7)("startIndex");if(typeof oe!="number"||oe<1)throw(0,A.$7)("length");if(ye!==void 0&&typeof ye!="string")throw(0,A.$7)("tooltip")}}e.$$M=_t;class en{constructor(F){this.uri=F}}e.$_M=en;class Ht{constructor(F){this.terminalCommand=F}}e.$aN=Ht;var Ct;(function(M){M[M.Panel=1]="Panel",M[M.Editor=2]="Editor"})(Ct||(e.TerminalLocation=Ct={}));class hn{constructor(F){if(this.options=F,typeof F!="object")throw(0,A.$7)("options")}}e.$bN=hn;var Qt;(function(M){M[M.Always=1]="Always",M[M.Silent=2]="Silent",M[M.Never=3]="Never"})(Qt||(e.TaskRevealKind=Qt={}));var Xt;(function(M){M[M.Shared=1]="Shared",M[M.Dedicated=2]="Dedicated",M[M.New=3]="New"})(Xt||(e.TaskPanelKind=Xt={}));let vt=Z=class{static from(F){switch(F){case"clean":return Z.Clean;case"build":return Z.Build;case"rebuild":return Z.Rebuild;case"test":return Z.Test;default:return}}constructor(F,oe){if(this.label=oe,typeof F!="string"||typeof oe!="string")throw(0,A.$7)("name");this.c=F}get id(){return this.c}};e.$cN=vt,vt.Clean=new Z("clean","Clean"),vt.Build=new Z("build","Build"),vt.Rebuild=new Z("rebuild","Rebuild"),vt.Test=new Z("test","Test"),e.$cN=vt=Z=Fe([z],vt);function tn(M){let F="";for(let oe=0;oe<M.length;oe++)F+=M[oe].replace(/,/g,",,")+",";return F}let Ft=class{constructor(F,oe,ye){if(typeof F!="string")throw(0,A.$7)("process");this.e=[],this.c=F,oe!==void 0&&(Array.isArray(oe)?(this.e=oe,this.f=ye):this.f=oe)}get process(){return this.c}set process(F){if(typeof F!="string")throw(0,A.$7)("process");this.c=F}get args(){return this.e}set args(F){Array.isArray(F)||(F=[]),this.e=F}get options(){return this.f}set options(F){this.f=F}computeId(){const F=[];if(F.push("process"),this.c!==void 0&&F.push(this.c),this.e&&this.e.length>0)for(const oe of this.e)F.push(oe);return tn(F)}};e.$dN=Ft,e.$dN=Ft=Fe([z],Ft);let Lt=class{constructor(F,oe,ye){if(this.f=[],Array.isArray(oe)){if(!F)throw(0,A.$7)("command can't be undefined or null");if(typeof F!="string"&&typeof F.value!="string")throw(0,A.$7)("command");this.e=F,this.f=oe,this.g=ye}else{if(typeof F!="string")throw(0,A.$7)("commandLine");this.c=F,this.g=oe}}get commandLine(){return this.c}set commandLine(F){if(typeof F!="string")throw(0,A.$7)("commandLine");this.c=F}get command(){return this.e?this.e:""}set command(F){if(typeof F!="string"&&typeof F.value!="string")throw(0,A.$7)("command");this.e=F}get args(){return this.f}set args(F){this.f=F||[]}get options(){return this.g}set options(F){this.g=F}computeId(){const F=[];if(F.push("shell"),this.c!==void 0&&F.push(this.c),this.e!==void 0&&F.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const oe of this.f)F.push(typeof oe=="string"?oe:oe.value);return tn(F)}};e.$eN=Lt,e.$eN=Lt=Fe([z],Lt);var on;(function(M){M[M.Escape=1]="Escape",M[M.Strong=2]="Strong",M[M.Weak=3]="Weak"})(on||(e.ShellQuoting=on={}));var Vt;(function(M){M[M.Global=1]="Global",M[M.Workspace=2]="Workspace"})(Vt||(e.TaskScope=Vt={}));class an{constructor(F){this.c=F}computeId(){return"customExecution"+(0,E.$Eg)()}set callback(F){this.c=F}get callback(){return this.c}}e.$fN=an;let Dt=he=class{constructor(F,oe,ye,Be,Ge,Ze){this.k=!1,this.l=this.definition=F;let et;typeof oe=="string"?(this.o=this.name=oe,this.w=this.source=ye,this.execution=Be,et=Ge,this.k=!0):oe===Vt.Global||oe===Vt.Workspace?(this.target=oe,this.o=this.name=ye,this.w=this.source=Be,this.execution=Ge,et=Ze):(this.target=oe,this.o=this.name=ye,this.w=this.source=Be,this.execution=Ge,et=Ze),typeof et=="string"?(this.r=[et],this.t=!0):Array.isArray(et)?(this.r=et,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(F){this.j=F}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Ft?this.l={type:he.e,id:this.q.computeId()}:this.q instanceof Lt?this.l={type:he.f,id:this.q.computeId()}:this.q instanceof an?this.l={type:he.c,id:this.q.computeId()}:this.l={type:he.g,id:(0,E.$Eg)()}}get definition(){return this.l}set definition(F){if(F==null)throw(0,A.$7)("Kind can't be undefined or null");this.B(),this.l=F}get scope(){return this.m}set target(F){this.B(),this.m=F}get name(){return this.o}set name(F){if(typeof F!="string")throw(0,A.$7)("name");this.B(),this.o=F}get execution(){return this.q}set execution(F){F===null&&(F=void 0),this.B(),this.q=F;const oe=this.l.type;(he.g===oe||he.e===oe||he.f===oe||he.c===oe)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(F){if(Array.isArray(F))this.B(),this.r=F,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(F){F!==!0&&F!==!1&&(F=!1),this.B(),this.u=F}get source(){return this.w}set source(F){if(typeof F!="string"||F.length===0)throw(0,A.$7)("source must be a string of length > 0");this.B(),this.w=F}get group(){return this.x}set group(F){F===null&&(F=void 0),this.B(),this.x=F}get detail(){return this.A}set detail(F){F===null&&(F=void 0),this.A=F}get presentationOptions(){return this.y}set presentationOptions(F){F==null&&(F=Object.create(null)),this.B(),this.y=F}get runOptions(){return this.z}set runOptions(F){F==null&&(F=Object.create(null)),this.B(),this.z=F}};e.$gN=Dt,Dt.c="customExecution",Dt.e="process",Dt.f="shell",Dt.g="$empty",e.$gN=Dt=he=Fe([z],Dt);var nn;(function(M){M[M.SourceControl=1]="SourceControl",M[M.Window=10]="Window",M[M.Notification=15]="Notification"})(nn||(e.ProgressLocation=nn={}));var cn;(function(M){function F(oe){const ye=oe;return(0,b.$Zf)(ye.value)?ye.tooltip&&!(0,b.$Vf)(ye.tooltip)?(console.log("INVALID view badge, invalid tooltip",ye.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",ye.value),!1)}M.isViewBadge=F})(cn||(e.ViewBadge=cn={}));let Zt=ae=class{static isTreeItem(F,oe){const ye=F;if(ye.checkboxState!==void 0){const Be=(0,b.$Zf)(ye.checkboxState)?ye.checkboxState:(0,b.$Xf)(ye.checkboxState)&&(0,b.$Zf)(ye.checkboxState.state)?ye.checkboxState.state:void 0,Ge=!(0,b.$Zf)(ye.checkboxState)&&(0,b.$Xf)(ye.checkboxState)?ye.checkboxState.tooltip:void 0;if(Be===void 0||Be!==Yt.Checked&&Be!==Yt.Unchecked||Ge!==void 0&&!(0,b.$Vf)(Ge))return console.log("INVALID tree item, invalid checkboxState",ye.checkboxState),!1}if(F instanceof ae)return!0;if(ye.label!==void 0&&!(0,b.$Vf)(ye.label)&&!ye.label?.label)return console.log("INVALID tree item, invalid label",ye.label),!1;if(ye.id!==void 0&&!(0,b.$Vf)(ye.id))return console.log("INVALID tree item, invalid id",ye.id),!1;if(ye.iconPath!==void 0&&!(0,b.$Vf)(ye.iconPath)&&!$.URI.isUri(ye.iconPath)&&(!ye.iconPath||!(0,b.$Vf)(ye.iconPath.id))){const Be=ye.iconPath;if(!Be||!(0,b.$Vf)(Be.light)&&!$.URI.isUri(Be.light)&&!(0,b.$Vf)(Be.dark)&&!$.URI.isUri(Be.dark))return console.log("INVALID tree item, invalid iconPath",ye.iconPath),!1}return ye.description!==void 0&&!(0,b.$Vf)(ye.description)&&typeof ye.description!="boolean"?(console.log("INVALID tree item, invalid description",ye.description),!1):ye.resourceUri!==void 0&&!$.URI.isUri(ye.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",ye.resourceUri),!1):ye.tooltip!==void 0&&!(0,b.$Vf)(ye.tooltip)&&!(ye.tooltip instanceof me)?(console.log("INVALID tree item, invalid tooltip",ye.tooltip),!1):ye.command!==void 0&&!ye.command.command?(console.log("INVALID tree item, invalid command",ye.command),!1):ye.collapsibleState!==void 0&&ye.collapsibleState<Wt.None&&ye.collapsibleState>Wt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",ye.collapsibleState),!1):ye.contextValue!==void 0&&!(0,b.$Vf)(ye.contextValue)?(console.log("INVALID tree item, invalid contextValue",ye.contextValue),!1):ye.accessibilityInformation!==void 0&&!ye.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",ye.accessibilityInformation),!1):!0}constructor(F,oe=Wt.None){this.collapsibleState=oe,$.URI.isUri(F)?this.resourceUri=F:this.label=F}};e.$hN=Zt,e.$hN=Zt=ae=Fe([z],Zt);var Wt;(function(M){M[M.None=0]="None",M[M.Collapsed=1]="Collapsed",M[M.Expanded=2]="Expanded"})(Wt||(e.TreeItemCollapsibleState=Wt={}));var Yt;(function(M){M[M.Unchecked=0]="Unchecked",M[M.Checked=1]="Checked"})(Yt||(e.TreeItemCheckboxState=Yt={}));let Kt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(F){this.value=F}};e.$iN=Kt,e.$iN=Kt=Fe([z],Kt);class rn extends Kt{}e.$jN=rn;class fn extends rn{constructor(F){super(""),u.set(this,void 0),Tt(this,u,F,"f")}asFile(){return tt(this,u,"f")}}e.$kN=fn,u=new WeakMap;class be{constructor(F,oe,ye,Be){this.name=F,this.uri=oe,this._itemId=ye,this.c=Be}data(){return this.c()}}e.$lN=be;let De=class{constructor(F){p.add(this),h.set(this,new Map);for(const[oe,ye]of F??[]){const Be=tt(this,h,"f").get(tt(this,p,"m",f).call(this,oe));Be?Be.push(ye):tt(this,h,"f").set(tt(this,p,"m",f).call(this,oe),[ye])}}get(F){return tt(this,h,"f").get(tt(this,p,"m",f).call(this,F))?.[0]}set(F,oe){tt(this,h,"f").set(tt(this,p,"m",f).call(this,F),[oe])}forEach(F,oe){for(const[ye,Be]of tt(this,h,"f"))for(const Ge of Be)F.call(oe,Ge,ye,this)}*[(h=new WeakMap,p=new WeakSet,Symbol.iterator)](){for(const[F,oe]of tt(this,h,"f"))for(const ye of oe)yield[F,ye]}};e.$mN=De,f=function(F){return F.toLowerCase()},e.$mN=De=Fe([z],De);let fe=class{constructor(F,oe,ye){this.insertText=F,this.title=oe,this.kind=ye}};e.$nN=fe,e.$nN=fe=Fe([z],fe);var G;(function(M){M[M.Automatic=0]="Automatic",M[M.PasteAs=1]="PasteAs"})(G||(e.DocumentPasteTriggerKind=G={}));class ve{constructor(F){this.value=F}append(...F){return new ve((this.value?[this.value,...F]:F).join(ve.c))}intersects(F){return this.contains(F)||F.contains(this)}contains(F){return this.value===F.value||F.value.startsWith(this.value+ve.c)}}e.$oN=ve,ve.c=".",ve.Empty=new ve("");let Oe=class{constructor(F,oe,ye){this.title=oe,this.insertText=F,this.kind=ye}};e.$pN=Oe,e.$pN=Oe=Fe([z],Oe);let Ue=class{constructor(F,oe){this.id=F,this.color=oe}static isThemeIcon(F){return typeof F.id!="string"?(console.log("INVALID ThemeIcon, invalid id",F.id),!1):!0}};e.$qN=Ue,e.$qN=Ue=Fe([z],Ue),Ue.File=new Ue("file"),Ue.Folder=new Ue("folder");let ze=class{constructor(F){this.id=F}};e.$rN=ze,e.$rN=ze=Fe([z],ze);var Xe;(function(M){M[M.Global=1]="Global",M[M.Workspace=2]="Workspace",M[M.WorkspaceFolder=3]="WorkspaceFolder"})(Xe||(e.ConfigurationTarget=Xe={}));let ot=class{get base(){return this.c}set base(F){this.c=F,this.e=$.URI.file(F)}get baseUri(){return this.e}set baseUri(F){this.e=F,this.c=F.fsPath}constructor(F,oe){if(typeof F!="string"&&(!F||!$.URI.isUri(F)&&!$.URI.isUri(F.uri)))throw(0,A.$7)("base");if(typeof oe!="string")throw(0,A.$7)("pattern");typeof F=="string"?this.baseUri=$.URI.file(F):$.URI.isUri(F)?this.baseUri=F:this.baseUri=F.uri,this.pattern=oe}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$sN=ot,e.$sN=ot=Fe([z],ot);const pt=new WeakMap;function Pt(M,F){pt.set(M,F)}let lt=class{constructor(F,oe,ye,Be,Ge){this.enabled=typeof F=="boolean"?F:!0,typeof oe=="string"&&(this.condition=oe),typeof ye=="string"&&(this.hitCondition=ye),typeof Be=="string"&&(this.logMessage=Be),typeof Ge=="string"&&(this.mode=Ge)}get id(){return this.c||(this.c=pt.get(this)??(0,E.$Eg)()),this.c}};e.$uN=lt,e.$uN=lt=Fe([z],lt);let wt=class extends lt{constructor(F,oe,ye,Be,Ge,Ze){if(super(oe,ye,Be,Ge,Ze),F===null)throw(0,A.$7)("location");this.location=F}};e.$vN=wt,e.$vN=wt=Fe([z],wt);let pn=class extends lt{constructor(F,oe,ye,Be,Ge,Ze){super(oe,ye,Be,Ge,Ze),this.functionName=F}};e.$wN=pn,e.$wN=pn=Fe([z],pn);let wn=class extends lt{constructor(F,oe,ye,Be,Ge,Ze,et,ht){if(super(Be,Ge,Ze,et,ht),!oe)throw(0,A.$7)("dataId");this.label=F,this.dataId=oe,this.canPersist=ye}};e.$xN=wn,e.$xN=wn=Fe([z],wn);let bn=class{constructor(F,oe,ye){this.command=F,this.args=oe||[],this.options=ye}};e.$yN=bn,e.$yN=bn=Fe([z],bn);let vn=class{constructor(F,oe){this.port=F,this.host=oe}};e.$zN=vn,e.$zN=vn=Fe([z],vn);let yn=class{constructor(F){this.path=F}};e.$AN=yn,e.$AN=yn=Fe([z],yn);let En=class{constructor(F){this.implementation=F}};e.$BN=En,e.$BN=En=Fe([z],En);class Pi{constructor(F,oe,ye){this.session=F,this.threadId=oe,this.frameId=ye}}e.$CN=Pi;class Si{constructor(F,oe){this.session=F,this.threadId=oe}}e.$DN=Si;let kn=class{constructor(F,oe){this.range=F,this.expression=oe}};e.$EN=kn,e.$EN=kn=Fe([z],kn);var Bn;(function(M){M[M.Invoke=0]="Invoke",M[M.Automatic=1]="Automatic"})(Bn||(e.InlineCompletionTriggerKind=Bn={}));let Cn=class{constructor(F,oe){this.range=F,this.text=oe}};e.$FN=Cn,e.$FN=Cn=Fe([z],Cn);let Dn=class{constructor(F,oe,ye=!0){this.range=F,this.variableName=oe,this.caseSensitiveLookup=ye}};e.$GN=Dn,e.$GN=Dn=Fe([z],Dn);let Pn=class{constructor(F,oe){this.range=F,this.expression=oe}};e.$HN=Pn,e.$HN=Pn=Fe([z],Pn);let Sn=class{constructor(F,oe){this.frameId=F,this.stoppedLocation=oe}};e.$IN=Sn,e.$IN=Sn=Fe([z],Sn);var zn;(function(M){M[M.AIGenerated=1]="AIGenerated"})(zn||(e.NewSymbolNameTag=zn={}));class Ii{constructor(F,oe){this.newSymbolName=F,this.tags=oe}}e.$JN=Ii;var qn;(function(M){M[M.Changed=1]="Changed",M[M.Created=2]="Created",M[M.Deleted=3]="Deleted"})(qn||(e.FileChangeType=qn={}));let In=ee=class extends Error{static FileExists(F){return new ee(F,w.FileSystemProviderErrorCode.FileExists,ee.FileExists)}static FileNotFound(F){return new ee(F,w.FileSystemProviderErrorCode.FileNotFound,ee.FileNotFound)}static FileNotADirectory(F){return new ee(F,w.FileSystemProviderErrorCode.FileNotADirectory,ee.FileNotADirectory)}static FileIsADirectory(F){return new ee(F,w.FileSystemProviderErrorCode.FileIsADirectory,ee.FileIsADirectory)}static NoPermissions(F){return new ee(F,w.FileSystemProviderErrorCode.NoPermissions,ee.NoPermissions)}static Unavailable(F){return new ee(F,w.FileSystemProviderErrorCode.Unavailable,ee.Unavailable)}constructor(F,oe=w.FileSystemProviderErrorCode.Unknown,ye){super($.URI.isUri(F)?F.toString(!0):F),this.code=ye?.name??"Unknown",(0,w.$4k)(this,oe),Object.setPrototypeOf(this,ee.prototype),typeof Error.captureStackTrace=="function"&&typeof ye=="function"&&Error.captureStackTrace(this,ye)}};e.$KN=In,e.$KN=In=ee=Fe([z],In);let An=class{constructor(F,oe,ye){this.start=F,this.end=oe,this.kind=ye}};e.$LN=An,e.$LN=An=Fe([z],An);var Un;(function(M){M[M.Comment=1]="Comment",M[M.Imports=2]="Imports",M[M.Region=3]="Region"})(Un||(e.FoldingRangeKind=Un={}));var Hn;(function(M){M[M.Collapsed=0]="Collapsed",M[M.Expanded=1]="Expanded"})(Hn||(e.CommentThreadCollapsibleState=Hn={}));var Vn;(function(M){M[M.Editing=0]="Editing",M[M.Preview=1]="Preview"})(Vn||(e.CommentMode=Vn={}));var Wn;(function(M){M[M.Published=0]="Published",M[M.Draft=1]="Draft"})(Wn||(e.CommentState=Wn={}));var Gn;(function(M){M[M.Unresolved=0]="Unresolved",M[M.Resolved=1]="Resolved"})(Gn||(e.CommentThreadState=Gn={}));var xn;(function(M){M[M.Current=0]="Current",M[M.Outdated=1]="Outdated"})(xn||(e.CommentThreadApplicability=xn={}));class Ai{constructor(F,oe=[]){this.tokenTypes=F,this.tokenModifiers=oe}}e.$MN=Ai;function Oi(M){return typeof M>"u"||(0,b.$Wf)(M)}class On{constructor(F){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,F){this.m=!0;for(let oe=0,ye=F.tokenTypes.length;oe<ye;oe++)this.k.set(F.tokenTypes[oe],oe);for(let oe=0,ye=F.tokenModifiers.length;oe<ye;oe++)this.l.set(F.tokenModifiers[oe],oe)}}push(F,oe,ye,Be,Ge){if(typeof F=="number"&&typeof oe=="number"&&typeof ye=="number"&&typeof Be=="number"&&(typeof Ge=="number"||typeof Ge>"u"))return typeof Ge>"u"&&(Ge=0),this.q(F,oe,ye,Be,Ge);if(re.isRange(F)&&typeof oe=="string"&&Oi(ye))return this.o(F,oe,ye);throw(0,A.$7)()}o(F,oe,ye){if(!this.m)throw new Error("Legend must be provided in constructor");if(F.start.line!==F.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(oe))throw new Error("`tokenType` is not in the provided legend");const Be=F.start.line,Ge=F.start.character,Ze=F.end.character-F.start.character,et=this.k.get(oe);let ht=0;if(ye)for(const yt of ye){if(!this.l.has(yt))throw new Error("`tokenModifier` is not in the provided legend");const St=this.l.get(yt);ht|=1<<St>>>0}this.q(Be,Ge,Ze,et,ht)}q(F,oe,ye,Be,Ge){if(this.f&&(F<this.c||F===this.c&&oe<this.e)){this.f=!1;const ht=this.g.length/5|0;let yt=0,St=0;for(let It=0;It<ht;It++){let Mt=this.g[5*It],ln=this.g[5*It+1];Mt===0?(Mt=yt,ln+=St):Mt+=yt,this.g[5*It]=Mt,this.g[5*It+1]=ln,yt=Mt,St=ln}}let Ze=F,et=oe;this.f&&this.j>0&&(Ze-=this.c,Ze===0&&(et-=this.e)),this.g[this.j++]=Ze,this.g[this.j++]=et,this.g[this.j++]=ye,this.g[this.j++]=Be,this.g[this.j++]=Ge,this.c=F,this.e=oe}static r(F){const oe=[],ye=F.length/5|0;for(let et=0;et<ye;et++)oe[et]=et;oe.sort((et,ht)=>{const yt=F[5*et],St=F[5*ht];if(yt===St){const It=F[5*et+1],Mt=F[5*ht+1];return It-Mt}return yt-St});const Be=new Uint32Array(F.length);let Ge=0,Ze=0;for(let et=0;et<ye;et++){const ht=5*oe[et],yt=F[ht+0],St=F[ht+1],It=F[ht+2],Mt=F[ht+3],ln=F[ht+4],Di=yt-Ge,gr=Di===0?St-Ze:St,un=5*et;Be[un+0]=Di,Be[un+1]=gr,Be[un+2]=It,Be[un+3]=Mt,Be[un+4]=ln,Ge=yt,Ze=St}return Be}build(F){return this.f?new jn(new Uint32Array(this.g),F):new jn(On.r(this.g),F)}}e.$NN=On;class jn{constructor(F,oe){this.resultId=oe,this.data=F}}e.$ON=jn;class ji{constructor(F,oe,ye){this.start=F,this.deleteCount=oe,this.data=ye}}e.$PN=ji;class Ri{constructor(F,oe){this.resultId=oe,this.edits=F}}e.$QN=Ri;var Jn;(function(M){M[M.Separate=0]="Separate",M[M.MergeWithParent=1]="MergeWithParent"})(Jn||(e.DebugConsoleMode=Jn={}));class Ni{constructor(F){this.name=F}}e.$RN=Ni;let dn=class{constructor(){}};e.$SN=dn,dn.Back={iconPath:new Ue("arrow-left")},e.$SN=dn=Fe([z],dn);var Qn;(function(M){M[M.Separator=-1]="Separator",M[M.Default=0]="Default"})(Qn||(e.QuickPickItemKind=Qn={}));var Xn;(function(M){M[M.Info=1]="Info",M[M.Warning=2]="Warning",M[M.Error=3]="Error"})(Xn||(e.InputBoxValidationSeverity=Xn={}));var Zn;(function(M){M[M.UI=1]="UI",M[M.Workspace=2]="Workspace"})(Zn||(e.ExtensionKind=Zn={}));class Fi{static validate(F){if(typeof F.badge=="string"){let oe=(0,k.$vf)(F.badge,0);if(oe<F.badge.length&&(oe+=(0,k.$vf)(F.badge,oe)),F.badge.length>oe)throw new Error("The 'badge'-property must be undefined or a short character")}else if(F.badge&&!Ue.isThemeIcon(F.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!F.color&&!F.badge&&!F.tooltip)throw new Error("The decoration is empty");return!0}constructor(F,oe,ye){this.badge=F,this.tooltip=oe,this.color=ye}}e.$TN=Fi;let Rn=class{constructor(F){this.kind=F}};e.$UN=Rn,e.$UN=Rn=Fe([z],Rn);var Yn;(function(M){M[M.Light=1]="Light",M[M.Dark=2]="Dark",M[M.HighContrast=3]="HighContrast",M[M.HighContrastLight=4]="HighContrastLight"})(Yn||(e.ColorThemeKind=Yn={}));class Gt{static isNotebookRange(F){return F instanceof Gt?!0:F?typeof F.start=="number"&&typeof F.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(F,oe){if(F<0)throw(0,A.$7)("start must be positive");if(oe<0)throw(0,A.$7)("end must be positive");F<=oe?(this.c=F,this.e=oe):(this.c=oe,this.e=F)}with(F){let oe=this.c,ye=this.e;return F.start!==void 0&&(oe=F.start),F.end!==void 0&&(ye=F.end),oe===this.c&&ye===this.e?this:new Gt(oe,ye)}}e.$VN=Gt;class mn{static validate(F){if(typeof F.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof F.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof F.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(F){return Array.isArray(F)&&F.every(oe=>mn.isNotebookCellData(oe))}static isNotebookCellData(F){return!0}constructor(F,oe,ye,Be,Ge,Ze,et){this.kind=F,this.value=oe,this.languageId=ye,this.mime=Be,this.outputs=Ge??[],this.metadata=Ze,this.executionSummary=et,mn.validate(this)}}e.$WN=mn;class Li{constructor(F){this.cells=F}}e.$XN=Li;class Kn{static isNotebookCellOutputItem(F){return F instanceof l?!0:F?typeof F.mime=="string"&&F.data instanceof Uint8Array:!1}static error(F){const oe={name:F.name,message:F.message,stack:F.stack};return l.json(oe,"application/vnd.code.notebook.error")}static stdout(F){return l.text(F,"application/vnd.code.notebook.stdout")}static stderr(F){return l.text(F,"application/vnd.code.notebook.stderr")}static bytes(F,oe="application/octet-stream"){return new l(F,oe)}static text(F,oe=C.$As.text){const ye=tt(l,l,"f",t).encode(String(F));return new l(ye,oe)}static json(F,oe="text/x-json"){const ye=JSON.stringify(F,void 0,"	");return l.text(ye,oe)}constructor(F,oe){this.data=F,this.mime=oe;const ye=(0,C.$Es)(oe,!0);if(!ye)throw new Error(`INVALID mime type: ${oe}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=ye}}e.$YN=Kn,l=Kn,t={value:new TextEncoder};class gn{static isNotebookCellOutput(F){return F instanceof gn?!0:!F||typeof F!="object"?!1:typeof F.id=="string"&&Array.isArray(F.items)}static ensureUniqueMimeTypes(F,oe=!1){const ye=new Set,Be=new Set;for(let Ge=0;Ge<F.length;Ge++){const Ze=F[Ge],et=(0,C.$Es)(Ze.mime);if(!ye.has(et)||(0,d.$pK)(et)){ye.add(et);continue}Be.add(Ge),oe&&console.warn(`DUPLICATED mime type '${Ze.mime}' will be dropped`)}return Be.size===0?F:F.filter((Ge,Ze)=>!Be.has(Ze))}constructor(F,oe,ye){this.items=gn.ensureUniqueMimeTypes(F,!0),typeof oe=="string"?(this.id=oe,this.metadata=ye):(this.id=(0,E.$Eg)(),this.metadata=oe??ye)}}e.$ZN=gn;var _n;(function(M){M[M.Markup=1]="Markup",M[M.Code=2]="Code"})(_n||(e.NotebookCellKind=_n={}));var ei;(function(M){M[M.Idle=1]="Idle",M[M.Pending=2]="Pending",M[M.Executing=3]="Executing"})(ei||(e.NotebookCellExecutionState=ei={}));var ti;(function(M){M[M.Left=1]="Left",M[M.Right=2]="Right"})(ti||(e.NotebookCellStatusBarAlignment=ti={}));var ni;(function(M){M[M.Default=0]="Default",M[M.InCenter=1]="InCenter",M[M.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",M[M.AtTop=3]="AtTop"})(ni||(e.NotebookEditorRevealType=ni={}));class Mi{constructor(F,oe){this.text=F,this.alignment=oe}}e.$1N=Mi;var ii;(function(M){M[M.Default=1]="Default",M[M.Preferred=2]="Preferred"})(ii||(e.NotebookControllerAffinity=ii={}));var ri;(function(M){M[M.Default=1]="Default",M[M.Preferred=2]="Preferred",M[M.Hidden=-1]="Hidden"})(ri||(e.NotebookControllerAffinity2=ri={}));class Ti{constructor(F,oe=[]){this.uri=F,this.provides=(0,n.$3b)(oe)}}e.$2N=Ti;class Bi{constructor(F){this.label=F}}e.$3N=Bi;var si;(function(M){M[M.Named=1]="Named",M[M.Indexed=2]="Indexed"})(si||(e.NotebookVariablesRequestKind=si={}));let Nn=class{constructor(F,oe){this.label=F,this.timestamp=oe}};e.$4N=Nn,e.$4N=Nn=Fe([z],Nn);var oi;(function(M){M[M.Production=1]="Production",M[M.Development=2]="Development",M[M.Test=3]="Test"})(oi||(e.ExtensionMode=oi={}));var ai;(function(M){M[M.Node=1]="Node",M[M.Webworker=2]="Webworker"})(ai||(e.ExtensionRuntime=ai={}));var ci;(function(M){M[M.Other=0]="Other",M[M.Comment=1]="Comment",M[M.String=2]="String",M[M.RegEx=3]="RegEx"})(ci||(e.StandardTokenType=ci={}));class zi{constructor(F,oe){this.ranges=F,this.wordPattern=oe}}e.$5N=zi;class qi{constructor(F){this.c=F}get autoForwardAction(){return this.c}}e.$6N=qi;var li;(function(M){M[M.Queued=1]="Queued",M[M.Running=2]="Running",M[M.Passed=3]="Passed",M[M.Failed=4]="Failed",M[M.Skipped=5]="Skipped",M[M.Errored=6]="Errored"})(li||(e.TestResultState=li={}));var ui;(function(M){M[M.Run=1]="Run",M[M.Debug=2]="Debug",M[M.Coverage=3]="Coverage"})(ui||(e.TestRunProfileKind=ui={}));let Fn=class{constructor(F=void 0,oe=void 0,ye=void 0,Be=!1){this.include=F,this.exclude=oe,this.profile=ye,this.continuous=Be}};e.$7N=Fn,e.$7N=Fn=Fe([z],Fn);let Ln=_=class{static diff(F,oe,ye){const Be=new _(F);return Be.expectedOutput=oe,Be.actualOutput=ye,Be}constructor(F){this.message=F}};e.$8N=Ln,e.$8N=Ln=_=Fe([z],Ln);let Mn=class{constructor(F){this.id=F}};e.$9N=Mn,e.$9N=Mn=Fe([z],Mn);class $n{constructor(F,oe){this.covered=F,this.total=oe,hi(this)}}e.$0N=$n;function hi(M){if(M){if(M.covered>M.total)throw new Error(`The total number of covered items (${M.covered}) cannot be greater than the total (${M.total})`);if(M.total<0)throw new Error(`The number of covered items (${M.total}) cannot be negative`)}}class Tn{static fromDetails(F,oe){const ye=new $n(0,0),Be=new $n(0,0),Ge=new $n(0,0);for(const et of oe)if("branches"in et){ye.total+=1,ye.covered+=et.executed?1:0;for(const ht of et.branches)Be.total+=1,Be.covered+=ht.executed?1:0}else Ge.total+=1,Ge.covered+=et.executed?1:0;const Ze=new Tn(F,ye,Be.total>0?Be:void 0,Ge.total>0?Ge:void 0);return Ze.detailedCoverage=oe,Ze}constructor(F,oe,ye,Be){this.uri=F,this.statementCoverage=oe,this.branchCoverage=ye,this.declarationCoverage=Be}}e.$_N=Tn;class Ui{get executionCount(){return+this.executed}set executionCount(F){this.executed=F}constructor(F,oe,ye=[]){this.executed=F,this.location=oe,this.branches=ye}}e.$aO=Ui;class Hi{get executionCount(){return+this.executed}set executionCount(F){this.executed=F}constructor(F,oe,ye){this.executed=F,this.location=oe,this.label=ye}}e.$bO=Hi;class Vi{get executionCount(){return+this.executed}set executionCount(F){this.executed=F}constructor(F,oe,ye){this.name=F,this.executed=oe,this.location=ye}}e.$cO=Vi;var fi;(function(M){M[M.None=0]="None",M[M.Option=1]="Option",M[M.Default=2]="Default",M[M.Preferred=3]="Preferred"})(fi||(e.ExternalUriOpenerPriority=fi={}));var di;(function(M){M[M.Untrusted=0]="Untrusted",M[M.Trusted=1]="Trusted",M[M.Unspecified=2]="Unspecified"})(di||(e.WorkspaceTrustState=di={}));var mi;(function(M){M[M.Notify=1]="Notify",M[M.OpenBrowser=2]="OpenBrowser",M[M.OpenPreview=3]="OpenPreview",M[M.Silent=4]="Silent",M[M.Ignore=5]="Ignore",M[M.OpenBrowserOnce=6]="OpenBrowserOnce"})(mi||(e.PortAutoForwardAction=mi={}));class Wi{constructor(F,oe,ye,Be,Ge,Ze){this.kind=F,this.name=oe,this.detail=ye,this.uri=Be,this.range=Ge,this.selectionRange=Ze}}e.$dO=Wi;class Gi{constructor(F){this.uri=F}}e.$eO=Gi;class xi{constructor(F,oe){this.original=F,this.modified=oe}}e.$fO=xi;class Ji{constructor(F,oe,ye,Be){this.base=F,this.input1=oe,this.input2=ye,this.result=Be}}e.$gO=Ji;class Qi{constructor(F,oe){this.uri=F,this.viewType=oe}}e.$hO=Qi;class Xi{constructor(F){this.viewType=F}}e.$iO=Xi;class Zi{constructor(F,oe){this.uri=F,this.notebookType=oe}}e.$jO=Zi;class Yi{constructor(F,oe,ye){this.original=F,this.modified=oe,this.notebookType=ye}}e.$kO=Yi;class Ki{constructor(){}}e.$lO=Ki;class _i{constructor(F,oe){this.uri=F,this.inputBoxUri=oe}}e.$mO=_i;class er{constructor(F){this.providerId=F}}e.$nO=er;class tr{constructor(F){this.textDiffs=F}}e.$oO=tr;var gi;(function(M){M[M.Down=0]="Down",M[M.Up=1]="Up"})(gi||(e.InteractiveSessionVoteDirection=gi={}));var $i;(function(M){M[M.Action=1]="Action",M[M.Toolbar=2]="Toolbar"})($i||(e.ChatCopyKind=$i={}));var pi;(function(M){M[M.Short=1]="Short",M[M.Medium=2]="Medium",M[M.Full=3]="Full"})(pi||(e.ChatVariableLevel=pi={}));class nr{constructor(F,oe){this.label=F,this.values=oe}}e.$pO=nr;var wi;(function(M){M[M.Unhelpful=0]="Unhelpful",M[M.Helpful=1]="Helpful",M[M.Undone=2]="Undone",M[M.Accepted=3]="Accepted",M[M.Bug=4]="Bug"})(wi||(e.InteractiveEditorResponseFeedbackKind=wi={}));var bi;(function(M){M[M.Unhelpful=0]="Unhelpful",M[M.Helpful=1]="Helpful"})(bi||(e.ChatResultFeedbackKind=bi={}));class ir{constructor(F){this.value=typeof F=="string"?new me(F):F}}e.$qO=ir;class rr{constructor(F,oe){this.value=F,this.baseUri=oe}}e.$rO=rr;class sr{constructor(F,oe){this.value=F,this.title=oe}}e.$sO=sr;class or{constructor(F){this.value=F}}e.$tO=or;class ar{constructor(F){this.value=F}}e.$uO=ar;class cr{constructor(F){this.value=F}}e.$vO=cr;class lr{constructor(F,oe,ye,Be){this.prompt=F,this.command=oe,this.variables=ye,this.participant=Be}}e.$wO=lr;class ur{constructor(F,oe,ye,Be){this.response=F,this.result=oe,this.participant=ye,this.command=Be}}e.$xO=ur;var vi;(function(M){M[M.Panel=1]="Panel",M[M.Terminal=2]="Terminal",M[M.Notebook=3]="Notebook",M[M.Editor=4]="Editor"})(vi||(e.ChatLocation=vi={}));class hr{constructor(F){this.content=F}}e.$yO=hr;class fr{constructor(F,oe){this.content=F,this.name=oe}}e.$zO=fr;class dr{constructor(F,oe){this.content=F,this.name=oe}}e.$AO=dr;class sn extends Error{static NotFound(F){return new sn(F,sn.NotFound.name)}static NoPermissions(F){return new sn(F,sn.NoPermissions.name)}constructor(F,oe,ye){super(F,{cause:ye}),this.name="LanguageModelError",this.code=oe??""}}e.$BO=sn;var yi;(function(M){M[M.SymbolInformation=1]="SymbolInformation",M[M.CommandInformation=2]="CommandInformation",M[M.SearchInformation=3]="SearchInformation",M[M.SettingInformation=4]="SettingInformation"})(yi||(e.RelatedInformationType=yi={}));var Ei;(function(M){M[M.Started=1]="Started",M[M.Recognizing=2]="Recognizing",M[M.Recognized=3]="Recognized",M[M.Stopped=4]="Stopped"})(Ei||(e.SpeechToTextStatus=Ei={}));var ki;(function(M){M[M.Recognized=1]="Recognized",M[M.Stopped=2]="Stopped"})(ki||(e.KeywordRecognitionStatus=ki={}));class mr{constructor(F,oe){this.text=F,this.range=oe}}e.$CO=mr;var Ci;(function(M){M[M.Invoke=0]="Invoke",M[M.Automatic=1]="Automatic"})(Ci||(e.InlineEditTriggerKind=Ci={}))}),define(Ee[141],ke([1,0,18,14,161,75,102,24,148,53,61,21,151,19,11,3,45,179,236,135,94,280,139,72,95,137,290,140]),function(ce,e,n,A,P,D,C,k,b,$,E,y,w,g,d,c,m,u,p,h,f,l,t,a,o,r,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentResolvedVariable=e.ChatLocation=e.ChatAgentRequest=e.ChatResponseProgress=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseCommandButtonPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseMarkdownPart=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.LanguageModelMessage=e.ChatInlineFollowup=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$LO=z,e.$MO=J,e.$NO=Y;var v;(function(be){function De(G){const{selectionStartLineNumber:ve,selectionStartColumn:Oe,positionLineNumber:Ue,positionColumn:ze}=G,Xe=new i.$vM(ve-1,Oe-1),ot=new i.$vM(Ue-1,ze-1);return new i.$xM(Xe,ot)}be.to=De;function fe(G){const{anchor:ve,active:Oe}=G;return{selectionStartLineNumber:ve.line+1,selectionStartColumn:ve.character+1,positionLineNumber:Oe.line+1,positionColumn:Oe.character+1}}be.from=fe})(v||(e.Selection=v={}));var S;(function(be){function De(G){if(!G)return;const{start:ve,end:Oe}=G;return{startLineNumber:ve.line+1,startColumn:ve.character+1,endLineNumber:Oe.line+1,endColumn:Oe.character+1}}be.from=De;function fe(G){if(!G)return;const{startLineNumber:ve,startColumn:Oe,endLineNumber:Ue,endColumn:ze}=G;return new i.$wM(ve-1,Oe-1,Ue-1,ze-1)}be.to=fe})(S||(e.Range=S={}));var O;(function(be){function De(G){return{uri:G.uri,range:S.from(G.range)}}be.from=De;function fe(G){return new i.$GM(c.URI.revive(G.uri),S.to(G.range))}be.to=fe})(O||(e.Location=O={}));var N;(function(be){function De(fe){switch(fe){case 1:return i.StandardTokenType.Comment;case 0:return i.StandardTokenType.Other;case 3:return i.StandardTokenType.RegEx;case 2:return i.StandardTokenType.String}}be.to=De})(N||(e.TokenType=N={}));var j;(function(be){function De(G){return new i.$vM(G.lineNumber-1,G.column-1)}be.to=De;function fe(G){return{lineNumber:G.line+1,column:G.character+1}}be.from=fe})(j||(e.Position=j={}));var I;(function(be){function De(ve,Oe,Ue){return(0,n.$Hb)((0,n.$3b)(ve).map(ze=>fe(ze,Oe,Ue)))}be.from=De;function fe(ve,Oe,Ue){if(typeof ve=="string")return{$serialized:!0,language:ve,isBuiltin:Ue?.isBuiltin};if(ve)return{$serialized:!0,language:ve.language,scheme:G(ve.scheme,Oe),pattern:We.from(ve.pattern)??void 0,exclusive:ve.exclusive,notebookType:ve.notebookType,isBuiltin:Ue?.isBuiltin}}function G(ve,Oe){return Oe&&typeof ve=="string"?Oe.transformOutgoingScheme(ve):ve}})(I||(e.DocumentSelector=I={}));var B;(function(be){function De(G){switch(G){case i.DiagnosticTag.Unnecessary:return 1;case i.DiagnosticTag.Deprecated:return 2}}be.from=De;function fe(G){switch(G){case 1:return i.DiagnosticTag.Unnecessary;case 2:return i.DiagnosticTag.Deprecated;default:return}}be.to=fe})(B||(e.DiagnosticTag=B={}));var Z;(function(be){function De(G){let ve;return G.code&&((0,d.$Vf)(G.code)||(0,d.$Zf)(G.code)?ve=String(G.code):ve={value:String(G.code.value),target:G.code.target}),{...S.from(G.range),message:G.message,source:G.source,code:ve,severity:ae.from(G.severity),relatedInformation:G.relatedInformation&&G.relatedInformation.map(he.from),tags:Array.isArray(G.tags)?(0,n.$Hb)(G.tags.map(B.from)):void 0}}be.from=De;function fe(G){const ve=new i.$IM(S.to(G),G.message,ae.to(G.severity));return ve.source=G.source,ve.code=(0,d.$Vf)(G.code)?G.code:G.code?.value,ve.relatedInformation=G.relatedInformation&&G.relatedInformation.map(he.to),ve.tags=G.tags&&(0,n.$Hb)(G.tags.map(B.to)),ve}be.to=fe})(Z||(e.Diagnostic=Z={}));var he;(function(be){function De(G){return{...S.from(G.location.range),message:G.message,resource:G.location.uri}}be.from=De;function fe(G){return new i.$HM(new i.$GM(G.resource,S.to(G)),G.message)}be.to=fe})(he||(e.DiagnosticRelatedInformation=he={}));var ae;(function(be){function De(G){switch(G){case i.DiagnosticSeverity.Error:return p.MarkerSeverity.Error;case i.DiagnosticSeverity.Warning:return p.MarkerSeverity.Warning;case i.DiagnosticSeverity.Information:return p.MarkerSeverity.Info;case i.DiagnosticSeverity.Hint:return p.MarkerSeverity.Hint}return p.MarkerSeverity.Error}be.from=De;function fe(G){switch(G){case p.MarkerSeverity.Info:return i.DiagnosticSeverity.Information;case p.MarkerSeverity.Warning:return i.DiagnosticSeverity.Warning;case p.MarkerSeverity.Error:return i.DiagnosticSeverity.Error;case p.MarkerSeverity.Hint:return i.DiagnosticSeverity.Hint;default:return i.DiagnosticSeverity.Error}}be.to=fe})(ae||(e.DiagnosticSeverity=ae={}));var ee;(function(be){function De(G){return typeof G=="number"&&G>=i.ViewColumn.One?G-1:G===i.ViewColumn.Beside?r.$HD:r.$GD}be.from=De;function fe(G){if(typeof G=="number"&&G>=0)return G+1;throw new Error("invalid 'EditorGroupColumn'")}be.to=fe})(ee||(e.ViewColumn=ee={}));function _(be){return typeof be.range<"u"}function z(be){return be.length===0?!0:!!_(be[0])}var T;(function(be){function De(ze){return ze.map(be.from)}be.fromMany=De;function fe(ze){return ze&&typeof ze=="object"&&typeof ze.language=="string"&&typeof ze.value=="string"}function G(ze){let Xe;if(fe(ze)){const{language:lt,value:wt}=ze;Xe={value:"```"+lt+`
`+wt+"\n```\n"}}else i.$VM.isMarkdownString(ze)?Xe={value:ze.value,isTrusted:ze.isTrusted,supportThemeIcons:ze.supportThemeIcons,supportHtml:ze.supportHtml,baseUri:ze.baseUri}:typeof ze=="string"?Xe={value:ze}:Xe={value:""};const ot=Object.create(null);Xe.uris=ot;const pt=lt=>{try{let wt=c.URI.parse(lt,!0);wt=wt.with({query:ve(wt.query,ot)}),ot[lt]=wt}catch{}return""},Pt=new b.marked.Renderer;return Pt.link=pt,Pt.image=lt=>typeof lt=="string"?pt(C.$Nk(lt).href):"",(0,b.marked)(Xe.value,{renderer:Pt}),Xe}be.from=G;function ve(ze,Xe){if(!ze)return ze;let ot;try{ot=(0,$.$Qh)(ze)}catch{}if(!ot)return ze;let pt=!1;return ot=(0,y.$Rn)(ot,Pt=>{if(c.URI.isUri(Pt)){const lt=`__uri_${Math.random().toString(16).slice(2,8)}`;return Xe[lt]=Pt,pt=!0,lt}else return}),pt?JSON.stringify(ot):ze}function Oe(ze){const Xe=new i.$VM(ze.value,ze.supportThemeIcons);return Xe.isTrusted=ze.isTrusted,Xe.supportHtml=ze.supportHtml,Xe.baseUri=ze.baseUri?c.URI.from(ze.baseUri):void 0,Xe}be.to=Oe;function Ue(ze){if(ze)return typeof ze=="string"?ze:be.from(ze)}be.fromStrict=Ue})(T||(e.MarkdownString=T={}));function J(be){return z(be)?be.map(De=>({range:S.from(De.range),hoverMessage:Array.isArray(De.hoverMessage)?T.fromMany(De.hoverMessage):De.hoverMessage?T.from(De.hoverMessage):void 0,renderOptions:De.renderOptions})):be.map(De=>({range:S.from(De)}))}function Y(be){return typeof be>"u"?be:typeof be=="string"?c.URI.file(be):be}var W;(function(be){function De(fe){return typeof fe>"u"?fe:{contentText:fe.contentText,contentIconPath:fe.contentIconPath?Y(fe.contentIconPath):void 0,border:fe.border,borderColor:fe.borderColor,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,color:fe.color,backgroundColor:fe.backgroundColor,margin:fe.margin,width:fe.width,height:fe.height}}be.from=De})(W||(e.ThemableDecorationAttachmentRenderOptions=W={}));var re;(function(be){function De(fe){return typeof fe>"u"?fe:{backgroundColor:fe.backgroundColor,outline:fe.outline,outlineColor:fe.outlineColor,outlineStyle:fe.outlineStyle,outlineWidth:fe.outlineWidth,border:fe.border,borderColor:fe.borderColor,borderRadius:fe.borderRadius,borderSpacing:fe.borderSpacing,borderStyle:fe.borderStyle,borderWidth:fe.borderWidth,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,cursor:fe.cursor,color:fe.color,opacity:fe.opacity,letterSpacing:fe.letterSpacing,gutterIconPath:fe.gutterIconPath?Y(fe.gutterIconPath):void 0,gutterIconSize:fe.gutterIconSize,overviewRulerColor:fe.overviewRulerColor,before:fe.before?W.from(fe.before):void 0,after:fe.after?W.from(fe.after):void 0}}be.from=De})(re||(e.ThemableDecorationRenderOptions=re={}));var ue;(function(be){function De(fe){if(typeof fe>"u")return fe;switch(fe){case i.DecorationRangeBehavior.OpenOpen:return 0;case i.DecorationRangeBehavior.ClosedClosed:return 1;case i.DecorationRangeBehavior.OpenClosed:return 2;case i.DecorationRangeBehavior.ClosedOpen:return 3}}be.from=De})(ue||(e.DecorationRangeBehavior=ue={}));var ie;(function(be){function De(fe){return{isWholeLine:fe.isWholeLine,rangeBehavior:fe.rangeBehavior?ue.from(fe.rangeBehavior):void 0,overviewRulerLane:fe.overviewRulerLane,light:fe.light?re.from(fe.light):void 0,dark:fe.dark?re.from(fe.dark):void 0,backgroundColor:fe.backgroundColor,outline:fe.outline,outlineColor:fe.outlineColor,outlineStyle:fe.outlineStyle,outlineWidth:fe.outlineWidth,border:fe.border,borderColor:fe.borderColor,borderRadius:fe.borderRadius,borderSpacing:fe.borderSpacing,borderStyle:fe.borderStyle,borderWidth:fe.borderWidth,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,cursor:fe.cursor,color:fe.color,opacity:fe.opacity,letterSpacing:fe.letterSpacing,gutterIconPath:fe.gutterIconPath?Y(fe.gutterIconPath):void 0,gutterIconSize:fe.gutterIconSize,overviewRulerColor:fe.overviewRulerColor,before:fe.before?W.from(fe.before):void 0,after:fe.after?W.from(fe.after):void 0}}be.from=De})(ie||(e.DecorationRenderOptions=ie={}));var $e;(function(be){function De(G){return{text:G.newText,eol:G.newEol&&Se.from(G.newEol),range:S.from(G.range)}}be.from=De;function fe(G){const ve=new i.$BM(S.to(G.range),G.text);return ve.newEol=typeof G.eol>"u"?void 0:Se.to(G.eol),ve}be.to=fe})($e||(e.TextEdit=$e={}));var ne;(function(be){function De(G,ve){const Oe={edits:[]};if(G instanceof i.$EM){const Ue=new k.$Cc;for(const ze of G._allEntries())ze._type===1&&c.URI.isUri(ze.to)&&ze.from===void 0&&Ue.add(ze.to);for(const ze of G._allEntries())if(ze._type===1){let Xe;ze.options?.contents&&(ArrayBuffer.isView(ze.options.contents)?Xe={type:"base64",value:(0,A.$Oe)(A.$ue.wrap(ze.options.contents))}:Xe={type:"dataTransferItem",id:ze.options.contents._itemId}),Oe.edits.push({oldResource:ze.from,newResource:ze.to,options:{...ze.options,contents:Xe},metadata:ze.metadata})}else ze._type===2?Oe.edits.push({resource:ze.uri,textEdit:$e.from(ze.edit),versionId:Ue.has(ze.uri)?void 0:ve?.getTextDocumentVersion(ze.uri),metadata:ze.metadata}):ze._type===6?Oe.edits.push({resource:ze.uri,textEdit:{range:S.from(ze.range),text:ze.edit.value,insertAsSnippet:!0},versionId:Ue.has(ze.uri)?void 0:ve?.getTextDocumentVersion(ze.uri),metadata:ze.metadata}):ze._type===3?Oe.edits.push({metadata:ze.metadata,resource:ze.uri,cellEdit:ze.edit,notebookMetadata:ze.notebookMetadata,notebookVersionId:ve?.getNotebookDocumentVersion(ze.uri)}):ze._type===5&&Oe.edits.push({metadata:ze.metadata,resource:ze.uri,notebookVersionId:ve?.getNotebookDocumentVersion(ze.uri),cellEdit:{editType:1,index:ze.index,count:ze.count,cells:ze.cells.map(dt.from)}})}return Oe}be.from=De;function fe(G){const ve=new i.$EM,Oe=new k.$Bc;for(const Ue of G.edits)if(Ue.textEdit){const ze=Ue,Xe=c.URI.revive(ze.resource),ot=S.to(ze.textEdit.range),pt=ze.textEdit.text,Pt=ze.textEdit.insertAsSnippet;let lt;Pt?lt=i.$DM.replace(ot,new i.$FM(pt)):lt=i.$BM.replace(ot,pt);const wt=Oe.get(Xe);wt?wt.push(lt):Oe.set(Xe,[lt])}else ve.renameFile(c.URI.revive(Ue.oldResource),c.URI.revive(Ue.newResource),Ue.options);for(const[Ue,ze]of Oe)ve.set(Ue,ze);return ve}be.to=fe})(ne||(e.WorkspaceEdit=ne={}));var U;(function(be){const De=Object.create(null);De[i.SymbolKind.File]=0,De[i.SymbolKind.Module]=1,De[i.SymbolKind.Namespace]=2,De[i.SymbolKind.Package]=3,De[i.SymbolKind.Class]=4,De[i.SymbolKind.Method]=5,De[i.SymbolKind.Property]=6,De[i.SymbolKind.Field]=7,De[i.SymbolKind.Constructor]=8,De[i.SymbolKind.Enum]=9,De[i.SymbolKind.Interface]=10,De[i.SymbolKind.Function]=11,De[i.SymbolKind.Variable]=12,De[i.SymbolKind.Constant]=13,De[i.SymbolKind.String]=14,De[i.SymbolKind.Number]=15,De[i.SymbolKind.Boolean]=16,De[i.SymbolKind.Array]=17,De[i.SymbolKind.Object]=18,De[i.SymbolKind.Key]=19,De[i.SymbolKind.Null]=20,De[i.SymbolKind.EnumMember]=21,De[i.SymbolKind.Struct]=22,De[i.SymbolKind.Event]=23,De[i.SymbolKind.Operator]=24,De[i.SymbolKind.TypeParameter]=25;function fe(ve){return typeof De[ve]=="number"?De[ve]:6}be.from=fe;function G(ve){for(const Oe in De)if(De[Oe]===ve)return Number(Oe);return i.SymbolKind.Property}be.to=G})(U||(e.SymbolKind=U={}));var R;(function(be){function De(G){switch(G){case i.SymbolTag.Deprecated:return 1}}be.from=De;function fe(G){switch(G){case 1:return i.SymbolTag.Deprecated}}be.to=fe})(R||(e.SymbolTag=R={}));var q;(function(be){function De(G){return{name:G.name,kind:U.from(G.kind),tags:G.tags&&G.tags.map(R.from),containerName:G.containerName,location:V.from(G.location)}}be.from=De;function fe(G){const ve=new i.$MM(G.name,U.to(G.kind),G.containerName,V.to(G.location));return ve.tags=G.tags&&G.tags.map(R.to),ve}be.to=fe})(q||(e.WorkspaceSymbol=q={}));var X;(function(be){function De(G){const ve={name:G.name||"!!MISSING: name!!",detail:G.detail,range:S.from(G.range),selectionRange:S.from(G.selectionRange),kind:U.from(G.kind),tags:G.tags?.map(R.from)??[]};return G.children&&(ve.children=G.children.map(De)),ve}be.from=De;function fe(G){const ve=new i.$NM(G.name,G.detail,U.to(G.kind),S.to(G.range),S.to(G.selectionRange));return(0,n.$Lb)(G.tags)&&(ve.tags=G.tags.map(R.to)),G.children&&(ve.children=G.children.map(fe)),ve}be.to=fe})(X||(e.DocumentSymbol=X={}));var le;(function(be){function De(G){const ve=new i.$RM(U.to(G.kind),G.name,G.detail||"",c.URI.revive(G.uri),S.to(G.range),S.to(G.selectionRange));return ve._sessionId=G._sessionId,ve._itemId=G._itemId,ve}be.to=De;function fe(G,ve,Oe){if(ve=ve??G._sessionId,Oe=Oe??G._itemId,ve===void 0||Oe===void 0)throw new Error("invalid item");return{_sessionId:ve,_itemId:Oe,name:G.name,detail:G.detail,kind:U.from(G.kind),uri:G.uri,range:S.from(G.range),selectionRange:S.from(G.selectionRange),tags:G.tags?.map(R.from)}}be.from=fe})(le||(e.CallHierarchyItem=le={}));var Q;(function(be){function De(fe){return new i.$SM(le.to(fe.from),fe.fromRanges.map(G=>S.to(G)))}be.to=De})(Q||(e.CallHierarchyIncomingCall=Q={}));var x;(function(be){function De(fe){return new i.$TM(le.to(fe.to),fe.fromRanges.map(G=>S.to(G)))}be.to=De})(x||(e.CallHierarchyOutgoingCall=x={}));var V;(function(be){function De(G){return{range:G.range&&S.from(G.range),uri:G.uri}}be.from=De;function fe(G){return new i.$GM(c.URI.revive(G.uri),S.to(G.range))}be.to=fe})(V||(e.location=V={}));var L;(function(be){function De(G){const ve=G,Oe=G;return{originSelectionRange:ve.originSelectionRange?S.from(ve.originSelectionRange):void 0,uri:ve.targetUri?ve.targetUri:Oe.uri,range:S.from(ve.targetRange?ve.targetRange:Oe.range),targetSelectionRange:ve.targetSelectionRange?S.from(ve.targetSelectionRange):void 0}}be.from=De;function fe(G){return{targetUri:c.URI.revive(G.uri),targetRange:S.to(G.range),targetSelectionRange:G.targetSelectionRange?S.to(G.targetSelectionRange):void 0,originSelectionRange:G.originSelectionRange?S.to(G.originSelectionRange):void 0}}be.to=fe})(L||(e.DefinitionLink=L={}));var H;(function(be){function De(G){return{range:S.from(G.range),contents:T.fromMany(G.contents)}}be.from=De;function fe(G){return new i.$JM(G.contents.map(T.to),S.to(G.range))}be.to=fe})(H||(e.Hover=H={}));var K;(function(be){function De(G){return{range:S.from(G.range),expression:G.expression}}be.from=De;function fe(G){return new i.$EN(S.to(G.range),G.expression)}be.to=fe})(K||(e.EvaluatableExpression=K={}));var te;(function(be){function De(G){if(G instanceof i.$FN)return{type:"text",range:S.from(G.range),text:G.text};if(G instanceof i.$GN)return{type:"variable",range:S.from(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};if(G instanceof i.$HN)return{type:"expression",range:S.from(G.range),expression:G.expression};throw new Error("Unknown 'InlineValue' type")}be.from=De;function fe(G){switch(G.type){case"text":return{range:S.to(G.range),text:G.text};case"variable":return{range:S.to(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};case"expression":return{range:S.to(G.range),expression:G.expression}}}be.to=fe})(te||(e.InlineValue=te={}));var de;(function(be){function De(G){return{frameId:G.frameId,stoppedLocation:S.from(G.stoppedLocation)}}be.from=De;function fe(G){return new i.$IN(G.frameId,S.to(G.stoppedLocation))}be.to=fe})(de||(e.InlineValueContext=de={}));var se;(function(be){function De(G){return{range:S.from(G.range),kind:G.kind}}be.from=De;function fe(G){return new i.$KM(S.to(G.range),G.kind)}be.to=fe})(se||(e.DocumentHighlight=se={}));var ge;(function(be){function De(G){return{uri:G.uri,highlights:G.highlights.map(se.from)}}be.from=De;function fe(G){return new i.$LM(c.URI.revive(G.uri),G.highlights.map(se.to))}be.to=fe})(ge||(e.MultiDocumentHighlight=ge={}));var we;(function(be){function De(fe){switch(fe){case 1:return i.CompletionTriggerKind.TriggerCharacter;case 2:return i.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return i.CompletionTriggerKind.Invoke}}be.to=De})(we||(e.CompletionTriggerKind=we={}));var Ie;(function(be){function De(fe){return{triggerKind:we.to(fe.triggerKind),triggerCharacter:fe.triggerCharacter}}be.to=De})(Ie||(e.CompletionContext=Ie={}));var je;(function(be){function De(G){switch(G){case i.CompletionItemTag.Deprecated:return 1}}be.from=De;function fe(G){switch(G){case 1:return i.CompletionItemTag.Deprecated}}be.to=fe})(je||(e.CompletionItemTag=je={}));var pe;(function(be){const De=new Map([[i.CompletionItemKind.Method,0],[i.CompletionItemKind.Function,1],[i.CompletionItemKind.Constructor,2],[i.CompletionItemKind.Field,3],[i.CompletionItemKind.Variable,4],[i.CompletionItemKind.Class,5],[i.CompletionItemKind.Interface,7],[i.CompletionItemKind.Struct,6],[i.CompletionItemKind.Module,8],[i.CompletionItemKind.Property,9],[i.CompletionItemKind.Unit,12],[i.CompletionItemKind.Value,13],[i.CompletionItemKind.Constant,14],[i.CompletionItemKind.Enum,15],[i.CompletionItemKind.EnumMember,16],[i.CompletionItemKind.Keyword,17],[i.CompletionItemKind.Snippet,27],[i.CompletionItemKind.Text,18],[i.CompletionItemKind.Color,19],[i.CompletionItemKind.File,20],[i.CompletionItemKind.Reference,21],[i.CompletionItemKind.Folder,23],[i.CompletionItemKind.Event,10],[i.CompletionItemKind.Operator,11],[i.CompletionItemKind.TypeParameter,24],[i.CompletionItemKind.Issue,26],[i.CompletionItemKind.User,25]]);function fe(Oe){return De.get(Oe)??9}be.from=fe;const G=new Map([[0,i.CompletionItemKind.Method],[1,i.CompletionItemKind.Function],[2,i.CompletionItemKind.Constructor],[3,i.CompletionItemKind.Field],[4,i.CompletionItemKind.Variable],[5,i.CompletionItemKind.Class],[7,i.CompletionItemKind.Interface],[6,i.CompletionItemKind.Struct],[8,i.CompletionItemKind.Module],[9,i.CompletionItemKind.Property],[12,i.CompletionItemKind.Unit],[13,i.CompletionItemKind.Value],[14,i.CompletionItemKind.Constant],[15,i.CompletionItemKind.Enum],[16,i.CompletionItemKind.EnumMember],[17,i.CompletionItemKind.Keyword],[27,i.CompletionItemKind.Snippet],[18,i.CompletionItemKind.Text],[19,i.CompletionItemKind.Color],[20,i.CompletionItemKind.File],[21,i.CompletionItemKind.Reference],[23,i.CompletionItemKind.Folder],[10,i.CompletionItemKind.Event],[11,i.CompletionItemKind.Operator],[24,i.CompletionItemKind.TypeParameter],[25,i.CompletionItemKind.User],[26,i.CompletionItemKind.Issue]]);function ve(Oe){return G.get(Oe)??i.CompletionItemKind.Property}be.to=ve})(pe||(e.CompletionItemKind=pe={}));var Pe;(function(be){function De(fe,G){const ve=new i.$2M(fe.label);return ve.insertText=fe.insertText,ve.kind=pe.to(fe.kind),ve.tags=fe.tags?.map(je.to),ve.detail=fe.detail,ve.documentation=C.$Hk(fe.documentation)?T.to(fe.documentation):fe.documentation,ve.sortText=fe.sortText,ve.filterText=fe.filterText,ve.preselect=fe.preselect,ve.commitCharacters=fe.commitCharacters,m.$dt.isIRange(fe.range)?ve.range=S.to(fe.range):typeof fe.range=="object"&&(ve.range={inserting:S.to(fe.range.insert),replacing:S.to(fe.range.replace)}),ve.keepWhitespace=typeof fe.insertTextRules>"u"?!1:!!(fe.insertTextRules&1),typeof fe.insertTextRules<"u"&&fe.insertTextRules&4?ve.insertText=new i.$FM(fe.insertText):(ve.insertText=fe.insertText,ve.textEdit=ve.range instanceof i.$wM?new i.$BM(ve.range,ve.insertText):void 0),fe.additionalTextEdits&&fe.additionalTextEdits.length>0&&(ve.additionalTextEdits=fe.additionalTextEdits.map(Oe=>$e.to(Oe))),ve.command=G&&fe.command?G.fromInternal(fe.command):void 0,ve}be.to=De})(Pe||(e.CompletionItem=Pe={}));var Ce;(function(be){function De(G){if(typeof G.label!="string"&&!Array.isArray(G.label))throw new TypeError("Invalid label");return{label:G.label,documentation:T.fromStrict(G.documentation)}}be.from=De;function fe(G){return{label:G.label,documentation:C.$Hk(G.documentation)?T.to(G.documentation):G.documentation}}be.to=fe})(Ce||(e.ParameterInformation=Ce={}));var Le;(function(be){function De(G){return{label:G.label,documentation:T.fromStrict(G.documentation),parameters:Array.isArray(G.parameters)?G.parameters.map(Ce.from):[],activeParameter:G.activeParameter}}be.from=De;function fe(G){return{label:G.label,documentation:C.$Hk(G.documentation)?T.to(G.documentation):G.documentation,parameters:Array.isArray(G.parameters)?G.parameters.map(Ce.to):[],activeParameter:G.activeParameter}}be.to=fe})(Le||(e.SignatureInformation=Le={}));var Me;(function(be){function De(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(Le.from):[]}}be.from=De;function fe(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(Le.to):[]}}be.to=fe})(Me||(e.SignatureHelp=Me={}));var Ve;(function(be){function De(fe,G){const ve=new i.$1M(j.to(G.position),typeof G.label=="string"?G.label:G.label.map(qe.to.bind(void 0,fe)),G.kind&&xe.to(G.kind));return ve.textEdits=G.textEdits&&G.textEdits.map($e.to),ve.tooltip=C.$Hk(G.tooltip)?T.to(G.tooltip):G.tooltip,ve.paddingLeft=G.paddingLeft,ve.paddingRight=G.paddingRight,ve}be.to=De})(Ve||(e.InlayHint=Ve={}));var qe;(function(be){function De(fe,G){const ve=new i.$ZM(G.label);return ve.tooltip=C.$Hk(G.tooltip)?T.to(G.tooltip):G.tooltip,u.Command.is(G.command)&&(ve.command=fe.fromInternal(G.command)),G.location&&(ve.location=V.to(G.location)),ve}be.to=De})(qe||(e.InlayHintLabelPart=qe={}));var xe;(function(be){function De(G){return G}be.from=De;function fe(G){return G}be.to=fe})(xe||(e.InlayHintKind=xe={}));var _e;(function(be){function De(G){return{range:S.from(G.range),url:G.target,tooltip:G.tooltip}}be.from=De;function fe(G){let ve;if(G.url)try{ve=typeof G.url=="string"?c.URI.parse(G.url,!0):c.URI.revive(G.url)}catch{}return new i.$7M(S.to(G.range),ve)}be.to=fe})(_e||(e.DocumentLink=_e={}));var Ke;(function(be){function De(G){const ve=new i.$0M(G.label);return G.textEdit&&(ve.textEdit=$e.to(G.textEdit)),G.additionalTextEdits&&(ve.additionalTextEdits=G.additionalTextEdits.map(Oe=>$e.to(Oe))),ve}be.to=De;function fe(G){return{label:G.label,textEdit:G.textEdit?$e.from(G.textEdit):void 0,additionalTextEdits:G.additionalTextEdits?G.additionalTextEdits.map(ve=>$e.from(ve)):void 0}}be.from=fe})(Ke||(e.ColorPresentation=Ke={}));var nt;(function(be){function De(G){return new i.$8M(G[0],G[1],G[2],G[3])}be.to=De;function fe(G){return[G.red,G.green,G.blue,G.alpha]}be.from=fe})(nt||(e.Color=nt={}));var Ye;(function(be){function De(G){return{range:S.from(G.range)}}be.from=De;function fe(G){return new i.$QM(S.to(G.range))}be.to=fe})(Ye||(e.SelectionRange=Ye={}));var Qe;(function(be){function De(fe){switch(fe){case 2:return i.TextDocumentSaveReason.AfterDelay;case 1:return i.TextDocumentSaveReason.Manual;case 3:case 4:return i.TextDocumentSaveReason.FocusOut}}be.to=De})(Qe||(e.TextDocumentSaveReason=Qe={}));var me;(function(be){function De(G){switch(G){case i.TextEditorLineNumbersStyle.Off:return 0;case i.TextEditorLineNumbersStyle.Relative:return 2;case i.TextEditorLineNumbersStyle.Interval:return 3;case i.TextEditorLineNumbersStyle.On:default:return 1}}be.from=De;function fe(G){switch(G){case 0:return i.TextEditorLineNumbersStyle.Off;case 2:return i.TextEditorLineNumbersStyle.Relative;case 3:return i.TextEditorLineNumbersStyle.Interval;case 1:default:return i.TextEditorLineNumbersStyle.On}}be.to=fe})(me||(e.TextEditorLineNumbersStyle=me={}));var Se;(function(be){function De(G){if(G===i.EndOfLine.CRLF)return 1;if(G===i.EndOfLine.LF)return 0}be.from=De;function fe(G){if(G===1)return i.EndOfLine.CRLF;if(G===0)return i.EndOfLine.LF}be.to=fe})(Se||(e.EndOfLine=Se={}));var Ae;(function(be){function De(fe){if(typeof fe=="object")return fe.viewId;switch(fe){case i.ProgressLocation.SourceControl:return 3;case i.ProgressLocation.Window:return 10;case i.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}be.from=De})(Ae||(e.ProgressLocation=Ae={}));var Re;(function(be){function De(G){const ve={start:G.start+1,end:G.end+1};return G.kind&&(ve.kind=Te.from(G.kind)),ve}be.from=De;function fe(G){const ve={start:G.start-1,end:G.end-1};return G.kind&&(ve.kind=Te.to(G.kind)),ve}be.to=fe})(Re||(e.FoldingRange=Re={}));var Te;(function(be){function De(G){if(G)switch(G){case i.FoldingRangeKind.Comment:return u.$8t.Comment;case i.FoldingRangeKind.Imports:return u.$8t.Imports;case i.FoldingRangeKind.Region:return u.$8t.Region}}be.from=De;function fe(G){if(G)switch(G.value){case u.$8t.Comment.value:return i.FoldingRangeKind.Comment;case u.$8t.Imports.value:return i.FoldingRangeKind.Imports;case u.$8t.Region.value:return i.FoldingRangeKind.Region}}be.to=fe})(Te||(e.FoldingRangeKind=Te={}));var He;(function(be){function De(fe){if(fe)return{pinned:typeof fe.preview=="boolean"?!fe.preview:void 0,inactive:fe.background,preserveFocus:fe.preserveFocus,selection:typeof fe.selection=="object"?S.from(fe.selection):void 0,override:typeof fe.override=="boolean"?f.$0E.id:void 0}}be.from=De})(He||(e.TextEditorOpenOptions=He={}));var We;(function(be){function De(Oe){return Oe instanceof i.$sN?Oe.toJSON():typeof Oe=="string"?Oe:fe(Oe)||G(Oe)?new i.$sN(Oe.baseUri??Oe.base,Oe.pattern).toJSON():Oe}be.from=De;function fe(Oe){const Ue=Oe;return Ue?c.URI.isUri(Ue.baseUri)&&typeof Ue.pattern=="string":!1}function G(Oe){const Ue=Oe;return Ue?typeof Ue.base=="string"&&typeof Ue.pattern=="string":!1}function ve(Oe){return typeof Oe=="string"?Oe:new i.$sN(c.URI.revive(Oe.baseUri),Oe.pattern)}be.to=ve})(We||(e.GlobPattern=We={}));var rt;(function(be){function De(fe){if(fe){if(Array.isArray(fe))return fe.map(De);if(typeof fe=="string")return fe;{const G=fe;return{language:G.language,scheme:G.scheme,pattern:We.from(G.pattern),exclusive:G.exclusive,notebookType:G.notebookType}}}else return}be.from=De})(rt||(e.LanguageSelector=rt={}));var st;(function(be){function De(G){return!!G&&typeof G=="object"&&"documents"in G&&Array.isArray(G.documents)&&G.documents.every(ve=>Array.isArray(ve)&&ve.every(Oe=>Oe&&typeof Oe=="object"&&"uri"in Oe&&c.URI.isUri(Oe.uri)&&"version"in Oe&&typeof Oe.version=="number"&&"ranges"in Oe&&Array.isArray(Oe.ranges)&&Oe.ranges.every(Ue=>Ue instanceof i.$wM)))}be.is=De;function fe(G){return{documents:G.documents.map(ve=>ve.map(Oe=>({uri:c.URI.from(Oe.uri),version:Oe.version,ranges:Oe.ranges.map(Ue=>S.from(Ue))})))}}be.from=fe})(st||(e.MappedEditsContext=st={}));var Je;(function(be){function De(G){return{start:G.start,end:G.end}}be.from=De;function fe(G){return new i.$VN(G.start,G.end)}be.to=fe})(Je||(e.NotebookRange=Je={}));var ct;(function(be){function De(G){return{timing:typeof G.runStartTime=="number"&&typeof G.runEndTime=="number"?{startTime:G.runStartTime,endTime:G.runEndTime}:void 0,executionOrder:G.executionOrder,success:G.lastRunSuccess}}be.to=De;function fe(G){return{lastRunSuccess:G.success,runStartTime:G.timing?.startTime,runEndTime:G.timing?.endTime,executionOrder:G.executionOrder}}be.from=fe})(ct||(e.NotebookCellExecutionSummary=ct={}));var at;(function(be){function De(fe){if(fe===t.NotebookCellExecutionState.Unconfirmed)return i.NotebookCellExecutionState.Pending;if(fe===t.NotebookCellExecutionState.Pending)return;if(fe===t.NotebookCellExecutionState.Executing)return i.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${fe}`)}be.to=De})(at||(e.NotebookCellExecutionState=at={}));var ft;(function(be){function De(G){switch(G){case i.NotebookCellKind.Markup:return t.CellKind.Markup;case i.NotebookCellKind.Code:default:return t.CellKind.Code}}be.from=De;function fe(G){switch(G){case t.CellKind.Markup:return i.NotebookCellKind.Markup;case t.CellKind.Code:default:return i.NotebookCellKind.Code}}be.to=fe})(ft||(e.NotebookCellKind=ft={}));var ut;(function(be){function De(G){const ve={metadata:G.metadata??Object.create(null),cells:[]};for(const Oe of G.cells)i.$WN.validate(Oe),ve.cells.push(dt.from(Oe));return ve}be.from=De;function fe(G){const ve=new i.$XN(G.cells.map(dt.to));return(0,d.$9f)(G.metadata)||(ve.metadata=G.metadata),ve}be.to=fe})(ut||(e.NotebookData=ut={}));var dt;(function(be){function De(G){return{cellKind:ft.from(G.kind),language:G.languageId,mime:G.mime,source:G.value,metadata:G.metadata,internalMetadata:ct.from(G.executionSummary??{}),outputs:G.outputs?G.outputs.map(Ot.from):[]}}be.from=De;function fe(G){return new i.$WN(ft.to(G.cellKind),G.source,G.language,G.mime,G.outputs?G.outputs.map(Ot.to):void 0,G.metadata,G.internalMetadata?ct.to(G.internalMetadata):void 0)}be.to=fe})(dt||(e.NotebookCellData=dt={}));var At;(function(be){function De(G){return{mime:G.mime,valueBytes:A.$ue.wrap(G.data)}}be.from=De;function fe(G){return new i.$YN(G.valueBytes.buffer,G.mime)}be.to=fe})(At||(e.NotebookCellOutputItem=At={}));var Ot;(function(be){function De(G){return{outputId:G.id,items:G.items.map(At.from),metadata:G.metadata}}be.from=De;function fe(G){const ve=G.items.map(At.to);return new i.$ZN(ve,G.outputId,G.metadata)}be.to=fe})(Ot||(e.NotebookCellOutput=Ot={}));var Bt;(function(be){function De(ve){return G(ve)?{include:We.from(ve.include)??void 0,exclude:We.from(ve.exclude)??void 0}:We.from(ve)??void 0}be.from=De;function fe(ve){return G(ve)?{include:We.to(ve.include),exclude:We.to(ve.exclude)}:We.to(ve)}be.to=fe;function G(ve){const Oe=ve;return Oe?!(0,d.$5f)(Oe.include)&&!(0,d.$5f)(Oe.exclude):!1}})(Bt||(e.NotebookExclusiveDocumentPattern=Bt={}));var zt;(function(be){function De(fe,G,ve){const Oe=typeof fe.command=="string"?{title:"",command:fe.command}:fe.command;return{alignment:fe.alignment===i.NotebookCellStatusBarAlignment.Left?1:2,command:G.toInternal(Oe,ve),text:fe.text,tooltip:fe.tooltip,accessibilityInformation:fe.accessibilityInformation,priority:fe.priority}}be.from=De})(zt||(e.NotebookStatusBarItem=zt={}));var Et;(function(be){function De(fe,G,ve){const Oe=typeof fe.command=="string"?{title:"",command:fe.command}:fe.command;return{command:G.toInternal(Oe,ve),label:fe.label,description:fe.description,detail:fe.detail,documentation:fe.documentation}}be.from=De})(Et||(e.NotebookKernelSourceAction=Et={}));var qt;(function(be){function De(fe){return{transientOutputs:fe?.transientOutputs??!1,transientCellMetadata:fe?.transientCellMetadata??{},transientDocumentMetadata:fe?.transientDocumentMetadata??{},cellContentMetadata:fe?.cellContentMetadata??{}}}be.from=De})(qt||(e.NotebookDocumentContentOptions=qt={}));var xt;(function(be){function De(G){return{uri:G.uri,provides:G.provides}}be.from=De;function fe(G){return new i.$2N(c.URI.revive(G.uri),G.provides)}be.to=fe})(xt||(e.NotebookRendererScript=xt={}));var mt;(function(be){function De(G){return{message:T.fromStrict(G.message)||"",type:0,expected:G.expectedOutput,actual:G.actualOutput,contextValue:G.contextValue,location:G.location&&{range:S.from(G.location.range),uri:G.location.uri}}}be.from=De;function fe(G){const ve=new i.$8N(typeof G.message=="string"?G.message:T.to(G.message));return ve.actualOutput=G.actual,ve.expectedOutput=G.expected,ve.contextValue=G.contextValue,ve.location=G.location?V.to(G.location):void 0,ve}be.to=fe})(mt||(e.TestMessage=mt={}));var kt;(function(be){be.namespace=o.$jL,be.denamespace=o.$kL})(kt||(e.TestTag=kt={}));var jt;(function(be){function De(G){const ve=(0,h.$KO)(G).controllerId;return{extId:a.$eL.fromExtHostTestItem(G,ve).toString(),label:G.label,uri:c.URI.revive(G.uri),busy:G.busy,tags:G.tags.map(Oe=>kt.namespace(ve,Oe.id)),range:m.$dt.lift(S.from(G.range)),description:G.description||null,sortText:G.sortText||null,error:G.error&&T.fromStrict(G.error)||null}}be.from=De;function fe(G){return{parent:void 0,error:void 0,id:a.$eL.fromString(G.extId).localId,label:G.label,uri:c.URI.revive(G.uri),tags:(G.tags||[]).map(ve=>{const{tagId:Oe}=kt.denamespace(ve);return new i.$9N(Oe)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:S.to(G.range||void 0),canResolveChildren:!1,busy:G.busy,description:G.description||void 0,sortText:G.sortText||void 0}}be.toPlain=fe})(jt||(e.TestItem=jt={})),function(be){function De(G){return{id:G.id}}be.from=De;function fe(G){return new i.$9N(G.id)}be.to=fe}(kt||(e.TestTag=kt={}));var it;(function(be){const De=(G,ve)=>{const Oe=G.value;if(!Oe)return;const Ue={...jt.toPlain(Oe.item),parent:ve,taskStates:Oe.tasks.map(ze=>({state:ze.state,duration:ze.duration,messages:ze.messages.filter(Xe=>Xe.type===0).map(mt.to)})),children:[]};if(G.children)for(const ze of G.children.values()){const Xe=De(ze,Ue);Xe&&Ue.children.push(Xe)}return Ue};function fe(G){const ve=new w.$DO;for(const ze of G.items)ve.insert(a.$eL.fromString(ze.item.extId).path,ze);const Oe=[ve.nodes],Ue=[];for(;Oe.length;)for(const ze of Oe.pop())ze.value?Ue.push(ze):ze.children&&Oe.push(ze.children.values());return{completedAt:G.completedAt,results:Ue.map(ze=>De(ze)).filter(d.$4f)}}be.to=fe})(it||(e.TestResults=it={}));var bt;(function(be){function De(Oe){return{covered:Oe.covered,total:Oe.total}}function fe(Oe){return"line"in Oe?j.from(Oe):S.from(Oe)}function G(Oe){if(typeof Oe.executed=="number"&&Oe.executed<0)throw new Error(`Invalid coverage count ${Oe.executed}`);return"branches"in Oe?{count:Oe.executed,location:fe(Oe.location),type:1,branches:Oe.branches.length?Oe.branches.map(Ue=>({count:Ue.executed,location:Ue.location&&fe(Ue.location),label:Ue.label})):void 0}:{type:0,name:Oe.name,count:Oe.executed,location:fe(Oe.location)}}be.fromDetails=G;function ve(Oe,Ue){return i.$$N(Ue.statementCoverage),i.$$N(Ue.branchCoverage),i.$$N(Ue.declarationCoverage),{id:Oe,uri:Ue.uri,statement:De(Ue.statementCoverage),branch:Ue.branchCoverage&&De(Ue.branchCoverage),declaration:Ue.declarationCoverage&&De(Ue.declarationCoverage)}}be.fromFile=ve})(bt||(e.TestCoverage=bt={}));var gt;(function(be){function De(fe){switch(fe){case 1:return i.CodeActionTriggerKind.Invoke;case 2:return i.CodeActionTriggerKind.Automatic}}be.to=De})(gt||(e.CodeActionTriggerKind=gt={}));var $t;(function(be){function De(G){const ve=new i.$dO(U.to(G.kind),G.name,G.detail||"",c.URI.revive(G.uri),S.to(G.range),S.to(G.selectionRange));return ve._sessionId=G._sessionId,ve._itemId=G._itemId,ve}be.to=De;function fe(G,ve,Oe){if(ve=ve??G._sessionId,Oe=Oe??G._itemId,ve===void 0||Oe===void 0)throw new Error("invalid item");return{_sessionId:ve,_itemId:Oe,kind:U.from(G.kind),name:G.name,detail:G.detail??"",uri:G.uri,range:S.from(G.range),selectionRange:S.from(G.selectionRange),tags:G.tags?.map(R.from)}}be.from=fe})($t||(e.TypeHierarchyItem=$t={}));var Ut;(function(be){function De(fe){if(fe)return{value:fe.value,tooltip:fe.tooltip}}be.from=De})(Ut||(e.ViewBadge=Ut={}));var Rt;(function(be){function De(Oe,Ue,ze){const Xe=Ue.fileData;return Xe?new i.$kN(new i.$lN(Xe.name,c.URI.revive(Xe.uri),Xe.id,(0,D.$db)(()=>ze(Xe.id)))):Oe===E.$As.uriList&&Ue.uriListData?new i.$jN(ve(Ue.uriListData)):new i.$jN(Ue.asString)}be.to=De;async function fe(Oe,Ue){const ze=await Ue.asString();if(Oe===E.$As.uriList)return{asString:ze,fileData:void 0,uriListData:G(ze)};const Xe=Ue.asFile();return{asString:ze,fileData:Xe?{name:Xe.name,uri:Xe.uri,id:Xe._itemId??Xe.id}:void 0}}be.from=fe;function G(Oe){return P.$Mt.split(Oe).map(Ue=>{if(Ue.startsWith("#"))return Ue;try{return c.URI.parse(Ue)}catch{}return Ue})}function ve(Oe){return P.$Mt.create(Oe.map(Ue=>typeof Ue=="string"?Ue:c.URI.revive(Ue)))}})(Rt||(e.DataTransferItem=Rt={}));var Jt;(function(be){function De(G,ve){const Oe=G.items.map(([Ue,ze])=>[Ue,Rt.to(Ue,ze,ve)]);return new i.$mN(Oe)}be.toDataTransfer=De;async function fe(G){const ve={items:[]},Oe=[];for(const[Ue,ze]of G)Oe.push((async()=>{ve.items.push([Ue,await Rt.from(Ue,ze)])})());return await Promise.all(Oe),ve}be.from=fe})(Jt||(e.DataTransfer=Jt={}));var Nt;(function(be){function De(G,ve){return{kind:"reply",agentId:G.participant??ve?.agentId??"",subCommand:G.command??ve?.command,message:G.prompt,title:G.label}}be.from=De;function fe(G){return{prompt:G.message,label:G.title,participant:G.agentId,command:G.subCommand}}be.to=fe})(Nt||(e.ChatFollowup=Nt={}));var _t;(function(be){function De(fe){return"commandId"in fe?{kind:"command",title:fe.title??"",commandId:fe.commandId??"",when:fe.when??"",args:fe.args}:{kind:"reply",message:fe.message,title:fe.title,tooltip:fe.tooltip}}be.from=De})(_t||(e.ChatInlineFollowup=_t={}));var en;(function(be){function De(G){switch(G.role){case 0:return new i.$yO(G.content);case 1:return new i.$zO(G.content);case 2:return new i.$AO(G.content)}}be.to=De;function fe(G){if(G instanceof i.$yO)return{role:0,content:G.content};if(G instanceof i.$zO)return{role:1,content:G.content};if(G instanceof i.$AO)return{role:2,content:G.content};throw new Error("Invalid LanguageModelMessage")}be.from=fe})(en||(e.LanguageModelMessage=en={}));var Ht;(function(be){function De(ve){const Oe={};for(const Ue of Object.keys(ve))Oe[Ue]=ve[Ue].map(be.to);return Oe}be.objectTo=De;function fe(ve){return{level:Ct.to(ve.level),kind:ve.kind,value:(0,c.$wc)(ve.value)?c.URI.revive(ve.value):ve.value,description:ve.description}}be.to=fe;function G(ve){return{level:Ct.from(ve.level),kind:ve.kind,value:ve.value,description:ve.description}}be.from=G})(Ht||(e.ChatVariable=Ht={}));var Ct;(function(be){function De(G){switch(G){case"short":return i.ChatVariableLevel.Short;case"medium":return i.ChatVariableLevel.Medium;case"full":default:return i.ChatVariableLevel.Full}}be.to=De;function fe(G){switch(G){case i.ChatVariableLevel.Short:return"short";case i.ChatVariableLevel.Medium:return"medium";case i.ChatVariableLevel.Full:default:return"full"}}be.from=fe})(Ct||(e.ChatVariableLevel=Ct={}));var hn;(function(be){function De(fe){switch(fe){case 1:return i.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return i.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return i.InteractiveEditorResponseFeedbackKind.Undone;case 3:return i.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return i.InteractiveEditorResponseFeedbackKind.Bug}}be.to=De})(hn||(e.InteractiveEditorResponseFeedbackKind=hn={}));var Qt;(function(be){function De(G){return{kind:"markdownContent",content:T.from(G.value)}}be.to=De;function fe(G){return new i.$qO(T.to(G.content))}be.from=fe})(Qt||(e.ChatResponseMarkdownPart=Qt={}));var Xt;(function(be){function De(G){const{value:ve,baseUri:Oe}=G;function Ue(ze,Xe){return ze.map(ot=>{const pt=c.URI.joinPath(Xe,ot.name);return{label:ot.name,uri:pt,children:ot.children&&Ue(ot.children,pt)}})}return{kind:"treeData",treeData:{label:(0,g.$Sg)(Oe),uri:Oe,children:Ue(ve,Oe)}}}be.to=De;function fe(G){const ve=(0,$.$Rh)(G.treeData);function Oe(Xe){return Xe.map(ot=>({name:ot.label,children:ot.children&&Oe(ot.children)}))}const Ue=ve.uri,ze=ve.children?Oe(ve.children):[];return new i.$rO(ze,Ue)}be.from=fe})(Xt||(e.ChatResponseFilesPart=Xt={}));var vt;(function(be){function De(G){return{kind:"inlineReference",name:G.title,inlineReference:c.URI.isUri(G.value)?G.value:O.from(G.value)}}be.to=De;function fe(G){const ve=(0,$.$Rh)(G);return new i.$sO(c.URI.isUri(ve.inlineReference)?ve.inlineReference:O.to(ve.inlineReference),G.name)}be.from=fe})(vt||(e.ChatResponseAnchorPart=vt={}));var tn;(function(be){function De(G){return{kind:"progressMessage",content:T.from(G.value)}}be.to=De;function fe(G){return new i.$tO(G.content.value)}be.from=fe})(tn||(e.ChatResponseProgressPart=tn={}));var Ft;(function(be){function De(G,ve,Oe){return{kind:"command",command:ve.toInternal(G.value,Oe)??{command:G.value.command,title:G.value.title}}}be.to=De;function fe(G,ve){return new i.$uO(ve.fromInternal(G.command)??{command:G.command.id,title:G.command.title})}be.from=fe})(Ft||(e.ChatResponseCommandButtonPart=Ft={}));var Lt;(function(be){function De(G){return"variableName"in G.value?{kind:"reference",reference:{variableName:G.value.variableName,value:c.URI.isUri(G.value.value)||!G.value.value?G.value.value:O.from(G.value.value)}}:{kind:"reference",reference:c.URI.isUri(G.value)?G.value:O.from(G.value)}}be.to=De;function fe(G){const ve=(0,$.$Rh)(G),Oe=Ue=>c.URI.isUri(Ue)?Ue:O.to(Ue);return new i.$vO("variableName"in ve.reference?{variableName:ve.reference.variableName,value:ve.reference.value&&Oe(ve.reference.value)}:Oe(ve.reference))}be.from=fe})(Lt||(e.ChatResponseReferencePart=Lt={}));var on;(function(be){function De(ve,Oe,Ue){return ve instanceof i.$qO?Qt.to(ve):ve instanceof i.$sO?vt.to(ve):ve instanceof i.$vO?Lt.to(ve):ve instanceof i.$tO?tn.to(ve):ve instanceof i.$rO?Xt.to(ve):ve instanceof i.$uO?Ft.to(ve,Oe,Ue):{kind:"content",content:""}}be.to=De;function fe(ve,Oe){switch(ve.kind){case"reference":return Lt.from(ve);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return G(ve,Oe)}}be.from=fe;function G(ve,Oe){switch(ve.kind){case"markdownContent":return Qt.from(ve);case"inlineReference":return vt.from(ve);case"progressMessage":return;case"treeData":return Xt.from(ve);case"command":return Ft.from(ve,Oe)}}be.fromContent=G})(on||(e.ChatResponsePart=on={}));var Vt;(function(be){function De(G,ve){return"markdownContent"in ve?((0,s.$dG)(G,"chatParticipantAdditions"),{content:T.from(ve.markdownContent),kind:"markdownContent"}):"content"in ve?"vulnerabilities"in ve&&ve.vulnerabilities?((0,s.$dG)(G,"chatParticipantAdditions"),{content:ve.content,vulnerabilities:ve.vulnerabilities,kind:"vulnerability"}):typeof ve.content=="string"?{content:ve.content,kind:"content"}:((0,s.$dG)(G,"chatParticipantAdditions"),{content:T.from(ve.content),kind:"markdownContent"}):"documents"in ve?{documents:ve.documents.map(Oe=>({uri:Oe.uri,version:Oe.version,ranges:Oe.ranges.map(Ue=>S.from(Ue))})),kind:"usedContext"}:"reference"in ve?{reference:"uri"in ve.reference?{uri:ve.reference.uri,range:S.from(ve.reference.range)}:ve.reference,kind:"reference"}:"inlineReference"in ve?{inlineReference:"uri"in ve.inlineReference?{uri:ve.inlineReference.uri,range:S.from(ve.inlineReference.range)}:ve.inlineReference,name:ve.title,kind:"inlineReference"}:"participant"in ve?((0,s.$dG)(G,"chatParticipantAdditions"),{agentId:ve.participant,command:ve.command,kind:"agentDetection"}):"message"in ve?{content:T.from(ve.message),kind:"progressMessage"}:void 0}be.from=De;function fe(G,ve){switch(G.kind){case"markdownContent":return{content:G.content.value};case"inlineReference":return{inlineReference:(0,c.$wc)(G.inlineReference)?c.URI.revive(G.inlineReference):O.to(G.inlineReference),title:G.name};case"command":return{command:ve.fromInternal(G.command)??{command:G.command.id,title:G.command.title}};default:return}}be.toProgressContent=fe})(Vt||(e.ChatResponseProgress=Vt={}));var an;(function(be){function De(fe){return{prompt:fe.message,command:fe.command,variables:fe.variables.variables.map(nn.to),location:Dt.to(fe.location)}}be.to=De})(an||(e.ChatAgentRequest=an={}));var Dt;(function(be){function De(fe){switch(fe){case l.ChatAgentLocation.Notebook:return i.ChatLocation.Notebook;case l.ChatAgentLocation.Terminal:return i.ChatLocation.Terminal;case l.ChatAgentLocation.Panel:return i.ChatLocation.Panel;case l.ChatAgentLocation.Editor:return i.ChatLocation.Editor}}be.to=De})(Dt||(e.ChatLocation=Dt={}));var nn;(function(be){function De(fe){return{name:fe.name,range:fe.range&&[fe.range.start,fe.range.endExclusive],values:fe.values.map(Ht.to)}}be.to=De})(nn||(e.ChatAgentResolvedVariable=nn={}));var cn;(function(be){function De(fe){return{label:fe.label,values:fe.values.map(Ht.from),insertText:fe.insertText,detail:fe.detail,documentation:fe.documentation}}be.from=De})(cn||(e.ChatAgentCompletionItem=cn={}));var Zt;(function(be){function De(fe){return{errorDetails:fe.errorDetails,metadata:fe.metadata}}be.to=De})(Zt||(e.ChatAgentResult=Zt={}));var Wt;(function(be){function De(fe,G,ve){if(G.action.kind==="vote")return;const Oe=Zt.to(fe);return G.action.kind==="command"?{action:{kind:"command",commandButton:Vt.toProgressContent(G.action.commandButton,ve)},result:Oe}:G.action.kind==="followUp"?{action:{kind:"followUp",followup:Nt.to(G.action.followup)},result:Oe}:{action:G.action,result:Oe}}be.to=De})(Wt||(e.ChatAgentUserActionEvent=Wt={}));var Yt;(function(be){function De(fe,G,ve){return"terminalCommand"in fe?{terminalCommand:fe.terminalCommand,shouldExecute:fe.shouldExecute}:"uri"in fe?{uri:fe.uri}:G.toInternal(fe,ve)}be.from=De})(Yt||(e.TerminalQuickFix=Yt={}));var Kt;(function(be){function De(fe){return{kind:rn.to(fe.kind)}}be.to=De})(Kt||(e.PartialAcceptInfo=Kt={}));var rn;(function(be){function De(fe){switch(fe){case 0:return i.PartialAcceptTriggerKind.Word;case 1:return i.PartialAcceptTriggerKind.Line;case 2:return i.PartialAcceptTriggerKind.Suggest;default:return i.PartialAcceptTriggerKind.Unknown}}be.to=De})(rn||(e.PartialAcceptTriggerKind=rn={}));var fn;(function(be){function De(fe,G){return{id:G,label:fe.label,description:fe.description,canEdit:fe.canEdit,collapsibleState:fe.collapsibleState||0,contextValue:fe.contextValue}}be.from=De})(fn||(e.DebugTreeItem=fn={}))}),define(Ee[295],ke([1,0,45,135,72,134,95,141,3]),function(ce,e,n,A,P,D,C,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4O=e.$3O=e.$2O=e.$1O=void 0;const $=(h,f,l,t)=>{let a=f;return{enumerable:!0,configurable:!1,get(){return a},set(o){if(!l(a,o)){const r=a;a=o,h.listener?.(t(o,r))}}}},E=(h,f)=>h===f,y={range:(h,f)=>h===f?!0:!h||!f?!1:h.isEqual(f),label:E,description:E,sortText:E,busy:E,error:E,canResolveChildren:E,tags:(h,f)=>!(h.length!==f.length||h.some(l=>!f.find(t=>l.id===t.id)))},w=h=>f=>({op:4,update:h(f)}),g=(h,f)=>({range:(()=>{let l;const t=w(a=>({range:n.$dt.lift(k.Range.from(a))}));return{enumerable:!0,configurable:!1,get(){return l},set(a){h.listener?.({op:6}),y.range(l,a)||(l=a,h.listener?.(t(a)))}}})(),label:$(h,f,y.label,w(l=>({label:l}))),description:$(h,void 0,y.description,w(l=>({description:l}))),sortText:$(h,void 0,y.sortText,w(l=>({sortText:l}))),canResolveChildren:$(h,!1,y.canResolveChildren,l=>({op:2,state:l})),busy:$(h,!1,y.busy,w(l=>({busy:l}))),error:$(h,void 0,y.error,w(l=>({error:k.MarkdownString.fromStrict(l)||null}))),tags:$(h,[],y.tags,(l,t)=>({op:1,new:l.map(k.TestTag.from),old:t.map(k.TestTag.from)}))}),d=h=>{const f=P.$eL.fromString(h.extId),l=new m(f.controllerId,f.localId,h.label,b.URI.revive(h.uri)||void 0);return l.range=k.Range.to(h.range||void 0),l.description=h.description||void 0,l.sortText=h.sortText||void 0,l.tags=h.tags.map(t=>k.TestTag.to({id:(0,C.$kL)(t).tagId})),l},c=h=>{let f;for(const l of h.tests){const t=d(l.item);(0,A.$KO)(t).parent=f,f=t}return f};e.$1O=c;class m{constructor(f,l,t,a){if(l.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(l)} symbol`);const o=(0,A.$JO)(this,f);Object.defineProperties(this,{id:{value:l,enumerable:!0,writable:!1},uri:{value:a,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return o.parent instanceof u?void 0:o.parent}},children:{value:(0,D.$IO)(o,A.$KO,m),enumerable:!0,writable:!1},...g(o,t)})}}e.$2O=m;class u extends m{constructor(f,l){super(f,f,l,void 0),this._isRoot=!0}}e.$3O=u;class p extends D.$EO{constructor(f,l,t){super({controllerId:f,getDocumentVersion:a=>a&&t.getDocument(a)?.version,getApiFor:A.$KO,getChildren:a=>a.children,root:new u(f,l),toITestItem:k.TestItem.from})}}e.$4O=p});var Tt=this&&this.__classPrivateFieldSet||function(ce,e,n,A,P){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ce!==e||!P:!e.has(ce))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?P.call(ce,n):P?P.value=n:e.set(ce,n),n},tt=this&&this.__classPrivateFieldGet||function(ce,e,n,A){if(n==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ce!==e||!A:!e.has(ce))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?A:n==="a"?A.call(ce):A?A.value:e.get(ce)};define(Ee[296],ke([1,0,11,140,141,21,293,18,13,53,45,79,3,2,5,277,295,14,138,40,63,39,289,22]),function(ce,e,n,A,P,D,C,k,b,$,E,y,w,g,d,c,m,u,p,h,f,l,t,a){"use strict";var o,r,s;Object.defineProperty(e,"__esModule",{value:!0}),e.$cP=e.$bP=e.$aP=e.$_O=e.$$O=e.$0O=void 0;let i=class{constructor(I,B,Z){o.set(this,void 0),this.b=new Map,this.c=new Map,r.set(this,void 0),s.set(this,void 0),Tt(this,o,I.getProxy(C.$sM.MainThreadCommands),"f"),this.d=B,Tt(this,s,Z,"f"),Tt(this,r,I.getProxy(C.$sM.MainThreadTelemetry),"f"),this.converter=new v(this,he=>{const ae=this.c.get(he);return ae?.result===O.Void?ae:void 0},B),this.f=[{processArgument(he){return(0,$.$Rh)(he)}},{processArgument(he){return(0,D.$Rn)(he,function(ae){if(E.$dt.isIRange(ae))return P.Range.to(ae);if(y.$ct.isIPosition(ae))return P.Position.to(ae);if(E.$dt.isIRange(ae.range)&&w.URI.isUri(ae.uri))return P.location.to(ae);if(ae instanceof u.$ue)return ae.buffer.buffer;if(!Array.isArray(ae))return ae})}}]}registerArgumentProcessor(I){this.f.push(I)}registerApiCommand(I){const B=this.registerCommand(!1,I.id,async(...Z)=>{const he=I.args.map((ee,_)=>{if(!ee.validate(Z[_]))throw new Error(`Invalid argument '${ee.name}' when running '${I.id}', received: ${typeof Z[_]=="object"?JSON.stringify(Z[_],null,"	"):Z[_]} `);return ee.convert(Z[_])}),ae=await this.executeCommand(I.internalId,...he);return I.result.convert(ae,Z,this.converter)},void 0,{description:I.description,args:I.args,returns:I.result.description});return this.c.set(I.id,I),new A.$uM(()=>{B.dispose(),this.c.delete(I.id)})}registerCommand(I,B,Z,he,ae,ee){if(this.d.trace("ExtHostCommands#registerCommand",B),!B.trim().length)throw new Error("invalid id");if(this.b.has(B))throw new Error(`command '${B}' already exists`);return this.b.set(B,{callback:Z,thisArg:he,metadata:ae,extension:ee}),I&&tt(this,o,"f").$registerCommand(B),new A.$uM(()=>{this.b.delete(B)&&I&&tt(this,o,"f").$unregisterCommand(B)})}executeCommand(I,...B){return this.d.trace("ExtHostCommands#executeCommand",I),this.g(I,B,!0)}async g(I,B,Z){if(this.b.has(I))return tt(this,o,"f").$fireCommandActivationEvent(I),this.h(I,B,!1);{let he=!1;const ae=(0,D.$Rn)(B,function(ee){if(ee instanceof A.$vM)return P.Position.from(ee);if(ee instanceof A.$wM)return P.Range.from(ee);if(ee instanceof A.$GM)return P.location.from(ee);if(A.$VN.isNotebookRange(ee))return P.NotebookRange.from(ee);if(ee instanceof ArrayBuffer)return he=!0,u.$ue.wrap(new Uint8Array(ee));if(ee instanceof Uint8Array)return he=!0,u.$ue.wrap(ee);if(ee instanceof u.$ue)return he=!0,ee;if(!Array.isArray(ee))return ee});try{const ee=await tt(this,o,"f").$executeCommand(I,he?new p.$fw(ae):ae,Z);return(0,$.$Rh)(ee)}catch(ee){if(ee instanceof Error&&ee.message==="$executeCommand:retry")return this.g(I,B,!1);throw ee}}}async h(I,B,Z){const he=this.b.get(I);if(!he)throw new Error("Unknown command");const{callback:ae,thisArg:ee,metadata:_}=he;if(_?.args)for(let T=0;T<_.args.length;T++)try{(0,n.$ag)(B[T],_.args[T].constraint)}catch{throw new Error(`Running the contributed command: '${I}' failed. Illegal argument '${_.args[T].name}' - ${_.args[T].description}`)}const z=f.$3d.create();try{return await ae.apply(ee,B)}catch(T){if(I===this.converter.delegatingCommandId){const J=this.converter.getActualCommand(...B);J&&(I=J.command)}if(this.d.error(T,I,he.extension?.identifier),!Z)throw T;if(he.extension?.identifier){const J=tt(this,s,"f").onExtensionError(he.extension.identifier,T);this.d.trace("forwarded error to extension?",J,he.extension?.identifier)}throw new class extends Error{constructor(){super((0,h.$6i)(T)),this.id=I,this.source=he.extension?.displayName??he.extension?.name}}}finally{this.j(he,I,z.elapsed())}}j(I,B,Z){I.extension&&tt(this,r,"f").$publicLog2("Extension:ActionExecuted",{extensionId:I.extension.identifier.value,id:new l.$5o(B),duration:Z})}$executeContributedCommand(I,...B){this.d.trace("ExtHostCommands#$executeContributedCommand",I);const Z=this.b.get(I);return Z?(B=B.map(he=>this.f.reduce((ae,ee)=>ee.processArgument(ae,Z.extension?.identifier),he)),this.h(I,B,!0)):Promise.reject(new Error(`Contributed command '${I}' does not exist.`))}getCommands(I=!1){return this.d.trace("ExtHostCommands#getCommands",I),tt(this,o,"f").$getCommands().then(B=>(I&&(B=B.filter(Z=>Z[0]!=="_")),B))}$getContributedCommandMetadata(){const I=Object.create(null);for(const[B,Z]of this.b){const{metadata:he}=Z;he&&(I[B]=he)}return Promise.resolve(I)}};e.$0O=i,o=new WeakMap,r=new WeakMap,s=new WeakMap,e.$0O=i=Fe([Ne(0,c.$OO),Ne(1,b.$Oj),Ne(2,t.$9O)],i),e.$$O=(0,d.$ii)("IExtHostCommands");class v{constructor(I,B,Z){this.d=I,this.f=B,this.g=Z,this.delegatingCommandId=`__vsc${(0,a.$Eg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(I,B){if(!I)return;const Z={$ident:void 0,id:I.command,title:I.title,tooltip:I.tooltip};if(!I.command)return Z;const he=this.f(I.command);if(he)Z.id=he.internalId,Z.arguments=he.args.map((ae,ee)=>ae.convert(I.arguments&&I.arguments[ee]));else if((0,k.$Lb)(I.arguments)){const ae=`${I.command} /${++this.c}`;this.b.set(ae,I),B.add((0,g.$Sc)(()=>{this.b.delete(ae),this.g.trace("CommandsConverter#DISPOSE",ae)})),Z.$ident=ae,Z.id=this.delegatingCommandId,Z.arguments=[ae],this.g.trace("CommandsConverter#CREATE",I.command,ae)}return Z}fromInternal(I){return typeof I.$ident=="string"?this.b.get(I.$ident):{command:I.id,title:I.title,arguments:I.arguments}}getActualCommand(...I){return this.b.get(I[0])}h(...I){const B=this.getActualCommand(...I);return this.g.trace("CommandsConverter#EXECUTE",I[0],B?B.command:"MISSING"),B?this.d.executeCommand(B.command,...B.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${I[0]}`)}}e.$_O=v;class S{static Arr(I){return new S(`${I.name}_array`,`Array of ${I.name}, ${I.description}`,B=>Array.isArray(B)&&B.every(Z=>I.validate(Z)),B=>B.map(Z=>I.convert(Z)))}constructor(I,B,Z,he){this.name=I,this.description=B,this.validate=Z,this.convert=he}optional(){return new S(this.name,`(optional) ${this.description}`,I=>I==null||this.validate(I),I=>I===void 0?void 0:I===null?null:this.convert(I))}with(I,B){return new S(I??this.name,B??this.description,this.validate,this.convert)}}e.$aP=S,S.Uri=new S("uri","Uri of a text document",j=>w.URI.isUri(j),j=>j),S.Position=new S("position","A position in a text document",j=>A.$vM.isPosition(j),P.Position.from),S.Range=new S("range","A range in a text document",j=>A.$wM.isRange(j),P.Range.from),S.Selection=new S("selection","A selection in a text document",j=>A.$xM.isSelection(j),P.Selection.from),S.Number=new S("number","",j=>typeof j=="number",j=>j),S.String=new S("string","",j=>typeof j=="string",j=>j),S.StringArray=S.Arr(S.String),S.CallHierarchyItem=new S("item","A call hierarchy item",j=>j instanceof A.$RM,P.CallHierarchyItem.from),S.TypeHierarchyItem=new S("item","A type hierarchy item",j=>j instanceof A.$dO,P.TypeHierarchyItem.from),S.TestItem=new S("testItem","A VS Code TestItem",j=>j instanceof m.$2O,P.TestItem.from);class O{constructor(I,B){this.description=I,this.convert=B}}e.$bP=O,O.Void=new O("no result",j=>j);class N{constructor(I,B,Z,he,ae){this.id=I,this.internalId=B,this.description=Z,this.args=he,this.result=ae}}e.$cP=N}),define(Ee[297],ke([1,0,10,2,12,226]),function(ce,e,n,A,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XP=e.$WP=void 0,e.$WP="remoteFilesystem";class C extends D.$VP{static register(b,$,E){const y=b.getConnection();if(!y)return A.$Uc.None;const w=new A.$Tc,g=(async()=>{try{const d=await b.getRawEnvironment();d?$.registerProvider(P.Schemas.vscodeRemote,w.add(new C(d,y))):E.error("Cannot register remote filesystem provider. Remote environment doesnot exist.")}catch(d){E.error("Cannot register remote filesystem provider. Error while fetching remote environment.",(0,n.$0)(d))}})();return w.add($.onWillActivateFileSystemProvider(d=>{d.scheme===P.Schemas.vscodeRemote&&d.join(g)})),w}constructor(b,$){super($.getChannel(e.$WP),{pathCaseSensitive:b.os===3})}}e.$XP=C}),define(Ee[73],ke([1,0,89,78,28,298,14,10,6,2,7,4,22,44,108]),function(ce,e,n,A,P,D,C,k,b,$,E,y,w,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ci=e.$_h=e.$$h=e.$0h=void 0,e.$ai=o,e.$bi=r,e.$di=v,e.$ei=S;class c{traceSocketEvent(N,j){d.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,N,j)}constructor(N,j=""){this.f=!0,this.debugLabel=j,this.socket=N,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=I=>{if(this.traceSocketEvent("error",{code:I?.code,message:I?.message}),I){if(I.code==="EPIPE")return;(0,k.$1)(I)}},this.socket.on("error",this.a),this.b=I=>{this.traceSocketEvent("close",{hadError:I}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(N){const j=I=>{this.traceSocketEvent("read",I),N(C.$ue.wrap(I))};return this.socket.on("data",j),{dispose:()=>this.socket.off("data",j)}}onClose(N){const j=I=>{N({type:0,hadError:I,error:void 0})};return this.socket.on("close",j),{dispose:()=>this.socket.off("close",j)}}onEnd(N){const j=()=>{N()};return this.socket.on("end",j),{dispose:()=>this.socket.off("end",j)}}write(N){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",N),this.socket.write(N.buffer,j=>{if(j){if(j.code==="EPIPE")return;(0,k.$1)(j)}})}catch(j){if(j.code==="EPIPE")return;(0,k.$1)(j)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((N,j)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),N();return}const I=()=>{this.socket.off("close",I),this.socket.off("end",I),this.socket.off("error",I),this.socket.off("timeout",I),this.socket.off("drain",I),this.traceSocketEvent("nodeDrainEnd"),N()};this.socket.on("close",I),this.socket.on("end",I),this.socket.on("error",I),this.socket.on("timeout",I),this.socket.on("drain",I)})}}e.$0h=c;var m;(function(O){O[O.MinHeaderByteSize=2]="MinHeaderByteSize",O[O.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(m||(m={}));var u;(function(O){O[O.PeekHeader=1]="PeekHeader",O[O.ReadHeader=2]="ReadHeader",O[O.ReadBody=3]="ReadBody",O[O.Fin=4]="Fin"})(u||(u={}));class p extends $.$Uc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(N,j){this.socket.traceSocketEvent(N,j)}constructor(N,j,I,B){super(),this.f=this.B(new b.$7d),this.g=this.B(new b.$7d),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=N,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:j,inflateBytesLength:I?.byteLength||0,recordInflateBytes:B}),this.a=this.B(new h(this,j,I,B,this.f,(Z,he)=>this.m(Z,he))),this.B(this.a.onError(Z=>{console.error(Z),(0,k.$1)(Z),this.g.fire({type:0,hadError:!0,error:Z})})),this.b=new d.$5h,this.B(this.socket.onData(Z=>this.n(Z))),this.B(this.socket.onClose(async Z=>{this.a.isProcessingReadQueue()&&await b.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(Z)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(N){return this.f.event(N)}onClose(N){return this.g.event(N)}onEnd(N){return this.socket.onEnd(N)}write(N){let j=0;for(;j<N.byteLength;)this.a.writeMessage(N.slice(j,Math.min(j+262144,N.byteLength)),{compressed:!0,opcode:2}),j+=262144}m(N,{compressed:j,opcode:I}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",N);let B=2;N.byteLength<126?B+=0:N.byteLength<2**16?B+=2:B+=8;const Z=C.$ue.alloc(B),he=j?64:0,ae=I&15;if(Z.writeUInt8(128|he|ae,0),N.byteLength<126)Z.writeUInt8(N.byteLength,1);else if(N.byteLength<2**16){Z.writeUInt8(126,1);let ee=1;Z.writeUInt8(N.byteLength>>>8&255,++ee),Z.writeUInt8(N.byteLength>>>0&255,++ee)}else{Z.writeUInt8(127,1);let ee=1;Z.writeUInt8(0,++ee),Z.writeUInt8(0,++ee),Z.writeUInt8(0,++ee),Z.writeUInt8(0,++ee),Z.writeUInt8(N.byteLength>>>24&255,++ee),Z.writeUInt8(N.byteLength>>>16&255,++ee),Z.writeUInt8(N.byteLength>>>8&255,++ee),Z.writeUInt8(N.byteLength>>>0&255,++ee)}this.socket.write(C.$ue.concat([Z,N]))}end(){this.h=!0,this.socket.end()}n(N){if(N.byteLength!==0){for(this.b.acceptChunk(N);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const j=this.b.peek(this.j.readLen),I=j.readUInt8(0),B=(I&128)>>>7,Z=(I&64)>>>6,he=I&15,ae=j.readUInt8(1),ee=(ae&128)>>>7,_=ae&127;this.j.state=2,this.j.readLen=2+(ee?4:0)+(_===126?2:0)+(_===127?8:0),this.j.fin=B,this.j.firstFrameOfMessage&&(this.j.compressed=!!Z),this.j.firstFrameOfMessage=!!B,this.j.mask=0,this.j.opcode=he,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const j=this.b.read(this.j.readLen),I=j.readUInt8(1),B=(I&128)>>>7;let Z=I&127,he=1;Z===126?Z=j.readUInt8(++he)*2**8+j.readUInt8(++he):Z===127&&(Z=j.readUInt8(++he)*0+j.readUInt8(++he)*0+j.readUInt8(++he)*0+j.readUInt8(++he)*0+j.readUInt8(++he)*2**24+j.readUInt8(++he)*2**16+j.readUInt8(++he)*2**8+j.readUInt8(++he));let ae=0;B&&(ae=j.readUInt8(++he)*2**24+j.readUInt8(++he)*2**16+j.readUInt8(++he)*2**8+j.readUInt8(++he)),this.j.state=3,this.j.readLen=Z,this.j.mask=ae,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const j=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",j),t(j,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",j),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(j,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(j,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await b.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$$h=p;class h extends $.$Uc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:C.$ue.alloc(0)}constructor(N,j,I,B,Z,he){super(),this.n=N,this.r=Z,this.s=he,this.a=this.B(new b.$7d),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new b.$7d),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new b.$7d),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,j?(this.b=this.B(new f(this.n,B,I,{windowBits:15})),this.f=this.B(new l(this.n,{windowBits:15})),this.B(this.b.onError(ae=>this.a.fire(ae))),this.B(this.f.onError(ae=>this.a.fire(ae)))):(this.b=null,this.f=null)}writeMessage(N,j){this.g.push({data:N,options:j}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:N,options:j}=this.g.shift();if(this.f&&j.compressed){const I=await this.w(this.f,N);this.s(I,j)}else this.s(N,{...j,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(N,j){return new Promise((I,B)=>{N.write(j),N.flush(Z=>I(Z))})}acceptFrame(N,j,I){this.h.push({data:N,isCompressed:j,isLastFrameOfMessage:I}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const N=this.h.shift();if(this.b&&N.isCompressed){const j=await this.C(this.b,N.data,N.isLastFrameOfMessage);this.r.fire(j)}else this.r.fire(N.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(N,j,I){return new Promise((B,Z)=>{N.write(j),I&&N.write(C.$ue.fromByteArray([0,0,255,255])),N.flush(he=>B(he))})}}class f extends $.$Uc{get recordedInflateBytes(){return this.j?C.$ue.concat(this.f):C.$ue.alloc(0)}constructor(N,j,I,B){super(),this.h=N,this.j=j,this.a=this.B(new b.$7d),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,D.createInflateRaw)(B),this.b.on("error",Z=>{this.h.traceSocketEvent("zlibInflateError",{message:Z?.message,code:Z?.code}),this.a.fire(Z)}),this.b.on("data",Z=>{this.h.traceSocketEvent("zlibInflateData",Z),this.g.push(C.$ue.wrap(Z))}),I&&(this.h.traceSocketEvent("zlibInflateInitialWrite",I.buffer),this.b.write(I.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(N){this.j&&this.f.push(N.clone()),this.h.traceSocketEvent("zlibInflateWrite",N),this.b.write(N.buffer)}flush(N){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const j=C.$ue.concat(this.g);this.g.length=0,N(j)})}}class l extends $.$Uc{constructor(N,j){super(),this.g=N,this.a=this.B(new b.$7d),this.onError=this.a.event,this.f=[],this.b=(0,D.createDeflateRaw)({windowBits:15}),this.b.on("error",I=>{this.g.traceSocketEvent("zlibDeflateError",{message:I?.message,code:I?.code}),this.a.fire(I)}),this.b.on("data",I=>{this.g.traceSocketEvent("zlibDeflateData",I),this.f.push(C.$ue.wrap(I))})}write(N){this.g.traceSocketEvent("zlibDeflateWrite",N.buffer),this.b.write(N.buffer)}flush(N){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let j=C.$ue.concat(this.f);this.f.length=0,j=j.slice(0,j.byteLength-4),N(j)})}}function t(O,N){if(N===0)return;const j=O.byteLength>>>2;for(let ee=0;ee<j;ee++){const _=O.readUInt32BE(ee*4);O.writeUInt32BE(_^N,ee*4)}const I=j*4,B=O.byteLength-I,Z=N>>>24&255,he=N>>>16&255,ae=N>>>8&255;B>=1&&O.writeUInt8(O.readUInt8(I)^Z,I),B>=2&&O.writeUInt8(O.readUInt8(I+1)^he,I+1),B>=3&&O.writeUInt8(O.readUInt8(I+2)^ae,I+2)}e.$_h=process.env.XDG_RUNTIME_DIR;const a={2:107,1:103};function o(){const O=(0,w.$Eg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${O}-sock`;const N=process.platform!=="darwin"&&e.$_h?e.$_h:(0,P.tmpdir)(),j=(0,E.$kc)(N,`vscode-ipc-${O}.sock`);return s(j),j}function r(O,N,j){const B=(0,n.createHash)("sha256").update(O).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${B}-${j}-${N}-sock`;const Z=j.substr(0,4),he=N.substr(0,6);let ae;return process.platform!=="darwin"&&e.$_h&&!process.env.VSCODE_PORTABLE?ae=(0,E.$kc)(e.$_h,`vscode-${B}-${Z}-${he}.sock`):ae=(0,E.$kc)(O,`${Z}-${he}.sock`),s(ae),ae}function s(O){const N=a[y.$o];typeof N=="number"&&O.length>=N&&console.warn(`WARNING: IPC handle "${O}" is longer than ${N} chars, try a shorter --user-data-dir`)}class i extends g.$Yh{static b(N){const j=b.Event.fromNodeEventEmitter(N,"connection");return b.Event.map(j,I=>({protocol:new d.$6h(new c(I,"ipc-server-connection")),onDidClientDisconnect:b.Event.once(b.Event.fromNodeEventEmitter(I,"close"))}))}constructor(N){super(i.b(N)),this.d=N}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$ci=i;function v(O){return new Promise((N,j)=>{const I=(0,A.createServer)();I.on("error",j),I.listen(O,()=>{I.removeListener("error",j),N(new i(I))})})}function S(O,N){return new Promise((j,I)=>{const B=(0,A.createConnection)(O,()=>{B.removeListener("error",I),j(d.$7h.fromSocket(new c(B,`ipc-client${N}`),N))});B.once("error",I)})}}),define(Ee[142],ke([1,0,86,15,14,10,11,25,26,87,13,48,244,298]),function(ce,e,n,A,P,D,C,k,b,$,E,y,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ir=void 0,e.$Jr=m;let d=class extends y.$Bp{constructor(p,h,f,l){super(l),this.m=p,this.n=h,this.r=f,this.s(),this.B(p.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.s()}))}s(){const p=this.m.getValue("http");this.f=p?.proxy,this.g=!!p?.proxyStrictSSL,this.h=p?.proxyAuthorization}async request(p,h){const{f,g:l}=this;let t;try{t=await(0,$.$tm)(this.m,this.r,this.n.args,process.env)}catch(r){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,D.$0)(r)))}const a={...process.env,...t},o=p.agent?p.agent:await(0,w.$Hr)(p.url||"",a,{proxyUrl:f,strictSSL:l});return p.agent=o,p.strictSSL=l,this.h&&(p.headers={...p.headers||{},"Proxy-Authorization":this.h}),this.c(p.isChromiumNetwork?"electron":"node",p,()=>m(p,h))}async resolveProxy(p){}async loadCertificates(){return(await new Promise((h,f)=>{ce(["@vscode/proxy-agent"],h,f)})).loadSystemCertificates({log:this.r})}};e.$Ir=d,e.$Ir=d=Fe([Ne(0,k.$Oi),Ne(1,b.$qi),Ne(2,E.$Oj),Ne(3,E.$Pj)],d);async function c(u){return((0,n.parse)(u.url).protocol==="https:"?await new Promise((f,l)=>{ce(["https"],f,l)}):await new Promise((f,l)=>{ce(["http"],f,l)})).request}async function m(u,p){return A.Promises.withAsyncBody(async(h,f)=>{const l=(0,n.parse)(u.url),t=u.getRawRequest?u.getRawRequest(u):await c(u),a={hostname:l.hostname,port:l.port?parseInt(l.port):l.protocol==="https:"?443:80,protocol:l.protocol,path:l.path,method:u.type||"GET",headers:u.headers,agent:u.agent,rejectUnauthorized:(0,C.$2f)(u.strictSSL)?u.strictSSL:!0};u.user&&u.password&&(a.auth=u.user+":"+u.password);const o=t(a,r=>{const s=(0,C.$Zf)(u.followRedirects)?u.followRedirects:3;if(r.statusCode&&r.statusCode>=300&&r.statusCode<400&&s>0&&r.headers.location)m({...u,url:r.headers.location,followRedirects:s-1},p).then(h,f);else{let i=r;!u.isChromiumNetwork&&r.headers["content-encoding"]==="gzip"&&(i=r.pipe((0,g.createGunzip)())),h({res:r,stream:(0,P.$Je)(i)})}});o.on("error",f),u.timeout&&o.setTimeout(u.timeout),u.isChromiumNetwork&&o.removeHeader("Content-Length"),u.data&&typeof u.data=="string"&&o.write(u.data),o.end(),p.onCancellationRequested(()=>{o.abort(),f(new D.$5)})})}}),define(Ee[143],ke([1,0,55,78,93,12,7,14,6,73,87,13,50,4,62,132,2,287,25]),function(ce,e,n,A,P,D,C,k,b,$,E,y,w,g,d,c,m,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dn=void 0,e.$cn=h;async function h(r={},s,i,v,S,O){const N=await(0,P.$Yl)(i,v.userDataPath);let j={};if(s)try{j=await(0,E.$tm)(O,S,v.args,process.env)}catch(ee){S.error("ExtensionHostConnection#buildUserEnvironment resolving shell environment failed",ee)}const B={...process.env,...j,VSCODE_AMD_ENTRYPOINT:"vs/workbench/api/node/extensionHostProcess",VSCODE_HANDLES_UNCAUGHT_ERRORS:"true",VSCODE_NLS_CONFIG:JSON.stringify(N,void 0,0),...r},Z=v.isBuilt?(0,C.$kc)(v.appRoot,"bin"):(0,C.$kc)(v.appRoot,"resources","server","bin-dev"),he=(0,C.$kc)(Z,"remote-cli");let ae=t(B,"PATH");return ae?ae=he+C.$uc+ae:ae=he,a(B,"PATH",ae),v.args["without-browser-env-var"]||(B.BROWSER=(0,C.$kc)(Z,"helpers",g.$c?"browser.cmd":"browser.sh")),o(B),B}class f{constructor(s,i){this.socket=s,this.initialDataChunk=i}socketDrain(){return this.socket.drain()}toIExtHostSocketMessage(){let s,i,v;return this.socket instanceof $.$0h?(s=!0,i=!1,v=k.$ue.alloc(0)):(s=!1,i=this.socket.permessageDeflate,v=this.socket.recordedInflateBytes),{type:"VSCODE_EXTHOST_IPC_SOCKET",initialDataChunk:this.initialDataChunk.buffer.toString("base64"),skipWebSocketFrames:s,permessageDeflate:i,inflateBytes:v.buffer.toString("base64")}}}let l=class{constructor(s,i,v,S,O,N,j,I){this.i=s,this.j=O,this.l=N,this.m=j,this.n=I,this.b=new b.$7d,this.onClose=this.b.event,this.c=!g.$c||!this.j.args["socket-path"],this.d=!1,this.f=i,this.g=null,this.h=new f(v,S),this.p("New connection established.")}get o(){return`[${this.f}][${this.i.substr(0,8)}][ExtensionHostConnection] `}p(s){this.l.info(`${this.o}${s}`)}q(s){this.l.error(`${this.o}${s}`)}async r(s,i){const v=new m.$Tc;v.add(i.socket),v.add((0,m.$Sc)(()=>{s.destroy()}));const S=()=>{v.dispose()};v.add(i.socket.onEnd(S)),v.add(i.socket.onClose(S)),v.add(b.Event.fromNodeEventEmitter(s,"end")(S)),v.add(b.Event.fromNodeEventEmitter(s,"close")(S)),v.add(b.Event.fromNodeEventEmitter(s,"error")(S)),v.add(i.socket.onData(O=>s.write(O.buffer))),v.add(b.Event.fromNodeEventEmitter(s,"data")(O=>{i.socket.write(k.$ue.wrap(O))})),i.initialDataChunk.byteLength>0&&s.write(i.initialDataChunk.buffer)}async s(s,i){await i.socketDrain();const v=i.toIExtHostSocketMessage();let S;i.socket instanceof $.$0h?S=i.socket.socket:S=i.socket.socket.socket,s.send(v,S)}shortenReconnectionGraceTimeIfNecessary(){if(!this.g)return;const s={type:"VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"};this.g.send(s)}acceptReconnection(s,i,v){this.f=s,this.p("The client has reconnected.");const S=new f(i,v);if(!this.g){this.h=S;return}this.s(this.g,S)}t(){this.d||(this.d=!0,this.h&&(this.h.socket.end(),this.h=null),this.g&&(this.g.kill(),this.g=null),this.b.fire(void 0))}async start(s){try{let i=process.execArgv?process.execArgv.filter(he=>!/^--inspect(-brk)?=/.test(he)):[];s.port&&!process.pkg&&(i=[`--inspect${s.break?"-brk":""}=${s.port}`]);const v=await h(s.env,!0,s.language,this.j,this.l,this.n);(0,d.$am)(v);let S;if(this.c)(0,u.$an)(new u.$$m,v),S=null;else{const{namedPipeServer:he,pipeName:ae}=await this.u();(0,u.$an)(new u.$0m(ae),v),S=he}const O={env:v,execArgv:i,silent:!0};O.execArgv.unshift("--dns-result-order=ipv4first");const N=["--type=extensionHost","--transformURIs"],j=this.j.args["use-host-proxy"];N.push(`--useHostProxy=${j?"true":"false"}`),this.g=n.fork(D.$Cg.asFileUri("bootstrap-fork").fsPath,N,O);const I=this.g.pid;this.p(`<${I}> Launched Extension Host Process.`),this.g.stdout.setEncoding("utf8"),this.g.stderr.setEncoding("utf8");const B=b.Event.fromNodeEventEmitter(this.g.stdout,"data"),Z=b.Event.fromNodeEventEmitter(this.g.stderr,"data");if(B(he=>this.p(`<${I}> ${he}`)),Z(he=>this.p(`<${I}><stderr> ${he}`)),this.g.on("error",he=>{this.q(`<${I}> Extension Host Process had an error`),this.l.error(he),this.t()}),this.g.on("exit",(he,ae)=>{this.m.setExitInfo(this.i,{code:he,signal:ae}),this.p(`<${I}> Extension Host Process exited with code: ${he}, signal: ${ae}.`),this.t()}),S)S.on("connection",he=>{S.close(),this.r(he,this.h)});else{const he=ae=>{ae.type==="VSCODE_EXTHOST_IPC_READY"&&(this.g.removeListener("message",he),this.s(this.g,this.h),this.h=null)};this.g.on("message",he)}}catch(i){console.error("ExtensionHostConnection errored"),i&&console.error(i)}}u(){return new Promise((s,i)=>{const v=(0,$.$ai)(),S=A.createServer();S.on("error",i),S.listen(v,()=>{S?.removeListener("error",i),s({pipeName:v,namedPipeServer:S})})})}};e.$dn=l,e.$dn=l=Fe([Ne(4,w.$Zm),Ne(5,y.$Oj),Ne(6,c.$8m),Ne(7,p.$Oi)],l);function t(r,s){const i=Object.keys(r).filter(S=>S.toLowerCase()===s.toLowerCase()),v=i.length>0?i[0]:s;return r[v]}function a(r,s,i){const v=Object.keys(r).filter(O=>O.toLowerCase()===s.toLowerCase()),S=v.length>0?v[0]:s;r[S]=i}function o(r){for(const s of Object.keys(r))r[s]===null&&delete r[s]}}),define(Ee[299],ke([1,0,83,13,68,119,25,48,142,39,29,31,130,128,88,113,58,2,114,69,12,16,32,50,122,84,123,10,3,7,30,242,82,34,127,67,4,59,133,33,49,70,131,129,116,117,207,300]),function(ce,e,n,A,P,D,C,k,b,$,E,y,w,g,d,c,m,u,p,h,f,l,t,a,o,r,s,i,v,S,O,N,j,I,B,Z,he,ae,ee,_,z,T,J,Y,W,re,ue,ie){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.run=U;class $e extends u.$Uc{constructor(q,X){super(),this.a=q,this.b=X,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const q=await this.f();await q.invokeFunction(async X=>{const le=X.get(C.$Oi),Q=X.get(A.$Oj);he.$c&&(le.getValue("security.restrictUNCAccess")===!1?(0,ie.disableUNCAccessRestrictions)():(0,ie.addUNCHostToAllowlist)(le.getValue("security.allowedUNCHosts")));try{await this.g(q.createInstance(o.$1p,new A.$Wj(Q.getLevel(),!1)))}catch(x){throw Q.error(x),console.error((0,i.$0)(x)),x}})}async f(){const q=new n.$gi,X={_serviceBrand:void 0,...m.default};q.set(t.$8j,X);const le=new a.$1m(this.a,X);q.set(a.$Zm,le);const Q=new re.$4P((0,A.$3j)(le),le.logsHome);q.set(A.$Pj,Q);const x=new W.$bQ(this.B(Q.createLogger("remoteCLI",{name:(0,ue.localize)(0,null)})));q.set(A.$Oj,x),x.trace(`Remote configuration data at ${this.b}`),x.trace("process arguments:",this.a);const V=this.B(new p.$vq(x));q.set(l.$Ok,V),V.registerProvider(f.Schemas.file,this.B(new h.$Wq(x)));const L=new B.$ks(V);q.set(I.$ml,L);const H=this.B(new J.$_P(L,le,V,x));q.set(_.$ol,H);const K=this.B(new D.$to(H.defaultProfile.settingsResource,V,new T.$6n,x));return q.set(C.$Oi,K),await Promise.all([K.initialize(),H.init()]),q.set(k.$Ap,new P.$fi(b.$Ir)),q.set(j.$xo,new P.$fi(N.$uQ)),q.set(E.$Nl,$.$7o),q.set(y.$So,new P.$fi(w.$Xp)),q.set(z.$cq,new P.$fi(Y.$aQ)),q.set(ae.$gq,new P.$fi(ee.$YP)),q.set(d.$Yp,new P.$fi(d.$Zp)),q.set(g.$qq,new P.$fi(g.$rq)),q.set(r.$Cr,new P.$fi(s.$Er)),new c.$Zq(q)}async g(q){if(this.a["list-extensions"])return q.listExtensions(!!this.a["show-versions"],this.a.category);if(this.a["install-extension"]||this.a["install-builtin-extension"]){const X={isMachineScoped:!!this.a["do-not-sync"],installPreReleaseVersion:!!this.a["pre-release"]};return q.installExtensions(this.h(this.a["install-extension"]||[]),this.h(this.a["install-builtin-extension"]||[]),X,!!this.a.force)}else{if(this.a["uninstall-extension"])return q.uninstallExtensions(this.h(this.a["uninstall-extension"]),!!this.a.force);if(this.a["update-extensions"])return q.updateExtensions();if(this.a["locate-extension"])return q.locateExtension(this.a["locate-extension"])}}h(q){return q.map(X=>/\.vsix$/i.test(X)?v.URI.file((0,S.$jc)(X)?X:(0,S.$kc)((0,O.cwd)(),X)):X)}}function ne(R){setTimeout(()=>process.exit(R),0)}async function U(R,q,X){if(R.help){const Q=m.default.serverApplicationName+(he.$c?".cmd":"");console.log((0,Z.$im)(m.default.nameLong,Q,m.default.version,X,{noInputFiles:!0,noPipe:!0}));return}if(R.version){console.log((0,Z.$jm)(m.default.version,m.default.commit));return}const le=new $e(R,q);try{await le.run(),ne(0)}catch{ne(1)}finally{le.dispose()}}}),define(Ee[301],ke([1,0,73,274,27,296,3,13,92]),function(ce,e,n,A,P,D,C,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eP=e.$dP=void 0;class ${constructor(w,g,d){this.b=w,this.c=g,this.f=d,this.a=A.createServer((c,m)=>this.h(c,m)),this.g().catch(c=>(g.error(c),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",w=>this.c.error(w))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(w,g){const d=(m,u)=>{g.writeHead(m,{"content-type":"application/json"}),g.end(JSON.stringify(u||null),p=>p&&this.c.error(p))},c=[];w.setEncoding("utf8"),w.on("data",m=>c.push(m)),w.on("end",async()=>{try{const m=JSON.parse(c.join(""));let u;switch(m.type){case"open":u=await this.i(m);break;case"openExternal":u=await this.j(m);break;case"status":u=await this.l(m);break;case"extensionManagement":u=await this.k(m);break;default:d(404,`Unknown message type: ${m.type}`);break}d(200,u)}catch(m){const u=m instanceof Error?m.message:JSON.stringify(m);d(500,u),this.c.error("Error while processing pipe request",m)}})}async i(w){const{fileURIs:g,folderURIs:d,forceNewWindow:c,diffMode:m,mergeMode:u,addMode:p,forceReuseWindow:h,gotoLineMode:f,waitMarkerFilePath:l,remoteAuthority:t}=w,a=[];if(Array.isArray(d))for(const i of d)try{a.push({folderUri:C.URI.parse(i)})}catch{}if(Array.isArray(g))for(const i of g)try{(0,b.$Ni)(i)?a.push({workspaceUri:C.URI.parse(i)}):a.push({fileUri:C.URI.parse(i)})}catch{}const o=l?C.URI.file(l):void 0,s={forceNewWindow:c,diffMode:m,mergeMode:u,addMode:p,gotoLineMode:f,forceReuseWindow:h,preferNewWindow:!h&&!o&&!p,waitMarkerFileURI:o,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",a,s)}async j(w){for(const g of w.uris){const d=C.URI.parse(g),c=d.scheme==="file"?d:g;await this.b.executeCommand("_remoteCLI.openExternal",c)}}async k(w){const g=c=>c?.map(m=>/\.vsix$/i.test(m)?C.URI.parse(m):m),d={list:w.list,install:g(w.install),uninstall:g(w.uninstall),force:w.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",d)}async l(w){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&P.existsSync(this.f)&&P.unlinkSync(this.f)}}e.$dP=$;let E=class extends ${constructor(w,g){super(w,g,(0,n.$ai)())}};e.$eP=E,e.$eP=E=Fe([Ne(0,D.$$O),Ne(1,k.$Oj)],E)}),define(Ee[302],ke([1,0,28,6,21,2,7,4,3,73,71,301,125,90,282,284,143,15,126]),function(ce,e,n,A,P,D,C,k,b,$,E,y,w,g,d,c,m,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RP=void 0;class h extends c.$QP{constructor(t,a,o,r,s){super({getFolderUri:i=>{const v=a.filter(S=>S.name===i);if(v&&v.length>0)return v[0].uri},getWorkspaceFolderCount:()=>a.length,getConfigurationValue:(i,v)=>r[`config:${v}`],getExecPath:()=>t.VSCODE_EXEC_PATH,getAppRoot:()=>t.VSCODE_CWD,getFilePath:()=>{if(o)return C.$ic(o.fsPath)},getSelectedText:()=>r.selectedText,getLineNumber:()=>r.lineNumber,getExtension:async i=>{const S=(await s.getInstalled()).find(O=>O.identifier.id===i);return S&&{extensionLocation:S.location}}},void 0,Promise.resolve(n.homedir()),Promise.resolve(t))}}class f extends D.$Uc{constructor(t,a,o,r,s,i){super(),this.g=t,this.h=a,this.j=o,this.m=r,this.n=s,this.r=i,this.a=0,this.b=new Map,this.c=this.B(new A.$7d),this.onExecuteCommand=this.c.event}async call(t,a,o){switch(a){case"$restartPtyHost":return this.j.restartPtyHost.apply(this.j,o);case"$createProcess":{const r=(0,E.$ls)(t.remoteAuthority);return this.s(r,o)}case"$attachToProcess":return this.j.attachToProcess.apply(this.j,o);case"$detachFromProcess":return this.j.detachFromProcess.apply(this.j,o);case"$listProcesses":return this.j.listProcesses.apply(this.j,o);case"$getLatency":return this.j.getLatency.apply(this.j,o);case"$getPerformanceMarks":return this.j.getPerformanceMarks.apply(this.j,o);case"$orphanQuestionReply":return this.j.orphanQuestionReply.apply(this.j,o);case"$acceptPtyHostResolvedVariables":return this.j.acceptPtyHostResolvedVariables.apply(this.j,o);case"$start":return this.j.start.apply(this.j,o);case"$input":return this.j.input.apply(this.j,o);case"$acknowledgeDataEvent":return this.j.acknowledgeDataEvent.apply(this.j,o);case"$shutdown":return this.j.shutdown.apply(this.j,o);case"$resize":return this.j.resize.apply(this.j,o);case"$clearBuffer":return this.j.clearBuffer.apply(this.j,o);case"$getInitialCwd":return this.j.getInitialCwd.apply(this.j,o);case"$getCwd":return this.j.getCwd.apply(this.j,o);case"$processBinary":return this.j.processBinary.apply(this.j,o);case"$sendCommandResult":return this.u(o[0],o[1],o[2]);case"$installAutoReply":return this.j.installAutoReply.apply(this.j,o);case"$uninstallAllAutoReplies":return this.j.uninstallAllAutoReplies.apply(this.j,o);case"$getDefaultSystemShell":return this.w.apply(this,o);case"$getProfiles":return this.y.apply(this,o);case"$getEnvironment":return this.z();case"$getWslPath":return this.C(o[0],o[1]);case"$getTerminalLayoutInfo":return this.j.getTerminalLayoutInfo(o);case"$setTerminalLayoutInfo":return this.j.setTerminalLayoutInfo(o);case"$serializeTerminalState":return this.j.serializeTerminalState.apply(this.j,o);case"$reviveTerminalProcesses":return this.j.reviveTerminalProcesses.apply(this.j,o);case"$getRevivedPtyNewId":return this.j.getRevivedPtyNewId.apply(this.j,o);case"$setUnicodeVersion":return this.j.setUnicodeVersion.apply(this.j,o);case"$reduceConnectionGraceTime":return this.D();case"$updateIcon":return this.j.updateIcon.apply(this.j,o);case"$updateTitle":return this.j.updateTitle.apply(this.j,o);case"$updateProperty":return this.j.updateProperty.apply(this.j,o);case"$refreshProperty":return this.j.refreshProperty.apply(this.j,o);case"$requestDetachInstance":return this.j.requestDetachInstance(o[0],o[1]);case"$acceptDetachedInstance":return this.j.acceptDetachInstanceReply(o[0],o[1]);case"$freePortKillProcess":return this.j.freePortKillProcess.apply(this.j,o);case"$acceptDetachInstanceReply":return this.j.acceptDetachInstanceReply.apply(this.j,o)}throw new Error(`IPC Command ${a} not found`)}listen(t,a,o){switch(a){case"$onPtyHostExitEvent":return this.j.onPtyHostExit||A.Event.None;case"$onPtyHostStartEvent":return this.j.onPtyHostStart||A.Event.None;case"$onPtyHostUnresponsiveEvent":return this.j.onPtyHostUnresponsive||A.Event.None;case"$onPtyHostResponsiveEvent":return this.j.onPtyHostResponsive||A.Event.None;case"$onPtyHostRequestResolveVariablesEvent":return this.j.onPtyHostRequestResolveVariables||A.Event.None;case"$onProcessDataEvent":return this.j.onProcessData;case"$onProcessReadyEvent":return this.j.onProcessReady;case"$onProcessExitEvent":return this.j.onProcessExit;case"$onProcessReplayEvent":return this.j.onProcessReplay;case"$onProcessOrphanQuestion":return this.j.onProcessOrphanQuestion;case"$onExecuteCommand":return this.onExecuteCommand;case"$onDidRequestDetach":return this.j.onDidRequestDetach||A.Event.None;case"$onDidChangeProperty":return this.j.onDidChangeProperty}throw new Error(`IPC Command ${a} not found`)}async s(t,a){const o={name:a.shellLaunchConfig.name,executable:a.shellLaunchConfig.executable,args:a.shellLaunchConfig.args,cwd:typeof a.shellLaunchConfig.cwd=="string"||typeof a.shellLaunchConfig.cwd>"u"?a.shellLaunchConfig.cwd:b.URI.revive(t.transformIncoming(a.shellLaunchConfig.cwd)),env:a.shellLaunchConfig.env,useShellEnvironment:a.shellLaunchConfig.useShellEnvironment,reconnectionProperties:a.shellLaunchConfig.reconnectionProperties,type:a.shellLaunchConfig.type,isFeatureTerminal:a.shellLaunchConfig.isFeatureTerminal},r=await(0,m.$cn)(a.resolverEnv,!!a.shellLaunchConfig.useShellEnvironment,k.$q,this.g,this.h,this.r);this.h.trace("baseEnv",r);const s=z=>({uri:b.URI.revive(t.transformIncoming(z.uri)),name:z.name,index:z.index,toResource:()=>{throw new Error("Not implemented")}}),i=a.workspaceFolders.map(s),v=a.activeWorkspaceFolder?s(a.activeWorkspaceFolder):void 0,S=a.activeFileResource?b.URI.revive(t.transformIncoming(a.activeFileResource)):void 0,O=new h(r,i,S,a.resolvedVariables,this.n),N=d.$MP(v,process.env,O),j=await d.$LP(o,n.homedir(),N,v?.uri,a.configuration["terminal.integrated.cwd"],this.h);o.cwd=j;const I=k.$c?"terminal.integrated.env.windows":k.$d?"terminal.integrated.env.osx":"terminal.integrated.env.linux",B=a.configuration[I],Z=await d.$NP(o,B,N,this.m.version,a.configuration["terminal.integrated.detectLocale"],r);if((0,p.$FP)(o)){const z=[];for(const[W,re,ue]of a.envVariableCollections)z.push([W,{map:(0,g.$0r)(re),descriptionMap:(0,g.$$r)(ue)}]);const T=new Map(z),J=new w.$bs(T),Y=v?v??void 0:void 0;await J.applyToProcessEnvironment(Z,{workspaceFolder:Y},N)}this.h.debug("Terminal process launching on remote agent",{shellLaunchConfig:o,initialCwd:j,cols:a.cols,rows:a.rows,env:Z});const he=(0,$.$ai)();Z.VSCODE_IPC_HOOK_CLI=he;const ae=await this.j.createProcess(o,j,a.cols,a.rows,a.unicodeVersion,Z,r,a.options,a.shouldPersistTerminal,a.workspaceId,a.workspaceName),ee={executeCommand:(z,...T)=>this.t(ae,z,T,t)},_=new y.$dP(ee,this.h,he);return this.j.onProcessExit(z=>z.id===ae&&_.dispose()),{persistentTerminalId:ae,resolvedShellLaunchConfig:o}}t(t,a,o,r){const{resolve:s,reject:i,promise:v}=(0,u.$bh)(),S=++this.a;this.b.set(S,{resolve:s,reject:i,uriTransformer:r});const O=(0,P.$Rn)(o,N=>{if(N&&N.$mid===1)return r.transformOutgoing(N);if(N&&N instanceof b.URI)return r.transformOutgoingURI(N)});return this.c.fire({reqId:S,persistentProcessId:t,commandId:a,commandArgs:O}),v}u(t,a,o){const r=this.b.get(t);if(!r)return;this.b.delete(t);const s=(0,P.$Rn)(o,i=>{if(i&&i.$mid===1)return r.uriTransformer.transformIncoming(i)});a?r.reject(s):r.resolve(s)}w(t){return this.j.getDefaultSystemShell(t)}async y(t,a,o,r){return this.j.getProfiles(t,a,o,r)||[]}z(){return{...process.env}}C(t,a){return this.j.getWslPath(t,a)}D(){return this.j.reduceConnectionGraceTime()}}e.$RP=f}),define(Ee[303],ke([1,0,28,6,2,12,7,103,23,44,25,119,215,82,216,26,130,31,88,122,225,128,16,114,69,68,113,83,84,123,13,58,32,48,243,142,121,29,39,258,91,265,34,127,278,279,248,255,302,71,50,286,297,132,59,133,49,33,273,70,256,117,131,129,116,115,209,292,239,269,262]),function(ce,e,n,A,P,D,C,k,b,$,E,y,w,g,d,c,m,u,p,h,f,l,t,a,o,r,s,i,v,S,O,N,j,I,B,Z,he,ae,ee,_,z,T,J,Y,W,re,ue,ie,$e,ne,U,R,q,X,le,Q,x,V,L,H,K,te,de,se,ge,we,Ie,je,pe,Pe,Ce){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lQ=void 0,e.$kQ=Me;const Le="monacoworkbench";async function Me(Qe,me,Se,Ae){const Re=new i.$gi,Te=new xe,He={_serviceBrand:void 0,...N.default};Re.set(j.$8j,He);const We=new U.$1m(me,He);Re.set(c.$pi,We),Re.set(c.$qi,We);const rt=new te.$4P((0,O.$3j)(We),We.logsHome);Re.set(O.$Pj,rt),Te.registerChannel("logger",new we.$Wr(rt,it=>qe(it.remoteAuthority)));const st=rt.createLogger("remoteagent",{name:(0,Ie.localize)(0,null)}),Je=new ge.$bQ(st,[new _e((0,O.$3j)(We))]);Re.set(O.$Oj,Je),setTimeout(()=>Ye(We.logsHome.with({scheme:D.Schemas.file}).fsPath).then(null,it=>Je.error(it)),1e4),Je.onDidChangeLogLevel(it=>(0,O.log)(Je,it,`Log level changed to ${(0,O.$4j)(Je.getLevel())}`)),Je.trace(`Remote configuration data at ${Se}`),Je.trace("process arguments:",We.args),Array.isArray(He.serverGreeting)&&Je.info(`

${He.serverGreeting.join(`
`)}

`),Te.registerChannel(w.$vo.ChannelName,new w.$vo);const ct=new $.$3h(it=>it.clientId==="renderer"),at=Ae.add(new a.$vq(Je));Re.set(t.$Ok,at),at.registerProvider(D.Schemas.file,Ae.add(new o.$Wq(Je)));const ft=new Y.$ks(at);Re.set(J.$ml,ft);const ut=new y.$to(We.machineSettingsResource,at,new H.$6n,Je);Re.set(E.$Oi,ut);const dt=new de.$_P(ft,We,at,Je);Re.set(V.$ol,dt),Te.registerChannel("userDataProfiles",new Pe.$hQ(dt,it=>qe(it.remoteAuthority)));const[,,At,Ot]=await Promise.all([ut.initialize(),dt.init(),(0,k.$sn)(Je.error.bind(Je)),(0,k.$tn)(Je.error.bind(Je))]),Bt=new X.$9m;Re.set(X.$8m,Bt);const zt=new Z.$Ir(ut,We,Je,rt);Re.set(I.$Ap,zt);let Et=ee.$$o;const qt=(0,ee.$ep)(He,ut);if((0,ee.$_o)(He,We)){const it=process.env.CS_TELEMETRY_URL||"https://v1.telemetry.coder.com/track";it?Et=new K.$2P(zt,!1,Le,null,()=>new L.$ZP(it)):!(0,ee.$ap)(He,We)&&He.aiConfig?.ariaKey&&(Et=new K.$2P(zt,qt,Le,null,He.aiConfig.ariaKey),Ae.add((0,P.$Sc)(()=>Et?.flush())));const bt={appenders:[Et],commonProperties:(0,he.$3o)((0,n.release)(),(0,n.hostname)(),process.arch,He.commit,He.version+"-remote",At,Ot,qt,"remoteAgent"),piiPaths:(0,ee.$fp)(We)},gt=We.args["telemetry-level"];let $t=3;gt==="all"?$t=3:gt==="error"?$t=2:gt==="crash"?$t=1:gt!==void 0&&($t=0),Re.set(ie.$ys,new r.$fi(ie.$ws,[bt,$t]))}else Re.set(ie.$ys,ie.$xs);Re.set(u.$So,new r.$fi(m.$Xp));const xt=Te.getChannel("download",ct);Re.set(g.$xo,new d.$zo(xt,()=>qe("renderer"))),Re.set(x.$cq,new r.$fi(se.$aQ)),Re.set(le.$gq,new r.$fi(Q.$YP)),Re.set(p.$Yp,new r.$fi(p.$Zp)),Re.set(l.$qq,new r.$fi(l.$rq));const mt=new s.$Zq(Re);Re.set(v.$Cr,mt.createInstance(S.$Er));const kt=mt.createInstance(Ce.$jQ,{graceTime:108e5,shortGraceTime:3e5,scrollback:ut.getValue("terminal.integrated.persistentSessionScrollback")??100}),jt=mt.createInstance(T.$gs,kt);return Re.set(z.$Rr,jt),mt.invokeFunction(it=>{const bt=it.get(l.$qq),gt=it.get(le.$gq),$t=it.get(u.$So),Ut=it.get(v.$Cr),Rt=new W.$ss(Qe,We,dt,Bt);Te.registerChannel("remoteextensionsenvironment",Rt);const Jt=new ue.$zs(it.get(ie.$ys),Et);Te.registerChannel("telemetry",Jt),Te.registerChannel(R.$SP,new $e.$RP(We,Je,jt,He,bt,ut));const Nt=new je.$fQ(mt.createInstance(h.$1p,Je),We,dt,gt,Je,$t,Ut);Te.registerChannel(pe.$eQ,new je.$gQ(Nt,Ct=>qe(Ct.remoteAuthority)));const _t=new re.$vs(Je,We);Te.registerChannel(q.$WP,_t),Te.registerChannel("request",new B.$Fr(it.get(I.$Ap)));const en=new f.$2p(bt,Ct=>qe(Ct.remoteAuthority));Te.registerChannel("extensions",en);const Ht=$.ProxyChannel.fromService(it.get(v.$Cr),Ae);return Te.registerChannel("languagePacks",Ht),Nt.whenExtensionsReady().then(()=>bt.cleanUp()),Ae.add(new _.default(it.get(ae.$Nl))),{telemetryService:it.get(ae.$Nl)}}),{socketServer:Te,instantiationService:mt}}const Ve=Object.create(null);function qe(Qe){return Ve[Qe]||(Ve[Qe]=(0,ne.$ls)(Qe)),Ve[Qe]}class xe extends $.$Yh{constructor(){const me=new A.$7d;super(me.event),this.b=me}acceptConnection(me,Se){this.b.fire({protocol:me,onDidClientDisconnect:Se})}}e.$lQ=xe;class _e extends O.$Tj{constructor(me=O.$Rj){super(),this.setLevel(me),this.g=!!process.stdout.isTTY}trace(me,...Se){this.f(O.LogLevel.Trace)&&(this.g?console.log(`\x1B[90m[${Ke()}]\x1B[0m`,me,...Se):console.log(`[${Ke()}]`,me,...Se))}debug(me,...Se){this.f(O.LogLevel.Debug)&&(this.g?console.log(`\x1B[90m[${Ke()}]\x1B[0m`,me,...Se):console.log(`[${Ke()}]`,me,...Se))}info(me,...Se){this.f(O.LogLevel.Info)&&(this.g?console.log(`\x1B[90m[${Ke()}]\x1B[0m`,me,...Se):console.log(`[${Ke()}]`,me,...Se))}warn(me,...Se){this.f(O.LogLevel.Warning)&&(this.g?console.warn(`\x1B[93m[${Ke()}]\x1B[0m`,me,...Se):console.warn(`[${Ke()}]`,me,...Se))}error(me,...Se){this.f(O.LogLevel.Error)&&(this.g?console.error(`\x1B[91m[${Ke()}]\x1B[0m`,me,...Se):console.error(`[${Ke()}]`,me,...Se))}flush(){}}function Ke(){const Qe=new Date;return`${nt(Qe.getHours())}:${nt(Qe.getMinutes())}:${nt(Qe.getSeconds())}`}function nt(Qe){return Qe<10?`0${Qe}`:String(Qe)}async function Ye(Qe){const me=C.$oc(Qe),Se=C.$nc(Qe),Te=(await b.Promises.readdir(Se)).filter(We=>/^\d{8}T\d{6}$/.test(We)).sort().filter(We=>We!==me),He=Te.slice(0,Math.max(0,Te.length-9));await Promise.all(He.map(We=>b.Promises.rm(C.$kc(Se,We))))}}),define(Ee[304],ke([1,0,89,27,78,305,86,96,14,10,37,2,12,7,43,4,17,3,22,164,166,300,108,73,25,5,13,32,29,143,270,271,50,303,275]),function(ce,e,n,A,P,D,C,k,b,$,E,y,w,g,d,c,m,u,p,h,f,l,t,a,o,r,s,i,v,S,O,N,j,I,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tQ=ae;const Z=5*60*1e3;let he=class extends y.$Uc{constructor(z,T,J,Y,W,re,ue,ie,$e){super(),this.n=z,this.r=T,this.s=J,this.t=re,this.u=ue,this.w=ie,this.y=$e,this.h=ee.create(this.u),this.j=(0,w.$wg)(ue,W),this.a=Object.create(null),this.b=Object.create(null),this.f=new Set,this.g=Y?this.y.createInstance(B.$oQ,this.r,W??"/",this.j):null,this.w.info("Extension host agent started."),this.L(!0)}async handleRequest(z,T){if(z.method!=="GET")return(0,B.$mQ)(z,T,405,`Unsupported method ${z.method}`);if(!z.url)return(0,B.$mQ)(z,T,400,"Bad request.");const J=C.parse(z.url,!0);let Y=J.pathname;if(!Y)return(0,B.$mQ)(z,T,400,"Bad request.");if(Y.startsWith(this.j)&&Y.charCodeAt(this.j.length)===47&&(Y=Y.substring(this.j.length)),Y==="/version")return T.writeHead(200,{"Content-Type":"text/plain"}),void T.end(this.u.commit||"");if(Y==="/delay-shutdown")return this.N(),T.writeHead(200),void T.end("OK");if(!(0,N.$kn)(this.r,z,J))return(0,B.$mQ)(z,T,403,"Forbidden.");if(Y==="/vscode-remote-resource"){const W=J.query.path;if(typeof W!="string")return(0,B.$mQ)(z,T,400,"Bad request.");let re;try{re=u.URI.from({scheme:w.Schemas.file,path:W}).fsPath}catch{return(0,B.$mQ)(z,T,400,"Bad request.")}const ue=Object.create(null);this.t.isBuilt&&((0,E.$ig)(re,this.t.builtinExtensionsPath,!c.$e)||(0,E.$ig)(re,this.t.extensionsPath,!c.$e))&&(ue["Cache-Control"]="public, max-age=31536000"),ue.Vary="Origin";const ie=z.headers.origin;return ie&&this.h.matches(ie)&&(ue["Access-Control-Allow-Origin"]=ie),(0,B.$nQ)(re,1,this.w,z,T,ue)}if(this.g){this.g.handle(z,T,J);return}return T.writeHead(404,{"Content-Type":"text/plain"}),void T.end("Not found")}handleUpgrade(z,T){let J=(0,p.$Eg)(),Y=!1,W=!1;if(z.url){const U=C.parse(z.url,!0).query;typeof U.reconnectionToken=="string"&&(J=U.reconnectionToken),U.reconnection==="true"&&(Y=!0),U.skipWebSocketFrames==="true"&&(W=!0)}if(z.headers.upgrade===void 0||z.headers.upgrade.toLowerCase()!=="websocket"){T.end("HTTP/1.1 400 Bad Request");return}const re=z.headers["sec-websocket-key"],ue=n.createHash("sha1");ue.update(re+"258EAFA5-E914-47DA-95CA-C5AB0DC85B11");const $e=["HTTP/1.1 101 Switching Protocols","Upgrade: websocket","Connection: Upgrade",`Sec-WebSocket-Accept: ${ue.digest("base64")}`];let ne=!1;if(!W&&!this.t.args["disable-websocket-compression"]&&z.headers["sec-websocket-extensions"]){const U=Array.isArray(z.headers["sec-websocket-extensions"])?z.headers["sec-websocket-extensions"]:[z.headers["sec-websocket-extensions"]];for(const R of U)if(!/\b((server_max_window_bits)|(server_no_context_takeover)|(client_no_context_takeover))\b/.test(R)){if(/\b(permessage-deflate)\b/.test(R)){ne=!0,$e.push("Sec-WebSocket-Extensions: permessage-deflate");break}if(/\b(x-webkit-deflate-frame)\b/.test(R)){ne=!0,$e.push("Sec-WebSocket-Extensions: x-webkit-deflate-frame");break}}}T.write($e.join(`\r
`)+`\r
\r
`),T.setTimeout(0),T.setNoDelay(!0),W?this.D(new a.$0h(T,`server-connection-${J}`),Y,J):this.D(new a.$$h(new a.$0h(T,`server-connection-${J}`),ne,null,!0),Y,J)}handleServerError(z){this.w.error("Error occurred in server"),this.w.error(z)}z(z){let T;return z instanceof a.$0h?T=z.socket:T=z.socket.socket,T.remoteAddress||"<unknown>"}async C(z,T,J){const Y=T.getSocket();this.w.error(`${z} ${J}.`);const W={type:"error",reason:J};T.sendControl(b.$ue.fromString(JSON.stringify(W))),T.dispose(),await Y.drain(),Y.dispose()}D(z,T,J){const Y=this.z(z),W=`[${Y}][${J.substr(0,8)}]`,re=new t.$9h({socket:z}),ue=this.s?new this.s.validator:null,ie=this.s?new this.s.signer:null;let $e;(function(q){q[q.WaitingForAuth=0]="WaitingForAuth",q[q.WaitingForConnectionType=1]="WaitingForConnectionType",q[q.Done=2]="Done",q[q.Error=3]="Error"})($e||($e={}));let ne=0;const U=q=>{ne=3,R.dispose(),this.C(W,re,q)},R=re.onControlMessage(q=>{if(ne===0){let X;try{X=JSON.parse(q.toString())}catch{return U("Malformed first message")}if(X.type!=="auth")return U("Invalid first message");if(this.r.type===2&&!this.r.validate(X.auth))return U("Unauthorized client refused: auth mismatch");let le=(0,p.$Eg)();if(ie)try{le=ie.sign(X.data)}catch{}let Q=(0,p.$Eg)();if(ue)try{Q=ue.createNewMessage(Q)}catch{}const x={type:"sign",data:Q,signedData:le};re.sendControl(b.$ue.fromString(JSON.stringify(x))),ne=1}else if(ne===1){let X;try{X=JSON.parse(q.toString())}catch{return U("Malformed second message")}if(X.type!=="connectionType")return U("Invalid second message");if(typeof X.signedData!="string")return U("Invalid second message field type");const le=X.commit,Q=this.u.commit;if(le&&Q&&le!==Q)return U("Client refused: version mismatch");let x=!1;if(!ue)x=!0;else if(this.r.validate(X.signedData))x=!0;else try{x=ue.validate(X.signedData)==="ok"}catch{}if(!x){if(this.t.isBuilt)return U("Unauthorized client refused");this.w.error(`${W} Unauthorized client handshake failed but we proceed because of dev mode.`)}for(const V in this.b)this.b[V].shortenReconnectionGraceTimeIfNecessary();for(const V in this.a)this.a[V].shortenReconnectionGraceTimeIfNecessary();ne=2,R.dispose(),this.F(Y,W,re,z,T,J,X)}})}async F(z,T,J,Y,W,re,ue){const ie=ue.desiredConnectionType===1?`${T}[ManagementConnection]`:ue.desiredConnectionType===2?`${T}[ExtensionHostConnection]`:T;if(ue.desiredConnectionType===1)if(W){if(!this.b[re])return this.f.has(re)?this.C(ie,J,"Unknown reconnection token (seen before)"):this.C(ie,J,"Unknown reconnection token (never seen)");J.sendControl(b.$ue.fromString(JSON.stringify({type:"ok"})));const $e=J.readEntireBuffer();J.dispose(),this.b[re].acceptReconnection(z,Y,$e)}else{if(this.b[re])return this.C(ie,J,"Duplicate reconnection token");J.sendControl(b.$ue.fromString(JSON.stringify({type:"ok"})));const $e=new O.$en(this.w,re,z,J);this.n.acceptConnection($e.protocol,$e.onClose),this.b[re]=$e,this.f.add(re),$e.onClose(()=>{delete this.b[re]})}else if(ue.desiredConnectionType===2){const $e=ue.args||{language:"en"},ne=await this.I($e);if(ne.port&&this.w.trace(`${ie} - startParams debug port ${ne.port}`),this.w.trace(`${ie} - startParams language: ${ne.language}`),this.w.trace(`${ie} - startParams env: ${JSON.stringify(ne.env)}`),W){if(!this.a[re])return this.f.has(re)?this.C(ie,J,"Unknown reconnection token (seen before)"):this.C(ie,J,"Unknown reconnection token (never seen)");J.sendPause(),J.sendControl(b.$ue.fromString(JSON.stringify(ne.port?{debugPort:ne.port}:{})));const U=J.readEntireBuffer();J.dispose(),this.a[re].acceptReconnection(z,Y,U)}else{if(this.a[re])return this.C(ie,J,"Duplicate reconnection token");J.sendPause(),J.sendControl(b.$ue.fromString(JSON.stringify(ne.port?{debugPort:ne.port}:{})));const U=J.readEntireBuffer();J.dispose();const R=this.y.createInstance(S.$dn,re,z,Y,U);this.a[re]=R,this.f.add(re),R.onClose(()=>{delete this.a[re],this.J()}),R.start(ne)}}else if(ue.desiredConnectionType===3){const $e=ue.args;this.G(J,$e)}else return this.C(ie,J,"Unknown initial data received")}async G(z,T){const J=z.getSocket().socket,Y=z.readEntireBuffer();z.dispose(),J.pause();const W=await this.H(T.host,T.port);Y.byteLength>0&&W.write(Y.buffer),W.on("end",()=>J.end()),W.on("close",()=>J.end()),W.on("error",()=>J.destroy()),J.on("end",()=>W.end()),J.on("close",()=>W.end()),J.on("error",()=>W.destroy()),W.pipe(J),J.pipe(W)}H(z,T){return new Promise((J,Y)=>{const W=P.createConnection({host:z,port:T,autoSelectFamily:!0},()=>{W.removeListener("error",Y),W.pause(),J(W)});W.once("error",Y)})}I(z){return typeof z.port=="number"?(0,f.$Gg)(z.port,10,5e3).then(T=>(z.port=T,z)):(z.debugId=void 0,z.port=void 0,z.break=void 0,Promise.resolve(z))}async J(){if(!this.t.args["enable-remote-auto-shutdown"])return;this.O(),!!Object.keys(this.a).length||(console.log("Last EH closed, waiting before shutting down"),this.w.info("Last EH closed, waiting before shutting down"),this.L())}L(z=!1){this.t.args["enable-remote-auto-shutdown"]&&(this.t.args["remote-auto-shutdown-without-delay"]&&!z?this.M():this.m=setTimeout(()=>{this.m=void 0,this.M()},Z))}M(){if(!!Object.keys(this.a).length){console.log("New EH opened, aborting shutdown"),this.w.info("New EH opened, aborting shutdown");return}else console.log("Last EH closed, shutting down"),this.w.info("Last EH closed, shutting down"),this.dispose(),process.exit(0)}N(){this.m&&(console.log("Got delay-shutdown request while in shutdown timeout, delaying"),this.w.info("Got delay-shutdown request while in shutdown timeout, delaying"),this.O(),this.L())}O(){this.m&&(console.log("Cancelling previous shutdown timeout"),this.w.info("Cancelling previous shutdown timeout"),clearTimeout(this.m),this.m=void 0)}};he=Fe([Ne(5,j.$Zm),Ne(6,i.$8j),Ne(7,s.$Oj),Ne(8,r.$hi)],he);async function ae(_,z,T){const J=await(0,N.$jn)(z);J instanceof N.$hn&&(console.warn(J.message),process.exit(1));function Y(V){(0,$.setUnexpectedErrorHandler)(L=>{(0,$.$Z)(L)&&L.stack&&/unexpectedErrorHandler/.test(L.stack)||V(L)})}const W=[];Y(V=>{W.push(V),console.error(V)});let re=!1;process.on("SIGPIPE",()=>{re||(re=!0,(0,$.$1)(new Error("Unexpected SIGPIPE")))});const ue=new y.$Tc,{socketServer:ie,instantiationService:$e}=await(0,I.$kQ)(J,z,T,ue);$e.invokeFunction(V=>{const L=V.get(s.$Oj);W.forEach(H=>L.error(H)),W.length=0,Y(H=>L.error(H))}),$e.invokeFunction(V=>{const L=V.get(o.$Oi);c.$c&&(L.getValue("security.restrictUNCAccess")===!1?(0,l.disableUNCAccessRestrictions)():(0,l.addUNCHostToAllowlist)(L.getValue("security.allowedUNCHosts")))}),$e.invokeFunction(V=>{const L=V.get(s.$Oj);if(c.$c&&process.env.HOMEDRIVE&&process.env.HOMEPATH){const H=(0,g.$kc)(process.env.HOMEDRIVE,"node_modules"),K=(0,g.$nc)((0,g.$kc)(process.env.HOMEDRIVE,process.env.HOMEPATH)),te=(0,g.$kc)(K,"node_modules");if(A.existsSync(H)||A.existsSync(te)){const de=`

*
* !!!! Server terminated due to presence of CVE-2020-1416 !!!!
*
* Please remove the following directories and re-try
* ${H}
* ${te}
*
* For more information on the vulnerability https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2020-1416
*

`;L.warn(de),console.warn(de),process.exit(0)}}});const ne=$e.invokeFunction(V=>{const L=V.get(s.$Oj);if(A.existsSync((0,g.$kc)(w.$Cg.asFileUri("").fsPath,"../node_modules/vsda")))try{return globalThis._VSCODE_NODE_MODULES.vsda}catch(K){L.error(K)}return null});let U=z["server-base-path"];U&&!U.startsWith("/")&&(U=`/${U}`);const R=A.existsSync(w.$Cg.asFileUri("vs/code/browser/workbench/workbench.html").fsPath);if(R&&_&&typeof _!="string"){const V=J.type!==0?`?${w.$ug}=${J.value}`:"";console.log(`Web UI available at http://localhost${_.port===80?"":`:${_.port}`}${U??""}${V}`)}const q=$e.createInstance(he,ie,J,ne,R,U);d.mark("code/server/ready");const X=D.performance.now(),le=global.vscodeServerStartTime,Q=global.vscodeServerListenTime,x=global.vscodeServerCodeLoadedTime;if($e.invokeFunction(async V=>{const L=V.get(v.$Nl);if(L.publicLog2("serverStart",{startTime:le,startedTime:Q,codeLoadedTime:x,readyTime:X}),c.$e){const H=V.get(s.$Oj),K=await(0,h.$Fg)(H.error.bind(H));K&&L.publicLog2("serverPlatformInfo",{platformId:K.id,platformVersionId:K.version_id,platformIdLike:K.id_like})}}),z["print-startup-performance"]){const V=k.$U.get();let L="";L+=`

### Load AMD-module
`,L+=k.$U.toMarkdownTable(["Module","Duration"],V.amdLoad),L+=`

### Load commonjs-module
`,L+=k.$U.toMarkdownTable(["Module","Duration"],V.nodeRequire),L+=`

### Invoke AMD-module factory
`,L+=k.$U.toMarkdownTable(["Module","Duration"],V.amdInvoke),L+=`

### Invoke commonjs-module
`,L+=k.$U.toMarkdownTable(["Module","Duration"],V.nodeEval),L+=`Start-up time: ${Q-le}
`,L+=`Code loading time: ${x-le}
`,L+=`Initialized time: ${X-le}
`,L+=`
`,console.log(L)}return q}class ee{static create(z){const T=z.webEndpointUrlTemplate,J=z.commit,Y=z.quality;if(!T||!J||!Y)return new ee(null);const W=(0,p.$Eg)(),ue=new URL(T.replace("{{uuid}}",W).replace("{{commit}}",J).replace("{{quality}}",Y)).origin,ie=(0,m.$Ze)(ue).replace(W,"[a-zA-Z0-9\\-]+");try{const $e=(0,m.$9e)(`^${ie}$`,!0,{matchCase:!1});return new ee($e)}catch{return new ee(null)}}constructor(z){this.a=z}matches(z){return this.a?this.a.test(z):!1}}}),define(Ee[313],ke([1,0,28,27,12,299,304,67,7,305,50,58,43]),function(ce,e,n,A,P,D,C,k,b,$,E,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spawnCli=m,e.createServer=u,w.mark("code/server/codeLoaded"),global.vscodeServerCodeLoadedTime=$.performance.now();const g={onMultipleValues:(p,h)=>{console.error(`Option '${p}' can only be defined once. Using value ${h}.`)},onEmptyValue:p=>{console.error(`Ignoring option '${p}': Value must not be empty.`)},onUnknownOption:p=>{console.error(`Ignoring option '${p}': not supported for server.`)},onDeprecatedOption:(p,h)=>{console.warn(`Option '${p}' is deprecated: ${h}`)}};function d(){return(0,k.$gm)(process.argv.slice(2),E.$Ym,g)}function c(p){const h=p["server-data-dir"]||p["user-data-dir"]||process.env.VSCODE_AGENT_FOLDER||(0,b.$kc)(n.homedir(),y.default.serverDataFolderName||".vscode-remote"),f=p["user-data-dir"]||(0,b.$kc)(h,"data"),l=(0,b.$kc)(f,"User"),t=(0,b.$kc)(l,"globalStorage"),a=(0,b.$kc)(l,"History"),o=(0,b.$kc)(f,"Machine");p["user-data-dir"]=f;const r=(0,b.$nc)(P.$Cg.asFileUri("").fsPath),s=p["builtin-extensions-dir"]||(0,b.$kc)(r,"extensions");return p["builtin-extensions-dir"]=s,p["extensions-dir"]=p["extensions-dir"]||(0,b.$kc)(h,"extensions"),[h,p["extensions-dir"],f,l,o,t,a].forEach(i=>{try{A.existsSync(i)||A.mkdirSync(i,{mode:448})}catch(v){console.error(v)}}),h}function m(p=d()){return(0,D.run)(p,c(p),E.$Ym)}function u(p,h=d()){return(0,C.$tQ)(p,h,c(h))}})}).call(this);

//# sourceMappingURL=server.main.js.map
