"use strict";/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ee=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/async","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/strings","vs/base/common/network","vs/workbench/api/common/extHostTypeConverters","vs/base/common/path","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/buffer","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/map","vs/workbench/api/common/extHostInitDataService","vs/editor/common/core/range","vs/base/common/uuid","vs/base/node/pfs","vs/platform/files/common/files","vs/workbench/api/common/extHostCommands","vs/base/common/extpath","vs/base/common/glob","vs/workbench/services/search/common/search","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/severity","vs/platform/contextkey/common/contextkey","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostConfiguration","vs/base/common/lazy","vs/base/common/errorMessage","vs/workbench/api/common/extHostExtensionService","vs/base/common/process","fs","child_process","vs/editor/common/core/position","vs/platform/configuration/common/configuration","vs/base/common/decorators","vs/base/common/hash","vs/base/common/themables","vs/base/common/marshalling","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","os","net","vs/platform/files/common/watcher","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/model","vs/editor/common/languages","vs/platform/instantiation/common/extensions","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/stream","vs/base/common/codiconsUtil","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/editor/common/model/textModelSearch","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","http","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostLanguageModels","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/comparers","vs/base/common/filters","vs/base/common/fuzzyScorer","vs/base/common/uint","vs/base/common/uriIpc","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/prefixTree","vs/base/common/cache","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/iconLabels","vs/base/common/console","vs/amdX","vs/base/common/dataTransfer","vs/base/node/ports","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languageSelector","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostLoggerService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","crypto","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],Ce=function(re){for(var e=[],o=0,R=re.length;o<R;o++)e[o]=Ee[re[o]];return e};define(Ee[163],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class o{static get(){const I=new Map,M=new Map,O=new Map,p=new Map;function $(C,y){C.has(y.detail)||C.set(y.detail,-y.timestamp)}function w(C,y){const a=C.get(y.detail);a&&(a>=0||C.set(y.detail,a+y.timestamp))}let A=[];typeof re=="function"&&typeof re.getStats=="function"&&(A=re.getStats().slice(0).sort((C,y)=>C.timestamp-y.timestamp));for(const C of A)switch(C.type){case 10:$(I,C);break;case 11:case 12:w(I,C);break;case 21:$(M,C);break;case 22:w(M,C);break;case 33:$(O,C);break;case 34:w(O,C);break;case 31:$(p,C);break;case 32:w(p,C);break}let P=0;O.forEach(C=>P+=C);function b(C){const y=[];return C.forEach((a,m)=>y.push([m,a])),y}return{amdLoad:b(I),amdInvoke:b(M),nodeRequire:b(O),nodeEval:b(p),nodeRequireTotal:P}}static toMarkdownTable(I,M){let O="";const p=[];return I.forEach(($,w)=>{p[w]=$.length}),M.forEach($=>{$.forEach((w,A)=>{typeof w>"u"&&(w=$[A]="-");const P=w.toString().length;p[A]=Math.max(P,p[A])})}),I.forEach(($,w)=>{O+=`| ${$+" ".repeat(p[w]-$.toString().length)} `}),O+=`|
`,I.forEach(($,w)=>{O+=`| ${"-".repeat(p[w])} `}),O+=`|
`,M.forEach($=>{$.forEach((w,A)=>{typeof w<"u"&&(O+=`| ${w+" ".repeat(p[A]-w.toString().length)} `)}),O+=`|
`}),O}}e.$U=o}),define(Ee[164],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mb=void 0,e.$fb=o,e.$gb=R,e.$hb=I,e.$ib=M,e.$jb=O,e.$kb=p,e.$lb=$,e.$nb=A,e.$ob=P,e.$pb=b,e.$qb=C,e.$rb=y;function o(a,m,l){const i=R(a,m);if(i!==-1)return a[i]}function R(a,m,l=a.length-1){for(let i=l;i>=0;i--){const n=a[i];if(m(n))return i}return-1}function I(a,m){const l=M(a,m);return l===-1?void 0:a[l]}function M(a,m,l=0,i=a.length){let n=l,r=i;for(;n<r;){const s=Math.floor((n+r)/2);m(a[s])?n=s+1:r=s}return n-1}function O(a,m){const l=p(a,m);return l===a.length?void 0:a[l]}function p(a,m,l=0,i=a.length){let n=l,r=i;for(;n<r;){const s=Math.floor((n+r)/2);m(a[s])?r=s:n=s+1}return n}function $(a,m,l=0,i=a.length){const n=p(a,m,l,i);return n===a.length?-1:n}class w{constructor(m){this.e=m,this.c=0}findLastMonotonous(m){if(w.assertInvariants){if(this.d){for(const i of this.e)if(this.d(i)&&!m(i))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=m}const l=M(this.e,m,this.c);return this.c=l+1,l===-1?void 0:this.e[l]}}e.$mb=w,w.assertInvariants=!1;function A(a,m){if(a.length===0)return;let l=a[0];for(let i=1;i<a.length;i++){const n=a[i];m(n,l)>0&&(l=n)}return l}function P(a,m){if(a.length===0)return;let l=a[0];for(let i=1;i<a.length;i++){const n=a[i];m(n,l)>=0&&(l=n)}return l}function b(a,m){return A(a,(l,i)=>-m(l,i))}function C(a,m){if(a.length===0)return-1;let l=0;for(let i=1;i<a.length;i++){const n=a[i];m(n,a[l])>0&&(l=i)}return l}function y(a,m){for(const l of a){const i=m(l);if(i!==void 0)return i}}}),define(Ee[73],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E=o,e.$F=R,e.$G=I,e.$H=M;function o(O,p){const $=Object.create(null);for(const w of O){const A=p(w);let P=$[A];P||(P=$[A]=[]),P.push(w)}return $}function R(O,p){const $=[],w=[];for(const A of O)p.has(A)||$.push(A);for(const A of p)O.has(A)||w.push(A);return{removed:$,added:w}}function I(O,p){const $=[],w=[];for(const[A,P]of O)p.has(A)||$.push(P);for(const[A,P]of p)O.has(A)||w.push(P);return{removed:$,added:w}}function M(O,p){const $=new Set;for(const w of p)O.has(w)&&$.add(w);return $}}),define(Ee[54],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mh=R,e.$Nh=I,e.$Oh=M;function o(O){return(p,$,w)=>{let A=null,P=null;if(typeof w.value=="function"?(A="value",P=w.value):typeof w.get=="function"&&(A="get",P=w.get),!P)throw new Error("not supported");w[A]=O(P,$)}}function R(O,p,$){let w=null,A=null;if(typeof $.value=="function"?(w="value",A=$.value,A.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof $.get=="function"&&(w="get",A=$.get),!A)throw new Error("not supported");const P=`$memoize$${p}`;$[w]=function(...b){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:A.apply(this,b)}),this[P]}}function I(O,p,$){return o((w,A)=>{const P=`$debounce$${A}`,b=`$debounce$result$${A}`;return function(...C){this[b]||(this[b]=$?$():void 0),clearTimeout(this[P]),p&&(this[b]=p(this[b],...C),C=[this[b]]),this[P]=setTimeout(()=>{w.apply(this,C),this[b]=$?$():void 0},O)}})}function M(O,p,$){return o((w,A)=>{const P=`$throttle$timer$${A}`,b=`$throttle$result$${A}`,C=`$throttle$lastRun$${A}`,y=`$throttle$pending$${A}`;return function(...a){if(this[b]||(this[b]=$?$():void 0),(this[C]===null||this[C]===void 0)&&(this[C]=-Number.MAX_VALUE),p&&(this[b]=p(this[b],...a)),this[y])return;const m=this[C]+O;m<=Date.now()?(this[C]=Date.now(),w.apply(this,[this[b]]),this[b]=$?$():void 0):(this[y]=!0,this[P]=setTimeout(()=>{this[y]=!1,this[C]=Date.now(),w.apply(this,[this[b]]),this[b]=$?$():void 0},m-Date.now()))}})}}),define(Ee[13],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$9=e.$5=e.$X=e.$W=void 0,e.setUnexpectedErrorHandler=R,e.$Z=I,e.$1=M,e.$2=O,e.$3=p,e.$4=w,e.$6=P,e.$7=b,e.$8=C,e.$0=a;class o{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?n.isErrorNoTelemetry(t)?new n(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(g=>{g(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=o,e.$X=new o;function R(s){e.$X.setUnexpectedErrorHandler(s)}function I(s){if(!s||typeof s!="object")return!1;const t=s;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function M(s){w(s)||e.$X.onUnexpectedError(s)}function O(s){w(s)||e.$X.onUnexpectedExternalError(s)}function p(s){if(s instanceof Error){const{name:t,message:g}=s,d=s.stacktrace||s.stack;return{$isError:!0,name:t,message:g,stack:d,noTelemetry:n.isErrorNoTelemetry(s)}}return s}const $="Canceled";function w(s){return s instanceof A?!0:s instanceof Error&&s.name===$&&s.message===$}class A extends Error{constructor(){super($),this.name=this.message}}e.$5=A;function P(){const s=new Error($);return s.name=s.message,s}function b(s){return s?new Error(`Illegal argument: ${s}`):new Error("Illegal argument")}function C(s){return s?new Error(`Illegal state: ${s}`):new Error("Illegal state")}class y extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=y;function a(s){return s?s.message?s.message:s.stack?s.stack.split(`
`)[0]:String(s):"Error"}class m extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=m;class l extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=l;class i extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=i;class n extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof n)return t;const g=new n;return g.message=t.message,g.stack=t.stack,g}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=n;class r extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,r.prototype)}}e.$cb=r}),define(Ee[19],Ce([1,0,13,164]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bc=e.$ac=e.$_b=e.$0b=e.$9b=e.CompareResult=void 0,e.$sb=I,e.$tb=M,e.$ub=O,e.$vb=p,e.$wb=$,e.$xb=w,e.$yb=A,e.$zb=P,e.$Ab=b,e.$Bb=C,e.$Cb=y,e.$Db=a,e.$Eb=m,e.top=l,e.$Gb=i,e.$Hb=r,e.$Ib=s,e.$Jb=t,e.$Kb=g,e.$Lb=d,e.$Mb=h,e.$Nb=c,e.$Ob=u,e.$Pb=f,e.$Qb=E,e.$Rb=v,e.$Sb=D,e.$Tb=k,e.$Ub=S,e.$Vb=F,e.$Wb=W,e.$Xb=B,e.$Yb=T,e.$Zb=N,e.$1b=j,e.$2b=L,e.$3b=z,e.$4b=Q,e.$5b=Y,e.$6b=J,e.$7b=te,e.$8b=pe,e.$$b=U;function I(ie,se=0){return ie[ie.length-(1+se)]}function M(ie){if(ie.length===0)throw new Error("Invalid tail call");return[ie.slice(0,ie.length-1),ie[ie.length-1]]}function O(ie,se,oe=(G,ee)=>G===ee){if(ie===se)return!0;if(!ie||!se||ie.length!==se.length)return!1;for(let G=0,ee=ie.length;G<ee;G++)if(!oe(ie[G],se[G]))return!1;return!0}function p(ie,se){const oe=ie.length-1;se<oe&&(ie[se]=ie[oe]),ie.pop()}function $(ie,se,oe){return w(ie.length,G=>oe(ie[G],se))}function w(ie,se){let oe=0,G=ie-1;for(;oe<=G;){const ee=(oe+G)/2|0,le=se(ee);if(le<0)oe=ee+1;else if(le>0)G=ee-1;else return ee}return-(oe+1)}function A(ie,se,oe){if(ie=ie|0,ie>=se.length)throw new TypeError("invalid index");const G=se[Math.floor(se.length*Math.random())],ee=[],le=[],de=[];for(const Me of se){const be=oe(Me,G);be<0?ee.push(Me):be>0?le.push(Me):de.push(Me)}return ie<ee.length?A(ie,ee,oe):ie<ee.length+de.length?de[0]:A(ie-(ee.length+de.length),le,oe)}function P(ie,se){const oe=[];let G;for(const ee of ie.slice(0).sort(se))!G||se(G[0],ee)!==0?(G=[ee],oe.push(G)):G.push(ee);return oe}function*b(ie,se){let oe,G;for(const ee of ie)G!==void 0&&se(G,ee)?oe.push(ee):(oe&&(yield oe),oe=[ee]),G=ee;oe&&(yield oe)}function C(ie,se){for(let oe=0;oe<=ie.length;oe++)se(oe===0?void 0:ie[oe-1],oe===ie.length?void 0:ie[oe])}function y(ie,se){for(let oe=0;oe<ie.length;oe++)se(oe===0?void 0:ie[oe-1],ie[oe],oe+1===ie.length?void 0:ie[oe+1])}function a(ie,se,oe){const G=[];function ee(Me,be,Pe){if(be===0&&Pe.length===0)return;const Re=G[G.length-1];Re&&Re.start+Re.deleteCount===Me?(Re.deleteCount+=be,Re.toInsert.push(...Pe)):G.push({start:Me,deleteCount:be,toInsert:Pe})}let le=0,de=0;for(;;){if(le===ie.length){ee(le,0,se.slice(de));break}if(de===se.length){ee(le,ie.length-le,[]);break}const Me=ie[le],be=se[de],Pe=oe(Me,be);Pe===0?(le+=1,de+=1):Pe<0?(ee(le,1,[]),le+=1):Pe>0&&(ee(le,0,[be]),de+=1)}return G}function m(ie,se,oe){const G=a(ie,se,oe),ee=[],le=[];for(const de of G)ee.push(...ie.slice(de.start,de.start+de.deleteCount)),le.push(...de.toInsert);return{removed:ee,added:le}}function l(ie,se,oe){if(oe===0)return[];const G=ie.slice(0,oe).sort(se);return n(ie,se,G,oe,ie.length),G}function i(ie,se,oe,G,ee){return oe===0?Promise.resolve([]):new Promise((le,de)=>{(async()=>{const Me=ie.length,be=ie.slice(0,oe).sort(se);for(let Pe=oe,Re=Math.min(oe+G,Me);Pe<Me;Pe=Re,Re=Math.min(Re+G,Me)){if(Pe>oe&&await new Promise(ze=>setTimeout(ze)),ee&&ee.isCancellationRequested)throw new o.$5;n(ie,se,be,Pe,Re)}return be})().then(le,de)})}function n(ie,se,oe,G,ee){for(const le=oe.length;G<ee;G++){const de=ie[G];if(se(de,oe[le-1])<0){oe.pop();const Me=(0,R.$kb)(oe,be=>se(de,be)<0);oe.splice(Me,0,de)}}}function r(ie){return ie.filter(se=>!!se)}function s(ie){let se=0;for(let oe=0;oe<ie.length;oe++)ie[oe]&&(ie[se]=ie[oe],se+=1);ie.length=se}function t(ie,se,oe){ie.splice(oe,0,ie.splice(se,1)[0])}function g(ie){return!Array.isArray(ie)||ie.length===0}function d(ie){return Array.isArray(ie)&&ie.length>0}function h(ie,se=oe=>oe){const oe=new Set;return ie.filter(G=>{const ee=se(G);return oe.has(ee)?!1:(oe.add(ee),!0)})}function c(ie){const se=new Set;return oe=>{const G=ie(oe);return se.has(G)?!1:(se.add(G),!0)}}function u(ie,se){return ie.length>0?ie[0]:se}function f(ie,se){return ie.length>0?ie[ie.length-1]:se}function E(ie,se,oe=(G,ee)=>G===ee){let G=0;for(let ee=0,le=Math.min(ie.length,se.length);ee<le&&oe(ie[ee],se[ee]);ee++)G++;return G}function v(ie){return[].concat(...ie)}function D(ie,se){let oe=typeof se=="number"?ie:0;typeof se=="number"?oe=ie:(oe=0,se=ie);const G=[];if(oe<=se)for(let ee=oe;ee<se;ee++)G.push(ee);else for(let ee=oe;ee>se;ee--)G.push(ee);return G}function k(ie,se,oe){return ie.reduce((G,ee)=>(G[se(ee)]=oe?oe(ee):ee,G),Object.create(null))}function S(ie,se){return ie.push(se),()=>F(ie,se)}function F(ie,se){const oe=ie.indexOf(se);if(oe>-1)return ie.splice(oe,1),se}function W(ie,se,oe){const G=ie.slice(0,se),ee=ie.slice(se);return G.concat(oe,ee)}function B(ie,se){let oe;if(typeof se=="number"){let G=se;oe=()=>{const ee=Math.sin(G++)*179426549;return ee-Math.floor(ee)}}else oe=Math.random;for(let G=ie.length-1;G>0;G-=1){const ee=Math.floor(oe()*(G+1)),le=ie[G];ie[G]=ie[ee],ie[ee]=le}}function T(ie,se){const oe=ie.indexOf(se);oe>-1&&(ie.splice(oe,1),ie.unshift(se))}function N(ie,se){const oe=ie.indexOf(se);oe>-1&&(ie.splice(oe,1),ie.push(se))}function j(ie,se){for(const oe of se)ie.push(oe)}function L(ie,se){return Array.isArray(ie)?ie.map(se):se(ie)}function z(ie){return Array.isArray(ie)?ie:[ie]}function Q(ie){return ie[Math.floor(Math.random()*ie.length)]}function Y(ie,se,oe){const G=x(ie,se),ee=ie.length,le=oe.length;ie.length=ee+le;for(let de=ee-1;de>=G;de--)ie[de+le]=ie[de];for(let de=0;de<le;de++)ie[de+G]=oe[de]}function J(ie,se,oe,G){const ee=x(ie,se);let le=ie.splice(ee,oe);return le===void 0&&(le=[]),Y(ie,ee,G),le}function x(ie,se){return se<0?Math.max(se+ie.length,0):Math.min(se,ie.length)}var ce;(function(ie){function se(le){return le<0}ie.isLessThan=se;function oe(le){return le<=0}ie.isLessThanOrEqual=oe;function G(le){return le>0}ie.isGreaterThan=G;function ee(le){return le===0}ie.isNeitherLessOrGreaterThan=ee,ie.greaterThan=1,ie.lessThan=-1,ie.neitherLessOrGreaterThan=0})(ce||(e.CompareResult=ce={}));function te(ie,se){return(oe,G)=>se(ie(oe),ie(G))}function pe(...ie){return(se,oe)=>{for(const G of ie){const ee=G(se,oe);if(!ce.isNeitherLessOrGreaterThan(ee))return ee}return ce.neitherLessOrGreaterThan}}const ye=(ie,se)=>ie-se;e.$9b=ye;const _=(ie,se)=>(0,e.$9b)(ie?1:0,se?1:0);e.$0b=_;function U(ie){return(se,oe)=>-ie(se,oe)}class he{constructor(se){this.g=se,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(se){let oe=this.c;for(;oe<this.g.length&&se(this.g[oe]);)oe++;const G=oe===this.c?null:this.g.slice(this.c,oe);return this.c=oe,G}takeFromEndWhile(se){let oe=this.d;for(;oe>=0&&se(this.g[oe]);)oe--;const G=oe===this.d?null:this.g.slice(oe+1,this.d+1);return this.d=oe,G}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const se=this.g[this.c];return this.c++,se}removeLast(){const se=this.g[this.d];return this.d--,se}takeCount(se){const oe=this.g.slice(this.c,this.c+se);return this.c+=se,oe}}e.$_b=he;class Se{constructor(se){this.iterate=se}forEach(se){this.iterate(oe=>(se(oe),!0))}toArray(){const se=[];return this.iterate(oe=>(se.push(oe),!0)),se}filter(se){return new Se(oe=>this.iterate(G=>se(G)?oe(G):!0))}map(se){return new Se(oe=>this.iterate(G=>oe(se(G))))}some(se){let oe=!1;return this.iterate(G=>(oe=se(G),!oe)),oe}findFirst(se){let oe;return this.iterate(G=>se(G)?(oe=G,!1):!0),oe}findLast(se){let oe;return this.iterate(G=>(se(G)&&(oe=G),!0)),oe}findLastMaxBy(se){let oe,G=!0;return this.iterate(ee=>((G||ce.isGreaterThan(se(ee,oe)))&&(G=!1,oe=ee),!0)),oe}}e.$ac=Se,Se.empty=new Se(ie=>{});class me{constructor(se){this.c=se}static createSortPermutation(se,oe){const G=Array.from(se.keys()).sort((ee,le)=>oe(se[ee],se[le]));return new me(G)}apply(se){return se.map((oe,G)=>se[this.c[G]])}inverse(){const se=this.c.slice();for(let oe=0;oe<this.c.length;oe++)se[this.c[oe]]=oe;return new me(se)}}e.$bc=me}),define(Ee[61],Ce([1,0,13]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=R,e.$0c=I,e.$$c=M,e.$_c=O,e.$ad=p,e.$bd=$;function R(w,A){if(!w)throw new Error(A?`Assertion failed (${A})`:"Assertion Failed")}function I(w,A="Unreachable"){throw new Error(A)}function M(w){if(!w)throw new o.$cb("Assertion Failed")}function O(w){w||(0,o.$1)(new o.$cb("Soft Assertion Failed"))}function p(w){if(!w()){debugger;w(),(0,o.$1)(new o.$cb("Assertion Failed"))}}function $(w,A){let P=0;for(;P<w.length-1;){const b=w[P],C=w[P+1];if(!A(b,C))return!1;P++}return!0}}),define(Ee[74],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=o;function o(R,I){const M=this;let O=!1,p;return function(){if(O)return p;if(O=!0,I)try{p=R.apply(M,arguments)}finally{I()}else p=R.apply(M,arguments);return p}}}),define(Ee[125],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UO=e.$TO=void 0;class o{constructor(I){this.a=I,this.b=0}nextId(){return this.a+ ++this.b}}e.$TO=o,e.$UO=new o("id#")}),define(Ee[39],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var o;(function(R){function I(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}R.is=I;const M=Object.freeze([]);function O(){return M}R.empty=O;function*p(t){yield t}R.single=p;function $(t){return I(t)?t:p(t)}R.wrap=$;function w(t){return t||M}R.from=w;function*A(t){for(let g=t.length-1;g>=0;g--)yield t[g]}R.reverse=A;function P(t){return!t||t[Symbol.iterator]().next().done===!0}R.isEmpty=P;function b(t){return t[Symbol.iterator]().next().value}R.first=b;function C(t,g){for(const d of t)if(g(d))return!0;return!1}R.some=C;function y(t,g){for(const d of t)if(g(d))return d}R.find=y;function*a(t,g){for(const d of t)g(d)&&(yield d)}R.filter=a;function*m(t,g){let d=0;for(const h of t)yield g(h,d++)}R.map=m;function*l(...t){for(const g of t)yield*g}R.concat=l;function i(t,g,d){let h=d;for(const c of t)h=g(h,c);return h}R.reduce=i;function*n(t,g,d=t.length){for(g<0&&(g+=t.length),d<0?d+=t.length:d>t.length&&(d=t.length);g<d;g++)yield t[g]}R.slice=n;function r(t,g=Number.POSITIVE_INFINITY){const d=[];if(g===0)return[d,t];const h=t[Symbol.iterator]();for(let c=0;c<g;c++){const u=h.next();if(u.done)return[d,R.empty()];d.push(u.value)}return[d,{[Symbol.iterator](){return h}}]}R.consume=r;async function s(t){const g=[];for await(const d of t)g.push(d);return Promise.resolve(g)}R.asyncToArray=s})(o||(e.Iterable=o={}))}),define(Ee[165],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$un=O,e.$vn=P,e.$wn=b,e.$xn=C,e.$yn=y,e.$zn=a,e.$An=m,e.$Bn=l,e.$Cn=i,e.$Dn=n,e.$En=r,e.$Fn=s;var o;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(o||(e.ScanError=o={}));var R;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(R||(e.SyntaxKind=R={}));var I;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(I||(e.ParseErrorCode=I={}));var M;(function(t){t.DEFAULT={allowTrailingComma:!0}})(M||(e.ParseOptions=M={}));function O(t,g=!1){let d=0;const h=t.length;let c="",u=0,f=16,E=0;function v(T){let N=0,j=0;for(;N<T;){const L=t.charCodeAt(d);if(L>=48&&L<=57)j=j*16+L-48;else if(L>=65&&L<=70)j=j*16+L-65+10;else if(L>=97&&L<=102)j=j*16+L-97+10;else break;d++,N++}return N<T&&(j=-1),j}function D(T){d=T,c="",u=0,f=16,E=0}function k(){const T=d;if(t.charCodeAt(d)===48)d++;else for(d++;d<t.length&&w(t.charCodeAt(d));)d++;if(d<t.length&&t.charCodeAt(d)===46)if(d++,d<t.length&&w(t.charCodeAt(d)))for(d++;d<t.length&&w(t.charCodeAt(d));)d++;else return E=3,t.substring(T,d);let N=d;if(d<t.length&&(t.charCodeAt(d)===69||t.charCodeAt(d)===101))if(d++,(d<t.length&&t.charCodeAt(d)===43||t.charCodeAt(d)===45)&&d++,d<t.length&&w(t.charCodeAt(d))){for(d++;d<t.length&&w(t.charCodeAt(d));)d++;N=d}else E=3;return t.substring(T,N)}function S(){let T="",N=d;for(;;){if(d>=h){T+=t.substring(N,d),E=2;break}const j=t.charCodeAt(d);if(j===34){T+=t.substring(N,d),d++;break}if(j===92){if(T+=t.substring(N,d),d++,d>=h){E=2;break}switch(t.charCodeAt(d++)){case 34:T+='"';break;case 92:T+="\\";break;case 47:T+="/";break;case 98:T+="\b";break;case 102:T+="\f";break;case 110:T+=`
`;break;case 114:T+="\r";break;case 116:T+="	";break;case 117:{const z=v(4);z>=0?T+=String.fromCharCode(z):E=4;break}default:E=5}N=d;continue}if(j>=0&&j<=31)if($(j)){T+=t.substring(N,d),E=2;break}else E=6;d++}return T}function F(){if(c="",E=0,u=d,d>=h)return u=h,f=17;let T=t.charCodeAt(d);if(p(T)){do d++,c+=String.fromCharCode(T),T=t.charCodeAt(d);while(p(T));return f=15}if($(T))return d++,c+=String.fromCharCode(T),T===13&&t.charCodeAt(d)===10&&(d++,c+=`
`),f=14;switch(T){case 123:return d++,f=1;case 125:return d++,f=2;case 91:return d++,f=3;case 93:return d++,f=4;case 58:return d++,f=6;case 44:return d++,f=5;case 34:return d++,c=S(),f=10;case 47:{const N=d-1;if(t.charCodeAt(d+1)===47){for(d+=2;d<h&&!$(t.charCodeAt(d));)d++;return c=t.substring(N,d),f=12}if(t.charCodeAt(d+1)===42){d+=2;const j=h-1;let L=!1;for(;d<j;){if(t.charCodeAt(d)===42&&t.charCodeAt(d+1)===47){d+=2,L=!0;break}d++}return L||(d++,E=1),c=t.substring(N,d),f=13}return c+=String.fromCharCode(T),d++,f=16}case 45:if(c+=String.fromCharCode(T),d++,d===h||!w(t.charCodeAt(d)))return f=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return c+=k(),f=11;default:for(;d<h&&W(T);)d++,T=t.charCodeAt(d);if(u!==d){switch(c=t.substring(u,d),c){case"true":return f=8;case"false":return f=9;case"null":return f=7}return f=16}return c+=String.fromCharCode(T),d++,f=16}}function W(T){if(p(T)||$(T))return!1;switch(T){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function B(){let T;do T=F();while(T>=12&&T<=15);return T}return{setPosition:D,getPosition:()=>d,scan:g?B:F,getToken:()=>f,getTokenValue:()=>c,getTokenOffset:()=>u,getTokenLength:()=>d-u,getTokenError:()=>E}}function p(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function $(t){return t===10||t===13||t===8232||t===8233}function w(t){return t>=48&&t<=57}var A;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(A||(A={}));function P(t,g){const d=[],h=new Object;let c;const u={value:{},offset:0,length:0,type:"object",parent:void 0};let f=!1;function E(v,D,k,S){u.value=v,u.offset=D,u.length=k,u.type=S,u.colonOffset=void 0,c=u}try{n(t,{onObjectBegin:(v,D)=>{if(g<=v)throw h;c=void 0,f=g>v,d.push("")},onObjectProperty:(v,D,k)=>{if(g<D||(E(v,D,k,"property"),d[d.length-1]=v,g<=D+k))throw h},onObjectEnd:(v,D)=>{if(g<=v)throw h;c=void 0,d.pop()},onArrayBegin:(v,D)=>{if(g<=v)throw h;c=void 0,d.push(0)},onArrayEnd:(v,D)=>{if(g<=v)throw h;c=void 0,d.pop()},onLiteralValue:(v,D,k)=>{if(g<D||(E(v,D,k,s(v)),g<=D+k))throw h},onSeparator:(v,D,k)=>{if(g<=D)throw h;if(v===":"&&c&&c.type==="property")c.colonOffset=D,f=!1,c=void 0;else if(v===","){const S=d[d.length-1];typeof S=="number"?d[d.length-1]=S+1:(f=!0,d[d.length-1]=""),c=void 0}}})}catch(v){if(v!==h)throw v}return{path:d,previousNode:c,isAtPropertyKey:f,matches:v=>{let D=0;for(let k=0;D<v.length&&k<d.length;k++)if(v[D]===d[k]||v[D]==="*")D++;else if(v[D]!=="**")return!1;return D===v.length}}}function b(t,g=[],d=M.DEFAULT){let h=null,c=[];const u=[];function f(v){Array.isArray(c)?c.push(v):h!==null&&(c[h]=v)}return n(t,{onObjectBegin:()=>{const v={};f(v),u.push(c),c=v,h=null},onObjectProperty:v=>{h=v},onObjectEnd:()=>{c=u.pop()},onArrayBegin:()=>{const v=[];f(v),u.push(c),c=v,h=null},onArrayEnd:()=>{c=u.pop()},onLiteralValue:f,onError:(v,D,k)=>{g.push({error:v,offset:D,length:k})}},d),c[0]}function C(t,g=[],d=M.DEFAULT){let h={type:"array",offset:-1,length:-1,children:[],parent:void 0};function c(v){h.type==="property"&&(h.length=v-h.offset,h=h.parent)}function u(v){return h.children.push(v),v}n(t,{onObjectBegin:v=>{h=u({type:"object",offset:v,length:-1,parent:h,children:[]})},onObjectProperty:(v,D,k)=>{h=u({type:"property",offset:D,length:-1,parent:h,children:[]}),h.children.push({type:"string",value:v,offset:D,length:k,parent:h})},onObjectEnd:(v,D)=>{h.length=v+D-h.offset,h=h.parent,c(v+D)},onArrayBegin:(v,D)=>{h=u({type:"array",offset:v,length:-1,parent:h,children:[]})},onArrayEnd:(v,D)=>{h.length=v+D-h.offset,h=h.parent,c(v+D)},onLiteralValue:(v,D,k)=>{u({type:s(v),offset:D,length:k,parent:h,value:v}),c(D+k)},onSeparator:(v,D,k)=>{h.type==="property"&&(v===":"?h.colonOffset=D:v===","&&c(D))},onError:(v,D,k)=>{g.push({error:v,offset:D,length:k})}},d);const E=h.children[0];return E&&delete E.parent,E}function y(t,g){if(!t)return;let d=t;for(const h of g)if(typeof h=="string"){if(d.type!=="object"||!Array.isArray(d.children))return;let c=!1;for(const u of d.children)if(Array.isArray(u.children)&&u.children[0].value===h){d=u.children[1],c=!0;break}if(!c)return}else{const c=h;if(d.type!=="array"||c<0||!Array.isArray(d.children)||c>=d.children.length)return;d=d.children[c]}return d}function a(t){if(!t.parent||!t.parent.children)return[];const g=a(t.parent);if(t.parent.type==="property"){const d=t.parent.children[0].value;g.push(d)}else if(t.parent.type==="array"){const d=t.parent.children.indexOf(t);d!==-1&&g.push(d)}return g}function m(t){switch(t.type){case"array":return t.children.map(m);case"object":{const g=Object.create(null);for(const d of t.children){const h=d.children[1];h&&(g[d.children[0].value]=m(h))}return g}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function l(t,g,d=!1){return g>=t.offset&&g<t.offset+t.length||d&&g===t.offset+t.length}function i(t,g,d=!1){if(l(t,g,d)){const h=t.children;if(Array.isArray(h))for(let c=0;c<h.length&&h[c].offset<=g;c++){const u=i(h[c],g,d);if(u)return u}return t}}function n(t,g,d=M.DEFAULT){const h=O(t,!1);function c(te){return te?()=>te(h.getTokenOffset(),h.getTokenLength()):()=>!0}function u(te){return te?pe=>te(pe,h.getTokenOffset(),h.getTokenLength()):()=>!0}const f=c(g.onObjectBegin),E=u(g.onObjectProperty),v=c(g.onObjectEnd),D=c(g.onArrayBegin),k=c(g.onArrayEnd),S=u(g.onLiteralValue),F=u(g.onSeparator),W=c(g.onComment),B=u(g.onError),T=d&&d.disallowComments,N=d&&d.allowTrailingComma;function j(){for(;;){const te=h.scan();switch(h.getTokenError()){case 4:L(14);break;case 5:L(15);break;case 3:L(13);break;case 1:T||L(11);break;case 2:L(12);break;case 6:L(16);break}switch(te){case 12:case 13:T?L(10):W();break;case 16:L(1);break;case 15:case 14:break;default:return te}}}function L(te,pe=[],ye=[]){if(B(te),pe.length+ye.length>0){let _=h.getToken();for(;_!==17;){if(pe.indexOf(_)!==-1){j();break}else if(ye.indexOf(_)!==-1)break;_=j()}}}function z(te){const pe=h.getTokenValue();return te?S(pe):E(pe),j(),!0}function Q(){switch(h.getToken()){case 11:{let te=0;try{te=JSON.parse(h.getTokenValue()),typeof te!="number"&&(L(2),te=0)}catch{L(2)}S(te);break}case 7:S(null);break;case 8:S(!0);break;case 9:S(!1);break;default:return!1}return j(),!0}function Y(){return h.getToken()!==10?(L(3,[],[2,5]),!1):(z(!1),h.getToken()===6?(F(":"),j(),ce()||L(4,[],[2,5])):L(5,[],[2,5]),!0)}function J(){f(),j();let te=!1;for(;h.getToken()!==2&&h.getToken()!==17;){if(h.getToken()===5){if(te||L(4,[],[]),F(","),j(),h.getToken()===2&&N)break}else te&&L(6,[],[]);Y()||L(4,[],[2,5]),te=!0}return v(),h.getToken()!==2?L(7,[2],[]):j(),!0}function x(){D(),j();let te=!1;for(;h.getToken()!==4&&h.getToken()!==17;){if(h.getToken()===5){if(te||L(4,[],[]),F(","),j(),h.getToken()===4&&N)break}else te&&L(6,[],[]);ce()||L(4,[],[4,5]),te=!0}return k(),h.getToken()!==4?L(8,[4],[]):j(),!0}function ce(){switch(h.getToken()){case 3:return x();case 1:return J();case 10:return z(!0);default:return Q()}}return j(),h.getToken()===17?d.allowEmptyContent?!0:(L(4,[],[]),!1):ce()?(h.getToken()!==17&&L(9,[],[]),!0):(L(4,[],[]),!1)}function r(t,g){const d=O(t),h=[];let c,u=0,f;do switch(f=d.getPosition(),c=d.scan(),c){case 12:case 13:case 17:u!==f&&h.push(t.substring(u,f)),g!==void 0&&h.push(d.getTokenValue().replace(/[^\r\n]/g,g)),u=d.getPosition();break}while(c!==17);return h.join("")}function s(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(Ee[46],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class o{constructor(I){this.d=I,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(I){this.c=I}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=o}),define(Ee[75],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=void 0;class o{constructor(M){this.element=M,this.next=o.Undefined,this.prev=o.Undefined}}o.Undefined=new o(void 0);class R{constructor(){this.a=o.Undefined,this.b=o.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===o.Undefined}clear(){let M=this.a;for(;M!==o.Undefined;){const O=M.next;M.prev=o.Undefined,M.next=o.Undefined,M=O}this.a=o.Undefined,this.b=o.Undefined,this.c=0}unshift(M){return this.d(M,!1)}push(M){return this.d(M,!0)}d(M,O){const p=new o(M);if(this.a===o.Undefined)this.a=p,this.b=p;else if(O){const w=this.b;this.b=p,p.prev=w,w.next=p}else{const w=this.a;this.a=p,p.next=w,w.prev=p}this.c+=1;let $=!1;return()=>{$||($=!0,this.e(p))}}shift(){if(this.a!==o.Undefined){const M=this.a.element;return this.e(this.a),M}}pop(){if(this.b!==o.Undefined){const M=this.b.element;return this.e(this.b),M}}e(M){if(M.prev!==o.Undefined&&M.next!==o.Undefined){const O=M.prev;O.next=M.next,M.next.prev=O}else M.prev===o.Undefined&&M.next===o.Undefined?(this.a=o.Undefined,this.b=o.Undefined):M.next===o.Undefined?(this.b=this.b.prev,this.b.next=o.Undefined):M.prev===o.Undefined&&(this.a=this.a.next,this.a.prev=o.Undefined);this.c-=1}*[Symbol.iterator](){let M=this.a;for(;M!==o.Undefined;)yield M.element,M=M.next}}e.$5c=R}),define(Ee[27],Ce([1,0]),function(re,e){"use strict";var o,R,I;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.Touch=e.$Cc=e.$Bc=void 0,e.$yc=M,e.$zc=O,e.$Ac=p,e.$Ic=i;function M(n,r,s){let t=n.get(r);return t===void 0&&(t=s,n.set(r,t)),t}function O(n){const r=[];return n.forEach((s,t)=>{r.push(`${t} => ${s}`)}),`Map(${n.size}) {${r.join(", ")}}`}function p(n){const r=[];return n.forEach(s=>{r.push(s)}),`Set(${n.size}) {${r.join(", ")}}`}class ${constructor(r,s){this.uri=r,this.value=s}}function w(n){return Array.isArray(n)}class A{constructor(r,s){if(this[o]="ResourceMap",r instanceof A)this.d=new Map(r.d),this.e=s??A.c;else if(w(r)){this.d=new Map,this.e=s??A.c;for(const[t,g]of r)this.set(t,g)}else this.d=new Map,this.e=r??A.c}set(r,s){return this.d.set(this.e(r),new $(r,s)),this}get(r){return this.d.get(this.e(r))?.value}has(r){return this.d.has(this.e(r))}get size(){return this.d.size}clear(){this.d.clear()}delete(r){return this.d.delete(this.e(r))}forEach(r,s){typeof s<"u"&&(r=r.bind(s));for(const[t,g]of this.d)r(g.value,g.uri,this)}*values(){for(const r of this.d.values())yield r.value}*keys(){for(const r of this.d.values())yield r.uri}*entries(){for(const r of this.d.values())yield[r.uri,r.value]}*[(o=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.d)yield[r.uri,r.value]}}e.$Bc=A,A.c=n=>n.toString();class P{constructor(r,s){this[R]="ResourceSet",!r||typeof r=="function"?this.c=new A(r):(this.c=new A(s),r.forEach(this.add,this))}get size(){return this.c.size}add(r){return this.c.set(r,r),this}clear(){this.c.clear()}delete(r){return this.c.delete(r)}forEach(r,s){this.c.forEach((t,g)=>r.call(s,g,g,this))}has(r){return this.c.has(r)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Cc=P;var b;(function(n){n[n.None=0]="None",n[n.AsOld=1]="AsOld",n[n.AsNew=2]="AsNew"})(b||(e.Touch=b={}));class C{constructor(){this[I]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(r){return this.c.has(r)}get(r,s=0){const t=this.c.get(r);if(t)return s!==0&&this.l(t,s),t.value}set(r,s,t=0){let g=this.c.get(r);if(g)g.value=s,t!==0&&this.l(g,t);else{switch(g={key:r,value:s,next:void 0,previous:void 0},t){case 0:this.j(g);break;case 1:this.i(g);break;case 2:this.j(g);break;default:this.j(g);break}this.c.set(r,g),this.f++}return this}delete(r){return!!this.remove(r)}remove(r){const s=this.c.get(r);if(s)return this.c.delete(r),this.k(s),this.f--,s.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const r=this.d;return this.c.delete(r.key),this.k(r),this.f--,r.value}forEach(r,s){const t=this.g;let g=this.d;for(;g;){if(s?r.bind(s)(g.value,g.key,this):r(g.value,g.key,this),this.g!==t)throw new Error("LinkedMap got modified during iteration.");g=g.next}}keys(){const r=this,s=this.g;let t=this.d;const g={[Symbol.iterator](){return g},next(){if(r.g!==s)throw new Error("LinkedMap got modified during iteration.");if(t){const d={value:t.key,done:!1};return t=t.next,d}else return{value:void 0,done:!0}}};return g}values(){const r=this,s=this.g;let t=this.d;const g={[Symbol.iterator](){return g},next(){if(r.g!==s)throw new Error("LinkedMap got modified during iteration.");if(t){const d={value:t.value,done:!1};return t=t.next,d}else return{value:void 0,done:!0}}};return g}entries(){const r=this,s=this.g;let t=this.d;const g={[Symbol.iterator](){return g},next(){if(r.g!==s)throw new Error("LinkedMap got modified during iteration.");if(t){const d={value:[t.key,t.value],done:!1};return t=t.next,d}else return{value:void 0,done:!0}}};return g}[(I=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(r){if(r>=this.size)return;if(r===0){this.clear();return}let s=this.d,t=this.size;for(;s&&t>r;)this.c.delete(s.key),s=s.next,t--;this.d=s,this.f=t,s&&(s.previous=void 0),this.g++}i(r){if(!this.d&&!this.e)this.e=r;else if(this.d)r.next=this.d,this.d.previous=r;else throw new Error("Invalid list");this.d=r,this.g++}j(r){if(!this.d&&!this.e)this.d=r;else if(this.e)r.previous=this.e,this.e.next=r;else throw new Error("Invalid list");this.e=r,this.g++}k(r){if(r===this.d&&r===this.e)this.d=void 0,this.e=void 0;else if(r===this.d){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this.d=r.next}else if(r===this.e){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this.e=r.previous}else{const s=r.next,t=r.previous;if(!s||!t)throw new Error("Invalid list");s.previous=t,t.next=s}r.next=void 0,r.previous=void 0,this.g++}l(r,s){if(!this.d||!this.e)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(r===this.d)return;const t=r.next,g=r.previous;r===this.e?(g.next=void 0,this.e=g):(t.previous=g,g.next=t),r.previous=void 0,r.next=this.d,this.d.previous=r,this.d=r,this.g++}else if(s===2){if(r===this.e)return;const t=r.next,g=r.previous;r===this.d?(t.previous=void 0,this.d=t):(t.previous=g,g.next=t),r.next=void 0,r.previous=this.e,this.e.next=r,this.e=r,this.g++}}}toJSON(){const r=[];return this.forEach((s,t)=>{r.push([t,s])}),r}fromJSON(r){this.clear();for(const[s,t]of r)this.set(s,t)}}e.$Dc=C;class y extends C{constructor(r,s=1){super(),this.m=r,this.n=Math.min(Math.max(0,s),1)}get limit(){return this.m}set limit(r){this.m=r,this.o()}get ratio(){return this.n}set ratio(r){this.n=Math.min(Math.max(0,r),1),this.o()}get(r,s=2){return super.get(r,s)}peek(r){return super.get(r,0)}set(r,s){return super.set(r,s,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}e.$Ec=y;class a{constructor(){this.c=new Map}add(r){return this.c.set(r,(this.c.get(r)||0)+1),this}delete(r){let s=this.c.get(r)||0;return s===0?!1:(s--,s===0?this.c.delete(r):this.c.set(r,s),!0)}has(r){return this.c.has(r)}}e.$Fc=a;class m{constructor(r){if(this.c=new Map,this.d=new Map,r)for(const[s,t]of r)this.set(s,t)}clear(){this.c.clear(),this.d.clear()}set(r,s){this.c.set(r,s),this.d.set(s,r)}get(r){return this.c.get(r)}getKey(r){return this.d.get(r)}delete(r){const s=this.c.get(r);return s===void 0?!1:(this.c.delete(r),this.d.delete(s),!0)}forEach(r,s){this.c.forEach((t,g)=>{r.call(s,t,g,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Gc=m;class l{constructor(){this.c=new Map}add(r,s){let t=this.c.get(r);t||(t=new Set,this.c.set(r,t)),t.add(s)}delete(r,s){const t=this.c.get(r);t&&(t.delete(s),t.size===0&&this.c.delete(r))}forEach(r,s){const t=this.c.get(r);t&&t.forEach(s)}get(r){const s=this.c.get(r);return s||new Set}}e.$Hc=l;function i(n,r){if(n===r)return!0;if(n.size!==r.size)return!1;for(const[s,t]of n)if(!r.has(s)||r.get(s)!==t)return!1;for(const[s]of r)if(!n.has(s))return!1;return!0}}),define(Ee[3],Ce([1,0,19,73,27,74,39]),function(re,e,o,R,I,M,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Jc=void 0,e.$Kc=A,e.$Lc=P,e.$Mc=b,e.$Nc=a,e.$Oc=m,e.$Pc=l,e.$Qc=i,e.$Rc=n,e.$Sc=r,e.$3c=v;const p=!1;let $=null;class w{constructor(){this.b=new Map}c(S){let F=this.b.get(S);return F||(F={parent:null,source:null,isSingleton:!1,value:S,idx:w.a++},this.b.set(S,F)),F}trackDisposable(S){const F=this.c(S);F.source||(F.source=new Error().stack)}setParent(S,F){const W=this.c(S);W.parent=F}markAsDisposed(S){this.b.delete(S)}markAsSingleton(S){this.c(S).isSingleton=!0}f(S,F){const W=F.get(S);if(W)return W;const B=S.parent?this.f(this.c(S.parent),F):S;return F.set(S,B),B}getTrackedDisposables(){const S=new Map;return[...this.b.entries()].filter(([,W])=>W.source!==null&&!this.f(W,S).isSingleton).flatMap(([W])=>W)}computeLeakingDisposables(S=10,F){let W;if(F)W=F;else{const L=new Map,z=[...this.b.values()].filter(Y=>Y.source!==null&&!this.f(Y,L).isSingleton);if(z.length===0)return;const Q=new Set(z.map(Y=>Y.value));if(W=z.filter(Y=>!(Y.parent&&Q.has(Y.parent))),W.length===0)throw new Error("There are cyclic diposable chains!")}if(!W)return;function B(L){function z(Y,J){for(;Y.length>0&&J.some(x=>typeof x=="string"?x===Y[0]:Y[0].match(x));)Y.shift()}const Q=L.source.split(`
`).map(Y=>Y.trim().replace("at ","")).filter(Y=>Y!=="");return z(Q,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Q.reverse()}const T=new I.$Hc;for(const L of W){const z=B(L);for(let Q=0;Q<=z.length;Q++)T.add(z.slice(0,Q).join(`
`),L)}W.sort((0,o.$7b)(L=>L.idx,o.$9b));let N="",j=0;for(const L of W.slice(0,S)){j++;const z=B(L),Q=[];for(let Y=0;Y<z.length;Y++){let J=z[Y];J=`(shared with ${T.get(z.slice(0,Y+1).join(`
`)).size}/${W.length} leaks) at ${J}`;const ce=T.get(z.slice(0,Y).join(`
`)),te=(0,R.$E)([...ce].map(pe=>B(pe)[Y]),pe=>pe);delete te[z[Y]];for(const[pe,ye]of Object.entries(te))Q.unshift(`    - stacktraces of ${ye.length} other leaks continue with ${pe}`);Q.unshift(J)}N+=`


==================== Leaking disposable ${j}/${W.length}: ${L.value.constructor.name} ====================
${Q.join(`
`)}
============================================================

`}return W.length>S&&(N+=`


... and ${W.length-S} more leaking disposables

`),{leaks:W,details:N}}}e.$Jc=w,w.a=0;function A(k){$=k}if(p){const k="__is_disposable_tracked__";A(new class{trackDisposable(S){const F=new Error("Potentially leaked disposable").stack;setTimeout(()=>{S[k]||console.log(F)},3e3)}setParent(S,F){if(S&&S!==t.None)try{S[k]=!0}catch{}}markAsDisposed(S){if(S&&S!==t.None)try{S[k]=!0}catch{}}markAsSingleton(S){}})}function P(k){return $?.trackDisposable(k),k}function b(k){$?.markAsDisposed(k)}function C(k,S){$?.setParent(k,S)}function y(k,S){if($)for(const F of k)$.setParent(F,S)}function a(k){return $?.markAsSingleton(k),k}function m(k){return typeof k.dispose=="function"&&k.dispose.length===0}function l(k){if(O.Iterable.is(k)){const S=[];for(const F of k)if(F)try{F.dispose()}catch(W){S.push(W)}if(S.length===1)throw S[0];if(S.length>1)throw new AggregateError(S,"Encountered errors while disposing of store");return Array.isArray(k)?[]:k}else if(k)return k.dispose(),k}function i(k){for(const S of k)m(S)&&S.dispose();return[]}function n(...k){const S=r(()=>l(k));return y(k,S),S}function r(k){const S=P({dispose:(0,M.$db)(()=>{b(S),k()})});return S}class s{constructor(){this.f=new Set,this.g=!1,P(this)}dispose(){this.g||(b(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{l(this.f)}finally{this.f.clear()}}add(S){if(!S)return S;if(S===this)throw new Error("Cannot register a disposable on itself!");return C(S,this),this.g?s.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(S),S}delete(S){if(S){if(S===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(S),S.dispose()}}deleteAndLeak(S){S&&this.f.has(S)&&(this.f.delete(S),C(S,null))}}e.$Tc=s,s.DISABLE_DISPOSED_WARNING=!1;class t{constructor(){this.q=new s,P(this),C(this.q,this)}dispose(){b(this),this.q.dispose()}B(S){if(S===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(S)}}e.$Uc=t,t.None=Object.freeze({dispose(){}});class g{constructor(){this.b=!1,P(this)}get value(){return this.b?void 0:this.a}set value(S){this.b||S===this.a||(this.a?.dispose(),S&&C(S,this),this.a=S)}clear(){this.value=void 0}dispose(){this.b=!0,b(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const S=this.a;return this.a=void 0,S&&C(S,null),S}}e.$Vc=g;class d{constructor(S){this.a=new g,this.b=!1,this.a.value=S}get value(){return this.a.value}set value(S){this.b||S===this.a.value||(this.a.value=S)}dispose(){this.b=!0,this.a.dispose()}}e.$Wc=d;class h{constructor(S){this.b=S,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Xc=h;class c{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(S){let F=S;return this.unset=()=>F=void 0,this.isset=()=>F!==void 0,this.dispose=()=>{F&&(F(),F=void 0,b(this))},this}}e.$Yc=c;class u{constructor(){this.a=new Map}acquire(S,...F){let W=this.a.get(S);W||(W={counter:0,object:this.b(S,...F)},this.a.set(S,W));const{object:B}=W,T=(0,M.$db)(()=>{--W.counter===0&&(this.c(S,W.object),this.a.delete(S))});return W.counter++,{object:B,dispose:T}}}e.$Zc=u;class f{constructor(S){this.a=S}async acquire(S,...F){const W=this.a.acquire(S,...F);try{return{object:await W.object,dispose:()=>W.dispose()}}catch(B){throw W.dispose(),B}}}e.$1c=f;class E{constructor(S){this.object=S}dispose(){}}e.$2c=E;function v(k){const S=new s;try{k(S)}finally{S.dispose()}}class D{constructor(){this.a=new Map,this.b=!1,P(this)}dispose(){b(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{l(this.a.values())}finally{this.a.clear()}}has(S){return this.a.has(S)}get size(){return this.a.size}get(S){return this.a.get(S)}set(S,F,W=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),W||this.a.get(S)?.dispose(),this.a.set(S,F)}deleteAndDispose(S){this.a.get(S)?.dispose(),this.a.delete(S)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$4c=D}),function(re,e){typeof define=="function"&&define.amd?define(Ee[166],Ce([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(re=typeof globalThis<"u"?globalThis:re||self,e(re.marked={}))}(this,function(re){"use strict";function e(ie,se){for(var oe=0;oe<se.length;oe++){var G=se[oe];G.enumerable=G.enumerable||!1,G.configurable=!0,"value"in G&&(G.writable=!0),Object.defineProperty(ie,G.key,G)}}function o(ie,se,oe){return se&&e(ie.prototype,se),oe&&e(ie,oe),Object.defineProperty(ie,"prototype",{writable:!1}),ie}function R(ie,se){if(ie){if(typeof ie=="string")return I(ie,se);var oe=Object.prototype.toString.call(ie).slice(8,-1);if(oe==="Object"&&ie.constructor&&(oe=ie.constructor.name),oe==="Map"||oe==="Set")return Array.from(ie);if(oe==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(oe))return I(ie,se)}}function I(ie,se){(se==null||se>ie.length)&&(se=ie.length);for(var oe=0,G=new Array(se);oe<se;oe++)G[oe]=ie[oe];return G}function M(ie,se){var oe=typeof Symbol<"u"&&ie[Symbol.iterator]||ie["@@iterator"];if(oe)return(oe=oe.call(ie)).next.bind(oe);if(Array.isArray(ie)||(oe=R(ie))||se&&ie&&typeof ie.length=="number"){oe&&(ie=oe);var G=0;return function(){return G>=ie.length?{done:!0}:{done:!1,value:ie[G++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function O(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}re.defaults=O();function p(ie){re.defaults=ie}var $=/[&<>"']/,w=/[&<>"']/g,A=/[<>"']|&(?!#?\w+;)/,P=/[<>"']|&(?!#?\w+;)/g,b={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},C=function(se){return b[se]};function y(ie,se){if(se){if($.test(ie))return ie.replace(w,C)}else if(A.test(ie))return ie.replace(P,C);return ie}var a=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function m(ie){return ie.replace(a,function(se,oe){return oe=oe.toLowerCase(),oe==="colon"?":":oe.charAt(0)==="#"?oe.charAt(1)==="x"?String.fromCharCode(parseInt(oe.substring(2),16)):String.fromCharCode(+oe.substring(1)):""})}var l=/(^|[^\[])\^/g;function i(ie,se){ie=typeof ie=="string"?ie:ie.source,se=se||"";var oe={replace:function(ee,le){return le=le.source||le,le=le.replace(l,"$1"),ie=ie.replace(ee,le),oe},getRegex:function(){return new RegExp(ie,se)}};return oe}var n=/[^\w:]/g,r=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function s(ie,se,oe){if(ie){var G;try{G=decodeURIComponent(m(oe)).replace(n,"").toLowerCase()}catch{return null}if(G.indexOf("javascript:")===0||G.indexOf("vbscript:")===0||G.indexOf("data:")===0)return null}se&&!r.test(oe)&&(oe=c(se,oe));try{oe=encodeURI(oe).replace(/%25/g,"%")}catch{return null}return oe}var t={},g=/^[^:]+:\/*[^/]*$/,d=/^([^:]+:)[\s\S]*$/,h=/^([^:]+:\/*[^/]*)[\s\S]*$/;function c(ie,se){t[" "+ie]||(g.test(ie)?t[" "+ie]=ie+"/":t[" "+ie]=v(ie,"/",!0)),ie=t[" "+ie];var oe=ie.indexOf(":")===-1;return se.substring(0,2)==="//"?oe?se:ie.replace(d,"$1")+se:se.charAt(0)==="/"?oe?se:ie.replace(h,"$1")+se:ie+se}var u={exec:function(){}};function f(ie){for(var se=1,oe,G;se<arguments.length;se++){oe=arguments[se];for(G in oe)Object.prototype.hasOwnProperty.call(oe,G)&&(ie[G]=oe[G])}return ie}function E(ie,se){var oe=ie.replace(/\|/g,function(le,de,Me){for(var be=!1,Pe=de;--Pe>=0&&Me[Pe]==="\\";)be=!be;return be?"|":" |"}),G=oe.split(/ \|/),ee=0;if(G[0].trim()||G.shift(),G.length>0&&!G[G.length-1].trim()&&G.pop(),G.length>se)G.splice(se);else for(;G.length<se;)G.push("");for(;ee<G.length;ee++)G[ee]=G[ee].trim().replace(/\\\|/g,"|");return G}function v(ie,se,oe){var G=ie.length;if(G===0)return"";for(var ee=0;ee<G;){var le=ie.charAt(G-ee-1);if(le===se&&!oe)ee++;else if(le!==se&&oe)ee++;else break}return ie.slice(0,G-ee)}function D(ie,se){if(ie.indexOf(se[1])===-1)return-1;for(var oe=ie.length,G=0,ee=0;ee<oe;ee++)if(ie[ee]==="\\")ee++;else if(ie[ee]===se[0])G++;else if(ie[ee]===se[1]&&(G--,G<0))return ee;return-1}function k(ie){ie&&ie.sanitize&&!ie.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function S(ie,se){if(se<1)return"";for(var oe="";se>1;)se&1&&(oe+=ie),se>>=1,ie+=ie;return oe+ie}function F(ie,se,oe,G){var ee=se.href,le=se.title?y(se.title):null,de=ie[1].replace(/\\([\[\]])/g,"$1");if(ie[0].charAt(0)!=="!"){G.state.inLink=!0;var Me={type:"link",raw:oe,href:ee,title:le,text:de,tokens:G.inlineTokens(de)};return G.state.inLink=!1,Me}return{type:"image",raw:oe,href:ee,title:le,text:y(de)}}function W(ie,se){var oe=ie.match(/^(\s+)(?:```)/);if(oe===null)return se;var G=oe[1];return se.split(`
`).map(function(ee){var le=ee.match(/^\s+/);if(le===null)return ee;var de=le[0];return de.length>=G.length?ee.slice(G.length):ee}).join(`
`)}var B=function(){function ie(oe){this.options=oe||re.defaults}var se=ie.prototype;return se.space=function(G){var ee=this.rules.block.newline.exec(G);if(ee&&ee[0].length>0)return{type:"space",raw:ee[0]}},se.code=function(G){var ee=this.rules.block.code.exec(G);if(ee){var le=ee[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ee[0],codeBlockStyle:"indented",text:this.options.pedantic?le:v(le,`
`)}}},se.fences=function(G){var ee=this.rules.block.fences.exec(G);if(ee){var le=ee[0],de=W(le,ee[3]||"");return{type:"code",raw:le,lang:ee[2]?ee[2].trim():ee[2],text:de}}},se.heading=function(G){var ee=this.rules.block.heading.exec(G);if(ee){var le=ee[2].trim();if(/#$/.test(le)){var de=v(le,"#");(this.options.pedantic||!de||/ $/.test(de))&&(le=de.trim())}return{type:"heading",raw:ee[0],depth:ee[1].length,text:le,tokens:this.lexer.inline(le)}}},se.hr=function(G){var ee=this.rules.block.hr.exec(G);if(ee)return{type:"hr",raw:ee[0]}},se.blockquote=function(G){var ee=this.rules.block.blockquote.exec(G);if(ee){var le=ee[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ee[0],tokens:this.lexer.blockTokens(le,[]),text:le}}},se.list=function(G){var ee=this.rules.block.list.exec(G);if(ee){var le,de,Me,be,Pe,Re,ze,V,H,Z,X,fe,we=ee[1].trim(),Te=we.length>1,Ve={type:"list",raw:"",ordered:Te,start:Te?+we.slice(0,-1):"",loose:!1,items:[]};we=Te?"\\d{1,9}\\"+we.slice(-1):"\\"+we,this.options.pedantic&&(we=Te?we:"[*+-]");for(var Ze=new RegExp("^( {0,3}"+we+")((?:[	 ][^\\n]*)?(?:\\n|$))");G&&(fe=!1,!(!(ee=Ze.exec(G))||this.rules.block.hr.test(G)));){if(le=ee[0],G=G.substring(le.length),V=ee[2].split(`
`,1)[0],H=G.split(`
`,1)[0],this.options.pedantic?(be=2,X=V.trimLeft()):(be=ee[2].search(/[^ ]/),be=be>4?1:be,X=V.slice(be),be+=ee[1].length),Re=!1,!V&&/^ *$/.test(H)&&(le+=H+`
`,G=G.substring(H.length+1),fe=!0),!fe)for(var nt=new RegExp("^ {0,"+Math.min(3,be-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),ot=new RegExp("^ {0,"+Math.min(3,be-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),lt=new RegExp("^ {0,"+Math.min(3,be-1)+"}(?:```|~~~)"),at=new RegExp("^ {0,"+Math.min(3,be-1)+"}#");G&&(Z=G.split(`
`,1)[0],V=Z,this.options.pedantic&&(V=V.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(lt.test(V)||at.test(V)||nt.test(V)||ot.test(G)));){if(V.search(/[^ ]/)>=be||!V.trim())X+=`
`+V.slice(be);else if(!Re)X+=`
`+V;else break;!Re&&!V.trim()&&(Re=!0),le+=Z+`
`,G=G.substring(Z.length+1)}Ve.loose||(ze?Ve.loose=!0:/\n *\n *$/.test(le)&&(ze=!0)),this.options.gfm&&(de=/^\[[ xX]\] /.exec(X),de&&(Me=de[0]!=="[ ] ",X=X.replace(/^\[[ xX]\] +/,""))),Ve.items.push({type:"list_item",raw:le,task:!!de,checked:Me,loose:!1,text:X}),Ve.raw+=le}Ve.items[Ve.items.length-1].raw=le.trimRight(),Ve.items[Ve.items.length-1].text=X.trimRight(),Ve.raw=Ve.raw.trimRight();var st=Ve.items.length;for(Pe=0;Pe<st;Pe++){this.lexer.state.top=!1,Ve.items[Pe].tokens=this.lexer.blockTokens(Ve.items[Pe].text,[]);var Ie=Ve.items[Pe].tokens.filter(function(Ae){return Ae.type==="space"}),We=Ie.every(function(Ae){for(var Ke=Ae.raw.split(""),ae=0,ue=M(Ke),De;!(De=ue()).done;){var Je=De.value;if(Je===`
`&&(ae+=1),ae>1)return!0}return!1});!Ve.loose&&Ie.length&&We&&(Ve.loose=!0,Ve.items[Pe].loose=!0)}return Ve}},se.html=function(G){var ee=this.rules.block.html.exec(G);if(ee){var le={type:"html",raw:ee[0],pre:!this.options.sanitizer&&(ee[1]==="pre"||ee[1]==="script"||ee[1]==="style"),text:ee[0]};if(this.options.sanitize){var de=this.options.sanitizer?this.options.sanitizer(ee[0]):y(ee[0]);le.type="paragraph",le.text=de,le.tokens=this.lexer.inline(de)}return le}},se.def=function(G){var ee=this.rules.block.def.exec(G);if(ee){ee[3]&&(ee[3]=ee[3].substring(1,ee[3].length-1));var le=ee[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:le,raw:ee[0],href:ee[2],title:ee[3]}}},se.table=function(G){var ee=this.rules.block.table.exec(G);if(ee){var le={type:"table",header:E(ee[1]).map(function(ze){return{text:ze}}),align:ee[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ee[3]&&ee[3].trim()?ee[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(le.header.length===le.align.length){le.raw=ee[0];var de=le.align.length,Me,be,Pe,Re;for(Me=0;Me<de;Me++)/^ *-+: *$/.test(le.align[Me])?le.align[Me]="right":/^ *:-+: *$/.test(le.align[Me])?le.align[Me]="center":/^ *:-+ *$/.test(le.align[Me])?le.align[Me]="left":le.align[Me]=null;for(de=le.rows.length,Me=0;Me<de;Me++)le.rows[Me]=E(le.rows[Me],le.header.length).map(function(ze){return{text:ze}});for(de=le.header.length,be=0;be<de;be++)le.header[be].tokens=this.lexer.inline(le.header[be].text);for(de=le.rows.length,be=0;be<de;be++)for(Re=le.rows[be],Pe=0;Pe<Re.length;Pe++)Re[Pe].tokens=this.lexer.inline(Re[Pe].text);return le}}},se.lheading=function(G){var ee=this.rules.block.lheading.exec(G);if(ee)return{type:"heading",raw:ee[0],depth:ee[2].charAt(0)==="="?1:2,text:ee[1],tokens:this.lexer.inline(ee[1])}},se.paragraph=function(G){var ee=this.rules.block.paragraph.exec(G);if(ee){var le=ee[1].charAt(ee[1].length-1)===`
`?ee[1].slice(0,-1):ee[1];return{type:"paragraph",raw:ee[0],text:le,tokens:this.lexer.inline(le)}}},se.text=function(G){var ee=this.rules.block.text.exec(G);if(ee)return{type:"text",raw:ee[0],text:ee[0],tokens:this.lexer.inline(ee[0])}},se.escape=function(G){var ee=this.rules.inline.escape.exec(G);if(ee)return{type:"escape",raw:ee[0],text:y(ee[1])}},se.tag=function(G){var ee=this.rules.inline.tag.exec(G);if(ee)return!this.lexer.state.inLink&&/^<a /i.test(ee[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ee[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ee[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ee[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ee[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ee[0]):y(ee[0]):ee[0]}},se.link=function(G){var ee=this.rules.inline.link.exec(G);if(ee){var le=ee[2].trim();if(!this.options.pedantic&&/^</.test(le)){if(!/>$/.test(le))return;var de=v(le.slice(0,-1),"\\");if((le.length-de.length)%2===0)return}else{var Me=D(ee[2],"()");if(Me>-1){var be=ee[0].indexOf("!")===0?5:4,Pe=be+ee[1].length+Me;ee[2]=ee[2].substring(0,Me),ee[0]=ee[0].substring(0,Pe).trim(),ee[3]=""}}var Re=ee[2],ze="";if(this.options.pedantic){var V=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Re);V&&(Re=V[1],ze=V[3])}else ze=ee[3]?ee[3].slice(1,-1):"";return Re=Re.trim(),/^</.test(Re)&&(this.options.pedantic&&!/>$/.test(le)?Re=Re.slice(1):Re=Re.slice(1,-1)),F(ee,{href:Re&&Re.replace(this.rules.inline._escapes,"$1"),title:ze&&ze.replace(this.rules.inline._escapes,"$1")},ee[0],this.lexer)}},se.reflink=function(G,ee){var le;if((le=this.rules.inline.reflink.exec(G))||(le=this.rules.inline.nolink.exec(G))){var de=(le[2]||le[1]).replace(/\s+/g," ");if(de=ee[de.toLowerCase()],!de||!de.href){var Me=le[0].charAt(0);return{type:"text",raw:Me,text:Me}}return F(le,de,le[0],this.lexer)}},se.emStrong=function(G,ee,le){le===void 0&&(le="");var de=this.rules.inline.emStrong.lDelim.exec(G);if(de&&!(de[3]&&le.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Me=de[1]||de[2]||"";if(!Me||Me&&(le===""||this.rules.inline.punctuation.exec(le))){var be=de[0].length-1,Pe,Re,ze=be,V=0,H=de[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(H.lastIndex=0,ee=ee.slice(-1*G.length+be);(de=H.exec(ee))!=null;)if(Pe=de[1]||de[2]||de[3]||de[4]||de[5]||de[6],!!Pe){if(Re=Pe.length,de[3]||de[4]){ze+=Re;continue}else if((de[5]||de[6])&&be%3&&!((be+Re)%3)){V+=Re;continue}if(ze-=Re,!(ze>0)){if(Re=Math.min(Re,Re+ze+V),Math.min(be,Re)%2){var Z=G.slice(1,be+de.index+Re);return{type:"em",raw:G.slice(0,be+de.index+Re+1),text:Z,tokens:this.lexer.inlineTokens(Z)}}var X=G.slice(2,be+de.index+Re-1);return{type:"strong",raw:G.slice(0,be+de.index+Re+1),text:X,tokens:this.lexer.inlineTokens(X)}}}}}},se.codespan=function(G){var ee=this.rules.inline.code.exec(G);if(ee){var le=ee[2].replace(/\n/g," "),de=/[^ ]/.test(le),Me=/^ /.test(le)&&/ $/.test(le);return de&&Me&&(le=le.substring(1,le.length-1)),le=y(le,!0),{type:"codespan",raw:ee[0],text:le}}},se.br=function(G){var ee=this.rules.inline.br.exec(G);if(ee)return{type:"br",raw:ee[0]}},se.del=function(G){var ee=this.rules.inline.del.exec(G);if(ee)return{type:"del",raw:ee[0],text:ee[2],tokens:this.lexer.inlineTokens(ee[2])}},se.autolink=function(G,ee){var le=this.rules.inline.autolink.exec(G);if(le){var de,Me;return le[2]==="@"?(de=y(this.options.mangle?ee(le[1]):le[1]),Me="mailto:"+de):(de=y(le[1]),Me=de),{type:"link",raw:le[0],text:de,href:Me,tokens:[{type:"text",raw:de,text:de}]}}},se.url=function(G,ee){var le;if(le=this.rules.inline.url.exec(G)){var de,Me;if(le[2]==="@")de=y(this.options.mangle?ee(le[0]):le[0]),Me="mailto:"+de;else{var be;do be=le[0],le[0]=this.rules.inline._backpedal.exec(le[0])[0];while(be!==le[0]);de=y(le[0]),le[1]==="www."?Me="http://"+de:Me=de}return{type:"link",raw:le[0],text:de,href:Me,tokens:[{type:"text",raw:de,text:de}]}}},se.inlineText=function(G,ee){var le=this.rules.inline.text.exec(G);if(le){var de;return this.lexer.state.inRawBlock?de=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(le[0]):y(le[0]):le[0]:de=y(this.options.smartypants?ee(le[0]):le[0]),{type:"text",raw:le[0],text:de}}},ie}(),T={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:u,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};T._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,T._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,T.def=i(T.def).replace("label",T._label).replace("title",T._title).getRegex(),T.bullet=/(?:[*+-]|\d{1,9}[.)])/,T.listItemStart=i(/^( *)(bull) */).replace("bull",T.bullet).getRegex(),T.list=i(T.list).replace(/bull/g,T.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+T.def.source+")").getRegex(),T._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",T._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,T.html=i(T.html,"i").replace("comment",T._comment).replace("tag",T._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),T.paragraph=i(T._paragraph).replace("hr",T.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",T._tag).getRegex(),T.blockquote=i(T.blockquote).replace("paragraph",T.paragraph).getRegex(),T.normal=f({},T),T.gfm=f({},T.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),T.gfm.table=i(T.gfm.table).replace("hr",T.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",T._tag).getRegex(),T.gfm.paragraph=i(T._paragraph).replace("hr",T.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",T.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",T._tag).getRegex(),T.pedantic=f({},T.normal,{html:i(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",T._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:u,paragraph:i(T.normal._paragraph).replace("hr",T.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",T.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var N={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:u,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:u,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};N._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",N.punctuation=i(N.punctuation).replace(/punctuation/g,N._punctuation).getRegex(),N.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,N.escapedEmSt=/\\\*|\\_/g,N._comment=i(T._comment).replace("(?:-->|$)","-->").getRegex(),N.emStrong.lDelim=i(N.emStrong.lDelim).replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimAst=i(N.emStrong.rDelimAst,"g").replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimUnd=i(N.emStrong.rDelimUnd,"g").replace(/punct/g,N._punctuation).getRegex(),N._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,N._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,N._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,N.autolink=i(N.autolink).replace("scheme",N._scheme).replace("email",N._email).getRegex(),N._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,N.tag=i(N.tag).replace("comment",N._comment).replace("attribute",N._attribute).getRegex(),N._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,N._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,N._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,N.link=i(N.link).replace("label",N._label).replace("href",N._href).replace("title",N._title).getRegex(),N.reflink=i(N.reflink).replace("label",N._label).replace("ref",T._label).getRegex(),N.nolink=i(N.nolink).replace("ref",T._label).getRegex(),N.reflinkSearch=i(N.reflinkSearch,"g").replace("reflink",N.reflink).replace("nolink",N.nolink).getRegex(),N.normal=f({},N),N.pedantic=f({},N.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:i(/^!?\[(label)\]\((.*?)\)/).replace("label",N._label).getRegex(),reflink:i(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",N._label).getRegex()}),N.gfm=f({},N.normal,{escape:i(N.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),N.gfm.url=i(N.gfm.url,"i").replace("email",N.gfm._extended_email).getRegex(),N.breaks=f({},N.gfm,{br:i(N.br).replace("{2,}","*").getRegex(),text:i(N.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function j(ie){return ie.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function L(ie){var se="",oe,G,ee=ie.length;for(oe=0;oe<ee;oe++)G=ie.charCodeAt(oe),Math.random()>.5&&(G="x"+G.toString(16)),se+="&#"+G+";";return se}var z=function(){function ie(oe){this.tokens=[],this.tokens.links=Object.create(null),this.options=oe||re.defaults,this.options.tokenizer=this.options.tokenizer||new B,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var G={block:T.normal,inline:N.normal};this.options.pedantic?(G.block=T.pedantic,G.inline=N.pedantic):this.options.gfm&&(G.block=T.gfm,this.options.breaks?G.inline=N.breaks:G.inline=N.gfm),this.tokenizer.rules=G}ie.lex=function(G,ee){var le=new ie(ee);return le.lex(G)},ie.lexInline=function(G,ee){var le=new ie(ee);return le.inlineTokens(G)};var se=ie.prototype;return se.lex=function(G){G=G.replace(/\r\n|\r/g,`
`),this.blockTokens(G,this.tokens);for(var ee;ee=this.inlineQueue.shift();)this.inlineTokens(ee.src,ee.tokens);return this.tokens},se.blockTokens=function(G,ee){var le=this;ee===void 0&&(ee=[]),this.options.pedantic?G=G.replace(/\t/g,"    ").replace(/^ +$/gm,""):G=G.replace(/^( *)(\t+)/gm,function(ze,V,H){return V+"    ".repeat(H.length)});for(var de,Me,be,Pe;G;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(ze){return(de=ze.call({lexer:le},G,ee))?(G=G.substring(de.raw.length),ee.push(de),!0):!1}))){if(de=this.tokenizer.space(G)){G=G.substring(de.raw.length),de.raw.length===1&&ee.length>0?ee[ee.length-1].raw+=`
`:ee.push(de);continue}if(de=this.tokenizer.code(G)){G=G.substring(de.raw.length),Me=ee[ee.length-1],Me&&(Me.type==="paragraph"||Me.type==="text")?(Me.raw+=`
`+de.raw,Me.text+=`
`+de.text,this.inlineQueue[this.inlineQueue.length-1].src=Me.text):ee.push(de);continue}if(de=this.tokenizer.fences(G)){G=G.substring(de.raw.length),ee.push(de);continue}if(de=this.tokenizer.heading(G)){G=G.substring(de.raw.length),ee.push(de);continue}if(de=this.tokenizer.hr(G)){G=G.substring(de.raw.length),ee.push(de);continue}if(de=this.tokenizer.blockquote(G)){G=G.substring(de.raw.length),ee.push(de);continue}if(de=this.tokenizer.list(G)){G=G.substring(de.raw.length),ee.push(de);continue}if(de=this.tokenizer.html(G)){G=G.substring(de.raw.length),ee.push(de);continue}if(de=this.tokenizer.def(G)){G=G.substring(de.raw.length),Me=ee[ee.length-1],Me&&(Me.type==="paragraph"||Me.type==="text")?(Me.raw+=`
`+de.raw,Me.text+=`
`+de.raw,this.inlineQueue[this.inlineQueue.length-1].src=Me.text):this.tokens.links[de.tag]||(this.tokens.links[de.tag]={href:de.href,title:de.title});continue}if(de=this.tokenizer.table(G)){G=G.substring(de.raw.length),ee.push(de);continue}if(de=this.tokenizer.lheading(G)){G=G.substring(de.raw.length),ee.push(de);continue}if(be=G,this.options.extensions&&this.options.extensions.startBlock&&function(){var ze=1/0,V=G.slice(1),H=void 0;le.options.extensions.startBlock.forEach(function(Z){H=Z.call({lexer:this},V),typeof H=="number"&&H>=0&&(ze=Math.min(ze,H))}),ze<1/0&&ze>=0&&(be=G.substring(0,ze+1))}(),this.state.top&&(de=this.tokenizer.paragraph(be))){Me=ee[ee.length-1],Pe&&Me.type==="paragraph"?(Me.raw+=`
`+de.raw,Me.text+=`
`+de.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Me.text):ee.push(de),Pe=be.length!==G.length,G=G.substring(de.raw.length);continue}if(de=this.tokenizer.text(G)){G=G.substring(de.raw.length),Me=ee[ee.length-1],Me&&Me.type==="text"?(Me.raw+=`
`+de.raw,Me.text+=`
`+de.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Me.text):ee.push(de);continue}if(G){var Re="Infinite loop on byte: "+G.charCodeAt(0);if(this.options.silent){console.error(Re);break}else throw new Error(Re)}}return this.state.top=!0,ee},se.inline=function(G,ee){return ee===void 0&&(ee=[]),this.inlineQueue.push({src:G,tokens:ee}),ee},se.inlineTokens=function(G,ee){var le=this;ee===void 0&&(ee=[]);var de,Me,be,Pe=G,Re,ze,V;if(this.tokens.links){var H=Object.keys(this.tokens.links);if(H.length>0)for(;(Re=this.tokenizer.rules.inline.reflinkSearch.exec(Pe))!=null;)H.includes(Re[0].slice(Re[0].lastIndexOf("[")+1,-1))&&(Pe=Pe.slice(0,Re.index)+"["+S("a",Re[0].length-2)+"]"+Pe.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Re=this.tokenizer.rules.inline.blockSkip.exec(Pe))!=null;)Pe=Pe.slice(0,Re.index)+"["+S("a",Re[0].length-2)+"]"+Pe.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Re=this.tokenizer.rules.inline.escapedEmSt.exec(Pe))!=null;)Pe=Pe.slice(0,Re.index)+"++"+Pe.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;G;)if(ze||(V=""),ze=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(X){return(de=X.call({lexer:le},G,ee))?(G=G.substring(de.raw.length),ee.push(de),!0):!1}))){if(de=this.tokenizer.escape(G)){G=G.substring(de.raw.length),ee.push(de);continue}if(de=this.tokenizer.tag(G)){G=G.substring(de.raw.length),Me=ee[ee.length-1],Me&&de.type==="text"&&Me.type==="text"?(Me.raw+=de.raw,Me.text+=de.text):ee.push(de);continue}if(de=this.tokenizer.link(G)){G=G.substring(de.raw.length),ee.push(de);continue}if(de=this.tokenizer.reflink(G,this.tokens.links)){G=G.substring(de.raw.length),Me=ee[ee.length-1],Me&&de.type==="text"&&Me.type==="text"?(Me.raw+=de.raw,Me.text+=de.text):ee.push(de);continue}if(de=this.tokenizer.emStrong(G,Pe,V)){G=G.substring(de.raw.length),ee.push(de);continue}if(de=this.tokenizer.codespan(G)){G=G.substring(de.raw.length),ee.push(de);continue}if(de=this.tokenizer.br(G)){G=G.substring(de.raw.length),ee.push(de);continue}if(de=this.tokenizer.del(G)){G=G.substring(de.raw.length),ee.push(de);continue}if(de=this.tokenizer.autolink(G,L)){G=G.substring(de.raw.length),ee.push(de);continue}if(!this.state.inLink&&(de=this.tokenizer.url(G,L))){G=G.substring(de.raw.length),ee.push(de);continue}if(be=G,this.options.extensions&&this.options.extensions.startInline&&function(){var X=1/0,fe=G.slice(1),we=void 0;le.options.extensions.startInline.forEach(function(Te){we=Te.call({lexer:this},fe),typeof we=="number"&&we>=0&&(X=Math.min(X,we))}),X<1/0&&X>=0&&(be=G.substring(0,X+1))}(),de=this.tokenizer.inlineText(be,j)){G=G.substring(de.raw.length),de.raw.slice(-1)!=="_"&&(V=de.raw.slice(-1)),ze=!0,Me=ee[ee.length-1],Me&&Me.type==="text"?(Me.raw+=de.raw,Me.text+=de.text):ee.push(de);continue}if(G){var Z="Infinite loop on byte: "+G.charCodeAt(0);if(this.options.silent){console.error(Z);break}else throw new Error(Z)}}return ee},o(ie,null,[{key:"rules",get:function(){return{block:T,inline:N}}}]),ie}(),Q=function(){function ie(oe){this.options=oe||re.defaults}var se=ie.prototype;return se.code=function(G,ee,le){var de=(ee||"").match(/\S*/)[0];if(this.options.highlight){var Me=this.options.highlight(G,de);Me!=null&&Me!==G&&(le=!0,G=Me)}return G=G.replace(/\n$/,"")+`
`,de?'<pre><code class="'+this.options.langPrefix+y(de,!0)+'">'+(le?G:y(G,!0))+`</code></pre>
`:"<pre><code>"+(le?G:y(G,!0))+`</code></pre>
`},se.blockquote=function(G){return`<blockquote>
`+G+`</blockquote>
`},se.html=function(G){return G},se.heading=function(G,ee,le,de){if(this.options.headerIds){var Me=this.options.headerPrefix+de.slug(le);return"<h"+ee+' id="'+Me+'">'+G+"</h"+ee+`>
`}return"<h"+ee+">"+G+"</h"+ee+`>
`},se.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},se.list=function(G,ee,le){var de=ee?"ol":"ul",Me=ee&&le!==1?' start="'+le+'"':"";return"<"+de+Me+`>
`+G+"</"+de+`>
`},se.listitem=function(G){return"<li>"+G+`</li>
`},se.checkbox=function(G){return"<input "+(G?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},se.paragraph=function(G){return"<p>"+G+`</p>
`},se.table=function(G,ee){return ee&&(ee="<tbody>"+ee+"</tbody>"),`<table>
<thead>
`+G+`</thead>
`+ee+`</table>
`},se.tablerow=function(G){return`<tr>
`+G+`</tr>
`},se.tablecell=function(G,ee){var le=ee.header?"th":"td",de=ee.align?"<"+le+' align="'+ee.align+'">':"<"+le+">";return de+G+("</"+le+`>
`)},se.strong=function(G){return"<strong>"+G+"</strong>"},se.em=function(G){return"<em>"+G+"</em>"},se.codespan=function(G){return"<code>"+G+"</code>"},se.br=function(){return this.options.xhtml?"<br/>":"<br>"},se.del=function(G){return"<del>"+G+"</del>"},se.link=function(G,ee,le){if(G=s(this.options.sanitize,this.options.baseUrl,G),G===null)return le;var de='<a href="'+y(G)+'"';return ee&&(de+=' title="'+ee+'"'),de+=">"+le+"</a>",de},se.image=function(G,ee,le){if(G=s(this.options.sanitize,this.options.baseUrl,G),G===null)return le;var de='<img src="'+G+'" alt="'+le+'"';return ee&&(de+=' title="'+ee+'"'),de+=this.options.xhtml?"/>":">",de},se.text=function(G){return G},ie}(),Y=function(){function ie(){}var se=ie.prototype;return se.strong=function(G){return G},se.em=function(G){return G},se.codespan=function(G){return G},se.del=function(G){return G},se.html=function(G){return G},se.text=function(G){return G},se.link=function(G,ee,le){return""+le},se.image=function(G,ee,le){return""+le},se.br=function(){return""},ie}(),J=function(){function ie(){this.seen={}}var se=ie.prototype;return se.serialize=function(G){return G.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},se.getNextSafeSlug=function(G,ee){var le=G,de=0;if(this.seen.hasOwnProperty(le)){de=this.seen[G];do de++,le=G+"-"+de;while(this.seen.hasOwnProperty(le))}return ee||(this.seen[G]=de,this.seen[le]=0),le},se.slug=function(G,ee){ee===void 0&&(ee={});var le=this.serialize(G);return this.getNextSafeSlug(le,ee.dryrun)},ie}(),x=function(){function ie(oe){this.options=oe||re.defaults,this.options.renderer=this.options.renderer||new Q,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Y,this.slugger=new J}ie.parse=function(G,ee){var le=new ie(ee);return le.parse(G)},ie.parseInline=function(G,ee){var le=new ie(ee);return le.parseInline(G)};var se=ie.prototype;return se.parse=function(G,ee){ee===void 0&&(ee=!0);var le="",de,Me,be,Pe,Re,ze,V,H,Z,X,fe,we,Te,Ve,Ze,nt,ot,lt,at,st=G.length;for(de=0;de<st;de++){if(X=G[de],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[X.type]&&(at=this.options.extensions.renderers[X.type].call({parser:this},X),at!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(X.type))){le+=at||"";continue}switch(X.type){case"space":continue;case"hr":{le+=this.renderer.hr();continue}case"heading":{le+=this.renderer.heading(this.parseInline(X.tokens),X.depth,m(this.parseInline(X.tokens,this.textRenderer)),this.slugger);continue}case"code":{le+=this.renderer.code(X.text,X.lang,X.escaped);continue}case"table":{for(H="",V="",Pe=X.header.length,Me=0;Me<Pe;Me++)V+=this.renderer.tablecell(this.parseInline(X.header[Me].tokens),{header:!0,align:X.align[Me]});for(H+=this.renderer.tablerow(V),Z="",Pe=X.rows.length,Me=0;Me<Pe;Me++){for(ze=X.rows[Me],V="",Re=ze.length,be=0;be<Re;be++)V+=this.renderer.tablecell(this.parseInline(ze[be].tokens),{header:!1,align:X.align[be]});Z+=this.renderer.tablerow(V)}le+=this.renderer.table(H,Z);continue}case"blockquote":{Z=this.parse(X.tokens),le+=this.renderer.blockquote(Z);continue}case"list":{for(fe=X.ordered,we=X.start,Te=X.loose,Pe=X.items.length,Z="",Me=0;Me<Pe;Me++)Ze=X.items[Me],nt=Ze.checked,ot=Ze.task,Ve="",Ze.task&&(lt=this.renderer.checkbox(nt),Te?Ze.tokens.length>0&&Ze.tokens[0].type==="paragraph"?(Ze.tokens[0].text=lt+" "+Ze.tokens[0].text,Ze.tokens[0].tokens&&Ze.tokens[0].tokens.length>0&&Ze.tokens[0].tokens[0].type==="text"&&(Ze.tokens[0].tokens[0].text=lt+" "+Ze.tokens[0].tokens[0].text)):Ze.tokens.unshift({type:"text",text:lt}):Ve+=lt),Ve+=this.parse(Ze.tokens,Te),Z+=this.renderer.listitem(Ve,ot,nt);le+=this.renderer.list(Z,fe,we);continue}case"html":{le+=this.renderer.html(X.text);continue}case"paragraph":{le+=this.renderer.paragraph(this.parseInline(X.tokens));continue}case"text":{for(Z=X.tokens?this.parseInline(X.tokens):X.text;de+1<st&&G[de+1].type==="text";)X=G[++de],Z+=`
`+(X.tokens?this.parseInline(X.tokens):X.text);le+=ee?this.renderer.paragraph(Z):Z;continue}default:{var Ie='Token with "'+X.type+'" type was not found.';if(this.options.silent){console.error(Ie);return}else throw new Error(Ie)}}}return le},se.parseInline=function(G,ee){ee=ee||this.renderer;var le="",de,Me,be,Pe=G.length;for(de=0;de<Pe;de++){if(Me=G[de],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Me.type]&&(be=this.options.extensions.renderers[Me.type].call({parser:this},Me),be!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Me.type))){le+=be||"";continue}switch(Me.type){case"escape":{le+=ee.text(Me.text);break}case"html":{le+=ee.html(Me.text);break}case"link":{le+=ee.link(Me.href,Me.title,this.parseInline(Me.tokens,ee));break}case"image":{le+=ee.image(Me.href,Me.title,Me.text);break}case"strong":{le+=ee.strong(this.parseInline(Me.tokens,ee));break}case"em":{le+=ee.em(this.parseInline(Me.tokens,ee));break}case"codespan":{le+=ee.codespan(Me.text);break}case"br":{le+=ee.br();break}case"del":{le+=ee.del(this.parseInline(Me.tokens,ee));break}case"text":{le+=ee.text(Me.text);break}default:{var Re='Token with "'+Me.type+'" type was not found.';if(this.options.silent){console.error(Re);return}else throw new Error(Re)}}}return le},ie}();function ce(ie,se,oe){if(typeof ie>"u"||ie===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ie!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ie)+", string expected");if(typeof se=="function"&&(oe=se,se=null),se=f({},ce.defaults,se||{}),k(se),oe){var G=se.highlight,ee;try{ee=z.lex(ie,se)}catch(Pe){return oe(Pe)}var le=function(Re){var ze;if(!Re)try{se.walkTokens&&ce.walkTokens(ee,se.walkTokens),ze=x.parse(ee,se)}catch(V){Re=V}return se.highlight=G,Re?oe(Re):oe(null,ze)};if(!G||G.length<3||(delete se.highlight,!ee.length))return le();var de=0;ce.walkTokens(ee,function(Pe){Pe.type==="code"&&(de++,setTimeout(function(){G(Pe.text,Pe.lang,function(Re,ze){if(Re)return le(Re);ze!=null&&ze!==Pe.text&&(Pe.text=ze,Pe.escaped=!0),de--,de===0&&le()})},0))}),de===0&&le();return}function Me(Pe){if(Pe.message+=`
Please report this to https://github.com/markedjs/marked.`,se.silent)return"<p>An error occurred:</p><pre>"+y(Pe.message+"",!0)+"</pre>";throw Pe}try{var be=z.lex(ie,se);if(se.walkTokens){if(se.async)return Promise.all(ce.walkTokens(be,se.walkTokens)).then(function(){return x.parse(be,se)}).catch(Me);ce.walkTokens(be,se.walkTokens)}return x.parse(be,se)}catch(Pe){Me(Pe)}}ce.options=ce.setOptions=function(ie){return f(ce.defaults,ie),p(ce.defaults),ce},ce.getDefaults=O,ce.defaults=re.defaults,ce.use=function(){for(var ie=arguments.length,se=new Array(ie),oe=0;oe<ie;oe++)se[oe]=arguments[oe];var G=f.apply(void 0,[{}].concat(se)),ee=ce.defaults.extensions||{renderers:{},childTokens:{}},le;se.forEach(function(de){if(de.extensions&&(le=!0,de.extensions.forEach(function(be){if(!be.name)throw new Error("extension name required");if(be.renderer){var Pe=ee.renderers?ee.renderers[be.name]:null;Pe?ee.renderers[be.name]=function(){for(var Re=arguments.length,ze=new Array(Re),V=0;V<Re;V++)ze[V]=arguments[V];var H=be.renderer.apply(this,ze);return H===!1&&(H=Pe.apply(this,ze)),H}:ee.renderers[be.name]=be.renderer}if(be.tokenizer){if(!be.level||be.level!=="block"&&be.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ee[be.level]?ee[be.level].unshift(be.tokenizer):ee[be.level]=[be.tokenizer],be.start&&(be.level==="block"?ee.startBlock?ee.startBlock.push(be.start):ee.startBlock=[be.start]:be.level==="inline"&&(ee.startInline?ee.startInline.push(be.start):ee.startInline=[be.start]))}be.childTokens&&(ee.childTokens[be.name]=be.childTokens)})),de.renderer&&function(){var be=ce.defaults.renderer||new Q,Pe=function(V){var H=be[V];be[V]=function(){for(var Z=arguments.length,X=new Array(Z),fe=0;fe<Z;fe++)X[fe]=arguments[fe];var we=de.renderer[V].apply(be,X);return we===!1&&(we=H.apply(be,X)),we}};for(var Re in de.renderer)Pe(Re);G.renderer=be}(),de.tokenizer&&function(){var be=ce.defaults.tokenizer||new B,Pe=function(V){var H=be[V];be[V]=function(){for(var Z=arguments.length,X=new Array(Z),fe=0;fe<Z;fe++)X[fe]=arguments[fe];var we=de.tokenizer[V].apply(be,X);return we===!1&&(we=H.apply(be,X)),we}};for(var Re in de.tokenizer)Pe(Re);G.tokenizer=be}(),de.walkTokens){var Me=ce.defaults.walkTokens;G.walkTokens=function(be){var Pe=[];return Pe.push(de.walkTokens.call(this,be)),Me&&(Pe=Pe.concat(Me.call(this,be))),Pe}}le&&(G.extensions=ee),ce.setOptions(G)})},ce.walkTokens=function(ie,se){for(var oe=[],G=function(){var Me=le.value;switch(oe=oe.concat(se.call(ce,Me)),Me.type){case"table":{for(var be=M(Me.header),Pe;!(Pe=be()).done;){var Re=Pe.value;oe=oe.concat(ce.walkTokens(Re.tokens,se))}for(var ze=M(Me.rows),V;!(V=ze()).done;)for(var H=V.value,Z=M(H),X;!(X=Z()).done;){var fe=X.value;oe=oe.concat(ce.walkTokens(fe.tokens,se))}break}case"list":{oe=oe.concat(ce.walkTokens(Me.items,se));break}default:ce.defaults.extensions&&ce.defaults.extensions.childTokens&&ce.defaults.extensions.childTokens[Me.type]?ce.defaults.extensions.childTokens[Me.type].forEach(function(we){oe=oe.concat(ce.walkTokens(Me[we],se))}):Me.tokens&&(oe=oe.concat(ce.walkTokens(Me.tokens,se)))}},ee=M(ie),le;!(le=ee()).done;)G();return oe},ce.parseInline=function(ie,se){if(typeof ie>"u"||ie===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ie!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ie)+", string expected");se=f({},ce.defaults,se||{}),k(se);try{var oe=z.lexInline(ie,se);return se.walkTokens&&ce.walkTokens(oe,se.walkTokens),x.parseInline(oe,se)}catch(G){if(G.message+=`
Please report this to https://github.com/markedjs/marked.`,se.silent)return"<p>An error occurred:</p><pre>"+y(G.message+"",!0)+"</pre>";throw G}},ce.Parser=x,ce.parser=x.parse,ce.Renderer=Q,ce.TextRenderer=Y,ce.Lexer=z,ce.lexer=z.lex,ce.Tokenizer=B,ce.Slugger=J,ce.parse=ce;var te=ce.options,pe=ce.setOptions,ye=ce.use,_=ce.walkTokens,U=ce.parseInline,he=ce,Se=x.parse,me=z.lex;re.Lexer=z,re.Parser=x,re.Renderer=Q,re.Slugger=J,re.TextRenderer=Y,re.Tokenizer=B,re.getDefaults=O,re.lexer=me,re.marked=ce,re.options=te,re.parse=he,re.parseInline=U,re.parser=Se,re.setOptions=pe,re.use=ye,re.walkTokens=_,Object.defineProperty(re,"__esModule",{value:!0})}),define(Ee[167],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hk=o;function o(a){const m=M(a);if(m&&m.length>0)return new Uint32Array(m)}let R=0;const I=new Uint32Array(10);function M(a){if(R=0,O(a,P,4352),R>0||(O(a,b,4449),R>0)||(O(a,C,4520),R>0)||(O(a,y,12593),R))return I.subarray(0,R);if(a>=44032&&a<=55203){const m=a-44032,l=m%588,i=Math.floor(m/588),n=Math.floor(l/28),r=l%28-1;if(i<P.length?O(i,P,0):4352+i-12593<y.length&&O(4352+i,y,12593),n<b.length?O(n,b,0):4449+n-12593<y.length&&O(4449+n-12593,y,12593),r>=0&&(r<C.length?O(r,C,0):4520+r-12593<y.length&&O(4520+r-12593,y,12593)),R>0)return I.subarray(0,R)}}function O(a,m,l){a>=l&&a<l+m.length&&p(m[a-l])}function p(a){a!==0&&(I[R++]=a&255,a>>8&&(I[R++]=a>>8&255),a>>16&&(I[R++]=a>>16&255))}var $;(function(a){a[a.InitialConsonant=4352]="InitialConsonant",a[a.Vowel=4449]="Vowel",a[a.FinalConsonant=4520]="FinalConsonant",a[a.CompatibilityJamo=12593]="CompatibilityJamo"})($||($={}));var w;(function(a){a[a.NUL=0]="NUL",a[a.A=65]="A",a[a.B=66]="B",a[a.C=67]="C",a[a.D=68]="D",a[a.E=69]="E",a[a.F=70]="F",a[a.G=71]="G",a[a.H=72]="H",a[a.I=73]="I",a[a.J=74]="J",a[a.K=75]="K",a[a.L=76]="L",a[a.M=77]="M",a[a.N=78]="N",a[a.O=79]="O",a[a.P=80]="P",a[a.Q=81]="Q",a[a.R=82]="R",a[a.S=83]="S",a[a.T=84]="T",a[a.U=85]="U",a[a.V=86]="V",a[a.W=87]="W",a[a.X=88]="X",a[a.Y=89]="Y",a[a.Z=90]="Z",a[a.a=97]="a",a[a.b=98]="b",a[a.c=99]="c",a[a.d=100]="d",a[a.e=101]="e",a[a.f=102]="f",a[a.g=103]="g",a[a.h=104]="h",a[a.i=105]="i",a[a.j=106]="j",a[a.k=107]="k",a[a.l=108]="l",a[a.m=109]="m",a[a.n=110]="n",a[a.o=111]="o",a[a.p=112]="p",a[a.q=113]="q",a[a.r=114]="r",a[a.s=115]="s",a[a.t=116]="t",a[a.u=117]="u",a[a.v=118]="v",a[a.w=119]="w",a[a.x=120]="x",a[a.y=121]="y",a[a.z=122]="z"})(w||(w={}));var A;(function(a){a[a.fa=24934]="fa",a[a.fg=26470]="fg",a[a.fq=29030]="fq",a[a.fr=29286]="fr",a[a.ft=29798]="ft",a[a.fv=30310]="fv",a[a.fx=30822]="fx",a[a.hk=27496]="hk",a[a.hl=27752]="hl",a[a.ho=28520]="ho",a[a.ml=27757]="ml",a[a.nj=27246]="nj",a[a.nl=27758]="nl",a[a.np=28782]="np",a[a.qt=29809]="qt",a[a.rt=29810]="rt",a[a.sg=26483]="sg",a[a.sw=30579]="sw"})(A||(A={}));const P=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),b=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),C=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),y=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(Ee[76],Ce([1,0,27]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3l=void 0,e.$1l=I,e.$2l=O;const R=new o.$Ec(1e4);function I(w){return $(w,"NFC",R)}const M=new o.$Ec(1e4);function O(w){return $(w,"NFD",M)}const p=/[^\u0000-\u0080]/;function $(w,A,P){if(!w)return w;const b=P.get(w);if(b)return b;let C;return p.test(w)?C=w.normalize(A):C=w,P.set(w,C),C}e.$3l=function(){const w=/[\u0300-\u036f]/g;return function(A){return O(A).replace(w,"")}}()}),define(Ee[126],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=e.$rm=e.$qm=void 0,e.$om=o,e.rot=R;function o(p,$,w){return Math.min(Math.max(p,$),w)}function R(p,$){return($+p%$)%$}class I{constructor(){this.a=0}getNext(){return this.a++}}e.$qm=I;class M{constructor(){this.a=1,this.b=0}update($){return this.b=this.b+($-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$rm=M;class O{constructor($){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array($),this.c.fill(0,0,$)}update($){const w=this.c[this.d];return this.c[this.d]=$,this.d=(this.d+1)%this.c.length,this.e-=w,this.e+=$,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$sm=O}),function(){function re(I){const M=[];typeof I=="number"&&M.push("code/timeOrigin",I);function O($){M.push($,Date.now())}function p(){const $=[];for(let w=0;w<M.length;w+=2)$.push({name:M[w],startTime:M[w+1]});return $}return{mark:O,getMarks:p}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?re():{mark(I){performance.mark(I)},getMarks(){let I=performance.timeOrigin;typeof I!="number"&&(I=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(I)}];for(const O of performance.getEntriesByType("mark"))M.push({name:O.name,startTime:Math.round(I+O.startTime)});return M}};if(typeof process=="object"){const I=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return re(I)}else return console.trace("perf-util loaded in UNKNOWN environment"),re()}function o(I){return I.MonacoPerformanceMarks||(I.MonacoPerformanceMarks=e()),I.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return o(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=o(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=o(R))}(),define(Ee[11],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C=e.$B=e.$A=e.$z=e.$y=e.OS=e.OperatingSystem=e.$v=e.$u=e.$t=e.$s=e.$r=e.Language=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.$g=e.$f=e.$e=e.$d=e.$c=e.Platform=e.$a=void 0,e.$b=t,e.$x=f,e.$D=E,e.$a="en";let o=!1,R=!1,I=!1,M=!1,O=!1,p=!1,$=!1,w=!1,A=!1,P=!1,b,C=e.$a,y=e.$a,a,m;const l=globalThis;let i;typeof l.vscode<"u"&&typeof l.vscode.process<"u"?i=l.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(i=process);const n=typeof i?.versions?.electron=="string",r=n&&i?.type==="renderer";if(typeof i=="object"){o=i.platform==="win32",R=i.platform==="darwin",I=i.platform==="linux",M=I&&!!i.env.SNAP&&!!i.env.SNAP_REVISION,$=n,A=!!i.env.CI||!!i.env.BUILD_ARTIFACTSTAGINGDIRECTORY,b=e.$a,C=e.$a;const v=i.env.VSCODE_NLS_CONFIG;if(v)try{const D=JSON.parse(v),k=D.availableLanguages["*"];b=D.locale,y=D.osLocale,C=k||e.$a,a=D._translationsConfigFile}catch{}O=!0}else if(typeof navigator=="object"&&!r){m=navigator.userAgent,o=m.indexOf("Windows")>=0,R=m.indexOf("Macintosh")>=0,w=(m.indexOf("Macintosh")>=0||m.indexOf("iPad")>=0||m.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,I=m.indexOf("Linux")>=0,P=m?.indexOf("Mobi")>=0,p=!0,b=e.$a,C=b,y=navigator.language;const v=typeof document<"u"&&document.getElementById("vscode-remote-nls-configuration"),D=v&&v.getAttribute("data-settings");if(D)try{const k=JSON.parse(D),S=k.availableLanguages["*"];b=k.locale,y=k.osLocale,C=S||e.$a,a=k._translationsConfigFile}catch{}}else console.error("Unable to resolve platform.");var s;(function(v){v[v.Web=0]="Web",v[v.Mac=1]="Mac",v[v.Linux=2]="Linux",v[v.Windows=3]="Windows"})(s||(e.Platform=s={}));function t(v){switch(v){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let g=0;R?g=1:o?g=3:I&&(g=2),e.$c=o,e.$d=R,e.$e=I,e.$f=M,e.$g=O,e.$h=$,e.$i=p,e.$j=p&&typeof l.importScripts=="function",e.$k=e.$j?l.origin:void 0,e.$l=w,e.$m=P,e.$n=A,e.$o=g,e.$p=m,e.$q=C;var d;(function(v){function D(){return e.$q}v.value=D;function k(){return e.$q.length===2?e.$q==="en":e.$q.length>=3?e.$q[0]==="e"&&e.$q[1]==="n"&&e.$q[2]==="-":!1}v.isDefaultVariant=k;function S(){return e.$q==="en"}v.isDefault=S})(d||(e.Language=d={})),e.$r=b,e.$s=y,e.$t=a,e.$u=typeof l.postMessage=="function"&&!l.importScripts,e.$v=(()=>{if(e.$u){const v=[];l.addEventListener("message",k=>{if(k.data&&k.data.vscodeScheduleAsyncWork)for(let S=0,F=v.length;S<F;S++){const W=v[S];if(W.id===k.data.vscodeScheduleAsyncWork){v.splice(S,1),W.callback();return}}});let D=0;return k=>{const S=++D;v.push({id:S,callback:k}),l.postMessage({vscodeScheduleAsyncWork:S},"*")}}return v=>setTimeout(v)})();var h;(function(v){v[v.Windows=1]="Windows",v[v.Macintosh=2]="Macintosh",v[v.Linux=3]="Linux"})(h||(e.OperatingSystem=h={})),e.OS=R||w?2:o?1:3;let c=!0,u=!1;function f(){if(!u){u=!0;const v=new Uint8Array(2);v[0]=1,v[1]=2,c=new Uint16Array(v.buffer)[0]===513}return c}e.$y=!!(e.$p&&e.$p.indexOf("Chrome")>=0),e.$z=!!(e.$p&&e.$p.indexOf("Firefox")>=0),e.$A=!!(!e.$y&&e.$p&&e.$p.indexOf("Safari")>=0),e.$B=!!(e.$p&&e.$p.indexOf("Edg/")>=0),e.$C=!!(e.$p&&e.$p.indexOf("Android")>=0);function E(v){return parseFloat(v)>=20}}),define(Ee[168],Ce([1,0,39]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DO=void 0;const R=Symbol("unset");class I{constructor(){this.a=new O,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||o.Iterable.empty()}insert($,w,A){this.d($,P=>P._value=w,A)}mutate($,w){this.d($,A=>A._value=w(A._value===R?void 0:A._value))}delete($){const w=this.c($);if(!w)return;let A=w.length-1;const P=w[A].node._value;if(P!==R){for(this.b--,w[A].node._value=R;A>0;A--){const{node:b,part:C}=w[A];if(b.children?.size||b._value!==R)break;w[A-1].node.children.delete(C)}return P}}*deleteRecursive($){const w=this.c($);if(!w)return;const A=w[w.length-1].node;for(let P=w.length-1;P>0;P--){const b=w[P-1];if(b.node.children.delete(w[P].part),b.node.children.size>0||b.node._value!==R)break}for(const P of M(A))P._value!==R&&(this.b--,yield P._value)}find($){let w=this.a;for(const A of $){const P=w.children?.get(A);if(!P)return;w=P}return w._value===R?void 0:w._value}hasKeyOrParent($){let w=this.a;for(const A of $){const P=w.children?.get(A);if(!P)return!1;if(P._value!==R)return!0;w=P}return!1}hasKeyOrChildren($){let w=this.a;for(const A of $){const P=w.children?.get(A);if(!P)return!1;w=P}return!0}hasKey($){let w=this.a;for(const A of $){const P=w.children?.get(A);if(!P)return!1;w=P}return w._value!==R}c($){const w=[{part:"",node:this.a}];let A=0;for(const P of $){const b=w[A].node.children?.get(P);if(!b)return;w.push({part:P,node:b}),A++}return w}d($,w,A){let P=this.a;for(const y of $){if(P.children)if(P.children.has(y))P=P.children.get(y);else{const a=new O;P.children.set(y,a),P=a}else{const a=new O;P.children=new Map([[y,a]]),P=a}A?.(P)}const b=P._value===R?0:1;w(P);const C=P._value===R?0:1;this.b+=C-b}*values(){for(const{_value:$}of M(this.a))$!==R&&(yield $)}}e.$DO=I;function*M(p){const $=[p];for(;$.length>0;){const w=$.pop();if(yield w,w.children)for(const A of w.children.values())$.push(A)}}class O{constructor(){this._value=R}get value(){return this._value===R?void 0:this._value}set value($){this._value=$===void 0?R:$}}}),define(Ee[49],Ce([1,0,11]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fc=e.$ec=e.env=e.cwd=void 0;let R;const I=globalThis.vscode;if(typeof I<"u"&&typeof I.process<"u"){const M=I.process;R={get platform(){return M.platform},get arch(){return M.arch},get env(){return M.env},cwd(){return M.cwd()}}}else typeof process<"u"?R={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:R={get platform(){return o.$c?"win32":o.$d?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=R.cwd,e.env=R.env,e.$ec=R.platform,e.$fc=R.arch}),define(Ee[17],Ce([1,0,49]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uc=e.sep=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=void 0;const R=65,I=97,M=90,O=122,p=46,$=47,w=92,A=58,P=63;class b extends Error{constructor(g,d,h){let c;typeof d=="string"&&d.indexOf("not ")===0?(c="must not be",d=d.replace(/^not /,"")):c="must be";const u=g.indexOf(".")!==-1?"property":"argument";let f=`The "${g}" ${u} ${c} of type ${d}`;f+=`. Received type ${typeof h}`,super(f),this.code="ERR_INVALID_ARG_TYPE"}}function C(t,g){if(t===null||typeof t!="object")throw new b(g,"Object",t)}function y(t,g){if(typeof t!="string")throw new b(g,"string",t)}const a=o.$ec==="win32";function m(t){return t===$||t===w}function l(t){return t===$}function i(t){return t>=R&&t<=M||t>=I&&t<=O}function n(t,g,d,h){let c="",u=0,f=-1,E=0,v=0;for(let D=0;D<=t.length;++D){if(D<t.length)v=t.charCodeAt(D);else{if(h(v))break;v=$}if(h(v)){if(!(f===D-1||E===1))if(E===2){if(c.length<2||u!==2||c.charCodeAt(c.length-1)!==p||c.charCodeAt(c.length-2)!==p){if(c.length>2){const k=c.lastIndexOf(d);k===-1?(c="",u=0):(c=c.slice(0,k),u=c.length-1-c.lastIndexOf(d)),f=D,E=0;continue}else if(c.length!==0){c="",u=0,f=D,E=0;continue}}g&&(c+=c.length>0?`${d}..`:"..",u=2)}else c.length>0?c+=`${d}${t.slice(f+1,D)}`:c=t.slice(f+1,D),u=D-f-1;f=D,E=0}else v===p&&E!==-1?++E:E=-1}return c}function r(t,g){C(g,"pathObject");const d=g.dir||g.root,h=g.base||`${g.name||""}${g.ext||""}`;return d?d===g.root?`${d}${h}`:`${d}${t}${h}`:h}e.$gc={resolve(...t){let g="",d="",h=!1;for(let c=t.length-1;c>=-1;c--){let u;if(c>=0){if(u=t[c],y(u,"path"),u.length===0)continue}else g.length===0?u=o.cwd():(u=o.env[`=${g}`]||o.cwd(),(u===void 0||u.slice(0,2).toLowerCase()!==g.toLowerCase()&&u.charCodeAt(2)===w)&&(u=`${g}\\`));const f=u.length;let E=0,v="",D=!1;const k=u.charCodeAt(0);if(f===1)m(k)&&(E=1,D=!0);else if(m(k))if(D=!0,m(u.charCodeAt(1))){let S=2,F=S;for(;S<f&&!m(u.charCodeAt(S));)S++;if(S<f&&S!==F){const W=u.slice(F,S);for(F=S;S<f&&m(u.charCodeAt(S));)S++;if(S<f&&S!==F){for(F=S;S<f&&!m(u.charCodeAt(S));)S++;(S===f||S!==F)&&(v=`\\\\${W}\\${u.slice(F,S)}`,E=S)}}}else E=1;else i(k)&&u.charCodeAt(1)===A&&(v=u.slice(0,2),E=2,f>2&&m(u.charCodeAt(2))&&(D=!0,E=3));if(v.length>0)if(g.length>0){if(v.toLowerCase()!==g.toLowerCase())continue}else g=v;if(h){if(g.length>0)break}else if(d=`${u.slice(E)}\\${d}`,h=D,D&&g.length>0)break}return d=n(d,!h,"\\",m),h?`${g}\\${d}`:`${g}${d}`||"."},normalize(t){y(t,"path");const g=t.length;if(g===0)return".";let d=0,h,c=!1;const u=t.charCodeAt(0);if(g===1)return l(u)?"\\":t;if(m(u))if(c=!0,m(t.charCodeAt(1))){let E=2,v=E;for(;E<g&&!m(t.charCodeAt(E));)E++;if(E<g&&E!==v){const D=t.slice(v,E);for(v=E;E<g&&m(t.charCodeAt(E));)E++;if(E<g&&E!==v){for(v=E;E<g&&!m(t.charCodeAt(E));)E++;if(E===g)return`\\\\${D}\\${t.slice(v)}\\`;E!==v&&(h=`\\\\${D}\\${t.slice(v,E)}`,d=E)}}}else d=1;else i(u)&&t.charCodeAt(1)===A&&(h=t.slice(0,2),d=2,g>2&&m(t.charCodeAt(2))&&(c=!0,d=3));let f=d<g?n(t.slice(d),!c,"\\",m):"";return f.length===0&&!c&&(f="."),f.length>0&&m(t.charCodeAt(g-1))&&(f+="\\"),h===void 0?c?`\\${f}`:f:c?`${h}\\${f}`:`${h}${f}`},isAbsolute(t){y(t,"path");const g=t.length;if(g===0)return!1;const d=t.charCodeAt(0);return m(d)||g>2&&i(d)&&t.charCodeAt(1)===A&&m(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let g,d;for(let u=0;u<t.length;++u){const f=t[u];y(f,"path"),f.length>0&&(g===void 0?g=d=f:g+=`\\${f}`)}if(g===void 0)return".";let h=!0,c=0;if(typeof d=="string"&&m(d.charCodeAt(0))){++c;const u=d.length;u>1&&m(d.charCodeAt(1))&&(++c,u>2&&(m(d.charCodeAt(2))?++c:h=!1))}if(h){for(;c<g.length&&m(g.charCodeAt(c));)c++;c>=2&&(g=`\\${g.slice(c)}`)}return e.$gc.normalize(g)},relative(t,g){if(y(t,"from"),y(g,"to"),t===g)return"";const d=e.$gc.resolve(t),h=e.$gc.resolve(g);if(d===h||(t=d.toLowerCase(),g=h.toLowerCase(),t===g))return"";let c=0;for(;c<t.length&&t.charCodeAt(c)===w;)c++;let u=t.length;for(;u-1>c&&t.charCodeAt(u-1)===w;)u--;const f=u-c;let E=0;for(;E<g.length&&g.charCodeAt(E)===w;)E++;let v=g.length;for(;v-1>E&&g.charCodeAt(v-1)===w;)v--;const D=v-E,k=f<D?f:D;let S=-1,F=0;for(;F<k;F++){const B=t.charCodeAt(c+F);if(B!==g.charCodeAt(E+F))break;B===w&&(S=F)}if(F!==k){if(S===-1)return h}else{if(D>k){if(g.charCodeAt(E+F)===w)return h.slice(E+F+1);if(F===2)return h.slice(E+F)}f>k&&(t.charCodeAt(c+F)===w?S=F:F===2&&(S=3)),S===-1&&(S=0)}let W="";for(F=c+S+1;F<=u;++F)(F===u||t.charCodeAt(F)===w)&&(W+=W.length===0?"..":"\\..");return E+=S,W.length>0?`${W}${h.slice(E,v)}`:(h.charCodeAt(E)===w&&++E,h.slice(E,v))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const g=e.$gc.resolve(t);if(g.length<=2)return t;if(g.charCodeAt(0)===w){if(g.charCodeAt(1)===w){const d=g.charCodeAt(2);if(d!==P&&d!==p)return`\\\\?\\UNC\\${g.slice(2)}`}}else if(i(g.charCodeAt(0))&&g.charCodeAt(1)===A&&g.charCodeAt(2)===w)return`\\\\?\\${g}`;return t},dirname(t){y(t,"path");const g=t.length;if(g===0)return".";let d=-1,h=0;const c=t.charCodeAt(0);if(g===1)return m(c)?t:".";if(m(c)){if(d=h=1,m(t.charCodeAt(1))){let E=2,v=E;for(;E<g&&!m(t.charCodeAt(E));)E++;if(E<g&&E!==v){for(v=E;E<g&&m(t.charCodeAt(E));)E++;if(E<g&&E!==v){for(v=E;E<g&&!m(t.charCodeAt(E));)E++;if(E===g)return t;E!==v&&(d=h=E+1)}}}}else i(c)&&t.charCodeAt(1)===A&&(d=g>2&&m(t.charCodeAt(2))?3:2,h=d);let u=-1,f=!0;for(let E=g-1;E>=h;--E)if(m(t.charCodeAt(E))){if(!f){u=E;break}}else f=!1;if(u===-1){if(d===-1)return".";u=d}return t.slice(0,u)},basename(t,g){g!==void 0&&y(g,"ext"),y(t,"path");let d=0,h=-1,c=!0,u;if(t.length>=2&&i(t.charCodeAt(0))&&t.charCodeAt(1)===A&&(d=2),g!==void 0&&g.length>0&&g.length<=t.length){if(g===t)return"";let f=g.length-1,E=-1;for(u=t.length-1;u>=d;--u){const v=t.charCodeAt(u);if(m(v)){if(!c){d=u+1;break}}else E===-1&&(c=!1,E=u+1),f>=0&&(v===g.charCodeAt(f)?--f===-1&&(h=u):(f=-1,h=E))}return d===h?h=E:h===-1&&(h=t.length),t.slice(d,h)}for(u=t.length-1;u>=d;--u)if(m(t.charCodeAt(u))){if(!c){d=u+1;break}}else h===-1&&(c=!1,h=u+1);return h===-1?"":t.slice(d,h)},extname(t){y(t,"path");let g=0,d=-1,h=0,c=-1,u=!0,f=0;t.length>=2&&t.charCodeAt(1)===A&&i(t.charCodeAt(0))&&(g=h=2);for(let E=t.length-1;E>=g;--E){const v=t.charCodeAt(E);if(m(v)){if(!u){h=E+1;break}continue}c===-1&&(u=!1,c=E+1),v===p?d===-1?d=E:f!==1&&(f=1):d!==-1&&(f=-1)}return d===-1||c===-1||f===0||f===1&&d===c-1&&d===h+1?"":t.slice(d,c)},format:r.bind(null,"\\"),parse(t){y(t,"path");const g={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return g;const d=t.length;let h=0,c=t.charCodeAt(0);if(d===1)return m(c)?(g.root=g.dir=t,g):(g.base=g.name=t,g);if(m(c)){if(h=1,m(t.charCodeAt(1))){let S=2,F=S;for(;S<d&&!m(t.charCodeAt(S));)S++;if(S<d&&S!==F){for(F=S;S<d&&m(t.charCodeAt(S));)S++;if(S<d&&S!==F){for(F=S;S<d&&!m(t.charCodeAt(S));)S++;S===d?h=S:S!==F&&(h=S+1)}}}}else if(i(c)&&t.charCodeAt(1)===A){if(d<=2)return g.root=g.dir=t,g;if(h=2,m(t.charCodeAt(2))){if(d===3)return g.root=g.dir=t,g;h=3}}h>0&&(g.root=t.slice(0,h));let u=-1,f=h,E=-1,v=!0,D=t.length-1,k=0;for(;D>=h;--D){if(c=t.charCodeAt(D),m(c)){if(!v){f=D+1;break}continue}E===-1&&(v=!1,E=D+1),c===p?u===-1?u=D:k!==1&&(k=1):u!==-1&&(k=-1)}return E!==-1&&(u===-1||k===0||k===1&&u===E-1&&u===f+1?g.base=g.name=t.slice(f,E):(g.name=t.slice(f,u),g.base=t.slice(f,E),g.ext=t.slice(u,E))),f>0&&f!==h?g.dir=t.slice(0,f-1):g.dir=g.root,g},sep:"\\",delimiter:";",win32:null,posix:null};const s=(()=>{if(a){const t=/\\/g;return()=>{const g=o.cwd().replace(t,"/");return g.slice(g.indexOf("/"))}}return()=>o.cwd()})();e.$hc={resolve(...t){let g="",d=!1;for(let h=t.length-1;h>=-1&&!d;h--){const c=h>=0?t[h]:s();y(c,"path"),c.length!==0&&(g=`${c}/${g}`,d=c.charCodeAt(0)===$)}return g=n(g,!d,"/",l),d?`/${g}`:g.length>0?g:"."},normalize(t){if(y(t,"path"),t.length===0)return".";const g=t.charCodeAt(0)===$,d=t.charCodeAt(t.length-1)===$;return t=n(t,!g,"/",l),t.length===0?g?"/":d?"./":".":(d&&(t+="/"),g?`/${t}`:t)},isAbsolute(t){return y(t,"path"),t.length>0&&t.charCodeAt(0)===$},join(...t){if(t.length===0)return".";let g;for(let d=0;d<t.length;++d){const h=t[d];y(h,"path"),h.length>0&&(g===void 0?g=h:g+=`/${h}`)}return g===void 0?".":e.$hc.normalize(g)},relative(t,g){if(y(t,"from"),y(g,"to"),t===g||(t=e.$hc.resolve(t),g=e.$hc.resolve(g),t===g))return"";const d=1,h=t.length,c=h-d,u=1,f=g.length-u,E=c<f?c:f;let v=-1,D=0;for(;D<E;D++){const S=t.charCodeAt(d+D);if(S!==g.charCodeAt(u+D))break;S===$&&(v=D)}if(D===E)if(f>E){if(g.charCodeAt(u+D)===$)return g.slice(u+D+1);if(D===0)return g.slice(u+D)}else c>E&&(t.charCodeAt(d+D)===$?v=D:D===0&&(v=0));let k="";for(D=d+v+1;D<=h;++D)(D===h||t.charCodeAt(D)===$)&&(k+=k.length===0?"..":"/..");return`${k}${g.slice(u+v)}`},toNamespacedPath(t){return t},dirname(t){if(y(t,"path"),t.length===0)return".";const g=t.charCodeAt(0)===$;let d=-1,h=!0;for(let c=t.length-1;c>=1;--c)if(t.charCodeAt(c)===$){if(!h){d=c;break}}else h=!1;return d===-1?g?"/":".":g&&d===1?"//":t.slice(0,d)},basename(t,g){g!==void 0&&y(g,"ext"),y(t,"path");let d=0,h=-1,c=!0,u;if(g!==void 0&&g.length>0&&g.length<=t.length){if(g===t)return"";let f=g.length-1,E=-1;for(u=t.length-1;u>=0;--u){const v=t.charCodeAt(u);if(v===$){if(!c){d=u+1;break}}else E===-1&&(c=!1,E=u+1),f>=0&&(v===g.charCodeAt(f)?--f===-1&&(h=u):(f=-1,h=E))}return d===h?h=E:h===-1&&(h=t.length),t.slice(d,h)}for(u=t.length-1;u>=0;--u)if(t.charCodeAt(u)===$){if(!c){d=u+1;break}}else h===-1&&(c=!1,h=u+1);return h===-1?"":t.slice(d,h)},extname(t){y(t,"path");let g=-1,d=0,h=-1,c=!0,u=0;for(let f=t.length-1;f>=0;--f){const E=t.charCodeAt(f);if(E===$){if(!c){d=f+1;break}continue}h===-1&&(c=!1,h=f+1),E===p?g===-1?g=f:u!==1&&(u=1):g!==-1&&(u=-1)}return g===-1||h===-1||u===0||u===1&&g===h-1&&g===d+1?"":t.slice(g,h)},format:r.bind(null,"/"),parse(t){y(t,"path");const g={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return g;const d=t.charCodeAt(0)===$;let h;d?(g.root="/",h=1):h=0;let c=-1,u=0,f=-1,E=!0,v=t.length-1,D=0;for(;v>=h;--v){const k=t.charCodeAt(v);if(k===$){if(!E){u=v+1;break}continue}f===-1&&(E=!1,f=v+1),k===p?c===-1?c=v:D!==1&&(D=1):c!==-1&&(D=-1)}if(f!==-1){const k=u===0&&d?1:u;c===-1||D===0||D===1&&c===f-1&&c===u+1?g.base=g.name=t.slice(k,f):(g.name=t.slice(k,c),g.base=t.slice(k,f),g.ext=t.slice(c,f))}return u>0?g.dir=t.slice(0,u-1):d&&(g.dir="/"),g},sep:"/",delimiter:":",win32:null,posix:null},e.$hc.win32=e.$gc.win32=e.$gc,e.$hc.posix=e.$gc.posix=e.$hc,e.$ic=a?e.$gc.normalize:e.$hc.normalize,e.$jc=a?e.$gc.isAbsolute:e.$hc.isAbsolute,e.$kc=a?e.$gc.join:e.$hc.join,e.$lc=a?e.$gc.resolve:e.$hc.resolve,e.$mc=a?e.$gc.relative:e.$hc.relative,e.$nc=a?e.$gc.dirname:e.$hc.dirname,e.$oc=a?e.$gc.basename:e.$hc.basename,e.$pc=a?e.$gc.extname:e.$hc.extname,e.$qc=a?e.$gc.format:e.$hc.format,e.$rc=a?e.$gc.parse:e.$hc.parse,e.$sc=a?e.$gc.toNamespacedPath:e.$hc.toNamespacedPath,e.sep=a?e.$gc.sep:e.$hc.sep,e.$uc=a?e.$gc.delimiter:e.$hc.delimiter}),define(Ee[127],Ce([1,0,46,17]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4q=p,e.$5q=$,e.$6q=w,e.$7q=A,e.$8q=P,e.$9q=b,e.$0q=C,e.$$q=y,e.$_q=a,e.$ar=m,e.$br=c,e.$cr=u,e.$dr=f;const I=new o.$V(()=>{const E=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:E,collatorIsNumeric:E.resolvedOptions().numeric}}),M=new o.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),O=new o.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function p(E,v,D=!1){const k=E||"",S=v||"",F=I.value.collator.compare(k,S);return I.value.collatorIsNumeric&&F===0&&k!==S?k<S?-1:1:F}function $(E,v){const D=M.value.collator;return E=E||"",v=v||"",r(D,E,v)}function w(E,v){const D=M.value.collator;return E=E||"",v=v||"",d(E,v)||r(D,E,v)}function A(E,v){const D=M.value.collator;return E=E||"",v=v||"",g(E,v)||r(D,E,v)}function P(E,v){return E=E||"",v=v||"",E===v?0:E<v?-1:1}function b(E,v){const[D,k]=i(E),[S,F]=i(v);let W=I.value.collator.compare(k,F);if(W===0){if(I.value.collatorIsNumeric&&k!==F)return k<F?-1:1;if(W=I.value.collator.compare(D,S),I.value.collatorIsNumeric&&W===0&&D!==S)return D<S?-1:1}return W}function C(E,v){E=E||"",v=v||"";const D=n(E),k=n(v),S=M.value.collator,F=O.value.collator;return r(F,D,k)||r(S,E,v)}function y(E,v){E=E||"",v=v||"";const D=n(E),k=n(v),S=M.value.collator,F=O.value.collator;return r(F,D,k)||d(E,v)||r(S,E,v)}function a(E,v){E=E||"",v=v||"";const D=n(E),k=n(v),S=M.value.collator,F=O.value.collator;return r(F,D,k)||g(E,v)||r(S,E,v)}function m(E,v){E=E||"",v=v||"";const D=n(E).toLowerCase(),k=n(v).toLowerCase();return D!==k?D<k?-1:1:E!==v?E<v?-1:1:0}const l=/^(.*?)(\.([^.]*))?$/;function i(E,v=!1){const D=E?l.exec(E):[];let k=[D&&D[1]||"",D&&D[3]||""];return v&&(!k[0]&&k[1]||k[0]&&k[0].charAt(0)===".")&&(k=[k[0]+"."+k[1],""]),k}function n(E){const v=E?l.exec(E):[];return v&&v[1]&&v[1].charAt(0)!=="."&&v[3]||""}function r(E,v,D){const k=E.compare(v,D);return k!==0?k:v.length!==D.length?v.length<D.length?-1:1:0}function s(E){const v=E.charAt(0);return v.toLocaleUpperCase()!==v}function t(E){const v=E.charAt(0);return v.toLocaleLowerCase()!==v}function g(E,v){return s(E)&&t(v)?-1:t(E)&&s(v)?1:0}function d(E,v){return t(E)&&s(v)?-1:s(E)&&t(v)?1:0}function h(E,v,D=!1){return D||(E=E&&E.toLowerCase(),v=v&&v.toLowerCase()),E===v?0:E<v?-1:1}function c(E,v,D=!1){const k=E.split(R.sep),S=v.split(R.sep),F=k.length-1,W=S.length-1;let B,T;for(let N=0;;N++){if(B=F===N,T=W===N,B&&T)return p(k[N],S[N],D);if(B)return-1;if(T)return 1;const j=h(k[N],S[N],D);if(j!==0)return j}}function u(E,v,D){const k=E.toLowerCase(),S=v.toLowerCase(),F=f(E,v,D);if(F)return F;const W=k.endsWith(D),B=S.endsWith(D);if(W!==B)return W?-1:1;const T=p(k,S);return T!==0?T:k.localeCompare(S)}function f(E,v,D){const k=E.toLowerCase(),S=v.toLowerCase(),F=k.startsWith(D),W=S.startsWith(D);if(F!==W)return F?-1:1;if(F&&W){if(k.length<S.length)return-1;if(k.length>S.length)return 1}return 0}}),define(Ee[98],Ce([1,0,17]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$As=void 0,e.$Bs=M,e.$Cs=O,e.$Ds=p,e.$Es=w,e.$As=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const R={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},I={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function M(A){const P=(0,o.$pc)(A),b=R[P.toLowerCase()];return b!==void 0?b:O(A)}function O(A){const P=(0,o.$pc)(A);return I[P.toLowerCase()]}function p(A){for(const P in I)if(I[P]===A)return P}const $=/^(.+)\/(.+?)(;.+)?$/;function w(A,P){const b=$.exec(A);return b?`${b[1].toLowerCase()}/${b[2].toLowerCase()}${b[3]??""}`:P?void 0:A}}),define(Ee[99],Ce([1,0,11]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$_l=M,e.$am=O;var R;(function(p){p[p.stdout=0]="stdout",p[p.stderr=1]="stderr"})(R||(e.Source=R={}));var I;(function(p){p[p.Success=0]="Success",p[p.Unknown=1]="Unknown",p[p.AccessDenied=2]="AccessDenied",p[p.ProcessNotFound=3]="ProcessNotFound"})(I||(e.TerminateResponseCode=I={}));function M(p,...$){const w=$.reduce((b,C)=>(b[C]=!0,b),{}),A=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/,/^CODE_SERVER_.+$/,/^CS_.+$/];Object.keys(p).filter(b=>!w[b]).forEach(b=>{for(let C=0;C<A.length;C++)if(b.search(A[C])!==-1){delete p[b];break}})}function O(p){p&&(delete p.DEBUG,o.$d&&delete p.DYLD_LIBRARY_PATH,o.$e&&delete p.LD_PRELOAD)}}),function(re,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var o=e();for(var R in o)(typeof exports=="object"?exports:re)[R]=o[R]}}(typeof self<"u"?self:this,function(){return function(re){var e={};function o(R){if(e[R])return e[R].exports;var I=e[R]={i:R,l:!1,exports:{}};return re[R].call(I.exports,I,I.exports,o),I.l=!0,I.exports}return o.m=re,o.c=e,o.d=function(R,I,M){o.o(R,I)||Object.defineProperty(R,I,{enumerable:!0,get:M})},o.r=function(R){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(R,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(R,"__esModule",{value:!0})},o.t=function(R,I){if(1&I&&(R=o(R)),8&I||4&I&&typeof R=="object"&&R&&R.__esModule)return R;var M=Object.create(null);if(o.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:R}),2&I&&typeof R!="string")for(var O in R)o.d(M,O,function(p){return R[p]}.bind(null,O));return M},o.n=function(R){var I=R&&R.__esModule?function(){return R.default}:function(){return R};return o.d(I,"a",I),I},o.o=function(R,I){return Object.prototype.hasOwnProperty.call(R,I)},o.p="",o(o.s=0)}([function(re,e,o){(function(R){var I;e=re.exports=ye,I=typeof R=="object"&&R.env&&R.env.NODE_DEBUG&&/\bsemver\b/i.test(R.env.NODE_DEBUG)?function(){var H=Array.prototype.slice.call(arguments,0);H.unshift("SEMVER"),console.log.apply(console,H)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,O=Number.MAX_SAFE_INTEGER||9007199254740991,p=e.re=[],$=e.src=[],w=0,A=w++;$[A]="0|[1-9]\\d*";var P=w++;$[P]="[0-9]+";var b=w++;$[b]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var C=w++;$[C]="("+$[A]+")\\.("+$[A]+")\\.("+$[A]+")";var y=w++;$[y]="("+$[P]+")\\.("+$[P]+")\\.("+$[P]+")";var a=w++;$[a]="(?:"+$[A]+"|"+$[b]+")";var m=w++;$[m]="(?:"+$[P]+"|"+$[b]+")";var l=w++;$[l]="(?:-("+$[a]+"(?:\\."+$[a]+")*))";var i=w++;$[i]="(?:-?("+$[m]+"(?:\\."+$[m]+")*))";var n=w++;$[n]="[0-9A-Za-z-]+";var r=w++;$[r]="(?:\\+("+$[n]+"(?:\\."+$[n]+")*))";var s=w++,t="v?"+$[C]+$[l]+"?"+$[r]+"?";$[s]="^"+t+"$";var g="[v=\\s]*"+$[y]+$[i]+"?"+$[r]+"?",d=w++;$[d]="^"+g+"$";var h=w++;$[h]="((?:<|>)?=?)";var c=w++;$[c]=$[P]+"|x|X|\\*";var u=w++;$[u]=$[A]+"|x|X|\\*";var f=w++;$[f]="[v=\\s]*("+$[u]+")(?:\\.("+$[u]+")(?:\\.("+$[u]+")(?:"+$[l]+")?"+$[r]+"?)?)?";var E=w++;$[E]="[v=\\s]*("+$[c]+")(?:\\.("+$[c]+")(?:\\.("+$[c]+")(?:"+$[i]+")?"+$[r]+"?)?)?";var v=w++;$[v]="^"+$[h]+"\\s*"+$[f]+"$";var D=w++;$[D]="^"+$[h]+"\\s*"+$[E]+"$";var k=w++;$[k]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var S=w++;$[S]="(?:~>?)";var F=w++;$[F]="(\\s*)"+$[S]+"\\s+",p[F]=new RegExp($[F],"g");var W=w++;$[W]="^"+$[S]+$[f]+"$";var B=w++;$[B]="^"+$[S]+$[E]+"$";var T=w++;$[T]="(?:\\^)";var N=w++;$[N]="(\\s*)"+$[T]+"\\s+",p[N]=new RegExp($[N],"g");var j=w++;$[j]="^"+$[T]+$[f]+"$";var L=w++;$[L]="^"+$[T]+$[E]+"$";var z=w++;$[z]="^"+$[h]+"\\s*("+g+")$|^$";var Q=w++;$[Q]="^"+$[h]+"\\s*("+t+")$|^$";var Y=w++;$[Y]="(\\s*)"+$[h]+"\\s*("+g+"|"+$[f]+")",p[Y]=new RegExp($[Y],"g");var J=w++;$[J]="^\\s*("+$[f]+")\\s+-\\s+("+$[f]+")\\s*$";var x=w++;$[x]="^\\s*("+$[E]+")\\s+-\\s+("+$[E]+")\\s*$";var ce=w++;$[ce]="(<|>)?=?\\s*\\*";for(var te=0;te<35;te++)I(te,$[te]),p[te]||(p[te]=new RegExp($[te]));function pe(H,Z){if(H instanceof ye)return H;if(typeof H!="string"||H.length>M||!(Z?p[d]:p[s]).test(H))return null;try{return new ye(H,Z)}catch{return null}}function ye(H,Z){if(H instanceof ye){if(H.loose===Z)return H;H=H.version}else if(typeof H!="string")throw new TypeError("Invalid Version: "+H);if(H.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof ye))return new ye(H,Z);I("SemVer",H,Z),this.loose=Z;var X=H.trim().match(Z?p[d]:p[s]);if(!X)throw new TypeError("Invalid Version: "+H);if(this.raw=H,this.major=+X[1],this.minor=+X[2],this.patch=+X[3],this.major>O||this.major<0)throw new TypeError("Invalid major version");if(this.minor>O||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>O||this.patch<0)throw new TypeError("Invalid patch version");X[4]?this.prerelease=X[4].split(".").map(function(fe){if(/^[0-9]+$/.test(fe)){var we=+fe;if(we>=0&&we<O)return we}return fe}):this.prerelease=[],this.build=X[5]?X[5].split("."):[],this.format()}e.parse=pe,e.valid=function(H,Z){var X=pe(H,Z);return X?X.version:null},e.clean=function(H,Z){var X=pe(H.trim().replace(/^[=v]+/,""),Z);return X?X.version:null},e.SemVer=ye,ye.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ye.prototype.toString=function(){return this.version},ye.prototype.compare=function(H){return I("SemVer.compare",this.version,this.loose,H),H instanceof ye||(H=new ye(H,this.loose)),this.compareMain(H)||this.comparePre(H)},ye.prototype.compareMain=function(H){return H instanceof ye||(H=new ye(H,this.loose)),U(this.major,H.major)||U(this.minor,H.minor)||U(this.patch,H.patch)},ye.prototype.comparePre=function(H){if(H instanceof ye||(H=new ye(H,this.loose)),this.prerelease.length&&!H.prerelease.length)return-1;if(!this.prerelease.length&&H.prerelease.length)return 1;if(!this.prerelease.length&&!H.prerelease.length)return 0;var Z=0;do{var X=this.prerelease[Z],fe=H.prerelease[Z];if(I("prerelease compare",Z,X,fe),X===void 0&&fe===void 0)return 0;if(fe===void 0)return 1;if(X===void 0)return-1;if(X!==fe)return U(X,fe)}while(++Z)},ye.prototype.inc=function(H,Z){switch(H){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Z);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Z);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Z),this.inc("pre",Z);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Z),this.inc("pre",Z);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var X=this.prerelease.length;--X>=0;)typeof this.prerelease[X]=="number"&&(this.prerelease[X]++,X=-2);X===-1&&this.prerelease.push(0)}Z&&(this.prerelease[0]===Z?isNaN(this.prerelease[1])&&(this.prerelease=[Z,0]):this.prerelease=[Z,0]);break;default:throw new Error("invalid increment argument: "+H)}return this.format(),this.raw=this.version,this},e.inc=function(H,Z,X,fe){typeof X=="string"&&(fe=X,X=void 0);try{return new ye(H,X).inc(Z,fe).version}catch{return null}},e.diff=function(H,Z){if(ie(H,Z))return null;var X=pe(H),fe=pe(Z);if(X.prerelease.length||fe.prerelease.length){for(var we in X)if((we==="major"||we==="minor"||we==="patch")&&X[we]!==fe[we])return"pre"+we;return"prerelease"}for(var we in X)if((we==="major"||we==="minor"||we==="patch")&&X[we]!==fe[we])return we},e.compareIdentifiers=U;var _=/^[0-9]+$/;function U(H,Z){var X=_.test(H),fe=_.test(Z);return X&&fe&&(H=+H,Z=+Z),X&&!fe?-1:fe&&!X?1:H<Z?-1:H>Z?1:0}function he(H,Z,X){return new ye(H,X).compare(new ye(Z,X))}function Se(H,Z,X){return he(H,Z,X)>0}function me(H,Z,X){return he(H,Z,X)<0}function ie(H,Z,X){return he(H,Z,X)===0}function se(H,Z,X){return he(H,Z,X)!==0}function oe(H,Z,X){return he(H,Z,X)>=0}function G(H,Z,X){return he(H,Z,X)<=0}function ee(H,Z,X,fe){var we;switch(Z){case"===":typeof H=="object"&&(H=H.version),typeof X=="object"&&(X=X.version),we=H===X;break;case"!==":typeof H=="object"&&(H=H.version),typeof X=="object"&&(X=X.version),we=H!==X;break;case"":case"=":case"==":we=ie(H,X,fe);break;case"!=":we=se(H,X,fe);break;case">":we=Se(H,X,fe);break;case">=":we=oe(H,X,fe);break;case"<":we=me(H,X,fe);break;case"<=":we=G(H,X,fe);break;default:throw new TypeError("Invalid operator: "+Z)}return we}function le(H,Z){if(H instanceof le){if(H.loose===Z)return H;H=H.value}if(!(this instanceof le))return new le(H,Z);I("comparator",H,Z),this.loose=Z,this.parse(H),this.semver===de?this.value="":this.value=this.operator+this.semver.version,I("comp",this)}e.rcompareIdentifiers=function(H,Z){return U(Z,H)},e.major=function(H,Z){return new ye(H,Z).major},e.minor=function(H,Z){return new ye(H,Z).minor},e.patch=function(H,Z){return new ye(H,Z).patch},e.compare=he,e.compareLoose=function(H,Z){return he(H,Z,!0)},e.rcompare=function(H,Z,X){return he(Z,H,X)},e.sort=function(H,Z){return H.sort(function(X,fe){return e.compare(X,fe,Z)})},e.rsort=function(H,Z){return H.sort(function(X,fe){return e.rcompare(X,fe,Z)})},e.gt=Se,e.lt=me,e.eq=ie,e.neq=se,e.gte=oe,e.lte=G,e.cmp=ee,e.Comparator=le;var de={};function Me(H,Z){if(H instanceof Me)return H.loose===Z?H:new Me(H.raw,Z);if(H instanceof le)return new Me(H.value,Z);if(!(this instanceof Me))return new Me(H,Z);if(this.loose=Z,this.raw=H,this.set=H.split(/\s*\|\|\s*/).map(function(X){return this.parseRange(X.trim())},this).filter(function(X){return X.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+H);this.format()}function be(H){return!H||H.toLowerCase()==="x"||H==="*"}function Pe(H,Z,X,fe,we,Te,Ve,Ze,nt,ot,lt,at,st){return((Z=be(X)?"":be(fe)?">="+X+".0.0":be(we)?">="+X+"."+fe+".0":">="+Z)+" "+(Ze=be(nt)?"":be(ot)?"<"+(+nt+1)+".0.0":be(lt)?"<"+nt+"."+(+ot+1)+".0":at?"<="+nt+"."+ot+"."+lt+"-"+at:"<="+Ze)).trim()}function Re(H,Z){for(var X=0;X<H.length;X++)if(!H[X].test(Z))return!1;if(Z.prerelease.length){for(X=0;X<H.length;X++)if(I(H[X].semver),H[X].semver!==de&&H[X].semver.prerelease.length>0){var fe=H[X].semver;if(fe.major===Z.major&&fe.minor===Z.minor&&fe.patch===Z.patch)return!0}return!1}return!0}function ze(H,Z,X){try{Z=new Me(Z,X)}catch{return!1}return Z.test(H)}function V(H,Z,X,fe){var we,Te,Ve,Ze,nt;switch(H=new ye(H,fe),Z=new Me(Z,fe),X){case">":we=Se,Te=G,Ve=me,Ze=">",nt=">=";break;case"<":we=me,Te=oe,Ve=Se,Ze="<",nt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ze(H,Z,fe))return!1;for(var ot=0;ot<Z.set.length;++ot){var lt=Z.set[ot],at=null,st=null;if(lt.forEach(function(Ie){Ie.semver===de&&(Ie=new le(">=0.0.0")),at=at||Ie,st=st||Ie,we(Ie.semver,at.semver,fe)?at=Ie:Ve(Ie.semver,st.semver,fe)&&(st=Ie)}),at.operator===Ze||at.operator===nt||(!st.operator||st.operator===Ze)&&Te(H,st.semver)||st.operator===nt&&Ve(H,st.semver))return!1}return!0}le.prototype.parse=function(H){var Z=this.loose?p[z]:p[Q],X=H.match(Z);if(!X)throw new TypeError("Invalid comparator: "+H);this.operator=X[1],this.operator==="="&&(this.operator=""),X[2]?this.semver=new ye(X[2],this.loose):this.semver=de},le.prototype.toString=function(){return this.value},le.prototype.test=function(H){return I("Comparator.test",H,this.loose),this.semver===de||(typeof H=="string"&&(H=new ye(H,this.loose)),ee(H,this.operator,this.semver,this.loose))},le.prototype.intersects=function(H,Z){if(!(H instanceof le))throw new TypeError("a Comparator is required");var X;if(this.operator==="")return X=new Me(H.value,Z),ze(this.value,X,Z);if(H.operator==="")return X=new Me(this.value,Z),ze(H.semver,X,Z);var fe=!(this.operator!==">="&&this.operator!==">"||H.operator!==">="&&H.operator!==">"),we=!(this.operator!=="<="&&this.operator!=="<"||H.operator!=="<="&&H.operator!=="<"),Te=this.semver.version===H.semver.version,Ve=!(this.operator!==">="&&this.operator!=="<="||H.operator!==">="&&H.operator!=="<="),Ze=ee(this.semver,"<",H.semver,Z)&&(this.operator===">="||this.operator===">")&&(H.operator==="<="||H.operator==="<"),nt=ee(this.semver,">",H.semver,Z)&&(this.operator==="<="||this.operator==="<")&&(H.operator===">="||H.operator===">");return fe||we||Te&&Ve||Ze||nt},e.Range=Me,Me.prototype.format=function(){return this.range=this.set.map(function(H){return H.join(" ").trim()}).join("||").trim(),this.range},Me.prototype.toString=function(){return this.range},Me.prototype.parseRange=function(H){var Z=this.loose;H=H.trim(),I("range",H,Z);var X=Z?p[x]:p[J];H=H.replace(X,Pe),I("hyphen replace",H),H=H.replace(p[Y],"$1$2$3"),I("comparator trim",H,p[Y]),H=(H=(H=H.replace(p[F],"$1~")).replace(p[N],"$1^")).split(/\s+/).join(" ");var fe=Z?p[z]:p[Q],we=H.split(" ").map(function(Te){return function(Ve,Ze){return I("comp",Ve),Ve=function(nt,ot){return nt.trim().split(/\s+/).map(function(lt){return function(at,st){I("caret",at,st);var Ie=st?p[L]:p[j];return at.replace(Ie,function(We,Ae,Ke,ae,ue){var De;return I("caret",at,We,Ae,Ke,ae,ue),be(Ae)?De="":be(Ke)?De=">="+Ae+".0.0 <"+(+Ae+1)+".0.0":be(ae)?De=Ae==="0"?">="+Ae+"."+Ke+".0 <"+Ae+"."+(+Ke+1)+".0":">="+Ae+"."+Ke+".0 <"+(+Ae+1)+".0.0":ue?(I("replaceCaret pr",ue),ue.charAt(0)!=="-"&&(ue="-"+ue),De=Ae==="0"?Ke==="0"?">="+Ae+"."+Ke+"."+ae+ue+" <"+Ae+"."+Ke+"."+(+ae+1):">="+Ae+"."+Ke+"."+ae+ue+" <"+Ae+"."+(+Ke+1)+".0":">="+Ae+"."+Ke+"."+ae+ue+" <"+(+Ae+1)+".0.0"):(I("no pr"),De=Ae==="0"?Ke==="0"?">="+Ae+"."+Ke+"."+ae+" <"+Ae+"."+Ke+"."+(+ae+1):">="+Ae+"."+Ke+"."+ae+" <"+Ae+"."+(+Ke+1)+".0":">="+Ae+"."+Ke+"."+ae+" <"+(+Ae+1)+".0.0"),I("caret return",De),De})}(lt,ot)}).join(" ")}(Ve,Ze),I("caret",Ve),Ve=function(nt,ot){return nt.trim().split(/\s+/).map(function(lt){return function(at,st){var Ie=st?p[B]:p[W];return at.replace(Ie,function(We,Ae,Ke,ae,ue){var De;return I("tilde",at,We,Ae,Ke,ae,ue),be(Ae)?De="":be(Ke)?De=">="+Ae+".0.0 <"+(+Ae+1)+".0.0":be(ae)?De=">="+Ae+"."+Ke+".0 <"+Ae+"."+(+Ke+1)+".0":ue?(I("replaceTilde pr",ue),ue.charAt(0)!=="-"&&(ue="-"+ue),De=">="+Ae+"."+Ke+"."+ae+ue+" <"+Ae+"."+(+Ke+1)+".0"):De=">="+Ae+"."+Ke+"."+ae+" <"+Ae+"."+(+Ke+1)+".0",I("tilde return",De),De})}(lt,ot)}).join(" ")}(Ve,Ze),I("tildes",Ve),Ve=function(nt,ot){return I("replaceXRanges",nt,ot),nt.split(/\s+/).map(function(lt){return function(at,st){at=at.trim();var Ie=st?p[D]:p[v];return at.replace(Ie,function(We,Ae,Ke,ae,ue,De){I("xRange",at,We,Ae,Ke,ae,ue,De);var Je=be(Ke),et=Je||be(ae),Ne=et||be(ue);return Ae==="="&&Ne&&(Ae=""),Je?We=Ae===">"||Ae==="<"?"<0.0.0":"*":Ae&&Ne?(et&&(ae=0),Ne&&(ue=0),Ae===">"?(Ae=">=",et?(Ke=+Ke+1,ae=0,ue=0):Ne&&(ae=+ae+1,ue=0)):Ae==="<="&&(Ae="<",et?Ke=+Ke+1:ae=+ae+1),We=Ae+Ke+"."+ae+"."+ue):et?We=">="+Ke+".0.0 <"+(+Ke+1)+".0.0":Ne&&(We=">="+Ke+"."+ae+".0 <"+Ke+"."+(+ae+1)+".0"),I("xRange return",We),We})}(lt,ot)}).join(" ")}(Ve,Ze),I("xrange",Ve),Ve=function(nt,ot){return I("replaceStars",nt,ot),nt.trim().replace(p[ce],"")}(Ve,Ze),I("stars",Ve),Ve}(Te,Z)}).join(" ").split(/\s+/);return this.loose&&(we=we.filter(function(Te){return!!Te.match(fe)})),we=we.map(function(Te){return new le(Te,Z)})},Me.prototype.intersects=function(H,Z){if(!(H instanceof Me))throw new TypeError("a Range is required");return this.set.some(function(X){return X.every(function(fe){return H.set.some(function(we){return we.every(function(Te){return fe.intersects(Te,Z)})})})})},e.toComparators=function(H,Z){return new Me(H,Z).set.map(function(X){return X.map(function(fe){return fe.value}).join(" ").trim().split(" ")})},Me.prototype.test=function(H){if(!H)return!1;typeof H=="string"&&(H=new ye(H,this.loose));for(var Z=0;Z<this.set.length;Z++)if(Re(this.set[Z],H))return!0;return!1},e.satisfies=ze,e.maxSatisfying=function(H,Z,X){var fe=null,we=null;try{var Te=new Me(Z,X)}catch{return null}return H.forEach(function(Ve){Te.test(Ve)&&(fe&&we.compare(Ve)!==-1||(we=new ye(fe=Ve,X)))}),fe},e.minSatisfying=function(H,Z,X){var fe=null,we=null;try{var Te=new Me(Z,X)}catch{return null}return H.forEach(function(Ve){Te.test(Ve)&&(fe&&we.compare(Ve)!==1||(we=new ye(fe=Ve,X)))}),fe},e.validRange=function(H,Z){try{return new Me(H,Z).range||"*"}catch{return null}},e.ltr=function(H,Z,X){return V(H,Z,"<",X)},e.gtr=function(H,Z,X){return V(H,Z,">",X)},e.outside=V,e.prerelease=function(H,Z){var X=pe(H,Z);return X&&X.prerelease.length?X.prerelease:null},e.intersects=function(H,Z,X){return H=new Me(H,X),Z=new Me(Z,X),H.intersects(Z)},e.coerce=function(H){if(H instanceof ye)return H;if(typeof H!="string")return null;var Z=H.match(p[k]);return Z==null?null:pe((Z[1]||"0")+"."+(Z[2]||"0")+"."+(Z[3]||"0"))}}).call(this,o(1))},function(re,e){var o,R,I=re.exports={};function M(){throw new Error("setTimeout has not been defined")}function O(){throw new Error("clearTimeout has not been defined")}function p(m){if(o===setTimeout)return setTimeout(m,0);if((o===M||!o)&&setTimeout)return o=setTimeout,setTimeout(m,0);try{return o(m,0)}catch{try{return o.call(null,m,0)}catch{return o.call(this,m,0)}}}(function(){try{o=typeof setTimeout=="function"?setTimeout:M}catch{o=M}try{R=typeof clearTimeout=="function"?clearTimeout:O}catch{R=O}})();var $,w=[],A=!1,P=-1;function b(){A&&$&&(A=!1,$.length?w=$.concat(w):P=-1,w.length&&C())}function C(){if(!A){var m=p(b);A=!0;for(var l=w.length;l;){for($=w,w=[];++P<l;)$&&$[P].run();P=-1,l=w.length}$=null,A=!1,function(i){if(R===clearTimeout)return clearTimeout(i);if((R===O||!R)&&clearTimeout)return R=clearTimeout,clearTimeout(i);try{R(i)}catch{try{return R.call(null,i)}catch{return R.call(this,i)}}}(m)}}function y(m,l){this.fun=m,this.array=l}function a(){}I.nextTick=function(m){var l=new Array(arguments.length-1);if(arguments.length>1)for(var i=1;i<arguments.length;i++)l[i-1]=arguments[i];w.push(new y(m,l)),w.length!==1||A||p(C)},y.prototype.run=function(){this.fun.apply(null,this.array)},I.title="browser",I.browser=!0,I.env={},I.argv=[],I.version="",I.versions={},I.on=a,I.addListener=a,I.once=a,I.off=a,I.removeListener=a,I.removeAllListeners=a,I.emit=a,I.prependListener=a,I.prependOnceListener=a,I.listeners=function(m){return[]},I.binding=function(m){throw new Error("process.binding is not supported")},I.cwd=function(){return"/"},I.chdir=function(m){throw new Error("process.chdir is not supported")},I.umask=function(){return 0}}])}),define(Ee[40],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3d=void 0;const o=globalThis.performance&&typeof globalThis.performance.now=="function";class R{static create(M){return new R(M)}constructor(M){this.c=o&&M===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$3d=R}),define(Ee[4],Ce([1,0,13,74,3,75,40]),function(re,e,o,R,I,M,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$5d=e.Event=void 0,e.$6d=C;const p=!1,$=!1,w=!1;var A;(function(k){k.None=()=>I.$Uc.None;function S(le){if(w){const{onDidAddListener:de}=le,Me=a.create();let be=0;le.onDidAddListener=()=>{++be===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Me.print()),de?.()}}}function F(le,de){return J(le,()=>{},0,void 0,!0,void 0,de)}k.defer=F;function W(le){return(de,Me=null,be)=>{let Pe=!1,Re;return Re=le(ze=>{if(!Pe)return Re?Re.dispose():Pe=!0,de.call(Me,ze)},null,be),Pe&&Re.dispose(),Re}}k.once=W;function B(le,de,Me){return Q((be,Pe=null,Re)=>le(ze=>be.call(Pe,de(ze)),null,Re),Me)}k.map=B;function T(le,de,Me){return Q((be,Pe=null,Re)=>le(ze=>{de(ze),be.call(Pe,ze)},null,Re),Me)}k.forEach=T;function N(le,de,Me){return Q((be,Pe=null,Re)=>le(ze=>de(ze)&&be.call(Pe,ze),null,Re),Me)}k.filter=N;function j(le){return le}k.signal=j;function L(...le){return(de,Me=null,be)=>{const Pe=(0,I.$Rc)(...le.map(Re=>Re(ze=>de.call(Me,ze))));return Y(Pe,be)}}k.any=L;function z(le,de,Me,be){let Pe=Me;return B(le,Re=>(Pe=de(Pe,Re),Pe),be)}k.reduce=z;function Q(le,de){let Me;const be={onWillAddFirstListener(){Me=le(Pe.fire,Pe)},onDidRemoveLastListener(){Me?.dispose()}};de||S(be);const Pe=new s(be);return de?.add(Pe),Pe.event}function Y(le,de){return de instanceof Array?de.push(le):de&&de.add(le),le}function J(le,de,Me=100,be=!1,Pe=!1,Re,ze){let V,H,Z,X=0,fe;const we={leakWarningThreshold:Re,onWillAddFirstListener(){V=le(Ve=>{X++,H=de(H,Ve),be&&!Z&&(Te.fire(H),H=void 0),fe=()=>{const Ze=H;H=void 0,Z=void 0,(!be||X>1)&&Te.fire(Ze),X=0},typeof Me=="number"?(clearTimeout(Z),Z=setTimeout(fe,Me)):Z===void 0&&(Z=0,queueMicrotask(fe))})},onWillRemoveListener(){Pe&&X>0&&fe?.()},onDidRemoveLastListener(){fe=void 0,V.dispose()}};ze||S(we);const Te=new s(we);return ze?.add(Te),Te.event}k.debounce=J;function x(le,de=0,Me){return k.debounce(le,(be,Pe)=>be?(be.push(Pe),be):[Pe],de,void 0,!0,void 0,Me)}k.accumulate=x;function ce(le,de=(be,Pe)=>be===Pe,Me){let be=!0,Pe;return N(le,Re=>{const ze=be||!de(Re,Pe);return be=!1,Pe=Re,ze},Me)}k.latch=ce;function te(le,de,Me){return[k.filter(le,de,Me),k.filter(le,be=>!de(be),Me)]}k.split=te;function pe(le,de=!1,Me=[],be){let Pe=Me.slice(),Re=le(H=>{Pe?Pe.push(H):V.fire(H)});be&&be.add(Re);const ze=()=>{Pe?.forEach(H=>V.fire(H)),Pe=null},V=new s({onWillAddFirstListener(){Re||(Re=le(H=>V.fire(H)),be&&be.add(Re))},onDidAddFirstListener(){Pe&&(de?setTimeout(ze):ze())},onDidRemoveLastListener(){Re&&Re.dispose(),Re=null}});return be&&be.add(V),V.event}k.buffer=pe;function ye(le,de){return(be,Pe,Re)=>{const ze=de(new U);return le(function(V){const H=ze.evaluate(V);H!==_&&be.call(Pe,H)},void 0,Re)}}k.chain=ye;const _=Symbol("HaltChainable");class U{constructor(){this.f=[]}map(de){return this.f.push(de),this}forEach(de){return this.f.push(Me=>(de(Me),Me)),this}filter(de){return this.f.push(Me=>de(Me)?Me:_),this}reduce(de,Me){let be=Me;return this.f.push(Pe=>(be=de(be,Pe),be)),this}latch(de=(Me,be)=>Me===be){let Me=!0,be;return this.f.push(Pe=>{const Re=Me||!de(Pe,be);return Me=!1,be=Pe,Re?Pe:_}),this}evaluate(de){for(const Me of this.f)if(de=Me(de),de===_)break;return de}}function he(le,de,Me=be=>be){const be=(...V)=>ze.fire(Me(...V)),Pe=()=>le.on(de,be),Re=()=>le.removeListener(de,be),ze=new s({onWillAddFirstListener:Pe,onDidRemoveLastListener:Re});return ze.event}k.fromNodeEventEmitter=he;function Se(le,de,Me=be=>be){const be=(...V)=>ze.fire(Me(...V)),Pe=()=>le.addEventListener(de,be),Re=()=>le.removeEventListener(de,be),ze=new s({onWillAddFirstListener:Pe,onDidRemoveLastListener:Re});return ze.event}k.fromDOMEventEmitter=Se;function me(le){return new Promise(de=>W(le)(de))}k.toPromise=me;function ie(le){const de=new s;return le.then(Me=>{de.fire(Me)},()=>{de.fire(void 0)}).finally(()=>{de.dispose()}),de.event}k.fromPromise=ie;function se(le,de,Me){return de(Me),le(be=>de(be))}k.runAndSubscribe=se;class oe{constructor(de,Me){this._observable=de,this.f=0,this.g=!1;const be={onWillAddFirstListener:()=>{de.addObserver(this)},onDidRemoveLastListener:()=>{de.removeObserver(this)}};Me||S(be),this.emitter=new s(be),Me&&Me.add(this.emitter)}beginUpdate(de){this.f++}handlePossibleChange(de){}handleChange(de,Me){this.g=!0}endUpdate(de){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function G(le,de){return new oe(le,de).emitter.event}k.fromObservable=G;function ee(le){return(de,Me,be)=>{let Pe=0,Re=!1;const ze={beginUpdate(){Pe++},endUpdate(){Pe--,Pe===0&&(le.reportChanges(),Re&&(Re=!1,de.call(Me)))},handlePossibleChange(){},handleChange(){Re=!0}};le.addObserver(ze),le.reportChanges();const V={dispose(){le.removeObserver(ze)}};return be instanceof I.$Tc?be.add(V):Array.isArray(be)&&be.push(V),V}}k.fromObservableLight=ee})(A||(e.Event=A={}));class P{constructor(S){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${S}_${P.f++}`,P.all.add(this)}start(S){this.g=new O.$3d,this.listenerCount=S}stop(){if(this.g){const S=this.g.elapsed();this.durations.push(S),this.elapsedOverall+=S,this.invocationCount+=1,this.g=void 0}}}e.$5d=P,P.all=new Set,P.f=0;let b=-1;function C(k){const S=b;return b=k,{dispose(){b=S}}}class y{constructor(S,F=Math.random().toString(18).slice(2,5)){this.threshold=S,this.name=F,this.g=0}dispose(){this.f?.clear()}check(S,F){const W=this.threshold;if(W<=0||F<W)return;this.f||(this.f=new Map);const B=this.f.get(S.value)||0;if(this.f.set(S.value,B+1),this.g-=1,this.g<=0){this.g=W*.5;let T,N=0;for(const[j,L]of this.f)(!T||N<L)&&(T=j,N=L);console.warn(`[${this.name}] potential listener LEAK detected, having ${F} listeners already. MOST frequent listener (${N}):`),console.warn(T)}return()=>{const T=this.f.get(S.value)||0;this.f.set(S.value,T-1)}}}class a{static create(){return new a(new Error().stack??"")}constructor(S){this.value=S}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let m=0;class l{constructor(S){this.value=S,this.id=m++}}const i=2,n=(k,S)=>{if(k instanceof l)S(k);else for(let F=0;F<k.length;F++){const W=k[F];W&&S(W)}},r=p?new FinalizationRegistry(k=>{typeof k=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(k))}):void 0;class s{constructor(S){this.w=0,this.f=S,this.g=b>0||this.f?.leakWarningThreshold?new y(this.f?.leakWarningThreshold??b):void 0,this.j=this.f?._profName?new P(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if($){const S=this.t;queueMicrotask(()=>{n(S,F=>F.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??(this.q=(S,F,W)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),I.$Uc.None;if(this.m)return I.$Uc.None;F&&(S=S.bind(F));const B=new l(S);let T,N;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(B.stack=a.create(),T=this.g.check(B.stack,this.w+1)),$&&(B.stack=N??a.create()),this.t?this.t instanceof l?(this.u??(this.u=new g),this.t=[this.t,B]):this.t.push(B):(this.f?.onWillAddFirstListener?.(this),this.t=B,this.f?.onDidAddFirstListener?.(this)),this.w++;const j=(0,I.$Sc)(()=>{r?.unregister(j),T?.(),this.x(B)});if(W instanceof I.$Tc?W.add(j):Array.isArray(W)&&W.push(j),r){const L=new Error().stack.split(`
`).slice(2).join(`
`).trim();r.register(j,L,j)}return j}),this.q}x(S){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const F=this.t,W=F.indexOf(S);if(W===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,F[W]=void 0;const B=this.u.current===this;if(this.w*i<=F.length){let T=0;for(let N=0;N<F.length;N++)F[N]?F[T++]=F[N]:B&&(this.u.end--,T<this.u.i&&this.u.i--);F.length=T}}y(S,F){if(!S)return;const W=this.f?.onListenerError||o.$1;if(!W){S.value(F);return}try{S.value(F)}catch(B){W(B)}}z(S){const F=S.current.t;for(;S.i<S.end;)this.y(F[S.i++],S.value);S.reset()}fire(S){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof l)this.y(this.t,S);else{const F=this.u;F.enqueue(this,S,this.t.length),this.z(F)}this.j?.stop()}hasListeners(){return this.w>0}}e.$7d=s;const t=()=>new g;e.$8d=t;class g{constructor(){this.i=-1,this.end=0}enqueue(S,F,W){this.i=0,this.end=W,this.current=S,this.value=F}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class d extends s{async fireAsync(S,F,W){if(this.t)for(this.h||(this.h=new M.$5c),n(this.t,B=>this.h.push([B.value,S]));this.h.size>0&&!F.isCancellationRequested;){const[B,T]=this.h.shift(),N=[],j={...T,token:F,waitUntil:L=>{if(Object.isFrozen(N))throw new Error("waitUntil can NOT be called asynchronous");W&&(L=W(L,B)),N.push(L)}};try{B(j)}catch(L){(0,o.$1)(L);continue}Object.freeze(N),await Promise.allSettled(N).then(L=>{for(const z of L)z.status==="rejected"&&(0,o.$1)(z.reason)})}}}e.$9d=d;class h extends s{get isPaused(){return this.h!==0}constructor(S){super(S),this.h=0,this.s=new M.$5c,this.A=S?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const S=Array.from(this.s);this.s.clear(),super.fire(this.A(S))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(S){this.w&&(this.h!==0?this.s.push(S):super.fire(S))}}e.$0d=h;class c extends h{constructor(S){super(S),this.k=S.delay??100}fire(S){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(S)}}e.$$d=c;class u extends s{constructor(S){super(S),this.h=[],this.k=S?.merge}fire(S){this.hasListeners()&&(this.h.push(S),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(F=>super.fire(F)),this.h=[]}))}}e.$_d=u;class f{constructor(){this.g=!1,this.h=[],this.f=new s({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(S){const F={event:S,listener:null};this.h.push(F),this.g&&this.m(F);const W=()=>{this.g&&this.o(F);const B=this.h.indexOf(F);this.h.splice(B,1)};return(0,I.$Sc)((0,R.$db)(W))}j(){this.g=!0,this.h.forEach(S=>this.m(S))}k(){this.g=!1,this.h.forEach(S=>this.o(S))}m(S){S.listener=S.event(F=>this.f.fire(F))}o(S){S.listener?.dispose(),S.listener=null}dispose(){this.f.dispose();for(const S of this.h)S.listener?.dispose();this.h=[]}}e.$ae=f;class E{constructor(S,F,W,B){this.f=new I.$Tc;const T=this.f.add(new f),N=this.f.add(new I.$4c);function j(L){N.set(L,T.add(B(L)))}for(const L of S)j(L);this.f.add(F(L=>{j(L)})),this.f.add(W(L=>{N.deleteAndDispose(L)})),this.event=T.event}dispose(){this.f.dispose()}}e.$be=E;class v{constructor(){this.f=[]}wrapEvent(S){return(F,W,B)=>S(T=>{const N=this.f[this.f.length-1];N?N.push(()=>F.call(W,T)):F.call(W,T)},void 0,B)}bufferEvents(S){const F=[];this.f.push(F);const W=S();return this.f.pop(),F.forEach(B=>B()),W}}e.$ce=v;class D{constructor(){this.f=!1,this.g=A.None,this.h=I.$Uc.None,this.j=new s({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(S){this.g=S,this.f&&(this.h.dispose(),this.h=S(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$de=D}),define(Ee[22],Ce([1,0,4]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ee=e.CancellationToken=void 0;const R=Object.freeze(function(p,$){const w=setTimeout(p.bind($),0);return{dispose(){clearTimeout(w)}}});var I;(function(p){function $(w){return w===p.None||w===p.Cancelled||w instanceof M?!0:!w||typeof w!="object"?!1:typeof w.isCancellationRequested=="boolean"&&typeof w.onCancellationRequested=="function"}p.isCancellationToken=$,p.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:o.Event.None}),p.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(I||(e.CancellationToken=I={}));class M{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?R:(this.b||(this.b=new o.$7d),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class O{constructor($){this.f=void 0,this.g=void 0,this.g=$&&$.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new M),this.f}cancel(){this.f?this.f instanceof M&&this.f.cancel():this.f=I.Cancelled}dispose($=!1){$&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof M&&this.f.dispose():this.f=I.None}}e.$ee=O}),define(Ee[169],Ce([1,0,22]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Re=e.$Qe=e.$Pe=void 0;class R{constructor(p){this.b=p,this.a=null}get(){if(this.a)return this.a;const p=new o.$ee,$=this.b(p.token);return this.a={promise:$,dispose:()=>{this.a=null,p.cancel(),p.dispose()}},this.a}}e.$Pe=R;class I{constructor(p,$=JSON.stringify){this.c=p,this.d=$,this.a=void 0,this.b=void 0}get(p){const $=this.d(p);return this.b!==$&&(this.b=$,this.a=this.c(p)),this.a}}e.$Qe=I;class M{get cachedValues(){return this.a}constructor(p){this.b=p,this.a=new Map}get(p){if(this.a.has(p))return this.a.get(p);const $=this.b(p);return this.a.set(p,$),$}}e.$Re=M}),define(Ee[100],Ce([1,0,13,3]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fe=I,e.$ge=M,e.$he=O,e.$ie=p,e.$je=w,e.$ke=A,e.$le=P,e.$me=b,e.$ne=C,e.$oe=y,e.$pe=a,e.$qe=m,e.$re=l,e.$se=i,e.$te=n;function I(r){const s=r;return s?typeof s.read=="function":!1}function M(r){const s=r;return s?[s.on,s.pause,s.resume,s.destroy].every(t=>typeof t=="function"):!1}function O(r){const s=r;return s?M(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}function p(r,s){return new $(r,s)}class ${constructor(s,t){this.e=s,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(s){if(!this.a.destroyed){if(this.a.flowing)this.g(s);else if(this.b.data.push(s),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(s){this.a.destroyed||(this.a.flowing?this.h(s):this.b.error.push(s))}end(s){this.a.destroyed||(typeof s<"u"&&this.write(s),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(s){this.c.data.slice(0).forEach(t=>t(s))}h(s){this.c.error.length===0?(0,o.$1)(s):this.c.error.slice(0).forEach(t=>t(s))}i(){this.c.end.slice(0).forEach(s=>s())}on(s,t){if(!this.a.destroyed)switch(s){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(s,t){if(this.a.destroyed)return;let g;switch(s){case"data":g=this.c.data;break;case"end":g=this.c.end;break;case"error":g=this.c.error;break}if(g){const d=g.indexOf(t);d>=0&&g.splice(d,1)}}j(){if(this.b.data.length>0){const s=this.e(this.b.data);this.g(s),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(g=>g())}}k(){if(this.c.error.length>0){for(const s of this.b.error)this.h(s);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function w(r,s){const t=[];let g;for(;(g=r.read())!==null;)t.push(g);return s(t)}function A(r,s,t){const g=[];let d;for(;(d=r.read())!==null&&g.length<t;)g.push(d);return d===null&&g.length>0?s(g):{read:()=>{if(g.length>0)return g.shift();if(typeof d<"u"){const h=d;return d=void 0,h}return r.read()}}}function P(r,s){return new Promise((t,g)=>{const d=[];b(r,{onData:h=>{s&&d.push(h)},onError:h=>{s?g(h):t(void 0)},onEnd:()=>{t(s?s(d):void 0)}})})}function b(r,s,t){r.on("error",g=>{t?.isCancellationRequested||s.onError(g)}),r.on("end",()=>{t?.isCancellationRequested||s.onEnd()}),r.on("data",g=>{t?.isCancellationRequested||s.onData(g)})}function C(r,s){return new Promise((t,g)=>{const d=new R.$Tc,h=[],c=E=>{if(h.push(E),h.length>s)return d.dispose(),r.pause(),t({stream:r,buffer:h,ended:!1})},u=E=>(d.dispose(),g(E)),f=()=>(d.dispose(),t({stream:r,buffer:h,ended:!0}));d.add((0,R.$Sc)(()=>r.removeListener("error",u))),r.on("error",u),d.add((0,R.$Sc)(()=>r.removeListener("end",f))),r.on("end",f),d.add((0,R.$Sc)(()=>r.removeListener("data",c))),r.on("data",c)})}function y(r,s){const t=p(s);return t.end(r),t}function a(){const r=p(()=>{throw new Error("not supported")});return r.end(),r}function m(r){let s=!1;return{read:()=>s?null:(s=!0,r)}}function l(r,s,t){const g=p(t);return b(r,{onData:d=>g.write(s.data(d)),onError:d=>g.error(s.error?s.error(d):d),onEnd:()=>g.end()}),g}function i(r,s,t){let g=!1;return{read:()=>{const d=s.read();return g?d:(g=!0,d!==null?t([r,d]):r)}}}function n(r,s,t){let g=!1;const d=p(t);return b(s,{onData:h=>g?d.write(h):(g=!0,d.write(t([r,h]))),onError:h=>d.error(h),onEnd:()=>{g||(g=!0,d.write(r)),d.end()}}),d}}),define(Ee[21],Ce([1,0,46,100]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ue=void 0,e.$ve=w,e.$we=A,e.$xe=P,e.$ye=b,e.$ze=C,e.$Ae=y,e.$Be=a,e.$Ce=m,e.$De=l,e.$Ee=i,e.$Fe=n,e.$Ge=r,e.$He=s,e.$Ie=t,e.$Je=g,e.$Ke=d,e.$Le=h,e.$Me=c,e.$Ne=u,e.$Oe=v;const I=typeof Buffer<"u",M=new o.$V(()=>new Uint8Array(256));let O,p;class ${static alloc(k){return I?new $(Buffer.allocUnsafe(k)):new $(new Uint8Array(k))}static wrap(k){return I&&!Buffer.isBuffer(k)&&(k=Buffer.from(k.buffer,k.byteOffset,k.byteLength)),new $(k)}static fromString(k,S){return!(S?.dontUseNodeBuffer||!1)&&I?new $(Buffer.from(k)):(O||(O=new TextEncoder),new $(O.encode(k)))}static fromByteArray(k){const S=$.alloc(k.length);for(let F=0,W=k.length;F<W;F++)S.buffer[F]=k[F];return S}static concat(k,S){if(typeof S>"u"){S=0;for(let B=0,T=k.length;B<T;B++)S+=k[B].byteLength}const F=$.alloc(S);let W=0;for(let B=0,T=k.length;B<T;B++){const N=k[B];F.set(N,W),W+=N.byteLength}return F}constructor(k){this.buffer=k,this.byteLength=this.buffer.byteLength}clone(){const k=$.alloc(this.byteLength);return k.set(this),k}toString(){return I?this.buffer.toString():(p||(p=new TextDecoder),p.decode(this.buffer))}slice(k,S){return new $(this.buffer.subarray(k,S))}set(k,S){if(k instanceof $)this.buffer.set(k.buffer,S);else if(k instanceof Uint8Array)this.buffer.set(k,S);else if(k instanceof ArrayBuffer)this.buffer.set(new Uint8Array(k),S);else if(ArrayBuffer.isView(k))this.buffer.set(new Uint8Array(k.buffer,k.byteOffset,k.byteLength),S);else throw new Error("Unknown argument 'array'")}readUInt32BE(k){return b(this.buffer,k)}writeUInt32BE(k,S){C(this.buffer,k,S)}readUInt32LE(k){return y(this.buffer,k)}writeUInt32LE(k,S){a(this.buffer,k,S)}readUInt8(k){return m(this.buffer,k)}writeUInt8(k,S){l(this.buffer,k,S)}indexOf(k,S=0){return w(this.buffer,k instanceof $?k.buffer:k,S)}}e.$ue=$;function w(D,k,S=0){const F=k.byteLength,W=D.byteLength;if(F===0)return 0;if(F===1)return D.indexOf(k[0]);if(F>W-S)return-1;const B=M.value;B.fill(k.length);for(let L=0;L<k.length;L++)B[k[L]]=k.length-L-1;let T=S+k.length-1,N=T,j=-1;for(;T<W;)if(D[T]===k[N]){if(N===0){j=T;break}T--,N--}else T+=Math.max(k.length-N,B[D[T]]),N=k.length-1;return j}function A(D,k){return D[k+0]<<0>>>0|D[k+1]<<8>>>0}function P(D,k,S){D[S+0]=k&255,k=k>>>8,D[S+1]=k&255}function b(D,k){return D[k]*2**24+D[k+1]*2**16+D[k+2]*2**8+D[k+3]}function C(D,k,S){D[S+3]=k,k=k>>>8,D[S+2]=k,k=k>>>8,D[S+1]=k,k=k>>>8,D[S]=k}function y(D,k){return D[k+0]<<0>>>0|D[k+1]<<8>>>0|D[k+2]<<16>>>0|D[k+3]<<24>>>0}function a(D,k,S){D[S+0]=k&255,k=k>>>8,D[S+1]=k&255,k=k>>>8,D[S+2]=k&255,k=k>>>8,D[S+3]=k&255}function m(D,k){return D[k]}function l(D,k,S){D[S]=k}function i(D){return R.$je(D,k=>$.concat(k))}function n(D){return R.$qe(D)}function r(D){return R.$le(D,k=>$.concat(k))}async function s(D){return D.ended?$.concat(D.buffer):$.concat([...D.buffer,await r(D.stream)])}function t(D){return R.$oe(D,k=>$.concat(k))}function g(D){return R.$re(D,{data:k=>typeof k=="string"?$.fromString(k):$.wrap(k)},k=>$.concat(k))}function d(D){return R.$ie(k=>$.concat(k),D)}function h(D,k){return R.$se(D,k,S=>$.concat(S))}function c(D,k){return R.$te(D,k,S=>$.concat(S))}function u(D){let k=0,S=0,F=0;const W=new Uint8Array(Math.floor(D.length/4*3)),B=N=>{switch(S){case 3:W[F++]=k|N,S=0;break;case 2:W[F++]=k|N>>>2,k=N<<6,S=3;break;case 1:W[F++]=k|N>>>4,k=N<<4,S=2;break;default:k=N<<2,S=1}};for(let N=0;N<D.length;N++){const j=D.charCodeAt(N);if(j>=65&&j<=90)B(j-65);else if(j>=97&&j<=122)B(j-97+26);else if(j>=48&&j<=57)B(j-48+52);else if(j===43||j===45)B(62);else if(j===47||j===95)B(63);else{if(j===61)break;throw new SyntaxError(`Unexpected base64 character ${D[N]}`)}}const T=F;for(;S>0;)B(0);return $.wrap(W).slice(0,T)}const f="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",E="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function v({buffer:D},k=!0,S=!1){const F=S?E:f;let W="";const B=D.byteLength%3;let T=0;for(;T<D.byteLength-B;T+=3){const N=D[T+0],j=D[T+1],L=D[T+2];W+=F[N>>>2],W+=F[(N<<4|j>>>4)&63],W+=F[(j<<2|L>>>6)&63],W+=F[L&63]}if(B===1){const N=D[T+0];W+=F[N>>>2],W+=F[N<<4&63],k&&(W+="==")}else if(B===2){const N=D[T+0],j=D[T+1];W+=F[N>>>2],W+=F[(N<<4|j>>>4)&63],W+=F[j<<2&63],k&&(W+="=")}return W}}),define(Ee[14],Ce([1,0,169,46]),function(re,e,o,R){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$Uf=e.$Tf=e.$Sf=e.GraphemeBreakType=e.$If=e.$Bf=e.$uf=e.$tf=void 0,e.$Ue=M,e.$Ve=p,e.$We=w,e.$Xe=A,e.$Ye=P,e.$Ze=b,e.$1e=C,e.$2e=y,e.$3e=a,e.$4e=m,e.$5e=l,e.$6e=i,e.$7e=n,e.$8e=r,e.$9e=s,e.$0e=t,e.$$e=g,e.$_e=d,e.$af=h,e.$bf=c,e.$cf=u,e.$df=f,e.$ef=E,e.$ff=v,e.$gf=D,e.$hf=k,e.$if=S,e.$jf=F,e.$kf=W,e.$lf=B,e.$mf=T,e.$nf=N,e.$of=j,e.$pf=L,e.$qf=z,e.$rf=Q,e.$sf=Y,e.$vf=te,e.$wf=pe,e.$xf=ye,e.$yf=_,e.$zf=Se,e.$Af=ie,e.$Cf=se,e.$Df=oe,e.$Ef=G,e.$Ff=ee,e.$Gf=de,e.$Hf=Me,e.$Jf=be,e.$Kf=Pe,e.$Lf=Re,e.$Mf=ze,e.$Nf=V,e.$Of=H,e.$Pf=Z,e.$Qf=X,e.$Rf=Ze;function M(Ie){return!Ie||typeof Ie!="string"?!0:Ie.trim().length===0}const O=/{(\d+)}/g;function p(Ie,...We){return We.length===0?Ie:Ie.replace(O,function(Ae,Ke){const ae=parseInt(Ke,10);return isNaN(ae)||ae<0||ae>=We.length?Ae:We[ae]})}const $=/{([^}]+)}/g;function w(Ie,We){return Object.keys(We).length===0?Ie:Ie.replace($,(Ae,Ke)=>We[Ke]??Ae)}function A(Ie){return Ie.replace(/[<>"'&]/g,We=>{switch(We){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return We})}function P(Ie){return Ie.replace(/[<>&]/g,function(We){switch(We){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return We}})}function b(Ie){return Ie.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function C(Ie,We){let Ae=0;const Ke=We.charCodeAt(0);for(let ae=Ie.length-1;ae>=0;ae--)Ie.charCodeAt(ae)===Ke&&Ae++;return Ae}function y(Ie,We,Ae="\u2026"){return Ie.length<=We?Ie:`${Ie.substr(0,We)}${Ae}`}function a(Ie,We,Ae="\u2026"){if(Ie.length<=We)return Ie;const Ke=Math.ceil(We/2)-Ae.length/2,ae=Math.floor(We/2)-Ae.length/2;return`${Ie.substr(0,Ke)}${Ae}${Ie.substr(Ie.length-ae)}`}function m(Ie,We=" "){const Ae=l(Ie,We);return i(Ae,We)}function l(Ie,We){if(!Ie||!We)return Ie;const Ae=We.length;if(Ae===0||Ie.length===0)return Ie;let Ke=0;for(;Ie.indexOf(We,Ke)===Ke;)Ke=Ke+Ae;return Ie.substring(Ke)}function i(Ie,We){if(!Ie||!We)return Ie;const Ae=We.length,Ke=Ie.length;if(Ae===0||Ke===0)return Ie;let ae=Ke,ue=-1;for(;ue=Ie.lastIndexOf(We,ae-1),!(ue===-1||ue+Ae!==ae);){if(ue===0)return"";ae=ue}return Ie.substring(0,ae)}function n(Ie){return Ie.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function r(Ie){return Ie.replace(/\*/g,"")}function s(Ie,We,Ae={}){if(!Ie)throw new Error("Cannot create regex from empty string");We||(Ie=b(Ie)),Ae.wholeWord&&(/\B/.test(Ie.charAt(0))||(Ie="\\b"+Ie),/\B/.test(Ie.charAt(Ie.length-1))||(Ie=Ie+"\\b"));let Ke="";return Ae.global&&(Ke+="g"),Ae.matchCase||(Ke+="i"),Ae.multiline&&(Ke+="m"),Ae.unicode&&(Ke+="u"),new RegExp(Ie,Ke)}function t(Ie){return Ie.source==="^"||Ie.source==="^$"||Ie.source==="$"||Ie.source==="^\\s*$"?!1:!!(Ie.exec("")&&Ie.lastIndex===0)}function g(Ie){return Ie.split(/\r\n|\r|\n/)}function d(Ie){const We=[],Ae=Ie.split(/(\r\n|\r|\n)/);for(let Ke=0;Ke<Math.ceil(Ae.length/2);Ke++)We.push(Ae[2*Ke]+(Ae[2*Ke+1]??""));return We}function h(Ie){for(let We=0,Ae=Ie.length;We<Ae;We++){const Ke=Ie.charCodeAt(We);if(Ke!==32&&Ke!==9)return We}return-1}function c(Ie,We=0,Ae=Ie.length){for(let Ke=We;Ke<Ae;Ke++){const ae=Ie.charCodeAt(Ke);if(ae!==32&&ae!==9)return Ie.substring(We,Ke)}return Ie.substring(We,Ae)}function u(Ie,We=Ie.length-1){for(let Ae=We;Ae>=0;Ae--){const Ke=Ie.charCodeAt(Ae);if(Ke!==32&&Ke!==9)return Ae}return-1}function f(Ie,We,Ae){const Ke=[];let ae=0;for(const ue of Ie.matchAll(We)){if(Ke.push(Ie.slice(ae,ue.index)),ue.index===void 0)throw new Error("match.index should be defined");ae=ue.index+ue[0].length,Ke.push(Ae(ue[0],...ue.slice(1),ue.index,Ie,ue.groups))}return Ke.push(Ie.slice(ae)),Promise.all(Ke).then(ue=>ue.join(""))}function E(Ie,We){return Ie<We?-1:Ie>We?1:0}function v(Ie,We,Ae=0,Ke=Ie.length,ae=0,ue=We.length){for(;Ae<Ke&&ae<ue;Ae++,ae++){const et=Ie.charCodeAt(Ae),Ne=We.charCodeAt(ae);if(et<Ne)return-1;if(et>Ne)return 1}const De=Ke-Ae,Je=ue-ae;return De<Je?-1:De>Je?1:0}function D(Ie,We){return k(Ie,We,0,Ie.length,0,We.length)}function k(Ie,We,Ae=0,Ke=Ie.length,ae=0,ue=We.length){for(;Ae<Ke&&ae<ue;Ae++,ae++){let et=Ie.charCodeAt(Ae),Ne=We.charCodeAt(ae);if(et===Ne)continue;if(et>=128||Ne>=128)return v(Ie.toLowerCase(),We.toLowerCase(),Ae,Ke,ae,ue);F(et)&&(et-=32),F(Ne)&&(Ne-=32);const ht=et-Ne;if(ht!==0)return ht}const De=Ke-Ae,Je=ue-ae;return De<Je?-1:De>Je?1:0}function S(Ie){return Ie>=48&&Ie<=57}function F(Ie){return Ie>=97&&Ie<=122}function W(Ie){return Ie>=65&&Ie<=90}function B(Ie,We){return Ie.length===We.length&&k(Ie,We)===0}function T(Ie,We){const Ae=We.length;return We.length>Ie.length?!1:k(Ie,We,0,Ae)===0}function N(Ie,We){const Ae=Math.min(Ie.length,We.length);let Ke;for(Ke=0;Ke<Ae;Ke++)if(Ie.charCodeAt(Ke)!==We.charCodeAt(Ke))return Ke;return Ae}function j(Ie,We){const Ae=Math.min(Ie.length,We.length);let Ke;const ae=Ie.length-1,ue=We.length-1;for(Ke=0;Ke<Ae;Ke++)if(Ie.charCodeAt(ae-Ke)!==We.charCodeAt(ue-Ke))return Ke;return Ae}function L(Ie){return 55296<=Ie&&Ie<=56319}function z(Ie){return 56320<=Ie&&Ie<=57343}function Q(Ie,We){return(Ie-55296<<10)+(We-56320)+65536}function Y(Ie,We,Ae){const Ke=Ie.charCodeAt(Ae);if(L(Ke)&&Ae+1<We){const ae=Ie.charCodeAt(Ae+1);if(z(ae))return Q(Ke,ae)}return Ke}function J(Ie,We){const Ae=Ie.charCodeAt(We-1);if(z(Ae)&&We>1){const Ke=Ie.charCodeAt(We-2);if(L(Ke))return Q(Ke,Ae)}return Ae}class x{get offset(){return this.e}constructor(We,Ae=0){this.c=We,this.d=We.length,this.e=Ae}setOffset(We){this.e=We}prevCodePoint(){const We=J(this.c,this.e);return this.e-=We>=65536?2:1,We}nextCodePoint(){const We=Y(this.c,this.d,this.e);return this.e+=We>=65536?2:1,We}eol(){return this.e>=this.d}}e.$tf=x;class ce{get offset(){return this.c.offset}constructor(We,Ae=0){this.c=new x(We,Ae)}nextGraphemeLength(){const We=Te.getInstance(),Ae=this.c,Ke=Ae.offset;let ae=We.getGraphemeBreakType(Ae.nextCodePoint());for(;!Ae.eol();){const ue=Ae.offset,De=We.getGraphemeBreakType(Ae.nextCodePoint());if(fe(ae,De)){Ae.setOffset(ue);break}ae=De}return Ae.offset-Ke}prevGraphemeLength(){const We=Te.getInstance(),Ae=this.c,Ke=Ae.offset;let ae=We.getGraphemeBreakType(Ae.prevCodePoint());for(;Ae.offset>0;){const ue=Ae.offset,De=We.getGraphemeBreakType(Ae.prevCodePoint());if(fe(De,ae)){Ae.setOffset(ue);break}ae=De}return Ke-Ae.offset}eol(){return this.c.eol()}}e.$uf=ce;function te(Ie,We){return new ce(Ie,We).nextGraphemeLength()}function pe(Ie,We){return new ce(Ie,We).prevGraphemeLength()}function ye(Ie,We){We>0&&z(Ie.charCodeAt(We))&&We--;const Ae=We+te(Ie,We);return[Ae-pe(Ie,Ae),Ae]}function _(Ie){const We=new ce(Ie);let Ae=0;for(;!We.eol();)Ae++,We.nextGraphemeLength();return Ae}let U;function he(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Se(Ie){return U||(U=he()),U.test(Ie)}const me=/^[\t\n\r\x20-\x7E]*$/;function ie(Ie){return me.test(Ie)}e.$Bf=/[\u2028\u2029]/;function se(Ie){return e.$Bf.test(Ie)}function oe(Ie){return Ie>=11904&&Ie<=55215||Ie>=63744&&Ie<=64255||Ie>=65281&&Ie<=65374}function G(Ie){return Ie>=127462&&Ie<=127487||Ie===8986||Ie===8987||Ie===9200||Ie===9203||Ie>=9728&&Ie<=10175||Ie===11088||Ie===11093||Ie>=127744&&Ie<=128591||Ie>=128640&&Ie<=128764||Ie>=128992&&Ie<=129008||Ie>=129280&&Ie<=129535||Ie>=129648&&Ie<=129782}function ee(Ie,We,Ae=""){const Ke=Ie.trimStart();if(Ke.length<We)return Ke;const ae=/\b/g;let ue=0;for(;ae.test(Ke)&&!(Ke.length-ae.lastIndex<We);)ue=ae.lastIndex,ae.lastIndex+=1;return ue===0?Ke:Ae+Ke.substring(ue).trimStart()}const le=/(:?(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*de(Ie){let We=0;for(const Ae of Ie.matchAll(le))We!==Ae.index&&(yield{isCode:!1,str:Ie.substring(We,Ae.index)}),yield{isCode:!0,str:Ae[0]},We=Ae.index+Ae[0].length;We!==Ie.length&&(yield{isCode:!1,str:Ie.substring(We)})}function Me(Ie){return Ie&&(Ie=Ie.replace(le,"")),Ie}e.$If="\uFEFF";function be(Ie){return!!(Ie&&Ie.length>0&&Ie.charCodeAt(0)===65279)}function Pe(Ie){return be(Ie)?Ie.substr(1):Ie}function Re(Ie,We){if(!Ie||!We||Ie.length<We.length)return!1;const Ae=We.length,Ke=Ie.toLowerCase();let ae=0,ue=-1;for(;ae<Ae;){const De=Ke.indexOf(We[ae],ue+1);if(De<0)return!1;ue=De,ae++}return!0}function ze(Ie,We=!1){return Ie?(We&&(Ie=Ie.replace(/\\./g,"")),Ie.toLowerCase()!==Ie):!1}function V(Ie){return Ie.charAt(0).toUpperCase()+Ie.slice(1)}function H(Ie,We=1){if(We===0)return"";let Ae=-1;do Ae=Ie.indexOf(`
`,Ae+1),We--;while(We>0&&Ae>=0);return Ae===-1?Ie:(Ie[Ae-1]==="\r"&&Ae--,Ie.substr(0,Ae))}function Z(Ie){return Ie=Ie%(2*26),Ie<26?String.fromCharCode(97+Ie):String.fromCharCode(65+Ie-26)}function X(Ie){return Te.getInstance().getGraphemeBreakType(Ie)}function fe(Ie,We){return Ie===0?We!==5&&We!==7:Ie===2&&We===3?!1:Ie===4||Ie===2||Ie===3||We===4||We===2||We===3?!0:!(Ie===8&&(We===8||We===9||We===11||We===12)||(Ie===11||Ie===9)&&(We===9||We===10)||(Ie===12||Ie===10)&&We===10||We===5||We===13||We===7||Ie===1||Ie===13&&We===14||Ie===6&&We===6)}var we;(function(Ie){Ie[Ie.Other=0]="Other",Ie[Ie.Prepend=1]="Prepend",Ie[Ie.CR=2]="CR",Ie[Ie.LF=3]="LF",Ie[Ie.Control=4]="Control",Ie[Ie.Extend=5]="Extend",Ie[Ie.Regional_Indicator=6]="Regional_Indicator",Ie[Ie.SpacingMark=7]="SpacingMark",Ie[Ie.L=8]="L",Ie[Ie.V=9]="V",Ie[Ie.T=10]="T",Ie[Ie.LV=11]="LV",Ie[Ie.LVT=12]="LVT",Ie[Ie.ZWJ=13]="ZWJ",Ie[Ie.Extended_Pictographic=14]="Extended_Pictographic"})(we||(e.GraphemeBreakType=we={}));class Te{static getInstance(){return Te.c||(Te.c=new Te),Te.c}constructor(){this.d=Ve()}getGraphemeBreakType(We){if(We<32)return We===10?3:We===13?2:4;if(We<127)return 0;const Ae=this.d,Ke=Ae.length/3;let ae=1;for(;ae<=Ke;)if(We<Ae[3*ae])ae=2*ae;else if(We>Ae[3*ae+1])ae=2*ae+1;else return Ae[3*ae+2];return 0}}Te.c=null;function Ve(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ze(Ie,We){if(Ie===0)return 0;const Ae=nt(Ie,We);if(Ae!==void 0)return Ae;const Ke=new x(We,Ie);return Ke.prevCodePoint(),Ke.offset}function nt(Ie,We){const Ae=new x(We,Ie);let Ke=Ae.prevCodePoint();for(;ot(Ke)||Ke===65039||Ke===8419;){if(Ae.offset===0)return;Ke=Ae.prevCodePoint()}if(!G(Ke))return;let ae=Ae.offset;return ae>0&&Ae.prevCodePoint()===8205&&(ae=Ae.offset),ae}function ot(Ie){return 127995<=Ie&&Ie<=127999}var lt;(function(Ie){Ie[Ie.zwj=8205]="zwj",Ie[Ie.emojiVariantSelector=65039]="emojiVariantSelector",Ie[Ie.enclosingKeyCap=8419]="enclosingKeyCap"})(lt||(lt={})),e.$Sf="\xA0";class at{static getInstance(We){return I.d.get(Array.from(We))}static getLocales(){return I.e.value}constructor(We){this.f=We}isAmbiguous(We){return this.f.has(We)}getPrimaryConfusable(We){return this.f.get(We)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Tf=at,I=at,at.c=new R.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),at.d=new o.$Qe(Ie=>{function We(Ne){const ht=new Map;for(let vt=0;vt<Ne.length;vt+=2)ht.set(Ne[vt],Ne[vt+1]);return ht}function Ae(Ne,ht){const vt=new Map(Ne);for(const[Mt,zt]of ht)vt.set(Mt,zt);return vt}function Ke(Ne,ht){if(!Ne)return ht;const vt=new Map;for(const[Mt,zt]of Ne)ht.has(Mt)&&vt.set(Mt,zt);return vt}const ae=I.c.value;let ue=Ie.filter(Ne=>!Ne.startsWith("_")&&Ne in ae);ue.length===0&&(ue=["_default"]);let De;for(const Ne of ue){const ht=We(ae[Ne]);De=Ke(De,ht)}const Je=We(ae._common),et=Ae(Je,De);return new I(et)}),at.e=new R.$V(()=>Object.keys(I.c.value).filter(Ie=>!Ie.startsWith("_")));class st{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(st.c())),this.d}static isInvisibleCharacter(We){return st.e().has(We)}static get codePoints(){return st.e()}}e.$Uf=st,st.d=void 0}),define(Ee[128],Ce([1,0,27,167,14]),function(re,e,o,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vk=e.FuzzyScore=e.$kk=e.$jk=void 0,e.or=M,e.$lk=p,e.$mk=$,e.$nk=P,e.$ok=u,e.$pk=f,e.$qk=F,e.$rk=W,e.$sk=B,e.$tk=T,e.$uk=he,e.$wk=se,e.$xk=ee,e.$yk=le;function M(...be){return function(Pe,Re){for(let ze=0,V=be.length;ze<V;ze++){const H=be[ze](Pe,Re);if(H)return H}return null}}e.$jk=O.bind(void 0,!1),e.$kk=O.bind(void 0,!0);function O(be,Pe,Re){if(!Re||Re.length<Pe.length)return null;let ze;return be?ze=I.$mf(Re,Pe):ze=Re.indexOf(Pe)===0,ze?Pe.length>0?[{start:0,end:Pe.length}]:[]:null}function p(be,Pe){const Re=Pe.toLowerCase().indexOf(be.toLowerCase());return Re===-1?null:[{start:Re,end:Re+be.length}]}function $(be,Pe){return w(be.toLowerCase(),Pe.toLowerCase(),0,0)}function w(be,Pe,Re,ze){if(Re===be.length)return[];if(ze===Pe.length)return null;if(be[Re]===Pe[ze]){let V=null;return(V=w(be,Pe,Re+1,ze+1))?r({start:ze,end:ze+1},V):null}return w(be,Pe,Re,ze+1)}function A(be){return 97<=be&&be<=122}function P(be){return 65<=be&&be<=90}function b(be){return 48<=be&&be<=57}function C(be){return be===32||be===9||be===10||be===13}const y=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(be=>y.add(be.charCodeAt(0)));function a(be){return C(be)||y.has(be)}function m(be,Pe){return be===Pe||a(be)&&a(Pe)}const l=new Map;function i(be){if(l.has(be))return l.get(be);let Pe;const Re=(0,R.$hk)(be);return Re&&(Pe=Re),l.set(be,Pe),Pe}function n(be){return A(be)||P(be)||b(be)}function r(be,Pe){return Pe.length===0?Pe=[be]:be.end===Pe[0].start?Pe[0].start=be.start:Pe.unshift(be),Pe}function s(be,Pe){for(let Re=Pe;Re<be.length;Re++){const ze=be.charCodeAt(Re);if(P(ze)||b(ze)||Re>0&&!n(be.charCodeAt(Re-1)))return Re}return be.length}function t(be,Pe,Re,ze){if(Re===be.length)return[];if(ze===Pe.length)return null;if(be[Re]!==Pe[ze].toLowerCase())return null;{let V=null,H=ze+1;for(V=t(be,Pe,Re+1,ze+1);!V&&(H=s(Pe,H))<Pe.length;)V=t(be,Pe,Re+1,H),H++;return V===null?null:r({start:ze,end:ze+1},V)}}function g(be){let Pe=0,Re=0,ze=0,V=0,H=0;for(let Te=0;Te<be.length;Te++)H=be.charCodeAt(Te),P(H)&&Pe++,A(H)&&Re++,n(H)&&ze++,b(H)&&V++;const Z=Pe/be.length,X=Re/be.length,fe=ze/be.length,we=V/be.length;return{upperPercent:Z,lowerPercent:X,alphaPercent:fe,numericPercent:we}}function d(be){const{upperPercent:Pe,lowerPercent:Re}=be;return Re===0&&Pe>.6}function h(be){const{upperPercent:Pe,lowerPercent:Re,alphaPercent:ze,numericPercent:V}=be;return Re>.2&&Pe<.8&&ze>.6&&V<.2}function c(be){let Pe=0,Re=0,ze=0,V=0;for(let H=0;H<be.length;H++)ze=be.charCodeAt(H),P(ze)&&Pe++,A(ze)&&Re++,C(ze)&&V++;return(Pe===0||Re===0)&&V===0?be.length<=30:Pe<=5}function u(be,Pe){if(!Pe||(Pe=Pe.trim(),Pe.length===0)||!c(be))return null;Pe.length>60&&(Pe=Pe.substring(0,60));const Re=g(Pe);if(!h(Re)){if(!d(Re))return null;Pe=Pe.toLowerCase()}let ze=null,V=0;for(be=be.toLowerCase();V<Pe.length&&(ze=t(be,Pe,0,V))===null;)V=s(Pe,V+1);return ze}function f(be,Pe,Re=!1){if(!Pe||Pe.length===0)return null;let ze=null,V=0;for(be=be.toLowerCase(),Pe=Pe.toLowerCase();V<Pe.length&&(ze=E(be,Pe,0,V,Re),ze===null);)V=v(Pe,V+1);return ze}function E(be,Pe,Re,ze,V){let H=0;if(Re===be.length)return[];if(ze===Pe.length)return null;if(!m(be.charCodeAt(Re),Pe.charCodeAt(ze))){const fe=i(be.charCodeAt(Re));if(!fe)return null;for(let we=0;we<fe.length;we++)if(!m(fe[we],Pe.charCodeAt(ze+we)))return null;H+=fe.length-1}let Z=null,X=ze+H+1;if(Z=E(be,Pe,Re+1,X,V),!V)for(;!Z&&(X=v(Pe,X))<Pe.length;)Z=E(be,Pe,Re+1,X,V),X++;if(!Z)return null;if(be.charCodeAt(Re)!==Pe.charCodeAt(ze)){const fe=i(be.charCodeAt(Re));if(!fe)return Z;for(let we=0;we<fe.length;we++)if(fe[we]!==Pe.charCodeAt(ze+we))return Z}return r({start:ze,end:ze+H+1},Z)}function v(be,Pe){for(let Re=Pe;Re<be.length;Re++)if(a(be.charCodeAt(Re))||Re>0&&a(be.charCodeAt(Re-1)))return Re;return be.length}const D=M(e.$kk,u,p),k=M(e.$kk,u,$),S=new o.$Ec(1e4);function F(be,Pe,Re=!1){if(typeof be!="string"||typeof Pe!="string")return null;let ze=S.get(be);ze||(ze=new RegExp(I.$7e(be),"i"),S.set(be,ze));const V=ze.exec(Pe);return V?[{start:V.index,end:V.index+V[0].length}]:Re?k(be,Pe):D(be,Pe)}function W(be,Pe){const Re=se(be,be.toLowerCase(),0,Pe,Pe.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Re?T(Re):null}function B(be,Pe,Re,ze,V,H){const Z=Math.min(13,be.length);for(;Re<Z;Re++){const X=se(be,Pe,Re,ze,V,H,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(X)return X}return[0,H]}function T(be){if(typeof be>"u")return[];const Pe=[],Re=be[1];for(let ze=be.length-1;ze>1;ze--){const V=be[ze]+Re,H=Pe[Pe.length-1];H&&H.end===V?H.end=V+1:Pe.push({start:V,end:V+1})}return Pe}const N=128;function j(){const be=[],Pe=[];for(let Re=0;Re<=N;Re++)Pe[Re]=0;for(let Re=0;Re<=N;Re++)be.push(Pe.slice(0));return be}function L(be){const Pe=[];for(let Re=0;Re<=be;Re++)Pe[Re]=0;return Pe}const z=L(2*N),Q=L(2*N),Y=j(),J=j(),x=j(),ce=!1;function te(be,Pe,Re,ze,V){function H(X,fe,we=" "){for(;X.length<fe;)X=we+X;return X}let Z=` |   |${ze.split("").map(X=>H(X,3)).join("|")}
`;for(let X=0;X<=Re;X++)X===0?Z+=" |":Z+=`${Pe[X-1]}|`,Z+=be[X].slice(0,V+1).map(fe=>H(fe.toString(),3)).join("|")+`
`;return Z}function pe(be,Pe,Re,ze){be=be.substr(Pe),Re=Re.substr(ze),console.log(te(J,be,be.length,Re,Re.length)),console.log(te(x,be,be.length,Re,Re.length)),console.log(te(Y,be,be.length,Re,Re.length))}function ye(be,Pe){if(Pe<0||Pe>=be.length)return!1;const Re=be.codePointAt(Pe);switch(Re){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!I.$Ef(Re)}}function _(be,Pe){if(Pe<0||Pe>=be.length)return!1;switch(be.charCodeAt(Pe)){case 32:case 9:return!0;default:return!1}}function U(be,Pe,Re){return Pe[be]!==Re[be]}function he(be,Pe,Re,ze,V,H,Z=!1){for(;Pe<Re&&V<H;)be[Pe]===ze[V]&&(Z&&(z[Pe]=V),Pe+=1),V+=1;return Pe===Re}var Se;(function(be){be[be.Diag=1]="Diag",be[be.Left=2]="Left",be[be.LeftLeft=3]="LeftLeft"})(Se||(Se={}));var me;(function(be){be.Default=[-100,0];function Pe(Re){return!Re||Re.length===2&&Re[0]===-100&&Re[1]===0}be.isDefault=Pe})(me||(e.FuzzyScore=me={}));class ie{constructor(Pe,Re){this.firstMatchCanBeWeak=Pe,this.boostFullMatch=Re}}e.$vk=ie,ie.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function se(be,Pe,Re,ze,V,H,Z=ie.default){const X=be.length>N?N:be.length,fe=ze.length>N?N:ze.length;if(Re>=X||H>=fe||X-Re>fe-H||!he(Pe,Re,X,V,H,fe,!0))return;oe(X,fe,Re,H,Pe,V);let we=1,Te=1,Ve=Re,Ze=H;const nt=[!1];for(we=1,Ve=Re;Ve<X;we++,Ve++){const Ie=z[Ve],We=Q[Ve],Ae=Ve+1<X?Q[Ve+1]:fe;for(Te=Ie-H+1,Ze=Ie;Ze<Ae;Te++,Ze++){let Ke=Number.MIN_SAFE_INTEGER,ae=!1;Ze<=We&&(Ke=G(be,Pe,Ve,Re,ze,V,Ze,fe,H,Y[we-1][Te-1]===0,nt));let ue=0;Ke!==Number.MAX_SAFE_INTEGER&&(ae=!0,ue=Ke+J[we-1][Te-1]);const De=Ze>Ie,Je=De?J[we][Te-1]+(Y[we][Te-1]>0?-5:0):0,et=Ze>Ie+1&&Y[we][Te-1]>0,Ne=et?J[we][Te-2]+(Y[we][Te-2]>0?-5:0):0;if(et&&(!De||Ne>=Je)&&(!ae||Ne>=ue))J[we][Te]=Ne,x[we][Te]=3,Y[we][Te]=0;else if(De&&(!ae||Je>=ue))J[we][Te]=Je,x[we][Te]=2,Y[we][Te]=0;else if(ae)J[we][Te]=ue,x[we][Te]=1,Y[we][Te]=Y[we-1][Te-1]+1;else throw new Error("not possible")}}if(ce&&pe(be,Re,ze,H),!nt[0]&&!Z.firstMatchCanBeWeak)return;we--,Te--;const ot=[J[we][Te],H];let lt=0,at=0;for(;we>=1;){let Ie=Te;do{const We=x[we][Ie];if(We===3)Ie=Ie-2;else if(We===2)Ie=Ie-1;else break}while(Ie>=1);lt>1&&Pe[Re+we-1]===V[H+Te-1]&&!U(Ie+H-1,ze,V)&&lt+1>Y[we][Ie]&&(Ie=Te),Ie===Te?lt++:lt=1,at||(at=Ie),we--,Te=Ie-1,ot.push(Te)}fe===X&&Z.boostFullMatch&&(ot[0]+=2);const st=at-X;return ot[0]-=st,ot}function oe(be,Pe,Re,ze,V,H){let Z=be-1,X=Pe-1;for(;Z>=Re&&X>=ze;)V[Z]===H[X]&&(Q[Z]=X,Z--),X--}function G(be,Pe,Re,ze,V,H,Z,X,fe,we,Te){if(Pe[Re]!==H[Z])return Number.MIN_SAFE_INTEGER;let Ve=1,Ze=!1;return Z===Re-ze?Ve=be[Re]===V[Z]?7:5:U(Z,V,H)&&(Z===0||!U(Z-1,V,H))?(Ve=be[Re]===V[Z]?7:5,Ze=!0):ye(H,Z)&&(Z===0||!ye(H,Z-1))?Ve=5:(ye(H,Z-1)||_(H,Z-1))&&(Ve=5,Ze=!0),Ve>1&&Re===ze&&(Te[0]=!0),Ze||(Ze=U(Z,V,H)||ye(H,Z-1)||_(H,Z-1)),Re===ze?Z>fe&&(Ve-=Ze?3:5):we?Ve+=Ze?2:0:Ve+=Ze?0:1,Z+1===X&&(Ve-=Ze?3:5),Ve}function ee(be,Pe,Re,ze,V,H,Z){return de(be,Pe,Re,ze,V,H,!0,Z)}function le(be,Pe,Re,ze,V,H,Z){return de(be,Pe,Re,ze,V,H,!1,Z)}function de(be,Pe,Re,ze,V,H,Z,X){let fe=se(be,Pe,Re,ze,V,H,X);if(fe&&!Z)return fe;if(be.length>=3){const we=Math.min(7,be.length-1);for(let Te=Re+1;Te<we;Te++){const Ve=Me(be,Te);if(Ve){const Ze=se(Ve,Ve.toLowerCase(),Re,ze,V,H,X);Ze&&(Ze[0]-=3,(!fe||Ze[0]>fe[0])&&(fe=Ze))}}}return fe}function Me(be,Pe){if(Pe+1>=be.length)return;const Re=be[Pe],ze=be[Pe+1];if(Re!==ze)return be.slice(0,Pe)+ze+Re+be.slice(Pe+2)}}),define(Ee[55],Ce([1,0,14]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cj=e.$aj=void 0,e.$9i=R,e.$0i=I,e.$$i=M,e.$_i=p,e.$bj=a;function R(l){return I(l,0)}function I(l,i){switch(typeof l){case"object":return l===null?M(349,i):Array.isArray(l)?$(l,i):w(l,i);case"string":return p(l,i);case"boolean":return O(l,i);case"number":return M(l,i);case"undefined":return M(937,i);default:return M(617,i)}}function M(l,i){return(i<<5)-i+l|0}function O(l,i){return M(l?433:863,i)}function p(l,i){i=M(149417,i);for(let n=0,r=l.length;n<r;n++)i=M(l.charCodeAt(n),i);return i}function $(l,i){return i=M(104579,i),l.reduce((n,r)=>I(r,n),i)}function w(l,i){return i=M(181387,i),Object.keys(l).sort().reduce((n,r)=>(n=p(r,n),I(l[r],n)),i)}class A{constructor(){this.g=0}get value(){return this.g}hash(i){return this.g=I(i,this.g),this.g}}e.$aj=A;var P;(function(l){l[l.BLOCK_SIZE=64]="BLOCK_SIZE",l[l.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function b(l,i,n=32){const r=n-i,s=~((1<<r)-1);return(l<<i|(s&l)>>>r)>>>0}function C(l,i=0,n=l.byteLength,r=0){for(let s=0;s<n;s++)l[i+s]=r}function y(l,i,n="0"){for(;l.length<i;)l=n+l;return l}function a(l,i=32){return l instanceof ArrayBuffer?Array.from(new Uint8Array(l)).map(n=>n.toString(16).padStart(2,"0")).join(""):y((l>>>0).toString(16),i/4)}class m{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(i){const n=i.length;if(n===0)return;const r=this.p;let s=this.r,t=this.u,g,d;for(t!==0?(g=t,d=-1,t=0):(g=i.charCodeAt(0),d=0);;){let h=g;if(o.$pf(g))if(d+1<n){const c=i.charCodeAt(d+1);o.$qf(c)?(d++,h=o.$rf(g,c)):h=65533}else{t=g;break}else o.$qf(g)&&(h=65533);if(s=this.w(r,s,h),d++,d<n)g=i.charCodeAt(d);else break}this.r=s,this.u=t}w(i,n,r){return r<128?i[n++]=r:r<2048?(i[n++]=192|(r&1984)>>>6,i[n++]=128|(r&63)>>>0):r<65536?(i[n++]=224|(r&61440)>>>12,i[n++]=128|(r&4032)>>>6,i[n++]=128|(r&63)>>>0):(i[n++]=240|(r&1835008)>>>18,i[n++]=128|(r&258048)>>>12,i[n++]=128|(r&4032)>>>6,i[n++]=128|(r&63)>>>0),n>=64&&(this.y(),n-=64,this.t+=64,i[0]=i[64],i[1]=i[65],i[2]=i[66]),n}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),a(this.h)+a(this.l)+a(this.m)+a(this.n)+a(this.o)}x(){this.p[this.r++]=128,C(this.p,this.r),this.r>56&&(this.y(),C(this.p));const i=8*this.t;this.q.setUint32(56,Math.floor(i/4294967296),!1),this.q.setUint32(60,i%4294967296,!1),this.y()}y(){const i=m.g,n=this.q;for(let f=0;f<64;f+=4)i.setUint32(f,n.getUint32(f,!1),!1);for(let f=64;f<320;f+=4)i.setUint32(f,b(i.getUint32(f-12,!1)^i.getUint32(f-32,!1)^i.getUint32(f-56,!1)^i.getUint32(f-64,!1),1),!1);let r=this.h,s=this.l,t=this.m,g=this.n,d=this.o,h,c,u;for(let f=0;f<80;f++)f<20?(h=s&t|~s&g,c=1518500249):f<40?(h=s^t^g,c=1859775393):f<60?(h=s&t|s&g|t&g,c=2400959708):(h=s^t^g,c=3395469782),u=b(r,5)+h+d+c+i.getUint32(f*4,!1)&4294967295,d=g,g=t,t=b(s,30),s=r,r=u;this.h=this.h+r&4294967295,this.l=this.l+s&4294967295,this.m=this.m+t&4294967295,this.n=this.n+g&4294967295,this.o=this.o+d&4294967295}}e.$cj=m,m.g=new DataView(new ArrayBuffer(320))}),define(Ee[129],Ce([1,0,127,128,55,17,11,14]),function(re,e,o,R,I,M,O,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$er=A,e.$fr=m,e.$gr=d,e.$hr=D,e.$ir=T,e.$jr=j;const $=0,w=[$,[]];function A(L,z,Q,Y){if(!L||!z)return w;const J=L.length,x=z.length;if(J<x)return w;const ce=L.toLowerCase();return P(z,Q,x,L,ce,J,Y)}function P(L,z,Q,Y,J,x,ce){const te=[],pe=[];for(let he=0;he<Q;he++){const Se=he*x,me=Se-x,ie=he>0,se=L[he],oe=z[he];for(let G=0;G<x;G++){const ee=G>0,le=Se+G,de=le-1,Me=me+G-1,be=ee?te[de]:0,Pe=ie&&ee?te[Me]:0,Re=ie&&ee?pe[Me]:0;let ze;!Pe&&ie?ze=0:ze=b(se,oe,Y,J,G,Re),ze&&Pe+ze>=be&&(ce||ie||J.startsWith(z,G))?(pe[le]=Re+1,te[le]=Pe+ze):(pe[le]=$,te[le]=be)}}const ye=[];let _=Q-1,U=x-1;for(;_>=0&&U>=0;){const he=_*x+U;pe[he]===$||(ye.push(U),_--),U--}return[te[Q*x-1],ye.reverse()]}function b(L,z,Q,Y,J,x){let ce=0;if(!C(z,Y[J]))return ce;if(ce+=1,x>0&&(ce+=x*5),L===Q[J]&&(ce+=1),J===0)ce+=8;else{const te=y(Q.charCodeAt(J-1));te?ce+=te:(0,R.$nk)(Q.charCodeAt(J))&&x===0&&(ce+=2)}return ce}function C(L,z){return L===z?!0:L==="/"||L==="\\"?z==="/"||z==="\\":!1}function y(L){switch(L){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const a=[void 0,[]];function m(L,z,Q=0,Y=0){const J=z;return J.values&&J.values.length>1?l(L,J.values,Q,Y):i(L,z,Q,Y)}function l(L,z,Q,Y){let J=0;const x=[];for(const ce of z){const[te,pe]=i(L,ce,Q,Y);if(typeof te!="number")return a;J+=te,x.push(...pe)}return[J,E(x)]}function i(L,z,Q,Y){const J=(0,R.$wk)(z.original,z.originalLowercase,Q,L,L.toLowerCase(),Y,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return J?[J[0],(0,R.$tk)(J)]:a}const n=Object.freeze({score:0}),r=1<<18,s=1<<17,t=65536;function g(L,z,Q,Y){const J=Y.values?Y.values:[Y];return(0,I.$9i)({[Y.normalized]:{values:J.map(ce=>({value:ce.normalized,expectContiguousMatch:ce.expectContiguousMatch})),label:L,description:z,allowNonContiguousMatches:Q}})}function d(L,z,Q,Y,J){if(!L||!z.normalized)return n;const x=Y.getItemLabel(L);if(!x)return n;const ce=Y.getItemDescription(L),te=g(x,ce,Q,z),pe=J[te];if(pe)return pe;const ye=h(x,ce,Y.getItemPath(L),z,Q);return J[te]=ye,ye}function h(L,z,Q,Y,J){const x=!Q||!Y.containsPathSeparator;return Q&&(O.$e?Y.pathNormalized===Q:(0,p.$lf)(Y.pathNormalized,Q))?{score:r,labelMatch:[{start:0,end:L.length}],descriptionMatch:z?[{start:0,end:z.length}]:void 0}:Y.values&&Y.values.length>1?c(L,z,Q,Y.values,x,J):u(L,z,Q,Y,x,J)}function c(L,z,Q,Y,J,x){let ce=0;const te=[],pe=[];for(const ye of Y){const{score:_,labelMatch:U,descriptionMatch:he}=u(L,z,Q,ye,J,x);if(_===$)return n;ce+=_,U&&te.push(...U),he&&pe.push(...he)}return{score:ce,labelMatch:E(te),descriptionMatch:E(pe)}}function u(L,z,Q,Y,J,x){if(J||!z){const[ce,te]=A(L,Y.normalized,Y.normalizedLowercase,x&&!Y.expectContiguousMatch);if(ce){const pe=(0,R.$kk)(Y.normalized,L);let ye;if(pe){ye=s;const _=Math.round(Y.normalized.length/L.length*100);ye+=_}else ye=t;return{score:ye+ce,labelMatch:pe||f(te)}}}if(z){let ce=z;Q&&(ce=`${z}${M.sep}`);const te=ce.length,pe=`${ce}${L}`,[ye,_]=A(pe,Y.normalized,Y.normalizedLowercase,x&&!Y.expectContiguousMatch);if(ye){const U=f(_),he=[],Se=[];return U.forEach(me=>{me.start<te&&me.end>te?(he.push({start:0,end:me.end-te}),Se.push({start:me.start,end:te})):me.start>=te?he.push({start:me.start-te,end:me.end-te}):Se.push(me)}),{score:ye,labelMatch:he,descriptionMatch:Se}}}return n}function f(L){const z=[];if(!L)return z;let Q;for(const Y of L)Q&&Q.end===Y?Q.end+=1:(Q={start:Y,end:Y+1},z.push(Q));return z}function E(L){const z=L.sort((J,x)=>J.start-x.start),Q=[];let Y;for(const J of z)!Y||!v(Y,J)?(Y=J,Q.push(J)):(Y.start=Math.min(Y.start,J.start),Y.end=Math.max(Y.end,J.end));return Q}function v(L,z){return!(L.end<z.start||z.end<L.start)}function D(L,z,Q,Y,J,x){const ce=d(L,Q,Y,J,x),te=d(z,Q,Y,J,x),pe=ce.score,ye=te.score;if((pe===r||ye===r)&&pe!==ye)return pe===r?-1:1;if(pe>t||ye>t){if(pe!==ye)return pe>ye?-1:1;if(pe<s&&ye<s){const se=S(ce.labelMatch,te.labelMatch);if(se!==0)return se}const me=J.getItemLabel(L)||"",ie=J.getItemLabel(z)||"";if(me.length!==ie.length)return me.length-ie.length}if(pe!==ye)return pe>ye?-1:1;const _=Array.isArray(ce.labelMatch)&&ce.labelMatch.length>0,U=Array.isArray(te.labelMatch)&&te.labelMatch.length>0;if(_&&!U)return-1;if(U&&!_)return 1;const he=k(L,ce,J),Se=k(z,te,J);return he&&Se&&he!==Se?Se>he?-1:1:F(L,z,Q,J)}function k(L,z,Q){let Y=-1,J=-1;if(z.descriptionMatch&&z.descriptionMatch.length?Y=z.descriptionMatch[0].start:z.labelMatch&&z.labelMatch.length&&(Y=z.labelMatch[0].start),z.labelMatch&&z.labelMatch.length){if(J=z.labelMatch[z.labelMatch.length-1].end,z.descriptionMatch&&z.descriptionMatch.length){const x=Q.getItemDescription(L);x&&(J+=x.length)}}else z.descriptionMatch&&z.descriptionMatch.length&&(J=z.descriptionMatch[z.descriptionMatch.length-1].end);return J-Y}function S(L,z){if(!L&&!z||(!L||!L.length)&&(!z||!z.length))return 0;if(!z||!z.length)return-1;if(!L||!L.length)return 1;const Q=L[0].start,J=L[L.length-1].end-Q,x=z[0].start,te=z[z.length-1].end-x;return J===te?0:te<J?1:-1}function F(L,z,Q,Y){const J=Y.getItemLabel(L)||"",x=Y.getItemLabel(z)||"",ce=Y.getItemDescription(L),te=Y.getItemDescription(z),pe=J.length+(ce?ce.length:0),ye=x.length+(te?te.length:0);if(pe!==ye)return pe-ye;const _=Y.getItemPath(L),U=Y.getItemPath(z);return _&&U&&_.length!==U.length?_.length-U.length:J!==x?(0,o.$cr)(J,x,Q.normalized):ce&&te&&ce!==te?(0,o.$cr)(ce,te,Q.normalized):_&&U&&_!==U?(0,o.$cr)(_,U,Q.normalized):0}function W(L){return L.startsWith('"')&&L.endsWith('"')}const B=" ";function T(L){typeof L!="string"&&(L="");const z=L.toLowerCase(),{pathNormalized:Q,normalized:Y,normalizedLowercase:J}=N(L),x=Q.indexOf(M.sep)>=0,ce=W(L);let te;const pe=L.split(B);if(pe.length>1)for(const ye of pe){const _=W(ye),{pathNormalized:U,normalized:he,normalizedLowercase:Se}=N(ye);he&&(te||(te=[]),te.push({original:ye,originalLowercase:ye.toLowerCase(),pathNormalized:U,normalized:he,normalizedLowercase:Se,expectContiguousMatch:_}))}return{original:L,originalLowercase:z,pathNormalized:Q,normalized:Y,normalizedLowercase:J,values:te,containsPathSeparator:x,expectContiguousMatch:ce}}function N(L){let z;O.$c?z=L.replace(/\//g,M.sep):z=L.replace(/\\/g,M.sep);const Q=(0,p.$8e)(z).replace(/\s|"/g,"");return{pathNormalized:z,normalized:Q,normalizedLowercase:Q.toLowerCase()}}function j(L){return Array.isArray(L)?T(L.map(z=>z.original).join(B)):T(L.original)}}),define(Ee[41],Ce([1,0,14]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var R;(function(I){I[I.Ignore=0]="Ignore",I[I.Info=1]="Info",I[I.Warning=2]="Warning",I[I.Error=3]="Error"})(R||(R={})),function(I){const M="error",O="warning",p="warn",$="info",w="ignore";function A(b){return b?o.$lf(M,b)?I.Error:o.$lf(O,b)||o.$lf(p,b)?I.Warning:o.$lf($,b)?I.Info:I.Ignore:I.Ignore}I.fromValue=A;function P(b){switch(b){case I.Error:return M;case I.Warning:return O;case I.Info:return $;default:return w}}I.toString=P}(R||(R={})),e.default=R}),define(Ee[170],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4d=void 0,e.$4d=Symbol("MicrotaskDelay")}),define(Ee[77],Ce([1,0,19,14]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=e.$ni=e.$mi=e.$li=e.$ki=void 0;class I{constructor(){this.b="",this.c=0}reset(C){return this.b=C,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(C){const y=C.charCodeAt(0),a=this.b.charCodeAt(this.c);return y-a}value(){return this.b[this.c]}}e.$ki=I;class M{constructor(C=!0){this.e=C}reset(C){return this.b=C,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let C=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(C)this.c++;else break;else C=!1;return this}cmp(C){return this.e?(0,R.$ff)(C,this.b,0,C.length,this.c,this.d):(0,R.$hf)(C,this.b,0,C.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$li=M;class O{constructor(C=!0,y=!0){this.f=C,this.g=y}reset(C){this.d=0,this.e=0,this.b=C,this.c=C.length;for(let y=C.length-1;y>=0;y--,this.c--){const a=this.b.charCodeAt(y);if(!(a===47||this.f&&a===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let C=!0;for(;this.e<this.c;this.e++){const y=this.b.charCodeAt(this.e);if(y===47||this.f&&y===92)if(C)this.d++;else break;else C=!1}return this}cmp(C){return this.g?(0,R.$ff)(C,this.b,0,C.length,this.d,this.e):(0,R.$hf)(C,this.b,0,C.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$mi=O;var p;(function(b){b[b.Scheme=1]="Scheme",b[b.Authority=2]="Authority",b[b.Path=3]="Path",b[b.Query=4]="Query",b[b.Fragment=5]="Fragment"})(p||(p={}));class ${constructor(C,y){this.f=C,this.g=y,this.d=[],this.e=0}reset(C){return this.c=C,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new O(!1,!this.f(C)),this.b.reset(C.path),this.b.value()&&this.d.push(3)),this.g(C)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(C){if(this.d[this.e]===1)return(0,R.$gf)(C,this.c.scheme);if(this.d[this.e]===2)return(0,R.$gf)(C,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(C);if(this.d[this.e]===4)return(0,R.$ef)(C,this.c.query);if(this.d[this.e]===5)return(0,R.$ef)(C,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$ni=$;class w{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const C=this.right;return this.right=C.left,C.left=this,this.updateHeight(),C.updateHeight(),C}rotateRight(){const C=this.left;return this.left=C.right,C.right=this,this.updateHeight(),C.updateHeight(),C}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var A;(function(b){b[b.Left=-1]="Left",b[b.Mid=0]="Mid",b[b.Right=1]="Right"})(A||(A={}));class P{static forUris(C=()=>!1,y=()=>!1){return new P(new $(C,y))}static forPaths(C=!1){return new P(new O(void 0,!C))}static forStrings(){return new P(new I)}static forConfigKeys(){return new P(new M)}constructor(C){this.b=C}clear(){this.c=void 0}fill(C,y){if(y){const a=y.slice(0);(0,o.$Xb)(a);for(const m of a)this.set(m,C)}else{const a=C.slice(0);(0,o.$Xb)(a);for(const m of a)this.set(m[0],m[1])}}set(C,y){const a=this.b.reset(C);let m;this.c||(this.c=new w,this.c.segment=a.value());const l=[];for(m=this.c;;){const n=a.cmp(m.segment);if(n>0)m.left||(m.left=new w,m.left.segment=a.value()),l.push([-1,m]),m=m.left;else if(n<0)m.right||(m.right=new w,m.right.segment=a.value()),l.push([1,m]),m=m.right;else if(a.hasNext())a.next(),m.mid||(m.mid=new w,m.mid.segment=a.value()),l.push([0,m]),m=m.mid;else break}const i=m.value;m.value=y,m.key=C;for(let n=l.length-1;n>=0;n--){const r=l[n][1];r.updateHeight();const s=r.balanceFactor();if(s<-1||s>1){const t=l[n][0],g=l[n+1][0];if(t===1&&g===1)l[n][1]=r.rotateLeft();else if(t===-1&&g===-1)l[n][1]=r.rotateRight();else if(t===1&&g===-1)r.right=l[n+1][1]=l[n+1][1].rotateRight(),l[n][1]=r.rotateLeft();else if(t===-1&&g===1)r.left=l[n+1][1]=l[n+1][1].rotateLeft(),l[n][1]=r.rotateRight();else throw new Error;if(n>0)switch(l[n-1][0]){case-1:l[n-1][1].left=l[n][1];break;case 1:l[n-1][1].right=l[n][1];break;case 0:l[n-1][1].mid=l[n][1];break}else this.c=l[0][1]}}return i}get(C){return this.d(C)?.value}d(C){const y=this.b.reset(C);let a=this.c;for(;a;){const m=y.cmp(a.segment);if(m>0)a=a.left;else if(m<0)a=a.right;else if(y.hasNext())y.next(),a=a.mid;else break}return a}has(C){const y=this.d(C);return!(y?.value===void 0&&y?.mid===void 0)}delete(C){return this.e(C,!1)}deleteSuperstr(C){return this.e(C,!0)}e(C,y){const a=this.b.reset(C),m=[];let l=this.c;for(;l;){const i=a.cmp(l.segment);if(i>0)m.push([-1,l]),l=l.left;else if(i<0)m.push([1,l]),l=l.right;else if(a.hasNext())a.next(),m.push([0,l]),l=l.mid;else break}if(l){if(y?(l.left=void 0,l.mid=void 0,l.right=void 0,l.height=1):(l.key=void 0,l.value=void 0),!l.mid&&!l.value)if(l.left&&l.right){const i=this.f(l.right);if(i.key){const{key:n,value:r,segment:s}=i;this.e(i.key,!1),l.key=n,l.value=r,l.segment=s}}else{const i=l.left??l.right;if(m.length>0){const[n,r]=m[m.length-1];switch(n){case-1:r.left=i;break;case 0:r.mid=i;break;case 1:r.right=i;break}}else this.c=i}for(let i=m.length-1;i>=0;i--){const n=m[i][1];n.updateHeight();const r=n.balanceFactor();if(r>1?(n.right.balanceFactor()>=0||(n.right=n.right.rotateRight()),m[i][1]=n.rotateLeft()):r<-1&&(n.left.balanceFactor()<=0||(n.left=n.left.rotateLeft()),m[i][1]=n.rotateRight()),i>0)switch(m[i-1][0]){case-1:m[i-1][1].left=m[i][1];break;case 1:m[i-1][1].right=m[i][1];break;case 0:m[i-1][1].mid=m[i][1];break}else this.c=m[0][1]}}}f(C){for(;C.left;)C=C.left;return C}findSubstr(C){const y=this.b.reset(C);let a=this.c,m;for(;a;){const l=y.cmp(a.segment);if(l>0)a=a.left;else if(l<0)a=a.right;else if(y.hasNext())y.next(),m=a.value||m,a=a.mid;else break}return a&&a.value||m}findSuperstr(C){return this.g(C,!1)}g(C,y){const a=this.b.reset(C);let m=this.c;for(;m;){const l=a.cmp(m.segment);if(l>0)m=m.left;else if(l<0)m=m.right;else if(a.hasNext())a.next(),m=m.mid;else return m.mid?this.h(m.mid):y?m.value:void 0}}hasElementOrSubtree(C){return this.g(C,!0)!==void 0}forEach(C){for(const[y,a]of this)C(a,y)}*[Symbol.iterator](){yield*this.h(this.c)}h(C){const y=[];return this.j(C,y),y[Symbol.iterator]()}j(C,y){C&&(C.left&&this.j(C.left,y),C.value&&y.push([C.key,C.value]),C.mid&&this.j(C.mid,y),C.right&&this.j(C.right,y))}_isBalanced(){const C=y=>{if(!y)return!0;const a=y.balanceFactor();return a<-1||a>1?!1:C(y.left)&&C(y.right)};return C(this.c)}}e.$oi=P}),define(Ee[18],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vf=o,e.$Wf=R,e.$Xf=I,e.$Yf=M,e.$Zf=O,e.$1f=p,e.$2f=$,e.$3f=w,e.$4f=A,e.$5f=P,e.$6f=b,e.$7f=C,e.$8f=y,e.$9f=m,e.$0f=l,e.$$f=i,e.$_f=n,e.$ag=r;function o(s){return typeof s=="string"}function R(s){return Array.isArray(s)&&s.every(t=>o(t))}function I(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}function M(s){const t=Object.getPrototypeOf(Uint8Array);return typeof s=="object"&&s instanceof t}function O(s){return typeof s=="number"&&!isNaN(s)}function p(s){return!!s&&typeof s[Symbol.iterator]=="function"}function $(s){return s===!0||s===!1}function w(s){return typeof s>"u"}function A(s){return!P(s)}function P(s){return w(s)||s===null}function b(s,t){if(!s)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function C(s){if(P(s))throw new Error("Assertion Failed: argument is undefined or null");return s}function y(...s){const t=[];for(let g=0;g<s.length;g++){const d=s[g];if(P(d))throw new Error(`Assertion Failed: argument at index ${g} is undefined or null`);t.push(d)}return t}const a=Object.prototype.hasOwnProperty;function m(s){if(!I(s))return!1;for(const t in s)if(a.call(s,t))return!1;return!0}function l(s){return typeof s=="function"}function i(...s){return s.length>0&&s.every(l)}function n(s,t){const g=Math.min(s.length,t.length);for(let d=0;d<g;d++)r(s[d],t[d])}function r(s,t){if(o(t)){if(typeof s!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(l(t)){try{if(s instanceof t)return}catch{}if(!P(s)&&s.constructor===t||t.length===1&&t.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(Ee[101],Ce([1,0,18]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cj=I,e.$Dj=M;const R=Object.create(null);function I(O,p){if((0,o.$Vf)(p)){const $=R[p];if($===void 0)throw new Error(`${O} references an unknown codicon: ${p}`);p=$}return R[O]=p,{id:O}}function M(){return R}}),define(Ee[171],Ce([1,0,101]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ej=void 0,e.$Ej={add:(0,o.$Cj)("add",6e4),plus:(0,o.$Cj)("plus",6e4),gistNew:(0,o.$Cj)("gist-new",6e4),repoCreate:(0,o.$Cj)("repo-create",6e4),lightbulb:(0,o.$Cj)("lightbulb",60001),lightBulb:(0,o.$Cj)("light-bulb",60001),repo:(0,o.$Cj)("repo",60002),repoDelete:(0,o.$Cj)("repo-delete",60002),gistFork:(0,o.$Cj)("gist-fork",60003),repoForked:(0,o.$Cj)("repo-forked",60003),gitPullRequest:(0,o.$Cj)("git-pull-request",60004),gitPullRequestAbandoned:(0,o.$Cj)("git-pull-request-abandoned",60004),recordKeys:(0,o.$Cj)("record-keys",60005),keyboard:(0,o.$Cj)("keyboard",60005),tag:(0,o.$Cj)("tag",60006),gitPullRequestLabel:(0,o.$Cj)("git-pull-request-label",60006),tagAdd:(0,o.$Cj)("tag-add",60006),tagRemove:(0,o.$Cj)("tag-remove",60006),person:(0,o.$Cj)("person",60007),personFollow:(0,o.$Cj)("person-follow",60007),personOutline:(0,o.$Cj)("person-outline",60007),personFilled:(0,o.$Cj)("person-filled",60007),gitBranch:(0,o.$Cj)("git-branch",60008),gitBranchCreate:(0,o.$Cj)("git-branch-create",60008),gitBranchDelete:(0,o.$Cj)("git-branch-delete",60008),sourceControl:(0,o.$Cj)("source-control",60008),mirror:(0,o.$Cj)("mirror",60009),mirrorPublic:(0,o.$Cj)("mirror-public",60009),star:(0,o.$Cj)("star",60010),starAdd:(0,o.$Cj)("star-add",60010),starDelete:(0,o.$Cj)("star-delete",60010),starEmpty:(0,o.$Cj)("star-empty",60010),comment:(0,o.$Cj)("comment",60011),commentAdd:(0,o.$Cj)("comment-add",60011),alert:(0,o.$Cj)("alert",60012),warning:(0,o.$Cj)("warning",60012),search:(0,o.$Cj)("search",60013),searchSave:(0,o.$Cj)("search-save",60013),logOut:(0,o.$Cj)("log-out",60014),signOut:(0,o.$Cj)("sign-out",60014),logIn:(0,o.$Cj)("log-in",60015),signIn:(0,o.$Cj)("sign-in",60015),eye:(0,o.$Cj)("eye",60016),eyeUnwatch:(0,o.$Cj)("eye-unwatch",60016),eyeWatch:(0,o.$Cj)("eye-watch",60016),circleFilled:(0,o.$Cj)("circle-filled",60017),primitiveDot:(0,o.$Cj)("primitive-dot",60017),closeDirty:(0,o.$Cj)("close-dirty",60017),debugBreakpoint:(0,o.$Cj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,o.$Cj)("debug-breakpoint-disabled",60017),debugHint:(0,o.$Cj)("debug-hint",60017),terminalDecorationSuccess:(0,o.$Cj)("terminal-decoration-success",60017),primitiveSquare:(0,o.$Cj)("primitive-square",60018),edit:(0,o.$Cj)("edit",60019),pencil:(0,o.$Cj)("pencil",60019),info:(0,o.$Cj)("info",60020),issueOpened:(0,o.$Cj)("issue-opened",60020),gistPrivate:(0,o.$Cj)("gist-private",60021),gitForkPrivate:(0,o.$Cj)("git-fork-private",60021),lock:(0,o.$Cj)("lock",60021),mirrorPrivate:(0,o.$Cj)("mirror-private",60021),close:(0,o.$Cj)("close",60022),removeClose:(0,o.$Cj)("remove-close",60022),x:(0,o.$Cj)("x",60022),repoSync:(0,o.$Cj)("repo-sync",60023),sync:(0,o.$Cj)("sync",60023),clone:(0,o.$Cj)("clone",60024),desktopDownload:(0,o.$Cj)("desktop-download",60024),beaker:(0,o.$Cj)("beaker",60025),microscope:(0,o.$Cj)("microscope",60025),vm:(0,o.$Cj)("vm",60026),deviceDesktop:(0,o.$Cj)("device-desktop",60026),file:(0,o.$Cj)("file",60027),fileText:(0,o.$Cj)("file-text",60027),more:(0,o.$Cj)("more",60028),ellipsis:(0,o.$Cj)("ellipsis",60028),kebabHorizontal:(0,o.$Cj)("kebab-horizontal",60028),mailReply:(0,o.$Cj)("mail-reply",60029),reply:(0,o.$Cj)("reply",60029),organization:(0,o.$Cj)("organization",60030),organizationFilled:(0,o.$Cj)("organization-filled",60030),organizationOutline:(0,o.$Cj)("organization-outline",60030),newFile:(0,o.$Cj)("new-file",60031),fileAdd:(0,o.$Cj)("file-add",60031),newFolder:(0,o.$Cj)("new-folder",60032),fileDirectoryCreate:(0,o.$Cj)("file-directory-create",60032),trash:(0,o.$Cj)("trash",60033),trashcan:(0,o.$Cj)("trashcan",60033),history:(0,o.$Cj)("history",60034),clock:(0,o.$Cj)("clock",60034),folder:(0,o.$Cj)("folder",60035),fileDirectory:(0,o.$Cj)("file-directory",60035),symbolFolder:(0,o.$Cj)("symbol-folder",60035),logoGithub:(0,o.$Cj)("logo-github",60036),markGithub:(0,o.$Cj)("mark-github",60036),github:(0,o.$Cj)("github",60036),terminal:(0,o.$Cj)("terminal",60037),console:(0,o.$Cj)("console",60037),repl:(0,o.$Cj)("repl",60037),zap:(0,o.$Cj)("zap",60038),symbolEvent:(0,o.$Cj)("symbol-event",60038),error:(0,o.$Cj)("error",60039),stop:(0,o.$Cj)("stop",60039),variable:(0,o.$Cj)("variable",60040),symbolVariable:(0,o.$Cj)("symbol-variable",60040),array:(0,o.$Cj)("array",60042),symbolArray:(0,o.$Cj)("symbol-array",60042),symbolModule:(0,o.$Cj)("symbol-module",60043),symbolPackage:(0,o.$Cj)("symbol-package",60043),symbolNamespace:(0,o.$Cj)("symbol-namespace",60043),symbolObject:(0,o.$Cj)("symbol-object",60043),symbolMethod:(0,o.$Cj)("symbol-method",60044),symbolFunction:(0,o.$Cj)("symbol-function",60044),symbolConstructor:(0,o.$Cj)("symbol-constructor",60044),symbolBoolean:(0,o.$Cj)("symbol-boolean",60047),symbolNull:(0,o.$Cj)("symbol-null",60047),symbolNumeric:(0,o.$Cj)("symbol-numeric",60048),symbolNumber:(0,o.$Cj)("symbol-number",60048),symbolStructure:(0,o.$Cj)("symbol-structure",60049),symbolStruct:(0,o.$Cj)("symbol-struct",60049),symbolParameter:(0,o.$Cj)("symbol-parameter",60050),symbolTypeParameter:(0,o.$Cj)("symbol-type-parameter",60050),symbolKey:(0,o.$Cj)("symbol-key",60051),symbolText:(0,o.$Cj)("symbol-text",60051),symbolReference:(0,o.$Cj)("symbol-reference",60052),goToFile:(0,o.$Cj)("go-to-file",60052),symbolEnum:(0,o.$Cj)("symbol-enum",60053),symbolValue:(0,o.$Cj)("symbol-value",60053),symbolRuler:(0,o.$Cj)("symbol-ruler",60054),symbolUnit:(0,o.$Cj)("symbol-unit",60054),activateBreakpoints:(0,o.$Cj)("activate-breakpoints",60055),archive:(0,o.$Cj)("archive",60056),arrowBoth:(0,o.$Cj)("arrow-both",60057),arrowDown:(0,o.$Cj)("arrow-down",60058),arrowLeft:(0,o.$Cj)("arrow-left",60059),arrowRight:(0,o.$Cj)("arrow-right",60060),arrowSmallDown:(0,o.$Cj)("arrow-small-down",60061),arrowSmallLeft:(0,o.$Cj)("arrow-small-left",60062),arrowSmallRight:(0,o.$Cj)("arrow-small-right",60063),arrowSmallUp:(0,o.$Cj)("arrow-small-up",60064),arrowUp:(0,o.$Cj)("arrow-up",60065),bell:(0,o.$Cj)("bell",60066),bold:(0,o.$Cj)("bold",60067),book:(0,o.$Cj)("book",60068),bookmark:(0,o.$Cj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,o.$Cj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,o.$Cj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,o.$Cj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,o.$Cj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,o.$Cj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,o.$Cj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,o.$Cj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,o.$Cj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,o.$Cj)("debug-breakpoint-log-disabled",60075),briefcase:(0,o.$Cj)("briefcase",60076),broadcast:(0,o.$Cj)("broadcast",60077),browser:(0,o.$Cj)("browser",60078),bug:(0,o.$Cj)("bug",60079),calendar:(0,o.$Cj)("calendar",60080),caseSensitive:(0,o.$Cj)("case-sensitive",60081),check:(0,o.$Cj)("check",60082),checklist:(0,o.$Cj)("checklist",60083),chevronDown:(0,o.$Cj)("chevron-down",60084),chevronLeft:(0,o.$Cj)("chevron-left",60085),chevronRight:(0,o.$Cj)("chevron-right",60086),chevronUp:(0,o.$Cj)("chevron-up",60087),chromeClose:(0,o.$Cj)("chrome-close",60088),chromeMaximize:(0,o.$Cj)("chrome-maximize",60089),chromeMinimize:(0,o.$Cj)("chrome-minimize",60090),chromeRestore:(0,o.$Cj)("chrome-restore",60091),circleOutline:(0,o.$Cj)("circle-outline",60092),circle:(0,o.$Cj)("circle",60092),debugBreakpointUnverified:(0,o.$Cj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,o.$Cj)("terminal-decoration-incomplete",60092),circleSlash:(0,o.$Cj)("circle-slash",60093),circuitBoard:(0,o.$Cj)("circuit-board",60094),clearAll:(0,o.$Cj)("clear-all",60095),clippy:(0,o.$Cj)("clippy",60096),closeAll:(0,o.$Cj)("close-all",60097),cloudDownload:(0,o.$Cj)("cloud-download",60098),cloudUpload:(0,o.$Cj)("cloud-upload",60099),code:(0,o.$Cj)("code",60100),collapseAll:(0,o.$Cj)("collapse-all",60101),colorMode:(0,o.$Cj)("color-mode",60102),commentDiscussion:(0,o.$Cj)("comment-discussion",60103),creditCard:(0,o.$Cj)("credit-card",60105),dash:(0,o.$Cj)("dash",60108),dashboard:(0,o.$Cj)("dashboard",60109),database:(0,o.$Cj)("database",60110),debugContinue:(0,o.$Cj)("debug-continue",60111),debugDisconnect:(0,o.$Cj)("debug-disconnect",60112),debugPause:(0,o.$Cj)("debug-pause",60113),debugRestart:(0,o.$Cj)("debug-restart",60114),debugStart:(0,o.$Cj)("debug-start",60115),debugStepInto:(0,o.$Cj)("debug-step-into",60116),debugStepOut:(0,o.$Cj)("debug-step-out",60117),debugStepOver:(0,o.$Cj)("debug-step-over",60118),debugStop:(0,o.$Cj)("debug-stop",60119),debug:(0,o.$Cj)("debug",60120),deviceCameraVideo:(0,o.$Cj)("device-camera-video",60121),deviceCamera:(0,o.$Cj)("device-camera",60122),deviceMobile:(0,o.$Cj)("device-mobile",60123),diffAdded:(0,o.$Cj)("diff-added",60124),diffIgnored:(0,o.$Cj)("diff-ignored",60125),diffModified:(0,o.$Cj)("diff-modified",60126),diffRemoved:(0,o.$Cj)("diff-removed",60127),diffRenamed:(0,o.$Cj)("diff-renamed",60128),diff:(0,o.$Cj)("diff",60129),diffSidebyside:(0,o.$Cj)("diff-sidebyside",60129),discard:(0,o.$Cj)("discard",60130),editorLayout:(0,o.$Cj)("editor-layout",60131),emptyWindow:(0,o.$Cj)("empty-window",60132),exclude:(0,o.$Cj)("exclude",60133),extensions:(0,o.$Cj)("extensions",60134),eyeClosed:(0,o.$Cj)("eye-closed",60135),fileBinary:(0,o.$Cj)("file-binary",60136),fileCode:(0,o.$Cj)("file-code",60137),fileMedia:(0,o.$Cj)("file-media",60138),filePdf:(0,o.$Cj)("file-pdf",60139),fileSubmodule:(0,o.$Cj)("file-submodule",60140),fileSymlinkDirectory:(0,o.$Cj)("file-symlink-directory",60141),fileSymlinkFile:(0,o.$Cj)("file-symlink-file",60142),fileZip:(0,o.$Cj)("file-zip",60143),files:(0,o.$Cj)("files",60144),filter:(0,o.$Cj)("filter",60145),flame:(0,o.$Cj)("flame",60146),foldDown:(0,o.$Cj)("fold-down",60147),foldUp:(0,o.$Cj)("fold-up",60148),fold:(0,o.$Cj)("fold",60149),folderActive:(0,o.$Cj)("folder-active",60150),folderOpened:(0,o.$Cj)("folder-opened",60151),gear:(0,o.$Cj)("gear",60152),gift:(0,o.$Cj)("gift",60153),gistSecret:(0,o.$Cj)("gist-secret",60154),gist:(0,o.$Cj)("gist",60155),gitCommit:(0,o.$Cj)("git-commit",60156),gitCompare:(0,o.$Cj)("git-compare",60157),compareChanges:(0,o.$Cj)("compare-changes",60157),gitMerge:(0,o.$Cj)("git-merge",60158),githubAction:(0,o.$Cj)("github-action",60159),githubAlt:(0,o.$Cj)("github-alt",60160),globe:(0,o.$Cj)("globe",60161),grabber:(0,o.$Cj)("grabber",60162),graph:(0,o.$Cj)("graph",60163),gripper:(0,o.$Cj)("gripper",60164),heart:(0,o.$Cj)("heart",60165),home:(0,o.$Cj)("home",60166),horizontalRule:(0,o.$Cj)("horizontal-rule",60167),hubot:(0,o.$Cj)("hubot",60168),inbox:(0,o.$Cj)("inbox",60169),issueReopened:(0,o.$Cj)("issue-reopened",60171),issues:(0,o.$Cj)("issues",60172),italic:(0,o.$Cj)("italic",60173),jersey:(0,o.$Cj)("jersey",60174),json:(0,o.$Cj)("json",60175),kebabVertical:(0,o.$Cj)("kebab-vertical",60176),key:(0,o.$Cj)("key",60177),law:(0,o.$Cj)("law",60178),lightbulbAutofix:(0,o.$Cj)("lightbulb-autofix",60179),linkExternal:(0,o.$Cj)("link-external",60180),link:(0,o.$Cj)("link",60181),listOrdered:(0,o.$Cj)("list-ordered",60182),listUnordered:(0,o.$Cj)("list-unordered",60183),liveShare:(0,o.$Cj)("live-share",60184),loading:(0,o.$Cj)("loading",60185),location:(0,o.$Cj)("location",60186),mailRead:(0,o.$Cj)("mail-read",60187),mail:(0,o.$Cj)("mail",60188),markdown:(0,o.$Cj)("markdown",60189),megaphone:(0,o.$Cj)("megaphone",60190),mention:(0,o.$Cj)("mention",60191),milestone:(0,o.$Cj)("milestone",60192),gitPullRequestMilestone:(0,o.$Cj)("git-pull-request-milestone",60192),mortarBoard:(0,o.$Cj)("mortar-board",60193),move:(0,o.$Cj)("move",60194),multipleWindows:(0,o.$Cj)("multiple-windows",60195),mute:(0,o.$Cj)("mute",60196),noNewline:(0,o.$Cj)("no-newline",60197),note:(0,o.$Cj)("note",60198),octoface:(0,o.$Cj)("octoface",60199),openPreview:(0,o.$Cj)("open-preview",60200),package:(0,o.$Cj)("package",60201),paintcan:(0,o.$Cj)("paintcan",60202),pin:(0,o.$Cj)("pin",60203),play:(0,o.$Cj)("play",60204),run:(0,o.$Cj)("run",60204),plug:(0,o.$Cj)("plug",60205),preserveCase:(0,o.$Cj)("preserve-case",60206),preview:(0,o.$Cj)("preview",60207),project:(0,o.$Cj)("project",60208),pulse:(0,o.$Cj)("pulse",60209),question:(0,o.$Cj)("question",60210),quote:(0,o.$Cj)("quote",60211),radioTower:(0,o.$Cj)("radio-tower",60212),reactions:(0,o.$Cj)("reactions",60213),references:(0,o.$Cj)("references",60214),refresh:(0,o.$Cj)("refresh",60215),regex:(0,o.$Cj)("regex",60216),remoteExplorer:(0,o.$Cj)("remote-explorer",60217),remote:(0,o.$Cj)("remote",60218),remove:(0,o.$Cj)("remove",60219),replaceAll:(0,o.$Cj)("replace-all",60220),replace:(0,o.$Cj)("replace",60221),repoClone:(0,o.$Cj)("repo-clone",60222),repoForcePush:(0,o.$Cj)("repo-force-push",60223),repoPull:(0,o.$Cj)("repo-pull",60224),repoPush:(0,o.$Cj)("repo-push",60225),report:(0,o.$Cj)("report",60226),requestChanges:(0,o.$Cj)("request-changes",60227),rocket:(0,o.$Cj)("rocket",60228),rootFolderOpened:(0,o.$Cj)("root-folder-opened",60229),rootFolder:(0,o.$Cj)("root-folder",60230),rss:(0,o.$Cj)("rss",60231),ruby:(0,o.$Cj)("ruby",60232),saveAll:(0,o.$Cj)("save-all",60233),saveAs:(0,o.$Cj)("save-as",60234),save:(0,o.$Cj)("save",60235),screenFull:(0,o.$Cj)("screen-full",60236),screenNormal:(0,o.$Cj)("screen-normal",60237),searchStop:(0,o.$Cj)("search-stop",60238),server:(0,o.$Cj)("server",60240),settingsGear:(0,o.$Cj)("settings-gear",60241),settings:(0,o.$Cj)("settings",60242),shield:(0,o.$Cj)("shield",60243),smiley:(0,o.$Cj)("smiley",60244),sortPrecedence:(0,o.$Cj)("sort-precedence",60245),splitHorizontal:(0,o.$Cj)("split-horizontal",60246),splitVertical:(0,o.$Cj)("split-vertical",60247),squirrel:(0,o.$Cj)("squirrel",60248),starFull:(0,o.$Cj)("star-full",60249),starHalf:(0,o.$Cj)("star-half",60250),symbolClass:(0,o.$Cj)("symbol-class",60251),symbolColor:(0,o.$Cj)("symbol-color",60252),symbolConstant:(0,o.$Cj)("symbol-constant",60253),symbolEnumMember:(0,o.$Cj)("symbol-enum-member",60254),symbolField:(0,o.$Cj)("symbol-field",60255),symbolFile:(0,o.$Cj)("symbol-file",60256),symbolInterface:(0,o.$Cj)("symbol-interface",60257),symbolKeyword:(0,o.$Cj)("symbol-keyword",60258),symbolMisc:(0,o.$Cj)("symbol-misc",60259),symbolOperator:(0,o.$Cj)("symbol-operator",60260),symbolProperty:(0,o.$Cj)("symbol-property",60261),wrench:(0,o.$Cj)("wrench",60261),wrenchSubaction:(0,o.$Cj)("wrench-subaction",60261),symbolSnippet:(0,o.$Cj)("symbol-snippet",60262),tasklist:(0,o.$Cj)("tasklist",60263),telescope:(0,o.$Cj)("telescope",60264),textSize:(0,o.$Cj)("text-size",60265),threeBars:(0,o.$Cj)("three-bars",60266),thumbsdown:(0,o.$Cj)("thumbsdown",60267),thumbsup:(0,o.$Cj)("thumbsup",60268),tools:(0,o.$Cj)("tools",60269),triangleDown:(0,o.$Cj)("triangle-down",60270),triangleLeft:(0,o.$Cj)("triangle-left",60271),triangleRight:(0,o.$Cj)("triangle-right",60272),triangleUp:(0,o.$Cj)("triangle-up",60273),twitter:(0,o.$Cj)("twitter",60274),unfold:(0,o.$Cj)("unfold",60275),unlock:(0,o.$Cj)("unlock",60276),unmute:(0,o.$Cj)("unmute",60277),unverified:(0,o.$Cj)("unverified",60278),verified:(0,o.$Cj)("verified",60279),versions:(0,o.$Cj)("versions",60280),vmActive:(0,o.$Cj)("vm-active",60281),vmOutline:(0,o.$Cj)("vm-outline",60282),vmRunning:(0,o.$Cj)("vm-running",60283),watch:(0,o.$Cj)("watch",60284),whitespace:(0,o.$Cj)("whitespace",60285),wholeWord:(0,o.$Cj)("whole-word",60286),window:(0,o.$Cj)("window",60287),wordWrap:(0,o.$Cj)("word-wrap",60288),zoomIn:(0,o.$Cj)("zoom-in",60289),zoomOut:(0,o.$Cj)("zoom-out",60290),listFilter:(0,o.$Cj)("list-filter",60291),listFlat:(0,o.$Cj)("list-flat",60292),listSelection:(0,o.$Cj)("list-selection",60293),selection:(0,o.$Cj)("selection",60293),listTree:(0,o.$Cj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,o.$Cj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,o.$Cj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,o.$Cj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,o.$Cj)("debug-stackframe-active",60297),circleSmallFilled:(0,o.$Cj)("circle-small-filled",60298),debugStackframeDot:(0,o.$Cj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,o.$Cj)("terminal-decoration-mark",60298),debugStackframe:(0,o.$Cj)("debug-stackframe",60299),debugStackframeFocused:(0,o.$Cj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,o.$Cj)("debug-breakpoint-unsupported",60300),symbolString:(0,o.$Cj)("symbol-string",60301),debugReverseContinue:(0,o.$Cj)("debug-reverse-continue",60302),debugStepBack:(0,o.$Cj)("debug-step-back",60303),debugRestartFrame:(0,o.$Cj)("debug-restart-frame",60304),debugAlt:(0,o.$Cj)("debug-alt",60305),callIncoming:(0,o.$Cj)("call-incoming",60306),callOutgoing:(0,o.$Cj)("call-outgoing",60307),menu:(0,o.$Cj)("menu",60308),expandAll:(0,o.$Cj)("expand-all",60309),feedback:(0,o.$Cj)("feedback",60310),gitPullRequestReviewer:(0,o.$Cj)("git-pull-request-reviewer",60310),groupByRefType:(0,o.$Cj)("group-by-ref-type",60311),ungroupByRefType:(0,o.$Cj)("ungroup-by-ref-type",60312),account:(0,o.$Cj)("account",60313),gitPullRequestAssignee:(0,o.$Cj)("git-pull-request-assignee",60313),bellDot:(0,o.$Cj)("bell-dot",60314),debugConsole:(0,o.$Cj)("debug-console",60315),library:(0,o.$Cj)("library",60316),output:(0,o.$Cj)("output",60317),runAll:(0,o.$Cj)("run-all",60318),syncIgnored:(0,o.$Cj)("sync-ignored",60319),pinned:(0,o.$Cj)("pinned",60320),githubInverted:(0,o.$Cj)("github-inverted",60321),serverProcess:(0,o.$Cj)("server-process",60322),serverEnvironment:(0,o.$Cj)("server-environment",60323),pass:(0,o.$Cj)("pass",60324),issueClosed:(0,o.$Cj)("issue-closed",60324),stopCircle:(0,o.$Cj)("stop-circle",60325),playCircle:(0,o.$Cj)("play-circle",60326),record:(0,o.$Cj)("record",60327),debugAltSmall:(0,o.$Cj)("debug-alt-small",60328),vmConnect:(0,o.$Cj)("vm-connect",60329),cloud:(0,o.$Cj)("cloud",60330),merge:(0,o.$Cj)("merge",60331),export:(0,o.$Cj)("export",60332),graphLeft:(0,o.$Cj)("graph-left",60333),magnet:(0,o.$Cj)("magnet",60334),notebook:(0,o.$Cj)("notebook",60335),redo:(0,o.$Cj)("redo",60336),checkAll:(0,o.$Cj)("check-all",60337),pinnedDirty:(0,o.$Cj)("pinned-dirty",60338),passFilled:(0,o.$Cj)("pass-filled",60339),circleLargeFilled:(0,o.$Cj)("circle-large-filled",60340),circleLarge:(0,o.$Cj)("circle-large",60341),circleLargeOutline:(0,o.$Cj)("circle-large-outline",60341),combine:(0,o.$Cj)("combine",60342),gather:(0,o.$Cj)("gather",60342),table:(0,o.$Cj)("table",60343),variableGroup:(0,o.$Cj)("variable-group",60344),typeHierarchy:(0,o.$Cj)("type-hierarchy",60345),typeHierarchySub:(0,o.$Cj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,o.$Cj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,o.$Cj)("git-pull-request-create",60348),runAbove:(0,o.$Cj)("run-above",60349),runBelow:(0,o.$Cj)("run-below",60350),notebookTemplate:(0,o.$Cj)("notebook-template",60351),debugRerun:(0,o.$Cj)("debug-rerun",60352),workspaceTrusted:(0,o.$Cj)("workspace-trusted",60353),workspaceUntrusted:(0,o.$Cj)("workspace-untrusted",60354),workspaceUnknown:(0,o.$Cj)("workspace-unknown",60355),terminalCmd:(0,o.$Cj)("terminal-cmd",60356),terminalDebian:(0,o.$Cj)("terminal-debian",60357),terminalLinux:(0,o.$Cj)("terminal-linux",60358),terminalPowershell:(0,o.$Cj)("terminal-powershell",60359),terminalTmux:(0,o.$Cj)("terminal-tmux",60360),terminalUbuntu:(0,o.$Cj)("terminal-ubuntu",60361),terminalBash:(0,o.$Cj)("terminal-bash",60362),arrowSwap:(0,o.$Cj)("arrow-swap",60363),copy:(0,o.$Cj)("copy",60364),personAdd:(0,o.$Cj)("person-add",60365),filterFilled:(0,o.$Cj)("filter-filled",60366),wand:(0,o.$Cj)("wand",60367),debugLineByLine:(0,o.$Cj)("debug-line-by-line",60368),inspect:(0,o.$Cj)("inspect",60369),layers:(0,o.$Cj)("layers",60370),layersDot:(0,o.$Cj)("layers-dot",60371),layersActive:(0,o.$Cj)("layers-active",60372),compass:(0,o.$Cj)("compass",60373),compassDot:(0,o.$Cj)("compass-dot",60374),compassActive:(0,o.$Cj)("compass-active",60375),azure:(0,o.$Cj)("azure",60376),issueDraft:(0,o.$Cj)("issue-draft",60377),gitPullRequestClosed:(0,o.$Cj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,o.$Cj)("git-pull-request-draft",60379),debugAll:(0,o.$Cj)("debug-all",60380),debugCoverage:(0,o.$Cj)("debug-coverage",60381),runErrors:(0,o.$Cj)("run-errors",60382),folderLibrary:(0,o.$Cj)("folder-library",60383),debugContinueSmall:(0,o.$Cj)("debug-continue-small",60384),beakerStop:(0,o.$Cj)("beaker-stop",60385),graphLine:(0,o.$Cj)("graph-line",60386),graphScatter:(0,o.$Cj)("graph-scatter",60387),pieChart:(0,o.$Cj)("pie-chart",60388),bracket:(0,o.$Cj)("bracket",60175),bracketDot:(0,o.$Cj)("bracket-dot",60389),bracketError:(0,o.$Cj)("bracket-error",60390),lockSmall:(0,o.$Cj)("lock-small",60391),azureDevops:(0,o.$Cj)("azure-devops",60392),verifiedFilled:(0,o.$Cj)("verified-filled",60393),newline:(0,o.$Cj)("newline",60394),layout:(0,o.$Cj)("layout",60395),layoutActivitybarLeft:(0,o.$Cj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,o.$Cj)("layout-activitybar-right",60397),layoutPanelLeft:(0,o.$Cj)("layout-panel-left",60398),layoutPanelCenter:(0,o.$Cj)("layout-panel-center",60399),layoutPanelJustify:(0,o.$Cj)("layout-panel-justify",60400),layoutPanelRight:(0,o.$Cj)("layout-panel-right",60401),layoutPanel:(0,o.$Cj)("layout-panel",60402),layoutSidebarLeft:(0,o.$Cj)("layout-sidebar-left",60403),layoutSidebarRight:(0,o.$Cj)("layout-sidebar-right",60404),layoutStatusbar:(0,o.$Cj)("layout-statusbar",60405),layoutMenubar:(0,o.$Cj)("layout-menubar",60406),layoutCentered:(0,o.$Cj)("layout-centered",60407),target:(0,o.$Cj)("target",60408),indent:(0,o.$Cj)("indent",60409),recordSmall:(0,o.$Cj)("record-small",60410),errorSmall:(0,o.$Cj)("error-small",60411),terminalDecorationError:(0,o.$Cj)("terminal-decoration-error",60411),arrowCircleDown:(0,o.$Cj)("arrow-circle-down",60412),arrowCircleLeft:(0,o.$Cj)("arrow-circle-left",60413),arrowCircleRight:(0,o.$Cj)("arrow-circle-right",60414),arrowCircleUp:(0,o.$Cj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,o.$Cj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,o.$Cj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,o.$Cj)("layout-sidebar-left-off",60418),blank:(0,o.$Cj)("blank",60419),heartFilled:(0,o.$Cj)("heart-filled",60420),map:(0,o.$Cj)("map",60421),mapHorizontal:(0,o.$Cj)("map-horizontal",60421),foldHorizontal:(0,o.$Cj)("fold-horizontal",60421),mapFilled:(0,o.$Cj)("map-filled",60422),mapHorizontalFilled:(0,o.$Cj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,o.$Cj)("fold-horizontal-filled",60422),circleSmall:(0,o.$Cj)("circle-small",60423),bellSlash:(0,o.$Cj)("bell-slash",60424),bellSlashDot:(0,o.$Cj)("bell-slash-dot",60425),commentUnresolved:(0,o.$Cj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,o.$Cj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,o.$Cj)("git-pull-request-new-changes",60428),searchFuzzy:(0,o.$Cj)("search-fuzzy",60429),commentDraft:(0,o.$Cj)("comment-draft",60430),send:(0,o.$Cj)("send",60431),sparkle:(0,o.$Cj)("sparkle",60432),insert:(0,o.$Cj)("insert",60433),mic:(0,o.$Cj)("mic",60434),thumbsdownFilled:(0,o.$Cj)("thumbsdown-filled",60435),thumbsupFilled:(0,o.$Cj)("thumbsup-filled",60436),coffee:(0,o.$Cj)("coffee",60437),snake:(0,o.$Cj)("snake",60438),game:(0,o.$Cj)("game",60439),vr:(0,o.$Cj)("vr",60440),chip:(0,o.$Cj)("chip",60441),piano:(0,o.$Cj)("piano",60442),music:(0,o.$Cj)("music",60443),micFilled:(0,o.$Cj)("mic-filled",60444),repoFetch:(0,o.$Cj)("repo-fetch",60445),copilot:(0,o.$Cj)("copilot",60446),lightbulbSparkle:(0,o.$Cj)("lightbulb-sparkle",60447),robot:(0,o.$Cj)("robot",60448),sparkleFilled:(0,o.$Cj)("sparkle-filled",60449),diffSingle:(0,o.$Cj)("diff-single",60450),diffMultiple:(0,o.$Cj)("diff-multiple",60451),surroundWith:(0,o.$Cj)("surround-with",60452),share:(0,o.$Cj)("share",60453),gitStash:(0,o.$Cj)("git-stash",60454),gitStashApply:(0,o.$Cj)("git-stash-apply",60455),gitStashPop:(0,o.$Cj)("git-stash-pop",60456),vscode:(0,o.$Cj)("vscode",60457),vscodeInsiders:(0,o.$Cj)("vscode-insiders",60458),codeOss:(0,o.$Cj)("code-oss",60459),runCoverage:(0,o.$Cj)("run-coverage",60460),runAllCoverage:(0,o.$Cj)("run-all-coverage",60461),coverage:(0,o.$Cj)("coverage",60462),githubProject:(0,o.$Cj)("github-project",60463),mapVertical:(0,o.$Cj)("map-vertical",60464),foldVertical:(0,o.$Cj)("fold-vertical",60464),mapVerticalFilled:(0,o.$Cj)("map-vertical-filled",60465),foldVerticalFilled:(0,o.$Cj)("fold-vertical-filled",60465)}}),define(Ee[78],Ce([1,0,101,171]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hj=e.$Gj=void 0,e.$Fj=I;function I(){return Object.values(e.$Hj)}e.$Gj={dialogError:(0,o.$Cj)("dialog-error","error"),dialogWarning:(0,o.$Cj)("dialog-warning","warning"),dialogInfo:(0,o.$Cj)("dialog-info","info"),dialogClose:(0,o.$Cj)("dialog-close","close"),treeItemExpanded:(0,o.$Cj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,o.$Cj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,o.$Cj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,o.$Cj)("tree-filter-clear","close"),treeItemLoading:(0,o.$Cj)("tree-item-loading","loading"),menuSelection:(0,o.$Cj)("menu-selection","check"),menuSubmenu:(0,o.$Cj)("menu-submenu","chevron-right"),menuBarMore:(0,o.$Cj)("menubar-more","more"),scrollbarButtonLeft:(0,o.$Cj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,o.$Cj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,o.$Cj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,o.$Cj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,o.$Cj)("toolbar-more","more"),quickInputBack:(0,o.$Cj)("quick-input-back","arrow-left"),dropDownButton:(0,o.$Cj)("drop-down-button",60084),symbolCustomColor:(0,o.$Cj)("symbol-customcolor",60252),exportIcon:(0,o.$Cj)("export",60332),workspaceUnspecified:(0,o.$Cj)("workspace-unspecified",60355),newLine:(0,o.$Cj)("newline",60394),thumbsDownFilled:(0,o.$Cj)("thumbsdown-filled",60435),thumbsUpFilled:(0,o.$Cj)("thumbsup-filled",60436),gitFetch:(0,o.$Cj)("git-fetch",60445),lightbulbSparkleAutofix:(0,o.$Cj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,o.$Cj)("debug-breakpoint-pending",60377)},e.$Hj={...R.$Ej,...e.$Gj}}),define(Ee[34],Ce([1,0,17,11,14,18]),function(re,e,o,R,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bg=O,e.$cg=p,e.$dg=$,e.$eg=w,e.$fg=A,e.$gg=y,e.$hg=a,e.$ig=m,e.$jg=l,e.$kg=i,e.$lg=n,e.$mg=r,e.$ng=s,e.$og=t,e.$pg=g,e.$qg=c;function O(u){return u===47||u===92}function p(u){return u.replace(/[\\/]/g,o.$hc.sep)}function $(u){return u.indexOf("/")===-1&&(u=p(u)),/^[a-zA-Z]:(\/|$)/.test(u)&&(u="/"+u),u}function w(u,f=o.$hc.sep){if(!u)return"";const E=u.length,v=u.charCodeAt(0);if(O(v)){if(O(u.charCodeAt(1))&&!O(u.charCodeAt(2))){let k=3;const S=k;for(;k<E&&!O(u.charCodeAt(k));k++);if(S!==k&&!O(u.charCodeAt(k+1))){for(k+=1;k<E;k++)if(O(u.charCodeAt(k)))return u.slice(0,k+1).replace(/[\\/]/g,f)}}return f}else if(l(v)&&u.charCodeAt(1)===58)return O(u.charCodeAt(2))?u.slice(0,2)+f:u.slice(0,2);let D=u.indexOf("://");if(D!==-1){for(D+=3;D<E;D++)if(O(u.charCodeAt(D)))return u.slice(0,D+1)}return""}function A(u){if(!R.$c||!u||u.length<5)return!1;let f=u.charCodeAt(0);if(f!==92||(f=u.charCodeAt(1),f!==92))return!1;let E=2;const v=E;for(;E<u.length&&(f=u.charCodeAt(E),f!==92);E++);return!(v===E||(f=u.charCodeAt(E+1),isNaN(f)||f===92))}const P=/[\\/:\*\?"<>\|]/g,b=/[\\/]/g,C=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function y(u,f=R.$c){const E=f?P:b;return!(!u||u.length===0||/^\s+$/.test(u)||(E.lastIndex=0,E.test(u))||f&&C.test(u)||u==="."||u===".."||f&&u[u.length-1]==="."||f&&u.length!==u.trim().length||u.length>255)}function a(u,f,E){const v=u===f;return!E||v?v:!u||!f?!1:(0,I.$lf)(u,f)}function m(u,f,E,v=o.sep){if(u===f)return!0;if(!u||!f||f.length>u.length)return!1;if(E){if(!(0,I.$mf)(u,f))return!1;if(f.length===u.length)return!0;let k=f.length;return f.charAt(f.length-1)===v&&k--,u.charAt(k)===v}return f.charAt(f.length-1)!==v&&(f+=v),u.indexOf(f)===0}function l(u){return u>=65&&u<=90||u>=97&&u<=122}function i(u,f){return R.$c&&u.endsWith(":")&&(u+=o.sep),(0,o.$jc)(u)||(u=(0,o.$kc)(f,u)),u=(0,o.$ic)(u),R.$c?(u=(0,I.$6e)(u,o.sep),u.endsWith(":")&&(u+=o.sep)):(u=(0,I.$6e)(u,o.sep),u||(u=o.sep)),u}function n(u){const f=(0,o.$ic)(u);return R.$c?u.length>3?!1:r(f)&&(u.length===2||f.charCodeAt(2)===92):f===o.$hc.sep}function r(u,f=R.$c){return f?l(u.charCodeAt(0))&&u.charCodeAt(1)===58:!1}function s(u,f=R.$c){return r(u,f)?u[0]:void 0}function t(u,f,E){return f.length>u.length?-1:u===f?0:(E&&(u=u.toLowerCase(),f=f.toLowerCase()),u.indexOf(f))}function g(u){const f=u.split(":");let E,v,D;for(const k of f){const S=Number(k);(0,M.$Zf)(S)?v===void 0?v=S:D===void 0&&(D=S):E=E?[E,k].join(":"):k}if(!E)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:E,line:v!==void 0?v:void 0,column:D!==void 0?D:v!==void 0?1:void 0}}const d="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",h="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function c(u,f,E=8){let v="";for(let k=0;k<E;k++){let S;k===0&&R.$c&&!f&&(E===3||E===4)?S=h:S=d,v+=S.charAt(Math.floor(Math.random()*S.length))}let D;return f?D=`${f}-${v}`:D=v,u?(0,o.$kc)(u,D):D}}),define(Ee[24],Ce([1,0,18]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pn=R,e.$Qn=I,e.$Rn=O,e.$Sn=$,e.$Tn=w,e.$Un=A,e.$Vn=P,e.$Wn=b,e.$Xn=C,e.$Yn=y,e.$Zn=a,e.$1n=m;function R(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const i=Array.isArray(l)?[]:{};return Object.entries(l).forEach(([n,r])=>{i[n]=r&&typeof r=="object"?R(r):r}),i}function I(l){if(!l||typeof l!="object")return l;const i=[l];for(;i.length>0;){const n=i.shift();Object.freeze(n);for(const r in n)if(M.call(n,r)){const s=n[r];typeof s=="object"&&!Object.isFrozen(s)&&!(0,o.$Yf)(s)&&i.push(s)}}return l}const M=Object.prototype.hasOwnProperty;function O(l,i){return p(l,i,new Set)}function p(l,i,n){if((0,o.$5f)(l))return l;const r=i(l);if(typeof r<"u")return r;if(Array.isArray(l)){const s=[];for(const t of l)s.push(p(t,i,n));return s}if((0,o.$Xf)(l)){if(n.has(l))throw new Error("Cannot clone recursive data-structure");n.add(l);const s={};for(const t in l)M.call(l,t)&&(s[t]=p(l[t],i,n));return n.delete(l),s}return l}function $(l,i,n=!0){return(0,o.$Xf)(l)?((0,o.$Xf)(i)&&Object.keys(i).forEach(r=>{r in l?n&&((0,o.$Xf)(l[r])&&(0,o.$Xf)(i[r])?$(l[r],i[r],n):l[r]=i[r]):l[r]=i[r]}),l):i}function w(l,i){if(l===i)return!0;if(l==null||i===null||i===void 0||typeof l!=typeof i||typeof l!="object"||Array.isArray(l)!==Array.isArray(i))return!1;let n,r;if(Array.isArray(l)){if(l.length!==i.length)return!1;for(n=0;n<l.length;n++)if(!w(l[n],i[n]))return!1}else{const s=[];for(r in l)s.push(r);s.sort();const t=[];for(r in i)t.push(r);if(t.sort(),!w(s,t))return!1;for(n=0;n<s.length;n++)if(!w(l[s[n]],i[s[n]]))return!1}return!0}function A(l){const i=new Set;return JSON.stringify(l,(n,r)=>{if((0,o.$Xf)(r)||Array.isArray(r)){if(i.has(r))return"[Circular]";i.add(r)}return r})}function P(l,i){const n=Object.create(null);return!l||!i||Object.keys(i).forEach(s=>{const t=l[s],g=i[s];w(t,g)||(n[s]=g)}),n}function b(l,i){const n=i.toLowerCase(),r=Object.keys(l).find(s=>s.toLowerCase()===n);return r?l[r]:l[i]}function C(l,i){const n=Object.create(null);for(const[r,s]of Object.entries(l))i(r,s)&&(n[r]=s);return n}function y(l){let i=[];for(;Object.prototype!==l;)i=i.concat(Object.getOwnPropertyNames(l)),l=Object.getPrototypeOf(l);return i}function a(l){const i=[];for(const n of y(l))typeof l[n]=="function"&&i.push(n);return i}function m(l,i){const n=s=>function(){const t=Array.prototype.slice.call(arguments,0);return i(s,t)},r={};for(const s of l)r[s]=n(s);return r}}),define(Ee[56],Ce([1,0,78]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$Ij=I;var R;(function(O){function p($){return $&&typeof $=="object"&&typeof $.id=="string"}O.isThemeColor=p})(R||(e.ThemeColor=R={}));function I(O){return{id:O}}var M;(function(O){O.iconNameSegment="[A-Za-z0-9]+",O.iconNameExpression="[A-Za-z0-9-]+",O.iconModifierExpression="~[A-Za-z]+",O.iconNameCharacter="[A-Za-z0-9~-]";const p=new RegExp(`^(${O.iconNameExpression})(${O.iconModifierExpression})?$`);function $(i){const n=p.exec(i.id);if(!n)return $(o.$Hj.error);const[,r,s]=n,t=["codicon","codicon-"+r];return s&&t.push("codicon-modifier-"+s.substring(1)),t}O.asClassNameArray=$;function w(i){return $(i).join(" ")}O.asClassName=w;function A(i){return"."+$(i).join(".")}O.asCSSSelector=A;function P(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color>"u"||R.isThemeColor(i.color))}O.isThemeIcon=P;const b=new RegExp(`^\\$\\((${O.iconNameExpression}(?:${O.iconModifierExpression})?)\\)$`);function C(i){const n=b.exec(i);if(!n)return;const[,r]=n;return{id:r}}O.fromString=C;function y(i){return{id:i}}O.fromId=y;function a(i,n){let r=i.id;const s=r.lastIndexOf("~");return s!==-1&&(r=r.substring(0,s)),n&&(r=`${r}~${n}`),{id:r}}O.modify=a;function m(i){const n=i.id.lastIndexOf("~");if(n!==-1)return i.id.substring(n+1)}O.getModifier=m;function l(i,n){return i.id===n.id&&i.color?.id===n.color?.id}O.isEqual=l})(M||(e.ThemeIcon=M={}))}),define(Ee[172],Ce([1,0,128,14,56]),function(re,e,o,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zk=$,e.$Ak=A,e.$Bk=b,e.$Ck=C,e.$Dk=a,e.$Ek=m;const M="$(",O=new RegExp(`\\$\\(${I.ThemeIcon.iconNameExpression}(?:${I.ThemeIcon.iconModifierExpression})?\\)`,"g"),p=new RegExp(`(\\\\)?${O.source}`,"g");function $(l){return l.replace(p,(i,n)=>n?i:`\\${i}`)}const w=new RegExp(`\\\\${O.source}`,"g");function A(l){return l.replace(w,i=>`\\${i}`)}const P=new RegExp(`(\\s)?(\\\\)?${O.source}(\\s)?`,"g");function b(l){return l.indexOf(M)===-1?l:l.replace(P,(i,n,r,s)=>r?i:n||s||"")}function C(l){return l?l.replace(/\$\((.*?)\)/g,(i,n)=>` ${n} `).trim():""}const y=new RegExp(`\\$\\(${I.ThemeIcon.iconNameCharacter}+\\)`,"g");function a(l){y.lastIndex=0;let i="";const n=[];let r=0;for(;;){const s=y.lastIndex,t=y.exec(l),g=l.substring(s,t?.index);if(g.length>0){i+=g;for(let d=0;d<g.length;d++)n.push(r)}if(!t)break;r+=t[0].length}return{text:i,iconOffsets:n}}function m(l,i,n=!1){const{text:r,iconOffsets:s}=i;if(!s||s.length===0)return(0,o.$qk)(l,r,n);const t=(0,R.$5e)(r," "),g=r.length-t.length,d=(0,o.$qk)(l,t,n);if(d)for(const h of d){const c=s[h.start+g]+g;h.start+=c,h.end+=c}return d}}),define(Ee[130],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$Se=R,e.$Te=I;var o;(function(M){M[M.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",M[M.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",M[M.MAX_UINT_8=255]="MAX_UINT_8",M[M.MAX_UINT_16=65535]="MAX_UINT_16",M[M.MAX_UINT_32=4294967295]="MAX_UINT_32",M[M.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(o||(e.Constants=o={}));function R(M){return M<0?0:M>255?255:M|0}function I(M){return M<0?0:M>4294967295?4294967295:M|0}}),define(Ee[2],Ce([1,0,17,11]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$wc=y,e.$xc=r;const I=/^\w[\w\d+.-]*$/,M=/^\//,O=/^\/\//;function p(h,c){if(!h.scheme&&c)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${h.authority}", path: "${h.path}", query: "${h.query}", fragment: "${h.fragment}"}`);if(h.scheme&&!I.test(h.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(h.path){if(h.authority){if(!M.test(h.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(O.test(h.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function $(h,c){return!h&&!c?"file":h}function w(h,c){switch(h){case"https":case"http":case"file":c?c[0]!==P&&(c=P+c):c=P;break}return c}const A="",P="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class C{static isUri(c){return c instanceof C?!0:c?typeof c.authority=="string"&&typeof c.fragment=="string"&&typeof c.path=="string"&&typeof c.query=="string"&&typeof c.scheme=="string"&&typeof c.fsPath=="string"&&typeof c.with=="function"&&typeof c.toString=="function":!1}constructor(c,u,f,E,v,D=!1){typeof c=="object"?(this.scheme=c.scheme||A,this.authority=c.authority||A,this.path=c.path||A,this.query=c.query||A,this.fragment=c.fragment||A):(this.scheme=$(c,D),this.authority=u||A,this.path=w(this.scheme,f||A),this.query=E||A,this.fragment=v||A,p(this,D))}get fsPath(){return r(this,!1)}with(c){if(!c)return this;let{scheme:u,authority:f,path:E,query:v,fragment:D}=c;return u===void 0?u=this.scheme:u===null&&(u=A),f===void 0?f=this.authority:f===null&&(f=A),E===void 0?E=this.path:E===null&&(E=A),v===void 0?v=this.query:v===null&&(v=A),D===void 0?D=this.fragment:D===null&&(D=A),u===this.scheme&&f===this.authority&&E===this.path&&v===this.query&&D===this.fragment?this:new m(u,f,E,v,D)}static parse(c,u=!1){const f=b.exec(c);return f?new m(f[2]||A,d(f[4]||A),d(f[5]||A),d(f[7]||A),d(f[9]||A),u):new m(A,A,A,A,A)}static file(c){let u=A;if(R.$c&&(c=c.replace(/\\/g,P)),c[0]===P&&c[1]===P){const f=c.indexOf(P,2);f===-1?(u=c.substring(2),c=P):(u=c.substring(2,f),c=c.substring(f)||P)}return new m("file",u,c,A,A)}static from(c,u){return new m(c.scheme,c.authority,c.path,c.query,c.fragment,u)}static joinPath(c,...u){if(!c.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let f;return R.$c&&c.scheme==="file"?f=C.file(o.$gc.join(r(c,!0),...u)).path:f=o.$hc.join(c.path,...u),c.with({path:f})}toString(c=!1){return s(this,c)}toJSON(){return this}static revive(c){if(c){if(c instanceof C)return c;{const u=new m(c);return u._formatted=c.external??null,u._fsPath=c._sep===a?c.fsPath??null:null,u}}else return c}}e.URI=C;function y(h){return!h||typeof h!="object"?!1:typeof h.scheme=="string"&&(typeof h.authority=="string"||typeof h.authority>"u")&&(typeof h.path=="string"||typeof h.path>"u")&&(typeof h.query=="string"||typeof h.query>"u")&&(typeof h.fragment=="string"||typeof h.fragment>"u")}const a=R.$c?1:void 0;class m extends C{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=r(this,!1)),this._fsPath}toString(c=!1){return c?s(this,!0):(this._formatted||(this._formatted=s(this,!1)),this._formatted)}toJSON(){const c={$mid:1};return this._fsPath&&(c.fsPath=this._fsPath,c._sep=a),this._formatted&&(c.external=this._formatted),this.path&&(c.path=this.path),this.scheme&&(c.scheme=this.scheme),this.authority&&(c.authority=this.authority),this.query&&(c.query=this.query),this.fragment&&(c.fragment=this.fragment),c}}const l={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function i(h,c,u){let f,E=-1;for(let v=0;v<h.length;v++){const D=h.charCodeAt(v);if(D>=97&&D<=122||D>=65&&D<=90||D>=48&&D<=57||D===45||D===46||D===95||D===126||c&&D===47||u&&D===91||u&&D===93||u&&D===58)E!==-1&&(f+=encodeURIComponent(h.substring(E,v)),E=-1),f!==void 0&&(f+=h.charAt(v));else{f===void 0&&(f=h.substr(0,v));const k=l[D];k!==void 0?(E!==-1&&(f+=encodeURIComponent(h.substring(E,v)),E=-1),f+=k):E===-1&&(E=v)}}return E!==-1&&(f+=encodeURIComponent(h.substring(E))),f!==void 0?f:h}function n(h){let c;for(let u=0;u<h.length;u++){const f=h.charCodeAt(u);f===35||f===63?(c===void 0&&(c=h.substr(0,u)),c+=l[f]):c!==void 0&&(c+=h[u])}return c!==void 0?c:h}function r(h,c){let u;return h.authority&&h.path.length>1&&h.scheme==="file"?u=`//${h.authority}${h.path}`:h.path.charCodeAt(0)===47&&(h.path.charCodeAt(1)>=65&&h.path.charCodeAt(1)<=90||h.path.charCodeAt(1)>=97&&h.path.charCodeAt(1)<=122)&&h.path.charCodeAt(2)===58?c?u=h.path.substr(1):u=h.path[1].toLowerCase()+h.path.substr(2):u=h.path,R.$c&&(u=u.replace(/\//g,"\\")),u}function s(h,c){const u=c?n:i;let f="",{scheme:E,authority:v,path:D,query:k,fragment:S}=h;if(E&&(f+=E,f+=":"),(v||E==="file")&&(f+=P,f+=P),v){let F=v.indexOf("@");if(F!==-1){const W=v.substr(0,F);v=v.substr(F+1),F=W.lastIndexOf(":"),F===-1?f+=u(W,!1,!1):(f+=u(W.substr(0,F),!1,!1),f+=":",f+=u(W.substr(F+1),!1,!0)),f+="@"}v=v.toLowerCase(),F=v.lastIndexOf(":"),F===-1?f+=u(v,!1,!0):(f+=u(v.substr(0,F),!1,!0),f+=v.substr(F))}if(D){if(D.length>=3&&D.charCodeAt(0)===47&&D.charCodeAt(2)===58){const F=D.charCodeAt(1);F>=65&&F<=90&&(D=`/${String.fromCharCode(F+32)}:${D.substr(3)}`)}else if(D.length>=2&&D.charCodeAt(1)===58){const F=D.charCodeAt(0);F>=65&&F<=90&&(D=`${String.fromCharCode(F+32)}:${D.substr(2)}`)}f+=u(D,!0,!1)}return k&&(f+="?",f+=u(k,!1,!1)),S&&(f+="#",f+=c?S:i(S,!1,!1)),f}function t(h){try{return decodeURIComponent(h)}catch{return h.length>3?h.substr(0,3)+t(h.substr(3)):h}}const g=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function d(h){return h.match(g)?h.replace(g,c=>t(c)):h}}),define(Ee[173],Ce([1,0,2]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gq=R,e.$Hq=I,e.$Iq=M,e.log=p;function R(w){const A=w;return A&&typeof A.type=="string"&&typeof A.severity=="string"}function I(w){const A=[];let P;try{const b=JSON.parse(w.arguments),C=b[b.length-1];C&&C.__$stack&&(b.pop(),P=C.__$stack),A.push(...b)}catch{A.push("Unable to log remote console arguments",w.arguments)}return{args:A,stack:P}}function M(w){if(typeof w!="string")return M(I(w).stack);const A=w;if(A){const P=O(A),b=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(P||"");if(b&&b.length===4)return{uri:o.URI.file(b[1]),line:Number(b[2]),column:Number(b[3])}}}function O(w){if(!w)return w;const A=w.indexOf(`
`);return A===-1?w:w.substring(0,A)}function p(w,A){const{args:P,stack:b}=I(w),C=typeof P[0]=="string"&&P.length===1;let y=O(b);y&&(y=`(${y.trim()})`);let a=[];if(typeof P[0]=="string"?y&&C?a=[`%c[${A}] %c${P[0]} %c${y}`,$("blue"),$(""),$("grey")]:a=[`%c[${A}] %c${P[0]}`,$("blue"),$(""),...P.slice(1)]:a=[`%c[${A}]%`,$("blue"),...P],y&&!C&&a.push(y),typeof console[w.severity]!="function")throw new Error("Unknown console method");console[w.severity].apply(console,a)}function $(w){return`color: ${w}`}}),define(Ee[57],Ce([1,0,21,2]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ph=I,e.$Qh=M,e.$Rh=p;function I($){return JSON.stringify($,O)}function M($){let w=JSON.parse($);return w=p(w),w}function O($,w){return w instanceof RegExp?{$mid:2,source:w.source,flags:w.flags}:w}function p($,w=0){if(!$||w>200)return $;if(typeof $=="object"){switch($.$mid){case 1:return R.URI.revive($);case 2:return new RegExp($.source,$.flags);case 17:return new Date($.source)}if($ instanceof o.$ue||$ instanceof Uint8Array)return $;if(Array.isArray($))for(let A=0;A<$.length;++A)$[A]=p($[A],w+1);else for(const A in $)Object.hasOwnProperty.call($,A)&&($[A]=p($[A],w+1))}return $}}),define(Ee[15],Ce([1,0,13,11,14,2,17]),function(re,e,o,R,I,M,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$vg=e.$ug=e.$tg=e.Schemas=void 0,e.$rg=$,e.$sg=w,e.$wg=P;var p;(function(y){y.inMemory="inmemory",y.vscode="vscode",y.internal="private",y.walkThrough="walkThrough",y.walkThroughSnippet="walkThroughSnippet",y.http="http",y.https="https",y.file="file",y.mailto="mailto",y.untitled="untitled",y.data="data",y.command="command",y.vscodeRemote="vscode-remote",y.vscodeRemoteResource="vscode-remote-resource",y.vscodeManagedRemoteResource="vscode-managed-remote-resource",y.vscodeUserData="vscode-userdata",y.vscodeCustomEditor="vscode-custom-editor",y.vscodeNotebookCell="vscode-notebook-cell",y.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",y.vscodeNotebookCellOutput="vscode-notebook-cell-output",y.vscodeInteractiveInput="vscode-interactive-input",y.vscodeSettings="vscode-settings",y.vscodeWorkspaceTrust="vscode-workspace-trust",y.vscodeTerminal="vscode-terminal",y.vscodeChatCodeBlock="vscode-chat-code-block",y.vscodeChatSesssion="vscode-chat-editor",y.webviewPanel="webview-panel",y.vscodeWebview="vscode-webview",y.extension="extension",y.vscodeFileResource="vscode-file",y.tmp="tmp",y.vsls="vsls",y.vscodeSourceControl="vscode-scm",y.codeSetting="code-setting"})(p||(e.Schemas=p={}));function $(y,a){return M.URI.isUri(y)?(0,I.$lf)(y.scheme,a):(0,I.$mf)(y,a+":")}function w(y,...a){return a.some(m=>$(y,m))}e.$tg="vscode-tkn",e.$ug="tkn";class A{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(a){this.d=a}setDelegate(a){this.e=a}setServerRootPath(a,m){this.f=P(a,m)}getServerRootPath(){return this.f}get g(){return O.$hc.join(this.f,p.vscodeRemoteResource)}set(a,m,l){this.a[a]=m,this.b[a]=l}setConnectionToken(a,m){this.c[a]=m}getPreferredWebSchema(){return this.d}rewrite(a){if(this.e)try{return this.e(a)}catch(s){return o.$1(s),a}const m=a.authority;let l=this.a[m];l&&l.indexOf(":")!==-1&&l.indexOf("[")===-1&&(l=`[${l}]`);const i=this.b[m],n=this.c[m];let r=`path=${encodeURIComponent(a.path)}`;return typeof n=="string"&&(r+=`&${e.$ug}=${encodeURIComponent(n)}`),M.URI.from({scheme:R.$i?this.d:p.vscodeRemoteResource,authority:`${l}:${i}`,path:R.$i?(window.location.pathname+"/"+this.g).replace(/\/\/+/g,"/"):this.g,query:r})}}e.$vg=new A;function P(y,a){return O.$hc.join(a??"/",`${y.quality??"oss"}-${y.commit??"dev"}`)}e.$xg="vs/../../extensions",e.$yg="vs/../../node_modules",e.$zg="vs/../../node_modules.asar",e.$Ag="vs/../../node_modules.asar.unpacked",e.$Bg="vscode-app";class b{asBrowserUri(a){const m=this.b(a,re);return this.uriToBrowserUri(m)}uriToBrowserUri(a){return a.scheme===p.vscodeRemote?e.$vg.rewrite(a):a.scheme===p.file&&(R.$g||R.$k===`${p.vscodeFileResource}://${b.a}`)?a.with({scheme:p.vscodeFileResource,authority:a.authority||b.a,query:null,fragment:null}):a}asFileUri(a){const m=this.b(a,re);return this.uriToFileUri(m)}uriToFileUri(a){return a.scheme===p.vscodeFileResource?a.with({scheme:p.file,authority:a.authority!==b.a?a.authority:null,query:null,fragment:null}):a}b(a,m){return M.URI.isUri(a)?a:M.URI.parse(m.toUrl(a))}}b.a=e.$Bg,e.$Cg=new b;var C;(function(y){const a=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);y.CoopAndCoep=Object.freeze(a.get("3"));const m="vscode-coi";function l(n){let r;typeof n=="string"?r=new URL(n).searchParams:n instanceof URL?r=n.searchParams:M.URI.isUri(n)&&(r=new URL(n.toString(!0)).searchParams);const s=r?.get(m);if(s)return a.get(s)}y.getHeadersFromQuery=l;function i(n,r,s){if(!globalThis.crossOriginIsolated)return;const t=r&&s?"3":s?"2":"1";n instanceof URLSearchParams?n.set(m,t):n[m]=t}y.addSearchParam=i})(C||(e.COI=C={}))}),define(Ee[174],Ce([1,0,163,15,11,2]),function(re,e,o,R,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KD=A;class O{constructor(b,C,y){this.id=b,this.dependencies=C,this.callback=y}}class p{constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(b,C,y)=>{typeof b!="string"&&(y=C,C=b,b=null),(typeof C!="object"||!Array.isArray(C))&&(y=C,C=null),this.c.push(new O(b,C,y))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(b){if(b.startsWith(window.location.origin)||b.startsWith("vscode-file://vscode-app"))return b;throw new Error(`[trusted_script_src] Invalid script url: ${b}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(b){return b}})))}async load(b){this.g();const C=await(this.a?this.i(b):this.b?this.h(b):this.j(b));if(!C)throw new Error(`Did not receive a define call from script ${b}`);if(Array.isArray(C.dependencies)&&C.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${b}. The dependencies are: ${C.dependencies.join(", ")}`);return typeof C.callback=="function"?C.callback([]):C.callback}h(b){return new Promise((C,y)=>{const a=document.createElement("script");a.setAttribute("async","async"),a.setAttribute("type","text/javascript");const m=()=>{a.removeEventListener("load",l),a.removeEventListener("error",i)},l=n=>{m(),C(this.c.pop())},i=n=>{m(),y(n)};a.addEventListener("load",l),a.addEventListener("error",i),this.f&&(b=this.f.createScriptURL(b)),a.setAttribute("src",b),window.document.getElementsByTagName("head")[0].appendChild(a)})}i(b){return new Promise((C,y)=>{try{this.f&&(b=this.f.createScriptURL(b)),importScripts(b),C(this.c.pop())}catch(a){y(a)}})}async j(b){try{const C=globalThis._VSCODE_NODE_MODULES.fs,y=globalThis._VSCODE_NODE_MODULES.vm,a=globalThis._VSCODE_NODE_MODULES.module,m=M.URI.parse(b).fsPath,l=C.readFileSync(m).toString(),i=a.wrap(l.replace(/^#!.*/,""));return new y.Script(i).runInThisContext().apply(),this.c.pop()}catch(C){throw C}}}p.INSTANCE=new p;const $=new Map;let w={};typeof globalThis.require=="object"&&(w=globalThis.require.paths??{});async function A(P,b,C){if(o.$T){C===void 0&&(C=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),w[P]&&(P=w[P]);const y=`${P}/${b}`;if($.has(y))return $.get(y);let a;if(/^\w[\w\d+.-]*:\/\//.test(y))a=y;else{const n=`${C&&!I.$i?R.$zg:R.$yg}/${y}`;a=R.$Cg.asBrowserUri(n).toString(!0)}const m=p.INSTANCE.load(a);return $.set(y,m),m}else return await new Promise((y,a)=>{re([P],y,a)})}}),define(Ee[23],Ce([1,0,34,15,17,11,14,2]),function(re,e,o,R,I,M,O,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=void 0,e.$Jg=$,e.$5g=A,e.$6g=b;function $(C){return(0,p.$xc)(C,!0)}class w{constructor(y){this.a=y}compare(y,a,m=!1){return y===a?0:(0,O.$ef)(this.getComparisonKey(y,m),this.getComparisonKey(a,m))}isEqual(y,a,m=!1){return y===a?!0:!y||!a?!1:this.getComparisonKey(y,m)===this.getComparisonKey(a,m)}getComparisonKey(y,a=!1){return y.with({path:this.a(y)?y.path.toLowerCase():void 0,fragment:a?null:void 0}).toString()}ignorePathCasing(y){return this.a(y)}isEqualOrParent(y,a,m=!1){if(y.scheme===a.scheme){if(y.scheme===R.Schemas.file)return o.$ig($(y),$(a),this.a(y))&&y.query===a.query&&(m||y.fragment===a.fragment);if((0,e.$1g)(y.authority,a.authority))return o.$ig(y.path,a.path,this.a(y),"/")&&y.query===a.query&&(m||y.fragment===a.fragment)}return!1}joinPath(y,...a){return p.URI.joinPath(y,...a)}basenameOrAuthority(y){return(0,e.$Sg)(y)||y.authority}basename(y){return I.$hc.basename(y.path)}extname(y){return I.$hc.extname(y.path)}dirname(y){if(y.path.length===0)return y;let a;return y.scheme===R.Schemas.file?a=p.URI.file(I.$nc($(y))).path:(a=I.$hc.dirname(y.path),y.authority&&a.length&&a.charCodeAt(0)!==47&&(console.error(`dirname("${y.toString})) resulted in a relative path`),a="/")),y.with({path:a})}normalizePath(y){if(!y.path.length)return y;let a;return y.scheme===R.Schemas.file?a=p.URI.file(I.$ic($(y))).path:a=I.$hc.normalize(y.path),y.with({path:a})}relativePath(y,a){if(y.scheme!==a.scheme||!(0,e.$1g)(y.authority,a.authority))return;if(y.scheme===R.Schemas.file){const i=I.$mc($(y),$(a));return M.$c?o.$cg(i):i}let m=y.path||"/";const l=a.path||"/";if(this.a(y)){let i=0;for(const n=Math.min(m.length,l.length);i<n&&!(m.charCodeAt(i)!==l.charCodeAt(i)&&m.charAt(i).toLowerCase()!==l.charAt(i).toLowerCase());i++);m=l.substr(0,i)+m.substr(i)}return I.$hc.relative(m,l)}resolvePath(y,a){if(y.scheme===R.Schemas.file){const m=p.URI.file(I.$lc($(y),a));return y.with({authority:m.authority,path:m.path})}return a=o.$dg(a),y.with({path:I.$hc.resolve(y.path,a)})}isAbsolutePath(y){return!!y.path&&y.path[0]==="/"}isEqualAuthority(y,a){return y===a||y!==void 0&&a!==void 0&&(0,O.$lf)(y,a)}hasTrailingPathSeparator(y,a=I.sep){if(y.scheme===R.Schemas.file){const m=$(y);return m.length>o.$eg(m).length&&m[m.length-1]===a}else{const m=y.path;return m.length>1&&m.charCodeAt(m.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(y.fsPath)}}removeTrailingPathSeparator(y,a=I.sep){return(0,e.$2g)(y,a)?y.with({path:y.path.substr(0,y.path.length-1)}):y}addTrailingPathSeparator(y,a=I.sep){let m=!1;if(y.scheme===R.Schemas.file){const l=$(y);m=l!==void 0&&l.length===o.$eg(l).length&&l[l.length-1]===a}else{a="/";const l=y.path;m=l.length===1&&l.charCodeAt(l.length-1)===47}return!m&&!(0,e.$2g)(y,a)?y.with({path:y.path+"/"}):y}}e.$Kg=w,e.$Lg=new w(()=>!1),e.$Mg=new w(C=>C.scheme===R.Schemas.file?!M.$e:!0),e.$Ng=new w(C=>!0),e.$Og=e.$Lg.isEqual.bind(e.$Lg),e.$Pg=e.$Lg.isEqualOrParent.bind(e.$Lg),e.$Qg=e.$Lg.getComparisonKey.bind(e.$Lg),e.$Rg=e.$Lg.basenameOrAuthority.bind(e.$Lg),e.$Sg=e.$Lg.basename.bind(e.$Lg),e.$Tg=e.$Lg.extname.bind(e.$Lg),e.$Ug=e.$Lg.dirname.bind(e.$Lg),e.$Vg=e.$Lg.joinPath.bind(e.$Lg),e.$Wg=e.$Lg.normalizePath.bind(e.$Lg),e.$Xg=e.$Lg.relativePath.bind(e.$Lg),e.$Yg=e.$Lg.resolvePath.bind(e.$Lg),e.$Zg=e.$Lg.isAbsolutePath.bind(e.$Lg),e.$1g=e.$Lg.isEqualAuthority.bind(e.$Lg),e.$2g=e.$Lg.hasTrailingPathSeparator.bind(e.$Lg),e.$3g=e.$Lg.removeTrailingPathSeparator.bind(e.$Lg),e.$4g=e.$Lg.addTrailingPathSeparator.bind(e.$Lg);function A(C,y){const a=[];for(let m=0;m<C.length;m++){const l=y(C[m]);C.some((i,n)=>n===m?!1:(0,e.$Pg)(l,y(i)))||a.push(C[m])}return a}var P;(function(C){C.META_DATA_LABEL="label",C.META_DATA_DESCRIPTION="description",C.META_DATA_SIZE="size",C.META_DATA_MIME="mime";function y(a){const m=new Map;a.path.substring(a.path.indexOf(";")+1,a.path.lastIndexOf(";")).split(";").forEach(n=>{const[r,s]=n.split(":");r&&s&&m.set(r,s)});const i=a.path.substring(0,a.path.indexOf(";"));return i&&m.set(C.META_DATA_MIME,i),m}C.parseMetaData=y})(P||(e.DataUri=P={}));function b(C,y,a){if(y){let m=C.path;return m&&m[0]!==I.$hc.sep&&(m=I.$hc.sep+m),C.with({scheme:a,authority:y,path:m})}return C.with({scheme:a})}}),define(Ee[8],Ce([1,0,22,13,4,3,23,11,170,46]),function(re,e,o,R,I,M,O,p,$,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.Promises=e.$Fh=e.$Eh=e.$Dh=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=void 0,e.$7g=A,e.$8g=P,e.$9g=b,e.$0g=C,e.$$g=y,e.$_g=a,e.$ah=m,e.$bh=l,e.$jh=u,e.$kh=f,e.$lh=E,e.$mh=v,e.$nh=D,e.$Ch=J,e.$Kh=ie;function A(oe){return!!oe&&typeof oe.then=="function"}function P(oe){const G=new o.$ee,ee=oe(G.token),le=new Promise((de,Me)=>{const be=G.token.onCancellationRequested(()=>{be.dispose(),Me(new R.$5)});Promise.resolve(ee).then(Pe=>{be.dispose(),G.dispose(),de(Pe)},Pe=>{be.dispose(),G.dispose(),Me(Pe)})});return new class{cancel(){G.cancel(),G.dispose()}then(de,Me){return le.then(de,Me)}catch(de){return this.then(void 0,de)}finally(de){return le.finally(de)}}}function b(oe,G,ee){return new Promise((le,de)=>{const Me=G.onCancellationRequested(()=>{Me.dispose(),le(ee)});oe.then(le,de).finally(()=>Me.dispose())})}function C(oe,G){return new Promise((ee,le)=>{const de=G.onCancellationRequested(()=>{de.dispose(),le(new R.$5)});oe.then(ee,le).finally(()=>de.dispose())})}async function y(oe){let G=-1;const ee=oe.map((le,de)=>le.then(Me=>(G=de,Me)));try{return await Promise.race(ee)}finally{oe.forEach((le,de)=>{de!==G&&le.cancel()})}}function a(oe,G,ee){let le;const de=setTimeout(()=>{le?.(void 0),ee?.()},G);return Promise.race([oe.finally(()=>clearTimeout(de)),new Promise(Me=>le=Me)])}function m(oe){return new Promise((G,ee)=>{const le=oe();A(le)?le.then(G,ee):G(le)})}function l(){let oe,G;return{promise:new Promise((le,de)=>{oe=le,G=de}),resolve:oe,reject:G}}class i{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(G){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=G,!this.b){const ee=()=>{if(this.b=null,this.f)return;const le=this.queue(this.d);return this.d=null,le};this.b=new Promise(le=>{this.a.then(ee,ee).then(le)})}return new Promise((ee,le)=>{this.b.then(ee,le)})}return this.a=G(),new Promise((ee,le)=>{this.a.then(de=>{this.a=null,ee(de)},de=>{this.a=null,le(de)})})}dispose(){this.f=!0}}e.$ch=i;class n{constructor(){this.a=Promise.resolve(null)}queue(G){return this.a=this.a.then(()=>G(),()=>G())}}e.$dh=n;class r{constructor(){this.a=new Map}queue(G,ee){const de=(this.a.get(G)??Promise.resolve()).catch(()=>{}).then(ee).finally(()=>{this.a.get(G)===de&&this.a.delete(G)});return this.a.set(G,de),de}}e.$eh=r;const s=(oe,G)=>{let ee=!0;const le=setTimeout(()=>{ee=!1,G()},oe);return{isTriggered:()=>ee,dispose:()=>{clearTimeout(le),ee=!1}}},t=oe=>{let G=!0;return queueMicrotask(()=>{G&&(G=!1,oe())}),{isTriggered:()=>G,dispose:()=>{G=!1}}};class g{constructor(G){this.defaultDelay=G,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(G,ee=this.defaultDelay){this.g=G,this.h(),this.b||(this.b=new Promise((de,Me)=>{this.d=de,this.f=Me}).then(()=>{if(this.b=null,this.d=null,this.g){const de=this.g;return this.g=null,de()}}));const le=()=>{this.a=null,this.d?.(null)};return this.a=ee===$.$4d?t(le):s(ee,le),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new R.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$fh=g;class d{constructor(G){this.a=new g(G),this.b=new i}trigger(G,ee){return this.a.trigger(()=>this.b.queue(G),ee)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$gh=d;class h{constructor(){this.a=!1,this.b=new Promise((G,ee)=>{this.d=G})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$hh=h;class c extends h{constructor(G){super(),this.f=setTimeout(()=>this.open(),G)}open(){clearTimeout(this.f),super.open()}}e.$ih=c;function u(oe,G){return G?new Promise((ee,le)=>{const de=setTimeout(()=>{Me.dispose(),ee()},oe),Me=G.onCancellationRequested(()=>{clearTimeout(de),Me.dispose(),le(new R.$5)})}):P(ee=>u(oe,ee))}function f(oe,G=0,ee){const le=setTimeout(()=>{oe(),ee&&de.dispose()},G),de=(0,M.$Sc)(()=>{clearTimeout(le),ee?.deleteAndLeak(de)});return ee?.add(de),de}function E(oe){const G=[];let ee=0;const le=oe.length;function de(){return ee<le?oe[ee++]():null}function Me(be){be!=null&&G.push(be);const Pe=de();return Pe?Pe.then(Me):Promise.resolve(G)}return Promise.resolve(null).then(Me)}function v(oe,G=le=>!!le,ee=null){let le=0;const de=oe.length,Me=()=>{if(le>=de)return Promise.resolve(ee);const be=oe[le++];return Promise.resolve(be()).then(Re=>G(Re)?Promise.resolve(Re):Me())};return Me()}function D(oe,G=le=>!!le,ee=null){if(oe.length===0)return Promise.resolve(ee);let le=oe.length;const de=()=>{le=-1;for(const Me of oe)Me.cancel?.()};return new Promise((Me,be)=>{for(const Pe of oe)Pe.then(Re=>{--le>=0&&G(Re)?(de(),Me(Re)):le===0&&Me(ee)}).catch(Re=>{--le>=0&&(de(),be(Re))})})}class k{constructor(G){this.a=0,this.b=!1,this.f=G,this.g=[],this.d=0,this.h=new I.$7d}whenIdle(){return this.size>0?I.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(G){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((ee,le)=>{this.g.push({factory:G,c:ee,e:le}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const G=this.g.shift();this.d++;const ee=G.factory();ee.then(G.c,G.e),ee.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$oh=k;class S extends k{constructor(){super(1)}}e.$ph=S;class F{constructor(){this.a=new x,this.b=0}queue(G){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,G())):this.a.run(this.b++,G())}}e.$qh=F;class W{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const G=new pe;return this.b.add(G),G.p}g(){for(const[,G]of this.a)if(G.size>0)return!1;return!0}queueSize(G,ee=O.$Lg){const le=ee.getComparisonKey(G);return this.a.get(le)?.size??0}queueFor(G,ee,le=O.$Lg){const de=le.getComparisonKey(G);let Me=this.a.get(de);if(!Me){Me=new S;const be=this.f++,Pe=I.Event.once(Me.onDrained)(()=>{Me?.dispose(),this.a.delete(de),this.h(),this.d?.deleteAndDispose(be),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new M.$4c),this.d.set(be,Pe),this.a.set(de,Me)}return Me.queue(ee)}h(){this.g()&&this.j()}j(){for(const G of this.b)G.complete();this.b.clear()}dispose(){for(const[,G]of this.a)G.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$rh=W;class B{constructor(G,ee){this.a=-1,typeof G=="function"&&typeof ee=="number"&&this.setIfNotSet(G,ee)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(G,ee){this.cancel(),this.a=setTimeout(()=>{this.a=-1,G()},ee)}setIfNotSet(G,ee){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,G()},ee))}}e.$sh=B;class T{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(G,ee,le=globalThis){this.cancel();const de=le.setInterval(()=>{G()},ee);this.d=(0,M.$Sc)(()=>{le.clearInterval(de),this.d=void 0})}dispose(){this.cancel()}}e.$th=T;class N{constructor(G,ee){this.b=-1,this.a=G,this.d=ee,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(G=this.d){this.cancel(),this.b=setTimeout(this.f,G)}get delay(){return this.d}set delay(G){this.d=G}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$uh=N;class j{constructor(G,ee){ee%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ee}ms is not a multiple of 1000ms.`),this.a=G,this.b=ee,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(G=this.b){G%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${G}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(G/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$vh=j;class L extends N{constructor(G,ee){super(G,ee),this.j=[]}work(G){this.j.push(G),this.isScheduled()||this.schedule()}h(){const G=this.j;this.j=[],this.a?.(G)}dispose(){this.j=[],super.dispose()}}e.$wh=L;class z extends M.$Uc{constructor(G,ee){super(),this.g=G,this.h=ee,this.a=[],this.b=this.B(new M.$Vc),this.f=!1}get pending(){return this.a.length}work(G){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+G.length>this.g.maxBufferedWork)return!1}else if(this.pending+G.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const ee of G)this.a.push(ee);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new N(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$xh=z,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$zh=(oe,G)=>{(0,p.$v)(()=>{if(ee)return;const le=Date.now()+15;G(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,le-Date.now())}}))});let ee=!1;return{dispose(){ee||(ee=!0)}}}:e.$zh=(oe,G,ee)=>{const le=oe.requestIdleCallback(G,typeof ee=="number"?{timeout:ee}:void 0);let de=!1;return{dispose(){de||(de=!0,oe.cancelIdleCallback(le))}}},e.$yh=oe=>(0,e.$zh)(globalThis,oe)}();class Q{constructor(G,ee){this.g=!1,this.d=()=>{try{this.j=ee()}catch(le){this.l=le}finally{this.g=!0}},this.f=(0,e.$zh)(G,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Ah=Q;class Y extends Q{constructor(G){super(globalThis,G)}}e.$Bh=Y;async function J(oe,G,ee){let le;for(let de=0;de<ee;de++)try{return await oe()}catch(Me){le=Me,await u(G)}throw le}class x{isRunning(G){return typeof G=="number"?this.a?.taskId===G:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(G,ee,le){return this.a={taskId:G,cancel:()=>le?.(),promise:ee},ee.then(()=>this.d(G),()=>this.d(G)),ee}d(G){this.a&&G===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const G=this.b;this.b=void 0,G.run().then(G.promiseResolve,G.promiseReject)}}queue(G){if(this.b)this.b.run=G;else{const{promise:ee,resolve:le,reject:de}=l();this.b={run:G,promise:ee,promiseResolve:le,promiseReject:de}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Dh=x;class ce{constructor(G,ee=()=>Date.now()){this.d=G,this.f=ee,this.a=0,this.b=0}increment(){const G=this.f();return G-this.a>this.d&&(this.a=G,this.b=0),this.b++,this.b}}e.$Eh=ce;var te;(function(oe){oe[oe.Resolved=0]="Resolved",oe[oe.Rejected=1]="Rejected"})(te||(te={}));class pe{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((G,ee)=>{this.a=G,this.b=ee})}complete(G){return new Promise(ee=>{this.a(G),this.d={outcome:0,value:G},ee()})}error(G){return new Promise(ee=>{this.b(G),this.d={outcome:1,value:G},ee()})}cancel(){return this.error(new R.$5)}}e.$Fh=pe;var ye;(function(oe){async function G(le){let de;const Me=await Promise.all(le.map(be=>be.then(Pe=>Pe,Pe=>{de||(de=Pe)})));if(typeof de<"u")throw de;return Me}oe.settled=G;function ee(le){return new Promise(async(de,Me)=>{try{await le(de,Me)}catch(be){Me(be)}})}oe.withAsyncBody=ee})(ye||(e.Promises=ye={}));class _{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(G){this.a=void 0,this.b=void 0,this.d=!1,this.promise=G.then(ee=>(this.a=ee,this.d=!0,ee),ee=>{throw this.b=ee,this.d=!0,ee})}requireValue(){if(!this.d)throw new R.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Gh=_;class U{constructor(G){this.b=G,this.a=new w.$V(()=>new _(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Hh=U;var he;(function(oe){oe[oe.Initial=0]="Initial",oe[oe.DoneOK=1]="DoneOK",oe[oe.DoneError=2]="DoneError"})(he||(he={}));class Se{static fromArray(G){return new Se(ee=>{ee.emitMany(G)})}static fromPromise(G){return new Se(async ee=>{ee.emitMany(await G)})}static fromPromises(G){return new Se(async ee=>{await Promise.all(G.map(async le=>ee.emitOne(await le)))})}static merge(G){return new Se(async ee=>{await Promise.all(G.map(async le=>{for await(const de of le)ee.emitOne(de)}))})}constructor(G){this.a=0,this.b=[],this.d=null,this.f=new I.$7d,queueMicrotask(async()=>{const ee={emitOne:le=>this.g(le),emitMany:le=>this.h(le),reject:le=>this.k(le)};try{await Promise.resolve(G(ee)),this.j()}catch(le){this.k(le)}finally{ee.emitOne=void 0,ee.emitMany=void 0,ee.reject=void 0}})}[Symbol.asyncIterator](){let G=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(G<this.b.length)return{done:!1,value:this.b[G++]};if(this.a===1)return{done:!0,value:void 0};await I.Event.toPromise(this.f.event)}while(!0)}}}static map(G,ee){return new Se(async le=>{for await(const de of G)le.emitOne(ee(de))})}map(G){return Se.map(this,G)}static filter(G,ee){return new Se(async le=>{for await(const de of G)ee(de)&&le.emitOne(de)})}filter(G){return Se.filter(this,G)}static coalesce(G){return Se.filter(G,ee=>!!ee)}coalesce(){return Se.coalesce(this)}static async toPromise(G){const ee=[];for await(const le of G)ee.push(le);return ee}toPromise(){return Se.toPromise(this)}g(G){this.a===0&&(this.b.push(G),this.f.fire())}h(G){this.a===0&&(this.b=this.b.concat(G),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(G){this.a===0&&(this.a=2,this.d=G,this.f.fire())}}e.$Ih=Se,Se.EMPTY=Se.fromArray([]);class me extends Se{constructor(G,ee){super(ee),this.l=G}cancel(){this.l.cancel()}}e.$Jh=me;function ie(oe){const G=new o.$ee,ee=oe(G.token);return new me(G,async le=>{const de=G.token.onCancellationRequested(()=>{de.dispose(),G.dispose(),le.reject(new R.$5)});try{for await(const Me of ee){if(G.token.isCancellationRequested)return;le.emitOne(Me)}de.dispose(),G.dispose()}catch(Me){de.dispose(),G.dispose(),le.reject(Me)}})}class se{constructor(){this.a=new pe,this.b=new Se(le=>{if(G){le.reject(G);return}return ee&&le.emitMany(ee),this.d=de=>le.reject(de),this.f=de=>le.emitOne(de),this.a.p});let G,ee;this.f=le=>{ee||(ee=[]),ee.push(le)},this.d=le=>{G||(G=le)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(G){this.d(G),this.a.complete()}emitOne(G){this.f(G)}}e.$Lh=se}),define(Ee[35],Ce([1,0,19,8,34,27,17,11,14]),function(re,e,o,R,I,M,O,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_j=e.$$j=void 0,e.$0j=w,e.$ak=y,e.$bk=S,e.$ck=F,e.$dk=W,e.$ek=B,e.$fk=T,e.$gk=z;function w(){return Object.create(null)}e.$$j="**",e.$_j="/";const A="[/\\\\]",P="[^/\\\\]",b=/\//g;function C(Q,Y){switch(Q){case 0:return"";case 1:return`${P}*?`;default:return`(?:${A}|${P}+${A}${Y?`|${A}${P}+`:""})*?`}}function y(Q,Y){if(!Q)return[];const J=[];let x=!1,ce=!1,te="";for(const pe of Q){switch(pe){case Y:if(!x&&!ce){J.push(te),te="";continue}break;case"{":x=!0;break;case"}":x=!1;break;case"[":ce=!0;break;case"]":ce=!1;break}te+=pe}return te&&J.push(te),J}function a(Q){if(!Q)return"";let Y="";const J=y(Q,e.$_j);if(J.every(x=>x===e.$$j))Y=".*";else{let x=!1;J.forEach((ce,te)=>{if(ce===e.$$j){if(x)return;Y+=C(2,te===J.length-1)}else{let pe=!1,ye="",_=!1,U="";for(const he of ce){if(he!=="}"&&pe){ye+=he;continue}if(_&&(he!=="]"||!U)){let Se;he==="-"?Se=he:(he==="^"||he==="!")&&!U?Se="^":he===e.$_j?Se="":Se=(0,$.$Ze)(he),U+=Se;continue}switch(he){case"{":pe=!0;continue;case"[":_=!0;continue;case"}":{const me=`(?:${y(ye,",").map(ie=>a(ie)).join("|")})`;Y+=me,pe=!1,ye="";break}case"]":{Y+="["+U+"]",_=!1,U="";break}case"?":Y+=P;continue;case"*":Y+=C(1);continue;default:Y+=(0,$.$Ze)(he)}}te<J.length-1&&(J[te+1]!==e.$$j||te+2<J.length)&&(Y+=A)}x=ce===e.$$j})}return Y}const m=/^\*\*\/\*\.[\w\.-]+$/,l=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,n=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,r=/^\*\*((\/[\w\.-]+)+)\/?$/,s=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new M.$Ec(1e4),g=function(){return!1},d=function(){return null};function h(Q,Y){if(!Q)return d;let J;typeof Q!="string"?J=Q.pattern:J=Q,J=J.trim();const x=`${J}_${!!Y.trimForExclusions}`;let ce=t.get(x);if(ce)return c(ce,Q);let te;return m.test(J)?ce=f(J.substr(4),J):(te=l.exec(u(J,Y)))?ce=E(te[1],J):(Y.trimForExclusions?n:i).test(J)?ce=v(J,Y):(te=r.exec(u(J,Y)))?ce=D(te[1].substr(1),J,!0):(te=s.exec(u(J,Y)))?ce=D(te[1],J,!1):ce=k(J),t.set(x,ce),c(ce,Q)}function c(Q,Y){if(typeof Y=="string")return Q;const J=function(x,ce){return(0,I.$ig)(x,Y.base,!p.$e)?Q((0,$.$5e)(x.substr(Y.base.length),O.sep),ce):null};return J.allBasenames=Q.allBasenames,J.allPaths=Q.allPaths,J.basenames=Q.basenames,J.patterns=Q.patterns,J}function u(Q,Y){return Y.trimForExclusions&&Q.endsWith("/**")?Q.substr(0,Q.length-2):Q}function f(Q,Y){return function(J,x){return typeof J=="string"&&J.endsWith(Q)?Y:null}}function E(Q,Y){const J=`/${Q}`,x=`\\${Q}`,ce=function(pe,ye){return typeof pe!="string"?null:ye?ye===Q?Y:null:pe===Q||pe.endsWith(J)||pe.endsWith(x)?Y:null},te=[Q];return ce.basenames=te,ce.patterns=[Y],ce.allBasenames=te,ce}function v(Q,Y){const J=L(Q.slice(1,-1).split(",").map(ye=>h(ye,Y)).filter(ye=>ye!==d),Q),x=J.length;if(!x)return d;if(x===1)return J[0];const ce=function(ye,_){for(let U=0,he=J.length;U<he;U++)if(J[U](ye,_))return Q;return null},te=J.find(ye=>!!ye.allBasenames);te&&(ce.allBasenames=te.allBasenames);const pe=J.reduce((ye,_)=>_.allPaths?ye.concat(_.allPaths):ye,[]);return pe.length&&(ce.allPaths=pe),ce}function D(Q,Y,J){const x=O.sep===O.$hc.sep,ce=x?Q:Q.replace(b,O.sep),te=O.sep+ce,pe=O.$hc.sep+Q;let ye;return J?ye=function(_,U){return typeof _=="string"&&(_===ce||_.endsWith(te)||!x&&(_===Q||_.endsWith(pe)))?Y:null}:ye=function(_,U){return typeof _=="string"&&(_===ce||!x&&_===Q)?Y:null},ye.allPaths=[(J?"*/":"./")+Q],ye}function k(Q){try{const Y=new RegExp(`^${a(Q)}$`);return function(J){return Y.lastIndex=0,typeof J=="string"&&Y.test(J)?Q:null}}catch{return d}}function S(Q,Y,J){return!Q||typeof Y!="string"?!1:F(Q)(Y,void 0,J)}function F(Q,Y={}){if(!Q)return g;if(typeof Q=="string"||W(Q)){const J=h(Q,Y);if(J===d)return g;const x=function(ce,te){return!!J(ce,te)};return J.allBasenames&&(x.allBasenames=J.allBasenames),J.allPaths&&(x.allPaths=J.allPaths),x}return N(Q,Y)}function W(Q){const Y=Q;return Y?typeof Y.base=="string"&&typeof Y.pattern=="string":!1}function B(Q){return Q.allBasenames||[]}function T(Q){return Q.allPaths||[]}function N(Q,Y){const J=L(Object.getOwnPropertyNames(Q).map(ye=>j(ye,Q[ye],Y)).filter(ye=>ye!==d)),x=J.length;if(!x)return d;if(!J.some(ye=>!!ye.requiresSiblings)){if(x===1)return J[0];const ye=function(he,Se){let me;for(let ie=0,se=J.length;ie<se;ie++){const oe=J[ie](he,Se);if(typeof oe=="string")return oe;(0,R.$7g)(oe)&&(me||(me=[]),me.push(oe))}return me?(async()=>{for(const ie of me){const se=await ie;if(typeof se=="string")return se}return null})():null},_=J.find(he=>!!he.allBasenames);_&&(ye.allBasenames=_.allBasenames);const U=J.reduce((he,Se)=>Se.allPaths?he.concat(Se.allPaths):he,[]);return U.length&&(ye.allPaths=U),ye}const ce=function(ye,_,U){let he,Se;for(let me=0,ie=J.length;me<ie;me++){const se=J[me];se.requiresSiblings&&U&&(_||(_=(0,O.$oc)(ye)),he||(he=_.substr(0,_.length-(0,O.$pc)(ye).length)));const oe=se(ye,_,he,U);if(typeof oe=="string")return oe;(0,R.$7g)(oe)&&(Se||(Se=[]),Se.push(oe))}return Se?(async()=>{for(const me of Se){const ie=await me;if(typeof ie=="string")return ie}return null})():null},te=J.find(ye=>!!ye.allBasenames);te&&(ce.allBasenames=te.allBasenames);const pe=J.reduce((ye,_)=>_.allPaths?ye.concat(_.allPaths):ye,[]);return pe.length&&(ce.allPaths=pe),ce}function j(Q,Y,J){if(Y===!1)return d;const x=h(Q,J);if(x===d)return d;if(typeof Y=="boolean")return x;if(Y){const ce=Y.when;if(typeof ce=="string"){const te=(pe,ye,_,U)=>{if(!U||!x(pe,ye))return null;const he=ce.replace("$(basename)",()=>_),Se=U(he);return(0,R.$7g)(Se)?Se.then(me=>me?Q:null):Se?Q:null};return te.requiresSiblings=!0,te}}return x}function L(Q,Y){const J=Q.filter(ye=>!!ye.basenames);if(J.length<2)return Q;const x=J.reduce((ye,_)=>{const U=_.basenames;return U?ye.concat(U):ye},[]);let ce;if(Y){ce=[];for(let ye=0,_=x.length;ye<_;ye++)ce.push(Y)}else ce=J.reduce((ye,_)=>{const U=_.patterns;return U?ye.concat(U):ye},[]);const te=function(ye,_){if(typeof ye!="string")return null;if(!_){let he;for(he=ye.length;he>0;he--){const Se=ye.charCodeAt(he-1);if(Se===47||Se===92)break}_=ye.substr(he)}const U=x.indexOf(_);return U!==-1?ce[U]:null};te.basenames=x,te.patterns=ce,te.allBasenames=x;const pe=Q.filter(ye=>!ye.basenames);return pe.push(te),pe}function z(Q,Y){return(0,o.$ub)(Q,Y,(J,x)=>typeof J=="string"&&typeof x=="string"?J===x:typeof J!="string"&&typeof x!="string"?J.base===x.base&&J.pattern===x.pattern:!1)}}),define(Ee[79],Ce([1,0,13,172,23,14,2]),function(re,e,o,R,I,M,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fk=e.MarkdownStringTextNewlineStyle=void 0,e.$Gk=w,e.$Hk=A,e.$Ik=P,e.$Jk=b,e.$Kk=C,e.$Lk=y,e.$Mk=a,e.$Nk=m;var p;(function(l){l[l.Paragraph=0]="Paragraph",l[l.Break=1]="Break"})(p||(e.MarkdownStringTextNewlineStyle=p={}));class ${constructor(i="",n=!1){if(this.value=i,typeof this.value!="string")throw(0,o.$7)("value");typeof n=="boolean"?(this.isTrusted=n,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=n.isTrusted??void 0,this.supportThemeIcons=n.supportThemeIcons??!1,this.supportHtml=n.supportHtml??!1)}appendText(i,n=0){return this.value+=b(this.supportThemeIcons?(0,R.$zk)(i):i).replace(/([ \t]+)/g,(r,s)=>"&nbsp;".repeat(s.length)).replace(/\>/gm,"\\>").replace(/\n/g,n===1?`\\
`:`

`),this}appendMarkdown(i){return this.value+=i,this}appendCodeblock(i,n){return this.value+=`
${C(n,i)}
`,this}appendLink(i,n,r){return this.value+="[",this.value+=this.c(n,"]"),this.value+="](",this.value+=this.c(String(i),")"),r&&(this.value+=` "${this.c(this.c(r,'"'),")")}"`),this.value+=")",this}c(i,n){const r=new RegExp((0,M.$Ze)(n),"g");return i.replace(r,(s,t)=>i.charAt(t-1)!=="\\"?`\\${s}`:s)}}e.$Fk=$;function w(l){return A(l)?!l.value:Array.isArray(l)?l.every(w):!0}function A(l){return l instanceof $?!0:l&&typeof l=="object"?typeof l.value=="string"&&(typeof l.isTrusted=="boolean"||typeof l.isTrusted=="object"||l.isTrusted===void 0)&&(typeof l.supportThemeIcons=="boolean"||l.supportThemeIcons===void 0):!1}function P(l,i){return l===i?!0:!l||!i?!1:l.value===i.value&&l.isTrusted===i.isTrusted&&l.supportThemeIcons===i.supportThemeIcons&&l.supportHtml===i.supportHtml&&(l.baseUri===i.baseUri||!!l.baseUri&&!!i.baseUri&&(0,I.$Og)(O.URI.from(l.baseUri),O.URI.from(i.baseUri)))}function b(l){return l.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function C(l,i){const n=l.match(/^`+/gm)?.reduce((s,t)=>s.length>t.length?s:t).length??0,r=n>=3?n+1:3;return[`${"`".repeat(r)}${i}`,l,`${"`".repeat(r)}`].join(`
`)}function y(l){return l.replace(/"/g,"&quot;")}function a(l){return l&&l.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function m(l){const i=[],n=l.split("|").map(s=>s.trim());l=n[0];const r=n[1];if(r){const s=/height=(\d+)/.exec(r),t=/width=(\d+)/.exec(r),g=s?s[1]:"",d=t?t[1]:"",h=isFinite(parseInt(d)),c=isFinite(parseInt(g));h&&i.push(`width="${d}"`),c&&i.push(`height="${g}"`)}return{href:l,dimensions:i}}}),define(Ee[102],Ce([1,0,19,34,17,11,23,14]),function(re,e,o,R,I,M,O,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hw=$,e.$iw=A,e.$jw=b,e.$kw=C,e.$lw=l,e.$mw=n,e.$nw=r,e.$ow=s,e.$pw=t,e.$qw=g;function $(h,c){const{os:u,tildify:f,relative:E}=c;if(E){const k=w(h,E,u);if(typeof k=="string")return k}let v=h.fsPath;if(u===1&&!M.$c?v=v.replace(/\//g,"\\"):u!==1&&M.$c&&(v=v.replace(/\\/g,"/")),u!==1&&f?.userHome){const k=f.userHome.fsPath;let S;h.scheme!==f.userHome.scheme&&h.path[0]===I.$hc.sep&&h.path[1]!==I.$hc.sep?S=f.userHome.with({path:h.path}).fsPath:S=v,v=b(S,k,u)}return(u===1?I.$gc:I.$hc).normalize(A(v,u===1))}function w(h,c,u){const f=u===1?I.$gc:I.$hc,E=u===3?O.$Lg:O.$Ng,v=c.getWorkspace(),D=(0,o.$Ob)(v.folders);if(!D)return;h.scheme!==D.uri.scheme&&h.path[0]===I.$hc.sep&&h.path[1]!==I.$hc.sep&&(h=D.uri.with({path:h.path}));const k=c.getWorkspaceFolder(h);if(!k)return;let S;if(E.isEqual(k.uri,h)?S="":S=E.relativePath(k.uri,h)??"",S&&(S=f.normalize(S)),v.folders.length>1&&!c.noPrefix){const F=k.name?k.name:E.basenameOrAuthority(k.uri);S=S?`${F} \u2022 ${S}`:F}return S}function A(h,c=M.$c){return(0,R.$mg)(h,c)?h.charAt(0).toUpperCase()+h.slice(1):h}let P=Object.create(null);function b(h,c,u=M.OS){if(u===1||!h||!c)return h;let f=P.original===c?P.normalized:void 0;f||(f=c,M.$c&&(f=(0,R.$cg)(f)),f=`${(0,p.$6e)(f,I.$hc.sep)}${I.$hc.sep}`,P={original:c,normalized:f});let E=h;return M.$c&&(E=(0,R.$cg)(E)),(u===3?E.startsWith(f):(0,p.$mf)(E,f))?`~/${E.substr(f.length)}`:h}function C(h,c){return h.replace(/^~($|\/|\\)/,`${c}$1`)}const y="\u2026",a="\\\\",m="~";function l(h,c=I.sep){const u=new Array(h.length);let f=!1;for(let E=0;E<h.length;E++){const v=h[E];if(v===""){u[E]=`.${c}`;continue}if(!v){u[E]=v;continue}f=!0;let D="",k=v;k.indexOf(a)===0?(D=k.substr(0,k.indexOf(a)+a.length),k=k.substr(k.indexOf(a)+a.length)):k.indexOf(c)===0?(D=k.substr(0,k.indexOf(c)+c.length),k=k.substr(k.indexOf(c)+c.length)):k.indexOf(m)===0&&(D=k.substr(0,k.indexOf(m)+m.length),k=k.substr(k.indexOf(m)+m.length));const S=k.split(c);for(let F=1;f&&F<=S.length;F++)for(let W=S.length-F;f&&W>=0;W--){f=!1;let B=S.slice(W,W+F).join(c);for(let T=0;!f&&T<h.length;T++)if(T!==E&&h[T]&&h[T].indexOf(B)>-1){const N=W+F===S.length,j=W>0&&h[T].indexOf(c)>-1?c+B:B,L=h[T].endsWith(j);f=!N||L}if(!f){let T="";(S[0].endsWith(":")||D!=="")&&(W===1&&(W=0,F++,B=S[0]+c+B),W>0&&(T=S[0]+c),T=D+T),W>0&&(T=T+y+c),T=T+B,W+F<S.length&&(T=T+c+y),u[E]=T}}f&&(u[E]=v)}return u}var i;(function(h){h[h.TEXT=0]="TEXT",h[h.VARIABLE=1]="VARIABLE",h[h.SEPARATOR=2]="SEPARATOR"})(i||(i={}));function n(h,c=Object.create(null)){const u=[];let f=!1,E="";for(const v of h)if(v==="$"||f&&v==="{")E&&u.push({value:E,type:i.TEXT}),E="",f=!0;else if(v==="}"&&f){const D=c[E];if(typeof D=="string")D.length&&u.push({value:D,type:i.VARIABLE});else if(D){const k=u[u.length-1];(!k||k.type!==i.SEPARATOR)&&u.push({value:D.label,type:i.SEPARATOR})}E="",f=!1}else E+=v;return E&&!f&&u.push({value:E,type:i.TEXT}),u.filter((v,D)=>{if(v.type===i.SEPARATOR){const k=u[D-1],S=u[D+1];return[k,S].every(F=>F&&(F.type===i.VARIABLE||F.type===i.TEXT)&&F.value.length>0)}return!0}).map(v=>v.value).join("")}function r(h,c){return M.$d||c?h.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.$d?"&":"&&"):h.replace(/&&|&/g,u=>u==="&"?"&&":"&")}function s(h,c){return M.$d||c?h.replace(/\(&&\w\)|&&/g,""):M.$c?h.replace(/&&|&/g,u=>u==="&"?"&&":"&"):h.replace(/&&/g,"_")}function t(h){return h.replace(/&/g,"&&")}function g(h){if(h.endsWith("]")){const c=h.lastIndexOf(" [",h.length-2);if(c!==-1){const u=d(h.substring(0,c)),f=h.substring(c);return{name:u.name+f,parentPath:u.parentPath}}}return d(h)}function d(h){const c=h.indexOf("/")!==-1?I.$hc:I.$gc,u=c.basename(h),f=c.dirname(h);return u.length?{name:u,parentPath:f}:{name:f,parentPath:""}}}),define(Ee[131],Ce([1,0,21,2]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mn=e.$ln=void 0,e.$nn=p,e.$on=w,e.$pn=A;function I(P){return P.toJSON()}class M{constructor(b){this.a=b}transformIncoming(b){const C=this.a.transformIncoming(b);return C===b?b:I(R.URI.from(C))}transformOutgoing(b){const C=this.a.transformOutgoing(b);return C===b?b:I(R.URI.from(C))}transformOutgoingURI(b){const C=this.a.transformOutgoing(b);return C===b?b:R.URI.from(C)}transformOutgoingScheme(b){return this.a.transformOutgoingScheme(b)}}e.$ln=M,e.$mn=new class{transformIncoming(P){return P}transformOutgoing(P){return P}transformOutgoingURI(P){return P}transformOutgoingScheme(P){return P}};function O(P,b,C){if(!P||C>200)return null;if(typeof P=="object"){if(P instanceof R.URI)return b.transformOutgoing(P);for(const y in P)if(Object.hasOwnProperty.call(P,y)){const a=O(P[y],b,C+1);a!==null&&(P[y]=a)}}return null}function p(P,b){const C=O(P,b,0);return C===null?P:C}function $(P,b,C,y){if(!P||y>200)return null;if(typeof P=="object"){if(P.$mid===1)return C?R.URI.revive(b.transformIncoming(P)):b.transformIncoming(P);if(P instanceof o.$ue)return null;for(const a in P)if(Object.hasOwnProperty.call(P,a)){const m=$(P[a],b,C,y+1);m!==null&&(P[a]=m)}}return null}function w(P,b){const C=$(P,b,!1,0);return C===null?P:C}function A(P,b){const C=$(P,b,!0,0);return C===null?P:C}}),define(Ee[30],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eg=void 0,e.$Dg=R;const o=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(I){return o.test(I)}e.$Eg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let I;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?I=crypto.getRandomValues.bind(crypto):I=function(p){for(let $=0;$<p.length;$++)p[$]=Math.floor(Math.random()*256);return p};const M=new Uint8Array(16),O=[];for(let p=0;p<256;p++)O.push(p.toString(16).padStart(2,"0"));return function(){I(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let $=0,w="";return w+=O[M[$++]],w+=O[M[$++]],w+=O[M[$++]],w+=O[M[$++]],w+="-",w+=O[M[$++]],w+=O[M[$++]],w+="-",w+=O[M[$++]],w+=O[M[$++]],w+="-",w+=O[M[$++]],w+=O[M[$++]],w+="-",w+=O[M[$++]],w+=O[M[$++]],w+=O[M[$++]],w+=O[M[$++]],w+=O[M[$++]],w+=O[M[$++]],w}}()}),define(Ee[175],Ce([1,0,19,39,30]),function(re,e,o,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mt=e.$Kt=void 0,e.$It=M,e.$Jt=O,e.$Lt=w;function M(P){return{asString:async()=>P,asFile:()=>{},value:typeof P=="string"?P:void 0}}function O(P,b,C){const y={id:(0,I.$Eg)(),name:P,uri:b,data:C};return{asString:async()=>"",asFile:()=>y,value:void 0}}class p{constructor(){this.a=new Map}get size(){let b=0;for(const C of this.a)b++;return b}has(b){return this.a.has(this.b(b))}matches(b){const C=[...this.a.keys()];return R.Iterable.some(this,([y,a])=>a.asFile())&&C.push("files"),A($(b),C)}get(b){return this.a.get(this.b(b))?.[0]}append(b,C){const y=this.a.get(b);y?y.push(C):this.a.set(this.b(b),[C])}replace(b,C){this.a.set(this.b(b),[C])}delete(b){this.a.delete(this.b(b))}*[Symbol.iterator](){for(const[b,C]of this.a)for(const y of C)yield[b,y]}b(b){return $(b)}}e.$Kt=p;function $(P){return P.toLowerCase()}function w(P,b){return A($(P),b.map($))}function A(P,b){if(P==="*/*")return b.length>0;if(b.includes(P))return!0;const C=P.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!C)return!1;const[y,a,m]=C;return m==="*"?b.some(l=>l.startsWith(a+"/")):!1}e.$Mt=Object.freeze({create:P=>(0,o.$Mb)(P.map(b=>b.toString())).join(`\r
`),split:P=>P.split(`\r
`),parse:P=>e.$Mt.split(P).filter(b=>!b.startsWith("#"))})}),define(Ee[31],Ce([1,0,50,62,395,8,34,76,17,11,23,2]),function(re,e,o,R,I,M,O,p,$,w,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=m,e.readdirSync=n,e.whenDeleted=t,e.configureFlushOnWrite=u,e.writeFileSync=E;var b;(function(j){j[j.UNLINK=0]="UNLINK",j[j.MOVE=1]="MOVE"})(b||(e.RimRafMode=b={}));async function C(j,L=b.UNLINK,z){if((0,O.$lg)(j))throw new Error("rimraf - will refuse to recursively delete root");return L===b.UNLINK?a(j):y(j,z)}async function y(j,L=(0,O.$qg)((0,R.tmpdir)())){try{try{await o.promises.rename(j,L)}catch(z){return z.code==="ENOENT"?void 0:a(j)}a(L).catch(z=>{})}catch(z){if(z.code!=="ENOENT")throw z}}async function a(j){return(0,I.promisify)(o.rm)(j,{recursive:!0,force:!0,maxRetries:3})}function m(j){if((0,O.$lg)(j))throw new Error("rimraf - will refuse to recursively delete root");o.rmSync(j,{recursive:!0,force:!0,maxRetries:3})}async function l(j,L){return r(await(L?i(j):(0,I.promisify)(o.readdir)(j)))}async function i(j){try{return await(0,I.promisify)(o.readdir)(j,{withFileTypes:!0})}catch(Q){console.warn("[node.js fs] readdir with filetypes failed with error: ",Q)}const L=[],z=await l(j);for(const Q of z){let Y=!1,J=!1,x=!1;try{const ce=await e.Promises.lstat((0,$.$kc)(j,Q));Y=ce.isFile(),J=ce.isDirectory(),x=ce.isSymbolicLink()}catch(ce){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ce)}L.push({name:Q,isFile:()=>Y,isDirectory:()=>J,isSymbolicLink:()=>x})}return L}function n(j){return r(o.readdirSync(j))}function r(j){return j.map(L=>typeof L=="string"?w.$d?(0,p.$1l)(L):L:(L.name=w.$d?(0,p.$1l)(L.name):L.name,L))}async function s(j){const L=await l(j),z=[];for(const Q of L)await g.existsDirectory((0,$.$kc)(j,Q))&&z.push(Q);return z}function t(j,L=1e3){return new Promise(z=>{let Q=!1;const Y=setInterval(()=>{Q||(Q=!0,o.access(j,J=>{Q=!1,J&&(clearInterval(Y),z(void 0))}))},L)})}var g;(function(j){async function L(Y){let J;try{if(J=await e.Promises.lstat(Y),!J.isSymbolicLink())return{stat:J}}catch{}try{return{stat:await e.Promises.stat(Y),symbolicLink:J?.isSymbolicLink()?{dangling:!1}:void 0}}catch(x){if(x.code==="ENOENT"&&J)return{stat:J,symbolicLink:{dangling:!0}};if(w.$c&&x.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(Y)),symbolicLink:{dangling:!1}}}catch(ce){if(ce.code==="ENOENT"&&J)return{stat:J,symbolicLink:{dangling:!0}};throw ce}throw x}}j.stat=L;async function z(Y){try{const{stat:J,symbolicLink:x}=await j.stat(Y);return J.isFile()&&x?.dangling!==!0}catch{}return!1}j.existsFile=z;async function Q(Y){try{const{stat:J,symbolicLink:x}=await j.stat(Y);return J.isDirectory()&&x?.dangling!==!0}catch{}return!1}j.existsDirectory=Q})(g||(e.SymlinkSupport=g={}));const d=new M.$rh;function h(j,L,z){return d.queueFor(P.URI.file(j),()=>{const Q=v(z);return new Promise((Y,J)=>f(j,L,Q,x=>x?J(x):Y()))},A.$Mg)}let c=!0;function u(j){c=j}function f(j,L,z,Q){if(!c)return o.writeFile(j,L,{mode:z.mode,flag:z.flag},Q);o.open(j,z.flag,z.mode,(Y,J)=>{if(Y)return Q(Y);o.writeFile(J,L,x=>{if(x)return o.close(J,()=>Q(x));o.fdatasync(J,ce=>(ce&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ce),u(!1)),o.close(J,te=>Q(te))))})})}function E(j,L,z){const Q=v(z);if(!c)return o.writeFileSync(j,L,{mode:Q.mode,flag:Q.flag});const Y=o.openSync(j,Q.flag,Q.mode);try{o.writeFileSync(Y,L);try{o.fdatasyncSync(Y)}catch(J){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",J),u(!1)}}finally{o.closeSync(Y)}}function v(j){return j?{mode:typeof j.mode=="number"?j.mode:438,flag:typeof j.flag=="string"?j.flag:"w"}:{mode:438,flag:"w"}}async function D(j,L,z=6e4){if(j!==L)try{w.$c&&typeof z=="number"?await k(j,L,Date.now(),z):await(0,I.promisify)(o.rename)(j,L)}catch(Q){if(j.toLowerCase()!==L.toLowerCase()&&Q.code==="EXDEV"||j.endsWith("."))await S(j,L,{preserveSymlinks:!1}),await C(j,b.MOVE);else throw Q}}async function k(j,L,z,Q,Y=0){try{return await(0,I.promisify)(o.rename)(j,L)}catch(J){if(J.code!=="EACCES"&&J.code!=="EPERM"&&J.code!=="EBUSY")throw J;if(Date.now()-z>=Q)throw console.error(`[node.js fs] rename failed after ${Y} retries with error: ${J}`),J;if(Y===0){let x=!1;try{const{stat:ce}=await g.stat(L);ce.isFile()||(x=!0)}catch{}if(x)throw J}return await(0,M.$jh)(Math.min(100,Y*10)),k(j,L,z,Q,Y+1)}}async function S(j,L,z){return W(j,L,{root:{source:j,target:L},options:z,handledSourcePaths:new Set})}const F=511;async function W(j,L,z){if(z.handledSourcePaths.has(j))return;z.handledSourcePaths.add(j);const{stat:Q,symbolicLink:Y}=await g.stat(j);if(Y){if(z.options.preserveSymlinks)try{return await N(j,L,z)}catch{}if(Y.dangling)return}return Q.isDirectory()?B(j,L,Q.mode&F,z):T(j,L,Q.mode&F)}async function B(j,L,z,Q){await e.Promises.mkdir(L,{recursive:!0,mode:z});const Y=await l(j);for(const J of Y)await W((0,$.$kc)(j,J),(0,$.$kc)(L,J),Q)}async function T(j,L,z){await e.Promises.copyFile(j,L),await e.Promises.chmod(L,z)}async function N(j,L,z){let Q=await e.Promises.readlink(j);(0,O.$ig)(Q,z.root.source,!w.$e)&&(Q=(0,$.$kc)(z.root.target,Q.substr(z.root.source.length+1))),await e.Promises.symlink(Q,L)}e.Promises=new class{get access(){return(0,I.promisify)(o.access)}get stat(){return(0,I.promisify)(o.stat)}get lstat(){return(0,I.promisify)(o.lstat)}get utimes(){return(0,I.promisify)(o.utimes)}get read(){return(j,L,z,Q,Y)=>new Promise((J,x)=>{o.read(j,L,z,Q,Y,(ce,te,pe)=>ce?x(ce):J({bytesRead:te,buffer:pe}))})}get readFile(){return(0,I.promisify)(o.readFile)}get write(){return(j,L,z,Q,Y)=>new Promise((J,x)=>{o.write(j,L,z,Q,Y,(ce,te,pe)=>ce?x(ce):J({bytesWritten:te,buffer:pe}))})}get appendFile(){return(0,I.promisify)(o.appendFile)}get fdatasync(){return(0,I.promisify)(o.fdatasync)}get truncate(){return(0,I.promisify)(o.truncate)}get copyFile(){return(0,I.promisify)(o.copyFile)}get open(){return(0,I.promisify)(o.open)}get close(){return(0,I.promisify)(o.close)}get symlink(){return(0,I.promisify)(o.symlink)}get readlink(){return(0,I.promisify)(o.readlink)}get chmod(){return(0,I.promisify)(o.chmod)}get mkdir(){return(0,I.promisify)(o.mkdir)}get unlink(){return(0,I.promisify)(o.unlink)}get rmdir(){return(0,I.promisify)(o.rmdir)}get realpath(){return(0,I.promisify)(o.realpath)}async exists(j){try{return await e.Promises.access(j),!0}catch{return!1}}get readdir(){return l}get readDirsInDir(){return s}get writeFile(){return h}get rm(){return C}get rename(){return D}get copy(){return S}}}),define(Ee[103],Ce([1,0,50,17,11,14,31]),function(re,e,o,R,I,M,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oq=p,e.$Pq=$,e.$Qq=w,e.$Rq=A;function p(b){if(I.$e)return b;const C=(0,R.$nc)(b);if(b===C)return b;const y=((0,R.$oc)(b)||b).toLowerCase();try{const m=(0,O.readdirSync)(C).filter(l=>l.toLowerCase()===y);if(m.length===1){const l=p(C);if(l)return(0,R.$kc)(l,m[0])}else if(m.length>1){const l=m.indexOf(y);if(l>=0){const i=p(C);if(i)return(0,R.$kc)(i,m[l])}}}catch{}return null}async function $(b,C){if(I.$e)return b;const y=(0,R.$nc)(b);if(b===y)return b;const a=((0,R.$oc)(b)||b).toLowerCase();try{if(C?.isCancellationRequested)return null;const l=(await O.Promises.readdir(y)).filter(i=>i.toLowerCase()===a);if(l.length===1){const i=await $(y,C);if(i)return(0,R.$kc)(i,l[0])}else if(l.length>1){const i=l.indexOf(a);if(i>=0){const n=await $(y,C);if(n)return(0,R.$kc)(n,l[i])}}}catch{}return null}async function w(b){try{return await O.Promises.realpath(b)}catch{const y=P(b);return await O.Promises.access(y,o.constants.R_OK),y}}function A(b){try{return o.realpathSync(b)}catch{const y=P(b);return o.accessSync(y,o.constants.R_OK),y}}function P(b){return(0,M.$6e)((0,R.$ic)(b),R.sep)}}),define(Ee[176],Ce([1,0,63]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hg=void 0,e.$Gg=R,e.$Ig=M;function R(p,$,w,A=1){let P=!1;return new Promise(b=>{const C=setTimeout(()=>{if(!P)return P=!0,b(0)},w);I(p,$,A,y=>{if(!P)return P=!0,clearTimeout(C),b(y)})})}function I(p,$,w,A){if($===0)return A(0);const P=new o.Socket;P.once("connect",()=>(O(P),I(p+w,$-1,w,A))),P.once("data",()=>{}),P.once("error",b=>(O(P),b.code!=="ECONNREFUSED"?I(p+w,$-1,w,A):A(p))),P.connect(p,"127.0.0.1")}e.$Hg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function M(p,$,w,A="127.0.0.1"){let P=!1,b,C=1;const y=o.createServer({pauseOnConnect:!0});function a(m,l){P||(P=!0,y.removeAllListeners(),y.close(),b&&clearTimeout(b),l(m))}return new Promise(m=>{b=setTimeout(()=>{a(0,m)},w),y.on("listening",()=>{a(p,m)}),y.on("error",l=>{l&&(l.code==="EADDRINUSE"||l.code==="EACCES")&&C<$?(p++,C++,y.listen(p,A)):a(0,m)}),y.on("close",()=>{a(0,m)}),y.listen(p,A)})}function O(p){try{p.removeAllListeners("connect"),p.removeAllListeners("error"),p.end(),p.destroy(),p.unref()}catch($){console.error($)}}}),define(Ee[104],Ce([1,0,17,11,49,99,18,31]),function(re,e,o,R,I,M,O,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$bm=$,e.$cm=w,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return M.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return M.TerminateResponseCode}});function $(P=I.env){return P.comspec||"cmd.exe"}function w(P){let b=[],C=!1;const y=function(a){if(C){b.push(a);return}(!P.send(a,l=>{if(l&&console.error(l),C=!1,b.length>0){const i=b.slice(0);b=[],i.forEach(n=>y(n))}})||R.$c)&&(C=!0)};return{send:y}}var A;(function(P){async function b(C,y,a){if(o.$jc(C))return C;if(y===void 0&&(y=I.cwd()),o.$nc(C)!=="."||(a===void 0&&O.$Vf(I.env.PATH)&&(a=I.env.PATH.split(o.$uc)),a===void 0||a.length===0))return o.$kc(y,C);async function l(i){if(await p.Promises.exists(i)){let n;try{n=await p.Promises.stat(i)}catch(r){r.message.startsWith("EACCES")&&(n=await p.Promises.lstat(i))}return n?!n.isDirectory():!1}return!1}for(const i of a){let n;if(o.$jc(i)?n=o.$kc(i,C):n=o.$kc(y,i,C),await l(n))return n;let r=n+".com";if(await l(r)||(r=n+".exe",await l(r)))return r}return o.$kc(y,C)}P.findExecutable=b})(A||(e.win32=A={}))});var Qe=this&&this.__decorate||function(re,e,o,R){var I=arguments.length,M=I<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,o):R,O;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(re,e,o,R);else for(var p=re.length-1;p>=0;p--)(O=re[p])&&(M=(I<3?O(M):I>3?O(e,o,M):O(e,o))||M);return I>3&&M&&Object.defineProperty(e,o,M),M};define(Ee[80],Ce([1,0,19,8,21,22,54,13,4,3,57,14,18]),function(re,e,o,R,I,M,O,p,$,w,A,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=e.ProxyChannel=e.$3h=e.$Zh=e.$Yh=e.$Xh=e.RequestInitiator=e.$Wh=e.$Th=e.$Sh=void 0,e.$Uh=u,e.$Vh=f,e.$1h=F,e.$2h=W;var C;(function(Y){Y[Y.Promise=100]="Promise",Y[Y.PromiseCancel=101]="PromiseCancel",Y[Y.EventListen=102]="EventListen",Y[Y.EventDispose=103]="EventDispose"})(C||(C={}));function y(Y){switch(Y){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var a;(function(Y){Y[Y.Initialize=200]="Initialize",Y[Y.PromiseSuccess=201]="PromiseSuccess",Y[Y.PromiseError=202]="PromiseError",Y[Y.PromiseErrorObj=203]="PromiseErrorObj",Y[Y.EventFire=204]="EventFire"})(a||(a={}));function m(Y){switch(Y){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var l;(function(Y){Y[Y.Uninitialized=0]="Uninitialized",Y[Y.Idle=1]="Idle"})(l||(l={}));function i(Y){let J=0;for(let x=0;;x+=7){const ce=Y.read(1);if(J|=(ce.buffer[0]&127)<<x,!(ce.buffer[0]&128))return J}}const n=d(0);function r(Y,J){if(J===0){Y.write(n);return}let x=0;for(let te=J;te!==0;te=te>>>7)x++;const ce=I.$ue.alloc(x);for(let te=0;J!==0;te++)ce.buffer[te]=J&127,J=J>>>7,J>0&&(ce.buffer[te]|=128);Y.write(ce)}class s{constructor(J){this.b=J,this.a=0}read(J){const x=this.b.slice(this.a,this.a+J);return this.a+=x.byteLength,x}}e.$Sh=s;class t{constructor(){this.a=[]}get buffer(){return I.$ue.concat(this.a)}write(J){this.a.push(J)}}e.$Th=t;var g;(function(Y){Y[Y.Undefined=0]="Undefined",Y[Y.String=1]="String",Y[Y.Buffer=2]="Buffer",Y[Y.VSBuffer=3]="VSBuffer",Y[Y.Array=4]="Array",Y[Y.Object=5]="Object",Y[Y.Int=6]="Int"})(g||(g={}));function d(Y){const J=I.$ue.alloc(1);return J.writeUInt8(Y,0),J}const h={Undefined:d(g.Undefined),String:d(g.String),Buffer:d(g.Buffer),VSBuffer:d(g.VSBuffer),Array:d(g.Array),Object:d(g.Object),Uint:d(g.Int)},c=typeof Buffer<"u";function u(Y,J){if(typeof J>"u")Y.write(h.Undefined);else if(typeof J=="string"){const x=I.$ue.fromString(J);Y.write(h.String),r(Y,x.byteLength),Y.write(x)}else if(c&&Buffer.isBuffer(J)){const x=I.$ue.wrap(J);Y.write(h.Buffer),r(Y,x.byteLength),Y.write(x)}else if(J instanceof I.$ue)Y.write(h.VSBuffer),r(Y,J.byteLength),Y.write(J);else if(Array.isArray(J)){Y.write(h.Array),r(Y,J.length);for(const x of J)u(Y,x)}else if(typeof J=="number"&&(J|0)===J)Y.write(h.Uint),r(Y,J);else{const x=I.$ue.fromString(JSON.stringify(J));Y.write(h.Object),r(Y,x.byteLength),Y.write(x)}}function f(Y){switch(Y.read(1).readUInt8(0)){case g.Undefined:return;case g.String:return Y.read(i(Y)).toString();case g.Buffer:return Y.read(i(Y)).buffer;case g.VSBuffer:return Y.read(i(Y));case g.Array:{const x=i(Y),ce=[];for(let te=0;te<x;te++)ce.push(f(Y));return ce}case g.Object:return JSON.parse(Y.read(i(Y)).toString());case g.Int:return i(Y)}}class E{constructor(J,x,ce=null,te=1e3){this.h=J,this.j=x,this.k=ce,this.l=te,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(pe=>this.q(pe)),this.m({type:200})}registerChannel(J,x){this.b.set(J,x),setTimeout(()=>this.w(J),0)}m(J){switch(J.type){case 200:{const x=this.o([J.type]);this.k?.logOutgoing(x,0,1,m(J.type));return}case 201:case 202:case 204:case 203:{const x=this.o([J.type,J.id],J.data);this.k?.logOutgoing(x,J.id,1,m(J.type),J.data);return}}}o(J,x=void 0){const ce=new t;return u(ce,J),u(ce,x),this.p(ce.buffer)}p(J){try{return this.h.send(J),J.byteLength}catch{return 0}}q(J){const x=new s(J),ce=f(x),te=f(x),pe=ce[0];switch(pe){case 100:return this.k?.logIncoming(J.byteLength,ce[1],1,`${y(pe)}: ${ce[2]}.${ce[3]}`,te),this.s({type:pe,id:ce[1],channelName:ce[2],name:ce[3],arg:te});case 102:return this.k?.logIncoming(J.byteLength,ce[1],1,`${y(pe)}: ${ce[2]}.${ce[3]}`,te),this.t({type:pe,id:ce[1],channelName:ce[2],name:ce[3],arg:te});case 101:return this.k?.logIncoming(J.byteLength,ce[1],1,`${y(pe)}`),this.u({type:pe,id:ce[1]});case 103:return this.k?.logIncoming(J.byteLength,ce[1],1,`${y(pe)}`),this.u({type:pe,id:ce[1]})}}s(J){const x=this.b.get(J.channelName);if(!x){this.v(J);return}const ce=new M.$ee;let te;try{te=x.call(this.j,J.name,J.arg,ce.token)}catch(_){te=Promise.reject(_)}const pe=J.id;te.then(_=>{this.m({id:pe,data:_,type:201})},_=>{_ instanceof Error?this.m({id:pe,data:{message:_.message,name:_.name,stack:_.stack?_.stack.split?_.stack.split(`
`):_.stack:void 0},type:202}):this.m({id:pe,data:_,type:203})}).finally(()=>{ye.dispose(),this.d.delete(J.id)});const ye=(0,w.$Sc)(()=>ce.cancel());this.d.set(J.id,ye)}t(J){const x=this.b.get(J.channelName);if(!x){this.v(J);return}const ce=J.id,pe=x.listen(this.j,J.name,J.arg)(ye=>this.m({id:ce,data:ye,type:204}));this.d.set(J.id,pe)}u(J){const x=this.d.get(J.id);x&&(x.dispose(),this.d.delete(J.id))}v(J){let x=this.g.get(J.channelName);x||(x=[],this.g.set(J.channelName,x));const ce=setTimeout(()=>{console.error(`Unknown channel: ${J.channelName}`),J.type===100&&this.m({id:J.id,data:{name:"Unknown channel",message:`Channel name '${J.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);x.push({request:J,timeoutTimer:ce})}w(J){const x=this.g.get(J);if(x){for(const ce of x)switch(clearTimeout(ce.timeoutTimer),ce.request.type){case 100:this.s(ce.request);break;case 102:this.t(ce.request);break}this.g.delete(J)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,w.$Pc)(this.d.values()),this.d.clear()}}e.$Wh=E;var v;(function(Y){Y[Y.LocalSide=0]="LocalSide",Y[Y.OtherSide=1]="OtherSide"})(v||(e.RequestInitiator=v={}));class D{constructor(J,x=null){this.l=J,this.a=!1,this.b=l.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new $.$7d,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ce=>this.s(ce)),this.j=x}getChannel(J){const x=this;return{call(ce,te,pe){return x.a?Promise.reject(new p.$5):x.m(J,ce,te,pe)},listen(ce,te){return x.a?$.Event.None:x.o(J,ce,te)}}}m(J,x,ce,te=M.CancellationToken.None){const pe=this.g++,_={id:pe,type:100,channelName:J,name:x,arg:ce};if(te.isCancellationRequested)return Promise.reject(new p.$5);let U;return new Promise((Se,me)=>{if(te.isCancellationRequested)return me(new p.$5);const ie=()=>{const ee=le=>{switch(le.type){case 201:this.f.delete(pe),Se(le.data);break;case 202:{this.f.delete(pe);const de=new Error(le.data.message);de.stack=Array.isArray(le.data.stack)?le.data.stack.join(`
`):le.data.stack,de.name=le.data.name,me(de);break}case 203:this.f.delete(pe),me(le.data);break}};this.f.set(pe,ee),this.p(_)};let se=null;this.b===l.Idle?ie():(se=(0,R.$8g)(ee=>this.u()),se.then(()=>{se=null,ie()}));const oe=()=>{se?(se.cancel(),se=null):this.p({id:pe,type:101}),me(new p.$5)},G=te.onCancellationRequested(oe);U=(0,w.$Rc)((0,w.$Sc)(oe),G),this.d.add(U)}).finally(()=>{U.dispose(),this.d.delete(U)})}o(J,x,ce){const te=this.g++,ye={id:te,type:102,channelName:J,name:x,arg:ce};let _=null;const U=new $.$7d({onWillAddFirstListener:()=>{_=(0,R.$8g)(Se=>this.u()),_.then(()=>{_=null,this.d.add(U),this.p(ye)})},onDidRemoveLastListener:()=>{_?(_.cancel(),_=null):(this.d.delete(U),this.p({id:te,type:103}))}}),he=Se=>U.fire(Se.data);return this.f.set(te,he),U.event}p(J){switch(J.type){case 100:case 102:{const x=this.q([J.type,J.id,J.channelName,J.name],J.arg);this.j?.logOutgoing(x,J.id,0,`${y(J.type)}: ${J.channelName}.${J.name}`,J.arg);return}case 101:case 103:{const x=this.q([J.type,J.id]);this.j?.logOutgoing(x,J.id,0,y(J.type));return}}}q(J,x=void 0){const ce=new t;return u(ce,J),u(ce,x),this.r(ce.buffer)}r(J){try{return this.l.send(J),J.byteLength}catch{return 0}}s(J){const x=new s(J),ce=f(x),te=f(x),pe=ce[0];switch(pe){case 200:return this.j?.logIncoming(J.byteLength,0,0,m(pe)),this.t({type:ce[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(J.byteLength,ce[1],0,m(pe),te),this.t({type:ce[0],id:ce[1],data:te})}}t(J){if(J.type===200){this.b=l.Idle,this.k.fire();return}this.f.get(J.id)?.(J)}get onDidInitializePromise(){return $.Event.toPromise(this.onDidInitialize)}u(){return this.b===l.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,w.$Pc)(this.d.values()),this.d.clear()}}e.$Xh=D,Qe([O.$Mh],D.prototype,"onDidInitializePromise",null);class k{get connections(){const J=[];return this.f.forEach(x=>J.push(x)),J}constructor(J,x,ce){this.a=new Map,this.f=new Set,this.g=new $.$7d,this.onDidAddConnection=this.g.event,this.h=new $.$7d,this.onDidRemoveConnection=this.h.event,this.j=new w.$Tc,this.j.add(J(({protocol:te,onDidClientDisconnect:pe})=>{const ye=$.Event.once(te.onMessage);this.j.add(ye(_=>{const U=new s(_),he=f(U),Se=new E(te,he,x,ce),me=new D(te,x);this.a.forEach((se,oe)=>Se.registerChannel(oe,se));const ie={channelServer:Se,channelClient:me,ctx:he};this.f.add(ie),this.g.fire(ie),this.j.add(pe(()=>{Se.dispose(),me.dispose(),this.f.delete(ie),this.h.fire(ie)}))}))}))}getChannel(J,x){const ce=this;return{call(te,pe,ye){let _;if((0,b.$0f)(x)){const he=(0,o.$4b)(ce.connections.filter(x));_=he?Promise.resolve(he):$.Event.toPromise($.Event.filter(ce.onDidAddConnection,x))}else _=x.routeCall(ce,te,pe);const U=_.then(he=>he.channelClient.getChannel(J));return F(U).call(te,pe,ye)},listen(te,pe){if((0,b.$0f)(x))return ce.k(J,x,te,pe);const ye=x.routeEvent(ce,te,pe).then(_=>_.channelClient.getChannel(J));return F(ye).listen(te,pe)}}}k(J,x,ce,te){const pe=this;let ye;const _=new $.$7d({onWillAddFirstListener:()=>{ye=new w.$Tc;const U=new $.$ae,he=new Map,Se=ie=>{const oe=ie.channelClient.getChannel(J).listen(ce,te),G=U.add(oe);he.set(ie,G)},me=ie=>{const se=he.get(ie);se&&(se.dispose(),he.delete(ie))};pe.connections.filter(x).forEach(Se),$.Event.filter(pe.onDidAddConnection,x)(Se,void 0,ye),pe.onDidRemoveConnection(me,void 0,ye),U.event(_.fire,_,ye),ye.add(U)},onDidRemoveLastListener:()=>{ye?.dispose(),ye=void 0}});return _.event}registerChannel(J,x){this.a.set(J,x);for(const ce of this.f)ce.channelServer.registerChannel(J,x)}dispose(){this.j.dispose();for(const J of this.f)J.channelClient.dispose(),J.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Yh=k;class S{constructor(J,x,ce=null){const te=new t;u(te,x),J.send(te.buffer),this.a=new D(J,ce),this.d=new E(J,x,ce)}getChannel(J){return this.a.getChannel(J)}registerChannel(J,x){this.d.registerChannel(J,x)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Zh=S;function F(Y){return{call(J,x,ce){return Y.then(te=>te.call(J,x,ce))},listen(J,x){const ce=new $.$de;return Y.then(te=>ce.input=te.listen(J,x)),ce.event}}}function W(Y){let J=!1;return{call(x,ce,te){return J?Y.call(x,ce,te):(0,R.$jh)(0).then(()=>J=!0).then(()=>Y.call(x,ce,te))},listen(x,ce){if(J)return Y.listen(x,ce);const te=new $.$de;return(0,R.$jh)(0).then(()=>J=!0).then(()=>te.input=Y.listen(x,ce)),te.event}}}class B{constructor(J){this.a=J}routeCall(J){return this.b(J)}routeEvent(J){return this.b(J)}async b(J){for(const x of J.connections)if(await Promise.resolve(this.a(x.ctx)))return Promise.resolve(x);return await $.Event.toPromise(J.onDidAddConnection),await this.b(J)}}e.$3h=B;var T;(function(Y){function J(pe,ye,_){const U=pe,he=_&&_.disableMarshalling,Se=new Map;for(const me in U)ce(me)&&Se.set(me,$.Event.buffer(U[me],!0,void 0,ye));return new class{listen(me,ie,se){const oe=Se.get(ie);if(oe)return oe;const G=U[ie];if(typeof G=="function"){if(te(ie))return G.call(U,se);if(ce(ie))return Se.set(ie,$.Event.buffer(U[ie],!0,void 0,ye)),Se.get(ie)}throw new p.$bb(`Event not found: ${ie}`)}call(me,ie,se){const oe=U[ie];if(typeof oe=="function"){if(!he&&Array.isArray(se))for(let ee=0;ee<se.length;ee++)se[ee]=(0,A.$Rh)(se[ee]);let G=oe.apply(U,se);return G instanceof Promise||(G=Promise.resolve(G)),G}throw new p.$bb(`Method not found: ${ie}`)}}}Y.fromService=J;function x(pe,ye){const _=ye&&ye.disableMarshalling;return new Proxy({},{get(U,he){if(typeof he=="string")return ye?.properties?.has(he)?ye.properties.get(he):te(he)?function(Se){return pe.listen(he,Se)}:ce(he)?pe.listen(he):async function(...Se){let me;ye&&!(0,b.$5f)(ye.context)?me=[ye.context,...Se]:me=Se;const ie=await pe.call(he,me);return _?ie:(0,A.$Rh)(ie)};throw new p.$bb(`Property not found: ${String(he)}`)}})}Y.toService=x;function ce(pe){return pe[0]==="o"&&pe[1]==="n"&&P.$kf(pe.charCodeAt(2))}function te(pe){return/^onDynamic/.test(pe)&&P.$kf(pe.charCodeAt(9))}})(T||(e.ProxyChannel=T={}));const N=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function j(Y){if(Array.isArray(Y))return Y;if(Y&&typeof Y=="object"&&typeof Y.toString=="function"){const J=Y.toString();if(J!=="[object Object]")return J}return Y}function L(Y){return Array.isArray(Y)?Y.map(j):j(Y)}function z(Y,J,x,ce,te,pe,ye){ye=L(ye);const _=N[te],U=_[ce%_.length];let he=[`%c[${Y}]%c[${String(J).padStart(7," ")}]%c[len: ${String(x).padStart(5," ")}]%c${String(ce).padStart(5," ")} - ${pe}`,"color: darkgreen","color: grey","color: grey",`color: ${U}`];/\($/.test(pe)?(he=he.concat(ye),he.push(")")):he.push(ye),console.log.apply(console,he)}class Q{constructor(J,x){this.d=J,this.f=x,this.a=0,this.b=0}logOutgoing(J,x,ce,te,pe){this.b+=J,z(this.d,this.b,J,x,ce,te,pe)}logIncoming(J,x,ce,te,pe){this.a+=J,z(this.f,this.a,J,x,ce,te,pe)}}e.$4h=Q}),define(Ee[81],Ce([1,0,21,4,3,80]),function(re,e,o,R,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9h=e.$8h=e.$7h=e.$6h=e.ProtocolConstants=e.$5h=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var O;(function(h){h.Created="created",h.Read="read",h.Write="write",h.Open="open",h.Error="error",h.Close="close",h.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",h.NodeEndReceived="nodeEndReceived",h.NodeEndSent="nodeEndSent",h.NodeDrainBegin="nodeDrainBegin",h.NodeDrainEnd="nodeDrainEnd",h.zlibInflateError="zlibInflateError",h.zlibInflateData="zlibInflateData",h.zlibInflateInitialWrite="zlibInflateInitialWrite",h.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",h.zlibInflateWrite="zlibInflateWrite",h.zlibInflateFlushFired="zlibInflateFlushFired",h.zlibDeflateError="zlibDeflateError",h.zlibDeflateData="zlibDeflateData",h.zlibDeflateWrite="zlibDeflateWrite",h.zlibDeflateFlushFired="zlibDeflateFlushFired",h.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",h.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",h.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",h.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",h.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",h.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",h.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",h.ProtocolHeaderRead="protocolHeaderRead",h.ProtocolMessageRead="protocolMessageRead",h.ProtocolHeaderWrite="protocolHeaderWrite",h.ProtocolMessageWrite="protocolMessageWrite",h.ProtocolWrite="protocolWrite"})(O||(e.SocketDiagnosticsEventType=O={}));var p;(function(h){h.enableDiagnostics=!1,h.records=[];const c=new WeakMap;let u=0;function f(v,D){if(!c.has(v)){const k=String(++u);c.set(v,k)}return c.get(v)}function E(v,D,k,S){if(!h.enableDiagnostics)return;const F=f(v,D);if(S instanceof o.$ue||S instanceof Uint8Array||S instanceof ArrayBuffer||ArrayBuffer.isView(S)){const W=o.$ue.alloc(S.byteLength);W.set(S),h.records.push({timestamp:Date.now(),id:F,label:D,type:k,buff:W})}else h.records.push({timestamp:Date.now(),id:F,label:D,type:k,data:S})}h.traceSocketEvent=E})(p||(e.SocketDiagnostics=p={}));var $;(function(h){h[h.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",h[h.WebSocketCloseEvent=1]="WebSocketCloseEvent"})($||(e.SocketCloseEventType=$={}));let w=null;function A(){return w||(w=o.$ue.alloc(0)),w}class P{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(c){this.a.push(c),this.b+=c.byteLength}read(c){return this.c(c,!0)}peek(c){return this.c(c,!1)}c(c,u){if(c===0)return A();if(c>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===c){const D=this.a[0];return u&&(this.a.shift(),this.b-=c),D}if(this.a[0].byteLength>c){const D=this.a[0].slice(0,c);return u&&(this.a[0]=this.a[0].slice(c),this.b-=c),D}const f=o.$ue.alloc(c);let E=0,v=0;for(;c>0;){const D=this.a[v];if(D.byteLength>c){const k=D.slice(0,c);f.set(k,E),E+=c,u&&(this.a[v]=D.slice(c),this.b-=c),c-=c}else f.set(D,E),E+=D.byteLength,u?(this.a.shift(),this.b-=D.byteLength):v++,c-=D.byteLength}return f}}e.$5h=P;var b;(function(h){h[h.None=0]="None",h[h.Regular=1]="Regular",h[h.Control=2]="Control",h[h.Ack=3]="Ack",h[h.Disconnect=5]="Disconnect",h[h.ReplayRequest=6]="ReplayRequest",h[h.Pause=7]="Pause",h[h.Resume=8]="Resume",h[h.KeepAlive=9]="KeepAlive"})(b||(b={}));function C(h){switch(h){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var y;(function(h){h[h.HeaderLength=13]="HeaderLength",h[h.AcknowledgeTime=2e3]="AcknowledgeTime",h[h.TimeoutTime=2e4]="TimeoutTime",h[h.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",h[h.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",h[h.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(y||(e.ProtocolConstants=y={}));class a{constructor(c,u,f,E){this.type=c,this.id=u,this.ack=f,this.data=E,this.writtenTime=0}get size(){return this.data.byteLength}}class m extends I.$Uc{constructor(c){super(),this.f=this.B(new R.$7d),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=c,this.b=!1,this.c=new P,this.B(this.a.onData(u=>this.acceptChunk(u))),this.lastReadTime=Date.now()}acceptChunk(c){if(!(!c||c.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(c);this.c.byteLength>=this.g.readLen;){const u=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=u.readUInt32BE(9),this.g.messageType=u.readUInt8(0),this.g.id=u.readUInt32BE(1),this.g.ack=u.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:C(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const f=this.g.messageType,E=this.g.id,v=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",u),this.f.fire(new a(f,E,v,u)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class l{constructor(c){this.k=null,this.a=!1,this.b=!1,this.c=c,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(c){if(this.a)return;c.writtenTime=Date.now(),this.lastWriteTime=Date.now();const u=o.$ue.alloc(13);u.writeUInt8(c.type,0),u.writeUInt32BE(c.id,1),u.writeUInt32BE(c.ack,5),u.writeUInt32BE(c.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:C(c.type),id:c.id,ack:c.ack,messageSize:c.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",c.data),this.j(u,c.data)}g(c,u){const f=this.f===0;return this.d.push(c,u),this.f+=c.byteLength+u.byteLength,f}h(){const c=o.$ue.concat(this.d,this.f);return this.d.length=0,this.f=0,c}j(c,u){this.g(c,u)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const c=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:c.byteLength}),this.c.write(c)}}class i extends I.$Uc{constructor(c){super(),this.f=new R.$7d,this.onMessage=this.f.event,this.g=new R.$7d,this.onDidDispose=this.g.event,this.a=c,this.b=this.B(new l(this.a)),this.c=this.B(new m(this.a)),this.B(this.c.onMessage(u=>{u.type===1&&this.f.fire(u.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(c){this.b.write(new a(1,0,0,c))}}e.$6h=i;class n extends M.$Zh{static fromSocket(c,u){return new n(new i(c),u)}get onDidDispose(){return this.b.onDidDispose}constructor(c,u,f=null){super(c,u,f),this.b=c}dispose(){super.dispose();const c=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),c.end()}}e.$7h=n;class r{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new R.$7d({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(c){this.b?this.d.length>0?this.d.push(c):this.a.fire(c):this.d.push(c)}flushBuffer(){this.d=[]}}e.$8h=r;class s{constructor(c){this.data=c,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let c=0,u=this.a;for(;u;)u=u.next,c++;return c}peek(){return this.a?this.a.data:null}toArray(){const c=[];let u=0,f=this.a;for(;f;)c[u++]=f.data,f=f.next;return c}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(c){const u=new s(c);if(!this.a){this.a=u,this.b=u;return}this.b.next=u,this.b=u}}class g{static getInstance(){return g.b||(g.b=new g),g.b}constructor(){this.c=[];const c=Date.now();for(let u=0;u<g.a;u++)this.c[u]=c-1e3*u;setInterval(()=>{for(let u=g.a;u>=1;u--)this.c[u]=this.c[u-1];this.c[0]=Date.now()},1e3)}d(){const c=Date.now(),u=(1+g.a)*1e3;let f=0;for(let E=0;E<g.a;E++)c-this.c[E]<=u&&f++;return 1-f/g.a}hasHighLoad(){return this.d()>=.5}}g.a=10,g.b=null;class d{get unacknowledgedCount(){return this.c-this.d}constructor(c){this.u=new r,this.onControlMessage=this.u.event,this.v=new r,this.onMessage=this.v.event,this.w=new r,this.onDidDispose=this.w.event,this.x=new r,this.onSocketClose=this.x.event,this.y=new r,this.onSocketTimeout=this.y.event,this.s=c.loadEstimator??g.getInstance(),this.t=c.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new I.$Tc,this.o=c.socket,this.p=this.r.add(new l(this.o)),this.q=this.r.add(new m(this.o)),this.r.add(this.q.onMessage(u=>this.z(u))),this.r.add(this.o.onClose(u=>this.x.fire(u))),c.initialChunk&&this.q.acceptChunk(c.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const c=new a(5,0,0,A());this.p.write(c),this.p.flush()}sendPause(){const c=new a(7,0,0,A());this.p.write(c)}sendResume(){const c=new a(8,0,0,A());this.p.write(c)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(c,u){this.a=!0,this.r.dispose(),this.r=new I.$Tc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=c,this.p=this.r.add(new l(this.o)),this.q=this.r.add(new m(this.o)),this.r.add(this.q.onMessage(f=>this.z(f))),this.r.add(this.o.onClose(f=>this.x.fire(f))),this.q.acceptChunk(u)}endAcceptReconnection(){this.a=!1,this.h=this.g;const c=new a(3,0,this.h,A());this.p.write(c);const u=this.b.toArray();for(let f=0,E=u.length;f<E;f++)this.p.write(u[f]);this.B()}acceptDisconnect(){this.w.fire()}z(c){if(c.ack>this.d){this.d=c.ack;do{const u=this.b.peek();if(u&&u.id<=c.ack)this.b.pop();else break}while(!0)}switch(c.type){case 0:break;case 1:{if(c.id>this.g)if(c.id!==this.g+1){const u=Date.now();u-this.m>1e4&&(this.m=u,this.p.write(new a(6,0,0,A())))}else this.g=c.id,this.j=Date.now(),this.A(),this.v.fire(c.data);break}case 2:{this.u.fire(c.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const u=this.b.toArray();for(let f=0,E=u.length;f<E;f++)this.p.write(u[f]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(c){const u=++this.c;this.h=this.g;const f=new a(1,u,this.h,c);this.b.push(f),this.a||(this.p.write(f),this.B())}sendControl(c){const u=new a(2,0,0,c);this.p.write(u)}A(){if(this.g<=this.h||this.k)return;const c=Date.now()-this.j;if(c>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-c+5)}B(){if(this.c<=this.d||this.f||this.a)return;const c=this.b.peek(),u=Date.now()-c.writtenTime,f=Date.now()-this.q.lastReadTime,E=Date.now()-this.n;if(u>=2e4&&f>=2e4&&E>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:u,timeSinceLastReceivedSomeData:f});return}const v=Math.max(2e4-u,2e4-f,2e4-E,500);this.f=setTimeout(()=>{this.f=null,this.B()},v)}C(){if(this.g<=this.h)return;this.h=this.g;const c=new a(3,0,this.h,A());this.p.write(c)}D(){this.h=this.g;const c=new a(9,0,this.h,A());this.p.write(c)}}e.$9h=d}),define(Ee[177],Ce([1,0,51,8,21,22,173,13,4,3,24,104,99,80]),function(re,e,o,R,I,M,O,p,$,w,A,P,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lq=e.$Kq=void 0;class y extends C.$Wh{constructor(l){super({send:i=>{try{process.send?.(i.buffer.toString("base64"))}catch{}},onMessage:$.Event.fromNodeEventEmitter(process,"message",i=>I.$ue.wrap(Buffer.from(i,"base64")))},l),process.once("disconnect",()=>this.dispose())}}e.$Kq=y;class a{constructor(l,i){this.i=l,this.j=i,this.c=new Set,this.g=new Map,this.h=new $.$7d,this.onDidProcessExit=this.h.event;const n=i&&i.timeout?i.timeout:6e4;this.b=new R.$fh(n),this.d=null,this.f=null}getChannel(l){const i=this;return{call(n,r,s){return i.k(l,n,r,s)},listen(n,r){return i.l(l,n,r)}}}k(l,i,n,r=M.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(r.isCancellationRequested)return Promise.reject(p.$6());this.b.cancel();const s=this.n(l),t=(0,R.$8g)(h=>s.call(i,n,h)),g=r.onCancellationRequested(()=>t.cancel()),d=(0,w.$Sc)(()=>t.cancel());return this.c.add(d),t.finally(()=>{g.dispose(),this.c.delete(d),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(l,i,n){if(!this.b)return $.Event.None;this.b.cancel();let r;const s=new $.$7d({onWillAddFirstListener:()=>{r=this.n(l).listen(i,n)(s.fire,s),this.c.add(r)},onDidRemoveLastListener:()=>{this.c.delete(r),r.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return s.event}get m(){if(!this.f){const l=this.j&&this.j.args?this.j.args:[],i=Object.create(null);i.env={...(0,A.$Pn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(i.env={...i.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(i.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(i.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(i.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),i.execArgv===void 0&&(i.execArgv=process.execArgv.filter(u=>!/^--inspect(-brk)?=/.test(u)).filter(u=>!u.startsWith("--vscode-"))),(0,b.$am)(i.env),this.d=(0,o.fork)(this.i,l,i);const n=new $.$7d,s=$.Event.fromNodeEventEmitter(this.d,"message",u=>u)(u=>{if((0,O.$Gq)(u)){(0,O.log)(u,`IPC Library: ${this.j.serverName}`);return}n.fire(I.$ue.wrap(Buffer.from(u,"base64")))}),t=this.j.useQueue?(0,P.$cm)(this.d):this.d,g=u=>this.d&&this.d.connected&&t.send(u.buffer.toString("base64")),d=n.event,h={send:g,onMessage:d};this.f=new C.$Xh(h);const c=()=>this.o();process.once("exit",c),this.d.on("error",u=>console.warn('IPC "'+this.j.serverName+'" errored with '+u)),this.d.on("exit",(u,f)=>{process.removeListener("exit",c),s.dispose(),this.c.forEach(E=>(0,w.$Pc)(E)),this.c.clear(),u!==0&&f!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+u+" and signal "+f),this.b?.cancel(),this.o(),this.h.fire({code:u,signal:f})})}return this.f}n(l){let i=this.g.get(l);return i||(i=this.m.getChannel(l),this.g.set(l,i)),i}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Lq=a}),define(Ee[178],Ce([1,0,8,4,3,57,18]),function(re,e,o,R,I,M,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kp=e.$Jp=e.StorageState=e.StorageHint=void 0,e.$Ip=$;var p;(function(b){b[b.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",b[b.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(p||(e.StorageHint=p={}));function $(b){const C=b;return C?.changed instanceof Map||C?.deleted instanceof Set}var w;(function(b){b[b.None=0]="None",b[b.Initialized=1]="Initialized",b[b.Closed=2]="Closed"})(w||(e.StorageState=w={}));class A extends I.$Uc{constructor(C,y=Object.create(null)){super(),this.r=C,this.s=y,this.b=this.B(new R.$0d),this.onDidChangeStorage=this.b.event,this.c=w.None,this.f=new Map,this.g=this.B(new o.$gh(A.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(C=>this.u(C)))}u(C){this.b.pause();try{C.changed?.forEach((y,a)=>this.w(a,y)),C.deleted?.forEach(y=>this.w(y,void 0))}finally{this.b.resume()}}w(C,y){if(this.c===w.Closed)return;let a=!1;(0,O.$5f)(y)?a=this.f.delete(C):this.f.get(C)!==y&&(this.f.set(C,y),a=!0),a&&this.b.fire({key:C,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===w.None&&(this.c=w.Initialized,this.s.hint!==p.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(C,y){const a=this.f.get(C);return(0,O.$5f)(a)?y:a}getBoolean(C,y){const a=this.get(C);return(0,O.$5f)(a)?y:a==="true"}getNumber(C,y){const a=this.get(C);return(0,O.$5f)(a)?y:parseInt(a,10)}getObject(C,y){const a=this.get(C);return(0,O.$5f)(a)?y:(0,M.$Qh)(a)}async set(C,y,a=!1){if(this.c===w.Closed)return;if((0,O.$5f)(y))return this.delete(C,a);const m=(0,O.$Xf)(y)||Array.isArray(y)?(0,M.$Ph)(y):String(y);if(this.f.get(C)!==m)return this.f.set(C,m),this.j.set(C,m),this.h.delete(C),this.b.fire({key:C,external:a}),this.D()}async delete(C,y=!1){if(!(this.c===w.Closed||!this.f.delete(C)))return this.h.has(C)||this.h.add(C),this.j.delete(C),this.b.fire({key:C,external:y}),this.D()}async optimize(){if(this.c!==w.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=w.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const C={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(C).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(C){if(this.z)return this.D(C)}async D(C){return this.s.hint===p.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),C)}async whenFlushed(){if(this.z)return new Promise(C=>this.n.push(C))}isInMemory(){return this.s.hint===p.STORAGE_IN_MEMORY}}e.$Jp=A,A.a=100;class P{constructor(){this.onDidChangeItemsExternal=R.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(C){C.insert?.forEach((y,a)=>this.a.set(a,y)),C.delete?.forEach(y=>this.a.delete(y))}async optimize(){}async close(){}}e.$Kp=P}),define(Ee[132],Ce([1,0,130]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bt=e.$At=void 0;class R{constructor(p){const $=(0,o.$Se)(p);this.c=$,this.a=R.d($),this.b=new Map}static d(p){const $=new Uint8Array(256);return $.fill(p),$}set(p,$){const w=(0,o.$Se)($);p>=0&&p<256?this.a[p]=w:this.b.set(p,w)}get(p){return p>=0&&p<256?this.a[p]:this.b.get(p)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$At=R;var I;(function(O){O[O.False=0]="False",O[O.True=1]="True"})(I||(I={}));class M{constructor(){this.a=new R(0)}add(p){this.a.set(p,1)}has(p){return this.a.get(p)===1}clear(){return this.a.clear()}}e.$Bt=M}),define(Ee[179],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$Pt=R;var o;(function(I){I[I.Unknown=0]="Unknown",I[I.Invalid=3]="Invalid",I[I.LF=1]="LF",I[I.CRLF=2]="CRLF"})(o||(e.StringEOL=o={}));function R(I){let M=0,O=0,p=0,$=0;for(let w=0,A=I.length;w<A;w++){const P=I.charCodeAt(w);P===13?(M===0&&(O=w),M++,w+1<A&&I.charCodeAt(w+1)===10?($|=2,w++):$|=3,p=w+1):P===10&&($|=1,M===0&&(O=w),M++,p=w+1)}return M===0&&(O=I.length),[M,O,I.length-p,$]}}),define(Ee[52],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ct=void 0;class o{constructor(I,M){this.lineNumber=I,this.column=M}with(I=this.lineNumber,M=this.column){return I===this.lineNumber&&M===this.column?this:new o(I,M)}delta(I=0,M=0){return this.with(this.lineNumber+I,this.column+M)}equals(I){return o.equals(this,I)}static equals(I,M){return!I&&!M?!0:!!I&&!!M&&I.lineNumber===M.lineNumber&&I.column===M.column}isBefore(I){return o.isBefore(this,I)}static isBefore(I,M){return I.lineNumber<M.lineNumber?!0:M.lineNumber<I.lineNumber?!1:I.column<M.column}isBeforeOrEqual(I){return o.isBeforeOrEqual(this,I)}static isBeforeOrEqual(I,M){return I.lineNumber<M.lineNumber?!0:M.lineNumber<I.lineNumber?!1:I.column<=M.column}static compare(I,M){const O=I.lineNumber|0,p=M.lineNumber|0;if(O===p){const $=I.column|0,w=M.column|0;return $-w}return O-p}clone(){return new o(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(I){return new o(I.lineNumber,I.column)}static isIPosition(I){return I&&typeof I.lineNumber=="number"&&typeof I.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$ct=o}),define(Ee[29],Ce([1,0,52]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dt=void 0;class R{constructor(M,O,p,$){M>p||M===p&&O>$?(this.startLineNumber=p,this.startColumn=$,this.endLineNumber=M,this.endColumn=O):(this.startLineNumber=M,this.startColumn=O,this.endLineNumber=p,this.endColumn=$)}isEmpty(){return R.isEmpty(this)}static isEmpty(M){return M.startLineNumber===M.endLineNumber&&M.startColumn===M.endColumn}containsPosition(M){return R.containsPosition(this,M)}static containsPosition(M,O){return!(O.lineNumber<M.startLineNumber||O.lineNumber>M.endLineNumber||O.lineNumber===M.startLineNumber&&O.column<M.startColumn||O.lineNumber===M.endLineNumber&&O.column>M.endColumn)}static strictContainsPosition(M,O){return!(O.lineNumber<M.startLineNumber||O.lineNumber>M.endLineNumber||O.lineNumber===M.startLineNumber&&O.column<=M.startColumn||O.lineNumber===M.endLineNumber&&O.column>=M.endColumn)}containsRange(M){return R.containsRange(this,M)}static containsRange(M,O){return!(O.startLineNumber<M.startLineNumber||O.endLineNumber<M.startLineNumber||O.startLineNumber>M.endLineNumber||O.endLineNumber>M.endLineNumber||O.startLineNumber===M.startLineNumber&&O.startColumn<M.startColumn||O.endLineNumber===M.endLineNumber&&O.endColumn>M.endColumn)}strictContainsRange(M){return R.strictContainsRange(this,M)}static strictContainsRange(M,O){return!(O.startLineNumber<M.startLineNumber||O.endLineNumber<M.startLineNumber||O.startLineNumber>M.endLineNumber||O.endLineNumber>M.endLineNumber||O.startLineNumber===M.startLineNumber&&O.startColumn<=M.startColumn||O.endLineNumber===M.endLineNumber&&O.endColumn>=M.endColumn)}plusRange(M){return R.plusRange(this,M)}static plusRange(M,O){let p,$,w,A;return O.startLineNumber<M.startLineNumber?(p=O.startLineNumber,$=O.startColumn):O.startLineNumber===M.startLineNumber?(p=O.startLineNumber,$=Math.min(O.startColumn,M.startColumn)):(p=M.startLineNumber,$=M.startColumn),O.endLineNumber>M.endLineNumber?(w=O.endLineNumber,A=O.endColumn):O.endLineNumber===M.endLineNumber?(w=O.endLineNumber,A=Math.max(O.endColumn,M.endColumn)):(w=M.endLineNumber,A=M.endColumn),new R(p,$,w,A)}intersectRanges(M){return R.intersectRanges(this,M)}static intersectRanges(M,O){let p=M.startLineNumber,$=M.startColumn,w=M.endLineNumber,A=M.endColumn;const P=O.startLineNumber,b=O.startColumn,C=O.endLineNumber,y=O.endColumn;return p<P?(p=P,$=b):p===P&&($=Math.max($,b)),w>C?(w=C,A=y):w===C&&(A=Math.min(A,y)),p>w||p===w&&$>A?null:new R(p,$,w,A)}equalsRange(M){return R.equalsRange(this,M)}static equalsRange(M,O){return!M&&!O?!0:!!M&&!!O&&M.startLineNumber===O.startLineNumber&&M.startColumn===O.startColumn&&M.endLineNumber===O.endLineNumber&&M.endColumn===O.endColumn}getEndPosition(){return R.getEndPosition(this)}static getEndPosition(M){return new o.$ct(M.endLineNumber,M.endColumn)}getStartPosition(){return R.getStartPosition(this)}static getStartPosition(M){return new o.$ct(M.startLineNumber,M.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(M,O){return new R(this.startLineNumber,this.startColumn,M,O)}setStartPosition(M,O){return new R(M,O,this.endLineNumber,this.endColumn)}collapseToStart(){return R.collapseToStart(this)}static collapseToStart(M){return new R(M.startLineNumber,M.startColumn,M.startLineNumber,M.startColumn)}collapseToEnd(){return R.collapseToEnd(this)}static collapseToEnd(M){return new R(M.endLineNumber,M.endColumn,M.endLineNumber,M.endColumn)}delta(M){return new R(this.startLineNumber+M,this.startColumn,this.endLineNumber+M,this.endColumn)}static fromPositions(M,O=M){return new R(M.lineNumber,M.column,O.lineNumber,O.column)}static lift(M){return M?new R(M.startLineNumber,M.startColumn,M.endLineNumber,M.endColumn):null}static isIRange(M){return M&&typeof M.startLineNumber=="number"&&typeof M.startColumn=="number"&&typeof M.endLineNumber=="number"&&typeof M.endColumn=="number"}static areIntersectingOrTouching(M,O){return!(M.endLineNumber<O.startLineNumber||M.endLineNumber===O.startLineNumber&&M.endColumn<O.startColumn||O.endLineNumber<M.startLineNumber||O.endLineNumber===M.startLineNumber&&O.endColumn<M.startColumn)}static areIntersecting(M,O){return!(M.endLineNumber<O.startLineNumber||M.endLineNumber===O.startLineNumber&&M.endColumn<=O.startColumn||O.endLineNumber<M.startLineNumber||O.endLineNumber===M.startLineNumber&&O.endColumn<=M.startColumn)}static compareRangesUsingStarts(M,O){if(M&&O){const w=M.startLineNumber|0,A=O.startLineNumber|0;if(w===A){const P=M.startColumn|0,b=O.startColumn|0;if(P===b){const C=M.endLineNumber|0,y=O.endLineNumber|0;if(C===y){const a=M.endColumn|0,m=O.endColumn|0;return a-m}return C-y}return P-b}return w-A}return(M?1:0)-(O?1:0)}static compareRangesUsingEnds(M,O){return M.endLineNumber===O.endLineNumber?M.endColumn===O.endColumn?M.startLineNumber===O.startLineNumber?M.startColumn-O.startColumn:M.startLineNumber-O.startLineNumber:M.endColumn-O.endColumn:M.endLineNumber-O.endLineNumber}static spansMultipleLines(M){return M.endLineNumber>M.startLineNumber}toJSON(){return this}}e.$dt=R}),define(Ee[180],Ce([1,0,29]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$et=void 0;class R{static insert(M,O){return{range:new o.$dt(M.lineNumber,M.column,M.lineNumber,M.column),text:O,forceMoveMarkers:!0}}static delete(M){return{range:M,text:null}}static replace(M,O){return{range:M,text:O}}static replaceMove(M,O){return{range:M,text:O,forceMoveMarkers:!0}}}e.$et=R}),define(Ee[181],Ce([1,0,52,29]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ft=e.SelectionDirection=void 0;var I;(function(O){O[O.LTR=0]="LTR",O[O.RTL=1]="RTL"})(I||(e.SelectionDirection=I={}));class M extends R.$dt{constructor(p,$,w,A){super(p,$,w,A),this.selectionStartLineNumber=p,this.selectionStartColumn=$,this.positionLineNumber=w,this.positionColumn=A}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(p){return M.selectionsEqual(this,p)}static selectionsEqual(p,$){return p.selectionStartLineNumber===$.selectionStartLineNumber&&p.selectionStartColumn===$.selectionStartColumn&&p.positionLineNumber===$.positionLineNumber&&p.positionColumn===$.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(p,$){return this.getDirection()===0?new M(this.startLineNumber,this.startColumn,p,$):new M(p,$,this.startLineNumber,this.startColumn)}getPosition(){return new o.$ct(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new o.$ct(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(p,$){return this.getDirection()===0?new M(p,$,this.endLineNumber,this.endColumn):new M(this.endLineNumber,this.endColumn,p,$)}static fromPositions(p,$=p){return new M(p.lineNumber,p.column,$.lineNumber,$.column)}static fromRange(p,$){return $===0?new M(p.startLineNumber,p.startColumn,p.endLineNumber,p.endColumn):new M(p.endLineNumber,p.endColumn,p.startLineNumber,p.startColumn)}static liftSelection(p){return new M(p.selectionStartLineNumber,p.selectionStartColumn,p.positionLineNumber,p.positionColumn)}static selectionsArrEqual(p,$){if(p&&!$||!p&&$)return!1;if(!p&&!$)return!0;if(p.length!==$.length)return!1;for(let w=0,A=p.length;w<A;w++)if(!this.selectionsEqual(p[w],$[w]))return!1;return!0}static isISelection(p){return p&&typeof p.selectionStartLineNumber=="number"&&typeof p.selectionStartColumn=="number"&&typeof p.positionLineNumber=="number"&&typeof p.positionColumn=="number"}static createWithDirection(p,$,w,A,P){return P===0?new M(p,$,w,A):new M(w,A,p,$)}}e.$ft=M}),define(Ee[182],Ce([1,0,14,11,21]),function(re,e,o,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xt=void 0,e.$vt=A,e.$wt=P;let M;function O(){return M||(M=new TextDecoder("UTF-16LE")),M}let p;function $(){return p||(p=new TextDecoder("UTF-16BE")),p}let w;function A(){return w||(w=R.$x()?O():$()),w}function P(y,a,m){const l=new Uint16Array(y.buffer,a,m);return m>0&&(l[0]===65279||l[0]===65534)?b(y,a,m):O().decode(l)}function b(y,a,m){const l=[];let i=0;for(let n=0;n<m;n++){const r=I.$we(y,a);a+=2,l[i++]=String.fromCharCode(r)}return l.join("")}class C{constructor(a){this.a=a|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const a=new Uint16Array(this.b.buffer,0,this.d);return A().decode(a)}f(){const a=this.e();this.d=0,this.c===null?this.c=[a]:this.c[this.c.length]=a}appendCharCode(a){const m=this.a-this.d;m<=1&&(m===0||o.$pf(a))&&this.f(),this.b[this.d++]=a}appendASCIICharCode(a){this.d===this.a&&this.f(),this.b[this.d++]=a}appendString(a){const m=a.length;if(this.d+m>=this.a){this.f(),this.c[this.c.length]=a;return}for(let l=0;l<m;l++)this.b[this.d++]=a.charCodeAt(l)}}e.$xt=C}),define(Ee[183],Ce([1,0,21,182]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yt=void 0,e.$zt=O;function I($){return $.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class M{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(w,A,P,b){this.oldPosition=w,this.oldText=A,this.newPosition=P,this.newText=b}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${I(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${I(this.oldText)}")`:`(replace@${this.oldPosition} "${I(this.oldText)}" with "${I(this.newText)}")`}static a(w){return 4+2*w.length}static c(w,A,P){const b=A.length;o.$ze(w,b,P),P+=4;for(let C=0;C<b;C++)o.$xe(w,A.charCodeAt(C),P),P+=2;return P}static d(w,A){const P=o.$ye(w,A);return A+=4,(0,R.$wt)(w,A,P)}writeSize(){return 8+M.a(this.oldText)+M.a(this.newText)}write(w,A){return o.$ze(w,this.oldPosition,A),A+=4,o.$ze(w,this.newPosition,A),A+=4,A=M.c(w,this.oldText,A),A=M.c(w,this.newText,A),A}static read(w,A,P){const b=o.$ye(w,A);A+=4;const C=o.$ye(w,A);A+=4;const y=M.d(w,A);A+=M.a(y);const a=M.d(w,A);return A+=M.a(a),P.push(new M(b,y,C,a)),A}}e.$yt=M;function O($,w){return $===null||$.length===0?w:new p($,w).compress()}class p{constructor(w,A){this.a=w,this.c=A,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let w=0,A=0,P=this.n(w),b=this.l(A);for(;w<this.f||A<this.h;){if(P===null){this.k(b),b=this.l(++A);continue}if(b===null){this.m(P),P=this.n(++w);continue}if(b.oldEnd<=P.newPosition){this.k(b),b=this.l(++A);continue}if(P.newEnd<=b.oldPosition){this.m(P),P=this.n(++w);continue}if(b.oldPosition<P.newPosition){const[l,i]=p.r(b,P.newPosition-b.oldPosition);this.k(l),b=i;continue}if(P.newPosition<b.oldPosition){const[l,i]=p.q(P,b.oldPosition-P.newPosition);this.m(l),P=i;continue}let a,m;if(b.oldEnd===P.newEnd)a=P,m=b,P=this.n(++w),b=this.l(++A);else if(b.oldEnd<P.newEnd){const[l,i]=p.q(P,b.oldLength);a=l,m=b,P=i,b=this.l(++A)}else{const[l,i]=p.r(b,P.newLength);a=P,m=l,P=this.n(++w),b=i}this.d[this.e++]=new M(a.oldPosition,a.oldText,m.newPosition,m.newText),this.g+=a.newLength-a.oldLength,this.j+=m.newLength-m.oldLength}const C=p.s(this.d);return p.t(C)}k(w){this.d[this.e++]=p.o(this.g,w),this.j+=w.newLength-w.oldLength}l(w){return w<this.h?this.c[w]:null}m(w){this.d[this.e++]=p.p(this.j,w),this.g+=w.newLength-w.oldLength}n(w){return w<this.f?this.a[w]:null}static o(w,A){return new M(A.oldPosition-w,A.oldText,A.newPosition,A.newText)}static p(w,A){return new M(A.oldPosition,A.oldText,A.newPosition+w,A.newText)}static q(w,A){const P=w.newText.substr(0,A),b=w.newText.substr(A);return[new M(w.oldPosition,w.oldText,w.newPosition,P),new M(w.oldEnd,"",w.newPosition+A,b)]}static r(w,A){const P=w.oldText.substr(0,A),b=w.oldText.substr(A);return[new M(w.oldPosition,P,w.newPosition,w.newText),new M(w.oldPosition+A,b,w.newEnd,"")]}static s(w){if(w.length===0)return w;const A=[];let P=0,b=w[0];for(let C=1;C<w.length;C++){const y=w[C];b.oldEnd===y.oldPosition?b=new M(b.oldPosition,b.oldText+y.oldText,b.newPosition,b.newText+y.newText):(A[P++]=b,b=y)}return A[P++]=b,A}static t(w){if(w.length===0)return w;const A=[];let P=0;for(let b=0;b<w.length;b++){const C=w[b];C.oldText!==C.newText&&(A[P++]=C)}return A}}}),define(Ee[184],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ns=void 0,e.$Ns={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ee[185],Ce([1,0,27,132]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ct=e.WordCharacterClass=void 0,e.$Dt=p;var I;(function($){$[$.Regular=0]="Regular",$[$.Whitespace=1]="Whitespace",$[$.WordSeparator=2]="WordSeparator"})(I||(e.WordCharacterClass=I={}));class M extends R.$At{constructor(w,A){super(0),this.e=null,this.f=null,this.g=[],this.intlSegmenterLocales=A,this.intlSegmenterLocales.length>0?this.e=new Intl.Segmenter(this.intlSegmenterLocales,{granularity:"word"}):this.e=null;for(let P=0,b=w.length;P<b;P++)this.set(w.charCodeAt(P),2);this.set(32,1),this.set(9,1)}findPrevIntlWordBeforeOrAtOffset(w,A){let P=null;for(const b of this.h(w)){if(b.index>A)break;P=b}return P}findNextIntlWordAtOrAfterOffset(w,A){for(const P of this.h(w))if(!(P.index<A))return P;return null}h(w){return this.e?this.f===w?this.g:(this.f=w,this.g=this.j(this.e.segment(w)),this.g):[]}j(w){const A=[];for(const P of w)this.k(P)&&A.push(P);return A}k(w){return!!w.isWordLike}}e.$Ct=M;const O=new o.$Ec(10);function p($,w){const A=`${$}/${w.join(",")}`;let P=O.get(A);return P||(P=new M($,w),O.set(A,P)),P}}),define(Ee[133],Ce([1,0,39,3,75]),function(re,e,o,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ps=e.$Os=void 0,e.$Qs=O,e.$Rs=$,e.$Ss=w,e.$Os="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function M(P=""){let b="(-?\\d*\\.\\d\\w*)|([^";for(const C of e.$Os)P.indexOf(C)>=0||(b+="\\"+C);return b+="\\s]+)",new RegExp(b,"g")}e.$Ps=M();function O(P){let b=e.$Ps;if(P&&P instanceof RegExp)if(P.global)b=P;else{let C="g";P.ignoreCase&&(C+="i"),P.multiline&&(C+="m"),P.unicode&&(C+="u"),b=new RegExp(P.source,C)}return b.lastIndex=0,b}const p=new I.$5c;p.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function $(P){const b=p.unshift(P);return(0,R.$Sc)(b)}function w(P,b,C,y,a){if(b=O(b),a||(a=o.Iterable.first(p)),C.length>a.maxLen){let r=P-a.maxLen/2;return r<0?r=0:y+=r,C=C.substring(r,P+a.maxLen/2),w(P,b,C,y,a)}const m=Date.now(),l=P-1-y;let i=-1,n=null;for(let r=1;!(Date.now()-m>=a.timeBudget);r++){const s=l-a.windowSize*r;b.lastIndex=Math.max(0,s);const t=A(b,C,l,i);if(!t&&n||(n=t,s<=0))break;i=s}if(n){const r={word:n[0],startColumn:y+1+n.index,endColumn:y+1+n.index+n[0].length};return b.lastIndex=0,r}return null}function A(P,b,C,y){let a;for(;a=P.exec(b);){const m=a.index||0;if(m<=C&&P.lastIndex>=C)return a;if(y>0&&m>y)return null}return null}}),define(Ee[186],Ce([1,0,35,17]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wt=I,e.$Xt=M;function I(O,p,$,w,A,P){if(Array.isArray(O)){let b=0;for(const C of O){const y=I(C,p,$,w,A,P);if(y===10)return y;y>b&&(b=y)}return b}else{if(typeof O=="string")return w?O==="*"?5:O===$?10:0:0;if(O){const{language:b,pattern:C,scheme:y,hasAccessToAllModels:a,notebookType:m}=O;if(!w&&!a)return 0;m&&A&&(p=A);let l=0;if(y)if(y===p.scheme)l=10;else if(y==="*")l=5;else return 0;if(b)if(b===$)l=10;else if(b==="*")l=Math.max(l,5);else return 0;if(m)if(m===P)l=10;else if(m==="*"&&P!==void 0)l=Math.max(l,5);else return 0;if(C){let i;if(typeof C=="string"?i=C:i={...C,base:(0,R.$ic)(C.base)},i===p.fsPath||(0,o.$bk)(i,p.fsPath))l=10;else return 0}return l}else return 0}}function M(O){return typeof O=="string"?!1:Array.isArray(O)?O.some(M):!!O.notebookType}}),define(Ee[187],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$du=e.$cu=e.IndentAction=void 0;var o;(function(O){O[O.None=0]="None",O[O.Indent=1]="Indent",O[O.IndentOutdent=2]="IndentOutdent",O[O.Outdent=3]="Outdent"})(o||(e.IndentAction=o={}));class R{constructor(p){if(this.e=null,this.f=!1,this.open=p.open,this.close=p.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(p.notIn))for(let $=0,w=p.notIn.length;$<w;$++)switch(p.notIn[$]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(p){switch(p){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(p,$){if(p.getTokenCount()===0)return!0;const w=p.findTokenIndexAtOffset($-2),A=p.getStandardTokenType(w);return this.isOK(A)}g(p,$){for(let w=p;w<=$;w++){const A=String.fromCharCode(w);if(!this.open.includes(A)&&!this.close.includes(A))return A}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$cu=R;class I{constructor(p){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const $ of p)M(this.autoClosingPairsOpenByStart,$.open.charAt(0),$),M(this.autoClosingPairsOpenByEnd,$.open.charAt($.open.length-1),$),M(this.autoClosingPairsCloseByStart,$.close.charAt(0),$),M(this.autoClosingPairsCloseByEnd,$.close.charAt($.close.length-1),$),$.close.length===1&&$.open.length===1&&M(this.autoClosingPairsCloseSingleChar,$.close,$)}}e.$du=I;function M(O,p,$){O.has(p)?O.get(p).push($):O.set(p,[$])}}),define(Ee[188],Ce([1,0,132]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F2=e.$E2=e.State=void 0,e.$G2=b;var R;(function(C){C[C.Invalid=0]="Invalid",C[C.Start=1]="Start",C[C.H=2]="H",C[C.HT=3]="HT",C[C.HTT=4]="HTT",C[C.HTTP=5]="HTTP",C[C.F=6]="F",C[C.FI=7]="FI",C[C.FIL=8]="FIL",C[C.BeforeColon=9]="BeforeColon",C[C.AfterColon=10]="AfterColon",C[C.AlmostThere=11]="AlmostThere",C[C.End=12]="End",C[C.Accept=13]="Accept",C[C.LastKnownState=14]="LastKnownState"})(R||(e.State=R={}));class I{constructor(y,a,m){const l=new Uint8Array(y*a);for(let i=0,n=y*a;i<n;i++)l[i]=m;this.a=l,this.rows=y,this.cols=a}get(y,a){return this.a[y*this.cols+a]}set(y,a,m){this.a[y*this.cols+a]=m}}class M{constructor(y){let a=0,m=0;for(let i=0,n=y.length;i<n;i++){const[r,s,t]=y[i];s>a&&(a=s),r>m&&(m=r),t>m&&(m=t)}a++,m++;const l=new I(m,a,0);for(let i=0,n=y.length;i<n;i++){const[r,s,t]=y[i];l.set(r,s,t)}this.a=l,this.b=a}nextState(y,a){return a<0||a>=this.b?0:this.a.get(y,a)}}e.$E2=M;let O=null;function p(){return O===null&&(O=new M([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),O}var $;(function(C){C[C.None=0]="None",C[C.ForceTermination=1]="ForceTermination",C[C.CannotEndIn=2]="CannotEndIn"})($||($={}));let w=null;function A(){if(w===null){w=new o.$At(0);const C=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let a=0;a<C.length;a++)w.set(C.charCodeAt(a),1);const y=".,;:";for(let a=0;a<y.length;a++)w.set(y.charCodeAt(a),2)}return w}class P{static a(y,a,m,l,i){let n=i-1;do{const r=a.charCodeAt(n);if(y.get(r)!==2)break;n--}while(n>l);if(l>0){const r=a.charCodeAt(l-1),s=a.charCodeAt(n);(r===40&&s===41||r===91&&s===93||r===123&&s===125)&&n--}return{range:{startLineNumber:m,startColumn:l+1,endLineNumber:m,endColumn:n+2},url:a.substring(l,n+1)}}static computeLinks(y,a=p()){const m=A(),l=[];for(let i=1,n=y.getLineCount();i<=n;i++){const r=y.getLineContent(i),s=r.length;let t=0,g=0,d=0,h=1,c=!1,u=!1,f=!1,E=!1;for(;t<s;){let v=!1;const D=r.charCodeAt(t);if(h===13){let k;switch(D){case 40:c=!0,k=0;break;case 41:k=c?0:1;break;case 91:f=!0,u=!0,k=0;break;case 93:f=!1,k=u?0:1;break;case 123:E=!0,k=0;break;case 125:k=E?0:1;break;case 39:case 34:case 96:d===D?k=1:d===39||d===34||d===96?k=0:k=1;break;case 42:k=d===42?1:0;break;case 124:k=d===124?1:0;break;case 32:k=f?0:1;break;default:k=m.get(D)}k===1&&(l.push(P.a(m,r,i,g,t)),v=!0)}else if(h===12){let k;D===91?(u=!0,k=0):k=m.get(D),k===1?v=!0:h=13}else h=a.nextState(h,D),h===0&&(v=!0);v&&(h=1,c=!1,u=!1,E=!1,g=t+1,d=D),t++}h===13&&l.push(P.a(m,r,i,g,s))}return l}}e.$F2=P;function b(C){return!C||typeof C.getLineCount!="function"||typeof C.getLineContent!="function"?[]:P.computeLinks(C)}}),define(Ee[82],Ce([1,0,24]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bv=e.$Av=e.$zv=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.$xv=e.$wv=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapSectionHeaderStyle=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0,e.$yv=y,e.$Cv=r;var R;(function(s){s[s.Left=1]="Left",s[s.Center=2]="Center",s[s.Right=4]="Right",s[s.Full=7]="Full"})(R||(e.OverviewRulerLane=R={}));var I;(function(s){s[s.Left=1]="Left",s[s.Center=2]="Center",s[s.Right=3]="Right"})(I||(e.GlyphMarginLane=I={}));var M;(function(s){s[s.Inline=1]="Inline",s[s.Gutter=2]="Gutter"})(M||(e.MinimapPosition=M={}));var O;(function(s){s[s.Normal=1]="Normal",s[s.Underlined=2]="Underlined"})(O||(e.MinimapSectionHeaderStyle=O={}));var p;(function(s){s[s.Both=0]="Both",s[s.Right=1]="Right",s[s.Left=2]="Left",s[s.None=3]="None"})(p||(e.InjectedTextCursorStops=p={}));var $;(function(s){s[s.TextDefined=0]="TextDefined",s[s.LF=1]="LF",s[s.CRLF=2]="CRLF"})($||(e.EndOfLinePreference=$={}));var w;(function(s){s[s.LF=1]="LF",s[s.CRLF=2]="CRLF"})(w||(e.DefaultEndOfLine=w={}));var A;(function(s){s[s.LF=0]="LF",s[s.CRLF=1]="CRLF"})(A||(e.EndOfLineSequence=A={}));class P{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(t){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,t.tabSize|0),t.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,t.indentSize|0),this.a=!1),this.insertSpaces=!!t.insertSpaces,this.defaultEOL=t.defaultEOL|0,this.trimAutoWhitespace=!!t.trimAutoWhitespace,this.bracketPairColorizationOptions=t.bracketPairColorizationOptions}equals(t){return this.tabSize===t.tabSize&&this.a===t.a&&this.indentSize===t.indentSize&&this.insertSpaces===t.insertSpaces&&this.defaultEOL===t.defaultEOL&&this.trimAutoWhitespace===t.trimAutoWhitespace&&(0,o.$Tn)(this.bracketPairColorizationOptions,t.bracketPairColorizationOptions)}createChangeEvent(t){return{tabSize:this.tabSize!==t.tabSize,indentSize:this.indentSize!==t.indentSize,insertSpaces:this.insertSpaces!==t.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==t.trimAutoWhitespace}}}e.$wv=P;class b{constructor(t,g){this._findMatchBrand=void 0,this.range=t,this.matches=g}}e.$xv=b;var C;(function(s){s[s.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",s[s.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",s[s.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",s[s.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(C||(e.TrackedRangeStickiness=C={}));function y(s){return s&&typeof s.read=="function"}var a;(function(s){s[s.Left=0]="Left",s[s.Right=1]="Right",s[s.None=2]="None",s[s.LeftOfInjectedText=3]="LeftOfInjectedText",s[s.RightOfInjectedText=4]="RightOfInjectedText"})(a||(e.PositionAffinity=a={}));var m;(function(s){s[s.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(m||(e.ModelConstants=m={}));class l{constructor(t,g,d,h,c,u){this.identifier=t,this.range=g,this.text=d,this.forceMoveMarkers=h,this.isAutoWhitespaceEdit=c,this._isTracked=u}}e.$zv=l;class i{constructor(t,g,d){this.regex=t,this.wordSeparators=g,this.simpleSearch=d}}e.$Av=i;class n{constructor(t,g,d){this.reverseEdits=t,this.changes=g,this.trimAutoWhitespaceLineNumbers=d}}e.$Bv=n;function r(s){return!s.isTooLargeForSyncing()&&!s.isForSimpleWidget}}),define(Ee[189],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kC=e.NodeColor=e.$jC=void 0,e.$lC=I,e.$mC=M,e.$nC=w,e.$oC=A,e.$pC=P,e.$qC=b,e.$rC=C,e.$sC=y;class o{constructor(m,l){this.piece=m,this.color=l,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$kC)return I(this.right);let m=this;for(;m.parent!==e.$kC&&m.parent.left!==m;)m=m.parent;return m.parent===e.$kC?e.$kC:m.parent}prev(){if(this.left!==e.$kC)return M(this.left);let m=this;for(;m.parent!==e.$kC&&m.parent.right!==m;)m=m.parent;return m.parent===e.$kC?e.$kC:m.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$jC=o;var R;(function(a){a[a.Black=0]="Black",a[a.Red=1]="Red"})(R||(e.NodeColor=R={})),e.$kC=new o(null,0),e.$kC.parent=e.$kC,e.$kC.left=e.$kC,e.$kC.right=e.$kC,e.$kC.color=0;function I(a){for(;a.left!==e.$kC;)a=a.left;return a}function M(a){for(;a.right!==e.$kC;)a=a.right;return a}function O(a){return a===e.$kC?0:a.size_left+a.piece.length+O(a.right)}function p(a){return a===e.$kC?0:a.lf_left+a.piece.lineFeedCnt+p(a.right)}function $(){e.$kC.parent=e.$kC}function w(a,m){const l=m.right;l.size_left+=m.size_left+(m.piece?m.piece.length:0),l.lf_left+=m.lf_left+(m.piece?m.piece.lineFeedCnt:0),m.right=l.left,l.left!==e.$kC&&(l.left.parent=m),l.parent=m.parent,m.parent===e.$kC?a.root=l:m.parent.left===m?m.parent.left=l:m.parent.right=l,l.left=m,m.parent=l}function A(a,m){const l=m.left;m.left=l.right,l.right!==e.$kC&&(l.right.parent=m),l.parent=m.parent,m.size_left-=l.size_left+(l.piece?l.piece.length:0),m.lf_left-=l.lf_left+(l.piece?l.piece.lineFeedCnt:0),m.parent===e.$kC?a.root=l:m===m.parent.right?m.parent.right=l:m.parent.left=l,l.right=m,m.parent=l}function P(a,m){let l,i;if(m.left===e.$kC?(i=m,l=i.right):m.right===e.$kC?(i=m,l=i.left):(i=I(m.right),l=i.right),i===a.root){a.root=l,l.color=0,m.detach(),$(),a.root.parent=e.$kC;return}const n=i.color===1;if(i===i.parent.left?i.parent.left=l:i.parent.right=l,i===m?(l.parent=i.parent,y(a,l)):(i.parent===m?l.parent=i:l.parent=i.parent,y(a,l),i.left=m.left,i.right=m.right,i.parent=m.parent,i.color=m.color,m===a.root?a.root=i:m===m.parent.left?m.parent.left=i:m.parent.right=i,i.left!==e.$kC&&(i.left.parent=i),i.right!==e.$kC&&(i.right.parent=i),i.size_left=m.size_left,i.lf_left=m.lf_left,y(a,i)),m.detach(),l.parent.left===l){const s=O(l),t=p(l);if(s!==l.parent.size_left||t!==l.parent.lf_left){const g=s-l.parent.size_left,d=t-l.parent.lf_left;l.parent.size_left=s,l.parent.lf_left=t,C(a,l.parent,g,d)}}if(y(a,l.parent),n){$();return}let r;for(;l!==a.root&&l.color===0;)l===l.parent.left?(r=l.parent.right,r.color===1&&(r.color=0,l.parent.color=1,w(a,l.parent),r=l.parent.right),r.left.color===0&&r.right.color===0?(r.color=1,l=l.parent):(r.right.color===0&&(r.left.color=0,r.color=1,A(a,r),r=l.parent.right),r.color=l.parent.color,l.parent.color=0,r.right.color=0,w(a,l.parent),l=a.root)):(r=l.parent.left,r.color===1&&(r.color=0,l.parent.color=1,A(a,l.parent),r=l.parent.left),r.left.color===0&&r.right.color===0?(r.color=1,l=l.parent):(r.left.color===0&&(r.right.color=0,r.color=1,w(a,r),r=l.parent.left),r.color=l.parent.color,l.parent.color=0,r.left.color=0,A(a,l.parent),l=a.root));l.color=0,$()}function b(a,m){for(y(a,m);m!==a.root&&m.parent.color===1;)if(m.parent===m.parent.parent.left){const l=m.parent.parent.right;l.color===1?(m.parent.color=0,l.color=0,m.parent.parent.color=1,m=m.parent.parent):(m===m.parent.right&&(m=m.parent,w(a,m)),m.parent.color=0,m.parent.parent.color=1,A(a,m.parent.parent))}else{const l=m.parent.parent.left;l.color===1?(m.parent.color=0,l.color=0,m.parent.parent.color=1,m=m.parent.parent):(m===m.parent.left&&(m=m.parent,A(a,m)),m.parent.color=0,m.parent.parent.color=1,w(a,m.parent.parent))}a.root.color=0}function C(a,m,l,i){for(;m!==a.root&&m!==e.$kC;)m.parent.left===m&&(m.parent.size_left+=l,m.parent.lf_left+=i),m=m.parent}function y(a,m){let l=0,i=0;if(m!==a.root){for(;m!==a.root&&m===m.parent.right;)m=m.parent;if(m!==a.root)for(m=m.parent,l=O(m.left)-m.size_left,i=p(m.left)-m.lf_left,m.size_left+=l,m.lf_left+=i;m!==a.root&&(l!==0||i!==0);)m.parent.left===m&&(m.parent.size_left+=l,m.parent.lf_left+=i),m=m.parent}}}),define(Ee[190],Ce([1,0,19,130]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hv=e.$Gv=e.$Fv=void 0;class I{constructor($){this.a=$,this.b=new Uint32Array($.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues($,w){$=(0,R.$Te)($);const A=this.a,P=this.b,b=w.length;return b===0?!1:(this.a=new Uint32Array(A.length+b),this.a.set(A.subarray(0,$),0),this.a.set(A.subarray($),$+b),this.a.set(w,$),$-1<this.c[0]&&(this.c[0]=$-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(P.subarray(0,this.c[0]+1)),!0)}setValue($,w){return $=(0,R.$Te)($),w=(0,R.$Te)(w),this.a[$]===w?!1:(this.a[$]=w,$-1<this.c[0]&&(this.c[0]=$-1),!0)}removeValues($,w){$=(0,R.$Te)($),w=(0,R.$Te)(w);const A=this.a,P=this.b;if($>=A.length)return!1;const b=A.length-$;return w>=b&&(w=b),w===0?!1:(this.a=new Uint32Array(A.length-w),this.a.set(A.subarray(0,$),0),this.a.set(A.subarray($+w),$),this.b=new Uint32Array(this.a.length),$-1<this.c[0]&&(this.c[0]=$-1),this.c[0]>=0&&this.b.set(P.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum($){return $<0?0:($=(0,R.$Te)($),this.d($))}d($){if($<=this.c[0])return this.b[$];let w=this.c[0]+1;w===0&&(this.b[0]=this.a[0],w++),$>=this.a.length&&($=this.a.length-1);for(let A=w;A<=$;A++)this.b[A]=this.b[A-1]+this.a[A];return this.c[0]=Math.max(this.c[0],$),this.b[$]}getIndexOf($){$=Math.floor($),this.getTotalSum();let w=0,A=this.a.length-1,P=0,b=0,C=0;for(;w<=A;)if(P=w+(A-w)/2|0,b=this.b[P],C=b-this.a[P],$<C)A=P-1;else if($>=b)w=P+1;else break;return new O(P,$-C)}}e.$Fv=I;class M{constructor($){this.a=$,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum($){return this.g(),$===0?0:this.d[$-1]}getIndexOf($){this.g();const w=this.e[$],A=w>0?this.d[w-1]:0;return new O(w,$-A)}removeValues($,w){this.a.splice($,w),this.f($)}insertValues($,w){this.a=(0,o.$Wb)(this.a,$,w),this.f($)}f($){this.b=!1,this.c=Math.min(this.c,$-1)}g(){if(!this.b){for(let $=this.c+1,w=this.a.length;$<w;$++){const A=this.a[$],P=$>0?this.d[$-1]:0;this.d[$]=P+A;for(let b=0;b<A;b++)this.e[P+b]=$}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue($,w){this.a[$]!==w&&(this.a[$]=w,this.f($))}}e.$Gv=M;class O{constructor($,w){this.index=$,this.remainder=w,this._prefixSumIndexOfResultBrand=void 0,this.index=$,this.remainder=w}}e.$Hv=O}),define(Ee[191],Ce([1,0,14,52,190]),function(re,e,o,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iv=void 0;class M{constructor(p,$,w,A){this.d=p,this.f=$,this.g=w,this.h=A,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(p){p.eol&&p.eol!==this.g&&(this.g=p.eol,this.j=null);const $=p.changes;for(const w of $)this.o(w.range),this.p(new R.$ct(w.range.startLineNumber,w.range.startColumn),w.text);this.h=p.versionId,this.k=null}l(){if(!this.j){const p=this.g.length,$=this.f.length,w=new Uint32Array($);for(let A=0;A<$;A++)w[A]=this.f[A].length+p;this.j=new I.$Fv(w)}}n(p,$){this.f[p]=$,this.j&&this.j.setValue(p,this.f[p].length+this.g.length)}o(p){if(p.startLineNumber===p.endLineNumber){if(p.startColumn===p.endColumn)return;this.n(p.startLineNumber-1,this.f[p.startLineNumber-1].substring(0,p.startColumn-1)+this.f[p.startLineNumber-1].substring(p.endColumn-1));return}this.n(p.startLineNumber-1,this.f[p.startLineNumber-1].substring(0,p.startColumn-1)+this.f[p.endLineNumber-1].substring(p.endColumn-1)),this.f.splice(p.startLineNumber,p.endLineNumber-p.startLineNumber),this.j&&this.j.removeValues(p.startLineNumber,p.endLineNumber-p.startLineNumber)}p(p,$){if($.length===0)return;const w=(0,o.$$e)($);if(w.length===1){this.n(p.lineNumber-1,this.f[p.lineNumber-1].substring(0,p.column-1)+w[0]+this.f[p.lineNumber-1].substring(p.column-1));return}w[w.length-1]+=this.f[p.lineNumber-1].substring(p.column-1),this.n(p.lineNumber-1,this.f[p.lineNumber-1].substring(0,p.column-1)+w[0]);const A=new Uint32Array(w.length-1);for(let P=1;P<w.length;P++)this.f.splice(p.lineNumber+P-1,0,w[P]),A[P-1]=w[P].length+this.g.length;this.j&&this.j.insertValues(p.lineNumber,A)}}e.$Iv=M}),define(Ee[105],Ce([1,0,14,185,52,29,82]),function(re,e,o,R,I,M,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yC=e.$wC=e.$tC=void 0,e.$uC=w,e.$vC=A,e.$xC=a;const p=999;class ${constructor(i,n,r,s){this.searchString=i,this.isRegex=n,this.matchCase=r,this.wordSeparators=s}parseSearchRequest(){if(this.searchString==="")return null;let i;this.isRegex?i=w(this.searchString):i=this.searchString.indexOf(`
`)>=0;let n=null;try{n=o.$9e(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:i,global:!0,unicode:!0})}catch{return null}if(!n)return null;let r=!this.isRegex&&!i;return r&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(r=this.matchCase),new O.$Av(n,this.wordSeparators?(0,R.$Dt)(this.wordSeparators,[]):null,r?this.searchString:null)}}e.$tC=$;function w(l){if(!l||l.length===0)return!1;for(let i=0,n=l.length;i<n;i++){const r=l.charCodeAt(i);if(r===10)return!0;if(r===92){if(i++,i>=n)break;const s=l.charCodeAt(i);if(s===110||s===114||s===87)return!0}}return!1}function A(l,i,n){if(!n)return new O.$xv(l,null);const r=[];for(let s=0,t=i.length;s<t;s++)r[s]=i[s];return new O.$xv(l,r)}class P{constructor(i){const n=[];let r=0;for(let s=0,t=i.length;s<t;s++)i.charCodeAt(s)===10&&(n[r++]=s);this.a=n}findLineFeedCountBeforeOffset(i){const n=this.a;let r=0,s=n.length-1;if(s===-1||i<=n[0])return 0;for(;r<s;){const t=r+((s-r)/2>>0);n[t]>=i?s=t-1:n[t+1]>=i?(r=t,s=t):r=t+1}return r+1}}class b{static findMatches(i,n,r,s,t){const g=n.parseSearchRequest();return g?g.regex.multiline?this.b(i,r,new m(g.wordSeparators,g.regex),s,t):this.c(i,r,g,s,t):[]}static a(i,n,r,s,t,g){let d,h=0;s?(h=s.findLineFeedCountBeforeOffset(t),d=n+t+h):d=n+t;let c;if(s){const v=s.findLineFeedCountBeforeOffset(t+g.length)-h;c=d+g.length+v}else c=d+g.length;const u=i.getPositionAt(d),f=i.getPositionAt(c);return new M.$dt(u.lineNumber,u.column,f.lineNumber,f.column)}static b(i,n,r,s,t){const g=i.getOffsetAt(n.getStartPosition()),d=i.getValueInRange(n,1),h=i.getEOL()===`\r
`?new P(d):null,c=[];let u=0,f;for(r.reset(0);f=r.next(d);)if(c[u++]=A(this.a(i,g,d,h,f.index,f[0]),f,s),u>=t)return c;return c}static c(i,n,r,s,t){const g=[];let d=0;if(n.startLineNumber===n.endLineNumber){const c=i.getLineContent(n.startLineNumber).substring(n.startColumn-1,n.endColumn-1);return d=this.d(r,c,n.startLineNumber,n.startColumn-1,d,g,s,t),g}const h=i.getLineContent(n.startLineNumber).substring(n.startColumn-1);d=this.d(r,h,n.startLineNumber,n.startColumn-1,d,g,s,t);for(let c=n.startLineNumber+1;c<n.endLineNumber&&d<t;c++)d=this.d(r,i.getLineContent(c),c,0,d,g,s,t);if(d<t){const c=i.getLineContent(n.endLineNumber).substring(0,n.endColumn-1);d=this.d(r,c,n.endLineNumber,0,d,g,s,t)}return g}static d(i,n,r,s,t,g,d,h){const c=i.wordSeparators;if(!d&&i.simpleSearch){const E=i.simpleSearch,v=E.length,D=n.length;let k=-v;for(;(k=n.indexOf(E,k+v))!==-1;)if((!c||a(c,n,D,k,v))&&(g[t++]=new O.$xv(new M.$dt(r,k+1+s,r,k+1+v+s),null),t>=h))return t;return t}const u=new m(i.wordSeparators,i.regex);let f;u.reset(0);do if(f=u.next(n),f&&(g[t++]=A(new M.$dt(r,f.index+1+s,r,f.index+1+f[0].length+s),f,d),t>=h))return t;while(f);return t}static findNextMatch(i,n,r,s){const t=n.parseSearchRequest();if(!t)return null;const g=new m(t.wordSeparators,t.regex);return t.regex.multiline?this.e(i,r,g,s):this.f(i,r,g,s)}static e(i,n,r,s){const t=new I.$ct(n.lineNumber,1),g=i.getOffsetAt(t),d=i.getLineCount(),h=i.getValueInRange(new M.$dt(t.lineNumber,t.column,d,i.getLineMaxColumn(d)),1),c=i.getEOL()===`\r
`?new P(h):null;r.reset(n.column-1);const u=r.next(h);return u?A(this.a(i,g,h,c,u.index,u[0]),u,s):n.lineNumber!==1||n.column!==1?this.e(i,new I.$ct(1,1),r,s):null}static f(i,n,r,s){const t=i.getLineCount(),g=n.lineNumber,d=i.getLineContent(g),h=this.g(r,d,g,n.column,s);if(h)return h;for(let c=1;c<=t;c++){const u=(g+c-1)%t,f=i.getLineContent(u+1),E=this.g(r,f,u+1,1,s);if(E)return E}return null}static g(i,n,r,s,t){i.reset(s-1);const g=i.next(n);return g?A(new M.$dt(r,g.index+1,r,g.index+1+g[0].length),g,t):null}static findPreviousMatch(i,n,r,s){const t=n.parseSearchRequest();if(!t)return null;const g=new m(t.wordSeparators,t.regex);return t.regex.multiline?this.h(i,r,g,s):this.j(i,r,g,s)}static h(i,n,r,s){const t=this.b(i,new M.$dt(1,1,n.lineNumber,n.column),r,s,10*p);if(t.length>0)return t[t.length-1];const g=i.getLineCount();return n.lineNumber!==g||n.column!==i.getLineMaxColumn(g)?this.h(i,new I.$ct(g,i.getLineMaxColumn(g)),r,s):null}static j(i,n,r,s){const t=i.getLineCount(),g=n.lineNumber,d=i.getLineContent(g).substring(0,n.column-1),h=this.k(r,d,g,s);if(h)return h;for(let c=1;c<=t;c++){const u=(t+g-c-1)%t,f=i.getLineContent(u+1),E=this.k(r,f,u+1,s);if(E)return E}return null}static k(i,n,r,s){let t=null,g;for(i.reset(0);g=i.next(n);)t=A(new M.$dt(r,g.index+1,r,g.index+1+g[0].length),g,s);return t}}e.$wC=b;function C(l,i,n,r,s){if(r===0)return!0;const t=i.charCodeAt(r-1);if(l.get(t)!==0||t===13||t===10)return!0;if(s>0){const g=i.charCodeAt(r);if(l.get(g)!==0)return!0}return!1}function y(l,i,n,r,s){if(r+s===n)return!0;const t=i.charCodeAt(r+s);if(l.get(t)!==0||t===13||t===10)return!0;if(s>0){const g=i.charCodeAt(r+s-1);if(l.get(g)!==0)return!0}return!1}function a(l,i,n,r,s){return C(l,i,n,r,s)&&y(l,i,n,r,s)}class m{constructor(i,n){this._wordSeparators=i,this.a=n,this.b=-1,this.c=0}reset(i){this.a.lastIndex=i,this.b=-1,this.c=0}next(i){const n=i.length;let r;do{if(this.b+this.c===n||(r=this.a.exec(i),!r))return null;const s=r.index,t=r[0].length;if(s===this.b&&t===this.c){if(t===0){o.$sf(i,n,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=s,this.c=t,!this._wordSeparators||a(this._wordSeparators,i,n,s,t))return r}while(r);return null}}e.$yC=m}),define(Ee[134],Ce([1,0,52,29,82,189,105]),function(re,e,o,R,I,M,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DC=e.$CC=e.$BC=void 0,e.$zC=A,e.$AC=P;const p=65535;function $(l){let i;return l[l.length-1]<65536?i=new Uint16Array(l.length):i=new Uint32Array(l.length),i.set(l,0),i}class w{constructor(i,n,r,s,t){this.lineStarts=i,this.cr=n,this.lf=r,this.crlf=s,this.isBasicASCII=t}}function A(l,i=!0){const n=[0];let r=1;for(let s=0,t=l.length;s<t;s++){const g=l.charCodeAt(s);g===13?s+1<t&&l.charCodeAt(s+1)===10?(n[r++]=s+2,s++):n[r++]=s+1:g===10&&(n[r++]=s+1)}return i?$(n):n}function P(l,i){l.length=0,l[0]=0;let n=1,r=0,s=0,t=0,g=!0;for(let h=0,c=i.length;h<c;h++){const u=i.charCodeAt(h);u===13?h+1<c&&i.charCodeAt(h+1)===10?(t++,l[n++]=h+2,h++):(r++,l[n++]=h+1):u===10?(s++,l[n++]=h+1):g&&u!==9&&(u<32||u>126)&&(g=!1)}const d=new w($(l),r,s,t,g);return l.length=0,d}class b{constructor(i,n,r,s,t){this.bufferIndex=i,this.start=n,this.end=r,this.lineFeedCnt=s,this.length=t}}e.$BC=b;class C{constructor(i,n){this.buffer=i,this.lineStarts=n}}e.$CC=C;class y{constructor(i,n){this.a=[],this.c=i,this.d=n,this.b=0,i.root!==M.$kC&&i.iterate(i.root,r=>(r!==M.$kC&&this.a.push(r.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class a{constructor(i){this.a=i,this.b=[]}get(i){for(let n=this.b.length-1;n>=0;n--){const r=this.b[n];if(r.nodeStartOffset<=i&&r.nodeStartOffset+r.node.piece.length>=i)return r}return null}get2(i){for(let n=this.b.length-1;n>=0;n--){const r=this.b[n];if(r.nodeStartLineNumber&&r.nodeStartLineNumber<i&&r.nodeStartLineNumber+r.node.piece.lineFeedCnt>=i)return r}return null}set(i){this.b.length>=this.a&&this.b.shift(),this.b.push(i)}validate(i){let n=!1;const r=this.b;for(let s=0;s<r.length;s++){const t=r[s];if(t.node.parent===null||t.nodeStartOffset>=i){r[s]=null,n=!0;continue}}if(n){const s=[];for(const t of r)t!==null&&s.push(t);this.b=s}}}class m{constructor(i,n,r){this.create(i,n,r)}create(i,n,r){this.a=[new C("",[0])],this.g={line:0,column:0},this.root=M.$kC,this.b=1,this.c=0,this.d=n,this.e=n.length,this.f=r;let s=null;for(let t=0,g=i.length;t<g;t++)if(i[t].buffer.length>0){i[t].lineStarts||(i[t].lineStarts=A(i[t].buffer));const d=new b(t+1,{line:0,column:0},{line:i[t].lineStarts.length-1,column:i[t].buffer.length-i[t].lineStarts[i[t].lineStarts.length-1]},i[t].lineStarts.length-1,i[t].buffer.length);this.a.push(i[t]),s=this.S(s,d)}this.h=new a(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(i){const n=p,r=n-Math.floor(n/3),s=r*2;let t="",g=0;const d=[];if(this.iterate(this.root,h=>{const c=this.R(h),u=c.length;if(g<=r||g+u<s)return t+=c,g+=u,!0;const f=t.replace(/\r\n|\r|\n/g,i);return d.push(new C(f,A(f))),t=c,g=u,!0}),g>0){const h=t.replace(/\r\n|\r|\n/g,i);d.push(new C(h,A(h)))}this.create(d,i,!0)}getEOL(){return this.d}setEOL(i){this.d=i,this.e=this.d.length,this.normalizeEOL(i)}createSnapshot(i){return new y(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let n=0;return this.iterate(this.root,s=>{if(s===M.$kC)return!0;const t=this.R(s),g=t.length,d=i.G(n),h=i.G(n+g),c=i.getValueInRange2(d,h);return n+=g,t===c})}getOffsetAt(i,n){let r=0,s=this.root;for(;s!==M.$kC;)if(s.left!==M.$kC&&s.lf_left+1>=i)s=s.left;else if(s.lf_left+s.piece.lineFeedCnt+1>=i){r+=s.size_left;const t=this.B(s,i-s.lf_left-2);return r+=t+n-1}else i-=s.lf_left+s.piece.lineFeedCnt,r+=s.size_left+s.piece.length,s=s.right;return r}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let n=this.root,r=0;const s=i;for(;n!==M.$kC;)if(n.size_left!==0&&n.size_left>=i)n=n.left;else if(n.size_left+n.piece.length>=i){const t=this.A(n,i-n.size_left);if(r+=n.lf_left+t.index,t.index===0){const g=this.getOffsetAt(r+1,1),d=s-g;return new o.$ct(r+1,d+1)}return new o.$ct(r+1,t.remainder+1)}else if(i-=n.size_left+n.piece.length,r+=n.lf_left+n.piece.lineFeedCnt,n.right===M.$kC){const t=this.getOffsetAt(r+1,1),g=s-i-t;return new o.$ct(r+1,g+1)}else n=n.right;return new o.$ct(1,1)}getValueInRange(i,n){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const r=this.H(i.startLineNumber,i.startColumn),s=this.H(i.endLineNumber,i.endColumn),t=this.getValueInRange2(r,s);return n?n!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,n):n===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,n):t}getValueInRange2(i,n){if(i.node===n.node){const d=i.node,h=this.a[d.piece.bufferIndex].buffer,c=this.u(d.piece.bufferIndex,d.piece.start);return h.substring(c+i.remainder,c+n.remainder)}let r=i.node;const s=this.a[r.piece.bufferIndex].buffer,t=this.u(r.piece.bufferIndex,r.piece.start);let g=s.substring(t+i.remainder,t+r.piece.length);for(r=r.next();r!==M.$kC;){const d=this.a[r.piece.bufferIndex].buffer,h=this.u(r.piece.bufferIndex,r.piece.start);if(r===n.node){g+=d.substring(h,h+n.remainder);break}else g+=d.substr(h,r.piece.length);r=r.next()}return g}getLinesContent(){const i=[];let n=0,r="",s=!1;return this.iterate(this.root,t=>{if(t===M.$kC)return!0;const g=t.piece;let d=g.length;if(d===0)return!0;const h=this.a[g.bufferIndex].buffer,c=this.a[g.bufferIndex].lineStarts,u=g.start.line,f=g.end.line;let E=c[u]+g.start.column;if(s&&(h.charCodeAt(E)===10&&(E++,d--),i[n++]=r,r="",s=!1,d===0))return!0;if(u===f)return!this.f&&h.charCodeAt(E+d-1)===13?(s=!0,r+=h.substr(E,d-1)):r+=h.substr(E,d),!0;r+=this.f?h.substring(E,Math.max(E,c[u+1]-this.e)):h.substring(E,c[u+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=r;for(let v=u+1;v<f;v++)r=this.f?h.substring(c[v],c[v+1]-this.e):h.substring(c[v],c[v+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=r;return!this.f&&h.charCodeAt(c[f]+g.end.column-1)===13?(s=!0,g.end.column===0?n--:r=h.substr(c[f],g.end.column-1)):r=h.substr(c[f],g.end.column),!0}),s&&(i[n++]=r,r=""),i[n++]=r,i}getLength(){return this.c}getLineCount(){return this.b}getLineContent(i){return this.j.lineNumber===i?this.j.value:(this.j.lineNumber=i,i===this.b?this.j.value=this.getLineRawContent(i):this.f?this.j.value=this.getLineRawContent(i,this.e):this.j.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(i){if(i.remainder===i.node.piece.length){const n=i.node.next();if(!n)return 0;const r=this.a[n.piece.bufferIndex],s=this.u(n.piece.bufferIndex,n.piece.start);return r.buffer.charCodeAt(s)}else{const n=this.a[i.node.piece.bufferIndex],s=this.u(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return n.buffer.charCodeAt(s)}}getLineCharCode(i,n){const r=this.H(i,n+1);return this.l(r)}getLineLength(i){if(i===this.getLineCount()){const n=this.getOffsetAt(i,1);return this.getLength()-n}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this.e}getCharCode(i){const n=this.G(i);return this.l(n)}findMatchesInNode(i,n,r,s,t,g,d,h,c,u,f){const E=this.a[i.piece.bufferIndex],v=this.u(i.piece.bufferIndex,i.piece.start),D=this.u(i.piece.bufferIndex,t),k=this.u(i.piece.bufferIndex,g);let S;const F={line:0,column:0};let W,B;n._wordSeparators?(W=E.buffer.substring(D,k),B=T=>T+D,n.reset(0)):(W=E.buffer,B=T=>T,n.reset(D));do if(S=n.next(W),S){if(B(S.index)>=k)return u;this.s(i,B(S.index)-v,F);const T=this.t(i.piece.bufferIndex,t,F),N=F.line===t.line?F.column-t.column+s:F.column+1,j=N+S[0].length;if(f[u++]=(0,O.$vC)(new R.$dt(r+T,N,r+T,j),S,h),B(S.index)+S[0].length>=k||u>=c)return u}while(S);return u}findMatchesLineByLine(i,n,r,s){const t=[];let g=0;const d=new O.$yC(n.wordSeparators,n.regex);let h=this.H(i.startLineNumber,i.startColumn);if(h===null)return[];const c=this.H(i.endLineNumber,i.endColumn);if(c===null)return[];let u=this.s(h.node,h.remainder);const f=this.s(c.node,c.remainder);if(h.node===c.node)return this.findMatchesInNode(h.node,d,i.startLineNumber,i.startColumn,u,f,n,r,s,g,t),t;let E=i.startLineNumber,v=h.node;for(;v!==c.node;){const k=this.t(v.piece.bufferIndex,u,v.piece.end);if(k>=1){const F=this.a[v.piece.bufferIndex].lineStarts,W=this.u(v.piece.bufferIndex,v.piece.start),B=F[u.line+k],T=E===i.startLineNumber?i.startColumn:1;if(g=this.findMatchesInNode(v,d,E,T,u,this.s(v,B-W),n,r,s,g,t),g>=s)return t;E+=k}const S=E===i.startLineNumber?i.startColumn-1:0;if(E===i.endLineNumber){const F=this.getLineContent(E).substring(S,i.endColumn-1);return g=this.n(n,d,F,i.endLineNumber,S,g,t,r,s),t}if(g=this.n(n,d,this.getLineContent(E).substr(S),E,S,g,t,r,s),g>=s)return t;E++,h=this.H(E,1),v=h.node,u=this.s(h.node,h.remainder)}if(E===i.endLineNumber){const k=E===i.startLineNumber?i.startColumn-1:0,S=this.getLineContent(E).substring(k,i.endColumn-1);return g=this.n(n,d,S,i.endLineNumber,k,g,t,r,s),t}const D=E===i.startLineNumber?i.startColumn:1;return g=this.findMatchesInNode(c.node,d,E,D,u,f,n,r,s,g,t),t}n(i,n,r,s,t,g,d,h,c){const u=i.wordSeparators;if(!h&&i.simpleSearch){const E=i.simpleSearch,v=E.length,D=r.length;let k=-v;for(;(k=r.indexOf(E,k+v))!==-1;)if((!u||(0,O.$xC)(u,r,D,k,v))&&(d[g++]=new I.$xv(new R.$dt(s,k+1+t,s,k+1+v+t),null),g>=c))return g;return g}let f;n.reset(0);do if(f=n.next(r),f&&(d[g++]=(0,O.$vC)(new R.$dt(s,f.index+1+t,s,f.index+1+f[0].length+t),f,h),g>=c))return g;while(f);return g}insert(i,n,r=!1){if(this.f=this.f&&r,this.j.lineNumber=0,this.j.value="",this.root!==M.$kC){const{node:s,remainder:t,nodeStartOffset:g}=this.G(i),d=s.piece,h=d.bufferIndex,c=this.s(s,t);if(s.piece.bufferIndex===0&&d.end.line===this.g.line&&d.end.column===this.g.column&&g+d.length===i&&n.length<p){this.F(s,n),this.y();return}if(g===i)this.o(n,s),this.h.validate(i);else if(g+s.piece.length>i){const u=[];let f=new b(d.bufferIndex,c,d.end,this.t(d.bufferIndex,c,d.end),this.u(h,d.end)-this.u(h,c));if(this.K()&&this.M(n)&&this.I(s,t)===10){const k={line:f.start.line+1,column:0};f=new b(f.bufferIndex,k,f.end,this.t(f.bufferIndex,k,f.end),f.length-1),n+=`
`}if(this.K()&&this.L(n))if(this.I(s,t-1)===13){const k=this.s(s,t-1);this.C(s,k),n="\r"+n,s.piece.length===0&&u.push(s)}else this.C(s,c);else this.C(s,c);const E=this.w(n);f.length>0&&this.S(s,f);let v=s;for(let D=0;D<E.length;D++)v=this.S(v,E[D]);this.v(u)}else this.q(n,s)}else{const s=this.w(n);let t=this.T(null,s[0]);for(let g=1;g<s.length;g++)t=this.S(t,s[g])}this.y()}delete(i,n){if(this.j.lineNumber=0,this.j.value="",n<=0||this.root===M.$kC)return;const r=this.G(i),s=this.G(i+n),t=r.node,g=s.node;if(t===g){const E=this.s(t,r.remainder),v=this.s(t,s.remainder);if(r.nodeStartOffset===i){if(n===t.piece.length){const D=t.next();(0,M.$pC)(this,t),this.N(D),this.y();return}this.D(t,v),this.h.validate(i),this.N(t),this.y();return}if(r.nodeStartOffset+t.piece.length===i+n){this.C(t,E),this.O(t),this.y();return}this.E(t,E,v),this.y();return}const d=[],h=this.s(t,r.remainder);this.C(t,h),this.h.validate(i),t.piece.length===0&&d.push(t);const c=this.s(g,s.remainder);this.D(g,c),g.piece.length===0&&d.push(g);const u=t.next();for(let E=u;E!==M.$kC&&E!==g;E=E.next())d.push(E);const f=t.piece.length===0?t.prev():t;this.v(d),this.O(f),this.y()}o(i,n){const r=[];if(this.K()&&this.M(i)&&this.L(n)){const g=n.piece,d={line:g.start.line+1,column:0},h=new b(g.bufferIndex,d,g.end,this.t(g.bufferIndex,d,g.end),g.length-1);n.piece=h,i+=`
`,(0,M.$rC)(this,n,-1,-1),n.piece.length===0&&r.push(n)}const s=this.w(i);let t=this.T(n,s[s.length-1]);for(let g=s.length-2;g>=0;g--)t=this.T(t,s[g]);this.N(t),this.v(r)}q(i,n){this.Q(i,n)&&(i+=`
`);const r=this.w(i),s=this.S(n,r[0]);let t=s;for(let g=1;g<r.length;g++)t=this.S(t,r[g]);this.N(s)}s(i,n,r){const s=i.piece,t=i.piece.bufferIndex,g=this.a[t].lineStarts,h=g[s.start.line]+s.start.column+n;let c=s.start.line,u=s.end.line,f=0,E=0,v=0;for(;c<=u&&(f=c+(u-c)/2|0,v=g[f],f!==u);)if(E=g[f+1],h<v)u=f-1;else if(h>=E)c=f+1;else break;return r?(r.line=f,r.column=h-v,null):{line:f,column:h-v}}t(i,n,r){if(r.column===0)return r.line-n.line;const s=this.a[i].lineStarts;if(r.line===s.length-1)return r.line-n.line;const t=s[r.line+1],g=s[r.line]+r.column;if(t>g+1)return r.line-n.line;const d=g-1;return this.a[i].buffer.charCodeAt(d)===13?r.line-n.line+1:r.line-n.line}u(i,n){return this.a[i].lineStarts[n.line]+n.column}v(i){for(let n=0;n<i.length;n++)(0,M.$pC)(this,i[n])}w(i){if(i.length>p){const u=[];for(;i.length>p;){const E=i.charCodeAt(p-1);let v;E===13||E>=55296&&E<=56319?(v=i.substring(0,p-1),i=i.substring(p-1)):(v=i.substring(0,p),i=i.substring(p));const D=A(v);u.push(new b(this.a.length,{line:0,column:0},{line:D.length-1,column:v.length-D[D.length-1]},D.length-1,v.length)),this.a.push(new C(v,D))}const f=A(i);return u.push(new b(this.a.length,{line:0,column:0},{line:f.length-1,column:i.length-f[f.length-1]},f.length-1,i.length)),this.a.push(new C(i,f)),u}let n=this.a[0].buffer.length;const r=A(i,!1);let s=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===n&&n!==0&&this.L(i)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},s=this.g;for(let u=0;u<r.length;u++)r[u]+=n+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(r.slice(1)),this.a[0].buffer+="_"+i,n+=1}else{if(n!==0)for(let u=0;u<r.length;u++)r[u]+=n;this.a[0].lineStarts=this.a[0].lineStarts.concat(r.slice(1)),this.a[0].buffer+=i}const t=this.a[0].buffer.length,g=this.a[0].lineStarts.length-1,d=t-this.a[0].lineStarts[g],h={line:g,column:d},c=new b(0,s,h,this.t(0,s,h),t-n);return this.g=h,[c]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(i,n=0){let r=this.root,s="";const t=this.h.get2(i);if(t){r=t.node;const g=this.B(r,i-t.nodeStartLineNumber-1),d=this.a[r.piece.bufferIndex].buffer,h=this.u(r.piece.bufferIndex,r.piece.start);if(t.nodeStartLineNumber+r.piece.lineFeedCnt===i)s=d.substring(h+g,h+r.piece.length);else{const c=this.B(r,i-t.nodeStartLineNumber);return d.substring(h+g,h+c-n)}}else{let g=0;const d=i;for(;r!==M.$kC;)if(r.left!==M.$kC&&r.lf_left>=i-1)r=r.left;else if(r.lf_left+r.piece.lineFeedCnt>i-1){const h=this.B(r,i-r.lf_left-2),c=this.B(r,i-r.lf_left-1),u=this.a[r.piece.bufferIndex].buffer,f=this.u(r.piece.bufferIndex,r.piece.start);return g+=r.size_left,this.h.set({node:r,nodeStartOffset:g,nodeStartLineNumber:d-(i-1-r.lf_left)}),u.substring(f+h,f+c-n)}else if(r.lf_left+r.piece.lineFeedCnt===i-1){const h=this.B(r,i-r.lf_left-2),c=this.a[r.piece.bufferIndex].buffer,u=this.u(r.piece.bufferIndex,r.piece.start);s=c.substring(u+h,u+r.piece.length);break}else i-=r.lf_left+r.piece.lineFeedCnt,g+=r.size_left+r.piece.length,r=r.right}for(r=r.next();r!==M.$kC;){const g=this.a[r.piece.bufferIndex].buffer;if(r.piece.lineFeedCnt>0){const d=this.B(r,0),h=this.u(r.piece.bufferIndex,r.piece.start);return s+=g.substring(h,h+d-n),s}else{const d=this.u(r.piece.bufferIndex,r.piece.start);s+=g.substr(d,r.piece.length)}r=r.next()}return s}y(){let i=this.root,n=1,r=0;for(;i!==M.$kC;)n+=i.lf_left+i.piece.lineFeedCnt,r+=i.size_left+i.piece.length,i=i.right;this.b=n,this.c=r,this.h.validate(this.c)}A(i,n){const r=i.piece,s=this.s(i,n),t=s.line-r.start.line;if(this.u(r.bufferIndex,r.end)-this.u(r.bufferIndex,r.start)===n){const g=this.t(i.piece.bufferIndex,r.start,s);if(g!==t)return{index:g,remainder:0}}return{index:t,remainder:s.column}}B(i,n){if(n<0)return 0;const r=i.piece,s=this.a[r.bufferIndex].lineStarts,t=r.start.line+n+1;return t>r.end.line?s[r.end.line]+r.end.column-s[r.start.line]-r.start.column:s[t]-s[r.start.line]-r.start.column}C(i,n){const r=i.piece,s=r.lineFeedCnt,t=this.u(r.bufferIndex,r.end),g=n,d=this.u(r.bufferIndex,g),h=this.t(r.bufferIndex,r.start,g),c=h-s,u=d-t,f=r.length+u;i.piece=new b(r.bufferIndex,r.start,g,h,f),(0,M.$rC)(this,i,u,c)}D(i,n){const r=i.piece,s=r.lineFeedCnt,t=this.u(r.bufferIndex,r.start),g=n,d=this.t(r.bufferIndex,g,r.end),h=this.u(r.bufferIndex,g),c=d-s,u=t-h,f=r.length+u;i.piece=new b(r.bufferIndex,g,r.end,d,f),(0,M.$rC)(this,i,u,c)}E(i,n,r){const s=i.piece,t=s.start,g=s.end,d=s.length,h=s.lineFeedCnt,c=n,u=this.t(s.bufferIndex,s.start,c),f=this.u(s.bufferIndex,n)-this.u(s.bufferIndex,t);i.piece=new b(s.bufferIndex,s.start,c,u,f),(0,M.$rC)(this,i,f-d,u-h);const E=new b(s.bufferIndex,r,g,this.t(s.bufferIndex,r,g),this.u(s.bufferIndex,g)-this.u(s.bufferIndex,r)),v=this.S(i,E);this.N(v)}F(i,n){this.Q(n,i)&&(n+=`
`);const r=this.K()&&this.L(n)&&this.M(i),s=this.a[0].buffer.length;this.a[0].buffer+=n;const t=A(n,!1);for(let v=0;v<t.length;v++)t[v]+=s;if(r){const v=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:s-v}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const g=this.a[0].lineStarts.length-1,d=this.a[0].buffer.length-this.a[0].lineStarts[g],h={line:g,column:d},c=i.piece.length+n.length,u=i.piece.lineFeedCnt,f=this.t(0,i.piece.start,h),E=f-u;i.piece=new b(i.piece.bufferIndex,i.piece.start,h,f,c),this.g=h,(0,M.$rC)(this,i,n.length,E)}G(i){let n=this.root;const r=this.h.get(i);if(r)return{node:r.node,nodeStartOffset:r.nodeStartOffset,remainder:i-r.nodeStartOffset};let s=0;for(;n!==M.$kC;)if(n.size_left>i)n=n.left;else if(n.size_left+n.piece.length>=i){s+=n.size_left;const t={node:n,remainder:i-n.size_left,nodeStartOffset:s};return this.h.set(t),t}else i-=n.size_left+n.piece.length,s+=n.size_left+n.piece.length,n=n.right;return null}H(i,n){let r=this.root,s=0;for(;r!==M.$kC;)if(r.left!==M.$kC&&r.lf_left>=i-1)r=r.left;else if(r.lf_left+r.piece.lineFeedCnt>i-1){const t=this.B(r,i-r.lf_left-2),g=this.B(r,i-r.lf_left-1);return s+=r.size_left,{node:r,remainder:Math.min(t+n-1,g),nodeStartOffset:s}}else if(r.lf_left+r.piece.lineFeedCnt===i-1){const t=this.B(r,i-r.lf_left-2);if(t+n-1<=r.piece.length)return{node:r,remainder:t+n-1,nodeStartOffset:s};n-=r.piece.length-t;break}else i-=r.lf_left+r.piece.lineFeedCnt,s+=r.size_left+r.piece.length,r=r.right;for(r=r.next();r!==M.$kC;){if(r.piece.lineFeedCnt>0){const t=this.B(r,0),g=this.J(r);return{node:r,remainder:Math.min(n-1,t),nodeStartOffset:g}}else if(r.piece.length>=n-1){const t=this.J(r);return{node:r,remainder:n-1,nodeStartOffset:t}}else n-=r.piece.length;r=r.next()}return null}I(i,n){if(i.piece.lineFeedCnt<1)return-1;const r=this.a[i.piece.bufferIndex],s=this.u(i.piece.bufferIndex,i.piece.start)+n;return r.buffer.charCodeAt(s)}J(i){if(!i)return 0;let n=i.size_left;for(;i!==this.root;)i.parent.right===i&&(n+=i.parent.size_left+i.parent.piece.length),i=i.parent;return n}K(){return!(this.f&&this.d===`
`)}L(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===M.$kC||i.piece.lineFeedCnt===0)return!1;const n=i.piece,r=this.a[n.bufferIndex].lineStarts,s=n.start.line,t=r[s]+n.start.column;return s===r.length-1||r[s+1]>t+1?!1:this.a[n.bufferIndex].buffer.charCodeAt(t)===10}M(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===M.$kC||i.piece.lineFeedCnt===0?!1:this.I(i,i.piece.length-1)===13}N(i){if(this.K()&&this.L(i)){const n=i.prev();this.M(n)&&this.P(n,i)}}O(i){if(this.K()&&this.M(i)){const n=i.next();this.L(n)&&this.P(i,n)}}P(i,n){const r=[],s=this.a[i.piece.bufferIndex].lineStarts;let t;i.piece.end.column===0?t={line:i.piece.end.line-1,column:s[i.piece.end.line]-s[i.piece.end.line-1]-1}:t={line:i.piece.end.line,column:i.piece.end.column-1};const g=i.piece.length-1,d=i.piece.lineFeedCnt-1;i.piece=new b(i.piece.bufferIndex,i.piece.start,t,d,g),(0,M.$rC)(this,i,-1,-1),i.piece.length===0&&r.push(i);const h={line:n.piece.start.line+1,column:0},c=n.piece.length-1,u=this.t(n.piece.bufferIndex,h,n.piece.end);n.piece=new b(n.piece.bufferIndex,h,n.piece.end,u,c),(0,M.$rC)(this,n,-1,-1),n.piece.length===0&&r.push(n);const f=this.w(`\r
`);this.S(i,f[0]);for(let E=0;E<r.length;E++)(0,M.$pC)(this,r[E])}Q(i,n){if(this.K()&&this.M(i)){const r=n.next();if(this.L(r)){if(i+=`
`,r.piece.length===1)(0,M.$pC)(this,r);else{const s=r.piece,t={line:s.start.line+1,column:0},g=s.length-1,d=this.t(s.bufferIndex,t,s.end);r.piece=new b(s.bufferIndex,t,s.end,d,g),(0,M.$rC)(this,r,-1,-1)}return!0}}return!1}iterate(i,n){if(i===M.$kC)return n(M.$kC);const r=this.iterate(i.left,n);return r&&n(i)&&this.iterate(i.right,n)}R(i){if(i===M.$kC)return"";const n=this.a[i.piece.bufferIndex],r=i.piece,s=this.u(r.bufferIndex,r.start),t=this.u(r.bufferIndex,r.end);return n.buffer.substring(s,t)}getPieceContent(i){const n=this.a[i.bufferIndex],r=this.u(i.bufferIndex,i.start),s=this.u(i.bufferIndex,i.end);return n.buffer.substring(r,s)}S(i,n){const r=new M.$jC(n,1);if(r.left=M.$kC,r.right=M.$kC,r.parent=M.$kC,r.size_left=0,r.lf_left=0,this.root===M.$kC)this.root=r,r.color=0;else if(i.right===M.$kC)i.right=r,r.parent=i;else{const t=(0,M.$lC)(i.right);t.left=r,r.parent=t}return(0,M.$qC)(this,r),r}T(i,n){const r=new M.$jC(n,1);if(r.left=M.$kC,r.right=M.$kC,r.parent=M.$kC,r.size_left=0,r.lf_left=0,this.root===M.$kC)this.root=r,r.color=0;else if(i.left===M.$kC)i.left=r,r.parent=i;else{const s=(0,M.$mC)(i.left);s.right=r,r.parent=s}return(0,M.$qC)(this,r),r}U(i){let n="";return this.iterate(i,r=>(n+=this.R(r),!0)),n}}e.$DC=m}),define(Ee[192],Ce([1,0,4,14,29,82,134,179,183,3]),function(re,e,o,R,I,M,O,p,$,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EC=void 0;class A extends w.$Uc{constructor(b,C,y,a,m,l,i){super(),this.m=this.B(new o.$7d),this.onDidChangeContent=this.m.event,this.f=C,this.j=!l,this.g=a,this.h=m,this.c=new O.$DC(b,y,i)}equals(b){return!(b instanceof A)||this.f!==b.f||this.getEOL()!==b.getEOL()?!1:this.c.equal(b.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(b){return this.c.createSnapshot(b?this.f:"")}getOffsetAt(b,C){return this.c.getOffsetAt(b,C)}getPositionAt(b){return this.c.getPositionAt(b)}getRangeAt(b,C){const y=b+C,a=this.getPositionAt(b),m=this.getPositionAt(y);return new I.$dt(a.lineNumber,a.column,m.lineNumber,m.column)}getValueInRange(b,C=0){if(b.isEmpty())return"";const y=this.n(C);return this.c.getValueInRange(b,y)}getValueLengthInRange(b,C=0){if(b.isEmpty())return 0;if(b.startLineNumber===b.endLineNumber)return b.endColumn-b.startColumn;const y=this.getOffsetAt(b.startLineNumber,b.startColumn),a=this.getOffsetAt(b.endLineNumber,b.endColumn);let m=0;const l=this.n(C),i=this.getEOL();if(l.length!==i.length){const n=l.length-i.length,r=b.endLineNumber-b.startLineNumber;m=n*r}return a-y+m}getCharacterCountInRange(b,C=0){if(this.j){let y=0;const a=b.startLineNumber,m=b.endLineNumber;for(let l=a;l<=m;l++){const i=this.getLineContent(l),n=l===a?b.startColumn-1:0,r=l===m?b.endColumn-1:i.length;for(let s=n;s<r;s++)R.$pf(i.charCodeAt(s))?(y=y+1,s=s+1):y=y+1}return y+=this.n(C).length*(m-a),y}return this.getValueLengthInRange(b,C)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(b){return this.c.getLineContent(b)}getLineCharCode(b,C){return this.c.getLineCharCode(b,C)}getCharCode(b){return this.c.getCharCode(b)}getLineLength(b){return this.c.getLineLength(b)}getLineMinColumn(b){return 1}getLineMaxColumn(b){return this.getLineLength(b)+1}getLineFirstNonWhitespaceColumn(b){const C=R.$af(this.getLineContent(b));return C===-1?0:C+1}getLineLastNonWhitespaceColumn(b){const C=R.$cf(this.getLineContent(b));return C===-1?0:C+2}n(b){switch(b){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(b){this.c.setEOL(b)}applyEdits(b,C,y){let a=this.g,m=this.h,l=this.j,i=!0,n=[];for(let c=0;c<b.length;c++){const u=b[c];i&&u._isTracked&&(i=!1);const f=u.range;if(u.text){let S=!0;l||(S=!R.$Af(u.text),l=S),!a&&S&&(a=R.$zf(u.text)),!m&&S&&(m=R.$Cf(u.text))}let E="",v=0,D=0,k=0;if(u.text){let S;[v,D,k,S]=(0,p.$Pt)(u.text);const F=this.getEOL();S===0||S===(F===`\r
`?2:1)?E=u.text:E=u.text.replace(/\r\n|\r|\n/g,F)}n[c]={sortIndex:c,identifier:u.identifier||null,range:f,rangeOffset:this.getOffsetAt(f.startLineNumber,f.startColumn),rangeLength:this.getValueLengthInRange(f),text:E,eolCount:v,firstLineLength:D,lastLineLength:k,forceMoveMarkers:!!u.forceMoveMarkers,isAutoWhitespaceEdit:u.isAutoWhitespaceEdit||!1}}n.sort(A.u);let r=!1;for(let c=0,u=n.length-1;c<u;c++){const f=n[c].range.getEndPosition(),E=n[c+1].range.getStartPosition();if(E.isBeforeOrEqual(f)){if(E.isBefore(f))throw new Error("Overlapping ranges are not allowed!");r=!0}}i&&(n=this.s(n));const s=y||C?A._getInverseEditRanges(n):[],t=[];if(C)for(let c=0;c<n.length;c++){const u=n[c],f=s[c];if(u.isAutoWhitespaceEdit&&u.range.isEmpty())for(let E=f.startLineNumber;E<=f.endLineNumber;E++){let v="";E===f.startLineNumber&&(v=this.getLineContent(u.range.startLineNumber),R.$af(v)!==-1)||t.push({lineNumber:E,oldContent:v})}}let g=null;if(y){let c=0;g=[];for(let u=0;u<n.length;u++){const f=n[u],E=s[u],v=this.getValueInRange(f.range),D=f.rangeOffset+c;c+=f.text.length-v.length,g[u]={sortIndex:f.sortIndex,identifier:f.identifier,range:E,text:v,textChange:new $.$yt(f.rangeOffset,v,D,f.text)}}r||g.sort((u,f)=>u.sortIndex-f.sortIndex)}this.g=a,this.h=m,this.j=l;const d=this.t(n);let h=null;if(C&&t.length>0){t.sort((c,u)=>u.lineNumber-c.lineNumber),h=[];for(let c=0,u=t.length;c<u;c++){const f=t[c].lineNumber;if(c>0&&t[c-1].lineNumber===f)continue;const E=t[c].oldContent,v=this.getLineContent(f);v.length===0||v===E||R.$af(v)!==-1||h.push(f)}}return this.m.fire(),new M.$Bv(g,d,h)}s(b){return b.length<1e3?b:[this._toSingleEditOperation(b)]}_toSingleEditOperation(b){let C=!1;const y=b[0].range,a=b[b.length-1].range,m=new I.$dt(y.startLineNumber,y.startColumn,a.endLineNumber,a.endColumn);let l=y.startLineNumber,i=y.startColumn;const n=[];for(let d=0,h=b.length;d<h;d++){const c=b[d],u=c.range;C=C||c.forceMoveMarkers,n.push(this.getValueInRange(new I.$dt(l,i,u.startLineNumber,u.startColumn))),c.text.length>0&&n.push(c.text),l=u.endLineNumber,i=u.endColumn}const r=n.join(""),[s,t,g]=(0,p.$Pt)(r);return{sortIndex:0,identifier:b[0].identifier,range:m,rangeOffset:this.getOffsetAt(m.startLineNumber,m.startColumn),rangeLength:this.getValueLengthInRange(m,0),text:r,eolCount:s,firstLineLength:t,lastLineLength:g,forceMoveMarkers:C,isAutoWhitespaceEdit:!1}}t(b){b.sort(A.w);const C=[];for(let y=0;y<b.length;y++){const a=b[y],m=a.range.startLineNumber,l=a.range.startColumn,i=a.range.endLineNumber,n=a.range.endColumn;if(m===i&&l===n&&a.text.length===0)continue;a.text?(this.c.delete(a.rangeOffset,a.rangeLength),this.c.insert(a.rangeOffset,a.text,!0)):this.c.delete(a.rangeOffset,a.rangeLength);const r=new I.$dt(m,l,i,n);C.push({range:r,rangeLength:a.rangeLength,text:a.text,rangeOffset:a.rangeOffset,forceMoveMarkers:a.forceMoveMarkers})}return C}findMatchesLineByLine(b,C,y,a){return this.c.findMatchesLineByLine(b,C,y,a)}getPieceTree(){return this.c}static _getInverseEditRange(b,C){const y=b.startLineNumber,a=b.startColumn,[m,l,i]=(0,p.$Pt)(C);let n;if(C.length>0){const r=m+1;r===1?n=new I.$dt(y,a,y,a+l):n=new I.$dt(y,a,y+r-1,i+1)}else n=new I.$dt(y,a,y,a);return n}static _getInverseEditRanges(b){const C=[];let y=0,a=0,m=null;for(let l=0,i=b.length;l<i;l++){const n=b[l];let r,s;m?m.range.endLineNumber===n.range.startLineNumber?(r=y,s=a+(n.range.startColumn-m.range.endColumn)):(r=y+(n.range.startLineNumber-m.range.endLineNumber),s=n.range.startColumn):(r=n.range.startLineNumber,s=n.range.startColumn);let t;if(n.text.length>0){const g=n.eolCount+1;g===1?t=new I.$dt(r,s,r,s+n.firstLineLength):t=new I.$dt(r,s,r+g-1,n.lastLineLength+1)}else t=new I.$dt(r,s,r,s);y=t.endLineNumber,a=t.endColumn,C.push(t),m=n}return C}static u(b,C){const y=I.$dt.compareRangesUsingEnds(b.range,C.range);return y===0?b.sortIndex-C.sortIndex:y}static w(b,C){const y=I.$dt.compareRangesUsingEnds(b.range,C.range);return y===0?C.sortIndex-b.sortIndex:-y}}e.$EC=A}),define(Ee[193],Ce([1,0,14,134,192]),function(re,e,o,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FC=void 0;class M{constructor($,w,A,P,b,C,y,a,m){this.a=$,this.b=w,this.c=A,this.d=P,this.e=b,this.f=C,this.g=y,this.h=a,this.j=m}k($){const w=this.c+this.d+this.e,A=this.c+this.e;return w===0?$===1?`
`:`\r
`:A>w/2?`\r
`:`
`}create($){const w=this.k($),A=this.a;if(this.j&&(w===`\r
`&&(this.c>0||this.d>0)||w===`
`&&(this.c>0||this.e>0)))for(let b=0,C=A.length;b<C;b++){const y=A[b].buffer.replace(/\r\n|\r|\n/g,w),a=(0,R.$zC)(y);A[b]=new R.$CC(y,a)}const P=new I.$EC(A,this.b,w,this.f,this.g,this.h,this.j);return{textBuffer:P,disposable:P}}getFirstLineText($){return this.a[0].buffer.substr(0,$).split(/\r\n|\r|\n/)[0]}}class O{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk($){if($.length===0)return;this.a.length===0&&o.$Jf($)&&(this.b=o.$If,$=$.substr(1));const w=$.charCodeAt($.length-1);w===13||w>=55296&&w<=56319?(this.m($.substr(0,$.length-1),!1),this.c=!0,this.d=w):(this.m($,!1),this.c=!1,this.d=w)}m($,w){!w&&$.length===0||(this.c?this.n(String.fromCharCode(this.d)+$):this.n($))}n($){const w=(0,R.$AC)(this.e,$);this.a.push(new R.$CC($,w.lineStarts)),this.f+=w.cr,this.g+=w.lf,this.h+=w.crlf,w.isBasicASCII||(this.l=!1,this.j||(this.j=o.$zf($)),this.k||(this.k=o.$Cf($)))}finish($=!0){return this.o(),new M(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,$)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const $=this.a[this.a.length-1];$.buffer+=String.fromCharCode(this.d);const w=(0,R.$zC)($.buffer);$.lineStarts=w,this.d===13&&this.f++}}}e.$FC=O}),define(Ee[135],Ce([1,0,21,11]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xab=$,e.$Yab=A;var I;(function(P){P[P.Full=1]="Full",P[P.Delta=2]="Delta"})(I||(I={}));function M(P){for(let b=0,C=P.length;b<C;b+=4){const y=P[b+0],a=P[b+1],m=P[b+2],l=P[b+3];P[b+0]=l,P[b+1]=m,P[b+2]=a,P[b+3]=y}}function O(P){const b=new Uint8Array(P.buffer,P.byteOffset,P.length*4);return R.$x()||M(b),o.$ue.wrap(b)}function p(P){const b=P.buffer;if(R.$x()||M(b),b.byteOffset%4===0)return new Uint32Array(b.buffer,b.byteOffset,b.length/4);{const C=new Uint8Array(b.byteLength);return C.set(b),new Uint32Array(C.buffer,C.byteOffset,C.length/4)}}function $(P){const b=new Uint32Array(w(P));let C=0;if(b[C++]=P.id,P.type==="full")b[C++]=1,b[C++]=P.data.length,b.set(P.data,C),C+=P.data.length;else{b[C++]=2,b[C++]=P.deltas.length;for(const y of P.deltas)b[C++]=y.start,b[C++]=y.deleteCount,y.data?(b[C++]=y.data.length,b.set(y.data,C),C+=y.data.length):b[C++]=0}return O(b)}function w(P){let b=0;if(b+=2,P.type==="full")b+=1+P.data.length;else{b+=1,b+=3*P.deltas.length;for(const C of P.deltas)C.data&&(b+=C.data.length)}return b}function A(P){const b=p(P);let C=0;const y=b[C++];if(b[C++]===1){const i=b[C++],n=b.subarray(C,C+i);return C+=i,{id:y,type:"full",data:n}}const m=b[C++],l=[];for(let i=0;i<m;i++){const n=b[C++],r=b[C++],s=b[C++];let t;s>0&&(t=b.subarray(C,C+s),C+=s),l[i]={start:n,deleteCount:r,data:t}}return{id:y,type:"delta",deltas:l}}}),define(Ee[194],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$r0=e.$q0=void 0;class o{constructor(){this.a=new Map}removeDragOperationTransfer(M){if(M&&this.a.has(M)){const O=this.a.get(M);return this.a.delete(M),O}}addDragOperationTransfer(M,O){this.a.set(M,O)}}e.$q0=o;class R{constructor(M){this.identifier=M}}e.$r0=R}),define(Ee[195],Ce([1,0,4,3]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ot=void 0;class I{constructor(){this.a=new Map,this.b=new Map,this.c=new o.$7d,this.onDidChange=this.c.event,this.d=null}handleChange(p){this.c.fire({changedLanguages:p,changedColorMap:!1})}register(p,$){return this.a.set(p,$),this.handleChange([p]),(0,R.$Sc)(()=>{this.a.get(p)===$&&(this.a.delete(p),this.handleChange([p]))})}get(p){return this.a.get(p)||null}registerFactory(p,$){this.b.get(p)?.dispose();const w=new M(this,p,$);return this.b.set(p,w),(0,R.$Sc)(()=>{const A=this.b.get(p);!A||A!==w||(this.b.delete(p),A.dispose())})}async getOrCreate(p){const $=this.get(p);if($)return $;const w=this.b.get(p);return!w||w.isResolved?null:(await w.resolve(),this.get(p))}isResolved(p){if(this.get(p))return!0;const w=this.b.get(p);return!!(!w||w.isResolved)}setColorMap(p){this.d=p,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$Ot=I;class M extends R.$Uc{get isResolved(){return this.c}constructor(p,$,w){super(),this.f=p,this.g=$,this.h=w,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const p=await this.h.tokenizationSupport;this.c=!0,p&&!this.a&&this.B(this.f.register(this.g,p))}}}),define(Ee[196],Ce([9,10]),function(re,e){return re.create("vs/base/common/actions",e)}),define(Ee[197],Ce([1,0,4,3,196]),function(re,e,o,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=void 0,e.$5i=A;class M extends R.$Uc{constructor(b,C="",y="",a=!0,m){super(),this.h=this.B(new o.$7d),this.onDidChange=this.h.event,this.w=!0,this.j=b,this.m=C,this.u=y,this.w=a,this.C=m}get id(){return this.j}get label(){return this.m}set label(b){this.D(b)}D(b){this.m!==b&&(this.m=b,this.h.fire({label:b}))}get tooltip(){return this.n||""}set tooltip(b){this.F(b)}F(b){this.n!==b&&(this.n=b,this.h.fire({tooltip:b}))}get class(){return this.u}set class(b){this.G(b)}G(b){this.u!==b&&(this.u=b,this.h.fire({class:b}))}get enabled(){return this.w}set enabled(b){this.H(b)}H(b){this.w!==b&&(this.w=b,this.h.fire({enabled:b}))}get checked(){return this.z}set checked(b){this.I(b)}I(b){this.z!==b&&(this.z=b,this.h.fire({checked:b}))}async run(b,C){this.C&&await this.C(b)}}e.$Zi=M;class O extends R.$Uc{constructor(){super(...arguments),this.f=this.B(new o.$7d),this.onWillRun=this.f.event,this.m=this.B(new o.$7d),this.onDidRun=this.m.event}async run(b,C){if(!b.enabled)return;this.f.fire({action:b});let y;try{await this.u(b,C)}catch(a){y=a}this.m.fire({action:b,error:y})}async u(b,C){await b.run(C)}}e.$1i=O;class p{constructor(){this.id=p.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...b){let C=[];for(const y of b)y.length&&(C.length?C=[...C,new p,...y]:C=y);return C}async run(){}}e.$2i=p,p.ID="vs.actions.separator";class ${get actions(){return this.a}constructor(b,C,y,a){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=b,this.label=C,this.class=a,this.a=y}async run(){}}e.$3i=$;class w extends M{constructor(){super(w.ID,I.localize(0,null),void 0,!1)}}e.$4i=w,w.ID="vs.actions.empty";function A(P){return{id:P.id,label:P.label,class:P.class,enabled:P.enabled??!0,checked:P.checked,run:async(...b)=>P.run(...b),tooltip:P.label}}}),define(Ee[198],Ce([9,10]),function(re,e){return re.create("vs/base/common/date",e)}),define(Ee[199],Ce([1,0,198]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Om=w,e.$Pm=A,e.$Qm=P;const R=60,I=R*60,M=I*24,O=M*7,p=M*30,$=M*365;function w(b,C,y,a){typeof b!="number"&&(b=b.getTime());const m=Math.round((new Date().getTime()-b)/1e3);if(m<-30)return(0,o.localize)(0,null,w(new Date().getTime()+m*1e3,!1));if(!a&&m<30)return(0,o.localize)(1,null);let l;return m<R?(l=m,C?l===1?y?(0,o.localize)(2,null,l):(0,o.localize)(3,null,l):y?(0,o.localize)(4,null,l):(0,o.localize)(5,null,l):l===1?y?(0,o.localize)(6,null,l):(0,o.localize)(7,null,l):y?(0,o.localize)(8,null,l):(0,o.localize)(9,null,l)):m<I?(l=Math.floor(m/R),C?l===1?y?(0,o.localize)(10,null,l):(0,o.localize)(11,null,l):y?(0,o.localize)(12,null,l):(0,o.localize)(13,null,l):l===1?y?(0,o.localize)(14,null,l):(0,o.localize)(15,null,l):y?(0,o.localize)(16,null,l):(0,o.localize)(17,null,l)):m<M?(l=Math.floor(m/I),C?l===1?y?(0,o.localize)(18,null,l):(0,o.localize)(19,null,l):y?(0,o.localize)(20,null,l):(0,o.localize)(21,null,l):l===1?y?(0,o.localize)(22,null,l):(0,o.localize)(23,null,l):y?(0,o.localize)(24,null,l):(0,o.localize)(25,null,l)):m<O?(l=Math.floor(m/M),C?l===1?(0,o.localize)(26,null,l):(0,o.localize)(27,null,l):l===1?(0,o.localize)(28,null,l):(0,o.localize)(29,null,l)):m<p?(l=Math.floor(m/O),C?l===1?y?(0,o.localize)(30,null,l):(0,o.localize)(31,null,l):y?(0,o.localize)(32,null,l):(0,o.localize)(33,null,l):l===1?y?(0,o.localize)(34,null,l):(0,o.localize)(35,null,l):y?(0,o.localize)(36,null,l):(0,o.localize)(37,null,l)):m<$?(l=Math.floor(m/p),C?l===1?y?(0,o.localize)(38,null,l):(0,o.localize)(39,null,l):y?(0,o.localize)(40,null,l):(0,o.localize)(41,null,l):l===1?y?(0,o.localize)(42,null,l):(0,o.localize)(43,null,l):y?(0,o.localize)(44,null,l):(0,o.localize)(45,null,l)):(l=Math.floor(m/$),C?l===1?y?(0,o.localize)(46,null,l):(0,o.localize)(47,null,l):y?(0,o.localize)(48,null,l):(0,o.localize)(49,null,l):l===1?y?(0,o.localize)(50,null,l):(0,o.localize)(51,null,l):y?(0,o.localize)(52,null,l):(0,o.localize)(53,null,l))}function A(b,C){const y=Math.abs(b/1e3);return y<1?C?(0,o.localize)(54,null,b):(0,o.localize)(55,null,b):y<R?C?(0,o.localize)(56,null,Math.round(b)/1e3):(0,o.localize)(57,null,Math.round(b)/1e3):y<I?C?(0,o.localize)(58,null,Math.round(b/(1e3*R))):(0,o.localize)(59,null,Math.round(b/(1e3*R))):y<M?C?(0,o.localize)(60,null,Math.round(b/(1e3*I))):(0,o.localize)(61,null,Math.round(b/(1e3*I))):(0,o.localize)(62,null,Math.round(b/(1e3*M)))}function P(b){return b.getFullYear()+"-"+String(b.getMonth()+1).padStart(2,"0")+"-"+String(b.getDate()).padStart(2,"0")+"T"+String(b.getHours()).padStart(2,"0")+":"+String(b.getMinutes()).padStart(2,"0")+":"+String(b.getSeconds()).padStart(2,"0")+"."+(b.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Ee[200],Ce([9,10]),function(re,e){return re.create("vs/base/common/errorMessage",e)}),define(Ee[47],Ce([1,0,19,18,200]),function(re,e,o,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6i=$,e.$7i=w,e.$8i=A;function M(P,b){return b&&(P.stack||P.stacktrace)?I.localize(0,null,p(P),O(P.stack)||O(P.stacktrace)):p(P)}function O(P){return Array.isArray(P)?P.join(`
`):P}function p(P){return P.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${P.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?I.localize(1,null,P.message):P.message||I.localize(2,null)}function $(P=null,b=!1){if(!P)return I.localize(3,null);if(Array.isArray(P)){const C=o.$Hb(P),y=$(C[0],b);return C.length>1?I.localize(4,null,y,C.length):y}if(R.$Vf(P))return P;if(P.detail){const C=P.detail;if(C.error)return M(C.error,b);if(C.exception)return M(C.exception,b)}return P.stack?M(P,b):P.message?P.message:I.localize(5,null)}function w(P){const b=P;return b instanceof Error&&Array.isArray(b.actions)}function A(P,b){let C;return typeof P=="string"?C=new Error(P):C=P,C.actions=b,C}}),define(Ee[201],Ce([9,10]),function(re,e){return re.create("vs/editor/common/config/editorOptions",e)}),define(Ee[136],Ce([1,0,19,24,11,184,133,201]),function(re,e,o,R,I,M,O,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=m,e.clampedInt=i,e.clampedFloat=r,e.stringSet=g,e.cursorStyleToString=k,e.filterValidationDecorations=de;var $;(function(ae){ae[ae.None=0]="None",ae[ae.Keep=1]="Keep",ae[ae.Brackets=2]="Brackets",ae[ae.Advanced=3]="Advanced",ae[ae.Full=4]="Full"})($||(e.EditorAutoIndentStrategy=$={})),e.MINIMAP_GUTTER_WIDTH=8;class w{constructor(ue){this.c=ue}hasChanged(ue){return this.c[ue]}}e.ConfigurationChangedEvent=w;class A{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=A;class P{constructor(ue,De,Je,et){this.id=ue,this.name=De,this.defaultValue=Je,this.schema=et}applyUpdate(ue,De){return C(ue,De)}compute(ue,De,Je){return Je}}class b{constructor(ue,De){this.newValue=ue,this.didChange=De}}e.ApplyUpdateResult=b;function C(ae,ue){if(typeof ae!="object"||typeof ue!="object"||!ae||!ue)return new b(ue,ae!==ue);if(Array.isArray(ae)||Array.isArray(ue)){const Je=Array.isArray(ae)&&Array.isArray(ue)&&o.$ub(ae,ue);return new b(ue,!Je)}let De=!1;for(const Je in ue)if(ue.hasOwnProperty(Je)){const et=C(ae[Je],ue[Je]);et.didChange&&(ae[Je]=et.newValue,De=!0)}return new b(ae,De)}class y{constructor(ue){this.schema=void 0,this.id=ue,this.name="_never_",this.defaultValue=void 0}applyUpdate(ue,De){return C(ue,De)}validate(ue){return this.defaultValue}}class a{constructor(ue,De,Je,et){this.id=ue,this.name=De,this.defaultValue=Je,this.schema=et}applyUpdate(ue,De){return C(ue,De)}validate(ue){return typeof ue>"u"?this.defaultValue:ue}compute(ue,De,Je){return Je}}function m(ae,ue){return typeof ae>"u"?ue:ae==="false"?!1:!!ae}class l extends a{constructor(ue,De,Je,et=void 0){typeof et<"u"&&(et.type="boolean",et.default=Je),super(ue,De,Je,et)}validate(ue){return m(ue,this.defaultValue)}}function i(ae,ue,De,Je){if(typeof ae>"u")return ue;let et=parseInt(ae,10);return isNaN(et)?ue:(et=Math.max(De,et),et=Math.min(Je,et),et|0)}class n extends a{static clampedInt(ue,De,Je,et){return i(ue,De,Je,et)}constructor(ue,De,Je,et,Ne,ht=void 0){typeof ht<"u"&&(ht.type="integer",ht.default=Je,ht.minimum=et,ht.maximum=Ne),super(ue,De,Je,ht),this.minimum=et,this.maximum=Ne}validate(ue){return n.clampedInt(ue,this.defaultValue,this.minimum,this.maximum)}}function r(ae,ue,De,Je){if(typeof ae>"u")return ue;const et=s.float(ae,ue);return s.clamp(et,De,Je)}class s extends a{static clamp(ue,De,Je){return ue<De?De:ue>Je?Je:ue}static float(ue,De){if(typeof ue=="number")return ue;if(typeof ue>"u")return De;const Je=parseFloat(ue);return isNaN(Je)?De:Je}constructor(ue,De,Je,et,Ne){typeof Ne<"u"&&(Ne.type="number",Ne.default=Je),super(ue,De,Je,Ne),this.validationFn=et}validate(ue){return this.validationFn(s.float(ue,this.defaultValue))}}class t extends a{static string(ue,De){return typeof ue!="string"?De:ue}constructor(ue,De,Je,et=void 0){typeof et<"u"&&(et.type="string",et.default=Je),super(ue,De,Je,et)}validate(ue){return t.string(ue,this.defaultValue)}}function g(ae,ue,De,Je){return typeof ae!="string"?ue:Je&&ae in Je?Je[ae]:De.indexOf(ae)===-1?ue:ae}class d extends a{constructor(ue,De,Je,et,Ne=void 0){typeof Ne<"u"&&(Ne.type="string",Ne.enum=et,Ne.default=Je),super(ue,De,Je,Ne),this.c=et}validate(ue){return g(ue,this.defaultValue,this.c)}}class h extends P{constructor(ue,De,Je,et,Ne,ht,vt=void 0){typeof vt<"u"&&(vt.type="string",vt.enum=Ne,vt.default=et),super(ue,De,Je,vt),this.c=Ne,this.d=ht}validate(ue){return typeof ue!="string"?this.defaultValue:this.c.indexOf(ue)===-1?this.defaultValue:this.d(ue)}}function c(ae){switch(ae){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class u extends P{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[p.localize(0,null),p.localize(1,null),p.localize(2,null)],default:"auto",tags:["accessibility"],description:p.localize(3,null)})}validate(ue){switch(ue){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ue,De,Je){return Je===0?ue.accessibilitySupport:Je}}class f extends P{constructor(){const ue={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",ue,{"editor.comments.insertSpace":{type:"boolean",default:ue.insertSpace,description:p.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ue.ignoreEmptyLines,description:p.localize(5,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const De=ue;return{insertSpace:m(De.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:m(De.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var E;(function(ae){ae[ae.Hidden=0]="Hidden",ae[ae.Blink=1]="Blink",ae[ae.Smooth=2]="Smooth",ae[ae.Phase=3]="Phase",ae[ae.Expand=4]="Expand",ae[ae.Solid=5]="Solid"})(E||(e.TextEditorCursorBlinkingStyle=E={}));function v(ae){switch(ae){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var D;(function(ae){ae[ae.Line=1]="Line",ae[ae.Block=2]="Block",ae[ae.Underline=3]="Underline",ae[ae.LineThin=4]="LineThin",ae[ae.BlockOutline=5]="BlockOutline",ae[ae.UnderlineThin=6]="UnderlineThin"})(D||(e.TextEditorCursorStyle=D={}));function k(ae){switch(ae){case D.Line:return"line";case D.Block:return"block";case D.Underline:return"underline";case D.LineThin:return"line-thin";case D.BlockOutline:return"block-outline";case D.UnderlineThin:return"underline-thin"}}function S(ae){switch(ae){case"line":return D.Line;case"block":return D.Block;case"underline":return D.Underline;case"line-thin":return D.LineThin;case"block-outline":return D.BlockOutline;case"underline-thin":return D.UnderlineThin}}class F extends y{constructor(){super(142)}compute(ue,De,Je){const et=["monaco-editor"];return De.get(39)&&et.push(De.get(39)),ue.extraEditorClassName&&et.push(ue.extraEditorClassName),De.get(74)==="default"?et.push("mouse-default"):De.get(74)==="copy"&&et.push("mouse-copy"),De.get(111)&&et.push("showUnused"),De.get(140)&&et.push("showDeprecated"),et.join(" ")}}class W extends l{constructor(){super(37,"emptySelectionClipboard",!0,{description:p.localize(6,null)})}compute(ue,De,Je){return Je&&ue.emptySelectionClipboard}}class B extends P{constructor(){const ue={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",ue,{"editor.find.cursorMoveOnType":{type:"boolean",default:ue.cursorMoveOnType,description:p.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:ue.seedSearchStringFromSelection,enumDescriptions:[p.localize(8,null),p.localize(9,null),p.localize(10,null)],description:p.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ue.autoFindInSelection,enumDescriptions:[p.localize(12,null),p.localize(13,null),p.localize(14,null)],description:p.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ue.globalFindClipboard,description:p.localize(16,null),included:I.$d},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ue.addExtraSpaceOnTop,description:p.localize(17,null)},"editor.find.loop":{type:"boolean",default:ue.loop,description:p.localize(18,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const De=ue;return{cursorMoveOnType:m(De.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof ue.seedSearchStringFromSelection=="boolean"?ue.seedSearchStringFromSelection?"always":"never":g(De.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof ue.autoFindInSelection=="boolean"?ue.autoFindInSelection?"always":"never":g(De.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:m(De.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:m(De.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:m(De.loop,this.defaultValue.loop)}}}class T extends P{constructor(){super(51,"fontLigatures",T.OFF,{anyOf:[{type:"boolean",description:p.localize(19,null)},{type:"string",description:p.localize(20,null)}],description:p.localize(21,null),default:!1})}validate(ue){return typeof ue>"u"?this.defaultValue:typeof ue=="string"?ue==="false"||ue.length===0?T.OFF:ue==="true"?T.ON:ue:ue?T.ON:T.OFF}}e.EditorFontLigatures=T,T.OFF='"liga" off, "calt" off',T.ON='"liga" on, "calt" on';class N extends P{constructor(){super(54,"fontVariations",N.OFF,{anyOf:[{type:"boolean",description:p.localize(22,null)},{type:"string",description:p.localize(23,null)}],description:p.localize(24,null),default:!1})}validate(ue){return typeof ue>"u"?this.defaultValue:typeof ue=="string"?ue==="false"?N.OFF:ue==="true"?N.TRANSLATE:ue:ue?N.TRANSLATE:N.OFF}compute(ue,De,Je){return ue.fontInfo.fontVariationSettings}}e.EditorFontVariations=N,N.OFF="normal",N.TRANSLATE="translate";class j extends y{constructor(){super(50)}compute(ue,De,Je){return ue.fontInfo}}class L extends a{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:p.localize(25,null)})}validate(ue){const De=s.float(ue,this.defaultValue);return De===0?e.EDITOR_FONT_DEFAULTS.fontSize:s.clamp(De,6,100)}compute(ue,De,Je){return ue.fontInfo.fontSize}}class z extends P{constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:z.d,maximum:z.e,errorMessage:p.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:z.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:p.localize(27,null)})}validate(ue){return ue==="normal"||ue==="bold"?ue:String(n.clampedInt(ue,e.EDITOR_FONT_DEFAULTS.fontWeight,z.d,z.e))}}z.c=["normal","bold","100","200","300","400","500","600","700","800","900"],z.d=1,z.e=1e3;class Q extends P{constructor(){const ue={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},De={type:"string",enum:["peek","gotoAndPeek","goto"],default:ue.multiple,enumDescriptions:[p.localize(28,null),p.localize(29,null),p.localize(30,null)]},Je=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",ue,{"editor.gotoLocation.multiple":{deprecationMessage:p.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:p.localize(32,null),...De},"editor.gotoLocation.multipleTypeDefinitions":{description:p.localize(33,null),...De},"editor.gotoLocation.multipleDeclarations":{description:p.localize(34,null),...De},"editor.gotoLocation.multipleImplementations":{description:p.localize(35,null),...De},"editor.gotoLocation.multipleReferences":{description:p.localize(36,null),...De},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ue.alternativeDefinitionCommand,enum:Je,description:p.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ue.alternativeTypeDefinitionCommand,enum:Je,description:p.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ue.alternativeDeclarationCommand,enum:Je,description:p.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ue.alternativeImplementationCommand,enum:Je,description:p.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ue.alternativeReferenceCommand,enum:Je,description:p.localize(41,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const De=ue;return{multiple:g(De.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:De.multipleDefinitions??g(De.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:De.multipleTypeDefinitions??g(De.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:De.multipleDeclarations??g(De.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:De.multipleImplementations??g(De.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:De.multipleReferences??g(De.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(De.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(De.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(De.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(De.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(De.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class Y extends P{constructor(){const ue={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",ue,{"editor.hover.enabled":{type:"boolean",default:ue.enabled,description:p.localize(42,null)},"editor.hover.delay":{type:"number",default:ue.delay,minimum:0,maximum:1e4,description:p.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:ue.sticky,description:p.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:ue.hidingDelay,description:p.localize(45,null)},"editor.hover.above":{type:"boolean",default:ue.above,description:p.localize(46,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const De=ue;return{enabled:m(De.enabled,this.defaultValue.enabled),delay:n.clampedInt(De.delay,this.defaultValue.delay,0,1e4),sticky:m(De.sticky,this.defaultValue.sticky),hidingDelay:n.clampedInt(De.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:m(De.above,this.defaultValue.above)}}}var J;(function(ae){ae[ae.None=0]="None",ae[ae.Text=1]="Text",ae[ae.Blocks=2]="Blocks"})(J||(e.RenderMinimap=J={}));class x extends y{constructor(){super(145)}compute(ue,De,Je){return x.computeLayout(De,{memory:ue.memory,outerWidth:ue.outerWidth,outerHeight:ue.outerHeight,isDominatedByLongLines:ue.isDominatedByLongLines,lineHeight:ue.fontInfo.lineHeight,viewLineCount:ue.viewLineCount,lineNumbersDigitCount:ue.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ue.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ue.fontInfo.maxDigitWidth,pixelRatio:ue.pixelRatio,glyphMarginDecorationLaneCount:ue.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(ue){const De=ue.height/ue.lineHeight,Je=Math.floor(ue.paddingTop/ue.lineHeight);let et=Math.floor(ue.paddingBottom/ue.lineHeight);ue.scrollBeyondLastLine&&(et=Math.max(et,De-1));const Ne=(Je+ue.viewLineCount+et)/(ue.pixelRatio*ue.height),ht=Math.floor(ue.viewLineCount/Ne);return{typicalViewportLineCount:De,extraLinesBeforeFirstLine:Je,extraLinesBeyondLastLine:et,desiredRatio:Ne,minimapLineCount:ht}}static c(ue,De){const Je=ue.outerWidth,et=ue.outerHeight,Ne=ue.pixelRatio;if(!ue.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ne*et),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:et};const ht=De.stableMinimapLayoutInput,vt=ht&&ue.outerHeight===ht.outerHeight&&ue.lineHeight===ht.lineHeight&&ue.typicalHalfwidthCharacterWidth===ht.typicalHalfwidthCharacterWidth&&ue.pixelRatio===ht.pixelRatio&&ue.scrollBeyondLastLine===ht.scrollBeyondLastLine&&ue.paddingTop===ht.paddingTop&&ue.paddingBottom===ht.paddingBottom&&ue.minimap.enabled===ht.minimap.enabled&&ue.minimap.side===ht.minimap.side&&ue.minimap.size===ht.minimap.size&&ue.minimap.showSlider===ht.minimap.showSlider&&ue.minimap.renderCharacters===ht.minimap.renderCharacters&&ue.minimap.maxColumn===ht.minimap.maxColumn&&ue.minimap.scale===ht.minimap.scale&&ue.verticalScrollbarWidth===ht.verticalScrollbarWidth&&ue.isViewportWrapping===ht.isViewportWrapping,Mt=ue.lineHeight,zt=ue.typicalHalfwidthCharacterWidth,Zt=ue.scrollBeyondLastLine,xt=ue.minimap.renderCharacters;let Pt=Ne>=2?Math.round(ue.minimap.scale*2):ue.minimap.scale;const sn=ue.minimap.maxColumn,_t=ue.minimap.size,dn=ue.minimap.side,tt=ue.verticalScrollbarWidth,on=ue.viewLineCount,Gt=ue.remainingWidth,Kt=ue.isViewportWrapping,gt=xt?2:3;let bt=Math.floor(Ne*et);const Xt=bt/Ne;let Bt=!1,Vt=!1,$t=gt*Pt,Rt=Pt/Ne,cn=1;if(_t==="fill"||_t==="fit"){const{typicalViewportLineCount:Ut,extraLinesBeforeFirstLine:Tt,extraLinesBeyondLastLine:Ot,desiredRatio:un,minimapLineCount:Wt}=x.computeContainedMinimapLineCount({viewLineCount:on,scrollBeyondLastLine:Zt,paddingTop:ue.paddingTop,paddingBottom:ue.paddingBottom,height:et,lineHeight:Mt,pixelRatio:Ne});if(on/Wt>1)Bt=!0,Vt=!0,Pt=1,$t=1,Rt=Pt/Ne;else{let It=!1,Ft=Pt+1;if(_t==="fit"){const rn=Math.ceil((Tt+on+Ot)*$t);Kt&&vt&&Gt<=De.stableFitRemainingWidth?(It=!0,Ft=De.stableFitMaxMinimapScale):It=rn>bt}if(_t==="fill"||It){Bt=!0;const rn=Pt;$t=Math.min(Mt*Ne,Math.max(1,Math.floor(1/un))),Kt&&vt&&Gt<=De.stableFitRemainingWidth&&(Ft=De.stableFitMaxMinimapScale),Pt=Math.min(Ft,Math.max(1,Math.floor($t/gt))),Pt>rn&&(cn=Math.min(2,Pt/rn)),Rt=Pt/Ne/cn,bt=Math.ceil(Math.max(Ut,Tt+on+Ot)*$t),Kt?(De.stableMinimapLayoutInput=ue,De.stableFitRemainingWidth=Gt,De.stableFitMaxMinimapScale=Pt):(De.stableMinimapLayoutInput=null,De.stableFitRemainingWidth=0)}}}const en=Math.floor(sn*Rt),Xe=Math.min(en,Math.max(0,Math.floor((Gt-tt-2)*Rt/(zt+Rt)))+e.MINIMAP_GUTTER_WIDTH);let Yt=Math.floor(Ne*Xe);const tn=Yt/Ne;Yt=Math.floor(Yt*cn);const nn=xt?1:2,yt=dn==="left"?0:Je-Xe-tt;return{renderMinimap:nn,minimapLeft:yt,minimapWidth:Xe,minimapHeightIsEditorHeight:Bt,minimapIsSampling:Vt,minimapScale:Pt,minimapLineHeight:$t,minimapCanvasInnerWidth:Yt,minimapCanvasInnerHeight:bt,minimapCanvasOuterWidth:tn,minimapCanvasOuterHeight:Xt}}static computeLayout(ue,De){const Je=De.outerWidth|0,et=De.outerHeight|0,Ne=De.lineHeight|0,ht=De.lineNumbersDigitCount|0,vt=De.typicalHalfwidthCharacterWidth,Mt=De.maxDigitWidth,zt=De.pixelRatio,Zt=De.viewLineCount,xt=ue.get(137),Pt=xt==="inherit"?ue.get(136):xt,sn=Pt==="inherit"?ue.get(132):Pt,_t=ue.get(135),dn=De.isDominatedByLongLines,tt=ue.get(57),on=ue.get(68).renderType!==0,Gt=ue.get(69),Kt=ue.get(105),gt=ue.get(84),bt=ue.get(73),Xt=ue.get(103),Bt=Xt.verticalScrollbarSize,Vt=Xt.verticalHasArrows,$t=Xt.arrowSize,Rt=Xt.horizontalScrollbarSize,cn=ue.get(43),en=ue.get(110)!=="never";let Xe=ue.get(66);cn&&en&&(Xe+=16);let Yt=0;if(on){const Et=Math.max(ht,Gt);Yt=Math.round(Et*Mt)}let tn=0;tt&&(tn=Ne*De.glyphMarginDecorationLaneCount);let nn=0,yt=nn+tn,Ut=yt+Yt,Tt=Ut+Xe;const Ot=Je-tn-Yt-Xe;let un=!1,Wt=!1,Ht=-1;Pt==="inherit"&&dn?(un=!0,Wt=!0):sn==="on"||sn==="bounded"?Wt=!0:sn==="wordWrapColumn"&&(Ht=_t);const It=x.c({outerWidth:Je,outerHeight:et,lineHeight:Ne,typicalHalfwidthCharacterWidth:vt,pixelRatio:zt,scrollBeyondLastLine:Kt,paddingTop:gt.top,paddingBottom:gt.bottom,minimap:bt,verticalScrollbarWidth:Bt,viewLineCount:Zt,remainingWidth:Ot,isViewportWrapping:Wt},De.memory||new A);It.renderMinimap!==0&&It.minimapLeft===0&&(nn+=It.minimapWidth,yt+=It.minimapWidth,Ut+=It.minimapWidth,Tt+=It.minimapWidth);const Ft=Ot-It.minimapWidth,rn=Math.max(1,Math.floor((Ft-Bt-2)/vt)),At=Vt?$t:0;return Wt&&(Ht=Math.max(1,rn),sn==="bounded"&&(Ht=Math.min(Ht,_t))),{width:Je,height:et,glyphMarginLeft:nn,glyphMarginWidth:tn,glyphMarginDecorationLaneCount:De.glyphMarginDecorationLaneCount,lineNumbersLeft:yt,lineNumbersWidth:Yt,decorationsLeft:Ut,decorationsWidth:Xe,contentLeft:Tt,contentWidth:Ft,minimap:It,viewportColumn:rn,isWordWrapMinified:un,isViewportWrapping:Wt,wrappingColumn:Ht,verticalScrollbarWidth:Bt,horizontalScrollbarHeight:Rt,overviewRuler:{top:At,width:Bt,height:et-2*At,right:0}}}}e.EditorLayoutInfoComputer=x;class ce extends P{constructor(){super(139,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[p.localize(47,null),p.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:p.localize(49,null)}})}validate(ue){return g(ue,"simple",["simple","advanced"])}compute(ue,De,Je){return De.get(2)===2?"advanced":Je}}var te;(function(ae){ae.Off="off",ae.OnCode="onCode",ae.On="on"})(te||(e.ShowLightbulbIconMode=te={}));class pe extends P{constructor(){const ue={enabled:te.On};super(65,"lightbulb",ue,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[te.Off,te.OnCode,te.On],default:ue.enabled,enumDescriptions:[p.localize(50,null),p.localize(51,null),p.localize(52,null)],description:p.localize(53,null)}})}validate(ue){return!ue||typeof ue!="object"?this.defaultValue:{enabled:g(ue.enabled,this.defaultValue.enabled,[te.Off,te.OnCode,te.On])}}}class ye extends P{constructor(){const ue={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",ue,{"editor.stickyScroll.enabled":{type:"boolean",default:ue.enabled,description:p.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:ue.maxLineCount,minimum:1,maximum:20,description:p.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:ue.defaultModel,description:p.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:ue.scrollWithEditor,description:p.localize(57,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const De=ue;return{enabled:m(De.enabled,this.defaultValue.enabled),maxLineCount:n.clampedInt(De.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:g(De.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:m(De.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class _ extends P{constructor(){const ue={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(141,"inlayHints",ue,{"editor.inlayHints.enabled":{type:"string",default:ue.enabled,description:p.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[p.localize(59,null),p.localize(60,null,I.$d?"Ctrl+Option":"Ctrl+Alt"),p.localize(61,null,I.$d?"Ctrl+Option":"Ctrl+Alt"),p.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:ue.fontSize,markdownDescription:p.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:ue.fontFamily,markdownDescription:p.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:ue.padding,description:p.localize(65,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const De=ue;return typeof De.enabled=="boolean"&&(De.enabled=De.enabled?"on":"off"),{enabled:g(De.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:n.clampedInt(De.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(De.fontFamily,this.defaultValue.fontFamily),padding:m(De.padding,this.defaultValue.padding)}}}class U extends P{constructor(){super(66,"lineDecorationsWidth",10)}validate(ue){return typeof ue=="string"&&/^\d+(\.\d+)?ch$/.test(ue)?-parseFloat(ue.substring(0,ue.length-2)):n.clampedInt(ue,this.defaultValue,0,1e3)}compute(ue,De,Je){return Je<0?n.clampedInt(-Je*ue.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Je}}class he extends s{constructor(){super(67,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ue=>s.clamp(ue,0,150),{markdownDescription:p.localize(66,null)})}compute(ue,De,Je){return ue.fontInfo.lineHeight}}class Se extends P{constructor(){const ue={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9};super(73,"minimap",ue,{"editor.minimap.enabled":{type:"boolean",default:ue.enabled,description:p.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:ue.autohide,description:p.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[p.localize(69,null),p.localize(70,null),p.localize(71,null)],default:ue.size,description:p.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ue.side,description:p.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ue.showSlider,description:p.localize(74,null)},"editor.minimap.scale":{type:"number",default:ue.scale,minimum:1,maximum:3,enum:[1,2,3],description:p.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ue.renderCharacters,description:p.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:ue.maxColumn,description:p.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:ue.showRegionSectionHeaders,description:p.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:ue.showMarkSectionHeaders,description:p.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:ue.sectionHeaderFontSize,description:p.localize(80,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const De=ue;return{enabled:m(De.enabled,this.defaultValue.enabled),autohide:m(De.autohide,this.defaultValue.autohide),size:g(De.size,this.defaultValue.size,["proportional","fill","fit"]),side:g(De.side,this.defaultValue.side,["right","left"]),showSlider:g(De.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:m(De.renderCharacters,this.defaultValue.renderCharacters),scale:n.clampedInt(De.scale,1,1,3),maxColumn:n.clampedInt(De.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:m(De.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:m(De.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:s.clamp(De.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32)}}}function me(ae){return ae==="ctrlCmd"?I.$d?"metaKey":"ctrlKey":"altKey"}class ie extends P{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:p.localize(81,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:p.localize(82,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const De=ue;return{top:n.clampedInt(De.top,0,0,1e3),bottom:n.clampedInt(De.bottom,0,0,1e3)}}}class se extends P{constructor(){const ue={enabled:!0,cycle:!0};super(86,"parameterHints",ue,{"editor.parameterHints.enabled":{type:"boolean",default:ue.enabled,description:p.localize(83,null)},"editor.parameterHints.cycle":{type:"boolean",default:ue.cycle,description:p.localize(84,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const De=ue;return{enabled:m(De.enabled,this.defaultValue.enabled),cycle:m(De.cycle,this.defaultValue.cycle)}}}class oe extends y{constructor(){super(143)}compute(ue,De,Je){return ue.pixelRatio}}class G extends P{constructor(){const ue={other:"on",comments:"off",strings:"off"},De=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[p.localize(85,null),p.localize(86,null),p.localize(87,null)]}];super(89,"quickSuggestions",ue,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:De,default:ue.strings,description:p.localize(88,null)},comments:{anyOf:De,default:ue.comments,description:p.localize(89,null)},other:{anyOf:De,default:ue.other,description:p.localize(90,null)}},default:ue,markdownDescription:p.localize(91,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=ue}validate(ue){if(typeof ue=="boolean"){const zt=ue?"on":"off";return{comments:zt,strings:zt,other:zt}}if(!ue||typeof ue!="object")return this.defaultValue;const{other:De,comments:Je,strings:et}=ue,Ne=["on","inline","off"];let ht,vt,Mt;return typeof De=="boolean"?ht=De?"on":"off":ht=g(De,this.defaultValue.other,Ne),typeof Je=="boolean"?vt=Je?"on":"off":vt=g(Je,this.defaultValue.comments,Ne),typeof et=="boolean"?Mt=et?"on":"off":Mt=g(et,this.defaultValue.strings,Ne),{other:ht,comments:vt,strings:Mt}}}var ee;(function(ae){ae[ae.Off=0]="Off",ae[ae.On=1]="On",ae[ae.Relative=2]="Relative",ae[ae.Interval=3]="Interval",ae[ae.Custom=4]="Custom"})(ee||(e.RenderLineNumbersType=ee={}));class le extends P{constructor(){super(68,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[p.localize(92,null),p.localize(93,null),p.localize(94,null),p.localize(95,null)],default:"on",description:p.localize(96,null)})}validate(ue){let De=this.defaultValue.renderType,Je=this.defaultValue.renderFn;return typeof ue<"u"&&(typeof ue=="function"?(De=4,Je=ue):ue==="interval"?De=3:ue==="relative"?De=2:ue==="on"?De=1:De=0),{renderType:De,renderFn:Je}}}function de(ae){const ue=ae.get(98);return ue==="editable"?ae.get(91):ue!=="on"}class Me extends P{constructor(){const ue=[],De={type:"number",description:p.localize(97,null)};super(102,"rulers",ue,{type:"array",items:{anyOf:[De,{type:["object"],properties:{column:De,color:{type:"string",description:p.localize(98,null),format:"color-hex"}}}]},default:ue,description:p.localize(99,null)})}validate(ue){if(Array.isArray(ue)){const De=[];for(const Je of ue)if(typeof Je=="number")De.push({column:n.clampedInt(Je,0,0,1e4),color:null});else if(Je&&typeof Je=="object"){const et=Je;De.push({column:n.clampedInt(et.column,0,0,1e4),color:et.color})}return De.sort((Je,et)=>Je.column-et.column),De}return this.defaultValue}}class be extends P{constructor(){super(92,"readOnlyMessage",void 0)}validate(ue){return!ue||typeof ue!="object"?this.defaultValue:ue}}function Pe(ae,ue){if(typeof ae!="string")return ue;switch(ae){case"hidden":return 2;case"visible":return 3;default:return 1}}class Re extends P{constructor(){const ue={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",ue,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[p.localize(100,null),p.localize(101,null),p.localize(102,null)],default:"auto",description:p.localize(103,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[p.localize(104,null),p.localize(105,null),p.localize(106,null)],default:"auto",description:p.localize(107,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ue.verticalScrollbarSize,description:p.localize(108,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ue.horizontalScrollbarSize,description:p.localize(109,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ue.scrollByPage,description:p.localize(110,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:ue.ignoreHorizontalScrollbarInContentHeight,description:p.localize(111,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const De=ue,Je=n.clampedInt(De.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),et=n.clampedInt(De.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:n.clampedInt(De.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Pe(De.vertical,this.defaultValue.vertical),horizontal:Pe(De.horizontal,this.defaultValue.horizontal),useShadows:m(De.useShadows,this.defaultValue.useShadows),verticalHasArrows:m(De.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:m(De.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:m(De.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:m(De.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Je,horizontalSliderSize:n.clampedInt(De.horizontalSliderSize,Je,0,1e3),verticalScrollbarSize:et,verticalSliderSize:n.clampedInt(De.verticalSliderSize,et,0,1e3),scrollByPage:m(De.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:m(De.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class ze extends P{constructor(){const ue={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",ue,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ue.nonBasicASCII,description:p.localize(112,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:ue.invisibleCharacters,description:p.localize(113,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:ue.ambiguousCharacters,description:p.localize(114,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ue.includeComments,description:p.localize(115,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ue.includeStrings,description:p.localize(116,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:ue.allowedCharacters,description:p.localize(117,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:ue.allowedLocales,description:p.localize(118,null)}})}applyUpdate(ue,De){let Je=!1;De.allowedCharacters&&ue&&(R.$Tn(ue.allowedCharacters,De.allowedCharacters)||(ue={...ue,allowedCharacters:De.allowedCharacters},Je=!0)),De.allowedLocales&&ue&&(R.$Tn(ue.allowedLocales,De.allowedLocales)||(ue={...ue,allowedLocales:De.allowedLocales},Je=!0));const et=super.applyUpdate(ue,De);return Je?new b(et.newValue,!0):et}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const De=ue;return{nonBasicASCII:fe(De.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:m(De.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:m(De.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:fe(De.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:fe(De.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(ue.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(ue.allowedLocales,this.defaultValue.allowedLocales)}}c(ue,De){if(typeof ue!="object"||!ue)return De;const Je={};for(const[et,Ne]of Object.entries(ue))Ne===!0&&(Je[et]=!0);return Je}}class V extends P{constructor(){const ue={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",ue,{"editor.inlineSuggest.enabled":{type:"boolean",default:ue.enabled,description:p.localize(119,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:ue.showToolbar,enum:["always","onHover","never"],enumDescriptions:[p.localize(120,null),p.localize(121,null),p.localize(122,null)],description:p.localize(123,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:ue.suppressSuggestions,description:p.localize(124,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:ue.fontFamily,description:p.localize(125,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const De=ue;return{enabled:m(De.enabled,this.defaultValue.enabled),mode:g(De.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:g(De.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:m(De.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:m(De.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:t.string(De.fontFamily,this.defaultValue.fontFamily)}}}class H extends P{constructor(){const ue={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(63,"experimentalInlineEdit",ue,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:ue.enabled,description:p.localize(126,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:ue.showToolbar,enum:["always","onHover","never"],enumDescriptions:[p.localize(127,null),p.localize(128,null),p.localize(129,null)],description:p.localize(130,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:ue.fontFamily,description:p.localize(131,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:ue.backgroundColoring,description:p.localize(132,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const De=ue;return{enabled:m(De.enabled,this.defaultValue.enabled),showToolbar:g(De.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:t.string(De.fontFamily,this.defaultValue.fontFamily),keepOnBlur:m(De.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:m(De.backgroundColoring,this.defaultValue.backgroundColoring)}}}class Z extends P{constructor(){const ue={enabled:M.$Ns.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:M.$Ns.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",ue,{"editor.bracketPairColorization.enabled":{type:"boolean",default:ue.enabled,markdownDescription:p.localize(133,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:ue.independentColorPoolPerBracketType,description:p.localize(134,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const De=ue;return{enabled:m(De.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:m(De.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class X extends P{constructor(){const ue={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",ue,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[p.localize(135,null),p.localize(136,null),p.localize(137,null)],default:ue.bracketPairs,description:p.localize(138,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[p.localize(139,null),p.localize(140,null),p.localize(141,null)],default:ue.bracketPairsHorizontal,description:p.localize(142,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:ue.highlightActiveBracketPair,description:p.localize(143,null)},"editor.guides.indentation":{type:"boolean",default:ue.indentation,description:p.localize(144,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[p.localize(145,null),p.localize(146,null),p.localize(147,null)],default:ue.highlightActiveIndentation,description:p.localize(148,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const De=ue;return{bracketPairs:fe(De.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:fe(De.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:m(De.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:m(De.indentation,this.defaultValue.indentation),highlightActiveIndentation:fe(De.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function fe(ae,ue,De){const Je=De.indexOf(ae);return Je===-1?ue:De[Je]}class we extends P{constructor(){const ue={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",ue,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[p.localize(149,null),p.localize(150,null)],default:ue.insertMode,description:p.localize(151,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ue.filterGraceful,description:p.localize(152,null)},"editor.suggest.localityBonus":{type:"boolean",default:ue.localityBonus,description:p.localize(153,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ue.shareSuggestSelections,markdownDescription:p.localize(154,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[p.localize(155,null),p.localize(156,null),p.localize(157,null),p.localize(158,null)],default:ue.selectionMode,markdownDescription:p.localize(159,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ue.snippetsPreventQuickSuggestions,description:p.localize(160,null)},"editor.suggest.showIcons":{type:"boolean",default:ue.showIcons,description:p.localize(161,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ue.showStatusBar,description:p.localize(162,null)},"editor.suggest.preview":{type:"boolean",default:ue.preview,description:p.localize(163,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ue.showInlineDetails,description:p.localize(164,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:p.localize(165,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:p.localize(166,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:p.localize(167,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:p.localize(168,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:p.localize(169,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:p.localize(170,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:p.localize(171,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:p.localize(172,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:p.localize(173,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:p.localize(174,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:p.localize(175,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:p.localize(176,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:p.localize(177,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:p.localize(178,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:p.localize(179,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:p.localize(180,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:p.localize(181,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:p.localize(182,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:p.localize(183,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:p.localize(184,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:p.localize(185,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:p.localize(186,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:p.localize(187,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:p.localize(188,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:p.localize(189,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:p.localize(190,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:p.localize(191,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:p.localize(192,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:p.localize(193,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:p.localize(194,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:p.localize(195,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:p.localize(196,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const De=ue;return{insertMode:g(De.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:m(De.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:m(De.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:m(De.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:m(De.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:g(De.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:m(De.showIcons,this.defaultValue.showIcons),showStatusBar:m(De.showStatusBar,this.defaultValue.showStatusBar),preview:m(De.preview,this.defaultValue.preview),previewMode:g(De.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:m(De.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:m(De.showMethods,this.defaultValue.showMethods),showFunctions:m(De.showFunctions,this.defaultValue.showFunctions),showConstructors:m(De.showConstructors,this.defaultValue.showConstructors),showDeprecated:m(De.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:m(De.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:m(De.showFields,this.defaultValue.showFields),showVariables:m(De.showVariables,this.defaultValue.showVariables),showClasses:m(De.showClasses,this.defaultValue.showClasses),showStructs:m(De.showStructs,this.defaultValue.showStructs),showInterfaces:m(De.showInterfaces,this.defaultValue.showInterfaces),showModules:m(De.showModules,this.defaultValue.showModules),showProperties:m(De.showProperties,this.defaultValue.showProperties),showEvents:m(De.showEvents,this.defaultValue.showEvents),showOperators:m(De.showOperators,this.defaultValue.showOperators),showUnits:m(De.showUnits,this.defaultValue.showUnits),showValues:m(De.showValues,this.defaultValue.showValues),showConstants:m(De.showConstants,this.defaultValue.showConstants),showEnums:m(De.showEnums,this.defaultValue.showEnums),showEnumMembers:m(De.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:m(De.showKeywords,this.defaultValue.showKeywords),showWords:m(De.showWords,this.defaultValue.showWords),showColors:m(De.showColors,this.defaultValue.showColors),showFiles:m(De.showFiles,this.defaultValue.showFiles),showReferences:m(De.showReferences,this.defaultValue.showReferences),showFolders:m(De.showFolders,this.defaultValue.showFolders),showTypeParameters:m(De.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:m(De.showSnippets,this.defaultValue.showSnippets),showUsers:m(De.showUsers,this.defaultValue.showUsers),showIssues:m(De.showIssues,this.defaultValue.showIssues)}}}class Te extends P{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:p.localize(197,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:p.localize(198,null),default:!0,type:"boolean"}})}validate(ue){return!ue||typeof ue!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:m(ue.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:m(ue.selectSubwords,this.defaultValue.selectSubwords)}}}class Ve extends P{constructor(){const ue=[];super(130,"wordSegmenterLocales",ue,{anyOf:[{description:p.localize(199,null),type:"string"},{description:p.localize(200,null),type:"array",items:{type:"string"}}]})}validate(ue){if(typeof ue=="string"&&(ue=[ue]),Array.isArray(ue)){const De=[];for(const Je of ue)if(typeof Je=="string")try{Intl.Segmenter.supportedLocalesOf(Je).length>0&&De.push(Je)}catch{}return De}return this.defaultValue}}var Ze;(function(ae){ae[ae.None=0]="None",ae[ae.Same=1]="Same",ae[ae.Indent=2]="Indent",ae[ae.DeepIndent=3]="DeepIndent"})(Ze||(e.WrappingIndent=Ze={}));class nt extends P{constructor(){super(138,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[p.localize(201,null),p.localize(202,null),p.localize(203,null),p.localize(204,null)],description:p.localize(205,null),default:"same"}})}validate(ue){switch(ue){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(ue,De,Je){return De.get(2)===2?0:Je}}class ot extends y{constructor(){super(146)}compute(ue,De,Je){const et=De.get(145);return{isDominatedByLongLines:ue.isDominatedByLongLines,isWordWrapMinified:et.isWordWrapMinified,isViewportWrapping:et.isViewportWrapping,wrappingColumn:et.wrappingColumn}}}class lt extends P{constructor(){const ue={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",ue,{"editor.dropIntoEditor.enabled":{type:"boolean",default:ue.enabled,markdownDescription:p.localize(206,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:p.localize(207,null),enum:["afterDrop","never"],enumDescriptions:[p.localize(208,null),p.localize(209,null)],default:"afterDrop"}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const De=ue;return{enabled:m(De.enabled,this.defaultValue.enabled),showDropSelector:g(De.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class at extends P{constructor(){const ue={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",ue,{"editor.pasteAs.enabled":{type:"boolean",default:ue.enabled,markdownDescription:p.localize(210,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:p.localize(211,null),enum:["afterPaste","never"],enumDescriptions:[p.localize(212,null),p.localize(213,null)],default:"afterPaste"}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const De=ue;return{enabled:m(De.enabled,this.defaultValue.enabled),showPasteSelector:g(De.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const st="Consolas, 'Courier New', monospace",Ie="Menlo, Monaco, 'Courier New', monospace",We="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:I.$d?Ie:I.$e?We:st,fontWeight:"normal",fontSize:I.$d?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ae(ae){return e.editorOptionsRegistry[ae.id]=ae,ae}var Ke;(function(ae){ae[ae.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ae[ae.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ae[ae.accessibilitySupport=2]="accessibilitySupport",ae[ae.accessibilityPageSize=3]="accessibilityPageSize",ae[ae.ariaLabel=4]="ariaLabel",ae[ae.ariaRequired=5]="ariaRequired",ae[ae.autoClosingBrackets=6]="autoClosingBrackets",ae[ae.autoClosingComments=7]="autoClosingComments",ae[ae.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",ae[ae.autoClosingDelete=9]="autoClosingDelete",ae[ae.autoClosingOvertype=10]="autoClosingOvertype",ae[ae.autoClosingQuotes=11]="autoClosingQuotes",ae[ae.autoIndent=12]="autoIndent",ae[ae.automaticLayout=13]="automaticLayout",ae[ae.autoSurround=14]="autoSurround",ae[ae.bracketPairColorization=15]="bracketPairColorization",ae[ae.guides=16]="guides",ae[ae.codeLens=17]="codeLens",ae[ae.codeLensFontFamily=18]="codeLensFontFamily",ae[ae.codeLensFontSize=19]="codeLensFontSize",ae[ae.colorDecorators=20]="colorDecorators",ae[ae.colorDecoratorsLimit=21]="colorDecoratorsLimit",ae[ae.columnSelection=22]="columnSelection",ae[ae.comments=23]="comments",ae[ae.contextmenu=24]="contextmenu",ae[ae.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",ae[ae.cursorBlinking=26]="cursorBlinking",ae[ae.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",ae[ae.cursorStyle=28]="cursorStyle",ae[ae.cursorSurroundingLines=29]="cursorSurroundingLines",ae[ae.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",ae[ae.cursorWidth=31]="cursorWidth",ae[ae.disableLayerHinting=32]="disableLayerHinting",ae[ae.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",ae[ae.domReadOnly=34]="domReadOnly",ae[ae.dragAndDrop=35]="dragAndDrop",ae[ae.dropIntoEditor=36]="dropIntoEditor",ae[ae.emptySelectionClipboard=37]="emptySelectionClipboard",ae[ae.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",ae[ae.extraEditorClassName=39]="extraEditorClassName",ae[ae.fastScrollSensitivity=40]="fastScrollSensitivity",ae[ae.find=41]="find",ae[ae.fixedOverflowWidgets=42]="fixedOverflowWidgets",ae[ae.folding=43]="folding",ae[ae.foldingStrategy=44]="foldingStrategy",ae[ae.foldingHighlight=45]="foldingHighlight",ae[ae.foldingImportsByDefault=46]="foldingImportsByDefault",ae[ae.foldingMaximumRegions=47]="foldingMaximumRegions",ae[ae.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",ae[ae.fontFamily=49]="fontFamily",ae[ae.fontInfo=50]="fontInfo",ae[ae.fontLigatures=51]="fontLigatures",ae[ae.fontSize=52]="fontSize",ae[ae.fontWeight=53]="fontWeight",ae[ae.fontVariations=54]="fontVariations",ae[ae.formatOnPaste=55]="formatOnPaste",ae[ae.formatOnType=56]="formatOnType",ae[ae.glyphMargin=57]="glyphMargin",ae[ae.gotoLocation=58]="gotoLocation",ae[ae.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",ae[ae.hover=60]="hover",ae[ae.inDiffEditor=61]="inDiffEditor",ae[ae.inlineSuggest=62]="inlineSuggest",ae[ae.inlineEdit=63]="inlineEdit",ae[ae.letterSpacing=64]="letterSpacing",ae[ae.lightbulb=65]="lightbulb",ae[ae.lineDecorationsWidth=66]="lineDecorationsWidth",ae[ae.lineHeight=67]="lineHeight",ae[ae.lineNumbers=68]="lineNumbers",ae[ae.lineNumbersMinChars=69]="lineNumbersMinChars",ae[ae.linkedEditing=70]="linkedEditing",ae[ae.links=71]="links",ae[ae.matchBrackets=72]="matchBrackets",ae[ae.minimap=73]="minimap",ae[ae.mouseStyle=74]="mouseStyle",ae[ae.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",ae[ae.mouseWheelZoom=76]="mouseWheelZoom",ae[ae.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",ae[ae.multiCursorModifier=78]="multiCursorModifier",ae[ae.multiCursorPaste=79]="multiCursorPaste",ae[ae.multiCursorLimit=80]="multiCursorLimit",ae[ae.occurrencesHighlight=81]="occurrencesHighlight",ae[ae.overviewRulerBorder=82]="overviewRulerBorder",ae[ae.overviewRulerLanes=83]="overviewRulerLanes",ae[ae.padding=84]="padding",ae[ae.pasteAs=85]="pasteAs",ae[ae.parameterHints=86]="parameterHints",ae[ae.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",ae[ae.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",ae[ae.quickSuggestions=89]="quickSuggestions",ae[ae.quickSuggestionsDelay=90]="quickSuggestionsDelay",ae[ae.readOnly=91]="readOnly",ae[ae.readOnlyMessage=92]="readOnlyMessage",ae[ae.renameOnType=93]="renameOnType",ae[ae.renderControlCharacters=94]="renderControlCharacters",ae[ae.renderFinalNewline=95]="renderFinalNewline",ae[ae.renderLineHighlight=96]="renderLineHighlight",ae[ae.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",ae[ae.renderValidationDecorations=98]="renderValidationDecorations",ae[ae.renderWhitespace=99]="renderWhitespace",ae[ae.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",ae[ae.roundedSelection=101]="roundedSelection",ae[ae.rulers=102]="rulers",ae[ae.scrollbar=103]="scrollbar",ae[ae.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",ae[ae.scrollBeyondLastLine=105]="scrollBeyondLastLine",ae[ae.scrollPredominantAxis=106]="scrollPredominantAxis",ae[ae.selectionClipboard=107]="selectionClipboard",ae[ae.selectionHighlight=108]="selectionHighlight",ae[ae.selectOnLineNumbers=109]="selectOnLineNumbers",ae[ae.showFoldingControls=110]="showFoldingControls",ae[ae.showUnused=111]="showUnused",ae[ae.snippetSuggestions=112]="snippetSuggestions",ae[ae.smartSelect=113]="smartSelect",ae[ae.smoothScrolling=114]="smoothScrolling",ae[ae.stickyScroll=115]="stickyScroll",ae[ae.stickyTabStops=116]="stickyTabStops",ae[ae.stopRenderingLineAfter=117]="stopRenderingLineAfter",ae[ae.suggest=118]="suggest",ae[ae.suggestFontSize=119]="suggestFontSize",ae[ae.suggestLineHeight=120]="suggestLineHeight",ae[ae.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",ae[ae.suggestSelection=122]="suggestSelection",ae[ae.tabCompletion=123]="tabCompletion",ae[ae.tabIndex=124]="tabIndex",ae[ae.unicodeHighlighting=125]="unicodeHighlighting",ae[ae.unusualLineTerminators=126]="unusualLineTerminators",ae[ae.useShadowDOM=127]="useShadowDOM",ae[ae.useTabStops=128]="useTabStops",ae[ae.wordBreak=129]="wordBreak",ae[ae.wordSegmenterLocales=130]="wordSegmenterLocales",ae[ae.wordSeparators=131]="wordSeparators",ae[ae.wordWrap=132]="wordWrap",ae[ae.wordWrapBreakAfterCharacters=133]="wordWrapBreakAfterCharacters",ae[ae.wordWrapBreakBeforeCharacters=134]="wordWrapBreakBeforeCharacters",ae[ae.wordWrapColumn=135]="wordWrapColumn",ae[ae.wordWrapOverride1=136]="wordWrapOverride1",ae[ae.wordWrapOverride2=137]="wordWrapOverride2",ae[ae.wrappingIndent=138]="wrappingIndent",ae[ae.wrappingStrategy=139]="wrappingStrategy",ae[ae.showDeprecated=140]="showDeprecated",ae[ae.inlayHints=141]="inlayHints",ae[ae.editorClassName=142]="editorClassName",ae[ae.pixelRatio=143]="pixelRatio",ae[ae.tabFocusMode=144]="tabFocusMode",ae[ae.layoutInfo=145]="layoutInfo",ae[ae.wrappingInfo=146]="wrappingInfo",ae[ae.defaultColorDecorators=147]="defaultColorDecorators",ae[ae.colorDecoratorsActivatedOn=148]="colorDecoratorsActivatedOn",ae[ae.inlineCompletionsAccessibilityVerbose=149]="inlineCompletionsAccessibilityVerbose"})(Ke||(e.EditorOption=Ke={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ae(new l(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:p.localize(214,null)})),acceptSuggestionOnEnter:Ae(new d(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",p.localize(215,null),""],markdownDescription:p.localize(216,null)})),accessibilitySupport:Ae(new u),accessibilityPageSize:Ae(new n(3,"accessibilityPageSize",10,1,1073741824,{description:p.localize(217,null),tags:["accessibility"]})),ariaLabel:Ae(new t(4,"ariaLabel",p.localize(218,null))),ariaRequired:Ae(new l(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Ae(new l(8,"screenReaderAnnounceInlineSuggestion",!0,{description:p.localize(219,null),tags:["accessibility"]})),autoClosingBrackets:Ae(new d(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(220,null),p.localize(221,null),""],description:p.localize(222,null)})),autoClosingComments:Ae(new d(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(223,null),p.localize(224,null),""],description:p.localize(225,null)})),autoClosingDelete:Ae(new d(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",p.localize(226,null),""],description:p.localize(227,null)})),autoClosingOvertype:Ae(new d(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",p.localize(228,null),""],description:p.localize(229,null)})),autoClosingQuotes:Ae(new d(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(230,null),p.localize(231,null),""],description:p.localize(232,null)})),autoIndent:Ae(new h(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],c,{enumDescriptions:[p.localize(233,null),p.localize(234,null),p.localize(235,null),p.localize(236,null),p.localize(237,null)],description:p.localize(238,null)})),automaticLayout:Ae(new l(13,"automaticLayout",!1)),autoSurround:Ae(new d(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[p.localize(239,null),p.localize(240,null),p.localize(241,null),""],description:p.localize(242,null)})),bracketPairColorization:Ae(new Z),bracketPairGuides:Ae(new X),stickyTabStops:Ae(new l(116,"stickyTabStops",!1,{description:p.localize(243,null)})),codeLens:Ae(new l(17,"codeLens",!0,{description:p.localize(244,null)})),codeLensFontFamily:Ae(new t(18,"codeLensFontFamily","",{description:p.localize(245,null)})),codeLensFontSize:Ae(new n(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:p.localize(246,null)})),colorDecorators:Ae(new l(20,"colorDecorators",!0,{description:p.localize(247,null)})),colorDecoratorActivatedOn:Ae(new d(148,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[p.localize(248,null),p.localize(249,null),p.localize(250,null)],description:p.localize(251,null)})),colorDecoratorsLimit:Ae(new n(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:p.localize(252,null)})),columnSelection:Ae(new l(22,"columnSelection",!1,{description:p.localize(253,null)})),comments:Ae(new f),contextmenu:Ae(new l(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Ae(new l(25,"copyWithSyntaxHighlighting",!0,{description:p.localize(254,null)})),cursorBlinking:Ae(new h(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],v,{description:p.localize(255,null)})),cursorSmoothCaretAnimation:Ae(new d(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[p.localize(256,null),p.localize(257,null),p.localize(258,null)],description:p.localize(259,null)})),cursorStyle:Ae(new h(28,"cursorStyle",D.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],S,{description:p.localize(260,null)})),cursorSurroundingLines:Ae(new n(29,"cursorSurroundingLines",0,0,1073741824,{description:p.localize(261,null)})),cursorSurroundingLinesStyle:Ae(new d(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[p.localize(262,null),p.localize(263,null)],markdownDescription:p.localize(264,null)})),cursorWidth:Ae(new n(31,"cursorWidth",0,0,1073741824,{markdownDescription:p.localize(265,null)})),disableLayerHinting:Ae(new l(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ae(new l(33,"disableMonospaceOptimizations",!1)),domReadOnly:Ae(new l(34,"domReadOnly",!1)),dragAndDrop:Ae(new l(35,"dragAndDrop",!0,{description:p.localize(266,null)})),emptySelectionClipboard:Ae(new W),dropIntoEditor:Ae(new lt),stickyScroll:Ae(new ye),experimentalWhitespaceRendering:Ae(new d(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[p.localize(267,null),p.localize(268,null),p.localize(269,null)],description:p.localize(270,null)})),extraEditorClassName:Ae(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Ae(new s(40,"fastScrollSensitivity",5,ae=>ae<=0?5:ae,{markdownDescription:p.localize(271,null)})),find:Ae(new B),fixedOverflowWidgets:Ae(new l(42,"fixedOverflowWidgets",!1)),folding:Ae(new l(43,"folding",!0,{description:p.localize(272,null)})),foldingStrategy:Ae(new d(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[p.localize(273,null),p.localize(274,null)],description:p.localize(275,null)})),foldingHighlight:Ae(new l(45,"foldingHighlight",!0,{description:p.localize(276,null)})),foldingImportsByDefault:Ae(new l(46,"foldingImportsByDefault",!1,{description:p.localize(277,null)})),foldingMaximumRegions:Ae(new n(47,"foldingMaximumRegions",5e3,10,65e3,{description:p.localize(278,null)})),unfoldOnClickAfterEndOfLine:Ae(new l(48,"unfoldOnClickAfterEndOfLine",!1,{description:p.localize(279,null)})),fontFamily:Ae(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:p.localize(280,null)})),fontInfo:Ae(new j),fontLigatures2:Ae(new T),fontSize:Ae(new L),fontWeight:Ae(new z),fontVariations:Ae(new N),formatOnPaste:Ae(new l(55,"formatOnPaste",!1,{description:p.localize(281,null)})),formatOnType:Ae(new l(56,"formatOnType",!1,{description:p.localize(282,null)})),glyphMargin:Ae(new l(57,"glyphMargin",!0,{description:p.localize(283,null)})),gotoLocation:Ae(new Q),hideCursorInOverviewRuler:Ae(new l(59,"hideCursorInOverviewRuler",!1,{description:p.localize(284,null)})),hover:Ae(new Y),inDiffEditor:Ae(new l(61,"inDiffEditor",!1)),letterSpacing:Ae(new s(64,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ae=>s.clamp(ae,-5,20),{description:p.localize(285,null)})),lightbulb:Ae(new pe),lineDecorationsWidth:Ae(new U),lineHeight:Ae(new he),lineNumbers:Ae(new le),lineNumbersMinChars:Ae(new n(69,"lineNumbersMinChars",5,1,300)),linkedEditing:Ae(new l(70,"linkedEditing",!1,{description:p.localize(286,null)})),links:Ae(new l(71,"links",!0,{description:p.localize(287,null)})),matchBrackets:Ae(new d(72,"matchBrackets","always",["always","near","never"],{description:p.localize(288,null)})),minimap:Ae(new Se),mouseStyle:Ae(new d(74,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ae(new s(75,"mouseWheelScrollSensitivity",1,ae=>ae===0?1:ae,{markdownDescription:p.localize(289,null)})),mouseWheelZoom:Ae(new l(76,"mouseWheelZoom",!1,{markdownDescription:I.$d?p.localize(290,null):p.localize(291,null)})),multiCursorMergeOverlapping:Ae(new l(77,"multiCursorMergeOverlapping",!0,{description:p.localize(292,null)})),multiCursorModifier:Ae(new h(78,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],me,{markdownEnumDescriptions:[p.localize(293,null),p.localize(294,null)],markdownDescription:p.localize(295,null)})),multiCursorPaste:Ae(new d(79,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[p.localize(296,null),p.localize(297,null)],markdownDescription:p.localize(298,null)})),multiCursorLimit:Ae(new n(80,"multiCursorLimit",1e4,1,1e5,{markdownDescription:p.localize(299,null)})),occurrencesHighlight:Ae(new d(81,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[p.localize(300,null),p.localize(301,null),p.localize(302,null)],markdownDescription:p.localize(303,null)})),overviewRulerBorder:Ae(new l(82,"overviewRulerBorder",!0,{description:p.localize(304,null)})),overviewRulerLanes:Ae(new n(83,"overviewRulerLanes",3,0,3)),padding:Ae(new ie),pasteAs:Ae(new at),parameterHints:Ae(new se),peekWidgetDefaultFocus:Ae(new d(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[p.localize(305,null),p.localize(306,null)],description:p.localize(307,null)})),definitionLinkOpensInPeek:Ae(new l(88,"definitionLinkOpensInPeek",!1,{description:p.localize(308,null)})),quickSuggestions:Ae(new G),quickSuggestionsDelay:Ae(new n(90,"quickSuggestionsDelay",10,0,1073741824,{description:p.localize(309,null)})),readOnly:Ae(new l(91,"readOnly",!1)),readOnlyMessage:Ae(new be),renameOnType:Ae(new l(93,"renameOnType",!1,{description:p.localize(310,null),markdownDeprecationMessage:p.localize(311,null)})),renderControlCharacters:Ae(new l(94,"renderControlCharacters",!0,{description:p.localize(312,null),restricted:!0})),renderFinalNewline:Ae(new d(95,"renderFinalNewline",I.$e?"dimmed":"on",["off","on","dimmed"],{description:p.localize(313,null)})),renderLineHighlight:Ae(new d(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",p.localize(314,null)],description:p.localize(315,null)})),renderLineHighlightOnlyWhenFocus:Ae(new l(97,"renderLineHighlightOnlyWhenFocus",!1,{description:p.localize(316,null)})),renderValidationDecorations:Ae(new d(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ae(new d(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",p.localize(317,null),p.localize(318,null),p.localize(319,null),""],description:p.localize(320,null)})),revealHorizontalRightPadding:Ae(new n(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Ae(new l(101,"roundedSelection",!0,{description:p.localize(321,null)})),rulers:Ae(new Me),scrollbar:Ae(new Re),scrollBeyondLastColumn:Ae(new n(104,"scrollBeyondLastColumn",4,0,1073741824,{description:p.localize(322,null)})),scrollBeyondLastLine:Ae(new l(105,"scrollBeyondLastLine",!0,{description:p.localize(323,null)})),scrollPredominantAxis:Ae(new l(106,"scrollPredominantAxis",!0,{description:p.localize(324,null)})),selectionClipboard:Ae(new l(107,"selectionClipboard",!0,{description:p.localize(325,null),included:I.$e})),selectionHighlight:Ae(new l(108,"selectionHighlight",!0,{description:p.localize(326,null)})),selectOnLineNumbers:Ae(new l(109,"selectOnLineNumbers",!0)),showFoldingControls:Ae(new d(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[p.localize(327,null),p.localize(328,null),p.localize(329,null)],description:p.localize(330,null)})),showUnused:Ae(new l(111,"showUnused",!0,{description:p.localize(331,null)})),showDeprecated:Ae(new l(140,"showDeprecated",!0,{description:p.localize(332,null)})),inlayHints:Ae(new _),snippetSuggestions:Ae(new d(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[p.localize(333,null),p.localize(334,null),p.localize(335,null),p.localize(336,null)],description:p.localize(337,null)})),smartSelect:Ae(new Te),smoothScrolling:Ae(new l(114,"smoothScrolling",!1,{description:p.localize(338,null)})),stopRenderingLineAfter:Ae(new n(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ae(new we),inlineSuggest:Ae(new V),inlineEdit:Ae(new H),inlineCompletionsAccessibilityVerbose:Ae(new l(149,"inlineCompletionsAccessibilityVerbose",!1,{description:p.localize(339,null)})),suggestFontSize:Ae(new n(119,"suggestFontSize",0,0,1e3,{markdownDescription:p.localize(340,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Ae(new n(120,"suggestLineHeight",0,0,1e3,{markdownDescription:p.localize(341,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Ae(new l(121,"suggestOnTriggerCharacters",!0,{description:p.localize(342,null)})),suggestSelection:Ae(new d(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[p.localize(343,null),p.localize(344,null),p.localize(345,null)],description:p.localize(346,null)})),tabCompletion:Ae(new d(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[p.localize(347,null),p.localize(348,null),p.localize(349,null)],description:p.localize(350,null)})),tabIndex:Ae(new n(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ae(new ze),unusualLineTerminators:Ae(new d(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[p.localize(351,null),p.localize(352,null),p.localize(353,null)],description:p.localize(354,null)})),useShadowDOM:Ae(new l(127,"useShadowDOM",!0)),useTabStops:Ae(new l(128,"useTabStops",!0,{description:p.localize(355,null)})),wordBreak:Ae(new d(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[p.localize(356,null),p.localize(357,null)],description:p.localize(358,null)})),wordSegmenterLocales:Ae(new Ve),wordSeparators:Ae(new t(131,"wordSeparators",O.$Os,{description:p.localize(359,null)})),wordWrap:Ae(new d(132,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[p.localize(360,null),p.localize(361,null),p.localize(362,null),p.localize(363,null)],description:p.localize(364,null)})),wordWrapBreakAfterCharacters:Ae(new t(133,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ae(new t(134,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ae(new n(135,"wordWrapColumn",80,1,1073741824,{markdownDescription:p.localize(365,null)})),wordWrapOverride1:Ae(new d(136,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ae(new d(137,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Ae(new F),defaultColorDecorators:Ae(new l(147,"defaultColorDecorators",!1,{markdownDescription:p.localize(366,null)})),pixelRatio:Ae(new oe),tabFocusMode:Ae(new l(144,"tabFocusMode",!1,{markdownDescription:p.localize(367,null)})),layoutInfo:Ae(new x),wrappingInfo:Ae(new ot),wrappingIndent:Ae(new nt),wrappingStrategy:Ae(new ce)}}),define(Ee[202],Ce([9,10]),function(re,e){return re.create("vs/editor/common/languages",e)}),define(Ee[83],Ce([1,0,78,2,180,29,195,202]),function(re,e,o,R,I,M,O,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.ExternalUriOpenerPriority=e.$0t=e.$9t=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadApplicability=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.NewSymbolNameTag=e.$8t=e.$7t=e.SymbolKinds=e.SymbolTag=e.$5t=e.SymbolKind=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.DocumentPasteTriggerKind=e.CodeActionTriggerType=e.$3t=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.PartialAcceptTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.$2t=e.$1t=e.$Zt=void 0,e.$4t=g,e.$6t=h;class ${constructor(Q,Y,J){this.offset=Q,this.type=Y,this.language=J,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$Zt=$;class w{constructor(Q,Y){this.tokens=Q,this.endState=Y,this._tokenizationResultBrand=void 0}}e.$1t=w;class A{constructor(Q,Y){this.tokens=Q,this.endState=Y,this._encodedTokenizationResultBrand=void 0}}e.$2t=A;var P;(function(z){z[z.Method=0]="Method",z[z.Function=1]="Function",z[z.Constructor=2]="Constructor",z[z.Field=3]="Field",z[z.Variable=4]="Variable",z[z.Class=5]="Class",z[z.Struct=6]="Struct",z[z.Interface=7]="Interface",z[z.Module=8]="Module",z[z.Property=9]="Property",z[z.Event=10]="Event",z[z.Operator=11]="Operator",z[z.Unit=12]="Unit",z[z.Value=13]="Value",z[z.Constant=14]="Constant",z[z.Enum=15]="Enum",z[z.EnumMember=16]="EnumMember",z[z.Keyword=17]="Keyword",z[z.Text=18]="Text",z[z.Color=19]="Color",z[z.File=20]="File",z[z.Reference=21]="Reference",z[z.Customcolor=22]="Customcolor",z[z.Folder=23]="Folder",z[z.TypeParameter=24]="TypeParameter",z[z.User=25]="User",z[z.Issue=26]="Issue",z[z.Snippet=27]="Snippet"})(P||(e.CompletionItemKind=P={}));var b;(function(z){const Q=new Map;Q.set(0,o.$Hj.symbolMethod),Q.set(1,o.$Hj.symbolFunction),Q.set(2,o.$Hj.symbolConstructor),Q.set(3,o.$Hj.symbolField),Q.set(4,o.$Hj.symbolVariable),Q.set(5,o.$Hj.symbolClass),Q.set(6,o.$Hj.symbolStruct),Q.set(7,o.$Hj.symbolInterface),Q.set(8,o.$Hj.symbolModule),Q.set(9,o.$Hj.symbolProperty),Q.set(10,o.$Hj.symbolEvent),Q.set(11,o.$Hj.symbolOperator),Q.set(12,o.$Hj.symbolUnit),Q.set(13,o.$Hj.symbolValue),Q.set(15,o.$Hj.symbolEnum),Q.set(14,o.$Hj.symbolConstant),Q.set(15,o.$Hj.symbolEnum),Q.set(16,o.$Hj.symbolEnumMember),Q.set(17,o.$Hj.symbolKeyword),Q.set(27,o.$Hj.symbolSnippet),Q.set(18,o.$Hj.symbolText),Q.set(19,o.$Hj.symbolColor),Q.set(20,o.$Hj.symbolFile),Q.set(21,o.$Hj.symbolReference),Q.set(22,o.$Hj.symbolCustomColor),Q.set(23,o.$Hj.symbolFolder),Q.set(24,o.$Hj.symbolTypeParameter),Q.set(25,o.$Hj.account),Q.set(26,o.$Hj.issues);function Y(ce){let te=Q.get(ce);return te||(console.info("No codicon found for CompletionItemKind "+ce),te=o.$Hj.symbolProperty),te}z.toIcon=Y;const J=new Map;J.set("method",0),J.set("function",1),J.set("constructor",2),J.set("field",3),J.set("variable",4),J.set("class",5),J.set("struct",6),J.set("interface",7),J.set("module",8),J.set("property",9),J.set("event",10),J.set("operator",11),J.set("unit",12),J.set("value",13),J.set("constant",14),J.set("enum",15),J.set("enum-member",16),J.set("enumMember",16),J.set("keyword",17),J.set("snippet",27),J.set("text",18),J.set("color",19),J.set("file",20),J.set("reference",21),J.set("customcolor",22),J.set("folder",23),J.set("type-parameter",24),J.set("typeParameter",24),J.set("account",25),J.set("issue",26);function x(ce,te){let pe=J.get(ce);return typeof pe>"u"&&!te&&(pe=9),pe}z.fromString=x})(b||(e.CompletionItemKinds=b={}));var C;(function(z){z[z.Deprecated=1]="Deprecated"})(C||(e.CompletionItemTag=C={}));var y;(function(z){z[z.None=0]="None",z[z.KeepWhitespace=1]="KeepWhitespace",z[z.InsertAsSnippet=4]="InsertAsSnippet"})(y||(e.CompletionItemInsertTextRule=y={}));var a;(function(z){z[z.Word=0]="Word",z[z.Line=1]="Line",z[z.Suggest=2]="Suggest"})(a||(e.PartialAcceptTriggerKind=a={}));var m;(function(z){z[z.Invoke=0]="Invoke",z[z.TriggerCharacter=1]="TriggerCharacter",z[z.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(m||(e.CompletionTriggerKind=m={}));var l;(function(z){z[z.Automatic=0]="Automatic",z[z.Explicit=1]="Explicit"})(l||(e.InlineCompletionTriggerKind=l={}));class i{constructor(Q,Y,J,x){this.range=Q,this.text=Y,this.completionKind=J,this.isSnippetText=x}equals(Q){return M.$dt.lift(this.range).equalsRange(Q.range)&&this.text===Q.text&&this.completionKind===Q.completionKind&&this.isSnippetText===Q.isSnippetText}}e.$3t=i;var n;(function(z){z[z.Invoke=1]="Invoke",z[z.Auto=2]="Auto"})(n||(e.CodeActionTriggerType=n={}));var r;(function(z){z[z.Automatic=0]="Automatic",z[z.PasteAs=1]="PasteAs"})(r||(e.DocumentPasteTriggerKind=r={}));var s;(function(z){z[z.Invoke=1]="Invoke",z[z.TriggerCharacter=2]="TriggerCharacter",z[z.ContentChange=3]="ContentChange"})(s||(e.SignatureHelpTriggerKind=s={}));var t;(function(z){z[z.Text=0]="Text",z[z.Read=1]="Read",z[z.Write=2]="Write"})(t||(e.DocumentHighlightKind=t={}));function g(z){return z&&R.URI.isUri(z.uri)&&M.$dt.isIRange(z.range)&&(M.$dt.isIRange(z.originSelectionRange)||M.$dt.isIRange(z.targetSelectionRange))}var d;(function(z){z[z.File=0]="File",z[z.Module=1]="Module",z[z.Namespace=2]="Namespace",z[z.Package=3]="Package",z[z.Class=4]="Class",z[z.Method=5]="Method",z[z.Property=6]="Property",z[z.Field=7]="Field",z[z.Constructor=8]="Constructor",z[z.Enum=9]="Enum",z[z.Interface=10]="Interface",z[z.Function=11]="Function",z[z.Variable=12]="Variable",z[z.Constant=13]="Constant",z[z.String=14]="String",z[z.Number=15]="Number",z[z.Boolean=16]="Boolean",z[z.Array=17]="Array",z[z.Object=18]="Object",z[z.Key=19]="Key",z[z.Null=20]="Null",z[z.EnumMember=21]="EnumMember",z[z.Struct=22]="Struct",z[z.Event=23]="Event",z[z.Operator=24]="Operator",z[z.TypeParameter=25]="TypeParameter"})(d||(e.SymbolKind=d={})),e.$5t={17:(0,p.localize)(0,null),16:(0,p.localize)(1,null),4:(0,p.localize)(2,null),13:(0,p.localize)(3,null),8:(0,p.localize)(4,null),9:(0,p.localize)(5,null),21:(0,p.localize)(6,null),23:(0,p.localize)(7,null),7:(0,p.localize)(8,null),0:(0,p.localize)(9,null),11:(0,p.localize)(10,null),10:(0,p.localize)(11,null),19:(0,p.localize)(12,null),5:(0,p.localize)(13,null),1:(0,p.localize)(14,null),2:(0,p.localize)(15,null),20:(0,p.localize)(16,null),15:(0,p.localize)(17,null),18:(0,p.localize)(18,null),24:(0,p.localize)(19,null),3:(0,p.localize)(20,null),6:(0,p.localize)(21,null),14:(0,p.localize)(22,null),22:(0,p.localize)(23,null),25:(0,p.localize)(24,null),12:(0,p.localize)(25,null)};function h(z,Q){return(0,p.localize)(26,null,z,e.$5t[Q])}var c;(function(z){z[z.Deprecated=1]="Deprecated"})(c||(e.SymbolTag=c={}));var u;(function(z){const Q=new Map;Q.set(0,o.$Hj.symbolFile),Q.set(1,o.$Hj.symbolModule),Q.set(2,o.$Hj.symbolNamespace),Q.set(3,o.$Hj.symbolPackage),Q.set(4,o.$Hj.symbolClass),Q.set(5,o.$Hj.symbolMethod),Q.set(6,o.$Hj.symbolProperty),Q.set(7,o.$Hj.symbolField),Q.set(8,o.$Hj.symbolConstructor),Q.set(9,o.$Hj.symbolEnum),Q.set(10,o.$Hj.symbolInterface),Q.set(11,o.$Hj.symbolFunction),Q.set(12,o.$Hj.symbolVariable),Q.set(13,o.$Hj.symbolConstant),Q.set(14,o.$Hj.symbolString),Q.set(15,o.$Hj.symbolNumber),Q.set(16,o.$Hj.symbolBoolean),Q.set(17,o.$Hj.symbolArray),Q.set(18,o.$Hj.symbolObject),Q.set(19,o.$Hj.symbolKey),Q.set(20,o.$Hj.symbolNull),Q.set(21,o.$Hj.symbolEnumMember),Q.set(22,o.$Hj.symbolStruct),Q.set(23,o.$Hj.symbolEvent),Q.set(24,o.$Hj.symbolOperator),Q.set(25,o.$Hj.symbolTypeParameter);function Y(J){let x=Q.get(J);return x||(console.info("No codicon found for SymbolKind "+J),x=o.$Hj.symbolProperty),x}z.toIcon=Y})(u||(e.SymbolKinds=u={}));class f{static asEditOperation(Q){return I.$et.replace(M.$dt.lift(Q.range),Q.text)}}e.$7t=f;class E{static fromValue(Q){switch(Q){case"comment":return E.Comment;case"imports":return E.Imports;case"region":return E.Region}return new E(Q)}constructor(Q){this.value=Q}}e.$8t=E,E.Comment=new E("comment"),E.Imports=new E("imports"),E.Region=new E("region");var v;(function(z){z[z.AIGenerated=1]="AIGenerated"})(v||(e.NewSymbolNameTag=v={}));var D;(function(z){function Q(Y){return!Y||typeof Y!="object"?!1:typeof Y.id=="string"&&typeof Y.title=="string"}z.is=Q})(D||(e.Command=D={}));var k;(function(z){z[z.Collapsed=0]="Collapsed",z[z.Expanded=1]="Expanded"})(k||(e.CommentThreadCollapsibleState=k={}));var S;(function(z){z[z.Unresolved=0]="Unresolved",z[z.Resolved=1]="Resolved"})(S||(e.CommentThreadState=S={}));var F;(function(z){z[z.Current=0]="Current",z[z.Outdated=1]="Outdated"})(F||(e.CommentThreadApplicability=F={}));var W;(function(z){z[z.Editing=0]="Editing",z[z.Preview=1]="Preview"})(W||(e.CommentMode=W={}));var B;(function(z){z[z.Published=0]="Published",z[z.Draft=1]="Draft"})(B||(e.CommentState=B={}));var T;(function(z){z[z.Type=1]="Type",z[z.Parameter=2]="Parameter"})(T||(e.InlayHintKind=T={}));class N{constructor(Q){this.b=Q,this.a=null}dispose(){this.a&&this.a.then(Q=>{Q&&Q.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$9t=N,e.$0t=new O.$Ot;var j;(function(z){z[z.None=0]="None",z[z.Option=1]="Option",z[z.Default=2]="Default",z[z.Preferred=3]="Preferred"})(j||(e.ExternalUriOpenerPriority=j={}));var L;(function(z){z[z.Invoke=0]="Invoke",z[z.Automatic=1]="Automatic"})(L||(e.InlineEditTriggerKind=L={}))}),define(Ee[203],Ce([9,10]),function(re,e){return re.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ee[204],Ce([9,10]),function(re,e){return re.create("vs/platform/contextkey/common/contextkey",e)}),define(Ee[205],Ce([9,10]),function(re,e){return re.create("vs/platform/contextkey/common/scanner",e)}),define(Ee[206],Ce([9,10]),function(re,e){return re.create("vs/platform/dialogs/common/dialogs",e)}),define(Ee[207],Ce([9,10]),function(re,e){return re.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ee[208],Ce([9,10]),function(re,e){return re.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ee[209],Ce([9,10]),function(re,e){return re.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Ee[210],Ce([9,10]),function(re,e){return re.create("vs/platform/files/common/files",e)}),define(Ee[211],Ce([9,10]),function(re,e){return re.create("vs/platform/files/common/io",e)}),define(Ee[212],Ce([9,10]),function(re,e){return re.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Ee[213],Ce([9,10]),function(re,e){return re.create("vs/platform/log/common/log",e)}),define(Ee[214],Ce([9,10]),function(re,e){return re.create("vs/platform/markers/common/markers",e)}),define(Ee[215],Ce([9,10]),function(re,e){return re.create("vs/platform/theme/common/iconRegistry",e)}),define(Ee[216],Ce([9,10]),function(re,e){return re.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Ee[217],Ce([9,10]),function(re,e){return re.create("vs/platform/workspace/common/workspace",e)}),define(Ee[218],Ce([9,10]),function(re,e){return re.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(Ee[219],Ce([9,10]),function(re,e){return re.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ee[220],Ce([9,10]),function(re,e){return re.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ee[221],Ce([9,10]),function(re,e){return re.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Ee[222],Ce([9,10]),function(re,e){return re.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(Ee[223],Ce([9,10]),function(re,e){return re.create("vs/workbench/api/common/extHostLogService",e)}),define(Ee[224],Ce([9,10]),function(re,e){return re.create("vs/workbench/api/common/extHostNotebook",e)}),define(Ee[225],Ce([9,10]),function(re,e){return re.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ee[226],Ce([9,10]),function(re,e){return re.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ee[227],Ce([9,10]),function(re,e){return re.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ee[228],Ce([9,10]),function(re,e){return re.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ee[229],Ce([9,10]),function(re,e){return re.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Ee[230],Ce([9,10]),function(re,e){return re.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ee[231],Ce([9,10]),function(re,e){return re.create("vs/workbench/api/node/extHostDebugService",e)}),define(Ee[232],Ce([9,10]),function(re,e){return re.create("vs/workbench/common/configuration",e)}),define(Ee[233],Ce([9,10]),function(re,e){return re.create("vs/workbench/common/editor",e)}),define(Ee[234],Ce([9,10]),function(re,e){return re.create("vs/workbench/common/views",e)}),define(Ee[235],Ce([9,10]),function(re,e){return re.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ee[236],Ce([9,10]),function(re,e){return re.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ee[237],Ce([9,10]),function(re,e){return re.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(Ee[238],Ce([9,10]),function(re,e){return re.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ee[239],Ce([9,10]),function(re,e){return re.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ee[240],Ce([9,10]),function(re,e){return re.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ee[241],Ce([9,10]),function(re,e){return re.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Ee[242],Ce([9,10]),function(re,e){return re.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ee[243],Ce([9,10]),function(re,e){return re.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(Ee[244],Ce([9,10]),function(re,e){return re.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ee[245],Ce([1,0,13,205]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dj=e.TokenType=void 0;var I;(function(w){w[w.LParen=0]="LParen",w[w.RParen=1]="RParen",w[w.Neg=2]="Neg",w[w.Eq=3]="Eq",w[w.NotEq=4]="NotEq",w[w.Lt=5]="Lt",w[w.LtEq=6]="LtEq",w[w.Gt=7]="Gt",w[w.GtEq=8]="GtEq",w[w.RegexOp=9]="RegexOp",w[w.RegexStr=10]="RegexStr",w[w.True=11]="True",w[w.False=12]="False",w[w.In=13]="In",w[w.Not=14]="Not",w[w.And=15]="And",w[w.Or=16]="Or",w[w.Str=17]="Str",w[w.QuotedStr=18]="QuotedStr",w[w.Error=19]="Error",w[w.EOF=20]="EOF"})(I||(e.TokenType=I={}));function M(...w){switch(w.length){case 1:return(0,R.localize)(0,null,w[0]);case 2:return(0,R.localize)(1,null,w[0],w[1]);case 3:return(0,R.localize)(2,null,w[0],w[1],w[2]);default:return}}const O=(0,R.localize)(3,null),p=(0,R.localize)(4,null);class ${constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(A){switch(A.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return A.isTripleEq?"===":"==";case 4:return A.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return A.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return A.lexeme;case 18:return A.lexeme;case 19:return A.lexeme;case 20:return"EOF";default:throw(0,o.$8)(`unhandled token type: ${JSON.stringify(A)}; have you forgotten to add a case?`)}}get errors(){return this.g}reset(A){return this.c=A,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const P=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:P})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const P=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:P})}else this.h(126)?this.k(9):this.l(M("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(M("&&"));break;case 124:this.h(124)?this.k(16):this.l(M("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(A){return this.r()||this.c.charCodeAt(this.e)!==A?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(A){this.f.push({type:A,offset:this.d})}l(A){const P=this.d,b=this.c.substring(this.d,this.e),C={type:19,offset:this.d,lexeme:b};this.g.push({offset:P,lexeme:b,additionalInfo:A}),this.f.push(C)}n(){this.m.lastIndex=this.d;const A=this.m.exec(this.c);if(A){this.e=this.d+A[0].length;const P=this.c.substring(this.d,this.e),b=$.b.get(P);b?this.k(b):this.f.push({type:17,lexeme:P,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(O);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let A=this.e,P=!1,b=!1;for(;;){if(A>=this.c.length){this.e=A,this.l(p);return}const y=this.c.charCodeAt(A);if(P)P=!1;else if(y===47&&!b){A++;break}else y===91?b=!0:y===92?P=!0:y===93&&(b=!1);A++}for(;A<this.c.length&&$.a.has(this.c.charCodeAt(A));)A++;this.e=A;const C=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:C,offset:this.d})}r(){return this.e>=this.c.length}}e.$dj=$,$.a=new Set(["i","g","s","m","y","u"].map(w=>w.charCodeAt(0))),$.b=new Map([["not",14],["in",13],["false",12],["true",11]])}),define(Ee[246],Ce([1,0,23,41,208,396]),function(re,e,o,R,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tp=$,e.$up=w,e.$vp=A,e.$wp=P,e.$xp=b,e.$yp=C,e.$zp=y;const O=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,p=/^-(\d{4})(\d{2})(\d{2})$/;function $(l){return l=l.trim(),l==="*"||O.test(l)}function w(l){if(!$(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const i=l.match(O);return i?{hasCaret:i[1]==="^",hasGreaterEquals:i[1]===">=",majorBase:i[2]==="x"?0:parseInt(i[2],10),majorMustEqual:i[2]!=="x",minorBase:i[4]==="x"?0:parseInt(i[4],10),minorMustEqual:i[4]!=="x",patchBase:i[6]==="x"?0:parseInt(i[6],10),patchMustEqual:i[6]!=="x",preRelease:i[8]||null}:null}function A(l){if(!l)return null;const i=l.majorBase,n=l.majorMustEqual,r=l.minorBase;let s=l.minorMustEqual;const t=l.patchBase;let g=l.patchMustEqual;l.hasCaret&&(i===0||(s=!1),g=!1);let d=0;if(l.preRelease){const h=p.exec(l.preRelease);if(h){const[,c,u,f]=h;d=Date.UTC(Number(c),Number(u)-1,Number(f))}}return{majorBase:i,majorMustEqual:n,minorBase:r,minorMustEqual:s,patchBase:t,patchMustEqual:g,isMinimum:l.hasGreaterEquals,notBefore:d}}function P(l,i,n){let r;typeof l=="string"?r=A(w(l)):r=l;let s;i instanceof Date?s=i.getTime():typeof i=="string"&&(s=new Date(i).getTime());let t;if(typeof n=="string"?t=A(w(n)):t=n,!r||!t)return!1;const g=r.majorBase,d=r.minorBase,h=r.patchBase;let c=t.majorBase,u=t.minorBase,f=t.patchBase;const E=t.notBefore;let v=t.majorMustEqual,D=t.minorMustEqual,k=t.patchMustEqual;return t.isMinimum?g>c?!0:g<c?!1:d>u?!0:d<u||s&&s<E?!1:h>=f:(g===1&&c===0&&(!v||!D||!k)&&(c=1,u=0,f=0,v=!0,D=!1,k=!1),g<c?!1:g>c?!v:d<u?!1:d>u?!D:h<f?!1:h>f?!k:!(s&&s<E))}function b(l,i,n,r,s){const t=[];if(typeof r.publisher<"u"&&typeof r.publisher!="string")return t.push([R.default.Error,I.localize(0,null)]),t;if(typeof r.name!="string")return t.push([R.default.Error,I.localize(1,null,"name")]),t;if(typeof r.version!="string")return t.push([R.default.Error,I.localize(2,null,"version")]),t;if(!r.engines)return t.push([R.default.Error,I.localize(3,null,"engines")]),t;if(typeof r.engines.vscode!="string")return t.push([R.default.Error,I.localize(4,null,"engines.vscode")]),t;if(typeof r.extensionDependencies<"u"&&!m(r.extensionDependencies))return t.push([R.default.Error,I.localize(5,null,"extensionDependencies")]),t;if(typeof r.activationEvents<"u"){if(!m(r.activationEvents))return t.push([R.default.Error,I.localize(6,null,"activationEvents")]),t;if(typeof r.main>"u"&&typeof r.browser>"u")return t.push([R.default.Error,I.localize(7,null,"activationEvents","main","browser")]),t}if(typeof r.extensionKind<"u"&&typeof r.main>"u"&&t.push([R.default.Warning,I.localize(8,null,"extensionKind")]),typeof r.main<"u"){if(typeof r.main!="string")return t.push([R.default.Error,I.localize(9,null,"main")]),t;{const h=(0,o.$Vg)(n,r.main);(0,o.$Pg)(h,n)||t.push([R.default.Warning,I.localize(10,null,h.path,n.path)])}}if(typeof r.browser<"u"){if(typeof r.browser!="string")return t.push([R.default.Error,I.localize(11,null,"browser")]),t;{const h=(0,o.$Vg)(n,r.browser);(0,o.$Pg)(h,n)||t.push([R.default.Warning,I.localize(12,null,h.path,n.path)])}}if(!M.valid(r.version))return t.push([R.default.Error,I.localize(13,null)]),t;const g=[];if(!C(l,i,r,s,g))for(const h of g)t.push([R.default.Error,h]);return t}function C(l,i,n,r,s){return r||typeof n.main>"u"&&typeof n.browser>"u"?!0:a(l,i,n.engines.vscode,s)}function y(l,i,n){return l==="*"||a(i,n,l)}function a(l,i,n,r=[]){const s=A(w(n));if(!s)return r.push(I.localize(14,null,n)),!1;if(s.majorBase===0){if(!s.majorMustEqual||!s.minorMustEqual)return r.push(I.localize(15,null,n)),!1}else if(!s.majorMustEqual)return r.push(I.localize(16,null,n)),!1;return P(l,i,s)?!0:(r.push(I.localize(17,null,l,n)),!1)}function m(l){if(!Array.isArray(l))return!1;for(let i=0,n=l.length;i<n;i++)if(typeof l[i]!="string")return!1;return!0}}),define(Ee[106],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=void 0;class o{constructor(I,M=[],O=!1){this.ctor=I,this.staticArguments=M,this.supportsDelayedInstantiation=O}}e.$fi=o}),define(Ee[84],Ce([1,0,106]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$hs=M,e.$is=O;const R=[];var I;(function(p){p[p.Eager=0]="Eager",p[p.Delayed=1]="Delayed"})(I||(e.InstantiationType=I={}));function M(p,$,w){$ instanceof o.$fi||($=new o.$fi($,[],!!w)),R.push([p,$])}function O(){return R}}),define(Ee[247],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yq=e.$Xq=void 0;class o{constructor(M,O){this.key=M,this.data=O,this.incoming=new Map,this.outgoing=new Map}}e.$Xq=o;class R{constructor(M){this.b=M,this.a=new Map}roots(){const M=[];for(const O of this.a.values())O.outgoing.size===0&&M.push(O);return M}insertEdge(M,O){const p=this.lookupOrInsertNode(M),$=this.lookupOrInsertNode(O);p.outgoing.set($.key,$),$.incoming.set(p.key,p)}removeNode(M){const O=this.b(M);this.a.delete(O);for(const p of this.a.values())p.outgoing.delete(O),p.incoming.delete(O)}lookupOrInsertNode(M){const O=this.b(M);let p=this.a.get(O);return p||(p=new o(O,M),this.a.set(O,p)),p}lookup(M){return this.a.get(this.b(M))}isEmpty(){return this.a.size===0}toString(){const M=[];for(const[O,p]of this.a)M.push(`${O}
	(-> incoming)[${[...p.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...p.outgoing.keys()].join(",")}]
`);return M.join(`
`)}findCycleSlow(){for(const[M,O]of this.a){const p=new Set([M]),$=this.c(O,p);if($)return $}}c(M,O){for(const[p,$]of M.outgoing){if(O.has(p))return[...O,p].join(" -> ");O.add(p);const w=this.c($,O);if(w)return w;O.delete(p)}}}e.$Yq=R}),define(Ee[5],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hi=e._util=void 0,e.$ii=I,e.$ji=M;var o;(function(O){O.serviceIds=new Map,O.DI_TARGET="$di$target",O.DI_DEPENDENCIES="$di$dependencies";function p($){return $[O.DI_DEPENDENCIES]||[]}O.getServiceDependencies=p})(o||(e._util=o={})),e.$hi=I("instantiationService");function R(O,p,$){p[o.DI_TARGET]===p?p[o.DI_DEPENDENCIES].push({id:O,index:$}):(p[o.DI_DEPENDENCIES]=[{id:O,index:$}],p[o.DI_TARGET]=p)}function I(O){if(o.serviceIds.has(O))return o.serviceIds.get(O);const p=function($,w,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(p,$,A)};return p.toString=()=>O,o.serviceIds.set(O,p),p}function M(O){return O}}),define(Ee[53],Ce([1,0,18,2,5]),function(re,e,o,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$Oi=void 0,e.$Pi=M,e.$Qi=O,e.$Ri=$,e.$Si=w,e.$Ti=A,e.$Ui=P,e.$Vi=b,e.$Wi=y,e.$Xi=a,e.$Yi=m,e.$Oi=(0,I.$ii)("configurationService");function M(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof R.URI)}function O(l){return l&&typeof l=="object"&&(!l.overrideIdentifiers||Array.isArray(l.overrideIdentifiers))&&!l.overrideIdentifier&&(!l.resource||l.resource instanceof R.URI)}var p;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.USER=2]="USER",l[l.USER_LOCAL=3]="USER_LOCAL",l[l.USER_REMOTE=4]="USER_REMOTE",l[l.WORKSPACE=5]="WORKSPACE",l[l.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",l[l.DEFAULT=7]="DEFAULT",l[l.MEMORY=8]="MEMORY"})(p||(e.ConfigurationTarget=p={}));function $(l){switch(l){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function w(l){return l.applicationValue!==void 0||l.userValue!==void 0||l.userLocalValue!==void 0||l.userRemoteValue!==void 0||l.workspaceValue!==void 0||l.workspaceFolderValue!==void 0}function A(l,i){const n=Object.create(null);for(const r in l)P(n,r,l[r],i);return n}function P(l,i,n,r){const s=i.split("."),t=s.pop();let g=l;for(let d=0;d<s.length;d++){const h=s[d];let c=g[h];switch(typeof c){case"undefined":c=g[h]=Object.create(null);break;case"object":break;default:r(`Ignoring ${i} as ${s.slice(0,d+1).join(".")} is ${JSON.stringify(c)}`);return}g=c}if(typeof g=="object"&&g!==null)try{g[t]=n}catch{r(`Ignoring ${i} as ${s.join(".")} is ${JSON.stringify(g)}`)}else r(`Ignoring ${i} as ${s.join(".")} is ${JSON.stringify(g)}`)}function b(l,i){const n=i.split(".");C(l,n)}function C(l,i){const n=i.shift();if(i.length===0){delete l[n];return}if(Object.keys(l).indexOf(n)!==-1){const r=l[n];typeof r=="object"&&!Array.isArray(r)&&(C(r,i),Object.keys(r).length===0&&delete l[n])}}function y(l,i,n){function r(g,d){let h=g;for(const c of d){if(typeof h!="object"||h===null)return;h=h[c]}return h}const s=i.split("."),t=r(l,s);return typeof t>"u"?n:t}function a(l,i,n){Object.keys(i).forEach(r=>{r!=="__proto__"&&(r in l?o.$Xf(l[r])&&o.$Xf(i[r])?a(l[r],i[r],n):n&&(l[r]=i[r]):l[r]=i[r])})}function m(l){return l.replace(/[\[\]]/g,"")}}),define(Ee[42],Ce([1,0,11,14,245,5,204,13]),function(re,e,o,R,I,M,O,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$gj=e.$fj=e.ContextKeyExprType=void 0,e.$ej=w,e.$hj=g,e.$ij=d,e.$Bj=te;const $=new Map;$.set("false",!1),$.set("true",!0),$.set("isMac",o.$d),$.set("isLinux",o.$e),$.set("isWindows",o.$c),$.set("isWeb",o.$i),$.set("isMacNative",o.$d&&!o.$i),$.set("isEdge",o.$B),$.set("isFirefox",o.$z),$.set("isChrome",o.$y),$.set("isSafari",o.$A);function w(_,U){if($.get(_)!==void 0)throw(0,p.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");$.set(_,U)}const A=Object.prototype.hasOwnProperty;var P;(function(_){_[_.False=0]="False",_[_.True=1]="True",_[_.Defined=2]="Defined",_[_.Not=3]="Not",_[_.Equals=4]="Equals",_[_.NotEquals=5]="NotEquals",_[_.And=6]="And",_[_.Regex=7]="Regex",_[_.NotRegex=8]="NotRegex",_[_.Or=9]="Or",_[_.In=10]="In",_[_.NotIn=11]="NotIn",_[_.Greater=12]="Greater",_[_.GreaterEquals=13]="GreaterEquals",_[_.Smaller=14]="Smaller",_[_.SmallerEquals=15]="SmallerEquals"})(P||(e.ContextKeyExprType=P={}));const b={regexParsingWithErrorRecovery:!0},C=(0,O.localize)(0,null),y=(0,O.localize)(1,null),a=(0,O.localize)(2,null),m=(0,O.localize)(3,null),l=(0,O.localize)(4,null),i=(0,O.localize)(5,null),n=(0,O.localize)(6,null),r=(0,O.localize)(7,null);class s{get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(U=b){this.k=U,this.d=new I.$dj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(U){if(U===""){this.h.push({message:C,offset:0,lexeme:"",additionalInfo:y});return}this.f=this.d.reset(U).scan(),this.g=0,this.h=[];try{const he=this.l();if(!this.E()){const Se=this.D(),me=Se.type===17?i:void 0;throw this.h.push({message:l,offset:Se.offset,lexeme:I.$dj.getLexeme(Se),additionalInfo:me}),s.c}return he}catch(he){if(he!==s.c)throw he;return}}l(){return this.m()}m(){const U=[this.o()];for(;this.y(16);){const he=this.o();U.push(he)}return U.length===1?U[0]:t.or(...U)}o(){const U=[this.s()];for(;this.y(15);){const he=this.s();U.push(he)}return U.length===1?U[0]:t.and(...U)}s(){if(this.y(2)){const U=this.D();switch(U.type){case 11:return this.z(),c.INSTANCE;case 12:return this.z(),u.INSTANCE;case 0:{this.z();const he=this.l();return this.A(1,m),he?.negate()}case 17:return this.z(),S.create(U.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",U)}}return this.t()}t(){const U=this.D();switch(U.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const he=this.l();return this.A(1,m),he}case 17:{const he=U.lexeme;if(this.z(),this.y(9)){const me=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),me.type!==10)throw this.B("REGEX",me);const ie=me.lexeme,se=ie.lastIndexOf("/"),oe=se===ie.length-1?void 0:this.w(ie.substring(se+1));let G;try{G=new RegExp(ie.substring(1,se),oe)}catch{throw this.B("REGEX",me)}return j.create(he,G)}switch(me.type){case 10:case 19:{const ie=[me.lexeme];this.z();let se=this.D(),oe=0;for(let Me=0;Me<me.lexeme.length;Me++)me.lexeme.charCodeAt(Me)===40?oe++:me.lexeme.charCodeAt(Me)===41&&oe--;for(;!this.E()&&se.type!==15&&se.type!==16;){switch(se.type){case 0:oe++;break;case 1:oe--;break;case 10:case 18:for(let Me=0;Me<se.lexeme.length;Me++)se.lexeme.charCodeAt(Me)===40?oe++:me.lexeme.charCodeAt(Me)===41&&oe--}if(oe<0)break;ie.push(I.$dj.getLexeme(se)),this.z(),se=this.D()}const G=ie.join(""),ee=G.lastIndexOf("/"),le=ee===G.length-1?void 0:this.w(G.substring(ee+1));let de;try{de=new RegExp(G.substring(1,ee),le)}catch{throw this.B("REGEX",me)}return t.regex(he,de)}case 18:{const ie=me.lexeme;this.z();let se=null;if(!(0,R.$Ue)(ie)){const oe=ie.indexOf("/"),G=ie.lastIndexOf("/");if(oe!==G&&oe>=0){const ee=ie.slice(oe+1,G),le=ie[G+1]==="i"?"i":"";try{se=new RegExp(ee,le)}catch{throw this.B("REGEX",me)}}}if(se===null)throw this.B("REGEX",me);return j.create(he,se)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,a);const me=this.u();return t.notIn(he,me)}switch(this.D().type){case 3:{this.z();const me=this.u();if(this.x().type===18)return t.equals(he,me);switch(me){case"true":return t.has(he);case"false":return t.not(he);default:return t.equals(he,me)}}case 4:{this.z();const me=this.u();if(this.x().type===18)return t.notEquals(he,me);switch(me){case"true":return t.not(he);case"false":return t.has(he);default:return t.notEquals(he,me)}}case 5:return this.z(),T.create(he,this.u());case 6:return this.z(),N.create(he,this.u());case 7:return this.z(),W.create(he,this.u());case 8:return this.z(),B.create(he,this.u());case 13:return this.z(),t.in(he,this.u());default:return t.has(he)}}case 20:throw this.h.push({message:n,offset:U.offset,lexeme:"",additionalInfo:r}),s.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const U=this.D();switch(U.type){case 17:case 18:return this.z(),U.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(U){return U.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(U){return this.C(U)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(U,he){if(this.C(U))return this.z();throw this.B(he,this.D())}B(U,he,Se){const me=(0,O.localize)(8,null,U,I.$dj.getLexeme(he)),ie=he.offset,se=I.$dj.getLexeme(he);return this.h.push({message:me,offset:ie,lexeme:se,additionalInfo:Se}),s.c}C(U){return this.D().type===U}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$fj=s,s.c=new Error;class t{static false(){return c.INSTANCE}static true(){return u.INSTANCE}static has(U){return f.create(U)}static equals(U,he){return E.create(U,he)}static notEquals(U,he){return k.create(U,he)}static regex(U,he){return j.create(U,he)}static in(U,he){return v.create(U,he)}static notIn(U,he){return D.create(U,he)}static not(U){return S.create(U)}static and(...U){return Q.create(U,null,!0)}static or(...U){return Y.create(U,null,!0)}static greater(U,he){return W.create(U,he)}static greaterEquals(U,he){return B.create(U,he)}static smaller(U,he){return T.create(U,he)}static smallerEquals(U,he){return N.create(U,he)}static deserialize(U){return U==null?void 0:this.c.parse(U)}}e.$gj=t,t.c=new s({regexParsingWithErrorRecovery:!1});function g(_){const U=new s({regexParsingWithErrorRecovery:!1});return _.map(he=>(U.parse(he),U.lexingErrors.length>0?U.lexingErrors.map(Se=>({errorMessage:Se.additionalInfo?(0,O.localize)(9,null,Se.additionalInfo):(0,O.localize)(10,null),offset:Se.offset,length:Se.lexeme.length})):U.parsingErrors.length>0?U.parsingErrors.map(Se=>({errorMessage:Se.additionalInfo?`${Se.message}. ${Se.additionalInfo}`:Se.message,offset:Se.offset,length:Se.lexeme.length})):[]))}function d(_,U){const he=_?_.substituteConstants():void 0,Se=U?U.substituteConstants():void 0;return!he&&!Se?!0:!he||!Se?!1:he.equals(Se)}function h(_,U){return _.cmp(U)}class c{constructor(){this.type=0}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!1}serialize(){return"false"}keys(){return[]}map(U){return this}negate(){return u.INSTANCE}}e.$jj=c,c.INSTANCE=new c;class u{constructor(){this.type=1}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!0}serialize(){return"true"}keys(){return[]}map(U){return this}negate(){return c.INSTANCE}}e.$kj=u,u.INSTANCE=new u;class f{static create(U,he=null){const Se=$.get(U);return typeof Se=="boolean"?Se?u.INSTANCE:c.INSTANCE:new f(U,he)}constructor(U,he){this.key=U,this.c=he,this.type=2}cmp(U){return U.type!==this.type?this.type-U.type:x(this.key,U.key)}equals(U){return U.type===this.type?this.key===U.key:!1}substituteConstants(){const U=$.get(this.key);return typeof U=="boolean"?U?u.INSTANCE:c.INSTANCE:this}evaluate(U){return!!U.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(U){return U.mapDefined(this.key)}negate(){return this.c||(this.c=S.create(this.key,this)),this.c}}e.$lj=f;class E{static create(U,he,Se=null){if(typeof he=="boolean")return he?f.create(U,Se):S.create(U,Se);const me=$.get(U);return typeof me=="boolean"?he===(me?"true":"false")?u.INSTANCE:c.INSTANCE:new E(U,he,Se)}constructor(U,he,Se){this.c=U,this.d=he,this.f=Se,this.type=4}cmp(U){return U.type!==this.type?this.type-U.type:ce(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=$.get(this.c);if(typeof U=="boolean"){const he=U?"true":"false";return this.d===he?u.INSTANCE:c.INSTANCE}return this}evaluate(U){return U.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(U){return U.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$mj=E;class v{static create(U,he){return new v(U,he)}constructor(U,he){this.d=U,this.f=he,this.type=10,this.c=null}cmp(U){return U.type!==this.type?this.type-U.type:ce(this.d,this.f,U.d,U.f)}equals(U){return U.type===this.type?this.d===U.d&&this.f===U.f:!1}substituteConstants(){return this}evaluate(U){const he=U.getValue(this.f),Se=U.getValue(this.d);return Array.isArray(he)?he.includes(Se):typeof Se=="string"&&typeof he=="object"&&he!==null?A.call(he,Se):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(U){return U.mapIn(this.d,this.f)}negate(){return this.c||(this.c=D.create(this.d,this.f)),this.c}}e.$nj=v;class D{static create(U,he){return new D(U,he)}constructor(U,he){this.d=U,this.f=he,this.type=11,this.c=v.create(U,he)}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(U){return U.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$oj=D;class k{static create(U,he,Se=null){if(typeof he=="boolean")return he?S.create(U,Se):f.create(U,Se);const me=$.get(U);return typeof me=="boolean"?he===(me?"true":"false")?c.INSTANCE:u.INSTANCE:new k(U,he,Se)}constructor(U,he,Se){this.c=U,this.d=he,this.f=Se,this.type=5}cmp(U){return U.type!==this.type?this.type-U.type:ce(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=$.get(this.c);if(typeof U=="boolean"){const he=U?"true":"false";return this.d===he?c.INSTANCE:u.INSTANCE}return this}evaluate(U){return U.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(U){return U.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=E.create(this.c,this.d,this)),this.f}}e.$pj=k;class S{static create(U,he=null){const Se=$.get(U);return typeof Se=="boolean"?Se?c.INSTANCE:u.INSTANCE:new S(U,he)}constructor(U,he){this.c=U,this.d=he,this.type=3}cmp(U){return U.type!==this.type?this.type-U.type:x(this.c,U.c)}equals(U){return U.type===this.type?this.c===U.c:!1}substituteConstants(){const U=$.get(this.c);return typeof U=="boolean"?U?c.INSTANCE:u.INSTANCE:this}evaluate(U){return!U.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(U){return U.mapNot(this.c)}negate(){return this.d||(this.d=f.create(this.c,this)),this.d}}e.$qj=S;function F(_,U){if(typeof _=="string"){const he=parseFloat(_);isNaN(he)||(_=he)}return typeof _=="string"||typeof _=="number"?U(_):c.INSTANCE}class W{static create(U,he,Se=null){return F(he,me=>new W(U,me,Se))}constructor(U,he,Se){this.c=U,this.d=he,this.f=Se,this.type=12}cmp(U){return U.type!==this.type?this.type-U.type:ce(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=N.create(this.c,this.d,this)),this.f}}e.$rj=W;class B{static create(U,he,Se=null){return F(he,me=>new B(U,me,Se))}constructor(U,he,Se){this.c=U,this.d=he,this.f=Se,this.type=13}cmp(U){return U.type!==this.type?this.type-U.type:ce(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}e.$sj=B;class T{static create(U,he,Se=null){return F(he,me=>new T(U,me,Se))}constructor(U,he,Se){this.c=U,this.d=he,this.f=Se,this.type=14}cmp(U){return U.type!==this.type?this.type-U.type:ce(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=B.create(this.c,this.d,this)),this.f}}e.$tj=T;class N{static create(U,he,Se=null){return F(he,me=>new N(U,me,Se))}constructor(U,he,Se){this.c=U,this.d=he,this.f=Se,this.type=15}cmp(U){return U.type!==this.type?this.type-U.type:ce(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.$uj=N;class j{static create(U,he){return new j(U,he)}constructor(U,he){this.d=U,this.f=he,this.type=7,this.c=null}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.d<U.d)return-1;if(this.d>U.d)return 1;const he=this.f?this.f.source:"",Se=U.f?U.f.source:"";return he<Se?-1:he>Se?1:0}equals(U){if(U.type===this.type){const he=this.f?this.f.source:"",Se=U.f?U.f.source:"";return this.d===U.d&&he===Se}return!1}substituteConstants(){return this}evaluate(U){const he=U.getValue(this.d);return this.f?this.f.test(he):!1}serialize(){const U=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${U}`}keys(){return[this.d]}map(U){return U.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=L.create(this)),this.c}}e.$vj=j;class L{static create(U){return new L(U)}constructor(U){this.c=U,this.type=8}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(U){return new L(this.c.map(U))}negate(){return this.c}}e.$wj=L;function z(_){let U=null;for(let he=0,Se=_.length;he<Se;he++){const me=_[he].substituteConstants();if(_[he]!==me&&U===null){U=[];for(let ie=0;ie<he;ie++)U[ie]=_[ie]}U!==null&&(U[he]=me)}return U===null?_:U}class Q{static create(U,he,Se){return Q.d(U,he,Se)}constructor(U,he){this.expr=U,this.c=he,this.type=6}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let he=0,Se=this.expr.length;he<Se;he++){const me=h(this.expr[he],U.expr[he]);if(me!==0)return me}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let he=0,Se=this.expr.length;he<Se;he++)if(!this.expr[he].equals(U.expr[he]))return!1;return!0}return!1}substituteConstants(){const U=z(this.expr);return U===this.expr?this:Q.create(U,this.c,!1)}evaluate(U){for(let he=0,Se=this.expr.length;he<Se;he++)if(!this.expr[he].evaluate(U))return!1;return!0}static d(U,he,Se){const me=[];let ie=!1;for(const se of U)if(se){if(se.type===1){ie=!0;continue}if(se.type===0)return c.INSTANCE;if(se.type===6){me.push(...se.expr);continue}me.push(se)}if(me.length===0&&ie)return u.INSTANCE;if(me.length!==0){if(me.length===1)return me[0];me.sort(h);for(let se=1;se<me.length;se++)me[se-1].equals(me[se])&&(me.splice(se,1),se--);if(me.length===1)return me[0];for(;me.length>1;){const se=me[me.length-1];if(se.type!==9)break;me.pop();const oe=me.pop(),G=me.length===0,ee=Y.create(se.expr.map(le=>Q.create([le,oe],null,Se)),null,G);ee&&(me.push(ee),me.sort(h))}if(me.length===1)return me[0];if(Se){for(let se=0;se<me.length;se++)for(let oe=se+1;oe<me.length;oe++)if(me[se].negate().equals(me[oe]))return c.INSTANCE;if(me.length===1)return me[0]}return new Q(me,he)}}serialize(){return this.expr.map(U=>U.serialize()).join(" && ")}keys(){const U=[];for(const he of this.expr)U.push(...he.keys());return U}map(U){return new Q(this.expr.map(he=>he.map(U)),null)}negate(){if(!this.c){const U=[];for(const he of this.expr)U.push(he.negate());this.c=Y.create(U,this,!0)}return this.c}}e.$xj=Q;class Y{static create(U,he,Se){return Y.d(U,he,Se)}constructor(U,he){this.expr=U,this.c=he,this.type=9}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let he=0,Se=this.expr.length;he<Se;he++){const me=h(this.expr[he],U.expr[he]);if(me!==0)return me}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let he=0,Se=this.expr.length;he<Se;he++)if(!this.expr[he].equals(U.expr[he]))return!1;return!0}return!1}substituteConstants(){const U=z(this.expr);return U===this.expr?this:Y.create(U,this.c,!1)}evaluate(U){for(let he=0,Se=this.expr.length;he<Se;he++)if(this.expr[he].evaluate(U))return!0;return!1}static d(U,he,Se){let me=[],ie=!1;if(U){for(let se=0,oe=U.length;se<oe;se++){const G=U[se];if(G){if(G.type===0){ie=!0;continue}if(G.type===1)return u.INSTANCE;if(G.type===9){me=me.concat(G.expr);continue}me.push(G)}}if(me.length===0&&ie)return c.INSTANCE;me.sort(h)}if(me.length!==0){if(me.length===1)return me[0];for(let se=1;se<me.length;se++)me[se-1].equals(me[se])&&(me.splice(se,1),se--);if(me.length===1)return me[0];if(Se){for(let se=0;se<me.length;se++)for(let oe=se+1;oe<me.length;oe++)if(me[se].negate().equals(me[oe]))return u.INSTANCE;if(me.length===1)return me[0]}return new Y(me,he)}}serialize(){return this.expr.map(U=>U.serialize()).join(" || ")}keys(){const U=[];for(const he of this.expr)U.push(...he.keys());return U}map(U){return new Y(this.expr.map(he=>he.map(U)),null)}negate(){if(!this.c){const U=[];for(const he of this.expr)U.push(he.negate());for(;U.length>1;){const he=U.shift(),Se=U.shift(),me=[];for(const ie of ye(he))for(const se of ye(Se))me.push(Q.create([ie,se],null,!1));U.unshift(Y.create(me,null,!1))}this.c=Y.create(U,this,!0)}return this.c}}e.$yj=Y;class J extends f{static all(){return J.d.values()}constructor(U,he,Se){super(U,null),this.f=he,typeof Se=="object"?J.d.push({...Se,key:U}):Se!==!0&&J.d.push({key:U,description:Se,type:he!=null?typeof he:void 0})}bindTo(U){return U.createKey(this.key,this.f)}getValue(U){return U.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(U){return E.create(this.key,U)}notEqualsTo(U){return k.create(this.key,U)}}e.$zj=J,J.d=[],e.$Aj=(0,M.$ii)("contextKeyService");function x(_,U){return _<U?-1:_>U?1:0}function ce(_,U,he,Se){return _<he?-1:_>he?1:U<Se?-1:U>Se?1:0}function te(_,U){if(_.type===0||U.type===1)return!0;if(_.type===9)return U.type===9?pe(_.expr,U.expr):!1;if(U.type===9){for(const he of U.expr)if(te(_,he))return!0;return!1}if(_.type===6){if(U.type===6)return pe(U.expr,_.expr);for(const he of _.expr)if(te(he,U))return!0;return!1}return _.equals(U)}function pe(_,U){let he=0,Se=0;for(;he<_.length&&Se<U.length;){const me=_[he].cmp(U[Se]);if(me<0)return!1;me===0&&he++,Se++}return he===_.length}function ye(_){return _.type===9?_.expr:[_]}}),define(Ee[248],Ce([1,0,23,41,206,5,102,11,24]),function(re,e,o,R,I,M,O,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.$tw=e.$sw=e.$rw=void 0,e.$uw=C,e.$vw=y,e.$rw=(0,M.$ii)("dialogService");var w;(function(a){a[a.Confirmation=1]="Confirmation",a[a.Prompt=2]="Prompt",a[a.Input=3]="Input"})(w||(w={}));class A{a(m){return this.d(m,w.Confirmation)}b(m){return this.d(m,w.Prompt)}c(m){return this.d(m,w.Input)}d(m,l){const i=[];switch(l){case w.Confirmation:{const n=m;n.primaryButton?i.push(n.primaryButton):i.push((0,I.localize)(0,null)),n.cancelButton?i.push(n.cancelButton):i.push((0,I.localize)(1,null));break}case w.Prompt:{const n=m;Array.isArray(n.buttons)&&n.buttons.length>0&&i.push(...n.buttons.map(r=>r.label)),n.cancelButton&&(n.cancelButton===!0?i.push((0,I.localize)(2,null)):typeof n.cancelButton=="string"?i.push(n.cancelButton):n.cancelButton.label?i.push(n.cancelButton.label):i.push((0,I.localize)(3,null))),i.length===0&&i.push((0,I.localize)(4,null));break}case w.Input:{const n=m;n.primaryButton?i.push(n.primaryButton):i.push((0,I.localize)(5,null)),n.cancelButton?i.push(n.cancelButton):i.push((0,I.localize)(6,null));break}}return i}e(m){if(typeof m=="string")return m;if(typeof m=="number")return m===R.default.Info?"info":m===R.default.Error?"error":m===R.default.Warning?"warning":"none"}f(m,l,i){const n=[...m.buttons??[]];m.cancelButton&&typeof m.cancelButton!="string"&&typeof m.cancelButton!="boolean"&&n.push(m.cancelButton);let r=n[l]?.run({checkboxChecked:i});return r instanceof Promise||(r=Promise.resolve(r)),{result:r,checkboxChecked:i}}}e.$sw=A,e.$tw=(0,M.$ii)("fileDialogService");var P;(function(a){a[a.SAVE=0]="SAVE",a[a.DONT_SAVE=1]="DONT_SAVE",a[a.CANCEL=2]="CANCEL"})(P||(e.ConfirmResult=P={}));const b=10;function C(a){const m=[];return m.push(...a.slice(0,b).map(l=>typeof l=="string"?l:(0,o.$Sg)(l))),a.length>b&&(a.length-b===1?m.push((0,I.localize)(7,null)):m.push((0,I.localize)(8,null,a.length-b))),m.push(""),m.join(`
`)}function y(a,m){const l=(0,$.$Pn)(a);let i=(l.buttons??[]).map(t=>(0,O.$ow)(t)),n=(a.buttons||[]).map((t,g)=>g),r=0,s=l.cancelId??i.length-1;if(i.length>1){const t=typeof s=="number"?i[s]:void 0;if(p.$e||p.$d){if(typeof t=="string"&&i.length>1&&s!==1){i.splice(s,1),i.splice(1,0,t);const g=n[s];n.splice(s,1),n.splice(1,0,g),s=1}p.$e&&i.length>1&&(i=i.reverse(),n=n.reverse(),r=i.length-1,typeof t=="string"&&(s=r-1))}else if(p.$c&&typeof t=="string"&&i.length>1&&s!==i.length-1){i.splice(s,1),i.push(t);const g=n[s];n.splice(s,1),n.push(g),s=i.length-1}}return l.buttons=i,l.defaultId=r,l.cancelId=s,l.noLink=!0,l.title=l.title||m.nameLong,{options:l,buttonIndeces:n}}}),define(Ee[137],Ce([1,0,5]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qi=e.$pi=void 0,e.$pi=(0,o.$ii)("environmentService"),e.$qi=(0,o.$ji)(e.$pi)}),define(Ee[138],Ce([1,0,207,5]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2o=e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.ExtensionGalleryErrorCode=e.$To=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$So=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=void 0,e.$Mo=I,e.$No=M,e.$Oo=O,e.$Po=p,e.$Qo=$,e.$Ro=w,e.$Go="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Ho=new RegExp(e.$Go),e.$Io="__web_extension",e.$Jo="skipWalkthrough",e.$Ko="extensionsSync",e.$Lo="dependecyOrPackExtensionInstall";function I(n){switch(n){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function M(n){switch(n){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function O(n,r){switch(n){case 3:return r==="x64"?"win32-x64":r==="arm64"?"win32-arm64":"unknown";case 2:return r==="x64"?"linux-x64":r==="arm64"?"linux-arm64":r==="arm"?"linux-armhf":"unknown";case"alpine":return r==="x64"?"alpine-x64":r==="arm64"?"alpine-arm64":"unknown";case 1:return r==="x64"?"darwin-x64":r==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function p(n,r){return r==="web"&&!n.includes("web")}function $(n,r,s){return p(r,s)?!1:n==="undefined"||n==="universal"?!0:n==="unknown"?!1:n===s}function w(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}var A;(function(n){n[n.NoneOrRelevance=0]="NoneOrRelevance",n[n.LastUpdatedDate=1]="LastUpdatedDate",n[n.Title=2]="Title",n[n.PublisherName=3]="PublisherName",n[n.InstallCount=4]="InstallCount",n[n.PublishedDate=10]="PublishedDate",n[n.AverageRating=6]="AverageRating",n[n.WeightedRating=12]="WeightedRating"})(A||(e.SortBy=A={}));var P;(function(n){n[n.Default=0]="Default",n[n.Ascending=1]="Ascending",n[n.Descending=2]="Descending"})(P||(e.SortOrder=P={}));var b;(function(n){n.Install="install",n.Uninstall="uninstall"})(b||(e.StatisticType=b={}));var C;(function(n){n[n.None=1]="None",n[n.Install=2]="Install",n[n.Update=3]="Update",n[n.Migrate=4]="Migrate"})(C||(e.InstallOperation=C={})),e.$So=(0,R.$ii)("extensionGalleryService");var y;(function(n){n.Unsupported="Unsupported",n.Deprecated="Deprecated",n.Malicious="Malicious",n.Incompatible="Incompatible",n.IncompatibleTargetPlatform="IncompatibleTargetPlatform",n.ReleaseVersionNotFound="ReleaseVersionNotFound",n.Invalid="Invalid",n.Download="Download",n.DownloadSignature="DownloadSignature",n.UpdateMetadata="UpdateMetadata",n.Extract="Extract",n.Scanning="Scanning",n.Delete="Delete",n.Rename="Rename",n.CorruptZip="CorruptZip",n.IncompleteZip="IncompleteZip",n.Signature="Signature",n.NotAllowed="NotAllowed",n.Gallery="Gallery",n.Unknown="Unknown",n.Internal="Internal"})(y||(e.ExtensionManagementErrorCode=y={}));var a;(function(n){n.UnknownError="UnknownError",n.PackageIsInvalidZip="PackageIsInvalidZip",n.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(a||(e.ExtensionSignaturetErrorCode=a={}));class m extends Error{constructor(r,s){super(r),this.code=s,this.name=s}}e.$To=m;var l;(function(n){n.Timeout="Timeout",n.Cancelled="Cancelled",n.Failed="Failed"})(l||(e.ExtensionGalleryErrorCode=l={}));class i extends Error{constructor(r,s){super(r),this.code=s,this.name=s}}e.$Uo=i,e.$Vo=(0,R.$ii)("extensionManagementService"),e.$Wo="extensionsIdentifiers/disabled",e.$Xo="extensionsIdentifiers/enabled",e.$Yo=(0,R.$ii)("IGlobalExtensionEnablementService"),e.$Zo=(0,R.$ii)("IExtensionTipsService"),e.$1o=(0,o.localize2)(0,"Extensions"),e.$2o=(0,o.localize2)(1,"Preferences")}),define(Ee[249],Ce([1,0,5]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$95b=e.$85b=void 0,e.$85b=(0,o.$ii)("externalTerminal"),e.$95b="Terminal.app"}),define(Ee[250],Ce([1,0,51,54,15,17,11,99,31,104,209,249]),function(re,e,o,R,I,M,O,p,$,w,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$ac=e.$0ac=e.$9ac=void 0;const b=A.localize(0,null);class C{async getDefaultTerminalForPlatforms(){return{windows:y.getDefaultTerminalWindows(),linux:await m.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class y extends C{openTerminal(s,t){return this.spawnTerminal(o,s,w.$bm(),t)}spawnTerminal(s,t,g,d){const h=t.windowsExec||y.getDefaultTerminalWindows();d&&d[1]===":"&&(d=d[0].toUpperCase()+d.substr(1));const c=M.$oc(h,".exe").toLowerCase();if(c==="cmder")return s.spawn(h,d?[d]:void 0),Promise.resolve(void 0);const u=["/c","start","/wait"];return h.indexOf(" ")>=0&&u.push('""'),u.push(h),c==="wt"&&u.push("-d ."),new Promise((f,E)=>{const v=l(process),D=s.spawn(g,u,{cwd:d,env:v,detached:!0});D.on("error",E),D.on("exit",()=>f())})}async runInTerminal(s,t,g,d,h){const c="windowsExec"in h&&h.windowsExec?h.windowsExec:y.getDefaultTerminalWindows(),u=await y.f();return new Promise((f,E)=>{const v=`"${t} - ${b}"`,D=`"${g.join('" "')}" & pause`,k=Object.assign({},l(process),d);Object.keys(k).filter(T=>k[T]===null).forEach(T=>delete k[T]);const S={cwd:t,env:k,windowsVerbatimArguments:!0};let F,W;M.$oc(c,".exe")==="wt"?(F=c,W=["-d",".",y.b,"/c",D]):u?(F=u,W=["-d",".",c,"/c",D]):(F=y.b,W=["/c","start",v,"/wait",c,"/c",`"${D}"`]),o.spawn(F,W,S).on("error",T=>{E(i(T))}),f(void 0)})}static getDefaultTerminalWindows(){if(!y.d){const s=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");y.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${s?"Sysnative":"System32"}\\cmd.exe`}return y.d}static async f(){try{const s=await w.win32.findExecutable("wt");return await $.Promises.exists(s)?s:void 0}catch{return}}}e.$9ac=y,y.b="cmd.exe",Qe([R.$Mh],y,"f",null);class a extends C{openTerminal(s,t){return this.spawnTerminal(o,s,t)}runInTerminal(s,t,g,d,h){const c=h.osxExec||P.$95b;return new Promise((u,f)=>{if(c===P.$95b||c==="iTerm.app"){const E=c===P.$95b?"TerminalHelper":"iTermHelper",D=[I.$Cg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${E}.scpt`).fsPath,"-t",s||b,"-w",t];for(const F of g)D.push("-a"),D.push(F);if(d){const F=Object.assign({},l(process),d);for(const W in F){const B=F[W];B===null?(D.push("-u"),D.push(W)):(D.push("-e"),D.push(`${W}=${B}`))}}let k="";const S=o.spawn(a.b,D);S.on("error",F=>{f(i(F))}),S.stderr.on("data",F=>{k+=F.toString()}),S.on("exit",F=>{if(F===0)u(void 0);else if(k){const W=k.split(`
`,1);f(new Error(W[0]))}else f(new Error(A.localize(1,null,E,F)))})}else f(new Error(A.localize(2,null,c)))})}spawnTerminal(s,t,g){const d=t.osxExec||P.$95b;return new Promise((h,c)=>{const u=["-a",d];g&&u.push(g);const f=l(process),E=s.spawn("/usr/bin/open",u,{cwd:g,env:f});E.on("error",c),E.on("exit",()=>h())})}}e.$0ac=a,a.b="/usr/bin/osascript";class m extends C{openTerminal(s,t){return this.spawnTerminal(o,s,t)}runInTerminal(s,t,g,d,h){const c=h.linuxExec?Promise.resolve(h.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((u,f)=>{const E=[];c.then(v=>{v.indexOf("gnome-terminal")>=0?E.push("-x"):E.push("-e"),E.push("bash"),E.push("-c");const D=`${n(g)}; echo; read -p "${m.b}" -n1;`;E.push(`''${D}''`);const k=Object.assign({},l(process),d);Object.keys(k).filter(B=>k[B]===null).forEach(B=>delete k[B]);const S={cwd:t,env:k};let F="";const W=o.spawn(v,E,S);W.on("error",B=>{f(i(B))}),W.stderr.on("data",B=>{F+=B.toString()}),W.on("exit",B=>{if(B===0)u(void 0);else if(F){const T=F.split(`
`,1);f(new Error(T[0]))}else f(new Error(A.localize(4,null,v,B)))})})})}static async getDefaultTerminalLinuxReady(){if(!m.d)if(!O.$e)m.d=Promise.resolve("xterm");else{const s=await $.Promises.exists("/etc/debian_version");m.d=new Promise(t=>{s?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm")})}return m.d}spawnTerminal(s,t,g){const d=t.linuxExec?Promise.resolve(t.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((h,c)=>{d.then(u=>{const f=l(process),E=s.spawn(u,[],{cwd:g,env:f});E.on("error",c),E.on("exit",()=>h())})})}}e.$$ac=m,m.b=A.localize(3,null);function l(r){const s={...r.env};return(0,p.$_l)(s),s}function i(r){return"errno"in r&&r.errno==="ENOENT"&&"path"in r&&typeof r.path=="string"?new Error(A.localize(5,null,r.path)):r}function n(r){let s="";for(const t of r)t.indexOf(" ")>=0?s+='"'+t+'"':s+=t,s+=" ";return s}}),define(Ee[32],Ce([1,0,77,17,14,18,2,210,5,11,15,46]),function(re,e,o,R,I,M,O,p,$,w,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kl=e.$hl=e.FileKind=e.$gl=e.$fl=e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.FileOperationResult=e.$_k=e.$$k=e.$0k=e.$8k=e.FileChangeType=e.$7k=e.FileOperation=e.$1k=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$Ok=void 0,e.$Pk=b,e.$Qk=a,e.$Rk=l,e.$Sk=i,e.$Tk=n,e.$Uk=r,e.$Vk=s,e.$Wk=t,e.$Xk=g,e.$Yk=d,e.$Zk=h,e.$2k=f,e.$3k=E,e.$4k=v,e.$5k=D,e.$6k=k,e.$9k=T,e.$il=Y,e.$jl=J,e.$ll=ce,e.$Ok=(0,$.$ii)("fileService");function b(te){return te.create===!0}var C;(function(te){te[te.Unknown=0]="Unknown",te[te.File=1]="File",te[te.Directory=2]="Directory",te[te.SymbolicLink=64]="SymbolicLink"})(C||(e.FileType=C={}));var y;(function(te){te[te.Readonly=1]="Readonly",te[te.Locked=2]="Locked"})(y||(e.FilePermission=y={}));function a(te){const pe=te;return!!pe&&typeof pe.onDidChange=="function"}var m;(function(te){te[te.None=0]="None",te[te.FileReadWrite=2]="FileReadWrite",te[te.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",te[te.FileReadStream=16]="FileReadStream",te[te.FileFolderCopy=8]="FileFolderCopy",te[te.PathCaseSensitive=1024]="PathCaseSensitive",te[te.Readonly=2048]="Readonly",te[te.Trash=4096]="Trash",te[te.FileWriteUnlock=8192]="FileWriteUnlock",te[te.FileAtomicRead=16384]="FileAtomicRead",te[te.FileAtomicWrite=32768]="FileAtomicWrite",te[te.FileAtomicDelete=65536]="FileAtomicDelete",te[te.FileClone=131072]="FileClone"})(m||(e.FileSystemProviderCapabilities=m={}));function l(te){return!!(te.capabilities&2)}function i(te){return!!(te.capabilities&8)}function n(te){return!!(te.capabilities&131072)}function r(te){return!!(te.capabilities&4)}function s(te){return!!(te.capabilities&16)}function t(te){return l(te)?!!(te.capabilities&16384):!1}function g(te){return l(te)?!!(te.capabilities&32768):!1}function d(te){return!!(te.capabilities&65536)}function h(te){return!!(te.capabilities&2048)}var c;(function(te){te.FileExists="EntryExists",te.FileNotFound="EntryNotFound",te.FileNotADirectory="EntryNotADirectory",te.FileIsADirectory="EntryIsADirectory",te.FileExceedsStorageQuota="EntryExceedsStorageQuota",te.FileTooLarge="EntryTooLarge",te.FileWriteLocked="EntryWriteLocked",te.NoPermissions="NoPermissions",te.Unavailable="Unavailable",te.Unknown="Unknown"})(c||(e.FileSystemProviderErrorCode=c={}));class u extends Error{static create(pe,ye){const _=new u(pe.toString(),ye);return v(_,ye),_}constructor(pe,ye){super(pe),this.code=ye}}e.$1k=u;function f(te,pe){return u.create(te,pe)}function E(te){return te||f((0,p.localize)(0,null),c.Unknown)}function v(te,pe){return te.name=pe?`${pe} (FileSystemError)`:"FileSystemError",te}function D(te){if(!te)return c.Unknown;if(te instanceof u)return te.code;const pe=/^(.+) \(FileSystemError\)$/.exec(te.name);if(!pe)return c.Unknown;switch(pe[1]){case c.FileExists:return c.FileExists;case c.FileIsADirectory:return c.FileIsADirectory;case c.FileNotADirectory:return c.FileNotADirectory;case c.FileNotFound:return c.FileNotFound;case c.FileTooLarge:return c.FileTooLarge;case c.FileWriteLocked:return c.FileWriteLocked;case c.NoPermissions:return c.NoPermissions;case c.Unavailable:return c.Unavailable}return c.Unknown}function k(te){if(te instanceof N)return te.fileOperationResult;switch(D(te)){case c.FileNotFound:return 1;case c.FileIsADirectory:return 0;case c.FileNotADirectory:return 9;case c.FileWriteLocked:return 5;case c.NoPermissions:return 6;case c.FileExists:return 4;case c.FileTooLarge:return 7;default:return 10}}var S;(function(te){te[te.CREATE=0]="CREATE",te[te.DELETE=1]="DELETE",te[te.MOVE=2]="MOVE",te[te.COPY=3]="COPY",te[te.WRITE=4]="WRITE"})(S||(e.FileOperation=S={}));class F{constructor(pe,ye,_){this.resource=pe,this.operation=ye,this.target=_}isOperation(pe){return this.operation===pe}}e.$7k=F;var W;(function(te){te[te.UPDATED=0]="UPDATED",te[te.ADDED=1]="ADDED",te[te.DELETED=2]="DELETED"})(W||(e.FileChangeType=W={}));class B{constructor(pe,ye){this.c=ye,this.b=void 0,this.d=new P.$V(()=>{const _=o.$oi.forUris(()=>this.c);return _.fill(this.rawAdded.map(U=>[U,!0])),_}),this.f=new P.$V(()=>{const _=o.$oi.forUris(()=>this.c);return _.fill(this.rawUpdated.map(U=>[U,!0])),_}),this.g=new P.$V(()=>{const _=o.$oi.forUris(()=>this.c);return _.fill(this.rawDeleted.map(U=>[U,!0])),_}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const _ of pe){switch(_.type){case 1:this.rawAdded.push(_.resource);break;case 0:this.rawUpdated.push(_.resource);break;case 2:this.rawDeleted.push(_.resource);break}this.b!==B.a&&(typeof _.cId=="number"?this.b===void 0?this.b=_.cId:this.b!==_.cId&&(this.b=B.a):this.b!==void 0&&(this.b=B.a))}}contains(pe,...ye){return this.h(pe,{includeChildren:!1},...ye)}affects(pe,...ye){return this.h(pe,{includeChildren:!0},...ye)}h(pe,ye,..._){if(!pe)return!1;const U=_.length>0;return!!((!U||_.includes(1))&&(this.d.value.get(pe)||ye.includeChildren&&this.d.value.findSuperstr(pe))||(!U||_.includes(0))&&(this.f.value.get(pe)||ye.includeChildren&&this.f.value.findSuperstr(pe))||(!U||_.includes(2))&&(this.g.value.findSubstr(pe)||ye.includeChildren&&this.g.value.findSuperstr(pe)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(pe){return this.b===pe}hasCorrelation(){return typeof this.b=="number"}}e.$8k=B,B.a=null;function T(te,pe,ye){return!te||!pe||te===pe||pe.length>te.length?!1:(pe.charAt(pe.length-1)!==R.sep&&(pe+=R.sep),ye?(0,I.$mf)(te,pe):te.indexOf(pe)===0)}class N extends Error{constructor(pe,ye,_){super(pe),this.fileOperationResult=ye,this.options=_}}e.$0k=N;class j extends N{constructor(pe,ye,_,U){super(pe,ye,U),this.fileOperationResult=ye,this.size=_}}e.$$k=j;class L extends N{constructor(pe,ye,_){super(pe,2,_),this.stat=ye}}e.$_k=L;var z;(function(te){te[te.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",te[te.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",te[te.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",te[te.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",te[te.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",te[te.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",te[te.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",te[te.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",te[te.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",te[te.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",te[te.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(z||(e.FileOperationResult=z={})),e.$al={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$bl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$cl="files.associations",e.$dl="files.exclude",e.$el="files.readonlyInclude",e.$fl="files.readonlyExclude",e.$gl="files.readonlyFromPermissions";var Q;(function(te){te[te.FILE=0]="FILE",te[te.FOLDER=1]="FOLDER",te[te.ROOT_FOLDER=2]="ROOT_FOLDER"})(Q||(e.FileKind=Q={})),e.$hl="";function Y(te){if(!(typeof te.size!="number"||typeof te.mtime!="number"))return te.mtime.toString(29)+te.size.toString(31)}async function J(te,pe){if(!pe.hasProvider(O.URI.from({scheme:te.scheme})))return new Promise(ye=>{const _=pe.onDidChangeFileSystemProviderRegistrations(U=>{U.scheme===te.scheme&&U.added&&(_.dispose(),ye())})})}class x{static formatSize(pe){return(0,M.$Zf)(pe)||(pe=0),pe<x.KB?(0,p.localize)(1,null,pe.toFixed(0)):pe<x.MB?(0,p.localize)(2,null,(pe/x.KB).toFixed(2)):pe<x.GB?(0,p.localize)(3,null,(pe/x.MB).toFixed(2)):pe<x.TB?(0,p.localize)(4,null,(pe/x.GB).toFixed(2)):(0,p.localize)(5,null,(pe/x.TB).toFixed(2))}}e.$kl=x,x.KB=1024,x.MB=x.KB*x.KB,x.GB=x.MB*x.KB,x.TB=x.GB*x.KB;function ce(te){const pe=typeof te=="string"||te?.scheme===A.Schemas.vscodeRemote;return typeof te!="string"&&te?.scheme===A.Schemas.file?1024*x.MB:pe?10*x.MB:w.$i?50*x.MB:1024*x.MB}}),define(Ee[251],Ce([1,0,21,13,211,32]),function(re,e,o,R,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uq=O;async function O(A,P,b,C,y,a){let m;try{await p(A,P,b,C,y,a)}catch(l){m=l}finally{m&&y.errorTransformer&&(m=y.errorTransformer(m)),typeof m<"u"&&b.error(m),b.end()}}async function p(A,P,b,C,y,a){$(a);const m=await A.open(P,{create:!1});try{$(a);let l=0,i=0,n=y&&typeof y.length=="number"?y.length:void 0,r=o.$ue.alloc(Math.min(y.bufferSize,typeof n=="number"?n:y.bufferSize)),s=y&&typeof y.position=="number"?y.position:0,t=0;do i=await A.read(m,s,r.buffer,t,r.byteLength-t),s+=i,t+=i,l+=i,typeof n=="number"&&(n-=i),t===r.byteLength&&(await b.write(C(r)),r=o.$ue.alloc(Math.min(y.bufferSize,typeof n=="number"?n:y.bufferSize)),t=0);while(i>0&&(typeof n!="number"||n>0)&&$(a)&&w(l,y));if(t>0){let g=t;typeof n=="number"&&(g=Math.min(t,n)),b.write(C(r.slice(0,g)))}}catch(l){throw(0,M.$3k)(l)}finally{await A.close(m)}}function $(A){if(A.isCancellationRequested)throw(0,R.$6)();return!0}function w(A,P){if(typeof P?.limits?.size=="number"&&A>P.limits.size)throw(0,M.$2k)((0,I.localize)(0,null),M.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(Ee[64],Ce([1,0,35,3,17,11,2,32]),function(re,e,o,R,I,M,O,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aq=e.$zq=e.$yq=void 0,e.$wq=$,e.$xq=w,e.$Bq=C,e.$Cq=y,e.$Dq=a,e.$Eq=m;function $(i){return typeof i.correlationId=="number"}function w(i){return i.recursive===!0}class A extends R.$Uc{constructor(n,r,s,t){super(),this.h=n,this.j=r,this.m=s,this.n=t,this.c=this.B(new R.$Vc),this.f=void 0,this.g=0}s(){const n=new R.$Tc;this.c.value=n,this.b=this.r(n),this.b.setVerboseLogging(this.m),n.add(this.b.onDidChangeFile(r=>this.h(r))),n.add(this.b.onDidLogMessage(r=>this.j(r))),n.add(this.b.onDidError(r=>this.t(r)))}t(n){this.n.restartOnError?this.g<A.a&&this.f?(this.w(`restarting watcher after error: ${n}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${n}`):this.w(n)}u(n){this.g++,this.s(),this.watch(n)}async watch(n){this.f=n,await this.b?.watch(n)}async setVerboseLogging(n){this.m=n,await this.b?.setVerboseLogging(n)}w(n){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${n}`})}y(n){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${n}`})}dispose(){return this.b=void 0,super.dispose()}}e.$yq=A,A.a=5;class P extends A{constructor(n,r,s){super(n,r,s,{type:"node.js",restartOnError:!1})}}e.$zq=P;class b extends A{constructor(n,r,s){super(n,r,s,{type:"universal",restartOnError:!0})}}e.$Aq=b;function C(i){return i.map(n=>({type:n.type,resource:O.URI.revive(n.resource),cId:n.cId}))}function y(i){const n=new l;for(const r of i)n.processEvent(r);return n.coalesce()}function a(i,n){return typeof n=="string"&&!n.startsWith(o.$$j)&&!(0,I.$jc)(n)?{base:i,pattern:n}:n}function m(i,n){const r=[];for(const s of n)r.push((0,o.$ck)(a(i,s)));return r}class l{constructor(){this.a=new Set,this.b=new Map}c(n){return M.$e?n.resource.fsPath:n.resource.fsPath.toLowerCase()}processEvent(n){const r=this.b.get(this.c(n));let s=!1;if(r){const t=r.type,g=n.type;r.resource.fsPath!==n.resource.fsPath&&(n.type===2||n.type===1)?s=!0:t===1&&g===2?(this.b.delete(this.c(n)),this.a.delete(r)):t===2&&g===1?r.type=0:t===1&&g===0||(r.type=g)}else s=!0;s&&(this.a.add(n),this.b.set(this.c(n),n))}coalesce(){const n=[],r=[];return Array.from(this.a).filter(s=>s.type!==2?(n.push(s),!1):!0).sort((s,t)=>s.resource.fsPath.length-t.resource.fsPath.length).filter(s=>r.some(t=>(0,p.$9k)(s.resource.fsPath,t,!M.$e))?!1:(r.push(s.resource.fsPath),!0)).concat(n)}}}),define(Ee[252],Ce([1,0,50,3,64,4,2]),function(re,e,o,R,I,M,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nq=void 0;class p extends R.$Uc{constructor(){super(),this.a=this.B(new M.$7d),this.onDidChangeFile=this.a.event,this.b=this.B(new M.$7d),this.onDidLogMessage=this.b.event,this.c=this.B(new M.$7d),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new R.$4c),this.m=5007,this.B(this.f(w=>this.n(w)))}n(w){this.r(w)&&this.t(w)}r(w){return(0,I.$wq)(w)}async watch(w){this.h.clear(),this.g.clear();for(const A of w)this.r(A)?this.h.set(A.correlationId,A):this.g.add(A);for(const[A]of this.j)this.h.has(A)||this.j.deleteAndDispose(A);return this.s()}s(){return this.D([...this.g,...Array.from(this.h.values()).filter(w=>!this.j.has(w.correlationId))])}t(w){if(this.j.has(w.correlationId))return;const A=new R.$Tc;this.j.set(w.correlationId,A),this.w(w,A),this.s()}u(w){this.j.deleteAndDispose(w.correlationId),this.s()}w(w,A){const P=O.URI.file(w.path),b=this;let C=!1;const y=(a,m)=>{if(A.isDisposed)return;const l=this.y(a),i=this.y(m),n=C;if(C=l,!l&&(i||n)){this.F(`fs.watchFile() detected ${w.path} exists again, resuming watcher (correlationId: ${w.correlationId})`);const r={resource:P,type:1,cId:w.correlationId};b.a.fire([r]),this.z(r,w),this.u(w)}};this.F(`starting fs.watchFile() on ${w.path} (correlationId: ${w.correlationId})`);try{(0,o.watchFile)(w.path,{persistent:!1,interval:this.m},y)}catch(a){this.G(`fs.watchFile() failed with error ${a} on path ${w.path} (correlationId: ${w.correlationId})`)}A.add((0,R.$Sc)(()=>{this.F(`stopping fs.watchFile() on ${w.path} (correlationId: ${w.correlationId})`);try{(0,o.unwatchFile)(w.path,y)}catch(a){this.G(`fs.unwatchFile() failed with error ${a} on path ${w.path} (correlationId: ${w.correlationId})`)}}))}y(w){return w.ctimeMs===0&&w.ino===0}async stop(){this.j.clearAndDisposeAll()}z(w,A){const P=` >> normalized ${w.type===1?"[ADDED]":w.type===2?"[DELETED]":"[CHANGED]"} ${w.resource.fsPath}`;this.F(typeof A.correlationId=="number"?`${P} (correlationId: ${A.correlationId})`:P)}C(w){return`${w.path} (excludes: ${w.excludes.length>0?w.excludes:"<none>"}, includes: ${w.includes&&w.includes.length>0?JSON.stringify(w.includes):"<all>"}, correlationId: ${typeof w.correlationId=="number"?w.correlationId:"<none>"})`}}e.$Nq=p}),define(Ee[253],Ce([1,0,50,8,22,34,3,76,17,11,23,2,103,31,64]),function(re,e,o,R,I,M,O,p,$,w,A,P,b,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sq=void 0,e.$Tq=m;class a extends O.$Uc{constructor(i,n,r,s,t){super(),this.m=i,this.n=n,this.r=r,this.s=s,this.t=t,this.c=this.B(new R.$xh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},g=>this.n(g))),this.f=this.B(new R.$wh(g=>this.D(g),a.b)),this.g=(0,y.$Eq)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,y.$Eq)(this.m.path,this.m.includes):void 0,this.j=new I.$ee,this.ready=this.u()}async u(){try{const i=await this.w(this.m);if(this.j.token.isCancellationRequested)return;const n=await C.Promises.stat(i);if(this.j.token.isCancellationRequested)return;this.B(await this.y(i,n.isDirectory()))}catch(i){i.code!=="ENOENT"?this.G(i):this.I(`ignoring a path for watching who's stat info failed to resolve: ${this.m.path} (error: ${i})`),this.r?.()}}async w(i){let n=i.path;try{n=await C.Promises.realpath(i.path),i.path===n&&(n=await(0,b.$Pq)(i.path,this.j.token)??i.path),i.path!==n&&this.I(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${i.path}, real: ${n})`)}catch{}return n}async y(i,n){if(w.$d&&(0,M.$ig)(i,"/Volumes/",!0))return this.G(`Refusing to watch ${i} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),O.$Uc.None;const r=new I.$ee(this.j.token),s=new O.$Tc;try{const t=P.URI.file(this.m.path),g=(0,$.$oc)(i),d=(0,o.watch)(i);s.add((0,O.$Sc)(()=>{d.removeAllListeners(),d.close()})),this.I(`Started watching: '${i}'`);const h=new Set;if(n)try{for(const u of await C.Promises.readdir(i))h.add(u)}catch(u){this.G(u)}const c=new Map;s.add((0,O.$Sc)(()=>{for(const[,u]of c)u.dispose();c.clear()})),d.on("error",(u,f)=>{this.G(`Failed to watch ${i} for changes using fs.watch() (${u}, ${f})`),this.r?.()}),d.on("change",(u,f)=>{if(r.token.isCancellationRequested)return;this.I(`[raw] ["${u}"] ${f}`);let E="";if(f&&(E=f.toString(),w.$d&&(E=(0,p.$1l)(E))),!(!E||u!=="change"&&u!=="rename"))if(n)if(u==="rename"){c.get(E)?.dispose();const v=setTimeout(async()=>{if(c.delete(E),E===g&&!await C.Promises.exists(i)){this.z(t);return}const D=await this.F((0,$.$kc)(i,E));if(r.token.isCancellationRequested)return;let k;D?h.has(E)?k=0:(k=1,h.add(E)):(h.delete(E),k=2),this.C({resource:(0,A.$Vg)(t,E),type:k,cId:this.m.correlationId})},a.a);c.set(E,(0,O.$Sc)(()=>clearTimeout(v)))}else{let v;h.has(E)?v=0:(v=1,h.add(E)),this.C({resource:(0,A.$Vg)(t,E),type:v,cId:this.m.correlationId})}else if(u==="rename"||E!==g){const v=setTimeout(async()=>{const D=await C.Promises.exists(i);r.token.isCancellationRequested||(D?(this.C({resource:t,type:0,cId:this.m.correlationId},!0),s.add(await this.y(i,!1))):this.z(t))},a.a);s.clear(),s.add((0,O.$Sc)(()=>clearTimeout(v)))}else this.C({resource:t,type:0,cId:this.m.correlationId},!0)})}catch(t){r.token.isCancellationRequested||this.G(`Failed to watch ${i} for changes using fs.watch() (${t.toString()})`),this.r?.()}return(0,O.$Sc)(()=>{r.dispose(!0),s.dispose()})}z(i){this.H("Watcher shutdown because watched path got deleted"),this.C({resource:i,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.r?.()}C(i,n=!1){this.j.token.isCancellationRequested||(this.t&&this.I(`${i.type===1?"[ADDED]":i.type===2?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`),!n&&this.g.some(r=>r(i.resource.fsPath))?this.t&&this.I(` >> ignored (excluded) ${i.resource.fsPath}`):!n&&this.h&&this.h.length>0&&!this.h.some(r=>r(i.resource.fsPath))?this.t&&this.I(` >> ignored (not included) ${i.resource.fsPath}`):this.f.work(i))}D(i){const n=(0,y.$Cq)(i);if(n.length>0){if(this.t)for(const s of n)this.I(` >> normalized ${s.type===1?"[ADDED]":s.type===2?"[DELETED]":"[CHANGED]"} ${s.resource.fsPath}`);this.c.work(n)?this.c.pending>0&&this.I(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${n[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.H(`started ignoring events due to too many file change events at once (incoming: ${n.length}, most recent change: ${n[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async F(i){if(w.$e)return C.Promises.exists(i);try{const n=(0,$.$oc)(i);return(await C.Promises.readdir((0,$.$nc)(i))).some(s=>s===n)}catch(n){return this.I(n),!1}}setVerboseLogging(i){this.t=i}G(i){this.j.token.isCancellationRequested||this.s?.({type:"error",message:`[File Watcher (node.js)] ${i}`})}H(i){this.j.token.isCancellationRequested||this.s?.({type:"warn",message:`[File Watcher (node.js)] ${i}`})}I(i){!this.j.token.isCancellationRequested&&this.t&&this.s?.({type:"trace",message:`[File Watcher (node.js)] ${i}`})}dispose(){this.j.dispose(!0),super.dispose()}}e.$Sq=a,a.a=100,a.b=75;async function m(l,i,n,r,s=512){const t=await C.Promises.open(l,"r"),g=Buffer.allocUnsafe(s),d=new I.$ee(r);let h,c=!1;const u={path:l,excludes:[],recursive:!1},f=new a(u,E=>{(async()=>{for(const{type:v}of E)if(v===0){if(c)return;c=!0;try{for(;!d.token.isCancellationRequested;){const{bytesRead:D}=await C.Promises.read(t,g,0,s,null);if(!D||d.token.isCancellationRequested)break;i(g.slice(0,D))}}catch(D){h=new Error(D),d.dispose(!0)}finally{c=!1}}})()});return await f.ready,n(),new Promise((E,v)=>{d.token.onCancellationRequested(async()=>{f.dispose();try{await C.Promises.close(t)}catch(D){h=new Error(D)}h?v(h):E()})})}}),define(Ee[254],Ce([1,0,4,35,252,11,253,34]),function(re,e,o,R,I,M,O,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=void 0;class $ extends I.$Nq{constructor(){super(...arguments),this.onDidError=o.Event.None,this.H=new Set,this.I=!1}async D(A){A=this.O(A);const P=[],b=new Set(Array.from(this.H));for(const C of A){const y=this.L(C);y&&(0,R.$gk)(y.request.excludes,C.excludes)&&(0,R.$gk)(y.request.includes,C.includes)?b.delete(y):P.push(C)}P.length&&this.F(`Request to start watching: ${P.map(C=>this.C(C)).join(",")}`),b.size&&this.F(`Request to stop watching: ${Array.from(b).map(C=>this.C(C.request)).join(",")}`);for(const C of b)this.N(C);for(const C of P)this.M(C)}L(A){for(const P of this.H)if(typeof A.correlationId=="number"||typeof P.request.correlationId=="number"){if(P.request.correlationId===A.correlationId)return P}else if((0,p.$hg)(P.request.path,A.path,!M.$e))return P}M(A){const P=new O.$Sq(A,C=>this.a.fire(C),()=>this.c.fire(A),C=>this.b.fire(C),this.I),b={request:A,instance:P};this.H.add(b)}async stop(){await super.stop();for(const A of this.H)this.N(A)}N(A){this.F("stopping file watcher",A),this.H.delete(A),A.instance.dispose()}O(A){const P=new Map;for(const b of A){const C=M.$e?b.path:b.path.toLowerCase();let y=P.get(b.correlationId);y||(y=new Map,P.set(b.correlationId,y)),y.has(C)&&this.F(`ignoring a request for watching who's path is already watched: ${this.C(b)}`),y.set(C,b)}return Array.from(P.values()).map(b=>Array.from(b.values())).flat()}async setVerboseLogging(A){this.I=A;for(const P of this.H)P.instance.setVerboseLogging(A)}F(A,P){this.I&&this.b.fire({type:"trace",message:this.R(A,P)})}G(A){this.b.fire({type:"warn",message:this.R(A)})}R(A,P){return P?`[File Watcher (node.js)] ${A} (${this.C(P.request)})`:`[File Watcher (node.js)] ${A}`}}e.$Uq=$}),define(Ee[255],Ce([1,0,64,254]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vq=void 0;class I extends o.$zq{constructor(O,p,$){super(O,p,$),this.s()}r(O){return O.add(new R.$Uq)}}e.$Vq=I}),define(Ee[256],Ce([1,0,15,80,177,64]),function(re,e,o,R,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mq=void 0;class O extends M.$Aq{constructor($,w,A){super($,w,A),this.s()}r($){const w=$.add(new I.$Lq(o.$Cg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return $.add(w.onDidProcessExit(({code:A,signal:P})=>this.t(`terminated by itself with code ${A}, signal: ${P}`))),R.ProxyChannel.toService((0,R.$2h)(w.getChannel("watcher")))}}e.$Mq=O}),define(Ee[107],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gi=void 0;class o{constructor(...I){this.a=new Map;for(const[M,O]of I)this.set(M,O)}set(I,M){const O=this.a.get(I);return this.a.set(I,M),O}has(I){return this.a.has(I)}get(I){return this.a.get(I)}}e.$gi=o}),define(Ee[257],Ce([1,0,8,13,3,106,247,5,107,75]),function(re,e,o,R,I,M,O,p,$,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=e.$Zq=void 0;const A=!1;class P extends Error{constructor(m){super("cyclic dependency between services"),this.message=m.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${m.toString()}`}}class b{constructor(m=new $.$gi,l=!1,i,n=A){this.f=m,this.g=l,this.h=i,this.i=n,this.o=new Set,this.f.set(p.$hi,this),this._globalGraph=n?i?._globalGraph??new O.$Yq(r=>r):void 0}createChild(m){return new b(m,this.g,this,this.i)}invokeFunction(m,...l){const i=y.traceInvocation(this.i,m);let n=!1;try{return m({get:s=>{if(n)throw(0,R.$8)("service accessor is only valid during the invocation of its target method");const t=this.m(s,i);if(!t)throw new Error(`[invokeFunction] unknown service '${s}'`);return t}},...l)}finally{n=!0,i.stop()}}createInstance(m,...l){let i,n;return m instanceof M.$fi?(i=y.traceCreation(this.i,m.ctor),n=this.j(m.ctor,m.staticArguments.concat(l),i)):(i=y.traceCreation(this.i,m),n=this.j(m,l,i)),i.stop(),n}j(m,l=[],i){const n=p._util.getServiceDependencies(m).sort((t,g)=>t.index-g.index),r=[];for(const t of n){const g=this.m(t.id,i);g||this.u(`[createInstance] ${m.name} depends on UNKNOWN service ${t.id}.`,!1),r.push(g)}const s=n.length>0?n[0].index:l.length;if(l.length!==s){console.trace(`[createInstance] First service dependency of ${m.name} at position ${s+1} conflicts with ${l.length} static arguments`);const t=s-l.length;t>0?l=l.concat(new Array(t)):l=l.slice(0,s)}return Reflect.construct(m,l.concat(r))}k(m,l){if(this.f.get(m)instanceof M.$fi)this.f.set(m,l);else if(this.h)this.h.k(m,l);else throw new Error("illegalState - setting UNKNOWN service instance")}l(m){const l=this.f.get(m);return!l&&this.h?this.h.l(m):l}m(m,l){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(m));const i=this.l(m);return i instanceof M.$fi?this.q(m,i,l.branch(m,!0)):(l.branch(m,!1),i)}q(m,l,i){if(this.o.has(m))throw new Error(`illegal state - RECURSIVELY instantiating service '${m}'`);this.o.add(m);try{return this.r(m,l,i)}finally{this.o.delete(m)}}r(m,l,i){const n=new O.$Yq(t=>t.id.toString());let r=0;const s=[{id:m,desc:l,_trace:i}];for(;s.length;){const t=s.pop();if(n.lookupOrInsertNode(t),r++>1e3)throw new P(n);for(const g of p._util.getServiceDependencies(t.desc.ctor)){const d=this.l(g.id);if(d||this.u(`[createInstance] ${m} depends on ${g.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(g.id)),d instanceof M.$fi){const h={id:g.id,desc:d,_trace:t._trace.branch(g.id,!0)};n.insertEdge(t,h),s.push(h)}}}for(;;){const t=n.roots();if(t.length===0){if(!n.isEmpty())throw new P(n);break}for(const{data:g}of t){if(this.l(g.id)instanceof M.$fi){const h=this.s(g.id,g.desc.ctor,g.desc.staticArguments,g.desc.supportsDelayedInstantiation,g._trace);this.k(g.id,h)}n.removeNode(g)}}return this.l(m)}s(m,l,i=[],n,r){if(this.f.get(m)instanceof M.$fi)return this.t(m,l,i,n,r);if(this.h)return this.h.s(m,l,i,n,r);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}t(m,l,i=[],n,r){if(n){const s=new b(void 0,this.g,this,this.i);s.c=String(m);const t=new Map,g=new o.$Bh(()=>{const d=s.j(l,i,r);for(const[h,c]of t){const u=d[h];if(typeof u=="function")for(const f of c)f.disposable=u.apply(d,f.listener)}return t.clear(),d});return new Proxy(Object.create(null),{get(d,h){if(!g.isInitialized&&typeof h=="string"&&(h.startsWith("onDid")||h.startsWith("onWill"))){let f=t.get(h);return f||(f=new w.$5c,t.set(h,f)),(v,D,k)=>{if(g.isInitialized)return g.value[h](v,D,k);{const S={listener:[v,D,k],disposable:void 0},F=f.push(S);return(0,I.$Sc)(()=>{F(),S.disposable?.dispose()})}}}if(h in d)return d[h];const c=g.value;let u=c[h];return typeof u!="function"||(u=u.bind(c),d[h]=u),u},set(d,h,c){return g.value[h]=c,!0},getPrototypeOf(d){return l.prototype}})}else return this.j(l,i,r)}u(m,l){if(l&&console.warn(m),this.g)throw new Error(m)}}e.$Zq=b;var C;(function(a){a[a.None=0]="None",a[a.Creation=1]="Creation",a[a.Invocation=2]="Invocation",a[a.Branch=3]="Branch"})(C||(C={}));class y{static traceInvocation(m,l){return m?new y(2,l.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):y.c}static traceCreation(m,l){return m?new y(1,l.name):y.c}constructor(m,l){this.type=m,this.name=l,this.g=Date.now(),this.h=[]}branch(m,l){const i=new y(3,m.toString());return this.h.push([m,l,i]),i}stop(){const m=Date.now()-this.g;y.f+=m;let l=!1;function i(r,s){const t=[],g=new Array(r+1).join("	");for(const[d,h,c]of s.h)if(h&&c){l=!0,t.push(`${g}CREATES -> ${d}`);const u=i(r+1,c);u&&t.push(u)}else t.push(`${g}uses -> ${d}`);return t.join(`
`)}const n=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${i(1,this)}`,`DONE, took ${m.toFixed(2)}ms (grand total ${y.f.toFixed(2)}ms)`];(m>2||l)&&y.all.add(n.join(`
`))}}e.$1q=y,y.all=new Set,y.c=new class extends y{constructor(){super(0,null)}stop(){}branch(){return this}},y.f=0}),define(Ee[12],Ce([1,0,213,47,4,55,3,27,11,23,18,2,42,5]),function(re,e,o,R,I,M,O,p,$,w,A,P,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Rj=e.LogLevel=e.$Pj=e.$Oj=void 0,e.$Qj=a,e.log=l,e.$3j=f,e.$4j=E,e.$5j=v,e.$6j=D,e.$Oj=(0,C.$ii)("logService"),e.$Pj=(0,C.$ii)("loggerService");function y(){return new Date().toISOString()}function a(k){return(0,A.$Zf)(k)}var m;(function(k){k[k.Off=0]="Off",k[k.Trace=1]="Trace",k[k.Debug=2]="Debug",k[k.Info=3]="Info",k[k.Warning=4]="Warning",k[k.Error=5]="Error"})(m||(e.LogLevel=m={})),e.$Rj=m.Info;function l(k,S,F){switch(S){case m.Trace:k.trace(F);break;case m.Debug:k.debug(F);break;case m.Info:k.info(F);break;case m.Warning:k.warn(F);break;case m.Error:k.error(F);break;case m.Off:break;default:throw new Error(`Invalid log level ${S}`)}}function i(k,S=!1){let F="";for(let W=0;W<k.length;W++){let B=k[W];if(B instanceof Error&&(B=(0,R.$6i)(B,S)),typeof B=="object")try{B=JSON.stringify(B)}catch{}F+=(W>0?" ":"")+B}return F}class n extends O.$Uc{constructor(){super(...arguments),this.b=e.$Rj,this.c=this.B(new I.$7d),this.onDidChangeLogLevel=this.c.event}setLevel(S){this.b!==S&&(this.b=S,this.c.fire(this.b))}getLevel(){return this.b}f(S){return this.b!==m.Off&&this.b<=S}}e.$Tj=n;class r extends n{constructor(S){super(),this.h=S}f(S){return this.h||super.f(S)}trace(S,...F){this.f(m.Trace)&&this.g(m.Trace,i([S,...F],!0))}debug(S,...F){this.f(m.Debug)&&this.g(m.Debug,i([S,...F]))}info(S,...F){this.f(m.Info)&&this.g(m.Info,i([S,...F]))}warn(S,...F){this.f(m.Warning)&&this.g(m.Warning,i([S,...F]))}error(S,...F){if(this.f(m.Error))if(S instanceof Error){const W=Array.prototype.slice.call(arguments);W[0]=S.stack,this.g(m.Error,i(W))}else this.g(m.Error,i([S,...F]))}flush(){}}e.$Uj=r;class s extends n{constructor(S=e.$Rj){super(),this.setLevel(S),this.g=!$.$c}trace(S,...F){this.f(m.Trace)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,S,...F):console.log(`[main ${y()}]`,S,...F))}debug(S,...F){this.f(m.Debug)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,S,...F):console.log(`[main ${y()}]`,S,...F))}info(S,...F){this.f(m.Info)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,S,...F):console.log(`[main ${y()}]`,S,...F))}warn(S,...F){this.f(m.Warning)&&(this.g?console.warn(`\x1B[93m[main ${y()}]\x1B[0m`,S,...F):console.warn(`[main ${y()}]`,S,...F))}error(S,...F){this.f(m.Error)&&(this.g?console.error(`\x1B[91m[main ${y()}]\x1B[0m`,S,...F):console.error(`[main ${y()}]`,S,...F))}flush(){}}e.$Vj=s;class t extends n{constructor(S=e.$Rj,F=!0){super(),this.g=F,this.setLevel(S)}trace(S,...F){this.f(m.Trace)&&(this.g?console.log("%cTRACE","color: #888",S,...F):console.log(S,...F))}debug(S,...F){this.f(m.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",S,...F):console.log(S,...F))}info(S,...F){this.f(m.Info)&&(this.g?console.log("%c INFO","color: #33f",S,...F):console.log(S,...F))}warn(S,...F){this.f(m.Warning)&&(this.g?console.log("%c WARN","color: #993",S,...F):console.log(S,...F))}error(S,...F){this.f(m.Error)&&(this.g?console.log("%c  ERR","color: #f33",S,...F):console.error(S,...F))}flush(){}}e.$Wj=t;class g extends n{constructor(S,F=e.$Rj){super(),this.g=S,this.setLevel(F)}trace(S,...F){this.f(m.Trace)&&this.g.log(m.Trace,[this.h(S),...F])}debug(S,...F){this.f(m.Debug)&&this.g.log(m.Debug,[this.h(S),...F])}info(S,...F){this.f(m.Info)&&this.g.log(m.Info,[this.h(S),...F])}warn(S,...F){this.f(m.Warning)&&this.g.log(m.Warning,[this.h(S),...F])}error(S,...F){this.f(m.Error)&&this.g.log(m.Error,[this.h(S),...F])}h(S){return typeof S=="string"?S:(0,R.$6i)(S,this.f(m.Trace))}flush(){}}e.$Xj=g;class d extends n{constructor(S){super(),this.g=S,S.length&&this.setLevel(S[0].getLevel())}setLevel(S){for(const F of this.g)F.setLevel(S);super.setLevel(S)}trace(S,...F){for(const W of this.g)W.trace(S,...F)}debug(S,...F){for(const W of this.g)W.debug(S,...F)}info(S,...F){for(const W of this.g)W.info(S,...F)}warn(S,...F){for(const W of this.g)W.warn(S,...F)}error(S,...F){for(const W of this.g)W.error(S,...F)}flush(){for(const S of this.g)S.flush()}dispose(){for(const S of this.g)S.dispose();super.dispose()}}e.$Yj=d;class h extends O.$Uc{constructor(S,F,W){if(super(),this.h=S,this.j=F,this.b=new p.$Bc,this.c=this.B(new I.$7d),this.onDidChangeLoggers=this.c.event,this.f=this.B(new I.$7d),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new I.$7d),this.onDidChangeVisibility=this.g.event,W)for(const B of W)this.b.set(B.resource,{logger:void 0,info:B})}m(S){return(0,A.$Vf)(S)?[...this.b.values()].find(F=>F.info.id===S):this.b.get(S)}getLogger(S){return this.m(S)?.logger}createLogger(S,F){const W=this.n(S),B=(0,A.$Vf)(S)?S:F?.id??(0,M.$9i)(W.toString()).toString(16);let T=this.b.get(W)?.logger;const N=F?.logLevel==="always"?m.Trace:F?.logLevel;T||(T=this.s(W,N??this.getLogLevel(W)??this.h,{...F,id:B}));const j={logger:T,info:{resource:W,id:B,logLevel:N,name:F?.name,hidden:F?.hidden,extensionId:F?.extensionId,when:F?.when}};return this.registerLogger(j.info),this.b.set(W,j),T}n(S){return(0,A.$Vf)(S)?(0,w.$Vg)(this.j,`${S}.log`):S}setLogLevel(S,F){if(P.URI.isUri(S)){const W=S,B=F,T=this.b.get(W);T&&B!==T.info.logLevel&&(T.info.logLevel=B===this.h?void 0:B,T.logger?.setLevel(B),this.b.set(T.info.resource,T),this.f.fire([W,B]))}else{this.h=S;for(const[W,B]of this.b.entries())this.b.get(W)?.info.logLevel===void 0&&B.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(S,F){const W=this.m(S);W&&F!==!W.info.hidden&&(W.info.hidden=!F,this.b.set(W.info.resource,W),this.g.fire([W.info.resource,F]))}getLogLevel(S){let F;return S&&(F=this.b.get(S)?.info.logLevel),F??this.h}registerLogger(S){const F=this.b.get(S.resource);F?F.info.hidden!==S.hidden&&this.setVisibility(S.resource,!S.hidden):(this.b.set(S.resource,{info:S,logger:void 0}),this.c.fire({added:[S],removed:[]}))}deregisterLogger(S){const F=this.b.get(S);F&&(F.logger&&F.logger.dispose(),this.b.delete(S),this.c.fire({added:[],removed:[F.info]}))}*getRegisteredLoggers(){for(const S of this.b.values())yield S.info}getRegisteredLogger(S){return this.b.get(S)?.info}dispose(){this.b.forEach(S=>S.logger?.dispose()),this.b.clear(),super.dispose()}}e.$Zj=h;class c{constructor(){this.onDidChangeLogLevel=new I.$7d().event}setLevel(S){}getLevel(){return m.Info}trace(S,...F){}debug(S,...F){}info(S,...F){}warn(S,...F){}error(S,...F){}critical(S,...F){}dispose(){}flush(){}}e.$1j=c;class u extends c{}e.$2j=u;function f(k){if(k.verbose)return m.Trace;if(typeof k.logLevel=="string"){const S=D(k.logLevel.toLowerCase());if(S!==void 0)return S}return e.$Rj}function E(k){switch(k){case m.Trace:return"trace";case m.Debug:return"debug";case m.Info:return"info";case m.Warning:return"warn";case m.Error:return"error";case m.Off:return"off"}}function v(k){switch(k){case m.Trace:return{original:"Trace",value:o.localize(0,null)};case m.Debug:return{original:"Debug",value:o.localize(1,null)};case m.Info:return{original:"Info",value:o.localize(2,null)};case m.Warning:return{original:"Warning",value:o.localize(3,null)};case m.Error:return{original:"Error",value:o.localize(4,null)};case m.Off:return{original:"Off",value:o.localize(5,null)}}}function D(k){switch(k){case"trace":return m.Trace;case"debug":return m.Debug;case"info":return m.Info;case"warn":return m.Warning;case"error":return m.Error;case"critical":return m.Error;case"off":return m.Off}}e.$7j=new b.$zj("logLevel",E(m.Info))}),define(Ee[258],Ce([1,0,19,8,13,4,3,17,64,12]),function(re,e,o,R,I,M,O,p,$,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fq=void 0;class A extends O.$Uc{constructor(b,C){super(),this.a=b,this.b=C,this.c=this.B(new M.$7d),this.onDidChangeFile=this.c.event,this.g=this.B(new M.$7d),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new R.$gh(0)),this.w=[],this.y=this.B(new R.$gh(0))}watch(b,C){return C.recursive||this.b?.watcher?.forceUniversal?this.n(b,C):this.z(b,C)}n(b,C){const y={path:this.H(b),excludes:C.excludes,includes:C.includes,recursive:C.recursive,correlationId:C.correlationId},a=(0,o.$Ub)(this.j,y);return this.r(),(0,O.$Sc)(()=>{a(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(b=>(0,I.$1)(b))}s(){this.h||(this.h=this.B(this.t(C=>this.c.fire((0,$.$Bq)(C)),C=>this.G(C),this.a.getLevel()===w.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===w.LogLevel.Trace)})));const b=this.b?.watcher?.recursive?.usePolling;if(b===!0)for(const C of this.j)(0,$.$xq)(C)&&(C.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(b))for(const C of this.j)(0,$.$xq)(C)&&b.includes(C.path)&&(C.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(b,C){const y={path:this.H(b),excludes:C.excludes,includes:C.includes,recursive:!1,correlationId:C.correlationId},a=(0,o.$Ub)(this.w,y);return this.C(),(0,O.$Sc)(()=>{a(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(b=>(0,I.$1)(b))}D(){return this.u||(this.u=this.B(this.F(b=>this.c.fire((0,$.$Bq)(b)),b=>this.G(b),this.a.getLevel()===w.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===w.LogLevel.Trace)}))),this.u.watch(this.w)}G(b){b.type==="error"&&this.g.fire(b.message),this.a[b.type](b.message)}H(b){return(0,p.$ic)(b.fsPath)}}e.$Fq=A}),define(Ee[259],Ce([1,0,50,397,8,27,21,4,34,3,17,11,23,100,31,212,32,251,258,47,256,255]),function(re,e,o,R,I,M,O,p,$,w,A,P,b,C,y,a,m,l,i,n,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wq=void 0,(()=>{try{(0,R.gracefulify)(o)}catch(g){console.error(`Error enabling graceful-fs: ${(0,n.$6i)(g)}`)}})();class t extends i.$Fq{constructor(d,h){super(d,h),this.onDidChangeCapabilities=p.Event.None,this.N=new M.$Bc(c=>b.$Mg.getComparisonKey(c)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,P.$e&&(this.J|=1024)),this.J}async stat(d){try{const{stat:h,symbolicLink:c}=await y.SymlinkSupport.stat(this.H(d));return{type:this.M(h,c),ctime:h.birthtime.getTime(),mtime:h.mtime.getTime(),size:h.size,permissions:h.mode&128?void 0:m.FilePermission.Locked}}catch(h){throw this.fb(h)}}async L(d){try{return await this.stat(d)}catch{return}}async readdir(d){try{const h=await y.Promises.readdir(this.H(d),{withFileTypes:!0}),c=[];return await Promise.all(h.map(async u=>{try{let f;u.isSymbolicLink()?f=(await this.stat((0,b.$Vg)(d,u.name))).type:f=this.M(u),c.push([u.name,f])}catch(f){this.a.trace(f)}})),c}catch(h){throw this.fb(h)}}M(d,h){let c;return h?.dangling?c=m.FileType.Unknown:d.isFile()?c=m.FileType.File:d.isDirectory()?c=m.FileType.Directory:c=m.FileType.Unknown,h&&(c|=m.FileType.SymbolicLink),c}async O(d){const h=this.H(d);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${h})`);let c;for(;c=this.N.get(d);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${h})`),await c.wait();const u=new I.$hh;return this.N.set(d,u),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${h})`),(0,w.$Sc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${h})`),this.N.get(d)===u&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${h})`),this.N.delete(d)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${h})`),u.open()})}async readFile(d,h){let c;try{h?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(d)})`),c=await this.O(d));const u=this.H(d);return await y.Promises.readFile(u)}catch(u){throw this.fb(u)}finally{c?.dispose()}}P(d){t.I&&this.a.trace(d)}readFileStream(d,h,c){const u=(0,C.$ie)(f=>O.$ue.concat(f.map(E=>O.$ue.wrap(E))).buffer);return(0,l.$uq)(this,d,u,f=>f.buffer,{...h,bufferSize:256*1024},c),u}async writeFile(d,h,c){return c?.atomic!==!1&&c?.atomic?.postfix&&await this.Q(d)?this.R(d,(0,b.$Vg)((0,b.$Ug)(d),`${(0,b.$Sg)(d)}${c.atomic.postfix}`),h,c):this.S(d,h,c)}async Q(d){try{const h=this.H(d),{symbolicLink:c}=await y.SymlinkSupport.stat(h);if(c)return!1}catch{}return!0}async R(d,h,c,u){const f=new w.$Tc;try{f.add(await this.O(d)),f.add(await this.O(h)),await this.S(h,c,u,!0);try{await this.rename(h,d,{overwrite:!0})}catch(E){try{await this.delete(h,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw E}}finally{f.dispose()}}async S(d,h,c,u){let f;try{const E=this.H(d);if(!c.create||!c.overwrite){if(await y.Promises.exists(E)){if(!c.overwrite)throw(0,m.$2k)((0,a.localize)(0,null),m.FileSystemProviderErrorCode.FileExists)}else if(!c.create)throw(0,m.$2k)((0,a.localize)(1,null),m.FileSystemProviderErrorCode.FileNotFound)}f=await this.open(d,{create:!0,unlock:c.unlock},u),await this.write(f,0,h,0,h.byteLength)}catch(E){throw await this.gb(d,E)}finally{typeof f=="number"&&await this.close(f)}}static configureFlushOnWrite(d){t.Y=d}async open(d,h,c){const u=this.H(d);let f;(0,m.$Pk)(h)&&!c&&(f=await this.O(d));let E;try{if((0,m.$Pk)(h)&&h.unlock)try{const{stat:D}=await y.SymlinkSupport.stat(u);D.mode&128||await y.Promises.chmod(u,D.mode|128)}catch(D){D.code!=="ENOENT"&&this.a.trace(D)}let v;if((0,m.$Pk)(h)){if(P.$c)try{await y.Promises.truncate(u,0),v="r+"}catch(D){D.code!=="ENOENT"&&this.a.trace(D)}v||(v="w")}else v="r";E=await y.Promises.open(u,v)}catch(v){throw f?.dispose(),(0,m.$Pk)(h)?await this.gb(d,v):this.fb(v)}if(this.U.set(E,0),(0,m.$Pk)(h)&&this.X.set(E,d),f){const v=this.W.get(E);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${E} (${u})`),this.W.set(E,f),v&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${E} (${u})`),v.dispose())}return E}async close(d){const h=this.W.get(d);try{if(this.U.delete(d),this.X.delete(d)&&t.Y)try{await y.Promises.fdatasync(d)}catch(c){t.configureFlushOnWrite(!1),this.a.error(c)}return await y.Promises.close(d)}catch(c){throw this.fb(c)}finally{h&&(this.W.get(d)===h&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${d}`),this.W.delete(d)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${d}`),h.dispose())}}async read(d,h,c,u,f){const E=this.Z(d,h);let v=null;try{v=(await y.Promises.read(d,c,u,f,E)).bytesRead}catch(D){throw this.fb(D)}finally{this.$(d,E,v)}return v}Z(d,h){return h===this.U.get(d)?null:h}$(d,h,c){const u=this.U.get(d);typeof u=="number"&&(typeof h=="number"||(typeof c=="number"?this.U.set(d,u+c):this.U.delete(d)))}async write(d,h,c,u,f){return(0,I.$Ch)(()=>this.ab(d,h,c,u,f),100,3)}async ab(d,h,c,u,f){const E=this.Z(d,h);let v=null;try{v=(await y.Promises.write(d,c,u,f,E)).bytesWritten}catch(D){throw await this.gb(this.X.get(d),D)}finally{this.$(d,E,v)}return v}async mkdir(d){try{await y.Promises.mkdir(this.H(d))}catch(h){throw this.fb(h)}}async delete(d,h){try{const c=this.H(d);if(h.recursive){let u;h?.atomic!==!1&&h.atomic.postfix&&(u=(0,A.$kc)((0,A.$nc)(c),`${(0,A.$oc)(c)}${h.atomic.postfix}`)),await y.Promises.rm(c,y.RimRafMode.MOVE,u)}else try{await y.Promises.unlink(c)}catch(u){if(u.code==="EPERM"||u.code==="EISDIR"){let f=!1;try{const{stat:E,symbolicLink:v}=await y.SymlinkSupport.stat(c);f=E.isDirectory()&&!v}catch{}if(f)await y.Promises.rmdir(c);else throw u}else throw u}}catch(c){throw this.fb(c)}}async rename(d,h,c){const u=this.H(d),f=this.H(h);if(u!==f)try{await this.bb(d,h,"move",c.overwrite),await y.Promises.rename(u,f)}catch(E){throw(E.code==="EINVAL"||E.code==="EBUSY"||E.code==="ENAMETOOLONG")&&(E=new Error((0,a.localize)(2,null,(0,A.$oc)(u),(0,A.$oc)((0,A.$nc)(f)),E.toString()))),this.fb(E)}}async copy(d,h,c){const u=this.H(d),f=this.H(h);if(u!==f)try{await this.bb(d,h,"copy",c.overwrite),await y.Promises.copy(u,f,{preserveSymlinks:!0})}catch(E){throw(E.code==="EINVAL"||E.code==="EBUSY"||E.code==="ENAMETOOLONG")&&(E=new Error((0,a.localize)(3,null,(0,A.$oc)(u),(0,A.$oc)((0,A.$nc)(f)),E.toString()))),this.fb(E)}}async bb(d,h,c,u){const f=this.H(d),E=this.H(h);let v=!1;if(!!(this.capabilities&1024)||(v=(0,$.$hg)(f,E,!0)),v){if(c==="copy")throw(0,m.$2k)((0,a.localize)(4,null),m.FileSystemProviderErrorCode.FileExists);if(c==="move")return}const k=await this.L(d);if(!k)throw(0,m.$2k)((0,a.localize)(5,null),m.FileSystemProviderErrorCode.FileNotFound);const S=await this.L(h);if(S){if(!u)throw(0,m.$2k)((0,a.localize)(6,null),m.FileSystemProviderErrorCode.FileExists);k.type&m.FileType.File&&S.type&m.FileType.File||await this.delete(h,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(d,h){return this.cb(d,h,!1)}async cb(d,h,c){const u=this.H(d),f=this.H(h),E=!!(this.capabilities&1024);if((0,$.$hg)(u,f,!E))return;const v=new w.$Tc;try{v.add(await this.O(d)),v.add(await this.O(h)),c&&await y.Promises.mkdir((0,A.$nc)(f),{recursive:!0}),await y.Promises.copyFile(u,f)}catch(D){if(D.code==="ENOENT"&&!c)return this.cb(d,h,!0);throw this.fb(D)}finally{v.dispose()}}t(d,h,c){return new r.$Mq(u=>d(u),u=>h(u),c)}F(d,h,c){return new s.$Vq(u=>d(u),u=>h(u),c)}fb(d){if(d instanceof m.$1k)return d;let h=d,c;switch(d.code){case"ENOENT":c=m.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":c=m.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":c=m.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":c=m.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":c=m.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":h=`${d.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,c=m.FileSystemProviderErrorCode.Unknown;break;default:c=m.FileSystemProviderErrorCode.Unknown}return(0,m.$2k)(h,c)}async gb(d,h){let c=this.fb(h);if(d&&c.code===m.FileSystemProviderErrorCode.NoPermissions)try{const{stat:u}=await y.SymlinkSupport.stat(this.H(d));u.mode&128||(c=(0,m.$2k)(h,m.FileSystemProviderErrorCode.FileWriteLocked))}catch(u){this.a.trace(u)}return c}}e.$Wq=t,t.I=!1,t.Y=!0}),define(Ee[260],Ce([1,0,3,12]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bQ=void 0;class I extends o.$Uc{constructor(O,p=[]){super(),this.a=new R.$Yj([O,...p]),this.B(O.onDidChangeLogLevel($=>this.setLevel($)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(O){this.a.setLevel(O)}getLevel(){return this.a.getLevel()}trace(O,...p){this.a.trace(O,...p)}debug(O,...p){this.a.debug(O,...p)}info(O,...p){this.a.info(O,...p)}warn(O,...p){this.a.warn(O,...p)}error(O,...p){this.a.error(O,...p)}flush(){this.a.flush()}}e.$bQ=I}),define(Ee[261],Ce([1,0,32,12]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3P=void 0;var I;(function(w){w[w.Trace=0]="Trace",w[w.Debug=1]="Debug",w[w.Info=2]="Info",w[w.Warning=3]="Warning",w[w.Error=4]="Error",w[w.Critical=5]="Critical",w[w.Off=6]="Off"})(I||(I={}));async function M(w,A,P,b,C){try{const y=await new Promise((m,l)=>{re(["@vscode/spdlog"],m,l)});y.setFlushOn(I.Trace);const a=await y.createAsyncRotatingLogger(w,A,P,b);return C?a.clearFormatters():a.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),a}catch(y){console.error(y)}return null}function O(w,A,P){switch(A){case R.LogLevel.Trace:w.trace(P);break;case R.LogLevel.Debug:w.debug(P);break;case R.LogLevel.Info:w.info(P);break;case R.LogLevel.Warning:w.warn(P);break;case R.LogLevel.Error:w.error(P);break;case R.LogLevel.Off:break;default:throw new Error(`Invalid log level ${A}`)}}function p(w,A){switch(A){case R.LogLevel.Trace:w.setLevel(I.Trace);break;case R.LogLevel.Debug:w.setLevel(I.Debug);break;case R.LogLevel.Info:w.setLevel(I.Info);break;case R.LogLevel.Warning:w.setLevel(I.Warning);break;case R.LogLevel.Error:w.setLevel(I.Error);break;case R.LogLevel.Off:w.setLevel(I.Off);break;default:throw new Error(`Invalid log level ${A}`)}}class $ extends R.$Uj{constructor(A,P,b,C,y){super(),this.m=[],this.setLevel(y),this.n=this.s(A,P,b,C),this.B(this.onDidChangeLogLevel(a=>{this.r&&p(this.r,a)}))}async s(A,P,b,C){const y=b?6:1,a=30/y*o.$kl.MB,m=await M(A,P,a,y,C);if(m){this.r=m,p(this.r,this.getLevel());for(const{level:l,message:i}of this.m)O(this.r,l,i);this.m=[]}}g(A,P){this.r?O(this.r,A,P):this.getLevel()<=A&&this.m.push({level:A,message:P})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$3P=$}),define(Ee[139],Ce([1,0,41,214,5]),function(re,e,o,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vt=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var M;(function($){$[$.Unnecessary=1]="Unnecessary",$[$.Deprecated=2]="Deprecated"})(M||(e.MarkerTag=M={}));var O;(function($){$[$.Hint=1]="Hint",$[$.Info=2]="Info",$[$.Warning=4]="Warning",$[$.Error=8]="Error"})(O||(e.MarkerSeverity=O={})),function($){function w(y,a){return a-y}$.compare=w;const A=Object.create(null);A[$.Error]=(0,R.localize)(0,null),A[$.Warning]=(0,R.localize)(1,null),A[$.Info]=(0,R.localize)(2,null);function P(y){return A[y]||""}$.toString=P;function b(y){switch(y){case o.default.Error:return $.Error;case o.default.Warning:return $.Warning;case o.default.Info:return $.Info;case o.default.Ignore:return $.Hint}}$.fromSeverity=b;function C(y){switch(y){case $.Error:return o.default.Error;case $.Warning:return o.default.Warning;case $.Info:return o.default.Info;case $.Hint:return o.default.Ignore}}$.toSeverity=C}(O||(e.MarkerSeverity=O={}));var p;(function($){const w="";function A(b){return P(b,!0)}$.makeKey=A;function P(b,C){const y=[w];return b.source?y.push(b.source.replace("\xA6","\\\xA6")):y.push(w),b.code?typeof b.code=="string"?y.push(b.code.replace("\xA6","\\\xA6")):y.push(b.code.value.replace("\xA6","\\\xA6")):y.push(w),b.severity!==void 0&&b.severity!==null?y.push(O.toString(b.severity)):y.push(w),b.message&&C?y.push(b.message.replace("\xA6","\\\xA6")):y.push(w),b.startLineNumber!==void 0&&b.startLineNumber!==null?y.push(b.startLineNumber.toString()):y.push(w),b.startColumn!==void 0&&b.startColumn!==null?y.push(b.startColumn.toString()):y.push(w),b.endLineNumber!==void 0&&b.endLineNumber!==null?y.push(b.endLineNumber.toString()):y.push(w),b.endColumn!==void 0&&b.endColumn!==null?y.push(b.endColumn.toString()):y.push(w),y.push(w),y.join("\xA6")}$.makeKeyOptionalMessage=P})(p||(e.IMarkerData=p={})),e.$Vt=(0,I.$ii)("markerService")}),define(Ee[262],Ce([1,0,4,41,5]),function(re,e,o,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pv=e.$Ov=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$Mv=e.Severity=void 0,e.$Nv=p,e.Severity=R.default,e.$Mv=(0,I.$ii)("notificationService");var M;(function(P){P[P.DEFAULT=0]="DEFAULT",P[P.SILENT=1]="SILENT",P[P.URGENT=2]="URGENT"})(M||(e.NotificationPriority=M={}));var O;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.PROFILE=1]="PROFILE",P[P.APPLICATION=2]="APPLICATION"})(O||(e.NeverShowAgainScope=O={}));function p(P){if(P){const b=P;return typeof b.id=="string"&&typeof b.label=="string"}return!1}var $;(function(P){P[P.OFF=0]="OFF",P[P.ERROR=1]="ERROR"})($||(e.NotificationsFilter=$={}));class w{constructor(){this.progress=new A,this.onDidClose=o.Event.None,this.onDidChangeVisibility=o.Event.None}updateSeverity(b){}updateMessage(b){}updateActions(b){}close(){}}e.$Ov=w;class A{infinite(){}done(){}total(b){}worked(b){}}e.$Pv=A}),define(Ee[263],Ce([1,0,49]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let R;const I=globalThis.vscode;if(typeof I<"u"&&typeof I.context<"u"){const M=I.context.configuration();if(M)R=M.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(R=globalThis._VSCODE_PRODUCT_JSON,o.env.VSCODE_DEV&&Object.assign(R,{nameShort:`${R.nameShort} Dev`,nameLong:`${R.nameLong} Dev`,dataFolderName:`${R.dataFolderName}-dev`,serverDataFolderName:R.serverDataFolderName?`${R.serverDataFolderName}-dev`:void 0}),!R.version){const M=globalThis._VSCODE_PACKAGE_JSON;Object.assign(R,{version:M.version})}Object.assign(R,{extensionsGallery:o.env.EXTENSIONS_GALLERY?JSON.parse(o.env.EXTENSIONS_GALLERY):R.extensionsGallery||{serviceUrl:"https://open-vsx.org/vscode/gallery",itemUrl:"https://open-vsx.org/vscode/item",resourceUrlTemplate:"https://open-vsx.org/vscode/asset/{publisher}/{name}/{version}/Microsoft.VisualStudio.Code.WebResources/{path}",controlUrl:"",recommendationsUrl:""}})}else R={nameShort:"code-server",nameLong:"code-server",applicationName:"code-server",dataFolderName:".code-server",win32MutexName:"codeserver",licenseName:"MIT",licenseUrl:"https://github.com/coder/code-server/blob/main/LICENSE",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverGreeting:[],serverLicense:[],serverLicensePrompt:"",serverApplicationName:"code-server-oss",serverDataFolderName:".vscode-server-oss",tunnelApplicationName:"code-tunnel-oss",win32DirName:"code-server",win32NameVersion:"code-server",win32RegValueName:"CodeOSS",win32x64AppId:"{{D77B7E06-80BA-4137-BCF4-654B95CCEBC5}",win32arm64AppId:"{{D1ACE434-89C5-48D1-88D3-E2991DF85475}",win32x64UserAppId:"{{CC6B787D-37A0-49E8-AE24-8559A032BE0C}",win32arm64UserAppId:"{{3AEBF0C8-F733-4AD4-BADE-FDB816D53D7B}",win32AppUserModelId:"coder.code-server",win32ShellNameShort:"c&ode-server",win32TunnelServiceMutex:"vscodeoss-tunnelservice",win32TunnelMutex:"vscodeoss-tunnel",darwinBundleIdentifier:"com.coder.code.server",linuxIconName:"com.coder.code.server",licenseFileName:"LICENSE.txt",reportIssueUrl:"https://github.com/coder/code-server/issues/new",nodejsRepository:"https://nodejs.org",urlProtocol:"code-oss",webviewContentExternalBaseUrlTemplate:"https://{{uuid}}.vscode-cdn.net/insider/ef65ac1ba57f57f2a3961bfe94aa20481caca4c6/out/vs/workbench/contrib/webview/browser/pre/",builtInExtensions:[{name:"ms-vscode.js-debug-companion",version:"1.1.2",sha256:"e034b8b41beb4e97e02c70f7175bd88abe66048374c2bd629f54bb33354bc2aa",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.88.0",sha256:"3a048d87c0fac116fce9190ff6042ec7691e66fc17211a058faf0db91bb6605e",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"1.0.8",sha256:"ca30069e21fbf576b49638ff8ff7c316b028c2faca924c23526737c65b8762bf",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}}],enableTelemetry:!0,quality:"stable",codeServerVersion:"0.0.0",documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",linkProtectionTrustedDomains:["https://open-vsx.org"],trustedExtensionAuthAccess:["vscode.git","vscode.github","github.vscode-pull-request-github","github.copilot","github.copilot-chat"],aiConfig:{ariaKey:"code-server"},version:"1.88.0",commit:"0cca7c67a4aba0e8ce199df0fdc59b64fc659fbc",date:"2024-04-05T22:24:44.781Z"},Object.keys(R).length===0&&Object.assign(R,{version:"1.87.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=R}),define(Ee[140],Ce([1,0,5]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9j=e.$8j=void 0,e.$8j=(0,o.$ii)("productService"),e.$9j="vscode://schemas/vscode-product"});var He=this&&this.__param||function(re,e){return function(o,R){e(o,R,re)}};define(Ee[108],Ce([1,0,8,22,3,5]),function(re,e,o,R,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wv=e.$Vv=e.$Uv=e.$Tv=e.$Sv=e.$Rv=e.ProgressLocation=e.$Qv=void 0,e.$Qv=(0,M.$ii)("progressService");var O;(function(P){P[P.Explorer=1]="Explorer",P[P.Scm=3]="Scm",P[P.Extensions=5]="Extensions",P[P.Window=10]="Window",P[P.Notification=15]="Notification",P[P.Dialog=20]="Dialog"})(O||(e.ProgressLocation=O={})),e.$Rv=Object.freeze({total(){},worked(){},done(){}});class p{get value(){return this.a}constructor(b){this.b=b}report(b){this.a=b,this.b(this.a)}}e.$Sv=p,p.None=Object.freeze({report(){}});class ${get value(){return this.a}constructor(b){this.e=b}report(b){this.b?this.b.push(b):this.b=[b],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const b=this.b.shift();this.a=b,await this.e(this.a)}}finally{this.c=!1;const b=this.d;this.d=void 0,b?.()}}drain(){return this.c?new Promise(b=>{const C=this.d;this.d=()=>{C?.(),b()}}):Promise.resolve()}}e.$Tv=$;let w=class extends I.$Uc{constructor(b,C){super(),this.a=new o.$Fh,C.withProgress(b,y=>(this.b=y,this.c&&y.report(this.c),this.a.p)),this.B((0,I.$Sc)(()=>this.a.complete()))}report(b){this.b?this.b.report(b):this.c=b}};e.$Uv=w,e.$Uv=w=Qe([He(1,e.$Qv)],w);class A extends I.$Uc{constructor(b){super(),this.g=b,this.a=0,this.b=this.B(new I.$Tc)}start(b){this.stop();const C=++this.a,y=new R.$ee;return this.f=setTimeout(()=>{C===this.a&&(this.c=this.g.show(!0))},b),this.b.add((0,I.$Sc)(()=>clearTimeout(this.f))),this.b.add((0,I.$Sc)(()=>y.cancel())),this.b.add((0,I.$Sc)(()=>this.c?this.c.done():void 0)),{id:C,token:y.token,stop:()=>this.h(C),isCurrent:()=>this.a===C}}stop(){this.h(this.a)}h(b){this.a===b&&this.b.clear()}}e.$Vv=A,e.$Wv=(0,M.$ii)("editorProgressService")}),define(Ee[37],Ce([1,0,61,18]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2n=void 0;class I{constructor(){this.a=new Map}add(O,p){o.ok(R.$Vf(O)),o.ok(R.$Xf(p)),o.ok(!this.a.has(O),"There is already an extension with this id"),this.a.set(O,p)}knows(O){return this.a.has(O)}as(O){return this.a.get(O)||null}}e.$2n=new I}),define(Ee[109],Ce([1,0,4,37]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3n=void 0,e.$3n={JSONContribution:"base.contributions.json"};function I(p){return p.length>0&&p.charAt(p.length-1)==="#"?p.substring(0,p.length-1):p}class M{constructor(){this.b=new o.$7d,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema($,w){this.a[I($)]=w,this.b.fire($)}notifySchemaChanged($){this.b.fire($)}getSchemaContributions(){return{schemas:this.a}}}const O=new M;R.$2n.add(e.$3n.JSONContribution,O)}),define(Ee[85],Ce([1,0,19,4,18,203,53,109,37]),function(re,e,o,R,I,M,O,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.ConfigurationScope=e.$7n=e.EditPresentationTypes=void 0,e.$fo=a,e.$go=m,e.$ho=l,e.$io=n,e.$jo=r;var w;(function(s){s.Multiline="multilineText",s.Singleline="singlelineText"})(w||(e.EditPresentationTypes=w={})),e.$7n={Configuration:"base.contributions.configuration"};var A;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.MACHINE=2]="MACHINE",s[s.WINDOW=3]="WINDOW",s[s.RESOURCE=4]="RESOURCE",s[s.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",s[s.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A||(e.ConfigurationScope=A={})),e.$8n={properties:{},patternProperties:{}},e.$9n={properties:{},patternProperties:{}},e.$0n={properties:{},patternProperties:{}},e.$$n={properties:{},patternProperties:{}},e.$_n={properties:{},patternProperties:{}},e.$ao={properties:{},patternProperties:{}},e.$bo="vscode://schemas/settings/resourceLanguage",e.$co="vscode://schemas/settings/configurationDefaults";const P=$.$2n.as(p.$3n.JSONContribution);class b{constructor(){this.h=new Set,this.i=new R.$7d,this.onDidSchemaChange=this.i.event,this.j=new R.$7d,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},P.registerSchema(e.$bo,this.g),this.v()}registerConfiguration(t,g=!0){this.registerConfigurations([t],g)}registerConfigurations(t,g=!0){const d=new Set;this.n(t,g,d),P.registerSchema(e.$bo,this.g),this.i.fire(),this.j.fire({properties:d})}deregisterConfigurations(t){const g=new Set;this.o(t,g),P.registerSchema(e.$bo,this.g),this.i.fire(),this.j.fire({properties:g})}updateConfigurations({add:t,remove:g}){const d=new Set;this.o(g,d),this.n(t,!1,d),P.registerSchema(e.$bo,this.g),this.i.fire(),this.j.fire({properties:d})}registerDefaultConfigurations(t){const g=new Set;this.k(t,g),this.i.fire(),this.j.fire({properties:g,defaultsOverrides:!0})}k(t,g){const d=[];for(const{overrides:h,source:c}of t)for(const u in h)if(g.add(u),e.$eo.test(u)){const f=this.a.get(u),E=f?.valuesSources??new Map;if(c)for(const S of Object.keys(h[u]))E.set(S,c);const v={...f?.value||{},...h[u]};this.a.set(u,{source:c,value:v,valuesSources:E});const D=(0,O.$Yi)(u),k={type:"object",default:v,description:M.localize(1,null,D),$ref:e.$bo,defaultDefaultValue:v,source:I.$Vf(c)?void 0:c,defaultValueSource:c};d.push(...a(u)),this.d[u]=k,this.b.properties[u]=k}else{this.a.set(u,{value:h[u],source:c});const f=this.d[u];f&&(this.w(u,f),this.r(u,f))}this.m(d)}deregisterDefaultConfigurations(t){const g=new Set;this.l(t,g),this.i.fire(),this.j.fire({properties:g,defaultsOverrides:!0})}l(t,g){for(const{overrides:d,source:h}of t)for(const c in d){const u=this.a.get(c),f=I.$Vf(h)?h:h?.id,E=I.$Vf(u?.source)?u?.source:u?.source?.id;if(f===E)if(g.add(c),this.a.delete(c),e.$eo.test(c))delete this.d[c],delete this.b.properties[c];else{const v=this.d[c];v&&(this.w(c,v),this.r(c,v))}}this.u()}deltaConfiguration(t){let g=!1;const d=new Set;t.removedDefaults&&(this.l(t.removedDefaults,d),g=!0),t.addedDefaults&&(this.k(t.addedDefaults,d),g=!0),t.removedConfigurations&&this.o(t.removedConfigurations,d),t.addedConfigurations&&this.n(t.addedConfigurations,!1,d),this.i.fire(),this.j.fire({properties:d,defaultsOverrides:g})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const g of t)this.h.add(g);this.u()}n(t,g,d){t.forEach(h=>{this.p(h,g,h.extensionInfo,h.restrictedProperties,void 0,d),this.c.push(h),this.q(h)})}o(t,g){const d=h=>{if(h.properties)for(const c in h.properties){g.add(c);const u=this.d[c];u?.policy?.name&&this.e.delete(u.policy.name),delete this.d[c],this.s(c,h.properties[c])}h.allOf?.forEach(c=>d(c))};for(const h of t){d(h);const c=this.c.indexOf(h);c!==-1&&this.c.splice(c,1)}}p(t,g=!0,d,h,c=3,u){c=I.$5f(t.scope)?c:t.scope;const f=t.properties;if(f)for(const v in f){const D=f[v];if(g&&n(v,D)){delete f[v];continue}if(D.source=d,D.defaultDefaultValue=f[v].default,this.w(v,D),e.$eo.test(v)?D.scope=void 0:(D.scope=I.$5f(D.scope)?c:D.scope,D.restricted=I.$5f(D.restricted)?!!h?.includes(v):D.restricted),f[v].hasOwnProperty("included")&&!f[v].included){this.f[v]=f[v],delete f[v];continue}else this.d[v]=f[v],f[v].policy?.name&&this.e.set(f[v].policy.name,v);!f[v].deprecationMessage&&f[v].markdownDeprecationMessage&&(f[v].deprecationMessage=f[v].markdownDeprecationMessage),u.add(v)}const E=t.allOf;if(E)for(const v of E)this.p(v,g,d,h,c,u)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const g=d=>{const h=d.properties;if(h)for(const u in h)this.r(u,h[u]);d.allOf?.forEach(g)};g(t)}r(t,g){switch(e.$8n.properties[t]=g,g.scope){case 1:e.$9n.properties[t]=g;break;case 2:e.$0n.properties[t]=g;break;case 6:e.$$n.properties[t]=g;break;case 3:e.$_n.properties[t]=g;break;case 4:e.$ao.properties[t]=g;break;case 5:e.$ao.properties[t]=g,this.g.properties[t]=g;break}}s(t,g){switch(delete e.$8n.properties[t],g.scope){case 1:delete e.$9n.properties[t];break;case 2:delete e.$0n.properties[t];break;case 6:delete e.$$n.properties[t];break;case 3:delete e.$_n.properties[t];break;case 4:case 5:delete e.$ao.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const g=`[${t}]`,d={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.$bo};this.w(g,d),e.$8n.properties[g]=d,e.$9n.properties[g]=d,e.$0n.properties[g]=d,e.$$n.properties[g]=d,e.$_n.properties[g]=d,e.$ao.properties[g]=d}}v(){const t={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.$bo};e.$8n.patternProperties[e.$do]=t,e.$9n.patternProperties[e.$do]=t,e.$0n.patternProperties[e.$do]=t,e.$$n.patternProperties[e.$do]=t,e.$_n.patternProperties[e.$do]=t,e.$ao.patternProperties[e.$do]=t,this.i.fire()}w(t,g){const d=this.a.get(t);let h=d?.value,c=d?.source;I.$3f(h)&&(h=g.defaultDefaultValue,c=void 0),I.$3f(h)&&(h=l(g.type)),g.default=h,g.defaultValueSource=c}}const C="\\[([^\\]]+)\\]",y=new RegExp(C,"g");e.$do=`^(${C})+$`,e.$eo=new RegExp(e.$do);function a(s){const t=[];if(e.$eo.test(s)){let g=y.exec(s);for(;g?.length;){const d=g[1].trim();d&&t.push(d),g=y.exec(s)}}return(0,o.$Mb)(t)}function m(s){return s.reduce((t,g)=>`${t}[${g}]`,"")}function l(s){switch(Array.isArray(s)?s[0]:s){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const i=new b;$.$2n.add(e.$7n.Configuration,i);function n(s,t){return s.trim()?e.$eo.test(s)?M.localize(7,null,s):i.getConfigurationProperties()[s]!==void 0?M.localize(8,null,s):t.policy?.name&&i.getPolicyConfigurations().get(t.policy?.name)!==void 0?M.localize(9,null,s,t.policy?.name,i.getPolicyConfigurations().get(t.policy?.name)):null:M.localize(6,null)}function r(){const s=[],t=i.getConfigurationProperties();for(const g of Object.keys(t))s.push([g,t[g].scope]);return s.push(["launch",4]),s.push(["task",4]),s}}),define(Ee[264],Ce([1,0,19,4,165,3,27,24,18,2,53,85,37]),function(re,e,o,R,I,M,O,p,$,w,A,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$po=e.$no=e.$mo=e.$lo=e.$ko=void 0,e.$oo=n;function C(g){return Object.isFrozen(g)?g:p.$Qn(g)}class y{constructor(d={},h=[],c=[],u){this.b=d,this.c=h,this.d=c,this.raw=u,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const d=this.raw.map(h=>{if(h instanceof y)return h;const c=new a("");return c.parseRaw(h),c.configurationModel});this.f=d.reduce((h,c)=>c===h?c:h.merge(c),d[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(d){return d?(0,A.$Wi)(this.contents,d):this.contents}inspect(d,h){const c=this;return{get value(){return C(c.rawConfiguration.getValue(d))},get override(){return h?C(c.rawConfiguration.getOverrideValue(d,h)):void 0},get merged(){return C(h?c.rawConfiguration.override(h).getValue(d):c.rawConfiguration.getValue(d))},get overrides(){const u=[];for(const{contents:f,identifiers:E,keys:v}of c.rawConfiguration.overrides){const D=new y(f,v).getValue(d);D!==void 0&&u.push({identifiers:E,value:D})}return u.length?C(u):void 0}}}getOverrideValue(d,h){const c=this.i(h);return c?d?(0,A.$Wi)(c,d):c:void 0}getKeysForOverrideIdentifier(d){const h=[];for(const c of this.overrides)c.identifiers.includes(d)&&h.push(...c.keys);return o.$Mb(h)}getAllOverrideIdentifiers(){const d=[];for(const h of this.overrides)d.push(...h.identifiers);return o.$Mb(d)}override(d){let h=this.a.get(d);return h||(h=this.g(d),this.a.set(d,h)),h}merge(...d){const h=p.$Pn(this.contents),c=p.$Pn(this.overrides),u=[...this.keys],f=this.raw?.length?[...this.raw]:[this];for(const E of d)if(f.push(...E.raw?.length?E.raw:[E]),!E.isEmpty()){this.h(h,E.contents);for(const v of E.overrides){const[D]=c.filter(k=>o.$ub(k.identifiers,v.identifiers));D?(this.h(D.contents,v.contents),D.keys.push(...v.keys),D.keys=o.$Mb(D.keys)):c.push(p.$Pn(v))}for(const v of E.keys)u.indexOf(v)===-1&&u.push(v)}return new y(h,u,c,f.every(E=>E instanceof y)?void 0:f)}g(d){const h=this.i(d);if(!h||typeof h!="object"||!Object.keys(h).length)return this;const c={};for(const u of o.$Mb([...Object.keys(this.contents),...Object.keys(h)])){let f=this.contents[u];const E=h[u];E&&(typeof f=="object"&&typeof E=="object"?(f=p.$Pn(f),this.h(f,E)):f=E),c[u]=f}return new y(c,this.keys,this.overrides)}h(d,h){for(const c of Object.keys(h)){if(c in d&&$.$Xf(d[c])&&$.$Xf(h[c])){this.h(d[c],h[c]);continue}d[c]=p.$Pn(h[c])}}i(d){let h=null,c=null;const u=f=>{f&&(c?this.h(c,f):c=p.$Pn(f))};for(const f of this.overrides)f.identifiers.length===1&&f.identifiers[0]===d?h=f.contents:f.identifiers.includes(d)&&u(f.contents);return u(h),c}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(d,h){this.j(d,h,!0)}setValue(d,h){this.j(d,h,!1)}removeValue(d){const h=this.keys.indexOf(d);h!==-1&&(this.keys.splice(h,1),(0,A.$Vi)(this.contents,d),P.$eo.test(d)&&this.overrides.splice(this.overrides.findIndex(c=>o.$ub(c.identifiers,(0,P.$fo)(d))),1))}j(d,h,c){(0,A.$Ui)(this.contents,d,h,u=>console.error(u)),c=c||this.keys.indexOf(d)===-1,c&&this.keys.push(d),P.$eo.test(d)&&this.overrides.push({identifiers:(0,P.$fo)(d),keys:Object.keys(this.contents[d]),contents:(0,A.$Ti)(this.contents[d],u=>console.error(u))})}}e.$ko=y;class a{constructor(d){this.f=d,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new y}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(d,h){if(!$.$5f(d)){const c=this.g(d);this.parseRaw(c,h)}}reparse(d){this.a&&this.parseRaw(this.a,d)}parseRaw(d,h){this.a=d;const{contents:c,keys:u,overrides:f,restricted:E,hasExcludedProperties:v}=this.h(d,h);this.b=new y(c,u,f,v?[d]:void 0),this.c=E||[]}g(d){let h={},c=null,u=[];const f=[],E=[];function v(k){Array.isArray(u)?u.push(k):c!==null&&(u[c]=k)}const D={onObjectBegin:()=>{const k={};v(k),f.push(u),u=k,c=null},onObjectProperty:k=>{c=k},onObjectEnd:()=>{u=f.pop()},onArrayBegin:()=>{const k=[];v(k),f.push(u),u=k,c=null},onArrayEnd:()=>{u=f.pop()},onLiteralValue:v,onError:(k,S,F)=>{E.push({error:k,offset:S,length:F})}};if(d)try{I.$Dn(d,D),h=u[0]||{}}catch(k){console.error(`Error while parsing settings file ${this.f}: ${k}`),this.d=[k]}return h}h(d,h){const c=b.$2n.as(P.$7n.Configuration).getConfigurationProperties(),u=this.i(d,c,!0,h);d=u.raw;const f=(0,A.$Ti)(d,D=>console.error(`Conflict in settings file ${this.f}: ${D}`)),E=Object.keys(d),v=this.j(d,D=>console.error(`Conflict in settings file ${this.f}: ${D}`));return{contents:f,keys:E,overrides:v,restricted:u.restricted,hasExcludedProperties:u.hasExcludedProperties}}i(d,h,c,u){let f=!1;if(!u?.scopes&&!u?.skipRestricted&&!u?.exclude?.length)return{raw:d,restricted:[],hasExcludedProperties:f};const E={},v=[];for(const D in d)if(P.$eo.test(D)&&c){const k=this.i(d[D],h,!1,u);E[D]=k.raw,f=f||k.hasExcludedProperties,v.push(...k.restricted)}else{const k=h[D],S=k?typeof k.scope<"u"?k.scope:3:void 0;k?.restricted&&v.push(D),!u.exclude?.includes(D)&&(u.include?.includes(D)||(S===void 0||u.scopes===void 0||u.scopes.includes(S))&&!(u.skipRestricted&&k?.restricted))?E[D]=d[D]:f=!0}return{raw:E,restricted:v,hasExcludedProperties:f}}j(d,h){const c=[];for(const u of Object.keys(d))if(P.$eo.test(u)){const f={};for(const E in d[u])f[E]=d[u][E];c.push({identifiers:(0,P.$fo)(u),keys:Object.keys(f),contents:(0,A.$Ti)(f,h)})}return c}}e.$lo=a;class m extends M.$Uc{constructor(d,h,c,u){super(),this.c=d,this.f=h,this.g=u,this.b=this.B(new R.$7d),this.onDidChange=this.b.event,this.a=new a(this.c.toString()),this.B(this.g.watch(c.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(R.Event.any(R.Event.filter(this.g.onDidFilesChange,f=>f.contains(this.c)),R.Event.filter(this.g.onDidRunOperation,f=>(f.isOperation(0)||f.isOperation(3)||f.isOperation(1)||f.isOperation(4))&&c.isEqual(f.resource,d)))(()=>this.b.fire()))}async loadConfiguration(){try{const d=await this.g.readFile(this.c);return this.a.parse(d.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new y}}reparse(d){return d&&(this.f=d),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$mo=m;class l{constructor(d,h,c,u,f,E,v,D,k,S,F,W,B){this.a=d,this.b=h,this.c=c,this.overrideIdentifiers=u,this.d=f,this.f=E,this.g=v,this.h=D,this.i=k,this.j=S,this.k=F,this.l=W,this.m=B}get value(){return C(this.c)}n(d){return d?.value!==void 0||d?.override!==void 0||d?.overrides!==void 0?d:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class i{constructor(d,h,c,u,f=new y,E=new y,v=new O.$Bc,D=new y,k=new O.$Bc){this.c=d,this.d=h,this.f=c,this.g=u,this.h=f,this.i=E,this.j=v,this.l=D,this.m=k,this.a=null,this.b=new O.$Bc,this.n=null}getValue(d,h,c){return this.p(d,h,c).getValue(d)}updateValue(d,h,c={}){let u;c.resource?(u=this.m.get(c.resource),u||(u=new y,this.m.set(c.resource,u))):u=this.l,h===void 0?u.removeValue(d):u.setValue(d,h),c.resource||(this.a=null)}inspect(d,h,c){const u=this.p(d,h,c),f=this.t(h.resource,c),E=h.resource?this.m.get(h.resource)||this.l:this.l,v=new Set;for(const D of u.overrides)for(const k of D.identifiers)u.getOverrideValue(d,k)!==void 0&&v.add(k);return new l(d,h,u.getValue(d),v.size?[...v]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,c?this.i:void 0,f||void 0,E)}keys(d){const h=this.t(void 0,d);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:h?h.keys.slice(0):[]}}updateDefaultConfiguration(d){this.c=d,this.a=null,this.b.clear()}updatePolicyConfiguration(d){this.d=d}updateApplicationConfiguration(d){this.f=d,this.a=null,this.b.clear()}updateLocalUserConfiguration(d){this.g=d,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(d){this.h=d,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(d){this.i=d,this.a=null,this.b.clear()}updateFolderConfiguration(d,h){this.j.set(d,h),this.b.delete(d)}deleteFolderConfiguration(d){this.folderConfigurations.delete(d),this.b.delete(d)}compareAndUpdateDefaultConfiguration(d,h){const c=[];if(!h){const{added:u,updated:f,removed:E}=s(this.c,d);h=[...u,...f,...E]}for(const u of h)for(const f of(0,P.$fo)(u)){const E=this.c.getKeysForOverrideIdentifier(f),v=d.getKeysForOverrideIdentifier(f),D=[...v.filter(k=>E.indexOf(k)===-1),...E.filter(k=>v.indexOf(k)===-1),...E.filter(k=>!p.$Tn(this.c.override(f).getValue(k),d.override(f).getValue(k)))];c.push([f,D])}return this.updateDefaultConfiguration(d),{keys:h,overrides:c}}compareAndUpdatePolicyConfiguration(d){const{added:h,updated:c,removed:u}=s(this.d,d),f=[...h,...c,...u];return f.length&&this.updatePolicyConfiguration(d),{keys:f,overrides:[]}}compareAndUpdateApplicationConfiguration(d){const{added:h,updated:c,removed:u,overrides:f}=s(this.applicationConfiguration,d),E=[...h,...c,...u];return E.length&&this.updateApplicationConfiguration(d),{keys:E,overrides:f}}compareAndUpdateLocalUserConfiguration(d){const{added:h,updated:c,removed:u,overrides:f}=s(this.localUserConfiguration,d),E=[...h,...c,...u];return E.length&&this.updateLocalUserConfiguration(d),{keys:E,overrides:f}}compareAndUpdateRemoteUserConfiguration(d){const{added:h,updated:c,removed:u,overrides:f}=s(this.remoteUserConfiguration,d),E=[...h,...c,...u];return E.length&&this.updateRemoteUserConfiguration(d),{keys:E,overrides:f}}compareAndUpdateWorkspaceConfiguration(d){const{added:h,updated:c,removed:u,overrides:f}=s(this.workspaceConfiguration,d),E=[...h,...c,...u];return E.length&&this.updateWorkspaceConfiguration(d),{keys:E,overrides:f}}compareAndUpdateFolderConfiguration(d,h){const c=this.folderConfigurations.get(d),{added:u,updated:f,removed:E,overrides:v}=s(c,h),D=[...u,...f,...E];return(D.length||!c)&&this.updateFolderConfiguration(d,h),{keys:D,overrides:v}}compareAndDeleteFolderConfiguration(d){const h=this.folderConfigurations.get(d);if(!h)throw new Error("Unknown folder");this.deleteFolderConfiguration(d);const{added:c,updated:u,removed:f,overrides:E}=s(h,void 0);return{keys:[...c,...u,...f],overrides:E}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(d,h,c){let u=this.q(h,c);return h.overrideIdentifier&&(u=u.override(h.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(d)!==void 0&&(u=u.merge(this.d)),u}q({resource:d},h){let c=this.r();if(h&&d){const u=h.getFolder(d);u&&(c=this.s(u.uri)||c);const f=this.m.get(d);f&&(c=c.merge(f))}return c}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(d){let h=this.b.get(d);if(!h){const c=this.r(),u=this.j.get(d);u?(h=c.merge(u),this.b.set(d,h)):h=c}return h}t(d,h){if(h&&d){const c=h.getFolder(d);if(c)return this.j.get(c.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((d,h)=>{const{contents:c,overrides:u,keys:f}=this.j.get(h);return d.push([h,{contents:c,overrides:u,keys:f}]),d},[])}}allKeys(){const d=new Set;return this.c.keys.forEach(h=>d.add(h)),this.userConfiguration.keys.forEach(h=>d.add(h)),this.i.keys.forEach(h=>d.add(h)),this.j.forEach(h=>h.keys.forEach(c=>d.add(c))),[...d.values()]}u(){const d=new Set;return this.c.getAllOverrideIdentifiers().forEach(h=>d.add(h)),this.userConfiguration.getAllOverrideIdentifiers().forEach(h=>d.add(h)),this.i.getAllOverrideIdentifiers().forEach(h=>d.add(h)),this.j.forEach(h=>h.getAllOverrideIdentifiers().forEach(c=>d.add(c))),[...d.values()]}v(d){const h=new Set;return this.c.getKeysForOverrideIdentifier(d).forEach(c=>h.add(c)),this.userConfiguration.getKeysForOverrideIdentifier(d).forEach(c=>h.add(c)),this.i.getKeysForOverrideIdentifier(d).forEach(c=>h.add(c)),this.j.forEach(c=>c.getKeysForOverrideIdentifier(d).forEach(u=>h.add(u))),[...h.values()]}static parse(d){const h=this.w(d.defaults),c=this.w(d.policy),u=this.w(d.application),f=this.w(d.user),E=this.w(d.workspace),v=d.folders.reduce((D,k)=>(D.set(w.URI.revive(k[0]),this.w(k[1])),D),new O.$Bc);return new i(h,c,u,f,new y,E,v,new y,new O.$Bc)}static w(d){return new y(d.contents,d.keys,d.overrides)}}e.$no=i;function n(...g){if(g.length===0)return{keys:[],overrides:[]};if(g.length===1)return g[0];const d=new Set,h=new Map;for(const u of g)u.keys.forEach(f=>d.add(f)),u.overrides.forEach(([f,E])=>{const v=(0,O.$yc)(h,f,new Set);E.forEach(D=>v.add(D))});const c=[];return h.forEach((u,f)=>c.push([f,[...u.values()]])),{keys:[...d.values()],overrides:c}}class r{constructor(d,h,c,u){this.change=d,this.f=h,this.g=c,this.h=u,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.i=void 0;for(const f of d.keys)this.affectedKeys.add(f);for(const[,f]of d.overrides)for(const E of f)this.affectedKeys.add(E);this.d=this.a;for(const f of this.affectedKeys)this.d+=f+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=i.parse(this.f.data)),this.i}affectsConfiguration(d,h){const c=this.a+d,u=this.d.indexOf(c);if(u<0)return!1;const f=u+c.length;if(f>=this.d.length)return!1;const E=this.d.charCodeAt(f);if(E!==this.b&&E!==this.c)return!1;if(h){const v=this.previousConfiguration?this.previousConfiguration.getValue(d,h,this.f?.workspace):void 0,D=this.g.getValue(d,h,this.h);return!p.$Tn(v,D)}return!0}}e.$po=r;function s(g,d){const{added:h,removed:c,updated:u}=t(d?.rawConfiguration,g?.rawConfiguration),f=[],E=g?.getAllOverrideIdentifiers()||[],v=d?.getAllOverrideIdentifiers()||[];if(d){const D=v.filter(k=>!E.includes(k));for(const k of D)f.push([k,d.getKeysForOverrideIdentifier(k)])}if(g){const D=E.filter(k=>!v.includes(k));for(const k of D)f.push([k,g.getKeysForOverrideIdentifier(k)])}if(d&&g){for(const D of E)if(v.includes(D)){const k=t({contents:g.getOverrideValue(void 0,D)||{},keys:g.getKeysForOverrideIdentifier(D)},{contents:d.getOverrideValue(void 0,D)||{},keys:d.getKeysForOverrideIdentifier(D)});f.push([D,[...k.added,...k.removed,...k.updated]])}}return{added:h,removed:c,updated:u,overrides:f}}function t(g,d){const h=g?d?g.keys.filter(f=>d.keys.indexOf(f)===-1):[...g.keys]:[],c=d?g?d.keys.filter(f=>g.keys.indexOf(f)===-1):[...d.keys]:[],u=[];if(g&&d){for(const f of d.keys)if(g.keys.indexOf(f)!==-1){const E=(0,A.$Wi)(d.contents,f),v=(0,A.$Wi)(g.contents,f);p.$Tn(E,v)||u.push(f)}}return{added:h,removed:c,updated:u}}}),define(Ee[265],Ce([1,0,21,4,3,81]),function(re,e,o,R,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fub=e.$dub=e.$cub=void 0,e.$eub=p;const O=(w,A,P)=>{const b=new Uint8Array(16);for(let a=0;a<16;a++)b[a]=Math.round(Math.random()*256);const C=(0,o.$Oe)(o.$ue.wrap(b));return[`GET ws://localhost${w}?${A}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${C}`].join(`\r
`)+`\r
\r
`};e.$cub=O,e.$dub=o.$ue.fromString(`\r
\r
`);async function p(w,A,P,b,C){w.write(o.$ue.fromString((0,e.$cub)(A,P,b)));const y=new I.$Tc;try{return await new Promise((a,m)=>{let l;y.add(w.onData(i=>{l?l=o.$ue.concat([l,i],l.byteLength+i.byteLength):l=i;const n=l.indexOf(e.$dub);if(n===-1)return;a(w),w.pauseData();const r=l.slice(n+e.$dub.byteLength);r.byteLength&&C.onData.fire(r)})),y.add(w.onClose(i=>m(i??new Error("socket closed")))),y.add(w.onEnd(()=>m(new Error("socket ended"))))})}catch(a){throw w.dispose(),a}finally{y.dispose()}}class $ extends I.$Uc{constructor(A,P){super(),this.g=A,this.a=this.B(new R.$0d),this.onData=(...b)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...b)),this.b=this.B(new R.$7d),this.onDidDispose=this.b.event,this.f=!1,this.B(P.onData),this.B(P.onData.event(b=>this.a.fire(b))),this.onClose=this.B(P.onClose).event,this.onEnd=this.B(P.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(A,P){M.SocketDiagnostics.traceSocketEvent(this,this.g,A,P)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$fub=$}),define(Ee[65],Ce([1,0,13,5]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wl=e.RemoteAuthorityResolverErrorCode=e.$vl=e.$ul=e.RemoteConnectionType=e.$tl=void 0,e.$xl=w,e.$tl=(0,R.$ii)("remoteAuthorityResolverService");var I;(function(A){A[A.WebSocket=0]="WebSocket",A[A.Managed=1]="Managed"})(I||(e.RemoteConnectionType=I={}));class M{constructor(P){this.id=P,this.type=1}toString(){return`Managed(${this.id})`}}e.$ul=M;class O{constructor(P,b){this.host=P,this.port=b,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$vl=O;var p;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound",A.InvalidAuthority="InvalidAuthority"})(p||(e.RemoteAuthorityResolverErrorCode=p={}));class $ extends o.$bb{static isNotAvailable(P){return P instanceof $&&P._code===p.NotAvailable}static isTemporarilyNotAvailable(P){return P instanceof $&&P._code===p.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof $&&P._code===p.NoResolverFound}static isInvalidAuthority(P){return P instanceof $&&P._code===p.InvalidAuthority}static isHandled(P){return P instanceof $&&P.isHandled}constructor(P,b=p.Unknown,C){super(P),this._message=P,this._code=b,this._detail=C,this.isHandled=b===p.NotAvailable&&C===!0,Object.setPrototypeOf(this,$.prototype)}}e.$wl=$;function w(A){const P=A.indexOf("+");return P===-1?A:A.substring(0,P)}}),define(Ee[266],Ce([1,0,8,21,22,13,4,3,15,58,40,30,81,65]),function(re,e,o,R,I,M,O,p,$,w,A,P,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ml=e.$Ll=e.$Kl=e.$Jl=e.$Il=e.$Hl=e.$Gl=e.$Fl=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Cl=E,e.$Dl=v,e.$El=k;const y=30*1e3;var a;(function(_){_[_.Management=1]="Management",_[_.ExtensionHost=2]="ExtensionHost",_[_.Tunnel=3]="Tunnel"})(a||(e.ConnectionType=a={}));function m(_){switch(_){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function l(_){const U=new I.$ee;return setTimeout(()=>U.cancel(),_),U.token}function i(_,U){if(_.isCancellationRequested||U.isCancellationRequested)return I.CancellationToken.Cancelled;const he=new I.$ee;return _.onCancellationRequested(()=>he.cancel()),U.onCancellationRequested(()=>he.cancel()),he.token}class n{get didTimeout(){return this.c==="timedout"}constructor(U){this.c="pending",this.d=new p.$Tc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,o.$bh)(),U.isCancellationRequested?this.h():this.d.add(U.onCancellationRequested(()=>this.h()))}registerDisposable(U){this.c==="pending"?this.d.add(U):U.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const U=new Error("Time limit reached");return U.code="ETIMEDOUT",U.syscall="connect",U}resolve(U){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(U))}reject(U){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(U))}}function r(_,U){const he=new n(U);return he.registerDisposable(_.onControlMessage(Se=>{const me=JSON.parse(Se.toString()),ie=J(me);ie?he.reject(ie):he.resolve(me)})),he.promise}function s(_,U,he,Se,me,ie,se,oe){const G=new n(oe),ee=A.$3d.create(!1);return _.info(`Creating a socket (${se})...`),w.mark(`code/willCreateSocket/${ie}`),U.connect(he,Se,me,se).then(le=>{G.didTimeout?(w.mark(`code/didCreateSocketError/${ie}`),_.info(`Creating a socket (${se}) finished after ${ee.elapsed()} ms, but this is too late and has timed out already.`),le?.dispose()):(w.mark(`code/didCreateSocketOK/${ie}`),_.info(`Creating a socket (${se}) was successful after ${ee.elapsed()} ms.`),G.resolve(le))},le=>{w.mark(`code/didCreateSocketError/${ie}`),_.info(`Creating a socket (${se}) returned an error after ${ee.elapsed()} ms.`),_.error(le),G.reject(le)}),G.promise}function t(_,U){const he=new n(U);return _.then(Se=>{he.didTimeout||he.resolve(Se)},Se=>{he.didTimeout||he.reject(Se)}),he.promise}async function g(_,U,he,Se){const me=pe(_,U);_.logService.trace(`${me} 1/6. invoking socketFactory.connect().`);let ie;try{ie=await s(_.logService,_.remoteSocketFactoryService,_.connectTo,$.$vg.getServerRootPath(),`reconnectionToken=${_.reconnectionToken}&reconnection=${_.reconnectionProtocol?"true":"false"}`,m(U),`renderer-${m(U)}-${_.reconnectionToken}`,Se)}catch(le){throw _.logService.error(`${me} socketFactory.connect() failed or timed out. Error:`),_.logService.error(le),le}_.logService.trace(`${me} 2/6. socketFactory.connect() was successful.`);let se,oe;_.reconnectionProtocol?(_.reconnectionProtocol.beginAcceptReconnection(ie,null),se=_.reconnectionProtocol,oe=!1):(se=new b.$9h({socket:ie}),oe=!0),_.logService.trace(`${me} 3/6. sending AuthRequest control message.`);const G=await t(_.signService.createNewMessage((0,P.$Eg)()),Se),ee={type:"auth",auth:_.connectionToken||"00000000000000000000",data:G.data};se.sendControl(R.$ue.fromString(JSON.stringify(ee)));try{const le=await r(se,i(Se,l(1e4)));if(le.type!=="sign"||typeof le.data!="string"){const Pe=new Error("Unexpected handshake message");throw Pe.code="VSCODE_CONNECTION_ERROR",Pe}if(_.logService.trace(`${me} 4/6. received SignRequest control message.`),!await t(_.signService.validate(G,le.signedData),Se)){const Pe=new Error("Refused to connect to unsupported server");throw Pe.code="VSCODE_CONNECTION_ERROR",Pe}const Me=await t(_.signService.sign(le.data),Se),be={type:"connectionType",commit:_.commit,signedData:Me,desiredConnectionType:U};return he&&(be.args=he),_.logService.trace(`${me} 5/6. sending ConnectionTypeRequest control message.`),se.sendControl(R.$ue.fromString(JSON.stringify(be))),{protocol:se,ownsProtocol:oe}}catch(le){throw le&&le.code==="ETIMEDOUT"&&(_.logService.error(`${me} the handshake timed out. Error:`),_.logService.error(le)),le&&le.code==="VSCODE_CONNECTION_ERROR"&&(_.logService.error(`${me} received error control message when negotiating connection. Error:`),_.logService.error(le)),oe&&Y(se),le}}async function d(_,U,he,Se){const me=Date.now(),ie=pe(_,U),{protocol:se,ownsProtocol:oe}=await g(_,U,he,Se),G=new n(Se);return G.registerDisposable(se.onControlMessage(ee=>{const le=JSON.parse(ee.toString()),de=J(le);de?(_.logService.error(`${ie} received error control message when negotiating connection. Error:`),_.logService.error(de),oe&&Y(se),G.reject(de)):(_.reconnectionProtocol?.endAcceptReconnection(),_.logService.trace(`${ie} 6/6. handshake finished, connection is up and running after ${ye(me)}!`),G.resolve({protocol:se,firstMessage:le}))})),G.promise}async function h(_,U){const{protocol:he}=await d(_,1,void 0,U);return{protocol:he}}async function c(_,U,he){const{protocol:Se,firstMessage:me}=await d(_,2,U,he),ie=me&&me.debugPort;return{protocol:Se,debugPort:ie}}async function u(_,U,he){const Se=Date.now(),me=pe(_,3),{protocol:ie}=await g(_,3,U,he);return _.logService.trace(`${me} 6/6. handshake finished, connection is up and running after ${ye(Se)}!`),ie}async function f(_,U,he){const{connectTo:Se,connectionToken:me}=await _.addressProvider.getAddress();return{commit:_.commit,quality:_.quality,connectTo:Se,connectionToken:me,reconnectionToken:U,reconnectionProtocol:he,remoteSocketFactoryService:_.remoteSocketFactoryService,signService:_.signService,logService:_.logService}}async function E(_,U,he){return D(_,async Se=>{const{protocol:me}=await h(Se,I.CancellationToken.None);return new z(_,U,he,Se.reconnectionToken,me)})}async function v(_,U){return D(_,async he=>{const{protocol:Se,debugPort:me}=await c(he,U,I.CancellationToken.None);return new Q(_,U,he.reconnectionToken,Se,me)})}async function D(_,U){for(let Se=1;;Se++)try{const me=(0,P.$Eg)(),ie=await f(_,me,null);return await U(ie)}catch(me){if(Se<5)_.logService.error(`[remote-connection][attempt ${Se}] An error occurred in initial connection! Will retry... Error:`),_.logService.error(me);else throw _.logService.error(`[remote-connection][attempt ${Se}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),_.logService.error(me),L.triggerPermanentFailure(0,0,C.$wl.isHandled(me)),me}}async function k(_,U,he){const Se=await f(_,(0,P.$Eg)(),null);return await u(Se,{host:U,port:he},I.CancellationToken.None)}function S(_){return(0,o.$8g)(U=>new Promise((he,Se)=>{const me=setTimeout(he,_*1e3);U.onCancellationRequested(()=>{clearTimeout(me),he()})}))}var F;(function(_){_[_.ConnectionLost=0]="ConnectionLost",_[_.ReconnectionWait=1]="ReconnectionWait",_[_.ReconnectionRunning=2]="ReconnectionRunning",_[_.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",_[_.ConnectionGain=4]="ConnectionGain"})(F||(e.PersistentConnectionEventType=F={}));class W{constructor(U,he){this.reconnectionToken=U,this.millisSinceLastIncomingData=he,this.type=0}}e.$Fl=W;class B{constructor(U,he,Se,me){this.reconnectionToken=U,this.millisSinceLastIncomingData=he,this.durationSeconds=Se,this.c=me,this.type=1}skipWait(){this.c.cancel()}}e.$Gl=B;class T{constructor(U,he,Se){this.reconnectionToken=U,this.millisSinceLastIncomingData=he,this.attempt=Se,this.type=2}}e.$Hl=T;class N{constructor(U,he,Se){this.reconnectionToken=U,this.millisSinceLastIncomingData=he,this.attempt=Se,this.type=4}}e.$Il=N;class j{constructor(U,he,Se,me){this.reconnectionToken=U,this.millisSinceLastIncomingData=he,this.attempt=Se,this.handled=me,this.type=3}}e.$Jl=j;class L extends p.$Uc{static triggerPermanentFailure(U,he,Se){this._permanentFailure=!0,this.f=U,this.g=he,this.h=Se,this.j.forEach(me=>me.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(U=>U.y())}static debugPauseSocketWriting(){this.j.forEach(U=>U.F())}get n(){return this.c||L._permanentFailure}constructor(U,he,Se,me,ie){super(),this.t=U,this.u=he,this.reconnectionToken=Se,this.protocol=me,this.w=ie,this.m=this.B(new O.$7d),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new N(this.reconnectionToken,0,0)),this.B(me.onSocketClose(se=>{const oe=te(this.t,this.reconnectionToken,!0);se?se.type===0?(this.u.logService.info(`${oe} received socket close event (hadError: ${se.hadError}).`),se.error&&this.u.logService.error(se.error)):(this.u.logService.info(`${oe} received socket close event (wasClean: ${se.wasClean}, code: ${se.code}, reason: ${se.reason}).`),se.event&&this.u.logService.error(se.event)):this.u.logService.info(`${oe} received socket close event.`),this.y()})),this.B(me.onSocketTimeout(se=>{const oe=te(this.t,this.reconnectionToken,!0);this.u.logService.info(`${oe} received socket timeout event (unacknowledgedMsgCount: ${se.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${se.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${se.timeSinceLastReceivedSomeData}).`),this.y()})),L.j.push(this),this.B((0,p.$Sc)(()=>{const se=L.j.indexOf(this);se>=0&&L.j.splice(se,1)})),this.n&&this.D(L.f,L.g,L.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const U=te(this.t,this.reconnectionToken,!0);this.u.logService.info(`${U} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new W(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const he=[0,5,5,10,10,10,10,10,30];let Se=-1;do{Se++;const me=Se<he.length?he[Se]:he[he.length-1];try{if(me>0){const se=S(me);this.m.fire(new B(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),me,se)),this.u.logService.info(`${U} waiting for ${me} seconds before reconnecting...`);try{await se}catch{}}if(this.n){this.u.logService.error(`${U} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Se+1)),this.u.logService.info(`${U} resolving connection...`);const ie=await f(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${U} connecting to ${ie.connectTo}...`),await this.G(ie,l(y)),this.u.logService.info(`${U} reconnected!`),this.m.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Se+1));break}catch(ie){if(ie.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${U} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(ie),this.C(this.protocol.getMillisSinceLastIncomingData(),Se+1,!1);break}if(Se>360){this.u.logService.error(`${U} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(ie),this.C(this.protocol.getMillisSinceLastIncomingData(),Se+1,!1);break}if(C.$wl.isTemporarilyNotAvailable(ie)){this.u.logService.info(`${U} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ie);continue}if((ie.code==="ETIMEDOUT"||ie.code==="ENETUNREACH"||ie.code==="ECONNREFUSED"||ie.code==="ECONNRESET")&&ie.syscall==="connect"){this.u.logService.info(`${U} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ie);continue}if((0,M.$4)(ie)){this.u.logService.info(`${U} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ie);continue}if(ie instanceof C.$wl){this.u.logService.error(`${U} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(ie),this.C(this.protocol.getMillisSinceLastIncomingData(),Se+1,C.$wl.isHandled(ie));break}this.u.logService.error(`${U} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(ie),this.C(this.protocol.getMillisSinceLastIncomingData(),Se+1,!1);break}}while(!this.n&&!this.s)}C(U,he,Se){this.w?L.triggerPermanentFailure(U,he,Se):this.D(U,he,Se)}D(U,he,Se){this.m.fire(new j(this.reconnectionToken,U,he,Se)),Y(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$Kl=L,L._permanentFailure=!1,L.f=0,L.g=0,L.h=!1,L.j=[];class z extends L{constructor(U,he,Se,me,ie){super(1,U,me,ie,!0),this.client=this.B(new b.$7h(ie,{remoteAuthority:he,clientId:Se},U.ipcLogger))}async G(U,he){await h(U,he)}}e.$Ll=z;class Q extends L{constructor(U,he,Se,me,ie){super(2,U,Se,me,!1),this.H=he,this.debugPort=ie}async G(U,he){await c(U,this.H,he)}}e.$Ml=Q;function Y(_){try{_.acceptDisconnect();const U=_.getSocket();_.dispose(),U.dispose()}catch(U){(0,M.$1)(U)}}function J(_){if(_&&_.type==="error"){const U=new Error(`Connection error: ${_.reason}`);return U.code="VSCODE_CONNECTION_ERROR",U}return null}function x(_,U){for(;_.length<U;)_+=" ";return _}function ce(_,U){return`[remote-connection][${x(m(_),13)}][${U.substr(0,5)}\u2026]`}function te(_,U,he){return`${ce(_,U)}[${he?"reconnect":"initial"}]`}function pe(_,U){return`${te(U,_.reconnectionToken,!!_.reconnectionProtocol)}[${_.connectTo}]`}function ye(_){return`${Date.now()-_} ms`}}),define(Ee[86],Ce([1,0,15]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$um=R,e.$vm=I,e.$wm=M,e.$xm=O;function R($){return $.scheme===o.Schemas.vscodeRemote?$.authority:void 0}function I($){if(!$)return;const w=$.indexOf("+");return w<0?$:$.substr(0,w)}function M($){const{host:w,port:A}=p($);if(typeof A>"u")throw new Error(`Invalid remote authority: ${$}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:w,port:A}}function O($,w){let{host:A,port:P}=p($);return typeof P>"u"&&(P=w),{host:A,port:P}}function p($){const w=$.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(w)return{host:w[1],port:parseInt(w[2],10)};const A=$.match(/^(\[[0-9a-z:]+\])$/);if(A)return{host:A[1],port:void 0};const P=$.match(/(.*):(\d+)$/);return P?{host:P[1],port:parseInt(P[2],10)}:{host:$,port:void 0}}}),define(Ee[25],Ce([1,0,14,5,86]),function(re,e,o,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lm=e.$Gm=e.$Fm=e.$Em=e.TargetPlatform=e.ExtensionType=e.$Dm=e.$Bm=e.$Am=e.$zm=e.$ym=void 0,e.$Cm=M,e.$Hm=P,e.$Im=b,e.$Jm=C,e.$Km=y,e.$ym="extensions.user.cache",e.$zm="extensions.builtin.cache",e.$Am="undefined_publisher",e.$Bm=["ui","workspace","web"];function M(a){if(typeof a=="object"&&a!==null&&a.supported!==!0)return a.description}e.$Dm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var O;(function(a){a[a.System=0]="System",a[a.User=1]="User"})(O||(e.ExtensionType=O={}));var p;(function(a){a.WIN32_X64="win32-x64",a.WIN32_ARM64="win32-arm64",a.LINUX_X64="linux-x64",a.LINUX_ARM64="linux-arm64",a.LINUX_ARMHF="linux-armhf",a.ALPINE_X64="alpine-x64",a.ALPINE_ARM64="alpine-arm64",a.DARWIN_X64="darwin-x64",a.DARWIN_ARM64="darwin-arm64",a.WEB="web",a.UNIVERSAL="universal",a.UNKNOWN="unknown",a.UNDEFINED="undefined"})(p||(e.TargetPlatform=p={}));class ${constructor(m){this.value=m,this._lower=m.toLowerCase()}static equals(m,l){if(typeof m>"u"||m===null)return typeof l>"u"||l===null;if(typeof l>"u"||l===null)return!1;if(typeof m=="string"||typeof l=="string"){const i=typeof m=="string"?m:m.value,n=typeof l=="string"?l:l.value;return o.$lf(i,n)}return m._lower===l._lower}static toKey(m){return typeof m=="string"?m.toLowerCase():m._lower}}e.$Em=$;class w{get size(){return this.c.size}constructor(m){if(this.c=new Set,m)for(const l of m)this.add(l)}add(m){this.c.add($.toKey(m))}delete(m){return this.c.delete($.toKey(m))}has(m){return this.c.has($.toKey(m))}}e.$Fm=w;class A{constructor(){this.c=new Map}clear(){this.c.clear()}delete(m){this.c.delete($.toKey(m))}get(m){return this.c.get($.toKey(m))}has(m){return this.c.has($.toKey(m))}set(m,l){this.c.set($.toKey(m),l)}values(){return this.c.values()}forEach(m){this.c.forEach(m)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Gm=A;function P(a){return b(a)}function b(a){return a.contributes&&a.contributes.localizations?a.contributes.localizations.length>0:!1}function C(a){return a.contributes&&a.contributes.authentication?a.contributes.authentication.length>0:!1}function y(a,m){if(m){const l=`onResolveRemoteAuthority:${(0,I.$vm)(m)}`;return!!a.activationEvents?.includes(l)}return!1}e.$Lm=(0,R.$ii)("IBuiltinExtensionsScannerService")}),define(Ee[141],Ce([1,0,13,25]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UF=e.$TF=void 0;class I{constructor(){this.a=new Map,this.b=new WeakMap}register(O,p){this.a.set(O,p)}readActivationEvents(O){return this.b.has(O)||this.b.set(O,this.c(O)),this.b.get(O)}createActivationEventsMap(O){const p=Object.create(null);for(const $ of O){const w=this.readActivationEvents($);w.length>0&&(p[R.$Em.toKey($.identifier)]=w)}return p}c(O){if(typeof O.main>"u"&&typeof O.browser>"u")return[];const p=Array.isArray(O.activationEvents)?O.activationEvents.slice(0):[];for(let $=0;$<p.length;$++)p[$]==="onUri"&&(p[$]=`onUri:${R.$Em.toKey(O.identifier)}`);if(!O.contributes)return p;for(const $ in O.contributes){const w=this.a.get($);if(!w)continue;const A=O.contributes[$],P=Array.isArray(A)?A:[A];try{w(P,p)}catch(b){(0,o.$1)(b)}}return p}}e.$TF=I,e.$UF=new I}),define(Ee[267],Ce([1,0,3,5]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zl=e.$yl=void 0,e.$yl=(0,R.$ii)("remoteSocketFactoryService");class I{constructor(){this.a={}}register(O,p){var $;return($=this.a)[O]??($[O]=[]),this.a[O].push(p),(0,o.$Sc)(()=>{const w=this.a[O]?.indexOf(p);typeof w=="number"&&w>=0&&this.a[O]?.splice(w,1)})}b(O){return(this.a[O.type]||[]).find($=>$.supports(O))}connect(O,p,$,w){const A=this.b(O);if(!A)throw new Error(`No socket factory found for ${O}`);return A.connect(O,p,$,w)}}e.$zl=I}),define(Ee[268],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p0b=void 0;class o{constructor(){this.b=new Map}async createNewMessage(I){try{const M=await this.c();if(M){const O=String(o.a++);return this.b.set(O,M),{id:O,data:M.createNewMessage(I)}}}catch{}return{id:"",data:I}}async validate(I,M){if(!I.id)return!0;const O=this.b.get(I.id);if(!O)return!1;this.b.delete(I.id);try{return O.validate(M)==="ok"}catch{return!1}finally{O.dispose?.()}}async sign(I){try{return await this.d(I)}catch{}return I}}e.$p0b=o,o.a=1}),define(Ee[110],Ce([1,0,5]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bl=e.$Al=void 0,e.$Al="signService",e.$Bl=(0,o.$ii)(e.$Al)}),define(Ee[142],Ce([1,0,268]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lcc=void 0;class R extends o.$p0b{c(){return this.h().then(M=>new M.validator)}d(M){return this.h().then(O=>new O.signer().sign(M))}h(){return new Promise((M,O)=>re(["vsda"],M,O))}}e.$lcc=R}),define(Ee[269],Ce([1,0,11,49,30]),function(re,e,o,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3o=O,e.$4o=p;function M($){if(o.$o===2&&/^penguin(\.|$)/i.test($))return"chromebook"}function O($,w,A,P,b,C,y,a,m){const l=Object.create(null);l["common.machineId"]=C,l["common.sqmId"]=y,l.sessionID=(0,I.$Eg)()+Date.now(),l.commitHash=P,l.version=b,l["common.platformVersion"]=($||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),l["common.platform"]=(0,o.$b)(o.$o),l["common.nodePlatform"]=R.$ec,l["common.nodeArch"]=A,l["common.product"]=m||"desktop",a&&(l["common.msftInternal"]=a);let i=0;const n=Date.now();Object.defineProperties(l,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-n,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),o.$f&&(l["common.snap"]="true");const r=M(w);return r&&(l["common.platformDetail"]=r),l}function p($){const w=R.env.USERDNSDOMAIN;if(!w)return!1;const A=w.toLowerCase();return $.some(P=>A===P)}}),define(Ee[270],Ce([1,0,5]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Xl=e.$Wl=e.$Vl=e.$Ul=e.$Tl=e.$Sl=e.$Rl=e.$Ql=e.$Pl=e.$Ol=e.$Nl=void 0,e.$Nl=(0,o.$ii)("telemetryService"),e.$Ol=(0,o.$ii)("customEndpointTelemetryService"),e.$Pl="telemetry.currentSessionDate",e.$Ql="telemetry.firstSessionDate",e.$Rl="telemetry.lastSessionDate",e.$Sl="telemetry.machineId",e.$Tl="telemetry.sqmId",e.$Ul="telemetry",e.$Vl="telemetry.telemetryLevel",e.$Wl="telemetry.enableCrashReporter",e.$Xl="telemetry.enableTelemetry";var R;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(R||(e.TelemetryLevel=R={}));var I;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(I||(e.TelemetryConfiguration=I={}))}),define(Ee[87],Ce([1,0,24,18,86,269,270]),function(re,e,o,R,I,M,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=void 0,e.$_o=A,e.$ap=P,e.$bp=b,e.$cp=C,e.$dp=a,e.$ep=l,e.$fp=i,e.$gp=s;class p{constructor(g){this.value=g,this.isTrustedTelemetryValue=!0}}e.$5o=p;class ${constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$6o=$,e.$7o=new $;class w{async publicLog(g,d,h){}async publicLogError(g,d,h){}}e.$8o=w,e.$9o="telemetry",e.$0o="extensionTelemetryLog",e.$$o={log:()=>null,flush:()=>Promise.resolve(null)};function A(t,g){return!g.isBuilt&&!g.disableTelemetry?!0:!(g.disableTelemetry||!t.enableTelemetry)}function P(t,g){return g.extensionTestsLocationURI?!0:!(g.isBuilt||g.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function b(t){const g=t.getValue(O.$Vl),d=t.getValue(O.$Wl);if(t.getValue(O.$Xl)===!1||d===!1)return 0;switch(g??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function C(t){const g={},d={},h={};m(t,h);for(let c in h){c=c.length>150?c.substr(c.length-149):c;const u=h[c];typeof u=="number"?d[c]=u:typeof u=="boolean"?d[c]=u?1:0:typeof u=="string"?(u.length>8192&&console.warn(`Telemetry property: ${c} has been trimmed to 8192, the original length is ${u.length}`),g[c]=u.substring(0,8191)):typeof u<"u"&&u!==null&&(g[c]=u)}return{properties:g,measurements:d}}const y=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function a(t){if(!t)return"none";const g=(0,I.$vm)(t);return y.has(g)?g:"other"}function m(t,g,d=0,h){if(t)for(const c of Object.getOwnPropertyNames(t)){const u=t[c],f=h?h+c:c;Array.isArray(u)?g[f]=(0,o.$Un)(u):u instanceof Date?g[f]=u.toISOString():(0,R.$Xf)(u)?d<2?m(u,g,d+1,f+"."):g[f]=(0,o.$Un)(u):g[f]=u}}function l(t,g){const d=t.msftInternalDomains||[],h=g.getValue("telemetry.internalTesting");return(0,M.$4o)(d)||h}function i(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function n(t,g){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let d=t;const h=[];for(const E of g)for(;;){const v=E.exec(t);if(!v)break;h.push([v.index,E.lastIndex])}const c=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,u=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let f=0;for(d="";;){const E=u.exec(t);if(!E)break;const v=h.some(([D,k])=>E.index<k&&D<u.lastIndex);!c.test(E[0])&&!v&&(d+=t.substring(f,E.index)+"<REDACTED: user-file-path>",f=u.lastIndex)}return f<t.length&&(d+=t.substr(f)),d}function r(t){if(!t)return t;const g=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const d of g)if(d.regex.test(t))return`<REDACTED: ${d.label}>`;return t}function s(t,g){return(0,o.$Rn)(t,d=>{if(d instanceof p||Object.hasOwnProperty.call(d,"isTrustedTelemetryValue"))return d.value;if(typeof d=="string"){let h=d.replaceAll("%20"," ");h=n(h,g);for(const c of g)h=h.replace(c,"");return h=r(h),h}})}}),define(Ee[271],Ce([1,0,14,138,25,11,2,13,49,87]),function(re,e,o,R,I,M,O,p,$,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qp=e.$ip=void 0,e.$hp=A,e.$jp=y,e.$kp=a,e.$lp=m,e.$mp=l,e.$np=i,e.$op=n,e.$pp=r,e.$rp=s,e.$sp=g;function A(d,h){return d.uuid&&h.uuid?d.uuid===h.uuid:d.id===h.id?!0:(0,o.$gf)(d.id,h.id)===0}const P=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class b{static create(h){const c=h.manifest?h.manifest.version:h.version,u=h.manifest?h.targetPlatform:h.properties.targetPlatform;return new b(h.identifier,c,u)}static parse(h){const c=P.exec(h);return c&&c[1]&&c[2]?new b({id:c[1]},c[2],c[4]||void 0):null}constructor(h,c,u="undefined"){this.version=c,this.targetPlatform=u,this.id=h.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(h){return h instanceof b?A(this,h)&&this.version===h.version&&this.targetPlatform===h.targetPlatform:!1}}e.$ip=b;const C=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function y(d){const h=C.exec(d);return h&&h[1]?[m(h[1]),h[2]]:[m(d),void 0]}function a(d,h){return`${d}.${h}`}function m(d){return d.toLowerCase()}function l(d,h){return m(a(d??I.$Am,h))}function i(d,h){const c=[],u=f=>{for(const E of c)if(E.some(v=>A(h(v),h(f))))return E;return null};for(const f of d){const E=u(f);E?E.push(f):c.push([f])}return c}function n(d){return{id:d.identifier.id,name:d.manifest.name,galleryId:null,publisherId:d.publisherId,publisherName:d.manifest.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:d.manifest.extensionDependencies&&d.manifest.extensionDependencies.length>0}}function r(d){return{id:new w.$5o(d.identifier.id),name:new w.$5o(d.name),galleryId:d.identifier.uuid,publisherId:d.publisherId,publisherName:d.publisher,publisherDisplayName:d.publisherDisplayName,isPreReleaseVersion:d.properties.isPreReleaseVersion,dependencies:!!(d.properties.dependencies&&d.properties.dependencies.length>0),isSigned:d.isSigned,...d.telemetryData}}e.$qp=new I.$Em("pprice.better-merge");function s(d,h){const c=[],u=h.manifest.extensionDependencies?.slice(0)??[];for(;u.length;){const f=u.shift();if(f&&c.every(E=>!A(E.identifier,{id:f}))){const E=d.filter(v=>A(v.identifier,{id:f}));E.length===1&&(c.push(E[0]),u.push(...E[0].manifest.extensionDependencies?.slice(0)??[]))}}return c}async function t(d,h){if(!M.$e)return!1;let c;try{c=(await d.readFile(O.URI.file("/etc/os-release"))).value.toString()}catch{try{c=(await d.readFile(O.URI.file("/usr/lib/os-release"))).value.toString()}catch(f){h.debug("Error while getting the os-release file.",(0,p.$0)(f))}}return!!c&&(c.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function g(d,h){const c=await t(d,h),u=(0,R.$Oo)(c?"alpine":M.$o,$.$fc);return h.debug("ComputeTargetPlatform:",u),u}}),define(Ee[272],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8r=o,e.$9r=R,e.$0r=I,e.$$r=M,e.$_r=O,e.$as=p;function o($){return[...$.entries()]}function R($){return $?[...$.entries()]:[]}function I($){return new Map($)}function M($){return new Map($??[])}function O($){return Array.from($.entries()).map(w=>[w[0],o(w[1].map),R(w[1].descriptionMap)])}function p($){return new Map($.map(w=>[w[0],{map:I(w[1]),descriptionMap:M(w[2])}]))}}),define(Ee[273],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xub=void 0;class o{constructor(I){this.b=I,this.a=new Map}dispose(){for(const I of this.a.values())I.dispose()}startBuffering(I,M,O=5){const p=M($=>{const w=typeof $=="string"?$:$.data;let A=this.a.get(I);if(A){A.data.push(w);return}const P=setTimeout(()=>this.flushBuffer(I),O);A={data:[w],timeoutId:P,dispose:()=>{clearTimeout(P),this.flushBuffer(I),p.dispose()}},this.a.set(I,A)});return p}stopBuffering(I){this.a.get(I)?.dispose()}flushBuffer(I){const M=this.a.get(I);M&&(this.a.delete(I),this.b(I,M.data.join("")))}}e.$xub=o}),define(Ee[274],Ce([1,0,8,78,101,56,4,18,2,215,109,37]),function(re,e,o,R,I,M,O,p,$,w,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3w=e.$2w=e.$1w=e.$Zw=e.$Yw=e.$Xw=e.IconFontDefinition=e.IconContribution=e.$Uw=void 0,e.$Vw=m,e.$Ww=l,e.$Uw={IconContribution:"base.contributions.icons"};var b;(function(s){function t(g,d){let h=g.defaults;for(;M.ThemeIcon.isThemeIcon(h);){const c=a.getIcon(h.id);if(!c)return;h=c.defaults}return h}s.getDefinition=t})(b||(e.IconContribution=b={}));var C;(function(s){function t(d){return{weight:d.weight,style:d.style,src:d.src.map(h=>({format:h.format,location:h.location.toString()}))}}s.toJSONObject=t;function g(d){const h=c=>(0,p.$Vf)(c)?c:void 0;if(d&&Array.isArray(d.src)&&d.src.every(c=>(0,p.$Vf)(c.format)&&(0,p.$Vf)(c.location)))return{weight:h(d.weight),style:h(d.style),src:d.src.map(c=>({format:c.format,location:$.URI.parse(c.location)}))}}s.fromJSONObject=g})(C||(e.IconFontDefinition=C={}));class y{constructor(){this.a=new O.$7d,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,w.localize)(0,null)},fontCharacter:{type:"string",description:(0,w.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${M.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(t,g,d,h){const c=this.b[t];if(c){if(d&&!c.description){c.description=d,this.d.properties[t].markdownDescription=`${d} $(${t})`;const E=this.e.enum.indexOf(t);E!==-1&&(this.e.enumDescriptions[E]=d),this.a.fire()}return c}const u={id:t,description:d,defaults:g,deprecationMessage:h};this.b[t]=u;const f={$ref:"#/definitions/icons"};return h&&(f.deprecationMessage=h),d&&(f.markdownDescription=`${d}: $(${t})`),this.d.properties[t]=f,this.e.enum.push(t),this.e.enumDescriptions.push(d||""),this.a.fire(),{id:t}}deregisterIcon(t){delete this.b[t],delete this.d.properties[t];const g=this.e.enum.indexOf(t);g!==-1&&(this.e.enum.splice(g,1),this.e.enumDescriptions.splice(g,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(t=>this.b[t])}getIcon(t){return this.b[t]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(t,g){const d=this.f[t];return d||(this.f[t]=g,this.a.fire(),g)}deregisterIconFont(t){delete this.f[t]}getIconFont(t){return this.f[t]}toString(){const t=(c,u)=>c.id.localeCompare(u.id),g=c=>{for(;M.ThemeIcon.isThemeIcon(c.defaults);)c=this.b[c.defaults.id];return`codicon codicon-${c?c.id:""}`},d=[];d.push("| preview     | identifier                        | default codicon ID                | description"),d.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const h=Object.keys(this.b).map(c=>this.b[c]);for(const c of h.filter(u=>!!u.description).sort(t))d.push(`|<i class="${g(c)}"></i>|${c.id}|${M.ThemeIcon.isThemeIcon(c.defaults)?c.defaults.id:c.id}|${c.description||""}|`);d.push("| preview     | identifier                        "),d.push("| ----------- | --------------------------------- |");for(const c of h.filter(u=>!M.ThemeIcon.isThemeIcon(u.defaults)).sort(t))d.push(`|<i class="${g(c)}"></i>|${c.id}|`);return d.join(`
`)}}const a=new y;P.$2n.add(e.$Uw.IconContribution,a);function m(s,t,g,d){return a.registerIcon(s,t,g,d)}function l(){return a}function i(){const s=(0,I.$Dj)();for(const t in s){const g="\\"+s[t].toString(16);a.registerIcon(t,{fontCharacter:g})}}i(),e.$Xw="vscode://schemas/icons";const n=P.$2n.as(A.$3n.JSONContribution);n.registerSchema(e.$Xw,a.getIconSchema());const r=new o.$uh(()=>n.notifySchemaChanged(e.$Xw),200);a.onDidChange(()=>{r.isScheduled()||r.schedule()}),e.$Yw=m("widget-close",R.$Hj.close,(0,w.localize)(2,null)),e.$Zw=m("goto-previous-location",R.$Hj.arrowUp,(0,w.localize)(3,null)),e.$1w=m("goto-next-location",R.$Hj.arrowDown,(0,w.localize)(4,null)),e.$2w=M.ThemeIcon.modify(R.$Hj.sync,"spin"),e.$3w=M.ThemeIcon.modify(R.$Hj.loading,"spin")}),define(Ee[88],Ce([1,0,4,2,53,5,12]),function(re,e,o,R,I,M,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9v=e.$8v=e.$5v=e.$3v=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$Yv=e.$Xv=void 0,e.$Zv=w,e.$1v=P,e.$2v=b,e.$4v=C,e.$6v=y,e.$7v=a,e.$Xv=(0,M.$ii)("tunnelService"),e.$Yv=(0,M.$ii)("sharedTunnelsService");var p;(function(i){i.Http="http",i.Https="https"})(p||(e.TunnelProtocol=p={}));var $;(function(i){i.ConstantPrivate="constantPrivate",i.Private="private",i.Public="public"})($||(e.TunnelPrivacyId=$={}));function w(i){return!!i.forwardPort}var A;(function(i){i[i.Notify=1]="Notify",i[i.OpenBrowser=2]="OpenBrowser",i[i.OpenPreview=3]="OpenPreview",i[i.Silent=4]="Silent",i[i.Ignore=5]="Ignore",i[i.OpenBrowserOnce=6]="OpenBrowserOnce"})(A||(e.ProvidedOnAutoForward=A={}));function P(i){if(i.scheme!=="http"&&i.scheme!=="https")return;const n=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(i.authority);if(n)return{address:n[1],port:+n[2]}}function b(i){if(i.scheme!=="http"&&i.scheme!=="https"||!i.query)return;const n=i.query.split("&");for(const r of n){const s=r.split("=")[1];if(/^https?:/.exec(s)){const t=P(R.URI.parse(s));if(t)return t}}}e.$3v=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function C(i){return e.$3v.indexOf(i)>=0}e.$5v=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function y(i){return e.$5v.indexOf(i)>=0}function a(i,n,r,s){if(r===1)return!1;if(r===2&&y(n)){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(s);if(t?.length===4&&parseInt(t[1])>=18)return!1}return i<1024}class m{constructor(n,r,s){this.remoteAddress=n,this.localAddress=r,this.b=s,this.a=new o.$7d,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$8v=m;let l=class{constructor(n,r){this.k=n,this.l=r,this.a=new o.$7d,this.onTunnelOpened=this.a.event,this.b=new o.$7d,this.onTunnelClosed=this.b.event,this.c=new o.$7d,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const n=this.l.getValue("remote.localPortHost");return!n||n==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(n){return this.f=n,n?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(n){this.g=n.elevation,this.i=n.privacyOptions,this.h=n.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const n=[],r=Array.from(this.e.values());for(const s of r){const t=Array.from(s.values());for(const g of t){const d=await g.value;d&&typeof d!="string"&&n.push(d)}}return n}async dispose(){for(const n of this.e.values()){for(const{value:r}of n.values())await r.then(s=>typeof s!="string"?s?.dispose():void 0);n.clear()}this.e.clear()}setEnvironmentTunnel(n,r,s,t,g){this.q(n,r,Promise.resolve({tunnelRemoteHost:n,tunnelRemotePort:r,localAddress:s,privacy:t,protocol:g,dispose:()=>Promise.resolve()}))}async getExistingTunnel(n,r){(y(n)||C(n))&&(n=e.$3v[0]);const s=this.s(n,r);if(s)return++s.refcount,s.value}openTunnel(n,r,s,t,g,d=!1,h,c){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${r}:${s} on local port ${g}.`);const u=this.f??n;if(!u)return;if(r||(r="localhost"),t||(t=this.m),this.f&&this.j.has(s)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const f=this.t(u,r,s,t,g,d,h,c);return f?f.then(E=>{if(E){if(typeof E=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(r,s),E}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(r,s);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const v=this.o(E);return(E.tunnelRemoteHost!==r||E.tunnelRemotePort!==s)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),h&&E.privacy!==h&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(v),v}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),f)}o(n){return{tunnelRemotePort:n.tunnelRemotePort,tunnelRemoteHost:n.tunnelRemoteHost,tunnelLocalPort:n.tunnelLocalPort,localAddress:n.localAddress,privacy:n.privacy,protocol:n.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${n.tunnelRemoteHost}:${n.tunnelRemotePort} `);const r=this.e.get(n.tunnelRemoteHost);if(r){const s=r.get(n.tunnelRemotePort);s&&(s.refcount--,await this.p(n.tunnelRemoteHost,n.tunnelRemotePort,s))}}}}async p(n,r,s){if(s.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${n}:${r}.`);const t=s.value.then(async g=>{g&&typeof g!="string"&&(await g.dispose(!0),this.b.fire({host:g.tunnelRemoteHost,port:g.tunnelRemotePort}))});return this.e.has(n)&&this.e.get(n).delete(r),t}}async closeTunnel(n,r){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${n}:${r} `);const s=this.e.get(n);if(s&&s.has(r)){const t=s.get(r);t.refcount=0,await this.p(n,r,t)}}q(n,r,s){this.e.has(n)||this.e.set(n,new Map),this.e.get(n).set(r,{refcount:1,value:s})}async r(n,r){const s=this.e.get(n);if(s){const t=s.get(r),g=t?await t.value:void 0;(!g||typeof g=="string")&&s.delete(r),s.size===0&&this.e.delete(n)}}s(n,r){const s=[n];C(n)?(s.push(...e.$3v),s.push(...e.$5v)):y(n)&&s.push(...e.$5v);const t=s.map(g=>this.e.get(g));for(const g of t){const d=g?.get(r);if(d)return d}}canTunnel(n){return!!P(n)}u(n,r,s,t,g,d,h){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${r}:${s} on local port ${t}.`);const c=s;this.j.add(c);const u=t===void 0?s:t,f={elevationRequired:g?this.isPortPrivileged(u):!1},E={remoteAddress:{host:r,port:s},localAddressPort:t,privacy:d,public:d?d!==$.Private:void 0,protocol:h},v=n.forwardPort(E,f);return v?(this.q(r,s,v),v.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(c)})):this.j.delete(c),v}};e.$9v=l,e.$9v=l=Qe([He(0,O.$Oj),He(1,I.$Oi)],l)}),define(Ee[275],Ce([1,0,5]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ml=void 0,e.$ml=(0,o.$ii)("IUriIdentityService")}),define(Ee[276],Ce([1,0,5]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$0v=void 0,e.$0v=(0,o.$ii)("editSessionIdentityService");var R;(function(I){I[I.Complete=100]="Complete",I[I.Partial=50]="Partial",I[I.None=0]="None"})(R||(e.EditSessionIdentityMatch=R={}))}),define(Ee[277],Ce([1,0,15]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2L=R,e.$3L=I,e.$4L=M,e.$5L=O,e.$6L=p;function R($){return $.scheme!==o.Schemas.file&&$.scheme!==o.Schemas.vscodeRemote}function I($){if($.folders.length)return $.folders.every(w=>R(w.uri))?$.folders[0].uri:void 0;if($.configuration&&R($.configuration))return $.configuration}function M($){return I($)?.scheme}function O($){return I($)?.authority}function p($){return I($)!==void 0}}),define(Ee[43],Ce([1,0,217,17,77,23,2,5,15]),function(re,e,o,R,I,M,O,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Ci=e.$Bi=e.WorkbenchState=e.$vi=e.$ui=e.$ri=void 0,e.$si=w,e.$ti=A,e.$wi=P,e.$xi=b,e.$yi=C,e.$zi=a,e.$Ai=m,e.$Di=n,e.$Ii=r,e.$Ji=s,e.$Li=t,e.$Mi=g,e.$Ni=d,e.$ri=(0,p.$ii)("contextService");function w(h){const c=h;return typeof c?.id=="string"&&O.URI.isUri(c.uri)}function A(h){return typeof h?.id=="string"&&!w(h)&&!b(h)}e.$ui={id:"ext-dev"},e.$vi={id:"empty-window"};function P(h,c){if(typeof h=="string"||typeof h>"u")return typeof h=="string"?{id:(0,R.$oc)(h)}:c?e.$ui:e.$vi;const u=h;return u.configuration?{id:u.id,configPath:u.configuration}:u.folders.length===1?{id:u.id,uri:u.folders[0].uri}:{id:u.id}}function b(h){const c=h;return typeof c?.id=="string"&&O.URI.isUri(c.configPath)}function C(h){const c=h;if(c?.uri)return{id:c.id,uri:O.URI.revive(c.uri)};const u=h;if(u?.configPath)return{id:u.id,configPath:O.URI.revive(u.configPath)};if(h?.id)return{id:h.id}}var y;(function(h){h[h.EMPTY=1]="EMPTY",h[h.FOLDER=2]="FOLDER",h[h.WORKSPACE=3]="WORKSPACE"})(y||(e.WorkbenchState=y={}));function a(h){const c=h;return!!(c&&typeof c=="object"&&typeof c.id=="string"&&Array.isArray(c.folders))}function m(h){const c=h;return!!(c&&typeof c=="object"&&O.URI.isUri(c.uri)&&typeof c.name=="string"&&typeof c.toResource=="function")}class l{constructor(c,u,f,E,v){this.h=c,this.j=f,this.k=E,this.l=v,this.c=I.$oi.forUris(this.l,()=>!0),this.folders=u}update(c){this.h=c.id,this.k=c.configuration,this.j=c.transient,this.l=c.l,this.folders=c.folders}get folders(){return this.g}set folders(c){this.g=c,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(c){this.k=c}getFolder(c){return c&&this.c.findSubstr(c)||null}n(){this.c=I.$oi.forUris(this.l,()=>!0);for(const c of this.folders)this.c.set(c.uri,c)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Bi=l;class i{constructor(c,u){this.raw=u,this.uri=c.uri,this.index=c.index,this.name=c.name}toResource(c){return(0,M.$Vg)(this.uri,c)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Ci=i;function n(h){return new i({uri:h,index:0,name:(0,M.$Rg)(h)},{uri:h.toString()})}e.$Ei="code-workspace",e.$Fi=`.${e.$Ei}`,e.$Gi=[{name:(0,o.localize)(0,null),extensions:[e.$Ei]}],e.$Hi="workspace.json";function r(h,c){return M.$Mg.isEqualOrParent(h,c.untitledWorkspacesHome)}function s(h){let c;return O.URI.isUri(h)?c=h:c=h.configuration,c?.scheme===$.Schemas.tmp}e.$Ki="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(h){return h.id===e.$Ki}function g(h,c){return!r(h,c)&&!s(h)}function d(h){return(typeof h=="string"?(0,R.$pc)(h):(0,M.$Tg)(h))===e.$Fi}}),define(Ee[278],Ce([1,0,55,4,3,23,2,216,137,32,5,12,43,27,275,8,30,14,18]),function(re,e,o,R,I,M,O,p,$,w,A,P,b,C,y,a,m,l,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sl=e.$rl=e.$ol=e.ProfileResourceType=void 0,e.$nl=r,e.$pl=s,e.$ql=t;var n;(function(h){h.Settings="settings",h.Keybindings="keybindings",h.Snippets="snippets",h.Tasks="tasks",h.Extensions="extensions",h.GlobalState="globalState"})(n||(e.ProfileResourceType=n={}));function r(h){const c=h;return!!(c&&typeof c=="object"&&typeof c.id=="string"&&typeof c.isDefault=="boolean"&&typeof c.name=="string"&&O.URI.isUri(c.location)&&O.URI.isUri(c.globalStorageHome)&&O.URI.isUri(c.settingsResource)&&O.URI.isUri(c.keybindingsResource)&&O.URI.isUri(c.tasksResource)&&O.URI.isUri(c.snippetsHome)&&O.URI.isUri(c.extensionsResource))}e.$ol=(0,A.$ii)("IUserDataProfilesService");function s(h,c){return{id:h.id,isDefault:h.isDefault,name:h.name,shortName:h.shortName,icon:h.icon,location:O.URI.revive(h.location).with({scheme:c}),globalStorageHome:O.URI.revive(h.globalStorageHome).with({scheme:c}),settingsResource:O.URI.revive(h.settingsResource).with({scheme:c}),keybindingsResource:O.URI.revive(h.keybindingsResource).with({scheme:c}),tasksResource:O.URI.revive(h.tasksResource).with({scheme:c}),snippetsHome:O.URI.revive(h.snippetsHome).with({scheme:c}),extensionsResource:O.URI.revive(h.extensionsResource).with({scheme:c}),cacheHome:O.URI.revive(h.cacheHome).with({scheme:c}),useDefaultFlags:h.useDefaultFlags,isTransient:h.isTransient}}function t(h,c,u,f,E,v){return{id:h,name:c,location:u,isDefault:!1,shortName:E?.shortName,icon:E?.icon,globalStorageHome:v&&E?.useDefaultFlags?.globalState?v.globalStorageHome:(0,M.$Vg)(u,"globalStorage"),settingsResource:v&&E?.useDefaultFlags?.settings?v.settingsResource:(0,M.$Vg)(u,"settings.json"),keybindingsResource:v&&E?.useDefaultFlags?.keybindings?v.keybindingsResource:(0,M.$Vg)(u,"keybindings.json"),tasksResource:v&&E?.useDefaultFlags?.tasks?v.tasksResource:(0,M.$Vg)(u,"tasks.json"),snippetsHome:v&&E?.useDefaultFlags?.snippets?v.snippetsHome:(0,M.$Vg)(u,"snippets"),extensionsResource:v&&E?.useDefaultFlags?.extensions?v.extensionsResource:(0,M.$Vg)(u,"extensions.json"),cacheHome:(0,M.$Vg)(f,h),useDefaultFlags:E?.useDefaultFlags,isTransient:E?.transient}}let g=class extends I.$Uc{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(c,u,f,E){super(),this.t=c,this.u=u,this.w=f,this.y=E,this.f=!0,this.h=this.B(new R.$7d),this.onDidChangeProfiles=this.h.event,this.j=this.B(new R.$7d),this.onWillCreateProfile=this.j.event,this.m=this.B(new R.$7d),this.onWillRemoveProfile=this.m.event,this.n=this.B(new R.$7d),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new C.$Bc,emptyWindows:new Map},this.profilesHome=(0,M.$Vg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,M.$Vg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(c){this.f!==c&&(this.z=void 0,this.f=c)}isEnabled(){return this.f}get C(){if(!this.z){const c=this.D(),u=[c];if(this.f)try{for(const v of this.O()){if(!v.name||!(0,i.$Vf)(v.name)||!v.location){this.y.warn("Skipping the invalid stored profile",v.location||v.name);continue}u.push(t((0,M.$Sg)(v.location),v.name,v.location,this.g,{shortName:v.shortName,icon:v.icon,useDefaultFlags:v.useDefaultFlags},c))}}catch(v){this.y.error(v)}const f=new C.$Bc,E=new Map;if(u.length)try{const v=this.Q();if(v.workspaces)for(const[D,k]of Object.entries(v.workspaces)){const S=O.URI.parse(D),F=u.find(W=>W.id===k);F&&f.set(S,F)}if(v.emptyWindows)for(const[D,k]of Object.entries(v.emptyWindows)){const S=u.find(F=>F.id===k);S&&E.set(D,S)}}catch(v){this.y.error(v)}this.z={profiles:u,workspaces:f,emptyWindows:E}}return this.z}D(){const c=t("__default__profile__",(0,p.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...c,extensionsResource:this.S()??c.extensionsResource,isDefault:!0}}async createTransientProfile(c){const u="Temp",f=new RegExp(`${(0,l.$Ze)(u)}\\s(\\d+)`);let E=0;for(const D of this.profiles){const k=f.exec(D.name),S=k?parseInt(k[1]):0;E=S>E?S:E}const v=`${u} ${E+1}`;return this.createProfile((0,o.$9i)((0,m.$Eg)()).toString(16),v,{transient:!0},c)}async createNamedProfile(c,u,f){return this.createProfile((0,o.$9i)((0,m.$Eg)()).toString(16),c,u,f)}async createProfile(c,u,f,E){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const v=await this.F(c,u,f);return E&&await this.setProfileForWorkspace(E,v),v}async F(c,u,f){if(!(0,i.$Vf)(u)||!u)throw new Error("Name of the profile is mandatory and must be of type `string`");let E=this.r.get(u);return E||(E=(async()=>{try{const v=this.profiles.find(S=>S.name===u||S.id===c);if(v)return v;const D=t(c,u,(0,M.$Vg)(this.profilesHome,c),this.g,f,this.defaultProfile);await this.u.createFolder(D.location);const k=[];return this.j.fire({profile:D,join(S){k.push(S)}}),await a.Promises.settled(k),this.I([D],[],[]),D}finally{this.r.delete(u)}})(),this.r.set(u,E)),E}async updateProfile(c,u){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let f=this.profiles.find(E=>E.id===c.id);if(!f)throw new Error(`Profile '${c.name}' does not exist`);return f=t(f.id,u.name??f.name,f.location,this.g,{shortName:u.shortName??f.shortName,icon:u.icon===null?void 0:u.icon??f.icon,transient:u.transient??f.isTransient,useDefaultFlags:u.useDefaultFlags??f.useDefaultFlags},this.defaultProfile),this.I([],[],[f]),f}async removeProfile(c){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(c.isDefault)throw new Error("Cannot remove default profile");const u=this.profiles.find(E=>E.id===c.id);if(!u)throw new Error(`Profile '${c.name}' does not exist`);const f=[];this.m.fire({profile:u,join(E){f.push(E)}});try{await Promise.allSettled(f)}catch(E){this.y.error(E)}for(const E of[...this.C.emptyWindows.keys()])u.id===this.C.emptyWindows.get(E)?.id&&this.C.emptyWindows.delete(E);for(const E of[...this.C.workspaces.keys()])u.id===this.C.workspaces.get(E)?.id&&this.C.workspaces.delete(E);this.M(),this.I([],[u],[]);try{await this.u.del(u.cacheHome,{recursive:!0})}catch(E){(0,w.$6k)(E)!==1&&this.y.error(E)}}async setProfileForWorkspace(c,u){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const f=this.profiles.find(E=>E.id===u.id);if(!f)throw new Error(`Profile '${u.name}' does not exist`);this.L(c,f)}unsetWorkspace(c,u){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(c,void 0,u)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const c=await this.u.resolve(this.profilesHome);await Promise.all((c.children||[]).filter(u=>u.isDirectory&&this.profiles.every(f=>!this.w.extUri.isEqual(f.location,u.resource))).map(u=>this.u.del(u.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const c=this.s.profiles.filter(u=>!this.H(u));await Promise.allSettled(c.map(u=>this.removeProfile(u)))}getProfileForWorkspace(c){const u=this.G(c);return O.URI.isUri(u)?this.s.workspaces.get(u)??this.C.workspaces.get(u):this.s.emptyWindows.get(u)??this.C.emptyWindows.get(u)}G(c){return(0,b.$si)(c)?c.uri:(0,b.$xi)(c)?c.configPath:c.id}H(c){return!!([...this.s.emptyWindows.values()].some(u=>this.w.extUri.isEqual(u.location,c.location))||[...this.s.workspaces.values()].some(u=>this.w.extUri.isEqual(u.location,c.location))||[...this.C.emptyWindows.values()].some(u=>this.w.extUri.isEqual(u.location,c.location))||[...this.C.workspaces.values()].some(u=>this.w.extUri.isEqual(u.location,c.location)))}I(c,u,f){const E=[...this.profiles,...c],v=[];this.s.profiles=[];for(let D of E)D.isDefault||u.some(k=>D.id===k.id)||(D=f.find(k=>D.id===k.id)??D,D.isTransient?this.s.profiles.push(D):v.push({location:D.location,name:D.name,shortName:D.shortName,icon:D.icon,useDefaultFlags:D.useDefaultFlags}));this.P(v),this.z=void 0,this.J(c,u,f)}J(c,u,f){this.h.fire({added:c,removed:u,updated:f,all:this.profiles})}L(c,u,f){f=u?.isTransient?!0:f,f||this.L(c,void 0,!0);const E=this.G(c),v=f?this.s:this.C;O.URI.isUri(E)?(v.workspaces.delete(E),u&&v.workspaces.set(E,u)):(v.emptyWindows.delete(E),u&&v.emptyWindows.set(E,u)),f||this.M()}M(){const c={};for(const[f,E]of this.C.workspaces.entries())c[f.toString()]=E.id;const u={};for(const[f,E]of this.C.emptyWindows.entries())u[f.toString()]=E.id;this.R({workspaces:c,emptyWindows:u}),this.z=void 0}N(c){const u={},f=this.D();if(c.workspaces)for(const[v,D]of Object.entries(c.workspaces)){const k=O.URI.parse(D);u[v]=this.w.extUri.isEqual(k,f.location)?f.id:this.w.extUri.basename(k)}const E={};if(c.emptyWindows)for(const[v,D]of Object.entries(c.emptyWindows)){const k=O.URI.parse(D);E[v]=this.w.extUri.isEqual(k,f.location)?f.id:this.w.extUri.basename(k)}return{workspaces:u,emptyWindows:E}}O(){return[]}P(c){throw new Error("not implemented")}Q(){return{}}R(c){throw new Error("not implemented")}S(){}};e.$rl=g,g.b="userDataProfiles",g.c="profileAssociations",e.$rl=g=Qe([He(0,$.$pi),He(1,w.$Ok),He(2,y.$ml),He(3,P.$Oj)],g);class d extends g{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(c){this.a=c}Q(){return this.X}R(c){this.X=c}}e.$sl=d}),define(Ee[279],Ce([1,0,8,4,3,58,18,178,5,278]),function(re,e,o,R,I,M,O,p,$,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=e.$Pp=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Np=e.$Mp=e.$Lp=void 0,e.$Op=C,e.$Qp=a,e.$Sp=l,e.$Lp="__$__isNewStorageMarker",e.$Mp="__$__targetStorageMarker",e.$Np=(0,$.$ii)("storageService");var A;(function(i){i[i.NONE=0]="NONE",i[i.SHUTDOWN=1]="SHUTDOWN"})(A||(e.WillSaveStateReason=A={}));var P;(function(i){i[i.APPLICATION=-1]="APPLICATION",i[i.PROFILE=0]="PROFILE",i[i.WORKSPACE=1]="WORKSPACE"})(P||(e.StorageScope=P={}));var b;(function(i){i[i.USER=0]="USER",i[i.MACHINE=1]="MACHINE"})(b||(e.StorageTarget=b={}));function C(i){const n=i.get(e.$Mp);if(n)try{return JSON.parse(n)}catch{}return Object.create(null)}class y extends I.$Uc{constructor(n={flushInterval:y.a}){super(),this.m=n,this.b=this.B(new R.$0d),this.c=this.B(new R.$0d),this.onDidChangeTarget=this.c.event,this.f=this.B(new R.$7d),this.onWillSaveState=this.f.event,this.h=this.B(new o.$uh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new I.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(n,r,s){return R.Event.filter(this.b.event,t=>t.scope===n&&(r===void 0||t.key===r),s)}n(){this.j.value=(0,o.$yh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,I.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,M.mark)("code/willInitStorage");try{await this.O()}finally{(0,M.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(n,r){const{key:s,external:t}=r;if(s===e.$Mp){switch(n){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:n})}else this.b.fire({scope:n,key:s,target:this.J(n)[s],external:t})}w(n){this.f.fire({reason:n})}get(n,r,s){return this.P(r)?.get(n,s)}getBoolean(n,r,s){return this.P(r)?.getBoolean(n,s)}getNumber(n,r,s){return this.P(r)?.getNumber(n,s)}getObject(n,r,s){return this.P(r)?.getObject(n,s)}storeAll(n,r){this.y(()=>{for(const s of n)this.store(s.key,s.value,s.scope,s.target,r)})}store(n,r,s,t,g=!1){if((0,O.$5f)(r)){this.remove(n,s,g);return}this.y(()=>{this.z(n,s,t),this.P(s)?.set(n,r,g)})}remove(n,r,s=!1){this.y(()=>{this.z(n,r,void 0),this.P(r)?.delete(n,s)})}y(n){this.b.pause(),this.c.pause();try{n()}finally{this.b.resume(),this.c.resume()}}keys(n,r){const s=[],t=this.J(n);for(const g of Object.keys(t))t[g]===r&&s.push(g);return s}z(n,r,s,t=!1){const g=this.J(r);typeof s=="number"?g[n]!==s&&(g[n]=s,this.P(r)?.set(e.$Mp,JSON.stringify(g),t)):typeof g[n]=="number"&&(delete g[n],this.P(r)?.set(e.$Mp,JSON.stringify(g),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(n){switch(n){case-1:return this.I;case 0:return this.G;default:return this.D}}L(n){const r=this.P(n);return r?C(r):Object.create(null)}isNew(n){return this.getBoolean(e.$Lp,n)===!0}async flush(n=A.NONE){this.f.fire({reason:n});const r=this.P(-1),s=this.P(0),t=this.P(1);switch(n){case A.NONE:await o.Promises.settled([r?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case A.SHUTDOWN:await o.Promises.settled([r?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const n=this.P(-1)?.items??new Map,r=this.P(0)?.items??new Map,s=this.P(1)?.items??new Map;return l(n,r,s,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(n){return await this.flush(),this.P(n)?.optimize()}async switch(n,r){return this.w(A.NONE),(0,w.$nl)(n)?this.R(n,r):this.S(n,r)}M(n,r){return!(n.id===r.id||a(r)&&a(n))}N(n,r,s){this.y(()=>{const t=new Set;for(const[g,d]of n)t.add(g),r.get(g)!==d&&this.u(s,{key:g,external:!0});for(const[g]of r.items)t.has(g)||this.u(s,{key:g,external:!0})})}}e.$Pp=y,y.a=60*1e3;function a(i){return i.isDefault||!!i.useDefaultFlags?.globalState}class m extends y{constructor(){super(),this.U=this.B(new p.$Jp(new p.$Kp,{hint:p.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new p.$Jp(new p.$Kp,{hint:p.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new p.$Jp(new p.$Kp,{hint:p.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(n=>this.u(1,n))),this.B(this.W.onDidChangeStorage(n=>this.u(0,n))),this.B(this.U.onDidChangeStorage(n=>this.u(-1,n)))}P(n){switch(n){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(n){switch(n){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(n){return!1}}e.$Rp=m;async function l(i,n,r,s,t,g){const d=S=>{try{return JSON.parse(S)}catch{return S}},h=new Map,c=new Map;i.forEach((S,F)=>{h.set(F,S),c.set(F,d(S))});const u=new Map,f=new Map;n.forEach((S,F)=>{u.set(F,S),f.set(F,d(S))});const E=new Map,v=new Map;r.forEach((S,F)=>{E.set(F,S),v.set(F,d(S))}),console.group(s!==t?`Storage: Application (path: ${s})`:`Storage: Application & Profile (path: ${s}, default profile)`);const D=[];if(h.forEach((S,F)=>{D.push({key:F,value:S})}),console.table(D),console.groupEnd(),console.log(c),s!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const S=[];u.forEach((F,W)=>{S.push({key:W,value:F})}),console.table(S),console.groupEnd(),console.log(f)}console.group(`Storage: Workspace (path: ${g})`);const k=[];E.forEach((S,F)=>{k.push({key:F,value:S})}),console.table(k),console.groupEnd(),console.log(v)}}),define(Ee[111],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xjc=void 0;class o{constructor(I){this.d=I,this.b=new Map,this.c=1}add(I){const M=this.c++;return this.b.set(M,I),this.e(),M}get(I,M){return this.b.has(I)?this.b.get(I)[M]:void 0}delete(I){this.b.delete(I),this.e()}e(){o.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$xjc=o,o.a=!1}),define(Ee[59],Ce([1,0,15,23,5]),function(re,e,o,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Djc=e.$Cjc=void 0;class M{constructor(){this.a=new Set(Object.keys(o.Schemas)),this.b=new Map,this.extUri=new R.$Kg(p=>{const $=this.b.get(p.scheme);return!($===void 0||$&1024)})}$acceptProviderInfos(p,$){$===null?this.b.delete(p.scheme):this.b.set(p.scheme,$)}isFreeScheme(p){return!this.b.has(p)&&!this.a.has(p)}getCapabilities(p){return this.b.get(p)}}e.$Cjc=M,e.$Djc=(0,I.$ii)("IExtHostFileSystemInfo")}),define(Ee[28],Ce([1,0,5]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5O=void 0,e.$5O=(0,o.$ii)("IExtHostInitDataService")}),define(Ee[280],Ce([1,0,223,12,260,28]),function(re,e,o,R,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Llc=void 0;let O=class extends I.$bQ{constructor($,w,A){const P=A.remote.isRemote?"remoteexthost":$?"workerexthost":"exthost",b=A.remote.isRemote?(0,o.localize)(0,null):$?(0,o.localize)(1,null):(0,o.localize)(2,null);super(w.createLogger(P,{name:b}))}};e.$Llc=O,e.$Llc=O=Qe([He(1,R.$Pj),He(2,M.$5O)],O)}),define(Ee[281],Ce([1,0,8]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mkc=e.$lkc=void 0;class R{constructor(O,p,$){this.h=new Map,this.a=O,this.b=p,this.c=$,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(w=>(this.f=w,this)),this.g=this.c.onDidChangeStorage(w=>{w.shared===this.b&&w.key===this.a&&(this.f=w.value)}),this.i=new o.$uh(()=>{const w=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const A of w.values())A.complete()}catch(A){for(const P of w.values())P.error(A)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,O])=>O!==void 0).map(([O])=>O)}get whenReady(){return this.d}get(O,p){let $=this.f[O];return typeof $>"u"&&($=p),$}update(O,p){this.f[O]=p;const $=this.h.get(O);if($!==void 0)return $.p;const w=new o.$Fh;return this.h.set(O,w),this.i.isScheduled()||this.i.schedule(),w.p}dispose(){this.g.dispose()}}e.$lkc=R;class I extends R{setKeysForSync(O){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},O)}constructor(O,p){super(O.identifier.value,!0,p),this.j=O}}e.$mkc=I}),define(Ee[282],Ce([1,0,4,2]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_kc=void 0;class I{constructor(O){this.c=O,this.a=new o.$7d,this.onDidSaveNotebookDocument=this.a.event,this.b=new o.$7d,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(O,p,$,w){const P=this.c.getNotebookDocument(R.URI.revive(O)).acceptModelChanged(p.value,$,w);this.b.fire(P)}$acceptDirtyStateChanged(O,p){this.c.getNotebookDocument(R.URI.revive(O)).acceptDirty(p)}$acceptModelSaved(O){const p=this.c.getNotebookDocument(R.URI.revive(O));this.a.fire(p.apiNotebook)}}e.$_kc=I}),define(Ee[20],Ce([1,0,5]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PO=e.$OO=void 0,e.$OO=(0,o.$ii)("IExtHostRpcService");class R{constructor(M){this.getProxy=M.getProxy.bind(M),this.set=M.set.bind(M),this.dispose=M.dispose.bind(M),this.assertRegistered=M.assertRegistered.bind(M),this.drain=M.drain.bind(M)}}e.$PO=R});var it=this&&this.__classPrivateFieldSet||function(re,e,o,R,I){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!I:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?I.call(re,o):I?I.value=o:e.set(re,o),o},qe=this&&this.__classPrivateFieldGet||function(re,e,o,R){if(o==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!R:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?R:o==="a"?R.call(re):R?R.value:e.get(re)};define(Ee[283],Ce([1,0,25,4]),function(re,e,o,R){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$tkc=void 0;class M{constructor(p,$){I.set(this,void 0),this.b=new R.$7d,this.onDidChange=this.b.event,this.a=o.$Em.toKey(p.identifier),it(this,I,$,"f"),qe(this,I,"f").onDidChangePassword(w=>{w.extensionId===this.a&&this.b.fire({key:w.key})})}get(p){return qe(this,I,"f").get(this.a,p)}store(p,$){return qe(this,I,"f").store(this.a,p,$)}delete(p){return qe(this,I,"f").delete(this.a,p)}}e.$tkc=M,I=new WeakMap}),define(Ee[66],Ce([1,0,5]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wjc=e.$Vjc=void 0,e.$Vjc=(0,o.$ii)("IURITransformerService");class R{constructor(M){M?(this.transformIncoming=M.transformIncoming.bind(M),this.transformOutgoing=M.transformOutgoing.bind(M),this.transformOutgoingURI=M.transformOutgoingURI.bind(M),this.transformOutgoingScheme=M.transformOutgoingScheme.bind(M)):(this.transformIncoming=O=>O,this.transformOutgoing=O=>O,this.transformOutgoingURI=O=>O,this.transformOutgoingScheme=O=>O)}}e.$Wjc=R}),define(Ee[284],Ce([1,0,21]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Onb=I,e.$Pnb=O;class R{constructor(){this.buffers=[]}add($){let w=this.buffers.indexOf($);return w<0&&(w=this.buffers.length,this.buffers.push($)),w}}function I(p,$){if($.serializeBuffersForPostMessage){const w=new R,P=JSON.stringify(p,(C,y)=>{if(y instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:w.add(y)};if(ArrayBuffer.isView(y)){const a=M(y);if(a)return{$$vscode_array_buffer_reference$$:!0,index:w.add(y.buffer),view:{type:a,byteLength:y.byteLength,byteOffset:y.byteOffset}}}return y}),b=w.buffers.map(C=>{const y=new Uint8Array(C);return o.$ue.wrap(y)});return{message:P,buffers:b}}else return{message:JSON.stringify(p),buffers:[]}}function M(p){switch(p.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function O(p,$){const w=$.map(b=>{const C=new ArrayBuffer(b.byteLength);return new Uint8Array(C).set(b.buffer),C}),A=$.length?(b,C)=>{if(C&&typeof C=="object"&&C.$$vscode_array_buffer_reference$$){const y=C,{index:a}=y,m=w[a];if(y.view)switch(y.view.type){case 1:return new Int8Array(m,y.view.byteOffset,y.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(m,y.view.byteOffset,y.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(m,y.view.byteOffset,y.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(m,y.view.byteOffset,y.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(m,y.view.byteOffset,y.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(m,y.view.byteOffset,y.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(m,y.view.byteOffset,y.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(m,y.view.byteOffset,y.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(m,y.view.byteOffset,y.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(m,y.view.byteOffset,y.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(m,y.view.byteOffset,y.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return m}return C}:void 0;return{message:JSON.parse(p,A),arrayBuffers:w}}}),define(Ee[285],Ce([1,0,112,398,399,63,2,12,400]),function(re,e,o,R,I,M,O,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hmc=A;const w=!1;function A(n,r,s,t,g,d){const h=d.environment.useHostProxy,c=typeof h=="boolean"?h:!d.remote.isRemote,u={resolveProxy:v=>n.resolveProxy(v),lookupProxyAuthorization:m.bind(void 0,t,g,r,{},d.remote.isRemote),getProxyURL:()=>r.getConfiguration("http").get("proxy"),getProxySupport:()=>r.getConfiguration("http").get("proxySupport")||"off",addCertificatesV1:()=>b(r),addCertificatesV2:()=>C(r),log:t,getLogLevel:()=>{const v=t.getLevel();switch(v){case p.LogLevel.Trace:return $.LogLevel.Trace;case p.LogLevel.Debug:return $.LogLevel.Debug;case p.LogLevel.Info:return $.LogLevel.Info;case p.LogLevel.Warning:return $.LogLevel.Warning;case p.LogLevel.Error:return $.LogLevel.Error;case p.LogLevel.Off:return $.LogLevel.Off;default:return D(v)}function D(k){return t.error("Unknown log level",k),$.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:c,loadAdditionalCertificates:async()=>{const v=[];if(d.remote.isRemote&&v.push((0,$.loadSystemCertificates)({log:t})),c){t.trace("ProxyResolver#loadAdditionalCertificates: Loading certificates from main process");const D=n.loadCertificates();D.then(k=>t.trace("ProxyResolver#loadAdditionalCertificates: Loaded certificates from main process",k.length)),v.push(D)}return(await Promise.all(v)).flat()},env:process.env},f=(0,$.createProxyResolver)(u),E=P(u,f);return a(s,E)}function P(n,r){return{http:Object.assign(o,(0,$.createHttpPatch)(n,o,r)),https:Object.assign(R,(0,$.createHttpPatch)(n,R,r)),net:Object.assign(M,(0,$.createNetPatch)(n,M)),tls:Object.assign(I,(0,$.createTlsPatch)(n,I))}}function b(n){const r=n.getConfiguration("http");return!r.get("experimental.systemCertificatesV2",w)&&!!r.get("systemCertificates")}function C(n){const r=n.getConfiguration("http");return!!r.get("experimental.systemCertificatesV2",w)&&!!r.get("systemCertificates")}const y=new Map;function a(n,r){return n.getExtensionPathIndex().then(s=>{const t=globalThis._VSCODE_NODE_MODULES.module,g=t._load;t._load=function(h,c,u){if(h==="net")return r.net;if(h==="tls")return r.tls;if(h!=="http"&&h!=="https")return g.apply(this,arguments);const f=s.findSubstr(O.URI.file(c.filename));let E=y.get(f);if(E||y.set(f,E={}),!E[h]){const v=r[h];E[h]={...v}}return E[h]}})}async function m(n,r,s,t,g,d,h,c){const u=t[d];h&&(t[d]=h),n.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${d}`,`proxyAuthenticate:${h}`,`proxyAuthenticateCache:${u}`);const f=h||u,E=Array.isArray(f)?f:typeof f=="string"?[f]:[];if(i(r,E,g),E.some(v=>/^(Negotiate|Kerberos)( |$)/i.test(v))&&!c.kerberosRequested)try{c.kerberosRequested=!0;const v=await new Promise((W,B)=>{re(["kerberos"],W,B)}),D=new URL(d),k=s.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${D.hostname}`:`HTTP@${D.hostname}`);return n.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${d}`,`spn:${k}`),"Negotiate "+await(await v.initializeClient(k)).step("")}catch(v){n.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",v)}}let l=!1;function i(n,r,s){l||!r.length||(l=!0,n.$publicLog2("proxyAuthenticationRequest",{authenticationType:r.map(t=>t.split(" ")[0]).join(","),extensionHostType:s?"remote":"local"}))}}),define(Ee[286],Ce([1,0,131]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ls=I;function R(M){return{transformIncoming:O=>O.scheme==="vscode-remote"?{scheme:"file",path:O.path,query:O.query,fragment:O.fragment}:O.scheme==="file"?{scheme:"vscode-local",path:O.path,query:O.query,fragment:O.fragment}:O,transformOutgoing:O=>O.scheme==="file"?{scheme:"vscode-remote",authority:M,path:O.path,query:O.query,fragment:O.fragment}:O.scheme==="vscode-local"?{scheme:"file",path:O.path,query:O.query,fragment:O.fragment}:O,transformOutgoingScheme:O=>O==="file"?"vscode-remote":O==="vscode-local"?"file":O}}function I(M){return new o.$ln(R(M))}}),define(Ee[143],Ce([1,0,233,18,2,3,5,37,32,15,47,197,41]),function(re,e,o,R,I,M,O,p,$,w,A,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$uF=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$lF=e.EditorInputCapabilities=e.$kF=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$aF=e.$_E=e.$$E=e.$0E=e.$9E=void 0,e.$bF=a,e.$cF=m,e.$dF=l,e.$eF=i,e.$fF=n,e.$gF=r,e.$hF=s,e.$iF=t,e.$jF=g,e.$mF=E,e.$nF=D,e.$oF=k,e.$pF=S,e.$qF=F,e.$rF=W,e.$sF=B,e.$tF=Q,e.$vF=x,e.$wF=te,e.$xF=pe,e.$yF=ye,e.$9E={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$0E={id:"default",displayName:(0,o.localize)(0,null),providerDisplayName:(0,o.localize)(1,null)},e.$$E="workbench.editor.sidebysideEditor",e.$_E="workbench.editors.textDiffEditor",e.$aF="workbench.editors.binaryResourceDiffEditor";var C;(function(_){_[_.PROGRAMMATIC=1]="PROGRAMMATIC",_[_.USER=2]="USER",_[_.EDIT=3]="EDIT",_[_.NAVIGATION=4]="NAVIGATION",_[_.JUMP=5]="JUMP"})(C||(e.EditorPaneSelectionChangeReason=C={}));var y;(function(_){_[_.IDENTICAL=1]="IDENTICAL",_[_.SIMILAR=2]="SIMILAR",_[_.DIFFERENT=3]="DIFFERENT"})(y||(e.EditorPaneSelectionCompareResult=y={}));function a(_){const U=_;return!!U&&typeof U.getSelection=="function"&&!!U.onDidChangeSelection}function m(_){const U=_;return!!U&&typeof U.getScrollPosition=="function"&&typeof U.setScrollPosition=="function"&&!!U.onDidChangeScroll}function l(_,U,he){for(const Se of he.visibleEditorPanes)if(Se.group.id===U&&_.matches(Se.input))return Se.getViewState()}function i(_){if(E(_))return!1;const U=_;return I.URI.isUri(U?.resource)}function n(_){if(E(_))return!1;const U=_;return U?.original!==void 0&&U.modified!==void 0}function r(_){if(E(_))return!1;const U=_;return!U||U.resources&&!Array.isArray(U.resources)?!1:!!U.resources||!!U.multiDiffSource}function s(_){if(E(_)||n(_))return!1;const U=_;return U?.primary!==void 0&&U.secondary!==void 0}function t(_){if(E(_))return!1;const U=_;return U?U.resource===void 0||U.resource.scheme===w.Schemas.untitled||U.forceUntitled===!0:!1}function g(_){if(E(_))return!1;const U=_;return I.URI.isUri(U?.base?.resource)&&I.URI.isUri(U?.input1?.resource)&&I.URI.isUri(U?.input2?.resource)&&I.URI.isUri(U?.result?.resource)}var d;(function(_){_[_.SHORT=0]="SHORT",_[_.MEDIUM=1]="MEDIUM",_[_.LONG=2]="LONG"})(d||(e.Verbosity=d={}));var h;(function(_){_[_.EXPLICIT=1]="EXPLICIT",_[_.AUTO=2]="AUTO",_[_.FOCUS_CHANGE=3]="FOCUS_CHANGE",_[_.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(h||(e.SaveReason=h={}));class c{constructor(){this.a=new Map}registerSource(U,he){let Se=this.a.get(U);return Se||(Se={source:U,label:he},this.a.set(U,Se)),Se.source}getSourceLabel(U){return this.a.get(U)?.label??U}}e.$kF=new c;var u;(function(_){_[_.None=0]="None",_[_.Readonly=2]="Readonly",_[_.Untitled=4]="Untitled",_[_.Singleton=8]="Singleton",_[_.RequiresTrust=16]="RequiresTrust",_[_.CanSplitInGroup=32]="CanSplitInGroup",_[_.ForceDescription=64]="ForceDescription",_[_.CanDropIntoEditor=128]="CanDropIntoEditor",_[_.MultipleEditors=256]="MultipleEditors",_[_.Scratchpad=512]="Scratchpad"})(u||(e.EditorInputCapabilities=u={}));class f extends M.$Uc{}e.$lF=f;function E(_){return _ instanceof f}function v(_){const U=_;return I.URI.isUri(U?.preferredResource)}function D(_){const U=_;return E(U?.primary)&&E(U?.secondary)}function k(_){const U=_;return E(U?.modified)&&E(U?.original)}function S(_,U,he,Se,me){return ye(Se,[(0,P.$5i)({id:"workbench.action.openLargeFile",label:(0,o.localize)(2,null),run:()=>{const ie={...he,limits:{size:Number.MAX_VALUE}};_.openEditor(U,ie)}}),(0,P.$5i)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,o.localize)(3,null),run:()=>me.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:b.default.Warning})}function F(_){return E(_?.editor)}function W(_){const U=_;return F(_)&&U?.group!==void 0}function B(_){const U=_;return typeof U?.groupId=="number"&&E(U.editor)}var T;(function(_){_[_.UNKNOWN=0]="UNKNOWN",_[_.REPLACE=1]="REPLACE",_[_.MOVE=2]="MOVE",_[_.UNPIN=3]="UNPIN"})(T||(e.EditorCloseContext=T={}));var N;(function(_){_[_.GROUP_ACTIVE=0]="GROUP_ACTIVE",_[_.GROUP_INDEX=1]="GROUP_INDEX",_[_.GROUP_LABEL=2]="GROUP_LABEL",_[_.GROUP_LOCKED=3]="GROUP_LOCKED",_[_.EDITOR_OPEN=4]="EDITOR_OPEN",_[_.EDITOR_CLOSE=5]="EDITOR_CLOSE",_[_.EDITOR_MOVE=6]="EDITOR_MOVE",_[_.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",_[_.EDITOR_LABEL=8]="EDITOR_LABEL",_[_.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",_[_.EDITOR_PIN=10]="EDITOR_PIN",_[_.EDITOR_TRANSIENT=11]="EDITOR_TRANSIENT",_[_.EDITOR_STICKY=12]="EDITOR_STICKY",_[_.EDITOR_DIRTY=13]="EDITOR_DIRTY",_[_.EDITOR_WILL_DISPOSE=14]="EDITOR_WILL_DISPOSE"})(N||(e.GroupModelChangeKind=N={}));var j;(function(_){_[_.PRIMARY=1]="PRIMARY",_[_.SECONDARY=2]="SECONDARY",_[_.BOTH=3]="BOTH",_[_.ANY=4]="ANY"})(j||(e.SideBySideEditor=j={}));class L{getOriginalUri(U,he){if(!U)return;if(g(U))return e.$uF.getOriginalUri(U.result,he);if(he?.supportSideBySide){const{primary:me,secondary:ie}=this.a(U);if(me&&ie){if(he?.supportSideBySide===j.BOTH)return{primary:this.getOriginalUri(me,{filterByScheme:he.filterByScheme}),secondary:this.getOriginalUri(ie,{filterByScheme:he.filterByScheme})};if(he?.supportSideBySide===j.ANY)return this.getOriginalUri(me,{filterByScheme:he.filterByScheme})??this.getOriginalUri(ie,{filterByScheme:he.filterByScheme});U=he.supportSideBySide===j.PRIMARY?me:ie}}if(n(U)||r(U)||s(U)||g(U))return;const Se=v(U)?U.preferredResource:U.resource;return!Se||!he||!he.filterByScheme?Se:this.b(Se,he.filterByScheme)}a(U){return D(U)||s(U)?{primary:U.primary,secondary:U.secondary}:k(U)||n(U)?{primary:U.modified,secondary:U.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(U,he){if(!U)return;if(g(U))return e.$uF.getCanonicalUri(U.result,he);if(he?.supportSideBySide){const{primary:me,secondary:ie}=this.a(U);if(me&&ie){if(he?.supportSideBySide===j.BOTH)return{primary:this.getCanonicalUri(me,{filterByScheme:he.filterByScheme}),secondary:this.getCanonicalUri(ie,{filterByScheme:he.filterByScheme})};if(he?.supportSideBySide===j.ANY)return this.getCanonicalUri(me,{filterByScheme:he.filterByScheme})??this.getCanonicalUri(ie,{filterByScheme:he.filterByScheme});U=he.supportSideBySide===j.PRIMARY?me:ie}}if(n(U)||r(U)||s(U)||g(U))return;const Se=U.resource;return!Se||!he||!he.filterByScheme?Se:this.b(Se,he.filterByScheme)}b(U,he){if(Array.isArray(he)){if(he.some(Se=>U.scheme===Se))return U}else if(he===U.scheme)return U}}var z;(function(_){_[_.UNKNOWN=0]="UNKNOWN",_[_.KEYBOARD=1]="KEYBOARD",_[_.MOUSE=2]="MOUSE"})(z||(e.EditorCloseMethod=z={}));function Q(_,U,he,Se){if(!_.isSticky(U))return!1;switch(Se.preventPinnedEditorClose){case"keyboardAndMouse":return he===z.MOUSE||he===z.KEYBOARD;case"mouse":return he===z.MOUSE;case"keyboard":return he===z.KEYBOARD}return!1}e.$uF=new L;var Y;(function(_){_[_.LEFT=0]="LEFT",_[_.RIGHT=1]="RIGHT"})(Y||(e.CloseDirection=Y={}));class J{constructor(){this.c=new Map,this.d=new Map}start(U){const he=this.a=U.get(O.$hi);for(const[Se,me]of this.c)this.e(Se,me,he);this.c.clear()}e(U,he,Se){const me=Se.createInstance(he);this.d.set(U,me)}registerFileEditorFactory(U){if(this.b)throw new Error("Can only register one file editor factory.");this.b=U}getFileEditorFactory(){return(0,R.$7f)(this.b)}registerEditorSerializer(U,he){if(this.c.has(U)||this.d.has(U))throw new Error(`A editor serializer with type ID '${U}' was already registered.`);return this.a?this.e(U,he,this.a):this.c.set(U,he),(0,M.$Sc)(()=>{this.c.delete(U),this.d.delete(U)})}getEditorSerializer(U){return this.d.get(typeof U=="string"?U:U.typeId)}}p.$2n.add(e.$9E.EditorFactory,new J);async function x(_,U,he){return!_||!_.length?[]:await Promise.all(_.map(async Se=>{const me=I.URI.revive(Se.fileUri);if(!me){he.info("Cannot resolve the path because it is not valid.",Se);return}if(!await U.canHandleResource(me)){he.info("Cannot resolve the path because it cannot be handled",Se);return}let se=Se.exists,oe=Se.type;if(typeof se!="boolean"||typeof oe!="number")try{oe=(await U.stat(me)).isDirectory?$.FileType.Directory:$.FileType.Unknown,se=!0}catch(ee){he.error(ee),se=!1}if(!se&&Se.openOnlyIfExists){he.info("Cannot resolve the path because it does not exist",Se);return}if(oe===$.FileType.Directory){he.info("Cannot resolve the path because it is a directory",Se);return}const G={...Se.options,pinned:!0};return se?{resource:me,options:G}:{resource:me,options:G,forceUntitled:!0}}))}var ce;(function(_){_[_.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",_[_.SEQUENTIAL=1]="SEQUENTIAL"})(ce||(e.EditorsOrder=ce={}));function te(_){const U=_;if(!U)return!1;const he=U;if(he.modified)return te(he.modified);const Se=U;return!!(Se.contributionsState&&Se.viewState&&Array.isArray(Se.cursorState))}function pe(_){return(0,A.$7i)(_)}function ye(_,U,he){const Se=(0,A.$8i)(_,U);return Se.forceMessage=he?.forceMessage,Se.forceSeverity=he?.forceSeverity,Se.allowDialog=he?.allowDialog,Se}}),define(Ee[287],Ce([1,0,4,234,5,3,27,37,19,24,78,274]),function(re,e,o,R,I,M,O,p,$,w,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GF=e.$FF=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$EF=e.ViewContentGroups=e.$CF=e.ViewContainerLocation=e.Extensions=e.$BF=e.$AF=e.$zF=void 0,e.$DF=y,e.$zF="views",e.$AF=(0,R.localize)(0,null),e.$BF=(0,P.$Vw)("default-view-icon",A.$Hj.window,(0,R.localize)(1,null));var b;(function(g){g.ViewContainersRegistry="workbench.registry.view.containers",g.ViewsRegistry="workbench.registry.view"})(b||(e.Extensions=b={}));var C;(function(g){g[g.Sidebar=0]="Sidebar",g[g.Panel=1]="Panel",g[g.AuxiliaryBar=2]="AuxiliaryBar"})(C||(e.ViewContainerLocation=C={})),e.$CF=[0,1,2];function y(g){switch(g){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}class a extends M.$Uc{constructor(){super(...arguments),this.c=this.B(new o.$7d),this.onDidRegister=this.c.event,this.f=this.B(new o.$7d),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,$.$Rb)([...this.g.values()])}registerViewContainer(d,h,c){const u=this.get(d.id);if(u)return u;const f=d;return f.openCommandActionDescriptor=c?.doNotRegisterOpenCommand?void 0:f.openCommandActionDescriptor??{id:f.id},(0,O.$yc)(this.g,h,[]).push(f),c?.isDefault&&this.h.push(f),this.c.fire({viewContainer:f,viewContainerLocation:h}),f}deregisterViewContainer(d){for(const h of this.g.keys()){const c=this.g.get(h),u=c?.indexOf(d);if(u!==-1){c?.splice(u,1),c.length===0&&this.g.delete(h),this.f.fire({viewContainer:d,viewContainerLocation:h});return}}}get(d){return this.all.filter(h=>h.id===d)[0]}getViewContainers(d){return[...this.g.get(d)||[]]}getViewContainerLocation(d){return[...this.g.keys()].filter(h=>this.getViewContainers(h).filter(c=>c?.id===d.id).length>0)[0]}getDefaultViewContainer(d){return this.h.find(h=>this.getViewContainerLocation(h)===d)}}p.$2n.add(b.ViewContainersRegistry,new a);var m;(function(g){g.Open="2_open",g.Debug="4_debug",g.SCM="5_scm",g.More="9_more"})(m||(e.ViewContentGroups=m={}));function l(g,d){const h=g.group??m.More,c=d.group??m.More;return h!==c?h.localeCompare(c):(g.order??5)-(d.order??5)}class i extends M.$Uc{constructor(){super(...arguments),this.c=this.B(new o.$7d),this.onViewsRegistered=this.c.event,this.f=this.B(new o.$7d),this.onViewsDeregistered=this.f.event,this.g=this.B(new o.$7d),this.onDidChangeContainer=this.g.event,this.h=this.B(new o.$7d),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new O.$Hc}registerViews(d,h){this.registerViews2([{views:d,viewContainer:h}])}registerViews2(d){d.forEach(({views:h,viewContainer:c})=>this.r(h,c)),this.c.fire(d)}deregisterViews(d,h){const c=this.s(d,h);c.length&&this.f.fire({views:c,viewContainer:h})}moveViews(d,h){for(const c of this.m.keys())if(c!==h){const u=this.s(d,c);u.length&&(this.r(u,h),this.g.fire({views:u,from:c,to:h}))}}getViews(d){return this.m.get(d)||[]}getView(d){for(const h of this.j){const c=(this.m.get(h)||[]).filter(u=>u.id===d)[0];if(c)return c}return null}getViewContainer(d){for(const h of this.j)if((this.m.get(h)||[]).filter(u=>u.id===d)[0])return h;return null}registerViewWelcomeContent(d,h){return this.n.add(d,h),this.h.fire(d),(0,M.$Sc)(()=>{this.n.delete(d,h),this.h.fire(d)})}registerViewWelcomeContent2(d,h){const c=new Map;for(const[u,f]of h)this.n.add(d,f),c.set(u,(0,M.$Sc)(()=>{this.n.delete(d,f),this.h.fire(d)}));return this.h.fire(d),c}getViewWelcomeContent(d){const h=[];return this.n.forEach(d,c=>h.push(c)),h.sort(l)}r(d,h){let c=this.m.get(h);c||(c=[],this.m.set(h,c),this.j.push(h));for(const u of d){if(this.getView(u.id)!==null)throw new Error((0,R.localize)(2,null,u.id));c.push(u)}}s(d,h){const c=this.m.get(h);if(!c)return[];const u=[],f=[];for(const E of c)d.includes(E)?u.push(E):f.push(E);return u.length&&(f.length?this.m.set(h,f):(this.m.delete(h),this.j.splice(this.j.indexOf(h),1))),u}}p.$2n.add(b.ViewsRegistry,new i),e.$EF=(0,I.$ii)("viewDescriptorService");var n;(function(g){g[g.Default=0]="Default",g[g.Expand=1]="Expand"})(n||(e.ViewVisibilityState=n={}));var r;(function(g){g[g.None=0]="None",g[g.Collapsed=1]="Collapsed",g[g.Expanded=2]="Expanded"})(r||(e.TreeItemCollapsibleState=r={}));class s{constructor(d,h){this.c=!1,this.d=!1,(0,w.$Sn)(this,d),this.d=!!h,this.resolve=async c=>{if(h&&!this.c){const u=await h(c);u&&(this.tooltip=this.tooltip??u.tooltip,this.command=this.command??u.command)}c.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$FF=s;class t extends Error{constructor(d){super((0,R.localize)(3,null,d)),this.name="NoTreeViewError"}static is(d){return d.name==="NoTreeViewError"}}e.$GF=t}),define(Ee[288],Ce([1,0,4,39,3,42,5]),function(re,e,o,R,I,M,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IG=e.$HG=e.$GG=e.ChatAgentLocation=void 0;var p;(function(A){A.Panel="panel",A.Terminal="terminal",A.Notebook="notebook",A.Editor="editor"})(p||(e.ChatAgentLocation=p={})),function(A){function P(b){switch(b){case"panel":return A.Panel;case"terminal":return A.Terminal;case"notebook":return A.Notebook}return A.Panel}A.fromRaw=P}(p||(e.ChatAgentLocation=p={})),e.$GG=(0,O.$ii)("chatAgentService");let $=class{constructor(P){this.e=P,this.b=[],this.d=new o.$7d,this.onDidChangeAgents=this.d.event}registerAgent(P,b){if(this.getAgent(P))throw new Error(`Agent already registered: ${JSON.stringify(P)}`);const y=this,a=b.slashCommands;b={...b,get slashCommands(){return a.filter(l=>!l.when||y.e.contextMatchesRules(M.$gj.deserialize(l.when)))}};const m={data:b};return this.b.push(m),(0,I.$Sc)(()=>{this.b=this.b.filter(l=>l!==m),this.d.fire(void 0)})}registerAgentImplementation(P,b){const C=this.f(P);if(!C)throw new Error(`Unknown agent: ${JSON.stringify(P)}`);if(C.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(P)}`);return C.impl=b,this.d.fire(new w(C.data,b)),(0,I.$Sc)(()=>{C.impl=void 0,this.d.fire(void 0)})}registerDynamicAgent(P,b){const C={data:P,impl:b};return this.b.push(C),this.d.fire(new w(P,b)),(0,I.$Sc)(()=>{this.b=this.b.filter(y=>y!==C),this.d.fire(void 0)})}updateAgent(P,b){const C=this.f(P);if(!C?.impl)throw new Error(`No activated agent with id ${JSON.stringify(P)} registered`);C.data.metadata={...C.data.metadata,...b},this.d.fire(new w(C.data,C.impl))}getDefaultAgent(P){return this.getActivatedAgents().find(b=>!!b.isDefault&&b.locations.includes(P))}getSecondaryAgent(){return R.Iterable.find(this.b.values(),P=>!!P.data.metadata.isSecondary)?.data}f(P){return this.b.find(b=>b.data.id===P)}getAgent(P){return this.f(P)?.data}getAgents(){return this.b.map(P=>P.data)}getActivatedAgents(){return Array.from(this.b.values()).filter(P=>!!P.impl).map(P=>new w(P.data,P.impl))}getAgentsByName(P){return this.getAgents().filter(b=>b.name===P)}async invokeAgent(P,b,C,y,a){const m=this.f(P);if(!m?.impl)throw new Error(`No activated agent with id ${P}`);return await m.impl.invoke(b,C,y,a)}async getFollowups(P,b,C,y,a){const m=this.f(P);if(!m?.impl)throw new Error(`No activated agent with id ${P}`);return m.impl?.provideFollowups?m.impl.provideFollowups(b,C,y,a):[]}};e.$HG=$,$.AGENT_LEADER="@",e.$HG=$=Qe([He(0,M.$Aj)],$);class w{constructor(P,b){this.b=P,this.d=b}get id(){return this.b.id}get name(){return this.b.name??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get defaultImplicitVariables(){return this.b.defaultImplicitVariables}get locations(){return this.b.locations}async invoke(P,b,C,y){return this.d.invoke(P,b,C,y)}async provideFollowups(P,b,C,y){return this.d.provideFollowups?this.d.provideFollowups(P,b,C,y):[]}provideWelcomeMessage(P){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(P)}provideSampleQuestions(P){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(P)}}e.$IG=w}),define(Ee[289],Ce([1,0,2,29,5]),function(re,e,o,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SF=e.$RF=e.ChatCopyKind=e.InteractiveSessionVoteDirection=void 0,e.$PF=M,e.$QF=O;function M(w){return!!w&&typeof w=="object"&&"uri"in w&&w.uri instanceof o.URI&&"version"in w&&typeof w.version=="number"&&"ranges"in w&&Array.isArray(w.ranges)&&w.ranges.every(R.$dt.isIRange)}function O(w){return!!w&&typeof w=="object"&&"documents"in w&&Array.isArray(w.documents)&&w.documents.every(M)}var p;(function(w){w[w.Down=0]="Down",w[w.Up=1]="Up"})(p||(e.InteractiveSessionVoteDirection=p={}));var $;(function(w){w[w.Action=1]="Action",w[w.Toolbar=2]="Toolbar"})($||(e.ChatCopyKind=$={})),e.$RF=(0,I.$ii)("IChatService"),e.$SF="accessibility.voice.keywordActivation"}),define(Ee[144],Ce([1,0,4,8,235]),function(re,e,o,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$job=void 0;class M{constructor(){this.f=new Map,this.m=[],this.n=new o.$7d,this.o=new o.$7d,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(p){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=p}onEvent(p){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=p}onRequest(p){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=p}sendResponse(p){p.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${p.command}`)):this.u("response",p)}sendRequest(p,$,w,A){const P={command:p};if($&&Object.keys($).length>0&&(P.arguments=$),this.u("request",P),typeof A=="number"){const b=setTimeout(()=>{clearTimeout(b);const C=this.f.get(P.seq);if(C){this.f.delete(P.seq);const y={type:"response",seq:0,request_seq:P.seq,success:!1,command:p,message:(0,I.localize)(0,null,A,p)};C(y)}},A)}return w&&this.f.set(P.seq,w),P.seq}acceptMessage(p){this.k?this.k(p):(this.m.push(p),this.m.length===1&&this.s())}q(p,$){return p.type!=="event"||$.type!=="event"}async s(){let p;for(;this.m.length;){if((!p||this.q(this.m[0],p))&&await(0,R.$jh)(0),p=this.m.shift(),!p)return;switch(p.type){case"event":this.j?.(p);break;case"request":this.g?.(p);break;case"response":{const $=p,w=this.f.get($.request_seq);w&&(this.f.delete($.request_seq),w($));break}}}}u(p,$){$.type=p,$.seq=this.d++,this.sendMessage($)}async w(){if(this.f.size===0)return Promise.resolve();const p=new Map;this.f.forEach(($,w)=>p.set(w,$)),await(0,R.$jh)(500),p.forEach(($,w)=>{$({type:"response",seq:0,request_seq:w,success:!1,command:"canceled",message:"canceled"}),this.f.delete(w)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$job=M}),define(Ee[290],Ce([1,0,2,236,42,5]),function(re,e,o,R,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$XI=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$WI=e.MemoryRangeType=e.State=e.$UI=e.$TI=e.$SI=e.$RI=e.$QI=e.$PI=e.$OI=e.$NI=e.$MI=e.$LI=e.$KI=e.$JI=e.$II=e.$HI=e.$GI=e.$FI=e.$EI=e.$DI=e.$CI=e.$BI=e.$AI=e.$zI=e.$yI=e.$xI=e.$wI=e.$vI=e.$uI=e.$tI=e.$sI=e.$rI=e.$qI=e.$pI=e.$oI=e.$nI=e.$mI=e.$lI=e.$kI=e.$jI=e.$iI=e.$hI=e.$gI=e.$fI=e.$eI=e.$dI=e.$cI=e.$bI=e.$aI=e.$_H=e.$$H=e.$0H=e.$9H=e.$8H=e.$7H=e.$6H=e.$5H=e.$4H=e.$3H=e.$2H=e.$1H=e.$ZH=e.$YH=e.$XH=e.$WH=e.$VH=e.$UH=e.$TH=e.$SH=e.$RH=e.$QH=e.$PH=e.$OH=e.$NH=e.$MH=e.$LH=e.$KH=e.$JH=void 0,e.$VI=$,e.$JH="workbench.view.debug",e.$KH="workbench.debug.variablesView",e.$LH="workbench.debug.watchExpressionsView",e.$MH="workbench.debug.callStackView",e.$NH="workbench.debug.loadedScriptsView",e.$OH="workbench.debug.breakPointsView",e.$PH="workbench.debug.disassemblyView",e.$QH="workbench.panel.repl",e.$RH="workbench.panel.repl.view",e.$SH=new I.$zj("debugType",void 0,{type:"string",description:R.localize(0,null)}),e.$TH=new I.$zj("debugConfigurationType",void 0,{type:"string",description:R.localize(1,null)}),e.$UH=new I.$zj("debugState","inactive",{type:"string",description:R.localize(2,null)}),e.$VH="debugUx",e.$WH=new I.$zj(e.$VH,"default",{type:"string",description:R.localize(3,null)}),e.$XH=new I.$zj("hasDebugged",!1,{type:"boolean",description:R.localize(4,null)}),e.$YH=new I.$zj("inDebugMode",!1,{type:"boolean",description:R.localize(5,null)}),e.$ZH=new I.$zj("inDebugRepl",!1,{type:"boolean",description:R.localize(6,null)}),e.$1H=new I.$zj("breakpointWidgetVisible",!1,{type:"boolean",description:R.localize(7,null)}),e.$2H=new I.$zj("inBreakpointWidget",!1,{type:"boolean",description:R.localize(8,null)}),e.$3H=new I.$zj("breakpointsFocused",!0,{type:"boolean",description:R.localize(9,null)}),e.$4H=new I.$zj("watchExpressionsFocused",!0,{type:"boolean",description:R.localize(10,null)}),e.$5H=new I.$zj("watchExpressionsExist",!1,{type:"boolean",description:R.localize(11,null)}),e.$6H=new I.$zj("variablesFocused",!0,{type:"boolean",description:R.localize(12,null)}),e.$7H=new I.$zj("expressionSelected",!1,{type:"boolean",description:R.localize(13,null)}),e.$8H=new I.$zj("breakpointInputFocused",!1,{type:"boolean",description:R.localize(14,null)}),e.$9H=new I.$zj("callStackItemType",void 0,{type:"string",description:R.localize(15,null)}),e.$0H=new I.$zj("callStackSessionIsAttach",!1,{type:"boolean",description:R.localize(16,null)}),e.$$H=new I.$zj("callStackItemStopped",!1,{type:"boolean",description:R.localize(17,null)}),e.$_H=new I.$zj("callStackSessionHasOneThread",!1,{type:"boolean",description:R.localize(18,null)}),e.$aI=new I.$zj("watchItemType",void 0,{type:"string",description:R.localize(19,null)}),e.$bI=new I.$zj("canViewMemory",void 0,{type:"boolean",description:R.localize(20,null)}),e.$cI=new I.$zj("breakpointItemType",void 0,{type:"string",description:R.localize(21,null)}),e.$dI=new I.$zj("breakpointItemBytes",void 0,{type:"boolean",description:R.localize(22,null)}),e.$eI=new I.$zj("breakpointHasModes",!1,{type:"boolean",description:R.localize(23,null)}),e.$fI=new I.$zj("breakpointSupportsCondition",!1,{type:"boolean",description:R.localize(24,null)}),e.$gI=new I.$zj("loadedScriptsSupported",!1,{type:"boolean",description:R.localize(25,null)}),e.$hI=new I.$zj("loadedScriptsItemType",void 0,{type:"string",description:R.localize(26,null)}),e.$iI=new I.$zj("focusedSessionIsAttach",!1,{type:"boolean",description:R.localize(27,null)}),e.$jI=new I.$zj("focusedSessionIsNoDebug",!1,{type:"boolean",description:R.localize(28,null)}),e.$kI=new I.$zj("stepBackSupported",!1,{type:"boolean",description:R.localize(29,null)}),e.$lI=new I.$zj("restartFrameSupported",!1,{type:"boolean",description:R.localize(30,null)}),e.$mI=new I.$zj("stackFrameSupportsRestart",!1,{type:"boolean",description:R.localize(31,null)}),e.$nI=new I.$zj("jumpToCursorSupported",!1,{type:"boolean",description:R.localize(32,null)}),e.$oI=new I.$zj("stepIntoTargetsSupported",!1,{type:"boolean",description:R.localize(33,null)}),e.$pI=new I.$zj("breakpointsExist",!1,{type:"boolean",description:R.localize(34,null)}),e.$qI=new I.$zj("debuggersAvailable",!1,{type:"boolean",description:R.localize(35,null)}),e.$rI=new I.$zj("debugExtensionAvailable",!0,{type:"boolean",description:R.localize(36,null)}),e.$sI=new I.$zj("debugProtocolVariableMenuContext",void 0,{type:"string",description:R.localize(37,null)}),e.$tI=new I.$zj("debugSetVariableSupported",!1,{type:"boolean",description:R.localize(38,null)}),e.$uI=new I.$zj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:R.localize(39,null)}),e.$vI=new I.$zj("debugSetExpressionSupported",!1,{type:"boolean",description:R.localize(40,null)}),e.$wI=new I.$zj("breakWhenValueChangesSupported",!1,{type:"boolean",description:R.localize(41,null)}),e.$xI=new I.$zj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:R.localize(42,null)}),e.$yI=new I.$zj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:R.localize(43,null)}),e.$zI=new I.$zj("terminateDebuggeeSupported",!1,{type:"boolean",description:R.localize(44,null)}),e.$AI=new I.$zj("suspendDebuggeeSupported",!1,{type:"boolean",description:R.localize(45,null)}),e.$BI=new I.$zj("variableEvaluateNamePresent",!1,{type:"boolean",description:R.localize(46,null)}),e.$CI=new I.$zj("variableIsReadonly",!1,{type:"boolean",description:R.localize(47,null)}),e.$DI=new I.$zj("variableValue",!1,{type:"string",description:R.localize(48,null)}),e.$EI=new I.$zj("variableType",!1,{type:"string",description:R.localize(49,null)}),e.$FI=new I.$zj("variableInterfaces",!1,{type:"array",description:R.localize(50,null)}),e.$GI=new I.$zj("variableName",!1,{type:"string",description:R.localize(51,null)}),e.$HI=new I.$zj("variableLanguage",!1,{type:"string",description:R.localize(52,null)}),e.$II=new I.$zj("variableExtensionId",!1,{type:"string",description:R.localize(53,null)}),e.$JI=new I.$zj("exceptionWidgetVisible",!1,{type:"boolean",description:R.localize(54,null)}),e.$KI=new I.$zj("multiSessionRepl",!1,{type:"boolean",description:R.localize(55,null)}),e.$LI=new I.$zj("multiSessionDebug",!1,{type:"boolean",description:R.localize(56,null)}),e.$MI=new I.$zj("disassembleRequestSupported",!1,{type:"boolean",description:R.localize(57,null)}),e.$NI=new I.$zj("disassemblyViewFocus",!1,{type:"boolean",description:R.localize(58,null)}),e.$OI=new I.$zj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:R.localize(59,null)}),e.$PI=new I.$zj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:R.localize(60,null)});const O=i=>R.localize(61,null,i);e.$QI=O,e.$RI="editor.contrib.debug",e.$SI="editor.contrib.breakpoint",e.$TI="debug",e.$UI={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:R.localize(62,null)};var p;(function(i){i[i.Inactive=0]="Inactive",i[i.Initializing=1]="Initializing",i[i.Stopped=2]="Stopped",i[i.Running=3]="Running"})(p||(e.State=p={}));function $(i){switch(i){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}var w;(function(i){i[i.Valid=0]="Valid",i[i.Unreadable=1]="Unreadable",i[i.Error=2]="Error"})(w||(e.MemoryRangeType=w={})),e.$WI="vscode-debug-memory";var A;(function(i){i[i.Variable=0]="Variable",i[i.Address=1]="Address"})(A||(e.DataBreakpointSetType=A={}));var P;(function(i){i[i.Initial=1]="Initial",i[i.Dynamic=2]="Dynamic"})(P||(e.DebugConfigurationProviderTriggerKind=P={}));var b;(function(i){i.UnverifiedBreakpoints="unverifiedBreakpoints"})(b||(e.DebuggerString=b={})),e.$XI=(0,M.$ii)("debugService");var C;(function(i){i[i.CONDITION=0]="CONDITION",i[i.HIT_COUNT=1]="HIT_COUNT",i[i.LOG_MESSAGE=2]="LOG_MESSAGE",i[i.TRIGGER_POINT=3]="TRIGGER_POINT"})(C||(e.BreakpointWidgetContext=C={}));var y;(function(i){i[i.Command=0]="Command",i[i.Tree=1]="Tree"})(y||(e.DebugVisualizationType=y={}));var a;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(a||(e.DebugTreeItemCollapsibleState=a={}));var m;(function(i){i.deserialize=n=>n,i.serialize=n=>n})(m||(e.IDebugVisualizationTreeItem=m={}));var l;(function(i){i.deserialize=n=>({id:n.id,name:n.name,iconPath:n.iconPath&&{light:o.URI.revive(n.iconPath.light),dark:o.URI.revive(n.iconPath.dark)},iconClass:n.iconClass,visualization:n.visualization}),i.serialize=n=>n})(l||(e.IDebugVisualization=l={}))}),define(Ee[291],Ce([1,0,14,2,17,24,15,29,22,19]),function(re,e,o,R,I,M,O,p,$,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XG=void 0,e.$LG=P,e.$MG=b,e.$NG=C,e.$OG=y,e.$PG=a,e.$QG=m,e.$RG=l,e.$SG=n,e.$TG=t,e.$UG=g,e.$VG=h,e.$WG=u;const A=/{([^}]+)}/g;function P(E,v,D){return E.replace(A,function(k,S){return v&&S.length>0&&S[0]!=="_"?k:D&&D.hasOwnProperty(S)?D[S]:k})}function b(E){const v={};for(const D of Object.keys(E))D.startsWith("!")||(v[D]=E[D]);return v}function C(E){return E.configuration.request==="attach"&&!y(E)&&(!E.parentSession||C(E.parentSession))}function y(E){let v=E.configuration.type;if(v)return v==="vslsShare"&&(v=E.configuration.adapterProxy.configuration.type),(0,o.$lf)(v,"extensionhost")||(0,o.$lf)(v,"pwa-extensionhost")?E:E.parentSession?y(E.parentSession):void 0}function a(E){return E.type&&(E.label||E.program||E.runtime)}function m(E,v,D){let k,S=0;const F=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let W=null;for(;W=F.exec(E);){const B=W.index+1,T=B+W[0].length;if(B<=v&&T>=D){k=W[0],S=B;break}}if(k){const B=/\w+/g;let T=null;for(;(T=B.exec(k))&&!(T.index+1+S+T[0].length>=D););T&&(k=k.substring(0,B.lastIndex))}return k?{start:S,end:S+k.length-1}:{start:0,end:0}}async function l(E,v,D,k){if(E.evaluatableExpressionProvider.has(v)){const S=E.evaluatableExpressionProvider.ordered(v),F=(0,w.$Hb)(await Promise.all(S.map(async W=>{try{return await W.provideEvaluatableExpression(v,D,k??$.CancellationToken.None)}catch{return}})));if(F.length>0){let W=F[0].expression;const B=F[0].range;return W||(W=v.getLineContent(D.lineNumber).substring(B.startColumn-1,B.endColumn-1)),{range:B,matchingExpression:W}}}else{const S=v.getLineContent(D.lineNumber),{start:F,end:W}=m(S,D.column,D.column),B=S.substring(F-1,W);return{matchingExpression:B,range:new p.$dt(D.lineNumber,F,D.lineNumber,F+B.length)}}return null}const i=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function n(E){return!!(E&&E.match(i))}function r(E){if(typeof E.path=="string"&&!(typeof E.sourceReference=="number"&&E.sourceReference>0)){if(n(E.path))return R.URI.parse(E.path);if((0,I.$jc)(E.path))return R.URI.file(E.path)}return E.path}function s(E){if(typeof E.path=="object"){const v=R.URI.revive(E.path);if(v)return v.scheme===O.Schemas.file?v.fsPath:v.toString()}return E.path}function t(E,v){const D=v?r:s,k=(0,M.$Pn)(E);return d(k,(S,F)=>{S&&F&&(F.path=D(F))}),k}function g(E,v){const D=v?r:s,k=(0,M.$Pn)(E);return d(k,(S,F)=>{!S&&F&&(F.path=D(F))}),k}function d(E,v){switch(E.type){case"event":{const D=E;switch(D.event){case"output":v(!1,D.body.source);break;case"loadedSource":v(!1,D.body.source);break;case"breakpoint":v(!1,D.body.breakpoint.source);break;default:break}break}case"request":{const D=E;switch(D.command){case"setBreakpoints":v(!0,D.arguments.source);break;case"breakpointLocations":v(!0,D.arguments.source);break;case"source":v(!0,D.arguments.source);break;case"gotoTargets":v(!0,D.arguments.source);break;case"launchVSCode":D.arguments.args.forEach(k=>v(!1,k));break;default:break}break}case"response":{const D=E;if(D.success&&D.body)switch(D.command){case"stackTrace":D.body.stackFrames.forEach(k=>v(!1,k.source));break;case"loadedSources":D.body.sources.forEach(k=>v(!1,k));break;case"scopes":D.body.scopes.forEach(k=>v(!1,k.source));break;case"setFunctionBreakpoints":D.body.breakpoints.forEach(k=>v(!1,k.source));break;case"setBreakpoints":D.body.breakpoints.forEach(k=>v(!1,k.source));break;case"disassemble":D.body?.instructions.forEach(S=>v(!1,S.location));break;default:break}break}}}function h(E){return E.filter(v=>!v.presentation?.hidden).sort((v,D)=>v.presentation?D.presentation?v.presentation.group?D.presentation.group?v.presentation.group!==D.presentation.group?v.presentation.group.localeCompare(D.presentation.group):c(v.presentation.order,D.presentation.order):-1:D.presentation.group?1:c(v.presentation.order,D.presentation.order):-1:D.presentation?1:0)}function c(E,v){return typeof E!="number"?typeof v!="number"?0:1:typeof v!="number"?-1:E-v}async function u(E,v){const D=E.getValue("debug.saveBeforeStart",{overrideIdentifier:v.activeTextEditorLanguageId});if(D!=="none"&&(await v.saveAll(),D==="allEditorsInActiveGroup")){const k=v.activeEditorPane;k&&k.input.resource?.scheme===O.Schemas.untitled&&await v.save({editor:k.input,groupId:k.group.id})}await E.reloadConfiguration()}const f=(E,v)=>!E||!v?E===v:E.name===v.name&&E.path===v.path&&E.sourceReference===v.sourceReference;e.$XG=f}),define(Ee[292],Ce([1,0,51,63,24,17,11,14,31,237,144]),function(re,e,o,R,I,M,O,p,$,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vlc=e.$Ulc=e.$Tlc=e.$Slc=e.$Rlc=void 0;class P extends A.$job{constructor(){super(),this.p=Buffer.allocUnsafe(0),this.r=-1}t(l,i){this.l=i,this.p=Buffer.allocUnsafe(0),this.r=-1,l.on("data",n=>this.v(n))}sendMessage(l){if(this.l){const i=JSON.stringify(l);this.l.write(`Content-Length: ${Buffer.byteLength(i,"utf8")}${P.a}${i}`,"utf8")}}v(l){for(this.p=Buffer.concat([this.p,l]);;){if(this.r>=0){if(this.p.length>=this.r){const i=this.p.toString("utf8",0,this.r);if(this.p=this.p.slice(this.r),this.r=-1,i.length>0)try{this.acceptMessage(JSON.parse(i))}catch(n){this.n.fire(new Error((n.message||n)+`
`+i))}continue}}else{const i=this.p.indexOf(P.a);if(i!==-1){const r=this.p.toString("utf8",0,i).split(P.b);for(const s of r){const t=s.split(P.i);t[0]==="Content-Length"&&(this.r=Number(t[1]))}this.p=this.p.slice(i+P.a.length);continue}}break}}}e.$Rlc=P,P.a=`\r
\r
`,P.b=/\r?\n/,P.i=/: */;class b extends P{startSession(){return new Promise((l,i)=>{let n=!1;this.x=this.y(()=>{this.t(this.x,this.x),l(),n=!0}),this.x.on("close",()=>{n?this.n.fire(new Error("connection closed")):i(new Error("connection closed"))}),this.x.on("error",r=>{n?this.n.fire(r):i(r)})})}async stopSession(){await this.w(),this.x&&(this.x.end(),this.x=void 0)}}e.$Slc=b;class C extends b{constructor(l){super(),this.z=l}y(l){return R.createConnection(this.z.port,this.z.host||"127.0.0.1",l)}}e.$Tlc=C;class y extends b{constructor(l){super(),this.z=l}y(l){return R.createConnection(this.z.path,l)}}e.$Ulc=y;class a extends P{constructor(l,i){super(),this.y=l,this.z=i}async startSession(){const l=this.y.command,i=this.y.args,n=this.y.options||{};try{if(l)if(M.$jc(l)){if(!await $.Promises.exists(l))throw new Error(w.localize(0,null,l))}else l.indexOf("/")<0&&l.indexOf("\\")<0;else throw new Error(w.localize(1,null,this.z));let r=process.env;if(n.env&&Object.keys(n.env).length>0&&(r=I.$Sn(I.$Pn(process.env),n.env)),l==="node")if(Array.isArray(i)&&i.length>0){const s=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:r,execArgv:s?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};n.cwd&&(t.cwd=n.cwd);const g=o.fork(i[0],i.slice(1),t);if(!g.pid)throw new Error(w.localize(2,null,i[0]));this.x=g}else throw new Error(w.localize(3,null));else{const s={env:r};n.cwd&&(s.cwd=n.cwd),this.x=o.spawn(l,i,s)}this.x.on("error",s=>{this.n.fire(s)}),this.x.on("exit",(s,t)=>{this.o.fire(s)}),this.x.stdout.on("close",()=>{this.n.fire(new Error("read error"))}),this.x.stdout.on("error",s=>{this.n.fire(s)}),this.x.stdin.on("error",s=>{this.n.fire(s)}),this.x.stderr.resume(),this.t(this.x.stdout,this.x.stdin)}catch(r){this.n.fire(r)}}async stopSession(){return this.x?(await this.w(),O.$c?new Promise((l,i)=>{const n=o.exec(`taskkill /F /T /PID ${this.x.pid}`,function(r,s,t){if(r)return i(r)});n.on("exit",l),n.on("error",i)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(l,i){if(!l)return;const n=Object.create(null);l.runtime&&(l.runtime.indexOf("./")===0?n.runtime=M.$kc(i,l.runtime):n.runtime=l.runtime),l.runtimeArgs&&(n.runtimeArgs=l.runtimeArgs),l.program&&(M.$jc(l.program)?n.program=l.program:n.program=M.$kc(i,l.program)),l.args&&(n.args=l.args);const r=l;return r.win&&(n.win=a.A(r.win,i)),r.winx86&&(n.winx86=a.A(r.winx86,i)),r.windows&&(n.windows=a.A(r.windows,i)),r.osx&&(n.osx=a.A(r.osx,i)),r.linux&&(n.linux=a.A(r.linux,i)),n}static platformAdapterExecutable(l,i){let n=Object.create(null);i=i.toLowerCase();for(const h of l)if(h.contributes){const c=h.contributes.debuggers;c&&c.length>0&&c.filter(u=>typeof u.type=="string"&&p.$lf(u.type,i)).forEach(u=>{const f=a.A(u,h.extensionLocation.fsPath);n=I.$Sn(n,f,h.isBuiltin)})}let r;O.$c&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?r=n.winx86||n.win||n.windows:O.$c?r=n.win||n.windows:O.$d?r=n.osx:O.$e&&(r=n.linux),r=r||n;const s=r.program||n.program,t=r.args||n.args,g=r.runtime||n.runtime,d=r.runtimeArgs||n.runtimeArgs;if(g)return{type:"executable",command:g,args:(d||[]).concat(typeof s=="string"?[s]:[]).concat(t||[])};if(s)return{type:"executable",command:s,args:t||[]}}}e.$Vlc=a}),define(Ee[293],Ce([1,0,51,34,11]),function(re,e,o,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wlc=O,e.$Xlc=$;function M(w,A){return new Promise((P,b)=>{let C="";const y=o.spawn(w,A);y.pid&&y.stdout.on("data",a=>{C+=a.toString()}),y.on("error",a=>{b(a)}),y.on("close",a=>{P(C)})})}async function O(w){if(w)if(I.$c){const A=await new Promise((P,b)=>{re(["@vscode/windows-process-tree"],P,b)});return new Promise(P=>{A.getProcessTree(w,b=>{P(!!b&&b.children.length>0)})})}else return M("/usr/bin/pgrep",["-lP",String(w)]).then(A=>{const P=A.trim();return!(P.length===0||P.indexOf(" tmux")>=0)},A=>!0);return Promise.resolve(!0)}var p;(function(w){w[w.cmd=0]="cmd",w[w.powershell=1]="powershell",w[w.bash=2]="bash"})(p||(p={}));function $(w,A,P,b){w=w.trim().toLowerCase();let C;w.indexOf("powershell")>=0||w.indexOf("pwsh")>=0?C=1:w.indexOf("cmd.exe")>=0?C=0:w.indexOf("bash")>=0?C=2:I.$c?C=0:C=2;let y,a=" ";switch(C){case 1:if(y=m=>(m=m.replace(/\'/g,"''"),m.length>0&&m.charAt(m.length-1)==="\\"?`'${m}\\'`:`'${m}'`),b){const m=(0,R.$ng)(b);m&&(a+=`${m}:; `),a+=`cd ${y(b)}; `}if(A.length>0){const m=A.shift(),l=P?m:y(m);a+=l[0]==="'"?`& ${l} `:`${l} `;for(const i of A)a+=i==="<"||i===">"||P?i:y(i),a+=" "}break;case 0:if(y=m=>(m=m.replace(/\"/g,'""'),m=m.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(l=>m.includes(l))||m.length===0?`"${m}"`:m),b){const m=(0,R.$ng)(b);m&&(a+=`${m}: && `),a+=`cd ${y(b)} && `}for(const m of A)a+=m==="<"||m===">"||P?m:y(m),a+=" ";break;case 2:{y=m=>(m=m.replace(/(["'\\\$!><#()\[\]*&^| ;{}?`])/g,"\\$1"),m.length===0?'""':m),b&&(a+=`cd ${y(b)} ; `);for(const m of A)a+=m==="<"||m===">"||P?m:y(m),a+=" ";break}}return a}}),define(Ee[294],Ce([1,0,5]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$J=e.CellExecutionUpdateType=void 0;var R;(function(I){I[I.Output=1]="Output",I[I.OutputItems=2]="OutputItems",I[I.ExecutionState=3]="ExecutionState"})(R||(e.CellExecutionUpdateType=R={})),e.$$J=(0,o.$ii)("INotebookExecutionService")}),define(Ee[295],Ce([1,0,5]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xhb=e.$Whb=e.ProxyKernelState=e.$Vhb=void 0,e.$Vhb=100;var R;(function(I){I[I.Disconnected=1]="Disconnected",I[I.Connected=2]="Connected",I[I.Initializing=3]="Initializing"})(R||(e.ProxyKernelState=R={})),e.$Whb=(0,o.$ii)("INotebookKernelService"),e.$Xhb=(0,o.$ii)("INotebookKernelHistoryService")}),define(Ee[296],Ce([1,0,3,29,193,105]),function(re,e,o,R,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6Ub=void 0;class O extends o.$Uc{constructor($,w,A){super(),this._source=$,this.b=w,this.c=A,this.a=void 0}f($){const w=$.getLineCount();return new R.$dt(1,1,w,this.g($,w))}g($,w){if(w<1||w>$.getLineCount())throw new Error("Illegal value for lineNumber");return $.getLineLength(w)+1}get inputTextBuffer(){if(!this.b){const $=new I.$FC;$.acceptChunk(this._source);const w=$.finish(!0),{textBuffer:A,disposable:P}=w.create(1);this.b=A,this.B(P)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map($=>{const w=new I.$FC;w.acceptChunk($);const A=w.finish(!0),{textBuffer:P,disposable:b}=A.create(1);return this.B(b),P})),this.a}findInInputs($){const A=new M.$tC($,!1,!1,null).parseSearchRequest();if(!A)return[];const P=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(P,A,!0,5e3)}findInOutputs($){const A=new M.$tC($,!1,!1,null).parseSearchRequest();return A?this.outputTextBuffers.map(P=>{const b=P.findMatchesLineByLine(this.f(P),A,!0,5e3);if(b.length!==0)return{textBuffer:P,matches:b}}).filter(P=>!!P):[]}}e.$6Ub=O}),define(Ee[67],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eL=e.TestPosition=e.TestIdPathParts=void 0;var o;(function(M){M.Delimiter="\0"})(o||(e.TestIdPathParts=o={}));var R;(function(M){M[M.IsSame=0]="IsSame",M[M.Disconnected=1]="Disconnected",M[M.IsChild=2]="IsChild",M[M.IsParent=3]="IsParent"})(R||(e.TestPosition=R={}));class I{static fromExtHostTestItem(O,p,$=O.parent){if(O._isRoot)return new I([p]);const w=[O.id];for(let A=$;A&&A.id!==p;A=A.parent)w.push(A.id);return w.push(p),new I(w.reverse())}static isRoot(O){return!O.includes("\0")}static root(O){const p=O.indexOf("\0");return p===-1?O:O.slice(0,p)}static fromString(O){return new I(O.split("\0"))}static join(O,p){return new I([...O.path,p])}static joinToString(O,p){return O.toString()+"\0"+p}static parentId(O){const p=O.lastIndexOf("\0");return p===-1?void 0:O.slice(0,p)}static localId(O){const p=O.lastIndexOf("\0");return p===-1?O:O.slice(p+1)}static isChild(O,p){return p.startsWith(O)&&p[O.length]==="\0"}static compare(O,p){return O===p?0:I.isChild(O,p)?2:I.isChild(p,O)?3:1}constructor(O,p=O.length){if(this.path=O,this.d=p,O.length===0||p<1)throw new Error("cannot create test with empty path")}get rootId(){return new I(this.path,1)}get parentId(){return this.d>1?new I(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let O=1;O<=this.d;O++)yield new I(this.path,O)}*idsToRoot(){for(let O=this.d;O>0;O--)yield new I(this.path,O)}compare(O){if(typeof O=="string")return I.compare(this.toString(),O);for(let p=0;p<O.d&&p<this.d;p++)if(O.path[p]!==this.path[p])return 1;return O.d>this.d?2:O.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let O=1;O<this.d;O++)this.c+="\0",this.c+=this.path[O]}return this.c}}e.$eL=I}),define(Ee[89],Ce([1,0,2,52,29,67]),function(re,e,o,R,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nL=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$mL=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$lL=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$kL=e.$jL=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$iL=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$hL=e.$gL=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$fL=e.TestResultState=void 0;var O;(function(N){N[N.Unset=0]="Unset",N[N.Queued=1]="Queued",N[N.Running=2]="Running",N[N.Passed=3]="Passed",N[N.Failed=4]="Failed",N[N.Skipped=5]="Skipped",N[N.Errored=6]="Errored"})(O||(e.TestResultState=O={})),e.$fL={0:"unset",1:"queued",2:"running",3:"passed",4:"failed",5:"skipped",6:"errored"};var p;(function(N){N[N.Run=1]="Run",N[N.Debug=2]="Debug",N[N.Coverage=3]="Coverage"})(p||(e.ExtTestRunProfileKind=p={}));var $;(function(N){N[N.Run=2]="Run",N[N.Debug=4]="Debug",N[N.Coverage=8]="Coverage",N[N.HasNonDefaultProfile=16]="HasNonDefaultProfile",N[N.HasConfigurable=32]="HasConfigurable",N[N.SupportsContinuousRun=64]="SupportsContinuousRun"})($||(e.TestRunProfileBitset=$={})),e.$gL=[2,4,8,16,32,64];const w=N=>"runId"in N;e.$hL=w;var A;(function(N){N.serialize=j=>({range:j.range.toJSON(),uri:j.uri.toJSON()}),N.deserialize=(j,L)=>({range:I.$dt.lift(L.range),uri:j.asCanonicalUri(o.URI.revive(L.uri))})})(A||(e.IRichLocation=A={}));var P;(function(N){N[N.Error=0]="Error",N[N.Output=1]="Output"})(P||(e.TestMessageType=P={}));var b;(function(N){N.serialize=j=>({message:j.message,type:0,expected:j.expected,actual:j.actual,contextValue:j.contextValue,location:j.location&&A.serialize(j.location)}),N.deserialize=(j,L)=>({message:L.message,type:0,expected:L.expected,actual:L.actual,contextValue:L.contextValue,location:L.location&&A.deserialize(j,L.location)})})(b||(e.ITestErrorMessage=b={}));const C=(N,j)=>`${j?"s":"e"}${N}`;e.$iL=C;var y;(function(N){N.serialize=j=>({message:j.message,type:1,offset:j.offset,length:j.length,location:j.location&&A.serialize(j.location)}),N.deserialize=(j,L)=>({message:L.message,type:1,offset:L.offset,length:L.length,location:L.location&&A.deserialize(j,L.location)})})(y||(e.ITestOutputMessage=y={}));var a;(function(N){N.serialize=j=>j.type===0?b.serialize(j):y.serialize(j),N.deserialize=(j,L)=>L.type===0?b.deserialize(j,L):y.deserialize(j,L)})(a||(e.ITestMessage=a={}));var m;(function(N){N.serializeWithoutMessages=j=>({state:j.state,duration:j.duration,messages:[]}),N.serialize=j=>({state:j.state,duration:j.duration,messages:j.messages.map(a.serialize)}),N.deserialize=(j,L)=>({state:L.state,duration:L.duration,messages:L.messages.map(z=>a.deserialize(j,z))})})(m||(e.ITestTaskState=m={}));const l="\0",i=(N,j)=>N+l+j;e.$jL=i;const n=N=>{const j=N.indexOf(l);return{ctrlId:N.slice(0,j),tagId:N.slice(j+1)}};e.$kL=n;var r;(function(N){N.serialize=j=>({extId:j.extId,label:j.label,tags:j.tags,busy:j.busy,children:void 0,uri:j.uri?.toJSON(),range:j.range?.toJSON()||null,description:j.description,error:j.error,sortText:j.sortText}),N.deserialize=(j,L)=>({extId:L.extId,label:L.label,tags:L.tags,busy:L.busy,children:void 0,uri:L.uri?j.asCanonicalUri(o.URI.revive(L.uri)):void 0,range:L.range?I.$dt.lift(L.range):null,description:L.description,error:L.error,sortText:L.sortText})})(r||(e.ITestItem=r={}));var s;(function(N){N[N.NotExpandable=0]="NotExpandable",N[N.Expandable=1]="Expandable",N[N.BusyExpanding=2]="BusyExpanding",N[N.Expanded=3]="Expanded"})(s||(e.TestItemExpandState=s={}));var t;(function(N){N.serialize=j=>({expand:j.expand,item:r.serialize(j.item)}),N.deserialize=(j,L)=>({controllerId:M.$eL.root(L.item.extId),expand:L.expand,item:r.deserialize(j,L.item)})})(t||(e.InternalTestItem=t={}));var g;(function(N){N.serialize=j=>{let L;return j.item&&(L={},j.item.label!==void 0&&(L.label=j.item.label),j.item.tags!==void 0&&(L.tags=j.item.tags),j.item.busy!==void 0&&(L.busy=j.item.busy),j.item.uri!==void 0&&(L.uri=j.item.uri?.toJSON()),j.item.range!==void 0&&(L.range=j.item.range?.toJSON()),j.item.description!==void 0&&(L.description=j.item.description),j.item.error!==void 0&&(L.error=j.item.error),j.item.sortText!==void 0&&(L.sortText=j.item.sortText)),{extId:j.extId,expand:j.expand,item:L}},N.deserialize=j=>{let L;return j.item&&(L={},j.item.label!==void 0&&(L.label=j.item.label),j.item.tags!==void 0&&(L.tags=j.item.tags),j.item.busy!==void 0&&(L.busy=j.item.busy),j.item.range!==void 0&&(L.range=j.item.range?I.$dt.lift(j.item.range):null),j.item.description!==void 0&&(L.description=j.item.description),j.item.error!==void 0&&(L.error=j.item.error),j.item.sortText!==void 0&&(L.sortText=j.item.sortText)),{extId:j.extId,expand:j.expand,item:L}}})(g||(e.ITestItemUpdate=g={}));const d=(N,j)=>{j.expand!==void 0&&(N.expand=j.expand),j.item!==void 0&&(N.item=N.item?Object.assign(N.item,j.item):j.item)};e.$lL=d;var h;(function(N){N.serializeWithoutMessages=j=>({...t.serialize(j),ownComputedState:j.ownComputedState,computedState:j.computedState,tasks:j.tasks.map(m.serializeWithoutMessages)}),N.serialize=j=>({...t.serialize(j),ownComputedState:j.ownComputedState,computedState:j.computedState,tasks:j.tasks.map(m.serialize)}),N.deserialize=(j,L)=>({...t.deserialize(j,L),ownComputedState:L.ownComputedState,computedState:L.computedState,tasks:L.tasks.map(z=>m.deserialize(j,z)),retired:!0})})(h||(e.TestResultItem=h={}));var c;(function(N){N.empty=()=>({covered:0,total:0}),N.sum=(j,L)=>{j.covered+=L.covered,j.total+=L.total}})(c||(e.ICoverageCount=c={}));var u;(function(N){N.serialize=j=>({id:j.id,statement:j.statement,branch:j.branch,declaration:j.declaration,uri:j.uri.toJSON()}),N.deserialize=(j,L)=>({id:L.id,statement:L.statement,branch:L.branch,declaration:L.declaration,uri:j.asCanonicalUri(o.URI.revive(L.uri))})})(u||(e.IFileCoverage=u={}));function f(N){return{...N,location:N.location?.toJSON()}}function E(N){return N.location=N.location?R.$ct.isIPosition(N.location)?R.$ct.lift(N.location):I.$dt.lift(N.location):void 0,N}e.$mL=3;var v;(function(N){N[N.Declaration=0]="Declaration",N[N.Statement=1]="Statement",N[N.Branch=2]="Branch"})(v||(e.DetailType=v={}));var D;(function(N){N.serialize=j=>j.type===0?S.serialize(j):F.serialize(j),N.deserialize=j=>j.type===0?S.deserialize(j):F.deserialize(j)})(D||(e.CoverageDetails=D={}));var k;(function(N){N.serialize=f,N.deserialize=E})(k||(e.IBranchCoverage=k={}));var S;(function(N){N.serialize=f,N.deserialize=E})(S||(e.IDeclarationCoverage=S={}));var F;(function(N){N.serialize=j=>({...f(j),branches:j.branches?.map(k.serialize)}),N.deserialize=j=>({...E(j),branches:j.branches?.map(k.deserialize)})})(F||(e.IStatementCoverage=F={}));var W;(function(N){N[N.Add=0]="Add",N[N.Update=1]="Update",N[N.DocumentSynced=2]="DocumentSynced",N[N.Remove=3]="Remove",N[N.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",N[N.Retire=5]="Retire",N[N.AddTag=6]="AddTag",N[N.RemoveTag=7]="RemoveTag"})(W||(e.TestDiffOpType=W={}));var B;(function(N){N.deserialize=(j,L)=>L.op===0?{op:L.op,item:t.deserialize(j,L.item)}:L.op===1?{op:L.op,item:g.deserialize(L.item)}:L.op===2?{op:L.op,uri:j.asCanonicalUri(o.URI.revive(L.uri)),docv:L.docv}:L,N.serialize=j=>j.op===0?{op:j.op,item:t.serialize(j.item)}:j.op===1?{op:j.op,item:g.serialize(j.item)}:j})(B||(e.TestsDiffOp=B={}));class T{constructor(j){this.l=j,this.f=new Map,this.g=new Map,this.h=new Set,this.j=0,this.k=0,this.tags=this.f}apply(j){const L=this.w();for(const z of j)switch(z.op){case 0:this.o(t.deserialize(this.l,z.item),L);break;case 1:this.p(g.deserialize(z.item),L);break;case 3:this.q(z.itemId,L);break;case 5:this.v(z.itemId);break;case 4:this.updatePendingRoots(z.amount);break;case 6:this.f.set(z.tag.id,z.tag);break;case 7:this.f.delete(z.id);break}L.complete?.()}o(j,L){const z=M.$eL.parentId(j.item.extId)?.toString();let Q;if(!z)Q=this.x(j),this.h.add(Q),this.g.set(j.item.extId,Q);else if(this.g.has(z)){const Y=this.g.get(z);Y.children.add(j.item.extId),Q=this.x(j,Y),this.g.set(j.item.extId,Q)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(j)}`);return}return L.add?.(Q),j.expand===2&&this.j++,Q}p(j,L){const z=this.g.get(j.extId);if(z)return j.expand!==void 0&&(z.expand===2&&this.j--,j.expand===2&&this.j++),(0,e.$lL)(z,j),L.update?.(z),z}q(j,L){const z=this.g.get(j);if(!z)return;const Q=M.$eL.parentId(z.item.extId)?.toString();Q?this.g.get(Q).children.delete(z.item.extId):this.h.delete(z);const Y=[[j]];for(;Y.length;)for(const J of Y.pop()){const x=this.g.get(J);x&&(Y.push(x.children),this.g.delete(J),L.remove?.(x,x!==z),x.expand===2&&this.j--)}}v(j){}updatePendingRoots(j){this.k+=j}w(){return{}}}e.$nL=T}),define(Ee[113],Ce([1,0,8,4,3,61,89,67]),function(re,e,o,R,I,M,O,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IO=e.$HO=e.$GO=e.$FO=e.$EO=e.TestItemEventOp=void 0;var $;(function(i){i[i.Upsert=0]="Upsert",i[i.SetTags=1]="SetTags",i[i.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",i[i.RemoveChild=3]="RemoveChild",i[i.SetProp=4]="SetProp",i[i.Bulk=5]="Bulk",i[i.DocumentSynced=6]="DocumentSynced"})($||(e.TestItemEventOp=$={}));const w=(i,n)=>i===n,P=Object.entries({range:(i,n)=>i===n?!0:!i||!n?!1:i.equalsRange(n),busy:w,label:w,description:w,error:w,sortText:w,tags:(i,n)=>!(i.length!==n.length||i.some(r=>!n.includes(r)))}),b=(i,n)=>{let r;for(const[s,t]of P)t(i[s],n[s])||(r?r[s]=n[s]:r={[s]:n[s]});return r};class C extends I.$Uc{get root(){return this.s.root}constructor(n){super(),this.s=n,this.f=this.B(new o.$uh(()=>this.flushDiff(),200)),this.g=this.B(new R.$7d),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(n){this.h=n;for(const r of this.tree.values())this.J(r)}get resolveHandler(){return this.h}collectDiff(){const n=this.m;return this.m=[],n}pushDiff(n){switch(n.op){case 2:{for(const r of this.m)if(r.op===2&&r.uri===n.uri){r.docv=n.docv;return}break}case 1:{const r=this.m[this.m.length-1];if(r){if(r.op===1&&r.item.extId===n.item.extId){(0,O.$lL)(r.item,n.item);return}if(r.op===0&&r.item.item.extId===n.item.extId){(0,O.$lL)(r.item,n.item);return}}break}}this.m.push(n),this.f.isScheduled()||this.f.schedule()}expand(n,r){const s=this.tree.get(n);if(s){if((s.expandLevels===void 0||r>s.expandLevels)&&(s.expandLevels=r),s.expand===1){const t=this.M(s);return t.isOpen()?this.L(s,r-1):t.wait().then(()=>this.L(s,r-1))}else if(s.expand===3)return s.resolveBarrier?.isOpen()===!1?s.resolveBarrier.wait().then(()=>this.L(s,r-1)):this.L(s,r-1)}}dispose(){for(const n of this.tree.values())this.s.getApiFor(n.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(n,r){switch(r.op){case 3:this.O(p.$eL.joinToString(n.fullId,r.id));break;case 0:this.z(r.item,n);break;case 5:for(const s of r.ops)this.w(n,s);break;case 1:this.C(r.new,r.old,n.fullId.toString());break;case 2:this.J(n);break;case 4:this.pushDiff({op:1,item:{extId:n.fullId.toString(),item:r.update}});break;case 6:this.y(n.actual.uri);break;default:(0,M.$0c)(r)}}y(n){n&&this.pushDiff({op:2,uri:n,docv:this.s.getDocumentVersion(n)})}z(n,r){const s=p.$eL.fromExtHostTestItem(n,this.root.id,r?.actual),t=this.s.getApiFor(n);t.parent&&t.parent!==r?.actual&&this.s.getChildren(t.parent).delete(n.id);let g=this.tree.get(s.toString());if(!g){g={fullId:s,actual:n,expandLevels:r?.expandLevels?r.expandLevels-1:void 0,expand:0},n.tags.forEach(this.D,this),this.tree.set(g.fullId.toString(),g),this.G(n,r),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:g.expand,item:this.s.toITestItem(n)}}),this.I(n,g,r);return}if(g.actual===n){this.H(n,g,r);return}if(g.actual.uri?.toString()!==n.uri?.toString())return this.O(s.toString()),this.z(n,r);const d=this.s.getChildren(g.actual),h=g.actual,c=b(this.s.toITestItem(h),this.s.toITestItem(n));this.s.getApiFor(h).listener=void 0,g.actual=n,g.expand=0,c&&(c.hasOwnProperty("tags")&&(this.C(n.tags,h.tags,s.toString()),delete c.tags),this.w(g,{op:4,update:c})),this.I(n,g,r);for(const[u,f]of d)this.s.getChildren(n).get(f.id)||this.O(p.$eL.joinToString(s,f.id));this.y(g.actual.uri)}C(n,r,s){const t=new Set(r.map(g=>g.id));for(const g of n)t.delete(g.id)||this.D(g);this.pushDiff({op:1,item:{extId:s,item:{tags:n.map(g=>(0,O.$jL)(this.s.controllerId,g.id))}}}),t.forEach(this.F,this)}D(n){const r=this.j.get(n.id);r?r.refCount++:(this.j.set(n.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,O.$jL)(this.s.controllerId,n.id)}}))}F(n){const r=this.j.get(n);r&&!--r.refCount&&(this.j.delete(n),this.pushDiff({op:7,id:(0,O.$jL)(this.s.controllerId,n)}))}G(n,r){this.s.getApiFor(n).parent=r&&r.actual!==this.root?r.actual:void 0}H(n,r,s){this.G(n,s);const t=this.s.getApiFor(n);t.parent=s?.actual,t.listener=g=>this.w(r,g),this.J(r)}I(n,r,s){this.H(n,r,s);for(const[t,g]of this.s.getChildren(n))this.z(g,r)}J(n){let r;this.h?n.resolveBarrier?r=n.resolveBarrier.isOpen()?3:2:r=n.actual.canResolveChildren?1:0:r=0,r!==n.expand&&(n.expand=r,this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:r}}),r===1&&n.expandLevels!==void 0&&this.M(n))}L(n,r){if(r<0)return;const s=[];for(const[t,g]of this.s.getChildren(n.actual)){const d=this.expand(p.$eL.joinToString(n.fullId,g.id),r);(0,o.$7g)(d)&&s.push(d)}if(s.length)return Promise.all(s).then(()=>{})}M(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this.h){const g=new o.$hh;return g.open(),g}n.expand=2,this.N(n);const r=n.resolveBarrier=new o.$hh,s=g=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,g)};let t;try{t=this.h(n.actual===this.root?void 0:n.actual)}catch(g){s(g)}return(0,o.$7g)(t)?t.catch(s).then(()=>{r.open(),this.J(n)}):(r.open(),this.J(n)),n.resolveBarrier}N(n){this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:n.expand}})}O(n){const r=this.tree.get(n);if(!r)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:n});const s=[r];for(;s.length;){const t=s.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const g of t.actual.tags)this.F(g.id);this.tree.delete(t.fullId.toString());for(const[g,d]of this.s.getChildren(t.actual))s.push(this.tree.get(p.$eL.joinToString(t.fullId,d.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.g.fire(n)}}e.$EO=C;class y extends Error{constructor(n){super(`Attempted to insert a duplicate test item ID ${n}`)}}e.$FO=y;class a extends Error{constructor(n){super(`TestItem with ID "${n}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$GO=a;class m extends Error{constructor(n,r,s){super(`TestItem with ID "${n}" is from controller "${r}" and cannot be added as a child of an item from controller "${s}".`)}}e.$HO=m;const l=(i,n,r)=>{let s=new Map;return{get size(){return s.size},forEach(t,g){for(const d of s.values())t.call(g,d,this)},[Symbol.iterator](){return s.entries()},replace(t){const g=new Map,d=new Set(s.keys()),h={op:5,ops:[]};for(const c of t){if(!(c instanceof r))throw new a(c.id);const u=n(c).controllerId;if(u!==i.controllerId)throw new m(c.id,u,i.controllerId);if(g.has(c.id))throw new y(c.id);g.set(c.id,c),d.delete(c.id),h.ops.push({op:0,item:c})}for(const c of d.keys())h.ops.push({op:3,id:c});i.listener?.(h),s=g},add(t){if(!(t instanceof r))throw new a(t.id);s.set(t.id,t),i.listener?.({op:0,item:t})},delete(t){s.delete(t)&&i.listener?.({op:3,id:t})},get(t){return s.get(t)},toJSON(){return Array.from(s.values())}}};e.$IO=l}),define(Ee[145],Ce([1,0,113]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KO=e.$JO=void 0;const R=new WeakMap,I=(O,p)=>{const $={controllerId:p};return R.set(O,$),$};e.$JO=I;const M=O=>{const p=R.get(O);if(!p)throw new o.$GO(O?.id||"<unknown>");return p};e.$KO=M}),define(Ee[114],Ce([1,0,15,2]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zzb=e.$yzb=e.$xzb=void 0,e.$Azb=I,e.$Bzb=O,e.$xzb="vscode-cdn.net",e.$yzb=`vscode-resource.${e.$xzb}`,e.$zzb=`'self' https://*.${e.$xzb}`;function I(p,$){return p.scheme===o.Schemas.http||p.scheme===o.Schemas.https?p:($&&$.authority&&$.isRemote&&p.scheme===o.Schemas.file&&(p=R.URI.from({scheme:o.Schemas.vscodeRemote,authority:$.authority,path:p.path})),R.URI.from({scheme:o.Schemas.https,authority:`${p.scheme}+${M(p.authority)}.${e.$yzb}`,path:p.path,fragment:p.fragment,query:p.query}))}function M(p){return p.replace(/./g,$=>{const w=$.charCodeAt(0);return w>=97&&w<=122||w>=65&&w<=90||w>=48&&w<=57?$:"-"+w.toString(16).padStart(4,"0")})}function O(p){return p.replace(/-([0-9a-f]{4})/g,($,w)=>String.fromCharCode(parseInt(w,16)))}}),define(Ee[297],Ce([1,0,4,3,114]),function(re,e,o,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tjc=void 0;class M{constructor(p,$,w){this.d=p,this.e=$,this.f=w,this.a=0,this.b=new R.$Tc,this.c=new Map,this.b.add($.onDidChangeVisibleTextEditors(()=>{const A=$.getVisibleTextEditors();for(const P of this.c.values())A.indexOf(P.editor)<0&&P.inset.dispose()}))}dispose(){this.c.forEach(p=>p.inset.dispose()),this.b.dispose()}createWebviewEditorInset(p,$,w,A,P){let b;for(const n of this.e.getVisibleTextEditors(!0))if(n.value===p){b=n;break}if(!b)throw new Error("not a visible editor");const C=this,y=this.a++,a=new o.$7d,m=new o.$7d,l=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(n){return(0,I.$Azb)(n,C.f)}get cspSource(){return I.$zzb}set options(n){this.b=n,C.d.$setOptions(y,n)}get options(){return this.b}set html(n){this.a=n,C.d.$setHtml(y,n)}get html(){return this.a}get onDidReceiveMessage(){return a.event}postMessage(n){return C.d.$postMessage(y,n)}},i=new class{constructor(){this.editor=p,this.line=$,this.height=w,this.webview=l,this.onDidDispose=m.event}dispose(){C.c.has(y)&&(C.c.delete(y),C.d.$disposeEditorInset(y),m.fire(),m.dispose(),a.dispose())}};return this.d.$createEditorInset(y,b.id,b.value.document.uri,$+1,w,A||{},P.identifier,P.extensionLocation),this.c.set(y,{editor:p,inset:i,onDidReceiveMessage:a}),i}$onDidDispose(p){const $=this.c.get(p);$&&$.inset.dispose()}$onDidReceiveMessage(p,$){this.c.get(p)?.onDidReceiveMessage.fire($)}}e.$Tjc=M}),define(Ee[146],Ce([1,0,5]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wL=e.$vL=e.$uL=void 0,e.$uL="__",e.$vL=(0,o.$ii)("IAuthenticationService"),e.$wL=(0,o.$ii)("IAuthenticationExtensionsService")}),define(Ee[298],Ce([1,0,5]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BP=e.VariableKind=e.$AP=void 0,e.$AP=(0,o.$ii)("configurationResolverService");var R;(function(M){M.Unknown="unknown",M.Env="env",M.Config="config",M.Command="command",M.Input="input",M.ExtensionInstallFolder="extensionInstallFolder",M.WorkspaceFolder="workspaceFolder",M.Cwd="cwd",M.WorkspaceFolderBasename="workspaceFolderBasename",M.UserHome="userHome",M.LineNumber="lineNumber",M.SelectedText="selectedText",M.File="file",M.FileWorkspaceFolder="fileWorkspaceFolder",M.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",M.RelativeFile="relativeFile",M.RelativeFileDirname="relativeFileDirname",M.FileDirname="fileDirname",M.FileExtname="fileExtname",M.FileBasename="fileBasename",M.FileBasenameNoExtension="fileBasenameNoExtension",M.FileDirnameBasename="fileDirnameBasename",M.ExecPath="execPath",M.ExecInstallFolder="execInstallFolder",M.PathSeparator="pathSeparator",M.PathSeparatorAlias="/"})(R||(e.VariableKind=R={}));class I extends Error{constructor(O,p){super(p),this.variable=O}}e.$BP=I}),define(Ee[299],Ce([1,0,17,49,18,24,11,102,240,298,14]),function(re,e,o,R,I,M,O,p,$,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QP=void 0;class P{constructor(C,y,a,m){this.h=new Map,this.a=C,this.b=y,this.g=a,m&&(this.c=m.then(l=>this.i(l)))}i(C){if(O.$c){const y=Object.create(null);return Object.keys(C).forEach(a=>{y[a.toLowerCase()]=C[a]}),y}return C}resolveWithEnvironment(C,y,a){return this.l({env:this.i(C),userHome:void 0},y?y.uri:void 0,a)}async resolveAsync(C,y){const a={env:await this.c,userHome:await this.g};return this.l(a,C?C.uri:void 0,y)}async j(C,y,a,m){const l=M.$Pn(y);O.$c&&l.windows?Object.keys(l.windows).forEach(n=>l[n]=l.windows[n]):O.$d&&l.osx?Object.keys(l.osx).forEach(n=>l[n]=l.osx[n]):O.$e&&l.linux&&Object.keys(l.linux).forEach(n=>l[n]=l.linux[n]),delete l.windows,delete l.osx,delete l.linux;const i={env:await this.c,userHome:await this.g};return this.l(i,C?C.uri:void 0,l,a,m)}async resolveAnyAsync(C,y,a){return this.j(C,y,a)}async resolveAnyMap(C,y,a){const m=new Map;return{newConfig:await this.j(C,y,a,m),resolvedVariables:m}}resolveWithInteractionReplace(C,y,a,m){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(C,y,a,m){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(C,y){if(this.h.has(C))throw new Error("Variable "+C+" is contributed twice.");this.h.set(C,y)}async l(C,y,a,m,l){if(I.$Vf(a))return this.m(C,y,a,m,l);if(Array.isArray(a))return Promise.all(a.map(i=>this.l(C,y,i,m,l)));if(I.$Xf(a)){const i=Object.create(null),n=await Promise.all(Object.keys(a).map(async r=>[await this.m(C,y,r,m,l),await this.l(C,y,a[r],m,l)]));for(const[r,s]of n)i[r]=s;return i}return a}m(C,y,a,m,l){return(0,A.$df)(a,P.VARIABLE_REGEXP,async(i,n)=>{if(n.includes(P.VARIABLE_LHS))return i;let r=await this.o(C,i,n,y,m);return l?.set(n,r),r!==i&&I.$Vf(r)&&r.match(P.VARIABLE_REGEXP)&&(r=await this.m(C,y,r,m,l)),r})}n(C){return this.b?this.b.getUriLabel(C,{noPrefix:!0}):C.fsPath}async o(C,y,a,m,l){let i;const n=a.split(":");n.length>1&&(a=n[0],i=n[1]);const r=g=>{const d=this.a.getFilePath();if(d)return(0,p.$iw)(d);throw new w.$BP(g,(0,$.localize)(0,null,y))},s=g=>{const d=r(g);if(this.a.getWorkspaceFolderPathForFile){const h=this.a.getWorkspaceFolderPathForFile();if(h)return(0,p.$iw)(h)}throw new w.$BP(g,(0,$.localize)(1,null,y,o.$oc(d)))},t=g=>{if(i){const d=this.a.getFolderUri(i);if(d)return d;throw new w.$BP(g,(0,$.localize)(2,null,y,i))}if(m)return m;throw this.a.getWorkspaceFolderCount()>1?new w.$BP(g,(0,$.localize)(3,null,y)):new w.$BP(g,(0,$.localize)(4,null,y))};switch(a){case"env":if(i){if(C.env){const g=C.env[O.$c?i.toLowerCase():i];if(I.$Vf(g))return g}return""}throw new w.$BP(w.VariableKind.Env,(0,$.localize)(5,null,y));case"config":if(i){const g=this.a.getConfigurationValue(m,i);if(I.$5f(g))throw new w.$BP(w.VariableKind.Config,(0,$.localize)(6,null,y,i));if(I.$Xf(g))throw new w.$BP(w.VariableKind.Config,(0,$.localize)(7,null,y,i));return g}throw new w.$BP(w.VariableKind.Config,(0,$.localize)(8,null,y));case"command":return this.p(w.VariableKind.Command,y,i,l,"command");case"input":return this.p(w.VariableKind.Input,y,i,l,"input");case"extensionInstallFolder":if(i){const g=await this.a.getExtension(i);if(!g)throw new w.$BP(w.VariableKind.ExtensionInstallFolder,(0,$.localize)(9,null,y,i));return this.n(g.extensionLocation)}throw new w.$BP(w.VariableKind.ExtensionInstallFolder,(0,$.localize)(10,null,y));default:switch(a){case"workspaceRoot":case"workspaceFolder":return(0,p.$iw)(this.n(t(w.VariableKind.WorkspaceFolder)));case"cwd":return m||i?(0,p.$iw)(this.n(t(w.VariableKind.Cwd))):R.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,p.$iw)(o.$oc(this.n(t(w.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(C.userHome)return C.userHome;throw new w.$BP(w.VariableKind.UserHome,(0,$.localize)(11,null,y))}case"lineNumber":{const g=this.a.getLineNumber();if(g)return g;throw new w.$BP(w.VariableKind.LineNumber,(0,$.localize)(12,null,y))}case"selectedText":{const g=this.a.getSelectedText();if(g)return g;throw new w.$BP(w.VariableKind.SelectedText,(0,$.localize)(13,null,y))}case"file":return r(w.VariableKind.File);case"fileWorkspaceFolder":return s(w.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return o.$oc(s(w.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return m||i?o.$mc(this.n(t(w.VariableKind.RelativeFile)),r(w.VariableKind.RelativeFile)):r(w.VariableKind.RelativeFile);case"relativeFileDirname":{const g=o.$nc(r(w.VariableKind.RelativeFileDirname));if(m||i){const d=o.$mc(this.n(t(w.VariableKind.RelativeFileDirname)),g);return d.length===0?".":d}return g}case"fileDirname":return o.$nc(r(w.VariableKind.FileDirname));case"fileExtname":return o.$pc(r(w.VariableKind.FileExtname));case"fileBasename":return o.$oc(r(w.VariableKind.FileBasename));case"fileBasenameNoExtension":{const g=o.$oc(r(w.VariableKind.FileBasenameNoExtension));return g.slice(0,g.length-o.$pc(g).length)}case"fileDirnameBasename":return o.$oc(o.$nc(r(w.VariableKind.FileDirnameBasename)));case"execPath":{const g=this.a.getExecPath();return g||y}case"execInstallFolder":{const g=this.a.getAppRoot();return g||y}case"pathSeparator":case"/":return o.sep;default:try{const g=i?`${a}:${i}`:a;return this.p(w.VariableKind.Unknown,y,g,l,void 0)}catch{return y}}}}p(C,y,a,m,l){if(a&&m){const i=l===void 0?m[a]:m[l+":"+a];if(typeof i=="string")return i;throw new w.$BP(C,(0,$.localize)(14,null,y))}return y}}e.$QP=P,P.VARIABLE_LHS="${",P.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Ee[147],Ce([1,0,5,143]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$BD=void 0,e.$CD=w,e.$DD=b,e.$ED=C,e.$BD=(0,o.$ii)("editorGroupsService");var I;(function(y){y[y.UP=0]="UP",y[y.DOWN=1]="DOWN",y[y.LEFT=2]="LEFT",y[y.RIGHT=3]="RIGHT"})(I||(e.GroupDirection=I={}));var M;(function(y){y[y.HORIZONTAL=0]="HORIZONTAL",y[y.VERTICAL=1]="VERTICAL"})(M||(e.GroupOrientation=M={}));var O;(function(y){y[y.FIRST=0]="FIRST",y[y.LAST=1]="LAST",y[y.NEXT=2]="NEXT",y[y.PREVIOUS=3]="PREVIOUS"})(O||(e.GroupLocation=O={}));var p;(function(y){y[y.MAXIMIZE=0]="MAXIMIZE",y[y.EXPAND=1]="EXPAND",y[y.EVEN=2]="EVEN"})(p||(e.GroupsArrangement=p={}));var $;(function(y){y[y.COPY_EDITORS=0]="COPY_EDITORS",y[y.MOVE_EDITORS=1]="MOVE_EDITORS"})($||(e.MergeGroupMode=$={}));function w(y){const a=y;return(0,R.$mF)(a?.editor)&&(0,R.$mF)(a?.replacement)}var A;(function(y){y[y.CREATION_TIME=0]="CREATION_TIME",y[y.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",y[y.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(A||(e.GroupsOrder=A={}));var P;(function(y){y[y.NEW_EDITOR=1]="NEW_EDITOR",y[y.MOVE_EDITOR=2]="MOVE_EDITOR",y[y.COPY_EDITOR=3]="COPY_EDITOR"})(P||(e.OpenEditorContext=P={}));function b(y){const a=y;return!!a&&typeof a.id=="number"&&Array.isArray(a.editors)}function C(y){return y.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}}),define(Ee[300],Ce([1,0,5,147]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ID=e.$HD=e.$GD=e.$FD=void 0,e.$JD=I,e.$FD=(0,o.$ii)("editorService"),e.$GD=-1,e.$HD=-2,e.$ID=-3;function I(M){const O=M;return typeof M=="number"||(0,R.$DD)(O)}}),define(Ee[148],Ce([1,0,5,137]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PL=void 0,e.$PL=(0,o.$ji)(R.$pi)}),define(Ee[149],Ce([1,0,25,4,17,3,8]),function(re,e,o,R,I,M,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t$b=e.$s$b=e.$r$b=e.$q$b=e.$p$b=void 0;class p{constructor(i,n){this.versionId=i,this.removedDueToLooping=n}}e.$p$b=p;class ${static isHostExtension(i,n,r){if(n.getExtensionDescription(i))return!1;const s=r.getExtensionDescription(i);return s?!!((s.main||s.browser)&&s.api==="none"):!1}constructor(i,n){this.j=i,this.c=new R.$7d,this.onDidChange=this.c.event,this.d=0,this.e=n,this.k()}k(){this.e.sort(a),this.f=new o.$Gm,this.g=[],this.h=new Map;for(const i of this.e){if(this.f.has(i.identifier)){console.error("Extension `"+i.identifier.value+"` is already registered");continue}this.f.set(i.identifier,i),this.g.push(i);const n=this.j.readActivationEvents(i);for(const r of n)this.h.has(r)||this.h.set(r,[]),this.h.get(r).push(i)}}set(i){return this.e=i,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(i,n){this.e=m(this.e,n),this.e=this.e.concat(i);const r=$.l(this.e);return this.e=m(this.e,r.map(s=>s.identifier)),this.k(),this.d++,this.c.fire(void 0),new p(this.d,r)}static l(i){const n=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(d){this.d.has(d)||(this.d.add(d),this.e.push(d))}addArc(d,h){this.addNode(d),this.addNode(h),this.c.has(d)?this.c.get(d).push(h):this.c.set(d,[h])}getArcs(d){return this.c.has(d)?this.c.get(d):[]}hasOnlyGoodArcs(d,h){const c=n.getArcs(d);for(let u=0;u<c.length;u++)if(!h.has(c[u]))return!1;return!0}getNodes(){return this.e}},r=new o.$Gm;for(const d of i)if(r.set(d.identifier,d),d.extensionDependencies)for(const h of d.extensionDependencies)n.addArc(o.$Em.toKey(d.identifier),o.$Em.toKey(h));const s=new Set;n.getNodes().filter(d=>n.getArcs(d).length===0).forEach(d=>s.add(d));const t=n.getNodes().filter(d=>!s.has(d));let g;do{g=!1;for(let d=0;d<t.length;d++){const h=t[d];n.hasOnlyGoodArcs(h,s)&&(t.splice(d,1),d--,s.add(h),g=!0)}}while(g);return t.map(d=>r.get(d))}containsActivationEvent(i){return this.h.has(i)}containsExtension(i){return this.f.has(i)}getExtensionDescriptionsForActivationEvent(i){const n=this.h.get(i);return n?n.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new w(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(i){const n=this.f.get(i);return n||void 0}getExtensionDescriptionByUUID(i){for(const n of this.g)if(n.uuid===i)return n}getExtensionDescriptionByIdOrUUID(i,n){return this.getExtensionDescription(i)??(n?this.getExtensionDescriptionByUUID(n):void 0)}}e.$q$b=$;class w{constructor(i,n){this.versionId=i,this.extensions=n}}e.$r$b=w;class A{constructor(i){this.d=new C,this.c=new $(i,[])}async acquireLock(i){const n=await this.d.acquire(i);return new P(this,n)}deltaExtensions(i,n,r){if(!i.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(n,r)}containsActivationEvent(i){return this.c.containsActivationEvent(i)}containsExtension(i){return this.c.containsExtension(i)}getExtensionDescriptionsForActivationEvent(i){return this.c.getExtensionDescriptionsForActivationEvent(i)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(i){return this.c.getExtensionDescription(i)}getExtensionDescriptionByUUID(i){return this.c.getExtensionDescriptionByUUID(i)}getExtensionDescriptionByIdOrUUID(i,n){return this.c.getExtensionDescriptionByIdOrUUID(i,n)}}e.$s$b=A;class P extends M.$Uc{constructor(i,n){super(),this.f=i,this.c=!1,this.B(n)}isAcquiredFor(i){return!this.c&&this.f===i}}e.$t$b=P;class b{constructor(i){this.name=i;const n=(0,O.$bh)();this.promise=n.promise,this.c=n.resolve}resolve(i){this.c(i)}}class C{constructor(){this.c=[],this.d=!1}async acquire(i){const n=new b(i);return this.c.push(n),this.e(),n.promise}e(){if(this.d||this.c.length===0)return;const i=this.c.shift();this.d=!0;let n=!0;const r=setTimeout(()=>{n&&console.warn(`The customer named ${i.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),s=()=>{n&&(clearTimeout(r),n=!1,this.d=!1,this.e())};i.resolve((0,M.$Sc)(s))}}var y;(function(l){l[l.Builtin=0]="Builtin",l[l.User=1]="User",l[l.Dev=2]="Dev"})(y||(y={}));function a(l,i){const n=l.isBuiltin?0:l.isUnderDevelopment?2:1,r=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(n!==r)return n-r;const s=I.$hc.basename(l.extensionLocation.path),t=I.$hc.basename(i.extensionLocation.path);return s<t?-1:s>t?1:0}function m(l,i){const n=new o.$Fm(i);return l.filter(r=>!n.has(r.identifier))}}),define(Ee[301],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_m=e.$$m=e.$0m=e.ExtHostConnectionType=void 0,e.$an=p,e.$bn=$;var o;(function(A){A[A.IPC=1]="IPC",A[A.Socket=2]="Socket",A[A.MessagePort=3]="MessagePort"})(o||(e.ExtHostConnectionType=o={}));class R{constructor(P){this.pipeName=P,this.type=1}serialize(P){P[R.ENV_KEY]=this.pipeName}}e.$0m=R,R.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK";class I{constructor(){this.type=2}serialize(P){P[I.ENV_KEY]="1"}}e.$$m=I,I.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET";class M{constructor(){this.type=3}serialize(P){P[M.ENV_KEY]="1"}}e.$_m=M,M.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT";function O(A){delete A[R.ENV_KEY],delete A[I.ENV_KEY],delete A[M.ENV_KEY]}function p(A,P){O(P),A.serialize(P)}function $(A){if(A[R.ENV_KEY])return w(A,new R(A[R.ENV_KEY]));if(A[I.ENV_KEY])return w(A,new I);if(A[M.ENV_KEY])return w(A,new M);throw new Error("No connection information defined in environment!")}function w(A,P){return O(A),P}}),define(Ee[115],Ce([1,0,21]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$Mm=O,e.$Nm=p;var R;(function(w){w[w.Desktop=1]="Desktop",w[w.Web=2]="Web"})(R||(e.UIKind=R={}));var I;(function(w){w[w.VersionMismatch=55]="VersionMismatch",w[w.UnexpectedError=81]="UnexpectedError"})(I||(e.ExtensionHostExitCode=I={}));var M;(function(w){w[w.Initialized=0]="Initialized",w[w.Ready=1]="Ready",w[w.Terminate=2]="Terminate"})(M||(e.MessageType=M={}));function O(w){const A=o.$ue.alloc(1);switch(w){case 0:A.writeUInt8(1,0);break;case 1:A.writeUInt8(2,0);break;case 2:A.writeUInt8(3,0);break}return A}function p(w,A){if(w.byteLength!==1)return!1;switch(w.readUInt8(0)){case 1:return A===0;case 2:return A===1;case 3:return A===2;default:return!1}}var $;(function(w){w.Start="START_NATIVE_LOG",w.End="END_NATIVE_LOG"})($||(e.NativeLogMarkers=$={}))}),define(Ee[90],Ce([1,0,5,4,12,28,115,86,87,24,2,3,226]),function(re,e,o,R,I,M,O,p,$,w,A,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9O=e.$7O=e.$6O=void 0,e.$8O=a;let C=class extends P.$Uc{constructor(l,i){super(),this.s=l,this.t=i,this.a=this.B(new R.$7d),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new R.$7d),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=A.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=i.createLogger(this.m,{id:$.$0o,name:(0,b.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(i.onDidChangeLogLevel(n=>{(0,I.$Qj)(n)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===I.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(l,i,n){const r=this.getTelemetryDetails(),s=new y(i,n,l,this.n,this.j,this.getBuiltInCommonProperties(l),{isUsageEnabled:r.isUsageEnabled,isErrorsEnabled:r.isErrorsEnabled}),t=this.r.get(l.identifier.value)??[];return this.r.set(l.identifier.value,[...t,s]),s.apiTelemetryLogger}$initializeTelemetryLevel(l,i,n){this.f=l,this.g=i,this.c=n??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(l){const i=Object.create(null);switch(i["common.extname"]=`${l.publisher}.${l.name}`,i["common.extversion"]=l.version,i["common.vscodemachineid"]=this.s.telemetryInfo.machineId,i["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,i["common.sqmid"]=this.s.telemetryInfo.sqmId,i["common.vscodeversion"]=this.s.version,i["common.isnewappinstall"]=a(this.s.telemetryInfo.firstSessionDate),i["common.product"]=this.s.environment.appHost,this.s.uiKind){case O.UIKind.Web:i["common.uikind"]="web";break;case O.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,p.$vm)((0,$.$dp)(this.s.remote.authority)),i}$onDidChangeTelemetryLevel(l){this.h=this.getTelemetryConfiguration(),this.f=l;const i=this.getTelemetryDetails();this.r.forEach((n,r)=>{const s=n.filter(t=>!t.isDisposed);s.length===0?this.r.delete(r):this.r.set(r,s)}),this.r.forEach(n=>{for(const r of n)r.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(l,i){const r=this.r.get(l.value)?.filter(t=>!t.isDisposed);if(!r)return this.r.delete(l.value),!1;let s=!1;for(const t of r)t.ignoreUnhandledExtHostErrors||(t.logError(i),s=!0);return s}};e.$6O=C,e.$6O=C=Qe([He(0,M.$5O),He(1,I.$Pj)],C);class y{static validateSender(l){if(typeof l!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof l.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof l.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof l.flush<"u"&&typeof l.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(l,i,n,r,s,t,g){this.g=n,this.h=r,this.i=s,this.j=t,this.a=new R.$7d,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this.b=i?.ignoreBuiltInCommonProperties??!1,this.c=i?.additionalCommonProperties,this.f=l,this.d={isUsageEnabled:g.isUsageEnabled,isErrorsEnabled:g.isErrorsEnabled}}updateTelemetryEnablements(l,i){this.e&&(this.d={isUsageEnabled:l,isErrorsEnabled:i},this.a.fire(this.e))}mixInCommonPropsAndCleanData(l){let i="properties"in l?l.properties??{}:l;return i=(0,$.$gp)(i,[]),this.c&&(i=(0,w.$Sn)(i,this.c)),this.b||(i=(0,w.$Sn)(i,this.j)),"properties"in l?l.properties=i:l=i,l}k(l,i){this.f&&(this.g.publisher==="vscode"?l=this.g.name+"/"+l:l=this.g.identifier.value+"/"+l,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f?.sendEventData(l,i),this.h.trace(l,i))}logUsage(l,i){this.d.isUsageEnabled&&this.k(l,i)}logError(l,i){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof l=="string")this.k(l,i);else{const n={name:l.name,message:l.message,stack:l.stack,cause:l.cause},r=(0,$.$gp)(n,[]),s=new Error(r.message,{cause:r.cause});s.stack=r.stack,s.name=r.name,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f.sendErrorData(s,i),this.h.trace("exception",i)}}get apiTelemetryLogger(){if(!this.e){const l=this,i={logUsage:l.logUsage.bind(l),get isUsageEnabled(){return l.d.isUsageEnabled},get isErrorsEnabled(){return l.d.isErrorsEnabled},logError:l.logError.bind(l),dispose:l.dispose.bind(l),onDidChangeEnableStates:l.a.event.bind(l)};this.e=Object.freeze(i)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let l=this.f;this.f=void 0,Promise.resolve(l.flush()).then(l=void 0),this.e=void 0}else this.f=void 0}}e.$7O=y;function a(m){const l=Date.now()-new Date(m).getTime();return isNaN(l)?!1:l<1e3*60*60*24}e.$9O=(0,o.$ii)("IExtHostTelemetry")}),define(Ee[26],Ce([1,0,4,2,271,141,25,5]),function(re,e,o,R,I,M,O,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iG=e.ActivationKind=e.$fG=e.$eG=e.$bG=e.ExtensionHostStartup=e.$aG=e.$_F=e.$$F=e.$0F=void 0,e.$cG=b,e.$dG=C,e.$gG=l,e.$hG=i,e.$0F=Object.freeze({identifier:new O.$Em("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:R.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$$F="extensions.webWorker",e.$_F=(0,p.$ii)("extensionService");class ${constructor(s){this.dependency=s}}e.$aG=$;var w;(function(r){r[r.EagerAutoStart=1]="EagerAutoStart",r[r.EagerManualStart=2]="EagerManualStart",r[r.Lazy=3]="Lazy"})(w||(e.ExtensionHostStartup=w={}));class A{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(s,t,g){this.c=s,this.d=t.slice(0),this.e=g.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:M.$UF.createActivationEventsMap(this.d)}}set(s,t,g){if(this.c>s)throw new Error(`ExtensionHostExtensions: invalid versionId ${s} (current: ${this.c})`);const d=[],h=[],c=[],u=[],f=P(this.d),E=P(t),v=(W,B)=>W.extensionLocation.toString()===B.extensionLocation.toString()||W.isBuiltin===B.isBuiltin||W.isUserBuiltin===B.isUserBuiltin||W.isUnderDevelopment===B.isUnderDevelopment;for(const W of this.d){const B=E.get(W.identifier);if(!B){d.push(W.identifier),f.delete(W.identifier);continue}if(!v(W,B)){d.push(W.identifier),f.delete(W.identifier);continue}}for(const W of t){const B=f.get(W.identifier);if(!B){h.push(W);continue}if(!v(B,W)){d.push(B.identifier),f.delete(B.identifier);continue}}const D=new O.$Fm(this.e),k=new O.$Fm(g);for(const W of this.e)k.has(W)||c.push(W);for(const W of g)D.has(W)||u.push(W);const S=M.$UF.createActivationEventsMap(h),F={versionId:s,toRemove:d,toAdd:h,addActivationEvents:S,myToRemove:c,myToAdd:u};return this.delta(F),F}delta(s){if(this.c>=s.versionId)return null;const{toRemove:t,toAdd:g,myToRemove:d,myToAdd:h}=s,c=new O.$Fm(t),u=new O.$Fm(d);for(let f=0;f<this.d.length;f++)c.has(this.d[f].identifier)&&(this.d.splice(f,1),f--);for(let f=0;f<this.e.length;f++)u.has(this.e[f])&&(this.e.splice(f,1),f--);for(const f of g)this.d.push(f);for(const f of h)this.e.push(f);return this.f=null,s}containsExtension(s){for(const t of this.e)if(O.$Em.equals(t,s))return!0;return!1}containsActivationEvent(s){return this.f||(this.f=this.g()),this.f.has(s)}g(){const s=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const g=M.$UF.readActivationEvents(t);for(const d of g)s.add(d)}return s}}e.$bG=A;function P(r){const s=new O.$Gm;for(const t of r)s.set(t.identifier,t);return s}function b(r,s){return!0}function C(r,s){if(!b(r,s))throw new Error(`Extension '${r.identifier.value}' CANNOT use API proposal: ${s}.
Its package.json#enabledApiProposals-property declares: ${r.enabledApiProposals?.join(", ")??"[]"} but NOT ${s}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${r.identifier.value}`)}class y{constructor(s,t,g,d){this.codeLoadingTime=s,this.activateCallTime=t,this.activateResolvedTime=g,this.activationReason=d}}e.$eG=y;class a{constructor(s,t){this.description=s,this.value=t}}e.$fG=a;var m;(function(r){r[r.Normal=0]="Normal",r[r.Immediate=1]="Immediate"})(m||(e.ActivationKind=m={}));function l(r){return{type:r.isBuiltin?0:1,isBuiltin:r.isBuiltin||r.isUserBuiltin,identifier:{id:(0,I.$mp)(r.publisher,r.name),uuid:r.uuid},manifest:r,location:r.extensionLocation,targetPlatform:r.targetPlatform,validations:[],isValid:!0}}function i(r,s){return{identifier:new O.$Em((0,I.$kp)(r.manifest.publisher,r.manifest.name)),isBuiltin:r.type===0,isUserBuiltin:r.type===1&&r.isBuiltin,isUnderDevelopment:!!s,extensionLocation:r.location,...r.manifest,uuid:r.identifier.uuid,targetPlatform:r.targetPlatform}}class n{constructor(){this.onDidRegisterExtensions=o.Event.None,this.onDidChangeExtensionsStatus=o.Event.None,this.onDidChangeExtensions=o.Event.None,this.onWillActivateByEvent=o.Event.None,this.onDidChangeResponsiveChange=o.Event.None,this.onWillStop=o.Event.None,this.extensions=[]}activateByEvent(s){return Promise.resolve(void 0)}activateById(s,t){return Promise.resolve(void 0)}activationEventIsDone(s){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(s){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(s,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(s){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$iG=n}),define(Ee[302],Ce([1,0,13,149,25,26,12,8]),function(re,e,o,R,I,M,O,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ikc=e.$hkc=e.$gkc=e.$fkc=e.$ekc=e.$dkc=void 0;class ${constructor(l,i,n,r){this.startup=l,this.codeLoadingTime=i,this.activateCallTime=n,this.activateResolvedTime=r}}e.$dkc=$,$.NONE=new $(!1,-1,-1,-1);class w{constructor(l){this.a=l,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(l,i){return l===-1||i===-1?-1:i-l}build(){return new $(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$ekc=w;class A{constructor(l,i,n,r,s,t){this.activationFailed=l,this.activationFailedError=i,this.activationTimes=n,this.module=r,this.exports=s,this.subscriptions=t}}e.$fkc=A;class P extends A{constructor(l){super(!1,null,l,{activate:void 0,deactivate:void 0},void 0,[])}}e.$gkc=P;class b extends A{constructor(){super(!1,null,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$hkc=b;class C extends A{constructor(l){super(!0,l,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let y=class{constructor(l,i,n,r){this.g=r,this.a=l,this.b=i,this.c=n,this.d=new I.$Gm,this.f=Object.create(null)}dispose(){for(const[l,i]of this.d)i.dispose()}async waitForActivatingExtensions(){const l=[];for(const[i,n]of this.d)l.push(n.wait());await Promise.all(l)}isActivated(l){const i=this.d.get(l);return!!(i&&i.value)}getActivatedExtension(l){const i=this.d.get(l);if(!i||!i.value)throw new Error(`Extension '${l.value}' is not known or not activated`);return i.value}async activateByEvent(l,i){if(this.f[l])return;const n=this.a.getExtensionDescriptionsForActivationEvent(l);await this.h(n.map(r=>({id:r.identifier,reason:{startup:i,extensionId:r.identifier,activationEvent:l}}))),this.f[l]=!0}activateById(l,i){const n=this.a.getExtensionDescription(l);if(!n)throw new Error(`Extension '${l.value}' is not known`);return this.h([{id:n.identifier,reason:i}])}async h(l){const i=l.filter(n=>!this.isActivated(n.id)).map(n=>this.j(n));await Promise.all(i.map(n=>n.wait()))}j(l){if(this.d.has(l.id))return this.d.get(l.id);if(this.l(l.id))return this.k(l,null,[],null);const i=this.a.getExtensionDescription(l.id);if(!i){const s=new Error(`Cannot activate unknown extension '${l.id.value}'`),t=this.k(l,null,[],new C(s));return this.c.onExtensionActivationError(l.id,s,new M.$aG(l.id.value)),t}const n=[],r=typeof i.extensionDependencies>"u"?[]:i.extensionDependencies;for(const s of r){if(this.m(s))continue;const t=this.d.get(s);if(t){n.push(t);continue}if(this.l(s)){n.push(this.j({id:this.b.getExtensionDescription(s).identifier,reason:l.reason}));continue}const g=this.a.getExtensionDescription(s);if(g){if(!g.main&&!g.browser)continue;n.push(this.j({id:g.identifier,reason:l.reason}));continue}const d=i.displayName||i.identifier.value,h=new Error(`Cannot activate the '${d}' extension because it depends on unknown extension '${s}'`),c=this.k(l,i.displayName,[],new C(h));return this.c.onExtensionActivationError(i.identifier,h,new M.$aG(s)),c}return this.k(l,i.displayName,n,null)}k(l,i,n,r){const s=new a(l.id,i,l.reason,n,r,this.c,this.g);return this.d.set(l.id,s),s}l(l){return R.$q$b.isHostExtension(l,this.a,this.b)}m(l){const i=this.b.getExtensionDescription(l);return i?!i.main&&!i.browser:!1}};e.$ikc=y,e.$ikc=y=Qe([He(3,O.$Oj)],y);let a=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(l,i,n,r,s,t,g){this.c=l,this.d=i,this.f=n,this.g=r,this.h=s,this.j=t,this.k=g,this.a=new p.$hh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let l=0;l<this.g.length;l++){const i=this.g[l];if(i.value&&!i.value.activationFailed){this.g.splice(l,1),l--;continue}if(i.value&&i.value.activationFailed){const n=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${i.friendlyName}' failed to activate`);n.detail=i.value.activationFailedError,this.h=new C(n),this.j.onExtensionActivationError(this.c,n,null);return}}this.g.length>0&&await Promise.race(this.g.map(l=>l.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(l){const i=new Error;if(l&&l.name&&(i.name=l.name),l&&l.message?i.message=`Activating extension '${this.c.value}' failed: ${l.message}.`:i.message=`Activating extension '${this.c.value}' failed: ${l}.`,l&&l.stack&&(i.stack=l.stack),this.h=new C(i),this.b&&o.$4(l))return;this.j.onExtensionActivationError(this.c,i,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(l)}}};a=Qe([He(6,O.$Oj)],a)}),define(Ee[303],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",aiTextSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authLearnMore:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipant.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentThreadApplicability:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts",commentingRangeHint:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribCommentsViewThreadMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts",contribDiffEditorGutterToolBarMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModels.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputMultiDiff:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",terminalShellIntegration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ee[304],Ce([1,0,242,13,41,138,109,37,25,303,140,141]),function(re,e,o,R,I,M,O,p,$,w,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9F=e.$8F=e.$7F=e.$6F=e.$5F=e.$4F=void 0;const b=p.$2n.as(O.$3n.JSONContribution);class C{constructor(s,t,g){this.a=s,this.b=t,this.c=g}d(s,t){this.a({type:s,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(s){this.d(I.default.Error,s)}warn(s){this.d(I.default.Warning,s)}info(s){this.d(I.default.Info,s)}}e.$4F=C;class y{static a(s){const t=new $.$Fm;for(let g=0,d=s.length;g<d;g++)t.add(s[g].description.identifier);return t}static compute(s,t){if(!s||!s.length)return new y(t,[]);if(!t||!t.length)return new y([],s);const g=this.a(s),d=this.a(t),h=t.filter(u=>!g.has(u.description.identifier)),c=s.filter(u=>!d.has(u.description.identifier));return new y(h,c)}constructor(s,t){this.added=s,this.removed=t}}e.$5F=y;class a{constructor(s,t){this.name=s,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(s){if(this.a!==null)throw new Error("Handler already set!");this.a=s,this.d()}acceptUsers(s){this.c=y.compute(this.b,s),this.b=s,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(s){(0,R.$1)(s)}}}e.$6F=a;const m={type:"string",enum:["ui","workspace"],enumDescriptions:[o.localize(0,null),o.localize(1,null)]},l="vscode://schemas/vscode-extensions";e.$7F={properties:{engines:{type:"object",description:o.localize(2,null),properties:{vscode:{type:"string",description:o.localize(3,null),default:"^1.22.0"}}},publisher:{description:o.localize(4,null),type:"string"},displayName:{description:o.localize(5,null),type:"string"},categories:{description:o.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:$.$Dm},{type:"string",const:"Languages",deprecationMessage:o.localize(7,null)}]}},galleryBanner:{type:"object",description:o.localize(8,null),properties:{color:{description:o.localize(9,null),type:"string"},theme:{description:o.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:o.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:o.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:o.localize(13,null)},enabledApiProposals:{markdownDescription:o.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(w.allApiProposals),markdownEnumDescriptions:Object.values(w.allApiProposals)}},api:{markdownDescription:o.localize(15,null),type:"string",enum:["none"],enumDescriptions:[o.localize(16,null)]},activationEvents:{description:o.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:o.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:o.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:o.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:o.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:o.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:o.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:o.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:o.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:o.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:o.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:o.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:o.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:o.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:o.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:o.localize(32,null)},{label:"onUri",body:"onUri",description:o.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:o.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:o.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:o.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:o.localize(37,null)},{label:"onRenderer",description:o.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:o.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:o.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:o.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:o.localize(42,null)},{label:"*",description:o.localize(43,null),body:"*"}]}},badges:{type:"array",description:o.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:o.localize(45,null)},href:{type:"string",description:o.localize(46,null)},description:{type:"string",description:o.localize(47,null)}}}},markdown:{type:"string",description:o.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:o.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:o.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.$Go}},extensionPack:{description:o.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.$Go}},extensionKind:{description:o.localize(52,null),type:"array",items:m,default:["workspace"],defaultSnippets:[{body:["ui"],description:o.localize(53,null)},{body:["workspace"],description:o.localize(54,null)},{body:["ui","workspace"],description:o.localize(55,null)},{body:["workspace","ui"],description:o.localize(56,null)},{body:[],description:o.localize(57,null)}]},capabilities:{description:o.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:o.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:o.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[o.localize(61,null),o.localize(62,null),o.localize(63,null)]},description:{type:"string",markdownDescription:o.localize(64,null)}}},untrustedWorkspaces:{description:o.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:o.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[o.localize(67,null),o.localize(68,null),o.localize(69,null)]},restrictedConfigurations:{description:o.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:o.localize(71,null)}}}}},sponsor:{description:o.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:o.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:o.localize(74,null),type:"string"},"vscode:uninstall":{description:o.localize(75,null),type:"string"}}},icon:{type:"string",description:o.localize(76,null)},l10n:{type:"string",description:o.localize(77,null)},pricing:{type:"string",markdownDescription:o.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class i{constructor(){this.a=new Map}registerExtensionPoint(s){if(this.a.has(s.extensionPoint))throw new Error("Duplicate extension point: "+s.extensionPoint);const t=new a(s.extensionPoint,s.defaultExtensionKind);return this.a.set(s.extensionPoint,t),s.activationEventsGenerator&&P.$UF.register(s.extensionPoint,s.activationEventsGenerator),e.$7F.properties.contributes.properties[s.extensionPoint]=s.jsonSchema,b.registerSchema(l,e.$7F),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$8F=i;const n={ExtensionsRegistry:"ExtensionsRegistry"};p.$2n.add(n.ExtensionsRegistry,new i),e.$9F=p.$2n.as(n.ExtensionsRegistry),b.registerSchema(l,e.$7F),b.registerSchema(A.$9j,{properties:{extensionEnabledApiProposals:{description:o.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(w.allApiProposals),markdownEnumDescriptions:Object.values(w.allApiProposals)}}]}}}})}),define(Ee[305],Ce([1,0,238,18,24,304,42,4]),function(re,e,o,R,I,M,O,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yH=void 0;const $={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:o.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:o.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:o.localize(2,null),default:""}}};var w;(function(b){function C(y,a,m){if(!y)return;const l=R.$Vf(y.type)?y.type:void 0;if(!l||l.length===0){m.error(o.localize(3,null));return}const i=[];if(Array.isArray(y.required))for(const n of y.required)R.$Vf(n)&&i.push(n);return{extensionId:a.value,taskType:l,required:i,properties:y.properties?I.$Pn(y.properties):{},when:y.when?O.$gj.deserialize(y.when):void 0}}b.from=C})(w||(w={}));const A=M.$9F.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(b,C)=>{for(const y of b)y.type&&C.push(`onTaskType:${y.type}`)},jsonSchema:{description:o.localize(4,null),type:"array",items:$}});class P{constructor(){this.d=new p.$7d,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((C,y)=>{A.setHandler((a,m)=>{this.c=void 0;try{for(const l of m.removed){const i=l.value;for(const n of i)this.a&&n.type&&this.a[n.type]&&delete this.a[n.type]}for(const l of m.added){const i=l.value;for(const n of i){const r=w.from(n,l.description.identifier,l.collector);r&&(this.a[r.taskType]=r)}}(m.removed.length>0||m.added.length>0)&&this.d.fire()}catch{}C(void 0)})})}onReady(){return this.b}get(C){return this.a[C]}all(){return Object.keys(this.a).map(C=>this.a[C])}getJsonSchema(){if(this.c===void 0){const C=[];for(const y of this.all()){const a={type:"object",additionalProperties:!1};y.required.length>0&&(a.required=y.required.slice(0)),y.properties!==void 0?a.properties=I.$Pn(y.properties):a.properties=Object.create(null),a.properties.type={type:"string",enum:[y.taskType]},C.push(a)}this.c={oneOf:C}}return this.c}}e.$yH=new P}),define(Ee[306],Ce([1,0,239,18,23,24,42,305]),function(re,e,o,R,I,M,O,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$IH=e.JsonSchemaVersion=e.ExecutionEngine=e.$HH=e.$GH=e.$FH=e.$EH=e.$DH=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$CH=e.ShellQuoting=e.$BH=e.$AH=e.$zH=void 0,e.$zH="settings",e.$AH=new O.$zj("taskRunning",!1,o.localize(0,null)),e.$BH=o.localize2(2,"Tasks");var $;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})($||(e.ShellQuoting=$={})),e.$CH="$customized",function(N){function j(L){if(!L)return N.Strong;switch(L.toLowerCase()){case"escape":return N.Escape;case"strong":return N.Strong;case"weak":return N.Weak;default:return N.Strong}}N.from=j}($||(e.ShellQuoting=$={}));var w;(function(N){N.defaults={cwd:"${workspaceFolder}"}})(w||(e.CommandOptions=w={}));var A;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(A||(e.RevealKind=A={})),function(N){function j(L){switch(L.toLowerCase()){case"always":return N.Always;case"silent":return N.Silent;case"never":return N.Never;default:return N.Always}}N.fromString=j}(A||(e.RevealKind=A={}));var P;(function(N){N[N.Never=1]="Never",N[N.OnProblem=2]="OnProblem",N[N.Always=3]="Always"})(P||(e.RevealProblemKind=P={})),function(N){function j(L){switch(L.toLowerCase()){case"always":return N.Always;case"never":return N.Never;case"onproblem":return N.OnProblem;default:return N.OnProblem}}N.fromString=j}(P||(e.RevealProblemKind=P={}));var b;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(b||(e.PanelKind=b={})),function(N){function j(L){switch(L.toLowerCase()){case"shared":return N.Shared;case"dedicated":return N.Dedicated;case"new":return N.New;default:return N.Shared}}N.fromString=j}(b||(e.PanelKind=b={}));var C;(function(N){N.defaults={echo:!0,reveal:A.Always,revealProblems:P.Never,focus:!1,panel:b.Shared,showReuseMessage:!0,clear:!1}})(C||(e.PresentationOptions=C={}));var y;(function(N){N[N.Shell=1]="Shell",N[N.Process=2]="Process",N[N.CustomExecution=3]="CustomExecution"})(y||(e.RuntimeType=y={})),function(N){function j(z){switch(z.toLowerCase()){case"shell":return N.Shell;case"process":return N.Process;case"customExecution":return N.CustomExecution;default:return N.Process}}N.fromString=j;function L(z){switch(z){case N.Shell:return"shell";case N.Process:return"process";case N.CustomExecution:return"customExecution";default:return"process"}}N.toString=L}(y||(e.RuntimeType=y={}));var a;(function(N){function j(L){return R.$Vf(L)?L:L.value}N.value=j})(a||(e.CommandString=a={}));var m;(function(N){N.Clean={_id:"clean",isDefault:!1},N.Build={_id:"build",isDefault:!1},N.Rebuild={_id:"rebuild",isDefault:!1},N.Test={_id:"test",isDefault:!1};function j(z){return z===N.Clean._id||z===N.Build._id||z===N.Rebuild._id||z===N.Test._id}N.is=j;function L(z){if(z!==void 0)return R.$Vf(z)?j(z)?{_id:z,isDefault:!1}:void 0:z}N.from=L})(m||(e.TaskGroup=m={}));var l;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.Folder=3]="Folder"})(l||(e.TaskScope=l={}));var i;(function(N){N.Workspace="workspace",N.Extension="extension",N.InMemory="inMemory",N.WorkspaceFile="workspaceFile",N.User="user";function j(L){switch(L){case N.User:return 2;case N.WorkspaceFile:return 5;default:return 6}}N.toConfigurationTarget=j})(i||(e.TaskSourceKind=i={}));var n;(function(N){N.parallel="parallel",N.sequence="sequence"})(n||(e.DependsOrder=n={}));var r;(function(N){N[N.default=1]="default",N[N.folderOpen=2]="folderOpen"})(r||(e.RunOnOptions=r={}));var s;(function(N){N.defaults={reevaluateOnRerun:!0,runOn:r.default,instanceLimit:1}})(s||(e.RunOptions=s={}));class t{constructor(j,L,z,Q,Y,J){this._label="",this._id=j,L&&(this._label=L),z&&(this.type=z),this.runOptions=Q,this.configurationProperties=Y,this._source=J}getDefinition(j){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const j={folder:this.d(),id:this._id};return JSON.stringify(j)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(j,L=!1){if(j===void 0)return!1;if(R.$Vf(j))return j===this._label||j===this.configurationProperties.identifier||L&&j===this._id;const z=this.getDefinition(!0);return z!==void 0&&z._key===j._key}getQualifiedLabel(){const j=this.getWorkspaceFolder();return j?`${this._label} (${j.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(j){this.c===void 0&&(this.c=[]),j&&(this.c=this.c.concat(j))}get taskLoadMessages(){return this.c}}e.$DH=t;class g extends t{constructor(j,L,z,Q,Y,J,x,ce){super(j,z,void 0,x,ce,L),this.command={},this._source=L,this.hasDefinedMatchers=J,Y&&(this.command=Y)}clone(){return new g(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(j=!1){if(j&&this._source.customizes!==void 0)return this._source.customizes;{let L;switch(this.command?this.command.runtime:void 0){case y.Shell:L="shell";break;case y.Process:L="process";break;case y.CustomExecution:L="customExecution";break;case void 0:L="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:L,_key:this._id,id:this._id}}}static is(j){return j instanceof g}getMapKey(){const j=this._source.config.workspaceFolder;return j?`${j.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===i.User?e.$zH:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const j=this.d();if(!j)return;let L=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(L+=this._source.kind);const z={type:e.$CH,folder:j,id:L};return JSON.stringify(z)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?I.$Sg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(j){return new g(j._id,j._source,j._label,j.type,j.command,j.hasDefinedMatchers,j.runOptions,j.configurationProperties)}}e.$EH=g;class d extends t{constructor(j,L,z,Q,Y,J,x){super(j,z,Q,J,x,L),this._source=L,this.configures=Y}static is(j){return j instanceof d}f(j){return j}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?I.$Sg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===i.User?e.$zH:this._source.config.workspaceFolder?.uri.toString()}getKey(){const j=this.d();if(!j)return;let L=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(L+=this._source.kind);const z={type:e.$CH,folder:j,id:L};return JSON.stringify(z)}}e.$FH=d;class h extends t{constructor(j,L,z,Q,Y,J,x,ce,te){super(j,z,Q,ce,te,L),this.defines=Y,this.hasDefinedMatchers=x,this.command=J,this.icon=te.icon,this.hide=te.hide}clone(){return new h(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(j){return j instanceof h}getMapKey(){const j=this._source.workspaceFolder;return j?`${this._source.scope.toString()}|${j.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const j={type:"contributed",scope:this._source.scope,id:this._id};return j.folder=this.d(),JSON.stringify(j)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(j){return new h(j._id,j._source,j._label,j.type,j.defines,j.command,j.hasDefinedMatchers,j.runOptions,j.configurationProperties)}}e.$GH=h;class c extends t{constructor(j,L,z,Q,Y,J){super(j,z,Q,Y,J,L),this._source=L}clone(){return new c(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(j){return j instanceof c}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(j){return new c(j._id,j._source,j._label,j.type,j.runOptions,j.configurationProperties)}}e.$HH=c;var u;(function(N){N[N.Process=1]="Process",N[N.Terminal=2]="Terminal"})(u||(e.ExecutionEngine=u={})),function(N){N._default=N.Terminal}(u||(e.ExecutionEngine=u={}));var f;(function(N){N[N.V0_1_0=1]="V0_1_0",N[N.V2_0_0=2]="V2_0_0"})(f||(e.JsonSchemaVersion=f={}));class E{constructor(j){this.c=new Map;for(let L=0;L<j.length;L++)this.c.set(j[L].uri.toString(),L)}compare(j,L){const z=j.getWorkspaceFolder(),Q=L.getWorkspaceFolder();if(z&&Q){let Y=this.c.get(z.uri.toString());Y=Y===void 0?0:Y+1;let J=this.c.get(Q.uri.toString());return J=J===void 0?0:J+1,Y===J?j._label.localeCompare(L._label):Y-J}else return!z&&Q?-1:z&&!Q?1:0}}e.$IH=E;var v;(function(N){N.DependsOnStarted="dependsOnStarted",N.AcquiredInput="acquiredInput",N.Start="start",N.ProcessStarted="processStarted",N.Active="active",N.Inactive="inactive",N.Changed="changed",N.Terminated="terminated",N.ProcessEnded="processEnded",N.End="end"})(v||(e.TaskEventKind=v={}));var D;(function(N){N.SingleRun="singleRun",N.Background="background"})(D||(e.TaskRunType=D={}));var k;(function(N){N[N.System=0]="System",N[N.User=1]="User",N[N.FolderOpen=2]="FolderOpen",N[N.ConfigurationChange=3]="ConfigurationChange",N[N.Reconnect=4]="Reconnect"})(k||(e.TaskRunSource=k={}));var S;(function(N){function j(ce){return{taskId:ce._id,taskName:ce.configurationProperties.name,runType:ce.configurationProperties.isBackground?"background":"singleRun",group:ce.configurationProperties.group,__task:ce}}function L(ce,te,pe){return{...j(ce),kind:"start",terminalId:te,resolvedVariables:pe}}N.start=L;function z(ce,te,pe){return{...j(ce),kind:"processStarted",terminalId:te,processId:pe}}N.processStarted=z;function Q(ce,te,pe){return{...j(ce),kind:"processEnded",terminalId:te,exitCode:pe}}N.processEnded=Q;function Y(ce,te,pe){return{...j(ce),kind:"terminated",exitReason:pe,terminalId:te}}N.terminated=Y;function J(ce,te,pe){return{...j(te),kind:ce,terminalId:pe}}N.general=J;function x(){return{kind:"changed"}}N.changed=x})(S||(e.TaskEvent=S={}));var F;(function(N){function j(z){const Q=Object.keys(z).sort();let Y="";for(const J of Q){let x=z[J];x instanceof Object?x=j(x):typeof x=="string"&&(x=x.replace(/,/g,",,")),Y+=J+","+x+","}return Y}function L(z){const Y={_key:j(z),type:z.taskType};return Object.assign(Y,z),Y}N.create=L})(F||(e.KeyedTaskIdentifier=F={}));var W;(function(N){N.AutoDetect="task.autoDetect",N.SaveBeforeRun="task.saveBeforeRun",N.ShowDecorations="task.showDecorations",N.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",N.SlowProviderWarning="task.slowProviderWarning",N.QuickOpenHistory="task.quickOpen.history",N.QuickOpenDetail="task.quickOpen.detail",N.QuickOpenSkip="task.quickOpen.skip",N.QuickOpenShowAll="task.quickOpen.showAll",N.AllowAutomaticTasks="task.allowAutomaticTasks",N.Reconnection="task.reconnection",N.VerboseLogging="task.verboseLogging"})(W||(e.TaskSettingId=W={}));var B;(function(N){N.Tasks="tasks",N.SuppressTaskName="tasks.suppressTaskName",N.Windows="tasks.windows",N.Osx="tasks.osx",N.Linux="tasks.linux",N.ShowOutput="tasks.showOutput",N.IsShellCommand="tasks.isShellCommand",N.ServiceTestSetting="tasks.service.testSetting"})(B||(e.TasksSchemaProperties=B={}));var T;(function(N){function j(L,z){const Q=p.$yH.get(L.type);if(Q===void 0){const ce=M.$Pn(L);return delete ce._key,F.create(ce)}const Y=Object.create(null);Y.type=Q.taskType;const J=new Set;Q.required.forEach(ce=>J.add(ce));const x=Q.properties;for(const ce of Object.keys(x)){const te=L[ce];if(te!=null)Y[ce]=te;else if(J.has(ce)){const pe=x[ce];if(pe.default!==void 0)Y[ce]=M.$Pn(pe.default);else switch(pe.type){case"boolean":Y[ce]=!1;break;case"number":case"integer":Y[ce]=0;break;case"string":Y[ce]="";break;default:z.error(o.localize(1,null,JSON.stringify(L,void 0,0),ce));return}}}return F.create(Y)}N.createTaskIdentifier=j})(T||(e.TaskDefinition=T={}))}),define(Ee[307],Ce([1,0,13]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v$b=e.$u$b=void 0;class R{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((O,p)=>{this.b=O,this.d=p,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(O){this.f||this.h||(this.f=!0,this.g=O,this.a&&this.b(O))}resolveErr(O){this.f||this.h||(this.h=!0,this.i=O,this.a?this.d(O):(0,o.$1)(O))}then(O,p){return this.j().then(O,p)}catch(O){return this.j().then(void 0,O)}finally(O){return this.j().finally(O)}}e.$u$b=R;class I extends R{constructor(){super(),this.h=!0,this.i=new o.$5}}e.$v$b=I}),define(Ee[68],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fw=e.$cw=void 0,e.$dw=I,e.$ew=M;class o{constructor($){this._proxyIdentifierBrand=void 0,this.sid=$,this.nid=++o.count}}e.$cw=o,o.count=0;const R=[];function I(p){const $=new o(p);return R[$.nid]=$,$}function M(p){return R[p].sid}class O{constructor($){this.value=$}}e.$fw=O}),define(Ee[6],Ce([1,0,68]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tM=e.$sM=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$rM=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var R;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(R||(e.TextEditorRevealType=R={}));var I;(function(a){a[a.UnknownInput=0]="UnknownInput",a[a.TextInput=1]="TextInput",a[a.TextDiffInput=2]="TextDiffInput",a[a.TextMergeInput=3]="TextMergeInput",a[a.NotebookInput=4]="NotebookInput",a[a.NotebookDiffInput=5]="NotebookDiffInput",a[a.CustomEditorInput=6]="CustomEditorInput",a[a.WebviewEditorInput=7]="WebviewEditorInput",a[a.TerminalEditorInput=8]="TerminalEditorInput",a[a.InteractiveEditorInput=9]="InteractiveEditorInput",a[a.ChatEditorInput=10]="ChatEditorInput",a[a.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(I||(e.TabInputKind=I={}));var M;(function(a){a[a.TAB_OPEN=0]="TAB_OPEN",a[a.TAB_CLOSE=1]="TAB_CLOSE",a[a.TAB_UPDATE=2]="TAB_UPDATE",a[a.TAB_MOVE=3]="TAB_MOVE"})(M||(e.TabModelOperationKind=M={}));var O;(function(a){a[a.Editable=0]="Editable",a[a.SupportsHotExit=1]="SupportsHotExit"})(O||(e.WebviewEditorCapabilities=O={}));var p;(function(a){a[a.Int8Array=1]="Int8Array",a[a.Uint8Array=2]="Uint8Array",a[a.Uint8ClampedArray=3]="Uint8ClampedArray",a[a.Int16Array=4]="Int16Array",a[a.Uint16Array=5]="Uint16Array",a[a.Int32Array=6]="Int32Array",a[a.Uint32Array=7]="Uint32Array",a[a.Float32Array=8]="Float32Array",a[a.Float64Array=9]="Float64Array",a[a.BigInt64Array=10]="BigInt64Array",a[a.BigUint64Array=11]="BigUint64Array"})(p||(e.WebviewMessageArrayBufferViewType=p={}));var $;(function(a){a[a.Text=1]="Text",a[a.Error=2]="Error",a[a.Rich=3]="Rich"})($||(e.CellOutputKind=$={}));var w;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(w||(e.NotebookEditorRevealType=w={}));var A;(function(a){a[a.None=0]="None",a[a.Process=1]="Process",a[a.Output=2]="Output"})(A||(e.CandidatePortSource=A={}));class P{static mixin(m){return m._id=P.a++,m}}e.$rM=P,P.a=0;var b;(function(a){a.label="a",a.kind="b",a.detail="c",a.documentation="d",a.sortText="e",a.filterText="f",a.preselect="g",a.insertText="h",a.insertTextRules="i",a.range="j",a.commitCharacters="k",a.additionalTextEdits="l",a.kindModifier="m",a.commandIdent="n",a.commandId="o",a.commandArguments="p"})(b||(e.ISuggestDataDtoField=b={}));var C;(function(a){a.defaultRanges="a",a.completions="b",a.isIncomplete="c",a.duration="d"})(C||(e.ISuggestResultDtoField=C={}));var y;(function(a){a[a.Workspace=0]="Workspace",a[a.TextDocument=1]="TextDocument"})(y||(e.ExtHostTestingResource=y={})),e.$sM={MainThreadAuthentication:(0,o.$dw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,o.$dw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,o.$dw)("MainThreadLanguageModels"),MainThreadChatAgents2:(0,o.$dw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,o.$dw)("MainThreadChatVariables"),MainThreadClipboard:(0,o.$dw)("MainThreadClipboard"),MainThreadCommands:(0,o.$dw)("MainThreadCommands"),MainThreadComments:(0,o.$dw)("MainThreadComments"),MainThreadConfiguration:(0,o.$dw)("MainThreadConfiguration"),MainThreadConsole:(0,o.$dw)("MainThreadConsole"),MainThreadDebugService:(0,o.$dw)("MainThreadDebugService"),MainThreadDecorations:(0,o.$dw)("MainThreadDecorations"),MainThreadDiagnostics:(0,o.$dw)("MainThreadDiagnostics"),MainThreadDialogs:(0,o.$dw)("MainThreadDiaglogs"),MainThreadDocuments:(0,o.$dw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,o.$dw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,o.$dw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,o.$dw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,o.$dw)("MainThreadEditorTabs"),MainThreadErrors:(0,o.$dw)("MainThreadErrors"),MainThreadTreeViews:(0,o.$dw)("MainThreadTreeViews"),MainThreadDownloadService:(0,o.$dw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,o.$dw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,o.$dw)("MainThreadLanguages"),MainThreadLogger:(0,o.$dw)("MainThreadLogger"),MainThreadMessageService:(0,o.$dw)("MainThreadMessageService"),MainThreadOutputService:(0,o.$dw)("MainThreadOutputService"),MainThreadProgress:(0,o.$dw)("MainThreadProgress"),MainThreadQuickDiff:(0,o.$dw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,o.$dw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,o.$dw)("MainThreadStatusBar"),MainThreadSecretState:(0,o.$dw)("MainThreadSecretState"),MainThreadStorage:(0,o.$dw)("MainThreadStorage"),MainThreadSpeech:(0,o.$dw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,o.$dw)("MainThreadTelemetry"),MainThreadTerminalService:(0,o.$dw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,o.$dw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,o.$dw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,o.$dw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,o.$dw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,o.$dw)("MainThreadCustomEditors"),MainThreadUrls:(0,o.$dw)("MainThreadUrls"),MainThreadUriOpeners:(0,o.$dw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,o.$dw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,o.$dw)("MainThreadWorkspace"),MainThreadFileSystem:(0,o.$dw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,o.$dw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,o.$dw)("MainThreadExtensionService"),MainThreadSCM:(0,o.$dw)("MainThreadSCM"),MainThreadSearch:(0,o.$dw)("MainThreadSearch"),MainThreadShare:(0,o.$dw)("MainThreadShare"),MainThreadTask:(0,o.$dw)("MainThreadTask"),MainThreadWindow:(0,o.$dw)("MainThreadWindow"),MainThreadLabelService:(0,o.$dw)("MainThreadLabelService"),MainThreadNotebook:(0,o.$dw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,o.$dw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,o.$dw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,o.$dw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,o.$dw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,o.$dw)("MainThreadInteractive"),MainThreadChat:(0,o.$dw)("MainThreadChat"),MainThreadInlineChat:(0,o.$dw)("MainThreadInlineChatShape"),MainThreadTheming:(0,o.$dw)("MainThreadTheming"),MainThreadTunnelService:(0,o.$dw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,o.$dw)("MainThreadManagedSockets"),MainThreadTimeline:(0,o.$dw)("MainThreadTimeline"),MainThreadTesting:(0,o.$dw)("MainThreadTesting"),MainThreadLocalization:(0,o.$dw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,o.$dw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,o.$dw)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,o.$dw)("MainThreadIssueReporter")},e.$tM={ExtHostCommands:(0,o.$dw)("ExtHostCommands"),ExtHostConfiguration:(0,o.$dw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,o.$dw)("ExtHostDiagnostics"),ExtHostDebugService:(0,o.$dw)("ExtHostDebugService"),ExtHostDecorations:(0,o.$dw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,o.$dw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,o.$dw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,o.$dw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,o.$dw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,o.$dw)("ExtHostEditors"),ExtHostTreeViews:(0,o.$dw)("ExtHostTreeViews"),ExtHostFileSystem:(0,o.$dw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,o.$dw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,o.$dw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,o.$dw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,o.$dw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,o.$dw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,o.$dw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,o.$dw)("ExtHostStatusBar"),ExtHostShare:(0,o.$dw)("ExtHostShare"),ExtHostExtensionService:(0,o.$dw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,o.$dw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,o.$dw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,o.$dw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,o.$dw)("ExtHostSCM"),ExtHostSearch:(0,o.$dw)("ExtHostSearch"),ExtHostTask:(0,o.$dw)("ExtHostTask"),ExtHostWorkspace:(0,o.$dw)("ExtHostWorkspace"),ExtHostWindow:(0,o.$dw)("ExtHostWindow"),ExtHostWebviews:(0,o.$dw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,o.$dw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,o.$dw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,o.$dw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,o.$dw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,o.$dw)("ExtHostEditorTabs"),ExtHostProgress:(0,o.$dw)("ExtHostProgress"),ExtHostComments:(0,o.$dw)("ExtHostComments"),ExtHostSecretState:(0,o.$dw)("ExtHostSecretState"),ExtHostStorage:(0,o.$dw)("ExtHostStorage"),ExtHostUrls:(0,o.$dw)("ExtHostUrls"),ExtHostUriOpeners:(0,o.$dw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,o.$dw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,o.$dw)("ExtHostOutputService"),ExtHostLabelService:(0,o.$dw)("ExtHostLabelService"),ExtHostNotebook:(0,o.$dw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,o.$dw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,o.$dw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,o.$dw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,o.$dw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,o.$dw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,o.$dw)("ExtHostInteractive"),ExtHostInlineChat:(0,o.$dw)("ExtHostInlineChatShape"),ExtHostChat:(0,o.$dw)("ExtHostChat"),ExtHostChatAgents2:(0,o.$dw)("ExtHostChatAgents"),ExtHostChatVariables:(0,o.$dw)("ExtHostChatVariables"),ExtHostChatProvider:(0,o.$dw)("ExtHostChatProvider"),ExtHostSpeech:(0,o.$dw)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,o.$dw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,o.$dw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,o.$dw)("ExtHostTheming"),ExtHostTunnelService:(0,o.$dw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,o.$dw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,o.$dw)("ExtHostAuthentication"),ExtHostTimeline:(0,o.$dw)("ExtHostTimeline"),ExtHostTesting:(0,o.$dw)("ExtHostTesting"),ExtHostTelemetry:(0,o.$dw)("ExtHostTelemetry"),ExtHostLocalization:(0,o.$dw)("ExtHostLocalization"),ExtHostIssueReporter:(0,o.$dw)("ExtHostIssueReporter")}}),define(Ee[91],Ce([1,0,5,12,6,20]),function(re,e,o,R,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bjc=e.$Ajc=e.$zjc=void 0,e.$zjc=(0,o.$ii)("IExtHostApiDeprecationService");let O=class{constructor($,w){this.c=w,this.a=new Set,this.b=$.getProxy(I.$sM.MainThreadTelemetry)}report($,w,A){const P=this.d($,w);this.a.has(P)||(this.a.add(P),w.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${$}' is deprecated. ${A}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:w.identifier.value,apiId:$}))}d($,w){return`${$}-${w.identifier.value}`}};e.$Ajc=O,e.$Ajc=O=Qe([He(0,M.$OO),He(1,R.$Oj)],O),e.$Bjc=Object.freeze(new class{report(p,$,w){}})}),define(Ee[308],Ce([1,0,39,3,6]),function(re,e,o,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mjc=void 0;class M{constructor($,w){this.extension=$,this.provider=w,this.handle=M.a++}}M.a=0;class O{constructor($){this.b=new Map,this.c=new Map,this.d=$.getProxy(I.$sM.MainThreadChat)}registerChatProvider($,w,A){const P=new M($,A);return this.b.set(P.handle,P),this.d.$registerChatProvider(P.handle,w),(0,R.$Sc)(()=>{this.d.$unregisterChatProvider(P.handle),this.b.delete(P.handle)})}transferChatSession($,w){const A=o.Iterable.find(this.c.keys(),P=>this.c.get(P)===$)??0;typeof A=="number"&&this.d.$transferChatSession(A,w)}async $prepareChat($,w){const A=this.b.get($);if(!A)return;const P=await A.provider.prepareSession(w);if(!P)return;const b=O.a++;return this.c.set(b,P),{id:b}}$releaseSession($){this.c.delete($)}}e.$Mjc=O,O.a=0}),define(Ee[309],Ce([1,0,6]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rjc=void 0;class R{constructor(M){const O=M.getProxy(o.$sM.MainThreadClipboard);this.value=Object.freeze({readText(){return O.$readText()},writeText(p){return O.$writeText(p)}})}}e.$Rjc=R}),define(Ee[310],Ce([1,0,24,6,28,20]),function(re,e,o,R,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Klc=void 0;let O=class{constructor(A,P){this.a=A.getProxy(R.$sM.MainThreadConsole),this.b=P.consoleForward.includeStack,this.c=P.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(A,P){const b=this,C=console[A];Object.defineProperty(console,A,{set:()=>{},get:()=>function(){b.e(A,P,C,arguments)}})}e(A,P,b,C){this.a.$logExtensionHostMessage({type:"__$console",severity:P,arguments:$(C,this.b)}),this.c&&this.f(A,b,C)}};e.$Klc=O,e.$Klc=O=Qe([He(0,M.$OO),He(1,I.$5O)],O);const p=1e5;function $(w,A){const P=[];if(w.length)for(let b=0;b<w.length;b++){let C=w[b];if(typeof C>"u")C="undefined";else if(C instanceof Error){const y=C;y.stack?C=y.stack:C=y.toString()}P.push(C)}if(A){const b=new Error().stack;b&&P.push({__$stack:b.split(`
`).slice(3).join(`
`)})}try{const b=(0,o.$Un)(P);return b.length>p?"Output omitted for a large object that exceeds the limits":b}catch(b){return`Output omitted for an object that cannot be inspected ('${b.toString()}')`}}}),define(Ee[311],Ce([1,0,2,6,26]),function(re,e,o,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mkc=void 0;class M{constructor(p){this.a=p.getProxy(R.$sM.MainThreadDialogs)}showOpenDialog(p,$){return $?.allowUIResources&&(0,I.$dG)(p,"showLocal"),this.a.$showOpenDialog($).then(w=>w?w.map(A=>o.URI.revive(A)):void 0)}showSaveDialog(p){return this.a.$showSaveDialog(p).then($=>$?o.URI.revive($):void 0)}}e.$Mkc=M}),define(Ee[312],Ce([1,0,3,6]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8kc=void 0;class I{constructor(O){this.b=0,this.a=O.getProxy(R.$sM.MainThreadLabelService)}$registerResourceLabelFormatter(O){const p=this.b++;return this.a.$registerResourceLabelFormatter(p,O),(0,o.$Sc)(()=>{this.a.$unregisterResourceLabelFormatter(p)})}}e.$8kc=I}),define(Ee[116],Ce([1,0,11,14,2,5,12,6,28,20]),function(re,e,o,R,I,M,O,p,$,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vkc=e.$ukc=void 0;let A=class{constructor(b,C,y){this.f=y,this.d=new Map,this.a=C.getProxy(p.$sM.MainThreadLocalization),this.b=b.environment.appLanguage,this.c=this.b===o.$a}getMessage(b,C){const{message:y,args:a,comment:m}=C;if(this.c)return(0,R.$We)(y,a??{});let l=y;m&&m.length>0&&(l+=`/${Array.isArray(m)?m.join(""):m}`);const i=this.d.get(b)?.contents[l];return i||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${l}`),(0,R.$We)(i??y,a??{})}getBundle(b){return this.d.get(b)?.contents}getBundleUri(b){return this.d.get(b)?.uri}async initializeLocalizedMessages(b){if(this.c||!b.l10n&&!b.isBuiltin||this.d.has(b.identifier.value))return;let C;const y=await this.g(b);if(!y){this.f.error(`No bundle location found for extension ${b.identifier.value}`);return}try{const a=await this.a.$fetchBundleContents(y),m=JSON.parse(a);C=b.isBuiltin?m.contents?.bundle:m}catch(a){this.f.error(`Failed to load translations for ${b.identifier.value} from ${y}: ${a.message}`);return}C&&this.d.set(b.identifier.value,{contents:C,uri:y})}async g(b){if(b.isBuiltin){const C=await this.a.$fetchBuiltInBundleUri(b.identifier.value,this.b);return I.URI.revive(C)}return b.l10n?I.URI.joinPath(b.extensionLocation,b.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$ukc=A,e.$ukc=A=Qe([He(0,$.$5O),He(1,w.$OO),He(2,O.$Oj)],A),e.$vkc=(0,M.$ii)("IExtHostLocalizationService")}),define(Ee[150],Ce([1,0,12,6,28,20,2,57]),function(re,e,o,R,I,M,O,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jlc=void 0;let $=class extends o.$Zj{constructor(P,b){super(b.logLevel,b.logsLocation,b.loggers.map(C=>(0,p.$Rh)(C))),this.r=P.getProxy(R.$sM.MainThreadLogger)}$setLogLevel(P,b){b?this.setLogLevel(O.URI.revive(b),P):this.setLogLevel(P)}setVisibility(P,b){super.setVisibility(P,b),this.r.$setVisibility(P,b)}s(P,b,C){return new w(this.r,P,b,C)}};e.$Jlc=$,e.$Jlc=$=Qe([He(0,M.$OO),He(1,I.$5O)],$);class w extends o.$Uj{constructor(P,b,C,y){super(y?.logLevel==="always"),this.r=P,this.s=b,this.m=!1,this.n=[],this.setLevel(C),this.r.$createLogger(b,y).then(()=>{this.u(this.n),this.m=!0})}g(P,b){const C=[[P,b]];this.m?this.u(C):this.n.push(...C)}u(P){this.r.$log(this.s,P)}flush(){this.r.$flush(this.s)}}}),define(Ee[117],Ce([1,0,6,5,3,20,21]),function(re,e,o,R,I,M,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xkc=e.$wkc=void 0,e.$wkc=(0,R.$ii)("IExtHostManagedSockets");let p=class{constructor(P){this.b=0,this.c=null,this.d=new Map,this.a=P.getProxy(o.$sM.MainThreadManagedSockets)}setFactory(P,b){for(const C of this.d.values())C.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new $(P,b),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(P){if(!this.c||this.c.socketFactoryId!==P)throw new Error(`No socket factory with id ${P}`);const b=++this.b,C=await this.c.makeConnection(),y=new I.$Tc;return this.d.set(b,new w(b,C,y)),y.add((0,I.$Sc)(()=>this.d.delete(b))),y.add(C.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(b),y.dispose()})),y.add(C.onDidClose(a=>{this.a.$onDidManagedSocketClose(b,a?.stack??a?.message),y.dispose()})),y.add(C.onDidReceiveMessage(a=>this.a.$onDidManagedSocketHaveData(b,O.$ue.wrap(a)))),b}$remoteSocketWrite(P,b){this.d.get(P)?.actual.send(b.buffer)}$remoteSocketEnd(P){const b=this.d.get(P);b&&(b.actual.end(),b.dispose())}async $remoteSocketDrain(P){await this.d.get(P)?.actual.drain?.()}};e.$xkc=p,e.$xkc=p=Qe([He(0,M.$OO)],p);class ${constructor(P,b){this.socketFactoryId=P,this.makeConnection=b}}class w extends I.$Uc{constructor(P,b,C){super(),this.socketId=P,this.actual=b,this.B(C)}}}),define(Ee[313],Ce([1,0,6,12,26]),function(re,e,o,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0kc=void 0;function M(p){return p&&p.title}let O=class{constructor($,w){this.b=w,this.a=$.getProxy(o.$sM.MainThreadMessageService)}showMessage($,w,A,P,b){const C={source:{identifier:$.identifier,label:$.displayName||$.name}};let y;typeof P=="string"||M(P)?y=[P,...b]:(C.modal=P?.modal,C.useCustom=P?.useCustom,C.detail=P?.detail,y=b),C.useCustom&&(0,I.$dG)($,"resolvers");const a=[];let m=!1;for(let l=0;l<y.length;l++){const i=y[l];if(typeof i=="string")a.push({title:i,handle:l,isCloseAffordance:!1});else if(typeof i=="object"){const{title:n,isCloseAffordance:r}=i;a.push({title:n,isCloseAffordance:!!r,handle:l}),r&&(m?this.b.warn(`[${$.identifier}] Only one message item can have 'isCloseAffordance':`,i):m=!0)}else this.b.warn(`[${$.identifier}] Invalid message item:`,i)}return this.a.$showMessage(w,A,C,a).then(l=>{if(typeof l=="number")return y[l]})}};e.$0kc=O,e.$0kc=O=Qe([He(1,R.$Oj)],O)}),define(Ee[314],Ce([1,0,3,18,2,26,6]),function(re,e,o,R,I,M,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$glc=void 0;class p{constructor(w){this.b=new Map,this.a=w.getProxy(O.$sM.MainThreadProfileContentHandlers)}registerProfileContentHandler(w,A,P){if((0,M.$dG)(w,"profileContentHandlers"),this.b.has(A))throw new Error(`Handler with id '${A}' already registered`);return this.b.set(A,P),this.a.$registerProfileContentHandler(A,P.name,P.description,w.identifier.value),(0,o.$Sc)(()=>{this.b.delete(A),this.a.$unregisterProfileContentHandler(A)})}async $saveProfile(w,A,P,b){const C=this.b.get(w);if(!C)throw new Error(`Unknown handler with id: ${w}`);return C.saveProfile(A,P,b)}async $readProfile(w,A,P){const b=this.b.get(w);if(!b)throw new Error(`Unknown handler with id: ${w}`);return b.readProfile((0,R.$Vf)(A)?A:I.URI.revive(A),P)}}e.$glc=p}),define(Ee[118],Ce([1,0,6,4,5]),function(re,e,o,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$skc=e.$rkc=void 0;class M{constructor(p){this.b=new R.$7d,this.onDidChangePassword=this.b.event,this.a=p.getProxy(o.$sM.MainThreadSecretState)}async $onDidChangePassword(p){this.b.fire(p)}get(p,$){return this.a.$getPassword(p,$)}store(p,$,w){return this.a.$setPassword(p,$,w)}delete(p,$){return this.a.$deletePassword(p,$)}}e.$rkc=M,e.$skc=(0,I.$ii)("IExtHostSecretState")}),define(Ee[315],Ce([1,0,22,3,6]),function(re,e,o,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nlc=void 0;class M{constructor(p){this.c=new Map,this.d=new Map,this.b=p.getProxy(I.$sM.MainThreadSpeech)}async $createSpeechToTextSession(p,$,w){const A=this.c.get(p);if(!A)return;const P=new R.$Tc,b=new o.$ee;this.d.set($,b);const C=P.add(A.provideSpeechToTextSession(b.token,w?{language:w}:void 0));P.add(C.onDidChange(y=>{b.token.isCancellationRequested||this.b.$emitSpeechToTextEvent($,y)})),P.add(b.token.onCancellationRequested(()=>P.dispose()))}async $cancelSpeechToTextSession(p){this.d.get(p)?.dispose(!0),this.d.delete(p)}async $createKeywordRecognitionSession(p,$){const w=this.c.get(p);if(!w)return;const A=new R.$Tc,P=new o.$ee;this.d.set($,P);const b=A.add(w.provideKeywordRecognitionSession(P.token));A.add(b.onDidChange(C=>{P.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent($,C)})),A.add(P.token.onCancellationRequested(()=>A.dispose()))}async $cancelKeywordRecognitionSession(p){this.d.get(p)?.dispose(!0),this.d.delete(p)}registerProvider(p,$,w){const A=M.a++;return this.c.set(A,w),this.b.$registerProvider(A,$,{extension:p,displayName:p.value}),(0,R.$Sc)(()=>{this.b.$unregisterProvider(A),this.c.delete(A)})}}e.$nlc=M,M.a=1}),define(Ee[119],Ce([1,0,6,4,5]),function(re,e,o,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kkc=e.$jkc=void 0;class M{constructor(p,$){this.c=$,this.b=new R.$7d,this.onDidChangeStorage=this.b.event,this.a=p.getProxy(o.$sM.MainThreadStorage)}registerExtensionStorageKeysToSync(p,$){this.a.$registerExtensionStorageKeysToSync(p,$)}async initializeExtensionStorage(p,$,w){const A=await this.a.$initializeExtensionStorage(p,$);let P;return A&&(P=this.d(p,$,A)),P||w}setValue(p,$,w){return this.a.$setValue(p,$,w)}$acceptValue(p,$,w){const A=this.d(p,$,w);A&&this.b.fire({shared:p,key:$,value:A})}d(p,$,w){try{return JSON.parse(w)}catch(A){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${$}, global: ${p}): ${A}`)}}}e.$jkc=M,e.$kkc=(0,I.$ii)("IExtHostStorage")}),define(Ee[316],Ce([1,0,3,15,2,6]),function(re,e,o,R,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Blc=void 0;class O{constructor($){this.c=new Map,this.b=$.getProxy(M.$sM.MainThreadUriOpeners)}registerExternalUriOpener($,w,A,P){if(this.c.has(w))throw new Error(`Opener with id '${w}' already registered`);const b=P.schemes.find(C=>!O.a.has(C));if(b)throw new Error(`Scheme '${b}' is not supported. Only http and https are currently supported.`);return this.c.set(w,A),this.b.$registerUriOpener(w,P.schemes,$,P.label),(0,o.$Sc)(()=>{this.c.delete(w),this.b.$unregisterUriOpener(w)})}async $canOpenUri($,w,A){const P=this.c.get($);if(!P)throw new Error(`Unknown opener with id: ${$}`);const b=I.URI.revive(w);return P.canOpenExternalUri(b,A)}async $openUri($,w,A){const P=this.c.get($);if(!P)throw new Error(`Unknown opener id: '${$}'`);return P.openExternalUri(I.URI.revive(w.resolvedUri),{sourceUri:I.URI.revive(w.sourceUri)},A)}}e.$Blc=O,O.a=new Set([R.Schemas.http,R.Schemas.https])}),define(Ee[317],Ce([1,0,6,2,3,13,25]),function(re,e,o,R,I,M,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Clc=void 0;class p{constructor(w){this.c=new O.$Fm,this.d=new Map,this.b=w.getProxy(o.$sM.MainThreadUrls)}registerUriHandler(w,A){const P=w.identifier;if(this.c.has(P))throw new Error(`Protocol handler already registered for extension ${P}`);const b=p.a++;return this.c.add(P),this.d.set(b,A),this.b.$registerUriHandler(b,P,w.displayName||w.name),(0,I.$Sc)(()=>{this.c.delete(P),this.d.delete(b),this.b.$unregisterUriHandler(b)})}$handleExternalUri(w,A){const P=this.d.get(w);if(!P)return Promise.resolve(void 0);try{P.handleUri(R.URI.revive(A))}catch(b){(0,M.$1)(b)}return Promise.resolve(void 0)}async createAppUri(w){return R.URI.revive(await this.b.$createAppUri(w))}}e.$Clc=p,p.a=0});var it=this&&this.__classPrivateFieldSet||function(re,e,o,R,I){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!I:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?I.call(re,o):I?I.value=o:e.set(re,o),o},qe=this&&this.__classPrivateFieldGet||function(re,e,o,R){if(o==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!R:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?R:o==="a"?R.call(re):R?R.value:e.get(re)};define(Ee[92],Ce([1,0,4,3,15,24,2,246,284,114,6]),function(re,e,o,R,I,M,O,p,$,w,A){"use strict";var P,b,C,y,a,m,l,i,n,r,s,t,g;Object.defineProperty(e,"__esModule",{value:!0}),e.$9jc=e.$7jc=void 0,e.$8jc=h,e.$0jc=f,e.$$jc=E;class d{constructor(S,F,W,B,T,N,j){P.set(this,void 0),b.set(this,void 0),C.set(this,void 0),y.set(this,void 0),a.set(this,void 0),m.set(this,void 0),l.set(this,""),i.set(this,void 0),n.set(this,!1),r.set(this,!1),s.set(this,void 0),t.set(this,void 0),this._onMessageEmitter=new o.$7d,this.onDidReceiveMessage=this._onMessageEmitter.event,g.set(this,new o.$7d),this._onDidDispose=qe(this,g,"f").event,it(this,P,S,"f"),it(this,b,F,"f"),it(this,i,W,"f"),it(this,y,B,"f"),it(this,a,T,"f"),it(this,m,N,"f"),it(this,s,h(N),"f"),it(this,t,c(N),"f"),it(this,C,j,"f")}dispose(){it(this,n,!0,"f"),qe(this,g,"f").fire(),qe(this,g,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(S){return it(this,r,!0,"f"),(0,w.$Azb)(S,qe(this,y,"f"))}get cspSource(){const S=qe(this,m,"f").extensionLocation;if(S.scheme===I.Schemas.https||S.scheme===I.Schemas.http){let F=S.toString();return F.endsWith("/")||(F+="/"),F+" "+w.$zzb}return w.$zzb}get html(){return this.a(),qe(this,l,"f")}set html(S){this.a(),qe(this,l,"f")!==S&&(it(this,l,S,"f"),qe(this,t,"f")&&!qe(this,r,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(S)&&(it(this,r,!0,"f"),qe(this,C,"f").report("Webview vscode-resource: uris",qe(this,m,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),qe(this,b,"f").$setHtml(qe(this,P,"f"),this.b(S)))}get options(){return this.a(),qe(this,i,"f")}set options(S){this.a(),M.$Tn(qe(this,i,"f"),S)||qe(this,b,"f").$setOptions(qe(this,P,"f"),E(qe(this,m,"f"),qe(this,a,"f"),S)),it(this,i,S,"f")}async postMessage(S){if(qe(this,n,"f"))return!1;const F=(0,$.$Onb)(S,{serializeBuffersForPostMessage:qe(this,s,"f")});return qe(this,b,"f").$postMessage(qe(this,P,"f"),F.message,...F.buffers)}a(){if(qe(this,n,"f"))throw new Error("Webview is disposed")}b(S){if(!qe(this,t,"f"))return S;const F=qe(this,m,"f").extensionLocation?.scheme===I.Schemas.vscodeRemote,W=qe(this,m,"f").extensionLocation.scheme===I.Schemas.vscodeRemote?qe(this,m,"f").extensionLocation.authority:void 0;return S.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(B,T,N,j,L,z)=>{const Q=O.URI.from({scheme:j||"file",path:decodeURIComponent(L)}),Y=(0,w.$Azb)(Q,{isRemote:F,authority:W}).toString();return`${T}${Y}${z}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(B,T,N,j,L,z)=>{const Q=O.URI.from({scheme:j||"file",path:decodeURIComponent(L)}),Y=(0,w.$Azb)(Q,{isRemote:F,authority:W}).toString();return`${T}${Y}${z}`})}}e.$7jc=d,P=new WeakMap,b=new WeakMap,C=new WeakMap,y=new WeakMap,a=new WeakMap,m=new WeakMap,l=new WeakMap,i=new WeakMap,n=new WeakMap,r=new WeakMap,s=new WeakMap,t=new WeakMap,g=new WeakMap;function h(k){try{const S=(0,p.$vp)((0,p.$up)(k.engines.vscode));return!!S&&S.majorBase>=1&&S.minorBase>=57}catch{return!1}}function c(k){try{const S=(0,p.$vp)((0,p.$up)(k.engines.vscode));return S?S.majorBase<1||S.majorBase===1&&S.minorBase<60:!1}catch{return!1}}class u extends R.$Uc{constructor(S,F,W,B,T){super(),this.c=F,this.f=W,this.g=B,this.h=T,this.b=new Map,this.a=S.getProxy(A.$sM.MainThreadWebviews)}dispose(){super.dispose();for(const S of this.b.values())S.dispose();this.b.clear()}$onMessage(S,F,W){const B=this.j(S);if(B){const{message:T}=(0,$.$Pnb)(F,W.value);B._onMessageEmitter.fire(T)}}$onMissingCsp(S,F){this.g.warn(`${F} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(S,F,W){const B=new d(S,this.a,v(F),this.c,this.f,W,this.h);this.b.set(S,B);const T=B._onDidDispose(()=>{T.dispose(),this.deleteWebview(S)});return B}deleteWebview(S){this.b.delete(S)}j(S){return this.b.get(S)}}e.$9jc=u;function f(k){return{id:k.identifier,location:k.extensionLocation}}function E(k,S,F){return{enableCommandUris:F.enableCommandUris,enableScripts:F.enableScripts,enableForms:F.enableForms,portMapping:F.portMapping,localResourceRoots:F.localResourceRoots||D(k,S)}}function v(k){return{enableCommandUris:k.enableCommandUris,enableScripts:k.enableScripts,enableForms:k.enableForms,portMapping:k.portMapping,localResourceRoots:k.localResourceRoots?.map(S=>O.URI.from(S))}}function D(k,S){return[...(S?.getWorkspaceFolders()||[]).map(F=>F.uri),k.extensionLocation]}}),define(Ee[151],Ce([1,0,4,6,2,15,14,5,20,26]),function(re,e,o,R,I,M,O,p,$,w){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.$Flc=e.$Elc=void 0;let P=A=class{getState(C){const y=this.d;return{get focused(){return y.focused},get active(){return(0,w.$dG)(C,"windowActivity"),y.active}}}constructor(C){this.c=new o.$7d,this.onDidChangeWindowState=this.c.event,this.d=A.a,this.b=C.getProxy(R.$sM.MainThreadWindow),this.b.$getInitialState().then(({isFocused:y,isActive:a})=>{this.onDidChangeWindowProperty("focused",y),this.onDidChangeWindowProperty("active",a)})}$onDidChangeWindowFocus(C){this.onDidChangeWindowProperty("focused",C)}$onDidChangeWindowActive(C){this.onDidChangeWindowProperty("active",C)}onDidChangeWindowProperty(C,y){y!==this.d[C]&&(this.d={...this.d,[C]:y},this.c.fire(this.d))}openUri(C,y){let a;if(typeof C=="string"){a=C;try{C=I.URI.parse(C)}catch{return Promise.reject(`Invalid uri - '${C}'`)}}return(0,O.$Ue)(C.scheme)?Promise.reject("Invalid scheme - cannot be empty"):C.scheme===M.Schemas.command?Promise.reject(`Invalid scheme '${C.scheme}'`):this.b.$openUri(C,a,y)}async asExternalUri(C,y){if((0,O.$Ue)(C.scheme))return Promise.reject("Invalid scheme - cannot be empty");const a=await this.b.$asExternalUri(C,y);return I.URI.from(a)}};e.$Elc=P,P.a={focused:!0,active:!0},e.$Elc=P=A=Qe([He(0,$.$OO)],P),e.$Flc=(0,p.$ii)("IExtHostWindow")}),define(Ee[318],Ce([1,0,310,28,20]),function(re,e,o,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jmc=void 0;const M=1024*1024;let O=class extends o.$Klc{constructor($,w){super($,w),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f($,w,A){const P=$==="error"||$==="warn"?process.stderr:process.stdout;this.g=!0,P.write(`
START_NATIVE_LOG
`),w.apply(console,A),P.write(`
END_NATIVE_LOG
`),this.g=!1}j($,w){const A=process[$],P=A.write;let b="";Object.defineProperty(A,"write",{set:()=>{},get:()=>(C,y,a)=>{if(!this.g){b+=C.toString(y);const m=b.length>M?b.length:b.lastIndexOf(`
`);m!==-1&&(console[w](b.slice(0,m)),b=b.slice(m+1))}P.call(A,C,y,a)}})}};e.$jmc=O,e.$jmc=O=Qe([He(0,I.$OO),He(1,R.$5O)],O)}),define(Ee[319],Ce([1,0,150,15,261,30]),function(re,e,o,R,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vmc=void 0;class O extends o.$Jlc{s($,w,A){return $.scheme===R.Schemas.file?new I.$3P(A?.name||(0,M.$Eg)(),$.fsPath,!A?.donotRotate,!!A?.donotUseFormatters,w):super.s($,w,A)}registerLogger($){super.registerLogger($),this.r.$registerLogger($)}deregisterLogger($){super.deregisterLogger($),this.r.$deregisterLogger($)}}e.$vmc=O}),define(Ee[320],Ce([1,0,8,21,22,13,4,3,131,307,68]),function(re,e,o,R,I,M,O,p,$,w,A){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$y$b=e.ResponsiveState=e.RequestInitiator=void 0,e.$w$b=m,e.$x$b=l;function b(k,S){try{return JSON.stringify(k,S)}catch{return"null"}}const C="$$ref$$",y={[C]:-1};class a{constructor(S,F){this.jsonString=S,this.referencedBuffers=F}}function m(k,S=null,F=!1){const W=[];return{jsonString:(F?b:JSON.stringify)(k,(T,N)=>{if(typeof N>"u")return y;if(typeof N=="object"){if(N instanceof R.$ue){const j=W.push(N)-1;return{[C]:j}}if(S)return S(T,N)}return N}),referencedBuffers:W}}function l(k,S,F){return JSON.parse(k,(W,B)=>{if(B){const T=B[C];if(typeof T=="number")return S[T];if(F&&B.$mid===1)return F.transformIncoming(B)}return B})}function i(k,S){return JSON.stringify(k,S)}function n(k){return k?(S,F)=>F&&F.$mid===1?k.transformOutgoing(F):F:null}var r;(function(k){k[k.LocalSide=0]="LocalSide",k[k.OtherSide=1]="OtherSide"})(r||(e.RequestInitiator=r={}));var s;(function(k){k[k.Responsive=0]="Responsive",k[k.Unresponsive=1]="Unresponsive"})(s||(e.ResponsiveState=s={}));const t=()=>{},g=Symbol.for("rpcProtocol"),d=Symbol.for("rpcProxy");class h extends p.$Uc{constructor(S,F=null,W=null){super(),this[P]=!0,this.b=this.B(new O.$7d),this.onDidChangeResponsiveState=this.b.event,this.c=S,this.f=F,this.g=W,this.h=n(this.g),this.j=!1,this.m=[],this.s=[];for(let B=0,T=A.$cw.count;B<T;B++)this.m[B]=null,this.s[B]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new o.$uh(()=>this.H(),1e3)),this.c.onMessage(B=>this.L(B))}dispose(){this.j=!0,Object.keys(this.w).forEach(S=>{const F=this.w[S];delete this.w[S],F.resolveErr(M.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(S){this.z===0&&(this.C=Date.now()+h.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(S){this.C=Date.now()+h.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(S){this.y!==S&&(this.y=S,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(S){return this.g?(0,$.$on)(S,this.g):S}getProxy(S){const{nid:F,sid:W}=S;return this.s[F]||(this.s[F]=this.J(F,W)),this.s[F]}J(S,F){const W={get:(B,T)=>(typeof T=="string"&&!B[T]&&T.charCodeAt(0)===36&&(B[T]=(...N)=>this.U(S,T,N)),T===d?F:B[T])};return new Proxy(Object.create(null),W)}set(S,F){return this.m[S.nid]=F,F}assertRegistered(S){for(let F=0,W=S.length;F<W;F++){const B=S[F];if(!this.m[B.nid])throw new Error(`Missing proxy instance ${B.sid}`)}}L(S){if(this.j)return;const F=S.byteLength,W=u.read(S,0),B=W.readUInt8(),T=W.readUInt32();switch(B){case 1:case 2:{let{rpcId:N,method:j,args:L}=E.deserializeRequestJSONArgs(W);this.g&&(L=(0,$.$on)(L,this.g)),this.M(F,T,N,j,L,B===2);break}case 3:case 4:{let{rpcId:N,method:j,args:L}=E.deserializeRequestMixedArgs(W);this.g&&(L=(0,$.$on)(L,this.g)),this.M(F,T,N,j,L,B===4);break}case 5:{this.f?.logIncoming(F,T,0,"ack"),this.G(T);break}case 6:{this.N(F,T);break}case 7:{this.O(F,T,void 0);break}case 9:{let N=E.deserializeReplyOKJSON(W);this.g&&(N=(0,$.$on)(N,this.g)),this.O(F,T,N);break}case 10:{const N=E.deserializeReplyOKJSONWithBuffers(W,this.g);this.O(F,T,N);break}case 8:{const N=E.deserializeReplyOKVSBuffer(W);this.O(F,T,N);break}case 11:{let N=E.deserializeReplyErrError(W);this.g&&(N=(0,$.$on)(N,this.g)),this.P(F,T,N);break}case 12:{this.P(F,T,void 0);break}default:console.error("received unexpected message"),console.error(S)}}M(S,F,W,B,T,N){this.f?.logIncoming(S,F,1,`receiveRequest ${(0,A.$ew)(W)}.${B}(`,T);const j=String(F);let L,z;if(N){const Y=new I.$ee;T.push(Y.token),L=this.Q(W,B,T),z=()=>Y.cancel()}else L=this.Q(W,B,T),z=t;this.u[j]=z;const Q=E.serializeAcknowledged(F);this.f?.logOutgoing(Q.byteLength,F,1,"ack"),this.c.send(Q),L.then(Y=>{delete this.u[j];const J=E.serializeReplyOK(F,Y,this.h);this.f?.logOutgoing(J.byteLength,F,1,"reply:",Y),this.c.send(J)},Y=>{delete this.u[j];const J=E.serializeReplyErr(F,Y);this.f?.logOutgoing(J.byteLength,F,1,"replyErr:",Y),this.c.send(J)})}N(S,F){this.f?.logIncoming(S,F,1,"receiveCancel");const W=String(F);this.u[W]?.()}O(S,F,W){this.f?.logIncoming(S,F,0,"receiveReply:",W);const B=String(F);if(!this.w.hasOwnProperty(B))return;const T=this.w[B];delete this.w[B],T.resolveOk(W)}P(S,F,W){this.f?.logIncoming(S,F,0,"receiveReplyErr:",W);const B=String(F);if(!this.w.hasOwnProperty(B))return;const T=this.w[B];delete this.w[B];let N;W&&(W.$isError?(N=new Error,N.name=W.name,N.message=W.message,N.stack=W.stack):N=W),T.resolveErr(N)}Q(S,F,W){try{return Promise.resolve(this.S(S,F,W))}catch(B){return Promise.reject(B)}}S(S,F,W){const B=this.m[S];if(!B)throw new Error("Unknown actor "+(0,A.$ew)(S));const T=B[F];if(typeof T!="function")throw new Error("Unknown method "+F+" on actor "+(0,A.$ew)(S));return T.apply(B,W)}U(S,F,W){if(this.j)return new w.$v$b;let B=null;if(W.length>0&&I.CancellationToken.isCancellationToken(W[W.length-1])&&(B=W.pop()),B&&B.isCancellationRequested)return Promise.reject(M.$6());const T=E.serializeRequestArguments(W,this.h),N=++this.t,j=String(N),L=new w.$u$b,z=new p.$Tc;B&&z.add(B.onCancellationRequested(()=>{const Y=E.serializeCancel(N);this.f?.logOutgoing(Y.byteLength,N,0,"cancel"),this.c.send(E.serializeCancel(N))})),this.w[j]=new c(L,z),this.F(N);const Q=E.serializeRequest(N,S,F,T,!!B);return this.f?.logOutgoing(Q.byteLength,N,0,`request: ${(0,A.$ew)(S)}.${F}(`,W),this.c.send(Q),L}}e.$y$b=h,P=g,h.a=3*1e3;class c{constructor(S,F){this.a=S,this.b=F}resolveOk(S){this.a.resolveOk(S),this.b.dispose()}resolveErr(S){this.a.resolveErr(S),this.b.dispose()}}class u{static alloc(S,F,W){const B=new u(R.$ue.alloc(W+1+4),0);return B.writeUInt8(S),B.writeUInt32(F),B}static read(S,F){return new u(S,F)}get buffer(){return this.a}constructor(S,F){this.a=S,this.b=F}static sizeUInt8(){return 1}writeUInt8(S){this.a.writeUInt8(S,this.b),this.b+=1}readUInt8(){const S=this.a.readUInt8(this.b);return this.b+=1,S}writeUInt32(S){this.a.writeUInt32BE(S,this.b),this.b+=4}readUInt32(){const S=this.a.readUInt32BE(this.b);return this.b+=4,S}static sizeShortString(S){return 1+S.byteLength}writeShortString(S){this.a.writeUInt8(S.byteLength,this.b),this.b+=1,this.a.set(S,this.b),this.b+=S.byteLength}readShortString(){const S=this.a.readUInt8(this.b);this.b+=1;const W=this.a.slice(this.b,this.b+S).toString();return this.b+=S,W}static sizeLongString(S){return 4+S.byteLength}writeLongString(S){this.a.writeUInt32BE(S.byteLength,this.b),this.b+=4,this.a.set(S,this.b),this.b+=S.byteLength}readLongString(){const S=this.a.readUInt32BE(this.b);this.b+=4;const W=this.a.slice(this.b,this.b+S).toString();return this.b+=S,W}writeBuffer(S){this.a.writeUInt32BE(S.byteLength,this.b),this.b+=4,this.a.set(S,this.b),this.b+=S.byteLength}static sizeVSBuffer(S){return 4+S.byteLength}writeVSBuffer(S){this.a.writeUInt32BE(S.byteLength,this.b),this.b+=4,this.a.set(S,this.b),this.b+=S.byteLength}readVSBuffer(){const S=this.a.readUInt32BE(this.b);this.b+=4;const F=this.a.slice(this.b,this.b+S);return this.b+=S,F}static sizeMixedArray(S){let F=0;F+=1;for(let W=0,B=S.length;W<B;W++){const T=S[W];switch(F+=1,T.type){case 1:F+=this.sizeLongString(T.value);break;case 2:F+=this.sizeVSBuffer(T.value);break;case 3:F+=this.sizeUInt32,F+=this.sizeLongString(T.value);for(let N=0;N<T.buffers.length;++N)F+=this.sizeVSBuffer(T.buffers[N]);break;case 4:break}}return F}writeMixedArray(S){this.a.writeUInt8(S.length,this.b),this.b+=1;for(let F=0,W=S.length;F<W;F++){const B=S[F];switch(B.type){case 1:this.writeUInt8(1),this.writeLongString(B.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(B.value);break;case 3:this.writeUInt8(3),this.writeUInt32(B.buffers.length),this.writeLongString(B.value);for(let T=0;T<B.buffers.length;++T)this.writeBuffer(B.buffers[T]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const S=this.a.readUInt8(this.b);this.b+=1;const F=new Array(S);for(let W=0;W<S;W++)switch(this.readUInt8()){case 1:F[W]=this.readLongString();break;case 2:F[W]=this.readVSBuffer();break;case 3:{const T=this.readUInt32(),N=this.readLongString(),j=[];for(let L=0;L<T;++L)j.push(this.readVSBuffer());F[W]=new A.$fw(l(N,j,null));break}case 4:F[W]=void 0;break}return F}}u.sizeUInt32=4;var f;(function(k){k[k.Simple=0]="Simple",k[k.Mixed=1]="Mixed"})(f||(f={}));class E{static a(S){for(let F=0,W=S.length;F<W;F++)if(S[F]instanceof R.$ue||S[F]instanceof A.$fw||typeof S[F]>"u")return!0;return!1}static serializeRequestArguments(S,F){if(this.a(S)){const W=[];for(let B=0,T=S.length;B<T;B++){const N=S[B];if(N instanceof R.$ue)W[B]={type:2,value:N};else if(typeof N>"u")W[B]={type:4};else if(N instanceof A.$fw){const{jsonString:j,referencedBuffers:L}=m(N.value,F);W[B]={type:3,value:R.$ue.fromString(j),buffers:L}}else W[B]={type:1,value:R.$ue.fromString(i(N,F))}}return{type:1,args:W}}return{type:0,args:i(S,F)}}static serializeRequest(S,F,W,B,T){switch(B.type){case 0:return this.b(S,F,W,B.args,T);case 1:return this.c(S,F,W,B.args,T)}}static b(S,F,W,B,T){const N=R.$ue.fromString(W),j=R.$ue.fromString(B);let L=0;L+=u.sizeUInt8(),L+=u.sizeShortString(N),L+=u.sizeLongString(j);const z=u.alloc(T?2:1,S,L);return z.writeUInt8(F),z.writeShortString(N),z.writeLongString(j),z.buffer}static deserializeRequestJSONArgs(S){const F=S.readUInt8(),W=S.readShortString(),B=S.readLongString();return{rpcId:F,method:W,args:JSON.parse(B)}}static c(S,F,W,B,T){const N=R.$ue.fromString(W);let j=0;j+=u.sizeUInt8(),j+=u.sizeShortString(N),j+=u.sizeMixedArray(B);const L=u.alloc(T?4:3,S,j);return L.writeUInt8(F),L.writeShortString(N),L.writeMixedArray(B),L.buffer}static deserializeRequestMixedArgs(S){const F=S.readUInt8(),W=S.readShortString(),B=S.readMixedArray(),T=new Array(B.length);for(let N=0,j=B.length;N<j;N++){const L=B[N];typeof L=="string"?T[N]=JSON.parse(L):T[N]=L}return{rpcId:F,method:W,args:T}}static serializeAcknowledged(S){return u.alloc(5,S,0).buffer}static serializeCancel(S){return u.alloc(6,S,0).buffer}static serializeReplyOK(S,F,W){if(typeof F>"u")return this.d(S);if(F instanceof R.$ue)return this.e(S,F);if(F instanceof A.$fw){const{jsonString:B,referencedBuffers:T}=m(F.value,W,!0);return this.g(S,B,T)}else return this.f(S,b(F,W))}static d(S){return u.alloc(7,S,0).buffer}static e(S,F){let W=0;W+=u.sizeVSBuffer(F);const B=u.alloc(8,S,W);return B.writeVSBuffer(F),B.buffer}static deserializeReplyOKVSBuffer(S){return S.readVSBuffer()}static f(S,F){const W=R.$ue.fromString(F);let B=0;B+=u.sizeLongString(W);const T=u.alloc(9,S,B);return T.writeLongString(W),T.buffer}static g(S,F,W){const B=R.$ue.fromString(F);let T=0;T+=u.sizeUInt32,T+=u.sizeLongString(B);for(const j of W)T+=u.sizeVSBuffer(j);const N=u.alloc(10,S,T);N.writeUInt32(W.length),N.writeLongString(B);for(const j of W)N.writeBuffer(j);return N.buffer}static deserializeReplyOKJSON(S){const F=S.readLongString();return JSON.parse(F)}static deserializeReplyOKJSONWithBuffers(S,F){const W=S.readUInt32(),B=S.readLongString(),T=[];for(let N=0;N<W;++N)T.push(S.readVSBuffer());return new A.$fw(l(B,T,F))}static serializeReplyErr(S,F){const W=F?b(M.$3(F),null):void 0;if(typeof W!="string")return this.h(S);const B=R.$ue.fromString(W);let T=0;T+=u.sizeLongString(B);const N=u.alloc(11,S,T);return N.writeLongString(B),N.buffer}static deserializeReplyErrError(S){const F=S.readLongString();return JSON.parse(F)}static h(S){return u.alloc(12,S,0).buffer}}var v;(function(k){k[k.RequestJSONArgs=1]="RequestJSONArgs",k[k.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",k[k.RequestMixedArgs=3]="RequestMixedArgs",k[k.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",k[k.Acknowledged=5]="Acknowledged",k[k.Cancel=6]="Cancel",k[k.ReplyOKEmpty=7]="ReplyOKEmpty",k[k.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",k[k.ReplyOKJSON=9]="ReplyOKJSON",k[k.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",k[k.ReplyErrError=11]="ReplyErrError",k[k.ReplyErrEmpty=12]="ReplyErrEmpty"})(v||(v={}));var D;(function(k){k[k.String=1]="String",k[k.VSBuffer=2]="VSBuffer",k[k.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",k[k.Undefined=4]="Undefined"})(D||(D={}))}),define(Ee[321],Ce([1,0,21,27,15,84,5]),function(re,e,o,R,I,M,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0J=e.$7J=void 0,e.$8J=A,e.$9J=P,e.$7J=(0,O.$ii)("notebookDocumentService");const p=["W","X","Y","Z","a","b","c","d","e","f"],$=new RegExp(`^[${p.join("")}]+`),w=7;function A(C){if(C.scheme!==I.Schemas.vscodeNotebookCell)return;const y=C.fragment.indexOf("s");if(y<0)return;const a=parseInt(C.fragment.substring(0,y).replace($,""),w),m=(0,o.$Ne)(C.fragment.substring(y+1)).toString();if(!isNaN(a))return{handle:a,notebook:C.with({scheme:m,fragment:null})}}function P(C,y){const a=y.toString(w),l=`${a.length<p.length?p[a.length-1]:"z"}${a}s${(0,o.$Oe)(o.$ue.fromString(C.scheme),!0,!0)}`;return C.with({scheme:I.Schemas.vscodeNotebookCell,fragment:l})}class b{constructor(){this.a=new R.$Bc}getNotebook(y){if(y.scheme===I.Schemas.vscodeNotebookCell){const a=A(y);if(a){const m=this.a.get(a.notebook);if(m)return m}}return this.a.get(y)}addNotebookDocument(y){this.a.set(y.uri,y)}removeNotebookDocument(y){this.a.delete(y.uri)}}e.$0J=b,(0,M.$hs)(e.$7J,b,1)}),define(Ee[120],Ce([1,0,21,35,39,98,15,17,11,42,321]),function(re,e,o,R,I,M,O,p,$,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rK=e.$oK=e.CellStatusbarAlignment=e.$nK=e.NotebookEditorPriority=e.$kK=e.$jK=e.$hK=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$gK=e.$fK=e.$eK=e.$dK=e.CellKind=e.$cK=e.$bK=e.$aK=void 0,e.$iK=g,e.$lK=h,e.$mK=c,e.$pK=E,e.$qK=D,e.$aK="workbench.editor.notebook",e.$bK="workbench.editor.notebookTextDiffEditor",e.$cK="workbench.editor.interactive";var P;(function(L){L[L.Markup=1]="Markup",L[L.Code=2]="Code"})(P||(e.CellKind=P={})),e.$dK=["application/json","application/javascript","text/html","image/svg+xml",M.$As.latex,M.$As.markdown,"image/png","image/jpeg",M.$As.text],e.$eK=[M.$As.latex,M.$As.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",M.$As.text],e.$fK=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$gK="_notAvailable";var b;(function(L){L[L.Running=1]="Running",L[L.Idle=2]="Idle"})(b||(e.NotebookRunState=b={}));var C;(function(L){L[L.Unconfirmed=1]="Unconfirmed",L[L.Pending=2]="Pending",L[L.Executing=3]="Executing"})(C||(e.NotebookCellExecutionState=C={}));var y;(function(L){L[L.Unconfirmed=1]="Unconfirmed",L[L.Pending=2]="Pending",L[L.Executing=3]="Executing"})(y||(e.NotebookExecutionState=y={}));var a;(function(L){L[L.WithHardKernelDependency=0]="WithHardKernelDependency",L[L.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",L[L.Pure=2]="Pure",L[L.Never=3]="Never"})(a||(e.NotebookRendererMatch=a={}));var m;(function(L){L.Always="always",L.Never="never",L.Optional="optional"})(m||(e.RendererMessagingSpec=m={}));var l;(function(L){L[L.ModelChange=1]="ModelChange",L[L.Move=2]="Move",L[L.ChangeCellLanguage=5]="ChangeCellLanguage",L[L.Initialize=6]="Initialize",L[L.ChangeCellMetadata=7]="ChangeCellMetadata",L[L.Output=8]="Output",L[L.OutputItem=9]="OutputItem",L[L.ChangeCellContent=10]="ChangeCellContent",L[L.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",L[L.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",L[L.ChangeCellMime=13]="ChangeCellMime",L[L.Unknown=100]="Unknown"})(l||(e.NotebookCellsChangeType=l={}));var i;(function(L){L[L.Handle=0]="Handle",L[L.Index=1]="Index"})(i||(e.SelectionStateType=i={}));var n;(function(L){L[L.Replace=1]="Replace",L[L.Output=2]="Output",L[L.Metadata=3]="Metadata",L[L.CellLanguage=4]="CellLanguage",L[L.DocumentMetadata=5]="DocumentMetadata",L[L.Move=6]="Move",L[L.OutputItems=7]="OutputItems",L[L.PartialMetadata=8]="PartialMetadata",L[L.PartialInternalMetadata=9]="PartialInternalMetadata"})(n||(e.CellEditType=n={}));var r;(function(L){L.scheme=O.Schemas.vscodeNotebookCell;function z(te,pe){return(0,A.$9J)(te,pe)}L.generate=z;function Q(te){return(0,A.$8J)(te)}L.parse=Q;function Y(te,pe){return te.with({scheme:O.Schemas.vscodeNotebookCellOutput,fragment:`op${pe??""},${te.scheme!==O.Schemas.file?te.scheme:""}`})}L.generateCellOutputUri=Y;function J(te){if(te.scheme!==O.Schemas.vscodeNotebookCellOutput)return;const pe=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(te.fragment);if(!pe)return;const ye=pe[1]&&pe[1]!==""?pe[1]:void 0,_=pe[2];return{outputId:ye,notebook:te.with({scheme:_||O.Schemas.file,fragment:null})}}L.parseCellOutputUri=J;function x(te,pe,ye){return L.generate(te,pe).with({scheme:ye})}L.generateCellPropertyUri=x;function ce(te,pe){if(te.scheme===pe)return L.parse(te.with({scheme:L.scheme}))}L.parseCellPropertyUri=ce})(r||(e.CellUri=r={}));const s=L=>$.$c?L.replace(/\//g,"\\"):L;class t{constructor(z=[],Q=e.$dK){this.e=Q,this.d=[...new Set(z)].map(Y=>({pattern:Y,matches:R.$ck(s(Y))}))}sort(z){const Q=new Map(I.Iterable.map(z,J=>[J,s(J)]));let Y=[];for(const{matches:J}of this.d)for(const[x,ce]of Q)if(J(ce)){Y.push(x),Q.delete(x);break}return Q.size&&(Y=Y.concat([...Q.keys()].sort((J,x)=>this.e.indexOf(J)-this.e.indexOf(x)))),Y}prioritize(z,Q){const Y=this.f(z);if(Y===-1){this.d.unshift({pattern:z,matches:R.$ck(s(z))});return}const J=new Set(Q.map(ce=>this.f(ce,Y)));J.delete(-1);const x=Array.from(J).sort();this.d.splice(Y+1,0,...x.map(ce=>this.d[ce]));for(let ce=x.length-1;ce>=0;ce--)this.d.splice(x[ce],1)}toArray(){return this.d.map(z=>z.pattern)}f(z,Q=this.d.length){const Y=s(z);for(let J=0;J<Q;J++)if(this.d[J].matches(Y))return J;return-1}}e.$hK=t;function g(L,z,Q,Y=(J,x)=>J===x){const J=[];function x(pe,ye,_){if(ye===0&&_.length===0)return;const U=J[J.length-1];U&&U.start+U.deleteCount===pe?(U.deleteCount+=ye,U.toInsert.push(..._)):J.push({start:pe,deleteCount:ye,toInsert:_})}let ce=0,te=0;for(;;){if(ce===L.length){x(ce,0,z.slice(te));break}if(te===z.length){x(ce,L.length-ce,[]);break}const pe=L[ce],ye=z[te];if(Y(pe,ye)){ce+=1,te+=1;continue}Q(ye)?(x(ce,1,[]),ce+=1):(x(ce,0,[ye]),te+=1)}return J}e.$jK=new w.$zj("notebookEditorCursorAtBoundary","none"),e.$kK=new w.$zj("notebookEditorCursorAtLineBoundary","none");var d;(function(L){L.default="default",L.option="option"})(d||(e.NotebookEditorPriority=d={}));function h(L){const z=L;return!!((typeof z.include=="string"||R.$dk(z.include))&&(typeof z.exclude=="string"||R.$dk(z.exclude)))}function c(L,z,Q){if(Array.isArray(L.viewType)&&L.viewType.indexOf(z)>=0||L.viewType===z)return!0;if(L.filenamePattern){const Y=h(L.filenamePattern)?L.filenamePattern.include:L.filenamePattern,J=h(L.filenamePattern)?L.filenamePattern.exclude:void 0;if(R.$bk(Y,(0,p.$oc)(Q.fsPath).toLowerCase()))return!(J&&R.$bk(J,(0,p.$oc)(Q.fsPath).toLowerCase()))}return!1}e.$nK={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics"};var u;(function(L){L[L.Left=1]="Left",L[L.Right=2]="Right"})(u||(e.CellStatusbarAlignment=u={}));class f{static create(z){return`${f.d}${z}`}static parse(z){if(z.startsWith(f.d))return z.substring(f.d.length)}}e.$oK=f,f.d="notebook/";function E(L){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(L)}const v=new TextDecoder;function D(L){const z=[];let Q=!1;for(const ce of L)(z.length===0||Q)&&(z.push(ce),Q=!0);let Y=F(z);const J=o.$ue.concat(z.map(ce=>o.$ue.wrap(ce))),x=j(J);return Y=Y||x.byteLength!==J.byteLength,{data:x,didCompression:Y}}e.$rK="\x1B[A";const k=e.$rK.split("").map(L=>L.charCodeAt(0)),S=10;function F(L){let z=!1;return L.forEach((Q,Y)=>{if(Y===0||Q.length<e.$rK.length)return;const J=L[Y-1],x=Q.subarray(0,e.$rK.length);if(x[0]===k[0]&&x[1]===k[1]&&x[2]===k[2]){const ce=J.lastIndexOf(S);if(ce===-1)return;z=!0,L[Y-1]=J.subarray(0,ce),L[Y]=Q.subarray(e.$rK.length)}}),z}function W(L){let z=L;do L=z,z=L.replace(/[^\n]\x08/gm,"");while(z.length<L.length);return L}function B(L){for(L=L.replace(/\r+\n/gm,`
`);L.search(/\r[^$]/g)>-1;){const z=L.match(/^(.*)\r+/m)[1];let Q=L.match(/\r+(.*)$/m)[1];Q=Q+z.slice(Q.length,z.length),L=L.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,Q)}return L}const T=8,N=13;function j(L){return!L.buffer.includes(T)&&!L.buffer.includes(N)?L:o.$ue.fromString(B(W(v.decode(L.buffer))))}});var it=this&&this.__classPrivateFieldSet||function(re,e,o,R,I){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!I:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?I.call(re,o):I?I.value=o:e.set(re,o),o},qe=this&&this.__classPrivateFieldGet||function(re,e,o,R){if(o==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!R:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?R:o==="a"?R.call(re):R?R.value:e.get(re)};define(Ee[7],Ce([1,0,19,13,79,27,98,14,18,2,30,25,32,65,120]),function(re,e,o,R,I,M,O,p,$,w,A,P,b,C,y){"use strict";var a,m,l,i,n,r,s,t,g,d,h,c,u,f,E,v,D,k,S,F,W,B,T,N,j;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$CO=e.KeywordRecognitionStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$BO=e.$AO=e.$zO=e.$yO=e.ChatLocation=e.$xO=e.$wO=e.$vO=e.$uO=e.$tO=e.$sO=e.$rO=e.$qO=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$pO=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$oO=e.$nO=e.$mO=e.$lO=e.$kO=e.$jO=e.$iO=e.$hO=e.$gO=e.$fO=e.$eO=e.$dO=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$cO=e.$bO=e.$aO=e.$_N=e.$0N=e.$9N=e.$8N=e.$7N=e.TestRunProfileKind=e.TestResultState=e.$6N=e.$5N=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$4N=e.NotebookVariablesRequestKind=e.$3N=e.$2N=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$1N=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$ZN=e.$YN=e.$XN=e.$WN=e.$VN=e.ColorThemeKind=e.$UN=e.$TN=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$SN=e.$RN=e.DebugConsoleMode=e.$QN=e.$PN=e.$ON=e.$NN=e.$MN=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$LN=e.$KN=e.FileChangeType=e.$JN=e.NewSymbolNameTag=e.$IN=e.$HN=e.$GN=e.$FN=e.InlineCompletionTriggerKind=e.$EN=e.$DN=e.$CN=e.$BN=e.$AN=e.$zN=e.$yN=e.$xN=e.$wN=e.$vN=e.$uN=e.$sN=e.ConfigurationTarget=e.$rN=e.$qN=e.$pN=e.$oN=e.DocumentPasteTriggerKind=e.$nN=e.$mN=e.$lN=e.$kN=e.$jN=e.$iN=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$hN=e.ViewBadge=e.ProgressLocation=e.$gN=e.$fN=e.TaskScope=e.ShellQuoting=e.$eN=e.$dN=e.$cN=e.TaskPanelKind=e.TaskRevealKind=e.$bN=e.TerminalLocation=e.$aN=e.$_M=e.$$M=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$0M=e.$9M=e.$8M=e.$7M=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$5M=e.$4M=e.$3M=e.$2M=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$1M=e.$ZM=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$YM=e.$XM=e.$WM=e.$VM=e.$UM=e.LanguageStatusSeverity=e.$TM=e.$SM=e.$RM=e.$QM=e.$PM=e.$OM=e.CodeActionTriggerKind=e.$NM=e.$MM=e.SymbolTag=e.SymbolKind=e.$LM=e.$KM=e.DocumentHighlightKind=e.$JM=e.$IM=e.$HM=e.$GM=e.DiagnosticSeverity=e.DiagnosticTag=e.$FM=e.$EM=e.FileEditType=e.$DM=e.$CM=e.$BM=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$AM=e.$zM=e.$yM=e.$xM=e.$wM=e.$vM=e.$uM=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$6M=_t,e.$tN=an,e.$$N=Di;function L(K){return Object.assign(K,{apply:function(...$e){if($e.length===0)return Reflect.construct(K,[]);{const je=$e.length===1?[]:$e[1];return Reflect.construct(K,je,$e[0].constructor)}},call:function(...$e){if($e.length===0)return Reflect.construct(K,[]);{const[je,...xe]=$e;return Reflect.construct(K,xe,je.constructor)}}})}var z;(function(K){K[K.Top=0]="Top",K[K.Bottom=1]="Bottom"})(z||(e.TerminalOutputAnchor=z={}));var Q;(function(K){K[K.TerminalCommand=0]="TerminalCommand",K[K.Opener=1]="Opener",K[K.Command=3]="Command"})(Q||(e.TerminalQuickFixType=Q={}));let Y=g=class{static from(...q){let $e=q;return new g(function(){if($e){for(const je of $e)je&&typeof je.dispose=="function"&&je.dispose();$e=void 0}})}constructor(q){a.set(this,void 0),it(this,a,q,"f")}dispose(){typeof qe(this,a,"f")=="function"&&(qe(this,a,"f").call(this),it(this,a,void 0,"f"))}};e.$uM=Y,a=new WeakMap,e.$uM=Y=g=Qe([L],Y);let J=d=class{static Min(...q){if(q.length===0)throw new TypeError;let $e=q[0];for(let je=1;je<q.length;je++){const xe=q[je];xe.isBefore($e)&&($e=xe)}return $e}static Max(...q){if(q.length===0)throw new TypeError;let $e=q[0];for(let je=1;je<q.length;je++){const xe=q[je];xe.isAfter($e)&&($e=xe)}return $e}static isPosition(q){if(!q)return!1;if(q instanceof d)return!0;const{line:$e,character:je}=q;return typeof $e=="number"&&typeof je=="number"}static of(q){if(q instanceof d)return q;if(this.isPosition(q))return new d(q.line,q.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(q,$e){if(q<0)throw(0,R.$7)("line must be non-negative");if($e<0)throw(0,R.$7)("character must be non-negative");this.c=q,this.e=$e}isBefore(q){return this.c<q.c?!0:q.c<this.c?!1:this.e<q.e}isBeforeOrEqual(q){return this.c<q.c?!0:q.c<this.c?!1:this.e<=q.e}isAfter(q){return!this.isBeforeOrEqual(q)}isAfterOrEqual(q){return!this.isBefore(q)}isEqual(q){return this.c===q.c&&this.e===q.e}compareTo(q){return this.c<q.c?-1:this.c>q.line?1:this.e<q.e?-1:this.e>q.e?1:0}translate(q,$e=0){if(q===null||$e===null)throw(0,R.$7)();let je;return typeof q>"u"?je=0:typeof q=="number"?je=q:(je=typeof q.lineDelta=="number"?q.lineDelta:0,$e=typeof q.characterDelta=="number"?q.characterDelta:0),je===0&&$e===0?this:new d(this.line+je,this.character+$e)}with(q,$e=this.character){if(q===null||$e===null)throw(0,R.$7)();let je;return typeof q>"u"?je=this.line:typeof q=="number"?je=q:(je=typeof q.line=="number"?q.line:this.line,$e=typeof q.character=="number"?q.character:this.character),je===this.line&&$e===this.character?this:new d(je,$e)}toJSON(){return{line:this.line,character:this.character}}};e.$vM=J,e.$vM=J=d=Qe([L],J);let x=h=class{static isRange(q){return q instanceof h?!0:q?J.isPosition(q.start)&&J.isPosition(q.end):!1}static of(q){if(q instanceof h)return q;if(this.isRange(q))return new h(q.start,q.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(q,$e,je,xe){let rt,ft;if(typeof q=="number"&&typeof $e=="number"&&typeof je=="number"&&typeof xe=="number"?(rt=new J(q,$e),ft=new J(je,xe)):J.isPosition(q)&&J.isPosition($e)&&(rt=J.of(q),ft=J.of($e)),!rt||!ft)throw new Error("Invalid arguments");rt.isBefore(ft)?(this.c=rt,this.e=ft):(this.c=ft,this.e=rt)}contains(q){return h.isRange(q)?this.contains(q.start)&&this.contains(q.end):J.isPosition(q)?!(J.of(q).isBefore(this.c)||this.e.isBefore(q)):!1}isEqual(q){return this.c.isEqual(q.c)&&this.e.isEqual(q.e)}intersection(q){const $e=J.Max(q.start,this.c),je=J.Min(q.end,this.e);if(!$e.isAfter(je))return new h($e,je)}union(q){if(this.contains(q))return this;if(q.contains(this))return q;const $e=J.Min(q.start,this.c),je=J.Max(q.end,this.end);return new h($e,je)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(q,$e=this.end){if(q===null||$e===null)throw(0,R.$7)();let je;return q?J.isPosition(q)?je=q:(je=q.start||this.start,$e=q.end||this.end):je=this.start,je.isEqual(this.c)&&$e.isEqual(this.end)?this:new h(je,$e)}toJSON(){return[this.start,this.end]}};e.$wM=x,e.$wM=x=h=Qe([L],x);let ce=c=class extends x{static isSelection(q){return q instanceof c?!0:q?x.isRange(q)&&J.isPosition(q.anchor)&&J.isPosition(q.active)&&typeof q.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(q,$e,je,xe){let rt,ft;if(typeof q=="number"&&typeof $e=="number"&&typeof je=="number"&&typeof xe=="number"?(rt=new J(q,$e),ft=new J(je,xe)):J.isPosition(q)&&J.isPosition($e)&&(rt=J.of(q),ft=J.of($e)),!rt||!ft)throw new Error("Invalid arguments");super(rt,ft),this.f=rt,this.g=ft}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$xM=ce,e.$xM=ce=c=Qe([L],ce);const te=K=>{if(typeof K!="string"||K.length===0||!/^[0-9A-Za-z_\-]+$/.test(K))throw(0,R.$7)("connectionToken")};class pe{static isResolvedAuthority(q){return q&&typeof q=="object"&&typeof q.host=="string"&&typeof q.port=="number"&&(q.connectionToken===void 0||typeof q.connectionToken=="string")}constructor(q,$e,je){if(typeof q!="string"||q.length===0)throw(0,R.$7)("host");if(typeof $e!="number"||$e===0||Math.round($e)!==$e)throw(0,R.$7)("port");typeof je<"u"&&te(je),this.host=q,this.port=Math.round($e),this.connectionToken=je}}e.$yM=pe;class ye{static isManagedResolvedAuthority(q){return q&&typeof q=="object"&&typeof q.makeConnection=="function"&&(q.connectionToken===void 0||typeof q.connectionToken=="string")}constructor(q,$e){this.makeConnection=q,this.connectionToken=$e,typeof $e<"u"&&te($e)}}e.$zM=ye;class _ extends Error{static NotAvailable(q,$e){return new _(q,C.RemoteAuthorityResolverErrorCode.NotAvailable,$e)}static TemporarilyNotAvailable(q){return new _(q,C.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(q,$e=C.RemoteAuthorityResolverErrorCode.Unknown,je){super(q),this._message=q,this._code=$e,this._detail=je,Object.setPrototypeOf(this,_.prototype)}}e.$AM=_;var U;(function(K){K[K.LF=1]="LF",K[K.CRLF=2]="CRLF"})(U||(e.EndOfLine=U={}));var he;(function(K){K[K.Replace=1]="Replace",K[K.Append=2]="Append",K[K.Prepend=3]="Prepend"})(he||(e.EnvironmentVariableMutatorType=he={}));let Se=u=class{static isTextEdit(q){return q instanceof u?!0:q?x.isRange(q)&&typeof q.newText=="string":!1}static replace(q,$e){return new u(q,$e)}static insert(q,$e){return u.replace(new x(q,q),$e)}static delete(q){return u.replace(q,"")}static setEndOfLine(q){const $e=new u(new x(new J(0,0),new J(0,0)),"");return $e.newEol=q,$e}get range(){return this.c}set range(q){if(q&&!x.isRange(q))throw(0,R.$7)("range");this.c=q}get newText(){return this.e||""}set newText(q){if(q&&typeof q!="string")throw(0,R.$7)("newText");this.e=q}get newEol(){return this.f}set newEol(q){if(q&&typeof q!="number")throw(0,R.$7)("newEol");this.f=q}constructor(q,$e){this.c=q,this.e=$e}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$BM=Se,e.$BM=Se=u=Qe([L],Se);let me=f=class{static isNotebookCellEdit(q){return q instanceof f?!0:q?pn.isNotebookRange(q)&&Array.isArray(q.newCells):!1}static replaceCells(q,$e){return new f(q,$e)}static insertCells(q,$e){return new f(new pn(q,q),$e)}static deleteCells(q){return new f(q,[])}static updateCellMetadata(q,$e){const je=new f(new pn(q,q),[]);return je.newCellMetadata=$e,je}static updateNotebookMetadata(q){const $e=new f(new pn(0,0),[]);return $e.newNotebookMetadata=q,$e}constructor(q,$e){this.range=q,this.newCells=$e}};e.$CM=me,e.$CM=me=f=Qe([L],me);class ie{static isSnippetTextEdit(q){return q instanceof ie?!0:q?x.isRange(q.range)&&G.isSnippetString(q.snippet):!1}static replace(q,$e){return new ie(q,$e)}static insert(q,$e){return ie.replace(new x(q,q),$e)}constructor(q,$e){this.range=q,this.snippet=$e}}e.$DM=ie;var se;(function(K){K[K.File=1]="File",K[K.Text=2]="Text",K[K.Cell=3]="Cell",K[K.CellReplace=5]="CellReplace",K[K.Snippet=6]="Snippet"})(se||(e.FileEditType=se={}));let oe=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(q,$e,je,xe){this.c.push({_type:1,from:q,to:$e,options:je,metadata:xe})}createFile(q,$e,je){this.c.push({_type:1,from:void 0,to:q,options:$e,metadata:je})}deleteFile(q,$e,je){this.c.push({_type:1,from:q,to:void 0,options:$e,metadata:je})}e(q,$e,je){this.c.push({_type:3,metadata:je,uri:q,edit:{editType:5,metadata:$e},notebookMetadata:$e})}f(q,$e,je,xe){const rt=$e.start,ft=$e.end;(rt!==ft||je.length>0)&&this.c.push({_type:5,uri:q,index:rt,count:ft-rt,cells:je,metadata:xe})}g(q,$e,je,xe){this.c.push({_type:3,metadata:xe,uri:q,edit:{editType:3,index:$e,metadata:je}})}replace(q,$e,je,xe){this.c.push({_type:2,uri:q,edit:new Se($e,je),metadata:xe})}insert(q,$e,je,xe){this.replace(q,new x($e,$e),je,xe)}delete(q,$e,je){this.replace(q,$e,"",je)}has(q){return this.c.some($e=>$e._type===2&&$e.uri.toString()===q.toString())}set(q,$e){if($e)for(const je of $e){if(!je)continue;let xe,rt;Array.isArray(je)?(xe=je[0],rt=je[1]):xe=je,me.isNotebookCellEdit(xe)?xe.newCellMetadata?this.g(q,xe.range.start,xe.newCellMetadata,rt):xe.newNotebookMetadata?this.e(q,xe.newNotebookMetadata,rt):this.f(q,xe.range,xe.newCells,rt):ie.isSnippetTextEdit(xe)?this.c.push({_type:6,uri:q,range:xe.range,edit:xe.snippet,metadata:rt}):this.c.push({_type:2,uri:q,edit:xe,metadata:rt})}else{for(let je=0;je<this.c.length;je++){const xe=this.c[je];switch(xe._type){case 2:case 6:case 3:case 5:xe.uri.toString()===q.toString()&&(this.c[je]=void 0);break}}(0,o.$Ib)(this.c)}}get(q){const $e=[];for(const je of this.c)je._type===2&&je.uri.toString()===q.toString()&&$e.push(je.edit);return $e}entries(){const q=new M.$Bc;for(const $e of this.c)if($e._type===2){let je=q.get($e.uri);je||(je=[$e.uri,[]],q.set($e.uri,je)),je[1].push($e.edit)}return[...q.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$EM=oe,e.$EM=oe=Qe([L],oe);let G=E=class{static isSnippetString(q){return q instanceof E?!0:q?typeof q.value=="string":!1}static c(q){return q.replace(/\$|}|\\/g,"\\$&")}constructor(q){this.e=1,this.value=q||""}appendText(q){return this.value+=E.c(q),this}appendTabstop(q=this.e++){return this.value+="$",this.value+=q,this}appendPlaceholder(q,$e=this.e++){if(typeof q=="function"){const je=new E;je.e=this.e,q(je),this.e=je.e,q=je.value}else q=E.c(q);return this.value+="${",this.value+=$e,this.value+=":",this.value+=q,this.value+="}",this}appendChoice(q,$e=this.e++){const je=q.map(xe=>xe.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=$e,this.value+="|",this.value+=je,this.value+="|}",this}appendVariable(q,$e){if(typeof $e=="function"){const je=new E;je.e=this.e,$e(je),this.e=je.e,$e=je.value}else typeof $e=="string"&&($e=$e.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=q,$e&&(this.value+=":",this.value+=$e),this.value+="}",this}};e.$FM=G,e.$FM=G=E=Qe([L],G);var ee;(function(K){K[K.Unnecessary=1]="Unnecessary",K[K.Deprecated=2]="Deprecated"})(ee||(e.DiagnosticTag=ee={}));var le;(function(K){K[K.Hint=3]="Hint",K[K.Information=2]="Information",K[K.Warning=1]="Warning",K[K.Error=0]="Error"})(le||(e.DiagnosticSeverity=le={}));let de=v=class{static isLocation(q){return q instanceof v?!0:q?x.isRange(q.range)&&w.URI.isUri(q.uri):!1}constructor(q,$e){if(this.uri=q,$e)if(x.isRange($e))this.range=x.of($e);else if(J.isPosition($e))this.range=new x($e,$e);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$GM=de,e.$GM=de=v=Qe([L],de);let Me=class{static is(q){return q?typeof q.message=="string"&&q.location&&x.isRange(q.location.range)&&w.URI.isUri(q.location.uri):!1}constructor(q,$e){this.location=q,this.message=$e}static isEqual(q,$e){return q===$e?!0:!q||!$e?!1:q.message===$e.message&&q.location.range.isEqual($e.location.range)&&q.location.uri.toString()===$e.location.uri.toString()}};e.$HM=Me,e.$HM=Me=Qe([L],Me);let be=class{constructor(q,$e,je=le.Error){if(!x.isRange(q))throw new TypeError("range must be set");if(!$e)throw new TypeError("message must be set");this.range=q,this.message=$e,this.severity=je}toJSON(){return{severity:le[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(q,$e){return q===$e?!0:!q||!$e?!1:q.message===$e.message&&q.severity===$e.severity&&q.code===$e.code&&q.severity===$e.severity&&q.source===$e.source&&q.range.isEqual($e.range)&&(0,o.$ub)(q.tags,$e.tags)&&(0,o.$ub)(q.relatedInformation,$e.relatedInformation,Me.isEqual)}};e.$IM=be,e.$IM=be=Qe([L],be);let Pe=class{constructor(q,$e){if(!q)throw new Error("Illegal argument, contents must be defined");Array.isArray(q)?this.contents=q:this.contents=[q],this.range=$e}};e.$JM=Pe,e.$JM=Pe=Qe([L],Pe);var Re;(function(K){K[K.Text=0]="Text",K[K.Read=1]="Read",K[K.Write=2]="Write"})(Re||(e.DocumentHighlightKind=Re={}));let ze=class{constructor(q,$e=Re.Text){this.range=q,this.kind=$e}toJSON(){return{range:this.range,kind:Re[this.kind]}}};e.$KM=ze,e.$KM=ze=Qe([L],ze);let V=class{constructor(q,$e){this.uri=q,this.highlights=$e}toJSON(){return{uri:this.uri,highlights:this.highlights.map(q=>q.toJSON())}}};e.$LM=V,e.$LM=V=Qe([L],V);var H;(function(K){K[K.File=0]="File",K[K.Module=1]="Module",K[K.Namespace=2]="Namespace",K[K.Package=3]="Package",K[K.Class=4]="Class",K[K.Method=5]="Method",K[K.Property=6]="Property",K[K.Field=7]="Field",K[K.Constructor=8]="Constructor",K[K.Enum=9]="Enum",K[K.Interface=10]="Interface",K[K.Function=11]="Function",K[K.Variable=12]="Variable",K[K.Constant=13]="Constant",K[K.String=14]="String",K[K.Number=15]="Number",K[K.Boolean=16]="Boolean",K[K.Array=17]="Array",K[K.Object=18]="Object",K[K.Key=19]="Key",K[K.Null=20]="Null",K[K.EnumMember=21]="EnumMember",K[K.Struct=22]="Struct",K[K.Event=23]="Event",K[K.Operator=24]="Operator",K[K.TypeParameter=25]="TypeParameter"})(H||(e.SymbolKind=H={}));var Z;(function(K){K[K.Deprecated=1]="Deprecated"})(Z||(e.SymbolTag=Z={}));let X=D=class{static validate(q){if(!q.name)throw new Error("name must not be falsy")}constructor(q,$e,je,xe,rt){this.name=q,this.kind=$e,this.containerName=rt,typeof je=="string"&&(this.containerName=je),xe instanceof de?this.location=xe:je instanceof x&&(this.location=new de(xe,je)),D.validate(this)}toJSON(){return{name:this.name,kind:H[this.kind],location:this.location,containerName:this.containerName}}};e.$MM=X,e.$MM=X=D=Qe([L],X);let fe=k=class{static validate(q){if(!q.name)throw new Error("name must not be falsy");if(!q.range.contains(q.selectionRange))throw new Error("selectionRange must be contained in fullRange");q.children?.forEach(k.validate)}constructor(q,$e,je,xe,rt){this.name=q,this.detail=$e,this.kind=je,this.range=xe,this.selectionRange=rt,this.children=[],k.validate(this)}};e.$NM=fe,e.$NM=fe=k=Qe([L],fe);var we;(function(K){K[K.Invoke=1]="Invoke",K[K.Automatic=2]="Automatic"})(we||(e.CodeActionTriggerKind=we={}));let Te=class{constructor(q,$e){this.title=q,this.kind=$e}};e.$OM=Te,e.$OM=Te=Qe([L],Te);let Ve=S=class{constructor(q){this.value=q}append(q){return new S(this.value?this.value+S.c+q:q)}intersects(q){return this.contains(q)||q.contains(this)}contains(q){return this.value===q.value||q.value.startsWith(this.value+S.c)}};e.$PM=Ve,Ve.c=".",e.$PM=Ve=S=Qe([L],Ve),Ve.Empty=new Ve(""),Ve.QuickFix=Ve.Empty.append("quickfix"),Ve.Refactor=Ve.Empty.append("refactor"),Ve.RefactorExtract=Ve.Refactor.append("extract"),Ve.RefactorInline=Ve.Refactor.append("inline"),Ve.RefactorMove=Ve.Refactor.append("move"),Ve.RefactorRewrite=Ve.Refactor.append("rewrite"),Ve.Source=Ve.Empty.append("source"),Ve.SourceOrganizeImports=Ve.Source.append("organizeImports"),Ve.SourceFixAll=Ve.Source.append("fixAll"),Ve.Notebook=Ve.Empty.append("notebook");let Ze=class{constructor(q,$e){if(this.range=q,this.parent=$e,$e&&!$e.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$QM=Ze,e.$QM=Ze=Qe([L],Ze);class nt{constructor(q,$e,je,xe,rt,ft){this.kind=q,this.name=$e,this.detail=je,this.uri=xe,this.range=rt,this.selectionRange=ft}}e.$RM=nt;class ot{constructor(q,$e){this.fromRanges=$e,this.from=q}}e.$SM=ot;class lt{constructor(q,$e){this.fromRanges=$e,this.to=q}}e.$TM=lt;var at;(function(K){K[K.Information=0]="Information",K[K.Warning=1]="Warning",K[K.Error=2]="Error"})(at||(e.LanguageStatusSeverity=at={}));let st=class{constructor(q,$e){this.range=q,this.command=$e}get isResolved(){return!!this.command}};e.$UM=st,e.$UM=st=Qe([L],st);let Ie=F=class{static isMarkdownString(q){return q instanceof F?!0:q&&q.appendCodeblock&&q.appendMarkdown&&q.appendText&&q.value!==void 0}constructor(q,$e=!1){m.set(this,void 0),it(this,m,new I.$Fk(q,{supportThemeIcons:$e}),"f")}get value(){return qe(this,m,"f").value}set value(q){qe(this,m,"f").value=q}get isTrusted(){return qe(this,m,"f").isTrusted}set isTrusted(q){qe(this,m,"f").isTrusted=q}get supportThemeIcons(){return qe(this,m,"f").supportThemeIcons}set supportThemeIcons(q){qe(this,m,"f").supportThemeIcons=q}get supportHtml(){return qe(this,m,"f").supportHtml}set supportHtml(q){qe(this,m,"f").supportHtml=q}get baseUri(){return qe(this,m,"f").baseUri}set baseUri(q){qe(this,m,"f").baseUri=q}appendText(q){return qe(this,m,"f").appendText(q),this}appendMarkdown(q){return qe(this,m,"f").appendMarkdown(q),this}appendCodeblock(q,$e){return qe(this,m,"f").appendCodeblock($e??"",q),this}};e.$VM=Ie,m=new WeakMap,e.$VM=Ie=F=Qe([L],Ie);let We=class{constructor(q,$e){this.label=q,this.documentation=$e}};e.$WM=We,e.$WM=We=Qe([L],We);let Ae=class{constructor(q,$e){this.label=q,this.documentation=$e,this.parameters=[]}};e.$XM=Ae,e.$XM=Ae=Qe([L],Ae);let Ke=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$YM=Ke,e.$YM=Ke=Qe([L],Ke);var ae;(function(K){K[K.Invoke=1]="Invoke",K[K.TriggerCharacter=2]="TriggerCharacter",K[K.ContentChange=3]="ContentChange"})(ae||(e.SignatureHelpTriggerKind=ae={}));var ue;(function(K){K[K.Type=1]="Type",K[K.Parameter=2]="Parameter"})(ue||(e.InlayHintKind=ue={}));let De=class{constructor(q){this.value=q}};e.$ZM=De,e.$ZM=De=Qe([L],De);let Je=class{constructor(q,$e,je){this.position=q,this.label=$e,this.kind=je}};e.$1M=Je,e.$1M=Je=Qe([L],Je);var et;(function(K){K[K.Invoke=0]="Invoke",K[K.TriggerCharacter=1]="TriggerCharacter",K[K.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(et||(e.CompletionTriggerKind=et={}));var Ne;(function(K){K[K.Text=0]="Text",K[K.Method=1]="Method",K[K.Function=2]="Function",K[K.Constructor=3]="Constructor",K[K.Field=4]="Field",K[K.Variable=5]="Variable",K[K.Class=6]="Class",K[K.Interface=7]="Interface",K[K.Module=8]="Module",K[K.Property=9]="Property",K[K.Unit=10]="Unit",K[K.Value=11]="Value",K[K.Enum=12]="Enum",K[K.Keyword=13]="Keyword",K[K.Snippet=14]="Snippet",K[K.Color=15]="Color",K[K.File=16]="File",K[K.Reference=17]="Reference",K[K.Folder=18]="Folder",K[K.EnumMember=19]="EnumMember",K[K.Constant=20]="Constant",K[K.Struct=21]="Struct",K[K.Event=22]="Event",K[K.Operator=23]="Operator",K[K.TypeParameter=24]="TypeParameter",K[K.User=25]="User",K[K.Issue=26]="Issue"})(Ne||(e.CompletionItemKind=Ne={}));var ht;(function(K){K[K.Deprecated=1]="Deprecated"})(ht||(e.CompletionItemTag=ht={}));let vt=class{constructor(q,$e){this.label=q,this.kind=$e}toJSON(){return{label:this.label,kind:this.kind&&Ne[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$2M=vt,e.$2M=vt=Qe([L],vt);let Mt=class{constructor(q=[],$e=!1){this.items=q,this.isIncomplete=$e}};e.$3M=Mt,e.$3M=Mt=Qe([L],Mt);let zt=class{constructor(q,$e,je){this.insertText=q,this.range=$e,this.command=je}};e.$4M=zt,e.$4M=zt=Qe([L],zt);let Zt=class{constructor(q){this.commands=void 0,this.suppressSuggestions=void 0,this.items=q}};e.$5M=Zt,e.$5M=Zt=Qe([L],Zt);var xt;(function(K){K[K.Unknown=0]="Unknown",K[K.Word=1]="Word",K[K.Line=2]="Line",K[K.Suggest=3]="Suggest"})(xt||(e.PartialAcceptTriggerKind=xt={}));var Pt;(function(K){K[K.Active=-1]="Active",K[K.Beside=-2]="Beside",K[K.One=1]="One",K[K.Two=2]="Two",K[K.Three=3]="Three",K[K.Four=4]="Four",K[K.Five=5]="Five",K[K.Six=6]="Six",K[K.Seven=7]="Seven",K[K.Eight=8]="Eight",K[K.Nine=9]="Nine"})(Pt||(e.ViewColumn=Pt={}));var sn;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(sn||(e.StatusBarAlignment=sn={}));function _t(K,q){return`${P.$Em.toKey(K)}.${q}`}var dn;(function(K){K[K.Off=0]="Off",K[K.On=1]="On",K[K.Relative=2]="Relative",K[K.Interval=3]="Interval"})(dn||(e.TextEditorLineNumbersStyle=dn={}));var tt;(function(K){K[K.Manual=1]="Manual",K[K.AfterDelay=2]="AfterDelay",K[K.FocusOut=3]="FocusOut"})(tt||(e.TextDocumentSaveReason=tt={}));var on;(function(K){K[K.Default=0]="Default",K[K.InCenter=1]="InCenter",K[K.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",K[K.AtTop=3]="AtTop"})(on||(e.TextEditorRevealType=on={}));var Gt;(function(K){K[K.Keyboard=1]="Keyboard",K[K.Mouse=2]="Mouse",K[K.Command=3]="Command"})(Gt||(e.TextEditorSelectionChangeKind=Gt={}));var Kt;(function(K){K[K.Undo=1]="Undo",K[K.Redo=2]="Redo"})(Kt||(e.TextDocumentChangeReason=Kt={}));var gt;(function(K){K[K.OpenOpen=0]="OpenOpen",K[K.ClosedClosed=1]="ClosedClosed",K[K.OpenClosed=2]="OpenClosed",K[K.ClosedOpen=3]="ClosedOpen"})(gt||(e.DecorationRangeBehavior=gt={})),function(K){function q($e){switch($e){case"keyboard":return K.Keyboard;case"mouse":return K.Mouse;case"api":return K.Command}}K.fromValue=q}(Gt||(e.TextEditorSelectionChangeKind=Gt={}));var bt;(function(K){K[K.Other=0]="Other",K[K.Comment=1]="Comment",K[K.String=2]="String",K[K.RegEx=3]="RegEx"})(bt||(e.SyntaxTokenType=bt={})),function(K){function q($e){switch($e){case K.Other:return"other";case K.Comment:return"comment";case K.String:return"string";case K.RegEx:return"regex"}return"other"}K.toString=q}(bt||(e.SyntaxTokenType=bt={}));let Xt=class{constructor(q,$e){if($e&&!w.URI.isUri($e))throw(0,R.$7)("target");if(!x.isRange(q)||q.isEmpty)throw(0,R.$7)("range");this.range=q,this.target=$e}};e.$7M=Xt,e.$7M=Xt=Qe([L],Xt);let Bt=class{constructor(q,$e,je,xe){this.red=q,this.green=$e,this.blue=je,this.alpha=xe}};e.$8M=Bt,e.$8M=Bt=Qe([L],Bt);let Vt=class{constructor(q,$e){if($e&&!($e instanceof Bt))throw(0,R.$7)("color");if(!x.isRange(q)||q.isEmpty)throw(0,R.$7)("range");this.range=q,this.color=$e}};e.$9M=Vt,e.$9M=Vt=Qe([L],Vt);let $t=class{constructor(q){if(!q||typeof q!="string")throw(0,R.$7)("label");this.label=q}};e.$0M=$t,e.$0M=$t=Qe([L],$t);var Rt;(function(K){K[K.RGB=0]="RGB",K[K.HEX=1]="HEX",K[K.HSL=2]="HSL"})(Rt||(e.ColorFormat=Rt={}));var cn;(function(K){K[K.Error=0]="Error",K[K.Warning=1]="Warning",K[K.Information=2]="Information"})(cn||(e.SourceControlInputBoxValidationType=cn={}));var en;(function(K){K[K.Unknown=0]="Unknown",K[K.Shutdown=1]="Shutdown",K[K.Process=2]="Process",K[K.User=3]="User",K[K.Extension=4]="Extension"})(en||(e.TerminalExitReason=en={}));class Xe{constructor(q,$e,je){if(this.startIndex=q,this.length=$e,this.tooltip=je,typeof q!="number"||q<0)throw(0,R.$7)("startIndex");if(typeof $e!="number"||$e<1)throw(0,R.$7)("length");if(je!==void 0&&typeof je!="string")throw(0,R.$7)("tooltip")}}e.$$M=Xe;class Yt{constructor(q){this.uri=q}}e.$_M=Yt;class tn{constructor(q){this.terminalCommand=q}}e.$aN=tn;var nn;(function(K){K[K.Panel=1]="Panel",K[K.Editor=2]="Editor"})(nn||(e.TerminalLocation=nn={}));class yt{constructor(q){if(this.options=q,typeof q!="object")throw(0,R.$7)("options")}}e.$bN=yt;var Ut;(function(K){K[K.Always=1]="Always",K[K.Silent=2]="Silent",K[K.Never=3]="Never"})(Ut||(e.TaskRevealKind=Ut={}));var Tt;(function(K){K[K.Shared=1]="Shared",K[K.Dedicated=2]="Dedicated",K[K.New=3]="New"})(Tt||(e.TaskPanelKind=Tt={}));let Ot=W=class{static from(q){switch(q){case"clean":return W.Clean;case"build":return W.Build;case"rebuild":return W.Rebuild;case"test":return W.Test;default:return}}constructor(q,$e){if(this.label=$e,typeof q!="string"||typeof $e!="string")throw(0,R.$7)("name");this.c=q}get id(){return this.c}};e.$cN=Ot,Ot.Clean=new W("clean","Clean"),Ot.Build=new W("build","Build"),Ot.Rebuild=new W("rebuild","Rebuild"),Ot.Test=new W("test","Test"),e.$cN=Ot=W=Qe([L],Ot);function un(K){let q="";for(let $e=0;$e<K.length;$e++)q+=K[$e].replace(/,/g,",,")+",";return q}let Wt=class{constructor(q,$e,je){if(typeof q!="string")throw(0,R.$7)("process");this.e=[],this.c=q,$e!==void 0&&(Array.isArray($e)?(this.e=$e,this.f=je):this.f=$e)}get process(){return this.c}set process(q){if(typeof q!="string")throw(0,R.$7)("process");this.c=q}get args(){return this.e}set args(q){Array.isArray(q)||(q=[]),this.e=q}get options(){return this.f}set options(q){this.f=q}computeId(){const q=[];if(q.push("process"),this.c!==void 0&&q.push(this.c),this.e&&this.e.length>0)for(const $e of this.e)q.push($e);return un(q)}};e.$dN=Wt,e.$dN=Wt=Qe([L],Wt);let Ht=class{constructor(q,$e,je){if(this.f=[],Array.isArray($e)){if(!q)throw(0,R.$7)("command can't be undefined or null");if(typeof q!="string"&&typeof q.value!="string")throw(0,R.$7)("command");this.e=q,this.f=$e,this.g=je}else{if(typeof q!="string")throw(0,R.$7)("commandLine");this.c=q,this.g=$e}}get commandLine(){return this.c}set commandLine(q){if(typeof q!="string")throw(0,R.$7)("commandLine");this.c=q}get command(){return this.e?this.e:""}set command(q){if(typeof q!="string"&&typeof q.value!="string")throw(0,R.$7)("command");this.e=q}get args(){return this.f}set args(q){this.f=q||[]}get options(){return this.g}set options(q){this.g=q}computeId(){const q=[];if(q.push("shell"),this.c!==void 0&&q.push(this.c),this.e!==void 0&&q.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const $e of this.f)q.push(typeof $e=="string"?$e:$e.value);return un(q)}};e.$eN=Ht,e.$eN=Ht=Qe([L],Ht);var It;(function(K){K[K.Escape=1]="Escape",K[K.Strong=2]="Strong",K[K.Weak=3]="Weak"})(It||(e.ShellQuoting=It={}));var Ft;(function(K){K[K.Global=1]="Global",K[K.Workspace=2]="Workspace"})(Ft||(e.TaskScope=Ft={}));class rn{constructor(q){this.c=q}computeId(){return"customExecution"+(0,A.$Eg)()}set callback(q){this.c=q}get callback(){return this.c}}e.$fN=rn;let At=B=class{constructor(q,$e,je,xe,rt,ft){this.k=!1,this.l=this.definition=q;let pt;typeof $e=="string"?(this.o=this.name=$e,this.w=this.source=je,this.execution=xe,pt=rt,this.k=!0):$e===Ft.Global||$e===Ft.Workspace?(this.target=$e,this.o=this.name=je,this.w=this.source=xe,this.execution=rt,pt=ft):(this.target=$e,this.o=this.name=je,this.w=this.source=xe,this.execution=rt,pt=ft),typeof pt=="string"?(this.r=[pt],this.t=!0):Array.isArray(pt)?(this.r=pt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(q){this.j=q}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Wt?this.l={type:B.e,id:this.q.computeId()}:this.q instanceof Ht?this.l={type:B.f,id:this.q.computeId()}:this.q instanceof rn?this.l={type:B.c,id:this.q.computeId()}:this.l={type:B.g,id:(0,A.$Eg)()}}get definition(){return this.l}set definition(q){if(q==null)throw(0,R.$7)("Kind can't be undefined or null");this.B(),this.l=q}get scope(){return this.m}set target(q){this.B(),this.m=q}get name(){return this.o}set name(q){if(typeof q!="string")throw(0,R.$7)("name");this.B(),this.o=q}get execution(){return this.q}set execution(q){q===null&&(q=void 0),this.B(),this.q=q;const $e=this.l.type;(B.g===$e||B.e===$e||B.f===$e||B.c===$e)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(q){if(Array.isArray(q))this.B(),this.r=q,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(q){q!==!0&&q!==!1&&(q=!1),this.B(),this.u=q}get source(){return this.w}set source(q){if(typeof q!="string"||q.length===0)throw(0,R.$7)("source must be a string of length > 0");this.B(),this.w=q}get group(){return this.x}set group(q){q===null&&(q=void 0),this.B(),this.x=q}get detail(){return this.A}set detail(q){q===null&&(q=void 0),this.A=q}get presentationOptions(){return this.y}set presentationOptions(q){q==null&&(q=Object.create(null)),this.B(),this.y=q}get runOptions(){return this.z}set runOptions(q){q==null&&(q=Object.create(null)),this.B(),this.z=q}};e.$gN=At,At.c="customExecution",At.e="process",At.f="shell",At.g="$empty",e.$gN=At=B=Qe([L],At);var Et;(function(K){K[K.SourceControl=1]="SourceControl",K[K.Window=10]="Window",K[K.Notification=15]="Notification"})(Et||(e.ProgressLocation=Et={}));var Nt;(function(K){function q($e){const je=$e;return(0,$.$Zf)(je.value)?je.tooltip&&!(0,$.$Vf)(je.tooltip)?(console.log("INVALID view badge, invalid tooltip",je.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",je.value),!1)}K.isViewBadge=q})(Nt||(e.ViewBadge=Nt={}));let fn=T=class{static isTreeItem(q,$e){const je=q;if(je.checkboxState!==void 0){const xe=(0,$.$Zf)(je.checkboxState)?je.checkboxState:(0,$.$Xf)(je.checkboxState)&&(0,$.$Zf)(je.checkboxState.state)?je.checkboxState.state:void 0,rt=!(0,$.$Zf)(je.checkboxState)&&(0,$.$Xf)(je.checkboxState)?je.checkboxState.tooltip:void 0;if(xe===void 0||xe!==ln.Checked&&xe!==ln.Unchecked||rt!==void 0&&!(0,$.$Vf)(rt))return console.log("INVALID tree item, invalid checkboxState",je.checkboxState),!1}if(q instanceof T)return!0;if(je.label!==void 0&&!(0,$.$Vf)(je.label)&&!je.label?.label)return console.log("INVALID tree item, invalid label",je.label),!1;if(je.id!==void 0&&!(0,$.$Vf)(je.id))return console.log("INVALID tree item, invalid id",je.id),!1;if(je.iconPath!==void 0&&!(0,$.$Vf)(je.iconPath)&&!w.URI.isUri(je.iconPath)&&(!je.iconPath||!(0,$.$Vf)(je.iconPath.id))){const xe=je.iconPath;if(!xe||!(0,$.$Vf)(xe.light)&&!w.URI.isUri(xe.light)&&!(0,$.$Vf)(xe.dark)&&!w.URI.isUri(xe.dark))return console.log("INVALID tree item, invalid iconPath",je.iconPath),!1}return je.description!==void 0&&!(0,$.$Vf)(je.description)&&typeof je.description!="boolean"?(console.log("INVALID tree item, invalid description",je.description),!1):je.resourceUri!==void 0&&!w.URI.isUri(je.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",je.resourceUri),!1):je.tooltip!==void 0&&!(0,$.$Vf)(je.tooltip)&&!(je.tooltip instanceof Ie)?(console.log("INVALID tree item, invalid tooltip",je.tooltip),!1):je.command!==void 0&&!je.command.command?(console.log("INVALID tree item, invalid command",je.command),!1):je.collapsibleState!==void 0&&je.collapsibleState<Ct.None&&je.collapsibleState>Ct.Expanded?(console.log("INVALID tree item, invalid collapsibleState",je.collapsibleState),!1):je.contextValue!==void 0&&!(0,$.$Vf)(je.contextValue)?(console.log("INVALID tree item, invalid contextValue",je.contextValue),!1):je.accessibilityInformation!==void 0&&!je.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",je.accessibilityInformation),!1):!0}constructor(q,$e=Ct.None){this.collapsibleState=$e,w.URI.isUri(q)?this.resourceUri=q:this.label=q}};e.$hN=fn,e.$hN=fn=T=Qe([L],fn);var Ct;(function(K){K[K.None=0]="None",K[K.Collapsed=1]="Collapsed",K[K.Expanded=2]="Expanded"})(Ct||(e.TreeItemCollapsibleState=Ct={}));var ln;(function(K){K[K.Unchecked=0]="Unchecked",K[K.Checked=1]="Checked"})(ln||(e.TreeItemCheckboxState=ln={}));let Jt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(q){this.value=q}};e.$iN=Jt,e.$iN=Jt=Qe([L],Jt);class En extends Jt{}e.$jN=En;class wn extends En{constructor(q){super(""),l.set(this,void 0),it(this,l,q,"f")}asFile(){return qe(this,l,"f")}}e.$kN=wn,l=new WeakMap;class Le{constructor(q,$e,je,xe){this.name=q,this.uri=$e,this._itemId=je,this.c=xe}data(){return this.c()}}e.$lN=Le;let Fe=class{constructor(q){i.add(this),n.set(this,new Map);for(const[$e,je]of q??[]){const xe=qe(this,n,"f").get(qe(this,i,"m",r).call(this,$e));xe?xe.push(je):qe(this,n,"f").set(qe(this,i,"m",r).call(this,$e),[je])}}get(q){return qe(this,n,"f").get(qe(this,i,"m",r).call(this,q))?.[0]}set(q,$e){qe(this,n,"f").set(qe(this,i,"m",r).call(this,q),[$e])}forEach(q,$e){for(const[je,xe]of qe(this,n,"f"))for(const rt of xe)q.call($e,rt,je,this)}*[(n=new WeakMap,i=new WeakSet,Symbol.iterator)](){for(const[q,$e]of qe(this,n,"f"))for(const je of $e)yield[q,je]}};e.$mN=Fe,r=function(q){return q.toLowerCase()},e.$mN=Fe=Qe([L],Fe);let ke=class{constructor(q,$e,je){this.insertText=q,this.title=$e,this.kind=je}};e.$nN=ke,e.$nN=ke=Qe([L],ke);var ne;(function(K){K[K.Automatic=0]="Automatic",K[K.PasteAs=1]="PasteAs"})(ne||(e.DocumentPasteTriggerKind=ne={}));class Oe{constructor(q){this.value=q}append(...q){return new Oe((this.value?[this.value,...q]:q).join(Oe.c))}intersects(q){return this.contains(q)||q.contains(this)}contains(q){return this.value===q.value||q.value.startsWith(this.value+Oe.c)}}e.$oN=Oe,Oe.c=".",Oe.Empty=new Oe("");let Ge=class{constructor(q,$e,je){this.title=$e,this.insertText=q,this.kind=je}};e.$pN=Ge,e.$pN=Ge=Qe([L],Ge);let _e=class{constructor(q,$e){this.id=q,this.color=$e}static isThemeIcon(q){return typeof q.id!="string"?(console.log("INVALID ThemeIcon, invalid id",q.id),!1):!0}};e.$qN=_e,e.$qN=_e=Qe([L],_e),_e.File=new _e("file"),_e.Folder=new _e("folder");let Ye=class{constructor(q){this.id=q}};e.$rN=Ye,e.$rN=Ye=Qe([L],Ye);var dt;(function(K){K[K.Global=1]="Global",K[K.Workspace=2]="Workspace",K[K.WorkspaceFolder=3]="WorkspaceFolder"})(dt||(e.ConfigurationTarget=dt={}));let St=class{get base(){return this.c}set base(q){this.c=q,this.e=w.URI.file(q)}get baseUri(){return this.e}set baseUri(q){this.e=q,this.c=q.fsPath}constructor(q,$e){if(typeof q!="string"&&(!q||!w.URI.isUri(q)&&!w.URI.isUri(q.uri)))throw(0,R.$7)("base");if(typeof $e!="string")throw(0,R.$7)("pattern");typeof q=="string"?this.baseUri=w.URI.file(q):w.URI.isUri(q)?this.baseUri=q:this.baseUri=q.uri,this.pattern=$e}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$sN=St,e.$sN=St=Qe([L],St);const Dt=new WeakMap;function an(K,q){Dt.set(K,q)}let Lt=class{constructor(q,$e,je,xe,rt){this.enabled=typeof q=="boolean"?q:!0,typeof $e=="string"&&(this.condition=$e),typeof je=="string"&&(this.hitCondition=je),typeof xe=="string"&&(this.logMessage=xe),typeof rt=="string"&&(this.mode=rt)}get id(){return this.c||(this.c=Dt.get(this)??(0,A.$Eg)()),this.c}};e.$uN=Lt,e.$uN=Lt=Qe([L],Lt);let qt=class extends Lt{constructor(q,$e,je,xe,rt,ft){if(super($e,je,xe,rt,ft),q===null)throw(0,R.$7)("location");this.location=q}};e.$vN=qt,e.$vN=qt=Qe([L],qt);let Cn=class extends Lt{constructor(q,$e,je,xe,rt,ft){super($e,je,xe,rt,ft),this.functionName=q}};e.$wN=Cn,e.$wN=Cn=Qe([L],Cn);let mt=class extends Lt{constructor(q,$e,je,xe,rt,ft,pt,Qt){if(super(xe,rt,ft,pt,Qt),!$e)throw(0,R.$7)("dataId");this.label=q,this.dataId=$e,this.canPersist=je}};e.$xN=mt,e.$xN=mt=Qe([L],mt);let Tn=class{constructor(q,$e,je){this.command=q,this.args=$e||[],this.options=je}};e.$yN=Tn,e.$yN=Tn=Qe([L],Tn);let gn=class{constructor(q,$e){this.port=q,this.host=$e}};e.$zN=gn,e.$zN=gn=Qe([L],gn);let vn=class{constructor(q){this.path=q}};e.$AN=vn,e.$AN=vn=Qe([L],vn);let Mn=class{constructor(q){this.implementation=q}};e.$BN=Mn,e.$BN=Mn=Qe([L],Mn);class mi{constructor(q,$e,je){this.session=q,this.threadId=$e,this.frameId=je}}e.$CN=mi;class $i{constructor(q,$e){this.session=q,this.threadId=$e}}e.$DN=$i;let Fn=class{constructor(q,$e){this.range=q,this.expression=$e}};e.$EN=Fn,e.$EN=Fn=Qe([L],Fn);var zn;(function(K){K[K.Invoke=0]="Invoke",K[K.Automatic=1]="Automatic"})(zn||(e.InlineCompletionTriggerKind=zn={}));let Bn=class{constructor(q,$e){this.range=q,this.text=$e}};e.$FN=Bn,e.$FN=Bn=Qe([L],Bn);let Rn=class{constructor(q,$e,je=!0){this.range=q,this.variableName=$e,this.caseSensitiveLookup=je}};e.$GN=Rn,e.$GN=Rn=Qe([L],Rn);let Un=class{constructor(q,$e){this.range=q,this.expression=$e}};e.$HN=Un,e.$HN=Un=Qe([L],Un);let Sn=class{constructor(q,$e){this.frameId=q,this.stoppedLocation=$e}};e.$IN=Sn,e.$IN=Sn=Qe([L],Sn);var On;(function(K){K[K.AIGenerated=1]="AIGenerated"})(On||(e.NewSymbolNameTag=On={}));class pi{constructor(q,$e){this.newSymbolName=q,this.tags=$e}}e.$JN=pi;var xn;(function(K){K[K.Changed=1]="Changed",K[K.Created=2]="Created",K[K.Deleted=3]="Deleted"})(xn||(e.FileChangeType=xn={}));let yn=N=class extends Error{static FileExists(q){return new N(q,b.FileSystemProviderErrorCode.FileExists,N.FileExists)}static FileNotFound(q){return new N(q,b.FileSystemProviderErrorCode.FileNotFound,N.FileNotFound)}static FileNotADirectory(q){return new N(q,b.FileSystemProviderErrorCode.FileNotADirectory,N.FileNotADirectory)}static FileIsADirectory(q){return new N(q,b.FileSystemProviderErrorCode.FileIsADirectory,N.FileIsADirectory)}static NoPermissions(q){return new N(q,b.FileSystemProviderErrorCode.NoPermissions,N.NoPermissions)}static Unavailable(q){return new N(q,b.FileSystemProviderErrorCode.Unavailable,N.Unavailable)}constructor(q,$e=b.FileSystemProviderErrorCode.Unknown,je){super(w.URI.isUri(q)?q.toString(!0):q),this.code=je?.name??"Unknown",(0,b.$4k)(this,$e),Object.setPrototypeOf(this,N.prototype),typeof Error.captureStackTrace=="function"&&typeof je=="function"&&Error.captureStackTrace(this,je)}};e.$KN=yn,e.$KN=yn=N=Qe([L],yn);let Wn=class{constructor(q,$e,je){this.start=q,this.end=$e,this.kind=je}};e.$LN=Wn,e.$LN=Wn=Qe([L],Wn);var _n;(function(K){K[K.Comment=1]="Comment",K[K.Imports=2]="Imports",K[K.Region=3]="Region"})(_n||(e.FoldingRangeKind=_n={}));var ei;(function(K){K[K.Collapsed=0]="Collapsed",K[K.Expanded=1]="Expanded"})(ei||(e.CommentThreadCollapsibleState=ei={}));var Vn;(function(K){K[K.Editing=0]="Editing",K[K.Preview=1]="Preview"})(Vn||(e.CommentMode=Vn={}));var ti;(function(K){K[K.Published=0]="Published",K[K.Draft=1]="Draft"})(ti||(e.CommentState=ti={}));var qn;(function(K){K[K.Unresolved=0]="Unresolved",K[K.Resolved=1]="Resolved"})(qn||(e.CommentThreadState=qn={}));var Hn;(function(K){K[K.Current=0]="Current",K[K.Outdated=1]="Outdated"})(Hn||(e.CommentThreadApplicability=Hn={}));class bi{constructor(q,$e=[]){this.tokenTypes=q,this.tokenModifiers=$e}}e.$MN=bi;function ni(K){return typeof K>"u"||(0,$.$Wf)(K)}class Ln{constructor(q){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,q){this.m=!0;for(let $e=0,je=q.tokenTypes.length;$e<je;$e++)this.k.set(q.tokenTypes[$e],$e);for(let $e=0,je=q.tokenModifiers.length;$e<je;$e++)this.l.set(q.tokenModifiers[$e],$e)}}push(q,$e,je,xe,rt){if(typeof q=="number"&&typeof $e=="number"&&typeof je=="number"&&typeof xe=="number"&&(typeof rt=="number"||typeof rt>"u"))return typeof rt>"u"&&(rt=0),this.q(q,$e,je,xe,rt);if(x.isRange(q)&&typeof $e=="string"&&ni(je))return this.o(q,$e,je);throw(0,R.$7)()}o(q,$e,je){if(!this.m)throw new Error("Legend must be provided in constructor");if(q.start.line!==q.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has($e))throw new Error("`tokenType` is not in the provided legend");const xe=q.start.line,rt=q.start.character,ft=q.end.character-q.start.character,pt=this.k.get($e);let Qt=0;if(je)for(const hn of je){if(!this.l.has(hn))throw new Error("`tokenModifier` is not in the provided legend");const $n=this.l.get(hn);Qt|=1<<$n>>>0}this.q(xe,rt,ft,pt,Qt)}q(q,$e,je,xe,rt){if(this.f&&(q<this.c||q===this.c&&$e<this.e)){this.f=!1;const Qt=this.g.length/5|0;let hn=0,$n=0;for(let bn=0;bn<Qt;bn++){let kn=this.g[5*bn],Yn=this.g[5*bn+1];kn===0?(kn=hn,Yn+=$n):kn+=hn,this.g[5*bn]=kn,this.g[5*bn+1]=Yn,hn=kn,$n=Yn}}let ft=q,pt=$e;this.f&&this.j>0&&(ft-=this.c,ft===0&&(pt-=this.e)),this.g[this.j++]=ft,this.g[this.j++]=pt,this.g[this.j++]=je,this.g[this.j++]=xe,this.g[this.j++]=rt,this.c=q,this.e=$e}static r(q){const $e=[],je=q.length/5|0;for(let pt=0;pt<je;pt++)$e[pt]=pt;$e.sort((pt,Qt)=>{const hn=q[5*pt],$n=q[5*Qt];if(hn===$n){const bn=q[5*pt+1],kn=q[5*Qt+1];return bn-kn}return hn-$n});const xe=new Uint32Array(q.length);let rt=0,ft=0;for(let pt=0;pt<je;pt++){const Qt=5*$e[pt],hn=q[Qt+0],$n=q[Qt+1],bn=q[Qt+2],kn=q[Qt+3],Yn=q[Qt+4],Ui=hn-rt,mr=Ui===0?$n-ft:$n,Zn=5*pt;xe[Zn+0]=Ui,xe[Zn+1]=mr,xe[Zn+2]=bn,xe[Zn+3]=kn,xe[Zn+4]=Yn,rt=hn,ft=$n}return xe}build(q){return this.f?new Gn(new Uint32Array(this.g),q):new Gn(Ln.r(this.g),q)}}e.$NN=Ln;class Gn{constructor(q,$e){this.resultId=$e,this.data=q}}e.$ON=Gn;class wi{constructor(q,$e,je){this.start=q,this.deleteCount=$e,this.data=je}}e.$PN=wi;class vi{constructor(q,$e){this.resultId=$e,this.edits=q}}e.$QN=vi;var ii;(function(K){K[K.Separate=0]="Separate",K[K.MergeWithParent=1]="MergeWithParent"})(ii||(e.DebugConsoleMode=ii={}));class Kn{constructor(q){this.name=q}}e.$RN=Kn;let Dn=class{constructor(){}};e.$SN=Dn,Dn.Back={iconPath:new _e("arrow-left")},e.$SN=Dn=Qe([L],Dn);var Ue;(function(K){K[K.Separator=-1]="Separator",K[K.Default=0]="Default"})(Ue||(e.QuickPickItemKind=Ue={}));var mn;(function(K){K[K.Info=1]="Info",K[K.Warning=2]="Warning",K[K.Error=3]="Error"})(mn||(e.InputBoxValidationSeverity=mn={}));var Jn;(function(K){K[K.UI=1]="UI",K[K.Workspace=2]="Workspace"})(Jn||(e.ExtensionKind=Jn={}));class ct{static validate(q){if(typeof q.badge=="string"){let $e=(0,p.$vf)(q.badge,0);if($e<q.badge.length&&($e+=(0,p.$vf)(q.badge,$e)),q.badge.length>$e)throw new Error("The 'badge'-property must be undefined or a short character")}else if(q.badge&&!_e.isThemeIcon(q.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!q.color&&!q.badge&&!q.tooltip)throw new Error("The decoration is empty");return!0}constructor(q,$e,je){this.badge=q,this.tooltip=$e,this.color=je}}e.$TN=ct;let wt=class{constructor(q){this.kind=q}};e.$UN=wt,e.$UN=wt=Qe([L],wt);var ri;(function(K){K[K.Light=1]="Light",K[K.Dark=2]="Dark",K[K.HighContrast=3]="HighContrast",K[K.HighContrastLight=4]="HighContrastLight"})(ri||(e.ColorThemeKind=ri={}));class pn{static isNotebookRange(q){return q instanceof pn?!0:q?typeof q.start=="number"&&typeof q.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(q,$e){if(q<0)throw(0,R.$7)("start must be positive");if($e<0)throw(0,R.$7)("end must be positive");q<=$e?(this.c=q,this.e=$e):(this.c=$e,this.e=q)}with(q){let $e=this.c,je=this.e;return q.start!==void 0&&($e=q.start),q.end!==void 0&&(je=q.end),$e===this.c&&je===this.e?this:new pn($e,je)}}e.$VN=pn;class Pn{static validate(q){if(typeof q.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof q.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof q.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(q){return Array.isArray(q)&&q.every($e=>Pn.isNotebookCellData($e))}static isNotebookCellData(q){return!0}constructor(q,$e,je,xe,rt,ft,pt){this.kind=q,this.value=$e,this.languageId=je,this.mime=xe,this.outputs=rt??[],this.metadata=ft,this.executionSummary=pt,Pn.validate(this)}}e.$WN=Pn;class yi{constructor(q){this.cells=q}}e.$XN=yi;class In{static isNotebookCellOutputItem(q){return q instanceof s?!0:q?typeof q.mime=="string"&&q.data instanceof Uint8Array:!1}static error(q){const $e={name:q.name,message:q.message,stack:q.stack};return s.json($e,"application/vnd.code.notebook.error")}static stdout(q){return s.text(q,"application/vnd.code.notebook.stdout")}static stderr(q){return s.text(q,"application/vnd.code.notebook.stderr")}static bytes(q,$e="application/octet-stream"){return new s(q,$e)}static text(q,$e=O.$As.text){const je=qe(s,s,"f",t).encode(String(q));return new s(je,$e)}static json(q,$e="text/x-json"){const je=JSON.stringify(q,void 0,"	");return s.text(je,$e)}constructor(q,$e){this.data=q,this.mime=$e;const je=(0,O.$Es)($e,!0);if(!je)throw new Error(`INVALID mime type: ${$e}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=je}}e.$YN=In,s=In,t={value:new TextEncoder};class Nn{static isNotebookCellOutput(q){return q instanceof Nn?!0:!q||typeof q!="object"?!1:typeof q.id=="string"&&Array.isArray(q.items)}static ensureUniqueMimeTypes(q,$e=!1){const je=new Set,xe=new Set;for(let rt=0;rt<q.length;rt++){const ft=q[rt],pt=(0,O.$Es)(ft.mime);if(!je.has(pt)||(0,y.$pK)(pt)){je.add(pt);continue}xe.add(rt),$e&&console.warn(`DUPLICATED mime type '${ft.mime}' will be dropped`)}return xe.size===0?q:q.filter((rt,ft)=>!xe.has(ft))}constructor(q,$e,je){this.items=Nn.ensureUniqueMimeTypes(q,!0),typeof $e=="string"?(this.id=$e,this.metadata=je):(this.id=(0,A.$Eg)(),this.metadata=$e??je)}}e.$ZN=Nn;var si;(function(K){K[K.Markup=1]="Markup",K[K.Code=2]="Code"})(si||(e.NotebookCellKind=si={}));var oi;(function(K){K[K.Idle=1]="Idle",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(oi||(e.NotebookCellExecutionState=oi={}));var Qn;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(Qn||(e.NotebookCellStatusBarAlignment=Qn={}));var ai;(function(K){K[K.Default=0]="Default",K[K.InCenter=1]="InCenter",K[K.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",K[K.AtTop=3]="AtTop"})(ai||(e.NotebookEditorRevealType=ai={}));class ki{constructor(q,$e){this.text=q,this.alignment=$e}}e.$1N=ki;var ci;(function(K){K[K.Default=1]="Default",K[K.Preferred=2]="Preferred"})(ci||(e.NotebookControllerAffinity=ci={}));var ui;(function(K){K[K.Default=1]="Default",K[K.Preferred=2]="Preferred",K[K.Hidden=-1]="Hidden"})(ui||(e.NotebookControllerAffinity2=ui={}));class Ei{constructor(q,$e=[]){this.uri=q,this.provides=(0,o.$3b)($e)}}e.$2N=Ei;class Ci{constructor(q){this.label=q}}e.$3N=Ci;var li;(function(K){K[K.Named=1]="Named",K[K.Indexed=2]="Indexed"})(li||(e.NotebookVariablesRequestKind=li={}));let Xn=class{constructor(q,$e){this.label=q,this.timestamp=$e}};e.$4N=Xn,e.$4N=Xn=Qe([L],Xn);var hi;(function(K){K[K.Production=1]="Production",K[K.Development=2]="Development",K[K.Test=3]="Test"})(hi||(e.ExtensionMode=hi={}));var di;(function(K){K[K.Node=1]="Node",K[K.Webworker=2]="Webworker"})(di||(e.ExtensionRuntime=di={}));var fi;(function(K){K[K.Other=0]="Other",K[K.Comment=1]="Comment",K[K.String=2]="String",K[K.RegEx=3]="RegEx"})(fi||(e.StandardTokenType=fi={}));class ge{constructor(q,$e){this.ranges=q,this.wordPattern=$e}}e.$5N=ge;class ve{constructor(q){this.c=q}get autoForwardAction(){return this.c}}e.$6N=ve;var Be;(function(K){K[K.Queued=1]="Queued",K[K.Running=2]="Running",K[K.Passed=3]="Passed",K[K.Failed=4]="Failed",K[K.Skipped=5]="Skipped",K[K.Errored=6]="Errored"})(Be||(e.TestResultState=Be={}));var ut;(function(K){K[K.Run=1]="Run",K[K.Debug=2]="Debug",K[K.Coverage=3]="Coverage"})(ut||(e.TestRunProfileKind=ut={}));let kt=class{constructor(q=void 0,$e=void 0,je=void 0,xe=!1){this.include=q,this.exclude=$e,this.profile=je,this.continuous=xe}};e.$7N=kt,e.$7N=kt=Qe([L],kt);let jt=j=class{static diff(q,$e,je){const xe=new j(q);return xe.expectedOutput=$e,xe.actualOutput=je,xe}constructor(q){this.message=q}};e.$8N=jt,e.$8N=jt=j=Qe([L],jt);let An=class{constructor(q){this.id=q}};e.$9N=An,e.$9N=An=Qe([L],An);class gi{constructor(q,$e){this.covered=q,this.total=$e,Di(this)}}e.$0N=gi;function Di(K){if(K){if(K.covered>K.total)throw new Error(`The total number of covered items (${K.covered}) cannot be greater than the total (${K.total})`);if(K.total<0)throw new Error(`The number of covered items (${K.total}) cannot be negative`)}}class Si{static fromDetails(q,$e){const je=new gi(0,0),xe=new gi(0,0),rt=new gi(0,0);for(const pt of $e)if("branches"in pt){je.total+=1,je.covered+=pt.executed?1:0;for(const Qt of pt.branches)xe.total+=1,xe.covered+=Qt.executed?1:0}else rt.total+=1,rt.covered+=pt.executed?1:0;const ft=new Si(q,je,xe.total>0?xe:void 0,rt.total>0?rt:void 0);return ft.detailedCoverage=$e,ft}constructor(q,$e,je,xe){this.uri=q,this.statementCoverage=$e,this.branchCoverage=je,this.declarationCoverage=xe}}e.$_N=Si;class Wi{get executionCount(){return+this.executed}set executionCount(q){this.executed=q}constructor(q,$e,je=[]){this.executed=q,this.location=$e,this.branches=je}}e.$aO=Wi;class Vi{get executionCount(){return+this.executed}set executionCount(q){this.executed=q}constructor(q,$e,je){this.executed=q,this.location=$e,this.label=je}}e.$bO=Vi;class qi{get executionCount(){return+this.executed}set executionCount(q){this.executed=q}constructor(q,$e,je){this.name=q,this.executed=$e,this.location=je}}e.$cO=qi;var Pi;(function(K){K[K.None=0]="None",K[K.Option=1]="Option",K[K.Default=2]="Default",K[K.Preferred=3]="Preferred"})(Pi||(e.ExternalUriOpenerPriority=Pi={}));var Ii;(function(K){K[K.Untrusted=0]="Untrusted",K[K.Trusted=1]="Trusted",K[K.Unspecified=2]="Unspecified"})(Ii||(e.WorkspaceTrustState=Ii={}));var Ai;(function(K){K[K.Notify=1]="Notify",K[K.OpenBrowser=2]="OpenBrowser",K[K.OpenPreview=3]="OpenPreview",K[K.Silent=4]="Silent",K[K.Ignore=5]="Ignore",K[K.OpenBrowserOnce=6]="OpenBrowserOnce"})(Ai||(e.PortAutoForwardAction=Ai={}));class Hi{constructor(q,$e,je,xe,rt,ft){this.kind=q,this.name=$e,this.detail=je,this.uri=xe,this.range=rt,this.selectionRange=ft}}e.$dO=Hi;class Gi{constructor(q){this.uri=q}}e.$eO=Gi;class Ki{constructor(q,$e){this.original=q,this.modified=$e}}e.$fO=Ki;class Ji{constructor(q,$e,je,xe){this.base=q,this.input1=$e,this.input2=je,this.result=xe}}e.$gO=Ji;class Qi{constructor(q,$e){this.uri=q,this.viewType=$e}}e.$hO=Qi;class Xi{constructor(q){this.viewType=q}}e.$iO=Xi;class Yi{constructor(q,$e){this.uri=q,this.notebookType=$e}}e.$jO=Yi;class Zi{constructor(q,$e,je){this.original=q,this.modified=$e,this.notebookType=je}}e.$kO=Zi;class xi{constructor(){}}e.$lO=xi;class _i{constructor(q,$e){this.uri=q,this.inputBoxUri=$e}}e.$mO=_i;class er{constructor(q){this.providerId=q}}e.$nO=er;class tr{constructor(q){this.textDiffs=q}}e.$oO=tr;var Mi;(function(K){K[K.Down=0]="Down",K[K.Up=1]="Up"})(Mi||(e.InteractiveSessionVoteDirection=Mi={}));var Ri;(function(K){K[K.Action=1]="Action",K[K.Toolbar=2]="Toolbar"})(Ri||(e.ChatCopyKind=Ri={}));var Oi;(function(K){K[K.Short=1]="Short",K[K.Medium=2]="Medium",K[K.Full=3]="Full"})(Oi||(e.ChatVariableLevel=Oi={}));class nr{constructor(q,$e){this.label=q,this.values=$e}}e.$pO=nr;var Li;(function(K){K[K.Unhelpful=0]="Unhelpful",K[K.Helpful=1]="Helpful",K[K.Undone=2]="Undone",K[K.Accepted=3]="Accepted",K[K.Bug=4]="Bug"})(Li||(e.InteractiveEditorResponseFeedbackKind=Li={}));var Ni;(function(K){K[K.Unhelpful=0]="Unhelpful",K[K.Helpful=1]="Helpful"})(Ni||(e.ChatResultFeedbackKind=Ni={}));class ir{constructor(q){this.value=typeof q=="string"?new Ie(q):q}}e.$qO=ir;class rr{constructor(q,$e){this.value=q,this.baseUri=$e}}e.$rO=rr;class sr{constructor(q,$e){this.value=q,this.title=$e}}e.$sO=sr;class or{constructor(q){this.value=q}}e.$tO=or;class ar{constructor(q){this.value=q}}e.$uO=ar;class cr{constructor(q){this.value=q}}e.$vO=cr;class ur{constructor(q,$e,je,xe){this.prompt=q,this.command=$e,this.variables=je,this.participant=xe}}e.$wO=ur;class lr{constructor(q,$e,je,xe){this.response=q,this.result=$e,this.participant=je,this.command=xe}}e.$xO=lr;var ji;(function(K){K[K.Panel=1]="Panel",K[K.Terminal=2]="Terminal",K[K.Notebook=3]="Notebook",K[K.Editor=4]="Editor"})(ji||(e.ChatLocation=ji={}));class hr{constructor(q){this.content=q}}e.$yO=hr;class dr{constructor(q,$e){this.content=q,this.name=$e}}e.$zO=dr;class fr{constructor(q,$e){this.content=q,this.name=$e}}e.$AO=fr;class jn extends Error{static NotFound(q){return new jn(q,jn.NotFound.name)}static NoPermissions(q){return new jn(q,jn.NoPermissions.name)}constructor(q,$e,je){super(q,{cause:je}),this.name="LanguageModelError",this.code=$e??""}}e.$BO=jn;var Ti;(function(K){K[K.SymbolInformation=1]="SymbolInformation",K[K.CommandInformation=2]="CommandInformation",K[K.SearchInformation=3]="SearchInformation",K[K.SettingInformation=4]="SettingInformation"})(Ti||(e.RelatedInformationType=Ti={}));var Fi;(function(K){K[K.Started=1]="Started",K[K.Recognizing=2]="Recognizing",K[K.Recognized=3]="Recognized",K[K.Stopped=4]="Stopped"})(Fi||(e.SpeechToTextStatus=Fi={}));var zi;(function(K){K[K.Recognized=1]="Recognized",K[K.Stopped=2]="Stopped"})(zi||(e.KeywordRecognitionStatus=zi={}));class gr{constructor(q,$e){this.text=q,this.range=$e}}e.$CO=gr;var Bi;(function(K){K[K.Invoke=0]="Invoke",K[K.Automatic=1]="Automatic"})(Bi||(e.InlineEditTriggerKind=Bi={}))}),define(Ee[322],Ce([1,0,6,7]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yjc=void 0;class I{constructor(O){this.a=new Map,this.b=0,this.c=O.getProxy(o.$sM.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(O,p,$){if(this.a.size===0)throw new Error("No related information providers registered");const w=this.a.get(O);if(!w)throw new Error("related information provider not found");return await w.provideRelatedInformation(p,$)??[]}getRelatedInformation(O,p,$){return this.c.$getAiRelatedInformation(p,$)}registerRelatedInformationProvider(O,p,$){const w=this.b;return this.b++,this.a.set(w,$),this.c.$registerAiRelatedInformationProvider(w,p),new R.$uM(()=>{this.c.$unregisterAiRelatedInformationProvider(w),this.a.delete(w)})}}e.$yjc=I}),define(Ee[121],Ce([1,0,4,6,7,25,146,5,20]),function(re,e,o,R,I,M,O,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kjc=e.$Jjc=void 0,e.$Jjc=(0,p.$ii)("IExtHostAuthentication");let w=class{constructor(b){this.b=new Map,this.c=new o.$7d,this.onDidChangeSessions=this.c.event,this.d=new A,this.f=new A,this.a=b.getProxy(R.$sM.MainThreadAuthentication)}async getSession(b,C,y,a={}){const m=M.$Em.toKey(b.identifier),l=[...y].sort().join(" ");return await this.d.getOrCreate(`${m} ${C} ${l}`,async()=>{await this.a.$ensureProvider(C);const i=b.displayName||b.name;return this.a.$getSession(C,y,m,i,a)})}async getSessions(b,C,y){const a=M.$Em.toKey(b.identifier),m=[...y].sort().join(" ");return await this.f.getOrCreate(`${a} ${m}`,async()=>{await this.a.$ensureProvider(C);const l=b.displayName||b.name;return this.a.$getSessions(C,y,a,l)})}async removeSession(b,C){const y=this.b.get(b);return y?y.provider.removeSession(C):this.a.$removeSession(b,C)}registerAuthenticationProvider(b,C,y,a){if(this.b.get(b))throw new Error(`An authentication provider with id '${b}' is already registered.`);this.b.set(b,{label:C,provider:y,options:a??{supportsMultipleAccounts:!1}});const m=y.onDidChangeSessions(l=>this.a.$sendDidChangeSessions(b,l));return this.a.$registerAuthenticationProvider(b,C,a?.supportsMultipleAccounts??!1),new I.$uM(()=>{m.dispose(),this.b.delete(b),this.a.$unregisterAuthenticationProvider(b)})}$createSession(b,C,y){const a=this.b.get(b);if(a)return Promise.resolve(a.provider.createSession(C,y));throw new Error(`Unable to find authentication provider with handle: ${b}`)}$removeSession(b,C){const y=this.b.get(b);if(y)return Promise.resolve(y.provider.removeSession(C));throw new Error(`Unable to find authentication provider with handle: ${b}`)}$getSessions(b,C){const y=this.b.get(b);if(y)return Promise.resolve(y.provider.getSessions(C));throw new Error(`Unable to find authentication provider with handle: ${b}`)}$onDidChangeAuthenticationSessions(b,C){return b.startsWith(O.$uL)||this.c.fire({provider:{id:b,label:C}}),Promise.resolve()}};e.$Kjc=w,e.$Kjc=w=Qe([He(0,$.$OO)],w);class A{constructor(){this.a=new Map}getOrCreate(b,C){const y=this.a.get(b);if(y)return y;const a=C().finally(()=>this.a.delete(b));return this.a.set(b,a),a}}}),define(Ee[152],Ce([1,0,2,6,7,5,20,12,19,14,17,26]),function(re,e,o,R,I,M,O,p,$,w,A,P){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$Lkc=e.$Kkc=void 0;let C=b=class{constructor(a,m){this.h=m,this.f=new Map,this.g=a.getProxy(R.$sM.MainThreadDecorations)}registerFileDecorationProvider(a,m){const l=b.c++;this.f.set(l,{provider:a,extensionDescription:m}),this.g.$registerDecorationProvider(l,m.identifier.value);const i=a.onDidChangeFileDecorations&&a.onDidChangeFileDecorations(n=>{if(!n){this.g.$onDidChange(l,null);return}const r=(0,$.$3b)(n);if(r.length<=b.d){this.g.$onDidChange(l,r);return}this.h.warn("[Decorations] CAPPING events from decorations provider",m.identifier.value,r.length);const s=r.map(d=>({uri:d,rank:(0,w.$1e)(d.path,"/")})),t=(0,$.$zb)(s,(d,h)=>d.rank-h.rank||(0,w.$ef)(d.uri.path,h.uri.path)),g=[];e:for(const d of t){let h;for(const c of d){const u=(0,A.$nc)(c.uri.path);if(h!==u&&(h=u,g.push(c.uri)>=b.d))break e}}this.g.$onDidChange(l,g)});return new I.$uM(()=>{i?.dispose(),this.g.$unregisterDecorationProvider(l),this.f.delete(l)})}async $provideDecorations(a,m,l){if(!this.f.has(a))return Object.create(null);const i=Object.create(null),{provider:n,extensionDescription:r}=this.f.get(a);return await Promise.all(m.map(async s=>{try{const{uri:t,id:g}=s,d=await Promise.resolve(n.provideFileDecoration(o.URI.revive(t),l));if(!d)return;try{I.$TN.validate(d),d.badge&&typeof d.badge!="string"&&(0,P.$dG)(r,"codiconDecoration"),i[g]=[d.propagate,d.tooltip,d.badge,d.color]}catch(h){this.h.warn(`INVALID decoration from extension '${r.identifier.value}': ${h}`)}}catch(t){this.h.error(t)}})),i}};e.$Kkc=C,C.c=0,C.d=250,e.$Kkc=C=b=Qe([He(0,O.$OO),He(1,p.$Oj)],C),e.$Lkc=(0,M.$ii)("IExtHostDecorations")}),define(Ee[323],Ce([1,0,13,2,7,6,15,22,14]),function(re,e,o,R,I,M,O,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nkc=void 0;class w{constructor(P,b,C){this.d=b,this.e=C,this.b=new Map,this.c=P.getProxy(M.$sM.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(P,b){if(Object.keys(O.Schemas).indexOf(P)>=0)throw new Error(`scheme '${P}' already registered`);const C=w.a++;this.b.set(C,b),this.c.$registerTextContentProvider(C,P);let y;if(typeof b.onDidChange=="function"){let a;y=b.onDidChange(async m=>{if(m.scheme!==P){this.e.warn(`Provider for scheme '${P}' is firing event for schema '${m.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(m))return;a&&await a;const l=this.$provideTextDocumentContent(C,m).then(async i=>{if(!i&&typeof i!="string")return;const n=this.d.getDocument(m);if(!n)return;const r=(0,$.$$e)(i);if(!n.equalLines(r))return this.c.$onVirtualDocumentChange(m,i)}).catch(o.$1).finally(()=>{a===l&&(a=void 0)});a=l})}return new I.$uM(()=>{this.b.delete(C)&&this.c.$unregisterTextContentProvider(C),y&&(y.dispose(),y=void 0)})}$provideTextDocumentContent(P,b){const C=this.b.get(P);return C?Promise.resolve(C.provideTextDocumentContent(R.URI.revive(b),p.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${b.scheme}`))}}e.$Nkc=w,w.a=0}),define(Ee[153],Ce([1,0,61,15,14,191,133,7,19]),function(re,e,o,R,I,M,O,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SO=e.$RO=void 0,e.$QO=A;const w=new Map;function A(y,a){a?w.set(y,a):w.delete(y)}function P(y){return w.get(y)}class b extends M.$Iv{constructor(a,m,l,i,n,r,s){super(m,l,i,n),this.c=a,this.m=r,this.q=s,this.b=!1}dispose(){(0,o.ok)(!this.b),this.b=!0,this.q=!1}equalLines(a){return(0,$.$ub)(this.f,a)}get document(){if(!this.a){const a=this;this.a={get uri(){return a.d},get fileName(){return a.d.fsPath},get isUntitled(){return a.d.scheme===R.Schemas.untitled},get languageId(){return a.m},get version(){return a.h},get isClosed(){return a.b},get isDirty(){return a.q},save(){return a.r()},getText(m){return m?a.s(m):a.getText()},get eol(){return a.g===`
`?p.EndOfLine.LF:p.EndOfLine.CRLF},get lineCount(){return a.f.length},lineAt(m){return a.t(m)},offsetAt(m){return a.u(m)},positionAt(m){return a.v(m)},validateRange(m){return a.w(m)},validatePosition(m){return a.x(m)},getWordRangeAtPosition(m,l){return a.y(m,l)}}}return Object.freeze(this.a)}_acceptLanguageId(a){(0,o.ok)(!this.b),this.m=a}_acceptIsDirty(a){(0,o.ok)(!this.b),this.q=a}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(a){const m=this.w(a);if(m.isEmpty)return"";if(m.isSingleLine)return this.f[m.start.line].substring(m.start.character,m.end.character);const l=this.g,i=m.start.line,n=m.end.line,r=[];r.push(this.f[i].substring(m.start.character));for(let s=i+1;s<n;s++)r.push(this.f[s]);return r.push(this.f[n].substring(0,m.end.character)),r.join(l)}t(a){let m;if(a instanceof p.$vM?m=a.line:typeof a=="number"&&(m=a),typeof m!="number"||m<0||m>=this.f.length||Math.floor(m)!==m)throw new Error("Illegal value for `line`");return new C(m,this.f[m],m===this.f.length-1)}u(a){return a=this.x(a),this.l(),this.j.getPrefixSum(a.line-1)+a.character}v(a){a=Math.floor(a),a=Math.max(0,a),this.l();const m=this.j.getIndexOf(a),l=this.f[m.index].length;return new p.$vM(m.index,Math.min(m.remainder,l))}w(a){if(!(a instanceof p.$wM))throw new Error("Invalid argument");const m=this.x(a.start),l=this.x(a.end);return m===a.start&&l===a.end?a:new p.$wM(m.line,m.character,l.line,l.character)}x(a){if(!(a instanceof p.$vM))throw new Error("Invalid argument");if(this.f.length===0)return a.with(0,0);let{line:m,character:l}=a,i=!1;if(m<0)m=0,l=0,i=!0;else if(m>=this.f.length)m=this.f.length-1,l=this.f[m].length,i=!0;else{const n=this.f[m].length;l<0?(l=0,i=!0):l>n&&(l=n,i=!0)}return i?new p.$vM(m,l):a}y(a,m){const l=this.x(a);if(!m)m=P(this.m);else if((0,I.$0e)(m))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${m.source}' because it matches the empty string.`);const i=(0,O.$Ss)(l.character+1,(0,O.$Qs)(m),this.f[l.line],0);if(i)return new p.$wM(l.line,i.startColumn-1,l.line,i.endColumn-1)}}e.$RO=b;class C{constructor(a,m,l){this.a=a,this.b=m,this.c=l}get lineNumber(){return this.a}get text(){return this.b}get range(){return new p.$wM(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new p.$wM(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$SO=C}),define(Ee[324],Ce([1,0,6,7]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pkc=void 0;class I{constructor(O){this.a=new Map,this.b=0,this.c=O.getProxy(o.$sM.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(O,p,$){if(this.a.size===0)throw new Error("No embedding vector providers registered");const w=this.a.get(O);if(!w)throw new Error("Embedding vector provider not found");const A=await w.provideEmbeddingVector(p,$);if(!A)throw new Error("Embedding vector provider returned undefined");return A}registerEmbeddingVectorProvider(O,p,$){const w=this.b;return this.b++,this.a.set(w,$),this.c.$registerAiEmbeddingVectorProvider(p,w),new R.$uM(()=>{this.c.$unregisterAiEmbeddingVectorProvider(w),this.a.delete(w)})}}e.$Pkc=I}),define(Ee[69],Ce([1,0,6,32,7,21,5,20,59,3,8,23,15]),function(re,e,o,R,I,M,O,p,$,w,A,P,b){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.$4jc=e.$3jc=void 0;let y=C=class{constructor(m,l){this.b=new Map,this.c=new A.$rh,this.a=m.getProxy(o.$sM.MainThreadFileSystem);const i=this;this.value=Object.freeze({async stat(n){try{let r;const s=i.b.get(n.scheme);return s?(await i.a.$ensureActivation(n.scheme),r=await s.impl.stat(n)):r=await i.a.$stat(n),{type:r.type,ctime:r.ctime,mtime:r.mtime,size:r.size,permissions:r.permissions===R.FilePermission.Readonly?1:void 0}}catch(r){C.e(r)}},async readDirectory(n){try{const r=i.b.get(n.scheme);return r?(await i.a.$ensureActivation(n.scheme),(await r.impl.readDirectory(n)).slice()):await i.a.$readdir(n)}catch(r){return C.e(r)}},async createDirectory(n){try{const r=i.b.get(n.scheme);return r&&!r.isReadonly?(await i.a.$ensureActivation(n.scheme),await i.d(r.impl,r.extUri,n)):await i.a.$mkdir(n)}catch(r){return C.e(r)}},async readFile(n){try{const r=i.b.get(n.scheme);return r?(await i.a.$ensureActivation(n.scheme),(await r.impl.readFile(n)).slice()):(await i.a.$readFile(n)).buffer}catch(r){return C.e(r)}},async writeFile(n,r){try{const s=i.b.get(n.scheme);return s&&!s.isReadonly?(await i.a.$ensureActivation(n.scheme),await i.d(s.impl,s.extUri,s.extUri.dirname(n)),await i.c.queueFor(n,()=>Promise.resolve(s.impl.writeFile(n,r,{create:!0,overwrite:!0})))):await i.a.$writeFile(n,M.$ue.wrap(r))}catch(s){return C.e(s)}},async delete(n,r){try{const s=i.b.get(n.scheme);return s&&!s.isReadonly&&!r?.useTrash?(await i.a.$ensureActivation(n.scheme),await s.impl.delete(n,{recursive:!1,...r})):await i.a.$delete(n,{recursive:!1,useTrash:!1,atomic:!1,...r})}catch(s){return C.e(s)}},async rename(n,r,s){try{return await i.a.$rename(n,r,{overwrite:!1,...s})}catch(t){return C.e(t)}},async copy(n,r,s){try{return await i.a.$copy(n,r,{overwrite:!1,...s})}catch(t){return C.e(t)}},isWritableFileSystem(n){const r=l.getCapabilities(n);if(typeof r=="number")return!(r&2048)}})}async d(m,l,i){const n=[];for(;!l.isEqual(i,l.dirname(i));)try{if(!((await m.stat(i)).type&R.FileType.Directory))throw I.$KN.FileExists(`Unable to create folder '${i.scheme===b.Schemas.file?i.fsPath:i.toString(!0)}' that already exists but is not a directory`);break}catch(r){if(R.$5k(r)!==R.FileSystemProviderErrorCode.FileNotFound)throw r;n.push(l.basename(i)),i=l.dirname(i)}for(let r=n.length-1;r>=0;r--){i=l.joinPath(i,n[r]);try{await m.createDirectory(i)}catch(s){if(R.$5k(s)!==R.FileSystemProviderErrorCode.FileExists)throw s}}}static e(m){if(m instanceof I.$KN)throw m;if(m instanceof R.$1k)switch(m.code){case R.FileSystemProviderErrorCode.FileExists:throw I.$KN.FileExists(m.message);case R.FileSystemProviderErrorCode.FileNotFound:throw I.$KN.FileNotFound(m.message);case R.FileSystemProviderErrorCode.FileNotADirectory:throw I.$KN.FileNotADirectory(m.message);case R.FileSystemProviderErrorCode.FileIsADirectory:throw I.$KN.FileIsADirectory(m.message);case R.FileSystemProviderErrorCode.NoPermissions:throw I.$KN.NoPermissions(m.message);case R.FileSystemProviderErrorCode.Unavailable:throw I.$KN.Unavailable(m.message);default:throw new I.$KN(m.message,m.name)}if(!(m instanceof Error))throw new I.$KN(String(m));if(m.name==="ENOPRO"||m.message.includes("ENOPRO"))throw I.$KN.Unavailable(m.message);switch(m.name){case R.FileSystemProviderErrorCode.FileExists:throw I.$KN.FileExists(m.message);case R.FileSystemProviderErrorCode.FileNotFound:throw I.$KN.FileNotFound(m.message);case R.FileSystemProviderErrorCode.FileNotADirectory:throw I.$KN.FileNotADirectory(m.message);case R.FileSystemProviderErrorCode.FileIsADirectory:throw I.$KN.FileIsADirectory(m.message);case R.FileSystemProviderErrorCode.NoPermissions:throw I.$KN.NoPermissions(m.message);case R.FileSystemProviderErrorCode.Unavailable:throw I.$KN.Unavailable(m.message);default:throw new I.$KN(m.message,m.name)}}addFileSystemProvider(m,l,i){return this.b.set(m,{impl:l,extUri:i?.isCaseSensitive?P.$Lg:P.$Ng,isReadonly:!!i?.isReadonly}),(0,w.$Sc)(()=>this.b.delete(m))}getFileSystemProviderExtUri(m){return this.b.get(m)?.extUri??P.$Lg}};e.$3jc=y,e.$3jc=y=C=Qe([He(0,p.$OO),He(1,$.$Djc)],y),e.$4jc=(0,O.$ii)("IExtHostConsumerFileSystem")}),define(Ee[325],Ce([1,0,6,7]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7kc=void 0;class I{constructor(O){this.a=new Map,this.b=new Map,this.c=O.getProxy(o.$sM.MainThreadIssueReporter)}async $getIssueReporterUri(O,p){if(this.a.size===0)throw new Error("No issue request handlers registered");const $=this.a.get(O);if(!$)throw new Error("Issue request handler not found");const w=await $.handleIssueUrlRequest();if(!w)throw new Error("Issue request handler returned no result");return w}async $getIssueReporterData(O,p){if(this.b.size===0)throw new Error("No issue request handlers registered");const $=this.b.get(O);if(!$)throw new Error("Issue data provider not found");const w=await $.provideIssueData(p);if(!w)throw new Error("Issue data provider returned no result");return w}async $getIssueReporterTemplate(O,p){if(this.b.size===0)throw new Error("No issue request handlers registered");const $=this.b.get(O);if(!$)throw new Error("Issue data provider not found");const w=await $.provideIssueTemplate(p);if(!w)throw new Error("Issue template provider returned no result");return w}registerIssueUriRequestHandler(O,p){const $=O.identifier.value;return this.a.set($,p),this.c.$registerIssueUriRequestHandler($),new R.$uM(()=>{this.c.$unregisterIssueUriRequestHandler($),this.a.delete($)})}registerIssueDataProvider(O,p){const $=O.identifier.value;return this.b.set($,p),this.c.$registerIssueDataProvider($),new R.$uM(()=>{this.c.$unregisterIssueDataProvider($),this.b.delete($)})}}e.$7kc=I}),define(Ee[93],Ce([1,0,5,28,12,69,2]),function(re,e,o,R,I,M,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6jc=e.$5jc=void 0,e.$5jc=(0,o.$ii)("IExtensionStoragePaths");let p=class{constructor(w,A,P){this.d=A,this.f=P,this.a=w.workspace??void 0,this.b=w.environment,this.whenReady=this.h().then(b=>this.c=b)}async g(w){return O.URI.joinPath(this.b.workspaceStorageHome,w)}async h(){if(!this.a)return Promise.resolve(void 0);const w=this.a.id,A=await this.g(w);try{return await this.f.value.stat(A),this.d.trace("[ExtHostStorage] storage dir already exists",A),A}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",A),await this.f.value.createDirectory(A),await this.f.value.writeFile(O.URI.joinPath(A,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:O.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),A}catch(P){this.d.error("[ExtHostStorage]",P);return}}workspaceValue(w){if(this.c)return O.URI.joinPath(this.c,w.identifier.value)}globalValue(w){return O.URI.joinPath(this.b.globalStorageHome,w.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$6jc=p,e.$6jc=p=Qe([He(0,R.$5O),He(1,I.$Oj),He(2,M.$4jc)],p)}),define(Ee[326],Ce([1,0,7,20,4]),function(re,e,o,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xlc=void 0;let M=class{constructor(p){this.a=new o.$UN(o.ColorThemeKind.Dark),this.b=new I.$7d}get activeColorTheme(){return this.a}$onColorThemeChange(p){let $;switch(p){case"light":$=o.ColorThemeKind.Light;break;case"hcDark":$=o.ColorThemeKind.HighContrast;break;case"hcLight":$=o.ColorThemeKind.HighContrastLight;break;default:$=o.ColorThemeKind.Dark}this.a=new o.$UN($),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$xlc=M,e.$xlc=M=Qe([He(0,R.$OO)],M)}),define(Ee[70],Ce([1,0,22,4,3,229,5,12,88,6,28,20,7]),function(re,e,o,R,I,M,O,p,$,w,A,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lCb=e.$kCb=e.TunnelDtoConverter=void 0;class C extends $.$8v{}var y;(function(m){function l(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public,privacy:n.privacy??(n.public?$.TunnelPrivacyId.Public:$.TunnelPrivacyId.Private),protocol:n.protocol}}m.fromApiTunnel=l;function i(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.privacy!==$.TunnelPrivacyId.ConstantPrivate&&n.privacy!==$.TunnelPrivacyId.ConstantPrivate,privacy:n.privacy,protocol:n.protocol}}m.fromServiceTunnel=i})(y||(e.TunnelDtoConverter=y={})),e.$kCb=(0,O.$ii)("IExtHostTunnelService");let a=class extends I.$Uc{constructor(l,i,n){super(),this.s=n,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new R.$7d,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=l.getProxy(w.$sM.MainThreadTunnelService)}async openTunnel(l,i){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${l.identifier.value} called openTunnel API for ${i.remoteAddress.host}:${i.remoteAddress.port}.`);const n=await this.a.$openTunnel(i,l.displayName);if(n){const r=new C(n.remoteAddress,n.localAddress,()=>this.a.$closeTunnel(n.remoteAddress));return this.B(r),r}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(l,i){l.portRange===void 0&&l.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const n=this.u();return this.r.set(n,{selector:l,provider:i}),this.a.$registerPortsAttributesProvider(l,n),new b.$uM(()=>{this.r.delete(n),this.a.$unregisterPortsAttributesProvider(n)})}async $providePortAttributes(l,i,n,r,s){const t=[];for(const d of l){const h=this.r.get(d);if(!h)return[];t.push(...await Promise.all(i.map(async c=>{let u;try{u=await h.provider.providePortAttributes({port:c,pid:n,commandLine:r},s)}catch{u=await h.provider.providePortAttributes(c,n,r,s)}return{providedAttributes:u,port:c}})))}const g=t.filter(d=>!!d.providedAttributes);return g.length>0?g.map(d=>({autoForwardAction:d.providedAttributes.autoForwardAction,port:d.port})):[]}async $registerCandidateFinder(l){}registerTunnelProvider(l,i){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(r,s)=>await l.provideTunnel(r,s,o.CancellationToken.None)??void 0;const n=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,privacyOptions:i.tunnelFeatures?.privacyOptions,protocol:i.tunnelFeatures.protocol===void 0?!0:i.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(n),Promise.resolve((0,I.$Sc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(l,i){if(l){l.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(l.candidatePortSource),l.showCandidatePort&&(this.f=l.showCandidatePort,this.a.$setCandidateFilter());const n=l.tunnelFactory??(i?this.w(i):void 0);if(n){this.b=n;let r=l.tunnelFeatures?.privacyOptions??[];l.tunnelFeatures?.public&&r.length===0&&(r=[{id:"private",label:M.localize(0,null),themeIcon:"lock"},{id:"public",label:M.localize(1,null),themeIcon:"eye"}]);const s=l.tunnelFeatures?{elevation:!!l.tunnelFeatures?.elevation,public:!!l.tunnelFeatures?.public,privacyOptions:r,protocol:!0}:void 0;this.a.$setTunnelProvider(s)}}else this.b=void 0;return(0,I.$Sc)(()=>{this.b=void 0})}w(l){}async $closeTunnel(l,i){if(this.g.has(l.host)){const n=this.g.get(l.host);n.has(l.port)&&(i&&n.get(l.port).disposeListener.dispose(),await n.get(l.port).tunnel.dispose(),n.delete(l.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(l,i){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const n=this.b(l,i);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),n!==void 0){const r=await n;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),r===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(l.remoteAddress.host)||this.g.set(l.remoteAddress.host,new Map);const s=this.B(r.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(r.remoteAddress))));return this.g.get(l.remoteAddress.host).set(l.remoteAddress.port,{tunnel:r,disposeListener:s}),y.fromApiTunnel(r)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(n){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),n instanceof Error)return n.message}}async $applyCandidateFilter(l){const i=await Promise.all(l.map(r=>this.f(r.host,r.port,r.detail??""))),n=l.filter((r,s)=>i[s]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${l.map(r=>r.port).join(", ")} to ${n.map(r=>r.port).join(", ")}`),n}};e.$lCb=a,e.$lCb=a=Qe([He(0,P.$OO),He(1,A.$5O),He(2,p.$Oj)],a)}),define(Ee[16],Ce([1,0,19,21,175,74,79,27,166,57,98,24,168,23,18,2,29,83,139,145,143,288,120,67,89,300,26,7]),function(re,e,o,R,I,M,O,p,$,w,A,P,b,C,y,a,m,l,i,n,r,s,t,g,d,h,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentResolvedVariable=e.ChatLocation=e.ChatAgentRequest=e.ChatResponseProgress=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseCommandButtonPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseMarkdownPart=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.LanguageModelMessage=e.ChatInlineFollowup=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$LO=L,e.$MO=Q,e.$NO=Y;var f;(function(Le){function Fe(ne){const{selectionStartLineNumber:Oe,selectionStartColumn:Ge,positionLineNumber:_e,positionColumn:Ye}=ne,dt=new u.$vM(Oe-1,Ge-1),St=new u.$vM(_e-1,Ye-1);return new u.$xM(dt,St)}Le.to=Fe;function ke(ne){const{anchor:Oe,active:Ge}=ne;return{selectionStartLineNumber:Oe.line+1,selectionStartColumn:Oe.character+1,positionLineNumber:Ge.line+1,positionColumn:Ge.character+1}}Le.from=ke})(f||(e.Selection=f={}));var E;(function(Le){function Fe(ne){if(!ne)return;const{start:Oe,end:Ge}=ne;return{startLineNumber:Oe.line+1,startColumn:Oe.character+1,endLineNumber:Ge.line+1,endColumn:Ge.character+1}}Le.from=Fe;function ke(ne){if(!ne)return;const{startLineNumber:Oe,startColumn:Ge,endLineNumber:_e,endColumn:Ye}=ne;return new u.$wM(Oe-1,Ge-1,_e-1,Ye-1)}Le.to=ke})(E||(e.Range=E={}));var v;(function(Le){function Fe(ne){return{uri:ne.uri,range:E.from(ne.range)}}Le.from=Fe;function ke(ne){return new u.$GM(a.URI.revive(ne.uri),E.to(ne.range))}Le.to=ke})(v||(e.Location=v={}));var D;(function(Le){function Fe(ke){switch(ke){case 1:return u.StandardTokenType.Comment;case 0:return u.StandardTokenType.Other;case 3:return u.StandardTokenType.RegEx;case 2:return u.StandardTokenType.String}}Le.to=Fe})(D||(e.TokenType=D={}));var k;(function(Le){function Fe(ne){return new u.$vM(ne.lineNumber-1,ne.column-1)}Le.to=Fe;function ke(ne){return{lineNumber:ne.line+1,column:ne.character+1}}Le.from=ke})(k||(e.Position=k={}));var S;(function(Le){function Fe(Oe,Ge,_e){return(0,o.$Hb)((0,o.$3b)(Oe).map(Ye=>ke(Ye,Ge,_e)))}Le.from=Fe;function ke(Oe,Ge,_e){if(typeof Oe=="string")return{$serialized:!0,language:Oe,isBuiltin:_e?.isBuiltin};if(Oe)return{$serialized:!0,language:Oe.language,scheme:ne(Oe.scheme,Ge),pattern:De.from(Oe.pattern)??void 0,exclusive:Oe.exclusive,notebookType:Oe.notebookType,isBuiltin:_e?.isBuiltin}}function ne(Oe,Ge){return Ge&&typeof Oe=="string"?Ge.transformOutgoingScheme(Oe):Oe}})(S||(e.DocumentSelector=S={}));var F;(function(Le){function Fe(ne){switch(ne){case u.DiagnosticTag.Unnecessary:return 1;case u.DiagnosticTag.Deprecated:return 2}}Le.from=Fe;function ke(ne){switch(ne){case 1:return u.DiagnosticTag.Unnecessary;case 2:return u.DiagnosticTag.Deprecated;default:return}}Le.to=ke})(F||(e.DiagnosticTag=F={}));var W;(function(Le){function Fe(ne){let Oe;return ne.code&&((0,y.$Vf)(ne.code)||(0,y.$Zf)(ne.code)?Oe=String(ne.code):Oe={value:String(ne.code.value),target:ne.code.target}),{...E.from(ne.range),message:ne.message,source:ne.source,code:Oe,severity:T.from(ne.severity),relatedInformation:ne.relatedInformation&&ne.relatedInformation.map(B.from),tags:Array.isArray(ne.tags)?(0,o.$Hb)(ne.tags.map(F.from)):void 0}}Le.from=Fe;function ke(ne){const Oe=new u.$IM(E.to(ne),ne.message,T.to(ne.severity));return Oe.source=ne.source,Oe.code=(0,y.$Vf)(ne.code)?ne.code:ne.code?.value,Oe.relatedInformation=ne.relatedInformation&&ne.relatedInformation.map(B.to),Oe.tags=ne.tags&&(0,o.$Hb)(ne.tags.map(F.to)),Oe}Le.to=ke})(W||(e.Diagnostic=W={}));var B;(function(Le){function Fe(ne){return{...E.from(ne.location.range),message:ne.message,resource:ne.location.uri}}Le.from=Fe;function ke(ne){return new u.$HM(new u.$GM(ne.resource,E.to(ne)),ne.message)}Le.to=ke})(B||(e.DiagnosticRelatedInformation=B={}));var T;(function(Le){function Fe(ne){switch(ne){case u.DiagnosticSeverity.Error:return i.MarkerSeverity.Error;case u.DiagnosticSeverity.Warning:return i.MarkerSeverity.Warning;case u.DiagnosticSeverity.Information:return i.MarkerSeverity.Info;case u.DiagnosticSeverity.Hint:return i.MarkerSeverity.Hint}return i.MarkerSeverity.Error}Le.from=Fe;function ke(ne){switch(ne){case i.MarkerSeverity.Info:return u.DiagnosticSeverity.Information;case i.MarkerSeverity.Warning:return u.DiagnosticSeverity.Warning;case i.MarkerSeverity.Error:return u.DiagnosticSeverity.Error;case i.MarkerSeverity.Hint:return u.DiagnosticSeverity.Hint;default:return u.DiagnosticSeverity.Error}}Le.to=ke})(T||(e.DiagnosticSeverity=T={}));var N;(function(Le){function Fe(ne){return typeof ne=="number"&&ne>=u.ViewColumn.One?ne-1:ne===u.ViewColumn.Beside?h.$HD:h.$GD}Le.from=Fe;function ke(ne){if(typeof ne=="number"&&ne>=0)return ne+1;throw new Error("invalid 'EditorGroupColumn'")}Le.to=ke})(N||(e.ViewColumn=N={}));function j(Le){return typeof Le.range<"u"}function L(Le){return Le.length===0?!0:!!j(Le[0])}var z;(function(Le){function Fe(Ye){return Ye.map(Le.from)}Le.fromMany=Fe;function ke(Ye){return Ye&&typeof Ye=="object"&&typeof Ye.language=="string"&&typeof Ye.value=="string"}function ne(Ye){let dt;if(ke(Ye)){const{language:Lt,value:qt}=Ye;dt={value:"```"+Lt+`
`+qt+"\n```\n"}}else u.$VM.isMarkdownString(Ye)?dt={value:Ye.value,isTrusted:Ye.isTrusted,supportThemeIcons:Ye.supportThemeIcons,supportHtml:Ye.supportHtml,baseUri:Ye.baseUri}:typeof Ye=="string"?dt={value:Ye}:dt={value:""};const St=Object.create(null);dt.uris=St;const Dt=Lt=>{try{let qt=a.URI.parse(Lt,!0);qt=qt.with({query:Oe(qt.query,St)}),St[Lt]=qt}catch{}return""},an=new $.marked.Renderer;return an.link=Dt,an.image=Lt=>typeof Lt=="string"?Dt(O.$Nk(Lt).href):"",(0,$.marked)(dt.value,{renderer:an}),dt}Le.from=ne;function Oe(Ye,dt){if(!Ye)return Ye;let St;try{St=(0,w.$Qh)(Ye)}catch{}if(!St)return Ye;let Dt=!1;return St=(0,P.$Rn)(St,an=>{if(a.URI.isUri(an)){const Lt=`__uri_${Math.random().toString(16).slice(2,8)}`;return dt[Lt]=an,Dt=!0,Lt}else return}),Dt?JSON.stringify(St):Ye}function Ge(Ye){const dt=new u.$VM(Ye.value,Ye.supportThemeIcons);return dt.isTrusted=Ye.isTrusted,dt.supportHtml=Ye.supportHtml,dt.baseUri=Ye.baseUri?a.URI.from(Ye.baseUri):void 0,dt}Le.to=Ge;function _e(Ye){if(Ye)return typeof Ye=="string"?Ye:Le.from(Ye)}Le.fromStrict=_e})(z||(e.MarkdownString=z={}));function Q(Le){return L(Le)?Le.map(Fe=>({range:E.from(Fe.range),hoverMessage:Array.isArray(Fe.hoverMessage)?z.fromMany(Fe.hoverMessage):Fe.hoverMessage?z.from(Fe.hoverMessage):void 0,renderOptions:Fe.renderOptions})):Le.map(Fe=>({range:E.from(Fe)}))}function Y(Le){return typeof Le>"u"?Le:typeof Le=="string"?a.URI.file(Le):Le}var J;(function(Le){function Fe(ke){return typeof ke>"u"?ke:{contentText:ke.contentText,contentIconPath:ke.contentIconPath?Y(ke.contentIconPath):void 0,border:ke.border,borderColor:ke.borderColor,fontStyle:ke.fontStyle,fontWeight:ke.fontWeight,textDecoration:ke.textDecoration,color:ke.color,backgroundColor:ke.backgroundColor,margin:ke.margin,width:ke.width,height:ke.height}}Le.from=Fe})(J||(e.ThemableDecorationAttachmentRenderOptions=J={}));var x;(function(Le){function Fe(ke){return typeof ke>"u"?ke:{backgroundColor:ke.backgroundColor,outline:ke.outline,outlineColor:ke.outlineColor,outlineStyle:ke.outlineStyle,outlineWidth:ke.outlineWidth,border:ke.border,borderColor:ke.borderColor,borderRadius:ke.borderRadius,borderSpacing:ke.borderSpacing,borderStyle:ke.borderStyle,borderWidth:ke.borderWidth,fontStyle:ke.fontStyle,fontWeight:ke.fontWeight,textDecoration:ke.textDecoration,cursor:ke.cursor,color:ke.color,opacity:ke.opacity,letterSpacing:ke.letterSpacing,gutterIconPath:ke.gutterIconPath?Y(ke.gutterIconPath):void 0,gutterIconSize:ke.gutterIconSize,overviewRulerColor:ke.overviewRulerColor,before:ke.before?J.from(ke.before):void 0,after:ke.after?J.from(ke.after):void 0}}Le.from=Fe})(x||(e.ThemableDecorationRenderOptions=x={}));var ce;(function(Le){function Fe(ke){if(typeof ke>"u")return ke;switch(ke){case u.DecorationRangeBehavior.OpenOpen:return 0;case u.DecorationRangeBehavior.ClosedClosed:return 1;case u.DecorationRangeBehavior.OpenClosed:return 2;case u.DecorationRangeBehavior.ClosedOpen:return 3}}Le.from=Fe})(ce||(e.DecorationRangeBehavior=ce={}));var te;(function(Le){function Fe(ke){return{isWholeLine:ke.isWholeLine,rangeBehavior:ke.rangeBehavior?ce.from(ke.rangeBehavior):void 0,overviewRulerLane:ke.overviewRulerLane,light:ke.light?x.from(ke.light):void 0,dark:ke.dark?x.from(ke.dark):void 0,backgroundColor:ke.backgroundColor,outline:ke.outline,outlineColor:ke.outlineColor,outlineStyle:ke.outlineStyle,outlineWidth:ke.outlineWidth,border:ke.border,borderColor:ke.borderColor,borderRadius:ke.borderRadius,borderSpacing:ke.borderSpacing,borderStyle:ke.borderStyle,borderWidth:ke.borderWidth,fontStyle:ke.fontStyle,fontWeight:ke.fontWeight,textDecoration:ke.textDecoration,cursor:ke.cursor,color:ke.color,opacity:ke.opacity,letterSpacing:ke.letterSpacing,gutterIconPath:ke.gutterIconPath?Y(ke.gutterIconPath):void 0,gutterIconSize:ke.gutterIconSize,overviewRulerColor:ke.overviewRulerColor,before:ke.before?J.from(ke.before):void 0,after:ke.after?J.from(ke.after):void 0}}Le.from=Fe})(te||(e.DecorationRenderOptions=te={}));var pe;(function(Le){function Fe(ne){return{text:ne.newText,eol:ne.newEol&&We.from(ne.newEol),range:E.from(ne.range)}}Le.from=Fe;function ke(ne){const Oe=new u.$BM(E.to(ne.range),ne.text);return Oe.newEol=typeof ne.eol>"u"?void 0:We.to(ne.eol),Oe}Le.to=ke})(pe||(e.TextEdit=pe={}));var ye;(function(Le){function Fe(ne,Oe){const Ge={edits:[]};if(ne instanceof u.$EM){const _e=new p.$Cc;for(const Ye of ne._allEntries())Ye._type===1&&a.URI.isUri(Ye.to)&&Ye.from===void 0&&_e.add(Ye.to);for(const Ye of ne._allEntries())if(Ye._type===1){let dt;Ye.options?.contents&&(ArrayBuffer.isView(Ye.options.contents)?dt={type:"base64",value:(0,R.$Oe)(R.$ue.wrap(Ye.options.contents))}:dt={type:"dataTransferItem",id:Ye.options.contents._itemId}),Ge.edits.push({oldResource:Ye.from,newResource:Ye.to,options:{...Ye.options,contents:dt},metadata:Ye.metadata})}else Ye._type===2?Ge.edits.push({resource:Ye.uri,textEdit:pe.from(Ye.edit),versionId:_e.has(Ye.uri)?void 0:Oe?.getTextDocumentVersion(Ye.uri),metadata:Ye.metadata}):Ye._type===6?Ge.edits.push({resource:Ye.uri,textEdit:{range:E.from(Ye.range),text:Ye.edit.value,insertAsSnippet:!0},versionId:_e.has(Ye.uri)?void 0:Oe?.getTextDocumentVersion(Ye.uri),metadata:Ye.metadata}):Ye._type===3?Ge.edits.push({metadata:Ye.metadata,resource:Ye.uri,cellEdit:Ye.edit,notebookMetadata:Ye.notebookMetadata,notebookVersionId:Oe?.getNotebookDocumentVersion(Ye.uri)}):Ye._type===5&&Ge.edits.push({metadata:Ye.metadata,resource:Ye.uri,notebookVersionId:Oe?.getNotebookDocumentVersion(Ye.uri),cellEdit:{editType:1,index:Ye.index,count:Ye.count,cells:Ye.cells.map(Zt.from)}})}return Ge}Le.from=Fe;function ke(ne){const Oe=new u.$EM,Ge=new p.$Bc;for(const _e of ne.edits)if(_e.textEdit){const Ye=_e,dt=a.URI.revive(Ye.resource),St=E.to(Ye.textEdit.range),Dt=Ye.textEdit.text,an=Ye.textEdit.insertAsSnippet;let Lt;an?Lt=u.$DM.replace(St,new u.$FM(Dt)):Lt=u.$BM.replace(St,Dt);const qt=Ge.get(dt);qt?qt.push(Lt):Ge.set(dt,[Lt])}else Oe.renameFile(a.URI.revive(_e.oldResource),a.URI.revive(_e.newResource),_e.options);for(const[_e,Ye]of Ge)Oe.set(_e,Ye);return Oe}Le.to=ke})(ye||(e.WorkspaceEdit=ye={}));var _;(function(Le){const Fe=Object.create(null);Fe[u.SymbolKind.File]=0,Fe[u.SymbolKind.Module]=1,Fe[u.SymbolKind.Namespace]=2,Fe[u.SymbolKind.Package]=3,Fe[u.SymbolKind.Class]=4,Fe[u.SymbolKind.Method]=5,Fe[u.SymbolKind.Property]=6,Fe[u.SymbolKind.Field]=7,Fe[u.SymbolKind.Constructor]=8,Fe[u.SymbolKind.Enum]=9,Fe[u.SymbolKind.Interface]=10,Fe[u.SymbolKind.Function]=11,Fe[u.SymbolKind.Variable]=12,Fe[u.SymbolKind.Constant]=13,Fe[u.SymbolKind.String]=14,Fe[u.SymbolKind.Number]=15,Fe[u.SymbolKind.Boolean]=16,Fe[u.SymbolKind.Array]=17,Fe[u.SymbolKind.Object]=18,Fe[u.SymbolKind.Key]=19,Fe[u.SymbolKind.Null]=20,Fe[u.SymbolKind.EnumMember]=21,Fe[u.SymbolKind.Struct]=22,Fe[u.SymbolKind.Event]=23,Fe[u.SymbolKind.Operator]=24,Fe[u.SymbolKind.TypeParameter]=25;function ke(Oe){return typeof Fe[Oe]=="number"?Fe[Oe]:6}Le.from=ke;function ne(Oe){for(const Ge in Fe)if(Fe[Ge]===Oe)return Number(Ge);return u.SymbolKind.Property}Le.to=ne})(_||(e.SymbolKind=_={}));var U;(function(Le){function Fe(ne){switch(ne){case u.SymbolTag.Deprecated:return 1}}Le.from=Fe;function ke(ne){switch(ne){case 1:return u.SymbolTag.Deprecated}}Le.to=ke})(U||(e.SymbolTag=U={}));var he;(function(Le){function Fe(ne){return{name:ne.name,kind:_.from(ne.kind),tags:ne.tags&&ne.tags.map(U.from),containerName:ne.containerName,location:oe.from(ne.location)}}Le.from=Fe;function ke(ne){const Oe=new u.$MM(ne.name,_.to(ne.kind),ne.containerName,oe.to(ne.location));return Oe.tags=ne.tags&&ne.tags.map(U.to),Oe}Le.to=ke})(he||(e.WorkspaceSymbol=he={}));var Se;(function(Le){function Fe(ne){const Oe={name:ne.name||"!!MISSING: name!!",detail:ne.detail,range:E.from(ne.range),selectionRange:E.from(ne.selectionRange),kind:_.from(ne.kind),tags:ne.tags?.map(U.from)??[]};return ne.children&&(Oe.children=ne.children.map(Fe)),Oe}Le.from=Fe;function ke(ne){const Oe=new u.$NM(ne.name,ne.detail,_.to(ne.kind),E.to(ne.range),E.to(ne.selectionRange));return(0,o.$Lb)(ne.tags)&&(Oe.tags=ne.tags.map(U.to)),ne.children&&(Oe.children=ne.children.map(ke)),Oe}Le.to=ke})(Se||(e.DocumentSymbol=Se={}));var me;(function(Le){function Fe(ne){const Oe=new u.$RM(_.to(ne.kind),ne.name,ne.detail||"",a.URI.revive(ne.uri),E.to(ne.range),E.to(ne.selectionRange));return Oe._sessionId=ne._sessionId,Oe._itemId=ne._itemId,Oe}Le.to=Fe;function ke(ne,Oe,Ge){if(Oe=Oe??ne._sessionId,Ge=Ge??ne._itemId,Oe===void 0||Ge===void 0)throw new Error("invalid item");return{_sessionId:Oe,_itemId:Ge,name:ne.name,detail:ne.detail,kind:_.from(ne.kind),uri:ne.uri,range:E.from(ne.range),selectionRange:E.from(ne.selectionRange),tags:ne.tags?.map(U.from)}}Le.from=ke})(me||(e.CallHierarchyItem=me={}));var ie;(function(Le){function Fe(ke){return new u.$SM(me.to(ke.from),ke.fromRanges.map(ne=>E.to(ne)))}Le.to=Fe})(ie||(e.CallHierarchyIncomingCall=ie={}));var se;(function(Le){function Fe(ke){return new u.$TM(me.to(ke.to),ke.fromRanges.map(ne=>E.to(ne)))}Le.to=Fe})(se||(e.CallHierarchyOutgoingCall=se={}));var oe;(function(Le){function Fe(ne){return{range:ne.range&&E.from(ne.range),uri:ne.uri}}Le.from=Fe;function ke(ne){return new u.$GM(a.URI.revive(ne.uri),E.to(ne.range))}Le.to=ke})(oe||(e.location=oe={}));var G;(function(Le){function Fe(ne){const Oe=ne,Ge=ne;return{originSelectionRange:Oe.originSelectionRange?E.from(Oe.originSelectionRange):void 0,uri:Oe.targetUri?Oe.targetUri:Ge.uri,range:E.from(Oe.targetRange?Oe.targetRange:Ge.range),targetSelectionRange:Oe.targetSelectionRange?E.from(Oe.targetSelectionRange):void 0}}Le.from=Fe;function ke(ne){return{targetUri:a.URI.revive(ne.uri),targetRange:E.to(ne.range),targetSelectionRange:ne.targetSelectionRange?E.to(ne.targetSelectionRange):void 0,originSelectionRange:ne.originSelectionRange?E.to(ne.originSelectionRange):void 0}}Le.to=ke})(G||(e.DefinitionLink=G={}));var ee;(function(Le){function Fe(ne){return{range:E.from(ne.range),contents:z.fromMany(ne.contents)}}Le.from=Fe;function ke(ne){return new u.$JM(ne.contents.map(z.to),E.to(ne.range))}Le.to=ke})(ee||(e.Hover=ee={}));var le;(function(Le){function Fe(ne){return{range:E.from(ne.range),expression:ne.expression}}Le.from=Fe;function ke(ne){return new u.$EN(E.to(ne.range),ne.expression)}Le.to=ke})(le||(e.EvaluatableExpression=le={}));var de;(function(Le){function Fe(ne){if(ne instanceof u.$FN)return{type:"text",range:E.from(ne.range),text:ne.text};if(ne instanceof u.$GN)return{type:"variable",range:E.from(ne.range),variableName:ne.variableName,caseSensitiveLookup:ne.caseSensitiveLookup};if(ne instanceof u.$HN)return{type:"expression",range:E.from(ne.range),expression:ne.expression};throw new Error("Unknown 'InlineValue' type")}Le.from=Fe;function ke(ne){switch(ne.type){case"text":return{range:E.to(ne.range),text:ne.text};case"variable":return{range:E.to(ne.range),variableName:ne.variableName,caseSensitiveLookup:ne.caseSensitiveLookup};case"expression":return{range:E.to(ne.range),expression:ne.expression}}}Le.to=ke})(de||(e.InlineValue=de={}));var Me;(function(Le){function Fe(ne){return{frameId:ne.frameId,stoppedLocation:E.from(ne.stoppedLocation)}}Le.from=Fe;function ke(ne){return new u.$IN(ne.frameId,E.to(ne.stoppedLocation))}Le.to=ke})(Me||(e.InlineValueContext=Me={}));var be;(function(Le){function Fe(ne){return{range:E.from(ne.range),kind:ne.kind}}Le.from=Fe;function ke(ne){return new u.$KM(E.to(ne.range),ne.kind)}Le.to=ke})(be||(e.DocumentHighlight=be={}));var Pe;(function(Le){function Fe(ne){return{uri:ne.uri,highlights:ne.highlights.map(be.from)}}Le.from=Fe;function ke(ne){return new u.$LM(a.URI.revive(ne.uri),ne.highlights.map(be.to))}Le.to=ke})(Pe||(e.MultiDocumentHighlight=Pe={}));var Re;(function(Le){function Fe(ke){switch(ke){case 1:return u.CompletionTriggerKind.TriggerCharacter;case 2:return u.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return u.CompletionTriggerKind.Invoke}}Le.to=Fe})(Re||(e.CompletionTriggerKind=Re={}));var ze;(function(Le){function Fe(ke){return{triggerKind:Re.to(ke.triggerKind),triggerCharacter:ke.triggerCharacter}}Le.to=Fe})(ze||(e.CompletionContext=ze={}));var V;(function(Le){function Fe(ne){switch(ne){case u.CompletionItemTag.Deprecated:return 1}}Le.from=Fe;function ke(ne){switch(ne){case 1:return u.CompletionItemTag.Deprecated}}Le.to=ke})(V||(e.CompletionItemTag=V={}));var H;(function(Le){const Fe=new Map([[u.CompletionItemKind.Method,0],[u.CompletionItemKind.Function,1],[u.CompletionItemKind.Constructor,2],[u.CompletionItemKind.Field,3],[u.CompletionItemKind.Variable,4],[u.CompletionItemKind.Class,5],[u.CompletionItemKind.Interface,7],[u.CompletionItemKind.Struct,6],[u.CompletionItemKind.Module,8],[u.CompletionItemKind.Property,9],[u.CompletionItemKind.Unit,12],[u.CompletionItemKind.Value,13],[u.CompletionItemKind.Constant,14],[u.CompletionItemKind.Enum,15],[u.CompletionItemKind.EnumMember,16],[u.CompletionItemKind.Keyword,17],[u.CompletionItemKind.Snippet,27],[u.CompletionItemKind.Text,18],[u.CompletionItemKind.Color,19],[u.CompletionItemKind.File,20],[u.CompletionItemKind.Reference,21],[u.CompletionItemKind.Folder,23],[u.CompletionItemKind.Event,10],[u.CompletionItemKind.Operator,11],[u.CompletionItemKind.TypeParameter,24],[u.CompletionItemKind.Issue,26],[u.CompletionItemKind.User,25]]);function ke(Ge){return Fe.get(Ge)??9}Le.from=ke;const ne=new Map([[0,u.CompletionItemKind.Method],[1,u.CompletionItemKind.Function],[2,u.CompletionItemKind.Constructor],[3,u.CompletionItemKind.Field],[4,u.CompletionItemKind.Variable],[5,u.CompletionItemKind.Class],[7,u.CompletionItemKind.Interface],[6,u.CompletionItemKind.Struct],[8,u.CompletionItemKind.Module],[9,u.CompletionItemKind.Property],[12,u.CompletionItemKind.Unit],[13,u.CompletionItemKind.Value],[14,u.CompletionItemKind.Constant],[15,u.CompletionItemKind.Enum],[16,u.CompletionItemKind.EnumMember],[17,u.CompletionItemKind.Keyword],[27,u.CompletionItemKind.Snippet],[18,u.CompletionItemKind.Text],[19,u.CompletionItemKind.Color],[20,u.CompletionItemKind.File],[21,u.CompletionItemKind.Reference],[23,u.CompletionItemKind.Folder],[10,u.CompletionItemKind.Event],[11,u.CompletionItemKind.Operator],[24,u.CompletionItemKind.TypeParameter],[25,u.CompletionItemKind.User],[26,u.CompletionItemKind.Issue]]);function Oe(Ge){return ne.get(Ge)??u.CompletionItemKind.Property}Le.to=Oe})(H||(e.CompletionItemKind=H={}));var Z;(function(Le){function Fe(ke,ne){const Oe=new u.$2M(ke.label);return Oe.insertText=ke.insertText,Oe.kind=H.to(ke.kind),Oe.tags=ke.tags?.map(V.to),Oe.detail=ke.detail,Oe.documentation=O.$Hk(ke.documentation)?z.to(ke.documentation):ke.documentation,Oe.sortText=ke.sortText,Oe.filterText=ke.filterText,Oe.preselect=ke.preselect,Oe.commitCharacters=ke.commitCharacters,m.$dt.isIRange(ke.range)?Oe.range=E.to(ke.range):typeof ke.range=="object"&&(Oe.range={inserting:E.to(ke.range.insert),replacing:E.to(ke.range.replace)}),Oe.keepWhitespace=typeof ke.insertTextRules>"u"?!1:!!(ke.insertTextRules&1),typeof ke.insertTextRules<"u"&&ke.insertTextRules&4?Oe.insertText=new u.$FM(ke.insertText):(Oe.insertText=ke.insertText,Oe.textEdit=Oe.range instanceof u.$wM?new u.$BM(Oe.range,Oe.insertText):void 0),ke.additionalTextEdits&&ke.additionalTextEdits.length>0&&(Oe.additionalTextEdits=ke.additionalTextEdits.map(Ge=>pe.to(Ge))),Oe.command=ne&&ke.command?ne.fromInternal(ke.command):void 0,Oe}Le.to=Fe})(Z||(e.CompletionItem=Z={}));var X;(function(Le){function Fe(ne){if(typeof ne.label!="string"&&!Array.isArray(ne.label))throw new TypeError("Invalid label");return{label:ne.label,documentation:z.fromStrict(ne.documentation)}}Le.from=Fe;function ke(ne){return{label:ne.label,documentation:O.$Hk(ne.documentation)?z.to(ne.documentation):ne.documentation}}Le.to=ke})(X||(e.ParameterInformation=X={}));var fe;(function(Le){function Fe(ne){return{label:ne.label,documentation:z.fromStrict(ne.documentation),parameters:Array.isArray(ne.parameters)?ne.parameters.map(X.from):[],activeParameter:ne.activeParameter}}Le.from=Fe;function ke(ne){return{label:ne.label,documentation:O.$Hk(ne.documentation)?z.to(ne.documentation):ne.documentation,parameters:Array.isArray(ne.parameters)?ne.parameters.map(X.to):[],activeParameter:ne.activeParameter}}Le.to=ke})(fe||(e.SignatureInformation=fe={}));var we;(function(Le){function Fe(ne){return{activeSignature:ne.activeSignature,activeParameter:ne.activeParameter,signatures:Array.isArray(ne.signatures)?ne.signatures.map(fe.from):[]}}Le.from=Fe;function ke(ne){return{activeSignature:ne.activeSignature,activeParameter:ne.activeParameter,signatures:Array.isArray(ne.signatures)?ne.signatures.map(fe.to):[]}}Le.to=ke})(we||(e.SignatureHelp=we={}));var Te;(function(Le){function Fe(ke,ne){const Oe=new u.$1M(k.to(ne.position),typeof ne.label=="string"?ne.label:ne.label.map(Ve.to.bind(void 0,ke)),ne.kind&&Ze.to(ne.kind));return Oe.textEdits=ne.textEdits&&ne.textEdits.map(pe.to),Oe.tooltip=O.$Hk(ne.tooltip)?z.to(ne.tooltip):ne.tooltip,Oe.paddingLeft=ne.paddingLeft,Oe.paddingRight=ne.paddingRight,Oe}Le.to=Fe})(Te||(e.InlayHint=Te={}));var Ve;(function(Le){function Fe(ke,ne){const Oe=new u.$ZM(ne.label);return Oe.tooltip=O.$Hk(ne.tooltip)?z.to(ne.tooltip):ne.tooltip,l.Command.is(ne.command)&&(Oe.command=ke.fromInternal(ne.command)),ne.location&&(Oe.location=oe.to(ne.location)),Oe}Le.to=Fe})(Ve||(e.InlayHintLabelPart=Ve={}));var Ze;(function(Le){function Fe(ne){return ne}Le.from=Fe;function ke(ne){return ne}Le.to=ke})(Ze||(e.InlayHintKind=Ze={}));var nt;(function(Le){function Fe(ne){return{range:E.from(ne.range),url:ne.target,tooltip:ne.tooltip}}Le.from=Fe;function ke(ne){let Oe;if(ne.url)try{Oe=typeof ne.url=="string"?a.URI.parse(ne.url,!0):a.URI.revive(ne.url)}catch{}return new u.$7M(E.to(ne.range),Oe)}Le.to=ke})(nt||(e.DocumentLink=nt={}));var ot;(function(Le){function Fe(ne){const Oe=new u.$0M(ne.label);return ne.textEdit&&(Oe.textEdit=pe.to(ne.textEdit)),ne.additionalTextEdits&&(Oe.additionalTextEdits=ne.additionalTextEdits.map(Ge=>pe.to(Ge))),Oe}Le.to=Fe;function ke(ne){return{label:ne.label,textEdit:ne.textEdit?pe.from(ne.textEdit):void 0,additionalTextEdits:ne.additionalTextEdits?ne.additionalTextEdits.map(Oe=>pe.from(Oe)):void 0}}Le.from=ke})(ot||(e.ColorPresentation=ot={}));var lt;(function(Le){function Fe(ne){return new u.$8M(ne[0],ne[1],ne[2],ne[3])}Le.to=Fe;function ke(ne){return[ne.red,ne.green,ne.blue,ne.alpha]}Le.from=ke})(lt||(e.Color=lt={}));var at;(function(Le){function Fe(ne){return{range:E.from(ne.range)}}Le.from=Fe;function ke(ne){return new u.$QM(E.to(ne.range))}Le.to=ke})(at||(e.SelectionRange=at={}));var st;(function(Le){function Fe(ke){switch(ke){case 2:return u.TextDocumentSaveReason.AfterDelay;case 1:return u.TextDocumentSaveReason.Manual;case 3:case 4:return u.TextDocumentSaveReason.FocusOut}}Le.to=Fe})(st||(e.TextDocumentSaveReason=st={}));var Ie;(function(Le){function Fe(ne){switch(ne){case u.TextEditorLineNumbersStyle.Off:return 0;case u.TextEditorLineNumbersStyle.Relative:return 2;case u.TextEditorLineNumbersStyle.Interval:return 3;case u.TextEditorLineNumbersStyle.On:default:return 1}}Le.from=Fe;function ke(ne){switch(ne){case 0:return u.TextEditorLineNumbersStyle.Off;case 2:return u.TextEditorLineNumbersStyle.Relative;case 3:return u.TextEditorLineNumbersStyle.Interval;case 1:default:return u.TextEditorLineNumbersStyle.On}}Le.to=ke})(Ie||(e.TextEditorLineNumbersStyle=Ie={}));var We;(function(Le){function Fe(ne){if(ne===u.EndOfLine.CRLF)return 1;if(ne===u.EndOfLine.LF)return 0}Le.from=Fe;function ke(ne){if(ne===1)return u.EndOfLine.CRLF;if(ne===0)return u.EndOfLine.LF}Le.to=ke})(We||(e.EndOfLine=We={}));var Ae;(function(Le){function Fe(ke){if(typeof ke=="object")return ke.viewId;switch(ke){case u.ProgressLocation.SourceControl:return 3;case u.ProgressLocation.Window:return 10;case u.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Le.from=Fe})(Ae||(e.ProgressLocation=Ae={}));var Ke;(function(Le){function Fe(ne){const Oe={start:ne.start+1,end:ne.end+1};return ne.kind&&(Oe.kind=ae.from(ne.kind)),Oe}Le.from=Fe;function ke(ne){const Oe={start:ne.start-1,end:ne.end-1};return ne.kind&&(Oe.kind=ae.to(ne.kind)),Oe}Le.to=ke})(Ke||(e.FoldingRange=Ke={}));var ae;(function(Le){function Fe(ne){if(ne)switch(ne){case u.FoldingRangeKind.Comment:return l.$8t.Comment;case u.FoldingRangeKind.Imports:return l.$8t.Imports;case u.FoldingRangeKind.Region:return l.$8t.Region}}Le.from=Fe;function ke(ne){if(ne)switch(ne.value){case l.$8t.Comment.value:return u.FoldingRangeKind.Comment;case l.$8t.Imports.value:return u.FoldingRangeKind.Imports;case l.$8t.Region.value:return u.FoldingRangeKind.Region}}Le.to=ke})(ae||(e.FoldingRangeKind=ae={}));var ue;(function(Le){function Fe(ke){if(ke)return{pinned:typeof ke.preview=="boolean"?!ke.preview:void 0,inactive:ke.background,preserveFocus:ke.preserveFocus,selection:typeof ke.selection=="object"?E.from(ke.selection):void 0,override:typeof ke.override=="boolean"?r.$0E.id:void 0}}Le.from=Fe})(ue||(e.TextEditorOpenOptions=ue={}));var De;(function(Le){function Fe(Ge){return Ge instanceof u.$sN?Ge.toJSON():typeof Ge=="string"?Ge:ke(Ge)||ne(Ge)?new u.$sN(Ge.baseUri??Ge.base,Ge.pattern).toJSON():Ge}Le.from=Fe;function ke(Ge){const _e=Ge;return _e?a.URI.isUri(_e.baseUri)&&typeof _e.pattern=="string":!1}function ne(Ge){const _e=Ge;return _e?typeof _e.base=="string"&&typeof _e.pattern=="string":!1}function Oe(Ge){return typeof Ge=="string"?Ge:new u.$sN(a.URI.revive(Ge.baseUri),Ge.pattern)}Le.to=Oe})(De||(e.GlobPattern=De={}));var Je;(function(Le){function Fe(ke){if(ke){if(Array.isArray(ke))return ke.map(Fe);if(typeof ke=="string")return ke;{const ne=ke;return{language:ne.language,scheme:ne.scheme,pattern:De.from(ne.pattern),exclusive:ne.exclusive,notebookType:ne.notebookType}}}else return}Le.from=Fe})(Je||(e.LanguageSelector=Je={}));var et;(function(Le){function Fe(ne){return!!ne&&typeof ne=="object"&&"documents"in ne&&Array.isArray(ne.documents)&&ne.documents.every(Oe=>Array.isArray(Oe)&&Oe.every(Ge=>Ge&&typeof Ge=="object"&&"uri"in Ge&&a.URI.isUri(Ge.uri)&&"version"in Ge&&typeof Ge.version=="number"&&"ranges"in Ge&&Array.isArray(Ge.ranges)&&Ge.ranges.every(_e=>_e instanceof u.$wM)))}Le.is=Fe;function ke(ne){return{documents:ne.documents.map(Oe=>Oe.map(Ge=>({uri:a.URI.from(Ge.uri),version:Ge.version,ranges:Ge.ranges.map(_e=>E.from(_e))})))}}Le.from=ke})(et||(e.MappedEditsContext=et={}));var Ne;(function(Le){function Fe(ne){return{start:ne.start,end:ne.end}}Le.from=Fe;function ke(ne){return new u.$VN(ne.start,ne.end)}Le.to=ke})(Ne||(e.NotebookRange=Ne={}));var ht;(function(Le){function Fe(ne){return{timing:typeof ne.runStartTime=="number"&&typeof ne.runEndTime=="number"?{startTime:ne.runStartTime,endTime:ne.runEndTime}:void 0,executionOrder:ne.executionOrder,success:ne.lastRunSuccess}}Le.to=Fe;function ke(ne){return{lastRunSuccess:ne.success,runStartTime:ne.timing?.startTime,runEndTime:ne.timing?.endTime,executionOrder:ne.executionOrder}}Le.from=ke})(ht||(e.NotebookCellExecutionSummary=ht={}));var vt;(function(Le){function Fe(ke){if(ke===t.NotebookCellExecutionState.Unconfirmed)return u.NotebookCellExecutionState.Pending;if(ke===t.NotebookCellExecutionState.Pending)return;if(ke===t.NotebookCellExecutionState.Executing)return u.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ke}`)}Le.to=Fe})(vt||(e.NotebookCellExecutionState=vt={}));var Mt;(function(Le){function Fe(ne){switch(ne){case u.NotebookCellKind.Markup:return t.CellKind.Markup;case u.NotebookCellKind.Code:default:return t.CellKind.Code}}Le.from=Fe;function ke(ne){switch(ne){case t.CellKind.Markup:return u.NotebookCellKind.Markup;case t.CellKind.Code:default:return u.NotebookCellKind.Code}}Le.to=ke})(Mt||(e.NotebookCellKind=Mt={}));var zt;(function(Le){function Fe(ne){const Oe={metadata:ne.metadata??Object.create(null),cells:[]};for(const Ge of ne.cells)u.$WN.validate(Ge),Oe.cells.push(Zt.from(Ge));return Oe}Le.from=Fe;function ke(ne){const Oe=new u.$XN(ne.cells.map(Zt.to));return(0,y.$9f)(ne.metadata)||(Oe.metadata=ne.metadata),Oe}Le.to=ke})(zt||(e.NotebookData=zt={}));var Zt;(function(Le){function Fe(ne){return{cellKind:Mt.from(ne.kind),language:ne.languageId,mime:ne.mime,source:ne.value,metadata:ne.metadata,internalMetadata:ht.from(ne.executionSummary??{}),outputs:ne.outputs?ne.outputs.map(Pt.from):[]}}Le.from=Fe;function ke(ne){return new u.$WN(Mt.to(ne.cellKind),ne.source,ne.language,ne.mime,ne.outputs?ne.outputs.map(Pt.to):void 0,ne.metadata,ne.internalMetadata?ht.to(ne.internalMetadata):void 0)}Le.to=ke})(Zt||(e.NotebookCellData=Zt={}));var xt;(function(Le){function Fe(ne){return{mime:ne.mime,valueBytes:R.$ue.wrap(ne.data)}}Le.from=Fe;function ke(ne){return new u.$YN(ne.valueBytes.buffer,ne.mime)}Le.to=ke})(xt||(e.NotebookCellOutputItem=xt={}));var Pt;(function(Le){function Fe(ne){return{outputId:ne.id,items:ne.items.map(xt.from),metadata:ne.metadata}}Le.from=Fe;function ke(ne){const Oe=ne.items.map(xt.to);return new u.$ZN(Oe,ne.outputId,ne.metadata)}Le.to=ke})(Pt||(e.NotebookCellOutput=Pt={}));var sn;(function(Le){function Fe(Oe){return ne(Oe)?{include:De.from(Oe.include)??void 0,exclude:De.from(Oe.exclude)??void 0}:De.from(Oe)??void 0}Le.from=Fe;function ke(Oe){return ne(Oe)?{include:De.to(Oe.include),exclude:De.to(Oe.exclude)}:De.to(Oe)}Le.to=ke;function ne(Oe){const Ge=Oe;return Ge?!(0,y.$5f)(Ge.include)&&!(0,y.$5f)(Ge.exclude):!1}})(sn||(e.NotebookExclusiveDocumentPattern=sn={}));var _t;(function(Le){function Fe(ke,ne,Oe){const Ge=typeof ke.command=="string"?{title:"",command:ke.command}:ke.command;return{alignment:ke.alignment===u.NotebookCellStatusBarAlignment.Left?1:2,command:ne.toInternal(Ge,Oe),text:ke.text,tooltip:ke.tooltip,accessibilityInformation:ke.accessibilityInformation,priority:ke.priority}}Le.from=Fe})(_t||(e.NotebookStatusBarItem=_t={}));var dn;(function(Le){function Fe(ke,ne,Oe){const Ge=typeof ke.command=="string"?{title:"",command:ke.command}:ke.command;return{command:ne.toInternal(Ge,Oe),label:ke.label,description:ke.description,detail:ke.detail,documentation:ke.documentation}}Le.from=Fe})(dn||(e.NotebookKernelSourceAction=dn={}));var tt;(function(Le){function Fe(ke){return{transientOutputs:ke?.transientOutputs??!1,transientCellMetadata:ke?.transientCellMetadata??{},transientDocumentMetadata:ke?.transientDocumentMetadata??{},cellContentMetadata:ke?.cellContentMetadata??{}}}Le.from=Fe})(tt||(e.NotebookDocumentContentOptions=tt={}));var on;(function(Le){function Fe(ne){return{uri:ne.uri,provides:ne.provides}}Le.from=Fe;function ke(ne){return new u.$2N(a.URI.revive(ne.uri),ne.provides)}Le.to=ke})(on||(e.NotebookRendererScript=on={}));var Gt;(function(Le){function Fe(ne){return{message:z.fromStrict(ne.message)||"",type:0,expected:ne.expectedOutput,actual:ne.actualOutput,contextValue:ne.contextValue,location:ne.location&&{range:E.from(ne.location.range),uri:ne.location.uri}}}Le.from=Fe;function ke(ne){const Oe=new u.$8N(typeof ne.message=="string"?ne.message:z.to(ne.message));return Oe.actualOutput=ne.actual,Oe.expectedOutput=ne.expected,Oe.contextValue=ne.contextValue,Oe.location=ne.location?oe.to(ne.location):void 0,Oe}Le.to=ke})(Gt||(e.TestMessage=Gt={}));var Kt;(function(Le){Le.namespace=d.$jL,Le.denamespace=d.$kL})(Kt||(e.TestTag=Kt={}));var gt;(function(Le){function Fe(ne){const Oe=(0,n.$KO)(ne).controllerId;return{extId:g.$eL.fromExtHostTestItem(ne,Oe).toString(),label:ne.label,uri:a.URI.revive(ne.uri),busy:ne.busy,tags:ne.tags.map(Ge=>Kt.namespace(Oe,Ge.id)),range:m.$dt.lift(E.from(ne.range)),description:ne.description||null,sortText:ne.sortText||null,error:ne.error&&z.fromStrict(ne.error)||null}}Le.from=Fe;function ke(ne){return{parent:void 0,error:void 0,id:g.$eL.fromString(ne.extId).localId,label:ne.label,uri:a.URI.revive(ne.uri),tags:(ne.tags||[]).map(Oe=>{const{tagId:Ge}=Kt.denamespace(Oe);return new u.$9N(Ge)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:E.to(ne.range||void 0),canResolveChildren:!1,busy:ne.busy,description:ne.description||void 0,sortText:ne.sortText||void 0}}Le.toPlain=ke})(gt||(e.TestItem=gt={})),function(Le){function Fe(ne){return{id:ne.id}}Le.from=Fe;function ke(ne){return new u.$9N(ne.id)}Le.to=ke}(Kt||(e.TestTag=Kt={}));var bt;(function(Le){const Fe=(ne,Oe)=>{const Ge=ne.value;if(!Ge)return;const _e={...gt.toPlain(Ge.item),parent:Oe,taskStates:Ge.tasks.map(Ye=>({state:Ye.state,duration:Ye.duration,messages:Ye.messages.filter(dt=>dt.type===0).map(Gt.to)})),children:[]};if(ne.children)for(const Ye of ne.children.values()){const dt=Fe(Ye,_e);dt&&_e.children.push(dt)}return _e};function ke(ne){const Oe=new b.$DO;for(const Ye of ne.items)Oe.insert(g.$eL.fromString(Ye.item.extId).path,Ye);const Ge=[Oe.nodes],_e=[];for(;Ge.length;)for(const Ye of Ge.pop())Ye.value?_e.push(Ye):Ye.children&&Ge.push(Ye.children.values());return{completedAt:ne.completedAt,results:_e.map(Ye=>Fe(Ye)).filter(y.$4f)}}Le.to=ke})(bt||(e.TestResults=bt={}));var Xt;(function(Le){function Fe(Ge){return{covered:Ge.covered,total:Ge.total}}function ke(Ge){return"line"in Ge?k.from(Ge):E.from(Ge)}function ne(Ge){if(typeof Ge.executed=="number"&&Ge.executed<0)throw new Error(`Invalid coverage count ${Ge.executed}`);return"branches"in Ge?{count:Ge.executed,location:ke(Ge.location),type:1,branches:Ge.branches.length?Ge.branches.map(_e=>({count:_e.executed,location:_e.location&&ke(_e.location),label:_e.label})):void 0}:{type:0,name:Ge.name,count:Ge.executed,location:ke(Ge.location)}}Le.fromDetails=ne;function Oe(Ge,_e){return u.$$N(_e.statementCoverage),u.$$N(_e.branchCoverage),u.$$N(_e.declarationCoverage),{id:Ge,uri:_e.uri,statement:Fe(_e.statementCoverage),branch:_e.branchCoverage&&Fe(_e.branchCoverage),declaration:_e.declarationCoverage&&Fe(_e.declarationCoverage)}}Le.fromFile=Oe})(Xt||(e.TestCoverage=Xt={}));var Bt;(function(Le){function Fe(ke){switch(ke){case 1:return u.CodeActionTriggerKind.Invoke;case 2:return u.CodeActionTriggerKind.Automatic}}Le.to=Fe})(Bt||(e.CodeActionTriggerKind=Bt={}));var Vt;(function(Le){function Fe(ne){const Oe=new u.$dO(_.to(ne.kind),ne.name,ne.detail||"",a.URI.revive(ne.uri),E.to(ne.range),E.to(ne.selectionRange));return Oe._sessionId=ne._sessionId,Oe._itemId=ne._itemId,Oe}Le.to=Fe;function ke(ne,Oe,Ge){if(Oe=Oe??ne._sessionId,Ge=Ge??ne._itemId,Oe===void 0||Ge===void 0)throw new Error("invalid item");return{_sessionId:Oe,_itemId:Ge,kind:_.from(ne.kind),name:ne.name,detail:ne.detail??"",uri:ne.uri,range:E.from(ne.range),selectionRange:E.from(ne.selectionRange),tags:ne.tags?.map(U.from)}}Le.from=ke})(Vt||(e.TypeHierarchyItem=Vt={}));var $t;(function(Le){function Fe(ke){if(ke)return{value:ke.value,tooltip:ke.tooltip}}Le.from=Fe})($t||(e.ViewBadge=$t={}));var Rt;(function(Le){function Fe(Ge,_e,Ye){const dt=_e.fileData;return dt?new u.$kN(new u.$lN(dt.name,a.URI.revive(dt.uri),dt.id,(0,M.$db)(()=>Ye(dt.id)))):Ge===A.$As.uriList&&_e.uriListData?new u.$jN(Oe(_e.uriListData)):new u.$jN(_e.asString)}Le.to=Fe;async function ke(Ge,_e){const Ye=await _e.asString();if(Ge===A.$As.uriList)return{asString:Ye,fileData:void 0,uriListData:ne(Ye)};const dt=_e.asFile();return{asString:Ye,fileData:dt?{name:dt.name,uri:dt.uri,id:dt._itemId??dt.id}:void 0}}Le.from=ke;function ne(Ge){return I.$Mt.split(Ge).map(_e=>{if(_e.startsWith("#"))return _e;try{return a.URI.parse(_e)}catch{}return _e})}function Oe(Ge){return I.$Mt.create(Ge.map(_e=>typeof _e=="string"?_e:a.URI.revive(_e)))}})(Rt||(e.DataTransferItem=Rt={}));var cn;(function(Le){function Fe(ne,Oe){const Ge=ne.items.map(([_e,Ye])=>[_e,Rt.to(_e,Ye,Oe)]);return new u.$mN(Ge)}Le.toDataTransfer=Fe;async function ke(ne){const Oe={items:[]},Ge=[];for(const[_e,Ye]of ne)Ge.push((async()=>{Oe.items.push([_e,await Rt.from(_e,Ye)])})());return await Promise.all(Ge),Oe}Le.from=ke})(cn||(e.DataTransfer=cn={}));var en;(function(Le){function Fe(ne,Oe){return{kind:"reply",agentId:ne.participant??Oe?.agentId??"",subCommand:ne.command??Oe?.command,message:ne.prompt,title:ne.label}}Le.from=Fe;function ke(ne){return{prompt:ne.message,label:ne.title,participant:ne.agentId,command:ne.subCommand}}Le.to=ke})(en||(e.ChatFollowup=en={}));var Xe;(function(Le){function Fe(ke){return"commandId"in ke?{kind:"command",title:ke.title??"",commandId:ke.commandId??"",when:ke.when??"",args:ke.args}:{kind:"reply",message:ke.message,title:ke.title,tooltip:ke.tooltip}}Le.from=Fe})(Xe||(e.ChatInlineFollowup=Xe={}));var Yt;(function(Le){function Fe(ne){switch(ne.role){case 0:return new u.$yO(ne.content);case 1:return new u.$zO(ne.content);case 2:return new u.$AO(ne.content)}}Le.to=Fe;function ke(ne){if(ne instanceof u.$yO)return{role:0,content:ne.content};if(ne instanceof u.$zO)return{role:1,content:ne.content};if(ne instanceof u.$AO)return{role:2,content:ne.content};throw new Error("Invalid LanguageModelMessage")}Le.from=ke})(Yt||(e.LanguageModelMessage=Yt={}));var tn;(function(Le){function Fe(Oe){const Ge={};for(const _e of Object.keys(Oe))Ge[_e]=Oe[_e].map(Le.to);return Ge}Le.objectTo=Fe;function ke(Oe){return{level:nn.to(Oe.level),kind:Oe.kind,value:(0,a.$wc)(Oe.value)?a.URI.revive(Oe.value):Oe.value,description:Oe.description}}Le.to=ke;function ne(Oe){return{level:nn.from(Oe.level),kind:Oe.kind,value:Oe.value,description:Oe.description}}Le.from=ne})(tn||(e.ChatVariable=tn={}));var nn;(function(Le){function Fe(ne){switch(ne){case"short":return u.ChatVariableLevel.Short;case"medium":return u.ChatVariableLevel.Medium;case"full":default:return u.ChatVariableLevel.Full}}Le.to=Fe;function ke(ne){switch(ne){case u.ChatVariableLevel.Short:return"short";case u.ChatVariableLevel.Medium:return"medium";case u.ChatVariableLevel.Full:default:return"full"}}Le.from=ke})(nn||(e.ChatVariableLevel=nn={}));var yt;(function(Le){function Fe(ke){switch(ke){case 1:return u.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return u.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return u.InteractiveEditorResponseFeedbackKind.Undone;case 3:return u.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return u.InteractiveEditorResponseFeedbackKind.Bug}}Le.to=Fe})(yt||(e.InteractiveEditorResponseFeedbackKind=yt={}));var Ut;(function(Le){function Fe(ne){return{kind:"markdownContent",content:z.from(ne.value)}}Le.to=Fe;function ke(ne){return new u.$qO(z.to(ne.content))}Le.from=ke})(Ut||(e.ChatResponseMarkdownPart=Ut={}));var Tt;(function(Le){function Fe(ne){const{value:Oe,baseUri:Ge}=ne;function _e(Ye,dt){return Ye.map(St=>{const Dt=a.URI.joinPath(dt,St.name);return{label:St.name,uri:Dt,children:St.children&&_e(St.children,Dt)}})}return{kind:"treeData",treeData:{label:(0,C.$Sg)(Ge),uri:Ge,children:_e(Oe,Ge)}}}Le.to=Fe;function ke(ne){const Oe=(0,w.$Rh)(ne.treeData);function Ge(dt){return dt.map(St=>({name:St.label,children:St.children&&Ge(St.children)}))}const _e=Oe.uri,Ye=Oe.children?Ge(Oe.children):[];return new u.$rO(Ye,_e)}Le.from=ke})(Tt||(e.ChatResponseFilesPart=Tt={}));var Ot;(function(Le){function Fe(ne){return{kind:"inlineReference",name:ne.title,inlineReference:a.URI.isUri(ne.value)?ne.value:v.from(ne.value)}}Le.to=Fe;function ke(ne){const Oe=(0,w.$Rh)(ne);return new u.$sO(a.URI.isUri(Oe.inlineReference)?Oe.inlineReference:v.to(Oe.inlineReference),ne.name)}Le.from=ke})(Ot||(e.ChatResponseAnchorPart=Ot={}));var un;(function(Le){function Fe(ne){return{kind:"progressMessage",content:z.from(ne.value)}}Le.to=Fe;function ke(ne){return new u.$tO(ne.content.value)}Le.from=ke})(un||(e.ChatResponseProgressPart=un={}));var Wt;(function(Le){function Fe(ne,Oe,Ge){return{kind:"command",command:Oe.toInternal(ne.value,Ge)??{command:ne.value.command,title:ne.value.title}}}Le.to=Fe;function ke(ne,Oe){return new u.$uO(Oe.fromInternal(ne.command)??{command:ne.command.id,title:ne.command.title})}Le.from=ke})(Wt||(e.ChatResponseCommandButtonPart=Wt={}));var Ht;(function(Le){function Fe(ne){return"variableName"in ne.value?{kind:"reference",reference:{variableName:ne.value.variableName,value:a.URI.isUri(ne.value.value)||!ne.value.value?ne.value.value:v.from(ne.value.value)}}:{kind:"reference",reference:a.URI.isUri(ne.value)?ne.value:v.from(ne.value)}}Le.to=Fe;function ke(ne){const Oe=(0,w.$Rh)(ne),Ge=_e=>a.URI.isUri(_e)?_e:v.to(_e);return new u.$vO("variableName"in Oe.reference?{variableName:Oe.reference.variableName,value:Oe.reference.value&&Ge(Oe.reference.value)}:Ge(Oe.reference))}Le.from=ke})(Ht||(e.ChatResponseReferencePart=Ht={}));var It;(function(Le){function Fe(Oe,Ge,_e){return Oe instanceof u.$qO?Ut.to(Oe):Oe instanceof u.$sO?Ot.to(Oe):Oe instanceof u.$vO?Ht.to(Oe):Oe instanceof u.$tO?un.to(Oe):Oe instanceof u.$rO?Tt.to(Oe):Oe instanceof u.$uO?Wt.to(Oe,Ge,_e):{kind:"content",content:""}}Le.to=Fe;function ke(Oe,Ge){switch(Oe.kind){case"reference":return Ht.from(Oe);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return ne(Oe,Ge)}}Le.from=ke;function ne(Oe,Ge){switch(Oe.kind){case"markdownContent":return Ut.from(Oe);case"inlineReference":return Ot.from(Oe);case"progressMessage":return;case"treeData":return Tt.from(Oe);case"command":return Wt.from(Oe,Ge)}}Le.fromContent=ne})(It||(e.ChatResponsePart=It={}));var Ft;(function(Le){function Fe(ne,Oe){return"markdownContent"in Oe?((0,c.$dG)(ne,"chatParticipantAdditions"),{content:z.from(Oe.markdownContent),kind:"markdownContent"}):"content"in Oe?"vulnerabilities"in Oe&&Oe.vulnerabilities?((0,c.$dG)(ne,"chatParticipantAdditions"),{content:Oe.content,vulnerabilities:Oe.vulnerabilities,kind:"vulnerability"}):typeof Oe.content=="string"?{content:Oe.content,kind:"content"}:((0,c.$dG)(ne,"chatParticipantAdditions"),{content:z.from(Oe.content),kind:"markdownContent"}):"documents"in Oe?{documents:Oe.documents.map(Ge=>({uri:Ge.uri,version:Ge.version,ranges:Ge.ranges.map(_e=>E.from(_e))})),kind:"usedContext"}:"reference"in Oe?{reference:"uri"in Oe.reference?{uri:Oe.reference.uri,range:E.from(Oe.reference.range)}:Oe.reference,kind:"reference"}:"inlineReference"in Oe?{inlineReference:"uri"in Oe.inlineReference?{uri:Oe.inlineReference.uri,range:E.from(Oe.inlineReference.range)}:Oe.inlineReference,name:Oe.title,kind:"inlineReference"}:"participant"in Oe?((0,c.$dG)(ne,"chatParticipantAdditions"),{agentId:Oe.participant,command:Oe.command,kind:"agentDetection"}):"message"in Oe?{content:z.from(Oe.message),kind:"progressMessage"}:void 0}Le.from=Fe;function ke(ne,Oe){switch(ne.kind){case"markdownContent":return{content:ne.content.value};case"inlineReference":return{inlineReference:(0,a.$wc)(ne.inlineReference)?a.URI.revive(ne.inlineReference):v.to(ne.inlineReference),title:ne.name};case"command":return{command:Oe.fromInternal(ne.command)??{command:ne.command.id,title:ne.command.title}};default:return}}Le.toProgressContent=ke})(Ft||(e.ChatResponseProgress=Ft={}));var rn;(function(Le){function Fe(ke){return{prompt:ke.message,command:ke.command,variables:ke.variables.variables.map(Et.to),location:At.to(ke.location)}}Le.to=Fe})(rn||(e.ChatAgentRequest=rn={}));var At;(function(Le){function Fe(ke){switch(ke){case s.ChatAgentLocation.Notebook:return u.ChatLocation.Notebook;case s.ChatAgentLocation.Terminal:return u.ChatLocation.Terminal;case s.ChatAgentLocation.Panel:return u.ChatLocation.Panel;case s.ChatAgentLocation.Editor:return u.ChatLocation.Editor}}Le.to=Fe})(At||(e.ChatLocation=At={}));var Et;(function(Le){function Fe(ke){return{name:ke.name,range:ke.range&&[ke.range.start,ke.range.endExclusive],values:ke.values.map(tn.to)}}Le.to=Fe})(Et||(e.ChatAgentResolvedVariable=Et={}));var Nt;(function(Le){function Fe(ke){return{label:ke.label,values:ke.values.map(tn.from),insertText:ke.insertText,detail:ke.detail,documentation:ke.documentation}}Le.from=Fe})(Nt||(e.ChatAgentCompletionItem=Nt={}));var fn;(function(Le){function Fe(ke){return{errorDetails:ke.errorDetails,metadata:ke.metadata}}Le.to=Fe})(fn||(e.ChatAgentResult=fn={}));var Ct;(function(Le){function Fe(ke,ne,Oe){if(ne.action.kind==="vote")return;const Ge=fn.to(ke);return ne.action.kind==="command"?{action:{kind:"command",commandButton:Ft.toProgressContent(ne.action.commandButton,Oe)},result:Ge}:ne.action.kind==="followUp"?{action:{kind:"followUp",followup:en.to(ne.action.followup)},result:Ge}:{action:ne.action,result:Ge}}Le.to=Fe})(Ct||(e.ChatAgentUserActionEvent=Ct={}));var ln;(function(Le){function Fe(ke,ne,Oe){return"terminalCommand"in ke?{terminalCommand:ke.terminalCommand,shouldExecute:ke.shouldExecute}:"uri"in ke?{uri:ke.uri}:ne.toInternal(ke,Oe)}Le.from=Fe})(ln||(e.TerminalQuickFix=ln={}));var Jt;(function(Le){function Fe(ke){return{kind:En.to(ke.kind)}}Le.to=Fe})(Jt||(e.PartialAcceptInfo=Jt={}));var En;(function(Le){function Fe(ke){switch(ke){case 0:return u.PartialAcceptTriggerKind.Word;case 1:return u.PartialAcceptTriggerKind.Line;case 2:return u.PartialAcceptTriggerKind.Suggest;default:return u.PartialAcceptTriggerKind.Unknown}}Le.to=Fe})(En||(e.PartialAcceptTriggerKind=En={}));var wn;(function(Le){function Fe(ke,ne){return{id:ne,label:ke.label,description:ke.description,canEdit:ke.canEdit,collapsibleState:ke.collapsibleState||0,contextValue:ke.contextValue}}Le.from=Fe})(wn||(e.DebugTreeItem=wn={}))}),define(Ee[327],Ce([1,0,6,20,16]),function(re,e,o,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ljc=void 0;let M=class{constructor(p,$){this.a=p.getProxy(o.$sM.MainThreadBulkEdits),this.b={getTextDocumentVersion:w=>$.getDocument(w)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(p,$,w){const A=I.WorkspaceEdit.from(p,this.b);return this.a.$tryApplyWorkspaceEdit(A,void 0,w?.isRefactoring??!1)}};e.$Ljc=M,e.$Ljc=M=Qe([He(0,R.$OO)],M)}),define(Ee[328],Ce([1,0,19,8,47,4,39,3,40,18,2,218,25,6,16,7,289,26]),function(re,e,o,R,I,M,O,p,$,w,A,P,b,C,y,a,m,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Njc=void 0;class i{constructor(t,g,d,h,c,u){this.i=t,this.j=g,this.k=d,this.l=h,this.m=c,this.n=u,this.b=$.$3d.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let g=function(h){if(t.c){const c=new Error("Response stream has been closed");throw Error.captureStackTrace(c,h),c}};const t=this;this.b.reset();const d=h=>{typeof this.d>"u"&&"content"in h&&(this.d=this.b.elapsed()),this.k.$handleProgressChunk(this.j.requestId,h)};this.g={markdown(h){g(this.markdown);const c=new a.$qO(h),u=y.ChatResponseMarkdownPart.to(c);return d(u),this},filetree(h,c){g(this.filetree);const u=new a.$rO(h,c),f=y.ChatResponseFilesPart.to(u);return d(f),this},anchor(h,c){g(this.anchor);const u=new a.$sO(h,c),f=y.ChatResponseAnchorPart.to(u);return d(f),this},button(h){g(this.anchor);const c=new a.$uO(h),u=y.ChatResponseCommandButtonPart.to(c,t.m,t.n);return d(u),this},progress(h){g(this.progress);const c=new a.$tO(h),u=y.ChatResponseProgressPart.to(c);return d(u),this},reference(h){if(g(this.reference),"variableName"in h&&!h.value){const c=t.j.variables.variables.find(u=>u.name===h.variableName);if(c){let u;if(c.references?.length)u=c.references.map(f=>({kind:"reference",reference:{variableName:h.variableName,value:f.reference}}));else{const f=new a.$vO(h);u=[y.ChatResponseReferencePart.to(f)]}return u.forEach(f=>d(f)),this}}else{const c=new a.$vO(h),u=y.ChatResponseReferencePart.to(c);d(u)}return this},push(h){if(g(this.push),h instanceof a.$vO)this.reference(h.value);else{const c=y.ChatResponsePart.to(h,t.m,t.n);d(c)}return this},report(h){if(g(this.report),"placeholder"in h&&"resolvedContent"in h)return;const c=y.ChatResponseProgress.from(t.i,h);if(!c){t.l.error("Unknown progress type: "+JSON.stringify(h));return}return d(c),this}}}return this.g}}class n{constructor(t,g,d){this.i=g,this.j=d,this.c=new Map,this.g=new p.$4c,this.d=t.getProxy(C.$sM.MainThreadChatAgents2)}createChatAgent(t,g,d){const h=n.b++,c=new r(t,g,this.d,h,d);return this.c.set(h,c),this.d.$registerAgent(h,t.identifier,g,{},void 0),c.apiAgent}createDynamicChatAgent(t,g,d,h,c){const u=n.b++,f=new r(t,g,this.d,u,c);return this.c.set(u,f),this.d.$registerAgent(u,t.identifier,g,{},{name:d,description:h}),f.apiAgent}async $invokeAgent(t,g,d,h){const c=this.c.get(t);if(!c)throw new Error(`[CHAT](${t}) CANNOT invoke agent because the agent is not registered`);let u=this.g.get(g.sessionId);u||(u=new p.$Tc,this.g.set(g.sessionId,u));const f=new i(c.extension,g,this.d,this.i,this.j.converter,u);try{const E=await this.k(g.agentId,d),v=c.invoke(y.ChatAgentRequest.to(g),{history:E},f.apiObject,h);return await(0,R.$9g)(Promise.resolve(v).then(D=>{if(D?.metadata)try{JSON.stringify(D.metadata)}catch(k){const S=`result.metadata MUST be JSON.stringify-able. Got error: ${k.message}`;return this.i.error(`[${c.extension.identifier.value}] [@${c.id}] ${S}`,c.extension),{errorDetails:{message:S},timings:f.timings}}return{errorDetails:D?.errorDetails,timings:f.timings,metadata:D?.metadata}}),h)}catch(E){return this.i.error(E,c.extension),{errorDetails:{message:(0,P.localize)(0,null,(0,I.$6i)(E)),responseIsIncomplete:!0}}}finally{f.close()}}async k(t,g){const d=[];for(const h of g.history){const c=y.ChatAgentResult.to(h.result),u=t===h.request.agentId?c:{...c,metadata:void 0};d.push(new a.$wO(h.request.message,h.request.command,h.request.variables.variables.map(y.ChatAgentResolvedVariable.to),h.request.agentId));const f=(0,o.$Hb)(h.response.map(E=>y.ChatResponsePart.fromContent(E,this.j.converter)));d.push(new a.$xO(f,u,h.request.agentId,h.request.command))}return d}$releaseSession(t){this.g.deleteAndDispose(t)}async $provideFollowups(t,g,d,h,c){const u=this.c.get(g);if(!u)return Promise.resolve([]);const f=await this.k(u.id,h),E=y.ChatAgentResult.to(d);return(await u.provideFollowups(E,{history:f},c)).filter(v=>{const D=!v.participant||O.Iterable.some(this.c.values(),k=>k.id===v.participant&&b.$Em.equals(k.extension.identifier,u.extension.identifier));return D||this.i.warn(`[@${u.id}] ChatFollowup refers to an unknown participant: ${v.participant}`),D}).map(v=>y.ChatFollowup.from(v,t))}$acceptFeedback(t,g,d,h){const c=this.c.get(t);if(!c)return;const u=y.ChatAgentResult.to(g);let f;switch(d){case m.InteractiveSessionVoteDirection.Down:f=a.ChatResultFeedbackKind.Unhelpful;break;case m.InteractiveSessionVoteDirection.Up:f=a.ChatResultFeedbackKind.Helpful;break}c.acceptFeedback(Object.freeze(h?{result:u,kind:f,reportIssue:h}:{result:u,kind:f}))}$acceptAction(t,g,d){const h=this.c.get(t);if(!h||d.action.kind==="vote")return;const c=y.ChatAgentUserActionEvent.to(g,d,this.j.converter);c&&h.acceptAction(Object.freeze(c))}async $invokeCompletionProvider(t,g,d){const h=this.c.get(t);return h?(await h.invokeCompletionProvider(g,d)).map(y.ChatAgentCompletionItem.from):[]}async $provideWelcomeMessage(t,g){const d=this.c.get(t);if(d)return await d.provideWelcomeMessage(g)}async $provideSampleQuestions(t,g){const d=this.c.get(t);if(d)return(await d.provideSampleQuestions(g)).map(h=>y.ChatFollowup.from(h,void 0))}}e.$Njc=n,n.b=0;class r{constructor(t,g,d,h,c){this.extension=t,this.id=g,this.u=d,this.w=h,this.x=c,this.n=new M.$7d,this.o=new M.$7d}acceptFeedback(t){this.n.fire(t)}acceptAction(t){this.o.fire(t)}async invokeCompletionProvider(t,g){return this.q?await this.q.provider.provideCompletionItems(t,g)??[]:[]}async provideFollowups(t,g,d){if(!this.b)return[];const h=await this.b.provideFollowups(t,g,d);return h?h.filter(c=>!(c&&"commandId"in c)).filter(c=>!(c&&"message"in c)):[]}async provideWelcomeMessage(t){if(!this.s)return[];const g=await this.s.provideWelcomeMessage(t);return g?g.map(d=>typeof d=="string"?d:y.MarkdownString.from(d)):[]}async provideSampleQuestions(t){if(!this.s||!this.s.provideSampleQuestions)return[];const g=await this.s.provideSampleQuestions(t);return g||[]}get apiAgent(){let t=!1,g=!1;const d=()=>{t||g||(g=!0,queueMicrotask(()=>{this.u.$updateAgent(this.w,{fullName:this.c,icon:this.d?this.d instanceof A.URI?this.d:"light"in this.d?this.d.light:void 0:void 0,iconDark:this.d&&"dark"in this.d?this.d.dark:void 0,themeIcon:this.d instanceof a.$qN?this.d:void 0,hasFollowups:this.b!==void 0,isSecondary:this.m,helpTextPrefix:!this.i||typeof this.i=="string"?this.i:y.MarkdownString.from(this.i),helpTextVariablesPrefix:!this.j||typeof this.j=="string"?this.j:y.MarkdownString.from(this.j),helpTextPostfix:!this.k||typeof this.k=="string"?this.k:y.MarkdownString.from(this.k),sampleRequest:this.l,supportIssueReporting:this.p,requester:this.t}),g=!1}))},h=this;return{get id(){return h.id},get fullName(){return(0,l.$dG)(h.extension,"defaultChatParticipant"),h.c??h.extension.displayName??h.extension.name},set fullName(c){(0,l.$dG)(h.extension,"defaultChatParticipant"),h.c=c,d()},get iconPath(){return h.d},set iconPath(c){h.d=c,d()},get requestHandler(){return h.x},set requestHandler(c){(0,w.$6f)(typeof c=="function","Invalid request handler"),h.x=c},get followupProvider(){return h.b},set followupProvider(c){h.b=c,d()},get isDefault(){return(0,l.$dG)(h.extension,"defaultChatParticipant"),h.g},set isDefault(c){(0,l.$dG)(h.extension,"defaultChatParticipant"),h.g=c,d()},get helpTextPrefix(){return(0,l.$dG)(h.extension,"defaultChatParticipant"),h.i},set helpTextPrefix(c){(0,l.$dG)(h.extension,"defaultChatParticipant"),h.i=c,d()},get helpTextVariablesPrefix(){return(0,l.$dG)(h.extension,"defaultChatParticipant"),h.j},set helpTextVariablesPrefix(c){(0,l.$dG)(h.extension,"defaultChatParticipant"),h.j=c,d()},get helpTextPostfix(){return(0,l.$dG)(h.extension,"defaultChatParticipant"),h.k},set helpTextPostfix(c){(0,l.$dG)(h.extension,"defaultChatParticipant"),h.k=c,d()},get isSecondary(){return(0,l.$dG)(h.extension,"defaultChatParticipant"),h.m},set isSecondary(c){(0,l.$dG)(h.extension,"defaultChatParticipant"),h.m=c,d()},get sampleRequest(){return h.l},set sampleRequest(c){h.l=c,d()},get supportIssueReporting(){return(0,l.$dG)(h.extension,"chatParticipantAdditions"),h.p},set supportIssueReporting(c){(0,l.$dG)(h.extension,"chatParticipantAdditions"),h.p=c,d()},get onDidReceiveFeedback(){return h.n.event},set participantVariableProvider(c){if((0,l.$dG)(h.extension,"chatParticipantAdditions"),h.q=c,c){if(!c.triggerCharacters.length)throw new Error("triggerCharacters are required");h.u.$registerAgentCompletionsProvider(h.w,c.triggerCharacters)}else h.u.$unregisterAgentCompletionsProvider(h.w)},get participantVariableProvider(){return(0,l.$dG)(h.extension,"chatParticipantAdditions"),h.q},set welcomeMessageProvider(c){(0,l.$dG)(h.extension,"defaultChatParticipant"),h.s=c,d()},get welcomeMessageProvider(){return(0,l.$dG)(h.extension,"defaultChatParticipant"),h.s},onDidPerformAction:(0,l.$cG)(this.extension,"chatParticipantAdditions")?this.o.event:void 0,set requester(c){h.t=c,d()},get requester(){return h.t},dispose(){t=!0,h.b=void 0,h.n.dispose(),h.u.$unregisterAgent(h.w)}}}invoke(t,g,d,h){return this.x(t,g,d,h)}}}),define(Ee[329],Ce([1,0,13,3,6,16,7,26]),function(re,e,o,R,I,M,O,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qjc=void 0;class ${constructor(P){this.b=new Map,this.c=P.getProxy(I.$sM.MainThreadChatVariables)}async $resolveVariable(P,b,C,y){const a=this.b.get(P);if(a)try{if(a.resolver.resolve2){(0,p.$dG)(a.extension,"chatParticipantAdditions");const m=new w(b,this.c),l=await a.resolver.resolve2(a.data.name,{prompt:C},m.apiObject,y);if(l)return l.map(M.ChatVariable.from)}else{const m=await a.resolver.resolve(a.data.name,{prompt:C},y);if(m)return m.map(M.ChatVariable.from)}}catch(m){(0,o.$2)(m)}}registerVariableResolver(P,b,C,y){const a=$.a++;return this.b.set(a,{extension:P,data:{name:b,description:C},resolver:y}),this.c.$registerVariable(a,{name:b,description:C}),(0,R.$Sc)(()=>{this.b.delete(a),this.c.$unregisterVariable(a)})}}e.$Qjc=$,$.a=0;class w{constructor(P,b){this.c=P,this.d=b,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let b=function(y){if(P.a){const a=new Error("Response stream has been closed");throw Error.captureStackTrace(a,y),a}};const P=this,C=y=>{this.d.$handleProgressChunk(this.c,y)};this.b={progress(y){b(this.progress);const a=new O.$tO(y),m=M.ChatResponseProgressPart.to(a);return C(m),this},reference(y){b(this.reference);const a=new O.$vO(y),m=M.ChatResponseReferencePart.to(a);return C(m),this},push(y){return b(this.push),y instanceof O.$vO?C(M.ChatResponseReferencePart.to(y)):y instanceof O.$tO&&C(M.ChatResponseProgressPart.to(y)),this}}}return this.b}}}),define(Ee[330],Ce([1,0,8,54,4,3,2,83,25,16,7,6,26]),function(re,e,o,R,I,M,O,p,$,w,A,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ujc=C;function C(y,a,m){const l=y.getProxy(P.$sM.MainThreadComments);class i{constructor(){this.b=new Map,this.c=new $.$Gm,a.registerArgumentProcessor({processArgument:f=>{if(f&&f.$mid===6){const E=this.b.get(f.handle);return E?E.value:f}else if(f&&f.$mid===7){const E=f,v=this.b.get(E.commentControlHandle);if(!v)return E;const D=v.getCommentThread(E.commentThreadHandle);return D?D.value:E}else if(f&&(f.$mid===9||f.$mid===8)){const E=this.b.get(f.thread.commentControlHandle);if(!E)return f;const v=E.getCommentThread(f.thread.commentThreadHandle);return v?f.$mid===8?v.value:{thread:v.value,text:f.text}:f}else if(f&&f.$mid===10){const E=this.b.get(f.thread.commentControlHandle);if(!E)return f;const v=E.getCommentThread(f.thread.commentThreadHandle);if(!v)return f;const D=f.commentUniqueId,k=v.getCommentByUniqueId(D);return k||f}else if(f&&f.$mid===11){const E=this.b.get(f.thread.commentControlHandle);if(!E)return f;const v=E.getCommentThread(f.thread.commentThreadHandle);if(!v)return f;const D=f.text,k=f.commentUniqueId,S=v.getCommentByUniqueId(k);return S?(typeof S.body=="string"?S.body=D:S.body=new A.$VM(D),S):f}return f}})}createCommentController(f,E,v){const D=i.a++,k=new r(f,D,E,v);this.b.set(k.handle,k);const S=this.c.get(f.identifier)||[];return S.push(k),this.c.set(f.identifier,S),k.value}async $createCommentThreadTemplate(f,E,v){const D=this.b.get(f);D&&D.$createCommentThreadTemplate(E,v)}async $setActiveComment(f,E){const v=this.b.get(f);v&&v.$setActiveComment(E??void 0)}async $updateCommentThreadTemplate(f,E,v){const D=this.b.get(f);D&&D.$updateCommentThreadTemplate(E,v)}$deleteCommentThread(f,E){this.b.get(f)?.$deleteCommentThread(E)}async $provideCommentingRanges(f,E,v){const D=this.b.get(f);if(!D||!D.commentingRangeProvider)return Promise.resolve(void 0);const k=await m.ensureDocumentData(O.URI.revive(E));return(0,o.$ah)(async()=>{const S=await D.commentingRangeProvider.provideCommentingRanges(k.document,v);let F;return Array.isArray(S)?F={ranges:S,fileComments:!1}:S?F={ranges:S.ranges||[],fileComments:S.fileComments||!1}:F=S??void 0,F}).then(S=>{let F;return S&&(F={ranges:S.ranges.map(W=>w.Range.from(W)),fileComments:S.fileComments}),F})}$toggleReaction(f,E,v,D,k){const S=this.b.get(f);return!S||!S.reactionHandler?Promise.resolve(void 0):(0,o.$ah)(()=>{const F=S.getCommentThread(E);if(F){const W=F.getCommentByUniqueId(D.uniqueIdInThread);if(S!==void 0&&W&&S.reactionHandler)return S.reactionHandler(W,g(k))}return Promise.resolve(void 0)})}}i.a=0;class n{set threadId(f){this.n=f}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(f){(f===void 0!=(this.p===void 0)||!f||!this.p||!f.isEqual(this.p))&&(this.p=f,this.b.range=f,this.c.fire())}get range(){return this.p}set canReply(f){this.d!==f&&(this.d=f,this.b.canReply=f,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(f){this.e=f,this.b.label=f,this.c.fire()}get contextValue(){return this.f}set contextValue(f){this.f=f,this.b.contextValue=f,this.c.fire()}get comments(){return this.q}set comments(f){this.q=f,this.b.comments=f,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(f){this.g=f,this.b.collapsibleState=f,this.c.fire()}get state(){return this.h}set state(f){this.h=f,typeof f=="object"?((0,b.$dG)(this.extensionDescription,"commentThreadApplicability"),this.b.state=f.resolved,this.b.applicability=f.applicability):this.b.state=f,this.c.fire()}get isDisposed(){return this.j}constructor(f,E,v,D,k,S,F,W){this.m=E,this.n=v,this.o=D,this.p=k,this.q=S,this.extensionDescription=F,this.r=W,this.handle=n.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new I.$7d,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new M.$Vc,this.l.value=new M.$Tc,this.n===void 0&&(this.n=`${f}.${this.handle}`),l.$createCommentThread(E,this.handle,this.n,this.o,w.Range.from(this.p),F.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=S,this.i.push({dispose:()=>{l.$deleteCommentThread(E,this.handle)}});const B=this;this.value={get uri(){return B.uri},get range(){return B.range},set range(T){B.range=T},get comments(){return B.comments},set comments(T){B.comments=T},get collapsibleState(){return B.collapsibleState},set collapsibleState(T){B.collapsibleState=T},get canReply(){return B.canReply},set canReply(T){B.canReply=T},get contextValue(){return B.contextValue},set contextValue(T){B.contextValue=T},get label(){return B.label},set label(T){B.label=T},get state(){return B.state},set state(T){B.state=T},dispose:()=>{B.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new M.$Tc);const f=v=>Object.prototype.hasOwnProperty.call(this.b,v),E={};f("range")&&(E.range=w.Range.from(this.p)),f("label")&&(E.label=this.label),f("contextValue")&&(E.contextValue=this.contextValue??null),f("comments")&&(E.comments=this.q.map(v=>s(this,v,this.k,this.extensionDescription))),f("collapsibleState")&&(E.collapseState=d(this.g)),f("canReply")&&(E.canReply=this.canReply),f("state")&&(E.state=h(this.h)),f("applicability")&&(E.applicability=c(this.h)),f("isTemplate")&&(E.isTemplate=this.r),this.b={},l.$updateCommentThread(this.m,this.handle,this.n,this.o,E)}getCommentByUniqueId(f){for(const E of this.k){const v=E[0],D=E[1];if(f===D)return v}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(f=>f.dispose())}}n.a=0,Qe([(0,R.$Nh)(100)],n.prototype,"eventuallyUpdateCommentThread",null);class r{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(f){this.b=f,f?.resourceHints&&(0,b.$dG)(this.h,"commentingRangeHint"),l.$updateCommentingRanges(this.handle,f?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(f){this.c=f,l.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!f})}get options(){return this.d}set options(f){this.d=f,l.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,b.$dG)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,b.$dG)(this.h,"activeComment"),this.f}constructor(f,E,v,D){this.h=f,this.i=E,this.j=v,this.k=D,this.a=new Map,l.$registerCommentController(this.handle,v,D,this.h.identifier.value);const k=this;this.value=Object.freeze({id:k.id,label:k.label,get options(){return k.options},set options(S){k.options=S},get commentingRangeProvider(){return k.commentingRangeProvider},set commentingRangeProvider(S){k.commentingRangeProvider=S},get reactionHandler(){return k.reactionHandler},set reactionHandler(S){k.reactionHandler=S},get activeCommentThread(){return k.activeCommentThread},createCommentThread(S,F,W){return k.createCommentThread(S,F,W).value},dispose:()=>{k.dispose()}}),this.g=[],this.g.push({dispose:()=>{l.$unregisterCommentController(this.handle)}})}createCommentThread(f,E,v){E===void 0&&(0,b.$dG)(this.h,"fileComments");const D=new n(this.id,this.handle,void 0,f,E,v,this.h,!1);return this.a.set(D.handle,D),D}$setActiveComment(f){if(!f){this.e=void 0,this.f=void 0;return}const E=this.a.get(f.commentThreadHandle);E&&(this.e=f.uniqueIdInThread?E.getCommentByUniqueId(f.uniqueIdInThread):void 0,this.f=E)}$createCommentThreadTemplate(f,E){const v=new n(this.id,this.handle,void 0,O.URI.revive(f),w.Range.to(E),[],this.h,!0);return v.collapsibleState=p.CommentThreadCollapsibleState.Expanded,this.a.set(v.handle,v),v}$updateCommentThreadTemplate(f,E){const v=this.a.get(f);v&&(v.range=w.Range.to(E))}$deleteCommentThread(f){this.a.get(f)?.dispose(),this.a.delete(f)}getCommentThread(f){return this.a.get(f)}dispose(){this.a.forEach(f=>{f.dispose()}),this.g.forEach(f=>f.dispose())}}function s(u,f,E,v){let D=E.get(f);return D||(D=++u.commentHandle,E.set(f,D)),f.state!==void 0&&(0,b.$dG)(v,"commentsDraftState"),f.reactions?.some(k=>k.reactors!==void 0)&&(0,b.$dG)(v,"commentReactor"),{mode:f.mode,contextValue:f.contextValue,uniqueIdInThread:D,body:typeof f.body=="string"?f.body:w.MarkdownString.from(f.body),userName:f.author.name,userIconPath:f.author.iconPath,label:f.label,commentReactions:f.reactions?f.reactions.map(k=>t(k)):void 0,state:f.state,timestamp:f.timestamp?.toJSON()}}function t(u){return{label:u.label,iconPath:u.iconPath?w.$NO(u.iconPath):void 0,count:u.count,hasReacted:u.authorHasReacted,reactors:u.reactors&&u.reactors.length>0&&typeof u.reactors[0]!="string"?u.reactors.map(f=>f.name):u.reactors}}function g(u){return{label:u.label||"",count:u.count||0,iconPath:u.iconPath?O.URI.revive(u.iconPath):"",authorHasReacted:u.hasReacted||!1,reactors:u.reactors?.map(f=>({name:f}))}}function d(u){if(u!==void 0)switch(u){case A.CommentThreadCollapsibleState.Expanded:return p.CommentThreadCollapsibleState.Expanded;case A.CommentThreadCollapsibleState.Collapsed:return p.CommentThreadCollapsibleState.Collapsed}return p.CommentThreadCollapsibleState.Collapsed}function h(u){let f;if(typeof u=="object"?f=u.resolved:f=u,f!==void 0)switch(f){case A.CommentThreadState.Unresolved:return p.CommentThreadState.Unresolved;case A.CommentThreadState.Resolved:return p.CommentThreadState.Resolved}return p.CommentThreadState.Unresolved}function c(u){let f;if(typeof u=="object"&&(f=u.applicability),f!==void 0)switch(f){case A.CommentThreadApplicability.Current:return p.CommentThreadApplicability.Current;case A.CommentThreadApplicability.Outdated:return p.CommentThreadApplicability.Outdated}return p.CommentThreadApplicability.Current}return new i}}),define(Ee[331],Ce([1,0,22,55,3,15,23,2,16,92,111,6,7]),function(re,e,o,R,I,M,O,p,$,w,A,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$akc=void 0;class C{constructor(g,d){this.document=g,this.b=d,this.a=1,this.c=new A.$xjc("custom documents")}addEdit(g){return this.c.add([g])}async undo(g,d){await this.f(g).undo(),d||this.disposeBackup()}async redo(g,d){await this.f(g).redo(),d||this.disposeBackup()}disposeEdits(g){for(const d of g)this.c.delete(d)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const g=s(this.document.uri)+this.a++;return(0,O.$Vg)(this.b,g)}updateBackup(g){this.d?.delete(),this.d=g}disposeBackup(){this.d?.delete(),this.d=void 0}f(g){const d=this.c.get(g,0);if(!d)throw new Error("No edit found");return d}}class y{constructor(){this.a=new Map}get(g,d){return this.a.get(this.b(g,d))}add(g,d,h){const c=this.b(g,d.uri);if(this.a.has(c))throw new Error(`Document already exists for viewType:${g} resource:${d.uri}`);const u=new C(d,h);return this.a.set(c,u),u}delete(g,d){const h=this.b(g,d.uri);this.a.delete(h)}b(g,d){return`${g}@@@${d}`}}var a;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(a||(a={}));class m{constructor(){this.a=new Map}addTextProvider(g,d,h){return this.b(0,g,d,h)}addCustomProvider(g,d,h){return this.b(1,g,d,h)}get(g){return this.a.get(g)}b(g,d,h,c){if(this.a.has(d))throw new Error(`Provider for viewType:${d} already registered`);return this.a.set(d,{type:g,extension:h,provider:c}),new b.$uM(()=>this.a.delete(d))}}class l{constructor(g,d,h,c,u){this.d=d,this.f=h,this.g=c,this.h=u,this.b=new m,this.c=new y,this.a=g.getProxy(P.$sM.MainThreadCustomEditors)}registerCustomEditorProvider(g,d,h,c){const u=new I.$Tc;return n(h)?(u.add(this.b.addTextProvider(d,g,h)),this.a.$registerTextEditorProvider((0,w.$0jc)(g),d,c.webviewOptions||{},{supportsMove:!!h.moveCustomTextEditor},(0,w.$8jc)(g))):(u.add(this.b.addCustomProvider(d,g,h)),i(h)&&u.add(h.onDidChangeCustomDocument(f=>{const E=this.i(d,f.document.uri);if(r(f)){const v=E.addEdit(f);this.a.$onDidEdit(f.document.uri,d,v,f.label)}else this.a.$onContentChange(f.document.uri,d)})),this.a.$registerCustomEditorProvider((0,w.$0jc)(g),d,c.webviewOptions||{},!!c.supportsMultipleEditorsPerDocument,(0,w.$8jc)(g))),b.$uM.from(u,new b.$uM(()=>{this.a.$unregisterEditorProvider(d)}))}async $createCustomDocument(g,d,h,c,u){const f=this.b.get(d);if(!f)throw new Error(`No provider found for '${d}'`);if(f.type!==1)throw new Error(`Invalid provide type for '${d}'`);const E=p.URI.revive(g),v=await f.provider.openCustomDocument(E,{backupId:h,untitledDocumentData:c?.buffer},u);let D;return i(f.provider)&&this.f&&(D=this.f.workspaceValue(f.extension)??this.f.globalValue(f.extension)),this.c.add(d,v,D),{editable:i(f.provider)}}async $disposeCustomDocument(g,d){const h=this.b.get(d);if(!h)throw new Error(`No provider found for '${d}'`);if(h.type!==1)throw new Error(`Invalid provider type for '${d}'`);const c=p.URI.revive(g),{document:u}=this.i(d,c);this.c.delete(d,u),u.dispose()}async $resolveCustomEditor(g,d,h,c,u,f){const E=this.b.get(h);if(!E)throw new Error(`No provider found for '${h}'`);const v=$.ViewColumn.to(u),D=this.g.createNewWebview(d,c.contentOptions,E.extension),k=this.h.createNewWebviewPanel(d,h,c.title,v,c.options,D,c.active),S=p.URI.revive(g);switch(E.type){case 1:{const{document:F}=this.i(h,S);return E.provider.resolveCustomEditor(F,k,f)}case 0:{const F=this.d.getDocument(S);return E.provider.resolveCustomTextEditor(F,k,f)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(g,d,h){this.i(d,g).disposeEdits(h)}async $onMoveCustomEditor(g,d,h){const c=this.b.get(h);if(!c)throw new Error(`No provider found for '${h}'`);if(!c.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${h}'`);const u=this.h.getWebviewPanel(g);if(!u)throw new Error("No webview found");const f=p.URI.revive(d),E=this.d.getDocument(f);await c.provider.moveCustomTextEditor(E,u,o.CancellationToken.None)}async $undo(g,d,h,c){return this.i(d,g).undo(h,c)}async $redo(g,d,h,c){return this.i(d,g).redo(h,c)}async $revert(g,d,h){const c=this.i(d,g);await this.j(d).revertCustomDocument(c.document,h),c.disposeBackup()}async $onSave(g,d,h){const c=this.i(d,g);await this.j(d).saveCustomDocument(c.document,h),c.disposeBackup()}async $onSaveAs(g,d,h,c){const u=this.i(d,g);return this.j(d).saveCustomDocumentAs(u.document,p.URI.revive(h),c)}async $backup(g,d,h){const c=this.i(d,g),f=await this.j(d).backupCustomDocument(c.document,{destination:c.getNewBackupUri()},h);return c.updateBackup(f),f.id}i(g,d){const h=this.c.get(g,p.URI.revive(d));if(!h)throw new Error("No custom document found");return h}j(g){const h=this.b.get(g)?.provider;if(!h||!i(h))throw new Error("Custom document is not editable");return h}}e.$akc=l;function i(t){return!!t.onDidChangeCustomDocument}function n(t){return typeof t.resolveCustomTextEditor=="function"}function r(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function s(t){const g=t.scheme===M.Schemas.file||t.scheme===M.Schemas.untitled?t.fsPath:t.toString();return(0,R.$9i)(g)+""}});var it=this&&this.__classPrivateFieldSet||function(re,e,o,R,I){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!I:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?I.call(re,o):I?I.value=o:e.set(re,o),o},qe=this&&this.__classPrivateFieldGet||function(re,e,o,R){if(o==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!R:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?R:o==="a"?R.call(re):R?R.value:e.get(re)};define(Ee[332],Ce([1,0,219,139,2,6,7,16,4,12,27,59]),function(re,e,o,R,I,M,O,p,$,w,A,P){"use strict";var b,C,y,a;Object.defineProperty(e,"__esModule",{value:!0}),e.$Fjc=e.$Ejc=void 0;class m{constructor(n,r,s,t,g,d,h,c){this.d=n,this.e=r,this.f=s,this.g=t,this.h=g,b.set(this,void 0),C.set(this,void 0),y.set(this,void 0),this.c=!1,this.f=Math.max(t,s),it(this,y,new A.$Bc(u=>d.getComparisonKey(u)),"f"),it(this,b,h,"f"),it(this,C,c,"f")}dispose(){this.c||(qe(this,C,"f").fire([...qe(this,y,"f").keys()]),qe(this,b,"f")?.$clear(this.e),qe(this,y,"f").clear(),this.c=!0)}get name(){return this.j(),this.d}set(n,r){if(!n){this.clear();return}this.j();let s=[];if(I.URI.isUri(n)){if(!r){this.delete(n);return}qe(this,y,"f").set(n,r.slice()),s=[n]}else if(Array.isArray(n)){s=[];let d;n=[...n].sort(m.k);for(const h of n){const[c,u]=h;if((!d||c.toString()!==d.toString())&&(d&&qe(this,y,"f").get(d).length===0&&qe(this,y,"f").delete(d),d=c,s.push(c),qe(this,y,"f").set(c,[])),u)qe(this,y,"f").get(c)?.push(...u);else{const f=qe(this,y,"f").get(c);f&&(f.length=0)}}}if(qe(this,C,"f").fire(s),!qe(this,b,"f"))return;const t=[];let g=0;for(const d of s){let h=[];const c=qe(this,y,"f").get(d);if(c)if(c.length>this.g){h=[];const u=[O.DiagnosticSeverity.Error,O.DiagnosticSeverity.Warning,O.DiagnosticSeverity.Information,O.DiagnosticSeverity.Hint];e:for(let f=0;f<4;f++)for(const E of c)if(E.severity===u[f]&&h.push({...p.Diagnostic.from(E),modelVersionId:this.h(d)})===this.g)break e;h.push({severity:R.MarkerSeverity.Info,message:(0,o.localize)(0,null,c.length-this.g),startLineNumber:h[h.length-1].startLineNumber,startColumn:h[h.length-1].startColumn,endLineNumber:h[h.length-1].endLineNumber,endColumn:h[h.length-1].endColumn})}else h=c.map(u=>({...p.Diagnostic.from(u),modelVersionId:this.h(d)}));if(t.push([d,h]),g+=h.length,g>this.f)break}qe(this,b,"f").$changeMany(this.e,t)}delete(n){this.j(),qe(this,C,"f").fire([n]),qe(this,y,"f").delete(n),qe(this,b,"f")?.$changeMany(this.e,[[n,void 0]])}clear(){this.j(),qe(this,C,"f").fire([...qe(this,y,"f").keys()]),qe(this,y,"f").clear(),qe(this,b,"f")?.$clear(this.e)}forEach(n,r){this.j();for(const[s,t]of this)n.call(r,s,t,this)}*[(b=new WeakMap,C=new WeakMap,y=new WeakMap,Symbol.iterator)](){this.j();for(const n of qe(this,y,"f").keys())yield[n,this.get(n)]}get(n){this.j();const r=qe(this,y,"f").get(n);return Array.isArray(r)?Object.freeze(r.slice(0)):[]}has(n){return this.j(),Array.isArray(qe(this,y,"f").get(n))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(n,r){return n[0].toString()<r[0].toString()?-1:n[0].toString()>r[0].toString()?1:0}}e.$Ejc=m;let l=a=class{static _mapper(n){const r=new A.$Bc;for(const s of n)r.set(s,s);return{uris:Object.freeze(Array.from(r.values()))}}constructor(n,r,s,t){this.j=r,this.k=s,this.l=t,this.g=new Map,this.h=new $.$$d({merge:g=>g.flat(),delay:50}),this.onDidChangeDiagnostics=$.Event.map(this.h.event,a._mapper),this.f=n.getProxy(M.$sM.MainThreadDiagnostics)}createDiagnosticCollection(n,r){const{g:s,f:t,h:g,j:d,k:h,l:c}=this,u=new class{$changeMany(v,D){t.$changeMany(v,D),d.trace("[DiagnosticCollection] change many (extension, owner, uris)",n.value,v,D.length===0?"CLEARING":D)}$clear(v){t.$clear(v),d.trace("[DiagnosticCollection] remove all (extension, owner)",n.value,v)}dispose(){t.dispose()}};let f;if(!r)r="_generated_diagnostic_collection_name_#"+a.c++,f=r;else if(!s.has(r))f=r;else{this.j.warn(`DiagnosticCollection with name '${r}' does already exist.`);do f=r+a.c++;while(s.has(f))}return new class extends m{constructor(){super(r,f,a.e,a.d,v=>c.getDocument(v)?.version,h.extUri,u,g),s.set(f,this)}dispose(){super.dispose(),s.delete(f)}}}getDiagnostics(n){if(n)return this.m(n);{const r=new Map,s=[];for(const t of this.g.values())t.forEach((g,d)=>{let h=r.get(g.toString());typeof h>"u"&&(h=s.length,r.set(g.toString(),h),s.push([g,[]])),s[h][1]=s[h][1].concat(...d)});return s}}m(n){let r=[];for(const s of this.g.values())s.has(n)&&(r=r.concat(s.get(n)));return r}$acceptMarkersChange(n){if(!this.n){const r="_generated_mirror",s=new m(r,r,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,t=>{},this.k.extUri,void 0,this.h);this.g.set(r,s),this.n=s}for(const[r,s]of n)this.n.set(I.URI.revive(r),s.map(p.Diagnostic.to))}};e.$Fjc=l,l.c=0,l.d=1e3,l.e=1.1*a.d,e.$Fjc=l=a=Qe([He(1,w.$Oj),He(2,P.$Djc)],l)}),define(Ee[333],Ce([1,0,2,13,7,16,75]),function(re,e,o,R,I,M,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Okc=void 0;class p{constructor(w,A,P,b={timeout:1500,errors:3}){this.c=w,this.d=A,this.f=P,this.g=b,this.a=new O.$5c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(w){return(A,P,b)=>{const y={dispose:this.a.push([A,P,w])};return Array.isArray(b)&&b.push(y),y}}async $participateInSave(w,A){const P=o.URI.revive(w);let b=!1;const C=setTimeout(()=>b=!0,this.g.timeout),y=[];try{for(const a of[...this.a]){if(b)break;const m=this.d.getDocument(P),l=await this.h(a,{document:m,reason:M.TextDocumentSaveReason.to(A)});y.push(l)}}finally{clearTimeout(C)}return y}h([w,A,P],b){const C=this.b.get(w);return typeof C=="number"&&C>this.g.errors?Promise.resolve(!1):this.i(P,w,A,b).then(()=>!0,y=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' threw ERROR`),this.c.error(y),!(y instanceof Error)||y.message!=="concurrent_edits"){const a=this.b.get(w);this.b.set(w,a?a+1:1),typeof a=="number"&&a>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(w,A,P,b){const C=[],y=Date.now(),{document:a,reason:m}=b,{version:l}=a,i=Object.freeze({document:a,reason:m,waitUntil(n){if(Object.isFrozen(C))throw(0,R.$8)("waitUntil can not be called async");C.push(Promise.resolve(n))}});try{A.apply(P,[i])}catch(n){return Promise.reject(n)}return Object.freeze(C),new Promise((n,r)=>{const s=setTimeout(()=>r(new Error("timeout")),this.g.timeout);return Promise.all(C).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${w.identifier.value}' finished after ${Date.now()-y}ms`),clearTimeout(s),n(t)}).catch(t=>{clearTimeout(s),r(t)})}).then(n=>{const r={edits:[]};for(const s of n)if(Array.isArray(s)&&s.every(t=>t instanceof I.$BM))for(const{newText:t,newEol:g,range:d}of s)r.edits.push({resource:a.uri,versionId:void 0,textEdit:{range:d&&M.Range.from(d),text:t,eol:g&&M.EndOfLine.from(g)}});if(r.edits.length!==0)return l===a.version?this.f.$tryApplyWorkspaceEdit(r):Promise.reject(new Error("concurrent_edits"))})}}e.$Okc=p}),define(Ee[334],Ce([1,0,4,3,2,6,153,16,18,24,7]),function(re,e,o,R,I,M,O,p,$,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gjc=void 0;class P{constructor(C,y){this.a=new o.$7d,this.b=new o.$7d,this.c=new o.$7d,this.d=new o.$7d,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new R.$Tc,this.h=new Map,this.f=C.getProxy(M.$sM.MainThreadDocuments),this.g=y,this.g.onDidRemoveDocuments(a=>{for(const m of a)this.b.fire(m.document)},void 0,this.e),this.g.onDidAddDocuments(a=>{for(const m of a)this.a.fire(m.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(C){if(!C)return;const y=this.g.getDocument(C);if(y)return y}getDocument(C){const y=this.getDocumentData(C);if(!y?.document)throw new Error(`Unable to retrieve document from URI '${C}'`);return y.document}ensureDocumentData(C){const y=this.g.getDocument(C);if(y)return Promise.resolve(y);let a=this.h.get(C.toString());return a||(a=this.f.$tryOpenDocument(C).then(m=>{this.h.delete(C.toString());const l=I.URI.revive(m);return(0,$.$7f)(this.g.getDocument(l))},m=>(this.h.delete(C.toString()),Promise.reject(m))),this.h.set(C.toString(),a)),a}createDocumentData(C){return this.f.$tryCreateDocument(C).then(y=>I.URI.revive(y))}$acceptModelLanguageChanged(C,y){const a=I.URI.revive(C),m=this.g.getDocument(a);if(!m)throw new Error("unknown document");this.b.fire(m.document),m._acceptLanguageId(y),this.a.fire(m.document)}$acceptModelSaved(C){const y=I.URI.revive(C),a=this.g.getDocument(y);if(!a)throw new Error("unknown document");this.$acceptDirtyStateChanged(C,!1),this.d.fire(a.document)}$acceptDirtyStateChanged(C,y){const a=I.URI.revive(C),m=this.g.getDocument(a);if(!m)throw new Error("unknown document");m._acceptIsDirty(y),this.c.fire({document:m.document,contentChanges:[],reason:void 0})}$acceptModelChanged(C,y,a){const m=I.URI.revive(C),l=this.g.getDocument(m);if(!l)throw new Error("unknown document");l._acceptIsDirty(a),l.onEvents(y);let i;y.isUndoing?i=A.TextDocumentChangeReason.Undo:y.isRedoing&&(i=A.TextDocumentChangeReason.Redo),this.c.fire((0,w.$Qn)({document:l.document,contentChanges:y.changes.map(n=>({range:p.Range.to(n.range),rangeOffset:n.rangeOffset,rangeLength:n.rangeLength,text:n.text})),reason:i}))}setWordDefinitionFor(C,y){(0,O.$QO)(C,y)}}e.$Gjc=P}),define(Ee[71],Ce([1,0,73,4,18,2,5,6,20,16,7]),function(re,e,o,R,I,M,O,p,$,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ckc=e.$bkc=void 0,e.$bkc=(0,O.$ii)("IExtHostEditorTabs");class P{constructor(m,l,i){this.e=i,this.d=l,this.acceptDtoUpdate(m)}get apiObject(){if(!this.a){const m=this,l={get isActive(){return m.b.id===m.e()},get label(){return m.b.label},get input(){return m.c},get isDirty(){return m.b.isDirty},get isPinned(){return m.b.isPinned},get isPreview(){return m.b.isPreview},get group(){return m.d.apiObject}};this.a=Object.freeze(l)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(m){this.b=m,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new A.$eO(M.URI.revive(this.b.input.uri));case 2:return new A.$fO(M.URI.revive(this.b.input.original),M.URI.revive(this.b.input.modified));case 3:return new A.$gO(M.URI.revive(this.b.input.base),M.URI.revive(this.b.input.input1),M.URI.revive(this.b.input.input2),M.URI.revive(this.b.input.result));case 6:return new A.$hO(M.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new A.$iO(this.b.input.viewType);case 4:return new A.$jO(M.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new A.$kO(M.URI.revive(this.b.input.original),M.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new A.$lO;case 9:return new A.$mO(M.URI.revive(this.b.input.uri),M.URI.revive(this.b.input.inputBoxUri));case 10:return new A.$nO(this.b.input.providerId);case 11:return new A.$oO(this.b.input.diffEditors.map(m=>new A.$fO(M.URI.revive(m.original),M.URI.revive(m.modified))));default:return}}}class b{constructor(m,l){this.c=[],this.d="",this.b=m,this.e=l;for(const i of m.tabs)i.isActive&&(this.d=i.id),this.c.push(new P(i,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const m=this,l={get isActive(){return m.b.groupId===m.e()},get viewColumn(){return w.ViewColumn.to(m.b.viewColumn)},get activeTab(){return m.c.find(i=>i.tabId===m.d)?.apiObject},get tabs(){return Object.freeze(m.c.map(i=>i.apiObject))}};this.a=Object.freeze(l)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(m){this.b=m}acceptTabOperation(m){if(m.kind===0){const i=new P(m.tabDto,this,()=>this.activeTabId());return this.c.splice(m.index,0,i),m.tabDto.isActive&&(this.d=i.tabId),i}else if(m.kind===1){const i=this.c.splice(m.index,1)[0];if(!i)throw new Error(`Tab close updated received for index ${m.index} which does not exist`);return i.tabId===this.d&&(this.d=""),i}else if(m.kind===3){if(m.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const i=this.c.splice(m.oldIndex,1)[0];if(!i)throw new Error(`Tab move updated received for index ${m.oldIndex} which does not exist`);return this.c.splice(m.index,0,i),i}const l=this.c.find(i=>i.tabId===m.tabDto.id);if(!l)throw new Error("INVALID tab");return m.tabDto.isActive?this.d=m.tabDto.id:this.d===m.tabDto.id&&!m.tabDto.isActive&&(this.d=""),l.acceptDtoUpdate(m.tabDto),l}activeTabId(){return this.d}}let C=class{constructor(m){this.b=new R.$7d,this.c=new R.$7d,this.e=[],this.a=m.getProxy(p.$sM.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const m=this,l={onDidChangeTabGroups:m.c.event,onDidChangeTabs:m.b.event,get all(){return Object.freeze(m.e.map(i=>i.apiObject))},get activeTabGroup(){const i=m.d;return(0,I.$7f)(m.e.find(r=>r.groupId===i)?.apiObject)},close:async(i,n)=>{const r=Array.isArray(i)?i:[i];return r.length?y(r[0])?this.j(r,n):this.i(r,n):!0}};this.f=Object.freeze(l)}return this.f}$acceptEditorTabModel(m){const l=new Set(this.e.map(d=>d.groupId)),i=new Set(m.map(d=>d.groupId)),n=(0,o.$F)(l,i),r=this.e.filter(d=>n.removed.includes(d.groupId)).map(d=>d.apiObject),s=[],t=[];this.e=m.map(d=>{const h=new b(d,()=>this.d);return n.added.includes(h.groupId)?s.push(h.apiObject):t.push(h.apiObject),h});const g=(0,I.$7f)(m.find(d=>d.isActive===!0)?.groupId);g!==void 0&&this.d!==g&&(this.d=g),this.c.fire(Object.freeze({opened:s,closed:r,changed:t}))}$acceptTabGroupUpdate(m){const l=this.e.find(i=>i.groupId===m.groupId);if(!l)throw new Error("Update Group IPC call received before group creation.");l.acceptGroupDtoUpdate(m),m.isActive&&(this.d=m.groupId),this.c.fire(Object.freeze({changed:[l.apiObject],opened:[],closed:[]}))}$acceptTabOperation(m){const l=this.e.find(n=>n.groupId===m.groupId);if(!l)throw new Error("Update Tabs IPC call received before group creation.");const i=l.acceptTabOperation(m);switch(m.kind){case 0:this.b.fire(Object.freeze({opened:[i.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[i.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[i.apiObject]}));return}}g(m){for(const l of this.e)for(const i of l.tabs)if(i.apiObject===m)return i}h(m){return this.e.find(l=>l.apiObject===m)}async i(m,l){const i=[];for(const n of m){const r=this.g(n);if(!r)throw new Error("Tab close: Invalid tab not found!");i.push(r.tabId)}return this.a.$closeTab(i,l)}async j(m,l){const i=[];for(const n of m){const r=this.h(n);if(!r)throw new Error("Group close: Invalid group not found!");i.push(r.groupId)}return this.a.$closeGroup(i,l)}};e.$ckc=C,e.$ckc=C=Qe([He(0,$.$OO)],C);function y(a){return a.tabs!==void 0}}),define(Ee[335],Ce([1,0,2,6,3,7,16,188,14,21,26,79]),function(re,e,o,R,I,M,O,p,$,w,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qkc=void 0;class b{constructor(){this.a=[]}add(a){this.b=void 0,this.a.push(a)}delete(a){const m=this.a.indexOf(a);m>=0&&(this.a.splice(m,1),this.b=void 0)}c(){if(!this.b){const a=this.a.sort(),m=[];let l,i,n=14,r=14;for(const s of a){let t=l?(0,$.$nf)(l,s):0;for(t===0?i=1:i=r;t<s.length;t++)t+1===s.length?(n=r,r=9):r+=1,m.push([i,s.toUpperCase().charCodeAt(t),r]),m.push([i,s.toLowerCase().charCodeAt(t),r]),i=r;l=s,r=n}m.push([9,58,10]),m.push([10,47,12]),this.b=new p.$E2(m)}}provideDocumentLinks(a){this.c();const m=[],l=p.$F2.computeLinks({getLineContent(i){return a.lineAt(i-1).text},getLineCount(){return a.lineCount}},this.b);for(const i of l){const n=O.DocumentLink.to(i);n.target&&m.push(n)}return m}}class C{constructor(a,m){this.i=m,this.b=new b,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=a.getProxy(R.$sM.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(a,m,l,i={}){if(C.j(l),this.d.has(m))throw new Error(`a provider for the scheme '${m}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(a,"*",this.b));const n=this.h++;this.b.add(m),this.d.add(m),this.c.set(n,l);let r=2;i.isCaseSensitive&&(r+=1024),i.isReadonly&&(r+=2048),typeof l.copy=="function"&&(r+=8),typeof l.open=="function"&&typeof l.close=="function"&&typeof l.read=="function"&&typeof l.write=="function"&&((0,A.$dG)(a,"fsChunks"),r+=4);let s;i.isReadonly&&(0,P.$Hk)(i.isReadonly)&&i.isReadonly.value!==""&&(s={value:i.isReadonly.value,isTrusted:i.isReadonly.isTrusted,supportThemeIcons:i.isReadonly.supportThemeIcons,supportHtml:i.isReadonly.supportHtml,baseUri:i.isReadonly.baseUri,uris:i.isReadonly.uris}),this.a.$registerFileSystemProvider(n,m,r,s).catch(g=>{console.error(`FAILED to register filesystem provider of ${a.identifier.value}-extension for the scheme ${m}`),console.error(g)});const t=l.onDidChangeFile(g=>{const d=[];for(const h of g){const{uri:c,type:u}=h;if(c.scheme!==m)continue;let f;switch(u){case M.FileChangeType.Changed:f=0;break;case M.FileChangeType.Created:f=1;break;case M.FileChangeType.Deleted:f=2;break;default:throw new Error("Unknown FileChangeType")}d.push({resource:c,type:f})}this.a.$onFileSystemChange(n,d)});return(0,I.$Sc)(()=>{t.dispose(),this.b.delete(m),this.d.delete(m),this.c.delete(n),this.a.$unregisterProvider(n)})}static j(a){if(!a)throw new Error("MISSING provider");if(typeof a.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof a.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof a.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof a.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof a.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof a.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof a.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof a.rename!="function")throw new Error("Provider does NOT implement rename")}static k(a){const{type:m,ctime:l,mtime:i,size:n,permissions:r}=a;return{type:m,ctime:l,mtime:i,size:n,permissions:r}}$stat(a,m){return Promise.resolve(this.l(a).stat(o.URI.revive(m))).then(l=>C.k(l))}$readdir(a,m){return Promise.resolve(this.l(a).readDirectory(o.URI.revive(m)))}$readFile(a,m){return Promise.resolve(this.l(a).readFile(o.URI.revive(m))).then(l=>w.$ue.wrap(l))}$writeFile(a,m,l,i){return Promise.resolve(this.l(a).writeFile(o.URI.revive(m),l.buffer,i))}$delete(a,m,l){return Promise.resolve(this.l(a).delete(o.URI.revive(m),l))}$rename(a,m,l,i){return Promise.resolve(this.l(a).rename(o.URI.revive(m),o.URI.revive(l),i))}$copy(a,m,l,i){const n=this.l(a);if(!n.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(n.copy(o.URI.revive(m),o.URI.revive(l),i))}$mkdir(a,m){return Promise.resolve(this.l(a).createDirectory(o.URI.revive(m)))}$watch(a,m,l,i){const n=this.l(a).watch(o.URI.revive(l),i);this.f.set(m,n)}$unwatch(a,m){const l=this.f.get(m);l&&(l.dispose(),this.f.delete(m))}$open(a,m,l){const i=this.l(a);if(!i.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(i.open(o.URI.revive(m),l))}$close(a,m){const l=this.l(a);if(!l.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(l.close(m))}$read(a,m,l,i){const n=this.l(a);if(!n.read)throw new Error('FileSystemProvider does not implement "read"');const r=w.$ue.alloc(i);return Promise.resolve(n.read(m,l,r.buffer,0,i)).then(s=>r.slice(0,s))}$write(a,m,l,i){const n=this.l(a);if(!n.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(n.write(m,l,i.buffer,0,i.byteLength))}l(a){const m=this.c.get(a);if(!m){const l=new Error;throw l.name="ENOPRO",l.message="no provider",l}return m}}e.$Qkc=C}),define(Ee[336],Ce([1,0,4,35,2,6,16,7,46]),function(re,e,o,R,I,M,O,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rkc=void 0;class w{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(C,y,a,m,l,i){this.a=Math.random(),this.b=new o.$7d,this.c=new o.$7d,this.d=new o.$7d,this.h=0,i?.ignoreCreateEvents&&(this.h+=1),i?.ignoreChangeEvents&&(this.h+=2),i?.ignoreDeleteEvents&&(this.h+=4);const n=(0,R.$ck)(l),r=typeof l=="string",s=i?.correlate,t=m(g=>{if(!(typeof g.session=="number"&&g.session!==this.a)&&!(s&&typeof g.session>"u")){if(!i?.ignoreCreateEvents)for(const d of g.created){const h=I.URI.revive(d);n(h.fsPath)&&(!r||y.getWorkspaceFolder(h))&&this.b.fire(h)}if(!i?.ignoreChangeEvents)for(const d of g.changed){const h=I.URI.revive(d);n(h.fsPath)&&(!r||y.getWorkspaceFolder(h))&&this.c.fire(h)}if(!i?.ignoreDeleteEvents)for(const d of g.deleted){const h=I.URI.revive(d);n(h.fsPath)&&(!r||y.getWorkspaceFolder(h))&&this.d.fire(h)}}});this.g=p.$uM.from(this.i(C,a,l,i,i?.correlate),this.b,this.c,this.d,t)}i(C,y,a,m,l){const i=p.$uM.from();if(typeof a=="string")return i;const n=C.getProxy(M.$sM.MainThreadFileSystemEventService);let r=!1;return(a.pattern.includes(R.$$j)||a.pattern.includes(R.$_j))&&(r=!0),n.$watch(y.identifier.value,this.a,a.baseUri,{recursive:r,excludes:m?.excludes??[]},!!l),p.$uM.from({dispose:()=>n.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class A{constructor(C){this.a=C,this.session=this.a.session,this.b=new $.$V(()=>this.a.created.map(I.URI.revive)),this.c=new $.$V(()=>this.a.changed.map(I.URI.revive)),this.d=new $.$V(()=>this.a.deleted.map(I.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class P{constructor(C,y,a){this.j=C,this.k=y,this.l=a,this.a=new o.$7d,this.b=new o.$7d,this.c=new o.$7d,this.d=new o.$7d,this.g=new o.$9d,this.h=new o.$9d,this.i=new o.$9d,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(C,y,a,m){return new w(this.j,C,y,this.a.event,O.GlobPattern.from(a),m)}$onFileEvent(C){this.a.fire(new A(C))}$onDidRunFileOperation(C,y){switch(C){case 2:this.b.fire(Object.freeze({files:y.map(a=>({oldUri:I.URI.revive(a.source),newUri:I.URI.revive(a.target)}))}));break;case 1:this.d.fire(Object.freeze({files:y.map(a=>I.URI.revive(a.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:y.map(a=>I.URI.revive(a.target))}));break;default:}}getOnWillRenameFileEvent(C){return this.m(C,this.g)}getOnWillCreateFileEvent(C){return this.m(C,this.h)}getOnWillDeleteFileEvent(C){return this.m(C,this.i)}m(C,y){return(a,m,l)=>{const i=function(r){a.call(m,r)};return i.extension=C,y.event(i,void 0,l)}}async $onWillRunFileOperation(C,y,a,m){switch(C){case 2:return await this.n(this.g,{files:y.map(l=>({oldUri:I.URI.revive(l.source),newUri:I.URI.revive(l.target)}))},a,m);case 1:return await this.n(this.i,{files:y.map(l=>I.URI.revive(l.target))},a,m);case 0:case 3:return await this.n(this.h,{files:y.map(l=>I.URI.revive(l.target))},a,m)}}async n(C,y,a,m){const l=new Set,i=[];if(await C.fireAsync(y,m,async(r,s)=>{const t=Date.now(),g=await Promise.resolve(r);g instanceof p.$EM&&(i.push([s.extension,g]),l.add(s.extension.displayName??s.extension.identifier.value)),Date.now()-t>a&&this.k.warn("SLOW file-participant",s.extension.identifier)}),m.isCancellationRequested||i.length===0)return;const n={edits:[]};for(const[,r]of i){const{edits:s}=O.WorkspaceEdit.from(r,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});n.edits=n.edits.concat(s)}return{edit:n,extensionNames:Array.from(l)}}}e.$Rkc=P}),define(Ee[337],Ce([1,0,19,8,22,13,125,3,24,40,14,18,2,29,181,83,135,221,25,16,7,26,111,6]),function(re,e,o,R,I,M,O,p,$,w,A,P,b,C,y,a,m,l,i,n,r,s,t,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hjc=void 0;class d{constructor(V,H){this.d=V,this.e=H}async provideDocumentSymbols(V,H){const Z=this.d.getDocument(V),X=await this.e.provideDocumentSymbols(Z,H);if(!(0,o.$Kb)(X))return X[0]instanceof r.$NM?X.map(n.DocumentSymbol.from):d.f(X)}static f(V){V=V.slice(0).sort((X,fe)=>{let we=X.location.range.start.compareTo(fe.location.range.start);return we===0&&(we=fe.location.range.end.compareTo(X.location.range.end)),we});const H=[],Z=[];for(const X of V){const fe={name:X.name||"!!MISSING: name!!",kind:n.SymbolKind.from(X.kind),tags:X.tags?.map(n.SymbolTag.from)||[],detail:"",containerName:X.containerName,range:n.Range.from(X.location.range),selectionRange:n.Range.from(X.location.range),children:[]};for(;;){if(Z.length===0){Z.push(fe),H.push(fe);break}const we=Z[Z.length-1];if(C.$dt.containsRange(we.range,fe.range)&&!C.$dt.equalsRange(we.range,fe.range)){we.children?.push(fe),Z.push(fe);break}Z.pop()}}return H}}class h{constructor(V,H,Z,X,fe,we){this.f=V,this.g=H,this.h=Z,this.j=X,this.k=fe,this.l=we,this.d=new t.$xjc("CodeLens"),this.e=new Map}async provideCodeLenses(V,H){const Z=this.f.getDocument(V),X=await this.h.provideCodeLenses(Z,H);if(!X||H.isCancellationRequested)return;const fe=this.d.add(X),we=new p.$Tc;this.e.set(fe,we);const Te={cacheId:fe,lenses:[]};for(let Ve=0;Ve<X.length;Ve++)Te.lenses.push({cacheId:[fe,Ve],range:n.Range.from(X[Ve].range),command:this.g.toInternal(X[Ve].command,we)});return Te}async resolveCodeLens(V,H){const Z=V.cacheId&&this.d.get(...V.cacheId);if(!Z)return;let X;if(typeof this.h.resolveCodeLens!="function"||Z.isResolved?X=Z:X=await this.h.resolveCodeLens(Z,H),X||(X=Z),H.isCancellationRequested)return;const fe=V.cacheId&&this.e.get(V.cacheId[0]);if(fe){if(!X.command){const we=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,we),this.l.error(we);return}return V.command=this.g.toInternal(X.command,fe),V}}releaseCodeLenses(V){this.e.get(V)?.dispose(),this.e.delete(V),this.d.delete(V)}}function c(ze){return Array.isArray(ze)?ze.map(n.DefinitionLink.from):ze?[n.DefinitionLink.from(ze)]:[]}class u{constructor(V,H){this.d=V,this.e=H}async provideDefinition(V,H,Z){const X=this.d.getDocument(V),fe=n.Position.to(H),we=await this.e.provideDefinition(X,fe,Z);return c(we)}}class f{constructor(V,H){this.d=V,this.e=H}async provideDeclaration(V,H,Z){const X=this.d.getDocument(V),fe=n.Position.to(H),we=await this.e.provideDeclaration(X,fe,Z);return c(we)}}class E{constructor(V,H){this.d=V,this.e=H}async provideImplementation(V,H,Z){const X=this.d.getDocument(V),fe=n.Position.to(H),we=await this.e.provideImplementation(X,fe,Z);return c(we)}}class v{constructor(V,H){this.d=V,this.e=H}async provideTypeDefinition(V,H,Z){const X=this.d.getDocument(V),fe=n.Position.to(H),we=await this.e.provideTypeDefinition(X,fe,Z);return c(we)}}class D{constructor(V,H){this.d=V,this.e=H}async provideHover(V,H,Z){const X=this.d.getDocument(V),fe=n.Position.to(H),we=await this.e.provideHover(X,fe,Z);if(!(!we||(0,o.$Kb)(we.contents)))return we.range||(we.range=X.getWordRangeAtPosition(fe)),we.range||(we.range=new r.$wM(fe,fe)),n.Hover.from(we)}}class k{constructor(V,H){this.d=V,this.e=H}async provideEvaluatableExpression(V,H,Z){const X=this.d.getDocument(V),fe=n.Position.to(H),we=await this.e.provideEvaluatableExpression(X,fe,Z);if(we)return n.EvaluatableExpression.from(we)}}class S{constructor(V,H){this.d=V,this.e=H}async provideInlineValues(V,H,Z,X){const fe=this.d.getDocument(V),we=await this.e.provideInlineValues(fe,n.Range.to(H),n.InlineValueContext.to(Z),X);if(Array.isArray(we))return we.map(Te=>n.InlineValue.from(Te))}}class F{constructor(V,H){this.d=V,this.e=H}async provideDocumentHighlights(V,H,Z){const X=this.d.getDocument(V),fe=n.Position.to(H),we=await this.e.provideDocumentHighlights(X,fe,Z);if(Array.isArray(we))return we.map(n.DocumentHighlight.from)}}class W{constructor(V,H){this.d=V,this.e=H}async provideMultiDocumentHighlights(V,H,Z,X){const fe=this.d.getDocument(V),we=Z.map(Ze=>this.d.getDocument(Ze)),Te=n.Position.to(H),Ve=await this.e.provideMultiDocumentHighlights(fe,Te,we,X);if(Array.isArray(Ve))return Ve.map(n.MultiDocumentHighlight.from)}}class B{constructor(V,H){this.d=V,this.e=H}async provideLinkedEditingRanges(V,H,Z){const X=this.d.getDocument(V),fe=n.Position.to(H),we=await this.e.provideLinkedEditingRanges(X,fe,Z);if(we&&Array.isArray(we.ranges))return{ranges:(0,o.$Hb)(we.ranges.map(n.Range.from)),wordPattern:we.wordPattern}}}class T{constructor(V,H){this.d=V,this.e=H}async provideReferences(V,H,Z,X){const fe=this.d.getDocument(V),we=n.Position.to(H),Te=await this.e.provideReferences(fe,we,Z,X);if(Array.isArray(Te))return Te.map(n.location.from)}}class N{constructor(V,H,Z,X,fe,we,Te){this.g=V,this.h=H,this.j=Z,this.k=X,this.l=fe,this.m=we,this.n=Te,this.e=new t.$xjc("CodeAction"),this.f=new Map}async provideCodeActions(V,H,Z,X){const fe=this.g.getDocument(V),we=y.$ft.isISelection(H)?n.Selection.to(H):n.Range.to(H),Te=[];for(const at of this.j.getDiagnostics(V))if(we.intersection(at.range)&&Te.push(at)>N.d)break;const Ve={diagnostics:Te,only:Z.only?new r.$PM(Z.only):void 0,triggerKind:n.CodeActionTriggerKind.to(Z.trigger)},Ze=await this.k.provideCodeActions(fe,we,Ve,X);if(!(0,o.$Lb)(Ze)||X.isCancellationRequested)return;const nt=this.e.add(Ze),ot=new p.$Tc;this.f.set(nt,ot);const lt=[];for(let at=0;at<Ze.length;at++){const st=Ze[at];if(st)if(N.o(st))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),lt.push({_isSynthetic:!0,title:st.title,command:this.h.toInternal(st,ot)});else{Ve.only&&(st.kind?Ve.only.contains(st.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ve.only.value} 'requested but returned code action is of kind '${st.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ve.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const Ie=st.ranges??[];lt.push({cacheId:[nt,at],title:st.title,command:st.command&&this.h.toInternal(st.command,ot),diagnostics:st.diagnostics&&st.diagnostics.map(n.Diagnostic.from),edit:st.edit&&n.WorkspaceEdit.from(st.edit,void 0),kind:st.kind&&st.kind.value,isPreferred:st.isPreferred,isAI:(0,s.$cG)(this.m,"codeActionAI")?st.isAI:!1,ranges:(0,s.$cG)(this.m,"codeActionRanges")?(0,o.$Hb)(Ie.map(n.Range.from)):void 0,disabled:st.disabled?.reason})}}return{cacheId:nt,actions:lt}}async resolveCodeAction(V,H){const[Z,X]=V,fe=this.e.get(Z,X);if(!fe||N.o(fe))return{};if(!this.k.resolveCodeAction)return{};const we=await this.k.resolveCodeAction(fe,H)??fe;let Te;we.edit&&(Te=n.WorkspaceEdit.from(we.edit,void 0));let Ve;if(we.command){const Ze=this.f.get(Z);Ze&&(Ve=this.h.toInternal(we.command,Ze))}return{edit:Te,command:Ve}}releaseCodeActions(V){this.f.get(V)?.dispose(),this.f.delete(V),this.e.delete(V)}static o(V){return typeof V.command=="string"&&typeof V.title=="string"}}N.d=1e3;class j{constructor(V,H,Z,X,fe){this.e=V,this.f=H,this.g=Z,this.h=X,this.j=fe,this.d=new t.$xjc("DocumentPasteEdit")}async prepareDocumentPaste(V,H,Z,X){if(!this.g.prepareDocumentPaste)return;const fe=this.f.getDocument(V),we=H.map(Ze=>n.Range.to(Ze)),Te=n.DataTransfer.toDataTransfer(Z,()=>{throw new M.$$});if(await this.g.prepareDocumentPaste(fe,we,Te,X),X.isCancellationRequested)return;const Ve=Array.from(Te).filter(([,Ze])=>!(Ze instanceof r.$jN));return n.DataTransfer.from(Ve)}async providePasteEdits(V,H,Z,X,fe,we){if(!this.g.provideDocumentPasteEdits)return[];const Te=this.f.getDocument(H),Ve=Z.map(lt=>n.Range.to(lt)),Ze=n.DataTransfer.toDataTransfer(X,async lt=>(await this.e.$resolvePasteFileData(this.h,V,lt)).buffer),nt=await this.g.provideDocumentPasteEdits(Te,Ve,Ze,{only:fe.only?new r.$oN(fe.only):void 0,triggerKind:fe.triggerKind},we);if(!nt||we.isCancellationRequested)return[];const ot=this.d.add(nt);return nt.map((lt,at)=>({_cacheId:[ot,at],title:lt.title??(0,l.localize)(0,null,this.j.displayName||this.j.name),kind:lt.kind,yieldTo:lt.yieldTo?.map(st=>st.value),insertText:typeof lt.insertText=="string"?lt.insertText:{snippet:lt.insertText.value},additionalEdit:lt.additionalEdit?n.WorkspaceEdit.from(lt.additionalEdit,void 0):void 0}))}async resolvePasteEdit(V,H){const[Z,X]=V,fe=this.d.get(Z,X);if(!fe||!this.g.resolveDocumentPasteEdit)return{};const we=await this.g.resolveDocumentPasteEdit(fe,H)??fe;return{additionalEdit:we.additionalEdit?n.WorkspaceEdit.from(we.additionalEdit,void 0):void 0}}releasePasteEdits(V){this.d.delete(V)}}class L{constructor(V,H){this.d=V,this.e=H}async provideDocumentFormattingEdits(V,H,Z){const X=this.d.getDocument(V),fe=await this.e.provideDocumentFormattingEdits(X,H,Z);if(Array.isArray(fe))return fe.map(n.TextEdit.from)}}class z{constructor(V,H){this.d=V,this.e=H}async provideDocumentRangeFormattingEdits(V,H,Z,X){const fe=this.d.getDocument(V),we=n.Range.to(H),Te=await this.e.provideDocumentRangeFormattingEdits(fe,we,Z,X);if(Array.isArray(Te))return Te.map(n.TextEdit.from)}async provideDocumentRangesFormattingEdits(V,H,Z,X){(0,P.$6f)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const fe=this.d.getDocument(V),we=H.map(n.Range.to),Te=await this.e.provideDocumentRangesFormattingEdits(fe,we,Z,X);if(Array.isArray(Te))return Te.map(n.TextEdit.from)}}class Q{constructor(V,H){this.d=V,this.e=H,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(V,H,Z,X,fe){const we=this.d.getDocument(V),Te=n.Position.to(H),Ve=await this.e.provideOnTypeFormattingEdits(we,Te,Z,X,fe);if(Array.isArray(Ve))return Ve.map(n.TextEdit.from)}}class Y{constructor(V,H){this.e=V,this.f=H,this.d=new t.$xjc("WorkspaceSymbols")}async provideWorkspaceSymbols(V,H){const Z=await this.e.provideWorkspaceSymbols(V,H);if(!(0,o.$Lb)(Z))return{symbols:[]};const X=this.d.add(Z),fe={cacheId:X,symbols:[]};for(let we=0;we<Z.length;we++){const Te=Z[we];if(!Te||!Te.name){this.f.warn("INVALID SymbolInformation",Te);continue}fe.symbols.push({...n.WorkspaceSymbol.from(Te),cacheId:[X,we]})}return fe}async resolveWorkspaceSymbol(V,H){if(typeof this.e.resolveWorkspaceSymbol!="function"||!V.cacheId)return V;const Z=this.d.get(...V.cacheId);if(Z){const X=await this.e.resolveWorkspaceSymbol(Z,H);return X&&(0,$.$Sn)(V,n.WorkspaceSymbol.from(X),!0)}}releaseWorkspaceSymbols(V){this.d.delete(V)}}class J{static supportsResolving(V){return typeof V.prepareRename=="function"}constructor(V,H,Z){this.d=V,this.e=H,this.f=Z}async provideRenameEdits(V,H,Z,X){const fe=this.d.getDocument(V),we=n.Position.to(H);try{const Te=await this.e.provideRenameEdits(fe,we,Z,X);return Te?n.WorkspaceEdit.from(Te):void 0}catch(Te){const Ve=J.g(Te);return Ve?{rejectReason:Ve,edits:void 0}:Promise.reject(Te)}}async resolveRenameLocation(V,H,Z){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const X=this.d.getDocument(V),fe=n.Position.to(H);try{const we=await this.e.prepareRename(X,fe,Z);let Te,Ve;if(r.$wM.isRange(we)?(Te=we,Ve=X.getText(we)):(0,P.$Xf)(we)&&(Te=we.range,Ve=we.placeholder),!Te||!Ve)return;if(Te.start.line>fe.line||Te.end.line<fe.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:n.Range.from(Te),text:Ve}}catch(we){const Te=J.g(we);return Te?{rejectReason:Te,range:void 0,text:void 0}:Promise.reject(we)}}static g(V){return typeof V=="string"?V:V instanceof Error&&typeof V.message=="string"?V.message:void 0}}class x{constructor(V,H,Z){this.d=V,this.e=H,this.f=Z}async provideNewSymbolNames(V,H,Z){const X=this.d.getDocument(V),fe=n.Range.to(H);try{const we=await this.e.provideNewSymbolNames(X,fe,Z);return we?we.map(Te=>typeof Te=="string"?{newSymbolName:Te}:{newSymbolName:Te.newSymbolName,tags:Te.tags}):void 0}catch(we){this.f.error(x.g(we)??JSON.stringify(we,null,"	"));return}}static g(V){return typeof V=="string"?V:V instanceof Error&&typeof V.message=="string"?V.message:void 0}}class ce{constructor(V,H){this.resultId=V,this.tokens=H}}class te{constructor(V,H){this.f=V,this.g=H,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(V,H,Z){const X=this.f.getDocument(V),fe=H!==0?this.d.get(H):null;let we=typeof fe?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(X,fe.resultId,Z):await this.g.provideDocumentSemanticTokens(X,Z);return fe&&this.d.delete(H),we?(we=te.h(we),this.o(te.n(fe,we),we)):null}async releaseDocumentSemanticColoring(V){this.d.delete(V)}static h(V){return te.j(V)?te.k(V)?V:new r.$ON(new Uint32Array(V.data),V.resultId):te.l(V)?te.m(V)?V:new r.$QN(V.edits.map(H=>new r.$PN(H.start,H.deleteCount,H.data?new Uint32Array(H.data):H.data)),V.resultId):V}static j(V){return V&&!!V.data}static k(V){return V.data instanceof Uint32Array}static l(V){return V&&Array.isArray(V.edits)}static m(V){for(const H of V.edits)if(!(H.data instanceof Uint32Array))return!1;return!0}static n(V,H){if(!te.j(H)||!V||!V.tokens)return H;const Z=V.tokens,X=Z.length,fe=H.data,we=fe.length;let Te=0;const Ve=Math.min(X,we);for(;Te<Ve&&Z[Te]===fe[Te];)Te++;if(Te===X&&Te===we)return new r.$QN([],H.resultId);let Ze=0;const nt=Ve-Te;for(;Ze<nt&&Z[X-Ze-1]===fe[we-Ze-1];)Ze++;return new r.$QN([{start:Te,deleteCount:X-Te-Ze,data:fe.subarray(Te,we-Ze)}],H.resultId)}o(V,H){if(te.j(V)){const Z=this.e++;return this.d.set(Z,new ce(V.resultId,V.data)),(0,m.$Xab)({id:Z,type:"full",data:V.data})}if(te.l(V)){const Z=this.e++;return te.j(H)?this.d.set(Z,new ce(H.resultId,H.data)):this.d.set(Z,new ce(V.resultId)),(0,m.$Xab)({id:Z,type:"delta",deltas:(V.edits||[]).map(X=>({start:X.start,deleteCount:X.deleteCount,data:X.data}))})}return null}}class pe{constructor(V,H){this.d=V,this.e=H}async provideDocumentRangeSemanticTokens(V,H,Z){const X=this.d.getDocument(V),fe=await this.e.provideDocumentRangeSemanticTokens(X,n.Range.to(H),Z);return fe?this.f(fe):null}f(V){return(0,m.$Xab)({id:0,type:"full",data:V.data})}}class ye{static supportsResolving(V){return typeof V.resolveCompletionItem=="function"}constructor(V,H,Z,X,fe){this.f=V,this.g=H,this.h=Z,this.j=X,this.k=fe,this.d=new t.$xjc("CompletionItem"),this.e=new Map}async provideCompletionItems(V,H,Z,X){const fe=this.f.getDocument(V),we=n.Position.to(H),Te=fe.getWordRangeAtPosition(we)||new r.$wM(we,we),Ve=Te.with({end:we}),Ze=new w.$3d,nt=await this.h.provideCompletionItems(fe,we,X,n.CompletionContext.to(Z));if(!nt||X.isCancellationRequested)return;const ot=Array.isArray(nt)?new r.$3M(nt):nt,lt=ye.supportsResolving(this.h)?this.d.add(ot.items):this.d.add([]),at=new p.$Tc;this.e.set(lt,at);const st=[],Ie={x:lt,b:st,a:{replace:n.Range.from(Te),insert:n.Range.from(Ve)},c:ot.isIncomplete||void 0,d:Ze.elapsed()};for(let We=0;We<ot.items.length;We++){const Ae=ot.items[We],Ke=this.l(Ae,[lt,We],Ve,Te);st.push(Ke)}return Ie}async resolveCompletionItem(V,H){if(typeof this.h.resolveCompletionItem!="function")return;const Z=this.d.get(...V);if(!Z)return;const X=this.l(Z,V),fe=await this.h.resolveCompletionItem(Z,H);if(!fe)return;const we=this.l(fe,V);return(X.h!==we.h||X.i!==we.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(X.n!==we.n||X.o!==we.o||!(0,$.$Tn)(X.p,we.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...X,d:we.d,c:we.c,l:we.l,h:we.h,i:we.i,n:we.n,o:we.o,p:we.p}}releaseCompletionItems(V){this.e.get(V)?.dispose(),this.e.delete(V),this.d.delete(V)}l(V,H,Z,X){const fe=this.e.get(H[0]);if(!fe)throw Error("DisposableStore is missing...");const we=this.g.toInternal(V.command,fe),Te={x:H,a:V.label,b:V.kind!==void 0?n.CompletionItemKind.from(V.kind):void 0,m:V.tags&&V.tags.map(n.CompletionItemTag.from),c:V.detail,d:typeof V.documentation>"u"?void 0:n.MarkdownString.fromStrict(V.documentation),e:V.sortText!==V.label?V.sortText:void 0,f:V.filterText!==V.label?V.filterText:void 0,g:V.preselect||void 0,i:V.keepWhitespace?1:0,k:V.commitCharacters?.join(""),l:V.additionalTextEdits&&V.additionalTextEdits.map(n.TextEdit.from),n:we?.$ident,o:we?.id,p:we?.$ident?void 0:we?.arguments};V.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Te.h=V.textEdit.newText):typeof V.insertText=="string"?Te.h=V.insertText:V.insertText instanceof r.$FM&&(Te.h=V.insertText.value,Te.i|=4);let Ve;return V.textEdit?Ve=V.textEdit.range:V.range&&(Ve=V.range),r.$wM.isRange(Ve)?Te.j=n.Range.from(Ve):Ve&&(!Z?.isEqual(Ve.inserting)||!X?.isEqual(Ve.replacing))&&(Te.j={insert:n.Range.from(Ve.inserting),replace:n.Range.from(Ve.replacing)}),Te}}class _{async provideInlineCompletions(V,H,Z,X){}disposeCompletions(V){}handleDidShowCompletionItem(V,H,Z){}handlePartialAccept(V,H,Z,X){}}class U extends _{constructor(V,H,Z,X){super(),this.f=V,this.g=H,this.h=Z,this.j=X,this.d=new Se,this.e=(0,s.$cG)(this.f,"inlineCompletionsAdditions"),this.k={[a.InlineCompletionTriggerKind.Automatic]:r.InlineCompletionTriggerKind.Automatic,[a.InlineCompletionTriggerKind.Explicit]:r.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,s.$cG)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(V,H,Z,X){const fe=this.g.getDocument(V),we=n.Position.to(H),Te=await this.h.provideInlineCompletionItems(fe,we,{selectedCompletionInfo:Z.selectedSuggestionInfo?{range:n.Range.to(Z.selectedSuggestionInfo.range),text:Z.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[Z.triggerKind]},X);if(!Te||X.isCancellationRequested)return;const Ve=Array.isArray(Te)?Te:Te.items,Ze=this.e?Array.isArray(Te)?[]:Te.commands||[]:[],nt=this.e&&!Array.isArray(Te)?Te.enableForwardStability:void 0;let ot;return{pid:this.d.createReferenceId({dispose(){ot?.dispose()},items:Ve}),items:Ve.map((at,st)=>{let Ie;at.command&&(ot||(ot=new p.$Tc),Ie=this.j.toInternal(at.command,ot));const We=at.insertText;return{insertText:typeof We=="string"?We:{snippet:We.value},filterText:at.filterText,range:at.range?n.Range.from(at.range):void 0,command:Ie,idx:st,completeBracketPairs:this.e?at.completeBracketPairs:!1}}),commands:Ze.map(at=>(ot||(ot=new p.$Tc),this.j.toInternal(at,ot))),suppressSuggestions:!1,enableForwardStability:nt}}disposeCompletions(V){this.d.disposeReferenceId(V)?.dispose()}handleDidShowCompletionItem(V,H,Z){const X=this.d.get(V)?.items[H];X&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(X,Z)}handlePartialAccept(V,H,Z,X){const fe=this.d.get(V)?.items[H];fe&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(fe,Z),this.h.handleDidPartiallyAcceptCompletionItem(fe,n.PartialAcceptInfo.to(X)))}}class he{async provideInlineEdits(V,H,Z){const X=this.f.getDocument(V),fe=await this.g.provideInlineEdit(X,{triggerKind:this.e[H.triggerKind]},Z);if(!fe||Z.isCancellationRequested)return;let we;const Te=this.d.createReferenceId({dispose(){we?.dispose()},item:fe});let Ve;fe.accepted&&(we||(we=new p.$Tc),Ve=this.h.toInternal(fe.accepted,we));let Ze;return fe.rejected&&(we||(we=new p.$Tc),Ze=this.h.toInternal(fe.rejected,we)),{pid:Te,text:fe.text,range:n.Range.from(fe.range),accepted:Ve,rejected:Ze}}disposeEdit(V){this.d.disposeReferenceId(V)?.dispose()}constructor(V,H,Z,X){this.f=H,this.g=Z,this.h=X,this.d=new Se,this.e={[a.InlineEditTriggerKind.Automatic]:r.InlineEditTriggerKind.Automatic,[a.InlineEditTriggerKind.Invoke]:r.InlineEditTriggerKind.Invoke}}}class Se{constructor(){this.d=new Map,this.e=1}createReferenceId(V){const H=this.e++;return this.d.set(H,V),H}disposeReferenceId(V){const H=this.d.get(V);return this.d.delete(V),H}get(V){return this.d.get(V)}}class me{constructor(V,H){this.e=V,this.f=H,this.d=new t.$xjc("SignatureHelp")}async provideSignatureHelp(V,H,Z,X){const fe=this.e.getDocument(V),we=n.Position.to(H),Te=this.g(Z),Ve=await this.f.provideSignatureHelp(fe,we,X,Te);if(Ve){const Ze=this.d.add([Ve]);return{...n.SignatureHelp.from(Ve),id:Ze}}}g(V){let H;if(V.activeSignatureHelp){const Z=n.SignatureHelp.to(V.activeSignatureHelp),X=this.d.get(V.activeSignatureHelp.id,0);X?(H=X,H.activeSignature=Z.activeSignature,H.activeParameter=Z.activeParameter):H=Z}return{...V,activeSignatureHelp:H}}releaseSignatureHelp(V){this.d.delete(V)}}class ie{constructor(V,H,Z,X,fe){this.f=V,this.g=H,this.h=Z,this.j=X,this.k=fe,this.d=new t.$xjc("InlayHints"),this.e=new Map}async provideInlayHints(V,H,Z){const X=this.f.getDocument(V),fe=n.Range.to(H),we=await this.h.provideInlayHints(X,fe,Z);if(!Array.isArray(we)||we.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(H)}`);return}if(Z.isCancellationRequested)return;const Te=this.d.add(we);this.e.set(Te,new p.$Tc);const Ve={hints:[],cacheId:Te};for(let Ze=0;Ze<we.length;Ze++)this.l(we[Ze],fe)&&Ve.hints.push(this.m(we[Ze],[Te,Ze]));return this.j.trace(`[InlayHints] ${Ve.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(H)}`),Ve}async resolveInlayHint(V,H){if(typeof this.h.resolveInlayHint!="function")return;const Z=this.d.get(...V);if(!Z)return;const X=await this.h.resolveInlayHint(Z,H);if(X&&this.l(X))return this.m(X,V)}releaseHints(V){this.e.get(V)?.dispose(),this.e.delete(V),this.d.delete(V)}l(V,H){return V.label.length===0||Array.isArray(V.label)&&V.label.every(Z=>Z.value.length===0)?(console.log("INVALID inlay hint, empty label",V),!1):!(H&&!H.contains(V.position))}m(V,H){const Z=this.e.get(H[0]);if(!Z)throw Error("DisposableStore is missing...");const X={label:"",cacheId:H,tooltip:n.MarkdownString.fromStrict(V.tooltip),position:n.Position.from(V.position),textEdits:V.textEdits&&V.textEdits.map(n.TextEdit.from),kind:V.kind&&n.InlayHintKind.from(V.kind),paddingLeft:V.paddingLeft,paddingRight:V.paddingRight};if(typeof V.label=="string")X.label=V.label;else{const fe=[];X.label=fe;for(const we of V.label){if(!we.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Te={label:we.value,tooltip:n.MarkdownString.fromStrict(we.tooltip)};r.$GM.isLocation(we.location)&&(Te.location=n.location.from(we.location)),we.command&&(Te.command=this.g.toInternal(we.command,Z)),fe.push(Te)}}return X}}class se{constructor(V,H){this.e=V,this.f=H,this.d=new t.$xjc("DocumentLink")}async provideLinks(V,H){const Z=this.e.getDocument(V),X=await this.f.provideDocumentLinks(Z,H);if(!(!Array.isArray(X)||X.length===0)&&!H.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:X.filter(se.g).map(n.DocumentLink.from)};{const fe=this.d.add(X),we={links:[],cacheId:fe};for(let Te=0;Te<X.length;Te++){if(!se.g(X[Te]))continue;const Ve=n.DocumentLink.from(X[Te]);Ve.cacheId=[fe,Te],we.links.push(Ve)}return we}}}static g(V){return V.target&&V.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(V,H){if(typeof this.f.resolveDocumentLink!="function")return;const Z=this.d.get(...V);if(!Z)return;const X=await this.f.resolveDocumentLink(Z,H);if(!(!X||!se.g(X)))return n.DocumentLink.from(X)}releaseLinks(V){this.d.delete(V)}}class oe{constructor(V,H){this.d=V,this.e=H}async provideColors(V,H){const Z=this.d.getDocument(V),X=await this.e.provideDocumentColors(Z,H);return Array.isArray(X)?X.map(we=>({color:n.Color.from(we.color),range:n.Range.from(we.range)})):[]}async provideColorPresentations(V,H,Z){const X=this.d.getDocument(V),fe=n.Range.to(H.range),we=n.Color.to(H.color),Te=await this.e.provideColorPresentations(we,{document:X,range:fe},Z);if(Array.isArray(Te))return Te.map(n.ColorPresentation.from)}}class G{constructor(V,H){this.d=V,this.e=H}async provideFoldingRanges(V,H,Z){const X=this.d.getDocument(V),fe=await this.e.provideFoldingRanges(X,H,Z);if(Array.isArray(fe))return fe.map(n.FoldingRange.from)}}class ee{constructor(V,H,Z){this.d=V,this.e=H,this.f=Z}async provideSelectionRanges(V,H,Z){const X=this.d.getDocument(V),fe=H.map(n.Position.to),we=await this.e.provideSelectionRanges(X,fe,Z);if(!(0,o.$Lb)(we))return[];if(we.length!==fe.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Te=[];for(let Ve=0;Ve<fe.length;Ve++){const Ze=[];Te.push(Ze);let nt=fe[Ve],ot=we[Ve];for(;;){if(!ot.range.contains(nt))throw new Error("INVALID selection range, must contain the previous range");if(Ze.push(n.SelectionRange.from(ot)),!ot.parent)break;nt=ot.range,ot=ot.parent}}return Te}}class le{constructor(V,H){this.f=V,this.g=H,this.d=new O.$TO(""),this.e=new Map}async prepareSession(V,H,Z){const X=this.f.getDocument(V),fe=n.Position.to(H),we=await this.g.prepareCallHierarchy(X,fe,Z);if(!we)return;const Te=this.d.nextId();return this.e.set(Te,new Map),Array.isArray(we)?we.map(Ve=>this.h(Te,Ve)):[this.h(Te,we)]}async provideCallsTo(V,H,Z){const X=this.j(V,H);if(!X)throw new Error("missing call hierarchy item");const fe=await this.g.provideCallHierarchyIncomingCalls(X,Z);if(fe)return fe.map(we=>({from:this.h(V,we.from),fromRanges:we.fromRanges.map(Te=>n.Range.from(Te))}))}async provideCallsFrom(V,H,Z){const X=this.j(V,H);if(!X)throw new Error("missing call hierarchy item");const fe=await this.g.provideCallHierarchyOutgoingCalls(X,Z);if(fe)return fe.map(we=>({to:this.h(V,we.to),fromRanges:we.fromRanges.map(Te=>n.Range.from(Te))}))}releaseSession(V){this.e.delete(V)}h(V,H){const Z=this.e.get(V),X=n.CallHierarchyItem.from(H,V,Z.size.toString(36));return Z.set(X._itemId,H),X}j(V,H){return this.e.get(V)?.get(H)}}class de{constructor(V,H){this.f=V,this.g=H,this.d=new O.$TO(""),this.e=new Map}async prepareSession(V,H,Z){const X=this.f.getDocument(V),fe=n.Position.to(H),we=await this.g.prepareTypeHierarchy(X,fe,Z);if(!we)return;const Te=this.d.nextId();return this.e.set(Te,new Map),Array.isArray(we)?we.map(Ve=>this.h(Te,Ve)):[this.h(Te,we)]}async provideSupertypes(V,H,Z){const X=this.j(V,H);if(!X)throw new Error("missing type hierarchy item");const fe=await this.g.provideTypeHierarchySupertypes(X,Z);if(fe)return fe.map(we=>this.h(V,we))}async provideSubtypes(V,H,Z){const X=this.j(V,H);if(!X)throw new Error("missing type hierarchy item");const fe=await this.g.provideTypeHierarchySubtypes(X,Z);if(fe)return fe.map(we=>this.h(V,we))}releaseSession(V){this.e.delete(V)}h(V,H){const Z=this.e.get(V),X=n.TypeHierarchyItem.from(H,V,Z.size.toString(36));return Z.set(X._itemId,H),X}j(V,H){return this.e.get(V)?.get(H)}}class Me{constructor(V,H,Z,X,fe){this.d=V,this.e=H,this.f=Z,this.g=X,this.h=fe}async provideDocumentOnDropEdits(V,H,Z,X,fe){const we=this.e.getDocument(H),Te=n.Position.to(Z),Ve=n.DataTransfer.toDataTransfer(X,async nt=>(await this.d.$resolveDocumentOnDropFileData(this.g,V,nt)).buffer),Ze=await this.f.provideDocumentDropEdits(we,Te,Ve,fe);if(Ze)return(0,o.$3b)(Ze).map(nt=>({title:nt.title??(0,l.localize)(1,null,this.h.displayName||this.h.name),kind:nt.kind?.value,yieldTo:nt.yieldTo?.map(ot=>ot.value),insertText:typeof nt.insertText=="string"?nt.insertText:{snippet:nt.insertText.value},additionalEdit:nt.additionalEdit?n.WorkspaceEdit.from(nt.additionalEdit,void 0):void 0}))}}class be{constructor(V,H){this.d=V,this.e=H}async provideMappedEdits(V,H,Z,X){const fe=b.URI.revive(V),we=this.d.getDocument(fe),Te=Z.documents.map(nt=>nt.map(ot=>({uri:b.URI.revive(ot.uri),version:ot.version,ranges:ot.ranges.map(lt=>n.Range.to(lt))}))),Ve={documents:Te,selections:Te[0]?.[0]?.ranges??[]},Ze=await this.e.provideMappedEdits(we,H,Ve,X);return Ze?n.WorkspaceEdit.from(Ze):null}}class Pe{constructor(V,H){this.adapter=V,this.extension=H}}class Re{constructor(V,H,Z,X,fe,we,Te,Ve){this.g=H,this.h=Z,this.j=X,this.k=fe,this.l=we,this.m=Te,this.n=Ve,this.f=new Map,this.e=V.getProxy(g.$sM.MainThreadLanguageFeatures)}o(V,H){return n.DocumentSelector.from(V,this.g,H)}p(V){return new r.$uM(()=>{this.f.delete(V),this.e.$unregister(V)})}q(){return Re.d++}async s(V,H,Z,X,fe,we=!1){const Te=this.f.get(V);if(!Te||!(Te.adapter instanceof H))return X;const Ve=Date.now();we||this.l.trace(`[${Te.extension.identifier.value}] INVOKE provider '${Z.toString().replace(/[\r\n]/g,"")}'`);const Ze=Z(Te.adapter,Te.extension);return Promise.resolve(Ze).catch(nt=>{(0,M.$4)(nt)||(this.l.error(`[${Te.extension.identifier.value}] provider FAILED`),this.l.error(nt),this.n.onExtensionError(Te.extension.identifier,nt))}).finally(()=>{we||this.l.trace(`[${Te.extension.identifier.value}] provider DONE after ${Date.now()-Ve}ms`)}),I.CancellationToken.isCancellationToken(fe)?(0,R.$0g)(Ze,fe):Ze}t(V,H){const Z=this.q();return this.f.set(Z,new Pe(V,H)),Z}static u(V){return V.displayName||V.name}registerDocumentSymbolProvider(V,H,Z,X){const fe=this.t(new d(this.h,Z),V),we=X&&X.label||Re.u(V);return this.e.$registerDocumentSymbolProvider(fe,this.o(H,V),we),this.p(fe)}$provideDocumentSymbols(V,H,Z){return this.s(V,d,X=>X.provideDocumentSymbols(b.URI.revive(H),Z),void 0,Z)}registerCodeLensProvider(V,H,Z){const X=this.q(),fe=typeof Z.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(X,new Pe(new h(this.h,this.j.converter,Z,V,this.n,this.l),V)),this.e.$registerCodeLensSupport(X,this.o(H,V),fe);let we=this.p(X);if(fe!==void 0){const Te=Z.onDidChangeCodeLenses(Ve=>this.e.$emitCodeLensEvent(fe));we=r.$uM.from(we,Te)}return we}$provideCodeLenses(V,H,Z){return this.s(V,h,X=>X.provideCodeLenses(b.URI.revive(H),Z),void 0,Z)}$resolveCodeLens(V,H,Z){return this.s(V,h,X=>X.resolveCodeLens(H,Z),void 0,void 0)}$releaseCodeLenses(V,H){this.s(V,h,Z=>Promise.resolve(Z.releaseCodeLenses(H)),void 0,void 0)}registerDefinitionProvider(V,H,Z){const X=this.t(new u(this.h,Z),V);return this.e.$registerDefinitionSupport(X,this.o(H,V)),this.p(X)}$provideDefinition(V,H,Z,X){return this.s(V,u,fe=>fe.provideDefinition(b.URI.revive(H),Z,X),[],X)}registerDeclarationProvider(V,H,Z){const X=this.t(new f(this.h,Z),V);return this.e.$registerDeclarationSupport(X,this.o(H,V)),this.p(X)}$provideDeclaration(V,H,Z,X){return this.s(V,f,fe=>fe.provideDeclaration(b.URI.revive(H),Z,X),[],X)}registerImplementationProvider(V,H,Z){const X=this.t(new E(this.h,Z),V);return this.e.$registerImplementationSupport(X,this.o(H,V)),this.p(X)}$provideImplementation(V,H,Z,X){return this.s(V,E,fe=>fe.provideImplementation(b.URI.revive(H),Z,X),[],X)}registerTypeDefinitionProvider(V,H,Z){const X=this.t(new v(this.h,Z),V);return this.e.$registerTypeDefinitionSupport(X,this.o(H,V)),this.p(X)}$provideTypeDefinition(V,H,Z,X){return this.s(V,v,fe=>fe.provideTypeDefinition(b.URI.revive(H),Z,X),[],X)}registerHoverProvider(V,H,Z,X){const fe=this.t(new D(this.h,Z),V);return this.e.$registerHoverProvider(fe,this.o(H,V)),this.p(fe)}$provideHover(V,H,Z,X){return this.s(V,D,fe=>fe.provideHover(b.URI.revive(H),Z,X),void 0,X)}registerEvaluatableExpressionProvider(V,H,Z,X){const fe=this.t(new k(this.h,Z),V);return this.e.$registerEvaluatableExpressionProvider(fe,this.o(H,V)),this.p(fe)}$provideEvaluatableExpression(V,H,Z,X){return this.s(V,k,fe=>fe.provideEvaluatableExpression(b.URI.revive(H),Z,X),void 0,X)}registerInlineValuesProvider(V,H,Z,X){const fe=typeof Z.onDidChangeInlineValues=="function"?this.q():void 0,we=this.t(new S(this.h,Z),V);this.e.$registerInlineValuesProvider(we,this.o(H,V),fe);let Te=this.p(we);if(fe!==void 0){const Ve=Z.onDidChangeInlineValues(Ze=>this.e.$emitInlineValuesEvent(fe));Te=r.$uM.from(Te,Ve)}return Te}$provideInlineValues(V,H,Z,X,fe){return this.s(V,S,we=>we.provideInlineValues(b.URI.revive(H),Z,X,fe),void 0,fe)}registerDocumentHighlightProvider(V,H,Z){const X=this.t(new F(this.h,Z),V);return this.e.$registerDocumentHighlightProvider(X,this.o(H,V)),this.p(X)}registerMultiDocumentHighlightProvider(V,H,Z){const X=this.t(new W(this.h,Z),V);return this.e.$registerMultiDocumentHighlightProvider(X,this.o(H,V)),this.p(X)}$provideDocumentHighlights(V,H,Z,X){return this.s(V,F,fe=>fe.provideDocumentHighlights(b.URI.revive(H),Z,X),void 0,X)}$provideMultiDocumentHighlights(V,H,Z,X,fe){return this.s(V,W,we=>we.provideMultiDocumentHighlights(b.URI.revive(H),Z,X.map(Te=>b.URI.revive(Te)),fe),void 0,fe)}registerLinkedEditingRangeProvider(V,H,Z){const X=this.t(new B(this.h,Z),V);return this.e.$registerLinkedEditingRangeProvider(X,this.o(H,V)),this.p(X)}$provideLinkedEditingRanges(V,H,Z,X){return this.s(V,B,async fe=>{const we=await fe.provideLinkedEditingRanges(b.URI.revive(H),Z,X);if(we)return{ranges:we.ranges,wordPattern:we.wordPattern?Re.w(we.wordPattern):void 0}},void 0,X)}registerReferenceProvider(V,H,Z){const X=this.t(new T(this.h,Z),V);return this.e.$registerReferenceSupport(X,this.o(H,V)),this.p(X)}$provideReferences(V,H,Z,X,fe){return this.s(V,T,we=>we.provideReferences(b.URI.revive(H),Z,X,fe),void 0,fe)}registerCodeActionProvider(V,H,Z,X){const fe=new p.$Tc,we=this.t(new N(this.h,this.j.converter,this.k,Z,this.l,V,this.m),V);return this.e.$registerQuickFixSupport(we,this.o(H,V),{providedKinds:X?.providedCodeActionKinds?.map(Te=>Te.value),documentation:X?.documentation?.map(Te=>({kind:Te.kind.value,command:this.j.converter.toInternal(Te.command,fe)}))},Re.u(V),!!Z.resolveCodeAction),fe.add(this.p(we)),fe}$provideCodeActions(V,H,Z,X,fe){return this.s(V,N,we=>we.provideCodeActions(b.URI.revive(H),Z,X,fe),void 0,fe)}$resolveCodeAction(V,H,Z){return this.s(V,N,X=>X.resolveCodeAction(H,Z),{},void 0)}$releaseCodeActions(V,H){this.s(V,N,Z=>Promise.resolve(Z.releaseCodeActions(H)),void 0,void 0)}registerDocumentFormattingEditProvider(V,H,Z){const X=this.t(new L(this.h,Z),V);return this.e.$registerDocumentFormattingSupport(X,this.o(H,V),V.identifier,V.displayName||V.name),this.p(X)}$provideDocumentFormattingEdits(V,H,Z,X){return this.s(V,L,fe=>fe.provideDocumentFormattingEdits(b.URI.revive(H),Z,X),void 0,X)}registerDocumentRangeFormattingEditProvider(V,H,Z){const X=typeof Z.provideDocumentRangesFormattingEdits=="function",fe=this.t(new z(this.h,Z),V);return this.e.$registerRangeFormattingSupport(fe,this.o(H,V),V.identifier,V.displayName||V.name,X),this.p(fe)}$provideDocumentRangeFormattingEdits(V,H,Z,X,fe){return this.s(V,z,we=>we.provideDocumentRangeFormattingEdits(b.URI.revive(H),Z,X,fe),void 0,fe)}$provideDocumentRangesFormattingEdits(V,H,Z,X,fe){return this.s(V,z,we=>we.provideDocumentRangesFormattingEdits(b.URI.revive(H),Z,X,fe),void 0,fe)}registerOnTypeFormattingEditProvider(V,H,Z,X){const fe=this.t(new Q(this.h,Z),V);return this.e.$registerOnTypeFormattingSupport(fe,this.o(H,V),X,V.identifier),this.p(fe)}$provideOnTypeFormattingEdits(V,H,Z,X,fe,we){return this.s(V,Q,Te=>Te.provideOnTypeFormattingEdits(b.URI.revive(H),Z,X,fe,we),void 0,we)}registerWorkspaceSymbolProvider(V,H){const Z=this.t(new Y(H,this.l),V);return this.e.$registerNavigateTypeSupport(Z,typeof H.resolveWorkspaceSymbol=="function"),this.p(Z)}$provideWorkspaceSymbols(V,H,Z){return this.s(V,Y,X=>X.provideWorkspaceSymbols(H,Z),{symbols:[]},Z)}$resolveWorkspaceSymbol(V,H,Z){return this.s(V,Y,X=>X.resolveWorkspaceSymbol(H,Z),void 0,void 0)}$releaseWorkspaceSymbols(V,H){this.s(V,Y,Z=>Z.releaseWorkspaceSymbols(H),void 0,void 0)}registerRenameProvider(V,H,Z){const X=this.t(new J(this.h,Z,this.l),V);return this.e.$registerRenameSupport(X,this.o(H,V),J.supportsResolving(Z)),this.p(X)}$provideRenameEdits(V,H,Z,X,fe){return this.s(V,J,we=>we.provideRenameEdits(b.URI.revive(H),Z,X,fe),void 0,fe)}$resolveRenameLocation(V,H,Z,X){return this.s(V,J,fe=>fe.resolveRenameLocation(b.URI.revive(H),Z,X),void 0,X)}registerNewSymbolNamesProvider(V,H,Z){const X=this.t(new x(this.h,Z,this.l),V);return this.e.$registerNewSymbolNamesProvider(X,this.o(H,V)),this.p(X)}$provideNewSymbolNames(V,H,Z,X){return this.s(V,x,fe=>fe.provideNewSymbolNames(b.URI.revive(H),Z,X),void 0,X)}registerDocumentSemanticTokensProvider(V,H,Z,X){const fe=this.t(new te(this.h,Z),V),we=typeof Z.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(fe,this.o(H,V),X,we);let Te=this.p(fe);if(we){const Ve=Z.onDidChangeSemanticTokens(Ze=>this.e.$emitDocumentSemanticTokensEvent(we));Te=r.$uM.from(Te,Ve)}return Te}$provideDocumentSemanticTokens(V,H,Z,X){return this.s(V,te,fe=>fe.provideDocumentSemanticTokens(b.URI.revive(H),Z,X),null,X)}$releaseDocumentSemanticTokens(V,H){this.s(V,te,Z=>Z.releaseDocumentSemanticColoring(H),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(V,H,Z,X){const fe=this.t(new pe(this.h,Z),V);return this.e.$registerDocumentRangeSemanticTokensProvider(fe,this.o(H,V),X),this.p(fe)}$provideDocumentRangeSemanticTokens(V,H,Z,X){return this.s(V,pe,fe=>fe.provideDocumentRangeSemanticTokens(b.URI.revive(H),Z,X),null,X)}registerCompletionItemProvider(V,H,Z,X){const fe=this.t(new ye(this.h,this.j.converter,Z,this.m,V),V);return this.e.$registerCompletionsProvider(fe,this.o(H,V),X,ye.supportsResolving(Z),V.identifier),this.p(fe)}$provideCompletionItems(V,H,Z,X,fe){return this.s(V,ye,we=>we.provideCompletionItems(b.URI.revive(H),Z,X,fe),void 0,fe)}$resolveCompletionItem(V,H,Z){return this.s(V,ye,X=>X.resolveCompletionItem(H,Z),void 0,Z)}$releaseCompletionItems(V,H){this.s(V,ye,Z=>Z.releaseCompletionItems(H),void 0,void 0)}registerInlineCompletionsProvider(V,H,Z,X){const fe=new U(V,this.h,Z,this.j.converter),we=this.t(fe,V);return this.e.$registerInlineCompletionsSupport(we,this.o(H,V),fe.supportsHandleEvents,i.$Em.toKey(V.identifier.value),X?.yieldTo?.map(Te=>i.$Em.toKey(Te))||[]),this.p(we)}$provideInlineCompletions(V,H,Z,X,fe){return this.s(V,_,we=>we.provideInlineCompletions(b.URI.revive(H),Z,X,fe),void 0,fe)}$handleInlineCompletionDidShow(V,H,Z,X){this.s(V,_,async fe=>{fe.handleDidShowCompletionItem(H,Z,X)},void 0,void 0)}$handleInlineCompletionPartialAccept(V,H,Z,X,fe){this.s(V,_,async we=>{we.handlePartialAccept(H,Z,X,fe)},void 0,void 0)}$freeInlineCompletionsList(V,H){this.s(V,_,async Z=>{Z.disposeCompletions(H)},void 0,void 0)}registerInlineEditProvider(V,H,Z){const X=new he(V,this.h,Z,this.j.converter),fe=this.t(X,V);return this.e.$registerInlineEditProvider(fe,this.o(H,V),V.identifier),this.p(fe)}$provideInlineEdit(V,H,Z,X){return this.s(V,he,fe=>fe.provideInlineEdits(b.URI.revive(H),Z,X),void 0,X)}$freeInlineEdit(V,H){this.s(V,he,async Z=>{Z.disposeEdit(H)},void 0,void 0)}registerSignatureHelpProvider(V,H,Z,X){const fe=Array.isArray(X)?{triggerCharacters:X,retriggerCharacters:[]}:X,we=this.t(new me(this.h,Z),V);return this.e.$registerSignatureHelpProvider(we,this.o(H,V),fe),this.p(we)}$provideSignatureHelp(V,H,Z,X,fe){return this.s(V,me,we=>we.provideSignatureHelp(b.URI.revive(H),Z,X,fe),void 0,fe)}$releaseSignatureHelp(V,H){this.s(V,me,Z=>Z.releaseSignatureHelp(H),void 0,void 0)}registerInlayHintsProvider(V,H,Z){const X=typeof Z.onDidChangeInlayHints=="function"?this.q():void 0,fe=this.t(new ie(this.h,this.j.converter,Z,this.l,V),V);this.e.$registerInlayHintsProvider(fe,this.o(H,V),typeof Z.resolveInlayHint=="function",X,Re.u(V));let we=this.p(fe);if(X!==void 0){const Te=Z.onDidChangeInlayHints(Ve=>this.e.$emitInlayHintsEvent(X));we=r.$uM.from(we,Te)}return we}$provideInlayHints(V,H,Z,X){return this.s(V,ie,fe=>fe.provideInlayHints(b.URI.revive(H),Z,X),void 0,X)}$resolveInlayHint(V,H,Z){return this.s(V,ie,X=>X.resolveInlayHint(H,Z),void 0,Z)}$releaseInlayHints(V,H){this.s(V,ie,Z=>Z.releaseHints(H),void 0,void 0)}registerDocumentLinkProvider(V,H,Z){const X=this.t(new se(this.h,Z),V);return this.e.$registerDocumentLinkProvider(X,this.o(H,V),typeof Z.resolveDocumentLink=="function"),this.p(X)}$provideDocumentLinks(V,H,Z){return this.s(V,se,X=>X.provideLinks(b.URI.revive(H),Z),void 0,Z,H.scheme==="output")}$resolveDocumentLink(V,H,Z){return this.s(V,se,X=>X.resolveLink(H,Z),void 0,void 0,!0)}$releaseDocumentLinks(V,H){this.s(V,se,Z=>Z.releaseLinks(H),void 0,void 0,!0)}registerColorProvider(V,H,Z){const X=this.t(new oe(this.h,Z),V);return this.e.$registerDocumentColorProvider(X,this.o(H,V)),this.p(X)}$provideDocumentColors(V,H,Z){return this.s(V,oe,X=>X.provideColors(b.URI.revive(H),Z),[],Z)}$provideColorPresentations(V,H,Z,X){return this.s(V,oe,fe=>fe.provideColorPresentations(b.URI.revive(H),Z,X),void 0,X)}registerFoldingRangeProvider(V,H,Z){const X=this.q(),fe=typeof Z.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(X,new Pe(new G(this.h,Z),V)),this.e.$registerFoldingRangeProvider(X,this.o(H,V),V.identifier,fe);let we=this.p(X);if(fe!==void 0){const Te=Z.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(fe));we=r.$uM.from(we,Te)}return we}$provideFoldingRanges(V,H,Z,X){return this.s(V,G,fe=>fe.provideFoldingRanges(b.URI.revive(H),Z,X),void 0,X)}registerSelectionRangeProvider(V,H,Z){const X=this.t(new ee(this.h,Z,this.l),V);return this.e.$registerSelectionRangeProvider(X,this.o(H,V)),this.p(X)}$provideSelectionRanges(V,H,Z,X){return this.s(V,ee,fe=>fe.provideSelectionRanges(b.URI.revive(H),Z,X),[],X)}registerCallHierarchyProvider(V,H,Z){const X=this.t(new le(this.h,Z),V);return this.e.$registerCallHierarchyProvider(X,this.o(H,V)),this.p(X)}$prepareCallHierarchy(V,H,Z,X){return this.s(V,le,fe=>Promise.resolve(fe.prepareSession(b.URI.revive(H),Z,X)),void 0,X)}$provideCallHierarchyIncomingCalls(V,H,Z,X){return this.s(V,le,fe=>fe.provideCallsTo(H,Z,X),void 0,X)}$provideCallHierarchyOutgoingCalls(V,H,Z,X){return this.s(V,le,fe=>fe.provideCallsFrom(H,Z,X),void 0,X)}$releaseCallHierarchy(V,H){this.s(V,le,Z=>Promise.resolve(Z.releaseSession(H)),void 0,void 0)}registerTypeHierarchyProvider(V,H,Z){const X=this.t(new de(this.h,Z),V);return this.e.$registerTypeHierarchyProvider(X,this.o(H,V)),this.p(X)}$prepareTypeHierarchy(V,H,Z,X){return this.s(V,de,fe=>Promise.resolve(fe.prepareSession(b.URI.revive(H),Z,X)),void 0,X)}$provideTypeHierarchySupertypes(V,H,Z,X){return this.s(V,de,fe=>fe.provideSupertypes(H,Z,X),void 0,X)}$provideTypeHierarchySubtypes(V,H,Z,X){return this.s(V,de,fe=>fe.provideSubtypes(H,Z,X),void 0,X)}$releaseTypeHierarchy(V,H){this.s(V,de,Z=>Promise.resolve(Z.releaseSession(H)),void 0,void 0)}registerDocumentOnDropEditProvider(V,H,Z,X){const fe=this.q();return this.f.set(fe,new Pe(new Me(this.e,this.h,Z,fe,V),V)),this.e.$registerDocumentOnDropEditProvider(fe,this.o(H,V),(0,s.$cG)(V,"dropMetadata")?X:void 0),this.p(fe)}$provideDocumentOnDropEdits(V,H,Z,X,fe,we){return this.s(V,Me,Te=>Promise.resolve(Te.provideDocumentOnDropEdits(H,b.URI.revive(Z),X,fe,we)),void 0,void 0)}registerMappedEditsProvider(V,H,Z){const X=this.t(new be(this.h,Z),V);return this.e.$registerMappedEditsProvider(X,this.o(H,V)),this.p(X)}$provideMappedEdits(V,H,Z,X,fe){return this.s(V,be,we=>Promise.resolve(we.provideMappedEdits(H,Z,X,fe)),null,fe)}registerDocumentPasteEditProvider(V,H,Z,X){const fe=this.q();return this.f.set(fe,new Pe(new j(this.e,this.h,Z,fe,V),V)),this.e.$registerPasteEditProvider(fe,this.o(H,V),{supportsCopy:!!Z.prepareDocumentPaste,supportsPaste:!!Z.provideDocumentPasteEdits,supportsResolve:!!Z.resolveDocumentPasteEdit,providedPasteEditKinds:X.providedPasteEditKinds?.map(we=>we.value),copyMimeTypes:X.copyMimeTypes,pasteMimeTypes:X.pasteMimeTypes}),this.p(fe)}$prepareDocumentPaste(V,H,Z,X,fe){return this.s(V,j,we=>we.prepareDocumentPaste(b.URI.revive(H),Z,X,fe),void 0,fe)}$providePasteEdits(V,H,Z,X,fe,we,Te){return this.s(V,j,Ve=>Ve.providePasteEdits(H,b.URI.revive(Z),X,fe,we,Te),void 0,Te)}$resolvePasteEdit(V,H,Z){return this.s(V,j,X=>X.resolvePasteEdit(H,Z),{},void 0)}$releasePasteEdits(V,H){this.s(V,j,Z=>Promise.resolve(Z.releasePasteEdits(H)),void 0,void 0)}static w(V){return{pattern:V.source,flags:V.flags}}static y(V){return{decreaseIndentPattern:Re.w(V.decreaseIndentPattern),increaseIndentPattern:Re.w(V.increaseIndentPattern),indentNextLinePattern:V.indentNextLinePattern?Re.w(V.indentNextLinePattern):void 0,unIndentedLinePattern:V.unIndentedLinePattern?Re.w(V.unIndentedLinePattern):void 0}}static z(V){return{beforeText:Re.w(V.beforeText),afterText:V.afterText?Re.w(V.afterText):void 0,previousLineText:V.previousLineText?Re.w(V.previousLineText):void 0,action:V.action}}static B(V){return V.map(Re.z)}static C(V){return{open:V.open,close:V.close,notIn:V.notIn?V.notIn.map(H=>r.SyntaxTokenType.toString(H)):void 0}}static D(V){return V.map(Re.C)}setLanguageConfiguration(V,H,Z){const{wordPattern:X}=Z;if(X&&(0,A.$0e)(X))throw new Error(`Invalid language configuration: wordPattern '${X}' is not allowed to match the empty string.`);X?this.h.setWordDefinitionFor(H,X):this.h.setWordDefinitionFor(H,void 0),Z.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",V,"Do not use."),Z.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",V,"Do not use.");const fe=this.q(),we={comments:Z.comments,brackets:Z.brackets,wordPattern:Z.wordPattern?Re.w(Z.wordPattern):void 0,indentationRules:Z.indentationRules?Re.y(Z.indentationRules):void 0,onEnterRules:Z.onEnterRules?Re.B(Z.onEnterRules):void 0,__electricCharacterSupport:Z.__electricCharacterSupport,__characterPairSupport:Z.__characterPairSupport,autoClosingPairs:Z.autoClosingPairs?Re.D(Z.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(fe,H,we),this.p(fe)}$setWordDefinitions(V){for(const H of V)this.h.setWordDefinitionFor(H.languageId,new RegExp(H.regexSource,H.regexFlags))}}e.$Hjc=Re,Re.d=0}),define(Ee[122],Ce([1,0,3,6,16,7,108,25,8,4,222,146,13,5,20,121,12]),function(re,e,o,R,I,M,O,p,$,w,A,P,b,C,y,a,m){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$Pjc=e.$Ojc=void 0,e.$Ojc=(0,C.$ii)("IExtHostLanguageModels");class i{constructor(t,g){this.option=t,this.stream=new $.$Lh,this.stream=g??new $.$Lh}}class n{constructor(){this.a=new Map,this.b=new $.$Lh,this.c=!1,this.d=!1;const t=this;this.apiObject={stream:t.b.asyncIterable}}*f(){if(this.a.size>0)for(const[,t]of this.a)yield t.stream;else yield this.b}handleFragment(t){if(this.c)return;this.d=!0;let g=this.a.get(t.index);g||(this.a.size===0?g=new i(t.index,this.b):g=new i(t.index),this.a.set(t.index,g)),g.stream.emitOne(t.part)}get isStreaming(){return this.d}reject(t){this.c=!0;for(const g of this.f())g.reject(t)}resolve(){this.c=!0;for(const t of this.f())t.resolve()}}let r=l=class{constructor(t,g,d){this.j=g,this.k=d,this.c=new w.$7d,this.d=new w.$7d,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new p.$Gm,this.i=new Map,this.o=new Set,this.b=t.getProxy(R.$sM.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(t,g,d,h){const c=l.a++;this.f.set(c,{extension:t.identifier,provider:d,languageModelId:g});let u;return h.auth&&(u={providerLabel:t.displayName||t.name,accountLabel:typeof h.auth=="object"?h.auth.label:void 0}),this.b.$registerLanguageModelProvider(c,g,{extension:t.identifier,identifier:g,model:h.name??"",auth:u}),(0,o.$Sc)(()=>{this.f.delete(c),this.b.$unregisterProvider(c)})}async $provideLanguageModelResponse(t,g,d,h,c,u){const f=this.f.get(t);if(!f)return;const E=new O.$Sv(async v=>{if(u.isCancellationRequested){this.j.warn(`[CHAT](${f.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(g,{index:v.index,part:v.part})});return f.provider.provideLanguageModelResponse2(h.map(I.LanguageModelMessage.to),c,p.$Em.toKey(d),E,u)}$updateLanguageModels(t){const g=[],d=[];if(t.added)for(const h of t.added)this.g.set(h.identifier,h),g.push(h.model);if(t.removed)for(const h of t.removed){this.g.delete(h),d.push(h);for(const[c,u]of this.i)u.languageModelId===h&&(u.res.reject(new b.$5),this.i.delete(c))}this.d.fire(Object.freeze({added:Object.freeze(g),removed:Object.freeze(d)})),t.added?.forEach(this.n,this)}getLanguageModelIds(){return Array.from(this.g.keys())}$updateModelAccesslist(t){const g=new Array;for(const{from:d,to:h,enabled:c}of t){const u=this.h.get(d)??new p.$Fm;if(u.has(h)!==c){c?u.add(h):u.delete(h),this.h.set(d,u);const E={from:d,to:h};g.push(E),this.c.fire(E)}}}async sendChatRequest(t,g,d,h,c){const u=t.identifier,f=await this.b.$prepareChatAccess(u,g,h.justification);if(!f||!this.g.has(g))throw M.$BO.NotFound(`Language model '${g}' is unknown.`);if(this.m(u,f)&&(!await this.l(t,{identifier:f.extension,displayName:f.auth.providerLabel},h.justification,h.silent)||!this.h.get(u)?.has(f.extension)))throw M.$BO.NoPermissions(`Language model '${g}' cannot be used by '${u.value}'.`);const E=Math.random()*1e6|0,v=this.b.$fetchResponse(u,g,E,d.map(I.LanguageModelMessage.from),h.modelOptions??{},c),D=new $.$hh,k=new n;this.i.set(E,{languageModelId:g,res:k});let S;if(v.catch(F=>{D.isOpen()?k.reject(F):S=F}).finally(()=>{this.i.delete(E),k.resolve(),D.open()}),await D.wait(),S)throw new M.$BO(`Language model '${g}' errored, check cause for more details`,"Unknown",S);return k.apiObject}async $handleResponseFragment(t,g){const d=this.i.get(t);d&&d.res.handleFragment(g)}async l(t,g,d,h){const c=P.$uL+g.identifier.value;if(await this.k.getSession(t,c,[],{silent:!0}))return this.$updateModelAccesslist([{from:t.identifier,to:g.identifier,enabled:!0}]),!0;if(h)return!1;try{const f=d?(0,A.localize)(0,null,g.displayName,d):(0,A.localize)(1,null,g.displayName);return await this.k.getSession(t,c,[],{forceNewSession:{detail:f}}),this.$updateModelAccesslist([{from:t.identifier,to:g.identifier,enabled:!0}]),!0}catch{return!1}}m(t,g){return!!g.auth&&!p.$Em.equals(g.extension,t)}async n(t){for(const g of this.o)try{await this.l(g,{identifier:t.extension,displayName:""},void 0,!0)}catch(d){this.j.error("Fake Auth request failed"),this.j.error(d)}}createLanguageModelAccessInformation(t){this.o.add(t);const g=this,d=w.Event.signal(w.Event.filter(this.c.event,c=>p.$Em.equals(c.from,t.identifier))),h=w.Event.signal(this.d.event);return{get onDidChange(){return w.Event.any(d,h)},canSendRequest(c){const u=g.g.get(c);if(!u)return;if(!g.m(t.identifier,u))return!0;const f=g.h.get(t.identifier);if(f)return f.has(u.extension)}}}};e.$Pjc=r,r.a=1,e.$Pjc=r=l=Qe([He(0,y.$OO),He(1,m.$Oj),He(2,a.$Jjc)],r)}),define(Ee[338],Ce([1,0,6,16,7,41,8,3,26]),function(re,e,o,R,I,M,O,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9kc=void 0;class w{constructor(P,b,C,y){this.c=b,this.d=C,this.e=y,this.b=[],this.f=0,this.g=new Set,this.a=P.getProxy(o.$sM.MainThreadLanguages)}$acceptLanguageIds(P){this.b=P}async getLanguages(){return this.b.slice(0)}async changeLanguage(P,b){await this.a.$changeLanguage(P,b);const C=this.c.getDocumentData(P);if(!C)throw new Error(`document '${P.toString()}' NOT found`);return C.document}async tokenAtPosition(P,b){const C=P.version,y=R.Position.from(b),a=await this.a.$tokensAtPosition(P.uri,y),m={type:I.StandardTokenType.Other,range:P.getWordRangeAtPosition(b)??new I.$wM(b.line,b.character,b.line,b.character)};if(!a)return m;const l={range:R.Range.to(a.range),type:R.TokenType.to(a.type)};return!l.range.contains(b)||C!==P.version?m:l}createLanguageStatusItem(P,b,C){const y=this.f++,a=this.a,m=this.g,l=`${P.identifier.value}/${b}`;if(m.has(l))throw new Error(`LanguageStatusItem with id '${b}' ALREADY exists`);m.add(l);const i={selector:C,id:b,name:P.displayName??P.name,severity:I.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let n;const r=new p.$Tc,s=()=>{if(n?.dispose(),!m.has(l)){console.warn(`LanguageStatusItem (${b}) from ${P.identifier.value} has been disposed and CANNOT be updated anymore`);return}n=(0,O.$kh)(()=>{r.clear(),this.a.$setLanguageStatus(y,{id:l,name:i.name??P.displayName??P.name,source:P.displayName??P.name,selector:R.DocumentSelector.from(i.selector,this.e),label:i.text,detail:i.detail??"",severity:i.severity===I.LanguageStatusSeverity.Error?M.default.Error:i.severity===I.LanguageStatusSeverity.Warning?M.default.Warning:M.default.Info,command:i.command&&this.d.toInternal(i.command,r),accessibilityInfo:i.accessibilityInformation,busy:i.busy})},0)},t={dispose(){r.dispose(),n?.dispose(),a.$removeLanguageStatus(y),m.delete(l)},get id(){return i.id},get name(){return i.name},set name(g){i.name=g,s()},get selector(){return i.selector},set selector(g){i.selector=g,s()},get text(){return i.text},set text(g){i.text=g,s()},set text2(g){(0,$.$dG)(P,"languageStatusText"),i.text=g,s()},get text2(){return(0,$.$dG)(P,"languageStatusText"),i.text},get detail(){return i.detail},set detail(g){i.detail=g,s()},get severity(){return i.severity},set severity(g){i.severity=g,s()},get accessibilityInformation(){return i.accessibilityInformation},set accessibilityInformation(g){i.accessibilityInformation=g,s()},get command(){return i.command},set command(g){i.command=g,s()},get busy(){return i.busy},set busy(g){i.busy=g,s()}};return s(),t}}e.$9kc=w}),define(Ee[339],Ce([1,0,15,2,16,7,120]),function(re,e,o,R,I,M,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ukc=e.$Tkc=void 0;class p{constructor(P,b,C,y){this.start=P,this.deletedCount=b,this.deletedItems=C,this.items=y}asApiEvent(){return{range:new M.$VN(this.start,this.start+this.deletedCount),addedCells:this.items.map(P=>P.apiCell),removedCells:this.deletedItems}}}class ${static asModelAddData(P){return{EOL:P.eol,lines:P.source,languageId:P.language,uri:P.uri,isDirty:!1,versionId:1}}constructor(P,b,C){this.notebook=P,this.h=b,this.j=C,this.handle=C.handle,this.uri=R.URI.revive(C.uri),this.cellKind=C.cellKind,this.a=C.outputs.map(I.NotebookCellOutput.to),this.e=C.internalMetadata??{},this.b=Object.freeze(C.metadata??{}),this.d=Object.freeze(I.NotebookCellExecutionSummary.to(C.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const P=this,b=this.h.getDocument(this.uri);if(!b)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const C={get index(){return P.notebook.getCellIndex(P)},notebook:P.notebook.apiNotebook,kind:I.NotebookCellKind.to(this.j.cellKind),document:b.document,get mime(){return P.g},set mime(y){P.g=y},get outputs(){return P.a.slice(0)},get metadata(){return P.b},get executionSummary(){return P.d}};this.f=Object.freeze(C)}return this.f}setOutputs(P){this.a=P.map(I.NotebookCellOutput.to)}setOutputItems(P,b,C){const y=C.map(I.NotebookCellOutputItem.to),a=this.a.find(m=>m.id===P);if(a&&(b||(a.items.length=0),a.items.push(...y),a.items.length>1&&a.items.every(m=>O.$pK(m.mime)))){const m=new Map,l=[];a.items.forEach(i=>{let n;m.has(i.mime)?n=m.get(i.mime):(n=[],m.set(i.mime,n),l.push(i.mime)),n.push(i.data)}),a.items.length=0,l.forEach(i=>{const n=O.$qK(m.get(i));a.items.push({mime:i,data:n.data.buffer})})}}setMetadata(P){this.b=Object.freeze(P)}setInternalMetadata(P){this.e=P,this.d=Object.freeze(I.NotebookCellExecutionSummary.to(P))}setMime(P){}}e.$Tkc=$;class w{constructor(P,b,C,y,a){this.k=P,this.l=b,this.m=C,this.uri=y,this.handle=w.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=a.viewType,this.f=Object.freeze(a.metadata??Object.create(null)),this.r([[0,0,a.cells]],!0,void 0),this.g=a.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const P=this,b={get uri(){return P.uri},get version(){return P.g},get notebookType(){return P.d},get isDirty(){return P.h},get isUntitled(){return P.uri.scheme===o.Schemas.untitled},get isClosed(){return P.j},get metadata(){return P.f},get cellCount(){return P.b.length},cellAt(C){return C=P.n(C),P.b[C].apiCell},getCells(C){return(C?P.p(C):P.b).map(a=>a.apiCell)},save(){return P.q()}};this.e=Object.freeze(b)}return this.e}acceptDocumentPropertiesChanged(P){P.metadata&&(this.f=Object.freeze({...this.f,...P.metadata}))}acceptDirty(P){this.h=P}acceptModelChanged(P,b,C){this.g=P.versionId,this.h=b,this.acceptDocumentPropertiesChanged({metadata:C});const y={notebook:this.apiNotebook,metadata:C,cellChanges:[],contentChanges:[]},a=[];for(const l of P.rawEvents)l.kind===O.NotebookCellsChangeType.ModelChange?this.r(l.changes,!1,y.contentChanges):l.kind===O.NotebookCellsChangeType.Move?this.s(l.index,l.length,l.newIdx,y.contentChanges):l.kind===O.NotebookCellsChangeType.Output?(this.t(l.index,l.outputs),a.push({cell:this.b[l.index].apiCell,outputs:this.b[l.index].apiCell.outputs})):l.kind===O.NotebookCellsChangeType.OutputItem?(this.u(l.index,l.outputId,l.append,l.outputItems),a.push({cell:this.b[l.index].apiCell,outputs:this.b[l.index].apiCell.outputs})):l.kind===O.NotebookCellsChangeType.ChangeCellLanguage?(this.v(l.index,l.language),a.push({cell:this.b[l.index].apiCell,document:this.b[l.index].apiCell.document})):l.kind===O.NotebookCellsChangeType.ChangeCellContent?a.push({cell:this.b[l.index].apiCell,document:this.b[l.index].apiCell.document}):l.kind===O.NotebookCellsChangeType.ChangeCellMime?this.w(l.index,l.mime):l.kind===O.NotebookCellsChangeType.ChangeCellMetadata?(this.x(l.index,l.metadata),a.push({cell:this.b[l.index].apiCell,metadata:this.b[l.index].apiCell.metadata})):l.kind===O.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(l.index,l.internalMetadata),a.push({cell:this.b[l.index].apiCell,executionSummary:this.b[l.index].apiCell.executionSummary}));const m=new Map;for(let l=0;l<a.length;l++){const i=a[l],n=m.get(i.cell);if(n===void 0){const r=y.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...i});m.set(i.cell,r-1)}else y.cellChanges[n]={...y.cellChanges[n],...i}}return Object.freeze(y),Object.freeze(y.cellChanges),Object.freeze(y.contentChanges),y}n(P){return P=P|0,P<0?0:P>=this.b.length?this.b.length-1:P}o(P){let b=P.start|0,C=P.end|0;return b<0&&(b=0),C>this.b.length&&(C=this.b.length),P.with({start:b,end:C})}p(P){P=this.o(P);const b=[];for(let C=P.start;C<P.end;C++)b.push(this.b[C]);return b}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(P,b,C){if(this.j)return;const y=[],a=[],m=[];if(P.reverse().forEach(l=>{const n=l[2].map(t=>{const g=new $(this,this.l,t);return b||a.push($.asModelAddData(t)),g}),r=new p(l[0],l[1],[],n),s=this.b.splice(l[0],l[1],...n);for(const t of s)m.push(t.uri),r.deletedItems.push(t.apiCell);y.push(r)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:a,removedDocuments:m}),C)for(const l of y)C.push(l.asApiEvent())}s(P,b,C,y){const a=this.b.splice(P,b);this.b.splice(C,0,...a);const m=[new p(P,b,a.map(l=>l.apiCell),[]),new p(C,0,[],a)];for(const l of m)y.push(l.asApiEvent())}t(P,b){this.b[P].setOutputs(b)}u(P,b,C,y){this.b[P].setOutputItems(b,C,y)}v(P,b){const C=this.b[P];C.apiCell.document.languageId!==b&&this.m.$acceptModelLanguageChanged(C.uri,b)}w(P,b){const C=this.b[P];C.apiCell.mime=b}x(P,b){this.b[P].setMetadata(b)}y(P,b){this.b[P].setInternalMetadata(b)}getCellFromApiCell(P){return this.b.find(b=>b.apiCell===P)}getCellFromIndex(P){return this.b[P]}getCell(P){return this.b.find(b=>b.handle===P)}getCellIndex(P){return this.b.indexOf(P)}}e.$Ukc=w,w.a=0}),define(Ee[340],Ce([1,0,4,2,16,7]),function(re,e,o,R,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$kc=void 0;class O{constructor($,w,A,P={timeout:1500,errors:3}){this.b=$,this.c=w,this.d=A,this.f=P,this.a=new o.$9d}dispose(){}getOnWillSaveNotebookDocumentEvent($){return(w,A,P)=>{const b=function(y){w.call(A,y)};return b.extension=$,this.a.event(b,void 0,P)}}async $participateInSave($,w,A){const P=R.URI.revive($),b=this.c.getNotebookDocument(P);if(!b)throw new Error("Unable to resolve notebook document");const C=[];if(await this.a.fireAsync({notebook:b.apiNotebook,reason:I.TextDocumentSaveReason.to(w)},A,async(a,m)=>{const l=Date.now(),i=await await Promise.resolve(a);Date.now()-l>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",m.extension.identifier),!A.isCancellationRequested&&i&&(i instanceof M.$EM?C.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",m.extension.identifier,"ignored due to invalid data"))}),A.isCancellationRequested)return!1;if(C.length===0)return!0;const y={edits:[]};for(const a of C){const{edits:m}=I.WorkspaceEdit.from(a);y.edits=y.edits.concat(m)}return this.d.$tryApplyWorkspaceEdit(y)}}e.$$kc=O}),define(Ee[154],Ce([1,0,13,16,7]),function(re,e,o,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vkc=void 0;class M{constructor(p,$,w,A,P,b){this.id=p,this.f=$,this.notebookData=w,this.a=[],this.b=[],this.d=!1,this.a=P,this.b=A,this.c=b}get apiEditor(){if(!this.e){const p=this;this.e={get notebook(){return p.notebookData.apiNotebook},get selection(){return p.a[0]},set selection($){this.selections=[$]},get selections(){return p.a},set selections($){if(!Array.isArray($)||!$.every(I.$VN.isNotebookRange))throw(0,o.$7)("selections");p.a=$,p.g($)},get visibleRanges(){return p.b},revealRange($,w){p.f.$tryRevealRange(p.id,R.NotebookRange.from($),w??I.NotebookEditorRevealType.Default)},get viewColumn(){return p.c}},M.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(p){this.d=p}_acceptVisibleRanges(p){this.b=p}_acceptSelections(p){this.a=p}g(p){this.f.$trySetSelections(this.id,p.map(R.NotebookRange.from))}_acceptViewColumn(p){this.c=p}}e.$Vkc=M,M.apiEditorsToExtHost=new WeakMap}),define(Ee[341],Ce([1,0,4,12,16]),function(re,e,o,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$alc=void 0;let M=class{constructor(p,$){this.c=p,this.d=$,this.a=new o.$7d,this.b=new o.$7d,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(p,$){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",p,$);const w=this.d.getEditorById(p);$.visibleRanges&&w._acceptVisibleRanges($.visibleRanges.ranges.map(I.NotebookRange.to)),$.selections&&w._acceptSelections($.selections.selections.map(I.NotebookRange.to)),$.visibleRanges&&this.b.fire({notebookEditor:w.apiEditor,visibleRanges:w.apiEditor.visibleRanges}),$.selections&&this.a.fire(Object.freeze({notebookEditor:w.apiEditor,selections:w.apiEditor.selections}))}$acceptEditorViewColumns(p){for(const $ in p)this.d.getEditorById($)._acceptViewColumn(I.ViewColumn.to(p[$]))}};e.$alc=M,e.$alc=M=Qe([He(0,R.$Oj)],M)}),define(Ee[342],Ce([1,0,4,6,154]),function(re,e,o,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dlc=void 0;class M{constructor(p,$){this.c=$,this.a=new Map,this.b=p.getProxy(R.$sM.MainThreadNotebookRenderers)}$postRendererMessage(p,$,w){const A=this.c.getEditorById(p);this.a.get($)?.fire({editor:A.apiEditor,message:w})}createRendererMessaging(p,$){if(!p.contributes?.notebookRenderer?.some(A=>A.id===$))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${$})`);return{onDidReceiveMessage:(A,P,b)=>this.d($).event(A,P,b),postMessage:(A,P)=>{I.$Vkc.apiEditorsToExtHost.has(A)&&([A,P]=[P,A]);const b=P&&I.$Vkc.apiEditorsToExtHost.get(P);return this.b.$postMessage(b?.id,$,A)}}}d(p){let $=this.a.get(p);return $||($=new o.$7d({onDidRemoveLastListener:()=>{$?.dispose(),this.a.delete(p)}}),this.a.set(p,$),$)}}e.$dlc=M}),define(Ee[343],Ce([1,0,16,108,22,54,13]),function(re,e,o,R,I,M,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hlc=void 0;class p{constructor(P){this.b=0,this.c=new Map,this.a=P}async withProgress(P,b,C){const y=this.b++,{title:a,location:m,cancellable:l}=b,i={label:P.displayName||P.name,id:P.identifier.value};return this.a.$startProgress(y,{location:o.ProgressLocation.from(m),title:a,source:i,cancellable:l},P.isUnderDevelopment?void 0:P.identifier.value).catch(O.$2),this.d(y,C,!!l)}d(P,b,C){let y;C&&(y=new I.$ee,this.c.set(P,y));const a=l=>{this.a.$progressEnd(l),this.c.delete(l),y?.dispose()};let m;try{m=b(new w(this.a,P),C&&y?y.token:I.CancellationToken.None)}catch(l){throw a(P),l}return m.then(l=>a(P),l=>a(P)),m}$acceptProgressCanceled(P){const b=this.c.get(P);b&&(b.cancel(),this.c.delete(P))}}e.$hlc=p;function $(A,P){return A.message=P.message,typeof P.increment=="number"&&(typeof A.increment=="number"?A.increment+=P.increment:A.increment=P.increment),A}class w extends R.$Sv{constructor(P,b){super(C=>this.throttledReport(C)),this.c=P,this.d=b}throttledReport(P){this.c.$progressReport(this.d,P)}}Qe([(0,M.$Oh)(100,(A,P)=>$(A,P),()=>Object.create(null))],w.prototype,"throttledReport",null)}),define(Ee[344],Ce([1,0,2,6,8,16]),function(re,e,o,R,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ilc=void 0;class O{constructor($,w){this.d=w,this.c=new Map,this.b=$.getProxy(R.$sM.MainThreadQuickDiff)}$provideOriginalResource($,w,A){const P=o.URI.revive(w),b=this.c.get($);return b?(0,I.$ah)(()=>b.provideOriginalResource(P,A)).then(C=>C||null):Promise.resolve(null)}registerQuickDiffProvider($,w,A,P){const b=O.a++;return this.c.set(b,w),this.b.$registerQuickDiffProvider(b,M.DocumentSelector.from($,this.d),A,P),{dispose:()=>{this.b.$unregisterQuickDiffProvider(b),this.c.delete(b)}}}}e.$ilc=O,O.a=0}),define(Ee[345],Ce([1,0,22,4,3,6,2,7,13,19,41,56,26,16]),function(re,e,o,R,I,M,O,p,$,w,A,P,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jlc=y;function y(a,m,l){const i=a.getProxy(M.$sM.MainThreadQuickOpen);class n{constructor(f,E){this.e=new Map,this.f=0,this.a=f,this.b=E}showQuickPick(f,E,v,D=o.CancellationToken.None){this.c=void 0;const k=Promise.resolve(E),S=++this.f,F=i.$show(S,{title:v?.title,placeHolder:v?.placeHolder,matchOnDescription:v?.matchOnDescription,matchOnDetail:v?.matchOnDetail,ignoreFocusLost:v?.ignoreFocusOut,canPickMany:v?.canPickMany},D),W={},B=F.then(()=>W);return Promise.race([B,k]).then(T=>{if(T===W)return;const N=(0,b.$cG)(f,"quickPickItemTooltip");return k.then(j=>{const L=[];for(let z=0;z<j.length;z++){const Q=j[z];if(typeof Q=="string")L.push({label:Q,handle:z});else if(Q.kind===p.QuickPickItemKind.Separator)L.push({type:"separator",label:Q.label});else{Q.tooltip&&!N&&console.warn(`Extension '${f.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${f.identifier.value}`);const Y=Q.iconPath?d(Q.iconPath):void 0;L.push({label:Q.label,iconPath:Y?.iconPath,iconClass:Y?.iconClass,description:Q.description,detail:Q.detail,picked:Q.picked,alwaysShow:Q.alwaysShow,tooltip:N?C.MarkdownString.fromStrict(Q.tooltip):void 0,handle:z})}}return v&&typeof v.onDidSelectItem=="function"&&(this.c=z=>{v.onDidSelectItem(j[z])}),i.$setItems(S,L),F.then(z=>{if(typeof z=="number")return j[z];if(Array.isArray(z))return z.map(Q=>j[Q])})})}).then(void 0,T=>{if(!(0,$.$4)(T))return i.$setError(S,T),Promise.reject(T)})}$onItemSelected(f){this.c?.(f)}showInput(f,E=o.CancellationToken.None){return this.d=f?.validateInput,i.$input(f,typeof this.d=="function",E).then(void 0,v=>{if(!(0,$.$4)(v))return Promise.reject(v)})}async $validateInput(f){if(!this.d)return;const E=await this.d(f);if(!E||typeof E=="string")return E;let v;switch(E.severity){case p.InputBoxValidationSeverity.Info:v=A.default.Info;break;case p.InputBoxValidationSeverity.Warning:v=A.default.Warning;break;case p.InputBoxValidationSeverity.Error:v=A.default.Error;break;default:v=E.message?A.default.Error:A.default.Ignore;break}return{content:E.message,severity:v}}async showWorkspaceFolderPick(f,E=o.CancellationToken.None){const v=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[f]);if(!v)return;const D=await this.a.getWorkspaceFolders2();if(D)return D.find(k=>k.uri.toString()===v.uri.toString())}createQuickPick(f){const E=new h(f,()=>this.e.delete(E._id));return this.e.set(E._id,E),E}createInputBox(f){const E=new c(f,()=>this.e.delete(E._id));return this.e.set(E._id,E),E}$onDidChangeValue(f,E){this.e.get(f)?._fireDidChangeValue(E)}$onDidAccept(f){this.e.get(f)?._fireDidAccept()}$onDidChangeActive(f,E){const v=this.e.get(f);v instanceof h&&v._fireDidChangeActive(E)}$onDidChangeSelection(f,E){const v=this.e.get(f);v instanceof h&&v._fireDidChangeSelection(E)}$onDidTriggerButton(f,E){this.e.get(f)?._fireDidTriggerButton(E)}$onDidTriggerItemButton(f,E,v){const D=this.e.get(f);D instanceof h&&D._fireDidTriggerItemButton(E,v)}$onDidHide(f){this.e.get(f)?._fireDidHide()}}class r{constructor(f,E){this.x=f,this.y=E,this._id=h.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new R.$7d,this.q=new R.$7d,this.r=new R.$7d,this.s=new R.$7d,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(f){this.b=f,this.z({title:f})}get step(){return this.c}set step(f){this.c=f,this.z({step:f})}get totalSteps(){return this.d}set totalSteps(f){this.d=f,this.z({totalSteps:f})}get enabled(){return this.g}set enabled(f){this.g=f,this.z({enabled:f})}get busy(){return this.j}set busy(f){this.j=f,this.z({busy:f})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(f){this.k=f,this.z({ignoreFocusOut:f})}get value(){return this.l}set value(f){this.l=f,this.z({value:f})}get placeholder(){return this.m}set placeholder(f){this.m=f,this.z({placeholder:f})}get buttons(){return this.n}set buttons(f){this.n=f.slice(),this.o.clear(),f.forEach((E,v)=>{const D=E===p.$SN.Back?-1:v;this.o.set(D,E)}),this.z({buttons:f.map((E,v)=>({...d(E.iconPath),tooltip:E.tooltip,handle:E===p.$SN.Back?-1:v}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(f){this.l=f,this.q.fire(f)}_fireDidTriggerButton(f){const E=this.o.get(f);E&&this.r.fire(E)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,I.$Pc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),i.$dispose(this._id))}z(f){if(!this.v){for(const E of Object.keys(f)){const v=f[E];this.u[E]=v===void 0?null:v}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){i.$createOrUpdate(this.u),this.u={id:this._id}}}r.a=1;function s(u){if(u instanceof p.$qN)return{id:u.id};const f=g(u),E=t(u);return{dark:typeof f=="string"?O.URI.file(f):f,light:typeof E=="string"?O.URI.file(E):E}}function t(u){return typeof u=="object"&&"light"in u?u.light:u}function g(u){return typeof u=="object"&&"dark"in u?u.dark:u}function d(u){const f=s(u);let E,v;return"id"in f?v=P.ThemeIcon.asClassName(f):E=f,{iconPath:E,iconClass:v}}class h extends r{constructor(f,E){super(f.identifier,E),this.O=f,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new R.$7d,this.L=[],this.M=new R.$7d,this.N=new R.$7d,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(f){this.B=f.slice(),this.C.clear(),this.D.clear(),f.forEach((D,k)=>{this.C.set(k,D),this.D.set(D,k)});const E=(0,b.$cG)(this.O,"quickPickItemTooltip"),v=[];for(let D=0;D<f.length;D++){const k=f[D];if(k.kind===p.QuickPickItemKind.Separator)v.push({type:"separator",label:k.label});else{k.tooltip&&!E&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const S=k.iconPath?d(k.iconPath):void 0;v.push({handle:D,label:k.label,iconPath:S?.iconPath,iconClass:S?.iconClass,description:k.description,detail:k.detail,picked:k.picked,alwaysShow:k.alwaysShow,tooltip:E?C.MarkdownString.fromStrict(k.tooltip):void 0,buttons:k.buttons?.map((F,W)=>({...d(F.iconPath),tooltip:F.tooltip,handle:W}))})}}this.z({items:v})}get canSelectMany(){return this.E}set canSelectMany(f){this.E=f,this.z({canSelectMany:f})}get matchOnDescription(){return this.F}set matchOnDescription(f){this.F=f,this.z({matchOnDescription:f})}get matchOnDetail(){return this.G}set matchOnDetail(f){this.G=f,this.z({matchOnDetail:f})}get sortByLabel(){return this.H}set sortByLabel(f){this.H=f,this.z({sortByLabel:f})}get keepScrollPosition(){return this.I}set keepScrollPosition(f){this.I=f,this.z({keepScrollPosition:f})}get activeItems(){return this.J}set activeItems(f){this.J=f.filter(E=>this.D.has(E)),this.z({activeItems:this.J.map(E=>this.D.get(E))})}get selectedItems(){return this.L}set selectedItems(f){this.L=f.filter(E=>this.D.has(E)),this.z({selectedItems:this.L.map(E=>this.D.get(E))})}_fireDidChangeActive(f){const E=(0,w.$Hb)(f.map(v=>this.C.get(v)));this.J=E,this.K.fire(E)}_fireDidChangeSelection(f){const E=(0,w.$Hb)(f.map(v=>this.C.get(v)));this.L=E,this.M.fire(E)}_fireDidTriggerItemButton(f,E){const v=this.C.get(f);if(!v||!v.buttons||!v.buttons.length)return;const D=v.buttons[E];D&&this.N.fire({button:D,item:v})}}class c extends r{constructor(f,E){super(f.identifier,E),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(f){this.B=f,this.z({password:f})}get prompt(){return this.C}set prompt(f){this.C=f,this.z({prompt:f})}get valueSelection(){return this.D}set valueSelection(f){this.D=f,this.z({valueSelection:f})}get validationMessage(){return this.E}set validationMessage(f){this.E=f,f?typeof f=="string"?this.z({validationMessage:f,severity:A.default.Error}):this.z({validationMessage:f.message,severity:f.severity??A.default.Error}):this.z({validationMessage:void 0,severity:A.default.Ignore})}}return new n(m,l)}});var qe=this&&this.__classPrivateFieldGet||function(re,e,o,R){if(o==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!R:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?R:o==="a"?R.call(re):R?R.value:e.get(re)},it=this&&this.__classPrivateFieldSet||function(re,e,o,R,I){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!I:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?I.call(re,o):I?I.value=o:e.set(re,o),o};define(Ee[346],Ce([1,0,2,4,54,3,8,6,19,127,12,25,56,16,26,15,11]),function(re,e,o,R,I,M,O,p,$,w,A,P,b,C,y,a,m){"use strict";var l,i,n,r;Object.defineProperty(e,"__esModule",{value:!0}),e.$llc=e.$klc=void 0;function s(B){return B instanceof o.URI}function t(B,T){return B.scheme===a.Schemas.file&&T.scheme===a.Schemas.file&&m.$e?B.toString()===T.toString():B.toString().toLowerCase()===T.toString().toLowerCase()}function g(B){if(B)return typeof B.iconPath=="string"?o.URI.file(B.iconPath):o.URI.isUri(B.iconPath)||b.ThemeIcon.isThemeIcon(B.iconPath)?B.iconPath:void 0}function d(B){if(B.icon){if(o.URI.isUri(B.icon))return B.icon;if(b.ThemeIcon.isThemeIcon(B.icon))return B.icon;{const T=B.icon;return{light:T.light,dark:T.dark}}}else return}function h(B,T){if(!B.iconPath&&!T.iconPath)return 0;if(B.iconPath){if(!T.iconPath)return 1}else return-1;const N=typeof B.iconPath=="string"?B.iconPath:o.URI.isUri(B.iconPath)?B.iconPath.fsPath:B.iconPath.id,j=typeof T.iconPath=="string"?T.iconPath:o.URI.isUri(T.iconPath)?T.iconPath.fsPath:T.iconPath.id;return(0,w.$br)(N,j)}function c(B,T){let N=0;if(B.strikeThrough!==T.strikeThrough)return B.strikeThrough?1:-1;if(B.faded!==T.faded)return B.faded?1:-1;if(B.tooltip!==T.tooltip)return(B.tooltip||"").localeCompare(T.tooltip||"");if(N=h(B,T),N!==0)return N;if(B.light&&T.light)N=h(B.light,T.light);else{if(B.light)return 1;if(T.light)return-1}if(N!==0)return N;if(B.dark&&T.dark)N=h(B.dark,T.dark);else{if(B.dark)return 1;if(T.dark)return-1}return N}function u(B,T){if(B.command!==T.command)return B.command<T.command?-1:1;if(B.title!==T.title)return B.title<T.title?-1:1;if(B.tooltip!==T.tooltip){if(B.tooltip!==void 0&&T.tooltip!==void 0)return B.tooltip<T.tooltip?-1:1;if(B.tooltip!==void 0)return 1;if(T.tooltip!==void 0)return-1}if(B.arguments===T.arguments)return 0;if(B.arguments)if(T.arguments){if(B.arguments.length!==T.arguments.length)return B.arguments.length-T.arguments.length}else return 1;else return-1;for(let N=0;N<B.arguments.length;N++){const j=B.arguments[N],L=T.arguments[N];if(j!==L&&!(s(j)&&s(L)&&t(j,L)))return j<L?-1:1}return 0}function f(B,T){let N=(0,w.$br)(B.resourceUri.fsPath,T.resourceUri.fsPath,!0);if(N!==0)return N;if(B.command&&T.command)N=u(B.command,T.command);else{if(B.command)return 1;if(T.command)return-1}if(N!==0)return N;if(B.decorations&&T.decorations)N=c(B.decorations,T.decorations);else{if(B.decorations)return 1;if(T.decorations)return-1}if(B.multiFileDiffEditorModifiedUri&&T.multiFileDiffEditorModifiedUri)N=(0,w.$br)(B.multiFileDiffEditorModifiedUri.fsPath,T.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(B.multiFileDiffEditorModifiedUri)return 1;if(T.multiFileDiffEditorModifiedUri)return-1}if(B.multiDiffEditorOriginalUri&&T.multiDiffEditorOriginalUri)N=(0,w.$br)(B.multiDiffEditorOriginalUri.fsPath,T.multiDiffEditorOriginalUri.fsPath,!0);else{if(B.multiDiffEditorOriginalUri)return 1;if(T.multiDiffEditorOriginalUri)return-1}return N}function E(B,T){for(let N=0;N<B.length;N++)if(B[N]!==T[N])return!1;return!0}function v(B,T){return B.command===T.command&&B.title===T.title&&B.tooltip===T.tooltip&&(B.arguments&&T.arguments?E(B.arguments,T.arguments):B.arguments===T.arguments)}function D(B,T){return(0,$.$ub)(B,T,v)}class k{get value(){return this.d}set value(T){T=T??"",qe(this,l,"f").$setInputBoxValue(this.l,T),this.n(T)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(T){qe(this,l,"f").$setInputBoxPlaceholder(this.l,T),this.f=T}get validateInput(){return(0,y.$dG)(this.k,"scmValidation"),this.g}set validateInput(T){if((0,y.$dG)(this.k,"scmValidation"),T&&typeof T!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=T,qe(this,l,"f").$setValidationProviderIsEnabled(this.l,!!T)}get enabled(){return this.h}set enabled(T){T=!!T,this.h!==T&&(this.h=T,qe(this,l,"f").$setInputBoxEnablement(this.l,T))}get visible(){return this.j}set visible(T){T=!!T,this.j!==T&&(this.j=T,qe(this,l,"f").$setInputBoxVisibility(this.l,T))}get document(){return(0,y.$dG)(this.k,"scmTextDocument"),qe(this,i,"f").getDocument(this.m)}constructor(T,N,j,L,z){this.k=T,this.l=L,this.m=z,l.set(this,void 0),i.set(this,void 0),this.d="",this.e=new R.$7d,this.f="",this.h=!0,this.j=!0,it(this,i,N,"f"),it(this,l,j,"f")}showValidationMessage(T,N){(0,y.$dG)(this.k,"scmValidation"),qe(this,l,"f").$showValidationMessage(this.l,T,N)}$onInputBoxValueChange(T){this.n(T)}n(T){this.d=T,this.e.fire(T)}}e.$klc=k,l=new WeakMap,i=new WeakMap;class S{get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(T){this.v=T,this.q.$updateGroupLabel(this.t,this.handle,T)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(T){this.p=T,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(T){this.f=[...T],this.k.fire()}constructor(T,N,j,L,z,Q,Y){this.q=T,this.s=N,this.t=j,this.u=L,this.v=z,this.multiDiffEditorEnableViewChanges=Q,this.w=Y,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new R.$7d,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new R.$7d,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=S.d++}getResourceState(T){return this.g.get(T)}$executeResourceCommand(T,N){const j=this.h.get(T);return j?(0,O.$ah)(()=>this.s.executeCommand(j.command,...j.arguments||[],N)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const T=[...this.f].sort(f),j=(0,$.$Db)(this.o,T,f).map(Q=>{const Y=Q.toInsert.map(J=>{const x=this.e++;this.g.set(x,J);const ce=J.resourceUri;let te;if(J.command)if(J.command.command==="vscode.open"||J.command.command==="vscode.diff"||J.command.command==="vscode.changes"){const le=new M.$Tc;te=this.s.converter.toInternal(J.command,le),this.j.set(x,le)}else this.h.set(x,J.command);const pe=(0,y.$cG)(this.w,"scmMultiDiffEditor"),ye=pe?J.multiDiffEditorOriginalUri:void 0,_=pe?J.multiFileDiffEditorModifiedUri:void 0,U=g(J.decorations),he=J.decorations&&g(J.decorations.light)||U,Se=J.decorations&&g(J.decorations.dark)||U,me=[he,Se],ie=J.decorations&&J.decorations.tooltip||"",se=J.decorations&&!!J.decorations.strikeThrough,oe=J.decorations&&!!J.decorations.faded,G=J.contextValue||"";return{rawResource:[x,ce,me,ie,se,oe,G,te,ye,_],handle:x}});return{start:Q.start,deleteCount:Q.deleteCount,toInsert:Y}}),L=j.map(({start:Q,deleteCount:Y,toInsert:J})=>[Q,Y,J.map(x=>x.rawResource)]),z=j.reverse();for(const{start:Q,deleteCount:Y,toInsert:J}of z){const x=J.map(te=>te.handle),ce=this.n.splice(Q,Y,...x);for(const te of ce)this.g.delete(te),this.h.delete(te),this.j.get(te)?.dispose(),this.j.delete(te)}return this.o=T,L}dispose(){this.l=!0,this.m.fire()}}S.d=0;class F{get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(T){this.g!==T&&(this.g=T,qe(this,n,"f").$updateSourceControl(this.w,{count:T}))}get quickDiffProvider(){return this.h}set quickDiffProvider(T){this.h=T;let N;(0,y.$cG)(this.x,"quickDiffProvider")&&(N=T?.label),qe(this,n,"f").$updateSourceControl(this.w,{hasQuickDiffProvider:!!T,quickDiffLabel:N})}get historyProvider(){return(0,y.$dG)(this.x,"scmHistoryProvider"),this.j}set historyProvider(T){(0,y.$dG)(this.x,"scmHistoryProvider"),this.j=T,this.k.value=new M.$Tc,qe(this,n,"f").$updateSourceControl(this.w,{hasHistoryProvider:!!T}),T&&this.k.value.add(T.onDidChangeCurrentHistoryItemGroup(()=>{this.l=T?.currentHistoryItemGroup,qe(this,n,"f").$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(T){T!==this.m&&(this.m=T,qe(this,n,"f").$updateSourceControl(this.w,{commitTemplate:T}))}get acceptInputCommand(){return this.o}set acceptInputCommand(T){this.n.value=new M.$Tc,this.o=T;const N=this.y.converter.toInternal(T,this.n.value);qe(this,n,"f").$updateSourceControl(this.w,{acceptInputCommand:N})}get actionButton(){return(0,y.$dG)(this.x,"scmActionButton"),this.q}set actionButton(T){(0,y.$dG)(this.x,"scmActionButton"),this.p.value=new M.$Tc,this.q=T;const N=T!==void 0?{command:this.y.converter.toInternal(T.command,this.p.value),secondaryCommands:T.secondaryCommands?.map(j=>j.map(L=>this.y.converter.toInternal(L,this.p.value))),description:T.description,enabled:T.enabled}:void 0;qe(this,n,"f").$updateSourceControl(this.w,{actionButton:N??null})}get statusBarCommands(){return this.t}set statusBarCommands(T){if(this.t&&T&&D(this.t,T))return;this.s.value=new M.$Tc,this.t=T;const N=(T||[]).map(j=>this.y.converter.toInternal(j,this.s.value));qe(this,n,"f").$updateSourceControl(this.w,{statusBarCommands:N})}get selected(){return this.u}constructor(T,N,j,L,z,Q,Y){this.x=T,this.y=L,this.z=z,this.A=Q,this.B=Y,n.set(this,void 0),this.e=new Map,this.g=void 0,this.h=void 0,this.k=new M.$Vc,this.m=void 0,this.n=new M.$Vc,this.o=void 0,this.p=new M.$Vc,this.s=new M.$Vc,this.t=void 0,this.u=!1,this.v=new R.$7d,this.onDidChangeSelection=this.v.event,this.w=F.d++,this.C=new Map,this.D=new Set,it(this,n,j,"f");const J=o.URI.from({scheme:a.Schemas.vscodeSourceControl,path:`${z}/scm${this.w}/input`,query:Y?`rootUri=${encodeURIComponent(Y.toString())}`:void 0});this.f=new k(T,N,qe(this,n,"f"),this.w,J),qe(this,n,"f").$registerSourceControl(this.w,z,Q,Y,J)}createResourceGroup(T,N,j){const L=(0,y.$cG)(this.x,"scmMultiDiffEditor")&&j?.multiDiffEditorEnableViewChanges===!0,z=new S(qe(this,n,"f"),this.y,this.w,T,N,L,this.x),Q=R.Event.once(z.onDidDispose)(()=>this.C.delete(z));return this.C.set(z,Q),this.eventuallyAddResourceGroups(),z}eventuallyAddResourceGroups(){const T=[],N=[];for(const[j,L]of this.C){L.dispose();const z=j.onDidUpdateResourceStates(()=>{this.D.add(j),this.eventuallyUpdateResourceStates()});R.Event.once(j.onDidDispose)(()=>{this.D.delete(j),z.dispose(),this.e.delete(j.handle),qe(this,n,"f").$unregisterGroup(this.w,j.handle)}),T.push([j.handle,j.id,j.label,j.features,j.multiDiffEditorEnableViewChanges]);const Q=j._takeResourceStateSnapshot();Q.length>0&&N.push([j.handle,Q]),this.e.set(j.handle,j)}qe(this,n,"f").$registerGroups(this.w,T,N),this.C.clear()}eventuallyUpdateResourceStates(){const T=[];this.D.forEach(N=>{const j=N._takeResourceStateSnapshot();j.length!==0&&T.push([N.handle,j])}),T.length>0&&qe(this,n,"f").$spliceResourceStates(this.w,T),this.D.clear()}getResourceGroup(T){return this.e.get(T)}setSelectionState(T){this.u=T,this.v.fire(T)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(T=>T.dispose()),qe(this,n,"f").$unregisterSourceControl(this.w)}}n=new WeakMap,F.d=0,Qe([(0,I.$Nh)(100)],F.prototype,"eventuallyAddResourceGroups",null),Qe([(0,I.$Nh)(100)],F.prototype,"eventuallyUpdateResourceStates",null);let W=r=class{get onDidChangeActiveProvider(){return this.j.event}constructor(T,N,j,L){this.l=N,this.m=j,this.n=L,this.g=new Map,this.h=new P.$Gm,this.j=new R.$7d,this.e=T.getProxy(p.$sM.MainThreadSCM),this.f=T.getProxy(p.$sM.MainThreadTelemetry),N.registerArgumentProcessor({processArgument:z=>{if(z&&z.$mid===3){const Q=this.g.get(z.sourceControlHandle);if(!Q)return z;const Y=Q.getResourceGroup(z.groupHandle);return Y?Y.getResourceState(z.handle):z}else if(z&&z.$mid===4){const Q=this.g.get(z.sourceControlHandle);return Q?Q.getResourceGroup(z.groupHandle):z}else if(z&&z.$mid===5){const Q=this.g.get(z.handle);return Q||z}return z}})}createSourceControl(T,N,j,L){this.n.trace("ExtHostSCM#createSourceControl",T.identifier.value,N,j,L),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:T.identifier.value});const z=r.d++,Q=new F(T,this.m,this.e,this.l,N,j,L);this.g.set(z,Q);const Y=this.h.get(T.identifier)||[];return Y.push(Q),this.h.set(T.identifier,Y),Q}getLastInputBox(T){this.n.trace("ExtHostSCM#getLastInputBox",T.identifier.value);const N=this.h.get(T.identifier),j=N&&N[N.length-1];return j&&j.inputBox}$provideOriginalResource(T,N,j){const L=o.URI.revive(N);this.n.trace("ExtHostSCM#$provideOriginalResource",T,L.toString());const z=this.g.get(T);return!z||!z.quickDiffProvider||!z.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,O.$ah)(()=>z.quickDiffProvider.provideOriginalResource(L,j)).then(Q=>Q||null)}$onInputBoxValueChange(T,N){this.n.trace("ExtHostSCM#$onInputBoxValueChange",T);const j=this.g.get(T);return j&&j.inputBox.$onInputBoxValueChange(N),Promise.resolve(void 0)}$executeResourceCommand(T,N,j,L){this.n.trace("ExtHostSCM#$executeResourceCommand",T,N,j);const z=this.g.get(T);if(!z)return Promise.resolve(void 0);const Q=z.getResourceGroup(N);return Q?Q.$executeResourceCommand(j,L):Promise.resolve(void 0)}$validateInput(T,N,j){this.n.trace("ExtHostSCM#$validateInput",T);const L=this.g.get(T);return!L||!L.inputBox.validateInput?Promise.resolve(void 0):(0,O.$ah)(()=>L.inputBox.validateInput(N,j)).then(z=>{if(!z)return Promise.resolve(void 0);const Q=C.MarkdownString.fromStrict(z.message);return Q?Promise.resolve([Q,z.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(T){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",T),T!==void 0&&this.g.get(T)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=T,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(T,N,j,L){return await this.g.get(T)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(N,j,L)??void 0}async $provideHistoryItems(T,N,j,L){return(await this.g.get(T)?.historyProvider?.provideHistoryItems(N,j,L))?.map(Y=>({...Y,icon:d(Y)}))??void 0}async $provideHistoryItemSummary(T,N,j,L){const z=this.g.get(T)?.historyProvider;if(typeof z?.provideHistoryItemSummary!="function")return;const Q=await z.provideHistoryItemSummary(N,j,L);return Q?{...Q,icon:d(Q)}:void 0}async $provideHistoryItemChanges(T,N,j,L){return await this.g.get(T)?.historyProvider?.provideHistoryItemChanges(N,j,L)??void 0}};e.$llc=W,W.d=0,e.$llc=W=r=Qe([He(3,A.$Oj)],W)}),define(Ee[347],Ce([1,0,6,16,2]),function(re,e,o,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mlc=void 0;class M{constructor(p,$){this.d=$,this.c=new Map,this.b=p.getProxy(o.$sM.MainThreadShare)}async $provideShare(p,$,w){return await this.c.get(p)?.provideShare({selection:R.Range.to($.selection),resourceUri:I.URI.revive($.resourceUri)},w)??void 0}registerShareProvider(p,$){const w=M.a++;return this.c.set(w,$),this.b.$registerShareProvider(w,R.DocumentSelector.from(p,this.d),$.id,$.label,$.priority),{dispose:()=>{this.b.$unregisterShareProvider(w),this.c.delete(w)}}}}e.$mlc=M,M.a=0});var it=this&&this.__classPrivateFieldSet||function(re,e,o,R,I){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!I:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?I.call(re,o):I?I.value=o:e.set(re,o),o},qe=this&&this.__classPrivateFieldGet||function(re,e,o,R){if(o==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!R:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?R:o==="a"?R.call(re):R?R.value:e.get(re)};define(Ee[348],Ce([1,0,7,6,225,3,16,18]),function(re,e,o,R,I,M,O,p){"use strict";var $,w;Object.defineProperty(e,"__esModule",{value:!0}),e.$plc=e.$olc=void 0;class A{constructor(y,a,m,l,i,n=o.StatusBarAlignment.Left,r){if($.set(this,void 0),w.set(this,void 0),this.i=!1,this.k="",this.q=new M.$Tc,it(this,$,y,"f"),it(this,w,a,"f"),i&&l){this.c=(0,o.$6M)(l.identifier,i);const s=m.get(this.c);s&&(n=s.alignLeft?o.StatusBarAlignment.Left:o.StatusBarAlignment.Right,r=s.priority,this.j=!0,this.name=s.name,this.text=s.text,this.tooltip=s.tooltip,this.command=s.command,this.accessibilityInformation=s.accessibilityInformation)}else this.c=String(A.a++);this.e=l,this.f=i,this.g=n,this.h=this.u(r)}u(y){if((0,p.$Zf)(y))return y===Number.POSITIVE_INFINITY?Number.MAX_VALUE:y===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:y}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(y){this.k=y,this.v()}set name(y){this.m=y,this.v()}set tooltip(y){this.l=y,this.v()}set color(y){this.n=y,this.v()}set backgroundColor(y){y&&!A.b.has(y.id)&&(y=void 0),this.o=y,this.v()}set command(y){this.r?.fromApi!==y&&(this.p&&this.q.add(this.p),this.p=new M.$Tc,typeof y=="string"?this.r={fromApi:y,internal:qe(this,w,"f").toInternal({title:"",command:y},this.p)}:y?this.r={fromApi:y,internal:qe(this,w,"f").toInternal(y,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(y){this.t=y,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,qe(this,$,"f").$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let y;this.e?this.f?y=`${this.e.identifier.value}.${this.f}`:y=this.e.identifier.value:y=this.f;let a;this.m?a=this.m:a=(0,I.localize)(0,null,this.e.displayName||this.e.name);let m=this.n;this.o&&(m=A.b.get(this.o.id));const l=O.MarkdownString.fromStrict(this.l);qe(this,$,"f").$setEntry(this.c,y,this.e?.identifier.value,a,this.k,l,this.r?.internal,m,this.o,this.g===o.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$olc=A,$=new WeakMap,w=new WeakMap,A.a=0,A.b=new Map([["statusBarItem.errorBackground",new o.$rN("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new o.$rN("statusBarItem.warningForeground")]]);class P{constructor(y){this.b=[],this.a=y.createStatusBarEntry(void 0,"status.extensionMessage",o.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,I.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(y){const a={message:y};return this.b.unshift(a),this.c(),new o.$uM(()=>{const m=this.b.indexOf(a);m>=0&&(this.b.splice(m,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class b{constructor(y,a){this.e=new Map,this.a=y.getProxy(R.$sM.MainThreadStatusBar),this.b=a,this.c=new P(this)}$acceptStaticEntries(y){for(const a of y)this.e.set(a.entryId,a)}createStatusBarEntry(y,a,m,l){return new A(this.a,this.b,this.e,y,a,m,l)}setStatusBarMessage(y,a){const m=this.c.setMessage(y);let l;return typeof a=="number"?l=setTimeout(()=>m.dispose(),a):typeof a<"u"&&a.then(()=>m.dispose(),()=>m.dispose()),new o.$uM(()=>{m.dispose(),clearTimeout(l)})}}e.$plc=b}),define(Ee[155],Ce([1,0,29,145,67,113,89,16,2]),function(re,e,o,R,I,M,O,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4O=e.$3O=e.$2O=e.$1O=void 0;const w=(n,r,s,t)=>{let g=r;return{enumerable:!0,configurable:!1,get(){return g},set(d){if(!s(g,d)){const h=g;g=d,n.listener?.(t(d,h))}}}},A=(n,r)=>n===r,P={range:(n,r)=>n===r?!0:!n||!r?!1:n.isEqual(r),label:A,description:A,sortText:A,busy:A,error:A,canResolveChildren:A,tags:(n,r)=>!(n.length!==r.length||n.some(s=>!r.find(t=>s.id===t.id)))},b=n=>r=>({op:4,update:n(r)}),C=(n,r)=>({range:(()=>{let s;const t=b(g=>({range:o.$dt.lift(p.Range.from(g))}));return{enumerable:!0,configurable:!1,get(){return s},set(g){n.listener?.({op:6}),P.range(s,g)||(s=g,n.listener?.(t(g)))}}})(),label:w(n,r,P.label,b(s=>({label:s}))),description:w(n,void 0,P.description,b(s=>({description:s}))),sortText:w(n,void 0,P.sortText,b(s=>({sortText:s}))),canResolveChildren:w(n,!1,P.canResolveChildren,s=>({op:2,state:s})),busy:w(n,!1,P.busy,b(s=>({busy:s}))),error:w(n,void 0,P.error,b(s=>({error:p.MarkdownString.fromStrict(s)||null}))),tags:w(n,[],P.tags,(s,t)=>({op:1,new:s.map(p.TestTag.from),old:t.map(p.TestTag.from)}))}),y=n=>{const r=I.$eL.fromString(n.extId),s=new m(r.controllerId,r.localId,n.label,$.URI.revive(n.uri)||void 0);return s.range=p.Range.to(n.range||void 0),s.description=n.description||void 0,s.sortText=n.sortText||void 0,s.tags=n.tags.map(t=>p.TestTag.to({id:(0,O.$kL)(t).tagId})),s},a=n=>{let r;for(const s of n.tests){const t=y(s.item);(0,R.$KO)(t).parent=r,r=t}return r};e.$1O=a;class m{constructor(r,s,t,g){if(s.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(s)} symbol`);const d=(0,R.$JO)(this,r);Object.defineProperties(this,{id:{value:s,enumerable:!0,writable:!1},uri:{value:g,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return d.parent instanceof l?void 0:d.parent}},children:{value:(0,M.$IO)(d,R.$KO,m),enumerable:!0,writable:!1},...C(d,t)})}}e.$2O=m;class l extends m{constructor(r,s){super(r,r,s,void 0),this._isRoot=!0}}e.$3O=l;class i extends M.$EO{constructor(r,s,t){super({controllerId:r,getDocumentVersion:g=>g&&t.getDocument(g)?.version,getApiFor:R.$KO,getChildren:g=>g.children,root:new l(r,s),toITestItem:p.TestItem.from})}}e.$4O=i});var it=this&&this.__classPrivateFieldSet||function(re,e,o,R,I){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!I:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?I.call(re,o):I?I.value=o:e.set(re,o),o},qe=this&&this.__classPrivateFieldGet||function(re,e,o,R){if(o==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!R:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?R:o==="a"?R.call(re):R?R.value:e.get(re)};define(Ee[33],Ce([1,0,18,7,16,24,6,19,12,57,29,52,2,3,5,20,155,21,68,47,40,87,90,30]),function(re,e,o,R,I,M,O,p,$,w,A,P,b,C,y,a,m,l,i,n,r,s,t,g){"use strict";var d,h,c;Object.defineProperty(e,"__esModule",{value:!0}),e.$cP=e.$bP=e.$aP=e.$_O=e.$$O=e.$0O=void 0;let u=class{constructor(S,F,W){d.set(this,void 0),this.b=new Map,this.c=new Map,h.set(this,void 0),c.set(this,void 0),it(this,d,S.getProxy(O.$sM.MainThreadCommands),"f"),this.d=F,it(this,c,W,"f"),it(this,h,S.getProxy(O.$sM.MainThreadTelemetry),"f"),this.converter=new f(this,B=>{const T=this.c.get(B);return T?.result===v.Void?T:void 0},F),this.f=[{processArgument(B){return(0,w.$Rh)(B)}},{processArgument(B){return(0,M.$Rn)(B,function(T){if(A.$dt.isIRange(T))return I.Range.to(T);if(P.$ct.isIPosition(T))return I.Position.to(T);if(A.$dt.isIRange(T.range)&&b.URI.isUri(T.uri))return I.location.to(T);if(T instanceof l.$ue)return T.buffer.buffer;if(!Array.isArray(T))return T})}}]}registerArgumentProcessor(S){this.f.push(S)}registerApiCommand(S){const F=this.registerCommand(!1,S.id,async(...W)=>{const B=S.args.map((N,j)=>{if(!N.validate(W[j]))throw new Error(`Invalid argument '${N.name}' when running '${S.id}', received: ${typeof W[j]=="object"?JSON.stringify(W[j],null,"	"):W[j]} `);return N.convert(W[j])}),T=await this.executeCommand(S.internalId,...B);return S.result.convert(T,W,this.converter)},void 0,{description:S.description,args:S.args,returns:S.result.description});return this.c.set(S.id,S),new R.$uM(()=>{F.dispose(),this.c.delete(S.id)})}registerCommand(S,F,W,B,T,N){if(this.d.trace("ExtHostCommands#registerCommand",F),!F.trim().length)throw new Error("invalid id");if(this.b.has(F))throw new Error(`command '${F}' already exists`);return this.b.set(F,{callback:W,thisArg:B,metadata:T,extension:N}),S&&qe(this,d,"f").$registerCommand(F),new R.$uM(()=>{this.b.delete(F)&&S&&qe(this,d,"f").$unregisterCommand(F)})}executeCommand(S,...F){return this.d.trace("ExtHostCommands#executeCommand",S),this.g(S,F,!0)}async g(S,F,W){if(this.b.has(S))return qe(this,d,"f").$fireCommandActivationEvent(S),this.h(S,F,!1);{let B=!1;const T=(0,M.$Rn)(F,function(N){if(N instanceof R.$vM)return I.Position.from(N);if(N instanceof R.$wM)return I.Range.from(N);if(N instanceof R.$GM)return I.location.from(N);if(R.$VN.isNotebookRange(N))return I.NotebookRange.from(N);if(N instanceof ArrayBuffer)return B=!0,l.$ue.wrap(new Uint8Array(N));if(N instanceof Uint8Array)return B=!0,l.$ue.wrap(N);if(N instanceof l.$ue)return B=!0,N;if(!Array.isArray(N))return N});try{const N=await qe(this,d,"f").$executeCommand(S,B?new i.$fw(T):T,W);return(0,w.$Rh)(N)}catch(N){if(N instanceof Error&&N.message==="$executeCommand:retry")return this.g(S,F,!1);throw N}}}async h(S,F,W){const B=this.b.get(S);if(!B)throw new Error("Unknown command");const{callback:T,thisArg:N,metadata:j}=B;if(j?.args)for(let z=0;z<j.args.length;z++)try{(0,o.$ag)(F[z],j.args[z].constraint)}catch{throw new Error(`Running the contributed command: '${S}' failed. Illegal argument '${j.args[z].name}' - ${j.args[z].description}`)}const L=r.$3d.create();try{return await T.apply(N,F)}catch(z){if(S===this.converter.delegatingCommandId){const Q=this.converter.getActualCommand(...F);Q&&(S=Q.command)}if(this.d.error(z,S,B.extension?.identifier),!W)throw z;if(B.extension?.identifier){const Q=qe(this,c,"f").onExtensionError(B.extension.identifier,z);this.d.trace("forwarded error to extension?",Q,B.extension?.identifier)}throw new class extends Error{constructor(){super((0,n.$6i)(z)),this.id=S,this.source=B.extension?.displayName??B.extension?.name}}}finally{this.j(B,S,L.elapsed())}}j(S,F,W){S.extension&&qe(this,h,"f").$publicLog2("Extension:ActionExecuted",{extensionId:S.extension.identifier.value,id:new s.$5o(F),duration:W})}$executeContributedCommand(S,...F){this.d.trace("ExtHostCommands#$executeContributedCommand",S);const W=this.b.get(S);return W?(F=F.map(B=>this.f.reduce((T,N)=>N.processArgument(T,W.extension?.identifier),B)),this.h(S,F,!0)):Promise.reject(new Error(`Contributed command '${S}' does not exist.`))}getCommands(S=!1){return this.d.trace("ExtHostCommands#getCommands",S),qe(this,d,"f").$getCommands().then(F=>(S&&(F=F.filter(W=>W[0]!=="_")),F))}$getContributedCommandMetadata(){const S=Object.create(null);for(const[F,W]of this.b){const{metadata:B}=W;B&&(S[F]=B)}return Promise.resolve(S)}};e.$0O=u,d=new WeakMap,h=new WeakMap,c=new WeakMap,e.$0O=u=Qe([He(0,a.$OO),He(1,$.$Oj),He(2,t.$9O)],u),e.$$O=(0,y.$ii)("IExtHostCommands");class f{constructor(S,F,W){this.d=S,this.f=F,this.g=W,this.delegatingCommandId=`__vsc${(0,g.$Eg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(S,F){if(!S)return;const W={$ident:void 0,id:S.command,title:S.title,tooltip:S.tooltip};if(!S.command)return W;const B=this.f(S.command);if(B)W.id=B.internalId,W.arguments=B.args.map((T,N)=>T.convert(S.arguments&&S.arguments[N]));else if((0,p.$Lb)(S.arguments)){const T=`${S.command} /${++this.c}`;this.b.set(T,S),F.add((0,C.$Sc)(()=>{this.b.delete(T),this.g.trace("CommandsConverter#DISPOSE",T)})),W.$ident=T,W.id=this.delegatingCommandId,W.arguments=[T],this.g.trace("CommandsConverter#CREATE",S.command,T)}return W}fromInternal(S){return typeof S.$ident=="string"?this.b.get(S.$ident):{command:S.id,title:S.title,arguments:S.arguments}}getActualCommand(...S){return this.b.get(S[0])}h(...S){const F=this.getActualCommand(...S);return this.g.trace("CommandsConverter#EXECUTE",S[0],F?F.command:"MISSING"),F?this.d.executeCommand(F.command,...F.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${S[0]}`)}}e.$_O=f;class E{static Arr(S){return new E(`${S.name}_array`,`Array of ${S.name}, ${S.description}`,F=>Array.isArray(F)&&F.every(W=>S.validate(W)),F=>F.map(W=>S.convert(W)))}constructor(S,F,W,B){this.name=S,this.description=F,this.validate=W,this.convert=B}optional(){return new E(this.name,`(optional) ${this.description}`,S=>S==null||this.validate(S),S=>S===void 0?void 0:S===null?null:this.convert(S))}with(S,F){return new E(S??this.name,F??this.description,this.validate,this.convert)}}e.$aP=E,E.Uri=new E("uri","Uri of a text document",k=>b.URI.isUri(k),k=>k),E.Position=new E("position","A position in a text document",k=>R.$vM.isPosition(k),I.Position.from),E.Range=new E("range","A range in a text document",k=>R.$wM.isRange(k),I.Range.from),E.Selection=new E("selection","A selection in a text document",k=>R.$xM.isSelection(k),I.Selection.from),E.Number=new E("number","",k=>typeof k=="number",k=>k),E.String=new E("string","",k=>typeof k=="string",k=>k),E.StringArray=E.Arr(E.String),E.CallHierarchyItem=new E("item","A call hierarchy item",k=>k instanceof R.$RM,I.CallHierarchyItem.from),E.TypeHierarchyItem=new E("item","A type hierarchy item",k=>k instanceof R.$dO,I.TypeHierarchyItem.from),E.TestItem=new E("testItem","A VS Code TestItem",k=>k instanceof m.$2O,I.TestItem.from);class v{constructor(S,F){this.description=S,this.convert=F}}e.$bP=v,v.Void=new v("no result",k=>k);class D{constructor(S,F,W,B,T){this.id=S,this.internalId=F,this.description=W,this.args=B,this.result=T}}e.$cP=D}),define(Ee[349],Ce([1,0,19,15,2,83,135,42,33,16,7]),function(re,e,o,R,I,M,O,p,$,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ijc=void 0;const P=[new $.$cP("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[$.$aP.Uri,$.$aP.Position],new $.$bP("A promise that resolves to an array of DocumentHighlight-instances.",C(w.DocumentHighlight.to))),new $.$cP("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[$.$aP.Uri],new $.$bP("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(a,m)=>{if((0,o.$Kb)(a))return;class l extends A.$MM{static to(n){const r=new l(n.name,w.SymbolKind.to(n.kind),n.containerName||"",new A.$GM(m[0],w.Range.to(n.range)));return r.detail=n.detail,r.range=r.location.range,r.selectionRange=w.Range.to(n.selectionRange),r.children=n.children?n.children.map(l.to):[],r}}return a.map(l.to)})),new $.$cP("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[$.$aP.Uri,new $.$aP("options","Formatting options",a=>!0,a=>a)],new $.$bP("A promise that resolves to an array of TextEdits.",C(w.TextEdit.to))),new $.$cP("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[$.$aP.Uri,$.$aP.Range,new $.$aP("options","Formatting options",a=>!0,a=>a)],new $.$bP("A promise that resolves to an array of TextEdits.",C(w.TextEdit.to))),new $.$cP("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[$.$aP.Uri,$.$aP.Position,new $.$aP("ch","Trigger character",a=>typeof a=="string",a=>a),new $.$aP("options","Formatting options",a=>!0,a=>a)],new $.$bP("A promise that resolves to an array of TextEdits.",C(w.TextEdit.to))),new $.$cP("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[$.$aP.Uri,$.$aP.Position],new $.$bP("A promise that resolves to an array of Location or LocationLink instances.",y)),new $.$cP("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[$.$aP.Uri,$.$aP.Position],new $.$bP("A promise that resolves to an array of Location or LocationLink instances.",y)),new $.$cP("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[$.$aP.Uri,$.$aP.Position],new $.$bP("A promise that resolves to an array of Location or LocationLink instances.",y)),new $.$cP("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[$.$aP.Uri,$.$aP.Position],new $.$bP("A promise that resolves to an array of Location or LocationLink instances.",y)),new $.$cP("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[$.$aP.Uri,$.$aP.Position],new $.$bP("A promise that resolves to an array of Location-instances.",C(w.location.to))),new $.$cP("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[$.$aP.Uri,$.$aP.Position],new $.$bP("A promise that resolves to an array of Hover-instances.",C(w.Hover.to))),new $.$cP("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[$.$aP.Uri,new $.$aP("position","A position in a text document",a=>Array.isArray(a)&&a.every(m=>A.$vM.isPosition(m)),a=>a.map(w.Position.from))],new $.$bP("A promise that resolves to an array of ranges.",a=>a.map(m=>{let l;for(const i of m.reverse())l=new A.$QM(w.Range.to(i),l);return l}))),new $.$cP("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[$.$aP.String.with("query","Search string")],new $.$bP("A promise that resolves to an array of SymbolInformation-instances.",a=>a.map(w.WorkspaceSymbol.to))),new $.$cP("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[$.$aP.Uri,$.$aP.Position],new $.$bP("A promise that resolves to an array of CallHierarchyItem-instances",a=>a.map(w.CallHierarchyItem.to))),new $.$cP("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[$.$aP.CallHierarchyItem],new $.$bP("A promise that resolves to an array of CallHierarchyIncomingCall-instances",a=>a.map(w.CallHierarchyIncomingCall.to))),new $.$cP("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[$.$aP.CallHierarchyItem],new $.$bP("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",a=>a.map(w.CallHierarchyOutgoingCall.to))),new $.$cP("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[$.$aP.Uri,$.$aP.Position],new $.$bP("A promise that resolves to a range and placeholder text.",a=>{if(a)return{range:w.Range.to(a.range),placeholder:a.text}})),new $.$cP("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[$.$aP.Uri,$.$aP.Position,$.$aP.String.with("newName","The new symbol name")],new $.$bP("A promise that resolves to a WorkspaceEdit.",a=>{if(a){if(a.rejectReason)throw new Error(a.rejectReason);return w.WorkspaceEdit.to(a)}})),new $.$cP("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[$.$aP.Uri,$.$aP.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new $.$bP("A promise that resolves to an array of DocumentLink-instances.",a=>a.map(w.DocumentLink.to))),new $.$cP("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[$.$aP.Uri],new $.$bP("A promise that resolves to SemanticTokensLegend.",a=>{if(a)return new A.$MN(a.tokenTypes,a.tokenModifiers)})),new $.$cP("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[$.$aP.Uri],new $.$bP("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const m=(0,O.$Yab)(a);if(m.type==="full")return new A.$ON(m.data,void 0)})),new $.$cP("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[$.$aP.Uri,$.$aP.Range.optional()],new $.$bP("A promise that resolves to SemanticTokensLegend.",a=>{if(a)return new A.$MN(a.tokenTypes,a.tokenModifiers)})),new $.$cP("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[$.$aP.Uri,$.$aP.Range],new $.$bP("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const m=(0,O.$Yab)(a);if(m.type==="full")return new A.$ON(m.data,void 0)})),new $.$cP("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[$.$aP.Uri,$.$aP.Position,$.$aP.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),$.$aP.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new $.$bP("A promise that resolves to a CompletionList-instance.",(a,m,l)=>{if(!a)return new A.$3M([]);const i=a.suggestions.map(n=>w.CompletionItem.to(n,l));return new A.$3M(i,a.incomplete)})),new $.$cP("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[$.$aP.Uri,$.$aP.Position,$.$aP.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new $.$bP("A promise that resolves to SignatureHelp.",a=>{if(a)return w.SignatureHelp.to(a)})),new $.$cP("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[$.$aP.Uri,$.$aP.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new $.$bP("A promise that resolves to an array of CodeLens-instances.",(a,m,l)=>C(i=>new A.$UM(w.Range.to(i.range),i.command&&l.fromInternal(i.command)))(a))),new $.$cP("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[$.$aP.Uri,new $.$aP("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",a=>A.$wM.isRange(a),a=>A.$xM.isSelection(a)?w.Selection.from(a):w.Range.from(a)),$.$aP.String.with("kind","Code action kind to return code actions for").optional(),$.$aP.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new $.$bP("A promise that resolves to an array of Command-instances.",(a,m,l)=>C(i=>{if(i._isSynthetic){if(!i.command)throw new Error("Synthetic code actions must have a command");return l.fromInternal(i.command)}else{const n=new A.$OM(i.title,i.kind?new A.$PM(i.kind):void 0);return i.edit&&(n.edit=w.WorkspaceEdit.to(i.edit)),i.command&&(n.command=l.fromInternal(i.command)),n.isPreferred=i.isPreferred,n}})(a))),new $.$cP("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[$.$aP.Uri],new $.$bP("A promise that resolves to an array of ColorInformation objects.",a=>a?a.map(m=>new A.$9M(w.Range.to(m.range),w.Color.to(m.color))):[])),new $.$cP("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new $.$aP("color","The color to show and insert",a=>a instanceof A.$8M,w.Color.from),new $.$aP("context","Context object with uri and range",a=>!0,a=>({uri:a.uri,range:w.Range.from(a.range)}))],new $.$bP("A promise that resolves to an array of ColorPresentation objects.",a=>a?a.map(w.ColorPresentation.to):[])),new $.$cP("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[$.$aP.Uri,$.$aP.Range],new $.$bP("A promise that resolves to an array of Inlay objects",(a,m,l)=>a.map(w.InlayHint.to.bind(void 0,l)))),new $.$cP("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[$.$aP.Uri],new $.$bP("A promise that resolves to an array of FoldingRange objects",(a,m)=>{if(a)return a.map(w.FoldingRange.to)})),new $.$cP("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new $.$bP("A promise that resolves to an array of NotebookContentProvider static info objects.",C(a=>({viewType:a.viewType,displayName:a.displayName,options:{transientOutputs:a.options.transientOutputs,transientCellMetadata:a.options.transientCellMetadata,transientDocumentMetadata:a.options.transientDocumentMetadata},filenamePattern:a.filenamePattern.map(m=>w.NotebookExclusiveDocumentPattern.to(m))})))),new $.$cP("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[$.$aP.Uri,$.$aP.Range,new $.$aP("context","An InlineValueContext",a=>a&&typeof a.frameId=="number"&&a.stoppedLocation instanceof A.$wM,a=>w.InlineValueContext.from(a))],new $.$bP("A promise that resolves to an array of InlineValue objects",a=>a.map(w.InlineValue.to))),new $.$cP("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new $.$aP("uriOrString","Uri-instance or string (only http/https)",a=>I.URI.isUri(a)||typeof a=="string"&&(0,R.$sg)(a,R.Schemas.http,R.Schemas.https),a=>a),new $.$aP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[w.ViewColumn.from(a),void 0]:[w.ViewColumn.from(a.viewColumn),w.TextEditorOpenOptions.from(a)])).optional(),$.$aP.String.with("label","").optional()],$.$bP.Void),new $.$cP("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[$.$aP.Uri.with("resource","Resource to open"),$.$aP.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new $.$aP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[w.ViewColumn.from(a),void 0]:[w.ViewColumn.from(a.viewColumn),w.TextEditorOpenOptions.from(a)])).optional()],$.$bP.Void),new $.$cP("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[$.$aP.Uri.with("left","Left-hand side resource of the diff editor"),$.$aP.Uri.with("right","Right-hand side resource of the diff editor"),$.$aP.String.with("title","Human readable title for the diff editor").optional(),new $.$aP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="object",a=>a&&[w.ViewColumn.from(a.viewColumn),w.TextEditorOpenOptions.from(a)]).optional()],$.$bP.Void),new $.$cP("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[$.$aP.String.with("title","Human readable title for the changes editor"),new $.$aP("resourceList","List of resources to compare",a=>{for(const m of a){if(m.length!==3)return!1;const[l,i,n]=m;if(!I.URI.isUri(l)||!I.URI.isUri(i)&&i!==void 0&&i!==null||!I.URI.isUri(n)&&n!==void 0&&n!==null)return!1}return!0},a=>a)],$.$bP.Void),new $.$cP("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[$.$aP.Uri,$.$aP.Position],new $.$bP("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(w.TypeHierarchyItem.to))),new $.$cP("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[$.$aP.TypeHierarchyItem],new $.$bP("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(w.TypeHierarchyItem.to))),new $.$cP("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[$.$aP.TypeHierarchyItem],new $.$bP("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(w.TypeHierarchyItem.to))),new $.$cP("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[$.$aP.TestItem],$.$bP.Void),new $.$cP("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[$.$aP.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],$.$bP.Void),new $.$cP("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[$.$aP.String.with("name","The context key name"),new $.$aP("value","The context key value",()=>!0,a=>a)],$.$bP.Void),new $.$cP("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[$.$aP.Uri,$.$aP.StringArray,new $.$aP("MappedEditsContext","Mapped Edits Context",a=>w.MappedEditsContext.is(a),a=>w.MappedEditsContext.from(a))],new $.$bP("A promise that resolves to a workspace edit or null",a=>a?w.WorkspaceEdit.to(a):null))];class b{static register(m){P.forEach(m.registerApiCommand,m),this.a(m)}static a(m){m.registerCommand(!1,"_validateWhenClauses",p.$hj)}}e.$Ijc=b;function C(a){return m=>{if(Array.isArray(m))return m.map(a)}}function y(a){if(!Array.isArray(a))return;const m=[];for(const l of a)M.$4t(l)?m.push(w.DefinitionLink.to(l)):m.push(w.location.to(l));return m}}),define(Ee[350],Ce([1,0,8,3,2,6,33,16,7]),function(re,e,o,R,I,M,O,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Skc=void 0;class w{constructor(C,y){this.extension=C,this.provider=y,this.handle=w.a++}}w.a=0;class A{constructor(C){this.session=C,this.responses=[]}}class P{constructor(C,y,a,m){this.f=a,this.g=m,this.b=new Map,this.d=new Map,this.e=C.getProxy(M.$sM.MainThreadInlineChat),y.registerApiCommand(new O.$cP("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new O.$aP("Run arguments","",l=>!0,l=>{if(l)return{initialRange:l.initialRange?p.Range.from(l.initialRange):void 0,initialSelection:$.$xM.isSelection(l.initialSelection)?p.Selection.from(l.initialSelection):void 0,message:l.message,autoSend:l.autoSend,position:l.position?p.Position.from(l.position):void 0}})],O.$bP.Void))}registerProvider(C,y,a){const m=new w(C,y);return this.b.set(m.handle,m),this.e.$registerInteractiveEditorProvider(m.handle,a?.label??C.displayName??C.name,C.identifier,typeof y.handleInteractiveEditorResponseFeedback=="function",typeof y.provideFollowups=="function",a?.supportReportIssue??!1),(0,R.$Sc)(()=>{this.e.$unregisterInteractiveEditorProvider(m.handle),this.b.delete(m.handle)})}async $prepareSession(C,y,a,m){const l=this.b.get(C);if(!l){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const i=this.f.getDocument(I.URI.revive(y)),n=p.Selection.to(a),r=await l.provider.prepareInteractiveEditorSession({document:i,selection:n},m);if(!r)return;if(r.wholeRange&&!r.wholeRange.contains(n))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const s=P.a++;return this.d.set(s,new A(r)),{id:s,placeholder:r.placeholder,input:r.input,slashCommands:r.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:p.Range.from(r.wholeRange),message:r.message}}async $provideResponse(C,y,a,m){const l=this.b.get(C);if(!l)return;const i=this.d.get(y.id);if(!i)return;const n={prompt:a.prompt,selection:p.Selection.to(a.selection),wholeRange:p.Range.to(a.wholeRange),attempt:a.attempt,live:a.live,previewDocument:this.f.getDocument(I.URI.revive(a.previewDocument)),withIntentDetection:a.withIntentDetection};let r=!1;const s={report:async E=>{if(!a.live&&E.edits?.length)throw new Error("Progress reporting is only supported for live sessions");r||m.isCancellationRequested||await this.e.$handleProgressChunk(a.requestId,{message:E.message,edits:E.edits?.map(p.TextEdit.from),editsShouldBeInstant:E.editsShouldBeInstant,slashCommand:E.slashCommand?.command,markdownFragment:$.$VM.isMarkdownString(E.content)?E.content.value:E.content})}},t=Promise.resolve(l.provider.provideInteractiveEditorResponse(i.session,n,s,m));let g;try{g=await(0,o.$9g)(t,m)}finally{r=!0}if(!g)return;const d=i.responses.push(g)-1,h={wholeRange:p.Range.from(g.wholeRange),placeholder:g.placeholder};if(!P.h(g))return{...h,id:d,type:"editorEdit",message:p.MarkdownString.from(g.contents),edits:[]};const{edits:c,contents:u}=g,f=u!==void 0?p.MarkdownString.from(u):void 0;return c instanceof $.$EM?{...h,id:d,type:"bulkEdit",edits:p.WorkspaceEdit.from(c),message:f}:{...h,id:d,type:"editorEdit",edits:c.map(p.TextEdit.from),message:f}}async $provideFollowups(C,y,a,m){const l=this.b.get(C),i=this.d.get(y),n=i?.responses[a];if(l&&n&&l.provider.provideFollowups){const r=Promise.resolve(l.provider.provideFollowups(i.session,n,m));return(await(0,o.$9g)(r,m))?.map(p.ChatInlineFollowup.from)}}$handleFeedback(C,y,a,m){const l=this.b.get(C),i=this.d.get(y),n=i?.responses[a];if(l&&n){const r=p.InteractiveEditorResponseFeedbackKind.to(m);l.provider.handleInteractiveEditorResponseFeedback?.(i.session,n,r)}}$releaseSession(C,y){}static h(C){return typeof C=="object"&&typeof C.edits=="object"}}e.$Skc=P,P.a=0}),define(Ee[351],Ce([1,0,2,33]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6kc=void 0;class I{constructor(O,p,$,w,A){this.a=p,this.b=$,this.c=w;const P=new R.$cP("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new R.$aP("showOptions","Show Options",b=>!0,b=>b),new R.$aP("resource","Interactive resource Uri",b=>!0,b=>b),new R.$aP("controllerId","Notebook controller Id",b=>!0,b=>b),new R.$aP("title","Interactive editor title",b=>!0,b=>b)],new R.$bP("Notebook and input URI",b=>{if(A.debug("[ExtHostInteractive] open iw with notebook editor id",b.notebookEditorId),b.notebookEditorId!==void 0){const C=this.a.getEditorById(b.notebookEditorId);return A.debug("[ExtHostInteractive] notebook editor found",C.id),{notebookUri:o.URI.revive(b.notebookUri),inputUri:o.URI.revive(b.inputUri),notebookEditor:C.apiEditor}}return A.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",b.notebookUri,b.inputUri),{notebookUri:o.URI.revive(b.notebookUri),inputUri:o.URI.revive(b.inputUri)}}));this.c.registerApiCommand(P)}$willAddInteractiveDocument(O,p,$,w){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:p,lines:[""],languageId:$,uri:O,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(O,p){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[O]})}}e.$6kc=I}),define(Ee[352],Ce([1,0,19,8,22,4,3,27,2,25,12,6,33,16,7,114,294,26,68,295]),function(re,e,o,R,I,M,O,p,$,w,A,P,b,C,y,a,m,l,i,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$blc=void 0,e.$clc=c;let r=class{constructor(f,E,v,D,k){this.m=E,this.n=v,this.o=D,this.q=k,this.b=new p.$Bc,this.c=new p.$Bc,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new M.$7d,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=f.getProxy(P.$sM.MainThreadNotebookKernels);const S=new b.$cP("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new b.$aP("options","Select kernel options",W=>!0,W=>{if(W&&"notebookEditor"in W&&"id"in W){const B=this.n.getIdByEditor(W.notebookEditor);return{id:W.id,extension:W.extension,notebookEditorId:B}}else if(W&&"notebookEditor"in W){const B=this.n.getIdByEditor(W.notebookEditor);if(B===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${W.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:B}}return W})],b.$bP.Void),F=new b.$cP("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[b.$aP.Uri],new b.$bP("A promise that resolves to an array of variables",(W,B)=>W.map(T=>({variable:{name:T.name,value:T.value,expression:T.expression,type:T.type,language:T.language},hasNamedChildren:T.hasNamedChildren,indexedChildrenCount:T.indexedChildrenCount}))));this.o.registerApiCommand(S),this.o.registerApiCommand(F)}createNotebookController(f,E,v,D,k,S){for(const pe of this.j.values())if(pe.controller.id===E&&w.$Em.equals(f.identifier,pe.extensionId))throw new Error(`notebook controller with id '${E}' ALREADY exist`);const F=this.k++,W=this;this.q.trace(`NotebookController[${F}], CREATED by ${f.identifier.value}, ${E}`);const B=()=>console.warn(`NO execute handler from notebook controller '${L.id}' of extension: '${f.identifier}'`);let T=!1;const N=new M.$7d,j=new M.$7d,L={id:c(f.identifier,E),notebookType:v,extensionId:f.identifier,extensionLocation:f.extensionLocation,label:D||f.identifier.value,preloads:S?S.map(C.NotebookRendererScript.from):[]};let z=k??B,Q,Y;this.a.$addKernel(F,L).catch(pe=>{console.log(pe),T=!0});let J=0;const x=()=>{if(T)return;const pe=++J;Promise.resolve().then(()=>{pe===J&&this.a.$updateKernel(F,L)})},ce=new p.$Bc,te={get id(){return E},get notebookType(){return L.notebookType},onDidChangeSelectedNotebooks:N.event,get label(){return L.label},set label(pe){L.label=pe??f.displayName??f.name,x()},get detail(){return L.detail??""},set detail(pe){L.detail=pe,x()},get description(){return L.description??""},set description(pe){L.description=pe,x()},get supportedLanguages(){return L.supportedLanguages},set supportedLanguages(pe){L.supportedLanguages=pe,x()},get supportsExecutionOrder(){return L.supportsExecutionOrder??!1},set supportsExecutionOrder(pe){L.supportsExecutionOrder=pe,x()},get rendererScripts(){return L.preloads?L.preloads.map(C.NotebookRendererScript.to):[]},get executeHandler(){return z},set executeHandler(pe){z=pe??B},get interruptHandler(){return Q},set interruptHandler(pe){Q=pe,L.supportsInterrupt=!!pe,x()},set variableProvider(pe){(0,l.$dG)(f,"notebookVariableProvider"),Y=pe,L.hasVariableProvider=!!pe,pe?.onDidChangeVariables(ye=>W.a.$variablesUpdated(ye.uri)),x()},get variableProvider(){return Y},createNotebookCellExecution(pe){if(T)throw new Error("notebook controller is DISPOSED");if(!ce.has(pe.notebook.uri))throw W.q.trace(`NotebookController[${F}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ce.keys()).map(ye=>ye.toString())),new Error(`notebook controller is NOT associated to notebook: ${pe.notebook.uri.toString()}`);return W._createNotebookCellExecution(pe,c(f.identifier,this.id))},createNotebookExecution(pe){if((0,l.$dG)(f,"notebookExecution"),T)throw new Error("notebook controller is DISPOSED");if(!ce.has(pe.uri))throw W.q.trace(`NotebookController[${F}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ce.keys()).map(ye=>ye.toString())),new Error(`notebook controller is NOT associated to notebook: ${pe.uri.toString()}`);return W._createNotebookExecution(pe,c(f.identifier,this.id))},dispose:()=>{T||(this.q.trace(`NotebookController[${F}], DISPOSED`),T=!0,this.j.delete(F),N.dispose(),j.dispose(),this.a.$removeKernel(F))},updateNotebookAffinity(pe,ye){ye===y.NotebookControllerAffinity2.Hidden&&(0,l.$dG)(f,"notebookControllerAffinityHidden"),W.a.$updateNotebookPriority(F,pe.uri,ye)},onDidReceiveMessage:j.event,postMessage(pe,ye){return(0,l.$dG)(f,"notebookMessaging"),W.a.$postMessage(F,ye&&W.n.getIdByEditor(ye),pe)},asWebviewUri(pe){return(0,l.$dG)(f,"notebookMessaging"),(0,a.$Azb)(pe,W.m.remote)}};return this.j.set(F,{extensionId:f.identifier,controller:te,onDidReceiveMessage:j,onDidChangeSelection:N,associatedNotebooks:ce}),te}getIdByController(f){for(const[E,v]of this.j)if(v.controller===f)return c(v.extensionId,f.id);return null}createNotebookControllerDetectionTask(f,E){const v=this.g++,D=this;this.q.trace(`NotebookControllerDetectionTask[${v}], CREATED by ${f.identifier.value}`),this.a.$addKernelDetectionTask(v,E);const k={dispose:()=>{this.f.delete(v),D.a.$removeKernelDetectionTask(v)}};return this.f.set(v,k),k}registerKernelSourceActionProvider(f,E,v){const D=this.i++,k=typeof v.onDidChangeNotebookKernelSourceActions=="function"?D:void 0,S=this;this.h.set(D,v),this.q.trace(`NotebookKernelSourceActionProvider[${D}], CREATED by ${f.identifier.value}`),this.a.$addKernelSourceActionProvider(D,D,E);let F;return k!==void 0&&(F=v.onDidChangeNotebookKernelSourceActions(W=>this.a.$emitNotebookKernelSourceActionsChangeEvent(k))),{dispose:()=>{this.h.delete(D),S.a.$removeKernelSourceActionProvider(D,D),F?.dispose()}}}async $provideKernelSourceActions(f,E){const v=this.h.get(f);if(v){const D=new O.$Tc;return(await v.provideNotebookKernelSourceActions(E)??[]).map(S=>C.NotebookKernelSourceAction.from(S,this.o.converter,D))}return[]}$acceptNotebookAssociation(f,E,v){const D=this.j.get(f);if(D){const k=this.n.getNotebookDocument($.URI.revive(E));v?D.associatedNotebooks.set(k.uri,!0):D.associatedNotebooks.delete(k.uri),this.q.trace(`NotebookController[${f}] ASSOCIATE notebook`,k.uri.toString(),v),D.onDidChangeSelection.fire({selected:v,notebook:k.apiNotebook})}}async $executeCells(f,E,v){const D=this.j.get(f);if(!D)return;const k=this.n.getNotebookDocument($.URI.revive(E)),S=[];for(const F of v){const W=k.getCell(F);W&&S.push(W.apiCell)}try{this.q.trace(`NotebookController[${f}] EXECUTE cells`,k.uri.toString(),S.length),await D.controller.executeHandler.call(D.controller,S,k.apiNotebook,D.controller)}catch(F){this.q.error(`NotebookController[${f}] execute cells FAILED`,F),console.error(F)}}async $cancelCells(f,E,v){const D=this.j.get(f);if(!D)return;const k=this.n.getNotebookDocument($.URI.revive(E));if(D.controller.interruptHandler)await D.controller.interruptHandler.call(D.controller,k.apiNotebook);else for(const S of v){const F=k.getCell(S);F&&this.b.get(F.uri)?.cancel()}if(D.controller.interruptHandler){const S=this.c.get(k.uri);v.length&&Array.isArray(S)&&S.length&&S.forEach(F=>F.dispose())}}async $provideVariables(f,E,v,D,k,S,F){const W=this.j.get(f);if(!W)return;const B=this.n.getNotebookDocument($.URI.revive(v)),T=W.controller.variableProvider;if(!T)return;let N;if(D!==void 0){if(N=this.s[D],!N)return}else this.s={};const j=k==="named"?y.NotebookVariablesRequestKind.Named:y.NotebookVariablesRequestKind.Indexed,L=T.provideVariables(B.apiNotebook,N,j,S,F);let z=0;for await(const Q of L){if(F.isCancellationRequested)return;const Y={id:this.r++,name:Q.variable.name,value:Q.variable.value,type:Q.variable.type,interfaces:Q.variable.interfaces,language:Q.variable.language,expression:Q.variable.expression,hasNamedChildren:Q.hasNamedChildren,indexedChildrenCount:Q.indexedChildrenCount,extensionId:W.extensionId.value};if(this.s[Y.id]=Q.variable,this.a.$receiveVariable(E,Y),z++>=n.$Vhb)return}}$acceptKernelMessageFromRenderer(f,E,v){const D=this.j.get(f);if(!D)return;const k=this.n.getEditorById(E);D.onDidReceiveMessage.fire(Object.freeze({editor:k.apiEditor,message:v}))}$cellExecutionChanged(f,E,v){const k=this.n.getNotebookDocument($.URI.revive(f)).getCell(E);if(k){const S=v?C.NotebookCellExecutionState.to(v):y.NotebookCellExecutionState.Idle;S!==void 0&&this.l.fire({cell:k.apiCell,state:S})}}_createNotebookCellExecution(f,E){if(f.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const D=this.n.getNotebookDocument(f.notebook.uri).getCellFromApiCell(f);if(!D)throw new Error("invalid cell");if(this.b.has(D.uri))throw new Error(`duplicate execution for ${D.uri}`);const k=new t(E,D,this.a);this.b.set(D.uri,k);const S=k.onDidChangeState(()=>{k.state===s.Resolved&&(k.dispose(),S.dispose(),this.b.delete(D.uri))});return k.asApiObject()}_createNotebookExecution(f,E){const v=this.n.getNotebookDocument(f.uri),D=f.getCells().find(F=>{const W=v.getCellFromApiCell(F);return W&&this.b.has(W.uri)});if(D)throw new Error(`duplicate cell execution for ${D.document.uri}`);if(this.c.has(v.uri))throw new Error(`duplicate notebook execution for ${v.uri}`);const k=new d(E,v,this.a),S=k.onDidChangeState(()=>{k.state===g.Resolved&&(k.dispose(),S.dispose(),this.c.delete(v.uri))});return this.c.set(v.uri,[k,S]),k.asApiObject()}};e.$blc=r,e.$blc=r=Qe([He(4,A.$Oj)],r);var s;(function(u){u[u.Init=0]="Init",u[u.Started=1]="Started",u[u.Resolved=2]="Resolved"})(s||(s={}));class t extends O.$Uc{get state(){return this.f}constructor(f,E,v){super(),this.m=E,this.n=v,this.b=t.a++,this.c=new M.$7d,this.onDidChangeState=this.c.event,this.f=s.Init,this.g=this.B(new I.$ee),this.h=new h(10,D=>this.s(D)),this.j=E.internalMetadata.executionOrder,this.n.$createExecution(this.b,f,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(f){await this.h.addItem(f)}async s(f){const E=Array.isArray(f)?f:[f];return this.n.$updateExecution(this.b,new i.$fw(E))}t(){if(this.f===s.Init)throw new Error("Must call start before modifying cell output");if(this.f===s.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(f){let E=this.m;if(f&&(E=this.m.notebook.getCellFromApiCell(f)),!E)throw new Error("INVALID cell");return E.handle}y(f){return f.map(E=>{const v=y.$ZN.ensureUniqueMimeTypes(E.items,!0);return v===E.items?C.NotebookCellOutput.from(E):C.NotebookCellOutput.from({items:v,id:E.id,metadata:E.metadata})})}async z(f,E,v){const D=this.w(E),k=this.y((0,o.$3b)(f));return this.r({editType:m.CellExecutionUpdateType.Output,cellHandle:D,append:v,outputs:k})}async C(f,E,v){return f=y.$ZN.ensureUniqueMimeTypes((0,o.$3b)(f),!0),this.r({editType:m.CellExecutionUpdateType.OutputItems,items:f.map(C.NotebookCellOutputItem.from),outputId:E.id,append:v})}asApiObject(){const f=this;return Object.freeze({get token(){return f.g.token},get cell(){return f.m.apiCell},get executionOrder(){return f.j},set executionOrder(v){f.j=v,f.s([{editType:m.CellExecutionUpdateType.ExecutionState,executionOrder:f.j}])},start(v){if(f.f===s.Resolved||f.f===s.Started)throw new Error("Cannot call start again");f.f=s.Started,f.c.fire(),f.s({editType:m.CellExecutionUpdateType.ExecutionState,runStartTime:v})},end(v,D,k){if(f.f===s.Resolved)throw new Error("Cannot call resolve twice");f.f=s.Resolved,f.c.fire(),f.h.flush();const S=k?{message:k.message,stack:k.stack,location:k?.location?{startLineNumber:k.location.start.line,startColumn:k.location.start.character,endLineNumber:k.location.end.line,endColumn:k.location.end.character}:void 0,uri:k.uri}:void 0;f.n.$completeExecution(f.b,new i.$fw({runEndTime:D,lastRunSuccess:v,error:S}))},clearOutput(v){return f.t(),f.z([],v,!1)},appendOutput(v,D){return f.t(),f.z(v,D,!0)},replaceOutput(v,D){return f.t(),f.z(v,D,!1)},appendOutputItems(v,D){return f.t(),f.C(v,D,!0)},replaceOutputItems(v,D){return f.t(),f.C(v,D,!1)}})}}t.a=0;var g;(function(u){u[u.Init=0]="Init",u[u.Started=1]="Started",u[u.Resolved=2]="Resolved"})(g||(g={}));class d extends O.$Uc{get state(){return this.f}constructor(f,E,v){super(),this.h=E,this.j=v,this.b=d.a++,this.c=new M.$7d,this.onDidChangeState=this.c.event,this.f=g.Init,this.g=this.B(new I.$ee),this.j.$createNotebookExecution(this.b,f,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===g.Resolved||this.f===g.Started)throw new Error("Cannot call start again");this.f=g.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===g.Resolved)throw new Error("Cannot call resolve twice");this.f=g.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}d.a=0;class h{constructor(f,E){this.f=f,this.g=E,this.a=[],this.b=Date.now()}addItem(f){return this.a.push(f),this.c||(this.c=new R.$Fh,this.b=Date.now(),(0,R.$jh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const f=this.c;this.c=void 0;const E=this.a;return this.a=[],this.g(E).finally(()=>f.complete())}}function c(u,f){return`${u.value}/${f}`}}),define(Ee[44],Ce([1,0,4,6,5,2,20,3,7,227,13,272,22,30,273,56,8,16,33]),function(re,e,o,R,I,M,O,p,$,w,A,P,b,C,y,a,m,l,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qkc=e.$pkc=e.$okc=e.$nkc=void 0,e.$nkc=(0,I.$ii)("IExtHostTerminalService");class n extends p.$Uc{constructor(v,D,k,S){super(),this.u=v,this._id=D,this.w=k,this.y=S,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new o.$7d),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(W=>this.g=W);const F=this;this.value={get name(){return F.y||""},get processId(){return F.b},get creationOptions(){return F.w},get exitStatus(){return F.j},get state(){return F.m},get selection(){return F.n},get shellIntegration(){return F.shellIntegration},sendText(W,B=!0){F.C(),F.u.$sendText(F._id,W,B)},show(W){F.C(),F.u.$show(F._id,W)},hide(){F.C(),F.u.$hide(F._id)},dispose(){F.a||(F.a=!0,F.u.$dispose(F._id))},get dimensions(){if(!(F.f===void 0||F.h===void 0))return{columns:F.f,rows:F.h}}}}dispose(){this.s.fire(),super.dispose()}async create(v,D){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:v.name,shellPath:v.shellPath??void 0,shellArgs:v.shellArgs??void 0,cwd:v.cwd??D?.cwd??void 0,env:v.env??void 0,icon:c(v.iconPath)??void 0,color:a.ThemeColor.isThemeColor(v.color)?v.color.id:void 0,initialText:v.message??void 0,strictEnv:v.strictEnv??void 0,hideFromUser:v.hideFromUser??void 0,forceShellIntegration:D?.forceShellIntegration??void 0,isFeatureTerminal:D?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:D?.useShellEnvironment??void 0,location:D?.location||this.z(v.location,D?.resolvedExtHostIdentifier),isTransient:v.isTransient??void 0})}async createExtensionTerminal(v,D,k,S,F){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:S,color:a.ThemeColor.isThemeColor(F)?F.id:void 0,location:D?.location||this.z(v,k),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z(v,D){return typeof v=="object"?"parentTerminal"in v&&v.parentTerminal&&D?{parentTerminal:D}:"viewColumn"in v?{viewColumn:l.ViewColumn.from(v.viewColumn),preserveFocus:v.preserveFocus}:void 0:v}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name(v){this.y=v}setExitStatus(v,D){this.j=Object.freeze({code:v,reason:D})}setDimensions(v,D){return v===this.f&&D===this.h||v===0||D===0?!1:(this.f=v,this.h=D,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection(v){this.n=v}_setProcessId(v){this.g?(this.g(v),this.g=void 0):this.b.then(D=>{D!==v&&(this.b=Promise.resolve(v))})}}e.$okc=n;class r{get onProcessReady(){return this.b.event}constructor(v){this.g=v,this.id=0,this.shouldPersist=!1,this.a=new o.$7d,this.onProcessData=this.a.event,this.b=new o.$7d,this.d=new o.$7d,this.onDidChangeProperty=this.d.event,this.f=new o.$7d,this.onProcessExit=this.f.event}refreshProperty(v){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${v}`)}updateProperty(v,D){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${v}, value: ${D}`)}async start(){}shutdown(){this.g.close()}input(v){this.g.handleInput?.(v)}resize(v,D){this.g.setDimensions?.({columns:v,rows:D})}clearBuffer(){}async processBinary(v){}acknowledgeDataEvent(v){}async setUnicodeVersion(v){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(v){this.g.onDidWrite(D=>this.a.fire(D)),this.g.onDidClose?.((D=void 0)=>{this.f.fire(D===void 0?void 0:D)}),this.g.onDidOverrideDimensions?.(D=>{D&&this.d.fire({type:"overrideDimensions",value:{cols:D.columns,rows:D.rows}})}),this.g.onDidChangeName?.(D=>{this.d.fire({type:"title",value:D})}),this.g.open(v||void 0),v&&this.g.setDimensions?.(v),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let s=1,t=class extends p.$Uc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(v=>v.value)}constructor(v,D,k){super(),this.Q=D,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new p.$Vc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new o.$7d,this.onDidCloseTerminal=this.H.event,this.I=new o.$7d,this.onDidOpenTerminal=this.I.event,this.J=new o.$7d,this.onDidChangeActiveTerminal=this.J.event,this.L=new o.$7d,this.onDidChangeTerminalDimensions=this.L.event,this.M=new o.$7d,this.onDidChangeTerminalState=this.M.event,this.N=new o.$7d,this.onDidChangeShell=this.N.event,this.O=new o.$7d({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new o.$7d({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=k.getProxy(R.$sM.MainThreadTerminalService),this.y=new y.$xub(this.a.$sendProcessData),this.a.$registerProcessSupport(v),this.Q.registerArgumentProcessor({processArgument:S=>{const F=W=>{const B=W;return this.getTerminalById(B.instanceId)?.value};switch(S?.$mid){case 15:return F(S);default:{if(Array.isArray(S))for(let W=0;W<S.length&&S[W].$mid===15;W++)S[W]=F(S[W]);return S}}}}),this.B({dispose:()=>{for(const[S,F]of this.g)F.shutdown(!0)}})}getDefaultShell(v){return(v?this.u:this.s)?.path||""}getDefaultShellArgs(v){return(v?this.u:this.s)?.args||[]}createExtensionTerminal(v,D){const k=new n(this.a,(0,C.$Eg)(),v,v.name),S=new r(v.pty);return k.createExtensionTerminal(v.location,D,this.R(v,D).resolvedExtHostIdentifier,c(v.iconPath),u(v.color)).then(F=>{const W=this.S(F,S);this.h[F]=W}),this.f.push(k),k.value}R(v,D){if(D=D||{},v.location&&typeof v.location=="object"&&"parentTerminal"in v.location){const k=v.location.parentTerminal;if(k){const S=this.f.find(F=>F.value===k);S&&(D.resolvedExtHostIdentifier=S._id)}}else v.location&&typeof v.location!="object"?D.location=v.location:D.location&&typeof D.location=="object"&&"splitActiveTerminal"in D.location&&(D.location={splitActiveTerminal:!0});return D}attachPtyToTerminal(v,D){if(!this.getTerminalById(v))throw new Error(`Cannot resolve terminal with id ${v} for virtual process`);const S=new r(D),F=this.S(v,S);this.h[v]=F}async $acceptActiveTerminalChanged(v){const D=this.b;if(v===null){this.b=void 0,D!==this.b&&this.J.fire(this.b);return}const k=this.getTerminalById(v);k&&(this.b=k,D!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(v,D){const k=this.getTerminalById(v);k&&this.O.fire({terminal:k.value,data:D})}async $acceptTerminalDimensions(v,D,k){const S=this.getTerminalById(v);S&&S.setDimensions(D,k)&&this.L.fire({terminal:S.value,dimensions:S.value.dimensions})}async $acceptDidExecuteCommand(v,D){const k=this.getTerminalById(v);k&&this.P.fire({terminal:k.value,...D})}async $acceptTerminalMaximumDimensions(v,D,k){this.g.get(v)?.resize(D,k)}async $acceptTerminalTitleChange(v,D){const k=this.getTerminalById(v);k&&(k.name=D)}async $acceptTerminalClosed(v,D,k){const S=this.X(this.f,v);if(S!==null){const F=this.f.splice(S,1)[0];F.setExitStatus(D,k),this.H.fire(F.value)}}$acceptTerminalOpened(v,D,k,S){if(D){const B=this.X(this.f,D);if(B!==null){this.f[B]._id=v,this.I.fire(this.terminals[B]),this.f[B].isOpen=!0;return}}const F={name:S.name,shellPath:S.executable,shellArgs:S.args,cwd:typeof S.cwd=="string"?S.cwd:M.URI.revive(S.cwd),env:S.env,hideFromUser:S.hideFromUser},W=new n(this.a,v,F,k);this.f.push(W),this.I.fire(W.value),W.isOpen=!0}async $acceptTerminalProcessId(v,D){this.getTerminalById(v)?._setProcessId(D)}async $startExtensionTerminal(v,D){const k=this.getTerminalById(v);if(!k)return{message:(0,w.localize)(0,null,v)};k.isOpen||await new Promise(F=>{const W=this.onDidOpenTerminal(async B=>{B===k.value&&(W.dispose(),F())})});const S=this.g.get(v);S?S.startSendingEvents(D):this.j[v]={initialDimensions:D}}S(v,D){const k=new p.$Tc;k.add(D.onProcessReady(F=>this.a.$sendProcessReady(v,F.pid,F.cwd,F.windowsPty))),k.add(D.onDidChangeProperty(F=>this.a.$sendProcessProperty(v,F))),this.y.startBuffering(v,D.onProcessData),k.add(D.onProcessExit(F=>this.U(v,F))),this.g.set(v,D);const S=this.j[v];return S&&D instanceof r&&(D.startSendingEvents(S.initialDimensions),delete this.j[v]),k}$acceptProcessAckDataEvent(v,D){this.g.get(v)?.acknowledgeDataEvent(D)}$acceptProcessInput(v,D){this.g.get(v)?.input(D)}$acceptTerminalInteraction(v){const D=this.getTerminalById(v);D?.setInteractedWith()&&this.M.fire(D.value)}$acceptTerminalSelection(v,D){this.getTerminalById(v)?.setSelection(D)}$acceptProcessResize(v,D,k){try{this.g.get(v)?.resize(D,k)}catch(S){if(S.code!=="EPIPE"&&S.code!=="ERR_IPC_CHANNEL_CLOSED")throw S}}$acceptProcessShutdown(v,D){this.g.get(v)?.shutdown(D)}$acceptProcessRequestInitialCwd(v){this.g.get(v)?.getInitialCwd().then(D=>this.a.$sendProcessProperty(v,{type:"initialCwd",value:D}))}$acceptProcessRequestCwd(v){this.g.get(v)?.getCwd().then(D=>this.a.$sendProcessProperty(v,{type:"cwd",value:D}))}$acceptProcessRequestLatency(v){return Promise.resolve(v)}registerLinkProvider(v){return this.z.add(v),this.z.size===1&&this.a.$startLinkProvider(),new $.$uM(()=>{this.z.delete(v),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(v,D,k){if(this.C.has(D))throw new Error(`Terminal profile provider "${D}" already registered`);return this.C.set(D,k),this.a.$registerProfileProvider(D,v.identifier.value),new $.$uM(()=>{this.C.delete(D),this.a.$unregisterProfileProvider(D)})}registerTerminalQuickFixProvider(v,D,k){if(this.D.has(v))throw new Error(`Terminal quick fix provider "${v}" is already registered`);return this.D.set(v,k),this.a.$registerQuickFixProvider(v,D),new $.$uM(()=>{this.D.delete(v),this.a.$unregisterQuickFixProvider(v)})}async $provideTerminalQuickFixes(v,D){const k=new b.$ee().token;if(k.isCancellationRequested)return;const S=this.D.get(v);if(!S)return;const F=await S.provideTerminalQuickFixes(D,k);if(F===null||Array.isArray(F)&&F.length===0)return;const W=new p.$Tc;if(this.w.value=W,!Array.isArray(F))return F?l.TerminalQuickFix.from(F,this.Q.converter,W):void 0;const B=[];for(const T of F){const N=l.TerminalQuickFix.from(T,this.Q.converter,W);N&&B.push(N)}return B}async $createContributedProfileTerminal(v,D){const k=new b.$ee().token;let S=await this.C.get(v)?.provideTerminalProfile(k);if(!k.isCancellationRequested){if(S&&!("options"in S)&&(S={options:S}),!S||!("options"in S))throw new Error(`No terminal profile options provided for id "${v}"`);if("pty"in S.options){this.createExtensionTerminal(S.options,D);return}this.createTerminalFromOptions(S.options,D)}}async $provideLinks(v,D){const k=this.getTerminalById(v);if(!k)return[];this.F.delete(v),this.G.get(v)?.dispose(!0);const F=new b.$ee;this.G.set(v,F);const W=[],B={terminal:k.value,line:D},T=[];for(const L of this.z)T.push(m.Promises.withAsyncBody(async z=>{F.token.onCancellationRequested(()=>z({provider:L,links:[]}));const Q=await L.provideTerminalLinks(B,F.token)||[];F.token.isCancellationRequested||z({provider:L,links:Q})}));const N=await Promise.all(T);if(F.token.isCancellationRequested)return[];const j=new Map;for(const L of N)L&&L.links.length>0&&W.push(...L.links.map(z=>{const Q={id:s++,startIndex:z.startIndex,length:z.length,label:z.tooltip};return j.set(Q.id,{provider:L.provider,link:z}),Q}));return this.F.set(v,j),W}$activateLink(v,D){const k=this.F.get(v)?.get(D);k&&k.provider.handleTerminalLink(k.link)}U(v,D){this.y.stopBuffering(v),this.g.delete(v),delete this.j[v];const k=this.h[v];k&&(k.dispose(),delete this.h[v]),this.a.$sendProcessExit(v,D)}getTerminalById(v){return this.W(this.f,v)}getTerminalIdByApiObject(v){const D=this.f.findIndex(k=>k.value===v);return D>=0?D:null}W(v,D){const k=this.X(v,D);return k!==null?v[k]:null}X(v,D){const k=v.findIndex(S=>S._id===D);return k>=0?k:null}getEnvironmentVariableCollection(v){let D=this.n.get(v.identifier.value);return D||(D=new g,this.Z(v.identifier.value,D)),D.getScopedEnvironmentVariableCollection(void 0)}Y(v,D){const k=(0,P.$8r)(D.map),S=(0,P.$9r)(D.descriptionMap);this.a.$setEnvironmentVariableCollection(v,D.persistent,k.length===0?void 0:k,S)}$initEnvironmentVariableCollections(v){v.forEach(D=>{const k=D[0],S=new g(D[1]);this.Z(k,S)})}$acceptDefaultProfile(v,D){const k=this.s;this.s=v,this.u=D,k?.path!==v.path&&this.N.fire(v.path)}Z(v,D){this.n.set(v,D),D.onDidChangeCollection(()=>{this.Y(v,D)})}};e.$pkc=t,e.$pkc=t=Qe([He(1,i.$$O),He(2,O.$OO)],t);class g{get persistent(){return this.b}set persistent(v){this.b=v,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(v){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new o.$7d,this.map=new Map(v)}getScopedEnvironmentVariableCollection(v){const D=this.h(v);let k=this.a.get(D);return k||(k=new d(this,v),this.a.set(D,k),k.onDidChangeCollection(()=>this.d.fire())),k}replace(v,D,k,S){this.f(v,{value:D,type:$.EnvironmentVariableMutatorType.Replace,options:k??{applyAtProcessCreation:!0},scope:S})}append(v,D,k,S){this.f(v,{value:D,type:$.EnvironmentVariableMutatorType.Append,options:k??{applyAtProcessCreation:!0},scope:S})}prepend(v,D,k,S){this.f(v,{value:D,type:$.EnvironmentVariableMutatorType.Prepend,options:k??{applyAtProcessCreation:!0},scope:S})}f(v,D){if(D.options&&D.options.applyAtProcessCreation===!1&&!D.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const k=this.g(v,D.scope),S=this.map.get(k),F=D.options?{applyAtProcessCreation:D.options.applyAtProcessCreation??!1,applyAtShellIntegration:D.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!S||S.value!==D.value||S.type!==D.type||S.options?.applyAtProcessCreation!==F.applyAtProcessCreation||S.options?.applyAtShellIntegration!==F.applyAtShellIntegration||S.scope?.workspaceFolder?.index!==D.scope?.workspaceFolder?.index){const W=this.g(v,D.scope),B={variable:v,...D,options:F};this.map.set(W,B),this.d.fire()}}get(v,D){const k=this.g(v,D),S=this.map.get(k);return S?f(S):void 0}g(v,D){const k=this.h(D);return k.length?`${v}:::${k}`:v}h(v){return this.j(v?.workspaceFolder)??""}j(v){return v?v.uri.toString():void 0}getVariableMap(v){const D=new Map;for(const[k,S]of this.map)this.h(S.scope)===this.h(v)&&D.set(S.variable,f(S));return D}delete(v,D){const k=this.g(v,D);this.map.delete(k),this.d.fire()}clear(v){if(v?.workspaceFolder){for(const[D,k]of this.map)k.scope?.workspaceFolder?.index===v.workspaceFolder.index&&this.map.delete(D);this.k(v)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(v,D){const k=this.h(D),S=this.descriptionMap.get(k);if(!S||S.description!==v){let F;typeof v=="string"?F=v:F=v?.value.split(`

`)[0];const W={description:F,scope:D};this.descriptionMap.set(k,W),this.d.fire()}}getDescription(v){const D=this.h(v);return this.descriptionMap.get(D)?.description}k(v){const D=this.h(v);this.descriptionMap.delete(D)}}class d{get persistent(){return this.b.persistent}set persistent(v){this.b.persistent=v}get onDidChangeCollection(){return this.a&&this.a.event}constructor(v,D){this.b=v,this.d=D,this.a=new o.$7d}getScoped(v){return this.b.getScopedEnvironmentVariableCollection(v)}replace(v,D,k){this.b.replace(v,D,k,this.d)}append(v,D,k){this.b.append(v,D,k,this.d)}prepend(v,D,k){this.b.prepend(v,D,k,this.d)}get(v){return this.b.get(v,this.d)}forEach(v,D){this.b.getVariableMap(this.d).forEach((k,S)=>v.call(D,S,k,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(v){this.b.delete(v,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(v){this.b.setDescription(v,this.d)}get description(){return this.b.getDescription(this.d)}}let h=class extends t{constructor(v,D){super(!1,v,D)}createTerminal(v,D,k){throw new A.$_}createTerminalFromOptions(v,D){throw new A.$_}};e.$qkc=h,e.$qkc=h=Qe([He(0,i.$$O),He(1,O.$OO)],h);function c(E){if(!(!E||typeof E=="string"))return"id"in E?{id:E.id,color:E.color}:E}function u(E){return a.ThemeColor.isThemeColor(E)?E:void 0}function f(E){const v={...E};return delete v.scope,v.options=v.options??void 0,delete v.variable,v}}),define(Ee[156],Ce([1,0,3,5,6,20,44,4,2,8]),function(re,e,o,R,I,M,O,p,$,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hlc=e.$Glc=void 0,e.$Glc=(0,R.$ii)("IExtHostTerminalShellIntegration");let A=class extends o.$Uc{constructor(a,m){super(),this.h=m,this.b=new Map,this.c=new p.$7d,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new p.$7d,this.onDidStartTerminalShellExecution=this.f.event,this.g=new p.$7d,this.onDidEndTerminalShellExecution=this.g.event,this.a=a.getProxy(I.$sM.MainThreadTerminalShellIntegration),this.B((0,o.$Sc)(()=>{for(const[l,i]of this.b)i.dispose();this.b.clear()}))}$shellIntegrationChange(a){const m=this.h.getTerminalById(a);if(!m)return;const l=m.value;let i=this.b.get(a);i||(i=new P(m.value,this.f),this.b.set(a,i),i.store.add(m.onWillDispose(()=>this.b.get(a)?.dispose())),i.store.add(i.onDidRequestShellExecution(n=>this.a.$executeCommand(a,n))),i.store.add(i.onDidRequestEndExecution(n=>this.g.fire(n.value))),i.store.add(i.onDidRequestChangeShellIntegration(n=>this.c.fire(n))),m.shellIntegration=i.value),this.c.fire({terminal:l,shellIntegration:i.value})}$shellExecutionStart(a,m,l){this.b.has(a)||this.$shellIntegrationChange(a),this.b.get(a)?.startShellExecution(m,l)}$shellExecutionEnd(a,m,l){this.b.get(a)?.endShellExecution(m,l)}$shellExecutionData(a,m){this.b.get(a)?.emitData(m)}$cwdChange(a,m){this.b.get(a)?.setCwd(m)}$closeTerminal(a){this.b.get(a)?.dispose(),this.b.delete(a)}};e.$Hlc=A,e.$Hlc=A=Qe([He(0,M.$OO),He(1,O.$nkc)],A);class P extends o.$Uc{get currentExecution(){return this.a}constructor(a,m){super(),this.j=a,this.m=m,this.b=!1,this.store=this.B(new o.$Tc),this.f=this.B(new p.$7d),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new p.$7d),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new p.$7d),this.onDidRequestEndExecution=this.h.event;const l=this;this.value={get cwd(){return l.c},executeCommand(i){l.g.fire(i);const n=l.startShellExecution(i,l.c).value;return l.b=!0,n}}}startShellExecution(a,m){return this.b&&this.a?this.b=!1:(this.a&&(this.a.endExecution(void 0,void 0),this.h.fire(this.a)),this.a=new b(this.j,a,m),this.m.fire(this.a.value)),this.a}emitData(a){this.currentExecution?.emitData(a)}endShellExecution(a,m){this.a&&(this.a.endExecution(a,m),this.h.fire(this.a),this.a=void 0)}setCwd(a){let m=!1;$.URI.isUri(this.c)?this.c.toString()!==a.toString()&&(m=!0):this.c!==a&&(m=!0),m&&(this.c=a,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class b{constructor(a,m,l){this.terminal=a,this.d=m,this.cwd=l,this.b=new Promise(n=>{this.c=n});const i=this;this.value={get terminal(){return a},get commandLine(){return i.d},get cwd(){return l},get exitCode(){return i.b},createDataStream(){return i.f()}}}f(){if(!this.a){if(this.c===void 0)return w.$Ih.EMPTY;this.a=new C}return this.a.createIterable()}emitData(a){this.a?.emitData(a)}endExecution(a,m){a&&(this.d=a),this.a?.endExecution(),this.a=void 0,this.c?.(m),this.c=void 0}}class C extends o.$Uc{constructor(){super(...arguments),this.b=[]}createIterable(){const a=this.a=new w.$hh;return new w.$Ih(async l=>{this.b.push(l),await a.wait()})}emitData(a){for(const m of this.b)m.emitOne(a)}endExecution(){this.a?.open(),this.a=void 0}}});var qe=this&&this.__classPrivateFieldGet||function(re,e,o,R){if(o==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!R:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?R:o==="a"?R.call(re):R?R.value:e.get(re)},it=this&&this.__classPrivateFieldSet||function(re,e,o,R,I){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!I:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?I.call(re,o):I?I.value=o:e.set(re,o),o};define(Ee[353],Ce([1,0,8,21,22,4,74,55,3,18,30,12,6,20,155,16,7,67,113,89]),function(re,e,o,R,I,M,O,p,$,w,A,P,b,C,y,a,m,l,i,n){"use strict";var r,s,t,g,d;Object.defineProperty(e,"__esModule",{value:!0}),e.$wlc=e.$vlc=e.$ulc=e.$tlc=void 0;let h=class extends $.$Uc{constructor(j,L,z,Q){super(),this.w=Q,this.f=this.B(new M.$7d),this.g=new Map,this.s=this.B(new M.$7d),this.onResultsChanged=this.f.event,this.results=[],this.h=j.getProxy(b.$sM.MainThreadTesting),this.m=new F(this.h),this.j=new E(this.h,L),z.registerArgumentProcessor({processArgument:Y=>{switch(Y?.$mid){case 16:{const J=Y,x=J.tests[J.tests.length-1].item.extId;return this.g.get(l.$eL.root(x))?.collection.tree.get(x)?.actual??(0,y.$1O)(Y)}case 18:{const{test:J,message:x}=Y,ce=J.item.extId;return{test:this.g.get(l.$eL.root(ce))?.collection.tree.get(ce)?.actual??(0,y.$1O)({$mid:16,tests:[J]}),message:a.TestMessage.to(x)}}default:return Y}}}),z.registerCommand(!1,"testing.getExplorerSelection",async()=>{const Y=await z.executeCommand("_testing.getExplorerSelection"),J=x=>{const ce=this.g.get(l.$eL.root(x));if(ce)return l.$eL.isRoot(x)?ce.controller:ce.collection.tree.get(x)?.actual};return{include:Y?.include.map(J).filter(w.$4f)||[],exclude:Y?.exclude.map(J).filter(w.$4f)||[]}})}createTestController(j,L,z,Q){if(this.g.has(L))throw new Error(`Attempt to insert a duplicate controller with ID "${L}"`);const Y=new $.$Tc,J=Y.add(new y.$4O(L,z,this.w));J.root.label=z;const x=new Map,ce=new Set,te=this.h,pe={items:J.root.children,get label(){return z},set label(_){z=_,J.root.label=_,te.$updateController(L,{label:z})},get refreshHandler(){return Q},set refreshHandler(_){Q=_,te.$updateController(L,{canRefresh:!!_})},get id(){return L},createRunProfile:(_,U,he,Se,me,ie)=>{let se=(0,p.$9i)(_);for(;x.has(se);)se++;return new B(this.h,x,ce,this.s.event,L,se,_,U,he,Se,me,ie)},createTestItem(_,U,he){return new y.$2O(L,_,U,he)},createTestRun:(_,U,he=!0)=>this.j.createTestRun(L,J,_,U,he),invalidateTestResults:_=>{if(_===void 0)this.h.$markTestRetired(void 0);else{const U=_ instanceof Array?_:[_];this.h.$markTestRetired(U.map(he=>l.$eL.fromExtHostTestItem(he,L).toString()))}},set resolveHandler(_){J.resolveHandler=_},get resolveHandler(){return J.resolveHandler},dispose:()=>{Y.dispose()}};te.$registerTestController(L,z,!!Q),Y.add((0,$.$Sc)(()=>te.$unregisterTestController(L)));const ye={controller:pe,collection:J,profiles:x,extension:j,activeProfiles:ce};return this.g.set(L,ye),Y.add((0,$.$Sc)(()=>this.g.delete(L))),Y.add(J.onDidGenerateDiff(_=>te.$publishDiff(L,_.map(n.TestsDiffOp.serialize)))),pe}createTestObserver(){return this.m.checkout()}async runTests(j,L=I.CancellationToken.None){const z=v(j);if(!z)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const Q=this.g.get(z.controllerId);if(!Q)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:j.include?.map(Y=>l.$eL.fromExtHostTestItem(Y,Q.collection.root.id).toString())??[Q.collection.root.id],profileGroup:T[z.kind],profileId:z.profileId,controllerId:z.controllerId}],exclude:j.exclude?.map(Y=>Y.id)},L)}$syncTests(){for(const{collection:j}of this.g.values())j.flushDiff();return Promise.resolve()}async $getCoverageDetails(j,L){return(await this.j.getCoverageDetails(j,L))?.map(a.TestCoverage.fromDetails)}async $disposeRun(j){this.j.disposeTestRun(j)}$configureRunProfile(j,L){this.g.get(j)?.profiles.get(L)?.configureHandler?.()}$setDefaultRunProfiles(j){const L=new Map;for(const[z,Q]of Object.entries(j)){const Y=this.g.get(z);if(!Y)continue;const J=new Map,x=Q.filter(te=>!Y.activeProfiles.has(te)),ce=[...Y.activeProfiles].filter(te=>!Q.includes(te));for(const te of x)J.set(te,!0),Y.activeProfiles.add(te);for(const te of ce)J.set(te,!1),Y.activeProfiles.delete(te);J.size&&L.set(z,J)}this.s.fire(L)}async $refreshTests(j,L){await this.g.get(j)?.controller.refreshHandler?.(L)}$publishTestResults(j){this.results=Object.freeze(j.map(a.TestResults.to).concat(this.results).sort((L,z)=>z.completedAt-L.completedAt).slice(0,32)),this.f.fire()}async $expandTest(j,L){const z=this.g.get(l.$eL.fromString(j).controllerId)?.collection;z&&(await z.expand(j,L<0?1/0:L),z.flushDiff())}$acceptDiff(j){this.m.applyDiff(j.map(L=>n.TestsDiffOp.deserialize({asCanonicalUri:z=>z},L)))}async $runControllerTests(j,L){return Promise.all(j.map(z=>this.y(z,!1,L)))}async $startContinuousRun(j,L){const z=new I.$ee(L),Q=await Promise.all(j.map(Y=>this.y(Y,!0,z.token)));return!L.isCancellationRequested&&!Q.some(Y=>Y.error)&&await new Promise(Y=>L.onCancellationRequested(Y)),z.dispose(!0),Q}async y(j,L,z){const Q=this.g.get(j.controllerId);if(!Q)return{};const{collection:Y,profiles:J}=Q,x=J.get(j.profileId);if(!x)return{};const ce=j.testIds.map(_=>Y.tree.get(_)).filter(w.$4f),te=j.excludeExtIds.map(_=>Q.collection.tree.get(_)).filter(w.$4f).filter(_=>ce.some(U=>U.fullId.compare(_.fullId)===2));if(!ce.length)return{};const pe=new m.$7N(ce.some(_=>_.actual instanceof y.$3O)?void 0:ce.map(_=>_.actual),te.map(_=>_.actual),x,L),ye=(0,n.$hL)(j)&&this.j.prepareForMainThreadTestRun(pe,D.fromInternal(j,Q.collection),x,z);try{return await x.runHandler(pe,z),{}}catch(_){return{error:String(_)}}finally{ye&&ye.hasRunningTasks&&!z.isCancellationRequested&&await M.Event.toPromise(ye.onEnd)}}$cancelExtensionTestRun(j){j===void 0?this.j.cancelAllRuns():this.j.cancelRunById(j)}};e.$tlc=h,e.$tlc=h=Qe([He(0,C.$OO),He(1,P.$Oj)],h);const c=1e4;var u;(function(N){N[N.Running=0]="Running",N[N.Cancelling=1]="Cancelling",N[N.Ended=2]="Ended"})(u||(u={}));class f extends $.$Uc{get hasRunningTasks(){return this.g>0}get id(){return this.z.id}constructor(j,L,z,Q,Y){super(),this.z=j,this.C=L,this.D=z,this.F=Q,this.f=0,this.g=0,this.h=new Map,this.j=new Set,this.s=this.B(new M.$7d),this.y=new Map,this.onEnd=this.s.event,this.m=this.B(new I.$ee(Y));const J=this.B(new o.$uh(()=>this.G(),c));this.B(this.m.token.onCancellationRequested(()=>J.schedule()));const x=new M.$7d;this.w=x.event,this.B((0,$.$Sc)(()=>{x.fire(),x.dispose()}))}cancel(){this.f===0?(this.m.cancel(),this.f=1):this.f===1&&this.G()}getCoverageDetails(j,L){const[,z,Q]=l.$eL.fromString(j).path,Y=this.y.get(Q);if(!Y)return[];if(Y.backCompatResolve)return Y.backCompatResolve(L);const J=this.h.get(z);if(!J)throw new Error("unreachable: run task was not found");return this.F?.loadDetailedCoverage?.(J.run,Y.coverage,L)??[]}createRun(j){const L=this.z.id,z=this.z.controllerId,Q=(0,A.$Eg)(),Y=ye=>(_,...U)=>{if(ce){this.D.warn(`Setting the state of test "${_.id}" is a no-op after the run ends.`);return}this.z.isIncluded(_)&&(this.I(_),ye(_,...U))},J=(ye,_)=>{const U=_ instanceof Array?_.map(a.TestMessage.from):[a.TestMessage.from(_)];if(ye.uri&&ye.range){const he={range:a.Range.from(ye.range),uri:ye.uri};for(const Se of U)Se.location=Se.location||he}this.C.$appendTestMessagesInRun(L,Q,l.$eL.fromExtHostTestItem(ye,z).toString(),U)},x=(ye,_)=>{const U=ye.uri.toString(),he=new l.$eL([L,Q,U]).toString();this.y.set(U,{coverage:ye,backCompatResolve:_}),this.C.$appendCoverage(L,Q,a.TestCoverage.fromFile(he,ye))};let ce=!1,te;const pe={isPersisted:this.z.isPersisted,token:this.m.token,name:j,onDidDispose:this.w,get coverageProvider(){return te},set coverageProvider(ye){te=ye,ye&&Promise.resolve(ye.provideFileCoverage(I.CancellationToken.None)).then(_=>{_?.forEach(U=>x(U,ye.resolveFileCoverage&&(async he=>(await ye.resolveFileCoverage(U,he)||U).detailedCoverage)))})},addCoverage:x,enqueued:Y(ye=>{this.C.$updateTestStateInRun(L,Q,l.$eL.fromExtHostTestItem(ye,z).toString(),1)}),skipped:Y(ye=>{this.C.$updateTestStateInRun(L,Q,l.$eL.fromExtHostTestItem(ye,z).toString(),5)}),started:Y(ye=>{this.C.$updateTestStateInRun(L,Q,l.$eL.fromExtHostTestItem(ye,z).toString(),2)}),errored:Y((ye,_,U)=>{J(ye,_),this.C.$updateTestStateInRun(L,Q,l.$eL.fromExtHostTestItem(ye,z).toString(),6,U)}),failed:Y((ye,_,U)=>{J(ye,_),this.C.$updateTestStateInRun(L,Q,l.$eL.fromExtHostTestItem(ye,z).toString(),4,U)}),passed:Y((ye,_)=>{this.C.$updateTestStateInRun(L,Q,l.$eL.fromExtHostTestItem(ye,this.z.controllerId).toString(),3,_)}),appendOutput:(ye,_,U)=>{ce||(U&&(this.z.isIncluded(U)?this.I(U):U=void 0),this.C.$appendOutputToRun(L,Q,R.$ue.fromString(ye),_&&a.location.from(_),U&&l.$eL.fromExtHostTestItem(U,z).toString()))},end:()=>{ce||(ce=!0,this.C.$finishedTestRunTask(L,Q),--this.g||this.H())}};return this.g++,this.h.set(Q,{run:pe}),this.C.$startedTestRunTask(L,{id:Q,name:j,running:!0}),pe}G(){for(const{run:j}of this.h.values())j.end()}H(){this.f!==2&&(this.f=2,this.s.fire())}I(j){if(!(j instanceof y.$2O))throw new i.$GO(j.id);if(this.j.has(l.$eL.fromExtHostTestItem(j,this.z.controllerId).toString()))return;const L=[],z=this.z.colllection.root;for(;;){const Q=a.TestItem.from(j);if(L.unshift(Q),this.j.has(Q.extId)||(this.j.add(Q.extId),j===z))break;j=j.parent||z}this.C.$addTestsToRun(this.z.controllerId,this.z.id,L)}dispose(){this.H(),super.dispose()}}class E{get trackers(){return this.f.values()}constructor(j,L){this.h=j,this.j=L,this.f=new Map,this.g=new Map}getCoverageDetails(j,L){const z=l.$eL.root(j);return this.g.get(z)?.getCoverageDetails(j,L)||[]}disposeTestRun(j){this.g.get(j)?.dispose(),this.g.delete(j);for(const[L,{id:z}]of this.f)z===j&&this.f.delete(L)}prepareForMainThreadTestRun(j,L,z,Q){return this.k(j,L,z,Q)}cancelRunById(j){this.g.get(j)?.cancel()}cancelAllRuns(){for(const j of this.f.values())j.cancel()}createTestRun(j,L,z,Q,Y){const J=this.f.get(z);if(J)return J.createRun(Q);const x=D.fromPublic(j,L,z,Y),ce=v(z);this.h.$startedExtensionTestRun({controllerId:j,continuous:!!z.continuous,profile:ce&&{group:T[ce.kind],id:ce.profileId},exclude:z.exclude?.map(pe=>l.$eL.fromExtHostTestItem(pe,L.root.id).toString())??[],id:x.id,include:z.include?.map(pe=>l.$eL.fromExtHostTestItem(pe,L.root.id).toString())??[L.root.id],persist:Y});const te=this.k(z,x,z.profile);return M.Event.once(te.onEnd)(()=>{this.h.$finishedExtensionTestRun(x.id)}),te.createRun(Q)}k(j,L,z,Q){const Y=new f(L,this.h,this.j,z,Q);return this.f.set(j,Y),this.g.set(Y.id,Y),Y}}e.$ulc=E;const v=N=>{if(N.profile){if(!(N.profile instanceof B))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return N.profile}};class D{static fromPublic(j,L,z,Q){return new D(j,(0,A.$Eg)(),z.include?.map(Y=>l.$eL.fromExtHostTestItem(Y,j).toString())??[j],z.exclude?.map(Y=>l.$eL.fromExtHostTestItem(Y,j).toString())??[],Q,L)}static fromInternal(j,L){return new D(j.controllerId,j.runId,j.testIds,j.excludeExtIds,!0,L)}constructor(j,L,z,Q,Y,J){this.controllerId=j,this.id=L,this.isPersisted=Y,this.colllection=J,this.f=z.map(x=>x+"\0"),this.g=Q.map(x=>x+"\0")}isIncluded(j){const L=l.$eL.fromExtHostTestItem(j,this.controllerId).toString()+"\0";for(const z of this.g)if(L===z||L.startsWith(z))return!1;for(const z of this.f)if(L===z||L.startsWith(z))return!0;return!1}}e.$vlc=D;class k{get isEmpty(){return this.f.size===0&&this.h.size===0&&this.g.size===0}constructor(j){this.k=j,this.f=new Set,this.g=new Set,this.h=new Set,this.j=new Set}add(j){this.f.add(j)}update(j){Object.assign(j.revived,a.TestItem.toPlain(j.item)),this.f.has(j)||this.g.add(j)}remove(j){if(this.f.has(j)){this.f.delete(j);return}this.g.delete(j);const L=l.$eL.parentId(j.item.extId);if(L&&this.j.has(L.toString())){this.j.add(j.item.extId);return}this.h.add(j)}getChangeEvent(){const{f:j,g:L,h:z}=this;return{get added(){return[...j].map(Q=>Q.revived)},get updated(){return[...L].map(Q=>Q.revived)},get removed(){return[...z].map(Q=>Q.revived)}}}complete(){this.isEmpty||this.k.fire(this.getChangeEvent())}}class S extends n.$nL{constructor(){super(...arguments),this.s=new M.$7d,this.onDidChangeTests=this.s.event}get rootTests(){return this.h}getMirroredTestDataById(j){return this.g.get(j)}getMirroredTestDataByReference(j){return this.g.get(j.id)}x(j,L){return{...j,revived:a.TestItem.toPlain(j.item),depth:L?L.depth+1:0,children:new Set}}w(){return new k(this.s)}}class F{constructor(j){this.g=j}checkout(){this.f||(this.f=this.h());const j=this.f;return j.observers++,{onDidChangeTest:j.tests.onDidChangeTests,get tests(){return[...j.tests.rootTests].map(L=>L.revived)},dispose:(0,O.$db)(()=>{--j.observers===0&&(this.g.$unsubscribeFromDiffs(),this.f=void 0)})}}getMirroredTestDataByReference(j){return this.f?.tests.getMirroredTestDataByReference(j)}applyDiff(j){this.f?.tests.apply(j)}h(){const j=new S({asCanonicalUri:L=>L});return this.g.$subscribeToDiffs(),{observers:0,tests:j}}}const W=(N,j,L,z)=>{L?Object.assign(L,z):j.$updateTestRunConfig(N.controllerId,N.profileId,z)};class B{get label(){return this.g}set label(j){j!==this.g&&(this.g=j,W(this,qe(this,r,"f"),qe(this,g,"f"),{label:j}))}get supportsContinuousRun(){return this.h}set supportsContinuousRun(j){j!==this.h&&(this.h=j,W(this,qe(this,r,"f"),qe(this,g,"f"),{supportsContinuousRun:j}))}get isDefault(){return qe(this,s,"f").has(this.profileId)}set isDefault(j){j!==this.isDefault&&(j?qe(this,s,"f").add(this.profileId):qe(this,s,"f").delete(this.profileId),W(this,qe(this,r,"f"),qe(this,g,"f"),{isDefault:j}))}get tag(){return this._tag}set tag(j){j?.id!==this._tag?.id&&(this._tag=j,W(this,qe(this,r,"f"),qe(this,g,"f"),{tag:j?a.TestTag.namespace(this.controllerId,j.id):null}))}get configureHandler(){return this.f}set configureHandler(j){j!==this.f&&(this.f=j,W(this,qe(this,r,"f"),qe(this,g,"f"),{hasConfigurationHandler:!!j}))}get onDidChangeDefault(){return M.Event.chain(qe(this,t,"f"),j=>j.map(L=>L.get(this.controllerId)?.get(this.profileId)).filter(w.$4f))}constructor(j,L,z,Q,Y,J,x,ce,te,pe=!1,ye=void 0,_=!1){this.controllerId=Y,this.profileId=J,this.g=x,this.kind=ce,this.runHandler=te,this._tag=ye,this.h=_,r.set(this,void 0),s.set(this,void 0),t.set(this,void 0),g.set(this,void 0),d.set(this,void 0),it(this,r,j,"f"),it(this,d,L,"f"),it(this,s,z,"f"),it(this,t,Q,"f"),L.set(J,this);const U=T[ce];if(typeof U!="number")throw new Error(`Unknown TestRunProfile.group ${ce}`);pe&&z.add(J),it(this,g,{profileId:J,controllerId:Y,tag:ye?a.TestTag.namespace(this.controllerId,ye.id):null,label:x,group:U,isDefault:pe,hasConfigurationHandler:!1,supportsContinuousRun:_},"f"),queueMicrotask(()=>{qe(this,g,"f")&&(qe(this,r,"f").$publishTestRunProfile(qe(this,g,"f")),it(this,g,void 0,"f"))})}dispose(){qe(this,d,"f")?.delete(this.profileId)&&(it(this,d,void 0,"f"),qe(this,r,"f").$removeTestProfile(this.controllerId,this.profileId)),it(this,g,void 0,"f")}}e.$wlc=B,r=new WeakMap,s=new WeakMap,t=new WeakMap,g=new WeakMap,d=new WeakMap;const T={[m.TestRunProfileKind.Coverage]:8,[m.TestRunProfileKind.Debug]:4,[m.TestRunProfileKind.Run]:2}}),define(Ee[157],Ce([1,0,61,13,125,16,7]),function(re,e,o,R,I,M,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XO=e.$WO=e.$VO=void 0;class p{constructor(b,C,y){const a=p.c.nextId();b.$registerTextEditorDecorationType(C.identifier,a,M.DecorationRenderOptions.from(y)),this.value=Object.freeze({key:a,dispose(){b.$removeTextEditorDecorationType(a)}})}}e.$VO=p,p.c=new I.$TO("TextEditorDecorationType");class ${constructor(b,C){this.g=[],this.h=void 0,this.j=!1,this.c=b,this.d=b.version,this.e=C.undoStopBefore,this.f=C.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(b,C){this.k();let y=null;if(b instanceof O.$vM)y=new O.$wM(b,b);else if(b instanceof O.$wM)y=b;else throw new Error("Unrecognized location");this.l(y,C,!1)}insert(b,C){this.k(),this.l(new O.$wM(b,b),C,!0)}delete(b){this.k();let C=null;if(b instanceof O.$wM)C=b;else throw new Error("Unrecognized location");this.l(C,null,!0)}l(b,C,y){const a=this.c.validateRange(b);this.g.push({range:a,text:C,forceMoveMarkers:y})}setEndOfLine(b){if(this.k(),b!==O.EndOfLine.LF&&b!==O.EndOfLine.CRLF)throw(0,R.$7)("endOfLine");this.h=b}}class w{constructor(b,C,y,a){this.c=b,this.d=C,this._accept(y),this.e=a;const m=this;this.value={get tabSize(){return m.f},set tabSize(l){m.n(l)},get indentSize(){return m.g},set indentSize(l){m.p(l)},get insertSpaces(){return m.j},set insertSpaces(l){m.s(l)},get cursorStyle(){return m.k},set cursorStyle(l){m.t(l)},get lineNumbers(){return m.l},set lineNumbers(l){m.u(l)}}}_accept(b){this.f=b.tabSize,this.g=b.indentSize,this.h=b.originalIndentSize,this.j=b.insertSpaces,this.k=b.cursorStyle,this.l=M.TextEditorLineNumbersStyle.to(b.lineNumbers)}m(b){if(b==="auto")return"auto";if(typeof b=="number"){const C=Math.floor(b);return C>0?C:null}if(typeof b=="string"){const C=parseInt(b,10);return isNaN(C)?null:C>0?C:null}return null}n(b){const C=this.m(b);if(C!==null){if(typeof C=="number"){if(this.f===C)return;this.f=C}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:C}))}}o(b){if(b==="tabSize")return"tabSize";if(typeof b=="number"){const C=Math.floor(b);return C>0?C:null}if(typeof b=="string"){const C=parseInt(b,10);return isNaN(C)?null:C>0?C:null}return null}p(b){const C=this.o(b);if(C!==null){if(typeof C=="number"){if(this.h===C)return;this.g=C,this.h=C}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:C}))}}q(b){return b==="auto"?"auto":b==="false"?!1:!!b}s(b){const C=this.q(b);if(typeof C=="boolean"){if(this.j===C)return;this.j=C}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:C}))}t(b){this.k!==b&&(this.k=b,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:b})))}u(b){this.l!==b&&(this.l=b,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:M.TextEditorLineNumbersStyle.from(b)})))}assign(b){const C={};let y=!1;if(typeof b.tabSize<"u"){const a=this.m(b.tabSize);a==="auto"?(y=!0,C.tabSize=a):typeof a=="number"&&this.f!==a&&(this.f=a,y=!0,C.tabSize=a)}if(typeof b.indentSize<"u"){const a=this.o(b.indentSize);a==="tabSize"?(y=!0,C.indentSize=a):typeof a=="number"&&this.h!==a&&(this.g=a,this.h=a,y=!0,C.indentSize=a)}if(typeof b.insertSpaces<"u"){const a=this.q(b.insertSpaces);a==="auto"?(y=!0,C.insertSpaces=a):this.j!==a&&(this.j=a,y=!0,C.insertSpaces=a)}typeof b.cursorStyle<"u"&&this.k!==b.cursorStyle&&(this.k=b.cursorStyle,y=!0,C.cursorStyle=b.cursorStyle),typeof b.lineNumbers<"u"&&this.l!==b.lineNumbers&&(this.l=b.lineNumbers,y=!0,C.lineNumbers=M.TextEditorLineNumbersStyle.from(b.lineNumbers)),y&&this.v("setOptions",this.c.$trySetOptions(this.d,C))}v(b,C){C.catch(y=>{this.e.warn(`ExtHostTextEditorOptions '${b}' failed:'`),this.e.warn(y)})}}e.$WO=w;class A{constructor(b,C,y,a,m,l,i,n){this.id=b,this.j=C,this.k=y,this.g=!1,this.h=new Set,this.c=m,this.d=new w(this.j,this.id,l,y),this.e=i,this.f=n;const r=this;this.value=Object.freeze({get document(){return a.value},set document(s){throw new R.$9("document")},get selection(){return r.c&&r.c[0]},set selection(s){if(!(s instanceof O.$xM))throw(0,R.$7)("selection");r.c=[s],r.l()},get selections(){return r.c},set selections(s){if(!Array.isArray(s)||s.some(t=>!(t instanceof O.$xM)))throw(0,R.$7)("selections");r.c=s,r.l()},get visibleRanges(){return r.e},set visibleRanges(s){throw new R.$9("visibleRanges")},get options(){return r.d.value},set options(s){r.g||r.d.assign(s)},get viewColumn(){return r.f},set viewColumn(s){throw new R.$9("viewColumn")},edit(s,t={undoStopBefore:!0,undoStopAfter:!0}){if(r.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const g=new $(a.value,t);return s(g),r.m(g)},insertSnippet(s,t,g={undoStopBefore:!0,undoStopAfter:!0}){if(r.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let d;if(!t||Array.isArray(t)&&t.length===0)d=r.c.map(h=>M.Range.from(h));else if(t instanceof O.$vM){const{lineNumber:h,column:c}=M.Position.from(t);d=[{startLineNumber:h,startColumn:c,endLineNumber:h,endColumn:c}]}else if(t instanceof O.$wM)d=[M.Range.from(t)];else{d=[];for(const h of t)if(h instanceof O.$wM)d.push(M.Range.from(h));else{const{lineNumber:c,column:u}=M.Position.from(h);d.push({startLineNumber:c,startColumn:u,endLineNumber:c,endColumn:u})}}return C.$tryInsertSnippet(b,a.value.version,s.value,d,g)},setDecorations(s,t){const g=t.length===0;g&&!r.h.has(s.key)||(g?r.h.delete(s.key):r.h.add(s.key),r.n(()=>{if(M.$LO(t))return C.$trySetDecorations(b,s.key,M.$MO(t));{const d=new Array(4*t.length);for(let h=0,c=t.length;h<c;h++){const u=t[h];d[4*h]=u.start.line+1,d[4*h+1]=u.start.character+1,d[4*h+2]=u.end.line+1,d[4*h+3]=u.end.character+1}return C.$trySetDecorationsFast(b,s.key,d)}}))},revealRange(s,t){r.n(()=>C.$tryRevealRange(b,M.Range.from(s),t||O.TextEditorRevealType.Default))},show(s){C.$tryShowEditor(b,M.ViewColumn.from(s))},hide(){C.$tryHideEditor(b)}})}dispose(){(0,o.ok)(!this.g),this.g=!0}_acceptOptions(b){(0,o.ok)(!this.g),this.d._accept(b)}_acceptVisibleRanges(b){(0,o.ok)(!this.g),this.e=b}_acceptViewColumn(b){(0,o.ok)(!this.g),this.f=b}_acceptSelections(b){(0,o.ok)(!this.g),this.c=b}async l(){const b=this.c.map(M.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,b)),this.value}m(b){const C=b.finalize();if(C.edits.length===0&&!C.setEndOfLine)return Promise.resolve(!0);const y=C.edits.map(m=>m.range);y.sort((m,l)=>m.end.line===l.end.line?m.end.character===l.end.character?m.start.line===l.start.line?m.start.character-l.start.character:m.start.line-l.start.line:m.end.character-l.end.character:m.end.line-l.end.line);for(let m=0,l=y.length-1;m<l;m++){const i=y[m].end;if(y[m+1].start.isBefore(i))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const a=C.edits.map(m=>({range:M.Range.from(m.range),text:m.text,forceMoveMarkers:m.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,C.documentVersionId,a,{setEndOfLine:typeof C.setEndOfLine=="number"?M.EndOfLine.from(C.setEndOfLine):void 0,undoStopBefore:C.undoStopBefore,undoStopAfter:C.undoStopAfter})}n(b){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):b().then(()=>this,C=>(C instanceof Error&&C.name==="DISPOSED"||this.k.warn(C),null))}}e.$XO=A}),define(Ee[72],Ce([1,0,61,4,3,2,5,6,153,20,157,16,12,27,15,39,46]),function(re,e,o,R,I,M,O,p,$,w,A,P,b,C,y,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZO=e.$YO=void 0;class l{constructor(r){this.value=r,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let i=class{constructor(r,s){this.h=r,this.i=s,this.a=null,this.b=new Map,this.c=new C.$Bc,this.d=new R.$7d,this.e=new R.$7d,this.f=new R.$7d,this.g=new R.$7d,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(r){this.acceptDocumentsAndEditorsDelta(r)}acceptDocumentsAndEditorsDelta(r){const s=[],t=[],g=[];if(r.removedDocuments)for(const d of r.removedDocuments){const h=M.URI.revive(d),c=this.c.get(h);c?.unref()&&(this.c.delete(h),s.push(c.value))}if(r.addedDocuments)for(const d of r.addedDocuments){const h=M.URI.revive(d.uri);let c=this.c.get(h);if(c&&h.scheme!==y.Schemas.vscodeNotebookCell&&h.scheme!==y.Schemas.vscodeInteractiveInput)throw new Error(`document '${h} already exists!'`);c||(c=new l(new $.$RO(this.h.getProxy(p.$sM.MainThreadDocuments),h,d.lines,d.EOL,d.versionId,d.languageId,d.isDirty)),this.c.set(h,c),t.push(c.value)),c.ref()}if(r.removedEditors)for(const d of r.removedEditors){const h=this.b.get(d);this.b.delete(d),h&&g.push(h)}if(r.addedEditors)for(const d of r.addedEditors){const h=M.URI.revive(d.documentUri);o.ok(this.c.has(h),`document '${h}' does not exist`),o.ok(!this.b.has(d.id),`editor '${d.id}' already exists!`);const c=this.c.get(h).value,u=new A.$XO(d.id,this.h.getProxy(p.$sM.MainThreadTextEditors),this.i,new m.$V(()=>c.document),d.selections.map(P.Selection.to),d.options,d.visibleRanges.map(f=>P.Range.to(f)),typeof d.editorPosition=="number"?P.ViewColumn.to(d.editorPosition):void 0);this.b.set(d.id,u)}r.newActiveEditor!==void 0&&(o.ok(r.newActiveEditor===null||this.b.has(r.newActiveEditor),`active editor '${r.newActiveEditor}' does not exist`),this.a=r.newActiveEditor),(0,I.$Pc)(s),(0,I.$Pc)(g),r.removedDocuments&&this.e.fire(s),r.addedDocuments&&this.d.fire(t),(r.removedEditors||r.addedEditors)&&this.f.fire(this.allEditors().map(d=>d.value)),r.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(r){return this.c.get(r)?.value}allDocuments(){return a.Iterable.map(this.c.values(),r=>r.value)}getEditor(r){return this.b.get(r)}activeEditor(r){if(!this.a)return;const s=this.b.get(this.a);return r?s:s?.value}allEditors(){return[...this.b.values()]}};e.$YO=i,e.$YO=i=Qe([He(0,w.$OO),He(1,b.$Oj)],i),e.$ZO=(0,O.$ii)("IExtHostDocumentsAndEditors")}),define(Ee[354],Ce([1,0,19,4,6,157,16,7]),function(re,e,o,R,I,M,O,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sjc=void 0;class ${constructor(A,P){this.i=P,this.a=new R.$7d,this.b=new R.$7d,this.c=new R.$7d,this.d=new R.$7d,this.f=new R.$7d,this.g=new R.$7d,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=A.getProxy(I.$sM.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(b=>this.g.fire(b)),this.i.onDidChangeActiveTextEditor(b=>this.f.fire(b))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(A){const P=this.i.allEditors();return A?P:P.map(b=>b.value)}async showTextDocument(A,P,b){let C;typeof P=="number"?C={position:O.ViewColumn.from(P),preserveFocus:b}:typeof P=="object"?C={position:O.ViewColumn.from(P.viewColumn),preserveFocus:P.preserveFocus,selection:typeof P.selection=="object"?O.Range.from(P.selection):void 0,pinned:typeof P.preview=="boolean"?!P.preview:void 0}:C={preserveFocus:!1};const y=await this.h.$tryShowTextDocument(A.uri,C),a=y&&this.i.getEditor(y);if(a)return a.value;throw y?new Error(`Could NOT open editor for "${A.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${A.uri.toString()}".`)}createTextEditorDecorationType(A,P){return new M.$VO(this.h,A,P).value}$acceptEditorPropertiesChanged(A,P){const b=this.i.getEditor(A);if(!b)throw new Error("unknown text editor");if(P.options&&b._acceptOptions(P.options),P.selections){const C=P.selections.selections.map(O.Selection.to);b._acceptSelections(C)}if(P.visibleRanges){const C=o.$Hb(P.visibleRanges.map(O.Range.to));b._acceptVisibleRanges(C)}if(P.options&&this.b.fire({textEditor:b.value,options:{...P.options,lineNumbers:O.TextEditorLineNumbersStyle.to(P.options.lineNumbers)}}),P.selections){const C=p.TextEditorSelectionChangeKind.fromValue(P.selections.source),y=P.selections.selections.map(O.Selection.to);this.a.fire({textEditor:b.value,selections:y,kind:C})}if(P.visibleRanges){const C=o.$Hb(P.visibleRanges.map(O.Range.to));this.c.fire({textEditor:b.value,visibleRanges:C})}}$acceptEditorPositionData(A){for(const P in A){const b=this.i.getEditor(P);if(!b)throw new Error("Unknown text editor");const C=O.ViewColumn.to(A[P]);b.value.viewColumn!==C&&(b._acceptViewColumn(C),this.d.fire({textEditor:b.value,viewColumn:C}))}}getDiffInformation(A){return Promise.resolve(this.h.$getDiffInformation(A))}}e.$Sjc=$}),define(Ee[355],Ce([1,0,2,5,6,3,7,16,25,18]),function(re,e,o,R,I,M,O,p,$,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zlc=e.$ylc=void 0,e.$ylc=(0,R.$ii)("IExtHostTimeline");class A{constructor(C,y){this.b=new Map,this.c=new Map,this.a=C.getProxy(I.$sM.MainThreadTimeline),y.registerArgumentProcessor({processArgument:(a,m)=>{if(a&&a.$mid===12)if(this.b.get(a.source)&&$.$Em.equals(m,this.b.get(a.source)?.extension)){const l=a.uri===void 0?void 0:o.URI.revive(a.uri);return this.c.get(a.source)?.get(P(l))?.get(a.handle)}else return;return a}})}async $getTimeline(C,y,a,m){return this.b.get(C)?.provider.provideTimeline(o.URI.revive(y),a,m)}registerTimelineProvider(C,y,a,m){const l=new M.$Tc,i=this.d(y.id,m,l).bind(this);let n;y.onDidChange&&(n=y.onDidChange(s=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...s,id:y.id}),this));const r=this.c;return this.f({...y,scheme:C,onDidChange:void 0,async provideTimeline(s,t,g){t?.resetCache&&(l.clear(),r.get(y.id)?.clear());const d=await y.provideTimeline(s,t,g);if(d==null)return;const h=i(s,t);return{...d,source:y.id,items:d.items.map(h)}},dispose(){for(const s of r.values())s.get(y.id)?.clear();n?.dispose(),l.dispose()}},a)}d(C,y,a){return(m,l)=>{let i;if(l?.cacheResults){let n=this.c.get(C);n===void 0&&(n=new Map,this.c.set(C,n));const r=P(m);i=n.get(r),i===void 0&&(i=new Map,n.set(r,i))}return n=>{const{iconPath:r,...s}=n,t=`${C}|${n.id??n.timestamp}`;i?.set(t,n);let g,d,h;n.iconPath&&(r instanceof O.$qN?h={id:r.id,color:r.color}:o.URI.isUri(r)?(g=r,d=r):{light:g,dark:d}=r);let c;return O.$VM.isMarkdownString(s.tooltip)?c=p.MarkdownString.from(s.tooltip):(0,w.$Vf)(s.tooltip)?c=s.tooltip:O.$VM.isMarkdownString(s.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),c=p.MarkdownString.from(s.detail)):(0,w.$Vf)(s.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),c=s.detail),{...s,id:s.id??void 0,handle:t,source:C,command:n.command?y.toInternal(n.command,a):void 0,icon:g,iconDark:d,themeIcon:h,tooltip:c,accessibilityInformation:n.accessibilityInformation}}}}f(C,y){if(this.b.get(C.id))throw new Error(`Timeline Provider ${C.id} already exists.`);return this.a.$registerTimelineProvider({id:C.id,label:C.label,scheme:C.scheme}),this.b.set(C.id,{provider:C,extension:y}),(0,M.$Sc)(()=>{for(const m of this.c.values())m.get(C.id)?.clear();this.b.delete(C.id),this.a.$unregisterTimelineProvider(C.id),C.dispose()})}}e.$zlc=A;function P(b){return b?.toString()}}),define(Ee[356],Ce([1,0,228,23,2,4,3,287,8,7,18,19,16,79,22,194,26]),function(re,e,o,R,I,M,O,p,$,w,A,P,b,C,y,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Alc=void 0;function l(r,s){if((0,A.$Vf)(r))return{label:r};if(r&&typeof r=="object"&&typeof r.label=="string"){let t;return Array.isArray(r.highlights)&&(t=r.highlights.filter(g=>g.length===2&&typeof g[0]=="number"&&typeof g[1]=="number"),t=t.length?t:void 0),{label:r.label,highlights:t}}}class i extends O.$Uc{constructor(s,t,g){super(),this.f=s,this.g=t,this.h=g,this.a=new Map,this.b=new a.$q0;function d(h){return h&&h.$treeViewId&&(h.$treeItemHandle||h.$selectedTreeItems||h.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:h=>d(h)?this.r(h):Array.isArray(h)&&h.length>0?h.map(c=>d(c)?this.r(c):c):h})}registerTreeDataProvider(s,t,g){const d=this.createTreeView(s,{treeDataProvider:t},g);return{dispose:()=>d.dispose()}}createTreeView(s,t,g){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const d=t.dragAndDropController?.dropMimeTypes??[],h=t.dragAndDropController?.dragMimeTypes??[],c=!!t.dragAndDropController?.handleDrag,u=!!t.dragAndDropController?.handleDrop,f=this.m(s,t,g),E={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:d,dragMimeTypes:h,hasHandleDrag:c,hasHandleDrop:u,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},v=this.f.$registerTreeViewDataProvider(s,E),D={get onDidCollapseElement(){return f.onDidCollapseElement},get onDidExpandElement(){return f.onDidExpandElement},get selection(){return f.selectedElements},get onDidChangeSelection(){return f.onDidChangeSelection},get activeItem(){return(0,m.$dG)(g,"treeViewActiveItem"),f.focusedElement},get onDidChangeActiveItem(){return(0,m.$dG)(g,"treeViewActiveItem"),f.onDidChangeActiveItem},get visible(){return f.visible},get onDidChangeVisibility(){return f.onDidChangeVisibility},get onDidChangeCheckboxState(){return f.onDidChangeCheckboxState},get message(){return f.message},set message(k){(0,C.$Hk)(k)&&(0,m.$dG)(g,"treeViewMarkdownMessage"),f.message=k},get title(){return f.title},set title(k){f.title=k},get description(){return f.description},set description(k){f.description=k},get badge(){return f.badge},set badge(k){k!==void 0&&w.ViewBadge.isViewBadge(k)?f.badge={value:Math.floor(Math.abs(k.value)),tooltip:k.tooltip}:k===void 0&&(f.badge=void 0)},reveal:(k,S)=>f.reveal(k,S),dispose:async()=>{await v,this.a.delete(s),f.dispose()}};return this.B(D),D}$getChildren(s,t){const g=this.a.get(s);return g?g.getChildren(t):Promise.reject(new p.$GF(s))}async $handleDrop(s,t,g,d,h,c,u,f){const E=this.a.get(s);if(!E)return Promise.reject(new p.$GF(s));const v=b.DataTransfer.toDataTransfer(g,async D=>(await this.f.$resolveDropFileData(s,t,D)).buffer);return u===s&&f&&await this.j(v,E,f,h,c),E.onDrop(v,d,h)}async j(s,t,g,d,h){const c=this.b.removeDragOperationTransfer(h);if(c)(await c)?.forEach((u,f)=>{u&&s.set(f,u)});else if(h&&t.handleDrag){const u=t.handleDrag(g,s,d);this.b.addDragOperationTransfer(h,u),await u}return s}async $handleDrag(s,t,g,d){const h=this.a.get(s);if(!h)return Promise.reject(new p.$GF(s));const c=await this.j(new w.$mN,h,t,d,g);if(!(!c||d.isCancellationRequested))return b.DataTransfer.from(c)}async $hasResolve(s){const t=this.a.get(s);if(!t)throw new p.$GF(s);return t.hasResolve}$resolve(s,t,g){const d=this.a.get(s);if(!d)throw new p.$GF(s);return d.resolveTreeItem(t,g)}$setExpanded(s,t,g){const d=this.a.get(s);if(!d)throw new p.$GF(s);d.setExpanded(t,g)}$setSelectionAndFocus(s,t,g){const d=this.a.get(s);if(!d)throw new p.$GF(s);d.setSelectionAndFocus(t,g)}$setVisible(s,t){const g=this.a.get(s);if(!g){if(!t)return;throw new p.$GF(s)}g.setVisible(t)}$changeCheckboxState(s,t){const g=this.a.get(s);if(!g)throw new p.$GF(s);g.setCheckboxState(t)}m(s,t,g){const d=this.B(new n(s,t,this.f,this.g.converter,this.h,g));return this.a.set(s,d),d}r(s){const t=this.a.get(s.$treeViewId);return t&&"$treeItemHandle"in s?t.getExtensionElement(s.$treeItemHandle):t&&"$focusedTreeItem"in s&&s.$focusedTreeItem?t.focusedElement:null}}e.$Alc=i;class n extends O.$Uc{get visible(){return this.r}get selectedElements(){return this.s.map(s=>this.getExtensionElement(s)).filter(s=>!(0,A.$5f)(s))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(s,t,g,d,h,c){if(super(),this.I=s,this.J=g,this.L=d,this.M=h,this.N=c,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new M.$7d),this.onDidExpandElement=this.u.event,this.w=this.B(new M.$7d),this.onDidCollapseElement=this.w.event,this.y=this.B(new M.$7d),this.onDidChangeSelection=this.y.event,this.z=this.B(new M.$7d),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new M.$7d),this.onDidChangeVisibility=this.C.event,this.D=this.B(new M.$7d),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new M.$7d),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new y.$ee,c.contributes&&c.contributes.views)for(const v in c.contributes.views)for(const D of c.contributes.views[v])D.id===s&&(this.P=D.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(v=>this.F.fire({message:!1,element:v})));let u,f;const E=M.Event.debounce(this.F.event,(v,D)=>(v||(v={message:!1,elements:[]}),D.element!==!1&&(u||(u=new Promise(k=>f=k),this.G=this.G.then(()=>u)),Array.isArray(D.element)?v.elements.push(...D.element):v.elements.push(D.element)),D.message&&(v.message=!0),v),200,!0);this.B(E(({message:v,elements:D})=>{D.length&&(this.H=this.H.then(()=>{const k=f;return u=null,this.$(D).then(()=>k())})),v&&this.J.$setMessage(this.I,b.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(s){const t=s?this.getExtensionElement(s):void 0;if(s&&!t)return this.M.error(`No tree item with id '${s}' found.`),Promise.resolve([]);let g=this.X(s);return g||(g=await this.Y(t)),g?g.map(d=>d.item):void 0}getExtensionElement(s){return this.j.get(s)}reveal(s,t){t=t||{select:!0,focus:!1};const g=(0,A.$5f)(t.select)?!0:t.select,d=(0,A.$5f)(t.focus)?!1:t.focus,h=(0,A.$5f)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):s?this.G.then(()=>this.S(s)).then(c=>this.W(s,c[c.length-1]).then(u=>this.J.$reveal(this.I,{item:u.item,parentChain:c.map(f=>f.item)},{select:g,focus:d,expand:h})),c=>this.M.error(c)):this.J.$reveal(this.I,void 0,{select:g,focus:d,expand:h})}get message(){return this.O}set message(s){this.O=s,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(s){this.P=s,this.J.$setTitle(this.I,s,this.Q)}get description(){return this.Q}set description(s){this.Q=s,this.J.$setTitle(this.I,this.P,s)}get badge(){return this.R}set badge(s){this.R?.value===s?.value&&this.R?.tooltip===s?.tooltip||(this.R=b.ViewBadge.from(s),this.J.$setBadge(this.I,s))}setExpanded(s,t){const g=this.getExtensionElement(s);g&&(t?this.u.fire(Object.freeze({element:g})):this.w.fire(Object.freeze({element:g})))}setSelectionAndFocus(s,t){const g=!(0,P.$ub)(this.s,s);this.s=s;const d=this.t!==t;this.t=t,g&&this.y.fire(Object.freeze({selection:this.selectedElements})),d&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(s){s!==this.r&&(this.r=s,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(s){const t=(await Promise.all(s.map(async g=>{const d=this.getExtensionElement(g.treeItemHandle);return d?{extensionItem:d,treeItem:await this.f.getTreeItem(d),newState:g.newState?w.TreeItemCheckboxState.Checked:w.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(g=>g!==void 0);t.forEach(g=>{g.treeItem.checkboxState=g.newState?w.TreeItemCheckboxState.Checked:w.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(g=>[g.extensionItem,g.newState])})}async handleDrag(s,t,g){const d=[];for(const h of s){const c=this.getExtensionElement(h);c&&d.push(c)}if(!(!this.g?.handleDrag||d.length===0))return await this.g.handleDrag(d,t,g),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(s,t,g){const d=t?this.getExtensionElement(t):void 0;if(!(!d&&t||!this.g?.handleDrop))return(0,$.$ah)(()=>this.g?.handleDrop?this.g.handleDrop(d,s,g):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(s,t){if(!this.f.resolveTreeItem)return;const g=this.j.get(s);if(g){const d=this.m.get(g);if(d){const h=await this.f.resolveTreeItem(d.extensionItem,g,t)??d.extensionItem;return this.hb(h),d.item.tooltip=this.eb(h.tooltip),d.item.command=this.fb(d.disposableStore,h.command),d.item}}}S(s){return this.U(s).then(t=>t?this.S(t).then(g=>this.W(t,g[g.length-1]).then(d=>(g.push(d),g))):Promise.resolve([]))}U(s){const t=this.m.get(s);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,$.$ah)(()=>this.f.getParent(s))}W(s,t){const g=this.m.get(s);return g?Promise.resolve(g):(0,$.$ah)(()=>this.f.getTreeItem(s)).then(d=>this.kb(s,d,t,!0)).then(d=>this.getChildren(t?t.item.handle:void 0).then(()=>{const h=this.getExtensionElement(d);if(h){const c=this.m.get(h);if(c)return Promise.resolve(c)}throw new Error(`Cannot resolve tree item for element ${d} from extension ${this.N.identifier.value}`)}))}X(s){if(s){let t;if(typeof s=="string"){const g=this.getExtensionElement(s);t=g?this.m.get(g):void 0}else t=s;return t&&t.children||void 0}return this.h}async Y(s){this.rb(s);const t=new y.$ee(this.Z.token);try{const g=s?this.m.get(s):void 0,d=await this.f.getChildren(s);if(t.token.isCancellationRequested)return;const h=(0,P.$Hb)(d||[]),c=await Promise.all((0,P.$Hb)(h).map(f=>this.f.getTreeItem(f)));if(t.token.isCancellationRequested)return;const u=c.map((f,E)=>f?this.db(h[E],f,g):null);return(0,P.$Hb)(u)}finally{t.dispose()}}$(s){if(s.some(g=>!g))return this.Z.dispose(!0),this.Z=new y.$ee,this.tb(),this.J.$refresh(this.I);{const g=this.ab(s);if(g.length)return this.bb(g)}return Promise.resolve(void 0)}ab(s){const t=new Set,g=s.map(h=>this.m.get(h));for(const h of g)if(h&&!t.has(h.item.handle)){let c=h;for(;c&&c.parent&&g.findIndex(u=>c&&c.parent&&u&&u.item.handle===c.parent.item.handle)===-1;){const u=this.j.get(c.parent.item.handle);c=u?this.m.get(u):void 0}c&&!c.parent&&t.add(h.item.handle)}const d=[];return t.forEach(h=>{const c=this.j.get(h);if(c){const u=this.m.get(c);u&&(!u.parent||!t.has(u.parent.item.handle))&&d.push(h)}}),d}bb(s){const t={};return Promise.all(s.map(g=>this.cb(g).then(d=>{d&&(t[g]=d.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(s){const t=this.getExtensionElement(s);if(t){const g=this.m.get(t);if(g)return this.rb(t),(0,$.$ah)(()=>this.f.getTreeItem(t)).then(d=>{if(d){const h=this.ib(t,d,g.parent);return this.pb(t,h,g,g.parent),g.dispose(),h}return null})}return Promise.resolve(null)}db(s,t,g){const d=this.ib(s,t,g);if(t.id&&this.j.has(d.item.handle))throw new Error((0,o.localize)(0,null,t.id));return this.ob(s,d),this.qb(d,g),d}eb(s){return w.$VM.isMarkdownString(s)?b.MarkdownString.from(s):s}fb(s,t){return t?{...this.L.toInternal(t,s),originalId:t.command}:void 0}gb(s){if(s.checkboxState===void 0)return;let t,g,d;return typeof s.checkboxState=="number"?t=s.checkboxState:(t=s.checkboxState.state,g=s.checkboxState.tooltip,d=s.checkboxState.accessibilityInformation),{isChecked:t===w.TreeItemCheckboxState.Checked,tooltip:g,accessibilityInformation:d}}hb(s){if(!w.$hN.isTreeItem(s,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(s,t,g){this.hb(t);const d=this.B(new O.$Tc),h=this.kb(s,t,g),c=this.lb(t);return{item:{handle:h,parentHandle:g?g.item.handle:void 0,label:l(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(d,t.command),contextValue:t.contextValue,icon:c,iconDark:this.mb(t)||c,themeIcon:this.jb(t),collapsibleState:(0,A.$5f)(t.collapsibleState)?w.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:g,children:void 0,disposableStore:d,dispose(){d.dispose()}}}jb(s){return s.iconPath instanceof w.$qN?s.iconPath:void 0}kb(s,{id:t,label:g,resourceUri:d},h,c){if(t)return`${n.b}/${t}`;const u=l(g,this.N),f=h?h.item.handle:n.a;let E=u?u.label:d?(0,R.$Sg)(d):"";E=E.indexOf("/")!==-1?E.replace("/","//"):E;const v=this.m.has(s)?this.m.get(s).item.handle:void 0,D=this.X(h)||[];let k,S=0;do{if(k=`${f}/${S}:${E}`,c||!this.j.has(k)||v===k)break;S++}while(S<=D.length);return k}lb(s){if(s.iconPath&&!(s.iconPath instanceof w.$qN))return typeof s.iconPath=="string"||I.URI.isUri(s.iconPath)?this.nb(s.iconPath):this.nb(s.iconPath.light)}mb(s){if(s.iconPath&&!(s.iconPath instanceof w.$qN)&&s.iconPath.dark)return this.nb(s.iconPath.dark)}nb(s){return I.URI.isUri(s)?s:I.URI.file(s)}ob(s,t){this.j.set(t.item.handle,s),this.m.set(s,t)}pb(s,t,g,d){this.j.delete(t.item.handle),this.m.delete(s),t.item.handle!==g.item.handle&&this.j.delete(g.item.handle),this.ob(s,t);const h=this.X(d)||[],c=h.filter(u=>u.item.handle===g.item.handle)[0];c&&h.splice(h.indexOf(c),1,t)}qb(s,t){t?(t.children||(t.children=[]),t.children.push(s)):(this.h||(this.h=[]),this.h.push(s))}rb(s){if(s){const t=this.m.get(s);if(t){if(t.children)for(const g of t.children){const d=this.j.get(g.item.handle);d&&this.sb(d)}t.children=void 0}}else this.tb()}sb(s){const t=this.m.get(s);if(t){if(t.children)for(const g of t.children){const d=this.j.get(g.item.handle);d&&this.sb(d)}this.m.delete(s),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(s=>s.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}n.a="0",n.b="1"});var it=this&&this.__classPrivateFieldSet||function(re,e,o,R,I){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!I:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?I.call(re,o):I?I.value=o:e.set(re,o),o},qe=this&&this.__classPrivateFieldGet||function(re,e,o,R){if(o==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!R:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?R:o==="a"?R.call(re):R?R.value:e.get(re)};define(Ee[357],Ce([1,0,4,3,2,30,16,92,6,7]),function(re,e,o,R,I,M,O,p,$,w){"use strict";var A,P,b,C,y,a,m,l,i,n,r,s,t;Object.defineProperty(e,"__esModule",{value:!0}),e.$_jc=void 0;class g extends R.$Uc{constructor(u,f,E,v){super(),A.set(this,void 0),P.set(this,void 0),b.set(this,void 0),C.set(this,void 0),y.set(this,void 0),a.set(this,void 0),m.set(this,void 0),l.set(this,void 0),i.set(this,!0),n.set(this,void 0),r.set(this,!1),s.set(this,this.B(new o.$7d)),this.onDidDispose=qe(this,s,"f").event,t.set(this,this.B(new o.$7d)),this.onDidChangeViewState=qe(this,t,"f").event,it(this,A,u,"f"),it(this,P,f,"f"),it(this,C,E,"f"),it(this,b,v.viewType,"f"),it(this,y,v.panelOptions,"f"),it(this,l,v.viewColumn,"f"),it(this,a,v.title,"f"),it(this,n,v.active,"f")}dispose(){qe(this,r,"f")||(it(this,r,!0,"f"),qe(this,s,"f").fire(),qe(this,P,"f").$disposeWebview(qe(this,A,"f")),qe(this,C,"f").dispose(),super.dispose())}get webview(){return this.c(),qe(this,C,"f")}get viewType(){return this.c(),qe(this,b,"f")}get title(){return this.c(),qe(this,a,"f")}set title(u){this.c(),qe(this,a,"f")!==u&&(it(this,a,u,"f"),qe(this,P,"f").$setTitle(qe(this,A,"f"),u))}get iconPath(){return this.c(),qe(this,m,"f")}set iconPath(u){this.c(),qe(this,m,"f")!==u&&(it(this,m,u,"f"),qe(this,P,"f").$setIconPath(qe(this,A,"f"),I.URI.isUri(u)?{light:u,dark:u}:u))}get options(){return qe(this,y,"f")}get viewColumn(){if(this.c(),!(typeof qe(this,l,"f")=="number"&&qe(this,l,"f")<0))return qe(this,l,"f")}get active(){return this.c(),qe(this,n,"f")}get visible(){return this.c(),qe(this,i,"f")}_updateViewState(u){qe(this,r,"f")||(this.active!==u.active||this.visible!==u.visible||this.viewColumn!==u.viewColumn)&&(it(this,n,u.active,"f"),it(this,i,u.visible,"f"),it(this,l,u.viewColumn,"f"),qe(this,t,"f").fire({webviewPanel:this}))}reveal(u,f){this.c(),qe(this,P,"f").$reveal(qe(this,A,"f"),{viewColumn:typeof u>"u"?void 0:O.ViewColumn.from(u),preserveFocus:!!f})}c(){if(qe(this,r,"f"))throw new Error("Webview is disposed")}}A=new WeakMap,P=new WeakMap,b=new WeakMap,C=new WeakMap,y=new WeakMap,a=new WeakMap,m=new WeakMap,l=new WeakMap,i=new WeakMap,n=new WeakMap,r=new WeakMap,s=new WeakMap,t=new WeakMap;class d extends R.$Uc{static c(){return(0,M.$Eg)()}constructor(u,f,E){super(),this.j=f,this.m=E,this.g=new Map,this.h=new Map,this.f=u.getProxy($.$sM.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(u=>u.dispose()),this.g.clear()}createWebviewPanel(u,f,E,v,D={}){const k=typeof v=="object"?v.viewColumn:v,S={viewColumn:O.ViewColumn.from(k),preserveFocus:typeof v=="object"&&!!v.preserveFocus},F=(0,p.$8jc)(u),W=d.c();this.f.$createWebviewPanel((0,p.$0jc)(u),W,f,{title:E,panelOptions:h(D),webviewOptions:(0,p.$$jc)(u,this.m,D),serializeBuffersForPostMessage:F},S);const B=this.j.createNewWebview(W,D,u);return this.createNewWebviewPanel(W,f,E,k,D,B,!0)}$onDidChangeWebviewPanelViewStates(u){const f=Object.keys(u);f.sort((E,v)=>{const D=u[E],k=u[v];return D.active?1:k.active?-1:+D.visible-+k.visible});for(const E of f){const v=this.getWebviewPanel(E);if(!v)continue;const D=u[E];v._updateViewState({active:D.active,visible:D.visible,viewColumn:O.ViewColumn.to(D.position)})}}async $onDidDisposeWebviewPanel(u){this.getWebviewPanel(u)?.dispose(),this.g.delete(u),this.j.deleteWebview(u)}registerWebviewPanelSerializer(u,f,E){if(this.h.has(f))throw new Error(`Serializer for '${f}' already registered`);return this.h.set(f,{serializer:E,extension:u}),this.f.$registerSerializer(f,{serializeBuffersForPostMessage:(0,p.$8jc)(u)}),new w.$uM(()=>{this.h.delete(f),this.f.$unregisterSerializer(f)})}async $deserializeWebviewPanel(u,f,E,v){const D=this.h.get(f);if(!D)throw new Error(`No serializer found for '${f}'`);const{serializer:k,extension:S}=D,F=this.j.createNewWebview(u,E.webviewOptions,S),W=this.createNewWebviewPanel(u,f,E.title,v,E.panelOptions,F,E.active);await k.deserializeWebviewPanel(W,E.state)}createNewWebviewPanel(u,f,E,v,D,k,S){const F=new g(u,this.f,k,{viewType:f,title:E,viewColumn:v,panelOptions:D,active:S});return this.g.set(u,F),F}getWebviewPanel(u){return this.g.get(u)}}e.$_jc=d;function h(c){return{enableFindWidget:c.enableFindWidget,retainContextWhenHidden:c.retainContextWhenHidden}}});var it=this&&this.__classPrivateFieldSet||function(re,e,o,R,I){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!I:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?I.call(re,o):I?I.value=o:e.set(re,o),o},qe=this&&this.__classPrivateFieldGet||function(re,e,o,R){if(o==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!R:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?R:o==="a"?R.call(re):R?R.value:e.get(re)};define(Ee[358],Ce([1,0,4,3,92,16,6,7]),function(re,e,o,R,I,M,O,p){"use strict";var $,w,A,P,b,C,y,a,m,l,i;Object.defineProperty(e,"__esModule",{value:!0}),e.$Dlc=void 0;class n extends R.$Uc{constructor(t,g,d,h,c,u){super(),$.set(this,void 0),w.set(this,void 0),A.set(this,void 0),P.set(this,void 0),b.set(this,!1),C.set(this,void 0),y.set(this,void 0),a.set(this,void 0),m.set(this,void 0),l.set(this,this.B(new o.$7d)),this.onDidChangeVisibility=qe(this,l,"f").event,i.set(this,this.B(new o.$7d)),this.onDidDispose=qe(this,i,"f").event,it(this,A,d,"f"),it(this,y,h,"f"),it(this,$,t,"f"),it(this,w,g,"f"),it(this,P,c,"f"),it(this,C,u,"f")}dispose(){qe(this,b,"f")||(it(this,b,!0,"f"),qe(this,i,"f").fire(),qe(this,P,"f").dispose(),super.dispose())}get title(){return this.a(),qe(this,y,"f")}set title(t){this.a(),qe(this,y,"f")!==t&&(it(this,y,t,"f"),qe(this,w,"f").$setWebviewViewTitle(qe(this,$,"f"),t))}get description(){return this.a(),qe(this,a,"f")}set description(t){this.a(),qe(this,a,"f")!==t&&(it(this,a,t,"f"),qe(this,w,"f").$setWebviewViewDescription(qe(this,$,"f"),t))}get visible(){return qe(this,C,"f")}get webview(){return qe(this,P,"f")}get viewType(){return qe(this,A,"f")}_setVisible(t){t===qe(this,C,"f")||qe(this,b,"f")||(it(this,C,t,"f"),qe(this,l,"f").fire())}get badge(){return this.a(),qe(this,m,"f")}set badge(t){this.a(),!(t?.value===qe(this,m,"f")?.value&&t?.tooltip===qe(this,m,"f")?.tooltip)&&(it(this,m,M.ViewBadge.from(t),"f"),qe(this,w,"f").$setWebviewViewBadge(qe(this,$,"f"),t))}show(t){this.a(),qe(this,w,"f").$show(qe(this,$,"f"),!!t)}a(){if(qe(this,b,"f"))throw new Error("Webview is disposed")}}$=new WeakMap,w=new WeakMap,A=new WeakMap,P=new WeakMap,b=new WeakMap,C=new WeakMap,y=new WeakMap,a=new WeakMap,m=new WeakMap,l=new WeakMap,i=new WeakMap;class r{constructor(t,g){this.d=g,this.b=new Map,this.c=new Map,this.a=t.getProxy(O.$sM.MainThreadWebviewViews)}registerWebviewViewProvider(t,g,d,h){if(this.b.has(g))throw new Error(`View provider for '${g}' already registered`);return this.b.set(g,{provider:d,extension:t}),this.a.$registerWebviewViewProvider((0,I.$0jc)(t),g,{retainContextWhenHidden:h?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,I.$8jc)(t)}),new p.$uM(()=>{this.b.delete(g),this.a.$unregisterWebviewViewProvider(g)})}async $resolveWebviewView(t,g,d,h,c){const u=this.b.get(g);if(!u)throw new Error(`No view provider found for '${g}'`);const{provider:f,extension:E}=u,v=this.d.createNewWebview(t,{},E),D=new n(t,this.a,g,d,v,!0);this.c.set(t,D),await f.resolveWebviewView(D,{state:h},c)}async $onDidChangeWebviewViewVisibility(t,g){this.e(t)._setVisible(g)}async $disposeWebviewView(t){const g=this.e(t);this.c.delete(t),g.dispose(),this.d.deleteWebview(t)}e(t){const g=this.c.get(t);if(!g)throw new Error("No webview found");return g}}e.$Dlc=r}),define(Ee[359],Ce([1,0,69,15,12,259,32,11]),function(re,e,o,R,I,M,O,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kmc=void 0;let $=class{constructor(P,b){P.addFileSystemProvider(R.Schemas.file,new w(b),{isCaseSensitive:p.$e})}};e.$kmc=$,e.$kmc=$=Qe([He(0,o.$4jc),He(1,I.$Oj)],$);class w{constructor(P){this.b=P,this.a=new M.$Wq(this.b)}async stat(P){const b=await this.a.stat(P);return{type:b.type,ctime:b.ctime,mtime:b.mtime,size:b.size,permissions:b.permissions===O.FilePermission.Readonly?1:void 0}}readDirectory(P){return this.a.readdir(P)}createDirectory(P){return this.a.mkdir(P)}readFile(P){return this.a.readFile(P)}writeFile(P,b,C){return this.a.writeFile(P,b,{...C,unlock:!1,atomic:!1})}delete(P,b){return this.a.delete(P,{...b,useTrash:!1,atomic:!1})}rename(P,b,C){return this.a.rename(P,b,C)}copy(P,b,C){return this.a.copy(P,b,C)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(P,b){throw new Error("Method not implemented.")}}}),define(Ee[360],Ce([1,0,17,62,30,33,3,6,2,20]),function(re,e,o,R,I,M,O,p,$,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$imc=void 0;let A=class extends O.$Uc{constructor(b,C){super();const y=b.getProxy(p.$sM.MainThreadDownloadService);C.registerCommand(!1,"_workbench.downloadResource",async a=>{const m=$.URI.file((0,o.$kc)((0,R.tmpdir)(),(0,I.$Eg)()));return await y.$download(a,m),m})}};e.$imc=A,e.$imc=A=Qe([He(0,w.$OO),He(1,M.$$O)],A)}),define(Ee[361],Ce([1,0,50,17,2,93,3,15,8,31]),function(re,e,o,R,I,M,O,p,$,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$umc=void 0;class A extends M.$6jc{constructor(){super(...arguments),this.i=null}async g(t){const g=await super.g(t);if(g.scheme!==p.Schemas.file)return g;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${g.fsPath}.`),g;const d=g.fsPath;let h=0;do{let c;h===0?c=d:c=/[/\\]$/.test(d)?`${d.substr(0,d.length-1)}-${h}`:`${d}-${h}`,await P(c);const u=R.$kc(c,"vscode.lock"),f=await a(this.d,u,!1);if(f)return this.i=f,process.on("exit",()=>{f.dispose()}),I.URI.file(c);h++}while(h<10);return g}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$umc=A;async function P(s){try{await w.Promises.stat(s);return}catch{}try{await w.Promises.mkdir(s,{recursive:!0})}catch{}}const b=1e3,C=10*60*1e3;class y extends O.$Uc{constructor(t,g){super(),this.b=t,this.c=g,this.a=this.B(new $.$th),this.a.cancelAndSet(async()=>{const d=await m(t,g);(!d||d.pid!==process.pid)&&(t.info(`Lock '${g}': The lock was lost unexpectedly.`),this.a.cancel());try{await w.Promises.utimes(g,new Date,new Date)}catch(h){t.error(h),t.info(`Lock '${g}': Could not update mtime.`)}},b)}dispose(){super.dispose();try{o.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const g={pid:process.pid,willReleaseAt:Date.now()+t};await w.Promises.writeFile(this.c,JSON.stringify(g),{flag:"w"})}catch(g){this.b.error(g)}}}async function a(s,t,g){try{const h={pid:process.pid,willReleaseAt:0};await w.Promises.writeFile(t,JSON.stringify(h),{flag:"wx"})}catch(h){s.error(h)}const d=await m(s,t);return!d||d.pid!==process.pid?g?(s.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(s.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),n(s,t)):(s.info(`Lock '${t}': Lock acquired.`),new y(s,t))}async function m(s,t){let g;try{g=await w.Promises.readFile(t)}catch(d){return s.error(d),null}try{return JSON.parse(String(g))}catch(d){return s.error(d),null}}async function l(s,t){let g;try{g=await w.Promises.stat(t)}catch(d){return s.error(d),0}return g.mtime.getTime()}function i(s){try{return process.kill(s,0),!0}catch{return!1}}async function n(s,t){const g=await m(s,t);if(!g)return s.info(`Lock '${t}': Could not read pid of lock holder.`),r(s,t);if(g.willReleaseAt){let f=g.willReleaseAt-Date.now();if(f<5e3){for(f>0?s.info(`Lock '${t}': The lockfile is scheduled to be released in ${f} ms.`):s.info(`Lock '${t}': The lockfile is scheduled to have been released.`);f>0;){if(await(0,$.$jh)(Math.min(100,f)),await l(s,t)===0)return r(s,t);f=g.willReleaseAt-Date.now()}return r(s,t)}}if(!i(g.pid))return s.info(`Lock '${t}': The pid ${g.pid} appears to be gone.`),r(s,t);const d=await l(s,t),h=Date.now()-d;if(h<=C)return s.info(`Lock '${t}': The lock does not look stale, elapsed: ${h} ms, giving up.`),null;s.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,$.$jh)(2e3);const c=await l(s,t),u=Date.now()-c;return u<=C?(s.info(`Lock '${t}': The lock does not look stale, elapsed: ${u} ms, giving up.`),null):(s.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),r(s,t))}async function r(s,t){s.info(`Lock '${t}': Deleting a stale lock.`);try{await w.Promises.unlink(t)}catch{}return a(s,t,!0)}}),define(Ee[362],Ce([1,0,30,20,44,33]),function(re,e,o,R,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Plc=void 0;let O=class extends I.$pkc{constructor($,w){super(!0,$,w)}createTerminal($,w,A){return this.createTerminalFromOptions({name:$,shellPath:w,shellArgs:A})}createTerminalFromOptions($,w){const A=new I.$okc(this.a,(0,o.$Eg)(),$,$.name);return this.f.push(A),A.create($,this.R($,w)),A.value}};e.$Plc=O,e.$Plc=O=Qe([He(0,M.$$O),He(1,R.$OO)],O)}),define(Ee[363],Ce([1,0,4,37,42,5]),function(re,e,o,R,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OL=e.$NL=e.OutputChannelUpdateMode=e.$ML=e.$LL=e.$KL=e.$JL=e.$IL=e.$HL=e.$GL=e.$FL=e.$EL=e.$DL=e.$CL=e.$BL=e.$AL=void 0,e.$AL="text/x-code-output",e.$BL="output",e.$CL="Log",e.$DL="text/x-code-log-output",e.$EL="log",e.$FL="workbench.panel.output",e.$GL=new I.$zj("inOutput",!1),e.$HL=new I.$zj("activeLogOutput",!1),e.$IL=new I.$zj("activeLogOutput.levelSettable",!1),e.$JL=new I.$zj("activeLogOutput.level",""),e.$KL=new I.$zj("activeLogOutput.levelIsDefault",!1),e.$LL=new I.$zj("outputView.scrollLock",!1),e.$ML=(0,M.$ii)("outputService");var O;(function($){$[$.Append=1]="Append",$[$.Replace=2]="Replace",$[$.Clear=3]="Clear"})(O||(e.OutputChannelUpdateMode=O={})),e.$NL={OutputChannels:"workbench.contributions.outputChannels"};class p{constructor(){this.a=new Map,this.b=new o.$7d,this.onDidRegisterChannel=this.b.event,this.c=new o.$7d,this.onDidRemoveChannel=this.c.event}registerChannel(w){this.a.has(w.id)||(this.a.set(w.id,w),this.b.fire(w.id))}getChannels(){const w=[];return this.a.forEach(A=>w.push(A)),w}getChannel(w){return this.a.get(w)}removeChannel(w){this.a.delete(w),this.c.fire(w)}}R.$2n.add(e.$NL.OutputChannels,new p),e.$OL=new I.$zj("activeOutputChannel","")}),define(Ee[158],Ce([1,0,6,5,20,25,12,363,69,28,59,199,21,18,32,4,3]),function(re,e,o,R,I,M,O,p,$,w,A,P,b,C,y,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$flc=e.$elc=void 0;class l extends O.$Uj{get disposed(){return this.n}constructor(s,t,g,d,h){super(),this.id=s,this.name=t,this.r=g,this.s=d,this.extension=h,this.m=0,this.n=!1,this.visible=!1,this.setLevel(g.getLevel()),this.B(g.onDidChangeLogLevel(c=>this.setLevel(c)))}get logLevel(){return this.getLevel()}appendLine(s){this.append(s+`
`)}append(s){this.info(s)}clear(){const s=this.m;this.r.flush(),this.s.$update(this.id,p.OutputChannelUpdateMode.Clear,s)}replace(s){const t=this.m;this.info(s),this.s.$update(this.id,p.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(s,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof s=="boolean"?s:t))}hide(){this.s.$close(this.id)}g(s,t){this.m+=b.$ue.fromString(t).byteLength,(0,O.log)(this.r,s,t),this.visible&&(this.r.flush(),this.s.$update(this.id,p.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class i extends l{appendLine(s){this.append(s)}}let n=class{constructor(s,t,g,d,h,c){this.i=t,this.j=g,this.k=d,this.l=h,this.m=c,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=s.getProxy(o.$sM.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,P.$Qm)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(s){this.h=s;for(const[t,g]of this.g)g.visible=t===this.h}createOutputChannel(s,t,g){if(s=s.trim(),!s)throw new Error("illegal argument `name`. must not be falsy");const d=typeof t=="object"&&t.log,h=(0,C.$Vf)(t)?t:void 0;if((0,C.$Vf)(h)&&!h.trim())throw new Error("illegal argument `languageId`. must not be empty");let c;const u=this.i.environment.extensionLogLevel?.find(([E])=>M.$Em.equals(g.identifier,E))?.[1];u&&(c=(0,O.$6j)(u));const f=d?this.o(s,c,g):this.n(s,h,g);return f.then(E=>{this.g.set(E.id,E),E.visible=E.id===this.h}),d?this.r(s,c??this.m.getLevel(),f):this.q(s,f)}async n(s,t,g){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const d=await this.c,h=this.k.extUri.joinPath(d,`${this.f++}-${s.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),c=this.l.createLogger(h,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),u=await this.a.$register(s,h,t,g.identifier.value);return new l(u,s,c,this.a,g)}async o(s,t,g){const d=await this.p(g),h=s.replace(/[\\/:\*\?"<>\|]/g,""),c=this.k.extUri.joinPath(d,`${h}.log`),u=`${g.identifier.value}.${h}`,f=this.l.createLogger(c,{id:u,name:s,logLevel:t,extensionId:g.identifier.value});return new i(u,s,f,this.a,g)}p(s){let t=this.d.get(s.identifier.value);if(!t){const g=this.k.extUri.joinPath(this.i.logsLocation,s.identifier.value);this.d.set(s.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(g)}catch(d){if((0,y.$5k)(d)!==y.FileSystemProviderErrorCode.FileExists)throw d}return g})())}return t}q(s,t){let g=!1;const d=()=>{if(g)throw new Error("Channel has been closed")};return{get name(){return s},append(h){d(),t.then(c=>c.append(h))},appendLine(h){d(),t.then(c=>c.appendLine(h))},clear(){d(),t.then(h=>h.clear())},replace(h){d(),t.then(c=>c.replace(h))},show(h,c){d(),t.then(u=>u.show(h,c))},hide(){d(),t.then(h=>h.hide())},dispose(){g=!0,t.then(h=>h.dispose())}}}r(s,t,g){const d=new m.$Tc,h=()=>{if(d.isDisposed)throw new Error("Channel has been closed")},c=d.add(new a.$7d);function u(f){t=f,c.fire(f)}return g.then(f=>{d.add(f),f.logLevel!==t&&u(f.logLevel),d.add(f.onDidChangeLogLevel(E=>u(E)))}),{...this.q(s,g),get logLevel(){return t},onDidChangeLogLevel:c.event,trace(f,...E){h(),g.then(v=>v.trace(f,...E))},debug(f,...E){h(),g.then(v=>v.debug(f,...E))},info(f,...E){h(),g.then(v=>v.info(f,...E))},warn(f,...E){h(),g.then(v=>v.warn(f,...E))},error(f,...E){h(),g.then(v=>v.error(f,...E))},dispose(){d.dispose()}}}};e.$elc=n,e.$elc=n=Qe([He(0,I.$OO),He(1,w.$5O),He(2,$.$4jc),He(3,A.$Djc),He(4,O.$Pj),He(5,O.$Oj)],n),e.$flc=(0,R.$ii)("IExtHostOutputService")}),define(Ee[159],Ce([1,0,5,8]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7m=e.$6m=void 0,e.$6m=(0,o.$ii)("remoteAgentService"),e.$7m=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(I){let M=1/0;for(let p=0;p<this.maxSampleCount;p++){const $=await I.getRoundTripTime();if($===void 0)return;M=Math.min(M,$/2),await(0,R.$jh)(this.sampleDelay)}this.average.push(M),this.average.length>this.maxAverageCount&&this.average.shift();let O;return this.initial.length<this.maxInitialCount?this.initial.push(M):O=this.initial.reduce((p,$)=>p+$,0)/this.initial.length,this.lastMeasurement={initial:O,current:M,average:this.average.reduce((p,$)=>p+$,0)/this.average.length,high:typeof O>"u"?!1:M>this.highLatencyMaxThreshold||M>this.highLatencyMinThreshold&&M>O*this.highLatencyMultiple},this.lastMeasurement}}}),define(Ee[364],Ce([1,0,232,85,37,43,53,3,4,159,11,24,8]),function(re,e,o,R,I,M,O,p,$,w,A,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_I=e.$$I=e.$0I=e.$9I=e.$8I=e.$7I=e.$6I=void 0,e.$6I=Object.freeze({id:"application",order:100,title:(0,o.localize)(0,null),type:"object"}),e.$7I=Object.freeze({id:"workbench",order:7,title:(0,o.localize)(1,null),type:"object"}),e.$8I=Object.freeze({id:"security",scope:1,title:(0,o.localize)(2,null),type:"object",order:7}),e.$9I=Object.freeze({id:"problems",title:(0,o.localize)(3,null),type:"object",order:101}),e.$0I={ConfigurationMigration:"base.contributions.configuration.migration"};class C{constructor(){this.migrations=[],this.a=new $.$7d,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(i){this.migrations.push(...i)}}const y=new C;I.$2n.add(e.$0I.ConfigurationMigration,y);let a=class extends p.$Uc{constructor(i,n){super(),this.a=i,this.b=n,this.B(this.b.onDidChangeWorkspaceFolders(async r=>{for(const s of r.added)await this.f(s,y.migrations)})),this.c(y.migrations),this.B(y.onDidRegisterConfigurationMigration(r=>this.c(r)))}async c(i){await this.f(void 0,i);for(const n of this.b.getWorkspace().folders)await this.f(n,i)}async f(i,n){await Promise.all([n.map(r=>this.g(r,i?.uri))])}async g(i,n){const r=this.a.inspect(i.key,{resource:n}),s=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[t,g]of s){const d=r[t];if(!d)continue;const h=[];if(d.value!==void 0){const c=await this.h(i,t,d.value,n,void 0);for(const u of c??[])h.push([u,[]])}for(const{identifiers:c,value:u}of d.overrides??[])if(u!==void 0){const f=await this.h(i,t,u,n,c);for(const E of f??[])h.push([E,c])}h.length&&await Promise.allSettled(h.map(async([[c,u],f])=>this.a.updateValue(c,u.value,{resource:n,overrideIdentifiers:f},g)))}}async h(i,n,r,s,t){const g=h=>{const u=this.a.inspect(h,{resource:s})[n];if(u)return t?u.overrides?.find(({identifiers:f})=>(0,P.$Tn)(f,t))?.value:u.value},d=await i.migrateFn(r,g);return Array.isArray(d)?d:[[i.key,d]]}};e.$$I=a,a.ID="workbench.contrib.configurationMigration",e.$$I=a=Qe([He(0,O.$Oi),He(1,M.$ri)],a);let m=class extends p.$Uc{constructor(i){super(),this.b=i,this.a=new b.$Fh,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!A.$c&&(await this.b.getEnvironment())?.os!==1)return;I.$2n.as(R.$7n.Configuration).registerConfiguration({...e.$8I,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,o.localize)(4,null)},default:[],markdownDescription:(0,o.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,o.localize)(6,null),scope:2}}})}};e.$_I=m,m.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration",e.$_I=m=Qe([He(0,w.$6m)],m)}),define(Ee[365],Ce([1,0,35,15,17,23,241,364,85,5,37]),function(re,e,o,R,I,M,O,p,$,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$Sfb=e.$Rfb=void 0,e.$Tfb=a,e.$Ufb=m,e.$Rfb=(0,w.$ii)("editorResolverService"),e.$Sfb="workbench.editorAssociations";const P=A.$2n.as($.$7n.Configuration),b={...p.$7I,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,O.localize)(0,null),additionalProperties:{type:"string"}}}};P.registerConfiguration(b);var C;(function(l){l.builtin="builtin",l.option="option",l.exclusive="exclusive",l.default="default"})(C||(e.RegisteredEditorPriority=C={}));var y;(function(l){l[l.ABORT=1]="ABORT",l[l.NONE=2]="NONE"})(y||(e.ResolvedStatus=y={}));function a(l){switch(l){case C.exclusive:return 5;case C.default:return 4;case C.builtin:return 3;case C.option:default:return 1}}function m(l,i){if(new Set([R.Schemas.extension,R.Schemas.webviewPanel,R.Schemas.vscodeWorkspaceTrust,R.Schemas.vscodeSettings]).has(i.scheme))return!1;const s=typeof l=="string"&&l.indexOf(I.$hc.sep)>=0?`${i.scheme}:${i.path}`:(0,M.$Sg)(i);return o.$bk(typeof l=="string"?l.toLowerCase():l,s.toLowerCase())}}),define(Ee[366],Ce([1,0,34,15,17,11,23,2,5,277,43,148,159]),function(re,e,o,R,I,M,O,p,$,w,A,P,b){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.$8L=e.$7L=void 0,e.$7L=(0,$.$ii)("pathService");let y=C=class{constructor(m,l,i,n){this.d=m,this.e=l,this.f=i,this.g=n,this.a=(async()=>(await this.e.getEnvironment())?.os||M.OS)(),this.b=(async()=>{const r=await this.e.getEnvironment();return this.c=r?.userHome??m})()}hasValidBasename(m,l,i){return typeof l=="string"||typeof l>"u"?this.a.then(n=>this.h(m,n,l)):this.h(m,l,i)}h(m,l,i){return m.scheme===R.Schemas.file||m.scheme===R.Schemas.vscodeRemote?(0,o.$gg)(i??(0,O.$Sg)(m),l===1):!0}get defaultUriScheme(){return C.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(m,l){if(m.remoteAuthority)return R.Schemas.vscodeRemote;const i=(0,w.$4L)(l.getWorkspace());if(i)return i;const n=l.getWorkspace().folders[0];if(n)return n.uri.scheme;const r=l.getWorkspace().configuration;return r?r.scheme:R.Schemas.file}userHome(m){return m?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(m=>m===1?I.$gc:I.$hc)}async fileURI(m){let l="";if(await this.a===1&&(m=m.replace(/\\/g,"/")),m[0]==="/"&&m[1]==="/"){const n=m.indexOf("/",2);n===-1?(l=m.substring(2),m="/"):(l=m.substring(2,n),m=m.substring(n)||"/")}return p.URI.from({scheme:R.Schemas.file,authority:l,path:m,query:"",fragment:""})}};e.$8L=y,e.$8L=y=C=Qe([He(1,b.$6m),He(2,P.$PL),He(3,A.$ri)],y)}),define(Ee[367],Ce([1,0,243,19,54,4,55,3,2,53,248,12,65,279,88,43,148,26,22,18,24,42]),function(re,e,o,R,I,M,O,p,$,w,A,P,b,C,y,a,m,l,i,n,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1L=e.$ZL=e.OnPortForward=e.$UL=e.$TL=e.TunnelSource=e.TunnelCloseReason=e.$RL=e.$QL=void 0,e.$SL=c,e.$VL=E,e.$WL=v,e.$XL=D,e.$YL=S;const t=10*1e3,g="remote.tunnels.toRestore",d="remote.tunnels.toRestoreExpiration",h=1e3*60*60*24*14;e.$QL="onTunnel",e.$RL=new s.$zj("forwardedPortsViewEnabled",!1,o.localize(0,null));function c(B){const T=B.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(T)return{host:T[1]?.substring(0,T[1].length-1)||"localhost",port:Number(T[2])}}var u;(function(B){B.Other="Other",B.User="User",B.AutoForwardEnd="AutoForwardEnd"})(u||(e.TunnelCloseReason=u={}));var f;(function(B){B[B.User=0]="User",B[B.Auto=1]="Auto",B[B.Extension=2]="Extension"})(f||(e.TunnelSource=f={})),e.$TL={source:f.User,description:o.localize(1,null)},e.$UL={source:f.Auto,description:o.localize(2,null)};function E(B,T,N){const j=B.get(D(T,N));if(j)return j;if((0,y.$4v)(T))for(const L of y.$3v){const z=D(L,N);if(B.has(z))return B.get(z)}else if((0,y.$6v)(T))for(const L of y.$5v){const z=D(L,N);if(B.has(z))return B.get(z)}}function v(B,T,N){const j=E(B,T,N);if(j)return j;const L=(0,y.$6v)(T)?"localhost":(0,y.$4v)(T)?"0.0.0.0":void 0;if(L)return E(B,L,N)}function D(B,T){return B+":"+T}var k;(function(B){B.Notify="notify",B.OpenBrowser="openBrowser",B.OpenBrowserOnce="openBrowserOnce",B.OpenPreview="openPreview",B.Silent="silent",B.Ignore="ignore"})(k||(e.OnPortForward=k={}));function S(B){return B&&"host"in B&&typeof B.host=="string"&&"port"in B&&typeof B.port=="number"&&(!("detail"in B)||typeof B.detail=="string")&&(!("pid"in B)||typeof B.pid=="string")}class F extends p.$Uc{constructor(T){super(),this.r=T,this.j=[],this.n=new M.$7d,this.onDidChangeAttributes=this.n.event,this.B(T.onDidChangeConfiguration(N=>{(N.affectsConfiguration(F.c)||N.affectsConfiguration(F.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(T,N,j){let L=this.w(T,N,j,this.j,0);const z={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;L>=0;){const Q=this.j[L];Q.key===T?(z.onAutoForward=Q.onAutoForward??z.onAutoForward,z.elevateIfNeeded=Q.elevateIfNeeded!==void 0?Q.elevateIfNeeded:z.elevateIfNeeded,z.label=Q.label??z.label,z.requireLocalPort=Q.requireLocalPort,z.protocol=Q.protocol):(z.onAutoForward=z.onAutoForward??Q.onAutoForward,z.elevateIfNeeded=z.elevateIfNeeded!==void 0?z.elevateIfNeeded:Q.elevateIfNeeded,z.label=z.label??Q.label,z.requireLocalPort=z.requireLocalPort!==void 0?z.requireLocalPort:void 0,z.protocol=z.protocol??Q.protocol),L=this.w(T,N,j,this.j,L+1)}return z.onAutoForward!==void 0||z.elevateIfNeeded!==void 0||z.label!==void 0||z.requireLocalPort!==void 0||z.protocol!==void 0?z:this.C()}t(T){return T.start!==void 0&&T.end!==void 0}u(T){return T.host!==void 0&&T.port!==void 0&&(0,n.$Vf)(T.host)&&(0,n.$Zf)(T.port)}w(T,N,j,L,z){if(z>=L.length)return-1;const Q=!(0,y.$4v)(N)&&!(0,y.$6v)(N),J=L.slice(z).findIndex(x=>(0,n.$Zf)(x.key)?Q?!1:x.key===T:this.t(x.key)?Q?!1:T>=x.key.start&&T<=x.key.end:this.u(x.key)?T===x.key.port&&N===x.key.host:j?x.key.test(j):!1);return J>=0?J+z:-1}y(){const T=this.r.getValue(F.c);if(!T||!(0,n.$Xf)(T))return[];const N=[];for(const L in T){if(L===void 0)continue;const z=T[L];let Q;if(Number(L))Q=Number(L);else if((0,n.$Vf)(L))if(F.g.test(L)){const Y=L.match(F.g);Q={start:Number(Y[1]),end:Number(Y[2])}}else if(F.h.test(L)){const Y=L.match(F.h);Q={host:Y[1],port:Number(Y[2])}}else{let Y;try{Y=RegExp(L)}catch{}Y&&(Q=Y)}Q&&N.push({key:Q,elevateIfNeeded:z.elevateIfNeeded,onAutoForward:z.onAutoForward,label:z.label,requireLocalPort:z.requireLocalPort,protocol:z.protocol})}const j=this.r.getValue(F.f);return j&&(this.m={elevateIfNeeded:j.elevateIfNeeded,label:j.label,onAutoForward:j.onAutoForward,requireLocalPort:j.requireLocalPort,protocol:j.protocol}),this.z(N)}z(T){function N(j,L){return(0,n.$Zf)(j.key)?j.key:L.t(j.key)?j.key.start:L.u(j.key)?j.key.port:Number.MAX_VALUE}return T.sort((j,L)=>N(j,this)-N(L,this))}C(){return this.m}static providedActionToAction(T){switch(T){case y.ProvidedOnAutoForward.Notify:return k.Notify;case y.ProvidedOnAutoForward.OpenBrowser:return k.OpenBrowser;case y.ProvidedOnAutoForward.OpenBrowserOnce:return k.OpenBrowserOnce;case y.ProvidedOnAutoForward.OpenPreview:return k.OpenPreview;case y.ProvidedOnAutoForward.Silent:return k.Silent;case y.ProvidedOnAutoForward.Ignore:return k.Ignore;default:return}}async addAttributes(T,N,j){const z=this.r.inspect(F.c).userRemoteValue;let Q;!z||!(0,n.$Xf)(z)?Q={}:Q=(0,r.$Pn)(z),Q[`${T}`]||(Q[`${T}`]={});for(const Y in N)Q[`${T}`][Y]=N[Y];return this.r.updateValue(F.c,Q,j)}}e.$ZL=F,F.c="remote.portsAttributes",F.f="remote.otherPortsAttributes",F.g=/^(\d+)\-(\d+)$/,F.h=/^([a-z0-9\-]+):(\d{1,5})$/;let W=class extends p.$Uc{constructor(T,N,j,L,z,Q,Y,J,x,ce){super(),this.H=T,this.I=N,this.J=j,this.L=L,this.M=z,this.N=Q,this.O=Y,this.P=J,this.Q=x,this.R=ce,this.c=new Map,this.g=new M.$7d,this.onForwardPort=this.g.event,this.h=new M.$7d,this.onClosePort=this.h.event,this.j=new M.$7d,this.onPortName=this.j.event,this.n=new M.$7d,this.onCandidatesChanged=this.n.event,this.t=new M.$7d,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new M.$7d,this.D=new Map,this.F=new Map,this.G=[],this.db=new Date,this.configPortsAttributes=new F(j),this.s=this.ab(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.jb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async te=>{const pe=await this.getAttributes(te.map(ye=>({port:ye.tunnelRemotePort,host:ye.tunnelRemoteHost})));for(const ye of te)if(ye.localAddress){const _=D(ye.tunnelRemoteHost,ye.tunnelRemotePort),U=v(this.m??new Map,ye.tunnelRemoteHost,ye.tunnelRemotePort);this.forwarded.set(_,{remotePort:ye.tunnelRemotePort,remoteHost:ye.tunnelRemoteHost,localAddress:ye.localAddress,protocol:pe?.get(ye.tunnelRemotePort)?.protocol??y.TunnelProtocol.Http,localUri:await this.X(ye.localAddress,pe?.get(ye.tunnelRemotePort)),localPort:ye.tunnelLocalPort,runningProcess:U?.detail,hasRunningProcess:!!U,pid:U?.pid,privacy:ye.privacy,source:e.$TL}),this.f.set(_,ye)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async te=>{const pe=D(te.tunnelRemoteHost,te.tunnelRemotePort);if(!v(this.forwarded,te.tunnelRemoteHost,te.tunnelRemotePort)&&!v(this.detected,te.tunnelRemoteHost,te.tunnelRemotePort)&&!v(this.c,te.tunnelRemoteHost,te.tunnelRemotePort)&&te.localAddress){const ye=v(this.m??new Map,te.tunnelRemoteHost,te.tunnelRemotePort),_=(await this.getAttributes([{port:te.tunnelRemotePort,host:te.tunnelRemoteHost}]))?.get(te.tunnelRemotePort);this.forwarded.set(pe,{remoteHost:te.tunnelRemoteHost,remotePort:te.tunnelRemotePort,localAddress:te.localAddress,protocol:_?.protocol??y.TunnelProtocol.Http,localUri:await this.X(te.localAddress,_),localPort:te.tunnelLocalPort,closeable:!0,runningProcess:ye?.detail,hasRunningProcess:!!ye,pid:ye?.pid,privacy:te.privacy,source:e.$TL})}await this.cb(),this.f.set(pe,te),this.g.fire(this.forwarded.get(pe))})),this.B(this.H.onTunnelClosed(te=>this.W(te,u.Other))),this.U()}S(){return this.Q.extensions.find(T=>T.activationEvents?.includes(e.$QL))?(this.R.createKey(e.$RL.key,!0),!0):!1}U(){if(this.S())return;const T=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&T.dispose()}))}async W(T,N){const j=D(T.host,T.port);this.forwarded.has(j)&&(this.forwarded.delete(j),await this.cb(),this.h.fire(T))}X(T,N){if(T.startsWith("http"))return $.URI.parse(T);const j=N?.protocol??"http";return $.URI.parse(`${j}://${T}`)}async Y(T){const N=this.N.getWorkspace(),j=N.configuration?(0,O.$9i)(N.configuration.path):N.folders.length>0?(0,O.$9i)(N.folders[0].uri.path):void 0;if(j===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${T}.${this.L.remoteAuthority}.${j}`}async Z(){return this.Y(g)}async $(){return this.Y(d)}async ab(){const T=this.I.get(g,1);if(T)return this.I.remove(g,1),await this.cb(),T;const N=await this.Z();if(N)return this.I.get(N,0)}async restoreForwarded(){if(this.bb(),this.J.getValue("remote.restoreForwardedPorts")){const T=await this.s;if(T&&T!==this.y){const N=JSON.parse(T)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${N.map(j=>j.remotePort).join(", ")}`);for(const j of N){const L=v(this.detected,j.remoteHost,j.remotePort);j.source.source!==f.Extension&&!L||j.source.source===f.Extension&&L?await this.fb({remote:{host:j.remoteHost,port:j.remotePort},local:j.localPort,name:j.name,elevateIfNeeded:!0,source:j.source}):j.source.source===f.Extension&&!L&&this.D.set(D(j.remoteHost,j.remotePort),j)}}}if(this.z=!0,this.C.fire(),!this.w){const T=await this.Z();this.w=this.B(new p.$Tc),this.w.add(this.I.onDidChangeValue(0,void 0,this.w)(async N=>{N.key===T&&(this.s=Promise.resolve(this.I.get(T,0)),await this.restoreForwarded())}))}}bb(){const T=this.I.keys(0,0).filter(N=>N.startsWith(d));for(const N of T){const j=this.I.getNumber(N,0);if(j&&j<Date.now()){this.s=Promise.resolve(void 0);const L=N.replace(d,g);this.I.remove(N,0),this.I.remove(L,0)}}}async cb(){if(this.J.getValue("remote.restoreForwardedPorts")){const T=Array.from(this.forwarded.values()),N=T.map(Q=>({remoteHost:Q.remoteHost,remotePort:Q.remotePort,localPort:Q.localPort,name:Q.name,localAddress:Q.localAddress,localUri:Q.localUri,protocol:Q.protocol,source:Q.source}));let j;T.length>0&&(j=JSON.stringify(N));const L=await this.Z(),z=await this.$();!j&&L&&z?(this.I.remove(L,0),this.I.remove(z,0)):j!==this.y&&L&&z&&(this.I.store(L,j,0,0),this.I.store(z,Date.now()+h,0,0)),this.y=j}}async eb(T,N,j){if(!T.tunnelLocalPort||!j?.requireLocalPort||T.tunnelLocalPort===N)return;const L=new Date;if(this.db.getTime()+t>L.getTime())return;this.db=L;const z=o.localize(3,null,N,T.tunnelRemotePort,T.tunnelLocalPort);return this.P.info(z)}async forward(T,N){return!this.z&&this.L.remoteAuthority&&await M.Event.toPromise(this.C.event),this.fb(T,N)}async fb(T,N){await this.Q.activateByEvent(e.$QL);const j=v(this.forwarded,T.remote.host,T.remote.port);N=N??(N!==null?(await this.getAttributes([T.remote]))?.get(T.remote.port):void 0);const L=T.local!==void 0?T.local:T.remote.port;let z;if(j)return this.hb(j,T,N);{const Q=this.L.remoteAuthority,Y=Q?{getAddress:async()=>(await this.M.resolveAuthority(Q)).authority}:void 0,J=D(T.remote.host,T.remote.port);this.c.set(J,!0),T=this.gb(J,T);const x=await this.H.openTunnel(Y,T.remote.host,T.remote.port,void 0,L,T.elevateIfNeeded?T.elevateIfNeeded:N?.elevateIfNeeded,T.privacy,N?.protocol);if(typeof x=="string")z=x;else if(x&&x.localAddress){const ce=v(this.m??new Map,T.remote.host,T.remote.port),te=x.protocol?x.protocol===y.TunnelProtocol.Https?y.TunnelProtocol.Https:y.TunnelProtocol.Http:N?.protocol??y.TunnelProtocol.Http,pe={remoteHost:x.tunnelRemoteHost,remotePort:x.tunnelRemotePort,localPort:x.tunnelLocalPort,name:N?.label??T.name,closeable:!0,localAddress:x.localAddress,protocol:te,localUri:await this.X(x.localAddress,N),runningProcess:ce?.detail,hasRunningProcess:!!ce,pid:ce?.pid,source:T.source??e.$TL,privacy:x.privacy};return this.forwarded.set(J,pe),this.f.set(J,x),this.c.delete(J),await this.cb(),await this.eb(x,L,N),this.g.fire(pe),x}this.c.delete(J)}return z}gb(T,N){const j=this.D.has(T)?this.D:this.F.has(T)?this.F:void 0;if(j){const L=j.get(T);j.delete(T),L&&(N.name=L.name??N.name,N.local=("local"in L?L.local:"localPort"in L?L.localPort:void 0)??N.local,N.privacy=N.privacy)}return N}async hb(T,N,j){const L=j?.label??N.name;let z;(function(Y){Y[Y.None=0]="None",Y[Y.Fire=1]="Fire",Y[Y.Reopen=2]="Reopen"})(z||(z={}));let Q=z.None;switch(L!==T.name&&(T.name=L,Q=z.Fire),(j?.protocol||T.protocol!==y.TunnelProtocol.Http)&&j?.protocol!==T.protocol&&(N.source=T.source,Q=z.Reopen),N.privacy&&T.privacy!==N.privacy&&(Q=z.Reopen),Q){case z.Fire:{this.g.fire();break}case z.Reopen:await this.close(T.remoteHost,T.remotePort,u.User),await this.fb(N,j)}return v(this.f,N.remote.host,N.remote.port)}async name(T,N,j){const L=v(this.forwarded,T,N),z=D(T,N);if(L){L.name=j,await this.cb(),this.j.fire({host:T,port:N});return}else this.detected.has(z)&&(this.detected.get(z).name=j,this.j.fire({host:T,port:N}))}async close(T,N,j){const L=D(T,N),z=this.forwarded.get(L);return j===u.AutoForwardEnd&&z&&z.source.source===f.Auto&&this.F.set(L,{local:z.localPort,name:z.name,privacy:z.privacy}),await this.H.closeTunnel(T,N),this.W({host:T,port:N},j)}address(T,N){const j=D(T,N);return(this.forwarded.get(j)||this.detected.get(j))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(T){if(T)for(const N of T){const j=v(this.m??new Map,N.remoteAddress.host,N.remoteAddress.port),L=typeof N.localAddress=="string"?N.localAddress:D(N.localAddress.host,N.localAddress.port);this.detected.set(D(N.remoteAddress.host,N.remoteAddress.port),{remoteHost:N.remoteAddress.host,remotePort:N.remoteAddress.port,localAddress:L,protocol:y.TunnelProtocol.Http,localUri:this.X(L),closeable:!1,runningProcess:j?.detail,hasRunningProcess:!!j,pid:j?.pid,privacy:y.TunnelPrivacyId.ConstantPrivate,source:{source:f.Extension,description:o.localize(4,null)}}),this.H.setEnvironmentTunnel(N.remoteAddress.host,N.remoteAddress.port,L,y.TunnelPrivacyId.ConstantPrivate,y.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(T){this.r=T}async setCandidates(T){let N=T;this.r&&(N=await this.r(T));const j=this.ib(N);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(j.values()).map(L=>L.port).join(", ")}`),this.n.fire(j)}ib(T){const N=this.m??new Map,j=new Map;return this.m=j,T.forEach(L=>{const z=D(L.host,L.port);j.set(z,{host:L.host,port:L.port,detail:L.detail,pid:L.pid}),N.has(z)&&N.delete(z);const Q=v(this.forwarded,L.host,L.port);Q&&(Q.runningProcess=L.detail,Q.hasRunningProcess=!0,Q.pid=L.pid)}),N.forEach((L,z)=>{const Q=c(z);if(!Q)return;const Y=v(this.forwarded,Q.host,Q.port);Y&&(Y.runningProcess=void 0,Y.hasRunningProcess=!1,Y.pid=void 0);const J=v(this.detected,Q.host,Q.port);J&&(J.runningProcess=void 0,J.hasRunningProcess=!1,J.pid=void 0)}),N}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async jb(){const T=Array.from(this.forwarded.values()),N=await this.getAttributes(T.map(j=>({port:j.remotePort,host:j.remoteHost})),!1);if(N)for(const j of T){const L=N.get(j.remotePort);(L?.protocol||j.protocol!==y.TunnelProtocol.Http)&&L?.protocol!==j.protocol&&await this.fb({remote:{host:j.remoteHost,port:j.remotePort},local:j.localPort,name:j.name,source:j.source},L),L&&L.label&&L.label!==j.name&&await this.name(j.remoteHost,j.remotePort,L.label)}}async getAttributes(T,N=!0){const j=new Map,L=new Map;T.forEach(x=>{const ce=v(this.m??new Map,y.$3v[0],x.port)??x;if(ce){j.set(x.port,ce);const te=S(ce)?ce.pid:void 0;L.has(te)||L.set(te,[]),L.get(te)?.push(x.port)}});const z=new Map;if(T.forEach(x=>{const ce=this.configPortsAttributes.getAttributes(x.port,x.host,j.get(x.port)?.detail);ce&&z.set(x.port,ce)}),this.G.length===0||!N)return z.size>0?z:void 0;const Q=await Promise.all((0,R.$Rb)(this.G.map(x=>Array.from(L.entries()).map(ce=>{const te=ce[1],pe=j.get(te[0]);return x.providePortAttributes(te,pe?.pid,pe?.detail,i.CancellationToken.None)})))),Y=new Map;if(Q.forEach(x=>x.forEach(ce=>{ce&&Y.set(ce.port,ce)})),!z&&!Y)return;const J=new Map;return T.forEach(x=>{const ce=z.get(x.port),te=Y.get(x.port);J.set(x.port,{elevateIfNeeded:ce?.elevateIfNeeded,label:ce?.label,onAutoForward:ce?.onAutoForward??F.providedActionToAction(te?.autoForwardAction),requireLocalPort:ce?.requireLocalPort,protocol:ce?.protocol})}),J}addAttributesProvider(T){this.G.push(T)}};e.$1L=W,Qe([(0,I.$Nh)(1e3)],W.prototype,"cb",null),e.$1L=W=Qe([He(0,y.$Xv),He(1,C.$Np),He(2,w.$Oi),He(3,m.$PL),He(4,b.$tl),He(5,a.$ri),He(6,P.$Oj),He(7,A.$rw),He(8,l.$_F),He(9,s.$Aj)],W)}),define(Ee[94],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$AK=e.$zK=void 0;class o{constructor(O,p){this.line=O,this.character=p}isBefore(O){return!1}isBeforeOrEqual(O){return!1}isAfter(O){return!1}isAfterOrEqual(O){return!1}isEqual(O){return!1}compareTo(O){return 0}translate(O,p){return new o(0,0)}with(O){return new o(0,0)}}e.$zK=o;class R{constructor(O,p,$,w){this.isEmpty=!1,this.isSingleLine=!1,this.start=new o(O,p),this.end=new o($,w)}contains(O){return!1}isEqual(O){return!1}intersection(O){}union(O){return new R(0,0,0,0)}with(O){return new R(0,0,0,0)}}e.$AK=R;var I;(function(M){M[M.Information=1]="Information",M[M.Warning=2]="Warning"})(I||(e.TextSearchCompleteMessageType=I={}))}),define(Ee[36],Ce([1,0,19,35,24,34,14,5,17,13,94,8]),function(re,e,o,R,I,M,O,p,$,w,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZK=e.$XK=e.$QK=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$NK=e.$MK=e.$LK=e.$KK=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$GK=e.$FK=e.$EK=e.$DK=e.$CK=e.$BK=e.TextSearchCompleteMessageType=void 0,e.$HK=l,e.$IK=i,e.$JK=n,e.$OK=f,e.$PK=E,e.$RK=k,e.$SK=S,e.$TK=F,e.$UK=W,e.$VK=B,e.$WK=T,e.$YK=j,e.$1K=Q,e.$2K=Y,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return A.TextSearchCompleteMessageType}}),e.$BK="workbench.view.search",e.$CK="workbench.panel.search",e.$DK="workbench.view.search",e.$EK="search-result",e.$FK="search.exclude";const b="\u27EA ",C=" characters skipped \u27EB",y=(b.length+C.length+5)*2;e.$GK=(0,p.$ii)("searchService");var a;(function(x){x[x.file=0]="file",x[x.text=1]="text",x[x.aiText=2]="aiText"})(a||(e.SearchProviderType=a={}));var m;(function(x){x[x.File=1]="File",x[x.Text=2]="Text",x[x.aiText=3]="aiText"})(m||(e.QueryType=m={}));function l(x){return!!x.preview}function i(x){return!!x.resource}function n(x){return!!x.message}var r;(function(x){x[x.Normal=0]="Normal",x[x.NewSearchStarted=1]="NewSearchStarted"})(r||(e.SearchCompletionExitCode=r={}));class s{constructor(ce){this.resource=ce,this.results=[]}}e.$KK=s;class t{constructor(ce,te,pe,ye){this.ranges=te,this.webviewIndex=ye;const _=Array.isArray(te)?te:[te];if(pe&&pe.matchLines===1&&g(_)){ce=(0,O.$Of)(ce,pe.matchLines);let U="",he=0,Se=0;const me=Math.floor(pe.charsPerLine/5),ie=[];for(const se of _){const oe=Math.max(se.startColumn-me,0),G=se.startColumn+pe.charsPerLine;if(oe>Se+me+y){const ee=b+(oe-Se)+C;U+=ee+ce.slice(oe,G),he+=oe-(Se+ee.length)}else U+=ce.slice(Se,G);ie.push(new h(0,se.startColumn-he,se.endColumn-he)),Se=G}this.preview={text:U,matches:Array.isArray(this.ranges)?ie:ie[0]}}else{const U=Array.isArray(te)?te[0].startLineNumber:te.startLineNumber;this.preview={text:ce,matches:(0,o.$2b)(te,he=>new d(he.startLineNumber-U,he.startColumn,he.endLineNumber-U,he.endColumn))}}}}e.$LK=t;function g(x){const ce=x[0].startLineNumber;for(const te of x)if(te.startLineNumber!==ce||te.endLineNumber!==ce)return!1;return!0}class d{constructor(ce,te,pe,ye){this.startLineNumber=ce,this.startColumn=te,this.endLineNumber=pe,this.endColumn=ye}}e.$MK=d;class h extends d{constructor(ce,te,pe){super(ce,te,ce,pe)}}e.$NK=h;var c;(function(x){x.List="list",x.Tree="tree"})(c||(e.ViewMode=c={}));var u;(function(x){x.Default="default",x.FileNames="fileNames",x.Type="type",x.Modified="modified",x.CountDescending="countDescending",x.CountAscending="countAscending"})(u||(e.SearchSortOrder=u={}));function f(x,ce=!0){const te=x&&x.files&&x.files.exclude,pe=ce&&x&&x.search&&x.search.exclude;if(!te&&!pe)return;if(!te||!pe)return te||pe;let ye=Object.create(null);return ye=I.$Sn(ye,I.$Pn(te)),ye=I.$Sn(ye,I.$Pn(pe),!0),ye}function E(x,ce){return x.excludePattern&&R.$bk(x.excludePattern,ce)?!1:x.includePattern||x.usingSearchPaths?x.includePattern&&R.$bk(x.includePattern,ce)?!0:x.usingSearchPaths?!!x.folderQueries&&x.folderQueries.some(te=>{const pe=te.folder.fsPath;if(M.$ig(ce,pe)){const ye=$.$mc(pe,ce);return!te.includePattern||!!R.$bk(te.includePattern,ye)}else return!1}):!1:!0}var v;(function(x){x[x.unknownEncoding=1]="unknownEncoding",x[x.regexParseError=2]="regexParseError",x[x.globParseError=3]="globParseError",x[x.invalidLiteral=4]="invalidLiteral",x[x.rgProcessError=5]="rgProcessError",x[x.other=6]="other",x[x.canceled=7]="canceled"})(v||(e.SearchErrorCode=v={}));class D extends Error{constructor(ce,te){super(ce),this.code=te}}e.$QK=D;function k(x){const ce=x.message;if((0,w.$4)(x))return new D(ce,v.canceled);try{const te=JSON.parse(ce);return new D(te.message,te.code)}catch{return new D(ce,v.other)}}function S(x){const ce={message:x.message,code:x.code};return new Error(JSON.stringify(ce))}function F(x){return x.type==="error"?!0:x.type==="success"}function W(x){return x.type==="success"}function B(x){return!!x.path}function T(x,ce,te=!0){const pe=x.searchPath?x.searchPath:x.relativePath;return te?(0,O.$Lf)(pe,ce):R.$bk(ce,pe)}class N{constructor(ce){this.path=ce,this.results=[]}addMatch(ce){this.results.push(ce)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$XK=N;function j(x,ce){const te={...x||{},...ce||{}};return Object.keys(te).filter(pe=>{const ye=te[pe];return typeof ye=="boolean"&&ye})}class L{constructor(ce,te){this.c=null,this.a={...ce.excludePattern||{},...te.excludePattern||{}},this.b=R.$ck(this.a);let pe=ce.includePattern;te.includePattern&&(pe?pe={...pe,...te.includePattern}:pe=te.includePattern),pe&&(this.c=R.$ck(pe))}matchesExcludesSync(ce,te,pe){return!!(this.b&&this.b(ce,te,pe))}includedInQuerySync(ce,te,pe){return!(this.b&&this.b(ce,te,pe)||this.c&&!this.c(ce,te,pe))}includedInQuery(ce,te,pe){const ye=this.b(ce,te,pe),_=()=>this.c?!!this.c(ce,te,pe):!0;return(0,P.$7g)(ye)?ye.then(U=>U?!1:_()):_()}hasSiblingExcludeClauses(){return z(this.a)}}e.$ZK=L;function z(x){for(const ce in x)if(typeof x[ce]!="boolean")return!0;return!1}function Q(x){if(!x)return;let ce;return te=>(ce||(ce=(x()||Promise.resolve([])).then(pe=>pe?J(pe):{})),ce.then(pe=>!!pe[te]))}function Y(x){if(!x)return;let ce;return te=>{if(!ce){const pe=x();ce=pe?J(pe):{}}return!!ce[te]}}function J(x){const ce={};for(const te of x)ce[te]=!0;return ce}}),define(Ee[38],Ce([1,0,19,8,22,4,3,77,15,126,23,14,2,230,5,12,262,43,59,28,20,16,7,66,36,6,57]),function(re,e,o,R,I,M,O,p,$,w,A,P,b,C,y,a,m,l,i,n,r,s,t,g,d,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yjc=e.$Xjc=void 0;function u(W,B,T){return new A.$Kg(N=>D(N,T)).isEqual(W,B)}function f(W,B,T){return u(W.uri,B.uri,T)?0:(0,P.$ef)(W.uri.toString(),B.uri.toString())}function E(W,B,T){return W.index!==B.index?W.index<B.index?-1:1:u(W.uri,B.uri,T)?(0,P.$ef)(W.name,B.name):(0,P.$ef)(W.uri.toString(),B.uri.toString())}function v(W,B,T,N){const j=W.slice(0).sort((z,Q)=>T(z,Q,N)),L=B.slice(0).sort((z,Q)=>T(z,Q,N));return(0,o.$Eb)(j,L,(z,Q)=>T(z,Q,N))}function D(W,B){const T=B.getCapabilities(W.scheme);return!(T&&T&1024)}class k extends l.$Bi{static toExtHostWorkspace(B,T,N,j){if(!B)return{workspace:null,added:[],removed:[]};const{id:L,name:z,folders:Q,configuration:Y,transient:J,isUntitled:x}=B,ce=[],te=T;T?Q.forEach((U,he)=>{const Se=b.URI.revive(U.uri),me=k.o(N||T,Se,j);me?(me.name=U.name,me.index=U.index,ce.push(me)):ce.push({uri:Se,name:U.name,index:he})}):ce.push(...Q.map(({uri:U,name:he,index:Se})=>({uri:b.URI.revive(U),name:he,index:Se}))),ce.sort((U,he)=>U.index<he.index?-1:1);const pe=new k(L,z,ce,!!J,Y?b.URI.revive(Y):null,!!x,U=>D(U,j)),{added:ye,removed:_}=v(te?te.workspaceFolders:[],pe.workspaceFolders,f,j);return{workspace:pe,added:ye,removed:_}}static o(B,T,N){for(let j=0;j<B.folders.length;j++){const L=B.workspaceFolders[j];if(u(L.uri,T,N))return L}}constructor(B,T,N,j,L,z,Q){super(B,N.map(Y=>new l.$Ci(Y)),j,L,Q),this.t=T,this.u=z,this.q=[],this.s=p.$oi.forUris(Q),N.forEach(Y=>{this.q.push(Y),this.s.set(Y.uri,Y)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(B,T){return T&&this.s.get(B)&&(B=(0,A.$Ug)(B)),this.s.findSubstr(B)}resolveWorkspaceFolder(B){return this.s.get(B)}}let S=class{constructor(B,T,N,j,L){this.c=new M.$7d,this.onDidChangeWorkspace=this.c.event,this.g=new M.$7d,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new M.$9d,this.C=new Map,this.h=j,this.s=N,this.t=L,this.j=new w.$qm,this.k=new R.$hh,this.o=B.getProxy(h.$sM.MainThreadWorkspace),this.q=B.getProxy(h.$sM.MainThreadMessageService);const z=T.workspace;this.l=z?new k(z.id,z.name,[],!!z.transient,z.configuration?b.URI.revive(z.configuration):null,!!z.isUntitled,Q=>D(Q,N)):void 0}$initializeWorkspace(B,T){this.v=T,this.$acceptWorkspaceData(B),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?b.URI.from({scheme:$.Schemas.untitled,path:(0,A.$Sg)((0,A.$Ug)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(B,T,N,...j){const L=[];if(Array.isArray(j)&&j.forEach(x=>{b.URI.isUri(x.uri)&&!L.some(ce=>u(ce.uri,x.uri,this.s))&&L.push({uri:x.uri,name:x.name||(0,A.$Rg)(x.uri)})}),this.n||[T,N].some(x=>typeof x!="number"||x<0)||N===0&&L.length===0)return!1;const z=this.x?this.x.workspaceFolders:[];if(T+N>z.length)return!1;const Q=z.slice(0);Q.splice(T,N,...L.map(x=>({uri:x.uri,name:x.name||(0,A.$Rg)(x.uri),index:void 0})));for(let x=0;x<Q.length;x++){const ce=Q[x];if(Q.some((te,pe)=>pe!==x&&u(ce.uri,te.uri,this.s)))return!1}Q.forEach((x,ce)=>x.index=ce);const{added:Y,removed:J}=v(z,Q,E,this.s);if(Y.length===0&&J.length===0)return!1;if(this.o){const x=B.displayName||B.name;this.o.$updateWorkspaceFolders(x,T,N,L).then(void 0,ce=>{this.n=void 0;const te={source:{identifier:B.identifier,label:B.displayName||B.name}};this.q.$showMessage(m.Severity.Error,(0,C.localize)(0,null,x,ce.toString()),te,[])})}return this.y(Q),!0}getWorkspaceFolder(B,T){if(this.x)return this.x.getWorkspaceFolder(B,T)}async getWorkspaceFolder2(B,T){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(B,T)}async resolveWorkspaceFolder(B){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(B)}getPath(){if(!this.x)return;const{folders:B}=this.x;if(B.length!==0)return B[0].uri.fsPath}getRelativePath(B,T){let N,j="";if(typeof B=="string"?(N=b.URI.file(B),j=B):typeof B<"u"&&(N=B,j=B.fsPath),!N)return j;const L=this.getWorkspaceFolder(N,!0);if(!L)return j;typeof T>"u"&&this.x&&(T=this.x.folders.length>1);let z=(0,A.$Xg)(L.uri,N);return T&&L.name&&(z=`${L.name}/${z}`),z}y(B){this.x&&(this.n=k.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:B,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(B){const{workspace:T,added:N,removed:j}=k.toExtHostWorkspace(B,this.l,this.n,this.s);this.l=T||void 0,this.n=void 0,this.c.fire(Object.freeze({added:N,removed:j}))}findFiles(B,T,N,j,L=I.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${j.value}, entryPoint: findFiles`);let z="",Q=!0;return T===null?Q=!1:T!==void 0&&(typeof T=="string"?z=T:z=T.pattern),this.z(B,void 0,{exclude:z,maxResults:N,useDefaultExcludes:Q,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},L)}findFiles2(B,T={},N,j=I.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${N.value}, entryPoint: findFiles2`),this.z(void 0,B,T,j)}async z(B,T,N,j=I.CancellationToken.None){if(j&&j.isCancellationRequested)return Promise.resolve([]);const L=typeof N.exclude=="string"?N.exclude:N.exclude?N.exclude.pattern:void 0,z={ignoreSymlinks:typeof N.followSymlinks=="boolean"?!N.followSymlinks:void 0,disregardIgnoreFiles:typeof N.useIgnoreFiles=="boolean"?!N.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof N.useGlobalIgnoreFiles=="boolean"?!N.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof N.useParentIgnoreFiles=="boolean"?!N.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof N.useDefaultExcludes=="boolean"?!N.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof N.useDefaultSearchExcludes=="boolean"?!N.useDefaultSearchExcludes:!1,maxResults:N.maxResults,excludePattern:L,shouldGlobSearch:typeof N.fuzzy=="boolean"?!N.fuzzy:!0,_reason:"startFileSearch"};let Q;if(B){const{includePattern:Y,folder:J}=F(s.GlobPattern.from(B));Q=J,z.includePattern=Y}else{const{includePattern:Y,folder:J}=F(s.GlobPattern.from(T));Q=J,z.filePattern=Y}return this.o.$startFileSearch(Q??null,z,j).then(Y=>Array.isArray(Y)?Y.map(J=>b.URI.revive(J)):[])}async findTextInFiles(B,T,N,j,L=I.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${j.value}, entryPoint: findTextInFiles`);const z=this.j.getNext(),Q=typeof T.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:T.previewOptions,{includePattern:Y,folder:J}=F(s.GlobPattern.from(T.include)),x=typeof T.exclude=="string"?T.exclude:T.exclude?T.exclude.pattern:void 0,ce={ignoreSymlinks:typeof T.followSymlinks=="boolean"?!T.followSymlinks:void 0,disregardIgnoreFiles:typeof T.useIgnoreFiles=="boolean"?!T.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof T.useGlobalIgnoreFiles=="boolean"?!T.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof T.useParentIgnoreFiles=="boolean"?!T.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof T.useDefaultExcludes=="boolean"?!T.useDefaultExcludes:!0,fileEncoding:T.encoding,maxResults:T.maxResults,previewOptions:Q,afterContext:T.afterContext,beforeContext:T.beforeContext,includePattern:Y,excludePattern:x},te=!1;if(this.u[z]=pe=>{if(te)return;const ye=b.URI.revive(pe.resource);pe.results.forEach(_=>{const U=(0,c.$Rh)(_);(0,d.$HK)(U)?N({uri:ye,preview:{text:U.preview.text,matches:(0,o.$2b)(U.preview.matches,he=>new t.$wM(he.startLineNumber,he.startColumn,he.endLineNumber,he.endColumn))},ranges:(0,o.$2b)(U.ranges,he=>new t.$wM(he.startLineNumber,he.startColumn,he.endLineNumber,he.endColumn))}):N({uri:ye,text:U.text,lineNumber:U.lineNumber})})},L.isCancellationRequested)return{};try{const pe=await this.o.$startTextSearch(B,J??null,ce,z,L);return delete this.u[z],pe||{}}catch(pe){throw delete this.u[z],pe}}$handleTextSearchResult(B,T){this.u[T]?.(B)}async save(B){const T=await this.o.$save(B,{saveAs:!1});return b.URI.revive(T)}async saveAs(B){const T=await this.o.$save(B,{saveAs:!0});return b.URI.revive(T)}saveAll(B){return this.o.$saveAll(B)}resolveProxy(B){return this.o.$resolveProxy(B)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(B){return this.o.$requestWorkspaceTrust(B)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(B,T){if(this.w.has(B))throw new Error(`A provider has already been registered for scheme ${B}`);this.w.set(B,T);const N=this.t.transformOutgoingScheme(B),j=this.A++;return this.o.$registerEditSessionIdentityProvider(j,N),(0,O.$Sc)(()=>{this.w.delete(B),this.o.$unregisterEditSessionIdentityProvider(j)})}async $getEditSessionIdentifier(B,T){this.h.info("Getting edit session identifier for workspaceFolder",B);const N=await this.resolveWorkspaceFolder(b.URI.revive(B));if(!N){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",N);const j=this.w.get(N.uri.scheme);if(this.h.info(`Provider for scheme ${N.uri.scheme} is defined: `,!!j),!j)return;const L=await j.provideEditSessionIdentity(N,T);if(this.h.info("Provider returned edit session identifier: ",L),!!L)return L}async $provideEditSessionIdentityMatch(B,T,N,j){this.h.info("Getting edit session identifier for workspaceFolder",B);const L=await this.resolveWorkspaceFolder(b.URI.revive(B));if(!L){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",L);const z=this.w.get(L.uri.scheme);if(this.h.info(`Provider for scheme ${L.uri.scheme} is defined: `,!!z),!z)return;const Q=await z.provideEditSessionIdentityMatch?.(T,N,j);if(this.h.info("Provider returned edit session identifier match result: ",Q),!!Q)return Q}getOnWillCreateEditSessionIdentityEvent(B){return(T,N,j)=>{const L=function(Q){T.call(N,Q)};return L.extension=B,this.B.event(L,void 0,j)}}async $onWillCreateEditSessionIdentity(B,T,N){const j=await this.resolveWorkspaceFolder(b.URI.revive(B));if(j===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:j},T,async(L,z)=>{const Q=Date.now();await Promise.resolve(L),Date.now()-Q>N&&this.h.warn("SLOW edit session create-participant",z.extension.identifier)}),T.isCancellationRequested}registerCanonicalUriProvider(B,T){if(this.C.has(B))throw new Error(`A provider has already been registered for scheme ${B}`);this.C.set(B,T);const N=this.t.transformOutgoingScheme(B),j=this.A++;return this.o.$registerCanonicalUriProvider(j,N),(0,O.$Sc)(()=>{this.C.delete(B),this.o.$unregisterCanonicalUriProvider(j)})}async provideCanonicalUri(B,T,N){const j=this.C.get(B.scheme);if(!j)return;const L=await j.provideCanonicalUri?.(b.URI.revive(B),T,N);if(L)return L}async $provideCanonicalUri(B,T,N){return this.provideCanonicalUri(b.URI.revive(B),{targetScheme:T},N)}};e.$Xjc=S,e.$Xjc=S=Qe([He(0,r.$OO),He(1,n.$5O),He(2,i.$Djc),He(3,a.$Oj),He(4,g.$Vjc)],S),e.$Yjc=(0,y.$ii)("IExtHostWorkspace");function F(W){let B,T;return W&&(typeof W=="string"?B=W:(B=W.pattern,T=b.URI.revive(W.baseUri))),{includePattern:B,folder:T}}}),define(Ee[45],Ce([1,0,24,4,38,6,7,264,85,18,8,5,20,12,2]),function(re,e,o,R,I,M,O,p,$,w,A,P,b,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2jc=e.$1jc=e.$Zjc=void 0;function a(g,d){if(d){const h=d.split(".");let c=g;for(let u=0;c&&u<h.length;u++)c=c[h[u]];return c}}function m(g){return g instanceof y.URI}function l(g){return g&&g.uri instanceof y.URI&&g.languageId&&typeof g.languageId=="string"}function i(g){return g&&!g.uri&&g.languageId&&typeof g.languageId=="string"}function n(g){return g&&g.uri instanceof y.URI&&(!g.name||typeof g.name=="string")&&(!g.index||typeof g.index=="number")}function r(g){if(m(g))return{resource:g};if(l(g))return{resource:g.uri,overrideIdentifier:g.languageId};if(i(g))return{overrideIdentifier:g.languageId};if(n(g))return{resource:g.uri};if(g===null)return{resource:null}}let s=class{constructor(d,h,c){this.a=d.getProxy(M.$sM.MainThreadConfiguration),this.c=h,this.b=c,this.d=new A.$hh,this.e=null}getConfigProvider(){return this.d.wait().then(d=>this.e)}$initializeConfiguration(d){this.e=new t(this.a,this.c,d,this.b),this.d.open()}$acceptConfigurationChanged(d,h){this.getConfigProvider().then(c=>c.$acceptConfigurationChanged(d,h))}};e.$Zjc=s,e.$Zjc=s=Qe([He(0,b.$OO),He(1,I.$Yjc),He(2,C.$Oj)],s);class t{constructor(d,h,c,u){this.a=new R.$7d,this.b=d,this.f=u,this.c=h,this.e=p.$no.parse(c),this.d=this.k(c.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(d,h){const c={data:this.e.toData(),workspace:this.c.workspace};this.e=p.$no.parse(d),this.d=this.k(d.configurationScopes),this.a.fire(this.j(h,c))}getConfiguration(d,h,c){const u=r(h)||{},f=this.g(d?a(this.e.getValue(void 0,u,this.c.workspace),d):this.e.getValue(void 0,u,this.c.workspace));d&&this.h(d,u,c?.identifier);function E(D){if(D==null)return null;if(typeof D=="boolean")return D?2:5;switch(D){case O.ConfigurationTarget.Global:return 2;case O.ConfigurationTarget.Workspace:return 5;case O.ConfigurationTarget.WorkspaceFolder:return 6}}const v={has(D){return typeof a(f,D)<"u"},get:(D,k)=>{this.h(d?`${d}.${D}`:D,u,c?.identifier);let S=a(f,D);if(typeof S>"u")S=k;else{let F;const W=(B,T)=>{if((0,w.$Xf)(B)){let N;const j=()=>{F=F||(0,o.$Pn)(f),N=N||a(F,T)};return new Proxy(B,{get:(L,z)=>{if(typeof z=="string"&&z.toLowerCase()==="tojson")return j(),()=>N;if(F)return N=N||a(F,T),N[z];const Q=L[z];return typeof z=="string"?W(Q,`${T}.${z}`):Q},set:(L,z,Q)=>(j(),N&&(N[z]=Q),!0),deleteProperty:(L,z)=>(j(),N&&delete N[z],!0),defineProperty:(L,z,Q)=>(j(),N&&Object.defineProperty(N,z,Q),!0)})}return Array.isArray(B)?(0,o.$Pn)(B):B};S=W(S,D)}return S},update:(D,k,S,F)=>{D=d?`${d}.${D}`:D;const W=E(S);return k!==void 0?this.b.$updateConfigurationOption(W,D,k,u,F):this.b.$removeConfigurationOption(W,D,u,F)},inspect:D=>{D=d?`${d}.${D}`:D;const k=this.e.inspect(D,u,this.c.workspace);if(k)return{key:D,defaultValue:(0,o.$Pn)(k.policy?.value??k.default?.value),globalValue:(0,o.$Pn)(k.user?.value??k.application?.value),workspaceValue:(0,o.$Pn)(k.workspace?.value),workspaceFolderValue:(0,o.$Pn)(k.workspaceFolder?.value),defaultLanguageValue:(0,o.$Pn)(k.default?.override),globalLanguageValue:(0,o.$Pn)(k.user?.override??k.application?.override),workspaceLanguageValue:(0,o.$Pn)(k.workspace?.override),workspaceFolderLanguageValue:(0,o.$Pn)(k.workspaceFolder?.override),languageIds:(0,o.$Pn)(k.overrideIdentifiers)}}};return typeof f=="object"&&(0,o.$Sn)(v,f,!1),Object.freeze(v)}g(d){const h=c=>(0,w.$Xf)(c)?new Proxy(c,{get:(u,f)=>h(u[f]),set:(u,f,E)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(f)}' of object`)},deleteProperty:(u,f)=>{throw new Error(`TypeError: Cannot delete read only property '${String(f)}' of object`)},defineProperty:(u,f)=>{throw new Error(`TypeError: Cannot define property '${String(f)}' for a readonly object`)},setPrototypeOf:u=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):c;return h(d)}h(d,h,c){const u=$.$eo.test(d)?4:this.d.get(d),f=c?`[${c.value}] `:"";if(u===4){typeof h?.resource>"u"&&this.f.warn(`${f}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${d}', provide the URI of a resource or 'null' for any resource.`);return}if(u===3){h?.resource&&this.f.warn(`${f}Accessing a window scoped configuration for a resource is not expected. To associate '${d}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(d,h){const c=new p.$po(d,h,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(u,f)=>c.affectsConfiguration(u,r(f))})}k(d){return d.reduce((h,c)=>(h.set(c[0],c[1]),h),new Map)}}e.$1jc=t,e.$2jc=(0,P.$ii)("IExtHostConfiguration")});var it=this&&this.__classPrivateFieldSet||function(re,e,o,R,I){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!I:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?I.call(re,o):I?I.value=o:e.set(re,o),o},qe=this&&this.__classPrivateFieldGet||function(re,e,o,R){if(o==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!R:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?R:o==="a"?R.call(re):R?R.value:e.get(re)};define(Ee[95],Ce([1,0,2,8,4,6,7,38,72,45,22,44,20,28,5,15,11,12,91,306,13]),function(re,e,o,R,I,M,O,p,$,w,A,P,b,C,y,a,m,l,i,n,r){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.$slc=e.$rlc=e.$qlc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var t;(function(B){function T(j){if(j!=null)return j}B.from=T;function N(j){if(j!=null)return j}B.to=N})(t||(t={}));var g;(function(B){function T(j){if(j!=null)return j}B.from=T;function N(j){if(j!=null)return j}B.to=N})(g||(g={}));var d;(function(B){function T(j){if(j!=null)return j}B.from=T;function N(j){if(j!=null)return j}B.to=N})(d||(d={}));var h;(function(B){function T(L){if(L){const z=L;return z&&!!z.process}else return!1}B.is=T;function N(L){if(L==null)return;const z={process:L.process,args:L.args};return L.options&&(z.options=d.from(L.options)),z}B.from=N;function j(L){if(L!=null)return new O.$dN(L.process,L.args,L.options)}B.to=j})(h||(h={}));var c;(function(B){function T(j){if(j!=null)return j}B.from=T;function N(j){if(j!=null)return j}B.to=N})(c||(c={}));var u;(function(B){function T(L){if(L){const z=L;return z&&(!!z.commandLine||!!z.command)}else return!1}B.is=T;function N(L){if(L==null)return;const z={};return L.commandLine!==void 0?z.commandLine=L.commandLine:(z.command=L.command,z.args=L.args),L.options&&(z.options=c.from(L.options)),z}B.from=N;function j(L){if(!(L==null||L.command===void 0&&L.commandLine===void 0))return L.commandLine?new O.$eN(L.commandLine,L.options):new O.$eN(L.command,L.args?L.args:[],L.options)}B.to=j})(u||(u={}));var f;(function(B){function T(L){if(L){const z=L;return z&&z.customExecution==="customExecution"}else return!1}B.is=T;function N(L){return{customExecution:"customExecution"}}B.from=N;function j(L,z){return z.get(L)}B.to=j})(f||(e.CustomExecutionDTO=f={}));var E;(function(B){function T(N,j){let L;return N.scope!==void 0&&typeof N.scope!="number"?L=N.scope.uri:N.scope!==void 0&&typeof N.scope=="number"&&(N.scope===O.TaskScope.Workspace&&j&&j.workspaceFile?L=j.workspaceFile:L=n.$zH),{id:N._id,workspaceFolder:L}}B.from=T})(E||(e.TaskHandleDTO=E={}));var v;(function(B){function T(N){if(N!=null)return{_id:N.id,isDefault:N.isDefault}}B.from=T})(v||(v={}));var D;(function(B){function T(L,z){if(L==null)return[];const Q=[];for(const Y of L){const J=N(Y,z);J&&Q.push(J)}return Q}B.fromMany=T;function N(L,z){if(L==null)return;let Q;L.execution instanceof O.$dN?Q=h.from(L.execution):L.execution instanceof O.$eN?Q=u.from(L.execution):L.execution&&L.execution instanceof O.$fN&&(Q=f.from(L.execution));const Y=t.from(L.definition);let J;return L.scope?typeof L.scope=="number"?J=L.scope:J=L.scope.uri:J=O.TaskScope.Workspace,!Y||!J?void 0:{_id:L._id,definition:Y,name:L.name,source:{extensionId:z.identifier.value,label:L.source,scope:J},execution:Q,isBackground:L.isBackground,group:v.from(L.group),presentationOptions:g.from(L.presentationOptions),problemMatchers:L.problemMatchers,hasDefinedMatchers:L.hasDefinedMatchers,runOptions:L.runOptions?L.runOptions:{reevaluateOnRerun:!0},detail:L.detail}}B.from=N;async function j(L,z,Q){if(L==null)return;let Y;h.is(L.execution)?Y=h.to(L.execution):u.is(L.execution)?Y=u.to(L.execution):f.is(L.execution)&&(Y=f.to(L._id,Q));const J=t.to(L.definition);let x;if(L.source&&(L.source.scope!==void 0?typeof L.source.scope=="number"?x=L.source.scope:x=await z.resolveWorkspaceFolder(o.URI.revive(L.source.scope)):x=O.TaskScope.Workspace),!J||!x)return;const ce=new O.$gN(J,x,L.name,L.source.label,Y,L.problemMatchers);return L.isBackground!==void 0&&(ce.isBackground=L.isBackground),L.group!==void 0&&(ce.group=O.$cN.from(L.group._id),ce.group&&L.group.isDefault&&(ce.group=new O.$cN(ce.group.id,ce.group.label),L.group.isDefault===!0&&(ce.group.isDefault=L.group.isDefault))),L.presentationOptions&&(ce.presentationOptions=g.to(L.presentationOptions)),L._id&&(ce._id=L._id),L.detail&&(ce.detail=L.detail),ce}B.to=j})(D||(e.TaskDTO=D={}));var k;(function(B){function T(j){return j}B.from=T;function N(j){if(j)return Object.assign(Object.create(null),j)}B.to=N})(k||(k={}));class S{constructor(T,N,j){this._id=N,this.a=j,s.set(this,void 0),it(this,s,T,"f")}get task(){return this.a}terminate(){qe(this,s,"f").terminateTask(this)}fireDidStartProcess(T){}fireDidEndProcess(T){}}s=new WeakMap;let F=class{constructor(T,N,j,L,z,Q,Y,J){this.q=new I.$7d,this.r=new I.$7d,this.s=new I.$7d,this.u=new I.$7d,this.a=T.getProxy(M.$sM.MainThreadTask),this.b=j,this.c=L,this.d=z,this.e=Q,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=Y,this.g=J,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(T,N,j){if(!j)return new O.$uM(()=>{});const L=this.x();return this.j.set(L,{type:N,provider:j,extension:T}),this.a.$registerTaskProvider(L,N),new O.$uM(()=>{this.j.delete(L),this.a.$unregisterTaskProvider(L)})}registerTaskSystem(T,N){this.a.$registerTaskSystem(T,N)}fetchTasks(T){return this.a.$fetchTasks(k.from(T)).then(async N=>{const j=[];for(const L of N){const z=await D.to(L,this.b,this.m);z&&j.push(z)}return j})}get taskExecutions(){const T=[];return this.k.forEach(N=>T.push(N)),T}terminateTask(T){if(!(T instanceof S))throw new Error("No valid task execution provided");return this.a.$terminateTask(T._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(T,N,j){const L=this.m.get(T.id);L&&(this.o.set(T.id,L),this.e.attachPtyToTerminal(N,await L.callback(j))),this.p=T.id,this.q.fire({execution:await this.z(T)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(T){if(!this.l.has(T.id))return;const N=await this.z(T);this.l.delete(T.id),this.k.delete(T.id),this.B(T),this.r.fire({execution:N})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(T){const N=await this.z(T.id);this.s.fire({execution:N,processId:T.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(T){const N=await this.z(T.id);this.u.fire({execution:N,exitCode:T.exitCode})}$provideTasks(T,N){const j=this.j.get(T);if(!j)return Promise.reject(new Error("no handler found"));const L=[],z=(0,R.$ah)(()=>j.provider.provideTasks(A.CancellationToken.None)).then(Q=>this.v(N,L,j,Q));return new Promise(Q=>{z.then(Y=>{Promise.all(L).then(()=>{Q(Y)})})})}async $resolveTask(T,N){const j=this.j.get(T);if(!j)return Promise.reject(new Error("no handler found"));if(N.definition.type!==j.type)throw new Error(`Unexpected: Task of type [${N.definition.type}] cannot be resolved by provider of type [${j.type}].`);const L=await D.to(N,this.b,this.m);if(!L)throw new Error("Unexpected: Task cannot be resolved.");const z=await j.provider.resolveTask(L,A.CancellationToken.None);if(!z)return;this.A(z,j);const Q=D.from(z,j.extension);if(!Q)throw new Error("Unexpected: Task cannot be resolved.");if(z.definition!==L.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return f.is(Q.execution)&&await this.y(Q,z,!0),await this.w(Q)}x(){return this.h++}async y(T,N,j){const L=await this.a.$createTaskId(T);!j&&!this.m.has(L)&&(this.n.add(L),this.o.set(L,N.execution)),this.m.set(L,N.execution)}async z(T,N){if(typeof T=="string"){const z=this.l.get(T);if(!z)throw new r.$bb("Unexpected: The specified task is missing an execution");return z}const j=this.l.get(T.id);if(j)return j;let L;return N?L=Promise.resolve(new S(this,T.id,N)):L=D.to(T.task,this.b,this.m).then(z=>{if(!z)throw new r.$bb("Unexpected: Task does not exist.");return new S(this,T.id,z)}),this.l.set(T.id,L),L.then(z=>(this.k.set(T.id,z),z))}A(T,N){T._deprecated&&this.g.report("Task.constructor",N.extension,"Use the Task constructor that takes a `scope` instead.")}B(T){this.o.get(T.id)&&this.o.delete(T.id),this.n.has(T.id)&&this.p!==T.id&&(this.m.delete(T.id),this.n.delete(T.id));const j=this.n.values();let L=j.next();for(;!L.done;)!this.o.has(L.value)&&this.p!==L.value&&(this.m.delete(L.value),this.n.delete(L.value)),L=j.next()}};e.$qlc=F,e.$qlc=F=Qe([He(0,b.$OO),He(1,C.$5O),He(2,p.$Yjc),He(3,$.$ZO),He(4,w.$2jc),He(5,P.$nkc),He(6,l.$Oj),He(7,i.$zjc)],F);let W=class extends F{constructor(T,N,j,L,z,Q,Y,J){super(T,N,j,L,z,Q,Y,J),this.registerTaskSystem(a.Schemas.vscodeRemote,{scheme:a.Schemas.vscodeRemote,authority:"",platform:m.$b(0)})}async executeTask(T,N){if(!N.execution)throw new Error("Tasks to execute must include an execution");const j=D.from(N,T);if(j===void 0)throw new Error("Task is not valid");if(f.is(j.execution))await this.y(j,N,!1);else throw new r.$_;const L=await this.z(await this.a.$getTaskExecution(j),N);return this.a.$executeTask(j).catch(z=>{throw new Error(z)}),L}v(T,N,j,L){const z=[];if(L)for(const Q of L){if(this.A(Q,j),!Q.definition||!T[Q.definition.type]){const J=Q.source?Q.source:"No task source";this.f.warn(`The task [${J}, ${Q.name}] uses an undefined task type. The task will be ignored in the future.`)}const Y=D.from(Q,j.extension);Y&&f.is(Y.execution)?(z.push(Y),N.push(this.y(Y,Q,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:z,extension:j.extension}}async w(T){if(f.is(T.execution))return T;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(T,N){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(T,N,j){}};e.$rlc=W,e.$rlc=W=Qe([He(0,b.$OO),He(1,C.$5O),He(2,p.$Yjc),He(3,$.$ZO),He(4,w.$2jc),He(5,P.$nkc),He(6,l.$Oj),He(7,i.$zjc)],W),e.$slc=(0,y.$ii)("IExtHostTask")}),define(Ee[368],Ce([1,0,36,29]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9K=void 0,e.$8K=I,e.$0K=M;function I(O){return"cellResults"in O}e.$9K="rawCell#";function M(O,p){let $=-1;const w=[];let A=[];return O.forEach(b=>{b.range.startLineNumber!==$&&A.length>0&&(w.push([...A]),A=[]),A.push(b),$=b.range.endLineNumber}),A.length>0&&w.push([...A]),w.map(b=>{const C=[],y=b[0].range.startLineNumber,a=b[b.length-1].range.endLineNumber;for(let m=y;m<=a;m++)C.push(p.getLineContent(m));return new o.$LK(C.join(`
`)+`
`,b.map(m=>new R.$dt(m.range.startLineNumber-1,m.range.startColumn-1,m.range.endLineNumber-1,m.range.endColumn-1)))})}}),define(Ee[369],Ce([1,0,224,21,4,3,27,14,18,2,32,111,6,33,16,7,68,339,154,24,15,296,368,365]),function(re,e,o,R,I,M,O,p,$,w,A,P,b,C,y,a,m,l,i,n,r,s,t,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5kc=void 0;class d{get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(c=>c.apiEditor)}constructor(c,u,f,E,v,D){this.q=f,this.r=E,this.s=v,this.t=D,this.f=new Map,this.g=new O.$Bc,this.h=new Map,this.j=new I.$7d,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new I.$7d,this.onDidOpenNotebookDocument=this.m.event,this.n=new I.$7d,this.onDidCloseNotebookDocument=this.n.event,this.o=new I.$7d,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new P.$xjc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=c.getProxy(b.$sM.MainThreadNotebook),this.c=c.getProxy(b.$sM.MainThreadNotebookDocuments),this.d=c.getProxy(b.$sM.MainThreadNotebookEditors),this.i=u.converter,u.registerArgumentProcessor({processArgument:k=>{if(k&&k.$mid===13){const S=k.notebookEditor?.notebookUri,F=k.cell.handle,B=this.g.get(S)?.getCell(F);if(B)return B.apiCell}if(k&&k.$mid===14){const S=k.uri,F=this.g.get(S);if(F)return F.apiNotebook}return k}}),d.B(u)}getEditorById(c){const u=this.h.get(c);if(!u)throw new Error(`unknown text editor: ${c}. known editors: ${[...this.h.keys()]} `);return u}getIdByEditor(c){for(const[u,f]of this.h)if(f.apiEditor===c)return u}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(c,u){const f=this.g.get(c);if(!f&&!u)throw new Error(`NO notebook document for '${c}'`);return f}static u(c,u){if(!u)return;const f=u.filenamePattern.map(E=>y.NotebookExclusiveDocumentPattern.from(E)).filter(E=>E!==void 0);if(u.filenamePattern&&!f){console.warn(`Notebook content provider view options file name pattern is invalid ${u.filenamePattern}`);return}return{extension:c.identifier,providerDisplayName:c.displayName||c.name,displayName:u.displayName,filenamePattern:f,exclusive:u.exclusive||!1}}registerNotebookCellStatusBarItemProvider(c,u,f){const E=d.a++,v=typeof f.onDidChangeCellStatusBarItems=="function"?d.a++:void 0;this.f.set(E,f),this.b.$registerNotebookCellStatusBarItemProvider(E,v,u);let D;return v!==void 0&&(D=f.onDidChangeCellStatusBarItems(k=>this.b.$emitCellStatusBarEvent(v))),new a.$uM(()=>{this.f.delete(E),this.b.$unregisterNotebookCellStatusBarItemProvider(E,v),D?.dispose()})}async createNotebookDocument(c){const u=await this.c.$tryCreateNotebook({viewType:c.viewType,content:c.content&&y.NotebookData.from(c.content)});return w.URI.revive(u)}async openNotebookDocument(c){const u=this.g.get(c);if(u)return u.apiNotebook;const f=await this.c.$tryOpenNotebook(c),E=this.g.get(w.URI.revive(f));return(0,$.$7f)(E?.apiNotebook)}async showNotebookDocument(c,u){w.URI.isUri(c)&&(c=await this.openNotebookDocument(c));let f;typeof u=="object"?f={position:y.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus,selections:u.selections&&u.selections.map(y.NotebookRange.from),pinned:typeof u.preview=="boolean"?!u.preview:void 0}:f={preserveFocus:!1};const E=await this.d.$tryShowNotebookDocument(c.uri,c.notebookType,f),v=E&&this.h.get(E)?.apiEditor;if(v)return v;throw E?new Error(`Could NOT open editor for "${c.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${c.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(c,u,f,E){const v=this.f.get(c),D=w.URI.revive(u),k=this.g.get(D);if(!k||!v)return;const S=k.getCellFromIndex(f);if(!S)return;const F=await v.provideCellStatusBarItems(S.apiCell,E);if(!F)return;const W=new M.$Tc,B=this.p.add([W]),N=(Array.isArray(F)?F:[F]).map(j=>y.NotebookStatusBarItem.from(j,this.i,W));return{cacheId:B,items:N}}$releaseNotebookCellStatusBarItems(c){this.p.delete(c)}registerNotebookSerializer(c,u,f,E,v){if((0,p.$Ue)(u))throw new Error("viewType cannot be empty or just whitespace");const D=this.w++;return this.x.set(D,{viewType:u,serializer:f,options:E}),this.b.$registerNotebookSerializer(D,{id:c.identifier,location:c.extensionLocation},u,y.NotebookDocumentContentOptions.from(E),d.u(c,v)),(0,M.$Sc)(()=>{this.b.$unregisterNotebookSerializer(D)})}async $dataToNotebook(c,u,f){const E=this.x.get(c);if(!E)throw new Error("NO serializer found");const v=await E.serializer.deserializeNotebook(u.buffer,f);return new m.$fw(y.NotebookData.from(v))}async $notebookToData(c,u,f){const E=this.x.get(c);if(!E)throw new Error("NO serializer found");const v=await E.serializer.serializeNotebook(y.NotebookData.to(u.value),f);return R.$ue.wrap(v)}async $saveNotebook(c,u,f,E,v){const D=w.URI.revive(u),k=this.x.get(c);if(!k)throw new Error("NO serializer found");const S=this.g.get(D);if(!S)throw new Error("Document NOT found");if(S.versionId!==f)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(D.scheme))throw new A.$0k((0,o.localize)(0,null,this.z(D)),6);await this.y(D,E);const F={metadata:(0,n.$Xn)(S.apiNotebook.metadata,j=>!(k.options?.transientDocumentMetadata??{})[j]),cells:[]};for(const j of S.apiNotebook.getCells()){const L=new a.$WN(j.kind,j.document.getText(),j.document.languageId,j.mime,k.options?.transientOutputs?[]:[...j.outputs],j.metadata,j.executionSummary);L.metadata=(0,n.$Xn)(j.metadata,z=>!(k.options?.transientCellMetadata??{})[z]),F.cells.push(L)}const W=await k.serializer.serializeNotebook(F,v);await this.s.value.writeFile(D,W);const B=this.s.getFileSystemProviderExtUri(D.scheme),T=await this.s.value.stat(D);return{name:B.basename(D),isFile:(T.type&A.FileType.File)!==0,isDirectory:(T.type&A.FileType.Directory)!==0,isSymbolicLink:(T.type&A.FileType.SymbolicLink)!==0,mtime:T.mtime,ctime:T.ctime,size:T.size,readonly:!!((T.permissions??0)&A.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(D.scheme),locked:!!((T.permissions??0)&A.FilePermission.Locked),etag:A.$il({mtime:T.mtime,size:T.size}),children:void 0}}async $searchInNotebooks(c,u,f,E,v){const D=this.x.get(c)?.serializer;if(!D)return{limitHit:!1,results:[]};const k=new O.$Cc;await(async(T,N,j)=>{await Promise.all(T.map(async L=>await Promise.all(L.filenamePatterns.map(z=>{const Q={_reason:j._reason,folderQueries:j.folderQueries,includePattern:j.includePattern,excludePattern:j.excludePattern,maxResults:j.maxResults,type:1,filePattern:z};return this.t.doInternalFileSearchWithCustomCallback(Q,N,Y=>{Y.forEach(J=>{k.has(J)||E.some(ce=>L.isFromSettings&&!ce.isFromSettings?!1:ce.filenamePatterns.some(te=>(0,g.$Ufb)(te,J)))||k.add(J)})}).catch(Y=>{if(Y.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw Y})}))))})(f,v,u);const F=new O.$Bc;let W=!1;const B=Array.from(k).map(async T=>{const N=[];try{if(v.isCancellationRequested)return;if(u.maxResults&&[...F.values()].reduce((Q,Y)=>Q+Y.cellResults.length,0)>u.maxResults){W=!0;return}const j=[],L=this.g.get(T);if(L)L.apiNotebook.getCells().forEach(Y=>j.push({input:Y.document.getText(),outputs:Y.outputs.flatMap(J=>J.items.map(x=>x.data.toString()))}));else{const Q=await this.s.value.readFile(T),Y=R.$ue.fromString(Q.toString()),J=await D.deserializeNotebook(Y.buffer,v);if(v.isCancellationRequested)return;y.NotebookData.from(J).cells.forEach(ce=>j.push({input:ce.source,outputs:ce.outputs.flatMap(te=>te.items.map(pe=>pe.valueBytes.toString()))}))}if(v.isCancellationRequested)return;j.forEach((Q,Y)=>{const J=u.contentPattern.pattern,x=new s.$6Ub(Q.input,void 0,Q.outputs),ce=x.findInInputs(J),te=x.findInOutputs(J),pe=te.flatMap(ye=>(0,t.$0K)(ye.matches,ye.textBuffer)).map((ye,_)=>(ye.webviewIndex=_,ye));if(ce.length>0||te.length>0){const ye={index:Y,contentResults:(0,t.$0K)(ce,x.inputTextBuffer),webviewResults:pe};N.push(ye)}});const z={resource:T,cellResults:N};F.set(T,z);return}catch{return}});return await Promise.all(B),{limitHit:W,results:[...F.values()]}}async y(c,u){const f=await this.s.value.stat(c);if(typeof u?.mtime=="number"&&typeof u.etag=="string"&&u.etag!==A.$hl&&typeof f.mtime=="number"&&typeof f.size=="number"&&u.mtime<f.mtime&&u.etag!==A.$il({mtime:u.mtime,size:f.size}))throw new A.$0k((0,o.localize)(1,null),3,u)}z(c){return c.scheme===r.Schemas.file?c.fsPath:c.toString()}A(c,u,f){if(this.h.has(u))throw new Error(`editor with id ALREADY EXSIST: ${u}`);const E=new i.$Vkc(u,this.d,c,f.visibleRanges.map(y.NotebookRange.to),f.selections.map(y.NotebookRange.to),typeof f.viewColumn=="number"?y.ViewColumn.to(f.viewColumn):void 0);this.h.set(u,E)}$acceptDocumentAndEditorsDelta(c){if(c.value.removedDocuments)for(const f of c.value.removedDocuments){const E=w.URI.revive(f),v=this.g.get(E);v&&(v.dispose(),this.g.delete(E),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:v.apiNotebook.getCells().map(D=>D.document.uri)}),this.n.fire(v.apiNotebook));for(const D of this.h.values())D.notebookData.uri.toString()===E.toString()&&this.h.delete(D.id)}if(c.value.addedDocuments){const f=[];for(const E of c.value.addedDocuments){const v=w.URI.revive(E.uri);if(this.g.has(v))throw new Error(`adding EXISTING notebook ${v} `);const D=new l.$Ukc(this.c,this.q,this.r,v,E);f.push(...E.cells.map(k=>l.$Tkc.asModelAddData(k))),this.g.get(v)?.dispose(),this.g.set(v,D),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:f}),this.m.fire(D.apiNotebook)}}if(c.value.addedEditors)for(const f of c.value.addedEditors){if(this.h.has(f.id))return;const E=w.URI.revive(f.documentUri),v=this.g.get(E);v&&this.A(v,f.id,f)}const u=[];if(c.value.removedEditors)for(const f of c.value.removedEditors){const E=this.h.get(f);E&&(this.h.delete(f),this.k?.id===E.id&&(this.k=void 0),u.push(E))}if(c.value.visibleEditors){this.l=c.value.visibleEditors.map(E=>this.h.get(E)).filter(E=>!!E);const f=new Set;this.l.forEach(E=>f.add(E.id));for(const E of this.h.values()){const v=f.has(E.id);E._acceptVisibility(v)}this.l=[...this.h.values()].map(E=>E).filter(E=>E.visible),this.o.fire(this.visibleNotebookEditors)}c.value.newActiveEditor===null?this.k=void 0:c.value.newActiveEditor&&(this.h.get(c.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${c.value.newActiveEditor}`),this.k=this.h.get(c.value.newActiveEditor)),c.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(c){const u=C.$aP.String.with("notebookType","A notebook type"),f=new C.$cP("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[u,new C.$aP("data","Bytes to convert to data",v=>v instanceof Uint8Array,v=>R.$ue.wrap(v))],new C.$bP("Notebook Data",v=>y.NotebookData.to(v.value))),E=new C.$cP("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[u,new C.$aP("NotebookData","Notebook data to convert to bytes",v=>!0,v=>new m.$fw(y.NotebookData.from(v)))],new C.$bP("Bytes",v=>v.buffer));c.registerApiCommand(f),c.registerApiCommand(E)}}e.$5kc=d,d.a=0}),define(Ee[370],Ce([1,0,17,22,47,35,23,40,36]),function(re,e,o,R,I,M,O,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wkc=void 0;class w{constructor(b,C,y){this.k=b,this.l=C,this.o=y,this.e=!1,this.f=0,this.g=!1,this.a=b.filePattern,this.b=b.includePattern&&M.$ck(b.includePattern),this.c=b.maxResults||void 0,this.d=b.exists,this.h=new Set,this.j=b.excludePattern&&M.$ck(b.excludePattern)}cancel(){this.g=!0,this.h.forEach(b=>b.cancel()),this.h=new Set}search(b){const C=this.k.folderQueries||[];return new Promise((y,a)=>{const m=l=>{this.f++,b(l)};if(this.g)return y({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(l=>{const i=l.toString(),n=o.$oc(i);this.j&&this.j(i,n)||this.v(m,{base:l,basename:n})}),Promise.all(C.map(l=>this.p(l,m))).then(l=>{y({limitHit:this.e,stats:l[0]||void 0})},l=>{a(new Error((0,I.$6i)(l)))})})}async p(b,C){const y=new R.$ee,a=this.q(b),m=this.r(),l=new $.$ZK(this.k,b),i=!l.hasSiblingExcludeClauses();let n;try{this.h.add(y),n=p.$3d.create();const r=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},a,y.token),s=n.elapsed(),t=p.$3d.create();return this.g&&!this.e||(r&&r.forEach(g=>{const d=o.$hc.relative(b.folder.path,g.path);if(i){const h=o.$oc(g.path);this.v(C,{base:b.folder,relativePath:d,basename:h});return}this.s(m,b.folder,d,C)}),this.g&&!this.e)?null:(this.u(m,l,C),{providerTime:s,postProcessTime:t.elapsed()})}finally{y.dispose(),this.h.delete(y)}}q(b){const C=(0,$.$YK)(this.k.includePattern,b.includePattern),y=(0,$.$YK)(this.k.excludePattern,b.excludePattern);return{folder:b.folder,excludes:y,includes:C,useIgnoreFiles:!b.disregardIgnoreFiles,useGlobalIgnoreFiles:!b.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!b.disregardParentIgnoreFiles,followSymlinks:!b.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const b={rootEntries:[],pathToEntries:Object.create(null)};return b.pathToEntries["."]=b.rootEntries,b}s({pathToEntries:b},C,y,a){if(y===this.a){const l=o.$oc(this.a);this.v(a,{base:C,relativePath:this.a,basename:l})}function m(l){const i=o.$oc(l),n=o.$nc(l);let r=b[n];r||(r=b[n]=[],m(n)),r.push({base:C,relativePath:l,basename:i})}m(y)}u({rootEntries:b,pathToEntries:C},y,a){const m=this,l=this.a;function i(n){const r=(0,$.$2K)(()=>n.map(s=>s.basename));for(let s=0,t=n.length;s<t;s++){const g=n[s],{relativePath:d,basename:h}=g;if(y.matchesExcludesSync(d,h,l!==h?r:void 0))continue;const c=C[d];if(c)i(c);else{if(d===l)continue;m.v(a,g)}if(m.e)break}}i(b)}v(b,C){(!this.b||C.relativePath&&this.b(C.relativePath,C.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||b(C))}}class A{constructor(){this.b=new Map}fileSearch(b,C,y,a){const m=this.c(b.cacheKey),l=new w(b,C,m&&m.token);let i=0;const n=r=>{i+=r.length,y(r.map(s=>this.d(s)))};return this.e(l,A.a,n,a).then(r=>({limitHit:r.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:i,detailStats:r.stats}}))}clearCache(b){this.c(b)?.cancel()}c(b){if(b)return this.b.has(b)||this.b.set(b,new R.$ee),this.b.get(b)}d(b){return b.relativePath?{resource:O.$Vg(b.base,b.relativePath)}:{resource:b.base}}e(b,C,y,a){const m=a.onCancellationRequested(()=>{b.cancel()}),l=n=>{n&&(i.push(n),C>0&&i.length>=C&&(y(i),i=[]))};let i=[];return b.search(l).then(n=>(i.length&&y(i),m.dispose(),n),n=>(i.length&&y(i),m.dispose(),Promise.reject(n)))}}e.$Wkc=A,A.a=512}),define(Ee[371],Ce([1,0,19,73,35,102,27,15,17,23,14,18,2,105,244,53,12,43,147,366,36]),function(re,e,o,R,I,M,O,p,$,w,A,P,b,C,y,a,m,l,i,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9L=void 0,e.$0L=E;let s=class{constructor(D,k,S,F,W){this.a=D,this.b=k,this.c=S,this.d=F,this.e=W}text(D,k,S={}){D=this.f(D,S);const F=this.a.getValue(),W=k&&k.some(T=>!this.a.getValue({resource:T}).search.useRipgrep);return{...this.h(k?.map(l.$Di),S),type:2,contentPattern:D,previewOptions:S.previewOptions,maxFileSize:S.maxFileSize,usePCRE2:F.search.usePCRE2||W||!1,beforeContext:S.beforeContext,afterContext:S.afterContext,userDisabledExcludesAndIgnoreFiles:S.disregardExcludeSettings&&S.disregardIgnoreFiles}}f(D,k){const S=this.a.getValue();D.isRegExp&&(D.pattern=D.pattern.replace(/\r?\n/g,"\\n"));const F={...D,wordSeparators:S.editor.wordSeparators};return this.j(D,k)&&(F.isCaseSensitive=!0),this.k(D)&&(F.isMultiline=!0),k.notebookSearchConfig?.includeMarkupInput&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookMarkdownInput=k.notebookSearchConfig.includeMarkupInput),k.notebookSearchConfig?.includeMarkupPreview&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookMarkdownPreview=k.notebookSearchConfig.includeMarkupPreview),k.notebookSearchConfig?.includeCodeInput&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookCellInput=k.notebookSearchConfig.includeCodeInput),k.notebookSearchConfig?.includeOutput&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookCellOutput=k.notebookSearchConfig.includeOutput),F}file(D,k={}){return{...this.h(D,k),type:1,filePattern:k.filePattern?k.filePattern.trim():k.filePattern,exists:k.exists,sortByScore:k.sortByScore,cacheKey:k.cacheKey,shouldGlobMatchFilePattern:k.shouldGlobSearch}}g(D,k){return D?(D=Array.isArray(D)?D.map(c):c(D),k?this.parseSearchPaths(D):{pattern:g(...Array.isArray(D)?D:[D])}):{}}h(D=[],k={}){const S=this.g(k.includePattern,k.expandPatterns),F=this.g(k.excludePattern,k.expandPatterns),W=D.length>1,B=(S.searchPaths&&S.searchPaths.length?S.searchPaths.map(j=>this.q(j,k,F)):D.map(j=>this.r(j,k,F,W))).filter(j=>!!j),T={_reason:k._reason,folderQueries:B,usingSearchPaths:!!(S.searchPaths&&S.searchPaths.length),extraFileResources:k.extraFileResources,excludePattern:F.pattern,includePattern:S.pattern,onlyOpenEditors:k.onlyOpenEditors,maxResults:k.maxResults};if(k.onlyOpenEditors){const j=o.$Hb(o.$Rb(this.c.groups.map(Q=>Q.editors.map(Y=>Y.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(j));const L=j.filter(Q=>(0,r.$PK)(T,Q.fsPath)),z=this.i(L);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(z)),{...T,...z}}const N=k.extraFileResources&&k.extraFileResources.filter(j=>(0,r.$PK)(T,j.fsPath));return T.extraFileResources=N&&N.length?N:void 0,T}i(D){const k=[],S=new O.$Bc,F={};let W=!1;return D.forEach(B=>{if(B.scheme===p.Schemas.walkThrough)return;if((0,w.$Zg)(B)){const N=this.b.getWorkspaceFolder(B)?.uri??B.with({path:$.$nc(B.fsPath)});let j=S.get(N);j||(W=!0,j={folder:N,includePattern:{}},k.push(j),S.set(N,j));const L=$.$mc(N.fsPath,B.fsPath);(0,P.$7f)(j.includePattern)[L.replace(/\\/g,"/")]=!0}else B.fsPath&&(W=!0,F[B.fsPath]=!0)}),{folderQueries:k,includePattern:F,usingSearchPaths:!0,excludePattern:W?void 0:{"**/*":!0}}}j(D,k){if(k.isSmartCase){if(D.isRegExp){if(A.$Mf(D.pattern,!0))return!0}else if(A.$Mf(D.pattern))return!0}return!!D.isCaseSensitive}k(D){return D.isMultiline||D.isRegExp&&(0,C.$uC)(D.pattern)||D.pattern.indexOf(`
`)>=0?!0:!!D.isMultiline}parseSearchPaths(D){const k=z=>$.$jc(z)||/^\.\.?([\/\\]|$)/.test(z),F=(Array.isArray(D)?D:d(D)).map(z=>{const Q=this.e.resolvedUserHome;return Q?(0,M.$kw)(z,Q.scheme===p.Schemas.file?Q.fsPath:Q.path):z}),W=R.$E(F,z=>k(z)?"searchPaths":"exprSegments"),B=(W.exprSegments||[]).map(z=>A.$6e(z,"/")).map(z=>A.$6e(z,"\\")).map(z=>(z[0]==="."&&(z="*"+z),h(z))),T={},N=this.m(W.searchPaths||[]);N&&N.length&&(T.searchPaths=N);const j=o.$Rb(B),L=g(...j);return L&&(T.pattern=L),T}l(D,k){return k.disregardExcludeSettings?void 0:(0,r.$OK)(D,!k.disregardSearchExcludeSettings)}m(D){if(!D||!D.length)return[];const k=D.flatMap(F=>{let{pathPortion:W,globPortion:B}=t(F);return B&&(B=u(B)),this.n(W).flatMap(N=>this.o(N,B))}),S=new Map;return k.forEach(F=>{const W=F.searchPath.toString(),B=S.get(W);B?F.pattern&&(B.pattern=B.pattern||{},B.pattern[F.pattern]=!0):S.set(W,{searchPath:F.searchPath,pattern:F.pattern?g(F.pattern):void 0})}),Array.from(S.values())}n(D){if($.$jc(D)){const k=this.b.getWorkspace().folders;return k[0]&&k[0].uri.scheme!==p.Schemas.file?[{searchPath:k[0].uri.with({path:D})}]:[{searchPath:b.URI.file($.$ic(D))}]}if(this.b.getWorkbenchState()===2){const k=this.b.getWorkspace().folders[0].uri;if(D=c(D),D.startsWith("../")||D===".."){const F=$.$hc.resolve(k.path,D);return[{searchPath:k.with({path:F})}]}const S=u(D);return[{searchPath:k,pattern:S}]}else{if(D==="./"||D===".\\")return[];{const k=D.replace(/^\.[\/\\]/,""),F=this.b.getWorkspace().folders.map(W=>{const B=k.match(new RegExp(`^${A.$Ze(W.name)}(?:/(.*)|$)`));return B?{match:B,folder:W}:null}).filter(P.$4f);if(F.length)return F.map(W=>{const B=W.match[1];return{searchPath:W.folder.uri,pattern:B&&u(B)}});{const W=D.match(/\.[\/\\](.+)[\/\\]?/),B=W?W[1]:D,T=y.localize(0,null,B);throw new Error(T)}}}}o(D,k){const S=D.pattern&&k?`${D.pattern}/${k}`:D.pattern||k,F=[{searchPath:D.searchPath,pattern:S}];return S&&!S.endsWith("**")&&F.push({searchPath:D.searchPath,pattern:S+"/**"}),F}q(D,k,S){const F=this.r((0,l.$Di)(D.searchPath),k,S,!1);return F?{...F,includePattern:D.pattern}:null}r(D,k,S,F){let W;const B=b.URI.isUri(D)?D:D.uri;if(S.searchPaths){const z=S.searchPaths.filter(Q=>(0,w.$Og)(Q.searchPath,B))[0];if(z&&!z.pattern)return null;z&&(W=z.pattern)}const T=this.a.getValue({resource:B}),j={...this.l(T,k)||{},...W||{}},L=b.URI.isUri(D)?(0,w.$Sg)(D):D.name;return{folder:B,folderName:F?L:void 0,excludePattern:Object.keys(j).length>0?j:void 0,fileEncoding:T.files&&T.files.encoding,disregardIgnoreFiles:typeof k.disregardIgnoreFiles=="boolean"?k.disregardIgnoreFiles:!T.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof k.disregardGlobalIgnoreFiles=="boolean"?k.disregardGlobalIgnoreFiles:!T.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof k.disregardParentIgnoreFiles=="boolean"?k.disregardParentIgnoreFiles:!T.search.useParentIgnoreFiles,ignoreSymlinks:typeof k.ignoreSymlinks=="boolean"?k.ignoreSymlinks:!T.search.followSymlinks}}};e.$9L=s,e.$9L=s=Qe([He(0,a.$Oi),He(1,l.$ri),He(2,i.$BD),He(3,m.$Oj),He(4,n.$7L)],s);function t(v){const D=v.match(/[\*\{\}\(\)\[\]\?]/);if(D){const k=D.index,S=v.substr(0,k).match(/[/|\\][^/\\]*$/);if(S){let F=v.substr(0,S.index);return F.match(/[/\\]/)||(F+="/"),{pathPortion:F,globPortion:v.substr((S.index||0)+1)}}}return{pathPortion:v}}function g(...v){return v.length?v.reduce((D,k)=>(D[k]=!0,D),Object.create(null)):void 0}function d(v){return I.$ak(v,",").map(D=>D.trim()).filter(D=>!!D.length)}function h(v){return[`**/${v}/**`,`**/${v}`].map(k=>k.replace(/\*\*\/\*\*/g,"**"))}function c(v){return v.replace(/\\/g,"/")}function u(v){return c(v).replace(/^\.\//,"").replace(/\/+$/g,"")}function f(v){return v.replace(/([?*[\]])/g,"[$1]")}function E(v,D){v=o.$Mb(v,F=>F.toString());const k=[],S=D.getWorkspace();return v&&v.forEach(F=>{let W;if(D.getWorkbenchState()===2)W=(0,w.$Xg)(S.folders[0].uri,F),W&&W!=="."&&(W="./"+W);else{const B=D.getWorkspaceFolder(F);if(B){const T=B.name;if(S.folders.filter(j=>j.name===T).length===1){const j=(0,w.$Xg)(B.uri,F);j===""?W=`./${B.name}`:W=`./${B.name}/${j}`}else W=F.fsPath}}W&&k.push(f(W))}),k}}),define(Ee[372],Ce([1,0,23,2,22,13,5,371,36,43,8]),function(re,e,o,R,I,M,O,p,$,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$evb=b,e.$fvb=a;const P=7e3;function b(m,l){const i=l.activationEvents;if(!i)return Promise.resolve(void 0);const n=[],r=[];for(const c of i)if(/^workspaceContains:/.test(c)){const u=c.substr(18);u.indexOf("*")>=0||u.indexOf("?")>=0||m.forceUsingSearch?r.push(u):n.push(u)}if(n.length===0&&r.length===0)return Promise.resolve(void 0);const{promise:s,resolve:t}=(0,A.$bh)(),g=c=>t({activationEvent:c}),d=Promise.all(n.map(c=>C(m,c,g))).then(()=>{}),h=y(m,l.identifier,r,g);return Promise.all([d,h]).then(()=>{t(void 0)}),s}async function C(m,l,i){for(const n of m.folders)if(await m.exists(o.$Vg(R.URI.revive(n),l))){i(`workspaceContains:${l}`);return}}async function y(m,l,i,n){if(i.length===0)return Promise.resolve(void 0);const r=new I.$ee,s=m.checkExists(m.folders,i,r.token),t=setTimeout(async()=>{r.cancel(),m.logService.info(`Not activating extension '${l.value}': Timed out while searching for 'workspaceContains' pattern ${i.join(",")}`)},P);let g=!1;try{g=await s}catch(d){M.$4(d)||M.$1(d)}r.dispose(),clearTimeout(t),g&&n(`workspaceContains:${i.join(",")}`)}function a(m,l,i,n){const r=m.get(O.$hi),s=m.get($.$GK),g=r.createInstance(p.$9L).file(l.map(d=>(0,w.$Di)(R.URI.revive(d))),{_reason:"checkExists",includePattern:i,exists:!0});return s.fileSearch(g,n).then(d=>!!d.limitHit,d=>M.$4(d)?!1:Promise.reject(d))}});var it=this&&this.__classPrivateFieldSet||function(re,e,o,R,I){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!I:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?I.call(re,o):I?I.value=o:e.set(re,o),o},qe=this&&this.__classPrivateFieldGet||function(re,e,o,R){if(o==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!R:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?R:o==="a"?R.call(re):R?R.value:e.get(re)};define(Ee[48],Ce([1,0,220,17,58,23,8,3,77,2,12,6,45,302,119,38,26,149,13,25,21,281,7,65,5,28,93,20,107,70,44,122,4,372,118,283,15,116,40,11,117]),function(re,e,o,R,I,M,O,p,$,w,A,P,b,C,y,a,m,l,i,n,r,s,t,g,d,h,c,u,f,E,v,D,k,S,F,W,B,T,N,j,L){"use strict";var z,Q,Y,J;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ckc=e.$Bkc=e.$Akc=e.$zkc=e.$ykc=void 0,e.$ykc=(0,d.$ii)("IHostUtils");let x=J=class extends p.$Uc{constructor(me,ie,se,oe,G,ee,le,de,Me,be,Pe,Re,ze){super(),this.Y=Re,this.Z=ze,this.a=this.B(new k.$7d),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=ie,this.g=se,this.f=le,this.j=oe,this.m=G,this.s=ee,this.t=Me,this.u=be,this.w=Pe,this.y=this.g.getProxy(P.$sM.MainThreadWorkspace),this.z=this.g.getProxy(P.$sM.MainThreadTelemetry),this.C=this.g.getProxy(P.$sM.MainThreadExtensionService),this.D=new O.$hh,this.F=new O.$hh,this.G=new O.$hh,this.H=new O.$hh,this.I=new he(this.f.extensions.activationEvents),this.L=new l.$q$b(this.I,this.f.extensions.allExtensions);const V=new n.$Fm(this.f.extensions.myExtensions);this.J=new l.$q$b(this.I,_(this.L,V)),j.$n&&(this.s.info(`Creating extension host with the following global extensions: ${pe(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${pe(this.J)}`)),this.M=new y.$jkc(this.g,this.s),this.N=new F.$rkc(this.g),this.O=de,this.h=me.createChild(new f.$gi([y.$kkc,this.M],[F.$skc,this.N])),this.P=this.B(new C.$ikc(this.J,this.L,{onExtensionActivationError:(H,Z,X)=>{this.C.$onExtensionActivationError(H,i.$3(Z),X)},actualActivateExtension:async(H,Z)=>{if(l.$q$b.isHostExtension(H,this.J,this.L))return await this.C.$activateExtension(H,Z),new C.$hkc;const X=this.J.getExtensionDescription(H);return this.fb(X,Z)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),I.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(me){i.$1(me)}}async $(){this.O.onWillDeactivateAll();let me=[];try{me=this.J.getAllExtensionDescriptions().map(G=>G.identifier).filter(G=>this.isActivated(G)).map(G=>this.eb(G))}catch{}await Promise.all(me)}terminate(me,ie=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${me}`),this.s.flush(),this.u.dispose(),this.P.dispose(),i.setUnexpectedErrorHandler(oe=>{this.s.error(oe)}),this.g.dispose();const se=this.$();Promise.race([(0,O.$jh)(5e3),se]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${ie}`):this.s.info(`Extension host exiting with code ${ie}`),this.s.flush(),this.s.dispose(),this.c.exit(ie)})}isActivated(me){return this.G.isOpen()?this.P.isActivated(me):!1}async getExtension(me){const ie=await this.C.$getExtension(me);return ie&&{...ie,identifier:new n.$Em(ie.identifier.value),extensionLocation:w.URI.revive(ie.extensionLocation)}}ab(me,ie){return this.P.activateByEvent(me,ie)}bb(me,ie){return this.P.activateById(me,ie)}activateByIdWithErrors(me,ie){return this.bb(me,ie).then(()=>{const se=this.P.getActivatedExtension(me);if(se.activationFailed)return Promise.reject(se.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(me=>this.J)}getExtensionExports(me){if(this.G.isOpen())return this.P.getActivatedExtension(me).exports;try{return this.P.getActivatedExtension(me).exports}catch{return null}}async cb(me){if(me.scheme===B.Schemas.file&&this.c.fsRealpath){const ie=me.fsPath;this.R.has(ie)||this.R.set(ie,this.c.fsRealpath(ie));const se=await this.R.get(ie);return w.URI.file(se)}return me}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(me=>new U(me))),this.Q}async db(me){const ie=$.$oi.forUris(se=>M.$Mg.ignorePathCasing(se));return await Promise.all(me.map(async se=>{if(this.wb(se)){const oe=await this.cb(se.extensionLocation);ie.set(oe,se)}})),ie}eb(me){let ie=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(me))return ie;const se=this.P.getActivatedExtension(me);if(!se)return ie;try{typeof se.module.deactivate=="function"&&(ie=Promise.resolve(se.module.deactivate()).then(void 0,oe=>(this.s.error(oe),Promise.resolve(void 0))))}catch(oe){this.s.error(`An error occurred when deactivating the extension '${me.value}':`),this.s.error(oe)}try{(0,p.$Pc)(se.subscriptions)}catch(oe){this.s.error(`An error occurred when deactivating the subscriptions for extension '${me.value}':`),this.s.error(oe)}return ie}async fb(me,ie){return this.f.remote.isRemote?this.C.$onWillActivateExtension(me.identifier):await this.C.$onWillActivateExtension(me.identifier),this.hb(me,ie).then(se=>{const oe=se.activationTimes;return this.C.$onDidActivateExtension(me.identifier,oe.codeLoadingTime,oe.activateCallTime,oe.activateResolvedTime,ie),this.gb(me,ie,"success",oe),se},se=>{throw this.gb(me,ie,"failure"),se})}gb(me,ie,se,oe){const G=te(me,ie);this.z.$publicLog2("extensionActivationTimes",{...G,...oe||{},outcome:se})}hb(me,ie){const se=te(me,ie);this.z.$publicLog2("activatePlugin",se);const oe=this.wb(me);if(!oe)return Promise.resolve(new C.$gkc(C.$dkc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${me.identifier.value}, startup: ${ie.startup}, activationEvent: '${ie.activationEvent}'${me.identifier.value!==ie.extensionId.value?`, root cause: ${ie.extensionId.value}`:""}`),this.s.flush();const G=new C.$ekc(ie.startup);return Promise.all([this.xb(me,(0,M.$Vg)(me.extensionLocation,oe),G),this.ib(me)]).then(ee=>(I.mark(`code/extHost/willActivateExtension/${me.identifier.value}`),J.jb(this.s,me.identifier,ee[0],ee[1],G))).then(ee=>(I.mark(`code/extHost/didActivateExtension/${me.identifier.value}`),ee))}ib(me){const ie=this.Z.createLanguageModelAccessInformation(me),se=new s.$mkc(me,this.M),oe=new s.$lkc(me.identifier.value,!1,this.M),G=new W.$tkc(me,this.N),ee=me.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,le=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${me.identifier.value}`),Promise.all([se.whenReady,oe.whenReady,this.O.whenReady]).then(()=>{const de=this;let Me,be;const Pe=(0,m.$cG)(me,"ipc")?this.f.messagePorts?.get(n.$Em.toKey(me.identifier)):void 0;return Object.freeze({globalState:se,workspaceState:oe,secrets:G,subscriptions:[],get languageModelAccessInformation(){return ie},get extensionUri(){return me.extensionLocation},get extensionPath(){return me.extensionLocation.fsPath},asAbsolutePath(Re){return R.$kc(me.extensionLocation.fsPath,Re)},get storagePath(){return de.O.workspaceValue(me)?.fsPath},get globalStoragePath(){return de.O.globalValue(me).fsPath},get logPath(){return R.$kc(de.f.logsLocation.fsPath,me.identifier.value)},get logUri(){return w.URI.joinPath(de.f.logsLocation,me.identifier.value)},get storageUri(){return de.O.workspaceValue(me)},get globalStorageUri(){return de.O.globalValue(me)},get extensionMode(){return ee},get extension(){return Me===void 0&&(Me=new ye(de,me.identifier,me,le,!1)),Me},get extensionRuntime(){return(0,m.$dG)(me,"extensionRuntime"),de.extensionRuntime},get environmentVariableCollection(){return de.u.getEnvironmentVariableCollection(me)},get messagePassingProtocol(){if(!be){if(!Pe)return;const Re=k.Event.buffer(k.Event.fromDOMEventEmitter(Pe,"message",ze=>ze.data));Pe.start(),be={onDidReceiveMessage:Re,postMessage:Pe.postMessage.bind(Pe)}}return be}})})}static jb(me,ie,se,oe,G){return se=se||{activate:void 0,deactivate:void 0},this.kb(me,ie,se,oe,G).then(ee=>new C.$fkc(!1,null,G.build(),se,ee,oe.subscriptions))}static kb(me,ie,se,oe,G){if(typeof se.activate=="function")try{G.activateCallStart(),me.trace(`ExtensionService#_callActivateOptional ${ie.value}`);const ee=typeof global=="object"?global:self,le=se.activate.apply(ee,[oe]);return G.activateCallStop(),G.activateResolveStart(),Promise.resolve(le).then(de=>(G.activateResolveStop(),de))}catch(ee){return Promise.reject(ee)}else return Promise.resolve(se)}lb(me,ie){this.bb(me.identifier,{startup:!1,extensionId:me.identifier,activationEvent:ie}).then(void 0,se=>{this.s.error(se)})}mb(me,ie=0){const oe=Date.now();(0,j.$v)(()=>{for(let G=ie;G<me.length;G+=1){const ee=me[G];for(const le of ee.activationEvents??[])if(le==="onStartupFinished")if(Date.now()-oe>50){this.mb(me,G);break}else this.lb(ee,le)}})}nb(){this.C.$setPerformanceMarks(I.getMarks()),this.m.getConfigProvider().then(me=>{const ie=me.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),se=this.J.getAllExtensionDescriptions();if(ie)this.mb(se);else for(const oe of se)if(oe.activationEvents)for(const G of oe.activationEvents)G==="onStartupFinished"&&this.lb(oe,G)})}ob(){const me=this.ab("*",!0).then(void 0,ee=>{this.s.error(ee)});this.B(this.j.onDidChangeWorkspace(ee=>this.pb(ee.added)));const ie=this.j.workspace?this.j.workspace.folders:[],se=this.pb(ie),oe=this.rb(),G=Promise.all([oe,me,se]).then(()=>{});return Promise.race([G,(0,O.$jh)(1e4)]).then(()=>{this.nb()}),G}pb(me){return me.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(ie=>this.qb(me,ie))).then(()=>{})}async qb(me,ie){if(this.isActivated(ie.identifier))return;const se=!this.f.remote.isRemote&&!!this.f.remote.authority,oe={logService:this.s,folders:me.map(ee=>ee.uri),forceUsingSearch:se||!this.c.fsExists,exists:ee=>this.c.fsExists(ee.fsPath),checkExists:(ee,le,de)=>this.y.$checkExists(ee,le,de)},G=await(0,S.$evb)(oe,ie);if(G)return this.bb(ie.identifier,{startup:!0,extensionId:ie.identifier,activationEvent:G.activationEvent}).then(void 0,ee=>this.s.error(ee))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(me){throw console.error(me),me}}async sb(){const{extensionDevelopmentLocationURI:me,extensionTestsLocationURI:ie}=this.f.environment;if(!me||!ie)throw new Error(o.localize(0,null));const se=await this.xb(null,ie,new C.$ekc(!1));if(!se||typeof se.run!="function")throw new Error(o.localize(1,null,ie.toString()));return new Promise((oe,G)=>{const ee=(Me,be)=>{Me?(j.$n&&this.s.error("Test runner called back with error",Me),G(Me)):(j.$n&&(be?this.s.info(`Test runner called back with ${be} failures.`):this.s.info("Test runner called back with successful outcome.")),oe(typeof be=="number"&&be>0?1:0))},le=(0,M.$Jg)(ie),de=se.run(le,ee);de&&de.then&&de.then(()=>{j.$n&&this.s.info("Test runner finished successfully."),oe(0)}).catch(Me=>{j.$n&&this.s.error("Test runner finished with error",Me),G(Me instanceof Error&&Me.stack?Me.stack:String(Me))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,O.$jh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(me,ie){return this.S[me]=ie,(0,p.$Sc)(()=>{delete this.S[me]})}async getRemoteExecServer(me){const{resolver:ie}=await this.ub(me);return ie?.resolveExecServer?.(me,{resolveAttempt:0})}async ub(me){const ie=me.indexOf("+");if(ie===-1)throw new t.$AM("Not an authority that can be resolved!",g.RemoteAuthorityResolverErrorCode.InvalidAuthority);const se=me.substr(0,ie);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${se}`,!1),{authorityPrefix:se,resolver:this.S[se]}}async $resolveAuthority(me,ie){const se=N.$3d.create(!1),oe=()=>`[resolveAuthority(${(0,g.$xl)(me)},${ie})][${se.elapsed()}ms] `,G=fe=>this.s.info(`${oe()}${fe}`),ee=fe=>this.s.warn(`${oe()}${fe}`),le=(fe,we=void 0)=>this.s.error(`${oe()}${fe}`,we),de=fe=>{if(fe instanceof t.$AM)return{type:"error",error:{code:fe._code,message:fe._message,detail:fe._detail}};throw fe},Me=async fe=>{G(`activating resolver for ${fe}...`);const{resolver:we,authorityPrefix:Te}=await this.ub(fe);if(!we)throw le(`no resolver for ${Te}`),new t.$AM(`No remote extension installed to resolve ${Te}.`,g.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:we,authorityPrefix:Te,remoteAuthority:fe}},be=me.split(/@|%40/g).reverse();G(`activating remote resolvers ${be.join(" -> ")}`);let Pe;try{Pe=await Promise.all(be.map(Me)).catch(async fe=>{if(!(fe instanceof t.$AM)||fe._code!==g.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw fe;return ee(`resolving nested authorities failed: ${fe.message}`),[await Me(me)]})}catch(fe){return de(fe)}const Re=new O.$th;Re.cancelAndSet(()=>G("waiting..."),1e3);let ze,V;for(const[fe,{authorityPrefix:we,resolver:Te,remoteAuthority:Ve}]of Pe.entries())try{if(fe===Pe.length-1)G("invoking final resolve()..."),I.mark(`code/extHost/willResolveAuthority/${we}`),ze=await Te.resolve(Ve,{resolveAttempt:ie,execServer:V}),I.mark(`code/extHost/didResolveAuthorityOK/${we}`),G("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(Te,t.$zM.isManagedResolvedAuthority(ze)?ze:void 0));else{if(G(`invoking resolveExecServer() for ${Ve}`),I.mark(`code/extHost/willResolveExecServer/${we}`),V=await Te.resolveExecServer?.(Ve,{resolveAttempt:ie,execServer:V}),!V)throw new t.$AM(`Exec server was not available for ${Ve}`,g.RemoteAuthorityResolverErrorCode.NoResolverFound);I.mark(`code/extHost/didResolveExecServerOK/${we}`)}}catch(Ze){return I.mark(`code/extHost/didResolveAuthorityError/${we}`),le("returned an error",Ze),Re.dispose(),de(Ze)}Re.dispose();const H={environmentTunnels:ze.environmentTunnels,features:ze.tunnelFeatures?{elevation:ze.tunnelFeatures.elevation,privacyOptions:ze.tunnelFeatures.privacyOptions,protocol:ze.tunnelFeatures.protocol===void 0?!0:ze.tunnelFeatures.protocol}:void 0},Z={extensionHostEnv:ze.extensionHostEnv,isTrusted:ze.isTrusted,authenticationSession:ze.authenticationSessionForInitializingExtensions?{id:ze.authenticationSessionForInitializingExtensions.id,providerId:ze.authenticationSessionForInitializingExtensions.providerId}:void 0};G(`returned ${t.$zM.isManagedResolvedAuthority(ze)?"managed authority":`${ze.host}:${ze.port}`}`);let X;if(t.$zM.isManagedResolvedAuthority(ze)){const fe=ie;this.Y.setFactory(fe,ze.makeConnection),X={authority:me,connectTo:new g.$ul(fe),connectionToken:ze.connectionToken}}else X={authority:me,connectTo:new g.$vl(ze.host,ze.port),connectionToken:ze.connectionToken};return{type:"ok",value:{authority:X,options:Z,tunnelInformation:H}}}async $getCanonicalURI(me,ie){this.s.info(`$getCanonicalURI invoked for authority (${(0,g.$xl)(me)})`);const{resolver:se}=await this.ub(me);if(!se)return null;const oe=w.URI.revive(ie);if(typeof se.getCanonicalURI>"u")return oe;const G=await(0,O.$ah)(()=>se.getCanonicalURI(oe));return G||oe}async $startExtensionHost(me){me.toAdd.forEach(ee=>ee.extensionLocation=w.URI.revive(ee.extensionLocation));const{globalRegistry:ie,myExtensions:se}=ce(this.I,this.L,this.J,me),oe=await this.db(se);return(await this.getExtensionPathIndex()).setSearchTree(oe),this.L.set(ie.getAllExtensionDescriptions()),this.J.set(se),j.$n&&(this.s.info(`$startExtensionHost: global extensions: ${pe(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${pe(this.J)}`)),this.tb()}$activateByEvent(me,ie){return ie===1?this.D.wait().then(se=>this.ab(me,!1)):this.G.wait().then(se=>this.ab(me,!1))}async $activate(me,ie){return await this.G.wait(),this.J.getExtensionDescription(me)?(await this.bb(me,ie),!0):!1}async $deltaExtensions(me){me.toAdd.forEach(ee=>ee.extensionLocation=w.URI.revive(ee.extensionLocation));const{globalRegistry:ie,myExtensions:se}=ce(this.I,this.L,this.J,me),oe=await this.db(se);return(await this.getExtensionPathIndex()).setSearchTree(oe),this.L.set(ie.getAllExtensionDescriptions()),this.J.set(se),j.$n&&(this.s.info(`$deltaExtensions: global extensions: ${pe(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${pe(this.J)}`)),Promise.resolve(void 0)}async $test_latency(me){return me}async $test_up(me){return me.byteLength}async $test_down(me){const ie=r.$ue.alloc(me),se=Math.random()%256;for(let oe=0;oe<me;oe++)ie.writeUInt8(se,oe);return ie}async $updateRemoteConnectionData(me){this.X=me,this.a.fire()}};e.$zkc=x,e.$zkc=x=J=Qe([He(0,d.$hi),He(1,e.$ykc),He(2,u.$OO),He(3,a.$Yjc),He(4,b.$2jc),He(5,A.$Oj),He(6,h.$5O),He(7,c.$5jc),He(8,E.$kCb),He(9,v.$nkc),He(10,T.$vkc),He(11,L.$wkc),He(12,D.$Ojc)],x);function ce(Se,me,ie,se){Se.addActivationEvents(se.addActivationEvents);const oe=new l.$q$b(Se,me.getAllExtensionDescriptions());oe.deltaExtensions(se.toAdd,se.toRemove);const G=new n.$Fm(ie.getAllExtensionDescriptions().map(le=>le.identifier));for(const le of se.myToRemove)G.delete(le);for(const le of se.myToAdd)G.add(le);const ee=_(oe,G);return{globalRegistry:oe,myExtensions:ee}}function te(Se,me){return{id:Se.identifier.value,name:Se.name,extensionVersion:Se.version,publisherDisplayName:Se.publisher,activationEvents:Se.activationEvents?Se.activationEvents.join(","):null,isBuiltin:Se.isBuiltin,reason:me.activationEvent,reasonId:me.extensionId.value}}function pe(Se){return Se.getAllExtensionDescriptions().map(me=>me.identifier.value).join(",")}e.$Akc=(0,d.$ii)("IExtHostExtensionService");class ye{constructor(me,ie,se,oe,G){z.set(this,void 0),Q.set(this,void 0),Y.set(this,void 0),it(this,z,me,"f"),it(this,Q,ie,"f"),it(this,Y,se.identifier,"f"),this.id=se.identifier.value,this.extensionUri=se.extensionLocation,this.extensionPath=R.$ic((0,M.$Jg)(se.extensionLocation)),this.packageJSON=se,this.extensionKind=oe,this.isFromDifferentExtensionHost=G}get isActive(){return qe(this,z,"f").isActivated(qe(this,Y,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return qe(this,z,"f").getExtensionExports(qe(this,Y,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await qe(this,z,"f").activateByIdWithErrors(qe(this,Y,"f"),{startup:!1,extensionId:qe(this,Q,"f"),activationEvent:"api"}),this.exports}}e.$Bkc=ye,z=new WeakMap,Q=new WeakMap,Y=new WeakMap;function _(Se,me){return Se.getAllExtensionDescriptions().filter(ie=>me.has(ie.identifier))}class U{constructor(me){this.a=me}setSearchTree(me){this.a=me}findSubstr(me){return this.a.findSubstr(me)}forEach(me){return this.a.forEach(me)}}e.$Ckc=U;class he{constructor(me){this.a=new n.$Gm,this.addActivationEvents(me)}readActivationEvents(me){return this.a.get(me.identifier)??[]}addActivationEvents(me){for(const ie of Object.keys(me))this.a.set(ie,me[ie])}}}),define(Ee[373],Ce([1,0,58,2,6,45,26,25,20,28,5,48,12,14]),function(re,e,o,R,I,M,O,p,$,w,A,P,b,C){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$Mlc=void 0;let a=class{constructor(r,s,t,g,d,h,c){this.c=r,this.d=s,this.f=t,this.g=g,this.h=d,this.i=h,this.j=c,this.a=new Map,this.b=[]}async install(){this.k(),o.mark("code/extHost/willWaitForConfig");const r=await this.g.getConfigProvider();o.mark("code/extHost/didWaitForConfig");const s=await this.h.getExtensionPathIndex();this.register(new l(this.c,s,this.d,r,this.j)),this.register(this.f.createInstance(m)),this.i.remote.isRemote&&this.register(this.f.createInstance(i,s,this.i.environment.appUriScheme))}register(r){if("nodeModuleName"in r)if(Array.isArray(r.nodeModuleName))for(const s of r.nodeModuleName)this.a.set(s,r);else this.a.set(r.nodeModuleName,r);typeof r.alternativeModuleName=="function"&&this.b.push(s=>r.alternativeModuleName(s))}};e.$Mlc=a,e.$Mlc=a=Qe([He(2,A.$hi),He(3,M.$2jc),He(4,P.$Akc),He(5,w.$5O),He(6,b.$Oj)],a);let m=y=class{constructor(r){if(r.environment.appRoot&&y.a.size){const s=(0,C.$Ze)(this.c(r.environment.appRoot.fsPath)),t="[a-z0-9_.-]",g=`@${t}+\\/${t}+|${t}+`,d="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${s}/${d}\\/)(${g})(.*)$`,"i")}}alternativeModuleName(r){if(!this.b)return;const s=this.b.exec(this.c(r));if(!s)return;const[,t,g,d]=s,h=y.a.get(g);if(h!==void 0)return console.warn(`${g} as been renamed to ${h}, please update your imports`),t+h+d}c(r){return r.replace(/\\/g,"/")}};m.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),m=y=Qe([He(0,w.$5O)],m);class l{constructor(r,s,t,g,d){this.c=r,this.d=s,this.e=t,this.f=g,this.g=d,this.nodeModuleName="vscode",this.a=new p.$Gm}load(r,s){const t=this.d.findSubstr(s);if(t){let g=this.a.get(t.identifier);return g||(g=this.c(t,this.e,this.f),this.a.set(t.identifier,g)),g}if(!this.b){let g="";this.d.forEach((d,h)=>g+=`	${h} -> ${d.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${s}. These are the extension path mappings: 
${g}`),this.b=this.c(O.$0F,this.e,this.f)}return this.b}}let i=class{constructor(r,s,t){this.e=r,this.f=s,this.nodeModuleName=["open","opn"],this.d=t.getProxy(I.$sM.MainThreadTelemetry);const g=t.getProxy(I.$sM.MainThreadWindow);this.c=(d,h)=>{const c=R.URI.parse(d);return h?this.g(d,h):c.scheme==="http"||c.scheme==="https"?g.$openUri(c,d,{allowTunneling:!0}):c.scheme==="mailto"||c.scheme===this.f?g.$openUri(c,d,{}):this.g(d,h)}}load(r,s,t){const g=this.e.findSubstr(s);return g&&(this.a=g.identifier.value,this.h()),this.b=t(r),this.c}g(r,s){return this.i(),this.b(r,s)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};i=Qe([He(2,$.$OO)],i)}),define(Ee[60],Ce([1,0,46,3,17,49,5,72,71,48,7,38,299,45]),function(re,e,o,R,I,M,O,p,$,w,A,P,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ekc=e.$Dkc=void 0,e.$Dkc=(0,O.$ii)("IExtHostVariableResolverProvider");class y extends b.$QP{constructor(l,i,n,r,s,t,g){function d(){if(n){const h=n.activeEditor();if(h)return h.document.uri;const c=r.tabGroups.all.find(u=>u.isActive)?.activeTab;if(c!==void 0){if(c.input instanceof A.$fO||c.input instanceof A.$kO)return c.input.modified;if(c.input instanceof A.$eO||c.input instanceof A.$jO||c.input instanceof A.$hO)return c.input.uri}}}super({getFolderUri:h=>{const c=t.folders.filter(u=>u.name===h);if(c&&c.length>0)return c[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(h,c)=>s.getConfiguration(void 0,h).get(c),getAppRoot:()=>M.cwd(),getExecPath:()=>M.env.VSCODE_EXEC_PATH,getFilePath:()=>{const h=d();if(h)return I.$ic(h.fsPath)},getWorkspaceFolderPathForFile:()=>{if(i){const h=d();if(h){const c=i.getWorkspaceFolder(h);if(c)return I.$ic(c.uri.fsPath)}}},getSelectedText:()=>{if(n){const h=n.activeEditor();if(h&&!h.selection.isEmpty)return h.document.getText(h.selection)}},getLineNumber:()=>{if(n){const h=n.activeEditor();if(h)return String(h.selection.end.line+1)}},getExtension:h=>l.getExtension(h)},void 0,g?Promise.resolve(g):void 0,Promise.resolve(M.env))}}let a=class extends R.$Uc{constructor(l,i,n,r,s){super(),this.b=l,this.c=i,this.g=n,this.h=r,this.j=s,this.a=new o.$V(async()=>{const t=await this.h.getConfigProvider(),d={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async h=>{d.folders=await this.c.getWorkspaceFolders2()||[]})),new y(this.b,this.c,this.g,this.j,t,d,this.m())})}getResolver(){return this.a.value}m(){}};e.$Ekc=a,e.$Ekc=a=Qe([He(0,w.$Akc),He(1,P.$Yjc),He(2,p.$ZO),He(3,C.$2jc),He(4,$.$bkc)],a)}),define(Ee[96],Ce([1,0,8,4,2,25,5,6,71,48,20,7,38,144,291,45,60,3,56,33,16]),function(re,e,o,R,I,M,O,p,$,w,A,P,b,C,y,a,m,l,i,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jkc=e.$Ikc=e.$Hkc=e.$Gkc=e.$Fkc=void 0,e.$Fkc=(0,O.$ii)("IExtHostDebugService");let s=class{get onDidStartDebugSession(){return this.n.event}get onDidTerminateDebugSession(){return this.o.event}get onDidChangeActiveDebugSession(){return this.q.event}get activeDebugSession(){return this.u?.api}get onDidReceiveDebugSessionCustomEvent(){return this.w.event}get activeDebugConsole(){return this.y.value}constructor(f,E,v,D,k,S,F){this.N=E,this.O=v,this.P=D,this.Q=k,this.R=S,this.S=F,this.m=new Map,this.F=0,this.G=new Map,this.H=new Map,this.I=new WeakMap,this.J=new Map,this.L=new Map,this.M=0,this.d=0,this.f=[],this.g=0,this.h=[],this.j=0,this.k=[],this.D=new Map,this.E=new Map,this.n=new R.$7d,this.o=new R.$7d,this.q=new R.$7d,this.w=new R.$7d,this.l=f.getProxy(p.$sM.MainThreadDebugService),this.A=new R.$7d,this.C=new R.$7d,this.y=new g(this.l),this.z=new Map,this.O.getExtensionRegistry().then(W=>{W.onDidChange(B=>{this.V(W)}),this.V(W)})}async $getVisualizerTreeItem(f,E){const v=this.W(E);if(!v)return;const D=await this.H.get(f)?.getTreeItem?.(v);return D?this.U(f,D):void 0}registerDebugVisualizationTree(f,E,v){const D=M.$Em.toKey(f.identifier),k=this.jb(D,E);if(this.G.has(k))throw new Error(`A debug visualization provider with id '${E}' is already registered`);return this.H.set(k,v),this.l.$registerDebugVisualizerTree(k,!!v.editItem),(0,l.$Sc)(()=>{this.l.$unregisterDebugVisualizerTree(k),this.H.delete(E)})}async $getVisualizerTreeItemChildren(f,E){const v=this.J.get(E)?.item;return v?(await this.H.get(f)?.getChildren?.(v))?.map(k=>this.U(f,k))||[]:[]}async $editVisualizerTreeItem(f,E){const v=this.J.get(f);if(!v)return;const D=await this.H.get(v.provider)?.editItem?.(v.item,E);return this.U(v.provider,D||v.item)}$disposeVisualizedTree(f){const E=this.J.get(f);if(!E)return;const v=[E.children];for(const D of v)if(D)for(const k of D)v.push(this.J.get(k)?.children),this.J.delete(k)}U(f,E){let v=this.I.get(E);return v||(v=this.F++,this.I.set(E,v),this.J.set(v,{provider:f,item:E})),r.DebugTreeItem.from(E,v)}asDebugSourceUri(f,E){const v=f;if(typeof v.sourceReference=="number"&&v.sourceReference>0){let D=`debug:${encodeURIComponent(v.path||"")}`,k="?";return E&&(D+=`${k}session=${encodeURIComponent(E.id)}`,k="&"),D+=`${k}ref=${v.sourceReference}`,I.URI.parse(D)}else{if(v.path)return I.URI.file(v.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}V(f){const E=[];for(const v of f.getAllExtensionDescriptions())if(v.contributes){const D=v.contributes.debuggers;if(D&&D.length>0)for(const k of D)(0,y.$PG)(k)&&E.push(k.type)}this.l.$registerDebugTypes(E)}get activeStackItem(){return this.B}get onDidChangeActiveStackItem(){return this.C.event}get onDidChangeBreakpoints(){return this.A.event}get breakpoints(){const f=[];return this.z.forEach(E=>f.push(E)),f}async $resolveDebugVisualizer(f,E){const v=this.L.get(f);if(!v)throw new Error(`No debug visualizer found with id '${f}'`);let{v:D,provider:k,extensionId:S}=v;if(D.visualization||(D=await k.resolveDebugVisualization?.(D,E)||D,v.v=D),!D.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${k}'`);return this.kb(S,D.visualization)}async $executeDebugVisualizerCommand(f){const E=this.L.get(f);if(!E)throw new Error(`No debug visualizer found with id '${f}'`);const v=E.v.visualization;v&&"command"in v&&this.S.executeCommand(v.command,...v.arguments||[])}W(f){const E=this.m.get(f.sessionId);return E&&{session:E.api,variable:f.variable,containerId:f.containerId,frameId:f.frameId,threadId:f.threadId}}async $provideDebugVisualizers(f,E,v,D){const k=this.W(v),S=this.jb(f,E),F=this.G.get(S);if(!k||!F)return[];const W=await F.provideDebugVisualization(k,D);return W?W.map(B=>{const T=++this.M;this.L.set(T,{v:B,provider:F,extensionId:f});const N=B.iconPath?this.lb(B.iconPath):void 0;return{id:T,name:B.name,iconClass:N?.iconClass,iconPath:N?.iconPath,visualization:this.kb(f,B.visualization)}}):[]}$disposeDebugVisualizers(f){for(const E of f)this.L.delete(E)}registerDebugVisualizationProvider(f,E,v){if(!f.contributes?.debugVisualizers?.some(S=>S.id===E))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${E})`);const D=M.$Em.toKey(f.identifier),k=this.jb(D,E);if(this.G.has(k))throw new Error(`A debug visualization provider with id '${E}' is already registered`);return this.G.set(k,v),this.l.$registerDebugVisualizer(D,E),(0,l.$Sc)(()=>{this.l.$unregisterDebugVisualizer(D,E),this.G.delete(E)})}addBreakpoints(f){const E=f.filter(k=>{const S=k.id;return this.z.has(S)?!1:(this.z.set(S,k),!0)});this.gb(E,[],[]);const v=[],D=new Map;for(const k of E)if(k instanceof P.$vN){let S=D.get(k.location.uri.toString());S||(S={type:"sourceMulti",uri:k.location.uri,lines:[]},D.set(k.location.uri.toString(),S),v.push(S)),S.lines.push({id:k.id,enabled:k.enabled,condition:k.condition,hitCondition:k.hitCondition,logMessage:k.logMessage,line:k.location.range.start.line,character:k.location.range.start.character,mode:k.mode})}else k instanceof P.$wN&&v.push({type:"function",id:k.id,enabled:k.enabled,hitCondition:k.hitCondition,logMessage:k.logMessage,condition:k.condition,functionName:k.functionName,mode:k.mode});return this.l.$registerBreakpoints(v)}removeBreakpoints(f){const E=f.filter(S=>this.z.delete(S.id));this.gb([],E,[]);const v=E.filter(S=>S instanceof P.$vN).map(S=>S.id),D=E.filter(S=>S instanceof P.$wN).map(S=>S.id),k=E.filter(S=>S instanceof P.$xN).map(S=>S.id);return this.l.$unregisterBreakpoints(v,D,k)}startDebugging(f,E,v){return this.l.$startDebugging(f?f.uri:void 0,E,{parentSessionID:v.parentSession?v.parentSession.id:void 0,lifecycleManagedByParent:v.lifecycleManagedByParent,repl:v.consoleMode===P.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:v.noDebug,compact:v.compact,suppressSaveBeforeStart:v.suppressSaveBeforeStart,suppressDebugStatusbar:v.suppressDebugStatusbar??v.debugUI?.simple,suppressDebugToolbar:v.suppressDebugToolbar??v.debugUI?.simple,suppressDebugView:v.suppressDebugView??v.debugUI?.simple})}stopDebugging(f){return this.l.$stopDebugging(f?f.id:void 0)}registerDebugConfigurationProvider(f,E,v){if(!E)return new P.$uM(()=>{});const D=this.d++;return this.f.push({type:f,handle:D,provider:E}),this.l.$registerDebugConfigurationProvider(f,v,!!E.provideDebugConfigurations,!!E.resolveDebugConfiguration,!!E.resolveDebugConfigurationWithSubstitutedVariables,D),new P.$uM(()=>{this.f=this.f.filter(k=>k.provider!==E),this.l.$unregisterDebugConfigurationProvider(D)})}registerDebugAdapterDescriptorFactory(f,E,v){if(!v)return new P.$uM(()=>{});if(!this.cb(f,E))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${E}' debugger.`);if(this.$(E))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const D=this.g++;return this.h.push({type:E,handle:D,factory:v}),this.l.$registerDebugAdapterDescriptorFactory(E,D),new P.$uM(()=>{this.h=this.h.filter(k=>k.factory!==v),this.l.$unregisterDebugAdapterDescriptorFactory(D)})}registerDebugAdapterTrackerFactory(f,E){if(!E)return new P.$uM(()=>{});const v=this.j++;return this.k.push({type:f,handle:v,factory:E}),new P.$uM(()=>{this.k=this.k.filter(D=>D.factory!==E)})}async $runInTerminal(f,E){return Promise.resolve(void 0)}async $substituteVariables(f,E){let v;const D=await this.ib(f);return D&&(v={uri:D.uri,name:D.name,index:D.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.R.getResolver()).resolveAnyAsync(v,E)}X(f,E){if(f.type==="implementation")return new h(f.implementation)}Y(){}async $startDASession(f,E){const v=this,D=await this.hb(E);return this.eb(this.$(D.type),D).then(k=>{if(!k)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${D.type}' (extension might have failed to activate)`);const S=this.Z(k),F=this.X(S,D);if(!F)throw new Error(`Couldn't create a debug adapter for type '${D.type}'.`);const W=F;return this.D.set(f,W),this.db(D).then(B=>(B&&this.E.set(f,B),W.onMessage(async T=>{if(T.type==="request"&&T.command==="handshake"){const N=T,j={type:"response",seq:0,command:N.command,request_seq:N.seq,success:!0};this.K||(this.K=this.Y());try{if(this.K){const L=await this.K.sign(N.arguments.value);j.body={signature:L},W.sendResponse(j)}else throw new Error("no signer")}catch(L){j.success=!1,j.message=L.message,W.sendResponse(j)}}else B&&B.onDidSendMessage&&B.onDidSendMessage(T),T=(0,y.$UG)(T,!0),v.l.$acceptDAMessage(f,T)}),W.onError(T=>{B&&B.onError&&B.onError(T),this.l.$acceptDAError(f,T.name,T.message,T.stack)}),W.onExit(T=>{B&&B.onExit&&B.onExit(T??void 0,void 0),this.l.$acceptDAExit(f,T??void 0,void 0)}),B&&B.onWillStartSession&&B.onWillStartSession(),W.startSession()))})}$sendDAMessage(f,E){E=(0,y.$TG)(E,!1);const v=this.E.get(f);v&&v.onWillReceiveMessage&&v.onWillReceiveMessage(E),this.D.get(f)?.sendMessage(E)}$stopDASession(f){const E=this.E.get(f);this.E.delete(f),E&&E.onWillStopSession&&E.onWillStopSession();const v=this.D.get(f);return this.D.delete(f),v?v.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(f){const E=[],v=[],D=[];if(f.added)for(const k of f.added){const S=k.id;if(S&&!this.z.has(S)){let F;if(k.type==="function")F=new P.$wN(k.functionName,k.enabled,k.condition,k.hitCondition,k.logMessage,k.mode);else if(k.type==="data")F=new P.$xN(k.label,k.dataId,k.canPersist,k.enabled,k.hitCondition,k.condition,k.logMessage,k.mode);else{const W=I.URI.revive(k.uri);F=new P.$vN(new P.$GM(W,new P.$vM(k.line,k.character)),k.enabled,k.condition,k.hitCondition,k.logMessage,k.mode)}(0,P.$tN)(F,S),this.z.set(S,F),E.push(F)}}if(f.removed)for(const k of f.removed){const S=this.z.get(k);S&&(this.z.delete(k),v.push(S))}if(f.changed){for(const k of f.changed)if(k.id){const S=this.z.get(k.id);if(S){if(S instanceof P.$wN&&k.type==="function"){const F=S;F.enabled=k.enabled,F.condition=k.condition,F.hitCondition=k.hitCondition,F.logMessage=k.logMessage,F.functionName=k.functionName}else if(S instanceof P.$vN&&k.type==="source"){const F=S;F.enabled=k.enabled,F.condition=k.condition,F.hitCondition=k.hitCondition,F.logMessage=k.logMessage,F.location=new P.$GM(I.URI.revive(k.uri),new P.$vM(k.line,k.character))}D.push(S)}}}this.gb(E,v,D)}async $acceptStackFrameFocus(f){let E;if(f){const v=await this.hb(f.sessionId);f.kind==="thread"?E=new P.$DN(v.api,f.threadId):E=new P.$CN(v.api,f.threadId,f.frameId)}this.B=E,this.C.fire(this.B)}$provideDebugConfigurations(f,E,v){return(0,o.$ah)(async()=>{const D=this.bb(f);if(!D)throw new Error("no DebugConfigurationProvider found");if(!D.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const k=await this.ib(E);return D.provideDebugConfigurations(k,v)}).then(D=>{if(!D)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return D})}$resolveDebugConfiguration(f,E,v,D){return(0,o.$ah)(async()=>{const k=this.bb(f);if(!k)throw new Error("no DebugConfigurationProvider found");if(!k.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const S=await this.ib(E);return k.resolveDebugConfiguration(S,v,D)})}$resolveDebugConfigurationWithSubstitutedVariables(f,E,v,D){return(0,o.$ah)(async()=>{const k=this.bb(f);if(!k)throw new Error("no DebugConfigurationProvider found");if(!k.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const S=await this.ib(E);return k.resolveDebugConfigurationWithSubstitutedVariables(S,v,D)})}async $provideDebugAdapter(f,E){const v=this.ab(f);if(!v)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const D=await this.hb(E);return this.eb(v,D).then(k=>{if(!k)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${D.type}'`);return this.Z(k)})}async $acceptDebugSessionStarted(f){const E=await this.hb(f);this.n.fire(E.api)}async $acceptDebugSessionTerminated(f){const E=await this.hb(f);E&&(this.o.fire(E.api),this.m.delete(E.id))}async $acceptDebugSessionActiveChanged(f){this.u=f?await this.hb(f):void 0,this.q.fire(this.u?.api)}async $acceptDebugSessionNameChanged(f,E){(await this.hb(f))?._acceptNameChanged(E)}async $acceptDebugSessionCustomEvent(f,E){const D={session:(await this.hb(f)).api,event:E.event,body:E.body};this.w.fire(D)}Z(f){if(f instanceof P.$yN)return{type:"executable",command:f.command,args:f.args,options:f.options};if(f instanceof P.$zN)return{type:"server",port:f.port,host:f.host};if(f instanceof P.$AN)return{type:"pipeServer",path:f.path};if(f instanceof P.$BN)return{type:"implementation",implementation:f.implementation};throw new Error("convertToDto unexpected type")}$(f){const E=this.h.filter(v=>v.type===f);if(E.length>0)return E[0].factory}ab(f){const E=this.h.filter(v=>v.handle===f);if(E.length>0)return E[0].factory}bb(f){const E=this.f.filter(v=>v.handle===f);if(E.length>0)return E[0].provider}cb(f,E){if(f.contributes){const v=f.contributes.debuggers;if(v&&v.length>0){for(const D of v)if(D.label&&D.type&&D.type===E)return!0}}return!1}db(f){const v=f.configuration.type,D=this.k.filter(k=>k.type===v||k.type==="*").map(k=>(0,o.$ah)(()=>k.factory.createDebugAdapterTracker(f.api)).then(S=>S,S=>null));return Promise.race([Promise.all(D).then(k=>{const S=k.filter(F=>!!F);if(S.length>0)return new d(S)}),new Promise(k=>setTimeout(()=>k(void 0),1e3))]).catch(k=>{})}async eb(f,E){const v=E.configuration.debugServer;if(typeof v=="number")return Promise.resolve(new P.$zN(v));if(f){const k=await this.O.getExtensionRegistry();return(0,o.$ah)(()=>f.createDebugAdapterDescriptor(E.api,this.fb(E,k))).then(S=>{if(S)return S})}const D=await this.O.getExtensionRegistry();return Promise.resolve(this.fb(E,D))}fb(f,E){}gb(f,E,v){(f.length>0||E.length>0||v.length>0)&&this.A.fire(Object.freeze({added:f,removed:E,changed:v}))}async hb(f){if(f)if(typeof f=="string"){const E=this.m.get(f);if(E)return E}else{let E=this.m.get(f.id);if(!E){const v=await this.ib(f.folderUri),D=f.parent?this.m.get(f.parent):void 0;E=new t(this.l,f.id,f.type,f.name,v,f.configuration,D?.api),this.m.set(E.id,E),this.l.$sessionCached(E.id)}return E}throw new Error("cannot find session")}ib(f){if(f){const E=I.URI.revive(f);return this.N.resolveWorkspaceFolder(E)}return Promise.resolve(void 0)}jb(f,E){return`${f}\0${E}`}kb(f,E){if(E){if("title"in E&&"command"in E)return{type:0};if("treeId"in E)return{type:1,id:`${f}\0${E.treeId}`};throw new Error("Unsupported debug visualization type")}}lb(f){const E=this.mb(f);let v,D;return"id"in E?D=i.ThemeIcon.asClassName(E):v=E,{iconPath:v,iconClass:D}}mb(f){if(f instanceof P.$qN)return{id:f.id};const E=typeof f=="object"&&"dark"in f?f.dark:f,v=typeof f=="object"&&"light"in f?f.light:f;return{dark:typeof E=="string"?I.URI.file(E):E,light:typeof v=="string"?I.URI.file(v):v}}};e.$Gkc=s,e.$Gkc=s=Qe([He(0,A.$OO),He(1,b.$Yjc),He(2,w.$Akc),He(3,a.$2jc),He(4,$.$bkc),He(5,m.$Dkc),He(6,n.$$O)],s);class t{constructor(f,E,v,D,k,S,F){this.f=f,this.g=E,this.h=v,this.j=D,this.k=k,this.l=S,this.m=F}get api(){const f=this;return this.d??(this.d=Object.freeze({id:f.g,type:f.h,get name(){return f.j},set name(E){f.j=E,f.f.$setDebugSessionName(f.g,E)},parentSession:f.m,workspaceFolder:f.k,configuration:f.l,customRequest(E,v){return f.f.$customDebugAdapterRequest(f.g,E,v)},getDebugProtocolBreakpoint(E){return f.f.$getDebugProtocolBreakpoint(f.g,E.id)}}))}get id(){return this.g}get type(){return this.h}_acceptNameChanged(f){this.j=f}get configuration(){return this.l}}e.$Hkc=t;class g{constructor(f){this.value=Object.freeze({append(E){f.$appendDebugConsole(E)},appendLine(E){this.append(E+`
`)}})}}e.$Ikc=g;class d{constructor(f){this.d=f}onWillStartSession(){this.d.forEach(f=>f.onWillStartSession?f.onWillStartSession():void 0)}onWillReceiveMessage(f){this.d.forEach(E=>E.onWillReceiveMessage?E.onWillReceiveMessage(f):void 0)}onDidSendMessage(f){this.d.forEach(E=>E.onDidSendMessage?E.onDidSendMessage(f):void 0)}onWillStopSession(){this.d.forEach(f=>f.onWillStopSession?f.onWillStopSession():void 0)}onError(f){this.d.forEach(E=>E.onError?E.onError(f):void 0)}onExit(f,E){this.d.forEach(v=>v.onExit?v.onExit(f,E):void 0)}}class h extends C.$job{constructor(f){super(),this.h=f,f.onDidSendMessage(E=>{this.acceptMessage(E)})}startSession(){return Promise.resolve(void 0)}sendMessage(f){this.h.handleMessage(f)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let c=class extends s{constructor(f,E,v,D,k,S,F){super(f,E,v,D,k,S,F)}};e.$Jkc=c,e.$Jkc=c=Qe([He(0,A.$OO),He(1,b.$Yjc),He(2,w.$Akc),He(3,a.$2jc),He(4,$.$bkc),He(5,m.$Dkc),He(6,n.$$O)],c)}),define(Ee[374],Ce([1,0,13,58,2,6,320,12,84,107,28,257,20,66,48,90]),function(re,e,o,R,I,M,O,p,$,w,A,P,b,C,y,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Olc=e.$Nlc=void 0;class m{static async installEarlyHandler(n){Error.stackTraceLimit=100;const r=n.get(p.$Oj),t=n.get(b.$OO).getProxy(M.$sM.MainThreadErrors);o.setUnexpectedErrorHandler(g=>{r.error(g);const d=o.$3(g);t.$onUnexpectedError(d)})}static async installFullHandler(n){const r=n.get(p.$Oj),s=n.get(b.$OO),t=n.get(y.$Akc),g=n.get(a.$9O),d=s.getProxy(M.$sM.MainThreadExtensionService),h=s.getProxy(M.$sM.MainThreadErrors),c=await t.getExtensionPathIndex(),u=new WeakMap;function f(D,k){if(u.has(D))return u.get(D).stack;let S="",F,W;for(const T of k)S+=`
	at ${T.toString()}`,W=T.getFileName(),!F&&W&&(F=c.findSubstr(I.URI.file(W)));const B=`${D.name||"Error"}: ${D.message||""}${S}`;return u.set(D,{extensionIdentifier:F?.identifier,stack:B}),B}const E=Symbol("prepareStackTrace wrapped");let v=f;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return v},set(D){if(D===f||!D||D[E]){v=D||f;return}v=function(k,S){return f(k,S),D.call(Error,k,S)},Object.assign(v,{[E]:!0})}}),o.setUnexpectedErrorHandler(D=>{r.error(D);const k=o.$3(D),S=u.get(D);if(!S?.extensionIdentifier){h.$onUnexpectedError(k);return}d.$onExtensionRuntimeError(S.extensionIdentifier,k);const F=g.onExtensionError(S.extensionIdentifier,D);r.trace("forwarded error to extension?",F,S)})}}e.$Nlc=m;class l{constructor(n,r,s,t,g){this.a=s,this.b=new O.$y$b(n,null,t),r=l.e(r,this.b);const d=new w.$gi(...(0,$.$is)());d.set(A.$5O,{_serviceBrand:void 0,...r,messagePorts:g}),d.set(b.$OO,new b.$PO(this.b)),d.set(C.$Vjc,new C.$Wjc(t)),d.set(y.$ykc,s);const h=new P.$Zq(d,!0);h.invokeFunction(m.installEarlyHandler),this.d=h.invokeFunction(c=>c.get(p.$Oj)),R.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",r),this.c=h.invokeFunction(c=>c.get(y.$Akc)),this.c.initialize(),h.invokeFunction(m.installFullHandler)}async asBrowserUri(n){const r=this.b.getProxy(M.$sM.MainThreadExtensionService);return I.URI.revive(await r.$asBrowserUri(n))}terminate(n){this.c.terminate(n)}static e(n,r){n.extensions.allExtensions.forEach(t=>{t.extensionLocation=I.URI.revive(r.transformIncomingURIs(t.extensionLocation))}),n.environment.appRoot=I.URI.revive(r.transformIncomingURIs(n.environment.appRoot));const s=n.environment.extensionDevelopmentLocationURI;return s&&(n.environment.extensionDevelopmentLocationURI=s.map(t=>I.URI.revive(r.transformIncomingURIs(t)))),n.environment.extensionTestsLocationURI=I.URI.revive(r.transformIncomingURIs(n.environment.extensionTestsLocationURI)),n.environment.globalStorageHome=I.URI.revive(r.transformIncomingURIs(n.environment.globalStorageHome)),n.environment.workspaceStorageHome=I.URI.revive(r.transformIncomingURIs(n.environment.workspaceStorageHome)),n.environment.extensionTelemetryLogResource=I.URI.revive(r.transformIncomingURIs(n.environment.extensionTelemetryLogResource)),n.nlsBaseUrl=I.URI.revive(r.transformIncomingURIs(n.nlsBaseUrl)),n.logsLocation=I.URI.revive(r.transformIncomingURIs(n.logsLocation)),n.workspace=r.transformIncomingURIs(n.workspace),n}}e.$Olc=l}),define(Ee[375],Ce([1,0,8,11,231,250,142,96,71,48,20,44,7,60,38,292,293,45,33,376]),function(re,e,o,R,I,M,O,p,$,w,A,P,b,C,y,a,m,l,i,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ylc=void 0;let r=class extends p.$Gkc{constructor(c,u,f,E,v,D,k,S){super(c,u,f,E,D,k,S),this.pb=v,this.nb=new d}X(c,u){switch(c.type){case"server":return new a.$Tlc(c);case"pipeServer":return new a.$Ulc(c);case"executable":return new a.$Vlc(c,u.type)}return super.X(c,u)}fb(c,u){const f=a.$Vlc.platformAdapterExecutable(u.getAllExtensionDescriptions(),c.type);if(f)return new b.$yN(f.command,f.args,f.options)}Y(){return new O.$lcc}async $runInTerminal(c,u){if(c.kind==="integrated"){this.ob||(this.ob=this.pb.onDidCloseTerminal(j=>{this.nb.onTerminalClosed(j)}));const f=await this.P.getConfigProvider(),E=this.pb.getDefaultShell(!0),v=this.pb.getDefaultShellArgs(!0),D=c.title||I.localize(0,null),k=s(E,v,c);let S=await this.nb.checkout(k,D,!0),F,W=!1;if(S)F=c.cwd;else{const j={shellPath:E,shellArgs:v,cwd:c.cwd,name:D,iconPath:new b.$qN("debug"),env:c.env};W=!0,S=this.pb.createTerminalFromOptions(j,{isFeatureTerminal:!0,forceShellIntegration:!0,useShellEnvironment:!0}),this.nb.insert(S,k)}S.show(!0);const B=await S.processId;W?await new Promise(j=>setTimeout(j,1e3)):(S.state.isInteractedWith&&S.sendText(""),f.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(E.indexOf("powershell")>=0||E.indexOf("pwsh")>=0||E.indexOf("cmd.exe")>=0?S.sendText("cls"):E.indexOf("bash")>=0?S.sendText("clear"):R.$c?S.sendText("cls"):S.sendText("clear")));const T=(0,m.$Xlc)(E,c.args,!!c.argsCanBeInterpretedByShell,F);S.sendText(T);const N=this.onDidTerminateDebugSession(j=>{j.id===u&&(this.nb.free(S),N.dispose())});return B}else if(c.kind==="external")return g(c,await this.P.getConfigProvider());return super.$runInTerminal(c,u)}};e.$Ylc=r,e.$Ylc=r=Qe([He(0,A.$OO),He(1,y.$Yjc),He(2,w.$Akc),He(3,l.$2jc),He(4,P.$nkc),He(5,$.$bkc),He(6,C.$Dkc),He(7,i.$$O)],r);function s(h,c,u){const f=(0,n.createHash)("sha256");return f.update(JSON.stringify({shell:h,shellArgs:c})),f.update(JSON.stringify(Object.entries(u.env||{}).sort(([E],[v])=>E.localeCompare(v)))),f.digest("base64")}let t;function g(h,c){if(!t)if(R.$c)t=new M.$9ac;else if(R.$d)t=new M.$0ac;else if(R.$e)t=new M.$$ac;else throw new Error("external terminals not supported on this platform");const u=c.getConfiguration("terminal");return t.runInTerminal(h.title,h.cwd,h.args,h.env||{},u.external||{})}class d{constructor(){this.b=new Map}async checkout(c,u,f=!1){const v=[...this.b.entries()].map(([D,k])=>(0,o.$8g)(async S=>{if(D.name!==u||k.lastUsedAt!==-1&&await(0,m.$Wlc)(await D.processId))return null;const F=Date.now();return k.lastUsedAt+d.a>F||S.isCancellationRequested?null:k.config!==c?(f&&D.dispose(),null):(k.lastUsedAt=F,D)}));return await(0,o.$nh)(v,D=>!!D)}insert(c,u){this.b.set(c,{lastUsedAt:Date.now(),config:u})}free(c){const u=this.b.get(c);u&&(u.lastUsedAt=-1)}onTerminalClosed(c){this.b.delete(c)}}d.a=1e3}),define(Ee[377],Ce([1,0,17,2,104,38,72,45,43,44,20,28,95,15,12,91,23,62,60]),function(re,e,o,R,I,M,O,p,$,w,A,P,b,C,y,a,m,l,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qlc=void 0;let n=class extends b.$qlc{constructor(s,t,g,d,h,c,u,f,E){super(s,t,g,d,h,c,u,f),this.C=g,this.D=E,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(C.Schemas.vscodeRemote,{scheme:C.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(C.Schemas.file,{scheme:C.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(s,t){const g=t;if(!t.execution&&g._id===void 0)throw new Error("Tasks to execute must include an execution");if(g._id!==void 0){const d=b.TaskHandleDTO.from(g,this.C),h=await this.a.$getTaskExecution(d);if(h.task===void 0)throw new Error("Task from execution DTO is undefined");const c=await this.z(h,t);return this.a.$executeTask(d).catch(()=>{}),c}else{const d=b.TaskDTO.from(t,s);if(d===void 0)return Promise.reject(new Error("Task is not valid"));b.CustomExecutionDTO.is(d.execution)&&await this.y(d,t,!1);const h=await this.z(await this.a.$getTaskExecution(d),t);return this.a.$executeTask(d).catch(()=>{}),h}}v(s,t,g,d){const h=[];if(d)for(const c of d){this.A(c,g),(!c.definition||!s[c.definition.type])&&this.f.warn(`The task [${c.source}, ${c.name}] uses an undefined task type. The task will be ignored in the future.`);const u=b.TaskDTO.from(c,g.extension);u&&(h.push(u),b.CustomExecutionDTO.is(u.execution)&&t.push(this.y(u,c,!0)))}return{tasks:h,extension:g.extension}}async w(s){return s}async G(s){let t=s&&s.length>0?s[0]:void 0;if(!t){const g=R.URI.file((0,l.homedir)());t=new $.$Ci({uri:g,name:m.$Sg(g),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(s,t){const g=R.URI.revive(s),d={process:void 0,variables:Object.create(null)},h=await this.b.resolveWorkspaceFolder(g),c=await this.b.getWorkspaceFolders2()??[],u=await this.D.getResolver(),f=h?{uri:h.uri,name:h.name,index:h.index,toResource:()=>{throw new Error("Not implemented")}}:await this.G(c);for(const E of t.variables)d.variables[E]=await u.resolveAsync(f,E);if(t.process!==void 0){let E;if(t.process.path!==void 0){E=t.process.path.split(o.$uc);for(let v=0;v<E.length;v++)E[v]=await u.resolveAsync(f,E[v])}d.process=await I.win32.findExecutable(await u.resolveAsync(f,t.process.name),t.process.cwd!==void 0?await u.resolveAsync(f,t.process.cwd):void 0,E)}return d}async $jsonTasksSupported(){return!0}async $findExecutable(s,t,g){return I.win32.findExecutable(s,t,g)}};e.$Qlc=n,e.$Qlc=n=Qe([He(0,A.$OO),He(1,P.$5O),He(2,M.$Yjc),He(3,O.$ZO),He(4,p.$2jc),He(5,w.$nkc),He(6,y.$Oj),He(7,a.$zjc),He(8,i.$Dkc)],n)}),define(Ee[378],Ce([1,0,62,60]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wmc=void 0;class I extends R.$Ekc{m(){return(0,o.homedir)()}}e.$wmc=I}),define(Ee[160],Ce([1,0,19,8,22,47,15,17,23,2,36]),function(re,e,o,R,I,M,O,p,$,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1kc=e.$Ykc=e.$Xkc=void 0,e.$Zkc=a;class P{constructor(i,n,r){this.d=i,this.e=n,this.f=r,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(i,n){const r=this.g.folderQueries||[],s=new I.$ee(n);return new Promise((t,g)=>{this.a=new C(i);let d=!1;const h=(c,u)=>{if(!d&&!this.b){const f=this.h(c);a(c)&&typeof this.g.maxResults=="number"&&this.c+f>this.g.maxResults&&(this.b=!0,d=!0,s.cancel(),c=this.j(c,this.g.maxResults-this.c));const E=this.h(c);this.c+=E,(E>0||!a(c))&&this.a.add(c,u)}};Promise.all(r.map((c,u)=>this.k(c,f=>h(f,u),s.token))).then(c=>{s.dispose(),this.a.flush();const u=c.some(f=>!!f&&!!f.limitHit);t({limitHit:this.b||u,messages:(0,o.$Rb)(c.map(f=>f?.message?Array.isArray(f.message)?f.message:[f.message]:[])),stats:{type:this.f}})},c=>{s.dispose();const u=(0,M.$6i)(c);g(new Error(u))})})}h(i){return a(i)?Array.isArray(i.ranges)?i.ranges.length:1:0}j(i,n){const r=Array.isArray(i.ranges)?i.ranges:[i.ranges],s=Array.isArray(i.preview.matches)?i.preview.matches:[i.preview.matches];return{ranges:r.slice(0,n),preview:{matches:s.slice(0,n),text:i.preview.text},uri:i.uri}}async k(i,n,r){const s=new A.$ZK(this.g,i),t=[],g={report:c=>{if(!this.l(c))return;const u=i.folder.scheme===O.Schemas.file?(0,A.$1K)(()=>this.e.readdir($.$Ug(c.uri))):void 0,f=$.$Xg(i.folder,c.uri);if(f){const E=s.includedInQuery(f,p.$oc(f),u);(0,R.$7g)(E)?t.push(E.then(v=>{v&&n(c)})):E&&n(c)}}},d=this.n(i);let h;return this.d.query.type===3?h=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,d,g,r):h=await this.d.provider.provideTextSearchResults(b(this.d.query.contentPattern),d,g,r),t.length&&await Promise.all(t),h}l(i){if(a(i)){if(Array.isArray(i.ranges)){if(!Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(i.preview.matches.length!==i.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(i){const n=(0,A.$YK)(this.g.includePattern,i.includePattern),r=(0,A.$YK)(this.g.excludePattern,i.excludePattern),s={folder:w.URI.from(i.folder),excludes:r,includes:n,useIgnoreFiles:!i.disregardIgnoreFiles,useGlobalIgnoreFiles:!i.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!i.disregardParentIgnoreFiles,followSymlinks:!i.ignoreSymlinks,encoding:i.fileEncoding&&this.e.toCanonicalName(i.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(s.usePCRE2=this.g.usePCRE2),s}}e.$Xkc=P;function b(l){return{isCaseSensitive:l.isCaseSensitive||!1,isRegExp:l.isRegExp||!1,isWordMatch:l.isWordMatch||!1,isMultiline:l.isMultiline||!1,pattern:l.pattern}}class C{constructor(i){this.e=i,this.b=-1,this.d=null,this.a=new m(512,n=>this.g(n))}add(i,n){this.d&&(this.b!==n||!$.$Og(this.c,i.uri))&&(this.f(),this.d=null),this.d||(this.b=n,this.d={resource:i.uri,results:[]}),this.d.results.push(y(i))}f(){const i=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,i)}flush(){this.f(),this.a.flush()}g(i){this.e(i)}}e.$Ykc=C;function y(l){return a(l)?{preview:{matches:(0,o.$2b)(l.preview.matches,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character})),text:l.preview.text},ranges:(0,o.$2b)(l.ranges,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character}))}:{text:l.text,lineNumber:l.lineNumber}}function a(l){return!!l.preview}class m{constructor(i,n){this.g=i,this.h=n,this.c=0,this.d=[],this.e=0}addItem(i,n){i&&this.j(i,n)}addItems(i,n){i&&this.k(i,n)}j(i,n){this.d.push(i),this.e+=n,this.l()}k(i,n){this.d=this.d.concat(i),this.e+=n,this.l()}l(){this.c<m.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},m.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$1kc=m,m.a=4e3,m.b=50}),define(Ee[97],Ce([1,0,3,6,5,370,20,66,12,2,160]),function(re,e,o,R,I,M,O,p,$,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3kc=e.$2kc=void 0,e.$4kc=b,e.$2kc=(0,I.$ii)("IExtHostSearch");let P=class{constructor(a,m,l){this.n=a,this.o=m,this.q=l,this.c=this.n.getProxy(R.$sM.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new M.$Wkc}s(a){return this.o.transformOutgoingScheme(a)}registerTextSearchProvider(a,m){if(this.g.has(a))throw new Error(`a text search provider for the scheme '${a}' is already registered`);this.g.add(a);const l=this.d++;return this.e.set(l,m),this.c.$registerTextSearchProvider(l,this.s(a)),(0,o.$Sc)(()=>{this.g.delete(a),this.e.delete(l),this.c.$unregisterProvider(l)})}registerAITextSearchProvider(a,m){if(this.i.has(a))throw new Error(`an AI text search provider for the scheme '${a}'is already registered`);this.i.add(a);const l=this.d++;return this.h.set(l,m),this.c.$registerAITextSearchProvider(l,this.s(a)),(0,o.$Sc)(()=>{this.i.delete(a),this.h.delete(l),this.c.$unregisterProvider(l)})}registerFileSearchProvider(a,m){if(this.k.has(a))throw new Error(`a file search provider for the scheme '${a}' is already registered`);this.k.add(a);const l=this.d++;return this.j.set(l,m),this.c.$registerFileSearchProvider(l,this.s(a)),(0,o.$Sc)(()=>{this.k.delete(a),this.j.delete(l),this.c.$unregisterProvider(l)})}$provideFileSearchResults(a,m,l,i){const n=b(l),r=this.j.get(a);if(r)return this.l.fileSearch(n,r,s=>{this.c.$handleFileMatch(a,m,s.map(t=>t.resource))},i);throw new Error("3 unknown provider: "+a)}async doInternalFileSearchWithCustomCallback(a,m,l){return{messages:[]}}$clearCache(a){return this.l.clearCache(a),Promise.resolve(void 0)}$provideTextSearchResults(a,m,l,i){const n=this.e.get(a);if(!n||!n.provideTextSearchResults)throw new Error(`2 Unknown provider ${a}`);const r=b(l);return this.t(r,n).search(t=>this.c.$handleTextMatch(a,m,t),i)}$provideAITextSearchResults(a,m,l,i){const n=this.h.get(a);if(!n||!n.provideAITextSearchResults)throw new Error(`1 Unknown provider ${a}`);const r=b(l);return this.v(r,n).search(t=>this.c.$handleTextMatch(a,m,t),i)}$enableExtensionHostSearch(){}t(a,m){return new A.$Xkc({query:a,provider:m},{readdir:l=>Promise.resolve([]),toCanonicalName:l=>l},"textSearchProvider")}v(a,m){return new A.$Xkc({query:a,provider:m},{readdir:l=>Promise.resolve([]),toCanonicalName:l=>l},"aiTextSearchProvider")}};e.$3kc=P,e.$3kc=P=Qe([He(0,O.$OO),He(1,p.$Vjc),He(2,$.$Oj)],P);function b(y){return{...y,folderQueries:y.folderQueries&&y.folderQueries.map(C),extraFileResources:y.extraFileResources&&y.extraFileResources.map(a=>w.URI.revive(a))}}function C(y){return{...y,folder:w.URI.revive(y.folder)}}}),define(Ee[379],Ce([1,0,22,13,4,3,15,41,2,136,186,187,82,25,32,12,86,87,276,6,322,349,91,121,327,308,328,122,329,309,297,33,330,45,331,96,152,332,311,323,333,334,72,71,324,48,335,69,336,59,28,350,351,325,312,337,338,116,117,313,369,340,282,341,352,342,158,314,343,344,345,20,346,97,118,347,315,348,119,93,95,90,44,353,354,326,355,356,70,16,7,316,66,317,92,357,358,151,38,290,115,26,94,156]),function(re,e,o,R,I,M,O,p,$,w,A,P,b,C,y,a,m,l,i,n,r,s,t,g,d,h,c,u,f,E,v,D,k,S,F,W,B,T,N,j,L,z,Q,Y,J,x,ce,te,pe,ye,_,U,he,Se,me,ie,se,oe,G,ee,le,de,Me,be,Pe,Re,ze,V,H,Z,X,fe,we,Te,Ve,Ze,nt,ot,lt,at,st,Ie,We,Ae,Ke,ae,ue,De,Je,et,Ne,ht,vt,Mt,zt,Zt,xt,Pt,sn,_t,dn,tt,on,Gt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ilc=Kt;function Kt(gt){const bt=gt.get(_.$5O),Xt=gt.get(ye.$Djc),Bt=gt.get(te.$4jc),Vt=gt.get(x.$Akc),$t=gt.get(sn.$Yjc),Rt=gt.get(Ie.$9O),cn=gt.get(S.$2jc),en=gt.get(vt.$Vjc),Xe=gt.get(fe.$OO),Yt=gt.get(lt.$kkc),tn=gt.get(at.$5jc),nn=gt.get(a.$Pj),yt=gt.get(a.$Oj),Ut=gt.get(Je.$kCb),Tt=gt.get(t.$zjc),Ot=gt.get(Pt.$Flc),un=gt.get(Ve.$skc),Wt=gt.get(Y.$bkc),Ht=gt.get(G.$wkc),It=gt.get(g.$Jjc),Ft=gt.get(u.$Ojc);Xe.set(n.$tM.ExtHostFileSystemInfo,Xt),Xe.set(n.$tM.ExtHostLogLevelServiceShape,nn),Xe.set(n.$tM.ExtHostWorkspace,$t),Xe.set(n.$tM.ExtHostConfiguration,cn),Xe.set(n.$tM.ExtHostExtensionService,Vt),Xe.set(n.$tM.ExtHostStorage,Yt),Xe.set(n.$tM.ExtHostTunnelService,Ut),Xe.set(n.$tM.ExtHostWindow,Ot),Xe.set(n.$tM.ExtHostSecretState,un),Xe.set(n.$tM.ExtHostTelemetry,Rt),Xe.set(n.$tM.ExtHostEditorTabs,Wt),Xe.set(n.$tM.ExtHostManagedSockets,Ht),Xe.set(n.$tM.ExtHostAuthentication,It),Xe.set(n.$tM.ExtHostChatProvider,Ft);const rn=Xe.set(n.$tM.ExtHostDecorations,gt.get(B.$Lkc)),At=Xe.set(n.$tM.ExtHostDocumentsAndEditors,gt.get(Q.$ZO)),Et=Xe.set(n.$tM.ExtHostCommands,gt.get(D.$$O)),Nt=Xe.set(n.$tM.ExtHostTerminalService,gt.get(We.$nkc)),fn=Xe.set(n.$tM.ExtHostTerminalShellIntegration,gt.get(Gt.$Glc)),Ct=Xe.set(n.$tM.ExtHostDebugService,gt.get(W.$Fkc)),ln=Xe.set(n.$tM.ExtHostSearch,gt.get(Te.$2kc)),Jt=Xe.set(n.$tM.ExtHostTask,gt.get(st.$slc)),En=Xe.set(n.$tM.ExtHostOutputService,gt.get(ze.$flc)),wn=Xe.set(n.$tM.ExtHostLocalization,gt.get(oe.$vkc)),Le=Xe.set(n.$tM.ExtHostUrls,new Mt.$Clc(Xe)),Fe=Xe.set(n.$tM.ExtHostDocuments,new z.$Gjc(Xe,At)),ke=Xe.set(n.$tM.ExtHostDocumentContentProviders,new j.$Nkc(Xe,At,yt)),ne=Xe.set(n.$tM.ExtHostDocumentSaveParticipant,new L.$Okc(yt,Fe,Xe.getProxy(n.$sM.MainThreadBulkEdits))),Oe=Xe.set(n.$tM.ExtHostNotebook,new le.$5kc(Xe,Et,At,Fe,Bt,ln)),Ge=Xe.set(n.$tM.ExtHostNotebookDocuments,new Me.$_kc(Oe)),_e=Xe.set(n.$tM.ExtHostNotebookEditors,new be.$alc(yt,Oe)),Ye=Xe.set(n.$tM.ExtHostNotebookKernels,new Pe.$blc(Xe,bt,Oe,Et,yt)),dt=Xe.set(n.$tM.ExtHostNotebookRenderers,new Re.$dlc(Xe,Oe)),St=Xe.set(n.$tM.ExtHostNotebookDocumentSaveParticipant,new de.$$kc(yt,Oe,Xe.getProxy(n.$sM.MainThreadBulkEdits))),Dt=Xe.set(n.$tM.ExtHostEditors,new Ke.$Sjc(Xe,At)),an=Xe.set(n.$tM.ExtHostTreeViews,new De.$Alc(Xe.getProxy(n.$sM.MainThreadTreeViews),Et,yt)),Lt=Xe.set(n.$tM.ExtHostEditorInsets,new v.$Tjc(Xe.getProxy(n.$sM.MainThreadEditorInsets),Dt,bt.remote)),qt=Xe.set(n.$tM.ExtHostDiagnostics,new T.$Fjc(Xe,yt,Xt,At)),Cn=Xe.set(n.$tM.ExtHostLanguages,new se.$9kc(Xe,Fe,Et.converter,en)),mt=Xe.set(n.$tM.ExtHostLanguageFeatures,new ie.$Hjc(Xe,en,Fe,Et,qt,yt,Tt,Rt)),Tn=Xe.set(n.$tM.ExtHostFileSystem,new ce.$Qkc(Xe,mt)),gn=Xe.set(n.$tM.ExtHostFileSystemEventService,new pe.$Rkc(Xe,yt,At)),vn=Xe.set(n.$tM.ExtHostQuickOpen,(0,X.$jlc)(Xe,$t,Et)),Mn=Xe.set(n.$tM.ExtHostSCM,new we.$llc(Xe,Et,Fe,yt)),mi=Xe.set(n.$tM.ExtHostQuickDiff,new Z.$ilc(Xe,en)),$i=Xe.set(n.$tM.ExtHostShare,new Ze.$mlc(Xe,en)),Fn=Xe.set(n.$tM.ExtHostComments,(0,k.$Ujc)(Xe,Et,Fe)),zn=Xe.set(n.$tM.ExtHostProgress,new H.$hlc(Xe.getProxy(n.$sM.MainThreadProgress))),Bn=Xe.set(n.$tM.ExtHostLabelService,new me.$8kc(Xe)),Rn=Xe.set(n.$tM.ExtHostTheming,new ae.$xlc(Xe)),Un=Xe.set(n.$tM.ExtHostTimeline,new ue.$zlc(Xe,Et)),Sn=Xe.set(n.$tM.ExtHostWebviews,new zt.$9jc(Xe,bt.remote,$t,yt,Tt)),On=Xe.set(n.$tM.ExtHostWebviewPanels,new Zt.$_jc(Xe,Sn,$t)),pi=Xe.set(n.$tM.ExtHostCustomEditors,new F.$akc(Xe,Fe,tn,Sn,On)),xn=Xe.set(n.$tM.ExtHostWebviewViews,new xt.$Dlc(Xe,Sn)),yn=Xe.set(n.$tM.ExtHostTesting,new Ae.$tlc(Xe,yt,Et,At)),Wn=Xe.set(n.$tM.ExtHostUriOpeners,new ht.$Blc(Xe)),_n=Xe.set(n.$tM.ExtHostProfileContentHandlers,new V.$glc(Xe));Xe.set(n.$tM.ExtHostInteractive,new he.$6kc(Xe,Oe,At,Et,yt));const ei=Xe.set(n.$tM.ExtHostInlineChat,new U.$Skc(Xe,Et,Fe,yt)),Vn=Xe.set(n.$tM.ExtHostChatAgents2,new c.$Njc(Xe,yt,Et)),ti=Xe.set(n.$tM.ExtHostChatVariables,new f.$Qjc(Xe)),qn=Xe.set(n.$tM.ExtHostChat,new h.$Mjc(Xe)),Hn=Xe.set(n.$tM.ExtHostAiRelatedInformation,new r.$yjc(Xe)),bi=Xe.set(n.$tM.ExtHostAiEmbeddingVector,new J.$Pkc(Xe)),ni=Xe.set(n.$tM.ExtHostIssueReporter,new Se.$7kc(Xe)),Ln=Xe.set(n.$tM.ExtHostStatusBar,new ot.$plc(Xe,Et.converter)),Gn=Xe.set(n.$tM.ExtHostSpeech,new nt.$nlc(Xe)),wi=Object.values(n.$tM);Xe.assertRegistered(wi);const vi=new d.$Ljc(Xe,At),ii=new E.$Rjc(Xe),Kn=new ee.$0kc(Xe,yt),Dn=new N.$Mkc(Xe);return s.$Ijc.register(Et),function(Ue,mn,Jn){function ct(ge){return(ve,Be,ut)=>{const kt=ge(jt=>{try{ve.call(Be,jt)}catch(An){R.$2(new Error(`[ExtensionListenerError] Extension '${Ue.identifier.value}' FAILED to handle event: ${An.toString()}`,{cause:An})),Rt.onExtensionError(Ue.identifier,An)}});return ut?.push(kt),kt}}const wt=function(){let ge=!Ue.isUnderDevelopment;function ve(){ge||(yt.info(`Extension '${Ue.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ge=!0)}return function Be(ut){if(Array.isArray(ut))ut.forEach(Be);else if(typeof ut=="string")ve();else{const kt=ut;typeof kt.scheme>"u"&&ve(),typeof kt.exclusive=="boolean"&&(0,tt.$dG)(Ue,"documentFiltersExclusive")}return ut}}(),ri={getSession(ge,ve,Be){return typeof Be?.forceNewSession=="object"&&Be.forceNewSession.learnMore&&(0,tt.$dG)(Ue,"authLearnMore"),It.getSession(Ue,ge,ve,Be)},getSessions(ge,ve){return(0,tt.$dG)(Ue,"authGetSessions"),It.getSessions(Ue,ge,ve)},async hasSession(ge,ve){return(0,tt.$dG)(Ue,"authSession"),!!await It.getSession(Ue,ge,ve,{silent:!0})},get onDidChangeSessions(){return ct(It.onDidChangeSessions)},registerAuthenticationProvider(ge,ve,Be,ut){return It.registerAuthenticationProvider(ge,ve,Be,ut)}},pn={registerCommand(ge,ve,Be){return Et.registerCommand(!0,ge,ve,Be,void 0,Ue)},registerTextEditorCommand(ge,ve,Be){return Et.registerCommand(!0,ge,(...ut)=>{const kt=Dt.getActiveTextEditor();if(!kt){yt.warn("Cannot execute "+ge+" because there is no active text editor.");return}return kt.edit(jt=>{ve.apply(Be,[kt,jt,...ut])}).then(jt=>{jt||yt.warn("Edits from command "+ge+" were not applied.")},jt=>{yt.warn("An error occurred while running command "+ge,jt)})},void 0,void 0,Ue)},registerDiffInformationCommand:(ge,ve,Be)=>((0,tt.$dG)(Ue,"diffCommand"),Et.registerCommand(!0,ge,async(...ut)=>{const kt=At.activeEditor(!0);if(!kt){yt.warn("Cannot execute "+ge+" because there is no active text editor.");return}const jt=await Dt.getDiffInformation(kt.id);ve.apply(Be,[jt,...ut])},void 0,void 0,Ue)),executeCommand(ge,...ve){return Et.executeCommand(ge,...ve)},getCommands(ge=!1){return Et.getCommands(ge)}},Pn={get machineId(){return bt.telemetryInfo.machineId},get sessionId(){return bt.telemetryInfo.sessionId},get language(){return bt.environment.appLanguage},get appName(){return bt.environment.appName},get appRoot(){return bt.environment.appRoot?.fsPath??""},get appHost(){return bt.environment.appHost},get uriScheme(){return bt.environment.appUriScheme},get clipboard(){return ii.value},get shell(){return Nt.getDefaultShell(!1)},get onDidChangeShell(){return ct(Nt.onDidChangeShell)},get isTelemetryEnabled(){return Rt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return ct(Rt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,tt.$dG)(Ue,"telemetry"),Rt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,tt.$dG)(Ue,"telemetry"),ct(Rt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,Ie.$8O)(bt.telemetryInfo.firstSessionDate)},createTelemetryLogger(ge,ve){return Ie.$7O.validateSender(ge),Rt.instantiateLogger(Ue,ge,ve)},openExternal(ge,ve){return Ot.openUri(ge,{allowTunneling:!!bt.remote.authority,allowContributedOpeners:ve?.allowContributedOpeners})},async asExternalUri(ge){if(ge.scheme===bt.environment.appUriScheme)return Le.createAppUri(ge);try{return await Ot.asExternalUri(ge,{allowTunneling:!!bt.remote.authority})}catch(ve){if((0,O.$rg)(ge,O.Schemas.http)||(0,O.$rg)(ge,O.Schemas.https))return ge;throw ve}},get remoteName(){return(0,m.$vm)(bt.remote.authority)},get remoteAuthority(){return(0,tt.$dG)(Ue,"resolvers"),bt.remote.authority},get uiKind(){return bt.uiKind},get logLevel(){return yt.getLevel()},get onDidChangeLogLevel(){return ct(yt.onDidChangeLogLevel)},registerIssueUriRequestHandler(ge){return(0,tt.$dG)(Ue,"handleIssueUri"),ni.registerIssueUriRequestHandler(Ue,ge)},registerIssueDataProvider(ge){return(0,tt.$dG)(Ue,"handleIssueUri"),ni.registerIssueDataProvider(Ue,ge)},get appQuality(){return(0,tt.$dG)(Ue,"resolvers"),bt.quality},get appCommit(){return(0,tt.$dG)(Ue,"resolvers"),bt.commit}};bt.environment.extensionTestsLocationURI||Object.freeze(Pn);const yi={createTestController(ge,ve,Be){return yn.createTestController(Ue,ge,ve,Be)},createTestObserver(){return(0,tt.$dG)(Ue,"testObserver"),yn.createTestObserver()},runTests(ge){return(0,tt.$dG)(Ue,"testObserver"),yn.runTests(ge)},get onDidChangeTestResults(){return(0,tt.$dG)(Ue,"testObserver"),ct(yn.onResultsChanged)},get testResults(){return(0,tt.$dG)(Ue,"testObserver"),yn.results}},In=bt.remote.isRemote?Ne.ExtensionKind.Workspace:Ne.ExtensionKind.UI,Nn={getExtension(ge,ve){(0,tt.$cG)(Ue,"extensionsAny")||(ve=!1);const Be=mn.mine.getExtensionDescription(ge);if(Be)return new x.$Bkc(Vt,Ue.identifier,Be,In,!1);if(ve){const ut=mn.all.getExtensionDescription(ge);if(ut)return new x.$Bkc(Vt,Ue.identifier,ut,In,!0)}},get all(){const ge=[];for(const ve of mn.mine.getAllExtensionDescriptions())ge.push(new x.$Bkc(Vt,Ue.identifier,ve,In,!1));return ge},get allAcrossExtensionHosts(){(0,tt.$dG)(Ue,"extensionsAny");const ge=new C.$Fm(mn.mine.getAllExtensionDescriptions().map(Be=>Be.identifier)),ve=[];for(const Be of mn.all.getAllExtensionDescriptions()){const ut=!ge.has(Be.identifier);ve.push(new x.$Bkc(Vt,Ue.identifier,Be,In,ut))}return ve},get onDidChange(){return(0,tt.$cG)(Ue,"extensionsAny")?ct(I.Event.any(mn.mine.onDidChange,mn.all.onDidChange)):ct(mn.mine.onDidChange)}},si={createDiagnosticCollection(ge){return qt.createDiagnosticCollection(Ue.identifier,ge)},get onDidChangeDiagnostics(){return ct(qt.onDidChangeDiagnostics)},getDiagnostics:ge=>qt.getDiagnostics(ge),getLanguages(){return Cn.getLanguages()},setTextDocumentLanguage(ge,ve){return Cn.changeLanguage(ge.uri,ve)},match(ge,ve){const Be=et.LanguageSelector.from(ge);let ut;return(0,A.$Xt)(Be)&&(ut=Oe.notebookDocuments.find(kt=>kt.apiNotebook.getCells().find(jt=>jt.document===ve))?.apiNotebook),(0,A.$Wt)(Be,ve.uri,ve.languageId,!0,ut?.uri,ut?.notebookType)},registerCodeActionsProvider(ge,ve,Be){return mt.registerCodeActionProvider(Ue,wt(ge),ve,Be)},registerDocumentPasteEditProvider(ge,ve,Be){return(0,tt.$dG)(Ue,"documentPaste"),mt.registerDocumentPasteEditProvider(Ue,wt(ge),ve,Be)},registerCodeLensProvider(ge,ve){return mt.registerCodeLensProvider(Ue,wt(ge),ve)},registerDefinitionProvider(ge,ve){return mt.registerDefinitionProvider(Ue,wt(ge),ve)},registerDeclarationProvider(ge,ve){return mt.registerDeclarationProvider(Ue,wt(ge),ve)},registerImplementationProvider(ge,ve){return mt.registerImplementationProvider(Ue,wt(ge),ve)},registerTypeDefinitionProvider(ge,ve){return mt.registerTypeDefinitionProvider(Ue,wt(ge),ve)},registerHoverProvider(ge,ve){return mt.registerHoverProvider(Ue,wt(ge),ve,Ue.identifier)},registerEvaluatableExpressionProvider(ge,ve){return mt.registerEvaluatableExpressionProvider(Ue,wt(ge),ve,Ue.identifier)},registerInlineValuesProvider(ge,ve){return mt.registerInlineValuesProvider(Ue,wt(ge),ve,Ue.identifier)},registerDocumentHighlightProvider(ge,ve){return mt.registerDocumentHighlightProvider(Ue,wt(ge),ve)},registerMultiDocumentHighlightProvider(ge,ve){return mt.registerMultiDocumentHighlightProvider(Ue,wt(ge),ve)},registerLinkedEditingRangeProvider(ge,ve){return mt.registerLinkedEditingRangeProvider(Ue,wt(ge),ve)},registerReferenceProvider(ge,ve){return mt.registerReferenceProvider(Ue,wt(ge),ve)},registerRenameProvider(ge,ve){return mt.registerRenameProvider(Ue,wt(ge),ve)},registerNewSymbolNamesProvider(ge,ve){return(0,tt.$dG)(Ue,"newSymbolNamesProvider"),mt.registerNewSymbolNamesProvider(Ue,wt(ge),ve)},registerDocumentSymbolProvider(ge,ve,Be){return mt.registerDocumentSymbolProvider(Ue,wt(ge),ve,Be)},registerWorkspaceSymbolProvider(ge){return mt.registerWorkspaceSymbolProvider(Ue,ge)},registerDocumentFormattingEditProvider(ge,ve){return mt.registerDocumentFormattingEditProvider(Ue,wt(ge),ve)},registerDocumentRangeFormattingEditProvider(ge,ve){return mt.registerDocumentRangeFormattingEditProvider(Ue,wt(ge),ve)},registerOnTypeFormattingEditProvider(ge,ve,Be,...ut){return mt.registerOnTypeFormattingEditProvider(Ue,wt(ge),ve,[Be].concat(ut))},registerDocumentSemanticTokensProvider(ge,ve,Be){return mt.registerDocumentSemanticTokensProvider(Ue,wt(ge),ve,Be)},registerDocumentRangeSemanticTokensProvider(ge,ve,Be){return mt.registerDocumentRangeSemanticTokensProvider(Ue,wt(ge),ve,Be)},registerSignatureHelpProvider(ge,ve,Be,...ut){return typeof Be=="object"?mt.registerSignatureHelpProvider(Ue,wt(ge),ve,Be):mt.registerSignatureHelpProvider(Ue,wt(ge),ve,typeof Be>"u"?[]:[Be,...ut])},registerCompletionItemProvider(ge,ve,...Be){return mt.registerCompletionItemProvider(Ue,wt(ge),ve,Be)},registerInlineCompletionItemProvider(ge,ve,Be){return ve.handleDidShowCompletionItem&&(0,tt.$dG)(Ue,"inlineCompletionsAdditions"),ve.handleDidPartiallyAcceptCompletionItem&&(0,tt.$dG)(Ue,"inlineCompletionsAdditions"),Be&&(0,tt.$dG)(Ue,"inlineCompletionsAdditions"),mt.registerInlineCompletionsProvider(Ue,wt(ge),ve,Be)},registerInlineEditProvider(ge,ve){return(0,tt.$dG)(Ue,"inlineEdit"),mt.registerInlineEditProvider(Ue,wt(ge),ve)},registerDocumentLinkProvider(ge,ve){return mt.registerDocumentLinkProvider(Ue,wt(ge),ve)},registerColorProvider(ge,ve){return mt.registerColorProvider(Ue,wt(ge),ve)},registerFoldingRangeProvider(ge,ve){return mt.registerFoldingRangeProvider(Ue,wt(ge),ve)},registerSelectionRangeProvider(ge,ve){return mt.registerSelectionRangeProvider(Ue,ge,ve)},registerCallHierarchyProvider(ge,ve){return mt.registerCallHierarchyProvider(Ue,ge,ve)},registerTypeHierarchyProvider(ge,ve){return mt.registerTypeHierarchyProvider(Ue,ge,ve)},setLanguageConfiguration:(ge,ve)=>mt.setLanguageConfiguration(Ue,ge,ve),getTokenInformationAtPosition(ge,ve){return(0,tt.$dG)(Ue,"tokenInformation"),Cn.tokenAtPosition(ge,ve)},registerInlayHintsProvider(ge,ve){return mt.registerInlayHintsProvider(Ue,ge,ve)},createLanguageStatusItem(ge,ve){return Cn.createLanguageStatusItem(Ue,ge,ve)},registerDocumentDropEditProvider(ge,ve,Be){return mt.registerDocumentOnDropEditProvider(Ue,ge,ve,(0,tt.$cG)(Ue,"dropMetadata")?Be:void 0)}},oi={get activeTextEditor(){return Dt.getActiveTextEditor()},get visibleTextEditors(){return Dt.getVisibleTextEditors()},get activeTerminal(){return Nt.activeTerminal},get terminals(){return Nt.terminals},async showTextDocument(ge,ve,Be){$.URI.isUri(ge)&&ge.scheme===O.Schemas.vscodeRemote&&!ge.authority&&Tt.report("workspace.showTextDocument",Ue,"A URI of 'vscode-remote' scheme requires an authority.");const ut=await($.URI.isUri(ge)?Promise.resolve(Qn.openTextDocument(ge)):Promise.resolve(ge));return Dt.showTextDocument(ut,ve,Be)},createTextEditorDecorationType(ge){return Dt.createTextEditorDecorationType(Ue,ge)},onDidChangeActiveTextEditor(ge,ve,Be){return ct(Dt.onDidChangeActiveTextEditor)(ge,ve,Be)},onDidChangeVisibleTextEditors(ge,ve,Be){return ct(Dt.onDidChangeVisibleTextEditors)(ge,ve,Be)},onDidChangeTextEditorSelection(ge,ve,Be){return ct(Dt.onDidChangeTextEditorSelection)(ge,ve,Be)},onDidChangeTextEditorOptions(ge,ve,Be){return ct(Dt.onDidChangeTextEditorOptions)(ge,ve,Be)},onDidChangeTextEditorVisibleRanges(ge,ve,Be){return ct(Dt.onDidChangeTextEditorVisibleRanges)(ge,ve,Be)},onDidChangeTextEditorViewColumn(ge,ve,Be){return ct(Dt.onDidChangeTextEditorViewColumn)(ge,ve,Be)},onDidCloseTerminal(ge,ve,Be){return ct(Nt.onDidCloseTerminal)(ge,ve,Be)},onDidOpenTerminal(ge,ve,Be){return ct(Nt.onDidOpenTerminal)(ge,ve,Be)},onDidChangeActiveTerminal(ge,ve,Be){return ct(Nt.onDidChangeActiveTerminal)(ge,ve,Be)},onDidChangeTerminalDimensions(ge,ve,Be){return(0,tt.$dG)(Ue,"terminalDimensions"),ct(Nt.onDidChangeTerminalDimensions)(ge,ve,Be)},onDidChangeTerminalState(ge,ve,Be){return ct(Nt.onDidChangeTerminalState)(ge,ve,Be)},onDidWriteTerminalData(ge,ve,Be){return(0,tt.$dG)(Ue,"terminalDataWriteEvent"),ct(Nt.onDidWriteTerminalData)(ge,ve,Be)},onDidExecuteTerminalCommand(ge,ve,Be){return(0,tt.$dG)(Ue,"terminalExecuteCommandEvent"),ct(Nt.onDidExecuteTerminalCommand)(ge,ve,Be)},onDidChangeTerminalShellIntegration(ge,ve,Be){return(0,tt.$dG)(Ue,"terminalShellIntegration"),ct(fn.onDidChangeTerminalShellIntegration)(ge,ve,Be)},onDidStartTerminalShellExecution(ge,ve,Be){return(0,tt.$dG)(Ue,"terminalShellIntegration"),ct(fn.onDidStartTerminalShellExecution)(ge,ve,Be)},onDidEndTerminalShellExecution(ge,ve,Be){return(0,tt.$dG)(Ue,"terminalShellIntegration"),ct(fn.onDidEndTerminalShellExecution)(ge,ve,Be)},get state(){return Ot.getState(Ue)},onDidChangeWindowState(ge,ve,Be){return ct(Ot.onDidChangeWindowState)(ge,ve,Be)},showInformationMessage(ge,...ve){return Kn.showMessage(Ue,p.default.Info,ge,ve[0],ve.slice(1))},showWarningMessage(ge,...ve){return Kn.showMessage(Ue,p.default.Warning,ge,ve[0],ve.slice(1))},showErrorMessage(ge,...ve){return Kn.showMessage(Ue,p.default.Error,ge,ve[0],ve.slice(1))},showQuickPick(ge,ve,Be){return vn.showQuickPick(Ue,ge,ve,Be)},showWorkspaceFolderPick(ge){return vn.showWorkspaceFolderPick(ge)},showInputBox(ge,ve){return vn.showInput(ge,ve)},showOpenDialog(ge){return Dn.showOpenDialog(Ue,ge)},showSaveDialog(ge){return Dn.showSaveDialog(ge)},createStatusBarItem(ge,ve,Be){let ut,kt,jt;return typeof ge=="string"?(ut=ge,kt=ve,jt=Be):(kt=ge,jt=ve),Ln.createStatusBarEntry(Ue,ut,kt,jt)},setStatusBarMessage(ge,ve){return Ln.setStatusBarMessage(ge,ve)},withScmProgress(ge){return Tt.report("window.withScmProgress",Ue,"Use 'withProgress' instead."),zn.withProgress(Ue,{location:Ne.ProgressLocation.SourceControl},(ve,Be)=>ge({report(ut){}}))},withProgress(ge,ve){return zn.withProgress(Ue,ge,ve)},createOutputChannel(ge,ve){return En.createOutputChannel(ge,ve,Ue)},createWebviewPanel(ge,ve,Be,ut){return On.createWebviewPanel(Ue,ge,ve,Be,ut)},createWebviewTextEditorInset(ge,ve,Be,ut){return(0,tt.$dG)(Ue,"editorInsets"),Lt.createWebviewEditorInset(ge,ve,Be,ut,Ue)},createTerminal(ge,ve,Be){return typeof ge=="object"?"pty"in ge?Nt.createExtensionTerminal(ge):Nt.createTerminalFromOptions(ge):Nt.createTerminal(ge,ve,Be)},registerTerminalLinkProvider(ge){return Nt.registerLinkProvider(ge)},registerTerminalProfileProvider(ge,ve){return Nt.registerProfileProvider(Ue,ge,ve)},registerTerminalQuickFixProvider(ge,ve){return(0,tt.$dG)(Ue,"terminalQuickFixProvider"),Nt.registerTerminalQuickFixProvider(ge,Ue.identifier.value,ve)},registerTreeDataProvider(ge,ve){return an.registerTreeDataProvider(ge,ve,Ue)},createTreeView(ge,ve){return an.createTreeView(ge,ve,Ue)},registerWebviewPanelSerializer:(ge,ve)=>On.registerWebviewPanelSerializer(Ue,ge,ve),registerCustomEditorProvider:(ge,ve,Be={})=>pi.registerCustomEditorProvider(Ue,ge,ve,Be),registerFileDecorationProvider(ge){return rn.registerFileDecorationProvider(ge,Ue)},registerUriHandler(ge){return Le.registerUriHandler(Ue,ge)},createQuickPick(){return vn.createQuickPick(Ue)},createInputBox(){return vn.createInputBox(Ue)},get activeColorTheme(){return Rn.activeColorTheme},onDidChangeActiveColorTheme(ge,ve,Be){return ct(Rn.onDidChangeActiveColorTheme)(ge,ve,Be)},registerWebviewViewProvider(ge,ve,Be){return xn.registerWebviewViewProvider(Ue,ge,ve,Be?.webviewOptions)},get activeNotebookEditor(){return Oe.activeNotebookEditor},onDidChangeActiveNotebookEditor(ge,ve,Be){return ct(Oe.onDidChangeActiveNotebookEditor)(ge,ve,Be)},get visibleNotebookEditors(){return Oe.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return ct(Oe.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(ge,ve,Be){return ct(_e.onDidChangeNotebookEditorSelection)(ge,ve,Be)},onDidChangeNotebookEditorVisibleRanges(ge,ve,Be){return ct(_e.onDidChangeNotebookEditorVisibleRanges)(ge,ve,Be)},showNotebookDocument(ge,ve){return Oe.showNotebookDocument(ge,ve)},registerExternalUriOpener(ge,ve,Be){return(0,tt.$dG)(Ue,"externalUriOpener"),Wn.registerExternalUriOpener(Ue.identifier,ge,ve,Be)},registerProfileContentHandler(ge,ve){return(0,tt.$dG)(Ue,"profileContentHandlers"),_n.registerProfileContentHandler(Ue,ge,ve)},registerQuickDiffProvider(ge,ve,Be,ut){return(0,tt.$dG)(Ue,"quickDiffProvider"),mi.registerQuickDiffProvider(wt(ge),ve,Be,ut)},get tabGroups(){return Wt.tabGroups},registerShareProvider(ge,ve){return(0,tt.$dG)(Ue,"shareProvider"),$i.registerShareProvider(wt(ge),ve)}},Qn={get rootPath(){return Tt.report("workspace.rootPath",Ue,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),$t.getPath()},set rootPath(ge){throw new R.$9("rootPath")},getWorkspaceFolder(ge){return $t.getWorkspaceFolder(ge)},get workspaceFolders(){return $t.getWorkspaceFolders()},get name(){return $t.name},set name(ge){throw new R.$9("name")},get workspaceFile(){return $t.workspaceFile},set workspaceFile(ge){throw new R.$9("workspaceFile")},updateWorkspaceFolders:(ge,ve,...Be)=>$t.updateWorkspaceFolders(Ue,ge,ve||0,...Be),onDidChangeWorkspaceFolders:function(ge,ve,Be){return ct($t.onDidChangeWorkspace)(ge,ve,Be)},asRelativePath:(ge,ve)=>$t.getRelativePath(ge,ve),findFiles:(ge,ve,Be,ut)=>$t.findFiles(ge,ve,Be,Ue.identifier,ut),findFiles2:(ge,ve,Be)=>((0,tt.$dG)(Ue,"findFiles2"),$t.findFiles2(ge,ve,Ue.identifier,Be)),findTextInFiles:(ge,ve,Be,ut)=>{(0,tt.$dG)(Ue,"findTextInFiles");let kt,jt;return typeof ve=="object"?(kt=ve,jt=Be):(kt={},jt=ve,ut=Be),$t.findTextInFiles(ge,kt||{},jt,Ue.identifier,ut)},save:ge=>$t.save(ge),saveAs:ge=>$t.saveAs(ge),saveAll:ge=>$t.saveAll(ge),applyEdit(ge,ve){return vi.applyWorkspaceEdit(ge,Ue,ve)},createFileSystemWatcher:(ge,ve,Be,ut)=>{let kt;return typeof ve=="boolean"?kt={ignoreCreateEvents:!!ve,ignoreChangeEvents:!!Be,ignoreDeleteEvents:!!ut,correlate:!1}:ve&&((0,tt.$dG)(Ue,"createFileSystemWatcher"),kt={...ve,correlate:!0}),gn.createFileSystemWatcher($t,Ue,ge,kt)},get textDocuments(){return Fe.getAllDocumentData().map(ge=>ge.document)},set textDocuments(ge){throw new R.$9("textDocuments")},openTextDocument(ge){let ve;const Be=ge;if(typeof ge=="string")ve=Promise.resolve($.URI.file(ge));else if($.URI.isUri(ge))ve=Promise.resolve(ge);else if(!Be||typeof Be=="object")ve=Fe.createDocumentData(Be);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ve.then(ut=>(ut.scheme===O.Schemas.vscodeRemote&&!ut.authority&&Tt.report("workspace.openTextDocument",Ue,"A URI of 'vscode-remote' scheme requires an authority."),Fe.ensureDocumentData(ut).then(kt=>kt.document)))},onDidOpenTextDocument:(ge,ve,Be)=>ct(Fe.onDidAddDocument)(ge,ve,Be),onDidCloseTextDocument:(ge,ve,Be)=>ct(Fe.onDidRemoveDocument)(ge,ve,Be),onDidChangeTextDocument:(ge,ve,Be)=>ct(Fe.onDidChangeDocument)(ge,ve,Be),onDidSaveTextDocument:(ge,ve,Be)=>ct(Fe.onDidSaveDocument)(ge,ve,Be),onWillSaveTextDocument:(ge,ve,Be)=>ct(ne.getOnWillSaveTextDocumentEvent(Ue))(ge,ve,Be),get notebookDocuments(){return Oe.notebookDocuments.map(ge=>ge.apiNotebook)},async openNotebookDocument(ge,ve){let Be;if($.URI.isUri(ge))Be=ge,await Oe.openNotebookDocument(ge);else if(typeof ge=="string")Be=$.URI.revive(await Oe.createNotebookDocument({viewType:ge,content:ve}));else throw new Error("Invalid arguments");return Oe.getNotebookDocument(Be).apiNotebook},onDidSaveNotebookDocument(ge,ve,Be){return ct(Ge.onDidSaveNotebookDocument)(ge,ve,Be)},onDidChangeNotebookDocument(ge,ve,Be){return ct(Ge.onDidChangeNotebookDocument)(ge,ve,Be)},onWillSaveNotebookDocument(ge,ve,Be){return ct(St.getOnWillSaveNotebookDocumentEvent(Ue))(ge,ve,Be)},get onDidOpenNotebookDocument(){return ct(Oe.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return ct(Oe.onDidCloseNotebookDocument)},registerNotebookSerializer(ge,ve,Be,ut){return Oe.registerNotebookSerializer(Ue,ge,ve,Be,(0,tt.$cG)(Ue,"notebookLiveShare")?ut:void 0)},onDidChangeConfiguration:(ge,ve,Be)=>ct(Jn.onDidChangeConfiguration)(ge,ve,Be),getConfiguration(ge,ve){return ve=arguments.length===1?void 0:ve,Jn.getConfiguration(ge,ve,Ue)},registerTextDocumentContentProvider(ge,ve){return ke.registerTextDocumentContentProvider(ge,ve)},registerTaskProvider:(ge,ve)=>(Tt.report("window.registerTaskProvider",Ue,"Use the corresponding function on the 'tasks' namespace instead"),Jt.registerTaskProvider(Ue,ge,ve)),registerFileSystemProvider(ge,ve,Be){return(0,M.$Rc)(Tn.registerFileSystemProvider(Ue,ge,ve,Be),Bt.addFileSystemProvider(ge,ve,Be))},get fs(){return Bt.value},registerFileSearchProvider:(ge,ve)=>((0,tt.$dG)(Ue,"fileSearchProvider"),ln.registerFileSearchProvider(ge,ve)),registerTextSearchProvider:(ge,ve)=>((0,tt.$dG)(Ue,"textSearchProvider"),ln.registerTextSearchProvider(ge,ve)),registerAITextSearchProvider:(ge,ve)=>((0,tt.$dG)(Ue,"aiTextSearchProvider"),(0,tt.$dG)(Ue,"textSearchProvider"),ln.registerAITextSearchProvider(ge,ve)),registerRemoteAuthorityResolver:(ge,ve)=>((0,tt.$dG)(Ue,"resolvers"),Vt.registerRemoteAuthorityResolver(ge,ve)),registerResourceLabelFormatter:ge=>((0,tt.$dG)(Ue,"resolvers"),Bn.$registerResourceLabelFormatter(ge)),getRemoteExecServer:ge=>((0,tt.$dG)(Ue,"resolvers"),Vt.getRemoteExecServer(ge)),onDidCreateFiles:(ge,ve,Be)=>ct(gn.onDidCreateFile)(ge,ve,Be),onDidDeleteFiles:(ge,ve,Be)=>ct(gn.onDidDeleteFile)(ge,ve,Be),onDidRenameFiles:(ge,ve,Be)=>ct(gn.onDidRenameFile)(ge,ve,Be),onWillCreateFiles:(ge,ve,Be)=>ct(gn.getOnWillCreateFileEvent(Ue))(ge,ve,Be),onWillDeleteFiles:(ge,ve,Be)=>ct(gn.getOnWillDeleteFileEvent(Ue))(ge,ve,Be),onWillRenameFiles:(ge,ve,Be)=>ct(gn.getOnWillRenameFileEvent(Ue))(ge,ve,Be),openTunnel:ge=>((0,tt.$dG)(Ue,"tunnels"),Ut.openTunnel(Ue,ge).then(ve=>{if(!ve)throw new Error("cannot open tunnel");return ve})),get tunnels(){return(0,tt.$dG)(Ue,"tunnels"),Ut.getTunnels()},onDidChangeTunnels:(ge,ve,Be)=>((0,tt.$dG)(Ue,"tunnels"),ct(Ut.onDidChangeTunnels)(ge,ve,Be)),registerPortAttributesProvider:(ge,ve)=>((0,tt.$dG)(Ue,"portsAttributes"),Ut.registerPortsAttributesProvider(ge,ve)),registerTunnelProvider:(ge,ve)=>((0,tt.$dG)(Ue,"tunnelFactory"),Ut.registerTunnelProvider(ge,ve)),registerTimelineProvider:(ge,ve)=>((0,tt.$dG)(Ue,"timeline"),Un.registerTimelineProvider(ge,ve,Ue.identifier,Et.converter)),get isTrusted(){return $t.trusted},requestWorkspaceTrust:ge=>((0,tt.$dG)(Ue,"workspaceTrust"),$t.requestWorkspaceTrust(ge)),onDidGrantWorkspaceTrust:(ge,ve,Be)=>ct($t.onDidGrantWorkspaceTrust)(ge,ve,Be),registerEditSessionIdentityProvider:(ge,ve)=>((0,tt.$dG)(Ue,"editSessionIdentityProvider"),$t.registerEditSessionIdentityProvider(ge,ve)),onWillCreateEditSessionIdentity:(ge,ve,Be)=>((0,tt.$dG)(Ue,"editSessionIdentityProvider"),ct($t.getOnWillCreateEditSessionIdentityEvent(Ue))(ge,ve,Be)),registerCanonicalUriProvider:(ge,ve)=>((0,tt.$dG)(Ue,"canonicalUriProvider"),$t.registerCanonicalUriProvider(ge,ve)),getCanonicalUri:(ge,ve,Be)=>((0,tt.$dG)(Ue,"canonicalUriProvider"),$t.provideCanonicalUri(ge,ve,Be))},ai={get inputBox(){return Tt.report("scm.inputBox",Ue,"Use 'SourceControl.inputBox' instead"),Mn.getLastInputBox(Ue)},createSourceControl(ge,ve,Be){return Mn.createSourceControl(Ue,ge,ve,Be)}},ki={createCommentController(ge,ve){return Fn.createCommentController(Ue,ge,ve)}},ci={get activeDebugSession(){return Ct.activeDebugSession},get activeDebugConsole(){return Ct.activeDebugConsole},get breakpoints(){return Ct.breakpoints},get activeStackItem(){if((0,tt.$cG)(Ue,"debugFocus"))return Ct.activeStackItem},registerDebugVisualizationProvider(ge,ve){return(0,tt.$dG)(Ue,"debugVisualization"),Ct.registerDebugVisualizationProvider(Ue,ge,ve)},registerDebugVisualizationTreeProvider(ge,ve){return(0,tt.$dG)(Ue,"debugVisualization"),Ct.registerDebugVisualizationTree(Ue,ge,ve)},onDidStartDebugSession(ge,ve,Be){return ct(Ct.onDidStartDebugSession)(ge,ve,Be)},onDidTerminateDebugSession(ge,ve,Be){return ct(Ct.onDidTerminateDebugSession)(ge,ve,Be)},onDidChangeActiveDebugSession(ge,ve,Be){return ct(Ct.onDidChangeActiveDebugSession)(ge,ve,Be)},onDidReceiveDebugSessionCustomEvent(ge,ve,Be){return ct(Ct.onDidReceiveDebugSessionCustomEvent)(ge,ve,Be)},onDidChangeBreakpoints(ge,ve,Be){return ct(Ct.onDidChangeBreakpoints)(ge,ve,Be)},onDidChangeActiveStackItem(ge,ve,Be){return(0,tt.$dG)(Ue,"debugFocus"),ct(Ct.onDidChangeActiveStackItem)(ge,ve,Be)},registerDebugConfigurationProvider(ge,ve,Be){return Ct.registerDebugConfigurationProvider(ge,ve,Be||_t.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ge,ve){return Ct.registerDebugAdapterDescriptorFactory(Ue,ge,ve)},registerDebugAdapterTrackerFactory(ge,ve){return Ct.registerDebugAdapterTrackerFactory(ge,ve)},startDebugging(ge,ve,Be){return!Be||typeof Be=="object"&&"configuration"in Be?Ct.startDebugging(ge,ve,{parentSession:Be}):Ct.startDebugging(ge,ve,Be||{})},stopDebugging(ge){return Ct.stopDebugging(ge)},addBreakpoints(ge){return Ct.addBreakpoints(ge)},removeBreakpoints(ge){return Ct.removeBreakpoints(ge)},asDebugSourceUri(ge,ve){return Ct.asDebugSourceUri(ge,ve)}},ui={registerTaskProvider:(ge,ve)=>Jt.registerTaskProvider(Ue,ge,ve),fetchTasks:ge=>Jt.fetchTasks(ge),executeTask:ge=>Jt.executeTask(Ue,ge),get taskExecutions(){return Jt.taskExecutions},onDidStartTask:(ge,ve,Be)=>ct(Jt.onDidStartTask)(ge,ve,Be),onDidEndTask:(ge,ve,Be)=>ct(Jt.onDidEndTask)(ge,ve,Be),onDidStartTaskProcess:(ge,ve,Be)=>ct(Jt.onDidStartTaskProcess)(ge,ve,Be),onDidEndTaskProcess:(ge,ve,Be)=>ct(Jt.onDidEndTaskProcess)(ge,ve,Be)},Ei={createNotebookController(ge,ve,Be,ut,kt){return Ye.createNotebookController(Ue,ge,ve,Be,ut,(0,tt.$cG)(Ue,"notebookMessaging")?kt:void 0)},registerNotebookCellStatusBarItemProvider:(ge,ve)=>Oe.registerNotebookCellStatusBarItemProvider(Ue,ge,ve),createRendererMessaging(ge){return dt.createRendererMessaging(Ue,ge)},createNotebookControllerDetectionTask(ge){return(0,tt.$dG)(Ue,"notebookKernelSource"),Ye.createNotebookControllerDetectionTask(Ue,ge)},registerKernelSourceActionProvider(ge,ve){return(0,tt.$dG)(Ue,"notebookKernelSource"),Ye.registerKernelSourceActionProvider(Ue,ge,ve)},onDidChangeNotebookCellExecutionState(ge,ve,Be){return(0,tt.$dG)(Ue,"notebookCellExecutionState"),ct(Ye.onDidChangeNotebookCellExecutionState)(ge,ve,Be)}},Ci={t(...ge){if(typeof ge[0]=="string"){const ve=ge.shift(),Be=!ge||typeof ge[0]!="object"?ge:ge[0];return wn.getMessage(Ue.identifier.value,{message:ve,args:Be})}return wn.getMessage(Ue.identifier.value,ge[0])},get bundle(){return wn.getBundle(Ue.identifier.value)},get uri(){return wn.getBundleUri(Ue.identifier.value)}},li={_version:1,registerInteractiveEditorSessionProvider(ge,ve){return(0,tt.$dG)(Ue,"interactive"),ei.registerProvider(Ue,ge,ve)},registerInteractiveSessionProvider(ge,ve){return(0,tt.$dG)(Ue,"interactive"),qn.registerChatProvider(Ue,ge,ve)},transferChatSession(ge,ve){return(0,tt.$dG)(Ue,"interactive"),qn.transferChatSession(ge,ve)}},Xn={getRelatedInformation(ge,ve){return(0,tt.$dG)(Ue,"aiRelatedInformation"),Hn.getRelatedInformation(Ue,ge,ve)},registerRelatedInformationProvider(ge,ve){return(0,tt.$dG)(Ue,"aiRelatedInformation"),Hn.registerRelatedInformationProvider(Ue,ge,ve)},registerEmbeddingVectorProvider(ge,ve){return(0,tt.$dG)(Ue,"aiRelatedInformation"),bi.registerEmbeddingVectorProvider(Ue,ge,ve)}},hi={registerChatResponseProvider(ge,ve,Be){return(0,tt.$dG)(Ue,"chatProvider"),Ft.registerLanguageModel(Ue,ge,ve,Be)},registerChatVariableResolver(ge,ve,Be){return(0,tt.$dG)(Ue,"chatVariableResolver"),ti.registerVariableResolver(Ue,ge,ve,Be)},registerMappedEditsProvider(ge,ve){return(0,tt.$dG)(Ue,"mappedEditsProvider"),mt.registerMappedEditsProvider(Ue,ge,ve)},createChatParticipant(ge,ve){return(0,tt.$dG)(Ue,"chatParticipant"),Vn.createChatAgent(Ue,ge,ve)},createDynamicChatParticipant(ge,ve,Be,ut){return(0,tt.$dG)(Ue,"chatParticipantAdditions"),Vn.createDynamicChatAgent(Ue,ge,ve,Be,ut)}},di={get languageModels(){return(0,tt.$dG)(Ue,"languageModels"),Ft.getLanguageModelIds()},onDidChangeLanguageModels:(ge,ve,Be)=>((0,tt.$dG)(Ue,"languageModels"),Ft.onDidChangeProviders(ge,ve,Be)),sendChatRequest(ge,ve,Be,ut){return(0,tt.$dG)(Ue,"languageModels"),Ft.sendChatRequest(Ue,ge,ve,Be,ut)}},fi={registerSpeechProvider(ge,ve){return(0,tt.$dG)(Ue,"speech"),Gn.registerProvider(Ue.identifier,ge,ve)}};return{version:bt.version,ai:Xn,authentication:ri,commands:pn,comments:ki,chat:hi,debug:ci,env:Pn,extensions:Nn,interactive:li,l10n:Ci,languages:si,lm:di,notebooks:Ei,scm:ai,speech:fi,tasks:ui,tests:yi,window:oi,workspace:Qn,Breakpoint:Ne.$uN,TerminalOutputAnchor:Ne.TerminalOutputAnchor,ChatResultFeedbackKind:Ne.ChatResultFeedbackKind,ChatVariableLevel:Ne.ChatVariableLevel,ChatCompletionItem:Ne.$pO,CallHierarchyIncomingCall:Ne.$SM,CallHierarchyItem:Ne.$RM,CallHierarchyOutgoingCall:Ne.$TM,CancellationError:R.$5,CancellationTokenSource:o.$ee,CandidatePortSource:n.CandidatePortSource,CodeAction:Ne.$OM,CodeActionKind:Ne.$PM,CodeActionTriggerKind:Ne.CodeActionTriggerKind,CodeLens:Ne.$UM,Color:Ne.$8M,ColorInformation:Ne.$9M,ColorPresentation:Ne.$0M,ColorThemeKind:Ne.ColorThemeKind,CommentMode:Ne.CommentMode,CommentState:Ne.CommentState,CommentThreadCollapsibleState:Ne.CommentThreadCollapsibleState,CommentThreadState:Ne.CommentThreadState,CommentThreadApplicability:Ne.CommentThreadApplicability,CompletionItem:Ne.$2M,CompletionItemKind:Ne.CompletionItemKind,CompletionItemTag:Ne.CompletionItemTag,CompletionList:Ne.$3M,CompletionTriggerKind:Ne.CompletionTriggerKind,ConfigurationTarget:Ne.ConfigurationTarget,CustomExecution:Ne.$fN,DebugAdapterExecutable:Ne.$yN,DebugAdapterInlineImplementation:Ne.$BN,DebugAdapterNamedPipeServer:Ne.$AN,DebugAdapterServer:Ne.$zN,DebugConfigurationProviderTriggerKind:_t.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Ne.DebugConsoleMode,DebugVisualization:Ne.$RN,DecorationRangeBehavior:Ne.DecorationRangeBehavior,Diagnostic:Ne.$IM,DiagnosticRelatedInformation:Ne.$HM,DiagnosticSeverity:Ne.DiagnosticSeverity,DiagnosticTag:Ne.DiagnosticTag,Disposable:Ne.$uM,DocumentHighlight:Ne.$KM,DocumentHighlightKind:Ne.DocumentHighlightKind,MultiDocumentHighlight:Ne.$LM,DocumentLink:Ne.$7M,DocumentSymbol:Ne.$NM,EndOfLine:Ne.EndOfLine,EnvironmentVariableMutatorType:Ne.EnvironmentVariableMutatorType,EvaluatableExpression:Ne.$EN,InlineValueText:Ne.$FN,InlineValueVariableLookup:Ne.$GN,InlineValueEvaluatableExpression:Ne.$HN,InlineCompletionTriggerKind:Ne.InlineCompletionTriggerKind,EventEmitter:I.$7d,ExtensionKind:Ne.ExtensionKind,ExtensionMode:Ne.ExtensionMode,ExternalUriOpenerPriority:Ne.ExternalUriOpenerPriority,FileChangeType:Ne.FileChangeType,FileDecoration:Ne.$TN,FileDecoration2:Ne.$TN,FileSystemError:Ne.$KN,FileType:y.FileType,FilePermission:y.FilePermission,FoldingRange:Ne.$LN,FoldingRangeKind:Ne.FoldingRangeKind,FunctionBreakpoint:Ne.$wN,InlineCompletionItem:Ne.$4M,InlineCompletionList:Ne.$5M,Hover:Ne.$JM,IndentAction:P.IndentAction,Location:Ne.$GM,MarkdownString:Ne.$VM,OverviewRulerLane:b.OverviewRulerLane,ParameterInformation:Ne.$WM,PortAutoForwardAction:Ne.PortAutoForwardAction,Position:Ne.$vM,ProcessExecution:Ne.$dN,ProgressLocation:Ne.ProgressLocation,QuickInputButtons:Ne.$SN,Range:Ne.$wM,RelativePattern:Ne.$sN,Selection:Ne.$xM,SelectionRange:Ne.$QM,SemanticTokens:Ne.$ON,SemanticTokensBuilder:Ne.$NN,SemanticTokensEdit:Ne.$PN,SemanticTokensEdits:Ne.$QN,SemanticTokensLegend:Ne.$MN,ShellExecution:Ne.$eN,ShellQuoting:Ne.ShellQuoting,SignatureHelp:Ne.$YM,SignatureHelpTriggerKind:Ne.SignatureHelpTriggerKind,SignatureInformation:Ne.$XM,SnippetString:Ne.$FM,SourceBreakpoint:Ne.$vN,StandardTokenType:Ne.StandardTokenType,StatusBarAlignment:Ne.StatusBarAlignment,SymbolInformation:Ne.$MM,SymbolKind:Ne.SymbolKind,SymbolTag:Ne.SymbolTag,Task:Ne.$gN,TaskGroup:Ne.$cN,TaskPanelKind:Ne.TaskPanelKind,TaskRevealKind:Ne.TaskRevealKind,TaskScope:Ne.TaskScope,TerminalLink:Ne.$$M,TerminalQuickFixTerminalCommand:Ne.$aN,TerminalQuickFixOpener:Ne.$_M,TerminalLocation:Ne.TerminalLocation,TerminalProfile:Ne.$bN,TerminalExitReason:Ne.TerminalExitReason,TextDocumentSaveReason:Ne.TextDocumentSaveReason,TextEdit:Ne.$BM,SnippetTextEdit:Ne.$DM,TextEditorCursorStyle:w.TextEditorCursorStyle,TextEditorLineNumbersStyle:Ne.TextEditorLineNumbersStyle,TextEditorRevealType:Ne.TextEditorRevealType,TextEditorSelectionChangeKind:Ne.TextEditorSelectionChangeKind,SyntaxTokenType:Ne.SyntaxTokenType,TextDocumentChangeReason:Ne.TextDocumentChangeReason,ThemeColor:Ne.$rN,ThemeIcon:Ne.$qN,TreeItem:Ne.$hN,TreeItemCheckboxState:Ne.TreeItemCheckboxState,TreeItemCollapsibleState:Ne.TreeItemCollapsibleState,TypeHierarchyItem:Ne.$dO,UIKind:dn.UIKind,Uri:$.URI,ViewColumn:Ne.ViewColumn,WorkspaceEdit:Ne.$EM,DocumentPasteTriggerKind:Ne.DocumentPasteTriggerKind,DocumentDropEdit:Ne.$nN,DocumentPasteEditKind:Ne.$oN,DocumentPasteEdit:Ne.$pN,InlayHint:Ne.$1M,InlayHintLabelPart:Ne.$ZM,InlayHintKind:Ne.InlayHintKind,RemoteAuthorityResolverError:Ne.$AM,ResolvedAuthority:Ne.$yM,ManagedResolvedAuthority:Ne.$zM,SourceControlInputBoxValidationType:Ne.SourceControlInputBoxValidationType,ExtensionRuntime:Ne.ExtensionRuntime,TimelineItem:Ne.$4N,NotebookRange:Ne.$VN,NotebookCellKind:Ne.NotebookCellKind,NotebookCellExecutionState:Ne.NotebookCellExecutionState,NotebookCellData:Ne.$WN,NotebookData:Ne.$XN,NotebookRendererScript:Ne.$2N,NotebookCellStatusBarAlignment:Ne.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Ne.NotebookEditorRevealType,NotebookCellOutput:Ne.$ZN,NotebookCellOutputItem:Ne.$YN,NotebookCellStatusBarItem:Ne.$1N,NotebookControllerAffinity:Ne.NotebookControllerAffinity,NotebookControllerAffinity2:Ne.NotebookControllerAffinity2,NotebookEdit:Ne.$CM,NotebookKernelSourceAction:Ne.$3N,NotebookVariablesRequestKind:Ne.NotebookVariablesRequestKind,PortAttributes:Ne.$6N,LinkedEditingRanges:Ne.$5N,TestResultState:Ne.TestResultState,TestRunRequest:Ne.$7N,TestMessage:Ne.$8N,TestTag:Ne.$9N,TestRunProfileKind:Ne.TestRunProfileKind,TextSearchCompleteMessageType:on.TextSearchCompleteMessageType,DataTransfer:Ne.$mN,DataTransferItem:Ne.$iN,TestCoverageCount:Ne.$0N,FileCoverage:Ne.$_N,StatementCoverage:Ne.$aO,BranchCoverage:Ne.$bO,DeclarationCoverage:Ne.$cO,FunctionCoverage:Ne.$cO,WorkspaceTrustState:Ne.WorkspaceTrustState,LanguageStatusSeverity:Ne.LanguageStatusSeverity,QuickPickItemKind:Ne.QuickPickItemKind,InputBoxValidationSeverity:Ne.InputBoxValidationSeverity,TabInputText:Ne.$eO,TabInputTextDiff:Ne.$fO,TabInputTextMerge:Ne.$gO,TabInputCustom:Ne.$hO,TabInputNotebook:Ne.$jO,TabInputNotebookDiff:Ne.$kO,TabInputWebview:Ne.$iO,TabInputTerminal:Ne.$lO,TabInputInteractiveWindow:Ne.$mO,TabInputChat:Ne.$nO,TabInputTextMultiDiff:Ne.$oO,TelemetryTrustedValue:l.$5o,LogLevel:a.LogLevel,EditSessionIdentityMatch:i.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Ne.InteractiveSessionVoteDirection,ChatCopyKind:Ne.ChatCopyKind,InteractiveEditorResponseFeedbackKind:Ne.InteractiveEditorResponseFeedbackKind,StackFrame:Ne.$CN,Thread:Ne.$DN,RelatedInformationType:Ne.RelatedInformationType,SpeechToTextStatus:Ne.SpeechToTextStatus,PartialAcceptTriggerKind:Ne.PartialAcceptTriggerKind,KeywordRecognitionStatus:Ne.KeywordRecognitionStatus,ChatResponseMarkdownPart:Ne.$qO,ChatResponseFileTreePart:Ne.$rO,ChatResponseAnchorPart:Ne.$sO,ChatResponseProgressPart:Ne.$tO,ChatResponseReferencePart:Ne.$vO,ChatResponseCommandButtonPart:Ne.$uO,ChatRequestTurn:Ne.$wO,ChatResponseTurn:Ne.$xO,ChatLocation:Ne.ChatLocation,LanguageModelChatSystemMessage:Ne.$yO,LanguageModelChatUserMessage:Ne.$zO,LanguageModelChatAssistantMessage:Ne.$AO,LanguageModelSystemMessage:Ne.$yO,LanguageModelUserMessage:Ne.$zO,LanguageModelAssistantMessage:Ne.$AO,LanguageModelError:Ne.$BO,NewSymbolName:Ne.$JN,NewSymbolNameTag:Ne.NewSymbolNameTag,InlineEdit:Ne.$CO,InlineEditTriggerKind:Ne.InlineEditTriggerKind}}}}),define(Ee[380],Ce([1,0,84,158,38,152,45,33,72,44,95,96,97,119,70,91,151,69,59,118,90,71,150,12,60,116,117,121,122,156]),function(re,e,o,R,I,M,O,p,$,w,A,P,b,C,y,a,m,l,i,n,r,s,t,g,d,h,c,u,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,o.$hs)(h.$vkc,h.$ukc,1),(0,o.$hs)(g.$Pj,t.$Jlc,1),(0,o.$hs)(a.$zjc,a.$Ajc,1),(0,o.$hs)(p.$$O,p.$0O,0),(0,o.$hs)(u.$Jjc,u.$Kjc,0),(0,o.$hs)(f.$Ojc,f.$Pjc,0),(0,o.$hs)(O.$2jc,O.$Zjc,0),(0,o.$hs)(l.$4jc,l.$3jc,0),(0,o.$hs)(P.$Fkc,P.$Jkc,0),(0,o.$hs)(M.$Lkc,M.$Kkc,0),(0,o.$hs)($.$ZO,$.$YO,0),(0,o.$hs)(c.$wkc,c.$xkc,0),(0,o.$hs)(i.$Djc,i.$Cjc,0),(0,o.$hs)(R.$flc,R.$elc,1),(0,o.$hs)(b.$2kc,b.$3kc,0),(0,o.$hs)(C.$kkc,C.$jkc,0),(0,o.$hs)(A.$slc,A.$rlc,0),(0,o.$hs)(w.$nkc,w.$qkc,0),(0,o.$hs)(E.$Glc,E.$Hlc,0),(0,o.$hs)(y.$kCb,y.$lCb,0),(0,o.$hs)(m.$Flc,m.$Elc,0),(0,o.$hs)(I.$Yjc,I.$Xjc,0),(0,o.$hs)(n.$skc,n.$rkc,0),(0,o.$hs)(r.$9O,r.$6O,0),(0,o.$hs)(s.$bkc,s.$ckc,0),(0,o.$hs)(d.$Dkc,d.$Ekc,0)}),define(Ee[123],Ce([1,0,19,12,36,94]),function(re,e,o,R,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2lc=void 0,e.$Zlc=O,e.$1lc=p;function O(P){return P.startsWith("**")||P.startsWith("/")?P:`/${P}`}function p(P,b,C,y){const a=(0,o.$2b)(C,$),m=new I.$LK(b,a,y),l=m.preview.matches;return{ranges:(0,o.$2b)(a,w),uri:P,preview:{text:m.preview.text,matches:(0,o.$2b)(l,w)}}}function $(P){return new I.$MK(P.start.line,P.start.character,P.end.line,P.end.character)}function w(P){return new M.$AK(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn)}let A=class{constructor(b,C){this.a=b,this.b=C}appendLine(b){this.b.debug(`${this.a}#search`,b)}};e.$2lc=A,e.$2lc=A=Qe([He(1,R.$Oj)],A)}),define(Ee[381],Ce([1,0,51,17,76,34,11,14,123,382]),function(re,e,o,R,I,M,O,p,$,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3lc=P,e.$4lc=m,e.$5lc=i;const A=w.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function P(n,r,s,t){const g=b(n,r,s,t),d=r.folder.fsPath;return{cmd:o.spawn(A,g.args,{cwd:d}),rgDiskPath:A,siblingClauses:g.siblingClauses,rgArgs:g,cwd:d}}function b(n,r,s,t){const g=["--files","--hidden","--case-sensitive","--no-require-git"];y([r],s,!1).forEach(h=>{const c=(0,$.$Zlc)(h);if(g.push("-g",c),O.$d){const u=(0,I.$2l)(c);u!==c&&g.push("-g",u)}});const d=C([r],t,void 0,!1);return d.globArgs.forEach(h=>{const c=`!${(0,$.$Zlc)(h)}`;if(g.push("-g",c),O.$d){const u=(0,I.$2l)(c);u!==c&&g.push("-g",u)}}),r.disregardIgnoreFiles!==!1?g.push("--no-ignore"):r.disregardParentIgnoreFiles!==!1&&g.push("--no-ignore-parent"),r.ignoreSymlinks||g.push("--follow"),n.exists&&g.push("--quiet"),g.push("--no-config"),r.disregardGlobalIgnoreFiles&&g.push("--no-ignore-global"),{args:g,siblingClauses:d.siblingClauses}}function C(n,r,s,t=!0){const g=[];let d={};return n.forEach(h=>{const c=Object.assign({},h.excludePattern||{},r||{}),u=a(c,t?h.folder.fsPath:void 0,s);g.push(...u.globArgs),u.siblingClauses&&(d=Object.assign(d,u.siblingClauses))}),{globArgs:g,siblingClauses:d}}function y(n,r,s=!0){const t=[];return n.forEach(g=>{const d=Object.assign({},r||{},g.includePattern||{}),h=a(d,s?g.folder.fsPath:void 0);t.push(...h.globArgs)}),t}function a(n,r,s){const t=[],g={};return Object.keys(n).forEach(d=>{if(s&&s.has(d)||!d)return;const h=n[d];d=l(r?m(r,d):d),d.startsWith("\\\\")?d="\\\\"+d.substr(2).replace(/\\/g,"/"):d=d.replace(/\\/g,"/"),typeof h=="boolean"&&h?(d.startsWith("\\\\")&&(d+="**"),t.push(i(d))):h&&h.when&&(g[d]=h)}),{globArgs:t,siblingClauses:g}}function m(n,r){return R.$jc(r)?r:R.$kc(n,r)}function l(n){return n=p.$6e(n,"\\"),p.$6e(n,"/")}function i(n){return M.$eg(n).toLowerCase()==="c:/"?n.replace(/^c:[/\\]/i,"/"):n}}),define(Ee[383],Ce([1,0,51,50,17,384,19,47,35,76,34,11,40,14,18,31,36,381,129]),function(re,e,o,R,I,M,O,p,$,w,A,P,b,C,y,a,m,l,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7lc=e.$6lc=void 0;const n=new Set;process.on("exit",()=>{n.forEach(d=>d())});class r{constructor(h){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=h,this.b=h.filePattern||"",this.d=h.includePattern&&$.$ck(h.includePattern),this.f=h.maxResults||null,this.g=!!h.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=h.shouldGlobMatchFilePattern?null:(0,i.$ir)(this.b).normalizedLowercase),this.u=h.excludePattern&&$.$ck(h.excludePattern),this.t=new Map,h.folderQueries.forEach(c=>{const u=Object.assign({},c.excludePattern||{},this.a.excludePattern||{}),f=c.folder.fsPath;h.folderQueries.map(E=>E.folder.fsPath).filter(E=>E!==f).forEach(E=>{(0,A.$ig)(E,f)&&(u[I.$mc(f,E)]=!0)}),this.t.set(f,new t(u,f))})}cancel(){this.l=!0,n.forEach(h=>h())}walk(h,c,u,f,E){if(this.m=b.$3d.create(!1),this.l)return E(null,this.j);c.forEach(v=>{const D=I.$oc(v.fsPath);this.u&&this.u(v.fsPath,D)||this.J(u,{relativePath:v.fsPath,searchPath:void 0})}),this.r=b.$3d.create(!1),this.w(h,(v,D)=>{this.x(this.y,this,v,u,f,k=>{if(k){const S=(0,p.$6i)(k);console.error(S),this.q.push(S),D(k,void 0)}else D(null,void 0)})},(v,D)=>{this.m.stop();const k=v?O.$Hb(v)[0]:null;E(k,this.j)})}w(h,c,u){const f=new Array(h.length),E=new Array(h.length);let v=!1,D=0;if(h.length===0)return u(null,[]);h.forEach((k,S)=>{c(k,(F,W)=>{if(F?(v=!0,f[S]=null,E[S]=F):(f[S]=W,E[S]=null),++D===h.length)return u(v?E:null,f)})})}x(h,c,...u){try{h.apply(c,u)}catch(f){u[u.length-1](f)}}y(h,c,u,f){const E=h.folder.fsPath,v=P.$d,D=()=>B&&B.kill();n.add(D);let k=L=>{n.delete(D),k=()=>{},f(L)},S="";const F=this.D(),W=(0,l.$3lc)(this.a,h,this.a.includePattern,this.t.get(h.folder.fsPath).expression),B=W.cmd,T=!Object.keys(W.siblingClauses).length,N=W.rgArgs.args.map(L=>L.match(/^-/)?L:`'${L}'`).join(" ");let j=`${W.rgDiskPath} ${N}
 - cwd: ${W.cwd}`;W.rgArgs.siblingClauses&&(j+=`
 - Sibling clauses: ${JSON.stringify(W.rgArgs.siblingClauses)}`),u({message:j}),this.s=0,this.z(B,"utf8",u,(L,z,Q)=>{if(L){k(L);return}if(this.j){k();return}const J=(S+(v?w.$1l(z||""):z)).split(`
`);if(Q){const x=J.length;J[x-1]=J[x-1].trim(),J[x-1]||J.pop()}else S=J.pop()||"";if(J.length&&J[0].indexOf(`
`)!==-1){k(new Error("Splitting up files failed"));return}if(this.s+=J.length,T){for(const x of J)if(this.J(c,{base:E,relativePath:x,searchPath:this.N(h,x)}),this.j){D();break}(Q||this.j)&&k();return}this.G(h,F,E,J,c),Q&&(this.H(F,E,c),k())})}spawnFindCmd(h){const c=this.t.get(h.folder.fsPath),u=c.getBasenameTerms(),f=c.getPathTerms(),E=["-L","."];if(u.length||f.length){E.push("-not","(","(");for(const v of u)E.push("-name",v),E.push("-o");for(const v of f)E.push("-path",v),E.push("-o");E.pop(),E.push(")","-prune",")")}return E.push("-type","f"),o.spawn("find",E,{cwd:h.folder.fsPath})}readStdout(h,c,u){let f="";this.z(h,c,()=>{},(E,v,D)=>{if(E){u(E);return}f+=v,D&&u(null,f)})}z(h,c,u,f){let E=(k,S,F)=>{(k||F)&&(E=()=>{},this.r?.stop()),f(k,S,F)},v=!1;h.stdout?(this.A(h.stdout,c,E),h.stdout.once("data",()=>v=!0)):u({message:"stdout is null"});let D;h.stderr?D=this.B(h.stderr):u({message:"stderr is null"}),h.on("error",k=>{E(k)}),h.on("close",k=>{let S;!v&&(S=this.C(D,c))&&g(S)?E(new Error(`command failed with error code ${k}: ${this.C(D,c)}`)):(this.g&&k===0&&(this.j=!0),E(null,"",!0))})}A(h,c,u){const f=new M.StringDecoder(c);return h.on("data",E=>{u(null,f.write(E))}),f}B(h){const c=[];return h.on("data",u=>{c.push(u)}),c}C(h,c){const u=new M.StringDecoder(c);return h.map(f=>u.write(f)).join("")}D(){const h={rootEntries:[],pathToEntries:Object.create(null)};return h.pathToEntries["."]=h.rootEntries,h}G(h,{pathToEntries:c},u,f,E){f.indexOf(this.b)!==-1&&this.J(E,{base:u,relativePath:this.b,searchPath:this.N(h,this.b)});const v=D=>{const k=I.$oc(D),S=I.$nc(D);let F=c[S];F||(F=c[S]=[],v(S)),F.push({base:u,relativePath:D,basename:k,searchPath:this.N(h,D)})};f.forEach(v)}H({rootEntries:h,pathToEntries:c},u,f){const E=this,v=this.t.get(u),D=this.b;function k(S){E.o++;const F=(0,m.$2K)(()=>S.map(W=>W.basename));for(let W=0,B=S.length;W<B;W++){const T=S[W],{relativePath:N,basename:j}=T;if(v.test(N,j,D!==j?F:void 0))continue;const L=c[N];if(L)k(L);else{if(E.p++,N===D)continue;E.J(f,T)}if(E.j)break}}k(h)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(h,c,u,f,E){const v=h.folder,D=(0,m.$2K)(()=>u);this.w(u,(k,S)=>{if(this.l||this.j)return S(null);const F=c?[c,k].join(I.sep):k;if(this.t.get(h.folder.fsPath).test(F,k,this.a.filePattern!==k?D:void 0))return S(null);const W=[v.fsPath,F].join(I.sep);R.lstat(W,(B,T)=>{if(B||this.l||this.j)return S(null);this.L(W,T,(N,j)=>N||this.l||this.j?S(null):j.isDirectory()?(this.o++,this.M(W,T,(L,z)=>L||this.l||this.j||(z=z||"",this.v[z])?S(null):(this.v[z]=!0,a.Promises.readdir(W).then(Q=>{if(this.l||this.j)return S(null);this.I(h,F,Q,f,Y=>S(Y||null))},Q=>{S(null)})))):(this.p++,F===this.b||this.h&&y.$Zf(j.size)&&j.size>this.h||this.J(f,{base:v.fsPath,relativePath:F,searchPath:this.N(h,F)}),S(null,void 0)))})},k=>{const S=k&&O.$Hb(k);return E(S&&S.length>0?S[0]:void 0)})}J(h,c){this.K(c)&&(!this.d||this.d(c.relativePath,I.$oc(c.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||h(c))}K(h){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,m.$WK)(h,this.c);if(this.b)return(0,m.$WK)(h,this.b,!1)}return!0}L(h,c,u){return c.isSymbolicLink()?R.stat(h,u):u(null,c)}M(h,c,u){return c.isSymbolicLink()?R.realpath(h,(f,E)=>f?u(f):u(null,E)):u(null,h)}N(h,c){return h.folderName?I.$kc(h.folderName,c):c}}e.$6lc=r;class s{constructor(h){this.a=h.folderQueries,this.b=h.extraFileResources||[],this.c=new r(h)}search(h,c,u){this.c.walk(this.a,this.b,h,c,(f,E)=>{u(f,{limitHit:E,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$7lc=s;class t{constructor(h,c){this.expression=h,this.c=c,this.d(h)}d(h){let c,u;Object.keys(h).filter(f=>h[f]).forEach(f=>{I.$jc(f)?(c=c||$.$0j(),c[f]=h[f]):(u=u||$.$0j(),u[f]=h[f])}),this.a=c&&$.$ck(c,{trimForExclusions:!0}),this.b=u&&$.$ck(u,{trimForExclusions:!0})}test(h,c,u){return this.b&&this.b(h,c,u)||this.a&&this.a(I.$kc(this.c,h),c,u)}getBasenameTerms(){const h=[];return this.a&&h.push(...$.$ek(this.a)),this.b&&h.push(...$.$ek(this.b)),h}getPathTerms(){const h=[];return this.a&&h.push(...$.$fk(this.a)),this.b&&h.push(...$.$fk(this.b)),h}}function g(d){const h=d.trim().split(`
`),c=h[0].trim();if(c.startsWith("Error parsing regex"))return c;if(c.startsWith("regex parse error"))return C.$Nf(h[h.length-1].trim());if(c.startsWith("error parsing glob")||c.startsWith("unsupported encoding"))return c.charAt(0).toUpperCase()+c.substr(1);if(c==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(c.startsWith("Literal "))return c}}),define(Ee[385],Ce([1,0,100,21,174,22]),function(re,e,o,R,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2D=e.$TD=e.DecodeStreamErrorKind=e.$SD=e.$RD=e.$QD=e.$OD=e.$ND=e.$MD=e.$LD=void 0,e.$PD=O,e.$UD=y,e.$VD=a,e.$WD=m,e.$XD=l,e.$YD=i,e.$ZD=d,e.$1D=h,e.$LD="utf8",e.$MD="utf8bom",e.$ND="utf16be",e.$OD="utf16le";function O(c){return[e.$LD,e.$MD,e.$ND,e.$OD].some(u=>u===c)}e.$QD=[254,255],e.$RD=[255,254],e.$SD=[239,187,191];const p=512,$=512,w=512*8,A=512*128;var P;(function(c){c[c.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(P||(e.DecodeStreamErrorKind=P={}));class b extends Error{constructor(u,f){super(u),this.decodeStreamErrorKind=f}}e.$TD=b;class C{static async create(u){let f;if(u!==e.$LD)f=(await(0,I.$KD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(l(u));else{const E=new TextDecoder;f={write(v){return E.decode(v,{stream:!0})},end(){return E.decode()}}}return new C(f)}constructor(u){this.a=u}write(u){return this.a.write(u)}end(){return this.a.end()}}function y(c,u){const f=u.minBytesRequiredForDetection??u.guessEncoding?w:$;return new Promise((E,v)=>{const D=(0,o.$ie)(T=>T.join("")),k=[];let S=0,F;const W=new M.$ee,B=async()=>{try{const T=await h({buffer:R.$ue.concat(k),bytesRead:S},u.guessEncoding);if(T.seemsBinary&&u.acceptTextOnly)throw new b("Stream is binary but only text is accepted for decoding",1);T.encoding=await u.overwriteEncoding(T.encoding),F=await C.create(T.encoding);const N=F.write(R.$ue.concat(k).buffer);D.write(N),k.length=0,S=0,E({stream:D,detected:T})}catch(T){W.cancel(),D.destroy(),v(T)}};(0,o.$me)(c,{onData:async T=>{F?D.write(F.write(T.buffer)):(k.push(T),S+=T.byteLength,S>=f&&(c.pause(),await B(),setTimeout(()=>c.resume())))},onError:T=>D.error(T),onEnd:async()=>{F||await B(),D.end(F?.end())}},W.token)})}async function a(c,u,f){const v=(await(0,I.$KD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(l(u),f);let D=!1,k=!1;return{read(){if(k)return null;const S=c.read();if(typeof S!="string"){if(k=!0,!D&&f?.addBOM)switch(u){case e.$LD:case e.$MD:return R.$ue.wrap(Uint8Array.from(e.$SD));case e.$ND:return R.$ue.wrap(Uint8Array.from(e.$QD));case e.$OD:return R.$ue.wrap(Uint8Array.from(e.$RD))}const F=v.end();return F&&F.length>0?(D=!0,R.$ue.wrap(F)):null}return D=!0,R.$ue.wrap(v.write(S))}}}async function m(c){return(await(0,I.$KD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(l(c))}function l(c){return c===e.$MD||c===null?e.$LD:c}function i(c,u){if(!c||u<e.$QD.length)return null;const f=c.readUInt8(0),E=c.readUInt8(1);if(f===e.$QD[0]&&E===e.$QD[1])return e.$ND;if(f===e.$RD[0]&&E===e.$RD[1])return e.$OD;if(u<e.$SD.length)return null;const v=c.readUInt8(2);return f===e.$SD[0]&&E===e.$SD[1]&&v===e.$SD[2]?e.$MD:null}const n=["ascii","utf-16","utf-32"];async function r(c){const u=await(0,I.$KD)("jschardet","dist/jschardet.min.js"),f=c.slice(0,A),E=g(f.buffer),v=u.detect(E);if(!v||!v.encoding)return null;const D=v.encoding.toLowerCase();return 0<=n.indexOf(D)?null:t(v.encoding)}const s={ibm866:"cp866",big5:"cp950"};function t(c){const u=c.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return s[u]||u}function g(c){let u="";for(let f=0;f<c.length;f++)u+=String.fromCharCode(c[f]);return u}function d(c){switch(c){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const u=c.match(/windows(\d+)/);return u?"windows-"+u[1]:c}}}function h({buffer:c,bytesRead:u},f){let E=i(c,u),v=!1;if(E!==e.$ND&&E!==e.$OD&&c){let D=!0,k=!0,S=!1;for(let F=0;F<u&&F<p;F++){const W=F%2===1,B=c.readUInt8(F)===0;if(B&&(S=!0),D&&(W&&!B||!W&&B)&&(D=!1),k&&(W&&B||!W&&!B)&&(k=!1),B&&!D&&!k)break}S&&(D?E=e.$OD:k?E=e.$ND:v=!0)}return f&&!v&&!E&&c?r(c.slice(0,u)).then(D=>({seemsBinary:!1,encoding:D})):{seemsBinary:v,encoding:E}}e.$2D={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(Ee[161],Ce([1,0,385,31,160]),function(re,e,o,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cmc=void 0;class M extends I.$Xkc{constructor(p,$,w=R,A="searchProcess"){super({query:p,provider:$},{readdir:P=>w.Promises.readdir(P.fsPath),toCanonicalName:P=>(0,o.$ZD)(P)},A)}}e.$cmc=M}),define(Ee[162],Ce([1,0,51,401,384,19,73,35,14,2,36,94,402,382,123]),function(re,e,o,R,I,M,O,p,$,w,A,P,b,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9lc=e.$8lc=void 0,e.$0lc=t,e.$$lc=d,e.$_lc=c,e.$amc=u,e.$bmc=E;const a=C.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class m{constructor(D){this.a=D}provideTextSearchResults(D,k,S,F){return this.a.appendLine(`provideTextSearchResults ${D.pattern}, ${JSON.stringify({...k,folder:k.folder.toString()})}`),new Promise((W,B)=>{F.onCancellationRequested(()=>J());const T=t(D,k),N=k.folder.fsPath,j=T.map(ye=>ye.match(/^-/)?ye:`'${ye}'`).join(" ");this.a.appendLine(`${a} ${j}
 - cwd: ${N}`);let L=o.spawn(a,T,{cwd:N});L.on("error",ye=>{console.error(ye),this.a.appendLine("Error: "+(ye&&ye.message)),B((0,A.$SK)(new A.$QK(ye&&ye.message,A.SearchErrorCode.rgProcessError)))});let z=!1;const Q=new n(k.maxResults,k.folder,k.previewOptions);Q.on("result",ye=>{z=!0,ce="",S.report(ye)});let Y=!1;const J=()=>{Y=!0,L?.kill(),Q?.cancel()};let x=!1;Q.on("hitLimit",()=>{x=!0,J()});let ce="";L.stdout.on("data",ye=>{Q.handleData(ye),z||(ce+=ye)});let te=!1;L.stdout.once("data",()=>te=!0);let pe="";L.stderr.on("data",ye=>{const _=ye.toString();this.a.appendLine(_),pe.length+_.length<1e6&&(pe+=_)}),L.on("close",()=>{if(this.a.appendLine(te?"Got data from stdout":"No data from stdout"),this.a.appendLine(z?"Got result from parser":"No result from parser"),ce&&this.a.appendLine(`Got data without result: ${ce}`),this.a.appendLine(""),Y)W({limitHit:x});else{Q.flush(),L=null;let ye;pe&&!te&&(ye=l(pe))?B((0,A.$SK)(new A.$QK(ye.message,ye.code))):W({limitHit:x})}})})}}e.$8lc=m;function l(v){const D=v.split(`
`),k=D[0].trim();if(D.some(F=>F.startsWith("regex parse error")))return new A.$QK(i(D),A.SearchErrorCode.regexParseError);const S=k.match(/grep config error: unknown encoding: (.*)/);if(S)return new A.$QK(`Unknown encoding: ${S[1]}`,A.SearchErrorCode.unknownEncoding);if(k.startsWith("error parsing glob"))return new A.$QK(k.charAt(0).toUpperCase()+k.substr(1),A.SearchErrorCode.globParseError);if(k.startsWith("the literal"))return new A.$QK(k.charAt(0).toUpperCase()+k.substr(1),A.SearchErrorCode.invalidLiteral);if(k.startsWith("PCRE2: error compiling pattern"))return new A.$QK(k,A.SearchErrorCode.regexParseError)}function i(v){const D=["Regex parse error"],k=v.filter(S=>S.startsWith("PCRE2:"));if(k.length>=1){const S=k[0].replace("PCRE2:","");if(S.indexOf(":")!==-1&&S.split(":").length>=2){const F=S.split(":")[1];D.push(":"+F)}}return D.join("")}class n extends R.EventEmitter{constructor(D,k,S){super(),this.g=D,this.h=k,this.j=S,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new I.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(D,k){return super.on(D,k),this}handleData(D){if(this.b)return;const k=typeof D=="string"?D:this.d.write(D);this.k(k)}k(D){let k=D.indexOf(`
`);const S=this.a+D;if(k>=0)k+=this.a.length;else{this.a=S;return}let F=0;for(;k>=0;)this.m(S.substring(F,k).trim()),F=k+1,k=S.indexOf(`
`,F);this.a=S.substring(F)}m(D){if(this.b||!D)return;let k;try{k=JSON.parse(D)}catch{throw new Error(`malformed line from rg: ${D}`)}if(k.type==="match"){const S=r(k.data.path),F=w.URI.joinPath(this.h,S),W=this.n(k.data,F);this.p(W),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(k.type==="context"){const S=r(k.data.path),F=w.URI.joinPath(this.h,S);this.o(k.data,F).forEach(B=>this.p(B))}}n(D,k){const S=D.line_number-1,F=r(D.lines),W=Buffer.from(F);let B=0,T=0,N=S;D.submatches.length===0&&D.submatches.push(F.length?{start:0,end:1,match:{text:F[0]}}:{start:0,end:0,match:{text:""}});const j=(0,M.$Hb)(D.submatches.map((L,z)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const Q=r(L.match),Y=W.slice(B,L.start).toString(),J=s(Y),x=J.numLines>0?J.lastLineLength:J.lastLineLength+T,ce=s(Q),te=J.numLines+N,pe=ce.numLines+te,ye=ce.numLines>0?ce.lastLineLength:ce.lastLineLength+x;return B=L.end,T=ye,N=pe,new P.$AK(te,x,pe,ye)}));return(0,y.$1lc)(k,F,j,this.j)}o(D,k){const S=r(D.lines),F=D.line_number;return S.replace(/\r?\n$/,"").split(`
`).map((W,B)=>({text:W,uri:k,lineNumber:F+B}))}p(D){this.emit("result",D)}}e.$9lc=n;function r(v){return v.bytes?Buffer.from(v.bytes,"base64").toString():v.text}function s(v){const D=/\n/g;let k=0,S=-1,F;for(;F=D.exec(v);)k++,S=F.index;const W=S>=0?v.length-S-1:v.length;return{numLines:k,lastLineLength:W}}function t(v,D){const k=["--hidden","--no-require-git"];k.push(v.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:S,otherIncludes:F}=(0,O.$E)(D.includes,B=>B.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(F&&F.length){const B=new Set;F.forEach(T=>{B.add(T)}),k.push("-g","!*"),B.forEach(T=>{g(T).map(y.$Zlc).forEach(N=>{k.push("-g",N)})})}S&&S.length&&S.forEach(B=>{k.push("-g",B)}),D.excludes.map(y.$Zlc).forEach(B=>k.push("-g",`!${B}`)),D.maxFileSize&&k.push("--max-filesize",D.maxFileSize+""),D.useIgnoreFiles?D.useParentIgnoreFiles||k.push("--no-ignore-parent"):k.push("--no-ignore"),D.followSymlinks&&k.push("--follow"),D.encoding&&D.encoding!=="utf8"&&k.push("--encoding",D.encoding),v.pattern==="--"&&(v.isRegExp=!0,v.pattern="\\-\\-"),v.isMultiline&&!v.isRegExp&&(v.pattern=(0,$.$Ze)(v.pattern),v.isRegExp=!0),D.usePCRE2&&k.push("--pcre2"),k.push("--crlf"),v.isRegExp&&(v.pattern=d(v.pattern),k.push("--engine","auto"));let W;if(v.isWordMatch){const T=(0,$.$9e)(v.pattern,!!v.isRegExp,{wholeWord:v.isWordMatch}).source.replace(/\\\//g,"/");k.push("--regexp",T)}else if(v.isRegExp){let B=c(v.pattern);B=u(B),k.push("--regexp",B)}else W=v.pattern,k.push("--fixed-strings");return k.push("--no-config"),D.useGlobalIgnoreFiles||k.push("--no-ignore-global"),k.push("--json"),v.isMultiline&&k.push("--multiline"),D.beforeContext&&k.push("--before-context",D.beforeContext+""),D.afterContext&&k.push("--after-context",D.afterContext+""),k.push("--"),W&&k.push(W),k.push("."),k}function g(v){return E(v).flatMap(k=>{const S=(0,p.$ak)(k,"/");return S.map((F,W)=>S.slice(0,W+1).join("/"))})}function d(v){const D=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;v.match(D);)v=v.replace(D,"$1\\x{$2}");const k=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;v.match(k);)v=v.replace(k,"$1\\x{$2}");return v}const h=v=>v.type==="Assertion"&&v.kind==="lookbehind";function c(v){let D;try{D=new b.RegExpParser().parsePattern(v)}catch{return v}let k="",S=0;const F=(T,N,j)=>{k+=v.slice(S,T)+j,S=N},W=[];return new b.RegExpVisitor({onCharacterEnter(T){if(T.raw!=="\\n")return;const N=W[0];if(!N)F(T.start,T.end,"\\r?\\n");else if(!W.some(h))if(N.type==="CharacterClass")if(N.negate){const j=v.slice(N.start+2,T.start)+v.slice(T.end,N.end-1);N.parent?.type==="Quantifier"?F(N.start,N.end,j?`[^${j}]`:"."):F(N.start,N.end,"(?!\\r?\\n"+(j?`|[${j}]`:"")+")")}else{const j=v.slice(N.start+1,T.start)+v.slice(T.end,N.end-1);F(N.start,N.end,j===""?"\\r?\\n":`(?:[${j}]|\\r?\\n)`)}else N.type==="Quantifier"&&F(T.start,T.end,"(?:\\r?\\n)")},onQuantifierEnter(T){W.unshift(T)},onQuantifierLeave(){W.shift()},onCharacterClassRangeEnter(T){W.unshift(T)},onCharacterClassRangeLeave(){W.shift()},onCharacterClassEnter(T){W.unshift(T)},onCharacterClassLeave(){W.shift()},onAssertionEnter(T){h(T)&&W.push(T)},onAssertionLeave(T){W[0]===T&&W.shift()}}).visit(D),k+=v.slice(S),k}function u(v){return v.replace(/\n/g,"\\r?\\n")}function f(v){let D=!1,k=!1,S="",F="";for(let W=0;W<v.length;W++){const B=v[W];switch(B){case"\\":k?(D?F+="\\"+B:S+="\\"+B,k=!1):k=!0;break;case"{":if(k)D?F+=B:S+=B,k=!1;else{if(D)return{strInBraces:S+"{"+F+"{"+v.substring(W+1)};D=!0}break;case"}":if(k)D?F+=B:S+=B,k=!1;else{if(D)return{fixedStart:S,strInBraces:F,fixedEnd:v.substring(W+1)};S+=B}break;default:D?F+=(k?"\\":"")+B:S+=(k?"\\":"")+B,k=!1;break}}return{strInBraces:S+(D?"{"+F:"")}}function E(v){const{fixedStart:D,strInBraces:k,fixedEnd:S}=f(v);if(D===void 0||S===void 0)return[k];let F=(0,p.$ak)(k,",");F.length||(F=[""]);const W=E(S);return F.flatMap(B=>{const T=D+B;return W.map(N=>T+N)})}}),define(Ee[386],Ce([1,0,22,162,108,15]),function(re,e,o,R,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fmc=void 0;class O{constructor(w){this.b=w,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(w,A,P,b){const C=new R.$8lc(this.b);if(A.folder.scheme===M.Schemas.vscodeUserData){const y={...A,folder:A.folder.with({scheme:M.Schemas.file})},a=new I.$Sv(m=>P.report({...m,uri:m.uri.with({scheme:A.folder.scheme})}));return this.c(b,m=>C.provideTextSearchResults(w,y,a,m))}else return this.c(b,y=>C.provideTextSearchResults(w,A,P,y))}async c(w,A){const P=p(w);this.a.add(P);const b=await A(P.token);return this.a.delete(P),b}d(){this.a.forEach(w=>w.cancel())}}e.$fmc=O;function p($){const w=new o.$ee;return $.onCancellationRequested(()=>w.cancel()),w}}),define(Ee[387],Ce([1,0,31,162,161]),function(re,e,o,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dmc=void 0;class M{constructor($){this.a=$}search($,w,A){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const P={appendLine(C){A({message:C})}},b=new I.$cmc(this.a,new R.$8lc(P),o);return new Promise((C,y)=>b.search(a=>{w(a.map(O))},$).then(a=>C({limitHit:a.limitHit,type:"success",stats:a.stats}),y))}}e.$dmc=M;function O(p){return{path:p.resource&&p.resource.fsPath,results:p.results,numMatches:(p.results||[]).reduce(($,w)=>{if(w.ranges){const A=w;return $+(Array.isArray(A.ranges)?A.ranges.length:1)}else return $+1},0)}}}),define(Ee[388],Ce([1,0,19,8,13,4,129,17,40,2,32,36,383,387]),function(re,e,o,R,I,M,O,p,$,w,A,P,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$emc=void 0;class y{constructor(r="searchProcess"){this.d=r,this.b=Object.create(null)}fileSearch(r){let s;const t=l(r),g=new M.$7d({onDidAddFirstListener:()=>{s=(0,R.$8g)(d=>this.doFileSearchWithEngine(b.$7lc,t,h=>g.fire(h),d)),s.then(d=>g.fire(d),d=>g.fire({type:"error",error:{message:d.message,stack:d.stack}}))},onDidRemoveLastListener:()=>{s.cancel()}});return g.event}textSearch(r){let s;const t=l(r),g=new M.$7d({onDidAddFirstListener:()=>{s=(0,R.$8g)(d=>this.f(t,h=>g.fire(h),d)),s.then(d=>g.fire(d),d=>g.fire({type:"error",error:{message:d.message,stack:d.stack}}))},onDidRemoveLastListener:()=>{s.cancel()}});return g.event}f(r,s,t){return r.maxFileSize=this.g().maxFileSize,new C.$dmc(r).search(t,s,s)}g(){return{maxFileSize:16*A.$kl.GB}}doFileSearch(r,s,t){return this.doFileSearchWithEngine(b.$7lc,r,s,t)}doFileSearchWithEngine(r,s,t,g,d=y.a){let h=0;const c=f=>{Array.isArray(f)?(h+=f.length,t(f.map(E=>this.h(E)))):f.relativePath?(h++,t(this.h(f))):t(f)};if(s.sortByScore){let f=this.l(s,c,g);if(!f){const E=s.maxResults?Object.assign({},s,{maxResults:null}):s,v=new r(E);f=this.j(v,s,t,c,g)}return new Promise((E,v)=>{f.then(([D,k])=>{const S=k.map(F=>this.h(F));this.o(S,t,d),E(D)},v)})}const u=new r(s);return this.r(u,c,d,g).then(f=>({limitHit:f.limitHit,type:"success",stats:{detailStats:f.stats,type:this.d,fromCache:!1,resultCount:h,sortingTime:void 0}}))}h(r){return{path:r.base?(0,p.$kc)(r.base,r.relativePath):r.relativePath}}j(r,s,t,g,d){const h=new M.$7d;let c=(0,R.$8g)(f=>{let E=[];const v=D=>{Array.isArray(D)?E=D:(g(D),h.fire(D))};return this.r(r,v,-1,f).then(D=>[D,E])}),u;if(s.cacheKey){u=this.k(s.cacheKey);const f={promise:c,event:h.event,resolved:!1};u.resultsToSearchCache[s.filePattern||""]=f,c.then(()=>{f.resolved=!0},E=>{delete u.resultsToSearchCache[s.filePattern||""]}),c=this.s(c)}return c.then(([f,E])=>{const v=u?u.scorerCache:Object.create(null),D=(typeof s.maxResults!="number"||s.maxResults>0)&&$.$3d.create(!1);return this.n(s,E,v,d).then(k=>{const S=D?D.elapsed():-1;return[{type:"success",stats:{detailStats:f.stats,sortingTime:S,fromCache:!1,type:this.d,workspaceFolderCount:s.folderQueries.length,resultCount:k.length},messages:f.messages,limitHit:f.limitHit||typeof s.maxResults=="number"&&E.length>s.maxResults},k]})})}k(r){const s=this.b[r];return s||(this.b[r]=new a)}l(r,s,t){const g=r.cacheKey&&this.b[r.cacheKey];if(!g)return;const d=this.q(g,r.filePattern||"",s,t);if(d)return d.then(([h,c,u])=>{const f=$.$3d.create(!1);return this.n(r,c,g.scorerCache,t).then(E=>{const v=f.elapsed(),D={fromCache:!0,detailStats:u,type:this.d,resultCount:c.length,sortingTime:v};return[{type:"success",limitHit:h.limitHit||typeof r.maxResults=="number"&&c.length>r.maxResults,stats:D},E]})})}n(r,s,t,g){const d=(0,O.$ir)(r.filePattern||""),h=(u,f)=>(0,O.$hr)(u,f,d,!0,m,t),c=typeof r.maxResults=="number"?r.maxResults:Number.MAX_VALUE;return o.$Gb(s,h,c,1e4,g)}o(r,s,t){if(t&&t>0)for(let g=0;g<r.length;g+=t)s(r.slice(g,g+t));else s(r)}q(r,s,t,g){const d=$.$3d.create(!1),h=s.indexOf(p.sep)>=0;let c;for(const v in r.resultsToSearchCache)if(s.startsWith(v)){if(h&&v.indexOf(p.sep)<0&&v!=="")continue;const D=r.resultsToSearchCache[v];c={promise:this.s(D.promise),event:D.event,resolved:D.resolved};break}if(!c)return null;const u=d.elapsed(),f=$.$3d.create(!1),E=c.event(t);return g&&g.onCancellationRequested(()=>{E.dispose()}),c.promise.then(([v,D])=>{if(g&&g.isCancellationRequested)throw(0,I.$6)();const k=[],S=(0,O.$ir)(s).normalizedLowercase;for(const F of D)(0,P.$WK)(F,S)&&k.push(F);return[v,k,{cacheWasResolved:c.resolved,cacheLookupTime:u,cacheFilterTime:f.elapsed(),cacheEntryCount:D.length}]})}r(r,s,t,g){return new Promise((d,h)=>{let c=[];g?.onCancellationRequested(()=>r.cancel()),r.search(u=>{u&&(t?(c.push(u),t>0&&c.length>=t&&(s(c),c=[])):s(u))},u=>{s(u)},(u,f)=>{c.length&&s(c),u?(s({message:"Search finished. Error: "+u.message}),h(u)):(s({message:"Search finished. Stats: "+JSON.stringify(f.stats)}),d(f))})})}clearCache(r){return delete this.b[r],Promise.resolve(void 0)}s(r){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(s,t){return r.then(s,t)}catch(s){return this.then(void 0,s)}finally(s){return r.finally(s)}}}}e.$emc=y,y.a=512;class a{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const m=new class{getItemLabel(n){return(0,p.$oc)(n.relativePath)}getItemDescription(n){return(0,p.$nc)(n.relativePath)}getItemPath(n){return n.relativePath}};function l(n){return{...n,folderQueries:n.folderQueries&&n.folderQueries.map(i),extraFileResources:n.extraFileResources&&n.extraFileResources.map(r=>w.URI.revive(r))}}function i(n){return{...n,folder:w.URI.revive(n.folder)}}}),define(Ee[389],Ce([1,0,3,15,2,31,12,28,20,97,66,36,388,386,123,161]),function(re,e,o,R,I,M,O,p,$,w,A,P,b,C,y,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gmc=void 0;let m=class extends w.$3kc{constructor(i,n,r,s){super(i,r,s),this.w=M,this.x=-1,this.y=null,this.z=!1,this.A=new o.$Tc;const t=new y.$2lc("RipgrepSearchUD",this.q);this.A.add(this.registerTextSearchProvider(R.Schemas.vscodeUserData,new C.$fmc(t))),n.remote.isRemote&&n.remote.authority&&this.B()}dispose(){this.A.dispose()}$enableExtensionHostSearch(){this.B()}B(){if(this.z)return;this.z=!0;const i=new y.$2lc("RipgrepSearchEH",this.q);this.A.add(this.registerTextSearchProvider(R.Schemas.file,new C.$fmc(i))),this.A.add(this.C(R.Schemas.file,new b.$emc("fileSearchProvider")))}C(i,n){const r=this.d++;return this.y=n,this.x=r,this.c.$registerFileSearchProvider(r,this.s(i)),(0,o.$Sc)(()=>{this.y=null,this.c.$unregisterProvider(r)})}$provideFileSearchResults(i,n,r,s){const t=(0,w.$4kc)(r);if(i===this.x){const g=Date.now();return this.D(i,n,t,s).then(d=>{const h=Date.now()-g;return this.q.debug(`Ext host file search time: ${h}ms`),d})}return super.$provideFileSearchResults(i,n,r,s)}doInternalFileSearchWithCustomCallback(i,n,r){const s=t=>{if((0,P.$VK)(t)&&(t=[t]),Array.isArray(t)){r(t.map(g=>I.URI.file(g.path)));return}t.message&&this.q.debug("ExtHostSearch",t.message)};if(!this.y)throw new Error("No internal file search handler");return this.y.doFileSearch(i,s,n)}async D(i,n,r,s){return this.doInternalFileSearchWithCustomCallback(r,s,t=>{this.c.$handleFileMatch(i,n,t)})}$clearCache(i){return this.y?.clearCache(i),super.$clearCache(i)}t(i,n){return new a.$cmc(i,n,void 0,"textSearchProvider")}};e.$gmc=m,e.$gmc=m=Qe([He(0,$.$OO),He(1,p.$5O),He(2,A.$Vjc),He(3,O.$Oj)],m)}),define(Ee[124],Ce([1,0,376,63,62,403,21,13,4,3,17,11,30,80,81]),function(re,e,o,R,I,M,O,p,$,w,A,P,b,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ci=e.$_h=e.$$h=e.$0h=void 0,e.$ai=d,e.$bi=h,e.$di=f,e.$ei=E;class a{traceSocketEvent(D,k){y.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,D,k)}constructor(D,k=""){this.f=!0,this.debugLabel=k,this.socket=D,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=S=>{if(this.traceSocketEvent("error",{code:S?.code,message:S?.message}),S){if(S.code==="EPIPE")return;(0,p.$1)(S)}},this.socket.on("error",this.a),this.b=S=>{this.traceSocketEvent("close",{hadError:S}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(D){const k=S=>{this.traceSocketEvent("read",S),D(O.$ue.wrap(S))};return this.socket.on("data",k),{dispose:()=>this.socket.off("data",k)}}onClose(D){const k=S=>{D({type:0,hadError:S,error:void 0})};return this.socket.on("close",k),{dispose:()=>this.socket.off("close",k)}}onEnd(D){const k=()=>{D()};return this.socket.on("end",k),{dispose:()=>this.socket.off("end",k)}}write(D){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",D),this.socket.write(D.buffer,k=>{if(k){if(k.code==="EPIPE")return;(0,p.$1)(k)}})}catch(k){if(k.code==="EPIPE")return;(0,p.$1)(k)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((D,k)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),D();return}const S=()=>{this.socket.off("close",S),this.socket.off("end",S),this.socket.off("error",S),this.socket.off("timeout",S),this.socket.off("drain",S),this.traceSocketEvent("nodeDrainEnd"),D()};this.socket.on("close",S),this.socket.on("end",S),this.socket.on("error",S),this.socket.on("timeout",S),this.socket.on("drain",S)})}}e.$0h=a;var m;(function(v){v[v.MinHeaderByteSize=2]="MinHeaderByteSize",v[v.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(m||(m={}));var l;(function(v){v[v.PeekHeader=1]="PeekHeader",v[v.ReadHeader=2]="ReadHeader",v[v.ReadBody=3]="ReadBody",v[v.Fin=4]="Fin"})(l||(l={}));class i extends w.$Uc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(D,k){this.socket.traceSocketEvent(D,k)}constructor(D,k,S,F){super(),this.f=this.B(new $.$7d),this.g=this.B(new $.$7d),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=D,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:k,inflateBytesLength:S?.byteLength||0,recordInflateBytes:F}),this.a=this.B(new n(this,k,S,F,this.f,(W,B)=>this.m(W,B))),this.B(this.a.onError(W=>{console.error(W),(0,p.$1)(W),this.g.fire({type:0,hadError:!0,error:W})})),this.b=new y.$5h,this.B(this.socket.onData(W=>this.n(W))),this.B(this.socket.onClose(async W=>{this.a.isProcessingReadQueue()&&await $.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(W)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(D){return this.f.event(D)}onClose(D){return this.g.event(D)}onEnd(D){return this.socket.onEnd(D)}write(D){let k=0;for(;k<D.byteLength;)this.a.writeMessage(D.slice(k,Math.min(k+262144,D.byteLength)),{compressed:!0,opcode:2}),k+=262144}m(D,{compressed:k,opcode:S}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",D);let F=2;D.byteLength<126?F+=0:D.byteLength<2**16?F+=2:F+=8;const W=O.$ue.alloc(F),B=k?64:0,T=S&15;if(W.writeUInt8(128|B|T,0),D.byteLength<126)W.writeUInt8(D.byteLength,1);else if(D.byteLength<2**16){W.writeUInt8(126,1);let N=1;W.writeUInt8(D.byteLength>>>8&255,++N),W.writeUInt8(D.byteLength>>>0&255,++N)}else{W.writeUInt8(127,1);let N=1;W.writeUInt8(0,++N),W.writeUInt8(0,++N),W.writeUInt8(0,++N),W.writeUInt8(0,++N),W.writeUInt8(D.byteLength>>>24&255,++N),W.writeUInt8(D.byteLength>>>16&255,++N),W.writeUInt8(D.byteLength>>>8&255,++N),W.writeUInt8(D.byteLength>>>0&255,++N)}this.socket.write(O.$ue.concat([W,D]))}end(){this.h=!0,this.socket.end()}n(D){if(D.byteLength!==0){for(this.b.acceptChunk(D);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const k=this.b.peek(this.j.readLen),S=k.readUInt8(0),F=(S&128)>>>7,W=(S&64)>>>6,B=S&15,T=k.readUInt8(1),N=(T&128)>>>7,j=T&127;this.j.state=2,this.j.readLen=2+(N?4:0)+(j===126?2:0)+(j===127?8:0),this.j.fin=F,this.j.firstFrameOfMessage&&(this.j.compressed=!!W),this.j.firstFrameOfMessage=!!F,this.j.mask=0,this.j.opcode=B,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const k=this.b.read(this.j.readLen),S=k.readUInt8(1),F=(S&128)>>>7;let W=S&127,B=1;W===126?W=k.readUInt8(++B)*2**8+k.readUInt8(++B):W===127&&(W=k.readUInt8(++B)*0+k.readUInt8(++B)*0+k.readUInt8(++B)*0+k.readUInt8(++B)*0+k.readUInt8(++B)*2**24+k.readUInt8(++B)*2**16+k.readUInt8(++B)*2**8+k.readUInt8(++B));let T=0;F&&(T=k.readUInt8(++B)*2**24+k.readUInt8(++B)*2**16+k.readUInt8(++B)*2**8+k.readUInt8(++B)),this.j.state=3,this.j.readLen=W,this.j.mask=T,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const k=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",k),t(k,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",k),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(k,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(k,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await $.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$$h=i;class n extends w.$Uc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:O.$ue.alloc(0)}constructor(D,k,S,F,W,B){super(),this.n=D,this.r=W,this.s=B,this.a=this.B(new $.$7d),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new $.$7d),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new $.$7d),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,k?(this.b=this.B(new r(this.n,F,S,{windowBits:15})),this.f=this.B(new s(this.n,{windowBits:15})),this.B(this.b.onError(T=>this.a.fire(T))),this.B(this.f.onError(T=>this.a.fire(T)))):(this.b=null,this.f=null)}writeMessage(D,k){this.g.push({data:D,options:k}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:D,options:k}=this.g.shift();if(this.f&&k.compressed){const S=await this.w(this.f,D);this.s(S,k)}else this.s(D,{...k,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(D,k){return new Promise((S,F)=>{D.write(k),D.flush(W=>S(W))})}acceptFrame(D,k,S){this.h.push({data:D,isCompressed:k,isLastFrameOfMessage:S}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const D=this.h.shift();if(this.b&&D.isCompressed){const k=await this.C(this.b,D.data,D.isLastFrameOfMessage);this.r.fire(k)}else this.r.fire(D.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(D,k,S){return new Promise((F,W)=>{D.write(k),S&&D.write(O.$ue.fromByteArray([0,0,255,255])),D.flush(B=>F(B))})}}class r extends w.$Uc{get recordedInflateBytes(){return this.j?O.$ue.concat(this.f):O.$ue.alloc(0)}constructor(D,k,S,F){super(),this.h=D,this.j=k,this.a=this.B(new $.$7d),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,M.createInflateRaw)(F),this.b.on("error",W=>{this.h.traceSocketEvent("zlibInflateError",{message:W?.message,code:W?.code}),this.a.fire(W)}),this.b.on("data",W=>{this.h.traceSocketEvent("zlibInflateData",W),this.g.push(O.$ue.wrap(W))}),S&&(this.h.traceSocketEvent("zlibInflateInitialWrite",S.buffer),this.b.write(S.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(D){this.j&&this.f.push(D.clone()),this.h.traceSocketEvent("zlibInflateWrite",D),this.b.write(D.buffer)}flush(D){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const k=O.$ue.concat(this.g);this.g.length=0,D(k)})}}class s extends w.$Uc{constructor(D,k){super(),this.g=D,this.a=this.B(new $.$7d),this.onError=this.a.event,this.f=[],this.b=(0,M.createDeflateRaw)({windowBits:15}),this.b.on("error",S=>{this.g.traceSocketEvent("zlibDeflateError",{message:S?.message,code:S?.code}),this.a.fire(S)}),this.b.on("data",S=>{this.g.traceSocketEvent("zlibDeflateData",S),this.f.push(O.$ue.wrap(S))})}write(D){this.g.traceSocketEvent("zlibDeflateWrite",D.buffer),this.b.write(D.buffer)}flush(D){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let k=O.$ue.concat(this.f);this.f.length=0,k=k.slice(0,k.byteLength-4),D(k)})}}function t(v,D){if(D===0)return;const k=v.byteLength>>>2;for(let N=0;N<k;N++){const j=v.readUInt32BE(N*4);v.writeUInt32BE(j^D,N*4)}const S=k*4,F=v.byteLength-S,W=D>>>24&255,B=D>>>16&255,T=D>>>8&255;F>=1&&v.writeUInt8(v.readUInt8(S)^W,S),F>=2&&v.writeUInt8(v.readUInt8(S+1)^B,S+1),F>=3&&v.writeUInt8(v.readUInt8(S+2)^T,S+2)}e.$_h=process.env.XDG_RUNTIME_DIR;const g={2:107,1:103};function d(){const v=(0,b.$Eg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${v}-sock`;const D=process.platform!=="darwin"&&e.$_h?e.$_h:(0,I.tmpdir)(),k=(0,A.$kc)(D,`vscode-ipc-${v}.sock`);return c(k),k}function h(v,D,k){const F=(0,o.createHash)("sha256").update(v).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${F}-${k}-${D}-sock`;const W=k.substr(0,4),B=D.substr(0,6);let T;return process.platform!=="darwin"&&e.$_h&&!process.env.VSCODE_PORTABLE?T=(0,A.$kc)(e.$_h,`vscode-${F}-${W}-${B}.sock`):T=(0,A.$kc)(v,`${W}-${B}.sock`),c(T),T}function c(v){const D=g[P.$o];typeof D=="number"&&v.length>=D&&console.warn(`WARNING: IPC handle "${v}" is longer than ${D} chars, try a shorter --user-data-dir`)}class u extends C.$Yh{static b(D){const k=$.Event.fromNodeEventEmitter(D,"connection");return $.Event.map(k,S=>({protocol:new y.$6h(new a(S,"ipc-server-connection")),onDidClientDisconnect:$.Event.once($.Event.fromNodeEventEmitter(S,"close"))}))}constructor(D){super(u.b(D)),this.d=D}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$ci=u;function f(v){return new Promise((D,k)=>{const S=(0,R.createServer)();S.on("error",k),S.listen(v,()=>{S.removeListener("error",k),D(new u(S))})})}function E(v,D){return new Promise((k,S)=>{const F=(0,R.createConnection)(v,()=>{F.removeListener("error",S),k(y.$7h.fromSocket(new a(F,`ipc-client${D}`),D))});F.once("error",S)})}}),define(Ee[390],Ce([1,0,63,62,176,124,8,3,11,53,12,140,266,267,110,88,21]),function(re,e,o,R,I,M,O,p,$,w,A,P,b,C,y,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jcc=e.$icc=e.$hcc=e.$gcc=void 0;async function l(t,g,d,h,c){let u;for(let f=3;f&&(u?.dispose(),u=await new i(t,g,d,h,c).waitForReady(),!(c&&I.$Hg[c]||!I.$Hg[u.tunnelLocalPort]));f--);return u}class i extends p.$Uc{constructor(g,d,h,c,u){super(),this.m=d,this.n=u,this.privacy=a.TunnelPrivacyId.Private,this.j=new Map,this.a=g,this.b=o.createServer(),this.c=new O.$hh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=f=>this.r(f),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=c,this.tunnelRemoteHost=h}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(d=>{d()})}async waitForReady(){const g=this.n??this.tunnelRemotePort,d=(0,a.$6v)(this.m)?"0.0.0.0":"127.0.0.1";let h=await(0,I.$Ig)(g,2,1e3,d),c=null;return this.b.listen(h,this.m),await this.c.wait(),c=this.b.address(),c||(h=0,this.b.listen(h,this.m),await this.c.wait(),c=this.b.address()),this.tunnelLocalPort=c.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${c.port}`,this}async r(g){g.pause();const d=(0,a.$4v)(this.tunnelRemoteHost)||(0,a.$6v)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,h=await(0,b.$El)(this.a,d,this.tunnelRemotePort),c=h.getSocket(),u=h.readEntireBuffer();h.dispose(),u.byteLength>0&&g.write(u.buffer),g.on("end",()=>{g.localAddress&&this.j.delete(g.localAddress),c.end()}),g.on("close",()=>c.end()),g.on("error",()=>{g.localAddress&&this.j.delete(g.localAddress),c instanceof M.$0h?c.socket.destroy():c.end()}),c instanceof M.$0h?this.t(g,c):this.s(g,c),g.localAddress&&this.j.set(g.localAddress,()=>{g.end(),c.end()})}s(g,d){d.onClose(()=>g.destroy()),d.onEnd(()=>g.end()),d.onData(h=>g.write(h.buffer)),g.on("data",h=>d.write(m.$ue.wrap(h))),g.resume()}t(g,d){const h=d.socket;h.on("end",()=>g.end()),h.on("close",()=>g.end()),h.on("error",()=>{g.destroy()}),h.pipe(g),g.pipe(h)}}e.$gcc=i;let n=class extends a.$9v{constructor(g,d,h,c,u){super(d,u),this.v=g,this.w=h,this.y=c}isPortPrivileged(g){return(0,a.$7v)(g,this.m,$.OS,R.release())}t(g,d,h,c,u,f,E,v){const D=this.s(d,h);if(D)return++D.refcount,D.value;if((0,a.$Zv)(g))return this.u(g,d,h,u,f,E,v);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${d}:${h} on local port ${u}.`);const k={commit:this.y.commit,quality:this.y.quality,addressProvider:g,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},S=l(k,c,d,h,u);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(d,h,S),S}}};e.$hcc=n,e.$hcc=n=Qe([He(0,C.$yl),He(1,A.$Oj),He(2,y.$Bl),He(3,P.$8j),He(4,w.$Oi)],n);let r=class extends n{constructor(g,d,h,c,u){super(g,d,h,c,u)}};e.$icc=r,e.$icc=r=Qe([He(0,C.$yl),He(1,A.$Oj),He(2,y.$Bl),He(3,P.$8j),He(4,w.$Oi)],r);let s=class extends p.$Uc{constructor(g,d,h,c,u){super(),this.b=g,this.c=d,this.f=h,this.g=c,this.h=u,this.a=new Map}async openTunnel(g,d,h,c,u,f,E,v,D){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${h}:${c} on local port ${f}.`),!this.a.has(g)){const k=new r(this.b,this.c,this.g,this.f,this.h);this.B(k),this.a.set(g,k),k.onTunnelClosed(async()=>{(await k.tunnels).length===0&&(k.dispose(),this.a.delete(g))})}return this.a.get(g).openTunnel(d,h,c,u,f,E,v,D)}};e.$jcc=s,e.$jcc=s=Qe([He(0,C.$yl),He(1,A.$Oj),He(2,P.$8j),He(3,y.$Bl),He(4,w.$Oi)],s)}),define(Ee[391],Ce([1,0,124,112,50,33,2,12,43]),function(re,e,o,R,I,M,O,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eP=e.$dP=void 0;class w{constructor(b,C,y){this.b=b,this.c=C,this.f=y,this.a=R.createServer((a,m)=>this.h(a,m)),this.g().catch(a=>(C.error(a),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",b=>this.c.error(b))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(b,C){const y=(m,l)=>{C.writeHead(m,{"content-type":"application/json"}),C.end(JSON.stringify(l||null),i=>i&&this.c.error(i))},a=[];b.setEncoding("utf8"),b.on("data",m=>a.push(m)),b.on("end",async()=>{try{const m=JSON.parse(a.join(""));let l;switch(m.type){case"open":l=await this.i(m);break;case"openExternal":l=await this.j(m);break;case"status":l=await this.l(m);break;case"extensionManagement":l=await this.k(m);break;default:y(404,`Unknown message type: ${m.type}`);break}y(200,l)}catch(m){const l=m instanceof Error?m.message:JSON.stringify(m);y(500,l),this.c.error("Error while processing pipe request",m)}})}async i(b){const{fileURIs:C,folderURIs:y,forceNewWindow:a,diffMode:m,mergeMode:l,addMode:i,forceReuseWindow:n,gotoLineMode:r,waitMarkerFilePath:s,remoteAuthority:t}=b,g=[];if(Array.isArray(y))for(const u of y)try{g.push({folderUri:O.URI.parse(u)})}catch{}if(Array.isArray(C))for(const u of C)try{(0,$.$Ni)(u)?g.push({workspaceUri:O.URI.parse(u)}):g.push({fileUri:O.URI.parse(u)})}catch{}const d=s?O.URI.file(s):void 0,c={forceNewWindow:a,diffMode:m,mergeMode:l,addMode:i,gotoLineMode:r,forceReuseWindow:n,preferNewWindow:!n&&!d&&!i,waitMarkerFileURI:d,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",g,c)}async j(b){for(const C of b.uris){const y=O.URI.parse(C),a=y.scheme==="file"?y:C;await this.b.executeCommand("_remoteCLI.openExternal",a)}}async k(b){const C=a=>a?.map(m=>/\.vsix$/i.test(m)?O.URI.parse(m):m),y={list:b.list,install:C(b.install),uninstall:C(b.uninstall),force:b.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",y)}async l(b){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&I.existsSync(this.f)&&I.unlinkSync(this.f)}}e.$dP=w;let A=class extends w{constructor(b,C){super(b,C,(0,o.$ai)())}};e.$eP=A,e.$eP=A=Qe([He(0,M.$$O),He(1,p.$Oj)],A)}),define(Ee[392],Ce([1,0,112,58,379,373,285,48,360,2,15,7,391,103,318,38,359]),function(re,e,o,R,I,M,O,p,$,w,A,P,b,C,y,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lmc=void 0;class l extends M.$Mlc{k(){const r=this,s=globalThis._VSCODE_NODE_MODULES.module,t=s._load;s._load=function(c,u,f){return c=d(c),r.a.has(c)?r.a.get(c).load(c,w.URI.file((0,C.$Rq)(u.filename)),E=>t.apply(this,[E,u,f])):t.apply(this,arguments)};const g=s._resolveLookupPaths;s._resolveLookupPaths=(h,c)=>g.call(this,d(h),c);const d=h=>{for(const c of r.b){const u=c(h);if(u){h=u;break}}return h}}}class i extends p.$zkc{constructor(){super(...arguments),this.extensionRuntime=P.ExtensionRuntime.Node}async vb(){this.h.createInstance(y.$jmc);const r=this.h.invokeFunction(I.$Ilc);if(this.h.createInstance($.$imc),this.f.remote.isRemote&&this.f.remote.authority){const g=this.h.createInstance(b.$eP);process.env.VSCODE_IPC_HOOK_CLI=g.ipcHandlePath}this.h.createInstance(m.$kmc),await this.h.createInstance(l,r,{mine:this.J,all:this.L}).install(),R.mark("code/extHost/didInitAPI"),(async()=>{const g=process.env.VSCODE_IPC_HOOK_CLI,d=process.env.CODE_SERVER_SESSION_SOCKET;if(!g||!d)return;const c={workspace:this.h.invokeFunction(f=>f.get(a.$Yjc).workspace),socketPath:g},u=JSON.stringify({entry:c});await new Promise((f,E)=>{const v={path:"/add-session",socketPath:d,method:"POST",headers:{"content-type":"application/json"}},D=o.request(v,k=>{k.on("error",E),k.on("end",()=>{try{k.statusCode===200?f():E(new Error("Unexpected status code: "+k.statusCode))}catch(S){E(S)}})});D.on("error",E),D.write(u),D.end()})})().catch(g=>{this.s.error(g)});const t=await this.m.getConfigProvider();await(0,O.$hmc)(this.j,t,this,this.s,this.z,this.f),R.mark("code/extHost/didInitProxyResolver")}wb(r){return r.main}async xb(r,s,t){if(s.scheme!==A.Schemas.file)throw new Error(`Cannot load URI: '${s}', must be of file-scheme`);let g=null;t.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${s.toString(!0)}`),this.s.flush();const d=r?.identifier.value;r&&await this.w.initializeLocalizedMessages(r);try{d&&R.mark(`code/extHost/willLoadExtensionCode/${d}`),g=re.__$__nodeRequire(s.fsPath)}finally{d&&R.mark(`code/extHost/didLoadExtensionCode/${d}`),t.codeLoadingStop()}return g}async $setRemoteEnvironment(r){if(this.f.remote.isRemote)for(const s in r){const t=r[s];t===null?delete process.env[s]:process.env[s]=t}}}e.$lmc=i}),define(Ee[393],Ce([1,0,51,21,4,3,126,11,23,2,31,12,265,65,110,88,390,28,20,70,367]),function(re,e,o,R,I,M,O,p,$,w,A,P,b,C,y,a,m,l,i,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tmc=void 0,e.$mmc=s,e.$nmc=t,e.$omc=g,e.$pmc=d,e.$qmc=c,e.$rmc=u,e.$smc=f;function s(D){const k=D.trim().split(`
`),S=[];return k.forEach(W=>{const B=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(W);B&&B.length>=3&&S.push({pid:parseInt(B[1],10),socket:parseInt(B[2],10)})}),S.reduce((W,B)=>(W[B.socket]=B,W),{})}function t(...D){const k=[].concat(...D.map(d));return[...new Map(k.filter(S=>S.st==="0A").map(S=>{const F=S.local_address.split(":");return{socket:parseInt(S.inode,10),ip:g(F[0]),port:parseInt(F[1],16)}}).map(S=>[S.ip+":"+S.port,S])).values()]}function g(D){let k="";if(D.length===8)for(let S=D.length-2;S>=0;S-=2)k+=parseInt(D.substr(S,2),16),S!==0&&(k+=".");else for(let S=0;S<D.length;S+=8){const F=D.substring(S,S+8);let W="";for(let B=8;B>=2;B-=2)W+=F.substring(B-2,B),(B===6||B===2)&&(W=parseInt(W,16).toString(16),k+=`${W}`,W="",S+B!==D.length-6&&(k+=":"))}return k}function d(D){const k=D.trim().split(`
`),S=k.shift().trim().split(/\s+/).filter(W=>W!=="rx_queue"&&W!=="tm->when");return k.map(W=>W.trim().split(/\s+/).reduce((B,T,N)=>(B[S[N]||N]=T,B),{}))}function h(D){return!!D.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||D.indexOf("out/server-main.js")!==-1||D.indexOf("_productName=VSCode")!==-1}function c(D){const k=D.trim().split(`
`),S=[];return k.forEach(F=>{const W=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(F);W&&W.length>=4&&S.push({pid:parseInt(W[1],10),ppid:parseInt(W[2]),cmd:W[3]})}),S}async function u(D,k,S){const F=S.reduce((B,T)=>(B[T.pid]=T,B),{}),W=[];return D.forEach(({socket:B,ip:T,port:N})=>{const j=k[B]?k[B].pid:void 0,L=j?F[j]?.cmd:void 0;j&&L&&!h(L)&&W.push({host:T,port:N,detail:L,pid:j})}),W}function f(D,k,S){const F=new Map,W=c(k);for(const B of D){const T=S.get(B.port);if(T){F.set(B.port,T);continue}const N=W.find(j=>j.cmd.includes(`${B.port}`));if(N){let j=N,L;do L=W.find(z=>z.ppid===j.pid),L&&(j=L);while(L);F.set(B.port,{host:B.ip,port:B.port,pid:j.pid,detail:j.cmd,ppid:j.ppid})}else F.set(B.port,{host:B.ip,port:B.port,ppid:Number.MAX_VALUE})}return F}let E=class extends n.$lCb{constructor(k,S,F,W){super(k,S,F),this.D=S,this.F=W,this.y=void 0,this.z=new Map,this.C=!1,p.$e&&S.remote.isRemote&&S.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(k){if(k&&this.C)return;this.C=k;let S;this.y&&(S=this.y,await this.a.$onFoundNewCandidates(this.y));const F=new O.$rm;let W=0;for(;this.C;){const B=new Date().getTime(),T=(await this.I()).filter(L=>(0,a.$4v)(L.host)||(0,a.$6v)(L.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${T.map(L=>L.port).join(", ")}`);const N=new Date().getTime()-B;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${N} ms.`),W++>3&&F.update(N),(!S||JSON.stringify(S)!==JSON.stringify(T))&&(S=T,await this.a.$onFoundNewCandidates(S));const j=this.G(F.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${j} ms.`),await new Promise(L=>setTimeout(()=>L(),j))}}G(k){return Math.max(k*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(k=>k.port).join(", ")}`)}async I(){let k="",S="";try{k=await A.Promises.readFile("/proc/net/tcp","utf8"),S=await A.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const F=t(k,S),W=await new Promise(Y=>{(0,o.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(J,x,ce)=>{Y(x)})}),B=s(W),T=await A.Promises.readdir("/proc"),N=[];for(const Y of T)try{const J=Number(Y),x=$.$Vg(w.URI.file("/proc"),Y);if((await A.Promises.stat(x.fsPath)).isDirectory()&&!isNaN(J)){const te=await A.Promises.readlink($.$Vg(x,"cwd").fsPath),pe=await A.Promises.readFile($.$Vg(x,"cmdline").fsPath,"utf8");N.push({pid:J,cwd:te,cmd:pe})}}catch{}const j=[],L=F.filter(Y=>{const J=B[Y.socket];return J||j.push(Y),J}),z=u(L,B,N);let Q;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${j.length}`),j.length>0){const Y=await new Promise(J=>{(0,o.exec)("ps -F -A -l | grep root",(x,ce,te)=>{J(ce)})});this.z=f(j,Y,this.z),Q=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${Q.map(J=>J.port).join(", ")}`)}return z.then(Y=>Q?Y.concat(Q):Y)}w(k){return async S=>{const F=new m.$gcc({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(B,T,N,j){const L=await k.makeConnection();return v.connect(L,T,N,j)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new C.$ul(0),connectionToken:k.connectionToken})}},signService:this.F},"localhost",S.remoteAddress.host||"localhost",S.remoteAddress.port,S.localAddressPort);await F.waitForReady();const W=new I.$7d;return{localAddress:(0,r.$SL)(F.localAddress)??F.localAddress,remoteAddress:{port:F.tunnelRemotePort,host:F.tunnelRemoteHost},onDidDispose:W.event,dispose:()=>{F.dispose(),W.fire(),W.dispose()}}}}};e.$tmc=E,e.$tmc=E=Qe([He(0,i.$OO),He(1,l.$5O),He(2,P.$Oj),He(3,y.$Bl)],E);class v extends b.$fub{static connect(k,S,F,W){const B=new M.$Tc,T={onClose:B.add(new I.$7d),onData:B.add(new I.$7d),onEnd:B.add(new I.$7d)};B.add(k.onDidReceiveMessage(j=>T.onData.fire(R.$ue.wrap(j)))),B.add(k.onDidEnd(()=>T.onEnd.fire())),B.add(k.onDidClose(j=>T.onClose.fire({type:0,error:j,hadError:!!j})));const N=new v(k,W,T);return N.B(B),(0,b.$eub)(N,S,F,W,T)}constructor(k,S,F){super(S,F),this.n=k}write(k){this.n.send(k.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(Ee[394],Ce([1,0,84,362,377,375,389,392,393,96,48,97,95,44,70,93,361,319,12,378,60,280,106,110,142]),function(re,e,o,R,I,M,O,p,$,w,A,P,b,C,y,a,m,l,i,n,r,s,t,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,o.$hs)(A.$Akc,p.$lmc,0),(0,o.$hs)(i.$Pj,l.$vmc,1),(0,o.$hs)(i.$Oj,new t.$fi(s.$Llc,[!1],!0)),(0,o.$hs)(g.$Bl,d.$lcc,1),(0,o.$hs)(a.$5jc,m.$umc,0),(0,o.$hs)(w.$Fkc,M.$Ylc,0),(0,o.$hs)(P.$2kc,O.$gmc,0),(0,o.$hs)(b.$slc,I.$Qlc,0),(0,o.$hs)(C.$nkc,R.$Plc,0),(0,o.$hs)(y.$kCb,$.$tmc,0),(0,o.$hs)(r.$Dkc,n.$wmc,0)}),define(Ee[404],Ce([1,0,112,63,405,58,13,81,124,263,115,374,21,31,103,8,136,286,301,380,394]),function(re,e,o,R,I,M,O,p,$,w,A,P,b,C,y,a,m,l,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let E=0;E<process.execArgv.length;E++)process.execArgv[E]==="--inspect-port=0"&&(process.execArgv.splice(E,1),E--)}();const n=I(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const f=globalThis._VSCODE_NODE_MODULES.module,E=f._load;f._load=function(v){if(v==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return E.apply(this,arguments)}})();const r=process.exit.bind(process),s=process.on.bind(process);function t(f){process.exit=function(E){if(f)r(E);else{const v=new Error("An extension called process.exit() and this was prevented.");console.warn(v.stack)}},process.crash=function(){const E=new Error("An extension called process.crash() and this was prevented.");console.warn(E.stack)},process.env.ELECTRON_RUN_AS_NODE="1",process.on=function(E,v){E==="uncaughtException"&&(v=function(){try{return v.call(void 0,arguments)}catch{}}),s(E,v)}}let g=function(f){r()};function d(){const f=(0,i.$bn)(process.env);if(f.type===3)return new Promise((E,v)=>{const D=k=>{const S=k[0],F=new p.$8h;S.on("message",W=>F.fire(b.$ue.wrap(W.data))),S.on("close",()=>{g("renderer closed the MessagePort")}),S.start(),E({onMessage:F.event,send:W=>S.postMessage(W.buffer)})};process.parentPort.on("message",k=>D(k.ports))});if(f.type===2)return new Promise((E,v)=>{let D=null;const k=setTimeout(()=>{g("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),S=108e5,F=3e5,W=new a.$vh(()=>g("renderer disconnected for too long (1)"),S),B=new a.$vh(()=>g("renderer disconnected for too long (2)"),F);process.on("message",(N,j)=>{if(N&&N.type==="VSCODE_EXTHOST_IPC_SOCKET"){j.setNoDelay(!0);const L=b.$ue.wrap(Buffer.from(N.initialDataChunk,"base64"));let z;if(N.skipWebSocketFrames)z=new $.$0h(j,"extHost-socket");else{const Q=b.$ue.wrap(Buffer.from(N.inflateBytes,"base64"));z=new $.$$h(new $.$0h(j,"extHost-socket"),N.permessageDeflate,Q,!1)}D?(W.cancel(),B.cancel(),D.beginAcceptReconnection(z,L),D.endAcceptReconnection(),D.sendResume()):(clearTimeout(k),D=new p.$9h({socket:z,initialChunk:L}),D.sendResume(),D.onDidDispose(()=>g("renderer disconnected")),E(D),D.onSocketClose(()=>{W.schedule()}))}if(N&&N.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(B.isScheduled())return;W.isScheduled()&&B.schedule()}});const T={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(T)});{const E=f.pipeName;return new Promise((v,D)=>{const k=R.createConnection(E,()=>{k.removeListener("error",D);const S=new p.$9h({socket:new $.$0h(k,"extHost-renderer")});S.sendResume(),v(S)});k.once("error",D),k.on("close",()=>{g("renderer closed the socket")})})}}async function h(){const f=await d();return new class{constructor(){this.a=new p.$8h,this.onMessage=this.a.event,this.b=!1,f.onMessage(E=>{(0,A.$Nm)(E,2)?(this.b=!0,g("received terminate message from renderer")):this.a.fire(E)})}send(E){this.b||f.send(E)}async drain(){if(f.drain)return f.drain()}}}function c(f){return new Promise(E=>{const v=f.onMessage(D=>{v.dispose();const k=JSON.parse(D.toString()),S=k.commit,F=w.default.commit;if(S&&F&&S!==F&&r(55),k.parentPid){let W=0;setInterval(function(){try{process.kill(k.parentPid,0),W=0}catch(T){T&&T.code==="EPERM"?(W++,W>=3&&g(`parent process ${k.parentPid} does not exist anymore (3 x EPERM): ${T.message} (code: ${T.code}) (errno: ${T.errno})`)):g(`parent process ${k.parentPid} does not exist anymore: ${T.message} (code: ${T.code}) (errno: ${T.errno})`)}},1e3);let B;try{B=globalThis._VSCODE_NODE_MODULES["native-watchdog"],B.start(k.parentPid)}catch(T){(0,O.$1)(T)}}f.send((0,A.$Mm)(0)),E({protocol:f,initData:k})});f.send((0,A.$Mm)(1))})}async function u(){const f=[];process.on("unhandledRejection",(W,B)=>{f.push(B),setTimeout(()=>{const T=f.indexOf(B);T>=0&&B.catch(N=>{f.splice(T,1),(0,O.$4)(N)||(console.warn(`rejected promise not handled within 1 second: ${N}`),N&&N.stack&&console.warn(`stack trace: ${N.stack}`),W&&(0,O.$1)(W))})},1e3)}),process.on("rejectionHandled",W=>{const B=f.indexOf(W);B>=0&&f.splice(B,1)}),process.on("uncaughtException",function(W){(0,O.$Z)(W)||(0,O.$1)(W)}),M.mark("code/extHost/willConnectToRenderer");const E=await h();M.mark("code/extHost/didConnectToRenderer");const v=await c(E);M.mark("code/extHost/didWaitForInitData");const{initData:D}=v;t(!!D.environment.extensionTestsLocationURI),D.environment.useHostProxy=n.useHostProxy!==void 0?n.useHostProxy!=="false":void 0,D.environment.skipWorkspaceStorageLock=(0,m.boolean)(n.skipWorkspaceStorageLock,!1);const k=new class{constructor(){this.pid=process.pid}exit(B){r(B)}fsExists(B){return C.Promises.exists(B)}fsRealpath(B){return(0,y.$Qq)(B)}};let S=null;D.remote.authority&&n.transformURIs&&(S=(0,l.$ls)(D.remote.authority));const F=new P.$Olc(v.protocol,D,k,S);g=W=>{F.terminate(W);const B=process.env.VSCODE_IPC_HOOK_CLI,T=process.env.CODE_SERVER_SESSION_SOCKET;if(!B||!T)return;const N=JSON.stringify({socketPath:B}),j={path:"/delete-session",socketPath:T,method:"POST",headers:{"content-type":"application/json",accept:"application/json"}},L=o.request(j);L.write(N),L.end()}}u().catch(f=>console.log(f))})}).call(this);

//# sourceMappingURL=extensionHostProcess.js.map
