"use strict";/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Pe=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/async","vs/base/common/network","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/strings","vs/workbench/api/common/extHostRpcService","vs/base/common/types","vs/base/common/arrays","vs/base/common/path","vs/platform/extensions/common/extensions","vs/base/common/platform","vs/base/common/buffer","vs/base/common/resources","vs/base/common/cancellation","vs/workbench/services/extensions/common/extensions","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/platform/registry/common/platform","vs/workbench/api/common/extHostCommands","vs/base/common/severity","vs/platform/contextkey/common/contextkey","vs/base/common/glob","vs/base/common/uuid","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/themables","vs/base/common/errorMessage","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/search/common/search","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/platform/workspace/common/workspace","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostTerminalService","vs/base/common/ternarySearchTree","vs/base/common/marshalling","vs/base/common/htmlContent","vs/platform/instantiation/common/extensions","vs/base/common/assert","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/stopwatch","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/decorators","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/editor/common/languages","vs/workbench/api/common/extHostLanguageModels","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/labels","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model","vs/editor/common/model/textModelSearch","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/prefixTree","vs/base/common/comparers","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/uriIpc","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/core/textModelDefaults","vs/editor/common/languageSelector","vs/editor/common/languages/languageConfiguration","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/base/common/codiconsUtil","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Re=function(ee){for(var e=[],k=0,M=ee.length;k<M;k++)e[k]=Pe[ee[k]];return e};define(Pe[68],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mh=M,e.$Nh=C,e.$Oh=N;function k(A){return(m,d,y)=>{let O=null,D=null;if(typeof y.value=="function"?(O="value",D=y.value):typeof y.get=="function"&&(O="get",D=y.get),!D)throw new Error("not supported");y[O]=A(D,d)}}function M(A,m,d){let y=null,O=null;if(typeof d.value=="function"?(y="value",O=d.value,O.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof d.get=="function"&&(y="get",O=d.get),!O)throw new Error("not supported");const D=`$memoize$${m}`;d[y]=function(...l){return this.hasOwnProperty(D)||Object.defineProperty(this,D,{configurable:!1,enumerable:!1,writable:!1,value:O.apply(this,l)}),this[D]}}function C(A,m,d){return k((y,O)=>{const D=`$debounce$${O}`,l=`$debounce$result$${O}`;return function(...b){this[l]||(this[l]=d?d():void 0),clearTimeout(this[D]),m&&(this[l]=m(this[l],...b),b=[this[l]]),this[D]=setTimeout(()=>{y.apply(this,b),this[l]=d?d():void 0},A)}})}function N(A,m,d){return k((y,O)=>{const D=`$throttle$timer$${O}`,l=`$throttle$result$${O}`,b=`$throttle$lastRun$${O}`,$=`$throttle$pending$${O}`;return function(...n){if(this[l]||(this[l]=d?d():void 0),(this[b]===null||this[b]===void 0)&&(this[b]=-Number.MAX_VALUE),m&&(this[l]=m(this[l],...n)),this[$])return;const o=this[b]+A;o<=Date.now()?(this[b]=Date.now(),y.apply(this,[this[l]]),this[l]=d?d():void 0):(this[$]=!0,this[D]=setTimeout(()=>{this[$]=!1,this[b]=Date.now(),y.apply(this,[this[l]]),this[l]=d?d():void 0},o-Date.now()))}})}}),define(Pe[90],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UO=e.$TO=void 0;class k{constructor(C){this.a=C,this.b=0}nextId(){return this.a+ ++this.b}}e.$TO=k,e.$UO=new k("id#")}),define(Pe[123],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$un=A,e.$vn=D,e.$wn=l,e.$xn=b,e.$yn=$,e.$zn=n,e.$An=o,e.$Bn=s,e.$Cn=r,e.$Dn=i,e.$En=c,e.$Fn=h;var k;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(k||(e.ScanError=k={}));var M;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(M||(e.SyntaxKind=M={}));var C;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(C||(e.ParseErrorCode=C={}));var N;(function(t){t.DEFAULT={allowTrailingComma:!0}})(N||(e.ParseOptions=N={}));function A(t,p=!1){let a=0;const g=t.length;let v="",f=0,u=16,E=0;function w(L){let R=0,F=0;for(;R<L;){const T=t.charCodeAt(a);if(T>=48&&T<=57)F=F*16+T-48;else if(T>=65&&T<=70)F=F*16+T-65+10;else if(T>=97&&T<=102)F=F*16+T-97+10;else break;a++,R++}return R<L&&(F=-1),F}function I(L){a=L,v="",f=0,u=16,E=0}function S(){const L=a;if(t.charCodeAt(a)===48)a++;else for(a++;a<t.length&&y(t.charCodeAt(a));)a++;if(a<t.length&&t.charCodeAt(a)===46)if(a++,a<t.length&&y(t.charCodeAt(a)))for(a++;a<t.length&&y(t.charCodeAt(a));)a++;else return E=3,t.substring(L,a);let R=a;if(a<t.length&&(t.charCodeAt(a)===69||t.charCodeAt(a)===101))if(a++,(a<t.length&&t.charCodeAt(a)===43||t.charCodeAt(a)===45)&&a++,a<t.length&&y(t.charCodeAt(a))){for(a++;a<t.length&&y(t.charCodeAt(a));)a++;R=a}else E=3;return t.substring(L,R)}function P(){let L="",R=a;for(;;){if(a>=g){L+=t.substring(R,a),E=2;break}const F=t.charCodeAt(a);if(F===34){L+=t.substring(R,a),a++;break}if(F===92){if(L+=t.substring(R,a),a++,a>=g){E=2;break}switch(t.charCodeAt(a++)){case 34:L+='"';break;case 92:L+="\\";break;case 47:L+="/";break;case 98:L+="\b";break;case 102:L+="\f";break;case 110:L+=`
`;break;case 114:L+="\r";break;case 116:L+="	";break;case 117:{const X=w(4);X>=0?L+=String.fromCharCode(X):E=4;break}default:E=5}R=a;continue}if(F>=0&&F<=31)if(d(F)){L+=t.substring(R,a),E=2;break}else E=6;a++}return L}function U(){if(v="",E=0,f=a,a>=g)return f=g,u=17;let L=t.charCodeAt(a);if(m(L)){do a++,v+=String.fromCharCode(L),L=t.charCodeAt(a);while(m(L));return u=15}if(d(L))return a++,v+=String.fromCharCode(L),L===13&&t.charCodeAt(a)===10&&(a++,v+=`
`),u=14;switch(L){case 123:return a++,u=1;case 125:return a++,u=2;case 91:return a++,u=3;case 93:return a++,u=4;case 58:return a++,u=6;case 44:return a++,u=5;case 34:return a++,v=P(),u=10;case 47:{const R=a-1;if(t.charCodeAt(a+1)===47){for(a+=2;a<g&&!d(t.charCodeAt(a));)a++;return v=t.substring(R,a),u=12}if(t.charCodeAt(a+1)===42){a+=2;const F=g-1;let T=!1;for(;a<F;){if(t.charCodeAt(a)===42&&t.charCodeAt(a+1)===47){a+=2,T=!0;break}a++}return T||(a++,E=1),v=t.substring(R,a),u=13}return v+=String.fromCharCode(L),a++,u=16}case 45:if(v+=String.fromCharCode(L),a++,a===g||!y(t.charCodeAt(a)))return u=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return v+=S(),u=11;default:for(;a<g&&Q(L);)a++,L=t.charCodeAt(a);if(f!==a){switch(v=t.substring(f,a),v){case"true":return u=8;case"false":return u=9;case"null":return u=7}return u=16}return v+=String.fromCharCode(L),a++,u=16}}function Q(L){if(m(L)||d(L))return!1;switch(L){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function H(){let L;do L=U();while(L>=12&&L<=15);return L}return{setPosition:I,getPosition:()=>a,scan:p?H:U,getToken:()=>u,getTokenValue:()=>v,getTokenOffset:()=>f,getTokenLength:()=>a-f,getTokenError:()=>E}}function m(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function d(t){return t===10||t===13||t===8232||t===8233}function y(t){return t>=48&&t<=57}var O;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(O||(O={}));function D(t,p){const a=[],g=new Object;let v;const f={value:{},offset:0,length:0,type:"object",parent:void 0};let u=!1;function E(w,I,S,P){f.value=w,f.offset=I,f.length=S,f.type=P,f.colonOffset=void 0,v=f}try{i(t,{onObjectBegin:(w,I)=>{if(p<=w)throw g;v=void 0,u=p>w,a.push("")},onObjectProperty:(w,I,S)=>{if(p<I||(E(w,I,S,"property"),a[a.length-1]=w,p<=I+S))throw g},onObjectEnd:(w,I)=>{if(p<=w)throw g;v=void 0,a.pop()},onArrayBegin:(w,I)=>{if(p<=w)throw g;v=void 0,a.push(0)},onArrayEnd:(w,I)=>{if(p<=w)throw g;v=void 0,a.pop()},onLiteralValue:(w,I,S)=>{if(p<I||(E(w,I,S,h(w)),p<=I+S))throw g},onSeparator:(w,I,S)=>{if(p<=I)throw g;if(w===":"&&v&&v.type==="property")v.colonOffset=I,u=!1,v=void 0;else if(w===","){const P=a[a.length-1];typeof P=="number"?a[a.length-1]=P+1:(u=!0,a[a.length-1]=""),v=void 0}}})}catch(w){if(w!==g)throw w}return{path:a,previousNode:v,isAtPropertyKey:u,matches:w=>{let I=0;for(let S=0;I<w.length&&S<a.length;S++)if(w[I]===a[S]||w[I]==="*")I++;else if(w[I]!=="**")return!1;return I===w.length}}}function l(t,p=[],a=N.DEFAULT){let g=null,v=[];const f=[];function u(w){Array.isArray(v)?v.push(w):g!==null&&(v[g]=w)}return i(t,{onObjectBegin:()=>{const w={};u(w),f.push(v),v=w,g=null},onObjectProperty:w=>{g=w},onObjectEnd:()=>{v=f.pop()},onArrayBegin:()=>{const w=[];u(w),f.push(v),v=w,g=null},onArrayEnd:()=>{v=f.pop()},onLiteralValue:u,onError:(w,I,S)=>{p.push({error:w,offset:I,length:S})}},a),v[0]}function b(t,p=[],a=N.DEFAULT){let g={type:"array",offset:-1,length:-1,children:[],parent:void 0};function v(w){g.type==="property"&&(g.length=w-g.offset,g=g.parent)}function f(w){return g.children.push(w),w}i(t,{onObjectBegin:w=>{g=f({type:"object",offset:w,length:-1,parent:g,children:[]})},onObjectProperty:(w,I,S)=>{g=f({type:"property",offset:I,length:-1,parent:g,children:[]}),g.children.push({type:"string",value:w,offset:I,length:S,parent:g})},onObjectEnd:(w,I)=>{g.length=w+I-g.offset,g=g.parent,v(w+I)},onArrayBegin:(w,I)=>{g=f({type:"array",offset:w,length:-1,parent:g,children:[]})},onArrayEnd:(w,I)=>{g.length=w+I-g.offset,g=g.parent,v(w+I)},onLiteralValue:(w,I,S)=>{f({type:h(w),offset:I,length:S,parent:g,value:w}),v(I+S)},onSeparator:(w,I,S)=>{g.type==="property"&&(w===":"?g.colonOffset=I:w===","&&v(I))},onError:(w,I,S)=>{p.push({error:w,offset:I,length:S})}},a);const E=g.children[0];return E&&delete E.parent,E}function $(t,p){if(!t)return;let a=t;for(const g of p)if(typeof g=="string"){if(a.type!=="object"||!Array.isArray(a.children))return;let v=!1;for(const f of a.children)if(Array.isArray(f.children)&&f.children[0].value===g){a=f.children[1],v=!0;break}if(!v)return}else{const v=g;if(a.type!=="array"||v<0||!Array.isArray(a.children)||v>=a.children.length)return;a=a.children[v]}return a}function n(t){if(!t.parent||!t.parent.children)return[];const p=n(t.parent);if(t.parent.type==="property"){const a=t.parent.children[0].value;p.push(a)}else if(t.parent.type==="array"){const a=t.parent.children.indexOf(t);a!==-1&&p.push(a)}return p}function o(t){switch(t.type){case"array":return t.children.map(o);case"object":{const p=Object.create(null);for(const a of t.children){const g=a.children[1];g&&(p[a.children[0].value]=o(g))}return p}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function s(t,p,a=!1){return p>=t.offset&&p<t.offset+t.length||a&&p===t.offset+t.length}function r(t,p,a=!1){if(s(t,p,a)){const g=t.children;if(Array.isArray(g))for(let v=0;v<g.length&&g[v].offset<=p;v++){const f=r(g[v],p,a);if(f)return f}return t}}function i(t,p,a=N.DEFAULT){const g=A(t,!1);function v(se){return se?()=>se(g.getTokenOffset(),g.getTokenLength()):()=>!0}function f(se){return se?De=>se(De,g.getTokenOffset(),g.getTokenLength()):()=>!0}const u=v(p.onObjectBegin),E=f(p.onObjectProperty),w=v(p.onObjectEnd),I=v(p.onArrayBegin),S=v(p.onArrayEnd),P=f(p.onLiteralValue),U=f(p.onSeparator),Q=v(p.onComment),H=f(p.onError),L=a&&a.disallowComments,R=a&&a.allowTrailingComma;function F(){for(;;){const se=g.scan();switch(g.getTokenError()){case 4:T(14);break;case 5:T(15);break;case 3:T(13);break;case 1:L||T(11);break;case 2:T(12);break;case 6:T(16);break}switch(se){case 12:case 13:L?T(10):Q();break;case 16:T(1);break;case 15:case 14:break;default:return se}}}function T(se,De=[],Oe=[]){if(H(se),De.length+Oe.length>0){let ie=g.getToken();for(;ie!==17;){if(De.indexOf(ie)!==-1){F();break}else if(Oe.indexOf(ie)!==-1)break;ie=F()}}}function X(se){const De=g.getTokenValue();return se?P(De):E(De),F(),!0}function re(){switch(g.getToken()){case 11:{let se=0;try{se=JSON.parse(g.getTokenValue()),typeof se!="number"&&(T(2),se=0)}catch{T(2)}P(se);break}case 7:P(null);break;case 8:P(!0);break;case 9:P(!1);break;default:return!1}return F(),!0}function me(){return g.getToken()!==10?(T(3,[],[2,5]),!1):(X(!1),g.getToken()===6?(U(":"),F(),be()||T(4,[],[2,5])):T(5,[],[2,5]),!0)}function pe(){u(),F();let se=!1;for(;g.getToken()!==2&&g.getToken()!==17;){if(g.getToken()===5){if(se||T(4,[],[]),U(","),F(),g.getToken()===2&&R)break}else se&&T(6,[],[]);me()||T(4,[],[2,5]),se=!0}return w(),g.getToken()!==2?T(7,[2],[]):F(),!0}function ae(){I(),F();let se=!1;for(;g.getToken()!==4&&g.getToken()!==17;){if(g.getToken()===5){if(se||T(4,[],[]),U(","),F(),g.getToken()===4&&R)break}else se&&T(6,[],[]);be()||T(4,[],[4,5]),se=!0}return S(),g.getToken()!==4?T(8,[4],[]):F(),!0}function be(){switch(g.getToken()){case 3:return ae();case 1:return pe();case 10:return X(!0);default:return re()}}return F(),g.getToken()===17?a.allowEmptyContent?!0:(T(4,[],[]),!1):be()?(g.getToken()!==17&&T(9,[],[]),!0):(T(4,[],[]),!1)}function c(t,p){const a=A(t),g=[];let v,f=0,u;do switch(u=a.getPosition(),v=a.scan(),v){case 12:case 13:case 17:f!==u&&g.push(t.substring(f,u)),p!==void 0&&g.push(a.getTokenValue().replace(/[^\r\n]/g,p)),f=a.getPosition();break}while(v!==17);return g.join("")}function h(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),function(ee,e){typeof define=="function"&&define.amd?define(Pe[124],Re([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(ee=typeof globalThis<"u"?globalThis:ee||self,e(ee.marked={}))}(this,function(ee){"use strict";function e(we,ge){for(var ce=0;ce<ge.length;ce++){var K=ge[ce];K.enumerable=K.enumerable||!1,K.configurable=!0,"value"in K&&(K.writable=!0),Object.defineProperty(we,K.key,K)}}function k(we,ge,ce){return ge&&e(we.prototype,ge),ce&&e(we,ce),Object.defineProperty(we,"prototype",{writable:!1}),we}function M(we,ge){if(we){if(typeof we=="string")return C(we,ge);var ce=Object.prototype.toString.call(we).slice(8,-1);if(ce==="Object"&&we.constructor&&(ce=we.constructor.name),ce==="Map"||ce==="Set")return Array.from(we);if(ce==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ce))return C(we,ge)}}function C(we,ge){(ge==null||ge>we.length)&&(ge=we.length);for(var ce=0,K=new Array(ge);ce<ge;ce++)K[ce]=we[ce];return K}function N(we,ge){var ce=typeof Symbol<"u"&&we[Symbol.iterator]||we["@@iterator"];if(ce)return(ce=ce.call(we)).next.bind(ce);if(Array.isArray(we)||(ce=M(we))||ge&&we&&typeof we.length=="number"){ce&&(we=ce);var K=0;return function(){return K>=we.length?{done:!0}:{done:!1,value:we[K++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ee.defaults=A();function m(we){ee.defaults=we}var d=/[&<>"']/,y=/[&<>"']/g,O=/[<>"']|&(?!#?\w+;)/,D=/[<>"']|&(?!#?\w+;)/g,l={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},b=function(ge){return l[ge]};function $(we,ge){if(ge){if(d.test(we))return we.replace(y,b)}else if(O.test(we))return we.replace(D,b);return we}var n=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(we){return we.replace(n,function(ge,ce){return ce=ce.toLowerCase(),ce==="colon"?":":ce.charAt(0)==="#"?ce.charAt(1)==="x"?String.fromCharCode(parseInt(ce.substring(2),16)):String.fromCharCode(+ce.substring(1)):""})}var s=/(^|[^\[])\^/g;function r(we,ge){we=typeof we=="string"?we:we.source,ge=ge||"";var ce={replace:function(Z,le){return le=le.source||le,le=le.replace(s,"$1"),we=we.replace(Z,le),ce},getRegex:function(){return new RegExp(we,ge)}};return ce}var i=/[^\w:]/g,c=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function h(we,ge,ce){if(we){var K;try{K=decodeURIComponent(o(ce)).replace(i,"").toLowerCase()}catch{return null}if(K.indexOf("javascript:")===0||K.indexOf("vbscript:")===0||K.indexOf("data:")===0)return null}ge&&!c.test(ce)&&(ce=v(ge,ce));try{ce=encodeURI(ce).replace(/%25/g,"%")}catch{return null}return ce}var t={},p=/^[^:]+:\/*[^/]*$/,a=/^([^:]+:)[\s\S]*$/,g=/^([^:]+:\/*[^/]*)[\s\S]*$/;function v(we,ge){t[" "+we]||(p.test(we)?t[" "+we]=we+"/":t[" "+we]=w(we,"/",!0)),we=t[" "+we];var ce=we.indexOf(":")===-1;return ge.substring(0,2)==="//"?ce?ge:we.replace(a,"$1")+ge:ge.charAt(0)==="/"?ce?ge:we.replace(g,"$1")+ge:we+ge}var f={exec:function(){}};function u(we){for(var ge=1,ce,K;ge<arguments.length;ge++){ce=arguments[ge];for(K in ce)Object.prototype.hasOwnProperty.call(ce,K)&&(we[K]=ce[K])}return we}function E(we,ge){var ce=we.replace(/\|/g,function(le,fe,Te){for(var ve=!1,Ie=fe;--Ie>=0&&Te[Ie]==="\\";)ve=!ve;return ve?"|":" |"}),K=ce.split(/ \|/),Z=0;if(K[0].trim()||K.shift(),K.length>0&&!K[K.length-1].trim()&&K.pop(),K.length>ge)K.splice(ge);else for(;K.length<ge;)K.push("");for(;Z<K.length;Z++)K[Z]=K[Z].trim().replace(/\\\|/g,"|");return K}function w(we,ge,ce){var K=we.length;if(K===0)return"";for(var Z=0;Z<K;){var le=we.charAt(K-Z-1);if(le===ge&&!ce)Z++;else if(le!==ge&&ce)Z++;else break}return we.slice(0,K-Z)}function I(we,ge){if(we.indexOf(ge[1])===-1)return-1;for(var ce=we.length,K=0,Z=0;Z<ce;Z++)if(we[Z]==="\\")Z++;else if(we[Z]===ge[0])K++;else if(we[Z]===ge[1]&&(K--,K<0))return Z;return-1}function S(we){we&&we.sanitize&&!we.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function P(we,ge){if(ge<1)return"";for(var ce="";ge>1;)ge&1&&(ce+=we),ge>>=1,we+=we;return ce+we}function U(we,ge,ce,K){var Z=ge.href,le=ge.title?$(ge.title):null,fe=we[1].replace(/\\([\[\]])/g,"$1");if(we[0].charAt(0)!=="!"){K.state.inLink=!0;var Te={type:"link",raw:ce,href:Z,title:le,text:fe,tokens:K.inlineTokens(fe)};return K.state.inLink=!1,Te}return{type:"image",raw:ce,href:Z,title:le,text:$(fe)}}function Q(we,ge){var ce=we.match(/^(\s+)(?:```)/);if(ce===null)return ge;var K=ce[1];return ge.split(`
`).map(function(Z){var le=Z.match(/^\s+/);if(le===null)return Z;var fe=le[0];return fe.length>=K.length?Z.slice(K.length):Z}).join(`
`)}var H=function(){function we(ce){this.options=ce||ee.defaults}var ge=we.prototype;return ge.space=function(K){var Z=this.rules.block.newline.exec(K);if(Z&&Z[0].length>0)return{type:"space",raw:Z[0]}},ge.code=function(K){var Z=this.rules.block.code.exec(K);if(Z){var le=Z[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:Z[0],codeBlockStyle:"indented",text:this.options.pedantic?le:w(le,`
`)}}},ge.fences=function(K){var Z=this.rules.block.fences.exec(K);if(Z){var le=Z[0],fe=Q(le,Z[3]||"");return{type:"code",raw:le,lang:Z[2]?Z[2].trim():Z[2],text:fe}}},ge.heading=function(K){var Z=this.rules.block.heading.exec(K);if(Z){var le=Z[2].trim();if(/#$/.test(le)){var fe=w(le,"#");(this.options.pedantic||!fe||/ $/.test(fe))&&(le=fe.trim())}return{type:"heading",raw:Z[0],depth:Z[1].length,text:le,tokens:this.lexer.inline(le)}}},ge.hr=function(K){var Z=this.rules.block.hr.exec(K);if(Z)return{type:"hr",raw:Z[0]}},ge.blockquote=function(K){var Z=this.rules.block.blockquote.exec(K);if(Z){var le=Z[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:Z[0],tokens:this.lexer.blockTokens(le,[]),text:le}}},ge.list=function(K){var Z=this.rules.block.list.exec(K);if(Z){var le,fe,Te,ve,Ie,Ae,je,j,B,G,W,_,oe=Z[1].trim(),Fe=oe.length>1,Be={type:"list",raw:"",ordered:Fe,start:Fe?+oe.slice(0,-1):"",loose:!1,items:[]};oe=Fe?"\\d{1,9}\\"+oe.slice(-1):"\\"+oe,this.options.pedantic&&(oe=Fe?oe:"[*+-]");for(var Qe=new RegExp("^( {0,3}"+oe+")((?:[	 ][^\\n]*)?(?:\\n|$))");K&&(_=!1,!(!(Z=Qe.exec(K))||this.rules.block.hr.test(K)));){if(le=Z[0],K=K.substring(le.length),j=Z[2].split(`
`,1)[0],B=K.split(`
`,1)[0],this.options.pedantic?(ve=2,W=j.trimLeft()):(ve=Z[2].search(/[^ ]/),ve=ve>4?1:ve,W=j.slice(ve),ve+=Z[1].length),Ae=!1,!j&&/^ *$/.test(B)&&(le+=B+`
`,K=K.substring(B.length+1),_=!0),!_)for(var et=new RegExp("^ {0,"+Math.min(3,ve-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),it=new RegExp("^ {0,"+Math.min(3,ve-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),ut=new RegExp("^ {0,"+Math.min(3,ve-1)+"}(?:```|~~~)"),st=new RegExp("^ {0,"+Math.min(3,ve-1)+"}#");K&&(G=K.split(`
`,1)[0],j=G,this.options.pedantic&&(j=j.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(ut.test(j)||st.test(j)||et.test(j)||it.test(K)));){if(j.search(/[^ ]/)>=ve||!j.trim())W+=`
`+j.slice(ve);else if(!Ae)W+=`
`+j;else break;!Ae&&!j.trim()&&(Ae=!0),le+=G+`
`,K=K.substring(G.length+1)}Be.loose||(je?Be.loose=!0:/\n *\n *$/.test(le)&&(je=!0)),this.options.gfm&&(fe=/^\[[ xX]\] /.exec(W),fe&&(Te=fe[0]!=="[ ] ",W=W.replace(/^\[[ xX]\] +/,""))),Be.items.push({type:"list_item",raw:le,task:!!fe,checked:Te,loose:!1,text:W}),Be.raw+=le}Be.items[Be.items.length-1].raw=le.trimRight(),Be.items[Be.items.length-1].text=W.trimRight(),Be.raw=Be.raw.trimRight();var rt=Be.items.length;for(Ie=0;Ie<rt;Ie++){this.lexer.state.top=!1,Be.items[Ie].tokens=this.lexer.blockTokens(Be.items[Ie].text,[]);var ot=Be.items[Ie].tokens.filter(function(Ue){return Ue.type==="space"}),$t=ot.every(function(Ue){for(var ct=Ue.raw.split(""),x=0,Y=N(ct),ye;!(ye=Y()).done;){var He=ye.value;if(He===`
`&&(x+=1),x>1)return!0}return!1});!Be.loose&&ot.length&&$t&&(Be.loose=!0,Be.items[Ie].loose=!0)}return Be}},ge.html=function(K){var Z=this.rules.block.html.exec(K);if(Z){var le={type:"html",raw:Z[0],pre:!this.options.sanitizer&&(Z[1]==="pre"||Z[1]==="script"||Z[1]==="style"),text:Z[0]};if(this.options.sanitize){var fe=this.options.sanitizer?this.options.sanitizer(Z[0]):$(Z[0]);le.type="paragraph",le.text=fe,le.tokens=this.lexer.inline(fe)}return le}},ge.def=function(K){var Z=this.rules.block.def.exec(K);if(Z){Z[3]&&(Z[3]=Z[3].substring(1,Z[3].length-1));var le=Z[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:le,raw:Z[0],href:Z[2],title:Z[3]}}},ge.table=function(K){var Z=this.rules.block.table.exec(K);if(Z){var le={type:"table",header:E(Z[1]).map(function(je){return{text:je}}),align:Z[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:Z[3]&&Z[3].trim()?Z[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(le.header.length===le.align.length){le.raw=Z[0];var fe=le.align.length,Te,ve,Ie,Ae;for(Te=0;Te<fe;Te++)/^ *-+: *$/.test(le.align[Te])?le.align[Te]="right":/^ *:-+: *$/.test(le.align[Te])?le.align[Te]="center":/^ *:-+ *$/.test(le.align[Te])?le.align[Te]="left":le.align[Te]=null;for(fe=le.rows.length,Te=0;Te<fe;Te++)le.rows[Te]=E(le.rows[Te],le.header.length).map(function(je){return{text:je}});for(fe=le.header.length,ve=0;ve<fe;ve++)le.header[ve].tokens=this.lexer.inline(le.header[ve].text);for(fe=le.rows.length,ve=0;ve<fe;ve++)for(Ae=le.rows[ve],Ie=0;Ie<Ae.length;Ie++)Ae[Ie].tokens=this.lexer.inline(Ae[Ie].text);return le}}},ge.lheading=function(K){var Z=this.rules.block.lheading.exec(K);if(Z)return{type:"heading",raw:Z[0],depth:Z[2].charAt(0)==="="?1:2,text:Z[1],tokens:this.lexer.inline(Z[1])}},ge.paragraph=function(K){var Z=this.rules.block.paragraph.exec(K);if(Z){var le=Z[1].charAt(Z[1].length-1)===`
`?Z[1].slice(0,-1):Z[1];return{type:"paragraph",raw:Z[0],text:le,tokens:this.lexer.inline(le)}}},ge.text=function(K){var Z=this.rules.block.text.exec(K);if(Z)return{type:"text",raw:Z[0],text:Z[0],tokens:this.lexer.inline(Z[0])}},ge.escape=function(K){var Z=this.rules.inline.escape.exec(K);if(Z)return{type:"escape",raw:Z[0],text:$(Z[1])}},ge.tag=function(K){var Z=this.rules.inline.tag.exec(K);if(Z)return!this.lexer.state.inLink&&/^<a /i.test(Z[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(Z[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(Z[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(Z[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:Z[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Z[0]):$(Z[0]):Z[0]}},ge.link=function(K){var Z=this.rules.inline.link.exec(K);if(Z){var le=Z[2].trim();if(!this.options.pedantic&&/^</.test(le)){if(!/>$/.test(le))return;var fe=w(le.slice(0,-1),"\\");if((le.length-fe.length)%2===0)return}else{var Te=I(Z[2],"()");if(Te>-1){var ve=Z[0].indexOf("!")===0?5:4,Ie=ve+Z[1].length+Te;Z[2]=Z[2].substring(0,Te),Z[0]=Z[0].substring(0,Ie).trim(),Z[3]=""}}var Ae=Z[2],je="";if(this.options.pedantic){var j=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ae);j&&(Ae=j[1],je=j[3])}else je=Z[3]?Z[3].slice(1,-1):"";return Ae=Ae.trim(),/^</.test(Ae)&&(this.options.pedantic&&!/>$/.test(le)?Ae=Ae.slice(1):Ae=Ae.slice(1,-1)),U(Z,{href:Ae&&Ae.replace(this.rules.inline._escapes,"$1"),title:je&&je.replace(this.rules.inline._escapes,"$1")},Z[0],this.lexer)}},ge.reflink=function(K,Z){var le;if((le=this.rules.inline.reflink.exec(K))||(le=this.rules.inline.nolink.exec(K))){var fe=(le[2]||le[1]).replace(/\s+/g," ");if(fe=Z[fe.toLowerCase()],!fe||!fe.href){var Te=le[0].charAt(0);return{type:"text",raw:Te,text:Te}}return U(le,fe,le[0],this.lexer)}},ge.emStrong=function(K,Z,le){le===void 0&&(le="");var fe=this.rules.inline.emStrong.lDelim.exec(K);if(fe&&!(fe[3]&&le.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Te=fe[1]||fe[2]||"";if(!Te||Te&&(le===""||this.rules.inline.punctuation.exec(le))){var ve=fe[0].length-1,Ie,Ae,je=ve,j=0,B=fe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(B.lastIndex=0,Z=Z.slice(-1*K.length+ve);(fe=B.exec(Z))!=null;)if(Ie=fe[1]||fe[2]||fe[3]||fe[4]||fe[5]||fe[6],!!Ie){if(Ae=Ie.length,fe[3]||fe[4]){je+=Ae;continue}else if((fe[5]||fe[6])&&ve%3&&!((ve+Ae)%3)){j+=Ae;continue}if(je-=Ae,!(je>0)){if(Ae=Math.min(Ae,Ae+je+j),Math.min(ve,Ae)%2){var G=K.slice(1,ve+fe.index+Ae);return{type:"em",raw:K.slice(0,ve+fe.index+Ae+1),text:G,tokens:this.lexer.inlineTokens(G)}}var W=K.slice(2,ve+fe.index+Ae-1);return{type:"strong",raw:K.slice(0,ve+fe.index+Ae+1),text:W,tokens:this.lexer.inlineTokens(W)}}}}}},ge.codespan=function(K){var Z=this.rules.inline.code.exec(K);if(Z){var le=Z[2].replace(/\n/g," "),fe=/[^ ]/.test(le),Te=/^ /.test(le)&&/ $/.test(le);return fe&&Te&&(le=le.substring(1,le.length-1)),le=$(le,!0),{type:"codespan",raw:Z[0],text:le}}},ge.br=function(K){var Z=this.rules.inline.br.exec(K);if(Z)return{type:"br",raw:Z[0]}},ge.del=function(K){var Z=this.rules.inline.del.exec(K);if(Z)return{type:"del",raw:Z[0],text:Z[2],tokens:this.lexer.inlineTokens(Z[2])}},ge.autolink=function(K,Z){var le=this.rules.inline.autolink.exec(K);if(le){var fe,Te;return le[2]==="@"?(fe=$(this.options.mangle?Z(le[1]):le[1]),Te="mailto:"+fe):(fe=$(le[1]),Te=fe),{type:"link",raw:le[0],text:fe,href:Te,tokens:[{type:"text",raw:fe,text:fe}]}}},ge.url=function(K,Z){var le;if(le=this.rules.inline.url.exec(K)){var fe,Te;if(le[2]==="@")fe=$(this.options.mangle?Z(le[0]):le[0]),Te="mailto:"+fe;else{var ve;do ve=le[0],le[0]=this.rules.inline._backpedal.exec(le[0])[0];while(ve!==le[0]);fe=$(le[0]),le[1]==="www."?Te="http://"+fe:Te=fe}return{type:"link",raw:le[0],text:fe,href:Te,tokens:[{type:"text",raw:fe,text:fe}]}}},ge.inlineText=function(K,Z){var le=this.rules.inline.text.exec(K);if(le){var fe;return this.lexer.state.inRawBlock?fe=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(le[0]):$(le[0]):le[0]:fe=$(this.options.smartypants?Z(le[0]):le[0]),{type:"text",raw:le[0],text:fe}}},we}(),L={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:f,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};L._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,L._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,L.def=r(L.def).replace("label",L._label).replace("title",L._title).getRegex(),L.bullet=/(?:[*+-]|\d{1,9}[.)])/,L.listItemStart=r(/^( *)(bull) */).replace("bull",L.bullet).getRegex(),L.list=r(L.list).replace(/bull/g,L.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+L.def.source+")").getRegex(),L._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",L._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,L.html=r(L.html,"i").replace("comment",L._comment).replace("tag",L._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),L.paragraph=r(L._paragraph).replace("hr",L.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",L._tag).getRegex(),L.blockquote=r(L.blockquote).replace("paragraph",L.paragraph).getRegex(),L.normal=u({},L),L.gfm=u({},L.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),L.gfm.table=r(L.gfm.table).replace("hr",L.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",L._tag).getRegex(),L.gfm.paragraph=r(L._paragraph).replace("hr",L.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",L.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",L._tag).getRegex(),L.pedantic=u({},L.normal,{html:r(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",L._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:f,paragraph:r(L.normal._paragraph).replace("hr",L.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",L.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var R={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:f,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:f,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};R._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",R.punctuation=r(R.punctuation).replace(/punctuation/g,R._punctuation).getRegex(),R.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,R.escapedEmSt=/\\\*|\\_/g,R._comment=r(L._comment).replace("(?:-->|$)","-->").getRegex(),R.emStrong.lDelim=r(R.emStrong.lDelim).replace(/punct/g,R._punctuation).getRegex(),R.emStrong.rDelimAst=r(R.emStrong.rDelimAst,"g").replace(/punct/g,R._punctuation).getRegex(),R.emStrong.rDelimUnd=r(R.emStrong.rDelimUnd,"g").replace(/punct/g,R._punctuation).getRegex(),R._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,R._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,R._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,R.autolink=r(R.autolink).replace("scheme",R._scheme).replace("email",R._email).getRegex(),R._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,R.tag=r(R.tag).replace("comment",R._comment).replace("attribute",R._attribute).getRegex(),R._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,R._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,R._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,R.link=r(R.link).replace("label",R._label).replace("href",R._href).replace("title",R._title).getRegex(),R.reflink=r(R.reflink).replace("label",R._label).replace("ref",L._label).getRegex(),R.nolink=r(R.nolink).replace("ref",L._label).getRegex(),R.reflinkSearch=r(R.reflinkSearch,"g").replace("reflink",R.reflink).replace("nolink",R.nolink).getRegex(),R.normal=u({},R),R.pedantic=u({},R.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:r(/^!?\[(label)\]\((.*?)\)/).replace("label",R._label).getRegex(),reflink:r(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",R._label).getRegex()}),R.gfm=u({},R.normal,{escape:r(R.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),R.gfm.url=r(R.gfm.url,"i").replace("email",R.gfm._extended_email).getRegex(),R.breaks=u({},R.gfm,{br:r(R.br).replace("{2,}","*").getRegex(),text:r(R.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function F(we){return we.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function T(we){var ge="",ce,K,Z=we.length;for(ce=0;ce<Z;ce++)K=we.charCodeAt(ce),Math.random()>.5&&(K="x"+K.toString(16)),ge+="&#"+K+";";return ge}var X=function(){function we(ce){this.tokens=[],this.tokens.links=Object.create(null),this.options=ce||ee.defaults,this.options.tokenizer=this.options.tokenizer||new H,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var K={block:L.normal,inline:R.normal};this.options.pedantic?(K.block=L.pedantic,K.inline=R.pedantic):this.options.gfm&&(K.block=L.gfm,this.options.breaks?K.inline=R.breaks:K.inline=R.gfm),this.tokenizer.rules=K}we.lex=function(K,Z){var le=new we(Z);return le.lex(K)},we.lexInline=function(K,Z){var le=new we(Z);return le.inlineTokens(K)};var ge=we.prototype;return ge.lex=function(K){K=K.replace(/\r\n|\r/g,`
`),this.blockTokens(K,this.tokens);for(var Z;Z=this.inlineQueue.shift();)this.inlineTokens(Z.src,Z.tokens);return this.tokens},ge.blockTokens=function(K,Z){var le=this;Z===void 0&&(Z=[]),this.options.pedantic?K=K.replace(/\t/g,"    ").replace(/^ +$/gm,""):K=K.replace(/^( *)(\t+)/gm,function(je,j,B){return j+"    ".repeat(B.length)});for(var fe,Te,ve,Ie;K;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(je){return(fe=je.call({lexer:le},K,Z))?(K=K.substring(fe.raw.length),Z.push(fe),!0):!1}))){if(fe=this.tokenizer.space(K)){K=K.substring(fe.raw.length),fe.raw.length===1&&Z.length>0?Z[Z.length-1].raw+=`
`:Z.push(fe);continue}if(fe=this.tokenizer.code(K)){K=K.substring(fe.raw.length),Te=Z[Z.length-1],Te&&(Te.type==="paragraph"||Te.type==="text")?(Te.raw+=`
`+fe.raw,Te.text+=`
`+fe.text,this.inlineQueue[this.inlineQueue.length-1].src=Te.text):Z.push(fe);continue}if(fe=this.tokenizer.fences(K)){K=K.substring(fe.raw.length),Z.push(fe);continue}if(fe=this.tokenizer.heading(K)){K=K.substring(fe.raw.length),Z.push(fe);continue}if(fe=this.tokenizer.hr(K)){K=K.substring(fe.raw.length),Z.push(fe);continue}if(fe=this.tokenizer.blockquote(K)){K=K.substring(fe.raw.length),Z.push(fe);continue}if(fe=this.tokenizer.list(K)){K=K.substring(fe.raw.length),Z.push(fe);continue}if(fe=this.tokenizer.html(K)){K=K.substring(fe.raw.length),Z.push(fe);continue}if(fe=this.tokenizer.def(K)){K=K.substring(fe.raw.length),Te=Z[Z.length-1],Te&&(Te.type==="paragraph"||Te.type==="text")?(Te.raw+=`
`+fe.raw,Te.text+=`
`+fe.raw,this.inlineQueue[this.inlineQueue.length-1].src=Te.text):this.tokens.links[fe.tag]||(this.tokens.links[fe.tag]={href:fe.href,title:fe.title});continue}if(fe=this.tokenizer.table(K)){K=K.substring(fe.raw.length),Z.push(fe);continue}if(fe=this.tokenizer.lheading(K)){K=K.substring(fe.raw.length),Z.push(fe);continue}if(ve=K,this.options.extensions&&this.options.extensions.startBlock&&function(){var je=1/0,j=K.slice(1),B=void 0;le.options.extensions.startBlock.forEach(function(G){B=G.call({lexer:this},j),typeof B=="number"&&B>=0&&(je=Math.min(je,B))}),je<1/0&&je>=0&&(ve=K.substring(0,je+1))}(),this.state.top&&(fe=this.tokenizer.paragraph(ve))){Te=Z[Z.length-1],Ie&&Te.type==="paragraph"?(Te.raw+=`
`+fe.raw,Te.text+=`
`+fe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Te.text):Z.push(fe),Ie=ve.length!==K.length,K=K.substring(fe.raw.length);continue}if(fe=this.tokenizer.text(K)){K=K.substring(fe.raw.length),Te=Z[Z.length-1],Te&&Te.type==="text"?(Te.raw+=`
`+fe.raw,Te.text+=`
`+fe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Te.text):Z.push(fe);continue}if(K){var Ae="Infinite loop on byte: "+K.charCodeAt(0);if(this.options.silent){console.error(Ae);break}else throw new Error(Ae)}}return this.state.top=!0,Z},ge.inline=function(K,Z){return Z===void 0&&(Z=[]),this.inlineQueue.push({src:K,tokens:Z}),Z},ge.inlineTokens=function(K,Z){var le=this;Z===void 0&&(Z=[]);var fe,Te,ve,Ie=K,Ae,je,j;if(this.tokens.links){var B=Object.keys(this.tokens.links);if(B.length>0)for(;(Ae=this.tokenizer.rules.inline.reflinkSearch.exec(Ie))!=null;)B.includes(Ae[0].slice(Ae[0].lastIndexOf("[")+1,-1))&&(Ie=Ie.slice(0,Ae.index)+"["+P("a",Ae[0].length-2)+"]"+Ie.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ae=this.tokenizer.rules.inline.blockSkip.exec(Ie))!=null;)Ie=Ie.slice(0,Ae.index)+"["+P("a",Ae[0].length-2)+"]"+Ie.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ae=this.tokenizer.rules.inline.escapedEmSt.exec(Ie))!=null;)Ie=Ie.slice(0,Ae.index)+"++"+Ie.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;K;)if(je||(j=""),je=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(W){return(fe=W.call({lexer:le},K,Z))?(K=K.substring(fe.raw.length),Z.push(fe),!0):!1}))){if(fe=this.tokenizer.escape(K)){K=K.substring(fe.raw.length),Z.push(fe);continue}if(fe=this.tokenizer.tag(K)){K=K.substring(fe.raw.length),Te=Z[Z.length-1],Te&&fe.type==="text"&&Te.type==="text"?(Te.raw+=fe.raw,Te.text+=fe.text):Z.push(fe);continue}if(fe=this.tokenizer.link(K)){K=K.substring(fe.raw.length),Z.push(fe);continue}if(fe=this.tokenizer.reflink(K,this.tokens.links)){K=K.substring(fe.raw.length),Te=Z[Z.length-1],Te&&fe.type==="text"&&Te.type==="text"?(Te.raw+=fe.raw,Te.text+=fe.text):Z.push(fe);continue}if(fe=this.tokenizer.emStrong(K,Ie,j)){K=K.substring(fe.raw.length),Z.push(fe);continue}if(fe=this.tokenizer.codespan(K)){K=K.substring(fe.raw.length),Z.push(fe);continue}if(fe=this.tokenizer.br(K)){K=K.substring(fe.raw.length),Z.push(fe);continue}if(fe=this.tokenizer.del(K)){K=K.substring(fe.raw.length),Z.push(fe);continue}if(fe=this.tokenizer.autolink(K,T)){K=K.substring(fe.raw.length),Z.push(fe);continue}if(!this.state.inLink&&(fe=this.tokenizer.url(K,T))){K=K.substring(fe.raw.length),Z.push(fe);continue}if(ve=K,this.options.extensions&&this.options.extensions.startInline&&function(){var W=1/0,_=K.slice(1),oe=void 0;le.options.extensions.startInline.forEach(function(Fe){oe=Fe.call({lexer:this},_),typeof oe=="number"&&oe>=0&&(W=Math.min(W,oe))}),W<1/0&&W>=0&&(ve=K.substring(0,W+1))}(),fe=this.tokenizer.inlineText(ve,F)){K=K.substring(fe.raw.length),fe.raw.slice(-1)!=="_"&&(j=fe.raw.slice(-1)),je=!0,Te=Z[Z.length-1],Te&&Te.type==="text"?(Te.raw+=fe.raw,Te.text+=fe.text):Z.push(fe);continue}if(K){var G="Infinite loop on byte: "+K.charCodeAt(0);if(this.options.silent){console.error(G);break}else throw new Error(G)}}return Z},k(we,null,[{key:"rules",get:function(){return{block:L,inline:R}}}]),we}(),re=function(){function we(ce){this.options=ce||ee.defaults}var ge=we.prototype;return ge.code=function(K,Z,le){var fe=(Z||"").match(/\S*/)[0];if(this.options.highlight){var Te=this.options.highlight(K,fe);Te!=null&&Te!==K&&(le=!0,K=Te)}return K=K.replace(/\n$/,"")+`
`,fe?'<pre><code class="'+this.options.langPrefix+$(fe,!0)+'">'+(le?K:$(K,!0))+`</code></pre>
`:"<pre><code>"+(le?K:$(K,!0))+`</code></pre>
`},ge.blockquote=function(K){return`<blockquote>
`+K+`</blockquote>
`},ge.html=function(K){return K},ge.heading=function(K,Z,le,fe){if(this.options.headerIds){var Te=this.options.headerPrefix+fe.slug(le);return"<h"+Z+' id="'+Te+'">'+K+"</h"+Z+`>
`}return"<h"+Z+">"+K+"</h"+Z+`>
`},ge.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ge.list=function(K,Z,le){var fe=Z?"ol":"ul",Te=Z&&le!==1?' start="'+le+'"':"";return"<"+fe+Te+`>
`+K+"</"+fe+`>
`},ge.listitem=function(K){return"<li>"+K+`</li>
`},ge.checkbox=function(K){return"<input "+(K?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ge.paragraph=function(K){return"<p>"+K+`</p>
`},ge.table=function(K,Z){return Z&&(Z="<tbody>"+Z+"</tbody>"),`<table>
<thead>
`+K+`</thead>
`+Z+`</table>
`},ge.tablerow=function(K){return`<tr>
`+K+`</tr>
`},ge.tablecell=function(K,Z){var le=Z.header?"th":"td",fe=Z.align?"<"+le+' align="'+Z.align+'">':"<"+le+">";return fe+K+("</"+le+`>
`)},ge.strong=function(K){return"<strong>"+K+"</strong>"},ge.em=function(K){return"<em>"+K+"</em>"},ge.codespan=function(K){return"<code>"+K+"</code>"},ge.br=function(){return this.options.xhtml?"<br/>":"<br>"},ge.del=function(K){return"<del>"+K+"</del>"},ge.link=function(K,Z,le){if(K=h(this.options.sanitize,this.options.baseUrl,K),K===null)return le;var fe='<a href="'+$(K)+'"';return Z&&(fe+=' title="'+Z+'"'),fe+=">"+le+"</a>",fe},ge.image=function(K,Z,le){if(K=h(this.options.sanitize,this.options.baseUrl,K),K===null)return le;var fe='<img src="'+K+'" alt="'+le+'"';return Z&&(fe+=' title="'+Z+'"'),fe+=this.options.xhtml?"/>":">",fe},ge.text=function(K){return K},we}(),me=function(){function we(){}var ge=we.prototype;return ge.strong=function(K){return K},ge.em=function(K){return K},ge.codespan=function(K){return K},ge.del=function(K){return K},ge.html=function(K){return K},ge.text=function(K){return K},ge.link=function(K,Z,le){return""+le},ge.image=function(K,Z,le){return""+le},ge.br=function(){return""},we}(),pe=function(){function we(){this.seen={}}var ge=we.prototype;return ge.serialize=function(K){return K.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ge.getNextSafeSlug=function(K,Z){var le=K,fe=0;if(this.seen.hasOwnProperty(le)){fe=this.seen[K];do fe++,le=K+"-"+fe;while(this.seen.hasOwnProperty(le))}return Z||(this.seen[K]=fe,this.seen[le]=0),le},ge.slug=function(K,Z){Z===void 0&&(Z={});var le=this.serialize(K);return this.getNextSafeSlug(le,Z.dryrun)},we}(),ae=function(){function we(ce){this.options=ce||ee.defaults,this.options.renderer=this.options.renderer||new re,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new me,this.slugger=new pe}we.parse=function(K,Z){var le=new we(Z);return le.parse(K)},we.parseInline=function(K,Z){var le=new we(Z);return le.parseInline(K)};var ge=we.prototype;return ge.parse=function(K,Z){Z===void 0&&(Z=!0);var le="",fe,Te,ve,Ie,Ae,je,j,B,G,W,_,oe,Fe,Be,Qe,et,it,ut,st,rt=K.length;for(fe=0;fe<rt;fe++){if(W=K[fe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[W.type]&&(st=this.options.extensions.renderers[W.type].call({parser:this},W),st!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(W.type))){le+=st||"";continue}switch(W.type){case"space":continue;case"hr":{le+=this.renderer.hr();continue}case"heading":{le+=this.renderer.heading(this.parseInline(W.tokens),W.depth,o(this.parseInline(W.tokens,this.textRenderer)),this.slugger);continue}case"code":{le+=this.renderer.code(W.text,W.lang,W.escaped);continue}case"table":{for(B="",j="",Ie=W.header.length,Te=0;Te<Ie;Te++)j+=this.renderer.tablecell(this.parseInline(W.header[Te].tokens),{header:!0,align:W.align[Te]});for(B+=this.renderer.tablerow(j),G="",Ie=W.rows.length,Te=0;Te<Ie;Te++){for(je=W.rows[Te],j="",Ae=je.length,ve=0;ve<Ae;ve++)j+=this.renderer.tablecell(this.parseInline(je[ve].tokens),{header:!1,align:W.align[ve]});G+=this.renderer.tablerow(j)}le+=this.renderer.table(B,G);continue}case"blockquote":{G=this.parse(W.tokens),le+=this.renderer.blockquote(G);continue}case"list":{for(_=W.ordered,oe=W.start,Fe=W.loose,Ie=W.items.length,G="",Te=0;Te<Ie;Te++)Qe=W.items[Te],et=Qe.checked,it=Qe.task,Be="",Qe.task&&(ut=this.renderer.checkbox(et),Fe?Qe.tokens.length>0&&Qe.tokens[0].type==="paragraph"?(Qe.tokens[0].text=ut+" "+Qe.tokens[0].text,Qe.tokens[0].tokens&&Qe.tokens[0].tokens.length>0&&Qe.tokens[0].tokens[0].type==="text"&&(Qe.tokens[0].tokens[0].text=ut+" "+Qe.tokens[0].tokens[0].text)):Qe.tokens.unshift({type:"text",text:ut}):Be+=ut),Be+=this.parse(Qe.tokens,Fe),G+=this.renderer.listitem(Be,it,et);le+=this.renderer.list(G,_,oe);continue}case"html":{le+=this.renderer.html(W.text);continue}case"paragraph":{le+=this.renderer.paragraph(this.parseInline(W.tokens));continue}case"text":{for(G=W.tokens?this.parseInline(W.tokens):W.text;fe+1<rt&&K[fe+1].type==="text";)W=K[++fe],G+=`
`+(W.tokens?this.parseInline(W.tokens):W.text);le+=Z?this.renderer.paragraph(G):G;continue}default:{var ot='Token with "'+W.type+'" type was not found.';if(this.options.silent){console.error(ot);return}else throw new Error(ot)}}}return le},ge.parseInline=function(K,Z){Z=Z||this.renderer;var le="",fe,Te,ve,Ie=K.length;for(fe=0;fe<Ie;fe++){if(Te=K[fe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Te.type]&&(ve=this.options.extensions.renderers[Te.type].call({parser:this},Te),ve!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Te.type))){le+=ve||"";continue}switch(Te.type){case"escape":{le+=Z.text(Te.text);break}case"html":{le+=Z.html(Te.text);break}case"link":{le+=Z.link(Te.href,Te.title,this.parseInline(Te.tokens,Z));break}case"image":{le+=Z.image(Te.href,Te.title,Te.text);break}case"strong":{le+=Z.strong(this.parseInline(Te.tokens,Z));break}case"em":{le+=Z.em(this.parseInline(Te.tokens,Z));break}case"codespan":{le+=Z.codespan(Te.text);break}case"br":{le+=Z.br();break}case"del":{le+=Z.del(this.parseInline(Te.tokens,Z));break}case"text":{le+=Z.text(Te.text);break}default:{var Ae='Token with "'+Te.type+'" type was not found.';if(this.options.silent){console.error(Ae);return}else throw new Error(Ae)}}}return le},we}();function be(we,ge,ce){if(typeof we>"u"||we===null)throw new Error("marked(): input parameter is undefined or null");if(typeof we!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(we)+", string expected");if(typeof ge=="function"&&(ce=ge,ge=null),ge=u({},be.defaults,ge||{}),S(ge),ce){var K=ge.highlight,Z;try{Z=X.lex(we,ge)}catch(Ie){return ce(Ie)}var le=function(Ae){var je;if(!Ae)try{ge.walkTokens&&be.walkTokens(Z,ge.walkTokens),je=ae.parse(Z,ge)}catch(j){Ae=j}return ge.highlight=K,Ae?ce(Ae):ce(null,je)};if(!K||K.length<3||(delete ge.highlight,!Z.length))return le();var fe=0;be.walkTokens(Z,function(Ie){Ie.type==="code"&&(fe++,setTimeout(function(){K(Ie.text,Ie.lang,function(Ae,je){if(Ae)return le(Ae);je!=null&&je!==Ie.text&&(Ie.text=je,Ie.escaped=!0),fe--,fe===0&&le()})},0))}),fe===0&&le();return}function Te(Ie){if(Ie.message+=`
Please report this to https://github.com/markedjs/marked.`,ge.silent)return"<p>An error occurred:</p><pre>"+$(Ie.message+"",!0)+"</pre>";throw Ie}try{var ve=X.lex(we,ge);if(ge.walkTokens){if(ge.async)return Promise.all(be.walkTokens(ve,ge.walkTokens)).then(function(){return ae.parse(ve,ge)}).catch(Te);be.walkTokens(ve,ge.walkTokens)}return ae.parse(ve,ge)}catch(Ie){Te(Ie)}}be.options=be.setOptions=function(we){return u(be.defaults,we),m(be.defaults),be},be.getDefaults=A,be.defaults=ee.defaults,be.use=function(){for(var we=arguments.length,ge=new Array(we),ce=0;ce<we;ce++)ge[ce]=arguments[ce];var K=u.apply(void 0,[{}].concat(ge)),Z=be.defaults.extensions||{renderers:{},childTokens:{}},le;ge.forEach(function(fe){if(fe.extensions&&(le=!0,fe.extensions.forEach(function(ve){if(!ve.name)throw new Error("extension name required");if(ve.renderer){var Ie=Z.renderers?Z.renderers[ve.name]:null;Ie?Z.renderers[ve.name]=function(){for(var Ae=arguments.length,je=new Array(Ae),j=0;j<Ae;j++)je[j]=arguments[j];var B=ve.renderer.apply(this,je);return B===!1&&(B=Ie.apply(this,je)),B}:Z.renderers[ve.name]=ve.renderer}if(ve.tokenizer){if(!ve.level||ve.level!=="block"&&ve.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");Z[ve.level]?Z[ve.level].unshift(ve.tokenizer):Z[ve.level]=[ve.tokenizer],ve.start&&(ve.level==="block"?Z.startBlock?Z.startBlock.push(ve.start):Z.startBlock=[ve.start]:ve.level==="inline"&&(Z.startInline?Z.startInline.push(ve.start):Z.startInline=[ve.start]))}ve.childTokens&&(Z.childTokens[ve.name]=ve.childTokens)})),fe.renderer&&function(){var ve=be.defaults.renderer||new re,Ie=function(j){var B=ve[j];ve[j]=function(){for(var G=arguments.length,W=new Array(G),_=0;_<G;_++)W[_]=arguments[_];var oe=fe.renderer[j].apply(ve,W);return oe===!1&&(oe=B.apply(ve,W)),oe}};for(var Ae in fe.renderer)Ie(Ae);K.renderer=ve}(),fe.tokenizer&&function(){var ve=be.defaults.tokenizer||new H,Ie=function(j){var B=ve[j];ve[j]=function(){for(var G=arguments.length,W=new Array(G),_=0;_<G;_++)W[_]=arguments[_];var oe=fe.tokenizer[j].apply(ve,W);return oe===!1&&(oe=B.apply(ve,W)),oe}};for(var Ae in fe.tokenizer)Ie(Ae);K.tokenizer=ve}(),fe.walkTokens){var Te=be.defaults.walkTokens;K.walkTokens=function(ve){var Ie=[];return Ie.push(fe.walkTokens.call(this,ve)),Te&&(Ie=Ie.concat(Te.call(this,ve))),Ie}}le&&(K.extensions=Z),be.setOptions(K)})},be.walkTokens=function(we,ge){for(var ce=[],K=function(){var Te=le.value;switch(ce=ce.concat(ge.call(be,Te)),Te.type){case"table":{for(var ve=N(Te.header),Ie;!(Ie=ve()).done;){var Ae=Ie.value;ce=ce.concat(be.walkTokens(Ae.tokens,ge))}for(var je=N(Te.rows),j;!(j=je()).done;)for(var B=j.value,G=N(B),W;!(W=G()).done;){var _=W.value;ce=ce.concat(be.walkTokens(_.tokens,ge))}break}case"list":{ce=ce.concat(be.walkTokens(Te.items,ge));break}default:be.defaults.extensions&&be.defaults.extensions.childTokens&&be.defaults.extensions.childTokens[Te.type]?be.defaults.extensions.childTokens[Te.type].forEach(function(oe){ce=ce.concat(be.walkTokens(Te[oe],ge))}):Te.tokens&&(ce=ce.concat(be.walkTokens(Te.tokens,ge)))}},Z=N(we),le;!(le=Z()).done;)K();return ce},be.parseInline=function(we,ge){if(typeof we>"u"||we===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof we!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(we)+", string expected");ge=u({},be.defaults,ge||{}),S(ge);try{var ce=X.lexInline(we,ge);return ge.walkTokens&&be.walkTokens(ce,ge.walkTokens),ae.parseInline(ce,ge)}catch(K){if(K.message+=`
Please report this to https://github.com/markedjs/marked.`,ge.silent)return"<p>An error occurred:</p><pre>"+$(K.message+"",!0)+"</pre>";throw K}},be.Parser=ae,be.parser=ae.parse,be.Renderer=re,be.TextRenderer=me,be.Lexer=X,be.lexer=X.lex,be.Tokenizer=H,be.Slugger=pe,be.parse=be;var se=be.options,De=be.setOptions,Oe=be.use,ie=be.walkTokens,q=be.parseInline,de=be,Ne=ae.parse,$e=X.lex;ee.Lexer=X,ee.Parser=ae,ee.Renderer=re,ee.Slugger=pe,ee.TextRenderer=me,ee.Tokenizer=H,ee.getDefaults=A,ee.lexer=$e,ee.marked=be,ee.options=se,ee.parse=de,ee.parseInline=q,ee.parser=Ne,ee.setOptions=De,ee.use=Oe,ee.walkTokens=ie,Object.defineProperty(ee,"__esModule",{value:!0})}),define(Pe[125],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hk=k;function k(n){const o=N(n);if(o&&o.length>0)return new Uint32Array(o)}let M=0;const C=new Uint32Array(10);function N(n){if(M=0,A(n,D,4352),M>0||(A(n,l,4449),M>0)||(A(n,b,4520),M>0)||(A(n,$,12593),M))return C.subarray(0,M);if(n>=44032&&n<=55203){const o=n-44032,s=o%588,r=Math.floor(o/588),i=Math.floor(s/28),c=s%28-1;if(r<D.length?A(r,D,0):4352+r-12593<$.length&&A(4352+r,$,12593),i<l.length?A(i,l,0):4449+i-12593<$.length&&A(4449+i-12593,$,12593),c>=0&&(c<b.length?A(c,b,0):4520+c-12593<$.length&&A(4520+c-12593,$,12593)),M>0)return C.subarray(0,M)}}function A(n,o,s){n>=s&&n<s+o.length&&m(o[n-s])}function m(n){n!==0&&(C[M++]=n&255,n>>8&&(C[M++]=n>>8&255),n>>16&&(C[M++]=n>>16&255))}var d;(function(n){n[n.InitialConsonant=4352]="InitialConsonant",n[n.Vowel=4449]="Vowel",n[n.FinalConsonant=4520]="FinalConsonant",n[n.CompatibilityJamo=12593]="CompatibilityJamo"})(d||(d={}));var y;(function(n){n[n.NUL=0]="NUL",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z"})(y||(y={}));var O;(function(n){n[n.fa=24934]="fa",n[n.fg=26470]="fg",n[n.fq=29030]="fq",n[n.fr=29286]="fr",n[n.ft=29798]="ft",n[n.fv=30310]="fv",n[n.fx=30822]="fx",n[n.hk=27496]="hk",n[n.hl=27752]="hl",n[n.ho=28520]="ho",n[n.ml=27757]="ml",n[n.nj=27246]="nj",n[n.nl=27758]="nl",n[n.np=28782]="np",n[n.qt=29809]="qt",n[n.rt=29810]="rt",n[n.sg=26483]="sg",n[n.sw=30579]="sw"})(O||(O={}));const D=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),l=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),b=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),$=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(Pe[126],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=e.$rm=e.$qm=void 0,e.$om=k,e.rot=M;function k(m,d,y){return Math.min(Math.max(m,d),y)}function M(m,d){return(d+m%d)%d}class C{constructor(){this.a=0}getNext(){return this.a++}}e.$qm=C;class N{constructor(){this.a=1,this.b=0}update(d){return this.b=this.b+(d-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$rm=N;class A{constructor(d){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(d),this.c.fill(0,0,d)}update(d){const y=this.c[this.d];return this.c[this.d]=d,this.d=(this.d+1)%this.c.length,this.e-=y,this.e+=d,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$sm=A}),function(){function ee(C){const N=[];typeof C=="number"&&N.push("code/timeOrigin",C);function A(d){N.push(d,Date.now())}function m(){const d=[];for(let y=0;y<N.length;y+=2)d.push({name:N[y],startTime:N[y+1]});return d}return{mark:A,getMarks:m}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ee():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const N=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const A of performance.getEntriesByType("mark"))N.push({name:A.name,startTime:Math.round(C+A.startTime)});return N}};if(typeof process=="object"){const C=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ee(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),ee()}function k(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var M;typeof global=="object"?M=global:typeof self=="object"?M=self:M={},typeof define=="function"?define("vs/base/common/performance",[],function(){return k(M)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=k(M):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),M.perf=k(M))}(),define(Pe[127],Re([1,0,39]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DO=void 0;const M=Symbol("unset");class C{constructor(){this.a=new A,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||k.Iterable.empty()}insert(d,y,O){this.d(d,D=>D._value=y,O)}mutate(d,y){this.d(d,O=>O._value=y(O._value===M?void 0:O._value))}delete(d){const y=this.c(d);if(!y)return;let O=y.length-1;const D=y[O].node._value;if(D!==M){for(this.b--,y[O].node._value=M;O>0;O--){const{node:l,part:b}=y[O];if(l.children?.size||l._value!==M)break;y[O-1].node.children.delete(b)}return D}}*deleteRecursive(d){const y=this.c(d);if(!y)return;const O=y[y.length-1].node;for(let D=y.length-1;D>0;D--){const l=y[D-1];if(l.node.children.delete(y[D].part),l.node.children.size>0||l.node._value!==M)break}for(const D of N(O))D._value!==M&&(this.b--,yield D._value)}find(d){let y=this.a;for(const O of d){const D=y.children?.get(O);if(!D)return;y=D}return y._value===M?void 0:y._value}hasKeyOrParent(d){let y=this.a;for(const O of d){const D=y.children?.get(O);if(!D)return!1;if(D._value!==M)return!0;y=D}return!1}hasKeyOrChildren(d){let y=this.a;for(const O of d){const D=y.children?.get(O);if(!D)return!1;y=D}return!0}hasKey(d){let y=this.a;for(const O of d){const D=y.children?.get(O);if(!D)return!1;y=D}return y._value!==M}c(d){const y=[{part:"",node:this.a}];let O=0;for(const D of d){const l=y[O].node.children?.get(D);if(!l)return;y.push({part:D,node:l}),O++}return y}d(d,y,O){let D=this.a;for(const $ of d){if(D.children)if(D.children.has($))D=D.children.get($);else{const n=new A;D.children.set($,n),D=n}else{const n=new A;D.children=new Map([[$,n]]),D=n}O?.(D)}const l=D._value===M?0:1;y(D);const b=D._value===M?0:1;this.b+=b-l}*values(){for(const{_value:d}of N(this.a))d!==M&&(yield d)}}e.$DO=C;function*N(m){const d=[m];for(;d.length>0;){const y=d.pop();if(yield y,y.children)for(const O of y.children.values())d.push(O)}}class A{constructor(){this._value=M}get value(){return this._value===M?void 0:this._value}set value(d){this._value=d===void 0?M:d}}}),define(Pe[128],Re([1,0,40,19]),function(ee,e,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4q=m,e.$5q=d,e.$6q=y,e.$7q=O,e.$8q=D,e.$9q=l,e.$0q=b,e.$$q=$,e.$_q=n,e.$ar=o,e.$br=v,e.$cr=f,e.$dr=u;const C=new k.$V(()=>{const E=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:E,collatorIsNumeric:E.resolvedOptions().numeric}}),N=new k.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new k.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function m(E,w,I=!1){const S=E||"",P=w||"",U=C.value.collator.compare(S,P);return C.value.collatorIsNumeric&&U===0&&S!==P?S<P?-1:1:U}function d(E,w){const I=N.value.collator;return E=E||"",w=w||"",c(I,E,w)}function y(E,w){const I=N.value.collator;return E=E||"",w=w||"",a(E,w)||c(I,E,w)}function O(E,w){const I=N.value.collator;return E=E||"",w=w||"",p(E,w)||c(I,E,w)}function D(E,w){return E=E||"",w=w||"",E===w?0:E<w?-1:1}function l(E,w){const[I,S]=r(E),[P,U]=r(w);let Q=C.value.collator.compare(S,U);if(Q===0){if(C.value.collatorIsNumeric&&S!==U)return S<U?-1:1;if(Q=C.value.collator.compare(I,P),C.value.collatorIsNumeric&&Q===0&&I!==P)return I<P?-1:1}return Q}function b(E,w){E=E||"",w=w||"";const I=i(E),S=i(w),P=N.value.collator,U=A.value.collator;return c(U,I,S)||c(P,E,w)}function $(E,w){E=E||"",w=w||"";const I=i(E),S=i(w),P=N.value.collator,U=A.value.collator;return c(U,I,S)||a(E,w)||c(P,E,w)}function n(E,w){E=E||"",w=w||"";const I=i(E),S=i(w),P=N.value.collator,U=A.value.collator;return c(U,I,S)||p(E,w)||c(P,E,w)}function o(E,w){E=E||"",w=w||"";const I=i(E).toLowerCase(),S=i(w).toLowerCase();return I!==S?I<S?-1:1:E!==w?E<w?-1:1:0}const s=/^(.*?)(\.([^.]*))?$/;function r(E,w=!1){const I=E?s.exec(E):[];let S=[I&&I[1]||"",I&&I[3]||""];return w&&(!S[0]&&S[1]||S[0]&&S[0].charAt(0)===".")&&(S=[S[0]+"."+S[1],""]),S}function i(E){const w=E?s.exec(E):[];return w&&w[1]&&w[1].charAt(0)!=="."&&w[3]||""}function c(E,w,I){const S=E.compare(w,I);return S!==0?S:w.length!==I.length?w.length<I.length?-1:1:0}function h(E){const w=E.charAt(0);return w.toLocaleUpperCase()!==w}function t(E){const w=E.charAt(0);return w.toLocaleLowerCase()!==w}function p(E,w){return h(E)&&t(w)?-1:t(E)&&h(w)?1:0}function a(E,w){return t(E)&&h(w)?-1:h(E)&&t(w)?1:0}function g(E,w,I=!1){return I||(E=E&&E.toLowerCase(),w=w&&w.toLowerCase()),E===w?0:E<w?-1:1}function v(E,w,I=!1){const S=E.split(M.sep),P=w.split(M.sep),U=S.length-1,Q=P.length-1;let H,L;for(let R=0;;R++){if(H=U===R,L=Q===R,H&&L)return m(S[R],P[R],I);if(H)return-1;if(L)return 1;const F=g(S[R],P[R],I);if(F!==0)return F}}function f(E,w,I){const S=E.toLowerCase(),P=w.toLowerCase(),U=u(E,w,I);if(U)return U;const Q=S.endsWith(I),H=P.endsWith(I);if(Q!==H)return Q?-1:1;const L=m(S,P);return L!==0?L:S.localeCompare(P)}function u(E,w,I){const S=E.toLowerCase(),P=w.toLowerCase(),U=S.startsWith(I),Q=P.startsWith(I);if(U!==Q)return U?-1:1;if(U&&Q){if(S.length<P.length)return-1;if(S.length>P.length)return 1}return 0}}),define(Pe[69],Re([1,0,19]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$As=void 0,e.$Bs=N,e.$Cs=A,e.$Ds=m,e.$Es=y,e.$As=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const M={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},C={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function N(O){const D=(0,k.$pc)(O),l=M[D.toLowerCase()];return l!==void 0?l:A(O)}function A(O){const D=(0,k.$pc)(O);return C[D.toLowerCase()]}function m(O){for(const D in C)if(C[D]===O)return D}const d=/^(.+)\/(.+?)(;.+)?$/;function y(O,D){const l=d.exec(O);return l?`${l[1].toLowerCase()}/${l[2].toLowerCase()}${l[3]??""}`:D?void 0:O}}),function(ee,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var k=e();for(var M in k)(typeof exports=="object"?exports:ee)[M]=k[M]}}(typeof self<"u"?self:this,function(){return function(ee){var e={};function k(M){if(e[M])return e[M].exports;var C=e[M]={i:M,l:!1,exports:{}};return ee[M].call(C.exports,C,C.exports,k),C.l=!0,C.exports}return k.m=ee,k.c=e,k.d=function(M,C,N){k.o(M,C)||Object.defineProperty(M,C,{enumerable:!0,get:N})},k.r=function(M){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(M,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(M,"__esModule",{value:!0})},k.t=function(M,C){if(1&C&&(M=k(M)),8&C||4&C&&typeof M=="object"&&M&&M.__esModule)return M;var N=Object.create(null);if(k.r(N),Object.defineProperty(N,"default",{enumerable:!0,value:M}),2&C&&typeof M!="string")for(var A in M)k.d(N,A,function(m){return M[m]}.bind(null,A));return N},k.n=function(M){var C=M&&M.__esModule?function(){return M.default}:function(){return M};return k.d(C,"a",C),C},k.o=function(M,C){return Object.prototype.hasOwnProperty.call(M,C)},k.p="",k(k.s=0)}([function(ee,e,k){(function(M){var C;e=ee.exports=Oe,C=typeof M=="object"&&M.env&&M.env.NODE_DEBUG&&/\bsemver\b/i.test(M.env.NODE_DEBUG)?function(){var B=Array.prototype.slice.call(arguments,0);B.unshift("SEMVER"),console.log.apply(console,B)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var N=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,m=e.re=[],d=e.src=[],y=0,O=y++;d[O]="0|[1-9]\\d*";var D=y++;d[D]="[0-9]+";var l=y++;d[l]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var b=y++;d[b]="("+d[O]+")\\.("+d[O]+")\\.("+d[O]+")";var $=y++;d[$]="("+d[D]+")\\.("+d[D]+")\\.("+d[D]+")";var n=y++;d[n]="(?:"+d[O]+"|"+d[l]+")";var o=y++;d[o]="(?:"+d[D]+"|"+d[l]+")";var s=y++;d[s]="(?:-("+d[n]+"(?:\\."+d[n]+")*))";var r=y++;d[r]="(?:-?("+d[o]+"(?:\\."+d[o]+")*))";var i=y++;d[i]="[0-9A-Za-z-]+";var c=y++;d[c]="(?:\\+("+d[i]+"(?:\\."+d[i]+")*))";var h=y++,t="v?"+d[b]+d[s]+"?"+d[c]+"?";d[h]="^"+t+"$";var p="[v=\\s]*"+d[$]+d[r]+"?"+d[c]+"?",a=y++;d[a]="^"+p+"$";var g=y++;d[g]="((?:<|>)?=?)";var v=y++;d[v]=d[D]+"|x|X|\\*";var f=y++;d[f]=d[O]+"|x|X|\\*";var u=y++;d[u]="[v=\\s]*("+d[f]+")(?:\\.("+d[f]+")(?:\\.("+d[f]+")(?:"+d[s]+")?"+d[c]+"?)?)?";var E=y++;d[E]="[v=\\s]*("+d[v]+")(?:\\.("+d[v]+")(?:\\.("+d[v]+")(?:"+d[r]+")?"+d[c]+"?)?)?";var w=y++;d[w]="^"+d[g]+"\\s*"+d[u]+"$";var I=y++;d[I]="^"+d[g]+"\\s*"+d[E]+"$";var S=y++;d[S]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var P=y++;d[P]="(?:~>?)";var U=y++;d[U]="(\\s*)"+d[P]+"\\s+",m[U]=new RegExp(d[U],"g");var Q=y++;d[Q]="^"+d[P]+d[u]+"$";var H=y++;d[H]="^"+d[P]+d[E]+"$";var L=y++;d[L]="(?:\\^)";var R=y++;d[R]="(\\s*)"+d[L]+"\\s+",m[R]=new RegExp(d[R],"g");var F=y++;d[F]="^"+d[L]+d[u]+"$";var T=y++;d[T]="^"+d[L]+d[E]+"$";var X=y++;d[X]="^"+d[g]+"\\s*("+p+")$|^$";var re=y++;d[re]="^"+d[g]+"\\s*("+t+")$|^$";var me=y++;d[me]="(\\s*)"+d[g]+"\\s*("+p+"|"+d[u]+")",m[me]=new RegExp(d[me],"g");var pe=y++;d[pe]="^\\s*("+d[u]+")\\s+-\\s+("+d[u]+")\\s*$";var ae=y++;d[ae]="^\\s*("+d[E]+")\\s+-\\s+("+d[E]+")\\s*$";var be=y++;d[be]="(<|>)?=?\\s*\\*";for(var se=0;se<35;se++)C(se,d[se]),m[se]||(m[se]=new RegExp(d[se]));function De(B,G){if(B instanceof Oe)return B;if(typeof B!="string"||B.length>N||!(G?m[a]:m[h]).test(B))return null;try{return new Oe(B,G)}catch{return null}}function Oe(B,G){if(B instanceof Oe){if(B.loose===G)return B;B=B.version}else if(typeof B!="string")throw new TypeError("Invalid Version: "+B);if(B.length>N)throw new TypeError("version is longer than "+N+" characters");if(!(this instanceof Oe))return new Oe(B,G);C("SemVer",B,G),this.loose=G;var W=B.trim().match(G?m[a]:m[h]);if(!W)throw new TypeError("Invalid Version: "+B);if(this.raw=B,this.major=+W[1],this.minor=+W[2],this.patch=+W[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");W[4]?this.prerelease=W[4].split(".").map(function(_){if(/^[0-9]+$/.test(_)){var oe=+_;if(oe>=0&&oe<A)return oe}return _}):this.prerelease=[],this.build=W[5]?W[5].split("."):[],this.format()}e.parse=De,e.valid=function(B,G){var W=De(B,G);return W?W.version:null},e.clean=function(B,G){var W=De(B.trim().replace(/^[=v]+/,""),G);return W?W.version:null},e.SemVer=Oe,Oe.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Oe.prototype.toString=function(){return this.version},Oe.prototype.compare=function(B){return C("SemVer.compare",this.version,this.loose,B),B instanceof Oe||(B=new Oe(B,this.loose)),this.compareMain(B)||this.comparePre(B)},Oe.prototype.compareMain=function(B){return B instanceof Oe||(B=new Oe(B,this.loose)),q(this.major,B.major)||q(this.minor,B.minor)||q(this.patch,B.patch)},Oe.prototype.comparePre=function(B){if(B instanceof Oe||(B=new Oe(B,this.loose)),this.prerelease.length&&!B.prerelease.length)return-1;if(!this.prerelease.length&&B.prerelease.length)return 1;if(!this.prerelease.length&&!B.prerelease.length)return 0;var G=0;do{var W=this.prerelease[G],_=B.prerelease[G];if(C("prerelease compare",G,W,_),W===void 0&&_===void 0)return 0;if(_===void 0)return 1;if(W===void 0)return-1;if(W!==_)return q(W,_)}while(++G)},Oe.prototype.inc=function(B,G){switch(B){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",G);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",G);break;case"prepatch":this.prerelease.length=0,this.inc("patch",G),this.inc("pre",G);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",G),this.inc("pre",G);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var W=this.prerelease.length;--W>=0;)typeof this.prerelease[W]=="number"&&(this.prerelease[W]++,W=-2);W===-1&&this.prerelease.push(0)}G&&(this.prerelease[0]===G?isNaN(this.prerelease[1])&&(this.prerelease=[G,0]):this.prerelease=[G,0]);break;default:throw new Error("invalid increment argument: "+B)}return this.format(),this.raw=this.version,this},e.inc=function(B,G,W,_){typeof W=="string"&&(_=W,W=void 0);try{return new Oe(B,W).inc(G,_).version}catch{return null}},e.diff=function(B,G){if(we(B,G))return null;var W=De(B),_=De(G);if(W.prerelease.length||_.prerelease.length){for(var oe in W)if((oe==="major"||oe==="minor"||oe==="patch")&&W[oe]!==_[oe])return"pre"+oe;return"prerelease"}for(var oe in W)if((oe==="major"||oe==="minor"||oe==="patch")&&W[oe]!==_[oe])return oe},e.compareIdentifiers=q;var ie=/^[0-9]+$/;function q(B,G){var W=ie.test(B),_=ie.test(G);return W&&_&&(B=+B,G=+G),W&&!_?-1:_&&!W?1:B<G?-1:B>G?1:0}function de(B,G,W){return new Oe(B,W).compare(new Oe(G,W))}function Ne(B,G,W){return de(B,G,W)>0}function $e(B,G,W){return de(B,G,W)<0}function we(B,G,W){return de(B,G,W)===0}function ge(B,G,W){return de(B,G,W)!==0}function ce(B,G,W){return de(B,G,W)>=0}function K(B,G,W){return de(B,G,W)<=0}function Z(B,G,W,_){var oe;switch(G){case"===":typeof B=="object"&&(B=B.version),typeof W=="object"&&(W=W.version),oe=B===W;break;case"!==":typeof B=="object"&&(B=B.version),typeof W=="object"&&(W=W.version),oe=B!==W;break;case"":case"=":case"==":oe=we(B,W,_);break;case"!=":oe=ge(B,W,_);break;case">":oe=Ne(B,W,_);break;case">=":oe=ce(B,W,_);break;case"<":oe=$e(B,W,_);break;case"<=":oe=K(B,W,_);break;default:throw new TypeError("Invalid operator: "+G)}return oe}function le(B,G){if(B instanceof le){if(B.loose===G)return B;B=B.value}if(!(this instanceof le))return new le(B,G);C("comparator",B,G),this.loose=G,this.parse(B),this.semver===fe?this.value="":this.value=this.operator+this.semver.version,C("comp",this)}e.rcompareIdentifiers=function(B,G){return q(G,B)},e.major=function(B,G){return new Oe(B,G).major},e.minor=function(B,G){return new Oe(B,G).minor},e.patch=function(B,G){return new Oe(B,G).patch},e.compare=de,e.compareLoose=function(B,G){return de(B,G,!0)},e.rcompare=function(B,G,W){return de(G,B,W)},e.sort=function(B,G){return B.sort(function(W,_){return e.compare(W,_,G)})},e.rsort=function(B,G){return B.sort(function(W,_){return e.rcompare(W,_,G)})},e.gt=Ne,e.lt=$e,e.eq=we,e.neq=ge,e.gte=ce,e.lte=K,e.cmp=Z,e.Comparator=le;var fe={};function Te(B,G){if(B instanceof Te)return B.loose===G?B:new Te(B.raw,G);if(B instanceof le)return new Te(B.value,G);if(!(this instanceof Te))return new Te(B,G);if(this.loose=G,this.raw=B,this.set=B.split(/\s*\|\|\s*/).map(function(W){return this.parseRange(W.trim())},this).filter(function(W){return W.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+B);this.format()}function ve(B){return!B||B.toLowerCase()==="x"||B==="*"}function Ie(B,G,W,_,oe,Fe,Be,Qe,et,it,ut,st,rt){return((G=ve(W)?"":ve(_)?">="+W+".0.0":ve(oe)?">="+W+"."+_+".0":">="+G)+" "+(Qe=ve(et)?"":ve(it)?"<"+(+et+1)+".0.0":ve(ut)?"<"+et+"."+(+it+1)+".0":st?"<="+et+"."+it+"."+ut+"-"+st:"<="+Qe)).trim()}function Ae(B,G){for(var W=0;W<B.length;W++)if(!B[W].test(G))return!1;if(G.prerelease.length){for(W=0;W<B.length;W++)if(C(B[W].semver),B[W].semver!==fe&&B[W].semver.prerelease.length>0){var _=B[W].semver;if(_.major===G.major&&_.minor===G.minor&&_.patch===G.patch)return!0}return!1}return!0}function je(B,G,W){try{G=new Te(G,W)}catch{return!1}return G.test(B)}function j(B,G,W,_){var oe,Fe,Be,Qe,et;switch(B=new Oe(B,_),G=new Te(G,_),W){case">":oe=Ne,Fe=K,Be=$e,Qe=">",et=">=";break;case"<":oe=$e,Fe=ce,Be=Ne,Qe="<",et="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(je(B,G,_))return!1;for(var it=0;it<G.set.length;++it){var ut=G.set[it],st=null,rt=null;if(ut.forEach(function(ot){ot.semver===fe&&(ot=new le(">=0.0.0")),st=st||ot,rt=rt||ot,oe(ot.semver,st.semver,_)?st=ot:Be(ot.semver,rt.semver,_)&&(rt=ot)}),st.operator===Qe||st.operator===et||(!rt.operator||rt.operator===Qe)&&Fe(B,rt.semver)||rt.operator===et&&Be(B,rt.semver))return!1}return!0}le.prototype.parse=function(B){var G=this.loose?m[X]:m[re],W=B.match(G);if(!W)throw new TypeError("Invalid comparator: "+B);this.operator=W[1],this.operator==="="&&(this.operator=""),W[2]?this.semver=new Oe(W[2],this.loose):this.semver=fe},le.prototype.toString=function(){return this.value},le.prototype.test=function(B){return C("Comparator.test",B,this.loose),this.semver===fe||(typeof B=="string"&&(B=new Oe(B,this.loose)),Z(B,this.operator,this.semver,this.loose))},le.prototype.intersects=function(B,G){if(!(B instanceof le))throw new TypeError("a Comparator is required");var W;if(this.operator==="")return W=new Te(B.value,G),je(this.value,W,G);if(B.operator==="")return W=new Te(this.value,G),je(B.semver,W,G);var _=!(this.operator!==">="&&this.operator!==">"||B.operator!==">="&&B.operator!==">"),oe=!(this.operator!=="<="&&this.operator!=="<"||B.operator!=="<="&&B.operator!=="<"),Fe=this.semver.version===B.semver.version,Be=!(this.operator!==">="&&this.operator!=="<="||B.operator!==">="&&B.operator!=="<="),Qe=Z(this.semver,"<",B.semver,G)&&(this.operator===">="||this.operator===">")&&(B.operator==="<="||B.operator==="<"),et=Z(this.semver,">",B.semver,G)&&(this.operator==="<="||this.operator==="<")&&(B.operator===">="||B.operator===">");return _||oe||Fe&&Be||Qe||et},e.Range=Te,Te.prototype.format=function(){return this.range=this.set.map(function(B){return B.join(" ").trim()}).join("||").trim(),this.range},Te.prototype.toString=function(){return this.range},Te.prototype.parseRange=function(B){var G=this.loose;B=B.trim(),C("range",B,G);var W=G?m[ae]:m[pe];B=B.replace(W,Ie),C("hyphen replace",B),B=B.replace(m[me],"$1$2$3"),C("comparator trim",B,m[me]),B=(B=(B=B.replace(m[U],"$1~")).replace(m[R],"$1^")).split(/\s+/).join(" ");var _=G?m[X]:m[re],oe=B.split(" ").map(function(Fe){return function(Be,Qe){return C("comp",Be),Be=function(et,it){return et.trim().split(/\s+/).map(function(ut){return function(st,rt){C("caret",st,rt);var ot=rt?m[T]:m[F];return st.replace(ot,function($t,Ue,ct,x,Y){var ye;return C("caret",st,$t,Ue,ct,x,Y),ve(Ue)?ye="":ve(ct)?ye=">="+Ue+".0.0 <"+(+Ue+1)+".0.0":ve(x)?ye=Ue==="0"?">="+Ue+"."+ct+".0 <"+Ue+"."+(+ct+1)+".0":">="+Ue+"."+ct+".0 <"+(+Ue+1)+".0.0":Y?(C("replaceCaret pr",Y),Y.charAt(0)!=="-"&&(Y="-"+Y),ye=Ue==="0"?ct==="0"?">="+Ue+"."+ct+"."+x+Y+" <"+Ue+"."+ct+"."+(+x+1):">="+Ue+"."+ct+"."+x+Y+" <"+Ue+"."+(+ct+1)+".0":">="+Ue+"."+ct+"."+x+Y+" <"+(+Ue+1)+".0.0"):(C("no pr"),ye=Ue==="0"?ct==="0"?">="+Ue+"."+ct+"."+x+" <"+Ue+"."+ct+"."+(+x+1):">="+Ue+"."+ct+"."+x+" <"+Ue+"."+(+ct+1)+".0":">="+Ue+"."+ct+"."+x+" <"+(+Ue+1)+".0.0"),C("caret return",ye),ye})}(ut,it)}).join(" ")}(Be,Qe),C("caret",Be),Be=function(et,it){return et.trim().split(/\s+/).map(function(ut){return function(st,rt){var ot=rt?m[H]:m[Q];return st.replace(ot,function($t,Ue,ct,x,Y){var ye;return C("tilde",st,$t,Ue,ct,x,Y),ve(Ue)?ye="":ve(ct)?ye=">="+Ue+".0.0 <"+(+Ue+1)+".0.0":ve(x)?ye=">="+Ue+"."+ct+".0 <"+Ue+"."+(+ct+1)+".0":Y?(C("replaceTilde pr",Y),Y.charAt(0)!=="-"&&(Y="-"+Y),ye=">="+Ue+"."+ct+"."+x+Y+" <"+Ue+"."+(+ct+1)+".0"):ye=">="+Ue+"."+ct+"."+x+" <"+Ue+"."+(+ct+1)+".0",C("tilde return",ye),ye})}(ut,it)}).join(" ")}(Be,Qe),C("tildes",Be),Be=function(et,it){return C("replaceXRanges",et,it),et.split(/\s+/).map(function(ut){return function(st,rt){st=st.trim();var ot=rt?m[I]:m[w];return st.replace(ot,function($t,Ue,ct,x,Y,ye){C("xRange",st,$t,Ue,ct,x,Y,ye);var He=ve(ct),Ye=He||ve(x),Me=Ye||ve(Y);return Ue==="="&&Me&&(Ue=""),He?$t=Ue===">"||Ue==="<"?"<0.0.0":"*":Ue&&Me?(Ye&&(x=0),Me&&(Y=0),Ue===">"?(Ue=">=",Ye?(ct=+ct+1,x=0,Y=0):Me&&(x=+x+1,Y=0)):Ue==="<="&&(Ue="<",Ye?ct=+ct+1:x=+x+1),$t=Ue+ct+"."+x+"."+Y):Ye?$t=">="+ct+".0.0 <"+(+ct+1)+".0.0":Me&&($t=">="+ct+"."+x+".0 <"+ct+"."+(+x+1)+".0"),C("xRange return",$t),$t})}(ut,it)}).join(" ")}(Be,Qe),C("xrange",Be),Be=function(et,it){return C("replaceStars",et,it),et.trim().replace(m[be],"")}(Be,Qe),C("stars",Be),Be}(Fe,G)}).join(" ").split(/\s+/);return this.loose&&(oe=oe.filter(function(Fe){return!!Fe.match(_)})),oe=oe.map(function(Fe){return new le(Fe,G)})},Te.prototype.intersects=function(B,G){if(!(B instanceof Te))throw new TypeError("a Range is required");return this.set.some(function(W){return W.every(function(_){return B.set.some(function(oe){return oe.every(function(Fe){return _.intersects(Fe,G)})})})})},e.toComparators=function(B,G){return new Te(B,G).set.map(function(W){return W.map(function(_){return _.value}).join(" ").trim().split(" ")})},Te.prototype.test=function(B){if(!B)return!1;typeof B=="string"&&(B=new Oe(B,this.loose));for(var G=0;G<this.set.length;G++)if(Ae(this.set[G],B))return!0;return!1},e.satisfies=je,e.maxSatisfying=function(B,G,W){var _=null,oe=null;try{var Fe=new Te(G,W)}catch{return null}return B.forEach(function(Be){Fe.test(Be)&&(_&&oe.compare(Be)!==-1||(oe=new Oe(_=Be,W)))}),_},e.minSatisfying=function(B,G,W){var _=null,oe=null;try{var Fe=new Te(G,W)}catch{return null}return B.forEach(function(Be){Fe.test(Be)&&(_&&oe.compare(Be)!==1||(oe=new Oe(_=Be,W)))}),_},e.validRange=function(B,G){try{return new Te(B,G).range||"*"}catch{return null}},e.ltr=function(B,G,W){return j(B,G,"<",W)},e.gtr=function(B,G,W){return j(B,G,">",W)},e.outside=j,e.prerelease=function(B,G){var W=De(B,G);return W&&W.prerelease.length?W.prerelease:null},e.intersects=function(B,G,W){return B=new Te(B,W),G=new Te(G,W),B.intersects(G)},e.coerce=function(B){if(B instanceof Oe)return B;if(typeof B!="string")return null;var G=B.match(m[S]);return G==null?null:De((G[1]||"0")+"."+(G[2]||"0")+"."+(G[3]||"0"))}}).call(this,k(1))},function(ee,e){var k,M,C=ee.exports={};function N(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function m(o){if(k===setTimeout)return setTimeout(o,0);if((k===N||!k)&&setTimeout)return k=setTimeout,setTimeout(o,0);try{return k(o,0)}catch{try{return k.call(null,o,0)}catch{return k.call(this,o,0)}}}(function(){try{k=typeof setTimeout=="function"?setTimeout:N}catch{k=N}try{M=typeof clearTimeout=="function"?clearTimeout:A}catch{M=A}})();var d,y=[],O=!1,D=-1;function l(){O&&d&&(O=!1,d.length?y=d.concat(y):D=-1,y.length&&b())}function b(){if(!O){var o=m(l);O=!0;for(var s=y.length;s;){for(d=y,y=[];++D<s;)d&&d[D].run();D=-1,s=y.length}d=null,O=!1,function(r){if(M===clearTimeout)return clearTimeout(r);if((M===A||!M)&&clearTimeout)return M=clearTimeout,clearTimeout(r);try{M(r)}catch{try{return M.call(null,r)}catch{return M.call(this,r)}}}(o)}}function $(o,s){this.fun=o,this.array=s}function n(){}C.nextTick=function(o){var s=new Array(arguments.length-1);if(arguments.length>1)for(var r=1;r<arguments.length;r++)s[r-1]=arguments[r];y.push(new $(o,s)),y.length!==1||O||m(b)},$.prototype.run=function(){this.fun.apply(null,this.array)},C.title="browser",C.browser=!0,C.env={},C.argv=[],C.version="",C.versions={},C.on=n,C.addListener=n,C.once=n,C.off=n,C.removeListener=n,C.removeAllListeners=n,C.emit=n,C.prependListener=n,C.prependOnceListener=n,C.listeners=function(o){return[]},C.binding=function(o){throw new Error("process.binding is not supported")},C.cwd=function(){return"/"},C.chdir=function(o){throw new Error("process.chdir is not supported")},C.umask=function(){return 0}}])}),define(Pe[129],Re([1,0,14,6]),function(ee,e,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fe=C,e.$ge=N,e.$he=A,e.$ie=m,e.$je=y,e.$ke=O,e.$le=D,e.$me=l,e.$ne=b,e.$oe=$,e.$pe=n,e.$qe=o,e.$re=s,e.$se=r,e.$te=i;function C(c){const h=c;return h?typeof h.read=="function":!1}function N(c){const h=c;return h?[h.on,h.pause,h.resume,h.destroy].every(t=>typeof t=="function"):!1}function A(c){const h=c;return h?N(h.stream)&&Array.isArray(h.buffer)&&typeof h.ended=="boolean":!1}function m(c,h){return new d(c,h)}class d{constructor(h,t){this.e=h,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(h){if(!this.a.destroyed){if(this.a.flowing)this.g(h);else if(this.b.data.push(h),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(h){this.a.destroyed||(this.a.flowing?this.h(h):this.b.error.push(h))}end(h){this.a.destroyed||(typeof h<"u"&&this.write(h),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(h){this.c.data.slice(0).forEach(t=>t(h))}h(h){this.c.error.length===0?(0,k.$1)(h):this.c.error.slice(0).forEach(t=>t(h))}i(){this.c.end.slice(0).forEach(h=>h())}on(h,t){if(!this.a.destroyed)switch(h){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(h,t){if(this.a.destroyed)return;let p;switch(h){case"data":p=this.c.data;break;case"end":p=this.c.end;break;case"error":p=this.c.error;break}if(p){const a=p.indexOf(t);a>=0&&p.splice(a,1)}}j(){if(this.b.data.length>0){const h=this.e(this.b.data);this.g(h),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(p=>p())}}k(){if(this.c.error.length>0){for(const h of this.b.error)this.h(h);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function y(c,h){const t=[];let p;for(;(p=c.read())!==null;)t.push(p);return h(t)}function O(c,h,t){const p=[];let a;for(;(a=c.read())!==null&&p.length<t;)p.push(a);return a===null&&p.length>0?h(p):{read:()=>{if(p.length>0)return p.shift();if(typeof a<"u"){const g=a;return a=void 0,g}return c.read()}}}function D(c,h){return new Promise((t,p)=>{const a=[];l(c,{onData:g=>{h&&a.push(g)},onError:g=>{h?p(g):t(void 0)},onEnd:()=>{t(h?h(a):void 0)}})})}function l(c,h,t){c.on("error",p=>{t?.isCancellationRequested||h.onError(p)}),c.on("end",()=>{t?.isCancellationRequested||h.onEnd()}),c.on("data",p=>{t?.isCancellationRequested||h.onData(p)})}function b(c,h){return new Promise((t,p)=>{const a=new M.$Tc,g=[],v=E=>{if(g.push(E),g.length>h)return a.dispose(),c.pause(),t({stream:c,buffer:g,ended:!1})},f=E=>(a.dispose(),p(E)),u=()=>(a.dispose(),t({stream:c,buffer:g,ended:!0}));a.add((0,M.$Sc)(()=>c.removeListener("error",f))),c.on("error",f),a.add((0,M.$Sc)(()=>c.removeListener("end",u))),c.on("end",u),a.add((0,M.$Sc)(()=>c.removeListener("data",v))),c.on("data",v)})}function $(c,h){const t=m(h);return t.end(c),t}function n(){const c=m(()=>{throw new Error("not supported")});return c.end(),c}function o(c){let h=!1;return{read:()=>h?null:(h=!0,c)}}function s(c,h,t){const p=m(t);return l(c,{onData:a=>p.write(h.data(a)),onError:a=>p.error(h.error?h.error(a):a),onEnd:()=>p.end()}),p}function r(c,h,t){let p=!1;return{read:()=>{const a=h.read();return p?a:(p=!0,a!==null?t([c,a]):c)}}}function i(c,h,t){let p=!1;const a=m(t);return l(h,{onData:g=>p?a.write(g):(p=!0,a.write(t([c,g]))),onError:g=>a.error(g),onEnd:()=>{p||(p=!0,a.write(c)),a.end()}}),a}}),define(Pe[22],Re([1,0,40,129]),function(ee,e,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ue=void 0,e.$ve=y,e.$we=O,e.$xe=D,e.$ye=l,e.$ze=b,e.$Ae=$,e.$Be=n,e.$Ce=o,e.$De=s,e.$Ee=r,e.$Fe=i,e.$Ge=c,e.$He=h,e.$Ie=t,e.$Je=p,e.$Ke=a,e.$Le=g,e.$Me=v,e.$Ne=f,e.$Oe=w;const C=typeof Buffer<"u",N=new k.$V(()=>new Uint8Array(256));let A,m;class d{static alloc(S){return C?new d(Buffer.allocUnsafe(S)):new d(new Uint8Array(S))}static wrap(S){return C&&!Buffer.isBuffer(S)&&(S=Buffer.from(S.buffer,S.byteOffset,S.byteLength)),new d(S)}static fromString(S,P){return!(P?.dontUseNodeBuffer||!1)&&C?new d(Buffer.from(S)):(A||(A=new TextEncoder),new d(A.encode(S)))}static fromByteArray(S){const P=d.alloc(S.length);for(let U=0,Q=S.length;U<Q;U++)P.buffer[U]=S[U];return P}static concat(S,P){if(typeof P>"u"){P=0;for(let H=0,L=S.length;H<L;H++)P+=S[H].byteLength}const U=d.alloc(P);let Q=0;for(let H=0,L=S.length;H<L;H++){const R=S[H];U.set(R,Q),Q+=R.byteLength}return U}constructor(S){this.buffer=S,this.byteLength=this.buffer.byteLength}clone(){const S=d.alloc(this.byteLength);return S.set(this),S}toString(){return C?this.buffer.toString():(m||(m=new TextDecoder),m.decode(this.buffer))}slice(S,P){return new d(this.buffer.subarray(S,P))}set(S,P){if(S instanceof d)this.buffer.set(S.buffer,P);else if(S instanceof Uint8Array)this.buffer.set(S,P);else if(S instanceof ArrayBuffer)this.buffer.set(new Uint8Array(S),P);else if(ArrayBuffer.isView(S))this.buffer.set(new Uint8Array(S.buffer,S.byteOffset,S.byteLength),P);else throw new Error("Unknown argument 'array'")}readUInt32BE(S){return l(this.buffer,S)}writeUInt32BE(S,P){b(this.buffer,S,P)}readUInt32LE(S){return $(this.buffer,S)}writeUInt32LE(S,P){n(this.buffer,S,P)}readUInt8(S){return o(this.buffer,S)}writeUInt8(S,P){s(this.buffer,S,P)}indexOf(S,P=0){return y(this.buffer,S instanceof d?S.buffer:S,P)}}e.$ue=d;function y(I,S,P=0){const U=S.byteLength,Q=I.byteLength;if(U===0)return 0;if(U===1)return I.indexOf(S[0]);if(U>Q-P)return-1;const H=N.value;H.fill(S.length);for(let T=0;T<S.length;T++)H[S[T]]=S.length-T-1;let L=P+S.length-1,R=L,F=-1;for(;L<Q;)if(I[L]===S[R]){if(R===0){F=L;break}L--,R--}else L+=Math.max(S.length-R,H[I[L]]),R=S.length-1;return F}function O(I,S){return I[S+0]<<0>>>0|I[S+1]<<8>>>0}function D(I,S,P){I[P+0]=S&255,S=S>>>8,I[P+1]=S&255}function l(I,S){return I[S]*2**24+I[S+1]*2**16+I[S+2]*2**8+I[S+3]}function b(I,S,P){I[P+3]=S,S=S>>>8,I[P+2]=S,S=S>>>8,I[P+1]=S,S=S>>>8,I[P]=S}function $(I,S){return I[S+0]<<0>>>0|I[S+1]<<8>>>0|I[S+2]<<16>>>0|I[S+3]<<24>>>0}function n(I,S,P){I[P+0]=S&255,S=S>>>8,I[P+1]=S&255,S=S>>>8,I[P+2]=S&255,S=S>>>8,I[P+3]=S&255}function o(I,S){return I[S]}function s(I,S,P){I[P]=S}function r(I){return M.$je(I,S=>d.concat(S))}function i(I){return M.$qe(I)}function c(I){return M.$le(I,S=>d.concat(S))}async function h(I){return I.ended?d.concat(I.buffer):d.concat([...I.buffer,await c(I.stream)])}function t(I){return M.$oe(I,S=>d.concat(S))}function p(I){return M.$re(I,{data:S=>typeof S=="string"?d.fromString(S):d.wrap(S)},S=>d.concat(S))}function a(I){return M.$ie(S=>d.concat(S),I)}function g(I,S){return M.$se(I,S,P=>d.concat(P))}function v(I,S){return M.$te(I,S,P=>d.concat(P))}function f(I){let S=0,P=0,U=0;const Q=new Uint8Array(Math.floor(I.length/4*3)),H=R=>{switch(P){case 3:Q[U++]=S|R,P=0;break;case 2:Q[U++]=S|R>>>2,S=R<<6,P=3;break;case 1:Q[U++]=S|R>>>4,S=R<<4,P=2;break;default:S=R<<2,P=1}};for(let R=0;R<I.length;R++){const F=I.charCodeAt(R);if(F>=65&&F<=90)H(F-65);else if(F>=97&&F<=122)H(F-97+26);else if(F>=48&&F<=57)H(F-48+52);else if(F===43||F===45)H(62);else if(F===47||F===95)H(63);else{if(F===61)break;throw new SyntaxError(`Unexpected base64 character ${I[R]}`)}}const L=U;for(;P>0;)H(0);return d.wrap(Q).slice(0,L)}const u="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",E="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function w({buffer:I},S=!0,P=!1){const U=P?E:u;let Q="";const H=I.byteLength%3;let L=0;for(;L<I.byteLength-H;L+=3){const R=I[L+0],F=I[L+1],T=I[L+2];Q+=U[R>>>2],Q+=U[(R<<4|F>>>4)&63],Q+=U[(F<<2|T>>>6)&63],Q+=U[T&63]}if(H===1){const R=I[L+0];Q+=U[R>>>2],Q+=U[R<<4&63],S&&(Q+="==")}else if(H===2){const R=I[L+0],F=I[L+1];Q+=U[R>>>2],Q+=U[(R<<4|F>>>4)&63],Q+=U[F<<2&63],S&&(Q+="=")}return Q}}),define(Pe[130],Re([1,0,28,125,15]),function(ee,e,k,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vk=e.FuzzyScore=e.$kk=e.$jk=void 0,e.or=N,e.$lk=m,e.$mk=d,e.$nk=D,e.$ok=f,e.$pk=u,e.$qk=U,e.$rk=Q,e.$sk=H,e.$tk=L,e.$uk=de,e.$wk=ge,e.$xk=Z,e.$yk=le;function N(...ve){return function(Ie,Ae){for(let je=0,j=ve.length;je<j;je++){const B=ve[je](Ie,Ae);if(B)return B}return null}}e.$jk=A.bind(void 0,!1),e.$kk=A.bind(void 0,!0);function A(ve,Ie,Ae){if(!Ae||Ae.length<Ie.length)return null;let je;return ve?je=C.$mf(Ae,Ie):je=Ae.indexOf(Ie)===0,je?Ie.length>0?[{start:0,end:Ie.length}]:[]:null}function m(ve,Ie){const Ae=Ie.toLowerCase().indexOf(ve.toLowerCase());return Ae===-1?null:[{start:Ae,end:Ae+ve.length}]}function d(ve,Ie){return y(ve.toLowerCase(),Ie.toLowerCase(),0,0)}function y(ve,Ie,Ae,je){if(Ae===ve.length)return[];if(je===Ie.length)return null;if(ve[Ae]===Ie[je]){let j=null;return(j=y(ve,Ie,Ae+1,je+1))?c({start:je,end:je+1},j):null}return y(ve,Ie,Ae,je+1)}function O(ve){return 97<=ve&&ve<=122}function D(ve){return 65<=ve&&ve<=90}function l(ve){return 48<=ve&&ve<=57}function b(ve){return ve===32||ve===9||ve===10||ve===13}const $=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ve=>$.add(ve.charCodeAt(0)));function n(ve){return b(ve)||$.has(ve)}function o(ve,Ie){return ve===Ie||n(ve)&&n(Ie)}const s=new Map;function r(ve){if(s.has(ve))return s.get(ve);let Ie;const Ae=(0,M.$hk)(ve);return Ae&&(Ie=Ae),s.set(ve,Ie),Ie}function i(ve){return O(ve)||D(ve)||l(ve)}function c(ve,Ie){return Ie.length===0?Ie=[ve]:ve.end===Ie[0].start?Ie[0].start=ve.start:Ie.unshift(ve),Ie}function h(ve,Ie){for(let Ae=Ie;Ae<ve.length;Ae++){const je=ve.charCodeAt(Ae);if(D(je)||l(je)||Ae>0&&!i(ve.charCodeAt(Ae-1)))return Ae}return ve.length}function t(ve,Ie,Ae,je){if(Ae===ve.length)return[];if(je===Ie.length)return null;if(ve[Ae]!==Ie[je].toLowerCase())return null;{let j=null,B=je+1;for(j=t(ve,Ie,Ae+1,je+1);!j&&(B=h(Ie,B))<Ie.length;)j=t(ve,Ie,Ae+1,B),B++;return j===null?null:c({start:je,end:je+1},j)}}function p(ve){let Ie=0,Ae=0,je=0,j=0,B=0;for(let Fe=0;Fe<ve.length;Fe++)B=ve.charCodeAt(Fe),D(B)&&Ie++,O(B)&&Ae++,i(B)&&je++,l(B)&&j++;const G=Ie/ve.length,W=Ae/ve.length,_=je/ve.length,oe=j/ve.length;return{upperPercent:G,lowerPercent:W,alphaPercent:_,numericPercent:oe}}function a(ve){const{upperPercent:Ie,lowerPercent:Ae}=ve;return Ae===0&&Ie>.6}function g(ve){const{upperPercent:Ie,lowerPercent:Ae,alphaPercent:je,numericPercent:j}=ve;return Ae>.2&&Ie<.8&&je>.6&&j<.2}function v(ve){let Ie=0,Ae=0,je=0,j=0;for(let B=0;B<ve.length;B++)je=ve.charCodeAt(B),D(je)&&Ie++,O(je)&&Ae++,b(je)&&j++;return(Ie===0||Ae===0)&&j===0?ve.length<=30:Ie<=5}function f(ve,Ie){if(!Ie||(Ie=Ie.trim(),Ie.length===0)||!v(ve))return null;Ie.length>60&&(Ie=Ie.substring(0,60));const Ae=p(Ie);if(!g(Ae)){if(!a(Ae))return null;Ie=Ie.toLowerCase()}let je=null,j=0;for(ve=ve.toLowerCase();j<Ie.length&&(je=t(ve,Ie,0,j))===null;)j=h(Ie,j+1);return je}function u(ve,Ie,Ae=!1){if(!Ie||Ie.length===0)return null;let je=null,j=0;for(ve=ve.toLowerCase(),Ie=Ie.toLowerCase();j<Ie.length&&(je=E(ve,Ie,0,j,Ae),je===null);)j=w(Ie,j+1);return je}function E(ve,Ie,Ae,je,j){let B=0;if(Ae===ve.length)return[];if(je===Ie.length)return null;if(!o(ve.charCodeAt(Ae),Ie.charCodeAt(je))){const _=r(ve.charCodeAt(Ae));if(!_)return null;for(let oe=0;oe<_.length;oe++)if(!o(_[oe],Ie.charCodeAt(je+oe)))return null;B+=_.length-1}let G=null,W=je+B+1;if(G=E(ve,Ie,Ae+1,W,j),!j)for(;!G&&(W=w(Ie,W))<Ie.length;)G=E(ve,Ie,Ae+1,W,j),W++;if(!G)return null;if(ve.charCodeAt(Ae)!==Ie.charCodeAt(je)){const _=r(ve.charCodeAt(Ae));if(!_)return G;for(let oe=0;oe<_.length;oe++)if(_[oe]!==Ie.charCodeAt(je+oe))return G}return c({start:je,end:je+B+1},G)}function w(ve,Ie){for(let Ae=Ie;Ae<ve.length;Ae++)if(n(ve.charCodeAt(Ae))||Ae>0&&n(ve.charCodeAt(Ae-1)))return Ae;return ve.length}const I=N(e.$kk,f,m),S=N(e.$kk,f,d),P=new k.$Ec(1e4);function U(ve,Ie,Ae=!1){if(typeof ve!="string"||typeof Ie!="string")return null;let je=P.get(ve);je||(je=new RegExp(C.$7e(ve),"i"),P.set(ve,je));const j=je.exec(Ie);return j?[{start:j.index,end:j.index+j[0].length}]:Ae?S(ve,Ie):I(ve,Ie)}function Q(ve,Ie){const Ae=ge(ve,ve.toLowerCase(),0,Ie,Ie.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Ae?L(Ae):null}function H(ve,Ie,Ae,je,j,B){const G=Math.min(13,ve.length);for(;Ae<G;Ae++){const W=ge(ve,Ie,Ae,je,j,B,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(W)return W}return[0,B]}function L(ve){if(typeof ve>"u")return[];const Ie=[],Ae=ve[1];for(let je=ve.length-1;je>1;je--){const j=ve[je]+Ae,B=Ie[Ie.length-1];B&&B.end===j?B.end=j+1:Ie.push({start:j,end:j+1})}return Ie}const R=128;function F(){const ve=[],Ie=[];for(let Ae=0;Ae<=R;Ae++)Ie[Ae]=0;for(let Ae=0;Ae<=R;Ae++)ve.push(Ie.slice(0));return ve}function T(ve){const Ie=[];for(let Ae=0;Ae<=ve;Ae++)Ie[Ae]=0;return Ie}const X=T(2*R),re=T(2*R),me=F(),pe=F(),ae=F(),be=!1;function se(ve,Ie,Ae,je,j){function B(W,_,oe=" "){for(;W.length<_;)W=oe+W;return W}let G=` |   |${je.split("").map(W=>B(W,3)).join("|")}
`;for(let W=0;W<=Ae;W++)W===0?G+=" |":G+=`${Ie[W-1]}|`,G+=ve[W].slice(0,j+1).map(_=>B(_.toString(),3)).join("|")+`
`;return G}function De(ve,Ie,Ae,je){ve=ve.substr(Ie),Ae=Ae.substr(je),console.log(se(pe,ve,ve.length,Ae,Ae.length)),console.log(se(ae,ve,ve.length,Ae,Ae.length)),console.log(se(me,ve,ve.length,Ae,Ae.length))}function Oe(ve,Ie){if(Ie<0||Ie>=ve.length)return!1;const Ae=ve.codePointAt(Ie);switch(Ae){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!C.$Ef(Ae)}}function ie(ve,Ie){if(Ie<0||Ie>=ve.length)return!1;switch(ve.charCodeAt(Ie)){case 32:case 9:return!0;default:return!1}}function q(ve,Ie,Ae){return Ie[ve]!==Ae[ve]}function de(ve,Ie,Ae,je,j,B,G=!1){for(;Ie<Ae&&j<B;)ve[Ie]===je[j]&&(G&&(X[Ie]=j),Ie+=1),j+=1;return Ie===Ae}var Ne;(function(ve){ve[ve.Diag=1]="Diag",ve[ve.Left=2]="Left",ve[ve.LeftLeft=3]="LeftLeft"})(Ne||(Ne={}));var $e;(function(ve){ve.Default=[-100,0];function Ie(Ae){return!Ae||Ae.length===2&&Ae[0]===-100&&Ae[1]===0}ve.isDefault=Ie})($e||(e.FuzzyScore=$e={}));class we{constructor(Ie,Ae){this.firstMatchCanBeWeak=Ie,this.boostFullMatch=Ae}}e.$vk=we,we.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function ge(ve,Ie,Ae,je,j,B,G=we.default){const W=ve.length>R?R:ve.length,_=je.length>R?R:je.length;if(Ae>=W||B>=_||W-Ae>_-B||!de(Ie,Ae,W,j,B,_,!0))return;ce(W,_,Ae,B,Ie,j);let oe=1,Fe=1,Be=Ae,Qe=B;const et=[!1];for(oe=1,Be=Ae;Be<W;oe++,Be++){const ot=X[Be],$t=re[Be],Ue=Be+1<W?re[Be+1]:_;for(Fe=ot-B+1,Qe=ot;Qe<Ue;Fe++,Qe++){let ct=Number.MIN_SAFE_INTEGER,x=!1;Qe<=$t&&(ct=K(ve,Ie,Be,Ae,je,j,Qe,_,B,me[oe-1][Fe-1]===0,et));let Y=0;ct!==Number.MAX_SAFE_INTEGER&&(x=!0,Y=ct+pe[oe-1][Fe-1]);const ye=Qe>ot,He=ye?pe[oe][Fe-1]+(me[oe][Fe-1]>0?-5:0):0,Ye=Qe>ot+1&&me[oe][Fe-1]>0,Me=Ye?pe[oe][Fe-2]+(me[oe][Fe-2]>0?-5:0):0;if(Ye&&(!ye||Me>=He)&&(!x||Me>=Y))pe[oe][Fe]=Me,ae[oe][Fe]=3,me[oe][Fe]=0;else if(ye&&(!x||He>=Y))pe[oe][Fe]=He,ae[oe][Fe]=2,me[oe][Fe]=0;else if(x)pe[oe][Fe]=Y,ae[oe][Fe]=1,me[oe][Fe]=me[oe-1][Fe-1]+1;else throw new Error("not possible")}}if(be&&De(ve,Ae,je,B),!et[0]&&!G.firstMatchCanBeWeak)return;oe--,Fe--;const it=[pe[oe][Fe],B];let ut=0,st=0;for(;oe>=1;){let ot=Fe;do{const $t=ae[oe][ot];if($t===3)ot=ot-2;else if($t===2)ot=ot-1;else break}while(ot>=1);ut>1&&Ie[Ae+oe-1]===j[B+Fe-1]&&!q(ot+B-1,je,j)&&ut+1>me[oe][ot]&&(ot=Fe),ot===Fe?ut++:ut=1,st||(st=ot),oe--,Fe=ot-1,it.push(Fe)}_===W&&G.boostFullMatch&&(it[0]+=2);const rt=st-W;return it[0]-=rt,it}function ce(ve,Ie,Ae,je,j,B){let G=ve-1,W=Ie-1;for(;G>=Ae&&W>=je;)j[G]===B[W]&&(re[G]=W,G--),W--}function K(ve,Ie,Ae,je,j,B,G,W,_,oe,Fe){if(Ie[Ae]!==B[G])return Number.MIN_SAFE_INTEGER;let Be=1,Qe=!1;return G===Ae-je?Be=ve[Ae]===j[G]?7:5:q(G,j,B)&&(G===0||!q(G-1,j,B))?(Be=ve[Ae]===j[G]?7:5,Qe=!0):Oe(B,G)&&(G===0||!Oe(B,G-1))?Be=5:(Oe(B,G-1)||ie(B,G-1))&&(Be=5,Qe=!0),Be>1&&Ae===je&&(Fe[0]=!0),Qe||(Qe=q(G,j,B)||Oe(B,G-1)||ie(B,G-1)),Ae===je?G>_&&(Be-=Qe?3:5):oe?Be+=Qe?2:0:Be+=Qe?0:1,G+1===W&&(Be-=Qe?3:5),Be}function Z(ve,Ie,Ae,je,j,B,G){return fe(ve,Ie,Ae,je,j,B,!0,G)}function le(ve,Ie,Ae,je,j,B,G){return fe(ve,Ie,Ae,je,j,B,!1,G)}function fe(ve,Ie,Ae,je,j,B,G,W){let _=ge(ve,Ie,Ae,je,j,B,W);if(_&&!G)return _;if(ve.length>=3){const oe=Math.min(7,ve.length-1);for(let Fe=Ae+1;Fe<oe;Fe++){const Be=Te(ve,Fe);if(Be){const Qe=ge(Be,Be.toLowerCase(),Ae,je,j,B,W);Qe&&(Qe[0]-=3,(!_||Qe[0]>_[0])&&(_=Qe))}}}return _}function Te(ve,Ie){if(Ie+1>=ve.length)return;const Ae=ve[Ie],je=ve[Ie+1];if(Ae!==je)return ve.slice(0,Ie)+je+Ae+ve.slice(Ie+2)}}),define(Pe[32],Re([1,0,15]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var M;(function(C){C[C.Ignore=0]="Ignore",C[C.Info=1]="Info",C[C.Warning=2]="Warning",C[C.Error=3]="Error"})(M||(M={})),function(C){const N="error",A="warning",m="warn",d="info",y="ignore";function O(l){return l?k.$lf(N,l)?C.Error:k.$lf(A,l)||k.$lf(m,l)?C.Warning:k.$lf(d,l)?C.Info:C.Ignore:C.Ignore}C.fromValue=O;function D(l){switch(l){case C.Error:return N;case C.Warning:return A;case C.Info:return d;default:return y}}C.toString=D}(M||(M={})),e.default=M}),define(Pe[131],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4d=void 0,e.$4d=Symbol("MicrotaskDelay")}),define(Pe[52],Re([1,0,18,15]),function(ee,e,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=e.$ni=e.$mi=e.$li=e.$ki=void 0;class C{constructor(){this.b="",this.c=0}reset(b){return this.b=b,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(b){const $=b.charCodeAt(0),n=this.b.charCodeAt(this.c);return $-n}value(){return this.b[this.c]}}e.$ki=C;class N{constructor(b=!0){this.e=b}reset(b){return this.b=b,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let b=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(b)this.c++;else break;else b=!1;return this}cmp(b){return this.e?(0,M.$ff)(b,this.b,0,b.length,this.c,this.d):(0,M.$hf)(b,this.b,0,b.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$li=N;class A{constructor(b=!0,$=!0){this.f=b,this.g=$}reset(b){this.d=0,this.e=0,this.b=b,this.c=b.length;for(let $=b.length-1;$>=0;$--,this.c--){const n=this.b.charCodeAt($);if(!(n===47||this.f&&n===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let b=!0;for(;this.e<this.c;this.e++){const $=this.b.charCodeAt(this.e);if($===47||this.f&&$===92)if(b)this.d++;else break;else b=!1}return this}cmp(b){return this.g?(0,M.$ff)(b,this.b,0,b.length,this.d,this.e):(0,M.$hf)(b,this.b,0,b.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$mi=A;var m;(function(l){l[l.Scheme=1]="Scheme",l[l.Authority=2]="Authority",l[l.Path=3]="Path",l[l.Query=4]="Query",l[l.Fragment=5]="Fragment"})(m||(m={}));class d{constructor(b,$){this.f=b,this.g=$,this.d=[],this.e=0}reset(b){return this.c=b,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f(b)),this.b.reset(b.path),this.b.value()&&this.d.push(3)),this.g(b)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(b){if(this.d[this.e]===1)return(0,M.$gf)(b,this.c.scheme);if(this.d[this.e]===2)return(0,M.$gf)(b,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(b);if(this.d[this.e]===4)return(0,M.$ef)(b,this.c.query);if(this.d[this.e]===5)return(0,M.$ef)(b,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$ni=d;class y{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const b=this.right;return this.right=b.left,b.left=this,this.updateHeight(),b.updateHeight(),b}rotateRight(){const b=this.left;return this.left=b.right,b.right=this,this.updateHeight(),b.updateHeight(),b}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var O;(function(l){l[l.Left=-1]="Left",l[l.Mid=0]="Mid",l[l.Right=1]="Right"})(O||(O={}));class D{static forUris(b=()=>!1,$=()=>!1){return new D(new d(b,$))}static forPaths(b=!1){return new D(new A(void 0,!b))}static forStrings(){return new D(new C)}static forConfigKeys(){return new D(new N)}constructor(b){this.b=b}clear(){this.c=void 0}fill(b,$){if($){const n=$.slice(0);(0,k.$Xb)(n);for(const o of n)this.set(o,b)}else{const n=b.slice(0);(0,k.$Xb)(n);for(const o of n)this.set(o[0],o[1])}}set(b,$){const n=this.b.reset(b);let o;this.c||(this.c=new y,this.c.segment=n.value());const s=[];for(o=this.c;;){const i=n.cmp(o.segment);if(i>0)o.left||(o.left=new y,o.left.segment=n.value()),s.push([-1,o]),o=o.left;else if(i<0)o.right||(o.right=new y,o.right.segment=n.value()),s.push([1,o]),o=o.right;else if(n.hasNext())n.next(),o.mid||(o.mid=new y,o.mid.segment=n.value()),s.push([0,o]),o=o.mid;else break}const r=o.value;o.value=$,o.key=b;for(let i=s.length-1;i>=0;i--){const c=s[i][1];c.updateHeight();const h=c.balanceFactor();if(h<-1||h>1){const t=s[i][0],p=s[i+1][0];if(t===1&&p===1)s[i][1]=c.rotateLeft();else if(t===-1&&p===-1)s[i][1]=c.rotateRight();else if(t===1&&p===-1)c.right=s[i+1][1]=s[i+1][1].rotateRight(),s[i][1]=c.rotateLeft();else if(t===-1&&p===1)c.left=s[i+1][1]=s[i+1][1].rotateLeft(),s[i][1]=c.rotateRight();else throw new Error;if(i>0)switch(s[i-1][0]){case-1:s[i-1][1].left=s[i][1];break;case 1:s[i-1][1].right=s[i][1];break;case 0:s[i-1][1].mid=s[i][1];break}else this.c=s[0][1]}}return r}get(b){return this.d(b)?.value}d(b){const $=this.b.reset(b);let n=this.c;for(;n;){const o=$.cmp(n.segment);if(o>0)n=n.left;else if(o<0)n=n.right;else if($.hasNext())$.next(),n=n.mid;else break}return n}has(b){const $=this.d(b);return!($?.value===void 0&&$?.mid===void 0)}delete(b){return this.e(b,!1)}deleteSuperstr(b){return this.e(b,!0)}e(b,$){const n=this.b.reset(b),o=[];let s=this.c;for(;s;){const r=n.cmp(s.segment);if(r>0)o.push([-1,s]),s=s.left;else if(r<0)o.push([1,s]),s=s.right;else if(n.hasNext())n.next(),o.push([0,s]),s=s.mid;else break}if(s){if($?(s.left=void 0,s.mid=void 0,s.right=void 0,s.height=1):(s.key=void 0,s.value=void 0),!s.mid&&!s.value)if(s.left&&s.right){const r=this.f(s.right);if(r.key){const{key:i,value:c,segment:h}=r;this.e(r.key,!1),s.key=i,s.value=c,s.segment=h}}else{const r=s.left??s.right;if(o.length>0){const[i,c]=o[o.length-1];switch(i){case-1:c.left=r;break;case 0:c.mid=r;break;case 1:c.right=r;break}}else this.c=r}for(let r=o.length-1;r>=0;r--){const i=o[r][1];i.updateHeight();const c=i.balanceFactor();if(c>1?(i.right.balanceFactor()>=0||(i.right=i.right.rotateRight()),o[r][1]=i.rotateLeft()):c<-1&&(i.left.balanceFactor()<=0||(i.left=i.left.rotateLeft()),o[r][1]=i.rotateRight()),r>0)switch(o[r-1][0]){case-1:o[r-1][1].left=o[r][1];break;case 1:o[r-1][1].right=o[r][1];break;case 0:o[r-1][1].mid=o[r][1];break}else this.c=o[0][1]}}}f(b){for(;b.left;)b=b.left;return b}findSubstr(b){const $=this.b.reset(b);let n=this.c,o;for(;n;){const s=$.cmp(n.segment);if(s>0)n=n.left;else if(s<0)n=n.right;else if($.hasNext())$.next(),o=n.value||o,n=n.mid;else break}return n&&n.value||o}findSuperstr(b){return this.g(b,!1)}g(b,$){const n=this.b.reset(b);let o=this.c;for(;o;){const s=n.cmp(o.segment);if(s>0)o=o.left;else if(s<0)o=o.right;else if(n.hasNext())n.next(),o=o.mid;else return o.mid?this.h(o.mid):$?o.value:void 0}}hasElementOrSubtree(b){return this.g(b,!0)!==void 0}forEach(b){for(const[$,n]of this)b(n,$)}*[Symbol.iterator](){yield*this.h(this.c)}h(b){const $=[];return this.j(b,$),$[Symbol.iterator]()}j(b,$){b&&(b.left&&this.j(b.left,$),b.value&&$.push([b.key,b.value]),b.mid&&this.j(b.mid,$),b.right&&this.j(b.right,$))}_isBalanced(){const b=$=>{if(!$)return!0;const n=$.balanceFactor();return n<-1||n>1?!1:b($.left)&&b($.right)};return b(this.c)}}e.$oi=D}),define(Pe[46],Re([1,0,19,21,15,17]),function(ee,e,k,M,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bg=A,e.$cg=m,e.$dg=d,e.$eg=y,e.$fg=O,e.$gg=$,e.$hg=n,e.$ig=o,e.$jg=s,e.$kg=r,e.$lg=i,e.$mg=c,e.$ng=h,e.$og=t,e.$pg=p,e.$qg=v;function A(f){return f===47||f===92}function m(f){return f.replace(/[\\/]/g,k.$hc.sep)}function d(f){return f.indexOf("/")===-1&&(f=m(f)),/^[a-zA-Z]:(\/|$)/.test(f)&&(f="/"+f),f}function y(f,u=k.$hc.sep){if(!f)return"";const E=f.length,w=f.charCodeAt(0);if(A(w)){if(A(f.charCodeAt(1))&&!A(f.charCodeAt(2))){let S=3;const P=S;for(;S<E&&!A(f.charCodeAt(S));S++);if(P!==S&&!A(f.charCodeAt(S+1))){for(S+=1;S<E;S++)if(A(f.charCodeAt(S)))return f.slice(0,S+1).replace(/[\\/]/g,u)}}return u}else if(s(w)&&f.charCodeAt(1)===58)return A(f.charCodeAt(2))?f.slice(0,2)+u:f.slice(0,2);let I=f.indexOf("://");if(I!==-1){for(I+=3;I<E;I++)if(A(f.charCodeAt(I)))return f.slice(0,I+1)}return""}function O(f){if(!M.$c||!f||f.length<5)return!1;let u=f.charCodeAt(0);if(u!==92||(u=f.charCodeAt(1),u!==92))return!1;let E=2;const w=E;for(;E<f.length&&(u=f.charCodeAt(E),u!==92);E++);return!(w===E||(u=f.charCodeAt(E+1),isNaN(u)||u===92))}const D=/[\\/:\*\?"<>\|]/g,l=/[\\/]/g,b=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function $(f,u=M.$c){const E=u?D:l;return!(!f||f.length===0||/^\s+$/.test(f)||(E.lastIndex=0,E.test(f))||u&&b.test(f)||f==="."||f===".."||u&&f[f.length-1]==="."||u&&f.length!==f.trim().length||f.length>255)}function n(f,u,E){const w=f===u;return!E||w?w:!f||!u?!1:(0,C.$lf)(f,u)}function o(f,u,E,w=k.sep){if(f===u)return!0;if(!f||!u||u.length>f.length)return!1;if(E){if(!(0,C.$mf)(f,u))return!1;if(u.length===f.length)return!0;let S=u.length;return u.charAt(u.length-1)===w&&S--,f.charAt(S)===w}return u.charAt(u.length-1)!==w&&(u+=w),f.indexOf(u)===0}function s(f){return f>=65&&f<=90||f>=97&&f<=122}function r(f,u){return M.$c&&f.endsWith(":")&&(f+=k.sep),(0,k.$jc)(f)||(f=(0,k.$kc)(u,f)),f=(0,k.$ic)(f),M.$c?(f=(0,C.$6e)(f,k.sep),f.endsWith(":")&&(f+=k.sep)):(f=(0,C.$6e)(f,k.sep),f||(f=k.sep)),f}function i(f){const u=(0,k.$ic)(f);return M.$c?f.length>3?!1:c(u)&&(f.length===2||u.charCodeAt(2)===92):u===k.$hc.sep}function c(f,u=M.$c){return u?s(f.charCodeAt(0))&&f.charCodeAt(1)===58:!1}function h(f,u=M.$c){return c(f,u)?f[0]:void 0}function t(f,u,E){return u.length>f.length?-1:f===u?0:(E&&(f=f.toLowerCase(),u=u.toLowerCase()),f.indexOf(u))}function p(f){const u=f.split(":");let E,w,I;for(const S of u){const P=Number(S);(0,N.$Zf)(P)?w===void 0?w=P:I===void 0&&(I=P):E=E?[E,S].join(":"):S}if(!E)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:E,line:w!==void 0?w:void 0,column:I!==void 0?I:w!==void 0?1:void 0}}const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",g="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function v(f,u,E=8){let w="";for(let S=0;S<E;S++){let P;S===0&&M.$c&&!u&&(E===3||E===4)?P=g:P=a,w+=P.charAt(Math.floor(Math.random()*P.length))}let I;return u?I=`${u}-${w}`:I=w,f?(0,k.$kc)(f,I):I}}),define(Pe[41],Re([1,0,91]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$Ij=C;var M;(function(A){function m(d){return d&&typeof d=="object"&&typeof d.id=="string"}A.isThemeColor=m})(M||(e.ThemeColor=M={}));function C(A){return{id:A}}var N;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const m=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function d(r){const i=m.exec(r.id);if(!i)return d(k.$Hj.error);const[,c,h]=i,t=["codicon","codicon-"+c];return h&&t.push("codicon-modifier-"+h.substring(1)),t}A.asClassNameArray=d;function y(r){return d(r).join(" ")}A.asClassName=y;function O(r){return"."+d(r).join(".")}A.asCSSSelector=O;function D(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color>"u"||M.isThemeColor(r.color))}A.isThemeIcon=D;const l=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function b(r){const i=l.exec(r);if(!i)return;const[,c]=i;return{id:c}}A.fromString=b;function $(r){return{id:r}}A.fromId=$;function n(r,i){let c=r.id;const h=c.lastIndexOf("~");return h!==-1&&(c=c.substring(0,h)),i&&(c=`${c}~${i}`),{id:c}}A.modify=n;function o(r){const i=r.id.lastIndexOf("~");if(i!==-1)return r.id.substring(i+1)}A.getModifier=o;function s(r,i){return r.id===i.id&&r.color?.id===i.color?.id}A.isEqual=s})(N||(e.ThemeIcon=N={}))}),define(Pe[132],Re([1,0,130,15,41]),function(ee,e,k,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zk=d,e.$Ak=O,e.$Bk=l,e.$Ck=b,e.$Dk=n,e.$Ek=o;const N="$(",A=new RegExp(`\\$\\(${C.ThemeIcon.iconNameExpression}(?:${C.ThemeIcon.iconModifierExpression})?\\)`,"g"),m=new RegExp(`(\\\\)?${A.source}`,"g");function d(s){return s.replace(m,(r,i)=>i?r:`\\${r}`)}const y=new RegExp(`\\\\${A.source}`,"g");function O(s){return s.replace(y,r=>`\\${r}`)}const D=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function l(s){return s.indexOf(N)===-1?s:s.replace(D,(r,i,c,h)=>c?r:i||h||"")}function b(s){return s?s.replace(/\$\((.*?)\)/g,(r,i)=>` ${i} `).trim():""}const $=new RegExp(`\\$\\(${C.ThemeIcon.iconNameCharacter}+\\)`,"g");function n(s){$.lastIndex=0;let r="";const i=[];let c=0;for(;;){const h=$.lastIndex,t=$.exec(s),p=s.substring(h,t?.index);if(p.length>0){r+=p;for(let a=0;a<p.length;a++)i.push(c)}if(!t)break;c+=t[0].length}return{text:r,iconOffsets:i}}function o(s,r,i=!1){const{text:c,iconOffsets:h}=r;if(!h||h.length===0)return(0,k.$qk)(s,c,i);const t=(0,M.$5e)(c," "),p=c.length-t.length,a=(0,k.$qk)(s,t,i);if(a)for(const g of a){const v=h[g.start+p]+p;g.start+=v,g.end+=v}return a}}),define(Pe[53],Re([1,0,22,2]),function(ee,e,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ph=C,e.$Qh=N,e.$Rh=m;function C(d){return JSON.stringify(d,A)}function N(d){let y=JSON.parse(d);return y=m(y),y}function A(d,y){return y instanceof RegExp?{$mid:2,source:y.source,flags:y.flags}:y}function m(d,y=0){if(!d||y>200)return d;if(typeof d=="object"){switch(d.$mid){case 1:return M.URI.revive(d);case 2:return new RegExp(d.source,d.flags);case 17:return new Date(d.source)}if(d instanceof k.$ue||d instanceof Uint8Array)return d;if(Array.isArray(d))for(let O=0;O<d.length;++O)d[O]=m(d[O],y+1);else for(const O in d)Object.hasOwnProperty.call(d,O)&&(d[O]=m(d[O],y+1))}return d}}),define(Pe[12],Re([1,0,14,21,15,2,19]),function(ee,e,k,M,C,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$vg=e.$ug=e.$tg=e.Schemas=void 0,e.$rg=d,e.$sg=y,e.$wg=D;var m;(function($){$.inMemory="inmemory",$.vscode="vscode",$.internal="private",$.walkThrough="walkThrough",$.walkThroughSnippet="walkThroughSnippet",$.http="http",$.https="https",$.file="file",$.mailto="mailto",$.untitled="untitled",$.data="data",$.command="command",$.vscodeRemote="vscode-remote",$.vscodeRemoteResource="vscode-remote-resource",$.vscodeManagedRemoteResource="vscode-managed-remote-resource",$.vscodeUserData="vscode-userdata",$.vscodeCustomEditor="vscode-custom-editor",$.vscodeNotebookCell="vscode-notebook-cell",$.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",$.vscodeNotebookCellOutput="vscode-notebook-cell-output",$.vscodeInteractiveInput="vscode-interactive-input",$.vscodeSettings="vscode-settings",$.vscodeWorkspaceTrust="vscode-workspace-trust",$.vscodeTerminal="vscode-terminal",$.vscodeChatCodeBlock="vscode-chat-code-block",$.vscodeChatSesssion="vscode-chat-editor",$.webviewPanel="webview-panel",$.vscodeWebview="vscode-webview",$.extension="extension",$.vscodeFileResource="vscode-file",$.tmp="tmp",$.vsls="vsls",$.vscodeSourceControl="vscode-scm",$.codeSetting="code-setting"})(m||(e.Schemas=m={}));function d($,n){return N.URI.isUri($)?(0,C.$lf)($.scheme,n):(0,C.$mf)($,n+":")}function y($,...n){return n.some(o=>d($,o))}e.$tg="vscode-tkn",e.$ug="tkn";class O{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(n){this.d=n}setDelegate(n){this.e=n}setServerRootPath(n,o){this.f=D(n,o)}getServerRootPath(){return this.f}get g(){return A.$hc.join(this.f,m.vscodeRemoteResource)}set(n,o,s){this.a[n]=o,this.b[n]=s}setConnectionToken(n,o){this.c[n]=o}getPreferredWebSchema(){return this.d}rewrite(n){if(this.e)try{return this.e(n)}catch(h){return k.$1(h),n}const o=n.authority;let s=this.a[o];s&&s.indexOf(":")!==-1&&s.indexOf("[")===-1&&(s=`[${s}]`);const r=this.b[o],i=this.c[o];let c=`path=${encodeURIComponent(n.path)}`;return typeof i=="string"&&(c+=`&${e.$ug}=${encodeURIComponent(i)}`),N.URI.from({scheme:M.$i?this.d:m.vscodeRemoteResource,authority:`${s}:${r}`,path:M.$i?(window.location.pathname+"/"+this.g).replace(/\/\/+/g,"/"):this.g,query:c})}}e.$vg=new O;function D($,n){return A.$hc.join(n??"/",`${$.quality??"oss"}-${$.commit??"dev"}`)}e.$xg="vs/../../extensions",e.$yg="vs/../../node_modules",e.$zg="vs/../../node_modules.asar",e.$Ag="vs/../../node_modules.asar.unpacked",e.$Bg="vscode-app";class l{asBrowserUri(n){const o=this.b(n,ee);return this.uriToBrowserUri(o)}uriToBrowserUri(n){return n.scheme===m.vscodeRemote?e.$vg.rewrite(n):n.scheme===m.file&&(M.$g||M.$k===`${m.vscodeFileResource}://${l.a}`)?n.with({scheme:m.vscodeFileResource,authority:n.authority||l.a,query:null,fragment:null}):n}asFileUri(n){const o=this.b(n,ee);return this.uriToFileUri(o)}uriToFileUri(n){return n.scheme===m.vscodeFileResource?n.with({scheme:m.file,authority:n.authority!==l.a?n.authority:null,query:null,fragment:null}):n}b(n,o){return N.URI.isUri(n)?n:N.URI.parse(o.toUrl(n))}}l.a=e.$Bg,e.$Cg=new l;var b;(function($){const n=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);$.CoopAndCoep=Object.freeze(n.get("3"));const o="vscode-coi";function s(i){let c;typeof i=="string"?c=new URL(i).searchParams:i instanceof URL?c=i.searchParams:N.URI.isUri(i)&&(c=new URL(i.toString(!0)).searchParams);const h=c?.get(o);if(h)return n.get(h)}$.getHeadersFromQuery=s;function r(i,c,h){if(!globalThis.crossOriginIsolated)return;const t=c&&h?"3":h?"2":"1";i instanceof URLSearchParams?i.set(o,t):i[o]=t}$.addSearchParam=r})(b||(e.COI=b={}))}),define(Pe[23],Re([1,0,46,12,19,21,15,2]),function(ee,e,k,M,C,N,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=void 0,e.$Jg=d,e.$5g=O,e.$6g=l;function d(b){return(0,m.$xc)(b,!0)}class y{constructor($){this.a=$}compare($,n,o=!1){return $===n?0:(0,A.$ef)(this.getComparisonKey($,o),this.getComparisonKey(n,o))}isEqual($,n,o=!1){return $===n?!0:!$||!n?!1:this.getComparisonKey($,o)===this.getComparisonKey(n,o)}getComparisonKey($,n=!1){return $.with({path:this.a($)?$.path.toLowerCase():void 0,fragment:n?null:void 0}).toString()}ignorePathCasing($){return this.a($)}isEqualOrParent($,n,o=!1){if($.scheme===n.scheme){if($.scheme===M.Schemas.file)return k.$ig(d($),d(n),this.a($))&&$.query===n.query&&(o||$.fragment===n.fragment);if((0,e.$1g)($.authority,n.authority))return k.$ig($.path,n.path,this.a($),"/")&&$.query===n.query&&(o||$.fragment===n.fragment)}return!1}joinPath($,...n){return m.URI.joinPath($,...n)}basenameOrAuthority($){return(0,e.$Sg)($)||$.authority}basename($){return C.$hc.basename($.path)}extname($){return C.$hc.extname($.path)}dirname($){if($.path.length===0)return $;let n;return $.scheme===M.Schemas.file?n=m.URI.file(C.$nc(d($))).path:(n=C.$hc.dirname($.path),$.authority&&n.length&&n.charCodeAt(0)!==47&&(console.error(`dirname("${$.toString})) resulted in a relative path`),n="/")),$.with({path:n})}normalizePath($){if(!$.path.length)return $;let n;return $.scheme===M.Schemas.file?n=m.URI.file(C.$ic(d($))).path:n=C.$hc.normalize($.path),$.with({path:n})}relativePath($,n){if($.scheme!==n.scheme||!(0,e.$1g)($.authority,n.authority))return;if($.scheme===M.Schemas.file){const r=C.$mc(d($),d(n));return N.$c?k.$cg(r):r}let o=$.path||"/";const s=n.path||"/";if(this.a($)){let r=0;for(const i=Math.min(o.length,s.length);r<i&&!(o.charCodeAt(r)!==s.charCodeAt(r)&&o.charAt(r).toLowerCase()!==s.charAt(r).toLowerCase());r++);o=s.substr(0,r)+o.substr(r)}return C.$hc.relative(o,s)}resolvePath($,n){if($.scheme===M.Schemas.file){const o=m.URI.file(C.$lc(d($),n));return $.with({authority:o.authority,path:o.path})}return n=k.$dg(n),$.with({path:C.$hc.resolve($.path,n)})}isAbsolutePath($){return!!$.path&&$.path[0]==="/"}isEqualAuthority($,n){return $===n||$!==void 0&&n!==void 0&&(0,A.$lf)($,n)}hasTrailingPathSeparator($,n=C.sep){if($.scheme===M.Schemas.file){const o=d($);return o.length>k.$eg(o).length&&o[o.length-1]===n}else{const o=$.path;return o.length>1&&o.charCodeAt(o.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test($.fsPath)}}removeTrailingPathSeparator($,n=C.sep){return(0,e.$2g)($,n)?$.with({path:$.path.substr(0,$.path.length-1)}):$}addTrailingPathSeparator($,n=C.sep){let o=!1;if($.scheme===M.Schemas.file){const s=d($);o=s!==void 0&&s.length===k.$eg(s).length&&s[s.length-1]===n}else{n="/";const s=$.path;o=s.length===1&&s.charCodeAt(s.length-1)===47}return!o&&!(0,e.$2g)($,n)?$.with({path:$.path+"/"}):$}}e.$Kg=y,e.$Lg=new y(()=>!1),e.$Mg=new y(b=>b.scheme===M.Schemas.file?!N.$e:!0),e.$Ng=new y(b=>!0),e.$Og=e.$Lg.isEqual.bind(e.$Lg),e.$Pg=e.$Lg.isEqualOrParent.bind(e.$Lg),e.$Qg=e.$Lg.getComparisonKey.bind(e.$Lg),e.$Rg=e.$Lg.basenameOrAuthority.bind(e.$Lg),e.$Sg=e.$Lg.basename.bind(e.$Lg),e.$Tg=e.$Lg.extname.bind(e.$Lg),e.$Ug=e.$Lg.dirname.bind(e.$Lg),e.$Vg=e.$Lg.joinPath.bind(e.$Lg),e.$Wg=e.$Lg.normalizePath.bind(e.$Lg),e.$Xg=e.$Lg.relativePath.bind(e.$Lg),e.$Yg=e.$Lg.resolvePath.bind(e.$Lg),e.$Zg=e.$Lg.isAbsolutePath.bind(e.$Lg),e.$1g=e.$Lg.isEqualAuthority.bind(e.$Lg),e.$2g=e.$Lg.hasTrailingPathSeparator.bind(e.$Lg),e.$3g=e.$Lg.removeTrailingPathSeparator.bind(e.$Lg),e.$4g=e.$Lg.addTrailingPathSeparator.bind(e.$Lg);function O(b,$){const n=[];for(let o=0;o<b.length;o++){const s=$(b[o]);b.some((r,i)=>i===o?!1:(0,e.$Pg)(s,$(r)))||n.push(b[o])}return n}var D;(function(b){b.META_DATA_LABEL="label",b.META_DATA_DESCRIPTION="description",b.META_DATA_SIZE="size",b.META_DATA_MIME="mime";function $(n){const o=new Map;n.path.substring(n.path.indexOf(";")+1,n.path.lastIndexOf(";")).split(";").forEach(i=>{const[c,h]=i.split(":");c&&h&&o.set(c,h)});const r=n.path.substring(0,n.path.indexOf(";"));return r&&o.set(b.META_DATA_MIME,r),o}b.parseMetaData=$})(D||(e.DataUri=D={}));function l(b,$,n){if($){let o=b.path;return o&&o[0]!==C.$hc.sep&&(o=C.$hc.sep+o),b.with({scheme:n,authority:$,path:o})}return b.with({scheme:n})}}),define(Pe[11],Re([1,0,24,14,5,6,23,21,131,40]),function(ee,e,k,M,C,N,A,m,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.Promises=e.$Fh=e.$Eh=e.$Dh=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=void 0,e.$7g=O,e.$8g=D,e.$9g=l,e.$0g=b,e.$$g=$,e.$_g=n,e.$ah=o,e.$bh=s,e.$jh=f,e.$kh=u,e.$lh=E,e.$mh=w,e.$nh=I,e.$Ch=pe,e.$Kh=we;function O(ce){return!!ce&&typeof ce.then=="function"}function D(ce){const K=new k.$ee,Z=ce(K.token),le=new Promise((fe,Te)=>{const ve=K.token.onCancellationRequested(()=>{ve.dispose(),Te(new M.$5)});Promise.resolve(Z).then(Ie=>{ve.dispose(),K.dispose(),fe(Ie)},Ie=>{ve.dispose(),K.dispose(),Te(Ie)})});return new class{cancel(){K.cancel(),K.dispose()}then(fe,Te){return le.then(fe,Te)}catch(fe){return this.then(void 0,fe)}finally(fe){return le.finally(fe)}}}function l(ce,K,Z){return new Promise((le,fe)=>{const Te=K.onCancellationRequested(()=>{Te.dispose(),le(Z)});ce.then(le,fe).finally(()=>Te.dispose())})}function b(ce,K){return new Promise((Z,le)=>{const fe=K.onCancellationRequested(()=>{fe.dispose(),le(new M.$5)});ce.then(Z,le).finally(()=>fe.dispose())})}async function $(ce){let K=-1;const Z=ce.map((le,fe)=>le.then(Te=>(K=fe,Te)));try{return await Promise.race(Z)}finally{ce.forEach((le,fe)=>{fe!==K&&le.cancel()})}}function n(ce,K,Z){let le;const fe=setTimeout(()=>{le?.(void 0),Z?.()},K);return Promise.race([ce.finally(()=>clearTimeout(fe)),new Promise(Te=>le=Te)])}function o(ce){return new Promise((K,Z)=>{const le=ce();O(le)?le.then(K,Z):K(le)})}function s(){let ce,K;return{promise:new Promise((le,fe)=>{ce=le,K=fe}),resolve:ce,reject:K}}class r{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(K){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=K,!this.b){const Z=()=>{if(this.b=null,this.f)return;const le=this.queue(this.d);return this.d=null,le};this.b=new Promise(le=>{this.a.then(Z,Z).then(le)})}return new Promise((Z,le)=>{this.b.then(Z,le)})}return this.a=K(),new Promise((Z,le)=>{this.a.then(fe=>{this.a=null,Z(fe)},fe=>{this.a=null,le(fe)})})}dispose(){this.f=!0}}e.$ch=r;class i{constructor(){this.a=Promise.resolve(null)}queue(K){return this.a=this.a.then(()=>K(),()=>K())}}e.$dh=i;class c{constructor(){this.a=new Map}queue(K,Z){const fe=(this.a.get(K)??Promise.resolve()).catch(()=>{}).then(Z).finally(()=>{this.a.get(K)===fe&&this.a.delete(K)});return this.a.set(K,fe),fe}}e.$eh=c;const h=(ce,K)=>{let Z=!0;const le=setTimeout(()=>{Z=!1,K()},ce);return{isTriggered:()=>Z,dispose:()=>{clearTimeout(le),Z=!1}}},t=ce=>{let K=!0;return queueMicrotask(()=>{K&&(K=!1,ce())}),{isTriggered:()=>K,dispose:()=>{K=!1}}};class p{constructor(K){this.defaultDelay=K,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(K,Z=this.defaultDelay){this.g=K,this.h(),this.b||(this.b=new Promise((fe,Te)=>{this.d=fe,this.f=Te}).then(()=>{if(this.b=null,this.d=null,this.g){const fe=this.g;return this.g=null,fe()}}));const le=()=>{this.a=null,this.d?.(null)};return this.a=Z===d.$4d?t(le):h(Z,le),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new M.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$fh=p;class a{constructor(K){this.a=new p(K),this.b=new r}trigger(K,Z){return this.a.trigger(()=>this.b.queue(K),Z)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$gh=a;class g{constructor(){this.a=!1,this.b=new Promise((K,Z)=>{this.d=K})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$hh=g;class v extends g{constructor(K){super(),this.f=setTimeout(()=>this.open(),K)}open(){clearTimeout(this.f),super.open()}}e.$ih=v;function f(ce,K){return K?new Promise((Z,le)=>{const fe=setTimeout(()=>{Te.dispose(),Z()},ce),Te=K.onCancellationRequested(()=>{clearTimeout(fe),Te.dispose(),le(new M.$5)})}):D(Z=>f(ce,Z))}function u(ce,K=0,Z){const le=setTimeout(()=>{ce(),Z&&fe.dispose()},K),fe=(0,N.$Sc)(()=>{clearTimeout(le),Z?.deleteAndLeak(fe)});return Z?.add(fe),fe}function E(ce){const K=[];let Z=0;const le=ce.length;function fe(){return Z<le?ce[Z++]():null}function Te(ve){ve!=null&&K.push(ve);const Ie=fe();return Ie?Ie.then(Te):Promise.resolve(K)}return Promise.resolve(null).then(Te)}function w(ce,K=le=>!!le,Z=null){let le=0;const fe=ce.length,Te=()=>{if(le>=fe)return Promise.resolve(Z);const ve=ce[le++];return Promise.resolve(ve()).then(Ae=>K(Ae)?Promise.resolve(Ae):Te())};return Te()}function I(ce,K=le=>!!le,Z=null){if(ce.length===0)return Promise.resolve(Z);let le=ce.length;const fe=()=>{le=-1;for(const Te of ce)Te.cancel?.()};return new Promise((Te,ve)=>{for(const Ie of ce)Ie.then(Ae=>{--le>=0&&K(Ae)?(fe(),Te(Ae)):le===0&&Te(Z)}).catch(Ae=>{--le>=0&&(fe(),ve(Ae))})})}class S{constructor(K){this.a=0,this.b=!1,this.f=K,this.g=[],this.d=0,this.h=new C.$7d}whenIdle(){return this.size>0?C.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(K){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((Z,le)=>{this.g.push({factory:K,c:Z,e:le}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const K=this.g.shift();this.d++;const Z=K.factory();Z.then(K.c,K.e),Z.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$oh=S;class P extends S{constructor(){super(1)}}e.$ph=P;class U{constructor(){this.a=new ae,this.b=0}queue(K){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,K())):this.a.run(this.b++,K())}}e.$qh=U;class Q{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const K=new De;return this.b.add(K),K.p}g(){for(const[,K]of this.a)if(K.size>0)return!1;return!0}queueSize(K,Z=A.$Lg){const le=Z.getComparisonKey(K);return this.a.get(le)?.size??0}queueFor(K,Z,le=A.$Lg){const fe=le.getComparisonKey(K);let Te=this.a.get(fe);if(!Te){Te=new P;const ve=this.f++,Ie=C.Event.once(Te.onDrained)(()=>{Te?.dispose(),this.a.delete(fe),this.h(),this.d?.deleteAndDispose(ve),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new N.$4c),this.d.set(ve,Ie),this.a.set(fe,Te)}return Te.queue(Z)}h(){this.g()&&this.j()}j(){for(const K of this.b)K.complete();this.b.clear()}dispose(){for(const[,K]of this.a)K.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$rh=Q;class H{constructor(K,Z){this.a=-1,typeof K=="function"&&typeof Z=="number"&&this.setIfNotSet(K,Z)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(K,Z){this.cancel(),this.a=setTimeout(()=>{this.a=-1,K()},Z)}setIfNotSet(K,Z){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,K()},Z))}}e.$sh=H;class L{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(K,Z,le=globalThis){this.cancel();const fe=le.setInterval(()=>{K()},Z);this.d=(0,N.$Sc)(()=>{le.clearInterval(fe),this.d=void 0})}dispose(){this.cancel()}}e.$th=L;class R{constructor(K,Z){this.b=-1,this.a=K,this.d=Z,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(K=this.d){this.cancel(),this.b=setTimeout(this.f,K)}get delay(){return this.d}set delay(K){this.d=K}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$uh=R;class F{constructor(K,Z){Z%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Z}ms is not a multiple of 1000ms.`),this.a=K,this.b=Z,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(K=this.b){K%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${K}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(K/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$vh=F;class T extends R{constructor(K,Z){super(K,Z),this.j=[]}work(K){this.j.push(K),this.isScheduled()||this.schedule()}h(){const K=this.j;this.j=[],this.a?.(K)}dispose(){this.j=[],super.dispose()}}e.$wh=T;class X extends N.$Uc{constructor(K,Z){super(),this.g=K,this.h=Z,this.a=[],this.b=this.B(new N.$Vc),this.f=!1}get pending(){return this.a.length}work(K){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+K.length>this.g.maxBufferedWork)return!1}else if(this.pending+K.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const Z of K)this.a.push(Z);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new R(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$xh=X,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$zh=(ce,K)=>{(0,m.$v)(()=>{if(Z)return;const le=Date.now()+15;K(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,le-Date.now())}}))});let Z=!1;return{dispose(){Z||(Z=!0)}}}:e.$zh=(ce,K,Z)=>{const le=ce.requestIdleCallback(K,typeof Z=="number"?{timeout:Z}:void 0);let fe=!1;return{dispose(){fe||(fe=!0,ce.cancelIdleCallback(le))}}},e.$yh=ce=>(0,e.$zh)(globalThis,ce)}();class re{constructor(K,Z){this.g=!1,this.d=()=>{try{this.j=Z()}catch(le){this.l=le}finally{this.g=!0}},this.f=(0,e.$zh)(K,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Ah=re;class me extends re{constructor(K){super(globalThis,K)}}e.$Bh=me;async function pe(ce,K,Z){let le;for(let fe=0;fe<Z;fe++)try{return await ce()}catch(Te){le=Te,await f(K)}throw le}class ae{isRunning(K){return typeof K=="number"?this.a?.taskId===K:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(K,Z,le){return this.a={taskId:K,cancel:()=>le?.(),promise:Z},Z.then(()=>this.d(K),()=>this.d(K)),Z}d(K){this.a&&K===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const K=this.b;this.b=void 0,K.run().then(K.promiseResolve,K.promiseReject)}}queue(K){if(this.b)this.b.run=K;else{const{promise:Z,resolve:le,reject:fe}=s();this.b={run:K,promise:Z,promiseResolve:le,promiseReject:fe}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Dh=ae;class be{constructor(K,Z=()=>Date.now()){this.d=K,this.f=Z,this.a=0,this.b=0}increment(){const K=this.f();return K-this.a>this.d&&(this.a=K,this.b=0),this.b++,this.b}}e.$Eh=be;var se;(function(ce){ce[ce.Resolved=0]="Resolved",ce[ce.Rejected=1]="Rejected"})(se||(se={}));class De{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((K,Z)=>{this.a=K,this.b=Z})}complete(K){return new Promise(Z=>{this.a(K),this.d={outcome:0,value:K},Z()})}error(K){return new Promise(Z=>{this.b(K),this.d={outcome:1,value:K},Z()})}cancel(){return this.error(new M.$5)}}e.$Fh=De;var Oe;(function(ce){async function K(le){let fe;const Te=await Promise.all(le.map(ve=>ve.then(Ie=>Ie,Ie=>{fe||(fe=Ie)})));if(typeof fe<"u")throw fe;return Te}ce.settled=K;function Z(le){return new Promise(async(fe,Te)=>{try{await le(fe,Te)}catch(ve){Te(ve)}})}ce.withAsyncBody=Z})(Oe||(e.Promises=Oe={}));class ie{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(K){this.a=void 0,this.b=void 0,this.d=!1,this.promise=K.then(Z=>(this.a=Z,this.d=!0,Z),Z=>{throw this.b=Z,this.d=!0,Z})}requireValue(){if(!this.d)throw new M.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Gh=ie;class q{constructor(K){this.b=K,this.a=new y.$V(()=>new ie(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Hh=q;var de;(function(ce){ce[ce.Initial=0]="Initial",ce[ce.DoneOK=1]="DoneOK",ce[ce.DoneError=2]="DoneError"})(de||(de={}));class Ne{static fromArray(K){return new Ne(Z=>{Z.emitMany(K)})}static fromPromise(K){return new Ne(async Z=>{Z.emitMany(await K)})}static fromPromises(K){return new Ne(async Z=>{await Promise.all(K.map(async le=>Z.emitOne(await le)))})}static merge(K){return new Ne(async Z=>{await Promise.all(K.map(async le=>{for await(const fe of le)Z.emitOne(fe)}))})}constructor(K){this.a=0,this.b=[],this.d=null,this.f=new C.$7d,queueMicrotask(async()=>{const Z={emitOne:le=>this.g(le),emitMany:le=>this.h(le),reject:le=>this.k(le)};try{await Promise.resolve(K(Z)),this.j()}catch(le){this.k(le)}finally{Z.emitOne=void 0,Z.emitMany=void 0,Z.reject=void 0}})}[Symbol.asyncIterator](){let K=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(K<this.b.length)return{done:!1,value:this.b[K++]};if(this.a===1)return{done:!0,value:void 0};await C.Event.toPromise(this.f.event)}while(!0)}}}static map(K,Z){return new Ne(async le=>{for await(const fe of K)le.emitOne(Z(fe))})}map(K){return Ne.map(this,K)}static filter(K,Z){return new Ne(async le=>{for await(const fe of K)Z(fe)&&le.emitOne(fe)})}filter(K){return Ne.filter(this,K)}static coalesce(K){return Ne.filter(K,Z=>!!Z)}coalesce(){return Ne.coalesce(this)}static async toPromise(K){const Z=[];for await(const le of K)Z.push(le);return Z}toPromise(){return Ne.toPromise(this)}g(K){this.a===0&&(this.b.push(K),this.f.fire())}h(K){this.a===0&&(this.b=this.b.concat(K),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(K){this.a===0&&(this.a=2,this.d=K,this.f.fire())}}e.$Ih=Ne,Ne.EMPTY=Ne.fromArray([]);class $e extends Ne{constructor(K,Z){super(Z),this.l=K}cancel(){this.l.cancel()}}e.$Jh=$e;function we(ce){const K=new k.$ee,Z=ce(K.token);return new $e(K,async le=>{const fe=K.token.onCancellationRequested(()=>{fe.dispose(),K.dispose(),le.reject(new M.$5)});try{for await(const Te of Z){if(K.token.isCancellationRequested)return;le.emitOne(Te)}fe.dispose(),K.dispose()}catch(Te){fe.dispose(),K.dispose(),le.reject(Te)}})}class ge{constructor(){this.a=new De,this.b=new Ne(le=>{if(K){le.reject(K);return}return Z&&le.emitMany(Z),this.d=fe=>le.reject(fe),this.f=fe=>le.emitOne(fe),this.a.p});let K,Z;this.f=le=>{Z||(Z=[]),Z.push(le)},this.d=le=>{K||(K=le)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(K){this.d(K),this.a.complete()}emitOne(K){this.f(K)}}e.$Lh=ge}),define(Pe[34],Re([1,0,18,11,46,28,19,21,15]),function(ee,e,k,M,C,N,A,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_j=e.$$j=void 0,e.$0j=y,e.$ak=$,e.$bk=P,e.$ck=U,e.$dk=Q,e.$ek=H,e.$fk=L,e.$gk=X;function y(){return Object.create(null)}e.$$j="**",e.$_j="/";const O="[/\\\\]",D="[^/\\\\]",l=/\//g;function b(re,me){switch(re){case 0:return"";case 1:return`${D}*?`;default:return`(?:${O}|${D}+${O}${me?`|${O}${D}+`:""})*?`}}function $(re,me){if(!re)return[];const pe=[];let ae=!1,be=!1,se="";for(const De of re){switch(De){case me:if(!ae&&!be){pe.push(se),se="";continue}break;case"{":ae=!0;break;case"}":ae=!1;break;case"[":be=!0;break;case"]":be=!1;break}se+=De}return se&&pe.push(se),pe}function n(re){if(!re)return"";let me="";const pe=$(re,e.$_j);if(pe.every(ae=>ae===e.$$j))me=".*";else{let ae=!1;pe.forEach((be,se)=>{if(be===e.$$j){if(ae)return;me+=b(2,se===pe.length-1)}else{let De=!1,Oe="",ie=!1,q="";for(const de of be){if(de!=="}"&&De){Oe+=de;continue}if(ie&&(de!=="]"||!q)){let Ne;de==="-"?Ne=de:(de==="^"||de==="!")&&!q?Ne="^":de===e.$_j?Ne="":Ne=(0,d.$Ze)(de),q+=Ne;continue}switch(de){case"{":De=!0;continue;case"[":ie=!0;continue;case"}":{const $e=`(?:${$(Oe,",").map(we=>n(we)).join("|")})`;me+=$e,De=!1,Oe="";break}case"]":{me+="["+q+"]",ie=!1,q="";break}case"?":me+=D;continue;case"*":me+=b(1);continue;default:me+=(0,d.$Ze)(de)}}se<pe.length-1&&(pe[se+1]!==e.$$j||se+2<pe.length)&&(me+=O)}ae=be===e.$$j})}return me}const o=/^\*\*\/\*\.[\w\.-]+$/,s=/^\*\*\/([\w\.-]+)\/?$/,r=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,i=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,h=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new N.$Ec(1e4),p=function(){return!1},a=function(){return null};function g(re,me){if(!re)return a;let pe;typeof re!="string"?pe=re.pattern:pe=re,pe=pe.trim();const ae=`${pe}_${!!me.trimForExclusions}`;let be=t.get(ae);if(be)return v(be,re);let se;return o.test(pe)?be=u(pe.substr(4),pe):(se=s.exec(f(pe,me)))?be=E(se[1],pe):(me.trimForExclusions?i:r).test(pe)?be=w(pe,me):(se=c.exec(f(pe,me)))?be=I(se[1].substr(1),pe,!0):(se=h.exec(f(pe,me)))?be=I(se[1],pe,!1):be=S(pe),t.set(ae,be),v(be,re)}function v(re,me){if(typeof me=="string")return re;const pe=function(ae,be){return(0,C.$ig)(ae,me.base,!m.$e)?re((0,d.$5e)(ae.substr(me.base.length),A.sep),be):null};return pe.allBasenames=re.allBasenames,pe.allPaths=re.allPaths,pe.basenames=re.basenames,pe.patterns=re.patterns,pe}function f(re,me){return me.trimForExclusions&&re.endsWith("/**")?re.substr(0,re.length-2):re}function u(re,me){return function(pe,ae){return typeof pe=="string"&&pe.endsWith(re)?me:null}}function E(re,me){const pe=`/${re}`,ae=`\\${re}`,be=function(De,Oe){return typeof De!="string"?null:Oe?Oe===re?me:null:De===re||De.endsWith(pe)||De.endsWith(ae)?me:null},se=[re];return be.basenames=se,be.patterns=[me],be.allBasenames=se,be}function w(re,me){const pe=T(re.slice(1,-1).split(",").map(Oe=>g(Oe,me)).filter(Oe=>Oe!==a),re),ae=pe.length;if(!ae)return a;if(ae===1)return pe[0];const be=function(Oe,ie){for(let q=0,de=pe.length;q<de;q++)if(pe[q](Oe,ie))return re;return null},se=pe.find(Oe=>!!Oe.allBasenames);se&&(be.allBasenames=se.allBasenames);const De=pe.reduce((Oe,ie)=>ie.allPaths?Oe.concat(ie.allPaths):Oe,[]);return De.length&&(be.allPaths=De),be}function I(re,me,pe){const ae=A.sep===A.$hc.sep,be=ae?re:re.replace(l,A.sep),se=A.sep+be,De=A.$hc.sep+re;let Oe;return pe?Oe=function(ie,q){return typeof ie=="string"&&(ie===be||ie.endsWith(se)||!ae&&(ie===re||ie.endsWith(De)))?me:null}:Oe=function(ie,q){return typeof ie=="string"&&(ie===be||!ae&&ie===re)?me:null},Oe.allPaths=[(pe?"*/":"./")+re],Oe}function S(re){try{const me=new RegExp(`^${n(re)}$`);return function(pe){return me.lastIndex=0,typeof pe=="string"&&me.test(pe)?re:null}}catch{return a}}function P(re,me,pe){return!re||typeof me!="string"?!1:U(re)(me,void 0,pe)}function U(re,me={}){if(!re)return p;if(typeof re=="string"||Q(re)){const pe=g(re,me);if(pe===a)return p;const ae=function(be,se){return!!pe(be,se)};return pe.allBasenames&&(ae.allBasenames=pe.allBasenames),pe.allPaths&&(ae.allPaths=pe.allPaths),ae}return R(re,me)}function Q(re){const me=re;return me?typeof me.base=="string"&&typeof me.pattern=="string":!1}function H(re){return re.allBasenames||[]}function L(re){return re.allPaths||[]}function R(re,me){const pe=T(Object.getOwnPropertyNames(re).map(Oe=>F(Oe,re[Oe],me)).filter(Oe=>Oe!==a)),ae=pe.length;if(!ae)return a;if(!pe.some(Oe=>!!Oe.requiresSiblings)){if(ae===1)return pe[0];const Oe=function(de,Ne){let $e;for(let we=0,ge=pe.length;we<ge;we++){const ce=pe[we](de,Ne);if(typeof ce=="string")return ce;(0,M.$7g)(ce)&&($e||($e=[]),$e.push(ce))}return $e?(async()=>{for(const we of $e){const ge=await we;if(typeof ge=="string")return ge}return null})():null},ie=pe.find(de=>!!de.allBasenames);ie&&(Oe.allBasenames=ie.allBasenames);const q=pe.reduce((de,Ne)=>Ne.allPaths?de.concat(Ne.allPaths):de,[]);return q.length&&(Oe.allPaths=q),Oe}const be=function(Oe,ie,q){let de,Ne;for(let $e=0,we=pe.length;$e<we;$e++){const ge=pe[$e];ge.requiresSiblings&&q&&(ie||(ie=(0,A.$oc)(Oe)),de||(de=ie.substr(0,ie.length-(0,A.$pc)(Oe).length)));const ce=ge(Oe,ie,de,q);if(typeof ce=="string")return ce;(0,M.$7g)(ce)&&(Ne||(Ne=[]),Ne.push(ce))}return Ne?(async()=>{for(const $e of Ne){const we=await $e;if(typeof we=="string")return we}return null})():null},se=pe.find(Oe=>!!Oe.allBasenames);se&&(be.allBasenames=se.allBasenames);const De=pe.reduce((Oe,ie)=>ie.allPaths?Oe.concat(ie.allPaths):Oe,[]);return De.length&&(be.allPaths=De),be}function F(re,me,pe){if(me===!1)return a;const ae=g(re,pe);if(ae===a)return a;if(typeof me=="boolean")return ae;if(me){const be=me.when;if(typeof be=="string"){const se=(De,Oe,ie,q)=>{if(!q||!ae(De,Oe))return null;const de=be.replace("$(basename)",()=>ie),Ne=q(de);return(0,M.$7g)(Ne)?Ne.then($e=>$e?re:null):Ne?re:null};return se.requiresSiblings=!0,se}}return ae}function T(re,me){const pe=re.filter(Oe=>!!Oe.basenames);if(pe.length<2)return re;const ae=pe.reduce((Oe,ie)=>{const q=ie.basenames;return q?Oe.concat(q):Oe},[]);let be;if(me){be=[];for(let Oe=0,ie=ae.length;Oe<ie;Oe++)be.push(me)}else be=pe.reduce((Oe,ie)=>{const q=ie.patterns;return q?Oe.concat(q):Oe},[]);const se=function(Oe,ie){if(typeof Oe!="string")return null;if(!ie){let de;for(de=Oe.length;de>0;de--){const Ne=Oe.charCodeAt(de-1);if(Ne===47||Ne===92)break}ie=Oe.substr(de)}const q=ae.indexOf(ie);return q!==-1?be[q]:null};se.basenames=ae,se.patterns=be,se.allBasenames=ae;const De=re.filter(Oe=>!Oe.basenames);return De.push(se),De}function X(re,me){return(0,k.$ub)(re,me,(pe,ae)=>typeof pe=="string"&&typeof ae=="string"?pe===ae:typeof pe!="string"&&typeof ae!="string"?pe.base===ae.base&&pe.pattern===ae.pattern:!1)}}),define(Pe[54],Re([1,0,14,132,23,15,2]),function(ee,e,k,M,C,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fk=e.MarkdownStringTextNewlineStyle=void 0,e.$Gk=y,e.$Hk=O,e.$Ik=D,e.$Jk=l,e.$Kk=b,e.$Lk=$,e.$Mk=n,e.$Nk=o;var m;(function(s){s[s.Paragraph=0]="Paragraph",s[s.Break=1]="Break"})(m||(e.MarkdownStringTextNewlineStyle=m={}));class d{constructor(r="",i=!1){if(this.value=r,typeof this.value!="string")throw(0,k.$7)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(r,i=0){return this.value+=l(this.supportThemeIcons?(0,M.$zk)(r):r).replace(/([ \t]+)/g,(c,h)=>"&nbsp;".repeat(h.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===1?`\\
`:`

`),this}appendMarkdown(r){return this.value+=r,this}appendCodeblock(r,i){return this.value+=`
${b(i,r)}
`,this}appendLink(r,i,c){return this.value+="[",this.value+=this.c(i,"]"),this.value+="](",this.value+=this.c(String(r),")"),c&&(this.value+=` "${this.c(this.c(c,'"'),")")}"`),this.value+=")",this}c(r,i){const c=new RegExp((0,N.$Ze)(i),"g");return r.replace(c,(h,t)=>r.charAt(t-1)!=="\\"?`\\${h}`:h)}}e.$Fk=d;function y(s){return O(s)?!s.value:Array.isArray(s)?s.every(y):!0}function O(s){return s instanceof d?!0:s&&typeof s=="object"?typeof s.value=="string"&&(typeof s.isTrusted=="boolean"||typeof s.isTrusted=="object"||s.isTrusted===void 0)&&(typeof s.supportThemeIcons=="boolean"||s.supportThemeIcons===void 0):!1}function D(s,r){return s===r?!0:!s||!r?!1:s.value===r.value&&s.isTrusted===r.isTrusted&&s.supportThemeIcons===r.supportThemeIcons&&s.supportHtml===r.supportHtml&&(s.baseUri===r.baseUri||!!s.baseUri&&!!r.baseUri&&(0,C.$Og)(A.URI.from(s.baseUri),A.URI.from(r.baseUri)))}function l(s){return s.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function b(s,r){const i=s.match(/^`+/gm)?.reduce((h,t)=>h.length>t.length?h:t).length??0,c=i>=3?i+1:3;return[`${"`".repeat(c)}${r}`,s,`${"`".repeat(c)}`].join(`
`)}function $(s){return s.replace(/"/g,"&quot;")}function n(s){return s&&s.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function o(s){const r=[],i=s.split("|").map(h=>h.trim());s=i[0];const c=i[1];if(c){const h=/height=(\d+)/.exec(c),t=/width=(\d+)/.exec(c),p=h?h[1]:"",a=t?t[1]:"",g=isFinite(parseInt(a)),v=isFinite(parseInt(p));g&&r.push(`width="${a}"`),v&&r.push(`height="${p}"`)}return{href:s,dimensions:r}}}),define(Pe[92],Re([1,0,18,46,19,21,23,15]),function(ee,e,k,M,C,N,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hw=d,e.$iw=O,e.$jw=l,e.$kw=b,e.$lw=s,e.$mw=i,e.$nw=c,e.$ow=h,e.$pw=t,e.$qw=p;function d(g,v){const{os:f,tildify:u,relative:E}=v;if(E){const S=y(g,E,f);if(typeof S=="string")return S}let w=g.fsPath;if(f===1&&!N.$c?w=w.replace(/\//g,"\\"):f!==1&&N.$c&&(w=w.replace(/\\/g,"/")),f!==1&&u?.userHome){const S=u.userHome.fsPath;let P;g.scheme!==u.userHome.scheme&&g.path[0]===C.$hc.sep&&g.path[1]!==C.$hc.sep?P=u.userHome.with({path:g.path}).fsPath:P=w,w=l(P,S,f)}return(f===1?C.$gc:C.$hc).normalize(O(w,f===1))}function y(g,v,f){const u=f===1?C.$gc:C.$hc,E=f===3?A.$Lg:A.$Ng,w=v.getWorkspace(),I=(0,k.$Ob)(w.folders);if(!I)return;g.scheme!==I.uri.scheme&&g.path[0]===C.$hc.sep&&g.path[1]!==C.$hc.sep&&(g=I.uri.with({path:g.path}));const S=v.getWorkspaceFolder(g);if(!S)return;let P;if(E.isEqual(S.uri,g)?P="":P=E.relativePath(S.uri,g)??"",P&&(P=u.normalize(P)),w.folders.length>1&&!v.noPrefix){const U=S.name?S.name:E.basenameOrAuthority(S.uri);P=P?`${U} \u2022 ${P}`:U}return P}function O(g,v=N.$c){return(0,M.$mg)(g,v)?g.charAt(0).toUpperCase()+g.slice(1):g}let D=Object.create(null);function l(g,v,f=N.OS){if(f===1||!g||!v)return g;let u=D.original===v?D.normalized:void 0;u||(u=v,N.$c&&(u=(0,M.$cg)(u)),u=`${(0,m.$6e)(u,C.$hc.sep)}${C.$hc.sep}`,D={original:v,normalized:u});let E=g;return N.$c&&(E=(0,M.$cg)(E)),(f===3?E.startsWith(u):(0,m.$mf)(E,u))?`~/${E.substr(u.length)}`:g}function b(g,v){return g.replace(/^~($|\/|\\)/,`${v}$1`)}const $="\u2026",n="\\\\",o="~";function s(g,v=C.sep){const f=new Array(g.length);let u=!1;for(let E=0;E<g.length;E++){const w=g[E];if(w===""){f[E]=`.${v}`;continue}if(!w){f[E]=w;continue}u=!0;let I="",S=w;S.indexOf(n)===0?(I=S.substr(0,S.indexOf(n)+n.length),S=S.substr(S.indexOf(n)+n.length)):S.indexOf(v)===0?(I=S.substr(0,S.indexOf(v)+v.length),S=S.substr(S.indexOf(v)+v.length)):S.indexOf(o)===0&&(I=S.substr(0,S.indexOf(o)+o.length),S=S.substr(S.indexOf(o)+o.length));const P=S.split(v);for(let U=1;u&&U<=P.length;U++)for(let Q=P.length-U;u&&Q>=0;Q--){u=!1;let H=P.slice(Q,Q+U).join(v);for(let L=0;!u&&L<g.length;L++)if(L!==E&&g[L]&&g[L].indexOf(H)>-1){const R=Q+U===P.length,F=Q>0&&g[L].indexOf(v)>-1?v+H:H,T=g[L].endsWith(F);u=!R||T}if(!u){let L="";(P[0].endsWith(":")||I!=="")&&(Q===1&&(Q=0,U++,H=P[0]+v+H),Q>0&&(L=P[0]+v),L=I+L),Q>0&&(L=L+$+v),L=L+H,Q+U<P.length&&(L=L+v+$),f[E]=L}}u&&(f[E]=w)}return f}var r;(function(g){g[g.TEXT=0]="TEXT",g[g.VARIABLE=1]="VARIABLE",g[g.SEPARATOR=2]="SEPARATOR"})(r||(r={}));function i(g,v=Object.create(null)){const f=[];let u=!1,E="";for(const w of g)if(w==="$"||u&&w==="{")E&&f.push({value:E,type:r.TEXT}),E="",u=!0;else if(w==="}"&&u){const I=v[E];if(typeof I=="string")I.length&&f.push({value:I,type:r.VARIABLE});else if(I){const S=f[f.length-1];(!S||S.type!==r.SEPARATOR)&&f.push({value:I.label,type:r.SEPARATOR})}E="",u=!1}else E+=w;return E&&!u&&f.push({value:E,type:r.TEXT}),f.filter((w,I)=>{if(w.type===r.SEPARATOR){const S=f[I-1],P=f[I+1];return[S,P].every(U=>U&&(U.type===r.VARIABLE||U.type===r.TEXT)&&U.value.length>0)}return!0}).map(w=>w.value).join("")}function c(g,v){return N.$d||v?g.replace(/\(&&\w\)|&&/g,"").replace(/&/g,N.$d?"&":"&&"):g.replace(/&&|&/g,f=>f==="&"?"&&":"&")}function h(g,v){return N.$d||v?g.replace(/\(&&\w\)|&&/g,""):N.$c?g.replace(/&&|&/g,f=>f==="&"?"&&":"&"):g.replace(/&&/g,"_")}function t(g){return g.replace(/&/g,"&&")}function p(g){if(g.endsWith("]")){const v=g.lastIndexOf(" [",g.length-2);if(v!==-1){const f=a(g.substring(0,v)),u=g.substring(v);return{name:f.name+u,parentPath:f.parentPath}}}return a(g)}function a(g){const v=g.indexOf("/")!==-1?C.$hc:C.$gc,f=v.basename(g),u=v.dirname(g);return f.length?{name:f,parentPath:u}:{name:u,parentPath:""}}}),define(Pe[133],Re([1,0,22,2]),function(ee,e,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mn=e.$ln=void 0,e.$nn=m,e.$on=y,e.$pn=O;function C(D){return D.toJSON()}class N{constructor(l){this.a=l}transformIncoming(l){const b=this.a.transformIncoming(l);return b===l?l:C(M.URI.from(b))}transformOutgoing(l){const b=this.a.transformOutgoing(l);return b===l?l:C(M.URI.from(b))}transformOutgoingURI(l){const b=this.a.transformOutgoing(l);return b===l?l:M.URI.from(b)}transformOutgoingScheme(l){return this.a.transformOutgoingScheme(l)}}e.$ln=N,e.$mn=new class{transformIncoming(D){return D}transformOutgoing(D){return D}transformOutgoingURI(D){return D}transformOutgoingScheme(D){return D}};function A(D,l,b){if(!D||b>200)return null;if(typeof D=="object"){if(D instanceof M.URI)return l.transformOutgoing(D);for(const $ in D)if(Object.hasOwnProperty.call(D,$)){const n=A(D[$],l,b+1);n!==null&&(D[$]=n)}}return null}function m(D,l){const b=A(D,l,0);return b===null?D:b}function d(D,l,b,$){if(!D||$>200)return null;if(typeof D=="object"){if(D.$mid===1)return b?M.URI.revive(l.transformIncoming(D)):l.transformIncoming(D);if(D instanceof k.$ue)return null;for(const n in D)if(Object.hasOwnProperty.call(D,n)){const o=d(D[n],l,b,$+1);o!==null&&(D[n]=o)}}return null}function y(D,l){const b=d(D,l,!1,0);return b===null?D:b}function O(D,l){const b=d(D,l,!0,0);return b===null?D:b}}),define(Pe[35],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eg=void 0,e.$Dg=M;const k=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function M(C){return k.test(C)}e.$Eg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let C;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?C=crypto.getRandomValues.bind(crypto):C=function(m){for(let d=0;d<m.length;d++)m[d]=Math.floor(Math.random()*256);return m};const N=new Uint8Array(16),A=[];for(let m=0;m<256;m++)A.push(m.toString(16).padStart(2,"0"));return function(){C(N),N[6]=N[6]&15|64,N[8]=N[8]&63|128;let d=0,y="";return y+=A[N[d++]],y+=A[N[d++]],y+=A[N[d++]],y+=A[N[d++]],y+="-",y+=A[N[d++]],y+=A[N[d++]],y+="-",y+=A[N[d++]],y+=A[N[d++]],y+="-",y+=A[N[d++]],y+=A[N[d++]],y+="-",y+=A[N[d++]],y+=A[N[d++]],y+=A[N[d++]],y+=A[N[d++]],y+=A[N[d++]],y+=A[N[d++]],y}}()}),define(Pe[134],Re([1,0,18,39,35]),function(ee,e,k,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mt=e.$Kt=void 0,e.$It=N,e.$Jt=A,e.$Lt=y;function N(D){return{asString:async()=>D,asFile:()=>{},value:typeof D=="string"?D:void 0}}function A(D,l,b){const $={id:(0,C.$Eg)(),name:D,uri:l,data:b};return{asString:async()=>"",asFile:()=>$,value:void 0}}class m{constructor(){this.a=new Map}get size(){let l=0;for(const b of this.a)l++;return l}has(l){return this.a.has(this.b(l))}matches(l){const b=[...this.a.keys()];return M.Iterable.some(this,([$,n])=>n.asFile())&&b.push("files"),O(d(l),b)}get(l){return this.a.get(this.b(l))?.[0]}append(l,b){const $=this.a.get(l);$?$.push(b):this.a.set(this.b(l),[b])}replace(l,b){this.a.set(this.b(l),[b])}delete(l){this.a.delete(this.b(l))}*[Symbol.iterator](){for(const[l,b]of this.a)for(const $ of b)yield[l,$]}b(l){return d(l)}}e.$Kt=m;function d(D){return D.toLowerCase()}function y(D,l){return O(d(D),l.map(d))}function O(D,l){if(D==="*/*")return l.length>0;if(l.includes(D))return!0;const b=D.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!b)return!1;const[$,n,o]=b;return o==="*"?l.some(s=>s.startsWith(n+"/")):!1}e.$Mt=Object.freeze({create:D=>(0,k.$Mb)(D.map(l=>l.toString())).join(`\r
`),split:D=>D.split(`\r
`),parse:D=>e.$Mt.split(D).filter(l=>!l.startsWith("#"))})}),define(Pe[135],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$Pt=M;var k;(function(C){C[C.Unknown=0]="Unknown",C[C.Invalid=3]="Invalid",C[C.LF=1]="LF",C[C.CRLF=2]="CRLF"})(k||(e.StringEOL=k={}));function M(C){let N=0,A=0,m=0,d=0;for(let y=0,O=C.length;y<O;y++){const D=C.charCodeAt(y);D===13?(N===0&&(A=y),N++,y+1<O&&C.charCodeAt(y+1)===10?(d|=2,y++):d|=3,m=y+1):D===10&&(d|=1,N===0&&(A=y),N++,m=y+1)}return N===0&&(A=C.length),[N,A,C.length-m,d]}}),define(Pe[136],Re([1,0,15,21,22]),function(ee,e,k,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xt=void 0,e.$vt=O,e.$wt=D;let N;function A(){return N||(N=new TextDecoder("UTF-16LE")),N}let m;function d(){return m||(m=new TextDecoder("UTF-16BE")),m}let y;function O(){return y||(y=M.$x()?A():d()),y}function D($,n,o){const s=new Uint16Array($.buffer,n,o);return o>0&&(s[0]===65279||s[0]===65534)?l($,n,o):A().decode(s)}function l($,n,o){const s=[];let r=0;for(let i=0;i<o;i++){const c=C.$we($,n);n+=2,s[r++]=String.fromCharCode(c)}return s.join("")}class b{constructor(n){this.a=n|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const n=new Uint16Array(this.b.buffer,0,this.d);return O().decode(n)}f(){const n=this.e();this.d=0,this.c===null?this.c=[n]:this.c[this.c.length]=n}appendCharCode(n){const o=this.a-this.d;o<=1&&(o===0||k.$pf(n))&&this.f(),this.b[this.d++]=n}appendASCIICharCode(n){this.d===this.a&&this.f(),this.b[this.d++]=n}appendString(n){const o=n.length;if(this.d+o>=this.a){this.f(),this.c[this.c.length]=n;return}for(let s=0;s<o;s++)this.b[this.d++]=n.charCodeAt(s)}}e.$xt=b}),define(Pe[137],Re([1,0,22,136]),function(ee,e,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yt=void 0,e.$zt=A;function C(d){return d.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class N{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(y,O,D,l){this.oldPosition=y,this.oldText=O,this.newPosition=D,this.newText=l}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${C(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${C(this.oldText)}")`:`(replace@${this.oldPosition} "${C(this.oldText)}" with "${C(this.newText)}")`}static a(y){return 4+2*y.length}static c(y,O,D){const l=O.length;k.$ze(y,l,D),D+=4;for(let b=0;b<l;b++)k.$xe(y,O.charCodeAt(b),D),D+=2;return D}static d(y,O){const D=k.$ye(y,O);return O+=4,(0,M.$wt)(y,O,D)}writeSize(){return 8+N.a(this.oldText)+N.a(this.newText)}write(y,O){return k.$ze(y,this.oldPosition,O),O+=4,k.$ze(y,this.newPosition,O),O+=4,O=N.c(y,this.oldText,O),O=N.c(y,this.newText,O),O}static read(y,O,D){const l=k.$ye(y,O);O+=4;const b=k.$ye(y,O);O+=4;const $=N.d(y,O);O+=N.a($);const n=N.d(y,O);return O+=N.a(n),D.push(new N(l,$,b,n)),O}}e.$yt=N;function A(d,y){return d===null||d.length===0?y:new m(d,y).compress()}class m{constructor(y,O){this.a=y,this.c=O,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let y=0,O=0,D=this.n(y),l=this.l(O);for(;y<this.f||O<this.h;){if(D===null){this.k(l),l=this.l(++O);continue}if(l===null){this.m(D),D=this.n(++y);continue}if(l.oldEnd<=D.newPosition){this.k(l),l=this.l(++O);continue}if(D.newEnd<=l.oldPosition){this.m(D),D=this.n(++y);continue}if(l.oldPosition<D.newPosition){const[s,r]=m.r(l,D.newPosition-l.oldPosition);this.k(s),l=r;continue}if(D.newPosition<l.oldPosition){const[s,r]=m.q(D,l.oldPosition-D.newPosition);this.m(s),D=r;continue}let n,o;if(l.oldEnd===D.newEnd)n=D,o=l,D=this.n(++y),l=this.l(++O);else if(l.oldEnd<D.newEnd){const[s,r]=m.q(D,l.oldLength);n=s,o=l,D=r,l=this.l(++O)}else{const[s,r]=m.r(l,D.newLength);n=D,o=s,D=this.n(++y),l=r}this.d[this.e++]=new N(n.oldPosition,n.oldText,o.newPosition,o.newText),this.g+=n.newLength-n.oldLength,this.j+=o.newLength-o.oldLength}const b=m.s(this.d);return m.t(b)}k(y){this.d[this.e++]=m.o(this.g,y),this.j+=y.newLength-y.oldLength}l(y){return y<this.h?this.c[y]:null}m(y){this.d[this.e++]=m.p(this.j,y),this.g+=y.newLength-y.oldLength}n(y){return y<this.f?this.a[y]:null}static o(y,O){return new N(O.oldPosition-y,O.oldText,O.newPosition,O.newText)}static p(y,O){return new N(O.oldPosition,O.oldText,O.newPosition+y,O.newText)}static q(y,O){const D=y.newText.substr(0,O),l=y.newText.substr(O);return[new N(y.oldPosition,y.oldText,y.newPosition,D),new N(y.oldEnd,"",y.newPosition+O,l)]}static r(y,O){const D=y.oldText.substr(0,O),l=y.oldText.substr(O);return[new N(y.oldPosition,D,y.newPosition,y.newText),new N(y.oldPosition+O,l,y.newEnd,"")]}static s(y){if(y.length===0)return y;const O=[];let D=0,l=y[0];for(let b=1;b<y.length;b++){const $=y[b];l.oldEnd===$.oldPosition?l=new N(l.oldPosition,l.oldText+$.oldText,l.newPosition,l.newText+$.newText):(O[D++]=l,l=$)}return O[D++]=l,O}static t(y){if(y.length===0)return y;const O=[];let D=0;for(let l=0;l<y.length;l++){const b=y[l];b.oldText!==b.newText&&(O[D++]=b)}return O}}}),define(Pe[138],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ns=void 0,e.$Ns={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Pe[139],Re([1,0,34,19]),function(ee,e,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wt=C,e.$Xt=N;function C(A,m,d,y,O,D){if(Array.isArray(A)){let l=0;for(const b of A){const $=C(b,m,d,y,O,D);if($===10)return $;$>l&&(l=$)}return l}else{if(typeof A=="string")return y?A==="*"?5:A===d?10:0:0;if(A){const{language:l,pattern:b,scheme:$,hasAccessToAllModels:n,notebookType:o}=A;if(!y&&!n)return 0;o&&O&&(m=O);let s=0;if($)if($===m.scheme)s=10;else if($==="*")s=5;else return 0;if(l)if(l===d)s=10;else if(l==="*")s=Math.max(s,5);else return 0;if(o)if(o===D)s=10;else if(o==="*"&&D!==void 0)s=Math.max(s,5);else return 0;if(b){let r;if(typeof b=="string"?r=b:r={...b,base:(0,M.$ic)(b.base)},r===m.fsPath||(0,k.$bk)(r,m.fsPath))s=10;else return 0}return s}else return 0}}function N(A){return typeof A=="string"?!1:Array.isArray(A)?A.some(N):!!A.notebookType}}),define(Pe[140],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$du=e.$cu=e.IndentAction=void 0;var k;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(k||(e.IndentAction=k={}));class M{constructor(m){if(this.e=null,this.f=!1,this.open=m.open,this.close=m.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(m.notIn))for(let d=0,y=m.notIn.length;d<y;d++)switch(m.notIn[d]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(m){switch(m){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(m,d){if(m.getTokenCount()===0)return!0;const y=m.findTokenIndexAtOffset(d-2),O=m.getStandardTokenType(y);return this.isOK(O)}g(m,d){for(let y=m;y<=d;y++){const O=String.fromCharCode(y);if(!this.open.includes(O)&&!this.close.includes(O))return O}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$cu=M;class C{constructor(m){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const d of m)N(this.autoClosingPairsOpenByStart,d.open.charAt(0),d),N(this.autoClosingPairsOpenByEnd,d.open.charAt(d.open.length-1),d),N(this.autoClosingPairsCloseByStart,d.close.charAt(0),d),N(this.autoClosingPairsCloseByEnd,d.close.charAt(d.close.length-1),d),d.close.length===1&&d.open.length===1&&N(this.autoClosingPairsCloseSingleChar,d.close,d)}}e.$du=C;function N(A,m,d){A.has(m)?A.get(m).push(d):A.set(m,[d])}}),define(Pe[141],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kC=e.NodeColor=e.$jC=void 0,e.$lC=C,e.$mC=N,e.$nC=y,e.$oC=O,e.$pC=D,e.$qC=l,e.$rC=b,e.$sC=$;class k{constructor(o,s){this.piece=o,this.color=s,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$kC)return C(this.right);let o=this;for(;o.parent!==e.$kC&&o.parent.left!==o;)o=o.parent;return o.parent===e.$kC?e.$kC:o.parent}prev(){if(this.left!==e.$kC)return N(this.left);let o=this;for(;o.parent!==e.$kC&&o.parent.right!==o;)o=o.parent;return o.parent===e.$kC?e.$kC:o.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$jC=k;var M;(function(n){n[n.Black=0]="Black",n[n.Red=1]="Red"})(M||(e.NodeColor=M={})),e.$kC=new k(null,0),e.$kC.parent=e.$kC,e.$kC.left=e.$kC,e.$kC.right=e.$kC,e.$kC.color=0;function C(n){for(;n.left!==e.$kC;)n=n.left;return n}function N(n){for(;n.right!==e.$kC;)n=n.right;return n}function A(n){return n===e.$kC?0:n.size_left+n.piece.length+A(n.right)}function m(n){return n===e.$kC?0:n.lf_left+n.piece.lineFeedCnt+m(n.right)}function d(){e.$kC.parent=e.$kC}function y(n,o){const s=o.right;s.size_left+=o.size_left+(o.piece?o.piece.length:0),s.lf_left+=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),o.right=s.left,s.left!==e.$kC&&(s.left.parent=o),s.parent=o.parent,o.parent===e.$kC?n.root=s:o.parent.left===o?o.parent.left=s:o.parent.right=s,s.left=o,o.parent=s}function O(n,o){const s=o.left;o.left=s.right,s.right!==e.$kC&&(s.right.parent=o),s.parent=o.parent,o.size_left-=s.size_left+(s.piece?s.piece.length:0),o.lf_left-=s.lf_left+(s.piece?s.piece.lineFeedCnt:0),o.parent===e.$kC?n.root=s:o===o.parent.right?o.parent.right=s:o.parent.left=s,s.right=o,o.parent=s}function D(n,o){let s,r;if(o.left===e.$kC?(r=o,s=r.right):o.right===e.$kC?(r=o,s=r.left):(r=C(o.right),s=r.right),r===n.root){n.root=s,s.color=0,o.detach(),d(),n.root.parent=e.$kC;return}const i=r.color===1;if(r===r.parent.left?r.parent.left=s:r.parent.right=s,r===o?(s.parent=r.parent,$(n,s)):(r.parent===o?s.parent=r:s.parent=r.parent,$(n,s),r.left=o.left,r.right=o.right,r.parent=o.parent,r.color=o.color,o===n.root?n.root=r:o===o.parent.left?o.parent.left=r:o.parent.right=r,r.left!==e.$kC&&(r.left.parent=r),r.right!==e.$kC&&(r.right.parent=r),r.size_left=o.size_left,r.lf_left=o.lf_left,$(n,r)),o.detach(),s.parent.left===s){const h=A(s),t=m(s);if(h!==s.parent.size_left||t!==s.parent.lf_left){const p=h-s.parent.size_left,a=t-s.parent.lf_left;s.parent.size_left=h,s.parent.lf_left=t,b(n,s.parent,p,a)}}if($(n,s.parent),i){d();return}let c;for(;s!==n.root&&s.color===0;)s===s.parent.left?(c=s.parent.right,c.color===1&&(c.color=0,s.parent.color=1,y(n,s.parent),c=s.parent.right),c.left.color===0&&c.right.color===0?(c.color=1,s=s.parent):(c.right.color===0&&(c.left.color=0,c.color=1,O(n,c),c=s.parent.right),c.color=s.parent.color,s.parent.color=0,c.right.color=0,y(n,s.parent),s=n.root)):(c=s.parent.left,c.color===1&&(c.color=0,s.parent.color=1,O(n,s.parent),c=s.parent.left),c.left.color===0&&c.right.color===0?(c.color=1,s=s.parent):(c.left.color===0&&(c.right.color=0,c.color=1,y(n,c),c=s.parent.left),c.color=s.parent.color,s.parent.color=0,c.left.color=0,O(n,s.parent),s=n.root));s.color=0,d()}function l(n,o){for($(n,o);o!==n.root&&o.parent.color===1;)if(o.parent===o.parent.parent.left){const s=o.parent.parent.right;s.color===1?(o.parent.color=0,s.color=0,o.parent.parent.color=1,o=o.parent.parent):(o===o.parent.right&&(o=o.parent,y(n,o)),o.parent.color=0,o.parent.parent.color=1,O(n,o.parent.parent))}else{const s=o.parent.parent.left;s.color===1?(o.parent.color=0,s.color=0,o.parent.parent.color=1,o=o.parent.parent):(o===o.parent.left&&(o=o.parent,O(n,o)),o.parent.color=0,o.parent.parent.color=1,y(n,o.parent.parent))}n.root.color=0}function b(n,o,s,r){for(;o!==n.root&&o!==e.$kC;)o.parent.left===o&&(o.parent.size_left+=s,o.parent.lf_left+=r),o=o.parent}function $(n,o){let s=0,r=0;if(o!==n.root){for(;o!==n.root&&o===o.parent.right;)o=o.parent;if(o!==n.root)for(o=o.parent,s=A(o.left)-o.size_left,r=m(o.left)-o.lf_left,o.size_left+=s,o.lf_left+=r;o!==n.root&&(s!==0||r!==0);)o.parent.left===o&&(o.parent.size_left+=s,o.parent.lf_left+=r),o=o.parent}}}),define(Pe[93],Re([1,0,94,29,95,141,96]),function(ee,e,k,M,C,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DC=e.$CC=e.$BC=void 0,e.$zC=O,e.$AC=D;const m=65535;function d(s){let r;return s[s.length-1]<65536?r=new Uint16Array(s.length):r=new Uint32Array(s.length),r.set(s,0),r}class y{constructor(r,i,c,h,t){this.lineStarts=r,this.cr=i,this.lf=c,this.crlf=h,this.isBasicASCII=t}}function O(s,r=!0){const i=[0];let c=1;for(let h=0,t=s.length;h<t;h++){const p=s.charCodeAt(h);p===13?h+1<t&&s.charCodeAt(h+1)===10?(i[c++]=h+2,h++):i[c++]=h+1:p===10&&(i[c++]=h+1)}return r?d(i):i}function D(s,r){s.length=0,s[0]=0;let i=1,c=0,h=0,t=0,p=!0;for(let g=0,v=r.length;g<v;g++){const f=r.charCodeAt(g);f===13?g+1<v&&r.charCodeAt(g+1)===10?(t++,s[i++]=g+2,g++):(c++,s[i++]=g+1):f===10?(h++,s[i++]=g+1):p&&f!==9&&(f<32||f>126)&&(p=!1)}const a=new y(d(s),c,h,t,p);return s.length=0,a}class l{constructor(r,i,c,h,t){this.bufferIndex=r,this.start=i,this.end=c,this.lineFeedCnt=h,this.length=t}}e.$BC=l;class b{constructor(r,i){this.buffer=r,this.lineStarts=i}}e.$CC=b;class ${constructor(r,i){this.a=[],this.c=r,this.d=i,this.b=0,r.root!==N.$kC&&r.iterate(r.root,c=>(c!==N.$kC&&this.a.push(c.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class n{constructor(r){this.a=r,this.b=[]}get(r){for(let i=this.b.length-1;i>=0;i--){const c=this.b[i];if(c.nodeStartOffset<=r&&c.nodeStartOffset+c.node.piece.length>=r)return c}return null}get2(r){for(let i=this.b.length-1;i>=0;i--){const c=this.b[i];if(c.nodeStartLineNumber&&c.nodeStartLineNumber<r&&c.nodeStartLineNumber+c.node.piece.lineFeedCnt>=r)return c}return null}set(r){this.b.length>=this.a&&this.b.shift(),this.b.push(r)}validate(r){let i=!1;const c=this.b;for(let h=0;h<c.length;h++){const t=c[h];if(t.node.parent===null||t.nodeStartOffset>=r){c[h]=null,i=!0;continue}}if(i){const h=[];for(const t of c)t!==null&&h.push(t);this.b=h}}}class o{constructor(r,i,c){this.create(r,i,c)}create(r,i,c){this.a=[new b("",[0])],this.g={line:0,column:0},this.root=N.$kC,this.b=1,this.c=0,this.d=i,this.e=i.length,this.f=c;let h=null;for(let t=0,p=r.length;t<p;t++)if(r[t].buffer.length>0){r[t].lineStarts||(r[t].lineStarts=O(r[t].buffer));const a=new l(t+1,{line:0,column:0},{line:r[t].lineStarts.length-1,column:r[t].buffer.length-r[t].lineStarts[r[t].lineStarts.length-1]},r[t].lineStarts.length-1,r[t].buffer.length);this.a.push(r[t]),h=this.S(h,a)}this.h=new n(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(r){const i=m,c=i-Math.floor(i/3),h=c*2;let t="",p=0;const a=[];if(this.iterate(this.root,g=>{const v=this.R(g),f=v.length;if(p<=c||p+f<h)return t+=v,p+=f,!0;const u=t.replace(/\r\n|\r|\n/g,r);return a.push(new b(u,O(u))),t=v,p=f,!0}),p>0){const g=t.replace(/\r\n|\r|\n/g,r);a.push(new b(g,O(g)))}this.create(a,r,!0)}getEOL(){return this.d}setEOL(r){this.d=r,this.e=this.d.length,this.normalizeEOL(r)}createSnapshot(r){return new $(this,r)}equal(r){if(this.getLength()!==r.getLength()||this.getLineCount()!==r.getLineCount())return!1;let i=0;return this.iterate(this.root,h=>{if(h===N.$kC)return!0;const t=this.R(h),p=t.length,a=r.G(i),g=r.G(i+p),v=r.getValueInRange2(a,g);return i+=p,t===v})}getOffsetAt(r,i){let c=0,h=this.root;for(;h!==N.$kC;)if(h.left!==N.$kC&&h.lf_left+1>=r)h=h.left;else if(h.lf_left+h.piece.lineFeedCnt+1>=r){c+=h.size_left;const t=this.B(h,r-h.lf_left-2);return c+=t+i-1}else r-=h.lf_left+h.piece.lineFeedCnt,c+=h.size_left+h.piece.length,h=h.right;return c}getPositionAt(r){r=Math.floor(r),r=Math.max(0,r);let i=this.root,c=0;const h=r;for(;i!==N.$kC;)if(i.size_left!==0&&i.size_left>=r)i=i.left;else if(i.size_left+i.piece.length>=r){const t=this.A(i,r-i.size_left);if(c+=i.lf_left+t.index,t.index===0){const p=this.getOffsetAt(c+1,1),a=h-p;return new k.$ct(c+1,a+1)}return new k.$ct(c+1,t.remainder+1)}else if(r-=i.size_left+i.piece.length,c+=i.lf_left+i.piece.lineFeedCnt,i.right===N.$kC){const t=this.getOffsetAt(c+1,1),p=h-r-t;return new k.$ct(c+1,p+1)}else i=i.right;return new k.$ct(1,1)}getValueInRange(r,i){if(r.startLineNumber===r.endLineNumber&&r.startColumn===r.endColumn)return"";const c=this.H(r.startLineNumber,r.startColumn),h=this.H(r.endLineNumber,r.endColumn),t=this.getValueInRange2(c,h);return i?i!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,i):i===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,i):t}getValueInRange2(r,i){if(r.node===i.node){const a=r.node,g=this.a[a.piece.bufferIndex].buffer,v=this.u(a.piece.bufferIndex,a.piece.start);return g.substring(v+r.remainder,v+i.remainder)}let c=r.node;const h=this.a[c.piece.bufferIndex].buffer,t=this.u(c.piece.bufferIndex,c.piece.start);let p=h.substring(t+r.remainder,t+c.piece.length);for(c=c.next();c!==N.$kC;){const a=this.a[c.piece.bufferIndex].buffer,g=this.u(c.piece.bufferIndex,c.piece.start);if(c===i.node){p+=a.substring(g,g+i.remainder);break}else p+=a.substr(g,c.piece.length);c=c.next()}return p}getLinesContent(){const r=[];let i=0,c="",h=!1;return this.iterate(this.root,t=>{if(t===N.$kC)return!0;const p=t.piece;let a=p.length;if(a===0)return!0;const g=this.a[p.bufferIndex].buffer,v=this.a[p.bufferIndex].lineStarts,f=p.start.line,u=p.end.line;let E=v[f]+p.start.column;if(h&&(g.charCodeAt(E)===10&&(E++,a--),r[i++]=c,c="",h=!1,a===0))return!0;if(f===u)return!this.f&&g.charCodeAt(E+a-1)===13?(h=!0,c+=g.substr(E,a-1)):c+=g.substr(E,a),!0;c+=this.f?g.substring(E,Math.max(E,v[f+1]-this.e)):g.substring(E,v[f+1]).replace(/(\r\n|\r|\n)$/,""),r[i++]=c;for(let w=f+1;w<u;w++)c=this.f?g.substring(v[w],v[w+1]-this.e):g.substring(v[w],v[w+1]).replace(/(\r\n|\r|\n)$/,""),r[i++]=c;return!this.f&&g.charCodeAt(v[u]+p.end.column-1)===13?(h=!0,p.end.column===0?i--:c=g.substr(v[u],p.end.column-1)):c=g.substr(v[u],p.end.column),!0}),h&&(r[i++]=c,c=""),r[i++]=c,r}getLength(){return this.c}getLineCount(){return this.b}getLineContent(r){return this.j.lineNumber===r?this.j.value:(this.j.lineNumber=r,r===this.b?this.j.value=this.getLineRawContent(r):this.f?this.j.value=this.getLineRawContent(r,this.e):this.j.value=this.getLineRawContent(r).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(r){if(r.remainder===r.node.piece.length){const i=r.node.next();if(!i)return 0;const c=this.a[i.piece.bufferIndex],h=this.u(i.piece.bufferIndex,i.piece.start);return c.buffer.charCodeAt(h)}else{const i=this.a[r.node.piece.bufferIndex],h=this.u(r.node.piece.bufferIndex,r.node.piece.start)+r.remainder;return i.buffer.charCodeAt(h)}}getLineCharCode(r,i){const c=this.H(r,i+1);return this.l(c)}getLineLength(r){if(r===this.getLineCount()){const i=this.getOffsetAt(r,1);return this.getLength()-i}return this.getOffsetAt(r+1,1)-this.getOffsetAt(r,1)-this.e}getCharCode(r){const i=this.G(r);return this.l(i)}findMatchesInNode(r,i,c,h,t,p,a,g,v,f,u){const E=this.a[r.piece.bufferIndex],w=this.u(r.piece.bufferIndex,r.piece.start),I=this.u(r.piece.bufferIndex,t),S=this.u(r.piece.bufferIndex,p);let P;const U={line:0,column:0};let Q,H;i._wordSeparators?(Q=E.buffer.substring(I,S),H=L=>L+I,i.reset(0)):(Q=E.buffer,H=L=>L,i.reset(I));do if(P=i.next(Q),P){if(H(P.index)>=S)return f;this.s(r,H(P.index)-w,U);const L=this.t(r.piece.bufferIndex,t,U),R=U.line===t.line?U.column-t.column+h:U.column+1,F=R+P[0].length;if(u[f++]=(0,A.$vC)(new M.$dt(c+L,R,c+L,F),P,g),H(P.index)+P[0].length>=S||f>=v)return f}while(P);return f}findMatchesLineByLine(r,i,c,h){const t=[];let p=0;const a=new A.$yC(i.wordSeparators,i.regex);let g=this.H(r.startLineNumber,r.startColumn);if(g===null)return[];const v=this.H(r.endLineNumber,r.endColumn);if(v===null)return[];let f=this.s(g.node,g.remainder);const u=this.s(v.node,v.remainder);if(g.node===v.node)return this.findMatchesInNode(g.node,a,r.startLineNumber,r.startColumn,f,u,i,c,h,p,t),t;let E=r.startLineNumber,w=g.node;for(;w!==v.node;){const S=this.t(w.piece.bufferIndex,f,w.piece.end);if(S>=1){const U=this.a[w.piece.bufferIndex].lineStarts,Q=this.u(w.piece.bufferIndex,w.piece.start),H=U[f.line+S],L=E===r.startLineNumber?r.startColumn:1;if(p=this.findMatchesInNode(w,a,E,L,f,this.s(w,H-Q),i,c,h,p,t),p>=h)return t;E+=S}const P=E===r.startLineNumber?r.startColumn-1:0;if(E===r.endLineNumber){const U=this.getLineContent(E).substring(P,r.endColumn-1);return p=this.n(i,a,U,r.endLineNumber,P,p,t,c,h),t}if(p=this.n(i,a,this.getLineContent(E).substr(P),E,P,p,t,c,h),p>=h)return t;E++,g=this.H(E,1),w=g.node,f=this.s(g.node,g.remainder)}if(E===r.endLineNumber){const S=E===r.startLineNumber?r.startColumn-1:0,P=this.getLineContent(E).substring(S,r.endColumn-1);return p=this.n(i,a,P,r.endLineNumber,S,p,t,c,h),t}const I=E===r.startLineNumber?r.startColumn:1;return p=this.findMatchesInNode(v.node,a,E,I,f,u,i,c,h,p,t),t}n(r,i,c,h,t,p,a,g,v){const f=r.wordSeparators;if(!g&&r.simpleSearch){const E=r.simpleSearch,w=E.length,I=c.length;let S=-w;for(;(S=c.indexOf(E,S+w))!==-1;)if((!f||(0,A.$xC)(f,c,I,S,w))&&(a[p++]=new C.$xv(new M.$dt(h,S+1+t,h,S+1+w+t),null),p>=v))return p;return p}let u;i.reset(0);do if(u=i.next(c),u&&(a[p++]=(0,A.$vC)(new M.$dt(h,u.index+1+t,h,u.index+1+u[0].length+t),u,g),p>=v))return p;while(u);return p}insert(r,i,c=!1){if(this.f=this.f&&c,this.j.lineNumber=0,this.j.value="",this.root!==N.$kC){const{node:h,remainder:t,nodeStartOffset:p}=this.G(r),a=h.piece,g=a.bufferIndex,v=this.s(h,t);if(h.piece.bufferIndex===0&&a.end.line===this.g.line&&a.end.column===this.g.column&&p+a.length===r&&i.length<m){this.F(h,i),this.y();return}if(p===r)this.o(i,h),this.h.validate(r);else if(p+h.piece.length>r){const f=[];let u=new l(a.bufferIndex,v,a.end,this.t(a.bufferIndex,v,a.end),this.u(g,a.end)-this.u(g,v));if(this.K()&&this.M(i)&&this.I(h,t)===10){const S={line:u.start.line+1,column:0};u=new l(u.bufferIndex,S,u.end,this.t(u.bufferIndex,S,u.end),u.length-1),i+=`
`}if(this.K()&&this.L(i))if(this.I(h,t-1)===13){const S=this.s(h,t-1);this.C(h,S),i="\r"+i,h.piece.length===0&&f.push(h)}else this.C(h,v);else this.C(h,v);const E=this.w(i);u.length>0&&this.S(h,u);let w=h;for(let I=0;I<E.length;I++)w=this.S(w,E[I]);this.v(f)}else this.q(i,h)}else{const h=this.w(i);let t=this.T(null,h[0]);for(let p=1;p<h.length;p++)t=this.S(t,h[p])}this.y()}delete(r,i){if(this.j.lineNumber=0,this.j.value="",i<=0||this.root===N.$kC)return;const c=this.G(r),h=this.G(r+i),t=c.node,p=h.node;if(t===p){const E=this.s(t,c.remainder),w=this.s(t,h.remainder);if(c.nodeStartOffset===r){if(i===t.piece.length){const I=t.next();(0,N.$pC)(this,t),this.N(I),this.y();return}this.D(t,w),this.h.validate(r),this.N(t),this.y();return}if(c.nodeStartOffset+t.piece.length===r+i){this.C(t,E),this.O(t),this.y();return}this.E(t,E,w),this.y();return}const a=[],g=this.s(t,c.remainder);this.C(t,g),this.h.validate(r),t.piece.length===0&&a.push(t);const v=this.s(p,h.remainder);this.D(p,v),p.piece.length===0&&a.push(p);const f=t.next();for(let E=f;E!==N.$kC&&E!==p;E=E.next())a.push(E);const u=t.piece.length===0?t.prev():t;this.v(a),this.O(u),this.y()}o(r,i){const c=[];if(this.K()&&this.M(r)&&this.L(i)){const p=i.piece,a={line:p.start.line+1,column:0},g=new l(p.bufferIndex,a,p.end,this.t(p.bufferIndex,a,p.end),p.length-1);i.piece=g,r+=`
`,(0,N.$rC)(this,i,-1,-1),i.piece.length===0&&c.push(i)}const h=this.w(r);let t=this.T(i,h[h.length-1]);for(let p=h.length-2;p>=0;p--)t=this.T(t,h[p]);this.N(t),this.v(c)}q(r,i){this.Q(r,i)&&(r+=`
`);const c=this.w(r),h=this.S(i,c[0]);let t=h;for(let p=1;p<c.length;p++)t=this.S(t,c[p]);this.N(h)}s(r,i,c){const h=r.piece,t=r.piece.bufferIndex,p=this.a[t].lineStarts,g=p[h.start.line]+h.start.column+i;let v=h.start.line,f=h.end.line,u=0,E=0,w=0;for(;v<=f&&(u=v+(f-v)/2|0,w=p[u],u!==f);)if(E=p[u+1],g<w)f=u-1;else if(g>=E)v=u+1;else break;return c?(c.line=u,c.column=g-w,null):{line:u,column:g-w}}t(r,i,c){if(c.column===0)return c.line-i.line;const h=this.a[r].lineStarts;if(c.line===h.length-1)return c.line-i.line;const t=h[c.line+1],p=h[c.line]+c.column;if(t>p+1)return c.line-i.line;const a=p-1;return this.a[r].buffer.charCodeAt(a)===13?c.line-i.line+1:c.line-i.line}u(r,i){return this.a[r].lineStarts[i.line]+i.column}v(r){for(let i=0;i<r.length;i++)(0,N.$pC)(this,r[i])}w(r){if(r.length>m){const f=[];for(;r.length>m;){const E=r.charCodeAt(m-1);let w;E===13||E>=55296&&E<=56319?(w=r.substring(0,m-1),r=r.substring(m-1)):(w=r.substring(0,m),r=r.substring(m));const I=O(w);f.push(new l(this.a.length,{line:0,column:0},{line:I.length-1,column:w.length-I[I.length-1]},I.length-1,w.length)),this.a.push(new b(w,I))}const u=O(r);return f.push(new l(this.a.length,{line:0,column:0},{line:u.length-1,column:r.length-u[u.length-1]},u.length-1,r.length)),this.a.push(new b(r,u)),f}let i=this.a[0].buffer.length;const c=O(r,!1);let h=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===i&&i!==0&&this.L(r)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},h=this.g;for(let f=0;f<c.length;f++)c[f]+=i+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1)),this.a[0].buffer+="_"+r,i+=1}else{if(i!==0)for(let f=0;f<c.length;f++)c[f]+=i;this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1)),this.a[0].buffer+=r}const t=this.a[0].buffer.length,p=this.a[0].lineStarts.length-1,a=t-this.a[0].lineStarts[p],g={line:p,column:a},v=new l(0,h,g,this.t(0,h,g),t-i);return this.g=g,[v]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(r,i=0){let c=this.root,h="";const t=this.h.get2(r);if(t){c=t.node;const p=this.B(c,r-t.nodeStartLineNumber-1),a=this.a[c.piece.bufferIndex].buffer,g=this.u(c.piece.bufferIndex,c.piece.start);if(t.nodeStartLineNumber+c.piece.lineFeedCnt===r)h=a.substring(g+p,g+c.piece.length);else{const v=this.B(c,r-t.nodeStartLineNumber);return a.substring(g+p,g+v-i)}}else{let p=0;const a=r;for(;c!==N.$kC;)if(c.left!==N.$kC&&c.lf_left>=r-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>r-1){const g=this.B(c,r-c.lf_left-2),v=this.B(c,r-c.lf_left-1),f=this.a[c.piece.bufferIndex].buffer,u=this.u(c.piece.bufferIndex,c.piece.start);return p+=c.size_left,this.h.set({node:c,nodeStartOffset:p,nodeStartLineNumber:a-(r-1-c.lf_left)}),f.substring(u+g,u+v-i)}else if(c.lf_left+c.piece.lineFeedCnt===r-1){const g=this.B(c,r-c.lf_left-2),v=this.a[c.piece.bufferIndex].buffer,f=this.u(c.piece.bufferIndex,c.piece.start);h=v.substring(f+g,f+c.piece.length);break}else r-=c.lf_left+c.piece.lineFeedCnt,p+=c.size_left+c.piece.length,c=c.right}for(c=c.next();c!==N.$kC;){const p=this.a[c.piece.bufferIndex].buffer;if(c.piece.lineFeedCnt>0){const a=this.B(c,0),g=this.u(c.piece.bufferIndex,c.piece.start);return h+=p.substring(g,g+a-i),h}else{const a=this.u(c.piece.bufferIndex,c.piece.start);h+=p.substr(a,c.piece.length)}c=c.next()}return h}y(){let r=this.root,i=1,c=0;for(;r!==N.$kC;)i+=r.lf_left+r.piece.lineFeedCnt,c+=r.size_left+r.piece.length,r=r.right;this.b=i,this.c=c,this.h.validate(this.c)}A(r,i){const c=r.piece,h=this.s(r,i),t=h.line-c.start.line;if(this.u(c.bufferIndex,c.end)-this.u(c.bufferIndex,c.start)===i){const p=this.t(r.piece.bufferIndex,c.start,h);if(p!==t)return{index:p,remainder:0}}return{index:t,remainder:h.column}}B(r,i){if(i<0)return 0;const c=r.piece,h=this.a[c.bufferIndex].lineStarts,t=c.start.line+i+1;return t>c.end.line?h[c.end.line]+c.end.column-h[c.start.line]-c.start.column:h[t]-h[c.start.line]-c.start.column}C(r,i){const c=r.piece,h=c.lineFeedCnt,t=this.u(c.bufferIndex,c.end),p=i,a=this.u(c.bufferIndex,p),g=this.t(c.bufferIndex,c.start,p),v=g-h,f=a-t,u=c.length+f;r.piece=new l(c.bufferIndex,c.start,p,g,u),(0,N.$rC)(this,r,f,v)}D(r,i){const c=r.piece,h=c.lineFeedCnt,t=this.u(c.bufferIndex,c.start),p=i,a=this.t(c.bufferIndex,p,c.end),g=this.u(c.bufferIndex,p),v=a-h,f=t-g,u=c.length+f;r.piece=new l(c.bufferIndex,p,c.end,a,u),(0,N.$rC)(this,r,f,v)}E(r,i,c){const h=r.piece,t=h.start,p=h.end,a=h.length,g=h.lineFeedCnt,v=i,f=this.t(h.bufferIndex,h.start,v),u=this.u(h.bufferIndex,i)-this.u(h.bufferIndex,t);r.piece=new l(h.bufferIndex,h.start,v,f,u),(0,N.$rC)(this,r,u-a,f-g);const E=new l(h.bufferIndex,c,p,this.t(h.bufferIndex,c,p),this.u(h.bufferIndex,p)-this.u(h.bufferIndex,c)),w=this.S(r,E);this.N(w)}F(r,i){this.Q(i,r)&&(i+=`
`);const c=this.K()&&this.L(i)&&this.M(r),h=this.a[0].buffer.length;this.a[0].buffer+=i;const t=O(i,!1);for(let w=0;w<t.length;w++)t[w]+=h;if(c){const w=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:h-w}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const p=this.a[0].lineStarts.length-1,a=this.a[0].buffer.length-this.a[0].lineStarts[p],g={line:p,column:a},v=r.piece.length+i.length,f=r.piece.lineFeedCnt,u=this.t(0,r.piece.start,g),E=u-f;r.piece=new l(r.piece.bufferIndex,r.piece.start,g,u,v),this.g=g,(0,N.$rC)(this,r,i.length,E)}G(r){let i=this.root;const c=this.h.get(r);if(c)return{node:c.node,nodeStartOffset:c.nodeStartOffset,remainder:r-c.nodeStartOffset};let h=0;for(;i!==N.$kC;)if(i.size_left>r)i=i.left;else if(i.size_left+i.piece.length>=r){h+=i.size_left;const t={node:i,remainder:r-i.size_left,nodeStartOffset:h};return this.h.set(t),t}else r-=i.size_left+i.piece.length,h+=i.size_left+i.piece.length,i=i.right;return null}H(r,i){let c=this.root,h=0;for(;c!==N.$kC;)if(c.left!==N.$kC&&c.lf_left>=r-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>r-1){const t=this.B(c,r-c.lf_left-2),p=this.B(c,r-c.lf_left-1);return h+=c.size_left,{node:c,remainder:Math.min(t+i-1,p),nodeStartOffset:h}}else if(c.lf_left+c.piece.lineFeedCnt===r-1){const t=this.B(c,r-c.lf_left-2);if(t+i-1<=c.piece.length)return{node:c,remainder:t+i-1,nodeStartOffset:h};i-=c.piece.length-t;break}else r-=c.lf_left+c.piece.lineFeedCnt,h+=c.size_left+c.piece.length,c=c.right;for(c=c.next();c!==N.$kC;){if(c.piece.lineFeedCnt>0){const t=this.B(c,0),p=this.J(c);return{node:c,remainder:Math.min(i-1,t),nodeStartOffset:p}}else if(c.piece.length>=i-1){const t=this.J(c);return{node:c,remainder:i-1,nodeStartOffset:t}}else i-=c.piece.length;c=c.next()}return null}I(r,i){if(r.piece.lineFeedCnt<1)return-1;const c=this.a[r.piece.bufferIndex],h=this.u(r.piece.bufferIndex,r.piece.start)+i;return c.buffer.charCodeAt(h)}J(r){if(!r)return 0;let i=r.size_left;for(;r!==this.root;)r.parent.right===r&&(i+=r.parent.size_left+r.parent.piece.length),r=r.parent;return i}K(){return!(this.f&&this.d===`
`)}L(r){if(typeof r=="string")return r.charCodeAt(0)===10;if(r===N.$kC||r.piece.lineFeedCnt===0)return!1;const i=r.piece,c=this.a[i.bufferIndex].lineStarts,h=i.start.line,t=c[h]+i.start.column;return h===c.length-1||c[h+1]>t+1?!1:this.a[i.bufferIndex].buffer.charCodeAt(t)===10}M(r){return typeof r=="string"?r.charCodeAt(r.length-1)===13:r===N.$kC||r.piece.lineFeedCnt===0?!1:this.I(r,r.piece.length-1)===13}N(r){if(this.K()&&this.L(r)){const i=r.prev();this.M(i)&&this.P(i,r)}}O(r){if(this.K()&&this.M(r)){const i=r.next();this.L(i)&&this.P(r,i)}}P(r,i){const c=[],h=this.a[r.piece.bufferIndex].lineStarts;let t;r.piece.end.column===0?t={line:r.piece.end.line-1,column:h[r.piece.end.line]-h[r.piece.end.line-1]-1}:t={line:r.piece.end.line,column:r.piece.end.column-1};const p=r.piece.length-1,a=r.piece.lineFeedCnt-1;r.piece=new l(r.piece.bufferIndex,r.piece.start,t,a,p),(0,N.$rC)(this,r,-1,-1),r.piece.length===0&&c.push(r);const g={line:i.piece.start.line+1,column:0},v=i.piece.length-1,f=this.t(i.piece.bufferIndex,g,i.piece.end);i.piece=new l(i.piece.bufferIndex,g,i.piece.end,f,v),(0,N.$rC)(this,i,-1,-1),i.piece.length===0&&c.push(i);const u=this.w(`\r
`);this.S(r,u[0]);for(let E=0;E<c.length;E++)(0,N.$pC)(this,c[E])}Q(r,i){if(this.K()&&this.M(r)){const c=i.next();if(this.L(c)){if(r+=`
`,c.piece.length===1)(0,N.$pC)(this,c);else{const h=c.piece,t={line:h.start.line+1,column:0},p=h.length-1,a=this.t(h.bufferIndex,t,h.end);c.piece=new l(h.bufferIndex,t,h.end,a,p),(0,N.$rC)(this,c,-1,-1)}return!0}}return!1}iterate(r,i){if(r===N.$kC)return i(N.$kC);const c=this.iterate(r.left,i);return c&&i(r)&&this.iterate(r.right,i)}R(r){if(r===N.$kC)return"";const i=this.a[r.piece.bufferIndex],c=r.piece,h=this.u(c.bufferIndex,c.start),t=this.u(c.bufferIndex,c.end);return i.buffer.substring(h,t)}getPieceContent(r){const i=this.a[r.bufferIndex],c=this.u(r.bufferIndex,r.start),h=this.u(r.bufferIndex,r.end);return i.buffer.substring(c,h)}S(r,i){const c=new N.$jC(i,1);if(c.left=N.$kC,c.right=N.$kC,c.parent=N.$kC,c.size_left=0,c.lf_left=0,this.root===N.$kC)this.root=c,c.color=0;else if(r.right===N.$kC)r.right=c,c.parent=r;else{const t=(0,N.$lC)(r.right);t.left=c,c.parent=t}return(0,N.$qC)(this,c),c}T(r,i){const c=new N.$jC(i,1);if(c.left=N.$kC,c.right=N.$kC,c.parent=N.$kC,c.size_left=0,c.lf_left=0,this.root===N.$kC)this.root=c,c.color=0;else if(r.left===N.$kC)r.left=c,c.parent=r;else{const h=(0,N.$mC)(r.left);h.right=c,c.parent=h}return(0,N.$qC)(this,c),c}U(r){let i="";return this.iterate(r,c=>(i+=this.R(c),!0)),i}}e.$DC=o}),define(Pe[142],Re([1,0,5,15,29,95,93,135,137,6]),function(ee,e,k,M,C,N,A,m,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EC=void 0;class O extends y.$Uc{constructor(l,b,$,n,o,s,r){super(),this.m=this.B(new k.$7d),this.onDidChangeContent=this.m.event,this.f=b,this.j=!s,this.g=n,this.h=o,this.c=new A.$DC(l,$,r)}equals(l){return!(l instanceof O)||this.f!==l.f||this.getEOL()!==l.getEOL()?!1:this.c.equal(l.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(l){return this.c.createSnapshot(l?this.f:"")}getOffsetAt(l,b){return this.c.getOffsetAt(l,b)}getPositionAt(l){return this.c.getPositionAt(l)}getRangeAt(l,b){const $=l+b,n=this.getPositionAt(l),o=this.getPositionAt($);return new C.$dt(n.lineNumber,n.column,o.lineNumber,o.column)}getValueInRange(l,b=0){if(l.isEmpty())return"";const $=this.n(b);return this.c.getValueInRange(l,$)}getValueLengthInRange(l,b=0){if(l.isEmpty())return 0;if(l.startLineNumber===l.endLineNumber)return l.endColumn-l.startColumn;const $=this.getOffsetAt(l.startLineNumber,l.startColumn),n=this.getOffsetAt(l.endLineNumber,l.endColumn);let o=0;const s=this.n(b),r=this.getEOL();if(s.length!==r.length){const i=s.length-r.length,c=l.endLineNumber-l.startLineNumber;o=i*c}return n-$+o}getCharacterCountInRange(l,b=0){if(this.j){let $=0;const n=l.startLineNumber,o=l.endLineNumber;for(let s=n;s<=o;s++){const r=this.getLineContent(s),i=s===n?l.startColumn-1:0,c=s===o?l.endColumn-1:r.length;for(let h=i;h<c;h++)M.$pf(r.charCodeAt(h))?($=$+1,h=h+1):$=$+1}return $+=this.n(b).length*(o-n),$}return this.getValueLengthInRange(l,b)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(l){return this.c.getLineContent(l)}getLineCharCode(l,b){return this.c.getLineCharCode(l,b)}getCharCode(l){return this.c.getCharCode(l)}getLineLength(l){return this.c.getLineLength(l)}getLineMinColumn(l){return 1}getLineMaxColumn(l){return this.getLineLength(l)+1}getLineFirstNonWhitespaceColumn(l){const b=M.$af(this.getLineContent(l));return b===-1?0:b+1}getLineLastNonWhitespaceColumn(l){const b=M.$cf(this.getLineContent(l));return b===-1?0:b+2}n(l){switch(l){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(l){this.c.setEOL(l)}applyEdits(l,b,$){let n=this.g,o=this.h,s=this.j,r=!0,i=[];for(let v=0;v<l.length;v++){const f=l[v];r&&f._isTracked&&(r=!1);const u=f.range;if(f.text){let P=!0;s||(P=!M.$Af(f.text),s=P),!n&&P&&(n=M.$zf(f.text)),!o&&P&&(o=M.$Cf(f.text))}let E="",w=0,I=0,S=0;if(f.text){let P;[w,I,S,P]=(0,m.$Pt)(f.text);const U=this.getEOL();P===0||P===(U===`\r
`?2:1)?E=f.text:E=f.text.replace(/\r\n|\r|\n/g,U)}i[v]={sortIndex:v,identifier:f.identifier||null,range:u,rangeOffset:this.getOffsetAt(u.startLineNumber,u.startColumn),rangeLength:this.getValueLengthInRange(u),text:E,eolCount:w,firstLineLength:I,lastLineLength:S,forceMoveMarkers:!!f.forceMoveMarkers,isAutoWhitespaceEdit:f.isAutoWhitespaceEdit||!1}}i.sort(O.u);let c=!1;for(let v=0,f=i.length-1;v<f;v++){const u=i[v].range.getEndPosition(),E=i[v+1].range.getStartPosition();if(E.isBeforeOrEqual(u)){if(E.isBefore(u))throw new Error("Overlapping ranges are not allowed!");c=!0}}r&&(i=this.s(i));const h=$||b?O._getInverseEditRanges(i):[],t=[];if(b)for(let v=0;v<i.length;v++){const f=i[v],u=h[v];if(f.isAutoWhitespaceEdit&&f.range.isEmpty())for(let E=u.startLineNumber;E<=u.endLineNumber;E++){let w="";E===u.startLineNumber&&(w=this.getLineContent(f.range.startLineNumber),M.$af(w)!==-1)||t.push({lineNumber:E,oldContent:w})}}let p=null;if($){let v=0;p=[];for(let f=0;f<i.length;f++){const u=i[f],E=h[f],w=this.getValueInRange(u.range),I=u.rangeOffset+v;v+=u.text.length-w.length,p[f]={sortIndex:u.sortIndex,identifier:u.identifier,range:E,text:w,textChange:new d.$yt(u.rangeOffset,w,I,u.text)}}c||p.sort((f,u)=>f.sortIndex-u.sortIndex)}this.g=n,this.h=o,this.j=s;const a=this.t(i);let g=null;if(b&&t.length>0){t.sort((v,f)=>f.lineNumber-v.lineNumber),g=[];for(let v=0,f=t.length;v<f;v++){const u=t[v].lineNumber;if(v>0&&t[v-1].lineNumber===u)continue;const E=t[v].oldContent,w=this.getLineContent(u);w.length===0||w===E||M.$af(w)!==-1||g.push(u)}}return this.m.fire(),new N.$Bv(p,a,g)}s(l){return l.length<1e3?l:[this._toSingleEditOperation(l)]}_toSingleEditOperation(l){let b=!1;const $=l[0].range,n=l[l.length-1].range,o=new C.$dt($.startLineNumber,$.startColumn,n.endLineNumber,n.endColumn);let s=$.startLineNumber,r=$.startColumn;const i=[];for(let a=0,g=l.length;a<g;a++){const v=l[a],f=v.range;b=b||v.forceMoveMarkers,i.push(this.getValueInRange(new C.$dt(s,r,f.startLineNumber,f.startColumn))),v.text.length>0&&i.push(v.text),s=f.endLineNumber,r=f.endColumn}const c=i.join(""),[h,t,p]=(0,m.$Pt)(c);return{sortIndex:0,identifier:l[0].identifier,range:o,rangeOffset:this.getOffsetAt(o.startLineNumber,o.startColumn),rangeLength:this.getValueLengthInRange(o,0),text:c,eolCount:h,firstLineLength:t,lastLineLength:p,forceMoveMarkers:b,isAutoWhitespaceEdit:!1}}t(l){l.sort(O.w);const b=[];for(let $=0;$<l.length;$++){const n=l[$],o=n.range.startLineNumber,s=n.range.startColumn,r=n.range.endLineNumber,i=n.range.endColumn;if(o===r&&s===i&&n.text.length===0)continue;n.text?(this.c.delete(n.rangeOffset,n.rangeLength),this.c.insert(n.rangeOffset,n.text,!0)):this.c.delete(n.rangeOffset,n.rangeLength);const c=new C.$dt(o,s,r,i);b.push({range:c,rangeLength:n.rangeLength,text:n.text,rangeOffset:n.rangeOffset,forceMoveMarkers:n.forceMoveMarkers})}return b}findMatchesLineByLine(l,b,$,n){return this.c.findMatchesLineByLine(l,b,$,n)}getPieceTree(){return this.c}static _getInverseEditRange(l,b){const $=l.startLineNumber,n=l.startColumn,[o,s,r]=(0,m.$Pt)(b);let i;if(b.length>0){const c=o+1;c===1?i=new C.$dt($,n,$,n+s):i=new C.$dt($,n,$+c-1,r+1)}else i=new C.$dt($,n,$,n);return i}static _getInverseEditRanges(l){const b=[];let $=0,n=0,o=null;for(let s=0,r=l.length;s<r;s++){const i=l[s];let c,h;o?o.range.endLineNumber===i.range.startLineNumber?(c=$,h=n+(i.range.startColumn-o.range.endColumn)):(c=$+(i.range.startLineNumber-o.range.endLineNumber),h=i.range.startColumn):(c=i.range.startLineNumber,h=i.range.startColumn);let t;if(i.text.length>0){const p=i.eolCount+1;p===1?t=new C.$dt(c,h,c,h+i.firstLineLength):t=new C.$dt(c,h,c+p-1,i.lastLineLength+1)}else t=new C.$dt(c,h,c,h);$=t.endLineNumber,n=t.endColumn,b.push(t),o=i}return b}static u(l,b){const $=C.$dt.compareRangesUsingEnds(l.range,b.range);return $===0?l.sortIndex-b.sortIndex:$}static w(l,b){const $=C.$dt.compareRangesUsingEnds(l.range,b.range);return $===0?b.sortIndex-l.sortIndex:-$}}e.$EC=O}),define(Pe[143],Re([1,0,15,93,142]),function(ee,e,k,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FC=void 0;class N{constructor(d,y,O,D,l,b,$,n,o){this.a=d,this.b=y,this.c=O,this.d=D,this.e=l,this.f=b,this.g=$,this.h=n,this.j=o}k(d){const y=this.c+this.d+this.e,O=this.c+this.e;return y===0?d===1?`
`:`\r
`:O>y/2?`\r
`:`
`}create(d){const y=this.k(d),O=this.a;if(this.j&&(y===`\r
`&&(this.c>0||this.d>0)||y===`
`&&(this.c>0||this.e>0)))for(let l=0,b=O.length;l<b;l++){const $=O[l].buffer.replace(/\r\n|\r|\n/g,y),n=(0,M.$zC)($);O[l]=new M.$CC($,n)}const D=new C.$EC(O,this.b,y,this.f,this.g,this.h,this.j);return{textBuffer:D,disposable:D}}getFirstLineText(d){return this.a[0].buffer.substr(0,d).split(/\r\n|\r|\n/)[0]}}class A{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(d){if(d.length===0)return;this.a.length===0&&k.$Jf(d)&&(this.b=k.$If,d=d.substr(1));const y=d.charCodeAt(d.length-1);y===13||y>=55296&&y<=56319?(this.m(d.substr(0,d.length-1),!1),this.c=!0,this.d=y):(this.m(d,!1),this.c=!1,this.d=y)}m(d,y){!y&&d.length===0||(this.c?this.n(String.fromCharCode(this.d)+d):this.n(d))}n(d){const y=(0,M.$AC)(this.e,d);this.a.push(new M.$CC(d,y.lineStarts)),this.f+=y.cr,this.g+=y.lf,this.h+=y.crlf,y.isBasicASCII||(this.l=!1,this.j||(this.j=k.$zf(d)),this.k||(this.k=k.$Cf(d)))}finish(d=!0){return this.o(),new N(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,d)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const d=this.a[this.a.length-1];d.buffer+=String.fromCharCode(this.d);const y=(0,M.$zC)(d.buffer);d.lineStarts=y,this.d===13&&this.f++}}}e.$FC=A}),define(Pe[97],Re([1,0,22,21]),function(ee,e,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xab=d,e.$Yab=O;var C;(function(D){D[D.Full=1]="Full",D[D.Delta=2]="Delta"})(C||(C={}));function N(D){for(let l=0,b=D.length;l<b;l+=4){const $=D[l+0],n=D[l+1],o=D[l+2],s=D[l+3];D[l+0]=s,D[l+1]=o,D[l+2]=n,D[l+3]=$}}function A(D){const l=new Uint8Array(D.buffer,D.byteOffset,D.length*4);return M.$x()||N(l),k.$ue.wrap(l)}function m(D){const l=D.buffer;if(M.$x()||N(l),l.byteOffset%4===0)return new Uint32Array(l.buffer,l.byteOffset,l.length/4);{const b=new Uint8Array(l.byteLength);return b.set(l),new Uint32Array(b.buffer,b.byteOffset,b.length/4)}}function d(D){const l=new Uint32Array(y(D));let b=0;if(l[b++]=D.id,D.type==="full")l[b++]=1,l[b++]=D.data.length,l.set(D.data,b),b+=D.data.length;else{l[b++]=2,l[b++]=D.deltas.length;for(const $ of D.deltas)l[b++]=$.start,l[b++]=$.deleteCount,$.data?(l[b++]=$.data.length,l.set($.data,b),b+=$.data.length):l[b++]=0}return A(l)}function y(D){let l=0;if(l+=2,D.type==="full")l+=1+D.data.length;else{l+=1,l+=3*D.deltas.length;for(const b of D.deltas)b.data&&(l+=b.data.length)}return l}function O(D){const l=m(D);let b=0;const $=l[b++];if(l[b++]===1){const r=l[b++],i=l.subarray(b,b+r);return b+=r,{id:$,type:"full",data:i}}const o=l[b++],s=[];for(let r=0;r<o;r++){const i=l[b++],c=l[b++],h=l[b++];let t;h>0&&(t=l.subarray(b,b+h),b+=h),s[r]={start:i,deleteCount:c,data:t}}return{id:$,type:"delta",deltas:s}}}),define(Pe[144],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$r0=e.$q0=void 0;class k{constructor(){this.a=new Map}removeDragOperationTransfer(N){if(N&&this.a.has(N)){const A=this.a.get(N);return this.a.delete(N),A}}addDragOperationTransfer(N,A){this.a.set(N,A)}}e.$q0=k;class M{constructor(N){this.identifier=N}}e.$r0=M}),define(Pe[145],Re([9,10]),function(ee,e){return ee.create("vs/base/common/actions",e)}),define(Pe[146],Re([1,0,5,6,145]),function(ee,e,k,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=void 0,e.$5i=O;class N extends M.$Uc{constructor(l,b="",$="",n=!0,o){super(),this.h=this.B(new k.$7d),this.onDidChange=this.h.event,this.w=!0,this.j=l,this.m=b,this.u=$,this.w=n,this.C=o}get id(){return this.j}get label(){return this.m}set label(l){this.D(l)}D(l){this.m!==l&&(this.m=l,this.h.fire({label:l}))}get tooltip(){return this.n||""}set tooltip(l){this.F(l)}F(l){this.n!==l&&(this.n=l,this.h.fire({tooltip:l}))}get class(){return this.u}set class(l){this.G(l)}G(l){this.u!==l&&(this.u=l,this.h.fire({class:l}))}get enabled(){return this.w}set enabled(l){this.H(l)}H(l){this.w!==l&&(this.w=l,this.h.fire({enabled:l}))}get checked(){return this.z}set checked(l){this.I(l)}I(l){this.z!==l&&(this.z=l,this.h.fire({checked:l}))}async run(l,b){this.C&&await this.C(l)}}e.$Zi=N;class A extends M.$Uc{constructor(){super(...arguments),this.f=this.B(new k.$7d),this.onWillRun=this.f.event,this.m=this.B(new k.$7d),this.onDidRun=this.m.event}async run(l,b){if(!l.enabled)return;this.f.fire({action:l});let $;try{await this.u(l,b)}catch(n){$=n}this.m.fire({action:l,error:$})}async u(l,b){await l.run(b)}}e.$1i=A;class m{constructor(){this.id=m.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...l){let b=[];for(const $ of l)$.length&&(b.length?b=[...b,new m,...$]:b=$);return b}async run(){}}e.$2i=m,m.ID="vs.actions.separator";class d{get actions(){return this.a}constructor(l,b,$,n){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=l,this.label=b,this.class=n,this.a=$}async run(){}}e.$3i=d;class y extends N{constructor(){super(y.ID,C.localize(0,null),void 0,!1)}}e.$4i=y,y.ID="vs.actions.empty";function O(D){return{id:D.id,label:D.label,class:D.class,enabled:D.enabled??!0,checked:D.checked,run:async(...l)=>D.run(...l),tooltip:D.label}}}),define(Pe[147],Re([9,10]),function(ee,e){return ee.create("vs/base/common/date",e)}),define(Pe[148],Re([1,0,147]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Om=y,e.$Pm=O,e.$Qm=D;const M=60,C=M*60,N=C*24,A=N*7,m=N*30,d=N*365;function y(l,b,$,n){typeof l!="number"&&(l=l.getTime());const o=Math.round((new Date().getTime()-l)/1e3);if(o<-30)return(0,k.localize)(0,null,y(new Date().getTime()+o*1e3,!1));if(!n&&o<30)return(0,k.localize)(1,null);let s;return o<M?(s=o,b?s===1?$?(0,k.localize)(2,null,s):(0,k.localize)(3,null,s):$?(0,k.localize)(4,null,s):(0,k.localize)(5,null,s):s===1?$?(0,k.localize)(6,null,s):(0,k.localize)(7,null,s):$?(0,k.localize)(8,null,s):(0,k.localize)(9,null,s)):o<C?(s=Math.floor(o/M),b?s===1?$?(0,k.localize)(10,null,s):(0,k.localize)(11,null,s):$?(0,k.localize)(12,null,s):(0,k.localize)(13,null,s):s===1?$?(0,k.localize)(14,null,s):(0,k.localize)(15,null,s):$?(0,k.localize)(16,null,s):(0,k.localize)(17,null,s)):o<N?(s=Math.floor(o/C),b?s===1?$?(0,k.localize)(18,null,s):(0,k.localize)(19,null,s):$?(0,k.localize)(20,null,s):(0,k.localize)(21,null,s):s===1?$?(0,k.localize)(22,null,s):(0,k.localize)(23,null,s):$?(0,k.localize)(24,null,s):(0,k.localize)(25,null,s)):o<A?(s=Math.floor(o/N),b?s===1?(0,k.localize)(26,null,s):(0,k.localize)(27,null,s):s===1?(0,k.localize)(28,null,s):(0,k.localize)(29,null,s)):o<m?(s=Math.floor(o/A),b?s===1?$?(0,k.localize)(30,null,s):(0,k.localize)(31,null,s):$?(0,k.localize)(32,null,s):(0,k.localize)(33,null,s):s===1?$?(0,k.localize)(34,null,s):(0,k.localize)(35,null,s):$?(0,k.localize)(36,null,s):(0,k.localize)(37,null,s)):o<d?(s=Math.floor(o/m),b?s===1?$?(0,k.localize)(38,null,s):(0,k.localize)(39,null,s):$?(0,k.localize)(40,null,s):(0,k.localize)(41,null,s):s===1?$?(0,k.localize)(42,null,s):(0,k.localize)(43,null,s):$?(0,k.localize)(44,null,s):(0,k.localize)(45,null,s)):(s=Math.floor(o/d),b?s===1?$?(0,k.localize)(46,null,s):(0,k.localize)(47,null,s):$?(0,k.localize)(48,null,s):(0,k.localize)(49,null,s):s===1?$?(0,k.localize)(50,null,s):(0,k.localize)(51,null,s):$?(0,k.localize)(52,null,s):(0,k.localize)(53,null,s))}function O(l,b){const $=Math.abs(l/1e3);return $<1?b?(0,k.localize)(54,null,l):(0,k.localize)(55,null,l):$<M?b?(0,k.localize)(56,null,Math.round(l)/1e3):(0,k.localize)(57,null,Math.round(l)/1e3):$<C?b?(0,k.localize)(58,null,Math.round(l/(1e3*M))):(0,k.localize)(59,null,Math.round(l/(1e3*M))):$<N?b?(0,k.localize)(60,null,Math.round(l/(1e3*C))):(0,k.localize)(61,null,Math.round(l/(1e3*C))):(0,k.localize)(62,null,Math.round(l/(1e3*N)))}function D(l){return l.getFullYear()+"-"+String(l.getMonth()+1).padStart(2,"0")+"-"+String(l.getDate()).padStart(2,"0")+"T"+String(l.getHours()).padStart(2,"0")+":"+String(l.getMinutes()).padStart(2,"0")+":"+String(l.getSeconds()).padStart(2,"0")+"."+(l.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Pe[149],Re([9,10]),function(ee,e){return ee.create("vs/base/common/errorMessage",e)}),define(Pe[42],Re([1,0,18,17,149]),function(ee,e,k,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6i=d,e.$7i=y,e.$8i=O;function N(D,l){return l&&(D.stack||D.stacktrace)?C.localize(0,null,m(D),A(D.stack)||A(D.stacktrace)):m(D)}function A(D){return Array.isArray(D)?D.join(`
`):D}function m(D){return D.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${D.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof D.code=="string"&&typeof D.errno=="number"&&typeof D.syscall=="string"?C.localize(1,null,D.message):D.message||C.localize(2,null)}function d(D=null,l=!1){if(!D)return C.localize(3,null);if(Array.isArray(D)){const b=k.$Hb(D),$=d(b[0],l);return b.length>1?C.localize(4,null,$,b.length):$}if(M.$Vf(D))return D;if(D.detail){const b=D.detail;if(b.error)return N(b.error,l);if(b.exception)return N(b.exception,l)}return D.stack?N(D,l):D.message?D.message:C.localize(5,null)}function y(D){const l=D;return l instanceof Error&&Array.isArray(l.actions)}function O(D,l){let b;return typeof D=="string"?b=new Error(D):b=D,b.actions=l,b}}),define(Pe[150],Re([9,10]),function(ee,e){return ee.create("vs/editor/common/config/editorOptions",e)}),define(Pe[151],Re([1,0,18,26,21,138,152,150]),function(ee,e,k,M,C,N,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=o,e.clampedInt=r,e.clampedFloat=c,e.stringSet=p,e.cursorStyleToString=S,e.filterValidationDecorations=fe;var d;(function(x){x[x.None=0]="None",x[x.Keep=1]="Keep",x[x.Brackets=2]="Brackets",x[x.Advanced=3]="Advanced",x[x.Full=4]="Full"})(d||(e.EditorAutoIndentStrategy=d={})),e.MINIMAP_GUTTER_WIDTH=8;class y{constructor(Y){this.c=Y}hasChanged(Y){return this.c[Y]}}e.ConfigurationChangedEvent=y;class O{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=O;class D{constructor(Y,ye,He,Ye){this.id=Y,this.name=ye,this.defaultValue=He,this.schema=Ye}applyUpdate(Y,ye){return b(Y,ye)}compute(Y,ye,He){return He}}class l{constructor(Y,ye){this.newValue=Y,this.didChange=ye}}e.ApplyUpdateResult=l;function b(x,Y){if(typeof x!="object"||typeof Y!="object"||!x||!Y)return new l(Y,x!==Y);if(Array.isArray(x)||Array.isArray(Y)){const He=Array.isArray(x)&&Array.isArray(Y)&&k.$ub(x,Y);return new l(Y,!He)}let ye=!1;for(const He in Y)if(Y.hasOwnProperty(He)){const Ye=b(x[He],Y[He]);Ye.didChange&&(x[He]=Ye.newValue,ye=!0)}return new l(x,ye)}class ${constructor(Y){this.schema=void 0,this.id=Y,this.name="_never_",this.defaultValue=void 0}applyUpdate(Y,ye){return b(Y,ye)}validate(Y){return this.defaultValue}}class n{constructor(Y,ye,He,Ye){this.id=Y,this.name=ye,this.defaultValue=He,this.schema=Ye}applyUpdate(Y,ye){return b(Y,ye)}validate(Y){return typeof Y>"u"?this.defaultValue:Y}compute(Y,ye,He){return He}}function o(x,Y){return typeof x>"u"?Y:x==="false"?!1:!!x}class s extends n{constructor(Y,ye,He,Ye=void 0){typeof Ye<"u"&&(Ye.type="boolean",Ye.default=He),super(Y,ye,He,Ye)}validate(Y){return o(Y,this.defaultValue)}}function r(x,Y,ye,He){if(typeof x>"u")return Y;let Ye=parseInt(x,10);return isNaN(Ye)?Y:(Ye=Math.max(ye,Ye),Ye=Math.min(He,Ye),Ye|0)}class i extends n{static clampedInt(Y,ye,He,Ye){return r(Y,ye,He,Ye)}constructor(Y,ye,He,Ye,Me,dt=void 0){typeof dt<"u"&&(dt.type="integer",dt.default=He,dt.minimum=Ye,dt.maximum=Me),super(Y,ye,He,dt),this.minimum=Ye,this.maximum=Me}validate(Y){return i.clampedInt(Y,this.defaultValue,this.minimum,this.maximum)}}function c(x,Y,ye,He){if(typeof x>"u")return Y;const Ye=h.float(x,Y);return h.clamp(Ye,ye,He)}class h extends n{static clamp(Y,ye,He){return Y<ye?ye:Y>He?He:Y}static float(Y,ye){if(typeof Y=="number")return Y;if(typeof Y>"u")return ye;const He=parseFloat(Y);return isNaN(He)?ye:He}constructor(Y,ye,He,Ye,Me){typeof Me<"u"&&(Me.type="number",Me.default=He),super(Y,ye,He,Me),this.validationFn=Ye}validate(Y){return this.validationFn(h.float(Y,this.defaultValue))}}class t extends n{static string(Y,ye){return typeof Y!="string"?ye:Y}constructor(Y,ye,He,Ye=void 0){typeof Ye<"u"&&(Ye.type="string",Ye.default=He),super(Y,ye,He,Ye)}validate(Y){return t.string(Y,this.defaultValue)}}function p(x,Y,ye,He){return typeof x!="string"?Y:He&&x in He?He[x]:ye.indexOf(x)===-1?Y:x}class a extends n{constructor(Y,ye,He,Ye,Me=void 0){typeof Me<"u"&&(Me.type="string",Me.enum=Ye,Me.default=He),super(Y,ye,He,Me),this.c=Ye}validate(Y){return p(Y,this.defaultValue,this.c)}}class g extends D{constructor(Y,ye,He,Ye,Me,dt,Mt=void 0){typeof Mt<"u"&&(Mt.type="string",Mt.enum=Me,Mt.default=Ye),super(Y,ye,He,Mt),this.c=Me,this.d=dt}validate(Y){return typeof Y!="string"?this.defaultValue:this.c.indexOf(Y)===-1?this.defaultValue:this.d(Y)}}function v(x){switch(x){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class f extends D{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[m.localize(0,null),m.localize(1,null),m.localize(2,null)],default:"auto",tags:["accessibility"],description:m.localize(3,null)})}validate(Y){switch(Y){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Y,ye,He){return He===0?Y.accessibilitySupport:He}}class u extends D{constructor(){const Y={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",Y,{"editor.comments.insertSpace":{type:"boolean",default:Y.insertSpace,description:m.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Y.ignoreEmptyLines,description:m.localize(5,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ye=Y;return{insertSpace:o(ye.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:o(ye.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var E;(function(x){x[x.Hidden=0]="Hidden",x[x.Blink=1]="Blink",x[x.Smooth=2]="Smooth",x[x.Phase=3]="Phase",x[x.Expand=4]="Expand",x[x.Solid=5]="Solid"})(E||(e.TextEditorCursorBlinkingStyle=E={}));function w(x){switch(x){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var I;(function(x){x[x.Line=1]="Line",x[x.Block=2]="Block",x[x.Underline=3]="Underline",x[x.LineThin=4]="LineThin",x[x.BlockOutline=5]="BlockOutline",x[x.UnderlineThin=6]="UnderlineThin"})(I||(e.TextEditorCursorStyle=I={}));function S(x){switch(x){case I.Line:return"line";case I.Block:return"block";case I.Underline:return"underline";case I.LineThin:return"line-thin";case I.BlockOutline:return"block-outline";case I.UnderlineThin:return"underline-thin"}}function P(x){switch(x){case"line":return I.Line;case"block":return I.Block;case"underline":return I.Underline;case"line-thin":return I.LineThin;case"block-outline":return I.BlockOutline;case"underline-thin":return I.UnderlineThin}}class U extends ${constructor(){super(142)}compute(Y,ye,He){const Ye=["monaco-editor"];return ye.get(39)&&Ye.push(ye.get(39)),Y.extraEditorClassName&&Ye.push(Y.extraEditorClassName),ye.get(74)==="default"?Ye.push("mouse-default"):ye.get(74)==="copy"&&Ye.push("mouse-copy"),ye.get(111)&&Ye.push("showUnused"),ye.get(140)&&Ye.push("showDeprecated"),Ye.join(" ")}}class Q extends s{constructor(){super(37,"emptySelectionClipboard",!0,{description:m.localize(6,null)})}compute(Y,ye,He){return He&&Y.emptySelectionClipboard}}class H extends D{constructor(){const Y={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",Y,{"editor.find.cursorMoveOnType":{type:"boolean",default:Y.cursorMoveOnType,description:m.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Y.seedSearchStringFromSelection,enumDescriptions:[m.localize(8,null),m.localize(9,null),m.localize(10,null)],description:m.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Y.autoFindInSelection,enumDescriptions:[m.localize(12,null),m.localize(13,null),m.localize(14,null)],description:m.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Y.globalFindClipboard,description:m.localize(16,null),included:C.$d},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Y.addExtraSpaceOnTop,description:m.localize(17,null)},"editor.find.loop":{type:"boolean",default:Y.loop,description:m.localize(18,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ye=Y;return{cursorMoveOnType:o(ye.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Y.seedSearchStringFromSelection=="boolean"?Y.seedSearchStringFromSelection?"always":"never":p(ye.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Y.autoFindInSelection=="boolean"?Y.autoFindInSelection?"always":"never":p(ye.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:o(ye.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:o(ye.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:o(ye.loop,this.defaultValue.loop)}}}class L extends D{constructor(){super(51,"fontLigatures",L.OFF,{anyOf:[{type:"boolean",description:m.localize(19,null)},{type:"string",description:m.localize(20,null)}],description:m.localize(21,null),default:!1})}validate(Y){return typeof Y>"u"?this.defaultValue:typeof Y=="string"?Y==="false"||Y.length===0?L.OFF:Y==="true"?L.ON:Y:Y?L.ON:L.OFF}}e.EditorFontLigatures=L,L.OFF='"liga" off, "calt" off',L.ON='"liga" on, "calt" on';class R extends D{constructor(){super(54,"fontVariations",R.OFF,{anyOf:[{type:"boolean",description:m.localize(22,null)},{type:"string",description:m.localize(23,null)}],description:m.localize(24,null),default:!1})}validate(Y){return typeof Y>"u"?this.defaultValue:typeof Y=="string"?Y==="false"?R.OFF:Y==="true"?R.TRANSLATE:Y:Y?R.TRANSLATE:R.OFF}compute(Y,ye,He){return Y.fontInfo.fontVariationSettings}}e.EditorFontVariations=R,R.OFF="normal",R.TRANSLATE="translate";class F extends ${constructor(){super(50)}compute(Y,ye,He){return Y.fontInfo}}class T extends n{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:m.localize(25,null)})}validate(Y){const ye=h.float(Y,this.defaultValue);return ye===0?e.EDITOR_FONT_DEFAULTS.fontSize:h.clamp(ye,6,100)}compute(Y,ye,He){return Y.fontInfo.fontSize}}class X extends D{constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:X.d,maximum:X.e,errorMessage:m.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:X.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:m.localize(27,null)})}validate(Y){return Y==="normal"||Y==="bold"?Y:String(i.clampedInt(Y,e.EDITOR_FONT_DEFAULTS.fontWeight,X.d,X.e))}}X.c=["normal","bold","100","200","300","400","500","600","700","800","900"],X.d=1,X.e=1e3;class re extends D{constructor(){const Y={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ye={type:"string",enum:["peek","gotoAndPeek","goto"],default:Y.multiple,enumDescriptions:[m.localize(28,null),m.localize(29,null),m.localize(30,null)]},He=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",Y,{"editor.gotoLocation.multiple":{deprecationMessage:m.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:m.localize(32,null),...ye},"editor.gotoLocation.multipleTypeDefinitions":{description:m.localize(33,null),...ye},"editor.gotoLocation.multipleDeclarations":{description:m.localize(34,null),...ye},"editor.gotoLocation.multipleImplementations":{description:m.localize(35,null),...ye},"editor.gotoLocation.multipleReferences":{description:m.localize(36,null),...ye},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Y.alternativeDefinitionCommand,enum:He,description:m.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Y.alternativeTypeDefinitionCommand,enum:He,description:m.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Y.alternativeDeclarationCommand,enum:He,description:m.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Y.alternativeImplementationCommand,enum:He,description:m.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Y.alternativeReferenceCommand,enum:He,description:m.localize(41,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ye=Y;return{multiple:p(ye.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ye.multipleDefinitions??p(ye.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ye.multipleTypeDefinitions??p(ye.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ye.multipleDeclarations??p(ye.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ye.multipleImplementations??p(ye.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ye.multipleReferences??p(ye.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(ye.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(ye.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(ye.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(ye.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(ye.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class me extends D{constructor(){const Y={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",Y,{"editor.hover.enabled":{type:"boolean",default:Y.enabled,description:m.localize(42,null)},"editor.hover.delay":{type:"number",default:Y.delay,minimum:0,maximum:1e4,description:m.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Y.sticky,description:m.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:Y.hidingDelay,description:m.localize(45,null)},"editor.hover.above":{type:"boolean",default:Y.above,description:m.localize(46,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ye=Y;return{enabled:o(ye.enabled,this.defaultValue.enabled),delay:i.clampedInt(ye.delay,this.defaultValue.delay,0,1e4),sticky:o(ye.sticky,this.defaultValue.sticky),hidingDelay:i.clampedInt(ye.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:o(ye.above,this.defaultValue.above)}}}var pe;(function(x){x[x.None=0]="None",x[x.Text=1]="Text",x[x.Blocks=2]="Blocks"})(pe||(e.RenderMinimap=pe={}));class ae extends ${constructor(){super(145)}compute(Y,ye,He){return ae.computeLayout(ye,{memory:Y.memory,outerWidth:Y.outerWidth,outerHeight:Y.outerHeight,isDominatedByLongLines:Y.isDominatedByLongLines,lineHeight:Y.fontInfo.lineHeight,viewLineCount:Y.viewLineCount,lineNumbersDigitCount:Y.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Y.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Y.fontInfo.maxDigitWidth,pixelRatio:Y.pixelRatio,glyphMarginDecorationLaneCount:Y.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(Y){const ye=Y.height/Y.lineHeight,He=Math.floor(Y.paddingTop/Y.lineHeight);let Ye=Math.floor(Y.paddingBottom/Y.lineHeight);Y.scrollBeyondLastLine&&(Ye=Math.max(Ye,ye-1));const Me=(He+Y.viewLineCount+Ye)/(Y.pixelRatio*Y.height),dt=Math.floor(Y.viewLineCount/Me);return{typicalViewportLineCount:ye,extraLinesBeforeFirstLine:He,extraLinesBeyondLastLine:Ye,desiredRatio:Me,minimapLineCount:dt}}static c(Y,ye){const He=Y.outerWidth,Ye=Y.outerHeight,Me=Y.pixelRatio;if(!Y.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Me*Ye),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ye};const dt=ye.stableMinimapLayoutInput,Mt=dt&&Y.outerHeight===dt.outerHeight&&Y.lineHeight===dt.lineHeight&&Y.typicalHalfwidthCharacterWidth===dt.typicalHalfwidthCharacterWidth&&Y.pixelRatio===dt.pixelRatio&&Y.scrollBeyondLastLine===dt.scrollBeyondLastLine&&Y.paddingTop===dt.paddingTop&&Y.paddingBottom===dt.paddingBottom&&Y.minimap.enabled===dt.minimap.enabled&&Y.minimap.side===dt.minimap.side&&Y.minimap.size===dt.minimap.size&&Y.minimap.showSlider===dt.minimap.showSlider&&Y.minimap.renderCharacters===dt.minimap.renderCharacters&&Y.minimap.maxColumn===dt.minimap.maxColumn&&Y.minimap.scale===dt.minimap.scale&&Y.verticalScrollbarWidth===dt.verticalScrollbarWidth&&Y.isViewportWrapping===dt.isViewportWrapping,Bt=Y.lineHeight,Qt=Y.typicalHalfwidthCharacterWidth,Yt=Y.scrollBeyondLastLine,xt=Y.minimap.renderCharacters;let It=Me>=2?Math.round(Y.minimap.scale*2):Y.minimap.scale;const ri=Y.minimap.maxColumn,_t=Y.minimap.size,hi=Y.minimap.side,xe=Y.verticalScrollbarWidth,si=Y.viewLineCount,Ht=Y.remainingWidth,Gt=Y.isViewportWrapping,ft=xt?2:3;let vt=Math.floor(Me*Ye);const Xt=vt/Me;let zt=!1,Vt=!1,mt=ft*It,Rt=It/Me,ai=1;if(_t==="fill"||_t==="fit"){const{typicalViewportLineCount:jt,extraLinesBeforeFirstLine:Nt,extraLinesBeyondLastLine:At,desiredRatio:ci,minimapLineCount:Ut}=ae.computeContainedMinimapLineCount({viewLineCount:si,scrollBeyondLastLine:Yt,paddingTop:Y.paddingTop,paddingBottom:Y.paddingBottom,height:Ye,lineHeight:Bt,pixelRatio:Me});if(si/Ut>1)zt=!0,Vt=!0,It=1,mt=1,Rt=It/Me;else{let Ct=!1,Lt=It+1;if(_t==="fit"){const ni=Math.ceil((Nt+si+At)*mt);Gt&&Mt&&Ht<=ye.stableFitRemainingWidth?(Ct=!0,Lt=ye.stableFitMaxMinimapScale):Ct=ni>vt}if(_t==="fill"||Ct){zt=!0;const ni=It;mt=Math.min(Bt*Me,Math.max(1,Math.floor(1/ci))),Gt&&Mt&&Ht<=ye.stableFitRemainingWidth&&(Lt=ye.stableFitMaxMinimapScale),It=Math.min(Lt,Math.max(1,Math.floor(mt/ft))),It>ni&&(ai=Math.min(2,It/ni)),Rt=It/Me/ai,vt=Math.ceil(Math.max(jt,Nt+si+At)*mt),Gt?(ye.stableMinimapLayoutInput=Y,ye.stableFitRemainingWidth=Ht,ye.stableFitMaxMinimapScale=It):(ye.stableMinimapLayoutInput=null,ye.stableFitRemainingWidth=0)}}}const ei=Math.floor(ri*Rt),Ge=Math.min(ei,Math.max(0,Math.floor((Ht-xe-2)*Rt/(Qt+Rt)))+e.MINIMAP_GUTTER_WIDTH);let Zt=Math.floor(Me*Ge);const ti=Zt/Me;Zt=Math.floor(Zt*ai);const ii=xt?1:2,bt=hi==="left"?0:He-Ge-xe;return{renderMinimap:ii,minimapLeft:bt,minimapWidth:Ge,minimapHeightIsEditorHeight:zt,minimapIsSampling:Vt,minimapScale:It,minimapLineHeight:mt,minimapCanvasInnerWidth:Zt,minimapCanvasInnerHeight:vt,minimapCanvasOuterWidth:ti,minimapCanvasOuterHeight:Xt}}static computeLayout(Y,ye){const He=ye.outerWidth|0,Ye=ye.outerHeight|0,Me=ye.lineHeight|0,dt=ye.lineNumbersDigitCount|0,Mt=ye.typicalHalfwidthCharacterWidth,Bt=ye.maxDigitWidth,Qt=ye.pixelRatio,Yt=ye.viewLineCount,xt=Y.get(137),It=xt==="inherit"?Y.get(136):xt,ri=It==="inherit"?Y.get(132):It,_t=Y.get(135),hi=ye.isDominatedByLongLines,xe=Y.get(57),si=Y.get(68).renderType!==0,Ht=Y.get(69),Gt=Y.get(105),ft=Y.get(84),vt=Y.get(73),Xt=Y.get(103),zt=Xt.verticalScrollbarSize,Vt=Xt.verticalHasArrows,mt=Xt.arrowSize,Rt=Xt.horizontalScrollbarSize,ai=Y.get(43),ei=Y.get(110)!=="never";let Ge=Y.get(66);ai&&ei&&(Ge+=16);let Zt=0;if(si){const kt=Math.max(dt,Ht);Zt=Math.round(kt*Bt)}let ti=0;xe&&(ti=Me*ye.glyphMarginDecorationLaneCount);let ii=0,bt=ii+ti,jt=bt+Zt,Nt=jt+Ge;const At=He-ti-Zt-Ge;let ci=!1,Ut=!1,qt=-1;It==="inherit"&&hi?(ci=!0,Ut=!0):ri==="on"||ri==="bounded"?Ut=!0:ri==="wordWrapColumn"&&(qt=_t);const Ct=ae.c({outerWidth:He,outerHeight:Ye,lineHeight:Me,typicalHalfwidthCharacterWidth:Mt,pixelRatio:Qt,scrollBeyondLastLine:Gt,paddingTop:ft.top,paddingBottom:ft.bottom,minimap:vt,verticalScrollbarWidth:zt,viewLineCount:Yt,remainingWidth:At,isViewportWrapping:Ut},ye.memory||new O);Ct.renderMinimap!==0&&Ct.minimapLeft===0&&(ii+=Ct.minimapWidth,bt+=Ct.minimapWidth,jt+=Ct.minimapWidth,Nt+=Ct.minimapWidth);const Lt=At-Ct.minimapWidth,ni=Math.max(1,Math.floor((Lt-zt-2)/Mt)),Pt=Vt?mt:0;return Ut&&(qt=Math.max(1,ni),ri==="bounded"&&(qt=Math.min(qt,_t))),{width:He,height:Ye,glyphMarginLeft:ii,glyphMarginWidth:ti,glyphMarginDecorationLaneCount:ye.glyphMarginDecorationLaneCount,lineNumbersLeft:bt,lineNumbersWidth:Zt,decorationsLeft:jt,decorationsWidth:Ge,contentLeft:Nt,contentWidth:Lt,minimap:Ct,viewportColumn:ni,isWordWrapMinified:ci,isViewportWrapping:Ut,wrappingColumn:qt,verticalScrollbarWidth:zt,horizontalScrollbarHeight:Rt,overviewRuler:{top:Pt,width:zt,height:Ye-2*Pt,right:0}}}}e.EditorLayoutInfoComputer=ae;class be extends D{constructor(){super(139,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[m.localize(47,null),m.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:m.localize(49,null)}})}validate(Y){return p(Y,"simple",["simple","advanced"])}compute(Y,ye,He){return ye.get(2)===2?"advanced":He}}var se;(function(x){x.Off="off",x.OnCode="onCode",x.On="on"})(se||(e.ShowLightbulbIconMode=se={}));class De extends D{constructor(){const Y={enabled:se.On};super(65,"lightbulb",Y,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[se.Off,se.OnCode,se.On],default:Y.enabled,enumDescriptions:[m.localize(50,null),m.localize(51,null),m.localize(52,null)],description:m.localize(53,null)}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{enabled:p(Y.enabled,this.defaultValue.enabled,[se.Off,se.OnCode,se.On])}}}class Oe extends D{constructor(){const Y={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",Y,{"editor.stickyScroll.enabled":{type:"boolean",default:Y.enabled,description:m.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:Y.maxLineCount,minimum:1,maximum:20,description:m.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:Y.defaultModel,description:m.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:Y.scrollWithEditor,description:m.localize(57,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ye=Y;return{enabled:o(ye.enabled,this.defaultValue.enabled),maxLineCount:i.clampedInt(ye.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:p(ye.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:o(ye.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class ie extends D{constructor(){const Y={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(141,"inlayHints",Y,{"editor.inlayHints.enabled":{type:"string",default:Y.enabled,description:m.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[m.localize(59,null),m.localize(60,null,C.$d?"Ctrl+Option":"Ctrl+Alt"),m.localize(61,null,C.$d?"Ctrl+Option":"Ctrl+Alt"),m.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:Y.fontSize,markdownDescription:m.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Y.fontFamily,markdownDescription:m.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Y.padding,description:m.localize(65,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ye=Y;return typeof ye.enabled=="boolean"&&(ye.enabled=ye.enabled?"on":"off"),{enabled:p(ye.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:i.clampedInt(ye.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(ye.fontFamily,this.defaultValue.fontFamily),padding:o(ye.padding,this.defaultValue.padding)}}}class q extends D{constructor(){super(66,"lineDecorationsWidth",10)}validate(Y){return typeof Y=="string"&&/^\d+(\.\d+)?ch$/.test(Y)?-parseFloat(Y.substring(0,Y.length-2)):i.clampedInt(Y,this.defaultValue,0,1e3)}compute(Y,ye,He){return He<0?i.clampedInt(-He*Y.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):He}}class de extends h{constructor(){super(67,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Y=>h.clamp(Y,0,150),{markdownDescription:m.localize(66,null)})}compute(Y,ye,He){return Y.fontInfo.lineHeight}}class Ne extends D{constructor(){const Y={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9};super(73,"minimap",Y,{"editor.minimap.enabled":{type:"boolean",default:Y.enabled,description:m.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:Y.autohide,description:m.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[m.localize(69,null),m.localize(70,null),m.localize(71,null)],default:Y.size,description:m.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Y.side,description:m.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Y.showSlider,description:m.localize(74,null)},"editor.minimap.scale":{type:"number",default:Y.scale,minimum:1,maximum:3,enum:[1,2,3],description:m.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Y.renderCharacters,description:m.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:Y.maxColumn,description:m.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:Y.showRegionSectionHeaders,description:m.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:Y.showMarkSectionHeaders,description:m.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:Y.sectionHeaderFontSize,description:m.localize(80,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ye=Y;return{enabled:o(ye.enabled,this.defaultValue.enabled),autohide:o(ye.autohide,this.defaultValue.autohide),size:p(ye.size,this.defaultValue.size,["proportional","fill","fit"]),side:p(ye.side,this.defaultValue.side,["right","left"]),showSlider:p(ye.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:o(ye.renderCharacters,this.defaultValue.renderCharacters),scale:i.clampedInt(ye.scale,1,1,3),maxColumn:i.clampedInt(ye.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:o(ye.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:o(ye.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:h.clamp(ye.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32)}}}function $e(x){return x==="ctrlCmd"?C.$d?"metaKey":"ctrlKey":"altKey"}class we extends D{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(81,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(82,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ye=Y;return{top:i.clampedInt(ye.top,0,0,1e3),bottom:i.clampedInt(ye.bottom,0,0,1e3)}}}class ge extends D{constructor(){const Y={enabled:!0,cycle:!0};super(86,"parameterHints",Y,{"editor.parameterHints.enabled":{type:"boolean",default:Y.enabled,description:m.localize(83,null)},"editor.parameterHints.cycle":{type:"boolean",default:Y.cycle,description:m.localize(84,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ye=Y;return{enabled:o(ye.enabled,this.defaultValue.enabled),cycle:o(ye.cycle,this.defaultValue.cycle)}}}class ce extends ${constructor(){super(143)}compute(Y,ye,He){return Y.pixelRatio}}class K extends D{constructor(){const Y={other:"on",comments:"off",strings:"off"},ye=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[m.localize(85,null),m.localize(86,null),m.localize(87,null)]}];super(89,"quickSuggestions",Y,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:ye,default:Y.strings,description:m.localize(88,null)},comments:{anyOf:ye,default:Y.comments,description:m.localize(89,null)},other:{anyOf:ye,default:Y.other,description:m.localize(90,null)}},default:Y,markdownDescription:m.localize(91,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Y}validate(Y){if(typeof Y=="boolean"){const Qt=Y?"on":"off";return{comments:Qt,strings:Qt,other:Qt}}if(!Y||typeof Y!="object")return this.defaultValue;const{other:ye,comments:He,strings:Ye}=Y,Me=["on","inline","off"];let dt,Mt,Bt;return typeof ye=="boolean"?dt=ye?"on":"off":dt=p(ye,this.defaultValue.other,Me),typeof He=="boolean"?Mt=He?"on":"off":Mt=p(He,this.defaultValue.comments,Me),typeof Ye=="boolean"?Bt=Ye?"on":"off":Bt=p(Ye,this.defaultValue.strings,Me),{other:dt,comments:Mt,strings:Bt}}}var Z;(function(x){x[x.Off=0]="Off",x[x.On=1]="On",x[x.Relative=2]="Relative",x[x.Interval=3]="Interval",x[x.Custom=4]="Custom"})(Z||(e.RenderLineNumbersType=Z={}));class le extends D{constructor(){super(68,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[m.localize(92,null),m.localize(93,null),m.localize(94,null),m.localize(95,null)],default:"on",description:m.localize(96,null)})}validate(Y){let ye=this.defaultValue.renderType,He=this.defaultValue.renderFn;return typeof Y<"u"&&(typeof Y=="function"?(ye=4,He=Y):Y==="interval"?ye=3:Y==="relative"?ye=2:Y==="on"?ye=1:ye=0),{renderType:ye,renderFn:He}}}function fe(x){const Y=x.get(98);return Y==="editable"?x.get(91):Y!=="on"}class Te extends D{constructor(){const Y=[],ye={type:"number",description:m.localize(97,null)};super(102,"rulers",Y,{type:"array",items:{anyOf:[ye,{type:["object"],properties:{column:ye,color:{type:"string",description:m.localize(98,null),format:"color-hex"}}}]},default:Y,description:m.localize(99,null)})}validate(Y){if(Array.isArray(Y)){const ye=[];for(const He of Y)if(typeof He=="number")ye.push({column:i.clampedInt(He,0,0,1e4),color:null});else if(He&&typeof He=="object"){const Ye=He;ye.push({column:i.clampedInt(Ye.column,0,0,1e4),color:Ye.color})}return ye.sort((He,Ye)=>He.column-Ye.column),ye}return this.defaultValue}}class ve extends D{constructor(){super(92,"readOnlyMessage",void 0)}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:Y}}function Ie(x,Y){if(typeof x!="string")return Y;switch(x){case"hidden":return 2;case"visible":return 3;default:return 1}}class Ae extends D{constructor(){const Y={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",Y,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(100,null),m.localize(101,null),m.localize(102,null)],default:"auto",description:m.localize(103,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(104,null),m.localize(105,null),m.localize(106,null)],default:"auto",description:m.localize(107,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Y.verticalScrollbarSize,description:m.localize(108,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Y.horizontalScrollbarSize,description:m.localize(109,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Y.scrollByPage,description:m.localize(110,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:Y.ignoreHorizontalScrollbarInContentHeight,description:m.localize(111,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ye=Y,He=i.clampedInt(ye.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ye=i.clampedInt(ye.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:i.clampedInt(ye.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ie(ye.vertical,this.defaultValue.vertical),horizontal:Ie(ye.horizontal,this.defaultValue.horizontal),useShadows:o(ye.useShadows,this.defaultValue.useShadows),verticalHasArrows:o(ye.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:o(ye.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:o(ye.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:o(ye.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:He,horizontalSliderSize:i.clampedInt(ye.horizontalSliderSize,He,0,1e3),verticalScrollbarSize:Ye,verticalSliderSize:i.clampedInt(ye.verticalSliderSize,Ye,0,1e3),scrollByPage:o(ye.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:o(ye.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class je extends D{constructor(){const Y={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",Y,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.nonBasicASCII,description:m.localize(112,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Y.invisibleCharacters,description:m.localize(113,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Y.ambiguousCharacters,description:m.localize(114,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.includeComments,description:m.localize(115,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.includeStrings,description:m.localize(116,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Y.allowedCharacters,description:m.localize(117,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Y.allowedLocales,description:m.localize(118,null)}})}applyUpdate(Y,ye){let He=!1;ye.allowedCharacters&&Y&&(M.$Tn(Y.allowedCharacters,ye.allowedCharacters)||(Y={...Y,allowedCharacters:ye.allowedCharacters},He=!0)),ye.allowedLocales&&Y&&(M.$Tn(Y.allowedLocales,ye.allowedLocales)||(Y={...Y,allowedLocales:ye.allowedLocales},He=!0));const Ye=super.applyUpdate(Y,ye);return He?new l(Ye.newValue,!0):Ye}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ye=Y;return{nonBasicASCII:_(ye.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:o(ye.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:o(ye.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:_(ye.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:_(ye.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(Y.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(Y.allowedLocales,this.defaultValue.allowedLocales)}}c(Y,ye){if(typeof Y!="object"||!Y)return ye;const He={};for(const[Ye,Me]of Object.entries(Y))Me===!0&&(He[Ye]=!0);return He}}class j extends D{constructor(){const Y={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",Y,{"editor.inlineSuggest.enabled":{type:"boolean",default:Y.enabled,description:m.localize(119,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:Y.showToolbar,enum:["always","onHover","never"],enumDescriptions:[m.localize(120,null),m.localize(121,null),m.localize(122,null)],description:m.localize(123,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:Y.suppressSuggestions,description:m.localize(124,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:Y.fontFamily,description:m.localize(125,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ye=Y;return{enabled:o(ye.enabled,this.defaultValue.enabled),mode:p(ye.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:p(ye.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:o(ye.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:o(ye.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:t.string(ye.fontFamily,this.defaultValue.fontFamily)}}}class B extends D{constructor(){const Y={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(63,"experimentalInlineEdit",Y,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:Y.enabled,description:m.localize(126,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:Y.showToolbar,enum:["always","onHover","never"],enumDescriptions:[m.localize(127,null),m.localize(128,null),m.localize(129,null)],description:m.localize(130,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:Y.fontFamily,description:m.localize(131,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:Y.backgroundColoring,description:m.localize(132,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ye=Y;return{enabled:o(ye.enabled,this.defaultValue.enabled),showToolbar:p(ye.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:t.string(ye.fontFamily,this.defaultValue.fontFamily),keepOnBlur:o(ye.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:o(ye.backgroundColoring,this.defaultValue.backgroundColoring)}}}class G extends D{constructor(){const Y={enabled:N.$Ns.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:N.$Ns.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",Y,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Y.enabled,markdownDescription:m.localize(133,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Y.independentColorPoolPerBracketType,description:m.localize(134,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ye=Y;return{enabled:o(ye.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:o(ye.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class W extends D{constructor(){const Y={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",Y,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(135,null),m.localize(136,null),m.localize(137,null)],default:Y.bracketPairs,description:m.localize(138,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(139,null),m.localize(140,null),m.localize(141,null)],default:Y.bracketPairsHorizontal,description:m.localize(142,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Y.highlightActiveBracketPair,description:m.localize(143,null)},"editor.guides.indentation":{type:"boolean",default:Y.indentation,description:m.localize(144,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[m.localize(145,null),m.localize(146,null),m.localize(147,null)],default:Y.highlightActiveIndentation,description:m.localize(148,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ye=Y;return{bracketPairs:_(ye.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:_(ye.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:o(ye.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:o(ye.indentation,this.defaultValue.indentation),highlightActiveIndentation:_(ye.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function _(x,Y,ye){const He=ye.indexOf(x);return He===-1?Y:ye[He]}class oe extends D{constructor(){const Y={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",Y,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[m.localize(149,null),m.localize(150,null)],default:Y.insertMode,description:m.localize(151,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Y.filterGraceful,description:m.localize(152,null)},"editor.suggest.localityBonus":{type:"boolean",default:Y.localityBonus,description:m.localize(153,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Y.shareSuggestSelections,markdownDescription:m.localize(154,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[m.localize(155,null),m.localize(156,null),m.localize(157,null),m.localize(158,null)],default:Y.selectionMode,markdownDescription:m.localize(159,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Y.snippetsPreventQuickSuggestions,description:m.localize(160,null)},"editor.suggest.showIcons":{type:"boolean",default:Y.showIcons,description:m.localize(161,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Y.showStatusBar,description:m.localize(162,null)},"editor.suggest.preview":{type:"boolean",default:Y.preview,description:m.localize(163,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Y.showInlineDetails,description:m.localize(164,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:m.localize(165,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:m.localize(166,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:m.localize(167,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:m.localize(168,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:m.localize(169,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:m.localize(170,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:m.localize(171,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:m.localize(172,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:m.localize(173,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:m.localize(174,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:m.localize(175,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:m.localize(176,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:m.localize(177,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:m.localize(178,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:m.localize(179,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:m.localize(180,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:m.localize(181,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:m.localize(182,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:m.localize(183,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:m.localize(184,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:m.localize(185,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:m.localize(186,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:m.localize(187,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:m.localize(188,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:m.localize(189,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:m.localize(190,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:m.localize(191,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:m.localize(192,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:m.localize(193,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:m.localize(194,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:m.localize(195,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:m.localize(196,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ye=Y;return{insertMode:p(ye.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:o(ye.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:o(ye.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:o(ye.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:o(ye.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:p(ye.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:o(ye.showIcons,this.defaultValue.showIcons),showStatusBar:o(ye.showStatusBar,this.defaultValue.showStatusBar),preview:o(ye.preview,this.defaultValue.preview),previewMode:p(ye.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:o(ye.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:o(ye.showMethods,this.defaultValue.showMethods),showFunctions:o(ye.showFunctions,this.defaultValue.showFunctions),showConstructors:o(ye.showConstructors,this.defaultValue.showConstructors),showDeprecated:o(ye.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:o(ye.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:o(ye.showFields,this.defaultValue.showFields),showVariables:o(ye.showVariables,this.defaultValue.showVariables),showClasses:o(ye.showClasses,this.defaultValue.showClasses),showStructs:o(ye.showStructs,this.defaultValue.showStructs),showInterfaces:o(ye.showInterfaces,this.defaultValue.showInterfaces),showModules:o(ye.showModules,this.defaultValue.showModules),showProperties:o(ye.showProperties,this.defaultValue.showProperties),showEvents:o(ye.showEvents,this.defaultValue.showEvents),showOperators:o(ye.showOperators,this.defaultValue.showOperators),showUnits:o(ye.showUnits,this.defaultValue.showUnits),showValues:o(ye.showValues,this.defaultValue.showValues),showConstants:o(ye.showConstants,this.defaultValue.showConstants),showEnums:o(ye.showEnums,this.defaultValue.showEnums),showEnumMembers:o(ye.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:o(ye.showKeywords,this.defaultValue.showKeywords),showWords:o(ye.showWords,this.defaultValue.showWords),showColors:o(ye.showColors,this.defaultValue.showColors),showFiles:o(ye.showFiles,this.defaultValue.showFiles),showReferences:o(ye.showReferences,this.defaultValue.showReferences),showFolders:o(ye.showFolders,this.defaultValue.showFolders),showTypeParameters:o(ye.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:o(ye.showSnippets,this.defaultValue.showSnippets),showUsers:o(ye.showUsers,this.defaultValue.showUsers),showIssues:o(ye.showIssues,this.defaultValue.showIssues)}}}class Fe extends D{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:m.localize(197,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:m.localize(198,null),default:!0,type:"boolean"}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:o(Y.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:o(Y.selectSubwords,this.defaultValue.selectSubwords)}}}class Be extends D{constructor(){const Y=[];super(130,"wordSegmenterLocales",Y,{anyOf:[{description:m.localize(199,null),type:"string"},{description:m.localize(200,null),type:"array",items:{type:"string"}}]})}validate(Y){if(typeof Y=="string"&&(Y=[Y]),Array.isArray(Y)){const ye=[];for(const He of Y)if(typeof He=="string")try{Intl.Segmenter.supportedLocalesOf(He).length>0&&ye.push(He)}catch{}return ye}return this.defaultValue}}var Qe;(function(x){x[x.None=0]="None",x[x.Same=1]="Same",x[x.Indent=2]="Indent",x[x.DeepIndent=3]="DeepIndent"})(Qe||(e.WrappingIndent=Qe={}));class et extends D{constructor(){super(138,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[m.localize(201,null),m.localize(202,null),m.localize(203,null),m.localize(204,null)],description:m.localize(205,null),default:"same"}})}validate(Y){switch(Y){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Y,ye,He){return ye.get(2)===2?0:He}}class it extends ${constructor(){super(146)}compute(Y,ye,He){const Ye=ye.get(145);return{isDominatedByLongLines:Y.isDominatedByLongLines,isWordWrapMinified:Ye.isWordWrapMinified,isViewportWrapping:Ye.isViewportWrapping,wrappingColumn:Ye.wrappingColumn}}}class ut extends D{constructor(){const Y={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",Y,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Y.enabled,markdownDescription:m.localize(206,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:m.localize(207,null),enum:["afterDrop","never"],enumDescriptions:[m.localize(208,null),m.localize(209,null)],default:"afterDrop"}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ye=Y;return{enabled:o(ye.enabled,this.defaultValue.enabled),showDropSelector:p(ye.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class st extends D{constructor(){const Y={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",Y,{"editor.pasteAs.enabled":{type:"boolean",default:Y.enabled,markdownDescription:m.localize(210,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:m.localize(211,null),enum:["afterPaste","never"],enumDescriptions:[m.localize(212,null),m.localize(213,null)],default:"afterPaste"}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ye=Y;return{enabled:o(ye.enabled,this.defaultValue.enabled),showPasteSelector:p(ye.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const rt="Consolas, 'Courier New', monospace",ot="Menlo, Monaco, 'Courier New', monospace",$t="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:C.$d?ot:C.$e?$t:rt,fontWeight:"normal",fontSize:C.$d?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ue(x){return e.editorOptionsRegistry[x.id]=x,x}var ct;(function(x){x[x.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",x[x.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",x[x.accessibilitySupport=2]="accessibilitySupport",x[x.accessibilityPageSize=3]="accessibilityPageSize",x[x.ariaLabel=4]="ariaLabel",x[x.ariaRequired=5]="ariaRequired",x[x.autoClosingBrackets=6]="autoClosingBrackets",x[x.autoClosingComments=7]="autoClosingComments",x[x.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",x[x.autoClosingDelete=9]="autoClosingDelete",x[x.autoClosingOvertype=10]="autoClosingOvertype",x[x.autoClosingQuotes=11]="autoClosingQuotes",x[x.autoIndent=12]="autoIndent",x[x.automaticLayout=13]="automaticLayout",x[x.autoSurround=14]="autoSurround",x[x.bracketPairColorization=15]="bracketPairColorization",x[x.guides=16]="guides",x[x.codeLens=17]="codeLens",x[x.codeLensFontFamily=18]="codeLensFontFamily",x[x.codeLensFontSize=19]="codeLensFontSize",x[x.colorDecorators=20]="colorDecorators",x[x.colorDecoratorsLimit=21]="colorDecoratorsLimit",x[x.columnSelection=22]="columnSelection",x[x.comments=23]="comments",x[x.contextmenu=24]="contextmenu",x[x.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",x[x.cursorBlinking=26]="cursorBlinking",x[x.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",x[x.cursorStyle=28]="cursorStyle",x[x.cursorSurroundingLines=29]="cursorSurroundingLines",x[x.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",x[x.cursorWidth=31]="cursorWidth",x[x.disableLayerHinting=32]="disableLayerHinting",x[x.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",x[x.domReadOnly=34]="domReadOnly",x[x.dragAndDrop=35]="dragAndDrop",x[x.dropIntoEditor=36]="dropIntoEditor",x[x.emptySelectionClipboard=37]="emptySelectionClipboard",x[x.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",x[x.extraEditorClassName=39]="extraEditorClassName",x[x.fastScrollSensitivity=40]="fastScrollSensitivity",x[x.find=41]="find",x[x.fixedOverflowWidgets=42]="fixedOverflowWidgets",x[x.folding=43]="folding",x[x.foldingStrategy=44]="foldingStrategy",x[x.foldingHighlight=45]="foldingHighlight",x[x.foldingImportsByDefault=46]="foldingImportsByDefault",x[x.foldingMaximumRegions=47]="foldingMaximumRegions",x[x.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",x[x.fontFamily=49]="fontFamily",x[x.fontInfo=50]="fontInfo",x[x.fontLigatures=51]="fontLigatures",x[x.fontSize=52]="fontSize",x[x.fontWeight=53]="fontWeight",x[x.fontVariations=54]="fontVariations",x[x.formatOnPaste=55]="formatOnPaste",x[x.formatOnType=56]="formatOnType",x[x.glyphMargin=57]="glyphMargin",x[x.gotoLocation=58]="gotoLocation",x[x.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",x[x.hover=60]="hover",x[x.inDiffEditor=61]="inDiffEditor",x[x.inlineSuggest=62]="inlineSuggest",x[x.inlineEdit=63]="inlineEdit",x[x.letterSpacing=64]="letterSpacing",x[x.lightbulb=65]="lightbulb",x[x.lineDecorationsWidth=66]="lineDecorationsWidth",x[x.lineHeight=67]="lineHeight",x[x.lineNumbers=68]="lineNumbers",x[x.lineNumbersMinChars=69]="lineNumbersMinChars",x[x.linkedEditing=70]="linkedEditing",x[x.links=71]="links",x[x.matchBrackets=72]="matchBrackets",x[x.minimap=73]="minimap",x[x.mouseStyle=74]="mouseStyle",x[x.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",x[x.mouseWheelZoom=76]="mouseWheelZoom",x[x.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",x[x.multiCursorModifier=78]="multiCursorModifier",x[x.multiCursorPaste=79]="multiCursorPaste",x[x.multiCursorLimit=80]="multiCursorLimit",x[x.occurrencesHighlight=81]="occurrencesHighlight",x[x.overviewRulerBorder=82]="overviewRulerBorder",x[x.overviewRulerLanes=83]="overviewRulerLanes",x[x.padding=84]="padding",x[x.pasteAs=85]="pasteAs",x[x.parameterHints=86]="parameterHints",x[x.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",x[x.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",x[x.quickSuggestions=89]="quickSuggestions",x[x.quickSuggestionsDelay=90]="quickSuggestionsDelay",x[x.readOnly=91]="readOnly",x[x.readOnlyMessage=92]="readOnlyMessage",x[x.renameOnType=93]="renameOnType",x[x.renderControlCharacters=94]="renderControlCharacters",x[x.renderFinalNewline=95]="renderFinalNewline",x[x.renderLineHighlight=96]="renderLineHighlight",x[x.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",x[x.renderValidationDecorations=98]="renderValidationDecorations",x[x.renderWhitespace=99]="renderWhitespace",x[x.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",x[x.roundedSelection=101]="roundedSelection",x[x.rulers=102]="rulers",x[x.scrollbar=103]="scrollbar",x[x.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",x[x.scrollBeyondLastLine=105]="scrollBeyondLastLine",x[x.scrollPredominantAxis=106]="scrollPredominantAxis",x[x.selectionClipboard=107]="selectionClipboard",x[x.selectionHighlight=108]="selectionHighlight",x[x.selectOnLineNumbers=109]="selectOnLineNumbers",x[x.showFoldingControls=110]="showFoldingControls",x[x.showUnused=111]="showUnused",x[x.snippetSuggestions=112]="snippetSuggestions",x[x.smartSelect=113]="smartSelect",x[x.smoothScrolling=114]="smoothScrolling",x[x.stickyScroll=115]="stickyScroll",x[x.stickyTabStops=116]="stickyTabStops",x[x.stopRenderingLineAfter=117]="stopRenderingLineAfter",x[x.suggest=118]="suggest",x[x.suggestFontSize=119]="suggestFontSize",x[x.suggestLineHeight=120]="suggestLineHeight",x[x.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",x[x.suggestSelection=122]="suggestSelection",x[x.tabCompletion=123]="tabCompletion",x[x.tabIndex=124]="tabIndex",x[x.unicodeHighlighting=125]="unicodeHighlighting",x[x.unusualLineTerminators=126]="unusualLineTerminators",x[x.useShadowDOM=127]="useShadowDOM",x[x.useTabStops=128]="useTabStops",x[x.wordBreak=129]="wordBreak",x[x.wordSegmenterLocales=130]="wordSegmenterLocales",x[x.wordSeparators=131]="wordSeparators",x[x.wordWrap=132]="wordWrap",x[x.wordWrapBreakAfterCharacters=133]="wordWrapBreakAfterCharacters",x[x.wordWrapBreakBeforeCharacters=134]="wordWrapBreakBeforeCharacters",x[x.wordWrapColumn=135]="wordWrapColumn",x[x.wordWrapOverride1=136]="wordWrapOverride1",x[x.wordWrapOverride2=137]="wordWrapOverride2",x[x.wrappingIndent=138]="wrappingIndent",x[x.wrappingStrategy=139]="wrappingStrategy",x[x.showDeprecated=140]="showDeprecated",x[x.inlayHints=141]="inlayHints",x[x.editorClassName=142]="editorClassName",x[x.pixelRatio=143]="pixelRatio",x[x.tabFocusMode=144]="tabFocusMode",x[x.layoutInfo=145]="layoutInfo",x[x.wrappingInfo=146]="wrappingInfo",x[x.defaultColorDecorators=147]="defaultColorDecorators",x[x.colorDecoratorsActivatedOn=148]="colorDecoratorsActivatedOn",x[x.inlineCompletionsAccessibilityVerbose=149]="inlineCompletionsAccessibilityVerbose"})(ct||(e.EditorOption=ct={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ue(new s(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:m.localize(214,null)})),acceptSuggestionOnEnter:Ue(new a(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",m.localize(215,null),""],markdownDescription:m.localize(216,null)})),accessibilitySupport:Ue(new f),accessibilityPageSize:Ue(new i(3,"accessibilityPageSize",10,1,1073741824,{description:m.localize(217,null),tags:["accessibility"]})),ariaLabel:Ue(new t(4,"ariaLabel",m.localize(218,null))),ariaRequired:Ue(new s(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Ue(new s(8,"screenReaderAnnounceInlineSuggestion",!0,{description:m.localize(219,null),tags:["accessibility"]})),autoClosingBrackets:Ue(new a(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(220,null),m.localize(221,null),""],description:m.localize(222,null)})),autoClosingComments:Ue(new a(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(223,null),m.localize(224,null),""],description:m.localize(225,null)})),autoClosingDelete:Ue(new a(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",m.localize(226,null),""],description:m.localize(227,null)})),autoClosingOvertype:Ue(new a(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",m.localize(228,null),""],description:m.localize(229,null)})),autoClosingQuotes:Ue(new a(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(230,null),m.localize(231,null),""],description:m.localize(232,null)})),autoIndent:Ue(new g(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],v,{enumDescriptions:[m.localize(233,null),m.localize(234,null),m.localize(235,null),m.localize(236,null),m.localize(237,null)],description:m.localize(238,null)})),automaticLayout:Ue(new s(13,"automaticLayout",!1)),autoSurround:Ue(new a(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[m.localize(239,null),m.localize(240,null),m.localize(241,null),""],description:m.localize(242,null)})),bracketPairColorization:Ue(new G),bracketPairGuides:Ue(new W),stickyTabStops:Ue(new s(116,"stickyTabStops",!1,{description:m.localize(243,null)})),codeLens:Ue(new s(17,"codeLens",!0,{description:m.localize(244,null)})),codeLensFontFamily:Ue(new t(18,"codeLensFontFamily","",{description:m.localize(245,null)})),codeLensFontSize:Ue(new i(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:m.localize(246,null)})),colorDecorators:Ue(new s(20,"colorDecorators",!0,{description:m.localize(247,null)})),colorDecoratorActivatedOn:Ue(new a(148,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[m.localize(248,null),m.localize(249,null),m.localize(250,null)],description:m.localize(251,null)})),colorDecoratorsLimit:Ue(new i(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:m.localize(252,null)})),columnSelection:Ue(new s(22,"columnSelection",!1,{description:m.localize(253,null)})),comments:Ue(new u),contextmenu:Ue(new s(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Ue(new s(25,"copyWithSyntaxHighlighting",!0,{description:m.localize(254,null)})),cursorBlinking:Ue(new g(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],w,{description:m.localize(255,null)})),cursorSmoothCaretAnimation:Ue(new a(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[m.localize(256,null),m.localize(257,null),m.localize(258,null)],description:m.localize(259,null)})),cursorStyle:Ue(new g(28,"cursorStyle",I.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],P,{description:m.localize(260,null)})),cursorSurroundingLines:Ue(new i(29,"cursorSurroundingLines",0,0,1073741824,{description:m.localize(261,null)})),cursorSurroundingLinesStyle:Ue(new a(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[m.localize(262,null),m.localize(263,null)],markdownDescription:m.localize(264,null)})),cursorWidth:Ue(new i(31,"cursorWidth",0,0,1073741824,{markdownDescription:m.localize(265,null)})),disableLayerHinting:Ue(new s(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ue(new s(33,"disableMonospaceOptimizations",!1)),domReadOnly:Ue(new s(34,"domReadOnly",!1)),dragAndDrop:Ue(new s(35,"dragAndDrop",!0,{description:m.localize(266,null)})),emptySelectionClipboard:Ue(new Q),dropIntoEditor:Ue(new ut),stickyScroll:Ue(new Oe),experimentalWhitespaceRendering:Ue(new a(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[m.localize(267,null),m.localize(268,null),m.localize(269,null)],description:m.localize(270,null)})),extraEditorClassName:Ue(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Ue(new h(40,"fastScrollSensitivity",5,x=>x<=0?5:x,{markdownDescription:m.localize(271,null)})),find:Ue(new H),fixedOverflowWidgets:Ue(new s(42,"fixedOverflowWidgets",!1)),folding:Ue(new s(43,"folding",!0,{description:m.localize(272,null)})),foldingStrategy:Ue(new a(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[m.localize(273,null),m.localize(274,null)],description:m.localize(275,null)})),foldingHighlight:Ue(new s(45,"foldingHighlight",!0,{description:m.localize(276,null)})),foldingImportsByDefault:Ue(new s(46,"foldingImportsByDefault",!1,{description:m.localize(277,null)})),foldingMaximumRegions:Ue(new i(47,"foldingMaximumRegions",5e3,10,65e3,{description:m.localize(278,null)})),unfoldOnClickAfterEndOfLine:Ue(new s(48,"unfoldOnClickAfterEndOfLine",!1,{description:m.localize(279,null)})),fontFamily:Ue(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:m.localize(280,null)})),fontInfo:Ue(new F),fontLigatures2:Ue(new L),fontSize:Ue(new T),fontWeight:Ue(new X),fontVariations:Ue(new R),formatOnPaste:Ue(new s(55,"formatOnPaste",!1,{description:m.localize(281,null)})),formatOnType:Ue(new s(56,"formatOnType",!1,{description:m.localize(282,null)})),glyphMargin:Ue(new s(57,"glyphMargin",!0,{description:m.localize(283,null)})),gotoLocation:Ue(new re),hideCursorInOverviewRuler:Ue(new s(59,"hideCursorInOverviewRuler",!1,{description:m.localize(284,null)})),hover:Ue(new me),inDiffEditor:Ue(new s(61,"inDiffEditor",!1)),letterSpacing:Ue(new h(64,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,x=>h.clamp(x,-5,20),{description:m.localize(285,null)})),lightbulb:Ue(new De),lineDecorationsWidth:Ue(new q),lineHeight:Ue(new de),lineNumbers:Ue(new le),lineNumbersMinChars:Ue(new i(69,"lineNumbersMinChars",5,1,300)),linkedEditing:Ue(new s(70,"linkedEditing",!1,{description:m.localize(286,null)})),links:Ue(new s(71,"links",!0,{description:m.localize(287,null)})),matchBrackets:Ue(new a(72,"matchBrackets","always",["always","near","never"],{description:m.localize(288,null)})),minimap:Ue(new Ne),mouseStyle:Ue(new a(74,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ue(new h(75,"mouseWheelScrollSensitivity",1,x=>x===0?1:x,{markdownDescription:m.localize(289,null)})),mouseWheelZoom:Ue(new s(76,"mouseWheelZoom",!1,{markdownDescription:C.$d?m.localize(290,null):m.localize(291,null)})),multiCursorMergeOverlapping:Ue(new s(77,"multiCursorMergeOverlapping",!0,{description:m.localize(292,null)})),multiCursorModifier:Ue(new g(78,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],$e,{markdownEnumDescriptions:[m.localize(293,null),m.localize(294,null)],markdownDescription:m.localize(295,null)})),multiCursorPaste:Ue(new a(79,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[m.localize(296,null),m.localize(297,null)],markdownDescription:m.localize(298,null)})),multiCursorLimit:Ue(new i(80,"multiCursorLimit",1e4,1,1e5,{markdownDescription:m.localize(299,null)})),occurrencesHighlight:Ue(new a(81,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[m.localize(300,null),m.localize(301,null),m.localize(302,null)],markdownDescription:m.localize(303,null)})),overviewRulerBorder:Ue(new s(82,"overviewRulerBorder",!0,{description:m.localize(304,null)})),overviewRulerLanes:Ue(new i(83,"overviewRulerLanes",3,0,3)),padding:Ue(new we),pasteAs:Ue(new st),parameterHints:Ue(new ge),peekWidgetDefaultFocus:Ue(new a(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[m.localize(305,null),m.localize(306,null)],description:m.localize(307,null)})),definitionLinkOpensInPeek:Ue(new s(88,"definitionLinkOpensInPeek",!1,{description:m.localize(308,null)})),quickSuggestions:Ue(new K),quickSuggestionsDelay:Ue(new i(90,"quickSuggestionsDelay",10,0,1073741824,{description:m.localize(309,null)})),readOnly:Ue(new s(91,"readOnly",!1)),readOnlyMessage:Ue(new ve),renameOnType:Ue(new s(93,"renameOnType",!1,{description:m.localize(310,null),markdownDeprecationMessage:m.localize(311,null)})),renderControlCharacters:Ue(new s(94,"renderControlCharacters",!0,{description:m.localize(312,null),restricted:!0})),renderFinalNewline:Ue(new a(95,"renderFinalNewline",C.$e?"dimmed":"on",["off","on","dimmed"],{description:m.localize(313,null)})),renderLineHighlight:Ue(new a(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",m.localize(314,null)],description:m.localize(315,null)})),renderLineHighlightOnlyWhenFocus:Ue(new s(97,"renderLineHighlightOnlyWhenFocus",!1,{description:m.localize(316,null)})),renderValidationDecorations:Ue(new a(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ue(new a(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",m.localize(317,null),m.localize(318,null),m.localize(319,null),""],description:m.localize(320,null)})),revealHorizontalRightPadding:Ue(new i(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Ue(new s(101,"roundedSelection",!0,{description:m.localize(321,null)})),rulers:Ue(new Te),scrollbar:Ue(new Ae),scrollBeyondLastColumn:Ue(new i(104,"scrollBeyondLastColumn",4,0,1073741824,{description:m.localize(322,null)})),scrollBeyondLastLine:Ue(new s(105,"scrollBeyondLastLine",!0,{description:m.localize(323,null)})),scrollPredominantAxis:Ue(new s(106,"scrollPredominantAxis",!0,{description:m.localize(324,null)})),selectionClipboard:Ue(new s(107,"selectionClipboard",!0,{description:m.localize(325,null),included:C.$e})),selectionHighlight:Ue(new s(108,"selectionHighlight",!0,{description:m.localize(326,null)})),selectOnLineNumbers:Ue(new s(109,"selectOnLineNumbers",!0)),showFoldingControls:Ue(new a(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[m.localize(327,null),m.localize(328,null),m.localize(329,null)],description:m.localize(330,null)})),showUnused:Ue(new s(111,"showUnused",!0,{description:m.localize(331,null)})),showDeprecated:Ue(new s(140,"showDeprecated",!0,{description:m.localize(332,null)})),inlayHints:Ue(new ie),snippetSuggestions:Ue(new a(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[m.localize(333,null),m.localize(334,null),m.localize(335,null),m.localize(336,null)],description:m.localize(337,null)})),smartSelect:Ue(new Fe),smoothScrolling:Ue(new s(114,"smoothScrolling",!1,{description:m.localize(338,null)})),stopRenderingLineAfter:Ue(new i(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ue(new oe),inlineSuggest:Ue(new j),inlineEdit:Ue(new B),inlineCompletionsAccessibilityVerbose:Ue(new s(149,"inlineCompletionsAccessibilityVerbose",!1,{description:m.localize(339,null)})),suggestFontSize:Ue(new i(119,"suggestFontSize",0,0,1e3,{markdownDescription:m.localize(340,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Ue(new i(120,"suggestLineHeight",0,0,1e3,{markdownDescription:m.localize(341,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Ue(new s(121,"suggestOnTriggerCharacters",!0,{description:m.localize(342,null)})),suggestSelection:Ue(new a(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[m.localize(343,null),m.localize(344,null),m.localize(345,null)],description:m.localize(346,null)})),tabCompletion:Ue(new a(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[m.localize(347,null),m.localize(348,null),m.localize(349,null)],description:m.localize(350,null)})),tabIndex:Ue(new i(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ue(new je),unusualLineTerminators:Ue(new a(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[m.localize(351,null),m.localize(352,null),m.localize(353,null)],description:m.localize(354,null)})),useShadowDOM:Ue(new s(127,"useShadowDOM",!0)),useTabStops:Ue(new s(128,"useTabStops",!0,{description:m.localize(355,null)})),wordBreak:Ue(new a(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[m.localize(356,null),m.localize(357,null)],description:m.localize(358,null)})),wordSegmenterLocales:Ue(new Be),wordSeparators:Ue(new t(131,"wordSeparators",A.$Os,{description:m.localize(359,null)})),wordWrap:Ue(new a(132,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[m.localize(360,null),m.localize(361,null),m.localize(362,null),m.localize(363,null)],description:m.localize(364,null)})),wordWrapBreakAfterCharacters:Ue(new t(133,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ue(new t(134,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ue(new i(135,"wordWrapColumn",80,1,1073741824,{markdownDescription:m.localize(365,null)})),wordWrapOverride1:Ue(new a(136,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ue(new a(137,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Ue(new U),defaultColorDecorators:Ue(new s(147,"defaultColorDecorators",!1,{markdownDescription:m.localize(366,null)})),pixelRatio:Ue(new ce),tabFocusMode:Ue(new s(144,"tabFocusMode",!1,{markdownDescription:m.localize(367,null)})),layoutInfo:Ue(new ae),wrappingInfo:Ue(new it),wrappingIndent:Ue(new et),wrappingStrategy:Ue(new be)}}),define(Pe[153],Re([9,10]),function(ee,e){return ee.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Pe[154],Re([9,10]),function(ee,e){return ee.create("vs/platform/contextkey/common/contextkey",e)}),define(Pe[155],Re([9,10]),function(ee,e){return ee.create("vs/platform/contextkey/common/scanner",e)}),define(Pe[156],Re([9,10]),function(ee,e){return ee.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Pe[157],Re([9,10]),function(ee,e){return ee.create("vs/platform/extensions/common/extensionValidator",e)}),define(Pe[158],Re([9,10]),function(ee,e){return ee.create("vs/platform/files/common/files",e)}),define(Pe[159],Re([9,10]),function(ee,e){return ee.create("vs/platform/log/common/log",e)}),define(Pe[160],Re([9,10]),function(ee,e){return ee.create("vs/platform/markers/common/markers",e)}),define(Pe[161],Re([9,10]),function(ee,e){return ee.create("vs/platform/theme/common/iconRegistry",e)}),define(Pe[162],Re([9,10]),function(ee,e){return ee.create("vs/platform/workspace/common/workspace",e)}),define(Pe[163],Re([9,10]),function(ee,e){return ee.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(Pe[164],Re([9,10]),function(ee,e){return ee.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Pe[165],Re([9,10]),function(ee,e){return ee.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Pe[166],Re([9,10]),function(ee,e){return ee.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Pe[167],Re([9,10]),function(ee,e){return ee.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(Pe[168],Re([9,10]),function(ee,e){return ee.create("vs/workbench/api/common/extHostLogService",e)}),define(Pe[169],Re([9,10]),function(ee,e){return ee.create("vs/workbench/api/common/extHostNotebook",e)}),define(Pe[170],Re([9,10]),function(ee,e){return ee.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Pe[171],Re([9,10]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Pe[172],Re([9,10]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Pe[173],Re([9,10]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Pe[174],Re([9,10]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Pe[175],Re([9,10]),function(ee,e){return ee.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Pe[176],Re([9,10]),function(ee,e){return ee.create("vs/workbench/common/configuration",e)}),define(Pe[177],Re([9,10]),function(ee,e){return ee.create("vs/workbench/common/editor",e)}),define(Pe[178],Re([9,10]),function(ee,e){return ee.create("vs/workbench/common/views",e)}),define(Pe[179],Re([9,10]),function(ee,e){return ee.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Pe[180],Re([9,10]),function(ee,e){return ee.create("vs/workbench/contrib/debug/common/debug",e)}),define(Pe[181],Re([9,10]),function(ee,e){return ee.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Pe[182],Re([9,10]),function(ee,e){return ee.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Pe[183],Re([9,10]),function(ee,e){return ee.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Pe[184],Re([9,10]),function(ee,e){return ee.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Pe[185],Re([9,10]),function(ee,e){return ee.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Pe[186],Re([9,10]),function(ee,e){return ee.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Pe[187],Re([1,0,14,155]),function(ee,e,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dj=e.TokenType=void 0;var C;(function(y){y[y.LParen=0]="LParen",y[y.RParen=1]="RParen",y[y.Neg=2]="Neg",y[y.Eq=3]="Eq",y[y.NotEq=4]="NotEq",y[y.Lt=5]="Lt",y[y.LtEq=6]="LtEq",y[y.Gt=7]="Gt",y[y.GtEq=8]="GtEq",y[y.RegexOp=9]="RegexOp",y[y.RegexStr=10]="RegexStr",y[y.True=11]="True",y[y.False=12]="False",y[y.In=13]="In",y[y.Not=14]="Not",y[y.And=15]="And",y[y.Or=16]="Or",y[y.Str=17]="Str",y[y.QuotedStr=18]="QuotedStr",y[y.Error=19]="Error",y[y.EOF=20]="EOF"})(C||(e.TokenType=C={}));function N(...y){switch(y.length){case 1:return(0,M.localize)(0,null,y[0]);case 2:return(0,M.localize)(1,null,y[0],y[1]);case 3:return(0,M.localize)(2,null,y[0],y[1],y[2]);default:return}}const A=(0,M.localize)(3,null),m=(0,M.localize)(4,null);class d{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(O){switch(O.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return O.isTripleEq?"===":"==";case 4:return O.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return O.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return O.lexeme;case 18:return O.lexeme;case 19:return O.lexeme;case 20:return"EOF";default:throw(0,k.$8)(`unhandled token type: ${JSON.stringify(O)}; have you forgotten to add a case?`)}}get errors(){return this.g}reset(O){return this.c=O,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const D=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:D})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const D=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:D})}else this.h(126)?this.k(9):this.l(N("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(N("&&"));break;case 124:this.h(124)?this.k(16):this.l(N("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(O){return this.r()||this.c.charCodeAt(this.e)!==O?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(O){this.f.push({type:O,offset:this.d})}l(O){const D=this.d,l=this.c.substring(this.d,this.e),b={type:19,offset:this.d,lexeme:l};this.g.push({offset:D,lexeme:l,additionalInfo:O}),this.f.push(b)}n(){this.m.lastIndex=this.d;const O=this.m.exec(this.c);if(O){this.e=this.d+O[0].length;const D=this.c.substring(this.d,this.e),l=d.b.get(D);l?this.k(l):this.f.push({type:17,lexeme:D,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let O=this.e,D=!1,l=!1;for(;;){if(O>=this.c.length){this.e=O,this.l(m);return}const $=this.c.charCodeAt(O);if(D)D=!1;else if($===47&&!l){O++;break}else $===91?l=!0:$===92?D=!0:$===93&&(l=!1);O++}for(;O<this.c.length&&d.a.has(this.c.charCodeAt(O));)O++;this.e=O;const b=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:b,offset:this.d})}r(){return this.e>=this.c.length}}e.$dj=d,d.a=new Set(["i","g","s","m","y","u"].map(y=>y.charCodeAt(0))),d.b=new Map([["not",14],["in",13],["false",12],["true",11]])}),define(Pe[188],Re([1,0,23,32,157,301]),function(ee,e,k,M,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tp=d,e.$up=y,e.$vp=O,e.$wp=D,e.$xp=l,e.$yp=b,e.$zp=$;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,m=/^-(\d{4})(\d{2})(\d{2})$/;function d(s){return s=s.trim(),s==="*"||A.test(s)}function y(s){if(!d(s))return null;if(s=s.trim(),s==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const r=s.match(A);return r?{hasCaret:r[1]==="^",hasGreaterEquals:r[1]===">=",majorBase:r[2]==="x"?0:parseInt(r[2],10),majorMustEqual:r[2]!=="x",minorBase:r[4]==="x"?0:parseInt(r[4],10),minorMustEqual:r[4]!=="x",patchBase:r[6]==="x"?0:parseInt(r[6],10),patchMustEqual:r[6]!=="x",preRelease:r[8]||null}:null}function O(s){if(!s)return null;const r=s.majorBase,i=s.majorMustEqual,c=s.minorBase;let h=s.minorMustEqual;const t=s.patchBase;let p=s.patchMustEqual;s.hasCaret&&(r===0||(h=!1),p=!1);let a=0;if(s.preRelease){const g=m.exec(s.preRelease);if(g){const[,v,f,u]=g;a=Date.UTC(Number(v),Number(f)-1,Number(u))}}return{majorBase:r,majorMustEqual:i,minorBase:c,minorMustEqual:h,patchBase:t,patchMustEqual:p,isMinimum:s.hasGreaterEquals,notBefore:a}}function D(s,r,i){let c;typeof s=="string"?c=O(y(s)):c=s;let h;r instanceof Date?h=r.getTime():typeof r=="string"&&(h=new Date(r).getTime());let t;if(typeof i=="string"?t=O(y(i)):t=i,!c||!t)return!1;const p=c.majorBase,a=c.minorBase,g=c.patchBase;let v=t.majorBase,f=t.minorBase,u=t.patchBase;const E=t.notBefore;let w=t.majorMustEqual,I=t.minorMustEqual,S=t.patchMustEqual;return t.isMinimum?p>v?!0:p<v?!1:a>f?!0:a<f||h&&h<E?!1:g>=u:(p===1&&v===0&&(!w||!I||!S)&&(v=1,f=0,u=0,w=!0,I=!1,S=!1),p<v?!1:p>v?!w:a<f?!1:a>f?!I:g<u?!1:g>u?!S:!(h&&h<E))}function l(s,r,i,c,h){const t=[];if(typeof c.publisher<"u"&&typeof c.publisher!="string")return t.push([M.default.Error,C.localize(0,null)]),t;if(typeof c.name!="string")return t.push([M.default.Error,C.localize(1,null,"name")]),t;if(typeof c.version!="string")return t.push([M.default.Error,C.localize(2,null,"version")]),t;if(!c.engines)return t.push([M.default.Error,C.localize(3,null,"engines")]),t;if(typeof c.engines.vscode!="string")return t.push([M.default.Error,C.localize(4,null,"engines.vscode")]),t;if(typeof c.extensionDependencies<"u"&&!o(c.extensionDependencies))return t.push([M.default.Error,C.localize(5,null,"extensionDependencies")]),t;if(typeof c.activationEvents<"u"){if(!o(c.activationEvents))return t.push([M.default.Error,C.localize(6,null,"activationEvents")]),t;if(typeof c.main>"u"&&typeof c.browser>"u")return t.push([M.default.Error,C.localize(7,null,"activationEvents","main","browser")]),t}if(typeof c.extensionKind<"u"&&typeof c.main>"u"&&t.push([M.default.Warning,C.localize(8,null,"extensionKind")]),typeof c.main<"u"){if(typeof c.main!="string")return t.push([M.default.Error,C.localize(9,null,"main")]),t;{const g=(0,k.$Vg)(i,c.main);(0,k.$Pg)(g,i)||t.push([M.default.Warning,C.localize(10,null,g.path,i.path)])}}if(typeof c.browser<"u"){if(typeof c.browser!="string")return t.push([M.default.Error,C.localize(11,null,"browser")]),t;{const g=(0,k.$Vg)(i,c.browser);(0,k.$Pg)(g,i)||t.push([M.default.Warning,C.localize(12,null,g.path,i.path)])}}if(!N.valid(c.version))return t.push([M.default.Error,C.localize(13,null)]),t;const p=[];if(!b(s,r,c,h,p))for(const g of p)t.push([M.default.Error,g]);return t}function b(s,r,i,c,h){return c||typeof i.main>"u"&&typeof i.browser>"u"?!0:n(s,r,i.engines.vscode,h)}function $(s,r,i){return s==="*"||n(r,i,s)}function n(s,r,i,c=[]){const h=O(y(i));if(!h)return c.push(C.localize(14,null,i)),!1;if(h.majorBase===0){if(!h.majorMustEqual||!h.minorMustEqual)return c.push(C.localize(15,null,i)),!1}else if(!h.majorMustEqual)return c.push(C.localize(16,null,i)),!1;return D(s,r,h)?!0:(c.push(C.localize(17,null,s,i)),!1)}function o(s){if(!Array.isArray(s))return!1;for(let r=0,i=s.length;r<i;r++)if(typeof s[r]!="string")return!1;return!0}}),define(Pe[70],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=void 0;class k{constructor(C,N=[],A=!1){this.ctor=C,this.staticArguments=N,this.supportsDelayedInstantiation=A}}e.$fi=k}),define(Pe[55],Re([1,0,70]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$hs=N,e.$is=A;const M=[];var C;(function(m){m[m.Eager=0]="Eager",m[m.Delayed=1]="Delayed"})(C||(e.InstantiationType=C={}));function N(m,d,y){d instanceof k.$fi||(d=new k.$fi(d,[],!!y)),M.push([m,d])}function A(){return M}}),define(Pe[189],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yq=e.$Xq=void 0;class k{constructor(N,A){this.key=N,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$Xq=k;class M{constructor(N){this.b=N,this.a=new Map}roots(){const N=[];for(const A of this.a.values())A.outgoing.size===0&&N.push(A);return N}insertEdge(N,A){const m=this.lookupOrInsertNode(N),d=this.lookupOrInsertNode(A);m.outgoing.set(d.key,d),d.incoming.set(m.key,m)}removeNode(N){const A=this.b(N);this.a.delete(A);for(const m of this.a.values())m.outgoing.delete(A),m.incoming.delete(A)}lookupOrInsertNode(N){const A=this.b(N);let m=this.a.get(A);return m||(m=new k(A,N),this.a.set(A,m)),m}lookup(N){return this.a.get(this.b(N))}isEmpty(){return this.a.size===0}toString(){const N=[];for(const[A,m]of this.a)N.push(`${A}
	(-> incoming)[${[...m.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...m.outgoing.keys()].join(",")}]
`);return N.join(`
`)}findCycleSlow(){for(const[N,A]of this.a){const m=new Set([N]),d=this.c(A,m);if(d)return d}}c(N,A){for(const[m,d]of N.outgoing){if(A.has(m))return[...A,m].join(" -> ");A.add(m);const y=this.c(d,A);if(y)return y;A.delete(m)}}}e.$Yq=M}),define(Pe[3],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hi=e._util=void 0,e.$ii=C,e.$ji=N;var k;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function m(d){return d[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=m})(k||(e._util=k={})),e.$hi=C("instantiationService");function M(A,m,d){m[k.DI_TARGET]===m?m[k.DI_DEPENDENCIES].push({id:A,index:d}):(m[k.DI_DEPENDENCIES]=[{id:A,index:d}],m[k.DI_TARGET]=m)}function C(A){if(k.serviceIds.has(A))return k.serviceIds.get(A);const m=function(d,y,O){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");M(m,d,O)};return m.toString=()=>A,k.serviceIds.set(A,m),m}function N(A){return A}}),define(Pe[47],Re([1,0,17,2,3]),function(ee,e,k,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$Oi=void 0,e.$Pi=N,e.$Qi=A,e.$Ri=d,e.$Si=y,e.$Ti=O,e.$Ui=D,e.$Vi=l,e.$Wi=$,e.$Xi=n,e.$Yi=o,e.$Oi=(0,C.$ii)("configurationService");function N(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof M.URI)}function A(s){return s&&typeof s=="object"&&(!s.overrideIdentifiers||Array.isArray(s.overrideIdentifiers))&&!s.overrideIdentifier&&(!s.resource||s.resource instanceof M.URI)}var m;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.USER=2]="USER",s[s.USER_LOCAL=3]="USER_LOCAL",s[s.USER_REMOTE=4]="USER_REMOTE",s[s.WORKSPACE=5]="WORKSPACE",s[s.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",s[s.DEFAULT=7]="DEFAULT",s[s.MEMORY=8]="MEMORY"})(m||(e.ConfigurationTarget=m={}));function d(s){switch(s){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function y(s){return s.applicationValue!==void 0||s.userValue!==void 0||s.userLocalValue!==void 0||s.userRemoteValue!==void 0||s.workspaceValue!==void 0||s.workspaceFolderValue!==void 0}function O(s,r){const i=Object.create(null);for(const c in s)D(i,c,s[c],r);return i}function D(s,r,i,c){const h=r.split("."),t=h.pop();let p=s;for(let a=0;a<h.length;a++){const g=h[a];let v=p[g];switch(typeof v){case"undefined":v=p[g]=Object.create(null);break;case"object":break;default:c(`Ignoring ${r} as ${h.slice(0,a+1).join(".")} is ${JSON.stringify(v)}`);return}p=v}if(typeof p=="object"&&p!==null)try{p[t]=i}catch{c(`Ignoring ${r} as ${h.join(".")} is ${JSON.stringify(p)}`)}else c(`Ignoring ${r} as ${h.join(".")} is ${JSON.stringify(p)}`)}function l(s,r){const i=r.split(".");b(s,i)}function b(s,r){const i=r.shift();if(r.length===0){delete s[i];return}if(Object.keys(s).indexOf(i)!==-1){const c=s[i];typeof c=="object"&&!Array.isArray(c)&&(b(c,r),Object.keys(c).length===0&&delete s[i])}}function $(s,r,i){function c(p,a){let g=p;for(const v of a){if(typeof g!="object"||g===null)return;g=g[v]}return g}const h=r.split("."),t=c(s,h);return typeof t>"u"?i:t}function n(s,r,i){Object.keys(r).forEach(c=>{c!=="__proto__"&&(c in s?k.$Xf(s[c])&&k.$Xf(r[c])?n(s[c],r[c],i):i&&(s[c]=r[c]):s[c]=r[c])})}function o(s){return s.replace(/[\[\]]/g,"")}}),define(Pe[33],Re([1,0,21,15,187,3,154,14]),function(ee,e,k,M,C,N,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$gj=e.$fj=e.ContextKeyExprType=void 0,e.$ej=y,e.$hj=p,e.$ij=a,e.$Bj=se;const d=new Map;d.set("false",!1),d.set("true",!0),d.set("isMac",k.$d),d.set("isLinux",k.$e),d.set("isWindows",k.$c),d.set("isWeb",k.$i),d.set("isMacNative",k.$d&&!k.$i),d.set("isEdge",k.$B),d.set("isFirefox",k.$z),d.set("isChrome",k.$y),d.set("isSafari",k.$A);function y(ie,q){if(d.get(ie)!==void 0)throw(0,m.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");d.set(ie,q)}const O=Object.prototype.hasOwnProperty;var D;(function(ie){ie[ie.False=0]="False",ie[ie.True=1]="True",ie[ie.Defined=2]="Defined",ie[ie.Not=3]="Not",ie[ie.Equals=4]="Equals",ie[ie.NotEquals=5]="NotEquals",ie[ie.And=6]="And",ie[ie.Regex=7]="Regex",ie[ie.NotRegex=8]="NotRegex",ie[ie.Or=9]="Or",ie[ie.In=10]="In",ie[ie.NotIn=11]="NotIn",ie[ie.Greater=12]="Greater",ie[ie.GreaterEquals=13]="GreaterEquals",ie[ie.Smaller=14]="Smaller",ie[ie.SmallerEquals=15]="SmallerEquals"})(D||(e.ContextKeyExprType=D={}));const l={regexParsingWithErrorRecovery:!0},b=(0,A.localize)(0,null),$=(0,A.localize)(1,null),n=(0,A.localize)(2,null),o=(0,A.localize)(3,null),s=(0,A.localize)(4,null),r=(0,A.localize)(5,null),i=(0,A.localize)(6,null),c=(0,A.localize)(7,null);class h{get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(q=l){this.k=q,this.d=new C.$dj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(q){if(q===""){this.h.push({message:b,offset:0,lexeme:"",additionalInfo:$});return}this.f=this.d.reset(q).scan(),this.g=0,this.h=[];try{const de=this.l();if(!this.E()){const Ne=this.D(),$e=Ne.type===17?r:void 0;throw this.h.push({message:s,offset:Ne.offset,lexeme:C.$dj.getLexeme(Ne),additionalInfo:$e}),h.c}return de}catch(de){if(de!==h.c)throw de;return}}l(){return this.m()}m(){const q=[this.o()];for(;this.y(16);){const de=this.o();q.push(de)}return q.length===1?q[0]:t.or(...q)}o(){const q=[this.s()];for(;this.y(15);){const de=this.s();q.push(de)}return q.length===1?q[0]:t.and(...q)}s(){if(this.y(2)){const q=this.D();switch(q.type){case 11:return this.z(),v.INSTANCE;case 12:return this.z(),f.INSTANCE;case 0:{this.z();const de=this.l();return this.A(1,o),de?.negate()}case 17:return this.z(),P.create(q.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",q)}}return this.t()}t(){const q=this.D();switch(q.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const de=this.l();return this.A(1,o),de}case 17:{const de=q.lexeme;if(this.z(),this.y(9)){const $e=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),$e.type!==10)throw this.B("REGEX",$e);const we=$e.lexeme,ge=we.lastIndexOf("/"),ce=ge===we.length-1?void 0:this.w(we.substring(ge+1));let K;try{K=new RegExp(we.substring(1,ge),ce)}catch{throw this.B("REGEX",$e)}return F.create(de,K)}switch($e.type){case 10:case 19:{const we=[$e.lexeme];this.z();let ge=this.D(),ce=0;for(let Te=0;Te<$e.lexeme.length;Te++)$e.lexeme.charCodeAt(Te)===40?ce++:$e.lexeme.charCodeAt(Te)===41&&ce--;for(;!this.E()&&ge.type!==15&&ge.type!==16;){switch(ge.type){case 0:ce++;break;case 1:ce--;break;case 10:case 18:for(let Te=0;Te<ge.lexeme.length;Te++)ge.lexeme.charCodeAt(Te)===40?ce++:$e.lexeme.charCodeAt(Te)===41&&ce--}if(ce<0)break;we.push(C.$dj.getLexeme(ge)),this.z(),ge=this.D()}const K=we.join(""),Z=K.lastIndexOf("/"),le=Z===K.length-1?void 0:this.w(K.substring(Z+1));let fe;try{fe=new RegExp(K.substring(1,Z),le)}catch{throw this.B("REGEX",$e)}return t.regex(de,fe)}case 18:{const we=$e.lexeme;this.z();let ge=null;if(!(0,M.$Ue)(we)){const ce=we.indexOf("/"),K=we.lastIndexOf("/");if(ce!==K&&ce>=0){const Z=we.slice(ce+1,K),le=we[K+1]==="i"?"i":"";try{ge=new RegExp(Z,le)}catch{throw this.B("REGEX",$e)}}}if(ge===null)throw this.B("REGEX",$e);return F.create(de,ge)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,n);const $e=this.u();return t.notIn(de,$e)}switch(this.D().type){case 3:{this.z();const $e=this.u();if(this.x().type===18)return t.equals(de,$e);switch($e){case"true":return t.has(de);case"false":return t.not(de);default:return t.equals(de,$e)}}case 4:{this.z();const $e=this.u();if(this.x().type===18)return t.notEquals(de,$e);switch($e){case"true":return t.not(de);case"false":return t.has(de);default:return t.notEquals(de,$e)}}case 5:return this.z(),L.create(de,this.u());case 6:return this.z(),R.create(de,this.u());case 7:return this.z(),Q.create(de,this.u());case 8:return this.z(),H.create(de,this.u());case 13:return this.z(),t.in(de,this.u());default:return t.has(de)}}case 20:throw this.h.push({message:i,offset:q.offset,lexeme:"",additionalInfo:c}),h.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const q=this.D();switch(q.type){case 17:case 18:return this.z(),q.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(q){return q.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(q){return this.C(q)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(q,de){if(this.C(q))return this.z();throw this.B(de,this.D())}B(q,de,Ne){const $e=(0,A.localize)(8,null,q,C.$dj.getLexeme(de)),we=de.offset,ge=C.$dj.getLexeme(de);return this.h.push({message:$e,offset:we,lexeme:ge,additionalInfo:Ne}),h.c}C(q){return this.D().type===q}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$fj=h,h.c=new Error;class t{static false(){return v.INSTANCE}static true(){return f.INSTANCE}static has(q){return u.create(q)}static equals(q,de){return E.create(q,de)}static notEquals(q,de){return S.create(q,de)}static regex(q,de){return F.create(q,de)}static in(q,de){return w.create(q,de)}static notIn(q,de){return I.create(q,de)}static not(q){return P.create(q)}static and(...q){return re.create(q,null,!0)}static or(...q){return me.create(q,null,!0)}static greater(q,de){return Q.create(q,de)}static greaterEquals(q,de){return H.create(q,de)}static smaller(q,de){return L.create(q,de)}static smallerEquals(q,de){return R.create(q,de)}static deserialize(q){return q==null?void 0:this.c.parse(q)}}e.$gj=t,t.c=new h({regexParsingWithErrorRecovery:!1});function p(ie){const q=new h({regexParsingWithErrorRecovery:!1});return ie.map(de=>(q.parse(de),q.lexingErrors.length>0?q.lexingErrors.map(Ne=>({errorMessage:Ne.additionalInfo?(0,A.localize)(9,null,Ne.additionalInfo):(0,A.localize)(10,null),offset:Ne.offset,length:Ne.lexeme.length})):q.parsingErrors.length>0?q.parsingErrors.map(Ne=>({errorMessage:Ne.additionalInfo?`${Ne.message}. ${Ne.additionalInfo}`:Ne.message,offset:Ne.offset,length:Ne.lexeme.length})):[]))}function a(ie,q){const de=ie?ie.substituteConstants():void 0,Ne=q?q.substituteConstants():void 0;return!de&&!Ne?!0:!de||!Ne?!1:de.equals(Ne)}function g(ie,q){return ie.cmp(q)}class v{constructor(){this.type=0}cmp(q){return this.type-q.type}equals(q){return q.type===this.type}substituteConstants(){return this}evaluate(q){return!1}serialize(){return"false"}keys(){return[]}map(q){return this}negate(){return f.INSTANCE}}e.$jj=v,v.INSTANCE=new v;class f{constructor(){this.type=1}cmp(q){return this.type-q.type}equals(q){return q.type===this.type}substituteConstants(){return this}evaluate(q){return!0}serialize(){return"true"}keys(){return[]}map(q){return this}negate(){return v.INSTANCE}}e.$kj=f,f.INSTANCE=new f;class u{static create(q,de=null){const Ne=d.get(q);return typeof Ne=="boolean"?Ne?f.INSTANCE:v.INSTANCE:new u(q,de)}constructor(q,de){this.key=q,this.c=de,this.type=2}cmp(q){return q.type!==this.type?this.type-q.type:ae(this.key,q.key)}equals(q){return q.type===this.type?this.key===q.key:!1}substituteConstants(){const q=d.get(this.key);return typeof q=="boolean"?q?f.INSTANCE:v.INSTANCE:this}evaluate(q){return!!q.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(q){return q.mapDefined(this.key)}negate(){return this.c||(this.c=P.create(this.key,this)),this.c}}e.$lj=u;class E{static create(q,de,Ne=null){if(typeof de=="boolean")return de?u.create(q,Ne):P.create(q,Ne);const $e=d.get(q);return typeof $e=="boolean"?de===($e?"true":"false")?f.INSTANCE:v.INSTANCE:new E(q,de,Ne)}constructor(q,de,Ne){this.c=q,this.d=de,this.f=Ne,this.type=4}cmp(q){return q.type!==this.type?this.type-q.type:be(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){const q=d.get(this.c);if(typeof q=="boolean"){const de=q?"true":"false";return this.d===de?f.INSTANCE:v.INSTANCE}return this}evaluate(q){return q.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(q){return q.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=S.create(this.c,this.d,this)),this.f}}e.$mj=E;class w{static create(q,de){return new w(q,de)}constructor(q,de){this.d=q,this.f=de,this.type=10,this.c=null}cmp(q){return q.type!==this.type?this.type-q.type:be(this.d,this.f,q.d,q.f)}equals(q){return q.type===this.type?this.d===q.d&&this.f===q.f:!1}substituteConstants(){return this}evaluate(q){const de=q.getValue(this.f),Ne=q.getValue(this.d);return Array.isArray(de)?de.includes(Ne):typeof Ne=="string"&&typeof de=="object"&&de!==null?O.call(de,Ne):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(q){return q.mapIn(this.d,this.f)}negate(){return this.c||(this.c=I.create(this.d,this.f)),this.c}}e.$nj=w;class I{static create(q,de){return new I(q,de)}constructor(q,de){this.d=q,this.f=de,this.type=11,this.c=w.create(q,de)}cmp(q){return q.type!==this.type?this.type-q.type:this.c.cmp(q.c)}equals(q){return q.type===this.type?this.c.equals(q.c):!1}substituteConstants(){return this}evaluate(q){return!this.c.evaluate(q)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(q){return q.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$oj=I;class S{static create(q,de,Ne=null){if(typeof de=="boolean")return de?P.create(q,Ne):u.create(q,Ne);const $e=d.get(q);return typeof $e=="boolean"?de===($e?"true":"false")?v.INSTANCE:f.INSTANCE:new S(q,de,Ne)}constructor(q,de,Ne){this.c=q,this.d=de,this.f=Ne,this.type=5}cmp(q){return q.type!==this.type?this.type-q.type:be(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){const q=d.get(this.c);if(typeof q=="boolean"){const de=q?"true":"false";return this.d===de?v.INSTANCE:f.INSTANCE}return this}evaluate(q){return q.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(q){return q.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=E.create(this.c,this.d,this)),this.f}}e.$pj=S;class P{static create(q,de=null){const Ne=d.get(q);return typeof Ne=="boolean"?Ne?v.INSTANCE:f.INSTANCE:new P(q,de)}constructor(q,de){this.c=q,this.d=de,this.type=3}cmp(q){return q.type!==this.type?this.type-q.type:ae(this.c,q.c)}equals(q){return q.type===this.type?this.c===q.c:!1}substituteConstants(){const q=d.get(this.c);return typeof q=="boolean"?q?v.INSTANCE:f.INSTANCE:this}evaluate(q){return!q.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(q){return q.mapNot(this.c)}negate(){return this.d||(this.d=u.create(this.c,this)),this.d}}e.$qj=P;function U(ie,q){if(typeof ie=="string"){const de=parseFloat(ie);isNaN(de)||(ie=de)}return typeof ie=="string"||typeof ie=="number"?q(ie):v.INSTANCE}class Q{static create(q,de,Ne=null){return U(de,$e=>new Q(q,$e,Ne))}constructor(q,de,Ne){this.c=q,this.d=de,this.f=Ne,this.type=12}cmp(q){return q.type!==this.type?this.type-q.type:be(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){return this}evaluate(q){return typeof this.d=="string"?!1:parseFloat(q.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(q){return q.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=R.create(this.c,this.d,this)),this.f}}e.$rj=Q;class H{static create(q,de,Ne=null){return U(de,$e=>new H(q,$e,Ne))}constructor(q,de,Ne){this.c=q,this.d=de,this.f=Ne,this.type=13}cmp(q){return q.type!==this.type?this.type-q.type:be(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){return this}evaluate(q){return typeof this.d=="string"?!1:parseFloat(q.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(q){return q.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=L.create(this.c,this.d,this)),this.f}}e.$sj=H;class L{static create(q,de,Ne=null){return U(de,$e=>new L(q,$e,Ne))}constructor(q,de,Ne){this.c=q,this.d=de,this.f=Ne,this.type=14}cmp(q){return q.type!==this.type?this.type-q.type:be(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){return this}evaluate(q){return typeof this.d=="string"?!1:parseFloat(q.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(q){return q.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=H.create(this.c,this.d,this)),this.f}}e.$tj=L;class R{static create(q,de,Ne=null){return U(de,$e=>new R(q,$e,Ne))}constructor(q,de,Ne){this.c=q,this.d=de,this.f=Ne,this.type=15}cmp(q){return q.type!==this.type?this.type-q.type:be(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){return this}evaluate(q){return typeof this.d=="string"?!1:parseFloat(q.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(q){return q.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=Q.create(this.c,this.d,this)),this.f}}e.$uj=R;class F{static create(q,de){return new F(q,de)}constructor(q,de){this.d=q,this.f=de,this.type=7,this.c=null}cmp(q){if(q.type!==this.type)return this.type-q.type;if(this.d<q.d)return-1;if(this.d>q.d)return 1;const de=this.f?this.f.source:"",Ne=q.f?q.f.source:"";return de<Ne?-1:de>Ne?1:0}equals(q){if(q.type===this.type){const de=this.f?this.f.source:"",Ne=q.f?q.f.source:"";return this.d===q.d&&de===Ne}return!1}substituteConstants(){return this}evaluate(q){const de=q.getValue(this.d);return this.f?this.f.test(de):!1}serialize(){const q=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${q}`}keys(){return[this.d]}map(q){return q.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=T.create(this)),this.c}}e.$vj=F;class T{static create(q){return new T(q)}constructor(q){this.c=q,this.type=8}cmp(q){return q.type!==this.type?this.type-q.type:this.c.cmp(q.c)}equals(q){return q.type===this.type?this.c.equals(q.c):!1}substituteConstants(){return this}evaluate(q){return!this.c.evaluate(q)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(q){return new T(this.c.map(q))}negate(){return this.c}}e.$wj=T;function X(ie){let q=null;for(let de=0,Ne=ie.length;de<Ne;de++){const $e=ie[de].substituteConstants();if(ie[de]!==$e&&q===null){q=[];for(let we=0;we<de;we++)q[we]=ie[we]}q!==null&&(q[de]=$e)}return q===null?ie:q}class re{static create(q,de,Ne){return re.d(q,de,Ne)}constructor(q,de){this.expr=q,this.c=de,this.type=6}cmp(q){if(q.type!==this.type)return this.type-q.type;if(this.expr.length<q.expr.length)return-1;if(this.expr.length>q.expr.length)return 1;for(let de=0,Ne=this.expr.length;de<Ne;de++){const $e=g(this.expr[de],q.expr[de]);if($e!==0)return $e}return 0}equals(q){if(q.type===this.type){if(this.expr.length!==q.expr.length)return!1;for(let de=0,Ne=this.expr.length;de<Ne;de++)if(!this.expr[de].equals(q.expr[de]))return!1;return!0}return!1}substituteConstants(){const q=X(this.expr);return q===this.expr?this:re.create(q,this.c,!1)}evaluate(q){for(let de=0,Ne=this.expr.length;de<Ne;de++)if(!this.expr[de].evaluate(q))return!1;return!0}static d(q,de,Ne){const $e=[];let we=!1;for(const ge of q)if(ge){if(ge.type===1){we=!0;continue}if(ge.type===0)return v.INSTANCE;if(ge.type===6){$e.push(...ge.expr);continue}$e.push(ge)}if($e.length===0&&we)return f.INSTANCE;if($e.length!==0){if($e.length===1)return $e[0];$e.sort(g);for(let ge=1;ge<$e.length;ge++)$e[ge-1].equals($e[ge])&&($e.splice(ge,1),ge--);if($e.length===1)return $e[0];for(;$e.length>1;){const ge=$e[$e.length-1];if(ge.type!==9)break;$e.pop();const ce=$e.pop(),K=$e.length===0,Z=me.create(ge.expr.map(le=>re.create([le,ce],null,Ne)),null,K);Z&&($e.push(Z),$e.sort(g))}if($e.length===1)return $e[0];if(Ne){for(let ge=0;ge<$e.length;ge++)for(let ce=ge+1;ce<$e.length;ce++)if($e[ge].negate().equals($e[ce]))return v.INSTANCE;if($e.length===1)return $e[0]}return new re($e,de)}}serialize(){return this.expr.map(q=>q.serialize()).join(" && ")}keys(){const q=[];for(const de of this.expr)q.push(...de.keys());return q}map(q){return new re(this.expr.map(de=>de.map(q)),null)}negate(){if(!this.c){const q=[];for(const de of this.expr)q.push(de.negate());this.c=me.create(q,this,!0)}return this.c}}e.$xj=re;class me{static create(q,de,Ne){return me.d(q,de,Ne)}constructor(q,de){this.expr=q,this.c=de,this.type=9}cmp(q){if(q.type!==this.type)return this.type-q.type;if(this.expr.length<q.expr.length)return-1;if(this.expr.length>q.expr.length)return 1;for(let de=0,Ne=this.expr.length;de<Ne;de++){const $e=g(this.expr[de],q.expr[de]);if($e!==0)return $e}return 0}equals(q){if(q.type===this.type){if(this.expr.length!==q.expr.length)return!1;for(let de=0,Ne=this.expr.length;de<Ne;de++)if(!this.expr[de].equals(q.expr[de]))return!1;return!0}return!1}substituteConstants(){const q=X(this.expr);return q===this.expr?this:me.create(q,this.c,!1)}evaluate(q){for(let de=0,Ne=this.expr.length;de<Ne;de++)if(this.expr[de].evaluate(q))return!0;return!1}static d(q,de,Ne){let $e=[],we=!1;if(q){for(let ge=0,ce=q.length;ge<ce;ge++){const K=q[ge];if(K){if(K.type===0){we=!0;continue}if(K.type===1)return f.INSTANCE;if(K.type===9){$e=$e.concat(K.expr);continue}$e.push(K)}}if($e.length===0&&we)return v.INSTANCE;$e.sort(g)}if($e.length!==0){if($e.length===1)return $e[0];for(let ge=1;ge<$e.length;ge++)$e[ge-1].equals($e[ge])&&($e.splice(ge,1),ge--);if($e.length===1)return $e[0];if(Ne){for(let ge=0;ge<$e.length;ge++)for(let ce=ge+1;ce<$e.length;ce++)if($e[ge].negate().equals($e[ce]))return f.INSTANCE;if($e.length===1)return $e[0]}return new me($e,de)}}serialize(){return this.expr.map(q=>q.serialize()).join(" || ")}keys(){const q=[];for(const de of this.expr)q.push(...de.keys());return q}map(q){return new me(this.expr.map(de=>de.map(q)),null)}negate(){if(!this.c){const q=[];for(const de of this.expr)q.push(de.negate());for(;q.length>1;){const de=q.shift(),Ne=q.shift(),$e=[];for(const we of Oe(de))for(const ge of Oe(Ne))$e.push(re.create([we,ge],null,!1));q.unshift(me.create($e,null,!1))}this.c=me.create(q,this,!0)}return this.c}}e.$yj=me;class pe extends u{static all(){return pe.d.values()}constructor(q,de,Ne){super(q,null),this.f=de,typeof Ne=="object"?pe.d.push({...Ne,key:q}):Ne!==!0&&pe.d.push({key:q,description:Ne,type:de!=null?typeof de:void 0})}bindTo(q){return q.createKey(this.key,this.f)}getValue(q){return q.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(q){return E.create(this.key,q)}notEqualsTo(q){return S.create(this.key,q)}}e.$zj=pe,pe.d=[],e.$Aj=(0,N.$ii)("contextKeyService");function ae(ie,q){return ie<q?-1:ie>q?1:0}function be(ie,q,de,Ne){return ie<de?-1:ie>de?1:q<Ne?-1:q>Ne?1:0}function se(ie,q){if(ie.type===0||q.type===1)return!0;if(ie.type===9)return q.type===9?De(ie.expr,q.expr):!1;if(q.type===9){for(const de of q.expr)if(se(ie,de))return!0;return!1}if(ie.type===6){if(q.type===6)return De(q.expr,ie.expr);for(const de of ie.expr)if(se(de,q))return!0;return!1}return ie.equals(q)}function De(ie,q){let de=0,Ne=0;for(;de<ie.length&&Ne<q.length;){const $e=ie[de].cmp(q[Ne]);if($e<0)return!1;$e===0&&de++,Ne++}return de===ie.length}function Oe(ie){return ie.type===9?ie.expr:[ie]}}),define(Pe[190],Re([1,0,3]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qi=e.$pi=void 0,e.$pi=(0,k.$ii)("environmentService"),e.$qi=(0,k.$ji)(e.$pi)}),define(Pe[98],Re([1,0,156,3]),function(ee,e,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2o=e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.ExtensionGalleryErrorCode=e.$To=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$So=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=void 0,e.$Mo=C,e.$No=N,e.$Oo=A,e.$Po=m,e.$Qo=d,e.$Ro=y,e.$Go="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Ho=new RegExp(e.$Go),e.$Io="__web_extension",e.$Jo="skipWalkthrough",e.$Ko="extensionsSync",e.$Lo="dependecyOrPackExtensionInstall";function C(i){switch(i){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function N(i){switch(i){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function A(i,c){switch(i){case 3:return c==="x64"?"win32-x64":c==="arm64"?"win32-arm64":"unknown";case 2:return c==="x64"?"linux-x64":c==="arm64"?"linux-arm64":c==="arm"?"linux-armhf":"unknown";case"alpine":return c==="x64"?"alpine-x64":c==="arm64"?"alpine-arm64":"unknown";case 1:return c==="x64"?"darwin-x64":c==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function m(i,c){return c==="web"&&!i.includes("web")}function d(i,c,h){return m(c,h)?!1:i==="undefined"||i==="universal"?!0:i==="unknown"?!1:i===h}function y(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}var O;(function(i){i[i.NoneOrRelevance=0]="NoneOrRelevance",i[i.LastUpdatedDate=1]="LastUpdatedDate",i[i.Title=2]="Title",i[i.PublisherName=3]="PublisherName",i[i.InstallCount=4]="InstallCount",i[i.PublishedDate=10]="PublishedDate",i[i.AverageRating=6]="AverageRating",i[i.WeightedRating=12]="WeightedRating"})(O||(e.SortBy=O={}));var D;(function(i){i[i.Default=0]="Default",i[i.Ascending=1]="Ascending",i[i.Descending=2]="Descending"})(D||(e.SortOrder=D={}));var l;(function(i){i.Install="install",i.Uninstall="uninstall"})(l||(e.StatisticType=l={}));var b;(function(i){i[i.None=1]="None",i[i.Install=2]="Install",i[i.Update=3]="Update",i[i.Migrate=4]="Migrate"})(b||(e.InstallOperation=b={})),e.$So=(0,M.$ii)("extensionGalleryService");var $;(function(i){i.Unsupported="Unsupported",i.Deprecated="Deprecated",i.Malicious="Malicious",i.Incompatible="Incompatible",i.IncompatibleTargetPlatform="IncompatibleTargetPlatform",i.ReleaseVersionNotFound="ReleaseVersionNotFound",i.Invalid="Invalid",i.Download="Download",i.DownloadSignature="DownloadSignature",i.UpdateMetadata="UpdateMetadata",i.Extract="Extract",i.Scanning="Scanning",i.Delete="Delete",i.Rename="Rename",i.CorruptZip="CorruptZip",i.IncompleteZip="IncompleteZip",i.Signature="Signature",i.NotAllowed="NotAllowed",i.Gallery="Gallery",i.Unknown="Unknown",i.Internal="Internal"})($||(e.ExtensionManagementErrorCode=$={}));var n;(function(i){i.UnknownError="UnknownError",i.PackageIsInvalidZip="PackageIsInvalidZip",i.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(n||(e.ExtensionSignaturetErrorCode=n={}));class o extends Error{constructor(c,h){super(c),this.code=h,this.name=h}}e.$To=o;var s;(function(i){i.Timeout="Timeout",i.Cancelled="Cancelled",i.Failed="Failed"})(s||(e.ExtensionGalleryErrorCode=s={}));class r extends Error{constructor(c,h){super(c),this.code=h,this.name=h}}e.$Uo=r,e.$Vo=(0,M.$ii)("extensionManagementService"),e.$Wo="extensionsIdentifiers/disabled",e.$Xo="extensionsIdentifiers/enabled",e.$Yo=(0,M.$ii)("IGlobalExtensionEnablementService"),e.$Zo=(0,M.$ii)("IExtensionTipsService"),e.$1o=(0,k.localize2)(0,"Extensions"),e.$2o=(0,k.localize2)(1,"Preferences")}),define(Pe[43],Re([1,0,52,19,15,17,2,158,3,21,12,40]),function(ee,e,k,M,C,N,A,m,d,y,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kl=e.$hl=e.FileKind=e.$gl=e.$fl=e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.FileOperationResult=e.$_k=e.$$k=e.$0k=e.$8k=e.FileChangeType=e.$7k=e.FileOperation=e.$1k=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$Ok=void 0,e.$Pk=l,e.$Qk=n,e.$Rk=s,e.$Sk=r,e.$Tk=i,e.$Uk=c,e.$Vk=h,e.$Wk=t,e.$Xk=p,e.$Yk=a,e.$Zk=g,e.$2k=u,e.$3k=E,e.$4k=w,e.$5k=I,e.$6k=S,e.$9k=L,e.$il=me,e.$jl=pe,e.$ll=be,e.$Ok=(0,d.$ii)("fileService");function l(se){return se.create===!0}var b;(function(se){se[se.Unknown=0]="Unknown",se[se.File=1]="File",se[se.Directory=2]="Directory",se[se.SymbolicLink=64]="SymbolicLink"})(b||(e.FileType=b={}));var $;(function(se){se[se.Readonly=1]="Readonly",se[se.Locked=2]="Locked"})($||(e.FilePermission=$={}));function n(se){const De=se;return!!De&&typeof De.onDidChange=="function"}var o;(function(se){se[se.None=0]="None",se[se.FileReadWrite=2]="FileReadWrite",se[se.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",se[se.FileReadStream=16]="FileReadStream",se[se.FileFolderCopy=8]="FileFolderCopy",se[se.PathCaseSensitive=1024]="PathCaseSensitive",se[se.Readonly=2048]="Readonly",se[se.Trash=4096]="Trash",se[se.FileWriteUnlock=8192]="FileWriteUnlock",se[se.FileAtomicRead=16384]="FileAtomicRead",se[se.FileAtomicWrite=32768]="FileAtomicWrite",se[se.FileAtomicDelete=65536]="FileAtomicDelete",se[se.FileClone=131072]="FileClone"})(o||(e.FileSystemProviderCapabilities=o={}));function s(se){return!!(se.capabilities&2)}function r(se){return!!(se.capabilities&8)}function i(se){return!!(se.capabilities&131072)}function c(se){return!!(se.capabilities&4)}function h(se){return!!(se.capabilities&16)}function t(se){return s(se)?!!(se.capabilities&16384):!1}function p(se){return s(se)?!!(se.capabilities&32768):!1}function a(se){return!!(se.capabilities&65536)}function g(se){return!!(se.capabilities&2048)}var v;(function(se){se.FileExists="EntryExists",se.FileNotFound="EntryNotFound",se.FileNotADirectory="EntryNotADirectory",se.FileIsADirectory="EntryIsADirectory",se.FileExceedsStorageQuota="EntryExceedsStorageQuota",se.FileTooLarge="EntryTooLarge",se.FileWriteLocked="EntryWriteLocked",se.NoPermissions="NoPermissions",se.Unavailable="Unavailable",se.Unknown="Unknown"})(v||(e.FileSystemProviderErrorCode=v={}));class f extends Error{static create(De,Oe){const ie=new f(De.toString(),Oe);return w(ie,Oe),ie}constructor(De,Oe){super(De),this.code=Oe}}e.$1k=f;function u(se,De){return f.create(se,De)}function E(se){return se||u((0,m.localize)(0,null),v.Unknown)}function w(se,De){return se.name=De?`${De} (FileSystemError)`:"FileSystemError",se}function I(se){if(!se)return v.Unknown;if(se instanceof f)return se.code;const De=/^(.+) \(FileSystemError\)$/.exec(se.name);if(!De)return v.Unknown;switch(De[1]){case v.FileExists:return v.FileExists;case v.FileIsADirectory:return v.FileIsADirectory;case v.FileNotADirectory:return v.FileNotADirectory;case v.FileNotFound:return v.FileNotFound;case v.FileTooLarge:return v.FileTooLarge;case v.FileWriteLocked:return v.FileWriteLocked;case v.NoPermissions:return v.NoPermissions;case v.Unavailable:return v.Unavailable}return v.Unknown}function S(se){if(se instanceof R)return se.fileOperationResult;switch(I(se)){case v.FileNotFound:return 1;case v.FileIsADirectory:return 0;case v.FileNotADirectory:return 9;case v.FileWriteLocked:return 5;case v.NoPermissions:return 6;case v.FileExists:return 4;case v.FileTooLarge:return 7;default:return 10}}var P;(function(se){se[se.CREATE=0]="CREATE",se[se.DELETE=1]="DELETE",se[se.MOVE=2]="MOVE",se[se.COPY=3]="COPY",se[se.WRITE=4]="WRITE"})(P||(e.FileOperation=P={}));class U{constructor(De,Oe,ie){this.resource=De,this.operation=Oe,this.target=ie}isOperation(De){return this.operation===De}}e.$7k=U;var Q;(function(se){se[se.UPDATED=0]="UPDATED",se[se.ADDED=1]="ADDED",se[se.DELETED=2]="DELETED"})(Q||(e.FileChangeType=Q={}));class H{constructor(De,Oe){this.c=Oe,this.b=void 0,this.d=new D.$V(()=>{const ie=k.$oi.forUris(()=>this.c);return ie.fill(this.rawAdded.map(q=>[q,!0])),ie}),this.f=new D.$V(()=>{const ie=k.$oi.forUris(()=>this.c);return ie.fill(this.rawUpdated.map(q=>[q,!0])),ie}),this.g=new D.$V(()=>{const ie=k.$oi.forUris(()=>this.c);return ie.fill(this.rawDeleted.map(q=>[q,!0])),ie}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const ie of De){switch(ie.type){case 1:this.rawAdded.push(ie.resource);break;case 0:this.rawUpdated.push(ie.resource);break;case 2:this.rawDeleted.push(ie.resource);break}this.b!==H.a&&(typeof ie.cId=="number"?this.b===void 0?this.b=ie.cId:this.b!==ie.cId&&(this.b=H.a):this.b!==void 0&&(this.b=H.a))}}contains(De,...Oe){return this.h(De,{includeChildren:!1},...Oe)}affects(De,...Oe){return this.h(De,{includeChildren:!0},...Oe)}h(De,Oe,...ie){if(!De)return!1;const q=ie.length>0;return!!((!q||ie.includes(1))&&(this.d.value.get(De)||Oe.includeChildren&&this.d.value.findSuperstr(De))||(!q||ie.includes(0))&&(this.f.value.get(De)||Oe.includeChildren&&this.f.value.findSuperstr(De))||(!q||ie.includes(2))&&(this.g.value.findSubstr(De)||Oe.includeChildren&&this.g.value.findSuperstr(De)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(De){return this.b===De}hasCorrelation(){return typeof this.b=="number"}}e.$8k=H,H.a=null;function L(se,De,Oe){return!se||!De||se===De||De.length>se.length?!1:(De.charAt(De.length-1)!==M.sep&&(De+=M.sep),Oe?(0,C.$mf)(se,De):se.indexOf(De)===0)}class R extends Error{constructor(De,Oe,ie){super(De),this.fileOperationResult=Oe,this.options=ie}}e.$0k=R;class F extends R{constructor(De,Oe,ie,q){super(De,Oe,q),this.fileOperationResult=Oe,this.size=ie}}e.$$k=F;class T extends R{constructor(De,Oe,ie){super(De,2,ie),this.stat=Oe}}e.$_k=T;var X;(function(se){se[se.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",se[se.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",se[se.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",se[se.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",se[se.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",se[se.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",se[se.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",se[se.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",se[se.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",se[se.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",se[se.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(X||(e.FileOperationResult=X={})),e.$al={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$bl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$cl="files.associations",e.$dl="files.exclude",e.$el="files.readonlyInclude",e.$fl="files.readonlyExclude",e.$gl="files.readonlyFromPermissions";var re;(function(se){se[se.FILE=0]="FILE",se[se.FOLDER=1]="FOLDER",se[se.ROOT_FOLDER=2]="ROOT_FOLDER"})(re||(e.FileKind=re={})),e.$hl="";function me(se){if(!(typeof se.size!="number"||typeof se.mtime!="number"))return se.mtime.toString(29)+se.size.toString(31)}async function pe(se,De){if(!De.hasProvider(A.URI.from({scheme:se.scheme})))return new Promise(Oe=>{const ie=De.onDidChangeFileSystemProviderRegistrations(q=>{q.scheme===se.scheme&&q.added&&(ie.dispose(),Oe())})})}class ae{static formatSize(De){return(0,N.$Zf)(De)||(De=0),De<ae.KB?(0,m.localize)(1,null,De.toFixed(0)):De<ae.MB?(0,m.localize)(2,null,(De/ae.KB).toFixed(2)):De<ae.GB?(0,m.localize)(3,null,(De/ae.MB).toFixed(2)):De<ae.TB?(0,m.localize)(4,null,(De/ae.GB).toFixed(2)):(0,m.localize)(5,null,(De/ae.TB).toFixed(2))}}e.$kl=ae,ae.KB=1024,ae.MB=ae.KB*ae.KB,ae.GB=ae.MB*ae.KB,ae.TB=ae.GB*ae.KB;function be(se){const De=typeof se=="string"||se?.scheme===O.Schemas.vscodeRemote;return typeof se!="string"&&se?.scheme===O.Schemas.file?1024*ae.MB:De?10*ae.MB:y.$i?50*ae.MB:1024*ae.MB}}),define(Pe[71],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gi=void 0;class k{constructor(...C){this.a=new Map;for(const[N,A]of C)this.set(N,A)}set(C,N){const A=this.a.get(C);return this.a.set(C,N),A}has(C){return this.a.has(C)}get(C){return this.a.get(C)}}e.$gi=k}),define(Pe[191],Re([1,0,11,14,6,70,189,3,71,192]),function(ee,e,k,M,C,N,A,m,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=e.$Zq=void 0;const O=!1;class D extends Error{constructor(o){super("cyclic dependency between services"),this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class l{constructor(o=new d.$gi,s=!1,r,i=O){this.f=o,this.g=s,this.h=r,this.i=i,this.o=new Set,this.f.set(m.$hi,this),this._globalGraph=i?r?._globalGraph??new A.$Yq(c=>c):void 0}createChild(o){return new l(o,this.g,this,this.i)}invokeFunction(o,...s){const r=$.traceInvocation(this.i,o);let i=!1;try{return o({get:h=>{if(i)throw(0,M.$8)("service accessor is only valid during the invocation of its target method");const t=this.m(h,r);if(!t)throw new Error(`[invokeFunction] unknown service '${h}'`);return t}},...s)}finally{i=!0,r.stop()}}createInstance(o,...s){let r,i;return o instanceof N.$fi?(r=$.traceCreation(this.i,o.ctor),i=this.j(o.ctor,o.staticArguments.concat(s),r)):(r=$.traceCreation(this.i,o),i=this.j(o,s,r)),r.stop(),i}j(o,s=[],r){const i=m._util.getServiceDependencies(o).sort((t,p)=>t.index-p.index),c=[];for(const t of i){const p=this.m(t.id,r);p||this.u(`[createInstance] ${o.name} depends on UNKNOWN service ${t.id}.`,!1),c.push(p)}const h=i.length>0?i[0].index:s.length;if(s.length!==h){console.trace(`[createInstance] First service dependency of ${o.name} at position ${h+1} conflicts with ${s.length} static arguments`);const t=h-s.length;t>0?s=s.concat(new Array(t)):s=s.slice(0,h)}return Reflect.construct(o,s.concat(c))}k(o,s){if(this.f.get(o)instanceof N.$fi)this.f.set(o,s);else if(this.h)this.h.k(o,s);else throw new Error("illegalState - setting UNKNOWN service instance")}l(o){const s=this.f.get(o);return!s&&this.h?this.h.l(o):s}m(o,s){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(o));const r=this.l(o);return r instanceof N.$fi?this.q(o,r,s.branch(o,!0)):(s.branch(o,!1),r)}q(o,s,r){if(this.o.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this.o.add(o);try{return this.r(o,s,r)}finally{this.o.delete(o)}}r(o,s,r){const i=new A.$Yq(t=>t.id.toString());let c=0;const h=[{id:o,desc:s,_trace:r}];for(;h.length;){const t=h.pop();if(i.lookupOrInsertNode(t),c++>1e3)throw new D(i);for(const p of m._util.getServiceDependencies(t.desc.ctor)){const a=this.l(p.id);if(a||this.u(`[createInstance] ${o} depends on ${p.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(p.id)),a instanceof N.$fi){const g={id:p.id,desc:a,_trace:t._trace.branch(p.id,!0)};i.insertEdge(t,g),h.push(g)}}}for(;;){const t=i.roots();if(t.length===0){if(!i.isEmpty())throw new D(i);break}for(const{data:p}of t){if(this.l(p.id)instanceof N.$fi){const g=this.s(p.id,p.desc.ctor,p.desc.staticArguments,p.desc.supportsDelayedInstantiation,p._trace);this.k(p.id,g)}i.removeNode(p)}}return this.l(o)}s(o,s,r=[],i,c){if(this.f.get(o)instanceof N.$fi)return this.t(o,s,r,i,c);if(this.h)return this.h.s(o,s,r,i,c);throw new Error(`illegalState - creating UNKNOWN service instance ${s.name}`)}t(o,s,r=[],i,c){if(i){const h=new l(void 0,this.g,this,this.i);h.c=String(o);const t=new Map,p=new k.$Bh(()=>{const a=h.j(s,r,c);for(const[g,v]of t){const f=a[g];if(typeof f=="function")for(const u of v)u.disposable=f.apply(a,u.listener)}return t.clear(),a});return new Proxy(Object.create(null),{get(a,g){if(!p.isInitialized&&typeof g=="string"&&(g.startsWith("onDid")||g.startsWith("onWill"))){let u=t.get(g);return u||(u=new y.$5c,t.set(g,u)),(w,I,S)=>{if(p.isInitialized)return p.value[g](w,I,S);{const P={listener:[w,I,S],disposable:void 0},U=u.push(P);return(0,C.$Sc)(()=>{U(),P.disposable?.dispose()})}}}if(g in a)return a[g];const v=p.value;let f=v[g];return typeof f!="function"||(f=f.bind(v),a[g]=f),f},set(a,g,v){return p.value[g]=v,!0},getPrototypeOf(a){return s.prototype}})}else return this.j(s,r,c)}u(o,s){if(s&&console.warn(o),this.g)throw new Error(o)}}e.$Zq=l;var b;(function(n){n[n.None=0]="None",n[n.Creation=1]="Creation",n[n.Invocation=2]="Invocation",n[n.Branch=3]="Branch"})(b||(b={}));class ${static traceInvocation(o,s){return o?new $(2,s.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):$.c}static traceCreation(o,s){return o?new $(1,s.name):$.c}constructor(o,s){this.type=o,this.name=s,this.g=Date.now(),this.h=[]}branch(o,s){const r=new $(3,o.toString());return this.h.push([o,s,r]),r}stop(){const o=Date.now()-this.g;$.f+=o;let s=!1;function r(c,h){const t=[],p=new Array(c+1).join("	");for(const[a,g,v]of h.h)if(g&&v){s=!0,t.push(`${p}CREATES -> ${a}`);const f=r(c+1,v);f&&t.push(f)}else t.push(`${p}uses -> ${a}`);return t.join(`
`)}const i=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${r(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${$.f.toFixed(2)}ms)`];(o>2||s)&&$.all.add(i.join(`
`))}}e.$1q=$,$.all=new Set,$.c=new class extends ${constructor(){super(0,null)}stop(){}branch(){return this}},$.f=0}),define(Pe[13],Re([1,0,159,42,5,99,6,28,21,23,17,2,33,3]),function(ee,e,k,M,C,N,A,m,d,y,O,D,l,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Rj=e.LogLevel=e.$Pj=e.$Oj=void 0,e.$Qj=n,e.log=s,e.$3j=u,e.$4j=E,e.$5j=w,e.$6j=I,e.$Oj=(0,b.$ii)("logService"),e.$Pj=(0,b.$ii)("loggerService");function $(){return new Date().toISOString()}function n(S){return(0,O.$Zf)(S)}var o;(function(S){S[S.Off=0]="Off",S[S.Trace=1]="Trace",S[S.Debug=2]="Debug",S[S.Info=3]="Info",S[S.Warning=4]="Warning",S[S.Error=5]="Error"})(o||(e.LogLevel=o={})),e.$Rj=o.Info;function s(S,P,U){switch(P){case o.Trace:S.trace(U);break;case o.Debug:S.debug(U);break;case o.Info:S.info(U);break;case o.Warning:S.warn(U);break;case o.Error:S.error(U);break;case o.Off:break;default:throw new Error(`Invalid log level ${P}`)}}function r(S,P=!1){let U="";for(let Q=0;Q<S.length;Q++){let H=S[Q];if(H instanceof Error&&(H=(0,M.$6i)(H,P)),typeof H=="object")try{H=JSON.stringify(H)}catch{}U+=(Q>0?" ":"")+H}return U}class i extends A.$Uc{constructor(){super(...arguments),this.b=e.$Rj,this.c=this.B(new C.$7d),this.onDidChangeLogLevel=this.c.event}setLevel(P){this.b!==P&&(this.b=P,this.c.fire(this.b))}getLevel(){return this.b}f(P){return this.b!==o.Off&&this.b<=P}}e.$Tj=i;class c extends i{constructor(P){super(),this.h=P}f(P){return this.h||super.f(P)}trace(P,...U){this.f(o.Trace)&&this.g(o.Trace,r([P,...U],!0))}debug(P,...U){this.f(o.Debug)&&this.g(o.Debug,r([P,...U]))}info(P,...U){this.f(o.Info)&&this.g(o.Info,r([P,...U]))}warn(P,...U){this.f(o.Warning)&&this.g(o.Warning,r([P,...U]))}error(P,...U){if(this.f(o.Error))if(P instanceof Error){const Q=Array.prototype.slice.call(arguments);Q[0]=P.stack,this.g(o.Error,r(Q))}else this.g(o.Error,r([P,...U]))}flush(){}}e.$Uj=c;class h extends i{constructor(P=e.$Rj){super(),this.setLevel(P),this.g=!d.$c}trace(P,...U){this.f(o.Trace)&&(this.g?console.log(`\x1B[90m[main ${$()}]\x1B[0m`,P,...U):console.log(`[main ${$()}]`,P,...U))}debug(P,...U){this.f(o.Debug)&&(this.g?console.log(`\x1B[90m[main ${$()}]\x1B[0m`,P,...U):console.log(`[main ${$()}]`,P,...U))}info(P,...U){this.f(o.Info)&&(this.g?console.log(`\x1B[90m[main ${$()}]\x1B[0m`,P,...U):console.log(`[main ${$()}]`,P,...U))}warn(P,...U){this.f(o.Warning)&&(this.g?console.warn(`\x1B[93m[main ${$()}]\x1B[0m`,P,...U):console.warn(`[main ${$()}]`,P,...U))}error(P,...U){this.f(o.Error)&&(this.g?console.error(`\x1B[91m[main ${$()}]\x1B[0m`,P,...U):console.error(`[main ${$()}]`,P,...U))}flush(){}}e.$Vj=h;class t extends i{constructor(P=e.$Rj,U=!0){super(),this.g=U,this.setLevel(P)}trace(P,...U){this.f(o.Trace)&&(this.g?console.log("%cTRACE","color: #888",P,...U):console.log(P,...U))}debug(P,...U){this.f(o.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",P,...U):console.log(P,...U))}info(P,...U){this.f(o.Info)&&(this.g?console.log("%c INFO","color: #33f",P,...U):console.log(P,...U))}warn(P,...U){this.f(o.Warning)&&(this.g?console.log("%c WARN","color: #993",P,...U):console.log(P,...U))}error(P,...U){this.f(o.Error)&&(this.g?console.log("%c  ERR","color: #f33",P,...U):console.error(P,...U))}flush(){}}e.$Wj=t;class p extends i{constructor(P,U=e.$Rj){super(),this.g=P,this.setLevel(U)}trace(P,...U){this.f(o.Trace)&&this.g.log(o.Trace,[this.h(P),...U])}debug(P,...U){this.f(o.Debug)&&this.g.log(o.Debug,[this.h(P),...U])}info(P,...U){this.f(o.Info)&&this.g.log(o.Info,[this.h(P),...U])}warn(P,...U){this.f(o.Warning)&&this.g.log(o.Warning,[this.h(P),...U])}error(P,...U){this.f(o.Error)&&this.g.log(o.Error,[this.h(P),...U])}h(P){return typeof P=="string"?P:(0,M.$6i)(P,this.f(o.Trace))}flush(){}}e.$Xj=p;class a extends i{constructor(P){super(),this.g=P,P.length&&this.setLevel(P[0].getLevel())}setLevel(P){for(const U of this.g)U.setLevel(P);super.setLevel(P)}trace(P,...U){for(const Q of this.g)Q.trace(P,...U)}debug(P,...U){for(const Q of this.g)Q.debug(P,...U)}info(P,...U){for(const Q of this.g)Q.info(P,...U)}warn(P,...U){for(const Q of this.g)Q.warn(P,...U)}error(P,...U){for(const Q of this.g)Q.error(P,...U)}flush(){for(const P of this.g)P.flush()}dispose(){for(const P of this.g)P.dispose();super.dispose()}}e.$Yj=a;class g extends A.$Uc{constructor(P,U,Q){if(super(),this.h=P,this.j=U,this.b=new m.$Bc,this.c=this.B(new C.$7d),this.onDidChangeLoggers=this.c.event,this.f=this.B(new C.$7d),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new C.$7d),this.onDidChangeVisibility=this.g.event,Q)for(const H of Q)this.b.set(H.resource,{logger:void 0,info:H})}m(P){return(0,O.$Vf)(P)?[...this.b.values()].find(U=>U.info.id===P):this.b.get(P)}getLogger(P){return this.m(P)?.logger}createLogger(P,U){const Q=this.n(P),H=(0,O.$Vf)(P)?P:U?.id??(0,N.$9i)(Q.toString()).toString(16);let L=this.b.get(Q)?.logger;const R=U?.logLevel==="always"?o.Trace:U?.logLevel;L||(L=this.s(Q,R??this.getLogLevel(Q)??this.h,{...U,id:H}));const F={logger:L,info:{resource:Q,id:H,logLevel:R,name:U?.name,hidden:U?.hidden,extensionId:U?.extensionId,when:U?.when}};return this.registerLogger(F.info),this.b.set(Q,F),L}n(P){return(0,O.$Vf)(P)?(0,y.$Vg)(this.j,`${P}.log`):P}setLogLevel(P,U){if(D.URI.isUri(P)){const Q=P,H=U,L=this.b.get(Q);L&&H!==L.info.logLevel&&(L.info.logLevel=H===this.h?void 0:H,L.logger?.setLevel(H),this.b.set(L.info.resource,L),this.f.fire([Q,H]))}else{this.h=P;for(const[Q,H]of this.b.entries())this.b.get(Q)?.info.logLevel===void 0&&H.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(P,U){const Q=this.m(P);Q&&U!==!Q.info.hidden&&(Q.info.hidden=!U,this.b.set(Q.info.resource,Q),this.g.fire([Q.info.resource,U]))}getLogLevel(P){let U;return P&&(U=this.b.get(P)?.info.logLevel),U??this.h}registerLogger(P){const U=this.b.get(P.resource);U?U.info.hidden!==P.hidden&&this.setVisibility(P.resource,!P.hidden):(this.b.set(P.resource,{info:P,logger:void 0}),this.c.fire({added:[P],removed:[]}))}deregisterLogger(P){const U=this.b.get(P);U&&(U.logger&&U.logger.dispose(),this.b.delete(P),this.c.fire({added:[],removed:[U.info]}))}*getRegisteredLoggers(){for(const P of this.b.values())yield P.info}getRegisteredLogger(P){return this.b.get(P)?.info}dispose(){this.b.forEach(P=>P.logger?.dispose()),this.b.clear(),super.dispose()}}e.$Zj=g;class v{constructor(){this.onDidChangeLogLevel=new C.$7d().event}setLevel(P){}getLevel(){return o.Info}trace(P,...U){}debug(P,...U){}info(P,...U){}warn(P,...U){}error(P,...U){}critical(P,...U){}dispose(){}flush(){}}e.$1j=v;class f extends v{}e.$2j=f;function u(S){if(S.verbose)return o.Trace;if(typeof S.logLevel=="string"){const P=I(S.logLevel.toLowerCase());if(P!==void 0)return P}return e.$Rj}function E(S){switch(S){case o.Trace:return"trace";case o.Debug:return"debug";case o.Info:return"info";case o.Warning:return"warn";case o.Error:return"error";case o.Off:return"off"}}function w(S){switch(S){case o.Trace:return{original:"Trace",value:k.localize(0,null)};case o.Debug:return{original:"Debug",value:k.localize(1,null)};case o.Info:return{original:"Info",value:k.localize(2,null)};case o.Warning:return{original:"Warning",value:k.localize(3,null)};case o.Error:return{original:"Error",value:k.localize(4,null)};case o.Off:return{original:"Off",value:k.localize(5,null)}}}function I(S){switch(S){case"trace":return o.Trace;case"debug":return o.Debug;case"info":return o.Info;case"warn":return o.Warning;case"error":return o.Error;case"critical":return o.Error;case"off":return o.Off}}e.$7j=new l.$zj("logLevel",E(o.Info))}),define(Pe[193],Re([1,0,6,13]),function(ee,e,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bQ=void 0;class C extends k.$Uc{constructor(A,m=[]){super(),this.a=new M.$Yj([A,...m]),this.B(A.onDidChangeLogLevel(d=>this.setLevel(d)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...m){this.a.trace(A,...m)}debug(A,...m){this.a.debug(A,...m)}info(A,...m){this.a.info(A,...m)}warn(A,...m){this.a.warn(A,...m)}error(A,...m){this.a.error(A,...m)}flush(){this.a.flush()}}e.$bQ=C}),define(Pe[100],Re([1,0,32,160,3]),function(ee,e,k,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vt=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var N;(function(d){d[d.Unnecessary=1]="Unnecessary",d[d.Deprecated=2]="Deprecated"})(N||(e.MarkerTag=N={}));var A;(function(d){d[d.Hint=1]="Hint",d[d.Info=2]="Info",d[d.Warning=4]="Warning",d[d.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function(d){function y($,n){return n-$}d.compare=y;const O=Object.create(null);O[d.Error]=(0,M.localize)(0,null),O[d.Warning]=(0,M.localize)(1,null),O[d.Info]=(0,M.localize)(2,null);function D($){return O[$]||""}d.toString=D;function l($){switch($){case k.default.Error:return d.Error;case k.default.Warning:return d.Warning;case k.default.Info:return d.Info;case k.default.Ignore:return d.Hint}}d.fromSeverity=l;function b($){switch($){case d.Error:return k.default.Error;case d.Warning:return k.default.Warning;case d.Info:return k.default.Info;case d.Hint:return k.default.Ignore}}d.toSeverity=b}(A||(e.MarkerSeverity=A={}));var m;(function(d){const y="";function O(l){return D(l,!0)}d.makeKey=O;function D(l,b){const $=[y];return l.source?$.push(l.source.replace("\xA6","\\\xA6")):$.push(y),l.code?typeof l.code=="string"?$.push(l.code.replace("\xA6","\\\xA6")):$.push(l.code.value.replace("\xA6","\\\xA6")):$.push(y),l.severity!==void 0&&l.severity!==null?$.push(A.toString(l.severity)):$.push(y),l.message&&b?$.push(l.message.replace("\xA6","\\\xA6")):$.push(y),l.startLineNumber!==void 0&&l.startLineNumber!==null?$.push(l.startLineNumber.toString()):$.push(y),l.startColumn!==void 0&&l.startColumn!==null?$.push(l.startColumn.toString()):$.push(y),l.endLineNumber!==void 0&&l.endLineNumber!==null?$.push(l.endLineNumber.toString()):$.push(y),l.endColumn!==void 0&&l.endColumn!==null?$.push(l.endColumn.toString()):$.push(y),$.push(y),$.join("\xA6")}d.makeKeyOptionalMessage=D})(m||(e.IMarkerData=m={})),e.$Vt=(0,C.$ii)("markerService")}),define(Pe[194],Re([1,0,5,32,3]),function(ee,e,k,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pv=e.$Ov=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$Mv=e.Severity=void 0,e.$Nv=m,e.Severity=M.default,e.$Mv=(0,C.$ii)("notificationService");var N;(function(D){D[D.DEFAULT=0]="DEFAULT",D[D.SILENT=1]="SILENT",D[D.URGENT=2]="URGENT"})(N||(e.NotificationPriority=N={}));var A;(function(D){D[D.WORKSPACE=0]="WORKSPACE",D[D.PROFILE=1]="PROFILE",D[D.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));function m(D){if(D){const l=D;return typeof l.id=="string"&&typeof l.label=="string"}return!1}var d;(function(D){D[D.OFF=0]="OFF",D[D.ERROR=1]="ERROR"})(d||(e.NotificationsFilter=d={}));class y{constructor(){this.progress=new O,this.onDidClose=k.Event.None,this.onDidChangeVisibility=k.Event.None}updateSeverity(l){}updateMessage(l){}updateActions(l){}close(){}}e.$Ov=y;class O{infinite(){}done(){}total(l){}worked(l){}}e.$Pv=O}),define(Pe[195],Re([1,0,3]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9j=e.$8j=void 0,e.$8j=(0,k.$ii)("productService"),e.$9j="vscode://schemas/vscode-product"});var Xe=this&&this.__decorate||function(ee,e,k,M){var C=arguments.length,N=C<3?e:M===null?M=Object.getOwnPropertyDescriptor(e,k):M,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")N=Reflect.decorate(ee,e,k,M);else for(var m=ee.length-1;m>=0;m--)(A=ee[m])&&(N=(C<3?A(N):C>3?A(e,k,N):A(e,k))||N);return C>3&&N&&Object.defineProperty(e,k,N),N},qe=this&&this.__param||function(ee,e){return function(k,M){e(k,M,ee)}};define(Pe[101],Re([1,0,11,24,6,3]),function(ee,e,k,M,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wv=e.$Vv=e.$Uv=e.$Tv=e.$Sv=e.$Rv=e.ProgressLocation=e.$Qv=void 0,e.$Qv=(0,N.$ii)("progressService");var A;(function(D){D[D.Explorer=1]="Explorer",D[D.Scm=3]="Scm",D[D.Extensions=5]="Extensions",D[D.Window=10]="Window",D[D.Notification=15]="Notification",D[D.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.$Rv=Object.freeze({total(){},worked(){},done(){}});class m{get value(){return this.a}constructor(l){this.b=l}report(l){this.a=l,this.b(this.a)}}e.$Sv=m,m.None=Object.freeze({report(){}});class d{get value(){return this.a}constructor(l){this.e=l}report(l){this.b?this.b.push(l):this.b=[l],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const l=this.b.shift();this.a=l,await this.e(this.a)}}finally{this.c=!1;const l=this.d;this.d=void 0,l?.()}}drain(){return this.c?new Promise(l=>{const b=this.d;this.d=()=>{b?.(),l()}}):Promise.resolve()}}e.$Tv=d;let y=class extends C.$Uc{constructor(l,b){super(),this.a=new k.$Fh,b.withProgress(l,$=>(this.b=$,this.c&&$.report(this.c),this.a.p)),this.B((0,C.$Sc)(()=>this.a.complete()))}report(l){this.b?this.b.report(l):this.c=l}};e.$Uv=y,e.$Uv=y=Xe([qe(1,e.$Qv)],y);class O extends C.$Uc{constructor(l){super(),this.g=l,this.a=0,this.b=this.B(new C.$Tc)}start(l){this.stop();const b=++this.a,$=new M.$ee;return this.f=setTimeout(()=>{b===this.a&&(this.c=this.g.show(!0))},l),this.b.add((0,C.$Sc)(()=>clearTimeout(this.f))),this.b.add((0,C.$Sc)(()=>$.cancel())),this.b.add((0,C.$Sc)(()=>this.c?this.c.done():void 0)),{id:b,token:$.token,stop:()=>this.h(b),isCurrent:()=>this.a===b}}stop(){this.h(this.a)}h(l){this.a===l&&this.b.clear()}}e.$Vv=O,e.$Wv=(0,N.$ii)("editorProgressService")}),define(Pe[30],Re([1,0,56,17]),function(ee,e,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2n=void 0;class C{constructor(){this.a=new Map}add(A,m){k.ok(M.$Vf(A)),k.ok(M.$Xf(m)),k.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,m)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$2n=new C}),define(Pe[72],Re([1,0,5,30]),function(ee,e,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3n=void 0,e.$3n={JSONContribution:"base.contributions.json"};function C(m){return m.length>0&&m.charAt(m.length-1)==="#"?m.substring(0,m.length-1):m}class N{constructor(){this.b=new k.$7d,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(d,y){this.a[C(d)]=y,this.b.fire(d)}notifySchemaChanged(d){this.b.fire(d)}getSchemaContributions(){return{schemas:this.a}}}const A=new N;M.$2n.add(e.$3n.JSONContribution,A)}),define(Pe[57],Re([1,0,18,5,17,153,47,72,30]),function(ee,e,k,M,C,N,A,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.ConfigurationScope=e.$7n=e.EditPresentationTypes=void 0,e.$fo=n,e.$go=o,e.$ho=s,e.$io=i,e.$jo=c;var y;(function(h){h.Multiline="multilineText",h.Singleline="singlelineText"})(y||(e.EditPresentationTypes=y={})),e.$7n={Configuration:"base.contributions.configuration"};var O;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.MACHINE=2]="MACHINE",h[h.WINDOW=3]="WINDOW",h[h.RESOURCE=4]="RESOURCE",h[h.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",h[h.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(O||(e.ConfigurationScope=O={})),e.$8n={properties:{},patternProperties:{}},e.$9n={properties:{},patternProperties:{}},e.$0n={properties:{},patternProperties:{}},e.$$n={properties:{},patternProperties:{}},e.$_n={properties:{},patternProperties:{}},e.$ao={properties:{},patternProperties:{}},e.$bo="vscode://schemas/settings/resourceLanguage",e.$co="vscode://schemas/settings/configurationDefaults";const D=d.$2n.as(m.$3n.JSONContribution);class l{constructor(){this.h=new Set,this.i=new M.$7d,this.onDidSchemaChange=this.i.event,this.j=new M.$7d,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:N.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},D.registerSchema(e.$bo,this.g),this.v()}registerConfiguration(t,p=!0){this.registerConfigurations([t],p)}registerConfigurations(t,p=!0){const a=new Set;this.n(t,p,a),D.registerSchema(e.$bo,this.g),this.i.fire(),this.j.fire({properties:a})}deregisterConfigurations(t){const p=new Set;this.o(t,p),D.registerSchema(e.$bo,this.g),this.i.fire(),this.j.fire({properties:p})}updateConfigurations({add:t,remove:p}){const a=new Set;this.o(p,a),this.n(t,!1,a),D.registerSchema(e.$bo,this.g),this.i.fire(),this.j.fire({properties:a})}registerDefaultConfigurations(t){const p=new Set;this.k(t,p),this.i.fire(),this.j.fire({properties:p,defaultsOverrides:!0})}k(t,p){const a=[];for(const{overrides:g,source:v}of t)for(const f in g)if(p.add(f),e.$eo.test(f)){const u=this.a.get(f),E=u?.valuesSources??new Map;if(v)for(const P of Object.keys(g[f]))E.set(P,v);const w={...u?.value||{},...g[f]};this.a.set(f,{source:v,value:w,valuesSources:E});const I=(0,A.$Yi)(f),S={type:"object",default:w,description:N.localize(1,null,I),$ref:e.$bo,defaultDefaultValue:w,source:C.$Vf(v)?void 0:v,defaultValueSource:v};a.push(...n(f)),this.d[f]=S,this.b.properties[f]=S}else{this.a.set(f,{value:g[f],source:v});const u=this.d[f];u&&(this.w(f,u),this.r(f,u))}this.m(a)}deregisterDefaultConfigurations(t){const p=new Set;this.l(t,p),this.i.fire(),this.j.fire({properties:p,defaultsOverrides:!0})}l(t,p){for(const{overrides:a,source:g}of t)for(const v in a){const f=this.a.get(v),u=C.$Vf(g)?g:g?.id,E=C.$Vf(f?.source)?f?.source:f?.source?.id;if(u===E)if(p.add(v),this.a.delete(v),e.$eo.test(v))delete this.d[v],delete this.b.properties[v];else{const w=this.d[v];w&&(this.w(v,w),this.r(v,w))}}this.u()}deltaConfiguration(t){let p=!1;const a=new Set;t.removedDefaults&&(this.l(t.removedDefaults,a),p=!0),t.addedDefaults&&(this.k(t.addedDefaults,a),p=!0),t.removedConfigurations&&this.o(t.removedConfigurations,a),t.addedConfigurations&&this.n(t.addedConfigurations,!1,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:p})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const p of t)this.h.add(p);this.u()}n(t,p,a){t.forEach(g=>{this.p(g,p,g.extensionInfo,g.restrictedProperties,void 0,a),this.c.push(g),this.q(g)})}o(t,p){const a=g=>{if(g.properties)for(const v in g.properties){p.add(v);const f=this.d[v];f?.policy?.name&&this.e.delete(f.policy.name),delete this.d[v],this.s(v,g.properties[v])}g.allOf?.forEach(v=>a(v))};for(const g of t){a(g);const v=this.c.indexOf(g);v!==-1&&this.c.splice(v,1)}}p(t,p=!0,a,g,v=3,f){v=C.$5f(t.scope)?v:t.scope;const u=t.properties;if(u)for(const w in u){const I=u[w];if(p&&i(w,I)){delete u[w];continue}if(I.source=a,I.defaultDefaultValue=u[w].default,this.w(w,I),e.$eo.test(w)?I.scope=void 0:(I.scope=C.$5f(I.scope)?v:I.scope,I.restricted=C.$5f(I.restricted)?!!g?.includes(w):I.restricted),u[w].hasOwnProperty("included")&&!u[w].included){this.f[w]=u[w],delete u[w];continue}else this.d[w]=u[w],u[w].policy?.name&&this.e.set(u[w].policy.name,w);!u[w].deprecationMessage&&u[w].markdownDeprecationMessage&&(u[w].deprecationMessage=u[w].markdownDeprecationMessage),f.add(w)}const E=t.allOf;if(E)for(const w of E)this.p(w,p,a,g,v,f)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const p=a=>{const g=a.properties;if(g)for(const f in g)this.r(f,g[f]);a.allOf?.forEach(p)};p(t)}r(t,p){switch(e.$8n.properties[t]=p,p.scope){case 1:e.$9n.properties[t]=p;break;case 2:e.$0n.properties[t]=p;break;case 6:e.$$n.properties[t]=p;break;case 3:e.$_n.properties[t]=p;break;case 4:e.$ao.properties[t]=p;break;case 5:e.$ao.properties[t]=p,this.g.properties[t]=p;break}}s(t,p){switch(delete e.$8n.properties[t],p.scope){case 1:delete e.$9n.properties[t];break;case 2:delete e.$0n.properties[t];break;case 6:delete e.$$n.properties[t];break;case 3:delete e.$_n.properties[t];break;case 4:case 5:delete e.$ao.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const p=`[${t}]`,a={type:"object",description:N.localize(2,null),errorMessage:N.localize(3,null),$ref:e.$bo};this.w(p,a),e.$8n.properties[p]=a,e.$9n.properties[p]=a,e.$0n.properties[p]=a,e.$$n.properties[p]=a,e.$_n.properties[p]=a,e.$ao.properties[p]=a}}v(){const t={type:"object",description:N.localize(4,null),errorMessage:N.localize(5,null),$ref:e.$bo};e.$8n.patternProperties[e.$do]=t,e.$9n.patternProperties[e.$do]=t,e.$0n.patternProperties[e.$do]=t,e.$$n.patternProperties[e.$do]=t,e.$_n.patternProperties[e.$do]=t,e.$ao.patternProperties[e.$do]=t,this.i.fire()}w(t,p){const a=this.a.get(t);let g=a?.value,v=a?.source;C.$3f(g)&&(g=p.defaultDefaultValue,v=void 0),C.$3f(g)&&(g=s(p.type)),p.default=g,p.defaultValueSource=v}}const b="\\[([^\\]]+)\\]",$=new RegExp(b,"g");e.$do=`^(${b})+$`,e.$eo=new RegExp(e.$do);function n(h){const t=[];if(e.$eo.test(h)){let p=$.exec(h);for(;p?.length;){const a=p[1].trim();a&&t.push(a),p=$.exec(h)}}return(0,k.$Mb)(t)}function o(h){return h.reduce((t,p)=>`${t}[${p}]`,"")}function s(h){switch(Array.isArray(h)?h[0]:h){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const r=new l;d.$2n.add(e.$7n.Configuration,r);function i(h,t){return h.trim()?e.$eo.test(h)?N.localize(7,null,h):r.getConfigurationProperties()[h]!==void 0?N.localize(8,null,h):t.policy?.name&&r.getPolicyConfigurations().get(t.policy?.name)!==void 0?N.localize(9,null,h,t.policy?.name,r.getPolicyConfigurations().get(t.policy?.name)):null:N.localize(6,null)}function c(){const h=[],t=r.getConfigurationProperties();for(const p of Object.keys(t))h.push([p,t[p].scope]);return h.push(["launch",4]),h.push(["task",4]),h}}),define(Pe[196],Re([1,0,18,5,123,6,28,26,17,2,47,57,30]),function(ee,e,k,M,C,N,A,m,d,y,O,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$po=e.$no=e.$mo=e.$lo=e.$ko=void 0,e.$oo=i;function b(p){return Object.isFrozen(p)?p:m.$Qn(p)}class ${constructor(a={},g=[],v=[],f){this.b=a,this.c=g,this.d=v,this.raw=f,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const a=this.raw.map(g=>{if(g instanceof $)return g;const v=new n("");return v.parseRaw(g),v.configurationModel});this.f=a.reduce((g,v)=>v===g?v:g.merge(v),a[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(a){return a?(0,O.$Wi)(this.contents,a):this.contents}inspect(a,g){const v=this;return{get value(){return b(v.rawConfiguration.getValue(a))},get override(){return g?b(v.rawConfiguration.getOverrideValue(a,g)):void 0},get merged(){return b(g?v.rawConfiguration.override(g).getValue(a):v.rawConfiguration.getValue(a))},get overrides(){const f=[];for(const{contents:u,identifiers:E,keys:w}of v.rawConfiguration.overrides){const I=new $(u,w).getValue(a);I!==void 0&&f.push({identifiers:E,value:I})}return f.length?b(f):void 0}}}getOverrideValue(a,g){const v=this.i(g);return v?a?(0,O.$Wi)(v,a):v:void 0}getKeysForOverrideIdentifier(a){const g=[];for(const v of this.overrides)v.identifiers.includes(a)&&g.push(...v.keys);return k.$Mb(g)}getAllOverrideIdentifiers(){const a=[];for(const g of this.overrides)a.push(...g.identifiers);return k.$Mb(a)}override(a){let g=this.a.get(a);return g||(g=this.g(a),this.a.set(a,g)),g}merge(...a){const g=m.$Pn(this.contents),v=m.$Pn(this.overrides),f=[...this.keys],u=this.raw?.length?[...this.raw]:[this];for(const E of a)if(u.push(...E.raw?.length?E.raw:[E]),!E.isEmpty()){this.h(g,E.contents);for(const w of E.overrides){const[I]=v.filter(S=>k.$ub(S.identifiers,w.identifiers));I?(this.h(I.contents,w.contents),I.keys.push(...w.keys),I.keys=k.$Mb(I.keys)):v.push(m.$Pn(w))}for(const w of E.keys)f.indexOf(w)===-1&&f.push(w)}return new $(g,f,v,u.every(E=>E instanceof $)?void 0:u)}g(a){const g=this.i(a);if(!g||typeof g!="object"||!Object.keys(g).length)return this;const v={};for(const f of k.$Mb([...Object.keys(this.contents),...Object.keys(g)])){let u=this.contents[f];const E=g[f];E&&(typeof u=="object"&&typeof E=="object"?(u=m.$Pn(u),this.h(u,E)):u=E),v[f]=u}return new $(v,this.keys,this.overrides)}h(a,g){for(const v of Object.keys(g)){if(v in a&&d.$Xf(a[v])&&d.$Xf(g[v])){this.h(a[v],g[v]);continue}a[v]=m.$Pn(g[v])}}i(a){let g=null,v=null;const f=u=>{u&&(v?this.h(v,u):v=m.$Pn(u))};for(const u of this.overrides)u.identifiers.length===1&&u.identifiers[0]===a?g=u.contents:u.identifiers.includes(a)&&f(u.contents);return f(g),v}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(a,g){this.j(a,g,!0)}setValue(a,g){this.j(a,g,!1)}removeValue(a){const g=this.keys.indexOf(a);g!==-1&&(this.keys.splice(g,1),(0,O.$Vi)(this.contents,a),D.$eo.test(a)&&this.overrides.splice(this.overrides.findIndex(v=>k.$ub(v.identifiers,(0,D.$fo)(a))),1))}j(a,g,v){(0,O.$Ui)(this.contents,a,g,f=>console.error(f)),v=v||this.keys.indexOf(a)===-1,v&&this.keys.push(a),D.$eo.test(a)&&this.overrides.push({identifiers:(0,D.$fo)(a),keys:Object.keys(this.contents[a]),contents:(0,O.$Ti)(this.contents[a],f=>console.error(f))})}}e.$ko=$;class n{constructor(a){this.f=a,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new $}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(a,g){if(!d.$5f(a)){const v=this.g(a);this.parseRaw(v,g)}}reparse(a){this.a&&this.parseRaw(this.a,a)}parseRaw(a,g){this.a=a;const{contents:v,keys:f,overrides:u,restricted:E,hasExcludedProperties:w}=this.h(a,g);this.b=new $(v,f,u,w?[a]:void 0),this.c=E||[]}g(a){let g={},v=null,f=[];const u=[],E=[];function w(S){Array.isArray(f)?f.push(S):v!==null&&(f[v]=S)}const I={onObjectBegin:()=>{const S={};w(S),u.push(f),f=S,v=null},onObjectProperty:S=>{v=S},onObjectEnd:()=>{f=u.pop()},onArrayBegin:()=>{const S=[];w(S),u.push(f),f=S,v=null},onArrayEnd:()=>{f=u.pop()},onLiteralValue:w,onError:(S,P,U)=>{E.push({error:S,offset:P,length:U})}};if(a)try{C.$Dn(a,I),g=f[0]||{}}catch(S){console.error(`Error while parsing settings file ${this.f}: ${S}`),this.d=[S]}return g}h(a,g){const v=l.$2n.as(D.$7n.Configuration).getConfigurationProperties(),f=this.i(a,v,!0,g);a=f.raw;const u=(0,O.$Ti)(a,I=>console.error(`Conflict in settings file ${this.f}: ${I}`)),E=Object.keys(a),w=this.j(a,I=>console.error(`Conflict in settings file ${this.f}: ${I}`));return{contents:u,keys:E,overrides:w,restricted:f.restricted,hasExcludedProperties:f.hasExcludedProperties}}i(a,g,v,f){let u=!1;if(!f?.scopes&&!f?.skipRestricted&&!f?.exclude?.length)return{raw:a,restricted:[],hasExcludedProperties:u};const E={},w=[];for(const I in a)if(D.$eo.test(I)&&v){const S=this.i(a[I],g,!1,f);E[I]=S.raw,u=u||S.hasExcludedProperties,w.push(...S.restricted)}else{const S=g[I],P=S?typeof S.scope<"u"?S.scope:3:void 0;S?.restricted&&w.push(I),!f.exclude?.includes(I)&&(f.include?.includes(I)||(P===void 0||f.scopes===void 0||f.scopes.includes(P))&&!(f.skipRestricted&&S?.restricted))?E[I]=a[I]:u=!0}return{raw:E,restricted:w,hasExcludedProperties:u}}j(a,g){const v=[];for(const f of Object.keys(a))if(D.$eo.test(f)){const u={};for(const E in a[f])u[E]=a[f][E];v.push({identifiers:(0,D.$fo)(f),keys:Object.keys(u),contents:(0,O.$Ti)(u,g)})}return v}}e.$lo=n;class o extends N.$Uc{constructor(a,g,v,f){super(),this.c=a,this.f=g,this.g=f,this.b=this.B(new M.$7d),this.onDidChange=this.b.event,this.a=new n(this.c.toString()),this.B(this.g.watch(v.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(M.Event.any(M.Event.filter(this.g.onDidFilesChange,u=>u.contains(this.c)),M.Event.filter(this.g.onDidRunOperation,u=>(u.isOperation(0)||u.isOperation(3)||u.isOperation(1)||u.isOperation(4))&&v.isEqual(u.resource,a)))(()=>this.b.fire()))}async loadConfiguration(){try{const a=await this.g.readFile(this.c);return this.a.parse(a.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new $}}reparse(a){return a&&(this.f=a),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$mo=o;class s{constructor(a,g,v,f,u,E,w,I,S,P,U,Q,H){this.a=a,this.b=g,this.c=v,this.overrideIdentifiers=f,this.d=u,this.f=E,this.g=w,this.h=I,this.i=S,this.j=P,this.k=U,this.l=Q,this.m=H}get value(){return b(this.c)}n(a){return a?.value!==void 0||a?.override!==void 0||a?.overrides!==void 0?a:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class r{constructor(a,g,v,f,u=new $,E=new $,w=new A.$Bc,I=new $,S=new A.$Bc){this.c=a,this.d=g,this.f=v,this.g=f,this.h=u,this.i=E,this.j=w,this.l=I,this.m=S,this.a=null,this.b=new A.$Bc,this.n=null}getValue(a,g,v){return this.p(a,g,v).getValue(a)}updateValue(a,g,v={}){let f;v.resource?(f=this.m.get(v.resource),f||(f=new $,this.m.set(v.resource,f))):f=this.l,g===void 0?f.removeValue(a):f.setValue(a,g),v.resource||(this.a=null)}inspect(a,g,v){const f=this.p(a,g,v),u=this.t(g.resource,v),E=g.resource?this.m.get(g.resource)||this.l:this.l,w=new Set;for(const I of f.overrides)for(const S of I.identifiers)f.getOverrideValue(a,S)!==void 0&&w.add(S);return new s(a,g,f.getValue(a),w.size?[...w]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,v?this.i:void 0,u||void 0,E)}keys(a){const g=this.t(void 0,a);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:g?g.keys.slice(0):[]}}updateDefaultConfiguration(a){this.c=a,this.a=null,this.b.clear()}updatePolicyConfiguration(a){this.d=a}updateApplicationConfiguration(a){this.f=a,this.a=null,this.b.clear()}updateLocalUserConfiguration(a){this.g=a,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(a){this.h=a,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(a){this.i=a,this.a=null,this.b.clear()}updateFolderConfiguration(a,g){this.j.set(a,g),this.b.delete(a)}deleteFolderConfiguration(a){this.folderConfigurations.delete(a),this.b.delete(a)}compareAndUpdateDefaultConfiguration(a,g){const v=[];if(!g){const{added:f,updated:u,removed:E}=h(this.c,a);g=[...f,...u,...E]}for(const f of g)for(const u of(0,D.$fo)(f)){const E=this.c.getKeysForOverrideIdentifier(u),w=a.getKeysForOverrideIdentifier(u),I=[...w.filter(S=>E.indexOf(S)===-1),...E.filter(S=>w.indexOf(S)===-1),...E.filter(S=>!m.$Tn(this.c.override(u).getValue(S),a.override(u).getValue(S)))];v.push([u,I])}return this.updateDefaultConfiguration(a),{keys:g,overrides:v}}compareAndUpdatePolicyConfiguration(a){const{added:g,updated:v,removed:f}=h(this.d,a),u=[...g,...v,...f];return u.length&&this.updatePolicyConfiguration(a),{keys:u,overrides:[]}}compareAndUpdateApplicationConfiguration(a){const{added:g,updated:v,removed:f,overrides:u}=h(this.applicationConfiguration,a),E=[...g,...v,...f];return E.length&&this.updateApplicationConfiguration(a),{keys:E,overrides:u}}compareAndUpdateLocalUserConfiguration(a){const{added:g,updated:v,removed:f,overrides:u}=h(this.localUserConfiguration,a),E=[...g,...v,...f];return E.length&&this.updateLocalUserConfiguration(a),{keys:E,overrides:u}}compareAndUpdateRemoteUserConfiguration(a){const{added:g,updated:v,removed:f,overrides:u}=h(this.remoteUserConfiguration,a),E=[...g,...v,...f];return E.length&&this.updateRemoteUserConfiguration(a),{keys:E,overrides:u}}compareAndUpdateWorkspaceConfiguration(a){const{added:g,updated:v,removed:f,overrides:u}=h(this.workspaceConfiguration,a),E=[...g,...v,...f];return E.length&&this.updateWorkspaceConfiguration(a),{keys:E,overrides:u}}compareAndUpdateFolderConfiguration(a,g){const v=this.folderConfigurations.get(a),{added:f,updated:u,removed:E,overrides:w}=h(v,g),I=[...f,...u,...E];return(I.length||!v)&&this.updateFolderConfiguration(a,g),{keys:I,overrides:w}}compareAndDeleteFolderConfiguration(a){const g=this.folderConfigurations.get(a);if(!g)throw new Error("Unknown folder");this.deleteFolderConfiguration(a);const{added:v,updated:f,removed:u,overrides:E}=h(g,void 0);return{keys:[...v,...f,...u],overrides:E}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(a,g,v){let f=this.q(g,v);return g.overrideIdentifier&&(f=f.override(g.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(a)!==void 0&&(f=f.merge(this.d)),f}q({resource:a},g){let v=this.r();if(g&&a){const f=g.getFolder(a);f&&(v=this.s(f.uri)||v);const u=this.m.get(a);u&&(v=v.merge(u))}return v}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(a){let g=this.b.get(a);if(!g){const v=this.r(),f=this.j.get(a);f?(g=v.merge(f),this.b.set(a,g)):g=v}return g}t(a,g){if(g&&a){const v=g.getFolder(a);if(v)return this.j.get(v.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((a,g)=>{const{contents:v,overrides:f,keys:u}=this.j.get(g);return a.push([g,{contents:v,overrides:f,keys:u}]),a},[])}}allKeys(){const a=new Set;return this.c.keys.forEach(g=>a.add(g)),this.userConfiguration.keys.forEach(g=>a.add(g)),this.i.keys.forEach(g=>a.add(g)),this.j.forEach(g=>g.keys.forEach(v=>a.add(v))),[...a.values()]}u(){const a=new Set;return this.c.getAllOverrideIdentifiers().forEach(g=>a.add(g)),this.userConfiguration.getAllOverrideIdentifiers().forEach(g=>a.add(g)),this.i.getAllOverrideIdentifiers().forEach(g=>a.add(g)),this.j.forEach(g=>g.getAllOverrideIdentifiers().forEach(v=>a.add(v))),[...a.values()]}v(a){const g=new Set;return this.c.getKeysForOverrideIdentifier(a).forEach(v=>g.add(v)),this.userConfiguration.getKeysForOverrideIdentifier(a).forEach(v=>g.add(v)),this.i.getKeysForOverrideIdentifier(a).forEach(v=>g.add(v)),this.j.forEach(v=>v.getKeysForOverrideIdentifier(a).forEach(f=>g.add(f))),[...g.values()]}static parse(a){const g=this.w(a.defaults),v=this.w(a.policy),f=this.w(a.application),u=this.w(a.user),E=this.w(a.workspace),w=a.folders.reduce((I,S)=>(I.set(y.URI.revive(S[0]),this.w(S[1])),I),new A.$Bc);return new r(g,v,f,u,new $,E,w,new $,new A.$Bc)}static w(a){return new $(a.contents,a.keys,a.overrides)}}e.$no=r;function i(...p){if(p.length===0)return{keys:[],overrides:[]};if(p.length===1)return p[0];const a=new Set,g=new Map;for(const f of p)f.keys.forEach(u=>a.add(u)),f.overrides.forEach(([u,E])=>{const w=(0,A.$yc)(g,u,new Set);E.forEach(I=>w.add(I))});const v=[];return g.forEach((f,u)=>v.push([u,[...f.values()]])),{keys:[...a.values()],overrides:v}}class c{constructor(a,g,v,f){this.change=a,this.f=g,this.g=v,this.h=f,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.i=void 0;for(const u of a.keys)this.affectedKeys.add(u);for(const[,u]of a.overrides)for(const E of u)this.affectedKeys.add(E);this.d=this.a;for(const u of this.affectedKeys)this.d+=u+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=r.parse(this.f.data)),this.i}affectsConfiguration(a,g){const v=this.a+a,f=this.d.indexOf(v);if(f<0)return!1;const u=f+v.length;if(u>=this.d.length)return!1;const E=this.d.charCodeAt(u);if(E!==this.b&&E!==this.c)return!1;if(g){const w=this.previousConfiguration?this.previousConfiguration.getValue(a,g,this.f?.workspace):void 0,I=this.g.getValue(a,g,this.h);return!m.$Tn(w,I)}return!0}}e.$po=c;function h(p,a){const{added:g,removed:v,updated:f}=t(a?.rawConfiguration,p?.rawConfiguration),u=[],E=p?.getAllOverrideIdentifiers()||[],w=a?.getAllOverrideIdentifiers()||[];if(a){const I=w.filter(S=>!E.includes(S));for(const S of I)u.push([S,a.getKeysForOverrideIdentifier(S)])}if(p){const I=E.filter(S=>!w.includes(S));for(const S of I)u.push([S,p.getKeysForOverrideIdentifier(S)])}if(a&&p){for(const I of E)if(w.includes(I)){const S=t({contents:p.getOverrideValue(void 0,I)||{},keys:p.getKeysForOverrideIdentifier(I)},{contents:a.getOverrideValue(void 0,I)||{},keys:a.getKeysForOverrideIdentifier(I)});u.push([I,[...S.added,...S.removed,...S.updated]])}}return{added:g,removed:v,updated:f,overrides:u}}function t(p,a){const g=p?a?p.keys.filter(u=>a.keys.indexOf(u)===-1):[...p.keys]:[],v=a?p?a.keys.filter(u=>p.keys.indexOf(u)===-1):[...a.keys]:[],f=[];if(p&&a){for(const u of a.keys)if(p.keys.indexOf(u)!==-1){const E=(0,O.$Wi)(a.contents,u),w=(0,O.$Wi)(p.contents,u);m.$Tn(E,w)||f.push(u)}}return{added:g,removed:v,updated:f}}}),define(Pe[102],Re([1,0,14,3]),function(ee,e,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wl=e.RemoteAuthorityResolverErrorCode=e.$vl=e.$ul=e.RemoteConnectionType=e.$tl=void 0,e.$xl=y,e.$tl=(0,M.$ii)("remoteAuthorityResolverService");var C;(function(O){O[O.WebSocket=0]="WebSocket",O[O.Managed=1]="Managed"})(C||(e.RemoteConnectionType=C={}));class N{constructor(D){this.id=D,this.type=1}toString(){return`Managed(${this.id})`}}e.$ul=N;class A{constructor(D,l){this.host=D,this.port=l,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$vl=A;var m;(function(O){O.Unknown="Unknown",O.NotAvailable="NotAvailable",O.TemporarilyNotAvailable="TemporarilyNotAvailable",O.NoResolverFound="NoResolverFound",O.InvalidAuthority="InvalidAuthority"})(m||(e.RemoteAuthorityResolverErrorCode=m={}));class d extends k.$bb{static isNotAvailable(D){return D instanceof d&&D._code===m.NotAvailable}static isTemporarilyNotAvailable(D){return D instanceof d&&D._code===m.TemporarilyNotAvailable}static isNoResolverFound(D){return D instanceof d&&D._code===m.NoResolverFound}static isInvalidAuthority(D){return D instanceof d&&D._code===m.InvalidAuthority}static isHandled(D){return D instanceof d&&D.isHandled}constructor(D,l=m.Unknown,b){super(D),this._message=D,this._code=l,this._detail=b,this.isHandled=l===m.NotAvailable&&b===!0,Object.setPrototypeOf(this,d.prototype)}}e.$wl=d;function y(O){const D=O.indexOf("+");return D===-1?O:O.substring(0,D)}}),define(Pe[58],Re([1,0,12]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$um=M,e.$vm=C,e.$wm=N,e.$xm=A;function M(d){return d.scheme===k.Schemas.vscodeRemote?d.authority:void 0}function C(d){if(!d)return;const y=d.indexOf("+");return y<0?d:d.substr(0,y)}function N(d){const{host:y,port:O}=m(d);if(typeof O>"u")throw new Error(`Invalid remote authority: ${d}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:y,port:O}}function A(d,y){let{host:O,port:D}=m(d);return typeof D>"u"&&(D=y),{host:O,port:D}}function m(d){const y=d.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(y)return{host:y[1],port:parseInt(y[2],10)};const O=d.match(/^(\[[0-9a-z:]+\])$/);if(O)return{host:O[1],port:void 0};const D=d.match(/(.*):(\d+)$/);return D?{host:D[1],port:parseInt(D[2],10)}:{host:d,port:void 0}}}),define(Pe[20],Re([1,0,15,3,58]),function(ee,e,k,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lm=e.$Gm=e.$Fm=e.$Em=e.TargetPlatform=e.ExtensionType=e.$Dm=e.$Bm=e.$Am=e.$zm=e.$ym=void 0,e.$Cm=N,e.$Hm=D,e.$Im=l,e.$Jm=b,e.$Km=$,e.$ym="extensions.user.cache",e.$zm="extensions.builtin.cache",e.$Am="undefined_publisher",e.$Bm=["ui","workspace","web"];function N(n){if(typeof n=="object"&&n!==null&&n.supported!==!0)return n.description}e.$Dm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var A;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(A||(e.ExtensionType=A={}));var m;(function(n){n.WIN32_X64="win32-x64",n.WIN32_ARM64="win32-arm64",n.LINUX_X64="linux-x64",n.LINUX_ARM64="linux-arm64",n.LINUX_ARMHF="linux-armhf",n.ALPINE_X64="alpine-x64",n.ALPINE_ARM64="alpine-arm64",n.DARWIN_X64="darwin-x64",n.DARWIN_ARM64="darwin-arm64",n.WEB="web",n.UNIVERSAL="universal",n.UNKNOWN="unknown",n.UNDEFINED="undefined"})(m||(e.TargetPlatform=m={}));class d{constructor(o){this.value=o,this._lower=o.toLowerCase()}static equals(o,s){if(typeof o>"u"||o===null)return typeof s>"u"||s===null;if(typeof s>"u"||s===null)return!1;if(typeof o=="string"||typeof s=="string"){const r=typeof o=="string"?o:o.value,i=typeof s=="string"?s:s.value;return k.$lf(r,i)}return o._lower===s._lower}static toKey(o){return typeof o=="string"?o.toLowerCase():o._lower}}e.$Em=d;class y{get size(){return this.c.size}constructor(o){if(this.c=new Set,o)for(const s of o)this.add(s)}add(o){this.c.add(d.toKey(o))}delete(o){return this.c.delete(d.toKey(o))}has(o){return this.c.has(d.toKey(o))}}e.$Fm=y;class O{constructor(){this.c=new Map}clear(){this.c.clear()}delete(o){this.c.delete(d.toKey(o))}get(o){return this.c.get(d.toKey(o))}has(o){return this.c.has(d.toKey(o))}set(o,s){this.c.set(d.toKey(o),s)}values(){return this.c.values()}forEach(o){this.c.forEach(o)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Gm=O;function D(n){return l(n)}function l(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}function b(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}function $(n,o){if(o){const s=`onResolveRemoteAuthority:${(0,C.$vm)(o)}`;return!!n.activationEvents?.includes(s)}return!1}e.$Lm=(0,M.$ii)("IBuiltinExtensionsScannerService")}),define(Pe[103],Re([1,0,14,20]),function(ee,e,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UF=e.$TF=void 0;class C{constructor(){this.a=new Map,this.b=new WeakMap}register(A,m){this.a.set(A,m)}readActivationEvents(A){return this.b.has(A)||this.b.set(A,this.c(A)),this.b.get(A)}createActivationEventsMap(A){const m=Object.create(null);for(const d of A){const y=this.readActivationEvents(d);y.length>0&&(m[M.$Em.toKey(d.identifier)]=y)}return m}c(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const m=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];for(let d=0;d<m.length;d++)m[d]==="onUri"&&(m[d]=`onUri:${M.$Em.toKey(A.identifier)}`);if(!A.contributes)return m;for(const d in A.contributes){const y=this.a.get(d);if(!y)continue;const O=A.contributes[d],D=Array.isArray(O)?O:[O];try{y(D,m)}catch(l){(0,k.$1)(l)}}return m}}e.$TF=C,e.$UF=new C}),define(Pe[197],Re([1,0,21,73,35]),function(ee,e,k,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3o=A,e.$4o=m;function N(d){if(k.$o===2&&/^penguin(\.|$)/i.test(d))return"chromebook"}function A(d,y,O,D,l,b,$,n,o){const s=Object.create(null);s["common.machineId"]=b,s["common.sqmId"]=$,s.sessionID=(0,C.$Eg)()+Date.now(),s.commitHash=D,s.version=l,s["common.platformVersion"]=(d||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),s["common.platform"]=(0,k.$b)(k.$o),s["common.nodePlatform"]=M.$ec,s["common.nodeArch"]=O,s["common.product"]=o||"desktop",n&&(s["common.msftInternal"]=n);let r=0;const i=Date.now();Object.defineProperties(s,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-i,enumerable:!0},"common.sequence":{get:()=>r++,enumerable:!0}}),k.$f&&(s["common.snap"]="true");const c=N(y);return c&&(s["common.platformDetail"]=c),s}function m(d){const y=M.env.USERDNSDOMAIN;if(!y)return!1;const O=y.toLowerCase();return d.some(D=>O===D)}}),define(Pe[198],Re([1,0,3]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Xl=e.$Wl=e.$Vl=e.$Ul=e.$Tl=e.$Sl=e.$Rl=e.$Ql=e.$Pl=e.$Ol=e.$Nl=void 0,e.$Nl=(0,k.$ii)("telemetryService"),e.$Ol=(0,k.$ii)("customEndpointTelemetryService"),e.$Pl="telemetry.currentSessionDate",e.$Ql="telemetry.firstSessionDate",e.$Rl="telemetry.lastSessionDate",e.$Sl="telemetry.machineId",e.$Tl="telemetry.sqmId",e.$Ul="telemetry",e.$Vl="telemetry.telemetryLevel",e.$Wl="telemetry.enableCrashReporter",e.$Xl="telemetry.enableTelemetry";var M;(function(N){N[N.NONE=0]="NONE",N[N.CRASH=1]="CRASH",N[N.ERROR=2]="ERROR",N[N.USAGE=3]="USAGE"})(M||(e.TelemetryLevel=M={}));var C;(function(N){N.OFF="off",N.CRASH="crash",N.ERROR="error",N.ON="all"})(C||(e.TelemetryConfiguration=C={}))}),define(Pe[59],Re([1,0,26,17,58,197,198]),function(ee,e,k,M,C,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=void 0,e.$_o=O,e.$ap=D,e.$bp=l,e.$cp=b,e.$dp=n,e.$ep=s,e.$fp=r,e.$gp=h;class m{constructor(p){this.value=p,this.isTrustedTelemetryValue=!0}}e.$5o=m;class d{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$6o=d,e.$7o=new d;class y{async publicLog(p,a,g){}async publicLogError(p,a,g){}}e.$8o=y,e.$9o="telemetry",e.$0o="extensionTelemetryLog",e.$$o={log:()=>null,flush:()=>Promise.resolve(null)};function O(t,p){return!p.isBuilt&&!p.disableTelemetry?!0:!(p.disableTelemetry||!t.enableTelemetry)}function D(t,p){return p.extensionTestsLocationURI?!0:!(p.isBuilt||p.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function l(t){const p=t.getValue(A.$Vl),a=t.getValue(A.$Wl);if(t.getValue(A.$Xl)===!1||a===!1)return 0;switch(p??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function b(t){const p={},a={},g={};o(t,g);for(let v in g){v=v.length>150?v.substr(v.length-149):v;const f=g[v];typeof f=="number"?a[v]=f:typeof f=="boolean"?a[v]=f?1:0:typeof f=="string"?(f.length>8192&&console.warn(`Telemetry property: ${v} has been trimmed to 8192, the original length is ${f.length}`),p[v]=f.substring(0,8191)):typeof f<"u"&&f!==null&&(p[v]=f)}return{properties:p,measurements:a}}const $=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function n(t){if(!t)return"none";const p=(0,C.$vm)(t);return $.has(p)?p:"other"}function o(t,p,a=0,g){if(t)for(const v of Object.getOwnPropertyNames(t)){const f=t[v],u=g?g+v:v;Array.isArray(f)?p[u]=(0,k.$Un)(f):f instanceof Date?p[u]=f.toISOString():(0,M.$Xf)(f)?a<2?o(f,p,a+1,u+"."):p[u]=(0,k.$Un)(f):p[u]=f}}function s(t,p){const a=t.msftInternalDomains||[],g=p.getValue("telemetry.internalTesting");return(0,N.$4o)(a)||g}function r(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function i(t,p){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let a=t;const g=[];for(const E of p)for(;;){const w=E.exec(t);if(!w)break;g.push([w.index,E.lastIndex])}const v=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,f=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let u=0;for(a="";;){const E=f.exec(t);if(!E)break;const w=g.some(([I,S])=>E.index<S&&I<f.lastIndex);!v.test(E[0])&&!w&&(a+=t.substring(u,E.index)+"<REDACTED: user-file-path>",u=f.lastIndex)}return u<t.length&&(a+=t.substr(u)),a}function c(t){if(!t)return t;const p=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const a of p)if(a.regex.test(t))return`<REDACTED: ${a.label}>`;return t}function h(t,p){return(0,k.$Rn)(t,a=>{if(a instanceof m||Object.hasOwnProperty.call(a,"isTrustedTelemetryValue"))return a.value;if(typeof a=="string"){let g=a.replaceAll("%20"," ");g=i(g,p);for(const v of p)g=g.replace(v,"");return g=c(g),g}})}}),define(Pe[199],Re([1,0,15,98,20,21,2,14,73,59]),function(ee,e,k,M,C,N,A,m,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qp=e.$ip=void 0,e.$hp=O,e.$jp=$,e.$kp=n,e.$lp=o,e.$mp=s,e.$np=r,e.$op=i,e.$pp=c,e.$rp=h,e.$sp=p;function O(a,g){return a.uuid&&g.uuid?a.uuid===g.uuid:a.id===g.id?!0:(0,k.$gf)(a.id,g.id)===0}const D=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class l{static create(g){const v=g.manifest?g.manifest.version:g.version,f=g.manifest?g.targetPlatform:g.properties.targetPlatform;return new l(g.identifier,v,f)}static parse(g){const v=D.exec(g);return v&&v[1]&&v[2]?new l({id:v[1]},v[2],v[4]||void 0):null}constructor(g,v,f="undefined"){this.version=v,this.targetPlatform=f,this.id=g.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(g){return g instanceof l?O(this,g)&&this.version===g.version&&this.targetPlatform===g.targetPlatform:!1}}e.$ip=l;const b=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function $(a){const g=b.exec(a);return g&&g[1]?[o(g[1]),g[2]]:[o(a),void 0]}function n(a,g){return`${a}.${g}`}function o(a){return a.toLowerCase()}function s(a,g){return o(n(a??C.$Am,g))}function r(a,g){const v=[],f=u=>{for(const E of v)if(E.some(w=>O(g(w),g(u))))return E;return null};for(const u of a){const E=f(u);E?E.push(u):v.push([u])}return v}function i(a){return{id:a.identifier.id,name:a.manifest.name,galleryId:null,publisherId:a.publisherId,publisherName:a.manifest.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:a.manifest.extensionDependencies&&a.manifest.extensionDependencies.length>0}}function c(a){return{id:new y.$5o(a.identifier.id),name:new y.$5o(a.name),galleryId:a.identifier.uuid,publisherId:a.publisherId,publisherName:a.publisher,publisherDisplayName:a.publisherDisplayName,isPreReleaseVersion:a.properties.isPreReleaseVersion,dependencies:!!(a.properties.dependencies&&a.properties.dependencies.length>0),isSigned:a.isSigned,...a.telemetryData}}e.$qp=new C.$Em("pprice.better-merge");function h(a,g){const v=[],f=g.manifest.extensionDependencies?.slice(0)??[];for(;f.length;){const u=f.shift();if(u&&v.every(E=>!O(E.identifier,{id:u}))){const E=a.filter(w=>O(w.identifier,{id:u}));E.length===1&&(v.push(E[0]),f.push(...E[0].manifest.extensionDependencies?.slice(0)??[]))}}return v}async function t(a,g){if(!N.$e)return!1;let v;try{v=(await a.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{v=(await a.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(u){g.debug("Error while getting the os-release file.",(0,m.$0)(u))}}return!!v&&(v.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function p(a,g){const v=await t(a,g),f=(0,M.$Oo)(v?"alpine":N.$o,d.$fc);return g.debug("ComputeTargetPlatform:",f),f}}),define(Pe[200],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8r=k,e.$9r=M,e.$0r=C,e.$$r=N,e.$_r=A,e.$as=m;function k(d){return[...d.entries()]}function M(d){return d?[...d.entries()]:[]}function C(d){return new Map(d)}function N(d){return new Map(d??[])}function A(d){return Array.from(d.entries()).map(y=>[y[0],k(y[1].map),M(y[1].descriptionMap)])}function m(d){return new Map(d.map(y=>[y[0],{map:C(y[1]),descriptionMap:N(y[2])}]))}}),define(Pe[201],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xub=void 0;class k{constructor(C){this.b=C,this.a=new Map}dispose(){for(const C of this.a.values())C.dispose()}startBuffering(C,N,A=5){const m=N(d=>{const y=typeof d=="string"?d:d.data;let O=this.a.get(C);if(O){O.data.push(y);return}const D=setTimeout(()=>this.flushBuffer(C),A);O={data:[y],timeoutId:D,dispose:()=>{clearTimeout(D),this.flushBuffer(C),m.dispose()}},this.a.set(C,O)});return m}stopBuffering(C){this.a.get(C)?.dispose()}flushBuffer(C){const N=this.a.get(C);N&&(this.a.delete(C),this.b(C,N.data.join("")))}}e.$xub=k}),define(Pe[202],Re([1,0,11,91,302,41,5,17,2,161,72,30]),function(ee,e,k,M,C,N,A,m,d,y,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3w=e.$2w=e.$1w=e.$Zw=e.$Yw=e.$Xw=e.IconFontDefinition=e.IconContribution=e.$Uw=void 0,e.$Vw=o,e.$Ww=s,e.$Uw={IconContribution:"base.contributions.icons"};var l;(function(h){function t(p,a){let g=p.defaults;for(;N.ThemeIcon.isThemeIcon(g);){const v=n.getIcon(g.id);if(!v)return;g=v.defaults}return g}h.getDefinition=t})(l||(e.IconContribution=l={}));var b;(function(h){function t(a){return{weight:a.weight,style:a.style,src:a.src.map(g=>({format:g.format,location:g.location.toString()}))}}h.toJSONObject=t;function p(a){const g=v=>(0,m.$Vf)(v)?v:void 0;if(a&&Array.isArray(a.src)&&a.src.every(v=>(0,m.$Vf)(v.format)&&(0,m.$Vf)(v.location)))return{weight:g(a.weight),style:g(a.style),src:a.src.map(v=>({format:v.format,location:d.URI.parse(v.location)}))}}h.fromJSONObject=p})(b||(e.IconFontDefinition=b={}));class ${constructor(){this.a=new A.$7d,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,y.localize)(0,null)},fontCharacter:{type:"string",description:(0,y.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${N.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(t,p,a,g){const v=this.b[t];if(v){if(a&&!v.description){v.description=a,this.d.properties[t].markdownDescription=`${a} $(${t})`;const E=this.e.enum.indexOf(t);E!==-1&&(this.e.enumDescriptions[E]=a),this.a.fire()}return v}const f={id:t,description:a,defaults:p,deprecationMessage:g};this.b[t]=f;const u={$ref:"#/definitions/icons"};return g&&(u.deprecationMessage=g),a&&(u.markdownDescription=`${a}: $(${t})`),this.d.properties[t]=u,this.e.enum.push(t),this.e.enumDescriptions.push(a||""),this.a.fire(),{id:t}}deregisterIcon(t){delete this.b[t],delete this.d.properties[t];const p=this.e.enum.indexOf(t);p!==-1&&(this.e.enum.splice(p,1),this.e.enumDescriptions.splice(p,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(t=>this.b[t])}getIcon(t){return this.b[t]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(t,p){const a=this.f[t];return a||(this.f[t]=p,this.a.fire(),p)}deregisterIconFont(t){delete this.f[t]}getIconFont(t){return this.f[t]}toString(){const t=(v,f)=>v.id.localeCompare(f.id),p=v=>{for(;N.ThemeIcon.isThemeIcon(v.defaults);)v=this.b[v.defaults.id];return`codicon codicon-${v?v.id:""}`},a=[];a.push("| preview     | identifier                        | default codicon ID                | description"),a.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const g=Object.keys(this.b).map(v=>this.b[v]);for(const v of g.filter(f=>!!f.description).sort(t))a.push(`|<i class="${p(v)}"></i>|${v.id}|${N.ThemeIcon.isThemeIcon(v.defaults)?v.defaults.id:v.id}|${v.description||""}|`);a.push("| preview     | identifier                        "),a.push("| ----------- | --------------------------------- |");for(const v of g.filter(f=>!N.ThemeIcon.isThemeIcon(f.defaults)).sort(t))a.push(`|<i class="${p(v)}"></i>|${v.id}|`);return a.join(`
`)}}const n=new $;D.$2n.add(e.$Uw.IconContribution,n);function o(h,t,p,a){return n.registerIcon(h,t,p,a)}function s(){return n}function r(){const h=(0,C.$Dj)();for(const t in h){const p="\\"+h[t].toString(16);n.registerIcon(t,{fontCharacter:p})}}r(),e.$Xw="vscode://schemas/icons";const i=D.$2n.as(O.$3n.JSONContribution);i.registerSchema(e.$Xw,n.getIconSchema());const c=new k.$uh(()=>i.notifySchemaChanged(e.$Xw),200);n.onDidChange(()=>{c.isScheduled()||c.schedule()}),e.$Yw=o("widget-close",M.$Hj.close,(0,y.localize)(2,null)),e.$Zw=o("goto-previous-location",M.$Hj.arrowUp,(0,y.localize)(3,null)),e.$1w=o("goto-next-location",M.$Hj.arrowDown,(0,y.localize)(4,null)),e.$2w=N.ThemeIcon.modify(M.$Hj.sync,"spin"),e.$3w=N.ThemeIcon.modify(M.$Hj.loading,"spin")}),define(Pe[203],Re([1,0,5,2,47,3,13]),function(ee,e,k,M,C,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9v=e.$8v=e.$5v=e.$3v=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$Yv=e.$Xv=void 0,e.$Zv=y,e.$1v=D,e.$2v=l,e.$4v=b,e.$6v=$,e.$7v=n,e.$Xv=(0,N.$ii)("tunnelService"),e.$Yv=(0,N.$ii)("sharedTunnelsService");var m;(function(r){r.Http="http",r.Https="https"})(m||(e.TunnelProtocol=m={}));var d;(function(r){r.ConstantPrivate="constantPrivate",r.Private="private",r.Public="public"})(d||(e.TunnelPrivacyId=d={}));function y(r){return!!r.forwardPort}var O;(function(r){r[r.Notify=1]="Notify",r[r.OpenBrowser=2]="OpenBrowser",r[r.OpenPreview=3]="OpenPreview",r[r.Silent=4]="Silent",r[r.Ignore=5]="Ignore",r[r.OpenBrowserOnce=6]="OpenBrowserOnce"})(O||(e.ProvidedOnAutoForward=O={}));function D(r){if(r.scheme!=="http"&&r.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(r.authority);if(i)return{address:i[1],port:+i[2]}}function l(r){if(r.scheme!=="http"&&r.scheme!=="https"||!r.query)return;const i=r.query.split("&");for(const c of i){const h=c.split("=")[1];if(/^https?:/.exec(h)){const t=D(M.URI.parse(h));if(t)return t}}}e.$3v=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function b(r){return e.$3v.indexOf(r)>=0}e.$5v=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function $(r){return e.$5v.indexOf(r)>=0}function n(r,i,c,h){if(c===1)return!1;if(c===2&&$(i)){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(h);if(t?.length===4&&parseInt(t[1])>=18)return!1}return r<1024}class o{constructor(i,c,h){this.remoteAddress=i,this.localAddress=c,this.b=h,this.a=new k.$7d,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$8v=o;let s=class{constructor(i,c){this.k=i,this.l=c,this.a=new k.$7d,this.onTunnelOpened=this.a.event,this.b=new k.$7d,this.onTunnelClosed=this.b.event,this.c=new k.$7d,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const i=this.l.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.f=i,i?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.g=i.elevation,this.i=i.privacyOptions,this.h=i.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const i=[],c=Array.from(this.e.values());for(const h of c){const t=Array.from(h.values());for(const p of t){const a=await p.value;a&&typeof a!="string"&&i.push(a)}}return i}async dispose(){for(const i of this.e.values()){for(const{value:c}of i.values())await c.then(h=>typeof h!="string"?h?.dispose():void 0);i.clear()}this.e.clear()}setEnvironmentTunnel(i,c,h,t,p){this.q(i,c,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:c,localAddress:h,privacy:t,protocol:p,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,c){($(i)||b(i))&&(i=e.$3v[0]);const h=this.s(i,c);if(h)return++h.refcount,h.value}openTunnel(i,c,h,t,p,a=!1,g,v){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${c}:${h} on local port ${p}.`);const f=this.f??i;if(!f)return;if(c||(c="localhost"),t||(t=this.m),this.f&&this.j.has(h)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const u=this.t(f,c,h,t,p,a,g,v);return u?u.then(E=>{if(E){if(typeof E=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(c,h),E}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(c,h);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const w=this.o(E);return(E.tunnelRemoteHost!==c||E.tunnelRemotePort!==h)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),g&&E.privacy!==g&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(w),w}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),u)}o(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const c=this.e.get(i.tunnelRemoteHost);if(c){const h=c.get(i.tunnelRemotePort);h&&(h.refcount--,await this.p(i.tunnelRemoteHost,i.tunnelRemotePort,h))}}}}async p(i,c,h){if(h.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${c}.`);const t=h.value.then(async p=>{p&&typeof p!="string"&&(await p.dispose(!0),this.b.fire({host:p.tunnelRemoteHost,port:p.tunnelRemotePort}))});return this.e.has(i)&&this.e.get(i).delete(c),t}}async closeTunnel(i,c){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${c} `);const h=this.e.get(i);if(h&&h.has(c)){const t=h.get(c);t.refcount=0,await this.p(i,c,t)}}q(i,c,h){this.e.has(i)||this.e.set(i,new Map),this.e.get(i).set(c,{refcount:1,value:h})}async r(i,c){const h=this.e.get(i);if(h){const t=h.get(c),p=t?await t.value:void 0;(!p||typeof p=="string")&&h.delete(c),h.size===0&&this.e.delete(i)}}s(i,c){const h=[i];b(i)?(h.push(...e.$3v),h.push(...e.$5v)):$(i)&&h.push(...e.$5v);const t=h.map(p=>this.e.get(p));for(const p of t){const a=p?.get(c);if(a)return a}}canTunnel(i){return!!D(i)}u(i,c,h,t,p,a,g){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${c}:${h} on local port ${t}.`);const v=h;this.j.add(v);const f=t===void 0?h:t,u={elevationRequired:p?this.isPortPrivileged(f):!1},E={remoteAddress:{host:c,port:h},localAddressPort:t,privacy:a,public:a?a!==d.Private:void 0,protocol:g},w=i.forwardPort(E,u);return w?(this.q(c,h,w),w.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(v)})):this.j.delete(v),w}};e.$9v=s,e.$9v=s=Xe([qe(0,A.$Oj),qe(1,C.$Oi)],s)}),define(Pe[204],Re([1,0,3]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$0v=void 0,e.$0v=(0,k.$ii)("editSessionIdentityService");var M;(function(C){C[C.Complete=100]="Complete",C[C.Partial=50]="Partial",C[C.None=0]="None"})(M||(e.EditSessionIdentityMatch=M={}))}),define(Pe[205],Re([1,0,12]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2L=M,e.$3L=C,e.$4L=N,e.$5L=A,e.$6L=m;function M(d){return d.scheme!==k.Schemas.file&&d.scheme!==k.Schemas.vscodeRemote}function C(d){if(d.folders.length)return d.folders.every(y=>M(y.uri))?d.folders[0].uri:void 0;if(d.configuration&&M(d.configuration))return d.configuration}function N(d){return C(d)?.scheme}function A(d){return C(d)?.authority}function m(d){return C(d)!==void 0}}),define(Pe[48],Re([1,0,162,19,52,23,2,3,12]),function(ee,e,k,M,C,N,A,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Ci=e.$Bi=e.WorkbenchState=e.$vi=e.$ui=e.$ri=void 0,e.$si=y,e.$ti=O,e.$wi=D,e.$xi=l,e.$yi=b,e.$zi=n,e.$Ai=o,e.$Di=i,e.$Ii=c,e.$Ji=h,e.$Li=t,e.$Mi=p,e.$Ni=a,e.$ri=(0,m.$ii)("contextService");function y(g){const v=g;return typeof v?.id=="string"&&A.URI.isUri(v.uri)}function O(g){return typeof g?.id=="string"&&!y(g)&&!l(g)}e.$ui={id:"ext-dev"},e.$vi={id:"empty-window"};function D(g,v){if(typeof g=="string"||typeof g>"u")return typeof g=="string"?{id:(0,M.$oc)(g)}:v?e.$ui:e.$vi;const f=g;return f.configuration?{id:f.id,configPath:f.configuration}:f.folders.length===1?{id:f.id,uri:f.folders[0].uri}:{id:f.id}}function l(g){const v=g;return typeof v?.id=="string"&&A.URI.isUri(v.configPath)}function b(g){const v=g;if(v?.uri)return{id:v.id,uri:A.URI.revive(v.uri)};const f=g;if(f?.configPath)return{id:f.id,configPath:A.URI.revive(f.configPath)};if(g?.id)return{id:g.id}}var $;(function(g){g[g.EMPTY=1]="EMPTY",g[g.FOLDER=2]="FOLDER",g[g.WORKSPACE=3]="WORKSPACE"})($||(e.WorkbenchState=$={}));function n(g){const v=g;return!!(v&&typeof v=="object"&&typeof v.id=="string"&&Array.isArray(v.folders))}function o(g){const v=g;return!!(v&&typeof v=="object"&&A.URI.isUri(v.uri)&&typeof v.name=="string"&&typeof v.toResource=="function")}class s{constructor(v,f,u,E,w){this.h=v,this.j=u,this.k=E,this.l=w,this.c=C.$oi.forUris(this.l,()=>!0),this.folders=f}update(v){this.h=v.id,this.k=v.configuration,this.j=v.transient,this.l=v.l,this.folders=v.folders}get folders(){return this.g}set folders(v){this.g=v,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(v){this.k=v}getFolder(v){return v&&this.c.findSubstr(v)||null}n(){this.c=C.$oi.forUris(this.l,()=>!0);for(const v of this.folders)this.c.set(v.uri,v)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Bi=s;class r{constructor(v,f){this.raw=f,this.uri=v.uri,this.index=v.index,this.name=v.name}toResource(v){return(0,N.$Vg)(this.uri,v)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Ci=r;function i(g){return new r({uri:g,index:0,name:(0,N.$Rg)(g)},{uri:g.toString()})}e.$Ei="code-workspace",e.$Fi=`.${e.$Ei}`,e.$Gi=[{name:(0,k.localize)(0,null),extensions:[e.$Ei]}],e.$Hi="workspace.json";function c(g,v){return N.$Mg.isEqualOrParent(g,v.untitledWorkspacesHome)}function h(g){let v;return A.URI.isUri(g)?v=g:v=g.configuration,v?.scheme===d.Schemas.tmp}e.$Ki="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(g){return g.id===e.$Ki}function p(g,v){return!c(g,v)&&!h(g)}function a(g){return(typeof g=="string"?(0,M.$pc)(g):(0,N.$Tg)(g))===e.$Fi}}),define(Pe[74],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xjc=void 0;class k{constructor(C){this.d=C,this.b=new Map,this.c=1}add(C){const N=this.c++;return this.b.set(N,C),this.e(),N}get(C,N){return this.b.has(C)?this.b.get(C)[N]:void 0}delete(C){this.b.delete(C),this.e()}e(){k.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$xjc=k,k.a=!1}),define(Pe[44],Re([1,0,12,23,3]),function(ee,e,k,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Djc=e.$Cjc=void 0;class N{constructor(){this.a=new Set(Object.keys(k.Schemas)),this.b=new Map,this.extUri=new M.$Kg(m=>{const d=this.b.get(m.scheme);return!(d===void 0||d&1024)})}$acceptProviderInfos(m,d){d===null?this.b.delete(m.scheme):this.b.set(m.scheme,d)}isFreeScheme(m){return!this.b.has(m)&&!this.a.has(m)}getCapabilities(m){return this.b.get(m)}}e.$Cjc=N,e.$Djc=(0,C.$ii)("IExtHostFileSystemInfo")}),define(Pe[27],Re([1,0,3]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5O=void 0,e.$5O=(0,k.$ii)("IExtHostInitDataService")}),define(Pe[206],Re([1,0,168,13,193,27]),function(ee,e,k,M,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Llc=void 0;let A=class extends C.$bQ{constructor(d,y,O){const D=O.remote.isRemote?"remoteexthost":d?"workerexthost":"exthost",l=O.remote.isRemote?(0,k.localize)(0,null):d?(0,k.localize)(1,null):(0,k.localize)(2,null);super(y.createLogger(D,{name:l}))}};e.$Llc=A,e.$Llc=A=Xe([qe(1,M.$Pj),qe(2,N.$5O)],A)}),define(Pe[207],Re([1,0,11]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mkc=e.$lkc=void 0;class M{constructor(A,m,d){this.h=new Map,this.a=A,this.b=m,this.c=d,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(y=>(this.f=y,this)),this.g=this.c.onDidChangeStorage(y=>{y.shared===this.b&&y.key===this.a&&(this.f=y.value)}),this.i=new k.$uh(()=>{const y=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const O of y.values())O.complete()}catch(O){for(const D of y.values())D.error(O)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this.d}get(A,m){let d=this.f[A];return typeof d>"u"&&(d=m),d}update(A,m){this.f[A]=m;const d=this.h.get(A);if(d!==void 0)return d.p;const y=new k.$Fh;return this.h.set(A,y),this.i.isScheduled()||this.i.schedule(),y.p}dispose(){this.g.dispose()}}e.$lkc=M;class C extends M{setKeysForSync(A){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},A)}constructor(A,m){super(A.identifier.value,!0,m),this.j=A}}e.$mkc=C}),define(Pe[208],Re([1,0,5,2]),function(ee,e,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_kc=void 0;class C{constructor(A){this.c=A,this.a=new k.$7d,this.onDidSaveNotebookDocument=this.a.event,this.b=new k.$7d,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(A,m,d,y){const D=this.c.getNotebookDocument(M.URI.revive(A)).acceptModelChanged(m.value,d,y);this.b.fire(D)}$acceptDirtyStateChanged(A,m){this.c.getNotebookDocument(M.URI.revive(A)).acceptDirty(m)}$acceptModelSaved(A){const m=this.c.getNotebookDocument(M.URI.revive(A));this.a.fire(m.apiNotebook)}}e.$_kc=C}),define(Pe[16],Re([1,0,3]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PO=e.$OO=void 0,e.$OO=(0,k.$ii)("IExtHostRpcService");class M{constructor(N){this.getProxy=N.getProxy.bind(N),this.set=N.set.bind(N),this.dispose=N.dispose.bind(N),this.assertRegistered=N.assertRegistered.bind(N),this.drain=N.drain.bind(N)}}e.$PO=M});var _e=this&&this.__classPrivateFieldSet||function(ee,e,k,M,C){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?C.call(ee,k):C?C.value=k:e.set(ee,k),k},Ve=this&&this.__classPrivateFieldGet||function(ee,e,k,M){if(k==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!M:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return k==="m"?M:k==="a"?M.call(ee):M?M.value:e.get(ee)};define(Pe[209],Re([1,0,20,5]),function(ee,e,k,M){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.$tkc=void 0;class N{constructor(m,d){C.set(this,void 0),this.b=new M.$7d,this.onDidChange=this.b.event,this.a=k.$Em.toKey(m.identifier),_e(this,C,d,"f"),Ve(this,C,"f").onDidChangePassword(y=>{y.extensionId===this.a&&this.b.fire({key:y.key})})}get(m){return Ve(this,C,"f").get(this.a,m)}store(m,d){return Ve(this,C,"f").store(this.a,m,d)}delete(m){return Ve(this,C,"f").delete(this.a,m)}}e.$tkc=N,C=new WeakMap}),define(Pe[60],Re([1,0,3]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wjc=e.$Vjc=void 0,e.$Vjc=(0,k.$ii)("IURITransformerService");class M{constructor(N){N?(this.transformIncoming=N.transformIncoming.bind(N),this.transformOutgoing=N.transformOutgoing.bind(N),this.transformOutgoingURI=N.transformOutgoingURI.bind(N),this.transformOutgoingScheme=N.transformOutgoingScheme.bind(N)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.$Wjc=M}),define(Pe[210],Re([1,0,22]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Onb=C,e.$Pnb=A;class M{constructor(){this.buffers=[]}add(d){let y=this.buffers.indexOf(d);return y<0&&(y=this.buffers.length,this.buffers.push(d)),y}}function C(m,d){if(d.serializeBuffersForPostMessage){const y=new M,D=JSON.stringify(m,(b,$)=>{if($ instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:y.add($)};if(ArrayBuffer.isView($)){const n=N($);if(n)return{$$vscode_array_buffer_reference$$:!0,index:y.add($.buffer),view:{type:n,byteLength:$.byteLength,byteOffset:$.byteOffset}}}return $}),l=y.buffers.map(b=>{const $=new Uint8Array(b);return k.$ue.wrap($)});return{message:D,buffers:l}}else return{message:JSON.stringify(m),buffers:[]}}function N(m){switch(m.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A(m,d){const y=d.map(l=>{const b=new ArrayBuffer(l.byteLength);return new Uint8Array(b).set(l.buffer),b}),O=d.length?(l,b)=>{if(b&&typeof b=="object"&&b.$$vscode_array_buffer_reference$$){const $=b,{index:n}=$,o=y[n];if($.view)switch($.view.type){case 1:return new Int8Array(o,$.view.byteOffset,$.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(o,$.view.byteOffset,$.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(o,$.view.byteOffset,$.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(o,$.view.byteOffset,$.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(o,$.view.byteOffset,$.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(o,$.view.byteOffset,$.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(o,$.view.byteOffset,$.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(o,$.view.byteOffset,$.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(o,$.view.byteOffset,$.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(o,$.view.byteOffset,$.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(o,$.view.byteOffset,$.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return o}return b}:void 0;return{message:JSON.parse(m,O),arrayBuffers:y}}}),define(Pe[104],Re([1,0,177,17,2,6,3,30,43,12,42,146,32]),function(ee,e,k,M,C,N,A,m,d,y,O,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$uF=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$lF=e.EditorInputCapabilities=e.$kF=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$aF=e.$_E=e.$$E=e.$0E=e.$9E=void 0,e.$bF=n,e.$cF=o,e.$dF=s,e.$eF=r,e.$fF=i,e.$gF=c,e.$hF=h,e.$iF=t,e.$jF=p,e.$mF=E,e.$nF=I,e.$oF=S,e.$pF=P,e.$qF=U,e.$rF=Q,e.$sF=H,e.$tF=re,e.$vF=ae,e.$wF=se,e.$xF=De,e.$yF=Oe,e.$9E={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$0E={id:"default",displayName:(0,k.localize)(0,null),providerDisplayName:(0,k.localize)(1,null)},e.$$E="workbench.editor.sidebysideEditor",e.$_E="workbench.editors.textDiffEditor",e.$aF="workbench.editors.binaryResourceDiffEditor";var b;(function(ie){ie[ie.PROGRAMMATIC=1]="PROGRAMMATIC",ie[ie.USER=2]="USER",ie[ie.EDIT=3]="EDIT",ie[ie.NAVIGATION=4]="NAVIGATION",ie[ie.JUMP=5]="JUMP"})(b||(e.EditorPaneSelectionChangeReason=b={}));var $;(function(ie){ie[ie.IDENTICAL=1]="IDENTICAL",ie[ie.SIMILAR=2]="SIMILAR",ie[ie.DIFFERENT=3]="DIFFERENT"})($||(e.EditorPaneSelectionCompareResult=$={}));function n(ie){const q=ie;return!!q&&typeof q.getSelection=="function"&&!!q.onDidChangeSelection}function o(ie){const q=ie;return!!q&&typeof q.getScrollPosition=="function"&&typeof q.setScrollPosition=="function"&&!!q.onDidChangeScroll}function s(ie,q,de){for(const Ne of de.visibleEditorPanes)if(Ne.group.id===q&&ie.matches(Ne.input))return Ne.getViewState()}function r(ie){if(E(ie))return!1;const q=ie;return C.URI.isUri(q?.resource)}function i(ie){if(E(ie))return!1;const q=ie;return q?.original!==void 0&&q.modified!==void 0}function c(ie){if(E(ie))return!1;const q=ie;return!q||q.resources&&!Array.isArray(q.resources)?!1:!!q.resources||!!q.multiDiffSource}function h(ie){if(E(ie)||i(ie))return!1;const q=ie;return q?.primary!==void 0&&q.secondary!==void 0}function t(ie){if(E(ie))return!1;const q=ie;return q?q.resource===void 0||q.resource.scheme===y.Schemas.untitled||q.forceUntitled===!0:!1}function p(ie){if(E(ie))return!1;const q=ie;return C.URI.isUri(q?.base?.resource)&&C.URI.isUri(q?.input1?.resource)&&C.URI.isUri(q?.input2?.resource)&&C.URI.isUri(q?.result?.resource)}var a;(function(ie){ie[ie.SHORT=0]="SHORT",ie[ie.MEDIUM=1]="MEDIUM",ie[ie.LONG=2]="LONG"})(a||(e.Verbosity=a={}));var g;(function(ie){ie[ie.EXPLICIT=1]="EXPLICIT",ie[ie.AUTO=2]="AUTO",ie[ie.FOCUS_CHANGE=3]="FOCUS_CHANGE",ie[ie.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(g||(e.SaveReason=g={}));class v{constructor(){this.a=new Map}registerSource(q,de){let Ne=this.a.get(q);return Ne||(Ne={source:q,label:de},this.a.set(q,Ne)),Ne.source}getSourceLabel(q){return this.a.get(q)?.label??q}}e.$kF=new v;var f;(function(ie){ie[ie.None=0]="None",ie[ie.Readonly=2]="Readonly",ie[ie.Untitled=4]="Untitled",ie[ie.Singleton=8]="Singleton",ie[ie.RequiresTrust=16]="RequiresTrust",ie[ie.CanSplitInGroup=32]="CanSplitInGroup",ie[ie.ForceDescription=64]="ForceDescription",ie[ie.CanDropIntoEditor=128]="CanDropIntoEditor",ie[ie.MultipleEditors=256]="MultipleEditors",ie[ie.Scratchpad=512]="Scratchpad"})(f||(e.EditorInputCapabilities=f={}));class u extends N.$Uc{}e.$lF=u;function E(ie){return ie instanceof u}function w(ie){const q=ie;return C.URI.isUri(q?.preferredResource)}function I(ie){const q=ie;return E(q?.primary)&&E(q?.secondary)}function S(ie){const q=ie;return E(q?.modified)&&E(q?.original)}function P(ie,q,de,Ne,$e){return Oe(Ne,[(0,D.$5i)({id:"workbench.action.openLargeFile",label:(0,k.localize)(2,null),run:()=>{const we={...de,limits:{size:Number.MAX_VALUE}};ie.openEditor(q,we)}}),(0,D.$5i)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,k.localize)(3,null),run:()=>$e.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:l.default.Warning})}function U(ie){return E(ie?.editor)}function Q(ie){const q=ie;return U(ie)&&q?.group!==void 0}function H(ie){const q=ie;return typeof q?.groupId=="number"&&E(q.editor)}var L;(function(ie){ie[ie.UNKNOWN=0]="UNKNOWN",ie[ie.REPLACE=1]="REPLACE",ie[ie.MOVE=2]="MOVE",ie[ie.UNPIN=3]="UNPIN"})(L||(e.EditorCloseContext=L={}));var R;(function(ie){ie[ie.GROUP_ACTIVE=0]="GROUP_ACTIVE",ie[ie.GROUP_INDEX=1]="GROUP_INDEX",ie[ie.GROUP_LABEL=2]="GROUP_LABEL",ie[ie.GROUP_LOCKED=3]="GROUP_LOCKED",ie[ie.EDITOR_OPEN=4]="EDITOR_OPEN",ie[ie.EDITOR_CLOSE=5]="EDITOR_CLOSE",ie[ie.EDITOR_MOVE=6]="EDITOR_MOVE",ie[ie.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",ie[ie.EDITOR_LABEL=8]="EDITOR_LABEL",ie[ie.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",ie[ie.EDITOR_PIN=10]="EDITOR_PIN",ie[ie.EDITOR_TRANSIENT=11]="EDITOR_TRANSIENT",ie[ie.EDITOR_STICKY=12]="EDITOR_STICKY",ie[ie.EDITOR_DIRTY=13]="EDITOR_DIRTY",ie[ie.EDITOR_WILL_DISPOSE=14]="EDITOR_WILL_DISPOSE"})(R||(e.GroupModelChangeKind=R={}));var F;(function(ie){ie[ie.PRIMARY=1]="PRIMARY",ie[ie.SECONDARY=2]="SECONDARY",ie[ie.BOTH=3]="BOTH",ie[ie.ANY=4]="ANY"})(F||(e.SideBySideEditor=F={}));class T{getOriginalUri(q,de){if(!q)return;if(p(q))return e.$uF.getOriginalUri(q.result,de);if(de?.supportSideBySide){const{primary:$e,secondary:we}=this.a(q);if($e&&we){if(de?.supportSideBySide===F.BOTH)return{primary:this.getOriginalUri($e,{filterByScheme:de.filterByScheme}),secondary:this.getOriginalUri(we,{filterByScheme:de.filterByScheme})};if(de?.supportSideBySide===F.ANY)return this.getOriginalUri($e,{filterByScheme:de.filterByScheme})??this.getOriginalUri(we,{filterByScheme:de.filterByScheme});q=de.supportSideBySide===F.PRIMARY?$e:we}}if(i(q)||c(q)||h(q)||p(q))return;const Ne=w(q)?q.preferredResource:q.resource;return!Ne||!de||!de.filterByScheme?Ne:this.b(Ne,de.filterByScheme)}a(q){return I(q)||h(q)?{primary:q.primary,secondary:q.secondary}:S(q)||i(q)?{primary:q.modified,secondary:q.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(q,de){if(!q)return;if(p(q))return e.$uF.getCanonicalUri(q.result,de);if(de?.supportSideBySide){const{primary:$e,secondary:we}=this.a(q);if($e&&we){if(de?.supportSideBySide===F.BOTH)return{primary:this.getCanonicalUri($e,{filterByScheme:de.filterByScheme}),secondary:this.getCanonicalUri(we,{filterByScheme:de.filterByScheme})};if(de?.supportSideBySide===F.ANY)return this.getCanonicalUri($e,{filterByScheme:de.filterByScheme})??this.getCanonicalUri(we,{filterByScheme:de.filterByScheme});q=de.supportSideBySide===F.PRIMARY?$e:we}}if(i(q)||c(q)||h(q)||p(q))return;const Ne=q.resource;return!Ne||!de||!de.filterByScheme?Ne:this.b(Ne,de.filterByScheme)}b(q,de){if(Array.isArray(de)){if(de.some(Ne=>q.scheme===Ne))return q}else if(de===q.scheme)return q}}var X;(function(ie){ie[ie.UNKNOWN=0]="UNKNOWN",ie[ie.KEYBOARD=1]="KEYBOARD",ie[ie.MOUSE=2]="MOUSE"})(X||(e.EditorCloseMethod=X={}));function re(ie,q,de,Ne){if(!ie.isSticky(q))return!1;switch(Ne.preventPinnedEditorClose){case"keyboardAndMouse":return de===X.MOUSE||de===X.KEYBOARD;case"mouse":return de===X.MOUSE;case"keyboard":return de===X.KEYBOARD}return!1}e.$uF=new T;var me;(function(ie){ie[ie.LEFT=0]="LEFT",ie[ie.RIGHT=1]="RIGHT"})(me||(e.CloseDirection=me={}));class pe{constructor(){this.c=new Map,this.d=new Map}start(q){const de=this.a=q.get(A.$hi);for(const[Ne,$e]of this.c)this.e(Ne,$e,de);this.c.clear()}e(q,de,Ne){const $e=Ne.createInstance(de);this.d.set(q,$e)}registerFileEditorFactory(q){if(this.b)throw new Error("Can only register one file editor factory.");this.b=q}getFileEditorFactory(){return(0,M.$7f)(this.b)}registerEditorSerializer(q,de){if(this.c.has(q)||this.d.has(q))throw new Error(`A editor serializer with type ID '${q}' was already registered.`);return this.a?this.e(q,de,this.a):this.c.set(q,de),(0,N.$Sc)(()=>{this.c.delete(q),this.d.delete(q)})}getEditorSerializer(q){return this.d.get(typeof q=="string"?q:q.typeId)}}m.$2n.add(e.$9E.EditorFactory,new pe);async function ae(ie,q,de){return!ie||!ie.length?[]:await Promise.all(ie.map(async Ne=>{const $e=C.URI.revive(Ne.fileUri);if(!$e){de.info("Cannot resolve the path because it is not valid.",Ne);return}if(!await q.canHandleResource($e)){de.info("Cannot resolve the path because it cannot be handled",Ne);return}let ge=Ne.exists,ce=Ne.type;if(typeof ge!="boolean"||typeof ce!="number")try{ce=(await q.stat($e)).isDirectory?d.FileType.Directory:d.FileType.Unknown,ge=!0}catch(Z){de.error(Z),ge=!1}if(!ge&&Ne.openOnlyIfExists){de.info("Cannot resolve the path because it does not exist",Ne);return}if(ce===d.FileType.Directory){de.info("Cannot resolve the path because it is a directory",Ne);return}const K={...Ne.options,pinned:!0};return ge?{resource:$e,options:K}:{resource:$e,options:K,forceUntitled:!0}}))}var be;(function(ie){ie[ie.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ie[ie.SEQUENTIAL=1]="SEQUENTIAL"})(be||(e.EditorsOrder=be={}));function se(ie){const q=ie;if(!q)return!1;const de=q;if(de.modified)return se(de.modified);const Ne=q;return!!(Ne.contributionsState&&Ne.viewState&&Array.isArray(Ne.cursorState))}function De(ie){return(0,O.$7i)(ie)}function Oe(ie,q,de){const Ne=(0,O.$8i)(ie,q);return Ne.forceMessage=de?.forceMessage,Ne.forceSeverity=de?.forceSeverity,Ne.allowDialog=de?.allowDialog,Ne}}),define(Pe[211],Re([1,0,5,178,3,6,28,30,18,26,91,202]),function(ee,e,k,M,C,N,A,m,d,y,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GF=e.$FF=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$EF=e.ViewContentGroups=e.$CF=e.ViewContainerLocation=e.Extensions=e.$BF=e.$AF=e.$zF=void 0,e.$DF=$,e.$zF="views",e.$AF=(0,M.localize)(0,null),e.$BF=(0,D.$Vw)("default-view-icon",O.$Hj.window,(0,M.localize)(1,null));var l;(function(p){p.ViewContainersRegistry="workbench.registry.view.containers",p.ViewsRegistry="workbench.registry.view"})(l||(e.Extensions=l={}));var b;(function(p){p[p.Sidebar=0]="Sidebar",p[p.Panel=1]="Panel",p[p.AuxiliaryBar=2]="AuxiliaryBar"})(b||(e.ViewContainerLocation=b={})),e.$CF=[0,1,2];function $(p){switch(p){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}class n extends N.$Uc{constructor(){super(...arguments),this.c=this.B(new k.$7d),this.onDidRegister=this.c.event,this.f=this.B(new k.$7d),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,d.$Rb)([...this.g.values()])}registerViewContainer(a,g,v){const f=this.get(a.id);if(f)return f;const u=a;return u.openCommandActionDescriptor=v?.doNotRegisterOpenCommand?void 0:u.openCommandActionDescriptor??{id:u.id},(0,A.$yc)(this.g,g,[]).push(u),v?.isDefault&&this.h.push(u),this.c.fire({viewContainer:u,viewContainerLocation:g}),u}deregisterViewContainer(a){for(const g of this.g.keys()){const v=this.g.get(g),f=v?.indexOf(a);if(f!==-1){v?.splice(f,1),v.length===0&&this.g.delete(g),this.f.fire({viewContainer:a,viewContainerLocation:g});return}}}get(a){return this.all.filter(g=>g.id===a)[0]}getViewContainers(a){return[...this.g.get(a)||[]]}getViewContainerLocation(a){return[...this.g.keys()].filter(g=>this.getViewContainers(g).filter(v=>v?.id===a.id).length>0)[0]}getDefaultViewContainer(a){return this.h.find(g=>this.getViewContainerLocation(g)===a)}}m.$2n.add(l.ViewContainersRegistry,new n);var o;(function(p){p.Open="2_open",p.Debug="4_debug",p.SCM="5_scm",p.More="9_more"})(o||(e.ViewContentGroups=o={}));function s(p,a){const g=p.group??o.More,v=a.group??o.More;return g!==v?g.localeCompare(v):(p.order??5)-(a.order??5)}class r extends N.$Uc{constructor(){super(...arguments),this.c=this.B(new k.$7d),this.onViewsRegistered=this.c.event,this.f=this.B(new k.$7d),this.onViewsDeregistered=this.f.event,this.g=this.B(new k.$7d),this.onDidChangeContainer=this.g.event,this.h=this.B(new k.$7d),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new A.$Hc}registerViews(a,g){this.registerViews2([{views:a,viewContainer:g}])}registerViews2(a){a.forEach(({views:g,viewContainer:v})=>this.r(g,v)),this.c.fire(a)}deregisterViews(a,g){const v=this.s(a,g);v.length&&this.f.fire({views:v,viewContainer:g})}moveViews(a,g){for(const v of this.m.keys())if(v!==g){const f=this.s(a,v);f.length&&(this.r(f,g),this.g.fire({views:f,from:v,to:g}))}}getViews(a){return this.m.get(a)||[]}getView(a){for(const g of this.j){const v=(this.m.get(g)||[]).filter(f=>f.id===a)[0];if(v)return v}return null}getViewContainer(a){for(const g of this.j)if((this.m.get(g)||[]).filter(f=>f.id===a)[0])return g;return null}registerViewWelcomeContent(a,g){return this.n.add(a,g),this.h.fire(a),(0,N.$Sc)(()=>{this.n.delete(a,g),this.h.fire(a)})}registerViewWelcomeContent2(a,g){const v=new Map;for(const[f,u]of g)this.n.add(a,u),v.set(f,(0,N.$Sc)(()=>{this.n.delete(a,u),this.h.fire(a)}));return this.h.fire(a),v}getViewWelcomeContent(a){const g=[];return this.n.forEach(a,v=>g.push(v)),g.sort(s)}r(a,g){let v=this.m.get(g);v||(v=[],this.m.set(g,v),this.j.push(g));for(const f of a){if(this.getView(f.id)!==null)throw new Error((0,M.localize)(2,null,f.id));v.push(f)}}s(a,g){const v=this.m.get(g);if(!v)return[];const f=[],u=[];for(const E of v)a.includes(E)?f.push(E):u.push(E);return f.length&&(u.length?this.m.set(g,u):(this.m.delete(g),this.j.splice(this.j.indexOf(g),1))),f}}m.$2n.add(l.ViewsRegistry,new r),e.$EF=(0,C.$ii)("viewDescriptorService");var i;(function(p){p[p.Default=0]="Default",p[p.Expand=1]="Expand"})(i||(e.ViewVisibilityState=i={}));var c;(function(p){p[p.None=0]="None",p[p.Collapsed=1]="Collapsed",p[p.Expanded=2]="Expanded"})(c||(e.TreeItemCollapsibleState=c={}));class h{constructor(a,g){this.c=!1,this.d=!1,(0,y.$Sn)(this,a),this.d=!!g,this.resolve=async v=>{if(g&&!this.c){const f=await g(v);f&&(this.tooltip=this.tooltip??f.tooltip,this.command=this.command??f.command)}v.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$FF=h;class t extends Error{constructor(a){super((0,M.localize)(3,null,a)),this.name="NoTreeViewError"}static is(a){return a.name==="NoTreeViewError"}}e.$GF=t}),define(Pe[212],Re([1,0,5,39,6,33,3]),function(ee,e,k,M,C,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IG=e.$HG=e.$GG=e.ChatAgentLocation=void 0;var m;(function(O){O.Panel="panel",O.Terminal="terminal",O.Notebook="notebook",O.Editor="editor"})(m||(e.ChatAgentLocation=m={})),function(O){function D(l){switch(l){case"panel":return O.Panel;case"terminal":return O.Terminal;case"notebook":return O.Notebook}return O.Panel}O.fromRaw=D}(m||(e.ChatAgentLocation=m={})),e.$GG=(0,A.$ii)("chatAgentService");let d=class{constructor(D){this.e=D,this.b=[],this.d=new k.$7d,this.onDidChangeAgents=this.d.event}registerAgent(D,l){if(this.getAgent(D))throw new Error(`Agent already registered: ${JSON.stringify(D)}`);const $=this,n=l.slashCommands;l={...l,get slashCommands(){return n.filter(s=>!s.when||$.e.contextMatchesRules(N.$gj.deserialize(s.when)))}};const o={data:l};return this.b.push(o),(0,C.$Sc)(()=>{this.b=this.b.filter(s=>s!==o),this.d.fire(void 0)})}registerAgentImplementation(D,l){const b=this.f(D);if(!b)throw new Error(`Unknown agent: ${JSON.stringify(D)}`);if(b.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(D)}`);return b.impl=l,this.d.fire(new y(b.data,l)),(0,C.$Sc)(()=>{b.impl=void 0,this.d.fire(void 0)})}registerDynamicAgent(D,l){const b={data:D,impl:l};return this.b.push(b),this.d.fire(new y(D,l)),(0,C.$Sc)(()=>{this.b=this.b.filter($=>$!==b),this.d.fire(void 0)})}updateAgent(D,l){const b=this.f(D);if(!b?.impl)throw new Error(`No activated agent with id ${JSON.stringify(D)} registered`);b.data.metadata={...b.data.metadata,...l},this.d.fire(new y(b.data,b.impl))}getDefaultAgent(D){return this.getActivatedAgents().find(l=>!!l.isDefault&&l.locations.includes(D))}getSecondaryAgent(){return M.Iterable.find(this.b.values(),D=>!!D.data.metadata.isSecondary)?.data}f(D){return this.b.find(l=>l.data.id===D)}getAgent(D){return this.f(D)?.data}getAgents(){return this.b.map(D=>D.data)}getActivatedAgents(){return Array.from(this.b.values()).filter(D=>!!D.impl).map(D=>new y(D.data,D.impl))}getAgentsByName(D){return this.getAgents().filter(l=>l.name===D)}async invokeAgent(D,l,b,$,n){const o=this.f(D);if(!o?.impl)throw new Error(`No activated agent with id ${D}`);return await o.impl.invoke(l,b,$,n)}async getFollowups(D,l,b,$,n){const o=this.f(D);if(!o?.impl)throw new Error(`No activated agent with id ${D}`);return o.impl?.provideFollowups?o.impl.provideFollowups(l,b,$,n):[]}};e.$HG=d,d.AGENT_LEADER="@",e.$HG=d=Xe([qe(0,N.$Aj)],d);class y{constructor(D,l){this.b=D,this.d=l}get id(){return this.b.id}get name(){return this.b.name??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get defaultImplicitVariables(){return this.b.defaultImplicitVariables}get locations(){return this.b.locations}async invoke(D,l,b,$){return this.d.invoke(D,l,b,$)}async provideFollowups(D,l,b,$){return this.d.provideFollowups?this.d.provideFollowups(D,l,b,$):[]}provideWelcomeMessage(D){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(D)}provideSampleQuestions(D){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(D)}}e.$IG=y}),define(Pe[213],Re([1,0,2,29,3]),function(ee,e,k,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SF=e.$RF=e.ChatCopyKind=e.InteractiveSessionVoteDirection=void 0,e.$PF=N,e.$QF=A;function N(y){return!!y&&typeof y=="object"&&"uri"in y&&y.uri instanceof k.URI&&"version"in y&&typeof y.version=="number"&&"ranges"in y&&Array.isArray(y.ranges)&&y.ranges.every(M.$dt.isIRange)}function A(y){return!!y&&typeof y=="object"&&"documents"in y&&Array.isArray(y.documents)&&y.documents.every(N)}var m;(function(y){y[y.Down=0]="Down",y[y.Up=1]="Up"})(m||(e.InteractiveSessionVoteDirection=m={}));var d;(function(y){y[y.Action=1]="Action",y[y.Toolbar=2]="Toolbar"})(d||(e.ChatCopyKind=d={})),e.$RF=(0,C.$ii)("IChatService"),e.$SF="accessibility.voice.keywordActivation"}),define(Pe[214],Re([1,0,5,11,179]),function(ee,e,k,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$job=void 0;class N{constructor(){this.f=new Map,this.m=[],this.n=new k.$7d,this.o=new k.$7d,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(m){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=m}onEvent(m){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=m}onRequest(m){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=m}sendResponse(m){m.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${m.command}`)):this.u("response",m)}sendRequest(m,d,y,O){const D={command:m};if(d&&Object.keys(d).length>0&&(D.arguments=d),this.u("request",D),typeof O=="number"){const l=setTimeout(()=>{clearTimeout(l);const b=this.f.get(D.seq);if(b){this.f.delete(D.seq);const $={type:"response",seq:0,request_seq:D.seq,success:!1,command:m,message:(0,C.localize)(0,null,O,m)};b($)}},O)}return y&&this.f.set(D.seq,y),D.seq}acceptMessage(m){this.k?this.k(m):(this.m.push(m),this.m.length===1&&this.s())}q(m,d){return m.type!=="event"||d.type!=="event"}async s(){let m;for(;this.m.length;){if((!m||this.q(this.m[0],m))&&await(0,M.$jh)(0),m=this.m.shift(),!m)return;switch(m.type){case"event":this.j?.(m);break;case"request":this.g?.(m);break;case"response":{const d=m,y=this.f.get(d.request_seq);y&&(this.f.delete(d.request_seq),y(d));break}}}}u(m,d){d.type=m,d.seq=this.d++,this.sendMessage(d)}async w(){if(this.f.size===0)return Promise.resolve();const m=new Map;this.f.forEach((d,y)=>m.set(y,d)),await(0,M.$jh)(500),m.forEach((d,y)=>{d({type:"response",seq:0,request_seq:y,success:!1,command:"canceled",message:"canceled"}),this.f.delete(y)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$job=N}),define(Pe[215],Re([1,0,2,180,33,3]),function(ee,e,k,M,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$XI=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$WI=e.MemoryRangeType=e.State=e.$UI=e.$TI=e.$SI=e.$RI=e.$QI=e.$PI=e.$OI=e.$NI=e.$MI=e.$LI=e.$KI=e.$JI=e.$II=e.$HI=e.$GI=e.$FI=e.$EI=e.$DI=e.$CI=e.$BI=e.$AI=e.$zI=e.$yI=e.$xI=e.$wI=e.$vI=e.$uI=e.$tI=e.$sI=e.$rI=e.$qI=e.$pI=e.$oI=e.$nI=e.$mI=e.$lI=e.$kI=e.$jI=e.$iI=e.$hI=e.$gI=e.$fI=e.$eI=e.$dI=e.$cI=e.$bI=e.$aI=e.$_H=e.$$H=e.$0H=e.$9H=e.$8H=e.$7H=e.$6H=e.$5H=e.$4H=e.$3H=e.$2H=e.$1H=e.$ZH=e.$YH=e.$XH=e.$WH=e.$VH=e.$UH=e.$TH=e.$SH=e.$RH=e.$QH=e.$PH=e.$OH=e.$NH=e.$MH=e.$LH=e.$KH=e.$JH=void 0,e.$VI=d,e.$JH="workbench.view.debug",e.$KH="workbench.debug.variablesView",e.$LH="workbench.debug.watchExpressionsView",e.$MH="workbench.debug.callStackView",e.$NH="workbench.debug.loadedScriptsView",e.$OH="workbench.debug.breakPointsView",e.$PH="workbench.debug.disassemblyView",e.$QH="workbench.panel.repl",e.$RH="workbench.panel.repl.view",e.$SH=new C.$zj("debugType",void 0,{type:"string",description:M.localize(0,null)}),e.$TH=new C.$zj("debugConfigurationType",void 0,{type:"string",description:M.localize(1,null)}),e.$UH=new C.$zj("debugState","inactive",{type:"string",description:M.localize(2,null)}),e.$VH="debugUx",e.$WH=new C.$zj(e.$VH,"default",{type:"string",description:M.localize(3,null)}),e.$XH=new C.$zj("hasDebugged",!1,{type:"boolean",description:M.localize(4,null)}),e.$YH=new C.$zj("inDebugMode",!1,{type:"boolean",description:M.localize(5,null)}),e.$ZH=new C.$zj("inDebugRepl",!1,{type:"boolean",description:M.localize(6,null)}),e.$1H=new C.$zj("breakpointWidgetVisible",!1,{type:"boolean",description:M.localize(7,null)}),e.$2H=new C.$zj("inBreakpointWidget",!1,{type:"boolean",description:M.localize(8,null)}),e.$3H=new C.$zj("breakpointsFocused",!0,{type:"boolean",description:M.localize(9,null)}),e.$4H=new C.$zj("watchExpressionsFocused",!0,{type:"boolean",description:M.localize(10,null)}),e.$5H=new C.$zj("watchExpressionsExist",!1,{type:"boolean",description:M.localize(11,null)}),e.$6H=new C.$zj("variablesFocused",!0,{type:"boolean",description:M.localize(12,null)}),e.$7H=new C.$zj("expressionSelected",!1,{type:"boolean",description:M.localize(13,null)}),e.$8H=new C.$zj("breakpointInputFocused",!1,{type:"boolean",description:M.localize(14,null)}),e.$9H=new C.$zj("callStackItemType",void 0,{type:"string",description:M.localize(15,null)}),e.$0H=new C.$zj("callStackSessionIsAttach",!1,{type:"boolean",description:M.localize(16,null)}),e.$$H=new C.$zj("callStackItemStopped",!1,{type:"boolean",description:M.localize(17,null)}),e.$_H=new C.$zj("callStackSessionHasOneThread",!1,{type:"boolean",description:M.localize(18,null)}),e.$aI=new C.$zj("watchItemType",void 0,{type:"string",description:M.localize(19,null)}),e.$bI=new C.$zj("canViewMemory",void 0,{type:"boolean",description:M.localize(20,null)}),e.$cI=new C.$zj("breakpointItemType",void 0,{type:"string",description:M.localize(21,null)}),e.$dI=new C.$zj("breakpointItemBytes",void 0,{type:"boolean",description:M.localize(22,null)}),e.$eI=new C.$zj("breakpointHasModes",!1,{type:"boolean",description:M.localize(23,null)}),e.$fI=new C.$zj("breakpointSupportsCondition",!1,{type:"boolean",description:M.localize(24,null)}),e.$gI=new C.$zj("loadedScriptsSupported",!1,{type:"boolean",description:M.localize(25,null)}),e.$hI=new C.$zj("loadedScriptsItemType",void 0,{type:"string",description:M.localize(26,null)}),e.$iI=new C.$zj("focusedSessionIsAttach",!1,{type:"boolean",description:M.localize(27,null)}),e.$jI=new C.$zj("focusedSessionIsNoDebug",!1,{type:"boolean",description:M.localize(28,null)}),e.$kI=new C.$zj("stepBackSupported",!1,{type:"boolean",description:M.localize(29,null)}),e.$lI=new C.$zj("restartFrameSupported",!1,{type:"boolean",description:M.localize(30,null)}),e.$mI=new C.$zj("stackFrameSupportsRestart",!1,{type:"boolean",description:M.localize(31,null)}),e.$nI=new C.$zj("jumpToCursorSupported",!1,{type:"boolean",description:M.localize(32,null)}),e.$oI=new C.$zj("stepIntoTargetsSupported",!1,{type:"boolean",description:M.localize(33,null)}),e.$pI=new C.$zj("breakpointsExist",!1,{type:"boolean",description:M.localize(34,null)}),e.$qI=new C.$zj("debuggersAvailable",!1,{type:"boolean",description:M.localize(35,null)}),e.$rI=new C.$zj("debugExtensionAvailable",!0,{type:"boolean",description:M.localize(36,null)}),e.$sI=new C.$zj("debugProtocolVariableMenuContext",void 0,{type:"string",description:M.localize(37,null)}),e.$tI=new C.$zj("debugSetVariableSupported",!1,{type:"boolean",description:M.localize(38,null)}),e.$uI=new C.$zj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:M.localize(39,null)}),e.$vI=new C.$zj("debugSetExpressionSupported",!1,{type:"boolean",description:M.localize(40,null)}),e.$wI=new C.$zj("breakWhenValueChangesSupported",!1,{type:"boolean",description:M.localize(41,null)}),e.$xI=new C.$zj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:M.localize(42,null)}),e.$yI=new C.$zj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:M.localize(43,null)}),e.$zI=new C.$zj("terminateDebuggeeSupported",!1,{type:"boolean",description:M.localize(44,null)}),e.$AI=new C.$zj("suspendDebuggeeSupported",!1,{type:"boolean",description:M.localize(45,null)}),e.$BI=new C.$zj("variableEvaluateNamePresent",!1,{type:"boolean",description:M.localize(46,null)}),e.$CI=new C.$zj("variableIsReadonly",!1,{type:"boolean",description:M.localize(47,null)}),e.$DI=new C.$zj("variableValue",!1,{type:"string",description:M.localize(48,null)}),e.$EI=new C.$zj("variableType",!1,{type:"string",description:M.localize(49,null)}),e.$FI=new C.$zj("variableInterfaces",!1,{type:"array",description:M.localize(50,null)}),e.$GI=new C.$zj("variableName",!1,{type:"string",description:M.localize(51,null)}),e.$HI=new C.$zj("variableLanguage",!1,{type:"string",description:M.localize(52,null)}),e.$II=new C.$zj("variableExtensionId",!1,{type:"string",description:M.localize(53,null)}),e.$JI=new C.$zj("exceptionWidgetVisible",!1,{type:"boolean",description:M.localize(54,null)}),e.$KI=new C.$zj("multiSessionRepl",!1,{type:"boolean",description:M.localize(55,null)}),e.$LI=new C.$zj("multiSessionDebug",!1,{type:"boolean",description:M.localize(56,null)}),e.$MI=new C.$zj("disassembleRequestSupported",!1,{type:"boolean",description:M.localize(57,null)}),e.$NI=new C.$zj("disassemblyViewFocus",!1,{type:"boolean",description:M.localize(58,null)}),e.$OI=new C.$zj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:M.localize(59,null)}),e.$PI=new C.$zj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:M.localize(60,null)});const A=r=>M.localize(61,null,r);e.$QI=A,e.$RI="editor.contrib.debug",e.$SI="editor.contrib.breakpoint",e.$TI="debug",e.$UI={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:M.localize(62,null)};var m;(function(r){r[r.Inactive=0]="Inactive",r[r.Initializing=1]="Initializing",r[r.Stopped=2]="Stopped",r[r.Running=3]="Running"})(m||(e.State=m={}));function d(r){switch(r){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}var y;(function(r){r[r.Valid=0]="Valid",r[r.Unreadable=1]="Unreadable",r[r.Error=2]="Error"})(y||(e.MemoryRangeType=y={})),e.$WI="vscode-debug-memory";var O;(function(r){r[r.Variable=0]="Variable",r[r.Address=1]="Address"})(O||(e.DataBreakpointSetType=O={}));var D;(function(r){r[r.Initial=1]="Initial",r[r.Dynamic=2]="Dynamic"})(D||(e.DebugConfigurationProviderTriggerKind=D={}));var l;(function(r){r.UnverifiedBreakpoints="unverifiedBreakpoints"})(l||(e.DebuggerString=l={})),e.$XI=(0,N.$ii)("debugService");var b;(function(r){r[r.CONDITION=0]="CONDITION",r[r.HIT_COUNT=1]="HIT_COUNT",r[r.LOG_MESSAGE=2]="LOG_MESSAGE",r[r.TRIGGER_POINT=3]="TRIGGER_POINT"})(b||(e.BreakpointWidgetContext=b={}));var $;(function(r){r[r.Command=0]="Command",r[r.Tree=1]="Tree"})($||(e.DebugVisualizationType=$={}));var n;(function(r){r[r.None=0]="None",r[r.Collapsed=1]="Collapsed",r[r.Expanded=2]="Expanded"})(n||(e.DebugTreeItemCollapsibleState=n={}));var o;(function(r){r.deserialize=i=>i,r.serialize=i=>i})(o||(e.IDebugVisualizationTreeItem=o={}));var s;(function(r){r.deserialize=i=>({id:i.id,name:i.name,iconPath:i.iconPath&&{light:k.URI.revive(i.iconPath.light),dark:k.URI.revive(i.iconPath.dark)},iconClass:i.iconClass,visualization:i.visualization}),r.serialize=i=>i})(s||(e.IDebugVisualization=s={}))}),define(Pe[216],Re([1,0,15,2,19,26,12,29,24,18]),function(ee,e,k,M,C,N,A,m,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XG=void 0,e.$LG=D,e.$MG=l,e.$NG=b,e.$OG=$,e.$PG=n,e.$QG=o,e.$RG=s,e.$SG=i,e.$TG=t,e.$UG=p,e.$VG=g,e.$WG=f;const O=/{([^}]+)}/g;function D(E,w,I){return E.replace(O,function(S,P){return w&&P.length>0&&P[0]!=="_"?S:I&&I.hasOwnProperty(P)?I[P]:S})}function l(E){const w={};for(const I of Object.keys(E))I.startsWith("!")||(w[I]=E[I]);return w}function b(E){return E.configuration.request==="attach"&&!$(E)&&(!E.parentSession||b(E.parentSession))}function $(E){let w=E.configuration.type;if(w)return w==="vslsShare"&&(w=E.configuration.adapterProxy.configuration.type),(0,k.$lf)(w,"extensionhost")||(0,k.$lf)(w,"pwa-extensionhost")?E:E.parentSession?$(E.parentSession):void 0}function n(E){return E.type&&(E.label||E.program||E.runtime)}function o(E,w,I){let S,P=0;const U=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let Q=null;for(;Q=U.exec(E);){const H=Q.index+1,L=H+Q[0].length;if(H<=w&&L>=I){S=Q[0],P=H;break}}if(S){const H=/\w+/g;let L=null;for(;(L=H.exec(S))&&!(L.index+1+P+L[0].length>=I););L&&(S=S.substring(0,H.lastIndex))}return S?{start:P,end:P+S.length-1}:{start:0,end:0}}async function s(E,w,I,S){if(E.evaluatableExpressionProvider.has(w)){const P=E.evaluatableExpressionProvider.ordered(w),U=(0,y.$Hb)(await Promise.all(P.map(async Q=>{try{return await Q.provideEvaluatableExpression(w,I,S??d.CancellationToken.None)}catch{return}})));if(U.length>0){let Q=U[0].expression;const H=U[0].range;return Q||(Q=w.getLineContent(I.lineNumber).substring(H.startColumn-1,H.endColumn-1)),{range:H,matchingExpression:Q}}}else{const P=w.getLineContent(I.lineNumber),{start:U,end:Q}=o(P,I.column,I.column),H=P.substring(U-1,Q);return{matchingExpression:H,range:new m.$dt(I.lineNumber,U,I.lineNumber,U+H.length)}}return null}const r=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function i(E){return!!(E&&E.match(r))}function c(E){if(typeof E.path=="string"&&!(typeof E.sourceReference=="number"&&E.sourceReference>0)){if(i(E.path))return M.URI.parse(E.path);if((0,C.$jc)(E.path))return M.URI.file(E.path)}return E.path}function h(E){if(typeof E.path=="object"){const w=M.URI.revive(E.path);if(w)return w.scheme===A.Schemas.file?w.fsPath:w.toString()}return E.path}function t(E,w){const I=w?c:h,S=(0,N.$Pn)(E);return a(S,(P,U)=>{P&&U&&(U.path=I(U))}),S}function p(E,w){const I=w?c:h,S=(0,N.$Pn)(E);return a(S,(P,U)=>{!P&&U&&(U.path=I(U))}),S}function a(E,w){switch(E.type){case"event":{const I=E;switch(I.event){case"output":w(!1,I.body.source);break;case"loadedSource":w(!1,I.body.source);break;case"breakpoint":w(!1,I.body.breakpoint.source);break;default:break}break}case"request":{const I=E;switch(I.command){case"setBreakpoints":w(!0,I.arguments.source);break;case"breakpointLocations":w(!0,I.arguments.source);break;case"source":w(!0,I.arguments.source);break;case"gotoTargets":w(!0,I.arguments.source);break;case"launchVSCode":I.arguments.args.forEach(S=>w(!1,S));break;default:break}break}case"response":{const I=E;if(I.success&&I.body)switch(I.command){case"stackTrace":I.body.stackFrames.forEach(S=>w(!1,S.source));break;case"loadedSources":I.body.sources.forEach(S=>w(!1,S));break;case"scopes":I.body.scopes.forEach(S=>w(!1,S.source));break;case"setFunctionBreakpoints":I.body.breakpoints.forEach(S=>w(!1,S.source));break;case"setBreakpoints":I.body.breakpoints.forEach(S=>w(!1,S.source));break;case"disassemble":I.body?.instructions.forEach(P=>w(!1,P.location));break;default:break}break}}}function g(E){return E.filter(w=>!w.presentation?.hidden).sort((w,I)=>w.presentation?I.presentation?w.presentation.group?I.presentation.group?w.presentation.group!==I.presentation.group?w.presentation.group.localeCompare(I.presentation.group):v(w.presentation.order,I.presentation.order):-1:I.presentation.group?1:v(w.presentation.order,I.presentation.order):-1:I.presentation?1:0)}function v(E,w){return typeof E!="number"?typeof w!="number"?0:1:typeof w!="number"?-1:E-w}async function f(E,w){const I=E.getValue("debug.saveBeforeStart",{overrideIdentifier:w.activeTextEditorLanguageId});if(I!=="none"&&(await w.saveAll(),I==="allEditorsInActiveGroup")){const S=w.activeEditorPane;S&&S.input.resource?.scheme===A.Schemas.untitled&&await w.save({editor:S.input,groupId:S.group.id})}await E.reloadConfiguration()}const u=(E,w)=>!E||!w?E===w:E.name===w.name&&E.path===w.path&&E.sourceReference===w.sourceReference;e.$XG=u}),define(Pe[217],Re([1,0,3]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$J=e.CellExecutionUpdateType=void 0;var M;(function(C){C[C.Output=1]="Output",C[C.OutputItems=2]="OutputItems",C[C.ExecutionState=3]="ExecutionState"})(M||(e.CellExecutionUpdateType=M={})),e.$$J=(0,k.$ii)("INotebookExecutionService")}),define(Pe[218],Re([1,0,3]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xhb=e.$Whb=e.ProxyKernelState=e.$Vhb=void 0,e.$Vhb=100;var M;(function(C){C[C.Disconnected=1]="Disconnected",C[C.Connected=2]="Connected",C[C.Initializing=3]="Initializing"})(M||(e.ProxyKernelState=M={})),e.$Whb=(0,k.$ii)("INotebookKernelService"),e.$Xhb=(0,k.$ii)("INotebookKernelHistoryService")}),define(Pe[219],Re([1,0,6,29,143,96]),function(ee,e,k,M,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6Ub=void 0;class A extends k.$Uc{constructor(d,y,O){super(),this._source=d,this.b=y,this.c=O,this.a=void 0}f(d){const y=d.getLineCount();return new M.$dt(1,1,y,this.g(d,y))}g(d,y){if(y<1||y>d.getLineCount())throw new Error("Illegal value for lineNumber");return d.getLineLength(y)+1}get inputTextBuffer(){if(!this.b){const d=new C.$FC;d.acceptChunk(this._source);const y=d.finish(!0),{textBuffer:O,disposable:D}=y.create(1);this.b=O,this.B(D)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(d=>{const y=new C.$FC;y.acceptChunk(d);const O=y.finish(!0),{textBuffer:D,disposable:l}=O.create(1);return this.B(l),D})),this.a}findInInputs(d){const O=new N.$tC(d,!1,!1,null).parseSearchRequest();if(!O)return[];const D=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(D,O,!0,5e3)}findInOutputs(d){const O=new N.$tC(d,!1,!1,null).parseSearchRequest();return O?this.outputTextBuffers.map(D=>{const l=D.findMatchesLineByLine(this.f(D),O,!0,5e3);if(l.length!==0)return{textBuffer:D,matches:l}}).filter(D=>!!D):[]}}e.$6Ub=A}),define(Pe[49],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eL=e.TestPosition=e.TestIdPathParts=void 0;var k;(function(N){N.Delimiter="\0"})(k||(e.TestIdPathParts=k={}));var M;(function(N){N[N.IsSame=0]="IsSame",N[N.Disconnected=1]="Disconnected",N[N.IsChild=2]="IsChild",N[N.IsParent=3]="IsParent"})(M||(e.TestPosition=M={}));class C{static fromExtHostTestItem(A,m,d=A.parent){if(A._isRoot)return new C([m]);const y=[A.id];for(let O=d;O&&O.id!==m;O=O.parent)y.push(O.id);return y.push(m),new C(y.reverse())}static isRoot(A){return!A.includes("\0")}static root(A){const m=A.indexOf("\0");return m===-1?A:A.slice(0,m)}static fromString(A){return new C(A.split("\0"))}static join(A,m){return new C([...A.path,m])}static joinToString(A,m){return A.toString()+"\0"+m}static parentId(A){const m=A.lastIndexOf("\0");return m===-1?void 0:A.slice(0,m)}static localId(A){const m=A.lastIndexOf("\0");return m===-1?A:A.slice(m+1)}static isChild(A,m){return m.startsWith(A)&&m[A.length]==="\0"}static compare(A,m){return A===m?0:C.isChild(A,m)?2:C.isChild(m,A)?3:1}constructor(A,m=A.length){if(this.path=A,this.d=m,A.length===0||m<1)throw new Error("cannot create test with empty path")}get rootId(){return new C(this.path,1)}get parentId(){return this.d>1?new C(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let A=1;A<=this.d;A++)yield new C(this.path,A)}*idsToRoot(){for(let A=this.d;A>0;A--)yield new C(this.path,A)}compare(A){if(typeof A=="string")return C.compare(this.toString(),A);for(let m=0;m<A.d&&m<this.d;m++)if(A.path[m]!==this.path[m])return 1;return A.d>this.d?2:A.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let A=1;A<this.d;A++)this.c+="\0",this.c+=this.path[A]}return this.c}}e.$eL=C}),define(Pe[61],Re([1,0,2,94,29,49]),function(ee,e,k,M,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nL=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$mL=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$lL=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$kL=e.$jL=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$iL=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$hL=e.$gL=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$fL=e.TestResultState=void 0;var A;(function(R){R[R.Unset=0]="Unset",R[R.Queued=1]="Queued",R[R.Running=2]="Running",R[R.Passed=3]="Passed",R[R.Failed=4]="Failed",R[R.Skipped=5]="Skipped",R[R.Errored=6]="Errored"})(A||(e.TestResultState=A={})),e.$fL={0:"unset",1:"queued",2:"running",3:"passed",4:"failed",5:"skipped",6:"errored"};var m;(function(R){R[R.Run=1]="Run",R[R.Debug=2]="Debug",R[R.Coverage=3]="Coverage"})(m||(e.ExtTestRunProfileKind=m={}));var d;(function(R){R[R.Run=2]="Run",R[R.Debug=4]="Debug",R[R.Coverage=8]="Coverage",R[R.HasNonDefaultProfile=16]="HasNonDefaultProfile",R[R.HasConfigurable=32]="HasConfigurable",R[R.SupportsContinuousRun=64]="SupportsContinuousRun"})(d||(e.TestRunProfileBitset=d={})),e.$gL=[2,4,8,16,32,64];const y=R=>"runId"in R;e.$hL=y;var O;(function(R){R.serialize=F=>({range:F.range.toJSON(),uri:F.uri.toJSON()}),R.deserialize=(F,T)=>({range:C.$dt.lift(T.range),uri:F.asCanonicalUri(k.URI.revive(T.uri))})})(O||(e.IRichLocation=O={}));var D;(function(R){R[R.Error=0]="Error",R[R.Output=1]="Output"})(D||(e.TestMessageType=D={}));var l;(function(R){R.serialize=F=>({message:F.message,type:0,expected:F.expected,actual:F.actual,contextValue:F.contextValue,location:F.location&&O.serialize(F.location)}),R.deserialize=(F,T)=>({message:T.message,type:0,expected:T.expected,actual:T.actual,contextValue:T.contextValue,location:T.location&&O.deserialize(F,T.location)})})(l||(e.ITestErrorMessage=l={}));const b=(R,F)=>`${F?"s":"e"}${R}`;e.$iL=b;var $;(function(R){R.serialize=F=>({message:F.message,type:1,offset:F.offset,length:F.length,location:F.location&&O.serialize(F.location)}),R.deserialize=(F,T)=>({message:T.message,type:1,offset:T.offset,length:T.length,location:T.location&&O.deserialize(F,T.location)})})($||(e.ITestOutputMessage=$={}));var n;(function(R){R.serialize=F=>F.type===0?l.serialize(F):$.serialize(F),R.deserialize=(F,T)=>T.type===0?l.deserialize(F,T):$.deserialize(F,T)})(n||(e.ITestMessage=n={}));var o;(function(R){R.serializeWithoutMessages=F=>({state:F.state,duration:F.duration,messages:[]}),R.serialize=F=>({state:F.state,duration:F.duration,messages:F.messages.map(n.serialize)}),R.deserialize=(F,T)=>({state:T.state,duration:T.duration,messages:T.messages.map(X=>n.deserialize(F,X))})})(o||(e.ITestTaskState=o={}));const s="\0",r=(R,F)=>R+s+F;e.$jL=r;const i=R=>{const F=R.indexOf(s);return{ctrlId:R.slice(0,F),tagId:R.slice(F+1)}};e.$kL=i;var c;(function(R){R.serialize=F=>({extId:F.extId,label:F.label,tags:F.tags,busy:F.busy,children:void 0,uri:F.uri?.toJSON(),range:F.range?.toJSON()||null,description:F.description,error:F.error,sortText:F.sortText}),R.deserialize=(F,T)=>({extId:T.extId,label:T.label,tags:T.tags,busy:T.busy,children:void 0,uri:T.uri?F.asCanonicalUri(k.URI.revive(T.uri)):void 0,range:T.range?C.$dt.lift(T.range):null,description:T.description,error:T.error,sortText:T.sortText})})(c||(e.ITestItem=c={}));var h;(function(R){R[R.NotExpandable=0]="NotExpandable",R[R.Expandable=1]="Expandable",R[R.BusyExpanding=2]="BusyExpanding",R[R.Expanded=3]="Expanded"})(h||(e.TestItemExpandState=h={}));var t;(function(R){R.serialize=F=>({expand:F.expand,item:c.serialize(F.item)}),R.deserialize=(F,T)=>({controllerId:N.$eL.root(T.item.extId),expand:T.expand,item:c.deserialize(F,T.item)})})(t||(e.InternalTestItem=t={}));var p;(function(R){R.serialize=F=>{let T;return F.item&&(T={},F.item.label!==void 0&&(T.label=F.item.label),F.item.tags!==void 0&&(T.tags=F.item.tags),F.item.busy!==void 0&&(T.busy=F.item.busy),F.item.uri!==void 0&&(T.uri=F.item.uri?.toJSON()),F.item.range!==void 0&&(T.range=F.item.range?.toJSON()),F.item.description!==void 0&&(T.description=F.item.description),F.item.error!==void 0&&(T.error=F.item.error),F.item.sortText!==void 0&&(T.sortText=F.item.sortText)),{extId:F.extId,expand:F.expand,item:T}},R.deserialize=F=>{let T;return F.item&&(T={},F.item.label!==void 0&&(T.label=F.item.label),F.item.tags!==void 0&&(T.tags=F.item.tags),F.item.busy!==void 0&&(T.busy=F.item.busy),F.item.range!==void 0&&(T.range=F.item.range?C.$dt.lift(F.item.range):null),F.item.description!==void 0&&(T.description=F.item.description),F.item.error!==void 0&&(T.error=F.item.error),F.item.sortText!==void 0&&(T.sortText=F.item.sortText)),{extId:F.extId,expand:F.expand,item:T}}})(p||(e.ITestItemUpdate=p={}));const a=(R,F)=>{F.expand!==void 0&&(R.expand=F.expand),F.item!==void 0&&(R.item=R.item?Object.assign(R.item,F.item):F.item)};e.$lL=a;var g;(function(R){R.serializeWithoutMessages=F=>({...t.serialize(F),ownComputedState:F.ownComputedState,computedState:F.computedState,tasks:F.tasks.map(o.serializeWithoutMessages)}),R.serialize=F=>({...t.serialize(F),ownComputedState:F.ownComputedState,computedState:F.computedState,tasks:F.tasks.map(o.serialize)}),R.deserialize=(F,T)=>({...t.deserialize(F,T),ownComputedState:T.ownComputedState,computedState:T.computedState,tasks:T.tasks.map(X=>o.deserialize(F,X)),retired:!0})})(g||(e.TestResultItem=g={}));var v;(function(R){R.empty=()=>({covered:0,total:0}),R.sum=(F,T)=>{F.covered+=T.covered,F.total+=T.total}})(v||(e.ICoverageCount=v={}));var f;(function(R){R.serialize=F=>({id:F.id,statement:F.statement,branch:F.branch,declaration:F.declaration,uri:F.uri.toJSON()}),R.deserialize=(F,T)=>({id:T.id,statement:T.statement,branch:T.branch,declaration:T.declaration,uri:F.asCanonicalUri(k.URI.revive(T.uri))})})(f||(e.IFileCoverage=f={}));function u(R){return{...R,location:R.location?.toJSON()}}function E(R){return R.location=R.location?M.$ct.isIPosition(R.location)?M.$ct.lift(R.location):C.$dt.lift(R.location):void 0,R}e.$mL=3;var w;(function(R){R[R.Declaration=0]="Declaration",R[R.Statement=1]="Statement",R[R.Branch=2]="Branch"})(w||(e.DetailType=w={}));var I;(function(R){R.serialize=F=>F.type===0?P.serialize(F):U.serialize(F),R.deserialize=F=>F.type===0?P.deserialize(F):U.deserialize(F)})(I||(e.CoverageDetails=I={}));var S;(function(R){R.serialize=u,R.deserialize=E})(S||(e.IBranchCoverage=S={}));var P;(function(R){R.serialize=u,R.deserialize=E})(P||(e.IDeclarationCoverage=P={}));var U;(function(R){R.serialize=F=>({...u(F),branches:F.branches?.map(S.serialize)}),R.deserialize=F=>({...E(F),branches:F.branches?.map(S.deserialize)})})(U||(e.IStatementCoverage=U={}));var Q;(function(R){R[R.Add=0]="Add",R[R.Update=1]="Update",R[R.DocumentSynced=2]="DocumentSynced",R[R.Remove=3]="Remove",R[R.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",R[R.Retire=5]="Retire",R[R.AddTag=6]="AddTag",R[R.RemoveTag=7]="RemoveTag"})(Q||(e.TestDiffOpType=Q={}));var H;(function(R){R.deserialize=(F,T)=>T.op===0?{op:T.op,item:t.deserialize(F,T.item)}:T.op===1?{op:T.op,item:p.deserialize(T.item)}:T.op===2?{op:T.op,uri:F.asCanonicalUri(k.URI.revive(T.uri)),docv:T.docv}:T,R.serialize=F=>F.op===0?{op:F.op,item:t.serialize(F.item)}:F.op===1?{op:F.op,item:p.serialize(F.item)}:F})(H||(e.TestsDiffOp=H={}));class L{constructor(F){this.l=F,this.f=new Map,this.g=new Map,this.h=new Set,this.j=0,this.k=0,this.tags=this.f}apply(F){const T=this.w();for(const X of F)switch(X.op){case 0:this.o(t.deserialize(this.l,X.item),T);break;case 1:this.p(p.deserialize(X.item),T);break;case 3:this.q(X.itemId,T);break;case 5:this.v(X.itemId);break;case 4:this.updatePendingRoots(X.amount);break;case 6:this.f.set(X.tag.id,X.tag);break;case 7:this.f.delete(X.id);break}T.complete?.()}o(F,T){const X=N.$eL.parentId(F.item.extId)?.toString();let re;if(!X)re=this.x(F),this.h.add(re),this.g.set(F.item.extId,re);else if(this.g.has(X)){const me=this.g.get(X);me.children.add(F.item.extId),re=this.x(F,me),this.g.set(F.item.extId,re)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(F)}`);return}return T.add?.(re),F.expand===2&&this.j++,re}p(F,T){const X=this.g.get(F.extId);if(X)return F.expand!==void 0&&(X.expand===2&&this.j--,F.expand===2&&this.j++),(0,e.$lL)(X,F),T.update?.(X),X}q(F,T){const X=this.g.get(F);if(!X)return;const re=N.$eL.parentId(X.item.extId)?.toString();re?this.g.get(re).children.delete(X.item.extId):this.h.delete(X);const me=[[F]];for(;me.length;)for(const pe of me.pop()){const ae=this.g.get(pe);ae&&(me.push(ae.children),this.g.delete(pe),T.remove?.(ae,ae!==X),ae.expand===2&&this.j--)}}v(F){}updatePendingRoots(F){this.k+=F}w(){return{}}}e.$nL=L}),define(Pe[75],Re([1,0,11,5,6,56,61,49]),function(ee,e,k,M,C,N,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IO=e.$HO=e.$GO=e.$FO=e.$EO=e.TestItemEventOp=void 0;var d;(function(r){r[r.Upsert=0]="Upsert",r[r.SetTags=1]="SetTags",r[r.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",r[r.RemoveChild=3]="RemoveChild",r[r.SetProp=4]="SetProp",r[r.Bulk=5]="Bulk",r[r.DocumentSynced=6]="DocumentSynced"})(d||(e.TestItemEventOp=d={}));const y=(r,i)=>r===i,D=Object.entries({range:(r,i)=>r===i?!0:!r||!i?!1:r.equalsRange(i),busy:y,label:y,description:y,error:y,sortText:y,tags:(r,i)=>!(r.length!==i.length||r.some(c=>!i.includes(c)))}),l=(r,i)=>{let c;for(const[h,t]of D)t(r[h],i[h])||(c?c[h]=i[h]:c={[h]:i[h]});return c};class b extends C.$Uc{get root(){return this.s.root}constructor(i){super(),this.s=i,this.f=this.B(new k.$uh(()=>this.flushDiff(),200)),this.g=this.B(new M.$7d),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(i){this.h=i;for(const c of this.tree.values())this.J(c)}get resolveHandler(){return this.h}collectDiff(){const i=this.m;return this.m=[],i}pushDiff(i){switch(i.op){case 2:{for(const c of this.m)if(c.op===2&&c.uri===i.uri){c.docv=i.docv;return}break}case 1:{const c=this.m[this.m.length-1];if(c){if(c.op===1&&c.item.extId===i.item.extId){(0,A.$lL)(c.item,i.item);return}if(c.op===0&&c.item.item.extId===i.item.extId){(0,A.$lL)(c.item,i.item);return}}break}}this.m.push(i),this.f.isScheduled()||this.f.schedule()}expand(i,c){const h=this.tree.get(i);if(h){if((h.expandLevels===void 0||c>h.expandLevels)&&(h.expandLevels=c),h.expand===1){const t=this.M(h);return t.isOpen()?this.L(h,c-1):t.wait().then(()=>this.L(h,c-1))}else if(h.expand===3)return h.resolveBarrier?.isOpen()===!1?h.resolveBarrier.wait().then(()=>this.L(h,c-1)):this.L(h,c-1)}}dispose(){for(const i of this.tree.values())this.s.getApiFor(i.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(i,c){switch(c.op){case 3:this.O(m.$eL.joinToString(i.fullId,c.id));break;case 0:this.z(c.item,i);break;case 5:for(const h of c.ops)this.w(i,h);break;case 1:this.C(c.new,c.old,i.fullId.toString());break;case 2:this.J(i);break;case 4:this.pushDiff({op:1,item:{extId:i.fullId.toString(),item:c.update}});break;case 6:this.y(i.actual.uri);break;default:(0,N.$0c)(c)}}y(i){i&&this.pushDiff({op:2,uri:i,docv:this.s.getDocumentVersion(i)})}z(i,c){const h=m.$eL.fromExtHostTestItem(i,this.root.id,c?.actual),t=this.s.getApiFor(i);t.parent&&t.parent!==c?.actual&&this.s.getChildren(t.parent).delete(i.id);let p=this.tree.get(h.toString());if(!p){p={fullId:h,actual:i,expandLevels:c?.expandLevels?c.expandLevels-1:void 0,expand:0},i.tags.forEach(this.D,this),this.tree.set(p.fullId.toString(),p),this.G(i,c),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:p.expand,item:this.s.toITestItem(i)}}),this.I(i,p,c);return}if(p.actual===i){this.H(i,p,c);return}if(p.actual.uri?.toString()!==i.uri?.toString())return this.O(h.toString()),this.z(i,c);const a=this.s.getChildren(p.actual),g=p.actual,v=l(this.s.toITestItem(g),this.s.toITestItem(i));this.s.getApiFor(g).listener=void 0,p.actual=i,p.expand=0,v&&(v.hasOwnProperty("tags")&&(this.C(i.tags,g.tags,h.toString()),delete v.tags),this.w(p,{op:4,update:v})),this.I(i,p,c);for(const[f,u]of a)this.s.getChildren(i).get(u.id)||this.O(m.$eL.joinToString(h,u.id));this.y(p.actual.uri)}C(i,c,h){const t=new Set(c.map(p=>p.id));for(const p of i)t.delete(p.id)||this.D(p);this.pushDiff({op:1,item:{extId:h,item:{tags:i.map(p=>(0,A.$jL)(this.s.controllerId,p.id))}}}),t.forEach(this.F,this)}D(i){const c=this.j.get(i.id);c?c.refCount++:(this.j.set(i.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,A.$jL)(this.s.controllerId,i.id)}}))}F(i){const c=this.j.get(i);c&&!--c.refCount&&(this.j.delete(i),this.pushDiff({op:7,id:(0,A.$jL)(this.s.controllerId,i)}))}G(i,c){this.s.getApiFor(i).parent=c&&c.actual!==this.root?c.actual:void 0}H(i,c,h){this.G(i,h);const t=this.s.getApiFor(i);t.parent=h?.actual,t.listener=p=>this.w(c,p),this.J(c)}I(i,c,h){this.H(i,c,h);for(const[t,p]of this.s.getChildren(i))this.z(p,c)}J(i){let c;this.h?i.resolveBarrier?c=i.resolveBarrier.isOpen()?3:2:c=i.actual.canResolveChildren?1:0:c=0,c!==i.expand&&(i.expand=c,this.pushDiff({op:1,item:{extId:i.fullId.toString(),expand:c}}),c===1&&i.expandLevels!==void 0&&this.M(i))}L(i,c){if(c<0)return;const h=[];for(const[t,p]of this.s.getChildren(i.actual)){const a=this.expand(m.$eL.joinToString(i.fullId,p.id),c);(0,k.$7g)(a)&&h.push(a)}if(h.length)return Promise.all(h).then(()=>{})}M(i){if(i.resolveBarrier)return i.resolveBarrier;if(!this.h){const p=new k.$hh;return p.open(),p}i.expand=2,this.N(i);const c=i.resolveBarrier=new k.$hh,h=p=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,p)};let t;try{t=this.h(i.actual===this.root?void 0:i.actual)}catch(p){h(p)}return(0,k.$7g)(t)?t.catch(h).then(()=>{c.open(),this.J(i)}):(c.open(),this.J(i)),i.resolveBarrier}N(i){this.pushDiff({op:1,item:{extId:i.fullId.toString(),expand:i.expand}})}O(i){const c=this.tree.get(i);if(!c)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:i});const h=[c];for(;h.length;){const t=h.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const p of t.actual.tags)this.F(p.id);this.tree.delete(t.fullId.toString());for(const[p,a]of this.s.getChildren(t.actual))h.push(this.tree.get(m.$eL.joinToString(t.fullId,a.id)))}}}flushDiff(){const i=this.collectDiff();i.length&&this.g.fire(i)}}e.$EO=b;class $ extends Error{constructor(i){super(`Attempted to insert a duplicate test item ID ${i}`)}}e.$FO=$;class n extends Error{constructor(i){super(`TestItem with ID "${i}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$GO=n;class o extends Error{constructor(i,c,h){super(`TestItem with ID "${i}" is from controller "${c}" and cannot be added as a child of an item from controller "${h}".`)}}e.$HO=o;const s=(r,i,c)=>{let h=new Map;return{get size(){return h.size},forEach(t,p){for(const a of h.values())t.call(p,a,this)},[Symbol.iterator](){return h.entries()},replace(t){const p=new Map,a=new Set(h.keys()),g={op:5,ops:[]};for(const v of t){if(!(v instanceof c))throw new n(v.id);const f=i(v).controllerId;if(f!==r.controllerId)throw new o(v.id,f,r.controllerId);if(p.has(v.id))throw new $(v.id);p.set(v.id,v),a.delete(v.id),g.ops.push({op:0,item:v})}for(const v of a.keys())g.ops.push({op:3,id:v});r.listener?.(g),h=p},add(t){if(!(t instanceof c))throw new n(t.id);h.set(t.id,t),r.listener?.({op:0,item:t})},delete(t){h.delete(t)&&r.listener?.({op:3,id:t})},get(t){return h.get(t)},toJSON(){return Array.from(h.values())}}};e.$IO=s}),define(Pe[105],Re([1,0,75]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KO=e.$JO=void 0;const M=new WeakMap,C=(A,m)=>{const d={controllerId:m};return M.set(A,d),d};e.$JO=C;const N=A=>{const m=M.get(A);if(!m)throw new k.$GO(A?.id||"<unknown>");return m};e.$KO=N}),define(Pe[76],Re([1,0,12,2]),function(ee,e,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zzb=e.$yzb=e.$xzb=void 0,e.$Azb=C,e.$Bzb=A,e.$xzb="vscode-cdn.net",e.$yzb=`vscode-resource.${e.$xzb}`,e.$zzb=`'self' https://*.${e.$xzb}`;function C(m,d){return m.scheme===k.Schemas.http||m.scheme===k.Schemas.https?m:(d&&d.authority&&d.isRemote&&m.scheme===k.Schemas.file&&(m=M.URI.from({scheme:k.Schemas.vscodeRemote,authority:d.authority,path:m.path})),M.URI.from({scheme:k.Schemas.https,authority:`${m.scheme}+${N(m.authority)}.${e.$yzb}`,path:m.path,fragment:m.fragment,query:m.query}))}function N(m){return m.replace(/./g,d=>{const y=d.charCodeAt(0);return y>=97&&y<=122||y>=65&&y<=90||y>=48&&y<=57?d:"-"+y.toString(16).padStart(4,"0")})}function A(m){return m.replace(/-([0-9a-f]{4})/g,(d,y)=>String.fromCharCode(parseInt(y,16)))}}),define(Pe[220],Re([1,0,5,6,76]),function(ee,e,k,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tjc=void 0;class N{constructor(m,d,y){this.d=m,this.e=d,this.f=y,this.a=0,this.b=new M.$Tc,this.c=new Map,this.b.add(d.onDidChangeVisibleTextEditors(()=>{const O=d.getVisibleTextEditors();for(const D of this.c.values())O.indexOf(D.editor)<0&&D.inset.dispose()}))}dispose(){this.c.forEach(m=>m.inset.dispose()),this.b.dispose()}createWebviewEditorInset(m,d,y,O,D){let l;for(const i of this.e.getVisibleTextEditors(!0))if(i.value===m){l=i;break}if(!l)throw new Error("not a visible editor");const b=this,$=this.a++,n=new k.$7d,o=new k.$7d,s=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(i){return(0,C.$Azb)(i,b.f)}get cspSource(){return C.$zzb}set options(i){this.b=i,b.d.$setOptions($,i)}get options(){return this.b}set html(i){this.a=i,b.d.$setHtml($,i)}get html(){return this.a}get onDidReceiveMessage(){return n.event}postMessage(i){return b.d.$postMessage($,i)}},r=new class{constructor(){this.editor=m,this.line=d,this.height=y,this.webview=s,this.onDidDispose=o.event}dispose(){b.c.has($)&&(b.c.delete($),b.d.$disposeEditorInset($),o.fire(),o.dispose(),n.dispose())}};return this.d.$createEditorInset($,l.id,l.value.document.uri,d+1,y,O||{},D.identifier,D.extensionLocation),this.c.set($,{editor:m,inset:r,onDidReceiveMessage:n}),r}$onDidDispose(m){const d=this.c.get(m);d&&d.inset.dispose()}$onDidReceiveMessage(m,d){this.c.get(m)?.onDidReceiveMessage.fire(d)}}e.$Tjc=N}),define(Pe[106],Re([1,0,3]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wL=e.$vL=e.$uL=void 0,e.$uL="__",e.$vL=(0,k.$ii)("IAuthenticationService"),e.$wL=(0,k.$ii)("IAuthenticationExtensionsService")}),define(Pe[221],Re([1,0,3]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BP=e.VariableKind=e.$AP=void 0,e.$AP=(0,k.$ii)("configurationResolverService");var M;(function(N){N.Unknown="unknown",N.Env="env",N.Config="config",N.Command="command",N.Input="input",N.ExtensionInstallFolder="extensionInstallFolder",N.WorkspaceFolder="workspaceFolder",N.Cwd="cwd",N.WorkspaceFolderBasename="workspaceFolderBasename",N.UserHome="userHome",N.LineNumber="lineNumber",N.SelectedText="selectedText",N.File="file",N.FileWorkspaceFolder="fileWorkspaceFolder",N.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",N.RelativeFile="relativeFile",N.RelativeFileDirname="relativeFileDirname",N.FileDirname="fileDirname",N.FileExtname="fileExtname",N.FileBasename="fileBasename",N.FileBasenameNoExtension="fileBasenameNoExtension",N.FileDirnameBasename="fileDirnameBasename",N.ExecPath="execPath",N.ExecInstallFolder="execInstallFolder",N.PathSeparator="pathSeparator",N.PathSeparatorAlias="/"})(M||(e.VariableKind=M={}));class C extends Error{constructor(A,m){super(m),this.variable=A}}e.$BP=C}),define(Pe[222],Re([1,0,19,73,17,26,21,92,183,221,15]),function(ee,e,k,M,C,N,A,m,d,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QP=void 0;class D{constructor(b,$,n,o){this.h=new Map,this.a=b,this.b=$,this.g=n,o&&(this.c=o.then(s=>this.i(s)))}i(b){if(A.$c){const $=Object.create(null);return Object.keys(b).forEach(n=>{$[n.toLowerCase()]=b[n]}),$}return b}resolveWithEnvironment(b,$,n){return this.l({env:this.i(b),userHome:void 0},$?$.uri:void 0,n)}async resolveAsync(b,$){const n={env:await this.c,userHome:await this.g};return this.l(n,b?b.uri:void 0,$)}async j(b,$,n,o){const s=N.$Pn($);A.$c&&s.windows?Object.keys(s.windows).forEach(i=>s[i]=s.windows[i]):A.$d&&s.osx?Object.keys(s.osx).forEach(i=>s[i]=s.osx[i]):A.$e&&s.linux&&Object.keys(s.linux).forEach(i=>s[i]=s.linux[i]),delete s.windows,delete s.osx,delete s.linux;const r={env:await this.c,userHome:await this.g};return this.l(r,b?b.uri:void 0,s,n,o)}async resolveAnyAsync(b,$,n){return this.j(b,$,n)}async resolveAnyMap(b,$,n){const o=new Map;return{newConfig:await this.j(b,$,n,o),resolvedVariables:o}}resolveWithInteractionReplace(b,$,n,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(b,$,n,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(b,$){if(this.h.has(b))throw new Error("Variable "+b+" is contributed twice.");this.h.set(b,$)}async l(b,$,n,o,s){if(C.$Vf(n))return this.m(b,$,n,o,s);if(Array.isArray(n))return Promise.all(n.map(r=>this.l(b,$,r,o,s)));if(C.$Xf(n)){const r=Object.create(null),i=await Promise.all(Object.keys(n).map(async c=>[await this.m(b,$,c,o,s),await this.l(b,$,n[c],o,s)]));for(const[c,h]of i)r[c]=h;return r}return n}m(b,$,n,o,s){return(0,O.$df)(n,D.VARIABLE_REGEXP,async(r,i)=>{if(i.includes(D.VARIABLE_LHS))return r;let c=await this.o(b,r,i,$,o);return s?.set(i,c),c!==r&&C.$Vf(c)&&c.match(D.VARIABLE_REGEXP)&&(c=await this.m(b,$,c,o,s)),c})}n(b){return this.b?this.b.getUriLabel(b,{noPrefix:!0}):b.fsPath}async o(b,$,n,o,s){let r;const i=n.split(":");i.length>1&&(n=i[0],r=i[1]);const c=p=>{const a=this.a.getFilePath();if(a)return(0,m.$iw)(a);throw new y.$BP(p,(0,d.localize)(0,null,$))},h=p=>{const a=c(p);if(this.a.getWorkspaceFolderPathForFile){const g=this.a.getWorkspaceFolderPathForFile();if(g)return(0,m.$iw)(g)}throw new y.$BP(p,(0,d.localize)(1,null,$,k.$oc(a)))},t=p=>{if(r){const a=this.a.getFolderUri(r);if(a)return a;throw new y.$BP(p,(0,d.localize)(2,null,$,r))}if(o)return o;throw this.a.getWorkspaceFolderCount()>1?new y.$BP(p,(0,d.localize)(3,null,$)):new y.$BP(p,(0,d.localize)(4,null,$))};switch(n){case"env":if(r){if(b.env){const p=b.env[A.$c?r.toLowerCase():r];if(C.$Vf(p))return p}return""}throw new y.$BP(y.VariableKind.Env,(0,d.localize)(5,null,$));case"config":if(r){const p=this.a.getConfigurationValue(o,r);if(C.$5f(p))throw new y.$BP(y.VariableKind.Config,(0,d.localize)(6,null,$,r));if(C.$Xf(p))throw new y.$BP(y.VariableKind.Config,(0,d.localize)(7,null,$,r));return p}throw new y.$BP(y.VariableKind.Config,(0,d.localize)(8,null,$));case"command":return this.p(y.VariableKind.Command,$,r,s,"command");case"input":return this.p(y.VariableKind.Input,$,r,s,"input");case"extensionInstallFolder":if(r){const p=await this.a.getExtension(r);if(!p)throw new y.$BP(y.VariableKind.ExtensionInstallFolder,(0,d.localize)(9,null,$,r));return this.n(p.extensionLocation)}throw new y.$BP(y.VariableKind.ExtensionInstallFolder,(0,d.localize)(10,null,$));default:switch(n){case"workspaceRoot":case"workspaceFolder":return(0,m.$iw)(this.n(t(y.VariableKind.WorkspaceFolder)));case"cwd":return o||r?(0,m.$iw)(this.n(t(y.VariableKind.Cwd))):M.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,m.$iw)(k.$oc(this.n(t(y.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(b.userHome)return b.userHome;throw new y.$BP(y.VariableKind.UserHome,(0,d.localize)(11,null,$))}case"lineNumber":{const p=this.a.getLineNumber();if(p)return p;throw new y.$BP(y.VariableKind.LineNumber,(0,d.localize)(12,null,$))}case"selectedText":{const p=this.a.getSelectedText();if(p)return p;throw new y.$BP(y.VariableKind.SelectedText,(0,d.localize)(13,null,$))}case"file":return c(y.VariableKind.File);case"fileWorkspaceFolder":return h(y.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return k.$oc(h(y.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return o||r?k.$mc(this.n(t(y.VariableKind.RelativeFile)),c(y.VariableKind.RelativeFile)):c(y.VariableKind.RelativeFile);case"relativeFileDirname":{const p=k.$nc(c(y.VariableKind.RelativeFileDirname));if(o||r){const a=k.$mc(this.n(t(y.VariableKind.RelativeFileDirname)),p);return a.length===0?".":a}return p}case"fileDirname":return k.$nc(c(y.VariableKind.FileDirname));case"fileExtname":return k.$pc(c(y.VariableKind.FileExtname));case"fileBasename":return k.$oc(c(y.VariableKind.FileBasename));case"fileBasenameNoExtension":{const p=k.$oc(c(y.VariableKind.FileBasenameNoExtension));return p.slice(0,p.length-k.$pc(p).length)}case"fileDirnameBasename":return k.$oc(k.$nc(c(y.VariableKind.FileDirnameBasename)));case"execPath":{const p=this.a.getExecPath();return p||$}case"execInstallFolder":{const p=this.a.getAppRoot();return p||$}case"pathSeparator":case"/":return k.sep;default:try{const p=r?`${n}:${r}`:n;return this.p(y.VariableKind.Unknown,$,p,s,void 0)}catch{return $}}}}p(b,$,n,o,s){if(n&&o){const r=s===void 0?o[n]:o[s+":"+n];if(typeof r=="string")return r;throw new y.$BP(b,(0,d.localize)(14,null,$))}return $}}e.$QP=D,D.VARIABLE_LHS="${",D.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Pe[107],Re([1,0,3,104]),function(ee,e,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$BD=void 0,e.$CD=y,e.$DD=l,e.$ED=b,e.$BD=(0,k.$ii)("editorGroupsService");var C;(function($){$[$.UP=0]="UP",$[$.DOWN=1]="DOWN",$[$.LEFT=2]="LEFT",$[$.RIGHT=3]="RIGHT"})(C||(e.GroupDirection=C={}));var N;(function($){$[$.HORIZONTAL=0]="HORIZONTAL",$[$.VERTICAL=1]="VERTICAL"})(N||(e.GroupOrientation=N={}));var A;(function($){$[$.FIRST=0]="FIRST",$[$.LAST=1]="LAST",$[$.NEXT=2]="NEXT",$[$.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var m;(function($){$[$.MAXIMIZE=0]="MAXIMIZE",$[$.EXPAND=1]="EXPAND",$[$.EVEN=2]="EVEN"})(m||(e.GroupsArrangement=m={}));var d;(function($){$[$.COPY_EDITORS=0]="COPY_EDITORS",$[$.MOVE_EDITORS=1]="MOVE_EDITORS"})(d||(e.MergeGroupMode=d={}));function y($){const n=$;return(0,M.$mF)(n?.editor)&&(0,M.$mF)(n?.replacement)}var O;(function($){$[$.CREATION_TIME=0]="CREATION_TIME",$[$.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",$[$.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(O||(e.GroupsOrder=O={}));var D;(function($){$[$.NEW_EDITOR=1]="NEW_EDITOR",$[$.MOVE_EDITOR=2]="MOVE_EDITOR",$[$.COPY_EDITOR=3]="COPY_EDITOR"})(D||(e.OpenEditorContext=D={}));function l($){const n=$;return!!n&&typeof n.id=="number"&&Array.isArray(n.editors)}function b($){return $.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}}),define(Pe[223],Re([1,0,3,107]),function(ee,e,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ID=e.$HD=e.$GD=e.$FD=void 0,e.$JD=C,e.$FD=(0,k.$ii)("editorService"),e.$GD=-1,e.$HD=-2,e.$ID=-3;function C(N){const A=N;return typeof N=="number"||(0,M.$DD)(A)}}),define(Pe[224],Re([1,0,3,190]),function(ee,e,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PL=void 0,e.$PL=(0,k.$ji)(M.$pi)}),define(Pe[108],Re([1,0,20,5,19,6,11]),function(ee,e,k,M,C,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t$b=e.$s$b=e.$r$b=e.$q$b=e.$p$b=void 0;class m{constructor(r,i){this.versionId=r,this.removedDueToLooping=i}}e.$p$b=m;class d{static isHostExtension(r,i,c){if(i.getExtensionDescription(r))return!1;const h=c.getExtensionDescription(r);return h?!!((h.main||h.browser)&&h.api==="none"):!1}constructor(r,i){this.j=r,this.c=new M.$7d,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(n),this.f=new k.$Gm,this.g=[],this.h=new Map;for(const r of this.e){if(this.f.has(r.identifier)){console.error("Extension `"+r.identifier.value+"` is already registered");continue}this.f.set(r.identifier,r),this.g.push(r);const i=this.j.readActivationEvents(r);for(const c of i)this.h.has(c)||this.h.set(c,[]),this.h.get(c).push(r)}}set(r){return this.e=r,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(r,i){this.e=o(this.e,i),this.e=this.e.concat(r);const c=d.l(this.e);return this.e=o(this.e,c.map(h=>h.identifier)),this.k(),this.d++,this.c.fire(void 0),new m(this.d,c)}static l(r){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(a){this.d.has(a)||(this.d.add(a),this.e.push(a))}addArc(a,g){this.addNode(a),this.addNode(g),this.c.has(a)?this.c.get(a).push(g):this.c.set(a,[g])}getArcs(a){return this.c.has(a)?this.c.get(a):[]}hasOnlyGoodArcs(a,g){const v=i.getArcs(a);for(let f=0;f<v.length;f++)if(!g.has(v[f]))return!1;return!0}getNodes(){return this.e}},c=new k.$Gm;for(const a of r)if(c.set(a.identifier,a),a.extensionDependencies)for(const g of a.extensionDependencies)i.addArc(k.$Em.toKey(a.identifier),k.$Em.toKey(g));const h=new Set;i.getNodes().filter(a=>i.getArcs(a).length===0).forEach(a=>h.add(a));const t=i.getNodes().filter(a=>!h.has(a));let p;do{p=!1;for(let a=0;a<t.length;a++){const g=t[a];i.hasOnlyGoodArcs(g,h)&&(t.splice(a,1),a--,h.add(g),p=!0)}}while(p);return t.map(a=>c.get(a))}containsActivationEvent(r){return this.h.has(r)}containsExtension(r){return this.f.has(r)}getExtensionDescriptionsForActivationEvent(r){const i=this.h.get(r);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new y(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(r){const i=this.f.get(r);return i||void 0}getExtensionDescriptionByUUID(r){for(const i of this.g)if(i.uuid===r)return i}getExtensionDescriptionByIdOrUUID(r,i){return this.getExtensionDescription(r)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$q$b=d;class y{constructor(r,i){this.versionId=r,this.extensions=i}}e.$r$b=y;class O{constructor(r){this.d=new b,this.c=new d(r,[])}async acquireLock(r){const i=await this.d.acquire(r);return new D(this,i)}deltaExtensions(r,i,c){if(!r.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,c)}containsActivationEvent(r){return this.c.containsActivationEvent(r)}containsExtension(r){return this.c.containsExtension(r)}getExtensionDescriptionsForActivationEvent(r){return this.c.getExtensionDescriptionsForActivationEvent(r)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(r){return this.c.getExtensionDescription(r)}getExtensionDescriptionByUUID(r){return this.c.getExtensionDescriptionByUUID(r)}getExtensionDescriptionByIdOrUUID(r,i){return this.c.getExtensionDescriptionByIdOrUUID(r,i)}}e.$s$b=O;class D extends N.$Uc{constructor(r,i){super(),this.f=r,this.c=!1,this.B(i)}isAcquiredFor(r){return!this.c&&this.f===r}}e.$t$b=D;class l{constructor(r){this.name=r;const i=(0,A.$bh)();this.promise=i.promise,this.c=i.resolve}resolve(r){this.c(r)}}class b{constructor(){this.c=[],this.d=!1}async acquire(r){const i=new l(r);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const r=this.c.shift();this.d=!0;let i=!0;const c=setTimeout(()=>{i&&console.warn(`The customer named ${r.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),h=()=>{i&&(clearTimeout(c),i=!1,this.d=!1,this.e())};r.resolve((0,N.$Sc)(h))}}var $;(function(s){s[s.Builtin=0]="Builtin",s[s.User=1]="User",s[s.Dev=2]="Dev"})($||($={}));function n(s,r){const i=s.isBuiltin?0:s.isUnderDevelopment?2:1,c=r.isBuiltin?0:r.isUnderDevelopment?2:1;if(i!==c)return i-c;const h=C.$hc.basename(s.extensionLocation.path),t=C.$hc.basename(r.extensionLocation.path);return h<t?-1:h>t?1:0}function o(s,r){const i=new k.$Fm(r);return s.filter(c=>!i.has(c.identifier))}}),define(Pe[77],Re([1,0,22]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$Mm=A,e.$Nm=m;var M;(function(y){y[y.Desktop=1]="Desktop",y[y.Web=2]="Web"})(M||(e.UIKind=M={}));var C;(function(y){y[y.VersionMismatch=55]="VersionMismatch",y[y.UnexpectedError=81]="UnexpectedError"})(C||(e.ExtensionHostExitCode=C={}));var N;(function(y){y[y.Initialized=0]="Initialized",y[y.Ready=1]="Ready",y[y.Terminate=2]="Terminate"})(N||(e.MessageType=N={}));function A(y){const O=k.$ue.alloc(1);switch(y){case 0:O.writeUInt8(1,0);break;case 1:O.writeUInt8(2,0);break;case 2:O.writeUInt8(3,0);break}return O}function m(y,O){if(y.byteLength!==1)return!1;switch(y.readUInt8(0)){case 1:return O===0;case 2:return O===1;case 3:return O===2;default:return!1}}var d;(function(y){y.Start="START_NATIVE_LOG",y.End="END_NATIVE_LOG"})(d||(e.NativeLogMarkers=d={}))}),define(Pe[62],Re([1,0,3,5,13,27,77,58,59,26,2,6,171]),function(ee,e,k,M,C,N,A,m,d,y,O,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9O=e.$7O=e.$6O=void 0,e.$8O=n;let b=class extends D.$Uc{constructor(s,r){super(),this.s=s,this.t=r,this.a=this.B(new M.$7d),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new M.$7d),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=O.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=r.createLogger(this.m,{id:d.$0o,name:(0,l.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(r.onDidChangeLogLevel(i=>{(0,C.$Qj)(i)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===C.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(s,r,i){const c=this.getTelemetryDetails(),h=new $(r,i,s,this.n,this.j,this.getBuiltInCommonProperties(s),{isUsageEnabled:c.isUsageEnabled,isErrorsEnabled:c.isErrorsEnabled}),t=this.r.get(s.identifier.value)??[];return this.r.set(s.identifier.value,[...t,h]),h.apiTelemetryLogger}$initializeTelemetryLevel(s,r,i){this.f=s,this.g=r,this.c=i??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(s){const r=Object.create(null);switch(r["common.extname"]=`${s.publisher}.${s.name}`,r["common.extversion"]=s.version,r["common.vscodemachineid"]=this.s.telemetryInfo.machineId,r["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,r["common.sqmid"]=this.s.telemetryInfo.sqmId,r["common.vscodeversion"]=this.s.version,r["common.isnewappinstall"]=n(this.s.telemetryInfo.firstSessionDate),r["common.product"]=this.s.environment.appHost,this.s.uiKind){case A.UIKind.Web:r["common.uikind"]="web";break;case A.UIKind.Desktop:r["common.uikind"]="desktop";break;default:r["common.uikind"]="unknown"}return r["common.remotename"]=(0,m.$vm)((0,d.$dp)(this.s.remote.authority)),r}$onDidChangeTelemetryLevel(s){this.h=this.getTelemetryConfiguration(),this.f=s;const r=this.getTelemetryDetails();this.r.forEach((i,c)=>{const h=i.filter(t=>!t.isDisposed);h.length===0?this.r.delete(c):this.r.set(c,h)}),this.r.forEach(i=>{for(const c of i)c.updateTelemetryEnablements(r.isUsageEnabled,r.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(s,r){const c=this.r.get(s.value)?.filter(t=>!t.isDisposed);if(!c)return this.r.delete(s.value),!1;let h=!1;for(const t of c)t.ignoreUnhandledExtHostErrors||(t.logError(r),h=!0);return h}};e.$6O=b,e.$6O=b=Xe([qe(0,N.$5O),qe(1,C.$Pj)],b);class ${static validateSender(s){if(typeof s!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof s.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof s.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof s.flush<"u"&&typeof s.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(s,r,i,c,h,t,p){this.g=i,this.h=c,this.i=h,this.j=t,this.a=new M.$7d,this.ignoreUnhandledExtHostErrors=r?.ignoreUnhandledErrors??!1,this.b=r?.ignoreBuiltInCommonProperties??!1,this.c=r?.additionalCommonProperties,this.f=s,this.d={isUsageEnabled:p.isUsageEnabled,isErrorsEnabled:p.isErrorsEnabled}}updateTelemetryEnablements(s,r){this.e&&(this.d={isUsageEnabled:s,isErrorsEnabled:r},this.a.fire(this.e))}mixInCommonPropsAndCleanData(s){let r="properties"in s?s.properties??{}:s;return r=(0,d.$gp)(r,[]),this.c&&(r=(0,y.$Sn)(r,this.c)),this.b||(r=(0,y.$Sn)(r,this.j)),"properties"in s?s.properties=r:s=r,s}k(s,r){this.f&&(this.g.publisher==="vscode"?s=this.g.name+"/"+s:s=this.g.identifier.value+"/"+s,r=this.mixInCommonPropsAndCleanData(r||{}),this.i||this.f?.sendEventData(s,r),this.h.trace(s,r))}logUsage(s,r){this.d.isUsageEnabled&&this.k(s,r)}logError(s,r){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof s=="string")this.k(s,r);else{const i={name:s.name,message:s.message,stack:s.stack,cause:s.cause},c=(0,d.$gp)(i,[]),h=new Error(c.message,{cause:c.cause});h.stack=c.stack,h.name=c.name,r=this.mixInCommonPropsAndCleanData(r||{}),this.i||this.f.sendErrorData(h,r),this.h.trace("exception",r)}}get apiTelemetryLogger(){if(!this.e){const s=this,r={logUsage:s.logUsage.bind(s),get isUsageEnabled(){return s.d.isUsageEnabled},get isErrorsEnabled(){return s.d.isErrorsEnabled},logError:s.logError.bind(s),dispose:s.dispose.bind(s),onDidChangeEnableStates:s.a.event.bind(s)};this.e=Object.freeze(r)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let s=this.f;this.f=void 0,Promise.resolve(s.flush()).then(s=void 0),this.e=void 0}else this.f=void 0}}e.$7O=$;function n(o){const s=Date.now()-new Date(o).getTime();return isNaN(s)?!1:s<1e3*60*60*24}e.$9O=(0,k.$ii)("IExtHostTelemetry")}),define(Pe[25],Re([1,0,5,2,199,103,20,3]),function(ee,e,k,M,C,N,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iG=e.ActivationKind=e.$fG=e.$eG=e.$bG=e.ExtensionHostStartup=e.$aG=e.$_F=e.$$F=e.$0F=void 0,e.$cG=l,e.$dG=b,e.$gG=s,e.$hG=r,e.$0F=Object.freeze({identifier:new A.$Em("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:M.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$$F="extensions.webWorker",e.$_F=(0,m.$ii)("extensionService");class d{constructor(h){this.dependency=h}}e.$aG=d;var y;(function(c){c[c.EagerAutoStart=1]="EagerAutoStart",c[c.EagerManualStart=2]="EagerManualStart",c[c.Lazy=3]="Lazy"})(y||(e.ExtensionHostStartup=y={}));class O{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(h,t,p){this.c=h,this.d=t.slice(0),this.e=p.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:N.$UF.createActivationEventsMap(this.d)}}set(h,t,p){if(this.c>h)throw new Error(`ExtensionHostExtensions: invalid versionId ${h} (current: ${this.c})`);const a=[],g=[],v=[],f=[],u=D(this.d),E=D(t),w=(Q,H)=>Q.extensionLocation.toString()===H.extensionLocation.toString()||Q.isBuiltin===H.isBuiltin||Q.isUserBuiltin===H.isUserBuiltin||Q.isUnderDevelopment===H.isUnderDevelopment;for(const Q of this.d){const H=E.get(Q.identifier);if(!H){a.push(Q.identifier),u.delete(Q.identifier);continue}if(!w(Q,H)){a.push(Q.identifier),u.delete(Q.identifier);continue}}for(const Q of t){const H=u.get(Q.identifier);if(!H){g.push(Q);continue}if(!w(H,Q)){a.push(H.identifier),u.delete(H.identifier);continue}}const I=new A.$Fm(this.e),S=new A.$Fm(p);for(const Q of this.e)S.has(Q)||v.push(Q);for(const Q of p)I.has(Q)||f.push(Q);const P=N.$UF.createActivationEventsMap(g),U={versionId:h,toRemove:a,toAdd:g,addActivationEvents:P,myToRemove:v,myToAdd:f};return this.delta(U),U}delta(h){if(this.c>=h.versionId)return null;const{toRemove:t,toAdd:p,myToRemove:a,myToAdd:g}=h,v=new A.$Fm(t),f=new A.$Fm(a);for(let u=0;u<this.d.length;u++)v.has(this.d[u].identifier)&&(this.d.splice(u,1),u--);for(let u=0;u<this.e.length;u++)f.has(this.e[u])&&(this.e.splice(u,1),u--);for(const u of p)this.d.push(u);for(const u of g)this.e.push(u);return this.f=null,h}containsExtension(h){for(const t of this.e)if(A.$Em.equals(t,h))return!0;return!1}containsActivationEvent(h){return this.f||(this.f=this.g()),this.f.has(h)}g(){const h=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const p=N.$UF.readActivationEvents(t);for(const a of p)h.add(a)}return h}}e.$bG=O;function D(c){const h=new A.$Gm;for(const t of c)h.set(t.identifier,t);return h}function l(c,h){return!0}function b(c,h){if(!l(c,h))throw new Error(`Extension '${c.identifier.value}' CANNOT use API proposal: ${h}.
Its package.json#enabledApiProposals-property declares: ${c.enabledApiProposals?.join(", ")??"[]"} but NOT ${h}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${c.identifier.value}`)}class ${constructor(h,t,p,a){this.codeLoadingTime=h,this.activateCallTime=t,this.activateResolvedTime=p,this.activationReason=a}}e.$eG=$;class n{constructor(h,t){this.description=h,this.value=t}}e.$fG=n;var o;(function(c){c[c.Normal=0]="Normal",c[c.Immediate=1]="Immediate"})(o||(e.ActivationKind=o={}));function s(c){return{type:c.isBuiltin?0:1,isBuiltin:c.isBuiltin||c.isUserBuiltin,identifier:{id:(0,C.$mp)(c.publisher,c.name),uuid:c.uuid},manifest:c,location:c.extensionLocation,targetPlatform:c.targetPlatform,validations:[],isValid:!0}}function r(c,h){return{identifier:new A.$Em((0,C.$kp)(c.manifest.publisher,c.manifest.name)),isBuiltin:c.type===0,isUserBuiltin:c.type===1&&c.isBuiltin,isUnderDevelopment:!!h,extensionLocation:c.location,...c.manifest,uuid:c.identifier.uuid,targetPlatform:c.targetPlatform}}class i{constructor(){this.onDidRegisterExtensions=k.Event.None,this.onDidChangeExtensionsStatus=k.Event.None,this.onDidChangeExtensions=k.Event.None,this.onWillActivateByEvent=k.Event.None,this.onDidChangeResponsiveChange=k.Event.None,this.onWillStop=k.Event.None,this.extensions=[]}activateByEvent(h){return Promise.resolve(void 0)}activateById(h,t){return Promise.resolve(void 0)}activationEventIsDone(h){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(h){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(h,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(h){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$iG=i}),define(Pe[225],Re([1,0,14,108,20,25,13,11]),function(ee,e,k,M,C,N,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ikc=e.$hkc=e.$gkc=e.$fkc=e.$ekc=e.$dkc=void 0;class d{constructor(s,r,i,c){this.startup=s,this.codeLoadingTime=r,this.activateCallTime=i,this.activateResolvedTime=c}}e.$dkc=d,d.NONE=new d(!1,-1,-1,-1);class y{constructor(s){this.a=s,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(s,r){return s===-1||r===-1?-1:r-s}build(){return new d(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$ekc=y;class O{constructor(s,r,i,c,h,t){this.activationFailed=s,this.activationFailedError=r,this.activationTimes=i,this.module=c,this.exports=h,this.subscriptions=t}}e.$fkc=O;class D extends O{constructor(s){super(!1,null,s,{activate:void 0,deactivate:void 0},void 0,[])}}e.$gkc=D;class l extends O{constructor(){super(!1,null,d.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$hkc=l;class b extends O{constructor(s){super(!0,s,d.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let $=class{constructor(s,r,i,c){this.g=c,this.a=s,this.b=r,this.c=i,this.d=new C.$Gm,this.f=Object.create(null)}dispose(){for(const[s,r]of this.d)r.dispose()}async waitForActivatingExtensions(){const s=[];for(const[r,i]of this.d)s.push(i.wait());await Promise.all(s)}isActivated(s){const r=this.d.get(s);return!!(r&&r.value)}getActivatedExtension(s){const r=this.d.get(s);if(!r||!r.value)throw new Error(`Extension '${s.value}' is not known or not activated`);return r.value}async activateByEvent(s,r){if(this.f[s])return;const i=this.a.getExtensionDescriptionsForActivationEvent(s);await this.h(i.map(c=>({id:c.identifier,reason:{startup:r,extensionId:c.identifier,activationEvent:s}}))),this.f[s]=!0}activateById(s,r){const i=this.a.getExtensionDescription(s);if(!i)throw new Error(`Extension '${s.value}' is not known`);return this.h([{id:i.identifier,reason:r}])}async h(s){const r=s.filter(i=>!this.isActivated(i.id)).map(i=>this.j(i));await Promise.all(r.map(i=>i.wait()))}j(s){if(this.d.has(s.id))return this.d.get(s.id);if(this.l(s.id))return this.k(s,null,[],null);const r=this.a.getExtensionDescription(s.id);if(!r){const h=new Error(`Cannot activate unknown extension '${s.id.value}'`),t=this.k(s,null,[],new b(h));return this.c.onExtensionActivationError(s.id,h,new N.$aG(s.id.value)),t}const i=[],c=typeof r.extensionDependencies>"u"?[]:r.extensionDependencies;for(const h of c){if(this.m(h))continue;const t=this.d.get(h);if(t){i.push(t);continue}if(this.l(h)){i.push(this.j({id:this.b.getExtensionDescription(h).identifier,reason:s.reason}));continue}const p=this.a.getExtensionDescription(h);if(p){if(!p.main&&!p.browser)continue;i.push(this.j({id:p.identifier,reason:s.reason}));continue}const a=r.displayName||r.identifier.value,g=new Error(`Cannot activate the '${a}' extension because it depends on unknown extension '${h}'`),v=this.k(s,r.displayName,[],new b(g));return this.c.onExtensionActivationError(r.identifier,g,new N.$aG(h)),v}return this.k(s,r.displayName,i,null)}k(s,r,i,c){const h=new n(s.id,r,s.reason,i,c,this.c,this.g);return this.d.set(s.id,h),h}l(s){return M.$q$b.isHostExtension(s,this.a,this.b)}m(s){const r=this.b.getExtensionDescription(s);return r?!r.main&&!r.browser:!1}};e.$ikc=$,e.$ikc=$=Xe([qe(3,A.$Oj)],$);let n=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(s,r,i,c,h,t,p){this.c=s,this.d=r,this.f=i,this.g=c,this.h=h,this.j=t,this.k=p,this.a=new m.$hh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let s=0;s<this.g.length;s++){const r=this.g[s];if(r.value&&!r.value.activationFailed){this.g.splice(s,1),s--;continue}if(r.value&&r.value.activationFailed){const i=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${r.friendlyName}' failed to activate`);i.detail=r.value.activationFailedError,this.h=new b(i),this.j.onExtensionActivationError(this.c,i,null);return}}this.g.length>0&&await Promise.race(this.g.map(s=>s.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(s){const r=new Error;if(s&&s.name&&(r.name=s.name),s&&s.message?r.message=`Activating extension '${this.c.value}' failed: ${s.message}.`:r.message=`Activating extension '${this.c.value}' failed: ${s}.`,s&&s.stack&&(r.stack=s.stack),this.h=new b(r),this.b&&k.$4(s))return;this.j.onExtensionActivationError(this.c,r,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(s)}}};n=Xe([qe(6,A.$Oj)],n)}),define(Pe[226],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",aiTextSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authLearnMore:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipant.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentThreadApplicability:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts",commentingRangeHint:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribCommentsViewThreadMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts",contribDiffEditorGutterToolBarMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModels.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputMultiDiff:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",terminalShellIntegration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Pe[227],Re([1,0,185,14,32,98,72,30,20,226,195,103]),function(ee,e,k,M,C,N,A,m,d,y,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9F=e.$8F=e.$7F=e.$6F=e.$5F=e.$4F=void 0;const l=m.$2n.as(A.$3n.JSONContribution);class b{constructor(h,t,p){this.a=h,this.b=t,this.c=p}d(h,t){this.a({type:h,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(h){this.d(C.default.Error,h)}warn(h){this.d(C.default.Warning,h)}info(h){this.d(C.default.Info,h)}}e.$4F=b;class ${static a(h){const t=new d.$Fm;for(let p=0,a=h.length;p<a;p++)t.add(h[p].description.identifier);return t}static compute(h,t){if(!h||!h.length)return new $(t,[]);if(!t||!t.length)return new $([],h);const p=this.a(h),a=this.a(t),g=t.filter(f=>!p.has(f.description.identifier)),v=h.filter(f=>!a.has(f.description.identifier));return new $(g,v)}constructor(h,t){this.added=h,this.removed=t}}e.$5F=$;class n{constructor(h,t){this.name=h,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(h){if(this.a!==null)throw new Error("Handler already set!");this.a=h,this.d()}acceptUsers(h){this.c=$.compute(this.b,h),this.b=h,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(h){(0,M.$1)(h)}}}e.$6F=n;const o={type:"string",enum:["ui","workspace"],enumDescriptions:[k.localize(0,null),k.localize(1,null)]},s="vscode://schemas/vscode-extensions";e.$7F={properties:{engines:{type:"object",description:k.localize(2,null),properties:{vscode:{type:"string",description:k.localize(3,null),default:"^1.22.0"}}},publisher:{description:k.localize(4,null),type:"string"},displayName:{description:k.localize(5,null),type:"string"},categories:{description:k.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:d.$Dm},{type:"string",const:"Languages",deprecationMessage:k.localize(7,null)}]}},galleryBanner:{type:"object",description:k.localize(8,null),properties:{color:{description:k.localize(9,null),type:"string"},theme:{description:k.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:k.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:k.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:k.localize(13,null)},enabledApiProposals:{markdownDescription:k.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals),markdownEnumDescriptions:Object.values(y.allApiProposals)}},api:{markdownDescription:k.localize(15,null),type:"string",enum:["none"],enumDescriptions:[k.localize(16,null)]},activationEvents:{description:k.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:k.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:k.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:k.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:k.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:k.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:k.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:k.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:k.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:k.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:k.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:k.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:k.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:k.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:k.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:k.localize(32,null)},{label:"onUri",body:"onUri",description:k.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:k.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:k.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:k.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:k.localize(37,null)},{label:"onRenderer",description:k.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:k.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:k.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:k.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:k.localize(42,null)},{label:"*",description:k.localize(43,null),body:"*"}]}},badges:{type:"array",description:k.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:k.localize(45,null)},href:{type:"string",description:k.localize(46,null)},description:{type:"string",description:k.localize(47,null)}}}},markdown:{type:"string",description:k.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:k.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:k.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:N.$Go}},extensionPack:{description:k.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:N.$Go}},extensionKind:{description:k.localize(52,null),type:"array",items:o,default:["workspace"],defaultSnippets:[{body:["ui"],description:k.localize(53,null)},{body:["workspace"],description:k.localize(54,null)},{body:["ui","workspace"],description:k.localize(55,null)},{body:["workspace","ui"],description:k.localize(56,null)},{body:[],description:k.localize(57,null)}]},capabilities:{description:k.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:k.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:k.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[k.localize(61,null),k.localize(62,null),k.localize(63,null)]},description:{type:"string",markdownDescription:k.localize(64,null)}}},untrustedWorkspaces:{description:k.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:k.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[k.localize(67,null),k.localize(68,null),k.localize(69,null)]},restrictedConfigurations:{description:k.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:k.localize(71,null)}}}}},sponsor:{description:k.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:k.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:k.localize(74,null),type:"string"},"vscode:uninstall":{description:k.localize(75,null),type:"string"}}},icon:{type:"string",description:k.localize(76,null)},l10n:{type:"string",description:k.localize(77,null)},pricing:{type:"string",markdownDescription:k.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class r{constructor(){this.a=new Map}registerExtensionPoint(h){if(this.a.has(h.extensionPoint))throw new Error("Duplicate extension point: "+h.extensionPoint);const t=new n(h.extensionPoint,h.defaultExtensionKind);return this.a.set(h.extensionPoint,t),h.activationEventsGenerator&&D.$UF.register(h.extensionPoint,h.activationEventsGenerator),e.$7F.properties.contributes.properties[h.extensionPoint]=h.jsonSchema,l.registerSchema(s,e.$7F),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$8F=r;const i={ExtensionsRegistry:"ExtensionsRegistry"};m.$2n.add(i.ExtensionsRegistry,new r),e.$9F=m.$2n.as(i.ExtensionsRegistry),l.registerSchema(s,e.$7F),l.registerSchema(O.$9j,{properties:{extensionEnabledApiProposals:{description:k.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals),markdownEnumDescriptions:Object.values(y.allApiProposals)}}]}}}})}),define(Pe[228],Re([1,0,181,17,26,227,33,5]),function(ee,e,k,M,C,N,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yH=void 0;const d={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:k.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:k.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:k.localize(2,null),default:""}}};var y;(function(l){function b($,n,o){if(!$)return;const s=M.$Vf($.type)?$.type:void 0;if(!s||s.length===0){o.error(k.localize(3,null));return}const r=[];if(Array.isArray($.required))for(const i of $.required)M.$Vf(i)&&r.push(i);return{extensionId:n.value,taskType:s,required:r,properties:$.properties?C.$Pn($.properties):{},when:$.when?A.$gj.deserialize($.when):void 0}}l.from=b})(y||(y={}));const O=N.$9F.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(l,b)=>{for(const $ of l)$.type&&b.push(`onTaskType:${$.type}`)},jsonSchema:{description:k.localize(4,null),type:"array",items:d}});class D{constructor(){this.d=new m.$7d,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((b,$)=>{O.setHandler((n,o)=>{this.c=void 0;try{for(const s of o.removed){const r=s.value;for(const i of r)this.a&&i.type&&this.a[i.type]&&delete this.a[i.type]}for(const s of o.added){const r=s.value;for(const i of r){const c=y.from(i,s.description.identifier,s.collector);c&&(this.a[c.taskType]=c)}}(o.removed.length>0||o.added.length>0)&&this.d.fire()}catch{}b(void 0)})})}onReady(){return this.b}get(b){return this.a[b]}all(){return Object.keys(this.a).map(b=>this.a[b])}getJsonSchema(){if(this.c===void 0){const b=[];for(const $ of this.all()){const n={type:"object",additionalProperties:!1};$.required.length>0&&(n.required=$.required.slice(0)),$.properties!==void 0?n.properties=C.$Pn($.properties):n.properties=Object.create(null),n.properties.type={type:"string",enum:[$.taskType]},b.push(n)}this.c={oneOf:b}}return this.c}}e.$yH=new D}),define(Pe[229],Re([1,0,182,17,23,26,33,228]),function(ee,e,k,M,C,N,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$IH=e.JsonSchemaVersion=e.ExecutionEngine=e.$HH=e.$GH=e.$FH=e.$EH=e.$DH=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$CH=e.ShellQuoting=e.$BH=e.$AH=e.$zH=void 0,e.$zH="settings",e.$AH=new A.$zj("taskRunning",!1,k.localize(0,null)),e.$BH=k.localize2(2,"Tasks");var d;(function(R){R[R.Escape=1]="Escape",R[R.Strong=2]="Strong",R[R.Weak=3]="Weak"})(d||(e.ShellQuoting=d={})),e.$CH="$customized",function(R){function F(T){if(!T)return R.Strong;switch(T.toLowerCase()){case"escape":return R.Escape;case"strong":return R.Strong;case"weak":return R.Weak;default:return R.Strong}}R.from=F}(d||(e.ShellQuoting=d={}));var y;(function(R){R.defaults={cwd:"${workspaceFolder}"}})(y||(e.CommandOptions=y={}));var O;(function(R){R[R.Always=1]="Always",R[R.Silent=2]="Silent",R[R.Never=3]="Never"})(O||(e.RevealKind=O={})),function(R){function F(T){switch(T.toLowerCase()){case"always":return R.Always;case"silent":return R.Silent;case"never":return R.Never;default:return R.Always}}R.fromString=F}(O||(e.RevealKind=O={}));var D;(function(R){R[R.Never=1]="Never",R[R.OnProblem=2]="OnProblem",R[R.Always=3]="Always"})(D||(e.RevealProblemKind=D={})),function(R){function F(T){switch(T.toLowerCase()){case"always":return R.Always;case"never":return R.Never;case"onproblem":return R.OnProblem;default:return R.OnProblem}}R.fromString=F}(D||(e.RevealProblemKind=D={}));var l;(function(R){R[R.Shared=1]="Shared",R[R.Dedicated=2]="Dedicated",R[R.New=3]="New"})(l||(e.PanelKind=l={})),function(R){function F(T){switch(T.toLowerCase()){case"shared":return R.Shared;case"dedicated":return R.Dedicated;case"new":return R.New;default:return R.Shared}}R.fromString=F}(l||(e.PanelKind=l={}));var b;(function(R){R.defaults={echo:!0,reveal:O.Always,revealProblems:D.Never,focus:!1,panel:l.Shared,showReuseMessage:!0,clear:!1}})(b||(e.PresentationOptions=b={}));var $;(function(R){R[R.Shell=1]="Shell",R[R.Process=2]="Process",R[R.CustomExecution=3]="CustomExecution"})($||(e.RuntimeType=$={})),function(R){function F(X){switch(X.toLowerCase()){case"shell":return R.Shell;case"process":return R.Process;case"customExecution":return R.CustomExecution;default:return R.Process}}R.fromString=F;function T(X){switch(X){case R.Shell:return"shell";case R.Process:return"process";case R.CustomExecution:return"customExecution";default:return"process"}}R.toString=T}($||(e.RuntimeType=$={}));var n;(function(R){function F(T){return M.$Vf(T)?T:T.value}R.value=F})(n||(e.CommandString=n={}));var o;(function(R){R.Clean={_id:"clean",isDefault:!1},R.Build={_id:"build",isDefault:!1},R.Rebuild={_id:"rebuild",isDefault:!1},R.Test={_id:"test",isDefault:!1};function F(X){return X===R.Clean._id||X===R.Build._id||X===R.Rebuild._id||X===R.Test._id}R.is=F;function T(X){if(X!==void 0)return M.$Vf(X)?F(X)?{_id:X,isDefault:!1}:void 0:X}R.from=T})(o||(e.TaskGroup=o={}));var s;(function(R){R[R.Global=1]="Global",R[R.Workspace=2]="Workspace",R[R.Folder=3]="Folder"})(s||(e.TaskScope=s={}));var r;(function(R){R.Workspace="workspace",R.Extension="extension",R.InMemory="inMemory",R.WorkspaceFile="workspaceFile",R.User="user";function F(T){switch(T){case R.User:return 2;case R.WorkspaceFile:return 5;default:return 6}}R.toConfigurationTarget=F})(r||(e.TaskSourceKind=r={}));var i;(function(R){R.parallel="parallel",R.sequence="sequence"})(i||(e.DependsOrder=i={}));var c;(function(R){R[R.default=1]="default",R[R.folderOpen=2]="folderOpen"})(c||(e.RunOnOptions=c={}));var h;(function(R){R.defaults={reevaluateOnRerun:!0,runOn:c.default,instanceLimit:1}})(h||(e.RunOptions=h={}));class t{constructor(F,T,X,re,me,pe){this._label="",this._id=F,T&&(this._label=T),X&&(this.type=X),this.runOptions=re,this.configurationProperties=me,this._source=pe}getDefinition(F){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const F={folder:this.d(),id:this._id};return JSON.stringify(F)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(F,T=!1){if(F===void 0)return!1;if(M.$Vf(F))return F===this._label||F===this.configurationProperties.identifier||T&&F===this._id;const X=this.getDefinition(!0);return X!==void 0&&X._key===F._key}getQualifiedLabel(){const F=this.getWorkspaceFolder();return F?`${this._label} (${F.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(F){this.c===void 0&&(this.c=[]),F&&(this.c=this.c.concat(F))}get taskLoadMessages(){return this.c}}e.$DH=t;class p extends t{constructor(F,T,X,re,me,pe,ae,be){super(F,X,void 0,ae,be,T),this.command={},this._source=T,this.hasDefinedMatchers=pe,me&&(this.command=me)}clone(){return new p(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(F=!1){if(F&&this._source.customizes!==void 0)return this._source.customizes;{let T;switch(this.command?this.command.runtime:void 0){case $.Shell:T="shell";break;case $.Process:T="process";break;case $.CustomExecution:T="customExecution";break;case void 0:T="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:T,_key:this._id,id:this._id}}}static is(F){return F instanceof p}getMapKey(){const F=this._source.config.workspaceFolder;return F?`${F.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===r.User?e.$zH:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const F=this.d();if(!F)return;let T=this.configurationProperties.identifier;this._source.kind!==r.Workspace&&(T+=this._source.kind);const X={type:e.$CH,folder:F,id:T};return JSON.stringify(X)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.$Sg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(F){return new p(F._id,F._source,F._label,F.type,F.command,F.hasDefinedMatchers,F.runOptions,F.configurationProperties)}}e.$EH=p;class a extends t{constructor(F,T,X,re,me,pe,ae){super(F,X,re,pe,ae,T),this._source=T,this.configures=me}static is(F){return F instanceof a}f(F){return F}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.$Sg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===r.User?e.$zH:this._source.config.workspaceFolder?.uri.toString()}getKey(){const F=this.d();if(!F)return;let T=this.configurationProperties.identifier;this._source.kind!==r.Workspace&&(T+=this._source.kind);const X={type:e.$CH,folder:F,id:T};return JSON.stringify(X)}}e.$FH=a;class g extends t{constructor(F,T,X,re,me,pe,ae,be,se){super(F,X,re,be,se,T),this.defines=me,this.hasDefinedMatchers=ae,this.command=pe,this.icon=se.icon,this.hide=se.hide}clone(){return new g(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(F){return F instanceof g}getMapKey(){const F=this._source.workspaceFolder;return F?`${this._source.scope.toString()}|${F.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const F={type:"contributed",scope:this._source.scope,id:this._id};return F.folder=this.d(),JSON.stringify(F)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(F){return new g(F._id,F._source,F._label,F.type,F.defines,F.command,F.hasDefinedMatchers,F.runOptions,F.configurationProperties)}}e.$GH=g;class v extends t{constructor(F,T,X,re,me,pe){super(F,X,re,me,pe,T),this._source=T}clone(){return new v(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(F){return F instanceof v}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(F){return new v(F._id,F._source,F._label,F.type,F.runOptions,F.configurationProperties)}}e.$HH=v;var f;(function(R){R[R.Process=1]="Process",R[R.Terminal=2]="Terminal"})(f||(e.ExecutionEngine=f={})),function(R){R._default=R.Terminal}(f||(e.ExecutionEngine=f={}));var u;(function(R){R[R.V0_1_0=1]="V0_1_0",R[R.V2_0_0=2]="V2_0_0"})(u||(e.JsonSchemaVersion=u={}));class E{constructor(F){this.c=new Map;for(let T=0;T<F.length;T++)this.c.set(F[T].uri.toString(),T)}compare(F,T){const X=F.getWorkspaceFolder(),re=T.getWorkspaceFolder();if(X&&re){let me=this.c.get(X.uri.toString());me=me===void 0?0:me+1;let pe=this.c.get(re.uri.toString());return pe=pe===void 0?0:pe+1,me===pe?F._label.localeCompare(T._label):me-pe}else return!X&&re?-1:X&&!re?1:0}}e.$IH=E;var w;(function(R){R.DependsOnStarted="dependsOnStarted",R.AcquiredInput="acquiredInput",R.Start="start",R.ProcessStarted="processStarted",R.Active="active",R.Inactive="inactive",R.Changed="changed",R.Terminated="terminated",R.ProcessEnded="processEnded",R.End="end"})(w||(e.TaskEventKind=w={}));var I;(function(R){R.SingleRun="singleRun",R.Background="background"})(I||(e.TaskRunType=I={}));var S;(function(R){R[R.System=0]="System",R[R.User=1]="User",R[R.FolderOpen=2]="FolderOpen",R[R.ConfigurationChange=3]="ConfigurationChange",R[R.Reconnect=4]="Reconnect"})(S||(e.TaskRunSource=S={}));var P;(function(R){function F(be){return{taskId:be._id,taskName:be.configurationProperties.name,runType:be.configurationProperties.isBackground?"background":"singleRun",group:be.configurationProperties.group,__task:be}}function T(be,se,De){return{...F(be),kind:"start",terminalId:se,resolvedVariables:De}}R.start=T;function X(be,se,De){return{...F(be),kind:"processStarted",terminalId:se,processId:De}}R.processStarted=X;function re(be,se,De){return{...F(be),kind:"processEnded",terminalId:se,exitCode:De}}R.processEnded=re;function me(be,se,De){return{...F(be),kind:"terminated",exitReason:De,terminalId:se}}R.terminated=me;function pe(be,se,De){return{...F(se),kind:be,terminalId:De}}R.general=pe;function ae(){return{kind:"changed"}}R.changed=ae})(P||(e.TaskEvent=P={}));var U;(function(R){function F(X){const re=Object.keys(X).sort();let me="";for(const pe of re){let ae=X[pe];ae instanceof Object?ae=F(ae):typeof ae=="string"&&(ae=ae.replace(/,/g,",,")),me+=pe+","+ae+","}return me}function T(X){const me={_key:F(X),type:X.taskType};return Object.assign(me,X),me}R.create=T})(U||(e.KeyedTaskIdentifier=U={}));var Q;(function(R){R.AutoDetect="task.autoDetect",R.SaveBeforeRun="task.saveBeforeRun",R.ShowDecorations="task.showDecorations",R.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",R.SlowProviderWarning="task.slowProviderWarning",R.QuickOpenHistory="task.quickOpen.history",R.QuickOpenDetail="task.quickOpen.detail",R.QuickOpenSkip="task.quickOpen.skip",R.QuickOpenShowAll="task.quickOpen.showAll",R.AllowAutomaticTasks="task.allowAutomaticTasks",R.Reconnection="task.reconnection",R.VerboseLogging="task.verboseLogging"})(Q||(e.TaskSettingId=Q={}));var H;(function(R){R.Tasks="tasks",R.SuppressTaskName="tasks.suppressTaskName",R.Windows="tasks.windows",R.Osx="tasks.osx",R.Linux="tasks.linux",R.ShowOutput="tasks.showOutput",R.IsShellCommand="tasks.isShellCommand",R.ServiceTestSetting="tasks.service.testSetting"})(H||(e.TasksSchemaProperties=H={}));var L;(function(R){function F(T,X){const re=m.$yH.get(T.type);if(re===void 0){const be=N.$Pn(T);return delete be._key,U.create(be)}const me=Object.create(null);me.type=re.taskType;const pe=new Set;re.required.forEach(be=>pe.add(be));const ae=re.properties;for(const be of Object.keys(ae)){const se=T[be];if(se!=null)me[be]=se;else if(pe.has(be)){const De=ae[be];if(De.default!==void 0)me[be]=N.$Pn(De.default);else switch(De.type){case"boolean":me[be]=!1;break;case"number":case"integer":me[be]=0;break;case"string":me[be]="";break;default:X.error(k.localize(1,null,JSON.stringify(T,void 0,0),be));return}}}return U.create(me)}R.createTaskIdentifier=F})(L||(e.TaskDefinition=L={}))}),define(Pe[230],Re([1,0,14]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v$b=e.$u$b=void 0;class M{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((A,m)=>{this.b=A,this.d=m,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(A){this.f||this.h||(this.f=!0,this.g=A,this.a&&this.b(A))}resolveErr(A){this.f||this.h||(this.h=!0,this.i=A,this.a?this.d(A):(0,k.$1)(A))}then(A,m){return this.j().then(A,m)}catch(A){return this.j().then(void 0,A)}finally(A){return this.j().finally(A)}}e.$u$b=M;class C extends M{constructor(){super(),this.h=!0,this.i=new k.$5}}e.$v$b=C}),define(Pe[50],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fw=e.$cw=void 0,e.$dw=C,e.$ew=N;class k{constructor(d){this._proxyIdentifierBrand=void 0,this.sid=d,this.nid=++k.count}}e.$cw=k,k.count=0;const M=[];function C(m){const d=new k(m);return M[d.nid]=d,d}function N(m){return M[m].sid}class A{constructor(d){this.value=d}}e.$fw=A}),define(Pe[4],Re([1,0,50]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tM=e.$sM=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$rM=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var M;(function(n){n[n.Default=0]="Default",n[n.InCenter=1]="InCenter",n[n.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",n[n.AtTop=3]="AtTop"})(M||(e.TextEditorRevealType=M={}));var C;(function(n){n[n.UnknownInput=0]="UnknownInput",n[n.TextInput=1]="TextInput",n[n.TextDiffInput=2]="TextDiffInput",n[n.TextMergeInput=3]="TextMergeInput",n[n.NotebookInput=4]="NotebookInput",n[n.NotebookDiffInput=5]="NotebookDiffInput",n[n.CustomEditorInput=6]="CustomEditorInput",n[n.WebviewEditorInput=7]="WebviewEditorInput",n[n.TerminalEditorInput=8]="TerminalEditorInput",n[n.InteractiveEditorInput=9]="InteractiveEditorInput",n[n.ChatEditorInput=10]="ChatEditorInput",n[n.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(C||(e.TabInputKind=C={}));var N;(function(n){n[n.TAB_OPEN=0]="TAB_OPEN",n[n.TAB_CLOSE=1]="TAB_CLOSE",n[n.TAB_UPDATE=2]="TAB_UPDATE",n[n.TAB_MOVE=3]="TAB_MOVE"})(N||(e.TabModelOperationKind=N={}));var A;(function(n){n[n.Editable=0]="Editable",n[n.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var m;(function(n){n[n.Int8Array=1]="Int8Array",n[n.Uint8Array=2]="Uint8Array",n[n.Uint8ClampedArray=3]="Uint8ClampedArray",n[n.Int16Array=4]="Int16Array",n[n.Uint16Array=5]="Uint16Array",n[n.Int32Array=6]="Int32Array",n[n.Uint32Array=7]="Uint32Array",n[n.Float32Array=8]="Float32Array",n[n.Float64Array=9]="Float64Array",n[n.BigInt64Array=10]="BigInt64Array",n[n.BigUint64Array=11]="BigUint64Array"})(m||(e.WebviewMessageArrayBufferViewType=m={}));var d;(function(n){n[n.Text=1]="Text",n[n.Error=2]="Error",n[n.Rich=3]="Rich"})(d||(e.CellOutputKind=d={}));var y;(function(n){n[n.Default=0]="Default",n[n.InCenter=1]="InCenter",n[n.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",n[n.AtTop=3]="AtTop"})(y||(e.NotebookEditorRevealType=y={}));var O;(function(n){n[n.None=0]="None",n[n.Process=1]="Process",n[n.Output=2]="Output"})(O||(e.CandidatePortSource=O={}));class D{static mixin(o){return o._id=D.a++,o}}e.$rM=D,D.a=0;var l;(function(n){n.label="a",n.kind="b",n.detail="c",n.documentation="d",n.sortText="e",n.filterText="f",n.preselect="g",n.insertText="h",n.insertTextRules="i",n.range="j",n.commitCharacters="k",n.additionalTextEdits="l",n.kindModifier="m",n.commandIdent="n",n.commandId="o",n.commandArguments="p"})(l||(e.ISuggestDataDtoField=l={}));var b;(function(n){n.defaultRanges="a",n.completions="b",n.isIncomplete="c",n.duration="d"})(b||(e.ISuggestResultDtoField=b={}));var $;(function(n){n[n.Workspace=0]="Workspace",n[n.TextDocument=1]="TextDocument"})($||(e.ExtHostTestingResource=$={})),e.$sM={MainThreadAuthentication:(0,k.$dw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,k.$dw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,k.$dw)("MainThreadLanguageModels"),MainThreadChatAgents2:(0,k.$dw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,k.$dw)("MainThreadChatVariables"),MainThreadClipboard:(0,k.$dw)("MainThreadClipboard"),MainThreadCommands:(0,k.$dw)("MainThreadCommands"),MainThreadComments:(0,k.$dw)("MainThreadComments"),MainThreadConfiguration:(0,k.$dw)("MainThreadConfiguration"),MainThreadConsole:(0,k.$dw)("MainThreadConsole"),MainThreadDebugService:(0,k.$dw)("MainThreadDebugService"),MainThreadDecorations:(0,k.$dw)("MainThreadDecorations"),MainThreadDiagnostics:(0,k.$dw)("MainThreadDiagnostics"),MainThreadDialogs:(0,k.$dw)("MainThreadDiaglogs"),MainThreadDocuments:(0,k.$dw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,k.$dw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,k.$dw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,k.$dw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,k.$dw)("MainThreadEditorTabs"),MainThreadErrors:(0,k.$dw)("MainThreadErrors"),MainThreadTreeViews:(0,k.$dw)("MainThreadTreeViews"),MainThreadDownloadService:(0,k.$dw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,k.$dw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,k.$dw)("MainThreadLanguages"),MainThreadLogger:(0,k.$dw)("MainThreadLogger"),MainThreadMessageService:(0,k.$dw)("MainThreadMessageService"),MainThreadOutputService:(0,k.$dw)("MainThreadOutputService"),MainThreadProgress:(0,k.$dw)("MainThreadProgress"),MainThreadQuickDiff:(0,k.$dw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,k.$dw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,k.$dw)("MainThreadStatusBar"),MainThreadSecretState:(0,k.$dw)("MainThreadSecretState"),MainThreadStorage:(0,k.$dw)("MainThreadStorage"),MainThreadSpeech:(0,k.$dw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,k.$dw)("MainThreadTelemetry"),MainThreadTerminalService:(0,k.$dw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,k.$dw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,k.$dw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,k.$dw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,k.$dw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,k.$dw)("MainThreadCustomEditors"),MainThreadUrls:(0,k.$dw)("MainThreadUrls"),MainThreadUriOpeners:(0,k.$dw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,k.$dw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,k.$dw)("MainThreadWorkspace"),MainThreadFileSystem:(0,k.$dw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,k.$dw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,k.$dw)("MainThreadExtensionService"),MainThreadSCM:(0,k.$dw)("MainThreadSCM"),MainThreadSearch:(0,k.$dw)("MainThreadSearch"),MainThreadShare:(0,k.$dw)("MainThreadShare"),MainThreadTask:(0,k.$dw)("MainThreadTask"),MainThreadWindow:(0,k.$dw)("MainThreadWindow"),MainThreadLabelService:(0,k.$dw)("MainThreadLabelService"),MainThreadNotebook:(0,k.$dw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,k.$dw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,k.$dw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,k.$dw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,k.$dw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,k.$dw)("MainThreadInteractive"),MainThreadChat:(0,k.$dw)("MainThreadChat"),MainThreadInlineChat:(0,k.$dw)("MainThreadInlineChatShape"),MainThreadTheming:(0,k.$dw)("MainThreadTheming"),MainThreadTunnelService:(0,k.$dw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,k.$dw)("MainThreadManagedSockets"),MainThreadTimeline:(0,k.$dw)("MainThreadTimeline"),MainThreadTesting:(0,k.$dw)("MainThreadTesting"),MainThreadLocalization:(0,k.$dw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,k.$dw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,k.$dw)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,k.$dw)("MainThreadIssueReporter")},e.$tM={ExtHostCommands:(0,k.$dw)("ExtHostCommands"),ExtHostConfiguration:(0,k.$dw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,k.$dw)("ExtHostDiagnostics"),ExtHostDebugService:(0,k.$dw)("ExtHostDebugService"),ExtHostDecorations:(0,k.$dw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,k.$dw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,k.$dw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,k.$dw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,k.$dw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,k.$dw)("ExtHostEditors"),ExtHostTreeViews:(0,k.$dw)("ExtHostTreeViews"),ExtHostFileSystem:(0,k.$dw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,k.$dw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,k.$dw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,k.$dw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,k.$dw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,k.$dw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,k.$dw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,k.$dw)("ExtHostStatusBar"),ExtHostShare:(0,k.$dw)("ExtHostShare"),ExtHostExtensionService:(0,k.$dw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,k.$dw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,k.$dw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,k.$dw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,k.$dw)("ExtHostSCM"),ExtHostSearch:(0,k.$dw)("ExtHostSearch"),ExtHostTask:(0,k.$dw)("ExtHostTask"),ExtHostWorkspace:(0,k.$dw)("ExtHostWorkspace"),ExtHostWindow:(0,k.$dw)("ExtHostWindow"),ExtHostWebviews:(0,k.$dw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,k.$dw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,k.$dw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,k.$dw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,k.$dw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,k.$dw)("ExtHostEditorTabs"),ExtHostProgress:(0,k.$dw)("ExtHostProgress"),ExtHostComments:(0,k.$dw)("ExtHostComments"),ExtHostSecretState:(0,k.$dw)("ExtHostSecretState"),ExtHostStorage:(0,k.$dw)("ExtHostStorage"),ExtHostUrls:(0,k.$dw)("ExtHostUrls"),ExtHostUriOpeners:(0,k.$dw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,k.$dw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,k.$dw)("ExtHostOutputService"),ExtHostLabelService:(0,k.$dw)("ExtHostLabelService"),ExtHostNotebook:(0,k.$dw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,k.$dw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,k.$dw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,k.$dw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,k.$dw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,k.$dw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,k.$dw)("ExtHostInteractive"),ExtHostInlineChat:(0,k.$dw)("ExtHostInlineChatShape"),ExtHostChat:(0,k.$dw)("ExtHostChat"),ExtHostChatAgents2:(0,k.$dw)("ExtHostChatAgents"),ExtHostChatVariables:(0,k.$dw)("ExtHostChatVariables"),ExtHostChatProvider:(0,k.$dw)("ExtHostChatProvider"),ExtHostSpeech:(0,k.$dw)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,k.$dw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,k.$dw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,k.$dw)("ExtHostTheming"),ExtHostTunnelService:(0,k.$dw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,k.$dw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,k.$dw)("ExtHostAuthentication"),ExtHostTimeline:(0,k.$dw)("ExtHostTimeline"),ExtHostTesting:(0,k.$dw)("ExtHostTesting"),ExtHostTelemetry:(0,k.$dw)("ExtHostTelemetry"),ExtHostLocalization:(0,k.$dw)("ExtHostLocalization"),ExtHostIssueReporter:(0,k.$dw)("ExtHostIssueReporter")}}),define(Pe[78],Re([1,0,3,13,4,16]),function(ee,e,k,M,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bjc=e.$Ajc=e.$zjc=void 0,e.$zjc=(0,k.$ii)("IExtHostApiDeprecationService");let A=class{constructor(d,y){this.c=y,this.a=new Set,this.b=d.getProxy(C.$sM.MainThreadTelemetry)}report(d,y,O){const D=this.d(d,y);this.a.has(D)||(this.a.add(D),y.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${d}' is deprecated. ${O}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:y.identifier.value,apiId:d}))}d(d,y){return`${d}-${y.identifier.value}`}};e.$Ajc=A,e.$Ajc=A=Xe([qe(0,N.$OO),qe(1,M.$Oj)],A),e.$Bjc=Object.freeze(new class{report(m,d,y){}})}),define(Pe[231],Re([1,0,39,6,4]),function(ee,e,k,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mjc=void 0;class N{constructor(d,y){this.extension=d,this.provider=y,this.handle=N.a++}}N.a=0;class A{constructor(d){this.b=new Map,this.c=new Map,this.d=d.getProxy(C.$sM.MainThreadChat)}registerChatProvider(d,y,O){const D=new N(d,O);return this.b.set(D.handle,D),this.d.$registerChatProvider(D.handle,y),(0,M.$Sc)(()=>{this.d.$unregisterChatProvider(D.handle),this.b.delete(D.handle)})}transferChatSession(d,y){const O=k.Iterable.find(this.c.keys(),D=>this.c.get(D)===d)??0;typeof O=="number"&&this.d.$transferChatSession(O,y)}async $prepareChat(d,y){const O=this.b.get(d);if(!O)return;const D=await O.provider.prepareSession(y);if(!D)return;const l=A.a++;return this.c.set(l,D),{id:l}}$releaseSession(d){this.c.delete(d)}}e.$Mjc=A,A.a=0}),define(Pe[232],Re([1,0,4]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rjc=void 0;class M{constructor(N){const A=N.getProxy(k.$sM.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(m){return A.$writeText(m)}})}}e.$Rjc=M}),define(Pe[233],Re([1,0,26,4,27,16]),function(ee,e,k,M,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Klc=void 0;let A=class{constructor(O,D){this.a=O.getProxy(M.$sM.MainThreadConsole),this.b=D.consoleForward.includeStack,this.c=D.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(O,D){const l=this,b=console[O];Object.defineProperty(console,O,{set:()=>{},get:()=>function(){l.e(O,D,b,arguments)}})}e(O,D,l,b){this.a.$logExtensionHostMessage({type:"__$console",severity:D,arguments:d(b,this.b)}),this.c&&this.f(O,l,b)}};e.$Klc=A,e.$Klc=A=Xe([qe(0,N.$OO),qe(1,C.$5O)],A);const m=1e5;function d(y,O){const D=[];if(y.length)for(let l=0;l<y.length;l++){let b=y[l];if(typeof b>"u")b="undefined";else if(b instanceof Error){const $=b;$.stack?b=$.stack:b=$.toString()}D.push(b)}if(O){const l=new Error().stack;l&&D.push({__$stack:l.split(`
`).slice(3).join(`
`)})}try{const l=(0,k.$Un)(D);return l.length>m?"Output omitted for a large object that exceeds the limits":l}catch(l){return`Output omitted for an object that cannot be inspected ('${l.toString()}')`}}}),define(Pe[234],Re([1,0,2,4,25]),function(ee,e,k,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mkc=void 0;class N{constructor(m){this.a=m.getProxy(M.$sM.MainThreadDialogs)}showOpenDialog(m,d){return d?.allowUIResources&&(0,C.$dG)(m,"showLocal"),this.a.$showOpenDialog(d).then(y=>y?y.map(O=>k.URI.revive(O)):void 0)}showSaveDialog(m){return this.a.$showSaveDialog(m).then(d=>d?k.URI.revive(d):void 0)}}e.$Mkc=N}),define(Pe[235],Re([1,0,6,4]),function(ee,e,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8kc=void 0;class C{constructor(A){this.b=0,this.a=A.getProxy(M.$sM.MainThreadLabelService)}$registerResourceLabelFormatter(A){const m=this.b++;return this.a.$registerResourceLabelFormatter(m,A),(0,k.$Sc)(()=>{this.a.$unregisterResourceLabelFormatter(m)})}}e.$8kc=C}),define(Pe[79],Re([1,0,21,15,2,3,13,4,27,16]),function(ee,e,k,M,C,N,A,m,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vkc=e.$ukc=void 0;let O=class{constructor(l,b,$){this.f=$,this.d=new Map,this.a=b.getProxy(m.$sM.MainThreadLocalization),this.b=l.environment.appLanguage,this.c=this.b===k.$a}getMessage(l,b){const{message:$,args:n,comment:o}=b;if(this.c)return(0,M.$We)($,n??{});let s=$;o&&o.length>0&&(s+=`/${Array.isArray(o)?o.join(""):o}`);const r=this.d.get(l)?.contents[s];return r||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${s}`),(0,M.$We)(r??$,n??{})}getBundle(l){return this.d.get(l)?.contents}getBundleUri(l){return this.d.get(l)?.uri}async initializeLocalizedMessages(l){if(this.c||!l.l10n&&!l.isBuiltin||this.d.has(l.identifier.value))return;let b;const $=await this.g(l);if(!$){this.f.error(`No bundle location found for extension ${l.identifier.value}`);return}try{const n=await this.a.$fetchBundleContents($),o=JSON.parse(n);b=l.isBuiltin?o.contents?.bundle:o}catch(n){this.f.error(`Failed to load translations for ${l.identifier.value} from ${$}: ${n.message}`);return}b&&this.d.set(l.identifier.value,{contents:b,uri:$})}async g(l){if(l.isBuiltin){const b=await this.a.$fetchBuiltInBundleUri(l.identifier.value,this.b);return C.URI.revive(b)}return l.l10n?C.URI.joinPath(l.extensionLocation,l.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$ukc=O,e.$ukc=O=Xe([qe(0,d.$5O),qe(1,y.$OO),qe(2,A.$Oj)],O),e.$vkc=(0,N.$ii)("IExtHostLocalizationService")}),define(Pe[236],Re([1,0,13,4,27,16,2,53]),function(ee,e,k,M,C,N,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jlc=void 0;let d=class extends k.$Zj{constructor(D,l){super(l.logLevel,l.logsLocation,l.loggers.map(b=>(0,m.$Rh)(b))),this.r=D.getProxy(M.$sM.MainThreadLogger)}$setLogLevel(D,l){l?this.setLogLevel(A.URI.revive(l),D):this.setLogLevel(D)}setVisibility(D,l){super.setVisibility(D,l),this.r.$setVisibility(D,l)}s(D,l,b){return new y(this.r,D,l,b)}};e.$Jlc=d,e.$Jlc=d=Xe([qe(0,N.$OO),qe(1,C.$5O)],d);class y extends k.$Uj{constructor(D,l,b,$){super($?.logLevel==="always"),this.r=D,this.s=l,this.m=!1,this.n=[],this.setLevel(b),this.r.$createLogger(l,$).then(()=>{this.u(this.n),this.m=!0})}g(D,l){const b=[[D,l]];this.m?this.u(b):this.n.push(...b)}u(D){this.r.$log(this.s,D)}flush(){this.r.$flush(this.s)}}}),define(Pe[80],Re([1,0,4,3,6,16,22]),function(ee,e,k,M,C,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xkc=e.$wkc=void 0,e.$wkc=(0,M.$ii)("IExtHostManagedSockets");let m=class{constructor(D){this.b=0,this.c=null,this.d=new Map,this.a=D.getProxy(k.$sM.MainThreadManagedSockets)}setFactory(D,l){for(const b of this.d.values())b.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new d(D,l),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(D){if(!this.c||this.c.socketFactoryId!==D)throw new Error(`No socket factory with id ${D}`);const l=++this.b,b=await this.c.makeConnection(),$=new C.$Tc;return this.d.set(l,new y(l,b,$)),$.add((0,C.$Sc)(()=>this.d.delete(l))),$.add(b.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(l),$.dispose()})),$.add(b.onDidClose(n=>{this.a.$onDidManagedSocketClose(l,n?.stack??n?.message),$.dispose()})),$.add(b.onDidReceiveMessage(n=>this.a.$onDidManagedSocketHaveData(l,A.$ue.wrap(n)))),l}$remoteSocketWrite(D,l){this.d.get(D)?.actual.send(l.buffer)}$remoteSocketEnd(D){const l=this.d.get(D);l&&(l.actual.end(),l.dispose())}async $remoteSocketDrain(D){await this.d.get(D)?.actual.drain?.()}};e.$xkc=m,e.$xkc=m=Xe([qe(0,N.$OO)],m);class d{constructor(D,l){this.socketFactoryId=D,this.makeConnection=l}}class y extends C.$Uc{constructor(D,l,b){super(),this.socketId=D,this.actual=l,this.B(b)}}}),define(Pe[237],Re([1,0,4,13,25]),function(ee,e,k,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0kc=void 0;function N(m){return m&&m.title}let A=class{constructor(d,y){this.b=y,this.a=d.getProxy(k.$sM.MainThreadMessageService)}showMessage(d,y,O,D,l){const b={source:{identifier:d.identifier,label:d.displayName||d.name}};let $;typeof D=="string"||N(D)?$=[D,...l]:(b.modal=D?.modal,b.useCustom=D?.useCustom,b.detail=D?.detail,$=l),b.useCustom&&(0,C.$dG)(d,"resolvers");const n=[];let o=!1;for(let s=0;s<$.length;s++){const r=$[s];if(typeof r=="string")n.push({title:r,handle:s,isCloseAffordance:!1});else if(typeof r=="object"){const{title:i,isCloseAffordance:c}=r;n.push({title:i,isCloseAffordance:!!c,handle:s}),c&&(o?this.b.warn(`[${d.identifier}] Only one message item can have 'isCloseAffordance':`,r):o=!0)}else this.b.warn(`[${d.identifier}] Invalid message item:`,r)}return this.a.$showMessage(y,O,b,n).then(s=>{if(typeof s=="number")return $[s]})}};e.$0kc=A,e.$0kc=A=Xe([qe(1,M.$Oj)],A)}),define(Pe[238],Re([1,0,6,17,2,25,4]),function(ee,e,k,M,C,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$glc=void 0;class m{constructor(y){this.b=new Map,this.a=y.getProxy(A.$sM.MainThreadProfileContentHandlers)}registerProfileContentHandler(y,O,D){if((0,N.$dG)(y,"profileContentHandlers"),this.b.has(O))throw new Error(`Handler with id '${O}' already registered`);return this.b.set(O,D),this.a.$registerProfileContentHandler(O,D.name,D.description,y.identifier.value),(0,k.$Sc)(()=>{this.b.delete(O),this.a.$unregisterProfileContentHandler(O)})}async $saveProfile(y,O,D,l){const b=this.b.get(y);if(!b)throw new Error(`Unknown handler with id: ${y}`);return b.saveProfile(O,D,l)}async $readProfile(y,O,D){const l=this.b.get(y);if(!l)throw new Error(`Unknown handler with id: ${y}`);return l.readProfile((0,M.$Vf)(O)?O:C.URI.revive(O),D)}}e.$glc=m}),define(Pe[81],Re([1,0,4,5,3]),function(ee,e,k,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$skc=e.$rkc=void 0;class N{constructor(m){this.b=new M.$7d,this.onDidChangePassword=this.b.event,this.a=m.getProxy(k.$sM.MainThreadSecretState)}async $onDidChangePassword(m){this.b.fire(m)}get(m,d){return this.a.$getPassword(m,d)}store(m,d,y){return this.a.$setPassword(m,d,y)}delete(m,d){return this.a.$deletePassword(m,d)}}e.$rkc=N,e.$skc=(0,C.$ii)("IExtHostSecretState")}),define(Pe[239],Re([1,0,24,6,4]),function(ee,e,k,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nlc=void 0;class N{constructor(m){this.c=new Map,this.d=new Map,this.b=m.getProxy(C.$sM.MainThreadSpeech)}async $createSpeechToTextSession(m,d,y){const O=this.c.get(m);if(!O)return;const D=new M.$Tc,l=new k.$ee;this.d.set(d,l);const b=D.add(O.provideSpeechToTextSession(l.token,y?{language:y}:void 0));D.add(b.onDidChange($=>{l.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(d,$)})),D.add(l.token.onCancellationRequested(()=>D.dispose()))}async $cancelSpeechToTextSession(m){this.d.get(m)?.dispose(!0),this.d.delete(m)}async $createKeywordRecognitionSession(m,d){const y=this.c.get(m);if(!y)return;const O=new M.$Tc,D=new k.$ee;this.d.set(d,D);const l=O.add(y.provideKeywordRecognitionSession(D.token));O.add(l.onDidChange(b=>{D.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(d,b)})),O.add(D.token.onCancellationRequested(()=>O.dispose()))}async $cancelKeywordRecognitionSession(m){this.d.get(m)?.dispose(!0),this.d.delete(m)}registerProvider(m,d,y){const O=N.a++;return this.c.set(O,y),this.b.$registerProvider(O,d,{extension:m,displayName:m.value}),(0,M.$Sc)(()=>{this.b.$unregisterProvider(O),this.c.delete(O)})}}e.$nlc=N,N.a=1}),define(Pe[82],Re([1,0,4,5,3]),function(ee,e,k,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kkc=e.$jkc=void 0;class N{constructor(m,d){this.c=d,this.b=new M.$7d,this.onDidChangeStorage=this.b.event,this.a=m.getProxy(k.$sM.MainThreadStorage)}registerExtensionStorageKeysToSync(m,d){this.a.$registerExtensionStorageKeysToSync(m,d)}async initializeExtensionStorage(m,d,y){const O=await this.a.$initializeExtensionStorage(m,d);let D;return O&&(D=this.d(m,d,O)),D||y}setValue(m,d,y){return this.a.$setValue(m,d,y)}$acceptValue(m,d,y){const O=this.d(m,d,y);O&&this.b.fire({shared:m,key:d,value:O})}d(m,d,y){try{return JSON.parse(y)}catch(O){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${d}, global: ${m}): ${O}`)}}}e.$jkc=N,e.$kkc=(0,C.$ii)("IExtHostStorage")}),define(Pe[240],Re([1,0,6,12,2,4]),function(ee,e,k,M,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Blc=void 0;class A{constructor(d){this.c=new Map,this.b=d.getProxy(N.$sM.MainThreadUriOpeners)}registerExternalUriOpener(d,y,O,D){if(this.c.has(y))throw new Error(`Opener with id '${y}' already registered`);const l=D.schemes.find(b=>!A.a.has(b));if(l)throw new Error(`Scheme '${l}' is not supported. Only http and https are currently supported.`);return this.c.set(y,O),this.b.$registerUriOpener(y,D.schemes,d,D.label),(0,k.$Sc)(()=>{this.c.delete(y),this.b.$unregisterUriOpener(y)})}async $canOpenUri(d,y,O){const D=this.c.get(d);if(!D)throw new Error(`Unknown opener with id: ${d}`);const l=C.URI.revive(y);return D.canOpenExternalUri(l,O)}async $openUri(d,y,O){const D=this.c.get(d);if(!D)throw new Error(`Unknown opener id: '${d}'`);return D.openExternalUri(C.URI.revive(y.resolvedUri),{sourceUri:C.URI.revive(y.sourceUri)},O)}}e.$Blc=A,A.a=new Set([M.Schemas.http,M.Schemas.https])}),define(Pe[241],Re([1,0,4,2,6,14,20]),function(ee,e,k,M,C,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Clc=void 0;class m{constructor(y){this.c=new A.$Fm,this.d=new Map,this.b=y.getProxy(k.$sM.MainThreadUrls)}registerUriHandler(y,O){const D=y.identifier;if(this.c.has(D))throw new Error(`Protocol handler already registered for extension ${D}`);const l=m.a++;return this.c.add(D),this.d.set(l,O),this.b.$registerUriHandler(l,D,y.displayName||y.name),(0,C.$Sc)(()=>{this.c.delete(D),this.d.delete(l),this.b.$unregisterUriHandler(l)})}$handleExternalUri(y,O){const D=this.d.get(y);if(!D)return Promise.resolve(void 0);try{D.handleUri(M.URI.revive(O))}catch(l){(0,N.$1)(l)}return Promise.resolve(void 0)}async createAppUri(y){return M.URI.revive(await this.b.$createAppUri(y))}}e.$Clc=m,m.a=0});var _e=this&&this.__classPrivateFieldSet||function(ee,e,k,M,C){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?C.call(ee,k):C?C.value=k:e.set(ee,k),k},Ve=this&&this.__classPrivateFieldGet||function(ee,e,k,M){if(k==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!M:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return k==="m"?M:k==="a"?M.call(ee):M?M.value:e.get(ee)};define(Pe[63],Re([1,0,5,6,12,26,2,188,210,76,4]),function(ee,e,k,M,C,N,A,m,d,y,O){"use strict";var D,l,b,$,n,o,s,r,i,c,h,t,p;Object.defineProperty(e,"__esModule",{value:!0}),e.$9jc=e.$7jc=void 0,e.$8jc=g,e.$0jc=u,e.$$jc=E;class a{constructor(P,U,Q,H,L,R,F){D.set(this,void 0),l.set(this,void 0),b.set(this,void 0),$.set(this,void 0),n.set(this,void 0),o.set(this,void 0),s.set(this,""),r.set(this,void 0),i.set(this,!1),c.set(this,!1),h.set(this,void 0),t.set(this,void 0),this._onMessageEmitter=new k.$7d,this.onDidReceiveMessage=this._onMessageEmitter.event,p.set(this,new k.$7d),this._onDidDispose=Ve(this,p,"f").event,_e(this,D,P,"f"),_e(this,l,U,"f"),_e(this,r,Q,"f"),_e(this,$,H,"f"),_e(this,n,L,"f"),_e(this,o,R,"f"),_e(this,h,g(R),"f"),_e(this,t,v(R),"f"),_e(this,b,F,"f")}dispose(){_e(this,i,!0,"f"),Ve(this,p,"f").fire(),Ve(this,p,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(P){return _e(this,c,!0,"f"),(0,y.$Azb)(P,Ve(this,$,"f"))}get cspSource(){const P=Ve(this,o,"f").extensionLocation;if(P.scheme===C.Schemas.https||P.scheme===C.Schemas.http){let U=P.toString();return U.endsWith("/")||(U+="/"),U+" "+y.$zzb}return y.$zzb}get html(){return this.a(),Ve(this,s,"f")}set html(P){this.a(),Ve(this,s,"f")!==P&&(_e(this,s,P,"f"),Ve(this,t,"f")&&!Ve(this,c,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(P)&&(_e(this,c,!0,"f"),Ve(this,b,"f").report("Webview vscode-resource: uris",Ve(this,o,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ve(this,l,"f").$setHtml(Ve(this,D,"f"),this.b(P)))}get options(){return this.a(),Ve(this,r,"f")}set options(P){this.a(),N.$Tn(Ve(this,r,"f"),P)||Ve(this,l,"f").$setOptions(Ve(this,D,"f"),E(Ve(this,o,"f"),Ve(this,n,"f"),P)),_e(this,r,P,"f")}async postMessage(P){if(Ve(this,i,"f"))return!1;const U=(0,d.$Onb)(P,{serializeBuffersForPostMessage:Ve(this,h,"f")});return Ve(this,l,"f").$postMessage(Ve(this,D,"f"),U.message,...U.buffers)}a(){if(Ve(this,i,"f"))throw new Error("Webview is disposed")}b(P){if(!Ve(this,t,"f"))return P;const U=Ve(this,o,"f").extensionLocation?.scheme===C.Schemas.vscodeRemote,Q=Ve(this,o,"f").extensionLocation.scheme===C.Schemas.vscodeRemote?Ve(this,o,"f").extensionLocation.authority:void 0;return P.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(H,L,R,F,T,X)=>{const re=A.URI.from({scheme:F||"file",path:decodeURIComponent(T)}),me=(0,y.$Azb)(re,{isRemote:U,authority:Q}).toString();return`${L}${me}${X}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(H,L,R,F,T,X)=>{const re=A.URI.from({scheme:F||"file",path:decodeURIComponent(T)}),me=(0,y.$Azb)(re,{isRemote:U,authority:Q}).toString();return`${L}${me}${X}`})}}e.$7jc=a,D=new WeakMap,l=new WeakMap,b=new WeakMap,$=new WeakMap,n=new WeakMap,o=new WeakMap,s=new WeakMap,r=new WeakMap,i=new WeakMap,c=new WeakMap,h=new WeakMap,t=new WeakMap,p=new WeakMap;function g(S){try{const P=(0,m.$vp)((0,m.$up)(S.engines.vscode));return!!P&&P.majorBase>=1&&P.minorBase>=57}catch{return!1}}function v(S){try{const P=(0,m.$vp)((0,m.$up)(S.engines.vscode));return P?P.majorBase<1||P.majorBase===1&&P.minorBase<60:!1}catch{return!1}}class f extends M.$Uc{constructor(P,U,Q,H,L){super(),this.c=U,this.f=Q,this.g=H,this.h=L,this.b=new Map,this.a=P.getProxy(O.$sM.MainThreadWebviews)}dispose(){super.dispose();for(const P of this.b.values())P.dispose();this.b.clear()}$onMessage(P,U,Q){const H=this.j(P);if(H){const{message:L}=(0,d.$Pnb)(U,Q.value);H._onMessageEmitter.fire(L)}}$onMissingCsp(P,U){this.g.warn(`${U} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(P,U,Q){const H=new a(P,this.a,w(U),this.c,this.f,Q,this.h);this.b.set(P,H);const L=H._onDidDispose(()=>{L.dispose(),this.deleteWebview(P)});return H}deleteWebview(P){this.b.delete(P)}j(P){return this.b.get(P)}}e.$9jc=f;function u(S){return{id:S.identifier,location:S.extensionLocation}}function E(S,P,U){return{enableCommandUris:U.enableCommandUris,enableScripts:U.enableScripts,enableForms:U.enableForms,portMapping:U.portMapping,localResourceRoots:U.localResourceRoots||I(S,P)}}function w(S){return{enableCommandUris:S.enableCommandUris,enableScripts:S.enableScripts,enableForms:S.enableForms,portMapping:S.portMapping,localResourceRoots:S.localResourceRoots?.map(P=>A.URI.from(P))}}function I(S,P){return[...(P?.getWorkspaceFolders()||[]).map(U=>U.uri),S.extensionLocation]}}),define(Pe[109],Re([1,0,5,4,2,12,15,3,16,25]),function(ee,e,k,M,C,N,A,m,d,y){"use strict";var O;Object.defineProperty(e,"__esModule",{value:!0}),e.$Flc=e.$Elc=void 0;let D=O=class{getState(b){const $=this.d;return{get focused(){return $.focused},get active(){return(0,y.$dG)(b,"windowActivity"),$.active}}}constructor(b){this.c=new k.$7d,this.onDidChangeWindowState=this.c.event,this.d=O.a,this.b=b.getProxy(M.$sM.MainThreadWindow),this.b.$getInitialState().then(({isFocused:$,isActive:n})=>{this.onDidChangeWindowProperty("focused",$),this.onDidChangeWindowProperty("active",n)})}$onDidChangeWindowFocus(b){this.onDidChangeWindowProperty("focused",b)}$onDidChangeWindowActive(b){this.onDidChangeWindowProperty("active",b)}onDidChangeWindowProperty(b,$){$!==this.d[b]&&(this.d={...this.d,[b]:$},this.c.fire(this.d))}openUri(b,$){let n;if(typeof b=="string"){n=b;try{b=C.URI.parse(b)}catch{return Promise.reject(`Invalid uri - '${b}'`)}}return(0,A.$Ue)(b.scheme)?Promise.reject("Invalid scheme - cannot be empty"):b.scheme===N.Schemas.command?Promise.reject(`Invalid scheme '${b.scheme}'`):this.b.$openUri(b,n,$)}async asExternalUri(b,$){if((0,A.$Ue)(b.scheme))return Promise.reject("Invalid scheme - cannot be empty");const n=await this.b.$asExternalUri(b,$);return C.URI.from(n)}};e.$Elc=D,D.a={focused:!0,active:!0},e.$Elc=D=O=Xe([qe(0,d.$OO)],D),e.$Flc=(0,m.$ii)("IExtHostWindow")}),define(Pe[242],Re([1,0,233,27,16]),function(ee,e,k,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Snc=void 0;let N=class extends k.$Klc{constructor(m,d){super(m,d)}f(m,d,y){d.apply(console,y)}};e.$Snc=N,e.$Snc=N=Xe([qe(0,C.$OO),qe(1,M.$5O)],N)}),define(Pe[243],Re([1,0,11,22,24,14,5,6,133,230,50]),function(ee,e,k,M,C,N,A,m,d,y,O){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.$y$b=e.ResponsiveState=e.RequestInitiator=void 0,e.$w$b=o,e.$x$b=s;function l(S,P){try{return JSON.stringify(S,P)}catch{return"null"}}const b="$$ref$$",$={[b]:-1};class n{constructor(P,U){this.jsonString=P,this.referencedBuffers=U}}function o(S,P=null,U=!1){const Q=[];return{jsonString:(U?l:JSON.stringify)(S,(L,R)=>{if(typeof R>"u")return $;if(typeof R=="object"){if(R instanceof M.$ue){const F=Q.push(R)-1;return{[b]:F}}if(P)return P(L,R)}return R}),referencedBuffers:Q}}function s(S,P,U){return JSON.parse(S,(Q,H)=>{if(H){const L=H[b];if(typeof L=="number")return P[L];if(U&&H.$mid===1)return U.transformIncoming(H)}return H})}function r(S,P){return JSON.stringify(S,P)}function i(S){return S?(P,U)=>U&&U.$mid===1?S.transformOutgoing(U):U:null}var c;(function(S){S[S.LocalSide=0]="LocalSide",S[S.OtherSide=1]="OtherSide"})(c||(e.RequestInitiator=c={}));var h;(function(S){S[S.Responsive=0]="Responsive",S[S.Unresponsive=1]="Unresponsive"})(h||(e.ResponsiveState=h={}));const t=()=>{},p=Symbol.for("rpcProtocol"),a=Symbol.for("rpcProxy");class g extends m.$Uc{constructor(P,U=null,Q=null){super(),this[D]=!0,this.b=this.B(new A.$7d),this.onDidChangeResponsiveState=this.b.event,this.c=P,this.f=U,this.g=Q,this.h=i(this.g),this.j=!1,this.m=[],this.s=[];for(let H=0,L=O.$cw.count;H<L;H++)this.m[H]=null,this.s[H]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new k.$uh(()=>this.H(),1e3)),this.c.onMessage(H=>this.L(H))}dispose(){this.j=!0,Object.keys(this.w).forEach(P=>{const U=this.w[P];delete this.w[P],U.resolveErr(N.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(P){this.z===0&&(this.C=Date.now()+g.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(P){this.C=Date.now()+g.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(P){this.y!==P&&(this.y=P,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(P){return this.g?(0,d.$on)(P,this.g):P}getProxy(P){const{nid:U,sid:Q}=P;return this.s[U]||(this.s[U]=this.J(U,Q)),this.s[U]}J(P,U){const Q={get:(H,L)=>(typeof L=="string"&&!H[L]&&L.charCodeAt(0)===36&&(H[L]=(...R)=>this.U(P,L,R)),L===a?U:H[L])};return new Proxy(Object.create(null),Q)}set(P,U){return this.m[P.nid]=U,U}assertRegistered(P){for(let U=0,Q=P.length;U<Q;U++){const H=P[U];if(!this.m[H.nid])throw new Error(`Missing proxy instance ${H.sid}`)}}L(P){if(this.j)return;const U=P.byteLength,Q=f.read(P,0),H=Q.readUInt8(),L=Q.readUInt32();switch(H){case 1:case 2:{let{rpcId:R,method:F,args:T}=E.deserializeRequestJSONArgs(Q);this.g&&(T=(0,d.$on)(T,this.g)),this.M(U,L,R,F,T,H===2);break}case 3:case 4:{let{rpcId:R,method:F,args:T}=E.deserializeRequestMixedArgs(Q);this.g&&(T=(0,d.$on)(T,this.g)),this.M(U,L,R,F,T,H===4);break}case 5:{this.f?.logIncoming(U,L,0,"ack"),this.G(L);break}case 6:{this.N(U,L);break}case 7:{this.O(U,L,void 0);break}case 9:{let R=E.deserializeReplyOKJSON(Q);this.g&&(R=(0,d.$on)(R,this.g)),this.O(U,L,R);break}case 10:{const R=E.deserializeReplyOKJSONWithBuffers(Q,this.g);this.O(U,L,R);break}case 8:{const R=E.deserializeReplyOKVSBuffer(Q);this.O(U,L,R);break}case 11:{let R=E.deserializeReplyErrError(Q);this.g&&(R=(0,d.$on)(R,this.g)),this.P(U,L,R);break}case 12:{this.P(U,L,void 0);break}default:console.error("received unexpected message"),console.error(P)}}M(P,U,Q,H,L,R){this.f?.logIncoming(P,U,1,`receiveRequest ${(0,O.$ew)(Q)}.${H}(`,L);const F=String(U);let T,X;if(R){const me=new C.$ee;L.push(me.token),T=this.Q(Q,H,L),X=()=>me.cancel()}else T=this.Q(Q,H,L),X=t;this.u[F]=X;const re=E.serializeAcknowledged(U);this.f?.logOutgoing(re.byteLength,U,1,"ack"),this.c.send(re),T.then(me=>{delete this.u[F];const pe=E.serializeReplyOK(U,me,this.h);this.f?.logOutgoing(pe.byteLength,U,1,"reply:",me),this.c.send(pe)},me=>{delete this.u[F];const pe=E.serializeReplyErr(U,me);this.f?.logOutgoing(pe.byteLength,U,1,"replyErr:",me),this.c.send(pe)})}N(P,U){this.f?.logIncoming(P,U,1,"receiveCancel");const Q=String(U);this.u[Q]?.()}O(P,U,Q){this.f?.logIncoming(P,U,0,"receiveReply:",Q);const H=String(U);if(!this.w.hasOwnProperty(H))return;const L=this.w[H];delete this.w[H],L.resolveOk(Q)}P(P,U,Q){this.f?.logIncoming(P,U,0,"receiveReplyErr:",Q);const H=String(U);if(!this.w.hasOwnProperty(H))return;const L=this.w[H];delete this.w[H];let R;Q&&(Q.$isError?(R=new Error,R.name=Q.name,R.message=Q.message,R.stack=Q.stack):R=Q),L.resolveErr(R)}Q(P,U,Q){try{return Promise.resolve(this.S(P,U,Q))}catch(H){return Promise.reject(H)}}S(P,U,Q){const H=this.m[P];if(!H)throw new Error("Unknown actor "+(0,O.$ew)(P));const L=H[U];if(typeof L!="function")throw new Error("Unknown method "+U+" on actor "+(0,O.$ew)(P));return L.apply(H,Q)}U(P,U,Q){if(this.j)return new y.$v$b;let H=null;if(Q.length>0&&C.CancellationToken.isCancellationToken(Q[Q.length-1])&&(H=Q.pop()),H&&H.isCancellationRequested)return Promise.reject(N.$6());const L=E.serializeRequestArguments(Q,this.h),R=++this.t,F=String(R),T=new y.$u$b,X=new m.$Tc;H&&X.add(H.onCancellationRequested(()=>{const me=E.serializeCancel(R);this.f?.logOutgoing(me.byteLength,R,0,"cancel"),this.c.send(E.serializeCancel(R))})),this.w[F]=new v(T,X),this.F(R);const re=E.serializeRequest(R,P,U,L,!!H);return this.f?.logOutgoing(re.byteLength,R,0,`request: ${(0,O.$ew)(P)}.${U}(`,Q),this.c.send(re),T}}e.$y$b=g,D=p,g.a=3*1e3;class v{constructor(P,U){this.a=P,this.b=U}resolveOk(P){this.a.resolveOk(P),this.b.dispose()}resolveErr(P){this.a.resolveErr(P),this.b.dispose()}}class f{static alloc(P,U,Q){const H=new f(M.$ue.alloc(Q+1+4),0);return H.writeUInt8(P),H.writeUInt32(U),H}static read(P,U){return new f(P,U)}get buffer(){return this.a}constructor(P,U){this.a=P,this.b=U}static sizeUInt8(){return 1}writeUInt8(P){this.a.writeUInt8(P,this.b),this.b+=1}readUInt8(){const P=this.a.readUInt8(this.b);return this.b+=1,P}writeUInt32(P){this.a.writeUInt32BE(P,this.b),this.b+=4}readUInt32(){const P=this.a.readUInt32BE(this.b);return this.b+=4,P}static sizeShortString(P){return 1+P.byteLength}writeShortString(P){this.a.writeUInt8(P.byteLength,this.b),this.b+=1,this.a.set(P,this.b),this.b+=P.byteLength}readShortString(){const P=this.a.readUInt8(this.b);this.b+=1;const Q=this.a.slice(this.b,this.b+P).toString();return this.b+=P,Q}static sizeLongString(P){return 4+P.byteLength}writeLongString(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readLongString(){const P=this.a.readUInt32BE(this.b);this.b+=4;const Q=this.a.slice(this.b,this.b+P).toString();return this.b+=P,Q}writeBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}static sizeVSBuffer(P){return 4+P.byteLength}writeVSBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readVSBuffer(){const P=this.a.readUInt32BE(this.b);this.b+=4;const U=this.a.slice(this.b,this.b+P);return this.b+=P,U}static sizeMixedArray(P){let U=0;U+=1;for(let Q=0,H=P.length;Q<H;Q++){const L=P[Q];switch(U+=1,L.type){case 1:U+=this.sizeLongString(L.value);break;case 2:U+=this.sizeVSBuffer(L.value);break;case 3:U+=this.sizeUInt32,U+=this.sizeLongString(L.value);for(let R=0;R<L.buffers.length;++R)U+=this.sizeVSBuffer(L.buffers[R]);break;case 4:break}}return U}writeMixedArray(P){this.a.writeUInt8(P.length,this.b),this.b+=1;for(let U=0,Q=P.length;U<Q;U++){const H=P[U];switch(H.type){case 1:this.writeUInt8(1),this.writeLongString(H.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(H.value);break;case 3:this.writeUInt8(3),this.writeUInt32(H.buffers.length),this.writeLongString(H.value);for(let L=0;L<H.buffers.length;++L)this.writeBuffer(H.buffers[L]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const P=this.a.readUInt8(this.b);this.b+=1;const U=new Array(P);for(let Q=0;Q<P;Q++)switch(this.readUInt8()){case 1:U[Q]=this.readLongString();break;case 2:U[Q]=this.readVSBuffer();break;case 3:{const L=this.readUInt32(),R=this.readLongString(),F=[];for(let T=0;T<L;++T)F.push(this.readVSBuffer());U[Q]=new O.$fw(s(R,F,null));break}case 4:U[Q]=void 0;break}return U}}f.sizeUInt32=4;var u;(function(S){S[S.Simple=0]="Simple",S[S.Mixed=1]="Mixed"})(u||(u={}));class E{static a(P){for(let U=0,Q=P.length;U<Q;U++)if(P[U]instanceof M.$ue||P[U]instanceof O.$fw||typeof P[U]>"u")return!0;return!1}static serializeRequestArguments(P,U){if(this.a(P)){const Q=[];for(let H=0,L=P.length;H<L;H++){const R=P[H];if(R instanceof M.$ue)Q[H]={type:2,value:R};else if(typeof R>"u")Q[H]={type:4};else if(R instanceof O.$fw){const{jsonString:F,referencedBuffers:T}=o(R.value,U);Q[H]={type:3,value:M.$ue.fromString(F),buffers:T}}else Q[H]={type:1,value:M.$ue.fromString(r(R,U))}}return{type:1,args:Q}}return{type:0,args:r(P,U)}}static serializeRequest(P,U,Q,H,L){switch(H.type){case 0:return this.b(P,U,Q,H.args,L);case 1:return this.c(P,U,Q,H.args,L)}}static b(P,U,Q,H,L){const R=M.$ue.fromString(Q),F=M.$ue.fromString(H);let T=0;T+=f.sizeUInt8(),T+=f.sizeShortString(R),T+=f.sizeLongString(F);const X=f.alloc(L?2:1,P,T);return X.writeUInt8(U),X.writeShortString(R),X.writeLongString(F),X.buffer}static deserializeRequestJSONArgs(P){const U=P.readUInt8(),Q=P.readShortString(),H=P.readLongString();return{rpcId:U,method:Q,args:JSON.parse(H)}}static c(P,U,Q,H,L){const R=M.$ue.fromString(Q);let F=0;F+=f.sizeUInt8(),F+=f.sizeShortString(R),F+=f.sizeMixedArray(H);const T=f.alloc(L?4:3,P,F);return T.writeUInt8(U),T.writeShortString(R),T.writeMixedArray(H),T.buffer}static deserializeRequestMixedArgs(P){const U=P.readUInt8(),Q=P.readShortString(),H=P.readMixedArray(),L=new Array(H.length);for(let R=0,F=H.length;R<F;R++){const T=H[R];typeof T=="string"?L[R]=JSON.parse(T):L[R]=T}return{rpcId:U,method:Q,args:L}}static serializeAcknowledged(P){return f.alloc(5,P,0).buffer}static serializeCancel(P){return f.alloc(6,P,0).buffer}static serializeReplyOK(P,U,Q){if(typeof U>"u")return this.d(P);if(U instanceof M.$ue)return this.e(P,U);if(U instanceof O.$fw){const{jsonString:H,referencedBuffers:L}=o(U.value,Q,!0);return this.g(P,H,L)}else return this.f(P,l(U,Q))}static d(P){return f.alloc(7,P,0).buffer}static e(P,U){let Q=0;Q+=f.sizeVSBuffer(U);const H=f.alloc(8,P,Q);return H.writeVSBuffer(U),H.buffer}static deserializeReplyOKVSBuffer(P){return P.readVSBuffer()}static f(P,U){const Q=M.$ue.fromString(U);let H=0;H+=f.sizeLongString(Q);const L=f.alloc(9,P,H);return L.writeLongString(Q),L.buffer}static g(P,U,Q){const H=M.$ue.fromString(U);let L=0;L+=f.sizeUInt32,L+=f.sizeLongString(H);for(const F of Q)L+=f.sizeVSBuffer(F);const R=f.alloc(10,P,L);R.writeUInt32(Q.length),R.writeLongString(H);for(const F of Q)R.writeBuffer(F);return R.buffer}static deserializeReplyOKJSON(P){const U=P.readLongString();return JSON.parse(U)}static deserializeReplyOKJSONWithBuffers(P,U){const Q=P.readUInt32(),H=P.readLongString(),L=[];for(let R=0;R<Q;++R)L.push(P.readVSBuffer());return new O.$fw(s(H,L,U))}static serializeReplyErr(P,U){const Q=U?l(N.$3(U),null):void 0;if(typeof Q!="string")return this.h(P);const H=M.$ue.fromString(Q);let L=0;L+=f.sizeLongString(H);const R=f.alloc(11,P,L);return R.writeLongString(H),R.buffer}static deserializeReplyErrError(P){const U=P.readLongString();return JSON.parse(U)}static h(P){return f.alloc(12,P,0).buffer}}var w;(function(S){S[S.RequestJSONArgs=1]="RequestJSONArgs",S[S.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",S[S.RequestMixedArgs=3]="RequestMixedArgs",S[S.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",S[S.Acknowledged=5]="Acknowledged",S[S.Cancel=6]="Cancel",S[S.ReplyOKEmpty=7]="ReplyOKEmpty",S[S.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",S[S.ReplyOKJSON=9]="ReplyOKJSON",S[S.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",S[S.ReplyErrError=11]="ReplyErrError",S[S.ReplyErrEmpty=12]="ReplyErrEmpty"})(w||(w={}));var I;(function(S){S[S.String=1]="String",S[S.VSBuffer=2]="VSBuffer",S[S.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",S[S.Undefined=4]="Undefined"})(I||(I={}))}),define(Pe[244],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Unc=void 0;const k=function(N){const A=m=>{globalThis.removeEventListener("message",A);const d=m.data;Object.defineProperties(globalThis,{postMessage:{value(y,O){d.postMessage(y,O)}},onmessage:{get(){return d.onmessage},set(y){d.onmessage=y}}}),d.addEventListener("message",y=>{globalThis.dispatchEvent(new MessageEvent("message",{data:y.data,ports:y.ports?[...y.ports]:void 0}))}),d.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(N)};globalThis.addEventListener("message",A)}.toString();class M extends EventTarget{constructor(N,A,m){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const d=`((${k})('${A}'))`,y=new Blob([d],{type:"application/javascript"}),O=URL.createObjectURL(y),D=new MessageChannel,l=O,b={type:"_newWorker",id:l,port:D.port2,url:O,options:m};N(b,[D.port2]),this.postMessage=D.port1.postMessage.bind(D.port1),this.terminate=()=>{N({type:"_terminateWorker",id:l}),URL.revokeObjectURL(O),D.port1.close(),D.port2.close()},Object.defineProperties(this,{onmessage:{get(){return D.port1.onmessage},set($){D.port1.onmessage=$}},onmessageerror:{get(){return D.port1.onmessageerror},set($){D.port1.onmessageerror=$}}}),D.port1.addEventListener("messageerror",$=>{const n=new MessageEvent("messageerror",{data:$.data});this.dispatchEvent(n)}),D.port1.addEventListener("message",$=>{const n=new MessageEvent("message",{data:$.data});this.dispatchEvent(n)}),D.port1.start()}}e.$Unc=M}),define(Pe[245],Re([1,0,22,28,12,55,3]),function(ee,e,k,M,C,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0J=e.$7J=void 0,e.$8J=O,e.$9J=D,e.$7J=(0,A.$ii)("notebookDocumentService");const m=["W","X","Y","Z","a","b","c","d","e","f"],d=new RegExp(`^[${m.join("")}]+`),y=7;function O(b){if(b.scheme!==C.Schemas.vscodeNotebookCell)return;const $=b.fragment.indexOf("s");if($<0)return;const n=parseInt(b.fragment.substring(0,$).replace(d,""),y),o=(0,k.$Ne)(b.fragment.substring($+1)).toString();if(!isNaN(n))return{handle:n,notebook:b.with({scheme:o,fragment:null})}}function D(b,$){const n=$.toString(y),s=`${n.length<m.length?m[n.length-1]:"z"}${n}s${(0,k.$Oe)(k.$ue.fromString(b.scheme),!0,!0)}`;return b.with({scheme:C.Schemas.vscodeNotebookCell,fragment:s})}class l{constructor(){this.a=new M.$Bc}getNotebook($){if($.scheme===C.Schemas.vscodeNotebookCell){const n=O($);if(n){const o=this.a.get(n.notebook);if(o)return o}}return this.a.get($)}addNotebookDocument($){this.a.set($.uri,$)}removeNotebookDocument($){this.a.delete($.uri)}}e.$0J=l,(0,N.$hs)(e.$7J,l,1)}),define(Pe[83],Re([1,0,22,34,39,69,12,19,21,33,245]),function(ee,e,k,M,C,N,A,m,d,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rK=e.$oK=e.CellStatusbarAlignment=e.$nK=e.NotebookEditorPriority=e.$kK=e.$jK=e.$hK=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$gK=e.$fK=e.$eK=e.$dK=e.CellKind=e.$cK=e.$bK=e.$aK=void 0,e.$iK=p,e.$lK=g,e.$mK=v,e.$pK=E,e.$qK=I,e.$aK="workbench.editor.notebook",e.$bK="workbench.editor.notebookTextDiffEditor",e.$cK="workbench.editor.interactive";var D;(function(T){T[T.Markup=1]="Markup",T[T.Code=2]="Code"})(D||(e.CellKind=D={})),e.$dK=["application/json","application/javascript","text/html","image/svg+xml",N.$As.latex,N.$As.markdown,"image/png","image/jpeg",N.$As.text],e.$eK=[N.$As.latex,N.$As.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",N.$As.text],e.$fK=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$gK="_notAvailable";var l;(function(T){T[T.Running=1]="Running",T[T.Idle=2]="Idle"})(l||(e.NotebookRunState=l={}));var b;(function(T){T[T.Unconfirmed=1]="Unconfirmed",T[T.Pending=2]="Pending",T[T.Executing=3]="Executing"})(b||(e.NotebookCellExecutionState=b={}));var $;(function(T){T[T.Unconfirmed=1]="Unconfirmed",T[T.Pending=2]="Pending",T[T.Executing=3]="Executing"})($||(e.NotebookExecutionState=$={}));var n;(function(T){T[T.WithHardKernelDependency=0]="WithHardKernelDependency",T[T.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",T[T.Pure=2]="Pure",T[T.Never=3]="Never"})(n||(e.NotebookRendererMatch=n={}));var o;(function(T){T.Always="always",T.Never="never",T.Optional="optional"})(o||(e.RendererMessagingSpec=o={}));var s;(function(T){T[T.ModelChange=1]="ModelChange",T[T.Move=2]="Move",T[T.ChangeCellLanguage=5]="ChangeCellLanguage",T[T.Initialize=6]="Initialize",T[T.ChangeCellMetadata=7]="ChangeCellMetadata",T[T.Output=8]="Output",T[T.OutputItem=9]="OutputItem",T[T.ChangeCellContent=10]="ChangeCellContent",T[T.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",T[T.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",T[T.ChangeCellMime=13]="ChangeCellMime",T[T.Unknown=100]="Unknown"})(s||(e.NotebookCellsChangeType=s={}));var r;(function(T){T[T.Handle=0]="Handle",T[T.Index=1]="Index"})(r||(e.SelectionStateType=r={}));var i;(function(T){T[T.Replace=1]="Replace",T[T.Output=2]="Output",T[T.Metadata=3]="Metadata",T[T.CellLanguage=4]="CellLanguage",T[T.DocumentMetadata=5]="DocumentMetadata",T[T.Move=6]="Move",T[T.OutputItems=7]="OutputItems",T[T.PartialMetadata=8]="PartialMetadata",T[T.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var c;(function(T){T.scheme=A.Schemas.vscodeNotebookCell;function X(se,De){return(0,O.$9J)(se,De)}T.generate=X;function re(se){return(0,O.$8J)(se)}T.parse=re;function me(se,De){return se.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${De??""},${se.scheme!==A.Schemas.file?se.scheme:""}`})}T.generateCellOutputUri=me;function pe(se){if(se.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const De=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(se.fragment);if(!De)return;const Oe=De[1]&&De[1]!==""?De[1]:void 0,ie=De[2];return{outputId:Oe,notebook:se.with({scheme:ie||A.Schemas.file,fragment:null})}}T.parseCellOutputUri=pe;function ae(se,De,Oe){return T.generate(se,De).with({scheme:Oe})}T.generateCellPropertyUri=ae;function be(se,De){if(se.scheme===De)return T.parse(se.with({scheme:T.scheme}))}T.parseCellPropertyUri=be})(c||(e.CellUri=c={}));const h=T=>d.$c?T.replace(/\//g,"\\"):T;class t{constructor(X=[],re=e.$dK){this.e=re,this.d=[...new Set(X)].map(me=>({pattern:me,matches:M.$ck(h(me))}))}sort(X){const re=new Map(C.Iterable.map(X,pe=>[pe,h(pe)]));let me=[];for(const{matches:pe}of this.d)for(const[ae,be]of re)if(pe(be)){me.push(ae),re.delete(ae);break}return re.size&&(me=me.concat([...re.keys()].sort((pe,ae)=>this.e.indexOf(pe)-this.e.indexOf(ae)))),me}prioritize(X,re){const me=this.f(X);if(me===-1){this.d.unshift({pattern:X,matches:M.$ck(h(X))});return}const pe=new Set(re.map(be=>this.f(be,me)));pe.delete(-1);const ae=Array.from(pe).sort();this.d.splice(me+1,0,...ae.map(be=>this.d[be]));for(let be=ae.length-1;be>=0;be--)this.d.splice(ae[be],1)}toArray(){return this.d.map(X=>X.pattern)}f(X,re=this.d.length){const me=h(X);for(let pe=0;pe<re;pe++)if(this.d[pe].matches(me))return pe;return-1}}e.$hK=t;function p(T,X,re,me=(pe,ae)=>pe===ae){const pe=[];function ae(De,Oe,ie){if(Oe===0&&ie.length===0)return;const q=pe[pe.length-1];q&&q.start+q.deleteCount===De?(q.deleteCount+=Oe,q.toInsert.push(...ie)):pe.push({start:De,deleteCount:Oe,toInsert:ie})}let be=0,se=0;for(;;){if(be===T.length){ae(be,0,X.slice(se));break}if(se===X.length){ae(be,T.length-be,[]);break}const De=T[be],Oe=X[se];if(me(De,Oe)){be+=1,se+=1;continue}re(Oe)?(ae(be,1,[]),be+=1):(ae(be,0,[Oe]),se+=1)}return pe}e.$jK=new y.$zj("notebookEditorCursorAtBoundary","none"),e.$kK=new y.$zj("notebookEditorCursorAtLineBoundary","none");var a;(function(T){T.default="default",T.option="option"})(a||(e.NotebookEditorPriority=a={}));function g(T){const X=T;return!!((typeof X.include=="string"||M.$dk(X.include))&&(typeof X.exclude=="string"||M.$dk(X.exclude)))}function v(T,X,re){if(Array.isArray(T.viewType)&&T.viewType.indexOf(X)>=0||T.viewType===X)return!0;if(T.filenamePattern){const me=g(T.filenamePattern)?T.filenamePattern.include:T.filenamePattern,pe=g(T.filenamePattern)?T.filenamePattern.exclude:void 0;if(M.$bk(me,(0,m.$oc)(re.fsPath).toLowerCase()))return!(pe&&M.$bk(pe,(0,m.$oc)(re.fsPath).toLowerCase()))}return!1}e.$nK={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics"};var f;(function(T){T[T.Left=1]="Left",T[T.Right=2]="Right"})(f||(e.CellStatusbarAlignment=f={}));class u{static create(X){return`${u.d}${X}`}static parse(X){if(X.startsWith(u.d))return X.substring(u.d.length)}}e.$oK=u,u.d="notebook/";function E(T){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(T)}const w=new TextDecoder;function I(T){const X=[];let re=!1;for(const be of T)(X.length===0||re)&&(X.push(be),re=!0);let me=U(X);const pe=k.$ue.concat(X.map(be=>k.$ue.wrap(be))),ae=F(pe);return me=me||ae.byteLength!==pe.byteLength,{data:ae,didCompression:me}}e.$rK="\x1B[A";const S=e.$rK.split("").map(T=>T.charCodeAt(0)),P=10;function U(T){let X=!1;return T.forEach((re,me)=>{if(me===0||re.length<e.$rK.length)return;const pe=T[me-1],ae=re.subarray(0,e.$rK.length);if(ae[0]===S[0]&&ae[1]===S[1]&&ae[2]===S[2]){const be=pe.lastIndexOf(P);if(be===-1)return;X=!0,T[me-1]=pe.subarray(0,be),T[me]=re.subarray(e.$rK.length)}}),X}function Q(T){let X=T;do T=X,X=T.replace(/[^\n]\x08/gm,"");while(X.length<T.length);return T}function H(T){for(T=T.replace(/\r+\n/gm,`
`);T.search(/\r[^$]/g)>-1;){const X=T.match(/^(.*)\r+/m)[1];let re=T.match(/\r+(.*)$/m)[1];re=re+X.slice(re.length,X.length),T=T.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,re)}return T}const L=8,R=13;function F(T){return!T.buffer.includes(L)&&!T.buffer.includes(R)?T:k.$ue.fromString(H(Q(w.decode(T.buffer))))}});var _e=this&&this.__classPrivateFieldSet||function(ee,e,k,M,C){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?C.call(ee,k):C?C.value=k:e.set(ee,k),k},Ve=this&&this.__classPrivateFieldGet||function(ee,e,k,M){if(k==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!M:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return k==="m"?M:k==="a"?M.call(ee):M?M.value:e.get(ee)};define(Pe[7],Re([1,0,18,14,54,28,69,15,17,2,35,20,43,102,83]),function(ee,e,k,M,C,N,A,m,d,y,O,D,l,b,$){"use strict";var n,o,s,r,i,c,h,t,p,a,g,v,f,u,E,w,I,S,P,U,Q,H,L,R,F;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$CO=e.KeywordRecognitionStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$BO=e.$AO=e.$zO=e.$yO=e.ChatLocation=e.$xO=e.$wO=e.$vO=e.$uO=e.$tO=e.$sO=e.$rO=e.$qO=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$pO=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$oO=e.$nO=e.$mO=e.$lO=e.$kO=e.$jO=e.$iO=e.$hO=e.$gO=e.$fO=e.$eO=e.$dO=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$cO=e.$bO=e.$aO=e.$_N=e.$0N=e.$9N=e.$8N=e.$7N=e.TestRunProfileKind=e.TestResultState=e.$6N=e.$5N=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$4N=e.NotebookVariablesRequestKind=e.$3N=e.$2N=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$1N=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$ZN=e.$YN=e.$XN=e.$WN=e.$VN=e.ColorThemeKind=e.$UN=e.$TN=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$SN=e.$RN=e.DebugConsoleMode=e.$QN=e.$PN=e.$ON=e.$NN=e.$MN=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$LN=e.$KN=e.FileChangeType=e.$JN=e.NewSymbolNameTag=e.$IN=e.$HN=e.$GN=e.$FN=e.InlineCompletionTriggerKind=e.$EN=e.$DN=e.$CN=e.$BN=e.$AN=e.$zN=e.$yN=e.$xN=e.$wN=e.$vN=e.$uN=e.$sN=e.ConfigurationTarget=e.$rN=e.$qN=e.$pN=e.$oN=e.DocumentPasteTriggerKind=e.$nN=e.$mN=e.$lN=e.$kN=e.$jN=e.$iN=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$hN=e.ViewBadge=e.ProgressLocation=e.$gN=e.$fN=e.TaskScope=e.ShellQuoting=e.$eN=e.$dN=e.$cN=e.TaskPanelKind=e.TaskRevealKind=e.$bN=e.TerminalLocation=e.$aN=e.$_M=e.$$M=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$0M=e.$9M=e.$8M=e.$7M=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$5M=e.$4M=e.$3M=e.$2M=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$1M=e.$ZM=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$YM=e.$XM=e.$WM=e.$VM=e.$UM=e.LanguageStatusSeverity=e.$TM=e.$SM=e.$RM=e.$QM=e.$PM=e.$OM=e.CodeActionTriggerKind=e.$NM=e.$MM=e.SymbolTag=e.SymbolKind=e.$LM=e.$KM=e.DocumentHighlightKind=e.$JM=e.$IM=e.$HM=e.$GM=e.DiagnosticSeverity=e.DiagnosticTag=e.$FM=e.$EM=e.FileEditType=e.$DM=e.$CM=e.$BM=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$AM=e.$zM=e.$yM=e.$xM=e.$wM=e.$vM=e.$uM=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$6M=_t,e.$tN=oi,e.$$N=In;function T(V){return Object.assign(V,{apply:function(...ne){if(ne.length===0)return Reflect.construct(V,[]);{const Se=ne.length===1?[]:ne[1];return Reflect.construct(V,Se,ne[0].constructor)}},call:function(...ne){if(ne.length===0)return Reflect.construct(V,[]);{const[Se,...Je]=ne;return Reflect.construct(V,Je,Se.constructor)}}})}var X;(function(V){V[V.Top=0]="Top",V[V.Bottom=1]="Bottom"})(X||(e.TerminalOutputAnchor=X={}));var re;(function(V){V[V.TerminalCommand=0]="TerminalCommand",V[V.Opener=1]="Opener",V[V.Command=3]="Command"})(re||(e.TerminalQuickFixType=re={}));let me=p=class{static from(...z){let ne=z;return new p(function(){if(ne){for(const Se of ne)Se&&typeof Se.dispose=="function"&&Se.dispose();ne=void 0}})}constructor(z){n.set(this,void 0),_e(this,n,z,"f")}dispose(){typeof Ve(this,n,"f")=="function"&&(Ve(this,n,"f").call(this),_e(this,n,void 0,"f"))}};e.$uM=me,n=new WeakMap,e.$uM=me=p=Xe([T],me);let pe=a=class{static Min(...z){if(z.length===0)throw new TypeError;let ne=z[0];for(let Se=1;Se<z.length;Se++){const Je=z[Se];Je.isBefore(ne)&&(ne=Je)}return ne}static Max(...z){if(z.length===0)throw new TypeError;let ne=z[0];for(let Se=1;Se<z.length;Se++){const Je=z[Se];Je.isAfter(ne)&&(ne=Je)}return ne}static isPosition(z){if(!z)return!1;if(z instanceof a)return!0;const{line:ne,character:Se}=z;return typeof ne=="number"&&typeof Se=="number"}static of(z){if(z instanceof a)return z;if(this.isPosition(z))return new a(z.line,z.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(z,ne){if(z<0)throw(0,M.$7)("line must be non-negative");if(ne<0)throw(0,M.$7)("character must be non-negative");this.c=z,this.e=ne}isBefore(z){return this.c<z.c?!0:z.c<this.c?!1:this.e<z.e}isBeforeOrEqual(z){return this.c<z.c?!0:z.c<this.c?!1:this.e<=z.e}isAfter(z){return!this.isBeforeOrEqual(z)}isAfterOrEqual(z){return!this.isBefore(z)}isEqual(z){return this.c===z.c&&this.e===z.e}compareTo(z){return this.c<z.c?-1:this.c>z.line?1:this.e<z.e?-1:this.e>z.e?1:0}translate(z,ne=0){if(z===null||ne===null)throw(0,M.$7)();let Se;return typeof z>"u"?Se=0:typeof z=="number"?Se=z:(Se=typeof z.lineDelta=="number"?z.lineDelta:0,ne=typeof z.characterDelta=="number"?z.characterDelta:0),Se===0&&ne===0?this:new a(this.line+Se,this.character+ne)}with(z,ne=this.character){if(z===null||ne===null)throw(0,M.$7)();let Se;return typeof z>"u"?Se=this.line:typeof z=="number"?Se=z:(Se=typeof z.line=="number"?z.line:this.line,ne=typeof z.character=="number"?z.character:this.character),Se===this.line&&ne===this.character?this:new a(Se,ne)}toJSON(){return{line:this.line,character:this.character}}};e.$vM=pe,e.$vM=pe=a=Xe([T],pe);let ae=g=class{static isRange(z){return z instanceof g?!0:z?pe.isPosition(z.start)&&pe.isPosition(z.end):!1}static of(z){if(z instanceof g)return z;if(this.isRange(z))return new g(z.start,z.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(z,ne,Se,Je){let tt,ht;if(typeof z=="number"&&typeof ne=="number"&&typeof Se=="number"&&typeof Je=="number"?(tt=new pe(z,ne),ht=new pe(Se,Je)):pe.isPosition(z)&&pe.isPosition(ne)&&(tt=pe.of(z),ht=pe.of(ne)),!tt||!ht)throw new Error("Invalid arguments");tt.isBefore(ht)?(this.c=tt,this.e=ht):(this.c=ht,this.e=tt)}contains(z){return g.isRange(z)?this.contains(z.start)&&this.contains(z.end):pe.isPosition(z)?!(pe.of(z).isBefore(this.c)||this.e.isBefore(z)):!1}isEqual(z){return this.c.isEqual(z.c)&&this.e.isEqual(z.e)}intersection(z){const ne=pe.Max(z.start,this.c),Se=pe.Min(z.end,this.e);if(!ne.isAfter(Se))return new g(ne,Se)}union(z){if(this.contains(z))return this;if(z.contains(this))return z;const ne=pe.Min(z.start,this.c),Se=pe.Max(z.end,this.end);return new g(ne,Se)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(z,ne=this.end){if(z===null||ne===null)throw(0,M.$7)();let Se;return z?pe.isPosition(z)?Se=z:(Se=z.start||this.start,ne=z.end||this.end):Se=this.start,Se.isEqual(this.c)&&ne.isEqual(this.end)?this:new g(Se,ne)}toJSON(){return[this.start,this.end]}};e.$wM=ae,e.$wM=ae=g=Xe([T],ae);let be=v=class extends ae{static isSelection(z){return z instanceof v?!0:z?ae.isRange(z)&&pe.isPosition(z.anchor)&&pe.isPosition(z.active)&&typeof z.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(z,ne,Se,Je){let tt,ht;if(typeof z=="number"&&typeof ne=="number"&&typeof Se=="number"&&typeof Je=="number"?(tt=new pe(z,ne),ht=new pe(Se,Je)):pe.isPosition(z)&&pe.isPosition(ne)&&(tt=pe.of(z),ht=pe.of(ne)),!tt||!ht)throw new Error("Invalid arguments");super(tt,ht),this.f=tt,this.g=ht}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$xM=be,e.$xM=be=v=Xe([T],be);const se=V=>{if(typeof V!="string"||V.length===0||!/^[0-9A-Za-z_\-]+$/.test(V))throw(0,M.$7)("connectionToken")};class De{static isResolvedAuthority(z){return z&&typeof z=="object"&&typeof z.host=="string"&&typeof z.port=="number"&&(z.connectionToken===void 0||typeof z.connectionToken=="string")}constructor(z,ne,Se){if(typeof z!="string"||z.length===0)throw(0,M.$7)("host");if(typeof ne!="number"||ne===0||Math.round(ne)!==ne)throw(0,M.$7)("port");typeof Se<"u"&&se(Se),this.host=z,this.port=Math.round(ne),this.connectionToken=Se}}e.$yM=De;class Oe{static isManagedResolvedAuthority(z){return z&&typeof z=="object"&&typeof z.makeConnection=="function"&&(z.connectionToken===void 0||typeof z.connectionToken=="string")}constructor(z,ne){this.makeConnection=z,this.connectionToken=ne,typeof ne<"u"&&se(ne)}}e.$zM=Oe;class ie extends Error{static NotAvailable(z,ne){return new ie(z,b.RemoteAuthorityResolverErrorCode.NotAvailable,ne)}static TemporarilyNotAvailable(z){return new ie(z,b.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(z,ne=b.RemoteAuthorityResolverErrorCode.Unknown,Se){super(z),this._message=z,this._code=ne,this._detail=Se,Object.setPrototypeOf(this,ie.prototype)}}e.$AM=ie;var q;(function(V){V[V.LF=1]="LF",V[V.CRLF=2]="CRLF"})(q||(e.EndOfLine=q={}));var de;(function(V){V[V.Replace=1]="Replace",V[V.Append=2]="Append",V[V.Prepend=3]="Prepend"})(de||(e.EnvironmentVariableMutatorType=de={}));let Ne=f=class{static isTextEdit(z){return z instanceof f?!0:z?ae.isRange(z)&&typeof z.newText=="string":!1}static replace(z,ne){return new f(z,ne)}static insert(z,ne){return f.replace(new ae(z,z),ne)}static delete(z){return f.replace(z,"")}static setEndOfLine(z){const ne=new f(new ae(new pe(0,0),new pe(0,0)),"");return ne.newEol=z,ne}get range(){return this.c}set range(z){if(z&&!ae.isRange(z))throw(0,M.$7)("range");this.c=z}get newText(){return this.e||""}set newText(z){if(z&&typeof z!="string")throw(0,M.$7)("newText");this.e=z}get newEol(){return this.f}set newEol(z){if(z&&typeof z!="number")throw(0,M.$7)("newEol");this.f=z}constructor(z,ne){this.c=z,this.e=ne}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$BM=Ne,e.$BM=Ne=f=Xe([T],Ne);let $e=u=class{static isNotebookCellEdit(z){return z instanceof u?!0:z?$i.isNotebookRange(z)&&Array.isArray(z.newCells):!1}static replaceCells(z,ne){return new u(z,ne)}static insertCells(z,ne){return new u(new $i(z,z),ne)}static deleteCells(z){return new u(z,[])}static updateCellMetadata(z,ne){const Se=new u(new $i(z,z),[]);return Se.newCellMetadata=ne,Se}static updateNotebookMetadata(z){const ne=new u(new $i(0,0),[]);return ne.newNotebookMetadata=z,ne}constructor(z,ne){this.range=z,this.newCells=ne}};e.$CM=$e,e.$CM=$e=u=Xe([T],$e);class we{static isSnippetTextEdit(z){return z instanceof we?!0:z?ae.isRange(z.range)&&K.isSnippetString(z.snippet):!1}static replace(z,ne){return new we(z,ne)}static insert(z,ne){return we.replace(new ae(z,z),ne)}constructor(z,ne){this.range=z,this.snippet=ne}}e.$DM=we;var ge;(function(V){V[V.File=1]="File",V[V.Text=2]="Text",V[V.Cell=3]="Cell",V[V.CellReplace=5]="CellReplace",V[V.Snippet=6]="Snippet"})(ge||(e.FileEditType=ge={}));let ce=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(z,ne,Se,Je){this.c.push({_type:1,from:z,to:ne,options:Se,metadata:Je})}createFile(z,ne,Se){this.c.push({_type:1,from:void 0,to:z,options:ne,metadata:Se})}deleteFile(z,ne,Se){this.c.push({_type:1,from:z,to:void 0,options:ne,metadata:Se})}e(z,ne,Se){this.c.push({_type:3,metadata:Se,uri:z,edit:{editType:5,metadata:ne},notebookMetadata:ne})}f(z,ne,Se,Je){const tt=ne.start,ht=ne.end;(tt!==ht||Se.length>0)&&this.c.push({_type:5,uri:z,index:tt,count:ht-tt,cells:Se,metadata:Je})}g(z,ne,Se,Je){this.c.push({_type:3,metadata:Je,uri:z,edit:{editType:3,index:ne,metadata:Se}})}replace(z,ne,Se,Je){this.c.push({_type:2,uri:z,edit:new Ne(ne,Se),metadata:Je})}insert(z,ne,Se,Je){this.replace(z,new ae(ne,ne),Se,Je)}delete(z,ne,Se){this.replace(z,ne,"",Se)}has(z){return this.c.some(ne=>ne._type===2&&ne.uri.toString()===z.toString())}set(z,ne){if(ne)for(const Se of ne){if(!Se)continue;let Je,tt;Array.isArray(Se)?(Je=Se[0],tt=Se[1]):Je=Se,$e.isNotebookCellEdit(Je)?Je.newCellMetadata?this.g(z,Je.range.start,Je.newCellMetadata,tt):Je.newNotebookMetadata?this.e(z,Je.newNotebookMetadata,tt):this.f(z,Je.range,Je.newCells,tt):we.isSnippetTextEdit(Je)?this.c.push({_type:6,uri:z,range:Je.range,edit:Je.snippet,metadata:tt}):this.c.push({_type:2,uri:z,edit:Je,metadata:tt})}else{for(let Se=0;Se<this.c.length;Se++){const Je=this.c[Se];switch(Je._type){case 2:case 6:case 3:case 5:Je.uri.toString()===z.toString()&&(this.c[Se]=void 0);break}}(0,k.$Ib)(this.c)}}get(z){const ne=[];for(const Se of this.c)Se._type===2&&Se.uri.toString()===z.toString()&&ne.push(Se.edit);return ne}entries(){const z=new N.$Bc;for(const ne of this.c)if(ne._type===2){let Se=z.get(ne.uri);Se||(Se=[ne.uri,[]],z.set(ne.uri,Se)),Se[1].push(ne.edit)}return[...z.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$EM=ce,e.$EM=ce=Xe([T],ce);let K=E=class{static isSnippetString(z){return z instanceof E?!0:z?typeof z.value=="string":!1}static c(z){return z.replace(/\$|}|\\/g,"\\$&")}constructor(z){this.e=1,this.value=z||""}appendText(z){return this.value+=E.c(z),this}appendTabstop(z=this.e++){return this.value+="$",this.value+=z,this}appendPlaceholder(z,ne=this.e++){if(typeof z=="function"){const Se=new E;Se.e=this.e,z(Se),this.e=Se.e,z=Se.value}else z=E.c(z);return this.value+="${",this.value+=ne,this.value+=":",this.value+=z,this.value+="}",this}appendChoice(z,ne=this.e++){const Se=z.map(Je=>Je.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=ne,this.value+="|",this.value+=Se,this.value+="|}",this}appendVariable(z,ne){if(typeof ne=="function"){const Se=new E;Se.e=this.e,ne(Se),this.e=Se.e,ne=Se.value}else typeof ne=="string"&&(ne=ne.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=z,ne&&(this.value+=":",this.value+=ne),this.value+="}",this}};e.$FM=K,e.$FM=K=E=Xe([T],K);var Z;(function(V){V[V.Unnecessary=1]="Unnecessary",V[V.Deprecated=2]="Deprecated"})(Z||(e.DiagnosticTag=Z={}));var le;(function(V){V[V.Hint=3]="Hint",V[V.Information=2]="Information",V[V.Warning=1]="Warning",V[V.Error=0]="Error"})(le||(e.DiagnosticSeverity=le={}));let fe=w=class{static isLocation(z){return z instanceof w?!0:z?ae.isRange(z.range)&&y.URI.isUri(z.uri):!1}constructor(z,ne){if(this.uri=z,ne)if(ae.isRange(ne))this.range=ae.of(ne);else if(pe.isPosition(ne))this.range=new ae(ne,ne);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$GM=fe,e.$GM=fe=w=Xe([T],fe);let Te=class{static is(z){return z?typeof z.message=="string"&&z.location&&ae.isRange(z.location.range)&&y.URI.isUri(z.location.uri):!1}constructor(z,ne){this.location=z,this.message=ne}static isEqual(z,ne){return z===ne?!0:!z||!ne?!1:z.message===ne.message&&z.location.range.isEqual(ne.location.range)&&z.location.uri.toString()===ne.location.uri.toString()}};e.$HM=Te,e.$HM=Te=Xe([T],Te);let ve=class{constructor(z,ne,Se=le.Error){if(!ae.isRange(z))throw new TypeError("range must be set");if(!ne)throw new TypeError("message must be set");this.range=z,this.message=ne,this.severity=Se}toJSON(){return{severity:le[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(z,ne){return z===ne?!0:!z||!ne?!1:z.message===ne.message&&z.severity===ne.severity&&z.code===ne.code&&z.severity===ne.severity&&z.source===ne.source&&z.range.isEqual(ne.range)&&(0,k.$ub)(z.tags,ne.tags)&&(0,k.$ub)(z.relatedInformation,ne.relatedInformation,Te.isEqual)}};e.$IM=ve,e.$IM=ve=Xe([T],ve);let Ie=class{constructor(z,ne){if(!z)throw new Error("Illegal argument, contents must be defined");Array.isArray(z)?this.contents=z:this.contents=[z],this.range=ne}};e.$JM=Ie,e.$JM=Ie=Xe([T],Ie);var Ae;(function(V){V[V.Text=0]="Text",V[V.Read=1]="Read",V[V.Write=2]="Write"})(Ae||(e.DocumentHighlightKind=Ae={}));let je=class{constructor(z,ne=Ae.Text){this.range=z,this.kind=ne}toJSON(){return{range:this.range,kind:Ae[this.kind]}}};e.$KM=je,e.$KM=je=Xe([T],je);let j=class{constructor(z,ne){this.uri=z,this.highlights=ne}toJSON(){return{uri:this.uri,highlights:this.highlights.map(z=>z.toJSON())}}};e.$LM=j,e.$LM=j=Xe([T],j);var B;(function(V){V[V.File=0]="File",V[V.Module=1]="Module",V[V.Namespace=2]="Namespace",V[V.Package=3]="Package",V[V.Class=4]="Class",V[V.Method=5]="Method",V[V.Property=6]="Property",V[V.Field=7]="Field",V[V.Constructor=8]="Constructor",V[V.Enum=9]="Enum",V[V.Interface=10]="Interface",V[V.Function=11]="Function",V[V.Variable=12]="Variable",V[V.Constant=13]="Constant",V[V.String=14]="String",V[V.Number=15]="Number",V[V.Boolean=16]="Boolean",V[V.Array=17]="Array",V[V.Object=18]="Object",V[V.Key=19]="Key",V[V.Null=20]="Null",V[V.EnumMember=21]="EnumMember",V[V.Struct=22]="Struct",V[V.Event=23]="Event",V[V.Operator=24]="Operator",V[V.TypeParameter=25]="TypeParameter"})(B||(e.SymbolKind=B={}));var G;(function(V){V[V.Deprecated=1]="Deprecated"})(G||(e.SymbolTag=G={}));let W=I=class{static validate(z){if(!z.name)throw new Error("name must not be falsy")}constructor(z,ne,Se,Je,tt){this.name=z,this.kind=ne,this.containerName=tt,typeof Se=="string"&&(this.containerName=Se),Je instanceof fe?this.location=Je:Se instanceof ae&&(this.location=new fe(Je,Se)),I.validate(this)}toJSON(){return{name:this.name,kind:B[this.kind],location:this.location,containerName:this.containerName}}};e.$MM=W,e.$MM=W=I=Xe([T],W);let _=S=class{static validate(z){if(!z.name)throw new Error("name must not be falsy");if(!z.range.contains(z.selectionRange))throw new Error("selectionRange must be contained in fullRange");z.children?.forEach(S.validate)}constructor(z,ne,Se,Je,tt){this.name=z,this.detail=ne,this.kind=Se,this.range=Je,this.selectionRange=tt,this.children=[],S.validate(this)}};e.$NM=_,e.$NM=_=S=Xe([T],_);var oe;(function(V){V[V.Invoke=1]="Invoke",V[V.Automatic=2]="Automatic"})(oe||(e.CodeActionTriggerKind=oe={}));let Fe=class{constructor(z,ne){this.title=z,this.kind=ne}};e.$OM=Fe,e.$OM=Fe=Xe([T],Fe);let Be=P=class{constructor(z){this.value=z}append(z){return new P(this.value?this.value+P.c+z:z)}intersects(z){return this.contains(z)||z.contains(this)}contains(z){return this.value===z.value||z.value.startsWith(this.value+P.c)}};e.$PM=Be,Be.c=".",e.$PM=Be=P=Xe([T],Be),Be.Empty=new Be(""),Be.QuickFix=Be.Empty.append("quickfix"),Be.Refactor=Be.Empty.append("refactor"),Be.RefactorExtract=Be.Refactor.append("extract"),Be.RefactorInline=Be.Refactor.append("inline"),Be.RefactorMove=Be.Refactor.append("move"),Be.RefactorRewrite=Be.Refactor.append("rewrite"),Be.Source=Be.Empty.append("source"),Be.SourceOrganizeImports=Be.Source.append("organizeImports"),Be.SourceFixAll=Be.Source.append("fixAll"),Be.Notebook=Be.Empty.append("notebook");let Qe=class{constructor(z,ne){if(this.range=z,this.parent=ne,ne&&!ne.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$QM=Qe,e.$QM=Qe=Xe([T],Qe);class et{constructor(z,ne,Se,Je,tt,ht){this.kind=z,this.name=ne,this.detail=Se,this.uri=Je,this.range=tt,this.selectionRange=ht}}e.$RM=et;class it{constructor(z,ne){this.fromRanges=ne,this.from=z}}e.$SM=it;class ut{constructor(z,ne){this.fromRanges=ne,this.to=z}}e.$TM=ut;var st;(function(V){V[V.Information=0]="Information",V[V.Warning=1]="Warning",V[V.Error=2]="Error"})(st||(e.LanguageStatusSeverity=st={}));let rt=class{constructor(z,ne){this.range=z,this.command=ne}get isResolved(){return!!this.command}};e.$UM=rt,e.$UM=rt=Xe([T],rt);let ot=U=class{static isMarkdownString(z){return z instanceof U?!0:z&&z.appendCodeblock&&z.appendMarkdown&&z.appendText&&z.value!==void 0}constructor(z,ne=!1){o.set(this,void 0),_e(this,o,new C.$Fk(z,{supportThemeIcons:ne}),"f")}get value(){return Ve(this,o,"f").value}set value(z){Ve(this,o,"f").value=z}get isTrusted(){return Ve(this,o,"f").isTrusted}set isTrusted(z){Ve(this,o,"f").isTrusted=z}get supportThemeIcons(){return Ve(this,o,"f").supportThemeIcons}set supportThemeIcons(z){Ve(this,o,"f").supportThemeIcons=z}get supportHtml(){return Ve(this,o,"f").supportHtml}set supportHtml(z){Ve(this,o,"f").supportHtml=z}get baseUri(){return Ve(this,o,"f").baseUri}set baseUri(z){Ve(this,o,"f").baseUri=z}appendText(z){return Ve(this,o,"f").appendText(z),this}appendMarkdown(z){return Ve(this,o,"f").appendMarkdown(z),this}appendCodeblock(z,ne){return Ve(this,o,"f").appendCodeblock(ne??"",z),this}};e.$VM=ot,o=new WeakMap,e.$VM=ot=U=Xe([T],ot);let $t=class{constructor(z,ne){this.label=z,this.documentation=ne}};e.$WM=$t,e.$WM=$t=Xe([T],$t);let Ue=class{constructor(z,ne){this.label=z,this.documentation=ne,this.parameters=[]}};e.$XM=Ue,e.$XM=Ue=Xe([T],Ue);let ct=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$YM=ct,e.$YM=ct=Xe([T],ct);var x;(function(V){V[V.Invoke=1]="Invoke",V[V.TriggerCharacter=2]="TriggerCharacter",V[V.ContentChange=3]="ContentChange"})(x||(e.SignatureHelpTriggerKind=x={}));var Y;(function(V){V[V.Type=1]="Type",V[V.Parameter=2]="Parameter"})(Y||(e.InlayHintKind=Y={}));let ye=class{constructor(z){this.value=z}};e.$ZM=ye,e.$ZM=ye=Xe([T],ye);let He=class{constructor(z,ne,Se){this.position=z,this.label=ne,this.kind=Se}};e.$1M=He,e.$1M=He=Xe([T],He);var Ye;(function(V){V[V.Invoke=0]="Invoke",V[V.TriggerCharacter=1]="TriggerCharacter",V[V.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ye||(e.CompletionTriggerKind=Ye={}));var Me;(function(V){V[V.Text=0]="Text",V[V.Method=1]="Method",V[V.Function=2]="Function",V[V.Constructor=3]="Constructor",V[V.Field=4]="Field",V[V.Variable=5]="Variable",V[V.Class=6]="Class",V[V.Interface=7]="Interface",V[V.Module=8]="Module",V[V.Property=9]="Property",V[V.Unit=10]="Unit",V[V.Value=11]="Value",V[V.Enum=12]="Enum",V[V.Keyword=13]="Keyword",V[V.Snippet=14]="Snippet",V[V.Color=15]="Color",V[V.File=16]="File",V[V.Reference=17]="Reference",V[V.Folder=18]="Folder",V[V.EnumMember=19]="EnumMember",V[V.Constant=20]="Constant",V[V.Struct=21]="Struct",V[V.Event=22]="Event",V[V.Operator=23]="Operator",V[V.TypeParameter=24]="TypeParameter",V[V.User=25]="User",V[V.Issue=26]="Issue"})(Me||(e.CompletionItemKind=Me={}));var dt;(function(V){V[V.Deprecated=1]="Deprecated"})(dt||(e.CompletionItemTag=dt={}));let Mt=class{constructor(z,ne){this.label=z,this.kind=ne}toJSON(){return{label:this.label,kind:this.kind&&Me[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$2M=Mt,e.$2M=Mt=Xe([T],Mt);let Bt=class{constructor(z=[],ne=!1){this.items=z,this.isIncomplete=ne}};e.$3M=Bt,e.$3M=Bt=Xe([T],Bt);let Qt=class{constructor(z,ne,Se){this.insertText=z,this.range=ne,this.command=Se}};e.$4M=Qt,e.$4M=Qt=Xe([T],Qt);let Yt=class{constructor(z){this.commands=void 0,this.suppressSuggestions=void 0,this.items=z}};e.$5M=Yt,e.$5M=Yt=Xe([T],Yt);var xt;(function(V){V[V.Unknown=0]="Unknown",V[V.Word=1]="Word",V[V.Line=2]="Line",V[V.Suggest=3]="Suggest"})(xt||(e.PartialAcceptTriggerKind=xt={}));var It;(function(V){V[V.Active=-1]="Active",V[V.Beside=-2]="Beside",V[V.One=1]="One",V[V.Two=2]="Two",V[V.Three=3]="Three",V[V.Four=4]="Four",V[V.Five=5]="Five",V[V.Six=6]="Six",V[V.Seven=7]="Seven",V[V.Eight=8]="Eight",V[V.Nine=9]="Nine"})(It||(e.ViewColumn=It={}));var ri;(function(V){V[V.Left=1]="Left",V[V.Right=2]="Right"})(ri||(e.StatusBarAlignment=ri={}));function _t(V,z){return`${D.$Em.toKey(V)}.${z}`}var hi;(function(V){V[V.Off=0]="Off",V[V.On=1]="On",V[V.Relative=2]="Relative",V[V.Interval=3]="Interval"})(hi||(e.TextEditorLineNumbersStyle=hi={}));var xe;(function(V){V[V.Manual=1]="Manual",V[V.AfterDelay=2]="AfterDelay",V[V.FocusOut=3]="FocusOut"})(xe||(e.TextDocumentSaveReason=xe={}));var si;(function(V){V[V.Default=0]="Default",V[V.InCenter=1]="InCenter",V[V.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",V[V.AtTop=3]="AtTop"})(si||(e.TextEditorRevealType=si={}));var Ht;(function(V){V[V.Keyboard=1]="Keyboard",V[V.Mouse=2]="Mouse",V[V.Command=3]="Command"})(Ht||(e.TextEditorSelectionChangeKind=Ht={}));var Gt;(function(V){V[V.Undo=1]="Undo",V[V.Redo=2]="Redo"})(Gt||(e.TextDocumentChangeReason=Gt={}));var ft;(function(V){V[V.OpenOpen=0]="OpenOpen",V[V.ClosedClosed=1]="ClosedClosed",V[V.OpenClosed=2]="OpenClosed",V[V.ClosedOpen=3]="ClosedOpen"})(ft||(e.DecorationRangeBehavior=ft={})),function(V){function z(ne){switch(ne){case"keyboard":return V.Keyboard;case"mouse":return V.Mouse;case"api":return V.Command}}V.fromValue=z}(Ht||(e.TextEditorSelectionChangeKind=Ht={}));var vt;(function(V){V[V.Other=0]="Other",V[V.Comment=1]="Comment",V[V.String=2]="String",V[V.RegEx=3]="RegEx"})(vt||(e.SyntaxTokenType=vt={})),function(V){function z(ne){switch(ne){case V.Other:return"other";case V.Comment:return"comment";case V.String:return"string";case V.RegEx:return"regex"}return"other"}V.toString=z}(vt||(e.SyntaxTokenType=vt={}));let Xt=class{constructor(z,ne){if(ne&&!y.URI.isUri(ne))throw(0,M.$7)("target");if(!ae.isRange(z)||z.isEmpty)throw(0,M.$7)("range");this.range=z,this.target=ne}};e.$7M=Xt,e.$7M=Xt=Xe([T],Xt);let zt=class{constructor(z,ne,Se,Je){this.red=z,this.green=ne,this.blue=Se,this.alpha=Je}};e.$8M=zt,e.$8M=zt=Xe([T],zt);let Vt=class{constructor(z,ne){if(ne&&!(ne instanceof zt))throw(0,M.$7)("color");if(!ae.isRange(z)||z.isEmpty)throw(0,M.$7)("range");this.range=z,this.color=ne}};e.$9M=Vt,e.$9M=Vt=Xe([T],Vt);let mt=class{constructor(z){if(!z||typeof z!="string")throw(0,M.$7)("label");this.label=z}};e.$0M=mt,e.$0M=mt=Xe([T],mt);var Rt;(function(V){V[V.RGB=0]="RGB",V[V.HEX=1]="HEX",V[V.HSL=2]="HSL"})(Rt||(e.ColorFormat=Rt={}));var ai;(function(V){V[V.Error=0]="Error",V[V.Warning=1]="Warning",V[V.Information=2]="Information"})(ai||(e.SourceControlInputBoxValidationType=ai={}));var ei;(function(V){V[V.Unknown=0]="Unknown",V[V.Shutdown=1]="Shutdown",V[V.Process=2]="Process",V[V.User=3]="User",V[V.Extension=4]="Extension"})(ei||(e.TerminalExitReason=ei={}));class Ge{constructor(z,ne,Se){if(this.startIndex=z,this.length=ne,this.tooltip=Se,typeof z!="number"||z<0)throw(0,M.$7)("startIndex");if(typeof ne!="number"||ne<1)throw(0,M.$7)("length");if(Se!==void 0&&typeof Se!="string")throw(0,M.$7)("tooltip")}}e.$$M=Ge;class Zt{constructor(z){this.uri=z}}e.$_M=Zt;class ti{constructor(z){this.terminalCommand=z}}e.$aN=ti;var ii;(function(V){V[V.Panel=1]="Panel",V[V.Editor=2]="Editor"})(ii||(e.TerminalLocation=ii={}));class bt{constructor(z){if(this.options=z,typeof z!="object")throw(0,M.$7)("options")}}e.$bN=bt;var jt;(function(V){V[V.Always=1]="Always",V[V.Silent=2]="Silent",V[V.Never=3]="Never"})(jt||(e.TaskRevealKind=jt={}));var Nt;(function(V){V[V.Shared=1]="Shared",V[V.Dedicated=2]="Dedicated",V[V.New=3]="New"})(Nt||(e.TaskPanelKind=Nt={}));let At=Q=class{static from(z){switch(z){case"clean":return Q.Clean;case"build":return Q.Build;case"rebuild":return Q.Rebuild;case"test":return Q.Test;default:return}}constructor(z,ne){if(this.label=ne,typeof z!="string"||typeof ne!="string")throw(0,M.$7)("name");this.c=z}get id(){return this.c}};e.$cN=At,At.Clean=new Q("clean","Clean"),At.Build=new Q("build","Build"),At.Rebuild=new Q("rebuild","Rebuild"),At.Test=new Q("test","Test"),e.$cN=At=Q=Xe([T],At);function ci(V){let z="";for(let ne=0;ne<V.length;ne++)z+=V[ne].replace(/,/g,",,")+",";return z}let Ut=class{constructor(z,ne,Se){if(typeof z!="string")throw(0,M.$7)("process");this.e=[],this.c=z,ne!==void 0&&(Array.isArray(ne)?(this.e=ne,this.f=Se):this.f=ne)}get process(){return this.c}set process(z){if(typeof z!="string")throw(0,M.$7)("process");this.c=z}get args(){return this.e}set args(z){Array.isArray(z)||(z=[]),this.e=z}get options(){return this.f}set options(z){this.f=z}computeId(){const z=[];if(z.push("process"),this.c!==void 0&&z.push(this.c),this.e&&this.e.length>0)for(const ne of this.e)z.push(ne);return ci(z)}};e.$dN=Ut,e.$dN=Ut=Xe([T],Ut);let qt=class{constructor(z,ne,Se){if(this.f=[],Array.isArray(ne)){if(!z)throw(0,M.$7)("command can't be undefined or null");if(typeof z!="string"&&typeof z.value!="string")throw(0,M.$7)("command");this.e=z,this.f=ne,this.g=Se}else{if(typeof z!="string")throw(0,M.$7)("commandLine");this.c=z,this.g=ne}}get commandLine(){return this.c}set commandLine(z){if(typeof z!="string")throw(0,M.$7)("commandLine");this.c=z}get command(){return this.e?this.e:""}set command(z){if(typeof z!="string"&&typeof z.value!="string")throw(0,M.$7)("command");this.e=z}get args(){return this.f}set args(z){this.f=z||[]}get options(){return this.g}set options(z){this.g=z}computeId(){const z=[];if(z.push("shell"),this.c!==void 0&&z.push(this.c),this.e!==void 0&&z.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ne of this.f)z.push(typeof ne=="string"?ne:ne.value);return ci(z)}};e.$eN=qt,e.$eN=qt=Xe([T],qt);var Ct;(function(V){V[V.Escape=1]="Escape",V[V.Strong=2]="Strong",V[V.Weak=3]="Weak"})(Ct||(e.ShellQuoting=Ct={}));var Lt;(function(V){V[V.Global=1]="Global",V[V.Workspace=2]="Workspace"})(Lt||(e.TaskScope=Lt={}));class ni{constructor(z){this.c=z}computeId(){return"customExecution"+(0,O.$Eg)()}set callback(z){this.c=z}get callback(){return this.c}}e.$fN=ni;let Pt=H=class{constructor(z,ne,Se,Je,tt,ht){this.k=!1,this.l=this.definition=z;let pt;typeof ne=="string"?(this.o=this.name=ne,this.w=this.source=Se,this.execution=Je,pt=tt,this.k=!0):ne===Lt.Global||ne===Lt.Workspace?(this.target=ne,this.o=this.name=Se,this.w=this.source=Je,this.execution=tt,pt=ht):(this.target=ne,this.o=this.name=Se,this.w=this.source=Je,this.execution=tt,pt=ht),typeof pt=="string"?(this.r=[pt],this.t=!0):Array.isArray(pt)?(this.r=pt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(z){this.j=z}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Ut?this.l={type:H.e,id:this.q.computeId()}:this.q instanceof qt?this.l={type:H.f,id:this.q.computeId()}:this.q instanceof ni?this.l={type:H.c,id:this.q.computeId()}:this.l={type:H.g,id:(0,O.$Eg)()}}get definition(){return this.l}set definition(z){if(z==null)throw(0,M.$7)("Kind can't be undefined or null");this.B(),this.l=z}get scope(){return this.m}set target(z){this.B(),this.m=z}get name(){return this.o}set name(z){if(typeof z!="string")throw(0,M.$7)("name");this.B(),this.o=z}get execution(){return this.q}set execution(z){z===null&&(z=void 0),this.B(),this.q=z;const ne=this.l.type;(H.g===ne||H.e===ne||H.f===ne||H.c===ne)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(z){if(Array.isArray(z))this.B(),this.r=z,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(z){z!==!0&&z!==!1&&(z=!1),this.B(),this.u=z}get source(){return this.w}set source(z){if(typeof z!="string"||z.length===0)throw(0,M.$7)("source must be a string of length > 0");this.B(),this.w=z}get group(){return this.x}set group(z){z===null&&(z=void 0),this.B(),this.x=z}get detail(){return this.A}set detail(z){z===null&&(z=void 0),this.A=z}get presentationOptions(){return this.y}set presentationOptions(z){z==null&&(z=Object.create(null)),this.B(),this.y=z}get runOptions(){return this.z}set runOptions(z){z==null&&(z=Object.create(null)),this.B(),this.z=z}};e.$gN=Pt,Pt.c="customExecution",Pt.e="process",Pt.f="shell",Pt.g="$empty",e.$gN=Pt=H=Xe([T],Pt);var kt;(function(V){V[V.SourceControl=1]="SourceControl",V[V.Window=10]="Window",V[V.Notification=15]="Notification"})(kt||(e.ProgressLocation=kt={}));var Tt;(function(V){function z(ne){const Se=ne;return(0,d.$Zf)(Se.value)?Se.tooltip&&!(0,d.$Vf)(Se.tooltip)?(console.log("INVALID view badge, invalid tooltip",Se.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Se.value),!1)}V.isViewBadge=z})(Tt||(e.ViewBadge=Tt={}));let di=L=class{static isTreeItem(z,ne){const Se=z;if(Se.checkboxState!==void 0){const Je=(0,d.$Zf)(Se.checkboxState)?Se.checkboxState:(0,d.$Xf)(Se.checkboxState)&&(0,d.$Zf)(Se.checkboxState.state)?Se.checkboxState.state:void 0,tt=!(0,d.$Zf)(Se.checkboxState)&&(0,d.$Xf)(Se.checkboxState)?Se.checkboxState.tooltip:void 0;if(Je===void 0||Je!==ui.Checked&&Je!==ui.Unchecked||tt!==void 0&&!(0,d.$Vf)(tt))return console.log("INVALID tree item, invalid checkboxState",Se.checkboxState),!1}if(z instanceof L)return!0;if(Se.label!==void 0&&!(0,d.$Vf)(Se.label)&&!Se.label?.label)return console.log("INVALID tree item, invalid label",Se.label),!1;if(Se.id!==void 0&&!(0,d.$Vf)(Se.id))return console.log("INVALID tree item, invalid id",Se.id),!1;if(Se.iconPath!==void 0&&!(0,d.$Vf)(Se.iconPath)&&!y.URI.isUri(Se.iconPath)&&(!Se.iconPath||!(0,d.$Vf)(Se.iconPath.id))){const Je=Se.iconPath;if(!Je||!(0,d.$Vf)(Je.light)&&!y.URI.isUri(Je.light)&&!(0,d.$Vf)(Je.dark)&&!y.URI.isUri(Je.dark))return console.log("INVALID tree item, invalid iconPath",Se.iconPath),!1}return Se.description!==void 0&&!(0,d.$Vf)(Se.description)&&typeof Se.description!="boolean"?(console.log("INVALID tree item, invalid description",Se.description),!1):Se.resourceUri!==void 0&&!y.URI.isUri(Se.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Se.resourceUri),!1):Se.tooltip!==void 0&&!(0,d.$Vf)(Se.tooltip)&&!(Se.tooltip instanceof ot)?(console.log("INVALID tree item, invalid tooltip",Se.tooltip),!1):Se.command!==void 0&&!Se.command.command?(console.log("INVALID tree item, invalid command",Se.command),!1):Se.collapsibleState!==void 0&&Se.collapsibleState<Et.None&&Se.collapsibleState>Et.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Se.collapsibleState),!1):Se.contextValue!==void 0&&!(0,d.$Vf)(Se.contextValue)?(console.log("INVALID tree item, invalid contextValue",Se.contextValue),!1):Se.accessibilityInformation!==void 0&&!Se.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Se.accessibilityInformation),!1):!0}constructor(z,ne=Et.None){this.collapsibleState=ne,y.URI.isUri(z)?this.resourceUri=z:this.label=z}};e.$hN=di,e.$hN=di=L=Xe([T],di);var Et;(function(V){V[V.None=0]="None",V[V.Collapsed=1]="Collapsed",V[V.Expanded=2]="Expanded"})(Et||(e.TreeItemCollapsibleState=Et={}));var ui;(function(V){V[V.Unchecked=0]="Unchecked",V[V.Checked=1]="Checked"})(ui||(e.TreeItemCheckboxState=ui={}));let Kt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(z){this.value=z}};e.$iN=Kt,e.$iN=Kt=Xe([T],Kt);class ki extends Kt{}e.$jN=ki;class vi extends ki{constructor(z){super(""),s.set(this,void 0),_e(this,s,z,"f")}asFile(){return Ve(this,s,"f")}}e.$kN=vi,s=new WeakMap;class Ee{constructor(z,ne,Se,Je){this.name=z,this.uri=ne,this._itemId=Se,this.c=Je}data(){return this.c()}}e.$lN=Ee;let Ce=class{constructor(z){r.add(this),i.set(this,new Map);for(const[ne,Se]of z??[]){const Je=Ve(this,i,"f").get(Ve(this,r,"m",c).call(this,ne));Je?Je.push(Se):Ve(this,i,"f").set(Ve(this,r,"m",c).call(this,ne),[Se])}}get(z){return Ve(this,i,"f").get(Ve(this,r,"m",c).call(this,z))?.[0]}set(z,ne){Ve(this,i,"f").set(Ve(this,r,"m",c).call(this,z),[ne])}forEach(z,ne){for(const[Se,Je]of Ve(this,i,"f"))for(const tt of Je)z.call(ne,tt,Se,this)}*[(i=new WeakMap,r=new WeakSet,Symbol.iterator)](){for(const[z,ne]of Ve(this,i,"f"))for(const Se of ne)yield[z,Se]}};e.$mN=Ce,c=function(z){return z.toLowerCase()},e.$mN=Ce=Xe([T],Ce);let he=class{constructor(z,ne,Se){this.insertText=z,this.title=ne,this.kind=Se}};e.$nN=he,e.$nN=he=Xe([T],he);var J;(function(V){V[V.Automatic=0]="Automatic",V[V.PasteAs=1]="PasteAs"})(J||(e.DocumentPasteTriggerKind=J={}));class ke{constructor(z){this.value=z}append(...z){return new ke((this.value?[this.value,...z]:z).join(ke.c))}intersects(z){return this.contains(z)||z.contains(this)}contains(z){return this.value===z.value||z.value.startsWith(this.value+ke.c)}}e.$oN=ke,ke.c=".",ke.Empty=new ke("");let We=class{constructor(z,ne,Se){this.title=ne,this.insertText=z,this.kind=Se}};e.$pN=We,e.$pN=We=Xe([T],We);let Ze=class{constructor(z,ne){this.id=z,this.color=ne}static isThemeIcon(z){return typeof z.id!="string"?(console.log("INVALID ThemeIcon, invalid id",z.id),!1):!0}};e.$qN=Ze,e.$qN=Ze=Xe([T],Ze),Ze.File=new Ze("file"),Ze.Folder=new Ze("folder");let Ke=class{constructor(z){this.id=z}};e.$rN=Ke,e.$rN=Ke=Xe([T],Ke);var lt;(function(V){V[V.Global=1]="Global",V[V.Workspace=2]="Workspace",V[V.WorkspaceFolder=3]="WorkspaceFolder"})(lt||(e.ConfigurationTarget=lt={}));let Dt=class{get base(){return this.c}set base(z){this.c=z,this.e=y.URI.file(z)}get baseUri(){return this.e}set baseUri(z){this.e=z,this.c=z.fsPath}constructor(z,ne){if(typeof z!="string"&&(!z||!y.URI.isUri(z)&&!y.URI.isUri(z.uri)))throw(0,M.$7)("base");if(typeof ne!="string")throw(0,M.$7)("pattern");typeof z=="string"?this.baseUri=y.URI.file(z):y.URI.isUri(z)?this.baseUri=z:this.baseUri=z.uri,this.pattern=ne}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$sN=Dt,e.$sN=Dt=Xe([T],Dt);const St=new WeakMap;function oi(V,z){St.set(V,z)}let Ot=class{constructor(z,ne,Se,Je,tt){this.enabled=typeof z=="boolean"?z:!0,typeof ne=="string"&&(this.condition=ne),typeof Se=="string"&&(this.hitCondition=Se),typeof Je=="string"&&(this.logMessage=Je),typeof tt=="string"&&(this.mode=tt)}get id(){return this.c||(this.c=St.get(this)??(0,O.$Eg)()),this.c}};e.$uN=Ot,e.$uN=Ot=Xe([T],Ot);let Wt=class extends Ot{constructor(z,ne,Se,Je,tt,ht){if(super(ne,Se,Je,tt,ht),z===null)throw(0,M.$7)("location");this.location=z}};e.$vN=Wt,e.$vN=Wt=Xe([T],Wt);let Ei=class extends Ot{constructor(z,ne,Se,Je,tt,ht){super(ne,Se,Je,tt,ht),this.functionName=z}};e.$wN=Ei,e.$wN=Ei=Xe([T],Ei);let gt=class extends Ot{constructor(z,ne,Se,Je,tt,ht,pt,Jt){if(super(Je,tt,ht,pt,Jt),!ne)throw(0,M.$7)("dataId");this.label=z,this.dataId=ne,this.canPersist=Se}};e.$xN=gt,e.$xN=gt=Xe([T],gt);let Ni=class{constructor(z,ne,Se){this.command=z,this.args=ne||[],this.options=Se}};e.$yN=Ni,e.$yN=Ni=Xe([T],Ni);let fi=class{constructor(z,ne){this.port=z,this.host=ne}};e.$zN=fi,e.$zN=fi=Xe([T],fi);let wi=class{constructor(z){this.path=z}};e.$AN=wi,e.$AN=wi=Xe([T],wi);let Mi=class{constructor(z){this.implementation=z}};e.$BN=Mi,e.$BN=Mi=Xe([T],Mi);class mn{constructor(z,ne,Se){this.session=z,this.threadId=ne,this.frameId=Se}}e.$CN=mn;class $n{constructor(z,ne){this.session=z,this.threadId=ne}}e.$DN=$n;let Li=class{constructor(z,ne){this.range=z,this.expression=ne}};e.$EN=Li,e.$EN=Li=Xe([T],Li);var zi;(function(V){V[V.Invoke=0]="Invoke",V[V.Automatic=1]="Automatic"})(zi||(e.InlineCompletionTriggerKind=zi={}));let ji=class{constructor(z,ne){this.range=z,this.text=ne}};e.$FN=ji,e.$FN=ji=Xe([T],ji);let Ri=class{constructor(z,ne,Se=!0){this.range=z,this.variableName=ne,this.caseSensitiveLookup=Se}};e.$GN=Ri,e.$GN=Ri=Xe([T],Ri);let Ui=class{constructor(z,ne){this.range=z,this.expression=ne}};e.$HN=Ui,e.$HN=Ui=Xe([T],Ui);let Di=class{constructor(z,ne){this.frameId=z,this.stoppedLocation=ne}};e.$IN=Di,e.$IN=Di=Xe([T],Di);var Ai;(function(V){V[V.AIGenerated=1]="AIGenerated"})(Ai||(e.NewSymbolNameTag=Ai={}));class pn{constructor(z,ne){this.newSymbolName=z,this.tags=ne}}e.$JN=pn;var Yi;(function(V){V[V.Changed=1]="Changed",V[V.Created=2]="Created",V[V.Deleted=3]="Deleted"})(Yi||(e.FileChangeType=Yi={}));let bi=R=class extends Error{static FileExists(z){return new R(z,l.FileSystemProviderErrorCode.FileExists,R.FileExists)}static FileNotFound(z){return new R(z,l.FileSystemProviderErrorCode.FileNotFound,R.FileNotFound)}static FileNotADirectory(z){return new R(z,l.FileSystemProviderErrorCode.FileNotADirectory,R.FileNotADirectory)}static FileIsADirectory(z){return new R(z,l.FileSystemProviderErrorCode.FileIsADirectory,R.FileIsADirectory)}static NoPermissions(z){return new R(z,l.FileSystemProviderErrorCode.NoPermissions,R.NoPermissions)}static Unavailable(z){return new R(z,l.FileSystemProviderErrorCode.Unavailable,R.Unavailable)}constructor(z,ne=l.FileSystemProviderErrorCode.Unknown,Se){super(y.URI.isUri(z)?z.toString(!0):z),this.code=Se?.name??"Unknown",(0,l.$4k)(this,ne),Object.setPrototypeOf(this,R.prototype),typeof Error.captureStackTrace=="function"&&typeof Se=="function"&&Error.captureStackTrace(this,Se)}};e.$KN=bi,e.$KN=bi=R=Xe([T],bi);let Bi=class{constructor(z,ne,Se){this.start=z,this.end=ne,this.kind=Se}};e.$LN=Bi,e.$LN=Bi=Xe([T],Bi);var xi;(function(V){V[V.Comment=1]="Comment",V[V.Imports=2]="Imports",V[V.Region=3]="Region"})(xi||(e.FoldingRangeKind=xi={}));var _i;(function(V){V[V.Collapsed=0]="Collapsed",V[V.Expanded=1]="Expanded"})(_i||(e.CommentThreadCollapsibleState=_i={}));var Vi;(function(V){V[V.Editing=0]="Editing",V[V.Preview=1]="Preview"})(Vi||(e.CommentMode=Vi={}));var en;(function(V){V[V.Published=0]="Published",V[V.Draft=1]="Draft"})(en||(e.CommentState=en={}));var Wi;(function(V){V[V.Unresolved=0]="Unresolved",V[V.Resolved=1]="Resolved"})(Wi||(e.CommentThreadState=Wi={}));var qi;(function(V){V[V.Current=0]="Current",V[V.Outdated=1]="Outdated"})(qi||(e.CommentThreadApplicability=qi={}));class vn{constructor(z,ne=[]){this.tokenTypes=z,this.tokenModifiers=ne}}e.$MN=vn;function tn(V){return typeof V>"u"||(0,d.$Wf)(V)}class Oi{constructor(z){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,z){this.m=!0;for(let ne=0,Se=z.tokenTypes.length;ne<Se;ne++)this.k.set(z.tokenTypes[ne],ne);for(let ne=0,Se=z.tokenModifiers.length;ne<Se;ne++)this.l.set(z.tokenModifiers[ne],ne)}}push(z,ne,Se,Je,tt){if(typeof z=="number"&&typeof ne=="number"&&typeof Se=="number"&&typeof Je=="number"&&(typeof tt=="number"||typeof tt>"u"))return typeof tt>"u"&&(tt=0),this.q(z,ne,Se,Je,tt);if(ae.isRange(z)&&typeof ne=="string"&&tn(Se))return this.o(z,ne,Se);throw(0,M.$7)()}o(z,ne,Se){if(!this.m)throw new Error("Legend must be provided in constructor");if(z.start.line!==z.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(ne))throw new Error("`tokenType` is not in the provided legend");const Je=z.start.line,tt=z.start.character,ht=z.end.character-z.start.character,pt=this.k.get(ne);let Jt=0;if(Se)for(const li of Se){if(!this.l.has(li))throw new Error("`tokenModifier` is not in the provided legend");const mi=this.l.get(li);Jt|=1<<mi>>>0}this.q(Je,tt,ht,pt,Jt)}q(z,ne,Se,Je,tt){if(this.f&&(z<this.c||z===this.c&&ne<this.e)){this.f=!1;const Jt=this.g.length/5|0;let li=0,mi=0;for(let pi=0;pi<Jt;pi++){let yi=this.g[5*pi],Xi=this.g[5*pi+1];yi===0?(yi=li,Xi+=mi):yi+=li,this.g[5*pi]=yi,this.g[5*pi+1]=Xi,li=yi,mi=Xi}}let ht=z,pt=ne;this.f&&this.j>0&&(ht-=this.c,ht===0&&(pt-=this.e)),this.g[this.j++]=ht,this.g[this.j++]=pt,this.g[this.j++]=Se,this.g[this.j++]=Je,this.g[this.j++]=tt,this.c=z,this.e=ne}static r(z){const ne=[],Se=z.length/5|0;for(let pt=0;pt<Se;pt++)ne[pt]=pt;ne.sort((pt,Jt)=>{const li=z[5*pt],mi=z[5*Jt];if(li===mi){const pi=z[5*pt+1],yi=z[5*Jt+1];return pi-yi}return li-mi});const Je=new Uint32Array(z.length);let tt=0,ht=0;for(let pt=0;pt<Se;pt++){const Jt=5*ne[pt],li=z[Jt+0],mi=z[Jt+1],pi=z[Jt+2],yi=z[Jt+3],Xi=z[Jt+4],Bn=li-tt,mr=Bn===0?mi-ht:mi,Zi=5*pt;Je[Zi+0]=Bn,Je[Zi+1]=mr,Je[Zi+2]=pi,Je[Zi+3]=yi,Je[Zi+4]=Xi,tt=li,ht=mi}return Je}build(z){return this.f?new Hi(new Uint32Array(this.g),z):new Hi(Oi.r(this.g),z)}}e.$NN=Oi;class Hi{constructor(z,ne){this.resultId=ne,this.data=z}}e.$ON=Hi;class wn{constructor(z,ne,Se){this.start=z,this.deleteCount=ne,this.data=Se}}e.$PN=wn;class bn{constructor(z,ne){this.resultId=ne,this.edits=z}}e.$QN=bn;var nn;(function(V){V[V.Separate=0]="Separate",V[V.MergeWithParent=1]="MergeWithParent"})(nn||(e.DebugConsoleMode=nn={}));class Gi{constructor(z){this.name=z}}e.$RN=Gi;let Si=class{constructor(){}};e.$SN=Si,Si.Back={iconPath:new Ze("arrow-left")},e.$SN=Si=Xe([T],Si);var ze;(function(V){V[V.Separator=-1]="Separator",V[V.Default=0]="Default"})(ze||(e.QuickPickItemKind=ze={}));var gi;(function(V){V[V.Info=1]="Info",V[V.Warning=2]="Warning",V[V.Error=3]="Error"})(gi||(e.InputBoxValidationSeverity=gi={}));var Ki;(function(V){V[V.UI=1]="UI",V[V.Workspace=2]="Workspace"})(Ki||(e.ExtensionKind=Ki={}));class nt{static validate(z){if(typeof z.badge=="string"){let ne=(0,m.$vf)(z.badge,0);if(ne<z.badge.length&&(ne+=(0,m.$vf)(z.badge,ne)),z.badge.length>ne)throw new Error("The 'badge'-property must be undefined or a short character")}else if(z.badge&&!Ze.isThemeIcon(z.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!z.color&&!z.badge&&!z.tooltip)throw new Error("The decoration is empty");return!0}constructor(z,ne,Se){this.badge=z,this.tooltip=ne,this.color=Se}}e.$TN=nt;let wt=class{constructor(z){this.kind=z}};e.$UN=wt,e.$UN=wt=Xe([T],wt);var rn;(function(V){V[V.Light=1]="Light",V[V.Dark=2]="Dark",V[V.HighContrast=3]="HighContrast",V[V.HighContrastLight=4]="HighContrastLight"})(rn||(e.ColorThemeKind=rn={}));class $i{static isNotebookRange(z){return z instanceof $i?!0:z?typeof z.start=="number"&&typeof z.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(z,ne){if(z<0)throw(0,M.$7)("start must be positive");if(ne<0)throw(0,M.$7)("end must be positive");z<=ne?(this.c=z,this.e=ne):(this.c=ne,this.e=z)}with(z){let ne=this.c,Se=this.e;return z.start!==void 0&&(ne=z.start),z.end!==void 0&&(Se=z.end),ne===this.c&&Se===this.e?this:new $i(ne,Se)}}e.$VN=$i;class Ii{static validate(z){if(typeof z.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof z.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof z.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(z){return Array.isArray(z)&&z.every(ne=>Ii.isNotebookCellData(ne))}static isNotebookCellData(z){return!0}constructor(z,ne,Se,Je,tt,ht,pt){this.kind=z,this.value=ne,this.languageId=Se,this.mime=Je,this.outputs=tt??[],this.metadata=ht,this.executionSummary=pt,Ii.validate(this)}}e.$WN=Ii;class yn{constructor(z){this.cells=z}}e.$XN=yn;class Ci{static isNotebookCellOutputItem(z){return z instanceof h?!0:z?typeof z.mime=="string"&&z.data instanceof Uint8Array:!1}static error(z){const ne={name:z.name,message:z.message,stack:z.stack};return h.json(ne,"application/vnd.code.notebook.error")}static stdout(z){return h.text(z,"application/vnd.code.notebook.stdout")}static stderr(z){return h.text(z,"application/vnd.code.notebook.stderr")}static bytes(z,ne="application/octet-stream"){return new h(z,ne)}static text(z,ne=A.$As.text){const Se=Ve(h,h,"f",t).encode(String(z));return new h(Se,ne)}static json(z,ne="text/x-json"){const Se=JSON.stringify(z,void 0,"	");return h.text(Se,ne)}constructor(z,ne){this.data=z,this.mime=ne;const Se=(0,A.$Es)(ne,!0);if(!Se)throw new Error(`INVALID mime type: ${ne}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Se}}e.$YN=Ci,h=Ci,t={value:new TextEncoder};class Ti{static isNotebookCellOutput(z){return z instanceof Ti?!0:!z||typeof z!="object"?!1:typeof z.id=="string"&&Array.isArray(z.items)}static ensureUniqueMimeTypes(z,ne=!1){const Se=new Set,Je=new Set;for(let tt=0;tt<z.length;tt++){const ht=z[tt],pt=(0,A.$Es)(ht.mime);if(!Se.has(pt)||(0,$.$pK)(pt)){Se.add(pt);continue}Je.add(tt),ne&&console.warn(`DUPLICATED mime type '${ht.mime}' will be dropped`)}return Je.size===0?z:z.filter((tt,ht)=>!Je.has(ht))}constructor(z,ne,Se){this.items=Ti.ensureUniqueMimeTypes(z,!0),typeof ne=="string"?(this.id=ne,this.metadata=Se):(this.id=(0,O.$Eg)(),this.metadata=ne??Se)}}e.$ZN=Ti;var sn;(function(V){V[V.Markup=1]="Markup",V[V.Code=2]="Code"})(sn||(e.NotebookCellKind=sn={}));var on;(function(V){V[V.Idle=1]="Idle",V[V.Pending=2]="Pending",V[V.Executing=3]="Executing"})(on||(e.NotebookCellExecutionState=on={}));var Ji;(function(V){V[V.Left=1]="Left",V[V.Right=2]="Right"})(Ji||(e.NotebookCellStatusBarAlignment=Ji={}));var an;(function(V){V[V.Default=0]="Default",V[V.InCenter=1]="InCenter",V[V.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",V[V.AtTop=3]="AtTop"})(an||(e.NotebookEditorRevealType=an={}));class kn{constructor(z,ne){this.text=z,this.alignment=ne}}e.$1N=kn;var cn;(function(V){V[V.Default=1]="Default",V[V.Preferred=2]="Preferred"})(cn||(e.NotebookControllerAffinity=cn={}));var un;(function(V){V[V.Default=1]="Default",V[V.Preferred=2]="Preferred",V[V.Hidden=-1]="Hidden"})(un||(e.NotebookControllerAffinity2=un={}));class En{constructor(z,ne=[]){this.uri=z,this.provides=(0,k.$3b)(ne)}}e.$2N=En;class Dn{constructor(z){this.label=z}}e.$3N=Dn;var ln;(function(V){V[V.Named=1]="Named",V[V.Indexed=2]="Indexed"})(ln||(e.NotebookVariablesRequestKind=ln={}));let Qi=class{constructor(z,ne){this.label=z,this.timestamp=ne}};e.$4N=Qi,e.$4N=Qi=Xe([T],Qi);var hn;(function(V){V[V.Production=1]="Production",V[V.Development=2]="Development",V[V.Test=3]="Test"})(hn||(e.ExtensionMode=hn={}));var dn;(function(V){V[V.Node=1]="Node",V[V.Webworker=2]="Webworker"})(dn||(e.ExtensionRuntime=dn={}));var fn;(function(V){V[V.Other=0]="Other",V[V.Comment=1]="Comment",V[V.String=2]="String",V[V.RegEx=3]="RegEx"})(fn||(e.StandardTokenType=fn={}));class te{constructor(z,ne){this.ranges=z,this.wordPattern=ne}}e.$5N=te;class ue{constructor(z){this.c=z}get autoForwardAction(){return this.c}}e.$6N=ue;var Le;(function(V){V[V.Queued=1]="Queued",V[V.Running=2]="Running",V[V.Passed=3]="Passed",V[V.Failed=4]="Failed",V[V.Skipped=5]="Skipped",V[V.Errored=6]="Errored"})(Le||(e.TestResultState=Le={}));var at;(function(V){V[V.Run=1]="Run",V[V.Debug=2]="Debug",V[V.Coverage=3]="Coverage"})(at||(e.TestRunProfileKind=at={}));let yt=class{constructor(z=void 0,ne=void 0,Se=void 0,Je=!1){this.include=z,this.exclude=ne,this.profile=Se,this.continuous=Je}};e.$7N=yt,e.$7N=yt=Xe([T],yt);let Ft=F=class{static diff(z,ne,Se){const Je=new F(z);return Je.expectedOutput=ne,Je.actualOutput=Se,Je}constructor(z){this.message=z}};e.$8N=Ft,e.$8N=Ft=F=Xe([T],Ft);let Pi=class{constructor(z){this.id=z}};e.$9N=Pi,e.$9N=Pi=Xe([T],Pi);class gn{constructor(z,ne){this.covered=z,this.total=ne,In(this)}}e.$0N=gn;function In(V){if(V){if(V.covered>V.total)throw new Error(`The total number of covered items (${V.covered}) cannot be greater than the total (${V.total})`);if(V.total<0)throw new Error(`The number of covered items (${V.total}) cannot be negative`)}}class Sn{static fromDetails(z,ne){const Se=new gn(0,0),Je=new gn(0,0),tt=new gn(0,0);for(const pt of ne)if("branches"in pt){Se.total+=1,Se.covered+=pt.executed?1:0;for(const Jt of pt.branches)Je.total+=1,Je.covered+=Jt.executed?1:0}else tt.total+=1,tt.covered+=pt.executed?1:0;const ht=new Sn(z,Se,Je.total>0?Je:void 0,tt.total>0?tt:void 0);return ht.detailedCoverage=ne,ht}constructor(z,ne,Se,Je){this.uri=z,this.statementCoverage=ne,this.branchCoverage=Se,this.declarationCoverage=Je}}e.$_N=Sn;class Vn{get executionCount(){return+this.executed}set executionCount(z){this.executed=z}constructor(z,ne,Se=[]){this.executed=z,this.location=ne,this.branches=Se}}e.$aO=Vn;class Wn{get executionCount(){return+this.executed}set executionCount(z){this.executed=z}constructor(z,ne,Se){this.executed=z,this.location=ne,this.label=Se}}e.$bO=Wn;class qn{get executionCount(){return+this.executed}set executionCount(z){this.executed=z}constructor(z,ne,Se){this.name=z,this.executed=ne,this.location=Se}}e.$cO=qn;var Cn;(function(V){V[V.None=0]="None",V[V.Option=1]="Option",V[V.Default=2]="Default",V[V.Preferred=3]="Preferred"})(Cn||(e.ExternalUriOpenerPriority=Cn={}));var Pn;(function(V){V[V.Untrusted=0]="Untrusted",V[V.Trusted=1]="Trusted",V[V.Unspecified=2]="Unspecified"})(Pn||(e.WorkspaceTrustState=Pn={}));var Mn;(function(V){V[V.Notify=1]="Notify",V[V.OpenBrowser=2]="OpenBrowser",V[V.OpenPreview=3]="OpenPreview",V[V.Silent=4]="Silent",V[V.Ignore=5]="Ignore",V[V.OpenBrowserOnce=6]="OpenBrowserOnce"})(Mn||(e.PortAutoForwardAction=Mn={}));class Hn{constructor(z,ne,Se,Je,tt,ht){this.kind=z,this.name=ne,this.detail=Se,this.uri=Je,this.range=tt,this.selectionRange=ht}}e.$dO=Hn;class Gn{constructor(z){this.uri=z}}e.$eO=Gn;class Kn{constructor(z,ne){this.original=z,this.modified=ne}}e.$fO=Kn;class Jn{constructor(z,ne,Se,Je){this.base=z,this.input1=ne,this.input2=Se,this.result=Je}}e.$gO=Jn;class Qn{constructor(z,ne){this.uri=z,this.viewType=ne}}e.$hO=Qn;class Xn{constructor(z){this.viewType=z}}e.$iO=Xn;class Zn{constructor(z,ne){this.uri=z,this.notebookType=ne}}e.$jO=Zn;class Yn{constructor(z,ne,Se){this.original=z,this.modified=ne,this.notebookType=Se}}e.$kO=Yn;class xn{constructor(){}}e.$lO=xn;class _n{constructor(z,ne){this.uri=z,this.inputBoxUri=ne}}e.$mO=_n;class er{constructor(z){this.providerId=z}}e.$nO=er;class tr{constructor(z){this.textDiffs=z}}e.$oO=tr;var Rn;(function(V){V[V.Down=0]="Down",V[V.Up=1]="Up"})(Rn||(e.InteractiveSessionVoteDirection=Rn={}));var An;(function(V){V[V.Action=1]="Action",V[V.Toolbar=2]="Toolbar"})(An||(e.ChatCopyKind=An={}));var On;(function(V){V[V.Short=1]="Short",V[V.Medium=2]="Medium",V[V.Full=3]="Full"})(On||(e.ChatVariableLevel=On={}));class ir{constructor(z,ne){this.label=z,this.values=ne}}e.$pO=ir;var Tn;(function(V){V[V.Unhelpful=0]="Unhelpful",V[V.Helpful=1]="Helpful",V[V.Undone=2]="Undone",V[V.Accepted=3]="Accepted",V[V.Bug=4]="Bug"})(Tn||(e.InteractiveEditorResponseFeedbackKind=Tn={}));var Fn;(function(V){V[V.Unhelpful=0]="Unhelpful",V[V.Helpful=1]="Helpful"})(Fn||(e.ChatResultFeedbackKind=Fn={}));class nr{constructor(z){this.value=typeof z=="string"?new ot(z):z}}e.$qO=nr;class rr{constructor(z,ne){this.value=z,this.baseUri=ne}}e.$rO=rr;class sr{constructor(z,ne){this.value=z,this.title=ne}}e.$sO=sr;class or{constructor(z){this.value=z}}e.$tO=or;class ar{constructor(z){this.value=z}}e.$uO=ar;class cr{constructor(z){this.value=z}}e.$vO=cr;class ur{constructor(z,ne,Se,Je){this.prompt=z,this.command=ne,this.variables=Se,this.participant=Je}}e.$wO=ur;class lr{constructor(z,ne,Se,Je){this.response=z,this.result=ne,this.participant=Se,this.command=Je}}e.$xO=lr;var Nn;(function(V){V[V.Panel=1]="Panel",V[V.Terminal=2]="Terminal",V[V.Notebook=3]="Notebook",V[V.Editor=4]="Editor"})(Nn||(e.ChatLocation=Nn={}));class hr{constructor(z){this.content=z}}e.$yO=hr;class dr{constructor(z,ne){this.content=z,this.name=ne}}e.$zO=dr;class fr{constructor(z,ne){this.content=z,this.name=ne}}e.$AO=fr;class Fi extends Error{static NotFound(z){return new Fi(z,Fi.NotFound.name)}static NoPermissions(z){return new Fi(z,Fi.NoPermissions.name)}constructor(z,ne,Se){super(z,{cause:Se}),this.name="LanguageModelError",this.code=ne??""}}e.$BO=Fi;var Ln;(function(V){V[V.SymbolInformation=1]="SymbolInformation",V[V.CommandInformation=2]="CommandInformation",V[V.SearchInformation=3]="SearchInformation",V[V.SettingInformation=4]="SettingInformation"})(Ln||(e.RelatedInformationType=Ln={}));var zn;(function(V){V[V.Started=1]="Started",V[V.Recognizing=2]="Recognizing",V[V.Recognized=3]="Recognized",V[V.Stopped=4]="Stopped"})(zn||(e.SpeechToTextStatus=zn={}));var jn;(function(V){V[V.Recognized=1]="Recognized",V[V.Stopped=2]="Stopped"})(jn||(e.KeywordRecognitionStatus=jn={}));class gr{constructor(z,ne){this.text=z,this.range=ne}}e.$CO=gr;var Un;(function(V){V[V.Invoke=0]="Invoke",V[V.Automatic=1]="Automatic"})(Un||(e.InlineEditTriggerKind=Un={}))}),define(Pe[246],Re([1,0,4,7]),function(ee,e,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yjc=void 0;class C{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(k.$sM.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(A,m,d){if(this.a.size===0)throw new Error("No related information providers registered");const y=this.a.get(A);if(!y)throw new Error("related information provider not found");return await y.provideRelatedInformation(m,d)??[]}getRelatedInformation(A,m,d){return this.c.$getAiRelatedInformation(m,d)}registerRelatedInformationProvider(A,m,d){const y=this.b;return this.b++,this.a.set(y,d),this.c.$registerAiRelatedInformationProvider(y,m),new M.$uM(()=>{this.c.$unregisterAiRelatedInformationProvider(y),this.a.delete(y)})}}e.$yjc=C}),define(Pe[84],Re([1,0,5,4,7,20,106,3,16]),function(ee,e,k,M,C,N,A,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kjc=e.$Jjc=void 0,e.$Jjc=(0,m.$ii)("IExtHostAuthentication");let y=class{constructor(l){this.b=new Map,this.c=new k.$7d,this.onDidChangeSessions=this.c.event,this.d=new O,this.f=new O,this.a=l.getProxy(M.$sM.MainThreadAuthentication)}async getSession(l,b,$,n={}){const o=N.$Em.toKey(l.identifier),s=[...$].sort().join(" ");return await this.d.getOrCreate(`${o} ${b} ${s}`,async()=>{await this.a.$ensureProvider(b);const r=l.displayName||l.name;return this.a.$getSession(b,$,o,r,n)})}async getSessions(l,b,$){const n=N.$Em.toKey(l.identifier),o=[...$].sort().join(" ");return await this.f.getOrCreate(`${n} ${o}`,async()=>{await this.a.$ensureProvider(b);const s=l.displayName||l.name;return this.a.$getSessions(b,$,n,s)})}async removeSession(l,b){const $=this.b.get(l);return $?$.provider.removeSession(b):this.a.$removeSession(l,b)}registerAuthenticationProvider(l,b,$,n){if(this.b.get(l))throw new Error(`An authentication provider with id '${l}' is already registered.`);this.b.set(l,{label:b,provider:$,options:n??{supportsMultipleAccounts:!1}});const o=$.onDidChangeSessions(s=>this.a.$sendDidChangeSessions(l,s));return this.a.$registerAuthenticationProvider(l,b,n?.supportsMultipleAccounts??!1),new C.$uM(()=>{o.dispose(),this.b.delete(l),this.a.$unregisterAuthenticationProvider(l)})}$createSession(l,b,$){const n=this.b.get(l);if(n)return Promise.resolve(n.provider.createSession(b,$));throw new Error(`Unable to find authentication provider with handle: ${l}`)}$removeSession(l,b){const $=this.b.get(l);if($)return Promise.resolve($.provider.removeSession(b));throw new Error(`Unable to find authentication provider with handle: ${l}`)}$getSessions(l,b){const $=this.b.get(l);if($)return Promise.resolve($.provider.getSessions(b));throw new Error(`Unable to find authentication provider with handle: ${l}`)}$onDidChangeAuthenticationSessions(l,b){return l.startsWith(A.$uL)||this.c.fire({provider:{id:l,label:b}}),Promise.resolve()}};e.$Kjc=y,e.$Kjc=y=Xe([qe(0,d.$OO)],y);class O{constructor(){this.a=new Map}getOrCreate(l,b){const $=this.a.get(l);if($)return $;const n=b().finally(()=>this.a.delete(l));return this.a.set(l,n),n}}}),define(Pe[110],Re([1,0,2,4,7,3,16,13,18,15,19,25]),function(ee,e,k,M,C,N,A,m,d,y,O,D){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$Lkc=e.$Kkc=void 0;let b=l=class{constructor(n,o){this.h=o,this.f=new Map,this.g=n.getProxy(M.$sM.MainThreadDecorations)}registerFileDecorationProvider(n,o){const s=l.c++;this.f.set(s,{provider:n,extensionDescription:o}),this.g.$registerDecorationProvider(s,o.identifier.value);const r=n.onDidChangeFileDecorations&&n.onDidChangeFileDecorations(i=>{if(!i){this.g.$onDidChange(s,null);return}const c=(0,d.$3b)(i);if(c.length<=l.d){this.g.$onDidChange(s,c);return}this.h.warn("[Decorations] CAPPING events from decorations provider",o.identifier.value,c.length);const h=c.map(a=>({uri:a,rank:(0,y.$1e)(a.path,"/")})),t=(0,d.$zb)(h,(a,g)=>a.rank-g.rank||(0,y.$ef)(a.uri.path,g.uri.path)),p=[];e:for(const a of t){let g;for(const v of a){const f=(0,O.$nc)(v.uri.path);if(g!==f&&(g=f,p.push(v.uri)>=l.d))break e}}this.g.$onDidChange(s,p)});return new C.$uM(()=>{r?.dispose(),this.g.$unregisterDecorationProvider(s),this.f.delete(s)})}async $provideDecorations(n,o,s){if(!this.f.has(n))return Object.create(null);const r=Object.create(null),{provider:i,extensionDescription:c}=this.f.get(n);return await Promise.all(o.map(async h=>{try{const{uri:t,id:p}=h,a=await Promise.resolve(i.provideFileDecoration(k.URI.revive(t),s));if(!a)return;try{C.$TN.validate(a),a.badge&&typeof a.badge!="string"&&(0,D.$dG)(c,"codiconDecoration"),r[p]=[a.propagate,a.tooltip,a.badge,a.color]}catch(g){this.h.warn(`INVALID decoration from extension '${c.identifier.value}': ${g}`)}}catch(t){this.h.error(t)}})),r}};e.$Kkc=b,b.c=0,b.d=250,e.$Kkc=b=l=Xe([qe(0,A.$OO),qe(1,m.$Oj)],b),e.$Lkc=(0,N.$ii)("IExtHostDecorations")}),define(Pe[247],Re([1,0,14,2,7,4,12,24,15]),function(ee,e,k,M,C,N,A,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nkc=void 0;class y{constructor(D,l,b){this.d=l,this.e=b,this.b=new Map,this.c=D.getProxy(N.$sM.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(D,l){if(Object.keys(A.Schemas).indexOf(D)>=0)throw new Error(`scheme '${D}' already registered`);const b=y.a++;this.b.set(b,l),this.c.$registerTextContentProvider(b,D);let $;if(typeof l.onDidChange=="function"){let n;$=l.onDidChange(async o=>{if(o.scheme!==D){this.e.warn(`Provider for scheme '${D}' is firing event for schema '${o.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(o))return;n&&await n;const s=this.$provideTextDocumentContent(b,o).then(async r=>{if(!r&&typeof r!="string")return;const i=this.d.getDocument(o);if(!i)return;const c=(0,d.$$e)(r);if(!i.equalLines(c))return this.c.$onVirtualDocumentChange(o,r)}).catch(k.$1).finally(()=>{n===s&&(n=void 0)});n=s})}return new C.$uM(()=>{this.b.delete(b)&&this.c.$unregisterTextContentProvider(b),$&&($.dispose(),$=void 0)})}$provideTextDocumentContent(D,l){const b=this.b.get(D);return b?Promise.resolve(b.provideTextDocumentContent(M.URI.revive(l),m.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${l.scheme}`))}}e.$Nkc=y,y.a=0}),define(Pe[111],Re([1,0,56,12,15,303,152,7,18]),function(ee,e,k,M,C,N,A,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SO=e.$RO=void 0,e.$QO=O;const y=new Map;function O($,n){n?y.set($,n):y.delete($)}function D($){return y.get($)}class l extends N.$Iv{constructor(n,o,s,r,i,c,h){super(o,s,r,i),this.c=n,this.m=c,this.q=h,this.b=!1}dispose(){(0,k.ok)(!this.b),this.b=!0,this.q=!1}equalLines(n){return(0,d.$ub)(this.f,n)}get document(){if(!this.a){const n=this;this.a={get uri(){return n.d},get fileName(){return n.d.fsPath},get isUntitled(){return n.d.scheme===M.Schemas.untitled},get languageId(){return n.m},get version(){return n.h},get isClosed(){return n.b},get isDirty(){return n.q},save(){return n.r()},getText(o){return o?n.s(o):n.getText()},get eol(){return n.g===`
`?m.EndOfLine.LF:m.EndOfLine.CRLF},get lineCount(){return n.f.length},lineAt(o){return n.t(o)},offsetAt(o){return n.u(o)},positionAt(o){return n.v(o)},validateRange(o){return n.w(o)},validatePosition(o){return n.x(o)},getWordRangeAtPosition(o,s){return n.y(o,s)}}}return Object.freeze(this.a)}_acceptLanguageId(n){(0,k.ok)(!this.b),this.m=n}_acceptIsDirty(n){(0,k.ok)(!this.b),this.q=n}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(n){const o=this.w(n);if(o.isEmpty)return"";if(o.isSingleLine)return this.f[o.start.line].substring(o.start.character,o.end.character);const s=this.g,r=o.start.line,i=o.end.line,c=[];c.push(this.f[r].substring(o.start.character));for(let h=r+1;h<i;h++)c.push(this.f[h]);return c.push(this.f[i].substring(0,o.end.character)),c.join(s)}t(n){let o;if(n instanceof m.$vM?o=n.line:typeof n=="number"&&(o=n),typeof o!="number"||o<0||o>=this.f.length||Math.floor(o)!==o)throw new Error("Illegal value for `line`");return new b(o,this.f[o],o===this.f.length-1)}u(n){return n=this.x(n),this.l(),this.j.getPrefixSum(n.line-1)+n.character}v(n){n=Math.floor(n),n=Math.max(0,n),this.l();const o=this.j.getIndexOf(n),s=this.f[o.index].length;return new m.$vM(o.index,Math.min(o.remainder,s))}w(n){if(!(n instanceof m.$wM))throw new Error("Invalid argument");const o=this.x(n.start),s=this.x(n.end);return o===n.start&&s===n.end?n:new m.$wM(o.line,o.character,s.line,s.character)}x(n){if(!(n instanceof m.$vM))throw new Error("Invalid argument");if(this.f.length===0)return n.with(0,0);let{line:o,character:s}=n,r=!1;if(o<0)o=0,s=0,r=!0;else if(o>=this.f.length)o=this.f.length-1,s=this.f[o].length,r=!0;else{const i=this.f[o].length;s<0?(s=0,r=!0):s>i&&(s=i,r=!0)}return r?new m.$vM(o,s):n}y(n,o){const s=this.x(n);if(!o)o=D(this.m);else if((0,C.$0e)(o))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${o.source}' because it matches the empty string.`);const r=(0,A.$Ss)(s.character+1,(0,A.$Qs)(o),this.f[s.line],0);if(r)return new m.$wM(s.line,r.startColumn-1,s.line,r.endColumn-1)}}e.$RO=l;class b{constructor(n,o,s){this.a=n,this.b=o,this.c=s}get lineNumber(){return this.a}get text(){return this.b}get range(){return new m.$wM(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new m.$wM(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$SO=b}),define(Pe[248],Re([1,0,4,7]),function(ee,e,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pkc=void 0;class C{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(k.$sM.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(A,m,d){if(this.a.size===0)throw new Error("No embedding vector providers registered");const y=this.a.get(A);if(!y)throw new Error("Embedding vector provider not found");const O=await y.provideEmbeddingVector(m,d);if(!O)throw new Error("Embedding vector provider returned undefined");return O}registerEmbeddingVectorProvider(A,m,d){const y=this.b;return this.b++,this.a.set(y,d),this.c.$registerAiEmbeddingVectorProvider(m,y),new M.$uM(()=>{this.c.$unregisterAiEmbeddingVectorProvider(y),this.a.delete(y)})}}e.$Pkc=C}),define(Pe[64],Re([1,0,4,43,7,22,3,16,44,6,11,23,12]),function(ee,e,k,M,C,N,A,m,d,y,O,D,l){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$4jc=e.$3jc=void 0;let $=b=class{constructor(o,s){this.b=new Map,this.c=new O.$rh,this.a=o.getProxy(k.$sM.MainThreadFileSystem);const r=this;this.value=Object.freeze({async stat(i){try{let c;const h=r.b.get(i.scheme);return h?(await r.a.$ensureActivation(i.scheme),c=await h.impl.stat(i)):c=await r.a.$stat(i),{type:c.type,ctime:c.ctime,mtime:c.mtime,size:c.size,permissions:c.permissions===M.FilePermission.Readonly?1:void 0}}catch(c){b.e(c)}},async readDirectory(i){try{const c=r.b.get(i.scheme);return c?(await r.a.$ensureActivation(i.scheme),(await c.impl.readDirectory(i)).slice()):await r.a.$readdir(i)}catch(c){return b.e(c)}},async createDirectory(i){try{const c=r.b.get(i.scheme);return c&&!c.isReadonly?(await r.a.$ensureActivation(i.scheme),await r.d(c.impl,c.extUri,i)):await r.a.$mkdir(i)}catch(c){return b.e(c)}},async readFile(i){try{const c=r.b.get(i.scheme);return c?(await r.a.$ensureActivation(i.scheme),(await c.impl.readFile(i)).slice()):(await r.a.$readFile(i)).buffer}catch(c){return b.e(c)}},async writeFile(i,c){try{const h=r.b.get(i.scheme);return h&&!h.isReadonly?(await r.a.$ensureActivation(i.scheme),await r.d(h.impl,h.extUri,h.extUri.dirname(i)),await r.c.queueFor(i,()=>Promise.resolve(h.impl.writeFile(i,c,{create:!0,overwrite:!0})))):await r.a.$writeFile(i,N.$ue.wrap(c))}catch(h){return b.e(h)}},async delete(i,c){try{const h=r.b.get(i.scheme);return h&&!h.isReadonly&&!c?.useTrash?(await r.a.$ensureActivation(i.scheme),await h.impl.delete(i,{recursive:!1,...c})):await r.a.$delete(i,{recursive:!1,useTrash:!1,atomic:!1,...c})}catch(h){return b.e(h)}},async rename(i,c,h){try{return await r.a.$rename(i,c,{overwrite:!1,...h})}catch(t){return b.e(t)}},async copy(i,c,h){try{return await r.a.$copy(i,c,{overwrite:!1,...h})}catch(t){return b.e(t)}},isWritableFileSystem(i){const c=s.getCapabilities(i);if(typeof c=="number")return!(c&2048)}})}async d(o,s,r){const i=[];for(;!s.isEqual(r,s.dirname(r));)try{if(!((await o.stat(r)).type&M.FileType.Directory))throw C.$KN.FileExists(`Unable to create folder '${r.scheme===l.Schemas.file?r.fsPath:r.toString(!0)}' that already exists but is not a directory`);break}catch(c){if(M.$5k(c)!==M.FileSystemProviderErrorCode.FileNotFound)throw c;i.push(s.basename(r)),r=s.dirname(r)}for(let c=i.length-1;c>=0;c--){r=s.joinPath(r,i[c]);try{await o.createDirectory(r)}catch(h){if(M.$5k(h)!==M.FileSystemProviderErrorCode.FileExists)throw h}}}static e(o){if(o instanceof C.$KN)throw o;if(o instanceof M.$1k)switch(o.code){case M.FileSystemProviderErrorCode.FileExists:throw C.$KN.FileExists(o.message);case M.FileSystemProviderErrorCode.FileNotFound:throw C.$KN.FileNotFound(o.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw C.$KN.FileNotADirectory(o.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw C.$KN.FileIsADirectory(o.message);case M.FileSystemProviderErrorCode.NoPermissions:throw C.$KN.NoPermissions(o.message);case M.FileSystemProviderErrorCode.Unavailable:throw C.$KN.Unavailable(o.message);default:throw new C.$KN(o.message,o.name)}if(!(o instanceof Error))throw new C.$KN(String(o));if(o.name==="ENOPRO"||o.message.includes("ENOPRO"))throw C.$KN.Unavailable(o.message);switch(o.name){case M.FileSystemProviderErrorCode.FileExists:throw C.$KN.FileExists(o.message);case M.FileSystemProviderErrorCode.FileNotFound:throw C.$KN.FileNotFound(o.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw C.$KN.FileNotADirectory(o.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw C.$KN.FileIsADirectory(o.message);case M.FileSystemProviderErrorCode.NoPermissions:throw C.$KN.NoPermissions(o.message);case M.FileSystemProviderErrorCode.Unavailable:throw C.$KN.Unavailable(o.message);default:throw new C.$KN(o.message,o.name)}}addFileSystemProvider(o,s,r){return this.b.set(o,{impl:s,extUri:r?.isCaseSensitive?D.$Lg:D.$Ng,isReadonly:!!r?.isReadonly}),(0,y.$Sc)(()=>this.b.delete(o))}getFileSystemProviderExtUri(o){return this.b.get(o)?.extUri??D.$Lg}};e.$3jc=$,e.$3jc=$=b=Xe([qe(0,m.$OO),qe(1,d.$Djc)],$),e.$4jc=(0,A.$ii)("IExtHostConsumerFileSystem")}),define(Pe[249],Re([1,0,4,7]),function(ee,e,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7kc=void 0;class C{constructor(A){this.a=new Map,this.b=new Map,this.c=A.getProxy(k.$sM.MainThreadIssueReporter)}async $getIssueReporterUri(A,m){if(this.a.size===0)throw new Error("No issue request handlers registered");const d=this.a.get(A);if(!d)throw new Error("Issue request handler not found");const y=await d.handleIssueUrlRequest();if(!y)throw new Error("Issue request handler returned no result");return y}async $getIssueReporterData(A,m){if(this.b.size===0)throw new Error("No issue request handlers registered");const d=this.b.get(A);if(!d)throw new Error("Issue data provider not found");const y=await d.provideIssueData(m);if(!y)throw new Error("Issue data provider returned no result");return y}async $getIssueReporterTemplate(A,m){if(this.b.size===0)throw new Error("No issue request handlers registered");const d=this.b.get(A);if(!d)throw new Error("Issue data provider not found");const y=await d.provideIssueTemplate(m);if(!y)throw new Error("Issue template provider returned no result");return y}registerIssueUriRequestHandler(A,m){const d=A.identifier.value;return this.a.set(d,m),this.c.$registerIssueUriRequestHandler(d),new M.$uM(()=>{this.c.$unregisterIssueUriRequestHandler(d),this.a.delete(d)})}registerIssueDataProvider(A,m){const d=A.identifier.value;return this.b.set(d,m),this.c.$registerIssueDataProvider(d),new M.$uM(()=>{this.c.$unregisterIssueDataProvider(d),this.b.delete(d)})}}e.$7kc=C}),define(Pe[85],Re([1,0,3,27,13,64,2]),function(ee,e,k,M,C,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6jc=e.$5jc=void 0,e.$5jc=(0,k.$ii)("IExtensionStoragePaths");let m=class{constructor(y,O,D){this.d=O,this.f=D,this.a=y.workspace??void 0,this.b=y.environment,this.whenReady=this.h().then(l=>this.c=l)}async g(y){return A.URI.joinPath(this.b.workspaceStorageHome,y)}async h(){if(!this.a)return Promise.resolve(void 0);const y=this.a.id,O=await this.g(y);try{return await this.f.value.stat(O),this.d.trace("[ExtHostStorage] storage dir already exists",O),O}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",O),await this.f.value.createDirectory(O),await this.f.value.writeFile(A.URI.joinPath(O,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:A.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),O}catch(D){this.d.error("[ExtHostStorage]",D);return}}workspaceValue(y){if(this.c)return A.URI.joinPath(this.c,y.identifier.value)}globalValue(y){return A.URI.joinPath(this.b.globalStorageHome,y.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$6jc=m,e.$6jc=m=Xe([qe(0,M.$5O),qe(1,C.$Oj),qe(2,N.$4jc)],m)}),define(Pe[250],Re([1,0,7,16,5]),function(ee,e,k,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xlc=void 0;let N=class{constructor(m){this.a=new k.$UN(k.ColorThemeKind.Dark),this.b=new C.$7d}get activeColorTheme(){return this.a}$onColorThemeChange(m){let d;switch(m){case"light":d=k.ColorThemeKind.Light;break;case"hcDark":d=k.ColorThemeKind.HighContrast;break;case"hcLight":d=k.ColorThemeKind.HighContrastLight;break;default:d=k.ColorThemeKind.Dark}this.a=new k.$UN(d),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$xlc=N,e.$xlc=N=Xe([qe(0,M.$OO)],N)}),define(Pe[86],Re([1,0,24,5,6,174,3,13,203,4,27,16,7]),function(ee,e,k,M,C,N,A,m,d,y,O,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lCb=e.$kCb=e.TunnelDtoConverter=void 0;class b extends d.$8v{}var $;(function(o){function s(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public,privacy:i.privacy??(i.public?d.TunnelPrivacyId.Public:d.TunnelPrivacyId.Private),protocol:i.protocol}}o.fromApiTunnel=s;function r(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.privacy!==d.TunnelPrivacyId.ConstantPrivate&&i.privacy!==d.TunnelPrivacyId.ConstantPrivate,privacy:i.privacy,protocol:i.protocol}}o.fromServiceTunnel=r})($||(e.TunnelDtoConverter=$={})),e.$kCb=(0,A.$ii)("IExtHostTunnelService");let n=class extends C.$Uc{constructor(s,r,i){super(),this.s=i,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new M.$7d,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=s.getProxy(y.$sM.MainThreadTunnelService)}async openTunnel(s,r){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${s.identifier.value} called openTunnel API for ${r.remoteAddress.host}:${r.remoteAddress.port}.`);const i=await this.a.$openTunnel(r,s.displayName);if(i){const c=new b(i.remoteAddress,i.localAddress,()=>this.a.$closeTunnel(i.remoteAddress));return this.B(c),c}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(s,r){s.portRange===void 0&&s.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const i=this.u();return this.r.set(i,{selector:s,provider:r}),this.a.$registerPortsAttributesProvider(s,i),new l.$uM(()=>{this.r.delete(i),this.a.$unregisterPortsAttributesProvider(i)})}async $providePortAttributes(s,r,i,c,h){const t=[];for(const a of s){const g=this.r.get(a);if(!g)return[];t.push(...await Promise.all(r.map(async v=>{let f;try{f=await g.provider.providePortAttributes({port:v,pid:i,commandLine:c},h)}catch{f=await g.provider.providePortAttributes(v,i,c,h)}return{providedAttributes:f,port:v}})))}const p=t.filter(a=>!!a.providedAttributes);return p.length>0?p.map(a=>({autoForwardAction:a.providedAttributes.autoForwardAction,port:a.port})):[]}async $registerCandidateFinder(s){}registerTunnelProvider(s,r){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(c,h)=>await s.provideTunnel(c,h,k.CancellationToken.None)??void 0;const i=r.tunnelFeatures?{elevation:!!r.tunnelFeatures?.elevation,privacyOptions:r.tunnelFeatures?.privacyOptions,protocol:r.tunnelFeatures.protocol===void 0?!0:r.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(i),Promise.resolve((0,C.$Sc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(s,r){if(s){s.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(s.candidatePortSource),s.showCandidatePort&&(this.f=s.showCandidatePort,this.a.$setCandidateFilter());const i=s.tunnelFactory??(r?this.w(r):void 0);if(i){this.b=i;let c=s.tunnelFeatures?.privacyOptions??[];s.tunnelFeatures?.public&&c.length===0&&(c=[{id:"private",label:N.localize(0,null),themeIcon:"lock"},{id:"public",label:N.localize(1,null),themeIcon:"eye"}]);const h=s.tunnelFeatures?{elevation:!!s.tunnelFeatures?.elevation,public:!!s.tunnelFeatures?.public,privacyOptions:c,protocol:!0}:void 0;this.a.$setTunnelProvider(h)}}else this.b=void 0;return(0,C.$Sc)(()=>{this.b=void 0})}w(s){}async $closeTunnel(s,r){if(this.g.has(s.host)){const i=this.g.get(s.host);i.has(s.port)&&(r&&i.get(s.port).disposeListener.dispose(),await i.get(s.port).tunnel.dispose(),i.delete(s.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(s,r){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const i=this.b(s,r);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),i!==void 0){const c=await i;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),c===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(s.remoteAddress.host)||this.g.set(s.remoteAddress.host,new Map);const h=this.B(c.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(c.remoteAddress))));return this.g.get(s.remoteAddress.host).set(s.remoteAddress.port,{tunnel:c,disposeListener:h}),$.fromApiTunnel(c)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(i){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),i instanceof Error)return i.message}}async $applyCandidateFilter(s){const r=await Promise.all(s.map(c=>this.f(c.host,c.port,c.detail??""))),i=s.filter((c,h)=>r[h]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${s.map(c=>c.port).join(", ")} to ${i.map(c=>c.port).join(", ")}`),i}};e.$lCb=n,e.$lCb=n=Xe([qe(0,D.$OO),qe(1,O.$5O),qe(2,m.$Oj)],n)}),define(Pe[8],Re([1,0,18,22,134,251,54,28,124,53,69,26,127,23,17,2,29,87,100,105,104,212,83,49,61,223,25,7]),function(ee,e,k,M,C,N,A,m,d,y,O,D,l,b,$,n,o,s,r,i,c,h,t,p,a,g,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentResolvedVariable=e.ChatLocation=e.ChatAgentRequest=e.ChatResponseProgress=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseCommandButtonPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseMarkdownPart=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.LanguageModelMessage=e.ChatInlineFollowup=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$LO=T,e.$MO=re,e.$NO=me;var u;(function(Ee){function Ce(J){const{selectionStartLineNumber:ke,selectionStartColumn:We,positionLineNumber:Ze,positionColumn:Ke}=J,lt=new f.$vM(ke-1,We-1),Dt=new f.$vM(Ze-1,Ke-1);return new f.$xM(lt,Dt)}Ee.to=Ce;function he(J){const{anchor:ke,active:We}=J;return{selectionStartLineNumber:ke.line+1,selectionStartColumn:ke.character+1,positionLineNumber:We.line+1,positionColumn:We.character+1}}Ee.from=he})(u||(e.Selection=u={}));var E;(function(Ee){function Ce(J){if(!J)return;const{start:ke,end:We}=J;return{startLineNumber:ke.line+1,startColumn:ke.character+1,endLineNumber:We.line+1,endColumn:We.character+1}}Ee.from=Ce;function he(J){if(!J)return;const{startLineNumber:ke,startColumn:We,endLineNumber:Ze,endColumn:Ke}=J;return new f.$wM(ke-1,We-1,Ze-1,Ke-1)}Ee.to=he})(E||(e.Range=E={}));var w;(function(Ee){function Ce(J){return{uri:J.uri,range:E.from(J.range)}}Ee.from=Ce;function he(J){return new f.$GM(n.URI.revive(J.uri),E.to(J.range))}Ee.to=he})(w||(e.Location=w={}));var I;(function(Ee){function Ce(he){switch(he){case 1:return f.StandardTokenType.Comment;case 0:return f.StandardTokenType.Other;case 3:return f.StandardTokenType.RegEx;case 2:return f.StandardTokenType.String}}Ee.to=Ce})(I||(e.TokenType=I={}));var S;(function(Ee){function Ce(J){return new f.$vM(J.lineNumber-1,J.column-1)}Ee.to=Ce;function he(J){return{lineNumber:J.line+1,column:J.character+1}}Ee.from=he})(S||(e.Position=S={}));var P;(function(Ee){function Ce(ke,We,Ze){return(0,k.$Hb)((0,k.$3b)(ke).map(Ke=>he(Ke,We,Ze)))}Ee.from=Ce;function he(ke,We,Ze){if(typeof ke=="string")return{$serialized:!0,language:ke,isBuiltin:Ze?.isBuiltin};if(ke)return{$serialized:!0,language:ke.language,scheme:J(ke.scheme,We),pattern:ye.from(ke.pattern)??void 0,exclusive:ke.exclusive,notebookType:ke.notebookType,isBuiltin:Ze?.isBuiltin}}function J(ke,We){return We&&typeof ke=="string"?We.transformOutgoingScheme(ke):ke}})(P||(e.DocumentSelector=P={}));var U;(function(Ee){function Ce(J){switch(J){case f.DiagnosticTag.Unnecessary:return 1;case f.DiagnosticTag.Deprecated:return 2}}Ee.from=Ce;function he(J){switch(J){case 1:return f.DiagnosticTag.Unnecessary;case 2:return f.DiagnosticTag.Deprecated;default:return}}Ee.to=he})(U||(e.DiagnosticTag=U={}));var Q;(function(Ee){function Ce(J){let ke;return J.code&&((0,$.$Vf)(J.code)||(0,$.$Zf)(J.code)?ke=String(J.code):ke={value:String(J.code.value),target:J.code.target}),{...E.from(J.range),message:J.message,source:J.source,code:ke,severity:L.from(J.severity),relatedInformation:J.relatedInformation&&J.relatedInformation.map(H.from),tags:Array.isArray(J.tags)?(0,k.$Hb)(J.tags.map(U.from)):void 0}}Ee.from=Ce;function he(J){const ke=new f.$IM(E.to(J),J.message,L.to(J.severity));return ke.source=J.source,ke.code=(0,$.$Vf)(J.code)?J.code:J.code?.value,ke.relatedInformation=J.relatedInformation&&J.relatedInformation.map(H.to),ke.tags=J.tags&&(0,k.$Hb)(J.tags.map(U.to)),ke}Ee.to=he})(Q||(e.Diagnostic=Q={}));var H;(function(Ee){function Ce(J){return{...E.from(J.location.range),message:J.message,resource:J.location.uri}}Ee.from=Ce;function he(J){return new f.$HM(new f.$GM(J.resource,E.to(J)),J.message)}Ee.to=he})(H||(e.DiagnosticRelatedInformation=H={}));var L;(function(Ee){function Ce(J){switch(J){case f.DiagnosticSeverity.Error:return r.MarkerSeverity.Error;case f.DiagnosticSeverity.Warning:return r.MarkerSeverity.Warning;case f.DiagnosticSeverity.Information:return r.MarkerSeverity.Info;case f.DiagnosticSeverity.Hint:return r.MarkerSeverity.Hint}return r.MarkerSeverity.Error}Ee.from=Ce;function he(J){switch(J){case r.MarkerSeverity.Info:return f.DiagnosticSeverity.Information;case r.MarkerSeverity.Warning:return f.DiagnosticSeverity.Warning;case r.MarkerSeverity.Error:return f.DiagnosticSeverity.Error;case r.MarkerSeverity.Hint:return f.DiagnosticSeverity.Hint;default:return f.DiagnosticSeverity.Error}}Ee.to=he})(L||(e.DiagnosticSeverity=L={}));var R;(function(Ee){function Ce(J){return typeof J=="number"&&J>=f.ViewColumn.One?J-1:J===f.ViewColumn.Beside?g.$HD:g.$GD}Ee.from=Ce;function he(J){if(typeof J=="number"&&J>=0)return J+1;throw new Error("invalid 'EditorGroupColumn'")}Ee.to=he})(R||(e.ViewColumn=R={}));function F(Ee){return typeof Ee.range<"u"}function T(Ee){return Ee.length===0?!0:!!F(Ee[0])}var X;(function(Ee){function Ce(Ke){return Ke.map(Ee.from)}Ee.fromMany=Ce;function he(Ke){return Ke&&typeof Ke=="object"&&typeof Ke.language=="string"&&typeof Ke.value=="string"}function J(Ke){let lt;if(he(Ke)){const{language:Ot,value:Wt}=Ke;lt={value:"```"+Ot+`
`+Wt+"\n```\n"}}else f.$VM.isMarkdownString(Ke)?lt={value:Ke.value,isTrusted:Ke.isTrusted,supportThemeIcons:Ke.supportThemeIcons,supportHtml:Ke.supportHtml,baseUri:Ke.baseUri}:typeof Ke=="string"?lt={value:Ke}:lt={value:""};const Dt=Object.create(null);lt.uris=Dt;const St=Ot=>{try{let Wt=n.URI.parse(Ot,!0);Wt=Wt.with({query:ke(Wt.query,Dt)}),Dt[Ot]=Wt}catch{}return""},oi=new d.marked.Renderer;return oi.link=St,oi.image=Ot=>typeof Ot=="string"?St(A.$Nk(Ot).href):"",(0,d.marked)(lt.value,{renderer:oi}),lt}Ee.from=J;function ke(Ke,lt){if(!Ke)return Ke;let Dt;try{Dt=(0,y.$Qh)(Ke)}catch{}if(!Dt)return Ke;let St=!1;return Dt=(0,D.$Rn)(Dt,oi=>{if(n.URI.isUri(oi)){const Ot=`__uri_${Math.random().toString(16).slice(2,8)}`;return lt[Ot]=oi,St=!0,Ot}else return}),St?JSON.stringify(Dt):Ke}function We(Ke){const lt=new f.$VM(Ke.value,Ke.supportThemeIcons);return lt.isTrusted=Ke.isTrusted,lt.supportHtml=Ke.supportHtml,lt.baseUri=Ke.baseUri?n.URI.from(Ke.baseUri):void 0,lt}Ee.to=We;function Ze(Ke){if(Ke)return typeof Ke=="string"?Ke:Ee.from(Ke)}Ee.fromStrict=Ze})(X||(e.MarkdownString=X={}));function re(Ee){return T(Ee)?Ee.map(Ce=>({range:E.from(Ce.range),hoverMessage:Array.isArray(Ce.hoverMessage)?X.fromMany(Ce.hoverMessage):Ce.hoverMessage?X.from(Ce.hoverMessage):void 0,renderOptions:Ce.renderOptions})):Ee.map(Ce=>({range:E.from(Ce)}))}function me(Ee){return typeof Ee>"u"?Ee:typeof Ee=="string"?n.URI.file(Ee):Ee}var pe;(function(Ee){function Ce(he){return typeof he>"u"?he:{contentText:he.contentText,contentIconPath:he.contentIconPath?me(he.contentIconPath):void 0,border:he.border,borderColor:he.borderColor,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,color:he.color,backgroundColor:he.backgroundColor,margin:he.margin,width:he.width,height:he.height}}Ee.from=Ce})(pe||(e.ThemableDecorationAttachmentRenderOptions=pe={}));var ae;(function(Ee){function Ce(he){return typeof he>"u"?he:{backgroundColor:he.backgroundColor,outline:he.outline,outlineColor:he.outlineColor,outlineStyle:he.outlineStyle,outlineWidth:he.outlineWidth,border:he.border,borderColor:he.borderColor,borderRadius:he.borderRadius,borderSpacing:he.borderSpacing,borderStyle:he.borderStyle,borderWidth:he.borderWidth,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,cursor:he.cursor,color:he.color,opacity:he.opacity,letterSpacing:he.letterSpacing,gutterIconPath:he.gutterIconPath?me(he.gutterIconPath):void 0,gutterIconSize:he.gutterIconSize,overviewRulerColor:he.overviewRulerColor,before:he.before?pe.from(he.before):void 0,after:he.after?pe.from(he.after):void 0}}Ee.from=Ce})(ae||(e.ThemableDecorationRenderOptions=ae={}));var be;(function(Ee){function Ce(he){if(typeof he>"u")return he;switch(he){case f.DecorationRangeBehavior.OpenOpen:return 0;case f.DecorationRangeBehavior.ClosedClosed:return 1;case f.DecorationRangeBehavior.OpenClosed:return 2;case f.DecorationRangeBehavior.ClosedOpen:return 3}}Ee.from=Ce})(be||(e.DecorationRangeBehavior=be={}));var se;(function(Ee){function Ce(he){return{isWholeLine:he.isWholeLine,rangeBehavior:he.rangeBehavior?be.from(he.rangeBehavior):void 0,overviewRulerLane:he.overviewRulerLane,light:he.light?ae.from(he.light):void 0,dark:he.dark?ae.from(he.dark):void 0,backgroundColor:he.backgroundColor,outline:he.outline,outlineColor:he.outlineColor,outlineStyle:he.outlineStyle,outlineWidth:he.outlineWidth,border:he.border,borderColor:he.borderColor,borderRadius:he.borderRadius,borderSpacing:he.borderSpacing,borderStyle:he.borderStyle,borderWidth:he.borderWidth,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,cursor:he.cursor,color:he.color,opacity:he.opacity,letterSpacing:he.letterSpacing,gutterIconPath:he.gutterIconPath?me(he.gutterIconPath):void 0,gutterIconSize:he.gutterIconSize,overviewRulerColor:he.overviewRulerColor,before:he.before?pe.from(he.before):void 0,after:he.after?pe.from(he.after):void 0}}Ee.from=Ce})(se||(e.DecorationRenderOptions=se={}));var De;(function(Ee){function Ce(J){return{text:J.newText,eol:J.newEol&&$t.from(J.newEol),range:E.from(J.range)}}Ee.from=Ce;function he(J){const ke=new f.$BM(E.to(J.range),J.text);return ke.newEol=typeof J.eol>"u"?void 0:$t.to(J.eol),ke}Ee.to=he})(De||(e.TextEdit=De={}));var Oe;(function(Ee){function Ce(J,ke){const We={edits:[]};if(J instanceof f.$EM){const Ze=new m.$Cc;for(const Ke of J._allEntries())Ke._type===1&&n.URI.isUri(Ke.to)&&Ke.from===void 0&&Ze.add(Ke.to);for(const Ke of J._allEntries())if(Ke._type===1){let lt;Ke.options?.contents&&(ArrayBuffer.isView(Ke.options.contents)?lt={type:"base64",value:(0,M.$Oe)(M.$ue.wrap(Ke.options.contents))}:lt={type:"dataTransferItem",id:Ke.options.contents._itemId}),We.edits.push({oldResource:Ke.from,newResource:Ke.to,options:{...Ke.options,contents:lt},metadata:Ke.metadata})}else Ke._type===2?We.edits.push({resource:Ke.uri,textEdit:De.from(Ke.edit),versionId:Ze.has(Ke.uri)?void 0:ke?.getTextDocumentVersion(Ke.uri),metadata:Ke.metadata}):Ke._type===6?We.edits.push({resource:Ke.uri,textEdit:{range:E.from(Ke.range),text:Ke.edit.value,insertAsSnippet:!0},versionId:Ze.has(Ke.uri)?void 0:ke?.getTextDocumentVersion(Ke.uri),metadata:Ke.metadata}):Ke._type===3?We.edits.push({metadata:Ke.metadata,resource:Ke.uri,cellEdit:Ke.edit,notebookMetadata:Ke.notebookMetadata,notebookVersionId:ke?.getNotebookDocumentVersion(Ke.uri)}):Ke._type===5&&We.edits.push({metadata:Ke.metadata,resource:Ke.uri,notebookVersionId:ke?.getNotebookDocumentVersion(Ke.uri),cellEdit:{editType:1,index:Ke.index,count:Ke.count,cells:Ke.cells.map(Yt.from)}})}return We}Ee.from=Ce;function he(J){const ke=new f.$EM,We=new m.$Bc;for(const Ze of J.edits)if(Ze.textEdit){const Ke=Ze,lt=n.URI.revive(Ke.resource),Dt=E.to(Ke.textEdit.range),St=Ke.textEdit.text,oi=Ke.textEdit.insertAsSnippet;let Ot;oi?Ot=f.$DM.replace(Dt,new f.$FM(St)):Ot=f.$BM.replace(Dt,St);const Wt=We.get(lt);Wt?Wt.push(Ot):We.set(lt,[Ot])}else ke.renameFile(n.URI.revive(Ze.oldResource),n.URI.revive(Ze.newResource),Ze.options);for(const[Ze,Ke]of We)ke.set(Ze,Ke);return ke}Ee.to=he})(Oe||(e.WorkspaceEdit=Oe={}));var ie;(function(Ee){const Ce=Object.create(null);Ce[f.SymbolKind.File]=0,Ce[f.SymbolKind.Module]=1,Ce[f.SymbolKind.Namespace]=2,Ce[f.SymbolKind.Package]=3,Ce[f.SymbolKind.Class]=4,Ce[f.SymbolKind.Method]=5,Ce[f.SymbolKind.Property]=6,Ce[f.SymbolKind.Field]=7,Ce[f.SymbolKind.Constructor]=8,Ce[f.SymbolKind.Enum]=9,Ce[f.SymbolKind.Interface]=10,Ce[f.SymbolKind.Function]=11,Ce[f.SymbolKind.Variable]=12,Ce[f.SymbolKind.Constant]=13,Ce[f.SymbolKind.String]=14,Ce[f.SymbolKind.Number]=15,Ce[f.SymbolKind.Boolean]=16,Ce[f.SymbolKind.Array]=17,Ce[f.SymbolKind.Object]=18,Ce[f.SymbolKind.Key]=19,Ce[f.SymbolKind.Null]=20,Ce[f.SymbolKind.EnumMember]=21,Ce[f.SymbolKind.Struct]=22,Ce[f.SymbolKind.Event]=23,Ce[f.SymbolKind.Operator]=24,Ce[f.SymbolKind.TypeParameter]=25;function he(ke){return typeof Ce[ke]=="number"?Ce[ke]:6}Ee.from=he;function J(ke){for(const We in Ce)if(Ce[We]===ke)return Number(We);return f.SymbolKind.Property}Ee.to=J})(ie||(e.SymbolKind=ie={}));var q;(function(Ee){function Ce(J){switch(J){case f.SymbolTag.Deprecated:return 1}}Ee.from=Ce;function he(J){switch(J){case 1:return f.SymbolTag.Deprecated}}Ee.to=he})(q||(e.SymbolTag=q={}));var de;(function(Ee){function Ce(J){return{name:J.name,kind:ie.from(J.kind),tags:J.tags&&J.tags.map(q.from),containerName:J.containerName,location:ce.from(J.location)}}Ee.from=Ce;function he(J){const ke=new f.$MM(J.name,ie.to(J.kind),J.containerName,ce.to(J.location));return ke.tags=J.tags&&J.tags.map(q.to),ke}Ee.to=he})(de||(e.WorkspaceSymbol=de={}));var Ne;(function(Ee){function Ce(J){const ke={name:J.name||"!!MISSING: name!!",detail:J.detail,range:E.from(J.range),selectionRange:E.from(J.selectionRange),kind:ie.from(J.kind),tags:J.tags?.map(q.from)??[]};return J.children&&(ke.children=J.children.map(Ce)),ke}Ee.from=Ce;function he(J){const ke=new f.$NM(J.name,J.detail,ie.to(J.kind),E.to(J.range),E.to(J.selectionRange));return(0,k.$Lb)(J.tags)&&(ke.tags=J.tags.map(q.to)),J.children&&(ke.children=J.children.map(he)),ke}Ee.to=he})(Ne||(e.DocumentSymbol=Ne={}));var $e;(function(Ee){function Ce(J){const ke=new f.$RM(ie.to(J.kind),J.name,J.detail||"",n.URI.revive(J.uri),E.to(J.range),E.to(J.selectionRange));return ke._sessionId=J._sessionId,ke._itemId=J._itemId,ke}Ee.to=Ce;function he(J,ke,We){if(ke=ke??J._sessionId,We=We??J._itemId,ke===void 0||We===void 0)throw new Error("invalid item");return{_sessionId:ke,_itemId:We,name:J.name,detail:J.detail,kind:ie.from(J.kind),uri:J.uri,range:E.from(J.range),selectionRange:E.from(J.selectionRange),tags:J.tags?.map(q.from)}}Ee.from=he})($e||(e.CallHierarchyItem=$e={}));var we;(function(Ee){function Ce(he){return new f.$SM($e.to(he.from),he.fromRanges.map(J=>E.to(J)))}Ee.to=Ce})(we||(e.CallHierarchyIncomingCall=we={}));var ge;(function(Ee){function Ce(he){return new f.$TM($e.to(he.to),he.fromRanges.map(J=>E.to(J)))}Ee.to=Ce})(ge||(e.CallHierarchyOutgoingCall=ge={}));var ce;(function(Ee){function Ce(J){return{range:J.range&&E.from(J.range),uri:J.uri}}Ee.from=Ce;function he(J){return new f.$GM(n.URI.revive(J.uri),E.to(J.range))}Ee.to=he})(ce||(e.location=ce={}));var K;(function(Ee){function Ce(J){const ke=J,We=J;return{originSelectionRange:ke.originSelectionRange?E.from(ke.originSelectionRange):void 0,uri:ke.targetUri?ke.targetUri:We.uri,range:E.from(ke.targetRange?ke.targetRange:We.range),targetSelectionRange:ke.targetSelectionRange?E.from(ke.targetSelectionRange):void 0}}Ee.from=Ce;function he(J){return{targetUri:n.URI.revive(J.uri),targetRange:E.to(J.range),targetSelectionRange:J.targetSelectionRange?E.to(J.targetSelectionRange):void 0,originSelectionRange:J.originSelectionRange?E.to(J.originSelectionRange):void 0}}Ee.to=he})(K||(e.DefinitionLink=K={}));var Z;(function(Ee){function Ce(J){return{range:E.from(J.range),contents:X.fromMany(J.contents)}}Ee.from=Ce;function he(J){return new f.$JM(J.contents.map(X.to),E.to(J.range))}Ee.to=he})(Z||(e.Hover=Z={}));var le;(function(Ee){function Ce(J){return{range:E.from(J.range),expression:J.expression}}Ee.from=Ce;function he(J){return new f.$EN(E.to(J.range),J.expression)}Ee.to=he})(le||(e.EvaluatableExpression=le={}));var fe;(function(Ee){function Ce(J){if(J instanceof f.$FN)return{type:"text",range:E.from(J.range),text:J.text};if(J instanceof f.$GN)return{type:"variable",range:E.from(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};if(J instanceof f.$HN)return{type:"expression",range:E.from(J.range),expression:J.expression};throw new Error("Unknown 'InlineValue' type")}Ee.from=Ce;function he(J){switch(J.type){case"text":return{range:E.to(J.range),text:J.text};case"variable":return{range:E.to(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};case"expression":return{range:E.to(J.range),expression:J.expression}}}Ee.to=he})(fe||(e.InlineValue=fe={}));var Te;(function(Ee){function Ce(J){return{frameId:J.frameId,stoppedLocation:E.from(J.stoppedLocation)}}Ee.from=Ce;function he(J){return new f.$IN(J.frameId,E.to(J.stoppedLocation))}Ee.to=he})(Te||(e.InlineValueContext=Te={}));var ve;(function(Ee){function Ce(J){return{range:E.from(J.range),kind:J.kind}}Ee.from=Ce;function he(J){return new f.$KM(E.to(J.range),J.kind)}Ee.to=he})(ve||(e.DocumentHighlight=ve={}));var Ie;(function(Ee){function Ce(J){return{uri:J.uri,highlights:J.highlights.map(ve.from)}}Ee.from=Ce;function he(J){return new f.$LM(n.URI.revive(J.uri),J.highlights.map(ve.to))}Ee.to=he})(Ie||(e.MultiDocumentHighlight=Ie={}));var Ae;(function(Ee){function Ce(he){switch(he){case 1:return f.CompletionTriggerKind.TriggerCharacter;case 2:return f.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return f.CompletionTriggerKind.Invoke}}Ee.to=Ce})(Ae||(e.CompletionTriggerKind=Ae={}));var je;(function(Ee){function Ce(he){return{triggerKind:Ae.to(he.triggerKind),triggerCharacter:he.triggerCharacter}}Ee.to=Ce})(je||(e.CompletionContext=je={}));var j;(function(Ee){function Ce(J){switch(J){case f.CompletionItemTag.Deprecated:return 1}}Ee.from=Ce;function he(J){switch(J){case 1:return f.CompletionItemTag.Deprecated}}Ee.to=he})(j||(e.CompletionItemTag=j={}));var B;(function(Ee){const Ce=new Map([[f.CompletionItemKind.Method,0],[f.CompletionItemKind.Function,1],[f.CompletionItemKind.Constructor,2],[f.CompletionItemKind.Field,3],[f.CompletionItemKind.Variable,4],[f.CompletionItemKind.Class,5],[f.CompletionItemKind.Interface,7],[f.CompletionItemKind.Struct,6],[f.CompletionItemKind.Module,8],[f.CompletionItemKind.Property,9],[f.CompletionItemKind.Unit,12],[f.CompletionItemKind.Value,13],[f.CompletionItemKind.Constant,14],[f.CompletionItemKind.Enum,15],[f.CompletionItemKind.EnumMember,16],[f.CompletionItemKind.Keyword,17],[f.CompletionItemKind.Snippet,27],[f.CompletionItemKind.Text,18],[f.CompletionItemKind.Color,19],[f.CompletionItemKind.File,20],[f.CompletionItemKind.Reference,21],[f.CompletionItemKind.Folder,23],[f.CompletionItemKind.Event,10],[f.CompletionItemKind.Operator,11],[f.CompletionItemKind.TypeParameter,24],[f.CompletionItemKind.Issue,26],[f.CompletionItemKind.User,25]]);function he(We){return Ce.get(We)??9}Ee.from=he;const J=new Map([[0,f.CompletionItemKind.Method],[1,f.CompletionItemKind.Function],[2,f.CompletionItemKind.Constructor],[3,f.CompletionItemKind.Field],[4,f.CompletionItemKind.Variable],[5,f.CompletionItemKind.Class],[7,f.CompletionItemKind.Interface],[6,f.CompletionItemKind.Struct],[8,f.CompletionItemKind.Module],[9,f.CompletionItemKind.Property],[12,f.CompletionItemKind.Unit],[13,f.CompletionItemKind.Value],[14,f.CompletionItemKind.Constant],[15,f.CompletionItemKind.Enum],[16,f.CompletionItemKind.EnumMember],[17,f.CompletionItemKind.Keyword],[27,f.CompletionItemKind.Snippet],[18,f.CompletionItemKind.Text],[19,f.CompletionItemKind.Color],[20,f.CompletionItemKind.File],[21,f.CompletionItemKind.Reference],[23,f.CompletionItemKind.Folder],[10,f.CompletionItemKind.Event],[11,f.CompletionItemKind.Operator],[24,f.CompletionItemKind.TypeParameter],[25,f.CompletionItemKind.User],[26,f.CompletionItemKind.Issue]]);function ke(We){return J.get(We)??f.CompletionItemKind.Property}Ee.to=ke})(B||(e.CompletionItemKind=B={}));var G;(function(Ee){function Ce(he,J){const ke=new f.$2M(he.label);return ke.insertText=he.insertText,ke.kind=B.to(he.kind),ke.tags=he.tags?.map(j.to),ke.detail=he.detail,ke.documentation=A.$Hk(he.documentation)?X.to(he.documentation):he.documentation,ke.sortText=he.sortText,ke.filterText=he.filterText,ke.preselect=he.preselect,ke.commitCharacters=he.commitCharacters,o.$dt.isIRange(he.range)?ke.range=E.to(he.range):typeof he.range=="object"&&(ke.range={inserting:E.to(he.range.insert),replacing:E.to(he.range.replace)}),ke.keepWhitespace=typeof he.insertTextRules>"u"?!1:!!(he.insertTextRules&1),typeof he.insertTextRules<"u"&&he.insertTextRules&4?ke.insertText=new f.$FM(he.insertText):(ke.insertText=he.insertText,ke.textEdit=ke.range instanceof f.$wM?new f.$BM(ke.range,ke.insertText):void 0),he.additionalTextEdits&&he.additionalTextEdits.length>0&&(ke.additionalTextEdits=he.additionalTextEdits.map(We=>De.to(We))),ke.command=J&&he.command?J.fromInternal(he.command):void 0,ke}Ee.to=Ce})(G||(e.CompletionItem=G={}));var W;(function(Ee){function Ce(J){if(typeof J.label!="string"&&!Array.isArray(J.label))throw new TypeError("Invalid label");return{label:J.label,documentation:X.fromStrict(J.documentation)}}Ee.from=Ce;function he(J){return{label:J.label,documentation:A.$Hk(J.documentation)?X.to(J.documentation):J.documentation}}Ee.to=he})(W||(e.ParameterInformation=W={}));var _;(function(Ee){function Ce(J){return{label:J.label,documentation:X.fromStrict(J.documentation),parameters:Array.isArray(J.parameters)?J.parameters.map(W.from):[],activeParameter:J.activeParameter}}Ee.from=Ce;function he(J){return{label:J.label,documentation:A.$Hk(J.documentation)?X.to(J.documentation):J.documentation,parameters:Array.isArray(J.parameters)?J.parameters.map(W.to):[],activeParameter:J.activeParameter}}Ee.to=he})(_||(e.SignatureInformation=_={}));var oe;(function(Ee){function Ce(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(_.from):[]}}Ee.from=Ce;function he(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(_.to):[]}}Ee.to=he})(oe||(e.SignatureHelp=oe={}));var Fe;(function(Ee){function Ce(he,J){const ke=new f.$1M(S.to(J.position),typeof J.label=="string"?J.label:J.label.map(Be.to.bind(void 0,he)),J.kind&&Qe.to(J.kind));return ke.textEdits=J.textEdits&&J.textEdits.map(De.to),ke.tooltip=A.$Hk(J.tooltip)?X.to(J.tooltip):J.tooltip,ke.paddingLeft=J.paddingLeft,ke.paddingRight=J.paddingRight,ke}Ee.to=Ce})(Fe||(e.InlayHint=Fe={}));var Be;(function(Ee){function Ce(he,J){const ke=new f.$ZM(J.label);return ke.tooltip=A.$Hk(J.tooltip)?X.to(J.tooltip):J.tooltip,s.Command.is(J.command)&&(ke.command=he.fromInternal(J.command)),J.location&&(ke.location=ce.to(J.location)),ke}Ee.to=Ce})(Be||(e.InlayHintLabelPart=Be={}));var Qe;(function(Ee){function Ce(J){return J}Ee.from=Ce;function he(J){return J}Ee.to=he})(Qe||(e.InlayHintKind=Qe={}));var et;(function(Ee){function Ce(J){return{range:E.from(J.range),url:J.target,tooltip:J.tooltip}}Ee.from=Ce;function he(J){let ke;if(J.url)try{ke=typeof J.url=="string"?n.URI.parse(J.url,!0):n.URI.revive(J.url)}catch{}return new f.$7M(E.to(J.range),ke)}Ee.to=he})(et||(e.DocumentLink=et={}));var it;(function(Ee){function Ce(J){const ke=new f.$0M(J.label);return J.textEdit&&(ke.textEdit=De.to(J.textEdit)),J.additionalTextEdits&&(ke.additionalTextEdits=J.additionalTextEdits.map(We=>De.to(We))),ke}Ee.to=Ce;function he(J){return{label:J.label,textEdit:J.textEdit?De.from(J.textEdit):void 0,additionalTextEdits:J.additionalTextEdits?J.additionalTextEdits.map(ke=>De.from(ke)):void 0}}Ee.from=he})(it||(e.ColorPresentation=it={}));var ut;(function(Ee){function Ce(J){return new f.$8M(J[0],J[1],J[2],J[3])}Ee.to=Ce;function he(J){return[J.red,J.green,J.blue,J.alpha]}Ee.from=he})(ut||(e.Color=ut={}));var st;(function(Ee){function Ce(J){return{range:E.from(J.range)}}Ee.from=Ce;function he(J){return new f.$QM(E.to(J.range))}Ee.to=he})(st||(e.SelectionRange=st={}));var rt;(function(Ee){function Ce(he){switch(he){case 2:return f.TextDocumentSaveReason.AfterDelay;case 1:return f.TextDocumentSaveReason.Manual;case 3:case 4:return f.TextDocumentSaveReason.FocusOut}}Ee.to=Ce})(rt||(e.TextDocumentSaveReason=rt={}));var ot;(function(Ee){function Ce(J){switch(J){case f.TextEditorLineNumbersStyle.Off:return 0;case f.TextEditorLineNumbersStyle.Relative:return 2;case f.TextEditorLineNumbersStyle.Interval:return 3;case f.TextEditorLineNumbersStyle.On:default:return 1}}Ee.from=Ce;function he(J){switch(J){case 0:return f.TextEditorLineNumbersStyle.Off;case 2:return f.TextEditorLineNumbersStyle.Relative;case 3:return f.TextEditorLineNumbersStyle.Interval;case 1:default:return f.TextEditorLineNumbersStyle.On}}Ee.to=he})(ot||(e.TextEditorLineNumbersStyle=ot={}));var $t;(function(Ee){function Ce(J){if(J===f.EndOfLine.CRLF)return 1;if(J===f.EndOfLine.LF)return 0}Ee.from=Ce;function he(J){if(J===1)return f.EndOfLine.CRLF;if(J===0)return f.EndOfLine.LF}Ee.to=he})($t||(e.EndOfLine=$t={}));var Ue;(function(Ee){function Ce(he){if(typeof he=="object")return he.viewId;switch(he){case f.ProgressLocation.SourceControl:return 3;case f.ProgressLocation.Window:return 10;case f.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ee.from=Ce})(Ue||(e.ProgressLocation=Ue={}));var ct;(function(Ee){function Ce(J){const ke={start:J.start+1,end:J.end+1};return J.kind&&(ke.kind=x.from(J.kind)),ke}Ee.from=Ce;function he(J){const ke={start:J.start-1,end:J.end-1};return J.kind&&(ke.kind=x.to(J.kind)),ke}Ee.to=he})(ct||(e.FoldingRange=ct={}));var x;(function(Ee){function Ce(J){if(J)switch(J){case f.FoldingRangeKind.Comment:return s.$8t.Comment;case f.FoldingRangeKind.Imports:return s.$8t.Imports;case f.FoldingRangeKind.Region:return s.$8t.Region}}Ee.from=Ce;function he(J){if(J)switch(J.value){case s.$8t.Comment.value:return f.FoldingRangeKind.Comment;case s.$8t.Imports.value:return f.FoldingRangeKind.Imports;case s.$8t.Region.value:return f.FoldingRangeKind.Region}}Ee.to=he})(x||(e.FoldingRangeKind=x={}));var Y;(function(Ee){function Ce(he){if(he)return{pinned:typeof he.preview=="boolean"?!he.preview:void 0,inactive:he.background,preserveFocus:he.preserveFocus,selection:typeof he.selection=="object"?E.from(he.selection):void 0,override:typeof he.override=="boolean"?c.$0E.id:void 0}}Ee.from=Ce})(Y||(e.TextEditorOpenOptions=Y={}));var ye;(function(Ee){function Ce(We){return We instanceof f.$sN?We.toJSON():typeof We=="string"?We:he(We)||J(We)?new f.$sN(We.baseUri??We.base,We.pattern).toJSON():We}Ee.from=Ce;function he(We){const Ze=We;return Ze?n.URI.isUri(Ze.baseUri)&&typeof Ze.pattern=="string":!1}function J(We){const Ze=We;return Ze?typeof Ze.base=="string"&&typeof Ze.pattern=="string":!1}function ke(We){return typeof We=="string"?We:new f.$sN(n.URI.revive(We.baseUri),We.pattern)}Ee.to=ke})(ye||(e.GlobPattern=ye={}));var He;(function(Ee){function Ce(he){if(he){if(Array.isArray(he))return he.map(Ce);if(typeof he=="string")return he;{const J=he;return{language:J.language,scheme:J.scheme,pattern:ye.from(J.pattern),exclusive:J.exclusive,notebookType:J.notebookType}}}else return}Ee.from=Ce})(He||(e.LanguageSelector=He={}));var Ye;(function(Ee){function Ce(J){return!!J&&typeof J=="object"&&"documents"in J&&Array.isArray(J.documents)&&J.documents.every(ke=>Array.isArray(ke)&&ke.every(We=>We&&typeof We=="object"&&"uri"in We&&n.URI.isUri(We.uri)&&"version"in We&&typeof We.version=="number"&&"ranges"in We&&Array.isArray(We.ranges)&&We.ranges.every(Ze=>Ze instanceof f.$wM)))}Ee.is=Ce;function he(J){return{documents:J.documents.map(ke=>ke.map(We=>({uri:n.URI.from(We.uri),version:We.version,ranges:We.ranges.map(Ze=>E.from(Ze))})))}}Ee.from=he})(Ye||(e.MappedEditsContext=Ye={}));var Me;(function(Ee){function Ce(J){return{start:J.start,end:J.end}}Ee.from=Ce;function he(J){return new f.$VN(J.start,J.end)}Ee.to=he})(Me||(e.NotebookRange=Me={}));var dt;(function(Ee){function Ce(J){return{timing:typeof J.runStartTime=="number"&&typeof J.runEndTime=="number"?{startTime:J.runStartTime,endTime:J.runEndTime}:void 0,executionOrder:J.executionOrder,success:J.lastRunSuccess}}Ee.to=Ce;function he(J){return{lastRunSuccess:J.success,runStartTime:J.timing?.startTime,runEndTime:J.timing?.endTime,executionOrder:J.executionOrder}}Ee.from=he})(dt||(e.NotebookCellExecutionSummary=dt={}));var Mt;(function(Ee){function Ce(he){if(he===t.NotebookCellExecutionState.Unconfirmed)return f.NotebookCellExecutionState.Pending;if(he===t.NotebookCellExecutionState.Pending)return;if(he===t.NotebookCellExecutionState.Executing)return f.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${he}`)}Ee.to=Ce})(Mt||(e.NotebookCellExecutionState=Mt={}));var Bt;(function(Ee){function Ce(J){switch(J){case f.NotebookCellKind.Markup:return t.CellKind.Markup;case f.NotebookCellKind.Code:default:return t.CellKind.Code}}Ee.from=Ce;function he(J){switch(J){case t.CellKind.Markup:return f.NotebookCellKind.Markup;case t.CellKind.Code:default:return f.NotebookCellKind.Code}}Ee.to=he})(Bt||(e.NotebookCellKind=Bt={}));var Qt;(function(Ee){function Ce(J){const ke={metadata:J.metadata??Object.create(null),cells:[]};for(const We of J.cells)f.$WN.validate(We),ke.cells.push(Yt.from(We));return ke}Ee.from=Ce;function he(J){const ke=new f.$XN(J.cells.map(Yt.to));return(0,$.$9f)(J.metadata)||(ke.metadata=J.metadata),ke}Ee.to=he})(Qt||(e.NotebookData=Qt={}));var Yt;(function(Ee){function Ce(J){return{cellKind:Bt.from(J.kind),language:J.languageId,mime:J.mime,source:J.value,metadata:J.metadata,internalMetadata:dt.from(J.executionSummary??{}),outputs:J.outputs?J.outputs.map(It.from):[]}}Ee.from=Ce;function he(J){return new f.$WN(Bt.to(J.cellKind),J.source,J.language,J.mime,J.outputs?J.outputs.map(It.to):void 0,J.metadata,J.internalMetadata?dt.to(J.internalMetadata):void 0)}Ee.to=he})(Yt||(e.NotebookCellData=Yt={}));var xt;(function(Ee){function Ce(J){return{mime:J.mime,valueBytes:M.$ue.wrap(J.data)}}Ee.from=Ce;function he(J){return new f.$YN(J.valueBytes.buffer,J.mime)}Ee.to=he})(xt||(e.NotebookCellOutputItem=xt={}));var It;(function(Ee){function Ce(J){return{outputId:J.id,items:J.items.map(xt.from),metadata:J.metadata}}Ee.from=Ce;function he(J){const ke=J.items.map(xt.to);return new f.$ZN(ke,J.outputId,J.metadata)}Ee.to=he})(It||(e.NotebookCellOutput=It={}));var ri;(function(Ee){function Ce(ke){return J(ke)?{include:ye.from(ke.include)??void 0,exclude:ye.from(ke.exclude)??void 0}:ye.from(ke)??void 0}Ee.from=Ce;function he(ke){return J(ke)?{include:ye.to(ke.include),exclude:ye.to(ke.exclude)}:ye.to(ke)}Ee.to=he;function J(ke){const We=ke;return We?!(0,$.$5f)(We.include)&&!(0,$.$5f)(We.exclude):!1}})(ri||(e.NotebookExclusiveDocumentPattern=ri={}));var _t;(function(Ee){function Ce(he,J,ke){const We=typeof he.command=="string"?{title:"",command:he.command}:he.command;return{alignment:he.alignment===f.NotebookCellStatusBarAlignment.Left?1:2,command:J.toInternal(We,ke),text:he.text,tooltip:he.tooltip,accessibilityInformation:he.accessibilityInformation,priority:he.priority}}Ee.from=Ce})(_t||(e.NotebookStatusBarItem=_t={}));var hi;(function(Ee){function Ce(he,J,ke){const We=typeof he.command=="string"?{title:"",command:he.command}:he.command;return{command:J.toInternal(We,ke),label:he.label,description:he.description,detail:he.detail,documentation:he.documentation}}Ee.from=Ce})(hi||(e.NotebookKernelSourceAction=hi={}));var xe;(function(Ee){function Ce(he){return{transientOutputs:he?.transientOutputs??!1,transientCellMetadata:he?.transientCellMetadata??{},transientDocumentMetadata:he?.transientDocumentMetadata??{},cellContentMetadata:he?.cellContentMetadata??{}}}Ee.from=Ce})(xe||(e.NotebookDocumentContentOptions=xe={}));var si;(function(Ee){function Ce(J){return{uri:J.uri,provides:J.provides}}Ee.from=Ce;function he(J){return new f.$2N(n.URI.revive(J.uri),J.provides)}Ee.to=he})(si||(e.NotebookRendererScript=si={}));var Ht;(function(Ee){function Ce(J){return{message:X.fromStrict(J.message)||"",type:0,expected:J.expectedOutput,actual:J.actualOutput,contextValue:J.contextValue,location:J.location&&{range:E.from(J.location.range),uri:J.location.uri}}}Ee.from=Ce;function he(J){const ke=new f.$8N(typeof J.message=="string"?J.message:X.to(J.message));return ke.actualOutput=J.actual,ke.expectedOutput=J.expected,ke.contextValue=J.contextValue,ke.location=J.location?ce.to(J.location):void 0,ke}Ee.to=he})(Ht||(e.TestMessage=Ht={}));var Gt;(function(Ee){Ee.namespace=a.$jL,Ee.denamespace=a.$kL})(Gt||(e.TestTag=Gt={}));var ft;(function(Ee){function Ce(J){const ke=(0,i.$KO)(J).controllerId;return{extId:p.$eL.fromExtHostTestItem(J,ke).toString(),label:J.label,uri:n.URI.revive(J.uri),busy:J.busy,tags:J.tags.map(We=>Gt.namespace(ke,We.id)),range:o.$dt.lift(E.from(J.range)),description:J.description||null,sortText:J.sortText||null,error:J.error&&X.fromStrict(J.error)||null}}Ee.from=Ce;function he(J){return{parent:void 0,error:void 0,id:p.$eL.fromString(J.extId).localId,label:J.label,uri:n.URI.revive(J.uri),tags:(J.tags||[]).map(ke=>{const{tagId:We}=Gt.denamespace(ke);return new f.$9N(We)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:E.to(J.range||void 0),canResolveChildren:!1,busy:J.busy,description:J.description||void 0,sortText:J.sortText||void 0}}Ee.toPlain=he})(ft||(e.TestItem=ft={})),function(Ee){function Ce(J){return{id:J.id}}Ee.from=Ce;function he(J){return new f.$9N(J.id)}Ee.to=he}(Gt||(e.TestTag=Gt={}));var vt;(function(Ee){const Ce=(J,ke)=>{const We=J.value;if(!We)return;const Ze={...ft.toPlain(We.item),parent:ke,taskStates:We.tasks.map(Ke=>({state:Ke.state,duration:Ke.duration,messages:Ke.messages.filter(lt=>lt.type===0).map(Ht.to)})),children:[]};if(J.children)for(const Ke of J.children.values()){const lt=Ce(Ke,Ze);lt&&Ze.children.push(lt)}return Ze};function he(J){const ke=new l.$DO;for(const Ke of J.items)ke.insert(p.$eL.fromString(Ke.item.extId).path,Ke);const We=[ke.nodes],Ze=[];for(;We.length;)for(const Ke of We.pop())Ke.value?Ze.push(Ke):Ke.children&&We.push(Ke.children.values());return{completedAt:J.completedAt,results:Ze.map(Ke=>Ce(Ke)).filter($.$4f)}}Ee.to=he})(vt||(e.TestResults=vt={}));var Xt;(function(Ee){function Ce(We){return{covered:We.covered,total:We.total}}function he(We){return"line"in We?S.from(We):E.from(We)}function J(We){if(typeof We.executed=="number"&&We.executed<0)throw new Error(`Invalid coverage count ${We.executed}`);return"branches"in We?{count:We.executed,location:he(We.location),type:1,branches:We.branches.length?We.branches.map(Ze=>({count:Ze.executed,location:Ze.location&&he(Ze.location),label:Ze.label})):void 0}:{type:0,name:We.name,count:We.executed,location:he(We.location)}}Ee.fromDetails=J;function ke(We,Ze){return f.$$N(Ze.statementCoverage),f.$$N(Ze.branchCoverage),f.$$N(Ze.declarationCoverage),{id:We,uri:Ze.uri,statement:Ce(Ze.statementCoverage),branch:Ze.branchCoverage&&Ce(Ze.branchCoverage),declaration:Ze.declarationCoverage&&Ce(Ze.declarationCoverage)}}Ee.fromFile=ke})(Xt||(e.TestCoverage=Xt={}));var zt;(function(Ee){function Ce(he){switch(he){case 1:return f.CodeActionTriggerKind.Invoke;case 2:return f.CodeActionTriggerKind.Automatic}}Ee.to=Ce})(zt||(e.CodeActionTriggerKind=zt={}));var Vt;(function(Ee){function Ce(J){const ke=new f.$dO(ie.to(J.kind),J.name,J.detail||"",n.URI.revive(J.uri),E.to(J.range),E.to(J.selectionRange));return ke._sessionId=J._sessionId,ke._itemId=J._itemId,ke}Ee.to=Ce;function he(J,ke,We){if(ke=ke??J._sessionId,We=We??J._itemId,ke===void 0||We===void 0)throw new Error("invalid item");return{_sessionId:ke,_itemId:We,kind:ie.from(J.kind),name:J.name,detail:J.detail??"",uri:J.uri,range:E.from(J.range),selectionRange:E.from(J.selectionRange),tags:J.tags?.map(q.from)}}Ee.from=he})(Vt||(e.TypeHierarchyItem=Vt={}));var mt;(function(Ee){function Ce(he){if(he)return{value:he.value,tooltip:he.tooltip}}Ee.from=Ce})(mt||(e.ViewBadge=mt={}));var Rt;(function(Ee){function Ce(We,Ze,Ke){const lt=Ze.fileData;return lt?new f.$kN(new f.$lN(lt.name,n.URI.revive(lt.uri),lt.id,(0,N.$db)(()=>Ke(lt.id)))):We===O.$As.uriList&&Ze.uriListData?new f.$jN(ke(Ze.uriListData)):new f.$jN(Ze.asString)}Ee.to=Ce;async function he(We,Ze){const Ke=await Ze.asString();if(We===O.$As.uriList)return{asString:Ke,fileData:void 0,uriListData:J(Ke)};const lt=Ze.asFile();return{asString:Ke,fileData:lt?{name:lt.name,uri:lt.uri,id:lt._itemId??lt.id}:void 0}}Ee.from=he;function J(We){return C.$Mt.split(We).map(Ze=>{if(Ze.startsWith("#"))return Ze;try{return n.URI.parse(Ze)}catch{}return Ze})}function ke(We){return C.$Mt.create(We.map(Ze=>typeof Ze=="string"?Ze:n.URI.revive(Ze)))}})(Rt||(e.DataTransferItem=Rt={}));var ai;(function(Ee){function Ce(J,ke){const We=J.items.map(([Ze,Ke])=>[Ze,Rt.to(Ze,Ke,ke)]);return new f.$mN(We)}Ee.toDataTransfer=Ce;async function he(J){const ke={items:[]},We=[];for(const[Ze,Ke]of J)We.push((async()=>{ke.items.push([Ze,await Rt.from(Ze,Ke)])})());return await Promise.all(We),ke}Ee.from=he})(ai||(e.DataTransfer=ai={}));var ei;(function(Ee){function Ce(J,ke){return{kind:"reply",agentId:J.participant??ke?.agentId??"",subCommand:J.command??ke?.command,message:J.prompt,title:J.label}}Ee.from=Ce;function he(J){return{prompt:J.message,label:J.title,participant:J.agentId,command:J.subCommand}}Ee.to=he})(ei||(e.ChatFollowup=ei={}));var Ge;(function(Ee){function Ce(he){return"commandId"in he?{kind:"command",title:he.title??"",commandId:he.commandId??"",when:he.when??"",args:he.args}:{kind:"reply",message:he.message,title:he.title,tooltip:he.tooltip}}Ee.from=Ce})(Ge||(e.ChatInlineFollowup=Ge={}));var Zt;(function(Ee){function Ce(J){switch(J.role){case 0:return new f.$yO(J.content);case 1:return new f.$zO(J.content);case 2:return new f.$AO(J.content)}}Ee.to=Ce;function he(J){if(J instanceof f.$yO)return{role:0,content:J.content};if(J instanceof f.$zO)return{role:1,content:J.content};if(J instanceof f.$AO)return{role:2,content:J.content};throw new Error("Invalid LanguageModelMessage")}Ee.from=he})(Zt||(e.LanguageModelMessage=Zt={}));var ti;(function(Ee){function Ce(ke){const We={};for(const Ze of Object.keys(ke))We[Ze]=ke[Ze].map(Ee.to);return We}Ee.objectTo=Ce;function he(ke){return{level:ii.to(ke.level),kind:ke.kind,value:(0,n.$wc)(ke.value)?n.URI.revive(ke.value):ke.value,description:ke.description}}Ee.to=he;function J(ke){return{level:ii.from(ke.level),kind:ke.kind,value:ke.value,description:ke.description}}Ee.from=J})(ti||(e.ChatVariable=ti={}));var ii;(function(Ee){function Ce(J){switch(J){case"short":return f.ChatVariableLevel.Short;case"medium":return f.ChatVariableLevel.Medium;case"full":default:return f.ChatVariableLevel.Full}}Ee.to=Ce;function he(J){switch(J){case f.ChatVariableLevel.Short:return"short";case f.ChatVariableLevel.Medium:return"medium";case f.ChatVariableLevel.Full:default:return"full"}}Ee.from=he})(ii||(e.ChatVariableLevel=ii={}));var bt;(function(Ee){function Ce(he){switch(he){case 1:return f.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return f.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return f.InteractiveEditorResponseFeedbackKind.Undone;case 3:return f.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return f.InteractiveEditorResponseFeedbackKind.Bug}}Ee.to=Ce})(bt||(e.InteractiveEditorResponseFeedbackKind=bt={}));var jt;(function(Ee){function Ce(J){return{kind:"markdownContent",content:X.from(J.value)}}Ee.to=Ce;function he(J){return new f.$qO(X.to(J.content))}Ee.from=he})(jt||(e.ChatResponseMarkdownPart=jt={}));var Nt;(function(Ee){function Ce(J){const{value:ke,baseUri:We}=J;function Ze(Ke,lt){return Ke.map(Dt=>{const St=n.URI.joinPath(lt,Dt.name);return{label:Dt.name,uri:St,children:Dt.children&&Ze(Dt.children,St)}})}return{kind:"treeData",treeData:{label:(0,b.$Sg)(We),uri:We,children:Ze(ke,We)}}}Ee.to=Ce;function he(J){const ke=(0,y.$Rh)(J.treeData);function We(lt){return lt.map(Dt=>({name:Dt.label,children:Dt.children&&We(Dt.children)}))}const Ze=ke.uri,Ke=ke.children?We(ke.children):[];return new f.$rO(Ke,Ze)}Ee.from=he})(Nt||(e.ChatResponseFilesPart=Nt={}));var At;(function(Ee){function Ce(J){return{kind:"inlineReference",name:J.title,inlineReference:n.URI.isUri(J.value)?J.value:w.from(J.value)}}Ee.to=Ce;function he(J){const ke=(0,y.$Rh)(J);return new f.$sO(n.URI.isUri(ke.inlineReference)?ke.inlineReference:w.to(ke.inlineReference),J.name)}Ee.from=he})(At||(e.ChatResponseAnchorPart=At={}));var ci;(function(Ee){function Ce(J){return{kind:"progressMessage",content:X.from(J.value)}}Ee.to=Ce;function he(J){return new f.$tO(J.content.value)}Ee.from=he})(ci||(e.ChatResponseProgressPart=ci={}));var Ut;(function(Ee){function Ce(J,ke,We){return{kind:"command",command:ke.toInternal(J.value,We)??{command:J.value.command,title:J.value.title}}}Ee.to=Ce;function he(J,ke){return new f.$uO(ke.fromInternal(J.command)??{command:J.command.id,title:J.command.title})}Ee.from=he})(Ut||(e.ChatResponseCommandButtonPart=Ut={}));var qt;(function(Ee){function Ce(J){return"variableName"in J.value?{kind:"reference",reference:{variableName:J.value.variableName,value:n.URI.isUri(J.value.value)||!J.value.value?J.value.value:w.from(J.value.value)}}:{kind:"reference",reference:n.URI.isUri(J.value)?J.value:w.from(J.value)}}Ee.to=Ce;function he(J){const ke=(0,y.$Rh)(J),We=Ze=>n.URI.isUri(Ze)?Ze:w.to(Ze);return new f.$vO("variableName"in ke.reference?{variableName:ke.reference.variableName,value:ke.reference.value&&We(ke.reference.value)}:We(ke.reference))}Ee.from=he})(qt||(e.ChatResponseReferencePart=qt={}));var Ct;(function(Ee){function Ce(ke,We,Ze){return ke instanceof f.$qO?jt.to(ke):ke instanceof f.$sO?At.to(ke):ke instanceof f.$vO?qt.to(ke):ke instanceof f.$tO?ci.to(ke):ke instanceof f.$rO?Nt.to(ke):ke instanceof f.$uO?Ut.to(ke,We,Ze):{kind:"content",content:""}}Ee.to=Ce;function he(ke,We){switch(ke.kind){case"reference":return qt.from(ke);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return J(ke,We)}}Ee.from=he;function J(ke,We){switch(ke.kind){case"markdownContent":return jt.from(ke);case"inlineReference":return At.from(ke);case"progressMessage":return;case"treeData":return Nt.from(ke);case"command":return Ut.from(ke,We)}}Ee.fromContent=J})(Ct||(e.ChatResponsePart=Ct={}));var Lt;(function(Ee){function Ce(J,ke){return"markdownContent"in ke?((0,v.$dG)(J,"chatParticipantAdditions"),{content:X.from(ke.markdownContent),kind:"markdownContent"}):"content"in ke?"vulnerabilities"in ke&&ke.vulnerabilities?((0,v.$dG)(J,"chatParticipantAdditions"),{content:ke.content,vulnerabilities:ke.vulnerabilities,kind:"vulnerability"}):typeof ke.content=="string"?{content:ke.content,kind:"content"}:((0,v.$dG)(J,"chatParticipantAdditions"),{content:X.from(ke.content),kind:"markdownContent"}):"documents"in ke?{documents:ke.documents.map(We=>({uri:We.uri,version:We.version,ranges:We.ranges.map(Ze=>E.from(Ze))})),kind:"usedContext"}:"reference"in ke?{reference:"uri"in ke.reference?{uri:ke.reference.uri,range:E.from(ke.reference.range)}:ke.reference,kind:"reference"}:"inlineReference"in ke?{inlineReference:"uri"in ke.inlineReference?{uri:ke.inlineReference.uri,range:E.from(ke.inlineReference.range)}:ke.inlineReference,name:ke.title,kind:"inlineReference"}:"participant"in ke?((0,v.$dG)(J,"chatParticipantAdditions"),{agentId:ke.participant,command:ke.command,kind:"agentDetection"}):"message"in ke?{content:X.from(ke.message),kind:"progressMessage"}:void 0}Ee.from=Ce;function he(J,ke){switch(J.kind){case"markdownContent":return{content:J.content.value};case"inlineReference":return{inlineReference:(0,n.$wc)(J.inlineReference)?n.URI.revive(J.inlineReference):w.to(J.inlineReference),title:J.name};case"command":return{command:ke.fromInternal(J.command)??{command:J.command.id,title:J.command.title}};default:return}}Ee.toProgressContent=he})(Lt||(e.ChatResponseProgress=Lt={}));var ni;(function(Ee){function Ce(he){return{prompt:he.message,command:he.command,variables:he.variables.variables.map(kt.to),location:Pt.to(he.location)}}Ee.to=Ce})(ni||(e.ChatAgentRequest=ni={}));var Pt;(function(Ee){function Ce(he){switch(he){case h.ChatAgentLocation.Notebook:return f.ChatLocation.Notebook;case h.ChatAgentLocation.Terminal:return f.ChatLocation.Terminal;case h.ChatAgentLocation.Panel:return f.ChatLocation.Panel;case h.ChatAgentLocation.Editor:return f.ChatLocation.Editor}}Ee.to=Ce})(Pt||(e.ChatLocation=Pt={}));var kt;(function(Ee){function Ce(he){return{name:he.name,range:he.range&&[he.range.start,he.range.endExclusive],values:he.values.map(ti.to)}}Ee.to=Ce})(kt||(e.ChatAgentResolvedVariable=kt={}));var Tt;(function(Ee){function Ce(he){return{label:he.label,values:he.values.map(ti.from),insertText:he.insertText,detail:he.detail,documentation:he.documentation}}Ee.from=Ce})(Tt||(e.ChatAgentCompletionItem=Tt={}));var di;(function(Ee){function Ce(he){return{errorDetails:he.errorDetails,metadata:he.metadata}}Ee.to=Ce})(di||(e.ChatAgentResult=di={}));var Et;(function(Ee){function Ce(he,J,ke){if(J.action.kind==="vote")return;const We=di.to(he);return J.action.kind==="command"?{action:{kind:"command",commandButton:Lt.toProgressContent(J.action.commandButton,ke)},result:We}:J.action.kind==="followUp"?{action:{kind:"followUp",followup:ei.to(J.action.followup)},result:We}:{action:J.action,result:We}}Ee.to=Ce})(Et||(e.ChatAgentUserActionEvent=Et={}));var ui;(function(Ee){function Ce(he,J,ke){return"terminalCommand"in he?{terminalCommand:he.terminalCommand,shouldExecute:he.shouldExecute}:"uri"in he?{uri:he.uri}:J.toInternal(he,ke)}Ee.from=Ce})(ui||(e.TerminalQuickFix=ui={}));var Kt;(function(Ee){function Ce(he){return{kind:ki.to(he.kind)}}Ee.to=Ce})(Kt||(e.PartialAcceptInfo=Kt={}));var ki;(function(Ee){function Ce(he){switch(he){case 0:return f.PartialAcceptTriggerKind.Word;case 1:return f.PartialAcceptTriggerKind.Line;case 2:return f.PartialAcceptTriggerKind.Suggest;default:return f.PartialAcceptTriggerKind.Unknown}}Ee.to=Ce})(ki||(e.PartialAcceptTriggerKind=ki={}));var vi;(function(Ee){function Ce(he,J){return{id:J,label:he.label,description:he.description,canEdit:he.canEdit,collapsibleState:he.collapsibleState||0,contextValue:he.contextValue}}Ee.from=Ce})(vi||(e.DebugTreeItem=vi={}))}),define(Pe[252],Re([1,0,4,16,8]),function(ee,e,k,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ljc=void 0;let N=class{constructor(m,d){this.a=m.getProxy(k.$sM.MainThreadBulkEdits),this.b={getTextDocumentVersion:y=>d.getDocument(y)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(m,d,y){const O=C.WorkspaceEdit.from(m,this.b);return this.a.$tryApplyWorkspaceEdit(O,void 0,y?.isRefactoring??!1)}};e.$Ljc=N,e.$Ljc=N=Xe([qe(0,M.$OO)],N)}),define(Pe[253],Re([1,0,18,11,42,5,39,6,65,17,2,163,20,4,8,7,213,25]),function(ee,e,k,M,C,N,A,m,d,y,O,D,l,b,$,n,o,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Njc=void 0;class r{constructor(t,p,a,g,v,f){this.i=t,this.j=p,this.k=a,this.l=g,this.m=v,this.n=f,this.b=d.$3d.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let p=function(g){if(t.c){const v=new Error("Response stream has been closed");throw Error.captureStackTrace(v,g),v}};const t=this;this.b.reset();const a=g=>{typeof this.d>"u"&&"content"in g&&(this.d=this.b.elapsed()),this.k.$handleProgressChunk(this.j.requestId,g)};this.g={markdown(g){p(this.markdown);const v=new n.$qO(g),f=$.ChatResponseMarkdownPart.to(v);return a(f),this},filetree(g,v){p(this.filetree);const f=new n.$rO(g,v),u=$.ChatResponseFilesPart.to(f);return a(u),this},anchor(g,v){p(this.anchor);const f=new n.$sO(g,v),u=$.ChatResponseAnchorPart.to(f);return a(u),this},button(g){p(this.anchor);const v=new n.$uO(g),f=$.ChatResponseCommandButtonPart.to(v,t.m,t.n);return a(f),this},progress(g){p(this.progress);const v=new n.$tO(g),f=$.ChatResponseProgressPart.to(v);return a(f),this},reference(g){if(p(this.reference),"variableName"in g&&!g.value){const v=t.j.variables.variables.find(f=>f.name===g.variableName);if(v){let f;if(v.references?.length)f=v.references.map(u=>({kind:"reference",reference:{variableName:g.variableName,value:u.reference}}));else{const u=new n.$vO(g);f=[$.ChatResponseReferencePart.to(u)]}return f.forEach(u=>a(u)),this}}else{const v=new n.$vO(g),f=$.ChatResponseReferencePart.to(v);a(f)}return this},push(g){if(p(this.push),g instanceof n.$vO)this.reference(g.value);else{const v=$.ChatResponsePart.to(g,t.m,t.n);a(v)}return this},report(g){if(p(this.report),"placeholder"in g&&"resolvedContent"in g)return;const v=$.ChatResponseProgress.from(t.i,g);if(!v){t.l.error("Unknown progress type: "+JSON.stringify(g));return}return a(v),this}}}return this.g}}class i{constructor(t,p,a){this.i=p,this.j=a,this.c=new Map,this.g=new m.$4c,this.d=t.getProxy(b.$sM.MainThreadChatAgents2)}createChatAgent(t,p,a){const g=i.b++,v=new c(t,p,this.d,g,a);return this.c.set(g,v),this.d.$registerAgent(g,t.identifier,p,{},void 0),v.apiAgent}createDynamicChatAgent(t,p,a,g,v){const f=i.b++,u=new c(t,p,this.d,f,v);return this.c.set(f,u),this.d.$registerAgent(f,t.identifier,p,{},{name:a,description:g}),u.apiAgent}async $invokeAgent(t,p,a,g){const v=this.c.get(t);if(!v)throw new Error(`[CHAT](${t}) CANNOT invoke agent because the agent is not registered`);let f=this.g.get(p.sessionId);f||(f=new m.$Tc,this.g.set(p.sessionId,f));const u=new r(v.extension,p,this.d,this.i,this.j.converter,f);try{const E=await this.k(p.agentId,a),w=v.invoke($.ChatAgentRequest.to(p),{history:E},u.apiObject,g);return await(0,M.$9g)(Promise.resolve(w).then(I=>{if(I?.metadata)try{JSON.stringify(I.metadata)}catch(S){const P=`result.metadata MUST be JSON.stringify-able. Got error: ${S.message}`;return this.i.error(`[${v.extension.identifier.value}] [@${v.id}] ${P}`,v.extension),{errorDetails:{message:P},timings:u.timings}}return{errorDetails:I?.errorDetails,timings:u.timings,metadata:I?.metadata}}),g)}catch(E){return this.i.error(E,v.extension),{errorDetails:{message:(0,D.localize)(0,null,(0,C.$6i)(E)),responseIsIncomplete:!0}}}finally{u.close()}}async k(t,p){const a=[];for(const g of p.history){const v=$.ChatAgentResult.to(g.result),f=t===g.request.agentId?v:{...v,metadata:void 0};a.push(new n.$wO(g.request.message,g.request.command,g.request.variables.variables.map($.ChatAgentResolvedVariable.to),g.request.agentId));const u=(0,k.$Hb)(g.response.map(E=>$.ChatResponsePart.fromContent(E,this.j.converter)));a.push(new n.$xO(u,f,g.request.agentId,g.request.command))}return a}$releaseSession(t){this.g.deleteAndDispose(t)}async $provideFollowups(t,p,a,g,v){const f=this.c.get(p);if(!f)return Promise.resolve([]);const u=await this.k(f.id,g),E=$.ChatAgentResult.to(a);return(await f.provideFollowups(E,{history:u},v)).filter(w=>{const I=!w.participant||A.Iterable.some(this.c.values(),S=>S.id===w.participant&&l.$Em.equals(S.extension.identifier,f.extension.identifier));return I||this.i.warn(`[@${f.id}] ChatFollowup refers to an unknown participant: ${w.participant}`),I}).map(w=>$.ChatFollowup.from(w,t))}$acceptFeedback(t,p,a,g){const v=this.c.get(t);if(!v)return;const f=$.ChatAgentResult.to(p);let u;switch(a){case o.InteractiveSessionVoteDirection.Down:u=n.ChatResultFeedbackKind.Unhelpful;break;case o.InteractiveSessionVoteDirection.Up:u=n.ChatResultFeedbackKind.Helpful;break}v.acceptFeedback(Object.freeze(g?{result:f,kind:u,reportIssue:g}:{result:f,kind:u}))}$acceptAction(t,p,a){const g=this.c.get(t);if(!g||a.action.kind==="vote")return;const v=$.ChatAgentUserActionEvent.to(p,a,this.j.converter);v&&g.acceptAction(Object.freeze(v))}async $invokeCompletionProvider(t,p,a){const g=this.c.get(t);return g?(await g.invokeCompletionProvider(p,a)).map($.ChatAgentCompletionItem.from):[]}async $provideWelcomeMessage(t,p){const a=this.c.get(t);if(a)return await a.provideWelcomeMessage(p)}async $provideSampleQuestions(t,p){const a=this.c.get(t);if(a)return(await a.provideSampleQuestions(p)).map(g=>$.ChatFollowup.from(g,void 0))}}e.$Njc=i,i.b=0;class c{constructor(t,p,a,g,v){this.extension=t,this.id=p,this.u=a,this.w=g,this.x=v,this.n=new N.$7d,this.o=new N.$7d}acceptFeedback(t){this.n.fire(t)}acceptAction(t){this.o.fire(t)}async invokeCompletionProvider(t,p){return this.q?await this.q.provider.provideCompletionItems(t,p)??[]:[]}async provideFollowups(t,p,a){if(!this.b)return[];const g=await this.b.provideFollowups(t,p,a);return g?g.filter(v=>!(v&&"commandId"in v)).filter(v=>!(v&&"message"in v)):[]}async provideWelcomeMessage(t){if(!this.s)return[];const p=await this.s.provideWelcomeMessage(t);return p?p.map(a=>typeof a=="string"?a:$.MarkdownString.from(a)):[]}async provideSampleQuestions(t){if(!this.s||!this.s.provideSampleQuestions)return[];const p=await this.s.provideSampleQuestions(t);return p||[]}get apiAgent(){let t=!1,p=!1;const a=()=>{t||p||(p=!0,queueMicrotask(()=>{this.u.$updateAgent(this.w,{fullName:this.c,icon:this.d?this.d instanceof O.URI?this.d:"light"in this.d?this.d.light:void 0:void 0,iconDark:this.d&&"dark"in this.d?this.d.dark:void 0,themeIcon:this.d instanceof n.$qN?this.d:void 0,hasFollowups:this.b!==void 0,isSecondary:this.m,helpTextPrefix:!this.i||typeof this.i=="string"?this.i:$.MarkdownString.from(this.i),helpTextVariablesPrefix:!this.j||typeof this.j=="string"?this.j:$.MarkdownString.from(this.j),helpTextPostfix:!this.k||typeof this.k=="string"?this.k:$.MarkdownString.from(this.k),sampleRequest:this.l,supportIssueReporting:this.p,requester:this.t}),p=!1}))},g=this;return{get id(){return g.id},get fullName(){return(0,s.$dG)(g.extension,"defaultChatParticipant"),g.c??g.extension.displayName??g.extension.name},set fullName(v){(0,s.$dG)(g.extension,"defaultChatParticipant"),g.c=v,a()},get iconPath(){return g.d},set iconPath(v){g.d=v,a()},get requestHandler(){return g.x},set requestHandler(v){(0,y.$6f)(typeof v=="function","Invalid request handler"),g.x=v},get followupProvider(){return g.b},set followupProvider(v){g.b=v,a()},get isDefault(){return(0,s.$dG)(g.extension,"defaultChatParticipant"),g.g},set isDefault(v){(0,s.$dG)(g.extension,"defaultChatParticipant"),g.g=v,a()},get helpTextPrefix(){return(0,s.$dG)(g.extension,"defaultChatParticipant"),g.i},set helpTextPrefix(v){(0,s.$dG)(g.extension,"defaultChatParticipant"),g.i=v,a()},get helpTextVariablesPrefix(){return(0,s.$dG)(g.extension,"defaultChatParticipant"),g.j},set helpTextVariablesPrefix(v){(0,s.$dG)(g.extension,"defaultChatParticipant"),g.j=v,a()},get helpTextPostfix(){return(0,s.$dG)(g.extension,"defaultChatParticipant"),g.k},set helpTextPostfix(v){(0,s.$dG)(g.extension,"defaultChatParticipant"),g.k=v,a()},get isSecondary(){return(0,s.$dG)(g.extension,"defaultChatParticipant"),g.m},set isSecondary(v){(0,s.$dG)(g.extension,"defaultChatParticipant"),g.m=v,a()},get sampleRequest(){return g.l},set sampleRequest(v){g.l=v,a()},get supportIssueReporting(){return(0,s.$dG)(g.extension,"chatParticipantAdditions"),g.p},set supportIssueReporting(v){(0,s.$dG)(g.extension,"chatParticipantAdditions"),g.p=v,a()},get onDidReceiveFeedback(){return g.n.event},set participantVariableProvider(v){if((0,s.$dG)(g.extension,"chatParticipantAdditions"),g.q=v,v){if(!v.triggerCharacters.length)throw new Error("triggerCharacters are required");g.u.$registerAgentCompletionsProvider(g.w,v.triggerCharacters)}else g.u.$unregisterAgentCompletionsProvider(g.w)},get participantVariableProvider(){return(0,s.$dG)(g.extension,"chatParticipantAdditions"),g.q},set welcomeMessageProvider(v){(0,s.$dG)(g.extension,"defaultChatParticipant"),g.s=v,a()},get welcomeMessageProvider(){return(0,s.$dG)(g.extension,"defaultChatParticipant"),g.s},onDidPerformAction:(0,s.$cG)(this.extension,"chatParticipantAdditions")?this.o.event:void 0,set requester(v){g.t=v,a()},get requester(){return g.t},dispose(){t=!0,g.b=void 0,g.n.dispose(),g.u.$unregisterAgent(g.w)}}}invoke(t,p,a,g){return this.x(t,p,a,g)}}}),define(Pe[254],Re([1,0,14,6,4,8,7,25]),function(ee,e,k,M,C,N,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qjc=void 0;class d{constructor(D){this.b=new Map,this.c=D.getProxy(C.$sM.MainThreadChatVariables)}async $resolveVariable(D,l,b,$){const n=this.b.get(D);if(n)try{if(n.resolver.resolve2){(0,m.$dG)(n.extension,"chatParticipantAdditions");const o=new y(l,this.c),s=await n.resolver.resolve2(n.data.name,{prompt:b},o.apiObject,$);if(s)return s.map(N.ChatVariable.from)}else{const o=await n.resolver.resolve(n.data.name,{prompt:b},$);if(o)return o.map(N.ChatVariable.from)}}catch(o){(0,k.$2)(o)}}registerVariableResolver(D,l,b,$){const n=d.a++;return this.b.set(n,{extension:D,data:{name:l,description:b},resolver:$}),this.c.$registerVariable(n,{name:l,description:b}),(0,M.$Sc)(()=>{this.b.delete(n),this.c.$unregisterVariable(n)})}}e.$Qjc=d,d.a=0;class y{constructor(D,l){this.c=D,this.d=l,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let l=function($){if(D.a){const n=new Error("Response stream has been closed");throw Error.captureStackTrace(n,$),n}};const D=this,b=$=>{this.d.$handleProgressChunk(this.c,$)};this.b={progress($){l(this.progress);const n=new A.$tO($),o=N.ChatResponseProgressPart.to(n);return b(o),this},reference($){l(this.reference);const n=new A.$vO($),o=N.ChatResponseReferencePart.to(n);return b(o),this},push($){return l(this.push),$ instanceof A.$vO?b(N.ChatResponseReferencePart.to($)):$ instanceof A.$tO&&b(N.ChatResponseProgressPart.to($)),this}}}return this.b}}}),define(Pe[255],Re([1,0,11,68,5,6,2,87,20,8,7,4,25]),function(ee,e,k,M,C,N,A,m,d,y,O,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ujc=b;function b($,n,o){const s=$.getProxy(D.$sM.MainThreadComments);class r{constructor(){this.b=new Map,this.c=new d.$Gm,n.registerArgumentProcessor({processArgument:u=>{if(u&&u.$mid===6){const E=this.b.get(u.handle);return E?E.value:u}else if(u&&u.$mid===7){const E=u,w=this.b.get(E.commentControlHandle);if(!w)return E;const I=w.getCommentThread(E.commentThreadHandle);return I?I.value:E}else if(u&&(u.$mid===9||u.$mid===8)){const E=this.b.get(u.thread.commentControlHandle);if(!E)return u;const w=E.getCommentThread(u.thread.commentThreadHandle);return w?u.$mid===8?w.value:{thread:w.value,text:u.text}:u}else if(u&&u.$mid===10){const E=this.b.get(u.thread.commentControlHandle);if(!E)return u;const w=E.getCommentThread(u.thread.commentThreadHandle);if(!w)return u;const I=u.commentUniqueId,S=w.getCommentByUniqueId(I);return S||u}else if(u&&u.$mid===11){const E=this.b.get(u.thread.commentControlHandle);if(!E)return u;const w=E.getCommentThread(u.thread.commentThreadHandle);if(!w)return u;const I=u.text,S=u.commentUniqueId,P=w.getCommentByUniqueId(S);return P?(typeof P.body=="string"?P.body=I:P.body=new O.$VM(I),P):u}return u}})}createCommentController(u,E,w){const I=r.a++,S=new c(u,I,E,w);this.b.set(S.handle,S);const P=this.c.get(u.identifier)||[];return P.push(S),this.c.set(u.identifier,P),S.value}async $createCommentThreadTemplate(u,E,w){const I=this.b.get(u);I&&I.$createCommentThreadTemplate(E,w)}async $setActiveComment(u,E){const w=this.b.get(u);w&&w.$setActiveComment(E??void 0)}async $updateCommentThreadTemplate(u,E,w){const I=this.b.get(u);I&&I.$updateCommentThreadTemplate(E,w)}$deleteCommentThread(u,E){this.b.get(u)?.$deleteCommentThread(E)}async $provideCommentingRanges(u,E,w){const I=this.b.get(u);if(!I||!I.commentingRangeProvider)return Promise.resolve(void 0);const S=await o.ensureDocumentData(A.URI.revive(E));return(0,k.$ah)(async()=>{const P=await I.commentingRangeProvider.provideCommentingRanges(S.document,w);let U;return Array.isArray(P)?U={ranges:P,fileComments:!1}:P?U={ranges:P.ranges||[],fileComments:P.fileComments||!1}:U=P??void 0,U}).then(P=>{let U;return P&&(U={ranges:P.ranges.map(Q=>y.Range.from(Q)),fileComments:P.fileComments}),U})}$toggleReaction(u,E,w,I,S){const P=this.b.get(u);return!P||!P.reactionHandler?Promise.resolve(void 0):(0,k.$ah)(()=>{const U=P.getCommentThread(E);if(U){const Q=U.getCommentByUniqueId(I.uniqueIdInThread);if(P!==void 0&&Q&&P.reactionHandler)return P.reactionHandler(Q,p(S))}return Promise.resolve(void 0)})}}r.a=0;class i{set threadId(u){this.n=u}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(u){(u===void 0!=(this.p===void 0)||!u||!this.p||!u.isEqual(this.p))&&(this.p=u,this.b.range=u,this.c.fire())}get range(){return this.p}set canReply(u){this.d!==u&&(this.d=u,this.b.canReply=u,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(u){this.e=u,this.b.label=u,this.c.fire()}get contextValue(){return this.f}set contextValue(u){this.f=u,this.b.contextValue=u,this.c.fire()}get comments(){return this.q}set comments(u){this.q=u,this.b.comments=u,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(u){this.g=u,this.b.collapsibleState=u,this.c.fire()}get state(){return this.h}set state(u){this.h=u,typeof u=="object"?((0,l.$dG)(this.extensionDescription,"commentThreadApplicability"),this.b.state=u.resolved,this.b.applicability=u.applicability):this.b.state=u,this.c.fire()}get isDisposed(){return this.j}constructor(u,E,w,I,S,P,U,Q){this.m=E,this.n=w,this.o=I,this.p=S,this.q=P,this.extensionDescription=U,this.r=Q,this.handle=i.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new C.$7d,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new N.$Vc,this.l.value=new N.$Tc,this.n===void 0&&(this.n=`${u}.${this.handle}`),s.$createCommentThread(E,this.handle,this.n,this.o,y.Range.from(this.p),U.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=P,this.i.push({dispose:()=>{s.$deleteCommentThread(E,this.handle)}});const H=this;this.value={get uri(){return H.uri},get range(){return H.range},set range(L){H.range=L},get comments(){return H.comments},set comments(L){H.comments=L},get collapsibleState(){return H.collapsibleState},set collapsibleState(L){H.collapsibleState=L},get canReply(){return H.canReply},set canReply(L){H.canReply=L},get contextValue(){return H.contextValue},set contextValue(L){H.contextValue=L},get label(){return H.label},set label(L){H.label=L},get state(){return H.state},set state(L){H.state=L},dispose:()=>{H.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new N.$Tc);const u=w=>Object.prototype.hasOwnProperty.call(this.b,w),E={};u("range")&&(E.range=y.Range.from(this.p)),u("label")&&(E.label=this.label),u("contextValue")&&(E.contextValue=this.contextValue??null),u("comments")&&(E.comments=this.q.map(w=>h(this,w,this.k,this.extensionDescription))),u("collapsibleState")&&(E.collapseState=a(this.g)),u("canReply")&&(E.canReply=this.canReply),u("state")&&(E.state=g(this.h)),u("applicability")&&(E.applicability=v(this.h)),u("isTemplate")&&(E.isTemplate=this.r),this.b={},s.$updateCommentThread(this.m,this.handle,this.n,this.o,E)}getCommentByUniqueId(u){for(const E of this.k){const w=E[0],I=E[1];if(u===I)return w}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(u=>u.dispose())}}i.a=0,Xe([(0,M.$Nh)(100)],i.prototype,"eventuallyUpdateCommentThread",null);class c{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(u){this.b=u,u?.resourceHints&&(0,l.$dG)(this.h,"commentingRangeHint"),s.$updateCommentingRanges(this.handle,u?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(u){this.c=u,s.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!u})}get options(){return this.d}set options(u){this.d=u,s.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,l.$dG)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,l.$dG)(this.h,"activeComment"),this.f}constructor(u,E,w,I){this.h=u,this.i=E,this.j=w,this.k=I,this.a=new Map,s.$registerCommentController(this.handle,w,I,this.h.identifier.value);const S=this;this.value=Object.freeze({id:S.id,label:S.label,get options(){return S.options},set options(P){S.options=P},get commentingRangeProvider(){return S.commentingRangeProvider},set commentingRangeProvider(P){S.commentingRangeProvider=P},get reactionHandler(){return S.reactionHandler},set reactionHandler(P){S.reactionHandler=P},get activeCommentThread(){return S.activeCommentThread},createCommentThread(P,U,Q){return S.createCommentThread(P,U,Q).value},dispose:()=>{S.dispose()}}),this.g=[],this.g.push({dispose:()=>{s.$unregisterCommentController(this.handle)}})}createCommentThread(u,E,w){E===void 0&&(0,l.$dG)(this.h,"fileComments");const I=new i(this.id,this.handle,void 0,u,E,w,this.h,!1);return this.a.set(I.handle,I),I}$setActiveComment(u){if(!u){this.e=void 0,this.f=void 0;return}const E=this.a.get(u.commentThreadHandle);E&&(this.e=u.uniqueIdInThread?E.getCommentByUniqueId(u.uniqueIdInThread):void 0,this.f=E)}$createCommentThreadTemplate(u,E){const w=new i(this.id,this.handle,void 0,A.URI.revive(u),y.Range.to(E),[],this.h,!0);return w.collapsibleState=m.CommentThreadCollapsibleState.Expanded,this.a.set(w.handle,w),w}$updateCommentThreadTemplate(u,E){const w=this.a.get(u);w&&(w.range=y.Range.to(E))}$deleteCommentThread(u){this.a.get(u)?.dispose(),this.a.delete(u)}getCommentThread(u){return this.a.get(u)}dispose(){this.a.forEach(u=>{u.dispose()}),this.g.forEach(u=>u.dispose())}}function h(f,u,E,w){let I=E.get(u);return I||(I=++f.commentHandle,E.set(u,I)),u.state!==void 0&&(0,l.$dG)(w,"commentsDraftState"),u.reactions?.some(S=>S.reactors!==void 0)&&(0,l.$dG)(w,"commentReactor"),{mode:u.mode,contextValue:u.contextValue,uniqueIdInThread:I,body:typeof u.body=="string"?u.body:y.MarkdownString.from(u.body),userName:u.author.name,userIconPath:u.author.iconPath,label:u.label,commentReactions:u.reactions?u.reactions.map(S=>t(S)):void 0,state:u.state,timestamp:u.timestamp?.toJSON()}}function t(f){return{label:f.label,iconPath:f.iconPath?y.$NO(f.iconPath):void 0,count:f.count,hasReacted:f.authorHasReacted,reactors:f.reactors&&f.reactors.length>0&&typeof f.reactors[0]!="string"?f.reactors.map(u=>u.name):f.reactors}}function p(f){return{label:f.label||"",count:f.count||0,iconPath:f.iconPath?A.URI.revive(f.iconPath):"",authorHasReacted:f.hasReacted||!1,reactors:f.reactors?.map(u=>({name:u}))}}function a(f){if(f!==void 0)switch(f){case O.CommentThreadCollapsibleState.Expanded:return m.CommentThreadCollapsibleState.Expanded;case O.CommentThreadCollapsibleState.Collapsed:return m.CommentThreadCollapsibleState.Collapsed}return m.CommentThreadCollapsibleState.Collapsed}function g(f){let u;if(typeof f=="object"?u=f.resolved:u=f,u!==void 0)switch(u){case O.CommentThreadState.Unresolved:return m.CommentThreadState.Unresolved;case O.CommentThreadState.Resolved:return m.CommentThreadState.Resolved}return m.CommentThreadState.Unresolved}function v(f){let u;if(typeof f=="object"&&(u=f.applicability),u!==void 0)switch(u){case O.CommentThreadApplicability.Current:return m.CommentThreadApplicability.Current;case O.CommentThreadApplicability.Outdated:return m.CommentThreadApplicability.Outdated}return m.CommentThreadApplicability.Current}return new r}}),define(Pe[256],Re([1,0,24,99,6,12,23,2,8,63,74,4,7]),function(ee,e,k,M,C,N,A,m,d,y,O,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$akc=void 0;class b{constructor(p,a){this.document=p,this.b=a,this.a=1,this.c=new O.$xjc("custom documents")}addEdit(p){return this.c.add([p])}async undo(p,a){await this.f(p).undo(),a||this.disposeBackup()}async redo(p,a){await this.f(p).redo(),a||this.disposeBackup()}disposeEdits(p){for(const a of p)this.c.delete(a)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const p=h(this.document.uri)+this.a++;return(0,A.$Vg)(this.b,p)}updateBackup(p){this.d?.delete(),this.d=p}disposeBackup(){this.d?.delete(),this.d=void 0}f(p){const a=this.c.get(p,0);if(!a)throw new Error("No edit found");return a}}class ${constructor(){this.a=new Map}get(p,a){return this.a.get(this.b(p,a))}add(p,a,g){const v=this.b(p,a.uri);if(this.a.has(v))throw new Error(`Document already exists for viewType:${p} resource:${a.uri}`);const f=new b(a,g);return this.a.set(v,f),f}delete(p,a){const g=this.b(p,a.uri);this.a.delete(g)}b(p,a){return`${p}@@@${a}`}}var n;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(n||(n={}));class o{constructor(){this.a=new Map}addTextProvider(p,a,g){return this.b(0,p,a,g)}addCustomProvider(p,a,g){return this.b(1,p,a,g)}get(p){return this.a.get(p)}b(p,a,g,v){if(this.a.has(a))throw new Error(`Provider for viewType:${a} already registered`);return this.a.set(a,{type:p,extension:g,provider:v}),new l.$uM(()=>this.a.delete(a))}}class s{constructor(p,a,g,v,f){this.d=a,this.f=g,this.g=v,this.h=f,this.b=new o,this.c=new $,this.a=p.getProxy(D.$sM.MainThreadCustomEditors)}registerCustomEditorProvider(p,a,g,v){const f=new C.$Tc;return i(g)?(f.add(this.b.addTextProvider(a,p,g)),this.a.$registerTextEditorProvider((0,y.$0jc)(p),a,v.webviewOptions||{},{supportsMove:!!g.moveCustomTextEditor},(0,y.$8jc)(p))):(f.add(this.b.addCustomProvider(a,p,g)),r(g)&&f.add(g.onDidChangeCustomDocument(u=>{const E=this.i(a,u.document.uri);if(c(u)){const w=E.addEdit(u);this.a.$onDidEdit(u.document.uri,a,w,u.label)}else this.a.$onContentChange(u.document.uri,a)})),this.a.$registerCustomEditorProvider((0,y.$0jc)(p),a,v.webviewOptions||{},!!v.supportsMultipleEditorsPerDocument,(0,y.$8jc)(p))),l.$uM.from(f,new l.$uM(()=>{this.a.$unregisterEditorProvider(a)}))}async $createCustomDocument(p,a,g,v,f){const u=this.b.get(a);if(!u)throw new Error(`No provider found for '${a}'`);if(u.type!==1)throw new Error(`Invalid provide type for '${a}'`);const E=m.URI.revive(p),w=await u.provider.openCustomDocument(E,{backupId:g,untitledDocumentData:v?.buffer},f);let I;return r(u.provider)&&this.f&&(I=this.f.workspaceValue(u.extension)??this.f.globalValue(u.extension)),this.c.add(a,w,I),{editable:r(u.provider)}}async $disposeCustomDocument(p,a){const g=this.b.get(a);if(!g)throw new Error(`No provider found for '${a}'`);if(g.type!==1)throw new Error(`Invalid provider type for '${a}'`);const v=m.URI.revive(p),{document:f}=this.i(a,v);this.c.delete(a,f),f.dispose()}async $resolveCustomEditor(p,a,g,v,f,u){const E=this.b.get(g);if(!E)throw new Error(`No provider found for '${g}'`);const w=d.ViewColumn.to(f),I=this.g.createNewWebview(a,v.contentOptions,E.extension),S=this.h.createNewWebviewPanel(a,g,v.title,w,v.options,I,v.active),P=m.URI.revive(p);switch(E.type){case 1:{const{document:U}=this.i(g,P);return E.provider.resolveCustomEditor(U,S,u)}case 0:{const U=this.d.getDocument(P);return E.provider.resolveCustomTextEditor(U,S,u)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(p,a,g){this.i(a,p).disposeEdits(g)}async $onMoveCustomEditor(p,a,g){const v=this.b.get(g);if(!v)throw new Error(`No provider found for '${g}'`);if(!v.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${g}'`);const f=this.h.getWebviewPanel(p);if(!f)throw new Error("No webview found");const u=m.URI.revive(a),E=this.d.getDocument(u);await v.provider.moveCustomTextEditor(E,f,k.CancellationToken.None)}async $undo(p,a,g,v){return this.i(a,p).undo(g,v)}async $redo(p,a,g,v){return this.i(a,p).redo(g,v)}async $revert(p,a,g){const v=this.i(a,p);await this.j(a).revertCustomDocument(v.document,g),v.disposeBackup()}async $onSave(p,a,g){const v=this.i(a,p);await this.j(a).saveCustomDocument(v.document,g),v.disposeBackup()}async $onSaveAs(p,a,g,v){const f=this.i(a,p);return this.j(a).saveCustomDocumentAs(f.document,m.URI.revive(g),v)}async $backup(p,a,g){const v=this.i(a,p),u=await this.j(a).backupCustomDocument(v.document,{destination:v.getNewBackupUri()},g);return v.updateBackup(u),u.id}i(p,a){const g=this.c.get(p,m.URI.revive(a));if(!g)throw new Error("No custom document found");return g}j(p){const g=this.b.get(p)?.provider;if(!g||!r(g))throw new Error("Custom document is not editable");return g}}e.$akc=s;function r(t){return!!t.onDidChangeCustomDocument}function i(t){return typeof t.resolveCustomTextEditor=="function"}function c(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function h(t){const p=t.scheme===N.Schemas.file||t.scheme===N.Schemas.untitled?t.fsPath:t.toString();return(0,M.$9i)(p)+""}});var _e=this&&this.__classPrivateFieldSet||function(ee,e,k,M,C){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?C.call(ee,k):C?C.value=k:e.set(ee,k),k},Ve=this&&this.__classPrivateFieldGet||function(ee,e,k,M){if(k==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!M:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return k==="m"?M:k==="a"?M.call(ee):M?M.value:e.get(ee)};define(Pe[257],Re([1,0,164,100,2,4,7,8,5,13,28,44]),function(ee,e,k,M,C,N,A,m,d,y,O,D){"use strict";var l,b,$,n;Object.defineProperty(e,"__esModule",{value:!0}),e.$Fjc=e.$Ejc=void 0;class o{constructor(i,c,h,t,p,a,g,v){this.d=i,this.e=c,this.f=h,this.g=t,this.h=p,l.set(this,void 0),b.set(this,void 0),$.set(this,void 0),this.c=!1,this.f=Math.max(t,h),_e(this,$,new O.$Bc(f=>a.getComparisonKey(f)),"f"),_e(this,l,g,"f"),_e(this,b,v,"f")}dispose(){this.c||(Ve(this,b,"f").fire([...Ve(this,$,"f").keys()]),Ve(this,l,"f")?.$clear(this.e),Ve(this,$,"f").clear(),this.c=!0)}get name(){return this.j(),this.d}set(i,c){if(!i){this.clear();return}this.j();let h=[];if(C.URI.isUri(i)){if(!c){this.delete(i);return}Ve(this,$,"f").set(i,c.slice()),h=[i]}else if(Array.isArray(i)){h=[];let a;i=[...i].sort(o.k);for(const g of i){const[v,f]=g;if((!a||v.toString()!==a.toString())&&(a&&Ve(this,$,"f").get(a).length===0&&Ve(this,$,"f").delete(a),a=v,h.push(v),Ve(this,$,"f").set(v,[])),f)Ve(this,$,"f").get(v)?.push(...f);else{const u=Ve(this,$,"f").get(v);u&&(u.length=0)}}}if(Ve(this,b,"f").fire(h),!Ve(this,l,"f"))return;const t=[];let p=0;for(const a of h){let g=[];const v=Ve(this,$,"f").get(a);if(v)if(v.length>this.g){g=[];const f=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let u=0;u<4;u++)for(const E of v)if(E.severity===f[u]&&g.push({...m.Diagnostic.from(E),modelVersionId:this.h(a)})===this.g)break e;g.push({severity:M.MarkerSeverity.Info,message:(0,k.localize)(0,null,v.length-this.g),startLineNumber:g[g.length-1].startLineNumber,startColumn:g[g.length-1].startColumn,endLineNumber:g[g.length-1].endLineNumber,endColumn:g[g.length-1].endColumn})}else g=v.map(f=>({...m.Diagnostic.from(f),modelVersionId:this.h(a)}));if(t.push([a,g]),p+=g.length,p>this.f)break}Ve(this,l,"f").$changeMany(this.e,t)}delete(i){this.j(),Ve(this,b,"f").fire([i]),Ve(this,$,"f").delete(i),Ve(this,l,"f")?.$changeMany(this.e,[[i,void 0]])}clear(){this.j(),Ve(this,b,"f").fire([...Ve(this,$,"f").keys()]),Ve(this,$,"f").clear(),Ve(this,l,"f")?.$clear(this.e)}forEach(i,c){this.j();for(const[h,t]of this)i.call(c,h,t,this)}*[(l=new WeakMap,b=new WeakMap,$=new WeakMap,Symbol.iterator)](){this.j();for(const i of Ve(this,$,"f").keys())yield[i,this.get(i)]}get(i){this.j();const c=Ve(this,$,"f").get(i);return Array.isArray(c)?Object.freeze(c.slice(0)):[]}has(i){return this.j(),Array.isArray(Ve(this,$,"f").get(i))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(i,c){return i[0].toString()<c[0].toString()?-1:i[0].toString()>c[0].toString()?1:0}}e.$Ejc=o;let s=n=class{static _mapper(i){const c=new O.$Bc;for(const h of i)c.set(h,h);return{uris:Object.freeze(Array.from(c.values()))}}constructor(i,c,h,t){this.j=c,this.k=h,this.l=t,this.g=new Map,this.h=new d.$$d({merge:p=>p.flat(),delay:50}),this.onDidChangeDiagnostics=d.Event.map(this.h.event,n._mapper),this.f=i.getProxy(N.$sM.MainThreadDiagnostics)}createDiagnosticCollection(i,c){const{g:h,f:t,h:p,j:a,k:g,l:v}=this,f=new class{$changeMany(w,I){t.$changeMany(w,I),a.trace("[DiagnosticCollection] change many (extension, owner, uris)",i.value,w,I.length===0?"CLEARING":I)}$clear(w){t.$clear(w),a.trace("[DiagnosticCollection] remove all (extension, owner)",i.value,w)}dispose(){t.dispose()}};let u;if(!c)c="_generated_diagnostic_collection_name_#"+n.c++,u=c;else if(!h.has(c))u=c;else{this.j.warn(`DiagnosticCollection with name '${c}' does already exist.`);do u=c+n.c++;while(h.has(u))}return new class extends o{constructor(){super(c,u,n.e,n.d,w=>v.getDocument(w)?.version,g.extUri,f,p),h.set(u,this)}dispose(){super.dispose(),h.delete(u)}}}getDiagnostics(i){if(i)return this.m(i);{const c=new Map,h=[];for(const t of this.g.values())t.forEach((p,a)=>{let g=c.get(p.toString());typeof g>"u"&&(g=h.length,c.set(p.toString(),g),h.push([p,[]])),h[g][1]=h[g][1].concat(...a)});return h}}m(i){let c=[];for(const h of this.g.values())h.has(i)&&(c=c.concat(h.get(i)));return c}$acceptMarkersChange(i){if(!this.n){const c="_generated_mirror",h=new o(c,c,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,t=>{},this.k.extUri,void 0,this.h);this.g.set(c,h),this.n=h}for(const[c,h]of i)this.n.set(C.URI.revive(c),h.map(m.Diagnostic.to))}};e.$Fjc=s,s.c=0,s.d=1e3,s.e=1.1*n.d,e.$Fjc=s=n=Xe([qe(1,y.$Oj),qe(2,D.$Djc)],s)}),define(Pe[258],Re([1,0,2,14,7,8,192]),function(ee,e,k,M,C,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Okc=void 0;class m{constructor(y,O,D,l={timeout:1500,errors:3}){this.c=y,this.d=O,this.f=D,this.g=l,this.a=new A.$5c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(y){return(O,D,l)=>{const $={dispose:this.a.push([O,D,y])};return Array.isArray(l)&&l.push($),$}}async $participateInSave(y,O){const D=k.URI.revive(y);let l=!1;const b=setTimeout(()=>l=!0,this.g.timeout),$=[];try{for(const n of[...this.a]){if(l)break;const o=this.d.getDocument(D),s=await this.h(n,{document:o,reason:N.TextDocumentSaveReason.to(O)});$.push(s)}}finally{clearTimeout(b)}return $}h([y,O,D],l){const b=this.b.get(y);return typeof b=="number"&&b>this.g.errors?Promise.resolve(!1):this.i(D,y,O,l).then(()=>!0,$=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' threw ERROR`),this.c.error($),!($ instanceof Error)||$.message!=="concurrent_edits"){const n=this.b.get(y);this.b.set(y,n?n+1:1),typeof n=="number"&&n>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(y,O,D,l){const b=[],$=Date.now(),{document:n,reason:o}=l,{version:s}=n,r=Object.freeze({document:n,reason:o,waitUntil(i){if(Object.isFrozen(b))throw(0,M.$8)("waitUntil can not be called async");b.push(Promise.resolve(i))}});try{O.apply(D,[r])}catch(i){return Promise.reject(i)}return Object.freeze(b),new Promise((i,c)=>{const h=setTimeout(()=>c(new Error("timeout")),this.g.timeout);return Promise.all(b).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${y.identifier.value}' finished after ${Date.now()-$}ms`),clearTimeout(h),i(t)}).catch(t=>{clearTimeout(h),c(t)})}).then(i=>{const c={edits:[]};for(const h of i)if(Array.isArray(h)&&h.every(t=>t instanceof C.$BM))for(const{newText:t,newEol:p,range:a}of h)c.edits.push({resource:n.uri,versionId:void 0,textEdit:{range:a&&N.Range.from(a),text:t,eol:p&&N.EndOfLine.from(p)}});if(c.edits.length!==0)return s===n.version?this.f.$tryApplyWorkspaceEdit(c):Promise.reject(new Error("concurrent_edits"))})}}e.$Okc=m}),define(Pe[259],Re([1,0,5,6,2,4,111,8,17,26,7]),function(ee,e,k,M,C,N,A,m,d,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gjc=void 0;class D{constructor(b,$){this.a=new k.$7d,this.b=new k.$7d,this.c=new k.$7d,this.d=new k.$7d,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new M.$Tc,this.h=new Map,this.f=b.getProxy(N.$sM.MainThreadDocuments),this.g=$,this.g.onDidRemoveDocuments(n=>{for(const o of n)this.b.fire(o.document)},void 0,this.e),this.g.onDidAddDocuments(n=>{for(const o of n)this.a.fire(o.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(b){if(!b)return;const $=this.g.getDocument(b);if($)return $}getDocument(b){const $=this.getDocumentData(b);if(!$?.document)throw new Error(`Unable to retrieve document from URI '${b}'`);return $.document}ensureDocumentData(b){const $=this.g.getDocument(b);if($)return Promise.resolve($);let n=this.h.get(b.toString());return n||(n=this.f.$tryOpenDocument(b).then(o=>{this.h.delete(b.toString());const s=C.URI.revive(o);return(0,d.$7f)(this.g.getDocument(s))},o=>(this.h.delete(b.toString()),Promise.reject(o))),this.h.set(b.toString(),n)),n}createDocumentData(b){return this.f.$tryCreateDocument(b).then($=>C.URI.revive($))}$acceptModelLanguageChanged(b,$){const n=C.URI.revive(b),o=this.g.getDocument(n);if(!o)throw new Error("unknown document");this.b.fire(o.document),o._acceptLanguageId($),this.a.fire(o.document)}$acceptModelSaved(b){const $=C.URI.revive(b),n=this.g.getDocument($);if(!n)throw new Error("unknown document");this.$acceptDirtyStateChanged(b,!1),this.d.fire(n.document)}$acceptDirtyStateChanged(b,$){const n=C.URI.revive(b),o=this.g.getDocument(n);if(!o)throw new Error("unknown document");o._acceptIsDirty($),this.c.fire({document:o.document,contentChanges:[],reason:void 0})}$acceptModelChanged(b,$,n){const o=C.URI.revive(b),s=this.g.getDocument(o);if(!s)throw new Error("unknown document");s._acceptIsDirty(n),s.onEvents($);let r;$.isUndoing?r=O.TextDocumentChangeReason.Undo:$.isRedoing&&(r=O.TextDocumentChangeReason.Redo),this.c.fire((0,y.$Qn)({document:s.document,contentChanges:$.changes.map(i=>({range:m.Range.to(i.range),rangeOffset:i.rangeOffset,rangeLength:i.rangeLength,text:i.text})),reason:r}))}setWordDefinitionFor(b,$){(0,A.$QO)(b,$)}}e.$Gjc=D}),define(Pe[66],Re([1,0,260,5,17,2,3,4,16,8,7]),function(ee,e,k,M,C,N,A,m,d,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ckc=e.$bkc=void 0,e.$bkc=(0,A.$ii)("IExtHostEditorTabs");class D{constructor(o,s,r){this.e=r,this.d=s,this.acceptDtoUpdate(o)}get apiObject(){if(!this.a){const o=this,s={get isActive(){return o.b.id===o.e()},get label(){return o.b.label},get input(){return o.c},get isDirty(){return o.b.isDirty},get isPinned(){return o.b.isPinned},get isPreview(){return o.b.isPreview},get group(){return o.d.apiObject}};this.a=Object.freeze(s)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(o){this.b=o,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new O.$eO(N.URI.revive(this.b.input.uri));case 2:return new O.$fO(N.URI.revive(this.b.input.original),N.URI.revive(this.b.input.modified));case 3:return new O.$gO(N.URI.revive(this.b.input.base),N.URI.revive(this.b.input.input1),N.URI.revive(this.b.input.input2),N.URI.revive(this.b.input.result));case 6:return new O.$hO(N.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new O.$iO(this.b.input.viewType);case 4:return new O.$jO(N.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new O.$kO(N.URI.revive(this.b.input.original),N.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new O.$lO;case 9:return new O.$mO(N.URI.revive(this.b.input.uri),N.URI.revive(this.b.input.inputBoxUri));case 10:return new O.$nO(this.b.input.providerId);case 11:return new O.$oO(this.b.input.diffEditors.map(o=>new O.$fO(N.URI.revive(o.original),N.URI.revive(o.modified))));default:return}}}class l{constructor(o,s){this.c=[],this.d="",this.b=o,this.e=s;for(const r of o.tabs)r.isActive&&(this.d=r.id),this.c.push(new D(r,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const o=this,s={get isActive(){return o.b.groupId===o.e()},get viewColumn(){return y.ViewColumn.to(o.b.viewColumn)},get activeTab(){return o.c.find(r=>r.tabId===o.d)?.apiObject},get tabs(){return Object.freeze(o.c.map(r=>r.apiObject))}};this.a=Object.freeze(s)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(o){this.b=o}acceptTabOperation(o){if(o.kind===0){const r=new D(o.tabDto,this,()=>this.activeTabId());return this.c.splice(o.index,0,r),o.tabDto.isActive&&(this.d=r.tabId),r}else if(o.kind===1){const r=this.c.splice(o.index,1)[0];if(!r)throw new Error(`Tab close updated received for index ${o.index} which does not exist`);return r.tabId===this.d&&(this.d=""),r}else if(o.kind===3){if(o.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const r=this.c.splice(o.oldIndex,1)[0];if(!r)throw new Error(`Tab move updated received for index ${o.oldIndex} which does not exist`);return this.c.splice(o.index,0,r),r}const s=this.c.find(r=>r.tabId===o.tabDto.id);if(!s)throw new Error("INVALID tab");return o.tabDto.isActive?this.d=o.tabDto.id:this.d===o.tabDto.id&&!o.tabDto.isActive&&(this.d=""),s.acceptDtoUpdate(o.tabDto),s}activeTabId(){return this.d}}let b=class{constructor(o){this.b=new M.$7d,this.c=new M.$7d,this.e=[],this.a=o.getProxy(m.$sM.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const o=this,s={onDidChangeTabGroups:o.c.event,onDidChangeTabs:o.b.event,get all(){return Object.freeze(o.e.map(r=>r.apiObject))},get activeTabGroup(){const r=o.d;return(0,C.$7f)(o.e.find(c=>c.groupId===r)?.apiObject)},close:async(r,i)=>{const c=Array.isArray(r)?r:[r];return c.length?$(c[0])?this.j(c,i):this.i(c,i):!0}};this.f=Object.freeze(s)}return this.f}$acceptEditorTabModel(o){const s=new Set(this.e.map(a=>a.groupId)),r=new Set(o.map(a=>a.groupId)),i=(0,k.$F)(s,r),c=this.e.filter(a=>i.removed.includes(a.groupId)).map(a=>a.apiObject),h=[],t=[];this.e=o.map(a=>{const g=new l(a,()=>this.d);return i.added.includes(g.groupId)?h.push(g.apiObject):t.push(g.apiObject),g});const p=(0,C.$7f)(o.find(a=>a.isActive===!0)?.groupId);p!==void 0&&this.d!==p&&(this.d=p),this.c.fire(Object.freeze({opened:h,closed:c,changed:t}))}$acceptTabGroupUpdate(o){const s=this.e.find(r=>r.groupId===o.groupId);if(!s)throw new Error("Update Group IPC call received before group creation.");s.acceptGroupDtoUpdate(o),o.isActive&&(this.d=o.groupId),this.c.fire(Object.freeze({changed:[s.apiObject],opened:[],closed:[]}))}$acceptTabOperation(o){const s=this.e.find(i=>i.groupId===o.groupId);if(!s)throw new Error("Update Tabs IPC call received before group creation.");const r=s.acceptTabOperation(o);switch(o.kind){case 0:this.b.fire(Object.freeze({opened:[r.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[r.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[r.apiObject]}));return}}g(o){for(const s of this.e)for(const r of s.tabs)if(r.apiObject===o)return r}h(o){return this.e.find(s=>s.apiObject===o)}async i(o,s){const r=[];for(const i of o){const c=this.g(i);if(!c)throw new Error("Tab close: Invalid tab not found!");r.push(c.tabId)}return this.a.$closeTab(r,s)}async j(o,s){const r=[];for(const i of o){const c=this.h(i);if(!c)throw new Error("Group close: Invalid group not found!");r.push(c.groupId)}return this.a.$closeGroup(r,s)}};e.$ckc=b,e.$ckc=b=Xe([qe(0,d.$OO)],b);function $(n){return n.tabs!==void 0}}),define(Pe[261],Re([1,0,2,4,6,7,8,304,15,22,25,54]),function(ee,e,k,M,C,N,A,m,d,y,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qkc=void 0;class l{constructor(){this.a=[]}add(n){this.b=void 0,this.a.push(n)}delete(n){const o=this.a.indexOf(n);o>=0&&(this.a.splice(o,1),this.b=void 0)}c(){if(!this.b){const n=this.a.sort(),o=[];let s,r,i=14,c=14;for(const h of n){let t=s?(0,d.$nf)(s,h):0;for(t===0?r=1:r=c;t<h.length;t++)t+1===h.length?(i=c,c=9):c+=1,o.push([r,h.toUpperCase().charCodeAt(t),c]),o.push([r,h.toLowerCase().charCodeAt(t),c]),r=c;s=h,c=i}o.push([9,58,10]),o.push([10,47,12]),this.b=new m.$E2(o)}}provideDocumentLinks(n){this.c();const o=[],s=m.$F2.computeLinks({getLineContent(r){return n.lineAt(r-1).text},getLineCount(){return n.lineCount}},this.b);for(const r of s){const i=A.DocumentLink.to(r);i.target&&o.push(i)}return o}}class b{constructor(n,o){this.i=o,this.b=new l,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=n.getProxy(M.$sM.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(n,o,s,r={}){if(b.j(s),this.d.has(o))throw new Error(`a provider for the scheme '${o}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(n,"*",this.b));const i=this.h++;this.b.add(o),this.d.add(o),this.c.set(i,s);let c=2;r.isCaseSensitive&&(c+=1024),r.isReadonly&&(c+=2048),typeof s.copy=="function"&&(c+=8),typeof s.open=="function"&&typeof s.close=="function"&&typeof s.read=="function"&&typeof s.write=="function"&&((0,O.$dG)(n,"fsChunks"),c+=4);let h;r.isReadonly&&(0,D.$Hk)(r.isReadonly)&&r.isReadonly.value!==""&&(h={value:r.isReadonly.value,isTrusted:r.isReadonly.isTrusted,supportThemeIcons:r.isReadonly.supportThemeIcons,supportHtml:r.isReadonly.supportHtml,baseUri:r.isReadonly.baseUri,uris:r.isReadonly.uris}),this.a.$registerFileSystemProvider(i,o,c,h).catch(p=>{console.error(`FAILED to register filesystem provider of ${n.identifier.value}-extension for the scheme ${o}`),console.error(p)});const t=s.onDidChangeFile(p=>{const a=[];for(const g of p){const{uri:v,type:f}=g;if(v.scheme!==o)continue;let u;switch(f){case N.FileChangeType.Changed:u=0;break;case N.FileChangeType.Created:u=1;break;case N.FileChangeType.Deleted:u=2;break;default:throw new Error("Unknown FileChangeType")}a.push({resource:v,type:u})}this.a.$onFileSystemChange(i,a)});return(0,C.$Sc)(()=>{t.dispose(),this.b.delete(o),this.d.delete(o),this.c.delete(i),this.a.$unregisterProvider(i)})}static j(n){if(!n)throw new Error("MISSING provider");if(typeof n.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof n.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof n.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof n.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof n.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof n.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof n.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof n.rename!="function")throw new Error("Provider does NOT implement rename")}static k(n){const{type:o,ctime:s,mtime:r,size:i,permissions:c}=n;return{type:o,ctime:s,mtime:r,size:i,permissions:c}}$stat(n,o){return Promise.resolve(this.l(n).stat(k.URI.revive(o))).then(s=>b.k(s))}$readdir(n,o){return Promise.resolve(this.l(n).readDirectory(k.URI.revive(o)))}$readFile(n,o){return Promise.resolve(this.l(n).readFile(k.URI.revive(o))).then(s=>y.$ue.wrap(s))}$writeFile(n,o,s,r){return Promise.resolve(this.l(n).writeFile(k.URI.revive(o),s.buffer,r))}$delete(n,o,s){return Promise.resolve(this.l(n).delete(k.URI.revive(o),s))}$rename(n,o,s,r){return Promise.resolve(this.l(n).rename(k.URI.revive(o),k.URI.revive(s),r))}$copy(n,o,s,r){const i=this.l(n);if(!i.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(i.copy(k.URI.revive(o),k.URI.revive(s),r))}$mkdir(n,o){return Promise.resolve(this.l(n).createDirectory(k.URI.revive(o)))}$watch(n,o,s,r){const i=this.l(n).watch(k.URI.revive(s),r);this.f.set(o,i)}$unwatch(n,o){const s=this.f.get(o);s&&(s.dispose(),this.f.delete(o))}$open(n,o,s){const r=this.l(n);if(!r.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(r.open(k.URI.revive(o),s))}$close(n,o){const s=this.l(n);if(!s.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(s.close(o))}$read(n,o,s,r){const i=this.l(n);if(!i.read)throw new Error('FileSystemProvider does not implement "read"');const c=y.$ue.alloc(r);return Promise.resolve(i.read(o,s,c.buffer,0,r)).then(h=>c.slice(0,h))}$write(n,o,s,r){const i=this.l(n);if(!i.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(i.write(o,s,r.buffer,0,r.byteLength))}l(n){const o=this.c.get(n);if(!o){const s=new Error;throw s.name="ENOPRO",s.message="no provider",s}return o}}e.$Qkc=b}),define(Pe[262],Re([1,0,5,34,2,4,8,7,40]),function(ee,e,k,M,C,N,A,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rkc=void 0;class y{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(b,$,n,o,s,r){this.a=Math.random(),this.b=new k.$7d,this.c=new k.$7d,this.d=new k.$7d,this.h=0,r?.ignoreCreateEvents&&(this.h+=1),r?.ignoreChangeEvents&&(this.h+=2),r?.ignoreDeleteEvents&&(this.h+=4);const i=(0,M.$ck)(s),c=typeof s=="string",h=r?.correlate,t=o(p=>{if(!(typeof p.session=="number"&&p.session!==this.a)&&!(h&&typeof p.session>"u")){if(!r?.ignoreCreateEvents)for(const a of p.created){const g=C.URI.revive(a);i(g.fsPath)&&(!c||$.getWorkspaceFolder(g))&&this.b.fire(g)}if(!r?.ignoreChangeEvents)for(const a of p.changed){const g=C.URI.revive(a);i(g.fsPath)&&(!c||$.getWorkspaceFolder(g))&&this.c.fire(g)}if(!r?.ignoreDeleteEvents)for(const a of p.deleted){const g=C.URI.revive(a);i(g.fsPath)&&(!c||$.getWorkspaceFolder(g))&&this.d.fire(g)}}});this.g=m.$uM.from(this.i(b,n,s,r,r?.correlate),this.b,this.c,this.d,t)}i(b,$,n,o,s){const r=m.$uM.from();if(typeof n=="string")return r;const i=b.getProxy(N.$sM.MainThreadFileSystemEventService);let c=!1;return(n.pattern.includes(M.$$j)||n.pattern.includes(M.$_j))&&(c=!0),i.$watch($.identifier.value,this.a,n.baseUri,{recursive:c,excludes:o?.excludes??[]},!!s),m.$uM.from({dispose:()=>i.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class O{constructor(b){this.a=b,this.session=this.a.session,this.b=new d.$V(()=>this.a.created.map(C.URI.revive)),this.c=new d.$V(()=>this.a.changed.map(C.URI.revive)),this.d=new d.$V(()=>this.a.deleted.map(C.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class D{constructor(b,$,n){this.j=b,this.k=$,this.l=n,this.a=new k.$7d,this.b=new k.$7d,this.c=new k.$7d,this.d=new k.$7d,this.g=new k.$9d,this.h=new k.$9d,this.i=new k.$9d,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(b,$,n,o){return new y(this.j,b,$,this.a.event,A.GlobPattern.from(n),o)}$onFileEvent(b){this.a.fire(new O(b))}$onDidRunFileOperation(b,$){switch(b){case 2:this.b.fire(Object.freeze({files:$.map(n=>({oldUri:C.URI.revive(n.source),newUri:C.URI.revive(n.target)}))}));break;case 1:this.d.fire(Object.freeze({files:$.map(n=>C.URI.revive(n.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:$.map(n=>C.URI.revive(n.target))}));break;default:}}getOnWillRenameFileEvent(b){return this.m(b,this.g)}getOnWillCreateFileEvent(b){return this.m(b,this.h)}getOnWillDeleteFileEvent(b){return this.m(b,this.i)}m(b,$){return(n,o,s)=>{const r=function(c){n.call(o,c)};return r.extension=b,$.event(r,void 0,s)}}async $onWillRunFileOperation(b,$,n,o){switch(b){case 2:return await this.n(this.g,{files:$.map(s=>({oldUri:C.URI.revive(s.source),newUri:C.URI.revive(s.target)}))},n,o);case 1:return await this.n(this.i,{files:$.map(s=>C.URI.revive(s.target))},n,o);case 0:case 3:return await this.n(this.h,{files:$.map(s=>C.URI.revive(s.target))},n,o)}}async n(b,$,n,o){const s=new Set,r=[];if(await b.fireAsync($,o,async(c,h)=>{const t=Date.now(),p=await Promise.resolve(c);p instanceof m.$EM&&(r.push([h.extension,p]),s.add(h.extension.displayName??h.extension.identifier.value)),Date.now()-t>n&&this.k.warn("SLOW file-participant",h.extension.identifier)}),o.isCancellationRequested||r.length===0)return;const i={edits:[]};for(const[,c]of r){const{edits:h}=A.WorkspaceEdit.from(c,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});i.edits=i.edits.concat(h)}return{edit:i,extensionNames:Array.from(s)}}}e.$Rkc=D}),define(Pe[263],Re([1,0,18,11,24,14,90,6,26,65,15,17,2,29,305,87,97,166,20,8,7,25,74,4]),function(ee,e,k,M,C,N,A,m,d,y,O,D,l,b,$,n,o,s,r,i,c,h,t,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hjc=void 0;class a{constructor(j,B){this.d=j,this.e=B}async provideDocumentSymbols(j,B){const G=this.d.getDocument(j),W=await this.e.provideDocumentSymbols(G,B);if(!(0,k.$Kb)(W))return W[0]instanceof c.$NM?W.map(i.DocumentSymbol.from):a.f(W)}static f(j){j=j.slice(0).sort((W,_)=>{let oe=W.location.range.start.compareTo(_.location.range.start);return oe===0&&(oe=_.location.range.end.compareTo(W.location.range.end)),oe});const B=[],G=[];for(const W of j){const _={name:W.name||"!!MISSING: name!!",kind:i.SymbolKind.from(W.kind),tags:W.tags?.map(i.SymbolTag.from)||[],detail:"",containerName:W.containerName,range:i.Range.from(W.location.range),selectionRange:i.Range.from(W.location.range),children:[]};for(;;){if(G.length===0){G.push(_),B.push(_);break}const oe=G[G.length-1];if(b.$dt.containsRange(oe.range,_.range)&&!b.$dt.equalsRange(oe.range,_.range)){oe.children?.push(_),G.push(_);break}G.pop()}}return B}}class g{constructor(j,B,G,W,_,oe){this.f=j,this.g=B,this.h=G,this.j=W,this.k=_,this.l=oe,this.d=new t.$xjc("CodeLens"),this.e=new Map}async provideCodeLenses(j,B){const G=this.f.getDocument(j),W=await this.h.provideCodeLenses(G,B);if(!W||B.isCancellationRequested)return;const _=this.d.add(W),oe=new m.$Tc;this.e.set(_,oe);const Fe={cacheId:_,lenses:[]};for(let Be=0;Be<W.length;Be++)Fe.lenses.push({cacheId:[_,Be],range:i.Range.from(W[Be].range),command:this.g.toInternal(W[Be].command,oe)});return Fe}async resolveCodeLens(j,B){const G=j.cacheId&&this.d.get(...j.cacheId);if(!G)return;let W;if(typeof this.h.resolveCodeLens!="function"||G.isResolved?W=G:W=await this.h.resolveCodeLens(G,B),W||(W=G),B.isCancellationRequested)return;const _=j.cacheId&&this.e.get(j.cacheId[0]);if(_){if(!W.command){const oe=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,oe),this.l.error(oe);return}return j.command=this.g.toInternal(W.command,_),j}}releaseCodeLenses(j){this.e.get(j)?.dispose(),this.e.delete(j),this.d.delete(j)}}function v(je){return Array.isArray(je)?je.map(i.DefinitionLink.from):je?[i.DefinitionLink.from(je)]:[]}class f{constructor(j,B){this.d=j,this.e=B}async provideDefinition(j,B,G){const W=this.d.getDocument(j),_=i.Position.to(B),oe=await this.e.provideDefinition(W,_,G);return v(oe)}}class u{constructor(j,B){this.d=j,this.e=B}async provideDeclaration(j,B,G){const W=this.d.getDocument(j),_=i.Position.to(B),oe=await this.e.provideDeclaration(W,_,G);return v(oe)}}class E{constructor(j,B){this.d=j,this.e=B}async provideImplementation(j,B,G){const W=this.d.getDocument(j),_=i.Position.to(B),oe=await this.e.provideImplementation(W,_,G);return v(oe)}}class w{constructor(j,B){this.d=j,this.e=B}async provideTypeDefinition(j,B,G){const W=this.d.getDocument(j),_=i.Position.to(B),oe=await this.e.provideTypeDefinition(W,_,G);return v(oe)}}class I{constructor(j,B){this.d=j,this.e=B}async provideHover(j,B,G){const W=this.d.getDocument(j),_=i.Position.to(B),oe=await this.e.provideHover(W,_,G);if(!(!oe||(0,k.$Kb)(oe.contents)))return oe.range||(oe.range=W.getWordRangeAtPosition(_)),oe.range||(oe.range=new c.$wM(_,_)),i.Hover.from(oe)}}class S{constructor(j,B){this.d=j,this.e=B}async provideEvaluatableExpression(j,B,G){const W=this.d.getDocument(j),_=i.Position.to(B),oe=await this.e.provideEvaluatableExpression(W,_,G);if(oe)return i.EvaluatableExpression.from(oe)}}class P{constructor(j,B){this.d=j,this.e=B}async provideInlineValues(j,B,G,W){const _=this.d.getDocument(j),oe=await this.e.provideInlineValues(_,i.Range.to(B),i.InlineValueContext.to(G),W);if(Array.isArray(oe))return oe.map(Fe=>i.InlineValue.from(Fe))}}class U{constructor(j,B){this.d=j,this.e=B}async provideDocumentHighlights(j,B,G){const W=this.d.getDocument(j),_=i.Position.to(B),oe=await this.e.provideDocumentHighlights(W,_,G);if(Array.isArray(oe))return oe.map(i.DocumentHighlight.from)}}class Q{constructor(j,B){this.d=j,this.e=B}async provideMultiDocumentHighlights(j,B,G,W){const _=this.d.getDocument(j),oe=G.map(Qe=>this.d.getDocument(Qe)),Fe=i.Position.to(B),Be=await this.e.provideMultiDocumentHighlights(_,Fe,oe,W);if(Array.isArray(Be))return Be.map(i.MultiDocumentHighlight.from)}}class H{constructor(j,B){this.d=j,this.e=B}async provideLinkedEditingRanges(j,B,G){const W=this.d.getDocument(j),_=i.Position.to(B),oe=await this.e.provideLinkedEditingRanges(W,_,G);if(oe&&Array.isArray(oe.ranges))return{ranges:(0,k.$Hb)(oe.ranges.map(i.Range.from)),wordPattern:oe.wordPattern}}}class L{constructor(j,B){this.d=j,this.e=B}async provideReferences(j,B,G,W){const _=this.d.getDocument(j),oe=i.Position.to(B),Fe=await this.e.provideReferences(_,oe,G,W);if(Array.isArray(Fe))return Fe.map(i.location.from)}}class R{constructor(j,B,G,W,_,oe,Fe){this.g=j,this.h=B,this.j=G,this.k=W,this.l=_,this.m=oe,this.n=Fe,this.e=new t.$xjc("CodeAction"),this.f=new Map}async provideCodeActions(j,B,G,W){const _=this.g.getDocument(j),oe=$.$ft.isISelection(B)?i.Selection.to(B):i.Range.to(B),Fe=[];for(const st of this.j.getDiagnostics(j))if(oe.intersection(st.range)&&Fe.push(st)>R.d)break;const Be={diagnostics:Fe,only:G.only?new c.$PM(G.only):void 0,triggerKind:i.CodeActionTriggerKind.to(G.trigger)},Qe=await this.k.provideCodeActions(_,oe,Be,W);if(!(0,k.$Lb)(Qe)||W.isCancellationRequested)return;const et=this.e.add(Qe),it=new m.$Tc;this.f.set(et,it);const ut=[];for(let st=0;st<Qe.length;st++){const rt=Qe[st];if(rt)if(R.o(rt))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),ut.push({_isSynthetic:!0,title:rt.title,command:this.h.toInternal(rt,it)});else{Be.only&&(rt.kind?Be.only.contains(rt.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Be.only.value} 'requested but returned code action is of kind '${rt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Be.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const ot=rt.ranges??[];ut.push({cacheId:[et,st],title:rt.title,command:rt.command&&this.h.toInternal(rt.command,it),diagnostics:rt.diagnostics&&rt.diagnostics.map(i.Diagnostic.from),edit:rt.edit&&i.WorkspaceEdit.from(rt.edit,void 0),kind:rt.kind&&rt.kind.value,isPreferred:rt.isPreferred,isAI:(0,h.$cG)(this.m,"codeActionAI")?rt.isAI:!1,ranges:(0,h.$cG)(this.m,"codeActionRanges")?(0,k.$Hb)(ot.map(i.Range.from)):void 0,disabled:rt.disabled?.reason})}}return{cacheId:et,actions:ut}}async resolveCodeAction(j,B){const[G,W]=j,_=this.e.get(G,W);if(!_||R.o(_))return{};if(!this.k.resolveCodeAction)return{};const oe=await this.k.resolveCodeAction(_,B)??_;let Fe;oe.edit&&(Fe=i.WorkspaceEdit.from(oe.edit,void 0));let Be;if(oe.command){const Qe=this.f.get(G);Qe&&(Be=this.h.toInternal(oe.command,Qe))}return{edit:Fe,command:Be}}releaseCodeActions(j){this.f.get(j)?.dispose(),this.f.delete(j),this.e.delete(j)}static o(j){return typeof j.command=="string"&&typeof j.title=="string"}}R.d=1e3;class F{constructor(j,B,G,W,_){this.e=j,this.f=B,this.g=G,this.h=W,this.j=_,this.d=new t.$xjc("DocumentPasteEdit")}async prepareDocumentPaste(j,B,G,W){if(!this.g.prepareDocumentPaste)return;const _=this.f.getDocument(j),oe=B.map(Qe=>i.Range.to(Qe)),Fe=i.DataTransfer.toDataTransfer(G,()=>{throw new N.$$});if(await this.g.prepareDocumentPaste(_,oe,Fe,W),W.isCancellationRequested)return;const Be=Array.from(Fe).filter(([,Qe])=>!(Qe instanceof c.$jN));return i.DataTransfer.from(Be)}async providePasteEdits(j,B,G,W,_,oe){if(!this.g.provideDocumentPasteEdits)return[];const Fe=this.f.getDocument(B),Be=G.map(ut=>i.Range.to(ut)),Qe=i.DataTransfer.toDataTransfer(W,async ut=>(await this.e.$resolvePasteFileData(this.h,j,ut)).buffer),et=await this.g.provideDocumentPasteEdits(Fe,Be,Qe,{only:_.only?new c.$oN(_.only):void 0,triggerKind:_.triggerKind},oe);if(!et||oe.isCancellationRequested)return[];const it=this.d.add(et);return et.map((ut,st)=>({_cacheId:[it,st],title:ut.title??(0,s.localize)(0,null,this.j.displayName||this.j.name),kind:ut.kind,yieldTo:ut.yieldTo?.map(rt=>rt.value),insertText:typeof ut.insertText=="string"?ut.insertText:{snippet:ut.insertText.value},additionalEdit:ut.additionalEdit?i.WorkspaceEdit.from(ut.additionalEdit,void 0):void 0}))}async resolvePasteEdit(j,B){const[G,W]=j,_=this.d.get(G,W);if(!_||!this.g.resolveDocumentPasteEdit)return{};const oe=await this.g.resolveDocumentPasteEdit(_,B)??_;return{additionalEdit:oe.additionalEdit?i.WorkspaceEdit.from(oe.additionalEdit,void 0):void 0}}releasePasteEdits(j){this.d.delete(j)}}class T{constructor(j,B){this.d=j,this.e=B}async provideDocumentFormattingEdits(j,B,G){const W=this.d.getDocument(j),_=await this.e.provideDocumentFormattingEdits(W,B,G);if(Array.isArray(_))return _.map(i.TextEdit.from)}}class X{constructor(j,B){this.d=j,this.e=B}async provideDocumentRangeFormattingEdits(j,B,G,W){const _=this.d.getDocument(j),oe=i.Range.to(B),Fe=await this.e.provideDocumentRangeFormattingEdits(_,oe,G,W);if(Array.isArray(Fe))return Fe.map(i.TextEdit.from)}async provideDocumentRangesFormattingEdits(j,B,G,W){(0,D.$6f)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const _=this.d.getDocument(j),oe=B.map(i.Range.to),Fe=await this.e.provideDocumentRangesFormattingEdits(_,oe,G,W);if(Array.isArray(Fe))return Fe.map(i.TextEdit.from)}}class re{constructor(j,B){this.d=j,this.e=B,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(j,B,G,W,_){const oe=this.d.getDocument(j),Fe=i.Position.to(B),Be=await this.e.provideOnTypeFormattingEdits(oe,Fe,G,W,_);if(Array.isArray(Be))return Be.map(i.TextEdit.from)}}class me{constructor(j,B){this.e=j,this.f=B,this.d=new t.$xjc("WorkspaceSymbols")}async provideWorkspaceSymbols(j,B){const G=await this.e.provideWorkspaceSymbols(j,B);if(!(0,k.$Lb)(G))return{symbols:[]};const W=this.d.add(G),_={cacheId:W,symbols:[]};for(let oe=0;oe<G.length;oe++){const Fe=G[oe];if(!Fe||!Fe.name){this.f.warn("INVALID SymbolInformation",Fe);continue}_.symbols.push({...i.WorkspaceSymbol.from(Fe),cacheId:[W,oe]})}return _}async resolveWorkspaceSymbol(j,B){if(typeof this.e.resolveWorkspaceSymbol!="function"||!j.cacheId)return j;const G=this.d.get(...j.cacheId);if(G){const W=await this.e.resolveWorkspaceSymbol(G,B);return W&&(0,d.$Sn)(j,i.WorkspaceSymbol.from(W),!0)}}releaseWorkspaceSymbols(j){this.d.delete(j)}}class pe{static supportsResolving(j){return typeof j.prepareRename=="function"}constructor(j,B,G){this.d=j,this.e=B,this.f=G}async provideRenameEdits(j,B,G,W){const _=this.d.getDocument(j),oe=i.Position.to(B);try{const Fe=await this.e.provideRenameEdits(_,oe,G,W);return Fe?i.WorkspaceEdit.from(Fe):void 0}catch(Fe){const Be=pe.g(Fe);return Be?{rejectReason:Be,edits:void 0}:Promise.reject(Fe)}}async resolveRenameLocation(j,B,G){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const W=this.d.getDocument(j),_=i.Position.to(B);try{const oe=await this.e.prepareRename(W,_,G);let Fe,Be;if(c.$wM.isRange(oe)?(Fe=oe,Be=W.getText(oe)):(0,D.$Xf)(oe)&&(Fe=oe.range,Be=oe.placeholder),!Fe||!Be)return;if(Fe.start.line>_.line||Fe.end.line<_.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:i.Range.from(Fe),text:Be}}catch(oe){const Fe=pe.g(oe);return Fe?{rejectReason:Fe,range:void 0,text:void 0}:Promise.reject(oe)}}static g(j){return typeof j=="string"?j:j instanceof Error&&typeof j.message=="string"?j.message:void 0}}class ae{constructor(j,B,G){this.d=j,this.e=B,this.f=G}async provideNewSymbolNames(j,B,G){const W=this.d.getDocument(j),_=i.Range.to(B);try{const oe=await this.e.provideNewSymbolNames(W,_,G);return oe?oe.map(Fe=>typeof Fe=="string"?{newSymbolName:Fe}:{newSymbolName:Fe.newSymbolName,tags:Fe.tags}):void 0}catch(oe){this.f.error(ae.g(oe)??JSON.stringify(oe,null,"	"));return}}static g(j){return typeof j=="string"?j:j instanceof Error&&typeof j.message=="string"?j.message:void 0}}class be{constructor(j,B){this.resultId=j,this.tokens=B}}class se{constructor(j,B){this.f=j,this.g=B,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(j,B,G){const W=this.f.getDocument(j),_=B!==0?this.d.get(B):null;let oe=typeof _?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(W,_.resultId,G):await this.g.provideDocumentSemanticTokens(W,G);return _&&this.d.delete(B),oe?(oe=se.h(oe),this.o(se.n(_,oe),oe)):null}async releaseDocumentSemanticColoring(j){this.d.delete(j)}static h(j){return se.j(j)?se.k(j)?j:new c.$ON(new Uint32Array(j.data),j.resultId):se.l(j)?se.m(j)?j:new c.$QN(j.edits.map(B=>new c.$PN(B.start,B.deleteCount,B.data?new Uint32Array(B.data):B.data)),j.resultId):j}static j(j){return j&&!!j.data}static k(j){return j.data instanceof Uint32Array}static l(j){return j&&Array.isArray(j.edits)}static m(j){for(const B of j.edits)if(!(B.data instanceof Uint32Array))return!1;return!0}static n(j,B){if(!se.j(B)||!j||!j.tokens)return B;const G=j.tokens,W=G.length,_=B.data,oe=_.length;let Fe=0;const Be=Math.min(W,oe);for(;Fe<Be&&G[Fe]===_[Fe];)Fe++;if(Fe===W&&Fe===oe)return new c.$QN([],B.resultId);let Qe=0;const et=Be-Fe;for(;Qe<et&&G[W-Qe-1]===_[oe-Qe-1];)Qe++;return new c.$QN([{start:Fe,deleteCount:W-Fe-Qe,data:_.subarray(Fe,oe-Qe)}],B.resultId)}o(j,B){if(se.j(j)){const G=this.e++;return this.d.set(G,new be(j.resultId,j.data)),(0,o.$Xab)({id:G,type:"full",data:j.data})}if(se.l(j)){const G=this.e++;return se.j(B)?this.d.set(G,new be(B.resultId,B.data)):this.d.set(G,new be(j.resultId)),(0,o.$Xab)({id:G,type:"delta",deltas:(j.edits||[]).map(W=>({start:W.start,deleteCount:W.deleteCount,data:W.data}))})}return null}}class De{constructor(j,B){this.d=j,this.e=B}async provideDocumentRangeSemanticTokens(j,B,G){const W=this.d.getDocument(j),_=await this.e.provideDocumentRangeSemanticTokens(W,i.Range.to(B),G);return _?this.f(_):null}f(j){return(0,o.$Xab)({id:0,type:"full",data:j.data})}}class Oe{static supportsResolving(j){return typeof j.resolveCompletionItem=="function"}constructor(j,B,G,W,_){this.f=j,this.g=B,this.h=G,this.j=W,this.k=_,this.d=new t.$xjc("CompletionItem"),this.e=new Map}async provideCompletionItems(j,B,G,W){const _=this.f.getDocument(j),oe=i.Position.to(B),Fe=_.getWordRangeAtPosition(oe)||new c.$wM(oe,oe),Be=Fe.with({end:oe}),Qe=new y.$3d,et=await this.h.provideCompletionItems(_,oe,W,i.CompletionContext.to(G));if(!et||W.isCancellationRequested)return;const it=Array.isArray(et)?new c.$3M(et):et,ut=Oe.supportsResolving(this.h)?this.d.add(it.items):this.d.add([]),st=new m.$Tc;this.e.set(ut,st);const rt=[],ot={x:ut,b:rt,a:{replace:i.Range.from(Fe),insert:i.Range.from(Be)},c:it.isIncomplete||void 0,d:Qe.elapsed()};for(let $t=0;$t<it.items.length;$t++){const Ue=it.items[$t],ct=this.l(Ue,[ut,$t],Be,Fe);rt.push(ct)}return ot}async resolveCompletionItem(j,B){if(typeof this.h.resolveCompletionItem!="function")return;const G=this.d.get(...j);if(!G)return;const W=this.l(G,j),_=await this.h.resolveCompletionItem(G,B);if(!_)return;const oe=this.l(_,j);return(W.h!==oe.h||W.i!==oe.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(W.n!==oe.n||W.o!==oe.o||!(0,d.$Tn)(W.p,oe.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...W,d:oe.d,c:oe.c,l:oe.l,h:oe.h,i:oe.i,n:oe.n,o:oe.o,p:oe.p}}releaseCompletionItems(j){this.e.get(j)?.dispose(),this.e.delete(j),this.d.delete(j)}l(j,B,G,W){const _=this.e.get(B[0]);if(!_)throw Error("DisposableStore is missing...");const oe=this.g.toInternal(j.command,_),Fe={x:B,a:j.label,b:j.kind!==void 0?i.CompletionItemKind.from(j.kind):void 0,m:j.tags&&j.tags.map(i.CompletionItemTag.from),c:j.detail,d:typeof j.documentation>"u"?void 0:i.MarkdownString.fromStrict(j.documentation),e:j.sortText!==j.label?j.sortText:void 0,f:j.filterText!==j.label?j.filterText:void 0,g:j.preselect||void 0,i:j.keepWhitespace?1:0,k:j.commitCharacters?.join(""),l:j.additionalTextEdits&&j.additionalTextEdits.map(i.TextEdit.from),n:oe?.$ident,o:oe?.id,p:oe?.$ident?void 0:oe?.arguments};j.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Fe.h=j.textEdit.newText):typeof j.insertText=="string"?Fe.h=j.insertText:j.insertText instanceof c.$FM&&(Fe.h=j.insertText.value,Fe.i|=4);let Be;return j.textEdit?Be=j.textEdit.range:j.range&&(Be=j.range),c.$wM.isRange(Be)?Fe.j=i.Range.from(Be):Be&&(!G?.isEqual(Be.inserting)||!W?.isEqual(Be.replacing))&&(Fe.j={insert:i.Range.from(Be.inserting),replace:i.Range.from(Be.replacing)}),Fe}}class ie{async provideInlineCompletions(j,B,G,W){}disposeCompletions(j){}handleDidShowCompletionItem(j,B,G){}handlePartialAccept(j,B,G,W){}}class q extends ie{constructor(j,B,G,W){super(),this.f=j,this.g=B,this.h=G,this.j=W,this.d=new Ne,this.e=(0,h.$cG)(this.f,"inlineCompletionsAdditions"),this.k={[n.InlineCompletionTriggerKind.Automatic]:c.InlineCompletionTriggerKind.Automatic,[n.InlineCompletionTriggerKind.Explicit]:c.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,h.$cG)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(j,B,G,W){const _=this.g.getDocument(j),oe=i.Position.to(B),Fe=await this.h.provideInlineCompletionItems(_,oe,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:i.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[G.triggerKind]},W);if(!Fe||W.isCancellationRequested)return;const Be=Array.isArray(Fe)?Fe:Fe.items,Qe=this.e?Array.isArray(Fe)?[]:Fe.commands||[]:[],et=this.e&&!Array.isArray(Fe)?Fe.enableForwardStability:void 0;let it;return{pid:this.d.createReferenceId({dispose(){it?.dispose()},items:Be}),items:Be.map((st,rt)=>{let ot;st.command&&(it||(it=new m.$Tc),ot=this.j.toInternal(st.command,it));const $t=st.insertText;return{insertText:typeof $t=="string"?$t:{snippet:$t.value},filterText:st.filterText,range:st.range?i.Range.from(st.range):void 0,command:ot,idx:rt,completeBracketPairs:this.e?st.completeBracketPairs:!1}}),commands:Qe.map(st=>(it||(it=new m.$Tc),this.j.toInternal(st,it))),suppressSuggestions:!1,enableForwardStability:et}}disposeCompletions(j){this.d.disposeReferenceId(j)?.dispose()}handleDidShowCompletionItem(j,B,G){const W=this.d.get(j)?.items[B];W&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(W,G)}handlePartialAccept(j,B,G,W){const _=this.d.get(j)?.items[B];_&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(_,G),this.h.handleDidPartiallyAcceptCompletionItem(_,i.PartialAcceptInfo.to(W)))}}class de{async provideInlineEdits(j,B,G){const W=this.f.getDocument(j),_=await this.g.provideInlineEdit(W,{triggerKind:this.e[B.triggerKind]},G);if(!_||G.isCancellationRequested)return;let oe;const Fe=this.d.createReferenceId({dispose(){oe?.dispose()},item:_});let Be;_.accepted&&(oe||(oe=new m.$Tc),Be=this.h.toInternal(_.accepted,oe));let Qe;return _.rejected&&(oe||(oe=new m.$Tc),Qe=this.h.toInternal(_.rejected,oe)),{pid:Fe,text:_.text,range:i.Range.from(_.range),accepted:Be,rejected:Qe}}disposeEdit(j){this.d.disposeReferenceId(j)?.dispose()}constructor(j,B,G,W){this.f=B,this.g=G,this.h=W,this.d=new Ne,this.e={[n.InlineEditTriggerKind.Automatic]:c.InlineEditTriggerKind.Automatic,[n.InlineEditTriggerKind.Invoke]:c.InlineEditTriggerKind.Invoke}}}class Ne{constructor(){this.d=new Map,this.e=1}createReferenceId(j){const B=this.e++;return this.d.set(B,j),B}disposeReferenceId(j){const B=this.d.get(j);return this.d.delete(j),B}get(j){return this.d.get(j)}}class $e{constructor(j,B){this.e=j,this.f=B,this.d=new t.$xjc("SignatureHelp")}async provideSignatureHelp(j,B,G,W){const _=this.e.getDocument(j),oe=i.Position.to(B),Fe=this.g(G),Be=await this.f.provideSignatureHelp(_,oe,W,Fe);if(Be){const Qe=this.d.add([Be]);return{...i.SignatureHelp.from(Be),id:Qe}}}g(j){let B;if(j.activeSignatureHelp){const G=i.SignatureHelp.to(j.activeSignatureHelp),W=this.d.get(j.activeSignatureHelp.id,0);W?(B=W,B.activeSignature=G.activeSignature,B.activeParameter=G.activeParameter):B=G}return{...j,activeSignatureHelp:B}}releaseSignatureHelp(j){this.d.delete(j)}}class we{constructor(j,B,G,W,_){this.f=j,this.g=B,this.h=G,this.j=W,this.k=_,this.d=new t.$xjc("InlayHints"),this.e=new Map}async provideInlayHints(j,B,G){const W=this.f.getDocument(j),_=i.Range.to(B),oe=await this.h.provideInlayHints(W,_,G);if(!Array.isArray(oe)||oe.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(B)}`);return}if(G.isCancellationRequested)return;const Fe=this.d.add(oe);this.e.set(Fe,new m.$Tc);const Be={hints:[],cacheId:Fe};for(let Qe=0;Qe<oe.length;Qe++)this.l(oe[Qe],_)&&Be.hints.push(this.m(oe[Qe],[Fe,Qe]));return this.j.trace(`[InlayHints] ${Be.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(B)}`),Be}async resolveInlayHint(j,B){if(typeof this.h.resolveInlayHint!="function")return;const G=this.d.get(...j);if(!G)return;const W=await this.h.resolveInlayHint(G,B);if(W&&this.l(W))return this.m(W,j)}releaseHints(j){this.e.get(j)?.dispose(),this.e.delete(j),this.d.delete(j)}l(j,B){return j.label.length===0||Array.isArray(j.label)&&j.label.every(G=>G.value.length===0)?(console.log("INVALID inlay hint, empty label",j),!1):!(B&&!B.contains(j.position))}m(j,B){const G=this.e.get(B[0]);if(!G)throw Error("DisposableStore is missing...");const W={label:"",cacheId:B,tooltip:i.MarkdownString.fromStrict(j.tooltip),position:i.Position.from(j.position),textEdits:j.textEdits&&j.textEdits.map(i.TextEdit.from),kind:j.kind&&i.InlayHintKind.from(j.kind),paddingLeft:j.paddingLeft,paddingRight:j.paddingRight};if(typeof j.label=="string")W.label=j.label;else{const _=[];W.label=_;for(const oe of j.label){if(!oe.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Fe={label:oe.value,tooltip:i.MarkdownString.fromStrict(oe.tooltip)};c.$GM.isLocation(oe.location)&&(Fe.location=i.location.from(oe.location)),oe.command&&(Fe.command=this.g.toInternal(oe.command,G)),_.push(Fe)}}return W}}class ge{constructor(j,B){this.e=j,this.f=B,this.d=new t.$xjc("DocumentLink")}async provideLinks(j,B){const G=this.e.getDocument(j),W=await this.f.provideDocumentLinks(G,B);if(!(!Array.isArray(W)||W.length===0)&&!B.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:W.filter(ge.g).map(i.DocumentLink.from)};{const _=this.d.add(W),oe={links:[],cacheId:_};for(let Fe=0;Fe<W.length;Fe++){if(!ge.g(W[Fe]))continue;const Be=i.DocumentLink.from(W[Fe]);Be.cacheId=[_,Fe],oe.links.push(Be)}return oe}}}static g(j){return j.target&&j.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(j,B){if(typeof this.f.resolveDocumentLink!="function")return;const G=this.d.get(...j);if(!G)return;const W=await this.f.resolveDocumentLink(G,B);if(!(!W||!ge.g(W)))return i.DocumentLink.from(W)}releaseLinks(j){this.d.delete(j)}}class ce{constructor(j,B){this.d=j,this.e=B}async provideColors(j,B){const G=this.d.getDocument(j),W=await this.e.provideDocumentColors(G,B);return Array.isArray(W)?W.map(oe=>({color:i.Color.from(oe.color),range:i.Range.from(oe.range)})):[]}async provideColorPresentations(j,B,G){const W=this.d.getDocument(j),_=i.Range.to(B.range),oe=i.Color.to(B.color),Fe=await this.e.provideColorPresentations(oe,{document:W,range:_},G);if(Array.isArray(Fe))return Fe.map(i.ColorPresentation.from)}}class K{constructor(j,B){this.d=j,this.e=B}async provideFoldingRanges(j,B,G){const W=this.d.getDocument(j),_=await this.e.provideFoldingRanges(W,B,G);if(Array.isArray(_))return _.map(i.FoldingRange.from)}}class Z{constructor(j,B,G){this.d=j,this.e=B,this.f=G}async provideSelectionRanges(j,B,G){const W=this.d.getDocument(j),_=B.map(i.Position.to),oe=await this.e.provideSelectionRanges(W,_,G);if(!(0,k.$Lb)(oe))return[];if(oe.length!==_.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Fe=[];for(let Be=0;Be<_.length;Be++){const Qe=[];Fe.push(Qe);let et=_[Be],it=oe[Be];for(;;){if(!it.range.contains(et))throw new Error("INVALID selection range, must contain the previous range");if(Qe.push(i.SelectionRange.from(it)),!it.parent)break;et=it.range,it=it.parent}}return Fe}}class le{constructor(j,B){this.f=j,this.g=B,this.d=new A.$TO(""),this.e=new Map}async prepareSession(j,B,G){const W=this.f.getDocument(j),_=i.Position.to(B),oe=await this.g.prepareCallHierarchy(W,_,G);if(!oe)return;const Fe=this.d.nextId();return this.e.set(Fe,new Map),Array.isArray(oe)?oe.map(Be=>this.h(Fe,Be)):[this.h(Fe,oe)]}async provideCallsTo(j,B,G){const W=this.j(j,B);if(!W)throw new Error("missing call hierarchy item");const _=await this.g.provideCallHierarchyIncomingCalls(W,G);if(_)return _.map(oe=>({from:this.h(j,oe.from),fromRanges:oe.fromRanges.map(Fe=>i.Range.from(Fe))}))}async provideCallsFrom(j,B,G){const W=this.j(j,B);if(!W)throw new Error("missing call hierarchy item");const _=await this.g.provideCallHierarchyOutgoingCalls(W,G);if(_)return _.map(oe=>({to:this.h(j,oe.to),fromRanges:oe.fromRanges.map(Fe=>i.Range.from(Fe))}))}releaseSession(j){this.e.delete(j)}h(j,B){const G=this.e.get(j),W=i.CallHierarchyItem.from(B,j,G.size.toString(36));return G.set(W._itemId,B),W}j(j,B){return this.e.get(j)?.get(B)}}class fe{constructor(j,B){this.f=j,this.g=B,this.d=new A.$TO(""),this.e=new Map}async prepareSession(j,B,G){const W=this.f.getDocument(j),_=i.Position.to(B),oe=await this.g.prepareTypeHierarchy(W,_,G);if(!oe)return;const Fe=this.d.nextId();return this.e.set(Fe,new Map),Array.isArray(oe)?oe.map(Be=>this.h(Fe,Be)):[this.h(Fe,oe)]}async provideSupertypes(j,B,G){const W=this.j(j,B);if(!W)throw new Error("missing type hierarchy item");const _=await this.g.provideTypeHierarchySupertypes(W,G);if(_)return _.map(oe=>this.h(j,oe))}async provideSubtypes(j,B,G){const W=this.j(j,B);if(!W)throw new Error("missing type hierarchy item");const _=await this.g.provideTypeHierarchySubtypes(W,G);if(_)return _.map(oe=>this.h(j,oe))}releaseSession(j){this.e.delete(j)}h(j,B){const G=this.e.get(j),W=i.TypeHierarchyItem.from(B,j,G.size.toString(36));return G.set(W._itemId,B),W}j(j,B){return this.e.get(j)?.get(B)}}class Te{constructor(j,B,G,W,_){this.d=j,this.e=B,this.f=G,this.g=W,this.h=_}async provideDocumentOnDropEdits(j,B,G,W,_){const oe=this.e.getDocument(B),Fe=i.Position.to(G),Be=i.DataTransfer.toDataTransfer(W,async et=>(await this.d.$resolveDocumentOnDropFileData(this.g,j,et)).buffer),Qe=await this.f.provideDocumentDropEdits(oe,Fe,Be,_);if(Qe)return(0,k.$3b)(Qe).map(et=>({title:et.title??(0,s.localize)(1,null,this.h.displayName||this.h.name),kind:et.kind?.value,yieldTo:et.yieldTo?.map(it=>it.value),insertText:typeof et.insertText=="string"?et.insertText:{snippet:et.insertText.value},additionalEdit:et.additionalEdit?i.WorkspaceEdit.from(et.additionalEdit,void 0):void 0}))}}class ve{constructor(j,B){this.d=j,this.e=B}async provideMappedEdits(j,B,G,W){const _=l.URI.revive(j),oe=this.d.getDocument(_),Fe=G.documents.map(et=>et.map(it=>({uri:l.URI.revive(it.uri),version:it.version,ranges:it.ranges.map(ut=>i.Range.to(ut))}))),Be={documents:Fe,selections:Fe[0]?.[0]?.ranges??[]},Qe=await this.e.provideMappedEdits(oe,B,Be,W);return Qe?i.WorkspaceEdit.from(Qe):null}}class Ie{constructor(j,B){this.adapter=j,this.extension=B}}class Ae{constructor(j,B,G,W,_,oe,Fe,Be){this.g=B,this.h=G,this.j=W,this.k=_,this.l=oe,this.m=Fe,this.n=Be,this.f=new Map,this.e=j.getProxy(p.$sM.MainThreadLanguageFeatures)}o(j,B){return i.DocumentSelector.from(j,this.g,B)}p(j){return new c.$uM(()=>{this.f.delete(j),this.e.$unregister(j)})}q(){return Ae.d++}async s(j,B,G,W,_,oe=!1){const Fe=this.f.get(j);if(!Fe||!(Fe.adapter instanceof B))return W;const Be=Date.now();oe||this.l.trace(`[${Fe.extension.identifier.value}] INVOKE provider '${G.toString().replace(/[\r\n]/g,"")}'`);const Qe=G(Fe.adapter,Fe.extension);return Promise.resolve(Qe).catch(et=>{(0,N.$4)(et)||(this.l.error(`[${Fe.extension.identifier.value}] provider FAILED`),this.l.error(et),this.n.onExtensionError(Fe.extension.identifier,et))}).finally(()=>{oe||this.l.trace(`[${Fe.extension.identifier.value}] provider DONE after ${Date.now()-Be}ms`)}),C.CancellationToken.isCancellationToken(_)?(0,M.$0g)(Qe,_):Qe}t(j,B){const G=this.q();return this.f.set(G,new Ie(j,B)),G}static u(j){return j.displayName||j.name}registerDocumentSymbolProvider(j,B,G,W){const _=this.t(new a(this.h,G),j),oe=W&&W.label||Ae.u(j);return this.e.$registerDocumentSymbolProvider(_,this.o(B,j),oe),this.p(_)}$provideDocumentSymbols(j,B,G){return this.s(j,a,W=>W.provideDocumentSymbols(l.URI.revive(B),G),void 0,G)}registerCodeLensProvider(j,B,G){const W=this.q(),_=typeof G.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(W,new Ie(new g(this.h,this.j.converter,G,j,this.n,this.l),j)),this.e.$registerCodeLensSupport(W,this.o(B,j),_);let oe=this.p(W);if(_!==void 0){const Fe=G.onDidChangeCodeLenses(Be=>this.e.$emitCodeLensEvent(_));oe=c.$uM.from(oe,Fe)}return oe}$provideCodeLenses(j,B,G){return this.s(j,g,W=>W.provideCodeLenses(l.URI.revive(B),G),void 0,G)}$resolveCodeLens(j,B,G){return this.s(j,g,W=>W.resolveCodeLens(B,G),void 0,void 0)}$releaseCodeLenses(j,B){this.s(j,g,G=>Promise.resolve(G.releaseCodeLenses(B)),void 0,void 0)}registerDefinitionProvider(j,B,G){const W=this.t(new f(this.h,G),j);return this.e.$registerDefinitionSupport(W,this.o(B,j)),this.p(W)}$provideDefinition(j,B,G,W){return this.s(j,f,_=>_.provideDefinition(l.URI.revive(B),G,W),[],W)}registerDeclarationProvider(j,B,G){const W=this.t(new u(this.h,G),j);return this.e.$registerDeclarationSupport(W,this.o(B,j)),this.p(W)}$provideDeclaration(j,B,G,W){return this.s(j,u,_=>_.provideDeclaration(l.URI.revive(B),G,W),[],W)}registerImplementationProvider(j,B,G){const W=this.t(new E(this.h,G),j);return this.e.$registerImplementationSupport(W,this.o(B,j)),this.p(W)}$provideImplementation(j,B,G,W){return this.s(j,E,_=>_.provideImplementation(l.URI.revive(B),G,W),[],W)}registerTypeDefinitionProvider(j,B,G){const W=this.t(new w(this.h,G),j);return this.e.$registerTypeDefinitionSupport(W,this.o(B,j)),this.p(W)}$provideTypeDefinition(j,B,G,W){return this.s(j,w,_=>_.provideTypeDefinition(l.URI.revive(B),G,W),[],W)}registerHoverProvider(j,B,G,W){const _=this.t(new I(this.h,G),j);return this.e.$registerHoverProvider(_,this.o(B,j)),this.p(_)}$provideHover(j,B,G,W){return this.s(j,I,_=>_.provideHover(l.URI.revive(B),G,W),void 0,W)}registerEvaluatableExpressionProvider(j,B,G,W){const _=this.t(new S(this.h,G),j);return this.e.$registerEvaluatableExpressionProvider(_,this.o(B,j)),this.p(_)}$provideEvaluatableExpression(j,B,G,W){return this.s(j,S,_=>_.provideEvaluatableExpression(l.URI.revive(B),G,W),void 0,W)}registerInlineValuesProvider(j,B,G,W){const _=typeof G.onDidChangeInlineValues=="function"?this.q():void 0,oe=this.t(new P(this.h,G),j);this.e.$registerInlineValuesProvider(oe,this.o(B,j),_);let Fe=this.p(oe);if(_!==void 0){const Be=G.onDidChangeInlineValues(Qe=>this.e.$emitInlineValuesEvent(_));Fe=c.$uM.from(Fe,Be)}return Fe}$provideInlineValues(j,B,G,W,_){return this.s(j,P,oe=>oe.provideInlineValues(l.URI.revive(B),G,W,_),void 0,_)}registerDocumentHighlightProvider(j,B,G){const W=this.t(new U(this.h,G),j);return this.e.$registerDocumentHighlightProvider(W,this.o(B,j)),this.p(W)}registerMultiDocumentHighlightProvider(j,B,G){const W=this.t(new Q(this.h,G),j);return this.e.$registerMultiDocumentHighlightProvider(W,this.o(B,j)),this.p(W)}$provideDocumentHighlights(j,B,G,W){return this.s(j,U,_=>_.provideDocumentHighlights(l.URI.revive(B),G,W),void 0,W)}$provideMultiDocumentHighlights(j,B,G,W,_){return this.s(j,Q,oe=>oe.provideMultiDocumentHighlights(l.URI.revive(B),G,W.map(Fe=>l.URI.revive(Fe)),_),void 0,_)}registerLinkedEditingRangeProvider(j,B,G){const W=this.t(new H(this.h,G),j);return this.e.$registerLinkedEditingRangeProvider(W,this.o(B,j)),this.p(W)}$provideLinkedEditingRanges(j,B,G,W){return this.s(j,H,async _=>{const oe=await _.provideLinkedEditingRanges(l.URI.revive(B),G,W);if(oe)return{ranges:oe.ranges,wordPattern:oe.wordPattern?Ae.w(oe.wordPattern):void 0}},void 0,W)}registerReferenceProvider(j,B,G){const W=this.t(new L(this.h,G),j);return this.e.$registerReferenceSupport(W,this.o(B,j)),this.p(W)}$provideReferences(j,B,G,W,_){return this.s(j,L,oe=>oe.provideReferences(l.URI.revive(B),G,W,_),void 0,_)}registerCodeActionProvider(j,B,G,W){const _=new m.$Tc,oe=this.t(new R(this.h,this.j.converter,this.k,G,this.l,j,this.m),j);return this.e.$registerQuickFixSupport(oe,this.o(B,j),{providedKinds:W?.providedCodeActionKinds?.map(Fe=>Fe.value),documentation:W?.documentation?.map(Fe=>({kind:Fe.kind.value,command:this.j.converter.toInternal(Fe.command,_)}))},Ae.u(j),!!G.resolveCodeAction),_.add(this.p(oe)),_}$provideCodeActions(j,B,G,W,_){return this.s(j,R,oe=>oe.provideCodeActions(l.URI.revive(B),G,W,_),void 0,_)}$resolveCodeAction(j,B,G){return this.s(j,R,W=>W.resolveCodeAction(B,G),{},void 0)}$releaseCodeActions(j,B){this.s(j,R,G=>Promise.resolve(G.releaseCodeActions(B)),void 0,void 0)}registerDocumentFormattingEditProvider(j,B,G){const W=this.t(new T(this.h,G),j);return this.e.$registerDocumentFormattingSupport(W,this.o(B,j),j.identifier,j.displayName||j.name),this.p(W)}$provideDocumentFormattingEdits(j,B,G,W){return this.s(j,T,_=>_.provideDocumentFormattingEdits(l.URI.revive(B),G,W),void 0,W)}registerDocumentRangeFormattingEditProvider(j,B,G){const W=typeof G.provideDocumentRangesFormattingEdits=="function",_=this.t(new X(this.h,G),j);return this.e.$registerRangeFormattingSupport(_,this.o(B,j),j.identifier,j.displayName||j.name,W),this.p(_)}$provideDocumentRangeFormattingEdits(j,B,G,W,_){return this.s(j,X,oe=>oe.provideDocumentRangeFormattingEdits(l.URI.revive(B),G,W,_),void 0,_)}$provideDocumentRangesFormattingEdits(j,B,G,W,_){return this.s(j,X,oe=>oe.provideDocumentRangesFormattingEdits(l.URI.revive(B),G,W,_),void 0,_)}registerOnTypeFormattingEditProvider(j,B,G,W){const _=this.t(new re(this.h,G),j);return this.e.$registerOnTypeFormattingSupport(_,this.o(B,j),W,j.identifier),this.p(_)}$provideOnTypeFormattingEdits(j,B,G,W,_,oe){return this.s(j,re,Fe=>Fe.provideOnTypeFormattingEdits(l.URI.revive(B),G,W,_,oe),void 0,oe)}registerWorkspaceSymbolProvider(j,B){const G=this.t(new me(B,this.l),j);return this.e.$registerNavigateTypeSupport(G,typeof B.resolveWorkspaceSymbol=="function"),this.p(G)}$provideWorkspaceSymbols(j,B,G){return this.s(j,me,W=>W.provideWorkspaceSymbols(B,G),{symbols:[]},G)}$resolveWorkspaceSymbol(j,B,G){return this.s(j,me,W=>W.resolveWorkspaceSymbol(B,G),void 0,void 0)}$releaseWorkspaceSymbols(j,B){this.s(j,me,G=>G.releaseWorkspaceSymbols(B),void 0,void 0)}registerRenameProvider(j,B,G){const W=this.t(new pe(this.h,G,this.l),j);return this.e.$registerRenameSupport(W,this.o(B,j),pe.supportsResolving(G)),this.p(W)}$provideRenameEdits(j,B,G,W,_){return this.s(j,pe,oe=>oe.provideRenameEdits(l.URI.revive(B),G,W,_),void 0,_)}$resolveRenameLocation(j,B,G,W){return this.s(j,pe,_=>_.resolveRenameLocation(l.URI.revive(B),G,W),void 0,W)}registerNewSymbolNamesProvider(j,B,G){const W=this.t(new ae(this.h,G,this.l),j);return this.e.$registerNewSymbolNamesProvider(W,this.o(B,j)),this.p(W)}$provideNewSymbolNames(j,B,G,W){return this.s(j,ae,_=>_.provideNewSymbolNames(l.URI.revive(B),G,W),void 0,W)}registerDocumentSemanticTokensProvider(j,B,G,W){const _=this.t(new se(this.h,G),j),oe=typeof G.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(_,this.o(B,j),W,oe);let Fe=this.p(_);if(oe){const Be=G.onDidChangeSemanticTokens(Qe=>this.e.$emitDocumentSemanticTokensEvent(oe));Fe=c.$uM.from(Fe,Be)}return Fe}$provideDocumentSemanticTokens(j,B,G,W){return this.s(j,se,_=>_.provideDocumentSemanticTokens(l.URI.revive(B),G,W),null,W)}$releaseDocumentSemanticTokens(j,B){this.s(j,se,G=>G.releaseDocumentSemanticColoring(B),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(j,B,G,W){const _=this.t(new De(this.h,G),j);return this.e.$registerDocumentRangeSemanticTokensProvider(_,this.o(B,j),W),this.p(_)}$provideDocumentRangeSemanticTokens(j,B,G,W){return this.s(j,De,_=>_.provideDocumentRangeSemanticTokens(l.URI.revive(B),G,W),null,W)}registerCompletionItemProvider(j,B,G,W){const _=this.t(new Oe(this.h,this.j.converter,G,this.m,j),j);return this.e.$registerCompletionsProvider(_,this.o(B,j),W,Oe.supportsResolving(G),j.identifier),this.p(_)}$provideCompletionItems(j,B,G,W,_){return this.s(j,Oe,oe=>oe.provideCompletionItems(l.URI.revive(B),G,W,_),void 0,_)}$resolveCompletionItem(j,B,G){return this.s(j,Oe,W=>W.resolveCompletionItem(B,G),void 0,G)}$releaseCompletionItems(j,B){this.s(j,Oe,G=>G.releaseCompletionItems(B),void 0,void 0)}registerInlineCompletionsProvider(j,B,G,W){const _=new q(j,this.h,G,this.j.converter),oe=this.t(_,j);return this.e.$registerInlineCompletionsSupport(oe,this.o(B,j),_.supportsHandleEvents,r.$Em.toKey(j.identifier.value),W?.yieldTo?.map(Fe=>r.$Em.toKey(Fe))||[]),this.p(oe)}$provideInlineCompletions(j,B,G,W,_){return this.s(j,ie,oe=>oe.provideInlineCompletions(l.URI.revive(B),G,W,_),void 0,_)}$handleInlineCompletionDidShow(j,B,G,W){this.s(j,ie,async _=>{_.handleDidShowCompletionItem(B,G,W)},void 0,void 0)}$handleInlineCompletionPartialAccept(j,B,G,W,_){this.s(j,ie,async oe=>{oe.handlePartialAccept(B,G,W,_)},void 0,void 0)}$freeInlineCompletionsList(j,B){this.s(j,ie,async G=>{G.disposeCompletions(B)},void 0,void 0)}registerInlineEditProvider(j,B,G){const W=new de(j,this.h,G,this.j.converter),_=this.t(W,j);return this.e.$registerInlineEditProvider(_,this.o(B,j),j.identifier),this.p(_)}$provideInlineEdit(j,B,G,W){return this.s(j,de,_=>_.provideInlineEdits(l.URI.revive(B),G,W),void 0,W)}$freeInlineEdit(j,B){this.s(j,de,async G=>{G.disposeEdit(B)},void 0,void 0)}registerSignatureHelpProvider(j,B,G,W){const _=Array.isArray(W)?{triggerCharacters:W,retriggerCharacters:[]}:W,oe=this.t(new $e(this.h,G),j);return this.e.$registerSignatureHelpProvider(oe,this.o(B,j),_),this.p(oe)}$provideSignatureHelp(j,B,G,W,_){return this.s(j,$e,oe=>oe.provideSignatureHelp(l.URI.revive(B),G,W,_),void 0,_)}$releaseSignatureHelp(j,B){this.s(j,$e,G=>G.releaseSignatureHelp(B),void 0,void 0)}registerInlayHintsProvider(j,B,G){const W=typeof G.onDidChangeInlayHints=="function"?this.q():void 0,_=this.t(new we(this.h,this.j.converter,G,this.l,j),j);this.e.$registerInlayHintsProvider(_,this.o(B,j),typeof G.resolveInlayHint=="function",W,Ae.u(j));let oe=this.p(_);if(W!==void 0){const Fe=G.onDidChangeInlayHints(Be=>this.e.$emitInlayHintsEvent(W));oe=c.$uM.from(oe,Fe)}return oe}$provideInlayHints(j,B,G,W){return this.s(j,we,_=>_.provideInlayHints(l.URI.revive(B),G,W),void 0,W)}$resolveInlayHint(j,B,G){return this.s(j,we,W=>W.resolveInlayHint(B,G),void 0,G)}$releaseInlayHints(j,B){this.s(j,we,G=>G.releaseHints(B),void 0,void 0)}registerDocumentLinkProvider(j,B,G){const W=this.t(new ge(this.h,G),j);return this.e.$registerDocumentLinkProvider(W,this.o(B,j),typeof G.resolveDocumentLink=="function"),this.p(W)}$provideDocumentLinks(j,B,G){return this.s(j,ge,W=>W.provideLinks(l.URI.revive(B),G),void 0,G,B.scheme==="output")}$resolveDocumentLink(j,B,G){return this.s(j,ge,W=>W.resolveLink(B,G),void 0,void 0,!0)}$releaseDocumentLinks(j,B){this.s(j,ge,G=>G.releaseLinks(B),void 0,void 0,!0)}registerColorProvider(j,B,G){const W=this.t(new ce(this.h,G),j);return this.e.$registerDocumentColorProvider(W,this.o(B,j)),this.p(W)}$provideDocumentColors(j,B,G){return this.s(j,ce,W=>W.provideColors(l.URI.revive(B),G),[],G)}$provideColorPresentations(j,B,G,W){return this.s(j,ce,_=>_.provideColorPresentations(l.URI.revive(B),G,W),void 0,W)}registerFoldingRangeProvider(j,B,G){const W=this.q(),_=typeof G.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(W,new Ie(new K(this.h,G),j)),this.e.$registerFoldingRangeProvider(W,this.o(B,j),j.identifier,_);let oe=this.p(W);if(_!==void 0){const Fe=G.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(_));oe=c.$uM.from(oe,Fe)}return oe}$provideFoldingRanges(j,B,G,W){return this.s(j,K,_=>_.provideFoldingRanges(l.URI.revive(B),G,W),void 0,W)}registerSelectionRangeProvider(j,B,G){const W=this.t(new Z(this.h,G,this.l),j);return this.e.$registerSelectionRangeProvider(W,this.o(B,j)),this.p(W)}$provideSelectionRanges(j,B,G,W){return this.s(j,Z,_=>_.provideSelectionRanges(l.URI.revive(B),G,W),[],W)}registerCallHierarchyProvider(j,B,G){const W=this.t(new le(this.h,G),j);return this.e.$registerCallHierarchyProvider(W,this.o(B,j)),this.p(W)}$prepareCallHierarchy(j,B,G,W){return this.s(j,le,_=>Promise.resolve(_.prepareSession(l.URI.revive(B),G,W)),void 0,W)}$provideCallHierarchyIncomingCalls(j,B,G,W){return this.s(j,le,_=>_.provideCallsTo(B,G,W),void 0,W)}$provideCallHierarchyOutgoingCalls(j,B,G,W){return this.s(j,le,_=>_.provideCallsFrom(B,G,W),void 0,W)}$releaseCallHierarchy(j,B){this.s(j,le,G=>Promise.resolve(G.releaseSession(B)),void 0,void 0)}registerTypeHierarchyProvider(j,B,G){const W=this.t(new fe(this.h,G),j);return this.e.$registerTypeHierarchyProvider(W,this.o(B,j)),this.p(W)}$prepareTypeHierarchy(j,B,G,W){return this.s(j,fe,_=>Promise.resolve(_.prepareSession(l.URI.revive(B),G,W)),void 0,W)}$provideTypeHierarchySupertypes(j,B,G,W){return this.s(j,fe,_=>_.provideSupertypes(B,G,W),void 0,W)}$provideTypeHierarchySubtypes(j,B,G,W){return this.s(j,fe,_=>_.provideSubtypes(B,G,W),void 0,W)}$releaseTypeHierarchy(j,B){this.s(j,fe,G=>Promise.resolve(G.releaseSession(B)),void 0,void 0)}registerDocumentOnDropEditProvider(j,B,G,W){const _=this.q();return this.f.set(_,new Ie(new Te(this.e,this.h,G,_,j),j)),this.e.$registerDocumentOnDropEditProvider(_,this.o(B,j),(0,h.$cG)(j,"dropMetadata")?W:void 0),this.p(_)}$provideDocumentOnDropEdits(j,B,G,W,_,oe){return this.s(j,Te,Fe=>Promise.resolve(Fe.provideDocumentOnDropEdits(B,l.URI.revive(G),W,_,oe)),void 0,void 0)}registerMappedEditsProvider(j,B,G){const W=this.t(new ve(this.h,G),j);return this.e.$registerMappedEditsProvider(W,this.o(B,j)),this.p(W)}$provideMappedEdits(j,B,G,W,_){return this.s(j,ve,oe=>Promise.resolve(oe.provideMappedEdits(B,G,W,_)),null,_)}registerDocumentPasteEditProvider(j,B,G,W){const _=this.q();return this.f.set(_,new Ie(new F(this.e,this.h,G,_,j),j)),this.e.$registerPasteEditProvider(_,this.o(B,j),{supportsCopy:!!G.prepareDocumentPaste,supportsPaste:!!G.provideDocumentPasteEdits,supportsResolve:!!G.resolveDocumentPasteEdit,providedPasteEditKinds:W.providedPasteEditKinds?.map(oe=>oe.value),copyMimeTypes:W.copyMimeTypes,pasteMimeTypes:W.pasteMimeTypes}),this.p(_)}$prepareDocumentPaste(j,B,G,W,_){return this.s(j,F,oe=>oe.prepareDocumentPaste(l.URI.revive(B),G,W,_),void 0,_)}$providePasteEdits(j,B,G,W,_,oe,Fe){return this.s(j,F,Be=>Be.providePasteEdits(B,l.URI.revive(G),W,_,oe,Fe),void 0,Fe)}$resolvePasteEdit(j,B,G){return this.s(j,F,W=>W.resolvePasteEdit(B,G),{},void 0)}$releasePasteEdits(j,B){this.s(j,F,G=>Promise.resolve(G.releasePasteEdits(B)),void 0,void 0)}static w(j){return{pattern:j.source,flags:j.flags}}static y(j){return{decreaseIndentPattern:Ae.w(j.decreaseIndentPattern),increaseIndentPattern:Ae.w(j.increaseIndentPattern),indentNextLinePattern:j.indentNextLinePattern?Ae.w(j.indentNextLinePattern):void 0,unIndentedLinePattern:j.unIndentedLinePattern?Ae.w(j.unIndentedLinePattern):void 0}}static z(j){return{beforeText:Ae.w(j.beforeText),afterText:j.afterText?Ae.w(j.afterText):void 0,previousLineText:j.previousLineText?Ae.w(j.previousLineText):void 0,action:j.action}}static B(j){return j.map(Ae.z)}static C(j){return{open:j.open,close:j.close,notIn:j.notIn?j.notIn.map(B=>c.SyntaxTokenType.toString(B)):void 0}}static D(j){return j.map(Ae.C)}setLanguageConfiguration(j,B,G){const{wordPattern:W}=G;if(W&&(0,O.$0e)(W))throw new Error(`Invalid language configuration: wordPattern '${W}' is not allowed to match the empty string.`);W?this.h.setWordDefinitionFor(B,W):this.h.setWordDefinitionFor(B,void 0),G.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",j,"Do not use."),G.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",j,"Do not use.");const _=this.q(),oe={comments:G.comments,brackets:G.brackets,wordPattern:G.wordPattern?Ae.w(G.wordPattern):void 0,indentationRules:G.indentationRules?Ae.y(G.indentationRules):void 0,onEnterRules:G.onEnterRules?Ae.B(G.onEnterRules):void 0,__electricCharacterSupport:G.__electricCharacterSupport,__characterPairSupport:G.__characterPairSupport,autoClosingPairs:G.autoClosingPairs?Ae.D(G.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(_,B,oe),this.p(_)}$setWordDefinitions(j){for(const B of j)this.h.setWordDefinitionFor(B.languageId,new RegExp(B.regexSource,B.regexFlags))}}e.$Hjc=Ae,Ae.d=0}),define(Pe[88],Re([1,0,6,4,8,7,101,20,11,5,167,106,14,3,16,84,13]),function(ee,e,k,M,C,N,A,m,d,y,O,D,l,b,$,n,o){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.$Pjc=e.$Ojc=void 0,e.$Ojc=(0,b.$ii)("IExtHostLanguageModels");class r{constructor(t,p){this.option=t,this.stream=new d.$Lh,this.stream=p??new d.$Lh}}class i{constructor(){this.a=new Map,this.b=new d.$Lh,this.c=!1,this.d=!1;const t=this;this.apiObject={stream:t.b.asyncIterable}}*f(){if(this.a.size>0)for(const[,t]of this.a)yield t.stream;else yield this.b}handleFragment(t){if(this.c)return;this.d=!0;let p=this.a.get(t.index);p||(this.a.size===0?p=new r(t.index,this.b):p=new r(t.index),this.a.set(t.index,p)),p.stream.emitOne(t.part)}get isStreaming(){return this.d}reject(t){this.c=!0;for(const p of this.f())p.reject(t)}resolve(){this.c=!0;for(const t of this.f())t.resolve()}}let c=s=class{constructor(t,p,a){this.j=p,this.k=a,this.c=new y.$7d,this.d=new y.$7d,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new m.$Gm,this.i=new Map,this.o=new Set,this.b=t.getProxy(M.$sM.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(t,p,a,g){const v=s.a++;this.f.set(v,{extension:t.identifier,provider:a,languageModelId:p});let f;return g.auth&&(f={providerLabel:t.displayName||t.name,accountLabel:typeof g.auth=="object"?g.auth.label:void 0}),this.b.$registerLanguageModelProvider(v,p,{extension:t.identifier,identifier:p,model:g.name??"",auth:f}),(0,k.$Sc)(()=>{this.f.delete(v),this.b.$unregisterProvider(v)})}async $provideLanguageModelResponse(t,p,a,g,v,f){const u=this.f.get(t);if(!u)return;const E=new A.$Sv(async w=>{if(f.isCancellationRequested){this.j.warn(`[CHAT](${u.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(p,{index:w.index,part:w.part})});return u.provider.provideLanguageModelResponse2(g.map(C.LanguageModelMessage.to),v,m.$Em.toKey(a),E,f)}$updateLanguageModels(t){const p=[],a=[];if(t.added)for(const g of t.added)this.g.set(g.identifier,g),p.push(g.model);if(t.removed)for(const g of t.removed){this.g.delete(g),a.push(g);for(const[v,f]of this.i)f.languageModelId===g&&(f.res.reject(new l.$5),this.i.delete(v))}this.d.fire(Object.freeze({added:Object.freeze(p),removed:Object.freeze(a)})),t.added?.forEach(this.n,this)}getLanguageModelIds(){return Array.from(this.g.keys())}$updateModelAccesslist(t){const p=new Array;for(const{from:a,to:g,enabled:v}of t){const f=this.h.get(a)??new m.$Fm;if(f.has(g)!==v){v?f.add(g):f.delete(g),this.h.set(a,f);const E={from:a,to:g};p.push(E),this.c.fire(E)}}}async sendChatRequest(t,p,a,g,v){const f=t.identifier,u=await this.b.$prepareChatAccess(f,p,g.justification);if(!u||!this.g.has(p))throw N.$BO.NotFound(`Language model '${p}' is unknown.`);if(this.m(f,u)&&(!await this.l(t,{identifier:u.extension,displayName:u.auth.providerLabel},g.justification,g.silent)||!this.h.get(f)?.has(u.extension)))throw N.$BO.NoPermissions(`Language model '${p}' cannot be used by '${f.value}'.`);const E=Math.random()*1e6|0,w=this.b.$fetchResponse(f,p,E,a.map(C.LanguageModelMessage.from),g.modelOptions??{},v),I=new d.$hh,S=new i;this.i.set(E,{languageModelId:p,res:S});let P;if(w.catch(U=>{I.isOpen()?S.reject(U):P=U}).finally(()=>{this.i.delete(E),S.resolve(),I.open()}),await I.wait(),P)throw new N.$BO(`Language model '${p}' errored, check cause for more details`,"Unknown",P);return S.apiObject}async $handleResponseFragment(t,p){const a=this.i.get(t);a&&a.res.handleFragment(p)}async l(t,p,a,g){const v=D.$uL+p.identifier.value;if(await this.k.getSession(t,v,[],{silent:!0}))return this.$updateModelAccesslist([{from:t.identifier,to:p.identifier,enabled:!0}]),!0;if(g)return!1;try{const u=a?(0,O.localize)(0,null,p.displayName,a):(0,O.localize)(1,null,p.displayName);return await this.k.getSession(t,v,[],{forceNewSession:{detail:u}}),this.$updateModelAccesslist([{from:t.identifier,to:p.identifier,enabled:!0}]),!0}catch{return!1}}m(t,p){return!!p.auth&&!m.$Em.equals(p.extension,t)}async n(t){for(const p of this.o)try{await this.l(p,{identifier:t.extension,displayName:""},void 0,!0)}catch(a){this.j.error("Fake Auth request failed"),this.j.error(a)}}createLanguageModelAccessInformation(t){this.o.add(t);const p=this,a=y.Event.signal(y.Event.filter(this.c.event,v=>m.$Em.equals(v.from,t.identifier))),g=y.Event.signal(this.d.event);return{get onDidChange(){return y.Event.any(a,g)},canSendRequest(v){const f=p.g.get(v);if(!f)return;if(!p.m(t.identifier,f))return!0;const u=p.h.get(t.identifier);if(u)return u.has(f.extension)}}}};e.$Pjc=c,c.a=1,e.$Pjc=c=s=Xe([qe(0,$.$OO),qe(1,o.$Oj),qe(2,n.$Jjc)],c)}),define(Pe[264],Re([1,0,4,8,7,32,11,6,25]),function(ee,e,k,M,C,N,A,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9kc=void 0;class y{constructor(D,l,b,$){this.c=l,this.d=b,this.e=$,this.b=[],this.f=0,this.g=new Set,this.a=D.getProxy(k.$sM.MainThreadLanguages)}$acceptLanguageIds(D){this.b=D}async getLanguages(){return this.b.slice(0)}async changeLanguage(D,l){await this.a.$changeLanguage(D,l);const b=this.c.getDocumentData(D);if(!b)throw new Error(`document '${D.toString()}' NOT found`);return b.document}async tokenAtPosition(D,l){const b=D.version,$=M.Position.from(l),n=await this.a.$tokensAtPosition(D.uri,$),o={type:C.StandardTokenType.Other,range:D.getWordRangeAtPosition(l)??new C.$wM(l.line,l.character,l.line,l.character)};if(!n)return o;const s={range:M.Range.to(n.range),type:M.TokenType.to(n.type)};return!s.range.contains(l)||b!==D.version?o:s}createLanguageStatusItem(D,l,b){const $=this.f++,n=this.a,o=this.g,s=`${D.identifier.value}/${l}`;if(o.has(s))throw new Error(`LanguageStatusItem with id '${l}' ALREADY exists`);o.add(s);const r={selector:b,id:l,name:D.displayName??D.name,severity:C.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let i;const c=new m.$Tc,h=()=>{if(i?.dispose(),!o.has(s)){console.warn(`LanguageStatusItem (${l}) from ${D.identifier.value} has been disposed and CANNOT be updated anymore`);return}i=(0,A.$kh)(()=>{c.clear(),this.a.$setLanguageStatus($,{id:s,name:r.name??D.displayName??D.name,source:D.displayName??D.name,selector:M.DocumentSelector.from(r.selector,this.e),label:r.text,detail:r.detail??"",severity:r.severity===C.LanguageStatusSeverity.Error?N.default.Error:r.severity===C.LanguageStatusSeverity.Warning?N.default.Warning:N.default.Info,command:r.command&&this.d.toInternal(r.command,c),accessibilityInfo:r.accessibilityInformation,busy:r.busy})},0)},t={dispose(){c.dispose(),i?.dispose(),n.$removeLanguageStatus($),o.delete(s)},get id(){return r.id},get name(){return r.name},set name(p){r.name=p,h()},get selector(){return r.selector},set selector(p){r.selector=p,h()},get text(){return r.text},set text(p){r.text=p,h()},set text2(p){(0,d.$dG)(D,"languageStatusText"),r.text=p,h()},get text2(){return(0,d.$dG)(D,"languageStatusText"),r.text},get detail(){return r.detail},set detail(p){r.detail=p,h()},get severity(){return r.severity},set severity(p){r.severity=p,h()},get accessibilityInformation(){return r.accessibilityInformation},set accessibilityInformation(p){r.accessibilityInformation=p,h()},get command(){return r.command},set command(p){r.command=p,h()},get busy(){return r.busy},set busy(p){r.busy=p,h()}};return h(),t}}e.$9kc=y}),define(Pe[265],Re([1,0,12,2,8,7,83]),function(ee,e,k,M,C,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ukc=e.$Tkc=void 0;class m{constructor(D,l,b,$){this.start=D,this.deletedCount=l,this.deletedItems=b,this.items=$}asApiEvent(){return{range:new N.$VN(this.start,this.start+this.deletedCount),addedCells:this.items.map(D=>D.apiCell),removedCells:this.deletedItems}}}class d{static asModelAddData(D){return{EOL:D.eol,lines:D.source,languageId:D.language,uri:D.uri,isDirty:!1,versionId:1}}constructor(D,l,b){this.notebook=D,this.h=l,this.j=b,this.handle=b.handle,this.uri=M.URI.revive(b.uri),this.cellKind=b.cellKind,this.a=b.outputs.map(C.NotebookCellOutput.to),this.e=b.internalMetadata??{},this.b=Object.freeze(b.metadata??{}),this.d=Object.freeze(C.NotebookCellExecutionSummary.to(b.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const D=this,l=this.h.getDocument(this.uri);if(!l)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const b={get index(){return D.notebook.getCellIndex(D)},notebook:D.notebook.apiNotebook,kind:C.NotebookCellKind.to(this.j.cellKind),document:l.document,get mime(){return D.g},set mime($){D.g=$},get outputs(){return D.a.slice(0)},get metadata(){return D.b},get executionSummary(){return D.d}};this.f=Object.freeze(b)}return this.f}setOutputs(D){this.a=D.map(C.NotebookCellOutput.to)}setOutputItems(D,l,b){const $=b.map(C.NotebookCellOutputItem.to),n=this.a.find(o=>o.id===D);if(n&&(l||(n.items.length=0),n.items.push(...$),n.items.length>1&&n.items.every(o=>A.$pK(o.mime)))){const o=new Map,s=[];n.items.forEach(r=>{let i;o.has(r.mime)?i=o.get(r.mime):(i=[],o.set(r.mime,i),s.push(r.mime)),i.push(r.data)}),n.items.length=0,s.forEach(r=>{const i=A.$qK(o.get(r));n.items.push({mime:r,data:i.data.buffer})})}}setMetadata(D){this.b=Object.freeze(D)}setInternalMetadata(D){this.e=D,this.d=Object.freeze(C.NotebookCellExecutionSummary.to(D))}setMime(D){}}e.$Tkc=d;class y{constructor(D,l,b,$,n){this.k=D,this.l=l,this.m=b,this.uri=$,this.handle=y.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=n.viewType,this.f=Object.freeze(n.metadata??Object.create(null)),this.r([[0,0,n.cells]],!0,void 0),this.g=n.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const D=this,l={get uri(){return D.uri},get version(){return D.g},get notebookType(){return D.d},get isDirty(){return D.h},get isUntitled(){return D.uri.scheme===k.Schemas.untitled},get isClosed(){return D.j},get metadata(){return D.f},get cellCount(){return D.b.length},cellAt(b){return b=D.n(b),D.b[b].apiCell},getCells(b){return(b?D.p(b):D.b).map(n=>n.apiCell)},save(){return D.q()}};this.e=Object.freeze(l)}return this.e}acceptDocumentPropertiesChanged(D){D.metadata&&(this.f=Object.freeze({...this.f,...D.metadata}))}acceptDirty(D){this.h=D}acceptModelChanged(D,l,b){this.g=D.versionId,this.h=l,this.acceptDocumentPropertiesChanged({metadata:b});const $={notebook:this.apiNotebook,metadata:b,cellChanges:[],contentChanges:[]},n=[];for(const s of D.rawEvents)s.kind===A.NotebookCellsChangeType.ModelChange?this.r(s.changes,!1,$.contentChanges):s.kind===A.NotebookCellsChangeType.Move?this.s(s.index,s.length,s.newIdx,$.contentChanges):s.kind===A.NotebookCellsChangeType.Output?(this.t(s.index,s.outputs),n.push({cell:this.b[s.index].apiCell,outputs:this.b[s.index].apiCell.outputs})):s.kind===A.NotebookCellsChangeType.OutputItem?(this.u(s.index,s.outputId,s.append,s.outputItems),n.push({cell:this.b[s.index].apiCell,outputs:this.b[s.index].apiCell.outputs})):s.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this.v(s.index,s.language),n.push({cell:this.b[s.index].apiCell,document:this.b[s.index].apiCell.document})):s.kind===A.NotebookCellsChangeType.ChangeCellContent?n.push({cell:this.b[s.index].apiCell,document:this.b[s.index].apiCell.document}):s.kind===A.NotebookCellsChangeType.ChangeCellMime?this.w(s.index,s.mime):s.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this.x(s.index,s.metadata),n.push({cell:this.b[s.index].apiCell,metadata:this.b[s.index].apiCell.metadata})):s.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(s.index,s.internalMetadata),n.push({cell:this.b[s.index].apiCell,executionSummary:this.b[s.index].apiCell.executionSummary}));const o=new Map;for(let s=0;s<n.length;s++){const r=n[s],i=o.get(r.cell);if(i===void 0){const c=$.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...r});o.set(r.cell,c-1)}else $.cellChanges[i]={...$.cellChanges[i],...r}}return Object.freeze($),Object.freeze($.cellChanges),Object.freeze($.contentChanges),$}n(D){return D=D|0,D<0?0:D>=this.b.length?this.b.length-1:D}o(D){let l=D.start|0,b=D.end|0;return l<0&&(l=0),b>this.b.length&&(b=this.b.length),D.with({start:l,end:b})}p(D){D=this.o(D);const l=[];for(let b=D.start;b<D.end;b++)l.push(this.b[b]);return l}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(D,l,b){if(this.j)return;const $=[],n=[],o=[];if(D.reverse().forEach(s=>{const i=s[2].map(t=>{const p=new d(this,this.l,t);return l||n.push(d.asModelAddData(t)),p}),c=new m(s[0],s[1],[],i),h=this.b.splice(s[0],s[1],...i);for(const t of h)o.push(t.uri),c.deletedItems.push(t.apiCell);$.push(c)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:n,removedDocuments:o}),b)for(const s of $)b.push(s.asApiEvent())}s(D,l,b,$){const n=this.b.splice(D,l);this.b.splice(b,0,...n);const o=[new m(D,l,n.map(s=>s.apiCell),[]),new m(b,0,[],n)];for(const s of o)$.push(s.asApiEvent())}t(D,l){this.b[D].setOutputs(l)}u(D,l,b,$){this.b[D].setOutputItems(l,b,$)}v(D,l){const b=this.b[D];b.apiCell.document.languageId!==l&&this.m.$acceptModelLanguageChanged(b.uri,l)}w(D,l){const b=this.b[D];b.apiCell.mime=l}x(D,l){this.b[D].setMetadata(l)}y(D,l){this.b[D].setInternalMetadata(l)}getCellFromApiCell(D){return this.b.find(l=>l.apiCell===D)}getCellFromIndex(D){return this.b[D]}getCell(D){return this.b.find(l=>l.handle===D)}getCellIndex(D){return this.b.indexOf(D)}}e.$Ukc=y,y.a=0}),define(Pe[266],Re([1,0,5,2,8,7]),function(ee,e,k,M,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$kc=void 0;class A{constructor(d,y,O,D={timeout:1500,errors:3}){this.b=d,this.c=y,this.d=O,this.f=D,this.a=new k.$9d}dispose(){}getOnWillSaveNotebookDocumentEvent(d){return(y,O,D)=>{const l=function($){y.call(O,$)};return l.extension=d,this.a.event(l,void 0,D)}}async $participateInSave(d,y,O){const D=M.URI.revive(d),l=this.c.getNotebookDocument(D);if(!l)throw new Error("Unable to resolve notebook document");const b=[];if(await this.a.fireAsync({notebook:l.apiNotebook,reason:C.TextDocumentSaveReason.to(y)},O,async(n,o)=>{const s=Date.now(),r=await await Promise.resolve(n);Date.now()-s>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",o.extension.identifier),!O.isCancellationRequested&&r&&(r instanceof N.$EM?b.push(r):this.b.warn("onWillSaveNotebookDocument-listener from extension",o.extension.identifier,"ignored due to invalid data"))}),O.isCancellationRequested)return!1;if(b.length===0)return!0;const $={edits:[]};for(const n of b){const{edits:o}=C.WorkspaceEdit.from(n);$.edits=$.edits.concat(o)}return this.d.$tryApplyWorkspaceEdit($)}}e.$$kc=A}),define(Pe[112],Re([1,0,14,8,7]),function(ee,e,k,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vkc=void 0;class N{constructor(m,d,y,O,D,l){this.id=m,this.f=d,this.notebookData=y,this.a=[],this.b=[],this.d=!1,this.a=D,this.b=O,this.c=l}get apiEditor(){if(!this.e){const m=this;this.e={get notebook(){return m.notebookData.apiNotebook},get selection(){return m.a[0]},set selection(d){this.selections=[d]},get selections(){return m.a},set selections(d){if(!Array.isArray(d)||!d.every(C.$VN.isNotebookRange))throw(0,k.$7)("selections");m.a=d,m.g(d)},get visibleRanges(){return m.b},revealRange(d,y){m.f.$tryRevealRange(m.id,M.NotebookRange.from(d),y??C.NotebookEditorRevealType.Default)},get viewColumn(){return m.c}},N.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(m){this.d=m}_acceptVisibleRanges(m){this.b=m}_acceptSelections(m){this.a=m}g(m){this.f.$trySetSelections(this.id,m.map(M.NotebookRange.from))}_acceptViewColumn(m){this.c=m}}e.$Vkc=N,N.apiEditorsToExtHost=new WeakMap}),define(Pe[267],Re([1,0,5,13,8]),function(ee,e,k,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$alc=void 0;let N=class{constructor(m,d){this.c=m,this.d=d,this.a=new k.$7d,this.b=new k.$7d,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(m,d){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",m,d);const y=this.d.getEditorById(m);d.visibleRanges&&y._acceptVisibleRanges(d.visibleRanges.ranges.map(C.NotebookRange.to)),d.selections&&y._acceptSelections(d.selections.selections.map(C.NotebookRange.to)),d.visibleRanges&&this.b.fire({notebookEditor:y.apiEditor,visibleRanges:y.apiEditor.visibleRanges}),d.selections&&this.a.fire(Object.freeze({notebookEditor:y.apiEditor,selections:y.apiEditor.selections}))}$acceptEditorViewColumns(m){for(const d in m)this.d.getEditorById(d)._acceptViewColumn(C.ViewColumn.to(m[d]))}};e.$alc=N,e.$alc=N=Xe([qe(0,M.$Oj)],N)}),define(Pe[268],Re([1,0,5,4,112]),function(ee,e,k,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dlc=void 0;class N{constructor(m,d){this.c=d,this.a=new Map,this.b=m.getProxy(M.$sM.MainThreadNotebookRenderers)}$postRendererMessage(m,d,y){const O=this.c.getEditorById(m);this.a.get(d)?.fire({editor:O.apiEditor,message:y})}createRendererMessaging(m,d){if(!m.contributes?.notebookRenderer?.some(O=>O.id===d))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${d})`);return{onDidReceiveMessage:(O,D,l)=>this.d(d).event(O,D,l),postMessage:(O,D)=>{C.$Vkc.apiEditorsToExtHost.has(O)&&([O,D]=[D,O]);const l=D&&C.$Vkc.apiEditorsToExtHost.get(D);return this.b.$postMessage(l?.id,d,O)}}}d(m){let d=this.a.get(m);return d||(d=new k.$7d({onDidRemoveLastListener:()=>{d?.dispose(),this.a.delete(m)}}),this.a.set(m,d),d)}}e.$dlc=N}),define(Pe[269],Re([1,0,8,101,24,68,14]),function(ee,e,k,M,C,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hlc=void 0;class m{constructor(D){this.b=0,this.c=new Map,this.a=D}async withProgress(D,l,b){const $=this.b++,{title:n,location:o,cancellable:s}=l,r={label:D.displayName||D.name,id:D.identifier.value};return this.a.$startProgress($,{location:k.ProgressLocation.from(o),title:n,source:r,cancellable:s},D.isUnderDevelopment?void 0:D.identifier.value).catch(A.$2),this.d($,b,!!s)}d(D,l,b){let $;b&&($=new C.$ee,this.c.set(D,$));const n=s=>{this.a.$progressEnd(s),this.c.delete(s),$?.dispose()};let o;try{o=l(new y(this.a,D),b&&$?$.token:C.CancellationToken.None)}catch(s){throw n(D),s}return o.then(s=>n(D),s=>n(D)),o}$acceptProgressCanceled(D){const l=this.c.get(D);l&&(l.cancel(),this.c.delete(D))}}e.$hlc=m;function d(O,D){return O.message=D.message,typeof D.increment=="number"&&(typeof O.increment=="number"?O.increment+=D.increment:O.increment=D.increment),O}class y extends M.$Sv{constructor(D,l){super(b=>this.throttledReport(b)),this.c=D,this.d=l}throttledReport(D){this.c.$progressReport(this.d,D)}}Xe([(0,N.$Oh)(100,(O,D)=>d(O,D),()=>Object.create(null))],y.prototype,"throttledReport",null)}),define(Pe[270],Re([1,0,2,4,11,8]),function(ee,e,k,M,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ilc=void 0;class A{constructor(d,y){this.d=y,this.c=new Map,this.b=d.getProxy(M.$sM.MainThreadQuickDiff)}$provideOriginalResource(d,y,O){const D=k.URI.revive(y),l=this.c.get(d);return l?(0,C.$ah)(()=>l.provideOriginalResource(D,O)).then(b=>b||null):Promise.resolve(null)}registerQuickDiffProvider(d,y,O,D){const l=A.a++;return this.c.set(l,y),this.b.$registerQuickDiffProvider(l,N.DocumentSelector.from(d,this.d),O,D),{dispose:()=>{this.b.$unregisterQuickDiffProvider(l),this.c.delete(l)}}}}e.$ilc=A,A.a=0}),define(Pe[271],Re([1,0,24,5,6,4,2,7,14,18,32,41,25,8]),function(ee,e,k,M,C,N,A,m,d,y,O,D,l,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jlc=$;function $(n,o,s){const r=n.getProxy(N.$sM.MainThreadQuickOpen);class i{constructor(u,E){this.e=new Map,this.f=0,this.a=u,this.b=E}showQuickPick(u,E,w,I=k.CancellationToken.None){this.c=void 0;const S=Promise.resolve(E),P=++this.f,U=r.$show(P,{title:w?.title,placeHolder:w?.placeHolder,matchOnDescription:w?.matchOnDescription,matchOnDetail:w?.matchOnDetail,ignoreFocusLost:w?.ignoreFocusOut,canPickMany:w?.canPickMany},I),Q={},H=U.then(()=>Q);return Promise.race([H,S]).then(L=>{if(L===Q)return;const R=(0,l.$cG)(u,"quickPickItemTooltip");return S.then(F=>{const T=[];for(let X=0;X<F.length;X++){const re=F[X];if(typeof re=="string")T.push({label:re,handle:X});else if(re.kind===m.QuickPickItemKind.Separator)T.push({type:"separator",label:re.label});else{re.tooltip&&!R&&console.warn(`Extension '${u.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${u.identifier.value}`);const me=re.iconPath?a(re.iconPath):void 0;T.push({label:re.label,iconPath:me?.iconPath,iconClass:me?.iconClass,description:re.description,detail:re.detail,picked:re.picked,alwaysShow:re.alwaysShow,tooltip:R?b.MarkdownString.fromStrict(re.tooltip):void 0,handle:X})}}return w&&typeof w.onDidSelectItem=="function"&&(this.c=X=>{w.onDidSelectItem(F[X])}),r.$setItems(P,T),U.then(X=>{if(typeof X=="number")return F[X];if(Array.isArray(X))return X.map(re=>F[re])})})}).then(void 0,L=>{if(!(0,d.$4)(L))return r.$setError(P,L),Promise.reject(L)})}$onItemSelected(u){this.c?.(u)}showInput(u,E=k.CancellationToken.None){return this.d=u?.validateInput,r.$input(u,typeof this.d=="function",E).then(void 0,w=>{if(!(0,d.$4)(w))return Promise.reject(w)})}async $validateInput(u){if(!this.d)return;const E=await this.d(u);if(!E||typeof E=="string")return E;let w;switch(E.severity){case m.InputBoxValidationSeverity.Info:w=O.default.Info;break;case m.InputBoxValidationSeverity.Warning:w=O.default.Warning;break;case m.InputBoxValidationSeverity.Error:w=O.default.Error;break;default:w=E.message?O.default.Error:O.default.Ignore;break}return{content:E.message,severity:w}}async showWorkspaceFolderPick(u,E=k.CancellationToken.None){const w=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[u]);if(!w)return;const I=await this.a.getWorkspaceFolders2();if(I)return I.find(S=>S.uri.toString()===w.uri.toString())}createQuickPick(u){const E=new g(u,()=>this.e.delete(E._id));return this.e.set(E._id,E),E}createInputBox(u){const E=new v(u,()=>this.e.delete(E._id));return this.e.set(E._id,E),E}$onDidChangeValue(u,E){this.e.get(u)?._fireDidChangeValue(E)}$onDidAccept(u){this.e.get(u)?._fireDidAccept()}$onDidChangeActive(u,E){const w=this.e.get(u);w instanceof g&&w._fireDidChangeActive(E)}$onDidChangeSelection(u,E){const w=this.e.get(u);w instanceof g&&w._fireDidChangeSelection(E)}$onDidTriggerButton(u,E){this.e.get(u)?._fireDidTriggerButton(E)}$onDidTriggerItemButton(u,E,w){const I=this.e.get(u);I instanceof g&&I._fireDidTriggerItemButton(E,w)}$onDidHide(u){this.e.get(u)?._fireDidHide()}}class c{constructor(u,E){this.x=u,this.y=E,this._id=g.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new M.$7d,this.q=new M.$7d,this.r=new M.$7d,this.s=new M.$7d,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(u){this.b=u,this.z({title:u})}get step(){return this.c}set step(u){this.c=u,this.z({step:u})}get totalSteps(){return this.d}set totalSteps(u){this.d=u,this.z({totalSteps:u})}get enabled(){return this.g}set enabled(u){this.g=u,this.z({enabled:u})}get busy(){return this.j}set busy(u){this.j=u,this.z({busy:u})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(u){this.k=u,this.z({ignoreFocusOut:u})}get value(){return this.l}set value(u){this.l=u,this.z({value:u})}get placeholder(){return this.m}set placeholder(u){this.m=u,this.z({placeholder:u})}get buttons(){return this.n}set buttons(u){this.n=u.slice(),this.o.clear(),u.forEach((E,w)=>{const I=E===m.$SN.Back?-1:w;this.o.set(I,E)}),this.z({buttons:u.map((E,w)=>({...a(E.iconPath),tooltip:E.tooltip,handle:E===m.$SN.Back?-1:w}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(u){this.l=u,this.q.fire(u)}_fireDidTriggerButton(u){const E=this.o.get(u);E&&this.r.fire(E)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,C.$Pc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),r.$dispose(this._id))}z(u){if(!this.v){for(const E of Object.keys(u)){const w=u[E];this.u[E]=w===void 0?null:w}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){r.$createOrUpdate(this.u),this.u={id:this._id}}}c.a=1;function h(f){if(f instanceof m.$qN)return{id:f.id};const u=p(f),E=t(f);return{dark:typeof u=="string"?A.URI.file(u):u,light:typeof E=="string"?A.URI.file(E):E}}function t(f){return typeof f=="object"&&"light"in f?f.light:f}function p(f){return typeof f=="object"&&"dark"in f?f.dark:f}function a(f){const u=h(f);let E,w;return"id"in u?w=D.ThemeIcon.asClassName(u):E=u,{iconPath:E,iconClass:w}}class g extends c{constructor(u,E){super(u.identifier,E),this.O=u,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new M.$7d,this.L=[],this.M=new M.$7d,this.N=new M.$7d,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(u){this.B=u.slice(),this.C.clear(),this.D.clear(),u.forEach((I,S)=>{this.C.set(S,I),this.D.set(I,S)});const E=(0,l.$cG)(this.O,"quickPickItemTooltip"),w=[];for(let I=0;I<u.length;I++){const S=u[I];if(S.kind===m.QuickPickItemKind.Separator)w.push({type:"separator",label:S.label});else{S.tooltip&&!E&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const P=S.iconPath?a(S.iconPath):void 0;w.push({handle:I,label:S.label,iconPath:P?.iconPath,iconClass:P?.iconClass,description:S.description,detail:S.detail,picked:S.picked,alwaysShow:S.alwaysShow,tooltip:E?b.MarkdownString.fromStrict(S.tooltip):void 0,buttons:S.buttons?.map((U,Q)=>({...a(U.iconPath),tooltip:U.tooltip,handle:Q}))})}}this.z({items:w})}get canSelectMany(){return this.E}set canSelectMany(u){this.E=u,this.z({canSelectMany:u})}get matchOnDescription(){return this.F}set matchOnDescription(u){this.F=u,this.z({matchOnDescription:u})}get matchOnDetail(){return this.G}set matchOnDetail(u){this.G=u,this.z({matchOnDetail:u})}get sortByLabel(){return this.H}set sortByLabel(u){this.H=u,this.z({sortByLabel:u})}get keepScrollPosition(){return this.I}set keepScrollPosition(u){this.I=u,this.z({keepScrollPosition:u})}get activeItems(){return this.J}set activeItems(u){this.J=u.filter(E=>this.D.has(E)),this.z({activeItems:this.J.map(E=>this.D.get(E))})}get selectedItems(){return this.L}set selectedItems(u){this.L=u.filter(E=>this.D.has(E)),this.z({selectedItems:this.L.map(E=>this.D.get(E))})}_fireDidChangeActive(u){const E=(0,y.$Hb)(u.map(w=>this.C.get(w)));this.J=E,this.K.fire(E)}_fireDidChangeSelection(u){const E=(0,y.$Hb)(u.map(w=>this.C.get(w)));this.L=E,this.M.fire(E)}_fireDidTriggerItemButton(u,E){const w=this.C.get(u);if(!w||!w.buttons||!w.buttons.length)return;const I=w.buttons[E];I&&this.N.fire({button:I,item:w})}}class v extends c{constructor(u,E){super(u.identifier,E),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(u){this.B=u,this.z({password:u})}get prompt(){return this.C}set prompt(u){this.C=u,this.z({prompt:u})}get valueSelection(){return this.D}set valueSelection(u){this.D=u,this.z({valueSelection:u})}get validationMessage(){return this.E}set validationMessage(u){this.E=u,u?typeof u=="string"?this.z({validationMessage:u,severity:O.default.Error}):this.z({validationMessage:u.message,severity:u.severity??O.default.Error}):this.z({validationMessage:void 0,severity:O.default.Ignore})}}return new i(o,s)}});var Ve=this&&this.__classPrivateFieldGet||function(ee,e,k,M){if(k==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!M:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return k==="m"?M:k==="a"?M.call(ee):M?M.value:e.get(ee)},_e=this&&this.__classPrivateFieldSet||function(ee,e,k,M,C){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?C.call(ee,k):C?C.value=k:e.set(ee,k),k};define(Pe[272],Re([1,0,2,5,68,6,11,4,18,128,13,20,41,8,25,12,21]),function(ee,e,k,M,C,N,A,m,d,y,O,D,l,b,$,n,o){"use strict";var s,r,i,c;Object.defineProperty(e,"__esModule",{value:!0}),e.$llc=e.$klc=void 0;function h(H){return H instanceof k.URI}function t(H,L){return H.scheme===n.Schemas.file&&L.scheme===n.Schemas.file&&o.$e?H.toString()===L.toString():H.toString().toLowerCase()===L.toString().toLowerCase()}function p(H){if(H)return typeof H.iconPath=="string"?k.URI.file(H.iconPath):k.URI.isUri(H.iconPath)||l.ThemeIcon.isThemeIcon(H.iconPath)?H.iconPath:void 0}function a(H){if(H.icon){if(k.URI.isUri(H.icon))return H.icon;if(l.ThemeIcon.isThemeIcon(H.icon))return H.icon;{const L=H.icon;return{light:L.light,dark:L.dark}}}else return}function g(H,L){if(!H.iconPath&&!L.iconPath)return 0;if(H.iconPath){if(!L.iconPath)return 1}else return-1;const R=typeof H.iconPath=="string"?H.iconPath:k.URI.isUri(H.iconPath)?H.iconPath.fsPath:H.iconPath.id,F=typeof L.iconPath=="string"?L.iconPath:k.URI.isUri(L.iconPath)?L.iconPath.fsPath:L.iconPath.id;return(0,y.$br)(R,F)}function v(H,L){let R=0;if(H.strikeThrough!==L.strikeThrough)return H.strikeThrough?1:-1;if(H.faded!==L.faded)return H.faded?1:-1;if(H.tooltip!==L.tooltip)return(H.tooltip||"").localeCompare(L.tooltip||"");if(R=g(H,L),R!==0)return R;if(H.light&&L.light)R=g(H.light,L.light);else{if(H.light)return 1;if(L.light)return-1}if(R!==0)return R;if(H.dark&&L.dark)R=g(H.dark,L.dark);else{if(H.dark)return 1;if(L.dark)return-1}return R}function f(H,L){if(H.command!==L.command)return H.command<L.command?-1:1;if(H.title!==L.title)return H.title<L.title?-1:1;if(H.tooltip!==L.tooltip){if(H.tooltip!==void 0&&L.tooltip!==void 0)return H.tooltip<L.tooltip?-1:1;if(H.tooltip!==void 0)return 1;if(L.tooltip!==void 0)return-1}if(H.arguments===L.arguments)return 0;if(H.arguments)if(L.arguments){if(H.arguments.length!==L.arguments.length)return H.arguments.length-L.arguments.length}else return 1;else return-1;for(let R=0;R<H.arguments.length;R++){const F=H.arguments[R],T=L.arguments[R];if(F!==T&&!(h(F)&&h(T)&&t(F,T)))return F<T?-1:1}return 0}function u(H,L){let R=(0,y.$br)(H.resourceUri.fsPath,L.resourceUri.fsPath,!0);if(R!==0)return R;if(H.command&&L.command)R=f(H.command,L.command);else{if(H.command)return 1;if(L.command)return-1}if(R!==0)return R;if(H.decorations&&L.decorations)R=v(H.decorations,L.decorations);else{if(H.decorations)return 1;if(L.decorations)return-1}if(H.multiFileDiffEditorModifiedUri&&L.multiFileDiffEditorModifiedUri)R=(0,y.$br)(H.multiFileDiffEditorModifiedUri.fsPath,L.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(H.multiFileDiffEditorModifiedUri)return 1;if(L.multiFileDiffEditorModifiedUri)return-1}if(H.multiDiffEditorOriginalUri&&L.multiDiffEditorOriginalUri)R=(0,y.$br)(H.multiDiffEditorOriginalUri.fsPath,L.multiDiffEditorOriginalUri.fsPath,!0);else{if(H.multiDiffEditorOriginalUri)return 1;if(L.multiDiffEditorOriginalUri)return-1}return R}function E(H,L){for(let R=0;R<H.length;R++)if(H[R]!==L[R])return!1;return!0}function w(H,L){return H.command===L.command&&H.title===L.title&&H.tooltip===L.tooltip&&(H.arguments&&L.arguments?E(H.arguments,L.arguments):H.arguments===L.arguments)}function I(H,L){return(0,d.$ub)(H,L,w)}class S{get value(){return this.d}set value(L){L=L??"",Ve(this,s,"f").$setInputBoxValue(this.l,L),this.n(L)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(L){Ve(this,s,"f").$setInputBoxPlaceholder(this.l,L),this.f=L}get validateInput(){return(0,$.$dG)(this.k,"scmValidation"),this.g}set validateInput(L){if((0,$.$dG)(this.k,"scmValidation"),L&&typeof L!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=L,Ve(this,s,"f").$setValidationProviderIsEnabled(this.l,!!L)}get enabled(){return this.h}set enabled(L){L=!!L,this.h!==L&&(this.h=L,Ve(this,s,"f").$setInputBoxEnablement(this.l,L))}get visible(){return this.j}set visible(L){L=!!L,this.j!==L&&(this.j=L,Ve(this,s,"f").$setInputBoxVisibility(this.l,L))}get document(){return(0,$.$dG)(this.k,"scmTextDocument"),Ve(this,r,"f").getDocument(this.m)}constructor(L,R,F,T,X){this.k=L,this.l=T,this.m=X,s.set(this,void 0),r.set(this,void 0),this.d="",this.e=new M.$7d,this.f="",this.h=!0,this.j=!0,_e(this,r,R,"f"),_e(this,s,F,"f")}showValidationMessage(L,R){(0,$.$dG)(this.k,"scmValidation"),Ve(this,s,"f").$showValidationMessage(this.l,L,R)}$onInputBoxValueChange(L){this.n(L)}n(L){this.d=L,this.e.fire(L)}}e.$klc=S,s=new WeakMap,r=new WeakMap;class P{get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(L){this.v=L,this.q.$updateGroupLabel(this.t,this.handle,L)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(L){this.p=L,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(L){this.f=[...L],this.k.fire()}constructor(L,R,F,T,X,re,me){this.q=L,this.s=R,this.t=F,this.u=T,this.v=X,this.multiDiffEditorEnableViewChanges=re,this.w=me,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new M.$7d,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new M.$7d,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=P.d++}getResourceState(L){return this.g.get(L)}$executeResourceCommand(L,R){const F=this.h.get(L);return F?(0,A.$ah)(()=>this.s.executeCommand(F.command,...F.arguments||[],R)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const L=[...this.f].sort(u),F=(0,d.$Db)(this.o,L,u).map(re=>{const me=re.toInsert.map(pe=>{const ae=this.e++;this.g.set(ae,pe);const be=pe.resourceUri;let se;if(pe.command)if(pe.command.command==="vscode.open"||pe.command.command==="vscode.diff"||pe.command.command==="vscode.changes"){const le=new N.$Tc;se=this.s.converter.toInternal(pe.command,le),this.j.set(ae,le)}else this.h.set(ae,pe.command);const De=(0,$.$cG)(this.w,"scmMultiDiffEditor"),Oe=De?pe.multiDiffEditorOriginalUri:void 0,ie=De?pe.multiFileDiffEditorModifiedUri:void 0,q=p(pe.decorations),de=pe.decorations&&p(pe.decorations.light)||q,Ne=pe.decorations&&p(pe.decorations.dark)||q,$e=[de,Ne],we=pe.decorations&&pe.decorations.tooltip||"",ge=pe.decorations&&!!pe.decorations.strikeThrough,ce=pe.decorations&&!!pe.decorations.faded,K=pe.contextValue||"";return{rawResource:[ae,be,$e,we,ge,ce,K,se,Oe,ie],handle:ae}});return{start:re.start,deleteCount:re.deleteCount,toInsert:me}}),T=F.map(({start:re,deleteCount:me,toInsert:pe})=>[re,me,pe.map(ae=>ae.rawResource)]),X=F.reverse();for(const{start:re,deleteCount:me,toInsert:pe}of X){const ae=pe.map(se=>se.handle),be=this.n.splice(re,me,...ae);for(const se of be)this.g.delete(se),this.h.delete(se),this.j.get(se)?.dispose(),this.j.delete(se)}return this.o=L,T}dispose(){this.l=!0,this.m.fire()}}P.d=0;class U{get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(L){this.g!==L&&(this.g=L,Ve(this,i,"f").$updateSourceControl(this.w,{count:L}))}get quickDiffProvider(){return this.h}set quickDiffProvider(L){this.h=L;let R;(0,$.$cG)(this.x,"quickDiffProvider")&&(R=L?.label),Ve(this,i,"f").$updateSourceControl(this.w,{hasQuickDiffProvider:!!L,quickDiffLabel:R})}get historyProvider(){return(0,$.$dG)(this.x,"scmHistoryProvider"),this.j}set historyProvider(L){(0,$.$dG)(this.x,"scmHistoryProvider"),this.j=L,this.k.value=new N.$Tc,Ve(this,i,"f").$updateSourceControl(this.w,{hasHistoryProvider:!!L}),L&&this.k.value.add(L.onDidChangeCurrentHistoryItemGroup(()=>{this.l=L?.currentHistoryItemGroup,Ve(this,i,"f").$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(L){L!==this.m&&(this.m=L,Ve(this,i,"f").$updateSourceControl(this.w,{commitTemplate:L}))}get acceptInputCommand(){return this.o}set acceptInputCommand(L){this.n.value=new N.$Tc,this.o=L;const R=this.y.converter.toInternal(L,this.n.value);Ve(this,i,"f").$updateSourceControl(this.w,{acceptInputCommand:R})}get actionButton(){return(0,$.$dG)(this.x,"scmActionButton"),this.q}set actionButton(L){(0,$.$dG)(this.x,"scmActionButton"),this.p.value=new N.$Tc,this.q=L;const R=L!==void 0?{command:this.y.converter.toInternal(L.command,this.p.value),secondaryCommands:L.secondaryCommands?.map(F=>F.map(T=>this.y.converter.toInternal(T,this.p.value))),description:L.description,enabled:L.enabled}:void 0;Ve(this,i,"f").$updateSourceControl(this.w,{actionButton:R??null})}get statusBarCommands(){return this.t}set statusBarCommands(L){if(this.t&&L&&I(this.t,L))return;this.s.value=new N.$Tc,this.t=L;const R=(L||[]).map(F=>this.y.converter.toInternal(F,this.s.value));Ve(this,i,"f").$updateSourceControl(this.w,{statusBarCommands:R})}get selected(){return this.u}constructor(L,R,F,T,X,re,me){this.x=L,this.y=T,this.z=X,this.A=re,this.B=me,i.set(this,void 0),this.e=new Map,this.g=void 0,this.h=void 0,this.k=new N.$Vc,this.m=void 0,this.n=new N.$Vc,this.o=void 0,this.p=new N.$Vc,this.s=new N.$Vc,this.t=void 0,this.u=!1,this.v=new M.$7d,this.onDidChangeSelection=this.v.event,this.w=U.d++,this.C=new Map,this.D=new Set,_e(this,i,F,"f");const pe=k.URI.from({scheme:n.Schemas.vscodeSourceControl,path:`${X}/scm${this.w}/input`,query:me?`rootUri=${encodeURIComponent(me.toString())}`:void 0});this.f=new S(L,R,Ve(this,i,"f"),this.w,pe),Ve(this,i,"f").$registerSourceControl(this.w,X,re,me,pe)}createResourceGroup(L,R,F){const T=(0,$.$cG)(this.x,"scmMultiDiffEditor")&&F?.multiDiffEditorEnableViewChanges===!0,X=new P(Ve(this,i,"f"),this.y,this.w,L,R,T,this.x),re=M.Event.once(X.onDidDispose)(()=>this.C.delete(X));return this.C.set(X,re),this.eventuallyAddResourceGroups(),X}eventuallyAddResourceGroups(){const L=[],R=[];for(const[F,T]of this.C){T.dispose();const X=F.onDidUpdateResourceStates(()=>{this.D.add(F),this.eventuallyUpdateResourceStates()});M.Event.once(F.onDidDispose)(()=>{this.D.delete(F),X.dispose(),this.e.delete(F.handle),Ve(this,i,"f").$unregisterGroup(this.w,F.handle)}),L.push([F.handle,F.id,F.label,F.features,F.multiDiffEditorEnableViewChanges]);const re=F._takeResourceStateSnapshot();re.length>0&&R.push([F.handle,re]),this.e.set(F.handle,F)}Ve(this,i,"f").$registerGroups(this.w,L,R),this.C.clear()}eventuallyUpdateResourceStates(){const L=[];this.D.forEach(R=>{const F=R._takeResourceStateSnapshot();F.length!==0&&L.push([R.handle,F])}),L.length>0&&Ve(this,i,"f").$spliceResourceStates(this.w,L),this.D.clear()}getResourceGroup(L){return this.e.get(L)}setSelectionState(L){this.u=L,this.v.fire(L)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(L=>L.dispose()),Ve(this,i,"f").$unregisterSourceControl(this.w)}}i=new WeakMap,U.d=0,Xe([(0,C.$Nh)(100)],U.prototype,"eventuallyAddResourceGroups",null),Xe([(0,C.$Nh)(100)],U.prototype,"eventuallyUpdateResourceStates",null);let Q=c=class{get onDidChangeActiveProvider(){return this.j.event}constructor(L,R,F,T){this.l=R,this.m=F,this.n=T,this.g=new Map,this.h=new D.$Gm,this.j=new M.$7d,this.e=L.getProxy(m.$sM.MainThreadSCM),this.f=L.getProxy(m.$sM.MainThreadTelemetry),R.registerArgumentProcessor({processArgument:X=>{if(X&&X.$mid===3){const re=this.g.get(X.sourceControlHandle);if(!re)return X;const me=re.getResourceGroup(X.groupHandle);return me?me.getResourceState(X.handle):X}else if(X&&X.$mid===4){const re=this.g.get(X.sourceControlHandle);return re?re.getResourceGroup(X.groupHandle):X}else if(X&&X.$mid===5){const re=this.g.get(X.handle);return re||X}return X}})}createSourceControl(L,R,F,T){this.n.trace("ExtHostSCM#createSourceControl",L.identifier.value,R,F,T),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:L.identifier.value});const X=c.d++,re=new U(L,this.m,this.e,this.l,R,F,T);this.g.set(X,re);const me=this.h.get(L.identifier)||[];return me.push(re),this.h.set(L.identifier,me),re}getLastInputBox(L){this.n.trace("ExtHostSCM#getLastInputBox",L.identifier.value);const R=this.h.get(L.identifier),F=R&&R[R.length-1];return F&&F.inputBox}$provideOriginalResource(L,R,F){const T=k.URI.revive(R);this.n.trace("ExtHostSCM#$provideOriginalResource",L,T.toString());const X=this.g.get(L);return!X||!X.quickDiffProvider||!X.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.$ah)(()=>X.quickDiffProvider.provideOriginalResource(T,F)).then(re=>re||null)}$onInputBoxValueChange(L,R){this.n.trace("ExtHostSCM#$onInputBoxValueChange",L);const F=this.g.get(L);return F&&F.inputBox.$onInputBoxValueChange(R),Promise.resolve(void 0)}$executeResourceCommand(L,R,F,T){this.n.trace("ExtHostSCM#$executeResourceCommand",L,R,F);const X=this.g.get(L);if(!X)return Promise.resolve(void 0);const re=X.getResourceGroup(R);return re?re.$executeResourceCommand(F,T):Promise.resolve(void 0)}$validateInput(L,R,F){this.n.trace("ExtHostSCM#$validateInput",L);const T=this.g.get(L);return!T||!T.inputBox.validateInput?Promise.resolve(void 0):(0,A.$ah)(()=>T.inputBox.validateInput(R,F)).then(X=>{if(!X)return Promise.resolve(void 0);const re=b.MarkdownString.fromStrict(X.message);return re?Promise.resolve([re,X.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(L){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",L),L!==void 0&&this.g.get(L)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=L,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(L,R,F,T){return await this.g.get(L)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(R,F,T)??void 0}async $provideHistoryItems(L,R,F,T){return(await this.g.get(L)?.historyProvider?.provideHistoryItems(R,F,T))?.map(me=>({...me,icon:a(me)}))??void 0}async $provideHistoryItemSummary(L,R,F,T){const X=this.g.get(L)?.historyProvider;if(typeof X?.provideHistoryItemSummary!="function")return;const re=await X.provideHistoryItemSummary(R,F,T);return re?{...re,icon:a(re)}:void 0}async $provideHistoryItemChanges(L,R,F,T){return await this.g.get(L)?.historyProvider?.provideHistoryItemChanges(R,F,T)??void 0}};e.$llc=Q,Q.d=0,e.$llc=Q=c=Xe([qe(3,O.$Oj)],Q)}),define(Pe[273],Re([1,0,4,8,2]),function(ee,e,k,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mlc=void 0;class N{constructor(m,d){this.d=d,this.c=new Map,this.b=m.getProxy(k.$sM.MainThreadShare)}async $provideShare(m,d,y){return await this.c.get(m)?.provideShare({selection:M.Range.to(d.selection),resourceUri:C.URI.revive(d.resourceUri)},y)??void 0}registerShareProvider(m,d){const y=N.a++;return this.c.set(y,d),this.b.$registerShareProvider(y,M.DocumentSelector.from(m,this.d),d.id,d.label,d.priority),{dispose:()=>{this.b.$unregisterShareProvider(y),this.c.delete(y)}}}}e.$mlc=N,N.a=0});var _e=this&&this.__classPrivateFieldSet||function(ee,e,k,M,C){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?C.call(ee,k):C?C.value=k:e.set(ee,k),k},Ve=this&&this.__classPrivateFieldGet||function(ee,e,k,M){if(k==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!M:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return k==="m"?M:k==="a"?M.call(ee):M?M.value:e.get(ee)};define(Pe[274],Re([1,0,7,4,170,6,8,17]),function(ee,e,k,M,C,N,A,m){"use strict";var d,y;Object.defineProperty(e,"__esModule",{value:!0}),e.$plc=e.$olc=void 0;class O{constructor($,n,o,s,r,i=k.StatusBarAlignment.Left,c){if(d.set(this,void 0),y.set(this,void 0),this.i=!1,this.k="",this.q=new N.$Tc,_e(this,d,$,"f"),_e(this,y,n,"f"),r&&s){this.c=(0,k.$6M)(s.identifier,r);const h=o.get(this.c);h&&(i=h.alignLeft?k.StatusBarAlignment.Left:k.StatusBarAlignment.Right,c=h.priority,this.j=!0,this.name=h.name,this.text=h.text,this.tooltip=h.tooltip,this.command=h.command,this.accessibilityInformation=h.accessibilityInformation)}else this.c=String(O.a++);this.e=s,this.f=r,this.g=i,this.h=this.u(c)}u($){if((0,m.$Zf)($))return $===Number.POSITIVE_INFINITY?Number.MAX_VALUE:$===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:$}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text($){this.k=$,this.v()}set name($){this.m=$,this.v()}set tooltip($){this.l=$,this.v()}set color($){this.n=$,this.v()}set backgroundColor($){$&&!O.b.has($.id)&&($=void 0),this.o=$,this.v()}set command($){this.r?.fromApi!==$&&(this.p&&this.q.add(this.p),this.p=new N.$Tc,typeof $=="string"?this.r={fromApi:$,internal:Ve(this,y,"f").toInternal({title:"",command:$},this.p)}:$?this.r={fromApi:$,internal:Ve(this,y,"f").toInternal($,this.p)}:this.r=void 0,this.v())}set accessibilityInformation($){this.t=$,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,Ve(this,d,"f").$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let $;this.e?this.f?$=`${this.e.identifier.value}.${this.f}`:$=this.e.identifier.value:$=this.f;let n;this.m?n=this.m:n=(0,C.localize)(0,null,this.e.displayName||this.e.name);let o=this.n;this.o&&(o=O.b.get(this.o.id));const s=A.MarkdownString.fromStrict(this.l);Ve(this,d,"f").$setEntry(this.c,$,this.e?.identifier.value,n,this.k,s,this.r?.internal,o,this.o,this.g===k.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$olc=O,d=new WeakMap,y=new WeakMap,O.a=0,O.b=new Map([["statusBarItem.errorBackground",new k.$rN("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new k.$rN("statusBarItem.warningForeground")]]);class D{constructor($){this.b=[],this.a=$.createStatusBarEntry(void 0,"status.extensionMessage",k.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,C.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage($){const n={message:$};return this.b.unshift(n),this.c(),new k.$uM(()=>{const o=this.b.indexOf(n);o>=0&&(this.b.splice(o,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class l{constructor($,n){this.e=new Map,this.a=$.getProxy(M.$sM.MainThreadStatusBar),this.b=n,this.c=new D(this)}$acceptStaticEntries($){for(const n of $)this.e.set(n.entryId,n)}createStatusBarEntry($,n,o,s){return new O(this.a,this.b,this.e,$,n,o,s)}setStatusBarMessage($,n){const o=this.c.setMessage($);let s;return typeof n=="number"?s=setTimeout(()=>o.dispose(),n):typeof n<"u"&&n.then(()=>o.dispose(),()=>o.dispose()),new k.$uM(()=>{o.dispose(),clearTimeout(s)})}}e.$plc=l}),define(Pe[113],Re([1,0,29,105,49,75,61,8,2]),function(ee,e,k,M,C,N,A,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4O=e.$3O=e.$2O=e.$1O=void 0;const y=(i,c,h,t)=>{let p=c;return{enumerable:!0,configurable:!1,get(){return p},set(a){if(!h(p,a)){const g=p;p=a,i.listener?.(t(a,g))}}}},O=(i,c)=>i===c,D={range:(i,c)=>i===c?!0:!i||!c?!1:i.isEqual(c),label:O,description:O,sortText:O,busy:O,error:O,canResolveChildren:O,tags:(i,c)=>!(i.length!==c.length||i.some(h=>!c.find(t=>h.id===t.id)))},l=i=>c=>({op:4,update:i(c)}),b=(i,c)=>({range:(()=>{let h;const t=l(p=>({range:k.$dt.lift(m.Range.from(p))}));return{enumerable:!0,configurable:!1,get(){return h},set(p){i.listener?.({op:6}),D.range(h,p)||(h=p,i.listener?.(t(p)))}}})(),label:y(i,c,D.label,l(h=>({label:h}))),description:y(i,void 0,D.description,l(h=>({description:h}))),sortText:y(i,void 0,D.sortText,l(h=>({sortText:h}))),canResolveChildren:y(i,!1,D.canResolveChildren,h=>({op:2,state:h})),busy:y(i,!1,D.busy,l(h=>({busy:h}))),error:y(i,void 0,D.error,l(h=>({error:m.MarkdownString.fromStrict(h)||null}))),tags:y(i,[],D.tags,(h,t)=>({op:1,new:h.map(m.TestTag.from),old:t.map(m.TestTag.from)}))}),$=i=>{const c=C.$eL.fromString(i.extId),h=new o(c.controllerId,c.localId,i.label,d.URI.revive(i.uri)||void 0);return h.range=m.Range.to(i.range||void 0),h.description=i.description||void 0,h.sortText=i.sortText||void 0,h.tags=i.tags.map(t=>m.TestTag.to({id:(0,A.$kL)(t).tagId})),h},n=i=>{let c;for(const h of i.tests){const t=$(h.item);(0,M.$KO)(t).parent=c,c=t}return c};e.$1O=n;class o{constructor(c,h,t,p){if(h.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(h)} symbol`);const a=(0,M.$JO)(this,c);Object.defineProperties(this,{id:{value:h,enumerable:!0,writable:!1},uri:{value:p,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return a.parent instanceof s?void 0:a.parent}},children:{value:(0,N.$IO)(a,M.$KO,o),enumerable:!0,writable:!1},...b(a,t)})}}e.$2O=o;class s extends o{constructor(c,h){super(c,c,h,void 0),this._isRoot=!0}}e.$3O=s;class r extends N.$EO{constructor(c,h,t){super({controllerId:c,getDocumentVersion:p=>p&&t.getDocument(p)?.version,getApiFor:M.$KO,getChildren:p=>p.children,root:new s(c,h),toITestItem:m.TestItem.from})}}e.$4O=r});var _e=this&&this.__classPrivateFieldSet||function(ee,e,k,M,C){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?C.call(ee,k):C?C.value=k:e.set(ee,k),k},Ve=this&&this.__classPrivateFieldGet||function(ee,e,k,M){if(k==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!M:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return k==="m"?M:k==="a"?M.call(ee):M?M.value:e.get(ee)};define(Pe[31],Re([1,0,17,7,8,26,4,18,13,53,29,94,2,6,3,16,113,22,50,42,65,59,62,35]),function(ee,e,k,M,C,N,A,m,d,y,O,D,l,b,$,n,o,s,r,i,c,h,t,p){"use strict";var a,g,v;Object.defineProperty(e,"__esModule",{value:!0}),e.$cP=e.$bP=e.$aP=e.$_O=e.$$O=e.$0O=void 0;let f=class{constructor(P,U,Q){a.set(this,void 0),this.b=new Map,this.c=new Map,g.set(this,void 0),v.set(this,void 0),_e(this,a,P.getProxy(A.$sM.MainThreadCommands),"f"),this.d=U,_e(this,v,Q,"f"),_e(this,g,P.getProxy(A.$sM.MainThreadTelemetry),"f"),this.converter=new u(this,H=>{const L=this.c.get(H);return L?.result===w.Void?L:void 0},U),this.f=[{processArgument(H){return(0,y.$Rh)(H)}},{processArgument(H){return(0,N.$Rn)(H,function(L){if(O.$dt.isIRange(L))return C.Range.to(L);if(D.$ct.isIPosition(L))return C.Position.to(L);if(O.$dt.isIRange(L.range)&&l.URI.isUri(L.uri))return C.location.to(L);if(L instanceof s.$ue)return L.buffer.buffer;if(!Array.isArray(L))return L})}}]}registerArgumentProcessor(P){this.f.push(P)}registerApiCommand(P){const U=this.registerCommand(!1,P.id,async(...Q)=>{const H=P.args.map((R,F)=>{if(!R.validate(Q[F]))throw new Error(`Invalid argument '${R.name}' when running '${P.id}', received: ${typeof Q[F]=="object"?JSON.stringify(Q[F],null,"	"):Q[F]} `);return R.convert(Q[F])}),L=await this.executeCommand(P.internalId,...H);return P.result.convert(L,Q,this.converter)},void 0,{description:P.description,args:P.args,returns:P.result.description});return this.c.set(P.id,P),new M.$uM(()=>{U.dispose(),this.c.delete(P.id)})}registerCommand(P,U,Q,H,L,R){if(this.d.trace("ExtHostCommands#registerCommand",U),!U.trim().length)throw new Error("invalid id");if(this.b.has(U))throw new Error(`command '${U}' already exists`);return this.b.set(U,{callback:Q,thisArg:H,metadata:L,extension:R}),P&&Ve(this,a,"f").$registerCommand(U),new M.$uM(()=>{this.b.delete(U)&&P&&Ve(this,a,"f").$unregisterCommand(U)})}executeCommand(P,...U){return this.d.trace("ExtHostCommands#executeCommand",P),this.g(P,U,!0)}async g(P,U,Q){if(this.b.has(P))return Ve(this,a,"f").$fireCommandActivationEvent(P),this.h(P,U,!1);{let H=!1;const L=(0,N.$Rn)(U,function(R){if(R instanceof M.$vM)return C.Position.from(R);if(R instanceof M.$wM)return C.Range.from(R);if(R instanceof M.$GM)return C.location.from(R);if(M.$VN.isNotebookRange(R))return C.NotebookRange.from(R);if(R instanceof ArrayBuffer)return H=!0,s.$ue.wrap(new Uint8Array(R));if(R instanceof Uint8Array)return H=!0,s.$ue.wrap(R);if(R instanceof s.$ue)return H=!0,R;if(!Array.isArray(R))return R});try{const R=await Ve(this,a,"f").$executeCommand(P,H?new r.$fw(L):L,Q);return(0,y.$Rh)(R)}catch(R){if(R instanceof Error&&R.message==="$executeCommand:retry")return this.g(P,U,!1);throw R}}}async h(P,U,Q){const H=this.b.get(P);if(!H)throw new Error("Unknown command");const{callback:L,thisArg:R,metadata:F}=H;if(F?.args)for(let X=0;X<F.args.length;X++)try{(0,k.$ag)(U[X],F.args[X].constraint)}catch{throw new Error(`Running the contributed command: '${P}' failed. Illegal argument '${F.args[X].name}' - ${F.args[X].description}`)}const T=c.$3d.create();try{return await L.apply(R,U)}catch(X){if(P===this.converter.delegatingCommandId){const re=this.converter.getActualCommand(...U);re&&(P=re.command)}if(this.d.error(X,P,H.extension?.identifier),!Q)throw X;if(H.extension?.identifier){const re=Ve(this,v,"f").onExtensionError(H.extension.identifier,X);this.d.trace("forwarded error to extension?",re,H.extension?.identifier)}throw new class extends Error{constructor(){super((0,i.$6i)(X)),this.id=P,this.source=H.extension?.displayName??H.extension?.name}}}finally{this.j(H,P,T.elapsed())}}j(P,U,Q){P.extension&&Ve(this,g,"f").$publicLog2("Extension:ActionExecuted",{extensionId:P.extension.identifier.value,id:new h.$5o(U),duration:Q})}$executeContributedCommand(P,...U){this.d.trace("ExtHostCommands#$executeContributedCommand",P);const Q=this.b.get(P);return Q?(U=U.map(H=>this.f.reduce((L,R)=>R.processArgument(L,Q.extension?.identifier),H)),this.h(P,U,!0)):Promise.reject(new Error(`Contributed command '${P}' does not exist.`))}getCommands(P=!1){return this.d.trace("ExtHostCommands#getCommands",P),Ve(this,a,"f").$getCommands().then(U=>(P&&(U=U.filter(Q=>Q[0]!=="_")),U))}$getContributedCommandMetadata(){const P=Object.create(null);for(const[U,Q]of this.b){const{metadata:H}=Q;H&&(P[U]=H)}return Promise.resolve(P)}};e.$0O=f,a=new WeakMap,g=new WeakMap,v=new WeakMap,e.$0O=f=Xe([qe(0,n.$OO),qe(1,d.$Oj),qe(2,t.$9O)],f),e.$$O=(0,$.$ii)("IExtHostCommands");class u{constructor(P,U,Q){this.d=P,this.f=U,this.g=Q,this.delegatingCommandId=`__vsc${(0,p.$Eg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(P,U){if(!P)return;const Q={$ident:void 0,id:P.command,title:P.title,tooltip:P.tooltip};if(!P.command)return Q;const H=this.f(P.command);if(H)Q.id=H.internalId,Q.arguments=H.args.map((L,R)=>L.convert(P.arguments&&P.arguments[R]));else if((0,m.$Lb)(P.arguments)){const L=`${P.command} /${++this.c}`;this.b.set(L,P),U.add((0,b.$Sc)(()=>{this.b.delete(L),this.g.trace("CommandsConverter#DISPOSE",L)})),Q.$ident=L,Q.id=this.delegatingCommandId,Q.arguments=[L],this.g.trace("CommandsConverter#CREATE",P.command,L)}return Q}fromInternal(P){return typeof P.$ident=="string"?this.b.get(P.$ident):{command:P.id,title:P.title,arguments:P.arguments}}getActualCommand(...P){return this.b.get(P[0])}h(...P){const U=this.getActualCommand(...P);return this.g.trace("CommandsConverter#EXECUTE",P[0],U?U.command:"MISSING"),U?this.d.executeCommand(U.command,...U.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${P[0]}`)}}e.$_O=u;class E{static Arr(P){return new E(`${P.name}_array`,`Array of ${P.name}, ${P.description}`,U=>Array.isArray(U)&&U.every(Q=>P.validate(Q)),U=>U.map(Q=>P.convert(Q)))}constructor(P,U,Q,H){this.name=P,this.description=U,this.validate=Q,this.convert=H}optional(){return new E(this.name,`(optional) ${this.description}`,P=>P==null||this.validate(P),P=>P===void 0?void 0:P===null?null:this.convert(P))}with(P,U){return new E(P??this.name,U??this.description,this.validate,this.convert)}}e.$aP=E,E.Uri=new E("uri","Uri of a text document",S=>l.URI.isUri(S),S=>S),E.Position=new E("position","A position in a text document",S=>M.$vM.isPosition(S),C.Position.from),E.Range=new E("range","A range in a text document",S=>M.$wM.isRange(S),C.Range.from),E.Selection=new E("selection","A selection in a text document",S=>M.$xM.isSelection(S),C.Selection.from),E.Number=new E("number","",S=>typeof S=="number",S=>S),E.String=new E("string","",S=>typeof S=="string",S=>S),E.StringArray=E.Arr(E.String),E.CallHierarchyItem=new E("item","A call hierarchy item",S=>S instanceof M.$RM,C.CallHierarchyItem.from),E.TypeHierarchyItem=new E("item","A type hierarchy item",S=>S instanceof M.$dO,C.TypeHierarchyItem.from),E.TestItem=new E("testItem","A VS Code TestItem",S=>S instanceof o.$2O,C.TestItem.from);class w{constructor(P,U){this.description=P,this.convert=U}}e.$bP=w,w.Void=new w("no result",S=>S);class I{constructor(P,U,Q,H,L){this.id=P,this.internalId=U,this.description=Q,this.args=H,this.result=L}}e.$cP=I}),define(Pe[275],Re([1,0,18,12,2,87,97,33,31,8,7]),function(ee,e,k,M,C,N,A,m,d,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ijc=void 0;const D=[new d.$cP("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[d.$aP.Uri,d.$aP.Position],new d.$bP("A promise that resolves to an array of DocumentHighlight-instances.",b(y.DocumentHighlight.to))),new d.$cP("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[d.$aP.Uri],new d.$bP("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(n,o)=>{if((0,k.$Kb)(n))return;class s extends O.$MM{static to(i){const c=new s(i.name,y.SymbolKind.to(i.kind),i.containerName||"",new O.$GM(o[0],y.Range.to(i.range)));return c.detail=i.detail,c.range=c.location.range,c.selectionRange=y.Range.to(i.selectionRange),c.children=i.children?i.children.map(s.to):[],c}}return n.map(s.to)})),new d.$cP("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[d.$aP.Uri,new d.$aP("options","Formatting options",n=>!0,n=>n)],new d.$bP("A promise that resolves to an array of TextEdits.",b(y.TextEdit.to))),new d.$cP("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[d.$aP.Uri,d.$aP.Range,new d.$aP("options","Formatting options",n=>!0,n=>n)],new d.$bP("A promise that resolves to an array of TextEdits.",b(y.TextEdit.to))),new d.$cP("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[d.$aP.Uri,d.$aP.Position,new d.$aP("ch","Trigger character",n=>typeof n=="string",n=>n),new d.$aP("options","Formatting options",n=>!0,n=>n)],new d.$bP("A promise that resolves to an array of TextEdits.",b(y.TextEdit.to))),new d.$cP("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[d.$aP.Uri,d.$aP.Position],new d.$bP("A promise that resolves to an array of Location or LocationLink instances.",$)),new d.$cP("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[d.$aP.Uri,d.$aP.Position],new d.$bP("A promise that resolves to an array of Location or LocationLink instances.",$)),new d.$cP("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[d.$aP.Uri,d.$aP.Position],new d.$bP("A promise that resolves to an array of Location or LocationLink instances.",$)),new d.$cP("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[d.$aP.Uri,d.$aP.Position],new d.$bP("A promise that resolves to an array of Location or LocationLink instances.",$)),new d.$cP("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[d.$aP.Uri,d.$aP.Position],new d.$bP("A promise that resolves to an array of Location-instances.",b(y.location.to))),new d.$cP("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[d.$aP.Uri,d.$aP.Position],new d.$bP("A promise that resolves to an array of Hover-instances.",b(y.Hover.to))),new d.$cP("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[d.$aP.Uri,new d.$aP("position","A position in a text document",n=>Array.isArray(n)&&n.every(o=>O.$vM.isPosition(o)),n=>n.map(y.Position.from))],new d.$bP("A promise that resolves to an array of ranges.",n=>n.map(o=>{let s;for(const r of o.reverse())s=new O.$QM(y.Range.to(r),s);return s}))),new d.$cP("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[d.$aP.String.with("query","Search string")],new d.$bP("A promise that resolves to an array of SymbolInformation-instances.",n=>n.map(y.WorkspaceSymbol.to))),new d.$cP("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[d.$aP.Uri,d.$aP.Position],new d.$bP("A promise that resolves to an array of CallHierarchyItem-instances",n=>n.map(y.CallHierarchyItem.to))),new d.$cP("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[d.$aP.CallHierarchyItem],new d.$bP("A promise that resolves to an array of CallHierarchyIncomingCall-instances",n=>n.map(y.CallHierarchyIncomingCall.to))),new d.$cP("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[d.$aP.CallHierarchyItem],new d.$bP("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",n=>n.map(y.CallHierarchyOutgoingCall.to))),new d.$cP("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[d.$aP.Uri,d.$aP.Position],new d.$bP("A promise that resolves to a range and placeholder text.",n=>{if(n)return{range:y.Range.to(n.range),placeholder:n.text}})),new d.$cP("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[d.$aP.Uri,d.$aP.Position,d.$aP.String.with("newName","The new symbol name")],new d.$bP("A promise that resolves to a WorkspaceEdit.",n=>{if(n){if(n.rejectReason)throw new Error(n.rejectReason);return y.WorkspaceEdit.to(n)}})),new d.$cP("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[d.$aP.Uri,d.$aP.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new d.$bP("A promise that resolves to an array of DocumentLink-instances.",n=>n.map(y.DocumentLink.to))),new d.$cP("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[d.$aP.Uri],new d.$bP("A promise that resolves to SemanticTokensLegend.",n=>{if(n)return new O.$MN(n.tokenTypes,n.tokenModifiers)})),new d.$cP("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[d.$aP.Uri],new d.$bP("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const o=(0,A.$Yab)(n);if(o.type==="full")return new O.$ON(o.data,void 0)})),new d.$cP("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[d.$aP.Uri,d.$aP.Range.optional()],new d.$bP("A promise that resolves to SemanticTokensLegend.",n=>{if(n)return new O.$MN(n.tokenTypes,n.tokenModifiers)})),new d.$cP("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[d.$aP.Uri,d.$aP.Range],new d.$bP("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const o=(0,A.$Yab)(n);if(o.type==="full")return new O.$ON(o.data,void 0)})),new d.$cP("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[d.$aP.Uri,d.$aP.Position,d.$aP.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),d.$aP.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new d.$bP("A promise that resolves to a CompletionList-instance.",(n,o,s)=>{if(!n)return new O.$3M([]);const r=n.suggestions.map(i=>y.CompletionItem.to(i,s));return new O.$3M(r,n.incomplete)})),new d.$cP("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[d.$aP.Uri,d.$aP.Position,d.$aP.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new d.$bP("A promise that resolves to SignatureHelp.",n=>{if(n)return y.SignatureHelp.to(n)})),new d.$cP("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[d.$aP.Uri,d.$aP.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new d.$bP("A promise that resolves to an array of CodeLens-instances.",(n,o,s)=>b(r=>new O.$UM(y.Range.to(r.range),r.command&&s.fromInternal(r.command)))(n))),new d.$cP("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[d.$aP.Uri,new d.$aP("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",n=>O.$wM.isRange(n),n=>O.$xM.isSelection(n)?y.Selection.from(n):y.Range.from(n)),d.$aP.String.with("kind","Code action kind to return code actions for").optional(),d.$aP.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new d.$bP("A promise that resolves to an array of Command-instances.",(n,o,s)=>b(r=>{if(r._isSynthetic){if(!r.command)throw new Error("Synthetic code actions must have a command");return s.fromInternal(r.command)}else{const i=new O.$OM(r.title,r.kind?new O.$PM(r.kind):void 0);return r.edit&&(i.edit=y.WorkspaceEdit.to(r.edit)),r.command&&(i.command=s.fromInternal(r.command)),i.isPreferred=r.isPreferred,i}})(n))),new d.$cP("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[d.$aP.Uri],new d.$bP("A promise that resolves to an array of ColorInformation objects.",n=>n?n.map(o=>new O.$9M(y.Range.to(o.range),y.Color.to(o.color))):[])),new d.$cP("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new d.$aP("color","The color to show and insert",n=>n instanceof O.$8M,y.Color.from),new d.$aP("context","Context object with uri and range",n=>!0,n=>({uri:n.uri,range:y.Range.from(n.range)}))],new d.$bP("A promise that resolves to an array of ColorPresentation objects.",n=>n?n.map(y.ColorPresentation.to):[])),new d.$cP("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[d.$aP.Uri,d.$aP.Range],new d.$bP("A promise that resolves to an array of Inlay objects",(n,o,s)=>n.map(y.InlayHint.to.bind(void 0,s)))),new d.$cP("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[d.$aP.Uri],new d.$bP("A promise that resolves to an array of FoldingRange objects",(n,o)=>{if(n)return n.map(y.FoldingRange.to)})),new d.$cP("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new d.$bP("A promise that resolves to an array of NotebookContentProvider static info objects.",b(n=>({viewType:n.viewType,displayName:n.displayName,options:{transientOutputs:n.options.transientOutputs,transientCellMetadata:n.options.transientCellMetadata,transientDocumentMetadata:n.options.transientDocumentMetadata},filenamePattern:n.filenamePattern.map(o=>y.NotebookExclusiveDocumentPattern.to(o))})))),new d.$cP("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[d.$aP.Uri,d.$aP.Range,new d.$aP("context","An InlineValueContext",n=>n&&typeof n.frameId=="number"&&n.stoppedLocation instanceof O.$wM,n=>y.InlineValueContext.from(n))],new d.$bP("A promise that resolves to an array of InlineValue objects",n=>n.map(y.InlineValue.to))),new d.$cP("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new d.$aP("uriOrString","Uri-instance or string (only http/https)",n=>C.URI.isUri(n)||typeof n=="string"&&(0,M.$sg)(n,M.Schemas.http,M.Schemas.https),n=>n),new d.$aP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[y.ViewColumn.from(n),void 0]:[y.ViewColumn.from(n.viewColumn),y.TextEditorOpenOptions.from(n)])).optional(),d.$aP.String.with("label","").optional()],d.$bP.Void),new d.$cP("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[d.$aP.Uri.with("resource","Resource to open"),d.$aP.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new d.$aP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[y.ViewColumn.from(n),void 0]:[y.ViewColumn.from(n.viewColumn),y.TextEditorOpenOptions.from(n)])).optional()],d.$bP.Void),new d.$cP("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[d.$aP.Uri.with("left","Left-hand side resource of the diff editor"),d.$aP.Uri.with("right","Right-hand side resource of the diff editor"),d.$aP.String.with("title","Human readable title for the diff editor").optional(),new d.$aP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="object",n=>n&&[y.ViewColumn.from(n.viewColumn),y.TextEditorOpenOptions.from(n)]).optional()],d.$bP.Void),new d.$cP("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[d.$aP.String.with("title","Human readable title for the changes editor"),new d.$aP("resourceList","List of resources to compare",n=>{for(const o of n){if(o.length!==3)return!1;const[s,r,i]=o;if(!C.URI.isUri(s)||!C.URI.isUri(r)&&r!==void 0&&r!==null||!C.URI.isUri(i)&&i!==void 0&&i!==null)return!1}return!0},n=>n)],d.$bP.Void),new d.$cP("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[d.$aP.Uri,d.$aP.Position],new d.$bP("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(y.TypeHierarchyItem.to))),new d.$cP("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[d.$aP.TypeHierarchyItem],new d.$bP("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(y.TypeHierarchyItem.to))),new d.$cP("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[d.$aP.TypeHierarchyItem],new d.$bP("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(y.TypeHierarchyItem.to))),new d.$cP("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[d.$aP.TestItem],d.$bP.Void),new d.$cP("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[d.$aP.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],d.$bP.Void),new d.$cP("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[d.$aP.String.with("name","The context key name"),new d.$aP("value","The context key value",()=>!0,n=>n)],d.$bP.Void),new d.$cP("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[d.$aP.Uri,d.$aP.StringArray,new d.$aP("MappedEditsContext","Mapped Edits Context",n=>y.MappedEditsContext.is(n),n=>y.MappedEditsContext.from(n))],new d.$bP("A promise that resolves to a workspace edit or null",n=>n?y.WorkspaceEdit.to(n):null))];class l{static register(o){D.forEach(o.registerApiCommand,o),this.a(o)}static a(o){o.registerCommand(!1,"_validateWhenClauses",m.$hj)}}e.$Ijc=l;function b(n){return o=>{if(Array.isArray(o))return o.map(n)}}function $(n){if(!Array.isArray(n))return;const o=[];for(const s of n)N.$4t(s)?o.push(y.DefinitionLink.to(s)):o.push(y.location.to(s));return o}}),define(Pe[276],Re([1,0,11,6,2,4,31,8,7]),function(ee,e,k,M,C,N,A,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Skc=void 0;class y{constructor(b,$){this.extension=b,this.provider=$,this.handle=y.a++}}y.a=0;class O{constructor(b){this.session=b,this.responses=[]}}class D{constructor(b,$,n,o){this.f=n,this.g=o,this.b=new Map,this.d=new Map,this.e=b.getProxy(N.$sM.MainThreadInlineChat),$.registerApiCommand(new A.$cP("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new A.$aP("Run arguments","",s=>!0,s=>{if(s)return{initialRange:s.initialRange?m.Range.from(s.initialRange):void 0,initialSelection:d.$xM.isSelection(s.initialSelection)?m.Selection.from(s.initialSelection):void 0,message:s.message,autoSend:s.autoSend,position:s.position?m.Position.from(s.position):void 0}})],A.$bP.Void))}registerProvider(b,$,n){const o=new y(b,$);return this.b.set(o.handle,o),this.e.$registerInteractiveEditorProvider(o.handle,n?.label??b.displayName??b.name,b.identifier,typeof $.handleInteractiveEditorResponseFeedback=="function",typeof $.provideFollowups=="function",n?.supportReportIssue??!1),(0,M.$Sc)(()=>{this.e.$unregisterInteractiveEditorProvider(o.handle),this.b.delete(o.handle)})}async $prepareSession(b,$,n,o){const s=this.b.get(b);if(!s){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const r=this.f.getDocument(C.URI.revive($)),i=m.Selection.to(n),c=await s.provider.prepareInteractiveEditorSession({document:r,selection:i},o);if(!c)return;if(c.wholeRange&&!c.wholeRange.contains(i))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const h=D.a++;return this.d.set(h,new O(c)),{id:h,placeholder:c.placeholder,input:c.input,slashCommands:c.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:m.Range.from(c.wholeRange),message:c.message}}async $provideResponse(b,$,n,o){const s=this.b.get(b);if(!s)return;const r=this.d.get($.id);if(!r)return;const i={prompt:n.prompt,selection:m.Selection.to(n.selection),wholeRange:m.Range.to(n.wholeRange),attempt:n.attempt,live:n.live,previewDocument:this.f.getDocument(C.URI.revive(n.previewDocument)),withIntentDetection:n.withIntentDetection};let c=!1;const h={report:async E=>{if(!n.live&&E.edits?.length)throw new Error("Progress reporting is only supported for live sessions");c||o.isCancellationRequested||await this.e.$handleProgressChunk(n.requestId,{message:E.message,edits:E.edits?.map(m.TextEdit.from),editsShouldBeInstant:E.editsShouldBeInstant,slashCommand:E.slashCommand?.command,markdownFragment:d.$VM.isMarkdownString(E.content)?E.content.value:E.content})}},t=Promise.resolve(s.provider.provideInteractiveEditorResponse(r.session,i,h,o));let p;try{p=await(0,k.$9g)(t,o)}finally{c=!0}if(!p)return;const a=r.responses.push(p)-1,g={wholeRange:m.Range.from(p.wholeRange),placeholder:p.placeholder};if(!D.h(p))return{...g,id:a,type:"editorEdit",message:m.MarkdownString.from(p.contents),edits:[]};const{edits:v,contents:f}=p,u=f!==void 0?m.MarkdownString.from(f):void 0;return v instanceof d.$EM?{...g,id:a,type:"bulkEdit",edits:m.WorkspaceEdit.from(v),message:u}:{...g,id:a,type:"editorEdit",edits:v.map(m.TextEdit.from),message:u}}async $provideFollowups(b,$,n,o){const s=this.b.get(b),r=this.d.get($),i=r?.responses[n];if(s&&i&&s.provider.provideFollowups){const c=Promise.resolve(s.provider.provideFollowups(r.session,i,o));return(await(0,k.$9g)(c,o))?.map(m.ChatInlineFollowup.from)}}$handleFeedback(b,$,n,o){const s=this.b.get(b),r=this.d.get($),i=r?.responses[n];if(s&&i){const c=m.InteractiveEditorResponseFeedbackKind.to(o);s.provider.handleInteractiveEditorResponseFeedback?.(r.session,i,c)}}$releaseSession(b,$){}static h(b){return typeof b=="object"&&typeof b.edits=="object"}}e.$Skc=D,D.a=0}),define(Pe[277],Re([1,0,2,31]),function(ee,e,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6kc=void 0;class C{constructor(A,m,d,y,O){this.a=m,this.b=d,this.c=y;const D=new M.$cP("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new M.$aP("showOptions","Show Options",l=>!0,l=>l),new M.$aP("resource","Interactive resource Uri",l=>!0,l=>l),new M.$aP("controllerId","Notebook controller Id",l=>!0,l=>l),new M.$aP("title","Interactive editor title",l=>!0,l=>l)],new M.$bP("Notebook and input URI",l=>{if(O.debug("[ExtHostInteractive] open iw with notebook editor id",l.notebookEditorId),l.notebookEditorId!==void 0){const b=this.a.getEditorById(l.notebookEditorId);return O.debug("[ExtHostInteractive] notebook editor found",b.id),{notebookUri:k.URI.revive(l.notebookUri),inputUri:k.URI.revive(l.inputUri),notebookEditor:b.apiEditor}}return O.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",l.notebookUri,l.inputUri),{notebookUri:k.URI.revive(l.notebookUri),inputUri:k.URI.revive(l.inputUri)}}));this.c.registerApiCommand(D)}$willAddInteractiveDocument(A,m,d,y){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:m,lines:[""],languageId:d,uri:A,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(A,m){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.$6kc=C}),define(Pe[278],Re([1,0,18,11,24,5,6,28,2,20,13,4,31,8,7,76,217,25,50,218]),function(ee,e,k,M,C,N,A,m,d,y,O,D,l,b,$,n,o,s,r,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$blc=void 0,e.$clc=v;let c=class{constructor(u,E,w,I,S){this.m=E,this.n=w,this.o=I,this.q=S,this.b=new m.$Bc,this.c=new m.$Bc,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new N.$7d,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=u.getProxy(D.$sM.MainThreadNotebookKernels);const P=new l.$cP("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new l.$aP("options","Select kernel options",Q=>!0,Q=>{if(Q&&"notebookEditor"in Q&&"id"in Q){const H=this.n.getIdByEditor(Q.notebookEditor);return{id:Q.id,extension:Q.extension,notebookEditorId:H}}else if(Q&&"notebookEditor"in Q){const H=this.n.getIdByEditor(Q.notebookEditor);if(H===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${Q.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:H}}return Q})],l.$bP.Void),U=new l.$cP("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[l.$aP.Uri],new l.$bP("A promise that resolves to an array of variables",(Q,H)=>Q.map(L=>({variable:{name:L.name,value:L.value,expression:L.expression,type:L.type,language:L.language},hasNamedChildren:L.hasNamedChildren,indexedChildrenCount:L.indexedChildrenCount}))));this.o.registerApiCommand(P),this.o.registerApiCommand(U)}createNotebookController(u,E,w,I,S,P){for(const De of this.j.values())if(De.controller.id===E&&y.$Em.equals(u.identifier,De.extensionId))throw new Error(`notebook controller with id '${E}' ALREADY exist`);const U=this.k++,Q=this;this.q.trace(`NotebookController[${U}], CREATED by ${u.identifier.value}, ${E}`);const H=()=>console.warn(`NO execute handler from notebook controller '${T.id}' of extension: '${u.identifier}'`);let L=!1;const R=new N.$7d,F=new N.$7d,T={id:v(u.identifier,E),notebookType:w,extensionId:u.identifier,extensionLocation:u.extensionLocation,label:I||u.identifier.value,preloads:P?P.map(b.NotebookRendererScript.from):[]};let X=S??H,re,me;this.a.$addKernel(U,T).catch(De=>{console.log(De),L=!0});let pe=0;const ae=()=>{if(L)return;const De=++pe;Promise.resolve().then(()=>{De===pe&&this.a.$updateKernel(U,T)})},be=new m.$Bc,se={get id(){return E},get notebookType(){return T.notebookType},onDidChangeSelectedNotebooks:R.event,get label(){return T.label},set label(De){T.label=De??u.displayName??u.name,ae()},get detail(){return T.detail??""},set detail(De){T.detail=De,ae()},get description(){return T.description??""},set description(De){T.description=De,ae()},get supportedLanguages(){return T.supportedLanguages},set supportedLanguages(De){T.supportedLanguages=De,ae()},get supportsExecutionOrder(){return T.supportsExecutionOrder??!1},set supportsExecutionOrder(De){T.supportsExecutionOrder=De,ae()},get rendererScripts(){return T.preloads?T.preloads.map(b.NotebookRendererScript.to):[]},get executeHandler(){return X},set executeHandler(De){X=De??H},get interruptHandler(){return re},set interruptHandler(De){re=De,T.supportsInterrupt=!!De,ae()},set variableProvider(De){(0,s.$dG)(u,"notebookVariableProvider"),me=De,T.hasVariableProvider=!!De,De?.onDidChangeVariables(Oe=>Q.a.$variablesUpdated(Oe.uri)),ae()},get variableProvider(){return me},createNotebookCellExecution(De){if(L)throw new Error("notebook controller is DISPOSED");if(!be.has(De.notebook.uri))throw Q.q.trace(`NotebookController[${U}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(be.keys()).map(Oe=>Oe.toString())),new Error(`notebook controller is NOT associated to notebook: ${De.notebook.uri.toString()}`);return Q._createNotebookCellExecution(De,v(u.identifier,this.id))},createNotebookExecution(De){if((0,s.$dG)(u,"notebookExecution"),L)throw new Error("notebook controller is DISPOSED");if(!be.has(De.uri))throw Q.q.trace(`NotebookController[${U}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(be.keys()).map(Oe=>Oe.toString())),new Error(`notebook controller is NOT associated to notebook: ${De.uri.toString()}`);return Q._createNotebookExecution(De,v(u.identifier,this.id))},dispose:()=>{L||(this.q.trace(`NotebookController[${U}], DISPOSED`),L=!0,this.j.delete(U),R.dispose(),F.dispose(),this.a.$removeKernel(U))},updateNotebookAffinity(De,Oe){Oe===$.NotebookControllerAffinity2.Hidden&&(0,s.$dG)(u,"notebookControllerAffinityHidden"),Q.a.$updateNotebookPriority(U,De.uri,Oe)},onDidReceiveMessage:F.event,postMessage(De,Oe){return(0,s.$dG)(u,"notebookMessaging"),Q.a.$postMessage(U,Oe&&Q.n.getIdByEditor(Oe),De)},asWebviewUri(De){return(0,s.$dG)(u,"notebookMessaging"),(0,n.$Azb)(De,Q.m.remote)}};return this.j.set(U,{extensionId:u.identifier,controller:se,onDidReceiveMessage:F,onDidChangeSelection:R,associatedNotebooks:be}),se}getIdByController(u){for(const[E,w]of this.j)if(w.controller===u)return v(w.extensionId,u.id);return null}createNotebookControllerDetectionTask(u,E){const w=this.g++,I=this;this.q.trace(`NotebookControllerDetectionTask[${w}], CREATED by ${u.identifier.value}`),this.a.$addKernelDetectionTask(w,E);const S={dispose:()=>{this.f.delete(w),I.a.$removeKernelDetectionTask(w)}};return this.f.set(w,S),S}registerKernelSourceActionProvider(u,E,w){const I=this.i++,S=typeof w.onDidChangeNotebookKernelSourceActions=="function"?I:void 0,P=this;this.h.set(I,w),this.q.trace(`NotebookKernelSourceActionProvider[${I}], CREATED by ${u.identifier.value}`),this.a.$addKernelSourceActionProvider(I,I,E);let U;return S!==void 0&&(U=w.onDidChangeNotebookKernelSourceActions(Q=>this.a.$emitNotebookKernelSourceActionsChangeEvent(S))),{dispose:()=>{this.h.delete(I),P.a.$removeKernelSourceActionProvider(I,I),U?.dispose()}}}async $provideKernelSourceActions(u,E){const w=this.h.get(u);if(w){const I=new A.$Tc;return(await w.provideNotebookKernelSourceActions(E)??[]).map(P=>b.NotebookKernelSourceAction.from(P,this.o.converter,I))}return[]}$acceptNotebookAssociation(u,E,w){const I=this.j.get(u);if(I){const S=this.n.getNotebookDocument(d.URI.revive(E));w?I.associatedNotebooks.set(S.uri,!0):I.associatedNotebooks.delete(S.uri),this.q.trace(`NotebookController[${u}] ASSOCIATE notebook`,S.uri.toString(),w),I.onDidChangeSelection.fire({selected:w,notebook:S.apiNotebook})}}async $executeCells(u,E,w){const I=this.j.get(u);if(!I)return;const S=this.n.getNotebookDocument(d.URI.revive(E)),P=[];for(const U of w){const Q=S.getCell(U);Q&&P.push(Q.apiCell)}try{this.q.trace(`NotebookController[${u}] EXECUTE cells`,S.uri.toString(),P.length),await I.controller.executeHandler.call(I.controller,P,S.apiNotebook,I.controller)}catch(U){this.q.error(`NotebookController[${u}] execute cells FAILED`,U),console.error(U)}}async $cancelCells(u,E,w){const I=this.j.get(u);if(!I)return;const S=this.n.getNotebookDocument(d.URI.revive(E));if(I.controller.interruptHandler)await I.controller.interruptHandler.call(I.controller,S.apiNotebook);else for(const P of w){const U=S.getCell(P);U&&this.b.get(U.uri)?.cancel()}if(I.controller.interruptHandler){const P=this.c.get(S.uri);w.length&&Array.isArray(P)&&P.length&&P.forEach(U=>U.dispose())}}async $provideVariables(u,E,w,I,S,P,U){const Q=this.j.get(u);if(!Q)return;const H=this.n.getNotebookDocument(d.URI.revive(w)),L=Q.controller.variableProvider;if(!L)return;let R;if(I!==void 0){if(R=this.s[I],!R)return}else this.s={};const F=S==="named"?$.NotebookVariablesRequestKind.Named:$.NotebookVariablesRequestKind.Indexed,T=L.provideVariables(H.apiNotebook,R,F,P,U);let X=0;for await(const re of T){if(U.isCancellationRequested)return;const me={id:this.r++,name:re.variable.name,value:re.variable.value,type:re.variable.type,interfaces:re.variable.interfaces,language:re.variable.language,expression:re.variable.expression,hasNamedChildren:re.hasNamedChildren,indexedChildrenCount:re.indexedChildrenCount,extensionId:Q.extensionId.value};if(this.s[me.id]=re.variable,this.a.$receiveVariable(E,me),X++>=i.$Vhb)return}}$acceptKernelMessageFromRenderer(u,E,w){const I=this.j.get(u);if(!I)return;const S=this.n.getEditorById(E);I.onDidReceiveMessage.fire(Object.freeze({editor:S.apiEditor,message:w}))}$cellExecutionChanged(u,E,w){const S=this.n.getNotebookDocument(d.URI.revive(u)).getCell(E);if(S){const P=w?b.NotebookCellExecutionState.to(w):$.NotebookCellExecutionState.Idle;P!==void 0&&this.l.fire({cell:S.apiCell,state:P})}}_createNotebookCellExecution(u,E){if(u.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const I=this.n.getNotebookDocument(u.notebook.uri).getCellFromApiCell(u);if(!I)throw new Error("invalid cell");if(this.b.has(I.uri))throw new Error(`duplicate execution for ${I.uri}`);const S=new t(E,I,this.a);this.b.set(I.uri,S);const P=S.onDidChangeState(()=>{S.state===h.Resolved&&(S.dispose(),P.dispose(),this.b.delete(I.uri))});return S.asApiObject()}_createNotebookExecution(u,E){const w=this.n.getNotebookDocument(u.uri),I=u.getCells().find(U=>{const Q=w.getCellFromApiCell(U);return Q&&this.b.has(Q.uri)});if(I)throw new Error(`duplicate cell execution for ${I.document.uri}`);if(this.c.has(w.uri))throw new Error(`duplicate notebook execution for ${w.uri}`);const S=new a(E,w,this.a),P=S.onDidChangeState(()=>{S.state===p.Resolved&&(S.dispose(),P.dispose(),this.c.delete(w.uri))});return this.c.set(w.uri,[S,P]),S.asApiObject()}};e.$blc=c,e.$blc=c=Xe([qe(4,O.$Oj)],c);var h;(function(f){f[f.Init=0]="Init",f[f.Started=1]="Started",f[f.Resolved=2]="Resolved"})(h||(h={}));class t extends A.$Uc{get state(){return this.f}constructor(u,E,w){super(),this.m=E,this.n=w,this.b=t.a++,this.c=new N.$7d,this.onDidChangeState=this.c.event,this.f=h.Init,this.g=this.B(new C.$ee),this.h=new g(10,I=>this.s(I)),this.j=E.internalMetadata.executionOrder,this.n.$createExecution(this.b,u,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(u){await this.h.addItem(u)}async s(u){const E=Array.isArray(u)?u:[u];return this.n.$updateExecution(this.b,new r.$fw(E))}t(){if(this.f===h.Init)throw new Error("Must call start before modifying cell output");if(this.f===h.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(u){let E=this.m;if(u&&(E=this.m.notebook.getCellFromApiCell(u)),!E)throw new Error("INVALID cell");return E.handle}y(u){return u.map(E=>{const w=$.$ZN.ensureUniqueMimeTypes(E.items,!0);return w===E.items?b.NotebookCellOutput.from(E):b.NotebookCellOutput.from({items:w,id:E.id,metadata:E.metadata})})}async z(u,E,w){const I=this.w(E),S=this.y((0,k.$3b)(u));return this.r({editType:o.CellExecutionUpdateType.Output,cellHandle:I,append:w,outputs:S})}async C(u,E,w){return u=$.$ZN.ensureUniqueMimeTypes((0,k.$3b)(u),!0),this.r({editType:o.CellExecutionUpdateType.OutputItems,items:u.map(b.NotebookCellOutputItem.from),outputId:E.id,append:w})}asApiObject(){const u=this;return Object.freeze({get token(){return u.g.token},get cell(){return u.m.apiCell},get executionOrder(){return u.j},set executionOrder(w){u.j=w,u.s([{editType:o.CellExecutionUpdateType.ExecutionState,executionOrder:u.j}])},start(w){if(u.f===h.Resolved||u.f===h.Started)throw new Error("Cannot call start again");u.f=h.Started,u.c.fire(),u.s({editType:o.CellExecutionUpdateType.ExecutionState,runStartTime:w})},end(w,I,S){if(u.f===h.Resolved)throw new Error("Cannot call resolve twice");u.f=h.Resolved,u.c.fire(),u.h.flush();const P=S?{message:S.message,stack:S.stack,location:S?.location?{startLineNumber:S.location.start.line,startColumn:S.location.start.character,endLineNumber:S.location.end.line,endColumn:S.location.end.character}:void 0,uri:S.uri}:void 0;u.n.$completeExecution(u.b,new r.$fw({runEndTime:I,lastRunSuccess:w,error:P}))},clearOutput(w){return u.t(),u.z([],w,!1)},appendOutput(w,I){return u.t(),u.z(w,I,!0)},replaceOutput(w,I){return u.t(),u.z(w,I,!1)},appendOutputItems(w,I){return u.t(),u.C(w,I,!0)},replaceOutputItems(w,I){return u.t(),u.C(w,I,!1)}})}}t.a=0;var p;(function(f){f[f.Init=0]="Init",f[f.Started=1]="Started",f[f.Resolved=2]="Resolved"})(p||(p={}));class a extends A.$Uc{get state(){return this.f}constructor(u,E,w){super(),this.h=E,this.j=w,this.b=a.a++,this.c=new N.$7d,this.onDidChangeState=this.c.event,this.f=p.Init,this.g=this.B(new C.$ee),this.j.$createNotebookExecution(this.b,u,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===p.Resolved||this.f===p.Started)throw new Error("Cannot call start again");this.f=p.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===p.Resolved)throw new Error("Cannot call resolve twice");this.f=p.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}a.a=0;class g{constructor(u,E){this.f=u,this.g=E,this.a=[],this.b=Date.now()}addItem(u){return this.a.push(u),this.c||(this.c=new M.$Fh,this.b=Date.now(),(0,M.$jh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const u=this.c;this.c=void 0;const E=this.a;return this.a=[],this.g(E).finally(()=>u.complete())}}function v(f,u){return`${f.value}/${u}`}}),define(Pe[51],Re([1,0,5,4,3,2,16,6,7,172,14,200,24,35,201,41,11,8,31]),function(ee,e,k,M,C,N,A,m,d,y,O,D,l,b,$,n,o,s,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qkc=e.$pkc=e.$okc=e.$nkc=void 0,e.$nkc=(0,C.$ii)("IExtHostTerminalService");class i extends m.$Uc{constructor(w,I,S,P){super(),this.u=w,this._id=I,this.w=S,this.y=P,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new k.$7d),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(Q=>this.g=Q);const U=this;this.value={get name(){return U.y||""},get processId(){return U.b},get creationOptions(){return U.w},get exitStatus(){return U.j},get state(){return U.m},get selection(){return U.n},get shellIntegration(){return U.shellIntegration},sendText(Q,H=!0){U.C(),U.u.$sendText(U._id,Q,H)},show(Q){U.C(),U.u.$show(U._id,Q)},hide(){U.C(),U.u.$hide(U._id)},dispose(){U.a||(U.a=!0,U.u.$dispose(U._id))},get dimensions(){if(!(U.f===void 0||U.h===void 0))return{columns:U.f,rows:U.h}}}}dispose(){this.s.fire(),super.dispose()}async create(w,I){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:w.name,shellPath:w.shellPath??void 0,shellArgs:w.shellArgs??void 0,cwd:w.cwd??I?.cwd??void 0,env:w.env??void 0,icon:v(w.iconPath)??void 0,color:n.ThemeColor.isThemeColor(w.color)?w.color.id:void 0,initialText:w.message??void 0,strictEnv:w.strictEnv??void 0,hideFromUser:w.hideFromUser??void 0,forceShellIntegration:I?.forceShellIntegration??void 0,isFeatureTerminal:I?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:I?.useShellEnvironment??void 0,location:I?.location||this.z(w.location,I?.resolvedExtHostIdentifier),isTransient:w.isTransient??void 0})}async createExtensionTerminal(w,I,S,P,U){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:P,color:n.ThemeColor.isThemeColor(U)?U.id:void 0,location:I?.location||this.z(w,S),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z(w,I){return typeof w=="object"?"parentTerminal"in w&&w.parentTerminal&&I?{parentTerminal:I}:"viewColumn"in w?{viewColumn:s.ViewColumn.from(w.viewColumn),preserveFocus:w.preserveFocus}:void 0:w}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name(w){this.y=w}setExitStatus(w,I){this.j=Object.freeze({code:w,reason:I})}setDimensions(w,I){return w===this.f&&I===this.h||w===0||I===0?!1:(this.f=w,this.h=I,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection(w){this.n=w}_setProcessId(w){this.g?(this.g(w),this.g=void 0):this.b.then(I=>{I!==w&&(this.b=Promise.resolve(w))})}}e.$okc=i;class c{get onProcessReady(){return this.b.event}constructor(w){this.g=w,this.id=0,this.shouldPersist=!1,this.a=new k.$7d,this.onProcessData=this.a.event,this.b=new k.$7d,this.d=new k.$7d,this.onDidChangeProperty=this.d.event,this.f=new k.$7d,this.onProcessExit=this.f.event}refreshProperty(w){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${w}`)}updateProperty(w,I){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${w}, value: ${I}`)}async start(){}shutdown(){this.g.close()}input(w){this.g.handleInput?.(w)}resize(w,I){this.g.setDimensions?.({columns:w,rows:I})}clearBuffer(){}async processBinary(w){}acknowledgeDataEvent(w){}async setUnicodeVersion(w){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(w){this.g.onDidWrite(I=>this.a.fire(I)),this.g.onDidClose?.((I=void 0)=>{this.f.fire(I===void 0?void 0:I)}),this.g.onDidOverrideDimensions?.(I=>{I&&this.d.fire({type:"overrideDimensions",value:{cols:I.columns,rows:I.rows}})}),this.g.onDidChangeName?.(I=>{this.d.fire({type:"title",value:I})}),this.g.open(w||void 0),w&&this.g.setDimensions?.(w),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let h=1,t=class extends m.$Uc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(w=>w.value)}constructor(w,I,S){super(),this.Q=I,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new m.$Vc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new k.$7d,this.onDidCloseTerminal=this.H.event,this.I=new k.$7d,this.onDidOpenTerminal=this.I.event,this.J=new k.$7d,this.onDidChangeActiveTerminal=this.J.event,this.L=new k.$7d,this.onDidChangeTerminalDimensions=this.L.event,this.M=new k.$7d,this.onDidChangeTerminalState=this.M.event,this.N=new k.$7d,this.onDidChangeShell=this.N.event,this.O=new k.$7d({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new k.$7d({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=S.getProxy(M.$sM.MainThreadTerminalService),this.y=new $.$xub(this.a.$sendProcessData),this.a.$registerProcessSupport(w),this.Q.registerArgumentProcessor({processArgument:P=>{const U=Q=>{const H=Q;return this.getTerminalById(H.instanceId)?.value};switch(P?.$mid){case 15:return U(P);default:{if(Array.isArray(P))for(let Q=0;Q<P.length&&P[Q].$mid===15;Q++)P[Q]=U(P[Q]);return P}}}}),this.B({dispose:()=>{for(const[P,U]of this.g)U.shutdown(!0)}})}getDefaultShell(w){return(w?this.u:this.s)?.path||""}getDefaultShellArgs(w){return(w?this.u:this.s)?.args||[]}createExtensionTerminal(w,I){const S=new i(this.a,(0,b.$Eg)(),w,w.name),P=new c(w.pty);return S.createExtensionTerminal(w.location,I,this.R(w,I).resolvedExtHostIdentifier,v(w.iconPath),f(w.color)).then(U=>{const Q=this.S(U,P);this.h[U]=Q}),this.f.push(S),S.value}R(w,I){if(I=I||{},w.location&&typeof w.location=="object"&&"parentTerminal"in w.location){const S=w.location.parentTerminal;if(S){const P=this.f.find(U=>U.value===S);P&&(I.resolvedExtHostIdentifier=P._id)}}else w.location&&typeof w.location!="object"?I.location=w.location:I.location&&typeof I.location=="object"&&"splitActiveTerminal"in I.location&&(I.location={splitActiveTerminal:!0});return I}attachPtyToTerminal(w,I){if(!this.getTerminalById(w))throw new Error(`Cannot resolve terminal with id ${w} for virtual process`);const P=new c(I),U=this.S(w,P);this.h[w]=U}async $acceptActiveTerminalChanged(w){const I=this.b;if(w===null){this.b=void 0,I!==this.b&&this.J.fire(this.b);return}const S=this.getTerminalById(w);S&&(this.b=S,I!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(w,I){const S=this.getTerminalById(w);S&&this.O.fire({terminal:S.value,data:I})}async $acceptTerminalDimensions(w,I,S){const P=this.getTerminalById(w);P&&P.setDimensions(I,S)&&this.L.fire({terminal:P.value,dimensions:P.value.dimensions})}async $acceptDidExecuteCommand(w,I){const S=this.getTerminalById(w);S&&this.P.fire({terminal:S.value,...I})}async $acceptTerminalMaximumDimensions(w,I,S){this.g.get(w)?.resize(I,S)}async $acceptTerminalTitleChange(w,I){const S=this.getTerminalById(w);S&&(S.name=I)}async $acceptTerminalClosed(w,I,S){const P=this.X(this.f,w);if(P!==null){const U=this.f.splice(P,1)[0];U.setExitStatus(I,S),this.H.fire(U.value)}}$acceptTerminalOpened(w,I,S,P){if(I){const H=this.X(this.f,I);if(H!==null){this.f[H]._id=w,this.I.fire(this.terminals[H]),this.f[H].isOpen=!0;return}}const U={name:P.name,shellPath:P.executable,shellArgs:P.args,cwd:typeof P.cwd=="string"?P.cwd:N.URI.revive(P.cwd),env:P.env,hideFromUser:P.hideFromUser},Q=new i(this.a,w,U,S);this.f.push(Q),this.I.fire(Q.value),Q.isOpen=!0}async $acceptTerminalProcessId(w,I){this.getTerminalById(w)?._setProcessId(I)}async $startExtensionTerminal(w,I){const S=this.getTerminalById(w);if(!S)return{message:(0,y.localize)(0,null,w)};S.isOpen||await new Promise(U=>{const Q=this.onDidOpenTerminal(async H=>{H===S.value&&(Q.dispose(),U())})});const P=this.g.get(w);P?P.startSendingEvents(I):this.j[w]={initialDimensions:I}}S(w,I){const S=new m.$Tc;S.add(I.onProcessReady(U=>this.a.$sendProcessReady(w,U.pid,U.cwd,U.windowsPty))),S.add(I.onDidChangeProperty(U=>this.a.$sendProcessProperty(w,U))),this.y.startBuffering(w,I.onProcessData),S.add(I.onProcessExit(U=>this.U(w,U))),this.g.set(w,I);const P=this.j[w];return P&&I instanceof c&&(I.startSendingEvents(P.initialDimensions),delete this.j[w]),S}$acceptProcessAckDataEvent(w,I){this.g.get(w)?.acknowledgeDataEvent(I)}$acceptProcessInput(w,I){this.g.get(w)?.input(I)}$acceptTerminalInteraction(w){const I=this.getTerminalById(w);I?.setInteractedWith()&&this.M.fire(I.value)}$acceptTerminalSelection(w,I){this.getTerminalById(w)?.setSelection(I)}$acceptProcessResize(w,I,S){try{this.g.get(w)?.resize(I,S)}catch(P){if(P.code!=="EPIPE"&&P.code!=="ERR_IPC_CHANNEL_CLOSED")throw P}}$acceptProcessShutdown(w,I){this.g.get(w)?.shutdown(I)}$acceptProcessRequestInitialCwd(w){this.g.get(w)?.getInitialCwd().then(I=>this.a.$sendProcessProperty(w,{type:"initialCwd",value:I}))}$acceptProcessRequestCwd(w){this.g.get(w)?.getCwd().then(I=>this.a.$sendProcessProperty(w,{type:"cwd",value:I}))}$acceptProcessRequestLatency(w){return Promise.resolve(w)}registerLinkProvider(w){return this.z.add(w),this.z.size===1&&this.a.$startLinkProvider(),new d.$uM(()=>{this.z.delete(w),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(w,I,S){if(this.C.has(I))throw new Error(`Terminal profile provider "${I}" already registered`);return this.C.set(I,S),this.a.$registerProfileProvider(I,w.identifier.value),new d.$uM(()=>{this.C.delete(I),this.a.$unregisterProfileProvider(I)})}registerTerminalQuickFixProvider(w,I,S){if(this.D.has(w))throw new Error(`Terminal quick fix provider "${w}" is already registered`);return this.D.set(w,S),this.a.$registerQuickFixProvider(w,I),new d.$uM(()=>{this.D.delete(w),this.a.$unregisterQuickFixProvider(w)})}async $provideTerminalQuickFixes(w,I){const S=new l.$ee().token;if(S.isCancellationRequested)return;const P=this.D.get(w);if(!P)return;const U=await P.provideTerminalQuickFixes(I,S);if(U===null||Array.isArray(U)&&U.length===0)return;const Q=new m.$Tc;if(this.w.value=Q,!Array.isArray(U))return U?s.TerminalQuickFix.from(U,this.Q.converter,Q):void 0;const H=[];for(const L of U){const R=s.TerminalQuickFix.from(L,this.Q.converter,Q);R&&H.push(R)}return H}async $createContributedProfileTerminal(w,I){const S=new l.$ee().token;let P=await this.C.get(w)?.provideTerminalProfile(S);if(!S.isCancellationRequested){if(P&&!("options"in P)&&(P={options:P}),!P||!("options"in P))throw new Error(`No terminal profile options provided for id "${w}"`);if("pty"in P.options){this.createExtensionTerminal(P.options,I);return}this.createTerminalFromOptions(P.options,I)}}async $provideLinks(w,I){const S=this.getTerminalById(w);if(!S)return[];this.F.delete(w),this.G.get(w)?.dispose(!0);const U=new l.$ee;this.G.set(w,U);const Q=[],H={terminal:S.value,line:I},L=[];for(const T of this.z)L.push(o.Promises.withAsyncBody(async X=>{U.token.onCancellationRequested(()=>X({provider:T,links:[]}));const re=await T.provideTerminalLinks(H,U.token)||[];U.token.isCancellationRequested||X({provider:T,links:re})}));const R=await Promise.all(L);if(U.token.isCancellationRequested)return[];const F=new Map;for(const T of R)T&&T.links.length>0&&Q.push(...T.links.map(X=>{const re={id:h++,startIndex:X.startIndex,length:X.length,label:X.tooltip};return F.set(re.id,{provider:T.provider,link:X}),re}));return this.F.set(w,F),Q}$activateLink(w,I){const S=this.F.get(w)?.get(I);S&&S.provider.handleTerminalLink(S.link)}U(w,I){this.y.stopBuffering(w),this.g.delete(w),delete this.j[w];const S=this.h[w];S&&(S.dispose(),delete this.h[w]),this.a.$sendProcessExit(w,I)}getTerminalById(w){return this.W(this.f,w)}getTerminalIdByApiObject(w){const I=this.f.findIndex(S=>S.value===w);return I>=0?I:null}W(w,I){const S=this.X(w,I);return S!==null?w[S]:null}X(w,I){const S=w.findIndex(P=>P._id===I);return S>=0?S:null}getEnvironmentVariableCollection(w){let I=this.n.get(w.identifier.value);return I||(I=new p,this.Z(w.identifier.value,I)),I.getScopedEnvironmentVariableCollection(void 0)}Y(w,I){const S=(0,D.$8r)(I.map),P=(0,D.$9r)(I.descriptionMap);this.a.$setEnvironmentVariableCollection(w,I.persistent,S.length===0?void 0:S,P)}$initEnvironmentVariableCollections(w){w.forEach(I=>{const S=I[0],P=new p(I[1]);this.Z(S,P)})}$acceptDefaultProfile(w,I){const S=this.s;this.s=w,this.u=I,S?.path!==w.path&&this.N.fire(w.path)}Z(w,I){this.n.set(w,I),I.onDidChangeCollection(()=>{this.Y(w,I)})}};e.$pkc=t,e.$pkc=t=Xe([qe(1,r.$$O),qe(2,A.$OO)],t);class p{get persistent(){return this.b}set persistent(w){this.b=w,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(w){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new k.$7d,this.map=new Map(w)}getScopedEnvironmentVariableCollection(w){const I=this.h(w);let S=this.a.get(I);return S||(S=new a(this,w),this.a.set(I,S),S.onDidChangeCollection(()=>this.d.fire())),S}replace(w,I,S,P){this.f(w,{value:I,type:d.EnvironmentVariableMutatorType.Replace,options:S??{applyAtProcessCreation:!0},scope:P})}append(w,I,S,P){this.f(w,{value:I,type:d.EnvironmentVariableMutatorType.Append,options:S??{applyAtProcessCreation:!0},scope:P})}prepend(w,I,S,P){this.f(w,{value:I,type:d.EnvironmentVariableMutatorType.Prepend,options:S??{applyAtProcessCreation:!0},scope:P})}f(w,I){if(I.options&&I.options.applyAtProcessCreation===!1&&!I.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const S=this.g(w,I.scope),P=this.map.get(S),U=I.options?{applyAtProcessCreation:I.options.applyAtProcessCreation??!1,applyAtShellIntegration:I.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!P||P.value!==I.value||P.type!==I.type||P.options?.applyAtProcessCreation!==U.applyAtProcessCreation||P.options?.applyAtShellIntegration!==U.applyAtShellIntegration||P.scope?.workspaceFolder?.index!==I.scope?.workspaceFolder?.index){const Q=this.g(w,I.scope),H={variable:w,...I,options:U};this.map.set(Q,H),this.d.fire()}}get(w,I){const S=this.g(w,I),P=this.map.get(S);return P?u(P):void 0}g(w,I){const S=this.h(I);return S.length?`${w}:::${S}`:w}h(w){return this.j(w?.workspaceFolder)??""}j(w){return w?w.uri.toString():void 0}getVariableMap(w){const I=new Map;for(const[S,P]of this.map)this.h(P.scope)===this.h(w)&&I.set(P.variable,u(P));return I}delete(w,I){const S=this.g(w,I);this.map.delete(S),this.d.fire()}clear(w){if(w?.workspaceFolder){for(const[I,S]of this.map)S.scope?.workspaceFolder?.index===w.workspaceFolder.index&&this.map.delete(I);this.k(w)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(w,I){const S=this.h(I),P=this.descriptionMap.get(S);if(!P||P.description!==w){let U;typeof w=="string"?U=w:U=w?.value.split(`

`)[0];const Q={description:U,scope:I};this.descriptionMap.set(S,Q),this.d.fire()}}getDescription(w){const I=this.h(w);return this.descriptionMap.get(I)?.description}k(w){const I=this.h(w);this.descriptionMap.delete(I)}}class a{get persistent(){return this.b.persistent}set persistent(w){this.b.persistent=w}get onDidChangeCollection(){return this.a&&this.a.event}constructor(w,I){this.b=w,this.d=I,this.a=new k.$7d}getScoped(w){return this.b.getScopedEnvironmentVariableCollection(w)}replace(w,I,S){this.b.replace(w,I,S,this.d)}append(w,I,S){this.b.append(w,I,S,this.d)}prepend(w,I,S){this.b.prepend(w,I,S,this.d)}get(w){return this.b.get(w,this.d)}forEach(w,I){this.b.getVariableMap(this.d).forEach((S,P)=>w.call(I,P,S,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(w){this.b.delete(w,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(w){this.b.setDescription(w,this.d)}get description(){return this.b.getDescription(this.d)}}let g=class extends t{constructor(w,I){super(!1,w,I)}createTerminal(w,I,S){throw new O.$_}createTerminalFromOptions(w,I){throw new O.$_}};e.$qkc=g,e.$qkc=g=Xe([qe(0,r.$$O),qe(1,A.$OO)],g);function v(E){if(!(!E||typeof E=="string"))return"id"in E?{id:E.id,color:E.color}:E}function f(E){return n.ThemeColor.isThemeColor(E)?E:void 0}function u(E){const w={...E};return delete w.scope,w.options=w.options??void 0,delete w.variable,w}}),define(Pe[114],Re([1,0,6,3,4,16,51,5,2,11]),function(ee,e,k,M,C,N,A,m,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hlc=e.$Glc=void 0,e.$Glc=(0,M.$ii)("IExtHostTerminalShellIntegration");let O=class extends k.$Uc{constructor(n,o){super(),this.h=o,this.b=new Map,this.c=new m.$7d,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new m.$7d,this.onDidStartTerminalShellExecution=this.f.event,this.g=new m.$7d,this.onDidEndTerminalShellExecution=this.g.event,this.a=n.getProxy(C.$sM.MainThreadTerminalShellIntegration),this.B((0,k.$Sc)(()=>{for(const[s,r]of this.b)r.dispose();this.b.clear()}))}$shellIntegrationChange(n){const o=this.h.getTerminalById(n);if(!o)return;const s=o.value;let r=this.b.get(n);r||(r=new D(o.value,this.f),this.b.set(n,r),r.store.add(o.onWillDispose(()=>this.b.get(n)?.dispose())),r.store.add(r.onDidRequestShellExecution(i=>this.a.$executeCommand(n,i))),r.store.add(r.onDidRequestEndExecution(i=>this.g.fire(i.value))),r.store.add(r.onDidRequestChangeShellIntegration(i=>this.c.fire(i))),o.shellIntegration=r.value),this.c.fire({terminal:s,shellIntegration:r.value})}$shellExecutionStart(n,o,s){this.b.has(n)||this.$shellIntegrationChange(n),this.b.get(n)?.startShellExecution(o,s)}$shellExecutionEnd(n,o,s){this.b.get(n)?.endShellExecution(o,s)}$shellExecutionData(n,o){this.b.get(n)?.emitData(o)}$cwdChange(n,o){this.b.get(n)?.setCwd(o)}$closeTerminal(n){this.b.get(n)?.dispose(),this.b.delete(n)}};e.$Hlc=O,e.$Hlc=O=Xe([qe(0,N.$OO),qe(1,A.$nkc)],O);class D extends k.$Uc{get currentExecution(){return this.a}constructor(n,o){super(),this.j=n,this.m=o,this.b=!1,this.store=this.B(new k.$Tc),this.f=this.B(new m.$7d),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new m.$7d),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new m.$7d),this.onDidRequestEndExecution=this.h.event;const s=this;this.value={get cwd(){return s.c},executeCommand(r){s.g.fire(r);const i=s.startShellExecution(r,s.c).value;return s.b=!0,i}}}startShellExecution(n,o){return this.b&&this.a?this.b=!1:(this.a&&(this.a.endExecution(void 0,void 0),this.h.fire(this.a)),this.a=new l(this.j,n,o),this.m.fire(this.a.value)),this.a}emitData(n){this.currentExecution?.emitData(n)}endShellExecution(n,o){this.a&&(this.a.endExecution(n,o),this.h.fire(this.a),this.a=void 0)}setCwd(n){let o=!1;d.URI.isUri(this.c)?this.c.toString()!==n.toString()&&(o=!0):this.c!==n&&(o=!0),o&&(this.c=n,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class l{constructor(n,o,s){this.terminal=n,this.d=o,this.cwd=s,this.b=new Promise(i=>{this.c=i});const r=this;this.value={get terminal(){return n},get commandLine(){return r.d},get cwd(){return s},get exitCode(){return r.b},createDataStream(){return r.f()}}}f(){if(!this.a){if(this.c===void 0)return y.$Ih.EMPTY;this.a=new b}return this.a.createIterable()}emitData(n){this.a?.emitData(n)}endExecution(n,o){n&&(this.d=n),this.a?.endExecution(),this.a=void 0,this.c?.(o),this.c=void 0}}class b extends k.$Uc{constructor(){super(...arguments),this.b=[]}createIterable(){const n=this.a=new y.$hh;return new y.$Ih(async s=>{this.b.push(s),await n.wait()})}emitData(n){for(const o of this.b)o.emitOne(n)}endExecution(){this.a?.open(),this.a=void 0}}});var Ve=this&&this.__classPrivateFieldGet||function(ee,e,k,M){if(k==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!M:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return k==="m"?M:k==="a"?M.call(ee):M?M.value:e.get(ee)},_e=this&&this.__classPrivateFieldSet||function(ee,e,k,M,C){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?C.call(ee,k):C?C.value=k:e.set(ee,k),k};define(Pe[279],Re([1,0,11,22,24,5,251,99,6,17,35,13,4,16,113,8,7,49,75,61]),function(ee,e,k,M,C,N,A,m,d,y,O,D,l,b,$,n,o,s,r,i){"use strict";var c,h,t,p,a;Object.defineProperty(e,"__esModule",{value:!0}),e.$wlc=e.$vlc=e.$ulc=e.$tlc=void 0;let g=class extends d.$Uc{constructor(F,T,X,re){super(),this.w=re,this.f=this.B(new N.$7d),this.g=new Map,this.s=this.B(new N.$7d),this.onResultsChanged=this.f.event,this.results=[],this.h=F.getProxy(l.$sM.MainThreadTesting),this.m=new U(this.h),this.j=new E(this.h,T),X.registerArgumentProcessor({processArgument:me=>{switch(me?.$mid){case 16:{const pe=me,ae=pe.tests[pe.tests.length-1].item.extId;return this.g.get(s.$eL.root(ae))?.collection.tree.get(ae)?.actual??(0,$.$1O)(me)}case 18:{const{test:pe,message:ae}=me,be=pe.item.extId;return{test:this.g.get(s.$eL.root(be))?.collection.tree.get(be)?.actual??(0,$.$1O)({$mid:16,tests:[pe]}),message:n.TestMessage.to(ae)}}default:return me}}}),X.registerCommand(!1,"testing.getExplorerSelection",async()=>{const me=await X.executeCommand("_testing.getExplorerSelection"),pe=ae=>{const be=this.g.get(s.$eL.root(ae));if(be)return s.$eL.isRoot(ae)?be.controller:be.collection.tree.get(ae)?.actual};return{include:me?.include.map(pe).filter(y.$4f)||[],exclude:me?.exclude.map(pe).filter(y.$4f)||[]}})}createTestController(F,T,X,re){if(this.g.has(T))throw new Error(`Attempt to insert a duplicate controller with ID "${T}"`);const me=new d.$Tc,pe=me.add(new $.$4O(T,X,this.w));pe.root.label=X;const ae=new Map,be=new Set,se=this.h,De={items:pe.root.children,get label(){return X},set label(ie){X=ie,pe.root.label=ie,se.$updateController(T,{label:X})},get refreshHandler(){return re},set refreshHandler(ie){re=ie,se.$updateController(T,{canRefresh:!!ie})},get id(){return T},createRunProfile:(ie,q,de,Ne,$e,we)=>{let ge=(0,m.$9i)(ie);for(;ae.has(ge);)ge++;return new H(this.h,ae,be,this.s.event,T,ge,ie,q,de,Ne,$e,we)},createTestItem(ie,q,de){return new $.$2O(T,ie,q,de)},createTestRun:(ie,q,de=!0)=>this.j.createTestRun(T,pe,ie,q,de),invalidateTestResults:ie=>{if(ie===void 0)this.h.$markTestRetired(void 0);else{const q=ie instanceof Array?ie:[ie];this.h.$markTestRetired(q.map(de=>s.$eL.fromExtHostTestItem(de,T).toString()))}},set resolveHandler(ie){pe.resolveHandler=ie},get resolveHandler(){return pe.resolveHandler},dispose:()=>{me.dispose()}};se.$registerTestController(T,X,!!re),me.add((0,d.$Sc)(()=>se.$unregisterTestController(T)));const Oe={controller:De,collection:pe,profiles:ae,extension:F,activeProfiles:be};return this.g.set(T,Oe),me.add((0,d.$Sc)(()=>this.g.delete(T))),me.add(pe.onDidGenerateDiff(ie=>se.$publishDiff(T,ie.map(i.TestsDiffOp.serialize)))),De}createTestObserver(){return this.m.checkout()}async runTests(F,T=C.CancellationToken.None){const X=w(F);if(!X)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const re=this.g.get(X.controllerId);if(!re)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:F.include?.map(me=>s.$eL.fromExtHostTestItem(me,re.collection.root.id).toString())??[re.collection.root.id],profileGroup:L[X.kind],profileId:X.profileId,controllerId:X.controllerId}],exclude:F.exclude?.map(me=>me.id)},T)}$syncTests(){for(const{collection:F}of this.g.values())F.flushDiff();return Promise.resolve()}async $getCoverageDetails(F,T){return(await this.j.getCoverageDetails(F,T))?.map(n.TestCoverage.fromDetails)}async $disposeRun(F){this.j.disposeTestRun(F)}$configureRunProfile(F,T){this.g.get(F)?.profiles.get(T)?.configureHandler?.()}$setDefaultRunProfiles(F){const T=new Map;for(const[X,re]of Object.entries(F)){const me=this.g.get(X);if(!me)continue;const pe=new Map,ae=re.filter(se=>!me.activeProfiles.has(se)),be=[...me.activeProfiles].filter(se=>!re.includes(se));for(const se of ae)pe.set(se,!0),me.activeProfiles.add(se);for(const se of be)pe.set(se,!1),me.activeProfiles.delete(se);pe.size&&T.set(X,pe)}this.s.fire(T)}async $refreshTests(F,T){await this.g.get(F)?.controller.refreshHandler?.(T)}$publishTestResults(F){this.results=Object.freeze(F.map(n.TestResults.to).concat(this.results).sort((T,X)=>X.completedAt-T.completedAt).slice(0,32)),this.f.fire()}async $expandTest(F,T){const X=this.g.get(s.$eL.fromString(F).controllerId)?.collection;X&&(await X.expand(F,T<0?1/0:T),X.flushDiff())}$acceptDiff(F){this.m.applyDiff(F.map(T=>i.TestsDiffOp.deserialize({asCanonicalUri:X=>X},T)))}async $runControllerTests(F,T){return Promise.all(F.map(X=>this.y(X,!1,T)))}async $startContinuousRun(F,T){const X=new C.$ee(T),re=await Promise.all(F.map(me=>this.y(me,!0,X.token)));return!T.isCancellationRequested&&!re.some(me=>me.error)&&await new Promise(me=>T.onCancellationRequested(me)),X.dispose(!0),re}async y(F,T,X){const re=this.g.get(F.controllerId);if(!re)return{};const{collection:me,profiles:pe}=re,ae=pe.get(F.profileId);if(!ae)return{};const be=F.testIds.map(ie=>me.tree.get(ie)).filter(y.$4f),se=F.excludeExtIds.map(ie=>re.collection.tree.get(ie)).filter(y.$4f).filter(ie=>be.some(q=>q.fullId.compare(ie.fullId)===2));if(!be.length)return{};const De=new o.$7N(be.some(ie=>ie.actual instanceof $.$3O)?void 0:be.map(ie=>ie.actual),se.map(ie=>ie.actual),ae,T),Oe=(0,i.$hL)(F)&&this.j.prepareForMainThreadTestRun(De,I.fromInternal(F,re.collection),ae,X);try{return await ae.runHandler(De,X),{}}catch(ie){return{error:String(ie)}}finally{Oe&&Oe.hasRunningTasks&&!X.isCancellationRequested&&await N.Event.toPromise(Oe.onEnd)}}$cancelExtensionTestRun(F){F===void 0?this.j.cancelAllRuns():this.j.cancelRunById(F)}};e.$tlc=g,e.$tlc=g=Xe([qe(0,b.$OO),qe(1,D.$Oj)],g);const v=1e4;var f;(function(R){R[R.Running=0]="Running",R[R.Cancelling=1]="Cancelling",R[R.Ended=2]="Ended"})(f||(f={}));class u extends d.$Uc{get hasRunningTasks(){return this.g>0}get id(){return this.z.id}constructor(F,T,X,re,me){super(),this.z=F,this.C=T,this.D=X,this.F=re,this.f=0,this.g=0,this.h=new Map,this.j=new Set,this.s=this.B(new N.$7d),this.y=new Map,this.onEnd=this.s.event,this.m=this.B(new C.$ee(me));const pe=this.B(new k.$uh(()=>this.G(),v));this.B(this.m.token.onCancellationRequested(()=>pe.schedule()));const ae=new N.$7d;this.w=ae.event,this.B((0,d.$Sc)(()=>{ae.fire(),ae.dispose()}))}cancel(){this.f===0?(this.m.cancel(),this.f=1):this.f===1&&this.G()}getCoverageDetails(F,T){const[,X,re]=s.$eL.fromString(F).path,me=this.y.get(re);if(!me)return[];if(me.backCompatResolve)return me.backCompatResolve(T);const pe=this.h.get(X);if(!pe)throw new Error("unreachable: run task was not found");return this.F?.loadDetailedCoverage?.(pe.run,me.coverage,T)??[]}createRun(F){const T=this.z.id,X=this.z.controllerId,re=(0,O.$Eg)(),me=Oe=>(ie,...q)=>{if(be){this.D.warn(`Setting the state of test "${ie.id}" is a no-op after the run ends.`);return}this.z.isIncluded(ie)&&(this.I(ie),Oe(ie,...q))},pe=(Oe,ie)=>{const q=ie instanceof Array?ie.map(n.TestMessage.from):[n.TestMessage.from(ie)];if(Oe.uri&&Oe.range){const de={range:n.Range.from(Oe.range),uri:Oe.uri};for(const Ne of q)Ne.location=Ne.location||de}this.C.$appendTestMessagesInRun(T,re,s.$eL.fromExtHostTestItem(Oe,X).toString(),q)},ae=(Oe,ie)=>{const q=Oe.uri.toString(),de=new s.$eL([T,re,q]).toString();this.y.set(q,{coverage:Oe,backCompatResolve:ie}),this.C.$appendCoverage(T,re,n.TestCoverage.fromFile(de,Oe))};let be=!1,se;const De={isPersisted:this.z.isPersisted,token:this.m.token,name:F,onDidDispose:this.w,get coverageProvider(){return se},set coverageProvider(Oe){se=Oe,Oe&&Promise.resolve(Oe.provideFileCoverage(C.CancellationToken.None)).then(ie=>{ie?.forEach(q=>ae(q,Oe.resolveFileCoverage&&(async de=>(await Oe.resolveFileCoverage(q,de)||q).detailedCoverage)))})},addCoverage:ae,enqueued:me(Oe=>{this.C.$updateTestStateInRun(T,re,s.$eL.fromExtHostTestItem(Oe,X).toString(),1)}),skipped:me(Oe=>{this.C.$updateTestStateInRun(T,re,s.$eL.fromExtHostTestItem(Oe,X).toString(),5)}),started:me(Oe=>{this.C.$updateTestStateInRun(T,re,s.$eL.fromExtHostTestItem(Oe,X).toString(),2)}),errored:me((Oe,ie,q)=>{pe(Oe,ie),this.C.$updateTestStateInRun(T,re,s.$eL.fromExtHostTestItem(Oe,X).toString(),6,q)}),failed:me((Oe,ie,q)=>{pe(Oe,ie),this.C.$updateTestStateInRun(T,re,s.$eL.fromExtHostTestItem(Oe,X).toString(),4,q)}),passed:me((Oe,ie)=>{this.C.$updateTestStateInRun(T,re,s.$eL.fromExtHostTestItem(Oe,this.z.controllerId).toString(),3,ie)}),appendOutput:(Oe,ie,q)=>{be||(q&&(this.z.isIncluded(q)?this.I(q):q=void 0),this.C.$appendOutputToRun(T,re,M.$ue.fromString(Oe),ie&&n.location.from(ie),q&&s.$eL.fromExtHostTestItem(q,X).toString()))},end:()=>{be||(be=!0,this.C.$finishedTestRunTask(T,re),--this.g||this.H())}};return this.g++,this.h.set(re,{run:De}),this.C.$startedTestRunTask(T,{id:re,name:F,running:!0}),De}G(){for(const{run:F}of this.h.values())F.end()}H(){this.f!==2&&(this.f=2,this.s.fire())}I(F){if(!(F instanceof $.$2O))throw new r.$GO(F.id);if(this.j.has(s.$eL.fromExtHostTestItem(F,this.z.controllerId).toString()))return;const T=[],X=this.z.colllection.root;for(;;){const re=n.TestItem.from(F);if(T.unshift(re),this.j.has(re.extId)||(this.j.add(re.extId),F===X))break;F=F.parent||X}this.C.$addTestsToRun(this.z.controllerId,this.z.id,T)}dispose(){this.H(),super.dispose()}}class E{get trackers(){return this.f.values()}constructor(F,T){this.h=F,this.j=T,this.f=new Map,this.g=new Map}getCoverageDetails(F,T){const X=s.$eL.root(F);return this.g.get(X)?.getCoverageDetails(F,T)||[]}disposeTestRun(F){this.g.get(F)?.dispose(),this.g.delete(F);for(const[T,{id:X}]of this.f)X===F&&this.f.delete(T)}prepareForMainThreadTestRun(F,T,X,re){return this.k(F,T,X,re)}cancelRunById(F){this.g.get(F)?.cancel()}cancelAllRuns(){for(const F of this.f.values())F.cancel()}createTestRun(F,T,X,re,me){const pe=this.f.get(X);if(pe)return pe.createRun(re);const ae=I.fromPublic(F,T,X,me),be=w(X);this.h.$startedExtensionTestRun({controllerId:F,continuous:!!X.continuous,profile:be&&{group:L[be.kind],id:be.profileId},exclude:X.exclude?.map(De=>s.$eL.fromExtHostTestItem(De,T.root.id).toString())??[],id:ae.id,include:X.include?.map(De=>s.$eL.fromExtHostTestItem(De,T.root.id).toString())??[T.root.id],persist:me});const se=this.k(X,ae,X.profile);return N.Event.once(se.onEnd)(()=>{this.h.$finishedExtensionTestRun(ae.id)}),se.createRun(re)}k(F,T,X,re){const me=new u(T,this.h,this.j,X,re);return this.f.set(F,me),this.g.set(me.id,me),me}}e.$ulc=E;const w=R=>{if(R.profile){if(!(R.profile instanceof H))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return R.profile}};class I{static fromPublic(F,T,X,re){return new I(F,(0,O.$Eg)(),X.include?.map(me=>s.$eL.fromExtHostTestItem(me,F).toString())??[F],X.exclude?.map(me=>s.$eL.fromExtHostTestItem(me,F).toString())??[],re,T)}static fromInternal(F,T){return new I(F.controllerId,F.runId,F.testIds,F.excludeExtIds,!0,T)}constructor(F,T,X,re,me,pe){this.controllerId=F,this.id=T,this.isPersisted=me,this.colllection=pe,this.f=X.map(ae=>ae+"\0"),this.g=re.map(ae=>ae+"\0")}isIncluded(F){const T=s.$eL.fromExtHostTestItem(F,this.controllerId).toString()+"\0";for(const X of this.g)if(T===X||T.startsWith(X))return!1;for(const X of this.f)if(T===X||T.startsWith(X))return!0;return!1}}e.$vlc=I;class S{get isEmpty(){return this.f.size===0&&this.h.size===0&&this.g.size===0}constructor(F){this.k=F,this.f=new Set,this.g=new Set,this.h=new Set,this.j=new Set}add(F){this.f.add(F)}update(F){Object.assign(F.revived,n.TestItem.toPlain(F.item)),this.f.has(F)||this.g.add(F)}remove(F){if(this.f.has(F)){this.f.delete(F);return}this.g.delete(F);const T=s.$eL.parentId(F.item.extId);if(T&&this.j.has(T.toString())){this.j.add(F.item.extId);return}this.h.add(F)}getChangeEvent(){const{f:F,g:T,h:X}=this;return{get added(){return[...F].map(re=>re.revived)},get updated(){return[...T].map(re=>re.revived)},get removed(){return[...X].map(re=>re.revived)}}}complete(){this.isEmpty||this.k.fire(this.getChangeEvent())}}class P extends i.$nL{constructor(){super(...arguments),this.s=new N.$7d,this.onDidChangeTests=this.s.event}get rootTests(){return this.h}getMirroredTestDataById(F){return this.g.get(F)}getMirroredTestDataByReference(F){return this.g.get(F.id)}x(F,T){return{...F,revived:n.TestItem.toPlain(F.item),depth:T?T.depth+1:0,children:new Set}}w(){return new S(this.s)}}class U{constructor(F){this.g=F}checkout(){this.f||(this.f=this.h());const F=this.f;return F.observers++,{onDidChangeTest:F.tests.onDidChangeTests,get tests(){return[...F.tests.rootTests].map(T=>T.revived)},dispose:(0,A.$db)(()=>{--F.observers===0&&(this.g.$unsubscribeFromDiffs(),this.f=void 0)})}}getMirroredTestDataByReference(F){return this.f?.tests.getMirroredTestDataByReference(F)}applyDiff(F){this.f?.tests.apply(F)}h(){const F=new P({asCanonicalUri:T=>T});return this.g.$subscribeToDiffs(),{observers:0,tests:F}}}const Q=(R,F,T,X)=>{T?Object.assign(T,X):F.$updateTestRunConfig(R.controllerId,R.profileId,X)};class H{get label(){return this.g}set label(F){F!==this.g&&(this.g=F,Q(this,Ve(this,c,"f"),Ve(this,p,"f"),{label:F}))}get supportsContinuousRun(){return this.h}set supportsContinuousRun(F){F!==this.h&&(this.h=F,Q(this,Ve(this,c,"f"),Ve(this,p,"f"),{supportsContinuousRun:F}))}get isDefault(){return Ve(this,h,"f").has(this.profileId)}set isDefault(F){F!==this.isDefault&&(F?Ve(this,h,"f").add(this.profileId):Ve(this,h,"f").delete(this.profileId),Q(this,Ve(this,c,"f"),Ve(this,p,"f"),{isDefault:F}))}get tag(){return this._tag}set tag(F){F?.id!==this._tag?.id&&(this._tag=F,Q(this,Ve(this,c,"f"),Ve(this,p,"f"),{tag:F?n.TestTag.namespace(this.controllerId,F.id):null}))}get configureHandler(){return this.f}set configureHandler(F){F!==this.f&&(this.f=F,Q(this,Ve(this,c,"f"),Ve(this,p,"f"),{hasConfigurationHandler:!!F}))}get onDidChangeDefault(){return N.Event.chain(Ve(this,t,"f"),F=>F.map(T=>T.get(this.controllerId)?.get(this.profileId)).filter(y.$4f))}constructor(F,T,X,re,me,pe,ae,be,se,De=!1,Oe=void 0,ie=!1){this.controllerId=me,this.profileId=pe,this.g=ae,this.kind=be,this.runHandler=se,this._tag=Oe,this.h=ie,c.set(this,void 0),h.set(this,void 0),t.set(this,void 0),p.set(this,void 0),a.set(this,void 0),_e(this,c,F,"f"),_e(this,a,T,"f"),_e(this,h,X,"f"),_e(this,t,re,"f"),T.set(pe,this);const q=L[be];if(typeof q!="number")throw new Error(`Unknown TestRunProfile.group ${be}`);De&&X.add(pe),_e(this,p,{profileId:pe,controllerId:me,tag:Oe?n.TestTag.namespace(this.controllerId,Oe.id):null,label:ae,group:q,isDefault:De,hasConfigurationHandler:!1,supportsContinuousRun:ie},"f"),queueMicrotask(()=>{Ve(this,p,"f")&&(Ve(this,c,"f").$publishTestRunProfile(Ve(this,p,"f")),_e(this,p,void 0,"f"))})}dispose(){Ve(this,a,"f")?.delete(this.profileId)&&(_e(this,a,void 0,"f"),Ve(this,c,"f").$removeTestProfile(this.controllerId,this.profileId)),_e(this,p,void 0,"f")}}e.$wlc=H,c=new WeakMap,h=new WeakMap,t=new WeakMap,p=new WeakMap,a=new WeakMap;const L={[o.TestRunProfileKind.Coverage]:8,[o.TestRunProfileKind.Debug]:4,[o.TestRunProfileKind.Run]:2}}),define(Pe[115],Re([1,0,56,14,90,8,7]),function(ee,e,k,M,C,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XO=e.$WO=e.$VO=void 0;class m{constructor(l,b,$){const n=m.c.nextId();l.$registerTextEditorDecorationType(b.identifier,n,N.DecorationRenderOptions.from($)),this.value=Object.freeze({key:n,dispose(){l.$removeTextEditorDecorationType(n)}})}}e.$VO=m,m.c=new C.$TO("TextEditorDecorationType");class d{constructor(l,b){this.g=[],this.h=void 0,this.j=!1,this.c=l,this.d=l.version,this.e=b.undoStopBefore,this.f=b.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(l,b){this.k();let $=null;if(l instanceof A.$vM)$=new A.$wM(l,l);else if(l instanceof A.$wM)$=l;else throw new Error("Unrecognized location");this.l($,b,!1)}insert(l,b){this.k(),this.l(new A.$wM(l,l),b,!0)}delete(l){this.k();let b=null;if(l instanceof A.$wM)b=l;else throw new Error("Unrecognized location");this.l(b,null,!0)}l(l,b,$){const n=this.c.validateRange(l);this.g.push({range:n,text:b,forceMoveMarkers:$})}setEndOfLine(l){if(this.k(),l!==A.EndOfLine.LF&&l!==A.EndOfLine.CRLF)throw(0,M.$7)("endOfLine");this.h=l}}class y{constructor(l,b,$,n){this.c=l,this.d=b,this._accept($),this.e=n;const o=this;this.value={get tabSize(){return o.f},set tabSize(s){o.n(s)},get indentSize(){return o.g},set indentSize(s){o.p(s)},get insertSpaces(){return o.j},set insertSpaces(s){o.s(s)},get cursorStyle(){return o.k},set cursorStyle(s){o.t(s)},get lineNumbers(){return o.l},set lineNumbers(s){o.u(s)}}}_accept(l){this.f=l.tabSize,this.g=l.indentSize,this.h=l.originalIndentSize,this.j=l.insertSpaces,this.k=l.cursorStyle,this.l=N.TextEditorLineNumbersStyle.to(l.lineNumbers)}m(l){if(l==="auto")return"auto";if(typeof l=="number"){const b=Math.floor(l);return b>0?b:null}if(typeof l=="string"){const b=parseInt(l,10);return isNaN(b)?null:b>0?b:null}return null}n(l){const b=this.m(l);if(b!==null){if(typeof b=="number"){if(this.f===b)return;this.f=b}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:b}))}}o(l){if(l==="tabSize")return"tabSize";if(typeof l=="number"){const b=Math.floor(l);return b>0?b:null}if(typeof l=="string"){const b=parseInt(l,10);return isNaN(b)?null:b>0?b:null}return null}p(l){const b=this.o(l);if(b!==null){if(typeof b=="number"){if(this.h===b)return;this.g=b,this.h=b}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:b}))}}q(l){return l==="auto"?"auto":l==="false"?!1:!!l}s(l){const b=this.q(l);if(typeof b=="boolean"){if(this.j===b)return;this.j=b}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:b}))}t(l){this.k!==l&&(this.k=l,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:l})))}u(l){this.l!==l&&(this.l=l,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:N.TextEditorLineNumbersStyle.from(l)})))}assign(l){const b={};let $=!1;if(typeof l.tabSize<"u"){const n=this.m(l.tabSize);n==="auto"?($=!0,b.tabSize=n):typeof n=="number"&&this.f!==n&&(this.f=n,$=!0,b.tabSize=n)}if(typeof l.indentSize<"u"){const n=this.o(l.indentSize);n==="tabSize"?($=!0,b.indentSize=n):typeof n=="number"&&this.h!==n&&(this.g=n,this.h=n,$=!0,b.indentSize=n)}if(typeof l.insertSpaces<"u"){const n=this.q(l.insertSpaces);n==="auto"?($=!0,b.insertSpaces=n):this.j!==n&&(this.j=n,$=!0,b.insertSpaces=n)}typeof l.cursorStyle<"u"&&this.k!==l.cursorStyle&&(this.k=l.cursorStyle,$=!0,b.cursorStyle=l.cursorStyle),typeof l.lineNumbers<"u"&&this.l!==l.lineNumbers&&(this.l=l.lineNumbers,$=!0,b.lineNumbers=N.TextEditorLineNumbersStyle.from(l.lineNumbers)),$&&this.v("setOptions",this.c.$trySetOptions(this.d,b))}v(l,b){b.catch($=>{this.e.warn(`ExtHostTextEditorOptions '${l}' failed:'`),this.e.warn($)})}}e.$WO=y;class O{constructor(l,b,$,n,o,s,r,i){this.id=l,this.j=b,this.k=$,this.g=!1,this.h=new Set,this.c=o,this.d=new y(this.j,this.id,s,$),this.e=r,this.f=i;const c=this;this.value=Object.freeze({get document(){return n.value},set document(h){throw new M.$9("document")},get selection(){return c.c&&c.c[0]},set selection(h){if(!(h instanceof A.$xM))throw(0,M.$7)("selection");c.c=[h],c.l()},get selections(){return c.c},set selections(h){if(!Array.isArray(h)||h.some(t=>!(t instanceof A.$xM)))throw(0,M.$7)("selections");c.c=h,c.l()},get visibleRanges(){return c.e},set visibleRanges(h){throw new M.$9("visibleRanges")},get options(){return c.d.value},set options(h){c.g||c.d.assign(h)},get viewColumn(){return c.f},set viewColumn(h){throw new M.$9("viewColumn")},edit(h,t={undoStopBefore:!0,undoStopAfter:!0}){if(c.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const p=new d(n.value,t);return h(p),c.m(p)},insertSnippet(h,t,p={undoStopBefore:!0,undoStopAfter:!0}){if(c.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let a;if(!t||Array.isArray(t)&&t.length===0)a=c.c.map(g=>N.Range.from(g));else if(t instanceof A.$vM){const{lineNumber:g,column:v}=N.Position.from(t);a=[{startLineNumber:g,startColumn:v,endLineNumber:g,endColumn:v}]}else if(t instanceof A.$wM)a=[N.Range.from(t)];else{a=[];for(const g of t)if(g instanceof A.$wM)a.push(N.Range.from(g));else{const{lineNumber:v,column:f}=N.Position.from(g);a.push({startLineNumber:v,startColumn:f,endLineNumber:v,endColumn:f})}}return b.$tryInsertSnippet(l,n.value.version,h.value,a,p)},setDecorations(h,t){const p=t.length===0;p&&!c.h.has(h.key)||(p?c.h.delete(h.key):c.h.add(h.key),c.n(()=>{if(N.$LO(t))return b.$trySetDecorations(l,h.key,N.$MO(t));{const a=new Array(4*t.length);for(let g=0,v=t.length;g<v;g++){const f=t[g];a[4*g]=f.start.line+1,a[4*g+1]=f.start.character+1,a[4*g+2]=f.end.line+1,a[4*g+3]=f.end.character+1}return b.$trySetDecorationsFast(l,h.key,a)}}))},revealRange(h,t){c.n(()=>b.$tryRevealRange(l,N.Range.from(h),t||A.TextEditorRevealType.Default))},show(h){b.$tryShowEditor(l,N.ViewColumn.from(h))},hide(){b.$tryHideEditor(l)}})}dispose(){(0,k.ok)(!this.g),this.g=!0}_acceptOptions(l){(0,k.ok)(!this.g),this.d._accept(l)}_acceptVisibleRanges(l){(0,k.ok)(!this.g),this.e=l}_acceptViewColumn(l){(0,k.ok)(!this.g),this.f=l}_acceptSelections(l){(0,k.ok)(!this.g),this.c=l}async l(){const l=this.c.map(N.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,l)),this.value}m(l){const b=l.finalize();if(b.edits.length===0&&!b.setEndOfLine)return Promise.resolve(!0);const $=b.edits.map(o=>o.range);$.sort((o,s)=>o.end.line===s.end.line?o.end.character===s.end.character?o.start.line===s.start.line?o.start.character-s.start.character:o.start.line-s.start.line:o.end.character-s.end.character:o.end.line-s.end.line);for(let o=0,s=$.length-1;o<s;o++){const r=$[o].end;if($[o+1].start.isBefore(r))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const n=b.edits.map(o=>({range:N.Range.from(o.range),text:o.text,forceMoveMarkers:o.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,b.documentVersionId,n,{setEndOfLine:typeof b.setEndOfLine=="number"?N.EndOfLine.from(b.setEndOfLine):void 0,undoStopBefore:b.undoStopBefore,undoStopAfter:b.undoStopAfter})}n(l){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):l().then(()=>this,b=>(b instanceof Error&&b.name==="DISPOSED"||this.k.warn(b),null))}}e.$XO=O}),define(Pe[67],Re([1,0,56,5,6,2,3,4,111,16,115,8,13,28,12,39,40]),function(ee,e,k,M,C,N,A,m,d,y,O,D,l,b,$,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZO=e.$YO=void 0;class s{constructor(c){this.value=c,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let r=class{constructor(c,h){this.h=c,this.i=h,this.a=null,this.b=new Map,this.c=new b.$Bc,this.d=new M.$7d,this.e=new M.$7d,this.f=new M.$7d,this.g=new M.$7d,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(c){this.acceptDocumentsAndEditorsDelta(c)}acceptDocumentsAndEditorsDelta(c){const h=[],t=[],p=[];if(c.removedDocuments)for(const a of c.removedDocuments){const g=N.URI.revive(a),v=this.c.get(g);v?.unref()&&(this.c.delete(g),h.push(v.value))}if(c.addedDocuments)for(const a of c.addedDocuments){const g=N.URI.revive(a.uri);let v=this.c.get(g);if(v&&g.scheme!==$.Schemas.vscodeNotebookCell&&g.scheme!==$.Schemas.vscodeInteractiveInput)throw new Error(`document '${g} already exists!'`);v||(v=new s(new d.$RO(this.h.getProxy(m.$sM.MainThreadDocuments),g,a.lines,a.EOL,a.versionId,a.languageId,a.isDirty)),this.c.set(g,v),t.push(v.value)),v.ref()}if(c.removedEditors)for(const a of c.removedEditors){const g=this.b.get(a);this.b.delete(a),g&&p.push(g)}if(c.addedEditors)for(const a of c.addedEditors){const g=N.URI.revive(a.documentUri);k.ok(this.c.has(g),`document '${g}' does not exist`),k.ok(!this.b.has(a.id),`editor '${a.id}' already exists!`);const v=this.c.get(g).value,f=new O.$XO(a.id,this.h.getProxy(m.$sM.MainThreadTextEditors),this.i,new o.$V(()=>v.document),a.selections.map(D.Selection.to),a.options,a.visibleRanges.map(u=>D.Range.to(u)),typeof a.editorPosition=="number"?D.ViewColumn.to(a.editorPosition):void 0);this.b.set(a.id,f)}c.newActiveEditor!==void 0&&(k.ok(c.newActiveEditor===null||this.b.has(c.newActiveEditor),`active editor '${c.newActiveEditor}' does not exist`),this.a=c.newActiveEditor),(0,C.$Pc)(h),(0,C.$Pc)(p),c.removedDocuments&&this.e.fire(h),c.addedDocuments&&this.d.fire(t),(c.removedEditors||c.addedEditors)&&this.f.fire(this.allEditors().map(a=>a.value)),c.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(c){return this.c.get(c)?.value}allDocuments(){return n.Iterable.map(this.c.values(),c=>c.value)}getEditor(c){return this.b.get(c)}activeEditor(c){if(!this.a)return;const h=this.b.get(this.a);return c?h:h?.value}allEditors(){return[...this.b.values()]}};e.$YO=r,e.$YO=r=Xe([qe(0,y.$OO),qe(1,l.$Oj)],r),e.$ZO=(0,A.$ii)("IExtHostDocumentsAndEditors")}),define(Pe[280],Re([1,0,18,5,4,115,8,7]),function(ee,e,k,M,C,N,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sjc=void 0;class d{constructor(O,D){this.i=D,this.a=new M.$7d,this.b=new M.$7d,this.c=new M.$7d,this.d=new M.$7d,this.f=new M.$7d,this.g=new M.$7d,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=O.getProxy(C.$sM.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(l=>this.g.fire(l)),this.i.onDidChangeActiveTextEditor(l=>this.f.fire(l))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(O){const D=this.i.allEditors();return O?D:D.map(l=>l.value)}async showTextDocument(O,D,l){let b;typeof D=="number"?b={position:A.ViewColumn.from(D),preserveFocus:l}:typeof D=="object"?b={position:A.ViewColumn.from(D.viewColumn),preserveFocus:D.preserveFocus,selection:typeof D.selection=="object"?A.Range.from(D.selection):void 0,pinned:typeof D.preview=="boolean"?!D.preview:void 0}:b={preserveFocus:!1};const $=await this.h.$tryShowTextDocument(O.uri,b),n=$&&this.i.getEditor($);if(n)return n.value;throw $?new Error(`Could NOT open editor for "${O.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${O.uri.toString()}".`)}createTextEditorDecorationType(O,D){return new N.$VO(this.h,O,D).value}$acceptEditorPropertiesChanged(O,D){const l=this.i.getEditor(O);if(!l)throw new Error("unknown text editor");if(D.options&&l._acceptOptions(D.options),D.selections){const b=D.selections.selections.map(A.Selection.to);l._acceptSelections(b)}if(D.visibleRanges){const b=k.$Hb(D.visibleRanges.map(A.Range.to));l._acceptVisibleRanges(b)}if(D.options&&this.b.fire({textEditor:l.value,options:{...D.options,lineNumbers:A.TextEditorLineNumbersStyle.to(D.options.lineNumbers)}}),D.selections){const b=m.TextEditorSelectionChangeKind.fromValue(D.selections.source),$=D.selections.selections.map(A.Selection.to);this.a.fire({textEditor:l.value,selections:$,kind:b})}if(D.visibleRanges){const b=k.$Hb(D.visibleRanges.map(A.Range.to));this.c.fire({textEditor:l.value,visibleRanges:b})}}$acceptEditorPositionData(O){for(const D in O){const l=this.i.getEditor(D);if(!l)throw new Error("Unknown text editor");const b=A.ViewColumn.to(O[D]);l.value.viewColumn!==b&&(l._acceptViewColumn(b),this.d.fire({textEditor:l.value,viewColumn:b}))}}getDiffInformation(O){return Promise.resolve(this.h.$getDiffInformation(O))}}e.$Sjc=d}),define(Pe[281],Re([1,0,2,3,4,6,7,8,20,17]),function(ee,e,k,M,C,N,A,m,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zlc=e.$ylc=void 0,e.$ylc=(0,M.$ii)("IExtHostTimeline");class O{constructor(b,$){this.b=new Map,this.c=new Map,this.a=b.getProxy(C.$sM.MainThreadTimeline),$.registerArgumentProcessor({processArgument:(n,o)=>{if(n&&n.$mid===12)if(this.b.get(n.source)&&d.$Em.equals(o,this.b.get(n.source)?.extension)){const s=n.uri===void 0?void 0:k.URI.revive(n.uri);return this.c.get(n.source)?.get(D(s))?.get(n.handle)}else return;return n}})}async $getTimeline(b,$,n,o){return this.b.get(b)?.provider.provideTimeline(k.URI.revive($),n,o)}registerTimelineProvider(b,$,n,o){const s=new N.$Tc,r=this.d($.id,o,s).bind(this);let i;$.onDidChange&&(i=$.onDidChange(h=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...h,id:$.id}),this));const c=this.c;return this.f({...$,scheme:b,onDidChange:void 0,async provideTimeline(h,t,p){t?.resetCache&&(s.clear(),c.get($.id)?.clear());const a=await $.provideTimeline(h,t,p);if(a==null)return;const g=r(h,t);return{...a,source:$.id,items:a.items.map(g)}},dispose(){for(const h of c.values())h.get($.id)?.clear();i?.dispose(),s.dispose()}},n)}d(b,$,n){return(o,s)=>{let r;if(s?.cacheResults){let i=this.c.get(b);i===void 0&&(i=new Map,this.c.set(b,i));const c=D(o);r=i.get(c),r===void 0&&(r=new Map,i.set(c,r))}return i=>{const{iconPath:c,...h}=i,t=`${b}|${i.id??i.timestamp}`;r?.set(t,i);let p,a,g;i.iconPath&&(c instanceof A.$qN?g={id:c.id,color:c.color}:k.URI.isUri(c)?(p=c,a=c):{light:p,dark:a}=c);let v;return A.$VM.isMarkdownString(h.tooltip)?v=m.MarkdownString.from(h.tooltip):(0,y.$Vf)(h.tooltip)?v=h.tooltip:A.$VM.isMarkdownString(h.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),v=m.MarkdownString.from(h.detail)):(0,y.$Vf)(h.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),v=h.detail),{...h,id:h.id??void 0,handle:t,source:b,command:i.command?$.toInternal(i.command,n):void 0,icon:p,iconDark:a,themeIcon:g,tooltip:v,accessibilityInformation:i.accessibilityInformation}}}}f(b,$){if(this.b.get(b.id))throw new Error(`Timeline Provider ${b.id} already exists.`);return this.a.$registerTimelineProvider({id:b.id,label:b.label,scheme:b.scheme}),this.b.set(b.id,{provider:b,extension:$}),(0,N.$Sc)(()=>{for(const o of this.c.values())o.get(b.id)?.clear();this.b.delete(b.id),this.a.$unregisterTimelineProvider(b.id),b.dispose()})}}e.$zlc=O;function D(l){return l?.toString()}}),define(Pe[282],Re([1,0,173,23,2,5,6,211,11,7,17,18,8,54,24,144,25]),function(ee,e,k,M,C,N,A,m,d,y,O,D,l,b,$,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Alc=void 0;function s(c,h){if((0,O.$Vf)(c))return{label:c};if(c&&typeof c=="object"&&typeof c.label=="string"){let t;return Array.isArray(c.highlights)&&(t=c.highlights.filter(p=>p.length===2&&typeof p[0]=="number"&&typeof p[1]=="number"),t=t.length?t:void 0),{label:c.label,highlights:t}}}class r extends A.$Uc{constructor(h,t,p){super(),this.f=h,this.g=t,this.h=p,this.a=new Map,this.b=new n.$q0;function a(g){return g&&g.$treeViewId&&(g.$treeItemHandle||g.$selectedTreeItems||g.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:g=>a(g)?this.r(g):Array.isArray(g)&&g.length>0?g.map(v=>a(v)?this.r(v):v):g})}registerTreeDataProvider(h,t,p){const a=this.createTreeView(h,{treeDataProvider:t},p);return{dispose:()=>a.dispose()}}createTreeView(h,t,p){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const a=t.dragAndDropController?.dropMimeTypes??[],g=t.dragAndDropController?.dragMimeTypes??[],v=!!t.dragAndDropController?.handleDrag,f=!!t.dragAndDropController?.handleDrop,u=this.m(h,t,p),E={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:a,dragMimeTypes:g,hasHandleDrag:v,hasHandleDrop:f,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},w=this.f.$registerTreeViewDataProvider(h,E),I={get onDidCollapseElement(){return u.onDidCollapseElement},get onDidExpandElement(){return u.onDidExpandElement},get selection(){return u.selectedElements},get onDidChangeSelection(){return u.onDidChangeSelection},get activeItem(){return(0,o.$dG)(p,"treeViewActiveItem"),u.focusedElement},get onDidChangeActiveItem(){return(0,o.$dG)(p,"treeViewActiveItem"),u.onDidChangeActiveItem},get visible(){return u.visible},get onDidChangeVisibility(){return u.onDidChangeVisibility},get onDidChangeCheckboxState(){return u.onDidChangeCheckboxState},get message(){return u.message},set message(S){(0,b.$Hk)(S)&&(0,o.$dG)(p,"treeViewMarkdownMessage"),u.message=S},get title(){return u.title},set title(S){u.title=S},get description(){return u.description},set description(S){u.description=S},get badge(){return u.badge},set badge(S){S!==void 0&&y.ViewBadge.isViewBadge(S)?u.badge={value:Math.floor(Math.abs(S.value)),tooltip:S.tooltip}:S===void 0&&(u.badge=void 0)},reveal:(S,P)=>u.reveal(S,P),dispose:async()=>{await w,this.a.delete(h),u.dispose()}};return this.B(I),I}$getChildren(h,t){const p=this.a.get(h);return p?p.getChildren(t):Promise.reject(new m.$GF(h))}async $handleDrop(h,t,p,a,g,v,f,u){const E=this.a.get(h);if(!E)return Promise.reject(new m.$GF(h));const w=l.DataTransfer.toDataTransfer(p,async I=>(await this.f.$resolveDropFileData(h,t,I)).buffer);return f===h&&u&&await this.j(w,E,u,g,v),E.onDrop(w,a,g)}async j(h,t,p,a,g){const v=this.b.removeDragOperationTransfer(g);if(v)(await v)?.forEach((f,u)=>{f&&h.set(u,f)});else if(g&&t.handleDrag){const f=t.handleDrag(p,h,a);this.b.addDragOperationTransfer(g,f),await f}return h}async $handleDrag(h,t,p,a){const g=this.a.get(h);if(!g)return Promise.reject(new m.$GF(h));const v=await this.j(new y.$mN,g,t,a,p);if(!(!v||a.isCancellationRequested))return l.DataTransfer.from(v)}async $hasResolve(h){const t=this.a.get(h);if(!t)throw new m.$GF(h);return t.hasResolve}$resolve(h,t,p){const a=this.a.get(h);if(!a)throw new m.$GF(h);return a.resolveTreeItem(t,p)}$setExpanded(h,t,p){const a=this.a.get(h);if(!a)throw new m.$GF(h);a.setExpanded(t,p)}$setSelectionAndFocus(h,t,p){const a=this.a.get(h);if(!a)throw new m.$GF(h);a.setSelectionAndFocus(t,p)}$setVisible(h,t){const p=this.a.get(h);if(!p){if(!t)return;throw new m.$GF(h)}p.setVisible(t)}$changeCheckboxState(h,t){const p=this.a.get(h);if(!p)throw new m.$GF(h);p.setCheckboxState(t)}m(h,t,p){const a=this.B(new i(h,t,this.f,this.g.converter,this.h,p));return this.a.set(h,a),a}r(h){const t=this.a.get(h.$treeViewId);return t&&"$treeItemHandle"in h?t.getExtensionElement(h.$treeItemHandle):t&&"$focusedTreeItem"in h&&h.$focusedTreeItem?t.focusedElement:null}}e.$Alc=r;class i extends A.$Uc{get visible(){return this.r}get selectedElements(){return this.s.map(h=>this.getExtensionElement(h)).filter(h=>!(0,O.$5f)(h))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(h,t,p,a,g,v){if(super(),this.I=h,this.J=p,this.L=a,this.M=g,this.N=v,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new N.$7d),this.onDidExpandElement=this.u.event,this.w=this.B(new N.$7d),this.onDidCollapseElement=this.w.event,this.y=this.B(new N.$7d),this.onDidChangeSelection=this.y.event,this.z=this.B(new N.$7d),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new N.$7d),this.onDidChangeVisibility=this.C.event,this.D=this.B(new N.$7d),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new N.$7d),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new $.$ee,v.contributes&&v.contributes.views)for(const w in v.contributes.views)for(const I of v.contributes.views[w])I.id===h&&(this.P=I.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(w=>this.F.fire({message:!1,element:w})));let f,u;const E=N.Event.debounce(this.F.event,(w,I)=>(w||(w={message:!1,elements:[]}),I.element!==!1&&(f||(f=new Promise(S=>u=S),this.G=this.G.then(()=>f)),Array.isArray(I.element)?w.elements.push(...I.element):w.elements.push(I.element)),I.message&&(w.message=!0),w),200,!0);this.B(E(({message:w,elements:I})=>{I.length&&(this.H=this.H.then(()=>{const S=u;return f=null,this.$(I).then(()=>S())})),w&&this.J.$setMessage(this.I,l.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(h){const t=h?this.getExtensionElement(h):void 0;if(h&&!t)return this.M.error(`No tree item with id '${h}' found.`),Promise.resolve([]);let p=this.X(h);return p||(p=await this.Y(t)),p?p.map(a=>a.item):void 0}getExtensionElement(h){return this.j.get(h)}reveal(h,t){t=t||{select:!0,focus:!1};const p=(0,O.$5f)(t.select)?!0:t.select,a=(0,O.$5f)(t.focus)?!1:t.focus,g=(0,O.$5f)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):h?this.G.then(()=>this.S(h)).then(v=>this.W(h,v[v.length-1]).then(f=>this.J.$reveal(this.I,{item:f.item,parentChain:v.map(u=>u.item)},{select:p,focus:a,expand:g})),v=>this.M.error(v)):this.J.$reveal(this.I,void 0,{select:p,focus:a,expand:g})}get message(){return this.O}set message(h){this.O=h,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(h){this.P=h,this.J.$setTitle(this.I,h,this.Q)}get description(){return this.Q}set description(h){this.Q=h,this.J.$setTitle(this.I,this.P,h)}get badge(){return this.R}set badge(h){this.R?.value===h?.value&&this.R?.tooltip===h?.tooltip||(this.R=l.ViewBadge.from(h),this.J.$setBadge(this.I,h))}setExpanded(h,t){const p=this.getExtensionElement(h);p&&(t?this.u.fire(Object.freeze({element:p})):this.w.fire(Object.freeze({element:p})))}setSelectionAndFocus(h,t){const p=!(0,D.$ub)(this.s,h);this.s=h;const a=this.t!==t;this.t=t,p&&this.y.fire(Object.freeze({selection:this.selectedElements})),a&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(h){h!==this.r&&(this.r=h,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(h){const t=(await Promise.all(h.map(async p=>{const a=this.getExtensionElement(p.treeItemHandle);return a?{extensionItem:a,treeItem:await this.f.getTreeItem(a),newState:p.newState?y.TreeItemCheckboxState.Checked:y.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(p=>p!==void 0);t.forEach(p=>{p.treeItem.checkboxState=p.newState?y.TreeItemCheckboxState.Checked:y.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(p=>[p.extensionItem,p.newState])})}async handleDrag(h,t,p){const a=[];for(const g of h){const v=this.getExtensionElement(g);v&&a.push(v)}if(!(!this.g?.handleDrag||a.length===0))return await this.g.handleDrag(a,t,p),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(h,t,p){const a=t?this.getExtensionElement(t):void 0;if(!(!a&&t||!this.g?.handleDrop))return(0,d.$ah)(()=>this.g?.handleDrop?this.g.handleDrop(a,h,p):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(h,t){if(!this.f.resolveTreeItem)return;const p=this.j.get(h);if(p){const a=this.m.get(p);if(a){const g=await this.f.resolveTreeItem(a.extensionItem,p,t)??a.extensionItem;return this.hb(g),a.item.tooltip=this.eb(g.tooltip),a.item.command=this.fb(a.disposableStore,g.command),a.item}}}S(h){return this.U(h).then(t=>t?this.S(t).then(p=>this.W(t,p[p.length-1]).then(a=>(p.push(a),p))):Promise.resolve([]))}U(h){const t=this.m.get(h);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,d.$ah)(()=>this.f.getParent(h))}W(h,t){const p=this.m.get(h);return p?Promise.resolve(p):(0,d.$ah)(()=>this.f.getTreeItem(h)).then(a=>this.kb(h,a,t,!0)).then(a=>this.getChildren(t?t.item.handle:void 0).then(()=>{const g=this.getExtensionElement(a);if(g){const v=this.m.get(g);if(v)return Promise.resolve(v)}throw new Error(`Cannot resolve tree item for element ${a} from extension ${this.N.identifier.value}`)}))}X(h){if(h){let t;if(typeof h=="string"){const p=this.getExtensionElement(h);t=p?this.m.get(p):void 0}else t=h;return t&&t.children||void 0}return this.h}async Y(h){this.rb(h);const t=new $.$ee(this.Z.token);try{const p=h?this.m.get(h):void 0,a=await this.f.getChildren(h);if(t.token.isCancellationRequested)return;const g=(0,D.$Hb)(a||[]),v=await Promise.all((0,D.$Hb)(g).map(u=>this.f.getTreeItem(u)));if(t.token.isCancellationRequested)return;const f=v.map((u,E)=>u?this.db(g[E],u,p):null);return(0,D.$Hb)(f)}finally{t.dispose()}}$(h){if(h.some(p=>!p))return this.Z.dispose(!0),this.Z=new $.$ee,this.tb(),this.J.$refresh(this.I);{const p=this.ab(h);if(p.length)return this.bb(p)}return Promise.resolve(void 0)}ab(h){const t=new Set,p=h.map(g=>this.m.get(g));for(const g of p)if(g&&!t.has(g.item.handle)){let v=g;for(;v&&v.parent&&p.findIndex(f=>v&&v.parent&&f&&f.item.handle===v.parent.item.handle)===-1;){const f=this.j.get(v.parent.item.handle);v=f?this.m.get(f):void 0}v&&!v.parent&&t.add(g.item.handle)}const a=[];return t.forEach(g=>{const v=this.j.get(g);if(v){const f=this.m.get(v);f&&(!f.parent||!t.has(f.parent.item.handle))&&a.push(g)}}),a}bb(h){const t={};return Promise.all(h.map(p=>this.cb(p).then(a=>{a&&(t[p]=a.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(h){const t=this.getExtensionElement(h);if(t){const p=this.m.get(t);if(p)return this.rb(t),(0,d.$ah)(()=>this.f.getTreeItem(t)).then(a=>{if(a){const g=this.ib(t,a,p.parent);return this.pb(t,g,p,p.parent),p.dispose(),g}return null})}return Promise.resolve(null)}db(h,t,p){const a=this.ib(h,t,p);if(t.id&&this.j.has(a.item.handle))throw new Error((0,k.localize)(0,null,t.id));return this.ob(h,a),this.qb(a,p),a}eb(h){return y.$VM.isMarkdownString(h)?l.MarkdownString.from(h):h}fb(h,t){return t?{...this.L.toInternal(t,h),originalId:t.command}:void 0}gb(h){if(h.checkboxState===void 0)return;let t,p,a;return typeof h.checkboxState=="number"?t=h.checkboxState:(t=h.checkboxState.state,p=h.checkboxState.tooltip,a=h.checkboxState.accessibilityInformation),{isChecked:t===y.TreeItemCheckboxState.Checked,tooltip:p,accessibilityInformation:a}}hb(h){if(!y.$hN.isTreeItem(h,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(h,t,p){this.hb(t);const a=this.B(new A.$Tc),g=this.kb(h,t,p),v=this.lb(t);return{item:{handle:g,parentHandle:p?p.item.handle:void 0,label:s(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(a,t.command),contextValue:t.contextValue,icon:v,iconDark:this.mb(t)||v,themeIcon:this.jb(t),collapsibleState:(0,O.$5f)(t.collapsibleState)?y.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:p,children:void 0,disposableStore:a,dispose(){a.dispose()}}}jb(h){return h.iconPath instanceof y.$qN?h.iconPath:void 0}kb(h,{id:t,label:p,resourceUri:a},g,v){if(t)return`${i.b}/${t}`;const f=s(p,this.N),u=g?g.item.handle:i.a;let E=f?f.label:a?(0,M.$Sg)(a):"";E=E.indexOf("/")!==-1?E.replace("/","//"):E;const w=this.m.has(h)?this.m.get(h).item.handle:void 0,I=this.X(g)||[];let S,P=0;do{if(S=`${u}/${P}:${E}`,v||!this.j.has(S)||w===S)break;P++}while(P<=I.length);return S}lb(h){if(h.iconPath&&!(h.iconPath instanceof y.$qN))return typeof h.iconPath=="string"||C.URI.isUri(h.iconPath)?this.nb(h.iconPath):this.nb(h.iconPath.light)}mb(h){if(h.iconPath&&!(h.iconPath instanceof y.$qN)&&h.iconPath.dark)return this.nb(h.iconPath.dark)}nb(h){return C.URI.isUri(h)?h:C.URI.file(h)}ob(h,t){this.j.set(t.item.handle,h),this.m.set(h,t)}pb(h,t,p,a){this.j.delete(t.item.handle),this.m.delete(h),t.item.handle!==p.item.handle&&this.j.delete(p.item.handle),this.ob(h,t);const g=this.X(a)||[],v=g.filter(f=>f.item.handle===p.item.handle)[0];v&&g.splice(g.indexOf(v),1,t)}qb(h,t){t?(t.children||(t.children=[]),t.children.push(h)):(this.h||(this.h=[]),this.h.push(h))}rb(h){if(h){const t=this.m.get(h);if(t){if(t.children)for(const p of t.children){const a=this.j.get(p.item.handle);a&&this.sb(a)}t.children=void 0}}else this.tb()}sb(h){const t=this.m.get(h);if(t){if(t.children)for(const p of t.children){const a=this.j.get(p.item.handle);a&&this.sb(a)}this.m.delete(h),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(h=>h.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}i.a="0",i.b="1"});var _e=this&&this.__classPrivateFieldSet||function(ee,e,k,M,C){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?C.call(ee,k):C?C.value=k:e.set(ee,k),k},Ve=this&&this.__classPrivateFieldGet||function(ee,e,k,M){if(k==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!M:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return k==="m"?M:k==="a"?M.call(ee):M?M.value:e.get(ee)};define(Pe[283],Re([1,0,5,6,2,35,8,63,4,7]),function(ee,e,k,M,C,N,A,m,d,y){"use strict";var O,D,l,b,$,n,o,s,r,i,c,h,t;Object.defineProperty(e,"__esModule",{value:!0}),e.$_jc=void 0;class p extends M.$Uc{constructor(f,u,E,w){super(),O.set(this,void 0),D.set(this,void 0),l.set(this,void 0),b.set(this,void 0),$.set(this,void 0),n.set(this,void 0),o.set(this,void 0),s.set(this,void 0),r.set(this,!0),i.set(this,void 0),c.set(this,!1),h.set(this,this.B(new k.$7d)),this.onDidDispose=Ve(this,h,"f").event,t.set(this,this.B(new k.$7d)),this.onDidChangeViewState=Ve(this,t,"f").event,_e(this,O,f,"f"),_e(this,D,u,"f"),_e(this,b,E,"f"),_e(this,l,w.viewType,"f"),_e(this,$,w.panelOptions,"f"),_e(this,s,w.viewColumn,"f"),_e(this,n,w.title,"f"),_e(this,i,w.active,"f")}dispose(){Ve(this,c,"f")||(_e(this,c,!0,"f"),Ve(this,h,"f").fire(),Ve(this,D,"f").$disposeWebview(Ve(this,O,"f")),Ve(this,b,"f").dispose(),super.dispose())}get webview(){return this.c(),Ve(this,b,"f")}get viewType(){return this.c(),Ve(this,l,"f")}get title(){return this.c(),Ve(this,n,"f")}set title(f){this.c(),Ve(this,n,"f")!==f&&(_e(this,n,f,"f"),Ve(this,D,"f").$setTitle(Ve(this,O,"f"),f))}get iconPath(){return this.c(),Ve(this,o,"f")}set iconPath(f){this.c(),Ve(this,o,"f")!==f&&(_e(this,o,f,"f"),Ve(this,D,"f").$setIconPath(Ve(this,O,"f"),C.URI.isUri(f)?{light:f,dark:f}:f))}get options(){return Ve(this,$,"f")}get viewColumn(){if(this.c(),!(typeof Ve(this,s,"f")=="number"&&Ve(this,s,"f")<0))return Ve(this,s,"f")}get active(){return this.c(),Ve(this,i,"f")}get visible(){return this.c(),Ve(this,r,"f")}_updateViewState(f){Ve(this,c,"f")||(this.active!==f.active||this.visible!==f.visible||this.viewColumn!==f.viewColumn)&&(_e(this,i,f.active,"f"),_e(this,r,f.visible,"f"),_e(this,s,f.viewColumn,"f"),Ve(this,t,"f").fire({webviewPanel:this}))}reveal(f,u){this.c(),Ve(this,D,"f").$reveal(Ve(this,O,"f"),{viewColumn:typeof f>"u"?void 0:A.ViewColumn.from(f),preserveFocus:!!u})}c(){if(Ve(this,c,"f"))throw new Error("Webview is disposed")}}O=new WeakMap,D=new WeakMap,l=new WeakMap,b=new WeakMap,$=new WeakMap,n=new WeakMap,o=new WeakMap,s=new WeakMap,r=new WeakMap,i=new WeakMap,c=new WeakMap,h=new WeakMap,t=new WeakMap;class a extends M.$Uc{static c(){return(0,N.$Eg)()}constructor(f,u,E){super(),this.j=u,this.m=E,this.g=new Map,this.h=new Map,this.f=f.getProxy(d.$sM.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(f=>f.dispose()),this.g.clear()}createWebviewPanel(f,u,E,w,I={}){const S=typeof w=="object"?w.viewColumn:w,P={viewColumn:A.ViewColumn.from(S),preserveFocus:typeof w=="object"&&!!w.preserveFocus},U=(0,m.$8jc)(f),Q=a.c();this.f.$createWebviewPanel((0,m.$0jc)(f),Q,u,{title:E,panelOptions:g(I),webviewOptions:(0,m.$$jc)(f,this.m,I),serializeBuffersForPostMessage:U},P);const H=this.j.createNewWebview(Q,I,f);return this.createNewWebviewPanel(Q,u,E,S,I,H,!0)}$onDidChangeWebviewPanelViewStates(f){const u=Object.keys(f);u.sort((E,w)=>{const I=f[E],S=f[w];return I.active?1:S.active?-1:+I.visible-+S.visible});for(const E of u){const w=this.getWebviewPanel(E);if(!w)continue;const I=f[E];w._updateViewState({active:I.active,visible:I.visible,viewColumn:A.ViewColumn.to(I.position)})}}async $onDidDisposeWebviewPanel(f){this.getWebviewPanel(f)?.dispose(),this.g.delete(f),this.j.deleteWebview(f)}registerWebviewPanelSerializer(f,u,E){if(this.h.has(u))throw new Error(`Serializer for '${u}' already registered`);return this.h.set(u,{serializer:E,extension:f}),this.f.$registerSerializer(u,{serializeBuffersForPostMessage:(0,m.$8jc)(f)}),new y.$uM(()=>{this.h.delete(u),this.f.$unregisterSerializer(u)})}async $deserializeWebviewPanel(f,u,E,w){const I=this.h.get(u);if(!I)throw new Error(`No serializer found for '${u}'`);const{serializer:S,extension:P}=I,U=this.j.createNewWebview(f,E.webviewOptions,P),Q=this.createNewWebviewPanel(f,u,E.title,w,E.panelOptions,U,E.active);await S.deserializeWebviewPanel(Q,E.state)}createNewWebviewPanel(f,u,E,w,I,S,P){const U=new p(f,this.f,S,{viewType:u,title:E,viewColumn:w,panelOptions:I,active:P});return this.g.set(f,U),U}getWebviewPanel(f){return this.g.get(f)}}e.$_jc=a;function g(v){return{enableFindWidget:v.enableFindWidget,retainContextWhenHidden:v.retainContextWhenHidden}}});var _e=this&&this.__classPrivateFieldSet||function(ee,e,k,M,C){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?C.call(ee,k):C?C.value=k:e.set(ee,k),k},Ve=this&&this.__classPrivateFieldGet||function(ee,e,k,M){if(k==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!M:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return k==="m"?M:k==="a"?M.call(ee):M?M.value:e.get(ee)};define(Pe[284],Re([1,0,5,6,63,8,4,7]),function(ee,e,k,M,C,N,A,m){"use strict";var d,y,O,D,l,b,$,n,o,s,r;Object.defineProperty(e,"__esModule",{value:!0}),e.$Dlc=void 0;class i extends M.$Uc{constructor(t,p,a,g,v,f){super(),d.set(this,void 0),y.set(this,void 0),O.set(this,void 0),D.set(this,void 0),l.set(this,!1),b.set(this,void 0),$.set(this,void 0),n.set(this,void 0),o.set(this,void 0),s.set(this,this.B(new k.$7d)),this.onDidChangeVisibility=Ve(this,s,"f").event,r.set(this,this.B(new k.$7d)),this.onDidDispose=Ve(this,r,"f").event,_e(this,O,a,"f"),_e(this,$,g,"f"),_e(this,d,t,"f"),_e(this,y,p,"f"),_e(this,D,v,"f"),_e(this,b,f,"f")}dispose(){Ve(this,l,"f")||(_e(this,l,!0,"f"),Ve(this,r,"f").fire(),Ve(this,D,"f").dispose(),super.dispose())}get title(){return this.a(),Ve(this,$,"f")}set title(t){this.a(),Ve(this,$,"f")!==t&&(_e(this,$,t,"f"),Ve(this,y,"f").$setWebviewViewTitle(Ve(this,d,"f"),t))}get description(){return this.a(),Ve(this,n,"f")}set description(t){this.a(),Ve(this,n,"f")!==t&&(_e(this,n,t,"f"),Ve(this,y,"f").$setWebviewViewDescription(Ve(this,d,"f"),t))}get visible(){return Ve(this,b,"f")}get webview(){return Ve(this,D,"f")}get viewType(){return Ve(this,O,"f")}_setVisible(t){t===Ve(this,b,"f")||Ve(this,l,"f")||(_e(this,b,t,"f"),Ve(this,s,"f").fire())}get badge(){return this.a(),Ve(this,o,"f")}set badge(t){this.a(),!(t?.value===Ve(this,o,"f")?.value&&t?.tooltip===Ve(this,o,"f")?.tooltip)&&(_e(this,o,N.ViewBadge.from(t),"f"),Ve(this,y,"f").$setWebviewViewBadge(Ve(this,d,"f"),t))}show(t){this.a(),Ve(this,y,"f").$show(Ve(this,d,"f"),!!t)}a(){if(Ve(this,l,"f"))throw new Error("Webview is disposed")}}d=new WeakMap,y=new WeakMap,O=new WeakMap,D=new WeakMap,l=new WeakMap,b=new WeakMap,$=new WeakMap,n=new WeakMap,o=new WeakMap,s=new WeakMap,r=new WeakMap;class c{constructor(t,p){this.d=p,this.b=new Map,this.c=new Map,this.a=t.getProxy(A.$sM.MainThreadWebviewViews)}registerWebviewViewProvider(t,p,a,g){if(this.b.has(p))throw new Error(`View provider for '${p}' already registered`);return this.b.set(p,{provider:a,extension:t}),this.a.$registerWebviewViewProvider((0,C.$0jc)(t),p,{retainContextWhenHidden:g?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,C.$8jc)(t)}),new m.$uM(()=>{this.b.delete(p),this.a.$unregisterWebviewViewProvider(p)})}async $resolveWebviewView(t,p,a,g,v){const f=this.b.get(p);if(!f)throw new Error(`No view provider found for '${p}'`);const{provider:u,extension:E}=f,w=this.d.createNewWebview(t,{},E),I=new i(t,this.a,p,a,w,!0);this.c.set(t,I),await u.resolveWebviewView(I,{state:g},v)}async $onDidChangeWebviewViewVisibility(t,p){this.e(t)._setVisible(p)}async $disposeWebviewView(t){const p=this.e(t);this.c.delete(t),p.dispose(),this.d.deleteWebview(t)}e(t){const p=this.c.get(t);if(!p)throw new Error("No webview found");return p}}e.$Dlc=c}),define(Pe[285],Re([1,0,5,30,33,3]),function(ee,e,k,M,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OL=e.$NL=e.OutputChannelUpdateMode=e.$ML=e.$LL=e.$KL=e.$JL=e.$IL=e.$HL=e.$GL=e.$FL=e.$EL=e.$DL=e.$CL=e.$BL=e.$AL=void 0,e.$AL="text/x-code-output",e.$BL="output",e.$CL="Log",e.$DL="text/x-code-log-output",e.$EL="log",e.$FL="workbench.panel.output",e.$GL=new C.$zj("inOutput",!1),e.$HL=new C.$zj("activeLogOutput",!1),e.$IL=new C.$zj("activeLogOutput.levelSettable",!1),e.$JL=new C.$zj("activeLogOutput.level",""),e.$KL=new C.$zj("activeLogOutput.levelIsDefault",!1),e.$LL=new C.$zj("outputView.scrollLock",!1),e.$ML=(0,N.$ii)("outputService");var A;(function(d){d[d.Append=1]="Append",d[d.Replace=2]="Replace",d[d.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.$NL={OutputChannels:"workbench.contributions.outputChannels"};class m{constructor(){this.a=new Map,this.b=new k.$7d,this.onDidRegisterChannel=this.b.event,this.c=new k.$7d,this.onDidRemoveChannel=this.c.event}registerChannel(y){this.a.has(y.id)||(this.a.set(y.id,y),this.b.fire(y.id))}getChannels(){const y=[];return this.a.forEach(O=>y.push(O)),y}getChannel(y){return this.a.get(y)}removeChannel(y){this.a.delete(y),this.c.fire(y)}}M.$2n.add(e.$NL.OutputChannels,new m),e.$OL=new C.$zj("activeOutputChannel","")}),define(Pe[116],Re([1,0,4,3,16,20,13,285,64,27,44,148,22,17,43,5,6]),function(ee,e,k,M,C,N,A,m,d,y,O,D,l,b,$,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$flc=e.$elc=void 0;class s extends A.$Uj{get disposed(){return this.n}constructor(h,t,p,a,g){super(),this.id=h,this.name=t,this.r=p,this.s=a,this.extension=g,this.m=0,this.n=!1,this.visible=!1,this.setLevel(p.getLevel()),this.B(p.onDidChangeLogLevel(v=>this.setLevel(v)))}get logLevel(){return this.getLevel()}appendLine(h){this.append(h+`
`)}append(h){this.info(h)}clear(){const h=this.m;this.r.flush(),this.s.$update(this.id,m.OutputChannelUpdateMode.Clear,h)}replace(h){const t=this.m;this.info(h),this.s.$update(this.id,m.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(h,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof h=="boolean"?h:t))}hide(){this.s.$close(this.id)}g(h,t){this.m+=l.$ue.fromString(t).byteLength,(0,A.log)(this.r,h,t),this.visible&&(this.r.flush(),this.s.$update(this.id,m.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class r extends s{appendLine(h){this.append(h)}}let i=class{constructor(h,t,p,a,g,v){this.i=t,this.j=p,this.k=a,this.l=g,this.m=v,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=h.getProxy(k.$sM.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,D.$Qm)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(h){this.h=h;for(const[t,p]of this.g)p.visible=t===this.h}createOutputChannel(h,t,p){if(h=h.trim(),!h)throw new Error("illegal argument `name`. must not be falsy");const a=typeof t=="object"&&t.log,g=(0,b.$Vf)(t)?t:void 0;if((0,b.$Vf)(g)&&!g.trim())throw new Error("illegal argument `languageId`. must not be empty");let v;const f=this.i.environment.extensionLogLevel?.find(([E])=>N.$Em.equals(p.identifier,E))?.[1];f&&(v=(0,A.$6j)(f));const u=a?this.o(h,v,p):this.n(h,g,p);return u.then(E=>{this.g.set(E.id,E),E.visible=E.id===this.h}),a?this.r(h,v??this.m.getLevel(),u):this.q(h,u)}async n(h,t,p){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const a=await this.c,g=this.k.extUri.joinPath(a,`${this.f++}-${h.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),v=this.l.createLogger(g,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),f=await this.a.$register(h,g,t,p.identifier.value);return new s(f,h,v,this.a,p)}async o(h,t,p){const a=await this.p(p),g=h.replace(/[\\/:\*\?"<>\|]/g,""),v=this.k.extUri.joinPath(a,`${g}.log`),f=`${p.identifier.value}.${g}`,u=this.l.createLogger(v,{id:f,name:h,logLevel:t,extensionId:p.identifier.value});return new r(f,h,u,this.a,p)}p(h){let t=this.d.get(h.identifier.value);if(!t){const p=this.k.extUri.joinPath(this.i.logsLocation,h.identifier.value);this.d.set(h.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(p)}catch(a){if((0,$.$5k)(a)!==$.FileSystemProviderErrorCode.FileExists)throw a}return p})())}return t}q(h,t){let p=!1;const a=()=>{if(p)throw new Error("Channel has been closed")};return{get name(){return h},append(g){a(),t.then(v=>v.append(g))},appendLine(g){a(),t.then(v=>v.appendLine(g))},clear(){a(),t.then(g=>g.clear())},replace(g){a(),t.then(v=>v.replace(g))},show(g,v){a(),t.then(f=>f.show(g,v))},hide(){a(),t.then(g=>g.hide())},dispose(){p=!0,t.then(g=>g.dispose())}}}r(h,t,p){const a=new o.$Tc,g=()=>{if(a.isDisposed)throw new Error("Channel has been closed")},v=a.add(new n.$7d);function f(u){t=u,v.fire(u)}return p.then(u=>{a.add(u),u.logLevel!==t&&f(u.logLevel),a.add(u.onDidChangeLogLevel(E=>f(E)))}),{...this.q(h,p),get logLevel(){return t},onDidChangeLogLevel:v.event,trace(u,...E){g(),p.then(w=>w.trace(u,...E))},debug(u,...E){g(),p.then(w=>w.debug(u,...E))},info(u,...E){g(),p.then(w=>w.info(u,...E))},warn(u,...E){g(),p.then(w=>w.warn(u,...E))},error(u,...E){g(),p.then(w=>w.error(u,...E))},dispose(){a.dispose()}}}};e.$elc=i,e.$elc=i=Xe([qe(0,C.$OO),qe(1,y.$5O),qe(2,d.$4jc),qe(3,O.$Djc),qe(4,A.$Pj),qe(5,A.$Oj)],i),e.$flc=(0,M.$ii)("IExtHostOutputService")}),define(Pe[117],Re([1,0,3,11]),function(ee,e,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7m=e.$6m=void 0,e.$6m=(0,k.$ii)("remoteAgentService"),e.$7m=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(C){let N=1/0;for(let m=0;m<this.maxSampleCount;m++){const d=await C.getRoundTripTime();if(d===void 0)return;N=Math.min(N,d/2),await(0,M.$jh)(this.sampleDelay)}this.average.push(N),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(N):A=this.initial.reduce((m,d)=>m+d,0)/this.initial.length,this.lastMeasurement={initial:A,current:N,average:this.average.reduce((m,d)=>m+d,0)/this.average.length,high:typeof A>"u"?!1:N>this.highLatencyMaxThreshold||N>this.highLatencyMinThreshold&&N>A*this.highLatencyMultiple},this.lastMeasurement}}}),define(Pe[286],Re([1,0,176,57,30,48,47,6,5,117,21,26,11]),function(ee,e,k,M,C,N,A,m,d,y,O,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_I=e.$$I=e.$0I=e.$9I=e.$8I=e.$7I=e.$6I=void 0,e.$6I=Object.freeze({id:"application",order:100,title:(0,k.localize)(0,null),type:"object"}),e.$7I=Object.freeze({id:"workbench",order:7,title:(0,k.localize)(1,null),type:"object"}),e.$8I=Object.freeze({id:"security",scope:1,title:(0,k.localize)(2,null),type:"object",order:7}),e.$9I=Object.freeze({id:"problems",title:(0,k.localize)(3,null),type:"object",order:101}),e.$0I={ConfigurationMigration:"base.contributions.configuration.migration"};class b{constructor(){this.migrations=[],this.a=new d.$7d,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(r){this.migrations.push(...r)}}const $=new b;C.$2n.add(e.$0I.ConfigurationMigration,$);let n=class extends m.$Uc{constructor(r,i){super(),this.a=r,this.b=i,this.B(this.b.onDidChangeWorkspaceFolders(async c=>{for(const h of c.added)await this.f(h,$.migrations)})),this.c($.migrations),this.B($.onDidRegisterConfigurationMigration(c=>this.c(c)))}async c(r){await this.f(void 0,r);for(const i of this.b.getWorkspace().folders)await this.f(i,r)}async f(r,i){await Promise.all([i.map(c=>this.g(c,r?.uri))])}async g(r,i){const c=this.a.inspect(r.key,{resource:i}),h=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[t,p]of h){const a=c[t];if(!a)continue;const g=[];if(a.value!==void 0){const v=await this.h(r,t,a.value,i,void 0);for(const f of v??[])g.push([f,[]])}for(const{identifiers:v,value:f}of a.overrides??[])if(f!==void 0){const u=await this.h(r,t,f,i,v);for(const E of u??[])g.push([E,v])}g.length&&await Promise.allSettled(g.map(async([[v,f],u])=>this.a.updateValue(v,f.value,{resource:i,overrideIdentifiers:u},p)))}}async h(r,i,c,h,t){const p=g=>{const f=this.a.inspect(g,{resource:h})[i];if(f)return t?f.overrides?.find(({identifiers:u})=>(0,D.$Tn)(u,t))?.value:f.value},a=await r.migrateFn(c,p);return Array.isArray(a)?a:[[r.key,a]]}};e.$$I=n,n.ID="workbench.contrib.configurationMigration",e.$$I=n=Xe([qe(0,A.$Oi),qe(1,N.$ri)],n);let o=class extends m.$Uc{constructor(r){super(),this.b=r,this.a=new l.$Fh,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!O.$c&&(await this.b.getEnvironment())?.os!==1)return;C.$2n.as(M.$7n.Configuration).registerConfiguration({...e.$8I,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,k.localize)(4,null)},default:[],markdownDescription:(0,k.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,k.localize)(6,null),scope:2}}})}};e.$_I=o,o.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration",e.$_I=o=Xe([qe(0,y.$6m)],o)}),define(Pe[287],Re([1,0,34,12,19,23,184,286,57,3,30]),function(ee,e,k,M,C,N,A,m,d,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$Sfb=e.$Rfb=void 0,e.$Tfb=n,e.$Ufb=o,e.$Rfb=(0,y.$ii)("editorResolverService"),e.$Sfb="workbench.editorAssociations";const D=O.$2n.as(d.$7n.Configuration),l={...m.$7I,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,A.localize)(0,null),additionalProperties:{type:"string"}}}};D.registerConfiguration(l);var b;(function(s){s.builtin="builtin",s.option="option",s.exclusive="exclusive",s.default="default"})(b||(e.RegisteredEditorPriority=b={}));var $;(function(s){s[s.ABORT=1]="ABORT",s[s.NONE=2]="NONE"})($||(e.ResolvedStatus=$={}));function n(s){switch(s){case b.exclusive:return 5;case b.default:return 4;case b.builtin:return 3;case b.option:default:return 1}}function o(s,r){if(new Set([M.Schemas.extension,M.Schemas.webviewPanel,M.Schemas.vscodeWorkspaceTrust,M.Schemas.vscodeSettings]).has(r.scheme))return!1;const h=typeof s=="string"&&s.indexOf(C.$hc.sep)>=0?`${r.scheme}:${r.path}`:(0,N.$Sg)(r);return k.$bk(typeof s=="string"?s.toLowerCase():s,h.toLowerCase())}}),define(Pe[288],Re([1,0,46,12,19,21,23,2,3,205,48,224,117]),function(ee,e,k,M,C,N,A,m,d,y,O,D,l){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$8L=e.$7L=void 0,e.$7L=(0,d.$ii)("pathService");let $=b=class{constructor(o,s,r,i){this.d=o,this.e=s,this.f=r,this.g=i,this.a=(async()=>(await this.e.getEnvironment())?.os||N.OS)(),this.b=(async()=>{const c=await this.e.getEnvironment();return this.c=c?.userHome??o})()}hasValidBasename(o,s,r){return typeof s=="string"||typeof s>"u"?this.a.then(i=>this.h(o,i,s)):this.h(o,s,r)}h(o,s,r){return o.scheme===M.Schemas.file||o.scheme===M.Schemas.vscodeRemote?(0,k.$gg)(r??(0,A.$Sg)(o),s===1):!0}get defaultUriScheme(){return b.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(o,s){if(o.remoteAuthority)return M.Schemas.vscodeRemote;const r=(0,y.$4L)(s.getWorkspace());if(r)return r;const i=s.getWorkspace().folders[0];if(i)return i.uri.scheme;const c=s.getWorkspace().configuration;return c?c.scheme:M.Schemas.file}userHome(o){return o?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(o=>o===1?C.$gc:C.$hc)}async fileURI(o){let s="";if(await this.a===1&&(o=o.replace(/\\/g,"/")),o[0]==="/"&&o[1]==="/"){const i=o.indexOf("/",2);i===-1?(s=o.substring(2),o="/"):(s=o.substring(2,i),o=o.substring(i)||"/")}return m.URI.from({scheme:M.Schemas.file,authority:s,path:o,query:"",fragment:""})}};e.$8L=$,e.$8L=$=b=Xe([qe(1,l.$6m),qe(2,D.$PL),qe(3,O.$ri)],$)}),define(Pe[118],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$AK=e.$zK=void 0;class k{constructor(A,m){this.line=A,this.character=m}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,m){return new k(0,0)}with(A){return new k(0,0)}}e.$zK=k;class M{constructor(A,m,d,y){this.isEmpty=!1,this.isSingleLine=!1,this.start=new k(A,m),this.end=new k(d,y)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new M(0,0,0,0)}with(A){return new M(0,0,0,0)}}e.$AK=M;var C;(function(N){N[N.Information=1]="Information",N[N.Warning=2]="Warning"})(C||(e.TextSearchCompleteMessageType=C={}))}),define(Pe[45],Re([1,0,18,34,26,46,15,3,19,14,118,11]),function(ee,e,k,M,C,N,A,m,d,y,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZK=e.$XK=e.$QK=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$NK=e.$MK=e.$LK=e.$KK=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$GK=e.$FK=e.$EK=e.$DK=e.$CK=e.$BK=e.TextSearchCompleteMessageType=void 0,e.$HK=s,e.$IK=r,e.$JK=i,e.$OK=u,e.$PK=E,e.$RK=S,e.$SK=P,e.$TK=U,e.$UK=Q,e.$VK=H,e.$WK=L,e.$YK=F,e.$1K=re,e.$2K=me,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return O.TextSearchCompleteMessageType}}),e.$BK="workbench.view.search",e.$CK="workbench.panel.search",e.$DK="workbench.view.search",e.$EK="search-result",e.$FK="search.exclude";const l="\u27EA ",b=" characters skipped \u27EB",$=(l.length+b.length+5)*2;e.$GK=(0,m.$ii)("searchService");var n;(function(ae){ae[ae.file=0]="file",ae[ae.text=1]="text",ae[ae.aiText=2]="aiText"})(n||(e.SearchProviderType=n={}));var o;(function(ae){ae[ae.File=1]="File",ae[ae.Text=2]="Text",ae[ae.aiText=3]="aiText"})(o||(e.QueryType=o={}));function s(ae){return!!ae.preview}function r(ae){return!!ae.resource}function i(ae){return!!ae.message}var c;(function(ae){ae[ae.Normal=0]="Normal",ae[ae.NewSearchStarted=1]="NewSearchStarted"})(c||(e.SearchCompletionExitCode=c={}));class h{constructor(be){this.resource=be,this.results=[]}}e.$KK=h;class t{constructor(be,se,De,Oe){this.ranges=se,this.webviewIndex=Oe;const ie=Array.isArray(se)?se:[se];if(De&&De.matchLines===1&&p(ie)){be=(0,A.$Of)(be,De.matchLines);let q="",de=0,Ne=0;const $e=Math.floor(De.charsPerLine/5),we=[];for(const ge of ie){const ce=Math.max(ge.startColumn-$e,0),K=ge.startColumn+De.charsPerLine;if(ce>Ne+$e+$){const Z=l+(ce-Ne)+b;q+=Z+be.slice(ce,K),de+=ce-(Ne+Z.length)}else q+=be.slice(Ne,K);we.push(new g(0,ge.startColumn-de,ge.endColumn-de)),Ne=K}this.preview={text:q,matches:Array.isArray(this.ranges)?we:we[0]}}else{const q=Array.isArray(se)?se[0].startLineNumber:se.startLineNumber;this.preview={text:be,matches:(0,k.$2b)(se,de=>new a(de.startLineNumber-q,de.startColumn,de.endLineNumber-q,de.endColumn))}}}}e.$LK=t;function p(ae){const be=ae[0].startLineNumber;for(const se of ae)if(se.startLineNumber!==be||se.endLineNumber!==be)return!1;return!0}class a{constructor(be,se,De,Oe){this.startLineNumber=be,this.startColumn=se,this.endLineNumber=De,this.endColumn=Oe}}e.$MK=a;class g extends a{constructor(be,se,De){super(be,se,be,De)}}e.$NK=g;var v;(function(ae){ae.List="list",ae.Tree="tree"})(v||(e.ViewMode=v={}));var f;(function(ae){ae.Default="default",ae.FileNames="fileNames",ae.Type="type",ae.Modified="modified",ae.CountDescending="countDescending",ae.CountAscending="countAscending"})(f||(e.SearchSortOrder=f={}));function u(ae,be=!0){const se=ae&&ae.files&&ae.files.exclude,De=be&&ae&&ae.search&&ae.search.exclude;if(!se&&!De)return;if(!se||!De)return se||De;let Oe=Object.create(null);return Oe=C.$Sn(Oe,C.$Pn(se)),Oe=C.$Sn(Oe,C.$Pn(De),!0),Oe}function E(ae,be){return ae.excludePattern&&M.$bk(ae.excludePattern,be)?!1:ae.includePattern||ae.usingSearchPaths?ae.includePattern&&M.$bk(ae.includePattern,be)?!0:ae.usingSearchPaths?!!ae.folderQueries&&ae.folderQueries.some(se=>{const De=se.folder.fsPath;if(N.$ig(be,De)){const Oe=d.$mc(De,be);return!se.includePattern||!!M.$bk(se.includePattern,Oe)}else return!1}):!1:!0}var w;(function(ae){ae[ae.unknownEncoding=1]="unknownEncoding",ae[ae.regexParseError=2]="regexParseError",ae[ae.globParseError=3]="globParseError",ae[ae.invalidLiteral=4]="invalidLiteral",ae[ae.rgProcessError=5]="rgProcessError",ae[ae.other=6]="other",ae[ae.canceled=7]="canceled"})(w||(e.SearchErrorCode=w={}));class I extends Error{constructor(be,se){super(be),this.code=se}}e.$QK=I;function S(ae){const be=ae.message;if((0,y.$4)(ae))return new I(be,w.canceled);try{const se=JSON.parse(be);return new I(se.message,se.code)}catch{return new I(be,w.other)}}function P(ae){const be={message:ae.message,code:ae.code};return new Error(JSON.stringify(be))}function U(ae){return ae.type==="error"?!0:ae.type==="success"}function Q(ae){return ae.type==="success"}function H(ae){return!!ae.path}function L(ae,be,se=!0){const De=ae.searchPath?ae.searchPath:ae.relativePath;return se?(0,A.$Lf)(De,be):M.$bk(be,De)}class R{constructor(be){this.path=be,this.results=[]}addMatch(be){this.results.push(be)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$XK=R;function F(ae,be){const se={...ae||{},...be||{}};return Object.keys(se).filter(De=>{const Oe=se[De];return typeof Oe=="boolean"&&Oe})}class T{constructor(be,se){this.c=null,this.a={...be.excludePattern||{},...se.excludePattern||{}},this.b=M.$ck(this.a);let De=be.includePattern;se.includePattern&&(De?De={...De,...se.includePattern}:De=se.includePattern),De&&(this.c=M.$ck(De))}matchesExcludesSync(be,se,De){return!!(this.b&&this.b(be,se,De))}includedInQuerySync(be,se,De){return!(this.b&&this.b(be,se,De)||this.c&&!this.c(be,se,De))}includedInQuery(be,se,De){const Oe=this.b(be,se,De),ie=()=>this.c?!!this.c(be,se,De):!0;return(0,D.$7g)(Oe)?Oe.then(q=>q?!1:ie()):ie()}hasSiblingExcludeClauses(){return X(this.a)}}e.$ZK=T;function X(ae){for(const be in ae)if(typeof ae[be]!="boolean")return!0;return!1}function re(ae){if(!ae)return;let be;return se=>(be||(be=(ae()||Promise.resolve([])).then(De=>De?pe(De):{})),be.then(De=>!!De[se]))}function me(ae){if(!ae)return;let be;return se=>{if(!be){const De=ae();be=De?pe(De):{}}return!!be[se]}}function pe(ae){const be={};for(const se of ae)be[se]=!0;return be}}),define(Pe[36],Re([1,0,18,11,24,5,6,52,12,126,23,15,2,175,3,13,194,48,44,27,16,8,7,60,45,4,53]),function(ee,e,k,M,C,N,A,m,d,y,O,D,l,b,$,n,o,s,r,i,c,h,t,p,a,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yjc=e.$Xjc=void 0;function f(Q,H,L){return new O.$Kg(R=>I(R,L)).isEqual(Q,H)}function u(Q,H,L){return f(Q.uri,H.uri,L)?0:(0,D.$ef)(Q.uri.toString(),H.uri.toString())}function E(Q,H,L){return Q.index!==H.index?Q.index<H.index?-1:1:f(Q.uri,H.uri,L)?(0,D.$ef)(Q.name,H.name):(0,D.$ef)(Q.uri.toString(),H.uri.toString())}function w(Q,H,L,R){const F=Q.slice(0).sort((X,re)=>L(X,re,R)),T=H.slice(0).sort((X,re)=>L(X,re,R));return(0,k.$Eb)(F,T,(X,re)=>L(X,re,R))}function I(Q,H){const L=H.getCapabilities(Q.scheme);return!(L&&L&1024)}class S extends s.$Bi{static toExtHostWorkspace(H,L,R,F){if(!H)return{workspace:null,added:[],removed:[]};const{id:T,name:X,folders:re,configuration:me,transient:pe,isUntitled:ae}=H,be=[],se=L;L?re.forEach((q,de)=>{const Ne=l.URI.revive(q.uri),$e=S.o(R||L,Ne,F);$e?($e.name=q.name,$e.index=q.index,be.push($e)):be.push({uri:Ne,name:q.name,index:de})}):be.push(...re.map(({uri:q,name:de,index:Ne})=>({uri:l.URI.revive(q),name:de,index:Ne}))),be.sort((q,de)=>q.index<de.index?-1:1);const De=new S(T,X,be,!!pe,me?l.URI.revive(me):null,!!ae,q=>I(q,F)),{added:Oe,removed:ie}=w(se?se.workspaceFolders:[],De.workspaceFolders,u,F);return{workspace:De,added:Oe,removed:ie}}static o(H,L,R){for(let F=0;F<H.folders.length;F++){const T=H.workspaceFolders[F];if(f(T.uri,L,R))return T}}constructor(H,L,R,F,T,X,re){super(H,R.map(me=>new s.$Ci(me)),F,T,re),this.t=L,this.u=X,this.q=[],this.s=m.$oi.forUris(re),R.forEach(me=>{this.q.push(me),this.s.set(me.uri,me)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(H,L){return L&&this.s.get(H)&&(H=(0,O.$Ug)(H)),this.s.findSubstr(H)}resolveWorkspaceFolder(H){return this.s.get(H)}}let P=class{constructor(H,L,R,F,T){this.c=new N.$7d,this.onDidChangeWorkspace=this.c.event,this.g=new N.$7d,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new N.$9d,this.C=new Map,this.h=F,this.s=R,this.t=T,this.j=new y.$qm,this.k=new M.$hh,this.o=H.getProxy(g.$sM.MainThreadWorkspace),this.q=H.getProxy(g.$sM.MainThreadMessageService);const X=L.workspace;this.l=X?new S(X.id,X.name,[],!!X.transient,X.configuration?l.URI.revive(X.configuration):null,!!X.isUntitled,re=>I(re,R)):void 0}$initializeWorkspace(H,L){this.v=L,this.$acceptWorkspaceData(H),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?l.URI.from({scheme:d.Schemas.untitled,path:(0,O.$Sg)((0,O.$Ug)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(H,L,R,...F){const T=[];if(Array.isArray(F)&&F.forEach(ae=>{l.URI.isUri(ae.uri)&&!T.some(be=>f(be.uri,ae.uri,this.s))&&T.push({uri:ae.uri,name:ae.name||(0,O.$Rg)(ae.uri)})}),this.n||[L,R].some(ae=>typeof ae!="number"||ae<0)||R===0&&T.length===0)return!1;const X=this.x?this.x.workspaceFolders:[];if(L+R>X.length)return!1;const re=X.slice(0);re.splice(L,R,...T.map(ae=>({uri:ae.uri,name:ae.name||(0,O.$Rg)(ae.uri),index:void 0})));for(let ae=0;ae<re.length;ae++){const be=re[ae];if(re.some((se,De)=>De!==ae&&f(be.uri,se.uri,this.s)))return!1}re.forEach((ae,be)=>ae.index=be);const{added:me,removed:pe}=w(X,re,E,this.s);if(me.length===0&&pe.length===0)return!1;if(this.o){const ae=H.displayName||H.name;this.o.$updateWorkspaceFolders(ae,L,R,T).then(void 0,be=>{this.n=void 0;const se={source:{identifier:H.identifier,label:H.displayName||H.name}};this.q.$showMessage(o.Severity.Error,(0,b.localize)(0,null,ae,be.toString()),se,[])})}return this.y(re),!0}getWorkspaceFolder(H,L){if(this.x)return this.x.getWorkspaceFolder(H,L)}async getWorkspaceFolder2(H,L){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(H,L)}async resolveWorkspaceFolder(H){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(H)}getPath(){if(!this.x)return;const{folders:H}=this.x;if(H.length!==0)return H[0].uri.fsPath}getRelativePath(H,L){let R,F="";if(typeof H=="string"?(R=l.URI.file(H),F=H):typeof H<"u"&&(R=H,F=H.fsPath),!R)return F;const T=this.getWorkspaceFolder(R,!0);if(!T)return F;typeof L>"u"&&this.x&&(L=this.x.folders.length>1);let X=(0,O.$Xg)(T.uri,R);return L&&T.name&&(X=`${T.name}/${X}`),X}y(H){this.x&&(this.n=S.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:H,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(H){const{workspace:L,added:R,removed:F}=S.toExtHostWorkspace(H,this.l,this.n,this.s);this.l=L||void 0,this.n=void 0,this.c.fire(Object.freeze({added:R,removed:F}))}findFiles(H,L,R,F,T=C.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${F.value}, entryPoint: findFiles`);let X="",re=!0;return L===null?re=!1:L!==void 0&&(typeof L=="string"?X=L:X=L.pattern),this.z(H,void 0,{exclude:X,maxResults:R,useDefaultExcludes:re,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},T)}findFiles2(H,L={},R,F=C.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${R.value}, entryPoint: findFiles2`),this.z(void 0,H,L,F)}async z(H,L,R,F=C.CancellationToken.None){if(F&&F.isCancellationRequested)return Promise.resolve([]);const T=typeof R.exclude=="string"?R.exclude:R.exclude?R.exclude.pattern:void 0,X={ignoreSymlinks:typeof R.followSymlinks=="boolean"?!R.followSymlinks:void 0,disregardIgnoreFiles:typeof R.useIgnoreFiles=="boolean"?!R.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof R.useGlobalIgnoreFiles=="boolean"?!R.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof R.useParentIgnoreFiles=="boolean"?!R.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof R.useDefaultExcludes=="boolean"?!R.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof R.useDefaultSearchExcludes=="boolean"?!R.useDefaultSearchExcludes:!1,maxResults:R.maxResults,excludePattern:T,shouldGlobSearch:typeof R.fuzzy=="boolean"?!R.fuzzy:!0,_reason:"startFileSearch"};let re;if(H){const{includePattern:me,folder:pe}=U(h.GlobPattern.from(H));re=pe,X.includePattern=me}else{const{includePattern:me,folder:pe}=U(h.GlobPattern.from(L));re=pe,X.filePattern=me}return this.o.$startFileSearch(re??null,X,F).then(me=>Array.isArray(me)?me.map(pe=>l.URI.revive(pe)):[])}async findTextInFiles(H,L,R,F,T=C.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${F.value}, entryPoint: findTextInFiles`);const X=this.j.getNext(),re=typeof L.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:L.previewOptions,{includePattern:me,folder:pe}=U(h.GlobPattern.from(L.include)),ae=typeof L.exclude=="string"?L.exclude:L.exclude?L.exclude.pattern:void 0,be={ignoreSymlinks:typeof L.followSymlinks=="boolean"?!L.followSymlinks:void 0,disregardIgnoreFiles:typeof L.useIgnoreFiles=="boolean"?!L.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof L.useGlobalIgnoreFiles=="boolean"?!L.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof L.useParentIgnoreFiles=="boolean"?!L.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof L.useDefaultExcludes=="boolean"?!L.useDefaultExcludes:!0,fileEncoding:L.encoding,maxResults:L.maxResults,previewOptions:re,afterContext:L.afterContext,beforeContext:L.beforeContext,includePattern:me,excludePattern:ae},se=!1;if(this.u[X]=De=>{if(se)return;const Oe=l.URI.revive(De.resource);De.results.forEach(ie=>{const q=(0,v.$Rh)(ie);(0,a.$HK)(q)?R({uri:Oe,preview:{text:q.preview.text,matches:(0,k.$2b)(q.preview.matches,de=>new t.$wM(de.startLineNumber,de.startColumn,de.endLineNumber,de.endColumn))},ranges:(0,k.$2b)(q.ranges,de=>new t.$wM(de.startLineNumber,de.startColumn,de.endLineNumber,de.endColumn))}):R({uri:Oe,text:q.text,lineNumber:q.lineNumber})})},T.isCancellationRequested)return{};try{const De=await this.o.$startTextSearch(H,pe??null,be,X,T);return delete this.u[X],De||{}}catch(De){throw delete this.u[X],De}}$handleTextSearchResult(H,L){this.u[L]?.(H)}async save(H){const L=await this.o.$save(H,{saveAs:!1});return l.URI.revive(L)}async saveAs(H){const L=await this.o.$save(H,{saveAs:!0});return l.URI.revive(L)}saveAll(H){return this.o.$saveAll(H)}resolveProxy(H){return this.o.$resolveProxy(H)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(H){return this.o.$requestWorkspaceTrust(H)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(H,L){if(this.w.has(H))throw new Error(`A provider has already been registered for scheme ${H}`);this.w.set(H,L);const R=this.t.transformOutgoingScheme(H),F=this.A++;return this.o.$registerEditSessionIdentityProvider(F,R),(0,A.$Sc)(()=>{this.w.delete(H),this.o.$unregisterEditSessionIdentityProvider(F)})}async $getEditSessionIdentifier(H,L){this.h.info("Getting edit session identifier for workspaceFolder",H);const R=await this.resolveWorkspaceFolder(l.URI.revive(H));if(!R){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",R);const F=this.w.get(R.uri.scheme);if(this.h.info(`Provider for scheme ${R.uri.scheme} is defined: `,!!F),!F)return;const T=await F.provideEditSessionIdentity(R,L);if(this.h.info("Provider returned edit session identifier: ",T),!!T)return T}async $provideEditSessionIdentityMatch(H,L,R,F){this.h.info("Getting edit session identifier for workspaceFolder",H);const T=await this.resolveWorkspaceFolder(l.URI.revive(H));if(!T){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",T);const X=this.w.get(T.uri.scheme);if(this.h.info(`Provider for scheme ${T.uri.scheme} is defined: `,!!X),!X)return;const re=await X.provideEditSessionIdentityMatch?.(L,R,F);if(this.h.info("Provider returned edit session identifier match result: ",re),!!re)return re}getOnWillCreateEditSessionIdentityEvent(H){return(L,R,F)=>{const T=function(re){L.call(R,re)};return T.extension=H,this.B.event(T,void 0,F)}}async $onWillCreateEditSessionIdentity(H,L,R){const F=await this.resolveWorkspaceFolder(l.URI.revive(H));if(F===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:F},L,async(T,X)=>{const re=Date.now();await Promise.resolve(T),Date.now()-re>R&&this.h.warn("SLOW edit session create-participant",X.extension.identifier)}),L.isCancellationRequested}registerCanonicalUriProvider(H,L){if(this.C.has(H))throw new Error(`A provider has already been registered for scheme ${H}`);this.C.set(H,L);const R=this.t.transformOutgoingScheme(H),F=this.A++;return this.o.$registerCanonicalUriProvider(F,R),(0,A.$Sc)(()=>{this.C.delete(H),this.o.$unregisterCanonicalUriProvider(F)})}async provideCanonicalUri(H,L,R){const F=this.C.get(H.scheme);if(!F)return;const T=await F.provideCanonicalUri?.(l.URI.revive(H),L,R);if(T)return T}async $provideCanonicalUri(H,L,R){return this.provideCanonicalUri(l.URI.revive(H),{targetScheme:L},R)}};e.$Xjc=P,e.$Xjc=P=Xe([qe(0,c.$OO),qe(1,i.$5O),qe(2,r.$Djc),qe(3,n.$Oj),qe(4,p.$Vjc)],P),e.$Yjc=(0,$.$ii)("IExtHostWorkspace");function U(Q){let H,L;return Q&&(typeof Q=="string"?H=Q:(H=Q.pattern,L=l.URI.revive(Q.baseUri))),{includePattern:H,folder:L}}}),define(Pe[37],Re([1,0,26,5,36,4,7,196,57,17,11,3,16,13,2]),function(ee,e,k,M,C,N,A,m,d,y,O,D,l,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2jc=e.$1jc=e.$Zjc=void 0;function n(p,a){if(a){const g=a.split(".");let v=p;for(let f=0;v&&f<g.length;f++)v=v[g[f]];return v}}function o(p){return p instanceof $.URI}function s(p){return p&&p.uri instanceof $.URI&&p.languageId&&typeof p.languageId=="string"}function r(p){return p&&!p.uri&&p.languageId&&typeof p.languageId=="string"}function i(p){return p&&p.uri instanceof $.URI&&(!p.name||typeof p.name=="string")&&(!p.index||typeof p.index=="number")}function c(p){if(o(p))return{resource:p};if(s(p))return{resource:p.uri,overrideIdentifier:p.languageId};if(r(p))return{overrideIdentifier:p.languageId};if(i(p))return{resource:p.uri};if(p===null)return{resource:null}}let h=class{constructor(a,g,v){this.a=a.getProxy(N.$sM.MainThreadConfiguration),this.c=g,this.b=v,this.d=new O.$hh,this.e=null}getConfigProvider(){return this.d.wait().then(a=>this.e)}$initializeConfiguration(a){this.e=new t(this.a,this.c,a,this.b),this.d.open()}$acceptConfigurationChanged(a,g){this.getConfigProvider().then(v=>v.$acceptConfigurationChanged(a,g))}};e.$Zjc=h,e.$Zjc=h=Xe([qe(0,l.$OO),qe(1,C.$Yjc),qe(2,b.$Oj)],h);class t{constructor(a,g,v,f){this.a=new M.$7d,this.b=a,this.f=f,this.c=g,this.e=m.$no.parse(v),this.d=this.k(v.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(a,g){const v={data:this.e.toData(),workspace:this.c.workspace};this.e=m.$no.parse(a),this.d=this.k(a.configurationScopes),this.a.fire(this.j(g,v))}getConfiguration(a,g,v){const f=c(g)||{},u=this.g(a?n(this.e.getValue(void 0,f,this.c.workspace),a):this.e.getValue(void 0,f,this.c.workspace));a&&this.h(a,f,v?.identifier);function E(I){if(I==null)return null;if(typeof I=="boolean")return I?2:5;switch(I){case A.ConfigurationTarget.Global:return 2;case A.ConfigurationTarget.Workspace:return 5;case A.ConfigurationTarget.WorkspaceFolder:return 6}}const w={has(I){return typeof n(u,I)<"u"},get:(I,S)=>{this.h(a?`${a}.${I}`:I,f,v?.identifier);let P=n(u,I);if(typeof P>"u")P=S;else{let U;const Q=(H,L)=>{if((0,y.$Xf)(H)){let R;const F=()=>{U=U||(0,k.$Pn)(u),R=R||n(U,L)};return new Proxy(H,{get:(T,X)=>{if(typeof X=="string"&&X.toLowerCase()==="tojson")return F(),()=>R;if(U)return R=R||n(U,L),R[X];const re=T[X];return typeof X=="string"?Q(re,`${L}.${X}`):re},set:(T,X,re)=>(F(),R&&(R[X]=re),!0),deleteProperty:(T,X)=>(F(),R&&delete R[X],!0),defineProperty:(T,X,re)=>(F(),R&&Object.defineProperty(R,X,re),!0)})}return Array.isArray(H)?(0,k.$Pn)(H):H};P=Q(P,I)}return P},update:(I,S,P,U)=>{I=a?`${a}.${I}`:I;const Q=E(P);return S!==void 0?this.b.$updateConfigurationOption(Q,I,S,f,U):this.b.$removeConfigurationOption(Q,I,f,U)},inspect:I=>{I=a?`${a}.${I}`:I;const S=this.e.inspect(I,f,this.c.workspace);if(S)return{key:I,defaultValue:(0,k.$Pn)(S.policy?.value??S.default?.value),globalValue:(0,k.$Pn)(S.user?.value??S.application?.value),workspaceValue:(0,k.$Pn)(S.workspace?.value),workspaceFolderValue:(0,k.$Pn)(S.workspaceFolder?.value),defaultLanguageValue:(0,k.$Pn)(S.default?.override),globalLanguageValue:(0,k.$Pn)(S.user?.override??S.application?.override),workspaceLanguageValue:(0,k.$Pn)(S.workspace?.override),workspaceFolderLanguageValue:(0,k.$Pn)(S.workspaceFolder?.override),languageIds:(0,k.$Pn)(S.overrideIdentifiers)}}};return typeof u=="object"&&(0,k.$Sn)(w,u,!1),Object.freeze(w)}g(a){const g=v=>(0,y.$Xf)(v)?new Proxy(v,{get:(f,u)=>g(f[u]),set:(f,u,E)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(u)}' of object`)},deleteProperty:(f,u)=>{throw new Error(`TypeError: Cannot delete read only property '${String(u)}' of object`)},defineProperty:(f,u)=>{throw new Error(`TypeError: Cannot define property '${String(u)}' for a readonly object`)},setPrototypeOf:f=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):v;return g(a)}h(a,g,v){const f=d.$eo.test(a)?4:this.d.get(a),u=v?`[${v.value}] `:"";if(f===4){typeof g?.resource>"u"&&this.f.warn(`${u}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${a}', provide the URI of a resource or 'null' for any resource.`);return}if(f===3){g?.resource&&this.f.warn(`${u}Accessing a window scoped configuration for a resource is not expected. To associate '${a}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(a,g){const v=new m.$po(a,g,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(f,u)=>v.affectsConfiguration(f,c(u))})}k(a){return a.reduce((g,v)=>(g.set(v[0],v[1]),g),new Map)}}e.$1jc=t,e.$2jc=(0,D.$ii)("IExtHostConfiguration")});var _e=this&&this.__classPrivateFieldSet||function(ee,e,k,M,C){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?C.call(ee,k):C?C.value=k:e.set(ee,k),k},Ve=this&&this.__classPrivateFieldGet||function(ee,e,k,M){if(k==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!M:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return k==="m"?M:k==="a"?M.call(ee):M?M.value:e.get(ee)};define(Pe[119],Re([1,0,2,11,5,4,7,36,67,37,24,51,16,27,3,12,21,13,78,229,14]),function(ee,e,k,M,C,N,A,m,d,y,O,D,l,b,$,n,o,s,r,i,c){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$slc=e.$rlc=e.$qlc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var t;(function(H){function L(F){if(F!=null)return F}H.from=L;function R(F){if(F!=null)return F}H.to=R})(t||(t={}));var p;(function(H){function L(F){if(F!=null)return F}H.from=L;function R(F){if(F!=null)return F}H.to=R})(p||(p={}));var a;(function(H){function L(F){if(F!=null)return F}H.from=L;function R(F){if(F!=null)return F}H.to=R})(a||(a={}));var g;(function(H){function L(T){if(T){const X=T;return X&&!!X.process}else return!1}H.is=L;function R(T){if(T==null)return;const X={process:T.process,args:T.args};return T.options&&(X.options=a.from(T.options)),X}H.from=R;function F(T){if(T!=null)return new A.$dN(T.process,T.args,T.options)}H.to=F})(g||(g={}));var v;(function(H){function L(F){if(F!=null)return F}H.from=L;function R(F){if(F!=null)return F}H.to=R})(v||(v={}));var f;(function(H){function L(T){if(T){const X=T;return X&&(!!X.commandLine||!!X.command)}else return!1}H.is=L;function R(T){if(T==null)return;const X={};return T.commandLine!==void 0?X.commandLine=T.commandLine:(X.command=T.command,X.args=T.args),T.options&&(X.options=v.from(T.options)),X}H.from=R;function F(T){if(!(T==null||T.command===void 0&&T.commandLine===void 0))return T.commandLine?new A.$eN(T.commandLine,T.options):new A.$eN(T.command,T.args?T.args:[],T.options)}H.to=F})(f||(f={}));var u;(function(H){function L(T){if(T){const X=T;return X&&X.customExecution==="customExecution"}else return!1}H.is=L;function R(T){return{customExecution:"customExecution"}}H.from=R;function F(T,X){return X.get(T)}H.to=F})(u||(e.CustomExecutionDTO=u={}));var E;(function(H){function L(R,F){let T;return R.scope!==void 0&&typeof R.scope!="number"?T=R.scope.uri:R.scope!==void 0&&typeof R.scope=="number"&&(R.scope===A.TaskScope.Workspace&&F&&F.workspaceFile?T=F.workspaceFile:T=i.$zH),{id:R._id,workspaceFolder:T}}H.from=L})(E||(e.TaskHandleDTO=E={}));var w;(function(H){function L(R){if(R!=null)return{_id:R.id,isDefault:R.isDefault}}H.from=L})(w||(w={}));var I;(function(H){function L(T,X){if(T==null)return[];const re=[];for(const me of T){const pe=R(me,X);pe&&re.push(pe)}return re}H.fromMany=L;function R(T,X){if(T==null)return;let re;T.execution instanceof A.$dN?re=g.from(T.execution):T.execution instanceof A.$eN?re=f.from(T.execution):T.execution&&T.execution instanceof A.$fN&&(re=u.from(T.execution));const me=t.from(T.definition);let pe;return T.scope?typeof T.scope=="number"?pe=T.scope:pe=T.scope.uri:pe=A.TaskScope.Workspace,!me||!pe?void 0:{_id:T._id,definition:me,name:T.name,source:{extensionId:X.identifier.value,label:T.source,scope:pe},execution:re,isBackground:T.isBackground,group:w.from(T.group),presentationOptions:p.from(T.presentationOptions),problemMatchers:T.problemMatchers,hasDefinedMatchers:T.hasDefinedMatchers,runOptions:T.runOptions?T.runOptions:{reevaluateOnRerun:!0},detail:T.detail}}H.from=R;async function F(T,X,re){if(T==null)return;let me;g.is(T.execution)?me=g.to(T.execution):f.is(T.execution)?me=f.to(T.execution):u.is(T.execution)&&(me=u.to(T._id,re));const pe=t.to(T.definition);let ae;if(T.source&&(T.source.scope!==void 0?typeof T.source.scope=="number"?ae=T.source.scope:ae=await X.resolveWorkspaceFolder(k.URI.revive(T.source.scope)):ae=A.TaskScope.Workspace),!pe||!ae)return;const be=new A.$gN(pe,ae,T.name,T.source.label,me,T.problemMatchers);return T.isBackground!==void 0&&(be.isBackground=T.isBackground),T.group!==void 0&&(be.group=A.$cN.from(T.group._id),be.group&&T.group.isDefault&&(be.group=new A.$cN(be.group.id,be.group.label),T.group.isDefault===!0&&(be.group.isDefault=T.group.isDefault))),T.presentationOptions&&(be.presentationOptions=p.to(T.presentationOptions)),T._id&&(be._id=T._id),T.detail&&(be.detail=T.detail),be}H.to=F})(I||(e.TaskDTO=I={}));var S;(function(H){function L(F){return F}H.from=L;function R(F){if(F)return Object.assign(Object.create(null),F)}H.to=R})(S||(S={}));class P{constructor(L,R,F){this._id=R,this.a=F,h.set(this,void 0),_e(this,h,L,"f")}get task(){return this.a}terminate(){Ve(this,h,"f").terminateTask(this)}fireDidStartProcess(L){}fireDidEndProcess(L){}}h=new WeakMap;let U=class{constructor(L,R,F,T,X,re,me,pe){this.q=new C.$7d,this.r=new C.$7d,this.s=new C.$7d,this.u=new C.$7d,this.a=L.getProxy(N.$sM.MainThreadTask),this.b=F,this.c=T,this.d=X,this.e=re,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=me,this.g=pe,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(L,R,F){if(!F)return new A.$uM(()=>{});const T=this.x();return this.j.set(T,{type:R,provider:F,extension:L}),this.a.$registerTaskProvider(T,R),new A.$uM(()=>{this.j.delete(T),this.a.$unregisterTaskProvider(T)})}registerTaskSystem(L,R){this.a.$registerTaskSystem(L,R)}fetchTasks(L){return this.a.$fetchTasks(S.from(L)).then(async R=>{const F=[];for(const T of R){const X=await I.to(T,this.b,this.m);X&&F.push(X)}return F})}get taskExecutions(){const L=[];return this.k.forEach(R=>L.push(R)),L}terminateTask(L){if(!(L instanceof P))throw new Error("No valid task execution provided");return this.a.$terminateTask(L._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(L,R,F){const T=this.m.get(L.id);T&&(this.o.set(L.id,T),this.e.attachPtyToTerminal(R,await T.callback(F))),this.p=L.id,this.q.fire({execution:await this.z(L)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(L){if(!this.l.has(L.id))return;const R=await this.z(L);this.l.delete(L.id),this.k.delete(L.id),this.B(L),this.r.fire({execution:R})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(L){const R=await this.z(L.id);this.s.fire({execution:R,processId:L.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(L){const R=await this.z(L.id);this.u.fire({execution:R,exitCode:L.exitCode})}$provideTasks(L,R){const F=this.j.get(L);if(!F)return Promise.reject(new Error("no handler found"));const T=[],X=(0,M.$ah)(()=>F.provider.provideTasks(O.CancellationToken.None)).then(re=>this.v(R,T,F,re));return new Promise(re=>{X.then(me=>{Promise.all(T).then(()=>{re(me)})})})}async $resolveTask(L,R){const F=this.j.get(L);if(!F)return Promise.reject(new Error("no handler found"));if(R.definition.type!==F.type)throw new Error(`Unexpected: Task of type [${R.definition.type}] cannot be resolved by provider of type [${F.type}].`);const T=await I.to(R,this.b,this.m);if(!T)throw new Error("Unexpected: Task cannot be resolved.");const X=await F.provider.resolveTask(T,O.CancellationToken.None);if(!X)return;this.A(X,F);const re=I.from(X,F.extension);if(!re)throw new Error("Unexpected: Task cannot be resolved.");if(X.definition!==T.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return u.is(re.execution)&&await this.y(re,X,!0),await this.w(re)}x(){return this.h++}async y(L,R,F){const T=await this.a.$createTaskId(L);!F&&!this.m.has(T)&&(this.n.add(T),this.o.set(T,R.execution)),this.m.set(T,R.execution)}async z(L,R){if(typeof L=="string"){const X=this.l.get(L);if(!X)throw new c.$bb("Unexpected: The specified task is missing an execution");return X}const F=this.l.get(L.id);if(F)return F;let T;return R?T=Promise.resolve(new P(this,L.id,R)):T=I.to(L.task,this.b,this.m).then(X=>{if(!X)throw new c.$bb("Unexpected: Task does not exist.");return new P(this,L.id,X)}),this.l.set(L.id,T),T.then(X=>(this.k.set(L.id,X),X))}A(L,R){L._deprecated&&this.g.report("Task.constructor",R.extension,"Use the Task constructor that takes a `scope` instead.")}B(L){this.o.get(L.id)&&this.o.delete(L.id),this.n.has(L.id)&&this.p!==L.id&&(this.m.delete(L.id),this.n.delete(L.id));const F=this.n.values();let T=F.next();for(;!T.done;)!this.o.has(T.value)&&this.p!==T.value&&(this.m.delete(T.value),this.n.delete(T.value)),T=F.next()}};e.$qlc=U,e.$qlc=U=Xe([qe(0,l.$OO),qe(1,b.$5O),qe(2,m.$Yjc),qe(3,d.$ZO),qe(4,y.$2jc),qe(5,D.$nkc),qe(6,s.$Oj),qe(7,r.$zjc)],U);let Q=class extends U{constructor(L,R,F,T,X,re,me,pe){super(L,R,F,T,X,re,me,pe),this.registerTaskSystem(n.Schemas.vscodeRemote,{scheme:n.Schemas.vscodeRemote,authority:"",platform:o.$b(0)})}async executeTask(L,R){if(!R.execution)throw new Error("Tasks to execute must include an execution");const F=I.from(R,L);if(F===void 0)throw new Error("Task is not valid");if(u.is(F.execution))await this.y(F,R,!1);else throw new c.$_;const T=await this.z(await this.a.$getTaskExecution(F),R);return this.a.$executeTask(F).catch(X=>{throw new Error(X)}),T}v(L,R,F,T){const X=[];if(T)for(const re of T){if(this.A(re,F),!re.definition||!L[re.definition.type]){const pe=re.source?re.source:"No task source";this.f.warn(`The task [${pe}, ${re.name}] uses an undefined task type. The task will be ignored in the future.`)}const me=I.from(re,F.extension);me&&u.is(me.execution)?(X.push(me),R.push(this.y(me,re,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:X,extension:F.extension}}async w(L){if(u.is(L.execution))return L;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(L,R){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(L,R,F){}};e.$rlc=Q,e.$rlc=Q=Xe([qe(0,l.$OO),qe(1,b.$5O),qe(2,m.$Yjc),qe(3,d.$ZO),qe(4,y.$2jc),qe(5,D.$nkc),qe(6,s.$Oj),qe(7,r.$zjc)],Q),e.$slc=(0,$.$ii)("IExtHostTask")}),define(Pe[289],Re([1,0,45,29]),function(ee,e,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9K=void 0,e.$8K=C,e.$0K=N;function C(A){return"cellResults"in A}e.$9K="rawCell#";function N(A,m){let d=-1;const y=[];let O=[];return A.forEach(l=>{l.range.startLineNumber!==d&&O.length>0&&(y.push([...O]),O=[]),O.push(l),d=l.range.endLineNumber}),O.length>0&&y.push([...O]),y.map(l=>{const b=[],$=l[0].range.startLineNumber,n=l[l.length-1].range.endLineNumber;for(let o=$;o<=n;o++)b.push(m.getLineContent(o));return new k.$LK(b.join(`
`)+`
`,l.map(o=>new M.$dt(o.range.startLineNumber-1,o.range.startColumn-1,o.range.endLineNumber-1,o.range.endColumn-1)))})}}),define(Pe[290],Re([1,0,169,22,5,6,28,15,17,2,43,74,4,31,8,7,50,265,112,26,12,219,289,287]),function(ee,e,k,M,C,N,A,m,d,y,O,D,l,b,$,n,o,s,r,i,c,h,t,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5kc=void 0;class a{get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(v=>v.apiEditor)}constructor(v,f,u,E,w,I){this.q=u,this.r=E,this.s=w,this.t=I,this.f=new Map,this.g=new A.$Bc,this.h=new Map,this.j=new C.$7d,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new C.$7d,this.onDidOpenNotebookDocument=this.m.event,this.n=new C.$7d,this.onDidCloseNotebookDocument=this.n.event,this.o=new C.$7d,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new D.$xjc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=v.getProxy(l.$sM.MainThreadNotebook),this.c=v.getProxy(l.$sM.MainThreadNotebookDocuments),this.d=v.getProxy(l.$sM.MainThreadNotebookEditors),this.i=f.converter,f.registerArgumentProcessor({processArgument:S=>{if(S&&S.$mid===13){const P=S.notebookEditor?.notebookUri,U=S.cell.handle,H=this.g.get(P)?.getCell(U);if(H)return H.apiCell}if(S&&S.$mid===14){const P=S.uri,U=this.g.get(P);if(U)return U.apiNotebook}return S}}),a.B(f)}getEditorById(v){const f=this.h.get(v);if(!f)throw new Error(`unknown text editor: ${v}. known editors: ${[...this.h.keys()]} `);return f}getIdByEditor(v){for(const[f,u]of this.h)if(u.apiEditor===v)return f}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(v,f){const u=this.g.get(v);if(!u&&!f)throw new Error(`NO notebook document for '${v}'`);return u}static u(v,f){if(!f)return;const u=f.filenamePattern.map(E=>$.NotebookExclusiveDocumentPattern.from(E)).filter(E=>E!==void 0);if(f.filenamePattern&&!u){console.warn(`Notebook content provider view options file name pattern is invalid ${f.filenamePattern}`);return}return{extension:v.identifier,providerDisplayName:v.displayName||v.name,displayName:f.displayName,filenamePattern:u,exclusive:f.exclusive||!1}}registerNotebookCellStatusBarItemProvider(v,f,u){const E=a.a++,w=typeof u.onDidChangeCellStatusBarItems=="function"?a.a++:void 0;this.f.set(E,u),this.b.$registerNotebookCellStatusBarItemProvider(E,w,f);let I;return w!==void 0&&(I=u.onDidChangeCellStatusBarItems(S=>this.b.$emitCellStatusBarEvent(w))),new n.$uM(()=>{this.f.delete(E),this.b.$unregisterNotebookCellStatusBarItemProvider(E,w),I?.dispose()})}async createNotebookDocument(v){const f=await this.c.$tryCreateNotebook({viewType:v.viewType,content:v.content&&$.NotebookData.from(v.content)});return y.URI.revive(f)}async openNotebookDocument(v){const f=this.g.get(v);if(f)return f.apiNotebook;const u=await this.c.$tryOpenNotebook(v),E=this.g.get(y.URI.revive(u));return(0,d.$7f)(E?.apiNotebook)}async showNotebookDocument(v,f){y.URI.isUri(v)&&(v=await this.openNotebookDocument(v));let u;typeof f=="object"?u={position:$.ViewColumn.from(f.viewColumn),preserveFocus:f.preserveFocus,selections:f.selections&&f.selections.map($.NotebookRange.from),pinned:typeof f.preview=="boolean"?!f.preview:void 0}:u={preserveFocus:!1};const E=await this.d.$tryShowNotebookDocument(v.uri,v.notebookType,u),w=E&&this.h.get(E)?.apiEditor;if(w)return w;throw E?new Error(`Could NOT open editor for "${v.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${v.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(v,f,u,E){const w=this.f.get(v),I=y.URI.revive(f),S=this.g.get(I);if(!S||!w)return;const P=S.getCellFromIndex(u);if(!P)return;const U=await w.provideCellStatusBarItems(P.apiCell,E);if(!U)return;const Q=new N.$Tc,H=this.p.add([Q]),R=(Array.isArray(U)?U:[U]).map(F=>$.NotebookStatusBarItem.from(F,this.i,Q));return{cacheId:H,items:R}}$releaseNotebookCellStatusBarItems(v){this.p.delete(v)}registerNotebookSerializer(v,f,u,E,w){if((0,m.$Ue)(f))throw new Error("viewType cannot be empty or just whitespace");const I=this.w++;return this.x.set(I,{viewType:f,serializer:u,options:E}),this.b.$registerNotebookSerializer(I,{id:v.identifier,location:v.extensionLocation},f,$.NotebookDocumentContentOptions.from(E),a.u(v,w)),(0,N.$Sc)(()=>{this.b.$unregisterNotebookSerializer(I)})}async $dataToNotebook(v,f,u){const E=this.x.get(v);if(!E)throw new Error("NO serializer found");const w=await E.serializer.deserializeNotebook(f.buffer,u);return new o.$fw($.NotebookData.from(w))}async $notebookToData(v,f,u){const E=this.x.get(v);if(!E)throw new Error("NO serializer found");const w=await E.serializer.serializeNotebook($.NotebookData.to(f.value),u);return M.$ue.wrap(w)}async $saveNotebook(v,f,u,E,w){const I=y.URI.revive(f),S=this.x.get(v);if(!S)throw new Error("NO serializer found");const P=this.g.get(I);if(!P)throw new Error("Document NOT found");if(P.versionId!==u)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(I.scheme))throw new O.$0k((0,k.localize)(0,null,this.z(I)),6);await this.y(I,E);const U={metadata:(0,i.$Xn)(P.apiNotebook.metadata,F=>!(S.options?.transientDocumentMetadata??{})[F]),cells:[]};for(const F of P.apiNotebook.getCells()){const T=new n.$WN(F.kind,F.document.getText(),F.document.languageId,F.mime,S.options?.transientOutputs?[]:[...F.outputs],F.metadata,F.executionSummary);T.metadata=(0,i.$Xn)(F.metadata,X=>!(S.options?.transientCellMetadata??{})[X]),U.cells.push(T)}const Q=await S.serializer.serializeNotebook(U,w);await this.s.value.writeFile(I,Q);const H=this.s.getFileSystemProviderExtUri(I.scheme),L=await this.s.value.stat(I);return{name:H.basename(I),isFile:(L.type&O.FileType.File)!==0,isDirectory:(L.type&O.FileType.Directory)!==0,isSymbolicLink:(L.type&O.FileType.SymbolicLink)!==0,mtime:L.mtime,ctime:L.ctime,size:L.size,readonly:!!((L.permissions??0)&O.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(I.scheme),locked:!!((L.permissions??0)&O.FilePermission.Locked),etag:O.$il({mtime:L.mtime,size:L.size}),children:void 0}}async $searchInNotebooks(v,f,u,E,w){const I=this.x.get(v)?.serializer;if(!I)return{limitHit:!1,results:[]};const S=new A.$Cc;await(async(L,R,F)=>{await Promise.all(L.map(async T=>await Promise.all(T.filenamePatterns.map(X=>{const re={_reason:F._reason,folderQueries:F.folderQueries,includePattern:F.includePattern,excludePattern:F.excludePattern,maxResults:F.maxResults,type:1,filePattern:X};return this.t.doInternalFileSearchWithCustomCallback(re,R,me=>{me.forEach(pe=>{S.has(pe)||E.some(be=>T.isFromSettings&&!be.isFromSettings?!1:be.filenamePatterns.some(se=>(0,p.$Ufb)(se,pe)))||S.add(pe)})}).catch(me=>{if(me.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw me})}))))})(u,w,f);const U=new A.$Bc;let Q=!1;const H=Array.from(S).map(async L=>{const R=[];try{if(w.isCancellationRequested)return;if(f.maxResults&&[...U.values()].reduce((re,me)=>re+me.cellResults.length,0)>f.maxResults){Q=!0;return}const F=[],T=this.g.get(L);if(T)T.apiNotebook.getCells().forEach(me=>F.push({input:me.document.getText(),outputs:me.outputs.flatMap(pe=>pe.items.map(ae=>ae.data.toString()))}));else{const re=await this.s.value.readFile(L),me=M.$ue.fromString(re.toString()),pe=await I.deserializeNotebook(me.buffer,w);if(w.isCancellationRequested)return;$.NotebookData.from(pe).cells.forEach(be=>F.push({input:be.source,outputs:be.outputs.flatMap(se=>se.items.map(De=>De.valueBytes.toString()))}))}if(w.isCancellationRequested)return;F.forEach((re,me)=>{const pe=f.contentPattern.pattern,ae=new h.$6Ub(re.input,void 0,re.outputs),be=ae.findInInputs(pe),se=ae.findInOutputs(pe),De=se.flatMap(Oe=>(0,t.$0K)(Oe.matches,Oe.textBuffer)).map((Oe,ie)=>(Oe.webviewIndex=ie,Oe));if(be.length>0||se.length>0){const Oe={index:me,contentResults:(0,t.$0K)(be,ae.inputTextBuffer),webviewResults:De};R.push(Oe)}});const X={resource:L,cellResults:R};U.set(L,X);return}catch{return}});return await Promise.all(H),{limitHit:Q,results:[...U.values()]}}async y(v,f){const u=await this.s.value.stat(v);if(typeof f?.mtime=="number"&&typeof f.etag=="string"&&f.etag!==O.$hl&&typeof u.mtime=="number"&&typeof u.size=="number"&&f.mtime<u.mtime&&f.etag!==O.$il({mtime:f.mtime,size:u.size}))throw new O.$0k((0,k.localize)(1,null),3,f)}z(v){return v.scheme===c.Schemas.file?v.fsPath:v.toString()}A(v,f,u){if(this.h.has(f))throw new Error(`editor with id ALREADY EXSIST: ${f}`);const E=new r.$Vkc(f,this.d,v,u.visibleRanges.map($.NotebookRange.to),u.selections.map($.NotebookRange.to),typeof u.viewColumn=="number"?$.ViewColumn.to(u.viewColumn):void 0);this.h.set(f,E)}$acceptDocumentAndEditorsDelta(v){if(v.value.removedDocuments)for(const u of v.value.removedDocuments){const E=y.URI.revive(u),w=this.g.get(E);w&&(w.dispose(),this.g.delete(E),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:w.apiNotebook.getCells().map(I=>I.document.uri)}),this.n.fire(w.apiNotebook));for(const I of this.h.values())I.notebookData.uri.toString()===E.toString()&&this.h.delete(I.id)}if(v.value.addedDocuments){const u=[];for(const E of v.value.addedDocuments){const w=y.URI.revive(E.uri);if(this.g.has(w))throw new Error(`adding EXISTING notebook ${w} `);const I=new s.$Ukc(this.c,this.q,this.r,w,E);u.push(...E.cells.map(S=>s.$Tkc.asModelAddData(S))),this.g.get(w)?.dispose(),this.g.set(w,I),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:u}),this.m.fire(I.apiNotebook)}}if(v.value.addedEditors)for(const u of v.value.addedEditors){if(this.h.has(u.id))return;const E=y.URI.revive(u.documentUri),w=this.g.get(E);w&&this.A(w,u.id,u)}const f=[];if(v.value.removedEditors)for(const u of v.value.removedEditors){const E=this.h.get(u);E&&(this.h.delete(u),this.k?.id===E.id&&(this.k=void 0),f.push(E))}if(v.value.visibleEditors){this.l=v.value.visibleEditors.map(E=>this.h.get(E)).filter(E=>!!E);const u=new Set;this.l.forEach(E=>u.add(E.id));for(const E of this.h.values()){const w=u.has(E.id);E._acceptVisibility(w)}this.l=[...this.h.values()].map(E=>E).filter(E=>E.visible),this.o.fire(this.visibleNotebookEditors)}v.value.newActiveEditor===null?this.k=void 0:v.value.newActiveEditor&&(this.h.get(v.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${v.value.newActiveEditor}`),this.k=this.h.get(v.value.newActiveEditor)),v.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(v){const f=b.$aP.String.with("notebookType","A notebook type"),u=new b.$cP("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[f,new b.$aP("data","Bytes to convert to data",w=>w instanceof Uint8Array,w=>M.$ue.wrap(w))],new b.$bP("Notebook Data",w=>$.NotebookData.to(w.value))),E=new b.$cP("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[f,new b.$aP("NotebookData","Notebook data to convert to bytes",w=>!0,w=>new o.$fw($.NotebookData.from(w)))],new b.$bP("Bytes",w=>w.buffer));v.registerApiCommand(u),v.registerApiCommand(E)}}e.$5kc=a,a.a=0}),define(Pe[291],Re([1,0,19,24,42,34,23,65,45]),function(ee,e,k,M,C,N,A,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wkc=void 0;class y{constructor(l,b,$){this.k=l,this.l=b,this.o=$,this.e=!1,this.f=0,this.g=!1,this.a=l.filePattern,this.b=l.includePattern&&N.$ck(l.includePattern),this.c=l.maxResults||void 0,this.d=l.exists,this.h=new Set,this.j=l.excludePattern&&N.$ck(l.excludePattern)}cancel(){this.g=!0,this.h.forEach(l=>l.cancel()),this.h=new Set}search(l){const b=this.k.folderQueries||[];return new Promise(($,n)=>{const o=s=>{this.f++,l(s)};if(this.g)return $({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(s=>{const r=s.toString(),i=k.$oc(r);this.j&&this.j(r,i)||this.v(o,{base:s,basename:i})}),Promise.all(b.map(s=>this.p(s,o))).then(s=>{$({limitHit:this.e,stats:s[0]||void 0})},s=>{n(new Error((0,C.$6i)(s)))})})}async p(l,b){const $=new M.$ee,n=this.q(l),o=this.r(),s=new d.$ZK(this.k,l),r=!s.hasSiblingExcludeClauses();let i;try{this.h.add($),i=m.$3d.create();const c=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},n,$.token),h=i.elapsed(),t=m.$3d.create();return this.g&&!this.e||(c&&c.forEach(p=>{const a=k.$hc.relative(l.folder.path,p.path);if(r){const g=k.$oc(p.path);this.v(b,{base:l.folder,relativePath:a,basename:g});return}this.s(o,l.folder,a,b)}),this.g&&!this.e)?null:(this.u(o,s,b),{providerTime:h,postProcessTime:t.elapsed()})}finally{$.dispose(),this.h.delete($)}}q(l){const b=(0,d.$YK)(this.k.includePattern,l.includePattern),$=(0,d.$YK)(this.k.excludePattern,l.excludePattern);return{folder:l.folder,excludes:$,includes:b,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!l.disregardParentIgnoreFiles,followSymlinks:!l.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}s({pathToEntries:l},b,$,n){if($===this.a){const s=k.$oc(this.a);this.v(n,{base:b,relativePath:this.a,basename:s})}function o(s){const r=k.$oc(s),i=k.$nc(s);let c=l[i];c||(c=l[i]=[],o(i)),c.push({base:b,relativePath:s,basename:r})}o($)}u({rootEntries:l,pathToEntries:b},$,n){const o=this,s=this.a;function r(i){const c=(0,d.$2K)(()=>i.map(h=>h.basename));for(let h=0,t=i.length;h<t;h++){const p=i[h],{relativePath:a,basename:g}=p;if($.matchesExcludesSync(a,g,s!==g?c:void 0))continue;const v=b[a];if(v)r(v);else{if(a===s)continue;o.v(n,p)}if(o.e)break}}r(l)}v(l,b){(!this.b||b.relativePath&&this.b(b.relativePath,b.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||l(b))}}class O{constructor(){this.b=new Map}fileSearch(l,b,$,n){const o=this.c(l.cacheKey),s=new y(l,b,o&&o.token);let r=0;const i=c=>{r+=c.length,$(c.map(h=>this.d(h)))};return this.e(s,O.a,i,n).then(c=>({limitHit:c.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:r,detailStats:c.stats}}))}clearCache(l){this.c(l)?.cancel()}c(l){if(l)return this.b.has(l)||this.b.set(l,new M.$ee),this.b.get(l)}d(l){return l.relativePath?{resource:A.$Vg(l.base,l.relativePath)}:{resource:l.base}}e(l,b,$,n){const o=n.onCancellationRequested(()=>{l.cancel()}),s=i=>{i&&(r.push(i),b>0&&r.length>=b&&($(r),r=[]))};let r=[];return l.search(s).then(i=>(r.length&&$(r),o.dispose(),i),i=>(r.length&&$(r),o.dispose(),Promise.reject(i)))}}e.$Wkc=O,O.a=512}),define(Pe[292],Re([1,0,18,260,34,92,28,12,19,23,15,17,2,96,186,47,13,48,107,288,45]),function(ee,e,k,M,C,N,A,m,d,y,O,D,l,b,$,n,o,s,r,i,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9L=void 0,e.$0L=E;let h=class{constructor(I,S,P,U,Q){this.a=I,this.b=S,this.c=P,this.d=U,this.e=Q}text(I,S,P={}){I=this.f(I,P);const U=this.a.getValue(),Q=S&&S.some(L=>!this.a.getValue({resource:L}).search.useRipgrep);return{...this.h(S?.map(s.$Di),P),type:2,contentPattern:I,previewOptions:P.previewOptions,maxFileSize:P.maxFileSize,usePCRE2:U.search.usePCRE2||Q||!1,beforeContext:P.beforeContext,afterContext:P.afterContext,userDisabledExcludesAndIgnoreFiles:P.disregardExcludeSettings&&P.disregardIgnoreFiles}}f(I,S){const P=this.a.getValue();I.isRegExp&&(I.pattern=I.pattern.replace(/\r?\n/g,"\\n"));const U={...I,wordSeparators:P.editor.wordSeparators};return this.j(I,S)&&(U.isCaseSensitive=!0),this.k(I)&&(U.isMultiline=!0),S.notebookSearchConfig?.includeMarkupInput&&(U.notebookInfo||(U.notebookInfo={}),U.notebookInfo.isInNotebookMarkdownInput=S.notebookSearchConfig.includeMarkupInput),S.notebookSearchConfig?.includeMarkupPreview&&(U.notebookInfo||(U.notebookInfo={}),U.notebookInfo.isInNotebookMarkdownPreview=S.notebookSearchConfig.includeMarkupPreview),S.notebookSearchConfig?.includeCodeInput&&(U.notebookInfo||(U.notebookInfo={}),U.notebookInfo.isInNotebookCellInput=S.notebookSearchConfig.includeCodeInput),S.notebookSearchConfig?.includeOutput&&(U.notebookInfo||(U.notebookInfo={}),U.notebookInfo.isInNotebookCellOutput=S.notebookSearchConfig.includeOutput),U}file(I,S={}){return{...this.h(I,S),type:1,filePattern:S.filePattern?S.filePattern.trim():S.filePattern,exists:S.exists,sortByScore:S.sortByScore,cacheKey:S.cacheKey,shouldGlobMatchFilePattern:S.shouldGlobSearch}}g(I,S){return I?(I=Array.isArray(I)?I.map(v):v(I),S?this.parseSearchPaths(I):{pattern:p(...Array.isArray(I)?I:[I])}):{}}h(I=[],S={}){const P=this.g(S.includePattern,S.expandPatterns),U=this.g(S.excludePattern,S.expandPatterns),Q=I.length>1,H=(P.searchPaths&&P.searchPaths.length?P.searchPaths.map(F=>this.q(F,S,U)):I.map(F=>this.r(F,S,U,Q))).filter(F=>!!F),L={_reason:S._reason,folderQueries:H,usingSearchPaths:!!(P.searchPaths&&P.searchPaths.length),extraFileResources:S.extraFileResources,excludePattern:U.pattern,includePattern:P.pattern,onlyOpenEditors:S.onlyOpenEditors,maxResults:S.maxResults};if(S.onlyOpenEditors){const F=k.$Hb(k.$Rb(this.c.groups.map(re=>re.editors.map(me=>me.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(F));const T=F.filter(re=>(0,c.$PK)(L,re.fsPath)),X=this.i(T);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(X)),{...L,...X}}const R=S.extraFileResources&&S.extraFileResources.filter(F=>(0,c.$PK)(L,F.fsPath));return L.extraFileResources=R&&R.length?R:void 0,L}i(I){const S=[],P=new A.$Bc,U={};let Q=!1;return I.forEach(H=>{if(H.scheme===m.Schemas.walkThrough)return;if((0,y.$Zg)(H)){const R=this.b.getWorkspaceFolder(H)?.uri??H.with({path:d.$nc(H.fsPath)});let F=P.get(R);F||(Q=!0,F={folder:R,includePattern:{}},S.push(F),P.set(R,F));const T=d.$mc(R.fsPath,H.fsPath);(0,D.$7f)(F.includePattern)[T.replace(/\\/g,"/")]=!0}else H.fsPath&&(Q=!0,U[H.fsPath]=!0)}),{folderQueries:S,includePattern:U,usingSearchPaths:!0,excludePattern:Q?void 0:{"**/*":!0}}}j(I,S){if(S.isSmartCase){if(I.isRegExp){if(O.$Mf(I.pattern,!0))return!0}else if(O.$Mf(I.pattern))return!0}return!!I.isCaseSensitive}k(I){return I.isMultiline||I.isRegExp&&(0,b.$uC)(I.pattern)||I.pattern.indexOf(`
`)>=0?!0:!!I.isMultiline}parseSearchPaths(I){const S=X=>d.$jc(X)||/^\.\.?([\/\\]|$)/.test(X),U=(Array.isArray(I)?I:a(I)).map(X=>{const re=this.e.resolvedUserHome;return re?(0,N.$kw)(X,re.scheme===m.Schemas.file?re.fsPath:re.path):X}),Q=M.$E(U,X=>S(X)?"searchPaths":"exprSegments"),H=(Q.exprSegments||[]).map(X=>O.$6e(X,"/")).map(X=>O.$6e(X,"\\")).map(X=>(X[0]==="."&&(X="*"+X),g(X))),L={},R=this.m(Q.searchPaths||[]);R&&R.length&&(L.searchPaths=R);const F=k.$Rb(H),T=p(...F);return T&&(L.pattern=T),L}l(I,S){return S.disregardExcludeSettings?void 0:(0,c.$OK)(I,!S.disregardSearchExcludeSettings)}m(I){if(!I||!I.length)return[];const S=I.flatMap(U=>{let{pathPortion:Q,globPortion:H}=t(U);return H&&(H=f(H)),this.n(Q).flatMap(R=>this.o(R,H))}),P=new Map;return S.forEach(U=>{const Q=U.searchPath.toString(),H=P.get(Q);H?U.pattern&&(H.pattern=H.pattern||{},H.pattern[U.pattern]=!0):P.set(Q,{searchPath:U.searchPath,pattern:U.pattern?p(U.pattern):void 0})}),Array.from(P.values())}n(I){if(d.$jc(I)){const S=this.b.getWorkspace().folders;return S[0]&&S[0].uri.scheme!==m.Schemas.file?[{searchPath:S[0].uri.with({path:I})}]:[{searchPath:l.URI.file(d.$ic(I))}]}if(this.b.getWorkbenchState()===2){const S=this.b.getWorkspace().folders[0].uri;if(I=v(I),I.startsWith("../")||I===".."){const U=d.$hc.resolve(S.path,I);return[{searchPath:S.with({path:U})}]}const P=f(I);return[{searchPath:S,pattern:P}]}else{if(I==="./"||I===".\\")return[];{const S=I.replace(/^\.[\/\\]/,""),U=this.b.getWorkspace().folders.map(Q=>{const H=S.match(new RegExp(`^${O.$Ze(Q.name)}(?:/(.*)|$)`));return H?{match:H,folder:Q}:null}).filter(D.$4f);if(U.length)return U.map(Q=>{const H=Q.match[1];return{searchPath:Q.folder.uri,pattern:H&&f(H)}});{const Q=I.match(/\.[\/\\](.+)[\/\\]?/),H=Q?Q[1]:I,L=$.localize(0,null,H);throw new Error(L)}}}}o(I,S){const P=I.pattern&&S?`${I.pattern}/${S}`:I.pattern||S,U=[{searchPath:I.searchPath,pattern:P}];return P&&!P.endsWith("**")&&U.push({searchPath:I.searchPath,pattern:P+"/**"}),U}q(I,S,P){const U=this.r((0,s.$Di)(I.searchPath),S,P,!1);return U?{...U,includePattern:I.pattern}:null}r(I,S,P,U){let Q;const H=l.URI.isUri(I)?I:I.uri;if(P.searchPaths){const X=P.searchPaths.filter(re=>(0,y.$Og)(re.searchPath,H))[0];if(X&&!X.pattern)return null;X&&(Q=X.pattern)}const L=this.a.getValue({resource:H}),F={...this.l(L,S)||{},...Q||{}},T=l.URI.isUri(I)?(0,y.$Sg)(I):I.name;return{folder:H,folderName:U?T:void 0,excludePattern:Object.keys(F).length>0?F:void 0,fileEncoding:L.files&&L.files.encoding,disregardIgnoreFiles:typeof S.disregardIgnoreFiles=="boolean"?S.disregardIgnoreFiles:!L.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof S.disregardGlobalIgnoreFiles=="boolean"?S.disregardGlobalIgnoreFiles:!L.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof S.disregardParentIgnoreFiles=="boolean"?S.disregardParentIgnoreFiles:!L.search.useParentIgnoreFiles,ignoreSymlinks:typeof S.ignoreSymlinks=="boolean"?S.ignoreSymlinks:!L.search.followSymlinks}}};e.$9L=h,e.$9L=h=Xe([qe(0,n.$Oi),qe(1,s.$ri),qe(2,r.$BD),qe(3,o.$Oj),qe(4,i.$7L)],h);function t(w){const I=w.match(/[\*\{\}\(\)\[\]\?]/);if(I){const S=I.index,P=w.substr(0,S).match(/[/|\\][^/\\]*$/);if(P){let U=w.substr(0,P.index);return U.match(/[/\\]/)||(U+="/"),{pathPortion:U,globPortion:w.substr((P.index||0)+1)}}}return{pathPortion:w}}function p(...w){return w.length?w.reduce((I,S)=>(I[S]=!0,I),Object.create(null)):void 0}function a(w){return C.$ak(w,",").map(I=>I.trim()).filter(I=>!!I.length)}function g(w){return[`**/${w}/**`,`**/${w}`].map(S=>S.replace(/\*\*\/\*\*/g,"**"))}function v(w){return w.replace(/\\/g,"/")}function f(w){return v(w).replace(/^\.\//,"").replace(/\/+$/g,"")}function u(w){return w.replace(/([?*[\]])/g,"[$1]")}function E(w,I){w=k.$Mb(w,U=>U.toString());const S=[],P=I.getWorkspace();return w&&w.forEach(U=>{let Q;if(I.getWorkbenchState()===2)Q=(0,y.$Xg)(P.folders[0].uri,U),Q&&Q!=="."&&(Q="./"+Q);else{const H=I.getWorkspaceFolder(U);if(H){const L=H.name;if(P.folders.filter(F=>F.name===L).length===1){const F=(0,y.$Xg)(H.uri,U);F===""?Q=`./${H.name}`:Q=`./${H.name}/${F}`}else Q=U.fsPath}}Q&&S.push(u(Q))}),S}}),define(Pe[293],Re([1,0,23,2,24,14,3,292,45,48,11]),function(ee,e,k,M,C,N,A,m,d,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$evb=l,e.$fvb=n;const D=7e3;function l(o,s){const r=s.activationEvents;if(!r)return Promise.resolve(void 0);const i=[],c=[];for(const v of r)if(/^workspaceContains:/.test(v)){const f=v.substr(18);f.indexOf("*")>=0||f.indexOf("?")>=0||o.forceUsingSearch?c.push(f):i.push(f)}if(i.length===0&&c.length===0)return Promise.resolve(void 0);const{promise:h,resolve:t}=(0,O.$bh)(),p=v=>t({activationEvent:v}),a=Promise.all(i.map(v=>b(o,v,p))).then(()=>{}),g=$(o,s.identifier,c,p);return Promise.all([a,g]).then(()=>{t(void 0)}),h}async function b(o,s,r){for(const i of o.folders)if(await o.exists(k.$Vg(M.URI.revive(i),s))){r(`workspaceContains:${s}`);return}}async function $(o,s,r,i){if(r.length===0)return Promise.resolve(void 0);const c=new C.$ee,h=o.checkExists(o.folders,r,c.token),t=setTimeout(async()=>{c.cancel(),o.logService.info(`Not activating extension '${s.value}': Timed out while searching for 'workspaceContains' pattern ${r.join(",")}`)},D);let p=!1;try{p=await h}catch(a){N.$4(a)||N.$1(a)}c.dispose(),clearTimeout(t),p&&i(`workspaceContains:${r.join(",")}`)}function n(o,s,r,i){const c=o.get(A.$hi),h=o.get(d.$GK),p=c.createInstance(m.$9L).file(s.map(a=>(0,y.$Di)(M.URI.revive(a))),{_reason:"checkExists",includePattern:r,exists:!0});return h.fileSearch(p,i).then(a=>!!a.limitHit,a=>N.$4(a)?!1:Promise.reject(a))}});var _e=this&&this.__classPrivateFieldSet||function(ee,e,k,M,C){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?C.call(ee,k):C?C.value=k:e.set(ee,k),k},Ve=this&&this.__classPrivateFieldGet||function(ee,e,k,M){if(k==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!M:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return k==="m"?M:k==="a"?M.call(ee):M?M.value:e.get(ee)};define(Pe[38],Re([1,0,165,19,89,23,11,6,52,2,13,4,37,225,82,36,25,108,14,20,22,207,7,102,3,27,85,16,71,86,51,88,5,293,81,209,12,79,65,21,80]),function(ee,e,k,M,C,N,A,m,d,y,O,D,l,b,$,n,o,s,r,i,c,h,t,p,a,g,v,f,u,E,w,I,S,P,U,Q,H,L,R,F,T){"use strict";var X,re,me,pe;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ckc=e.$Bkc=e.$Akc=e.$zkc=e.$ykc=void 0,e.$ykc=(0,a.$ii)("IHostUtils");let ae=pe=class extends m.$Uc{constructor($e,we,ge,ce,K,Z,le,fe,Te,ve,Ie,Ae,je){super(),this.Y=Ae,this.Z=je,this.a=this.B(new S.$7d),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=we,this.g=ge,this.f=le,this.j=ce,this.m=K,this.s=Z,this.t=Te,this.u=ve,this.w=Ie,this.y=this.g.getProxy(D.$sM.MainThreadWorkspace),this.z=this.g.getProxy(D.$sM.MainThreadTelemetry),this.C=this.g.getProxy(D.$sM.MainThreadExtensionService),this.D=new A.$hh,this.F=new A.$hh,this.G=new A.$hh,this.H=new A.$hh,this.I=new de(this.f.extensions.activationEvents),this.L=new s.$q$b(this.I,this.f.extensions.allExtensions);const j=new i.$Fm(this.f.extensions.myExtensions);this.J=new s.$q$b(this.I,ie(this.L,j)),F.$n&&(this.s.info(`Creating extension host with the following global extensions: ${De(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${De(this.J)}`)),this.M=new $.$jkc(this.g,this.s),this.N=new U.$rkc(this.g),this.O=fe,this.h=$e.createChild(new u.$gi([$.$kkc,this.M],[U.$skc,this.N])),this.P=this.B(new b.$ikc(this.J,this.L,{onExtensionActivationError:(B,G,W)=>{this.C.$onExtensionActivationError(B,r.$3(G),W)},actualActivateExtension:async(B,G)=>{if(s.$q$b.isHostExtension(B,this.J,this.L))return await this.C.$activateExtension(B,G),new b.$hkc;const W=this.J.getExtensionDescription(B);return this.fb(W,G)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),C.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch($e){r.$1($e)}}async $(){this.O.onWillDeactivateAll();let $e=[];try{$e=this.J.getAllExtensionDescriptions().map(K=>K.identifier).filter(K=>this.isActivated(K)).map(K=>this.eb(K))}catch{}await Promise.all($e)}terminate($e,we=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${$e}`),this.s.flush(),this.u.dispose(),this.P.dispose(),r.setUnexpectedErrorHandler(ce=>{this.s.error(ce)}),this.g.dispose();const ge=this.$();Promise.race([(0,A.$jh)(5e3),ge]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${we}`):this.s.info(`Extension host exiting with code ${we}`),this.s.flush(),this.s.dispose(),this.c.exit(we)})}isActivated($e){return this.G.isOpen()?this.P.isActivated($e):!1}async getExtension($e){const we=await this.C.$getExtension($e);return we&&{...we,identifier:new i.$Em(we.identifier.value),extensionLocation:y.URI.revive(we.extensionLocation)}}ab($e,we){return this.P.activateByEvent($e,we)}bb($e,we){return this.P.activateById($e,we)}activateByIdWithErrors($e,we){return this.bb($e,we).then(()=>{const ge=this.P.getActivatedExtension($e);if(ge.activationFailed)return Promise.reject(ge.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then($e=>this.J)}getExtensionExports($e){if(this.G.isOpen())return this.P.getActivatedExtension($e).exports;try{return this.P.getActivatedExtension($e).exports}catch{return null}}async cb($e){if($e.scheme===H.Schemas.file&&this.c.fsRealpath){const we=$e.fsPath;this.R.has(we)||this.R.set(we,this.c.fsRealpath(we));const ge=await this.R.get(we);return y.URI.file(ge)}return $e}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then($e=>new q($e))),this.Q}async db($e){const we=d.$oi.forUris(ge=>N.$Mg.ignorePathCasing(ge));return await Promise.all($e.map(async ge=>{if(this.wb(ge)){const ce=await this.cb(ge.extensionLocation);we.set(ce,ge)}})),we}eb($e){let we=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated($e))return we;const ge=this.P.getActivatedExtension($e);if(!ge)return we;try{typeof ge.module.deactivate=="function"&&(we=Promise.resolve(ge.module.deactivate()).then(void 0,ce=>(this.s.error(ce),Promise.resolve(void 0))))}catch(ce){this.s.error(`An error occurred when deactivating the extension '${$e.value}':`),this.s.error(ce)}try{(0,m.$Pc)(ge.subscriptions)}catch(ce){this.s.error(`An error occurred when deactivating the subscriptions for extension '${$e.value}':`),this.s.error(ce)}return we}async fb($e,we){return this.f.remote.isRemote?this.C.$onWillActivateExtension($e.identifier):await this.C.$onWillActivateExtension($e.identifier),this.hb($e,we).then(ge=>{const ce=ge.activationTimes;return this.C.$onDidActivateExtension($e.identifier,ce.codeLoadingTime,ce.activateCallTime,ce.activateResolvedTime,we),this.gb($e,we,"success",ce),ge},ge=>{throw this.gb($e,we,"failure"),ge})}gb($e,we,ge,ce){const K=se($e,we);this.z.$publicLog2("extensionActivationTimes",{...K,...ce||{},outcome:ge})}hb($e,we){const ge=se($e,we);this.z.$publicLog2("activatePlugin",ge);const ce=this.wb($e);if(!ce)return Promise.resolve(new b.$gkc(b.$dkc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${$e.identifier.value}, startup: ${we.startup}, activationEvent: '${we.activationEvent}'${$e.identifier.value!==we.extensionId.value?`, root cause: ${we.extensionId.value}`:""}`),this.s.flush();const K=new b.$ekc(we.startup);return Promise.all([this.xb($e,(0,N.$Vg)($e.extensionLocation,ce),K),this.ib($e)]).then(Z=>(C.mark(`code/extHost/willActivateExtension/${$e.identifier.value}`),pe.jb(this.s,$e.identifier,Z[0],Z[1],K))).then(Z=>(C.mark(`code/extHost/didActivateExtension/${$e.identifier.value}`),Z))}ib($e){const we=this.Z.createLanguageModelAccessInformation($e),ge=new h.$mkc($e,this.M),ce=new h.$lkc($e.identifier.value,!1,this.M),K=new Q.$tkc($e,this.N),Z=$e.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,le=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${$e.identifier.value}`),Promise.all([ge.whenReady,ce.whenReady,this.O.whenReady]).then(()=>{const fe=this;let Te,ve;const Ie=(0,o.$cG)($e,"ipc")?this.f.messagePorts?.get(i.$Em.toKey($e.identifier)):void 0;return Object.freeze({globalState:ge,workspaceState:ce,secrets:K,subscriptions:[],get languageModelAccessInformation(){return we},get extensionUri(){return $e.extensionLocation},get extensionPath(){return $e.extensionLocation.fsPath},asAbsolutePath(Ae){return M.$kc($e.extensionLocation.fsPath,Ae)},get storagePath(){return fe.O.workspaceValue($e)?.fsPath},get globalStoragePath(){return fe.O.globalValue($e).fsPath},get logPath(){return M.$kc(fe.f.logsLocation.fsPath,$e.identifier.value)},get logUri(){return y.URI.joinPath(fe.f.logsLocation,$e.identifier.value)},get storageUri(){return fe.O.workspaceValue($e)},get globalStorageUri(){return fe.O.globalValue($e)},get extensionMode(){return Z},get extension(){return Te===void 0&&(Te=new Oe(fe,$e.identifier,$e,le,!1)),Te},get extensionRuntime(){return(0,o.$dG)($e,"extensionRuntime"),fe.extensionRuntime},get environmentVariableCollection(){return fe.u.getEnvironmentVariableCollection($e)},get messagePassingProtocol(){if(!ve){if(!Ie)return;const Ae=S.Event.buffer(S.Event.fromDOMEventEmitter(Ie,"message",je=>je.data));Ie.start(),ve={onDidReceiveMessage:Ae,postMessage:Ie.postMessage.bind(Ie)}}return ve}})})}static jb($e,we,ge,ce,K){return ge=ge||{activate:void 0,deactivate:void 0},this.kb($e,we,ge,ce,K).then(Z=>new b.$fkc(!1,null,K.build(),ge,Z,ce.subscriptions))}static kb($e,we,ge,ce,K){if(typeof ge.activate=="function")try{K.activateCallStart(),$e.trace(`ExtensionService#_callActivateOptional ${we.value}`);const Z=typeof global=="object"?global:self,le=ge.activate.apply(Z,[ce]);return K.activateCallStop(),K.activateResolveStart(),Promise.resolve(le).then(fe=>(K.activateResolveStop(),fe))}catch(Z){return Promise.reject(Z)}else return Promise.resolve(ge)}lb($e,we){this.bb($e.identifier,{startup:!1,extensionId:$e.identifier,activationEvent:we}).then(void 0,ge=>{this.s.error(ge)})}mb($e,we=0){const ce=Date.now();(0,F.$v)(()=>{for(let K=we;K<$e.length;K+=1){const Z=$e[K];for(const le of Z.activationEvents??[])if(le==="onStartupFinished")if(Date.now()-ce>50){this.mb($e,K);break}else this.lb(Z,le)}})}nb(){this.C.$setPerformanceMarks(C.getMarks()),this.m.getConfigProvider().then($e=>{const we=$e.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ge=this.J.getAllExtensionDescriptions();if(we)this.mb(ge);else for(const ce of ge)if(ce.activationEvents)for(const K of ce.activationEvents)K==="onStartupFinished"&&this.lb(ce,K)})}ob(){const $e=this.ab("*",!0).then(void 0,Z=>{this.s.error(Z)});this.B(this.j.onDidChangeWorkspace(Z=>this.pb(Z.added)));const we=this.j.workspace?this.j.workspace.folders:[],ge=this.pb(we),ce=this.rb(),K=Promise.all([ce,$e,ge]).then(()=>{});return Promise.race([K,(0,A.$jh)(1e4)]).then(()=>{this.nb()}),K}pb($e){return $e.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(we=>this.qb($e,we))).then(()=>{})}async qb($e,we){if(this.isActivated(we.identifier))return;const ge=!this.f.remote.isRemote&&!!this.f.remote.authority,ce={logService:this.s,folders:$e.map(Z=>Z.uri),forceUsingSearch:ge||!this.c.fsExists,exists:Z=>this.c.fsExists(Z.fsPath),checkExists:(Z,le,fe)=>this.y.$checkExists(Z,le,fe)},K=await(0,P.$evb)(ce,we);if(K)return this.bb(we.identifier,{startup:!0,extensionId:we.identifier,activationEvent:K.activationEvent}).then(void 0,Z=>this.s.error(Z))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch($e){throw console.error($e),$e}}async sb(){const{extensionDevelopmentLocationURI:$e,extensionTestsLocationURI:we}=this.f.environment;if(!$e||!we)throw new Error(k.localize(0,null));const ge=await this.xb(null,we,new b.$ekc(!1));if(!ge||typeof ge.run!="function")throw new Error(k.localize(1,null,we.toString()));return new Promise((ce,K)=>{const Z=(Te,ve)=>{Te?(F.$n&&this.s.error("Test runner called back with error",Te),K(Te)):(F.$n&&(ve?this.s.info(`Test runner called back with ${ve} failures.`):this.s.info("Test runner called back with successful outcome.")),ce(typeof ve=="number"&&ve>0?1:0))},le=(0,N.$Jg)(we),fe=ge.run(le,Z);fe&&fe.then&&fe.then(()=>{F.$n&&this.s.info("Test runner finished successfully."),ce(0)}).catch(Te=>{F.$n&&this.s.error("Test runner finished with error",Te),K(Te instanceof Error&&Te.stack?Te.stack:String(Te))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,A.$jh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver($e,we){return this.S[$e]=we,(0,m.$Sc)(()=>{delete this.S[$e]})}async getRemoteExecServer($e){const{resolver:we}=await this.ub($e);return we?.resolveExecServer?.($e,{resolveAttempt:0})}async ub($e){const we=$e.indexOf("+");if(we===-1)throw new t.$AM("Not an authority that can be resolved!",p.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ge=$e.substr(0,we);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${ge}`,!1),{authorityPrefix:ge,resolver:this.S[ge]}}async $resolveAuthority($e,we){const ge=R.$3d.create(!1),ce=()=>`[resolveAuthority(${(0,p.$xl)($e)},${we})][${ge.elapsed()}ms] `,K=_=>this.s.info(`${ce()}${_}`),Z=_=>this.s.warn(`${ce()}${_}`),le=(_,oe=void 0)=>this.s.error(`${ce()}${_}`,oe),fe=_=>{if(_ instanceof t.$AM)return{type:"error",error:{code:_._code,message:_._message,detail:_._detail}};throw _},Te=async _=>{K(`activating resolver for ${_}...`);const{resolver:oe,authorityPrefix:Fe}=await this.ub(_);if(!oe)throw le(`no resolver for ${Fe}`),new t.$AM(`No remote extension installed to resolve ${Fe}.`,p.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:oe,authorityPrefix:Fe,remoteAuthority:_}},ve=$e.split(/@|%40/g).reverse();K(`activating remote resolvers ${ve.join(" -> ")}`);let Ie;try{Ie=await Promise.all(ve.map(Te)).catch(async _=>{if(!(_ instanceof t.$AM)||_._code!==p.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw _;return Z(`resolving nested authorities failed: ${_.message}`),[await Te($e)]})}catch(_){return fe(_)}const Ae=new A.$th;Ae.cancelAndSet(()=>K("waiting..."),1e3);let je,j;for(const[_,{authorityPrefix:oe,resolver:Fe,remoteAuthority:Be}]of Ie.entries())try{if(_===Ie.length-1)K("invoking final resolve()..."),C.mark(`code/extHost/willResolveAuthority/${oe}`),je=await Fe.resolve(Be,{resolveAttempt:we,execServer:j}),C.mark(`code/extHost/didResolveAuthorityOK/${oe}`),K("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(Fe,t.$zM.isManagedResolvedAuthority(je)?je:void 0));else{if(K(`invoking resolveExecServer() for ${Be}`),C.mark(`code/extHost/willResolveExecServer/${oe}`),j=await Fe.resolveExecServer?.(Be,{resolveAttempt:we,execServer:j}),!j)throw new t.$AM(`Exec server was not available for ${Be}`,p.RemoteAuthorityResolverErrorCode.NoResolverFound);C.mark(`code/extHost/didResolveExecServerOK/${oe}`)}}catch(Qe){return C.mark(`code/extHost/didResolveAuthorityError/${oe}`),le("returned an error",Qe),Ae.dispose(),fe(Qe)}Ae.dispose();const B={environmentTunnels:je.environmentTunnels,features:je.tunnelFeatures?{elevation:je.tunnelFeatures.elevation,privacyOptions:je.tunnelFeatures.privacyOptions,protocol:je.tunnelFeatures.protocol===void 0?!0:je.tunnelFeatures.protocol}:void 0},G={extensionHostEnv:je.extensionHostEnv,isTrusted:je.isTrusted,authenticationSession:je.authenticationSessionForInitializingExtensions?{id:je.authenticationSessionForInitializingExtensions.id,providerId:je.authenticationSessionForInitializingExtensions.providerId}:void 0};K(`returned ${t.$zM.isManagedResolvedAuthority(je)?"managed authority":`${je.host}:${je.port}`}`);let W;if(t.$zM.isManagedResolvedAuthority(je)){const _=we;this.Y.setFactory(_,je.makeConnection),W={authority:$e,connectTo:new p.$ul(_),connectionToken:je.connectionToken}}else W={authority:$e,connectTo:new p.$vl(je.host,je.port),connectionToken:je.connectionToken};return{type:"ok",value:{authority:W,options:G,tunnelInformation:B}}}async $getCanonicalURI($e,we){this.s.info(`$getCanonicalURI invoked for authority (${(0,p.$xl)($e)})`);const{resolver:ge}=await this.ub($e);if(!ge)return null;const ce=y.URI.revive(we);if(typeof ge.getCanonicalURI>"u")return ce;const K=await(0,A.$ah)(()=>ge.getCanonicalURI(ce));return K||ce}async $startExtensionHost($e){$e.toAdd.forEach(Z=>Z.extensionLocation=y.URI.revive(Z.extensionLocation));const{globalRegistry:we,myExtensions:ge}=be(this.I,this.L,this.J,$e),ce=await this.db(ge);return(await this.getExtensionPathIndex()).setSearchTree(ce),this.L.set(we.getAllExtensionDescriptions()),this.J.set(ge),F.$n&&(this.s.info(`$startExtensionHost: global extensions: ${De(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${De(this.J)}`)),this.tb()}$activateByEvent($e,we){return we===1?this.D.wait().then(ge=>this.ab($e,!1)):this.G.wait().then(ge=>this.ab($e,!1))}async $activate($e,we){return await this.G.wait(),this.J.getExtensionDescription($e)?(await this.bb($e,we),!0):!1}async $deltaExtensions($e){$e.toAdd.forEach(Z=>Z.extensionLocation=y.URI.revive(Z.extensionLocation));const{globalRegistry:we,myExtensions:ge}=be(this.I,this.L,this.J,$e),ce=await this.db(ge);return(await this.getExtensionPathIndex()).setSearchTree(ce),this.L.set(we.getAllExtensionDescriptions()),this.J.set(ge),F.$n&&(this.s.info(`$deltaExtensions: global extensions: ${De(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${De(this.J)}`)),Promise.resolve(void 0)}async $test_latency($e){return $e}async $test_up($e){return $e.byteLength}async $test_down($e){const we=c.$ue.alloc($e),ge=Math.random()%256;for(let ce=0;ce<$e;ce++)we.writeUInt8(ge,ce);return we}async $updateRemoteConnectionData($e){this.X=$e,this.a.fire()}};e.$zkc=ae,e.$zkc=ae=pe=Xe([qe(0,a.$hi),qe(1,e.$ykc),qe(2,f.$OO),qe(3,n.$Yjc),qe(4,l.$2jc),qe(5,O.$Oj),qe(6,g.$5O),qe(7,v.$5jc),qe(8,E.$kCb),qe(9,w.$nkc),qe(10,L.$vkc),qe(11,T.$wkc),qe(12,I.$Ojc)],ae);function be(Ne,$e,we,ge){Ne.addActivationEvents(ge.addActivationEvents);const ce=new s.$q$b(Ne,$e.getAllExtensionDescriptions());ce.deltaExtensions(ge.toAdd,ge.toRemove);const K=new i.$Fm(we.getAllExtensionDescriptions().map(le=>le.identifier));for(const le of ge.myToRemove)K.delete(le);for(const le of ge.myToAdd)K.add(le);const Z=ie(ce,K);return{globalRegistry:ce,myExtensions:Z}}function se(Ne,$e){return{id:Ne.identifier.value,name:Ne.name,extensionVersion:Ne.version,publisherDisplayName:Ne.publisher,activationEvents:Ne.activationEvents?Ne.activationEvents.join(","):null,isBuiltin:Ne.isBuiltin,reason:$e.activationEvent,reasonId:$e.extensionId.value}}function De(Ne){return Ne.getAllExtensionDescriptions().map($e=>$e.identifier.value).join(",")}e.$Akc=(0,a.$ii)("IExtHostExtensionService");class Oe{constructor($e,we,ge,ce,K){X.set(this,void 0),re.set(this,void 0),me.set(this,void 0),_e(this,X,$e,"f"),_e(this,re,we,"f"),_e(this,me,ge.identifier,"f"),this.id=ge.identifier.value,this.extensionUri=ge.extensionLocation,this.extensionPath=M.$ic((0,N.$Jg)(ge.extensionLocation)),this.packageJSON=ge,this.extensionKind=ce,this.isFromDifferentExtensionHost=K}get isActive(){return Ve(this,X,"f").isActivated(Ve(this,me,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Ve(this,X,"f").getExtensionExports(Ve(this,me,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Ve(this,X,"f").activateByIdWithErrors(Ve(this,me,"f"),{startup:!1,extensionId:Ve(this,re,"f"),activationEvent:"api"}),this.exports}}e.$Bkc=Oe,X=new WeakMap,re=new WeakMap,me=new WeakMap;function ie(Ne,$e){return Ne.getAllExtensionDescriptions().filter(we=>$e.has(we.identifier))}class q{constructor($e){this.a=$e}setSearchTree($e){this.a=$e}findSubstr($e){return this.a.findSubstr($e)}forEach($e){return this.a.forEach($e)}}e.$Ckc=q;class de{constructor($e){this.a=new i.$Gm,this.addActivationEvents($e)}readActivationEvents($e){return this.a.get($e.identifier)??[]}addActivationEvents($e){for(const we of Object.keys($e))this.a.set(we,$e[we])}}}),define(Pe[294],Re([1,0,89,2,4,37,25,20,16,27,3,38,13,15]),function(ee,e,k,M,C,N,A,m,d,y,O,D,l,b){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$Mlc=void 0;let n=class{constructor(c,h,t,p,a,g,v){this.c=c,this.d=h,this.f=t,this.g=p,this.h=a,this.i=g,this.j=v,this.a=new Map,this.b=[]}async install(){this.k(),k.mark("code/extHost/willWaitForConfig");const c=await this.g.getConfigProvider();k.mark("code/extHost/didWaitForConfig");const h=await this.h.getExtensionPathIndex();this.register(new s(this.c,h,this.d,c,this.j)),this.register(this.f.createInstance(o)),this.i.remote.isRemote&&this.register(this.f.createInstance(r,h,this.i.environment.appUriScheme))}register(c){if("nodeModuleName"in c)if(Array.isArray(c.nodeModuleName))for(const h of c.nodeModuleName)this.a.set(h,c);else this.a.set(c.nodeModuleName,c);typeof c.alternativeModuleName=="function"&&this.b.push(h=>c.alternativeModuleName(h))}};e.$Mlc=n,e.$Mlc=n=Xe([qe(2,O.$hi),qe(3,N.$2jc),qe(4,D.$Akc),qe(5,y.$5O),qe(6,l.$Oj)],n);let o=$=class{constructor(c){if(c.environment.appRoot&&$.a.size){const h=(0,b.$Ze)(this.c(c.environment.appRoot.fsPath)),t="[a-z0-9_.-]",p=`@${t}+\\/${t}+|${t}+`,a="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${h}/${a}\\/)(${p})(.*)$`,"i")}}alternativeModuleName(c){if(!this.b)return;const h=this.b.exec(this.c(c));if(!h)return;const[,t,p,a]=h,g=$.a.get(p);if(g!==void 0)return console.warn(`${p} as been renamed to ${g}, please update your imports`),t+g+a}c(c){return c.replace(/\\/g,"/")}};o.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),o=$=Xe([qe(0,y.$5O)],o);class s{constructor(c,h,t,p,a){this.c=c,this.d=h,this.e=t,this.f=p,this.g=a,this.nodeModuleName="vscode",this.a=new m.$Gm}load(c,h){const t=this.d.findSubstr(h);if(t){let p=this.a.get(t.identifier);return p||(p=this.c(t,this.e,this.f),this.a.set(t.identifier,p)),p}if(!this.b){let p="";this.d.forEach((a,g)=>p+=`	${g} -> ${a.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${h}. These are the extension path mappings: 
${p}`),this.b=this.c(A.$0F,this.e,this.f)}return this.b}}let r=class{constructor(c,h,t){this.e=c,this.f=h,this.nodeModuleName=["open","opn"],this.d=t.getProxy(C.$sM.MainThreadTelemetry);const p=t.getProxy(C.$sM.MainThreadWindow);this.c=(a,g)=>{const v=M.URI.parse(a);return g?this.g(a,g):v.scheme==="http"||v.scheme==="https"?p.$openUri(v,a,{allowTunneling:!0}):v.scheme==="mailto"||v.scheme===this.f?p.$openUri(v,a,{}):this.g(a,g)}}load(c,h,t){const p=this.e.findSubstr(h);return p&&(this.a=p.identifier.value,this.h()),this.b=t(c),this.c}g(c,h){return this.i(),this.b(c,h)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};r=Xe([qe(2,d.$OO)],r)}),define(Pe[120],Re([1,0,40,6,19,73,3,67,66,38,7,36,222,37]),function(ee,e,k,M,C,N,A,m,d,y,O,D,l,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ekc=e.$Dkc=void 0,e.$Dkc=(0,A.$ii)("IExtHostVariableResolverProvider");class $ extends l.$QP{constructor(s,r,i,c,h,t,p){function a(){if(i){const g=i.activeEditor();if(g)return g.document.uri;const v=c.tabGroups.all.find(f=>f.isActive)?.activeTab;if(v!==void 0){if(v.input instanceof O.$fO||v.input instanceof O.$kO)return v.input.modified;if(v.input instanceof O.$eO||v.input instanceof O.$jO||v.input instanceof O.$hO)return v.input.uri}}}super({getFolderUri:g=>{const v=t.folders.filter(f=>f.name===g);if(v&&v.length>0)return v[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(g,v)=>h.getConfiguration(void 0,g).get(v),getAppRoot:()=>N.cwd(),getExecPath:()=>N.env.VSCODE_EXEC_PATH,getFilePath:()=>{const g=a();if(g)return C.$ic(g.fsPath)},getWorkspaceFolderPathForFile:()=>{if(r){const g=a();if(g){const v=r.getWorkspaceFolder(g);if(v)return C.$ic(v.uri.fsPath)}}},getSelectedText:()=>{if(i){const g=i.activeEditor();if(g&&!g.selection.isEmpty)return g.document.getText(g.selection)}},getLineNumber:()=>{if(i){const g=i.activeEditor();if(g)return String(g.selection.end.line+1)}},getExtension:g=>s.getExtension(g)},void 0,p?Promise.resolve(p):void 0,Promise.resolve(N.env))}}let n=class extends M.$Uc{constructor(s,r,i,c,h){super(),this.b=s,this.c=r,this.g=i,this.h=c,this.j=h,this.a=new k.$V(async()=>{const t=await this.h.getConfigProvider(),a={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async g=>{a.folders=await this.c.getWorkspaceFolders2()||[]})),new $(this.b,this.c,this.g,this.j,t,a,this.m())})}getResolver(){return this.a.value}m(){}};e.$Ekc=n,e.$Ekc=n=Xe([qe(0,y.$Akc),qe(1,D.$Yjc),qe(2,m.$ZO),qe(3,b.$2jc),qe(4,d.$bkc)],n)}),define(Pe[121],Re([1,0,11,5,2,20,3,4,66,38,16,7,36,214,216,37,120,6,41,31,8]),function(ee,e,k,M,C,N,A,m,d,y,O,D,l,b,$,n,o,s,r,i,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jkc=e.$Ikc=e.$Hkc=e.$Gkc=e.$Fkc=void 0,e.$Fkc=(0,A.$ii)("IExtHostDebugService");let h=class{get onDidStartDebugSession(){return this.n.event}get onDidTerminateDebugSession(){return this.o.event}get onDidChangeActiveDebugSession(){return this.q.event}get activeDebugSession(){return this.u?.api}get onDidReceiveDebugSessionCustomEvent(){return this.w.event}get activeDebugConsole(){return this.y.value}constructor(u,E,w,I,S,P,U){this.N=E,this.O=w,this.P=I,this.Q=S,this.R=P,this.S=U,this.m=new Map,this.F=0,this.G=new Map,this.H=new Map,this.I=new WeakMap,this.J=new Map,this.L=new Map,this.M=0,this.d=0,this.f=[],this.g=0,this.h=[],this.j=0,this.k=[],this.D=new Map,this.E=new Map,this.n=new M.$7d,this.o=new M.$7d,this.q=new M.$7d,this.w=new M.$7d,this.l=u.getProxy(m.$sM.MainThreadDebugService),this.A=new M.$7d,this.C=new M.$7d,this.y=new p(this.l),this.z=new Map,this.O.getExtensionRegistry().then(Q=>{Q.onDidChange(H=>{this.V(Q)}),this.V(Q)})}async $getVisualizerTreeItem(u,E){const w=this.W(E);if(!w)return;const I=await this.H.get(u)?.getTreeItem?.(w);return I?this.U(u,I):void 0}registerDebugVisualizationTree(u,E,w){const I=N.$Em.toKey(u.identifier),S=this.jb(I,E);if(this.G.has(S))throw new Error(`A debug visualization provider with id '${E}' is already registered`);return this.H.set(S,w),this.l.$registerDebugVisualizerTree(S,!!w.editItem),(0,s.$Sc)(()=>{this.l.$unregisterDebugVisualizerTree(S),this.H.delete(E)})}async $getVisualizerTreeItemChildren(u,E){const w=this.J.get(E)?.item;return w?(await this.H.get(u)?.getChildren?.(w))?.map(S=>this.U(u,S))||[]:[]}async $editVisualizerTreeItem(u,E){const w=this.J.get(u);if(!w)return;const I=await this.H.get(w.provider)?.editItem?.(w.item,E);return this.U(w.provider,I||w.item)}$disposeVisualizedTree(u){const E=this.J.get(u);if(!E)return;const w=[E.children];for(const I of w)if(I)for(const S of I)w.push(this.J.get(S)?.children),this.J.delete(S)}U(u,E){let w=this.I.get(E);return w||(w=this.F++,this.I.set(E,w),this.J.set(w,{provider:u,item:E})),c.DebugTreeItem.from(E,w)}asDebugSourceUri(u,E){const w=u;if(typeof w.sourceReference=="number"&&w.sourceReference>0){let I=`debug:${encodeURIComponent(w.path||"")}`,S="?";return E&&(I+=`${S}session=${encodeURIComponent(E.id)}`,S="&"),I+=`${S}ref=${w.sourceReference}`,C.URI.parse(I)}else{if(w.path)return C.URI.file(w.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}V(u){const E=[];for(const w of u.getAllExtensionDescriptions())if(w.contributes){const I=w.contributes.debuggers;if(I&&I.length>0)for(const S of I)(0,$.$PG)(S)&&E.push(S.type)}this.l.$registerDebugTypes(E)}get activeStackItem(){return this.B}get onDidChangeActiveStackItem(){return this.C.event}get onDidChangeBreakpoints(){return this.A.event}get breakpoints(){const u=[];return this.z.forEach(E=>u.push(E)),u}async $resolveDebugVisualizer(u,E){const w=this.L.get(u);if(!w)throw new Error(`No debug visualizer found with id '${u}'`);let{v:I,provider:S,extensionId:P}=w;if(I.visualization||(I=await S.resolveDebugVisualization?.(I,E)||I,w.v=I),!I.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${S}'`);return this.kb(P,I.visualization)}async $executeDebugVisualizerCommand(u){const E=this.L.get(u);if(!E)throw new Error(`No debug visualizer found with id '${u}'`);const w=E.v.visualization;w&&"command"in w&&this.S.executeCommand(w.command,...w.arguments||[])}W(u){const E=this.m.get(u.sessionId);return E&&{session:E.api,variable:u.variable,containerId:u.containerId,frameId:u.frameId,threadId:u.threadId}}async $provideDebugVisualizers(u,E,w,I){const S=this.W(w),P=this.jb(u,E),U=this.G.get(P);if(!S||!U)return[];const Q=await U.provideDebugVisualization(S,I);return Q?Q.map(H=>{const L=++this.M;this.L.set(L,{v:H,provider:U,extensionId:u});const R=H.iconPath?this.lb(H.iconPath):void 0;return{id:L,name:H.name,iconClass:R?.iconClass,iconPath:R?.iconPath,visualization:this.kb(u,H.visualization)}}):[]}$disposeDebugVisualizers(u){for(const E of u)this.L.delete(E)}registerDebugVisualizationProvider(u,E,w){if(!u.contributes?.debugVisualizers?.some(P=>P.id===E))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${E})`);const I=N.$Em.toKey(u.identifier),S=this.jb(I,E);if(this.G.has(S))throw new Error(`A debug visualization provider with id '${E}' is already registered`);return this.G.set(S,w),this.l.$registerDebugVisualizer(I,E),(0,s.$Sc)(()=>{this.l.$unregisterDebugVisualizer(I,E),this.G.delete(E)})}addBreakpoints(u){const E=u.filter(S=>{const P=S.id;return this.z.has(P)?!1:(this.z.set(P,S),!0)});this.gb(E,[],[]);const w=[],I=new Map;for(const S of E)if(S instanceof D.$vN){let P=I.get(S.location.uri.toString());P||(P={type:"sourceMulti",uri:S.location.uri,lines:[]},I.set(S.location.uri.toString(),P),w.push(P)),P.lines.push({id:S.id,enabled:S.enabled,condition:S.condition,hitCondition:S.hitCondition,logMessage:S.logMessage,line:S.location.range.start.line,character:S.location.range.start.character,mode:S.mode})}else S instanceof D.$wN&&w.push({type:"function",id:S.id,enabled:S.enabled,hitCondition:S.hitCondition,logMessage:S.logMessage,condition:S.condition,functionName:S.functionName,mode:S.mode});return this.l.$registerBreakpoints(w)}removeBreakpoints(u){const E=u.filter(P=>this.z.delete(P.id));this.gb([],E,[]);const w=E.filter(P=>P instanceof D.$vN).map(P=>P.id),I=E.filter(P=>P instanceof D.$wN).map(P=>P.id),S=E.filter(P=>P instanceof D.$xN).map(P=>P.id);return this.l.$unregisterBreakpoints(w,I,S)}startDebugging(u,E,w){return this.l.$startDebugging(u?u.uri:void 0,E,{parentSessionID:w.parentSession?w.parentSession.id:void 0,lifecycleManagedByParent:w.lifecycleManagedByParent,repl:w.consoleMode===D.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:w.noDebug,compact:w.compact,suppressSaveBeforeStart:w.suppressSaveBeforeStart,suppressDebugStatusbar:w.suppressDebugStatusbar??w.debugUI?.simple,suppressDebugToolbar:w.suppressDebugToolbar??w.debugUI?.simple,suppressDebugView:w.suppressDebugView??w.debugUI?.simple})}stopDebugging(u){return this.l.$stopDebugging(u?u.id:void 0)}registerDebugConfigurationProvider(u,E,w){if(!E)return new D.$uM(()=>{});const I=this.d++;return this.f.push({type:u,handle:I,provider:E}),this.l.$registerDebugConfigurationProvider(u,w,!!E.provideDebugConfigurations,!!E.resolveDebugConfiguration,!!E.resolveDebugConfigurationWithSubstitutedVariables,I),new D.$uM(()=>{this.f=this.f.filter(S=>S.provider!==E),this.l.$unregisterDebugConfigurationProvider(I)})}registerDebugAdapterDescriptorFactory(u,E,w){if(!w)return new D.$uM(()=>{});if(!this.cb(u,E))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${E}' debugger.`);if(this.$(E))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const I=this.g++;return this.h.push({type:E,handle:I,factory:w}),this.l.$registerDebugAdapterDescriptorFactory(E,I),new D.$uM(()=>{this.h=this.h.filter(S=>S.factory!==w),this.l.$unregisterDebugAdapterDescriptorFactory(I)})}registerDebugAdapterTrackerFactory(u,E){if(!E)return new D.$uM(()=>{});const w=this.j++;return this.k.push({type:u,handle:w,factory:E}),new D.$uM(()=>{this.k=this.k.filter(I=>I.factory!==E)})}async $runInTerminal(u,E){return Promise.resolve(void 0)}async $substituteVariables(u,E){let w;const I=await this.ib(u);return I&&(w={uri:I.uri,name:I.name,index:I.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.R.getResolver()).resolveAnyAsync(w,E)}X(u,E){if(u.type==="implementation")return new g(u.implementation)}Y(){}async $startDASession(u,E){const w=this,I=await this.hb(E);return this.eb(this.$(I.type),I).then(S=>{if(!S)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${I.type}' (extension might have failed to activate)`);const P=this.Z(S),U=this.X(P,I);if(!U)throw new Error(`Couldn't create a debug adapter for type '${I.type}'.`);const Q=U;return this.D.set(u,Q),this.db(I).then(H=>(H&&this.E.set(u,H),Q.onMessage(async L=>{if(L.type==="request"&&L.command==="handshake"){const R=L,F={type:"response",seq:0,command:R.command,request_seq:R.seq,success:!0};this.K||(this.K=this.Y());try{if(this.K){const T=await this.K.sign(R.arguments.value);F.body={signature:T},Q.sendResponse(F)}else throw new Error("no signer")}catch(T){F.success=!1,F.message=T.message,Q.sendResponse(F)}}else H&&H.onDidSendMessage&&H.onDidSendMessage(L),L=(0,$.$UG)(L,!0),w.l.$acceptDAMessage(u,L)}),Q.onError(L=>{H&&H.onError&&H.onError(L),this.l.$acceptDAError(u,L.name,L.message,L.stack)}),Q.onExit(L=>{H&&H.onExit&&H.onExit(L??void 0,void 0),this.l.$acceptDAExit(u,L??void 0,void 0)}),H&&H.onWillStartSession&&H.onWillStartSession(),Q.startSession()))})}$sendDAMessage(u,E){E=(0,$.$TG)(E,!1);const w=this.E.get(u);w&&w.onWillReceiveMessage&&w.onWillReceiveMessage(E),this.D.get(u)?.sendMessage(E)}$stopDASession(u){const E=this.E.get(u);this.E.delete(u),E&&E.onWillStopSession&&E.onWillStopSession();const w=this.D.get(u);return this.D.delete(u),w?w.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(u){const E=[],w=[],I=[];if(u.added)for(const S of u.added){const P=S.id;if(P&&!this.z.has(P)){let U;if(S.type==="function")U=new D.$wN(S.functionName,S.enabled,S.condition,S.hitCondition,S.logMessage,S.mode);else if(S.type==="data")U=new D.$xN(S.label,S.dataId,S.canPersist,S.enabled,S.hitCondition,S.condition,S.logMessage,S.mode);else{const Q=C.URI.revive(S.uri);U=new D.$vN(new D.$GM(Q,new D.$vM(S.line,S.character)),S.enabled,S.condition,S.hitCondition,S.logMessage,S.mode)}(0,D.$tN)(U,P),this.z.set(P,U),E.push(U)}}if(u.removed)for(const S of u.removed){const P=this.z.get(S);P&&(this.z.delete(S),w.push(P))}if(u.changed){for(const S of u.changed)if(S.id){const P=this.z.get(S.id);if(P){if(P instanceof D.$wN&&S.type==="function"){const U=P;U.enabled=S.enabled,U.condition=S.condition,U.hitCondition=S.hitCondition,U.logMessage=S.logMessage,U.functionName=S.functionName}else if(P instanceof D.$vN&&S.type==="source"){const U=P;U.enabled=S.enabled,U.condition=S.condition,U.hitCondition=S.hitCondition,U.logMessage=S.logMessage,U.location=new D.$GM(C.URI.revive(S.uri),new D.$vM(S.line,S.character))}I.push(P)}}}this.gb(E,w,I)}async $acceptStackFrameFocus(u){let E;if(u){const w=await this.hb(u.sessionId);u.kind==="thread"?E=new D.$DN(w.api,u.threadId):E=new D.$CN(w.api,u.threadId,u.frameId)}this.B=E,this.C.fire(this.B)}$provideDebugConfigurations(u,E,w){return(0,k.$ah)(async()=>{const I=this.bb(u);if(!I)throw new Error("no DebugConfigurationProvider found");if(!I.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const S=await this.ib(E);return I.provideDebugConfigurations(S,w)}).then(I=>{if(!I)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return I})}$resolveDebugConfiguration(u,E,w,I){return(0,k.$ah)(async()=>{const S=this.bb(u);if(!S)throw new Error("no DebugConfigurationProvider found");if(!S.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const P=await this.ib(E);return S.resolveDebugConfiguration(P,w,I)})}$resolveDebugConfigurationWithSubstitutedVariables(u,E,w,I){return(0,k.$ah)(async()=>{const S=this.bb(u);if(!S)throw new Error("no DebugConfigurationProvider found");if(!S.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const P=await this.ib(E);return S.resolveDebugConfigurationWithSubstitutedVariables(P,w,I)})}async $provideDebugAdapter(u,E){const w=this.ab(u);if(!w)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const I=await this.hb(E);return this.eb(w,I).then(S=>{if(!S)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${I.type}'`);return this.Z(S)})}async $acceptDebugSessionStarted(u){const E=await this.hb(u);this.n.fire(E.api)}async $acceptDebugSessionTerminated(u){const E=await this.hb(u);E&&(this.o.fire(E.api),this.m.delete(E.id))}async $acceptDebugSessionActiveChanged(u){this.u=u?await this.hb(u):void 0,this.q.fire(this.u?.api)}async $acceptDebugSessionNameChanged(u,E){(await this.hb(u))?._acceptNameChanged(E)}async $acceptDebugSessionCustomEvent(u,E){const I={session:(await this.hb(u)).api,event:E.event,body:E.body};this.w.fire(I)}Z(u){if(u instanceof D.$yN)return{type:"executable",command:u.command,args:u.args,options:u.options};if(u instanceof D.$zN)return{type:"server",port:u.port,host:u.host};if(u instanceof D.$AN)return{type:"pipeServer",path:u.path};if(u instanceof D.$BN)return{type:"implementation",implementation:u.implementation};throw new Error("convertToDto unexpected type")}$(u){const E=this.h.filter(w=>w.type===u);if(E.length>0)return E[0].factory}ab(u){const E=this.h.filter(w=>w.handle===u);if(E.length>0)return E[0].factory}bb(u){const E=this.f.filter(w=>w.handle===u);if(E.length>0)return E[0].provider}cb(u,E){if(u.contributes){const w=u.contributes.debuggers;if(w&&w.length>0){for(const I of w)if(I.label&&I.type&&I.type===E)return!0}}return!1}db(u){const w=u.configuration.type,I=this.k.filter(S=>S.type===w||S.type==="*").map(S=>(0,k.$ah)(()=>S.factory.createDebugAdapterTracker(u.api)).then(P=>P,P=>null));return Promise.race([Promise.all(I).then(S=>{const P=S.filter(U=>!!U);if(P.length>0)return new a(P)}),new Promise(S=>setTimeout(()=>S(void 0),1e3))]).catch(S=>{})}async eb(u,E){const w=E.configuration.debugServer;if(typeof w=="number")return Promise.resolve(new D.$zN(w));if(u){const S=await this.O.getExtensionRegistry();return(0,k.$ah)(()=>u.createDebugAdapterDescriptor(E.api,this.fb(E,S))).then(P=>{if(P)return P})}const I=await this.O.getExtensionRegistry();return Promise.resolve(this.fb(E,I))}fb(u,E){}gb(u,E,w){(u.length>0||E.length>0||w.length>0)&&this.A.fire(Object.freeze({added:u,removed:E,changed:w}))}async hb(u){if(u)if(typeof u=="string"){const E=this.m.get(u);if(E)return E}else{let E=this.m.get(u.id);if(!E){const w=await this.ib(u.folderUri),I=u.parent?this.m.get(u.parent):void 0;E=new t(this.l,u.id,u.type,u.name,w,u.configuration,I?.api),this.m.set(E.id,E),this.l.$sessionCached(E.id)}return E}throw new Error("cannot find session")}ib(u){if(u){const E=C.URI.revive(u);return this.N.resolveWorkspaceFolder(E)}return Promise.resolve(void 0)}jb(u,E){return`${u}\0${E}`}kb(u,E){if(E){if("title"in E&&"command"in E)return{type:0};if("treeId"in E)return{type:1,id:`${u}\0${E.treeId}`};throw new Error("Unsupported debug visualization type")}}lb(u){const E=this.mb(u);let w,I;return"id"in E?I=r.ThemeIcon.asClassName(E):w=E,{iconPath:w,iconClass:I}}mb(u){if(u instanceof D.$qN)return{id:u.id};const E=typeof u=="object"&&"dark"in u?u.dark:u,w=typeof u=="object"&&"light"in u?u.light:u;return{dark:typeof E=="string"?C.URI.file(E):E,light:typeof w=="string"?C.URI.file(w):w}}};e.$Gkc=h,e.$Gkc=h=Xe([qe(0,O.$OO),qe(1,l.$Yjc),qe(2,y.$Akc),qe(3,n.$2jc),qe(4,d.$bkc),qe(5,o.$Dkc),qe(6,i.$$O)],h);class t{constructor(u,E,w,I,S,P,U){this.f=u,this.g=E,this.h=w,this.j=I,this.k=S,this.l=P,this.m=U}get api(){const u=this;return this.d??(this.d=Object.freeze({id:u.g,type:u.h,get name(){return u.j},set name(E){u.j=E,u.f.$setDebugSessionName(u.g,E)},parentSession:u.m,workspaceFolder:u.k,configuration:u.l,customRequest(E,w){return u.f.$customDebugAdapterRequest(u.g,E,w)},getDebugProtocolBreakpoint(E){return u.f.$getDebugProtocolBreakpoint(u.g,E.id)}}))}get id(){return this.g}get type(){return this.h}_acceptNameChanged(u){this.j=u}get configuration(){return this.l}}e.$Hkc=t;class p{constructor(u){this.value=Object.freeze({append(E){u.$appendDebugConsole(E)},appendLine(E){this.append(E+`
`)}})}}e.$Ikc=p;class a{constructor(u){this.d=u}onWillStartSession(){this.d.forEach(u=>u.onWillStartSession?u.onWillStartSession():void 0)}onWillReceiveMessage(u){this.d.forEach(E=>E.onWillReceiveMessage?E.onWillReceiveMessage(u):void 0)}onDidSendMessage(u){this.d.forEach(E=>E.onDidSendMessage?E.onDidSendMessage(u):void 0)}onWillStopSession(){this.d.forEach(u=>u.onWillStopSession?u.onWillStopSession():void 0)}onError(u){this.d.forEach(E=>E.onError?E.onError(u):void 0)}onExit(u,E){this.d.forEach(w=>w.onExit?w.onExit(u,E):void 0)}}class g extends b.$job{constructor(u){super(),this.h=u,u.onDidSendMessage(E=>{this.acceptMessage(E)})}startSession(){return Promise.resolve(void 0)}sendMessage(u){this.h.handleMessage(u)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let v=class extends h{constructor(u,E,w,I,S,P,U){super(u,E,w,I,S,P,U)}};e.$Jkc=v,e.$Jkc=v=Xe([qe(0,O.$OO),qe(1,l.$Yjc),qe(2,y.$Akc),qe(3,n.$2jc),qe(4,d.$bkc),qe(5,o.$Dkc),qe(6,i.$$O)],v)}),define(Pe[295],Re([1,0,14,89,2,4,243,13,55,71,27,191,16,60,38,62]),function(ee,e,k,M,C,N,A,m,d,y,O,D,l,b,$,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Olc=e.$Nlc=void 0;class o{static async installEarlyHandler(i){Error.stackTraceLimit=100;const c=i.get(m.$Oj),t=i.get(l.$OO).getProxy(N.$sM.MainThreadErrors);k.setUnexpectedErrorHandler(p=>{c.error(p);const a=k.$3(p);t.$onUnexpectedError(a)})}static async installFullHandler(i){const c=i.get(m.$Oj),h=i.get(l.$OO),t=i.get($.$Akc),p=i.get(n.$9O),a=h.getProxy(N.$sM.MainThreadExtensionService),g=h.getProxy(N.$sM.MainThreadErrors),v=await t.getExtensionPathIndex(),f=new WeakMap;function u(I,S){if(f.has(I))return f.get(I).stack;let P="",U,Q;for(const L of S)P+=`
	at ${L.toString()}`,Q=L.getFileName(),!U&&Q&&(U=v.findSubstr(C.URI.file(Q)));const H=`${I.name||"Error"}: ${I.message||""}${P}`;return f.set(I,{extensionIdentifier:U?.identifier,stack:H}),H}const E=Symbol("prepareStackTrace wrapped");let w=u;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return w},set(I){if(I===u||!I||I[E]){w=I||u;return}w=function(S,P){return u(S,P),I.call(Error,S,P)},Object.assign(w,{[E]:!0})}}),k.setUnexpectedErrorHandler(I=>{c.error(I);const S=k.$3(I),P=f.get(I);if(!P?.extensionIdentifier){g.$onUnexpectedError(S);return}a.$onExtensionRuntimeError(P.extensionIdentifier,S);const U=p.onExtensionError(P.extensionIdentifier,I);c.trace("forwarded error to extension?",U,P)})}}e.$Nlc=o;class s{constructor(i,c,h,t,p){this.a=h,this.b=new A.$y$b(i,null,t),c=s.e(c,this.b);const a=new y.$gi(...(0,d.$is)());a.set(O.$5O,{_serviceBrand:void 0,...c,messagePorts:p}),a.set(l.$OO,new l.$PO(this.b)),a.set(b.$Vjc,new b.$Wjc(t)),a.set($.$ykc,h);const g=new D.$Zq(a,!0);g.invokeFunction(o.installEarlyHandler),this.d=g.invokeFunction(v=>v.get(m.$Oj)),M.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",c),this.c=g.invokeFunction(v=>v.get($.$Akc)),this.c.initialize(),g.invokeFunction(o.installFullHandler)}async asBrowserUri(i){const c=this.b.getProxy(N.$sM.MainThreadExtensionService);return C.URI.revive(await c.$asBrowserUri(i))}terminate(i){this.c.terminate(i)}static e(i,c){i.extensions.allExtensions.forEach(t=>{t.extensionLocation=C.URI.revive(c.transformIncomingURIs(t.extensionLocation))}),i.environment.appRoot=C.URI.revive(c.transformIncomingURIs(i.environment.appRoot));const h=i.environment.extensionDevelopmentLocationURI;return h&&(i.environment.extensionDevelopmentLocationURI=h.map(t=>C.URI.revive(c.transformIncomingURIs(t)))),i.environment.extensionTestsLocationURI=C.URI.revive(c.transformIncomingURIs(i.environment.extensionTestsLocationURI)),i.environment.globalStorageHome=C.URI.revive(c.transformIncomingURIs(i.environment.globalStorageHome)),i.environment.workspaceStorageHome=C.URI.revive(c.transformIncomingURIs(i.environment.workspaceStorageHome)),i.environment.extensionTelemetryLogResource=C.URI.revive(c.transformIncomingURIs(i.environment.extensionTelemetryLogResource)),i.nlsBaseUrl=C.URI.revive(c.transformIncomingURIs(i.nlsBaseUrl)),i.logsLocation=C.URI.revive(c.transformIncomingURIs(i.logsLocation)),i.workspace=c.transformIncomingURIs(i.workspace),i}}e.$Olc=s}),define(Pe[296],Re([1,0,18,11,24,42,12,19,23,2,45]),function(ee,e,k,M,C,N,A,m,d,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1kc=e.$Ykc=e.$Xkc=void 0,e.$Zkc=n;class D{constructor(r,i,c){this.d=r,this.e=i,this.f=c,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(r,i){const c=this.g.folderQueries||[],h=new C.$ee(i);return new Promise((t,p)=>{this.a=new b(r);let a=!1;const g=(v,f)=>{if(!a&&!this.b){const u=this.h(v);n(v)&&typeof this.g.maxResults=="number"&&this.c+u>this.g.maxResults&&(this.b=!0,a=!0,h.cancel(),v=this.j(v,this.g.maxResults-this.c));const E=this.h(v);this.c+=E,(E>0||!n(v))&&this.a.add(v,f)}};Promise.all(c.map((v,f)=>this.k(v,u=>g(u,f),h.token))).then(v=>{h.dispose(),this.a.flush();const f=v.some(u=>!!u&&!!u.limitHit);t({limitHit:this.b||f,messages:(0,k.$Rb)(v.map(u=>u?.message?Array.isArray(u.message)?u.message:[u.message]:[])),stats:{type:this.f}})},v=>{h.dispose();const f=(0,N.$6i)(v);p(new Error(f))})})}h(r){return n(r)?Array.isArray(r.ranges)?r.ranges.length:1:0}j(r,i){const c=Array.isArray(r.ranges)?r.ranges:[r.ranges],h=Array.isArray(r.preview.matches)?r.preview.matches:[r.preview.matches];return{ranges:c.slice(0,i),preview:{matches:h.slice(0,i),text:r.preview.text},uri:r.uri}}async k(r,i,c){const h=new O.$ZK(this.g,r),t=[],p={report:v=>{if(!this.l(v))return;const f=r.folder.scheme===A.Schemas.file?(0,O.$1K)(()=>this.e.readdir(d.$Ug(v.uri))):void 0,u=d.$Xg(r.folder,v.uri);if(u){const E=h.includedInQuery(u,m.$oc(u),f);(0,M.$7g)(E)?t.push(E.then(w=>{w&&i(v)})):E&&i(v)}}},a=this.n(r);let g;return this.d.query.type===3?g=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,a,p,c):g=await this.d.provider.provideTextSearchResults(l(this.d.query.contentPattern),a,p,c),t.length&&await Promise.all(t),g}l(r){if(n(r)){if(Array.isArray(r.ranges)){if(!Array.isArray(r.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(r.preview.matches.length!==r.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(r.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(r){const i=(0,O.$YK)(this.g.includePattern,r.includePattern),c=(0,O.$YK)(this.g.excludePattern,r.excludePattern),h={folder:y.URI.from(r.folder),excludes:c,includes:i,useIgnoreFiles:!r.disregardIgnoreFiles,useGlobalIgnoreFiles:!r.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!r.disregardParentIgnoreFiles,followSymlinks:!r.ignoreSymlinks,encoding:r.fileEncoding&&this.e.toCanonicalName(r.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(h.usePCRE2=this.g.usePCRE2),h}}e.$Xkc=D;function l(s){return{isCaseSensitive:s.isCaseSensitive||!1,isRegExp:s.isRegExp||!1,isWordMatch:s.isWordMatch||!1,isMultiline:s.isMultiline||!1,pattern:s.pattern}}class b{constructor(r){this.e=r,this.b=-1,this.d=null,this.a=new o(512,i=>this.g(i))}add(r,i){this.d&&(this.b!==i||!d.$Og(this.c,r.uri))&&(this.f(),this.d=null),this.d||(this.b=i,this.d={resource:r.uri,results:[]}),this.d.results.push($(r))}f(){const r=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,r)}flush(){this.f(),this.a.flush()}g(r){this.e(r)}}e.$Ykc=b;function $(s){return n(s)?{preview:{matches:(0,k.$2b)(s.preview.matches,r=>({startLineNumber:r.start.line,startColumn:r.start.character,endLineNumber:r.end.line,endColumn:r.end.character})),text:s.preview.text},ranges:(0,k.$2b)(s.ranges,r=>({startLineNumber:r.start.line,startColumn:r.start.character,endLineNumber:r.end.line,endColumn:r.end.character}))}:{text:s.text,lineNumber:s.lineNumber}}function n(s){return!!s.preview}class o{constructor(r,i){this.g=r,this.h=i,this.c=0,this.d=[],this.e=0}addItem(r,i){r&&this.j(r,i)}addItems(r,i){r&&this.k(r,i)}j(r,i){this.d.push(r),this.e+=i,this.l()}k(r,i){this.d=this.d.concat(r),this.e+=i,this.l()}l(){this.c<o.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},o.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$1kc=o,o.a=4e3,o.b=50}),define(Pe[122],Re([1,0,6,4,3,291,16,60,13,2,296]),function(ee,e,k,M,C,N,A,m,d,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3kc=e.$2kc=void 0,e.$4kc=l,e.$2kc=(0,C.$ii)("IExtHostSearch");let D=class{constructor(n,o,s){this.n=n,this.o=o,this.q=s,this.c=this.n.getProxy(M.$sM.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new N.$Wkc}s(n){return this.o.transformOutgoingScheme(n)}registerTextSearchProvider(n,o){if(this.g.has(n))throw new Error(`a text search provider for the scheme '${n}' is already registered`);this.g.add(n);const s=this.d++;return this.e.set(s,o),this.c.$registerTextSearchProvider(s,this.s(n)),(0,k.$Sc)(()=>{this.g.delete(n),this.e.delete(s),this.c.$unregisterProvider(s)})}registerAITextSearchProvider(n,o){if(this.i.has(n))throw new Error(`an AI text search provider for the scheme '${n}'is already registered`);this.i.add(n);const s=this.d++;return this.h.set(s,o),this.c.$registerAITextSearchProvider(s,this.s(n)),(0,k.$Sc)(()=>{this.i.delete(n),this.h.delete(s),this.c.$unregisterProvider(s)})}registerFileSearchProvider(n,o){if(this.k.has(n))throw new Error(`a file search provider for the scheme '${n}' is already registered`);this.k.add(n);const s=this.d++;return this.j.set(s,o),this.c.$registerFileSearchProvider(s,this.s(n)),(0,k.$Sc)(()=>{this.k.delete(n),this.j.delete(s),this.c.$unregisterProvider(s)})}$provideFileSearchResults(n,o,s,r){const i=l(s),c=this.j.get(n);if(c)return this.l.fileSearch(i,c,h=>{this.c.$handleFileMatch(n,o,h.map(t=>t.resource))},r);throw new Error("3 unknown provider: "+n)}async doInternalFileSearchWithCustomCallback(n,o,s){return{messages:[]}}$clearCache(n){return this.l.clearCache(n),Promise.resolve(void 0)}$provideTextSearchResults(n,o,s,r){const i=this.e.get(n);if(!i||!i.provideTextSearchResults)throw new Error(`2 Unknown provider ${n}`);const c=l(s);return this.t(c,i).search(t=>this.c.$handleTextMatch(n,o,t),r)}$provideAITextSearchResults(n,o,s,r){const i=this.h.get(n);if(!i||!i.provideAITextSearchResults)throw new Error(`1 Unknown provider ${n}`);const c=l(s);return this.v(c,i).search(t=>this.c.$handleTextMatch(n,o,t),r)}$enableExtensionHostSearch(){}t(n,o){return new O.$Xkc({query:n,provider:o},{readdir:s=>Promise.resolve([]),toCanonicalName:s=>s},"textSearchProvider")}v(n,o){return new O.$Xkc({query:n,provider:o},{readdir:s=>Promise.resolve([]),toCanonicalName:s=>s},"aiTextSearchProvider")}};e.$3kc=D,e.$3kc=D=Xe([qe(0,A.$OO),qe(1,m.$Vjc),qe(2,d.$Oj)],D);function l($){return{...$,folderQueries:$.folderQueries&&$.folderQueries.map(b),extraFileResources:$.extraFileResources&&$.extraFileResources.map(n=>y.URI.revive(n))}}function b($){return{...$,folder:y.URI.revive($.folder)}}}),define(Pe[297],Re([1,0,24,14,5,6,12,32,2,151,139,140,95,20,43,13,58,59,204,4,246,275,78,84,252,231,253,88,254,232,220,31,255,37,256,121,110,257,234,247,258,259,67,66,248,38,261,64,262,44,27,276,277,249,235,263,264,79,80,237,290,266,208,267,278,268,116,238,269,270,271,16,272,122,81,273,239,274,82,85,119,62,51,279,280,250,281,282,86,8,7,240,60,241,63,283,284,109,36,215,77,25,118,114]),function(ee,e,k,M,C,N,A,m,d,y,O,D,l,b,$,n,o,s,r,i,c,h,t,p,a,g,v,f,u,E,w,I,S,P,U,Q,H,L,R,F,T,X,re,me,pe,ae,be,se,De,Oe,ie,q,de,Ne,$e,we,ge,ce,K,Z,le,fe,Te,ve,Ie,Ae,je,j,B,G,W,_,oe,Fe,Be,Qe,et,it,ut,st,rt,ot,$t,Ue,ct,x,Y,ye,He,Ye,Me,dt,Mt,Bt,Qt,Yt,xt,It,ri,_t,hi,xe,si,Ht){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ilc=Gt;function Gt(ft){const vt=ft.get(ie.$5O),Xt=ft.get(Oe.$Djc),zt=ft.get(se.$4jc),Vt=ft.get(ae.$Akc),mt=ft.get(ri.$Yjc),Rt=ft.get(ot.$9O),ai=ft.get(P.$2jc),ei=ft.get(Mt.$Vjc),Ge=ft.get(_.$OO),Zt=ft.get(ut.$kkc),ti=ft.get(st.$5jc),ii=ft.get(n.$Pj),bt=ft.get(n.$Oj),jt=ft.get(He.$kCb),Nt=ft.get(t.$zjc),At=ft.get(It.$Flc),ci=ft.get(Be.$skc),Ut=ft.get(me.$bkc),qt=ft.get(K.$wkc),Ct=ft.get(p.$Jjc),Lt=ft.get(f.$Ojc);Ge.set(i.$tM.ExtHostFileSystemInfo,Xt),Ge.set(i.$tM.ExtHostLogLevelServiceShape,ii),Ge.set(i.$tM.ExtHostWorkspace,mt),Ge.set(i.$tM.ExtHostConfiguration,ai),Ge.set(i.$tM.ExtHostExtensionService,Vt),Ge.set(i.$tM.ExtHostStorage,Zt),Ge.set(i.$tM.ExtHostTunnelService,jt),Ge.set(i.$tM.ExtHostWindow,At),Ge.set(i.$tM.ExtHostSecretState,ci),Ge.set(i.$tM.ExtHostTelemetry,Rt),Ge.set(i.$tM.ExtHostEditorTabs,Ut),Ge.set(i.$tM.ExtHostManagedSockets,qt),Ge.set(i.$tM.ExtHostAuthentication,Ct),Ge.set(i.$tM.ExtHostChatProvider,Lt);const ni=Ge.set(i.$tM.ExtHostDecorations,ft.get(H.$Lkc)),Pt=Ge.set(i.$tM.ExtHostDocumentsAndEditors,ft.get(re.$ZO)),kt=Ge.set(i.$tM.ExtHostCommands,ft.get(I.$$O)),Tt=Ge.set(i.$tM.ExtHostTerminalService,ft.get($t.$nkc)),di=Ge.set(i.$tM.ExtHostTerminalShellIntegration,ft.get(Ht.$Glc)),Et=Ge.set(i.$tM.ExtHostDebugService,ft.get(Q.$Fkc)),ui=Ge.set(i.$tM.ExtHostSearch,ft.get(Fe.$2kc)),Kt=Ge.set(i.$tM.ExtHostTask,ft.get(rt.$slc)),ki=Ge.set(i.$tM.ExtHostOutputService,ft.get(je.$flc)),vi=Ge.set(i.$tM.ExtHostLocalization,ft.get(ce.$vkc)),Ee=Ge.set(i.$tM.ExtHostUrls,new Bt.$Clc(Ge)),Ce=Ge.set(i.$tM.ExtHostDocuments,new X.$Gjc(Ge,Pt)),he=Ge.set(i.$tM.ExtHostDocumentContentProviders,new F.$Nkc(Ge,Pt,bt)),J=Ge.set(i.$tM.ExtHostDocumentSaveParticipant,new T.$Okc(bt,Ce,Ge.getProxy(i.$sM.MainThreadBulkEdits))),ke=Ge.set(i.$tM.ExtHostNotebook,new le.$5kc(Ge,kt,Pt,Ce,zt,ui)),We=Ge.set(i.$tM.ExtHostNotebookDocuments,new Te.$_kc(ke)),Ze=Ge.set(i.$tM.ExtHostNotebookEditors,new ve.$alc(bt,ke)),Ke=Ge.set(i.$tM.ExtHostNotebookKernels,new Ie.$blc(Ge,vt,ke,kt,bt)),lt=Ge.set(i.$tM.ExtHostNotebookRenderers,new Ae.$dlc(Ge,ke)),Dt=Ge.set(i.$tM.ExtHostNotebookDocumentSaveParticipant,new fe.$$kc(bt,ke,Ge.getProxy(i.$sM.MainThreadBulkEdits))),St=Ge.set(i.$tM.ExtHostEditors,new ct.$Sjc(Ge,Pt)),oi=Ge.set(i.$tM.ExtHostTreeViews,new ye.$Alc(Ge.getProxy(i.$sM.MainThreadTreeViews),kt,bt)),Ot=Ge.set(i.$tM.ExtHostEditorInsets,new w.$Tjc(Ge.getProxy(i.$sM.MainThreadEditorInsets),St,vt.remote)),Wt=Ge.set(i.$tM.ExtHostDiagnostics,new L.$Fjc(Ge,bt,Xt,Pt)),Ei=Ge.set(i.$tM.ExtHostLanguages,new ge.$9kc(Ge,Ce,kt.converter,ei)),gt=Ge.set(i.$tM.ExtHostLanguageFeatures,new we.$Hjc(Ge,ei,Ce,kt,Wt,bt,Nt,Rt)),Ni=Ge.set(i.$tM.ExtHostFileSystem,new be.$Qkc(Ge,gt)),fi=Ge.set(i.$tM.ExtHostFileSystemEventService,new De.$Rkc(Ge,bt,Pt)),wi=Ge.set(i.$tM.ExtHostQuickOpen,(0,W.$jlc)(Ge,mt,kt)),Mi=Ge.set(i.$tM.ExtHostSCM,new oe.$llc(Ge,kt,Ce,bt)),mn=Ge.set(i.$tM.ExtHostQuickDiff,new G.$ilc(Ge,ei)),$n=Ge.set(i.$tM.ExtHostShare,new Qe.$mlc(Ge,ei)),Li=Ge.set(i.$tM.ExtHostComments,(0,S.$Ujc)(Ge,kt,Ce)),zi=Ge.set(i.$tM.ExtHostProgress,new B.$hlc(Ge.getProxy(i.$sM.MainThreadProgress))),ji=Ge.set(i.$tM.ExtHostLabelService,new $e.$8kc(Ge)),Ri=Ge.set(i.$tM.ExtHostTheming,new x.$xlc(Ge)),Ui=Ge.set(i.$tM.ExtHostTimeline,new Y.$zlc(Ge,kt)),Di=Ge.set(i.$tM.ExtHostWebviews,new Qt.$9jc(Ge,vt.remote,mt,bt,Nt)),Ai=Ge.set(i.$tM.ExtHostWebviewPanels,new Yt.$_jc(Ge,Di,mt)),pn=Ge.set(i.$tM.ExtHostCustomEditors,new U.$akc(Ge,Ce,ti,Di,Ai)),Yi=Ge.set(i.$tM.ExtHostWebviewViews,new xt.$Dlc(Ge,Di)),bi=Ge.set(i.$tM.ExtHostTesting,new Ue.$tlc(Ge,bt,kt,Pt)),Bi=Ge.set(i.$tM.ExtHostUriOpeners,new dt.$Blc(Ge)),xi=Ge.set(i.$tM.ExtHostProfileContentHandlers,new j.$glc(Ge));Ge.set(i.$tM.ExtHostInteractive,new de.$6kc(Ge,ke,Pt,kt,bt));const _i=Ge.set(i.$tM.ExtHostInlineChat,new q.$Skc(Ge,kt,Ce,bt)),Vi=Ge.set(i.$tM.ExtHostChatAgents2,new v.$Njc(Ge,bt,kt)),en=Ge.set(i.$tM.ExtHostChatVariables,new u.$Qjc(Ge)),Wi=Ge.set(i.$tM.ExtHostChat,new g.$Mjc(Ge)),qi=Ge.set(i.$tM.ExtHostAiRelatedInformation,new c.$yjc(Ge)),vn=Ge.set(i.$tM.ExtHostAiEmbeddingVector,new pe.$Pkc(Ge)),tn=Ge.set(i.$tM.ExtHostIssueReporter,new Ne.$7kc(Ge)),Oi=Ge.set(i.$tM.ExtHostStatusBar,new it.$plc(Ge,kt.converter)),Hi=Ge.set(i.$tM.ExtHostSpeech,new et.$nlc(Ge)),wn=Object.values(i.$tM);Ge.assertRegistered(wn);const bn=new a.$Ljc(Ge,Pt),nn=new E.$Rjc(Ge),Gi=new Z.$0kc(Ge,bt),Si=new R.$Mkc(Ge);return h.$Ijc.register(kt),function(ze,gi,Ki){function nt(te){return(ue,Le,at)=>{const yt=te(Ft=>{try{ue.call(Le,Ft)}catch(Pi){M.$2(new Error(`[ExtensionListenerError] Extension '${ze.identifier.value}' FAILED to handle event: ${Pi.toString()}`,{cause:Pi})),Rt.onExtensionError(ze.identifier,Pi)}});return at?.push(yt),yt}}const wt=function(){let te=!ze.isUnderDevelopment;function ue(){te||(bt.info(`Extension '${ze.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),te=!0)}return function Le(at){if(Array.isArray(at))at.forEach(Le);else if(typeof at=="string")ue();else{const yt=at;typeof yt.scheme>"u"&&ue(),typeof yt.exclusive=="boolean"&&(0,xe.$dG)(ze,"documentFiltersExclusive")}return at}}(),rn={getSession(te,ue,Le){return typeof Le?.forceNewSession=="object"&&Le.forceNewSession.learnMore&&(0,xe.$dG)(ze,"authLearnMore"),Ct.getSession(ze,te,ue,Le)},getSessions(te,ue){return(0,xe.$dG)(ze,"authGetSessions"),Ct.getSessions(ze,te,ue)},async hasSession(te,ue){return(0,xe.$dG)(ze,"authSession"),!!await Ct.getSession(ze,te,ue,{silent:!0})},get onDidChangeSessions(){return nt(Ct.onDidChangeSessions)},registerAuthenticationProvider(te,ue,Le,at){return Ct.registerAuthenticationProvider(te,ue,Le,at)}},$i={registerCommand(te,ue,Le){return kt.registerCommand(!0,te,ue,Le,void 0,ze)},registerTextEditorCommand(te,ue,Le){return kt.registerCommand(!0,te,(...at)=>{const yt=St.getActiveTextEditor();if(!yt){bt.warn("Cannot execute "+te+" because there is no active text editor.");return}return yt.edit(Ft=>{ue.apply(Le,[yt,Ft,...at])}).then(Ft=>{Ft||bt.warn("Edits from command "+te+" were not applied.")},Ft=>{bt.warn("An error occurred while running command "+te,Ft)})},void 0,void 0,ze)},registerDiffInformationCommand:(te,ue,Le)=>((0,xe.$dG)(ze,"diffCommand"),kt.registerCommand(!0,te,async(...at)=>{const yt=Pt.activeEditor(!0);if(!yt){bt.warn("Cannot execute "+te+" because there is no active text editor.");return}const Ft=await St.getDiffInformation(yt.id);ue.apply(Le,[Ft,...at])},void 0,void 0,ze)),executeCommand(te,...ue){return kt.executeCommand(te,...ue)},getCommands(te=!1){return kt.getCommands(te)}},Ii={get machineId(){return vt.telemetryInfo.machineId},get sessionId(){return vt.telemetryInfo.sessionId},get language(){return vt.environment.appLanguage},get appName(){return vt.environment.appName},get appRoot(){return vt.environment.appRoot?.fsPath??""},get appHost(){return vt.environment.appHost},get uriScheme(){return vt.environment.appUriScheme},get clipboard(){return nn.value},get shell(){return Tt.getDefaultShell(!1)},get onDidChangeShell(){return nt(Tt.onDidChangeShell)},get isTelemetryEnabled(){return Rt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return nt(Rt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,xe.$dG)(ze,"telemetry"),Rt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,xe.$dG)(ze,"telemetry"),nt(Rt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,ot.$8O)(vt.telemetryInfo.firstSessionDate)},createTelemetryLogger(te,ue){return ot.$7O.validateSender(te),Rt.instantiateLogger(ze,te,ue)},openExternal(te,ue){return At.openUri(te,{allowTunneling:!!vt.remote.authority,allowContributedOpeners:ue?.allowContributedOpeners})},async asExternalUri(te){if(te.scheme===vt.environment.appUriScheme)return Ee.createAppUri(te);try{return await At.asExternalUri(te,{allowTunneling:!!vt.remote.authority})}catch(ue){if((0,A.$rg)(te,A.Schemas.http)||(0,A.$rg)(te,A.Schemas.https))return te;throw ue}},get remoteName(){return(0,o.$vm)(vt.remote.authority)},get remoteAuthority(){return(0,xe.$dG)(ze,"resolvers"),vt.remote.authority},get uiKind(){return vt.uiKind},get logLevel(){return bt.getLevel()},get onDidChangeLogLevel(){return nt(bt.onDidChangeLogLevel)},registerIssueUriRequestHandler(te){return(0,xe.$dG)(ze,"handleIssueUri"),tn.registerIssueUriRequestHandler(ze,te)},registerIssueDataProvider(te){return(0,xe.$dG)(ze,"handleIssueUri"),tn.registerIssueDataProvider(ze,te)},get appQuality(){return(0,xe.$dG)(ze,"resolvers"),vt.quality},get appCommit(){return(0,xe.$dG)(ze,"resolvers"),vt.commit}};vt.environment.extensionTestsLocationURI||Object.freeze(Ii);const yn={createTestController(te,ue,Le){return bi.createTestController(ze,te,ue,Le)},createTestObserver(){return(0,xe.$dG)(ze,"testObserver"),bi.createTestObserver()},runTests(te){return(0,xe.$dG)(ze,"testObserver"),bi.runTests(te)},get onDidChangeTestResults(){return(0,xe.$dG)(ze,"testObserver"),nt(bi.onResultsChanged)},get testResults(){return(0,xe.$dG)(ze,"testObserver"),bi.results}},Ci=vt.remote.isRemote?Me.ExtensionKind.Workspace:Me.ExtensionKind.UI,Ti={getExtension(te,ue){(0,xe.$cG)(ze,"extensionsAny")||(ue=!1);const Le=gi.mine.getExtensionDescription(te);if(Le)return new ae.$Bkc(Vt,ze.identifier,Le,Ci,!1);if(ue){const at=gi.all.getExtensionDescription(te);if(at)return new ae.$Bkc(Vt,ze.identifier,at,Ci,!0)}},get all(){const te=[];for(const ue of gi.mine.getAllExtensionDescriptions())te.push(new ae.$Bkc(Vt,ze.identifier,ue,Ci,!1));return te},get allAcrossExtensionHosts(){(0,xe.$dG)(ze,"extensionsAny");const te=new b.$Fm(gi.mine.getAllExtensionDescriptions().map(Le=>Le.identifier)),ue=[];for(const Le of gi.all.getAllExtensionDescriptions()){const at=!te.has(Le.identifier);ue.push(new ae.$Bkc(Vt,ze.identifier,Le,Ci,at))}return ue},get onDidChange(){return(0,xe.$cG)(ze,"extensionsAny")?nt(C.Event.any(gi.mine.onDidChange,gi.all.onDidChange)):nt(gi.mine.onDidChange)}},sn={createDiagnosticCollection(te){return Wt.createDiagnosticCollection(ze.identifier,te)},get onDidChangeDiagnostics(){return nt(Wt.onDidChangeDiagnostics)},getDiagnostics:te=>Wt.getDiagnostics(te),getLanguages(){return Ei.getLanguages()},setTextDocumentLanguage(te,ue){return Ei.changeLanguage(te.uri,ue)},match(te,ue){const Le=Ye.LanguageSelector.from(te);let at;return(0,O.$Xt)(Le)&&(at=ke.notebookDocuments.find(yt=>yt.apiNotebook.getCells().find(Ft=>Ft.document===ue))?.apiNotebook),(0,O.$Wt)(Le,ue.uri,ue.languageId,!0,at?.uri,at?.notebookType)},registerCodeActionsProvider(te,ue,Le){return gt.registerCodeActionProvider(ze,wt(te),ue,Le)},registerDocumentPasteEditProvider(te,ue,Le){return(0,xe.$dG)(ze,"documentPaste"),gt.registerDocumentPasteEditProvider(ze,wt(te),ue,Le)},registerCodeLensProvider(te,ue){return gt.registerCodeLensProvider(ze,wt(te),ue)},registerDefinitionProvider(te,ue){return gt.registerDefinitionProvider(ze,wt(te),ue)},registerDeclarationProvider(te,ue){return gt.registerDeclarationProvider(ze,wt(te),ue)},registerImplementationProvider(te,ue){return gt.registerImplementationProvider(ze,wt(te),ue)},registerTypeDefinitionProvider(te,ue){return gt.registerTypeDefinitionProvider(ze,wt(te),ue)},registerHoverProvider(te,ue){return gt.registerHoverProvider(ze,wt(te),ue,ze.identifier)},registerEvaluatableExpressionProvider(te,ue){return gt.registerEvaluatableExpressionProvider(ze,wt(te),ue,ze.identifier)},registerInlineValuesProvider(te,ue){return gt.registerInlineValuesProvider(ze,wt(te),ue,ze.identifier)},registerDocumentHighlightProvider(te,ue){return gt.registerDocumentHighlightProvider(ze,wt(te),ue)},registerMultiDocumentHighlightProvider(te,ue){return gt.registerMultiDocumentHighlightProvider(ze,wt(te),ue)},registerLinkedEditingRangeProvider(te,ue){return gt.registerLinkedEditingRangeProvider(ze,wt(te),ue)},registerReferenceProvider(te,ue){return gt.registerReferenceProvider(ze,wt(te),ue)},registerRenameProvider(te,ue){return gt.registerRenameProvider(ze,wt(te),ue)},registerNewSymbolNamesProvider(te,ue){return(0,xe.$dG)(ze,"newSymbolNamesProvider"),gt.registerNewSymbolNamesProvider(ze,wt(te),ue)},registerDocumentSymbolProvider(te,ue,Le){return gt.registerDocumentSymbolProvider(ze,wt(te),ue,Le)},registerWorkspaceSymbolProvider(te){return gt.registerWorkspaceSymbolProvider(ze,te)},registerDocumentFormattingEditProvider(te,ue){return gt.registerDocumentFormattingEditProvider(ze,wt(te),ue)},registerDocumentRangeFormattingEditProvider(te,ue){return gt.registerDocumentRangeFormattingEditProvider(ze,wt(te),ue)},registerOnTypeFormattingEditProvider(te,ue,Le,...at){return gt.registerOnTypeFormattingEditProvider(ze,wt(te),ue,[Le].concat(at))},registerDocumentSemanticTokensProvider(te,ue,Le){return gt.registerDocumentSemanticTokensProvider(ze,wt(te),ue,Le)},registerDocumentRangeSemanticTokensProvider(te,ue,Le){return gt.registerDocumentRangeSemanticTokensProvider(ze,wt(te),ue,Le)},registerSignatureHelpProvider(te,ue,Le,...at){return typeof Le=="object"?gt.registerSignatureHelpProvider(ze,wt(te),ue,Le):gt.registerSignatureHelpProvider(ze,wt(te),ue,typeof Le>"u"?[]:[Le,...at])},registerCompletionItemProvider(te,ue,...Le){return gt.registerCompletionItemProvider(ze,wt(te),ue,Le)},registerInlineCompletionItemProvider(te,ue,Le){return ue.handleDidShowCompletionItem&&(0,xe.$dG)(ze,"inlineCompletionsAdditions"),ue.handleDidPartiallyAcceptCompletionItem&&(0,xe.$dG)(ze,"inlineCompletionsAdditions"),Le&&(0,xe.$dG)(ze,"inlineCompletionsAdditions"),gt.registerInlineCompletionsProvider(ze,wt(te),ue,Le)},registerInlineEditProvider(te,ue){return(0,xe.$dG)(ze,"inlineEdit"),gt.registerInlineEditProvider(ze,wt(te),ue)},registerDocumentLinkProvider(te,ue){return gt.registerDocumentLinkProvider(ze,wt(te),ue)},registerColorProvider(te,ue){return gt.registerColorProvider(ze,wt(te),ue)},registerFoldingRangeProvider(te,ue){return gt.registerFoldingRangeProvider(ze,wt(te),ue)},registerSelectionRangeProvider(te,ue){return gt.registerSelectionRangeProvider(ze,te,ue)},registerCallHierarchyProvider(te,ue){return gt.registerCallHierarchyProvider(ze,te,ue)},registerTypeHierarchyProvider(te,ue){return gt.registerTypeHierarchyProvider(ze,te,ue)},setLanguageConfiguration:(te,ue)=>gt.setLanguageConfiguration(ze,te,ue),getTokenInformationAtPosition(te,ue){return(0,xe.$dG)(ze,"tokenInformation"),Ei.tokenAtPosition(te,ue)},registerInlayHintsProvider(te,ue){return gt.registerInlayHintsProvider(ze,te,ue)},createLanguageStatusItem(te,ue){return Ei.createLanguageStatusItem(ze,te,ue)},registerDocumentDropEditProvider(te,ue,Le){return gt.registerDocumentOnDropEditProvider(ze,te,ue,(0,xe.$cG)(ze,"dropMetadata")?Le:void 0)}},on={get activeTextEditor(){return St.getActiveTextEditor()},get visibleTextEditors(){return St.getVisibleTextEditors()},get activeTerminal(){return Tt.activeTerminal},get terminals(){return Tt.terminals},async showTextDocument(te,ue,Le){d.URI.isUri(te)&&te.scheme===A.Schemas.vscodeRemote&&!te.authority&&Nt.report("workspace.showTextDocument",ze,"A URI of 'vscode-remote' scheme requires an authority.");const at=await(d.URI.isUri(te)?Promise.resolve(Ji.openTextDocument(te)):Promise.resolve(te));return St.showTextDocument(at,ue,Le)},createTextEditorDecorationType(te){return St.createTextEditorDecorationType(ze,te)},onDidChangeActiveTextEditor(te,ue,Le){return nt(St.onDidChangeActiveTextEditor)(te,ue,Le)},onDidChangeVisibleTextEditors(te,ue,Le){return nt(St.onDidChangeVisibleTextEditors)(te,ue,Le)},onDidChangeTextEditorSelection(te,ue,Le){return nt(St.onDidChangeTextEditorSelection)(te,ue,Le)},onDidChangeTextEditorOptions(te,ue,Le){return nt(St.onDidChangeTextEditorOptions)(te,ue,Le)},onDidChangeTextEditorVisibleRanges(te,ue,Le){return nt(St.onDidChangeTextEditorVisibleRanges)(te,ue,Le)},onDidChangeTextEditorViewColumn(te,ue,Le){return nt(St.onDidChangeTextEditorViewColumn)(te,ue,Le)},onDidCloseTerminal(te,ue,Le){return nt(Tt.onDidCloseTerminal)(te,ue,Le)},onDidOpenTerminal(te,ue,Le){return nt(Tt.onDidOpenTerminal)(te,ue,Le)},onDidChangeActiveTerminal(te,ue,Le){return nt(Tt.onDidChangeActiveTerminal)(te,ue,Le)},onDidChangeTerminalDimensions(te,ue,Le){return(0,xe.$dG)(ze,"terminalDimensions"),nt(Tt.onDidChangeTerminalDimensions)(te,ue,Le)},onDidChangeTerminalState(te,ue,Le){return nt(Tt.onDidChangeTerminalState)(te,ue,Le)},onDidWriteTerminalData(te,ue,Le){return(0,xe.$dG)(ze,"terminalDataWriteEvent"),nt(Tt.onDidWriteTerminalData)(te,ue,Le)},onDidExecuteTerminalCommand(te,ue,Le){return(0,xe.$dG)(ze,"terminalExecuteCommandEvent"),nt(Tt.onDidExecuteTerminalCommand)(te,ue,Le)},onDidChangeTerminalShellIntegration(te,ue,Le){return(0,xe.$dG)(ze,"terminalShellIntegration"),nt(di.onDidChangeTerminalShellIntegration)(te,ue,Le)},onDidStartTerminalShellExecution(te,ue,Le){return(0,xe.$dG)(ze,"terminalShellIntegration"),nt(di.onDidStartTerminalShellExecution)(te,ue,Le)},onDidEndTerminalShellExecution(te,ue,Le){return(0,xe.$dG)(ze,"terminalShellIntegration"),nt(di.onDidEndTerminalShellExecution)(te,ue,Le)},get state(){return At.getState(ze)},onDidChangeWindowState(te,ue,Le){return nt(At.onDidChangeWindowState)(te,ue,Le)},showInformationMessage(te,...ue){return Gi.showMessage(ze,m.default.Info,te,ue[0],ue.slice(1))},showWarningMessage(te,...ue){return Gi.showMessage(ze,m.default.Warning,te,ue[0],ue.slice(1))},showErrorMessage(te,...ue){return Gi.showMessage(ze,m.default.Error,te,ue[0],ue.slice(1))},showQuickPick(te,ue,Le){return wi.showQuickPick(ze,te,ue,Le)},showWorkspaceFolderPick(te){return wi.showWorkspaceFolderPick(te)},showInputBox(te,ue){return wi.showInput(te,ue)},showOpenDialog(te){return Si.showOpenDialog(ze,te)},showSaveDialog(te){return Si.showSaveDialog(te)},createStatusBarItem(te,ue,Le){let at,yt,Ft;return typeof te=="string"?(at=te,yt=ue,Ft=Le):(yt=te,Ft=ue),Oi.createStatusBarEntry(ze,at,yt,Ft)},setStatusBarMessage(te,ue){return Oi.setStatusBarMessage(te,ue)},withScmProgress(te){return Nt.report("window.withScmProgress",ze,"Use 'withProgress' instead."),zi.withProgress(ze,{location:Me.ProgressLocation.SourceControl},(ue,Le)=>te({report(at){}}))},withProgress(te,ue){return zi.withProgress(ze,te,ue)},createOutputChannel(te,ue){return ki.createOutputChannel(te,ue,ze)},createWebviewPanel(te,ue,Le,at){return Ai.createWebviewPanel(ze,te,ue,Le,at)},createWebviewTextEditorInset(te,ue,Le,at){return(0,xe.$dG)(ze,"editorInsets"),Ot.createWebviewEditorInset(te,ue,Le,at,ze)},createTerminal(te,ue,Le){return typeof te=="object"?"pty"in te?Tt.createExtensionTerminal(te):Tt.createTerminalFromOptions(te):Tt.createTerminal(te,ue,Le)},registerTerminalLinkProvider(te){return Tt.registerLinkProvider(te)},registerTerminalProfileProvider(te,ue){return Tt.registerProfileProvider(ze,te,ue)},registerTerminalQuickFixProvider(te,ue){return(0,xe.$dG)(ze,"terminalQuickFixProvider"),Tt.registerTerminalQuickFixProvider(te,ze.identifier.value,ue)},registerTreeDataProvider(te,ue){return oi.registerTreeDataProvider(te,ue,ze)},createTreeView(te,ue){return oi.createTreeView(te,ue,ze)},registerWebviewPanelSerializer:(te,ue)=>Ai.registerWebviewPanelSerializer(ze,te,ue),registerCustomEditorProvider:(te,ue,Le={})=>pn.registerCustomEditorProvider(ze,te,ue,Le),registerFileDecorationProvider(te){return ni.registerFileDecorationProvider(te,ze)},registerUriHandler(te){return Ee.registerUriHandler(ze,te)},createQuickPick(){return wi.createQuickPick(ze)},createInputBox(){return wi.createInputBox(ze)},get activeColorTheme(){return Ri.activeColorTheme},onDidChangeActiveColorTheme(te,ue,Le){return nt(Ri.onDidChangeActiveColorTheme)(te,ue,Le)},registerWebviewViewProvider(te,ue,Le){return Yi.registerWebviewViewProvider(ze,te,ue,Le?.webviewOptions)},get activeNotebookEditor(){return ke.activeNotebookEditor},onDidChangeActiveNotebookEditor(te,ue,Le){return nt(ke.onDidChangeActiveNotebookEditor)(te,ue,Le)},get visibleNotebookEditors(){return ke.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return nt(ke.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(te,ue,Le){return nt(Ze.onDidChangeNotebookEditorSelection)(te,ue,Le)},onDidChangeNotebookEditorVisibleRanges(te,ue,Le){return nt(Ze.onDidChangeNotebookEditorVisibleRanges)(te,ue,Le)},showNotebookDocument(te,ue){return ke.showNotebookDocument(te,ue)},registerExternalUriOpener(te,ue,Le){return(0,xe.$dG)(ze,"externalUriOpener"),Bi.registerExternalUriOpener(ze.identifier,te,ue,Le)},registerProfileContentHandler(te,ue){return(0,xe.$dG)(ze,"profileContentHandlers"),xi.registerProfileContentHandler(ze,te,ue)},registerQuickDiffProvider(te,ue,Le,at){return(0,xe.$dG)(ze,"quickDiffProvider"),mn.registerQuickDiffProvider(wt(te),ue,Le,at)},get tabGroups(){return Ut.tabGroups},registerShareProvider(te,ue){return(0,xe.$dG)(ze,"shareProvider"),$n.registerShareProvider(wt(te),ue)}},Ji={get rootPath(){return Nt.report("workspace.rootPath",ze,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),mt.getPath()},set rootPath(te){throw new M.$9("rootPath")},getWorkspaceFolder(te){return mt.getWorkspaceFolder(te)},get workspaceFolders(){return mt.getWorkspaceFolders()},get name(){return mt.name},set name(te){throw new M.$9("name")},get workspaceFile(){return mt.workspaceFile},set workspaceFile(te){throw new M.$9("workspaceFile")},updateWorkspaceFolders:(te,ue,...Le)=>mt.updateWorkspaceFolders(ze,te,ue||0,...Le),onDidChangeWorkspaceFolders:function(te,ue,Le){return nt(mt.onDidChangeWorkspace)(te,ue,Le)},asRelativePath:(te,ue)=>mt.getRelativePath(te,ue),findFiles:(te,ue,Le,at)=>mt.findFiles(te,ue,Le,ze.identifier,at),findFiles2:(te,ue,Le)=>((0,xe.$dG)(ze,"findFiles2"),mt.findFiles2(te,ue,ze.identifier,Le)),findTextInFiles:(te,ue,Le,at)=>{(0,xe.$dG)(ze,"findTextInFiles");let yt,Ft;return typeof ue=="object"?(yt=ue,Ft=Le):(yt={},Ft=ue,at=Le),mt.findTextInFiles(te,yt||{},Ft,ze.identifier,at)},save:te=>mt.save(te),saveAs:te=>mt.saveAs(te),saveAll:te=>mt.saveAll(te),applyEdit(te,ue){return bn.applyWorkspaceEdit(te,ze,ue)},createFileSystemWatcher:(te,ue,Le,at)=>{let yt;return typeof ue=="boolean"?yt={ignoreCreateEvents:!!ue,ignoreChangeEvents:!!Le,ignoreDeleteEvents:!!at,correlate:!1}:ue&&((0,xe.$dG)(ze,"createFileSystemWatcher"),yt={...ue,correlate:!0}),fi.createFileSystemWatcher(mt,ze,te,yt)},get textDocuments(){return Ce.getAllDocumentData().map(te=>te.document)},set textDocuments(te){throw new M.$9("textDocuments")},openTextDocument(te){let ue;const Le=te;if(typeof te=="string")ue=Promise.resolve(d.URI.file(te));else if(d.URI.isUri(te))ue=Promise.resolve(te);else if(!Le||typeof Le=="object")ue=Ce.createDocumentData(Le);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ue.then(at=>(at.scheme===A.Schemas.vscodeRemote&&!at.authority&&Nt.report("workspace.openTextDocument",ze,"A URI of 'vscode-remote' scheme requires an authority."),Ce.ensureDocumentData(at).then(yt=>yt.document)))},onDidOpenTextDocument:(te,ue,Le)=>nt(Ce.onDidAddDocument)(te,ue,Le),onDidCloseTextDocument:(te,ue,Le)=>nt(Ce.onDidRemoveDocument)(te,ue,Le),onDidChangeTextDocument:(te,ue,Le)=>nt(Ce.onDidChangeDocument)(te,ue,Le),onDidSaveTextDocument:(te,ue,Le)=>nt(Ce.onDidSaveDocument)(te,ue,Le),onWillSaveTextDocument:(te,ue,Le)=>nt(J.getOnWillSaveTextDocumentEvent(ze))(te,ue,Le),get notebookDocuments(){return ke.notebookDocuments.map(te=>te.apiNotebook)},async openNotebookDocument(te,ue){let Le;if(d.URI.isUri(te))Le=te,await ke.openNotebookDocument(te);else if(typeof te=="string")Le=d.URI.revive(await ke.createNotebookDocument({viewType:te,content:ue}));else throw new Error("Invalid arguments");return ke.getNotebookDocument(Le).apiNotebook},onDidSaveNotebookDocument(te,ue,Le){return nt(We.onDidSaveNotebookDocument)(te,ue,Le)},onDidChangeNotebookDocument(te,ue,Le){return nt(We.onDidChangeNotebookDocument)(te,ue,Le)},onWillSaveNotebookDocument(te,ue,Le){return nt(Dt.getOnWillSaveNotebookDocumentEvent(ze))(te,ue,Le)},get onDidOpenNotebookDocument(){return nt(ke.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return nt(ke.onDidCloseNotebookDocument)},registerNotebookSerializer(te,ue,Le,at){return ke.registerNotebookSerializer(ze,te,ue,Le,(0,xe.$cG)(ze,"notebookLiveShare")?at:void 0)},onDidChangeConfiguration:(te,ue,Le)=>nt(Ki.onDidChangeConfiguration)(te,ue,Le),getConfiguration(te,ue){return ue=arguments.length===1?void 0:ue,Ki.getConfiguration(te,ue,ze)},registerTextDocumentContentProvider(te,ue){return he.registerTextDocumentContentProvider(te,ue)},registerTaskProvider:(te,ue)=>(Nt.report("window.registerTaskProvider",ze,"Use the corresponding function on the 'tasks' namespace instead"),Kt.registerTaskProvider(ze,te,ue)),registerFileSystemProvider(te,ue,Le){return(0,N.$Rc)(Ni.registerFileSystemProvider(ze,te,ue,Le),zt.addFileSystemProvider(te,ue,Le))},get fs(){return zt.value},registerFileSearchProvider:(te,ue)=>((0,xe.$dG)(ze,"fileSearchProvider"),ui.registerFileSearchProvider(te,ue)),registerTextSearchProvider:(te,ue)=>((0,xe.$dG)(ze,"textSearchProvider"),ui.registerTextSearchProvider(te,ue)),registerAITextSearchProvider:(te,ue)=>((0,xe.$dG)(ze,"aiTextSearchProvider"),(0,xe.$dG)(ze,"textSearchProvider"),ui.registerAITextSearchProvider(te,ue)),registerRemoteAuthorityResolver:(te,ue)=>((0,xe.$dG)(ze,"resolvers"),Vt.registerRemoteAuthorityResolver(te,ue)),registerResourceLabelFormatter:te=>((0,xe.$dG)(ze,"resolvers"),ji.$registerResourceLabelFormatter(te)),getRemoteExecServer:te=>((0,xe.$dG)(ze,"resolvers"),Vt.getRemoteExecServer(te)),onDidCreateFiles:(te,ue,Le)=>nt(fi.onDidCreateFile)(te,ue,Le),onDidDeleteFiles:(te,ue,Le)=>nt(fi.onDidDeleteFile)(te,ue,Le),onDidRenameFiles:(te,ue,Le)=>nt(fi.onDidRenameFile)(te,ue,Le),onWillCreateFiles:(te,ue,Le)=>nt(fi.getOnWillCreateFileEvent(ze))(te,ue,Le),onWillDeleteFiles:(te,ue,Le)=>nt(fi.getOnWillDeleteFileEvent(ze))(te,ue,Le),onWillRenameFiles:(te,ue,Le)=>nt(fi.getOnWillRenameFileEvent(ze))(te,ue,Le),openTunnel:te=>((0,xe.$dG)(ze,"tunnels"),jt.openTunnel(ze,te).then(ue=>{if(!ue)throw new Error("cannot open tunnel");return ue})),get tunnels(){return(0,xe.$dG)(ze,"tunnels"),jt.getTunnels()},onDidChangeTunnels:(te,ue,Le)=>((0,xe.$dG)(ze,"tunnels"),nt(jt.onDidChangeTunnels)(te,ue,Le)),registerPortAttributesProvider:(te,ue)=>((0,xe.$dG)(ze,"portsAttributes"),jt.registerPortsAttributesProvider(te,ue)),registerTunnelProvider:(te,ue)=>((0,xe.$dG)(ze,"tunnelFactory"),jt.registerTunnelProvider(te,ue)),registerTimelineProvider:(te,ue)=>((0,xe.$dG)(ze,"timeline"),Ui.registerTimelineProvider(te,ue,ze.identifier,kt.converter)),get isTrusted(){return mt.trusted},requestWorkspaceTrust:te=>((0,xe.$dG)(ze,"workspaceTrust"),mt.requestWorkspaceTrust(te)),onDidGrantWorkspaceTrust:(te,ue,Le)=>nt(mt.onDidGrantWorkspaceTrust)(te,ue,Le),registerEditSessionIdentityProvider:(te,ue)=>((0,xe.$dG)(ze,"editSessionIdentityProvider"),mt.registerEditSessionIdentityProvider(te,ue)),onWillCreateEditSessionIdentity:(te,ue,Le)=>((0,xe.$dG)(ze,"editSessionIdentityProvider"),nt(mt.getOnWillCreateEditSessionIdentityEvent(ze))(te,ue,Le)),registerCanonicalUriProvider:(te,ue)=>((0,xe.$dG)(ze,"canonicalUriProvider"),mt.registerCanonicalUriProvider(te,ue)),getCanonicalUri:(te,ue,Le)=>((0,xe.$dG)(ze,"canonicalUriProvider"),mt.provideCanonicalUri(te,ue,Le))},an={get inputBox(){return Nt.report("scm.inputBox",ze,"Use 'SourceControl.inputBox' instead"),Mi.getLastInputBox(ze)},createSourceControl(te,ue,Le){return Mi.createSourceControl(ze,te,ue,Le)}},kn={createCommentController(te,ue){return Li.createCommentController(ze,te,ue)}},cn={get activeDebugSession(){return Et.activeDebugSession},get activeDebugConsole(){return Et.activeDebugConsole},get breakpoints(){return Et.breakpoints},get activeStackItem(){if((0,xe.$cG)(ze,"debugFocus"))return Et.activeStackItem},registerDebugVisualizationProvider(te,ue){return(0,xe.$dG)(ze,"debugVisualization"),Et.registerDebugVisualizationProvider(ze,te,ue)},registerDebugVisualizationTreeProvider(te,ue){return(0,xe.$dG)(ze,"debugVisualization"),Et.registerDebugVisualizationTree(ze,te,ue)},onDidStartDebugSession(te,ue,Le){return nt(Et.onDidStartDebugSession)(te,ue,Le)},onDidTerminateDebugSession(te,ue,Le){return nt(Et.onDidTerminateDebugSession)(te,ue,Le)},onDidChangeActiveDebugSession(te,ue,Le){return nt(Et.onDidChangeActiveDebugSession)(te,ue,Le)},onDidReceiveDebugSessionCustomEvent(te,ue,Le){return nt(Et.onDidReceiveDebugSessionCustomEvent)(te,ue,Le)},onDidChangeBreakpoints(te,ue,Le){return nt(Et.onDidChangeBreakpoints)(te,ue,Le)},onDidChangeActiveStackItem(te,ue,Le){return(0,xe.$dG)(ze,"debugFocus"),nt(Et.onDidChangeActiveStackItem)(te,ue,Le)},registerDebugConfigurationProvider(te,ue,Le){return Et.registerDebugConfigurationProvider(te,ue,Le||_t.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(te,ue){return Et.registerDebugAdapterDescriptorFactory(ze,te,ue)},registerDebugAdapterTrackerFactory(te,ue){return Et.registerDebugAdapterTrackerFactory(te,ue)},startDebugging(te,ue,Le){return!Le||typeof Le=="object"&&"configuration"in Le?Et.startDebugging(te,ue,{parentSession:Le}):Et.startDebugging(te,ue,Le||{})},stopDebugging(te){return Et.stopDebugging(te)},addBreakpoints(te){return Et.addBreakpoints(te)},removeBreakpoints(te){return Et.removeBreakpoints(te)},asDebugSourceUri(te,ue){return Et.asDebugSourceUri(te,ue)}},un={registerTaskProvider:(te,ue)=>Kt.registerTaskProvider(ze,te,ue),fetchTasks:te=>Kt.fetchTasks(te),executeTask:te=>Kt.executeTask(ze,te),get taskExecutions(){return Kt.taskExecutions},onDidStartTask:(te,ue,Le)=>nt(Kt.onDidStartTask)(te,ue,Le),onDidEndTask:(te,ue,Le)=>nt(Kt.onDidEndTask)(te,ue,Le),onDidStartTaskProcess:(te,ue,Le)=>nt(Kt.onDidStartTaskProcess)(te,ue,Le),onDidEndTaskProcess:(te,ue,Le)=>nt(Kt.onDidEndTaskProcess)(te,ue,Le)},En={createNotebookController(te,ue,Le,at,yt){return Ke.createNotebookController(ze,te,ue,Le,at,(0,xe.$cG)(ze,"notebookMessaging")?yt:void 0)},registerNotebookCellStatusBarItemProvider:(te,ue)=>ke.registerNotebookCellStatusBarItemProvider(ze,te,ue),createRendererMessaging(te){return lt.createRendererMessaging(ze,te)},createNotebookControllerDetectionTask(te){return(0,xe.$dG)(ze,"notebookKernelSource"),Ke.createNotebookControllerDetectionTask(ze,te)},registerKernelSourceActionProvider(te,ue){return(0,xe.$dG)(ze,"notebookKernelSource"),Ke.registerKernelSourceActionProvider(ze,te,ue)},onDidChangeNotebookCellExecutionState(te,ue,Le){return(0,xe.$dG)(ze,"notebookCellExecutionState"),nt(Ke.onDidChangeNotebookCellExecutionState)(te,ue,Le)}},Dn={t(...te){if(typeof te[0]=="string"){const ue=te.shift(),Le=!te||typeof te[0]!="object"?te:te[0];return vi.getMessage(ze.identifier.value,{message:ue,args:Le})}return vi.getMessage(ze.identifier.value,te[0])},get bundle(){return vi.getBundle(ze.identifier.value)},get uri(){return vi.getBundleUri(ze.identifier.value)}},ln={_version:1,registerInteractiveEditorSessionProvider(te,ue){return(0,xe.$dG)(ze,"interactive"),_i.registerProvider(ze,te,ue)},registerInteractiveSessionProvider(te,ue){return(0,xe.$dG)(ze,"interactive"),Wi.registerChatProvider(ze,te,ue)},transferChatSession(te,ue){return(0,xe.$dG)(ze,"interactive"),Wi.transferChatSession(te,ue)}},Qi={getRelatedInformation(te,ue){return(0,xe.$dG)(ze,"aiRelatedInformation"),qi.getRelatedInformation(ze,te,ue)},registerRelatedInformationProvider(te,ue){return(0,xe.$dG)(ze,"aiRelatedInformation"),qi.registerRelatedInformationProvider(ze,te,ue)},registerEmbeddingVectorProvider(te,ue){return(0,xe.$dG)(ze,"aiRelatedInformation"),vn.registerEmbeddingVectorProvider(ze,te,ue)}},hn={registerChatResponseProvider(te,ue,Le){return(0,xe.$dG)(ze,"chatProvider"),Lt.registerLanguageModel(ze,te,ue,Le)},registerChatVariableResolver(te,ue,Le){return(0,xe.$dG)(ze,"chatVariableResolver"),en.registerVariableResolver(ze,te,ue,Le)},registerMappedEditsProvider(te,ue){return(0,xe.$dG)(ze,"mappedEditsProvider"),gt.registerMappedEditsProvider(ze,te,ue)},createChatParticipant(te,ue){return(0,xe.$dG)(ze,"chatParticipant"),Vi.createChatAgent(ze,te,ue)},createDynamicChatParticipant(te,ue,Le,at){return(0,xe.$dG)(ze,"chatParticipantAdditions"),Vi.createDynamicChatAgent(ze,te,ue,Le,at)}},dn={get languageModels(){return(0,xe.$dG)(ze,"languageModels"),Lt.getLanguageModelIds()},onDidChangeLanguageModels:(te,ue,Le)=>((0,xe.$dG)(ze,"languageModels"),Lt.onDidChangeProviders(te,ue,Le)),sendChatRequest(te,ue,Le,at){return(0,xe.$dG)(ze,"languageModels"),Lt.sendChatRequest(ze,te,ue,Le,at)}},fn={registerSpeechProvider(te,ue){return(0,xe.$dG)(ze,"speech"),Hi.registerProvider(ze.identifier,te,ue)}};return{version:vt.version,ai:Qi,authentication:rn,commands:$i,comments:kn,chat:hn,debug:cn,env:Ii,extensions:Ti,interactive:ln,l10n:Dn,languages:sn,lm:dn,notebooks:En,scm:an,speech:fn,tasks:un,tests:yn,window:on,workspace:Ji,Breakpoint:Me.$uN,TerminalOutputAnchor:Me.TerminalOutputAnchor,ChatResultFeedbackKind:Me.ChatResultFeedbackKind,ChatVariableLevel:Me.ChatVariableLevel,ChatCompletionItem:Me.$pO,CallHierarchyIncomingCall:Me.$SM,CallHierarchyItem:Me.$RM,CallHierarchyOutgoingCall:Me.$TM,CancellationError:M.$5,CancellationTokenSource:k.$ee,CandidatePortSource:i.CandidatePortSource,CodeAction:Me.$OM,CodeActionKind:Me.$PM,CodeActionTriggerKind:Me.CodeActionTriggerKind,CodeLens:Me.$UM,Color:Me.$8M,ColorInformation:Me.$9M,ColorPresentation:Me.$0M,ColorThemeKind:Me.ColorThemeKind,CommentMode:Me.CommentMode,CommentState:Me.CommentState,CommentThreadCollapsibleState:Me.CommentThreadCollapsibleState,CommentThreadState:Me.CommentThreadState,CommentThreadApplicability:Me.CommentThreadApplicability,CompletionItem:Me.$2M,CompletionItemKind:Me.CompletionItemKind,CompletionItemTag:Me.CompletionItemTag,CompletionList:Me.$3M,CompletionTriggerKind:Me.CompletionTriggerKind,ConfigurationTarget:Me.ConfigurationTarget,CustomExecution:Me.$fN,DebugAdapterExecutable:Me.$yN,DebugAdapterInlineImplementation:Me.$BN,DebugAdapterNamedPipeServer:Me.$AN,DebugAdapterServer:Me.$zN,DebugConfigurationProviderTriggerKind:_t.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Me.DebugConsoleMode,DebugVisualization:Me.$RN,DecorationRangeBehavior:Me.DecorationRangeBehavior,Diagnostic:Me.$IM,DiagnosticRelatedInformation:Me.$HM,DiagnosticSeverity:Me.DiagnosticSeverity,DiagnosticTag:Me.DiagnosticTag,Disposable:Me.$uM,DocumentHighlight:Me.$KM,DocumentHighlightKind:Me.DocumentHighlightKind,MultiDocumentHighlight:Me.$LM,DocumentLink:Me.$7M,DocumentSymbol:Me.$NM,EndOfLine:Me.EndOfLine,EnvironmentVariableMutatorType:Me.EnvironmentVariableMutatorType,EvaluatableExpression:Me.$EN,InlineValueText:Me.$FN,InlineValueVariableLookup:Me.$GN,InlineValueEvaluatableExpression:Me.$HN,InlineCompletionTriggerKind:Me.InlineCompletionTriggerKind,EventEmitter:C.$7d,ExtensionKind:Me.ExtensionKind,ExtensionMode:Me.ExtensionMode,ExternalUriOpenerPriority:Me.ExternalUriOpenerPriority,FileChangeType:Me.FileChangeType,FileDecoration:Me.$TN,FileDecoration2:Me.$TN,FileSystemError:Me.$KN,FileType:$.FileType,FilePermission:$.FilePermission,FoldingRange:Me.$LN,FoldingRangeKind:Me.FoldingRangeKind,FunctionBreakpoint:Me.$wN,InlineCompletionItem:Me.$4M,InlineCompletionList:Me.$5M,Hover:Me.$JM,IndentAction:D.IndentAction,Location:Me.$GM,MarkdownString:Me.$VM,OverviewRulerLane:l.OverviewRulerLane,ParameterInformation:Me.$WM,PortAutoForwardAction:Me.PortAutoForwardAction,Position:Me.$vM,ProcessExecution:Me.$dN,ProgressLocation:Me.ProgressLocation,QuickInputButtons:Me.$SN,Range:Me.$wM,RelativePattern:Me.$sN,Selection:Me.$xM,SelectionRange:Me.$QM,SemanticTokens:Me.$ON,SemanticTokensBuilder:Me.$NN,SemanticTokensEdit:Me.$PN,SemanticTokensEdits:Me.$QN,SemanticTokensLegend:Me.$MN,ShellExecution:Me.$eN,ShellQuoting:Me.ShellQuoting,SignatureHelp:Me.$YM,SignatureHelpTriggerKind:Me.SignatureHelpTriggerKind,SignatureInformation:Me.$XM,SnippetString:Me.$FM,SourceBreakpoint:Me.$vN,StandardTokenType:Me.StandardTokenType,StatusBarAlignment:Me.StatusBarAlignment,SymbolInformation:Me.$MM,SymbolKind:Me.SymbolKind,SymbolTag:Me.SymbolTag,Task:Me.$gN,TaskGroup:Me.$cN,TaskPanelKind:Me.TaskPanelKind,TaskRevealKind:Me.TaskRevealKind,TaskScope:Me.TaskScope,TerminalLink:Me.$$M,TerminalQuickFixTerminalCommand:Me.$aN,TerminalQuickFixOpener:Me.$_M,TerminalLocation:Me.TerminalLocation,TerminalProfile:Me.$bN,TerminalExitReason:Me.TerminalExitReason,TextDocumentSaveReason:Me.TextDocumentSaveReason,TextEdit:Me.$BM,SnippetTextEdit:Me.$DM,TextEditorCursorStyle:y.TextEditorCursorStyle,TextEditorLineNumbersStyle:Me.TextEditorLineNumbersStyle,TextEditorRevealType:Me.TextEditorRevealType,TextEditorSelectionChangeKind:Me.TextEditorSelectionChangeKind,SyntaxTokenType:Me.SyntaxTokenType,TextDocumentChangeReason:Me.TextDocumentChangeReason,ThemeColor:Me.$rN,ThemeIcon:Me.$qN,TreeItem:Me.$hN,TreeItemCheckboxState:Me.TreeItemCheckboxState,TreeItemCollapsibleState:Me.TreeItemCollapsibleState,TypeHierarchyItem:Me.$dO,UIKind:hi.UIKind,Uri:d.URI,ViewColumn:Me.ViewColumn,WorkspaceEdit:Me.$EM,DocumentPasteTriggerKind:Me.DocumentPasteTriggerKind,DocumentDropEdit:Me.$nN,DocumentPasteEditKind:Me.$oN,DocumentPasteEdit:Me.$pN,InlayHint:Me.$1M,InlayHintLabelPart:Me.$ZM,InlayHintKind:Me.InlayHintKind,RemoteAuthorityResolverError:Me.$AM,ResolvedAuthority:Me.$yM,ManagedResolvedAuthority:Me.$zM,SourceControlInputBoxValidationType:Me.SourceControlInputBoxValidationType,ExtensionRuntime:Me.ExtensionRuntime,TimelineItem:Me.$4N,NotebookRange:Me.$VN,NotebookCellKind:Me.NotebookCellKind,NotebookCellExecutionState:Me.NotebookCellExecutionState,NotebookCellData:Me.$WN,NotebookData:Me.$XN,NotebookRendererScript:Me.$2N,NotebookCellStatusBarAlignment:Me.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Me.NotebookEditorRevealType,NotebookCellOutput:Me.$ZN,NotebookCellOutputItem:Me.$YN,NotebookCellStatusBarItem:Me.$1N,NotebookControllerAffinity:Me.NotebookControllerAffinity,NotebookControllerAffinity2:Me.NotebookControllerAffinity2,NotebookEdit:Me.$CM,NotebookKernelSourceAction:Me.$3N,NotebookVariablesRequestKind:Me.NotebookVariablesRequestKind,PortAttributes:Me.$6N,LinkedEditingRanges:Me.$5N,TestResultState:Me.TestResultState,TestRunRequest:Me.$7N,TestMessage:Me.$8N,TestTag:Me.$9N,TestRunProfileKind:Me.TestRunProfileKind,TextSearchCompleteMessageType:si.TextSearchCompleteMessageType,DataTransfer:Me.$mN,DataTransferItem:Me.$iN,TestCoverageCount:Me.$0N,FileCoverage:Me.$_N,StatementCoverage:Me.$aO,BranchCoverage:Me.$bO,DeclarationCoverage:Me.$cO,FunctionCoverage:Me.$cO,WorkspaceTrustState:Me.WorkspaceTrustState,LanguageStatusSeverity:Me.LanguageStatusSeverity,QuickPickItemKind:Me.QuickPickItemKind,InputBoxValidationSeverity:Me.InputBoxValidationSeverity,TabInputText:Me.$eO,TabInputTextDiff:Me.$fO,TabInputTextMerge:Me.$gO,TabInputCustom:Me.$hO,TabInputNotebook:Me.$jO,TabInputNotebookDiff:Me.$kO,TabInputWebview:Me.$iO,TabInputTerminal:Me.$lO,TabInputInteractiveWindow:Me.$mO,TabInputChat:Me.$nO,TabInputTextMultiDiff:Me.$oO,TelemetryTrustedValue:s.$5o,LogLevel:n.LogLevel,EditSessionIdentityMatch:r.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Me.InteractiveSessionVoteDirection,ChatCopyKind:Me.ChatCopyKind,InteractiveEditorResponseFeedbackKind:Me.InteractiveEditorResponseFeedbackKind,StackFrame:Me.$CN,Thread:Me.$DN,RelatedInformationType:Me.RelatedInformationType,SpeechToTextStatus:Me.SpeechToTextStatus,PartialAcceptTriggerKind:Me.PartialAcceptTriggerKind,KeywordRecognitionStatus:Me.KeywordRecognitionStatus,ChatResponseMarkdownPart:Me.$qO,ChatResponseFileTreePart:Me.$rO,ChatResponseAnchorPart:Me.$sO,ChatResponseProgressPart:Me.$tO,ChatResponseReferencePart:Me.$vO,ChatResponseCommandButtonPart:Me.$uO,ChatRequestTurn:Me.$wO,ChatResponseTurn:Me.$xO,ChatLocation:Me.ChatLocation,LanguageModelChatSystemMessage:Me.$yO,LanguageModelChatUserMessage:Me.$zO,LanguageModelChatAssistantMessage:Me.$AO,LanguageModelSystemMessage:Me.$yO,LanguageModelUserMessage:Me.$zO,LanguageModelAssistantMessage:Me.$AO,LanguageModelError:Me.$BO,NewSymbolName:Me.$JN,NewSymbolNameTag:Me.NewSymbolNameTag,InlineEdit:Me.$CO,InlineEditTriggerKind:Me.InlineEditTriggerKind}}}}),define(Pe[298],Re([1,0,55,116,36,110,37,31,67,51,119,121,122,82,86,78,109,64,44,81,62,66,236,13,120,79,80,84,88,114]),function(ee,e,k,M,C,N,A,m,d,y,O,D,l,b,$,n,o,s,r,i,c,h,t,p,a,g,v,f,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,k.$hs)(g.$vkc,g.$ukc,1),(0,k.$hs)(p.$Pj,t.$Jlc,1),(0,k.$hs)(n.$zjc,n.$Ajc,1),(0,k.$hs)(m.$$O,m.$0O,0),(0,k.$hs)(f.$Jjc,f.$Kjc,0),(0,k.$hs)(u.$Ojc,u.$Pjc,0),(0,k.$hs)(A.$2jc,A.$Zjc,0),(0,k.$hs)(s.$4jc,s.$3jc,0),(0,k.$hs)(D.$Fkc,D.$Jkc,0),(0,k.$hs)(N.$Lkc,N.$Kkc,0),(0,k.$hs)(d.$ZO,d.$YO,0),(0,k.$hs)(v.$wkc,v.$xkc,0),(0,k.$hs)(r.$Djc,r.$Cjc,0),(0,k.$hs)(M.$flc,M.$elc,1),(0,k.$hs)(l.$2kc,l.$3kc,0),(0,k.$hs)(b.$kkc,b.$jkc,0),(0,k.$hs)(O.$slc,O.$rlc,0),(0,k.$hs)(y.$nkc,y.$qkc,0),(0,k.$hs)(E.$Glc,E.$Hlc,0),(0,k.$hs)($.$kCb,$.$lCb,0),(0,k.$hs)(o.$Flc,o.$Elc,0),(0,k.$hs)(C.$Yjc,C.$Xjc,0),(0,k.$hs)(i.$skc,i.$rkc,0),(0,k.$hs)(c.$9O,c.$6O,0),(0,k.$hs)(h.$bkc,h.$ckc,0),(0,k.$hs)(a.$Dkc,a.$Ekc,0)}),define(Pe[299],Re([1,0,297,38,2,294,7,11,242]),function(ee,e,k,M,C,N,A,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tnc=void 0;class y extends N.$Mlc{k(){}getModule(b,$){for(const n of this.b){const o=n(b);if(o){b=o;break}}if(this.a.has(b))return this.a.get(b).load(b,$,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class O extends M.$zkc{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Webworker}async vb(){this.h.createInstance(d.$Snc);const b=this.h.invokeFunction(k.$Ilc);this.r=this.h.createInstance(y,b,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.Bb()}wb(b){return b.browser}async xb(b,$,n){$=$.with({path:D($.path,".js")});const o=b?.identifier.value;o&&performance.mark(`code/extHost/willFetchExtensionCode/${o}`);const s=C.URI.revive(await this.C.$asBrowserUri($)),r=await fetch(s.toString(!0));if(o&&performance.mark(`code/extHost/didFetchExtensionCode/${o}`),r.status!==200)throw new Error(r.statusText);const i=await r.text(),c=`${$.toString(!0)}#vscode-extension`,h=`${i}
//# sourceURL=${c}`;let t;try{t=new Function("module","exports","require",h)}catch(v){throw console.error(o?`Loading code for extension ${o} failed: ${v.message}`:`Loading code failed: ${v.message}`),console.error(`${$.toString(!0)}${typeof v.line=="number"?` line ${v.line}`:""}${typeof v.column=="number"?` column ${v.column}`:""}`),console.error(v),v}b&&await this.w.initializeLocalizedMessages(b);const p={},a={exports:p},g=v=>{const f=this.r.getModule(v,$);if(f===void 0)throw new Error(`Cannot load module '${v}'`);return f};try{return n.codeLoadingStart(),o&&performance.mark(`code/extHost/willLoadExtensionCode/${o}`),t(a,p,g),a.exports!==p?a.exports:p}finally{o&&performance.mark(`code/extHost/didLoadExtensionCode/${o}`),n.codeLoadingStop()}}async $setRemoteEnvironment(b){}async Bb(b=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const $=Date.now()+b;for(;Date.now()<$&&!("__jsDebugIsReady"in globalThis);)await(0,m.$jh)(10)}}e.$Tnc=O;function D(l,b){return l.endsWith(b)?l:l+b}}),define(Pe[300],Re([1,0,70,55,13,38,206,85,299]),function(ee,e,k,M,C,N,A,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,M.$hs)(C.$Oj,new k.$fi(A.$Llc,[!0],!0)),(0,M.$hs)(N.$Akc,d.$Tnc,0),(0,M.$hs)(m.$5jc,m.$6jc,0)}),define(Pe[306],Re([1,0,22,5,77,295,244,19,89,12,2,298,300]),function(ee,e,k,M,C,N,A,m,d,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=h;const D=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const l=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function b(t){return/^(file|vscode-remote):/i.test(t)}const $=fetch.bind(self);function n(t){self.fetch=async function(p,a){return p instanceof Request||b(String(p))&&(p=(await t(O.URI.parse(String(p)))).toString(!0)),$(p,a)},self.XMLHttpRequest=class extends XMLHttpRequest{open(p,a,g,v,f){(async()=>(b(a.toString())&&(a=(await t(O.URI.parse(a.toString()))).toString(!0)),super.open(p,a,g??!0,v,f)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const t=self.Worker;Worker=function(p,a){if(/^file:/i.test(p.toString()))p=y.$Cg.uriToBrowserUri(O.URI.parse(p.toString())).toString(!0);else if(/^vscode-remote:/i.test(p.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const v=`(${function(w){function I(U){return typeof U=="string"||U instanceof URL?String(U).replace(/^file:\/\//i,"vscode-file://vscode-app"):U}const S=fetch.bind(self);self.fetch=function(U,Q){return U instanceof Request?S(U,Q):S(I(U),Q)},self.XMLHttpRequest=class extends XMLHttpRequest{open(U,Q,H,L,R){return super.open(U,I(Q),H??!0,L,R)}};const P=importScripts.bind(self);self.importScripts=(...U)=>{P(...U.map(I))},P(w)}.toString()}('${p}'))`;a=a||{},a.name=`${name} -> ${a.name||m.$oc(p.toString())}`;const f=new Blob([v],{type:"application/javascript"}),u=URL.createObjectURL(f);return new t(u,a)}}else self.Worker=class extends A.$Unc{constructor(t,p){super(l,t,{name:m.$oc(t.toString()),...p})}};const o=new class{constructor(){this.pid=void 0}exit(t){D()}};class s{constructor(){const p=new MessageChannel,a=new M.$7d;let g=!1;l(p.port2,[p.port2]),p.port1.onmessage=v=>{const{data:f}=v;if(!(f instanceof ArrayBuffer)){console.warn("UNKNOWN data received",f);return}const u=k.$ue.wrap(new Uint8Array(f,0,f.byteLength));if((0,C.$Nm)(u,2)){g=!0,i("received terminate message from renderer");return}a.fire(u)},this.protocol={onMessage:a.event,send:v=>{if(!g){const f=v.buffer.buffer.slice(v.buffer.byteOffset,v.buffer.byteOffset+v.buffer.byteLength);p.port1.postMessage(f,[f])}}}}}function r(t){return new Promise(p=>{const a=t.onMessage(g=>{a.dispose();const v=JSON.parse(g.toString());t.send((0,C.$Mm)(0)),p({protocol:t,initData:v})});t.send((0,C.$Mm)(1))})}let i=t=>D();function c(t){return!!t&&typeof t=="object"&&t.type==="vscode.init"&&t.data instanceof Map}function h(){d.mark("code/extHost/willConnectToRenderer");const t=new s;return{onmessage(p){c(p)&&r(t.protocol).then(a=>{d.mark("code/extHost/didWaitForInitData");const g=new N.$Olc(a.protocol,a.initData,o,null,p.data);n(v=>g.asBrowserUri(v)),i=v=>g.terminate(v)})}}}})}).call(this);

//# sourceMappingURL=extensionHostWorker.js.map
